<?php

/**
 * Description of ClxExpression
 *
 */
class ClxExpression {

    const PATTERN = '/(?:\-?\d+(?:\.?\d+)?[\+\-\*\/])+\-?\d+(?:\.?\d+)?/';
    const PARENTHESIS_DEPTH = 10;

    public function parseRecordFormula($expresion) {
        return $expresion;
    }
	public function parseRecordConstant($expresion) {
        return $expresion;
    }
    public function parseAndCalculate($expresion) {
        return $this->calculate($expresion);
    }

    public function calculate($input) {
        $return = 0;
        $match = array();
        if (strpos($input, '+') != null || strpos($input, '-') != null || strpos($input, '/') != null || strpos($input, '*') != null) {
            //  Remove white spaces and invalid math chars
            $input = preg_replace('[^0-9\.\+\-\*\/\(\)]', '', str_replace(',', '.', $input));

            //  Calculate each of the parenthesis from the top
            $i = 0;
            while (strpos($input, '(') || strpos($input, ')')) {
                $input = preg_replace_callback('/\(([^\(\)]+)\)/', 'self::callback', $input);

                $i++;
                if ($i > self::PARENTHESIS_DEPTH) {
                    break;
                }
            }

            //  Calculate the result
            if (preg_match(self::PATTERN, $input, $match)) {
                $return = $this->compute($match[CLX_NUM_ZERO]);
            } else {
                $return = 0;
            }
        }

        return $return;
    }

    private function compute($input) {
     /*   $compute = create_function('', 'return ' . $input . ';'); //*ESTA DEPRECATED PARA PHP 7.4*
	 */
		$compute = function() use ($input) {
			return   $input . ';';
		};
        return 0 + $compute();
    }

    public function callback($input) {
        $return = 0;
        $match = array();
        if (is_numeric($input[1])) {
            $return = $input[1];
        } elseif (preg_match(self::PATTERN, $input[1], $match)) {
            $return = $this->compute($match[CLX_NUM_ZERO]);
        }

        return $return;
    }

}
