<?php

/**
 * mysql database class
 * Database Object for communicating with a MySQL Database Version <= 4.0
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2016-02-18 16:40:17 +0000 (Thu, 18 Feb 2016) $
 * @version    	$Rev: 7815 $
 * @package		Clientix.Classes.Database
 * @abstract		MYSQL - Database Abstraction Layer
 */
class MysqlDatabase extends ClxDatabase {

    /**
     * Constructor
     */
    function __construct($url, $user, $pass, $name) {
        $this->databaseURL = $url;
        $this->databaseUsername = $user;
        $this->databasePassword = $pass;
        $this->databaseName = $name;
        $this->debug = false;
    }

    /**
     * Database Error Number
     *
     * @param
     *        	: SQL Query
     */
    function errorNum() {
        return mysql_errno();
    }

    /**
     * Database Error Message
     *
     * @param
     *        	: SQL Query
     */
    function errorMsg() {
        return mysql_error();
    }

    /**
     * Returns string with information about the most recent query.
     *
     * @param
     *        	: SQL Query
     */
    function info() {
        return mysql_info();
    }

    /**
     * Open a connection to a Database Server
     */
    function connectToDatabase() {
        $this->dblink = mysql_pconnect($this->databaseURL, $this->databaseUsername, $this->databasePassword) or die('<center><h2>Clientix</h2><br><p>ERR1 - Connection to database fail. Please contact System Administrator. Thank You.</p></center>');
    }

    /**
     * Selects the default database for queries
     */
    function selectDatabase() {
        mysql_select_db($this->databaseName, $this->dblink) or die('<center><h2>Clientix</h2><br><p>ERR2 - Connection to database fail. Please contact System Administrator. Thank You.</p></center>');
        // setting character encoding
        mysql_set_charset($this->charset, $this->dblink);
    }

    /**
     * Close database connection
     */
    function closeConnection() {
        mysql_close($this->dblink);
    }

    function freeResult($resource) {
        mysql_free_result($resource);
    }

// end method
    /**
     * Executes SQL Query and returns the correspondant
     * result resource or error on failure.
     *
     * @param
     *        	: SQL Query
     */
    function executeQuery($sql) {
		if ( isset($_SESSION["_dEBUG"]) and (((strlen($sql)>25 or (strlen($sql)<=65 and stripos($sql, "IDCODE")<1)) and stripos($sql, "CLX_DICTIONARY")<1 and stripos($sql, "dictionary")<1 and stripos($sql, "CLX_DICTIONARY_HEAP")<1     /*and stripos($sql, "SER_SESSIONS")<1  */ /* and stripos($sql, "events")<1 */ and stripos($sql, "CLX_AC_GROUP_MEMBERS")<1 and stripos($sql, "CLX_UI_FORMS")<1 /* and stripos($sql, "CLX_DB_TABLE")<1 */		   and stripos($sql, "CLX_OBJECTS")<1 and stripos($sql, "CLX_DB_DYNRELATIONS")<1 and stripos($sql, "CLX_AC_USERS")<1 /*and stripos($sql, "CLX_SYS_PARAMETERS")<1 */ and stripos($sql, "CLX_CODELIB")<1 and stripos($sql, "ALRT_ALERT_SCHEDU")<1 and stripos($sql, "CLX_TOOLS")<1 and stripos($sql, "CLX_UI_LISTINGS")<1 and stripos($sql, "CLX_UI_FORM_PANEL")<1 and stripos($sql, "CLX_DB_LISTS")<1 and stripos($sql, "CLX_DB_FIELDS")<1 and stripos($sql, "CLX_UI_VIEW_PREFS")<1) or ( $_SESSION["_dEBUG"]==99 and stripos($sql, "dictionary")<1                 ))){list($h1,$m1,$s1)=explode(':', date('h:i:s'));$sidebug=1; if (isset($_SESSION["maxdebug"]) && filesize(kPathToWebSite."/".kPathToTemp."archivo.txt")>$_SESSION["maxdebug"]) {$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","r"); $conte=fread($tta,filesize(kPathToWebSite."/".kPathToTemp."archivo.txt")); fclose($tta);$arreglos=explode("GET-",$conte);			for($t=0;$t<count($arreglos)-6;$t++) {unset($arreglos[$t]);	}$conte=implode("GET-", (is_Array($conte))?$conte:array());	$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","w+");	fwrite($tta,substr($conte,-$_SESSION["maxdebug"]*80/100));}else {$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");}	fwrite($tta,chr(13).chr(10)."1- hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,				"   remote:".(isset($_SERVER["REMOTE_ADDR"]) ? $_SERVER["REMOTE_ADDR"]:"").chr(13).chr(10));	fwrite($tta,chr(13).chr(10).beautiful_sql($sql,chr(13).chr(10),"    ",false).chr(13).chr(10));$te=debug_backtrace();for ($t=0;$t<18;$t++) { if (isset($te[$t]["file"]))	fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));	}fwrite($tta,chr(13).chr(10));
		fclose($tta);}
        $result = false;
        if (!empty($this->debug)) {
            if (function_exists('pre')) {
                pre($sql . ';');
            } else {
                echoLog($sql . ';<br>');
            }
        }
        $this->logStart();
        $this->dumpScript($sql);
        $result = mysql_query($sql, $this->dblink);
        $this->logEnd();
        $errorNum = $this->errorNum();
        if ($errorNum != CLX_NUM_ZERO) {
            $this->reportError($sql, $errorNum, $this->errorMsg());
        }
        $this->writeTimeLog($sql); // Writing log
        return $result;
    }

    function executeQueryVoid($sql) {
        ClxFreeReturn($this->executeQuery($sql));
    }

    /**
     * Executes SQL Query aunbuffered
     * result resource or error on failure.
     *
     * @param
     *        	: SQL Query
     */
    function executeUnbufferedQuery($sql) {
		if ( isset($_SESSION["_dEBUG"]) and (((strlen($sql)>65 or (strlen($sql)<=65 and stripos($sql, "IDCODE")<1)) and stripos($sql, "CLX_DICTIONARY")<1 and stripos($sql, "dictionary")<1  and stripos($sql, "CLX_DICTIONARY_HEAP")<1 /*and stripos($sql, "SER_SESSIONS")<1  */ /* and stripos($sql, "events")<1 */ and stripos($sql, "CLX_AC_GROUP_MEMBERS")<1 and stripos($sql, "CLX_UI_FORMS")<1 /* and stripos($sql, "CLX_DB_TABLE")<1 */		   and stripos($sql, "CLX_OBJECTS")<1 and stripos($sql, "CLX_DB_DYNRELATIONS")<1 and stripos($sql, "CLX_AC_USERS")<1 /*and stripos($sql, "CLX_SYS_PARAMETERS")<1 */ and stripos($sql, "CLX_CODELIB")<1 and stripos($sql, "ALRT_ALERT_SCHEDU")<1 and stripos($sql, "CLX_TOOLS")<1 and stripos($sql, "CLX_UI_LISTINGS")<1 and stripos($sql, "CLX_UI_FORM_PANEL")<1 and stripos($sql, "CLX_DB_LISTS")<1 and stripos($sql, "CLX_DB_FIELDS")<1 and stripos($sql, "CLX_UI_VIEW_PREFS")<1) or $_SESSION["_dEBUG"]==99)) {list($h1,$m1,$s1)=explode(':', date('h:i:s')); $sidebug=1; if (isset($_SESSION["maxdebug"]) && filesize(kPathToWebSite."/".kPathToTemp."archivo.txt")>$_SESSION["maxdebug"]) {$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","r"); $conte=fread($tta,filesize(kPathToWebSite."/".kPathToTemp."archivo.txt")); fclose($tta);$arreglos=explode("GET-",$conte);			for($t=0;$t<count($arreglos)-6;$t++) {unset($arreglos[$t]);	}/*$conte=implode("GET-",$conte);*/	$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","w+"); if(empty($_SESSION["maxdebug"])) $_SESSION["maxdebug"]=50000;	fwrite($tta,substr($conte,-$_SESSION["maxdebug"]*80/100));}else {$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");}	fwrite($tta,chr(13).chr(10)."1- hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,				"   remote:".(isset($_SERVER["REMOTE_ADDR"]) ? $_SERVER["REMOTE_ADDR"]:"").chr(13).chr(10));	fwrite($tta,chr(13).chr(10).beautiful_sql($sql,chr(13).chr(10),"    ",false).chr(13).chr(10));$te=debug_backtrace();for ($t=0;$t<18;$t++) { if (isset($te[$t]["file"]))	fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));	}fwrite($tta,chr(13).chr(10));
		fclose($tta);}
        $result = false;
        if (!empty($this->debug)) {
            if (function_exists('pre')) {
                pre($sql);
            } else {
                echoLog($sql . '<br>');
            }
        }
        $this->logStart();
        $this->dumpScript($sql);
        $result = mysql_unbuffered_query($sql, $this->dblink);
        $this->logEnd();
        $errorNum = $this->errorNum();
        if ($errorNum != CLX_NUM_ZERO) {
            $this->reportError($sql, $errorNum, $this->errorMsg());
        }
        $this->writeTimeLog($sql); // Writing log
        return $result;
    }

    /**
     * Equivalent to executeQuery with the exception of no error reported on
     * failure
     *
     * @param
     *        	: SQL Query
     */
    function executeQuerySilent($sql) {
        $this->logStart();
        $this->dumpScript($sql);
        $result = mysql_query($sql, $this->dblink);
        $this->logEnd();
        $this->writeTimeLog($sql); // Writing log
        return $result;
    }

    /**
     * Return true if table exists or false if not found on database
     *
     * @param
     *        	: String tablename
     */
    function tableExists($tablename) {
        $records = $this->executeQuery('SHOW TABLES LIKE ' . singleQuote($tablename));
        return $this->numRows($records) > CLX_NUM_ZERO;
    }

    /**
     * Creates physical table on database.
     *
     * @param string $tablename
     *        	Name of table
     * @param string $tabletype
     *        	Type of table VIEW, TEMP, ETC
     * @param array $fields
     *        	List of field and its caracteristicts
     * @param bool $casesensitive
     *        	Additiona parameter to define case sensitivity. only for mysql
     */
    function createTable($tablename, $tabletype, $fields, $casesensitive = false) {
        if ($tabletype === 'VIEW') {
            return;
        }
        $indexes = array();
        $descriptions = array();
        reset($fields);
        foreach ($fields as $name => $info) {
            if (!array_key_exists('null', $info)) {
                $info ['null'] = 'YES';
            }
            $type = $info ['type'];
            $null = ($info ['null'] === 'NO') ? 'NOT null' : ' null';
            $properties = '';
            // Handling Defaults
            if (array_key_exists('default', $info) && strlen('' . $info ['default']) > CLX_NUM_ZERO) {
                if ($info ['null'] === 'NO' && $info ['default'] === 'null') {
                    // validar en caso de que sea not null que colocar como null
                    $properties .= ' ';
                } else {
                    $properties .= ' DEFAULT ' . $info ['default'] . ' ';
                }
            }
            if (isset($info ['properties'])) {
                $properties .= $info ['properties'];
            }

            if (!empty($info ['collate'])) {
                $properties .= ' COLLATE '.$info ['collate'];
            }

            $d = '`' . $name - '` ' . $type . ' ' . $null . ' ' . $properties;
            $descriptions [] = $d;
            if (!array_key_exists('index', $info))
                $info ['index'] = '';
            $info ['name'] = $name;
            switch ($info ['index']) {
                case 'PRI' :
                    $indexes [] = 'PRIMARY KEY(' . $name . ')';
                    break;
                case 'MUL' :
                    $indexes [] = 'INDEX(' . $name . ')';
                    break;
                case 'UNI' :
                    $indexes [] = 'UNIQUE INDEX(' . $name . ')';
                    break;
                default:
                    break;
            }
        }
        if ($tabletype === 'TEMP') {
            $temporary = ' TEMPORARY ';
            $type = '';
        } else {
            $temporary = '';
            $type = ((kMysqlVersion >= '5.0') ? ' ENGINE=' . singleQuote($tabletype) : 'TYPE=' . singleQuote($tabletype) );
        }
        $sql = 'CREATE ' . $temporary . ' TABLE IF NOT EXISTS ' . $tablename . ' (' . implode(',', $descriptions);
        if (count($indexes) > CLX_NUM_ZERO) {
            $sql .= ',' . implode(',', $indexes);
        }
        $sql .= ') $type';
        if (!empty($casesensitive)) {
            $sql .= ' CHARSET=' . $this->charset . ' COLLATE=' . $this->charsetCcollateBin;
        }
        $this->executeQueryVoid($sql);
    }

    /**
     * Return physical table information of empty array otherwise
     *
     * @param string $tablename
     *        	Name of table
     * @return array
     */
    function getTableInfo($tablename) {
        $sql = 'SHOW TABLE STATUS LIKE ' . singleQuote($tablename);
        $records = $this->executeQuery($sql);
        $info = $this->getNextRecord($records, ASSOCIATIVE);
        if (!empty($info)) {
            $info = array('name' => $info ['Name'], 'type' => ((array_key_exists('Engine', $info)) ? $info ['Engine'] : $info ['Type']), 'fields' => array(), 'indexes' => array(), 'case_sensitive' => (($info ['Collation'] == $this->charsetCcollateBin) ? true : false), 'raw' => $info);
        } else {
            $info = array();
        }
        return $info;
    }

    /**
     * Changed table type
     *
     * @param string $tablename
     *        	Name of table
     * @param string $newtype
     *        	Type of table ex: VIEW, TEMP, ETC
     */
    function changeTableType($tablename, $newtype) {
        $sql = 'ALTER TABLE $tablename ' . ((kMysqlVersion >= '5.0') ? ' ENGINE=' . singleQuote($newtype) : ' TYPE=' . singleQuote($newtype) );
        $this->executeQueryVoid($sql);
    }

    /**
     * Sets the table collection for case sensitivity
     *
     * @param string $tablename
     *        	Name of table to set case sensitive
     * @param boolen $active
     *        	Status of active or inactive
     */
    function changeTableCaseSensitive($tablename, $active) {
        if (!empty($active)) {
            $sql = 'ALTER TABLE ' . $tablename . ' CONVERT TO CHARACTER SET ' . $this->charset . ' COLLATE ' . $this->charsetCcollateBin;
        } else {
            $sql = 'ALTER TABLE ' . $tablename . ' CONVERT TO CHARACTER SET ' . $this->charset . ' COLLATE ' . $this->charsetCollateCi;
        }
        $this->executeQueryVoid($sql);
    }

// end method
    /**
     * Changes table name
     *
     * @param string $oldtablename
     * @param string $newtablename
     */
    function renameTable($oldtablename, $newtablename) {
        $sql = 'ALTER TABLE '.$oldtablename.' RENAME ' . $newtablename;
        $this->executeQueryVoid($sql);
    }

    /**
     * Drop Table from database
     */
    function dropTable($tablename) {
        $sql = 'DROP TABLE IF EXISTS ' . $tablename;
        $this->executeQueryVoid($sql);
    }

    /**
     * Returns array containing tables names
     */
    function tables() {
        $result = array();
        $records = $this->executeQuery('SHOW TABLES');
        while (($record = $this->getNextRecord($records, NUMERIC)) === true) {
            $result [] = $record [CLX_NUM_ZERO];
        }
        return $result;
    }

    /**
     *
     * @param unknown_type $tablename
     * @return resource
     */
    function tableLock($tablename) {
        $sql = 'LOCK TABLES ' . $tablename . ' WRITE';
        return $this->executeQuery($sql);
    }

    /**
     *
     * @return resource
     */
    function tableUnlock() {
        $sql = 'UNLOCK TABLES';
        return $this->executeQuery($sql);
    }

    /**
     * (non-PHPdoc)
     *
     * @see ClxDatabase::fieldList()
     */
    function fieldList($tablename, $fieldname = '') {
        $sql = 'SHOW FIELDS FROM ' . $tablename;
        if (strlen($fieldname) > CLX_NUM_ZERO)
            $sql .= ' LIKE ' . singleQuote($fieldname);
        $records = $this->executeQuery($sql);
        return $records;
    }

    /**
     * (non-PHPdoc)
     *
     * @see ClxDatabase::created_id()
     */
    function createdId() {
        return mysql_insert_id();
    }

    /**
     * (non-PHPdoc)
     *
     * @see ClxDatabase::moveto()
     */
    function moveTo($cursor, $position) {
        mysql_data_seek($cursor, $position);
    }

    /**
     * (non-PHPdoc)
     *
     * @see ClxDatabase::num_fields()
     */
    function numFields($cursor) {
        return mysql_num_fields($cursor);
    }

    /**
     * (non-PHPdoc)
     *
     * @see ClxDatabase::num_rows()
     */
    function numRows($cursor) {
        return mysql_num_rows($cursor);
    }

    /**
     * (non-PHPdoc)
     *
     * @see ClxDatabase::field_name()
     */
    function fieldName($cursor, $field_num) {
        return mysql_field_name($cursor, $field_num);
    }

    // procdures and functions
    /**
     * (non-PHPdoc)
     *
     * @see ClxDatabase::createFunction()
     */
    function createFunction($name, $parameters, $body, $return) {
        $sql = 'CREATE FUNCTION ' . $name . ' (' . $parameters . ') RETURNS ' . $return . ' DETERMINISTIC READS SQL DATA BEGIN ' . $body . ' END';
        ClxFreeReturn( $this->executeQuerySilent($sql));
        $err = $this->errorMsg();
        if (!empty($err)) {
            return $err;
        } else {
            return true;
        }
    }

    /**
     * (non-PHPdoc)
     *
     * @see ClxDatabase::createProcedure()
     */
    function createProcedure($name, $parameters, $body) {
        $sql = 'CREATE PROCEDURE ' . $name . '(' . $parameters . ')	BEGIN ' . $body . '	END';
        ClxFreeReturn( $this->executeQuerySilent($sql));
        $err = $this->errorMsg();
        if (!empty($err)) {
            return $err;
        } else {
            return true;
        }
    }

    /**
     * (non-PHPdoc)
     *
     * @see ClxDatabase::existsFunction()
     */
    function existsFunction($name) {
        $sql = 'SHOW FUNCTION STATUS WHERE NAME = ' . singleQuote($name);
        $rs = $this->executeQuery($sql);
        if ($this->getNextRecord($rs, ASSOCIATIVE) === true) {
            return true;
        } else {
            return false;
        }
    }

    /**
     * (non-PHPdoc)
     *
     * @see ClxDatabase::existsProcedure()
     */
    function existsProcedure($name) {
        $sql = 'SHOW PROCEDURE STATUS WHERE NAME = ' . singleQuote($name);
        $rs =$this->executeQuery($sql);
        if ($this->getNextRecord($rs, ASSOCIATIVE) === true) {
            return true;
        } else {
            return false;
        }
    }

    /**
     * (non-PHPdoc)
     *
     * @see ClxDatabase::dropProcedure()
     */
    function dropProcedure($name) {
        $sql = 'DROP PROCEDURE IF EXISTS ' . $name;
        $this->executeQueryVoid($sql);
        return true;
    }

    /**
     * (non-PHPdoc)
     *
     * @see ClxDatabase::dropFunction()
     */
    function dropFunction($name) {
        $sql = 'DROP FUNCTION IF EXISTS ' . $name;
        $this->executeQueryVoid($sql);
        return true;
    }

}

// End class
