<?php

/**
 * General Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-10-09 11:22:02 -0400 (Tue, 09 Oct 2018) $
 * @version        $Rev: 10222 $
 * @package		Clientix.Classes.Form
 * @abstract		General Class
 * CHANGE LOG
 *  Included label
 */
class clx_form_panel_entry {

    var $caption;  // Panel caption, optional
    var $label;
    var $haslabel;
    var $fields;

    /**
     * Constructor
     * @param obj $form
     * @param array $data
     */
    function __construct(&$form, $data) {
        $this->caption = (!empty($data['caption'])) ? $data['caption'] : '';
        $this->loadArray($form, $data);
    }

    function loadArray(&$form, $data) {
        $this->haslabel = (isset($data['label']));
        if (!empty($this->haslabel)) {
            $this->label = $data['label'];
        } else {
            $this->label = '';
        }
        $this->fields = array();
        foreach ($data['fields'] as $fielddata) {
            $fieldtype = 'clx_field_' . $fielddata['type'];
            $this->fields[] = new $fieldtype($form, $fielddata);
        }
    }

    /**
     * Build Tool Edit Form
     * @param obj $form
     * @param array $record
     * @param array $msg
     * @param obj $table
     */
    function editForm(&$form, $record, $msg, &$table) { IF ($GLOBALS['ADDRDEBUGEDITFORM_']==1) { ECHO __METHOD__.' '.__FILE__.':'.__LINE__.'<br>'; }
		$fields = '';
        $required = false;
		foreach ($this->fields as &$field) {if ( isset($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1654;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");fwrite($tta, '15590-editform fields '.var_export($field,true).chr(13).chr(10)  );$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_mappings-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
			//pre($fields);
			for ($t=0;$t<count($form->panels);$t++) {
				$ent=$form->panels[$t]->entries;
				for ($xx=0;$xx<count($ent);$xx++) {
					$ent2=$ent[$xx]->fields;
					for ($yy=0;$yy<count($ent2);$yy++) {
						if (isset($ent2[$yy]->data['required']) &&isset($ent2[$yy]->data['name']) && $ent2[$yy]->data['required'] &&$ent2[$yy]->data['name']==$field->name) {
							$field->required=1;
						}
					}	
				}
			}
            if (empty($required)) {
                $required = $field->required;
            }
            $sufix_extra = (!empty($field->data['sufix_extra'])) ? $field->data['sufix_extra'] : '';
			$prefix_extra = (!empty($field->data['prefix_extra'])) ? $field->data['prefix_extra'] : '';
            $fields .= $prefix_extra.$field->editForm_($form, $record, $msg) . $sufix_extra;
        }
        if (strlen($fields) > CLX_NUM_ZERO) {
            if (strlen($this->caption) > CLX_NUM_ZERO) {
                $table->addCell(dict($this->caption), array(CLX_PROP_CLASS => 'caption', CLX_PROP_COLSPAN => $table->cellqty));
            }
            if ($this->haslabel === true) {
                if (empty($required)) {
                    $promptclass = CLX_CLASS_PROMPT;
                    $dataclass = CLX_CLASS_DATA;
                } else {
                    $promptclass = CLX_CLASS_PROMPTREQUIRED;
                    $dataclass = CLX_CLASS_DATA;
                }
                $table->addData(dict($this->label), $fields, $promptclass, $dataclass);
            } else {
                $table->addCell($fields, array(CLX_PROP_CLASS => CLX_CLASS_DATA));
            }
        }
    }

    /**
     * Builds Tool View Form
     * @param string $toolcode
     * @param array $record
     * @param obj $table
     */
    function viewForm($toolcode, $record, &$table) {
        $fields = '';
        foreach ($this->fields as $field) {
            $fields .= $field->viewFormField($toolcode, $record);
        }
        if (strlen($fields) > CLX_NUM_ZERO) {
            if ($this->haslabel === true) {
                $table->addData(dict($this->label), $fields);
            } else {
                $table->addCell($fields, array(CLX_PROP_CLASS => CLX_CLASS_DATA));
            }
        }
    }

    /**
     * Check User Form
     * @param obj $form
     * @param array $record
     * @param array $msg
     */
    function checkForm(&$form, &$record, &$msg) {
        foreach ($this->fields as $field) {
            $field->checkForm($form, $record, $msg);
        }
    }

}
