<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-09-03 12:24:19 -0400 (Thu, 03 Sep 2015) $
 * @version        $Rev: 6814 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
/**
 * Base Different interest Calculation Functions
 * @version: 1.0.0
 * @author: Alenet, Inc.
 * @date: 6/10/2005
 * From buton $a = new fidu_interest(); $a->run();
 */

/**
 * Parse Interest rate
 */
function parseInterest($int) {
    if (!is_float($int)) {
        $int = str_replace('%', '', $int);
        $int = (float) $int;
    } else {
        $int = (float) $int;
    }
    return $int;
}

/**
 * Calculate the future amount for present amount under n periods under single compaounding.
 */
function singleCompound($amt, $int, $periods) {
    $f = (float) CLX_INIT_ZERO;
    $periods = (float) $periods;
    $amt = (float) $amt;
    $int = parseInterest($int);
    $f = $amt * (pow(( CLX_NUM_ONE + ($int / CLX_NUM_HUNDRED)), $periods));
    return $f;
}

// end function
/**
 * Calculate the future amount for present amount under n periods under single compounding.
 */
function continuosCompound($amt, $int, $periods) {
    $f = (float) CLX_NUM_ZERO;
    $periods = (float) $periods;
    $amt = (float) $amt;
    $int = parseInterest($int);
    $f = $amt * (pow(M_E, ($periods * ($int / CLX_NUM_HUNDRED))));
    return $f;
}

// end function
/**
 * Returns array of amortization for a loan.
 */
function loan($amt, $int, $months, $compound, $sdate) {
    $loan = array();
    $int = parseInterest($int);
    switch ($compound) {
        case 'annually':
            $m = CLX_NUM_12;
            break;
        default:
            $m = $compound;
            break;
    }
    $n = (float) ($months / $m);
    for ($i = $months; $i > CLX_NUM_ZERO; $i--) {
        $loan[] = continuosCompound($amt, ($int / $i), $n);
    }
    return $loan;
}
