<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-09-03 12:24:19 -0400 (Thu, 03 Sep 2015) $
 * @version        $Rev: 6814 $
 *
 * CHANGE LOG
 *  Included svn prop
 */

/**
 * Contract Administration module utilities
 *
  /**
 * Line Total Amount for budget
 */
function lineTotal($record) {
    $record['LINE_TOTAL'] = $record['ITEM_QTY'] * $record['UNIT_PRICE'];
    return $record;
}

// End function
/**
 * Total amount for budget
 */
function updateTotal($record) {
    if (!empty($record['BUDGET_CODE'])) {
        $result = ClxCommon::$db->executeQuery('SELECT SUM(LINE_TOTAL) TOTAL_AMT FROM COAD_BUDGET_LINES WHERE BUDGET_CODE=' . singleQuote($record['BUDGET_CODE']));
        $t = ClxCommon::$db->getNextRecord($result);
        if (empty($t))
            $t = array('TOTAL_AMT' => '0.00');
        ClxCommon::$db->updateRecord('COAD_BUDGETS', $t, 'IDCODE = ' . singleQuote($record['BUDGET_CODE']));
        // Fund Balance
        balanceFunds($record['FUND_CODE']);
    }
}

// End function
/**
 * Line Sequence Number for budget
 */
function lineSequence($record) {
    if (!empty($record['BUDGET_CODE'])) {
        $record['SEQNUM'] = ClxCommon::$db->getOne('SELECT MAX(SEQNUM)+1 FROM COAD_BUDGET_LINES WHERE BUDGET_CODE=' . singleQuote($record['BUDGET_CODE']));
        if (empty($record['SEQNUM']))
            $record['SEQNUM'] = CLX_NUM_ONE;
    }
    return $record;
}

// End function
/**
 * Total amount for appraisal
 */
function updateAppTotal($record) {
    if (!empty($record['APPRAISAL_CODE'])) {
        $result = ClxCommon::$db->executeQuery('SELECT SUM(LINE_TOTAL) TOTAL_AMT FROM COAD_APPRAISAL_LINES WHERE APPRAISAL_CODE=' . singleQuote($record['APPRAISAL_CODE']));
        $t = ClxCommon::$db->getNextRecord($result);
        if (empty($t))
            $t = array('TOTAL_AMT' => '0.00');
        ClxCommon::$db->updateRecord('COAD_APPRAISALS', $t, 'IDCODE = ' . singleQuote($record['APPRAISAL_CODE']));
        // Fund Balance
        balanceFunds($record['FUND_CODE']);
    }
}

// End function
/**
 * Line Sequence Number for appraisals
 */
function lineAppSequence($record) {
    if (!empty($record['APPRAISAL_CODE'])) {
        $record['SEQNUM'] = ClxCommon::$db->getOne('SELECT MAX(SEQNUM)+1 FROM COAD_APPRAISAL_LINES WHERE APPRAISAL_CODE=' . singleQuote($record['APPRAISAL_CODE']));
        if (empty($record['SEQNUM']))
            $record['SEQNUM'] = CLX_NUM_ONE;
    }
    return $record;
}

// End function
/**
 * Calculates the total balance for a fund
 */
function balanceFunds($code) {
    if (!empty($code)) {
        $a = ClxCommon::$db->executeQuery('SELECT SUM(LINE_TOTAL) TOTAL_AMT FROM COAD_APPRAISAL_LINES WHERE FUND_CODE=' . singleQuote($code));
        $apr = ClxCommon::$db->getNextRecord($a);
        $a = ClxCommon::$db->executeQuery('SELECT SUM(LINE_TOTAL) TOTAL_AMT FROM COAD_BUDGET_LINES WHERE FUND_CODE=' . singleQuote($code));
        $pre = ClxCommon::$db->getNextRecord($a);
        $bal = $pre['TOTAL_AMT'] - $apr['TOTAL_AMT'];
        ClxCommon::$db->executeQuery('UPDATE FUND_FUNDS SET BALANCE_AMT = (TOTAL_AMT + ' . $bal . ') WHERE IDCODE=' . singleQuote($code));
    }
}

// End function