<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-12-01 11:24:29 -0500 (vie, 01 dic 2017) $
 * @version        $Rev: 9650 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class fidu_statement {

    var $code = 'FIRE';
    var $sdate = ''; // Start Date
    var $edate = ''; // End Date
    var $print_btn = false;
    var $single_currency = false; // Sngle currency on reports, set to true
    // to select from one currency only
    var $contents; // Content Output
    var $date_format = 'd / m / Y'; // 'd - M';//Date Formating on reports
    var $initial_balance = array();
    var $comp; // Company code
    var $currency_code; // Currency code
    var $currency_format = CLX_INIT_ZERO;
    var $comp_code;
    var $participant_id;
    var $ledger_code;
    var $fiscal_period;
    var $glaccs; // Parameters
    var $nl = '';
    var $now = '';
    var $commitions = array(); // Comitions values
    var $page_footer_use_def_address = true;
    var $page_footer_notes_msgs;
    var $page_footer_address;
    var $page_footer_total_extra_lines = CLX_NUM_TWO;
    var $page_footer_total_address_lines = CLX_NUM_TWO;
    var $send_pdf;

    /**
     * Contructor
     */
    function __construct ($procParameters = array()) {
        $this->contents = '';
        $this->glaccs = array('INT' => '714', 'AR' => '722', 'PAY' => '72', 'INV' => '712', 'EQ' => '731');
        $this->batch_id = (!empty($procParameters ['BATCH_ID'])) ? $procParameters ['BATCH_ID'] : batch_id();
        multiTableName($this, array('ACCO', 'ACLO', 'COMP', 'COLO', 'FICO', 'JEBL', 'FIAI', 'FIPA', 'DYCL', 'FIAT', 'FITL', 'CURR', 'JTMP', 'INAT', 'FITB', 'FIPD', 'FIDA', 'FIBT', 'GLRT', 'PROC', 'FIAS', 'JEHD', 'JELN', 'GLCP', 'GLT1', 'GLAC', 'INPR', 'FSMG', 'FIPB', 'JACP', 'GDVW', 'GLPF', 'CSVW'));
        $this->comp = '';
        $this->fontsize = CLX_NUM_7;
        $this->titlefontsize = CLX_NUM_TEN;
        $this->cellmaxchar = CLX_NUM_50;
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        // Setting Report Dates
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        $comp = new Comp ();
        if (empty(UserRequest::$post)) {
            $comprec = $comp->comp_operation_parameters();
            $acc_date = $comprec ['OPERATION_DATE'];
            UserRequest::$post ['RTBL_FROM_DATE'] = adodb_next_day($acc_date, 'Y-m-01');
            UserRequest::$post ['RTBL_TO_DATE'] = adodb_next_day($acc_date);
            UserRequest::$post ['RTBL_COMP_CODE'] = $comprec ['IDCODE'];
            UserRequest::$post ['RTBL_CONTRACT_CODE'] = '';
            UserRequest::$post ['RTBL_ACCOUNTCODE'] = '';
            UserRequest::$post ['RTBL_CURRENCY_CODE'] = '';
        } else {
            $comprec = $comp->comp_operation_parameters(UserRequest::$post ['RTBL_COMP_CODE']);
            $this->ledger_code = $comprec ['LEDGER_CODE'];
            $this->fiscal_period = $comprec ['FISCAL_PERIOD'];
        }
        unset($comp);
        $this->base_currency_code = $comprec ['CURRENCY_CODE'];
        $this->sdate = (!empty(UserRequest::$post ['RTBL_FROM_DATE'])) ? UserRequest::$post ['RTBL_FROM_DATE'] : CLX_CHAR_EMPTY_STRING;
        $this->edate = (!empty(UserRequest::$post ['RTBL_TO_DATE'])) ? UserRequest::$post ['RTBL_TO_DATE'] : CLX_CHAR_EMPTY_STRING;
        $this->send_pdf = !empty(UserRequest::$post ['RTBL_SEND_PDF']);
        $this->comp_code = UserRequest::$post ['RTBL_COMP_CODE'];
        $this->contract_code = (!empty(UserRequest::$post ['RTBL_CONTRACT_CODE'])) ? UserRequest::$post ['RTBL_CONTRACT_CODE'] : CLX_CHAR_EMPTY_STRING;
        $this->participant_id = (!empty(UserRequest::$post ['RTBL_ACCOUNTCODE'])) ? UserRequest::$post ['RTBL_ACCOUNTCODE'] : CLX_CHAR_EMPTY_STRING;
        $this->currency_code = (empty(UserRequest::$post ['RTBL_CURRENCY_CODE'])) ? $comprec['CURRENCY_CODE'] : UserRequest::$post ['RTBL_CURRENCY_CODE'];
        if ($this->currency_code !== '') {
            $this->base_currency_code = $this->currency_code;
        }
        //$this->single_currency = (! empty ( $this->currency_code )) ? true : false;
        $this->single_currency = false;
        $this->nl = chr(CLX_NUM_TEN);
        $this->currency_format = companyParameter('GL_REP_CURRENCY_FORMAT');
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $comp_code
     * @return unknown
     */
    function comp_logo($comp_code) {
        $OBJS = &getTool('OBJS');
        $fieldinstance = $OBJS->getObject_('DBFT', 'FILE');
        $fieldrec = ClxCommon::$db->getRecord('CLX_DB_FIELDS', 'FIELDNAME=' . singleQuote('COMP_LOGO'));
        $comprec = ClxCommon::$db->getRecord($this->compname, 'IDCODE = ' . singleQuote($comp_code));
        return $fieldinstance->formatField('COMP_LOGO', $fieldrec, $comprec);
    }

    /**
     * Prompt period && Client to display on statement
     */
    function print_dialog($formcode = 'RTBL_STMT') {
        $title = dict('FIDU_CODE_STATEMENT');
        // print_r(UserRequest::$request);
        $ac = UserRequest::$request ['ac'];
        $to = UserRequest::$request [CLX_PROP_TO];
        $it = (!empty(UserRequest::$request ['it'])) ? UserRequest::$request ['it'] : '';
        UserRequest::$post ['RTBL_FROM_DATE'] = (empty(UserRequest::$post ['RTBL_FROM_DATE'])) ? $this->sdate : UserRequest::$post ['RTBL_FROM_DATE'];
        UserRequest::$post ['RTBL_TO_DATE'] = (empty(UserRequest::$post ['RTBL_TO_DATE'])) ? $this->edate : UserRequest::$post ['RTBL_TO_DATE'];
        UserRequest::$post ['RTBL_COMP_CODE'] = (!empty(UserRequest::$post ['RTBL_COMP_CODE'])) ? UserRequest::$post ['RTBL_COMP_CODE'] : ClxCommon::$db->getField($this->compname, 'IDCODE');
        UserRequest::$post ['RTBL_CURRENCY_CODE '] = $this->currency_code;
        // RTBL_REPCINV
        $EDIT = &getTool('EDIT');
        $record = array();
        $msg = array();
        $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote($formcode));
        $record = UserRequest::$post;
        if (!empty($record ['confirm'])) {
            getLookupValue('RTBL_CONTRACT_CODE', 'CONTRACT_CODE', $record);
            getLookupValue('RTBL_ACCOUNTCODE', 'ACCOUNTCODE', $record);
            $EDIT->checkForm2($msg, $formrec);
            if (count(explode('-', UserRequest::$request ['RTBL_TO_DATE'])) != CLX_NUM_THREE)
                $msg ['RTBL_TO_DATE'] = dict('GEN_ERR_CANTPARSE');
            if (count(explode('-', UserRequest::$request ['RTBL_FROM_DATE'])) != CLX_NUM_THREE)
                $msg ['RTBL_FROM_DATE'] = dict('GEN_ERR_CANTPARSE');
            if ($this->sdate > $this->edate) {
                /*
                 * GEN_ERR_STARTGREATERENDDATE Start date cannot be greater than
                 * end date. Fecha inicial no puede ser mayor que fecha final.
                 */
                $msg ['RTBL_TO_DATE'] = dict('GEN_ERR_STARTGREATERENDDATE');
                $msg ['RTBL_FROM_DATE'] = dict('GEN_ERR_STARTGREATERENDDATE');
            }
        }
        if (!empty($record ['RTBL_ACCOUNTCODE']) && ClxCommon::$db->oneExistsRecords($this->fipaname, 'CONTRACT_CODE = ' . singleQuote($record ['RTBL_CONTRACT_CODE']) . ' AND ACCOUNTCODE = ' . singleQuote($record ['RTBL_ACCOUNTCODE'])) == CLX_NUM_ZERO) {
            $msg ['RTBL_ACCOUNTCODE'] = dict('CODE_ERR_NOPARTICIPANTFOUND', $record ['RTBL_CONTRACT_CODE']);
        }
        $EDIT = &getTool('EDIT');
        $form = $EDIT->defaultForm($formrec, $record, $msg, $ac, $to, $it, 'tool.php', '', $title);
        if (!empty($record ['confirm']) && empty($msg)) {
            $sql = 'SELECT FIPA.CONTRACT_CODE, FIPA.ACCOUNTCODE FROM ' . $this->fipaname . ' FIPA WHERE 1=1 AND EXISTS(SELECT JELN.ID FROM ' . $this->jelnname . ' JELN WHERE JELN.CHART_FIELD01 = FIPA.CONTRACT_CODE AND JELN.CHART_FIELD02 = FIPA.ACCOUNTCODE) AND (FIPA.STATUS = ' . singleQuote('A') . '  OR EXISTS( SELECT FIAT.ID FROM ' . $this->fiatname . ' FIAT WHERE FIAT.CHART_FIELD01 = FIPA.CONTRACT_CODE AND FIAT.CHART_FIELD02 = FIPA.ACCOUNTCODE AND FIAT.TRANSTBL_CODE = ' . singleQuote('SYS_DESIN') . ' AND FIAT.EFFTDATE>=' . singleQuote($this->sdate) . ' ))  ';
            if (!empty($this->contract_code)) {
                $sql .= ' AND FIPA.CONTRACT_CODE = ' . singleQuote($this->contract_code);
            }
            if (!empty($this->participant_id)) {
                $sql .= 'AND FIPA.ACCOUNTCODE = ' . singleQuote($this->participant_id);
            }
            $sql .= ' ORDER BY FIPA.CONTRACT_CODE, FIPA.ACCOUNTCODE ';
            $participants = ClxCommon::$db->executeQuery($sql);
            while (($participant = ClxCommon::$db->getNextRecord($participants))) {
                $this->contract_code = $participant ['CONTRACT_CODE'];
                $this->participant_id = $participant ['ACCOUNTCODE'];
                $this->build();
                $this->contents .= ($this->send_pdf) ? CLX_CHAR_NL . CLX_CHAR_NL : '<br><br>';
            }
            if ($this->contents === '') {
                $this->contents = note(dict('TOOL_DBQY_ERR_NO_RECORD'));
            }
        } else {
            $this->contents = $form->source();
        }
    }

    /**
     * Send to output statement
     */
    function source() {
        $contents = '';
        if (!empty($this->print_btn)) {
            $table = new htmlTable(CLX_WIDTH_ONE);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_ALIGN => 'center'));

            $b = new htmlButton(dict('GEN_LBL_PRINT'));
            $b->setProp('onClick', 'javascript:open_div_window('.singleQuote('div_to_print').', '.singleQuote('Print').','.singleQuote(skinPath() . '/styles.css').');');
            $table->addCell($b->source(), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
            $contents .= $table->source();
        }
        $contents .= '<div id="div_to_print">' . $this->contents . '</div>';
        return $contents;
    }

    // S E C T I O N B U I L D E R S
    /**
     * Builds the contract statement for each account
     * The following section will be included on report:
     * Participant Account, Message Board, Account Summary(General
     * Information), Portfolio Distribution, Account
     * Movements / Other Movements
     */
    function build() {
        // PDF Options
        $this->headers = array();
        $this->variants = array();
        $this->data = array();
        if (empty($this->send_pdf)) {
            $this->print_btn = true;
        } else {
            $this->print_btn = false;
        }
        $ficoRec = ClxCommon::$db->getRecord($this->ficoname, 'IDCODE = ' . singleQuote($this->contract_code));
        $ficoRec [$this->code . '_CLIENT'] = $this->participant_id;
        $ficoRec [$this->code . '_SDATE'] = $this->sdate;
        $ficoRec [$this->code . '_EDATE'] = $this->edate;
        if (!empty($ficoRec)) {
            $this->page_footer_start($ficoRec['COMP_CODE'], $ficoRec);
            if ($this->send_pdf === true) {
                $this->build_pdf('P', dict('FIDU_CODE_STATEMENT'), $ficoRec);
            }
            // Retrieve period details
            $sql = 'SELECT MAX(IDCODE) IDCODE, MAX(TO_DATE) TO_DATE FROM ' . $this->jacpname . '   WHERE TO_DATE <= ' . singleQuote($this->edate) . ' AND COMP_CODE = ' . singleQuote($this->comp_code);
            $last_period = ClxCommon::$db->getOneRecord($sql);
            $this->fiscal_period = $last_period ['IDCODE'];
            unset($last_period);
            $DBLT = &getTool('DBLT');
            $tableFrame = new htmlTable(CLX_WIDTH_ONE);
            $tableFrame->setProps(array(CLX_PROP_WIDTH => '98%', CLX_PROP_ALIGN => 'center'));


            if (empty($this->send_pdf)) {
                // Title
                $table = new htmlTable(CLX_WIDTH_TWO);
                $table->setProps(array(CLX_PROP_WIDTH => '98%', CLX_PROP_ALIGN => 'center'));
                $table->addcell($this->comp_logo($ficoRec ['COMP_CODE']), array(CLX_PROP_WIDTH => CLX_NUM_ONE));
                $table->addcell('<br><br><h3>' . dict('FIDU_CODE_STATEMENT') . '<br>' . uppercase(dict('GEN_LBL_TRUST') . ': ' . $ficoRec ['IDNAME']) . '<br><font size=1>' . dict('GEN_LBL_ISSUED_ON') . ': ' . xFormat::date($ficoRec ['START_DATE'], $this->date_format) . '<br>' . dict('GEN_LBL_CURRENCY_EXP') . ': ' . $DBLT->getListItem('CURR', $this->base_currency_code, $this->currency_format) . '</font></h3><br>', array(CLX_PROP_ALIGN => 'center'));
                $tableFrame->addcell($table->source(), array());
            }
            // if not account code just search the principal account
            $aclorec = $this->contractAddress($ficoRec ['IDCODE'], $ficoRec [$this->code . '_CLIENT']);
            if (empty($ficoRec [$this->code . '_CLIENT'])) {
                $ficoRec [$this->code . '_CLIENT'] = ClxCommon::$db->getField($this->fipaname, 'ACCOUNTCODE', 'CONTRACT_CODE = ' . singleQuote($ficoRec ['IDCODE']) . ' AND ISPRIMARY=1');
            }
            $accorec = ClxCommon::$db->getRecord($this->acconame, 'IDCODE = ' . singleQuote($ficoRec [$this->code . '_CLIENT']));
            $aclorec ['IDCODE'] = $accorec ['IDCODE'];
            $aclorec ['IDNAME'] = $accorec ['IDNAME'];
            $tableFrame->addcell(CLX_CHAR_HTML_NBSP, array());
            $tableFrame->addcell($this->buldClient($ficoRec, $aclorec), array());
            // Informacion General
            $tableFrame->addcell(CLX_CHAR_HTML_NBSP, array());
            $tableFrame->addcell($this->buildSummary($ficoRec), array());
            // CASH Prefered EQUITY
            // EQUITY
            $tableFrame->addcell(CLX_CHAR_HTML_NBSP, array());
            $tableFrame->addcell($this->buildTransactions($ficoRec, 'EQ', 'EQ', 'FICO_CODE_PERIOD_EQACTIVITY'), array());
            // Cartera de inversion
            // 2.2- INTERESES A COBRAR COLOCACIONES
            $tableFrame->addcell(CLX_CHAR_HTML_NBSP, array());
            $tableFrame->addcell($this->buildTransactions($ficoRec, 'AS', array('AR', 'ARI'), 'FICO_CODE_EARNEDINT'), array());
            // 2.3- AMORTIZACIONES DEL MES
            // CUENTAS POR COBRAR A BANCO SEE INTERESES A COBRAR COLOCACIONES
            // CUENTAS POR PAGAR
            $tableFrame->addcell(CLX_CHAR_HTML_NBSP, array());
            $tableFrame->addcell($this->buildAccountPayable($ficoRec, 'LI', ''), array());
            // INVESTMENTS
            $tableFrame->addcell(CLX_CHAR_HTML_NBSP, array());
            $tableFrame->addcell($this->buildAccountInvestments($ficoRec, 'AS', array('IN', 'CD')), array());
            // CREDITS
            // CASH
            // NOTES
            $tableFrame->addcell(CLX_CHAR_HTML_NBSP, array());
            $tableFrame->addcell($this->buildNotes($ficoRec), array());
            if ($this->send_pdf === true) {
                $this->send_pdf('stmt_' . $ficoRec ['IDCODE'] . '_' . $ficoRec [$this->code . '_CLIENT'] . '_' .$this->edate . '.pdf');
                return;
            } else {
                $this->contents .= $tableFrame->source();
            }
        }
    }

    /**
     * Return Contract Address Record
     */
    function contractAddress($contract_code, $accountcode = '') {
	$sql = 'SELECT * FROM ' . $this->acconame . ' ACCO WHERE IDCODE = ' .
	     (($accountcode !== '') ? singleQuote($accountcode) :   ' (SELECT FIPA.ACCOUNTCODE  FROM ' . $this->fipaname . ' FIPA  WHERE FIPA.CONTRACT_CODE = ' . singleQuote($contract_code) . '  ORDER BY ISPRIMARY DESC LIMIT 1)');
        return ClxCommon::$db->getOneRecord($sql);;
    }

    /**
     * Build client information
     * @param unknown_type $contract
     * @param unknown_type $record
     * @return string
     */
    function buldClient($contract, $record) {
        $DBLT = &getTool('DBLT');
        if (empty($record ['ADDRESS1']))
            $record ['ADDRESS1'] = '';
        if (empty($record ['ADDRESS2']))
            $record ['ADDRESS2'] = '';
        if (empty($record ['CITY']))
            $record ['CITY'] = '';
        else
            $record ['CITY'] = $DBLT->getListItem('CITI', $record ['CITY'], CLX_NUM_TWO);
        if (empty($record ['STATE']))
            $record ['STATE'] = '';
        else
            $record ['STATE'] = $DBLT->getListItem('STAT', $record ['STATE'], CLX_NUM_TWO);
        if (empty($record ['ZIPCODE']))
            $record ['ZIPCODE'] = '';
        if (empty($record ['COUNTRY']))
            $record ['COUNTRY'] = '';
        else
            $record ['COUNTRY'] = $DBLT->getListItem('COUN', $record ['COUNTRY'], CLX_NUM_TWO);
        if (!empty($this->loan_code)) {
            $sql = 'SELECT FILO.LOAN_STATUS  FROM ' . $this->filoname . ' FILO WHERE FILO.IDCODE = ' . singleQuote($this->loan_code) . ' AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE)  FROM ' . $this->filoname . ' FILOX WHERE FILOX.IDCODE = FILO.IDCODE AND FILOX.CLX_EFFTDATE<=' . singleQuote($this->now) . ')';
            $loan_status = ClxCommon::$db->getOne($sql);
            if ($loan_status !== '') {
                $cred_status = $DBLT->getListItem('LOST', $loan_status, CLX_NUM_TWO);
            } else {
                $cred_status = ' ';
            }
        }
        if ($this->send_pdf === true) {
            $y = $this->RPPD->GetY();
            $this->RPPD->Cell(CLX_NUM_ZERO, CLX_NUM_22, '', CLX_NUM_ONE, CLX_NUM_ONE);
            $this->RPPD->SetY($y + CLX_NUM_TWO);
            $this->RPPD->SetFont('Arial', 'B', $this->fontsize);
            $this->RPPD->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, $record ['IDNAME']);
            $this->RPPD->Ln(CLX_NUM_FOUR);
            $this->RPPD->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, $record ['ADDRESS1'] . ' ' . $record ['ADDRESS2']);
            $this->RPPD->Ln(CLX_NUM_FOUR);
            $this->RPPD->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, $record ['CITY'] . ', ' . $record ['STATE'] . ' ' . $record ['ZIPCODE'] . ' ' . $record ['COUNTRY']);
            $this->RPPD->Ln(CLX_NUM_FOUR);
            if (!empty($this->loan_code)) {
                $this->RPPD->Ln(CLX_NUM_FOUR);
                $this->RPPD->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, capitalize(dict('GEN_LBL_LOAN_CODE')) . ':' . $this->loan_code . ', ' . dict('GEN_LBL_STATUS') . ': ' . $cred_status);
            }
            $this->RPPD->Ln(CLX_NUM_FOUR);
        } else {
            $client = '<b>' . (($this->participant_id !== '%') ? $record ['IDNAME'] : '') . '</b><br>';
            $client .= $record ['ADDRESS1'] . ' ' . $record ['ADDRESS2'] . '<BR>';
            $client .= $record ['CITY'] . ', ' . $record ['STATE'] . ' ' . $record ['ZIPCODE'] . '<BR>';
            $client .= $record ['COUNTRY'];
            $tableFrame = new htmlTable(CLX_WIDTH_TWO);
            $tableFrame->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $table = new htmlTable(CLX_WIDTH_TWO);
            $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $table->addcell($client, array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            $tableFrame->addcell($table->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
            // Account Information
            $table = new htmlTable(CLX_WIDTH_TWO);
            $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $table->addcell(dict('FICO_CODE_PERIOD'), array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO, CLX_PROP_CLASS => CLX_CLASS_HEADERS));
            $table->addcells(CLX_CLASS_PROMPT, array(dict('GEN_LBL_FROM'), xFormat::date($this->sdate, $this->date_format)));
            $table->addcells(CLX_CLASS_PROMPT, array(dict('GEN_LBL_UNTIL'), xFormat::date($this->edate, $this->date_format)));
            $table->addcells(CLX_CLASS_PROMPT, array(capitalize(dict('FIDU_CODE_FICONUMBER')), $contract ['CONTRACT_NUMBER']));
            if (!empty($this->loan_code)) {
                $table->addcells(CLX_CLASS_PROMPT, array(capitalize(dict('GEN_LBL_STATUS')), $cred_status));
                $table->addcells(CLX_CLASS_PROMPT, array(capitalize(dict('GEN_LBL_LOAN_CODE')), $this->loan_code));
            }
            $tableFrame->addcell($table->source(), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
            return $tableFrame->source();
        }
    }

    function buildSummary($ficorec = array()) {
        if (empty($ficorec)) {
            $idlist = getIdlist();
            $ficorec = ClxCommon::$db->getRecord($this->ficoname, 'ID =' . singleQuote($idlist [CLX_NUM_ZERO]));
        }
        $rs = ClxCommon::$db->getRecord($this->glcpname, 'COMP_CODE = ' . singleQuote($ficorec ['COMP_CODE']));
        $resultados_ejer = $rs['ACR_EARNING_CODE'];
        $resultados_loss_ejer = $rs['ACR_LOSS_CODE'];
        $resultados_acc = $rs['RET_EARNING_CODE'];
        $resultados_loss_acc = $rs['RET_LOSS_CODE'];
        if (!class_exists('gl')) {
            includeCodeLib('GL');
        }
        $data = array();
        $accresults = '0';
        $netresult = '0';
        $total = CLX_INIT_ZERO;
        $a = new gl ();
        $this->single_currency = false;
        // setting first date
        // $has_retaing=false,

        $rollup = $a->rollup($this->comp_code, $this->currency_code, $this->ledger_code, '', $this->sdate, $this->edate, $this->contract_code, $this->participant_id, null, null, null, false, null, null, $this->single_currency, false, true);
        foreach ($rollup as $key => $val) {
            if ((!empty($resultados_acc) && $resultados_acc == $key) || (!empty($resultados_loss_acc) && $resultados_loss_acc == $key)) {
                $accresults = bcadd($accresults, $val ['BALANCE_AMT']);
            }
            if ((!empty($resultados_ejer) && $resultados_ejer == $key) || (!empty($resultados_loss_ejer) && $resultados_loss_ejer == $key)) {
                $netresult = bcadd($netresult, $val ['BALANCE_AMT']);
            }
            switch ($val ['GL_TYPE']) {
                case 'EQ':
                    if (empty($data [$val ['GL_TYPE']])) {
                        $val ['GL'] = $key;
                        $data [$val ['GL_TYPE']] = $val;
                    }
                    break;
                case 'EX':
                    if (empty($val ['ACPARENT'])) {
                        $data [$val ['GL_TYPE']] = $val;
                    }
                    break;
                case 'IN':
                    if (empty($val ['ACPARENT'])) {
                        $data [$val ['GL_TYPE']] = $val;
                    }
                    break;
                case 'AS':
                    if ($val ['LEVEL'] == CLX_NUM_TWO) {
                        if ($val['BALANCE_AMT'] == CLX_NUM_ZERO)
                            continue 2;                                      //cambiado el continue funciona en un break continue 2 for fuera del break
                        $data [$val ['GL_TYPE']] [$key] = $val;
                        $this->initial_balance [$val ['GL_TYPE']] [$key] = $val;
                    }
                    break;
                default:
                    if ($val ['GL_TYPE'] <> '' && empty($val ['ACPARENT'])) {
                        $val ['GL'] = $key;
                        $data [$val ['GL_TYPE']] = $val;
                    }
                    break;
            }
        }
        if (empty($this->send_pdf)) {
            $tableFrame = new htmlTable(CLX_WIDTH_TWO);
            $tableFrame->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $tableFrame->addcell('<h3>' . dict('FIDU_CODE_SUMMARY') . '</h3>', array());
            // Formating
            $table = new htmlTable(CLX_WIDTH_TWO);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $table->addcell('<h3>' . dict('FICO_CODE_TRIALBALANCESUMARY') . '</h3>', array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        } else {
            $this->RPPD->Cell(CLX_NUM_ZERO);
            $this->RPPD->Ln(CLX_NUM_TEN);
            $this->RPPD->SetFont('Arial', 'B', $this->titlefontsize);
            $this->RPPD->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, dict('FICO_CODE_TRIALBALANCESUMARY'));
            $this->RPPD->SetFont('Arial', '', $this->fontsize);
            $this->RPPD->Ln(CLX_NUM_FIVE);
        }
        if (empty($data ['EX'] ['BALANCE_AMT'])) {
            $data ['EX'] ['BALANCE_AMT'] = CLX_INIT_ZERO;
        }
        if (empty($data ['IN'] ['BALANCE_AMT'])) {
            $data ['IN'] ['BALANCE_AMT'] = CLX_INIT_ZERO;
        }
        if (empty($data ['LI'] ['BALANCE_AMT'])) {
            $data ['LI'] ['BALANCE_AMT'] = CLX_INIT_ZERO;
        }

        //$total_result = bcadd(bcadd($data ['IN'] ['BALANCE_AMT'], $data ['EX'] ['BALANCE_AMT']), $accresults);
        $total_result = bcadd($data ['IN'] ['BALANCE_AMT'], $data ['EX'] ['BALANCE_AMT']);
        //$total = bcmul('-1', bcadd($total, bcadd($data ['LI'] ['BALANCE_AMT'], bcadd($data ['EQ'] ['BALANCE_AMT'], bcadd($total_result, $netresult)))));
        $total = bcmul('-1', bcadd($total, bcadd($data ['LI'] ['BALANCE_AMT'], bcadd($data ['EQ'] ['BALANCE_AMT'], $total_result))));

        // Assets
        if (empty($this->send_pdf)) {
            $t = new htmlTable(CLX_WIDTH_TWO);
            $t->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $t->addcell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        } else {
            $y = $this->RPPD->GetY();
            $this->RPPD->Cell(CLX_NUM_ZERO, CLX_NUM_45, '', CLX_NUM_ONE, CLX_NUM_ONE);
            $this->RPPD->SetY($y + CLX_NUM_FOUR);
        }
        $total_assets = '0';
        // Results income - expense
        if (!empty($data ['AS'])) {
            foreach ($data ['AS'] as $key => $val) {
                if (empty($this->send_pdf)) {
                    $t->addcell(capitalize($val ['IDNAME']), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_LEFT));
                    $t->addcell(xFormat::currency($val ['BALANCE_AMT']), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                } else {
                    $this->RPPD->Cell(CLX_NUM_45, CLX_NUM_ZERO, capitalize($val ['IDNAME']));
                    $this->RPPD->Cell(CLX_NUM_40, CLX_NUM_ZERO, xFormat::currency($val ['BALANCE_AMT']), false, false, 'R');
                    $this->RPPD->Ln(CLX_NUM_FOUR);
                }
                $total_assets = bcadd($total_assets, $val ['BALANCE_AMT']);
            }
        }
        if ($this->send_pdf === true) {
            $this->RPPD->SetFont('Arial', 'B', $this->fontsize);
            $this->RPPD->Cell(CLX_NUM_45, CLX_NUM_ZERO, capitalize(dict('GEN_LBL_TRUSTTOTALASSETS')));
            $this->RPPD->Cell(CLX_NUM_40, CLX_NUM_ZERO, xFormat::currency($total_assets), false, false, 'R');
            $this->RPPD->Ln(CLX_NUM_SIX);
        } else {
            if (!empty($data ['AS'])) {
                $t->addcell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            }
            $t->addcell(capitalize(dict('GEN_LBL_TRUSTTOTALASSETS')), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_LEFT));
            $t->addcell('<b>' . xFormat::currency($total_assets) . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_RIGHT));
            $table->addcell($t->source(), array());
        }
        if (empty($data ['EX'] ['IDNAME'])) {
            $data ['EX'] ['IDNAME'] = dict('FIDU_PR_REPEXP');
        }
        if (empty($data ['IN'] ['IDNAME'])) {
            $data ['IN'] ['IDNAME'] = dict('FIDU_PR_REPINCO');
        }
        if (empty($data ['LI'] ['IDNAME'])) {
            $data ['LI'] ['IDNAME'] = dict('GEN_LBL_LIABILITY');
        }
        // li vs eq
        if (empty($this->send_pdf)) {
            // Eq and Li
            $t = new htmlTable(CLX_WIDTH_TWO);
            $t->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $t->addcell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_CLASS => CLX_CLASS_HEADERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            $t->addcell(capitalize($data ['LI'] ['IDNAME']), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_LEFT));
            $t->addcell(xFormat::currency(bcmul('-1', $data ['LI'] ['BALANCE_AMT']), CLX_NUM_TWO), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_RIGHT));
            $t->addcell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            $t->addcell(capitalize($data ['EQ'] ['IDNAME']), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_LEFT));
            $t->addcell(xFormat::currency(bcmul('-1', $data ['EQ'] ['BALANCE_AMT']), CLX_NUM_TWO), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_RIGHT));
            $t->addcell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            $t->addcell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            $t->addcell(dict('GEN_LBL_TRUSTACCRESULT'), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_LEFT));
            // $t->addcell(xFormat::currency(bcmul('-1',array($accresults))=>CLX_PROP_CLASS,CLX_CLASS_DATA=>
            // CLX_PROP_ALIGN,CLX_PROP_RIGHT)=> ;
            $t->addcell(xFormat::currency(bcmul('-1', $netresult)), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_RIGHT));
            $t->addcell(dict('GEN_LBL_TRUSTNETRESULT'), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_LEFT));
            $t->addcell(xFormat::currency(bcmul('-1', $total_result)), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_RIGHT));
            $t->addcell(capitalize($data ['IN'] ['IDNAME']), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_LEFT));
            $t->addcell(xFormat::currency(bcmul('-1', $data ['IN'] ['BALANCE_AMT']), CLX_NUM_TWO), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_RIGHT));
            $t->addcell(capitalize($data ['EX'] ['IDNAME']), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_LEFT));
            $t->addcell(xFormat::currency($data ['EX'] ['BALANCE_AMT']), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_RIGHT));
            $t->addcell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            $t->addcell(capitalize(dict('GEN_CODE_TOTALFIDUFUND')), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_LEFT));
            $t->addcell('<b>' . xFormat::currency($total) . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_RIGHT));
            $table->addcell($t->source(), array(CLX_PROP_ALIGN => CLX_PROP_CENTER));
        } else {
            /*
             * $y = $this->RPPD->GetY(); $this->RPPD->Cell(0,45, '',1,1);
             * $this->RPPD->SetY($y+4); $x = $this->RPPD->GetX();
             */
            $this->RPPD->SetY($y + CLX_NUM_FOUR);
            $this->RPPD->Cell(CLX_NUM_90);
            $this->RPPD->SetFont('Arial', '', $this->fontsize);
            $this->RPPD->Cell(CLX_NUM_45, CLX_NUM_ZERO, capitalize($data ['LI'] ['IDNAME']));
            $this->RPPD->Cell(CLX_NUM_40, CLX_NUM_ZERO, xFormat::currency(bcmul('-1', $data ['LI'] ['BALANCE_AMT']), CLX_NUM_TWO), false, false, 'R');
            $this->RPPD->Ln(CLX_NUM_FOUR);
            $this->RPPD->Cell(CLX_NUM_90);
            $this->RPPD->Cell(CLX_NUM_45, CLX_NUM_ZERO, capitalize($data ['EQ'] ['IDNAME']));
            $this->RPPD->Cell(CLX_NUM_40, CLX_NUM_ZERO, xFormat::currency(bcmul('-1', $data ['EQ'] ['BALANCE_AMT']), CLX_NUM_TWO), false, false, 'R');
            $this->RPPD->Ln(CLX_NUM_FOUR);
            $this->RPPD->Cell(CLX_NUM_90);
            $this->RPPD->Cell(CLX_NUM_45, CLX_NUM_ZERO, capitalize(dict('GEN_LBL_TRUSTACCRESULT')));
            $this->RPPD->Cell(CLX_NUM_40, CLX_NUM_ZERO, xFormat::currency(bcmul('-1', $netresult), CLX_NUM_TWO), false, false, 'R');
            $this->RPPD->Ln(CLX_NUM_FOUR);
            $this->RPPD->Cell(CLX_NUM_90);
            $this->RPPD->Cell(CLX_NUM_45, CLX_NUM_ZERO, capitalize(dict('GEN_LBL_TRUSTNETRESULT')));
            $this->RPPD->Cell(CLX_NUM_40, CLX_NUM_ZERO, xFormat::currency(bcmul('-1', $total_result), CLX_NUM_TWO), false, false, 'R');
            $this->RPPD->Ln(CLX_NUM_SIX);
            $this->RPPD->SetFont('Arial', '', $this->fontsize);
            $this->RPPD->Cell(CLX_NUM_90);
            $this->RPPD->Cell(CLX_NUM_45, CLX_NUM_ZERO, capitalize($data ['IN'] ['IDNAME']));
            $this->RPPD->Cell(CLX_NUM_40, CLX_NUM_ZERO, xFormat::currency(bcmul('-1', $data ['IN'] ['BALANCE_AMT'])), false, false, 'R');
            $this->RPPD->Ln(CLX_NUM_FOUR);
            $this->RPPD->Cell(CLX_NUM_90);
            $this->RPPD->Cell(CLX_NUM_45, CLX_NUM_ZERO, capitalize($data ['EX'] ['IDNAME']));
            $this->RPPD->Cell(CLX_NUM_40, CLX_NUM_ZERO, xFormat::currency($data ['EX'] ['BALANCE_AMT']), false, false, 'R');
            $this->RPPD->Ln(CLX_NUM_SIX);
            $this->RPPD->Cell(CLX_NUM_90);
            $this->RPPD->SetFont('Arial', 'B', $this->fontsize);
            $this->RPPD->Cell(CLX_NUM_45, CLX_NUM_ZERO, capitalize(dict('GEN_CODE_TOTALFIDUFUND')));
            $this->RPPD->Cell(CLX_NUM_40, CLX_NUM_ZERO, xFormat::currency($total), false, false, 'R');
            /*
             * $this->RPPD->Ln(6);
             * $this->RPPD->SetFont('Arial','',$this->fontsize);
             * $this->RPPD->SetY($y+5);
             */
        }
        if ($this->send_pdf === true) {
            $this->RPPD->Ln(CLX_NUM_8);
        } else {
            $tableFrame->addcell($table->source(), array());
            return $tableFrame->source();
        }
    }

    /**
     * Builds the period movements
     */
    function buildTransactions($ficorec, $gl_type, $trust_item_type, $title = '') {
        $contents = '';
        if ($title === '') {
            $title = 'FICO_CODE_PERIOD_MOVEMENTS';
        }

        $single_crit = ' AND GLAC.GL_TYPE = ' . singleQuote($gl_type);

        if (!empty($trust_item_type)) {
            if (is_array($trust_item_type)) {
                $single_crit .= ' AND GLAC.TRUST_ITEM_TYPE IN (' . singleQuote(implode("','", $trust_item_type)) . ') ';
            } else {
                $single_crit .= ' AND GLAC.TRUST_ITEM_TYPE = ' . singleQuote($trust_item_type) . ' ';
            }
        }

        if (!empty($this->participant_id)) {
            $single_crit .= ' AND JELN.CHART_FIELD02 = ' . singleQuote($this->participant_id);
        }

        $sql = ' SELECT  ' . singleQuote($this->sdate) . ' EFFTDATE, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' TNAME, 0 DEBITS, 0 CREDITS, SUM(JEBL.BASE_BAL_AMT) BALANCE_AMT FROM  ' . $this->jeblname . ' JEBL WHERE  JEBL.COMP_CODE = ' . singleQuote($this->comp_code) . ' AND JEBL.CHART_FIELD01 = ' . singleQuote($this->contract_code) . ' ' . $single_crit . ' AND JEBL.EFFTDATE = (SELECT MAX(JEBL2.EFFTDATE) FROM ' . $this->jeblname . ' JEBL2 WHERE JEBL2.COMP_CODE =' . singleQuote($this->comp_code) . ' AND JEBL2.EFFTDATE < ' . singleQuote($this->sdate) . ')';
        $sql = str_replace(array('JEHD', 'JELN', 'GLAC'), 'JEBL', $sql);
        $init_vals = ClxCommon::$db->getOneRecord($sql);
        if ($gl_type === 'EQ') {
            $init_vals ['BALANCE_AMT'] = bcmul('-1', $init_vals ['BALANCE_AMT']);
        }
        $total = $init_vals ['BALANCE_AMT'];
        $sql = '  SELECT  JEHD.EFFTDATE, JEHD.IDNAME TNAME, SUM(JELN.DEBIT_AMT) DEBITS, SUM(JELN.CREDIT_AMT) CREDITS FROM  ' . $this->glcpname . ' GLCP,  ' . $this->glacname . ' GLAC,  ' . $this->jelnname . ' JELN, ' . $this->jehdname . ' JEHD  WHERE GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLCP.GLGROUP_CODE = GLAC.GLGROUP_CODE AND GLCP.COMP_CODE = JEHD.COMP_CODE AND JEHD.IDCODE = JELN.JEHDR_CODE AND JEHD.JE_STATUS = ' . singleQuote('AP') . '  AND JEHD.COMP_CODE = ' . singleQuote($this->comp_code) . ' AND	JELN.CHART_FIELD01 = ' . singleQuote($this->contract_code) . ' AND	JEHD.EFFTDATE >= ' . singleQuote($this->sdate) . '  AND	JEHD.EFFTDATE <= ' . singleQuote($this->edate) . '  AND JEHD.REVERSED = 0 ' . $single_crit . ' GROUP BY JEHD.EFFTDATE, JEHD.IDCODE, JELN.GLACCOUNTCODE ORDER BY JEHD.EFFTDATE ASC, JEHD.ID ASC';
        $summary = array();
        $summary [CLX_NUM_ZERO] = array('EFFTDATE' => $this->sdate, 'IDNAME' => dict('FICO_CODE_SBALANCE'), 'CR' => CLX_NUM_ZERO, 'DR' => CLX_NUM_ZERO, 'BAL' => $init_vals ['BALANCE_AMT']);
        $totalcr = (float) CLX_NUM_ZERO;
        $totaldr = (float) CLX_NUM_ZERO;
        // (float)0;
        $i = CLX_NUM_ONE;
        $results = ClxCommon::$db->executeQuery($sql);
        while (($result = ClxCommon::$db->getNextRecord($results))) {
            // Tipo de Activo 'Efectivo' y que afecta al efectivo
            if ($gl_type === 'AS') {
                $totalcr = bcadd($totalcr, $result ['CREDITS']);
                $totaldr = bcadd($totaldr, $result ['DEBITS']);
                $summary [$i] ['CR'] = $result ['DEBITS'];
                $summary [$i] ['DR'] = $result ['CREDITS'];
                $total = bcadd($total, bcsub($result ['DEBITS'], $result ['CREDITS']));
            } else {
                $totalcr = bcadd($totalcr, $result ['DEBITS']);
                $totaldr = bcadd($totaldr, $result ['CREDITS']);
                $summary [$i] ['DR'] = $result ['DEBITS'];
                $summary [$i] ['CR'] = $result ['CREDITS'];
                $total = bcsub($total, bcmul('-1', bcsub($result ['CREDITS'], $result ['DEBITS'])));
            }
            $summary [$i] ['EFFTDATE'] = $result ['EFFTDATE'];
            $summary [$i] ['IDNAME'] = $result ['TNAME'];
            $summary [$i] ['BALANCE_AMT'] = $total;
            $i ++;
        }
        // Building Report Table
        $tableFrame = new htmlTable(CLX_WIDTH_ONE);
        $tableFrame->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $tableFrame->addcell('<h4>' . dict($title) . '</h4>', array(CLX_PROP_ALIGN => CLX_PROP_LEFT));
        if ($this->send_pdf === true) {
            $this->RPPD->Cell(CLX_NUM_ZERO);
            $this->RPPD->Ln(CLX_NUM_TEN);
            $this->RPPD->SetFont('Arial', 'B', $this->titlefontsize);
            $this->RPPD->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, dict($title));
            $this->RPPD->SetFont('Arial', '', $this->fontsize);
            $this->RPPD->Ln(CLX_NUM_FOUR);
            $this->RPPD->SetFont('Arial', 'B', $this->fontsize);
            $this->RPPD->Cell(CLX_NUM_20, CLX_NUM_FOUR, dict('FICO_CODE_DATE'), CLX_NUM_ONE, false, 'C', CLX_NUM_ONE);
            $this->RPPD->Cell(CLX_NUM_60, CLX_NUM_FOUR, dict('FICO_CODE_DESCRIPTION'), CLX_NUM_ONE, false, 'C', CLX_NUM_ONE);
            $this->RPPD->Cell(CLX_NUM_38, CLX_NUM_FOUR, dict('FICO_CODE_INCOME'), CLX_NUM_ONE, false, 'C', CLX_NUM_ONE);
            $this->RPPD->Cell(CLX_NUM_38, CLX_NUM_FOUR, dict('FICO_CODE_WITHDRAWALS'), CLX_NUM_ONE, false, 'C', CLX_NUM_ONE);
            $this->RPPD->Cell(CLX_NUM_39, CLX_NUM_FOUR, dict('FICO_CODE_BALANCE'), CLX_NUM_ONE, false, 'C', CLX_NUM_ONE);
            $this->RPPD->Ln(CLX_NUM_FOUR);
        }
        $table = new htmlTable(CLX_WIDTH_ONE + CLX_NUM_FOUR);
        $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT, CLX_PROP_CLASS => CLX_CLASS_FORM));

        $table->addcells(CLX_CLASS_HEADERS, array('<b>' . dict('FICO_CODE_DATE') . '</b>', '<b>' . dict('FICO_CODE_DESCRIPTION') . '</b>', '<b>' . dict('FICO_CODE_INCOME') . '</b>', '<b>' . dict('FICO_CODE_WITHDRAWALS') . '</b>', '<b>' . dict('FICO_CODE_BALANCE') . '</b>'));
        $table->addcell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_COLSPAN => CLX_NUM_FIVE));
        $i = count($summary);
        foreach ($summary as $key => $val) {
            if ($this->send_pdf === true) {
                $this->RPPD->SetFont('Arial', '', $this->fontsize);
                if ($i > $key && $key > CLX_NUM_ZERO) {
                    $this->RPPD->Cell(CLX_NUM_20, CLX_NUM_FOUR, xFormat::date($val ['EFFTDATE'], $this->date_format), CLX_NUM_ONE, false, 'C');
                    $this->RPPD->Cell(CLX_NUM_60, CLX_NUM_FOUR, capitalize(substr($val ['IDNAME'], CLX_NUM_ZERO, $this->cellmaxchar)), CLX_NUM_ONE, false, 'L');
                    $this->RPPD->Cell(CLX_NUM_38, CLX_NUM_FOUR, xFormat::currency($val ['CR']), CLX_NUM_ONE, false, 'R');
                    $this->RPPD->Cell(CLX_NUM_38, CLX_NUM_FOUR, xFormat::currency($val ['DR']), CLX_NUM_ONE, false, 'R');
                    $this->RPPD->Cell(CLX_NUM_39, CLX_NUM_FOUR, xFormat::currency($val ['BALANCE_AMT']), CLX_NUM_ONE, false, 'R');
                } else {
                    $this->RPPD->SetFont('Arial', 'B', $this->fontsize);
                    $this->RPPD->Cell(CLX_NUM_20, CLX_NUM_FOUR, xFormat::date($val ['EFFTDATE'], $this->date_format), CLX_NUM_ONE, false, 'C');
                    $this->RPPD->Cell(CLX_NUM_136, CLX_NUM_FOUR, capitalize(substr($val ['IDNAME'], CLX_NUM_ZERO, $this->cellmaxchar)), CLX_NUM_ONE, false, 'L');
                    $this->RPPD->Cell(CLX_NUM_39, CLX_NUM_FOUR, xFormat::currency($val ['BAL']), CLX_NUM_ONE, false, 'R');
                }
                $this->RPPD->Ln(CLX_NUM_FOUR);
            } else {
                $table->addCell(xFormat::date($val ['EFFTDATE'], $this->date_format), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                if ($i > $key && $key > CLX_NUM_ZERO) {
                    $table->addcells(CLX_CLASS_DATA, array(capitalize($val ['IDNAME'])));
                    $table->addcell(xFormat::currency($val ['CR']), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => CLX_CLASS_DATA));
                    $table->addcell(xFormat::currency($val ['DR']), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => CLX_CLASS_DATA));
                    $table->addcell(xFormat::currency($val ['BALANCE_AMT']), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => CLX_CLASS_DATA));
                } else {
                    $table->addcell('<b>' . capitalize($val ['IDNAME']) . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_LEFT));
                    $table->addcells(CLX_CLASS_DATA, array(CLX_CHAR_HTML_NBSP, CLX_CHAR_HTML_NBSP));
                    $table->addcell('<b>' . xFormat::currency($val ['BAL']) . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                }
            }
        }
        $tableFrame->addcell($table->source(), array());
        $contents .= $tableFrame->source();
        return $contents;
    }

    /**
     * Builds the period movements
     */
    function buildMovements($ficorec, $glaccountcode, $title = 'GEN_LBL_OPERATIONS', $debit_credit = CLX_NUM_ONE, $summary = false) {
        if ($debit_credit == CLX_NUM_ONE) {
            $lbl_dr = dict('GEN_LBL_DEBITS');
            $lbl_cr = dict('GEN_LBL_CREDITS');
        } elseif ($debit_credit == CLX_NUM_TWO) {
            $lbl_dr = dict('GEN_LBL_INCREMENT');
            $lbl_cr = dict('GEN_LBL_DISMINUTION');
        } else {
            $lbl_dr = dict('FICO_CODE_INCOME');
            $lbl_cr = dict('FICO_CODE_WITHDRAWALS');
        }
        if (is_array($glaccountcode)) {
            $glaccountcode = implode(singleQuote(','), $glaccountcode);
        }
        $single_crit = '';
        if (!empty($this->participant_id)) {
            $single_crit .= ' AND GDVW.CHART_FIELD02 = ' . singleQuote($this->participant_id);
        }
        if (!empty($this->asset_code)) {
            $single_crit .= ' AND GDVW.CHART_FIELD03 = ' . singleQuote($this->asset_code);
        }
        // si es summary ocurre como en devengos donde se muestra el total
        // y luego las operaciones puntuales como las de pago
        if ($summary === true) {
            $sql = ' SELECT  MAX(GDVW.EFFTDATE) EFFTDATE, MAX(GDVW.GL_TYPE) GL_TYPE, SUM(GDVW.DEBIT_AMT - GDVW.CREDIT_AMT) BALANCE_AMT, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' IDNAME,  MAX(GDVW.GL_TYPE) GL_TYPE, 0 DEBITS, 0 CREDITS, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' LEVEL, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' ALLOW_ACTIVITY FROM  ' . $this->gdvwname . ' GDVW WHERE  GDVW.COMP_CODE = ' . singleQuote($this->comp_code) . ' AND	GDVW.CHART_FIELD01 = ' . singleQuote($this->contract_code) . '  AND	GDVW.EFFTDATE < ' . singleQuote($this->sdate) . ' AND GDVW.JE_SOURCE NOT IN (' . singleQuoteArray(array('CRGC', 'CRGR')) . ') AND GDVW.GLACCOUNTCODE IN (' . singleQuote($glaccountcode) . ')  AND GDVW.REVERSED = 0 ' . $single_crit . ' ';
        } else {
            $sql = ' SELECT  MAX(GDVW.GL_TYPE) GL_TYPE, SUM((GDVW.DEBIT_AMT - GDVW.CREDIT_AMT)) BALANCE_AMT, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' IDNAME,  MAX(GDVW.GL_TYPE) GL_TYPE, 0 DEBITS, 0 CREDITS, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' LEVEL, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' ALLOW_ACTIVITY, ' . singleQuote($this->sdate) . ' EFFTDATE FROM  ' . $this->gdvwname . ' GDVW WHERE  GDVW.COMP_CODE = ' . singleQuote($this->comp_code) . ' AND	GDVW.CHART_FIELD01 = ' . singleQuote($this->contract_code) . '  AND	GDVW.EFFTDATE < ' . singleQuote($this->sdate) . ' AND GDVW.JE_SOURCE NOT IN (' . singleQuoteArray(array('CRGC', 'CRGR')) . ') AND GDVW.GLACCOUNTCODE IN (' . singleQuote($glaccountcode) . ')  AND GDVW.REVERSED = 0 ' . $single_crit . ' ';
        }
        $init_vals = ClxCommon::$db->getOneRecord($sql);
        $total = $init_vals ['BALANCE_AMT'];
        if ($debit_credit != CLX_NUM_ONE) { // determine sign
            if ($init_vals ['GL_TYPE'] === 'LI' || $init_vals ['GL_TYPE'] === 'IN') {
                $total = - CLX_NUM_ONE * $total;
                $init_vals ['BALANCE_AMT'] *=-CLX_NUM_ONE;
            }
        }
        // print_r($init_vals);
        $contents = '';
        if ($summary === true) {
            $sql = ' SELECT  MAX(GDVW.GL_TYPE) GL_TYPE, MAX(GDVW.EFFTDATE) EFFTDATE, GDVW.IDNAME TNAME, SUM(GDVW.DEBIT_AMT) DEBITS, SUM(GDVW.CREDIT_AMT) CREDITS  FROM  ' . $this->gdvwname . ' GDVW  WHERE  GDVW.COMP_CODE = ' . singleQuote($this->comp_code) . ' AND	GDVW.CHART_FIELD01 = ' . singleQuote($this->contract_code) . ' AND GDVW.EFFTDATE >= ' . singleQuote($this->sdate) . '  AND GDVW.EFFTDATE <= ' . singleQuote($this->edate) . ' AND GDVW.GLACCOUNTCODE IN (' . singleQuote($glaccountcode) . ') AND GDVW.REVERSED = 0 AND GDVW.JE_SOURCE NOT IN (' . singleQuoteArray(array('CRGC', 'CRGR')) . ') ' . $single_crit . ' GROUP BY GDVW.IDNAME';
        } else {
            $sql = 'SELECT  MAX(GDVW.GL_TYPE) GL_TYPE, GDVW.EFFTDATE, GDVW.IDNAME TNAME, SUM(GDVW.DEBIT_AMT) DEBITS, SUM(GDVW.CREDIT_AMT) CREDITS FROM  ' . $this->gdvwname . ' GDVW  WHERE  GDVW.COMP_CODE = ' . singleQuote($this->comp_code) . ' AND	GDVW.CHART_FIELD01 = ' . singleQuote($this->contract_code) . ' AND GDVW.EFFTDATE >= ' . singleQuote($this->sdate) . '  AND GDVW.EFFTDATE <= ' . singleQuote($this->edate) . ' AND GDVW.GLACCOUNTCODE IN (' . singleQuote($glaccountcode) . ') AND GDVW.REVERSED = 0 AND GDVW.JE_SOURCE NOT IN (' . singleQuoteArray(array('CRGC', 'CRGR', 'CINDX', 'EXVL')) . ') ' . $single_crit . ' GROUP BY GDVW.EFFTDATE, GDVW.IDNAME UNION ALL SELECT  MAX(GDVW.GL_TYPE) GL_TYPE, MAX(GDVW.EFFTDATE) EFFTDATE, GDVW.IDNAME TNAME, SUM(GDVW.DEBIT_AMT) DEBITS, SUM(GDVW.CREDIT_AMT) CREDITS FROM  ' . $this->gdvwname . ' GDVW  WHERE  GDVW.COMP_CODE = ' . singleQuote($this->comp_code) . ' AND	GDVW.CHART_FIELD01 = ' . singleQuote($this->contract_code) . ' AND GDVW.EFFTDATE >= ' . singleQuote($this->sdate) . '  AND GDVW.EFFTDATE <= ' . singleQuote($this->edate) . ' AND GDVW.GLACCOUNTCODE IN (' . singleQuote($glaccountcode) . ') AND GDVW.REVERSED = 0 AND GDVW.JE_SOURCE IN (' . singleQuoteArray(array('CINDX', 'EXVL')) . ') ' . $single_crit . ' GROUP BY GDVW.IDNAME ORDER BY EFFTDATE';
        }

        $summary = array();
        $summary [CLX_NUM_ZERO] = array('EFFTDATE' => $init_vals ['EFFTDATE'], 'IDNAME' => dict('FICO_CODE_SBALANCE'), 'CR' => CLX_NUM_ZERO, 'DR' => CLX_NUM_ZERO, 'BAL' => $init_vals ['BALANCE_AMT']);
        $totalcr = (float) CLX_INIT_ZERO;
        $totaldr = (float) CLX_INIT_ZERO;
        $total = bcadd($totaldr, $init_vals ['BALANCE_AMT']);
        $i = CLX_NUM_ONE;
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            if ($debit_credit != CLX_NUM_ONE) {
                // determine sign display as positive
                if ($result ['GL_TYPE'] === 'LI' || $result ['GL_TYPE'] === 'IN') {
                    $dr = $result ['DEBITS'];
                    $cr = $result ['CREDITS'];
                    $result ['DEBITS'] = $cr;
                    $result ['CREDITS'] = $dr;
                }
            }
            // Tipo de Activo 'Efectivo' y que afecta al efectivo
            $totalcr = bcadd($totalcr, $result ['CREDITS']);
            $totaldr = bcadd($totaldr, $result ['DEBITS']);
            $summary [$i] ['DR'] = $result ['DEBITS'];
            $summary [$i] ['CR'] = $result ['CREDITS'];
            $total = bcadd($total, bcsub($result ['DEBITS'], $result ['CREDITS']));
            $summary [$i] ['EFFTDATE'] = $result ['EFFTDATE'];
            $summary [$i] ['IDNAME'] = $result ['TNAME'];
            $summary [$i] ['BALANCE_AMT'] = $total;
            $i ++;
        }

        // Building Report Table
        if ($this->send_pdf === true) {
            $this->RPPD->Cell(CLX_NUM_ZERO);
            $this->RPPD->Ln(CLX_NUM_SIX);
            $this->RPPD->SetFont('Arial', 'B', $this->titlefontsize);
            $this->RPPD->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, dict($title));
            $this->RPPD->SetFont('Arial', '', $this->fontsize);
            $this->RPPD->Ln(CLX_NUM_FOUR);
            $this->RPPD->SetFont('Arial', 'B', $this->fontsize);
            $this->RPPD->Cell(CLX_NUM_20, CLX_NUM_FOUR, dict('FICO_CODE_DATE'), CLX_NUM_ONE, false, 'C', CLX_NUM_ONE);
            $this->RPPD->Cell(CLX_NUM_60, CLX_NUM_FOUR, dict('FICO_CODE_DESCRIPTION'), CLX_NUM_ONE, false, 'C', CLX_NUM_ONE);
            $this->RPPD->Cell(CLX_NUM_38, CLX_NUM_FOUR, $lbl_dr, CLX_NUM_ONE, false, 'C', CLX_NUM_ONE);
            $this->RPPD->Cell(CLX_NUM_38, CLX_NUM_FOUR, $lbl_cr, CLX_NUM_ONE, false, 'C', CLX_NUM_ONE);
            $this->RPPD->Cell(CLX_NUM_39, CLX_NUM_FOUR, dict('FICO_CODE_BALANCE'), CLX_NUM_ONE, false, 'C', CLX_NUM_ONE);
            $this->RPPD->Ln(CLX_NUM_FOUR);
        } else {
            $tableFrame = new htmlTable(CLX_WIDTH_ONE);
            $tableFrame->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $tableFrame->addcell('<h4>' . dict($title) . '</h4>', array(CLX_PROP_ALIGN => CLX_PROP_LEFT));
            $table = new htmlTable(CLX_WIDTH_ONE + CLX_NUM_FOUR);
            $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT, CLX_PROP_CLASS => CLX_CLASS_FORM));
            $table->addcells(CLX_CLASS_HEADERS, array('<b>' . dict('FICO_CODE_DATE') . '</b>', '<b>' . dict('FICO_CODE_DESCRIPTION') . '</b>', '<b>' . $lbl_dr . '</b>', '<b>' . $lbl_cr . '</b>', '<b>' . dict('GEN_LBL_TOTAL') . '</b>'));
        }
        $i = count($summary);
        foreach ($summary as $key => $val) {
            if ($this->send_pdf === true) {
                $this->RPPD->SetFont('Arial', '', $this->fontsize);
                if ($i > $key && $key > CLX_NUM_ZERO) {
                    $this->RPPD->Cell(CLX_NUM_20, CLX_NUM_FOUR, xFormat::date($val ['EFFTDATE'], $this->date_format), CLX_NUM_ONE, false, 'C');
                    // $this->RPPD->Cell(20,4,xFormat::date($this->edate,$this->date_format),
                    // 1,false,'C');
                    $this->RPPD->Cell(CLX_NUM_60, CLX_NUM_FOUR, capitalize(substr($val ['IDNAME'], CLX_NUM_ZERO, $this->cellmaxchar)), CLX_NUM_ONE, false, 'L');
                    $this->RPPD->Cell(CLX_NUM_38, CLX_NUM_FOUR, xFormat::currency($val ['DR']), CLX_NUM_ONE, false, 'R');
                    $this->RPPD->Cell(CLX_NUM_38, CLX_NUM_FOUR, xFormat::currency($val ['CR']), CLX_NUM_ONE, false, 'R');
                    $this->RPPD->Cell(CLX_NUM_39, CLX_NUM_FOUR, xFormat::currency($val ['BALANCE_AMT']), CLX_NUM_ONE, false, 'R');
                } else {
                    $this->RPPD->SetFont('Arial', 'B', $this->fontsize);
                    $this->RPPD->Cell(CLX_NUM_20, CLX_NUM_FOUR, xFormat::date($val ['EFFTDATE'], $this->date_format), CLX_NUM_ONE, false, 'C');
                    // $this->RPPD->Cell(20,4,xFormat::date($this->edate,$this->date_format),
                    // 1,false,'C');
                    $this->RPPD->Cell(CLX_NUM_136, CLX_NUM_FOUR, $val ['IDNAME'], CLX_NUM_ONE, false, 'L');
                    $this->RPPD->Cell(CLX_NUM_39, CLX_NUM_FOUR, xFormat::currency($val ['BAL']), CLX_NUM_ONE, false, 'R');
                }
                $this->RPPD->Ln(CLX_NUM_FOUR);
            } else {
                $table->addCell(xFormat::date($val ['EFFTDATE'], $this->date_format), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                if ($i > $key && $key > CLX_NUM_ZERO) {
                    $table->addcells(CLX_CLASS_DATA, array(capitalize($val ['IDNAME'])));
                    $table->addcell(xFormat::currency($val ['DR']), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => CLX_CLASS_DATA));
                    $table->addcell(xFormat::currency($val ['CR']), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => CLX_CLASS_DATA));
                    $table->addcell(xFormat::currency($val ['BALANCE_AMT']), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => CLX_CLASS_DATA));
                } else {
                    $table->addcell('<b>' . capitalize($val ['IDNAME']) . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_LEFT));
                    $table->addcells(CLX_CLASS_DATA, array(CLX_CHAR_HTML_NBSP, CLX_CHAR_HTML_NBSP));
                    $table->addcell('<b>' . xFormat::currency($val ['BAL']) . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                }
            }
        }
        if (empty($this->send_pdf)) {
            $tableFrame->addcell($table->source(), array());
            $contents .= $tableFrame->source();
        }
        return $contents;
    }

    /**
     * Builds the period movements
     */
    function buildMovementsInterest($ficorec, $glaccountcode, $title = 'GEN_LBL_OPERATIONS', $debit_credit = CLX_NUM_ONE, $summary = false) {
        if ($debit_credit == CLX_NUM_ONE) {
            $lbl_dr = dict('GEN_LBL_DEBITS');
            $lbl_cr = dict('GEN_LBL_CREDITS');
        } elseif ($debit_credit == CLX_NUM_TWO) {
            $lbl_dr = dict('GEN_LBL_INCREMENT');
            $lbl_cr = dict('GEN_LBL_DISMINUTION');
        } else {
            $lbl_dr = dict('FICO_CODE_INCOME');
            $lbl_cr = dict('FICO_CODE_WITHDRAWALS');
        }
        if (is_array($glaccountcode)) {
            $glaccountcode = implode(singleQuote(','), $glaccountcode);
        }
        $single_crit = '';
        if (!empty($this->participant_id)) {
            $single_crit .= ' AND GDVW.CHART_FIELD02 = ' . singleQuote($this->participant_id);
        }
        if (!empty($this->asset_code)) {
            $single_crit .= ' AND GDVW.CHART_FIELD03 = ' . singleQuote($this->asset_code);
        }
        // si es summary ocurre como en devengos donde se muestra el total
        // y luego las operaciones puntuales como las de pago
        $sql = ' SELECT  MAX(GDVW.EFFTDATE) EFFTDATE, MAX(GDVW.GL_TYPE) GL_TYPE, SUM(GDVW.DEBIT_AMT - GDVW.CREDIT_AMT) BALANCE_AMT, SUM(GDVW.DEBIT_AMT - GDVW.CREDIT_AMT) BAL, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' IDNAME,  MAX(GDVW.GL_TYPE) GL_TYPE, SUM(GDVW.DEBIT_AMT) DEBITS, SUM(GDVW.CREDIT_AMT) CREDITS, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' LEVEL, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' ALLOW_ACTIVITY FROM  ' . $this->gdvwname . ' GDVW WHERE  GDVW.COMP_CODE = ' . singleQuote($this->comp_code) . ' AND	GDVW.CHART_FIELD01 = ' . singleQuote($this->contract_code) . '  AND	GDVW.EFFTDATE <= ' . singleQuote($this->edate) . ' AND GDVW.JE_SOURCE NOT IN (' . singleQuoteArray(array('CRGC', 'CRGR')) . ') AND GDVW.GLACCOUNTCODE IN (' . singleQuote($glaccountcode) . ')  AND GDVW.REVERSED = 0 ' . $single_crit . ' ';
        $init_vals = ClxCommon::$db->getOneRecord($sql);
        $total = $init_vals ['BALANCE_AMT'];
        if ($debit_credit != CLX_NUM_ONE) { // determine sign
            if ($init_vals ['GL_TYPE'] === 'LI' || $init_vals ['GL_TYPE'] === 'IN') {
                $init_vals['BALANCE_AMT'] *= - CLX_NUM_ONE;
                $init_vals['BAL'] *= - CLX_NUM_ONE;
                $dr = $init_vals ['DEBITS'];
                $cr = $init_vals ['CREDITS'];
                $init_vals ['DEBITS'] = $cr;
                $init_vals ['CREDITS'] = $dr;
                $total = - CLX_NUM_ONE * $total;
            }
        }
        // print_r($init_vals);
        $contents = '';
        $sql = 'SELECT  (GDVW.GL_TYPE) GL_TYPE, (GDVW.EFFTDATE) EFFTDATE, GDVW.IDNAME TNAME, (GDVW.DEBIT_AMT) DEBITS, (GDVW.CREDIT_AMT) CREDITS FROM  ' . $this->gdvwname . ' GDVW  WHERE  GDVW.COMP_CODE = ' . singleQuote($this->comp_code) . ' AND	GDVW.CHART_FIELD01 = ' . singleQuote($this->contract_code) . ' AND GDVW.EFFTDATE >= ' . singleQuote($this->sdate) . '  AND GDVW.EFFTDATE <= ' . singleQuote($this->edate) . ' AND GDVW.GLACCOUNTCODE IN (' . singleQuote($glaccountcode) . ') AND GDVW.REVERSED = 0 AND (GDVW.JE_SOURCE =' . singleQuote('USR') . '  OR EXISTS (SELECT JEHD.ID FROM ' . $this->jehdname . ' JEHD WHERE JEHD.IDCODE = GDVW.IDCODE AND JEHD.IS_PAYMENT = 1) ) ' . $single_crit;
        $summary = array();
        $summary [CLX_NUM_ZERO] = array('EFFTDATE' => $init_vals ['EFFTDATE'], 'IDNAME' => dict('GEN_LBL_BALANCE'), 'CR' => $init_vals ['CREDITS'], 'DR' => $init_vals ['DEBITS'], 'BAL' => $init_vals ['BALANCE_AMT']);
        $totalcr = (float) CLX_NUM_ZERO;
        $totaldr = (float) CLX_NUM_ZERO;
        $total = bcadd($totaldr, $init_vals ['BAL']);
        $i = CLX_NUM_ONE;
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            if ($debit_credit != CLX_NUM_ONE) { // determine sign
                if ($result ['GL_TYPE'] === 'LI' || $result ['GL_TYPE'] === 'IN') {
                    $dr = $result ['DEBITS'];
                    $cr = $result ['CREDITS'];
                    $result ['DEBITS'] = $cr;
                    $result ['CREDITS'] = $dr;
                }
            }
            // Tipo de Activo 'Efectivo' y que afecta al efectivo
            $totalcr = bcadd($totalcr, $result ['CREDITS']);
            $totaldr = bcadd($totaldr, $result ['DEBITS']);
            $summary [$i] ['DR'] = $result ['DEBITS'];
            $summary [$i] ['CR'] = $result ['CREDITS'];
            $total = CLX_INIT_ZERO;
            $summary [$i] ['EFFTDATE'] = $result ['EFFTDATE'];
            $summary [$i] ['IDNAME'] = $result ['TNAME'];
            $summary [$i] ['BAL'] = $total;
            $i ++;
        }
        // Building Report Table
        if ($this->send_pdf === true) {
            $this->RPPD->Cell(CLX_NUM_ZERO);
            $this->RPPD->Ln(CLX_NUM_SIX);
            $this->RPPD->SetFont('Arial', 'B', $this->titlefontsize);
            $this->RPPD->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, dict($title));
            $this->RPPD->SetFont('Arial', '', $this->fontsize);
            $this->RPPD->Ln(CLX_NUM_FOUR);
            $this->RPPD->SetFont('Arial', 'B', $this->fontsize);
            $this->RPPD->Cell(CLX_NUM_20, CLX_NUM_FOUR, dict('FICO_CODE_DATE'), CLX_NUM_ONE, false, 'C', CLX_NUM_ONE);
            $this->RPPD->Cell(CLX_NUM_60, CLX_NUM_FOUR, dict('FICO_CODE_DESCRIPTION'), CLX_NUM_ONE, false, 'C', CLX_NUM_ONE);
            $this->RPPD->Cell(CLX_NUM_38, CLX_NUM_FOUR, $lbl_dr, CLX_NUM_ONE, false, 'C', CLX_NUM_ONE);
            $this->RPPD->Cell(CLX_NUM_38, CLX_NUM_FOUR, $lbl_cr, CLX_NUM_ONE, false, 'C', CLX_NUM_ONE);
            $this->RPPD->Cell(CLX_NUM_39, CLX_NUM_FOUR, dict('FICO_CODE_BALANCE'), CLX_NUM_ONE, false, 'C', CLX_NUM_ONE);
            $this->RPPD->Ln(CLX_NUM_FOUR);
        } else {
            $tableFrame = new htmlTable(CLX_WIDTH_ONE);
            $tableFrame->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $tableFrame->addcell('<h4>' . dict($title) . '</h4>', array(CLX_PROP_ALIGN => CLX_PROP_LEFT));
            $table = new htmlTable(CLX_WIDTH_ONE + CLX_NUM_FOUR);
            $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT, CLX_PROP_CLASS => CLX_CLASS_FORM));
            $table->addcells(CLX_CLASS_HEADERS, array('<b>' . dict('FICO_CODE_DATE') . '</b>', '<b>' . dict('FICO_CODE_DESCRIPTION') . '</b>', '<b>' . $lbl_dr . '</b>', '<b>' . $lbl_cr . '</b>', '<b>' . dict('GEN_LBL_TOTAL') . '</b>'));
        }
        $i = count($summary);
        foreach ($summary as $key => $val) {
            if ($this->send_pdf === true) {
                if ($key == CLX_NUM_ZERO) {
                    $this->RPPD->SetFont('Arial', 'B', $this->fontsize);
                } else {
                    $this->RPPD->SetFont('Arial', '', $this->fontsize);
                    $val ['BALANCE_AMT'] = '';
                }
                $this->RPPD->Cell(CLX_NUM_20, CLX_NUM_FOUR, xFormat::date($val ['EFFTDATE'], $this->date_format), CLX_NUM_ONE, false, 'C');
                $this->RPPD->Cell(CLX_NUM_60, CLX_NUM_FOUR, capitalize(substr($val ['IDNAME'], CLX_NUM_ZERO, $this->cellmaxchar)), CLX_NUM_ONE, false, 'L');
                $this->RPPD->Cell(CLX_NUM_38, CLX_NUM_FOUR, xFormat::currency($val ['DR']), CLX_NUM_ONE, false, 'R');
                $this->RPPD->Cell(CLX_NUM_38, CLX_NUM_FOUR, xFormat::currency($val ['CR']), CLX_NUM_ONE, false, 'R');
                if ($key == CLX_NUM_ZERO) {
                    $this->RPPD->Cell(CLX_NUM_39, CLX_NUM_FOUR, xFormat::currency($val ['BAL']), CLX_NUM_ONE, false, 'R');
                    // separator
                    $this->RPPD->Ln(CLX_NUM_FOUR);
                    $this->RPPD->Cell(CLX_NUM_195, CLX_NUM_FOUR, dict('GEN_LBL_OPERATIONS'), CLX_NUM_ONE, false, 'L');
                } else {
                    $this->RPPD->Cell(CLX_NUM_39, CLX_NUM_FOUR, '', CLX_NUM_ONE, false, 'R');
                }
                $this->RPPD->Ln(CLX_NUM_FOUR);
            } else {
                $table->addCell(xFormat::date($val ['EFFTDATE'], $this->date_format), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                if ($i > $key && $key > CLX_NUM_ZERO) {
                    $table->addcells(CLX_CLASS_DATA, array(capitalize($val ['IDNAME'])));
                    $table->addcell(xFormat::currency($val ['DR']), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => CLX_CLASS_DATA));
                    $table->addcell(xFormat::currency($val ['CR']), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => CLX_CLASS_DATA));
                    $table->addcell('', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => CLX_CLASS_DATA));
                } else {
                    $table->addcell('<b>' . capitalize($val ['IDNAME']) . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_LEFT));
                    $table->addcell('<b>' . xFormat::currency($val ['DR']) . '</b>', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => CLX_CLASS_DATA));
                    $table->addcell('<b>' . xFormat::currency($val ['CR']) . '</b>', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => CLX_CLASS_DATA));
                    $table->addcell('<b>' . xFormat::currency($val ['BAL']) . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                    $table->addcell('<b>' . dict('GEN_LBL_OPERATIONS') . '</b>', array(CLX_PROP_CLASS, 'caption', CLX_PROP_COLSPAN, CLX_NUM_FIVE));
                }
            }
        }
        if (empty($this->send_pdf)) {
            $tableFrame->addcell($table->source(), array());
            $contents .= $tableFrame->source();
        }
        return $contents;
    }

    /**
     * Builds the period movements
     */
    function buildAccountPayable($ficorec, $gl_type, $trust_item_type) {

        $single_crit = 'AND GLAC.GL_TYPE = ' . singleQuote($gl_type);
        if (!empty($trust_item_type)) {
            if (is_array($trust_item_type)) {
                $single_crit .= ' AND GLAC.TRUST_ITEM_TYPE IN (' . singleQuote(implode(singleQuote(','), $trust_item_type)) . ') ';
            } else {
                $single_crit .= ' AND GLAC.TRUST_ITEM_TYPE = ' . singleQuote($trust_item_type) . ' ';
            }
        }
        if (!empty($this->participant_id))
            $single_crit .= 'AND JELN.CHART_FIELD02 = ' . singleQuote($this->participant_id);
        $sql = ' SELECT   SUM(JELN.DEBIT_AMT - JELN.CREDIT_AMT) BALANCE_AMT, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' IDNAME,  ' . singleQuote($gl_type) . ' GL_TYPE, 0 DEBITS, 0 CREDITS, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' LEVEL, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' ALLOW_ACTIVITY, ' . singleQuote(adodb_prev_day($this->sdate)) . ' EFFTDATE FROM  ' . $this->glcpname . ' GLCP,  ' . $this->glacname . ' GLAC,  ' . $this->jelnname . ' JELN, ' . $this->jehdname . ' JEHD  WHERE  GLAC.IDCODE = JELN.GLACCOUNTCODE  AND GLCP.COMP_CODE = JEHD.COMP_CODE  AND GLCP.GLGROUP_CODE = GLAC.GLGROUP_CODE AND	JEHD.IDCODE = JELN.JEHDR_CODE   AND	JEHD.JE_STATUS = ' . singleQuote('AP') . '  AND JEHD.COMP_CODE = ' . singleQuote($this->comp_code) . ' AND	JELN.CHART_FIELD01 = ' . singleQuote($this->contract_code) . '  AND	JEHD.EFFTDATE < ' . singleQuote($this->sdate) . '  AND JEHD.REVERSED = 0 ' . $single_crit;
        $init_vals = ClxCommon::$db->getOneRecord($sql);
        $total = $init_vals ['BALANCE_AMT'];
        // print_r($init_vals);
        $contents = '';
        $sql = ' SELECT  MAX(JEHD.EFFTDATE) EFFTDATE, JEHD.IDNAME TNAME, SUM(JELN.DEBIT_AMT) DEBITS, SUM(JELN.CREDIT_AMT) CREDITS FROM  ' . $this->glcpname . ' GLCP, ' . $this->glacname . ' GLAC, ' . $this->jelnname . ' JELN, ' . $this->jehdname . ' JEHD  WHERE GLAC.IDCODE = JELN.GLACCOUNTCODE  AND GLCP.COMP_CODE = JEHD.COMP_CODE  AND GLCP.GLGROUP_CODE = GLAC.GLGROUP_CODE AND	JEHD.IDCODE = JELN.JEHDR_CODE   AND	JEHD.JE_STATUS = ' . singleQuote('AP') . '  AND JEHD.COMP_CODE = ' . singleQuote($this->comp_code) . ' AND	JELN.CHART_FIELD01 = ' . singleQuote($this->contract_code) . ' AND JEHD.EFFTDATE >= ' . singleQuote($this->sdate) . '  AND JEHD.EFFTDATE <= ' . singleQuote($this->edate) . ' AND JEHD.REVERSED = 0 ' . $single_crit . ' GROUP BY JEHD.IDNAME';
        // pre($sql);
        $summary = array();
        $summary [CLX_NUM_ZERO] = array('EFFTDATE' => $init_vals ['EFFTDATE'], 'IDNAME' => dict('FICO_CODE_SBALANCE'), 'CR' => CLX_NUM_ZERO, 'DR' => CLX_NUM_ZERO, 'BAL' => $init_vals ['BALANCE_AMT']);
        $totalcr = (float) CLX_NUM_ZERO;
        $totaldr = (float) CLX_NUM_ZERO;
        $total = bcadd($totaldr, $init_vals ['BALANCE_AMT']);
        $i = CLX_NUM_ONE;
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            // Tipo de Activo 'Efectivo' y que afecta al efectivo
            $totalcr = bcadd($totalcr, $result ['CREDITS']);
            $totaldr = bcadd($totaldr, $result ['DEBITS']);
            $summary [$i] ['DR'] = $result ['DEBITS'];
            $summary [$i] ['CR'] = $result ['CREDITS'];
            $total = bcadd($total, bcsub($result ['DEBITS'], $result ['CREDITS']));
            $summary [$i] ['EFFTDATE'] = $result ['EFFTDATE'];
            $summary [$i] ['IDNAME'] = $result ['TNAME'];
            $summary [$i] ['BALANCE_AMT'] = $total;
            $i ++;
        }
        // Building Report Table
        $tableFrame = new htmlTable(CLX_WIDTH_ONE);
        $tableFrame->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $tableFrame->addcell('<h4>' . dict('FICO_CODE_ACCPAYABLE') . '</h4>', array(CLX_PROP_ALIGN => CLX_PROP_LEFT));
        if ($this->send_pdf === true) {
            $this->RPPD->Cell(CLX_NUM_ZERO);
            $this->RPPD->Ln(CLX_NUM_SIX);
            $this->RPPD->SetFont('Arial', 'B', $this->titlefontsize);
            $this->RPPD->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, dict('FICO_CODE_ACCPAYABLE'));
            $this->RPPD->SetFont('Arial', '', $this->fontsize);
            $this->RPPD->Ln(CLX_NUM_FOUR);
            $this->RPPD->SetFont('Arial', 'B', $this->fontsize);
            $this->RPPD->Cell(CLX_NUM_20, CLX_NUM_FOUR, dict('FICO_CODE_DATE'), CLX_NUM_ONE, false, 'C', CLX_NUM_ONE);
            $this->RPPD->Cell(CLX_NUM_60, CLX_NUM_FOUR, dict('FICO_CODE_DESCRIPTION'), CLX_NUM_ONE, false, 'C', CLX_NUM_ONE);
            $this->RPPD->Cell(CLX_NUM_38, CLX_NUM_FOUR, dict('GEN_LBL_DEBITS'), CLX_NUM_ONE, false, 'C', CLX_NUM_ONE);
            $this->RPPD->Cell(CLX_NUM_38, CLX_NUM_FOUR, dict('GEN_LBL_CREDITS'), CLX_NUM_ONE, false, 'C', CLX_NUM_ONE);
            $this->RPPD->Cell(CLX_NUM_39, CLX_NUM_FOUR, dict('FICO_CODE_BALANCE'), CLX_NUM_ONE, false, 'C', CLX_NUM_ONE);
            $this->RPPD->Ln(CLX_NUM_FOUR);
        }
        $table = new htmlTable(CLX_WIDTH_ONE + CLX_NUM_FOUR);
        $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT, CLX_PROP_CLASS => CLX_CLASS_FORM));
        // CLX_PROP_COLSPAN=> (CLX_WIDTH_ONE+4)));
        $table->addcells(CLX_CLASS_HEADERS, array('<b>' . dict('FICO_CODE_DATE') . '</b>', '<b>' . dict('FICO_CODE_DESCRIPTION') . '</b>', '<b>' . dict('GEN_LBL_DEBITS') . '</b>', '<b>' . dict('GEN_LBL_CREDITS') . '</b>', '<b>' . dict('GEN_LBL_TOTAL') . '</b>'));
        $table->addcell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_COLSPAN => CLX_NUM_FIVE));
        $i = count($summary);
        foreach ($summary as $key => $val) {
            if ($this->send_pdf === true) {
                $this->RPPD->SetFont('Arial', '', $this->fontsize);
                if ($i > $key && $key > CLX_NUM_ZERO) {
                    $this->RPPD->Cell(CLX_NUM_20, CLX_NUM_FOUR, xFormat::date($val ['EFFTDATE'], $this->date_format), CLX_NUM_ONE, false, 'C');
                    // $this->RPPD->Cell(20,4,xFormat::date($this->edate,$this->date_format),
                    // 1,false,'C');
                    $this->RPPD->Cell(CLX_NUM_60, CLX_NUM_FOUR, capitalize(substr($val ['IDNAME'], CLX_NUM_ZERO, $this->cellmaxchar)), CLX_NUM_ONE, false, 'L');
                    $this->RPPD->Cell(CLX_NUM_38, CLX_NUM_FOUR, xFormat::currency($val ['DR']), CLX_NUM_ONE, false, 'R');
                    $this->RPPD->Cell(CLX_NUM_38, CLX_NUM_FOUR, xFormat::currency($val ['CR']), CLX_NUM_ONE, false, 'R');
                    $this->RPPD->Cell(CLX_NUM_39, CLX_NUM_FOUR, xFormat::currency($val ['BALANCE_AMT']), CLX_NUM_ONE, false, 'R');
                } else {
                    $this->RPPD->SetFont('Arial', 'B', $this->fontsize);
                    $this->RPPD->Cell(CLX_NUM_20, CLX_NUM_FOUR, xFormat::date($val ['EFFTDATE'], $this->date_format), CLX_NUM_ONE, false, 'C');
                    // $this->RPPD->Cell(20,4,xFormat::date($this->edate,$this->date_format),
                    // 1,false,'C');
                    $this->RPPD->Cell(CLX_NUM_136, CLX_NUM_FOUR, $val ['IDNAME'], CLX_NUM_ONE, false, 'L');
                    $this->RPPD->Cell(CLX_NUM_39, CLX_NUM_FOUR, xFormat::currency($val ['BAL']), CLX_NUM_ONE, false, 'R');
                }
                $this->RPPD->Ln(CLX_NUM_FOUR);
            } else {
                // CLX_PROP_CLASS,CLX_CLASS_DATA));
                $table->addCell(xFormat::date($val ['EFFTDATE'], $this->date_format), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                if ($i > $key && $key > CLX_NUM_ZERO) {
                    $table->addcells(CLX_CLASS_DATA, array(capitalize($val ['IDNAME'])));
                    $table->addcell(xFormat::currency($val ['DR']), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => CLX_CLASS_DATA));
                    $table->addcell(xFormat::currency($val ['CR']), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => CLX_CLASS_DATA));
                    $table->addcell(xFormat::currency($val ['BALANCE_AMT']), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => CLX_CLASS_DATA));
                } else {
                    $table->addcell('<b>' . capitalize($val ['IDNAME']) . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_LEFT));
                    $table->addcells(CLX_CLASS_DATA, array(CLX_CHAR_HTML_NBSP, CLX_CHAR_HTML_NBSP));
                    $table->addcell('<b>' . xFormat::currency($val ['BAL']) . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                }
            }
        }
        $tableFrame->addcell($table->source(), array());
        $contents .= $tableFrame->source();
        return $contents;
    }

    /**
     * Builds the period movements
     */
    function buildAccountInvestments($ficorec, $gl_type, $trust_item_type, $lbl = 'FICO_CODE_INVESTMENTS') {
        $single_crit = 'AND GLAC.GL_TYPE = ' . singleQuote($gl_type);
        if (!empty($trust_item_type)) {
            if (is_array($trust_item_type)) {
                $single_crit .= ' AND GLAC.TRUST_ITEM_TYPE IN (' . singleQuote(implode("','", $trust_item_type)) . ') ';
            } else {
                $single_crit .= ' AND GLAC.TRUST_ITEM_TYPE = ' . singleQuote($trust_item_type) . ' ';
            }
        }
        if (!empty($this->participant_id)) {
            $single_crit .= ' AND JELN.CHART_FIELD02 = ' . singleQuote($this->participant_id);
        }
        // GDVW
        $sql = ' SELECT SUM(JELN.DEBIT_AMT - JELN.CREDIT_AMT) BALANCE_AMT, 0 DEBITS, 0 CREDITS, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' IDNAME,  ' . singleQuote($gl_type) . ' GL_TYPE, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' LEVEL, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' ALLOW_ACTIVITY, ' . singleQuote(adodb_prev_day($this->sdate)) . ' EFFTDATE FROM  ' . $this->glcpname . ' GLCP,  ' . $this->glacname . ' GLAC,  ' . $this->jelnname . ' JELN, ' . $this->jehdname . ' JEHD  WHERE GLAC.IDCODE = JELN.GLACCOUNTCODE  AND GLCP.COMP_CODE = JEHD.COMP_CODE  AND GLCP.GLGROUP_CODE = GLAC.GLGROUP_CODE  AND JEHD.IDCODE = JELN.JEHDR_CODE ' . /* AND JEHD.JE_SOURCE NOT IN ('RDST') */
                ' AND JEHD.JE_STATUS = ' . singleQuote('AP') . '  AND JEHD.COMP_CODE = ' . singleQuote($this->comp_code) . ' AND JELN.CHART_FIELD01 = ' . singleQuote($this->contract_code) . '  AND JEHD.EFFTDATE < ' . singleQuote($this->sdate) . '  AND JEHD.REVERSED = 0 ' . $single_crit;
        $init_vals = ClxCommon::$db->getOneRecord($sql);
        $total = $init_vals ['BALANCE_AMT'];
        $contents = '';
        $sql = ' SELECT  MAX(JEHD.EFFTDATE) EFFTDATE, GLAC.IDNAME TNAME,  SUM(JELN.DEBIT_AMT) DEBITS, SUM(JELN.CREDIT_AMT) CREDITS FROM  ' . $this->glcpname . ' GLCP,  ' . $this->glacname . ' GLAC,  ' . $this->jelnname . ' JELN, ' . $this->jehdname . ' JEHD  WHERE GLAC.IDCODE = JELN.GLACCOUNTCODE  AND GLCP.COMP_CODE = JEHD.COMP_CODE  AND GLCP.GLGROUP_CODE = GLAC.GLGROUP_CODE  AND JEHD.IDCODE = JELN.JEHDR_CODE  AND JEHD.JE_STATUS = ' . singleQuote('AP') . '  AND JEHD.COMP_CODE = ' . singleQuote($this->comp_code) . ' AND JELN.CHART_FIELD01 = ' . singleQuote($this->contract_code) . '  AND JEHD.EFFTDATE >= ' . singleQuote($this->sdate) . ' AND JEHD.EFFTDATE <= ' . singleQuote($this->edate) . '  AND JEHD.REVERSED = 0 ' . $single_crit . ' GROUP BY GLAC.IDNAME	';
        $summary = array();
        $summary [CLX_NUM_ZERO] = array('EFFTDATE' => $init_vals ['EFFTDATE'], 'IDNAME' => dict('FICO_CODE_SBALANCE'), 'CR' => CLX_NUM_ZERO, 'DR' => CLX_NUM_ZERO, 'BAL' => $init_vals ['BALANCE_AMT']);
        $totalcr = (float) CLX_NUM_ZERO;
        $totaldr = (float) CLX_NUM_ZERO;
        $total = (float) $init_vals ['BALANCE_AMT'];
        $i = CLX_NUM_ONE;
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            // Tipo de Activo 'Efectivo' y que afecta al efectivo
            $totalcr = bcadd($totalcr, $result ['CREDITS']);
            $totaldr = bcadd($totaldr, $result ['DEBITS']);
            $summary [$i] ['DR'] = $result ['DEBITS'];
            $summary [$i] ['CR'] = $result ['CREDITS'];
            $total = bcadd($total, bcsub($result ['DEBITS'], $result ['CREDITS']));
            $summary [$i] ['EFFTDATE'] = $result ['EFFTDATE'];
            $summary [$i] ['IDNAME'] = $result ['TNAME'];
            $summary [$i] ['BALANCE_AMT'] = $total;
            $i ++;
        }
        // Building Report Table
        if ($this->send_pdf === true) {
            $this->RPPD->Cell(CLX_NUM_ZERO);
            $this->RPPD->Ln(CLX_NUM_SIX);
            $this->RPPD->SetFont('Arial', 'B', $this->titlefontsize);
            $this->RPPD->Cell(CLX_NUM_ZERO, CLX_NUM_ZERO, dict($lbl));
            $this->RPPD->SetFont('Arial', '', $this->fontsize);
            $this->RPPD->Ln(CLX_NUM_FOUR);
            $this->RPPD->SetFont('Arial', 'B', $this->fontsize);
            $this->RPPD->Cell(CLX_NUM_20, CLX_NUM_FOUR, dict('FICO_CODE_DATE'), CLX_NUM_ONE, false, 'C', CLX_NUM_ONE);
            $this->RPPD->Cell(CLX_NUM_60, CLX_NUM_FOUR, dict('FICO_CODE_DESCRIPTION'), CLX_NUM_ONE, false, 'C', CLX_NUM_ONE);
            $this->RPPD->Cell(CLX_NUM_38, CLX_NUM_FOUR, dict('GEN_LBL_DEBITS'), CLX_NUM_ONE, false, 'C', CLX_NUM_ONE);
            $this->RPPD->Cell(CLX_NUM_38, CLX_NUM_FOUR, dict('GEN_LBL_CREDITS'), CLX_NUM_ONE, false, 'C', CLX_NUM_ONE);
            $this->RPPD->Cell(CLX_NUM_39, CLX_NUM_FOUR, dict('FICO_CODE_BALANCE'), CLX_NUM_ONE, false, 'C', CLX_NUM_ONE);
            $this->RPPD->Ln(CLX_NUM_FOUR);
        }
        $tableFrame = new htmlTable(CLX_WIDTH_ONE);
        $tableFrame->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $tableFrame->addcell('<h4>' . dict($lbl) . '</h4>', array(CLX_PROP_ALIGN => CLX_PROP_LEFT));
        $table = new htmlTable(CLX_WIDTH_ONE + CLX_NUM_FOUR);
        $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT, CLX_PROP_CLASS => CLX_CLASS_FORM));
        // CLX_PROP_COLSPAN=> (CLX_WIDTH_ONE+4)));
        $table->addcells(CLX_CLASS_HEADERS, array('<b>' . dict('FICO_CODE_DATE') . '</b>', '<b>' . dict('FICO_CODE_DESCRIPTION') . '</b>', '<b>' . dict('GEN_LBL_DEBITS') . '</b>', '<b>' . dict('GEN_LBL_CREDITS') . '</b>', '<b>' . dict('GEN_LBL_TOTAL') . '</b>'));
        $table->addcell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_COLSPAN => CLX_NUM_FIVE));
        $i = count($summary);
        foreach ($summary as $key => $val) {
            if ($this->send_pdf === true) {
                $this->RPPD->SetFont('Arial', '', $this->fontsize);
                if ($i > $key && $key > CLX_NUM_ZERO) {
                    $this->RPPD->Cell(CLX_NUM_20, CLX_NUM_FOUR, xFormat::date($val ['EFFTDATE'], $this->date_format), CLX_NUM_ONE, false, 'C');
                    $this->RPPD->Cell(CLX_NUM_60, CLX_NUM_FOUR, capitalize(substr($val ['IDNAME'], CLX_NUM_ZERO, $this->cellmaxchar)), CLX_NUM_ONE, false, 'L');
                    $this->RPPD->Cell(CLX_NUM_38, CLX_NUM_FOUR, xFormat::currency($val ['DR']), CLX_NUM_ONE, false, 'R');
                    $this->RPPD->Cell(CLX_NUM_38, CLX_NUM_FOUR, xFormat::currency($val ['CR']), CLX_NUM_ONE, false, 'R');
                    $this->RPPD->Cell(CLX_NUM_39, CLX_NUM_FOUR, xFormat::currency($val ['BALANCE_AMT']), CLX_NUM_ONE, false, 'R');
                } else {
                    $this->RPPD->SetFont('Arial', 'B', $this->fontsize);
                    $this->RPPD->Cell(CLX_NUM_20, CLX_NUM_FOUR, xFormat::date($val ['EFFTDATE'], $this->date_format), CLX_NUM_ONE, false, 'C');
                    $this->RPPD->Cell(CLX_NUM_136, CLX_NUM_FOUR, capitalize(substr($val ['IDNAME'], CLX_NUM_ZERO, $this->cellmaxchar)), CLX_NUM_ONE, false, 'L');
                    $this->RPPD->Cell(CLX_NUM_39, CLX_NUM_FOUR, xFormat::currency($val ['BAL']), CLX_NUM_ONE, false, 'R');
                }
                $this->RPPD->Ln(CLX_NUM_FOUR);
            } else {
                $table->addCell(xFormat::date($val ['EFFTDATE'], $this->date_format), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                if ($i > $key && $key > CLX_NUM_ZERO) {
                    $table->addcells(CLX_CLASS_DATA, array(capitalize($val ['IDNAME'])));
                    $table->addcell(xFormat::currency($val ['DR']), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => CLX_CLASS_DATA));
                    $table->addcell(xFormat::currency($val ['CR']), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => CLX_CLASS_DATA));
                    $table->addcell(xFormat::currency($val ['BALANCE_AMT']), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_CLASS => CLX_CLASS_DATA));
                } else {
                    $table->addcell('<b>' . capitalize($val ['IDNAME']) . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_LEFT));
                    $table->addcells(CLX_CLASS_DATA, array(CLX_CHAR_HTML_NBSP, CLX_CHAR_HTML_NBSP));
                    $table->addcell('<b>' . xFormat::currency($val ['BAL']) . '</b>', array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                }
            }
        }
        $tableFrame->addcell($table->source(), array());
        $contents .= $tableFrame->source();
        return $contents;
    }

    /**
     * Init Footer statement methods data
     */
    function page_footer_start($par_comp_code, $ficorec = null) {
        if (!defined('TOKEN_NO_ADDRESS_IN_FOOTPRINT')) {
            define('TOKEN_NO_ADDRESS_IN_FOOTPRINT', '%NO_ADDRESS_IN_FOOTPRINT%'); // Para que no ponga la dirección por defecto en el pie de pagina
            define('TOKEN_ADDRESS', '%ADDRESS%'); // Sustituye en el texto donde se ubique el token por la dirección por defecto.
            define('TOKEN_FOOTPRINT_BEGIN', '%FOOTPRINT_BEGIN%');
            define('TOKEN_FOOTPRINT_END', '%FOOTPRINT_END%'); // Sustituye el pie de pagina standard por este texto entre los tokens
        }
        $this->page_footer_use_def_address = true;
        $this->page_footer_address = $this->page_footer_get_company_address($par_comp_code);
        if (!is_null($ficorec))
            $this->page_footer_get_notes($ficorec);
    }

    /**
     * Get Footer statement Notes
     */
    function page_footer_get_notes($ficorec) {
        $sql = 'SELECT * FROM ' . $this->fsmgname . ' WHERE  FI_TYPE = ' . singleQuote($ficorec ['FI_TYPE']) . ' AND COMP_CODE = ' . singleQuote($ficorec ['COMP_CODE']) . ' AND STATUS = ' . singleQuote('A') . ' AND CLX_EFFTDATE = (SELECT MAX(FSMGB.CLX_EFFTDATE)  FROM ' . $this->fsmgname . ' FSMGB, ' . $this->glcpname . ' GLCP WHERE GLCP.COMP_CODE = ' . singleQuote($ficorec ['COMP_CODE']) . '  AND FSMGB.CLX_EFFTDATE <= GLCP.OPERATION_DATE AND FSMGB.COMP_CODE = GLCP.COMP_CODE AND FSMGB.STATUS = ' . singleQuote('A') . ') UNION ALL  SELECT * FROM ' . $this->fsmgname . ' WHERE  (FI_TYPE = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' OR FI_TYPE IS NULL) AND COMP_CODE = ' . singleQuote($ficorec ['COMP_CODE']) . ' AND STATUS = ' . singleQuote('A') . '  AND CLX_EFFTDATE = (SELECT MAX(FSMGB.CLX_EFFTDATE)  FROM ' . $this->fsmgname . ' FSMGB, ' . $this->glcpname . ' GLCP WHERE GLCP.COMP_CODE = ' . singleQuote($ficorec ['COMP_CODE']) . '  AND (FSMGB.FI_TYPE = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' OR FSMGB.FI_TYPE IS NULL) AND	FSMGB.CLX_EFFTDATE <= GLCP.OPERATION_DATE AND FSMGB.COMP_CODE = GLCP.COMP_CODE AND FSMGB.STATUS = ' . singleQuote('A') . ')';
        $results = ClxCommon::$db->executeQuery($sql);
        $msgs = array();
        while (($result = ClxCommon::$db->getNextRecord($results))) {
            if ($result['CONTRACT_TYPE'] <> '' && $ficorec['CONTRACT_TYPE'] <> $result['CONTRACT_TYPE'])
                continue;
            $line_comment = $this->page_footer_process_special_tokens($result['COMMENTS']);
            $msgs [] = $line_comment . '<BR>' . CLX_CHAR_NL;
        }
        $this->page_footer_notes_msgs = $msgs;
    }

    /**
     * Company Address for footprint
     * @param array $ficorec
     */
    function page_footer_get_company_address($par_comp_code, &$colorec = null) {
        $DBLT = &getTool('DBLT');
        $comprec = ClxCommon::$db->getRecord($this->compname, 'IDCODE = ' . singleQuote($par_comp_code));
        $sql = 'SELECT COLO.* FROM ' . $this->coloname . ' COLO, ' . $this->dyclname . ' DYCL  WHERE DYCL.COMP_CODE =' . singleQuote($comprec['IDCODE']) . ' AND DYCL.COMPLOC_CODE = COLO.IDCODE ORDER BY COLO.ISPRIMARY DESC ';
        $colorec = ClxCommon::$db->getOneRecord($sql);
        if (empty($colorec ['ADDRESS1'])) {
            $colorec ['ADDRESS1'] = '';
        } else {
            $colorec ['ADDRESS1'] = $colorec ['ADDRESS1'] . ' ';
        }
        if (empty($colorec ['ADDRESS2'])) {
            $colorec ['ADDRESS2'] = '';
        } else {
            $colorec ['ADDRESS2'] = $colorec ['ADDRESS2'];
        }
        if (empty($colorec ['CITY'])) {
            $colorec ['CITY'] = '';
        } else {
            $colorec ['CITY'] = $DBLT->getListItem('CITI', $colorec ['CITY'], CLX_NUM_TWO);
        }
        if (empty($colorec ['STATE'])) {
            $colorec ['STATE'] = '';
        } else {
            $colorec ['STATE'] = $DBLT->getListItem('STAT', $colorec ['STATE'], CLX_NUM_TWO);
        }
        if (empty($colorec ['PHONE'])) {
            $colorec ['PHONE'] = '';
        } else {
            $colorec ['PHONE'] = ' Tel: ' . $colorec ['PHONE'];
        }
        if (empty($colorec ['FAX'])) {
            $colorec ['FAX'] = '';
        } else {
            $colorec ['FAX'] = ' Fax: ' . $colorec ['FAX'];
        }
        if (empty($colorec ['COUNTRY'])) {
            $colorec ['COUNTRY'] = '';
        } else {
            $colorec ['COUNTRY'] = $DBLT->getListItem('COUN', $colorec ['COUNTRY'], CLX_NUM_TWO);
        }
        $address = $colorec ['CITY'];
        $address .= ($address !== '' ? ', ' : '') . $colorec ['STATE'];
        $address .= ($address !== '' ? ', ' : '') . $colorec ['COUNTRY'];
        $address .= ($address !== '' ? '. ' : '');
        $address .= $colorec ['PHONE'];
        $address .= ($colorec ['PHONE'] !== '' ? ', ' : '') . $colorec ['FAX'];
        $address = trim($colorec ['ADDRESS1'] . $colorec ['ADDRESS2']) . (!$this->send_pdf ? '<br>' : '. ') . $address;
        return $address;
    }

    function page_footer_process_special_tokens($str_par) {
        $line_comment = ' ' . $str_par; // adds space at the begining to avoid mb_strpos() y str_replace() misbehavior ¿?
        $token_begin = mb_strpos($line_comment, TOKEN_FOOTPRINT_BEGIN);
        //e cho '<br>token_begin = ' . $token_begin;
        if (false === !$token_begin) {
            $token_end = mb_strpos($line_comment, TOKEN_FOOTPRINT_END);
            $total_len = (($token_end + mb_strlen(TOKEN_FOOTPRINT_END)) - $token_begin);
            $this->page_footer_address = mb_substr($line_comment, $token_begin, $total_len);
            $line_comment = str_replace($this->page_footer_address, '', $line_comment);
            $this->page_footer_address = str_replace(TOKEN_FOOTPRINT_BEGIN, '', $this->page_footer_address);
            $this->page_footer_address = str_replace(TOKEN_FOOTPRINT_END, '', $this->page_footer_address);
            unset($token_begin, $token_end, $total_len);
        }
        if (!mb_strpos($line_comment, TOKEN_NO_ADDRESS_IN_FOOTPRINT) === false) {
            $line_comment = str_replace(TOKEN_NO_ADDRESS_IN_FOOTPRINT, '', $line_comment);
            $this->page_footer_use_def_address = false;
        }
        if (!mb_strpos($line_comment, TOKEN_ADDRESS) === false) {
            $line_comment = str_replace(TOKEN_ADDRESS, $this->page_footer_address, $line_comment);
        }
        $line_comment = mb_substr($line_comment, CLX_NUM_ONE); // deletes space at the begining to avoid mb_strpos() y str_replace() misbehavior ¿?
        if ($this->send_pdf === true) {
            $line_comment = str_replace('<br>', CLX_CHAR_NL, $line_comment);
        } else {
            $line_comment = str_replace(CLX_CHAR_NL, '<br>', $line_comment);
        }
        return $line_comment;
    }

    /**
     * PDF Footer lines assigment
     */
    function page_footer_put_pdf_lines($RPPD, $ve_txt_par) {
        $ve_txt = $this->page_footer_process_special_tokens($ve_txt_par);
        $ve_txt = strip_tags(str_replace('<br>', CLX_CHAR_NL, $ve_txt));
        $ve_txt = str_replace(CLX_CHAR_NL . CLX_CHAR_NL, CLX_CHAR_NL, $ve_txt);
        $ve_txt = explode(CLX_CHAR_NL, $ve_txt);
        if (!is_array($ve_txt))
            $ve_txt = array($ve_txt);
        $curr_line_counter = CLX_NUM_ONE;
        $total_footer_lines = $this->page_footer_total_extra_lines + $this->page_footer_total_address_lines;
        $address_line = CLX_NUM_ONE;
        foreach ($ve_txt as $key => $val) {
            if ($curr_line_counter <= $this->page_footer_total_extra_lines) {
                $fld_name_sf = 'extra' . $curr_line_counter;
            } else {
                $fld_name_sf = 'address' . ($curr_line_counter - $this->page_footer_total_extra_lines);
                if ($curr_line_counter >= $total_footer_lines) {
                    $this->page_footer_use_def_address = false;
                } else {
                    $address_line += CLX_NUM_ONE;
                }
            }
            if (!empty($val)) {
                $RPPD->setFooter($fld_name_sf, strip_tags($val));
                $curr_line_counter += CLX_NUM_ONE;
            }
        }
        if ($this->page_footer_use_def_address === true) {
            $fld_name_sf = 'address' . ($address_line);
//e cho '<br> Address Fld Name' . $fld_name_sf . ' = ' . $this->page_footer_address;
            $RPPD->setFooter($fld_name_sf, strip_tags(str_replace('<br>', CLX_CHAR_NL, $this->page_footer_address)));
        }
    }

    /**
     * Estatement Notes
     */
    function buildNotes($ficorec) {
        $contents = '';
        /*
          $sql = 'SELECT * FROM
          $this->fsmgname WHERE  FI_TYPE = ' . singleQuote($ficorec ['FI_TYPE'] . '' AND COMP_CODE = ' . singleQuote($ficorec ['COMP_CODE']).' AND STATUS = ' . singleQuote('A') . ' AND CLX_EFFTDATE = (SELECT MAX(FSMGB.CLX_EFFTDATE)  FROM ' . $this->fsmgname.' FSMGB, ' . $this->glcpname.' GLCP WHERE GLCP.COMP_CODE = ' . singleQuote($ficorec ['COMP_CODE']).'  AND FSMGB.CLX_EFFTDATE <= GLCP.OPERATION_DATE AND FSMGB.COMP_CODE = GLCP.COMP_CODE AND FSMGB.STATUS = ' . singleQuote('A') . ') UNION ALL  SELECT * FROM
          $this->fsmgname WHERE  (FI_TYPE = ' . singleQuote(CLX_CHAR_EMPTY_STRING).' OR FI_TYPE IS NULL) AND COMP_CODE = ' . singleQuote($ficorec ['COMP_CODE']).' AND STATUS = ' . singleQuote('A') . '  AND CLX_EFFTDATE = (SELECT MAX(FSMGB.CLX_EFFTDATE)  FROM ' . $this->fsmgname.' FSMGB, ' . $this->glcpname.' GLCP WHERE GLCP.COMP_CODE = ' . singleQuote($ficorec ['COMP_CODE']).'  AND (FSMGB.FI_TYPE = ' . singleQuote(CLX_CHAR_EMPTY_STRING).' OR FSMGB.FI_TYPE IS NULL) AND	FSMGB.CLX_EFFTDATE <= GLCP.OPERATION_DATE AND FSMGB.COMP_CODE = GLCP.COMP_CODE AND FSMGB.STATUS = ' . singleQuote('A') . ')';
          $results = ClxCommon::$db->executeQuery ( $sql );
          $msgs = array ();
          while ( ($result = ClxCommon::$db->getNextRecord( $results ))  ) {
          if($result['CONTRACT_TYPE']<>'' && $ficorec['CONTRACT_TYPE'] <> $result['CONTRACT_TYPE']) continue;
          $msgs [] = $result ['COMMENTS'] . '<bR>'.CLX_CHAR_NL;
          }
         */
        $msgs = $this->page_footer_notes_msgs;
        if (empty($this->send_pdf)) {
            $tableFrame = new htmlTable(CLX_WIDTH_ONE);
            $tableFrame->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
            // $tableFrame->addcell('<h4>'.dict('FICO_NOTES') . '</h4>',array(CLX_PROP_ALIGN=>CLX_PROP_LEFT));
        }
        if (!empty($msgs)) {
            if ($this->send_pdf === true) {
                $this->RPPD->Cell(CLX_NUM_ZERO);
                $this->RPPD->Ln(CLX_NUM_SIX);
                $this->RPPD->SetFont('Arial', 'I', $this->fontsize);
                /*
                 * $m =
                 * explode(CLX_CHAR_NL,trim(strip_tags(wordwrap(implode(CLX_CHAR_NL,$msgs),
                 * 200, CLX_CHAR_NL, false)))); pre($m); foreach($m as $v){
                 * $this->RPPD->Cell(200, 0, $v, 0, 1, 'C'); $this->RPPD->Ln();
                 * //Cell(float w [, float h [, string txt [, mixed border [,
                 * int ln [, string align [, boolean fill [, mixed link]]]]]]])
                 * }
                 */
                $this->RPPD->MultiCell(CLX_NUM_ZERO, CLX_NUM_2_PT_5, trim(strip_tags(implode(CLX_CHAR_NL, $msgs))), CLX_NUM_ZERO, 'C');
                $this->RPPD->SetFont('Arial', '', $this->fontsize);
                $this->RPPD->Ln(CLX_NUM_FOUR);
            } else {
                $tableFrame->addcell(implode('<br>' . CLX_CHAR_NL, $msgs), array(CLX_PROP_ALIGN => CLX_PROP_CENTER));
            }
        }
        // adding address if html. pdf done on pdf build
        if (empty($this->send_pdf)) {
            $comprec = ClxCommon::$db->getRecord($this->compname, 'IDCODE = ' . singleQuote($ficorec ['COMP_CODE']));
            $ve_txt = $this->page_footer_process_special_tokens($comprec ['VE_TXTINFO']);
            $ve_txt = str_replace(CLX_CHAR_NL, '<br>', $ve_txt);
            if (!empty($ve_txt)) {
                $tableFrame->addcell($ve_txt, array(CLX_PROP_ALIGN => CLX_PROP_CENTER));
            }
            if ($this->page_footer_use_def_address === true) {
                $tableFrame->addcell($this->page_footer_address, array(CLX_PROP_ALIGN => CLX_PROP_CENTER));
            }
            $contents .= $tableFrame->source();
        }
        return $contents;
    }

    /**
     * Build PDF
     */
    function build_pdf($orientation, $title, $ficorec) {
        $comprec = ClxCommon::$db->getRecord($this->compname, 'IDCODE = ' . singleQuote($ficorec ['COMP_CODE']));
        $DBLT = &getTool('DBLT');
        $currency = $DBLT->getListItem('CURR', $comprec ['CURRENCY_CODE'], $this->currency_format);
        $title .= CLX_CHAR_NL . dict('GEN_LBL_CONTRACT_NAME') . ': ' . $ficorec ['IDNAME'] . CLX_CHAR_NL . dict('GEN_LBL_CONTRACT_CODE') . ': ' . $ficorec ['CONTRACT_NUMBER'];
        $title .= CLX_CHAR_NL . dict('GEN_LBL_FROM') . ' ' . xFormat::date($this->sdate, $this->date_format) . ' ' . dict('GEN_LBL_UNTIL') . ' ' . xFormat::date($this->edate, $this->date_format);
        $title .= CLX_CHAR_NL . dict('GEN_LBL_CURRENCY_EXP') . ': ' . $currency;
        // Company Record
        $OBJS = &getTool('OBJS');
  	$FILE = $OBJS->getObject_('DBFT', 'FILE');
        $complogo = $FILE->fileName($comprec ['COMP_LOGO']);
        // Output Report
        $OBJS = & getTool('OBJS');
        $this->RPPD = $OBJS->getObject_('RPFT', 'RPPD');
        $this->RPPD->__construct($orientation, 'mm', 'letter');
        $this->RPPD->SetAuthor($comprec ['IDNAME']);
        $this->RPPD->Open();
        $this->RPPD->setHeaderAdd('logo_x', CLX_NUM_TEN);
        $this->RPPD->setHeaderAdd('logo_y', CLX_NUM_ZERO);
        $this->RPPD->setHeaderAdd('logo_width', CLX_NUM_36_PT_5);
        $this->RPPD->setHeaderAdd('logo_height', CLX_NUM_24_PT_6);
        $this->RPPD->setHeaderAdd('logo_img', $complogo);
        $this->RPPD->setHeaderAdd(CLX_CLASS_TITLE, uppercase($title));
        $this->RPPD->setHeaderAdd('logo_text1', strip_tags(str_replace('<br>', CLX_CHAR_NL, $comprec ['REP_GERENCIA'])));
        $this->RPPD->setHeaderAdd('height', CLX_NUM_FIVE);
        $this->RPPD->setHeaderAdd('border', CLX_NUM_ZERO);
        $this->RPPD->setHeaderAdd('pagination', false);
        $this->RPPD->setHeaderAdd('date', true);
        $this->RPPD->setFooter('enabled', true);
        /*
          $ve_txt = strip_tags ( str_replace ( '<br>', CLX_CHAR_NL, $comprec ['VE_TXTINFO'] ) );
          $ve_txt = str_replace ( CLX_CHAR_NL.CLX_CHAR_NL, CLX_CHAR_NL, $comprec ['VE_TXTINFO'] );
          if (! empty ( $ve_txt [CLX_NUM_ZERO] ))
          $this->RPPD->setFooter ( 'extra1', strip_tags ( $ve_txt [CLX_NUM_ZERO] ) );
          if (! empty ( $ve_txt [1] ))
          $this->RPPD->setFooter ( 'extra2', strip_tags ( $ve_txt [1] ) );
          $this->RPPD->setFooter ( 'address1', strip_tags ( str_replace ( '<br>', CLX_CHAR_NL, $address ) ) );
         */
        $this->page_footer_put_pdf_lines($this->RPPD, $comprec['VE_TXTINFO']);
        $this->RPPD->setFooter('page_location', 'R');
        $this->RPPD->AddPage();
        $this->RPPD->SetFont('Arial', 'B', $this->fontsize);
        $this->RPPD->SetFillColor(CLX_NUM_204, CLX_NUM_204, CLX_NUM_204);
        $this->RPPD->SetAutoPageBreak(true, CLX_NUM_25);
        // Column titles
        $this->RPPD->SetFont('Arial', 'B', $this->fontsize);
        // $this->RPPD->Ln(20);
        // $this->RPPD->Footers();
    }

    /**
     * Description...
     * @param unknown_type $filename
     */
    function send_pdf($filename = 'temp_pdf_stmt') {
        $this->RPPD->Close();
        // $this->RPPD->Output(kPathToTemp.'/' . $filename, 'D');
        $this->RPPD->Output(kPathToTemp . $filename, 'F');
        $this->contents .= note('<a href="' . kPathToTemp . $filename . '" target="_blank">' . dict('GEN_LBL_DOWNLOAD_THE_FILE') . '</a><br>');
    }

    // ESTADO DE CUENTA DE BENEFICIARIOS DE FONDAFA
    /**
     * Build PDF
     */
    function fondafa_build_pdf($orientation, $title) {
        $comprec = ClxCommon::$db->getRecord($this->compname, 'IDCODE = ' . singleQuote($this->comp));
        $title .= CLX_CHAR_NL . dict('GEN_LBL_FROM') . ' ' . xFormat::date($this->sdate, $this->date_format) . ' ' . dict('GEN_LBL_UNTIL') . ' ' . xFormat::date($this->edate, $this->date_format);
        // Company Record
        $OBJS = &getTool('OBJS');
        $FILE = &$OBJS->getObject_('DBFT', 'FILE');
        $complogo = $FILE->fileName($comprec ['COMP_LOGO']);
        // Output Report
        $OBJS = & getTool('OBJS');
        $this->RPPD = $OBJS->getObject_('RPFT', 'RPPD');
        $this->RPPD->__construct($orientation, 'mm', 'letter');
        $this->RPPD->SetAuthor($comprec ['IDNAME']);
        $this->RPPD->Open();
        $this->RPPD->setHeaderAdd('logo_x', CLX_NUM_TEN);
        $this->RPPD->setHeaderAdd('logo_y', CLX_NUM_ZERO);
        $this->RPPD->setHeaderAdd('logo_width', CLX_NUM_36_PT_5);
        $this->RPPD->setHeaderAdd('logo_height', CLX_NUM_24_PT_6);
        $this->RPPD->setHeaderAdd('logo_img', $complogo);
        $this->RPPD->setHeaderAdd(CLX_CLASS_TITLE, uppercase($title));
        $this->RPPD->setHeaderAdd('logo_text1', strip_tags(str_replace('<br>', CLX_CHAR_NL, $comprec ['REP_GERENCIA'])));
        $this->RPPD->setHeaderAdd('height', CLX_NUM_FIVE);
        $this->RPPD->setHeaderAdd('border', CLX_NUM_ZERO);
        $this->RPPD->setHeaderAdd('pagination', false);
        $this->RPPD->setHeaderAdd('date', true);
        $this->RPPD->setFooter('enabled', true);
        $this->page_footer_put_pdf_lines($this->RPPD, $comprec['VE_TXTINFO']);
        $this->RPPD->setFooter('page_location', 'R');
        $this->RPPD->AddPage();
        $this->RPPD->SetFont('Arial', 'B', $this->fontsize);
        $this->RPPD->SetFillColor(CLX_NUM_204, CLX_NUM_204, CLX_NUM_204);
        $this->RPPD->SetAutoPageBreak(true, CLX_NUM_25);
        $this->RPPD->SetFont('Arial', 'B', $this->fontsize);
    }

    // REPORTE DE RENDIMIENTOS
    /**
     * used to display contract earnings report
     */
    function earnings_dialog() {
        $show_detail = false;
        $formcode = 'RTBL_STMT';
        $title = dict('FIDU_TRUST_YIELD');
        // print_r(UserRequest::$request);
        $ac = UserRequest::$request ['ac'];
        $to = UserRequest::$request [CLX_PROP_TO];
        $it = (!empty(UserRequest::$request ['it'])) ? UserRequest::$request ['it'] : '';
        UserRequest::$post ['RTBL_FROM_DATE'] = (empty(UserRequest::$post ['RTBL_FROM_DATE'])) ? $this->sdate : UserRequest::$post ['RTBL_FROM_DATE'];
        UserRequest::$post ['RTBL_TO_DATE'] = (empty(UserRequest::$post ['RTBL_TO_DATE'])) ? $this->edate : UserRequest::$post ['RTBL_TO_DATE'];
        UserRequest::$post ['RTBL_CURRENCY_CODE'] = $this->currency_code;
        // RTBL_REPCINV
        $EDIT = &getTool('EDIT');
        $record = array();
        $msg = array();
        $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote($formcode));
        $record = UserRequest::$post;
        if (!empty($record ['confirm'])) {
            getLookupValue('RTBL_CONTRACT_CODE', 'CONTRACT_CODE', $record);
            getLookupValue('RTBL_ACCOUNTCODE', 'ACCOUNTCODE', $record);
            $EDIT->checkForm2($msg, $formrec);
            if (count(explode('-', UserRequest::$request ['RTBL_TO_DATE'])) != CLX_NUM_THREE) {
                $msg ['RTBL_TO_DATE'] = dict('GEN_ERR_CANTPARSE');
            }
            if (count(explode('-', UserRequest::$request ['RTBL_FROM_DATE'])) != CLX_NUM_THREE) {
                $msg ['RTBL_FROM_DATE'] = dict('GEN_ERR_CANTPARSE');
            }
            if ($this->sdate > $this->edate) {
                /*
                 * GEN_ERR_STARTGREATERENDDATE Start date cannot be greater than
                 * end date. Fecha inicial no puede ser mayor que fecha final.
                 */
                $msg ['RTBL_TO_DATE'] = dict('GEN_ERR_STARTGREATERENDDATE');
                $msg ['RTBL_FROM_DATE'] = dict('GEN_ERR_STARTGREATERENDDATE');
            }
        }
        if (!empty($record ['RTBL_ACCOUNTCODE']) && ClxCommon::$db->oneExistsRecords($this->fipaname, 'CONTRACT_CODE = ' . singleQuote($record ['RTBL_CONTRACT_CODE']) . ' AND ACCOUNTCODE = ' . singleQuote($record ['RTBL_ACCOUNTCODE'])) == CLX_NUM_ZERO) {
            $msg ['RTBL_ACCOUNTCODE'] = dict('CODE_ERR_NOPARTICIPANTFOUND', $record ['RTBL_CONTRACT_CODE']);
        }
        $EDIT = &getTool('EDIT');
        $form = $EDIT->defaultForm($formrec, $record, $msg, $ac, $to, $it, 'index.php', '', $title);
        // Building report
        if (!empty($record ['confirm']) && empty($msg)) {
            // Para ver batchs
            $comp_code = UserRequest::$post ['RTBL_COMP_CODE'];
            $contract_code = UserRequest::$post ['RTBL_CONTRACT_CODE'];
            $participant_id = UserRequest::$post ['RTBL_ACCOUNTCODE'];
            $sdate = UserRequest::$post ['RTBL_FROM_DATE'];
            $edate = UserRequest::$post ['RTBL_TO_DATE'];
            $currency_code = UserRequest::$post ['RTBL_CURRENCY_CODE'];
            // Schedule will redirect if not empty
            // redirect if excheduled
            $this->contents = $form->source();
            $this->initTemporaryTables($this->batch_id);
            // Range balances
            // calculando rendimientos
            $earnings = $this->calculateEarnings($comp_code, $contract_code, $participant_id, $currency_code, $edate, $sdate);

            $table = new htmlTable(CLX_WIDTH_TWO);
            $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $table->addCell($title, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_NUM_TWO));
            if (!empty($contract_code)) {
                $contract_no = ClxCommon::$db->getField($this->ficoname, 'CONTRACT_NUMBER', 'IDCODE = ' . singleQuote($contract_code));
                $contract_name = ClxCommon::$db->getField($this->ficoname, 'IDNAME', 'IDCODE = ' . singleQuote($contract_code));
                $table->addCell(dict('FIDU_CODE_FICONUMBER'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE));
                $table->addCell($contract_no . ', ' . $contract_name, array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
            }
            $tableFrame = new htmlTable(CLX_WIDTH_ONE);
            $tableFrame->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $table = new htmlTable(CLX_WIDTH_ONE);
            $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $table->addcell($title, array(CLX_PROP_CLASS => CLX_CLASS_TITLE));
            $tableFrame->addcell($table->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
            // Account Information
            $table = new htmlTable(CLX_WIDTH_TWO);
            $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
            /*
             * $table->addcells(CLX_CLASS_PROMPT,array( dict('GEN_LBL_REFERENCE_NO')));
             * $table->addcells(CLX_CLASS_DATA,array( $this->batch_id));
             */
            if (!isset($contract_name))
                $contract_name = '';
            $table->addcells(CLX_CLASS_PROMPT, array(capitalize(dict('FIDU_CODE_FICONUMBER'))));
            $table->addcells(CLX_CLASS_DATA, array($contract_code . ', ' . $contract_name));
            if (!empty($participant_id)) {
                $accountname = ClxCommon::$db->getField('CRM_ACCOUNTS', 'IDNAME', 'IDCODE = ' . singleQuote($participant_id));
                $table->addcells(CLX_CLASS_PROMPT, array(capitalize(dict('GEN_LBL_PARTICIPANT'))));
                $table->addcells(CLX_CLASS_DATA, array($participant_id . ', ' . $accountname));
            }
            $table->addcells(CLX_CLASS_PROMPT, array(dict('GEN_LBL_FROM')));
            $table->addcells(CLX_CLASS_DATA, array(xFormat::date($sdate, $this->date_format)));
            $table->addcells(CLX_CLASS_PROMPT, array(dict('GEN_LBL_UNTIL')));
            $table->addcells(CLX_CLASS_DATA, array(xFormat::date($edate, $this->date_format)));
            $DBLT = &getTool('DBLT');
            $table->addcells(CLX_CLASS_PROMPT, array(dict('GEN_LBL_CURRENCY_EXP')));
            $table->addcells(CLX_CLASS_DATA, array($DBLT->getListItem('CURR', $currency_code)));
            $table->addcells(CLX_CLASS_PROMPT, array(dict('GEN_LBL_NUMERAL')));
            $table->addcells(CLX_CLASS_DATA, array(xFormat::currency($earnings ['NUMERAL'], CLX_NUM_FIVE)));
            $table->addcells(CLX_CLASS_PROMPT, array(dict('GEN_LBL_IN_EX')));
            $table->addcells(CLX_CLASS_DATA, array(xFormat::currency($earnings ['INCOME_EXPENSE'], CLX_NUM_FIVE)));
            $table->addcells(CLX_CLASS_PROMPT, array(dict('GEN_LBL_INCOME')));
            $table->addcells(CLX_CLASS_DATA, array(xFormat::currency($earnings ['INCOME'], CLX_NUM_FIVE)));
            $table->addcells(CLX_CLASS_PROMPT, array(dict('GEN_LBL_GROSS_EARNING')));
            $table->addcells(CLX_CLASS_DATA, array(xFormat::currency($earnings ['EARNING_PCT'], CLX_NUM_FIVE) . ' %'));
            $table->addcells(CLX_CLASS_PROMPT, array(dict('GEN_LBL_NET_EARNING')));
            $table->addcells(CLX_CLASS_DATA, array(xFormat::currency($earnings ['NET_EARNING_PCT'], CLX_NUM_FIVE) . ' %'));
            if ($show_detail === true) {
                $table->addcell(dict('GEN_LBL_DETAIL'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_NUM_TWO));
                $sql = 'SELECT  EFFTDATE, NEXT_DATE, GEN_PERIOD, CONTRACT_CODE, PARTICIPANT_ID, GLACCOUNTCODE, GL_TYPE, TRUST_ITEM_TYPE, INIT_BAL_AMT, DEBIT_AMT, CREDIT_AMT, BALANCE_AMT, CALC_AMT_01  FROM ' . $this->glt1name . '  WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' ORDER BY GLACCOUNTCODE, EFFTDATE';
                $results = ClxCommon::$db->executeQuery($sql);
                $tabledet = new htmlTable(CLX_WIDTH_13);
                $tabledet->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
                $tabledet->addcells(CLX_CLASS_HEADERS, array('EFFTDATE', 'NEXT_DATE', 'GEN_PERIOD', 'CONTRACT_CODE', 'PARTICIPANT_ID', 'GLACCOUNTCODE', 'GL_TYPE', 'TRUST_ITEM_TYPE', 'INIT_BAL_AMT', 'DEBIT_AMT', 'CREDIT_AMT', 'BALANCE_AMT', 'CALC_AMT_01'));
                while (($result = ClxCommon::$db->getNextRecord($results, NUMERIC)) === true) {
                    $tabledet->addcells(CLX_CLASS_DATA, array(xFormat::date($result [CLX_NUM_ZERO], $this->date_format), xFormat::date($result [CLX_NUM_ONE], $this->date_format), $result [CLX_NUM_TWO], $result [CLX_NUM_THREE], $result [CLX_NUM_FOUR], $result [CLX_NUM_FIVE], $result [CLX_NUM_SIX], $result [CLX_NUM_7], $result [CLX_NUM_8], $result [CLX_NUM_NINE], $result [CLX_NUM_TEN], $result [CLX_NUM_11], $result [CLX_NUM_12]));
                }
                $table->addcell($tabledet->source(), array(CLX_PROP_COLSPAN => CLX_NUM_TWO));
                unset($tabledet);
            } // show_detail
            $tableFrame->addCell($table->source(), array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            $ccs = '<link href="skins/" . kDefaultSkin . "/styles.css" rel="stylesheet" type="text/css">';
            $this->contents .= $ccs . $tableFrame->source();
        } else {
            $this->contents .= $form->source();
        }
    }

    /**
     * Earning calculations
     *
     * @param array $ficorec
     */
    function calculateEarnings($comp_code, $contract_code, $participant_id, $currency_code, $edate, $sdate) {
        // Participant criteria
        $cc = '';
        if (!empty($contract_code)) {
            $cc .= ' AND JELN.CHART_FIELD01 = ' . singleQuote($contract_code) . ' ';
        }
        if (!empty($participant_id)) {
            $cc .= ' AND JELN.CHART_FIELD02 = ' . singleQuote($participant_id) . ' ';
        }
        // Sumarize balances
        $sql = 'INSERT INTO ' . $this->glt1name . '  (ID, EFFTDATE, NEXT_DATE, GEN_PERIOD, GLACCOUNTCODE, GL_TYPE, TRUST_ITEM_TYPE, INIT_BAL_AMT, DEBIT_AMT, CREDIT_AMT, BALANCE_AMT, CALC_AMT_01, CURRENCY_CODE, BATCH_ID) SELECT JELN.ID, JEHD.EFFTDATE, JEHD.EFFTDATE NEXT_DATE, 0 GEN_PERIOD, JELN.GLACCOUNTCODE, GLAC.GL_TYPE, GLAC.TRUST_ITEM_TYPE, 0 INIT_BAL_AMT, SUM(JELN.DEBIT_AMT) DEBIT_AMT, SUM(JELN.CREDIT_AMT) CREDIT_AMT, 0 BALANCE_AMT, 0 CALC_AMT_01, JELN.CURRENCY_CODE, ' . singleQuote($this->batch_id) . ' BATCH_ID FROM  ' . $this->jehdname . ' JEHD,  ' . $this->jelnname . ' JELN, ' . $this->glacname . ' GLAC WHERE   JEHD.JE_STATUS IN (' . singleQuoteArray(array('AP', 'CLOS')) . ') AND JEHD.COMP_CODE = ' . singleQuote($comp_code) . ' AND JEHD.IDCODE = JELN.JEHDR_CODE AND GLAC.IDCODE = JELN.GLACCOUNTCODE AND JELN.CURRENCY_CODE = ' . singleQuote($currency_code) . $cc . '  AND JEHD.EFFTDATE>=' . singleQuote($sdate) . ' AND JEHD.EFFTDATE<=' . singleQuote($edate) . ' AND (GLAC.GL_TYPE IN (' . singleQuoteArray(array('IN', 'EX')) . ') OR (GLAC.GL_TYPE = ' . singleQuote('EQ') . ' AND GLAC.TRUST_ITEM_TYPE = ' . singleQuote('EQ') . ') OR (GLAC.GL_TYPE = ' . singleQuote('AS') . ' AND GLAC.TRUST_ITEM_TYPE = ' . singleQuote('AR') . '  AND JELN.CREDIT_AMT<>0) OR (GLAC.GL_TYPE = ' . singleQuote('AS') . ' AND GLAC.TRUST_ITEM_TYPE = ' . singleQuote('AD') . ')) AND NOT (JEHD.CLOSING_ENTRY = 1 AND GLAC.GL_TYPE IN(' . singleQuote('IN') . ',' . singleQuote('EX') . ')) AND NOT (JEHD.JE_SOURCE = ' . singleQuote('SETT') . ' AND GLAC.GL_TYPE IN(' . singleQuote('IN') . ',' . singleQuote('EX') . ')) GROUP BY  JEHD.EFFTDATE, JELN.GLACCOUNTCODE, JELN.CURRENCY_CODE, GLAC.GL_TYPE, GLAC.TRUST_ITEM_TYPE ORDER BY EFFTDATE ASC, ID ASC';
        ClxCommon::$db->executeQuery($sql);
        // updating next date
        $sql = 'SELECT DISTINCT  GLT1.CURRENCY_CODE, GLT1.GLACCOUNTCODE,  GLT1.EFFTDATE  FROM ' . $this->glt1name . ' GLT1 WHERE GLT1.BATCH_ID = ' . singleQuote($this->batch_id) . ' ORDER BY EFFTDATE DESC';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $sql = 'UPDATE ' . $this->glt1name . '  GLT1 SET GLT1.NEXT_DATE = ' . singleQuote($r ['EFFTDATE']) . ' WHERE  GLT1.EFFTDATE< ' . singleQuote($r ['EFFTDATE']) . ' AND GLT1.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GLT1.CURRENCY_CODE = ' . singleQuote($r ['CURRENCY_CODE']) . ' AND GLT1.GLACCOUNTCODE = ' . singleQuote($r ['GLACCOUNTCODE']) . ' ';
            ClxCommon::$db->executeQuery($sql);
        }
        // Update begining balances
        $sql = 'SELECT  GLT1.ID, GLT1.CURRENCY_CODE, GLT1.GLACCOUNTCODE,  GLT1.EFFTDATE  FROM ' . $this->glt1name . ' GLT1 WHERE GLT1.BATCH_ID = ' . singleQuote($this->batch_id) . ' ORDER BY EFFTDATE DESC';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $sql = 'SELECT  SUM(GLT1.DEBIT_AMT-GLT1.CREDIT_AMT) BALANCE_AMT  FROM ' . $this->glt1name . ' GLT1 WHERE  GLT1.EFFTDATE< ' . singleQuote($r ['EFFTDATE']) . ' AND GLT1.ID < ' . $r ['ID'] . ' AND GLT1.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GLT1.CURRENCY_CODE = ' . singleQuote($r ['CURRENCY_CODE']) . ' AND GLT1.GLACCOUNTCODE = ' . singleQuote($r ['GLACCOUNTCODE']);
            $ini_bal = ClxCommon::$db->getOne($sql);
            if (empty($ini_bal))
                $ini_bal = CLX_INIT_ZERO;
            $sql = 'UPDATE ' . $this->glt1name . '  GLT1 SET GLT1.INIT_BAL_AMT = ' . $ini_bal . ' WHERE  GLT1.EFFTDATE< ' . singleQuote($r ['EFFTDATE']) . ' AND GLT1.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GLT1.CURRENCY_CODE = ' . singleQuote($r ['CURRENCY_CODE']) . ' AND GLT1.GLACCOUNTCODE = ' . singleQuote($r ['GLACCOUNTCODE']) . ' ';
            ClxCommon::$db->executeQuery($sql);
        }
        // Updating initial values for begining value
        $sql = 'UPDATE ' . $this->glt1name . '  SET INIT_BAL_AMT = (DEBIT_AMT-CREDIT_AMT), DEBIT_AMT = 0, CREDIT_AMT = 0 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND EFFTDATE<' . singleQuote($sdate);
        // Updating period
        $sql = 'UPDATE ' . $this->glt1name . '  SET GEN_PERIOD = (NEXT_DATE-EFFTDATE)  WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        // UPDATING BALANCES
        $sql = 'UPDATE ' . $this->glt1name . '  SET BALANCE_AMT = (INIT_BAL_AMT+DEBIT_AMT-CREDIT_AMT)  WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        // Update numeral
        $sql = 'UPDATE ' . $this->glt1name . '  SET CALC_AMT_01 = BALANCE_AMT * GEN_PERIOD WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        $return = array();
        $sql = 'SELECT IFNULL(SUM(CALC_AMT_01),0)  FROM ' . $this->glt1name . '  WHERE GL_TYPE IN (' . singleQuote('AS') . ',' . singleQuote('EQ') . ')  AND BATCH_ID = ' . singleQuote($this->batch_id);
        $return ['NUMERAL'] = ClxCommon::$db->getOne($sql);
        $sql = 'SELECT round(SUM(DEBIT_AMT-CREDIT_AMT), 2)  FROM ' . $this->glt1name . '  WHERE GL_TYPE IN (' . singleQuote('IN') . ')  AND BATCH_ID = ' . singleQuote($this->batch_id) . ' AND EFFTDATE >=' . singleQuote($sdate);
        $return ['INCOME'] = ClxCommon::$db->getOne($sql);
        $sql = 'SELECT SUM(DEBIT_AMT-CREDIT_AMT)  FROM ' . $this->glt1name . '   WHERE GL_TYPE IN (' . singleQuote('EX') . ')  AND BATCH_ID = ' . singleQuote($this->batch_id) . ' AND EFFTDATE >=' . singleQuote($sdate);
        $return ['EXPENSE'] = ClxCommon::$db->getOne($sql);
        $return ['INCOME_EXPENSE'] = bcadd($return ['INCOME'], $return ['EXPENSE']);
        if ($return ['NUMERAL'] == CLX_NUM_ZERO) {
            $return ['NET_EARNING_PCT'] = CLX_INIT_ZERO;
            $return ['EARNING_PCT'] = CLX_INIT_ZERO;
        } else {
            $a = bcmul($return ['INCOME_EXPENSE'], '360');
            $return ['NET_EARNING_PCT'] = bcmul(bcdiv($a, $return ['NUMERAL']), CLX_NUM_HUNDRED);
            $a = bcmul($return ['INCOME'], '360');
            $return ['EARNING_PCT'] = bcmul(bcdiv($a, $return ['NUMERAL']), CLX_NUM_HUNDRED);
        }
        return $return;
    }

    // ESTADO DE CUENTA DE CREDITOS
    /**
     * Prompt period && Client to display on statement
     */
    function print_dialog_credit($formcode = 'RTBL_FILO_STMT') {
        multiTableName($this, array('FILO', 'PRLT', 'PRAT'));
        $title = dict('CRED_FILO_STATEMENT');
        // print_r(UserRequest::$request);
        $ac = UserRequest::$request ['ac'];
        $to = UserRequest::$request [CLX_PROP_TO];
        $it = (!empty(UserRequest::$request ['it'])) ? UserRequest::$request ['it'] : '';
        UserRequest::$post ['RTBL_FROM_DATE'] = (empty(UserRequest::$post ['RTBL_FROM_DATE'])) ? $this->sdate : UserRequest::$post ['RTBL_FROM_DATE'];
        UserRequest::$post ['RTBL_TO_DATE'] = (empty(UserRequest::$post ['RTBL_TO_DATE'])) ? $this->edate : UserRequest::$post ['RTBL_TO_DATE'];
        UserRequest::$post ['RTBL_COMP_CODE'] = (!empty(UserRequest::$post ['RTBL_COMP_CODE'])) ? UserRequest::$post ['RTBL_COMP_CODE'] : ClxCommon::$db->getField($this->compname, 'IDCODE');
        UserRequest::$post ['RTBL_CURRENCY_CODE'] = $this->currency_code;
        UserRequest::$post ['RTBL_COMP_CODE_prim'] = UserRequest::$post ['RTBL_COMP_CODE'];
        UserRequest::$post ['RTBL_COMP_CODE_secd'] = ClxCommon::$db->getField($this->compname, 'IDNAME', 'IDCODE = ' . singleQuote(UserRequest::$post ['RTBL_COMP_CODE']));
        // RTBL_REPCINV
        $EDIT = &getTool('EDIT');
        $record = array();
        $msg = array();
        $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote($formcode));
        $record = UserRequest::$post;
        if (!empty($record ['confirm'])) {
            getLookupValue('RTBL_CONTRACT_CODE', 'CONTRACT_CODE', $record);
            getLookupValue('RTBL_ACCOUNTCODE', 'ACCOUNTCODE', $record);
            getLookupValue('RTBL_DEBTOR_CODE', 'DEBTOR_CODE', $record);
            getLookupValue('RTBL_LOAN_CODE', 'LOAN_CODE', $record);
            $this->loan_code = $record ['RTBL_LOAN_CODE'];
            $this->debtor_code = $record ['RTBL_DEBTOR_CODE'];
            $EDIT->checkForm2($msg, $formrec);
            if (count(explode('-', UserRequest::$request ['RTBL_TO_DATE'])) != CLX_NUM_THREE) {
                $msg ['RTBL_TO_DATE'] = dict('GEN_ERR_CANTPARSE');
            }
            if (count(explode('-', UserRequest::$request ['RTBL_FROM_DATE'])) != CLX_NUM_THREE) {
                $msg ['RTBL_FROM_DATE'] = dict('GEN_ERR_CANTPARSE');
            }
            if ($this->sdate > $this->edate) {
                /*
                 * GEN_ERR_STARTGREATERENDDATE Start date cannot be greater than
                 * end date. Fecha inicial no puede ser mayor que fecha final.
                 */
                $msg ['RTBL_TO_DATE'] = dict('GEN_ERR_STARTGREATERENDDATE');
                $msg ['RTBL_FROM_DATE'] = dict('GEN_ERR_STARTGREATERENDDATE');
            }
        }
        if (!empty($record ['RTBL_ACCOUNTCODE']) && ClxCommon::$db->oneExistsRecords($this->fipaname, 'CONTRACT_CODE = ' . singleQuote($record ['RTBL_CONTRACT_CODE']) . ' AND ACCOUNTCODE = ' . singleQuote($record ['RTBL_ACCOUNTCODE'])) == CLX_NUM_ZERO) {
            $msg ['RTBL_ACCOUNTCODE'] = dict('CODE_ERR_NOPARTICIPANTFOUND', $record ['RTBL_CONTRACT_CODE']);
        }
        if (empty($_SESSION ['user_record'] ['isadmin'])) {
            $ACTR = &getTool('ACTR');
            $nodes = $ACTR->getUserNodesCriteria('ACCO', 'ACCO.ACCDEP');
            if ($nodes !== '')
                $nodes = ' AND ' . $nodes;
        } else {
            $nodes = '';
        }
        $EDIT = &getTool('EDIT');
        $form = $EDIT->defaultForm($formrec, $record, $msg, $ac, $to, $it, 'tool.php', '', $title);
        if (!empty($record ['confirm']) && empty($msg)) {
            $sql = 'SELECT  FIAS.CONTRACT_CODE,  FIAS.LOAN_CODE, FILO.DEBTOR_CODE, FILO.PRODUCT_CODE, FIAS.IDCODE ASSET_CODE FROM  ' . $this->acconame . ' ACCO, ' . $this->fiasname . ' FIAS, ' . $this->filoname . ' FILO WHERE  FILO.DEBTOR_CODE = ACCO.IDCODE AND FIAS.LOAN_CODE = FILO.IDCODE ' . $nodes . ' AND FILO.COMP_CODE = ' . singleQuote($this->comp_code) . ' AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) FROM CRED_CREDITS FILOX WHERE FILOX.IDCODE = FILO.IDCODE) ';
            if (!empty($this->debtor_code)) {
                $sql .= ' AND FILO.DEBTOR_CODE = ' . singleQuote($this->debtor_code);
            }
            if (!empty($this->loan_code)) {
                $sql .= ' AND FILO.IDCODE = ' . singleQuote($this->loan_code) . ' ';
            }
            if (!empty($this->contract_code)) {
                $sql .= ' AND FIAS.CONTRACT_CODE = ' . singleQuote($this->contract_code) . ' ';
            }
            if (!empty($this->participant_id)) {
                $sql .= ' AND FILO.DEBTOR_CODE = ' . singleQuote($this->participant_id) . ' ';
            }
            $sql .= ' ORDER BY FILO.IDCODE';
            $rs = ClxCommon::$db->executeQuery($sql);
            $i = CLX_INIT_ZERO;
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $i ++;
                $this->contract_code = $r ['CONTRACT_CODE'];
                $this->participant_id = false;
                $this->loan_code = $r ['LOAN_CODE'];
                $this->debtor_code = $r ['DEBTOR_CODE'];
                $this->product_code = $r ['PRODUCT_CODE'];
                $this->asset_code = $r ['ASSET_CODE'];
                $this->buildCreditStatement();
                $this->contents .= ($this->send_pdf) ? $this->nl . $this->nl : '<br><br>';
            }
            if ($i == CLX_NUM_ZERO) {
                $this->contents = note(dict('TOOL_DBQY_MSG_FOUNDRECORDS'));
            }
        } else {
            $this->contents = $form->source();
        }
    }

    /**
     * Builds the credit statement for each account
     * The following section will be included on report:
     * Participant Account, Message Board, Account Summary(General
     * Information), Portfolio Distribution, Account
     * Movements / Other Movements
     */
    function buildCreditStatement() {
        // PDF Options
        $this->headers = array();
        $this->variants = array();
        $this->data = array();
        if (empty($this->send_pdf)) {
            $this->print_btn = true;
        } else {
            $this->print_btn = false;
        }
        $ficoRec = ClxCommon::$db->getRecord($this->ficoname, 'IDCODE = ' . singleQuote($this->contract_code));
        $ficoRec [$this->code . '_CLIENT'] = $this->debtor_code;
        $ficoRec [$this->code . '_SDATE'] = $this->sdate;
        $ficoRec [$this->code . '_EDATE'] = $this->edate;
        if (!empty($ficoRec)) {
            $this->page_footer_start($ficoRec['COMP_CODE'], $ficoRec);
            if ($this->send_pdf === true) {
                $this->build_pdf('P', dict('CRED_FILO_STATEMENT'), $ficoRec);
            }
            // Retrieve period details
            $sql = 'SELECT MAX(IDCODE) IDCODE, MAX(TO_DATE) TO_DATE FROM ' . $this->jacpname . '   WHERE TO_DATE <= ' . singleQuote($this->edate) . ' AND COMP_CODE = ' . singleQuote($this->comp_code);
            $last_period = ClxCommon::$db->getOneRecord($sql);
            $this->fiscal_period = $last_period ['IDCODE'];
            unset($last_period);
            $DBLT = &getTool('DBLT');
            $tableFrame = new htmlTable(CLX_WIDTH_ONE);
            $tableFrame->setProps(array(CLX_PROP_WIDTH => '98%', CLX_PROP_ALIGN => 'center'));
            if (empty($this->send_pdf)) {
                // Title
                $table = new htmlTable(CLX_WIDTH_ONE + CLX_NUM_ONE);
                $table->setProps(array(CLX_PROP_WIDTH => '98%', CLX_PROP_ALIGN => 'center'));
                $table->addcell($this->comp_logo($ficoRec ['COMP_CODE']), array(CLX_PROP_WIDTH => CLX_NUM_ONE));
                $table->addcell('<br><br><h3>' . dict('CRED_FILO_STATEMENT') . '<br>' . uppercase(dict('GEN_LBL_TRUST') . ': ' . $ficoRec ['IDNAME']) . '<br><font size=1>' . dict('GEN_LBL_ISSUED_ON') . ': ' . xFormat::date($ficoRec ['START_DATE'], $this->date_format) . '<br>' . dict('GEN_LBL_CURRENCY_EXP') . ': ' . $DBLT->getListItem('CURR', $this->base_currency_code, $this->currency_format) . '</font></h3><br>', array(CLX_PROP_ALIGN => CLX_PROP_CENTER));
                $tableFrame->addcell($table->source(), array());
            }
            // if not account code just search the principal account
            $aclorec = $this->contractAddress($ficoRec ['IDCODE'], $ficoRec [$this->code . '_CLIENT']);
            if (empty($ficoRec [$this->code . '_CLIENT'])) {
                $ficoRec [$this->code . '_CLIENT'] = ClxCommon::$db->getField($this->fipaname, 'ACCOUNTCODE', 'CONTRACT_CODE = ' . singleQuote($ficoRec ['IDCODE']) . ' AND ISPRIMARY=1');
            }
            $accorec = ClxCommon::$db->getRecord($this->acconame, 'IDCODE = ' . singleQuote($ficoRec [$this->code . '_CLIENT']));
            $aclorec ['IDCODE'] = $accorec ['IDCODE'];
            $aclorec ['IDNAME'] = $accorec ['IDNAME'];
            $tableFrame->addcell(CLX_CHAR_HTML_NBSP, array());
            $tableFrame->addcell($this->buldClient($ficoRec, $aclorec), array());
            // EQUITY - Movimiento del Credito
            $gls = array();
            $sql = 'SELECT PRAT.PRO_GL_CODE FROM ' . $this->pratname . ' PRAT WHERE PRAT.PRODUCT_CODE = ' . singleQuote($this->product_code);
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, NUMERIC)) {
                if (empty($r [CLX_NUM_ZERO]))
                    continue;
                $gls [] = $r [CLX_NUM_ZERO];
            }
            $tableFrame->addcell(CLX_CHAR_HTML_NBSP, array());
            $tableFrame->addcell($this->buildMovements($ficoRec, $gls, 'CRED_GEN_CRED_MOVEMENT', CLX_NUM_TWO), array());
            // Intereses devengados del Credito
            $gls = array();
            $sql = 'SELECT PRAT.AR_GL_CODE  FROM ' . $this->pratname . ' PRAT WHERE PRAT.PRODUCT_CODE = ' . singleQuote($this->product_code);
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, NUMERIC)) {
                if (empty($r [CLX_NUM_ZERO]))
                    continue;
                $gls [] = $r [CLX_NUM_ZERO];
            }
            // Intereses en contingencia
            $sql = 'SELECT PRAT.CINT_GL_CODE FROM ' . $this->pratname . ' PRAT WHERE PRAT.PRODUCT_CODE = ' . singleQuote($this->product_code) . '  AND PRAT.CINT_GL_CODE IS NOT null';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, NUMERIC)) {
                if (empty($r [CLX_NUM_ZERO]))
                    continue;
                $gls [] = $r [CLX_NUM_ZERO];
            }
            $tableFrame->addcell(CLX_CHAR_HTML_NBSP, array());
            $tableFrame->addcell($this->buildMovementsInterest($ficoRec, $gls, 'CRED_GEN_CRED_AR_MOVE', CLX_NUM_TWO, true), array());
            // Mora devengada del Credito
            $gls = array();
            $sql = 'SELECT GLPF.FEE2_GL_CODE  FROM ' . $this->glpfname . ' GLPF WHERE GLPF.PRODUCT_CODE = ' . singleQuote($this->product_code) . ' AND GLPF.FEE2_GL_CODE IS NOT null AND GLPF.CINC_GL_CODE IS NULL';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, NUMERIC)) {
                if (empty($r [CLX_NUM_ZERO]))
                    continue;
                $gls [] = $r [CLX_NUM_ZERO];
            }
            // Cuentas de Intereses sobre Prestamos en Contingencia
            $sql = 'SELECT GLPF.FEE2_GL_CODE FROM ' . $this->glpfname . ' GLPF WHERE GLPF.PRODUCT_CODE = ' . singleQuote($this->product_code) . ' AND GLPF.FEE2_GL_CODE IS NOT null AND GLPF.CINC_GL_CODE IS NOT null';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, NUMERIC)) {
                $gls [] = $r [CLX_NUM_ZERO];
            }
            $tableFrame->addcell(CLX_CHAR_HTML_NBSP, array());
            $tableFrame->addcell($this->buildMovements($ficoRec, $gls, 'CRED_GEN_CRED_LATEF_MOVE', CLX_NUM_TWO, true), array());
            // Mora sobre Prestamos en Contingencia
            // NOTES
            $tableFrame->addcell(CLX_CHAR_HTML_NBSP, array());
            $tableFrame->addcell($this->buildNotes($ficoRec), array());
            if ($this->send_pdf === true) {
                $this->send_pdf('cred_stmt_' . $this->loan_code . '_' . $this->edate . '.pdf');
            } else {
                $this->contents .= $tableFrame->source();
            }
        }
        return;
    }

    // OTROS
    /**
     * Initialice all temporary tables
     *
     * @param unknown_type $batch_id
     */
    private function initTemporaryTables($batch_id) {
        // Load temporary table - Req on mysql
        $DBTB = &getTool('DBTB');
        $DBTB->buildTemporaryTable('GLT1');
        // Clear tmp
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($batch_id));
    }

// end function
}

// End class
