<?php

if (!class_exists('ItcModule')) {

    /**
     * General Code File
     * For more information contact support@alenet.com
     *
     * @author $Author: fsantana $
     * @copyright Alenet, Inc.
     * @since $Date: 2015-10-07 11:58:37 -0400 (Wed, 07 Oct 2015) $
     * @version $Rev: 7154 $
     *
     *          CHANGE LOG
     *           Included svn prop
     *
     */
    class ItcModule {

        var $contents = '';
        var $send_pdf = false;
        var $date_format = 'd-m-Y';

        function __construct($procParameters = array()) {
            $this->batch_id = (!empty($procParameters ['BATCH_ID'])) ? $procParameters ['BATCH_ID'] : batch_id();
            $this->username = $_SESSION ['user_record'] ['username'];
            $this->now = xFormat::getNow('Y-m-d H:i:s');
            multiTableName($this, array(
                'FILS',
                'FIBK',
                'INSI',
                'IT01',
                'IT02',
                'IT03',
                'IT04',
                'CREB',
                'FILO',
                'CRCL'
            ));
        }

// end method
        // Alertas ITC
        /**
         * Method used on alert to prevent
         *
         * @param array $record
         */
        function itc_001(&$record) {
            $old_local = setlocale(LC_ALL, null);
            if (is_linux()) {
                setlocale(LC_ALL, 'es_ES');
            } else {
                setlocale(LC_ALL, 'esp');
            }
            $record ['CURRENT_DATE'] = ucfirst(strftime('%d de %B de %Y', strtotime('now')));
            $record ['DAY'] = ucfirst(strftime('%d', strtotime($record ['FILS_PERIOD_END_DATE'])));
            $record ['MONTH'] = ucfirst(strftime('%B', strtotime($record ['FILS_PERIOD_END_DATE'])));
            $record ['YEAR'] = ucfirst(strftime('%Y', strtotime($record ['FILS_PERIOD_END_DATE'])));
            $record ['FILS_PERIOD_END_DATE'] = ucfirst(strftime('%d de %B, %Y', strtotime($record ['FILS_PERIOD_END_DATE'])));
            $record ['FILO_END_DATE'] = ucfirst(strftime('%d de %B, %Y', strtotime($record ['FILO_END_DATE'])));
            $record ['FIAT_EFFTDATE'] = ucfirst(strftime('%d de %B de %Y', strtotime($record ['FIAT_EFFTDATE'])));
            // Amortization Table
            $record ['AMORTIZATION_TABLE'] = '<table width=' . CLX_PROP_100PCT . '  style ="border-color:#000000; border-width: 1px 1px 1px 1px; border-style: solid;">';
            if (!class_exists('Filo'))
                includeCodeLib('FILO');
            $sql = 'SELECT
                    MIN(PERIOD_START_DATE) ' . singleQuote('Inicio Período') . ',
                    MAX(PERIOD_END_DATE) ' . singleQuote('Fin Período') . ',
                    SUM(NO_DAYS) ' . singleQuote('Dias') . ',
                    INSTALLMENT_NO ' . singleQuote('Cuota') . ',
                    ROUND(MAX(LOAN_AMT), 2) ' . singleQuote('Monto Crédito') . ',
                    ROUND(MAX(PRINCIPAL_PAY), 2) ' . singleQuote('Principal') . ',
                    LOAN_INTEREST ' . singleQuote('Pct. Interes') . ',
                    ROUND(SUM(INTEREST_PAY), 2) ' . singleQuote('PAGo Interes') . ',
                    RESERVE_PCT ' . singleQuote('Pct. Reserva') . ',
                    ROUND(SUM(RESERVE_PAY), 2) ' . singleQuote('PAGo Reserva') . ',
                    ROUND(SUM(PAYMENT_AMT), 2) ' . singleQuote('Monto Pago') . ',
                    ROUND(MIN(PRINCIPAL_BAL), 2) ' . singleQuote('Saldo') . '
        		FROM ' . $this->filsname . '   WHERE LOAN_CODE = ' . singleQuote($record ['FILO_IDCODE']) . ' AND EFFTDATE = ' . singleQuote($record ['FILO_CLX_EFFTDATE']) . ' GROUP BY INSTALLMENT_NO, LOAN_INTEREST, RESERVE_PCT';
            $rs = ClxCommon::$db->executeQuery($sql);
            $lbl = false;
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $r ['Inicio Período'] = xFormat::date($r ['Inicio Período'], $this->date_format);
                $r ['Fin Período'] = xFormat::date($r ['Fin Período'], $this->date_format);
                if (empty($lbl)) {
                    $record ['AMORTIZATION_TABLE'] .= '<tr >';
                    foreach ($r as $key => $val) {
                        $record ['AMORTIZATION_TABLE'] .= '<td style ="border-color:#000000; border-width: 1px 1px 1px 1px; border-style: solid;"><b>' . $key . '</b></td>';
                    }
                    $record ['AMORTIZATION_TABLE'] .= '</tr>';
                }
                $lbl = true;
                $record ['AMORTIZATION_TABLE'] .= '<tr><td>' . implode('</td><td> &nbsp;', $r) . '</td></tr>';
            }
            $record ['AMORTIZATION_TABLE'] .= '</table>';
            setlocale(LC_ALL, $old_local);
        }

// end method
        /**
         * Method used on alert to prevent
         *
         * @param array $record
         */
        function itc_002(&$record) {
            $old_local = setlocale(LC_ALL, null);
            if (is_linux()) {
                setlocale(LC_ALL, 'es_ES');
            } else {
                setlocale(LC_ALL, 'esp');
            }
            $record ['CURRENT_DATE'] = ucfirst(strftime('%d de %B de %Y', strtotime('now')));
            $record ['DAY'] = ucfirst(strftime('%d', strtotime($record ['FILO_ADJ_INDEX_DATE'])));
            $record ['MONTH'] = ucfirst(strftime('%B', strtotime($record ['FILO_ADJ_INDEX_DATE'])));
            $record ['YEAR'] = ucfirst(strftime('%Y', strtotime($record ['FILO_ADJ_INDEX_DATE'])));
            setlocale(LC_ALL, $old_local);
        }

// end method
        /**
         * Method used on alert to prevent
         *
         * @param array $record
         */
        function itc_003(&$record) {
            $old_local = setlocale(LC_ALL, null);
            setlocale(LC_ALL, (is_linux()) ? 'es_ES' : 'esp');
            $DBLT = getTool('DBLT');
            $fibkrec = ClxCommon::$db->getFields($this->fibkname, 'BENEFICIARY_NAME, BANK_PROD_TYPE, BANK_CODE', 'BANK_ACCOUNT_NO = ' . singleQuote($record ['FILO_PAY_BANKACT_NO']));
            ///////////////////////////
            //  CR
            // Para que solo ponga el 'nombre' del elemento de la Lista y
            // no el 'nombre(codigo)'. Esto lo pidió ITC
            $record ['FIBK_BANK_PROD_TYPE'] = $DBLT->getListItem('BPTY', $fibkrec ['BANK_PROD_TYPE'], CLX_NUM_TWO);
            ///////////////////////////
            //  CR
            // Para que ponga solamente el numero de la cuenta de banco, hubo que buscar
            // un campo de tipo entero, de tal forma que no le agregue la descripcion
            // de la cuenta (FIBK.IDNAME)
            $record ['REP_NUMBER'] = $record ['FILO_PAY_BANKACT_NO'];
            ///////////////////////////
            $record ['FIBK_BENEFICIARY_NAME'] = $fibkrec ['BENEFICIARY_NAME'];
            $record ['FIBK_BANK_CODE'] = ClxCommon::$db->getField($this->insiname, 'IDNAME', 'IDCODE = ' . singleQuote($fibkrec ['BANK_CODE']));
            $record ['CURRENT_DATE'] = ucfirst(strftime('%d de %B de %Y', strtotime('now')));
            $record ['DAY'] = ucfirst(strftime('%d', strtotime($record ['FILS_PERIOD_END_DATE'])));
            $record ['MONTH'] = ucfirst(strftime('%B', strtotime($record ['FILS_PERIOD_END_DATE'])));
            $record ['YEAR'] = ucfirst(strftime('%Y', strtotime($record ['FILS_PERIOD_END_DATE'])));
            // $record['FILO_START_DATE'] = ucfirst(strftime('%d de %B, %Y',
            ///////////////////////////
            //  CR
            // Para que ponga la fecha correcta se comentó esta línea, ya que esta poniendo
            // una fecha con el año incorrecto. Por mas que se cambia la forma de mostrarlo
            // aca, a la final el programa que realiza el merge le pone el formato
            // que tiene el campo y NO lo que se asigna en este programa. Esto lo pidió ITC
            ///////////////////////////
            $record ['GLCP_OPERATION_DATE'] = ucfirst(strftime('%d de %B de %Y', strtotime($record ['GLCP_OPERATION_DATE'])));
            setlocale(LC_ALL, $old_local);
        }

// end method
        /**
         * Method used on alert to prevent
         *
         * @param array $record
         */
        function itc_004(&$record) {
            $old_local = setlocale(LC_ALL, null);
            if (is_linux()) {
                setlocale(LC_ALL, 'es_ES');
            } else {
                setlocale(LC_ALL, 'esp');
            }
            $record ['CURRENT_DATE'] = ucfirst(strftime('%d de %B de %Y', strtotime('now')));
            $record ['IT01_START_DATE'] = ucfirst(strftime('%d/%m/%Y', strtotime($record ['IT01_START_DATE'])));
            $record ['EFFTDATE'] = ucfirst(strftime('%B', strtotime('now')));
            setlocale(LC_ALL, $old_local);
        }

        /**
         * Initialices temporary table
         */
        function itc_004_init(&$record) {
            $DBTB = &getTool('DBTB');
            $DBTB->buildTemporaryTable('IT01');
            $DBTB->buildTemporaryTable('IT04');
            if (empty($record['COMP_CODE']))
                return;
            $_SESSION ['paging'] ['IT01_LIST'] ['qfilter']['IT01_COMP_CODE'] = $record['COMP_CODE'];
            $_SESSION ['paging'] ['IT02_LIST'] ['criteria'] = ' IT02.COMP_CODE = ' . singleQuote($record['COMP_CODE']);
            //Load temporary table
            $this->it02_init_listing();
        }

// end method
        // Auxiliares para modulo de intermediarios
        /**
         * Transfiere registros perdidos de cuentas del
         * proceso de borrados en intermediarios.
         * Metodo copia de conexion
         * local a ambiente remoto.
         *
         * @param$db_host target
         *        	database host
         * @param$db_user target
         *        	database user
         * @param$db_pass target
         *        	database password
         * @param$db_name target
         *        	database
         * @param $contract_code codigo
         *        	de contrato en criterio
         */
        function itcCopyAcco($db_host, $db_user, $db_pass, $db_name, $contract_code) {
            $contenidoHTML = '';
            // Connect to target
            ClxCommon::$db2 = new MysqlDatabase($db_host, $db_user, $db_pass, $db_name);
            ClxCommon::$db2->connectToDatabase();
            ClxCommon::$db2->selectDatabase();
            // Select all particiapnts missing in acco
            $sql = 'SELECT DISTINCT FIPA.ACCOUNTCODE FROM FIDU_PARTICIPANTS FIPA LEFT JOIN CRM_ACCOUNTS ACCO ON ACCO.IDCODE=FIPA.ACCOUNTCODE WHERE ACCO.IDCODE IS NULL AND FIPA.CONTRACT_CODE=' . singleQuote($contract_code);
            $rs = ClxCommon::$db2->executeQuery($sql);
            while (($r = ClxCommon::$db2->getNextRecord($rs, NUMERIC)) === true) {
                // getting record and copy
                $accorec = ClxCommon::$db->getRecord('CRM_ACCOUNTS', 'IDCODE = ' . singleQuote($r [CLX_NUM_ZERO]));
                if (!empty($accorec)) {
                    $contenidoHTML = 'Transfiriendo ACCO: ' . $accorec ['IDCODE'] . '<Br>';
                    echo $contenidoHTML;
                    ClxCommon::$db2->createRecord('CRM_ACCOUNTS', $accorec, false);
                }
            } // end while
            ClxCommon::$db2->closeConnection();
            unset(ClxCommon::$db2);
        }

// end function
        // Metodo para reporte de intermediarios
        /**
         * Loads intermediary report Additional Information
         *
         * @param unknown_type $record
         */
        static function it03_listing_load_record(&$record) {
            // Lo nuevo que se edit�
            // Crear tabla temporal
            $DBTB = &getTool('DBTB');
            ClxCommon::$db->debug = true;
            $DBTB->buildTemporaryTable('IT01');
            ClxCommon::$db->debug = false;
            // Captura criterios de busqueda
            if (empty($_SESSION ['paging'] ['IT01_LIST']))
                return;
        }

        /**
         * Loads intermediary report Additional Information
         *
         * @param unknown_type $record
         */
        static function it02_listing_load_record(&$record) {
            $sql = 'SELECT
				  SUM(IT02.LOAN_AMT)
				FROM
				  ITC_REP_BENEFICIARY_TMP IT02
				WHERE
				  IT02.PRODUCT_CODE = ' . singleQuote($record ['IT02_PRODUCT_CODE']) . '
				  AND IT02.COMP_CODE = ' . singleQuote($record ['IT02_COMP_CODE']) . '
				  AND IT02.EFFTDATE = ' . singleQuote($record ['IT02_EFFTDATE']);
            $record ['IT02_TOTAL_PROD_AMT'] = ClxCommon::$db->getOne($sql);
        }

// end method
        /**
         * Build listing information
         */
        function it02_init_listing() {
            $DBTB = &getTool('DBTB');
            $DBTB->buildTemporaryTable('IT02');
            // Captura criterios de busqueda
            if (empty($_SESSION ['paging'] ['IT02_LIST'] ['criteria']))
                return;
            $criteria = $_SESSION ['paging'] ['IT02_LIST'] ['criteria'];
            if (empty($criteria))
                return;
            $criteria = str_replace('IT02.COMP_CODE', 'FILO.COMP_CODE', $criteria);
            $criteria = str_replace('IT02.IDENTIFICATION', 'ACCO.IDENTIFICATION', $criteria);
            $criteria = str_replace('IT02.DEBTOR_CODE', 'FILO.DEBTOR_CODE', $criteria);
            $criteria = str_replace('IT02.COSIZE_CLASS', 'CREB.COSIZE_CLASS', $criteria);
            $criteria = str_replace('IT02.EFFTDATE', 'CREB.EFFTDATE', $criteria);
            $criteria = str_replace('IT02.INDUSTRYCLASS', 'CREB.INDUSTRYCLASS', $criteria);
            $criteria = str_replace('IT02.STATE', 'CREB.STATE', $criteria);
            $criteria = str_replace('IT02.FULLNAME', 'CREB.FULLNAME', $criteria);
            // ITC_REP_BENEFICIARY_VW->ITC_REP_BENEFICIARY_TMP
            $sql = 'INSERT INTO ITC_REP_BENEFICIARY_TMP (COMP_CODE, DEBTOR_CODE, LEGAL_TYPE_NAME, ACCDEP, STATE, CITY, COTYPE, CRED_LINE_CODE, INDUSTRYCLASS, COSIZE_CLASS, PRODUCT_CODE, EFFTDATE, FULLNAME, LOAN_AMT, MAX_PRODUCT_AMT, MIN_PRODUCT_AMT, MAX_UNIT_PROD_AMT, MIN_UNIT_PROD_AMT, OVER_MAX_PRODUCT, BELOW_MIN_PRODUCT, TOTAL_PROD_AMT) SELECT FILO.COMP_CODE, FILO.DEBTOR_CODE, /*IFNULL(CREB.IDENTIFICATION,' . singleQuote('NA') . ') IDENTIFICATION,*/ MAX(CREB.LEGAL_TYPE_NAME) LEGAL_TYPE_NAME, ACCO.ACCDEP, MAX(CREB.STATE) STATE, MAX(CREB.CITY) CITY, ACCO.COTYPE, FILO.CRED_LINE_CODE, MAX(CREB.INDUSTRYCLASS) INDUSTRYCLASS, MAX(CREB.COSIZE_CLASS) COSIZE_CLASS, FILO.PRODUCT_CODE, CREB.EFFTDATE, CREB.FULLNAME, SUM(CREB.LOAN_AMT) LOAN_AMT, PRLM.MAX_PRODUCT_AMT, PRLM.MIN_PRODUCT_AMT, PRLM.MAX_UNIT_PROD_AMT, PRLM.MIN_UNIT_PROD_AMT, /*IF (nullIF(PRLM.MAX_UNIT_PROD_AMT,0)<SUM(CREB.LOAN_AMT),1,0)*/0 OVER_MAX_PRODUCT, /*IF (nullIF(PRLM.MIN_UNIT_PROD_AMT,0)>SUM(CREB.LOAN_AMT),1,0)*/0 BELOW_MIN_PRODUCT, 0 TOTAL_PROD_AMT FROM CRM_ACCOUNTS ACCO, CRED_CREDITS FILO, CRED_BENEFICIARIES CREB, CRM_PROD_LIMITS PRLM WHERE CREB.LOAN_CODE = FILO.IDCODE AND FILO.DEBTOR_CODE = ACCO.IDCODE AND PRLM.PRODUCT_CODE = FILO.PRODUCT_CODE AND PRLM.COSIZE_CLASS = CREB.COSIZE_CLASS AND FILO.LOAN_STATUS <> ' . singleQuote('PRE') . ' AND	PRLM.CLX_EFFTDATE = (SELECT MAX(X3.CLX_EFFTDATE) FROM CRM_PROD_LIMITS X3 WHERE X3.PRODUCT_CODE = PRLM.PRODUCT_CODE AND X3.COSIZE_CLASS = PRLM.COSIZE_CLASS AND X3.CLX_EFFTDATE<=CREB.EFFTDATE) AND	FILO.CLX_EFFTDATE = (SELECT MAX(X1.CLX_EFFTDATE) FROM CRED_CREDITS X1 WHERE X1.IDCODE = FILO.IDCODE AND X1.CLX_EFFTDATE<=CREB.EFFTDATE) AND ' . $criteria . '  GROUP BY FILO.COMP_CODE, FILO.DEBTOR_CODE, ACCO.ACCDEP, ACCO.COTYPE, FILO.CRED_LINE_CODE, FILO.PRODUCT_CODE, CREB.EFFTDATE, CREB.FULLNAME, PRLM.MAX_PRODUCT_AMT, PRLM.MIN_PRODUCT_AMT, PRLM.MAX_UNIT_PROD_AMT, PRLM.MIN_UNIT_PROD_AMT';
            echo $sql; 
            ClxCommon::$db->executeQuery($sql);
        }

// End the Method
        /**
         * Loads intermediary report Additional Information
         *
         * @param unknown_type $record
         */
        static function it01_listing_load_record(&$record) {
            // Usado anteriormente, ahora se alimenta la tabla temporal
            // directamente
            // al crear
        }

// end method
        /**
         * inits intermediary report Additional Information
         *
         * @param unknown_type $record
         *
         */
        function it01_init_listing() {
            $DBTB = &getTool('DBTB');
            $DBTB->buildTemporaryTable('IT01');
            $DBTB->buildTemporaryTable('IT04');
            // Captura criterios de busqueda
            if (empty($_SESSION ['paging'] ['IT01_LIST'] ['criteria']))
                return;
            $record = $_SESSION ['paging'] ['IT01_LIST'] ['qfilter'];
            // Clear criteria not needed
            $_SESSION ['paging'] ['IT01_LIST'] ['criteria'] = '1=1';
            $criteria = array();
            if (!empty($record ['IT01_COMP_CODE'])) {
                $criteria ['FILO.COMP_CODE'] = 'FILO.COMP_CODE =' . singleQuote($record ['IT01_COMP_CODE']);
            }
            if (!empty($record ['IT01_DEBTOR_CODE'])) {
                $criteria [] = 'FILO.DEBTOR_CODE = ' . singleQuote($record ['IT01_DEBTOR_CODE']);
            }
            $report_date = $this->today;
            if (!empty($record ['IT01_START_DATE'])) {
                $report_date = $record ['IT01_START_DATE'];
            }
            //Setting date criteria
            //set period
            $asof = (int) xFormat::date($report_date, 'm');
            $asofyear = xFormat::date($report_date, 'Y');
            // Conteo de beneficiarios debe ir por trimestre
            if ($asof >= CLX_NUM_ONE && $asof <= CLX_NUM_THREE) {
                $creb_crit = 'CREB.EFFTDATE >=' . singleQuote($asofyear . '-01-01') . ' AND CREB.EFFTDATE <=' . singleQuote($asofyear . '-03-31') . '';
                $report_date = $asofyear . '-03-31';
            } elseif ($asof >= CLX_NUM_FOUR && $asof <= CLX_NUM_SIX) {
                $creb_crit = 'CREB.EFFTDATE >=' . singleQuote($asofyear . '-04-01') . ' AND CREB.EFFTDATE <=' . singleQuote($asofyear . '-06-30') . '';
                $report_date = $asofyear . '-06-30';
            } elseif ($asof >= CLX_NUM_7 && $asof <= CLX_NUM_NINE) {
                $creb_crit = 'CREB.EFFTDATE >=' . singleQuote($asofyear . '-07-01') . ' AND CREB.EFFTDATE <=' . singleQuote($asofyear . '-09-30') . '';
                $report_date = $asofyear . '-09-30';
            } else {
                $creb_crit = 'CREB.EFFTDATE >=' . singleQuote($asofyear . '-10-01') . ' AND CREB.EFFTDATE <=' . singleQuote($asofyear . '-12-31') . '';
                $report_date = $asofyear . '-12-31';
            }
            $criteria [] = 'FILO.START_DATE <= ' . singleQuote($report_date);
            $criteria = implode(' AND ', $criteria);
            //Sumarizando saldos contables a la fecha del credito
            // ITC_REP_BENEFICIARY_VW->ITC_REP_BENEFICIARY_TMP
            $sql = 'INSERT INTO ITC_REP_INTERMD_TMP (ACCDEP, COMP_CODE, DEBTOR_CODE, IDNAME, IDENTIFICATION, COTYPE, CRED_LINE_CODE, LINE_NAME, LINE_START_DATE, LINE_AMT, LOAN_CODE, LOAN_NAME, START_DATE, LOAN_AMT, PRINCIPAL_BAL, LOAN_PERIOD, EQ_GRACE_PERIODS, PERIOD_TYPE, LOAN_INTEREST, END_DATE, LAST_REPORT_DATE, BENEFICIARY_NO, BENEF_LOAN_AMT, BENEF_PRINC_BAL, LINE_BAL_AMT, LINE_BAL_PCT, UNREPORTED_AMT, REPORTED_PCT, LINE_VS_BENEF_PCT, PRODUCT_CODE, AMRT_LINE_CREDIT) SELECT ACCO.ACCDEP, FILO.COMP_CODE, ACCO.IDCODE DEBTOR_CODE, ACCO.IDNAME, ACCO.IDENTIFICATION, ACCO.COTYPE, CRCL.IDCODE CRED_LINE_CODE, CRCL.IDNAME LINE_NAME, CRCL.CLX_EFFTDATE LINE_START_DATE, CRCL.LINE_AMT LINE_AMT, FILO.IDCODE LOAN_CODE, FILO.IDNAME LOAN_NAME, FILO.START_DATE, FILO.LOAN_AMT, FILO.PRINCIPAL_BAL, FILO.LOAN_PERIOD, FILO.EQ_GRACE_PERIODS, FILO.PERIOD_TYPE, FILO.LOAN_INTEREST, FILO.END_DATE, ' . singleQuote($report_date) . ' LAST_REPORT_DATE, 0 BENEFICIARY_NO, 0 BENEF_LOAN_AMT, 0 BENEF_PRINC_BAL, CRCL.LINE_AMT LINE_BAL_AMT, 0 LINE_BAL_PCT, 0 UNREPORTED_AMT, 0 REPORTED_PCT, 0 LINE_VS_BENEF_PCT, FILO.PRODUCT_CODE, 1 AMRT_LINE_CREDIT FROM CRM_ACCOUNTS ACCO, CRED_CREDIT_LINES CRCL, CRED_CREDITS FILO WHERE ACCO.IDCODE = FILO.DEBTOR_CODE AND CRCL.IDCODE = FILO.CRED_LINE_CODE AND FILO.LOAN_STATUS <> ' . singleQuote('PRE') . ' AND CRCL.CLX_EFFTDATE = (SELECT MIN(X.CLX_EFFTDATE) FROM CRED_CREDIT_LINES X WHERE X.IDCODE = CRCL.IDCODE) AND FILO.CLX_EFFTDATE = (SELECT MIN(X.CLX_EFFTDATE) FROM CRED_CREDITS X WHERE X.IDCODE = FILO.IDCODE) AND ' . $criteria;
            ClxCommon::$db->executeQuery($sql);
            //Ajustando parametro
            $sql = 'UPDATE
			 			ITC_REP_INTERMD_TMP IT01,
			 			CRED_PROD_PRMTR_TBL PRLT
			 		 SET
			 			IT01.PRINCIPAL_BAL = PRLT.AMRT_LINE_CREDIT
			 		 WHERE
			 			PRLT.PRODUCT_CODE = IT01.PRODUCT_CODE';
            ClxCommon::$db->executeQuery($sql);
            //Calculating loan amount
            $sql = 'INSERT INTO ITC_REP_INTERMD_TMP2 (LOAN_CODE,LOAN_AMT) SELECT FIAS.LOAN_CODE, SUM(JELN.DEBIT_AMT-JELN.CREDIT_AMT) LOAN_AMT FROM GL_JOURNAL_HDR JEHD, GL_JOURNAL_LINES JELN, GL_PROD_PRMTR_TBL PRAT, FIDU_ITEMS FIAS, ITC_REP_INTERMD_TMP IT01 WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND JELN.GLACCOUNTCODE = PRAT.PRO_GL_CODE AND JELN.CHART_FIELD03 = FIAS.IDCODE AND FIAS.LOAN_CODE = IT01.LOAN_CODE AND JEHD.JE_STATUS = ' . singleQuote('AP') . ' AND JEHD.EFFTDATE <= ' . singleQuote($report_date) . ' GROUP BY FIAS.LOAN_CODE';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE
			 			ITC_REP_INTERMD_TMP IT01,
			 			ITC_REP_INTERMD_TMP2 IT04
			 		 SET
			 			IT01.PRINCIPAL_BAL = IT04.LOAN_AMT,
			 			IT04.CRED_LINE_CODE = IT01.CRED_LINE_CODE,
			 			IT04.LINE_AMT = IT01.LINE_AMT
			 		 WHERE
			 			IT01.LOAN_CODE = IT04.LOAN_CODE';
            ClxCommon::$db->executeQuery($sql);
            //Actualizando saldo de linea de credito
            $sql = 'UPDATE ITC_REP_INTERMD_TMP2 IT04 SET IT04.AVAILABLE_AMT = (IT04.LINE_AMT-IFNULL((SELECT SUM(IF(IT01.AMRT_LINE_CREDIT=1,IT01.PRINCIPAL_BAL,IT01.LOAN_AMT)) FROM ITC_REP_INTERMD_TMP IT01 WHERE IT04.CRED_LINE_CODE = IT01.CRED_LINE_CODE), 0)) WHERE 1=1';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE
                        ITC_REP_INTERMD_TMP IT01,
                        ITC_REP_INTERMD_TMP2 IT04
                    SET
                        IT01.LINE_BAL_AMT = IT04.AVAILABLE_AMT
                    WHERE
                        IT01.LOAN_CODE = IT04.LOAN_CODE';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ITC_REP_INTERMD_TMP TMP SET TMP.BENEFICIARY_NO = (SELECT COUNT(DISTINCT CREB.IDENTIFICATION) FROM CRED_BENEFICIARIES CREB WHERE CREB.LOAN_CODE = TMP.LOAN_CODE AND ' . $creb_crit . ') WHERE 1=1';
            ClxCommon::$db->executeQuery($sql);
            // Borrar el contenido de la tabla temporal
            $sql = 'DELETE FROM ITC_REP_INTERMD_TMP2';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'INSERT INTO ITC_REP_INTERMD_TMP2 (LOAN_CODE, LOAN_AMT, BENEF_PRINC_BAL, EFFTDATE) SELECT CREB.LOAN_CODE, SUM(CREB.LOAN_AMT) LOAN_AMT, SUM(CREB.PRINCIPAL_BAL) LOAN_AMT, CREB.EFFTDATE FROM CRED_BENEFICIARIES CREB, (SELECT CREB.LOAN_CODE, MAX(CREB.EFFTDATE) EFFTDATE FROM CRED_BENEFICIARIES CREB WHERE ' . $creb_crit . '  GROUP BY  CREB.LOAN_CODE) A WHERE CREB.EFFTDATE = A.EFFTDATE AND CREB.LOAN_CODE = A.LOAN_CODE GROUP BY CREB.LOAN_CODE, CREB.EFFTDATE';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE
                            ITC_REP_INTERMD_TMP IT01
                    SET
                            IT01.LINE_BAL_PCT = IFNULL((IT01.LOAN_AMT /nullIF(IT01.LINE_AMT,0))*100,0),
                            IT01.UNREPORTED_AMT = IT01.LOAN_AMT,
                            IT01.REPORTED_PCT = 0,
                            IT01.LINE_VS_BENEF_PCT = 0
                    WHERE
                            1=1';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE
                        ITC_REP_INTERMD_TMP IT01,
                        ITC_REP_INTERMD_TMP2 CREBX
                    SET
                        IT01.LAST_REPORT_DATE = CREBX.EFFTDATE,
                        IT01.BENEF_LOAN_AMT = CREBX.LOAN_AMT,
                        IT01.BENEF_PRINC_BAL = CREBX.BENEF_PRINC_BAL,
                        IT01.LINE_BAL_PCT = IFNULL((IT01.LOAN_AMT/nullIF(IT01.LINE_AMT,0))*100,0),
                        IT01.UNREPORTED_AMT = IT01.LOAN_AMT - CREBX.LOAN_AMT,
                        IT01.REPORTED_PCT = IFNULL((CREBX.LOAN_AMT/nullIF(IT01.LOAN_AMT,0))*100, 0),
                        IT01.LINE_VS_BENEF_PCT = IFNULL((CREBX.LOAN_AMT/nullIF(IT01.LINE_AMT,0))*100,0)
                    WHERE
                        IT01.LOAN_CODE = CREBX.LOAN_CODE
                ';
            ClxCommon::$db->executeQuery($sql);
        }

// End Method
    }

    // End class
} // end if
