<?php

/**
* General Code File
* For more information contact  support@alenet.com
*
* @author       $Author: cramirez $
* @copyright    Alenet, Inc.
* @since        $Date: 2018-04-20 11:27:35 -0400 (Fri, 20 Apr 2018) $
* @version        $Rev: 9796 $
*
* CHANGE LOG
*  Included svn prop
*/
/*
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
RECORD OF CHANGES 17/03/2008		Extracted from EIBS_utilities.php
07/04/2008 	 create_proc_sched and done_dialog method copied from EIBS_utilities.php to handle process run and new
alter_process_params method from scratch, to handle process paramenters modification
06/05/2008 	 se agrego el parametro debug
14/05/2008 	 metodo create_proc_sched(): se agrego la hora en la fecha de proxima ejecucion para evitor error en oracle
08/07/2008	 se agregaron los metodos get_file_link(), stop_proc_sched() Y get_tablename()
25/07/2008		get_file_link: se cambio el parametro para q sea un array con dos parametros: TITLE, FILENAME. Se agreg� parametro adicional FILENAME_PLAIN para poner el nombre del archivo completo , sin enlace(plain), preventivamente en caso que el enlace sea trasgiversado por el motor de procesos en la versi�n de linea de comando
06/02/2009		nueva estructura de la tabla PRSC (Caso 1001102)
07/07/2009	 documentacion
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
*/
static $prsc_table_new_struc = true;

class proc_eng_params {

	var $process_parameters;
	var $errormsg = '';
	var $tablename = '';
	var $prspname; //Process Schedule Parameters Table
	var $prscname; //Process Schedule Table
	var $debug = false;

	/*
	* Constructor
	* @param array
	* @return void
	*
	*/

	function __construct($parameters = array()) {
		$this->process_parameters = $parameters;
		$PRSP = getTool('PRSP');
		$this->prspname = $PRSP->tablename;
		$PRSC = getTool('PRSC');
		$this->prscname = $PRSC->tablename;
	}

	// Method end
	/*
	* Set tablename property value
	* @param text
	* @return void
	*/
	function set_tablename($tablename) {
		$this->tablename = $tablename;
	}

	// Method end
	/*
	* Gets tablename property value
	* @param void
	* @return text
	*/
	function get_tablename() {
		return $this->tablename;
	}

	// Method end
	/*
	* Verify if paramenters parameter it's a valid array
	* @param void
	* @return boolean
	*/
	function verify_parameters() {
		$b_response = isset($this->process_parameters['SCHEDULECODE']);
		/**
		* GEN_LBL_PARAMETERS
		* Parameters
		* Parametros
		* */
		/**
		* GEN_LBL_NOTSET
		* Not set
		* No definida
		* */
		if (empty($b_response)) {
			$this->errormsg = dict('GEN_LBL_PARAMETERS') . ': ' . dict('GEN_LBL_NOTSET');
		}
		return $b_response;
	}

	/*
	* Creates an entry in process exception table
	* @param text, array
	* @return void
	*/

	function report_exceptions($msg, $a_fields = array()) {
		;
		if (!isset($a_fields['PROC_STATUS']))
			$a_fields['PROC_STATUS'] = 'ERRO';
		if (!isset($a_fields['TABLECODE']))
			$a_fields['TABLECODE'] = $this->tablename;
		// Other field that can be assigned: RECORDID = affected record code of table TABLECODE
		$a_fields['SCHEDULECODE'] = $this->process_parameters['SCHEDULECODE'];
		$a_fields['EFFTDATE'] = $this->process_parameters['START_TIME'];
		$a_fields['LOG_RECID'] = $this->process_parameters['RUNID'];
		$a_fields['description'] = $msg;
		ClxCommon::$db->createRecord('CLX_PR_EXCEPT_LOGS', $a_fields, false);
	}

	// Method end
	/*
	* Alters Process Schedule data to run it inmediatelly
	* @param text, array, text, text
	* @return text
	*/
	//function create_proc_sched($s_title, $ar_pars, $s_recurrence=null, $s_sched_process = null)
	//   - Caso 1002695 - BNP-Prob list al crear campania
	function create_proc_sched($s_title, $ar_pars, $s_recurrence = null, $s_sched_process = null, $s_adic_html = '') {
		if (is_null($s_sched_process))
			$s_sched_process = $this->process_parameters['SCHEDULECODE'];
		if (is_null($s_recurrence))
			$s_recurrence = 'ONE';
		if ($s_title === '')
			$s_title = ClxCommon::$db->getField($this->prscname, 'IDNAME', 'IDCODE =' . singleQuote($s_sched_process));
		$a = new pr_schedules();
		$a->setSchedule($s_sched_process, $s_recurrence, date('Y-m-d'), date('H:i:s'), $ar_pars);
		unset($a);
		// Show a screen telling the user that the process is about to run
		$contents = $this->done_dialog($s_title, dict('GEN_LBL_SCHED_ACTIVITY')) . $s_adic_html;
		return $contents;
	}

	// Method End
	/**
	* Modify $s_sched_process process parameters from array $ar_pars. Each entry of $ar_pars has the name of
	* parameter as the array entry name and the value as the array entry value.
	* @param array, text
	* @return void
	*/
	function alter_process_params($ar_pars, $s_sched_process = null) {
		if (!empty($this->debug)) {
			echoLog('<br>alter_process_params - s_sched_process=' . $s_sched_process . '<br>' . debug_dump('ar_pars', $ar_pars));
		}
		if (is_null($s_sched_process))
			$s_sched_process = $this->process_parameters['SCHEDULECODE'];
		$PRSP = getTool('PRSP');
		foreach ($ar_pars as $s_name => $s_value) {
			if (!empty($this->debug))
			ClxCommon::$db->debug = true;
			ClxCommon::$db->updateRecord($PRSP->tablename, array('PARAMETER_VALUE' => $s_value), 'FIELDNAME = ' . singleQuote($s_name) . ' AND SCHEDULECODE =' . singleQuote($s_sched_process));
			if (!empty($this->debug))
			ClxCommon::$db->debug = false;
		}
	}

	// Method End
	/**
	* End dialog
	* @param text, text
	* @return text
	*/
	function done_dialog($title, $msg) {
		$table = new htmlTable(CLX_WIDTH_TWO);
		$table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_ALIGN => 'center'));
		$table->addCell($title, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
		$table->addCell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
		$table->addCell($msg, array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
		$table->addCell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
		return $table->source();
	}

	// End method
	/*
	* Alters Process Schedule recurrence & optionally parameters to STOP EXECUTING, EVEN DO the log is deleted
	* @param array, text, text
	* @return void
	*/
	function stop_proc_sched($ar_pars = null, $s_recurrence = null, $s_sched_process = null) {
		if (is_null($s_sched_process))
			$s_sched_process = $this->process_parameters['SCHEDULECODE'];
		if (is_null($s_recurrence))
			$s_recurrence = '0'; // 'NEVE'
		// Parameters values
		$this->alter_process_params($ar_pars, $s_sched_process);
		// Schedule to STOP EXECUTING, EVEN DO the log is deleted
		if ($s_recurrence !== '') {
			$ar_sched_pars = array();
			$ar_sched_pars['PR_RECURRENCE'] = $s_recurrence;
			if (!empty($this->debug))
			ClxCommon::$db->debug = true;
			ClxCommon::$db->updateRecord($this->prscname, $ar_sched_pars, 'IDCODE =' . singleQuote($s_sched_process));
			if (!empty($this->debug))
			ClxCommon::$db->debug = false;
		}
	}

	// Method End
	/*
	 * Other usefull functions
	 */

	/**
	 * Returns link to download output file
	 * @param array
	 * @return text
	 */
	function get_file_link($a_filename) {
		$s_link = '';
		$total = count($a_filename);
		for ($i = CLX_NUM_ZERO; $i < $total; $i++) {
			$s_title = dict('GEN_LBL_DOWNLOAD_THE_FILE');
			if (isset($a_filename[$i]['TITLE']))
			$s_title .= ' (' . $a_filename[$i]['TITLE'] . ')';
			$s_link .= '<page t=proc_clsadd></page><a href=' . quote($a_filename[$i]['FILENAME']) . ' target=_blank>' .
			$s_title . '</a><br>';
			if (isset($a_filename[$i]['FILENAME_PLAIN'])) {
				$s_link .= $a_filename[$i]['FILENAME_PLAIN'] . '<br>';
			}
		}
		return note($s_link);
	}

	/*
	 * Optimize current table
	 * @param text
	 * @return void
	 */

	function optimize_table($s_table_name = null) {
		;
		if (kDatabaseType === 'oci') {
			// Oracle
			$sql_template_1 = 'EXEC dbms_stats.gather_schema_stats(' . singleQuote(kDatabaseName) . ', cascade=>true)';
			$sql_template_2 = 'EXEC dbms_stats.gather_table_stats(' . singleQuote(kDatabaseName) . ',' % tablename % ',cascade=>true)';
		} else {
			// MySql
			$sql_template_1 = 'OPTIMIZE TABLE %tablename%';
			$sql_template_2 = '';
		}
		if ($s_table_name == null) {
			$s_table_name = $this->get_tablename();
		}
		$s_table_name = TableName($s_table_name);
		$sql = str_replace('%tablename%', $s_table_name, $sql_template_1);
		if (!empty($this->debug))
			ClxCommon::$db->debug = true;
		ClxCommon::$db->executeQuery($sql);
		if (!empty($this->debug))
			ClxCommon::$db->debug = false;
		if ($sql_template_2 !== '') {
			$sql = str_replace('%tablename%', $s_table_name, $sql_template_2);
			if (!empty($this->debug))
			ClxCommon::$db->debug = true;
			ClxCommon::$db->executeQuery($sql);
			if (!empty($this->debug))
			ClxCommon::$db->debug = false;
		}
	}

}

// proc_eng_params class end
