<?php

/**
 * Default Home Page
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-09-25 14:57:26 -0400 (Fri, 25 Sep 2015) $
 * @version    	$Rev: 7015 $
 */
class srmi_utilities {

    var $contents;

    function __construct() {
        multiTableName($this, array('ACSR', 'SRMI', 'SRRQ'));
        $this->contents = '';
    }

    function action($ac) {
        switch ($ac) {
            case 'MIGRATE':
                if (!empty(UserRequest::$request['comfirm'])) {
                    //Migrating
                    $this->migrate();
                } else {
                    $this->prompt_servers();
                }
                break;
            default;
                break;
        }
        return $this->contents;
    }

    function prompt_servers() {
        $idlist = toString(getIdList());
        $action = (!empty(UserRequest::$server['PHP_SELF'])) ? UserRequest::$server['PHP_SELF'] : 'tool.php';
        $form = new htmlForm(CLX_PROP_ACTION, $action);
        $form->setProp(CLX_PROP_ID, 'theForm');
        $form->addArgument(CLX_PROP_TO, UserRequest::$request[CLX_PROP_TO]);
        $form->addArgument('ac', UserRequest::$request['ac']);
        $form->addArgument('comfirm', CLX_NUM_ONE);
        $form->addArgument('qy', '');
        $form->addArgument('fm', '');
        $table = new htmlTable(CLX_WIDTH_ONE);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $table->addCell(dict('GEN_LBL_MIGRATE'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE));
        $table->addCell(dict('GEN_LBL_CHOOSESERVER'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE));
        $i = CLX_NUM_ZERO;
        $servers = ClxCommon::$db->getRecords($this->acsrname, 'NO_MIGRATIONS=0');
        while (($server = ClxCommon::$db->getNextRecord($servers))) {
            $checkbox = new htmlCheckbox('SERV_' . $server['IDCODE'], CLX_NUM_ZERO, $idlist);
            $class = ($i % CLX_NUM_TWO === CLX_NUM_ONE) ? CLX_CLASS_DATAALT : CLX_CLASS_DATA;
            $i++;
            $table->addCell($checkbox->source() . $server['IDNAME'] . ' (' . $server['IDCODE'] . ')', array(CLX_PROP_CLASS => $class));
        }
        $b = new htmlButtonCancel();
        $btn = $b->source();
        if ($i > CLX_NUM_ZERO) {
            $b = new htmlFormSubmit(dict('GEN_LBL_MIGRATE'), UserRequest::$request['ac'], $form->getProp(CLX_PROP_ID));
            $btn .= $b->source();
        }
        $table->addCell($btn, array(CLX_PROP_CLASS => 'buttons'));
        $form->addContents($table->source());
        $this->contents .= $form->source();
    }

    function migrate() {
        $action = (!empty(UserRequest::$server['PHP_SELF'])) ? UserRequest::$server['PHP_SELF'] : 'tool.php';
        $form = new htmlForm(CLX_PROP_ACTION, $action);
        $form->setProp(CLX_PROP_ID, 'theForm');
        $form->addArgument(CLX_PROP_TO, UserRequest::$request[CLX_PROP_TO]);
        $form->addArgument('ac', UserRequest::$request['ac']);
        $form->addArgument('comfirm', CLX_NUM_ONE);
        $form->addArgument('qy', '');
        $form->addArgument('fm', '');
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $table->addCell(dict('GEN_LBL_MIGRATE'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE));
        $i = CLX_NUM_ZERO;
        if (!function_exists('setCreationData'))
            includeCodeLib('GEN_REC_UTIL');
        foreach (UserRequest::$request as $key => $val) {
            $class = ($i % CLX_NUM_TWO === CLX_NUM_ONE) ? CLX_CLASS_DATAALT : CLX_CLASS_DATA;
            if (strpos($key, 'SERV_') === false)
                continue;
            $server_idcode = str_replace('SERV_', '', $key);
            $sql = 'SELECT R.IDCODE, R.ACCOUNTCODE  FROM ' . $this->srrqname . ' R  WHERE R.ID IN (' . $val . ' ) AND NOT EXISTS(SELECT M.ID  FROM ' . $this->srminame . ' M  WHERE M.RELATED_case = R.IDCODE  AND M.TGT_SERVER=' . singleQuote($server_idcode) . ')';
            $results = ClxCommon::$db->executeQuery($sql);
            while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
                $record = array('IDCODE' => 'AUTO',
                    'IDNAME' => 'Auto Mig.',
                    'RELATED_CASE' => $result['IDCODE'],
                    'MIGRASTAT' => 'C',
                    'ACCOUNTCODE' => $result['ACCOUNTCODE'],
                    'ASSIGNEDTO_USER' => '',
                    'NOTES' => '',
                    'CDATE' => '',
                    'CREATEDBY' => '',
                    'MDATE' => '',
                    'MODIFIEDBY' => '',
                    'TGT_SERVER' => $server_idcode,
                    'EFFTDATETIME' => '');
                $record = setCreationIdCode($record, 'SRMI');
                $record = setCreationData($record);
                $record['ASSIGNEDTO_USER'] = $record['CREATEDBY'];
                $record['EFFTDATETIME'] = $record['CDATE'];
                $record['NOTES'] = $record['IDNAME'];
                ClxCommon::$db->createRecord($this->srminame, $record, false);
            }
            $table->addCell(dict('GEN_LBL_MIGCOMPFORSRVR') . ': ' . $server_idcode, array(CLX_PROP_CLASS => $class));
        }
        $b = new htmlButtonCancel();
        $btn = $b->source();
        $table->addCell($btn, array(CLX_PROP_CLASS => 'buttons'));
        $form->addContents($table->source());
        $this->contents .= $form->source();
    }

    function source() {
        return $this->source();
    }

}
