<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author	   $Author: alenetdev $
 * @copyright	Alenet, Inc.
 * @since		$Date: 2017-10-02 10:22:43 -0400 (Mon, 02 Oct 2017) $
 * @version		$Rev: 9550 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Apin {

    var $display = false;

    /**
     * Constructor
     * @param array [$procParameters]
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('FIAC', 'FIRT', 'GDVW', 'FTMP', 'INVT', 'APIN', 'APIL', 'PROD', 'PRAT', 'GLAC', 'AMDS', 'GLT1', 'JEHD', 'JELN', 'FIAT', 'JCBV', 'JEIT', 'FICO', 'APAS', 'GLCP', 'GLPF', 'FICO', 'FTMP', 'APPY', 'FIPA'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->today = xFormat::getNow('Y-m-d');
        $this->je_source = '';
    }

    /**
     * Execute bottom reverse from listing invo
     */
    function apin_reverse_build() {
        $idlist = toString(getIdlist());
        $results = ClxCommon::$db->executeQuery('SELECT IDCODE, JEHDR_CODE, INVO_STAT , CLX_AUTH_STATUS FROM ' . $this->apinname . ' WHERE ID IN (' . $idlist . ')' );
        if (!class_exists('Jehd')) {
            includeCodeLib('JEHD');
        }
        
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            if (!empty($result['JEHDR_CODE'])) {
                $verifica = ClxCommon::$db->getOneRecord('SELECT IDCODE, CLX_AUTH_STATUS FROM ' . $this->jehdname . ' WHERE REV_JEHDR_CODE LIKE ' . singleQuote($result['JEHDR_CODE']));
                if (!empty($verifica['IDCODE'])) {
                    addMessage(smsg('MSG-406', $result['IDCODE'], $verifica['IDCODE'], $verifica['CLX_AUTH_STATUS']));
                    return false;
                }


                //Validar que tenga transacciones sin reversos.
                $sql = 'SELECT COUNT(FIAT.ID) QTY FROM AP_PAY_INVOICES APIN, FIDU_TRANSACTIONS FIAT, GL_JOURNAL_HDR JEHD, AP_PYMT_TRANS APPY WHERE APPY.PAYINV_CODE = APIN.IDCODE AND APPY.JEHDR_CODE = JEHD.IDCODE AND FIAT.IDCODE = JEHD.TRANS_CODE AND FIAT.CLX_AUTH_STATUS<> ' .singleQuote('REJ'). ' AND FIAT.VOID = 0 AND APIN.IDCODE = ' . singleQuote($result['IDCODE']);
                if (ClxCommon::$db->getOne($sql) > 0) {
                    addMessage(smsg('MSG-497'));
                    return false;
                }
                IF ($result['CLX_AUTH_STATUS'] !='PEAP') {
                    $jehd = new Jehd();
                    $cod_new_jehdr = $jehd->jehd_reverse($result['JEHDR_CODE']);
                    unset($jehd);
                    if ('' !== $cod_new_jehdr) {
                        addMessage(smsg('MSG-401', $result['IDCODE'], $cod_new_jehdr));
                    }
                }
                else {
                    addMessage(smsg('MSG-45', $result['JEHDR_CODE']));
                }
            } else {//factura no tiene asiento contable
                addMessage(smsg('MSG-400', $result['IDCODE']));
                return false;
            }
        }
    }

    // end function
    /**
     * Initialice fiat form - Executed on init event
     *
     * @param array $record
     */
    function init_form(&$record) {
        if (!class_exists('Comp')) {
            includeCodeLib('COMP');
        }
        $comp = new Comp();
        $comprec = $comp->comp_operation_parameters($record['APIN_COMP_CODE']);
        if ((UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'DUPLICATE' || UserRequest::$request['ac'] === 'CODE') && empty(UserRequest::$post['confirm'])) {
            $record['APIN_INVOICEDATE'] = $comprec['OPERATION_DATE'];
            $record['APIN_CURRENCY_CODE'] = $comprec['CURRENCY_CODE'];
            $record['APIN_IDCODE'] = 'AUTO';
            $record['APIN_CLX_AUTH_STATUS'] = 'PEND';
            $record['APIN_INVO_STAT'] = '01';
            $record['APIN_JEHDR_CODE'] = '';
            $record['APIN_JEHDR_CODE_prim'] = '';
            $record['APIN_JEHDR_CODE_secd'] = '';
            $record['APIN_PAY_JEHDR_CODE'] = '';
            $record['APIN_PAY_JEHDR_CODE_prim'] = '';
            $record['APIN_PAY_JEHDR_CODE_secd'] = '';
            $record['APIN_RESTRICTED'] = CLX_INIT_ZERO;
			$record['APIN_TAXRCPT_NO'] = '';
			$record['APIN_TAXRCPTREL_NO'] = '';
			
            if (!empty($comprec['INVO_DEFDUE_FREQ'])) {
                $record['APIN_DUE_DATE'] = adodb_period_date($record['APIN_INVOICEDATE'], $comprec['INVO_DEFDUE_FREQ'], $comprec['INVO_DEFDUE_PER'], 'Y-m-d');
            }
        }
    }

    /**
     * Initialice form - Executed on init event
     *
     * @param array $record
     */
    function load_form(&$record) {
        if ((UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'DUPLICATE' || UserRequest::$request['ac'] === 'CODE') && empty(UserRequest::$post['confirm'])) {
            $this->init_form($record);
        }
    }

    /**
     * Validate record information
     * Executed on table validate
     *
     * @param array $record
     * @param array $msg
     */
    function validate_form(&$record, &$msg) {
        if (UserRequest::$request['ac'] == 'DELETE'){
            $idlist = getIdlist();
            $idlist = toString($idlist);
            $sql = 'SELECT IDCODE FROM ' . $this->apinname . ' WHERE ID IN (' . $idlist. ') AND CLX_AUTH_STATUS<>'.singleQuote('PEND').' AND CLX_AUTH_STATUS<>'.singleQuote('OPQU');
            $reg = ClxCommon::$db->getOne($sql);

            if (!empty($reg))  {
                    $msg['APIN_CLX_AUTH_STATUS'] = smsg('MSG-263', $reg);
                    addMessage($msg['APIN_CLX_AUTH_STATUS']);
                    return false;
            }else{
                    return true;
            }

        }
        
        if ($record['APIN_CLX_AUTH_STATUS'] <> 'PEND' && $record['APIN_CLX_AUTH_STATUS'] <> 'OPQU' && UserRequest::$post['fm'] <> 'APIN_APP') {
            $msg['APIN_CLX_AUTH_STATUS'] = smsg('MSG-263', $record['APIN_IDCODE']);
            return false;
        }

        $sql = 'SELECT FICO.CONTRACT_STATUS FROM ' . $this->ficoname . ' FICO WHERE FICO.IDCODE = ' . singleQuote($record['APIN_CHART_FIELD01']);
        $CONTRACT_STATUS = ClxCommon::$db->getOne($sql);
        if ($CONTRACT_STATUS === 'FINQ') {
            $msg['APIN_CHART_FIELD01'] = smsg('MSG-410', $record['APIN_CHART_FIELD01_prim']);
        }
        if (UserRequest::$request['ac'] === 'REQAUTHORIZATION' && $record['APIN_INVO_STAT'] === '04') {
            $msg['APIN_INVO_STAT'] = smsg('MSG-404', $record['APIN_IDCODE']);
            return false;
        }

        if (UserRequest::$request['ac'] === 'MODIFY' && ClxCommon::$db->oneExistsRecords($this->apinname, 'IDCODE = ' . singleQuote($record['APIN_IDCODE']) . ' AND INVO_STAT IN (' . singleQuote('02') . ',' . singleQuote('04') . ',' . singleQuote('05') . ')') > CLX_NUM_ZERO) {
            $msg['APIN_INVO_STAT'] = smsg('MSG-404', $record['APIN_IDCODE']);
            return false;
        }
        //ivan
        if ($record['APIN_CLX_AUTH_STATUS'] == 'PEND' && $record['APIN_INVO_STAT'] === '04') {
            $jehd_status=ClxCommon::$db->getOneRecord('select CLX_AUTH_STATUS from '. $this->jehdname .' where IDCODE = ' . singleQuote( $record['APIN_JEHDR_CODE']));            
            if ($jehd_status['CLX_AUTH_STATUS']=='AP') {
                $msg['APIN_INVO_STAT'] = smsg('MSG-20170712161615', $record['APIN_IDCODE'],$record['APIN_JEHDR_CODE']);
            }    
            return false;
        }
        if (empty(UserRequest::$post['fm']))
            UserRequest::$post['fm'] = '';

        //Validating amortization type
        if ($record['APIN_AP_AMORT_METHOD'] == CLX_NUM_ONE && $record['APIN_AMORTIZATION_AMT'] == CLX_NUM_ZERO) {
            $msg['APIN_AMORTIZATION_AMT'] = smsg('MSG-286');
        }
        if ($record['APIN_AP_AMORT_METHOD'] == CLX_NUM_TWO && $record['APIN_AMORTIZATION_RT'] == CLX_NUM_ZERO) {
            $msg['APIN_AMORTIZATION_RT'] = smsg('MSG-287');
        }
        if ($record['APIN_AMORTIZATION_AMT'] > CLX_NUM_ZERO && $record['APIN_AMORTIZATION_RT'] > CLX_NUM_ZERO) {
            $msg['APIN_AMORTIZATION_RT'] = smsg('MSG-288');
            $msg['APIN_AMORTIZATION_AMT'] = smsg('MSG-288');
        }
        if ($record['APIN_AP_AMORT_METHOD'] == CLX_NUM_ZERO && $record['APIN_AMORTIZATION_AMT'] <> CLX_NUM_ZERO) {
            $msg['APIN_AMORTIZATION_AMT'] = smsg('MSG-289');
        }
        if ($record['APIN_AP_AMORT_METHOD'] == CLX_NUM_ONE && $record['APIN_AMORTIZATION_RT'] <> CLX_NUM_ZERO) {
            $msg['APIN_AMORTIZATION_RT'] = smsg('MSG-289');
        }

        if(!empty($record['APIN_DUE_DATE']) && $record['APIN_INVOICEDATE']>$record['APIN_DUE_DATE']){
            $msg['APIN_INVOICEDATE'] = smsg('MSG-20170327152025');
        }

        //Validar que exista cuenta contable
        $sql = 'SELECT GLAC.IDCODE, GLAC.GL_TYPE FROM ' . $this->glacname . ' GLAC, ' . $this->jeitname . ' JEIT, ' . $this->glcpname . ' GLCP WHERE JEIT.GLACCOUNTCODE = GLAC.IDCODE AND GLCP.GLGROUP_CODE = GLAC.GLGROUP_CODE AND GLCP.COMP_CODE = ' . singleQuote($record['APIN_COMP_CODE']) . ' AND JEIT.IDCODE = ' . singleQuote($record['APIN_AP_ITEM_CODE']);
        $glacrec = ClxCommon::$db->getOneRecord($sql);
        if (empty($glacrec)) {
            $msg['APIN_AP_ITEM_CODE'] = smsg('MSG-290');
        }
        //validando amortizacion de ser pago anticipado
        if (!empty($glacrec['GL_TYPE']) && $glacrec['GL_TYPE'] === 'AS' && $record['APIN_AP_AMORT_METHOD'] == CLX_NUM_ZERO) {
            $msg['APIN_AP_AMORT_METHOD'] = smsg('MSG-291');
        }
        if (!empty($record['APIN_PUOR_CODE'])) {
            //Total en orden
            $sql = 'SELECT SUM(PURL.LINE_TOTAL) FROM PURC_ORDER_LINES PURL WHERE PURL.PUOR_CODE=' . singleQuote($record['APIN_PUOR_CODE']);
            $orderamt = ClxCommon::$db->getOne($sql);
            if (empty($orderamt))
                $orderamt = CLX_INIT_ZERO;
            //total en facturas
            $sql = 'SELECT SUM(APIN.INVOICE_AMT) FROM ' . $this->apinname . ' APIN WHERE APIN.PUOR_CODE=' . singleQuote($record['APIN_PUOR_CODE']) . ' AND APIN.IDCODE <> ' . singleQuote($record['APIN_IDCODE']);
            $invototalamt = ClxCommon::$db->getOne($sql);
            if (empty($invototalamt))
                $invototalamt = CLX_INIT_ZERO;
            $invototalamt += $record['APIN_INVOICE_AMT'];
            if ($invototalamt > $orderamt) {
                $msg['APIN_PUOR_CODE'] = smsg('MSG-323', rounder($orderamt, CLX_NUM_TWO), rounder($invototalamt, CLX_NUM_TWO));
            }
        }
        if (UserRequest::$request['ac'] === 'REQAUTHORIZATION' && empty($msg)) {
            //Validar que la suma de las amortizaciones sea igual a monto de la factura
            if ($record['APIN_AP_AMORT_METHOD'] > CLX_NUM_ZERO) {
                //val
                $sql = 'SELECT SUM(AMORTIZATION_AMT) AMORTIZATION_AMT FROM ' . $this->apasname . '  WHERE PAYINV_CODE = ' . singleQuote($record['APIN_IDCODE']);
                $amt = ClxCommon::$db->getOne($sql);
                if ($amt <> ($record['APIN_INVOICE_AMT'] - $record['APIN_AMORTIZATION_INIT'])) {
                    $msg['APIN_CLX_AUTH_STATUS'] = smsg('MSG-292', $record['APIN_IDCODE']);
                }
            }
            if ($record['APIN_RESTRICTED'] == CLX_NUM_ZERO) {
                //Count lines at least 1 must exists
                if (ClxCommon::$db->oneExistsRecords($this->apilname, 'PAYINV_CODE = ' . singleQuote($record['APIN_IDCODE'])) == CLX_NUM_ZERO) {
                    $msg['APIN_CLX_AUTH_STATUS'] = smsg('MSG-309', $record['APIN_IDCODE']);
                }
            }
            //validate if not restricted
            if ($record['APIN_RESTRICTED'] == CLX_NUM_ZERO && $record['APIN_AP_AMORT_METHOD'] == CLX_NUM_ZERO) {
                //Previous to autorization
                if (empty($msg)) {
                    $record['APIN_JEHDR_CODE'] = $this->buildAccounting($record['APIN_IDCODE'],$record['APIN_INVO_STAT']);
                }
                if (!class_exists('Jehd'))
                    includeCodeLib('JEHD');
                $jehd = new Jehd();
                $jehdrec = ClxCommon::$db->getRecord($this->jehdname, 'IDCODE = ' . singleQuote($record['APIN_JEHDR_CODE']));
                if (!empty($jehdrec)) {
                    foreach ($jehdrec as $key => $val) {
                        $jehdrec['JEHD_' . $key] = $val;
                    }
                } else {
                    $msg['APIN_CLX_AUTH_STATUS'] = smsg('MSG-273', $record['APIN_IDCODE']);
                    return false;
                }
                $jehd->jehd_validate_form($jehdrec, $msg);
                unset($jehd);
            }
        }
        return (count($msg) > CLX_NUM_ZERO) ? false : true;
    }

    /**
     * Update Information one record is saved
     * @param array $record
     */
    function save_form(&$record) {

        /* Caso 1002909 - BEGIN - CJRD */
        // Updates lines tax amounts
        $this->apil_all_lines_tax_calc($record['IDCODE']);
        // Updates invoice total amount
        if (UserRequest::$request['ac'] <> 'DUPLICATE') {
            $record['INVOICE_AMT'] = $this->update_apin_total_amt($record['IDCODE'], 'get');
        }
        /* Caso 1002909 - END - CJRD */


        //Find accounting for cases
        if ($record['RESTRICTED'] == CLX_NUM_ZERO) {
            $sql = 'SELECT JEIT.GLACCOUNTCODE FROM ' . $this->jeitname . ' JEIT WHERE JEIT.IDCODE = ' . singleQuote($record['AP_ITEM_CODE']) . ' AND JEIT.CLX_EFFTDATE = (SELECT MAX(JEIT2.CLX_EFFTDATE) FROM ' . $this->jeitname . ' JEIT2 WHERE JEIT.IDCODE = JEIT2.IDCODE AND JEIT2.CLX_EFFTDATE<=' . singleQuote($this->now) . ')';
            $record['GLACCOUNTCODE'] = ClxCommon::$db->getOne($sql);
        }
    }

    /**
     * Update Information one record is saved
     * @param array $record
     */
    function save_form_post(&$record){
        
        if (UserRequest::$request['ac'] === 'DUPLICATE' && $record['INVO_STAT']=='04') {
            $record['CLX_AUTH_STATUS']=='REJ';
        }
        else if($record['CLX_AUTH_STATUS'] === 'PEND'){
            if(companyParameter('APIN_BUILD_GL_ON_SAVE', $record["COMP_CODE"]) == 1 && $record['AP_AMORT_METHOD'] == CLX_NUM_ZERO)
                $this->buildAccounting($record['IDCODE'],$record['INVO_STAT']);
			if ($record['INVO_STAT']=='04') {
                $jehd_status=ClxCommon::$db->getOneRecord('SELECT JE_STATUS FROM '. $this->jehdname .' WHERE IDCODE = ' . singleQuote($record['JEHDR_CODE']));
				if (empty($jehd_status) || empty($jehd_status['JE_STATUS']) || $jehd_status['JE_STATUS']==='REJ' || $jehd_status['JE_STATUS']==='PEND' || $jehd_status['JE_STATUS']==='') {   
				   ClxCommon::$db->updateRecord($this->apinname, array('CLX_AUTH_STATUS' => 'REJ'), 'IDCODE = ' . singleQuote($record['IDCODE']).' AND CLX_AUTH_STATUS<>'.singleQuote('AP'));
				   ClxCommon::$db->updateRecord($this->jehdname, array('CLX_AUTH_STATUS' => 'REJ', 'JE_STATUS'=>'REJ'), 'IDCODE = ' . singleQuote($record['JEHDR_CODE']));
                } 
            }
            //Accounting build on approval
            //Build Amortization
            if(!class_exists('Apas'))
                includeCodeLib('APAS');
            $apas = new Apas();
            $apas->build_amortization($record['IDCODE']);
        }
    }

    /**
     * Delete record on delete.
     * @param array $record
     */
    function delete_record_post($record) {

    }

    /**
     * Post Authorization Method
     *
     * @param array $record
     */
    function post_autorize(&$record,$reject=false) {
        if (UserRequest::$request['ac'] === 'DELETE')
            return;
        if (array_key_exists('APIN_IDCODE', $record)) {
            $invoicecode = $record['APIN_IDCODE'];
        } else {
            $invoicecode = $record['IDCODE'];
        }
            if (empty($reject)) {
                if (!class_exists('Jehd'))
            includeCodeLib('JEHD');
            $jehd = new Jehd();
            //get approve invoice and approve journal if found
            $sql = 'SELECT JEHD.IDCODE FROM ' . $this->jehdname . ' JEHD, ' . $this->apinname . ' APIN WHERE JEHD.IDCODE = APIN.JEHDR_CODE AND APIN.CLX_AUTH_STATUS = ' . singleQuote('AP') . ' AND JEHD.CLX_AUTH_STATUS = ' . singleQuote('PEND') . ' AND APIN.IDCODE = ' . singleQuote($invoicecode);
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $jehd->jehd_approve_queue_by_code($r['IDCODE']);
            }
        } else {
		    //   - Caso 1002718 - COR-Al rechazar la aprobacion de la factura el comprobante queda en pendiente
            // Reject invoice
            ClxCommon::$db->updateRecord($this->apinname, array('CLX_AUTH_STATUS' => 'REJ'), 'IDCODE = ' . singleQuote($invoicecode));
		    // Reject journal entry
                    $apin_jehdr_code = ClxCommon::$db->getField($this->apinname, 'JEHDR_CODE', 'IDCODE = ' . singleQuote($invoicecode));
		    if (!is_null($apin_jehdr_code) && $apin_jehdr_code !== '') {
		        ClxCommon::$db->updateRecord($this->jehdname, array('JE_STATUS' => 'REJ', 'CLX_AUTH_STATUS' => 'REJ'), 'IDCODE = ' . singleQuote($apin_jehdr_code));
            }
        }
    }

    /**
     * Builds accounting for invoice. Account Receivables
     * @param string $invoicecode
     */
    function buildAccounting($invoicecode,$apin_invo_stat='') {

        $this->je_source = 'AP-ARC';

        $apinrec = ClxCommon::$db->getRecord($this->apinname, 'IDCODE = ' . singleQuote($invoicecode));
        if (empty($invoicecode)) {
            return '';
        }
        if ($apinrec['RESTRICTED'] == CLX_NUM_ONE)
            return '';
        if ($apinrec['AP_AMORT_METHOD'] > CLX_NUM_ZERO)
            return ''; //amortizada
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        if (!class_exists('Jehd'))
            includeCodeLib('JEHD');
        $jehd = new Jehd();
        $comp = new Comp();
        $oper = $comp->comp_operation_parameters($apinrec['COMP_CODE']);
        $rate = $comp->comp_current_exchange($oper['IDCODE'], $apinrec['CURRENCY_CODE'], $oper['OPERATION_DATE']);
        $jehdr_code = $apinrec['JEHDR_CODE'];
        if (ClxCommon::$db->oneExistsRecords($this->jehdname, 'IDCODE = ' . singleQuote($apinrec['JEHDR_CODE'])) == CLX_NUM_ZERO) {
            $jehdr_code = '';
        }
        //Try to search any pending journal for current operation
        if ($jehdr_code === '') {
            $gl_rec = $jehd->jehd_init_record();
            $gl_rec['IDNAME'] = $apinrec['IDNAME'];
            $gl_rec['JE_SOURCE'] = $this->je_source;
            $gl_rec['LGGROUP_CODE'] = $oper['LGGROUP_CODE'];
            $gl_rec['EFFTDATE'] = (!empty($apinrec['INVOICEDATE'])) ? $apinrec['INVOICEDATE'] : $oper['OPERATION_DATE'];
            $gl_rec['REAL_DATE'] = $oper['OPERATION_DATE'];
            $gl_rec['JE_STATUS'] = 'PEND';
            $gl_rec['CLX_AUTH_STATUS'] = 'PEND';
            $gl_rec['COMP_CODE'] = $oper['IDCODE'];
            $gl_rec['FISCAL_PERIOD'] = $oper['FISCAL_PERIOD'];
            $gl_rec['TRANS_CODE'] = 'null';
            $gl_rec['TRANSTBL_CODE'] = 'null';
            $gl_rec['REQ_CHANNEL'] = 'SYS';
            $gl_rec['BATCH_ID'] = $this->batch_id;
            $jehd->jehd_build($gl_rec);
            $jehdr_code = $gl_rec['IDCODE'];
            ClxCommon::$db->updateRecord($this->apinname, array('JEHDR_CODE' => $jehdr_code), 'IDCODE = ' . singleQuote($invoicecode));
        } else {
            $gl_rec = array();
            $gl_rec['IDNAME'] = $apinrec['IDNAME'];
            $gl_rec['FISCAL_PERIOD'] = $oper['FISCAL_PERIOD'];
            $gl_rec['EFFTDATE'] = (!empty($apinrec['INVOICEDATE'])) ? $apinrec['INVOICEDATE'] : $oper['OPERATION_DATE'];
            $gl_rec['REAL_DATE'] = $oper['OPERATION_DATE'];
            $gl_rec['LGGROUP_CODE'] = $oper['LGGROUP_CODE'];
            $gl_rec['FISCAL_PERIOD'] = $oper['FISCAL_PERIOD'];
            $gl_rec['BATCH_ID'] = $this->batch_id;
            //ivan
            if ($apin_invo_stat=='04') {
                $jehd_status=ClxCommon::$db->getOneRecord('select CLX_AUTH_STATUS from '. $this->jehdname .' where IDCODE = ' . singleQuote($apinrec['JEHDR_CODE']));
                if ($jehd_status['CLX_AUTH_STATUS']=='PEND') {
                   $gl_rec['CLX_AUTH_STATUS']='REJ';
                   $gl_rec['JE_STATUS']='REJ';
                }   
            }
            ClxCommon::$db->updateRecord($this->jehdname, $gl_rec, 'IDCODE = ' . singleQuote($jehdr_code));
        }

        //Mark lines for delete
        $sql = 'UPDATE ' . $this->jelnname . '  SET IS_REMOVE = 1 WHERE JEHDR_CODE = ' . singleQuote($jehdr_code);
        ClxCommon::$db->executeQuery($sql);

        //adding lines to journal
        //$sql = 'SELECT ' . singleQuote($jehdr_code) . ' JEHDR_CODE, APIL.GLACCOUNTCODE, APIL.ITEM_CODE, APIN.CHART_FIELD01, APIN.CHART_FIELD02, APIL.CHART_FIELD03, APIL.CHART_FIELD04, APIN.EXT_REF_NO ITEM_REF_NO, APIN.CURRENCY_CODE, ' . $rate['EXCHANGE_RT'] . ' EXCHANGE_RT, ' . $rate['CUR_OPERATOR'] . ' CUR_OPERATOR, 0 DEBIT_AMT, ROUND(APIL.LINE_TOTAL*POW(' . $rate['EXCHANGE_RT'] . ', ' . $rate['CUR_OPERATOR'] . '), 2) CREDIT_AMT, 0 DEBIT_TRANS_AMT, APIL.LINE_TOTAL CREDIT_TRANS_AMT, APIL.SEQNUM SEQNUM FROM ' . $this->apinname . ' APIN, ' . $this->apilname . ' APIL WHERE APIL.PAYINV_CODE = APIN.IDCODE AND APIN.IDCODE = ' . singleQuote($invoicecode) . ' ORDER BY APIL.SEQNUM ASC';
        $sql = 'SELECT ' . singleQuote($jehdr_code) . ' JEHDR_CODE,
                    APIN.GLACCOUNTCODE,
                    APIN.AP_ITEM_CODE ITEM_CODE,
                    APIN.CHART_FIELD01,
                    APIN.CHART_FIELD02,
                    APIN.CHART_FIELD03,
                    APIN.CHART_FIELD04,
                    APIN.EXT_REF_NO ITEM_REF_NO,
                    APIN.CURRENCY_CODE,
                    ' . $rate['EXCHANGE_RT'] . ' EXCHANGE_RT,
                    ' . $rate['CUR_OPERATOR'] . ' CUR_OPERATOR,
                    0 DEBIT_AMT,
                    ROUND(APIN.INVOICE_AMT*POW(' . $rate['EXCHANGE_RT'] . ', ' . $rate['CUR_OPERATOR'] . '),2) CREDIT_AMT,
                    0 DEBIT_TRANS_AMT,
                    APIN.INVOICE_AMT CREDIT_TRANS_AMT,
                    1 SEQNUM
            FROM AP_PAY_INVOICES APIN WHERE APIN.IDCODE = ' . singleQuote($invoicecode);
        $line = ClxCommon::$db->getOneRecord($sql);
        $i = CLX_NUM_ONE;
        if (!empty($line)) {
            if (empty($line['CHART_FIELD03'])) {
                $line['CHART_FIELD03'] = 'null';
            }
            if (empty($line['CHART_FIELD04'])) {
                $line['CHART_FIELD04'] = 'null';
            }
            $line['SEQNUM'] = $i;
            /* if ($line['CREDIT_AMT'] > CLX_NUM_ZERO) {
              $line['DEBIT_AMT'] = $line['CREDIT_AMT'];
              $line['CREDIT_AMT'] = CLX_INIT_ZERO;
              $line['DEBIT_TRANS_AMT'] = $line['CREDIT_TRANS_AMT'];
              $line['CREDIT_TRANS_AMT'] = CLX_INIT_ZERO;
              } else */if ($line['CREDIT_AMT'] < 0) {
                $line['DEBIT_AMT'] = bcabs($line['CREDIT_AMT']);
                $line['CREDIT_AMT'] = 0;
                $line['DEBIT_TRANS_AMT'] = bcabs($line['CREDIT_TRANS_AMT']);
                $line['CREDIT_TRANS_AMT'] = 0;
            }
            $line['IS_REMOVE'] = CLX_INIT_ZERO;
            ClxCommon::$db->loadDbRecord($this->jelnname, $line, false, 'JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND SEQNUM=' . $i);
            $i++;
        }

        //adding lines to journal
        $sql = 'SELECT ' . singleQuote($jehdr_code) . ' JEHDR_CODE, APIL.TAX_AMT, APIL.GLACCOUNTCODE, APIL.ITEM_CODE, APIN.CHART_FIELD01, APIN.CHART_FIELD02, APIL.CHART_FIELD03, APIL.CHART_FIELD04, APIN.EXT_REF_NO ITEM_REF_NO, APIN.CURRENCY_CODE, ' . $rate['EXCHANGE_RT'] . ' EXCHANGE_RT, ' . $rate['CUR_OPERATOR'] . ' CUR_OPERATOR, APIL.LINE_TOTAL DEBIT_TRANS_AMT, 0 CREDIT_TRANS_AMT, ROUND(APIL.LINE_TOTAL*POW(' . $rate['EXCHANGE_RT'] . ', ' . $rate['CUR_OPERATOR'] . '),2) DEBIT_AMT, 0 CREDIT_AMT, APIL.SEQNUM FROM AP_PAY_INVOICES APIN, AP_PAY_INVOICE_LINE APIL WHERE APIL.PAYINV_CODE = APIN.IDCODE AND APIN.IDCODE = ' . singleQuote($invoicecode) . ' ORDER BY APIL.SEQNUM ASC';
        
		
		$lines = ClxCommon::$db->executeQuery($sql);
        while ($line = ClxCommon::$db->getNextRecord($lines)) {
            $this_line_tax_amt = $line['TAX_AMT'];
            unset($line['TAX_AMT']);
			
			$line_fact=$line['SEQNUM'];
            $line['SEQNUM'] = $i;
            if (empty($line['CHART_FIELD03'])) {
                $line['CHART_FIELD03'] = 'null';
            }
            if (empty($line['CHART_FIELD04'])) {
                $line['CHART_FIELD04'] = 'null';
            }
            if ($line['CREDIT_AMT'] < CLX_NUM_ZERO) {
                $line['DEBIT_AMT'] = CLX_INIT_ZERO;
                $line['DEBIT_TRANS_AMT'] = CLX_INIT_ZERO;
            } elseif ($line['CREDIT_AMT'] > CLX_NUM_ZERO) {
                $line['DEBIT_AMT'] = bcabs($line['CREDIT_AMT']);
                $line['DEBIT_TRANS_AMT'] = bcabs($line['CREDIT_TRANS_AMT']);
                $line['CREDIT_AMT'] = CLX_INIT_ZERO;
                $line['CREDIT_TRANS_AMT'] = CLX_INIT_ZERO;
            }
            $line['IS_REMOVE'] = CLX_INIT_ZERO;
            
			if ($line['GLACCOUNTCODE']!=''){
				ClxCommon::$db->loadDbRecord($this->jelnname, $line, false, 'JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND SEQNUM=' . $i);
				$i++;
			}
				/* Caso 1002909 - BEGIN - CJRD */
            if ($this_line_tax_amt > 0) {
                $tax_line = $line;

                $a_item_tax_data = $this->get_item_tax_data($line['ITEM_CODE'], $invoicecode);
                if ($a_item_tax_data['error'] == true || $a_item_tax_data['found'] == false) {
                    // Invalid item, so set an empty G/L account code to force system to throw a warning
                    $tax_line['GLACCOUNTCODE'] = '';
                } else {
                    $tax_line['GLACCOUNTCODE'] = $a_item_tax_data['data']['GLACCOUNTC_TAX'];
                }

                // line has a Tax Item code, so look for it and calculate tax amount

                if ($tax_line['DEBIT_AMT'] > 0) {
                    $line_amt_colname = 'DEBIT_AMT';
                    $line_trans_amt_colname = 'DEBIT_TRANS_AMT';
                } else {
                    $line_amt_colname = 'CREDIT_AMT';
                    $line_trans_amt_colname = 'CREDIT_TRANS_AMT';
                }

				// Aqui veo si la linea es solo un impuesto y no un rubro con impuesto
				$sql = 'SELECT APIN.JEHDR_CODE, APIL.TAX_AMT, APIL.LINE_TOTAL, APIL.LINE_TOTAL_W, APIL.ITEM_CODE, JEIT.ITEM_TYPE FROM ' . $this->apinname . ' APIN, ' . $this->apilname . ' APIL, ' . $this->jeitname  . ' JEIT, ' . $this->jelnname  . ' JELN  WHERE APIL.PAYINV_CODE = APIN.IDCODE AND APIL.ITEM_CODE = JEIT.IDCODE AND APIN.JEHDR_CODE=JELN.JEHDR_CODE AND APIN.IDCODE = ' . singleQuote($invoicecode) . ' AND APIL.SEQNUM= '.singleQuote($line_fact);
				
				$linea_fact = ClxCommon::$db->getOneRecord($sql);


				//Si la linea es solo un impuesto y no un rubro se debe hacer un ajuste para que el comprobante quede equilibrado
				//Ademas Si es impuesto por pagar recupero el importe usado para el calculo de impuesto
				if ($linea_fact['ITEM_TYPE']=='IXP'){
					$line_trans_amt_colname = 'DEBIT_TRANS_AMT';
					$tax_line[$line_trans_amt_colname]=$linea_fact['LINE_TOTAL_W'];
					$tax_line_temp=$tax_line[$line_amt_colname];
					$tax_line[$line_amt_colname]=0;
                    $line_amt_colname = 'DEBIT_AMT';
					$tax_line[$line_amt_colname]=$tax_line_temp;	
				}
             
				
				$tax_line[$line_amt_colname] = $this_line_tax_amt;
                if ($tax_line[$line_amt_colname] <> $tax_line[$line_trans_amt_colname]) {
					$tax_line[$line_trans_amt_colname] = $this->calc_tax_amt($tax_line[$line_trans_amt_colname], $a_item_tax_data);
				} else {
                    $tax_line[$line_trans_amt_colname] = $this_line_tax_amt;
                }

                $tax_line['SEQNUM'] = $i;
                ClxCommon::$db->loadDbRecord($this->jelnname, $tax_line, false, 'JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND SEQNUM=' . $i);
                $i++;
            }
        }


        $sql = 'DELETE FROM ' . $this->jelnname . '  WHERE JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND IS_REMOVE = 1';
        ClxCommon::$db->executeQuery($sql);
        return $jehdr_code;
    }

    /**
     * Prepares payment form
     * @return string
     */
    function makePayments() {
        if (!class_exists('Fiat'))
            includeCodeLib('FIAT');
        $idlist = getIdlist();
        $_SESSION['FIAT_OPTS'] = array();
        $_SESSION['FIAT_OPTS']['APIN'] = $idlist;
        $idlist = toString($idlist);
        //check status
        $sql = 'SELECT COUNT(ID) FROM ' . $this->apinname . '  WHERE (CLX_AUTH_STATUS <> ' . singleQuote('AP') . ' OR INVO_STAT = '. singleQuote('05') .') AND ID IN (' . $idlist . ')';
        if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
            return note(smsg('MSG-277'));
        }

        $sql = 'SELECT APIN.COMP_CODE, APIN.CHART_FIELD01, APIN.VENDOR_CODE BENEFICIARY_CODE, APIN.CHART_FIELD02, APIN.CHART_FIELD03, APIN.CURRENCY_CODE, APIN.CHART_FIELD04, /*Open Balance*/ SUM(IFNULL(APIN.INVOICE_AMT-(IF(APIN.OPENING_BAL<>0, APIN.INVOICE_AMT-APIN.OPENING_BAL, 0)+ IFNULL((SELECT SUM(APPY.PAID_AMT) FIAT_TRANS_AMT FROM GL_JOURNAL_HDR JEHD, FIDU_TRANSACTIONS FIAT, AP_PYMT_TRANS APPY WHERE APPY.PAYINV_CODE = APIN.IDCODE AND APPY.JEHDR_CODE = JEHD.IDCODE AND FIAT.IDCODE = JEHD.TRANS_CODE AND (FIAT.CLX_AUTH_STATUS<> ' .singleQuote('REJ'). ' AND FIAT.VOID = 0)),0)),0)) INVOICE_AMT, MAX(APIN.INVOICEDATE) INVOICE_DATE, MAX(APIN.IDNAME) IDNAME, MAX(IFNULL(NULLIF(APIN.EXT_REF_NO,' . singleQuote(CLX_CHAR_EMPTY_STRING) . '),APIN.IDCODE)) EXT_REF_NO, MAX((IFNULL((SELECT SUM(APIL.TAX_AMT) FROM ' . $this->apilname . ' APIL, GL_ITEM_TBL JEIT WHERE APIL.PAYINV_CODE = APIN.IDCODE AND APIL.ITEM_CODE=JEIT.IDCODE AND JEIT.TAX_TYPE<> ' .singleQuote('PROP'). ' AND JEIT.TAX_TYPE<> '.singleQuote('ISC'). ' AND JEIT.TAX_TYPE<> '.singleQuote('OTAX'). ' ), 0))) TAX_AMT FROM ' . $this->apinname . ' APIN WHERE APIN.ID IN (' . $idlist . ') GROUP BY APIN.COMP_CODE, APIN.VENDOR_CODE, APIN.CHART_FIELD01, APIN.CHART_FIELD02';
        $r = ClxCommon::$db->getOneRecord($sql);
        if (empty($r)) {
            return note(smsg('MSG-277'));
        }
        UserRequest::$post['FIAT_COMP_CODE'] = $r['COMP_CODE'];
        UserRequest::$post['FIAT_CHART_FIELD01'] = $r['CHART_FIELD01'];
        UserRequest::$post['FIAT_CHART_FIELD02'] = $r['CHART_FIELD02'];
        UserRequest::$post['FIAT_CHART_FIELD03'] = $r['CHART_FIELD03'];
        UserRequest::$post['FIAT_CHART_FIELD04'] = $r['CHART_FIELD04'];
        UserRequest::$post['FIAT_CURRENCY_CODE'] = $r['CURRENCY_CODE'];
        UserRequest::$post['FIAT_TRANS_AMT'] = $r['INVOICE_AMT'];
        UserRequest::$post['FIAT_BASE_TRANS_AMT'] = $r['INVOICE_AMT'];
        UserRequest::$post['FIAT_TAX_AMT'] = $r['TAX_AMT'];
        UserRequest::$post['FIAT_BENEFICIARY_CODE'] = $r['BENEFICIARY_CODE'];
        UserRequest::$post['FIAT_BENEFICIARY_CODE_prim'] = $r['BENEFICIARY_CODE'];
        //se quito porque no aplica para OMG
		UserRequest::$post['FIAT_DISBURSEMENT_TYPE'] = '';
		//UserRequest::$post['FIAT_DISBURSEMENT_TYPE'] = 'OT';
        
		UserRequest::$post['FIAT_INVOICE_DATE'] = $r['INVOICE_DATE'];
        UserRequest::$post['FIAT_IDNAME'] = $r['IDNAME'];
		UserRequest::$post['FIAT_REFERENCE_NO'] = $r['EXT_REF_NO'];
		
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        if (!class_exists('Jehd'))
            includeCodeLib('JEHD');
        $comp = new Comp();
        $oper = $comp->comp_operation_parameters($r['COMP_CODE']);
        $rate = $comp->comp_current_exchange($oper['IDCODE'], $r['CURRENCY_CODE'], $oper['OPERATION_DATE']);
        UserRequest::$post['FIAT_EXCHANGE_RT'] = $rate['EXCHANGE_RT'];
        UserRequest::$post['FIAT_CUR_OPERATOR'] = $rate['CUR_OPERATOR'];
        UserRequest::$post['FIAT_BASE_TRANS_AMT'] = $r['INVOICE_AMT'];
        if ($rate['CUR_OPERATOR'] == CLX_NUM_ONE) {
            UserRequest::$post['FIAT_BASE_TRANS_AMT'] = rounder($r['INVOICE_AMT'] * $rate['EXCHANGE_RT'], CLX_NUM_TWO);
        } else {
            UserRequest::$post['FIAT_BASE_TRANS_AMT'] = rounder($r['INVOICE_AMT'] / $rate['EXCHANGE_RT'], CLX_NUM_TWO);
        }
        $ac = 'CREATE';
        UserRequest::$request['ac'] = $ac;
        UserRequest::$post['ac'] = $ac;
        UserRequest::$get['ac'] = $ac;
        UserRequest::$request['li'] = 'FIAT_AP_SRCH'; //to enable list after save
        pushHistory('EDIT', 'LIST', '', 'li', 'FIAT_AP_SRCH');
        $EDIT = &getTool('EDIT');
        return $EDIT->action('CREATE', CLX_NUM_ZERO);
    }

    /**
     * Builds Apin Record, Used in processes
     * @param array $record
     */
    function build_record(&$record) {
        if (empty($record))
            return;
        if (!function_exists('setCreationData')) {
            includeCodeLib('GEN_REC_UTIL');
        }
        setCreationData($record);
        setCreationIdCode($record, 'APIN');
        ClxCommon::$db->loadDbRecord($this->apinname, $record, false, 'IDCODE = ' . singleQuote($record['IDCODE']));
    }

    //APIL Events
    function apil_init_form(&$record) {
        if (UserRequest::$request['ac'] === 'CREATE' && empty(UserRequest::$post['confirm'])) {
            $cp = peekHistory();
            if (!empty($cp['parentrecord']['APIN_CHART_FIELD01'])) {
                $record['APIL_CHART_FIELD01'] = $cp['parentrecord']['APIN_CHART_FIELD01'];
            }
            $sql = 'SELECT ROUND((APIN.INVOICE_AMT - IFNULL((SELECT SUM(APIL.LINE_TOTAL) TOTAL_LINES FROM AP_PAY_INVOICE_LINE APIL  WHERE APIL.PAYINV_CODE = APIN.IDCODE),0)),2) TOTAL FROM ' . $this->apinname . ' APIN  WHERE APIN.IDCODE = ' . singleQuote($record['APIL_PAYINV_CODE']);
            $total = ClxCommon::$db->getOne($sql);
            //$record['APIL_LINE_TOTAL'] = $total;
            //$record['APIL_PRICE'] = $total;
            //$record['APIL_QUANTITY'] = CLX_NUM_ONE;
            $record['APIL_LINE_TOTAL'] = 0;
            $record['APIL_PRICE'] = 0;
            $record['APIL_QUANTITY'] = 0;

        }else{
			$sql = 'SELECT APIL.PRICE_W, APIL.QUANTITY_W, JEIT.ITEM_TYPE FROM ' . $this->apilname . ' APIL, '. $this->jeitname .' JEIT WHERE APIL.ID= '.singleQuote($record['APIL_ID']). ' AND APIL.PAYINV_CODE = ' . singleQuote($record['APIL_PAYINV_CODE']) . ' AND APIL.ITEM_CODE = JEIT.IDCODE';
            $r = ClxCommon::$db->getOneRecord($sql);
			if ($r['ITEM_TYPE'] === 'IXP' or $r['ITEM_TYPE'] === 'IXC'){
            	$record['APIL_PRICE'] = $r['PRICE_W'];
				$record['APIL_QUANTITY'] = $r['QUANTITY_W'];
			}else{
				//pre($record);
				//exit;
			}
		}
    }

    /**
     * Update Information one record is saved
     */
    function apil_save_form(&$record) {
        //Find accounting for cases
        $restricted = ClxCommon::$db->getField($this->apinname, 'RESTRICTED', 'IDCODE = ' . singleQuote($record['PAYINV_CODE']));
        if ($restricted == CLX_NUM_ZERO) {
            $sql = 'SELECT JEIT.GLACCOUNTCODE FROM ' . $this->jeitname . ' JEIT WHERE JEIT.IDCODE = ' . singleQuote($record['ITEM_CODE']) . ' AND JEIT.CLX_EFFTDATE = (SELECT MAX(JEIT2.CLX_EFFTDATE) FROM GL_ITEM_TBL JEIT2 WHERE JEIT.IDCODE = JEIT2.IDCODE AND JEIT2.CLX_EFFTDATE<=' . singleQuote($this->now) . ')';
            $record['GLACCOUNTCODE'] = ClxCommon::$db->getOne($sql);
        }
    }

    /**
     * Validate record information for invoice lines
     * Executed on table validate
     *
     * @param array $record
     * @param array $msg
     */
    function apil_validate_form(&$record, &$msg) {
        if (UserRequest::$request['ac'] === 'DELETE'){
            $sql = 'SELECT APIN.IDCODE, APIN.CLX_AUTH_STATUS, APIL.PAYINV_CODE FROM ' . $this->apinname . ' APIN, ' . $this->apilname . ' APIL WHERE APIN.IDCODE=APIL.PAYINV_CODE AND APIL.ID in ('.singleQuote($record['idlist']). ')';
            $r = ClxCommon::$db->getOneRecord($sql);
            $record['APIN_IDCODE']=$r['IDCODE'];
            $record['APIN_CLX_AUTH_STATUS'] =$r['CLX_AUTH_STATUS'];
            $record['APIL_PAYINV_CODE'] =$r['PAYINV_CODE'];

            if ($record['APIN_CLX_AUTH_STATUS'] <> 'PEND') {
                $msg['APIL_PAYINV_CODE'] = smsg('MSG-262', $record['APIL_PAYINV_CODE']);
                if (UserRequest::$request['ac'] === 'DELETE')
                    addMessage($msg['APIL_PAYINV_CODE']);
                    return false;
            }else{
                return true;
            }
        }
        //Validate line amount must be greater than cero.
        if ($record['APIL_LINE_TOTAL'] == CLX_NUM_ZERO) {
            $msg['APIL_LINE_TOTAL'] = smsg('MSG-281', $record['APIL_PAYINV_CODE']);
            return false;
        }
        // Aqui preguntamos si la linea de factura es solo un impuesto, si lo es colocamos quantity=0 price=0 y Line_total=0 para que no nos sume en el total de factura antes de guardar
        $sql='SELECT ITEM_TYPE FROM '. $this->jeitname .' WHERE IDCODE = '. singleQuote($record['APIL_ITEM_CODE']);
		$item_imp = ClxCommon::$db->getOneRecord($sql);
		
		if ($item_imp['ITEM_TYPE'] === 'IXP' or $item_imp['ITEM_TYPE'] === 'IXC') {
			$record['APIL_QUANTITY_W']=$record['APIL_QUANTITY'];
			$record['APIL_PRICE_W']=$record['APIL_PRICE'];
			$record['APIL_LINE_TOTAL_W']=$record['APIL_LINE_TOTAL'];
			$record['APIL_QUANTITY']=0;
			$record['APIL_PRICE']=0.00;
			$record['APIL_LINE_TOTAL']=0.00;	
		}else{
		   // Solo se valida cuenta contable si no es un impuesto
           $apinrec = ClxCommon::$db->getRecord($this->apinname, 'IDCODE = ' . singleQuote($record['APIL_PAYINV_CODE']));
           $sql = 'SELECT GLAC.IDCODE, GLAC.GL_TYPE FROM ' . $this->glacname . ' GLAC, ' . $this->jeitname . ' JEIT, ' . $this->glcpname . ' GLCP WHERE JEIT.GLACCOUNTCODE = GLAC.IDCODE AND GLCP.GLGROUP_CODE = GLAC.GLGROUP_CODE AND GLCP.COMP_CODE = ' . singleQuote($apinrec['COMP_CODE']) . '  AND JEIT.IDCODE = ' . singleQuote($record['APIL_ITEM_CODE']);
		   $glacrec = ClxCommon::$db->getOneRecord($sql);
			if (empty($glacrec)) {
				$msg['APIL_ITEM_CODE'] = smsg('MSG-316');
			}
		}

    }

    /**
     * Post line save events that affect invoice headers
     * @param $record
     */
    function updateTotalFromLine($record) {
        $sql = 'UPDATE ' . $this->apinname . ' APIN SET INVOICE_AMT = IFNULL((SELECT SUM(APIL.LINE_TOTAL+APIL.TAX_AMT) FROM ' . $this->apilname . ' APIL WHERE APIL.PAYINV_CODE = APIN.IDCODE),0) WHERE IDCODE = ' . singleQuote($record['PAYINV_CODE']);
        ClxCommon::$db->executeQuery($sql);
        $apinrec = ClxCommon::$db->getFields($this->apinname, 'IDCODE, CLX_AUTH_STATUS, COMP_CODE, AP_AMORT_METHOD', 'IDCODE = ' . singleQuote($record['PAYINV_CODE']));
        if ($apinrec['CLX_AUTH_STATUS'] === 'PEND') {
            if (!class_exists('Apas'))
                includeCodeLib('APAS');
            $apas = new Apas();
            $apas->build_amortization($apinrec['IDCODE']);
            unset($apas);
            //Done in invoice approval
            if(companyParameter('APIN_BUILD_GL_ON_SAVE', $apinrec["COMP_CODE"]) == 1 && $apinrec['AP_AMORT_METHOD'] == CLX_NUM_ZERO)
				$this->buildAccounting($apinrec['IDCODE']);
        }
    }

    //Amortization process run by daily closing
    /**
     * Runs interest calculation from btn
     *
     */
    function run_amortization_accounting_btn() {
        $idlist = getIdlist();
        if (empty($idlist))
            return;
        $sql = 'SELECT DISTINCT COMP_CODE, IDCODE FROM ' . $this->apinname . '  WHERE ID IN (' . toString($idlist) . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while (($r = ClxCommon::$db->getNextRecord($rs, NUMERIC))) {
            $this->build_amortization_accounting($r[CLX_NUM_ZERO], $r[CLX_NUM_ONE]);
        }
    }

    /**
     * Runs asset depreciation on closing
     * @param string $comp_code
     */
    function run_amortization_cron($comp_code) {
        $this->display = true;
        $this->build_amortization_accounting($comp_code);
    }

    /**
     * Proceso para construccion de amortizacion de facturas
     *
     * @param string $comp_code
     * @param string $invoice_code
     */
    private function build_amortization_accounting($comp_code, $invoice_code = '') {
        //GLT1
        $this->je_source = 'AP.APAS'; ///Amortizacion de cuentas por pagar. Deferred Payment/Amortizacion de cuentas por pagar. Deferred Payment
        $DBLT = &getTool('DBLT');
        $idname = $DBLT->getListItem('SOTY', $this->je_source);
        $idname = substr($idname, CLX_NUM_ZERO, CLX_NUM_60);
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        $comp = new Comp();
        $comprec = $comp->comp_operation_parameters($comp_code);
        $operation_date = $comprec['OPERATION_DATE'];
		if (empty($operation_date)) {
			echoLog('<br> ERROR not operation date for company: '.$comp_code.' <br>');
			return;
		}
        if (!empty($this->display)) {
            echoLog('AP DEFERRED PAYMENT PROCESS. BATCH ID: ' . $this->batch_id);
            echoLog('Efective date: ' . $operation_date);
            echoLog('Invoice: ' . (($invoice_code === '') ? 'ALL' : $invoice_code));
        }
        if (empty($comprec) || empty($comp_code)) {
            echoLog('Error, no company operation parameters found');
        }
        //Init Temporary Tables
        $this->initTemporaryTables($this->batch_id);
        //loading temporary table
        $sql = 'INSERT INTO ' . $this->glt1name . '
				 (COMP_CODE,
				 BATCH_ID,
				 EFFTDATE,
				 GLACCOUNTCODE,
				 GL01_CODE,
				 GL_TYPE,
				 BALANCE_AMT,
				 CALC_AMT_01,
				 CALC_AMT_02,
				 CALC_AMT_03,
				 CALC_AMT_04,
				 CHART_FIELD01,
				 CHART_FIELD02,
				 CHART_FIELD03,
				 CHART_FIELD04,
				 CURRENCY_CODE,
				 CUR_OPERATOR,
				 EXCHANGE_RT,
				 DEBIT_AMT,
				 CREDIT_AMT,
				 DEBIT_TRANS_AMT,
				 CREDIT_TRANS_AMT,
				 LOAN_CODE,
				 ITEM_CODE,
				 ITEM02_CODE)
			 SELECT
			 	 '. singleQuote($comp_code) .' COMP_CODE,
				 '. singleQuote($this->batch_id) .'  BATCH_ID,
				 APIN.INVOICEDATE EFFTDATE,
				 APIN.GLACCOUNTCODE,
				 APIL.GLACCOUNTCODE GL01_CODE,
				 JCBV.GL_TYPE,
				 -1*SUM(JCBV.BALANCE_AMT) BALANCE_AMT,
				 APAS.AMORTIZATION_AMT CALC_AMT_01,
				 -1*SUM(JCBV.BALANCE_AMT) CALC_AMT_02,
				 APIN.INVOICE_AMT CALC_AMT_03,
				 APIL.LINE_TOTAL CALC_AMT_04,
				 JCBV.CHART_FIELD01,
				 JCBV.CHART_FIELD02,
				 JCBV.CHART_FIELD03,
				 JCBV.CHART_FIELD04,
				 JCBV.CURRENCY_CODE,
				 1 CUR_OPERATOR,
				 1 EXCHANGE_RT,
				 0 DEBIT_AMT,
				 0 CREDIT_AMT,
				 0 DEBIT_TRANS_AMT,
				 0 CREDIT_TRANS_AMT,
				 APIN.IDCODE LOAN_CODE,
				 APIN.AP_ITEM_CODE ITEM_CODE,
				 APIL.ITEM_CODE ITEM02_CODE
			 FROM
				 '. $this->apinname .' APIN,
				 '. $this->apilname .' APIL,
				 '. $this->apasname .' APAS,
				 '. $this->jcbvname .' JCBV,
                 '. $this->fipaname .' FIPA
			 WHERE
				 APAS.PAYINV_CODE = APIN.IDCODE
				 AND APIL.PAYINV_CODE = APIN.IDCODE
				 AND JCBV.CHART_FIELD01 = APIN.CHART_FIELD01
				 AND JCBV.CHART_FIELD02 = APIN.CHART_FIELD02
				 AND APIN.GLACCOUNTCODE = JCBV.GLACCOUNTCODE
				 AND APIN.CURRENCY_CODE = JCBV.CURRENCY_CODE
                 AND FIPA.CONTRACT_CODE = APIN.CHART_FIELD01
                 AND FIPA.ACCOUNTCODE = APIN.CHART_FIELD02
                 AND FIPA.STATUS = '. singleQuote('A') .'
				 AND APAS.PERIOD_END_DATE = '. singleQuote($operation_date) .'
				 AND APIN.COMP_CODE = '. singleQuote($comp_code) .' '.(($invoice_code!='')? ' 
                 AND APIN.IDCODE =' . singleQuote($invoice_code) : '') . ' 
				 AND JCBV.BALANCE_AMT <= APAS.AMORTIZATION_AMT
				 AND APIN.INVO_STAT = '. singleQuote('02') .'
				 AND EXISTS(SELECT GLAC.ID FROM '. $this->glacname .' GLAC WHERE GLAC.IDCODE = APIL.GLACCOUNTCODE AND GLAC.GL_TYPE = '. singleQuote('IN') .')
            GROUP BY
                 APIN.INVOICEDATE,
				 APIN.GLACCOUNTCODE,
				 APIL.GLACCOUNTCODE,
				 JCBV.GL_TYPE,
				 APAS.AMORTIZATION_AMT,
				 APIN.INVOICE_AMT,
				 APIL.LINE_TOTAL,
				 JCBV.CHART_FIELD01,
				 JCBV.CHART_FIELD02,
				 JCBV.CHART_FIELD03,
				 JCBV.CHART_FIELD04,
				 JCBV.CURRENCY_CODE,
				 APIN.IDCODE,
				 APIN.AP_ITEM_CODE,
				 APIL.ITEM_CODE
                 HAVING SUM(JCBV.BALANCE_AMT) <= APAS.AMORTIZATION_AMT';

        ClxCommon::$db->executeQuery($sql);
        if (ClxCommon::$db->oneExistsRecords($this->glt1name, 'BATCH_ID = ' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
            return;
        }
        //Actualizar porcentage que representa el concepto sobre el total de la factura.
        //Distribuir en funcion del concepto si tiene multiples cuentas contables
        $sql = 'UPDATE ' . $this->glt1name . '  SET CALC_AMT_01 = round(CALC_AMT_01 * (CALC_AMT_04/CALC_AMT_03), 2) WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'SELECT DISTINCT COMP_CODE, CURRENCY_CODE, EFFTDATE OPERATION_DATE FROM ' . $this->glt1name . '  WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' ';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $rate = $comp->comp_current_exchange($r['COMP_CODE'], $r['CURRENCY_CODE'], $r['OPERATION_DATE']);
            $sql = 'UPDATE ' . $this->glt1name . '   SET CUR_OPERATOR = ' . singleQuote($rate['CUR_OPERATOR']) . ', EXCHANGE_RT = ' . singleQuote($rate['EXCHANGE_RT']) . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND CURRENCY_CODE = ' . singleQuote($r['CURRENCY_CODE']) . ' AND COMP_CODE = ' . singleQuote($r['COMP_CODE']);
            ClxCommon::$db->executeQuery($sql);
        } //end while
        //Colocando contabilidad
        $sql = 'UPDATE ' . $this->glt1name . '   SET DEBIT_AMT = CALC_AMT_01 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE =  ' . singleQuote('AS') . '';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt1name . '   SET CREDIT_AMT = CALC_AMT_01 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE <> ' . singleQuote('AS') . '';
        ClxCommon::$db->executeQuery($sql);
        //Colocando contabilidad
        $sql = 'UPDATE ' . $this->glt1name . '   SET DEBIT_TRANS_AMT = DEBIT_AMT, DEBIT_AMT = ROUND((DEBIT_AMT*POW(EXCHANGE_RT, CUR_OPERATOR)), 2) WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND DEBIT_AMT <> 0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt1name . '   SET CREDIT_TRANS_AMT = CREDIT_AMT, CREDIT_AMT = ROUND((CREDIT_AMT*POW(EXCHANGE_RT, CUR_OPERATOR)), 2) WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND CREDIT_AMT <> 0';
        ClxCommon::$db->executeQuery($sql);
        if (!class_exists('Jehd'))
            includeCodeLib('Jehd');
        $jehd = new Jehd();
        $jehd->display = $this->display;
        //Reject any posible todays entry from this process thas has run today
        $jehd->jehd_reverse_by_je_source($comp_code, $this->je_source, $operation_date);
        /* 2. GENERAR ACTIVIDADES DE DEVENGO PARA PARTICIPANTES DE CONTRATO */
        //Build Header for this process, one pre currency
        $sql = 'SELECT DISTINCT	COMP_CODE, ' . singleQuote($operation_date) . '  OPERATION_DATE, ' . singleQuote($comprec['LGGROUP_CODE']) . ' LGGROUP_CODE FROM ' . $this->glt1name . '  WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            $gl_rec = $jehd->jehd_init_record();
            $gl_rec['IDNAME'] = $idname;
            $gl_rec['JE_SOURCE'] = $this->je_source;
            $gl_rec['LGGROUP_CODE'] = $result['LGGROUP_CODE'];
            $gl_rec['EFFTDATE'] = $result['OPERATION_DATE'];
            $gl_rec['COMP_CODE'] = $result['COMP_CODE'];
            $gl_rec['TRANS_CODE'] = null;
            $gl_rec['TRANSTBL_CODE'] = 'SYS_CRED-INTE';
            $gl_rec['REQ_CHANNEL'] = 'SYS';
            $gl_rec['BATCH_ID'] = $this->batch_id;
            $jehd->jehd_build($gl_rec);
            //Search any scale if apply and dump lines to journal
            //debit in credit as
            $sql = 'INSERT INTO ' . $this->jelnname . '  (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec['IDCODE']) . ' JEHDR_CODE, X.GL01_CODE GLACCOUNTCODE, X.ITEM02_CODE ITEM_CODE, X.CHART_FIELD01, X.CHART_FIELD02, X.CHART_FIELD03, X.CHART_FIELD04, X.LOAN_CODE ITEM_REF_NO, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR, X.DEBIT_AMT, X.CREDIT_AMT, X.DEBIT_TRANS_AMT, X,CREDIT_TRANS_AMT, 1 SEQNUM FROM ' . $this->glt1name . ' X WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' ';
            ClxCommon::$db->executeQuery($sql);
            //contraparte
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec['IDCODE']) . ' JEHDR_CODE, X.GLACCOUNTCODE GLACCOUNTCODE, X.ITEM_CODE ITEM_CODE, X.CHART_FIELD01, X.CHART_FIELD02, X.CHART_FIELD03, X.CHART_FIELD04, X.LOAN_CODE ITEM_REF_NO, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR, X.CREDIT_AMT DEBIT_AMT, X.DEBIT_AMT CREDIT_AMT, X.DEBIT_TRANS_AMT, X.CREDIT_TRANS_AMT, 2 SEQNUM FROM ' . $this->glt1name . ' X WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' ';
            ClxCommon::$db->executeQuery($sql);
            //Removing sub account from in,ex,eq
            $sql = 'UPDATE ' . $this->jelnname . ' JELN SET JELN.CHART_FIELD03 = null WHERE JELN.JEHDR_CODE = ' . singleQuote($gl_rec['IDCODE']) . ' AND EXISTS(SELECT GLAC.ID FROM ' . $this->glacname . ' GLAC WHERE GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLAC.GL_TYPE IN (' . singleQuote('IN') . ',' . singleQuote('EX') . ',' . singleQuote('EQ') . '))';
            ClxCommon::$db->executeQuery($sql);
            $jehd->jehd_approve_by_code($gl_rec['IDCODE']);
        }
    }

    /**
     * Initialice all temporary tables
     *
     * @param string $batch_id
     */
    private function initTemporaryTables($batch_id) {
        //Load temporary table - Req on mysql
        $DBTB = &getTool('DBTB');
        $DBTB->buildTemporaryTable('GLT1'); //Clear tmp
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($batch_id));
    }

    //Other methods
    /**
     * Used by fiat to mark invoice payment transactions
     * @param unknown_type $jehdr_code
     */
    function record_fiat_payment_trasaction($jehdr_code, $apin_idlist) {
        $sql = 'INSERT INTO ' . $this->appyname . ' (PAYINV_CODE, JEHDR_CODE, CDATE, MDATE, CREATEDBY, MODIFIEDBY) SELECT APIN.IDCODE PAYINV_CODE, JEHD.IDCODE JEHDR_CODE, ' . singleQuote($this->now) . ' CDATE, ' . singleQuote($this->now) . ' MDATE, ' . singleQuote($this->username) . '  CREATEDBY, ' . singleQuote($this->username) . ' MODIFIEDBY FROM ' . $this->apinname . ' APIN, ' . $this->jehdname . ' JEHD WHERE JEHD.IDCODE = ' . singleQuote($jehdr_code) . ' AND APIN.ID IN (' . toString($apin_idlist) . ') AND NOT EXISTS(SELECT APPY.ID FROM ' . $this->appyname . ' APPY WHERE APPY.PAYINV_CODE = APIN.IDCODE AND APPY.JEHDR_CODE = JEHD.IDCODE)';
        ClxCommon::$db->executeQuery($sql);
        //This will be deprecated. Display just the last
        $sql = 'UPDATE ' . $this->apinname . '  SET PAY_JEHDR_CODE = ' . singleQuote($jehdr_code) . ' WHERE  ID IN (' . toString($apin_idlist) . ')';
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     * Builds Invoice based on information from invt table
     * @param unknown_type $batch_id
     */
    function buildInvoceFromInvt($batch_id, $gl_type = '', $auth_status = 'AP', $approve = false) {
        if (!empty($approve)) {
            if (!class_exists('Jehd'))
                includeCodeLib('JEHD');
            $jehd = new Jehd();
        }

        if (empty($auth_status)) {
            $auth_status = 'PEND';
        }

        //Item2 se usa en comisiones de adm pero no en otras facturas que solo usan item
        //Por eso copiar el valor si no esta definido
        $sql = 'UPDATE ' . $this->invtname . '  SET TGT_ITEM2_CODE = ITEM_CODE WHERE TGT_ITEM2_CODE IS NULL AND BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);

        //Setting due date
        $sql = 'UPDATE ' . $this->invtname . ' INVT, GL_PARAMETERS_TBL GLCP SET INVT.DUE_DATE = IFNULL((CASE GLCP.INVO_DEFDUE_FREQ WHEN ' . singleQuote('Y') . ' THEN ADDDATE(INVT.INVOICEDATE, INTERVAL  GLCP.INVO_DEFDUE_PER YEAR) WHEN ' . singleQuote('M') . ' THEN ADDDATE(INVT.INVOICEDATE, INTERVAL  GLCP.INVO_DEFDUE_PER MONTH) WHEN ' . singleQuote('D') . ' THEN ADDDATE(INVT.INVOICEDATE, INTERVAL  GLCP.INVO_DEFDUE_PER DAY) ELSE ADDDATE(INVT.INVOICEDATE, INTERVAL 1 DAY) END),INVT.DUE_DATE) WHERE INVT.COMP_CODE = GLCP.COMP_CODE AND INVT.BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);

        //Creating AP
        $sql = 'SELECT ' . singleQuote('AUTO') . ' IDCODE, MAX(IDNAME) IDNAME, VENDOR_CODE, MAX(INVOICEDATE) INVOICEDATE, MAX(DUE_DATE) DUE_DATE, CURRENCY_CODE, SUM(INVOICE_AMT) INVOICE_AMT, MAX(INVO_STAT) INVO_STAT, COMP_CODE, CHART_FIELD01, CHART_FIELD02, ITEM_CODE AP_ITEM_CODE, GL01_CODE GLACCOUNTCODE, MAX(CDATE) CDATE, MAX(CREATEDBY) CREATEDBY, MAX(CDATE) MDATE, MAX(CREATEDBY) MODIFIEDBY, RESTRICTED, FROM_CONTRACT_CODE, COMMISSION_CODE, BATCH_ID, EXT_REF_NO, GLPF_ID FROM ' . $this->invtname . '  WHERE BATCH_ID = ' . singleQuote($batch_id) . ' ' . (($gl_type <> '') ? ' AND GL_TYPE = ' . singleQuote($gl_type) . ' ' : ' ') . ' GROUP BY VENDOR_CODE, CURRENCY_CODE, COMP_CODE, CHART_FIELD01, CHART_FIELD02, ITEM_CODE, GL01_CODE, FROM_CONTRACT_CODE, COMMISSION_CODE, RESTRICTED, BATCH_ID, EXT_REF_NO, GLPF_ID';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $r['CLX_AUTH_STATUS'] = $auth_status;
            //Building Account Payables Apin bill
            //$r['DUE_DATE'] = adodb_next_day($r['DUE_DATE']);
            $this->build_record($r);
            ClxCommon::$db->executeQuery('DELETE FROM ' . $this->apilname . ' WHERE PAYINV_CODE = ' . singleQuote($r['IDCODE']));
            $sql = 'INSERT INTO ' . $this->apilname . '  (PAYINV_CODE, SEQNUM, DESCRIPTION, QUANTITY, PRICE, LINE_TOTAL, ITEM_CODE, GLACCOUNTCODE, CHART_FIELD03, CHART_FIELD04) SELECT ' . singleQuote($r['IDCODE']) . ' PAYINV_CODE, (@rownum:=@rownum+1) SEQNUM, CONCAT(CONCAT(IDNAME,' . singleQuote('-') . '), EXT_REF_NO) DESCRIPTION, 1 QUANTITY, (INVOICE_AMT) PRICE, (INVOICE_AMT) LINE_TOTAL, /*ITEM_CODE*/ TGT_ITEM2_CODE ITEM_CODE, GL02_CODE GLACCOUNTCODE, CHART_FIELD03, CHART_FIELD04 FROM ' . $this->invtname . ', (SELECT @rownum:=0) r WHERE GL_TYPE = ' . singleQuote($gl_type) . ' AND ITEM_CODE = ' . singleQuote($r['AP_ITEM_CODE']) . ' AND GL01_CODE = ' . singleQuote($r['GLACCOUNTCODE']) . ' AND VENDOR_CODE = ' . singleQuote($r['VENDOR_CODE']) . ' AND CURRENCY_CODE = ' . singleQuote($r['CURRENCY_CODE']) . ' AND COMP_CODE = ' . singleQuote($r['COMP_CODE']) . ' AND CHART_FIELD01 = ' . singleQuote($r['CHART_FIELD01']) . ' AND CHART_FIELD02 = ' . singleQuote($r['CHART_FIELD02']);
            if (!empty($r['FROM_CONTRACT_CODE'])) {
                $sql .=' AND FROM_CONTRACT_CODE = ' . singleQuote($r['FROM_CONTRACT_CODE']);
            }
            if (!empty($r['COMMISSION_CODE'])) {
                $sql .=' AND COMMISSION_CODE = ' . singleQuote($r['COMMISSION_CODE']);
            }
            if (!empty($r['EXT_REF_NO'])) {
                $sql .=' AND EXT_REF_NO = ' . singleQuote($r['EXT_REF_NO']);
            }
            if (!empty($r['GLPF_ID'])) {
                $sql .=' AND GLPF_ID = ' . singleQuote($r['GLPF_ID']);
            }
            ClxCommon::$db->executeQuery($sql);
            if ($r['RESTRICTED'] == CLX_NUM_ZERO) {
                $jehdr_code = $this->buildAccounting($r['IDCODE'],$r['INVO_STAT']);
                $sql = 'UPDATE ' . $this->apinname . '  SET JEHDR_CODE = ' . singleQuote($jehdr_code) . ' WHERE IDCODE = ' . singleQuote($r['IDCODE']);
                ClxCommon::$db->executeQuery($sql);
            }
            if ($auth_status === 'PEND' && $approve) {
                if ($jehd->jehd_approve_by_code($jehdr_code)) {
                    $sql = 'UPDATE ' . $this->apinname . '  SET CLX_AUTH_STATUS = ' . singleQuote('AP') . ' WHERE IDCODE = ' . singleQuote($r['IDCODE']);
                    ClxCommon::$db->executeQuery($sql);
                }
            }
        }
    }

    /**
     * Sets invoice status post authorization of journal entries
     * @param string $jehd_code
     */
    function post_jehd_approve($jehd_code) {
        /*
         * Si el asiento de la factura es reversado se marca la factura reversada 05
         * Si el asiento es de pago. Se suman los pagos para la cuenta de la factura si es igual al monto de la factura
         */
        //Marcar autorizacion como completada
        $sql = 'UPDATE CLX_AC_AUTHORIZATIONS AUTH, ' . $this->apinname . ' APIN SET AUTH.AUTH_STATUS = ' . singleQuote('AP') . ' WHERE AUTH.TABLECODE = ' . singleQuote('APIN') . ' AND AUTH.REC_ID = APIN.ID AND AUTH.AUTH_STATUS IN (' . singleQuoteArray(array('PEND','PEAP')) . ') AND APIN.JEHDR_CODE = ' . singleQuote($jehd_code);
        ClxCommon::$db->executeQuery($sql);

        $sql = 'SELECT JEHD.REV_JEHDR_CODE FROM ' . $this->jehdname . ' JEHD WHERE JEHD.IDCODE = ' . singleQuote($jehd_code) . ' AND EXISTS (SELECT APIN.ID FROM ' . $this->apinname . ' APIN WHERE APIN.JEHDR_CODE = JEHD.REV_JEHDR_CODE)';
        $rev_jehdr_code = ClxCommon::$db->getOne($sql);
        if (!empty($rev_jehdr_code)) {
            // setting void status
            $sql = 'UPDATE ' . $this->apinname . '  SET INVO_STAT = ' . singleQuote('05') . ', CLX_AUTH_STATUS = ' . singleQuote('AP') . ' WHERE JEHDR_CODE = ' . singleQuote($rev_jehdr_code);
            ClxCommon::$db->executeQuery($sql);
            return; //no need to check status of payment
        }
        //UPDATE AUTORIZATION STATUS
        // setting void status
        $sql = 'UPDATE ' . $this->apinname . '  SET CLX_AUTH_STATUS = ' . singleQuote('AP') . ' WHERE JEHDR_CODE = ' . singleQuote($jehd_code) . ' AND CLX_AUTH_STATUS in (' . singleQuoteArray(array('PEND','PEAP')) . ')';
        ClxCommon::$db->executeQuery($sql);

        $rev_jehdr_code = ClxCommon::$db->getField($this->jehdname, 'REV_JEHDR_CODE', 'IDCODE = ' . singleQuote($jehd_code));

        $sql = 'SELECT APIN.IDCODE, IFNULL((APIN.INVOICE_AMT-(IF(APIN.OPENING_BAL<>0, APIN.INVOICE_AMT-APIN.OPENING_BAL, 0)+ IFNULL((SELECT SUM(APPY.PAID_AMT) FIAT_TRANS_AMT FROM AP_PYMT_TRANS APPY, GL_JOURNAL_HDR JEHDX WHERE APPY.PAYINV_CODE = APIN.IDCODE AND JEHDX.IDCODE = APPY.JEHDR_CODE AND JEHDX.REVERSED = 0),0))),0) OPEN_BALANCE FROM ' . $this->apinname . ' APIN WHERE APIN.IDCODE IN (SELECT DISTINCT APPY2.PAYINV_CODE FROM ' . $this->appyname . ' APPY2 WHERE APPY2.JEHDR_CODE = ' . singleQuote(((!empty($rev_jehdr_code)) ? $rev_jehdr_code : $jehd_code)) . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $status = ($r['OPEN_BALANCE'] == 0) ? '02' : '01';
            //Paid status
            $sql = 'UPDATE ' . $this->apinname . '  SET INVO_STAT = ' . singleQuote($status) . ' WHERE IDCODE = ' . singleQuote($r['IDCODE']) . ' AND INVO_STAT IN (' . singleQuote('01') . ',' . singleQuote('02') . ')';
            ClxCommon::$db->executeQuery($sql);
            //Si aplica genera la comision en el contrato relacionado
            if ($status === '02') {
                $this->pay_related_commision($jehd_code);
            }
        }
    }

    /**
     * Generates transation for dependant contract
     * @param string $jehdr_code
     */
    function pay_related_commision($jehd_code) {
        $sql = 'SELECT COUNT(FIAC.ID) FROM ' . $this->apinname . ' APIN, ' . $this->fiacname . ' FIAC, ' . $this->appyname . ' APPY WHERE APPY.PAYINV_CODE = APIN.IDCODE AND APPY.JEHDR_CODE = ' . singleQuote($jehd_code) . ' AND FIAC.IDCODE = APIN.COMMISSION_CODE';
        if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
            $this->pay_related_commision_fiac($jehd_code);
        }
        $sql = 'SELECT COUNT(GLPF.ID) FROM ' . $this->apinname . ' APIN, ' . $this->glpfname . ' GLPF, ' . $this->appyname . ' APPY WHERE APIN.IDCODE = APPY.PAYINV_CODE AND APPY.JEHDR_CODE = ' . singleQuote($jehd_code) . ' AND GLPF.ID = APIN.GLPF_ID';
        if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
            $this->pay_related_commision_glpf($jehd_code);
        }
    }

    /**
     * Generates transation for dependant contract
     * @param string $jehdr_code
     */
    private function pay_related_commision_fiac($jehd_code) {
        // Load temporary table - Req on mysql
        $DBTB = &getTool('DBTB');
        $DBTB->buildTemporaryTable('FTMP');
        ClxCommon::$db->deleteRecords($this->ftmpname, 'BATCH_ID = ' . singleQuote($this->batch_id));
        //Si es una factura de la administradora con origen en una comision al marcar como pagada
        //es necesario generar la transaccion de pago en el contrato de fideicomiso para completar el ciclo
        //1.Seleccionar facturas pagadas por asiento que tengan contrato relacionado
        /* Nota se buscan saldos de transacciones de pago por lo que dr-cr es <0 si es activo */
        // AND INVO.INVO_STAT = '01' se contemplan solo facturas que esten pendientes de pago
        /*  SUM(APIN.INVOICE_AMT) INVOICE_AMT,
          MAX(APIN.INVOICEDATE) INVOICE_DATE, MAX(APIN.IDNAME) IDNAME, MAX(IFNULL(nullIF(APIN.EXT_REF_NO,''),APIN.IDCODE)) EXT_REF_NO, (SELECT IFNULL(SUM(APIL.LINE_TOTAL),0) FROM ' . $this->apilname.' APIL, ' . $this->jeitname.' JEIT WHERE APIL.PAYINV_CODE = APIN.IDCODE AND JEIT.TAX_TYPE <> '' AND JEIT.IDCODE = APIL.ITEM_CODE AND JEIT.CLX_EFFTDATE = (SELECT MAX(JEITX.CLX_EFFTDATE) FROM ' . $this->jeitname.' JEITX WHERE JEITX.IDCODE = JEIT.IDCODE AND JEITX.CLX_EFFTDATE<='. singleQuote($this->now).')) TAX_AMT */
        $sql = 'INSERT INTO ' . $this->ftmpname . '  (IDNAME, EFFTDATE, TRANSTBL_CODE, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, LGGROUP_CODE, ITEM_REF_NO, COMP_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, BANKACCOUNT_CODE, CALC_AMT_01, CALC_AMT_02, CALC_AMT_03, DISBURSEMENT_TYPE, BENEFICIARY_NAME, BRANCH_PRN, BATCH_ID, REC_STATUS, REC_ID) SELECT FIRT.IDNAME, GLCP.OPERATION_DATE EFFTDATE, FIRT.PAY_TX_CODE TRANSTBL_CODE, FIAT.CURRENCY_CODE, FIAT.EXCHANGE_RT, FIAT.CUR_OPERATOR, GLCP.DEF_LGGROUP_CODE LGGROUP_CODE, FIAC.IDCODE ITEM_REF_NO, FIRT.COMP_CODE, FIAC.CONTRACT_CODE CHART_FIELD01, APIN.VENDOR_CODE CHART_FIELD02, null CHART_FIELD03, null CHART_FIELD04, FIAC.FIDU_BANKACT_CODE BANKACCOUNT_CODE, /*FIAT.TRANS_AMT*/ APIN.INVOICE_AMT CALC_AMT_01, FIAC.APPROVE_PAYMENT CALC_AMT_02, /*FIAT.TAX_AMT*/ (SELECT IFNULL(SUM(APIL.LINE_TOTAL),0) FROM ' . $this->apilname . ' APIL, ' . $this->jeitname . ' JEIT WHERE APIL.PAYINV_CODE = APIN.IDCODE AND JEIT.TAX_TYPE <> ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND JEIT.IDCODE = APIL.ITEM_CODE AND JEIT.CLX_EFFTDATE = (SELECT MAX(JEITX.CLX_EFFTDATE) FROM ' . $this->jeitname . ' JEITX WHERE JEITX.IDCODE = JEIT.IDCODE AND JEITX.CLX_EFFTDATE<=' . singleQuote($this->now) . ')) CALC_AMT_03, FIAC.ADM_DISMNT_TYPE DISBURSEMENT_TYPE, FIAC.BENEFICIARY_NAME, FIAC.BRANCH_PRN, ' . singleQuote($this->batch_id) . ' BATCH_ID, ' . "'RUN'" . ' REC_STATUS, APPY.ID FROM ' . $this->glcpname . ' GLCP, ' . $this->apinname . ' APIN, ' . $this->fiacname . ' FIAC, ' . $this->firtname . ' FIRT, ' . $this->jehdname . ' JEHD, ' . $this->fiatname . ' FIAT, ' . $this->appyname . ' APPY WHERE APPY.PAYINV_CODE = APIN.IDCODE AND APPY.JEHDR_CODE = ' . singleQuote($jehd_code) . ' AND JEHD.TRANS_CODE = FIAT.IDCODE AND GLCP.COMP_CODE = FIRT.COMP_CODE AND JEHD.IDCODE = APPY.JEHDR_CODE AND FIAC.IDCODE = APIN.COMMISSION_CODE AND FIAC.FIDU_RATETBLCODE = FIRT.IDCODE AND FIRT.CLX_EFFTDATE=(SELECT MAX(X.CLX_EFFTDATE) CLX_EFFTDATE FROM ' . $this->firtname . ' X WHERE X.IDCODE=FIRT.IDCODE AND X.CLX_EFFTDATE<=APIN.INVOICEDATE) ';
        ClxCommon::$db->executeQuery($sql);
        if (!class_exists('Fiac')) {
            includeCodeLib('FIAC');
        }
        $fiac = new Fiac();
        $fiac->build_invoice_pay_fiat_from_ftmp($this->batch_id, 'FIRTADMPAY');
        unset($fiac);
    }

    /**
     * Generates transation for dependant contract credit
     * @param string $jehdr_code
     */
    private function pay_related_commision_glpf($jehd_code) {
        // Load temporary table - Req on mysql
        $DBTB = &getTool('DBTB');
        $DBTB->buildTemporaryTable('FTMP');
        ClxCommon::$db->deleteRecords($this->ftmpname, 'BATCH_ID = ' . singleQuote($this->batch_id));
        //Si es una factura de la administradora con origen en una comision al marcar como pagada
        //es necesario generar la transaccion de pago en el contrato de fideicomiso para completar el ciclo
        //1.Seleccionar facturas pagadas por asiento que tengan contrato relacionado
        /* Nota se buscan saldos de transacciones de pago por lo que dr-cr es <0 si es activo */
        // AND INVO.INVO_STAT = '01' se contemplan solo facturas que esten pendientes de pago
        //Casos que vienen por comision
        $sql = 'INSERT INTO ' . $this->ftmpname . '  (IDNAME, EFFTDATE, TRANSTBL_CODE, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, LGGROUP_CODE, ITEM_REF_NO, COMP_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, BANKACCOUNT_CODE, CALC_AMT_01, CALC_AMT_02, CALC_AMT_03, DISBURSEMENT_TYPE, BENEFICIARY_NAME, BENEFICIARY_CODE, BRANCH_PRN, BATCH_ID, REC_STATUS, GLPF_ID, REC.ID) SELECT GLPF.IDNAME, GLCP.OPERATION_DATE EFFTDATE, GLPF.PAY_TX_CODE TRANSTBL_CODE, FIAT.CURRENCY_CODE, FIAT.EXCHANGE_RT, FIAT.CUR_OPERATOR, GLCP.DEF_LGGROUP_CODE LGGROUP_CODE, APIN.EXT_REF_NO ITEM_REF_NO, FICO.COMP_CODE, APIN.FROM_CONTRACT_CODE CHART_FIELD01, APIN.ACCOUNTCODE CHART_FIELD02, null CHART_FIELD03, null CHART_FIELD04, null BANKACCOUNT_CODE, APIN.INVOICE_AMT CALC_AMT_01, GLPF.APPROVE_PAYMENT CALC_AMT_02, (SELECT IFNULL(SUM(APIL.LINE_TOTAL),0) FROM ' . $this->apilname . ' APIL, ' . $this->jeitname . ' JEIT WHERE APIL.PAYINV_CODE = APIN.IDCODE AND JEIT.TAX_TYPE <> ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND JEIT.IDCODE = APIL.ITEM_CODE AND JEIT.CLX_EFFTDATE = (SELECT MAX(JEITX.CLX_EFFTDATE) FROM ' . $this->jeitname . ' JEITX WHERE JEITX.IDCODE = JEIT.IDCODE AND JEITX.CLX_EFFTDATE<=' . singleQuote($this->now) . ')) CALC_AMT_03, FIAT.DISBURSEMENT_TYPE, FIAT.BENEFICIARY_NAME, FIAT.BENEFICIARY_CODE, FIAT.BRANCH_PRN, ' . singleQuote($this->batch_id) . ' BATCH_ID, ' . singleQuote('RUN') . ' REC_STATUS, GLPF.ID, APPY.ID FROM ' . $this->ficoname . ' FICO, ' . $this->glcpname . ' GLCP, ' . $this->apinname . ' APIN, ' . $this->glpfname . ' GLPF, ' . $this->jehdname . ' JEHD, ' . $this->fiatname . ' FIAT, ' . $this->appyname . ' APPY WHERE APPY.PAYINV_CODE = APIN.IDCODE AND APPY.JEHDR_CODE = ' . singleQuote($jehd_code) . ' AND APIN.FROM_CONTRACT_CODE = FICO.IDCODE AND FIAT.IDCODE = JEHD.TRANS_CODE AND GLCP.COMP_CODE = FICO.COMP_CODE AND JEHD.IDCODE = APPY.JEHDR_CODE AND GLPF.ID = APIN.GLPF_ID';
        ClxCommon::$db->executeQuery($sql);
        //Actualizando participante principal del contrato
        $sql = 'UPDATE ' . $this->ftmpname . ' FTMP, ' . $this->fipaname . ' FIPA SET FTMP.BANKACCOUNT_CODE = FIPA.DEF_BANKACC_CODE, FTMP.CHART_FIELD02 = FIPA.ACCOUNTCODE WHERE FIPA.CONTRACT_CODE = FTMP.CHART_FIELD01 AND FIPA.ISPRIMARY = 1 AND FTMP.BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->ftmpname . ' FTMP, ' . $this->filoname . ' FILO SET FTMP.BANKACCOUNT_CODE = FILO.PAY_BANKACT_NO WHERE FILO.IDCODE = FTMP.ITEM_REF_NO AND FTMP.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILOX WHERE FILOX.IDCODE = FILO.IDCODE)';
        ClxCommon::$db->executeQuery($sql);
        if (!class_exists('Glpf')) {
            includeCodeLib('GLPF');
        }
        $glpf = new Glpf();
        $glpf->build_invoice_pay_fiat_from_ftmp($this->batch_id, 'GLPFADMPAY');
        unset($glpf);
    }

    /**
     * Method to reset invoce to pending
     */
    function invoice_reset() {
        $idlist = toString(getIdlist());
        ClxCommon::$db->updateRecord($this->apinname, array('CLX_AUTH_STATUS' => 'PEND', 'INVO_STAT' => '01'), 'ID IN (' . $idlist . ')');
        $sql = 'UPDATE ' . $this->fiatname . ' FIAT SET FIAT.CLX_AUTH_STATUS = ' . singleQuote('PEND') . ', FIAT.TRANS_STATUS = ' . singleQuote('PEND') . ' WHERE FIAT.TRANS_STATUS <> ' . "'REJ'" . ' AND FIAT.IDCODE IN (SELECT JEHD.TRANS_CODE FROM ' . $this->jehdname . ' JEHD, ' . $this->apinname . ' APIN WHERE (JEHD.IDCODE IN (APIN.JEHDR_CODE, APIN.PAY_JEHDR_CODE) OR EXISTS(SELECT APPY.ID FROM ' . $this->appyname . ' APPY WHERE APPY.PAYINV_CODE = APIN.IDCODE)) AND APIN.ID IN (' . $idlist . ') AND JEHD.TRANS_CODE IS NOT null)';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->jehdname . ' JEHD SET JEHD.CLX_AUTH_STATUS = ' . singleQuote('PEND') . ', JEHD.JE_STATUS = ' . singleQuote('PEND') . ' WHERE JEHD.JE_STATUS <> ' . "'REJ'" . ' AND EXISTS (SELECT APIN.ID FROM ' . $this->apinname . ' APIN WHERE (APIN.JEHDR_CODE = JEHD.IDCODE OR APIN.PAY_JEHDR_CODE = JEHD.IDCODE OR EXISTS(SELECT APPY.ID FROM ' . $this->appyname . ' APPY WHERE APPY.PAYINV_CODE = APIN.IDCODE)) AND APIN.ID IN (' . $idlist . '))';
        ClxCommon::$db->executeQuery($sql);
        //Recalculation ledgers
        if (!class_exists('Leba'))
            includeCodeLib('LEBA');
        if (!class_exists('Jebl'))
            includeCodeLib('JEBL');
        $a = new Leba();
        $b = new Jebl();
        $sql = 'SELECT COMP_CODE, MIN(INVOICEDATE) INVOICEDATE FROM ' . $this->apinname . ' WHERE ID IN (' . $idlist . ') GROUP BY COMP_CODE';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $a->leba_rebuild($r['COMP_CODE']);
            $b->jebl_build($r['COMP_CODE'], $r['INVOICEDATE']);
        }
        unset($a);
    }

    /**
     * Invoice line's "Invoice Amount Calc" button event
     * @param void
     * @return void
     */
    function recalculateTotalFromLine() {
        $cp = peekHistory();
        if (!empty($cp['parentrecord']['APIN_IDCODE'])) {
            if ($cp['parentrecord']['APIN_CLX_AUTH_STATUS'] == 'PEND') {
                // Updates lines tax amounts
                $this->apil_all_lines_tax_calc($cp['parentrecord']['APIN_IDCODE']);
                // Updates invoice total amount
                $prev_invoice_amt = 0 + $cp['parentrecord']['APIN_INVOICE_AMT'];
                $new_invoice_amt = $this->update_apin_total_amt($cp['parentrecord']['APIN_IDCODE'], 'set');
                if ($prev_invoice_amt != $new_invoice_amt && $cp['parentrecord']['APIN_JEHDR_CODE'] != '') {
                    /*
                     * Re-Builds accounting if invoice total amount was changed in this method
                     * and journal entry was already generated
                     */
                    $this->buildAccounting($cp['parentrecord']['APIN_IDCODE']);
                }
            } else {
                addMessage(smsg('MSG-262', $cp['parentrecord']['APIN_IDCODE']));
            }
        } else {
            addMessage('INTERNAL ERROR: no Invoice code...');
        }
    }

    /**
     * Get invoice line tax amount
     */
    private function get_tax_amt($line_item_code, $line_total, $invoicecode) {
        $a_item_tax_data = $this->get_item_tax_data($line_item_code, $invoicecode);
        if ($a_item_tax_data['error'] == true || $a_item_tax_data['found'] == false) {
            return 0;
        }
        // line has a Tax Item code, so look for it and calculate tax amount
        return $this->calc_tax_amt($line_total, $a_item_tax_data);
    }

    /**
     * Calc line tax amount
     */
    private function calc_tax_amt($line_total, $sales_tax_data) {

        $response = bcmul(bcmul(bcsub($line_total, $sales_tax_data['data']['EXEMPT_TAX_AMT']), bcdiv($sales_tax_data['data']['FLAT_RATE'], 100)), bcdiv($sales_tax_data['data']['TAX_WITHOLDING_PCT'], '100'));
        if ($response < 0) {
            $response = 0;
        }
        return $response;
    }

    /**
     * Get invoice line tax item record
     */
    private function get_item_tax_data($line_item_code, $invoicecode) {

        $a_response = array();
        $a_response['error'] = false;
        $a_response['found'] = false;

        $sql = 'SELECT APIN.VENDOR_CODE ACCOUNTCODE, ACCO.LEGAL_TYPE, ACCO.STATE, ACCO.COUNTRY, JEIT.FLAT_RATE, JEIT.EXEMPT_TAX_AMT, JEIT.TAX_WITHOLDING_PCT, JEIT.TAX_TYPE, JEIT.FILING_STATUS,JEIT.STATE,JEIT.COUNTRY, IFNULL(JEIT.GLACCOUNTC_TAX, \'\') GLACCOUNTC_TAX, JEIT.GLACCOUNTCODE FROM AP_PAY_INVOICES APIN LEFT JOIN CRM_ACCOUNTS ACCO ON ACCO.IDCODE = APIN.VENDOR_CODE, ' . $this->jeitname . ' JEIT  WHERE APIN.IDCODE = ' . singleQuote($invoicecode) . ' AND JEIT.IDCODE = ' . singleQuote($line_item_code) . ' AND JEIT.CLX_EFFTDATE=(SELECT MAX(X.CLX_EFFTDATE) CLX_EFFTDATE FROM ' . $this->jeitname . ' X WHERE  X.IDCODE=JEIT.IDCODE AND  X.CLX_EFFTDATE <=  APIN.INVOICEDATE)';
        $rs = ClxCommon::$db->executeQuery($sql);
        if ($r = ClxCommon::$db->getNextRecord($rs)) {
            $a_response['data'] = $r;
            $a_response['found'] = true;
        }

        return $a_response;
    }

    /**
     * Calculate Tax amount for all invoice lines
     */
    private function apil_all_lines_tax_calc($invoicecode) {

        $sql = 'SELECT APIL.ID, APIL.ITEM_CODE, APIL.TAX_AMT, (CASE WHEN ITEM_TYPE=\'IXC\' THEN APIL.LINE_TOTAL_W WHEN ITEM_TYPE=\'IXP\' THEN APIL.LINE_TOTAL_W ELSE APIL.LINE_TOTAL END) LINE_TOTAL FROM ' . $this->apilname . ' APIL , '. $this->jeitname . ' JEIT WHERE APIL.PAYINV_CODE = \'' . $invoicecode . '\' AND APIL.ITEM_CODE=JEIT.IDCODE';
        $lines = ClxCommon::$db->executeQuery($sql);
        while ($line = ClxCommon::$db->getNextRecord($lines)) {

            $this_line_tax_amt = 0;
            $a_item_tax_data = $this->get_item_tax_data($line['ITEM_CODE'], $invoicecode);
            if ($a_item_tax_data['error'] == false && $a_item_tax_data['found'] == true) {
                // line has a Tax Item code, so look for it and calculate tax amount
                $this_line_tax_amt = $this->calc_tax_amt($line ['LINE_TOTAL'], $a_item_tax_data);
            }

            if ($this_line_tax_amt <> $line ['TAX_AMT']) {
                $tax_line = array('TAX_AMT' => $this_line_tax_amt);
                ClxCommon::$db->updateRecord('AP_PAY_INVOICE_LINE', $tax_line, 'ID = ' . singleQuote($line ['ID']));
            }
        }
    }

    /**
     * Update invoice total amount from invoice lines
     */
    private function update_apin_total_amt($invoicecode, $action) {

        if ($action == 'set') {
            $sql = 'UPDATE AP_PAY_INVOICES APIN SET APIN.INVOICE_AMT = IFNULL((SELECT SUM(APIL.LINE_TOTAL+APIL.TAX_AMT) FROM AP_PAY_INVOICE_LINE APIL WHERE APIL.PAYINV_CODE = APIN.IDCODE), 0) WHERE APIN.IDCODE = ' . singleQuote($invoicecode);
            ClxCommon::$db->executeQuery($sql);
            $response = ClxCommon::$db->getField('AP_PAY_INVOICES', 'INVOICE_AMT', 'IDCODE = ' . singleQuote($invoicecode));
        } else {
            $response = ClxCommon::$db->getField('AP_PAY_INVOICE_LINE', 'SUM(LINE_TOTAL+TAX_AMT)', 'PAYINV_CODE = ' . singleQuote($invoicecode));
        }

        return $response;
    }
	
	
	
	/* función para exportar las compras a rendir a la DGII    */
	function apin_export_compras() {
		$criteria=$_SESSION['paging']['INVO_606_LIST'];
		$comp_code='';
		//verificamos que existe la variable de session qfilter que contiene la compañia seleccionada en el criterio de busqueda
		if (empty($criteria['qfilter']['APIF_COMP_CODE'])){
			addMessage(smsg('MSG-536', '606'));
		}else{
			$comp_code=$criteria['qfilter']['APIF_COMP_CODE']; //obtenemos el codigo de compañía

		
			$ncfinvo = ClxCommon::$db->getFields('AP_PAY_INVOICE_DGIIH', 'TYPE_REPORT, TAXID, PERIOD_NAME, REGISTER_NUMBER', 'COMP_CODE='.singleQuote($comp_code));


			$cab=$ncfinvo['TYPE_REPORT'].'|'.$ncfinvo['TAXID'].'|'.$ncfinvo['PERIOD_NAME'].'|'.$ncfinvo['REGISTER_NUMBER'];
			$cab.=chr(13).chr(10);

			$taxid=$ncfinvo['TAXID'];
			$periodo=$ncfinvo['PERIOD_NAME'];

			$sql='SELECT IDENTIFICATION, (CASE WHEN IDENTIFICATION_TYPE="RNC" THEN "1" WHEN IDENTIFICATION_TYPE="CIV" THEN "2" ELSE "0" END) IDENTIFICATION_TYPE, PURCHASE_TYPE, TAXRCPT_NO, TAXRCPTREL_NO, INVOICEDATE+0 AS INVOICEDATE, EFFTDATE+0 AS EFFTDATE, COALESCE(INV_SERV_AMT, 0.00) AS INV_SERV_AMT, COALESCE(INV_BIEN_AMT,0.00) AS INV_BIEN_AMT, INVOICE_AMT, TAX_AMT, COALESCE(TAX_AMT_RET,0.00) AS TAX_AMT_RET, COALESCE(TAX_SUJ_PROP,0.00) AS TAX_SUJ_PROP, COALESCE(TAX_COST,0.00) AS TAX_COST, COALESCE(TAX_ADV,0.00) AS TAX_ADV, COALESCE(TAX_PURCH,0.00) AS TAX_PURCH, INCTAX_TYPE, COALESCE(INCTAX,0.00) AS INCTAX, COALESCE(ISR_PERC_COMP,0.00) AS ISR_PERC_COMP, COALESCE(TAX_SEL_CONS,0.00) AS TAX_SEL_CONS, COALESCE(TAX_OTHER,0.00) AS TAX_OTHER, COALESCE(AMT_PROP,0.00) AS AMT_PROP, CLX_TRANSLATE(DISBURSEMENT_TYPE,"DISB_OMG", 0, 0) AS DISBURSEMENT_TYPE FROM AP_PAY_INVOICE_DGII WHERE COMP_CODE = '.singleQuote($comp_code);

			$rs = ClxCommon::$db->executeQuery($sql);

			$cuerpo=$cab;
			while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {                                  
				$cuerpo.=$r['IDENTIFICATION']."|";
				$cuerpo.=$r['IDENTIFICATION_TYPE']."|";
				$cuerpo.=$r['PURCHASE_TYPE']."|";
				$cuerpo.=$r['TAXRCPT_NO']."|";
				$cuerpo.=$r['TAXRCPTREL_NO']."|"; 
				$cuerpo.=$r['INVOICEDATE']."|";
				$cuerpo.=$r['EFFTDATE']."|";
				$cuerpo.=$r['INV_SERV_AMT']."|";
				$cuerpo.=$r['INV_BIEN_AMT']."|";
				$cuerpo.=$r['INVOICE_AMT']."|";
				$cuerpo.=$r['TAX_AMT']."|";
				$cuerpo.=$r['TAX_AMT_RET']."|";
				$cuerpo.=$r['TAX_SUJ_PROP']."|";
				$cuerpo.=$r['TAX_COST']."|";
				$cuerpo.=$r['TAX_ADV']."|";
				$cuerpo.=$r['TAX_PURCH']."|";
				$cuerpo.=$r['INCTAX_TYPE']."|";
				$cuerpo.=$r['INCTAX']."|";
				$cuerpo.=$r['ISR_PERC_COMP']."|";
				$cuerpo.=$r['TAX_SEL_CONS']."|";
				$cuerpo.=$r['TAX_OTHER']."|";
				$cuerpo.=$r['AMT_PROP']."|";
				$cuerpo.=$r['DISBURSEMENT_TYPE'].chr(13).chr(10);
			}

			$path = "temp/DGII_F_606_".$taxid."_".$periodo.".txt";

			$nomb_descarga="DGII_F_606_".$taxid."_".$periodo.".txt";

			if($archivo = fopen($path, "w+"))
			{
				if(fwrite($archivo, $cuerpo))
				{
					addMessage("Se ha ejecutado correctamente la generación del archivo. </br> Descargar en el siguiente enlace:  ".chr(60)."a href='$path' "."download='".$nomb_descarga."'".chr(62)."$nomb_descarga".chr(60)."a".chr(62)); 
				}
				else
				{
					addMessage("Se ha producido un problema al crear el archivo");
				}

				fclose($archivo);
			}

		}
			
			
	
	}
	
	
	/* función para exportar pagos al exterior a rendir a la DGII    */
	function apin_export_exterior() {

		$criteria=$_SESSION['paging']['INVO_609_LIST'];
		$comp_code='';
		//verificamos que existe la variable de session qfilter que contiene la compañia seleccionada en el criterio de busqueda
		if (empty($criteria['qfilter']['APEX_COMP_CODE'])){
			addMessage(smsg('MSG-536', '609'));
		}else{
			$comp_code=$criteria['qfilter']['APEX_COMP_CODE']; //obtenemos el codigo de compañía
      

			$ncfinvo = ClxCommon::$db->getFields('AP_PAY_INVEXT_DGIIH', 'TYPE_REPORT, TAXID, PERIOD_NAME, REGISTER_NUMBER', 'COMP_CODE='.singleQuote($comp_code));


			$cab=$ncfinvo['TYPE_REPORT'].'|'.$ncfinvo['TAXID'].'|'.$ncfinvo['PERIOD_NAME'].'|'.$ncfinvo['REGISTER_NUMBER'];
			$cab.=chr(13).chr(10);

			$taxid=$ncfinvo['TAXID'];
			$periodo=$ncfinvo['PERIOD_NAME'];

			$sql='SELECT IDNAME, (CASE WHEN IDENTIFICATION_TYPE="RNC" THEN "2" WHEN IDENTIFICATION_TYPE="CIV" THEN "1" ELSE "0" END) IDENTIFICATION_TYPE, IDENTIFICATION, CLX_TRANSLATE(COUP,"ISO3166", 0, 0) AS COP, SERVICES, DET_SERV, VINC_REL, DOC_JURISDICTION, DATE_DOC+0 AS DATE_DOC, INVOICE_AMT, EFFTDATE+0 AS EFFTDATE, COALESCE(BASE_ISR,0.00) AS BASE_ISR, COALESCE(ISLR_AMT,0.00) AS ISLR_AMT FROM AP_PAY_INVEXT_DGII WHERE COMP_CODE = '.singleQuote($comp_code);

			$rs = ClxCommon::$db->executeQuery($sql);

			$cuerpo=$cab;
			while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {                                  
				$cuerpo.=$r['IDNAME']."|";
				$cuerpo.=$r['IDENTIFICATION_TYPE']."|";
				$cuerpo.=$r['IDENTIFICATION']."|";
				$cuerpo.=$r['COP']."|";
				$cuerpo.=$r['SERVICES']."|";
				$cuerpo.=$r['DET_SERV']."|";
				$cuerpo.=$r['VINC_REL']."|"; 
				$cuerpo.=$r['DOC_JURISDICTION']."|";
				$cuerpo.=$r['DATE_DOC']."|";
				$cuerpo.=$r['INVOICE_AMT']."|";
				$cuerpo.=$r['EFFTDATE']."|";
				$cuerpo.=$r['BASE_ISR']."|";
				$cuerpo.=$r['ISLR_AMT'].chr(13).chr(10);
			}

			$path = "temp/DGII_F_609_".$taxid."_".$periodo.".txt";

			$nomb_descarga="DGII_F_609_".$taxid."_".$periodo.".txt";

			if($archivo = fopen($path, "w+"))
			{
				if(fwrite($archivo, $cuerpo))
				{
					addMessage("Se ha ejecutado correctamente la generación del archivo. </br> Descargar en el siguiente enlace:  ".chr(60)."a href='$path' "."download='".$nomb_descarga."'".chr(62)."$nomb_descarga".chr(60)."a".chr(62));
				}
				else
				{
					addMessage("Se ha producido un problema al crear el archivo");
				}

				fclose($archivo);
			}
		}
			
	}
	
	    // TRANSACTION REPORTS JASPER COMPROBANTE DE RETENCIONES OMG
    function print_invoice_comp() {
		$tool = &getTool('ANRP');
		$controls = array();
		$idlist = toString(getIdlist());
		
		$comp = ClxCommon::$db->getFields('GL_TAX_REPORTS', 'IDCODE, COMP_CODE, TAX_TYPE, INITIAL_DATE, DATE_FINAL', 'ID=' . $idlist);
		
		
		$controls['idcode']=$comp['IDCODE'];
		$controls['comp_code']=$comp['COMP_CODE'];
		$controls['initial_date']=$comp['INITIAL_DATE'];
		$controls['date_final']=$comp['DATE_FINAL'];
		
		//pre($controls);
		//exit;
		$controls['view_display']=true;

        $controls['RTBL_URI_IMAGES']=@ANRP_JASPER_SERVER_URI_IMAGES;

		switch ($comp['TAX_TYPE']) {
			case 'ITBIST':
				return $tool->buildRunJasperReport('01', 'pdf', 'invo/Detail_comp_iva', $controls);
				break;
			case 'ISRR':
				return $tool->buildRunJasperReport('02', 'pdf', 'invo/Detail_comp_isr', $controls);
				break;
			default:
			    addMessage("Comprobante de Retención no puede procesarse");
		}
	}


}
