function CpitCalcNoPayments() {

    var payfreq = parseFloat($('#CPIT_PAYMENT_FREQ').val());
    var period = parseFloat($('#CPIT_LOAN_PERIOD').val());
    var periodtype = $('#CPIT_PERIOD_TYPE').val();
    var periodfactor = 0;
    if (isNaN(period)) {
        period = 0;
        $('#CPIT_LOAN_PERIOD').val(0);
    }
    if (periodtype == 'D') {
        periodfactor = 360;
    }
    else if (periodtype == 'W') {
        periodfactor = 52;
    }
    else if (periodtype == 'M') {
        periodfactor = 12;
    }
    else if (periodtype == 'Q') {
        periodfactor = 4;
    }
    else if (periodtype == 'S') {
        periodfactor = 2;
    }
    else if (periodtype == 'Y') {
        periodfactor = 1;
    }
    else {
        periodfactor = 0;
    }
    var nopay = 0;
    if (periodfactor > 0) {
        nopay = period * (payfreq / periodfactor);
    }
    if (payfreq == 99) {
        nopay = 1;
    }
    $('#CPIT_NO_PAYMENTS').val(Math.round(nopay));

}//end function

/**
 * Localiza el monto de interes para reserva
 */
function CpitFindFeesNames() {

    //GLPV
    var prod_code = $('#CPIT_PRODUCT_CODE_prim').val();
    $.ajax({type: 'GET',
        url: 'window.php?to=DBQY&ac=QXML&no_menu=1&no_alerts=1&qy=GLPF_JS&fn=GLPF.PRODUCT_CODE&fv=' + prod_code,
        dataType: 'xml',
        success: function (xml) {
            var self = self;
            $(xml).find('GLPF_JS').each(function () {
                var self = self;
                var fm1 = CpitFeesFormulaLbl($(self).find('GLPF_FEE_01_FORMULA_WRK').text());
                var fm2 = CpitFeesFormulaLbl($(self).find('GLPF_FEE_02_FORMULA_WRK').text());
                var fm3 = CpitFeesFormulaLbl($(self).find('GLPF_FEE_03_FORMULA_WRK').text());
                var fm4 = CpitFeesFormulaLbl($(self).find('GLPF_FEE_04_FORMULA_WRK').text());
                var fm5 = CpitFeesFormulaLbl($(self).find('GLPF_FEE_05_FORMULA_WRK').text());

                $('#CPIT_FEE_01_NAME').val(fm1 + $(self).find('GLPF_FEE_01_NAME_WRK').text());
                $('#CPIT_FEE_02_NAME').val(fm2 + $(self).find('GLPF_FEE_02_NAME_WRK').text());
                $('#CPIT_FEE_03_NAME').val(fm3 + $(self).find('GLPF_FEE_03_NAME_WRK').text());
                $('#CPIT_FEE_04_NAME').val(fm4 + $(self).find('GLPF_FEE_04_NAME_WRK').text());
                $('#CPIT_FEE_05_NAME').val(fm5 + $(self).find('GLPF_FEE_05_NAME_WRK').text());
            });
        }
    });
}//end function

function CpitFeesFormulaLbl(code) {
    var lbl = '';
    if (code.charAt(0) == 'P') {
        lbl = '% ';
    }
    return lbl;
}

function cpitCalcLoanAmt() {

    $('#CPIT_LOAN_AMT').val(numDec(parseFloat($('#CPIT_REQUESTED_AMT').val()) - parseFloat($('#CPIT_DOWN_PYMT_AMT').val()), 2));

}

function cpitInitForm() {
    var self = this;
    $(function () {
        $('#CPIT_CRED_PAY_METHOD option').each(function (i) {
            switch ($(self).val()) {
                case '7':
                    $(self).hide();
                    break;
                default:
                    //do nothing
                    break;
            }
            ;
        });
    });


    //CPIT_PAYMENT_FREQ
    $(function () {
        $('#CPIT_PAYMENT_FREQ option').each(function (i) {
            switch ($(self).val()) {
                case '0':
                case '12':
                case '6':
                case '4':
                case '3':
                case '2':
                case '1':
                    //do nothing
                    break;
                default:
                    $(self).hide();
                    break;
            }
            ;
        });
    });
    //CPIT_PERIOD_TYPE
    $(function () {
        $('#CPIT_PERIOD_TYPE option').each(function (i) {
            switch ($(self).val()) {
                case 'H':
                case 'D':
                case 'W':
                    $(self).hide();
                    break;
                default:

                    break;
            }
            ;
        });
    });


    $(function () {
        $('#CPIT_INTEREST_CALC option').each(function (i) {
            switch ($(self).val()) {
                case '30/360': /*case 'AC/360':*/
                case '':
                case '30/365':/* case 'AC/365': case 'AC/AC':*/
                    //do nothing
                    break;
                default:
                    $(self).hide();
                    break;
            }
            ;
        });
    });
    $('#CPIT_REQUESTED_AMT').change(cpitCalcLoanAmt);
    $('#CPIT_DOWN_PYMT_AMT').change(cpitCalcLoanAmt);


    $('#CPIT_PAYMENT_FREQ').change(CpitCalcNoPayments);
    $('#CPIT_LOAN_PERIOD').change(CpitCalcNoPayments);
    $('#CPIT_PERIOD_TYPE').change(CpitCalcNoPayments);
    $('#CPIT_LOAN_PERIOD').change(CpitCalcNoPayments);
    $('#CPIT_PRODUCT_CODE').change(CpitFindFeesNames);
    CpitFindFeesNames();

}
