<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author	   $Author: fsantana $
 * @copyright	Alenet, Inc.
 * @since		$Date:  12:18:50 -0400 (Mon, 16 May 2011) $
 * @version		$Rev: 2484 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Fiae {

    var $display = false;

    /**
     * Constructor
     * @param array [$procParameters]
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('FIAS', 'FIAE', 'PROD', 'PRAT', 'GLAC', 'AMDS', 'GLT1', 'JEHD', 'JELN', 'FIAT', 'JCBV', 'FILC', 'FILO', 'ACCO', 'COMP', 'FICO', 'GLCP', 'TTPA'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->today = xFormat::getNow('Y-m-d');
        $this->je_source = '';
    }

    /**
     * Initialice fiat form - Executed on init event
     *
     * @param unknown_type $record
     */
    function init_form(&$record) {
        if ((UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'DUPLICATE_EFFTDATE') && empty(UserRequest::$post['confirm'])) {
            $record['FIAE_CLX_EFFTDATE'] = $this->today;
            $callingpage = peekHistory();
            if (!empty($callingpage['parentrecord']['CRPR_COMP_CODE'])) {//loading proposal info
                $record['FIAE_COMP_CODE'] = $callingpage['parentrecord']['CRPR_COMP_CODE'];
                $record['FIAE_CHART_FIELD01'] = $callingpage['parentrecord']['CRPR_CHART_FIELD01'];
                $record['FIAE_CHART_FIELD01_prim'] = $callingpage['parentrecord']['CRPR_CHART_FIELD01_prim'];
                $record['FIAE_CHART_FIELD01_secd'] = $callingpage['parentrecord']['CRPR_CHART_FIELD01_secd'];
                $record['FIAE_CHART_FIELD01_terc'] = $callingpage['parentrecord']['CRPR_CHART_FIELD01_terc'];
                $accorec = ClxCommon::$db->getFields($this->acconame, 'IDCODE,IDNAME, IDENTIFICATION', 'IDCODE = ' . singleQuote($callingpage['parentrecord']['CRPR_CHART_FIELD02']));
                $record['FIAE_CHART_FIELD02'] = $accorec['IDCODE'];
                $record['FIAE_CHART_FIELD02_prim'] = $accorec['IDCODE'];
                $record['FIAE_CHART_FIELD02_secd'] = $accorec['IDNAME'];
                $record['FIAE_CHART_FIELD02_terc'] = $accorec['IDENTIFICATION'];
                $record['FIAE_CURRENCY_CODE'] = ClxCommon::$db->getField($this->compname, 'CURRENCY_CODE', 'IDCODE = ' . singleQuote($callingpage['parentrecord']['CRPR_COMP_CODE']));
            } elseif (!empty($callingpage['parentrecord']['FILO_COMP_CODE'])) {//The credit way
                $record['FIAE_COMP_CODE'] = $callingpage['parentrecord']['FILO_COMP_CODE'];
                $record['FIAE_CHART_FIELD01'] = $callingpage['parentrecord']['FILO_CONTRACT_CODE'];
                $record['FIAE_CHART_FIELD01_prim'] = $callingpage['parentrecord']['FILO_CONTRACT_CODE_prim'];
                $record['FIAE_CHART_FIELD01_secd'] = $callingpage['parentrecord']['FILO_CONTRACT_CODE_secd'];
                $record['FIAE_CHART_FIELD01_terc'] = $callingpage['parentrecord']['FILO_CONTRACT_CODE_terc'];
                $accorec = ClxCommon::$db->getFields($this->acconame, 'IDCODE,IDNAME, IDENTIFICATION', 'IDCODE = ' . singleQuote($callingpage['parentrecord']['FILO_PARTICIPANT_ID']));
                $record['FIAE_CHART_FIELD02'] = $accorec['IDCODE'];
                $record['FIAE_CHART_FIELD02_prim'] = $accorec['IDCODE'];
                $record['FIAE_CHART_FIELD02_secd'] = $accorec['IDNAME'];
                $record['FIAE_CHART_FIELD02_terc'] = $accorec['IDENTIFICATION'];
                $record['FIAE_CURRENCY_CODE'] = $callingpage['parentrecord']['FILO_CURRENCY_CODE'];
            }
        }
        if (UserRequest::$request['ac'] === 'DUPLICATE' && empty(UserRequest::$post['confirm'])) {
            $record['FIAE_CLX_EFFTDATE'] = $this->today;
            $record['FIAE_IDCODE'] = 'AUTO';
            $record['FIAE_CHART_FIELD03'] = '';
            $record['FIAE_CHART_FIELD03_prim'] = '';
            $record['FIAE_CHART_FIELD03_secd'] = '';
        }
        //Setting default Values
        //see fiae.js
        $ua = $record['FIAE_SIZE_LOT'] - $record['FIAE_SIZE_COMMON_AR'];
        $record['FIAE_SIZE_USABLE'] = rounder($ua, CLX_NUM_FOUR);
        $size = $record['FIAE_SIZE_LOT'];
        $price = $record['FIAE_PURCHASE_AMT'];
        $up = CLX_INIT_ZERO;
        if ($size != CLX_NUM_ZERO) {
            $up = $price / $size;
        }
        $record['FIAE_UNIT_COST'] = rounder($up, CLX_NUM_TWO);
        $up = CLX_INIT_ZERO;
        if ($ua <> CLX_NUM_ZERO) {
            $up = $price / $ua;
        }
        $record['FIAE_AVAIL_UNIT_COST'] = rounder($up, CLX_NUM_TWO);
    }

    /**
     * Initialice form - Executed on init event
     *
     * @param unknown_type $record
     */
    function load_form(&$record) {
        $this->init_form($record);
    }

    /**
     * Validate record information
     * Executed on table validate
     *
     * @param array $record
     * @param array $msg
     */
    function validate_form(&$record, &$msg) {
        if (($record['FIAE_VALORIZATION_METHOD'] == CLX_NUM_TWO) && (empty($record['FIAE_VAL_INS_TYPE']) || $record['FIAE_VAL_INS_TYPE'] == null)) {
            $msg['FIAE_VAL_INS_TYPE'] = smsg('MSG-463', $record['FIAE_VAL_INS_TYPE']);
            addMessage(smsg('MSG-463', $record['FIAE_VAL_INS_TYPE']));
        }
        if ($record['FIAE_VALORIZATION_METHOD'] != CLX_NUM_ZERO) {
            $sql = 'SELECT COUNT(PRAT.ID) QTY FROM GL_PROD_PRMTR_TBL PRAT WHERE PRAT.PRODUCT_CODE = ' . singleQuote($record['FIAE_PRODUCT_CODE']) . ' AND PRAT.VALOR_GL_CODE IS NOT null AND PRAT.VALOR_GL_CODE <> ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND PRAT.VALOR2_GL_CODE IS NOT null AND PRAT.VALOR2_GL_CODE <> ' . "''";
            $qty = ClxCommon::$db->getOneRecord($sql);
            if (trim($qty['QTY']) === '0') {
                $msg['FIAE_VALORIZATION_METHOD'] = smsg('MSG-431', $record['FIAE_VALORIZATION_METHOD']);
                addMessage(smsg('MSG-431', $record['FIAE_VALORIZATION_METHOD']));
            }
        }
        if ($record['FIAE_PRODUCT_CODE'] !== '') {
            $sql = 'SELECT COUNT(ATPR.ID) QTY FROM ATOM_PROD_PRMTS_TBL ATPR WHERE ATPR.PRODUCT_CODE = ' . singleQuote($record['FIAE_PRODUCT_CODE']) . ' AND ATPR.IS_ATOM_AF01 = 1';
            if (ClxCommon::$db->getOneRecord($sql) > CLX_NUM_ZERO && $record['FIAE_CRED_FACILITY_TYPE'] === '') {
                $msg['FIAE_CRED_FACILITY_TYPE'] = dict('GEN_ERR_REQUIRED_FIELD');
            }
        }
        if ($record['FIAE_USEFUL_LIFE'] > CLX_NUM_ZERO && $record['FIAE_USEFUL_LIFE_UNIT'] === '') {
            $msg['FIAE_USEFUL_LIFE_UNIT'] = dict('GEN_LBL_FIELD_REQUIRED');
        }
        $callingpage = peekHistory();
        if (!empty($callingpage['parentrecord']['FILO_COMP_CODE'])) {
            if ($callingpage['parentrecord']['FILO_COMP_CODE'] <> $record['FIAE_COMP_CODE']) {
                $msg['FIAE_COMP_CODE'] = smsg('MSG-317');
            }
        }
    }

    /**
     * Update Information one record is saved
     */
    function save_form(&$record) {
        //add fias to
        $this->build_fias($record);
    }

    /**
     * Update Information one record is saved
     */
    function save_form_post(&$record) {
        if (!class_exists('Amds'))
            includeCodeLib('AMDS');
        $amds = new Amds();
        $amds->build_depreciation($record['IDCODE'], $record['CLX_EFFTDATE']);
        unset($amds);
        //Adjust colateral information if exists
        $callingpage = peekHistory();
        if (!empty($callingpage['parentrecord']) && !empty($callingpage['parentrecord']['FILO_IDCODE'])) {
            $sql = 'SELECT FIAS.LOAN_CODE, FIAS.IDCODE, FIAS.CONTRACT_CODE FROM ' . $this->fiasname . ' FIAS WHERE FIAS.LOAN_CODE = ' . singleQuote($callingpage['parentrecord']['FILO_IDCODE']);
            $fiasrec = ClxCommon::$db->getOneRecord($sql);
            $filcr = array('LOAN_CODE' => $fiasrec['LOAN_CODE'],
                'ASSETCODE' => $record['IDCODE'],
                'COMP_CODE' => $record['COMP_CODE'],
                'CREDIT_RISK' => UserRequest::$post['FILC_CREDIT_RISK'],
                'FIAS_LOAN_CODE' => $fiasrec['IDCODE'],
                'FIAS_COLL_CODE' => $record['CHART_FIELD03'],
                'CLX_EFFTDATE' => $callingpage['parentrecord']['FILO_CLX_EFFTDATE'],
                'STATUS' => UserRequest::$post['FILC_STATUS'],
                'CREATEDBY' => $this->username, 'CDATE' => $this->now, 'MODIFIEDBY' => $this->username, 'MDATE' => $this->now);
            //LOAN_CODE, ASSETCODE, CLX_EFFTDATE
            $id = ClxCommon::$db->getField($this->filcname, 'ID', 'ASSETCODE = ' . singleQuote($filcr['ASSETCODE']) . ' AND LOAN_CODE = ' . singleQuote($filcr['LOAN_CODE']));
            if (empty($id)) {
                ClxCommon::$db->createRecord($this->filcname, $filcr, false);
            } else {
                unset($filcr['CREATEDBY'], $filcr['CDATE']);
                ClxCommon::$db->updateRecord($this->filcname, $filcr, 'ID = ' . $id);
            }
        }
    }

    /**
     * Delete record on delete.
     * @param array $record
     */
    function delete_record_post($record) {
        $sql = 'DELETE FROM ' . $this->amdsname . '  WHERE ASSETCODE = ' . singleQuote($record['IDCODE']) . ' AND EFFTDATE = ' . singleQuote($record['CLX_EFFTDATE']);
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     * Builds fias record for loan
     *
     * @param array $record
     */
    function build_fias(&$record) {
        //test if already exists
        $sql = 'SELECT COUNT(ID) FROM ' . $this->fiasname . ' WHERE ASSET_CODE = ' . singleQuote($record['IDCODE']);
        if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
            ClxCommon::$db->updateRecord($this->fiasname, array('CONTRACT_CODE' => $record['CHART_FIELD01']), 'ASSET_CODE =' . singleQuote($record['IDCODE']));
            $sql = 'UPDATE ' . $this->fiaename . ' FIAE SET FIAE.CHART_FIELD03 = (SELECT MAX(FIAS.IDCODE) FROM ' . $this->fiasname . ' FIAS WHERE FIAS.ASSET_CODE = FIAE.IDCODE AND FIAS.CONTRACT_CODE=' . singleQuote($record['CHART_FIELD01']) . ') WHERE FIAE.IDCODE = ' . singleQuote($record['IDCODE']);
            ClxCommon::$db->executeQuery($sql);
            return;
        }
        //search if default contract
        //set fias type
        $sql = 'SELECT GLAC.GL_TYPE, GLAC.TRUST_ITEM_TYPE FROM ' . $this->prodname . ' PROD, ' . $this->pratname . ' PRAT, ' . $this->glacname . ' GLAC WHERE GLAC.IDCODE = PRAT.PRO_GL_CODE AND GLAC.GLGROUP_CODE = PRAT.GLGROUP_CODE AND PRAT.PRODUCT_CODE = PROD.IDCODE AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND PRAT.PRODUCT_CODE = ' . singleQuote($record['PRODUCT_CODE']);
        $pratrec = ClxCommon::$db->getOneRecord($sql);
        if (empty($pratrec)) {
            $pratrec = array('GL_TYPE' => 'AS', 'TRUST_ITEM_TYPE' => 'RE');
        }
        if (array_key_exists('FIAE_CHART_FIELD01_prim', UserRequest::$post)) {
            getLookupValue('FIAE_CHART_FIELD01', 'CHART_FIELD01', UserRequest::$post);
        }
        //FIAE_PARTICIPANT_ID_prim
        if (array_key_exists('FIAE_CHART_FIELD02_prim', UserRequest::$post)) {
            getLookupValue('FIAE_CHART_FIELD02_prim', 'CHART_FIELD02', UserRequest::$post);
        }
        if (!empty(UserRequest::$post['FIAE_CHART_FIELD01'])) {
            $prgtrec['CHART_FIELD01'] = UserRequest::$post['FIAE_CHART_FIELD01'];
        }
        if (!empty(UserRequest::$post['FIAE_CHART_FIELD02'])) {
            $prgtrec['CHART_FIELD02'] = UserRequest::$post['FIAE_CHART_FIELD02'];
        }
        $r = array('ASSET_CODE' => $record['IDCODE'],
            'GL_TYPE' => $pratrec['GL_TYPE'],
            'CURRENCY_CODE' => $record['CURRENCY_CODE'],
            'TRUST_ITEM_TYPE' => 'BI',
            'CONTRACT_CODE' => ((!empty($prgtrec['CHART_FIELD01'])) ? $prgtrec['CHART_FIELD01'] : ''),
            'ACCOUNTCODE' => ((!empty($prgtrec['CHART_FIELD02'])) ? $prgtrec['CHART_FIELD02'] : ''),
            'IDNAME' => $record['IDNAME'],
            'FIDU_BANKACT_CODE' => 'null',
            'GUAR_CODE' => 'null',
            'IDCODE' => 'AUTO');
        if (empty($r['EXT_PRODUCT_CODE'])) {
            $r['EXT_PRODUCT_CODE'] = $record['IDCODE'];
        }
        if (!empty($r['CONTRACT_CODE'])) {
            if (!class_exists('Fias'))
                includeCodeLib('FIAS');
            $fias = new Fias();
            $fias->fias_build($r);
            unset($fias);
            $record['CHART_FIELD03'] = $r['IDCODE'];
            ClxCommon::$db->updateRecord($this->fiaename, array('CHART_FIELD03' => $record['CHART_FIELD03']), 'IDCODE = ' . singleQuote($record['IDCODE']));
        }
    }

    function build_fias_from_rec(&$record) {
        //	test if already exists
        $sql = 'SELECT COUNT(ID) FROM ' . $this->fiasname . ' WHERE ASSET_CODE = ' . singleQuote($record['IDCODE']);
        if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
            ClxCommon::$db->updateRecord($this->fiasname, array('CONTRACT_CODE' => $record['CHART_FIELD01'], 'ACCOUNTCODE' => $record['CHART_FIELD02']), 'ASSET_CODE =' . singleQuote($record['IDCODE']));
            return;
        }
        //search if default contract
        //set fias type
        $sql = 'SELECT GLAC.GL_TYPE, GLAC.TRUST_ITEM_TYPE FROM ' . $this->prodname . ' PROD, ' . $this->pratname . ' PRAT, ' . $this->glacname . ' GLAC WHERE GLAC.IDCODE = PRAT.PRO_GL_CODE AND GLAC.GLGROUP_CODE = PRAT.GLGROUP_CODE AND PRAT.PRODUCT_CODE = PROD.IDCODE AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND PRAT.PRODUCT_CODE = ' . singleQuote($record['PRODUCT_CODE']);
        $pratrec = ClxCommon::$db->getOneRecord($sql);
        if (empty($pratrec)) {
            $pratrec = array('GL_TYPE' => 'AS', 'TRUST_ITEM_TYPE' => 'RE');
        }
        $r = array('ASSET_CODE' => $record['IDCODE'],
            'GL_TYPE' => $pratrec['GL_TYPE'],
            'TRUST_ITEM_TYPE' => $pratrec['TRUST_ITEM_TYPE'],
            'CONTRACT_CODE' => $record['CHART_FIELD01'],
            'ACCOUNTCODE' => ((!empty($record['CHART_FIELD02'])) ? $record['CHART_FIELD02'] : ''),
            'IDNAME' => $record['IDNAME'],
            'FIDU_BANKACT_CODE' => 'null',
            'GUAR_CODE' => 'null',
            'IDCODE' => 'AUTO');
        if (empty($r['EXT_PRODUCT_CODE'])) {
            $r['EXT_PRODUCT_CODE'] = $record['IDCODE'];
        }
        if (!empty($r['CONTRACT_CODE'])) {
            if (!class_exists('Fias'))
                includeCodeLib('FIAS');
            $fias = new Fias();
            $fias->fias_build($r);
            unset($fias);
            $record['CHART_FIELD03'] = $r['IDCODE'];
            ClxCommon::$db->updateRecord($this->fiaename, array('CHART_FIELD03' => $record['CHART_FIELD03']), 'IDCODE = ' . singleQuote($record['IDCODE']));
        }
    }

    /**
     * Runs interest calculation from btn
     *
     */
    function run_depreciation_accounting_btn() {
        $idlist = getIdlist();
        if (empty($idlist))
            return;
        $sql = 'SELECT DISTINCT COMP_CODE, IDCODE FROM ' . $this->fiaename . ' WHERE ID IN (' . toString($idlist) . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while (($r = ClxCommon::$db->getNextRecord($rs, NUMERIC))) {
            $this->build_depreciation_accounting($r[CLX_NUM_ZERO], $r[CLX_NUM_ONE]);
        }
    }

    /**
     * Runs asset depreciation on closing
     * @param string $comp_code
     */
    function run_depreciation_cron($comp_code) {
        $this->display = true;
        $this->build_depreciation_accounting($comp_code);
    }

    /**
     * Proceso para devengar intereses de portafolio
     *
     * @param string $comp_code
     * @param string $asset_code
     */
    private function build_depreciation_accounting($comp_code, $asset_code = '') {
        //GLT1
        $this->je_source = 'AMGT.AMDS'; //provision de intereses de prestamos
        $DBLT = getTool('DBLT');
        $idname = $DBLT->getListItem('SOTY', $this->je_source);
        $idname = substr($idname, CLX_NUM_ZERO, CLX_NUM_60);
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        $comp = new Comp();
        $comprec = $comp->comp_operation_parameters($comp_code);
        $operation_date = $comprec['OPERATION_DATE'];
        if ($this->display === true) {
            echoLog(' ASSET DEPRECIATION PROCESS. BATCH ID: ' . $this->batch_id);
            echoLog('Efective date: ' . $operation_date);
            echoLog('Asset: ' . (($asset_code === '') ? 'ALL' : $asset_code));
        }
        if (empty($comprec) || empty($comp_code)) {
            echoLog('Error, no company operation parameters found');
        }
        //Init Temporary Tables
        $this->initTemporaryTables($this->batch_id);

        //loading temporary table
        $sql = ' INSERT INTO ' . $this->glt1name . ' (BATCH_ID, COMP_CODE, EFFTDATE, GLACCOUNTCODE, GL01_CODE, GL_TYPE, BALANCE_AMT, CALC_AMT_01, CALC_AMT_02, CALC_AMT_03, CALC_AMT_04, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, LOAN_CODE, PRODUCT_CODE) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, ' . singleQuote($comp_code) . ' COMP_CODE, FIAE.CLX_EFFTDATE EFFTDATE, PRAT.DPRAC_GL_CODE GLACCOUNTCODE, PRAT.DPR_GL_CODE GL01_CODE, MAX(JCBV.GL_TYPE) GL_TYPE, SUM(JCBV.BALANCE_AMT) BALANCE_AMT, AMDS.DEPRECIATION_AMT CALC_AMT_01, SUM(JCBV.BALANCE_AMT) CALC_AMT_02, 0 CALC_AMT_03, FIAE.SALVAGE_VALUE CALC_AMT_04, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, FIAE.CURRENCY_CODE, 1 CUR_OPERATOR, 1 EXCHANGE_RT, 0 DEBIT_AMT, 0 CREDIT_AMT, 0 DEBIT_TRANS_AMT, 0 CREDIT_TRANS_AMT, FIAE.IDCODE LOAN_CODE, FIAE.PRODUCT_CODE FROM ' . $this->fiaename . ' FIAE, ' . $this->amdsname . ' AMDS, ' . $this->fiasname . ' FIAS, ' . $this->jcbvname . ' JCBV, ' . $this->pratname . ' PRAT WHERE FIAE.IDCODE = FIAS.ASSET_CODE AND AMDS.ASSETCODE = FIAE.IDCODE AND AMDS.EFFTDATE = FIAE.CLX_EFFTDATE AND FIAS.IDCODE = JCBV.CHART_FIELD03 AND PRAT.PRODUCT_CODE = FIAE.PRODUCT_CODE AND JCBV.GLACCOUNTCODE IN (PRAT.PRO_GL_CODE, PRAT.VALOR_GL_CODE, PRAT.VALOR3_GL_CODE,PRAT.DPRAC_GL_CODE) AND FIAE.CURRENCY_CODE = JCBV.CURRENCY_CODE AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND AMDS.PERIOD_END_DATE = ' . singleQuote($operation_date) . ' AND FIAE.COMP_CODE = ' . singleQuote($comp_code) . ' ' . (($asset_code !== '') ? ' AND FIAE.IDCODE =' . singleQuote($asset_code) : '') . ' AND JCBV.BALANCE_AMT > FIAE.SALVAGE_VALUE AND AMDS.DEPRECIATION_AMT <>0 AND FIAE.CLX_EFFTDATE = (SELECT MAX(FIAE2.CLX_EFFTDATE) FROM ' . $this->fiaename . ' FIAE2 WHERE FIAE2.IDCODE = FIAE.IDCODE AND FIAE2.CLX_EFFTDATE<=' . singleQuote($this->now) . ') GROUP BY FIAE.CLX_EFFTDATE, PRAT.DPRAC_GL_CODE, PRAT.DPR_GL_CODE, AMDS.DEPRECIATION_AMT, FIAE.SALVAGE_VALUE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, FIAE.CURRENCY_CODE, FIAE.IDCODE, FIAE.PRODUCT_CODE';
        ClxCommon::$db->executeQuery($sql);

        /* AND AMDS.PERIOD_START_DATE <= '. singleQuote($operation_date).' AND AMDS.PERIOD_END_DATE >= '. singleQuote($operation_date).' */
        if (ClxCommon::$db->oneExistsRecords($this->glt1name, 'BATCH_ID = ' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
            return;
        }
        //Delete all participants where rows from overdraft loans. or cero that will not earn int.
        $sql = 'UPDATE ' . $this->glt1name . ' Y SET Y.CALC_AMT_03 = (SELECT IFNULL(SUM(X.BALANCE_AMT),0) FROM ' . $this->jcbvname . ' X WHERE X.CHART_FIELD03 = Y.CHART_FIELD03 AND X.CURRENCY_CODE = Y.CURRENCY_CODE) WHERE Y.BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //borrar todo lo que el saldo sea menor o igual al salvage
        $sql = 'DELETE FROM ' . $this->glt1name . ' WHERE CALC_AMT_03<= CALC_AMT_04 AND BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //verificando salvage value to preserve
        //CALC_AMT_04 salvage
        //CALC_AMT_01 depreciation amt
        //CALC_AMT_03 asset balance
        // depreciation = balance - salvage where salvage>
        $sql = 'UPDATE ' . $this->glt1name . ' SET CALC_AMT_01 = CALC_AMT_03-CALC_AMT_04 WHERE CALC_AMT_01 > (CALC_AMT_03-CALC_AMT_04) AND BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        /* COLOCANDO CONVERSIONES DE MONEDAS PARA ACTIVIDADES */
        $sql = 'SELECT DISTINCT CURRENCY_CODE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' ';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $rate = $comp->comp_current_exchange($comp_code, $r['CURRENCY_CODE'], $operation_date);
            $sql = 'UPDATE ' . $this->glt1name . ' SET CUR_OPERATOR = ' . singleQuote($rate['CUR_OPERATOR']) . ', EXCHANGE_RT = ' . singleQuote($rate['EXCHANGE_RT']) . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND CURRENCY_CODE = ' . singleQuote($r['CURRENCY_CODE']);
            ClxCommon::$db->executeQuery($sql);
        } //end while
        //Delete all participants where rows from overdraft loans. or cero that will not earn int.
        $sql = 'DELETE FROM ' . $this->glt1name . ' WHERE ((CALC_AMT_02<0 AND GL_TYPE = ' . singleQuote('AS') . ') OR (CALC_AMT_02>0 AND GL_TYPE <> ' . singleQuote('AS') . ') OR CALC_AMT_02 = 0) AND BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //Colocando monto total
        $sql = 'UPDATE ' . $this->glt1name . '  SET BALANCE_AMT = CALC_AMT_01, CALC_AMT_03 = CALC_AMT_01 WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //Colocando contabilidad
        $sql = 'UPDATE ' . $this->glt1name . ' SET DEBIT_TRANS_AMT = BALANCE_AMT, DEBIT_AMT = ROUND((BALANCE_AMT*POW(EXCHANGE_RT, CUR_OPERATOR)), 2) WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE = ' . singleQuote('AS') . '';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt1name . ' SET CREDIT_TRANS_AMT = BALANCE_AMT, CREDIT_AMT = ROUND((BALANCE_AMT*POW(EXCHANGE_RT, CUR_OPERATOR)), 2) WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE <> ' . singleQuote('AS') . '';
        ClxCommon::$db->executeQuery($sql);

        $sql = 'DELETE FROM ' . $this->glt1name . ' WHERE DEBIT_TRANS_AMT = 0 AND CREDIT_TRANS_AMT = 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);

        if (!class_exists('Jehd'))
            includeCodeLib('Jehd');
        $jehd = new Jehd();
        $jehd->display = $this->display;

        //Reject any posible todays entry from this process thas has run today
        $jehd->jehd_reverse_by_je_source($comp_code, $this->je_source, $operation_date);
        /* 2. GENERAR ACTIVIDADES DE DEVENGO PARA PARTICIPANTES DE CONTRATO */
        //Build Header for this process, one pre currency
        $sql = 'SELECT DISTINCT COMP_CODE, ' . singleQuote($operation_date) . ' OPERATION_DATE, ' . singleQuote($comprec['LGGROUP_CODE']) . ' LGGROUP_CODE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' ';
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            $gl_rec = $jehd->jehd_init_record();
            $gl_rec['IDNAME'] = $idname;
            $gl_rec['JE_SOURCE'] = $this->je_source;
            $gl_rec['LGGROUP_CODE'] = $result['LGGROUP_CODE'];
            $gl_rec['EFFTDATE'] = $result['OPERATION_DATE'];
            $gl_rec['COMP_CODE'] = $result['COMP_CODE'];
            $gl_rec['TRANS_CODE'] = null;
            $gl_rec['TRANSTBL_CODE'] = 'SYS_CRED-INTE';
            $gl_rec['REQ_CHANNEL'] = 'SYS';
            $gl_rec['BATCH_ID'] = $this->batch_id;
            $jehd->jehd_build($gl_rec);
            //Search any scale if apply and dump lines to journal
            //debit in credit as
            $sql = 'INSERT INTO ' . $this->jelnname . '  (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, DEBIT_AMT, CREDIT_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec['IDCODE']) . ' JEHDR_CODE, X.GL01_CODE GLACCOUNTCODE, ' . singleQuote('IP') . ' ITEM_CODE, X.CHART_FIELD01, X.CHART_FIELD02, X.CHART_FIELD03, X.CHART_FIELD04, X.LOAN_CODE ITEM_REF_NO, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR, X.DEBIT_TRANS_AMT, X.CREDIT_TRANS_AMT, X.DEBIT_AMT, X.CREDIT_AMT, 1 SEQNUM FROM ' . $this->glt1name . ' X WHERE X.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            //contraparte
            $sql = 'INSERT INTO ' . $this->jelnname . '  (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, DEBIT_AMT, CREDIT_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec['IDCODE']) . ' JEHDR_CODE, X.GLACCOUNTCODE GLACCOUNTCODE, ' . singleQuote('IP') . ' ITEM_CODE, X.CHART_FIELD01, X.CHART_FIELD02, X.CHART_FIELD03, X.CHART_FIELD04, X.LOAN_CODE ITEM_REF_NO, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR, X.CREDIT_TRANS_AMT DEBIT_TRANS_AMT, X.DEBIT_TRANS_AMT CREDIT_TRANS_AMT, X.CREDIT_AMT DEBIT_AMT, X.DEBIT_AMT CREDIT_AMT, 2 SEQNUM FROM ' . $this->glt1name . ' X WHERE X.BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            //Removing sub account from in,ex,eq
            $sql = 'UPDATE ' . $this->jelnname . ' JELN SET JELN.CHART_FIELD03 = null WHERE JELN.JEHDR_CODE = ' . singleQuote($gl_rec['IDCODE']) . ' AND EXISTS(SELECT GLAC.ID FROM ' . $this->glacname . ' GLAC WHERE GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLAC.GL_TYPE IN (' . singleQuote('IN') . ',' . singleQuote('EX') . ',' . singleQuote('EQ') . '))';
            ClxCommon::$db->executeQuery($sql);
            //Verificando conversion;
            $jehd->balance_exchange_rounding($gl_rec['IDCODE']);
            $jehd->jehd_approve_by_code($gl_rec['IDCODE']);
        }
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
    }

    /**
     * Initialice all temporary tables
     *
     * @param string $batch_id
     */
    private function initTemporaryTables($batch_id) {
        //Load temporary table - Req on mysql
        $DBTB = &getTool('DBTB');
        $DBTB->buildTemporaryTable('GLT1'); //Clear tmp
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($batch_id));
    }

}
