<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author	   $Author: fsantana $
 * @copyright	Alenet, Inc.
 * @since		$Date: 2016-10-20 14:57:18 -0400 (Thu, 20 Oct 2016) $
 * @version		$Rev: 8841 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class FiaeReports {

    var $display = false;

    /**
     * Constructor
     * @param array [$procParameters]
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('FIAS', 'FIAE', 'PROD', 'PRAT', 'GLAC', 'AMDS', 'GLT1', 'JEHD', 'JELN', 'FIAT', 'JCBV', 'FILC', 'FILO', 'ACCO', 'COMP', 'GLCP'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->today = xFormat::getNow('Y-m-d');
        $this->je_source = '';
    }

    /**
     * Download Report as PDF
     */
    function export_FIAE_VH_REP_PDF() {

        $limit = 'LIMIT 20000';

        $comp_code = '';
        if (!empty($_SESSION['paging']['FIAE_VH_REP_LIST']['qfilter']['FICO_COMP_CODE'])) {
            $comp_code = $_SESSION['paging']['FIAE_VH_REP_LIST']['qfilter']['FICO_COMP_CODE'];
        }
        $date = xFormat::getNow('Y-m-d');
        if (!empty($_SESSION['paging']['FIAE_VH_REP_LIST']['qfilter']['FICO_START_DATE'])) {
            $date = $_SESSION['paging']['FIAE_VH_REP_LIST']['qfilter']['FICO_START_DATE'];
            //Separando commas y eliminando porcientos
            $ndate = explode(',', str_replace('%', '', $date));
            if (empty($ndate[CLX_NUM_ZERO])) {
                $ndate = $date;
            } else {
                $ndate = explode('-', $ndate[CLX_NUM_ZERO]);
                if (!empty($ndate[CLX_NUM_ZERO]) && !empty($ndate[CLX_NUM_ONE])) {//%2003-02%
                    $ndate = $ndate[CLX_NUM_ZERO] . '-' . $ndate[CLX_NUM_ONE] . '-01';
                } elseif (!empty($ndate[CLX_NUM_ZERO]) && empty($ndate[CLX_NUM_ONE])) { //%02%
                    if (strlen($ndate[CLX_NUM_ZERO]) <= CLX_NUM_TWO && strlen($ndate[CLX_NUM_ZERO]) > CLX_NUM_ZERO) {
                        //just get the month
                        $ndate = '0000-' . $ndate[CLX_NUM_ZERO] . '-01';
                    }
                } elseif (empty($ndate[CLX_NUM_ZERO]) && !empty($ndate[CLX_NUM_ONE])) { //%-02
                    if (strlen($ndate[CLX_NUM_ONE]) <= CLX_NUM_TWO && strlen($ndate[CLX_NUM_ONE]) > CLX_NUM_ZERO) {
                        //just get the month
                        $ndate = '0000-' . $ndate[CLX_NUM_ONE] . '-01';
                    }
                }
            }
        } else {
            if (!empty($comp_code)) {
                $date = ClxCommon::$db->getField($this->glcpname, 'OPERATION_DATE', 'COMP_CODE = ' . singleQuote($comp_code));
            }
            $ndate = $date;
        }
        //buscando completar criterios de fechas alternativos
        if (empty($ndate))
            $ndate = $date;
        if (is_array($ndate)) {
            $ndate = implode('-', $ndate);
        }
        $ndate = explode('-', $ndate);
        if (empty($ndate[CLX_NUM_ONE]))
            $ndate[CLX_NUM_ONE] = '01';
        elseif (strlen($ndate[CLX_NUM_ONE]) === CLX_NUM_ONE)
            $ndate[CLX_NUM_ONE] = '0' . $ndate[CLX_NUM_ONE];
        //$date_lbl = uppercase(dict('UICA_LBL_MONTH_'.xFormat::date($date,'m')).' '.dict('GEN_LBL_OF') . ' '.xFormat::date($date,'Y'));
        $date_lbl = uppercase(dict('UICA_LBL_MONTH_' . $ndate[CLX_NUM_ONE]) . ' ' . dict('GEN_LBL_OF') . ' ' . $ndate[CLX_NUM_ZERO]);
        $DBQY = &getTool('DBQY');
        $OBJS = &getTool('OBJS');
        $listingrec = ClxCommon::$db->getRecord('CLX_UI_LISTINGS', 'IDCODE = ' . singleQuote('FIAE_VH_REP'));
        $queryrec = $DBQY->getquery('CODE', $listingrec['QUERYCODE']);
        $tableWidth = count($queryrec['COLUMNS']);
        $filter_criteria = $_SESSION['paging']['FIAE_VH_REP_LIST']['criteria'];
        //Include Filter Criteria to the sql
        if ($filter_criteria <> '')
            $queryrec['FROMWHERESORT'] = str_replace('WHERE', 'WHERE ' . $filter_criteria . ' AND ', $queryrec['FROMWHERESORT']);
        $this->InitReport();
        $styles = $this->build_consolidado_styles();

        ///NUEVO_REPORTE
        /*foreach($styles as $key=>$val){
            $styles[$key]->setBoxHeight(300);
        }*/
		ob_clean();
        $report = new pdf_table('L','mm','legal');
        $report->setMargin(array(CLX_NUM_ZERO=>array(  'margin_left'=>CLX_NUM_SIX,           'margin_right'=>CLX_NUM_SIX,          'margin_left_header'=>CLX_NUM_SIX,
                                            'margin_right_header'=>CLX_NUM_SIX,   'margin_left_footer'=>CLX_NUM_SIX,    'margin_right_footer'=>CLX_NUM_SIX)));
        //ALINEACION
        $alignencabezado=array('C');
        $aligncolumnas1=array_fill(CLX_NUM_ZERO,CLX_NUM_18,'L');//DATA
        $aligncolumnas1[CLX_NUM_7]='C';
        $aligncolumnas1[CLX_NUM_8]='C';
        $aligncolumnas1[CLX_NUM_NINE]='R';
        $aligncolumnas1[CLX_NUM_13]='C';
        $aligncolumnas2=array_fill(CLX_NUM_ZERO,CLX_NUM_18,'C'); //TITULO COLUMNA
        $report->FontSize=CLX_NUM_8;
        $fuentecolumna=array();
        $fuentecolumnatitle=array();
        $fieldinstances = array();
        $titles=array();
        $total=CLX_NUM_ZERO;

        $columna=-CLX_NUM_ONE;
        $init=true;
        //creacion de estilos pdf_table
        $tiposestilos=array('tbhead','data','datanum','head','head2','head3','total');
        $fuenteestilos=Array();
        foreach ($tiposestilos as $key) {

            $fuenteestilos[$key]= array('estilo'=>'B',
                                                    'letra'=>$styles [$key]->getFontFace(),
                                                    'tamano'=>$styles [$key]->getFontSize(),
                                                    'cR'=> hexdec(substr($styles [$key]->getFontColor(),CLX_NUM_ZERO,CLX_NUM_TWO)),
                                                    'cG'=> hexdec(substr($styles [$key]->getFontColor(),CLX_NUM_TWO,CLX_NUM_TWO)),
                                                    'cB'=> hexdec(substr($styles [$key]->getFontColor(),CLX_NUM_FOUR,CLX_NUM_TWO)),
                                                    'fR'=> hexdec(substr($styles [$key]->getBoxBgColor(),CLX_NUM_ZERO,CLX_NUM_TWO)),
                                                    'fG'=> hexdec(substr($styles [$key]->getBoxBgColor(),CLX_NUM_TWO,CLX_NUM_TWO)),
                                                    'fB'=> hexdec(substr($styles [$key]->getBoxBgColor(),CLX_NUM_FOUR,CLX_NUM_TWO))
                                    );
        }

        //ANCHOS DE COLUMNA
        $columnasdata=array(
                    CLX_NUM_16, /*PERIODO*/                               CLX_NUM_24, /*NOMBRE CORTO*/
                    CLX_NUM_15, /*NÚMERO DE CONTRATO*/                    CLX_NUM_14, /*CODIGO*/
                    CLX_NUM_26, /*Nº DE FINANCIAMIENTO*/                  CLX_NUM_26, /*FIDEICOMISANTE*/
                    CLX_NUM_19, /*CEDULA*/                                CLX_NUM_19, /*FECHA DE INICIO DE LA OBLIGACION*/
                    CLX_NUM_22, /*VENCIMIENTO DE LA OBLIGACION*/          CLX_NUM_24, /*VALOR INICIAL DE LA GARANTIA*/
                    CLX_NUM_19, /*FABRICANTE O MARCA*/                    CLX_NUM_16, /*MODELO */
                    CLX_NUM_16, /*COLOR */                                CLX_NUM_16, /*AÑO DEL VEHICULO*/
                    CLX_NUM_16, /*POLIZA DEL SEGURO*/                     CLX_NUM_16, /*RENOVACION DE LA POLIZA*/
                    CLX_NUM_16, /*MATRICULA*/                             CLX_NUM_20); /*MES DE RENOVACION*/
        $columnasencabezado=array(array_sum($columnasdata));

        //SALTOS DE LINEAS PARA EL TITULO EN COLOR
        $rellenostitle=array(  str_repeat(CLX_CHAR_NL,CLX_NUM_THREE),   str_repeat(CLX_CHAR_NL,CLX_NUM_THREE),                                      '',
                               str_repeat(CLX_CHAR_NL,CLX_NUM_THREE),   str_repeat(CLX_CHAR_NL,CLX_NUM_TWO  ),   str_repeat(CLX_CHAR_NL,CLX_NUM_THREE),
                               str_repeat(CLX_CHAR_NL,CLX_NUM_THREE),                                      '',                                      '',
                                                                  '',   str_repeat(CLX_CHAR_NL,CLX_NUM_TWO  ),   str_repeat(CLX_CHAR_NL,CLX_NUM_THREE),
                               str_repeat(CLX_CHAR_NL,CLX_NUM_THREE),   str_repeat(CLX_CHAR_NL,CLX_NUM_TWO  ),   str_repeat(CLX_CHAR_NL,CLX_NUM_TWO  ),
                               str_repeat(CLX_CHAR_NL,CLX_NUM_TWO),     str_repeat(CLX_CHAR_NL,CLX_NUM_THREE),                                      '');
        if (empty($fieldinstances)) {
            foreach ($queryrec['COLUMNS'] as $k => $v) {
                $fieldinstances[$v ['FIELDTYPE']] = getToolObject('DBFT', $v ['FIELDTYPE']);
                $fieldinstances[$v ['FIELDTYPE']]->set_obj_cache($v);
                $fuentecolumna[]= $fuenteestilos[ ($v['FIELDTYPE'] === 'DECN' || $v['FIELDTYPE'] === 'INTN') ?      'datanum': CLX_CLASS_DATA];//STYLE DATA
                $titles[]=decode_string(dict($v['FIELDLISTLABEL'])).$rellenostitle[++$columna];//TITLE string
            }
        } //IMPRESION TITLE y ENCABEZADO

        //Titulos
        $report->AddPage('L');
        $report->SetWidths($columnasencabezado);
        $report->SetAligns($alignencabezado);
        $report->row1(array(uppercase(dict('0BEDC3EA55A71148DE716239FF8A7AE0'))), false,false, CLX_NUM_ONE, true, array($fuenteestilos['head'])  );
        $report->row1(array($date_lbl), false,false, CLX_NUM_ONE, true, array($fuenteestilos['head2'])  );
        $report->row1(array(dict('DICT_FIAE_VH_REP_TITLE4')), false,false, CLX_NUM_ONE, true, array($fuenteestilos['head3'])  );
        $report->row1(array(''),  false,false, CLX_NUM_ONE, true, array($fuenteestilos['head3'])  );
        $report->row1(array(''),  false,false, CLX_NUM_ONE, true, array($fuenteestilos['head3'])  );

        $fontsize = CLX_NUM_NINE;

        //table titles
        $report->SetWidths($columnasdata);
        $report->SetAligns($aligncolumnas2);
        $report->SetLineWidth(CLX_NUM_0_PT_05);
        //encabezado de tabla
        $report->SetFont($fuenteestilos['tbhead']['letra'], $fuenteestilos['tbhead']['estilo'], $fontsize);
        $report->SetFillColor($fuenteestilos['tbhead']['fR'],$fuenteestilos['tbhead']['fG'],$fuenteestilos['tbhead']['fB']);
        $report->SetDrawColor(CLX_NUM_ZERO, CLX_NUM_ZERO, CLX_NUM_ZERO);
        $report->row($titles,true);
        $report->SetFont($fuenteestilos['tbhead']['letra'], '', $fontsize);
        $report->SetAligns($aligncolumnas1);



        //$report->SetFont(0, 0, 0);
        $report->SetFillColor(CLX_NUM_255, CLX_NUM_255, CLX_NUM_255);

        //ESCRITURA DEL REPORTE
        $sql = 'SELECT ' . $queryrec['SELECTCLAUSE'] . ' ' . $queryrec['FROMWHERESORT'].' '.$limit;
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $data=array();
            foreach ($queryrec['COLUMNS'] as $k => $v) {
                $data[]= decode_string(($v ['FIELDTYPE']=='LOOK') ? $r[$k] :str_replace(array(CLX_CHAR_NL, CLX_CHAR_CR), '', $fieldinstances[$v ['FIELDTYPE']]->placeListFieldText($k, $v, $r, false,1)));
                //$data[]= decode_string($r[$k]);
            }
            //IMPRESION DE DATA
            $data[CLX_NUM_FIVE]=ucwords(lowercase(str_replace(",",", ",$data[CLX_NUM_FIVE])));
            $data[CLX_NUM_ONE]=ucwords(lowercase(str_replace(",",", ",$data[CLX_NUM_ONE])));
            $data[CLX_NUM_11]=ucwords(lowercase(str_replace(",",", ",$data[CLX_NUM_11])));
            $data[CLX_NUM_12]=ucwords(lowercase(str_replace(",",", ",$data[CLX_NUM_12])));
            //$report->row1($data,false,false, CLX_NUM_ONE, true, $fuentecolumna );
            if($report->RowHasPageBreak($data)){
                $report->CheckPageBreakAddPage();
                $report->SetAligns($aligncolumnas2);
                $report->SetFont($fuenteestilos['tbhead']['letra'], $fuenteestilos['tbhead']['estilo'], $fontsize);
                $report->SetFillColor($fuenteestilos['tbhead']['fR'],$fuenteestilos['tbhead']['fG'],$fuenteestilos['tbhead']['fB']);
                $report->SetDrawColor(CLX_NUM_ZERO, CLX_NUM_ZERO, CLX_NUM_ZERO);
                $report->row($titles,true);
                $report->SetFont($fuenteestilos['tbhead']['letra'], '', $fontsize);
                $report->SetFillColor(CLX_NUM_255, CLX_NUM_255, CLX_NUM_255);
                $report->SetAligns($aligncolumnas1);
            }
            $report->row($data,true);
            $total +=$r['FIAE_GUARANTEE_INITVAL_WRK'];
        }
        //total
        $data=array_fill(CLX_NUM_ZERO, CLX_NUM_18,'');
        $data[CLX_NUM_ONE]=dict('GEN_LBL_TOTAL') . ': ';
        $data[CLX_NUM_NINE]=clx_format_currency($total, CLX_NUM_TWO);
        //$report->row1($data,true,false, CLX_NUM_ONE, true, array_fill(0, 18,$fuenteestilos['total']) );
        $report->SetAligns($aligncolumnas1);
        $report->SetFont($fuenteestilos['total']['letra'], $fuenteestilos['total']['estilo'], $fontsize);
        $report->SetFillColor($fuenteestilos['total']['fR'],$fuenteestilos['total']['fG'],$fuenteestilos['total']['fB']);
        $report->row($data, true);
        $report->close();
        return $report->Output('AUT_'.microtime_float().'.pdf','S');

    }
    function export_FIAE_VH_REP($report_format = 'pdf') {

        ini_set('memory_limit','300M');

        $ANRJ = &getTool('ANRJ');
        if ($report_format == 'pdf') {
            $ANRJ->setBatchGeneral('rep_auto.pdf', 'pdf', UserRequest::$post);
            return $this->export_FIAE_VH_REP_PDF();
        }
        $ANRJ->setBatchGeneral('rep_auto.xls', 'xls', UserRequest::$post);
        $limit = ' LIMIT 20000';

        $comp_code = '';
        if (!empty($_SESSION['paging']['FIAE_VH_REP_LIST']['qfilter']['FICO_COMP_CODE'])) {
            $comp_code = $_SESSION['paging']['FIAE_VH_REP_LIST']['qfilter']['FICO_COMP_CODE'];
        }
        $date = xFormat::getNow('Y-m-d');
        if (!empty($_SESSION['paging']['FIAE_VH_REP_LIST']['qfilter']['FICO_START_DATE'])) {
            $date = $_SESSION['paging']['FIAE_VH_REP_LIST']['qfilter']['FICO_START_DATE'];
            //Separando commas y eliminando porcientos
            $ndate = explode(',', str_replace('%', '', $date));
            if (empty($ndate[CLX_NUM_ZERO])) {
                $ndate = $date;
            } else {
                $ndate = explode('-', $ndate[CLX_NUM_ZERO]);
                if (!empty($ndate[CLX_NUM_ZERO]) && !empty($ndate[CLX_NUM_ONE])) {//%2003-02%
                    $ndate = $ndate[CLX_NUM_ZERO] . '-' . $ndate[CLX_NUM_ONE] . '-01';
                } elseif (!empty($ndate[CLX_NUM_ZERO]) && empty($ndate[CLX_NUM_ONE])) { //%02%
                    if (strlen($ndate[CLX_NUM_ZERO]) <= CLX_NUM_TWO && strlen($ndate[CLX_NUM_ZERO]) > CLX_NUM_ZERO) {
                        //just get the month
                        $ndate = '0000-' . $ndate[CLX_NUM_ZERO] . '-01';
                    }
                } elseif (empty($ndate[CLX_NUM_ZERO]) && !empty($ndate[CLX_NUM_ONE])) { //%-02
                    if (strlen($ndate[CLX_NUM_ONE]) <= CLX_NUM_TWO && strlen($ndate[CLX_NUM_ONE]) > CLX_NUM_ZERO) {
                        //just get the month
                        $ndate = '0000-' . $ndate[CLX_NUM_ONE] . '-01';
                    }
                }
            }
        } else {
            if (!empty($comp_code)) {
                $date = ClxCommon::$db->getField($this->glcpname, 'OPERATION_DATE', 'COMP_CODE = ' . singleQuote($comp_code));
            }
            $ndate = $date;
        }
        //buscando completar criterios de fechas alternativos
        if (empty($ndate))
            $ndate = $date;
        if (is_array($ndate)) {
            $ndate = implode('-', $ndate);
        }
        $ndate = explode('-', $ndate);
        if (empty($ndate[CLX_NUM_ONE]))
            $ndate[CLX_NUM_ONE] = '01';
        elseif (strlen($ndate[CLX_NUM_ONE]) === CLX_NUM_ONE)
            $ndate[CLX_NUM_ONE] = '0' . $ndate[CLX_NUM_ONE];
        //$date_lbl = uppercase(dict('UICA_LBL_MONTH_'.xFormat::date($date,'m')).' '.dict('GEN_LBL_OF') . ' '.xFormat::date($date,'Y'));
        $date_lbl = uppercase(dict('UICA_LBL_MONTH_' . $ndate[CLX_NUM_ONE]) . ' ' . dict('GEN_LBL_OF') . ' ' . $ndate[CLX_NUM_ZERO]);
        $DBQY = &getTool('DBQY');
        $OBJS = &getTool('OBJS');
        $listingrec = ClxCommon::$db->getRecord('CLX_UI_LISTINGS', 'IDCODE = ' . singleQuote('FIAE_VH_REP'));
        $queryrec = $DBQY->getquery('CODE', $listingrec['QUERYCODE']);
        $tableWidth = count($queryrec['COLUMNS']);
        $filter_criteria = $_SESSION['paging']['FIAE_VH_REP_LIST']['criteria'];
        //Include Filter Criteria to the sql
        if ($filter_criteria <> '')
            $queryrec['FROMWHERESORT'] = str_replace('WHERE', 'WHERE ' . $filter_criteria . ' AND ', $queryrec['FROMWHERESORT']);
        $this->InitReport();
        $styles = $this->build_consolidado_styles();
        //Build Header
        //$report = new clx_report('L', 'mm', array(600, 1390));
        //$report = new clx_report('L', 'mm', array(700, 1500));
        if($report_format=='pdf'){
            $report = new clx_report('L', 'mm', array(210, 450));
        }else{
            $report = new clx_report('L', 'mm', 'letter');
        }

        //$report = new clx_report('L', 'mm', 'letter');
        $page = new clx_report_page ();
        $page->setMarginTop(CLX_NUM_TEN);
        $styles ['head']->setBoxColSpan($tableWidth);
        $styles ['head2']->setBoxColSpan($tableWidth);
        $styles ['head3']->setBoxColSpan($tableWidth);
        $styles ['head']->setBoxHeight(14);
        $styles ['head2']->setBoxHeight(14);
        $styles ['head3']->setBoxHeight(14);
        //$styles ['tbhead']->setBoxHeight();
        if($report_format=='pdf'){

            /*$styles['tbhead']->setBoxWidth(100);
            $styles['data']->setBoxWidth(100);
            $styles['datanum']->setBoxWidth(100);*/
            /*foreach($styles as $key => $val){
                $styles[$key]->setBoxHeight(20);
            }*/
        }

        $page->setHeader(new clx_report_data(uppercase(dict('0BEDC3EA55A71148DE716239FF8A7AE0')), $styles ['head'], -1, -1, false, true)); //0BEDC3EA55A71148DE716239FF8A7AE0=Fideicomisos de Garantias Autos
        $page->setHeader(new clx_report_data($date_lbl, $styles ['head2'], -1, -1, false, true));
        $page->setHeader(new clx_report_data(dict('DICT_FIAE_VH_REP_TITLE4'), $styles ['head3'], -1, -1, false, true));
       // $logo_filename = $this->comp_logo($comp_code, ($report_format === 'html') ? false : true);
        //$report->setReplogo($logo_filename, CLX_NUM_TEN, CLX_NUM_TEN, CLX_NUM_36_PT_5, CLX_NUM_24_PT_6);
        $page->setHeader(new clx_report_data('', $styles ['head3'], -1, -1, false, true));
          //Adding Columns
        $fieldinstances = array();
        $table = new clx_report_object_table ();

        foreach ($queryrec['COLUMNS'] as $k => $v) {
            $fieldinstances[$v ['FIELDTYPE']] = getToolObject('DBFT', $v ['FIELDTYPE']);
            $fieldinstances[$v ['FIELDTYPE']]->set_obj_cache($v);
            if($report_format=='pdf'){
                $table->addColumn(new clx_report_data(decode_string(dict($v['FIELDLISTLABEL'])), $styles ['tbhead']));
            }else{
                $table->addColumn(new clx_report_data(dict($v['FIELDLISTLABEL']), $styles ['tbhead']));
            }
        }


        //Adjust some columns sizes
        if($report_format=='pdf'){
            $table->setColumnWidth(CLX_NUM_ZERO, CLX_NUM_15);
            $table->setColumnWidth(CLX_NUM_ONE, CLX_NUM_60);
            $table->setColumnWidth(CLX_NUM_THREE, CLX_NUM_15);
            $table->setColumnWidth(CLX_NUM_FOUR, CLX_NUM_25);
            $table->setColumnWidth(CLX_NUM_FIVE, CLX_NUM_55);
            $table->setColumnWidth(CLX_NUM_14, CLX_NUM_22);
        }
        $styles ['group']->setBoxColSpan(count($queryrec['COLUMNS']));
        $total = CLX_INIT_ZERO;
        $class = CLX_CLASS_DATA;
        $i = CLX_NUM_ZERO;
        $sql = 'SELECT ' . $queryrec['SELECTCLAUSE'] . ' ' . $queryrec['FROMWHERESORT'].' '.$limit;
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {

            foreach ($queryrec['COLUMNS'] as $k => $v) {
                if ($r[$k] === ''){
                    $r[$k] = ' ';
                }
                $v['NOCODES'] = 1;
                if($v ['FIELDTYPE']<>'LOOK'){
                    $val = str_replace(array(CLX_CHAR_NL, CLX_CHAR_CR), '', $fieldinstances[$v ['FIELDTYPE']]->placeListFieldText($k, $v, $r, false,1));
                }else{
                    $val = $r[$k];
                }
                 if($report_format=='pdf'){
                     $val = decode_string($val);
                 }

                //Some format for the numbers
                if ($v['FIELDTYPE'] === 'DECN' || $v['FIELDTYPE'] === 'INTN') {
                    $class = 'datanum';
                } else {
                    //$class = ($i % 2 == 0) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT;
                    $class = CLX_CLASS_DATA;
                }

                $table->addRow(new clx_report_data($val, $styles [$class]));
                if ($k === 'FIAE_GUARANTEE_INITVAL_WRK'){
                    $total += $r[$k];
                }
            }

            //$class = ($i % 2 == 0) ? CLX_CLASS_DATAALT : CLX_CLASS_DATA;
            $class = CLX_CLASS_DATA;
            $i++;
        }

        //Adding totals
        for ($i = CLX_INIT_ZERO; $i < $tableWidth; $i++) {
            if ($i == CLX_NUM_ONE) {
                $table->addRow(new clx_report_data(dict('GEN_LBL_TOTAL') . ': ', $styles ['total']));
            } elseif ($i == CLX_NUM_NINE) {
                $table->addRow(new clx_report_data(clx_format_currency($total, CLX_NUM_TWO), $styles ['total']));
            } else {
                $table->addRow(new clx_report_data('', $styles ['total']));
            }
        }

        $page->addPanel(new clx_report_panel($table));
        $report->addPage($page);
        return $report->source2($report_format, false);

    }

    private function InitReport() {
        require_once kPathToWebSite . kPathToPear . 'Spreadsheet/Excel/Writer.php';
        include_once kPathToWebSite.kPathToFpdf . 'fpdf.php';
        include_once 'classes/clx_report.php';
        include_once 'classes/clx_report_page.php';
        include_once 'classes/clx_report_panel.php';
        include_once 'classes/clx_report_object.php';
        include_once 'classes/clx_report_object_table.php';
        include_once 'classes/clx_report_data.php';
        include_once 'classes/clx_style.php';
    }

    function build_consolidado_styles() {
        $styles = array();
        $styles ['all'] = new clx_style('all');
        $styles ['all']->setFontSize(CLX_NUM_8);
        $styles ['all']->setBoxHeight(CLX_NUM_20);
        $styles ['all']->setBoxPadding(CLX_NUM_ZERO);
        $styles ['all']->setBoxWidth(CLX_NUM_ZERO);
        //$styles ['all']->setBoxBorderColor('ffffff');
        //$styles ['all']->setBoxBgColor('ffffff');
        //$styles ['all']->setBoxWidth (80); //pdf maby
        $styles ['all']->setFontColor('000000');
        $styles ['group'] =$styles ['all']->copyStyle('group');
        $styles ['group']->setBoxBgColor('eeeeee');
        $styles ['group']->setFontBold();
        $styles [CLX_CLASS_DATA] = $styles ['all']->copyStyle('data');
        //$styles [CLX_CLASS_DATA]->setBoxWidth ( 155 );
        $styles [CLX_CLASS_DATA]->setBoxBorder(CLX_NUM_ONE, 'all');
        $styles [CLX_CLASS_DATA]->setBoxBorderColor('black');
        $styles [CLX_CLASS_DATAALT] = $styles ['all']->copyStyle(CLX_CLASS_DATAALT);

        //$styles [CLX_CLASS_DATAALT]->setBoxBgColor('aaaaaa');
        //$styles [CLX_CLASS_DATAALT]->setBoxWidth ( 155 );
        $styles [CLX_CLASS_DATAALT]->setBoxBorder(CLX_NUM_ONE, 'all');
        $styles [CLX_CLASS_DATAALT]->setBoxBorderColor('ffffff');
        $styles ['datanum'] = $styles [CLX_CLASS_DATA]->copyStyle('datanum');
        $styles ['datanum']->setFontAligment(CLX_PROP_RIGHT);
        $styles ['dataaltnum'] = $styles [CLX_CLASS_DATAALT]->copyStyle('dataaltnum');
        $styles ['dataaltnum']->setFontAligment(CLX_PROP_RIGHT);
        $styles ['total'] = $styles ['all']->copyStyle('total');
        //$styles [CLX_CLASS_DATAALT]->setBoxWidth ( 155 );
        $styles ['total']->setBoxBgColor('bbbbbb');
        $styles ['total']->setFontBold();
        //$styles ['total']->setFontSize(CLX_NUM_TEN);
        $styles ['total']->setFontAligment(CLX_PROP_RIGHT);
        $styles ['total']->setBoxBorder(CLX_NUM_ONE, 'all');
        //$styles ['total']->setBoxBorderColor('ffffff');
        $styles ['tbhead'] = $styles [CLX_CLASS_DATA]->copyStyle('tbhead');
        $styles ['tbhead']->setFontBold();
        $styles ['tbhead']->setBoxBorder(CLX_NUM_ONE, 'all');
        $styles ['tbhead']->setBoxBorderColor('black');
        $styles ['tbhead']->setBoxBgColor('bbbbbb');
        $styles ['tbhead']->setBoxHeight(CLX_NUM_60);
        $styles ['tbhead']->setFontSize(CLX_NUM_TEN);
        $styles ['tbheaddesc'] = $styles ['tbhead']->copyStyle('tbheaddesc');
        $styles ['tbheaddesc']->setBoxWidth ( 100 );


        $styles ['head'] = $styles ['all']->copyStyle('head');
        //$styles ['head']->setBoxColSpan(3);
        $styles ['head']->setFontAligment('center');
        $styles ['head']->setFontBold();
        $styles ['head']->setFontSize(CLX_NUM_12);
        $styles ['head']->setBoxHeight(CLX_NUM_40);
        $styles ['head2'] = $styles ['head']->copyStyle('head2');
        $styles ['head2']->setFontSize(CLX_NUM_TEN);
        $styles ['head3'] = $styles ['head']->copyStyle('head3');
        $styles ['head3']->setFontSize(CLX_NUM_8);
        $styles ['head3']->setFontNormal();
        $styles ['footer'] = $styles ['all']->copyStyle('footer');

        return $styles;
    }

    /**
     * Description
     *
     * @return string
     */
    private function comp_logo($comp_code, $filename_only = true) {
        $return = '';
        $comprec = ClxCommon::$db->getRecord($this->compname, 'IDCODE = ' . singleQuote($comp_code));
        if (empty($comprec))
            return CLX_CHAR_EMPTY_STRING;
        $OBJS = &getTool('OBJS');
        $fieldinstance = $OBJS->getObject_('DBFT', 'FILE');
        if (empty($filename_only)) {
            $fieldrec = ClxCommon::$db->getRecord('CLX_DB_FIELDS', 'FIELDNAME=' . singleQuote('COMP_LOGO'));
            $return = $fieldinstance->formatField('COMP_LOGO', $fieldrec, $comprec);
        } else {
            $return = $fieldinstance->fileName($comprec['COMP_LOGO']);
        }
        return $return;
    }

}
