/**
 * Performs interest field calculations
 */
function filoCalcInterestAmt() {
    var int_type = $('#FILO_INTEREST_TYPE').val();
    if (int_type == 'VAR') {

        var int_adj_amt = parseFloat($('#FILO_ADJ_POINTS_OVERINDEX').val());
        var int_amt = parseFloat($('#FILO_INDEX_RATE').val());
        var t = int_adj_amt + int_amt;
        var capy = parseFloat($('#FILO_ADJ_CAPPOINTS_LIFE').val());
        var capl = parseFloat($('#FILO_ADJ_CAPPOINTS_YEAR').val());
        if (capy > 0 && t > capy) {
            t = capy;
        }
        if (capl > 0 && t > capl) {
            t = capl;
        }
        $('#FILO_LOAN_INTEREST').val(t);
    } else {
        $('#FILO_INDEX_RATE').val(0);
        $('#FILO_ADJ_POINTS_OVERINDEX').val(0);
        $('#FILO_ADJ_CAPPOINTS_LIFE').val(0);
        $('#FILO_ADJ_CAPPOINTS_YEAR').val(0);
        $('#FILO_ADJ_PATTERN').val('');
        $('#FILO_ADJ_INDEX').val('N/A');
        /*$('#FILO_RESERVE_INDEX').val('N/A');
         $('#FILO_RESERVE_INDX_PCT').val(numDec((0),5));
         $('#FILO_RESERVE_PCT').val(numDec((0),5));*/
    }

    $('#FILO_LOAN_INTEREST').val(numDec($('#FILO_LOAN_INTEREST').val(), 5));
    $('#FILO_ADJ_POINTS_OVERINDEX').val(numDec($('#FILO_ADJ_POINTS_OVERINDEX').val(), 5));
    $('#FILO_INDEX_RATE').val(numDec($('#FILO_INDEX_RATE').val(), 5));
    $('#FILO_ADJ_CAPPOINTS_LIFE').val(numDec($('#FILO_ADJ_CAPPOINTS_LIFE').val(), 5));
    $('#FILO_ADJ_CAPPOINTS_YEAR').val(numDec($('#FILO_ADJ_CAPPOINTS_YEAR').val(), 5));

    //Calculate reseves
    FiloCalculeReserRates();
}//end function

/**
 * Updates rates base on index via ajax
 */
function FiloFindRates() {

    $('#FILO_INTEREST_TYPE').val('VAR');
    $('#FILO_LOAN_INTEREST').val(numDec(0, 5));
    var indx = $('#FILO_ADJ_INDEX').val();
    if (indx == 'N/A') {
        $('#FILO_INDEX_RATE').val(numDec(0, 5));
        filoCalcInterestAmt();
    } else {
        $.ajax({type: 'GET',
            url: 'window.php?to=DBQY&ac=QXML&no_menu=1&no_alerts=1&qy=INDX_JS&fn[]=INDX.ADJ_INDEX&fv[]=' + indx
                    + '&fn[]=GLCP.COMP_CODE&fv[]=' + $('#FILO_COMP_CODE').val(),
            dataType: 'xml',
            success: function (xml) {
                $(xml).find('INDX_JS').each(function () {
                    var self = this;
                    var index_rate = parseFloat($(self).find('INDX_INDEX_RATE_WRK').text());
                    $('#FILO_INDEX_RATE').val(numDec(index_rate, 5));
                    filoCalcInterestAmt();
                });
            }
        });
    }
}//end function


/**
 * Localiza el monto de interes para reserva
 */
function FiloFindReserRates() {

    var indx = $('#FILO_RESERVE_INDEX').val();
    var inter = parseFloat($('#FILO_LOAN_INTEREST').val());
    if (indx == 'N/A') {
        $('#FILO_RESERVE_INDX_PCT').val(numDec((0), 5));
        $('#FILO_RESERVE_PCT').val(numDec((0), 5));
    } else {
        $.ajax({type: 'GET',
            url: 'window.php?to=DBQY&ac=QXML&no_menu=1&no_alerts=1&qy=INDX_JS&fn=INDX.ADJ_INDEX&fv=' + indx,
            dataType: 'xml',
            success: function (xml) {
                $(xml).find('INDX_JS').each(function () {
                    var self = this;
                    var index_rate = parseFloat($(self).find('INDX_INDEX_RATE_WRK').text());
                    $('#FILO_RESERVE_PCT').val(numDec((inter - index_rate), 5));
                    $('#FILO_RESERVE_INDX_PCT').val(numDec((index_rate), 5));
                    //FiloCalculeReserRates()
                });
            }
        });
    }
}//end function

/**
 * Calculates Index Rate
 */
function FiloCalculeReserRates() {
    var inter = parseFloat($('#FILO_LOAN_INTEREST').val());
    var res = parseFloat($('#FILO_RESERVE_PCT').val());
    $('#FILO_RESERVE_INDX_PCT').val(numDec((inter - res), 5));
}

/**
 * Calculates loan amount on change
 */
function FiloSetLoanAmt() {
    var inter = parseFloat($('#FILO_REQUESTED_AMT').val());
    var res = parseFloat($('#FILO_DOWN_PYMT_AMT').val());
    $('#FILO_LOAN_AMT').val(numDec((inter - res), 2));
}

function FiloCalcNoPayments() {

    var payfreq = parseFloat($('#FILO_PAYMENT_FREQ').val());
    var period = parseFloat($('#FILO_LOAN_PERIOD').val());
    var periodtype = $('#FILO_PERIOD_TYPE').val();
    var periodfactor = 0;
    if (isNaN(period)) {
        period = 0;
        $('#FILO_LOAN_PERIOD').val(0);
    }
    if (periodtype == 'D') {
        periodfactor = 360;
    }
    else if (periodtype == 'W') {
        periodfactor = 52;
    }
    else if (periodtype == 'M') {
        periodfactor = 12;
    }
    else if (periodtype == 'Q') {
        periodfactor = 4;
    }
    else if (periodtype == 'S') {
        periodfactor = 2;
    }
    else if (periodtype == 'Y') {
        periodfactor = 1;
    }
    else {
        periodfactor = 0;
    }
    var nopay = 0;
    if (periodfactor > 0) {
        nopay = period * (payfreq / periodfactor);
    }
    if (payfreq == 99) {
        nopay = 1;
    }
    $('#FILO_NO_PAYMENTS').val(Math.round(nopay));

    //Check for ballon payments
    FiloCalcNoBallonPayments();
}//end function

/**
 * Calculates number of ballon payments
 */
function FiloCalcNoBallonPayments() {
    var payfreq = parseFloat($('#FILO_BALLOON_PAY_FREQ').val());
    var period = parseFloat($('#FILO_LOAN_PERIOD').val());
    var periodtype = $('#FILO_PERIOD_TYPE').val();
    var binterval = parseFloat($('#FILO_BALLOON_PERIOD').val());
    //var balpay = parseFloat($('#FILO_BALLOON_PERIOD').val());
    var balloon_pay = parseFloat($('#FILO_BALLOON_PAY_AMT').val());

    var periodfactor = 0;
    if (isNaN(period)) {
        period = 0;
        $('#FILO_LOAN_PERIOD').val(0);
    }

    var one_day = 1000 * 60 * 60 * 24;
    if (periodtype == 'D') {
        periodfactor = 360;
    } else if (periodtype == 'W') {
        one_day *= 7;
        periodfactor = 52;
    } else if (periodtype == 'M') {
        one_day *= 30;
        periodfactor = 12;
    } else if (periodtype == 'Q') {
        one_day *= 30 * 4;
        periodfactor = 4;
    } else if (periodtype == 'S') {
        one_day *= 30 * 2;
        periodfactor = 2;
    } else if (periodtype == 'Y') {
        one_day *= 360;
        periodfactor = 1;
    } else {

        periodfactor = 0;
    }
    var nopay = 0;
    if (periodfactor > 0 && binterval > 0) {
        nopay = period * ((payfreq / binterval) / periodfactor);
    }

    //Set the two dates
    //var sdate = new Date($('#FILO_START_DATE').val());
    //var bsdate = new Date($('#FILO_BALLOON_SDATE').val());
    //Calculate difference from loan start and loan ballos start
    $('#FILO_BALLOON_PAYMENTS').val(numDec(nopay, 0));
    $('#FILO_BALLOON_AMT').val(numDec((nopay * balloon_pay), 2));

}//end function

function FiloFeesFormulaLbl(code) {
    var lbl = '';
    if (code.charAt(0) == 'P') {
        lbl = '% ';
    }
    return lbl;
}

/**
 * Localiza el monto de interes para reserva
 */
function FiloFindFeesNames() {

    //GLPV
    var prod_code = $('#FILO_PRODUCT_CODE_prim').val();
    $.ajax({type: 'GET',
        url: 'window.php?to=DBQY&ac=QXML&no_menu=1&no_alerts=1&qy=GLPF_JS&fn=GLPF.PRODUCT_CODE&fv=' + prod_code,
        dataType: 'xml',
        success: function (xml) {

            $(xml).find('GLPF_JS').each(function () {
                var self = this;
                var fm1 = FiloFeesFormulaLbl($(self).find('GLPF_FEE_01_FORMULA_WRK').text());
                var fm2 = FiloFeesFormulaLbl($(self).find('GLPF_FEE_02_FORMULA_WRK').text());
                var fm3 = FiloFeesFormulaLbl($(self).find('GLPF_FEE_03_FORMULA_WRK').text());
                var fm4 = FiloFeesFormulaLbl($(self).find('GLPF_FEE_04_FORMULA_WRK').text());
                var fm5 = FiloFeesFormulaLbl($(self).find('GLPF_FEE_05_FORMULA_WRK').text());

                $('#FILO_FEE_01_NAME').val(fm1 + $(self).find('GLPF_FEE_01_NAME_WRK').text());
                $('#FILO_FEE_02_NAME').val(fm2 + $(self).find('GLPF_FEE_02_NAME_WRK').text());
                $('#FILO_FEE_03_NAME').val(fm3 + $(self).find('GLPF_FEE_03_NAME_WRK').text());
                $('#FILO_FEE_04_NAME').val(fm4 + $(self).find('GLPF_FEE_04_NAME_WRK').text());
                $('#FILO_FEE_05_NAME').val(fm5 + $(self).find('GLPF_FEE_05_NAME_WRK').text());
            });
        }
    });
}//end function

function filoSetExtProdCode() {
    $('#FILO_EXT_PRODUCT_CODE').val($('#FILO_IDCODE').val());
}

function filoSetDeductiblePct() {
    var pct = parseFloat($('#FILO_DEDCTBLE_PCT').val());
    var lnmt = parseFloat($('#FILO_REQUESTED_AMT').val());
    $('#FILO_DEDUCTIBLE_AMT').val(numDec((lnmt * (pct / 100)), 2));
    FiloSetLoanAmt();
}

function filoRestructure() {
    //FILO_REFINANCED
    if ($('#FILO_REFINANCED').val() == 1) {
        $('#FILO_REQUESTED_AMT').val($('#FILO_PRINCIPAL_BAL').val());
        $('#FILO_DOWN_PYMT_AMT').val('0.00');
        FiloSetLoanAmt();
    }
}

function setPayDay(){
    //var t = parseInt($("#FILO_PAY_DAY").val());
    var d = $("#FILO_FIRST_PYMNT_DATE").val().split('-');
    if(parseInt(d[2]) > 0){
        $("#FILO_PAY_DAY").val(parseInt(d[2]));
    }
}

function filoInitForm() {
    //FiloSetLoanAmt();
    //$('#FILO_DEDUCTIBLE_AMT').change(FiloSetLoanAmt);
    $('#FILO_DEDCTBLE_PCT').change(filoSetDeductiblePct);
    $('#FILO_REFINANCED').change(filoRestructure);
    $("#FILO_FIRST_PYMNT_DATE").change(setPayDay);

    $("#FILO_CRED_LINE_CODE_prim").change(lineaCredito);
    $("#FILO_PRODUCT_CODE_prim").ready(verifica);

    $(function () {
        $('#FILO_BALLOON_PAY_FREQ option').each(function (i) {
            var self = this;
            switch ($(self).val()) {
                case '00':case '365':case '366':
                    $(self).hide();
                    break;
                default:
                    $(self).show();
                    break;
            }
            ;
        });
    });
    $(function () {
        $('#FILO_PAYMENT_FREQ option').each(function (i) {
            var self = this;
            switch ($(self).val()) {
                case '00':case '365':case '366':
                    $(self).hide();
                    break;
                default:
                    $(self).show();
                    break;
            }
            ;
        });
    });

    $(function () {
        $('#FILO_PERIOD_TYPE option').each(function (i) {
            var self = this;
            switch ($(self).val()) {
                case 'D': case 'W': case 'M': case '': case 'Q': case 'S': case 'Y':
                    $(self).show();
                    break;
                default:
                    $(self).hide();
                    break;
            }
            ;
        });
    });

    $(function () {
        $('#FILO_INTEREST_CALC option').each(function (i) {
            var self = this;
            switch ($(self).val()) {
                case '30/360':
                case '366':
                case 'AC/360':
                case '':
                case '30/365':
                case 'AC/365':
                case 'AC/AC':
                    $(self).hide();
                    break;
                default:
                    break;
            }
            ;
        });
    });
}

function verifica(){
    var producto_servicio = $("#FILO_PRODUCT_CODE_prim").val();

    if(producto_servicio == '')
        $("#FILO_CRED_LINE_CODE_prim").ready(lineaCredito);
}

function lineaCredito(){
    var crcl = $("#FILO_CRED_LINE_CODE_prim").val();

    if(crcl == ''){
        return;
    }

    $.ajax({type: "GET",
            url: "window.php?to=DBQY&ac=QXML&no_menu=1&no_alerts=1&qy=CRCL_FORM&fn=CRCL.IDCODE&fv=" + crcl,
            dataType: "xml",
            async: true,
            success: function(xml){
                $(xml).find('CRCL_FORM').each(function(){
                    $("#FILO_PRODUCT_CODE_prim").val($(this).find('CRCL_PRODUCT_CODE').text());
                    $("#FILO_PRODUCT_CODE_secd").val($(this).find('CRCL_PRODUCT_NAME_WRK').text());
                    $("#FILO_CONTRACT_CODE_prim").val($(this).find('CRCL_CODE_CONTRATO_WRK').text());
                    $("#FILO_CONTRACT_CODE_secd").val($(this).find('CRCL_NAME_CONTRATO_WRK').text());
                    $("#FILO_PARTICIPANT_ID_prim").val($(this).find('CRCL_CODE_PATICIPANT_WRK').text());
                    $("#FILO_PARTICIPANT_ID_secd").val($(this).find('CRCL_CTA_PATICIPANT_WRK').text());
                    $("#FILO_PARTICIPANT_ID_terc").val($(this).find('CRCL_CODE_CONTRA_SEC_WRK').text());
                    $("#FILO_DEBTOR_CODE_prim").val($(this).find('CRCL_ACCOUNTCODE').text());
                    $("#FILO_DEBTOR_CODE_secd").val($(this).find('CRCL_ACCOUNT_SHORT_NAME_WRK').text());
                });
            }
    });
}