<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-09-03 12:24:19 -0400 (Thu, 03 Sep 2015) $
 * @version        $Rev: 6814 $
 *
 * CHANGE LOG
 *  Included svn prop
 */

/**
 * Initialice firt form
 * Executed on init event
 */
function firs_init_form(&$record) {
    if (empty(UserRequest::$post['confirm']) && UserRequest::$request['ac'] === 'CREATE') {
        $callingpage = peekHistory();
        if (!empty($callingpage['parentrecord'])) {
            $record['FIRS_SEQNUM'] = ClxCommon::$db->countRecords(tableName('FIRS'), 'FIDU_RATETBLCODE = ' . singleQuote($callingpage['parentrecord']['FIRT_IDCODE']) . ' AND EFFTDATE = ' . singleQuote($callingpage['parentrecord']['FIRT_CLX_EFFTDATE'])) + CLX_NUM_ONE;
            $record['FIRS_IDNAME'] = $callingpage['parentrecord']['FIRT_IDCODE'] . ' - ' . $record['FIRS_SEQNUM'];
        }
    }
}

/**
 * Validate record information
 * Executed on table validate
 */
function firs_validate_form(&$record, &$msg) {
    $firtrec = ClxCommon::$db->getFields(tableName('FIRT'), 'STATUS,TRANSCODE', 'IDCODE = ' . singleQuote($record['FIRS_FIDU_RATETBLCODE']));
    if ($firtrec['STATUS'] <> 'A') {
        $msg['FIRS_FIDU_RATETBLCODE'] = 'FETR02 ' . dict('GEN_ERR_INVALID_STATUS');
    }
    if ($firtrec['STATUS'] <> 'A') {
        $msg['FIRS_FIDU_RATETBLCODE'] = 'FETR03 ' . dict('GEN_ERR_INVALID_STATUS');
    }
    if ($record['FIRS_RANGE_FROM_AMT'] > $record['FIRS_RANGE_TO_AMT']) {
        //from no puede ser mayor que to
        $msg['FIRS_RANGE_FROM_AMT'] = 'FETR04 ' . dict('GEN_LBL_FROMTORANGEINVALID');
        $msg['FIRS_RANGE_TO_AMT'] = 'FETR04 ' . dict('GEN_LBL_FROMTORANGEINVALID');
    }
    if (($record['FIRS_FEES_RATE_PCT'] <> CLX_NUM_ZERO && $record['FIRS_FEES_RATE_AMT'] <> CLX_NUM_ZERO) ||
            ($record['FIRS_FEES_RATE_PCT'] == CLX_NUM_ZERO && $record['FIRS_FEES_RATE_AMT'] == CLX_NUM_ZERO)) {
        //seleccionar monto o porcentaje no ambos
        $msg['FIRS_FEES_RATE_PCT'] = 'FETR05 ' . dict('GEN_ERR_FEEORPCTNOTBOTH');
        $msg['FIRS_FEES_RATE_AMT'] = 'FETR05 ' . dict('GEN_ERR_FEEORPCTNOTBOTH');
    }
    if ($record['FIRS_FEES_RATE_PCT'] < CLX_NUM_ZERO || $record['FIRS_FEES_RATE_AMT'] < CLX_NUM_ZERO) {
        //seleccionar monto o porcentaje no ambos
        $msg['FIRS_FEES_RATE_AMT'] = 'FETR05 ' . dict('GEN_LBL_GREATERTHANOREQUEALTO', CLX_NUM_ZERO);
        $msg['FIRS_FEES_RATE_PCT'] = 'FETR05 ' . dict('GEN_LBL_GREATERTHANOREQUEALTO', CLX_NUM_ZERO);
    }
    if ($firtrec['TRANSCODE'] === 'SYS_DESIN') {
        $msg['FIRS_FIDU_RATETBLCODE'] = 'FETR06 ' . dict('GEN_LBL_SCALENOTALLOWED');
    }
}

/**
 * Update Parent (FETR) Information one record is saved
 */
function firs_save_form(&$record) {
    //Update modified by and modification date on FIRS
}
