/**
 * Removes selection options
 * @param {type} field
 * @param {type} allowed_values
 * @returns {undefined}
 */
var genjs_msg1='Error on request';
function removeSelectOptions(field, allowed_values)
{
    var original_list = field;
    var values = allowed_values.split(',');
    for (var i = 0; original_list.length > i; i++) {
        var found = false;
        for (var j = 0; values.length > j; j++) {
            if (original_list[i].value == values[j]) {
                found = true;
                break;
            }
        }
        if (!found) {
            field[i] = null;
        }
    }
    original_list = false;
}


/**
 * Updates form object
 * @param {type} formfield
 * @param {type} querycode
 * @returns {undefined}
 */
function FormUpdateFields(formfield, querycode) {


    //var ff = formfield.name;
    if (formfield.name.indexOf('_prim') >= 0 || formfield.name.indexOf('_secd') >= 0 || formfield.name.indexOf('_terc') >= 0) {
        return;
    }
    var fft = formfield.name.substr(5, formfield.name.length - 4);
    var url = 'window.php?to=DBQY&ac=QXML&no_menu=1&no_alerts=1&qy=' + querycode + '&fn=' + fft + '&fv=' + formfield.value;

    $.get(url, function (data, status) {

        ProcessFormUpdateFieldsResult(data, status, formfield);}, 'xml').fail(function () {alert(genjs_msg1);});
}

/**
 * Form uptdate calback
 * @param {type} root
 * @param {type} status
 * @param {type} formfield
 * @returns {undefined}
 */
function ProcessFormUpdateFieldsResult(root, status, formfield) {

    var roots = (root.childNodes.length == 1) ? root.childNodes[0] : root.childNodes[1];//xml
    for (var i = 0; i < roots.childNodes.length; i++) {
        var n = roots.childNodes[i];
        for (var j = 0; j < n.childNodes.length; j++) {
            var m = n.childNodes[j];
            if (m.nodeType == 1) {

                var tbl = m.getAttribute('TBL');
                var wrk = m.getAttribute('WRK');
                var fname = (wrk === '1') ? m.nodeName.slice(0, m.nodeName.length - 4) : m.nodeName;
                var formfieldname = formfield.name.substr(0, 5) + fname.slice(tbl.length + 1, fname.length);

                if ($('#' + formfieldname) !== null) {
                    DBLT_load_list_enties($('#' + formfieldname).prop('id'));
                    $('#' + formfieldname).val(m.firstChild.nodeValue);
                }

                //clear any posible lookups that should not be updated
                if ($('#' + formfieldname + '_prim') !== null) {
                    $('#' + formfieldname + '_prim').val('');
                }
                if ($('#' + formfieldname + '_secd') !== null) {
                    $('#' + formfieldname + '_secd').val('');
                }
                if ($('#' + formfieldname + '_terc') !== null) {
                    $('#' + formfieldname + '_terc').val('');
                }
            }
        }
    }


}

/**
 * Change Form Target
 * @param {type} ispopup
 * @param {type} formfield
 * @returns {undefined}
 */
function ChangeFormTarget(ispopup, formfield) {
    var action;
    var target;
    if (ispopup) {
        action = 'pop.php';
        target = '_new';
    } else {
        action = 'tool.php';
        target = '_self';
    }
    $('#' + $(formfield.form).attr('name')).attr('action', action);
    $('#' + $(formfield.form).attr('name')).attr('target', target);
}
