<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2016-01-13 13:08:09 -0500 (Wed, 13 Jan 2016) $
 * @version        $Rev: 7689 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class glre {

    var $display = false;
    var $batch_process = false;
    var $no_ncf = false;
	
    /**
     * Contructor
     *
     * @param array $procParameters
     * @return void
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('GLRE', 'INVO', 'APIN', 'GLCP', 'APIL', 'APIN', 'INVL', 'JEHD'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
		$this->today = xFormat::getNow('Y-m-d');
    }

    /**
     * Runs schedules by cron o closing
     * @param string $comp_code
     * @param strin $efftdate
     */
    function glre_run_cron($comp_code, $efftdate = '') {
        if ($efftdate === '') {
            $efftdate = ClxCommon::$db->getField($this->glcpname, 'OPERATION_DATE', 'COMP_CODE = ' . singleQuote($comp_code));
        }
        $this->batch_process = true;
        //$sql = 'SELECT GLRE.ID FROM ' . $this->glrename . ' GLRE, ' . $this->invoname . ' INVO WHERE INVO.IDCODE = GLRE.INVOICECODE AND INVO.COMP_CODE = ' . singleQuote($comp_code) . ' AND GLRE.STATUS = ' . singleQuote('A') . ' AND GLRE.NEXT_RUN_DATE <= ' . singleQuote($efftdate) . ' AND (GLRE.RECURRENT_R9 = ' . singleQuote('0000-00-00') . ' OR GLRE.RECURRENT_R9>=' . singleQuote($efftdate) . ') UNION SELECT GLRE.ID FROM ' . $this->glrename . ' GLRE, ' . $this->apinname . ' APIN WHERE APIN.IDCODE = GLRE.PAYINV_CODE AND APIN.COMP_CODE = ' . singleQuote($comp_code) . ' AND GLRE.STATUS = ' . singleQuote('A') . ' AND GLRE.NEXT_RUN_DATE <= ' . singleQuote($efftdate) . ' AND (GLRE.RECURRENT_R9 = ' . singleQuote('0000-00-00') . ' OR GLRE.RECURRENT_R9>=' . singleQuote($efftdate) . ')';
        $sql = 'SELECT GLRE.ID FROM ' . $this->glrename . ' GLRE, ' . $this->invoname . ' INVO WHERE INVO.IDCODE = GLRE.INVOICECODE AND INVO.COMP_CODE = ' . singleQuote($comp_code) . ' AND GLRE.STATUS = ' . singleQuote('A') . ' AND GLRE.NEXT_RUN_DATE = ' . singleQuote($efftdate) . ' AND (GLRE.RECURRENT_R9 = ' . singleQuote('0000-00-00') . ' OR GLRE.RECURRENT_R9>=' . singleQuote($efftdate) . ') UNION SELECT GLRE.ID FROM ' . $this->glrename . ' GLRE, ' . $this->apinname . ' APIN WHERE APIN.IDCODE = GLRE.PAYINV_CODE AND APIN.COMP_CODE = ' . singleQuote($comp_code) . ' AND GLRE.STATUS = ' . singleQuote('A') . ' AND GLRE.NEXT_RUN_DATE = ' . singleQuote($efftdate) . ' AND (GLRE.RECURRENT_R9 = ' . singleQuote('0000-00-00') . ' OR GLRE.RECURRENT_R9>=' . singleQuote($efftdate) . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while (($r = ClxCommon::$db->getNextRecord($rs, NUMERIC))) {
            $this->glre_run_recurrence($r[CLX_NUM_ZERO]);
        }
    }

    function glre_run_recurrence_btn() {
        $this->batch_process = false;
        $idlist = getIdlist();
        if (empty($idlist))
            return;
        foreach ($idlist as $val) {
           $this->glre_run_recurrence($val);
        }
    }

    /**
     * Build transaction instructions
     * @param: integer glre_code
     */
    function glre_run_recurrence($glre_code) {
        //get information
        if (empty($glre_code))
            return;
		$glre_rec = ClxCommon::$db->getRecord($this->glrename, 'ID = ' . $glre_code);
        $tablecode = '';
        $tablename = '';
        if (!empty($glre_rec['INVOICECODE'])) {
            $srcinvoice = ClxCommon::$db->getRecord($this->invoname, 'IDCODE = ' . singleQuote($glre_rec['INVOICECODE']));
            $tablecode = 'INVO';
            $tablename = $this->invoname;
        } elseif (!empty($glre_rec['PAYINV_CODE'])) {
            $srcinvoice = ClxCommon::$db->getRecord($this->apinname, 'IDCODE = ' . singleQuote($glre_rec['PAYINV_CODE']));
            $tablecode = 'APIN';
            $tablename = $this->apinname;
        } else {
            return;
        }
        //If efftdate is not provided then search operation date day as operation date
        if (!function_exists('setCreationData'))
            includeCodeLib('GEN_REC_UTIL');
        if (!function_exists('Comp'))
            includeCodeLib('COMP');
        $comp = new Comp();
        $operation_date = $comp->comp_operation_date($srcinvoice['COMP_CODE']);
        $fiscal_period = $comp->comp_fiscal_period($srcinvoice['COMP_CODE'], $operation_date);
        unset($fiscal_period);
        //Copiar encabezado de factura
        $newinvoice = $srcinvoice;
        unset($newinvoice['ID']);
        $newinvoice['IDCODE'] = 'AUTO';
        $interval = day_diff($srcinvoice['DUE_DATE'], $srcinvoice['INVOICEDATE']);
        $newinvoice['INVOICEDATE'] = $operation_date;
        $newinvoice['DUE_DATE'] = adodb_period_date($operation_date, '360', $interval, 'Y-m-d');
        $newinvoice['INVO_STAT'] = '01';
        $newinvoice['CLX_AUTH_STATUS'] = 'PEND';
        $newinvoice['JEHDR_CODE'] = 'null';
        $newinvoice['PAY_JEHDR_CODE'] = 'null';
		$newinvoice['TAXRCPT_NO']= '';

        if (array_key_exists('INVODOC_STAT', $newinvoice))
            $newinvoice['INVODOC_STAT'] = 'AP';
        $key = '';
        $lines_table = '';
        if ($tablecode === 'INVO') {
            $newinvoice['GLRE_AR_CODE'] = $glre_code;
            $newinvoice['INVODOC_STAT'] = 'PEND';
            $newinvoice['CANCEL_DT'] = 'null';
			$key = 'INVOICECODE';
            $lines_table = $this->invlname;
        } elseif ($tablecode === 'APIN') {
            $newinvoice['GLRE_AP_CODE'] = $glre_code;
            $newinvoice['TAXRCPTREL_NO']= '';
			$key = 'PAYINV_CODE';
            $lines_table = $this->apilname;
        }
        setCreationData($newinvoice);
        setCreationIdCode($newinvoice, $tablecode);
        ClxCommon::$db->createRecord($tablename, $newinvoice, false);
        $sql = 'INSERT INTO ' . $lines_table . ' (' . $key . ', SEQNUM, DESCRIPTION, QUANTITY, PRICE, LINE_TOTAL, TAX_AMT, ITEM_CODE, GLACCOUNTCODE, CHART_FIELD03, CHART_FIELD04, QUANTITY_W, PRICE_W, LINE_TOTAL_W) SELECT ' . singleQuote($newinvoice['IDCODE']) . ' ' . $key . ', INL.SEQNUM, INL.DESCRIPTION, INL.QUANTITY, INL.PRICE, INL.LINE_TOTAL, INL.TAX_AMT, INL.ITEM_CODE, INL.GLACCOUNTCODE, INL.CHART_FIELD03, INL.CHART_FIELD04, INL.QUANTITY_W, INL.PRICE_W, LINE_TOTAL_W FROM ' . $lines_table . ' INL WHERE INL.' . $key . ' = ' . singleQuote($srcinvoice['IDCODE']) . ' AND NOT EXISTS(SELECT X.ID FROM ' . $lines_table . ' X WHERE X.' . $key . ' = ' . singleQuote($newinvoice['IDCODE']) . ')';
        ClxCommon::$db->executeQuery($sql);
        //building amortizacion if apply and building accounting if needs approbal
        if ($tablecode === 'INVO') {
            //Build Amortization if apply
            if (!class_exists('Aras'))
                includeCodeLib('ARAS');
            $aras = new Aras();
            $aras->build_amortization($newinvoice['IDCODE']);
            unset($aras);
            
			//Build accounting and send to approve
            if ($glre_rec['APPROVE_INVOICE'] == CLX_NUM_ONE) {
				
				if(companyParameter('INVO_ASSIG_NCF', $srcinvoice['COMP_CODE']) == 1){	
					//obtengo el tipo de comprobante fiscal de la factura
					$taxrcpt_type = ClxCommon::$db->getField($tablename, 'TAXRCPT_TYPE', 'IDCODE=' . $newinvoice['IDCODE']);

					//verifico que hay NCF disponibles para asignar
					$sql = 'SELECT TXRT.TAXRCPT_TYPE, TXRT.TAXRCPT_NEXTSEQ, TXRT.TAXRCPT_FINALSEQ, TXRT.TAXRCPT_ASIGN FROM BILL_TAXRCPTSEQ_TBL TXRT WHERE TXRT.TAXRCPT_TYPE = '.singleQuote($taxrcpt_type). ' AND TXRT.TAXRCPT_FINALSEQ>TXRT.TAXRCPT_ASIGN AND  TXRT.TAXRCPT_EXPDATE>= ' . singleQuote($this->today);
					$txrtnfc = ClxCommon::$db->getOneRecord($sql);

					if (empty($txrtnfc)) {
						addMessage(dict('GEN_ETL_ERR_050', $newinvoice['IDCODE']));
						$this->no_ncf= false;
					}else{
						$this->no_ncf= true;
						//busco la secuencia asociada al tipo de comprobante fiscal y obtengo el ultimo NCF asignado
						//$ncfinvo = ClxCommon::$db->getFields('BILL_TAXRCPTSEQ_TBL', 'TAXRCPT_NEXTSEQ, TAXRCPT_ASIGN', 'TAXRCPT_TYPE = ' . singleQuote($taxrcpt_type));
						$sql = 'SELECT TXRT.ID, TXRT.TAXRCPT_TYPE, TXRT.TAXRCPT_NEXTSEQ, TXRT.TAXRCPT_FINALSEQ, TXRT.TAXRCPT_ASIGN FROM BILL_TAXRCPTSEQ_TBL TXRT WHERE TXRT.TAXRCPT_TYPE = '.singleQuote($taxrcpt_type). ' AND TXRT.TAXRCPT_FINALSEQ>TXRT.TAXRCPT_ASIGN AND  TXRT.TAXRCPT_EXPDATE>= ' . singleQuote($this->today) . ' ORDER BY ID ASC LIMIT 1';

						$ncfinvo = ClxCommon::$db->getOneRecord($sql);


						if ($ncfinvo['TAXRCPT_ASIGN']==='00000000'){
							$ncfinvo['TAXRCPT_ASIGN']=$ncfinvo['TAXRCPT_NEXTSEQ'];
						}else{
							$ncfinvo['TAXRCPT_ASIGN']=str_pad($ncfinvo['TAXRCPT_ASIGN']+1, 8, '0', STR_PAD_LEFT); //incremento NCF para obtener el disponible
						}

						if (!is_null($ncfinvo['TAXRCPT_ASIGN'])){
							 //Asigno NCF 
							ClxCommon::$db->updateRecord($tablename, array('TAXRCPT_NO' => $ncfinvo['TAXRCPT_ASIGN']), 'IDCODE=' .$newinvoice['IDCODE']);

							//guardo el ultimo NCF asignado usando el ID de la secuencia ncf
							ClxCommon::$db->updateRecord('BILL_TAXRCPTSEQ_TBL', array('TAXRCPT_ASIGN' => $ncfinvo['TAXRCPT_ASIGN']), 'ID=' . $ncfinvo['ID']);
						} 
					}
				}else{
					$this->no_ncf= true;
				}
			}
			if (!class_exists('Invo'))
				includeCodeLib('INVO');
			if (!class_exists('Jehd'))
				includeCodeLib('JEHD');
			$a = new Invo();
			$jehdr_code = $a->buildAccounting($newinvoice['IDCODE']);
			if ($this->no_ncf){
				$jehd = new Jehd();
				if ($this->batch_process) {//just approve
						$jehd->jehd_approve_by_code($jehdr_code);
				}else {//send to queue
						$jehd->jehd_approve_queue_by_code($jehdr_code);
				}
			}
            	
		
        } elseif ($tablecode === 'APIN') {
            //Build Amortization
            if (!class_exists('Apas'))
                includeCodeLib('APAS');
            $apas = new Apas();
            $apas->build_amortization($newinvoice['IDCODE']);
            unset($apas);
            //Build accounting and send to approve
            if ($glre_rec['APPROVE_INVOICE'] == CLX_NUM_ONE) {
                if (!class_exists('APIN'))
                    includeCodeLib('APIN');
                if (!class_exists('Jehd'))
                    includeCodeLib('JEHD');
                $a = new Apin();
                $jehdr_code = $a->buildAccounting($newinvoice['IDCODE']);
                $jehd = new Jehd();
                if ($this->batch_process) {//just approve
                    $jehd->jehd_approve_by_code($jehdr_code);
                }else {//send to queue
                    $jehd->jehd_approve_queue_by_code($jehdr_code);
                }
            }
        }
        //Aprobar factura si es requerido
        //Marcar registro como completada
        $field = getToolObject('DBFT', 'RECU');
        $glre_rec['LAST_RUN_DATE'] = $glre_rec['NEXT_RUN_DATE'];
        $glre_rec['NEXT_RUN_DATE'] = xFormat :: date($field->next_run_date('RECURRENT', $glre_rec['LAST_RUN_DATE'], $glre_rec), 'Y-m-d');
        $sql = 'UPDATE ' . $this->glrename . ' SET LAST_RUN_DATE =' . singleQuote($glre_rec['LAST_RUN_DATE']) . ', NEXT_RUN_DATE = ' . singleQuote($glre_rec['NEXT_RUN_DATE']) . ' WHERE ID = ' . $glre_rec['ID'];
        ClxCommon::$db->executeQuery($sql);
        //Notify user of results
        if ($this->batch_process) {
            echoLog('Process completed invoice nod: ' . $tablecode . ' ' . $newinvoice['IDCODE']);
        } else {
            if ($tablename === 'INVO') {
                addMessage(dict('GEN_LBL_INVO_GENERATED', $newinvoice['IDCODE']));
            } else {
                addMessage(dict('GEN_LBL_APIN_GENERATED', $newinvoice['IDCODE']));
            }
        }
    }

}
