function INPR_checkISINCODE(sISINCode) {

    if (sISINCode.length != 12) {
        return false;
    }

    if (sISINCode.charCodeAt(0) < 'A'.charCodeAt(0) ||
            sISINCode.charCodeAt(0) > 'Z'.charCodeAt(0)) {
        return false;
    }
    if (sISINCode.charCodeAt(1) < 'A'.charCodeAt(0) ||
            sISINCode.charCodeAt(1) > 'Z'.charCodeAt(0)) {
        return false;
    }

    var sDigits = '';

    for (var i = 0; i < 11; i++) {
        sDigits += parseInt(sISINCode.charAt(i), 36);
    }

    sDigits = sDigits.split('').reverse().join('');

    var iTotalScore = 0;

    for (var i = 0; i < sDigits.length; i++) {
        iTotalScore += parseInt(sDigits.charAt(i));
        if (i % 2 == 0) {
            iTotalScore += parseInt(sDigits.charAt(i));
            if (parseInt(sDigits.charAt(i)) > 4) {
                iTotalScore -= 9;
            }
        }
    }

    return (10 - (iTotalScore % 10)) % 10 == parseInt(sISINCode.charAt(11));
}

/*
 $(document).ready(inprInitFormPanels);
 */
function inprInitFormPanels() {
    var self = this;
    $('#INPR_INTEREST_CALC option').each(function (i) {
        switch ($(self).val()) {
            case '30/360':
            case 'AC/360':
            case '1':
            case '30/365':
            case 'AC/365':
            case 'AC/AC':
                break;
            default:
                $(self).hide();
                break;
        }
        ;
    });

    $('#INPR_IS_FIXINCOME').change(inprSetFixPanels);
    inprSetFixPanels();

}

function inprSetFixPanels() {
    if ($('#INPR_IS_FIXINCOME').val() == 1) {
        $('#3536').show();//fix
        $('#3537').show();//fix

    } else {
        $('#3536').hide();//non fix
        $('#3537').hide();//non fix
    }
}

