<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-10-08 10:34:58 -0400 (Thu, 08 Oct 2015) $
 * @version        $Rev: 7183 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Prlt {

    /**
     * Contructor
     *
     * @param array $procParameters
     * @return void
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('PRLT', 'PRAT', 'GLPF'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
    }

    /**
     * Initialice prlt form
     * Executed on init event
     */
    function init_form(&$record) {
        if (!empty($record['PRLT_PRODUCT_CODE'])) {
            $sql = 'SELECT IDNAME, SEQNUM, FEE_FORMULA FROM ' . $this->glpfname . ' WHERE PRODUCT_CODE = ' . singleQuote($record['PRLT_PRODUCT_CODE']) . ' ORDER BY SEQNUM ASC';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $i = $r['SEQNUM'];
                $lbl = '';
                if (substr($r['FEE_FORMULA'], CLX_NUM_ZERO, CLX_NUM_ONE) === 'P')
                    $lbl = '% ';
                $record['PRLT_FEE_0' . $i . '_NAME'] = $lbl . $r['IDNAME'];
            }
        }
    }

    /**
     * Initialice prlt form
     * Executed on init event
     */
    function load_form(&$record) {
        $this->init_form($record);
    }

    /**
     * Validate record information
     * Executed on table validate
     */
    function validate_form(&$record, &$msg) {
        $a = array('01', '02', '03', '04');
        $lastdays = CLX_INIT_ZERO;
        foreach ($a as $val) {
            $flt = 'PRLT_PROD_STATUS_' . $val;
            $fld = 'PRLT_DAYS_STATUS_' . $val;
            $flo = 'PRLT_OPER_STATUS_' . $val;
            if ($record[$flt] <> '') {
                $qty = ClxCommon::$db->oneExistsRecords($this->pratname, 'PRODUCT_CODE = ' . singleQuote($record['PRLT_PRODUCT_CODE']) . ' AND PROD_STATUS = ' . singleQuote($record[$flt]));
                if ($record[$flo] <> CLX_NUM_TWO && $qty == CLX_NUM_ZERO) {
                    $msg[$flt] = smsg('MSG-156', $record[$flt]);
                }
                if ($record['PRLT_STATUS_COND_' . $val] === '0') {
                    if ($lastdays >= $record[$fld]) {
                        $msg[$fld] = smsg('MSG-157', $lastdays);
                    }
                    $lastdays += $record[$fld];
                }
            }
            //Validating status requirement if days are set
            if ($record[$fld] > CLX_NUM_ZERO && $record[$flt] === '') {
                $msg[$flt] = smsg('MSG-191');
            }
        }//end for
    }

    /**
     * Update Parent (PRLT) Information one record is saved
     */
    function save_form(&$record) {

    }

}
