<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2016-05-23 11:43:58 -0400 (Mon, 23 May 2016) $
 * @version        $Rev: 8256 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Srap {

    /**
     * Contructor
     *
     * @param array $procParameters
     * @return void
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('SRAP', 'SRAA', 'ACTI', 'PROD', 'ACCO', 'SRRQ', 'SRRP'));
        $this->batch_id = (!empty($procParameters ['BATCH_ID'])) ? $procParameters ['BATCH_ID'] : batch_id();
        $this->username = $_SESSION ['user_record'] ['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
    }

    /**
     * Initialice fiai form
     * Executed on init event
     */
    function init_form(&$record) {
	
    }

// end function
    /**
     * Validate record information
     * Executed on table validate
     */
    function validate_form(&$record, &$msg) {

    }

// end function
    /**
     * Save form post database comit
     * @param unknown_type $record
     */
    function save_form_post(&$record) {

    }

    /**
     * Builds activities based in requests.
     * @param unknown_type $srrqrec
     */
    function process_request($srrqrec) {
        includeCodeLib('ACTI');
        $acti = new Acti();
        //Actividades a generar seran todas aquellas sin dependencia.
        //Otras actividades post dependencia se colocaran al modificar
        //actividad.
        $sql = 'SELECT SRAA.ASSIGN_RULE, case SRAA.ASSIGN_RULE WHEN ' . singleQuote('RL') . ' THEN SRRP.USER_CODE WHEN ' . singleQuote('RO') . ' THEN SRRP.USER_CODE ELSE SRRQ.ASSIGNEDTO_USER END ASSIGNEDTO_USER, SRRQ.IDCODE REQUESTCODE, SRRQ.PRODUCT_CODE PRODUCT_CODE, SRRQ.COMP_CODE, SRRQ.ACCOUNTCODE, SRRQ.ASSIGNEDTO_USER OWNERCODE, SRRQ.CDATE START_DTTM, SRAA.ID SRAA_CODE, SRAA.* FROM SERV_REQUESTS SRRQ, SERV_SERVACTPLN_TBL SRAP, SERV_SERVACTI_ASSIGN SRAA LEFT JOIN SERV_ROLE_PARTICIPANTS SRRP ON SRRP.ROLE_CODE = SRAA.ROLE_CODE WHERE SRAP.IDCODE = SRAA.SRAP_CODE AND SRAP.CLX_EFFTDATE = SRAA.CLX_EFFTDATE AND SRAP.STATUS = ' . singleQuote('A') . ' AND (SRAA.SRAC_DEPEND IS NULL OR SRAA.SRAC_DEPEND =' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND SRAP.CLX_EFFTDATE = (SELECT MAX(SRAPX.CLX_EFFTDATE) FROM SERV_SERVACTPLN_TBL SRAPX WHERE SRAPX.IDCODE = SRAP.IDCODE AND SRAPX.CLX_EFFTDATE<=' . singleQuote($this->now) . '  AND SRAPX.STATUS = ' . singleQuote('A') . ') AND SRAP.REQTYPE = SRRQ.REQTYPE AND SRRQ.IDCODE =' . singleQuote($srrqrec['IDCODE']);
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            unset($r['ID']);
            //ACTI_DUEDATE, ACTI_START_DTTM, SRAA_DURATION_UNITS, SRAA_DURATION_PER -> D, H,M
            $r['DUEDATE'] = adodb_period_date($r['START_DTTM'], $r['DURATION_PER'], $r['DURATION_UNITS'], 'Y-m-d H:i:s');
            $r['COMPLETE_DATE'] = 'null';
            $r['LAST_ESCALATION'] = 'null';
            $r['LAST_REMINDER'] = 'null';
            $r['REMINDER'] = 'null';
            $acti->create_activity($r);
        }
    }

    /**
     * Builds next activity information.
     * @param unknown_type $activity_id
     */
    function process_activity($activity_id) {
        includeCodeLib('ACTI');
        $acti = new Acti();
        //Llamado post commit de acti update
        $sql = 'SELECT SRAA.ASSIGN_RULE, case SRAA.ASSIGN_RULE WHEN ' . singleQuote('RL') . ' THEN SRRP.USER_CODE WHEN ' . singleQuote('RO') . ' THEN SRRP.USER_CODE ELSE SRRQ.ASSIGNEDTO_USER END ASSIGNEDTO_USER, SRRQ.IDCODE REQUESTCODE, SRRQ.PRODUCT_CODE PRODUCT_CODE, SRRQ.COMP_CODE, SRRQ.ACCOUNTCODE, SRRQ.ASSIGNEDTO_USER OWNERCODE, SRAA.ID SRAA_CODE, ACTI.MDATE START_DTTM, SRAA.* FROM ' . $this->actiname . ' ACTI, ' . $this->srrqname . ' SRRQ, ' . $this->srapname . ' SRAP, ' . $this->sraaname . ' SRAA LEFT JOIN ' . $this->srrpname . ' SRRP ON SRRP.ROLE_CODE = SRAA.ROLE_CODE WHERE SRAP.IDCODE = SRAA.SRAP_CODE AND SRAP.CLX_EFFTDATE = SRAA.CLX_EFFTDATE AND SRAP.STATUS = ' . singleQuote('A') . ' AND ACTI.ACTIVITY_STATUS = SRAA.ACTI_DEPSTAT AND SRAA.SRAC_DEPEND = ACTI.SRAA_CODE AND ACTI.ID = ' . $activity_id . '   AND SRAP.CLX_EFFTDATE = (SELECT MAX(SRAPX.CLX_EFFTDATE) FROM SERV_SERVACTPLN_TBL SRAPX WHERE SRAPX.IDCODE = SRAP.IDCODE AND SRAPX.CLX_EFFTDATE<=' . singleQuote($this->now) . ' AND SRAPX.STATUS = ' . singleQuote('A') . ') AND SRAP.REQTYPE = SRRQ.REQTYPE AND SRRQ.IDCODE = ACTI.REQUESTCODE AND NOT EXISTS(SELECT ACTI2.ID FROM ' . $this->actiname . ' ACTI2 WHERE ACTI2.SRAA_CODE = SRAA.ID AND ACTI2.REQUESTCODE = ACTI.REQUESTCODE AND ACTI2.OWNERCODE = ACTI.OWNERCODE)';
	    $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            unset($r['ID']);
            $r['DUEDATE'] = adodb_period_date($r['START_DTTM'], $r['DURATION_PER'], $r['DURATION_UNITS'], 'Y-m-d H:i:s');
            $r['COMPLETE_DATE'] = 'null';
            $r['LAST_ESCALATION'] = 'null';
            $r['LAST_REMINDER'] = 'null';
            $r['REMINDER'] = 'null';
            $acti->create_activity($r);
        }
    }

}
