<?php

/**
 * General Functions
 * For more information contact  support@alenet.com
 *
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-11-20 16:34:10 +0000 (Tue, 20 Nov 2018) $
 * @version        $Rev: 10389 $
 *
 * CHANGE LOG
 *  Included label
 */



/**
 * Build Panel Interface
 * @param string $title
 * @param string $code
 * @param string $panelcontents
 * @param int $initialstate
 * @return type
 */
function buildPanelInterface($title, $code, $panelcontents, $initialstate = CLX_NUM_MINUS_1) {
    $contents = (string) '';
    if ($initialstate === CLX_NUM_MINUS_1) {
        $initialstate = (!empty($_SESSION['prefs']['PANEL_STATE'])) ? $_SESSION['prefs']['PANEL_STATE'] : '';
    }
    $variables = array();
    $variables['PANEL_CODE'] = $code;
    $variables['PANEL_TITLE'] = $title;
    $variables['PANEL_CONTENTS'] = $panelcontents;
    $variables['PANEL_STYLE'] = ($initialstate) ? '' : 'display:none;';
    if (strlen($variables['PANEL_TITLE']) > CLX_NUM_ZERO) {
        $contents .= getSkinForm('panel_title.html', $variables);
    }
    $contents .= getSkinForm('panel.html', $variables);
    return $contents;
}

function getVariables() {
    $variables['PAGE_TITLE'] = 'Clientix';
    $variables['STYLE_SHEET'] = '';//.'<link rel="stylesheet" href="../extlibs/js/bootstrap/bootstrap-4.5.3-dist/css/bootstrap.min.css">';
	$variables['STYLE_SHEET'] .= sprintf('<link href="%s" rel="stylesheet" type="text/css">', kPathToSkins . $_SESSION['skin'] . '/styles.css');
    
		
	$jscode = 'var clxskn = ' . singleQuote(kPathToSkins . $_SESSION['skin']) . '; ' . 'var curlanguage = ' . singleQuote(substr(getCurrentLanguage(), CLX_NUM_ZERO, CLX_NUM_TWO)) . '; ' . 'var lblnewitem = ' . singleQuote(dict('GEN_LBL_ADD_NEW_ITEM')) . ';'.'var formatprefsdate='.singleQuote(isset($_SESSION['prefs']['DATE_FORMAT'])?$_SESSION['prefs']['DATE_FORMAT']:'');
    $variables['JAVA_SCRIPT_1'] = setJavaScriptTag($jscode, false);
    $variables['JAVA_SCRIPT_1'] .= jQueryIncludes();
	$variables['JAVA_SCRIPT_1'] .= '<script type="text/javascript" src="/extlibs/js/fusioncharts/fusioncharts.js"></script>';
	$variables['JAVA_SCRIPT_1'] .= '<script type="text/javascript" src="/extlibs/js/fusioncharts/themes/fusioncharts.theme.fusion.js"></script>';
	$variables['JAVA_SCRIPT_1'] .= '<script type="text/javascript" src="/extlibs/js/fusioncharts/themes/fusioncharts.theme.carbon.js"></script>';
	$variables['JAVA_SCRIPT_1'] .= '<script type="text/javascript" src="/extlibs/js/fusioncharts/themes/fusioncharts.theme.zune.js"></script>';
	$variables['JAVA_SCRIPT_1'] .= '<script type="text/javascript" src="/extlibs/js/fusioncharts/themes/fusioncharts.theme.candy.js"></script>';
	$variables['JAVA_SCRIPT_1'] .= '<script type="text/javascript" src="/extlibs/js/fusioncharts/themes/fusioncharts.theme.gammel.js"></script>';
	$variables['JAVA_SCRIPT_1'] .= '<script type="text/javascript" src="/extlibs/js/fusioncharts/themes/fusioncharts.theme.ocean.js"></script>';
    $variables['JAVA_SCRIPT_1'] .= setJavaScriptTag(getJavaScriptFilename('util.js'), true);
    $variables['JAVA_SCRIPT_2'] = setJavaScriptTag(kPathToSkins . $_SESSION['skin'] . '/interface.js', true);
    $variables['JAVA_SCRIPT_3'] = setJavaScriptTag(getJavaScriptFilename('DBLT_ajax.js'), true);
	$variables['MENUS'] = '';
    $variables['CONTENTS'] = 'Clientix';
    $variables['GEN_LBL_LOGIN_TYPEUSER'] = dict('GEN_LBL_LOGIN_TYPEUSER');
    $variables['GEN_LBL_LOGIN_TITLE'] = dict('GEN_LBL_LOGIN_TITLE', substr(kSystemVersion, CLX_NUM_ZERO, CLX_NUM_THREE));
    $variables['GEN_LBL_LOGIN_SUBTITLE'] = dict('GEN_LBL_LOGIN_SUBTITLE');
    $variables['GEN_LBL_LOGIN_USERNAME'] = dict('GEN_LBL_LOGIN_USERNAME');
    $variables['GEN_LBL_LOGIN_PASSWORD'] = dict('GEN_LBL_LOGIN_PASSWORD');
    $variables['GEN_LBL_LOGIN_SYSTEM'] = dict('GEN_LBL_LOGIN_SYSTEM');
    $variables['GEN_LBL_LOGIN_SKIN'] = dict('GEN_LBL_LOGIN_SKIN');
    $variables['GEN_LBL_LOGIN_LANGUAGE'] = dict('GEN_LBL_LOGIN_LANGUAGE');
    $variables['GEN_LBL_LOGIN_LOGIN'] = dict('GEN_LBL_LOGIN_LOGIN');
    $variables['GEN_LBL_LOGIN_HELP'] = dict('GEN_LBL_LOGIN_HELP');
    $variables['GEN_LBL_LOGIN_NOTEEMAIL'] = dict('GEN_LBL_LOGIN_NOTEEMAIL');
    $variables['GEN_LBL_LOGIN_EMAIL'] = dict('GEN_LBL_LOGIN_EMAIL');
    $variables['GEN_LBL_SUBMIT'] = dict('GEN_LBL_SUBMIT');
    $variables['GEN_LBL_LOGIN_LOGINFORM'] = dict('GEN_LBL_LOGIN_LOGINFORM');
    $variables['CLX_ENCODING'] = 'UTF-8';
    $variables['DBNOPTIONS'] = dbnOptions();
    $variables['SKNOPTIONS'] = sknOptions();
    $variables['LANOPTIONS'] = lanOptions();
    $variables['ONLOAD'] = '';
    $variables['ONUNLOAD'] = '';
    //Alert Tool
    $variables['ALERTS'] = (defined('clxDisplayNoAlerts')) ? '' : alrt_count();
    $variables['BREADCRUMBS'] = '';
    return $variables;
}

/**
 * JQuery Includes
 * @return type
 */
function jQueryIncludes() {

    $return = CLX_CHAR_NL;
    if (!defined('kPathToJQuery')) {
        define('kPathToJQuery', '../extlibs/js/jquery-ui/');
    }
    $jqueryLibraries = array(kPathToExtLibJs . 'jquery/jquery-1.6.4.min.js', kPathToJQuery . 'jquery-ui-1.7.2.custom.min.js', kPathToJQuery . 'ui/ui.core.js', kPathToJQuery . 'ui/ui.slider.js', kPathToJQuery . 'ui/ui.progressbar.js', kPathToJQuery . 'ui/ui.sortable.js', kPathToJQuery . 'ui/ui.dialog.js', kPathToJQuery . 'jquery.maskedinput.js', kPathToJQuery . 'ui/timepicker.js', kPathToJQuery . 'ui/jquery.autocomplete.js', kPathToExtLibJs . 'jquery/jquery.hoverIntent.js', kPathToExtLibJs . 'jquery/jquery_calculator/jquery.calculator.js');
    $lang = substr(getCurrentLanguage(), CLX_NUM_ZERO, CLX_NUM_TWO);
	
		
    if ($lang <> 'en') {
        $jqueryLibraries[] = kPathToJQuery . 'ui/i18n/ui.datepicker-' . $lang . '.js';
        $jqueryLibraries[] = kPathToExtLibJs . 'jquery/jquery_calculator/jquery.calculator-' . $lang . '.js';
    }
    $jqueryStyles = array(kPathToJQuery . 'themes/base/ui.all.css', kPathToJQuery . 'themes/base/jquery.autocomplete.css', kPathToExtLibJs . 'jquery/jquery_calculator/jquery.calculator.css');
    foreach ($jqueryLibraries as $val) {
        $return .= setJavaScriptTag($val, true) . CLX_CHAR_NL;
    }
	$jqueryLibraries2=array();
//	$jqueryLibraries2[] = kPathToExtLibJs.  'jquery/jquery-3.5.1.min.js';
	
	foreach ($jqueryLibraries2 as $val) {
        $return .= setJavaScriptTag($val, true) . CLX_CHAR_NL;
    }
    foreach ($jqueryStyles as $val) {
        $return .= sprintf('<link href="%s" rel="stylesheet" type="text/css">', $val) . CLX_CHAR_NL;
    }

    //Initial scripts required for the entire application.
    $return .= setJavaScriptTag(getJavaScriptFilename('GEN_formctl.js'), true);

    return $return;
}
//------------------------------------------------------------------------------------------
function getStyleHtml() {
    return sprintf("<link href='%s' rel='stylesheet' type='text/css'>", kPathToSkins . $_SESSION["skin"] . "/styles.css");
}
/**
 *
 * @param type $kDatabase
 * @return string
 */
function dbnOptions() {
    $return = '';
    foreach (ClxCommon::$cached['kDatabase'] as $key => $val) {
        $return .='<option value=' . $key.' ';
        if (strval(kDatabaseNo) === strval($key)) {
            $return .=' selected';
        }
        $return .='>' . $val[CLX_NUM_ZERO] . '</option>';
    }
    return $return;
}

function sknOptions() {
    $return = '';
    if (empty($_SESSION['skin'])) {
        $_SESSION['skin'] = 'default';
    }
    $skins = dir(kPathToWebSite . kPathToSkins);
    while ($skin = $skins->read()) {
        if (strstr($skin, '.') !== false) {
            continue;
        }
        $return .='<option value="' . $skin . '"';
        if ($_SESSION['skin'] == $skin) {
            $return .=' selected';
        }
        $return .='>' . $skin . '</option>';
    }
    return $return;
}

function lanOptions() {
    $return = '';
    //[LANOPTIONS]
    $DBLT = &getTool('DBLT');
    $languages = $DBLT->getListAsArray('LANG');
    if (!defined('kSystemLoginLanguage')) {
        define('kSystemLoginLanguage', kSystemLanguage);
    }
    $curlan = kSystemLoginLanguage;
    if (!empty(UserRequest::$get['lan'])) {
        $curlan = UserRequest::$get['lan'];
    }
    foreach ($languages as $key => $val) {
		$key=lowercase($key);
        $return .='<option value="' . $key . '"';
        if ($curlan == $key) {
            $return .=' selected';
        }
        $return .='>' . $val . '</option>';
    }
    return $return;
}

function getSkinForm($formname, $variables) {if ( isset($_SESSION["_dEBUGX"]) and $_SESSION["_dEBUGX"]==99) { $tta=fopen(kPathToWebSite."/".kPathToTemp."archivo4.txt","a+");	fwrite($tta,chr(13).chr(10)."13011- hora:".date("h:i:s d/m/Y").chr(13).chr(10));$te=debug_backtrace();for ($t=0;$t<18;$t++) {	if (isset($te[$t]["file"]))	fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));	}fwrite($tta,chr(13).chr(10));fclose($tta);}
    $filename = kPathToWebSite . kPathToSkins . $_SESSION['skin'] . '/forms/' . $formname;
    $menustatus = (!array_key_exists('pagemenu', UserRequest::$cookies)) ? 'block' : UserRequest::$cookies['pagemenu'];
    $variables['MENU_STYLE'] = 'display:' . $menustatus . ';';
    if (!isset($variables['SKIN'])) {
        $variables['SKIN'] = kPathToSkins . $_SESSION['skin'] . '/';
    }
    $f = new clx_filesystem();
    $form = $f->rFile($filename, true);
	
    foreach ($variables as $key => $value) {
		$form = str_replace('[' . $key . ']', $value, $form);
    }

    return $form;
}

function getSkinHtmlStyleReport($contents,$js) {if ( isset($_SESSION["_dEBUGX"]) and $_SESSION["_dEBUGX"]==99) { $tta=fopen(kPathToWebSite."/".kPathToTemp."archivo4.txt","a+");	fwrite($tta,chr(13).chr(10)."12004- hora getSkinHtmlStyleReport_interface:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,chr(13).chr(10));fclose($tta);}
    return '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html50/loose.dtd">' . CLX_CHAR_NL . '<html><head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8"><link href="' . kPathToSkins . $_SESSION['skin'] . '/styles.css" rel="stylesheet" type="text/css">'.(($js=='')?'':jQueryIncludes().'<script type="text/javascript" src="'.$js.'"></script>').'</head><body>' . $contents . '</body></html>';
}

function skinPath() {if ( isset($_SESSION["_dEBUGX"]) and $_SESSION["_dEBUGX"]==99) { $tta=fopen(kPathToWebSite."/".kPathToTemp."archivo4.txt","a+");	fwrite($tta,chr(13).chr(10)."12003- hora skinspath_interface:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,chr(13).chr(10));fclose($tta);}
    return kWebSite . kPathToSkins . $_SESSION['skin'];
}

/**
 * Displays path visited
 * @return type
 */
function makeBreadCrumbs() {if ( isset($_SESSION["_dEBUGX"]) and $_SESSION["_dEBUGX"]==99) { $tta=fopen(kPathToWebSite."/".kPathToTemp."archivo4.txt","a+");	fwrite($tta,chr(13).chr(10)."12002- hora makeBreadCrumbs_interface:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,chr(13).chr(10));fclose($tta);}
    if (empty($_SESSION ['history'])) {
        return '';
    }
    $list = '';
    $delim = '';
    $done = array();
    foreach (currentHistory() as $info) {
        if (empty($info['li']))
            continue;
        if (array_key_exists($info['li'], $done))
            continue;
        $UILG = &getTool('UILG');
        $listingrec = $UILG->getToolRecord($info['li']);
        if (!empty($listingrec['TITLE'])) {
            $done[$info['li']] = dict($listingrec['TITLE']);
        } else {
            $done[$info['li']] = '*';
        }
        $list .= $delim . $done[$info['li']];
        $delim = '>>';
    }
    $table = new htmlTable(CLX_WIDTH_ONE);
    $table->setProps(array(CLX_PROP_CLASS => 'gen_title'));
    $table->addCell($list, array(CLX_PROP_CLASS => 'historyDisplay'));
    return $table->source();
}

function alert($msg) {
    $qty = func_num_args();
    $button = ($qty > CLX_NUM_ONE) ? func_get_arg(CLX_NUM_ONE) : '';
    return dialog(dict('GEN_LBL_ALERT'), CLX_CLASS_ALERT, $msg, $button);
}

function note($msg) {
	if ( isset($_SESSION["_dEBUGX"]) and $_SESSION["_dEBUGX"]==99) { $tta=fopen(kPathToWebSite."/".kPathToTemp."archivo4.txt","a+");	fwrite($tta,chr(13).chr(10)."101- hora:".date("h:i:s d/m/Y").chr(13).chr(10));$te=debug_backtrace();for ($t=0;$t<18;$t++) {	if (isset($te[$t]["file"]))	fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));	}fwrite($tta,chr(13).chr(10));fclose($tta);}
    $qty = func_num_args();
    $button = ($qty > CLX_NUM_ONE) ? func_get_arg(CLX_NUM_ONE) : '';
    return dialog(dict('GEN_LBL_NOTE'), CLX_CLASS_PROMPT, $msg, $button);
}

function warning($msg) {
    $qty = func_num_args();
    $button = ($qty > CLX_NUM_ONE) ? func_get_arg(CLX_NUM_ONE) : '';
    return dialog(dict('GEN_LBL_WARNING'), CLX_CLASS_PROMPT, $msg, $button);
}

function record_display_dialog($record, $title, $class, $msg, $button) {
    $table = new htmlTable(CLX_WIDTH_ONE);
    $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));

    $table->addCell($title, array(CLX_PROP_CLASS => CLX_CLASS_TITLE));
    $table->addCell($msg, array(CLX_PROP_CLASS => $class));
    foreach ($record as $key => $val) {
        $fieldrec = ClxCommon::$db->getRecord('CLX_DB_FIELDS', 'FIELDNAME=' . singleQuote($key));
        if (empty($fieldrec)) {
            continue;
        }
        $fieldrec['FIELD_HIDDEN'] = CLX_INIT_ZERO;
        $fieldrec['CAPTION'] = '';
        $fieldinstance = getToolObject('DBFT', $fieldrec['FIELDTYPE']);
        $cell = $fieldinstance->placeViewField($key, $fieldrec, $record);
        $table->addCell($cell->source(), array(CLX_PROP_CLASS => 'formdata'));
    }
    if (!empty($button)) {
        $url = 'tool.php?pop=1';
        $c = new htmlButtonGoto($button, $url);
        $table->addCell($c->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS));
    }
    return $table->source();
}

function dialog($title, $class, $msg, $button) {if ( isset($_SESSION["_dEBUGX"]) and $_SESSION["_dEBUGX"]==99) { $tta=fopen(kPathToWebSite."/".kPathToTemp."archivo4.txt","a+");	fwrite($tta,chr(13).chr(10)."12008- hora dialog_interface:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,chr(13).chr(10));fclose($tta);}
    $table = new htmlTable(CLX_WIDTH_ONE);
    $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
    $table->addCell($title, array(CLX_PROP_CLASS => CLX_CLASS_TITLE));
    $table->addCell($msg, array(CLX_PROP_CLASS => $class));
    if (!empty($button)) {
        $url = 'tool.php?pop=1';
        $c = new htmlButtonGoto($button, $url);
        $table->addCell($c->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS));
    }
    return $table->source();
}

function getSkinIcon($iconname, $url, $title, $w = CLX_NUM_ZERO, $h = CLX_NUM_ZERO, $align = '') {	if ( isset($_SESSION["_dEBUG"]) and $_SESSION["_dEBUG"]==99) { $tta=fopen(kPathToWebSite."/".kPathToTemp."archivo4.txt","a+");	fwrite($tta,chr(13).chr(10)."13001- hora:".date("h:i:s d/m/Y").chr(13).chr(10));$te=debug_backtrace();for ($t=0;$t<18;$t++) {	if (isset($te[$t]["file"]))	fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));	}fwrite($tta,chr(13).chr(10));fclose($tta);}
    $filename = kPathToSkins . $_SESSION['skin'] . '/icons/' . lowercase($iconname) . '.gif';
    $i = new htmlImage($filename, $title);
    if ($w <> CLX_NUM_ZERO)
        $i->setProp(CLX_PROP_WIDTH, $w);
    if ($h <> CLX_NUM_ZERO)
        $i->setProp('height', $h);
    if ($align <> '')
        $i->setProp(CLX_PROP_ALIGN, $align);
    if (!empty($url)) {
        $c = new htmlAnchor($i->source(), $url);
        $contents = $c->source();
    } else {
        $contents = $i->source();
    }
    return $contents;
}

/**
 *
 * @param type $iconname
 * @param type $name
 * @param type $title
 * @param type $to
 * @param type $ac
 * @param type $w
 * @param type $h
 * @param type $align
 * @return type
 */
function getSkinIconPop($iconname, $title, $to, $ac, $target) {
    $url = 'javascript:openWindow(' . singleQuote(CLX_CHAR_EMPTY_STRING) . ', ' . singleQuote('pop.php?to=' . $to . '&ac=' . $ac . '&target=' . $target) . ', ' . CLX_SRCH_WIN_DEF_WIDTH . ', ' . CLX_SRCH_WIN_DEF_HEIGHT . ');';
    return '<!-- openUbicacionwindow12 -->'.getSkinIcon($iconname, $url, $title, null, null, null);
}

function getSkinImage($imagename, $title) {
    $filename = kPathToSkins . $_SESSION['skin'] . '/images/' . $imagename;
    $i = new htmlImage($filename, $title);
    return $i->source();
}

function getSkinImagePath($imagename) {
    return kPathToSkins . $_SESSION['skin'] . '/images/' . $imagename;
}

function getJavaScriptFilename($scriptname) {
    if (array_key_exists('client', $_SESSION) && file_exists('js/' . $_SESSION['client']['browser'] . '/' . $scriptname)) {
        $filename = 'js/' . $_SESSION['client']['browser'] . '/' . $scriptname;
    } elseif (file_exists('js/standard/' . $scriptname)) {
        $filename = 'js/standard/' . $scriptname;
    } else {
        $filename = '';
    }
    return $filename;
}

function getJavaScript($scriptname, $variables) {
    $filename = getJavaScriptFilename($scriptname);
    $script = '';
    if (!empty($filename)) {
        $fd = fopen($filename, 'r');
        if ($fd !== false) {
            $script = fread($fd, filesize($filename));
            fclose($fd);
            if (is_array($variables)) {
                reset($variables);
                foreach ($variables as $key => $value) {
                    $script = str_replace('[' . $key . ']', $value, $script);
                }
            }
        } else {
            $script = alert('Can' . CLX_CHAR_SINGLE_QUOTE . 't open script: ' . $filename . ' / ' . $scriptname);
        }
    } else {
        $script = alert('Can' . CLX_CHAR_SINGLE_QUOTE . 't find script: ' . $filename . ' / ' . $scriptname);
    }
    return $script;
}

/**
 * Return formated string conteining javascript tags
 *
 * @param String $code
 * @param Boolean $is_include_file
 */
function setJavaScriptTag($code, $is_include_file = false, $use_jquery_include = false) {
    if ($is_include_file === true) {
		// 2018-11-16 CR - Caso 1003486 - GB-Rep BATCH no arranca
	    if ($use_jquery_include === true) {
		    $retorno= sprintf('<script type="text/javascript">' .CLX_CHAR_CR . CLX_CHAR_NL . 'var url = "%s";' .CLX_CHAR_CR . CLX_CHAR_NL . '$.holdReady(true);' .CLX_CHAR_CR . CLX_CHAR_NL . 'function releaseHold() { $.holdReady(false); }' .CLX_CHAR_CR . CLX_CHAR_NL . '$.getScript(url, releaseHold);' .CLX_CHAR_CR . CLX_CHAR_NL . '</script>', $code);
		} else {
		    $retorno= sprintf('<script src="%s" type="text/javascript"></script>', $code);
		}
    } else {
        $retorno= sprintf('<script type="text/javascript">' .CLX_CHAR_CR. CLX_CHAR_NL . '//<![CDATA[' .CLX_CHAR_CR. CLX_CHAR_NL . '%s' . CLX_CHAR_CR.CLX_CHAR_NL . '//]]>' . CLX_CHAR_NL . '</script>', $code);
    }
    return $retorno;
}

function ajaxFullRequest($request, $redirect = '') {
    if ($redirect <> '') {
        $tx = '<!--' . CLX_CHAR_NL . 'sendFullRequestRedirected(' . singleQuote($request) . ', ' . singleQuote($redirect) . ');' . CLX_CHAR_NL . '-->' . CLX_CHAR_NL;
    } else {
        $tx = '<!--' . CLX_CHAR_NL . 'sendFullRequest(' . singleQuote($request) . ' );' . CLX_CHAR_NL . '-->' . CLX_CHAR_NL;
    }
    $js = new htmlObject('script');
    $js->setProp('language', 'javascript');
    $js->setContents($tx);
    return $js->source();
}

/**
 * Build ajex container and sends request
 * Sample request to=EDIT&ac=DISPLAY&li=MARK_CAMP&qy=MARK_CAMP&idlist=1
 * @param string $request_url
 * @param string $container
 * @return string $html
 */
function ajaxRequest($request, $container = 'divajax', $waiticon = 'sqsWait', $waitlbl = '') {
    $tx = '<--' . CLX_CHAR_NL . 'sendRequest(' . singleQuote($container) . ', ' . singleQuote($request) . ');' . CLX_CHAR_NL . '-->' . CLX_CHAR_NL;
    $js = new htmlObject('script');
    $js->setProp('language', 'javascript');
    $js->setContents($tx);
    return ajaxContainer($container, $waiticon, $waitlbl) . $js->source();
}

function ajaxContainer($name, $waiticon = 'sqsWait', $waitlbl = '') {
    $div = new htmlObject('div');
    $div->setProp(CLX_PROP_ID, $name);
    $div->setProp('name', $name);
    $div->setProp('WIDTH', CLX_PROP_100PCT);
    $table = new htmlTable(CLX_WIDTH_ONE);
    $table->setProps(array('WIDTH' => CLX_PROP_100PCT));
    $table->addCell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_ALIGN => 'center'));
    if ($waiticon <> '') {
        $table->addCell(getSkinIcon($waiticon, '', dict('GEN_LBL_WAIT')), array(CLX_PROP_ALIGN => 'center'));
        $table->addCell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_ALIGN => 'center'));
    }
    if ($waitlbl === '') {
        $table->addCell(dict('GEN_LBL_WAIT'), array(CLX_PROP_ALIGN => 'center'));
    } else {
        $table->addCell($waitlbl, array(CLX_PROP_ALIGN => 'center'));
    }
    $table->addCell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_ALIGN => 'center'));
    $contents = $table->source();
    $div->setContents($contents);
    return $div->source();
}

function pageMenus() {
$a=microtime(true);	
		$menus = array();
		$buttons = '<table>';
		$visiblepath = (isset(UserRequest::$cookies[kSideBarCookieName])) ? UserRequest::$cookies[kSideBarCookieName] : '';
		if (ClxCommon::sessionHasUser()) {
			$buttons .= '<tr>';
			$buttons .= sprintf('<td align=' . singleQuote('center') . '><a href=' . singleQuote('index.php') . ' alt=' . singleQuote('%s') . '><img src=' . singleQuote('%s') . ' border=' . singleQuote(CLX_CHAR_EMPTY_STRING) . '><br><p>%s</p></a></td>', dict('GEN_URL_WELCOME'), kPathToSkins . $_SESSION['skin'] . '/icons/home.jpg', dict('GEN_URL_WELCOME'));
			$buttons .= sprintf('<td align=' . singleQuote('center') . '><a href=' . singleQuote('tool.php?to=EDIT&ac=LIST&li=HPGS&menuid=HPGS') . ' alt=' . singleQuote('%s') . '><img src=' . singleQuote('%s') . ' border=' . singleQuote(CLX_CHAR_EMPTY_STRING) . '><br><p>%s</p></a></td>', dict('GEN_URL_HELP'), kPathToSkins . $_SESSION['skin'] . '/icons/help.jpg', dict('GEN_URL_HELP'));
			if (defined('kChatEnabled') && kChatEnabled) {
				$buttons .= sprintf('<td align=' . singleQuote('center') . '><a href="javascript:openWindow(' . singleQuote('Chat') . ', ' . singleQuote(kPathToChat) . ', ' . CLX_NUM_500 . ' , 380)" alt=' . singleQuote('%s') . '><img src=' . singleQuote('%s') . ' border=' . singleQuote(CLX_CHAR_EMPTY_STRING) . '><br><p>%s</p></a></td>', dict('GEN_URL_CHAT'), kPathToSkins . $_SESSION['skin'] . '/icons/people.gif', dict('GEN_URL_CHAT'));
			}
			$buttons .= sprintf('<td align=' . singleQuote('center') . '><a href=' . singleQuote('tool.php?to=USPR&ac=MODIFY') . ' alt=' . singleQuote('%s') . '><img src=' . singleQuote('%s') . ' border=' . singleQuote(CLX_CHAR_EMPTY_STRING) . '><br><p>%s</p></a></td>', dict('MENU_PREFERENCES'), kPathToSkins . $_SESSION['skin'] . '/icons/prefs.gif', dict('MENU_PREFERENCES'));
			$acus_logout_active = trim(( defined('ACUS_LOGOUT_ACTIVE') ? ACUS_LOGOUT_ACTIVE : '1' ));
			$acus_logout_target = trim(( defined('ACUS_LOGOUT_TARGET') ? ACUS_LOGOUT_TARGET : 'null' ));
			if (is_null($acus_logout_target) || $acus_logout_target === 'null' || $acus_logout_target === '') {
				$acus_logout_target = '';
			} else {
				$acus_logout_target = ' target=' . singleQuote($acus_logout_target);
			}
			// Caso 1002901 - BEGIN
			$acus_logout_url = trim(( defined('ACUS_LOGOUT_JS') ? ACUS_LOGOUT_JS : 'null' ));
			if (is_null($acus_logout_url) || $acus_logout_url === 'null' || $acus_logout_url === '') {
				$acus_logout_url = 'logoff.php';
			}
			// Caso 1002901 - END
			if (!empty(UserRequest::$request['ibslog'])) {
				$_SESSION['ibslog'] = UserRequest::$request['ibslog'];
			}
			switch ($acus_logout_active) {
				case '1':
				case '2':
					if (empty($_SESSION['ibslog'])) {
						$acus_logout_target = '';
					}
					break;
				default:
					break;
			}
			if ($acus_logout_active !== '0') {
				$buttons .= sprintf('<td align=' . singleQuote('center') . '><a href=' . singleQuote($acus_logout_url) . ' alt=' . singleQuote('%s') . $acus_logout_target . '><img src=' . singleQuote('%s') . ' border="0"><br><p>%s</p></a></td>', dict('GEN_URL_LOGOFF'), kPathToSkins . $_SESSION['skin'] . '/icons/logoff.jpg', dict('GEN_URL_LOGOFF'));
			}
			$buttons .= '</tr>';
			$UIMI = &getTool('UIMI');
			
			$UIMI->getMenu($menus);
		} else {
			//If user is not logged
			$buttons .= sprintf('<tr><td align=' . singleQuote('center') . '><a href=' . singleQuote('index.php') . ' alt=' . singleQuote('%s') . '><img src=' . singleQuote('%s') . ' border=0><br><p>%s</p></a></td></tr>', dict('GEN_URL_LOGON'), kPathToSkins . $_SESSION['skin'] . '/icons/login.jpg', dict('GEN_URL_LOGON'));
		}
		$buttons .= '</table>';
		$list = CLX_CHAR_NL;
		paintMenu($list, 'menubar', $menus);
		// Setting Variables
		if (empty($_SESSION['user_record']['username'])) {
			$_SESSION['user_record']['username'] = '';
		}
		if (empty($_SESSION['user_record']['firstname'])) {
			$_SESSION['user_record']['firstname'] = '';
		}
		if (empty($_SESSION['user_record']['lastname'])) {
			$_SESSION['user_record']['lastname'] = '';
		}
		$list .= CLX_CHAR_NL . ' var username = ' . singleQuote($_SESSION['user_record']['username']) . ';' . CLX_CHAR_NL;
		$list .= ' var firstname = ' . singleQuote($_SESSION['user_record']['firstname']) . ';' . CLX_CHAR_NL;
		$list .= ' var lastname = ' . singleQuote($_SESSION['user_record']['lastname']) . ';' . CLX_CHAR_NL;
		$list .= ' var version = ' . singleQuote(kSystemVersion) . ';' . CLX_CHAR_NL;
		$list .= ' var sysloc = ' . singleQuote(kDatabaseDisplay . '@' . UserRequest::$server['HTTP_HOST']) . ';' . CLX_CHAR_NL;
		$list .= ' var cookiename = ' . singleQuote(kSideBarCookieName) . ';' . CLX_CHAR_NL;
		$list .= ' var skindir = ' . singleQuote(kPathToSkins . $_SESSION['skin']) . ';' . CLX_CHAR_NL;
		$list .= ' var visiblepath = ' . singleQuote(string_encode(clx_html_spchrs_decode($visiblepath))) . ';' . CLX_CHAR_NL;
		$list .= ' var menuTitle = ' . singleQuote(dict('GEN_LBL_OPTIONS')) . ';' . CLX_CHAR_NL;
		$list .= ' document.write(paintMenuBar());'.CLX_CHAR_NL.'setCookie("dbn", '.kDatabaseNo.');' . CLX_CHAR_NL;
		$script = setJavaScriptTag($list) . CLX_CHAR_NL;
		$_SESSION["XMENUS"]=$buttons . $script;
		return $buttons . $script;
	//}	
	//else {
	//	return $_SESSION["XMENUS"];
		
	//}	
}

/**
 * Loads menu options
 * @param string $list
 * @param string $prompt
 * @param array $menus
 */
function paintMenu(&$list, $prompt, $menus) {
	//pre($menus);
    $list .= $prompt . ' = new Array();' . CLX_CHAR_NL;
    if (!empty($menus)) {
        foreach ($menus as $key => $value) {
            if (is_array($value)) {
                paintMenu($list, $prompt . '[' . singleQuote($key) . ']', $value);
            } else {
                $list .= $prompt . '[' . singleQuote($key) . '] = ' . singleQuote($value) . ';' . CLX_CHAR_NL;
            }
        }
    }
}

function wysiwyg($form_fieldname, $readonly = CLX_NUM_ZERO) {
    $contents = '<!-- TinyMCE -->
                <script type=' . singleQuote('text/javascrip') . ' src=' . singleQuote(kPathToExtLibJs . 'tinymce403/js/tinymce/tinymce.min.js') . '></script>
                <script type=' . singleQuote('text/javascrip') . '>
                	tinyMCE.init({
                		// General options
                		//mode : ' . singleQuote('textarea') . ',
                		selector: ' . CLX_CHAR_SINGLE_QUOTE . 'textarea#' . singleQuote($form_fieldname) . ',
                		convert_urls : false,
                		plugins: [' . singleQuote('visualblock') . ',
				                ' . singleQuote('advlist autolink autosave link image lists charmap print preview hr anchor pagebreak spellchecke') . ', ' . singleQuote('searchreplace wordcount visualblocks visualchars code fullscreen insertdatetime media nonbreakin') . ', ' . singleQuote('table contextmenu directionality emoticons template textcolor paste fullpage textcolo') . ' ], toolbar1: ' . singleQuote('newdocument fullpage | bold italic underline strikethrough | alignleft aligncenter alignright alignjustify | styleselect formatselect fontselect fontsizeselec') . ', toolbar2: ' . singleQuote('cut copy paste | searchreplace | bullist numlist | outdent indent blockquote | undo redo | link unlink anchor image media code | inserttime preview | forecolor backcolo') . ', toolbar3: ' . singleQuote('table | hr removeformat | subscript superscript | charmap emoticons | print fullscreen | ltr rtl | spellchecker | visualchars visualblocks nonbreaking template pagebreak restoredraf') . ', menubar: false, toolbar_items_size: ' . singleQuote('smal') . ', style_formats: [ {title: ' . singleQuote('Bold tex') . ', inline: ' . singleQuote(CLX_CHAR_EMPTY_STRING) . '}, {title: ' . singleQuote('Red tex') . ', inline: ' . singleQuote('spa') . ', styles: {color: ' . singleQuote('#ff000') . '}}, {title: ' . singleQuote('Red heade') . ', block: ' . singleQuote('h') . ', styles: {color: ' . singleQuote('#ff000') . '}}, {title: ' . singleQuote('Example ') . ', inline: ' . singleQuote('spa') . ', classes: ' . singleQuote('example') . '}, {title: ' . singleQuote('Example ') . ', inline: ' . singleQuote('spa') . ', classes: ' . singleQuote('example') . '}, {title: ' . singleQuote('Table style') . '}, {title: ' . singleQuote('Table row ') . ', selector: ' . singleQuote('t') . ', classes: ' . singleQuote('tablerow') . '} ], templates: [ {title: ' . singleQuote('Test template ') . ', content: ' . singleQuote('Test ') . '}, {title: ' . singleQuote('Test template ') . ', content: ' . singleQuote('Test ') . '} ], // Replace values for the template plugin template_replace_values : { username : ' . singleQuote('Some Use') . ', staffid : ' . singleQuote('99123') . ' } }); </script> <!-- /TinyMCE --> ';
    return $contents;
}
