<?php

/**
 * General Functions
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-09-03 16:24:19 +0000 (Thu, 03 Sep 2015) $
 * @version        $Rev: 6814 $
 *
 * CHANGE LOG
 *  Included label
 */
class plot extends clx_object {

    var $operators;
    var $plotfile;
    var $has_range;
    var $serie_types;

    /**
     * CONSTRUCTOR
     */
    function plot() {
        $this->code = 'PLOT';
        $this->name = 'Generic Clientix Plot';
        $this->type = '----';
        $this->version = '1.0.0.0';
        $this->description = 'This is a Generic Clientix Plot';
        $this->plotfile = '';
        $this->has_range = false;
        $this->serie_types = array('VAL' => dict('GEN_LABEL_VALUE'),
            'CAT' => dict('GEN_LABEL_CATEGORY'),
            'XAXI' => dict('GEN_LABEL_XAXIS'),
            'YAXI' => dict('GEN_LABEL_YAXIS'),
            'PROC' => dict('GEN_LBL_PROCESS'),
            'PKEY' => dict('GEN_LBL_PRIMARYKEY'),
            'TASK' => dict('GEN_LBL_TASK'),
            'SESD' => dict('GEN_LBL_SERIES_SDATE'),
            'SEED' => dict('GEN_LBL_SERIES_EDATE'),
            'TASA' => dict('GEN_LBL_ACTUAL_TASK'),
            'SASD' => dict('GEN_LBL_SERIES_ACTUAL_SDATE'),
            'SAED' => dict('GEN_LBL_SERIES_ACTUAL_EDATE'));
    }

    /**
     * The following procedures are intented to be used by the Database
     * Administrator to interface with the user when creating new fields in the database.
     */
    function panel($msg, $plotrecord, &$form) {
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $table->addCell('This is the panel for field: ' . $this->code, array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $div = new htmlDiv($this->code, 'visibility:hidden; display:none', $table->source());
        return CLX_CHAR_NL . CLX_CHAR_NL . $div->source() . CLX_CHAR_NL . CLX_CHAR_NL;
    }

    function checkPanel(&$msg) {
        $msg['SOMETHING'] = 'This field does not have defined a checkPanel function';
    }

    function createPanel(&$plotrecord) {

    }

    function savePanel(&$plotrecord) {

    }

    function loadPanel(&$plotrecord, $values) {

    }

    function deletePanel($plotrecord) {

    }

    function defaultPanel(&$plotrecord) {

    }

    function viewForm_2(&$table, $record) {

    }

    function defaultRange($plotrecord) {

    }

    /**
     * Builds Plot XML
     * General set to single series
     */
    function build($plotrecord) {
        if (!empty($plotrecord))
            $sourceData = $this->plotData($plotrecord);
        if (!empty($sourceData)) {
            /** Chart Data start * */
            /** XML Setup * */
            $basefont = ($plotrecord['FONTTYPE'] === '') ? 'arial' : $plotrecord['FONTTYPE'];
            $baseFontSize = $plotrecord['FONTSIZE'];
            /** XML Creation * */
            $data = new XMLObject('graph');
            $data->setProp('basefontsize', $baseFontSize);
            $data->setProp('basefont', $basefont);
            $data->setProp('caption', dict($plotrecord['TITLE']));
            $data->setProp('subCaption', dict($plotrecord['SUBTITLE']));
            $data->setProp('xaxisname', dict($plotrecord['XLABEL']));
            $data->setProp('yaxisname', dict($plotrecord['YLABEL']));
            /** PLOT Data * */
            $values = array();
            reset($sourceData);
            foreach ($sourceData as $key => $val) {
                $set = new XMLObject('set');
                reset($val);
                foreach ($val as $key2 => $val2) {
                    switch ($val2['type']) {
                        case 'VAL':
                            $set->setProp('value', $val2['val']);
                            $values[] = $val2['val'];
                            break;
                        case 'CAT':
                            $set->setProp('name', $val2['val']);
                            break;
                        default:
                            break;
                    }
                }//end while
                $set->setProp('color', $this->pickColor());
                $set->setProp('link', '');
                $data->addObject($set);
            }//end while
            /* Plot Extras */
            $set = new XMLObject('trendlines');
            if ($plotrecord['LINE_AVERAGE'] === true) {
                $sum = CLX_INIT_ZERO;
                $ave = CLX_INIT_ZERO;
                foreach ($values as $key => $val)
                    $sum += $val;
                $cont = count($values);
                if ($cont > CLX_NUM_ZERO) {
                    $ave = $sum / $cont;
                }
                $line = new XMLObject('line');
                $line->setProp('value', $ave);
                $line->setProp('displayValue', dict('GEN_LABEL_AVERAGE'));
                $line->setProp('color', '#FFCC00');
                $line->setProp('thickness', '1');
                $line->setProp('alpha', CLX_NUM_HUNDRED);
                $set->addObject($line);
                unset($ave);
            }
            if ($plotrecord['LINE_MAX'] === true) {
                sort($values, SORT_NUMERIC);
                reset($values);
                $key = count($values) - CLX_NUM_ONE;
                if (isset($values[$key]))
                    $max = $values[$key];
                else
                    $max = CLX_INIT_ZERO;
                $line = new XMLObject('line');
                $line->setProp('value', $max);
                $line->setProp('displayValue', dict('GEN_LABEL_MAX'));
                $line->setProp('color', '#339900');
                $line->setProp('thickness', '1');
                $line->setProp('alpha', CLX_NUM_HUNDRED);
                $set->addObject($line);
                unset($max);
            }
            if ($plotrecord['LINE_MIN'] === true) {
                sort($values, SORT_NUMERIC);
                reset($values);
                if (isset($values[CLX_NUM_ZERO]))
                    $min = $values[CLX_NUM_ZERO];
                else
                    $min = CLX_INIT_ZERO;
                $line = new XMLObject('line');
                $line->setProp('value', $min);
                $line->setProp('displayValue', dict('GEN_LABEL_MIN'));
                $line->setProp('color', '#CC0000');
                $line->setProp('thickness', '1');
                $line->setProp('alpha', CLX_NUM_HUNDRED);
                $set->addObject($line);
                unset($min);
            }
            $data->addObject($set);
            $flash = array();
            $flash['TYPE'] = $this->plotfile;

            $flash['FILENAME'] = 'rep_' . $plotrecord['IDCODE'] . '_' . time('U') . '.xml';
            $data->save(kPathToWebSite . kPathToTemp . $flash['FILENAME']);
            $flash['WIDTH'] = $plotrecord['HSIZE'];
            $flash['HEIGHT'] = $plotrecord['VSIZE'];
            $flash['BORDER'] = $plotrecord['BORDER'];
            $flash['SWFFILE'] = 'plot/' . $flash['TYPE'] . '?dataUrl=' . kWebSite . 'temp/' . $flash['FILENAME'];
            $flash['ID'] = str_replace('.swf', '', $flash['TYPE']);
            $flash['ALIGN'] = '';
            $flash['BGCOLOR'] = '#FFFFFF';
            $contents = '<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6, 0, 0,0" WIDTH="' . $plotrecord['HSIZE'] . '" HEIGHT="' . $plotrecord['VSIZE'] . '" VIEWASTEXT>
			    <param NAME="movie" VALUE="' . $flash['SWFFILE'] . '&amp;chartWidth=' . $plotrecord['HSIZE'] . '&amp;chartHeight=' . $plotrecord['VSIZE'] . '">
			    <param NAME=' . singleQuote('FlashVar') . ' VALUE="">
						<param NAME=' . singleQuote('quality') . ' VALUE=' . singleQuote('high') . '>
						<param NAME=' . singleQuote('bgcolor') . ' VALUE=' . singleQuote('#FFFFFF') . '>
						<embed src="' . $flash['SWFFILE'] . '&amp;chartWidth=' . $plotrecord['HSIZE'] . '&amp;chartHeight=' . $plotrecord['VSIZE'] . '" FlashVars="" quality="high" bgcolor="#FFFFFF" NAME="FusionCharts" ALIGN TYPE="application/x-shockwave-flash" WIDTH="' . $plotrecord['HSIZE'] . '" HEIGHT="' . $plotrecord['VSIZE'] . '" PLUGINSPAGE="http://www.macromedia.com/go/getflashplayer">
						</object>';
        }else {
            $contents = dict('GEN_ERROR_INVALID_CHART_OR_SEARCH');
        }
        return $contents;
    }

    /**
     * Construct Data Series
     */
    function plotData($plotrecord) {
        $series_data = array();
        $fields_cache = array();
        $this->plotQuery($plotrecord, $series_records, $sql);
        $records = ClxCommon::$db->executeQuerySilent($sql);
        if ($records === true) {
            $i = CLX_INIT_ZERO;
            while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
                foreach ($series_records as $series_rec) {
                    $pos = strpos($series_rec['AS'], '_', CLX_NUM_ZERO) + CLX_NUM_ONE;
                    $steps = strlen($series_rec['AS']) - $pos;
                    $fieldname = substr($series_rec['AS'], $pos, $steps);
                    if (array_key_exists($fieldname, $fields_cache)) {
                        $fieldrec = $fields_cache[$fieldname];
                    } else {
                        $fieldrec = ClxCommon::$db->getRecord('CLX_DB_FIELDS', 'FIELDNAME=' . singleQuote($fieldname));
                        $fields_cache[$fieldname] = $fieldrec;
                    }
                    if (!empty($fieldrec)) {
                        $fieldinstance = getToolObject('DBFT', $fieldrec['FIELDTYPE']);
                        $data = array();
                        $data[$fieldrec['FIELDNAME']] = $record[$series_rec['AS']];
                        if ($fieldrec['FIELDTYPE'] === 'DECN' || $fieldrec['FIELDTYPE'] === 'INTN') {
                            $value = $data[$fieldrec['FIELDNAME']]; // Field format as string could damage the plot
                        } else {
                            if ($series_rec['FORMAT'] === true) {
                                $value = $fieldinstance->formatField($fieldrec['FIELDNAME'], $fieldrec, $data);
                                if (stristr($value, 'pop.php?to=DICT&ac=CREATE_FAST&entry') !== false > CLX_NUM_ZERO)
                                    $value = $data[$fieldrec['FIELDNAME']];
                            }else {
                                $value = $data[$fieldrec['FIELDNAME']];
                            }
                        }
                        $data = array('val' => $value, 'type' => $series_rec['TYPE']);
                        $series_data[$i][] = $data;
                    }
                }
                $i++;
            }//end while
        } else {

            $series_data = array();
        }//end if
        return $series_data;
    }

    function plotQuery($plotrecord, &$series_records, &$sql) {
        $DBQY = &getTool('DBQY');
        $ANPS = &getTool('ANPS');
        $querycode = $plotrecord['QUERYCODE'];
        $queryrec = $DBQY->getQuery($this->code, $querycode);
        $chartseries = ClxCommon::$db->getRecords($ANPS->tablename, 'CHARTCODE=' . singleQuote($plotrecord['IDCODE']) . ' AND STATUS=1 ORDER BY SEQNUM');
        //Adding Filters
        $whereclause = stripslashes($_SESSION['paging'][$querycode . '_LIST']['criteria']);
        $sortclause = stripslashes($_SESSION['paging'][$querycode . '_LIST']['sortby']);
        if (strlen($whereclause) > CLX_NUM_ZERO && strlen($queryrec['WHERECLAUSE']) > CLX_NUM_ZERO)
            $whereclause .= ' AND ';
        if (strlen($sortclause) > CLX_NUM_ZERO && strlen($queryrec['SORTCLAUSE']) > CLX_NUM_ZERO)
            $whereclause .= ', ';
        $selectclause = '';
        $fromclause = $queryrec['FROMCLAUSE'];
        $whereclause .= $queryrec['WHERECLAUSE'];
        $groupclause .= $queryrec['GROUPCLAUSE'];
        $sortclause .= $queryrec['SORTCLAUSE'];
        $comma1 = '';
        $comma2 = '';
        $series_records = array();
        while (($series_rec = ClxCommon::$db->getNextRecord($chartseries))) {
            if (empty($series_rec['FUNCTION'])) {
                $as = $series_rec['TABLECODE'] . '_' . $series_rec['fieldname'];
                $selectclause .= $comma1 . $series_rec['TABLECODE'] . '.' . $series_rec['fieldname'] . ' ' . $as;
            } else {
                $as = $series_rec['TABLECODE'] . '_' . $series_rec['fieldname'];
                $selectclause .= $comma1 . $series_rec['FUNCTION'] . '(' . $series_rec['TABLECODE'] . '.' . $series_rec['fieldname'] . ')' . ' ' . $as;
            }
            $comma1 = ', ';
            if ($series_rec['GROUPBY'] === true) {
                $groupclause .= $series_rec['TABLECODE'] . '.' . $comma2 . $as;
                $comma2 = ', ';
            }
            $series_rec['AS'] = $as;
            $series_records[] = $series_rec;
        }//end while
        //Execute on search
        if ($plotrecord['EXEONSEARCH'] == CLX_NUM_ONE && empty($_SESSION['paging'][$querycode . '_LIST']['criteria'])) {
            if (strlen($whereclause) > CLX_NUM_ZERO)
                $whereclause .= ' AND ';
            $whereclause .= ' 2=1 ';
        }
        $sql = 'SELECT ' . $selectclause . ' FROM ' . $fromclause;
        if (!empty($whereclause))
            $sql .= ' WHERE ' . $whereclause;
        if (!empty($groupclause))
            $sql .= ' GROUP BY ' . $groupclause;
    }

    /**
     * Just a random color picker
     */
    function pickColor() {
        return '#' . dechex(rand(CLX_NUM_TEN, CLX_NUM_16777215));
    }

}
