<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
if (!class_exists('anog') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'anog.php';

class anog_html extends anog {

    var $template;

    function __construct() {
        $this->code = 'AHTM';
        $this->name = 'HTML';
        $this->type = 'ANOG';
        $this->version = '0.1.0.1';
        $this->description = 'Output Generator Form Format: HTML';
        $this->editPanel = array('entries' => array(
                array('label' => 'GEN_LBL_HTMLFILE',
                    'fields' => array(
                        array('name' => 'htmlfile', 'type' => 'file', 'required' => '1'))
                )
            )
        );
    }

    function extractFields($templaterec) {

        $templateid = $templaterec['ID'];
        $templatecode = $templaterec['IDCODE'];
        $this->deletefiles($templateid);
        $field_name = $this->type . '_htmlfile';

        $filename = kPathToWebSite . kPathToTemplates . $templateid . '.html';
        if (!is_writable(kPathToWebSite . kPathToTemplates)) {
            addMessage(dict('GEN_ERR_FILEUPLOADFAIL'));
            return;
        }
        if (!move_uploaded_file(UserRequest::$files[$field_name]['tmp_name'], $filename)) {
            addMessage(dict('GEN_ERR_FILEUPLOADFAIL'));
        }

        $fields = $this->getfields($templatecode);
        ClxCommon::$db->deleteRecords('CLX_AN_OUTPUT_GEN_FIELDS', 'TEMPLATECODE=' . singleQuote($templaterec['IDCODE']));
        $contents = file_get_contents($filename);
        $matches = gettags('clxfield', $contents);
        foreach ($matches[CLX_NUM_ZERO] as $field) {
            $field = str_replace('<clxfield>', '', $field);
            $field = str_replace('</clxfield>', '', $field);
            $record = array();
            if (array_key_exists($field, $fields)) {
                $record = $fields[$field];
            } else {
                $record['TEMPLATECODE'] = $templatecode;
                $record['FIELDNAME'] = addslashes($field);
                $record['MAP'] = addslashes($field);
            }
            $this->savefield($record);
        }
    }

    function deletefiles($templateid) {
        $this->deleteFile($templateid . '.html');
    }

    function printtemplate($templaterec, $tree, &$contents, &$headers) {
        $templateid = $templaterec['ID'];
        $filename = kPathToWebSite . kPathToTemplates . $templateid . '.html';
	echo $filename;
        $fd = new clx_file($filename, 'r');
        $fd->open();
        if (!$fd->hasError()) {
            $this->template = $fd->read(false);
            $fd->close();
        } else {
            $this->template = '';
        }

        $tree->set($this);
        $headers = array();
        $headers['Content-type'] = 'text/html';

        $contents = $this->template;
    }

    function set($field, $value) {
        $this->template = str_replace('<clxfield>' . $field . '</clxfield>', $value, $this->template);
    }

    function view_template($templaterec) {

        $content = '';
        $filename = kPathToWebSite . kPathToTemplates . $templaterec['ID'] . '.html';
        $fd = new clx_file($filename, 'r');
        $fd->open();
        if (!$fd->hasError()) {
            $content = $fd->read(false);
            $fd->close();
        } else {
            $content = alert(dict('GEN_ERR_CANT_OPEN_FILE'));
        }
        return $content;
    }

}
