<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
if (!class_exists('anog') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'anog.php';
if (!class_exists('FPDF') && file_exists(kPathToWebSite.kPathToFpdf . 'fpdf.php')) {
    include_once kPathToWebSite.kPathToFpdf . 'fpdf.php';
}
class anog_pdf extends anog {

    var $fd;

    function __construct() {
        $this->code = 'APDF';
        $this->name = 'Adobe PDF';
        $this->type = 'ANOG';
        $this->version = '0.1.1.1';
        $this->description = 'Output Generator Form Format: Adobe PDF';
        $this->hidden = (function_exists('fdf_create')) ? false : true;
        $this->editPanel = array('entries' => array(
                array('label' => 'GEN_LBL_FILES',
                    'fields' => array(
                        array('name' => 'pdffile', 'type' => 'file', 'label' => 'GEN_LBL_PDFFILE', 'required' => '1'),
                        array('name' => 'fdffile', 'type' => 'file', 'label' => 'GEN_LBL_FDFFILE', 'required' => '1'))
                )
            )
        );
    }

    function extractFields($templaterec) {
        $templateid = $templaterec['ID'];
        $templatecode = $templaterec['IDCODE'];
        $this->deletefiles($templateid);
        $pdf_filename = kPathToWebSite . kPathToTemplates . $templateid . '.pdf';
        $fdf_filename = kPathToWebSite . kPathToTemplates . $templateid . '.fdf';
        if (!move_uploaded_file(UserRequest::$files[$this->type . '_pdffile']['tmp_name'], $pdf_filename))
            addMessage(dict('GEN_ERR_FILEUPLOADFAIL'));

        if (!move_uploaded_file(UserRequest::$files[$this->type . '_fdffile']['tmp_name'], $fdf_filename))
            addMessage(dict('GEN_ERR_FILEUPLOADFAIL'));
        $fields = $this->getfields($templatecode);
        ClxCommon::$db->deleteRecords('CLX_AN_OUTPUT_GEN_FIELDS', 'TEMPLATECODE=' . singleQuote($templatecode));
        $fdf = fdf_open($fdf_filename);
        for ($field = fdf_next_field_name($fdf); $field !== ''; $field = fdf_next_field_name($fdf, $field)) {
            $record = array();
            if (array_key_exists($field, $fields)) {
                $record['TEMPLATECODE'] = $fields[$field]['templatecode'];
                $record['FIELDNAME'] = addslashes($fields[$field]['fieldname']);
                $record['MAP'] = addslashes($fields[$field]['map']);
            } else {
                $record['TEMPLATECODE'] = $templatecode;
                $record['FIELDNAME'] = addslashes($field);
                $record['MAP'] = addslashes($field);
            }
            $this->savefield($record);
        }
        fdf_close($fdf);
    }

    function deletefiles($templateid) {
        $this->deleteFile($templateid . '.pdf');
        $this->deleteFile($templateid . '.fdf');
    }

    function printtemplate($templaterec, $tree, &$contents, &$headers) {
        $templateid = $templaterec['ID'];
        $filename = kWebSite . kPathToTemplates . $templateid . '.pdf';
        $this->fd = fdf_create();
        $tree->set($this);
        if (!fdf_set_file($this->fd, $filename))
            salir('Cannot set file: ' . $filename);
        $headers = array();
        $headers['Content-type'] = 'application/vnd.fdf';
        $headers['Content-Disposition'] = 'attachment; filename=' . $templaterec['IDNAME'] . '.fdf';
        $headers['Pragma'] = 'no-cache';
        $headers['Expires'] = '0';
        $headers['Cache-control'] = 'private';
        $contents = fdf_save_string($this->fd);
        fdf_close($this->fd);
    }

    function set($field, $value) {
        if ($value === CLX_CHAR_HTML_NBSP)
            $value = ' ';
        fdf_set_value($this->fd, $field, $value);
    }

    function view_template($templaterec) {
        $filename = kPathToWebSite . kPathToTemplates . $templaterec['ID'] . '.pdf';
        header('Content-type: application/pdf');
        header('Content-Disposition: inline; filename=' . $templaterec['IDNAME'] . '.pdf');
        header('Pragma: no-cache');
        header('Expires: 0');
        header('Cache-control: private');
        if (is_readable($filename)) {
            $fd = fopen($filename, 'rb');
            echo fread($fd, filesize($filename));
            fclose($fd);
        } else {
            echo alert(dict('GEN_ERR_CANT_OPEN_FILE'));
        }
    }

}
