<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
class anor extends clx_object {

    var $editform;

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'ANOR';
        $this->name = 'Output Generator Form Group';
        $this->type = '----';
        $this->version = '0.1.1.0';
        $this->description = 'This is a Generic Output Generator Form Group';
        $this->editPanel = array('entries' => array(
                array('label' => 'GEN_LBL_HTMLFILE',
                    'fields' => array(
                        array('name' => 'htmlfile', 'type' => 'file', 'required' => '1'))
                )
            )
        );
    }

    function savefield($record) {
        $templatecode = $record['TEMPLATECODE'];
        $fieldname = $record['FIELDNAME'];
        $qty = ClxCommon::$db->oneExistsRecords('CLX_AN_OUTPUT_GEN_FIELDS', 'TEMPLATECODE=' . singleQuote($templatecode) . ' AND FIELDNAME=' . singleQuote($fieldname));
        if ($qty == CLX_NUM_ZERO) {
            ClxCommon::$db->createRecord('CLX_AN_OUTPUT_GEN_FIELDS', $record, false);
        }
    }

    function getfields($templatecode) {
        $fields = array();
        $records = ClxCommon::$db->getRecords('CLX_AN_OUTPUT_GEN_FIELDS', 'TEMPLATECODE=' . singleQuote($templatecode));
        while (($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE))) {
            unset($record['ID']);
            $fields[$record['FIELDNAME']] = $record;
        }
        return $fields;
    }

}
