<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @package		Clientix.Tool.Interface
 * @abstract		System Chart Manager
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 */
include_once kPathToObjects . 'cpty.php';

class cpty_chartprops extends cpty {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'CPRO';
        $this->name = 'Chart';
        $this->type = 'CPTX';
        $this->version = '0.2.0.0';
        $this->description = 'Chart Properties';
        $this->classname = '';
        $this->classfile = '';
        $this->functions = array(array('function' => 'AdjImage', 'name' => 'ADJIMAGE', CLX_CLASS_PROMPT => 'OBJ_CPRO_PROMPT_ADJIMAGE', 'arguments' => array(
                    array('name' => 'BRIGHTNESS', 'type' => 'NUMBER', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_BRIGHTNESS', 'decimal' => '1', 'min' => '-1', 'max' => '1'), array('name' => 'CONTRAST', 'type' => 'NUMBER', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_CONTRAST', 'decimal' => '1', 'min' => '-1', 'max' => '1'), array('name' => 'SATURATION', 'type' => 'NUMBER', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_SATURATION', 'decimal' => '1', 'min' => '-1', 'max' => '1'))
            ), array('function' => 'AdjBackgroundImage', 'name' => 'ADJBKIMAGE', CLX_CLASS_PROMPT => 'OBJ_CPRO_PROMPT_ADJBKIMAGE', 'arguments' => array(
                    array('name' => 'BRIGHTNESS', 'type' => 'NUMBER', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_BRIGHTNESS', 'decimal' => '1', 'min' => '-1', 'max' => '1'), array('name' => 'CONTRAST', 'type' => 'NUMBER', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_CONTRAST', 'decimal' => '1', 'min' => '-1', 'max' => '1'), array('name' => 'SATURATION', 'type' => 'NUMBER', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_SATURATION', 'decimal' => '1', 'min' => '-1', 'max' => '1'))
            ), array('function' => 'SetAlphaBlending', 'name' => 'ALPHABLEND', CLX_CLASS_PROMPT => 'OBJ_CPRO_PROMPT_ALPHABLEND', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'BOOLEAN', 'default' => ''))
            ), array('function' => 'SetAngle', 'name' => 'ANGLE', CLX_CLASS_PROMPT => 'GEN_LBL_ANGLE', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'NUMBER', 'default' => '', 'postfix' => 'GEN_LBL_DEGREES'))
            ), array('function' => 'SetAxisStyle', 'name' => 'AXISSTYLE', CLX_CLASS_PROMPT => 'OBJ_CPRO_PROMPT_AXISSTYLE', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'LIST', 'default' => '', 'constant' => '1', 'options' => 'AXSTYLE_SIMPLE:OBJ_CPRO_PROMPT_AXSTYLE_SIMPLE,AXSTYLE_BOXIN:OBJ_CPRO_PROMPT_AXSTYLE_BOXIN,AXSTYLE_BOXOUT:OBJ_CPRO_PROMPT_AXSTYLE_BOXOUT')
                )
            ), array('function' => 'SetBackgroundGradient', 'name' => 'BKGRADIENT', CLX_CLASS_PROMPT => 'OBJ_CPRO_PROMPT_BKGRADIENT', 'arguments' => array(
                    array('name' => 'FROMCOLOR', 'type' => 'STRING', 'default' => '', 'size' => '255', 'displaysize' => '45', CLX_CLASS_PROMPT => 'GEN_LBL_FROMCOLOR'), array('name' => 'TOCOLOR', 'type' => 'STRING', 'default' => '', 'size' => '255', 'displaysize' => '45', CLX_CLASS_PROMPT => 'GEN_LBL_TOCOLOR'), array('name' => 'GRADTYPE', 'type' => 'LIST', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_TYPE', 'constant' => '1', 'options' => 'GRAD_VER:GEN_LBL_GRADVERT,GRAD_HOR:GEN_LBL_GRADHORZ,GRAD_MIDHOR:GEN_LBL_GRADCENTERHOR,GRAD_MIDVER:GEN_LBL_GRADCENTERVER,GRAD_WIDE_MIDVER:GEN_LBL_GRADCENTERVERWIDE,GRAD_WIDE_MIDHOR:GEN_LBL_GRADCENTERHORWIDE,GRAD_CENTER:GEN_LBL_GRADCENTERBEAM,GRAD_LEFT_REFLECTION:GEN_LBL_GRADLEFTREFLEX,GRAD_RIGHT_REFLECTION:GEN_LBL_GRADRIGHTREFLEX'),
                    array('name' => 'STYLE', 'type' => 'LIST', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_STYLE', 'constant' => '1', 'options' => 'BGRAD_FRAME:OBJ_CPRO_PROMPT_BGRAD_FRAME,BGRAD_PLOT:OBJ_CPRO_PROMPT_BGRAD_PLOT,BGRAD_MARGIN:OBJ_CPRO_PROMPT_BGRAD_MARGIN')
                )
            ), array('function' => 'SetBackgroundImage', 'name' => 'BKIMAGE', CLX_CLASS_PROMPT => 'OBJ_CPRO_PROMPT_BKIMAGE', 'arguments' => array(
                    array('name' => 'FILENAME', 'type' => 'STRING', 'default' => '', 'size' => '255', 'displaysize' => '45', CLX_CLASS_PROMPT => 'GEN_LBL_FILENAME'), array('name' => 'TYPE', 'type' => 'LIST', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_TYPE', 'constant' => '1', 'options' => 'BGIMG_FILLPLOT:OBJ_CPRO_PROMPT_BGIMG_FILLPLOT,BGIMG_FILLFRAME:OBJ_CPRO_PROMPT_BGIMG_FILLFRAME,BGIMG_COPY:OBJ_CPRO_PROMPT_BGIMG_COPY,BGIMG_CENTER:OBJ_CPRO_PROMPT_BGIMG_CENTER'),
                    array('name' => 'FORMAT', 'type' => 'LIST', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_FORMAT', 'options' => 'auto,jpeg,png,gif')
                )
            ), array('function' => 'SetColor', 'name' => 'COLOR', CLX_CLASS_PROMPT => 'GEN_LBL_COLOR', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'STRING', 'default' => '', 'size' => '255', 'displaysize' => '45'))
            ), array('function' => 'SetMargin', 'name' => 'MARGIN', CLX_CLASS_PROMPT => 'GEN_LBL_MARGIN', 'arguments' => array(
                    array('name' => 'LEFT', 'type' => 'NUMBER', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_LEFT', 'postfix' => 'GEN_LBL_PIXELS'), array('name' => 'RIGHT', 'type' => 'NUMBER', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_RIGHT', 'postfix' => 'GEN_LBL_PIXELS'), array('name' => 'TOP', 'type' => 'NUMBER', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_TOP', 'postfix' => 'GEN_LBL_PIXELS'), array('name' => 'BOTTOM', 'type' => 'NUMBER', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_BOTTOM', 'postfix' => 'GEN_LBL_PIXELS'))
            ), array('function' => 'SetMarginColor', 'name' => 'MARGINCOLOR', CLX_CLASS_PROMPT => 'GEN_LBL_MARGINCOLOR', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'STRING', 'default' => '', 'size' => '255', 'displaysize' => '45'))
            )
        );
    }

    function setFunctions(&$graph, $args, $series = array()) {
        $arguments = new XMLObject('properties', false);
        $arguments->parse($args);
        foreach ($this->functions as $function) {
            if ($arguments->hasObject($function['name'])) {
                $func_arguments = $arguments->getObject($function['name']);
                $this->setFunction($graph, $function, $func_arguments);
            }
        }
    }

}
