<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @package		Clientix.Tool.Interface
 * @abstract		System Chart Manager
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 */
include_once kPathToObjects . 'cpty.php';

class cpty_imageprops extends cpty {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'CIMP';
        $this->name = 'Image';
        $this->type = 'CPTX';
        $this->version = '0.2.0.0';
        $this->description = 'Image Properties';
        $this->classname = '';
        $this->classfile = '';
        $this->functions = array(array('function' => 'SetAlphaBlending', 'name' => 'ALPHABLEND', CLX_CLASS_PROMPT => 'OBJ_CIMP_PROMPT_ALPHABLEND', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'BOOLEAN', 'default' => ''))
            ), array('function' => 'SetAntiAliasing', 'name' => 'ANTIALIAS', CLX_CLASS_PROMPT => 'OBJ_CIMP_PROMPT_ANTIALIAS', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'BOOLEAN', 'default' => ''))
            ), array('function' => 'SetCanvasColor', 'name' => 'CANVASCOLOR', CLX_CLASS_PROMPT => 'GEN_LBL_COLOR', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'STRING', 'default' => '', 'size' => '255', 'displaysize' => '30'))
            ), array('function' => 'SetImgFormat', 'name' => 'FORMAT', CLX_CLASS_PROMPT => 'GEN_LBL_FORMAT', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'LIST', 'default' => '', 'options' => 'gif,png,jpeg')
                )
            ), array('function' => 'SetQuality', 'name' => 'QUALITY', CLX_CLASS_PROMPT => 'GEN_LBL_QUALITY', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'NUMBER', 'default' => '', 'min' => '0', 'max' => CLX_NUM_HUNDRED, 'postfix' => '%'))
            ), array('function' => 'SetTransparent', 'name' => 'TRANSPARENTCOLOR', CLX_CLASS_PROMPT => 'OBJ_CIMP_PROMPT_TRANSPARENTCOLOR', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'STRING', 'default' => '', 'size' => '255', 'displaysize' => '30'))
            ), array('function' => 'SetMargin', 'name' => 'MARGIN', CLX_CLASS_PROMPT => 'GEN_LBL_MARGIN', 'arguments' => array(
                    array('name' => 'LEFT', 'type' => 'NUMBER', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_LEFT', 'postfix' => 'GEN_LBL_PIXELS'), array('name' => 'RIGHT', 'type' => 'NUMBER', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_RIGHT', 'postfix' => 'GEN_LBL_PIXELS'), array('name' => 'TOP', 'type' => 'NUMBER', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_TOP', 'postfix' => 'GEN_LBL_PIXELS'), array('name' => 'BOTTOM', 'type' => 'NUMBER', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_BOTTOM', 'postfix' => 'GEN_LBL_PIXELS'))
            ), array('function' => 'SetAngle', 'name' => 'ANGLE', CLX_CLASS_PROMPT => 'GEN_LBL_ANGLE', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'NUMBER', 'default' => '', 'postfix' => 'GEN_LBL_DEGREES'))
            ), array('function' => 'SetCenter', 'name' => 'CENTER', CLX_CLASS_PROMPT => 'GEN_LBL_CENTER', 'arguments' => array(
                    array('name' => 'X', 'type' => 'NUMBER', 'default' => '', CLX_CLASS_PROMPT => 'X', 'postfix' => 'GEN_LBL_PIXELS'), array('name' => 'Y', 'type' => 'NUMBER', 'default' => '', CLX_CLASS_PROMPT => 'Y', 'postfix' => 'GEN_LBL_PIXELS'))
            ), array('function' => 'SetTranslation', 'name' => 'TRANSLATION', CLX_CLASS_PROMPT => 'GEN_LBL_TRANSLATION', 'arguments' => array(
                    array('name' => 'DX', 'type' => 'NUMBER', 'default' => '', CLX_CLASS_PROMPT => 'DX', 'postfix' => 'GEN_LBL_PIXELS'), array('name' => 'DY', 'type' => 'NUMBER', 'default' => '', CLX_CLASS_PROMPT => 'DY', 'postfix' => 'GEN_LBL_PIXELS'))
            )
        );
    }

    function setFunctions(&$graph, $args, $series = array()) {
        $arguments = new XMLObject('properties', false);
        $arguments->parse($args);
        foreach ($this->functions as $function) {
            if ($arguments->hasObject($function['name'])) {
                $func_arguments = $arguments->getObject($function['name']);
                $this->setFunction($graph->img, $function, $func_arguments);
            }
        }
    }

}
