<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @package		Clientix.Tool.Interface
 * @abstract		System Chart Manager
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 */
include_once kPathToObjects . 'cpty.php';

class cpty_titleprops extends cpty {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'CTPR';
        $this->name = 'Title';
        $this->type = 'CPTX';
        $this->version = '0.2.0.0';
        $this->description = 'Chart Title Properties';
        $this->classname = '';
        $this->classfile = '';
        $this->functions = array(array('function' => 'Align', 'name' => 'RELALIGN', CLX_CLASS_PROMPT => 'GEN_LBL_RELATIVEALIGN', 'arguments' => array(
                    array('name' => 'HORIZONTAL', 'type' => 'LIST', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_HORALIGN', 'options' => 'left:GEN_LBL_LEFT,center:GEN_LBL_CENTER,right:GEN_LBL_RIGHT'),
                    array('name' => 'VERTICAL', 'type' => 'LIST', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_VERALIGN', 'options' => 'top:GEN_LBL_TOP,center:GEN_LBL_CENTER,bottom:GEN_LBL_BOTTOM'),
                    array('name' => 'PARAGRAPH', 'type' => 'LIST', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_PARAALIGN', 'options' => 'left:GEN_LBL_LEFT,center:GEN_LBL_CENTER,right:GEN_LBL_RIGHT')
                )
            ), array('function' => 'ParagraphAlign', 'name' => 'PARALIGN', CLX_CLASS_PROMPT => 'GEN_LBL_ALIGN', 'arguments' => array(
                    array('name' => 'HORIZONTAL', 'type' => 'LIST', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_HORALIGN', 'options' => 'left:GEN_LBL_LEFT,center:GEN_LBL_CENTER,right:GEN_LBL_RIGHT')
                )
            ), array('function' => 'Center', 'name' => 'CENTER', CLX_CLASS_PROMPT => 'GEN_LBL_CENTER', 'arguments' => array(
                    array('name' => 'LEFT', 'type' => 'NUMBER', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_LEFT', 'postfix' => 'GEN_LBL_PIXELS', 'max' => '', 'min' => ''), array('name' => 'RIGHT', 'type' => 'NUMBER', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_RIGHT', 'postfix' => 'GEN_LBL_PIXELS', 'max' => '', 'min' => ''), array('name' => 'BASE', 'type' => 'NUMBER', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_BASE', 'postfix' => 'GEN_LBL_PIXELS', 'max' => '', 'min' => ''))
            ), array('function' => 'Set', 'name' => 'TEXT', CLX_CLASS_PROMPT => 'GEN_LBL_TEXT', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'TEXT', 'default' => ''))
            ), array('function' => 'SetAngle', 'name' => 'ANGLE', CLX_CLASS_PROMPT => 'GEN_LBL_ANGLE', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'NUMBER', 'default' => '', 'postfix' => 'GEN_LBL_DEGREES'))
            ), array('function' => 'SetBox', 'name' => 'BOX', CLX_CLASS_PROMPT => 'GEN_LBL_BOX', 'arguments' => array(
                    array('name' => 'FRAMECOLOR', 'type' => 'STRING', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_FRAMECOLOR'), array('name' => 'BORDERCOLOR', 'type' => 'STRING', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_BORDERCOLOR'), array('name' => 'SHADOWCOLOR', 'type' => 'STRING', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_SHADOWCOLOR'), array('name' => 'CORNERRADIUS', 'type' => 'NUMBER', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_CORNERRADIUS', 'postfix' => 'GEN_LBL_PIXELS'), array('name' => 'SHADOWWIDTH', 'type' => 'NUMBER', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_SHADOWWIDTH', 'postfix' => 'GEN_LBL_PIXELS'))
            ), array('function' => 'SetColor', 'name' => 'COLOR', CLX_CLASS_PROMPT => 'GEN_LBL_COLOR', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'STRING', 'default' => ''))
            ), array('function' => 'SetFont', 'name' => 'FONT', CLX_CLASS_PROMPT => 'GEN_LBL_FONT', 'arguments' => array(
                    array('name' => 'FAMILY', 'type' => 'STRING', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_FONTFAMILY', 'displaysize' => '30', 'size' => '255', 'constant' => '1'), array('name' => 'STYLE', 'type' => 'LIST', 'default' => '', 'constant' => '1', 'constant' => '1', 'options' => 'FS_NORMAL:GEN_LBL_PLAIN,FS_BOLD:GEN_LBL_BOLD,FS_ITALIC:GEN_LBL_ITALIC,FS_BOLDITALIC:GEN_LBL_BOLDITALIC', CLX_CLASS_PROMPT => 'GEN_LBL_STYLE'),
                    array('name' => 'SIZE', 'type' => 'NUMBER', 'default' => '', 'min' => '2', 'max' => '255', CLX_CLASS_PROMPT => 'GEN_LBL_SIZE', 'postfix' => 'GEN_LBL_POINTS'))
            ), array('function' => 'SetMargin', 'name' => 'MARGIN', CLX_CLASS_PROMPT => 'GEN_LBL_MARGIN', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'NUMBER', 'default' => '', 'postfix' => 'GEN_LBL_PIXELS'))
            ), array('function' => 'SetPos', 'name' => 'POSITION', CLX_CLASS_PROMPT => 'GEN_LBL_POSITION', 'arguments' => array(
                    array('name' => 'XPOS', 'type' => 'NUMBER', 'decimal' => '1', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_XPOS', 'postfix' => 'GEN_LBL_PIXELS'), array('name' => 'YPOS', 'type' => 'NUMBER', 'decimal' => '1', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_YPOS', 'postfix' => 'GEN_LBL_PIXELS'), array('name' => 'HALIGN', 'type' => 'LIST', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_HORALIGN', 'options' => 'left:GEN_LBL_LEFT,center:GEN_LBL_CENTER,right:GEN_LBL_RIGHT'),
                    array('name' => 'VALIGN', 'type' => 'LIST', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_VERALIGN', 'options' => 'top:GEN_LBL_TOP,center:GEN_LBL_CENTER,bottom:GEN_LBL_BOTTOM')
                )
            )
        );
    }

    function setFunctions(&$graph, $args, $series = array()) {
        $arguments = new XMLObject('properties', false);
        $arguments->parse($args);
        foreach ($this->functions as $function) {
            if ($arguments->hasObject($function['name'])) {
                $func_arguments = $arguments->getObject($function['name']);
                $this->setFunction($graph->title, $function, $func_arguments);
            }
        }
    }

}
