<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @package		Clientix.Tool.Interface
 * @abstract		System Chart Manager
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 */
include_once kPathToObjects . 'cpty.php';

class cpty_yaxesprops extends cpty {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'YAXE';
        $this->name = 'Y Axe';
        $this->type = 'CPTX';
        $this->version = '0.3.0.0';
        $this->description = 'Y Axe Properties';
        $this->classname = '';
        $this->classfile = '';
        $this->functions = array(array('function' => 'Hide', 'name' => 'VISIBLE', CLX_CLASS_PROMPT => 'GEN_LBL_VISIBLE', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'BOOLEAN', 'default' => ''))
            ), array('function' => 'HideLabels', 'name' => 'HIDELABELS', CLX_CLASS_PROMPT => 'GEN_LBL_HIDELABELS', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'BOOLEAN', 'default' => ''))
            ), array('function' => 'HideFirstTickLabel', 'name' => 'HIDEFIRSTLABEL', CLX_CLASS_PROMPT => 'OBJ_YAXE_PROMPT_HIDEFIRSTLABEL', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'BOOLEAN', 'default' => ''))
            ), array('function' => 'HideLastTickLabel', 'name' => 'HIDELASTLABEL', CLX_CLASS_PROMPT => 'OBJ_YAXE_PROMPT_HIDELASTLABEL', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'BOOLEAN', 'default' => ''))
            ), array('function' => 'HideLine', 'name' => 'HIDELINE', CLX_CLASS_PROMPT => 'OBJ_YAXE_PROMPT_HIDELINE', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'BOOLEAN', 'default' => ''))
            ), array('function' => 'HideTicks', 'name' => 'HIDETICKS', CLX_CLASS_PROMPT => 'OBJ_YAXE_PROMPT_HIDETICKS', 'arguments' => array(
                    array('name' => 'MAJOR', 'type' => 'BOOLEAN', 'default' => '', CLX_CLASS_PROMPT => 'OBJ_YAXE_PROMPT_MAJORTICKS'), array('name' => 'MINOR', 'type' => 'BOOLEAN', 'default' => '', CLX_CLASS_PROMPT => 'OBJ_YAXE_PROMPT_MINORTICKS'))
            ), array('function' => 'HideZeroLabel', 'name' => 'HIDEZEROLABEL', CLX_CLASS_PROMPT => 'OBJ_YAXE_PROMPT_HIDEZEROLABEL', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'BOOLEAN', 'default' => ''))
            ), array('function' => 'SetColor', 'name' => 'COLOR', CLX_CLASS_PROMPT => 'GEN_LBL_COLORS', 'arguments' => array(
                    array('name' => 'AXISCOLOR', 'type' => 'STRING', 'default' => 'black', CLX_CLASS_PROMPT => 'OBJ_YAXE_PROMPT_AXISCOLOR', 'displaysize' => '30', 'size' => '255'), array('name' => 'LABELCOLOR', 'type' => 'STRING', 'default' => 'black', CLX_CLASS_PROMPT => 'OBJ_YAXE_PROMPT_LABELCOLOR', 'displaysize' => '30', 'size' => '255'))
            ), array('function' => 'SetFont', 'name' => 'FONT', CLX_CLASS_PROMPT => 'GEN_LBL_FONT', 'arguments' => array(
                    array('name' => 'FAMILY', 'type' => 'STRING', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_FONTFAMILY', 'displaysize' => '30', 'size' => '255', 'constant' => '1'), array('name' => 'STYLE', 'type' => 'LIST', 'default' => '', 'constant' => '1', 'constant' => '1', 'options' => 'FS_NORMAL:GEN_LBL_PLAIN,FS_BOLD:GEN_LBL_BOLD,FS_ITALIC:GEN_LBL_ITALIC,FS_BOLDITALIC:GEN_LBL_BOLDITALIC', CLX_CLASS_PROMPT => 'GEN_LBL_STYLE'),
                    array('name' => 'SIZE', 'type' => 'NUMBER', 'default' => '', 'min' => '2', 'max' => '255', CLX_CLASS_PROMPT => 'GEN_LBL_SIZE', 'postfix' => 'GEN_LBL_POINTS'))
            ), array('function' => 'SetLabelAlign', 'name' => 'LABELALIGN', CLX_CLASS_PROMPT => 'OBJ_YAXE_PROMPT_LABELALIGN', 'arguments' => array(
                    array('name' => 'HORIZONTAL', 'type' => 'LIST', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_HORALIGN', 'options' => 'left:GEN_LBL_LEFT,center:GEN_LBL_CENTER,right:GEN_LBL_RIGHT'),
                    array('name' => 'VERTICAL', 'type' => 'LIST', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_VERALIGN', 'options' => 'top:GEN_LBL_TOP,center:GEN_LBL_CENTER,bottom:GEN_LBL_BOTTOM'),
                    array('name' => 'PARAGRAPH', 'type' => 'LIST', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_PARAALIGN', 'options' => 'left:GEN_LBL_LEFT,center:GEN_LBL_CENTER,right:GEN_LBL_RIGHT')
                )
            ), array('function' => 'SetLabelAngle', 'name' => 'LABELANGLE', CLX_CLASS_PROMPT => 'OBJ_YAXE_PROMPT_LABELANGLE', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'NUMBER', 'default' => '0', 'min' => '0', 'max' => '360', 'postfix' => 'GEN_LBL_DEGREES'))
            ), array('function' => 'SetLabelFormat', 'name' => 'LABELFORMAT', CLX_CLASS_PROMPT => 'OBJ_YAXE_PROMPT_LABELFORMAT', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'STRING', 'default' => '%s', 'displaysize' => '10', 'size' => '30', 'postfix' => 'ie: %s')
                )
            ), array('function' => 'SetLabelMargin', 'name' => 'LABELMARGIN', CLX_CLASS_PROMPT => 'OBJ_YAXE_PROMPT_LABELMARGIN', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'NUMBER', 'default' => '0', 'postfix' => 'GEN_LBL_PIXELS'))
            ), array('function' => 'SetLabelSide', 'name' => 'LABELSIDE', CLX_CLASS_PROMPT => 'OBJ_YAXE_PROMPT_LABELSIDE', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'LIST', 'default' => 'SIDE_UP', 'constant' => '1', 'options' => 'SIDE_LEFT:GEN_LBL_LEFT,SIDE_RIGHT:GEN_LBL_RIGHT')
                )
            ), array('function' => 'SetPos', 'name' => 'AXESPOS', CLX_CLASS_PROMPT => 'OBJ_YAXE_PROMPT_AXELPOS', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'NUMBER', 'default' => '', 'postfix' => 'GEN_LBL_PIXELS'))
            ), array('function' => 'SetTextLabelInterval', 'name' => 'LABELINTERVAL', CLX_CLASS_PROMPT => 'OBJ_YAXE_PROMPT_LABELINTERVAL', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'NUMBER', 'default' => ''))
            ), array('function' => 'SetTickDirection', 'name' => 'TICKDIRECTION', CLX_CLASS_PROMPT => 'OBJ_YAXE_PROMPT_TICKDIRECTION', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'LIST', 'default' => '', 'constant' => '1', 'options' => 'SIDE_LEFT:GEN_LBL_LEFT,SIDE_RIGHT:GEN_LBL_RIGHT')
                )
            ), array('function' => 'SetTickLabelMargin', 'name' => 'TICKLABELMARGIN', CLX_CLASS_PROMPT => 'OBJ_YAXE_PROMPT_TICKLABELMARGIN', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'NUMBER', 'default' => '', 'postfix' => 'GEN_LBL_PIXELS'))
            ), array('function' => 'SetTickSide', 'name' => 'TICKSIDE', CLX_CLASS_PROMPT => 'OBJ_YAXE_PROMPT_TICKSIDE', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'LIST', 'default' => '', 'constant' => '1', 'options' => 'SIDE_LEFT:GEN_LBL_LEFT,SIDE_RIGHT:GEN_LBL_RIGHT')
                )
            ), array('function' => 'SetTitleMargin', 'name' => 'TITLEMARGIN', CLX_CLASS_PROMPT => 'OBJ_YAXE_PROMPT_TITLEMARGIN', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'NUMBER', 'default' => '', 'postfix' => 'GEN_LBL_PIXELS'))
            ), array('function' => 'SetTitleSide', 'name' => 'TITLESIDE', CLX_CLASS_PROMPT => 'OBJ_YAXE_PROMPT_TITLESIDE', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'LIST', 'default' => '', 'constant' => '1', 'options' => 'SIDE_LEFT:GEN_LBL_LEFT,SIDE_RIGHT:GEN_LBL_RIGHT')
                )
            ), array('function' => 'SetWeight', 'name' => 'LINEWEIGHT', CLX_CLASS_PROMPT => 'GEN_LBL_LINEWEIGHT', 'arguments' => array(
                    array('name' => 'VALUE', 'type' => 'NUMBER', 'default' => '1', 'postfix' => 'GEN_LBL_PIXELS'))
            )
        );
    }

    function setFunctions(&$graph, $args, $series = array()) {
        $arguments = new XMLObject('properties', false);
        $arguments->parse($args);
        foreach ($this->functions as $function) {
            if ($arguments->hasObject($function['name'])) {
                $func_arguments = $arguments->getObject($function['name']);
                $this->setFunction($graph->yaxis, $function, $func_arguments);
            }
        }
    }

}
