<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2019-03-15 18:47:32 +0000 (Fri, 15 Mar 2019) $
 * @version        $Rev: 10571 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
if (!class_exists('dbex') && !defined('clxInstallProcess')) {
    include_once kPathToObjects . 'dbex.php';
}

class dbex_text extends dbex {

    var $fielddelim;
    var $recorddelim;
    var $fieldenclosure;
	var $utf8_output = false;	// 2019-02-18 CR | SA | Caso 1003786 - PBL-Interf Rev Client

    function __construct() {
        $this->code = 'DBTX';
        $this->name = 'Text';
        $this->type = 'DBEX';
        $this->version = '0.1.1.0';
        $this->description = 'Text Export Format';
        $this->editPanel = array('entries' => array(
                array('label' => 'GEN_LBL_FIELDDELIM',
                    'fields' => array(
                        array('name' => 'fielddelim', 'type' => 'radiobutton', 'value' => '[9]', CLX_CLASS_PROMPT => 'GEN_LBL_TAB'), array('name' => 'fielddelim', 'type' => 'radiobutton', 'value' => ',', CLX_CLASS_PROMPT => 'GEN_LBL_COMMA'), array('name' => 'fielddelim', 'type' => 'radiobutton', 'value' => ';', CLX_CLASS_PROMPT => 'GEN_LBL_SEMICOLON'),
                        array('name' => 'fielddelim', 'type' => 'radiobutton', 'value' => '[32]', CLX_CLASS_PROMPT => 'GEN_LBL_SPACE'), array('name' => 'fielddelim', 'type' => 'radiobutton', 'value' => 'other', CLX_CLASS_PROMPT => 'GEN_LBL_OTHER'), array('name' => 'fielddelim_other', 'type' => 'string', 'default' => '', 'size' => '24', 'displaysize' => '24'))
                ), array('label' => 'GEN_LBL_RECORDDELIM',
                    'fields' => array(
                        array('name' => 'recorddelim', 'type' => 'radiobutton', 'value' => '[13]', CLX_CLASS_PROMPT => 'GEN_LBL_CARRIAGE_RETURN'), array('name' => 'recorddelim', 'type' => 'radiobutton', 'value' => '[10]', CLX_CLASS_PROMPT => 'GEN_LBL_LINE_FEED'), array('name' => 'recorddelim', 'type' => 'radiobutton', 'value' => '[13][10]', CLX_CLASS_PROMPT => 'GEN_LBL_CRLF'), array('name' => 'recorddelim', 'type' => 'radiobutton', 'value' => 'other', CLX_CLASS_PROMPT => 'GEN_LBL_OTHER'), array('name' => 'recorddelim_other', 'type' => 'string', 'default' => '', 'size' => '24', 'displaysize' => '24'))
                ), array('label' => 'GEN_LBL_FIELD_ENCLOSURE',
                    'fields' => array(
                        array('name' => 'fieldenclosure', 'type' => 'radiobutton', 'value' => '[34]', CLX_CLASS_PROMPT => 'GEN_LBL_QUOTE'), array('name' => 'fieldenclosure', 'type' => 'radiobutton', 'value' => '[39]', CLX_CLASS_PROMPT => 'GEN_LBL_SINGLE_QUOTE'), array('name' => 'fieldenclosure', 'type' => 'radiobutton', 'value' => 'other', CLX_CLASS_PROMPT => 'GEN_LBL_OTHER'), array('name' => 'fieldenclosure_other', 'type' => 'string', 'default' => '', 'size' => '24', 'displaysize' => '24'))
                )
            )
        );
    }

    function start($fd, $filename) {
        $this->fd = $fd;
        if (UserRequest::$request['DBEX_fielddelim'] === 'other') {
            $this->fielddelim = replace_ascii_chars(UserRequest::$request['DBEX_fielddelim_other']);
        } else {
            $this->fielddelim = replace_ascii_chars(UserRequest::$request['DBEX_fielddelim']);
        }
        if (UserRequest::$request['DBEX_recorddelim'] === 'other') {
            $this->recorddelim = replace_ascii_chars(UserRequest::$request['DBEX_recorddelim_other']);
        } else {
            $this->recorddelim = replace_ascii_chars(UserRequest::$request['DBEX_recorddelim']);
        }
        if (UserRequest::$request['DBEX_fieldenclosure'] === 'other') {
            $this->fieldenclosure = replace_ascii_chars(UserRequest::$request['DBEX_fieldenclosure_other']);
        } else {
            $this->fieldenclosure = replace_ascii_chars(UserRequest::$request['DBEX_fieldenclosure']);
        }
    }

    function columnHeaders($headers) {
        $line = '';
        $d = '';
        foreach ($headers as $header) {
            $line .= $d . $this->fieldenclosure . addslashes($header) . $this->fieldenclosure;
            $d = $this->fielddelim;
        }
        $line .= (( $this->utf8_output===true) ? utf8_encode( chr(160) ) :''). $this->recorddelim;
		$this->fd->write($line);
		//fwrite($this->fd, $line);
    }

    function save($record,$lbreak=true) {
        $line = '';
        $d = '';
        /* $key => */
        foreach ($record as $value) {
            //$line .= $d . $this->fieldenclosure . addslashes($value) . $this->fieldenclosure;
            $line .= $d . $this->fieldenclosure . $value . $this->fieldenclosure;
            $d = $this->fielddelim;
        }
		if ($lbreak) {
			$line .= $this->recorddelim;
		}	
		// 2019-02-18 CR | SA | Caso 1003786 - PBL-Interf Rev Client
		if($this->utf8_output === false) {
			// Writes ASCCI
	        $this->fd->write(utf8_decode($line));
		} else {
			// Writes UTF-8
	        $this->fd->write($line);
		}
    }

}
