<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
if (!class_exists('ussh') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'ussh.php';

class ussh_page extends ussh {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'USPA';
        $this->name = 'Show a page';
        $this->type = 'USSH';
        $this->version = '0.1.0.0';
        $this->description = 'This is a Clientix Shortcut that shows a page.';
        $this->editPanel = array('entries' => array(
                array('label' => 'OBJ_USSH_USPA_TITLE',
                    'fields' => array(
                        array('name' => 'USPA_extra1', 'type' => 'lookup', 'default' => '', 'tool' => 'UIPG', 'validations' => array(
                                array('type' => 'sqlobject', 'required' => '1'), array('type' => 'lookup', 'fieldname' => 'IDCODE', 'tablename' => 'CLX_UI_PAGES'))
                        )
                    )
                )
            )
        );
    }

    function getPanel(&$record) {
        $record['EXTRA1'] = UserRequest::$post['USPA_extra1'];
    }

    function setPanel(&$record, $values) {
        $record['USPA_extra1'] = $values['EXTRA1'];
    }

    function defaultPanel(&$record) {
        $record['USPA_extra1'] = '';
    }

    function viewForm(&$table, $record) {
        $table->addData(dict('GEN_LBL_LISTING') . ':', $record['USPA_extra1']);
    }

    function describe($record) {
        return 'Show page: ' . $record['EXTRA1'];
    }

    function makeURL($record) {
        return sprintf('tool.php?to=UIPG&ac=USPA&pc=%s', $record['EXTRA1']);
    }

}
