<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
if (!class_exists('util') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'util.php';

class util_footprint extends util {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'FOOT';
        $this->name = 'Footprint';
        $this->type = 'UTIL';
        $this->version = '0.1.5.0';
        $this->description = 'This utility will dump the code and the version of all the utils to an XML file.';
        $this->haspanel = true;
        $this->panelform = array(CLX_CLASS_TITLE => 'UTIL_FOOT_TITLE_EXECUTE',
            'panels' => array(
                array('type' => 'normal',
                    'entries' => array(
                        array('label' => 'GEN_LBL_TYPE',
                            'fields' => array(
                                array('name' => 'type', 'type' => 'dynamic', 'panels' => array(
                                        'GEN' => 'OBJ_FOOT_GENERATE',
                                        'COMP' => 'OBJ_FOOT_COMPARE'
                                    )
                                )
                            )
                        )
                    )
                ), array('type' => 'dynamic',
                    'code' => 'GEN',
                    'entries' => array(
                        array('label' => 'GEN_LBL_FILENAME',
                            'fields' => array(
                                array('name' => 'filename_gen', 'type' => 'string', 'displaysize' => '45', 'size' => '255', 'validations' => array(
                                        array('type' => 'string', 'required' => '1')
                                    )
                                )
                            )
                        )
                    )
                ), array('type' => 'dynamic',
                    'code' => 'COMP',
                    'entries' => array(
                        array('label' => 'GEN_LBL_FILENAME',
                            'fields' => array(
                                array('name' => 'filename_comp', 'type' => 'file', 'validations' => array(
                                        array('type' => 'string', 'required' => '1'))
                                )
                            )
                        )
                    )
                )
            )
        );
    }

    function checkPanel(&$msg) {
        $msg = array();
        if (UserRequest::$post['FOOT_type'] === 'GEN' && empty(UserRequest::$post['FOOT_filename_gen'])) {
            $msg['FOOT_filename_gen'] = dict('GEN_LBL_FIELD_REQUIRED');
        } elseif (UserRequest::$post['FOOT_type'] <> 'GEN' && empty(UserRequest::$files)) {
            $msg['FOOT_filename_comp'] = dict('GEN_LBL_FIELD_REQUIRED');
        }
        return (count($msg) == CLX_NUM_ZERO) ? true : false;
    }

    function execute_() {
        UserResponse::setIgnoreUserAbort(CLX_NUM_ONE);
        UserResponse::setRunTimeLimit(CLX_NUM_ZERO);
        $contents = '';
        if (UserRequest::$post['FOOT_type'] == 'GEN') {
            $contents = $this->generate();
        } else {
            $contents = $this->compare();
        }
        return $contents;
    }

    function generate() {

        $o = new xmlObject('FOOT_PRINT');
        $this->getVersions('TOOL', 'CLX_TOOLS', $o);
        $this->getVersions('OBJECT', 'CLX_OBJECTS', $o);
        $this->getVersions('MODULE', 'CLX_DB_MODULES', $o);
        $filename = UserRequest::$post['FOOT_filename_gen'];
        $fd = new clx_file($filename, 'w');
        $fd->open();
        if ($fd->hasError()) {
            $contents = alert(dict('GEN_ERR_CANT_OPEN_FILE', $filename));
        } else {
            $fd->write($o->source_(array('level' => CLX_NUM_ZERO)));
            $contents = note(dict('GEN_LBL_SUCCESS'), dict('GEN_LBL_OK'));
        }

        return $contents;
    }

    function getVersions($name, $tablename, &$o) {
        $records = ClxCommon::$db->getRecords($tablename);
        while (($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE))) {
            $f = new xmlObject($name);
            $code = new xmlObject('CODE');
            $code->setContents($record['IDCODE']);
            $f->addObject($code);
            $code = new xmlObject('NAME');
            $code->setContents($record['IDNAME']);
            $f->addObject($code);
            $code = new xmlObject('VERSION');
            $code->setContents($record['VERSION']);
            $f->addObject($code);
            $o->addObject($f);
        }
    }

    function compare() {
        //e cho xDebug::dump(UserRequest::$files);
        $upload = UserRequest::$files['UTIL_filename_comp'] ['tmp_name'];
        $o = new xmlObject('FOOT_PRINT');
        $o->load($upload);
        //if $o has an error then... (to do error handling to check for non-XML files)
        // table headers
        $table = new htmlTable(CLX_WIDTH_THREE);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('UTIL_FOOT_COMPARERESULTS'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_THREE));
        $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_OBJECTS'), dict('GEN_LBL_VERSION'), dict('UTIL_FOOT_FOOTPRINT')));
        $i = CLX_INIT_ZERO;
        foreach ($o->objects as $object) {
            switch ($object->tag) {
                case 'TOOL':
                    $this->compareObject($object, $table, $i, 'CLX_TOOLS', 'GEN_ERR_NO_TOOLCODE', 'GEN_LBL_TOOLCODE');
                    break;
                case 'OBJECT':
                    $this->compareObject($object, $table, $i, 'CLX_OBJECTS', 'GEN_ERR_NO_OBJECTCODE', 'GEN_LBL_OBJECTCODE');
                    break;
                case 'MODULE':
                    $this->compareObject($object, $table, $i, 'CLX_DB_MODULES', 'GEN_ERR_NO_MODULECODE', 'GEN_LBL_MODULECODE');
                    break;
                default:
                    break;
            }
        }
        $c = new htmlButtonCancel(dict('GEN_LBL_RETURN'));
        $buttons = $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_THREE));
        return $table->source();
    }

    function compareObject($object, &$table, &$i, $db_tablename, $dict_entry, $object_label) {
        $code = $object->getObject('CODE');
        $objectcode = $code->getContents();
        $qty = ClxCommon::$db->oneExistsRecords(ClxCommon::$db_tablename, 'IDCODE=' . singleQuote($objectcode));
        if ($qty == CLX_NUM_ZERO) {
            $table->addCell(dict($dict_entry, $objectcode), array(CLX_PROP_COLSPAN => $table, 'width' => getProp(CLX_PROP_WIDTH)));
            $i++;
        } else {
            $objectrec = ClxCommon::$db->getRecord(ClxCommon::$db_tablename, 'IDCODE=' . singleQuote($objectcode));
            $version = $object->getObject('VERSION');
            $objectversion = $version->getContents();
            if ($objectrec['VERSION'] != $objectversion) {
                $class = ($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT;
                $table->addCells($class, array(dict($object_label) . ': ' . $objectrec['IDNAME'] . ' (' . $objectrec['IDCODE'] . ')', $objectrec['VERSION']));
                if ($objectrec['VERSION'] > $objectversion) {
                    $color = 'red';
                } else {
                    $color = 'green';
                }
                $table->addCell($objectversion, array(CLX_PROP_CLASS => $class, 'style' => 'color: ' . $color));
                $i++;
            }
        }
    }

}
