<?php

/**
 * Sql Statement Utilities
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version    	$Rev: 9615 $
 *
 * 7/5/2005 Oracle uppercase record changed
 */
if (!class_exists('util') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'util.php';

class util_synch_dict extends util {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'IMDC';
        $this->name = 'Dictionary Synch Tool';
        $this->type = 'UTIL';
        $this->version = '0.1.0.0';
        $this->description = 'Sync remote diccionary entries.';
        $this->haspanel = true;
        if (!defined('RUNNING_TIME_LIMIT')) {
            define('RUNNING_TIME_LIMIT', CLX_NUM_24 * CLX_NUM_60 * CLX_NUM_60);
        }
    }

    function panel($msg) {
        $contents = '';
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->addArgument(CLX_PROP_TO, 'UTIL');
        $form->addArgument('ut', $this->code);
        $form->addArgument('ac', 'PANEL');
        $form->addArgument('confirm', '1');
        $form->addArgument('sure', (!empty(UserRequest::$post['sure'])) ? UserRequest::$post['sure'] : '');
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $table->addCell(dict('GEN_LBL_DICTSYNCH'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell(dict('GEN_LBL_SYNCNOTE'), array(CLX_PROP_CLASS => 'caption', CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $t = new htmlSelect('utl_db_type');
        $t->addItem('Mysqli', 'Mysqli', true);
        if (!empty($msg['utl_db_type']))
            $table->addCell($msg['utl_db_type'], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell(dict('GEN_LBL_REMOTEDBTYPE'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($t->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $t = new htmlField('utl_host', (!empty(UserRequest::$post['utl_host'])) ? UserRequest::$post['utl_host'] : '', CLX_NUM_40, CLX_NUM_150);
        if (!empty($msg['utl_host']))
            $table->addCell($msg['utl_host'], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell(dict('GEN_LBL_REMOTEHOST'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($t->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $t = new htmlField('utl_db', (!empty(UserRequest::$post['utl_db'])) ? UserRequest::$post['utl_db'] : '', CLX_NUM_40, CLX_NUM_HUNDRED);
        if (!empty($msg['utl_db']))
            $table->addCell($msg['utl_db'], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell(dict('GEN_LBL_REMOTEDB'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($t->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $t = new htmlField('utl_user', (!empty(UserRequest::$post['utl_user'])) ? UserRequest::$post['utl_user'] : '', CLX_NUM_40, CLX_NUM_150);
        if (!empty($msg['utl_user']))
            $table->addCell($msg['utl_user'], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell(dict('GEN_LBL_REMOTEUSER'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($t->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $t = new htmlPassword('utl_pass', (!empty(UserRequest::$post['utl_pass'])) ? UserRequest::$post['utl_pass'] : '', CLX_NUM_40, CLX_NUM_150);
        if (!empty($msg['utl_pass']))
            $table->addCell($msg['utl_pass'], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell(dict('GEN_LBL_REMOTEPASSWORD') . ':', array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($t->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $t = new htmlSelect('utl_db_options');
        $t->addItem(dict('TOOL_DICT_IMPORT_NEW'), 'NEW', true);
        $t->addItem(dict('TOOL_DICT_UPDATE'), 'UPD', false);
        $t->addItem(dict('TOOL_DICT_REPLACE'), 'REP', false);
        if (!empty($msg['utl_db_options']))
            $table->addCell($msg['utl_db_options'], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell(dict('GEN_LBL_OPTIONS'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($t->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $table->addCell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $buttons = '';
        $c = new htmlSubmit(dict('GEN_LBL_EXECUTE'));
        $buttons .= $c->source();
        $c = new htmlButtonCancel();
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $contents = $form->source();
        return $contents;
    }

    function checkPanel(&$msg) {
        $msg = array();
        if (empty(UserRequest::$post['utl_db_type'])) {
            $msg['utl_db_type'] = dict('GEN_ERR_REQUIRED_FIELD');
        }
        if (empty(UserRequest::$post['utl_host'])) {
            $msg['utl_host'] = dict('GEN_ERR_REQUIRED_FIELD');
        }
        if (empty(UserRequest::$post['utl_host'])) {
            $msg['utl_host'] = dict('GEN_ERR_REQUIRED_FIELD');
        }
        if (empty(UserRequest::$post['utl_db'])) {
            $msg['utl_db'] = dict('GEN_ERR_REQUIRED_FIELD');
        }
        if (empty(UserRequest::$post['utl_user'])) {
            $msg['utl_user'] = dict('GEN_ERR_REQUIRED_FIELD');
        }
        if (empty(UserRequest::$post['utl_pass'])) {
            $msg['utl_pass'] = dict('GEN_ERR_REQUIRED_FIELD');
        }
        return count($msg) == CLX_NUM_ZERO;
    }

    function execute_() {
        $now = xFormat::getNow('Y-m-d H:i:s');
        UserResponse::setRunTimeLimit(RUNNING_TIME_LIMIT);
        $type = UserRequest::$post['utl_db_type'] . 'Database';
        if (!class_exists($type)){
            require kPathToWebSite . 'classes/'.$type.'.php';
        }
        $dbsrc = new $type(UserRequest::$post['utl_host'], UserRequest::$post['utl_user'], UserRequest::$post['utl_pass'], UserRequest::$post['utl_db']);
        $dbsrc->connectToDatabase();
        $dbsrc->selectDatabase();
        $i = CLX_INIT_ZERO;
        $j = CLX_INIT_ZERO;
        $rs = $dbsrc->getRecords('CLX_DICTIONARY');
        while ($r = $dbsrc->getNextRecord($rs, ASSOCIATIVE)) {
            unset($r['ID']);
            $qty = ClxCommon::$db->oneExistsRecords('CLX_DICTIONARY', 'ENTRY = ' . singleQuote($r['ENTRY']) . ' AND UPPER(LANGUAGE) = ' . singleQuote(uppercase($r['LANGUAGE'])));
            switch (UserRequest::$post['utl_db_options']) {
                case 'NEW':
                    if ($qty == CLX_NUM_ZERO) {
                        $r['MDATE'] = $now;
                        ClxCommon::$db->createRecord('CLX_DICTIONARY', $r, false);
                        $i++;
                    }
                    break;
                case 'UPD':
                    if ($qty == CLX_NUM_ZERO) {
                        $r['MDATE'] = $now;
                        ClxCommon::$db->createRecord('CLX_DICTIONARY', $r, false);
                    } else {
                        $oldrecord = ClxCommon::$db->getRecord('CLX_DICTIONARY', 'ENTRY=' . singleQuote($r['ENTRY']) . ' AND UPPER(LANGUAGE)=' . singleQuote(uppercase($r['LANGUAGE'])));
                        if ($oldrecord['MDATE'] < $r['MDATE']) {
                            $r['MDATE'] = $now;
                            ClxCommon::$db->updateRecord('CLX_DICTIONARY', $r, 'ENTRY=' . singleQuote($r['ENTRY']) . ' AND UPPER(LANGUAGE)=' . singleQuote(uppercase($r['LANGUAGE'])));
                        }
                    }
                    $i++;
                    break;
                case 'REP':
                    $r['MDATE'] = $now;
                    if ($qty == CLX_NUM_ZERO) {
                        ClxCommon::$db->createRecord('CLX_DICTIONARY', $r, false);
                    } else {
                        ClxCommon::$db->updateRecord('CLX_DICTIONARY', $r, 'ENTRY=' . singleQuote($r['ENTRY']) . ' AND UPPER(LANGUAGE)=' . singleQuote(uppercase($r['LANGUAGE'])));
                    }
                    $i++;
                    break;
                default:
                    break;
            }
            $j++;
        }
        pushHistory($this->code, 'IGNORE_THIS_ENTRY', CLX_NUM_ZERO);
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->addArgument(CLX_PROP_TO, 'UTIL');
        $form->addArgument('ac', 'UTL_LIST');
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $table->addCell(dict('GEN_LBL_DICTSYNCH'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell(dict('GEN_LBL_RESULT'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell(dict('GEN_LBL_CREATED') . ' ' . $i . ' ' . dict('GEN_LBL_OF') . ' ' . $j . ' ' . dict('GEN_LBL_ENTRIES'), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $c = new htmlButtonReturn();
        $buttons = $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $contents = $form->source();
        return $contents;
    }

}
