<?php

/**
 * Sql Statement Utilities
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version    	$Rev: 9615 $
 *
 * 7/5/2005 Oracle uppercase record changed
 */
if (!class_exists('util') && !defined('clxInstallProcess')) {
    include_once kPathToObjects . 'util.php';
}

class util_synch_tools extends util {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'IMTC';
        $this->name = 'Clientix Compare Tool';
        $this->type = 'UTIL';
        $this->version = '0.2.0.0';
        $this->description = 'Compares clientix tools.';
        $this->haspanel = true;
        if (!defined('RUNNING_TIME_LIMIT'))
            define('RUNNING_TIME_LIMIT', CLX_NUM_24 * CLX_NUM_60 * CLX_NUM_60);
    }

    function panel($msg) {

        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->addArgument(CLX_PROP_TO, 'UTIL');
        $form->addArgument('ut', $this->code);
        $form->addArgument('ac', 'PANEL');
        $form->addArgument('confirm', '1');
        $form->addArgument('sure', (!empty(UserRequest::$post['sure'])) ? UserRequest::$post['sure'] : '');
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $table->addCell(dict('GEN_LBL_TOOLCOMP'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell(dict('GEN_LBL_TOOLCOMPNOTE'), array(CLX_PROP_CLASS => 'caption', CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $t = new htmlSelect('utl_db_type');
        $t->addItem('mysql', 'mysql', true);
        if (!empty($msg['utl_db_type']))
            $table->addCell($msg['utl_db_type'], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell(dict('GEN_LBL_REMOTEDBTYPE'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($t->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $t = new htmlField('utl_host', (!empty(UserRequest::$post['utl_host'])) ? UserRequest::$post['utl_host'] : '', CLX_NUM_40, CLX_NUM_150);
        if (!empty($msg['utl_host']))
            $table->addCell($msg['utl_host'], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell(dict('GEN_LBL_REMOTEHOST'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($t->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $t = new htmlField('utl_db', (!empty(UserRequest::$post['utl_db'])) ? UserRequest::$post['utl_db'] : '', CLX_NUM_40, CLX_NUM_HUNDRED);
        if (!empty($msg['utl_db']))
            $table->addCell($msg['utl_db'], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell(dict('GEN_LBL_REMOTEDB'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($t->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $t = new htmlField('utl_user', (!empty(UserRequest::$post['utl_user'])) ? UserRequest::$post['utl_user'] : '', CLX_NUM_40, CLX_NUM_150);
        if (!empty($msg['utl_user']))
            $table->addCell($msg['utl_user'], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell(dict('GEN_LBL_REMOTEUSER'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($t->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $t = new htmlPassword('utl_pass', (!empty(UserRequest::$post['utl_pass'])) ? UserRequest::$post['utl_pass'] : '', CLX_NUM_40, CLX_NUM_150);
        if (!empty($msg['utl_pass']))
            $table->addCell($msg['utl_pass'], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell(dict('GEN_LBL_REMOTEPASSWORD') . ':', array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($t->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $table->addSeparator(CLX_CLASS_DATA);
        $form->addArgument('utl_fix', CLX_NUM_ZERO);
        $sel = new htmlSelect('utl_hide_same_version');
        $sel->addItem(dict('GEN_LBL_NO'), CLX_NUM_ZERO, false);
        $sel->addItem(dict('GEN_LBL_YES'), CLX_NUM_ONE, true);
        $table->addCell(dict('GEN_LBL_HIDE_SAME_VERSION') . ':', array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($sel->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $sel = new htmlSelect('utl_hide_local_objs');
        $sel->addItem(dict('GEN_LBL_NO'), CLX_NUM_ZERO, false);
        $sel->addItem(dict('GEN_LBL_YES'), CLX_NUM_ONE, true);
        $table->addCell(dict('GEN_LBL_HIDE_LOCAL_OBJECTS') . ':', array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($sel->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $table->addCell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        if (empty(UserRequest::$post['utl_tool']))
            UserRequest::$post['utl_tool'] = array();
        $sel = new htmlSelect('utl_tool[]');
        $sel->setProp('multiple', 'multiple');
        $sel->setProp('size', '10');
        $sql = 'SELECT  IDCODE, IDNAME, SYSTEM  FROM  CLX_TOOLS WHERE HAS_PACKAGE = 1 ORDER BY  SYSTEM, IDCODE, IDNAME';
        $results = ClxCommon::$db->executeQuery($sql);
        while (($result = ClxCommon::$db->getNextRecord($results, NUMERIC))) {
            $tool = getTool($result[CLX_NUM_ZERO]);
            if (empty($tool->tablename)or empty($tool->primary_key)) {
                continue;
            }
            $check = (array_search($result[CLX_NUM_ZERO], UserRequest::$post['utl_tool'])) ? true : false;
            $sel->addItem($result[CLX_NUM_TWO] . ' - ' . $result[CLX_NUM_ZERO] . ', ' . $result[CLX_NUM_ONE], $result[CLX_NUM_ZERO], $check);
        }
        $table->addCell(dict('GEN_LBL_TOOLS_TO_COMPARE') . ':', array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($sel->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $table->addCell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        if (empty(UserRequest::$post['utl_modules']))
            UserRequest::$post['utl_modules'] = array();
        $sel = new htmlSelect('utl_modules[]');
        $sel->setProp('multiple', 'multiple');
        $sel->setProp('size', '5');
        $sql = 'SELECT IDCODE, IDNAME FROM  CLX_DB_MODULES ORDER BY  IDCODE, IDNAME';
        $results = ClxCommon::$db->executeQuery($sql);
        while (($result = ClxCommon::$db->getNextRecord($results, NUMERIC))) {
            $check = (array_search($result[CLX_NUM_ZERO], UserRequest::$post['utl_modules'])) ? true : false;
            $sel->addItem($result[CLX_NUM_ZERO] . ', ' . $result[CLX_NUM_ONE], $result[CLX_NUM_ZERO], $check);
        }
        $table->addCell(dict('GEN_LBL_MODULES_FILTER') . ':', array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($sel->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $buttons = '';
        $c = new htmlSubmit(dict('GEN_LBL_EXECUTE'));
        $buttons .= $c->source();
        $c = new htmlButtonCancel();
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $contents = $form->source();
        return $contents;
    }

    function checkPanel(&$msg) {
        $msg = array();
        if (empty(UserRequest::$post['utl_db_type'])) {
            $msg['utl_db_type'] = dict('GEN_ERR_REQUIRED_FIELD');
        }
        if (empty(UserRequest::$post['utl_host'])) {
            $msg['utl_host'] = dict('GEN_ERR_REQUIRED_FIELD');
        }
        if (empty(UserRequest::$post['utl_host'])) {
            $msg['utl_host'] = dict('GEN_ERR_REQUIRED_FIELD');
        }
        if (empty(UserRequest::$post['utl_db'])) {
            $msg['utl_db'] = dict('GEN_ERR_REQUIRED_FIELD');
        }
        if (empty(UserRequest::$post['utl_user'])) {
            $msg['utl_user'] = dict('GEN_ERR_REQUIRED_FIELD');
        }
        if (empty(UserRequest::$post['utl_pass'])) {
            $msg['utl_pass'] = dict('GEN_ERR_REQUIRED_FIELD');
        }
        if (empty(UserRequest::$post['utl_tool'])) {
            $msg['utl_tool'] = dict('GEN_ERR_REQUIRED_FIELD');
        }
        return count($msg) == CLX_NUM_ZERO;
    }

    /**
     * Build Index key used to construct array to compare
     *
     * @param array $primary_keys
     * @param array $record
     * @return string
     */
    private function getToolKey(&$primary_keys, &$record) {
        $return = '';
        foreach ($primary_keys as $key => $val) {
            $return .= $record[$val];
        }
        if ($return === '')
            $return = 'ID';
        return $return;
    }

    function execute_() {
        UserResponse::setRunTimeLimit(RUNNING_TIME_LIMIT);
        $dicts = array();
        $dicts['GEN_LBL_LOCAL_ONLY'] = dict('GEN_LBL_LOCAL_ONLY');
        $dicts['GEN_LBL_MODULE'] = dict('GEN_LBL_MODULE');
        $dicts['GEN_LBL_DOWNGRADE'] = dict('GEN_LBL_DOWNGRADE');
        $dicts['GEN_LBL_SAME'] = dict('GEN_LBL_SAME');
        $dicts['GEN_LBL_UPGRADE'] = dict('GEN_LBL_UPGRADE');
        $dicts['GEN_LBL_NEW'] = dict('GEN_LBL_NEW');
        $dicts['GEN_LBL_NOTABLE'] = dict('GEN_LBL_NOTABLE');
        $dicts['GEN_LBL_ADDTOOLPRIMARY'] = dict('GEN_LBL_ADDTOOLPRIMARY');
        $dicts['GEN_LBL_NOPRIMARY'] = dict('GEN_LBL_NOPRIMARY');
        $dicts['GEN_LBL_OBJECT'] = dict('GEN_LBL_OBJECT');
        $type = UserRequest::$post['utl_db_type'] . '_database';
        if (!class_exists($type))
            require kPathToWebSite . 'classes/$type.php';
        ClxCommon::$dbsrc = new $type(UserRequest::$post['utl_host'], UserRequest::$post['utl_user'], UserRequest::$post['utl_pass'], UserRequest::$post['utl_db']);
        ClxCommon::$dbsrc->connectToDatabase();
        ClxCommon::$dbsrc->selectDatabase();
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $table->addCell(dict('GEN_LBL_TOOLSYNCH'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell(dict('GEN_LBL_RESULT') . ' ' . dict('GEN_LBL_REMOTE') . ': ' . ClxCommon::$dbsrc->databaseName . '@' . $dbsrc->databaseURL . ' ' . dict('GEN_LBL_LOCAL') . ': ' . ClxCommon::$db->databaseName . '@' . CLX_PROP_100PCTdatabaseURL, array(CLX_PROP_CLASS => CLX_CLASS_PROMPT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        foreach (UserRequest::$post['utl_tool'] as $key => $toolcode) {
            if (empty($toolcode)) {
                continue;
            }
            $tool = getTool($toolcode);
            if (empty($tool->tablename)) {
                $table->addCell($tool->name . ' ' . $dicts['GEN_LBL_NOTABLE'], array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO, CLX_PROP_CLASS => CLX_CLASS_DATAALT));
                continue;
            }
            if (empty($tool->primary_key)) {
                $table->addCell($tool->name . ' ' . $dicts['GEN_LBL_ADDTOOLPRIMARY'], array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO, CLX_PROP_CLASS => CLX_CLASS_DATAALT));
                continue;
            }
            if (empty($tool->primary_field)) {
                $table->addCell($tool->name . ' ' . $dicts['GEN_LBL_NOPRIMARY'], array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO, CLX_PROP_CLASS => CLX_CLASS_DATAALT));
                continue;
            }
            $fields = array('ID', 'VERSION', 'VERSION_COUNTER');
            if (!empty($tool->primary_field))
                $fields[] = $tool->primary_field;
            if (!empty($tool->secondary_field))
                $fields[] = $tool->secondary_field;
            if (!empty($tool->terciary_field))
                $fields[] = $tool->terciary_field;
            //check for module criteria
            $has_module = false;
            $criterias = '';
            $tableStructure = $tool->toolTableStructure();
            if (array_key_exists('MODULECODE', $tableStructure['fields'])) {
                $fields[] = 'MODULECODE';
                $has_module = true;
                if (!empty(UserRequest::$post['utl_modules'])) {
                    $criterias = ' AND MODULECODE IN (' . singleQuote($implode('', '', UserRequest::$post['utl_modules'])) . ') ';
                }
            }
            //adding entries
            foreach ($tool->primary_key as $key => $val) {
                if (!array_key_exists($val, $fields)) {
                    $fields[] = $val;
                }
            }
            $table->addCell($tool->name, array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO, CLX_PROP_CLASS => CLX_CLASS_DATAALT));
            //synchsing
            $rem = array();
            $f = implode(',', $fields);
            $sql = 'SELECT ' . $f . ' FROM ' . $tool->tablename . ' WHERE 1=1 ' . $criterias . ' ORDER BY ' . (($has_module) ? ' MODULECODE, ' : '') . ' ' . $tool->primary_field . ' ';
            $rs = ClxCommon::$dbsrc->executeQuery($sql);
            while (($r = ClxCommon::$dbsrc->getNextRecord($rs)) === true) {
                $key = $this->getToolKey($tool->primary_key, $r);
                $rem[$key] = $r;
            }
            $cur = array();
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $key = $this->getToolKey($tool->primary_key, $r);
                $cur[$key] = $r;
            }
            $class = CLX_CLASS_DATA;
            foreach ($rem as $key => $val) {
                $name = '';
                $comma = '';
                if (!empty($tool->primary_field)) {
                    $name .= $val[$tool->primary_field];
                    $comma = ', ';
                }
                if (!empty($tool->secondary_field)) {
                    if ($toolcode === 'UIMI') {
                        $name .= $comma . dict($val[$tool->secondary_field]);
                    } else {
                        $name .= $comma . $val[$tool->secondary_field];
                    }
                    $comma = ', ';
                }
                if (!empty($tool->terciary_field)) {
                    $name .= $comma . $val[$tool->terciary_field];
                    $comma = ', ';
                }
                if (empty($name))
                    $name = $key;
                if ($has_module === true) {
                    $name = $dicts['GEN_LBL_MODULE'] . ': ' . $val['MODULECODE'] . ', ' . $dicts['GEN_LBL_OBJECT'] . ':' . $name;
                }
                $rv = $rem[$key]['VERSION'] . '.' . $rem[$key]['VERSION_COUNTER'];
                if (!array_key_exists($key, $cur)) {
                    $table->addCell($name, array(CLX_PROP_CLASS => $class));
                    $table->addCell($dicts['GEN_LBL_NEW'] . ' ' . $rv, array(CLX_PROP_CLASS => $class, 'style' => 'background-color: yellow'));
                } else {
                    $cv = $cur[$key]['VERSION'] . '.' . $cur[$key]['VERSION_COUNTER'];
                    if ($cv < $rv) {
                        $table->addCell($name, array(CLX_PROP_CLASS => $class));
                        $table->addCell($dicts['GEN_LBL_UPGRADE'] . ' ' . $cv . '->' . $rv, array(CLX_PROP_CLASS => $class, 'style' => 'background-color: green'));
                    } elseif ($cv == $rv) {
                        if (empty(UserRequest::$post['utl_hide_same_version'])) {
                            $table->addCell($name, array(CLX_PROP_CLASS => $class));
                            $table->addCell($dicts['GEN_LBL_SAME'] . ' ' . $cv, array(CLX_PROP_CLASS => $class));
                        }
                    } else {
                        $table->addCell($name, array(CLX_PROP_CLASS => $class));
                        $table->addCell($dicts['GEN_LBL_DOWNGRADE'] . ' ' . $cv . '->' . $rv, array(CLX_PROP_CLASS => $class, 'style' => 'background-color: red'));
                    }
                }
            }
            //hiding local objets
            if (!empty(UserRequest::$post['utl_hide_local_objs']))
                continue;
            $table->addSeparator(CLX_CLASS_SUBTITLE, $tool->name . ' (' . $dicts['GEN_LBL_LOCAL_ONLY'] . ')');
            $minus = array_diff_assoc($cur, $rem);
            //removing entries not found
            foreach ($minus as $key => $val) {
                $cv = $minus[$key]['VERSION'] . '.' . $minus[$key]['VERSION_COUNTER'];
                $name = '';
                $comma = '';
                if (!empty($tool->primary_field)) {
                    $name .= $val[$tool->primary_field];
                    $comma = ', ';
                }
                if (!empty($tool->secondary_field)) {
                    $name .= $comma . $val[$tool->secondary_field];
                    $comma = ', ';
                }
                if (!empty($tool->terciary_field)) {
                    $name .= $comma . $val[$tool->terciary_field];
                    $comma = ', ';
                }
                if (empty($name))
                    $name = $key;
                if ($has_module === true) {
                    $name = $dicts['GEN_LBL_MODULE'] . ': ' . $val['MODULECODE'] . ', ' . $dicts['GEN_LBL_OBJECT'] . ':' . $name;
                }
                $table->addCell($name, array(CLX_PROP_CLASS => $class));
                $table->addCell($dicts['GEN_LBL_LOCAL_ONLY'] . ' ' . $cv, array(CLX_PROP_CLASS => $class, 'style' => 'background-color: grey'));
            }
            unset($rem, $cur, $minus);
        }
        pushHistory($this->code, 'IGNORE_THIS_ENTRY', CLX_NUM_ZERO);
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->addArgument(CLX_PROP_TO, 'UTIL');
        $form->addArgument('ac', 'UTL_LIST');
        $c = new htmlButtonReturn();
        $buttons = $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $contents = $form->source();
        return $contents;
    }

}
