<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
class an_output_gen_fields extends clx_tool {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'ANOF';
        $this->name = 'Output Generator Template Fields';
        $this->system = 'Analytics';
        $this->version = '0.1.3.0';



        $this->accesskey = 'ANOG';
        $this->tablename = 'CLX_AN_OUTPUT_GEN_FIELDS';
        $this->record_name_singular = 'field';
        $this->record_name_plural = 'fields';
        $this->primary_field = 'ID';
        $this->secondary_field = 'FORMCODE';

        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_ANOF_TITLE_CREATE',
            'panels' => array(
                array('type' => 'normal', 'entries' => array(
                        array('label' => 'GEN_LBL_TEMPLATECODE',
                            'fields' => array(
                                array('name' => 'templatecode', 'type' => 'string', 'readonly' => '1'))
                        ), array('label' => 'GEN_LBL_FIELDNAME',
                            'fields' => array(
                                array('name' => 'fieldname', 'type' => 'string', 'readonly' => '1'))
                        ), array('label' => 'GEN_LBL_MAP',
                            'fields' => array(
                                array('name' => 'map', 'type' => 'text', 'validations' => array(
                                        array('type' => 'string', 'required' => '1'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_PREFIX',
                            'fields' => array(
                                array('name' => 'prefix', 'type' => 'string', 'size' => '255', 'displaysize' => '48'))
                        ), array('label' => 'GEN_LBL_SUFIX',
                            'fields' => array(
                                array('name' => 'sufix', 'type' => 'string', 'size' => '255', 'displaysize' => '48'))
                        ), array('label' => 'GEN_LBL_FORMAT',
                            'fields' => array(
                                array('name' => 'format', 'type' => CLX_CLASS_LIST, 'options' => array('1' => 'GEN_LBL_YES', '0' => 'GEN_LBL_NO')))
                        )
                    )
                )
            )
        );
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['TEMPLATECODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['FIELDNAME'] = array('type' => 'varchar(255)', 'null' => 'NO', 'properties' => '');
        $fields['PREFIX'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $fields['SUFIX'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $fields['FORMAT'] = array('type' => 'tinyint(1) unsigned', 'null' => 'YES', 'properties' => '');
        $fields['MAP'] = array('type' => 'text', 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'MUL', 'fieldname' => 'TEMPLATECODE');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'FIELDNAME');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB', 'fields' => $fields, 'indexes' => $indexes);
    }

    function action($ac, $idlist) {
        if ($this->getAccess()->canRead()) {
            $contents = parent::action($ac, $idlist);
        } else {
            $contents = warning(dict('GEN_ERR_NO_ACCESS') . '[AN_OUTPUT_GEN_FIELDS-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    function makepanel($groupcode = null) {
        if ($this->getAccess()->canRead()) {
            $t = time();
            $to = $this->code;
            $here = 'tool.php?to=' . $to . '&t=' . $t;
            $yesno = array(dict('GEN_LBL_NO'), dict('GEN_LBL_YES'));
            $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
            $form->setProp(CLX_PROP_ID, 'ANOFPanel');
            $form->addArgument(CLX_PROP_TO, $this->code);
            $form->addArgument('templatecode', $groupcode);
            $form->addArgument('ac', 'NOT_DEFINED');
            $selectclause = '*';
            $fromclause = 'CLX_AN_OUTPUT_GEN_FIELDS';
            $whereclause = 'TEMPLATECODE=' . singleQuote($groupcode);
            $sortclause = 'FIELDNAME';
            $page = new xPaging();
            $page->setProp('rpp', CLX_NUM_TEN_THOUSAND);
            $page->setProp('printheaders', false);
            $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
            $table = new htmlTable(CLX_WIDTH_SIX);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $page->header($table);
            $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SELECT'), dict('GEN_LBL_FIELDNAME'), dict('GEN_LBL_MAP'), dict('GEN_LBL_FORMAT'), dict('GEN_LBL_PREFIX'), dict('GEN_LBL_SUFIX')));
            $i = CLX_INIT_ZERO;
            while ($record = $page->nextRecord()) {
                $recordid = $record['ID'];
                $select = new htmlCheckbox('selector_' . $recordid, false);
                $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
                $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
                if (empty($record['FORMAT']))
                    $record['FORMAT'] = CLX_NUM_ZERO;
                $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array($record['FIELDNAME'], xFormat::text($record['MAP']), $yesno[$record['FORMAT']], $record['PREFIX'], $record['SUFIX']));
                $i++;
            }
            $buttons = '';
            if ($this->getAccess()->canModify()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            }
            $form->addContents($page->footers($table, $buttons));
            return buildPanelInterface(dict('TOOL_ANOF_TITLE_LIST'), $groupcode . 'FIELDS', $form->source(), CLX_NUM_MINUS_1);
        } else {
            return CLX_CHAR_EMPTY_STRING;
        }
    }

    function loadToolRecord($recordid) {
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $recordid);
        $record = array();
        $record['ANOF_id'] = $recordid;
        $record['ANOF_templatecode'] = $values['TEMPLATECODE'];
        $record['ANOF_fieldname'] = $values['FIELDNAME'];
        $record['ANOF_prefix'] = $values['PREFIX'];
        $record['ANOF_sufix'] = $values['SUFIX'];
        $record['ANOF_format'] = $values['FORMAT'];
        $record['ANOF_map'] = $values['MAP'];
        return $record;
    }

    function saveRecord() {
        $record = ClxCommon::$db->getRecord($this->tablename, 'ID=' . UserRequest::$post['ANOF_id']);
        unset($record['ID']);
        unset($record['FIELDNAME']);
        $record['PREFIX'] = UserRequest::$post['ANOF_prefix'];
        $record['SUFIX'] = UserRequest::$post['ANOF_sufix'];
        $record['FORMAT'] = UserRequest::$post['ANOF_format'];
        $record['MAP'] = UserRequest::$post['ANOF_map'];
        ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post['ANOF_id']);
        $this->versionIncrease('ID', UserRequest::$post['ANOF_id']);
        $templaterecord = ClxCommon::$db->getRecord('CLX_AN_OUTPUT_GEN', 'IDCODE=' . singleQuote($record['TEMPLATECODE']));
        $ANOG = &getTool('ANOG');
        $ANOG->checkTemplate($templaterecord);
    }

    function versionIncrease($fieldname, $fieldvalue) {
        $templatecode = ClxCommon::$db->getField($this->tablename, 'TEMPLATECODE', $fieldname . '=' . singleQuote($fieldvalue));
        $ANOG = &getTool('ANOG');
        $ANOG->versionIncrease('IDCODE', $templatecode);
    }

}
