<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
class an_plot_series extends clx_tool {

    var $serie_types;

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'ANPS';
        $this->name = 'Chart Plot Series';
        $this->system = 'Analytics';
        $this->version = '4.0.0.2';

        $this->accesskey = 'ANPL';


        $this->tablename = 'CLX_AN_PLOT_SERIES';
        $this->record_name_singular = 'Chart serie';
        $this->record_name_plural = 'Chart series';
        $this->primary_field = 'NAME';
        $this->secondary_field = 'CHARTCODE';
        $this->seqnum_field = 'SEQNUM';
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['CHARTCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['NAME'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '');
        $fields['TYPE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['TABLECODE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['FIELDNAME'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '');
        $fields['FUNCTION'] = array('type' => 'varchar(32)', 'null' => 'YES', 'properties' => '');
        $fields['EXPRESSION'] = array('type' => 'text', 'null' => 'YES', 'properties' => '');
        $fields['GROUPBY'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['STATUS'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['SEQNUM'] = array('type' => 'tinyint(4) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['SERIES_PROPERTIES'] = array('type' => 'mediumtext', 'null' => 'YES', 'properties' => '');
        $fields['FORMAT'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ONE);
        $fields['USE_QUERY_FIELD'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        //Multiseries Elements
        $fields['QUERYCODE'] = array('type' => 'varchar(16)', 'null' => 'YES', 'properties' => '');
        $fields['REL_TABLECODE'] = array('type' => 'varchar(4)', 'null' => 'YES', 'properties' => '');
        $fields['REL_FIELDNAME'] = array('type' => 'varchar(64)', 'null' => 'YES', 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'MUL', 'fieldname' => 'CHARTCODE');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'SEQNUM');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
            'fields' => $fields,
            'indexes' => $indexes);
    }

    function unpack($parameters) {
        $parameters = array_values(array_merge(array('package' => null, 'id' => null), $parameters));
        list($package, $panelid) = $parameters;
        $record = $this->unpackRecord($package);
        $fieldid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        if ($package->hasSubObject($this->code . '_OBJECTS')) {
            $objs = $package->getObjectXml($this->code . '_OBJECTS');
            foreach ($objs->objects as $o) {
                $toolcode = $o->tag;
                $tool = &getTool($toolcode);
                $tool->unpack(array('package' => $o, 'id' => $fieldid));
            }
        }
    }

//--  C H A R T    S E R I E S
    function makepanel($groupcode = null) {
        $this->buildTypes($groupcode);
        if ($this->getAccess()->canRead()) {
            $t = time();
            $to = $this->code;
            $here = 'tool.php?to=' . $to . '&t=' . $t;
            $yesno = array(dict('GEN_LBL_NO'), dict('GEN_LBL_YES'));
            $status = array(dict('GEN_LBL_INACTIVE'), dict('GEN_LBL_ACTIVE'));
            $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
            $form->setProp(CLX_PROP_ID, 'ANPSPanel');
            $form->addArgument(CLX_PROP_TO, $this->code);
            $form->addArgument('chartcode', $groupcode);
            $form->addArgument('ac', 'NOT_DEFINED');
            switch (kDatabaseType) {
                case 'oci':
                    $selectclause = 't.MODULECODE||' . singleQuote(CLX_CHAR_EMPTY_STRING) . '||t.IDNAME||' . singleQuote(CLX_CHAR_EMPTY_STRING) . '||c.FIELDNAME FULLFIELDNAME, c.*';
                    break;
                default:
                    $selectclause = 'concat(t.MODULECODE, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ', t.IDNAME, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ', c.FIELDNAME) FULLFIELDNAME, c.*';
                    break;
            }//End switch
            $fromclause = $this->tablename . ' c, CLX_DB_TABLES t';
            $whereclause = 'c.TABLECODE = t.idcode AND c.CHARTCODE=' . singleQuote($groupcode);
            $sortclause = 'SEQNUM';
            $page = new xPaging();
            $page->setProp('rpp', CLX_NUM_TEN_THOUSAND);
            $page->setProp('printheaders', false);
            $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
            $table = new htmlTable(CLX_WIDTH_NINE);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $page->header($table);
            $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_NAME'), dict('GEN_LBL_FIELDNAME'), dict('GEN_LBL_USE_QUERY_FIELD'), dict('GEN_LBL_FUNCTION'), dict('GEN_LBL_TYPE'), dict('GEN_LBL_GROUP'), dict('GEN_LBL_ACTIVE'), dict('GEN_LBL_FORMAT')));
            $i = CLX_INIT_ZERO;
            while ($record = $page->nextRecord()) {
                $recordid = $record['ID'];
                $select = new htmlCheckbox('selector_' . $recordid, false);
                $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
                $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
                $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array($record['NAME'], $record['FULLFIELDNAME'], dict(($record['USE_QUERY_FIELD']) ? 'GEN_LBL_YES' : 'GEN_LBL_NO'), (strlen($record['EXPRESSION']) > CLX_NUM_ZERO) ? $record['EXPRESSION'] : $record['FUNCTION'], $this->serie_types[$record['TYPE']], $yesno[$record['GROUPBY']], $status[$record['STATUS']], $yesno[$record['FORMAT']]));
                $i++;
            }
            $buttons = '';
            $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_DISPLAY'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            if ($this->getAccess()->canModify()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            }
            if ($this->getAccess()->canDelete()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            }
            if ($this->getAccess()->canDisplay()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE_SOMETHING', dict('GEN_LBL_SERIES')), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
            }
            if ($page->getProp('qty') > CLX_NUM_ONE) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_REORDER'), array('action' => 'REORDER', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
            }
            $form->addContents($page->footers($table, $buttons));
            return buildPanelInterface(dict('TOOL_ANPS_TITLE_LIST'), 'TABLES', $form->source(), CLX_NUM_MINUS_1);
        } else {
            return CLX_CHAR_EMPTY_STRING;
        }
    }

    function editForm($ac, $idlist, $record, $msg) {
        $ANPL = &getTool('ANPL');
        $chartcode = $record['ANPS_chartcode'];
        ClxFreeReturn(ClxCommon::$db->getRecord($ANPL->tablename, 'IDCODE=' . singleQuote($chartcode)));
        $this->buildTypes($chartcode);
        $modify = (UserRequest::$request['ac'] === 'MODIFY');
        $title = ($modify) ? dict('TOOL_ANPS_TITLE_MODIFY') : dict('TOOL_ANPS_TITLE_CREATE');
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', $ac);
        $form->addArgument('confirm', '1');
        $form->addArgument('ANPS_id', $record['ANPS_id']);
        $form->addArgument('ANPS_chartcode', $record['ANPS_chartcode']);
        $form->addArgument('idlist', toString($idlist));
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell($title, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addField($msg, dict('GEN_LBL_NAME') . ':', 'ANPS_name', $record['ANPS_name'], CLX_NUM_48, CLX_NUM_64, true);
        /*         * ************** Fieldname and Tablecode **************** */
        $chartcode = $record['ANPS_chartcode'];
        $sql = 'SELECT DISTINCT c.QUERYCODE, q.TABLECODE, t.IDCODE, t.IDNAME, t.MODULECODE, f.FIELDNAME FROM ' . $ANPL->tablename . ' c, CLX_DB_QUERY_TABLES q, CLX_DB_TABLES t, CLX_DB_TABLEFIELDS f WHERE c.IDCODE=' . singleQuote($chartcode) . ' AND q.QUERYCODE = c.QUERYCODE AND t.IDCODE = q.TABLECODE AND f.TABLECODE=q.TABLECODE UNION SELECT DISTINCT c.QUERYCODE, q.TABLECODE, t.IDCODE, t.IDNAME, t.MODULECODE, CONCAT(f.FIELDNAME,' . singleQuote('_WR') . ') FIELDNAME FROM ' . $ANPL->tablename . ' c, CLX_DB_QUERY_TABLES q, CLX_DB_TABLES t, CLX_DB_TABLEDFIELDS f WHERE c.IDCODE=' . singleQuote($chartcode) . ' AND q.QUERYCODE = c.QUERYCODE AND t.IDCODE = q.TABLECODE AND f.TABLECODE=q.TABLECODE ';
        $fields = ClxCommon::$db->executeQuery($sql);
        $pop = new htmlSelect('ANPS_tablecode_fieldname');
        while (($field = ClxCommon::$db->getNextRecord($fields))) {
            $fieldvalue = $field['TABLECODE'] . '.' . $field['FIELDNAME'];
            $pop->addItem($fieldvalue, $fieldvalue, ($fieldvalue == $record['ANPS_tablecode_fieldname']));
        }
        $table->addData(dict('GEN_LBL_FIELDNAME') . ':', $pop->source(), CLX_CLASS_PROMPTREQUIRED);
        // Type
        $pop = new htmlSelect('ANPS_type');
        foreach ($this->serie_types as $key => $value) {
            $pop->addItem($value, $key, ($record['ANPS_type'] == $key));
        }
        $table->addData(dict('GEN_LBL_TYPE') . ':', $pop->source(), CLX_CLASS_PROMPTREQUIRED);
        $table->addSeparator(CLX_CLASS_DATA);
        // Use query field
        $pop = new htmlSelect('ANPS_use_query_field');
        $pop->addItem(dict('GEN_LBL_YES'), '1', ($record['ANPS_use_query_field'] === '1'));
        $pop->addItem(dict('GEN_LBL_NO'), '0', ($record['ANPS_use_query_field'] === '0'));
        $table->addData(dict('GEN_LBL_USE_QUERY_FIELD') . ':', $pop->source());
        $pop = new htmlSelect('ANPS_function');
        $pop->addItem('', '', ($record['ANPS_function'] === ''));
        $pop->addItem('Count', 'COUNT', ($record['ANPS_function'] === 'COUNT'));
        $pop->addItem('Average', 'AVG', ($record['ANPS_function'] === 'AVG'));
        $pop->addItem('Minimum Value', 'MIN', ($record['ANPS_function'] === 'MIN'));
        $pop->addItem('Maximum Value', 'MAX', ($record['ANPS_function'] === 'COMAXUNT'));
        $pop->addItem('Sum', 'SUM', ($record['ANPS_function'] === 'SUM'));
        $pop->addItem('Standard Variance ', 'VARIANCE', ($record['ANPS_function'] === 'VARIANCE'));
        $pop->addItem('Standard Deviation ', 'STD', ($record['ANPS_function'] === 'STD'));
        $pop->addItem('Bitwise Or', 'BIT_OR', ($record['ANPS_function'] === 'BIT_OR'));
        $pop->addItem('Bitwise And', 'BIT_AND', ($record['ANPS_function'] === 'BIT_AND'));
        //$table->addData(dict('GEN_LBL_FUNCTION') . ':', $pop->source());
        $field = new htmlTextArea('ANPS_expression', $record['ANPS_expression'], CLX_NUM_7, CLX_NUM_50);
        if (!empty($msg['ANPS_expression']))
            $table->addCell($msg['ANPS_expression'], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => $table->width));
        $table->addData(dict('TOOL_ANPS_FUNCTIONOREXPRE') . ':', $pop->source() . '<br>' . dict('GEN_LBL_OR') . '<br>' . $field->source());
        $table->addSeparator(CLX_CLASS_DATA);
        // Group
        $pop = new htmlSelect('ANPS_groupby');
        $pop->addItem(dict('GEN_LBL_YES'), '1', ($record['ANPS_groupby'] === '1'));
        $pop->addItem(dict('GEN_LBL_NO'), '0', ($record['ANPS_groupby'] === '0'));
        $table->addData(dict('GEN_LBL_GROUP') . ':', $pop->source());
        // Status
        $pop = new htmlSelect('ANPS_status');
        $pop->addItem(dict('GEN_LBL_ACTIVE'), '1', ($record['ANPS_status'] === '1'));
        $pop->addItem(dict('GEN_LBL_INACTIVE'), '0', ($record['ANPS_status'] === '0'));
        $table->addData(dict('GEN_LBL_STATUS') . ':', $pop->source());
        $pop = new htmlSelect('ANPS_format');
        $pop->addItem(dict('GEN_LBL_YES'), '1', ($record['ANPS_format'] === '1'));
        $pop->addItem(dict('GEN_LBL_NO'), '0', ($record['ANPS_format'] === '0'));
        $table->addData(dict('GEN_LBL_FORMAT') . ':', $pop->source());
        $form->addContents($table->source());
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $buttons = '';
        if (!empty($modify)) {
            $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_SAVE'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID)))->source();
        } else {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE'), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID)))->source();
        }
        $c = new htmlButtonCancel();
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->addContents($table->source());
        return $form->source();
    }

    function checkForm(&$msg) {
        $msg = array();
        xValidate::required($msg, 'ANPS_name', UserRequest::$post['ANPS_name']);
        return count($msg) == CLX_NUM_ZERO;
    }

    function confirmDeleteFill(&$table, $record) {
        $table->addData(dict('GEN_LBL_NAME') . ':', $record['ANPS_name']);
    }

    function reorderRecords() {
        $records = ClxCommon::$db->getRecords($this->tablename, 'CHARTCODE=' . singleQuote(UserRequest::$post['chartcode']) . ' ORDER BY SEQNUM');
        $list = array();
        while (($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE))) {
            $list[$record['ID']] = $record['NAME'];
        }
        return $list;
    }

    function reorderAction() {
        parent::reorderAction();
        $callingpage = peekHistory();
        $chartcode = $callingpage['chartcode'];
        $ANPL = &getTool('ANPL');
        $ANPL->versionIncrease('idcode', $chartcode);
    }

    function viewFormFill($record) {
        $this->buildTypes($record['ANPS_chartcode']);
        $series_records = array();
        $sql = '';
        $ANPL = &getTool('ANPL');
        $ANPL->plotQuery($record['ANPS_chartcode'], $series_records, $sql);
        $yesno = array(dict('GEN_LBL_NO'), dict('GEN_LBL_YES'));
        $status = array(dict('GEN_LBL_INACTIVE'), dict('GEN_LBL_ACTIVE'));
        $contents = '';
        // Usual Information
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_ANPS_TITLE_VIEW') . ': ' . $record['ANPS_name'], array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addData(dict('GEN_LBL_NAME') . ':', $record['ANPS_name']);
        $table->addData(dict('GEN_LBL_FIELDNAME') . ':', $record['ANPS_tablecode'] . '.' . $record['ANPS_fieldname']);
        $table->addData(dict('GEN_LBL_USE_QUERY_FIELD') . ':', $yesno[$record['ANPS_use_query_field']]);
        $table->addSeparator(CLX_CLASS_DATA);
        $table->addData(dict('GEN_LBL_FUNCTION') . ':', (strlen($record['ANPS_expression']) > CLX_NUM_ZERO) ? $record['ANPS_expression'] : $record['ANPS_function']);
        $table->addData(dict('GEN_LBL_GROUP') . ':', $yesno[$record['ANPS_groupby']]);
        $table->addData(dict('GEN_LBL_STATUS') . ':', $status[$record['ANPS_status']]);
        $table->addData(dict('GEN_LBL_FORMAT') . ':', $yesno[$record['ANPS_format']]);
        $table->addSeparator(CLX_CLASS_DATA);
        $nicesql = str_replace('SELECT', '<b>SELECT</b><br>', $sql);
        $nicesql = str_replace('FROM', '<br><b>FROM</b><br>', $nicesql);
        $nicesql = str_replace('WHERE', '<br><b>WHERE</b><br>', $nicesql);
        $nicesql = str_replace('GROUP BY', '<br><b>GROUP BY</b><br>', $nicesql);
        $table->addData(dict('GEN_LBL_SQL') . ':', $nicesql);
        $contents .= $table->source();
        // Series Information
        $records = ClxCommon::$db->executeQuerySilent($sql);
        $qty = ($records) ? ClxCommon::$db->numFields($records) : CLX_NUM_ZERO;
        $tableWidth = $qty;
        $table = new htmlTable($tableWidth);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_ANPS_TITLE_SERIESDATA'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => $tableWidth));
        if (empty($records)) {
            $table->addCell(dict('GEN_ERR_SQLERR'), array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => $tableWidth));
        }
        foreach ($series_records as $i => $v) {
            $table->addCell($v['NAME'] . ' (' . $v['AS'] . ')', array(CLX_PROP_CLASS => CLX_CLASS_HEADERS));
        }
        $j = CLX_INIT_ZERO;
        while (($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE))) {
            foreach ($series_records as $i => $v) {
                $pos = strpos($v['AS'], '_', CLX_NUM_ZERO);
                $fieldname = substr($v['AS'], $pos + CLX_NUM_ONE);
                $fieldrec = ClxCommon::$db->getRecord('CLX_DB_FIELDS', '(FIELDNAME=' . singleQuote($fieldname) . ' OR CONCAT(FIELDNAME, ' . singleQuote('_WR') . ')=' . singleQuote($fieldname) . ')');
                if (!empty($fieldrec)) {
                    $fieldinstance = getToolObject('DBFT', $fieldrec['FIELDTYPE']);
                    $data = array();
                    $data[$fieldname] = $record[uppercase($v['AS'])];
                    $value = $fieldinstance->formatField($fieldname, $fieldrec, $data);
                    $table->addCell($value, array(CLX_PROP_CLASS => ($j % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT));
                }
            }
            $j++;
        }
        $contents .= $table->source();
        return $contents;
    }

    function loadToolRecord($recordid) {
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $recordid);
        $record = array();
        $record['ANPS_id'] = $recordid;
        $record['ANPS_chartcode'] = $values['CHARTCODE'];
        $record['ANPS_name'] = $values['NAME'];
        $record['ANPS_type'] = $values['TYPE'];
        $record['ANPS_tablecode'] = $values['TABLECODE'];
        $record['ANPS_fieldname'] = $values['FIELDNAME'];
        $record['ANPS_tablecode_fieldname'] = $record['ANPS_tablecode'] . '.' . $record['ANPS_fieldname'];
        $record['ANPS_function'] = $values['FUNCTION'];
        $record['ANPS_expression'] = $values['EXPRESSION'];
        $record['ANPS_groupby'] = $values['GROUPBY'];
        $record['ANPS_status'] = $values['STATUS'];
        $record['ANPS_seqnum'] = $values['SEQNUM'];
        $record['ANPS_format'] = $values['FORMAT'];
        $record['ANPS_use_query_field'] = (!empty($values['USE_QUERY_FIELD'])) ? CLX_NUM_ONE : CLX_NUM_ZERO;
        //multiseries
        return $record;
    }

    function saveRecord() {
        $record = array();
        $record['CHARTCODE'] = UserRequest::$post['ANPS_chartcode'];
        $record['NAME'] = UserRequest::$post['ANPS_name'];
        $record['TYPE'] = UserRequest::$post['ANPS_type'];
        $pos = explode('.', UserRequest::$post['ANPS_tablecode_fieldname']);
        $record['TABLECODE'] = $pos[CLX_NUM_ZERO];
        $record['FIELDNAME'] = $pos[CLX_NUM_ONE];
        $record['FUNCTION'] = UserRequest::$post['ANPS_function'];
        $record['EXPRESSION'] = UserRequest::$post['ANPS_expression'];
        $record['GROUPBY'] = UserRequest::$post['ANPS_groupby'];
        $record['STATUS'] = UserRequest::$post['ANPS_status'];
        $record['FORMAT'] = UserRequest::$post['ANPS_format'];
        $record['USE_QUERY_FIELD'] = (!empty(UserRequest::$post['ANPS_use_query_field'])) ? CLX_NUM_ONE : CLX_NUM_ZERO;
        //multiseries
        ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post['ANPS_id']);
        $ANPL = &getTool('ANPL');
        $ANPL->versionIncrease('IDCODE', UserRequest::$post['ANPS_chartcode']);
    }

    function createRecordVoid_() {
        ClxFreeReturn($this->createRecord_());
    }

    function createRecord_() {
        $record = array();
        $record['CHARTCODE'] = UserRequest::$post['ANPS_chartcode'];
        $record['NAME'] = UserRequest::$post['ANPS_name'];
        $record['TYPE'] = UserRequest::$post['ANPS_type'];
        $pos = explode('.', UserRequest::$post['ANPS_tablecode_fieldname']);
        $record['TABLECODE'] = $pos[CLX_NUM_ZERO];
        $record['FIELDNAME'] = $pos[CLX_NUM_ONE];
        $record['FUNCTION'] = UserRequest::$post['ANPS_function'];
        $record['EXPRESSION'] = UserRequest::$post['ANPS_expression'];
        $record['GROUPBY'] = UserRequest::$post['ANPS_groupby'];
        $record['STATUS'] = UserRequest::$post['ANPS_status'];
        $record['SEQNUM'] = ClxCommon::$db->getField($this->tablename, 'SEQNUM', 'CHARTCODE=' . singleQuote($record['CHARTCODE']) . ' ORDER BY SEQNUM DESC') + CLX_NUM_ONE;
        $record['FORMAT'] = UserRequest::$post['ANPS_format'];
        $record['USE_QUERY_FIELD'] = (!empty(UserRequest::$post['ANPS_use_query_field'])) ? CLX_NUM_ONE : CLX_NUM_ZERO;
        //multiseries
        $recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        $ANPL = &getTool('ANPL');
        $ANPL->versionIncrease('IDCODE', UserRequest::$post['ANPS_chartcode']);
        return $recordid;
    }

    function deleteRecordSk($id) {
        $plotrec = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $id);
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
        $ANPL = &getTool('ANPL');
        $ANPL->versionIncrease('IDCODE', $plotrec['CHARTCODE']);
    }

    function defaultRecord() {
        $record = array();
        $record['ANPS_id'] = CLX_INIT_ZERO;
        $record['ANPS_chartcode'] = UserRequest::$request['chartcode'];
        $record['ANPS_name'] = '';
        $record['ANPS_type'] = '?';
        $record['ANPS_tablecode'] = '';
        $record['ANPS_fieldname'] = '';
        $record['ANPS_tablecode_fieldname'] = '';
        $record['QUERYCODE'] = '';
        $record['ANPS_rel_tablecode'] = '';
        $record['ANPS_rel_fieldname'] = '';
        $record['ANPS_function'] = '';
        $record['ANPS_expression'] = '';
        $record['ANPS_groupby'] = '0';
        $record['ANPS_status'] = '1';
        $record['ANPS_seqnum'] = '0';
        $record['ANPS_format'] = '0';
        $record['ANPS_use_query_field'] = CLX_INIT_ZERO;
        return $record;
    }

    function buildTypes($chartcode) {
        $plotType = ClxCommon::$db->getField('CLX_AN_PLOT', 'PLOT_TYPE', 'IDCODE = ' . singleQuote($chartcode));
        $plotinstance = getToolObject('PLOT', $plotType);
        $this->serie_types = $plotinstance->serie_types;
    }

}
