<?php
/**
 * Process Activities Parameters Manager
 *
 * @package		Clientix.Tool.Business Process
 * @abstract		Business Process Manager
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-06-21 08:03:11 -0400 (Thu, 21 Jun 2018) $
 * @version    	$Rev: 9841 $
 *
 */
class bp_act_prmts extends clx_tool {

    /**
     * Constructor
     */
    function __construct() {
        $this->code = 'BPAP';
        $this->name = 'Business Process - Activity Parameters';
        $this->system = 'Business Process';
        $this->version = '5.5.0.1';
        $this->tablename = 'CLX_BP_ACTIVITY_PRMTS';
        $this->record_name_singular = 'GEN_LBL_BP_AC_PAR';
        $this->record_name_plural = 'GEN_LBL_BP_AC_PARS';
        $this->primary_key = array('ID');
        $this->primary_field = 'ID';
        $this->secondary_field = 'FIELDNAME';
        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_BPPE_TITLE_CREATE', // ETIQUETA
            'panels' => array(
                array('type' => 'normal',
                    'entries' => array(
                        array('label' => 'GEN_LBL_ACTIVITIESCODE',
                            'fields' => array(
                                array('name' => 'activitiescode',
                                    'type' => 'lookup',
                                    'default' => '',
                                    'readonly' => false,
                                    'tool' => 'BPAC',
                                    'validations' => array(
                                        array('type' => 'string',
                                            'required' => '1'
                                        ), array('type' => 'lookup',
                                            'fieldname' => 'activitiescode',
                                            'tablename' => 'CLX_BP_ACTIVITIES'
                                        )
                                    )
                                )
                            )
                        ), 
                        array(
                            'label' => 'GEN_LBL_STATUS',
                            'fields' => array(
                                array(
                                    'name' => 'status',
                                    'type' => CLX_CLASS_LIST,
                                    'default' => '1',
                                    'options' => $this->status
                                )
                            )
                        ),
                        array('label' => 'GEN_LBL_TABLECODE',
                            'fields' => array(
                                array('name' => 'tablecode',
                                    'type' => 'lookup',
                                    'default' => '',
                                    'readonly' => false,
                                    'tool' => 'DBTB',
                                    'validations' => array(
                                        array('type' => 'string',
                                            'required' => '1'
                                        ), array('type' => 'lookup',
                                            'fieldname' => 'idcode',
                                            'tablename' => 'CLX_DB_TABLES'
                                        )
                                    )
                                )
                            )
                        ), 
                        array('label' => 'GEN_LBL_FIELDNAME',
                            'fields' => array(
                                array('name' => 'fieldname',
                                    'type' => 'lookup',
                                    'default' => '',
                                    'readonly' => false,
                                    'tool' => 'DBFL',
                                    'validations' => array(
                                        array('type' => 'sqlobject',
                                            'required' => '1'
                                        ), array('type' => 'lookup',
                                            'fieldname' => 'FIELDNAME',
                                            'tablename' => 'CLX_DB_FIELDS'
                                        )
                                    )
                                )
                            )
                        ), 
                        array('label' => 'GEN_LBL_FIELDVALUE',
                            'fields' => array(
                                array('name' => 'fieldvalue',
                                    'type' => 'string',
                                    'default' => '',
                                    'size' => '255',
                                    'displaysize' => '30',
                                    'validations' => array(
                                        array('type' => 'string', 'required' => CLX_NUM_ONE))
                                )
                            )
                        )
                    )
                )
            )
        );
        $this->viewform = $this->editform;
        $this->viewform [CLX_CLASS_TITLE] = 'TOOL_BPAP_TITLE_DISPLAY'; // Etiqueta listo
        $this->toolpanelkeys = array(array('name' => 'ACTIVITIESCODE',
                'type' => 'string'
            )
        ); // listo
        $this->toolpanel = array('name' => $this->tablename, CLX_CLASS_TITLE => $this->record_name_plural, 'fields' => array(
                array('name' => 'ID',
                    'label' => 'GEN_LBL_ID',
                    'type' => 'number'
                ), array('name' => 'STATUS',
                    'label' => 'GEN_LBL_STATUS',
                    'type' => 'string'
                ), array('name' => 'TABLECODE',
                    'label' => 'GEN_LBL_TABLECODE',
                    'type' => 'string'
                ), array('name' => 'FIELDNAME',
                    'label' => 'GEN_LBL_FIELDNAME',
                    'type' => 'string'
                ), array('name' => 'FIELDVALUE',
                    'label' => 'GEN_LBL_FIELDVALUE',
                    'type' => 'string'
                )
            )
        );
    }

// End method
    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::toolTableStructure()
     */
    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['ACTIVITIESCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['STATUS'] = array('type' => 'varchar(1)', 'null' => 'NO', 'properties' => '');
        $fields['TABLECODE'] = array('type' => 'varchar(4)', 'properties' => '');
        $fields['FIELDNAME'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '');
        $fields['FIELDVALUE'] = array('type' => 'varchar(255)', 'null' => 'NO', 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes [$ipf . '01'] = array('index' => 'PRI',
            'fieldname' => 'ID'
        );
        $indexes [$ipf . '02'] = array('index' => 'MUL',
            'fieldname' => 'ACTIVITIESCODE'
        );
        $indexes [$ipf . '03'] = array('index' => 'MUL',
            'fieldname' => 'STATUS'
        );
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
            'fields' => $fields,
            'indexes' => $indexes
        );
    }

// end method
    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::action()
     */
    function action($ac, $idlist) {
        //if ($this->access ['canread'] === true) {
        if ($this->getAccess()->canRead()) {
            switch ($ac) {
                default :
                    $contents = parent::action($ac, $idlist);
                    break;
            }
        } else {
            $contents = warning(dict('GEN_ERR_NO_ACCESS') . '[BP_ACTIVITY_PRMTS-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

// end method
    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::unpack()
     */
    function unpack($parameters) {
        $parameters = array_values(array_merge(array('package' => null), $parameters));
        list($package) = $parameters;
        $record = $this->unpackRecord($package);
        ClxCommon::$db->deleteRecords($this->tablename, $this->primary_field . '=' . singleQuote($record [$this->primary_field]));
        ClxCommon::$db->createRecord($this->tablename, $record, false);
    }

    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::defaultRecord()
     */
    function defaultRecord() {
        $callingpage = peekHistory(); // Buscar ojo
        $record = parent::defaultRecord();
        $record ['BPAP_activitiescode'] = $callingpage ['activitiescode'];
        $record ['BPAP_status'] = '1';
        return $record;
    }

// end method
}

// End class
