<?php

/**
 * Process Seccion Manager
 *
 * @package		Clientix.Tool.Business Process
 * @abstract		Business Process Manager
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-06-21 08:03:11 -0400 (Thu, 21 Jun 2018) $
 * @version    	$Rev: 9841 $
 *
 */
class bp_case_activities extends clx_tool {

    /**
     * Constructor
     */
    function __construct() {
        $this->code = 'BPCS';
        $this->name = 'Business Process - Cases Activities';
        $this->system = 'Business Process';
        $this->version = '5.5.0.1';
        $this->tablename = 'CLX_BP_CASE_ACTIVITIES';
        $this->record_name_singular = 'GEN_LBL_BP_CASE_ACTIVITY';
        $this->record_name_plural = 'GEN_LBL_BP_CASE_ACTIVITIES';
        $this->primary_key = array('ID');
        $this->primary_field = 'ID';
        $this->secondary_field = 'CASECODE';
        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_BPCS_TITLE_CREATE',
            'panels' => array(
                array('type' => 'normal',
                    CLX_CLASS_TITLE => 'GEN_LBL_BP_CASE_ACTIVITY',
                    'entries' => array(
                        array('label' => 'GEN_LBL_CASECODE',
                            'fields' => array(
                                array('name' => 'casecode',
                                    'type' => 'lookup',
                                    'default' => '',
                                    'readonly' => false,
                                    'tool' => 'BPCA',
                                    'validations' => array(
                                        array('type' => 'string',
                                            'required' => '1'
                                        ), array('type' => 'lookup',
                                            'fieldname' => 'CASECODE',
                                            'tablename' => 'CLX_BP_CASES'
                                        )
                                    )
                                )
                            )
                        ), array('label' => 'GEN_LBL_LANECODE',
                            'fields' => array(
                                array('name' => 'lanecode',
                                    'type' => 'lookup',
                                    'default' => '',
                                    'readonly' => false,
                                    'tool' => 'BPLA',
                                    'validations' => array(
                                        array('type' => 'string',
                                            'required' => '1'
                                        ), array('type' => 'lookup',
                                            'fieldname' => 'LANECODE',
                                            'tablename' => 'CLX_BP_LANES'
                                        )
                                    )
                                )
                            )
                        ), array('label' => 'GEN_LBL_STARTDATE',
                            'fields' => array(
                                array('name' => 'startdate',
                                    'type' => 'date',
                                    'default' => '1'
                                )
                            )
                        ), array('label' => 'GEN_LBL_ENDDATE',
                            'fields' => array(
                                array('name' => 'enddate',
                                    'type' => 'date',
                                    'default' => '1'
                                )
                            )
                        ), array('label' => 'GEN_LBL_STATUS',
                            'fields' => array(
                                array('name' => 'status',
                                    'type' => CLX_CLASS_LIST,
                                    'default' => '1',
                                    'options' => $this->status)
                            )
                        )
                    )
                )
            )
        );
        $this->viewform = $this->editform;
        $this->viewform [CLX_CLASS_TITLE] = 'TOOL_BPCA_TITLE_DISPLAY'; // Etiqueta listo
        $this->toolpanelkeys = array(array('name' => 'CASECODE',
                'type' => 'string'
            )
        );
        $this->toolpanel = array('name' => $this->tablename, CLX_CLASS_TITLE => $this->record_name_plural, 'has_create' => true,
            'has_modify' => false,
            'has_duplicate' => false,
            'has_delete' => false,
            'has_reorder' => false,
            'fields' => array(
                array('name' => 'ID',
                    'label' => 'GEN_LBL_ID',
                    'type' => 'number'
                ), array('name' => 'CASECODE',
                    'label' => 'GEN_LBL_CASECODE',
                    'type' => 'lookup',
                    'tool' => 'BPCA'
                ), array('name' => 'LANECODE',
                    'label' => 'GEN_LBL_LANECODE',
                    'type' => 'lookup',
                    'tool' => 'BPLA'
                ), array('name' => 'STARTDATE',
                    'label' => 'GEN_LBL_STARTDATE',
                    'type' => 'dati'
                ), array('name' => 'ENDDATE',
                    'label' => 'GEN_LBL_ENDDATE',
                    'type' => 'dati'
                ), array('name' => 'STATUS',
                    'type' => CLX_CLASS_LIST,
                    'label' => 'GEN_LBL_STATUS',
                    'options' => $this->status)
            )
        );
    }

// End method
    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::toolTableStructure()
     */
    function toolTableStructure() {
        $fields = array();
        $fields ['ID'] = array('type' => 'int(11) unsigned',
            'null' => 'NO',
            'properties' => 'auto_increment',
            'index' => 'PRI'
        );
        $fields ['CASECODE'] = array('type' => 'varchar(16)',
            'null' => 'NO',
            'properties' => ''
        );
        $fields ['LANECODE'] = array('type' => 'varchar(16)',
            'null' => 'NO',
            'properties' => ''
        );
        $fields ['STARTDATE'] = array('type' => 'datetime',
            'null' => 'YES',
            'properties' => ''
        );
        $fields ['ENDDATE'] = array('type' => 'datetime',
            'null' => 'YES',
            'properties' => ''
        );
        $fields ['PRIORITY_SEQNUM'] = array('type' => 'varchar(16)',
            'null' => 'NO',
            'properties' => ''
        );
        $fields ['STATUS'] = array('type' => 'varchar(1)',
            'null' => 'NO',
            'properties' => ''
        );
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes [$ipf . '01'] = array('index' => 'PRI',
            'fieldname' => 'ID'
        );
        $indexes [$ipf . '03'] = array('index' => 'MUL',
            'fieldname' => 'CASECODE'
        );
        $indexes [$ipf . '04'] = array('index' => 'MUL',
            'fieldname' => 'LANECODE'
        );
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
            'fields' => $fields,
            'indexes' => $indexes
        );
    }

// end method
    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::action()
     */
    function action($ac, $idlist) {
        //if ($this->access ['canread'] === true) {
        if ($this->getAccess()->canRead()) {
            switch ($ac) {
                default :
                    $contents = parent::action($ac, $idlist);
                    break;
            }
        } else {
            $contents = warning(dict('GEN_ERR_NO_ACCESS') . '[BP_CASE_ACTIVITIES-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

// end method
    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::viewFormFill()
     */
    function viewFormFill($record) {
        addHistory('caseactcode', $record [$this->code . '_id']);
        $BPCK = &getTool('BPCK');
        $contents = $BPCK->makepanel($record [$this->code . '_id']);
        return $contents;
    }

// end method
    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::deleteRecord()
     */
    function deleteRecordSk($id) {
        $TOOL = &getTool('BPCK');
        $rs = ClxCommon::$db->getRecords($TOOL->tablename, 'CASEACTCODE=' . $id);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $TOOL->deleteRecordSk($r ['ID']);
        }
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
    }

// end method
    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::defaultRecord()
     */
    function defaultRecord() {
        $callingpage = peekHistory();
        $record = parent::defaultRecord();
        $record [$this->code . '_casecode'] = $callingpage ['casecode'];
        return $record;
    }

// end method
    /**
     * Builds activity record
     * @param unknown_type $case_rec
     */
}

// End class
