<?php

/**
 * Process Seccion Manager
 *
 * @package		Clientix.Tool.Business Process
 * @abstract		Business Process Manager
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-08-26 17:20:31 -0400 (Sun, 26 Aug 2018) $
 * @version    	$Rev: 9919 $
 *
 */
class bp_case_tasks extends clx_tool {

    /**
     * Constructor
     */
    function __construct() {
        $this->code = 'BPCK';
        $this->name = 'Business Process - Case Tasks';
        $this->system = 'Business Process';
        $this->version = '5.5.0.1';




        $this->tablename = 'CLX_BP_CASE_TASKS';
        $this->record_name_singular = 'GEN_LBL_BP_CASE_TASK';
        $this->record_name_plural = 'GEN_LBL_BP_CASE_TASKS';
        $this->primary_key = array('ID');
        $this->primary_field = 'ID';
        $this->secondary_field = 'CASECODE';

        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_BPCK_TITLE_CREATE',
            'panels' => array(
                array('type' => 'normal',
                    'entries' => array(
                        array(
                            'label' => 'GEN_LBL_CASECODE',
                            'fields' => array(
                                array(
                                    'name' => 'casecode',
                                    'type' => 'lookup',
                                    'default' => '',
                                    'readonly' => false,
                                    'tool' => 'BPCA',
                                    'validations' => array(
                                        array('type' => 'string',
                                            'required' => '1'
                                        ), array('type' => 'lookup',
                                            'fieldname' => 'CASECODE',
                                            'tablename' => 'CLX_BP_CASES'
                                        )
                                    )
                                )
                            )
                        ), array('label' => 'GEN_LBL_ACTIVITIESCODE',
                            'fields' => array(
                                array('name' => 'activitiescode',
                                    'type' => 'lookup',
                                    'default' => '',
                                    'readonly' => false,
                                    'tool' => 'BPAC',
                                    'validations' => array(
                                        array('type' => 'string',
                                            'required' => '1'
                                        ), array('type' => 'lookup',
                                            'fieldname' => 'activitiescode',
                                            'tablename' => 'CLX_BP_ACTIVITIES'
                                        )
                                    )
                                )
                            )
                        ), array('label' => 'GEN_LBL_PERFORMERSCODE',
                            'fields' => array(
                                array('name' => 'performerscode',
                                    'type' => 'lookup',
                                    'default' => '',
                                    'readonly' => false,
                                    'tool' => 'BPPE',
                                    'validations' => array(
                                        array('type' => 'string',
                                            'required' => '1'
                                        ), array('type' => 'lookup',
                                            'fieldname' => 'performerscode',
                                            'tablename' => 'CLX_BP_PERFORMERS'
                                        )
                                    )
                                )
                            )
                        ), array('label' => 'GEN_LBL_STARTDATE', // ETIQUETA
                            'fields' => array(
                                array('name' => 'startdate',
                                    'type' => 'date',
                                    'default' => '1'
                                )
                            )
                        ), array('label' => 'GEN_LBL_ENDDATE', // ETIQUETA
                            'fields' => array(
                                array('name' => 'enddate',
                                    'type' => 'date',
                                    'default' => '1'
                                )
                            )
                        ), array('label' => 'GEN_LBL_STATUS',
                            'fields' => array(
                                array('name' => 'proc_status',
                                    'type' => CLX_CLASS_LIST,
                                    'default' => '1',
                                    'options' => $this->notify_status
                                )
                            )
                        ), array('label' => 'GEN_LBL_RESULT',
                            'fields' => array(
                                array('name' => 'result_status',
                                    'type' => CLX_CLASS_LIST,
                                    'default' => '0',
                                    'options' => $this->truefalse)
                            )
                        )
                    )
                )
            )
        );
        $this->viewform = &$this->editform;
        $this->viewform [CLX_CLASS_TITLE] = 'TOOL_BPCK_TITLE_DISPLAY';
        $this->toolpanelkeys = array(array(
                'name' => 'CASECODE',
                'type' => 'number'
            )
        );
        $this->toolpanel = array('name' => $this->tablename, CLX_CLASS_TITLE => $this->record_name_plural, 'has_create' => true,
            'has_modify' => false,
            'has_duplicate' => false,
            'has_delete' => false,
            'has_reorder' => false,
            'fields' => array(
                array('name' => 'ID',
                    'label' => 'GEN_LBL_ID',
                    'type' => 'number'
                ), array(
                    'name' => 'CASECODE',
                    'label' => 'GEN_LBL_CASECODE',
                    'type' => 'lookup',
                    'tool' => 'BPCS'
                ), array('name' => 'ACTIVITIESCODE',
                    'label' => 'GEN_LBL_ACTIVITIESCODE',
                    'type' => 'lookup',
                    'tool' => 'BPAC'
                ), array('name' => 'PERFORMERSCODE',
                    'label' => 'GEN_LBL_PERFORMERSCODE',
                    'type' => 'lookup',
                    'tool' => 'BPPE'
                ), array('name' => 'STARTDATE',
                    'label' => 'GEN_LBL_STARTDATE',
                    'type' => 'date'
                ), array('name' => 'ENDDATE',
                    'label' => 'GEN_LBL_ENDDATE',
                    'type' => 'date'
                ), array('name' => 'PROC_STATUS',
                    'type' => CLX_CLASS_LIST,
                    'label' => 'GEN_LBL_PROC_STATUS',
                    'options' => $this->notify_status,
                    'default' => 'IDLE'
                ), array('name' => 'RESULT_STATUS',
                    'type' => CLX_CLASS_LIST,
                    'label' => 'GEN_LBL_RESULT',
                    'options' => $this->truefalse, 'default' => '0'
                )
            )
        );
        $this->toollist = $this->toolpanel;
        $this->toollist ['has_delete'] = false;
        $this->toollist ['has_create'] = false;
        //$this->toollist ['selectclause'] = 'BPCK.*, BPAC.USER_INSTRUCTIONS, IF(BPCK.PROC_STATUS=' . singleQuote('WAIT') . ', 0,1) SR';
        $this->toollist ['selectclause'] = 'BPCK.*, BPAC.USER_INSTRUCTIONS, CASE WHEN BPCK.PROC_STATUS=' . singleQuote('WAIT') . ' THEN 0 ELSE 1 END AS SR';
        $this->toollist ['tablename'] = 'CLX_BP_CASE_TASKS BPCK, CLX_BP_ACTIVITIES BPAC';
        $this->toollist ['whereclause'] = 'BPCK.ACTIVITIESCODE = BPAC.ACTIVITIESCODE';
        $this->toollist ['sortclause'] = 'SR ASC, BPCK.STARTDATE ASC';
        $this->toollist ['fields'] [CLX_NUM_THREE] = array('name' => 'USER_INSTRUCTIONS',
            'label' => 'GEN_LBL_USER_INSTRUCTIONS',
            'type' => 'string'
        );
        $this->toollist ['buttons'] = array(array('access' => 'canread',
                'tool' => 'has_display',
                'library' => 'GEN_LBL_EXECUTE',
                'name' => 'EXECUTE_TASK',
                'prop' => 'ONE'
            ), array('access' => 'canread',
                'tool' => 'has_display',
                'library' => 'GEN_LBL_AUTHORIZE',
                'name' => 'TASK_AUTHORIZE',
                'prop' => 'ONE'
            ), array('access' => 'canread',
                'tool' => 'has_display',
                'library' => 'GEN_LBL_REJECT',
                'name' => 'TASK_REJECT',
                'prop' => 'ONE'
            )
        );
    }

// End method
    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::toolTableStructure()
     */
    function toolTableStructure() {
        $fields = array();
        $fields ['ID'] = array('type' => 'int(11) unsigned',
            'null' => 'NO',
            'properties' => 'auto_increment',
            'index' => 'PRI'
        );
        $fields ['CASECODE'] = array('type' => 'varchar(16)',
            'null' => 'NO',
            'properties' => ''
        );
        $fields ['ACTIVITIESCODE'] = array('type' => 'varchar(16)',
            'null' => 'NO',
            'properties' => ''
        );
        $fields ['PERFORMERSCODE'] = array('type' => 'varchar(16)',
            'null' => 'YES',
            'properties' => ''
        );
        $fields ['STARTDATE'] = array('type' => 'datetime',
            'null' => 'YES',
            'properties' => ''
        );
        $fields ['ENDDATE'] = array('type' => 'datetime',
            'null' => 'YES',
            'properties' => ''
        );
        $fields ['PROC_STATUS'] = array('type' => 'varchar(10)',
            'null' => 'NO',
            'default' => '' . singleQuote('IDLE') . '',
            'default_raw' => 'IDLE'
        );
        $fields ['RESULT_STATUS'] = array('type' => 'int(1) unsigned',
            'null' => 'NO',
            'default' => '0',
            'default_raw' => '0'
        );
        $fields ['TABLECODE'] = array('type' => 'varchar(4)',
            'null' => 'YES',
            'properties' => ''
        );
        $fields ['RESULT_REC_ID'] = array('type' => 'varchar(100)',
            'null' => 'YES'
        );
        $fields ['TASK_PARAMETERS'] = array('type' => 'blob',
            'null' => 'YES',
            'properties' => ''
        );
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes [$ipf . '01'] = array('index' => 'PRI',
            'fieldname' => 'ID'
        );
        $indexes [$ipf . '02'] = array('index' => 'MUL',
            'fieldname' => 'PROC_STATUS'
        );
        $indexes [$ipf . '03'] = array('index' => 'MUL',
            'fieldname' => 'CASECODE'
        );
        $indexes [$ipf . '04'] = array('index' => 'MUL',
            'fieldname' => 'ACTIVITIESCODE'
        );
        $indexes [$ipf . '05'] = array('index' => 'MUL',
            'fieldname' => 'PERFORMERSCODE'
        );
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
            'fields' => $fields,
            'indexes' => $indexes
        );
    }

// end method
    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::action()
     */
    function action($ac, $idlist) {
        //if ($this->access ['canread'] === true) {
        if ($this->getAccess()->canRead()) {
            switch ($ac) {
                case 'TASK_AUTHORIZE' :
                    pushHistory($this->code, 'LIST', $idlist);
                    $this->complete_manual_task(toString($idlist), true);
                    // Run user task
                    $info = popHistory();
                    $contents = executeHistory($info);
                    break;
                case 'TASK_REJECT' :
                    pushHistory($this->code, 'LIST', $idlist);
                    $this->complete_manual_task(toString($idlist), false);
                    // Run user task
                    $info = popHistory();
                    $contents = executeHistory($info);
                    break;
                case 'EXECUTE_TASK' :
                    pushHistory($this->code, 'LIST', $idlist);
                    $this->execute_manual_task(toString($idlist));
                    // Run user task
                    $info = popHistory();
                    $contents = executeHistory($info);
                    break;
                default :
                    $contents = parent::action($ac, $idlist);
                    break;
            }
        } else {
            //$contents = warning ( dict ( 'GEN_ERR_NO_ACCESS' ) );
            $contents = warning(dict('GEN_ERR_NO_ACCESS') . '[BP_CASE_TASKS-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

// end method
    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::defaultRecord()
     */
    function defaultRecord() {
        $callingpage = peekHistory();
        $record = parent::defaultRecord();
        $record [$this->code . '_casecode'] = $callingpage ['casecode'];
        return $record;
    }

// end method
    // case task execution
    /**
     * Test if case has pending tasks
     *
     * @param unknown_type $case_code
     * @return boolean
     */
    public function case_has_pending_tasks($case_code) {
        // Counts task to see if there is any pending to run
        $sql = 'SELECT COUNT(ID) FROM ' . $this->tablename . ' WHERE CASECODE = ' . singleQuote($case_code) . ' AND PROC_STATUS IN (' . singleQuote('WAI') . ',' . singleQuote('RUN') . ',' . singleQuote('IDLE') . ')';
        return (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) ? false : true;
    }

    /**
     * Creates next Task
     *
     * @param string $case_code
     * @param boolean $start
     */
    public function build_case_task($case_code, $from_activity = CLX_NUM_ZERO, $parameters = array()) {
        $parameters = '';
        if ($from_activity == CLX_NUM_ZERO) {
            $sql = 'SELECT ' . singleQuote($case_code) . ' CASECODE, BPAC.ACTIVITIESCODE, BPPE.PERFORMERSCODE, NOW() STARTDATE, ' . singleQuote('RUN') . ' PROC_STATUS FROM CLX_BP_CASES BPCA, CLX_BP_LANES BPLA, CLX_BP_ACTIVITIES BPAC LEFT JOIN CLX_BP_PERFORMERS BPPE ON BPPE.ACTIVITIESCODE = BPAC.ACTIVITIESCODE WHERE BPCA.CASECODE = ' . singleQuote($case_code) . ' AND BPLA.LANECODE = BPAC.LANECODE AND BPLA.PROCESSCODE = BPCA.PROCESSCODE AND BPLA.STATUS = 1 AND BPAC.STATUS = 1 AND BPAC.ACTIVITY_TYPE = ' . singleQuote('START');
        } else {
            // Search next activity from transition
            $sql = 'SELECT BPCK.CASECODE, BPAC.ACTIVITIESCODE, BPPE.PERFORMERSCODE, NOW() STARTDATE, ' . singleQuote('RUN') . ' PROC_STATUS FROM CLX_BP_TRANSITIONS BPTR, CLX_BP_CASE_TASKS BPCK, CLX_BP_CASES BPCA, CLX_BP_LANES BPLA, CLX_BP_ACTIVITIES BPAC LEFT JOIN CLX_BP_PERFORMERS BPPE ON BPPE.ACTIVITIESCODE = BPAC.ACTIVITIESCODE WHERE BPCK.ID = ' . $from_activity . '  AND BPCA.CASECODE = ' . singleQuote($case_code) . ' AND BPTR.FROMACTIVITY = BPCK.ACTIVITIESCODE AND BPTR.TOACTIVITY = BPAC.ACTIVITIESCODE AND BPTR.CONDITION = BPCK.RESULT_STATUS AND BPTR.PROCESSCODE = BPCA.PROCESSCODE AND BPLA.PROCESSCODE = BPCA.PROCESSCODE AND BPLA.PROCESSCODE = BPCA.PROCESSCODE AND BPLA.LANECODE = BPAC.LANECODE AND BPLA.STATUS = 1 AND BPAC.STATUS = 1 ';
        }
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            ClxCommon::$db->createRecord($this->tablename, $r, false);
        }
    }

// end method
    /**
     * Return true if task is defined for case
     *
     * @param string $case_code
     * @param string $task_status
     * @return boolean
     */
    public function case_task_exists($case_code, $task_status = '', $activity_type = '') {
        $sql = 'SELECT COUNT(BPCK.ID) QTY FROM ' . $this->tablename . ' BPCK WHERE BPCK.CASECODE = ' . singleQuote($case_code) . ' ';
        if ($task_status !== '') {
            $sql .= ' AND BPCK.PROC_STATUS = ' . singleQuote($task_status) . ' ';
        }
        if ($activity_type !== '') {
            $sql .= ' AND EXISTS(SELECT FROM CLX_BP_ACTIVITIES BPAC WHERE BPAC.ACTIVITIESCODE = BPCK.ACTIVITIESCODE AND BPAC.ACTIVITY_TYPE = ' . singleQuote($activity_type) . ') ';
        }
        return (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) ? false : true;
    }

    /**
     * Chances case status
     *
     * @param string $case_code
     * @param string $from_status
     * @param string $to_status
     */
    public function set_case_task_status($case_code, $from_status, $to_status, $task_id = CLX_NUM_ZERO) {
        echo 'Set case ', $case_code, ' task status from ', $from_status, ' to ', $to_status, CLX_CHAR_NL;
        $sql = 'UPDATE ' . $this->tablename . ' SET PROC_STATUS = ' . singleQuote($to_status) . ' WHERE CASECODE = ' . singleQuote($case_code) . ' AND PROC_STATUS = ' . singleQuote($from_status);
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     * Sets task status
     *
     * @param integer $task_id
     * @param string $status
     */
    private function set_task_status($task_id, $status) {
        if (empty($task_id))
            return;
        $sql = 'UPDATE ' . $this->tablename . '  SET PROC_STATUS = ' . singleQuote($status) . (($status === 'END') ? ', ENDDATE = NOW()' : '') . ' WHERE ID = ' . $task_id;
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     * Set task result status
     *
     * @param string $task_id
     * @param bool $status
     */
    private function set_task_result_status($task_id, $status, $tablecode = null, $result_rec_id = CLX_NUM_ZERO) {
        if (empty($task_id))
            return;
        $rec = array('RESULT_STATUS' => (($status) ? CLX_NUM_ONE : CLX_NUM_ZERO)
        );
        if ($tablecode === true)
            $rec ['TABLECODE'] = $tablecode;
        if ($result_rec_id === true)
            $rec ['RESULT_REC_ID'] = $result_rec_id;
        ClxCommon::$db->updateRecord($this->tablename, $rec, 'ID = ' . $task_id);
    }

    /**
     * Runs case task
     *
     * @param array $task_rec
     */
    private function execute_case_task(&$task_rec) {
        // Activity: ' . $task_rec ['ACTIVITIESCODE']. CLX_CHAR_NL;
        if (empty($task_rec ['ID'])) {
            return;
        }
        // This may be moved to task execution
        if ($this->case_task_wait($task_rec ['ACTIVITIESCODE'])) {
            // Instructions for user action must be set here
            echo 'Set wait for user ', $task_rec ['ACTIVITIESCODE'], CLX_CHAR_NL;
            // Set wait flag
            $this->set_task_status($task_rec ['ID'], 'WAIT');
        } else {
            // Executing Task
            $this->execute_task($task_rec);
            // Set next task from transitions
            $this->build_case_task($task_rec ['CASECODE'], $task_rec ['ID']);
            // Mark as end
            $this->set_task_status($task_rec ['ID'], 'END');
        }
    }

    /**
     * Task id
     *
     * @param integer $activity_code
     * @return boolean
     */
    private function case_task_wait($activity_code) {
        $BPAC = &getTool('BPAC');
        return $BPAC->activity_has_wait($activity_code);
    }

    /**
     * Executes Task
     *
     * @param array $task_rec
     * @param boolean $manual_task
     */
    private function execute_task(&$task_rec, $manual_task = false) {
        $status = false;
        $msg = array();
        $record = array();
        //Restore Parameters
        $this->get_task_parameters($task_rec, $record);
        $BPAC = &getTool('BPAC');
        if ($manual_task === true) {
            $status = $BPAC->execute_manual_activity($task_rec ['ACTIVITIESCODE'], $record, $msg);
            echo 'Execute manual task ', $task_rec ['ACTIVITIESCODE'], ' ', (($status) ? 'si' : 'no'), CLX_CHAR_NL;
        } else {
            $status = $BPAC->execute_activity($task_rec ['ACTIVITIESCODE'], $record, $msg);
            echo 'Execute flow task ', $task_rec ['ACTIVITIESCODE'], ' ', (($status) ? 'si' : 'no'), CLX_CHAR_NL;
        }
        //Save parameters back to task
        // Setting result to 1 or 0 for false
        $this->set_task_result_status($task_rec ['ID'], $status, null, CLX_NUM_ZERO);
    }

    /**
     * Get Test parameters
     * @param unknown_type $task_rec
     * @param unknown_type $record
     */
    private function get_task_parameters(&$task_rec, &$record) {
        if (!empty($task_rec['TASK_PARAMETERS'])) {
            $record = unserialize($task_rec['TASK_PARAMETERS']);
        }
    }

    /**
     * Task parameters
     * @param unknown_type $task_id
     * @param unknown_type $record
     */
    public function save_task_parameters($task_id, &$record) {
        if (!empty($record)) {
            ClxCommon::$db->updateRecord($this->tablename, array('TASK_PARAMETERS' => serialize($record)), 'ID = ' . $task_id);
        }
    }

    /**
     * Execute Manual Task
     *
     * @param integer $task_id
     */
    function execute_manual_task($task_id) {
        // Set the task to run
        $task_rec = ClxCommon::$db->getRecord($this->tablename, 'ID = ' . $task_id);
        $_SESSION ['BPCK_task_id'] = $task_id;
        // Run task
        $this->execute_task($task_rec, true);
    }

    /**
     * Completes manual status
     *
     * @param integer $task_id
     * @param boolean $result_status
     */
    public function complete_manual_task($task_id, $result_status, &$record, $tablecode = null, $result_rec_id = CLX_NUM_ZERO) {
        // Completes run task.
        // Task id
        $task_rec = ClxCommon::$db->getFields($this->tablename, 'ID, CASECODE', 'ID = ' . $task_id);
        // Setting result status
        $this->set_task_result_status($task_rec ['ID'], $result_status, $tablecode, $result_rec_id);
        // Set next task from transitions
        $this->build_case_task($task_rec ['CASECODE'], $task_rec ['ID'], $record);
        // Mark as end
        $this->set_task_status($task_rec ['ID'], 'END');
    }

    /**
     * Task status
     *
     * @param string $case_code
     */
    public function execute_case_tasks_by_status($case_code) {
        $sql = 'SELECT * FROM ' . $this->tablename . '  WHERE CASECODE = ' . singleQuote($case_code) . ' AND PROC_STATUS = ' . singleQuote('RUN') . '';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $this->execute_case_task($r);
        }
    }

// end method
    /**
     * Set default Parameters
     *
     * @param int $task_id
     * @param array $record
     */
    public function set_task_default_parameters($task_id, &$record) {
        $sql = 'SELECT BPAP.TABLECODE, BPAP.FIELDNAME, BPAP.FIELDVALUE FROM ' . $this->tablename . ' BCPK, CLX_BP_ACTIVITY_PRMTS BPAP WHERE BCPK.ID = ' . $task_id . '  AND BCPK.ACTIVITIESCODE = BPAP.ACTIVITIESCODE AND BPAP.STATUS = 1';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            if (!empty($r ['TABLECODE'])) {
                $r ['fieldname'] = $r ['TABLECODE'] . '_' . $r ['fieldname'];
            }
            $record [$r ['fieldname']] = $r ['FIELDVALUE'];
        }
    }

}

// End class