<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 *
 * @package		Clientix.Tool.Business Process
 * @abstract		Business Process Manager
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2019-01-22 15:45:22 -0400 (ma., 22 ene. 2019) $
 * @version        $Rev: 10496 $
 *
 * CHANGE LOG
 *  Included label
 */
class bp_cases extends clx_tool {

    /**
     * Constructor
     */
    function __construct() {
        $this->code = 'BPCA';
        $this->name = 'Business Process - Cases';
        $this->system = 'Business Process';
        $this->version = '5.5.0.1';
        $this->has_access = true;
        $this->tablename = 'CLX_BP_CASES';
        $this->record_name_singular = 'GEN_LBL_BUSINESS_CASE';
        $this->record_name_plural = 'GEN_LBL_BUSINESS_CASES';
        $this->primary_key = array('CASECODE');
        $this->primary_field = 'CASECODE';
        $this->secondary_field = 'PROCESSCODE';
        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_BPCA_TITLE_CREATE',
            'panels' => array(
                array('type' => 'normal',
                    'entries' => array(
                        array('label' => 'GEN_LBL_CASECODE',
                            'fields' => array(
                                array('name' => 'casecode',
                                    'type' => 'string',
                                    'default' => '',
                                    'size' => '20',
                                    'displaysize' => '35',
                                    'dontmodify' => '1',
                                    'validations' => array(
                                        array('type' => 'string',
                                            'required' => '1'
                                        ), array('type' => 'unique',
                                            'fieldname' => 'casecode',
                                            'tablename' => $this->tablename)
                                    )
                                )
                            )
                        ), array('label' => 'GEN_LBL_PROCESSCODE',
                            'fields' => array(
                                array('name' => 'processcode',
                                    'type' => 'lookup',
                                    'default' => '',
                                    'readonly' => false,
                                    'tool' => 'BPPR',
                                    'validations' => array(
                                        array('type' => 'string',
                                            'required' => '1'
                                        ), array('type' => 'lookup',
                                            'fieldname' => 'PROCESSCODE',
                                            'tablename' => 'CLX_BP_PROCESSES'
                                        )
                                    )
                                )
                            )
                        ), array('label' => 'GEN_LBL_STARTDATE',
                            'fields' => array(
                                array('name' => 'startdate',
                                    'type' => 'date',
                                    'readonly' => true
                                )
                            )
                        ), array('label' => 'GEN_LBL_ENDDATE',
                            'fields' => array(
                                array('name' => 'enddate',
                                    'type' => 'date',
                                    'readonly' => true
                                )
                            )
                        ), array('label' => 'GEN_LBL_EXPIRE_DATE',
                            'fields' => array(
                                array('name' => 'expire_date',
                                    'type' => 'date',
                                    'readonly' => true
                                )
                            )
                        )
                    )
                ), array('type' => 'normal',
                    CLX_CLASS_TITLE => 'GEN_LBL_ADITIONAL_OPTIONS',
                    'entries' => array(
                        array('label' => 'GEN_LBL_OWNERCODE',
                            'fields' => array(
                                array('name' => 'ownercode',
                                    'type' => 'lookup',
                                    'default' => '',
                                    'readonly' => false,
                                    'tool' => 'ACUS',
                                    'validations' => array(
                                        array('type' => 'lookup',
                                            'fieldname' => 'username',
                                            'tablename' => 'CLX_AC_USERS',
                                            'required' => '1'
                                        )
                                    )
                                )
                            )
                        ), array('label' => 'GEN_LBL_PROC_STATUS',
                            'fields' => array(
                                array('name' => 'proc_status',
                                    'type' => CLX_CLASS_LIST,
                                    'default' => '',
                                    'options' => $this->notify_status
                                )
                            )
                        ), array('label' => 'GEN_LBL_BATCH_PID',
                            'fields' => array(
                                array('name' => 'batch_pid',
                                    'readonly' => true,
                                    'type' => 'string',
                                    'default' => '0',
                                    'size' => '10',
                                    'displaysize' => '35'
                                )
                            )
                        )
                    )
                ), array('type' => 'normal',
                    CLX_CLASS_TITLE => 'GEN_LBL_RECORD_OPTIONS',
                    'cols' => CLX_NUM_FOUR,
                    'entries' => array(
                        array('label' => 'GEN_LBL_CDATE',
                            'fields' => array(
                                array('name' => 'cdate',
                                    'type' => 'dati',
                                    'dontmodify' => '1',
                                    'displaysize' => '35',
                                    'readonly' => true,
                                    'validations' => array(
                                        array('type' => 'string'
                                        )
                                    )
                                )
                            )
                        ), array('label' => 'GEN_LBL_CREATEDBY',
                            'fields' => array(
                                array('name' => 'createdby',
                                    'type' => 'lookup',
                                    'default' => '',
                                    'readonly' => true,
                                    'tool' => 'ACUS',
                                    'validations' => array(
                                        array('type' => 'lookup',
                                            'fieldname' => 'username',
                                            'tablename' => 'CLX_AC_USERS'
                                        )
                                    )
                                )
                            )
                        ), array('label' => 'GEN_LBL_MDATE',
                            'fields' => array(
                                array('name' => 'mdate',
                                    'type' => 'dati',
                                    'displaysize' => '35',
                                    'dontmodify' => '1',
                                    'readonly' => true,
                                    'validations' => array(
                                        array('type' => 'string'
                                        )
                                    )
                                )
                            )
                        ), array('label' => 'GEN_LBL_MODIFIEDBY',
                            'fields' => array(
                                array('name' => 'modifiedby',
                                    'type' => 'lookup',
                                    'default' => '',
                                    'readonly' => true,
                                    'tool' => 'ACUS',
                                    'validations' => array(
                                        array('type' => 'lookup',
                                            'fieldname' => 'username',
                                            'tablename' => 'CLX_AC_USERS'
                                        )
                                    )
                                )
                            )
                        )
                    )
                )
            )
        );
        $this->viewform = &$this->editform;
        $this->toollist = array('name' => $this->tablename, CLX_CLASS_TITLE => $this->record_name_plural, 'has_filter' => true,
            'has_display' => true,
            'has_create' => false,
            'has_modify' => false,
            'has_duplicate' => false,
            'has_delete' => true,
            'fields' => array(
                array('name' => 'ID',
                    'type' => 'number',
                    'label' => 'GEN_LBL_ID'
                ), array('name' => 'CASECODE',
                    'type' => 'string',
                    'label' => 'GEN_LBL_CASECODE'
                ), array('name' => 'PROCESSCODE',
                    'type' => 'lookup',
                    'label' => 'GEN_LBL_PROCESSCODE',
                    'tool' => 'BPPR'
                ), array('name' => 'OWNERCODE',
                    'type' => 'lookup',
                    'label' => 'GEN_LBL_OWNERCODE',
                    'tool' => 'ACUS'
                ), array('name' => 'STARTDATE',
                    'type' => 'dati',
                    'label' => 'GEN_LBL_STARTDATE'
                ), array('name' => 'ENDDATE',
                    'type' => 'dati',
                    'label' => 'GEN_LBL_ENDDATE'
                ), array('name' => 'EXPIRE_DATE',
                    'type' => 'dati',
                    'label' => 'GEN_LBL_EXPIRE_DATE'
                ), array('name' => 'PROC_STATUS',
                    'type' => CLX_CLASS_LIST,
                    'label' => 'GEN_LBL_PROC_STATUS',
                    'options' => $this->notify_status
                ), array('name' => 'BATCH_PID',
                    'type' => 'string',
                    'label' => 'GEN_LBL_BATCH_PID'
                )
            ), 'buttons' => array(
                array('access' => 'canread',
                    'tool' => 'has_display',
                    'library' => 'GEN_LBL_RUN_PROCESS',
                    'name' => 'RUN_BRPR',
                    'prop' => 'ON'
                )
            )
        );
        $this->quickfilterform = array(
            'panels' => array(
                array('type' => 'normal',
                    'entries' => array(
                        array('label' => 'GEN_LBL_CASECODE',
                            'fields' => array(
                                array('name' => 'casecode',
                                    'type' => 'lookup',
                                    'default' => '',
                                    'tool' => 'BPCA'
                                )
                            )
                        ), array('label' => 'GEN_LBL_PROCESSCODE',
                            'fields' => array(
                                array('name' => 'processcode',
                                    'type' => 'lookup',
                                    'default' => '',
                                    'readonly' => false,
                                    'tool' => 'BPPR'
                                )
                            )
                        ), array('label' => 'GEN_LBL_OWNERCODE',
                            'fields' => array(
                                array('name' => 'ownercode',
                                    'type' => 'lookup',
                                    'default' => '',
                                    'readonly' => false,
                                    'tool' => 'ACUS'
                                )
                            )
                        )
                    )
                )
            )
        );
        if (empty($_SESSION)) {
            $_SESSION ['user_record'] ['username'] = 'system';
        }
        $this->executedby = $_SESSION ['user_record'] ['username'];
    }

    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::install()
     */
    function install() {
        $UIMI = getTool('UIMI');
        $UIMI->add($this->code, 'MENU_TOOLS:MENU_BUSINESS_PROCESS:MENU_' . $this->code, 'TOOL', $this->code, 'ac=LIST'); // ETIQUETA
    }

    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::toolTableStructure()
     */
    function toolTableStructure() {
        $fields = array();
        $fields ['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields ['CASECODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields ['STARTDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields ['ENDDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields ['EXPIRE_DATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields ['PROCESSCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields ['OWNERCODE'] = array('type' => 'varchar(30)', 'null' => 'NO');
        $fields ['PROC_STATUS'] = array('type' => 'varchar(10)', 'null' => 'NO', 'default' => singleQuote('IDLE'), 'default_raw' => 'IDLE');
        $fields ['BATCH_PID'] = array('type' => 'varchar(20)', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields ['CDATE'] = array('type' => 'datetime', 'null' => 'YES');
        $fields ['MDATE'] = array('type' => 'datetime', 'null' => 'YES');
        $fields ['CREATEDBY'] = array('type' => 'varchar(30)', 'null' => 'NO');
        $fields ['MODIFIEDBY'] = array('type' => 'varchar(30)', 'null' => 'NO');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes [$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes [$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'CASECODE');
        $indexes [$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'PROCESSCODE');
        $indexes [$ipf . '04'] = array('index' => 'MUL', 'fieldname' => 'OWNERCODE');
        $indexes [$ipf . '05'] = array('index' => 'MUL', 'fieldname' => 'PROC_STATUS');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB', 'fields' => $fields, 'indexes' => $indexes);
    }

    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::action()
     */
    function action($ac, $idlist) {
        $msg = array();
        if ($this->getAccess()->canRead()) {
            switch ($ac) {
                case 'RUN_BRPR' :
                    if ($this->checkSelectProcess($msg)) {
                        // Run process method
                        $this->runSelectedProcess();
                        $info = popHistory();
                        $contents = executeHistory($info);
                    } else {
                        $contents = $this->selectProcess($msg);
                    }
                    break;
                case 'ULIST' :
                    $contents = parent::action('LIST', $idlist);
                    break;
                default :
                    $contents = parent::action($ac, $idlist);
                    break;
            }
        } else {
            $contents = warning(dict('GEN_ERR_NO_ACCESS') . '[BP_CASES-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::viewFormFill()
     */
    function viewFormFill($record) {
        addHistory('casecode', $record ['BPCA_casecode']);
        /*
         * $BPCS = &getTool ( 'BPCS' ); no more activities $contents =
         * $BPCS->makepanel ( $record ['BPCA_casecode'] );
         */
        $BPCK = &getTool('BPCK');
        return $BPCK->makepanel($record ['BPCA_casecode']);
    }

    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::filterFormFill()
     */
    function filterFormFill($msg, &$table) {
        if (!array_key_exists($this->code . '_processcode', UserRequest::$post))
            UserRequest::$post [$this->code . '_processcode'] = '';
        if (!array_key_exists($this->code . '_ownercode', UserRequest::$post))
            UserRequest::$post [$this->code . '_ownercode'] = '';
        if (!array_key_exists($this->code . '_modulecode', UserRequest::$post))
            UserRequest::$post [$this->code . '_modulecode'] = '';
        $table->addField($msg, dict('GEN_LBL_CODE') . ':', $this->code . '_processcode', UserRequest::$post [$this->code . '_processcode'], CLX_NUM_FOUR, CLX_NUM_FOUR);
        $table->addField($msg, dict('GEN_LBL_OWNERCODE') . ':', $this->code . '_ownercode', UserRequest::$post [$this->code . '_ownercode'], CLX_NUM_32, CLX_NUM_64);
        $table->addField($msg, dict('GEN_LBL_MODULECODE') . ':', $this->code . '_modulecode', UserRequest::$post [$this->code . '_modulecode'], CLX_NUM_FOUR, CLX_NUM_FOUR);
        $sort = new HtmlSelect($this->code . '_sort');
        $sort->addItem('', '', true);
        $sort->addItem(dict('GEN_LBL_CODE'), 'processcode', false);
        $sort->addItem(dict('GEN_LBL_OWNERCODE'), 'ownercode', false);
        $table->addData(dict('GEN_LBL_ORDERBY') . ':', $sort->source());
    }

    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::setfilter()
     */
    function setfilter() {
        $filter = '';
        $boolean = '';
        if (!empty(UserRequest::$post [$this->code . '_processcode'])) {
            $filter .= $boolean . ' PROCESSCODE LIKE ' . singleQuote(UserRequest::$post [$this->code . '_processcode'] . '%');
            $boolean = 'AND';
        }
        if (!empty(UserRequest::$post [$this->code . '_ownercode'])) {
            $filter .= $boolean . ' OWNERCODE LIKE ' . singleQuote(UserRequest::$post [$this->code . '_ownercode'] . '%');
            $boolean = 'AND';
        }
        if (!empty(UserRequest::$post [$this->code . '_modulecode'])) {
            $filter .= $boolean . ' EXISTS (SELECT BPPR.ID FROM CLX_BP_PROCESSES BPPR WHERE BPPR.PROCESSCODE = BPCA.PROCESSCODE AND BPPR.MODULECODE LIKE ' . singleQuote(UserRequest::$post [$this->code . '_modulecode'] . '%)');
            $boolean = 'AND';
        }
        $_SESSION ['paging'] [$this->code . 'List'] ['sortby'] = UserRequest::$post [$this->code . '_sort'];
        $_SESSION ['paging'] [$this->code . 'List'] ['criteria'] = $filter;
        $_SESSION ['paging'] [$this->code . 'List'] ['startat'] = '0';
    }

    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::clearfilter()
     */
	///////////////////////////////////////////////////
	///comentado 22/01/2019 para utilizar la clx_tool
	////////////////////////////////////////////////// 
   /* function clearfilter() {
        $_SESSION ['paging'] [$this->code . 'List'] ['criteria'] = '';
    }*/

    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::deleteRecord()
     */
    function deleteRecordSk($id) {
        $keycode = ClxCommon::$db->getField($this->tablename, $this->primary_field, 'ID=' . $id);
        $TOOL = &getTool('BPCK');
        $rs = ClxCommon::$db->getRecords($TOOL->tablename, $this->primary_field . '=' . singleQuote($keycode));
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $TOOL->deleteRecordSk($r ['ID']);
        }
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
    }

    // Start process by selecting it and run
    /**
     * Select process
     *
     * @return string
     */
    private function selectProcess(&$msg) {
        $BPPR = &getTool('BPPR');
        $data = $BPPR->toollist;
        $data ['buttons'] = array(array('access' => 'canread',
                'tool' => '',
                'library' => 'GEN_LBL_EXECUTE',
                'name' => UserRequest::$request['ac'],
                'prop' => 'MULT'
            )
        );
        $listing = new clx_listing('BPPR', $data);
        $listing->to = $this->code; // switch code in post
        $listing->has_return_button = true;
        $listing->has_display = false;
        $listing->has_create = false;
        $listing->has_modify = false;
        $listing->has_delete = false;
        $listing->has_duplicate = false;
        $listing->has_export = false;
        $listing->has_filter = false;
        $listing->has_reorder = false;
        return $listing->makeList(true);
    }

    /**
     * Verify Report Questions
     *
     * @param
     *        	array &$msg
     * @return bool
     */
    private function checkSelectProcess(&$msg) {
        $idlist = getIdlist();
        if (count($idlist) == CLX_NUM_ZERO) {
            return false;
        }
        $qty = ClxCommon::$db->oneExistsRecords('CLX_BP_PROCESSES', 'ID IN (' . toString($idlist) . ') AND STATUS = 1');
        if ($qty == CLX_NUM_ZERO) {
            addMessage(dict('GEN_LBL_INVALID_PROCESS'));
            return false;
        }
        return true;
    }

    /**
     * Runs selected process
     */
    private function runSelectedProcess() {
        $now = getNow('Y-m-d h:i:s');
        $username = $_SESSION ['user_record'] ['username'];
        $idlist = getIdlist();
        $sql = 'SELECT BPPR.PROCESSCODE, BPPR.EXPIRES_ON, BPPR.EXPIRES_ON_UOM FROM CLX_BP_PROCESSES BPPR WHERE BPPR.ID IN (' . toString($idlist) . ') AND BPPR.STATUS = 1';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $expiration = 'null';
            // Calculate Expiration date for process if applies
            if ($r ['EXPIRES_ON'] != CLX_NUM_ZERO) {
                $expiration = date('Y-m-d H:i:s', strtotime('+' . ($r ['EXPIRES_ON'] * $r ['EXPIRES_ON_UOM']) . ' minutes'));
            }
            // Create Case
            $case_rec = array(
                'CASECODE' => uniqid(),
                'STARTDATE' => $now,
                'ENDDATE' => 'null',
                'EXPIRE_DATE' => $expiration,
                'PROCESSCODE' => $r ['PROCESSCODE'],
                'OWNERCODE' => $username,
                'PROC_STATUS' => 'IDLE',
                'BATCH_PID' => getPid(),
                'CDATE' => $now,
                'MDATE' => $now,
                'CREATEDBY' => $username,
                'MODIFIEDBY' => $username
            );
            ClxCommon::$db->createRecord($this->tablename, $case_rec, false);
            // Set start task in run status
            $BPCK = &getTool('BPCK');
            $BPCK->build_case_task($case_rec ['CASECODE']);
            $this->set_case_status($case_rec ['CASECODE'], 'RUN');
        }
    }

    // Case Execution
    private function check_case_end($case_code) {
        $this->set_case_status($case_code, 'END');
    }

    /**
     * Sets case status
     *
     * @param string $case_code
     * @param string $status
     */
    private function set_case_status($case_code, $status) {
        //See also this->expire_cases()
        $sql = 'UPDATE ' . $this->tablename . '  SET PROC_STATUS = ' . singleQuote($status) . ' ' . (($status === 'END') ? ', ENDDATE = NOW() ' : '') . ' 				WHERE CASECODE = ' . singleQuote($case_code);
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     * Expire pending cases
     */
    private function expire_cases() {
        $sql = 'UPDATE ' . $this->tablename . '  SET PROC_STATUS = ' . singleQuote('EXP') . ', ENDDATE = NOW() WHERE PROC_STATUS = ' . singleQuote('RUN') . ' AND EXPIRE_DATE <= NOW()';
        ClxCommon::$db->executeQuery($sql);
    }

    private function check_case_task(&$case_rec) {
        $BPCK = &getTool('BPCK');
        if ($BPCK->case_task_exists($case_rec ['CASECODE'], 'RUN')) {
            $BPCK->execute_case_tasks_by_status($case_rec ['CASECODE']);
            //Test if case should end
            if (!$BPCK->case_has_pending_tasks($case_rec ['CASECODE'])) {
                $this->check_case_end($case_rec ['CASECODE']);
            }
        } else {
            // do nothing
        }
    }

    /**
     * Check case.
     * Method called by batch engine
     * return void
     */
    public function check_case() {
        // loop and build treads. each line should run a code
        // Set expired cases
        $this->expire_cases();
        $sql = 'SELECT * FROM ' . $this->tablename . ' WHERE PROC_STATUS = ' . singleQuote('RUN') . '';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $this->check_case_task($r);
        }
    }

}
