<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 * @package		Clientix.Tool.Rule
 * @abstract		System rules Manager
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-02-07 16:57:26 -0400 (mi., 07 feb. 2018) $
 * @version        $Rev: 9714 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
class db_import_exceptions_rules extends clx_tool {

    /**
     * List of rules allowed
     * @var array
     */
    var $rules = array();
    var $cache_rules = true;

    /**
     * Constructor
     */
    function __construct() {
        $this->code = 'DBIR';
        $this->name = 'Import Exeptions Rules';
        $this->system = 'Database';
        $this->version = '7.0.0.0';

        $this->has_access = true;
		$this->accesskey = 'DBIM';
        $this->tablename = 'CLX_DB_IMPORT_RULES';
        $this->record_name_singular = 'rule';
        $this->record_name_plural = 'GEN_LBL_rules';
        $this->primary_field = 'ID';
		
        $this->primary_key = array('ID');
        $this->rule = array('LINI' => 'GEN_LBL_INIT_LISTING', 'LQSR' => 'GEN_LBL_QUICK_SEARCH');
        $this->rules = array();
        // Record rules
       	
		$this->rules['WREC'] = array('name' => 'GEN_LBL_WHITE_SPACE_OR_MIN');
		$this->rules['TREC'] = array('name' => 'GEN_LBL_SHOW_TEXT');
		$this->rules['NREC'] = array('name' => 'GEN_LBL_NUMBER_LINE');

		$this->rulesAction = array();
        // Record rules
        $this->rulesAction['IACT'] = array('name' => 'GEN_LBL_ALL_EXCLUSION');
        $this->rulesAction['FACT'] = array('name' => 'GEN_LBL_EXCLUSIONS_FIRST_PAGE');
		$this->rulesAction['SACT'] = array('name' => 'GEN_LBL_EXCLUSIONS_SECONDS_PAGE');
		
        $this->rules_list = array();
    }

    /**
     * Describes the tool table structure.
     * @return array ('type' => 'varchar(255)', 'properties'=>'auto increment',
     * 				'index'=>'', default = '', 'dict'=>true)
     * 				 dict true or false means that field holds dictionary entry
     */
    function toolTableStructure() {if ( isset($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1635;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_exceotions_rule-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['RULE'] = array('type' => 'varchar(15)', 'null' => 'NO', 'properties' => '');
		$fields['RULE_TEXT'] = array('type' => 'varchar(30)', 'null' => 'NO', 'properties' => '');
        $fields['ACTION'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['STATUS'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['IMPORTCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
		$indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'MUL', 'fieldname' => 'ACTION');
		$indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'STATUS');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB', 'fields' => $fields, 'indexes' => $indexes);
    }

    /**
     * Loads package into system
     * @param string $package
     */
    function unpack($parameters) {if ( isset($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1636;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_exceotions_rule-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        $parameters = array_values(array_merge(array('package' => null, 'id' => ''), $parameters));
        list($package, $ownerid) = $parameters;
        $record = $this->unpackRecord($package);
        foreach ($record as $key => $val) {
            $record[$key] = stripslashes($val);
        }
        $record['OWNERID'] = (string) $ownerid;
        ClxCommon::$db->createRecordVoid($this->tablename, $record, false);
    }

    /**
     * Action is called for every user interaction with the module...
     *
     * @param unknown_type $ac
     * @param unknown_type $idlist
     * @return unknown
     */
    function action($ac, $idlist) {if ( isset($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1637;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_exceotions_rule-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        
		$contents = '';
        if ($this->getAccess()->canRead()) {
            switch ($ac) {
                default:
                    $contents = parent::action($ac, $idlist);
                    break;
            }
        } else {
            $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [rules-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    /**
     * Builds Panel listing on tool
     *
     * @param string $groupcode
     * @return string
     */
    function makepanel($importcode=null) {if ( isset($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1638;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_exceotions_rule-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        //Compatibilidad con clx_tools
        if ($this->getAccess()->canRead()) {
            $t = time();
            $to = $this->code;
            $here = 'tool.php?to=' . $to . '&t=' . $t;
            $modulecode = '';
            $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
            $form->setProp(CLX_PROP_ID, 'RULE_EXCEPTIONS');
            $form->addArgument(CLX_PROP_TO, $this->code);
			$form->addArgument('importcode', $importcode);
            $form->addArgument('ac', 'NOT_DEFINED');
            $selectclause = '*';
            $fromclause = $this->tablename;
            $whereclause = 'IMPORTCODE='.singleQuote($importcode);
            $sortclause = 'ID';
            $page = new xPaging();
            $page->setProp('rpp', CLX_NUM_TEN_THOUSAND);
            $page->setProp('printheaders', false);
            $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
            $table = new htmlTable(CLX_WIDTH_FIVE);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $page->header($table);
            $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_RULE'), dict('GEN_LBL_STATUS'), dict('GEN_LBL_ACTION') ,dict('GEN_LBL_RULE_TEXT')       )     );
            $i = CLX_INIT_ZERO;
            $status = array(dict('GEN_LBL_INACTIVE'), dict('GEN_LBL_ACTIVE'));
            while ($record = $page->nextRecord()) {
                $recordid = $record['ID'];
                $select = new htmlCheckbox('selector_' . $recordid, false);
                $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
                $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
				$table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array(dict($this->rules[$record['RULE']]['name'])." (".$record['RULE'].")", $status[$record['STATUS']],dict($this->rulesAction[$record['ACTION']]['name'])." (".$record['ACTION'].")",'<pre>'.$record['RULE_TEXT'].'</pre>'));
                $i++;
            }
            $buttons = '';
            $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_DISPLAY'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            if ($this->getAccess()->canModify()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            }
            if ($this->getAccess()->canDelete()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            }
            if ($this->getAccess()->canDisplay()) {
                $b = new htmlFormSubmit(dict('GEN_LBL_CREATE_SOMETHING', dict('GEN_LBL_RULE')), 'CREATE', $form->getProp(CLX_PROP_ID));
                $b->setProp(CLX_PROP_ID, 'ON');
                $buttons .= $b->source();
            }
            if (($page->getProp('qty') > CLX_NUM_ONE) && $this->getAccess()->canModify()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_REORDER'), array('action' => 'REORDER', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
            }
            $form->addContents($page->footers($table, $buttons));
            return buildPanelInterface(dict('TOOL_RULE_TITLE_LIST'), $modulecode . '_RULES', $form->source(), CLX_NUM_MINUS_1);
        } else {
            return CLX_CHAR_EMPTY_STRING;
        }
    }

    /**
     * Tool Edit Form
     * @param string $ac
     * @param string $idlist
     * @param array $record
     * @param array $msg
     * @return string
     */
    function editForm($ac, $idlist, $record, $msg) {if ( isset($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1639;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_exceotions_rule-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        // Build/get the different java scripts...
		if (!empty($record['DBIR_id'])) {
			$infoRule=ClxCommon::$db->getRecord($this->tablename,' ID='.$record['DBIR_id']);
		}
		else{
			$infoRule=array('ACTION'=>0,'STATUS'=>1,'RULE_TEXT'=>'');
		}
        $OBJS = &getTool('OBJS');
        $variables = array('CONTENTS' => '');
        $script = setJavaScriptTag(getJavaScript('DBIR_editform.js', $variables), false);
        unset($variables['CONTENTS']);
        $variables['VISIBLEPANEL'] = 'DBIR_action';
        //Build the form
        $modify = (UserRequest::$request['ac'] === 'MODIFY') ? true : false;
        $title = ($modify) ? dict('TOOL_RULE_TITLE_MODIFY') : dict('TOOL_RULE_TITLE_CREATE');
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->addArgument(CLX_PROP_TO, $this->code);
		
		$form->addArgument('DBIR_id', $record['DBIR_id']);
        $form->addArgument('ac', $ac);
        $form->addArgument('confirm', CLX_NUM_ONE);
		
        $form->addArgument('DBIR_importcode', UserRequest::$request['importcode']);
		
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
		$table->addCell($title, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $rule = new htmlSelect('DBIR_rule');
        foreach ($this->rules as $code => $info) {
            $rule->addItem(dict($info['name']) /*. ' (' . $info['language'] . ')'*/, $code, (!empty($infoRule['RULE']) and $code == $infoRule['RULE'] ));
        }
        $table->addData(dict('GEN_LBL_RULE') . ':', $rule->source());
        $table->addYesNo(dict('GEN_LBL_ACTIVE'), 'DBIR_status',$infoRule['STATUS'], CLX_NUM_ZERO, true);
        if (isset($msg['DBIR_action'])) {
            $table->addCell($msg['DBIR_action'], array(CLX_PROP_COLSPAN => CLX_WIDTH_FIVE, CLX_PROP_CLASS => CLX_CLASS_ALERT));
        }
		
		$table->addField($msg, dict('GEN_LBL_RULE_TEXT') . ':', 'DBIR_rule_text', $infoRule['RULE_TEXT'], CLX_NUM_30, CLX_NUM_120);
		
		$ruleAction = new htmlSelect('DBIR_action');
        foreach ($this->rulesAction as $code => $info) {
            $ruleAction->addItem(dict($info['name']) /*. ' (' . $info['language'] . ')'*/, $code, ($code == $infoRule['ACTION']));
        }
        $table->addData(dict('GEN_LBL_RULE_ACTION') . ':', $ruleAction->source());
		
        $form->addContents($table->source());


        // Footers
        $table2 = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $buttons = '';
        if (!empty($modify)) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID)))->source();
        } else {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE'), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID)))->source();
        }
        $c = new htmlButtonCancel();
        $buttons .= $c->source();
        $table2->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->addContents($table2->source());
        return $form->source().$script;
    }

    /**
     * Verify Tool Edit Forms
     * @param array $msg
     * @return bool
     */
    function checkForm(&$msg) {if ( isset($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1634;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_exceotions_rule-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        $msg = array();
        return count($msg) == CLX_NUM_ZERO;
    }

   
    /**
     * Build display form contents
     * @param array $record
     * @return string
     */
    function viewFormFill($record) {
        $status = array(dict('GEN_LBL_INACTIVE'), dict('GEN_LBL_ACTIVE'));
        // Headers
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_RULE_TITLE_VIEW'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addData(dict('GEN_LBL_RULE') . ':', $this->rules[$record['DBIR_rule']]['name']);
        $table->addData(dict('GEN_LBL_STATUS') . ':', $status[$record['DBIR_status']]);
        $contents = $table->source();
        return $contents;
    }

    /**
     * Loads current record on selected id
     *
     * @param integer $id
     * @return array
     */
    function loadToolRecord($recordid) {
        $values = ClxCommon::$db->getRecord('CLX_DB_IMPORT_RULES', 'ID= ' . $recordid);
        $record = array();
        $record['DBIR_id'] = $recordid;
		$record['DBIR_rule'] = $values['RULE'];
        $record['DBIR_rule_text'] = $values['RULE_TEXT'];
        $record['DBIR_action'] = $values['ACTION'];
        $record['DBIR_status'] = $values['STATUS'];
		$record['DBIR_importcode'] = $values['IMPORTCODE'];
     //   $actionobject->setPanel($record, $values);
        return $record;
    }

    /**
     * Update records
     *
     * @return integer
     */
    function saveRecord() {
        $record = array();
		$record['RULE'] = UserRequest::$post['DBIR_rule'];
        $record['RULE_TEXT'] = UserRequest::$post['DBIR_rule_text'];
        $record['ACTION'] = UserRequest::$post['DBIR_action'];
        $record['STATUS'] = UserRequest::$post['DBIR_status'];
		$record['IMPORTCODE'] = UserRequest::$post['DBIR_importcode'];
	    ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post['DBIR_id']);
        
       // $this->clearHeap();
    }

    /**
     * Creates record
     *
     * @return integer
     */
    function createRecord_() {
        $record = array();
		$record['RULE'] = UserRequest::$post['DBIR_rule'];
        $record['RULE_TEXT'] = UserRequest::$post['DBIR_rule_text'];
        $record['ACTION'] = UserRequest::$post['DBIR_action'];
        $record['STATUS'] = UserRequest::$post['DBIR_status'];
        $record['IMPORTCODE'] = UserRequest::$post['DBIR_importcode'];
		$ID=ClxCommon::$db->getOne($XX='SELECT MAX(ID) ID FROM '.$this->tablename.' where RULE='.singleQuote($record['RULE']).'AND ACTION = '.singleQuote($record['ACTION']) .' AND  IMPORTCODE = '.singleQuote($record['IMPORTCODE']).' AND RULE_TEXT = '.singleQuote($record['RULE_TEXT']));
		
		IF ($ID==0) {
			$recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);
		}else { 
			$recordid=-1;
		}	
		
		return $recordid;
    }

    /**
     * Deletes record on selected id
     *
     * @param integer $id
     */
    function deleteRecordSk($id) {
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
       
    }


}
