<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
class dictionary_cache extends clx_tool {

    var $working;
    var $debug;
    var $dict_entries = array();

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'DICA';
        $this->name = 'Dictionary Cache';
        $this->system = 'System';
        $this->version = '0.4.1.5';

        $this->accesskey = 'DICT';


        $this->tablename = '';
        $this->record_name_singular = '';
        $this->record_name_plural = '';



        $this->working = true;
        $this->per_session = false;
        $this->debug = false;
    }

    function emptyCache() {
        if ($this->per_session === true) {
            return empty($_SESSION['DICCACHE']);
        } else {
            return empty($this->dict_entries);
        }
    }

    function defaultCache() {
        if ($this->per_session === true) {
            $_SESSION['DICCACHE'] = array();
        } else {
            $this->dict_entries = array();
        }
    }

    /**
     * Clear the cache and starts a new one.
     */
    function resetCache() {
        if ($this->per_session === true) {
            $_SESSION['DICCACHE'] = array();
        } else {
            $this->dict_entries = array();
        }
    }

    /**
     * Add cache array entry
     */
    function addCache($entry, $language, $value) {
		$language=clx_language_lower_upper($language);
        if ($this->working === true) {
            if ($this->per_session === true) {
                $_SESSION['DICCACHE'][$entry][$language] = $value;
            } else {

                $this->dict_entries[$entry] = array($language => $value);
            }
        }
    }

    /**
     * Remove a cache entry
     */
    function removeCache($entry) {
        if ($this->per_session === true) {
            unset($_SESSION['DICCACHE'][$entry]);
        } else {
            $this->dict_entries = array();
        }
    }

    /**
     * Search dictionary cache array and return the value or false
     */
    function searchCache($entry, $language) {
		$language=clx_language_lower_upper($language);
        $return = false;
        if ($this->working === true) {
            $entry = uppercase($entry);
            if ($this->per_session === true) {
                if ($this->emptyCache()) {
                    $this->defaultCache();
                } else {
                    if (!empty($_SESSION['DICCACHE'][$entry]) && array_key_exists($language, $_SESSION['DICCACHE'][$entry])) {
                        $return = $_SESSION['DICCACHE'][$entry][$language];
                    }
                }
            } else {
                if (array_key_exists($entry, $this->dict_entries)) {
                    if (array_key_exists($language, $this->dict_entries[$entry])) {
                        $return = $this->dict_entries[$entry][$language];
                    } elseif (array_key_exists(clx_language_lower_upper(kSystemLanguage), $this->dict_entries[$entry])) {
                        $return = $this->dict_entries[$entry][clx_language_lower_upper(kSystemLanguage)];
                    } else {
                        $return = false;
                    }
                }
            }
        }
        return $return;
    }

}
