<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 *  Repourposed class to check audits
 */
class logger extends clx_tool {

    var $enabled = false;
    var $excluded_actions = array('LIST', 'DISPLAY',
        'SEARCH', 'FILTER', 'UNFILTER', 'REORDER');
    var $logger_types = array('PACK' => 'TOOL_PACK_TITLE_IMPORT', 'DBAU' => 'UTIL_DBAU_TITLE_EXECUTE');

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'LOGR';
        $this->name = 'Audit Logger';
        $this->system = 'System';
        $this->version = '0.4.3.0';

        $this->has_access = true;


        $this->tablename = 'CLX_LOGGER';
        $this->record_name_singular = 'Audit logger';
        $this->record_name_plural = 'Audit logs';
        $this->primary_field = 'ID';
        $this->secondary_field = 'CDATE';

        $this->enabled = false;
        $this->notify_status = array('' => '', 'IDLE' => 'GEN_LBL_IDLE', 'RUN' => 'GEN_LBL_RUN', 'ERROR' => 'GEN_LBL_ERRO', 'END' => 'GEN_LBL_END');
        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_PRLO_TITLE_CREATE',
            'panels' => array(
                array('type' => 'normal',
                    'entries' => array(
                        array('label' => 'GEN_LBL_ID',
                            'fields' => array(
                                array('name' => CLX_PROP_ID,
                                    'type' => 'text',
                                    'default' => ''
                                )
                            )
                        ), array('label' => 'GEN_LBL_CDATE',
                            'fields' => array(
                                array('name' => 'cdate',
                                    'type' => 'date',
                                    'displaysize' => '35'
                                )
                            )
                        ), array('label' => 'GEN_LBL_OWNERCODE',
                            'fields' => array(
                                array('name' => 'ownercode',
                                    'type' => 'string',
                                    'default' => '0',
                                    'displaysize' => '35'
                                )
                            ), array('label' => 'GEN_LBL_USERNAME',
                                'fields' => array(
                                    array('name' => 'username',
                                        'type' => 'lookup',
                                        'default' => '',
                                        'tool' => 'ACUS'
                                    )
                                )
                            ), array('label' => 'GEN_LBL_STATUS',
                                'fields' => array(
                                    array('name' => 'status',
                                        'type' => CLX_CLASS_LIST,
                                        'default' => '',
                                        'options' => $this->notify_status
                                    )
                                )
                            )
                        )
                    )
                ), array('type' => 'normal',
                    CLX_CLASS_TITLE => 'TOOL_LOGR_AUDIT_PARAMETERS',
                    'cols' => CLX_NUM_SIX,
                    'entries' => array(
                        array('label' => 'GEN_LBL_FIX_ERRORS',
                            'fields' => array(array('name' => 'fix', 'type' => CLX_CLASS_LIST, 'options' => $this->yesno))),
                        array('label' => 'GEN_LBL_TOOLS',
                            'fields' => array(array('name' => 'tools', 'type' => CLX_CLASS_LIST, 'options' => $this->yesno))),
                        array('label' => 'GEN_LBL_TABLES',
                            'fields' => array(array('name' => 'tables', 'type' => CLX_CLASS_LIST, 'options' => $this->yesno))),
                        array('label' => 'GEN_LBL_PROCEDURES_FUNCTIONS',
                            'fields' => array(array('name' => 'procedures_functions', 'type' => CLX_CLASS_LIST, 'options' => $this->yesno))), array('label' => 'GEN_LBL_DYNAMIC_RELATIONS', 'fields' => array(array('name' => 'dynrel', 'type' => CLX_CLASS_LIST, 'options' => $this->yesno))), array('label' => 'GEN_LBL_DYNREL_INTEGRITY', 'fields' => array(array('name' => 'dynreldata', 'type' => CLX_CLASS_LIST, 'options' => $this->yesno))), array('label' => 'GEN_LBL_DROPFIELDS', 'fields' => array(array('name' => 'dropfields', 'type' => CLX_CLASS_LIST, 'options' => $this->yesno))), array('label' => 'GEN_LBL_FIELDS_ONLY', 'fields' => array(array('name' => 'fieldsonly', 'type' => CLX_CLASS_LIST, 'options' => $this->yesno))), array('label' => 'GEN_LBL_INDEXES_ONLY', 'fields' => array(array('name' => 'indexesonly', 'type' => CLX_CLASS_LIST, 'options' => $this->yesno))),array('label' => 'GEN_LBL_COMPILE', 'fields' => array(array('name' => 'compile', 'type' => CLX_CLASS_LIST, 'options' => $this->yesno))), array('label' => 'GEN_LBL_MSEXCELFILE', 'fields' => array(array('name' => 'filename', 'type' => 'string', 'size' => '255', 'displaysize' => '48',))))
                ), array('type' => 'normal',
                    CLX_CLASS_TITLE => 'GEN_LBL_MESSAGE',
                    'cols' => CLX_NUM_ONE,
                    'entries' => array(
                        array('fields' => array(array('name' => 'result', 'type' => 'text'))))
                )
            )
        );
        $this->quickfilterform = array('panels' => array(
                array('type' => 'normal',
                    'entries' => array(
                        array('label' => 'GEN_LBL_CDATE',
                            'fields' => array(
                                array('name' => 'cdate',
                                    'type' => 'date',
                                    'displaysize' => '35'
                                )
                            )
                        ), array('label' => 'GEN_LBL_STATUS',
                            'fields' => array(
                                array('name' => 'status',
                                    'type' => CLX_CLASS_LIST,
                                    'default' => '',
                                    'options' => $this->notify_status
                                )
                            )
                        ), array('label' => 'GEN_LBL_USERNAME',
                            'fields' => array(
                                array('name' => 'username',
                                    'type' => 'lookup',
                                    'default' => '',
                                    'tool' => 'ACUS'
                                )
                            )
                        )
                    )
                )
            )
        );
        $this->viewform = $this->editform;
        $this->panel = array('fields' => array(array('name' => 'ID', 'type' => 'string', 'label' => 'GEN_LBL_ID'), array('name' => 'CDATE', 'type' => 'dati', 'label' => 'GEN_LBL_CDATE'), array('name' => 'OWNERCODE', 'type' => 'string', 'label' => 'GEN_LBL_OWNERCODE'), array('name' => 'USERNAME', 'type' => 'string', 'label' => 'GEN_LBL_USERNAME'), array('name' => 'STATUS', 'type' => 'string', 'label' => 'GEN_LBL_STATUS')));
        $this->toolpanel = null;
        $this->toollist = array('name' => $this->tablename, 'sortclause' => 'CDATE DESC',
            CLX_CLASS_TITLE => $this->record_name_plural, 'has_modify' => false,
            'has_create' => false,
            'has_duplicate' => false,
            'fields' =>
            array(array('name' => 'ID', 'type' => 'string', 'label' => 'GEN_LBL_ID'), array('name' => 'CDATE', 'type' => 'dati', 'label' => 'GEN_LBL_CDATE'), array('name' => 'OWNERCODE', 'type' => 'string', 'label' => 'GEN_LBL_OWNERCODE'), array('name' => 'USERNAME', 'type' => 'string', 'label' => 'GEN_LBL_USERNAME'), array('name' => 'STATUS', 'type' => 'string', 'label' => 'GEN_LBL_STATUS'))
        );
    }

    function install() {
        $UIMI = getTool('UIMI');
        $UIMI->add($this->code, 'MENU_TOOLS:MENU_SYSTEM:MENU_AUDLOGGER', 'TOOL', $this->code, 'ac=LIST');
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['OWNERCODE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['USERNAME'] = array('type' => 'varchar(30)', 'null' => 'NO', 'properties' => '');
        $fields['ACTION'] = array('type' => 'varchar(16)', 'null' => 'YES', 'properties' => '');
        $fields['TOOLCODE'] = array('type' => 'varchar(4)', 'null' => 'YES', 'properties' => '');
        $fields['TRANSACTION'] = array('type' => 'text', 'null' => 'YES', 'properties' => '');
        $fields['STATUS'] = array('type' => 'varchar(5)', 'null' => 'NO', 'properties' => '');
        $fields['PARAMETERS'] = array('type' => 'text', 'null' => 'YES', 'properties' => '');
        $fields['RESULT'] = array('type' => 'text', 'null' => 'YES', 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'MUL', 'fieldname' => 'CDATE');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
            'fields' => $fields,
            'indexes' => $indexes);
    }

//--  A U D I T
    function action($ac, $idlist) {
        if ($this->getAccess()->canRead()) {
            $contents = parent::action($ac, $idlist);
        } else {
            $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [LOGGER-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    function makelist($listingcode = null) {
	ClxFreeReturn($listingcode);
          //$t = time('U'); genera un warning
		$t = time();
        $to = $this->code;
        $here = 'tool.php?to=' . $to . '&t=' . $t;
        clearHistory();
        pushHistory($this->code, 'LIST', array());
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->setProp(CLX_PROP_ID, $this->code . 'List');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'NOT_DEFINED');
        $selectclause = '*';
        $fromclause = $this->tablename;
        $whereclause = '';
        $sortclause = 'CDATE DESC';
        $page = new xPaging();
        $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
        $table = new htmlTable(CLX_WIDTH_FIVE);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_' . $this->code . '_TITLE_LIST'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_FIVE));
        $page->header($table);
        $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_OWNERCODE'), dict('GEN_LBL_CDATE'), dict('GEN_LBL_USERNAME'), dict('GEN_LBL_STATUS')));
        $i = CLX_INIT_ZERO;
        while ($record = $page->nextRecord()) {
            $recordid = $record['ID'];
            $select = new htmlCheckbox('selector_' . $recordid, false);
            $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
            $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
            $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array(dict((!array_key_exists($record['OWNERCODE'], $this->logger_types)) ? 'GEN_LBL_OTHER' : $this->logger_types[$record['OWNERCODE']]) . ' (' . $record['OWNERCODE'] . ')', xFormat::datetime($record['CDATE']), $record['USERNAME'], dict($this->notify_status[$record['STATUS']])));
            $i++;
        }
        $buttons = '';
        if ($this->getAccess()->canRead()) {
            $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_DISPLAY'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        /* if (CLX_NUM_ONE == CLX_NUM_TWO && $this->getAccess()->canModify()) {
          $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID),CLX_PROP_ID=> 'MULT'))->source();
          } */
        if ($this->getAccess()->canDelete()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canRead()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_EXPORT'), array('action' => 'EXPORT', 'form' => $form->getProp(CLX_PROP_ID)))->source();
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_FILTER'), array('action' => 'FILTER', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        }
        $form->addContents($page->footers($table, $buttons));
        return $form->source();
    }

    function loadToolRecord($recordid) {
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID=' . singleQuote($recordid));
        $record = array();
        $record[$this->code . '_id'] = $recordid;
        $record[$this->code . '_cdate'] = $values['CDATE'];
        $record[$this->code . '_ownercode'] = $values['OWNERCODE'];
        $record[$this->code . '_status'] = $values['STATUS'];
        $record[$this->code . '_username'] = $values['USERNAME'];
        $parameters = explode('|', $values['PARAMETERS']);
        if (count($parameters) > CLX_NUM_ONE) {
            $record[$this->code . '_fix'] = (empty($parameters[CLX_NUM_ZERO]))?0:1;
            $record[$this->code . '_filename'] = (empty($parameters[CLX_NUM_ONE]))?0:1;
            $record[$this->code . '_dropfields'] = (empty($parameters[CLX_NUM_TWO]))?0:1;
            $record[$this->code . '_fieldsonly'] = (empty($parameters[CLX_NUM_THREE]))?0:1;
            $record[$this->code . '_indexesonly'] = (empty($parameters[CLX_NUM_FOUR]))?0:1;
            $record[$this->code . '_tools'] = (empty($parameters[CLX_NUM_FIVE]))?0:1;
            $record[$this->code . '_tables'] = (empty($parameters[CLX_NUM_SIX]))?0:1;
            $record[$this->code . '_procedures_functions'] = (empty($parameters[CLX_NUM_7]))?0:1;
            $record[$this->code . '_dynrel'] = (empty($parameters[CLX_NUM_8]))?0:1;
            $record[$this->code . '_dynreldata'] = (empty($parameters[CLX_NUM_NINE]))?0:1;
            $record[$this->code . '_compile'] = (empty($parameters[CLX_NUM_TEN]))?0:1;
        } else {
            $record[$this->code . '_fix'] = 0;
            $record[$this->code . '_filename'] = 0;
            $record[$this->code . '_dropfields'] = 0;
            $record[$this->code . '_fieldsonly'] = 0;
            $record[$this->code . '_indexesonly'] = 0;
            $record[$this->code . '_tools'] = 0;
            $record[$this->code . '_tables'] = 0;
            $record[$this->code . '_procedures_functions'] = 0;
            $record[$this->code . '_dynrel'] = 0;
            $record[$this->code . '_dynreldata'] = 0;
            $record[$this->code . '_compile'] = 0;
        }
        $record[$this->code . '_result'] = $values['RESULT'];
        return $record;
    }

    function buildLog() {

    }

    /**
     * Appends to log
     *
     * @param type $log_id
     * @param string $msg
     * @return type
     */
    function appendLog($log_id, $msg) {
        if (empty($log_id))
            return;
        $msg .= CLX_CHAR_NL . ClxCommon::$db->getField('CLX_LOGGER', 'RESULT', 'ID = ' . $log_id);
        ClxCommon::$db->updateRecord($this->tablename, array('STATUS' => 'END', 'RESULT' => $msg), 'ID = ' . $log_id);
    }

    /**
     * Appends to log
     *
     * @param type $log_id
     * @param string $msg
     * @return type
     */
    function setLogStatys($log_id, $status) {
        if (empty($log_id))
            return;
        ClxCommon::$db->updateRecord($this->tablename, array('STATUS' => $status), 'ID = ' . $log_id);
    }

}
