<?php

/**
 * Porcess Logs Manager
 *
 * @package		Clientix.Tool.Process
 * @abstract		Process Engine Managers
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-05-25 14:53:28 -0400 (Fri, 25 May 2018) $
 * @version    	$Rev: 9823 $
 *
 */
class pr_proc_logs extends clx_tool {

    /**
     * Constructor
     */
    function __construct() {
        $this->code = 'PRLO';
        $this->name = 'Process Logs Manager';
        $this->system = 'Process';
        $this->version = '5.5.0.1';

        $this->has_access = true;
        $this->has_package = true;

        $this->tablename = 'CLX_PR_PROC_LOGS';
        $this->record_name_singular = 'GEN_LBL_PR_LOGS';
        $this->record_name_plural = 'GEN_LBL_PR_LOG';
        $this->primary_field = 'ID';
        $this->secondary_field = 'SCHEDULECODE';
        $this->terciary_field = 'PROCESSCODE';

        $this->notify_status = array('' => '', 'NOT' => 'GEN_LBL_NOT', 'IDLE' => 'GEN_LBL_IDLE', 'STOP' => 'GEN_LBL_STOP', 'RUN' => 'GEN_LBL_RUN', 'CANC' => 'GEN_LBL_CANC', 'ERRO' => 'GEN_LBL_ERRO', 'END' => 'GEN_LBL_END', 'ENDR' => 'GEN_LBL_ENDR', 'RWOC' => 'GEN_LBL_RWOC', 'RWAC' => 'GEN_LBL_RWAC');
        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_PRLO_TITLE_CREATE',
            'panels' => array(
                array('type' => 'normal',
                    'entries' => array(
                        array('label' => 'GEN_LBL_SCHEDULECODE',
                            'fields' => array(
                                array('name' => 'schedulecode', 'type' => 'lookup', 'default' => '', 'tool' => 'PRSC', 'validations' => array(
                                        array('type' => 'sqlobject', 'required' => '1'), array('type' => 'lookup', 'fieldname' => 'IDCODE', 'tablename' => /* 'DBTB'*/ 'CLX_PR_SCHEDULES'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_SDATE',
                            'fields' => array(
                                array('name' => 'sdate',
                                    'type' => 'date',
                                    'displaysize' => '35',
                                    'validations' => array(
                                        array('type' => 'string', 'required' => '0'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_EDATE',
                            'fields' => array(
                                array('name' => 'edate',
                                    'type' => 'date',
                                    'displaysize' => '35',
                                    'validations' => array(
                                        array('type' => 'string', 'required' => '0'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_BATCH_PID',
                            'fields' => array(
                                array('name' => 'batch_pid',
                                    'type' => 'string', 'default' => '0', 'displaysize' => '35',
                                    'validations' => array(
                                        array('type' => 'string', 'required' => '1'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_PROC_STATUS',
                            'fields' => array(
                                array('name' => 'proc_status',
                                    'type' => CLX_CLASS_LIST,
                                    'default' => '',
                                    'options' => $this->notify_status
                                )
                            )
                        ), array('label' => 'GEN_LBL_PROCESSCODE',
                            'fields' => array(
                                array('name' => 'processcode', 'type' => 'lookup', 'default' => '', 'readonly' => true, 'tool' => 'PRPR', 'validations' => array(
                                        array('type' => 'sqlobject', 'required' => '1'), array('type' => 'lookup', 'fieldname' => 'idcode', 'tablename' => 'CLX_PR_PROCESS'))
                                )
                            )
                        )
                    )
                )
            )
        );
        $this->quickfilterform = array(CLX_CLASS_TITLE => 'TOOL_PRLO_TITLE_CREATE',
            'panels' => array(
                array('type' => 'normal',
                    'entries' => array(
                        array('label' => 'GEN_LBL_SCHEDULECODE',
                            'fields' => array(
                                array('name' => 'schedulecode',
                                    'type' => 'lookup',
                                    'default' => '',
                                    'tool' => 'PRSC'
                                )
                            )
                        ), array('label' => 'GEN_LBL_PROCESSCODE',
                            'fields' => array(
                                array('name' => 'processcode',
                                    'type' => 'lookup',
                                    'default' => '',
                                    'tool' => 'PRPR'
                                )
                            )
                        ), array('label' => 'GEN_LBL_SDATE',
                            'fields' => array(
                                array('name' => 'sdate',
                                    'type' => 'date',
                                    'displaysize' => '35'
                                )
                            )
                        ), array('label' => 'GEN_LBL_EDATE',
                            'fields' => array(
                                array('name' => 'edate',
                                    'type' => 'date',
                                    'displaysize' => '35'
                                )
                            )
                        ), array('label' => 'GEN_LBL_BATCH_PID',
                            'fields' => array(
                                array('name' => 'batch_pid',
                                    'type' => 'string',
                                    'default' => '0',
                                    'displaysize' => '35'
                                )
                            )
                        ), array('label' => 'GEN_LBL_PROC_STATUS',
                            'fields' => array(
                                array('name' => 'proc_status',
                                    'type' => CLX_CLASS_LIST,
                                    'default' => '',
                                    'options' => $this->notify_status
                                )
                            )
                        )
                    )
                )
            )
        );
        $this->viewform = $this->editform;
        $this->viewform[CLX_CLASS_TITLE] = 'TOOL_PRLO_TITLE_DISPLAY';
        $this->panel = array('fields' => array(array('name' => 'SCHEDULECODE', 'type' => 'lookup', 'tool' => 'PRSC', 'label' => 'GEN_LBL_SCHEDULECODE'), array('name' => 'SDATE', 'type' => 'date', 'label' => 'GEN_LBL_SDATE'), array('name' => 'EDATE', 'type' => 'date', 'label' => 'GEN_LBL_EDATE'), array('name' => 'BATCH_PID', 'type' => 'string', 'label' => 'GEN_LBL_BATCH_PID'), array('name' => 'PROC_STATUS', 'type' => 'string', 'label' => 'GEN_LBL_BATCH_PID'), array('name' => 'PROCESSCODE', 'type' => 'string', 'label' => 'GEN_LBL_PROCESSCODE')));
        $this->toolpanel = null;
        $this->toollist = array('name' => $this->tablename, 'sortclause' => 'SDATE DESC',
            CLX_CLASS_TITLE => $this->record_name_plural, 'has_modify' => false,
            'has_create' => false,
            'has_duplicate' => false,
            'fields' =>
            array(
                array('name' => 'ID', 'type' => 'number'),
                array('name' => 'SCHEDULECODE', 'type' => 'lookup', 'tool' => 'PRSC', 'label' => 'GEN_LBL_SCHEDULECODE'),
                array('name' => 'SDATE', 'type' => 'dati'),
                array('name' => 'EDATE', 'type' => 'dati'),
                array('name' => 'BATCH_PID', 'type' => 'number'),
                array('name' => 'PROC_STATUS', 'type' => CLX_CLASS_LIST, 'options' => $this->notify_status)
            )
        );
    }

// End method
    /**
     * Tool Table Structure
     * @return array
     */
    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['SCHEDULECODE'] = array('type' => 'varchar(20)', 'null' => 'NO');
        $fields['PROCESSCODE'] = array('type' => 'varchar(20)', 'null' => 'NO');
        $fields['EXECUTEDBY'] = array('type' => 'varchar(30)', 'null' => 'NO');
        $fields['PROCESS_MSG'] = array('type' => 'varchar(30)', 'null' => 'YES');
        $fields['PROC_STATUS'] = array('type' => 'varchar(10)', 'null' => 'NO', 'default' => '' . singleQuote('IDLE') . '', 'default_raw' => 'IDLE');
        $fields['BATCH_PID'] = array('type' => 'varchar(35)', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['SDATE'] = array('type' => 'datetime', 'null' => 'YES');
        $fields['EDATE'] = array('type' => 'datetime', 'null' => 'YES');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'MUL', 'fieldname' => 'SCHEDULECODE,PROC_STATUS');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
            'fields' => $fields,
            'indexes' => $indexes);
    }

    /**
     * Tool Install Method
     */
    function install() {
        $UIMI = getTool('UIMI');
        $UIMI->add($this->code, 'MENU_TOOLS:MENU_PROCESS:MENU_' . $this->code, 'TOOL', $this->code, 'ac=LIST');
    }

//-- PROCESS LOGS
    /**
     * Tool Action
     * @param string $ac Action code
     * @param string $idlist Record(s) affected by action
     * @return string
     */
    function action($ac, $idlist) {
        if ($this->getAccess()->canRead()) {
            switch ($ac) {
                default:
                    $contents = parent::action($ac, $idlist);
                    break;
            }
        } else {
            $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [PR_PROC_LOGS-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    /**
     * Prepares tool default record
     * @return array
     */
    function defaultRecord() {
        $record = parent::defaultRecord();
        $record['PRLO_proc_status'] = 'IDLE';
        return $record;
    }

    /**
     * Builds tool display form
     * @param array $record
     * @return string
     */
    function viewFormFill($record) {
        addHistory('processcode', $record['PRLO_id']);
        $PRSL = &getTool('PRSL');
        $contents = $PRSL->makepanel($record['PRLO_id']);
        // Elements
        $PREL = &getTool('PREL');
        $contents .= $PREL->makepanel($record['PRLO_id']);
        return $contents;
    }

    /**
     * Deletes tool record by ID
     * @param int $id
     */
    function deleteRecordSk($id) {
        $this->deleteChildRecord($id);
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
    }

    function deleteLogsUtil() {
        ClxCommon::$db->deleteRecords('CLX_PR_PROC_LOGS',null);
        ClxCommon::$db->deleteRecords('CLX_PR_EXCEPT_LOGS',null);
        ClxCommon::$db->deleteRecords('CLX_PR_STEP_LOGS',null);
    }

    /**
     * Deletes child records
     * @param type $id Dee
     */
    function deleteChildRecord($id) {
        $idcode = ClxCommon::$db->getField($this->tablename, 'ID', 'ID=' . $id);
        //Exception logs
        $PREL = getTool('PREL');
        $rs = ClxCommon::$db->getRecords($PREL->tablename, 'LOG_RECID=' . singleQuote($idcode));
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $PREL->deleteRecordSk($r['ID']);
        }
        //Step logs
        $PRSL = getTool('PRSL');
        $rs = ClxCommon::$db->getRecords($PRSL->tablename, 'LOG_RECID=' . singleQuote($idcode));
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $PRSL->deleteRecordSk($r['ID']);
        }
    }

    function toolArchive() {
        if (!defined('UTIL_ARCHIVE_MODE'))
            define('UTIL_ARCHIVE_MODE', CLX_NUM_12);
        //Archive
        $sql = 'SELECT * FROM ' . $this->tablename;
        if (UTIL_ARCHIVE_MODE == CLX_NUM_ONE) {
            $archive_tbl = $this->tablename . '_' . getNow('m') . '_' . getNow('Y');
        } else {
            $archive_tbl = $this->tablename . '_' . getNow('Y');
        }
        $tableinfo = $this->toolTableStructure();
        unset($tableinfo['fields']['ID']);
        $tableinfo['name'] = $archive_tbl;
        $tableinfo['type'] = 'ARCHIVE';
        $tableinfo['indexes'] = array();
        $structure = ClxCommon::$db->translateTableStructure($tableinfo);
        //Create table if not exists
        if (!ClxCommon::$db->tableExists($structure['name'])) {
            //Create table if not exists
            ClxCommon::$db->createTable($structure['name'], $structure['type'], $structure['fields'], $structure['case_sensitive']);
        }
        $comma = '';
        $select = '';
        foreach ($structure['fields'] as $key => $val) {
            $select .= $comma . $key;
            $comma = ',';
        }
        //Lock table to archive
        $sql = 'SELECT MAX(ID) FROM ' . $this->tablename;
        $maxid = ClxCommon::$db->getOne($sql);
        $PREL = &getTool('PREL');
        $PREL->toolArchive();
        $PRSL = &getTool('PRSL');
        $PRSL->toolArchive();
        if (empty($maxid))
            return;
        //Backup
        $sql = 'INSERT INTO ' . $structure['name'] . '(' . $select . ') SELECT ' . $select . ' FROM ' . $this->tablename . ' WHERE ID <=' . $maxid;
        ClxCommon::$db->executeQuery($sql);
        //Unlock table
        $sql = 'DELETE FROM ' . $this->tablename . ' WHERE ID<=' . $maxid;
        ClxCommon::$db->executeQuery($sql);
        //Restore stats if apply
        ClxCommon::$db->buldStats($this->tablename);
        /* probar */
    }

    /**
     *
     *
     * @param type $parameters
     * metodo que se ejecuta cuando corre el proceso clx_los_clean
     */
    function toolArchive_batch($parameters) {
        $contenidoHTML = '';
        //e cho 'TOOLARCHIVE_BATCH parameters:<br>'.CLX_CHAR_NL; print_r($parameters);
        //   - Caso 1002598 - BNP-Limpieza Proccess Logs en Batch
        // Method 'get_bkp_time_limit' implemented to avoid schedule CLX_PRLO_CLEAN
        // to remain un 'In progress(RUN) status due to PHP timeout.
        $DBBK = getToolObject('UTIL', 'DBBK');
        $bkp_time_limit = $DBBK->get_bkp_time_limit();
        // Set it to twice the time limit of backup, just in case
        UserResponse::setRunTimeLimit($bkp_time_limit * CLX_NUM_TWO * CLX_NUM_60 * CLX_NUM_60);
        //   - Caso 1002598 - BNP-Limpieza Audit en Batch
        // Se agrega este método para realizar el archival en batch,
        // ya que en los casos que CLX_PR_PROC_LOGS tenga muchos registros,
        // se cae cuando se hace en el interactivo.
        // Realiza la llamada al método $this->toolArchive()
        $this->toolArchive();
        // Extrae la lista de las tablas con los archives existentes
        //   - Caso 1002670 - BNP-Limpieza Proc Log en batch
        // Fix size of SUBSTR with calculated strlen($this->tablename)+1
        // Substitutes table name prefix with $this->tablename
        /*
         * Para saber los nombres de los Archives de PROC_LOGS en la base de datos corriente
         */
        $sql = 'SELECT  TABLE_NAME  FROM  INFORMATION_SCHEMA.TABLES  WHERE  SUBSTR(TABLE_NAME, 1, ' . (strlen($this->tablename) + CLX_NUM_ONE) . ') = ' . singleQuote($this->tablename . '_') . ' AND TABLE_SCHEMA = ' . singleQuote(kDatabaseName);
        $results = ClxCommon::$db->executeQuery($sql);
        $tables = array();
        while (($rec = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE))) {
            $tables[] = $rec['TABLE_NAME'];
        }
        // Verifica su hay archives
        if (count($tables) > CLX_NUM_ZERO) {
            // List of archive tables to backup (separated by '/')
            $parameters['TABLES'] = implode('/', $tables);
            //   - Caso 1002670 - BNP-Limpieza Proc Log en batch
            // Get ACAD tool to make ACAD_ARC_NAME_SUFFIX constant available
            // Eventually adds a suffix to backup file name
            // to avoid Recycler to delete those bkp files
            // Le agrega lo necesario para que el respaldo se conserve del reciclaje
            if (defined('ACAD_ARC_NAME_SUFFIX')) {
                $archive_name_suffix = ACAD_ARC_NAME_SUFFIX;
            } else {
                $archive_name_suffix = '';
            }
            if ($archive_name_suffix === '' || $archive_name_suffix === 'null' || is_null($archive_name_suffix)) {
                $archive_name_suffix = '';
            }
            // Backup file name
            $parameters['NAME_SUFFIX'] = '_' . $this->tablename . $archive_name_suffix;
            // No Drop Table option
            $parameters['DUMP_OPTIONS'] = '--skip-add-drop-table';
            // Local Backup Script optional parameters: Don't stop minute-by-minute process
            $parameters['LBS_OPT_PAR'] = '-ncss 0';
            $contenidoHTML.= '<br>' .
                    'Calling backup procedure<br>' .
                    'Tables: ' . str_replace('/', ', ', $parameters['TABLES']) . '<br>' .
                    'File name suffix: ' . $parameters['NAME_SUFFIX'] . '<br>';
            // Llama al respaldo pasandole como parametro los nombres de los archives
            $results = $DBBK->run($parameters);
            if ($results === '') {
                // Si el respaldo fue existoso, elimina los archives de la BDD
                $contenidoHTML.= '<br>';
                foreach ($tables as $key => $val) {
                    $contenidoHTML.= 'Dropping Table: ' . $val . '<br>';
                    $sql = 'DROP TABLE IF EXISTS ' . $val;
                    ClxCommon::$db->executeQuery($sql);
                }
            } else {
                $contenidoHTML.= '<br>';
                $contenidoHTML.='ERROR: excecuting backup<br>';
                $contenidoHTML.= $results;
                $contenidoHTML.= '<br>';
            }
        }
        echo $contenidoHTML;
    }
	
	//Caso 1004051: Se agrega función para saber si un proceso determinado esta ejecutandose en un momento determinado. Se invoca a la función con el idcode del proceso
	function isProcess_Run($idcodeprocess) {
		  $status=false;
		  if (ClxCommon::$db->countRecords($this->tablename, 'SCHEDULECODE=' . singleQuote($idcodeprocess) . 'AND PROC_STATUS=' . singleQuote('RUN')) > CLX_NUM_ZERO) {
		      $status=true;
		  }
		  return $status;
	}

//-- PROCESS LOGIN METHODS
}

// End class
