<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
class sd_mimegroup_members extends clx_tool {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'SDMM';
        $this->name = 'MIME Group Members';
        $this->system = 'System Data';
        $this->version = '0.2.0.0';


        $this->accesskey = 'SDMG';

        $this->tablename = 'CLX_SD_MIMEGROUP_MEMBERS';
        $this->record_name_singular = 'MIME Group Member';
        $this->record_name_plural = 'MIME Group Members';
        $this->primary_field = 'GROUPCODE';
        $this->secondary_field = 'MIMECODE';
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['GROUPCODE'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '');
        $fields['MIMECODE'] = array('type' => 'varchar(100)', 'null' => 'NO', 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'GROUPCODE,MIMECODE');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
            'fields' => $fields,
            'indexes' => $indexes);
    }

}
