<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2019-01-22 15:45:22 -0400 (ma., 22 ene. 2019) $
 * @version        $Rev: 10496 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
class sd_mimetypes extends clx_tool {

    var $importForm;

    function __construct() {
        $this->code = 'SDMT';
        $this->name = 'MIME Types Manager';
        $this->system = 'System Data';
        $this->version = '0.2.0.0';

        $this->has_access = true;


        $this->tablename = 'CLX_SD_MIMETYPES';
        $this->record_name_singular = 'MIME Type';
        $this->record_name_plural = 'MIME Types';
        $this->primary_field = 'IDCODE';
        $this->secondary_field = 'IDNAME';

        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_SDMT_TITLE_CREATE',
            'panels' => array(
                array('type' => 'normal',
                    'entries' => array(
                        array('label' => 'GEN_LBL_CODE',
                            'fields' => array(
                                array('name' => 'idcode', 'type' => 'string', 'default' => '', 'size' => CLX_NUM_HUNDRED, 'displaysize' => '32', 'dontmodify' => '1',
                                    'validations' => array(
                                        array('type' => 'string', 'required' => '1'), array('type' => 'unique', 'fieldname' => 'idcode', 'tablename' => $this->tablename))
                                )
                            )
                        ), array('label' => 'GEN_LBL_NAME',
                            'fields' => array(
                                array('name' => 'idname', 'type' => 'string', 'default' => '', 'size' => CLX_NUM_HUNDRED, 'displaysize' => '48', 'validations' => array(
                                        array('type' => 'string', 'required' => '1'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_HTMLTAG',
                            'fields' => array(
                                array('name' => 'html_tag', 'type' => 'text', 'default' => '', 'cols' => '48', 'rows' => '4'))
                        ), array('label' => 'GEN_LBL_EXTENSION',
                            'fields' => array(
                                array('name' => 'extension', 'type' => 'string', 'default' => '', 'size' => '12', 'displaysize' => '24'))
                        )
                    )
                )
            )
        );
        $this->importForm = array(CLX_CLASS_TITLE => 'TOOL_SDMT_TITLE_IMPORT',
            'panels' => array(
                array('type' => 'normal',
                    'entries' => array(
                        array('label' => 'GEN_LBL_FILE',
                            'fields' => array(
                                array('name' => 'filename', 'type' => 'file', 'validations' => array(
                                        array('type' => 'string', 'required' => '1'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_NAME',
                            'fields' => array(
                                array('name' => 'idname', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '48', 'validations' => array(
                                        array('type' => 'string', 'required' => '1'), array('type' => 'unique', 'fieldname' => 'idcode', 'tablename' => $this->tablename))
                                )
                            )
                        )
                    )
                )
            )
        );
    }

    function install() {
        $UIMI = getTool('UIMI');
        $UIMI->add($this->code, 'MENU_TOOLS:MENU_SYSTEMDATA:MENU_MIMETYPES', 'TOOL', $this->code, 'ac=LIST');
        $init = array(array('IDCODE' => 'text/plain', 'IDNAME' => 'Plain Text'),
            array('IDCODE' => 'text/richtext', 'IDNAME' => 'Rich Text'),
            array('IDCODE' => 'text/enriched', 'IDNAME' => 'Enriched Text'),
            array('IDCODE' => 'text/tab-separated-values', 'IDNAME' => 'Tab Separated Text'),
            array('IDCODE' => 'text/html', 'IDNAME' => 'HTML Format', 'HTML_TAG' => '<div>[CONTENTS]</div>', 'EXTENSION' => 'html'),
            array('IDCODE' => 'text/sgml', 'IDNAME' => 'SGML Format'),
            array('IDCODE' => 'text/vnd.latex-z', 'IDNAME' => 'LaTex Format'),
            array('IDCODE' => 'text/css', 'IDNAME' => 'CSS Format', 'HTML_TAG' => '<style>[CONTENTS]</style>', 'EXTENSION' => 'css'),
            array('IDCODE' => 'text/xml', 'IDNAME' => 'XML Format'),
            array('IDCODE' => 'text/rtf', 'IDNAME' => 'RTF Text Format'),
            array('IDCODE' => 'application/postscript', 'IDNAME' => 'Postscript'),
            array('IDCODE' => 'application/mac-binhex40', 'IDNAME' => 'BinHex Compresed Macintosh File', 'EXTENSION' => 'hqx'),
            array('IDCODE' => 'application/wordperfect5.1', 'IDNAME' => 'Word Perfect 5.1'),
            array('IDCODE' => 'application/pdf', 'IDNAME' => 'PDF Format'),
            array('IDCODE' => 'application/zip', 'IDNAME' => 'ZIPCompresed File'),
            array('IDCODE' => 'application/macwriteii', 'IDNAME' => 'Max Write II'),
            array('IDCODE' => 'application/msword', 'IDNAME' => 'Microsoft Word', 'EXTENSION' => 'doc'),
            array('IDCODE' => 'application/vnd.openxmlformats-officedocument.wordprocessingml.document', 'IDNAME' => 'Microsoft Word X', 'EXTENSION' => 'docx'),
            array('IDCODE' => 'application/mathematica', 'IDNAME' => 'Mathematica'),
            array('IDCODE' => 'application/sgml', 'IDNAME' => 'SGML Format'),
            array('IDCODE' => 'application/vnd.framemaker', 'IDNAME' => 'FrameMaker'),
            array('IDCODE' => 'application/vnd.ms-excel', 'IDNAME' => 'VND Microsoft Excel', 'EXTENSION' => 'xls'),
            array('IDCODE' => 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet', 'IDNAME' => 'VND Microsoft Excel X', 'EXTENSION' => 'xlsx'),
            array('IDCODE' => 'application/vnd.ms-powerpoint', 'IDNAME' => 'VND Microsoft Powerpoint', 'EXTENSION' => 'ppt'),
            array('IDCODE' => 'application/vnd.openxmlformats-officedocument.presentationml.presentation', 'IDNAME' => 'VND Microsoft Powerpoint X', 'EXTENSION' => 'pptx'),
            array('IDCODE' => 'application/vnd.ms-project', 'IDNAME' => 'VND Microsoft Project'),
            array('IDCODE' => 'application/vnd.ms-works', 'IDNAME' => 'VND Microsoft Works'),
            array('IDCODE' => 'application/vnd.fdf', 'IDNAME' => 'FDF'),
            array('IDCODE' => 'application/vnd.lotus-wordpro', 'IDNAME' => 'VND Lotus Wordpro'),
            array('IDCODE' => 'application/vnd.lotus-approach', 'IDNAME' => 'VND Lotus Approach'),
            array('IDCODE' => 'application/vnd.lotus-1-2-3', 'IDNAME' => 'VND Lotus 1-2-3'),
            array('IDCODE' => 'application/vnd.lotus-organizer', 'IDNAME' => 'VND Lotus Organizar'),
            array('IDCODE' => 'application/vnd.lotus-screencam', 'IDNAME' => 'VND Lotus ScreenCam'),
            array('IDCODE' => 'application/vnd.lotus-freelance', 'IDNAME' => 'VND Lotus Freelance'),
            array('IDCODE' => 'application/vnd.visio', 'IDNAME' => 'Visio'),
            array('IDCODE' => 'application/vnd.lotus-notes', 'IDNAME' => 'VND Lotus Notes'),
            array('IDCODE' => 'image/jpeg', 'IDNAME' => 'JPEG', 'HTML_TAG' => '<img src=' . singleQuote('[PATHNAME') . '>', 'EXTENSION' => 'jpeg'),
            array('IDCODE' => 'image/gif', 'GIF', 'HTML_TAG' => '<img src=' . singleQuote('[PATHNAME') . '>', 'EXTENSION' => 'gif'),
            array('IDCODE' => 'image/tiff', 'IDNAME' => 'TIFF'),
            array('IDCODE' => 'image/vnd.dxf', 'IDNAME' => 'DXF'),
            array('IDCODE' => 'image/png', 'PNG', 'HTML_TAG' => '<img src=' . singleQuote('[PATHNAME') . '>', 'EXTENSION' => 'png'),
            array('IDCODE' => 'audio/mpeg', 'IDNAME' => 'Audio MPEG'),
            array('IDCODE' => 'video/mpeg', 'IDNAME' => 'Video MPEG'),
            array('IDCODE' => 'video/quicktime', 'IDNAME' => 'QuickTime'),
            array('IDCODE' => 'video/vnd.vivo', 'IDNAME' => 'VIVO'),
            array('IDCODE' => 'model/vrml', 'IDNAME' => 'VRML'),
            array('IDCODE' => 'application/octet-stream', 'IDNAME' => 'Application/octect-stream'),
            array('IDCODE' => 'audio/mid', 'IDNAME' => 'MIDI'),
            array('IDCODE' => 'image/x-photoshop', 'IDNAME' => 'Adobe Photoshop', 'EXTENSION' => 'PSD'),
            array('IDCODE' => 'image/pjpeg', 'IDNAME' => 'JPEG', 'HTML_TAG' => '<img src=' . singleQuote('[PATHNAME') . '>', 'EXTENSION' => 'jpeg'));
        foreach ($init as $key => $val) {
            ClxCommon::$db->createRecord($this->tablename, $val, false);
        }
    }

// End method
    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['IDCODE'] = array('type' => 'varchar(100)', 'null' => 'NO', 'properties' => '');
        $fields['IDNAME'] = array('type' => 'varchar(100)', 'null' => 'NO', 'properties' => '');
        $fields['HTML_TAG'] = array('type' => 'varchar(255)', 'properties' => '');
        $fields['EXTENSION'] = array('type' => 'varchar(25)', 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'IDCODE');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'IDNAME');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
            'fields' => $fields,
            'indexes' => $indexes);
        ;
    }

//-- M I M E    T Y P E S
    function action($ac, $idlist) {
        $msg = array();
        if ($this->getAccess()->canRead()) {
            switch ($ac) {
                case 'IMPORT':
                    if ($this->getAccess()->canDisplay()) {
                        if (isset(UserRequest::$request['confirm'])) {
                            $contents = $this->importType();
                        } else {
                            $record = array();
                            $contents = $this->importForm($ac, $idlist, $record, $msg);
                        }
                    } else {
                        $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [SD_MIMETYPES-CAN_APPEND][' . $ac . '] ' . $this->getCode(false));
                    }
                    break;
                default:
                    $contents = parent::action($ac, $idlist);
                    break;
            }
        } else {
            $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [SD_MIMETYPES-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    function importForm($ac, $idlist, $record, $msg) {
        $form = new clx_form($this->code, $this->importForm);
        return $form->editForm($ac, $idlist, $record, $msg);
    }

    function importType() {
        if (UserRequest::$files['SDMT_filename']['error']) {
            $contents = warning(dict('TOOL_SDMT_CANT_IMPORT', UserRequest::$files['SDMT_filename']['name']), dict('GEN_LBL_RETURN'));
        } else {
            $qty = ClxCommon::$db->oneExistsRecords($this->tablename, 'IDCODE=' . singleQuote(UserRequest::$files['SDMT_filename']['type']));
            if ($qty == CLX_NUM_ZERO) {
                $pos = strrpos(UserRequest::$files['SDMT_filename']['name'], '.');
                if ($pos !== false) {
                    $extension = substr(UserRequest::$files['SDMT_filename']['name'], $pos + CLX_NUM_ONE);
                } else {
                    $extension = '';
                }
                $record = array();
                $record['IDCODE'] = UserRequest::$files['SDMT_filename']['type'];
                $record['IDNAME'] = UserRequest::$post['SDMT_idname'];
                $record['HTML_TAG'] = '';
                $record['EXTENSION'] = $extension;
                $recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);
                $idlist = array($recordid);
                $contents = $this->viewForm($idlist);
            } else {
                $contents = note(dict('TOOL_SDMT_DUPLICATE_ENTRY', UserRequest::$files['SDMT_filename']['type']), dict('GEN_LBL_RETURN'));
            }
        }
        return $contents;
    }

    function makelist($listingcode = null) {
        ClxFreeReturn($listingcode);
        $t = time();
        $to = $this->code;
        $here = 'tool.php?to=' . $to . '&t=' . $t;
        clearHistory();
        pushHistory($this->code, 'LIST', array());
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->setProp(CLX_PROP_ID, 'SDMTList');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'NOT_DEFINED');
        $selectclause = '*';
        $fromclause = 'CLX_SD_MIMETYPES';
        $whereclause = '';
        $sortclause = 'IDNAME';
        $page = new xPaging();
        $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
        $table = new htmlTable(CLX_WIDTH_FOUR);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_SDMT_TITLE_LIST'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_FOUR));
        $page->header($table);
        $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_CODE'), dict('GEN_LBL_NAME'), dict('GEN_LBL_EXTENSION')));
        $i = CLX_INIT_ZERO;
        while ($record = $page->nextRecord()) {
            $recordid = $record['ID'];
            $select = new htmlCheckbox('selector_' . $recordid, false);
            $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
            $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
            $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array($record['IDCODE'], $record['IDNAME'], $record['EXTENSION']));
            $i++;
        }
        $buttons = '';
        $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_DISPLAY'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        if ($this->getAccess()->canModify()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canDelete()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canDisplay()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE_SOMETHING', dict('GEN_LBL_MIMETYPE')), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_IMPORT'), array('action' => 'IMPORT', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        }
        $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_FILTER'), array('action' => 'FILTER', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        $form->addContents($page->footers($table, $buttons));
        return $form->source();
    }

    function searchForm() {
        $msg = array();
        $contents = '';
        // Search Form
        $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF']);
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'SEARCH');
        $form->addArgument('confirm', '1');
        $form->addArgument(CLX_PROP_TARGET, UserRequest::$request[CLX_PROP_TARGET]);
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_SDMT_TITLE_SEARCH'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addField($msg, dict('GEN_LBL_CODE') . ':', 'SDMT_idcode', UserRequest::$post['SDMT_idcode'], CLX_NUM_FOUR, CLX_NUM_FOUR);
        $table->addField($msg, dict('GEN_LBL_NAME') . ':', 'SDMT_idname', UserRequest::$post['SDMT_idname'], CLX_NUM_32, CLX_NUM_64);
        $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_SEARCH'), array('action' => 'SEARCH', 'form' => $form->getProp(CLX_PROP_ID)))->source();
        $c = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $contents .= $form->source();
        // Search Procedure
        if (isset(UserRequest::$post['confirm'])) {
            $table = new htmlTable(CLX_WIDTH_TWO);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $criteria = '';
            if (UserRequest::$post['SDMT_idcode'] <> '') {
                $criteria .= 'UPPER(IDCODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['SDMT_idcode']) . '%');
            }
            if (UserRequest::$post['SDMT_idname'] <> '') {
                $criteria .= 'UPPER(IDNAME) LIKE ' . singleQuote(uppercase(clx_change_especial_char_html (UserRequest::$post['SDMT_idname'])) . '%');
            }
            $qty = ClxCommon::$db->oneExistsRecords($this->tablename, $criteria);
            if ($qty == CLX_NUM_ZERO) {
                $table->addCell(dict('TOOL_GEN_ERR_NOMATCH'), array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            } else {
                $table->addCell(dict('TOOL_GEN_MSG_FOUNDRECORDS'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
                $records = ClxCommon::$db->getRecords($this->tablename, $criteria);
                $i = CLX_INIT_ZERO;
                while (($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE))) {
                    $js = 'javascript:setLookupValue(' . quote(UserRequest::$request[CLX_PROP_TARGET]) . ', ' . quote($record['IDCODE']) . ');';
                    $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array('<page t=sd_mimetypes></page><a href="' . $js . '">' . $record['IDCODE'] . '</a>', $record['IDNAME']));
                    $i++;
                }
            }
            $contents .= $table->source();
        }
        return $contents;
    }

    function confirmDeleteFill(&$table, $record) {
        $table->addData(dict('GEN_LBL_CODE') . ':', $record['SDMT_idcode']);
        $table->addData(dict('GEN_LBL_NAME') . ':', $record['SDMT_idname']);
    }

    function viewFormFill($record) {
        $contents = '';
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_SDMT_TITLE_VIEW') . ': ' . $record['SDMT_idname'], array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addData(dict('GEN_LBL_CODE') . ':', $record['SDMT_idcode']);
        $table->addData(dict('GEN_LBL_NAME') . ':', $record['SDMT_idname']);
        $contents .= $table->source();
        return $contents;
    }

    function filterFormFill($msg, &$table) {
        if (!array_key_exists('SDMT_idcode', UserRequest::$post))
            UserRequest::$post['SDMT_idcode'] = '';
        if (!array_key_exists('SDMT_idname', UserRequest::$post))
            UserRequest::$post['SDMT_idname'] = '';
        if (!array_key_exists('SDMT_extension', UserRequest::$post))
            UserRequest::$post['SDMT_extension'] = '';
        $table->addField($msg, dict('GEN_LBL_CODE'), 'SDMT_idcode', UserRequest::$post['SDMT_idcode'], CLX_NUM_32, CLX_NUM_64);
        $table->addField($msg, dict('GEN_LBL_NAME'), 'SDMT_idname', UserRequest::$post['SDMT_idname'], CLX_NUM_32, CLX_NUM_64);
        $table->addField($msg, dict('GEN_LBL_EXTENSION'), 'SDMT_extension', UserRequest::$post['SDMT_extension'], CLX_NUM_24, CLX_NUM_24);
    }

    function setfilter() {
        $filter = '';
        $boolean = '';
        if (!empty(UserRequest::$post['SDMT_idcode'])) {
            $filter .= $boolean . ' UPPER(IDCODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['SDMT_idcode']) . '%');
            $boolean = 'AND';
        }
        if (!empty(UserRequest::$post['SDMT_idname'])) {
            $filter .= $boolean . ' UPPER(IDNAME) LIKE ' . singleQuote(uppercase(clx_change_especial_char_html (UserRequest::$post['SDMT_idname'])) . '%');
            $boolean = 'AND';
        }
        if (!empty(UserRequest::$post['SDMT_extension'])) {
            $filter .= $boolean . ' EXTENSION LIKE ' . singleQuote(UserRequest::$post['SDMT_extension'] . '%');
            $boolean = 'AND';
        }
        $_SESSION['paging']['SDMTList']['criteria'] = $filter;
        $_SESSION['paging']['SDMTList']['startat'] = '0';
    }
	///////////////////////////////////////////////////
	///comentado 22/01/2019 para utilizar la clx_tool
	//////////////////////////////////////////////////
   /* function clearfilter() {
        $_SESSION['paging']['SDMTList']['criteria'] = '';
    }*/

    function loadToolRecord($recordid) {
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID= ' . $recordid);
        $record = array();
        $record['SDMT_id'] = $recordid;
        $record['SDMT_idcode'] = $values['IDCODE'];
        $record['SDMT_idname'] = $values['IDNAME'];
        $record['SDMT_html_tag'] = $values['HTML_TAG'];
        $record['SDMT_extension'] = $values['EXTENSION'];
        return $record;
    }

    function saveRecord() {
        $record = array();
        $record['IDNAME'] = UserRequest::$post['SDMT_idname'];
        $record['HTML_TAG'] = UserRequest::$post['SDMT_html_tag'];
        $record['EXTENSION'] = UserRequest::$post['SDMT_extension'];
        ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post['SDMT_id']);
    }

    function createRecord_() {
        $record = array();
        $record['IDCODE'] = UserRequest::$post['SDMT_idcode'];
        $record['IDNAME'] = UserRequest::$post['SDMT_idname'];
        $record['HTML_TAG'] = UserRequest::$post['SDMT_html_tag'];
        $record['EXTENSION'] = UserRequest::$post['SDMT_extension'];
        $recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        return $recordid;
    }

    function deleteRecordSk($id) {
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
    }

    function defaultRecord() {
        $record = array();
        $record['SDMT_id'] = CLX_INIT_ZERO;
        $record['SDMT_idcode'] = '';
        $record['SDMT_idname'] = '';
        $record['SDMT_html_tag'] = '';
        $record['SDMT_extension'] = '';
        return $record;
    }

// DEPRECATED in favor of chooseRecord($name, $default)
    function placeChooseMimeType($msg, $prompt, $name, $default, &$table) {
        if (!empty($msg[$name]))
            $table->addCell($msg[$name], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => $table->width));
        $table->addCell($prompt, array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($this->chooseRecord($name, $default), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        return CLX_CHAR_EMPTY_STRING;
    }

// DEPRECATED in favor of recordExists($field_label, &$field_value, $msg)
    function MimeTypeExists(&$idcode) {
        $qty = ClxCommon::$db->oneExistsRecords($this->tablename, $this->primary_field . '=' . singleQuote($idcode));
        if ($qty > CLX_NUM_ZERO) {
            $idcode = ClxCommon::$db->getField($this->tablename, $this->primary_field, $this->primary_field . '=' . singleQuote($idcode));
        }
        return $qty > CLX_NUM_ZERO;
    }

}
