<?php

/**
 * Map Criterias Manager
 * Webservices Map Criterias Manager
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version    	$Rev: 9615 $
 *
 * CHANGE LOG
 *  Included label
 */
class sk_criterias extends clx_tool {

    var $import_types;
    var $importForm;
    var $operators;

    function __construct() {
        $this->code = 'SKMC';
        $this->name = 'Map Criterias Manager';
        $this->system = 'Sockets';
        $this->version = '5.5.0.0';

        $this->has_access = true;
        $this->has_package = true;

        $this->tablename = 'CLX_SK_CRITERIAS';
        $this->record_name_singular = 'GEN_LBL_CRITERIA';
        $this->record_name_plural = 'GEN_LBL_CRITERIAS';
        $this->primary_field = 'MAP_CODE';
        $this->secondary_field = 'MSG_ELEMENT';
        $this->seqnum_field = 'SEQNUM';
        $this->operators = array('EQ' => 'GEN_OPE_EQUAL', 'NQ' => 'GEN_OPE_NOTEQUAL',
            'LS' => 'GEN_OPE_LESS',
            'LQ' => 'GEN_OPE_LESS_EQUAL',
            'GQ' => 'GEN_OPE_GREATER_EQUAL',
            'GT' => 'GEN_OPE_GREATER',
            'IN' => 'GEN_OPE_IN',
            'NI' => 'GEN_OPE_NOTIN',
            'BW' => 'GEN_OPE_BETWEEN',
            'SW' => 'GEN_OPE_STARTS_WITH',
            'EW' => 'GEN_OPE_ENDS_WITH',
            'CT' => 'GEN_OPE_CONTAINS',
            'EX' => 'GEN_OPE_EXPRESSIONS',
            'IS' => 'GEN_OPE_IS',
            'IT' => 'GEN_OPE_ISNOT',
            'EF' => 'GEN_EFFDATE_LESSEQUAL');
        $this->operators_value = array('EQ' => '=',
            'NQ' => '<>',
            'LS' => '<',
            'LQ' => '<=',
            'GQ' => '>=', 'GT' => '>', 'IN' => 'IN',
            'NI' => 'NOT IN',
            'BW' => '?',
            'SW' => 'LIKE',
            'EW' => 'LIKE',
            'CT' => 'LIKE',
            'EX' => '',
            'IS' => 'IS',
            'IT' => 'IS NOT'
        );
        $this->logicals = array('AND' => 'GEN_LOG_AND',
            'OR' => 'GEN_LOG_OR',
        );
        $this->open_bracket = array('' => 'GEN_LBL_NO',
            '(' => 'GEN_LBL_YES',
        );
        $this->close_bracket = array('' => 'GEN_LBL_NO',
            ')' => 'GEN_LBL_YES',
        );
        $this->access_types = array(
        );
        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_SKMC_TITLE_CREATE',
            'panels' => array(
                array('type' => 'normal',
                    'entries' => array(
                        array('label' => 'GEN_LBL_MAP_CODE',
                            'fields' => array(
                                array('name' => 'map_code', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '16', 'dontmodify' => '1', 'readonly' => '1',
                                    'validations' => array(
                                        array('type' => 'string', 'required' => '1'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_SEQNUM',
                            'fields' => array(
                                array('name' => 'seqnum', 'type' => 'string', 'default' => '', 'size' => '6', 'displaysize' => '6', 'dontmodify' => '')
                            )
                        ), array('label' => 'GEN_LBL_TABLECODE1',
                            'fields' => array(
                                array('name' => 'tablecode1', 'type' => 'lookup', 'default' => '', 'tool' => 'DBTB', 'validations' => array(
                                        array('type' => 'lookup', 'fieldname' => 'IDCODE', 'tablename' => 'CLX_DB_TABLES'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_FIELDNAME1',
                            'fields' => array(
                                array('name' => 'fieldname1', 'type' => 'lookup', 'default' => '', 'tool' => 'DBFL', 'validations' => array(
                                        array('type' => 'sqlobject', 'required' => '1'), array('type' => 'lookup', 'fieldname' => 'FIELDNAME', 'tablename' => 'CLX_DB_FIELDS'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_OPERATOR',
                            'fields' => array(
                                array('name' => 'operator', 'type' => CLX_CLASS_LIST, 'options' => $this->operators)
                            )
                        ), array('label' => 'GEN_LBL_TABLECODE2',
                            'fields' => array(
                                array('name' => 'tablecode2', 'type' => 'lookup', 'default' => '', 'tool' => 'DBTB', 'validations' => array(
                                        array('type' => 'lookup', 'fieldname' => 'IDCODE', 'tablename' => 'CLX_DB_TABLES'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_FIELDNAME2',
                            'fields' => array(
                                array('name' => 'fieldname2', 'type' => 'lookup', 'default' => '', 'tool' => 'DBFL', 'validations' => array(
                                        array('type' => 'lookup', 'fieldname' => 'FIELDNAME', 'tablename' => 'CLX_DB_FIELDS'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_FIELD_VALUE',
                            'fields' => array(
                                array('name' => 'field_value', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '20', 'validations' => array(
                                        array('type' => 'string', 'required' => '0'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_MSG_ELEMENT',
                            'fields' => array(
                                array('name' => 'msg_element', 'type' => 'lookup', 'default' => '', 'tool' => 'SKME', 'validations' => array(
                                        array('type' => 'lookup', 'fieldname' => 'IDCODE', 'tablename' => 'CLX_SK_ELEMENTS'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_LOGICAL',
                            'fields' => array(
                                array('name' => 'logical', 'type' => CLX_CLASS_LIST, 'options' => $this->logicals)
                            )
                        ), array('label' => 'GEN_LBL_OPEN_BRACKET',
                            'fields' => array(
                                array('name' => 'open_bracket', 'type' => CLX_CLASS_LIST, 'options' => $this->open_bracket)
                            )
                        ), array('label' => 'GEN_LBL_CLOSE_BRACKET',
                            'fields' => array(
                                array('name' => 'close_bracket', 'type' => CLX_CLASS_LIST, 'options' => $this->close_bracket)
                            )
                        )
                    )
                )
            )
        );
        $this->viewform = $this->editform;
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['MAP_CODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['SEQNUM'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['TABLECODE1'] = array('type' => 'varchar(4)', 'null' => 'YES', 'properties' => '');
        $fields['FIELDNAME1'] = array('type' => 'varchar(64)', 'null' => 'YES', 'properties' => '');
        $fields['OPERATOR'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['TABLECODE2'] = array('type' => 'varchar(4)', 'null' => 'YES', 'properties' => '');
        $fields['FIELDNAME2'] = array('type' => 'varchar(64)', 'null' => 'YES', 'properties' => '');
        $fields['FIELD_VALUE'] = array('type' => 'varchar(64)', 'null' => 'YES', 'properties' => '');
        $fields['MSG_ELEMENT'] = array('type' => 'varchar(16)', 'null' => 'YES', 'properties' => '');
        $fields['LOGICAL'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['OPEN_BRACKET'] = array('type' => 'varchar(10)', 'null' => 'YES', 'properties' => '');
        $fields['CLOSE_BRACKET'] = array('type' => 'varchar(10)', 'null' => 'YES', 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'MUL', 'fieldname' => 'MAP_CODE,SEQNUM');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'TABLECODE1');
        $indexes[$ipf . '04'] = array('index' => 'MUL', 'fieldname' => 'FIELDNAME1');
        $indexes[$ipf . '05'] = array('index' => 'MUL', 'fieldname' => 'TABLECODE2');
        $indexes[$ipf . '06'] = array('index' => 'MUL', 'fieldname' => 'FIELDNAME2');
        $indexes[$ipf . '07'] = array('index' => 'MUL', 'fieldname' => 'MSG_ELEMENT');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
            'fields' => $fields,
            'indexes' => $indexes);
    }

    function unpack($parameters) {
        $parameters = array_values(array_merge(array('package' => null), $parameters));
        list($package) = $parameters;
        $record = $this->unpackRecord($package);
        $exists = (ClxCommon::$db->oneExistsRecords($this->tablename, 'MAP_CODE=' . singleQuote($record['MAP_CODE']) . ' AND SEQNUM=' . singleQuote($record['SEQNUM'])) > CLX_NUM_ZERO);
        if ($exists === true) {
            ClxCommon::$db->deleteRecords($this->tablename, 'MAP_CODE=' . singleQuote($record['MAP_CODE']) . ' AND SEQNUM=' . singleQuote($record['SEQNUM']));
        }
        $id = ClxCommon::$db->createRecord($this->tablename, $record, false);
        if ($package->hasSubObject($this->code . '_OBJECTS')) {
            $objs = $package->getObjectXml($this->code . '_OBJECTS');
            foreach ($objs->objects as $o) {
                $toolcode = $o->tag;
                $tool = getTool($toolcode);
                $tool->unpack(array('package' => $o, 'id' => $id));
            }
        }
    }

    function makepanel($map_code = null) {
        if ($this->getAccess()->canRead()) {
            $t = time();
            $to = $this->code;
            $here = 'tool.php?to=' . $to . '&t=' . $t;
            $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
            $form->setProp(CLX_PROP_ID, 'SKMCPanel');
            $form->addArgument(CLX_PROP_TO, $this->code);
            $form->addArgument('msg_code', $map_code);
            $form->addArgument('ac', 'NOT_DEFINED');
            $selectclause = '*';
            $fromclause = $this->tablename;
            $whereclause = 'MAP_CODE=' . singleQuote($map_code);
            $sortclause = 'SEQNUM';
            $page = new xPaging();
            $page->setProp('rpp', CLX_NUM_TEN_THOUSAND);
            $page->setProp('printheaders', false);
            $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
            $table = new htmlTable(CLX_WIDTH_NINE);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $page->header($table);
            $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_MAP_CODE'), dict('GEN_LBL_SEQNUM'), dict('GEN_LBL_FIELDNAME1'), dict('GEN_LBL_OPERATOR'), dict('GEN_LBL_FIELDNAME2'), dict('GEN_LBL_FIELD_VALUE'), dict('GEN_LBL_MSG_ELEMENT'), dict('GEN_LBL_LOGICAL')));
            $i = CLX_INIT_ZERO;
            while ($record = $page->nextRecord()) {
                $recordid = $record['ID'];
                $select = new htmlCheckbox('selector_' . $recordid, false);
                $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
                $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
                $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array($record['OPEN_BRACKET'] . ' ' . $record['MAP_CODE'], $record['SEQNUM'], $record['TABLECODE1'] . '.' . $record['FIELDNAME1'], dict($this->operators[$record['OPERATOR']]), $record['TABLECODE2'] . '.' . $record['FIELDNAME2'], $record['FIELD_VALUE'], $record['MSG_ELEMENT'] . ' ' . $record['CLOSE_BRACKET'], dict($this->logicals[$record['LOGICAL']])));
                $i++;
            }
            $buttons = '';
            $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_DISPLAY'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            if ($this->getAccess()->canModify()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            }
            if ($this->getAccess()->canDelete()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            }
            if ($this->getAccess()->canDisplay()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE_SOMETHING', dict('GEN_LBL_CRITERIA')), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
            }
            $form->addContents($page->footers($table, $buttons));
            return buildPanelInterface(dict('TOOL_SKMC_TITLE_LIST'), 'SK_MAPPINGS_' . $map_code, $form->source(), CLX_NUM_MINUS_1);
        } else {
            return CLX_CHAR_EMPTY_STRING;
        }
    }

    function confirmDeleteFill(&$table, $record) {
        $table->addData(dict('GEN_LBL_MAP_CODE') . ':', $record['SKMC_map_code']);
        $table->addData(dict('GEN_LBL_SEQNUM') . ':', $record['SKMC_seqnum']);
    }

    function loadToolRecord($recordid) {
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID= ' . $recordid);
        $record = array();
        $record['SKMC_id'] = $recordid;
        $record['SKMC_map_code'] = $values['MAP_CODE'];
        $record['SKMC_seqnum'] = $values['SEQNUM'];
        $record['SKMC_tablecode1'] = $values['TABLECODE1'];
        $record['SKMC_fieldname1'] = $values['FIELDNAME1'];
        $record['SKMC_operator'] = $values['OPERATOR'];
        $record['SKMC_tablecode2'] = $values['TABLECODE2'];
        $record['SKMC_fieldname2'] = $values['FIELDNAME2'];
        $record['SKMC_field_value'] = $values['FIELD_VALUE'];
        $record['SKMC_msg_element'] = $values['MSG_ELEMENT'];
        $record['SKMC_logical'] = $values['LOGICAL'];
        $record['SKMC_open_bracket'] = $values['OPEN_BRACKET'];
        $record['SKMC_close_bracket'] = $values['CLOSE_BRACKET'];
        return $record;
    }

    function saveRecord() {
        $record = array();
        $record['MAP_CODE'] = UserRequest::$post['SKMC_map_code'];
        $record['SEQNUM'] = UserRequest::$post['SKMC_seqnum'];
        $record['TABLECODE1'] = UserRequest::$post['SKMC_tablecode1'];
        $record['FIELDNAME1'] = UserRequest::$post['SKMC_fieldname1'];
        $record['OPERATOR'] = UserRequest::$post['SKMC_operator'];
        $record['TABLECODE2'] = UserRequest::$post['SKMC_tablecode2'];
        $record['FIELDNAME2'] = UserRequest::$post['SKMC_fieldname2'];
        $record['FIELD_VALUE'] = UserRequest::$post['SKMC_field_value'];
        $record['MSG_ELEMENT'] = UserRequest::$post['SKMC_msg_element'];
        $record['LOGICAL'] = UserRequest::$post['SKMC_logical'];
        $record['OPEN_BRACKET'] = UserRequest::$post['SKMC_open_bracket'];
        $record['CLOSE_BRACKET'] = UserRequest::$post['SKMC_close_bracket'];
        ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post['SKMC_id']);
        $this->versionIncrease('ID', UserRequest::$post['SKMC_id']);
    }

    function createRecord_() {
        $record = array();
        $record['MAP_CODE'] = UserRequest::$post['SKMC_map_code'];
        $record['SEQNUM'] = (UserRequest::$post['SKMC_seqnum'] > CLX_NUM_ZERO) ? UserRequest::$post['SKMC_seqnum'] : ClxCommon::$db->getField($this->tablename, 'MAX(SEQNUM)', 'MAP_CODE =  ' . singleQuote($record['MAP_CODE'])) + CLX_NUM_ONE;
        $record['TABLECODE1'] = UserRequest::$post['SKMC_tablecode1'];
        $record['FIELDNAME1'] = UserRequest::$post['SKMC_fieldname1'];
        $record['OPERATOR'] = UserRequest::$post['SKMC_operator'];
        $record['TABLECODE2'] = UserRequest::$post['SKMC_tablecode2'];
        $record['FIELDNAME2'] = UserRequest::$post['SKMC_fieldname2'];
        $record['FIELD_VALUE'] = UserRequest::$post['SKMC_field_value'];
        $record['MSG_ELEMENT'] = UserRequest::$post['SKMC_msg_element'];
        $record['LOGICAL'] = UserRequest::$post['SKMC_logical'];
        $record['OPEN_BRACKET'] = UserRequest::$post['SKMC_open_bracket'];
        $record['CLOSE_BRACKET'] = UserRequest::$post['SKMC_close_bracket'];
        $recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        $this->versionIncrease('ID', $recordid);
        return $recordid;
    }

    function deleteRecordSk($id) {
        $this->versionIncrease('ID', $id);
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
    }

    function defaultRecord() {
        $callingpage = peekHistory();
        $record = array();
        $record['SKMC_id'] = CLX_INIT_ZERO;
        $record['SKMC_map_code'] = $callingpage['map_code'];
        $record['SKMC_seqnum'] = '0';
        $record['SKMC_tablecode1'] = '';
        $record['SKMC_fieldname1'] = '';
        $record['SKMC_operator'] = '';
        $record['SKMC_tablecode2'] = '';
        $record['SKMC_fieldname2'] = '';
        $record['SKMC_field_value'] = '';
        $record['SKMC_field_value'] = '';
        $record['SKMC_msg_element'] = '';
        $record['SKMC_logical'] = '';
        $record['SKMC_open_bracket'] = '';
        $record['SKMC_close_bracket'] = '';
        return $record;
    }

    function versionIncrease($fieldname, $fieldvalue) {
        $map_code = ClxCommon::$db->getField($this->tablename, 'MAP_CODE', $fieldname . '=' . singleQuote($fieldvalue));
        $SKMP = &getTool('SKMP');
        $SKMP->versionIncrease('IDCODE', $map_code);
    }

    function buildOperator($operator, $fieldname, $value, $is_numeric = false) {
        ClxFreeReturn($is_numeric);
        if ($operator === 'EX') {
            return '(' . $value . ')';
        }
        foreach ($this->operators as $key => $val) {
            if ($operator == $key) {
                if ($operator === 'IN' || $operator === 'NI') {
                    $value = str_replace(',', '', '', $value);
                }
                if (is_numeric($value)) {
                    $value = str_replace('VALUE', $value, $val[CLX_NUM_ONE]);
                } else {
                    $value = str_replace('VALUE', singleQuote($value), $val[CLX_NUM_ONE]);
                }
                return $fieldname . ' ' . $value;
            }
        }
        return $fieldname . ' IS NULL ';
    }

}

// End class
