<?php

/**
/**
 * Application Form Listing Criterias Manager
 * For more information contact  support@alenet.com
 *
 * @package		Clientix.Tool.Interface
 * @abstract		User Interface - Form Listings
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version    	$Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Implementado status UPDATE CLX_UI_FORM_LISTINGS SET ACTIVE = 1
 */
class ui_form_listings extends clx_tool {

    /**
     * Contructor
     */
    function __construct() {
        $this->code = 'UIFL';
        $this->name = 'Form Listings';
        $this->system = 'Interface';
        $this->version = '0.2.4.1';

        $this->accesskey = 'UIFM';


        $this->tablename = 'CLX_UI_FORM_LISTINGS';
        $this->record_name_singular = 'form listing';
        $this->record_name_plural = 'form listings';
        $this->primary_field = 'FORMCODE';
        $this->secondary_field = 'LISTINGCODE';
        $this->seqnum_field = 'SEQNUM';
        $this->primary_key = array('FORMCODE', 'LISTINGCODE');
        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_DBDR_TITLE_MODIFY',
            'panels' => array(
                array('type' => 'normal',
                    CLX_CLASS_TITLE => 'GEN_LBL_TABLEPRMTS',
                    'entries' => array(
                        array('label' => 'GEN_LBL_FORMCODE',
                            'fields' => array(
                                array('name' => 'formcode', 'type' => 'lookup', 'tool' => 'UIFM', 'readonly' => true, 'validations' => array(
                                        array('type' => 'lookup', 'fieldname' => 'IDCODE', 'tablename' => 'CLX_UI_FORMS'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_LISTINGCODE',
                            'fields' => array(
                                array('name' => 'listingcode', 'type' => 'lookup', 'tool' => 'UILG', 'validations' => array(
                                        array('type' => 'string', 'required' => '1'), array('type' => 'lookup', 'fieldname' => 'IDCODE', 'tablename' => 'CLX_UI_LISTING'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_ACTIVE',
                            'fields' => array(
                                array('name' => 'active', 'type' => CLX_CLASS_LIST, 'options' => $this->yesno)
                            )
                        ), array('label' => 'GEN_LBL_RELFORMCODE',
                            'fields' => array(
                                array('name' => 'relformcode', 'type' => 'lookup', 'tool' => 'UIFM', 'validations' => array(
                                        array('type' => 'lookup', 'fieldname' => 'IDCODE', 'tablename' => 'CLX_UI_FORMS'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_RELLINKLIST',
                            'fields' => array(
                                array('name' => 'rellinklist', 'type' => 'lookup', 'tool' => 'UILG', 'validations' => array(
                                        array('type' => 'lookup', 'fieldname' => 'IDCODE', 'tablename' => 'CLX_UI_LISTING'))
                                )
                            )
                        )
                    )
                )
            )
        );
        $this->viewform = $this->editform;
    }
    function action($ac, $idlist) {
        $msg = null;
        $formcode = null;
        $formrec = null;
        $tablecode = null;
        $tablerec = null;
        $continue = null;
        $contents = '';
        $next_action = $_SESSION ['prefs'] ['NEXT_ACTION'];
        if ($this->getAccess()->canRead()) {
            switch ($ac) {
                case 'CREATE':
                    if ($this->getAccess()->canDisplay()) {
                        if (isset(UserRequest::$post['confirm'])) {
                            if ($this->checkForm($msg)) {
						       $this->createRecordVoid_();
                                $info = popHistory();
                                $contents = executeHistory($info);
                            } else {
							//	echo "-----2-----------";
     
                                $contents = $this->editForm($ac, array(), UserRequest::$post, $msg);
                            }
                        } else {
                            $record = $this->defaultRecord();
						
                             $contents = $this->editForm($ac, array(), $record, $msg);
                        }
                    } else {
                        $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [CLX_TOOL-CAN_APPEND][' . $ac . '] ' . $this->getCode(false));
                    }
                    break;
                    
                  
				default :
                        $contents = parent::action($ac, $idlist);
            }
        } else {
            $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [EDIT-CAN_READ_3][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    /**
     * Describes the tool table structure.
     * @return array ('type' => 'varchar(255)', 'properties'=>'auto increment',
     * 				'index'=>'', default = '', 'dict'=>true)
     * 				 dict true or false means that field holds dictionary entry
     */
    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
		$fields['FORMCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['LISTINGCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['SEQNUM'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['ACTIVE'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => '1', 'properties' => '');
        $fields['RELFORMCODE'] = array('type' => 'varchar(16)', 'null' => 'YES', 'properties' => '');
        $fields['RELLINKLIST'] = array('type' => 'varchar(16)', 'null' => 'YES', 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'MUL', 'fieldname' => 'FORMCODE');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'LISTINGCODE');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB', 'fields' => $fields, 'indexes' => $indexes);
    }

    //-- F O R M     L I S T I N G S

    /**
     * Pack tool record on xml Format
     * @param array record
     * @return obj
     */
    function pack($record) {
        $o = $this->packRecord($record);
        $objs = new XMLObject($this->code . '_OBJECTS');
        $this->packsub($objs, 'UIFI', 'SELECT * FROM CLX_UI_FORM_LISTING_CRITS WHERE FORMLISTINGID=' . singleQuote($record['ID']));
        $o->addObject($objs);
        return $o;
    }

    /**
     * Loads package into system
     * @param string $package
     */
    function unpack($parameters) {
        $parameters = array_values(array_merge(array('package' => null, 'id' => null), $parameters));
        list($package, $formid) = $parameters;
        $record = $this->unpackRecord($package);
        $record['FORMCODE'] = uppercase($record['FORMCODE']);
        $record['LISTINGCODE'] = uppercase($record['LISTINGCODE']);
		//echo "UIFL";
		//pre($record);
		$recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);
		//echo "id";
		//pre($recordid);
        if ($package->hasSubObject($this->code . '_OBJECTS')) {
			if (empty($recordid)) {
			$recordid=ClxCommon::$db->getOne("select id from ".$this->tablename." WHERE FORMCODE= " . singlequote($record['FORMCODE'])." AND LISTINGCODE=  " . singlequote($record['LISTINGCODE']));
			//echo "buscando otro recordid";
			//pre($recordid);
			}
            $objs = $package->getObjectXml($this->code . '_OBJECTS');
            foreach ($objs->objects as $o) {
                $toolcode = $o->tag;
                $tool = &getTool($toolcode);
                $tool->unpack(array('package' => $o, 'id' => $recordid));
            }
        }
    }

    /**
     * Builds Panel listing on tool
     *
     * @param string $groupcode
     * @return string
     */
    function makepanel($formcode = null) {
        if ($this->getAccess()->canRead()) {
            $t = time();
            $to = $this->code;
            $here = 'tool.php?to=' . $to . '&t=' . $t;
            $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
            $form->setProp(CLX_PROP_ID, 'UIFLPanel');
            $form->addArgument(CLX_PROP_TO, $this->code);
            $form->addArgument('formcode', $formcode);
            $form->addArgument('ac', 'NOT_DEFINED');
            $selectclause = '*';
            $fromclause = 'CLX_UI_FORM_LISTINGS';
            $whereclause = 'FORMCODE=' . singleQuote($formcode);
            $sortclause = 'SEQNUM';
            $page = new xPaging();
            $page->setProp('rpp', CLX_NUM_TEN_THOUSAND);
            $page->setProp('printheaders', false);
            $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
            $table = new htmlTable(CLX_WIDTH_SIX);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $page->header($table);
            $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_LISTING'), dict('GEN_LBL_CRITERIA'), dict('GEN_LBL_ACTIVE'), dict('GEN_LBL_RELFORMCODE'), dict('GEN_LBL_RELLINKLIST')));
            $i = CLX_INIT_ZERO;
            while ($record = $page->nextRecord()) {
                $recordid = $record['ID'];
                $select = new htmlCheckbox('selector_' . $recordid, false);
                $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
        		$table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
		       //CHECK IF DYNAMIC RELATION
                $sql = 'SELECT  COUNT(DBDR.ID) QTY FROM  CLX_DB_DYNRELATIONS DBDR, CLX_UI_FORM_LISTINGS UIFL, CLX_UI_FORMS UIFM, CLX_UI_LISTINGS UILG WHERE  UIFM.TABLECODE = DBDR.PARENT_TABLECODE AND UILG.TABLECODE = DBDR.CHILD_TABLECODE AND UIFM.IDCODE = UIFL.FORMCODE AND UIFL.LISTINGCODE = UILG.IDCODE AND DBDR.RELATION_TYPE = 0 AND DBDR.ACTIVE = 1 AND UIFL.FORMCODE = ' . singleQuote($formcode);
                $is_dynamic_rel = (ClxCommon::$db->getOne($sql) === CLX_NUM_ONE) ? true : false;
                $criterias = ClxCommon::$db->getRecords('CLX_UI_FORM_LISTING_CRITS', 'FORMLISTINGID=' . $recordid);
                $list = '';
                $boolean = '';
                if ($is_dynamic_rel === true) {
                    $list .= dict('TOOL_DBDR_TITLE_VIEW') . ' ';
                }
                while (($criteria = ClxCommon::$db->getNextRecord($criterias))) {
                    $list .= $boolean . $criteria['FIELDNAME1'] . ' = ' . $criteria['FIELDNAME2'];
                    $boolean = ' AND ';
                }
                $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array($record['LISTINGCODE'], $list, dict($this->yesno[$record['ACTIVE']]), $record['RELFORMCODE'], $record['RELLINKLIST']));
                $i++;
            }
            $buttons = '';
            $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_DISPLAY'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            if ($this->getAccess()->canModify()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            }
            if ($this->getAccess()->canDelete()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            }
            if ($this->getAccess()->canDisplay()) {
                $b = new htmlFormSubmit(dict('GEN_LBL_INCLUDE_SOMETHING', dict('GEN_LBL_LISTING')), 'CREATE', $form->getProp(CLX_PROP_ID));
                $b->setProp(CLX_PROP_ID, 'ON');
                $buttons .= $b->source();
            }
            if (($page->getProp('qty') > CLX_NUM_ONE) && $this->getAccess()->canModify()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_REORDER'), array('action' => 'REORDER', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
            }
            $form->addContents($page->footers($table, $buttons));
            return buildPanelInterface(dict('TOOL_UIFL_TITLE_LIST'), $formcode . 'LISTINGS', $form->source(), CLX_NUM_MINUS_1);
        } else {
            return CLX_CHAR_EMPTY_STRING;
        }
    }

    /**
     * Verify Tool Edit Forms
     * @param array $msg
     * @return bool
     */
    function checkForm(&$msg) {
        $msg = array();
        $UILG = &getTool('UILG');
        if (!$UILG->listingExists(UserRequest::$post['UIFL_listingcode'])) {
            $msg['UIFL_listingcode'] = dict('GEN_ERR_LISTING_DOES_NOT_EXISTS');
        }

        //RELLINKLIST
        if (!empty(UserRequest::$post['UIFL_rellinklist']) && !$UILG->listingExists(UserRequest::$post['UIFL_rellinklist'])) {
            $msg['UIFL_rellinklist'] = dict('GEN_ERR_LISTING_DOES_NOT_EXISTS');
        }

        //check form code
        if (!empty(UserRequest::$post['UIFL_relformcode'])) {
            $UIFM = &getTool('UIFM');
            if (!$UIFM->formExists(UserRequest::$post['UIFL_relformcode'])) {
                $msg['UIFL_relformcode'] = dict('TOOL_UILG_ERR_NOFORMCODE');
            }
        }
        return count($msg) == CLX_NUM_ZERO;
    }

    /**
     * Builds confirm delete form for tool
     * @param obj $table
     * @param array $record
     */
    function confirmDeleteFill(&$table, $record) {
        $table->addData(dict('GEN_LBL_LISTING') . ':', $record['UIFL_listingcode']);
    }

    /**
     * Build display form contents
     * @param array $record
     * @return string
     */
    function viewFormFill($record) {
        addHistory('fl', $record['UIFL_id']);
        $contents = parent::viewFormFill($record);
        $UIFI = &getTool('UIFI');
        $contents .= $UIFI->makepanel($record['UIFL_id']);
        return $contents;
    }

    /**
     * Creates reorder list
     * @return string
     */
    function reorderRecords() {
        $records = ClxCommon::$db->getRecords($this->tablename, 'FORMCODE=' . singleQuote(UserRequest::$post['formcode']) . ' ORDER BY SEQNUM');
        $list = array();
        while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
            $list[$record['ID']] = $record['LISTINGCODE'];
        }
        return $list;
    }

    /**
     * Performs reorder record action
     */
    function reorderAction() {
        parent::reorderAction();
        $callingpage = peekHistory();
        $formcode = $callingpage['formcode'];
        $UIFM = &getTool('UIFM');
        $UIFM->versionIncrease('IDCODE', $formcode);
    }

    /**
     * Loads current record on selected id
     *
     * @param integer $id
     * @return array
     */
    function loadToolRecord($recordid) {
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID= ' . $recordid);
        $record = array();
        $record['UIFL_id'] = $recordid;
        $record['UIFL_formcode'] = $values['FORMCODE'];
        $record['UIFL_listingcode'] = $values['LISTINGCODE'];
        $record['UIFL_seqnum'] = $values['SEQNUM'];
        $record['UIFL_active'] = $values['ACTIVE'];
        $record['UIFL_relformcode'] = $values['RELFORMCODE'];
        $record['UIFL_rellinklist'] = $values['RELLINKLIST'];
        return $record;
    }

    /**
     * Update records
     *
     * @return integer
     */
    function saveRecord() {
        $record = array();
        $record['FORMCODE'] = UserRequest::$post['UIFL_formcode'];
        $record['LISTINGCODE'] = UserRequest::$post['UIFL_listingcode'];
        $record['ACTIVE'] = UserRequest::$post['UIFL_active'];
        $record['RELFORMCODE'] = UserRequest::$post['UIFL_relformcode'];
        $record['RELLINKLIST'] = UserRequest::$post['UIFL_rellinklist'];

	    ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post['UIFL_id']);
        $UIFM = &getTool('UIFM');
        $UIFM->versionIncrease('IDCODE', UserRequest::$post['UIFL_formcode']);
    }

    /**
     * Creates record
     *
     * @return integer
     */
    function createRecord_() {
		$record = array();
        $record['FORMCODE'] = UserRequest::$post['UIFL_formcode'];
        $record['LISTINGCODE'] = UserRequest::$post['UIFL_listingcode'];
        $record['SEQNUM'] = ClxCommon::$db->getField($this->tablename, 'SEQNUM', 'FORMCODE=' . singleQuote(UserRequest::$post['UIFL_formcode']) . ' ORDER BY SEQNUM DESC') + CLX_NUM_ONE;
        $record['ACTIVE'] = UserRequest::$post['UIFL_active'];
        $record['RELFORMCODE'] = UserRequest::$post['UIFL_relformcode'];
        $record['RELLINKLIST'] = UserRequest::$post['UIFL_rellinklist'];
        $recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        $UIFM = &getTool('UIFM');
        $UIFM->versionIncrease('IDCODE', UserRequest::$post['UIFL_formcode']);
        //Loading Relation from table Relation if exists 
        ClxCommon::$db->deleteRecords('CLX_UI_FORM_LISTING_CRITS', 'FORMLISTINGID = ' . $recordid);
        //Creating Relations if exists
        $sql = 'SELECT DBDC.* FROM  CLX_DB_DYNRELATIONS DBDR, CLX_DB_DYNRELATION_COLS DBDC, CLX_UI_LISTINGS UILG, CLX_UI_FORMS UIFM WHERE DBDR.PARENT_TABLECODE = DBDC.PARENT_TABLECODE AND DBDR.CHILD_TABLECODE = DBDC.CHILD_TABLECODE AND DBDC.PARENT_TABLECODE = UIFM.TABLECODE AND UILG.TABLECODE = DBDC.CHILD_TABLECODE AND DBDR.ACTIVE = 1 AND DBDR.RELATION_TYPE = 1 AND UIFM.IDCODE = ' . singleQuote(UserRequest::$post['UIFL_formcode']) . ' AND UILG.IDCODE = ' . singleQuote(UserRequest::$post['UIFL_listingcode']) . '                 ORDER BY  DBDC.SEQNUM ASC';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $rel = array('FORMLISTINGID' => $recordid, 'FIELDNAME1' => $r['CHILD_TABLECODE'] . '.' . $r['CHILD_FIELD'], 'FIELDNAME2' => $r['PARENT_TABLECODE'] . '_' . $r['PARENT_FIELD'], 'OPERATOR' => 'EQ');
            ClxCommon::$db->createRecord('CLX_UI_FORM_LISTING_CRITS', $rel, false);
        }
        return $recordid;
    }

    /**
     * Deletes record on selected id
     *
     * @param integer $id
     */
    function deleteRecordSk($id) {
        $record = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $id);
        ClxCommon::$db->deleteRecords('CLX_UI_FORM_LISTING_CRITS', 'FORMLISTINGID=' . $id);
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
        $UIFM = &getTool('UIFM');
		if (isset( $record['FORMCODE']))
			$UIFM->versionIncrease('IDCODE', $record['FORMCODE']);
    }

    /**
     * Defines default record on initializacion
     *
     * @return array
     */
    function defaultRecord() {
        $callingpage = peekHistory();
        $record = array();
        $record['UIFL_id'] = '';
        $record['UIFL_formcode'] = $callingpage['formcode'];
		$record['UIFL_listingcode'] = '';
        $record['UIFL_seqnum'] = '';
        $record['UIFL_active'] = '1';
        $record['UIFL_relformcode'] = '';
        $record['RELLINKLIST'] = '';
        return $record;
    }

    /**
     * Increase tool version
     * @param string $fieldname
     * @param string $fieldvalue
     */
    function versionIncrease($fieldname, $fieldvalue) {
        $formcode = ClxCommon::$db->getField($this->tablename, 'FORMCODE', $fieldname . '=' . singleQuote($fieldvalue));
        $UIFM = &getTool('UIFM');
        $UIFM->versionIncrease('IDCODE', $formcode);
    }

}
