<?php

/**
 * Menu item manager
 * For more information contact  support@alenet.com
 *
 * @author      $Author: fsantana $
 * @copyright   Alenet, Inc.
 * @since       $Date:  10:41:59 -0430 (Thu, 23 Jun 2011) $
 * @version    	$Rev: 2531 $
 *
 * CHANGE LOGS
 * -  Oracle uppercase record changed
 * -  Incorporado idcode a la herramienta de menu para actualizar
 * ALTER TABLE CLX_UI_MENUITEMS ,ADD COLUMN `IDCODE` VARCHAR (16)   NOT null  AFTER `ID`;
 * UPDATE CLX_UI_MENUITEMS SET IDCODE = ID;
 * alter table `CLX_UI_MENUITEMS` ,add column `ACTIVE` tinyint (1)  DEFAULT '1' NOT null  after `NAME`
 * -  Se actualiza la herramientas de menus para resolver prolemas con el parent
 * - Debe copiarse la herramienta, auditarla y luego aplicar el siguiente sql
 * alter table CLX_UI_MENUITEMS, change PARENT PARENT varchar (16)  DEFAULT '0' NOT null;
 * SELECT
 * CONCAT(CONCAT(CONCAT(CONCAT('UPDATE CLX_UI_MENUITEMS SET PARENT = '",
 * (SELECT X.IDCODE FROM CLX_UI_MENUITEMS X WHERE A.PARENT = X.ID)),
 *  '' WHERE IDCODE = ''),A.IDCODE),);') UP
 *  FROM CLX_UI_MENUITEMS A
 *  WHERE EXISTS (SELECT X.IDCODE FROM CLX_UI_MENUITEMS X WHERE A.PARENT = X.ID)
 */
class ui_masks_crit extends clx_tool {

    /**
     * Verify window string
     * @var string
     */
    var $window_strings;
    var $ops = array();

    /**
     * Constructor
     */
    function __construct() {
        $this->code = 'UIMC';
        $this->name = 'Masks Criteria Manager';
        $this->system = 'Interface';
        $this->version = '5.5.0.0';

        $this->has_access = true;
        $this->has_package = true;

        $this->tablename = 'CLX_UI_MASKS_CRIT';
        $this->record_name_singular = 'criteria';
        $this->record_name_plural = 'criteria';
        $this->primary_field = 'ID';
        $this->secondary_field = 'IDNAME';
        $this->sortclause = 'IDNAME';
        $this->primary_key = array('ID');
        $this->operators = array('EQ' => array('GEN_OPE_EQUAL', '==='),
            'EX' => array('GEN_OPE_EXAC_EQUAL', '==='),
            'NQ' => array('GEN_OPE_NOTEQUAL', '!== '),
            'LS' => array('GEN_OPE_LESS', '<'),
            'GT' => array('GEN_OPE_GREATER', '>'), 'LQ' => array('GEN_OPE_GREATER_EQUAL', '>='), 'GQ' => array('GEN_OPE_LESS_EQUAL', '<=')
        );
        foreach ($this->operators as $key => $val) {
            $this->ops[$key] = $val[CLX_NUM_ZERO];
        }
        $this->ui_masks_crit_cont();
        $this->editform = $this->viewform;
        $this->toolpanelkeys = array(array('name' => 'MASKCODE', 'type' => 'string'));
        $this->toolpanel = array('name' => $this->tablename, CLX_CLASS_TITLE => $this->record_name_plural, 'has_reorder' => true,
            'fields' =>
            array(array('name' => 'ID', 'type' => 'number'), array('name' => 'IDNAME', 'type' => 'string', 'label' => 'GEN_LBL_IDNAME'), array('name' => 'MASKFORMAT', 'type' => 'string', 'label' => 'GEN_LBL_MASKFORMAT'), array('name' => 'FIELDNAME1', 'type' => 'string', 'label' => 'GEN_LBL_MAIN_FIELDNAME'), array('name' => 'OPERATOR', 'type' => CLX_CLASS_LIST, 'options' => $this->ops), array('name' => 'FIELDNAME2', 'type' => 'string', 'label' => 'GEN_LBL_FIELDNAME'), array('name' => 'VALUE', 'type' => 'string')), 'buttons' =>
            array(array('access' => 'DISPLAY',
                    'tool' => 'has_create',
                    'library' => 'GEN_LBL_ADD_AND',
                    'name' => 'AND',
                    'prop' => 'ONE'
                )
            )
        );
        $this->toollist = $this->toolpanel;
    }

    function ui_masks_crit_cont() {
        $this->viewform = array(CLX_CLASS_TITLE => 'TOOL_UIMC0_TITLE_DISPLAY',
            'panels' => array(
                array('type' => 'normal',
                    'entries' => array(
                        array('label' => 'GEN_LBL_MASKCODE',
                            'fields' => array(array('name' => 'maskcode', 'type' => 'string', 'readonly' => true))
                        ), array('label' => 'GEN_LBL_NAME',
                            'fields' => array(
                                array('name' => 'idname',
                                    'type' => 'string',
                                    'default' => '',
                                    'size' => '64',
                                    'displaysize' => '48',
                                    'validations' => array(array('type' => 'string', 'required' => '1'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_MAIN_FIELDNAME',
                            'fields' => array(
                                array('name' => 'fieldname1',
                                    'type' => 'lookup',
                                    'default' => '',
                                    'tool' => 'DBFL',
                                    'validations' => array(
                                        array('type' => 'lookup', 'fieldname' => 'FIELDNAME', 'tablename' => 'CLX_DB_FIELDS', 'required' => '1')
                                    )
                                )
                            )
                        ), array('label' => 'GEN_LBL_OPERATOR',
                            'fields' => array(array('name' => 'operator', 'type' => CLX_CLASS_LIST, 'options' => $this->ops)
                            )
                        )
                    )
                ), array('type' => 'normal',
                    CLX_CLASS_TITLE => 'GEN_LBL_CONDITION',
                    'entries' => array(
                        array('label' => 'GEN_LBL_FIELDNAME',
                            'fields' => array(
                                array('name' => 'fieldname2',
                                    'type' => 'lookup',
                                    'default' => '',
                                    'tool' => 'DBFL',
                                    'validations' => array(
                                        array('type' => 'lookup', 'fieldname' => 'FIELDNAME', 'tablename' => 'CLX_DB_FIELDS',
                                            'required' => '0')
                                    )
                                )
                            )
                        ), array('label' => 'GEN_LBL_VALUE',
                            'caption' => 'GEN_LBL_OR',
                            'fields' => array(
                                array('name' => 'value', 'type' => 'string', 'size' => '64', 'displaysize' => '32',
                                    'default' => '')
                            )
                        )
                    )
                ), array('type' => 'normal',
                    CLX_CLASS_TITLE => 'GEN_LBL_DEF_MASKFORMAT',
                    'caption' => 'GEN_LBL_MASK_HELP',
                    'entries' => array(
                        array('label' => 'GEN_LBL_DEF_MASKFORMAT',
                            'fields' => array(
                                array('name' => 'maskformat',
                                    'type' => 'string',
                                    'default' => '',
                                    'size' => '64',
                                    'displaysize' => '48',
                                    'validations' => array(array('type' => 'string', 'required' => '0'))
                                )
                            )
                        )
                    )
                ), array('type' => 'normal',
                    CLX_CLASS_TITLE => 'GEN_LBL_RECORD_OPTIONS',
                    'cols' => CLX_NUM_FOUR,
                    'entries' => array(
                        array('label' => 'GEN_LBL_CDATE',
                            'fields' => array(
                                array('name' => 'cdate',
                                    'type' => 'dati',
                                    'dontmodify' => '1',
                                    'displaysize' => '35',
                                    'readonly' => true,
                                    'validations' => array(array('type' => 'string')
                                    )
                                )
                            )
                        ), array('label' => 'GEN_LBL_CREATEDBY',
                            'fields' => array(
                                array('name' => 'createdby',
                                    'type' => 'lookup',
                                    'default' => '',
                                    'readonly' => true,
                                    'tool' => 'ACUS',
                                    'validations' => array(
                                        array('type' => 'lookup', 'fieldname' => 'username', 'tablename' => 'CLX_AC_USERS')
                                    )
                                )
                            )
                        ), array('label' => 'GEN_LBL_MDATE',
                            'fields' => array(
                                array('name' => 'mdate',
                                    'type' => 'dati',
                                    'displaysize' => '35',
                                    'dontmodify' => '1',
                                    'readonly' => true,
                                    'validations' => array(array('type' => 'string'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_MODIFIEDBY',
                            'fields' => array(
                                array('name' => 'modifiedby',
                                    'type' => 'lookup',
                                    'default' => '',
                                    'readonly' => true,
                                    'tool' => 'ACUS',
                                    'validations' => array(
                                        array('type' => 'lookup', 'fieldname' => 'username', 'tablename' => 'CLX_AC_USERS')
                                    )
                                )
                            )
                        )
                    )
                )
            )
        );
    }

    /**
     * Describes the tool table structure.
     * @return array ('type' => 'varchar(255)', 'properties'=>'auto increment',
     * 				'index'=>'', default = '', 'dict'=>true)
     * 				 dict true or false means that field holds dictionary entry
     */
    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['IDNAME'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '', 'dict' => true);
        $fields['MASKCODE'] = array('type' => 'varchar(30)', 'null' => 'NO');
        $fields['MASKFORMAT'] = array('type' => 'varchar(64)', 'null' => 'NO');
        $fields['FIELDNAME1'] = array('type' => 'varchar(64)', 'null' => 'NO');
        $fields['OPERATOR'] = array('type' => 'varchar(4)', 'null' => 'NO', 'default' => singleQuote('EQ'), 'default_raw' => 'EQ');
        $fields['FIELDNAME2'] = array('type' => 'varchar(64)', 'null' => 'YES');
        $fields['VALUE'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES');
        $fields['MDATE'] = array('type' => 'datetime', 'null' => 'YES');
        $fields['CREATEDBY'] = array('type' => 'varchar(30)', 'null' => 'NO');
        $fields['MODIFIEDBY'] = array('type' => 'varchar(30)', 'null' => 'NO');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'MASKCODE');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
            'fields' => $fields,
            'indexes' => $indexes);
    }

    /**
     * Pack tool record on xml Format
     * @param array record
     * @return obj
     */
    function pack($record) {
        $o = $this->packRecord($record);
        $id = $record['ID'];
        $objs = new XMLObject($this->code . '_OBJECTS');
        if (ClxCommon::$db->oneExistsRecords('CLX_UI_MENUITEMS', 'PARENT=' . singleQuote($record['ID'])) > CLX_NUM_ZERO) {
            $this->packsub($objs, $this->code, 'SELECT * FROM CLX_UI_MENUITEMS WHERE UPPER(PARENT)=' . singleQuote(uppercase($record['IDCODE'])));
            //Packing Dictionary
            if (ClxCommon::$db->oneExistsRecords('CLX_DICTIONARY DICT, CLX_UI_MENUITEMS X', 'DICT.ENTRY=X.NAME AND UPPER(X.PARENT)=' . singleQuote(uppercase($record['IDCODE']))) > CLX_NUM_ZERO) {
                $this->packsub($objs, 'DICT', 'SELECT DICT.* FROM CLX_DICTIONARY DICT, CLX_UI_MENUITEMS X WHERE DICT.ENTRY=X.NAME AND UPPER(X.PARENT)=' . singleQuote(uppercase($record['IDCODE'])));
            }
        }
        //Packing Dictionary
        $this->packsub($objs, 'DICT', 'SELECT DICT.* FROM CLX_DICTIONARY DICT, ' . $this->tablename . ' X WHERE DICT.ENTRY=X.IDNAME AND X.ID=' . singleQuote($id));
        $o->addObject($objs);
        return $o;
    }

    /**
     * Loads package into system
     * @param string $package
     */
    function unpack($parameters) {
        $parameters = array_values(array_merge(array('package' => null, 'id' => CLX_NUM_ZERO), $parameters));
        list($package, $parent) = $parameters;
        $record = $this->unpackRecord($package);
        unset($record['ID']);
        if (ClxCommon::$db->oneExistsRecords($this->tablename, 'ID=' . singleQuote($record['ID'])) > CLX_NUM_ZERO) {
            ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . singleQuote($record['ID']));
        } else {
            ClxCommon::$db->createRecord($this->tablename, $record, false);
        }
        if ($package->hasSubObject($this->code . '_OBJECTS')) {
            $objs = $package->getObjectXml($this->code . '_OBJECTS');
            foreach ($objs->objects as $o) {
                $toolcode = $o->tag;
                $tool = &getTool($toolcode);
                $tool->unpack(array('package' => $o, 'id' => $record['PARENT']));
            }
        }
    }

    /**
     * Action is called for every user interaction with the module...
     *
     * @param string $ac
     * @param string $idlist
     * @return string
     */
    function action($ac, $idlist) {
        if ($this->getAccess()->canRead()) {
            switch ($ac) {
                case 'AND':
                    $contents = $this->addAnd($idlist);
                    break;
                default:
                    $contents = parent::action($ac, $idlist);
                    break;
            }
        } else {
            $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [UI_MASKS_CRIT-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    /**
     * Build display form contents
     * @param array $record
     * @return string
     */
    function viewFormFill($record) {
        $contents = '';
        addHistory('maskcode', $record['UIMC_idcode']);
        return $contents;
    }

    /**
     * Verify Tool Edit Forms
     * @param array $msg
     * @return bool
     */
    function checkForm(&$msg) {
        $UIMA = getTool('UIMA');
        $result = parent::checkForm($msg);
        $sql = 'SELECT * FROM ' . $UIMA->tablename . ' WHERE UPPER(IDCODE)=' . singleQuote(uppercase(UserRequest::$post['UIMC_maskcode'])) . ';';
        $result = ClxCommon::$db->executeQuery($sql);
        while (($record = ClxCommon::$db->getNextRecord($result))) {
            if (!empty($record['TABLECODE'])) {
                $DBTF = getTool('DBTF');
                $sql = 'SELECT ID FROM ' . $DBTF->tablename . ' WHERE UPPER(TABLECODE) =' . singleQuote(uppercase($record['TABLECODE'])) . ' AND UPPER(FIELDNAME)=' . singleQuote(uppercase(UserRequest::$post['UIMC_fieldname1'])) . ';';
                $result = ClxCommon::$db->executeQuery($sql);
                if (!($result = ClxCommon::$db->getNextRecord($result))) {
                    $msg['UIMC_fieldname1'] = dict('GEN_LBL_WRONG_TABLE_MSG');
                }
                if (!empty(UserRequest::$post['UIMC_fieldname2'])) {
                    $sql = 'SELECT ID FROM ' . $DBTF->tablename . ' WHERE UPPER(TABLECODE) =' . singleQuote(uppercase($record['TABLECODE'])) . ' AND UPPER(FIELDNAME)=' . singleQuote(uppercase(UserRequest::$post['UIMC_fieldname2'])) . ';';
                    $result = ClxCommon::$db->executeQuery($sql);
                    if (!($result = ClxCommon::$db->getNextRecord($result))) {
                        $msg['UIMC_fieldname2'] = dict('GEN_LBL_WRONG_TABLE_MSG');
                    }
                }
            }
        }
        if (empty(UserRequest::$post['UIMC_fieldname2']) && UserRequest::$post['UIMC_value'] === '') {
            $msg['UIMC_fieldname2'] = dict('GEN_LBL_EMPTY_MSG');
        } else {
            if (!empty(UserRequest::$post['UIMC_fieldname2']) && !(UserRequest::$post['UIMC_value'] === '')) {
                $msg['UIMC_fieldname2'] = dict('GEN_LBL_EMPTY_MSG');
            }
        }
        if (!empty(UserRequest::$post['UIMC_value']) && (UserRequest::$post['UIMC_operator'] !== 'EQ' && UserRequest::$post['UIMC_operator'] !== 'EX')) {
            if (!is_numeric(UserRequest::$post['UIMC_value'])) {
                $msg['UIMC_value'] = dict('GEN_LBL_MUST_NUM');
            }
        }
        return $result && (count($msg) == CLX_NUM_ZERO);
    }

    /**
     * Return operator
     * @param string $op
     * @return array
     */
    function getOperator($op) {
        return $this->operators[$op][CLX_NUM_ONE];
    }

    /**
     * Defines default record on initializacion
     *
     * @return array
     */
    function defaultRecord() {
        $callingpage = peekHistory();
        $record = parent::defaultRecord();
        $record['UIMC_maskcode'] = $callingpage['maskcode'];
        if (!empty(UserRequest::$post['AND'])) {
            $record['UIMC_idname'] = UserRequest::$post['record']['IDNAME'];
            $record['UIMC_maskformat'] = UserRequest::$post['record']['MASKFORMAT'];
            $this->editform['panels'][CLX_NUM_ZERO]['entries'][CLX_NUM_ONE]['fields'][CLX_NUM_ZERO]['readonly'] = true;
            $this->editform['panels'][CLX_NUM_TWO]['entries'][CLX_NUM_ZERO]['fields'][CLX_NUM_ZERO]['readonly'] = true;
        }
        return $record;
    }

    /**
     * Return add condition
     * @param $idlist
     * @return string
     */
    function addAnd($idlist) {
        UserRequest::$post['AND'] = true;
        $sql = 'SELECT * FROM ' . $this->tablename . ' WHERE ID = ' . $idlist[CLX_NUM_ZERO] . ';';
        $result = ClxCommon::$db->executeQuery($sql);
        $record = ClxCommon::$db->getNextRecord($result);
        UserRequest::$post['record'] = $record;
        $contents = parent::action('CREATE', $idlist);
        return $contents;
    }

}
