<?php

/**
 * Pages Object Criterias Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version      $Rev: 9615 $
 *
 * CHANGE LOG
 *  Included label
 */
class ui_page_row_objects_crits extends clx_tool {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'UIPC';
        $this->name = 'Page object criterias';
        $this->system = 'Interface';
        $this->version = '0.5.1.0';
        $this->accesskey = 'UIFM';



        $this->tablename = 'CLX_UI_PAGE_OBJ_CRITS';
        $this->record_name_singular = 'criteria';
        $this->record_name_plural = 'criterias';
        $this->primary_field = 'OBJECTID';
        $this->secondary_field = 'QRY_FIELDNAME';
        $this->operators = array('EQ' => array('GEN_OPE_EQUAL', '=VALUE')
        );
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['OBJECTID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['QRY_FIELDNAME'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '');
        $fields['FRM_FIELDNAME'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '');
        $fields['OPERATOR'] = array('type' => 'varchar(4)', 'null' => 'NO', 'default' => '' . singleQuote('E') . '', 'default_raw' => 'EQ', 'properties' => '');
        $fields['VALUE'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'MUL', 'fieldname' => 'OBJECTID');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'QRY_FIELDNAME');
        $indexes[$ipf . '04'] = array('index' => 'MUL', 'fieldname' => 'FRM_FIELDNAME');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
            'fields' => $fields,
            'indexes' => $indexes);
    }

//-- F O R M    P A N E L    F I E L D S
    function unpack($parameters) {
        $parameters = array_values(array_merge(array('package' => null, 'id' => null), $parameters));
        list($package, $objectid) = $parameters;
        $record = $this->unpackRecord($package);
        $record['OBJECTID'] = $objectid;
        $record['QRY_FIELDNAME'] = uppercase($record['QRY_FIELDNAME']);
        $record['FRM_FIELDNAME'] = uppercase($record['FRM_FIELDNAME']);
        ClxCommon::$db->createRecord($this->tablename, $record, false);
    }

    function makepanel($groupcode = null) {
        if ($this->getAccess()->canRead()) {
            $t = time();
            $to = $this->code;
            $here = 'tool.php?to=' . $to . '&t=' . $t;
            $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
            $form->setProp(CLX_PROP_ID, 'UIPCPanel');
            $form->addArgument(CLX_PROP_TO, $this->code);
            $form->addArgument('panelid', $groupcode);
            $form->addArgument('ac', 'NOT_DEFINED');
            $selectclause = '*';
            $fromclause = $this->tablename;
            $whereclause = 'OBJECTID = ' . $groupcode;
            $sortclause = '';
            $page = new xPaging();
            $page->setProp('rpp', CLX_NUM_TEN_THOUSAND);
            $page->setProp('printheaders', false);
            $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
            $table = new htmlTable(CLX_WIDTH_FIVE);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $page->header($table);
            $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_QRY_FIELDNAME'), dict('GEN_LBL_OPERATOR'), dict('GEN_LBL_FRM_FIELDNAME'), dict('GEN_LBL_VALUE')));
            $i = CLX_INIT_ZERO;
            while ($record = $page->nextRecord()) {
                $recordid = $record['ID'];
                $select = new htmlCheckbox('selector_' . $recordid, false);
                $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
                $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
                $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array(
                    $record['QRY_FIELDNAME'], dict($this->operators[$record['OPERATOR']][CLX_NUM_ZERO]), $record['FRM_FIELDNAME'], $record['value']));
                $i++;
            }
            $buttons = '';
            if ($this->getAccess()->canModify()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            }
            if ($this->getAccess()->canDisplay()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE'), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
            }
            if ($this->getAccess()->canDelete()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            }
            $form->addContents($page->footers($table, $buttons));
            $modulecode = '';
            return buildPanelInterface(dict('TOOL_UIPC_TITLE_LIST'), $modulecode . 'TABLES', $form->source(), CLX_NUM_MINUS_1);
        } else {
            return CLX_CHAR_EMPTY_STRING;
        }
    }

    function editForm($ac, $idlist, $record, $msg) {
        $modify = (UserRequest::$request['ac'] === 'MODIFY');
        if (empty($modify)) {
            $callingpage = peekHistory();
            $record['UIPC_objectid'] = $callingpage['idrow'];
            unset($callingpage);
        }
        // Query Fields -------------------------
        $sql = 'SELECT DISTINCT CONCAT(CONCAT(DBTB.IDCODE, ' .singleQuote('.'). '), DBTF.FIELDNAME) FIELDCODE FROM CLX_UI_PAGES UIPG, CLX_UI_PAGE_ROWS UIPR, CLX_AN_PLOT ANPL, CLX_DB_QUERY_TABLES DBQT, CLX_DB_TABLES DBTB, CLX_DB_TABLEFIELDS DBTF, CLX_UI_PAGE_OBJECTS UIPO WHERE UIPG.IDCODE = UIPR.PAGECODE AND ANPL.QUERYCODE = DBQT.QUERYCODE AND DBTB.IDCODE = DBQT.TABLECODE AND DBTB.IDCODE = DBTF.TABLECODE AND UIPR.ID = UIPO.IDROW AND ANPL.IDCODE = UIPO.OBJECTCODE AND UIPO.ID = ' . $record['UIPC_objectid'] . ' AND UIPO.TOOLCODE = ' . singleQuote('ANPL') . ' UNION SELECT DISTINCT CONCAT(CONCAT(DBTB.IDCODE, ' . singleQuote('.') . '), DBTF.FIELDNAME) FIELDCODE FROM CLX_UI_PAGES UIPG, CLX_UI_PAGE_ROWS UIPR, CLX_UI_LISTINGS ANPL, CLX_DB_QUERY_TABLES DBQT, CLX_DB_TABLES DBTB, CLX_DB_TABLEFIELDS DBTF, CLX_UI_PAGE_OBJECTS UIPO WHERE UIPG.IDCODE = UIPR.PAGECODE AND ANPL.QUERYCODE = DBQT.QUERYCODE AND DBTB.IDCODE = DBQT.TABLECODE AND DBTB.IDCODE = DBTF.TABLECODE AND UIPR.ID = UIPO.IDROW AND ANPL.IDCODE = UIPO.OBJECTCODE AND UIPO.ID = ' . $record['UIPC_objectid'] . ' AND UIPO.TOOLCODE = ' . singleQuote('UILG') . ' UNION SELECT DISTINCT CONCAT(CONCAT(DBTB.IDCODE, ' . singleQuote('.') . '), DBTF.FIELDNAME) FIELDCODE FROM CLX_UI_PAGES UIPG, CLX_UI_PAGE_ROWS UIPR, CLX_UI_FORMS UIFM, CLX_DB_TABLES DBTB, CLX_DB_TABLEFIELDS DBTF, CLX_UI_PAGE_OBJECTS UIPO WHERE UIPG.IDCODE = UIPR.PAGECODE AND DBTB.IDCODE = DBTF.TABLECODE AND UIFM.TABLECODE = DBTB.IDCODE AND UIPR.ID = UIPO.IDROW AND UIFM.IDCODE = UIPO.OBJECTCODE AND UIPO.ID = ' . $record['UIPC_objectid'] . ' AND UIPO.TOOLCODE = ' . singleQuote('UIFM') . ' ORDER BY FIELDCODE';
        $fields = ClxCommon::$db->executeQuery($sql);
        $queryfields = new htmlSelect($this->code . '_qry_fieldname');
        while (($field = ClxCommon::$db->getNextRecord($fields))) {
            $queryfields->addItem($field['FIELDCODE'], $field['FIELDCODE'], ($field['FIELDCODE'] == $record[$this->code . '_qry_fieldname']));
        }
        // Form Fields -------------------------
        $sql = 'SELECT CASE WHEN UIFF.TABLECODE IS NULL THEN CONCAT(CONCAT(UIFM.TABLECODE, ' .singleQuote('.'). '), UIFF.FIELDNAME) ELSE CONCAT(CONCAT(UIFF.TABLECODE, ' . singleQuote('.') . '), UIFF.FIELDNAME) END FIELDNAME, CASE WHEN UIFF.TABLECODE IS NULL THEN CONCAT(CONCAT(UIFM.TABLECODE, ' . singleQuote('_') . '), UIFF.FIELDNAME) ELSE CONCAT(CONCAT(UIFF.TABLECODE, ' . singleQuote('_') . '), UIFF.FIELDNAME) END FIELDCODE FROM CLX_UI_FORMS UIFM, CLX_UI_FORM_PANELS UIFP, CLX_UI_FORM_PANEL_FIELDS UIFF, CLX_UI_PAGE_ROWS UIPR, CLX_UI_PAGE_OBJECTS UIPO WHERE UIFM.IDCODE=UIFP.FORMCODE AND UIFF.PANELID = UIFP.ID AND UIFM.IDCODE = UIPO.OBJECTCODE AND UIPR.ID = UIPO.IDROW AND UIPO.TOOLCODE = ' . singleQuote('UIFM') . ' AND UIPO.FORM_ACTION = ' . singleQuote('QFILTER') . ' AND UIPR.PAGECODE IN (SELECT X.PAGECODE FROM CLX_UI_PAGE_ROWS X, CLX_UI_PAGE_OBJECTS Y WHERE X.ID = Y.IDROW AND Y.ID = ' . $record['UIPC_objectid'] . ')';
        $fields = ClxCommon::$db->executeQuery($sql);
        $formfields = new htmlSelect($this->code . '_frm_fieldname');
        $formfields->addItem('', '', (empty($record[$this->code . '_frm_fieldname'])));
        while (($field = ClxCommon::$db->getNextRecord($fields))) {
            $formfields->addItem($field['fieldname'], $field['FIELDCODE'], ($field['FIELDCODE'] == $record[$this->code . '_frm_fieldname']));
        }
        //The listing
        $title = ($modify) ? dict('TOOL_UIPC_TITLE_MODIFY') : dict('TOOL_UIPC_TITLE_CREATE');
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', $ac);
        $form->addArgument('confirm', '1');
        $form->addArgument($this->code . '_id', $record[$this->code . '_id']);
        $form->addArgument('idlist', toString($idlist));
        $form->addArgument($this->code . '_objectid', $record[$this->code . '_objectid']);
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell($title, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        if (!empty($msg[$this->code . '_qry_fieldname']))
            $table->addCell($msg[$this->code . '_qry_fieldname'], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => $table->width));
        $table->addData(dict('TOOL_UIFI_PROMPT_QUERYFIELD') . ':', $queryfields->source());
        // The operators
        $pop = new HTMLSelect($this->code . '_operator');
        foreach ($this->operators as $key => $value) {
            $pop->addItem(dict($value[CLX_NUM_ZERO]), $key, ($key == $record[$this->code . '_operator']));
        }
        $table->addData(dict('GEN_LBL_OPERATORS') . ':', $pop->source());
        $field = new htmlTextArea('UIPC_value', $record['UIPC_value'], CLX_NUM_7, CLX_NUM_50);
        if (!empty($msg[$this->code . '_frm_fieldname']))
            $table->addCell($msg[$this->code . '_frm_fieldname'], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => $table->width));
        $table->addData(dict('TOOL_UIFI_PROMPT_FORMFIELDORVALUE') . ':', $formfields->source() . '<br>' . dict('GEN_LBL_OR') . '<br>' . $field->source());
        $form->addContents($table->source());
        $buttons = '';
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_SAVE'), array('action' => $ac, 'form' => $form->getProp(CLX_PROP_ID)))->source();
        $c = new htmlButtonCancel();
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->addContents($table->source());
        return $form->source();
    }

    function checkForm(&$msg) {
        $msg = array();
        if (strlen(UserRequest::$post[$this->code . '_qry_fieldname']) == CLX_NUM_ZERO) {
            $msg[$this->code . '_qry_fieldname'] = dict('GEN_ERR_REQUIRED');
        }
        if (strlen(UserRequest::$post[$this->code . '_frm_fieldname']) == CLX_NUM_ZERO && strlen(UserRequest::$post[$this->code . '_value']) == CLX_NUM_ZERO) {
            $msg[$this->code . '_frm_fieldname'] = dict('GEN_ERR_REQUIRED');
        }
        if (strlen(UserRequest::$post[$this->code . '_objectid']) == CLX_NUM_ZERO) {
            $msg[$this->code . '_objectid'] = dict('GEN_ERR_REQUIRED');
        }
        return count($msg) == CLX_NUM_ZERO;
    }

    function confirmDeleteFill(&$table, $record) {
        $table->addData(dict('TOOL_UIFI_PROMPT_QUERYFIELD') . ':', $record[$this->code . '_qry_fieldname']);
        $table->addData(dict('TOOL_UIFI_PROMPT_FORMFIELD') . ':', $record[$this->code . '_frm_fieldname']);
    }

    function loadToolRecord($recordid) {
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID= ' . $recordid);
        $record = array();
        $record['UIPC_id'] = $recordid;
        $record['UIPC_objectid'] = $values['OBJECTID'];
        $record['UIPC_qry_fieldname'] = $values['QRY_FIELDNAME'];
        $record['UIPC_operator'] = $values['OPERATOR'];
        $record['UIPC_frm_fieldname'] = $values['FRM_FIELDNAME'];
        $record['UIPC_value'] = $values['value'];
        return $record;
    }

    function createRecord_() {
        $record = array();
        $record['OBJECTID'] = UserRequest::$post['UIPC_objectid'];
        $record['QRY_FIELDNAME'] = UserRequest::$post['UIPC_qry_fieldname'];
        $record['FRM_FIELDNAME'] = UserRequest::$post['UIPC_frm_fieldname'];
        $record['OPERATOR'] = UserRequest::$post['UIPC_operator'];
        $record['value'] = UserRequest::$post['UIPC_value'];
        $id = ClxCommon::$db->createRecord($this->tablename, $record, false);
        $this->versionIncrease('ID', $id);
    }

    function saveRecord() {
        $record = array();
        $record['QRY_FIELDNAME'] = UserRequest::$post['UIPC_qry_fieldname'];
        $record['FRM_FIELDNAME'] = UserRequest::$post['UIPC_frm_fieldname'];
        $record['OPERATOR'] = UserRequest::$post['UIPC_operator'];
        $record['value'] = UserRequest::$post['UIPC_value'];
        ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post['UIPC_id']);
        $this->versionIncrease('ID', UserRequest::$post['UIPC_id']);
    }

    function deleteRecordSk($id) {
        $this->versionIncrease('ID', $id);
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
    }

    function defaultRecord() {
        $record = array();
        $record['UIPC_id'] = CLX_INIT_ZERO;
        $record['UIPC_objectid'] = CLX_INIT_ZERO;
        $record['UIPC_qry_fieldname'] = '';
        $record['UIPC_frm_fieldname'] = '';
        $record['UIPC_operator'] = 'EQ';
        $record['UIPC_value'] = '';
        return $record;
    }

    function versionIncrease($fieldname, $fieldvalue) {
        $objectid = ClxCommon::$db->getField($this->tablename, 'OBJECTID', $fieldname . '=' . singleQuote($fieldvalue));
        $UIPR = &getTool('UIPR');
        $UIPR->versionIncrease('ID', $objectid);
    }

    function buildOperator($operator, $fieldname, $value, $is_numeric = false) {
        if ($operator === 'EX') {
            return '(' . $value . ')';
        }
        foreach ($this->operators as $key => $val) {
            if ($operator == $key) {
                if ($operator === 'IN' || $operator === 'NI') {
                    $value = str_replace(',', '' . singleQuote(CLX_CHAR_EMPTY_STRING) . '', $value);
                }
                if (is_numeric($value)) {
                    $value = str_replace('VALUE', $value, $val[CLX_NUM_ONE]);
                } else {
                    $value = str_replace('VALUE', singleQuote($value), $val[CLX_NUM_ONE]);
                }
                return $fieldname . ' ' . $value;
            }
        }
        unset($is_numeric);
        return $fieldname . ' IS NULL ';
    }

    /**
     * Replace record entry for new on criterias.
     *
     * @param array $record
     * @param array $criterias
     * @return array
     */
    function buildRecordOperator(&$record, $criterias) {
        //[QRY_FIELDNAME] => FIAT.CHART_FIELD01
        //[FRM_FIELDNAME] => JELN_CHART_FIELD01
        //[OPERATOR] => EQ [VALUE] => )
        $has_value = (strlen($criterias['VALUE']) > CLX_NUM_ZERO);
        switch ($criterias['OPERATOR']) {
            case 'EQ':
                if ($has_value === true) {
                    $record[$criterias['FRM_FIELDNAME']] = $criterias['VALUE'];
                } else {
                    $criterias['QRY_FIELDNAME'] = str_replace('.', '_', $criterias['QRY_FIELDNAME']);
                    $record[$criterias['QRY_FIELDNAME']] = $record[$criterias['FRM_FIELDNAME']];
                    unset($record[$criterias['FRM_FIELDNAME']], $record[$criterias['FRM_FIELDNAME'] . '_prim'], $record[$criterias['FRM_FIELDNAME'] . '_secd'], $record[$criterias['FRM_FIELDNAME'] . '_terc']);
                }
                break;
            default:
                break;
        }//end switch
    }

}
