<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Included label
 */
class us_shortcuts extends clx_tool {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'USSH';
        $this->name = 'Shortcut Manager';
        $this->system = 'User';
        $this->version = '0.1.0.0';

        $this->has_access = true;


        $this->tablename = 'CLX_US_SHORTCUTS';
        $this->record_name_singular = 'menu item';
        $this->record_name_plural = 'menu items';
        $this->primary_field = 'NAME';
        $this->secondary_field = 'DESCRIPTION';
        $this->seqnum_field = 'SEQNUM';
        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_DBTB_TITLE_CREATE',
            'panels' => array(
                array('type' => 'normal',
                    'entries' => array(
                        array('label' => 'GEN_LBL_NAME',
                            'fields' => array(
                                array('name' => 'name', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '48', 'validations' => array(array('type' => 'string', 'required' => '1'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_DESCRIPTION',
                            'fields' => array(
                                array('name' => 'description', 'type' => 'text', 'default' => '', 'rows' => '4', 'cols' => '48'))
                        ), array('label' => 'GEN_LBL_TYPE',
                            'fields' => array(
                                array('name' => 'type', 'type' => 'objects', 'default' => (array_key_exists('USSH_type', UserRequest::$post)) ? UserRequest::$post['USSH_type'] : '', 'objects' => 'USSH')
                            )
                        ), array('label' => 'GEN_LBL_ACCESS',
                            'fields' => array(array('name' => 'access', 'type' => CLX_CLASS_LIST, 'default' => 'private',
                                    'options' => array('1' => 'GEN_LBL_PUBLIC', '0' => 'GEN_LBL_PRIVATE'
                                    )
                                )
                            )
                        ), array('label' => 'GEN_LBL_ICON',
                            'fields' => array(
                                array('name' => 'icon', 'type' => 'file'))
                        )
                    )
                )
            )
        );
    }

    function install() {
        $UIMI = getTool('UIMI');
        $UIMI->add($this->code, 'MENU_PERSONAL_INFORMATION:MENU_SHORTCUTS', 'TOOL', $this->code, 'ac=LIST');
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['NAME'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '');
        $fields['DESCRIPTION'] = array('type' => 'mediumtext', 'properties' => '');
        $fields['USERNAME'] = array('type' => 'varchar(30)', 'null' => 'YES', 'properties' => '');
        $fields['TYPE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['ACCESSES'] = array('type' => 'tinyint(1)', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['TOOLCODE'] = array('type' => 'varchar(4)', 'null' => 'YES', 'properties' => '');
        $fields['ICON'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['EXTRA1'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $fields['EXTRA2'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $fields['EXTRA3'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $fields['EXTRA4'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $fields['EXTRA5'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $fields['SEQNUM'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['PARENT'] = array('type' => 'int(11)', 'null' => 'YES', 'properties' => '');
        $fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['MDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['VERSION'] = array('type' => 'varchar(32)', 'null' => 'YES', 'properties' => '', 'default' => '0');
        $fields['VERSION_COUNTER'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['MODULECODE'] = array('type' => 'varchar(4)', 'null' => 'YES', 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'MUL', 'fieldname' => 'NAME');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'USERNAME');
        $indexes[$ipf . '04'] = array('index' => 'MUL', 'fieldname' => 'TYPE');
        $indexes[$ipf . '05'] = array('index' => 'MUL', 'fieldname' => 'TOOLCODE');
        $indexes[$ipf . '06'] = array('index' => 'MUL', 'fieldname' => 'MODULECODE');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
            'fields' => $fields,
            'indexes' => $indexes);
    }

//-- S H O  R  T C U T S
    function makelist($listingcode = null) {
        ClxFreeReturn($listingcode);
        $t = time();
        $to = $this->code;
        $here = 'tool.php?to=' . $to . '&t=' . $t;
        clearHistory();
        pushHistory($this->code, 'LIST', array());
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->setProp(CLX_PROP_ID, 'USSHList');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'NOT_DEFINED');
        $selectclause = '*';
        $fromclause = 'CLX_US_SHORTCUTS';
        $whereclause = '';
        $sortclause = '';
        $page = new xPaging();
        $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
        $table = new htmlTable(CLX_WIDTH_7);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_USSH_TITLE_LIST'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_7));
        $page->header($table);
        $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_NAME'), dict('GEN_LBL_DESCRIPTION'), dict('GEN_LBL_USERNAME'), dict('GEN_LBL_TYPE'), dict('GEN_LBL_ACCESS'), dict('GEN_LBL_ICON')));
        $i = CLX_INIT_ZERO;
        while ($record = $page->nextRecord()) {
            $recordid = $record['ID'];
            $select = new htmlCheckbox('selector_' . $recordid, false);
            $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
            $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
            if ($record['ICON'] > CLX_NUM_ZERO) {
                $image = '<img src="window.php?to=SDFL&ac=SHOW_FILE&ff=' . $record['ICON'] . '">';
            } else {
                $image = CLX_CHAR_HTML_NBSP;
            }
            // Print out words instead of 0 or 1 for 'Access'
            if ($record['ACCESSES'] == CLX_NUM_ZERO) {
                $access_type = 'Private';
            }
            if ($record['ACCESSES'] == CLX_NUM_ONE) {
                $access_type = 'Public';
            }
            $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array($record['name'], $record['DESCRIPTION'], $record['USERNAME'], $record['TYPE'], $access_type, $image));
            $i++;
        }
        $buttons = '';
        $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_DISPLAY'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        if ($this->getAccess()->canModify()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canDelete()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canDisplay()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE_SOMETHING', dict('GEN_LBL_SHORTCUT')), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        }
        $form->addContents($page->footers($table, $buttons));
        return $form->source();
    }

    function checkForm(&$msg) {
        $form = new clx_form($this->code, $this->editform);
        $result = $form->checkForm1(UserRequest::$post['ac'], UserRequest::$post, $msg);
        $path = basename(realpath(UserRequest::$files['USSH_icon']['tmp_name']));
        if ((fopen($path, 'r')) === false) {
            $msg['USSH_icon'] = dict('GEN_ERR_CANT_OPEN_FILE');
        }
        return $result;
    }

    function confirmDeleteFill(&$table, $record) {
        $table->addData(dict('GEN_LBL_NAME') . ':', $record['USSH_name']);
        $table->addData(dict('GEN_LBL_TYPE') . ':', $record['USSH_type']);
    }

    function viewFormFill($record) {
        addHistory('parent', $record['USSH_id']);
        $contents = '';
        // Headers
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_USSH_TITLE_VIEW'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addData(dict('GEN_LBL_NAME') . ':', $record['USSH_name']);
        $table->addData(dict('GEN_LBL_DESCRIPTION') . ':', $record['USSH_description']);
        $table->addData(dict('GEN_LBL_USERNAME') . ':', $record['USSH_username']);
        $table->addData(dict('GEN_LBL_TYPE') . ':', $record['USSH_type']);
        $table->addData(dict('GEN_LBL_ACCESS') . ':', $record['USSH_access']);
        $table->addData(dict('GEN_LBL_ICON') . ':', $record['USSH_icon']);
        $contents .= $table->source();
        return $contents;
    }

    function loadToolRecord($recordid) {
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $recordid);
        $record = array();
        $record['USSH_id'] = $recordid;
        $record['USSH_name'] = $values['name'];
        $record['USSH_description'] = $values['DESCRIPTION'];
        $record['USSH_username'] = $values['USERNAME'];
        $record['USSH_type'] = $values['TYPE'];
        $record['USSH_access'] = $values['ACCESSES'];
        $record['USSH_icon'] = $values['ICON'];
        $record['USSH_extra1'] = $values['EXTRA1'];
        $record['USSH_extra2'] = $values['EXTRA2'];
        return $record;
    }

    function saveRecord() {
        // get the file object (for deleting / saving)
        $SDFL = &getTool('SDFL');
        $record = array();
        $record['name'] = UserRequest::$post['USSH_name'];
        $record['DESCRIPTION'] = UserRequest::$post['USSH_description'];
        $record['TYPE'] = UserRequest::$post['USSH_type'];
        $record['ACCESSES'] = UserRequest::$post['USSH_access'];
        $record['EXTRA1'] = '';
        $record['EXTRA2'] = '';
        $recordid = UserRequest::$post['USSH_id'];
        // if the icon is set, we want to modify it
        if (strlen(UserRequest::$files['USSH_icon']['tmp_name']) != CLX_NUM_ZERO) {
            ClxCommon::$db_rec = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $recordid);
            if (ClxCommon::$db_rec['ICON'] != CLX_NUM_ZERO) {
                $SDFL->deleteRecordSk(ClxCommon::$db_rec['ICON']);  // delete old icon blob from database
            }
            if (UserRequest::$files['USSH_icon']['error'] === '0') {  // create new icon
                $contents = file_get_contents(UserRequest::$files['USSH_icon']['tmp_name']);
                $record['ICON'] = $SDFL->saveFile(UserRequest::$files['USSH_icon']['tmp_name'], UserRequest::$files['USSH_icon']['type'], $contents);
            } else {
                $record['ICON'] = UserRequest::$post['USSH_icon'];
            }
        }
        // update the record
        ClxCommon::$db->updateRecord($this->tablename, $record, 'ID= ' . $recordid);
        return $recordid;
    }

    function createRecord_() {
        $record = array();
        $record['name'] = UserRequest::$post['USSH_name'];
        $record['DESCRIPTION'] = UserRequest::$post['USSH_description'];
        $record['USERNAME'] = $_SESSION['user_record']['username'];
        $record['TYPE'] = UserRequest::$post['USSH_type'];
        $record['ACCESSES'] = UserRequest::$post['USSH_access'];
        $record['EXTRA1'] = '';
        $record['EXTRA2'] = '';
        if (UserRequest::$files['USSH_icon']['error'] === '0') {
            $contents = file_get_contents(UserRequest::$files['USSH_icon']['tmp_name'], 'r');
            $SDFL = &getTool('SDFL');
            $record['ICON'] = $SDFL->saveFile(UserRequest::$files['USSH_icon']['tmp_name'], UserRequest::$files['USSH_icon']['type'], $contents);
            fclose($contents);
        }
        $recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        return $recordid;
    }

    function deleteRecordSk($id) {
        // delete icon blob from database
        $record = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $id);
        if ($record['ICON'] != CLX_NUM_ZERO) {
            $SDFL = &getTool('SDFL');
            $SDFL->deleteRecordSk($record['ICON']);
        }
        // delete record of shortcut
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
    }

    function defaultRecord() {
        $record = array();
        $record['USSH_id'] = CLX_INIT_ZERO;
        $record['USSH_name'] = '';
        $record['USSH_description'] = '';
        $record['USSH_username'] = '';
        $record['USSH_type'] = '';
        $record['USSH_access'] = '';
        $record['USSH_icon'] = '';
        $record['USSH_extra1'] = '';
        $record['USSH_extra2'] = '';
        return $record;
    }

}
