<?php
/**
* Default Home Page
* For more information contact  support@alenet.com
*
* @author       $Author: cramirez $
* @copyright    Alenet, Inc.
* @since        $Date: 2017-08-08 10:38:19 -0400 (Tue, 08 Aug 2017) $
* @version    	$Rev: 9454 $
*/
require "includes/constants.php";
require "includes/includes.php";
PrepareConstants();
ConnectToDatabase();
initTools();

includeCodeLib("COMP");

$ACUS = &getTool("ACUS");
$ACUS->login();

if(empty($_SESSION["hasUser"])) exit(0);

//recalculo de transaccion de credito
if(!empty($_GET['fiat_cred_up']) && $_GET['fiat_cred_up']==1){

    //required parameters: fiat_cred_up=1, loan_code, ppal_pay, trans_amt, efftdate, currency_code, transtbl_code
    //sample xrate.php?fiat_cred_up=1&loan_code=000608&ppal_pay=0&trans_amt=0&efftdate=2013-11-11&currency_code=USD&transtbl_code=SYS_CRED-DISB
    if (!class_exists('Fiat'))
            includeCodeLib('FIAT');
    $response = array();
    $fiat = new Fiat();
    $record = array('FIAT_LOAN_CODE'=>$_GET['loan_code'], 'FIAT_EFFTDATE'=>$_GET['efftdate'], 'FIAT_TRANS_AMT'=>$_GET['trans_amt'], 'FIAT_CURRENCY_CODE'=>$_GET['currency_code'], 'FIAT_TRANSTBL_CODE'=>$_GET['transtbl_code'], 'FIAT_PAY_APPLIES_TO'=>$_GET['pay_app']);
    #var_dump($record);
    $fiat->loadCreditOperationRecord($record['FIAT_LOAN_CODE'], $record['FIAT_TRANSTBL_CODE'], $record['FIAT_EFFTDATE'], $record);
    if(!empty($record)){
        #var_dump($record);die;
        $response['FIAT_TRANS_AMT'] =$record['FIAT_TRANS_AMT'];
        $response['FIAT_PRINCIPAL_PAY'] =$record['FIAT_PRINCIPAL_PAY'];
        $response['FIAT_INTEREST_PAY'] = $record['FIAT_INTEREST_PAY'];
        $response['FIAT_TAX_AMT'] = (!empty($record['FIAT_TAX_AMT']))?$record['FIAT_TAX_AMT']:0;
        for($i=1; $i<=5; $i++){
            $response['FIAT_FEE_0'.$i.'_PAY'] = (!empty($record['FIAT_FEE_0'.$i.'_PAY']))?$record['FIAT_FEE_0'.$i.'_PAY']:0;
            $response['FIAT_TAX_0'.$i.'_AMT'] = (!empty($record['FIAT_TAX_0'.$i.'_AMT']))?$record['FIAT_TAX_0'.$i.'_AMT']:0;
        }
    }
   // ob_clean();
    echo json_encode($response);
    exit(0);
}

if(empty($_GET['COMP_CODE']) || empty($_GET['BASE_CURRENCY']) || empty($_GET['EFFTDATE'])) exit(0);
$comp_code = $_GET['COMP_CODE'];
$currency_code = $_GET['BASE_CURRENCY'];
$efftdate = $_GET['EFFTDATE'];
//$tobase = isset($_GET['TOBASE']) ? $_GET['TOBASE'] : '1';

/*Array
(
    $record["EFFTDATE"] => 2014-09-30
    $record["BASE_CURRENCY"] => USD
    $record["FOREIGN_CURRENCY"] => COR
    $record["EXCHANGE_RT"] => 26.273300
    $record["CUR_OPERATOR"] => 1
)*/
 $contents = '';
$a = new Comp();
$record = $a->comp_current_exchange($comp_code, $currency_code, $efftdate, true);
//$record = $a->comp_current_exchange($comp_code, $currency_code, $efftdate, ($tobase == '1'));
if(!empty($record)){
    $contents = '<?xml version="1.0"?><xml to="DBQY" qy="CURR_GL_JS">'.
        '<CURR_GL_JS RNUM="0">'.
        '<CURR_CLX_EFFTDATE RNUM="0" TBL="CURR" WRK="0">'.$record["EFFTDATE"].'</CURR_CLX_EFFTDATE>'.
        '<CURR_EXCHANGE_RT RNUM="1" TBL="CURR" WRK="0">'.rounder($record["EXCHANGE_RT"],6).'</CURR_EXCHANGE_RT>'.
        '<CURR_CUR_OPERATOR RNUM="2" TBL="CURR" WRK="0">'.$record["CUR_OPERATOR"].'</CURR_CUR_OPERATOR>'.
        '<CURR_BASE_CURRENCY RNUM="3" TBL="CURR" WRK="0">'.$record["BASE_CURRENCY"].'</CURR_BASE_CURRENCY>'.
        '<CURR_FOREIGN_CURRENCY RNUM="4" TBL="CURR" WRK="0">'.$record["FOREIGN_CURRENCY"].'</CURR_FOREIGN_CURRENCY>'.
        '<CURR_COMP_CURRENCY RNUM="4" TBL="CURR" WRK="0">'.$record["COMP_CURRENCY"].'</CURR_COMP_CURRENCY>'.
    '</CURR_GL_JS>'.
    '</xml>';
}
header('Content-type: text/xml');
header("Content-Disposition: inline; filename=temp.xml");
header("Pragma: no-cache");
header("Expires: 0");
header("Cache-control: private");
echo  $contents;
?>