<?php

/**
 * General ClxAccess
 * For more information contact  support@alenet.com
 *
 * @author       $Author: imrsnik $
 * @copyright    Alenet, Inc.
 * @since        $Date:  08:54:57 -0400 (Thu, 18 Jun 2015) $
 * @version        $Rev: 5921 $
 *
 * CHANGE LOG
 *  Included label
 */
class ClxAccess {

    private $type = '';
    private $canread = CLX_NUM_ZERO;
    private $canmodify = CLX_NUM_ZERO;
    private $candelete = CLX_NUM_ZERO;
    private $canappend = CLX_NUM_ZERO;
    private $display = CLX_NUM_ZERO;
    private $isadmin = CLX_NUM_ZERO;

    function __construct($type) {
        $this->setType($type);
    }

    /**
     * Retur type
     * @return type
     */
    public function getType() {
        return $this->type;
    }


    public function getCanread() {
        return $this->canread;
    }

    public function getCanmodify() {
        return $this->canmodify;
    }

    public function getCandelete() {
        return $this->candelete;
    }

    public function getCanappend() {
        return $this->canappend;
    }

    public function getDisplay() {
        return $this->display;
    }

    public function getIsadmin() {
        return $this->isadmin;
    }

    public function canRead() {
        return ($this->getCanread() === CLX_NUM_ONE) ? true : false;
    }

    public function canModify() {
        return ($this->getCanmodify() === CLX_NUM_ONE) ? true : false;
    }

    public function canDelete() {
        return ($this->getCandelete() === CLX_NUM_ONE) ? true : false;
    }

    public function canAppend() {
        return ($this->getCanappend() === CLX_NUM_ONE) ? true : false;
    }

    public function canDisplay() {
        return ($this->getDisplay() === CLX_NUM_ONE) ? true : false;
    }

    public function isAdmin() {
        return ($this->getIsadmin() === CLX_NUM_ONE) ? true : false;
    }

    public function setType($type) {
        $this->type = intval($type);
    }

    public function setCanread($canread) {
        $this->canread = $canread;
    }

    public function setCanmodify($canmodify) {
        $this->canmodify = ($canmodify === CLX_NUM_ONE) ? CLX_NUM_ONE : CLX_NUM_ZERO;
    }

    public function setCandelete($candelete) {
        $this->candelete = ($candelete === CLX_NUM_ONE) ? CLX_NUM_ONE : CLX_NUM_ZERO;
    }

    public function setCanappend($canappend) {
        $this->canappend = ($canappend === CLX_NUM_ONE) ? CLX_NUM_ONE : CLX_NUM_ZERO;
    }

    public function setDisplay($display) {
        $this->display = ($display === CLX_NUM_ONE) ? CLX_NUM_ONE : CLX_NUM_ZERO;
    }

    /**
     * Set isadmin
     * @param int $isadmin
     */
    public function setIsadmin($isadmin) {
        $this->isadmin = ($isadmin === CLX_NUM_ONE) ? CLX_NUM_ONE : CLX_NUM_ZERO;
    }

    /**
     * Set all users
     * @param type $canread
     * @param type $canmodify
     * @param type $candelete
     * @param type $canappend
     * @param type $display
     * @param type $isadmin
     */
    public function setUserAccess($canread, $canmodify, $candelete, $canappend, $display, $isadmin) {
        $this->setCanread($canread);
        $this->setCanmodify($canmodify);
        $this->setCandelete($candelete);
        $this->setCanappend($canappend);
        $this->setDisplay($display);
        $this->setIsadmin($isadmin);
    }

    /**
     * Set admin user
     */
    public function setAdminUser() {
        $this->setCanread(CLX_NUM_ONE);
        $this->setCanmodify(CLX_NUM_ONE);
        $this->setCandelete(CLX_NUM_ONE);
        $this->setCanappend(CLX_NUM_ONE);
        $this->setDisplay(CLX_NUM_ONE);
        $this->setIsadmin(CLX_NUM_ONE);
    }

    /**
     * Set no access
     */
    public function setNoAccess() {
        $this->setCanread(CLX_NUM_ZERO);
        $this->setCanmodify(CLX_NUM_ZERO);
        $this->setCandelete(CLX_NUM_ZERO);
        $this->setCanappend(CLX_NUM_ZERO);
        $this->setDisplay(CLX_NUM_ZERO);
        $this->setIsadmin(CLX_NUM_ZERO);
    }

    /**
     * Checks user access by type
     * @param type $accesstype
     * @return boolean
     */
    public function checkUserAccessByType($accesstype){

        if($this->isAdmin()){
		  $return = $this->isAdmin();
        }elseif($accesstype === 'canread'){
		  $return = $this->canread();
        }elseif($accesstype === 'canmodify'){
		  $return = $this->canmodify();
        }elseif($accesstype === 'candelete'){
		  $return = $this->canDelete();
        }elseif($accesstype === 'DISPLAY'){
		  $return = $this->canDisplay();
        }elseif($accesstype === 'isadmin'){
		  $return = $this->isAdmin();
        }else{
		  $return = false;
        }
        return $return;
    }
}
