<?php
class Encription {
	/**
	 * Text to be encrypted
	 *
	 * @var string
	 */
	private $text;
	
	/**
	 * Key generated by algorithm itself
	 *
	 * @var string
	 */
	private $skey;

	/**
	 * Use OpenSSL or mcrypt
	 *
	 * @var string
	 */
	private $param = array();
	private $last_err_msg = array('code' => '', 'msg' => '');

	const ENC_MSG_010 = 'ERROR: [ReEncrypt] could not be done in PHP %PHP_VERSION%.';
	const ENC_MSG_020 = 'ERROR: [mcrypt] extension';
	const ENC_MSG_030 = 'ERROR: [openssl] extension';
	const ENC_MSG_040 = 'is not loaded';
	const ENC_MSG_050 = 'is deprecated in PHP %PHP_VERSION%.';
	const ENC_MSG_060 = 'Only can be used until PHP %PHP_VERS_MAX_MCRYPT_LIB%';
	const ENC_MSG_070 = 'The file is encrypted with [mcrypt] and cannot be decrypted in this version %PHP_VERSION% of PHP';
        
	const PHP_VERS_MAX_MCRYPT_LIB = '5.6.99';
	// http://php.net/manual/en/function.openssl-get-cipher-methods.php
	const SESS_CIPHER = 'aes-256-cbc';
	const OPENSSL_CONST_FILE_MARK = 'cr10s';
//	const SESS_CIPHER = 'aes-256-cbc';
//	const OPENSSL_CONST_FILE_MARK = 'cr20s';

	function __construct($param = array()) {
		$this->param = $param;
//		$this->param['use_openssl'] = '0';
//		$this->param['debug'] = '1';
//		$this->param['show_msg'] = '1';
	}
	function start($op, $value) {
		$this->param['debug'] = (isset($this->param['debug']) ? $this->param['debug'] : '0');
		$this->param['show_msg'] = (isset($this->param['show_msg']) ? $this->param['show_msg'] : '1');
		$this->param['use_openssl'] = (isset($this->param['use_openssl']) ? $this->param['use_openssl'] : (PHP_VERSION > self::PHP_VERS_MAX_MCRYPT_LIB ? '1' : '0'));
		switch ($op) {
			case 'DoEncrypt' :
				$this->text = $value;
				$this->KeyGenerator();
				$retorno = $this->Encode();
				break;
			case 'DoDecrypt' :
				$this->text = $value;
				$retorno = $this->Decode();
				break;
			case 'ReEncrypt' :
				if(PHP_VERSION > self::PHP_VERS_MAX_MCRYPT_LIB) {
					$this->setLastErrCode('010', str_replace('%PHP_VERSION%',PHP_VERSION,self::ENC_MSG_010).' '.str_replace('%PHP_VERS_MAX_MCRYPT_LIB%', self::PHP_VERS_MAX_MCRYPT_LIB, self::ENC_MSG_060));
					$retorno = null;
				} else {
					$this->param['use_openssl'] = '0';
					$this->text = $value;
					$retorno = $this->Decode();
					$this->text = $retorno;
					$this->param['use_openssl'] = '1';
					$this->KeyGenerator();
					$retorno = $this->Encode();
				}
				break;
			default:
				$retorno = null;
				break;
		}
		return $retorno;
	}
	private function KeyGenerator() {
		$contents = null;
		$key = array();
		$filename = kPathToRoot . 'configurator/' . kData . ambFile;
		if (file_exists($filename)) {
			$handle = fopen($filename, 'r');
			while (!feof($handle)) {
				$contents .= fread($handle, filesize($filename));
			}
			fclose($handle);
			$suffix = explode(';', $contents);
		}
		$data = base64_encode($suffix [0] . php_uname() . date('YmdHms'));
		for($a = 0; $a < strlen($data); $a ++) {
			@$key [$a % 64] = chr(ord($key [$a % 64] ) ^ ord($data [$a]));
		}
		shuffle($key);
		$key = array_slice($key, 0, 24);
		$this->skey = implode('', $key);
	}
	private function Encode() {
		if (! $this->text) {
			return false;
		}
		if($this->param['use_openssl'] === '1') {
			if(! function_exists('openssl_encrypt')) {
				$this->setLastErrCode('030', self::ENC_MSG_030.' '.self::ENC_MSG_040);
				return false;
			}
			$iv_size = openssl_cipher_iv_length(self::SESS_CIPHER);
			$iv = openssl_random_pseudo_bytes($iv_size);
			$crypt_text = openssl_encrypt($this->text, self::SESS_CIPHER, $this->skey, $options=OPENSSL_RAW_DATA, $iv);
		} else {
			if(PHP_VERSION > self::PHP_VERS_MAX_MCRYPT_LIB || ! function_exists('mcrypt_encrypt')) {
				$this->setLastErrCode('020', self::ENC_MSG_020.' '.(! function_exists('mcrypt_encrypt') ? self::ENC_MSG_040 : str_replace('%PHP_VERSION%',PHP_VERSION,self::ENC_MSG_050).' '.str_replace('%PHP_VERS_MAX_MCRYPT_LIB%', self::PHP_VERS_MAX_MCRYPT_LIB, self::ENC_MSG_060)));
				return false;
			}
			$iv_size = mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, MCRYPT_MODE_CBC);
			$iv = mcrypt_create_iv($iv_size, MCRYPT_RAND);
			$crypt_text = mcrypt_encrypt(MCRYPT_RIJNDAEL_256, $this->skey, $this->text, MCRYPT_MODE_CBC, $iv);
		}
//		$encode_text = base64_encode($crypt_text) . mb_convert_encoding('~', 'ISO-8859-1') . base64_encode($this->skey) . mb_convert_encoding('~', 'ISO-8859-1') . base64_encode($iv);
		$encode_text = base64_encode($crypt_text) . mb_convert_encoding('~', 'ISO-8859-1') . base64_encode($this->skey) . mb_convert_encoding('~', 'ISO-8859-1') . base64_encode($iv) . mb_convert_encoding('~', 'ISO-8859-1') . base64_encode(self::OPENSSL_CONST_FILE_MARK);
		return $encode_text;
	}
	private function Decode() {
		if (! $this->text) {
			return false;
		}
		// 2018-12-20 CR - Para evitar el Notice que estropea la edicion de los parametros del ambiente
		// En vez del list(..) se asigna por separado cada elemento 
		// y el nuevo $entype que puede no existir, se verifica antes de asignar
		//list($txt, $key, $iv, $entype) = explode(mb_convert_encoding('~', 'ISO-8859-1'), $this->text);
		$ar_elements = explode(mb_convert_encoding('~', 'ISO-8859-1'), $this->text);
		$txt = $ar_elements[0];
		$key = $ar_elements[1];
		$iv = $ar_elements[2];
		$entype = (isset($ar_elements[3]) ? $ar_elements[3] : '');
		// 2018-12-20 CR - Para evitar el Notice que estropea la edicion de los parametros del ambiente
		$crypt_text = base64_decode($txt);
		$crypt_key = base64_decode($key);
		$crypt_iv = base64_decode($iv);
		$enc_type = base64_decode($entype);
		if($this->param['use_openssl'] === '1' || $enc_type === self::OPENSSL_CONST_FILE_MARK) {
			if(! function_exists('openssl_encrypt')) {
				$this->setLastErrCode('040', self::ENC_MSG_030.' '.self::ENC_MSG_040);
				return false;
			}
			//03-12-2020: EC - No se requiere esta validacin
			/*if(is_null($enc_type) || $enc_type != self::OPENSSL_CONST_FILE_MARK) {
				//$this->setLastErrCode('070', str_replace('%PHP_VERSION%',PHP_VERSION,self::ENC_MSG_070));
				//return false;
			}*/
			$decrypt_text = openssl_decrypt($crypt_text, self::SESS_CIPHER, $crypt_key, $options=OPENSSL_RAW_DATA, $crypt_iv);
		} else {
			if(PHP_VERSION > self::PHP_VERS_MAX_MCRYPT_LIB || ! function_exists('mcrypt_encrypt')) {
				$this->setLastErrCode('050', self::ENC_MSG_020.' '.(! function_exists('mcrypt_encrypt') ? self::ENC_MSG_040 : str_replace('%PHP_VERSION%',PHP_VERSION,self::ENC_MSG_050).' '.str_replace('%PHP_VERS_MAX_MCRYPT_LIB%', self::PHP_VERS_MAX_MCRYPT_LIB, self::ENC_MSG_060)));
				return false;
			}
			$decrypt_text = mcrypt_decrypt(MCRYPT_RIJNDAEL_256, $crypt_key, $crypt_text, MCRYPT_MODE_CBC, $crypt_iv);
		}
		if($this->param['debug'] === '1') {
			echo 
			'<br>$txt='.$txt.
			'<br>$key='.$key.
			'<br>$iv='.$iv.
			'<br>$enc_type='.(is_null($enc_type) ? '[null]' : $enc_type).
			//'<br>$crypt_text='.$crypt_text.
			//'<br>$crypt_key='.$crypt_key.
			//'<br>$crypt_iv='.$crypt_iv.
			'<br>['.$decrypt_text.']<br>';
		}
		return trim($decrypt_text);
	}
	private function setLastErrCode($errcode, $errmsg) {
		$this->last_err_msg['code'] = $errcode;
		$this->last_err_msg['msg'] = $errmsg;
		if($this->param['show_msg'] === '1') {
			echo '<br>'.$errmsg.' ['.$errcode.']';
		}
	}
	function getLastErrCode() {
		return $this->last_err_msg['code'];
	}
	function getLastErrMsg() {
		return $this->last_err_msg['msg'];
	}
}
?>
