<?php

/**
 * Http Response UserResponse handler
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date:  08:53:00 -0400 (Fri, 04 Jun 2010) $
 * @version    	$Rev: 1854 $
 */
class UserResponse {


    protected static $contentType = '';
    protected static $contentDisposition = '';
    protected static $filename = '';
    protected static $keepAlive = '';
    protected static $pragma = '';
    protected static $expires = '';
    protected static $cacheControl = '';
    protected static $customHeaders = false;
    protected static $size= '';
    protected static $description = '';
    protected static $transferEncoding = '';
    
    public static function getCustomHeaders() {
        return self::$customHeaders;
    }

    public static function getCacheControl() {
        return self::$cacheControl;
    }

    public static function setCacheControl($cacheControl) {
        self::$cacheControl = $cacheControl;
    }

    public static function setCustomHeaders($customHeaders) {
        self::$customHeaders = $customHeaders;
    }

    public static function getExpires() {
        return self::$expires;
    }

    public static function setExpires($expires) {
        self::$expires = $expires;
    }

    public static function getContentType() {
        return self::$contentType;
    }

    public static function getContentDisposition() {

        return self::$contentDisposition;
    }

    public static function getFilename() {
        return self::$filename;
    }

    public static function getKeepAlive() {
        return self::$keepAlive;
    }

    public static function getPragma() {
        return self::$pragma;
    }

    public static function getSize() {
        return self::$size;
    }

    public static function getDescription() {
        return self::$description;
    }
    public static function getTransferEncoding() {
	return self::$transferEncoding;
    }
    
    public static function setContentType($contentType) {
        UserResponse::setCustomHeaders(true);
        self::$contentType = $contentType;
    }

    public static function setContentDisposition($contentDisposition) {
        self::$contentDisposition = $contentDisposition;
    }

    public static function setFilename($filename) {
        self::$filename = $filename;
    }

    public static function setKeepAlive($keepAlive) {
        self::$keepAlive = $keepAlive;
    }

    public static function setPragma($pragma) {
        self::$pragma = $pragma;
    }
    public static function setSize($size) {
        self::$size = $size;
    }
    public static function setDescription($description) {
        self::$description = $description;
    }
    public static function setTransferEncoding($transferEncoding) {
        self::$transferEncoding = $transferEncoding;
    }
   
    public static function sendHeaders() {
	 header("Access-Control-Allow-Origin: *");
	 
	$val = self::getContentDisposition();
        if (!empty($val)) {
		  header('Content-type: ' . $val);
        }
	$val2 = self::getFilename();
        if (!empty($val2)and !empty($val)) {
		  header('Content-Disposition: ' .$val . '; filename=' . $val2);
        }
	$val3 = self::getKeepAlive();
        if (!empty($val3)) {
		  header('Keep-Alive: ' . $val3);
        }
	$val4 = self::getCacheControl();
        if (!empty($val)) {
		  header('Cache-control: ' . $val4);
        }
	$val5 = self::getPragma();
        if (!empty($val5)) {
		  header('Pragma: ' . $val5);
        }
	$val6 = self::getExpires();
        if (!empty($val6)) {
		  header('Expires: ' . $val6);
        }
	$val7 = self::getSize();
        if (!empty($val7)) {
		  header('Content-Length: ' . $val7);
        }
	$val8 = self::getDescription();
        if (!empty($val8)) {
		  header('Content-Description: ' . $val8);
        }
	$val9 = self::getTransferEncoding();
        if (!empty($val9)) {
		  header('Content-Transfer-Encoding: ' . $val9);
        }
	
    }
    /**
     * Sets response time limit
     * @param type $runTimeLimit
     */
    public static function setRunTimeLimit($runTimeLimit) {
        set_time_limit ($runTimeLimit);
    }

    public static function setIgnoreUserAbort($value){
        ignore_user_abort ($value);
    }
}
