<?php

/**
 * Add Report Styles
 * For more information contact  support@alenet.com
 *
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2016-10-07 16:04:54 +0000 (Fri, 07 Oct 2016) $
 * @version        $Rev: 8793 $
 * @package		Clientix.Classes.Report
 * @abstract		Abstract Class
 */
class clx_style {

    private $name;
    private $number1;
    private $number2;
    private $number3;
    private $ln = CLX_NUM_ONE;
    //font properties
    private $font_face;
    private $font_face_excel;
    private $font_color;
    private $font_size;
    private $font_aligment;
    private $font_bold;
    private $font_underline;
    private $font_italic;
    private $wrap_text;
    private $url;
    private $urlText = "";
    //table, cell or any container props
    private $box_width;
    private $box_height;
    private $box_border;
    public $box_border_size;
    private $box_border_style;
    public $box_border_color;
    private $box_border_form = '0';
    private $box_bg_color;
    private $box_col_span;
    private $box_row_span;
    public $box_padding;
    //formating styles
    private $data_type;
    public $data_format;
    private $position_x;
    private $position_y;
    private $reset_y;
    private $orden;
    public $xls_border_type = 1; //solid

    function __construct($name, $num1 = CLX_NUM_11, $num2 = CLX_NUM_12, $num3 = CLX_NUM_13) {
        $this->name = $name;
        $this->font_face = 'Times';
        $this->font_face_excel = 'Times';
        $this->font_color = '';
        $this->font_size = CLX_NUM_12;
        $this->font_aligment = CLX_PROP_LEFT;
        $this->font_bold = false;
        $this->font_italic = false;
        $this->font_underline = false;
        $this->wrap_text = false;
        $this->url = false;
        //table, cell or any container props
        $this->box_width = null;
        $this->box_height = null;
        $this->box_border = CLX_INIT_ZERO;
        $this->box_border_color = null;
        $this->box_bg_color = null;
        $this->box_col_span = CLX_NUM_ONE;
        $this->box_row_span = CLX_NUM_ONE;
        $this->box_padding = CLX_INIT_ZERO;
        //formating styles
        $this->data_type = 'string';
        $this->data_format = null;
        $this->position_x = 0;
        $this->position_y = -1;
        $this->reset_y = -1;
        $this->orden = '(+)';
        $this->number1 = $num1;
        $this->number2 = $num2;
        $this->number3 = $num3;
    }

    public static function __set_state($arguments) {
        $obj = new clx_style($arguments['name']);
        foreach ($arguments as $key => $value) {
		  //eval('$obj->' . $key."='".$value."';");
		  $obj->$key = $value;
        }
        return $obj;
    }

    function copyStyle($newname) {
        $a = clone $this;
        $a->setName($newname);
        return $a;
    }

    function getName() {
        return $this->name;
    }

    function setName($name) {
        $this->name = $name;
    }

    function setNumber($fondo, $fuente, $borde) {
        $this->number1 = $fondo;
        $this->number2 = $fuente;
        $this->number3 = $borde;
    }

    function getNumber() {
        return array('1' => $this->number1, '2' => $this->number2, '3' => $this->number3);
    }

    function setFontFaceExcel($font_face) {
        $this->font_face_excel = $font_face;
    }

    function setFontFace($font_face) {
        $this->font_face = $font_face;
    }

    function getFontFace($format = '') {
        ClxFreeReturn($format);
			return $this->font_face;
    }

    function getFontFaceExcel($format = '') {
        ClxFreeReturn($format);
        return $this->font_face_excel;
    }

    function setFontColor($font_color) {
        $this->font_color = $font_color;
    }

    function getFontColor($format = '') {
        if ($format === 'pdf' || $format === 'msexcel') {
		  if (empty($this->font_color)) {
			 $r = array('r' => CLX_NUM_255, 'g' => CLX_NUM_255, 'b' => CLX_NUM_255);
		  } else {
			 $color = str_replace('#', '', $this->font_color);
			 $r = array(
			     'r' => hexdec(substr($color, CLX_NUM_ZERO, CLX_NUM_TWO)),
			     'g' => hexdec(substr($color, CLX_NUM_TWO, CLX_NUM_TWO)),
			     'b' => hexdec(substr($color, CLX_NUM_FOUR, CLX_NUM_TWO))
			 );
		  }
		  return $r;
        } else {
		  return $this->font_color;
        }
    }

    function setFontSize($font_size) {
        $this->font_size = $font_size;
    }

    function getFontSize($format = '') {
        ClxFreeReturn($format);
        return $this->font_size;
    }

    function getPositionX($format = '') {
        return $this->position_x;
    }

    function setPositionX($position_x) {
        $this->position_x = $position_x;
    }

    function getPositionY() {
        return $this->position_y;
    }

    function setPositionY($position_y) {
        $this->position_y = $position_y;
    }

    function getResetY() {
        return $this->reset_y;
    }

    function setResetY($reset_y) {
        $this->reset_y = $reset_y;
    }

    function getOrden() {
        return $this->orden;
    }

    function setOrden($orden) {
        $this->orden = $orden;
    }

    function setFontAligment($font_align) {
        $this->font_aligment = $font_align;
    }

    function getFontAligment($format = '') {
        if ($format === 'pdf') {
		  switch ($this->font_aligment) {
			 case 'center':
			     $retorno = 'C';
			     break;
			 case CLX_PROP_RIGHT:
			     $retorno = 'R';
			     break;
			 case 'justify':
			     $retorno = 'J';
			     break;
			 default :
			     $retorno = 'L';
			     break;
		  }
        } else {
		  $retorno = $this->font_aligment;
        }
        return $retorno;
    }

    function getFont($format = '') {
        $return = '';
        if ($format === 'pdf' or $format === 'msexcel') {
		  if (!empty($this->font_bold)) {
			 $return .= 'B';
		  }
		  if (!empty($this->font_underline)) {
			 $return .= 'U';
		  }
		  if (!empty($this->font_italic)) {
			 $return .= 'I';
		  }
        }
        return $return;
    }

    function setFontNormal() {
        $this->font_bold = false;
        $this->font_underline = false;
    }

    function setFontBold() {
        $this->font_bold = true;
    }

    function unsetFontBold() {
        $this->font_bold = false;
    }

    function setFontItalic() {
        $this->font_italic = true;
    }

    function unsetFontItalic() {
        $this->font_italic = false;
    }

    function setFontUnderline() {
        $this->font_underline = true;
    }

    function unsetFontUnderline() {
        $this->font_underline = false;
    }

    function setFontBoldUnderline() {
        $this->font_bold = true;
        $this->font_underline = true;
    }

    function setWrapText() {
        $this->wrap_text = true;
    }

    function unsetWrapText() {
        $this->wrap_text = false;
    }

    function getWrapText() {
        return $this->wrap_text;
    }

    function setUrlText($urlText) {
        $this->url = true;
        $this->urlText = $urlText;
    }

    function unsetUrlText() {
        $this->url = false;
        $this->urlText = '';
    }

    function getUrlText() {
        return $this->urlText;
    }

    function getUrl() {
        return $this->url;
    }

    function setBoxWidth($box_width) {
        $this->box_width = $box_width;
    }

    function getBoxWidth($format = 'pdf') {
        if ($format === 'pdf') {
		  return $this->box_width / CLX_NUM_FOUR;
        } elseif ($format === 'msexcel') {
		  return $this->box_width / CLX_NUM_SIX;
        } else {
		  return $this->box_width;
        }
    }

    function setBoxHeight($box_height) {
        $this->box_height = $box_height;
    }

    function getBoxHeight($format = '') {
        if ($format === 'pdf') {
		  return $this->box_height / CLX_NUM_6_PT_5;
        } elseif ($format === 'msexcel') {
		  return $this->box_height / CLX_NUM_1_PT_2;
        } else {
		  return $this->box_height;
        }
    }

    function setBoxBorder($border_size, $box_style = 'solid', $border_color = 'black', $box_form = '1') {
        $this->box_border = true;
        $this->box_border_size[$this->name] = $border_size;
        $this->box_border_style[$this->name] = $box_style;
        $this->setBoxBorderColor($border_color);
        $this->setBoxBorderForm($box_form);
    }


    function unsetBoxBorder() {
        $this->box_border = false;
         $this->box_border = true;
        $this->box_border_size = array();
        $this->box_border_style = array();
        $this->box_border_color = array();
        $this->box_border_form = array();
    }

    function setBoxBorderForm($box_form) {
        $this->box_border_form = $box_form;
    }

    function getBoxBorderForm($format = '') {
        if (in_array($format, array('msexcel', 'html'))) {
		  $borderForm = array();
		  if ($this->box_border_form === '1') {
			 $borderForm['all'] = CLX_NUM_ONE;
		  } elseif (empty($this->box_border_form)) {
			 $borderForm = array();
		  } else {
			 $borderForm[CLX_PROP_LEFT] = (strpos($this->box_border_form, 'L') !== false) ? CLX_NUM_ONE : CLX_NUM_ZERO;
			 $borderForm['top'] = (strpos($this->box_border_form, 'T') !== false) ? CLX_NUM_ONE : CLX_NUM_ZERO;
			 $borderForm[CLX_PROP_RIGHT] = (strpos($this->box_border_form, 'R') !== false) ? CLX_NUM_ONE : CLX_NUM_ZERO;
			 $borderForm['bottom'] = (strpos($this->box_border_form, 'B') !== false) ? CLX_NUM_ONE : CLX_NUM_ZERO;
		  }

		  return $borderForm;
        } elseif ($format === 'pdf') {
		  $borderForm = '';
		  if ($this->box_border_form === '1')
			 $borderForm = 'LTRB';
		  elseif ($this->box_border_form === '0')
			 $borderForm = $this->box_border_form;
		  else {
			 if (!empty($this->box_border_form)) {
			     $borderForm .= (strpos($this->box_border_form, 'L') !== false) ? 'L' : CLX_CHAR_EMPTY_STRING;
			     $borderForm .= (strpos($this->box_border_form, 'T') !== false) ? 'T' : CLX_CHAR_EMPTY_STRING;
			     $borderForm .= (strpos($this->box_border_form, 'R') !== false) ? 'R' : CLX_CHAR_EMPTY_STRING;
			     $borderForm .= (strpos($this->box_border_form, 'B') !== false) ? 'B' : CLX_CHAR_EMPTY_STRING;
			 }
		  }
		  return $borderForm;
        } else
		  return $this->box_border_form;
    }

    function getBoxBorder($format = '') {
        if ($format === 'pdf') {
		  if (!empty($this->box_border_size[$this->name]) > CLX_NUM_ZERO) {
			 return CLX_NUM_ONE;
		  } else {
			 return CLX_NUM_ZERO;
		  }
        } else {
		  return $this->box_border;
        }
    }

    function setBoxBorderStyle($style) {
        $this->box_border_style = $style;
    }

    function getBoxBorderStyle($format = '') {
        return $this->box_border_style;
    }

    function setBoxBorderColor($box_border_color) {

        if ($box_border_color == 'black') {
		  $this->box_border_color[$this->name] = '#000000';
        } else {
		  $this->box_border_color[$this->name] = $box_border_color;
        }
    }

    function setLn($ln) {
        $this->ln = $ln;
    }

    function getLn() {
        return $this->ln;
    }

    function getBoxBorderColor($format = '') {
        if ($format === 'pdf' || $format === 'msexcel') {
		  if (empty($this->box_border_color[$this->name])) {
			 $r = array('r' => CLX_NUM_255, 'g' => CLX_NUM_255, 'b' => CLX_NUM_255);
		  } else {
			 $color = str_replace('#', '', $this->box_border_color[$this->name]);
			 $r = array('r' => hexdec(substr($color, CLX_NUM_ZERO, CLX_NUM_TWO)), 'g' => hexdec(substr($color, CLX_NUM_TWO, CLX_NUM_TWO)), 'b' => hexdec(substr($color, CLX_NUM_FOUR, CLX_NUM_TWO)));
		  }
		  return $r;
        } else {
		  return $this->box_border_color[$this->name];
        }
    }

    /**
     * Sets the background color
     * @param string $box_bg_color
     */
    function setBoxBgColor($box_bg_color) {
        $this->box_bg_color = $box_bg_color;
    }

    function getBoxBgColor($format = '') {
        if ($format === 'pdf' || $format === 'msexcel') {
		  if (empty($this->box_bg_color)) {
			 $r = array('r' => CLX_NUM_255, 'g' => CLX_NUM_255, 'b' => CLX_NUM_255);
		  } else {
			 $color = str_replace('#', '', $this->box_bg_color);
			 $r = array('r' => hexdec(substr($color, CLX_NUM_ZERO, CLX_NUM_TWO)),
			     'g' => hexdec(substr($color, CLX_NUM_TWO, CLX_NUM_TWO)),
			     'b' => hexdec(substr($color, CLX_NUM_FOUR, CLX_NUM_TWO))
			 );
		  }
		  return $r;
        } else {
		  return $this->box_bg_color;
        }
    }

    function setBoxColSpan($box_col_span) {
        $this->box_col_span = $box_col_span;
    }

    function getBoxColSpan($format = '') {
        switch ($format) {
		  case 'msexcel':
			 if (empty($this->box_col_span)) {
			     $retorno = CLX_NUM_ZERO;
			 } else {
			     $retorno = $this->box_col_span - CLX_NUM_ONE;
			 }
			 break;
		  case 'html':
			 $retorno = ($this->box_col_span == 0) ? 1 : $this->box_col_span;
			 break;
		  default:
			 $retorno = $this->box_col_span;
			 break;
        }
        return $retorno;
    }

    function setBoxRowSpan($box_row_span) {
        $this->box_row_span = $box_row_span;
    }

    function getBoxRowSpan($format = '') {
        switch ($format) {
		  case 'msexcel':
			 if (empty($this->box_row_span))
			     return CLX_NUM_ZERO;
			 else
			     return $this->box_row_span - CLX_NUM_ONE;
			 break;
		  case 'html':
			 return ($this->box_row_span==0) ? 1 : $this->box_row_span;
			 break;
		  case 'pdf':
			 return ($this->box_row_span==0) ? 1 : $this->box_row_span;
			 break;
		  default:
			 return $this->box_row_span;
			 break;
        }
    }

    function setBoxPadding($padding) {
        $this->box_padding = $padding;
    }

    function getDataType() {
        return $this->data_type;
    }

    function setDataType($data_type) {
        $this->data_type = $data_type;
    }

    function setDataFormat($data_format) {
        $this->data_format = $data_format;
    }

    function formatData($data, $format = '') {
        if ($this->data_type === 'decimal') {
		  if ($data === '') {
			 return CLX_CHAR_EMPTY_STRING;
		  } else {
			 if ($format === 'msexcel') {
			     return rounder($data, CLX_NUM_TWO);
			 } else {
			     return clx_format_currency($data, CLX_NUM_TWO);
			 }
		  }
        } elseif ($this->data_type === 'integer') {
		  if ($data === '')
			 return CLX_CHAR_EMPTY_STRING;
		  else
			 return rounder($data, CLX_NUM_ZERO);
        }else {
		  return (string) $data;
        }
    }

    // FORMATERS
    function sourceHtml() {
        $contents = '';
        foreach ($this as $key => $val) {
		  if (empty($val)) {
			 continue;
		  }
		  switch ($key) {
			 case 'font_face':
			     $contents .= 'font-family:' . $val . ';';
			     break;
			 case 'font_color':
			     $contents .= 'color:' . $val . ';';
			     break;
			 case 'font_size': $contents .= 'font-size:' . $val . 'pt;';
			     break;
			 case 'font_aligment':
			     $contents .= 'text-align:' . $val . ';';
			     break;
			 case 'font_bold':
			     $contents .= 'font-weight: bold;';
			     break;
			 case 'font_underline':
			     $contents .= 'text-decoration:underline;';
			     break;
			 case 'box_width':
			     $contents .= 'width:' . $val . 'px;';
			     break;
			 case 'box_height':
			     $contents .= 'height:' . $val . 'px;';
			     break;
			 case 'box_border':
			     if (!empty($val)) {
			         foreach ($this->box_border_style as $k => $v) {
					   if ($k === 'all') {
						  $contents .= 'border-style:' . $this->box_border_style['all'] . ';';
						  $contents .= 'border-width:' . $this->box_border_size['all'] . ';';
						  $contents .= 'border-color:' . $this->box_border_color['all'] . ';';
						  break;
					   } else {
						  $borderForm = $this->getBoxBorderForm('html');

						  if (array_key_exists('all', $borderForm)) {
						      $contents .= 'border-style:' . $this->box_border_style[$k] . ';';
						  } else {

						      if ($borderForm['top'] == CLX_NUM_ONE)
								$contents .= 'border-top-style:' . $this->box_border_style[$k] . ';';
						      if ($borderForm['bottom'] == CLX_NUM_ONE)
								$contents .= 'border-bottom-style:' . $this->box_border_style[$k] . ';';
						      if ($borderForm[CLX_PROP_LEFT] == CLX_NUM_ONE)
								$contents .= 'border-left-style:' . $this->box_border_style[$k] . ';';
						      if ($borderForm[CLX_PROP_RIGHT] == CLX_NUM_ONE)
								$contents .= 'border-right-style:' . $this->box_border_style[$k] . ';';
						  }
						  $contents .= 'border-width:' . $this->box_border_size[$k] . ';';
						  $contents .= 'border-color:' . $this->box_border_color[$k] . ';';
					   }
			         }
			     }
			     break;
			 case 'box_bg_color':
			     $contents .= 'background-color:' . $val . ';';
			     break;
			 case 'box_col_span': break;
			 case 'box_row_span': break;
			 case 'box_padding':
			     $contents .= 'padding:' . $val . ';';
			     break;
			 case 'data_type': break;
			 case 'data_format': break;
			 default: break;
		  }//end switch
        }
        return $contents;
    }

    function sourceMsExcelStyle(&$wb) {
        //Agregando formato a ws para no repetir valores generalmente los formatos son pocos
        if (!isset($wb->clx_styles)) {
		  $wb->clx_styles = array();
        }
        if (array_key_exists($this->name, $wb->clx_styles)) {
		  //si el formato ya esta definido retornandolo para no multiplicar mas formatos
		  $format = &$wb->clx_styles[$this->name];
        } else {
		  $format = &$wb->addFormat();
		  $format->setFontFamily($this->font_face_excel);
		  $format->setSize($this->getFontSize('msexcel'));
		  $format->setAlign($this->getFontAligment('msexcel'));
		  $format->setVAlign('vcenter');
		  if (!empty($this->font_italic))
			 $format->setItalic();
		  if (!empty($this->font_bold))
			 $format->setBold();
		  if (!empty($this->font_underline))
			 $format->setUnderline(CLX_NUM_ONE); //2 for double
		  if ($this->data_type === 'decimal')
			 $format->setNumFormat('#,##0.00');
		  if ($this->data_type === 'integer')
			 $format->setNumFormat('#');
		  if ($this->wrap_text)
			 $format->setTextWrap();
		  if (!empty($this->box_border)) {
			 if (!empty($this->box_border_color[$this->name]) && $this->box_border_color[$this->name]) {
			     $colorBd = $this->getBoxBorderColor('msexcel');
			     $wb->setCustomColor($this->number3, $colorBd['r'], $colorBd['g'], $colorBd['b']);
			     $format->setBorderColor($this->number3);
			 }
			 $borderForm = $this->getBoxBorderForm('msexcel');
			 if (array_key_exists('all', $borderForm)) {
			     $format->setBorder($this->xls_border_type);
			 } else {
			     if (isset($borderForm['top']) && $borderForm['top'] == CLX_NUM_ONE) {
			         $format->setTop($this->xls_border_type);
			     }
			     if (isset($borderForm['bottom']) && $borderForm['bottom'] == CLX_NUM_ONE)
			         $format->setBottom($this->xls_border_type);
			     if (isset($borderForm[CLX_PROP_LEFT]) && $borderForm[CLX_PROP_LEFT] == CLX_NUM_ONE)
			         $format->setLeft($this->xls_border_type);
			     if (isset($borderForm[CLX_PROP_RIGHT]) && $borderForm[CLX_PROP_RIGHT] == CLX_NUM_ONE)
			         $format->setRight($this->xls_border_type);
			 }
		  }
		  if ($this->box_bg_color === true) {
			 $colorBg = $this->getBoxBgColor('msexcel');
			 $wb->setCustomColor($this->number1, $colorBg['r'], $colorBg['g'], $colorBg['b']);
			 $format->setBgColor($this->number1);
			 $format->setFgColor($this->number1);
			 $format->setPattern(CLX_NUM_ONE);
		  }
		  if ($this->font_color === true) {
			 $colorT = $this->getFontColor('msexcel');
			 $wb->setCustomColor($this->number2, $colorT['r'], $colorT['g'], $colorT['b']);
			 $format->setColor($this->number2);
		  }
		  //Guardando formato
		  $wb->clx_styles[$this->name] = $format;
        }
        return $format;
    }

}
