<?php

/**
 * General Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-09-03 16:24:19 +0000 (Thu, 03 Sep 2015) $
 * @version        $Rev: 6814 $
 * @package		Clientix.Classes.File
 * @abstract		file Archive Class
 */
class clx_zip extends ZipArchive {

    /**
     * Zip directory recurrently
     * @param string $directory Directory to compress
     * @param string $node Recurrence node
     */
    public function addDir($directory, $node = '') {
        $fullpath = $directory . $node;
        $nodes = scandir($fullpath);
        foreach ($nodes as $val) {
		  if ($val === '.' || $val === '..')
			 continue;
		  $filepath = $fullpath . $val;
		  $nodezippath = str_replace($directory, '', $filepath);
		  if (is_dir($filepath)) {
			 $this->addEmptyDir($nodezippath);
			 $this->addDir($directory, $nodezippath . '/');
		  } elseif (is_file($filepath)) {
			 $this->addFile($filepath, $nodezippath);
		  }
        }
    }

    /**
     * Process file on template output
     * @param $zip
     * @param $zipfile
     */

    /**
     * Returns dom object conteinng xml file
     * @param unknown_type $zipedfile
     * @return DOMDocument
     */
    public function &loadXmlDom($zipedfile) {
        //Read the file on zip and parse variables
        $dom = new DOMDocument();
        $dom->loadXML($this->getFromName($zipedfile));
        return $dom;
    }

}

// end class
