<?php

/**
 * General Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2019-02-13 14:27:56 +0000 (Wed, 13 Feb 2019) $
 * @version        $Rev: 10549 $
 * @package		Clientix.Classes.Format
 * @abstract		General Class
 * CHANGE LOG
 *  Included label
 */
class xFormat { 

    static function time($atime) {
        if (func_num_args() > CLX_NUM_ONE) {
		  $format = func_get_arg(CLX_NUM_ONE);
		  if (empty($format)) {
			 $format = 'h:i:s A';
		  }
        } else {
		  $format = 'h:i:s A';
        }
        $timestamp = adodb_strtotime($atime);
        return ($timestamp == -CLX_NUM_ONE) ? $atime : adodb_date($format, $timestamp);
    }

    static function date($adate) {
        if (func_num_args() > CLX_NUM_ONE) {
		  $format = func_get_arg(CLX_NUM_ONE);
		  if (empty($format)) {
			 $format = 'M j, Y';
		  }
        } else {
		  $format = 'M j, Y';
        }
        $retorno= xFormat::anytimedate($adate, $format);
	if ($retorno=='0000-00-00') {
	    $convert=array('n'=>'0','j'=>'0','d'=>'00','m'=>'00','Y'=>'0000','y'=>'00','M'=>'xxx');
	    $retorno=strtr($format,$convert);
	}
	return $retorno;
    }

    static function textdateusr($adate) {
        $date = xFormat::date($adate,$_SESSION['prefs']['DATE_FORMAT']);

        return $date;
    }
    static function textdate($adate, $format) {
        $date = self::date($adate,$format);
        //$date = xFormat::date($adate,$_SESSION['prefs']['DATE_FORMAT']);
        $a = new xFormat();
        $parts = $a->dateSplit($adate);
        if(!empty($parts) && count($parts)===CLX_NUM_THREE){
		  $parts[CLX_NUM_ONE] = self::month($parts[CLX_NUM_ONE]);
		  if (substr(getCurrentLanguage(),0,2) === 'en') {
			 $date = $parts[CLX_NUM_ONE].' '.$parts[CLX_NUM_TWO].' of '.$parts[CLX_NUM_ZERO];
		  }else{
			 $date = $parts[CLX_NUM_TWO].' de '.$parts[CLX_NUM_ONE].' de '.$parts[CLX_NUM_ZERO];
		  }
        }
        return $date;
    }

    static function month($m) {
        if (substr(getCurrentLanguage(),0,2) === 'en') {
		  if (is_int($m) || strlen($m) <= CLX_NUM_TWO) {
			 switch ($m) {
			     case '01': $m = 'January';
			         break;
			     case '02': $m = 'February';
			         break;
			     case '03': $m = 'March';
			         break;
			     case '04': $m = 'April';
			         break;
			     case '05': $m = 'May';
			         break;
			     case '06': $m = 'June';
			         break;
			     case '07': $m = 'July';
			         break;
			     case '08': $m = 'August';
			         break;
			     case '09': $m = 'September';
			         break;
			     case '10': $m = 'October';
			         break;
			     case '11': $m = 'November';
			         break;
			     case '12': $m = 'December';
			         break;
			     default:
			         break;
			 }
		  }
        } else {
		  if (is_int($m) || strlen($m) <= CLX_NUM_TWO) {
			 switch ($m) {
			     case '01': $m = 'ENERO';
			         break;
			     case '02': $m = 'FEBRERO';
			         break;
			     case '03': $m = 'MARZO';
			         break;
			     case '04': $m = 'ABRIL';
			         break;
			     case '05': $m = 'MAYO';
			         break;
			     case '06': $m = 'JUNIO';
			         break;
			     case '07': $m = 'JULIO';
			         break;
			     case '08': $m = 'AGOSTO';
			         break;
			     case '09': $m = 'SEPTIEMBRE';
			         break;
			     case '10': $m = 'OCTUBRE';
			         break;
			     case '11': $m = 'NOVIEMBRE';
			         break;
			     case '12': $m = 'DICIEMBRE';
			         break;
			     default:
			         break;
			 }
		  } else {
			 switch ($m) {
			     case 'January': $m = 'ENERO';
			         break;
			     case 'February': $m = 'FEBRERO';
			         break;
			     case 'March': $m = 'MARZO';
			         break;
			     case 'April': $m = 'ABRIL';
			         break;
			     case 'May': $m = 'MAYO';
			         break;
			     case 'June': $m = 'JUNIO';
			         break;
			     case 'July': $m = 'JULIO';
			         break;
			     case 'August': $m = 'AGOSTO';
			         break;
			     case 'September': $m = 'SEPTIEMBRE';
			         break;
			     case 'October': $m = 'OCTUBRE';
			         break;
			     case 'November': $m = 'NOVIEMBRE';
			         break;
			     case 'December': $m = 'DICIEMBRE';
			         break;
			     default:
			         break;
			 }
		  }
        }
        return $m;
    }

    function dateSplit($adate) { //splits iso dates(yyyy-mm-dd hh:mm:ss) into an array
        $tdate = explode(' ', trim($adate));
        if (isset($tdate[CLX_NUM_ZERO])) {
		  $ayear = $tdate[CLX_NUM_ZERO];
        } else {
		  $ayear = '0000-00-00';
        }
        if (isset($tdate[CLX_NUM_ONE])) {
		  $ahour = $tdate[CLX_NUM_ONE];
        } else {
		  $ahour = '';
        }
        $ayear = explode('-', trim($ayear));
        $xdate = array($ayear[CLX_NUM_ZERO], $ayear[CLX_NUM_ONE], $ayear[CLX_NUM_TWO]);
        if (!empty($ahour)) {
		  $ahour = explode(':', trim($ahour));
		  $xdate[] = $ahour[CLX_NUM_ZERO];
		  $xdate[] = $ahour[CLX_NUM_ONE];
		  $xdate[] = $ahour[CLX_NUM_TWO];
        }
        return $xdate;
    }

    static function getNow() {
        if (func_num_args() > CLX_NUM_ZERO) {
		  $format = func_get_arg(CLX_NUM_ZERO);
        } else {
		  $format = 'YmdHis';
        }
        return adodb_date($format);
    }

    static function relative_date($adate) {
        $xdate = adodb_date('Y-m-d', adodb_strtotime($adate));
        $today = adodb_date('Y-m-d');
        $yy = adodb_date('Y');
        $ym = adodb_date('m');
        $yd = (adodb_date('d') - CLX_NUM_ONE);
        if ($xdate == $today) {
		  return 'Today';
        } elseif ($xdate == adodb_date('Y-m-d', adodb_strtotime($yy . '-' . $ym . '-' . $yd))) {
		  return 'Yesterday';
        } else {
		  return xFormat::date($adate,$_SESSION['prefs']['DATE_FORMAT'].' h:i:s');
        }
    }

    static function datetime($adate) {
        if (!empty($adate)) {
		  if (func_num_args() > CLX_NUM_ONE) {
			 $format = func_get_arg(CLX_NUM_ONE);
			 if (empty($format))
			     $format = $_SESSION['prefs']['DATE_FORMAT'].' h:i:s A';
		  } else {
			 $format = $_SESSION['prefs']['DATE_FORMAT'].' h:i:s A';
		  }
		  return xFormat::anytimedate($adate, $format);
        } else {
		  return CLX_CHAR_EMPTY_STRING;
        }
    }

    static function anytimedate($adate, $format) {
	//ivan mrsnik
	//colocado con fechas en 0000-00-00
	//no hace cambio de formato.
	$revert=false;
	if ($adate=='0000-00-00' or $adate=='0000-00-00 00:00:00') {
	    $adate=str_replace('00','11',$adate);
	    $revert=true;
	}
        $timestamp = adodb_strtotime($adate);
        if ($timestamp == -CLX_NUM_ONE) {
	    $return= $adate;
        } else {
		  $return= adodb_date($format, $timestamp);
        }
	if ($revert) {
	    $return=str_replace('11','00',$return);
	}
	return $return;
    }

    static function number($anumber) {
        if (func_num_args() > CLX_NUM_ONE) {
		  $dec = func_get_arg(CLX_NUM_ONE);
        } else {
		  $dec = CLX_NUM_TWO;
        }
        return clx_format_currency($anumber, $dec, '.', ',');
    }

    /**
     * Returns formated currency
     * @param decimal $anumber
     * @param integer $decimals
     * @param string $dec_point
     * @param string $thousands_sep
     * @return string <string, mixed>
     */
    static function currency($anumber, $decimals = CLX_NUM_TWO, $dec_point = '.', $thousands_sep = ',') {
        return number_format($anumber, $decimals, $dec_point, $thousands_sep);
    }

    static function text($atext) {
        if (func_num_args() > CLX_NUM_ONE) {
		  $chars = func_get_arg(CLX_NUM_ONE);
        } else {
		  $chars = CLX_NUM_40;
        }
        if (is_object($atext)) {
		  $atext = $atext->read($atext->size());
        }
        return wordwrap($atext, $chars, '<br>', true);
    }

    static function filesize($size) {
        $unit = 'bytes';
        if ($size > CLX_NUM_1024) {
		  $size /= CLX_NUM_1024;
		  $unit = 'KB';
        }
        if ($size > CLX_NUM_1024) {
		  $size /= CLX_NUM_1024;
		  $unit = 'MB';
        }
        if ($size > CLX_NUM_1024) {
		  $size /= CLX_NUM_1024;
		  $unit = 'GB';
        }
        $size = number_format($size, CLX_NUM_TWO);
        return $size . ' ' . $unit;
    }

}
