<?php

/**
 * Compliance Module Utilities
 * For more information contact  support@alenet.com
 *
 * @author	   $Author: fsantana $
 * @copyright	Alenet, Inc.
 * @since		$Date: 2016-05-20 14:50:51 -0400 (Fri, 20 May 2016) $
 * @since		$Date: 2016-05-20 14:50:51 -0400 (Fri, 20 May 2016) $
 * @version		$Rev: 8239 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class cmp_utilities {

    var $err_msg = array();
    var $other_msg = array();
    var $contents = '';
    var $run_id = CLX_INIT_ZERO; // Run id
    var $now = '';
    var $today = '';
    var $debug = false;
    var $criteria_name = '';

    /**
     * Constructor
     *
     * @return void
     */
    function __construct() {
        multiTableName($this, array('CMBP', 'CMBD', 'CMDD', 'CMAP', 'CMAD', 'CMDT', 'ACCO', 'FIPA', 'FICO'));
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->today = xFormat::getNow('Y-m-d');
    }

// end function
    /**
     * Execute Form Process
     *
     * @param array $record
     */
    static function initCmapForm(&$record) {
        $record ['CMAP_CMP_STATUS'] = 'NOT';
    }

    /**
     * Init Cmad Record
     * @param array $record
     */
    function CmadinitForm(&$record) {
        if ((UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'DUPLICATE_EFFTDATE') && empty(UserRequest::$post['confirm'])) {
            $record['CMAD_CLX_EFFTDATE'] = $this->today;
            $record['CMAD_EXP_REMINDED_DATE'] = '';
            $record['CMAD_REMINDED_USER'] = '';
        }
        $callingpage = peekHistory();
        if (!empty($callingpage['parentrecord']['OPCL_CMBD_CODE'])) {
            $record['CMAD_ACCOUNTCODE'] = $callingpage['parentrecord']['OPCL_ACCOUNTCODE'];
            $record['CMAD_ACCOUNTCODE_prim'] = $callingpage['parentrecord']['OPCL_ACCOUNTCODE_prim'];
            $record['CMAD_ACCOUNTCODE_secd'] = $callingpage['parentrecord']['OPCL_ACCOUNTCODE_secd'];
            $record['CMAD_ACCOUNTCODE_terc'] = $callingpage['parentrecord']['OPCL_ACCOUNTCODE_terc'];
            $sql = 'SELECT CMDT.IDCODE, CMDT.IDNAME, CMDT.DOC_TYPE FROM CMP_RULE_DOCS CMBD, CMP_DOCUMENTS_TBL CMDT WHERE CMDT.IDCODE = CMBD.DOC_TYPE_CODE AND CMBD.IDCODE = ' . singleQuote($callingpage['parentrecord']['OPCL_CMBD_CODE']);
            $r = ClxCommon::$db->getOneRecord($sql);
            if (!empty($r)) {
                $record['CMAD_DOC_TYPE_CODE'] = $r['IDCODE'];
                $record['CMAD_DOC_TYPE_CODE_prim'] = $r['IDCODE'];
                $record['CMAD_DOC_TYPE_CODE_secd'] = $r['IDNAME'];
                $record['CMAD_DOC_TYPE_CODE_terc'] = $r['DOC_TYPE'];
            }
        }
    }

    /**
     * Execute Form Process
     *
     * @param array $record
     */
    function validateCmapRecord(&$record) {
        $this->run_id = ClxCommon::$db->getField($this->cmapname, 'ID', 'IDCODE = ' . singleQuote($record ['IDCODE']));
        ClxCommon::$db->updateRecord($this->cmapname, array('CMP_STATUS' => 'RUN'), 'ID = ' . $this->run_id);
        ClxFreeReturn($this->validateCmap($record ['ACCOUNTCODE'], $record ['PROCRULE_CODE']));
    }

    /**
     * Performs validation against business process
     *
     * @param string $accountcode
     */
    function reValidateCmap($accountcode) {
        $something = false;
        $sql = 'SELECT CMAP.ID, CMAP.PROCRULE_CODE, CMAP.ACCOUNTCODE, CMAP.CMP_STATUS, CMAP.CONTRACT_CODE FROM CMP_ACCOUNT_PROCESSES CMAP WHERE CMAP.ACCOUNTCODE = ' . singleQuote($accountcode) . ' AND CMAP.ID = (SELECT MAX(X.ID) FROM CMP_ACCOUNT_PROCESSES X WHERE X.PROCRULE_CODE = CMAP.PROCRULE_CODE AND X.ACCOUNTCODE = CMAP.ACCOUNTCODE AND (X.CONTRACT_CODE = CMAP.CONTRACT_CODE OR X.CONTRACT_CODE IS NULL)) AND CMAP.CMP_STATUS IN (' . singleQuoteArray(array('ERR', 'END')) . ') ORDER BY CMAP.ID ASC';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $something = true;
            $this->run_id = $r ['ID'];
            ClxCommon::$db->updateRecord('CMP_ACCOUNT_PROCESSES', array('CMP_STATUS' => 'RUN'), 'ID = ' . singleQuote($this->run_id));
            ClxFreeReturn($this->validateCmap($r ['ACCOUNTCODE'], $r ['PROCRULE_CODE'], $r['CONTRACT_CODE']));
        }
        if (empty($something)) {
            //Clear message an compliance of no process enabled
            $this->processMessageField($accountcode);
            $this->requestAccoSynch($accountcode, CLX_NUM_ONE);
        }
    }

// end method
    /**
     * Validates Account Process Status
     *
     * @param string $accountcode
     * @param string $process_code
     * @param string $contract_code
     * @return bool $status
     */
    function validateCmap($accountcode, $process_code, $contract_code = '') {

        $proc_crit = $this->validate_checklist_form($process_code,$accountcode);
        if(!$proc_crit){
            $error_msg_criter = '<font color="red"><b>'.dict('INVALID_DOC_PROCESS').'</b></font>';
            $this->processMessageField($accountcode,$error_msg_criter);
            return;
        }

        $status = true;
        $this->err_msg = array();
        // Create activity if not exists
        $this->initCmapRecord($accountcode, $process_code, $contract_code);
        // Check Documents
        ClxFreeReturn($this->checkProcessDocuments());
        // Check Data
        ClxFreeReturn($this->checkProcessData());
        // Setting status
        if (!empty($this->err_msg)) {
            $status = false;
        }
        // Write Log
        $font = new htmlObject('font');
        $msg = dict('GEN_LBL_PROCESS') . ' ';
        $msg .= ClxCommon::$db->getField('CMP_BUS_PROCS', 'IDNAME', 'IDCODE = ' . singleQuote($process_code));
        $msg .= ' (' . $process_code . ') <br>';
        $msg .= dict('GEN_LBL_STATUS') . ':';
        if (!empty($status)) {
            $font->setProp('color', 'green');
            $font->setContents(dict('GEN_LBL_OK'));
            $msg .= $font->source() . '<br><!>';
        } else {
            $font->setProp('color', 'red');
            $font->setContents(dict('GEN_LBL_FAIL'));
            $msg .= $font->source() . '<br><!>';
            $msg .= '<ul><li>' . implode('</li><li>', $this->err_msg) . '</li></ul>';
        }
        if (!empty($this->other_msg)) {
            $msg .= dict('GEN_LBL_OTHERINFO') . ': ';
            $msg .= '<ul><li>' . implode('</li><li>', $this->other_msg) . '</li></ul>';
        }
        // Write log
        $this->writeErrorMsgs($msg);
        // Sending case to end
        if (!empty($status)) {
            $this->setCmapStatus('END');
        } else {
            $this->setCmapStatus('ERR');
        }
        // Process action, also compliance status note
        // done at the end since status must be set already
        $this->exeProcessAction($accountcode);
        $this->processMessageField($accountcode);
        $this->run_id = CLX_INIT_ZERO;
        return $status;
    }

// end method
    /**
     * Executes action for process if exists
     *
     * @param string $accountcode
     * @param string $process_code
     */
    function exeProcessAction($accountcode) {
        // Setting compliance status
        $sql = 'SELECT ACCO.IDCODE ACCOUNTCODE, ACCO.IDENTIFICATION, MIN(CMBA.COMPLIANCE_STATUS) COMPLIANCE_STATUS, MAX(ACCO.COMPLIANCE_STATUS) ACTUAL_COMPLIANCE_STATUS FROM CMP_ACCOUNT_PROCESSES CMAP, CMP_BUS_ACTIONS CMBA, CRM_ACCOUNTS ACCO WHERE CMBA.PROCRULE_CODE = CMAP.PROCRULE_CODE AND ACCO.IDCODE = CMAP.ACCOUNTCODE AND CMAP.CMP_STATUS = CMBA.CMP_STATUS AND CMAP.ACCOUNTCODE = ' . singleQuote($accountcode) . '  AND CMBA.STATUS = ' . singleQuote('A') . ' AND CMAP.ID = (SELECT MAX(X.ID) FROM CMP_ACCOUNT_PROCESSES X WHERE X.PROCRULE_CODE = CMAP.PROCRULE_CODE AND X.ACCOUNTCODE = CMAP.ACCOUNTCODE) GROUP BY ACCO.IDCODE, ACCO.IDENTIFICATION HAVING MIN(CMBA.COMPLIANCE_STATUS) IS NOT null AND NOT (MIN(CMBA.COMPLIANCE_STATUS) = 0 AND MAX(ACCO.COMPLIANCE_STATUS) = 2) ';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            if (empty($r ['COMPLIANCE_STATUS'])) {
                $r ['COMPLIANCE_STATUS'] = CLX_INIT_ZERO;
            }
            // Requesting account sincronization to process
            $this->requestAccoSynch($accountcode, $r ['COMPLIANCE_STATUS']);
        }
        // Ahora buscar las que est�n excentas
    }

// end method
    /**
     * Synchronize accounts to LA
     */
    function synchAccounts() {
        $contenidoHTML = '';
        if (!class_exists('lain_reports'))
            includeCodeLib('LAIN_REP');
        $o_lain_reports = new lain_reports ();
        $sql = 'SELECT IDCODE FROM CRM_ACCOUNTS WHERE REQ_SYNCH = 1 AND ACCSTAT = ' . singleQuote('A') . '';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $contenidoHTML.= 'Synchronizing: ' . $r ['IDCODE'] . ', Status:';
            // updating status
            $sql = 'UPDATE CRM_ACCOUNTS SET REQ_SYNCH = 0 WHERE IDCODE = ' . singleQuote($r ['IDCODE']);
            ClxCommon::$db->executeQuery($sql);
            // Sending Information
            $a_response = $o_lain_reports->la_create_one_customer($r ['IDCODE']);
            if (!empty($a_response ['error'])) {
                $contenidoHTML.= 'Fail<br>';
                echoLog($a_response ['response']);
            } else {
                $contenidoHTML.= 'Ok<br>';
                echoLog($a_response ['response']);
            }
        }
        echo $contenidoHTML;
    }

// end method
    /**
     * Validates Required Documents for process
     *
     * @param string $accountcode
     * @param string $process_code
     * @return bool $status
     */
    function checkProcessDocuments() {
        $status = true;
        // Search any posible missing document
        // Subselect will try to search correct value if not found then
        // there is an error.
        $sql = 'SELECT CMBD.IDCODE CMBD_IDCODE, CMAP.ID, CMAP.PROCRULE_CODE, CMDT.IDNAME, CMDT.IDCODE, CMBD.IS_REQUIRED, CMBD.FIELDNAME, CMBD.LOGICAL_OPERATOR, CMBD.FIELD_VALUE, CMBD.FROM_VALUE, CMBD.TO_VALUE, CMAP.CONTRACT_CODE, CMAP.COMP_CODE, CMBD.DOC_TYPE_CODE, CMAP.ACCOUNTCODE, CMAP.CONTRACT_CODE FROM CMP_ACCOUNT_PROCESSES CMAP, CMP_RULE_DOCS CMBD, CMP_DOCUMENTS_TBL CMDT WHERE CMAP.PROCRULE_CODE = CMBD.PROCRULE_CODE AND CMDT.IDCODE = CMBD.DOC_TYPE_CODE AND CMBD.STATUS = ' . singleQuote('A') . ' AND CMAP.ID = ' . $this->run_id;
        $rs = ClxCommon::$db->executeQuery($sql);
        while (($result = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE))) {
            $criterio = $this->checklist_doc_crit_valid($result['CMBD_IDCODE'], $result['ACCOUNTCODE']);
            //Test for required
            //Test for expiration
            $sql = 'SELECT CMAD.ID, CMAD.EXPIRATION_DATE FROM CMP_ACCOUNT_DOCS CMAD WHERE CMAD.DOC_TYPE_CODE = ' . singleQuote($result['DOC_TYPE_CODE']) . ' AND CMAD.ACCOUNTCODE = ' . singleQuote($result['ACCOUNTCODE']) . ' AND CMAD.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM CMP_ACCOUNT_DOCS X WHERE X.IDCODE = CMAD.IDCODE AND X.CLX_EFFTDATE<=' . singleQuote($this->now) . ')';
            if ($result['CONTRACT_CODE'] <> '')
                $sql .= ' AND CMAD.CONTRACT_CODE = ' . singleQuote($result['CONTRACT_CODE']);
            $docinfo = ClxCommon::$db->getOneRecord($sql);
            if ($result ['IS_REQUIRED'] == CLX_NUM_ONE && empty($docinfo) && $criterio) {
                $this->err_msg [] = dict('GEN_LBL_MISSINGDOCS') . ':' . $result ['IDNAME'] . '(' . $result ['IDCODE'] . ')';
                $status = false;
            }
            if (!empty($docinfo)) {
                if ($docinfo['EXPIRATION_DATE'] <> '' && $docinfo['EXPIRATION_DATE'] < $this->today) {
                    $this->err_msg [] = dict('GEN_LBL_MISSINGDOCS') . ':' . $result ['IDNAME'] . '(' . $result ['IDCODE'] . ')';
                    $status = false;
                }
                //validating extra fields
                if (!empty($result['FIELDNAME'])) {
                    $sql = 'SELECT ID, EXPIRATION_DATE FROM CMP_ACCOUNT_DOCS WHERE ID = ' . $docinfo['ID'] . ' AND ' . $this->logical_operator($result['FIELDNAME'], $result['LOGICAL_OPERATOR'], $result['FIELD_VALUE'], $result['FROM_VALUE'], $result['TO_VALUE']);
                    $docinfo = ClxCommon::$db->getOneRecord($sql);
                    if (empty($docinfo)) {
                        $this->err_msg [] = dict('GEN_LBL_DOC_INVALID_CONDITION') . ':' . $result ['IDNAME'] . '(' . $result ['IDCODE'] . ')';
                        $status = false;
                    }
                }
                /*$status = $this->checklist_doc_crit_valid($result['CMBD_IDCODE'], $result['ACCOUNTCODE']);
                if($status == false){
                    $this->err_msg [] = dict('GEN_LBL_DOC_INVALID_CRITERIA') . ':"'.$this->criteria_name.'('.$result['CMBD_IDCODE'].')" - ' . $result ['IDNAME'] . '(' . $result ['IDCODE'] . ')';
                    $this->criteria_name = '';
                }*/
            }
        }
        return $status;
    }

// end method
    /**
     * Validates Required Documents for process
     *
     * @param string $accountcode
     * @param string $process_code
     * @return bool $status
     */
    function checkProcessData() {
        $status = true;
        // Search any posible missing document
        $sql = 'SELECT CMAP.PROCRULE_CODE, CMDD.IDNAME, CMDD.TABLECODE, CMDD.FIELDNAME, CMDD.FIELD_VALUE, DBFL.FIELDLISTLABEL, DBTF.FIELDNAME TB_FIELDNAME, CMDD.LOGICAL_OPERATOR, CMDD.FIELD_VALUE, CMDD.FROM_VALUE, CMDD.TO_VALUE, CMAP.CONTRACT_CODE FROM CLX_DB_FIELDS DBFL, CMP_ACCOUNT_PROCESSES CMAP, CMP_RULE_DATA CMDD LEFT JOIN CLX_DB_TABLEFIELDS DBTF ON DBTF.TABLECODE = CMDD.TABLECODE AND DBTF.FIELDNAME = CMDD.FIELDNAME WHERE DBFL.FIELDNAME = CMDD.FIELDNAME AND CMAP.PROCRULE_CODE = CMDD.PROCRULE_CODE AND CMDD.STATUS = ' . singleQuote('A') . ' AND CMAP.ID = ' . $this->run_id . ' ORDER BY CMDD.SEQNUM ASC';
        $rs = ClxCommon::$db->executeQuery($sql);
        while (($result = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE))) {
            switch ($result ['TABLECODE']) {
                case 'ACCO' :
                    if ($result['FIELDNAME'] === 'AGE') {
                        $result['FIELDNAME'] = 'IF(ACCO.BIRTHDATE="0000-00-00", 0,((DATE_FORMAT(NOW(),' . singleQuote('%Y') . ') - DATE_FORMAT(ACCO.BIRTHDATE,' . singleQuote('%Y') . ')) - (DATE_FORMAT(NOW(),' . singleQuote('00-%m-%d') . ') < DATE_FORMAT(ACCO.BIRTHDATE,' . singleQuote('00-%m-%d') . '))))';
                    }
                    $sql = 'SELECT COUNT(ACCO.ID) FROM ' . tableName($result ['TABLECODE']) . ' ACCO, CMP_ACCOUNT_PROCESSES CMAP WHERE CMAP.ACCOUNTCODE = ACCO.IDCODE AND CMAP.ID = ' . $this->run_id.' ';
                    if ($result ['FIELDNAME'] !== '') {
                        if ($result ['FIELD_VALUE'] !== '' || $result ['FROM_VALUE'] !== '' || $result ['TO_VALUE'] !== '') {
                            $sql .= 'AND ' . $this->logical_operator($result ['FIELDNAME'], $result['LOGICAL_OPERATOR'], $result ['FIELD_VALUE'], $result['FROM_VALUE'], $result['TO_VALUE']).' ';
                        } else {
                            $sql .= 'AND ' . $result ['FIELDNAME'] . CLX_CHAR_DIFERENTE_SING . singleQuote(CLX_CHAR_EMPTY_STRING) . ' ';
                            $sql .= 'AND ' . $result ['FIELDNAME'] . ' IS NOT NULL ';
                        }
                    }

                    break;
                default :
                    $status = false;
                    $this->err_msg [] = dict('GEN_LBL_TABLENOTSET');
                    continue 2;
                    break;
            } // end switch
            $qty = ClxCommon::$db->getOne($sql);
            if ($qty == CLX_NUM_ZERO) {
                $status = false;
                $this->err_msg [] = dict('GEN_LBL_MISSINGDATA') . ': ' . $result ['IDNAME'];
            }
        }
        return $status;
    }

// end method
    /**
     *
     * @param unknown_type $fieldname
     * @param unknown_type $logical_operator
     * @param unknown_type $field_value
     * @param unknown_type $from_value
     * @param unknown_type $to_value
     * @return string
     */
    function logical_operator($fieldname, $logical_operator, $field_value, $from_value, $to_value) {
        $return = '';
        /* see db list COMP
          Not equal to (!=) Less than (<)
          Less than or equal to (<=)
          Equal to (==) Greater than (>)
          Greater than or equal to (>=)
          Between (BW) */
        switch ($logical_operator) {
            case 'BW':
                $return .= '(' . $fieldname . ' >= ' . singleQuote($from_value) . ' AND ' . $fieldname . ' <= ' . singleQuote($to_value) . ')';
                break;
            case '!== ':
                $return .= $fieldname . ' <> ' . singleQuote($field_value);
                break;
            case '==':
                $return .= $fieldname . ' = ' . singleQuote($field_value);
                break;
            case '===':
                $return .= $fieldname . ' = ' . singleQuote($field_value);
                break;
            default:
                $return .= $fieldname . ' ' . $logical_operator . ' ' . singleQuote($field_value);
                break;
        }
        return $return;
    }

    /**
     * Creates action log if not exists or Updates
     */
    function initCmapRecord($accountcode, $process_code, $contract_code = '') {
        if ($this->run_id == CLX_NUM_ZERO) {
            //Verify if process requires contract.
            if ($contract_code <> '') {
                $cc = ' AND CONTRACT_CODE = ' . singleQuote($contract_code);
                $proc_rec = array('COMP_CODE' => ClxCommon::$db->getField($this->ficoname, 'COMP_CODE', 'IDCODE = ' . singleQuote($contract_code)), 'CONTRACT_CODE' => $contract_code);
            } else {
                $proc_rec = ClxCommon::$db->getFields($this->cmbpname, 'COMP_CODE, CONTRACT_CODE', 'IDCODE = ' . singleQuote($process_code) . ' AND STATUS = ' . singleQuote('A') . '');
                if (empty($proc_rec['COMP_CODE']))
                    $proc_rec['COMP_CODE'] = 'null';
                if (empty($proc_rec['CONTRACT_CODE'])) {
                    $proc_rec['CONTRACT_CODE'] = 'null';
                    $cc = '';
                } else {
                    $cc = ' AND CONTRACT_CODE = ' . singleQuote($proc_rec['CONTRACT_CODE']);
                }
            }
            $record = array('IDCODE' => 'AUTO', 'ACCOUNTCODE' => $accountcode, 'COMP_CODE' => $proc_rec['COMP_CODE'], 'CONTRACT_CODE' => $proc_rec['CONTRACT_CODE'], 'CMP_STATUS' => 'RUN', 'PROCRULE_CODE' => $process_code, 'CDATE' => '', 'MDATE' => '', 'CREATEDBY' => '', 'MODIFIEDBY' => '', 'ERROR_MSGS' => '');
            $this->run_id = ClxCommon::$db->countRecords($this->cmapname, 'ACCOUNTCODE=' . singleQuote($accountcode), 'PROCRULE_CODE = ' . singleQuote($process_code), 'CMP_STATUS=' . singleQuote('RUN') . ' ' . $cc);
            if (!function_exists('setCreationData')) {
                includeCodeLib('GEN_REC_UTIL');
            }
            setCreationIdCode($record, 'CMAP');
            setCreationData($record);
            $this->run_id = ClxCommon::$db->createRecord($this->cmapname, $record, false);
        }
    }

// end method
    /**
     * Changes Compliance Status
     * @param string $status
     */
    function setCmapStatus($status = 'END') {
        ClxCommon::$db->updateRecord($this->cmapname, array('CMP_STATUS' => $status), 'ID = ' . $this->run_id, 'CMP_STATUS IN (' . singleQuoteArray(array('RUN', 'IDLE')) . ')');
    }

// end method
    /**
     * Writes log message to process log
     *
     * @param string $accountcode
     * @param string $msg
     * @return void
     */
    function writeErrorMsgs($msg) {
        ClxCommon::$db->updateRecord($this->cmapname, array('ERROR_MSGS' => $msg), 'ID = ' . $this->run_id, 'CMP_STATUS=' . singleQuote('RUN'));
    }

// end method
    /**
     * Start compliance validation from list jump
     * Some request variables are required from this method.
     *
     * On particular UserRequest::$request['jm'] AND ' . $idlist
     *
     * @param
     *        	void
     * @return void
     */
    function processBtn() {
        $process = UserRequest::$request ['jm'];
        unset(UserRequest::$request ['jm']);
        $idlist = getIdlist();
        if (strpos($process, ':') !== false) {
            $t = explode(':', $process);
            $process = ClxCommon::$db->getField($this->cmbpname, 'IDCODE', 'ID = ' . singleQuote($t[CLX_NUM_ONE]));
        }
        if (ClxCommon::$db->oneExistsRecords($this->cmbpname, 'IDCODE = ' . singleQuote($process)) == CLX_NUM_ZERO) {
            $this->contents = alert(dict('GEN_LBL_PROCNOTFOUND'));
            return;
        }
        if (empty($idlist)) {
            $this->contents = alert(dict('GEN_LBL_PLEASESELECT'));
            return;
        }
        //go by contract this may be inproved by search query as parameter
        if (UserRequest::$request['qy'] === 'FICO_GEN_CMBP') {
            $sql = 'SELECT FIPA.ACCOUNTCODE, FIPA.CONTRACT_CODE FROM ' . $this->fipaname . ' FIPA WHERE FIPA.ID IN (' . toString($idlist) . ')';
        } else {
            $sql = 'SELECT ACCO.IDCODE ACCOUNTCODE, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' CONTRACT_CODE FROM ' . $this->acconame . ' ACCO WHERE ACCO.ID IN (' . toString($idlist) . ')';
        }
        $rs = ClxCommon::$db->executeQuery($sql);
        while (($result = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE))) {
            ClxFreeReturn($this->validateCmap($result ['ACCOUNTCODE'], $process, $result ['CONTRACT_CODE']));
        }
    }

    //Checklist methods
    /**
     * Performs check list validations for business processes
     * @param type $record
     * @param type $msg
     */
    #private function validate_checklist_form(&$record, &$msg) {
    private function validate_checklist_form(&$process_code, &$accountcode) {
        $status = true;
        $sql = 'SELECT COUNT(*) FROM CMP_BUS_CRITERIA CMBC WHERE CMBC.PROCRULE_CODE ='.singleQuote($process_code).' AND STATUS = '.singleQuote('A');
        if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO)
            return;

        $sql = 'SELECT * FROM '.$this->acconame.' WHERE IDCODE = '.singleQuote($accountcode);
        $record = ClxCommon::$db->getOneRecord($sql);

        //Business process table CMBP
        $DBQY = &getTool('DBQY');
        $sql = 'SELECT DBTF.FIELDNAME, DBFL.FIELDTYPE, DBFL.FIELD_EXTRA1 FROM CLX_DB_TABLEFIELDS DBTF, CLX_DB_FIELDS DBFL WHERE DBTF.TABLECODE = ' . singleQuote('ACCO') . ' AND DBFL.FIELDNAME = DBTF.FIELDNAME AND DBFL.FIELDTYPE NOT IN (' . singleQuote('TEX') . ',' . singleQuote('REC') . ',' . singleQuote('FIL') . ', ' . singleQuote('PRI') . ') ORDER BY DBTF.SEQNUM ASC';
        $acco_table = '(SELECT ';
        $comma = '';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            #$key = 'ACCO_' . $r['FIELDNAME'];
            $key = $r['FIELDNAME'];
            if (array_key_exists($key, $record)) {
                $acco_table .= $comma . ' ' . singleQuote(clxCommon::$db->addslashes($record[$key])) . ' ' . $r['FIELDNAME'];
                $comma = ',';
            }
        }
        $acco_table .= ' FROM DUAL)';
        $sql_sub = '';
        //Read process criterias to test if valid process.
        $sql = 'SELECT CMCT.IDCODE CRITERIA_CODE, CMCT.IDNAME CRITERIA_NAME, CMBC.ANDOR_OPER, CMBC.OPEN_BRACKETS, CMCT.QUERYCODE, CMBC.CLOSE_BRACKETS FROM CMP_BUS_CRITERIA CMBC, CMP_BUS_CRITERIA_TBL CMCT WHERE CMBC.PROCRULE_CODE = ' . singleQuote($process_code) . ' AND CMBC.CMCT_CODE = CMCT.IDCODE AND CMCT.STATUS = ' . singleQuote('A') . ' AND CMBC.STATUS = ' . singleQuote('A') . ' ORDER BY CMBC.PROCRULE_CODE ASC, CMBC.SEQNUM ASC';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $criteria['IDCODE'] = $r['CRITERIA_CODE'];
            $criteria['IDNAME'] = $r['CRITERIA_NAME'];
            $queryinfo = $DBQY->getquery('DBQY', $r['QUERYCODE']);
            $and_oper = '';
            switch ($r['ANDOR_OPER']) {
                case 'NOT':
                    $and_oper = ' AND NOT ';
                    break;
                case 'OR':
                    $and_oper = ' OR ';
                    break;
                default:
                    $and_oper = ' AND ';
                    break;
            }
            if (strpos($queryinfo['FROMCLAUSE'], ' ACCO') !== false) {
                //Remplazando tablas de oppo por tabla temporal con registro de oppo
                $queryinfo['FROMCLAUSE'] = str_replace('CRM_ACCOUNTS', $acco_table, $queryinfo['FROMCLAUSE']);
            }
            $sql_sub .= CLX_CHAR_CR . $and_oper . $r['OPEN_BRACKETS'] . ' EXISTS(SELECT 1 VAL FROM ' . $queryinfo['FROMCLAUSE'] . ' WHERE 1=1 ';
            if (strpos($queryinfo['FROMCLAUSE'], 'CRM_ACCOUNTS ACCO') !== false) {
                $sql_sub .= ' AND ACCO.IDCODE = ACCO1.IDCODE '; /* acco1 en tabla tempora luego */
            }
            if (strlen($queryinfo['WHERECLAUSE']) > CLX_NUM_ZERO) {
                $sql_sub .= ' AND ' . $queryinfo['WHERECLAUSE'];
            }
            $sql_sub .= ')' . $r['CLOSE_BRACKETS'];
        }
        if ($sql_sub <> '') {
            $sql_crit = 'SELECT COUNT(ACCO1.ID) QTY FROM CRM_ACCOUNTS ACCO1 WHERE ACCO1.IDCODE = ' . singleQuote($record['IDCODE']) . ' ' . $sql_sub;
            if (ClxCommon::$db->getOne($sql_crit) == CLX_NUM_ZERO) {
                //$this->err_msg [] = dict('GEN_LBL_PROC_INVALID_CONDITION') . ':' . $criteria ['IDNAME'] . '(' . $criteria ['IDCODE'] . ')';
                        $status = false;
            }
        }
        return $status;
    }

    #private function checklist_doc_crit_valid($cmbd_code, $oppo_code, $acco_code) {
    private function checklist_doc_crit_valid($cmbd_code, $acco_code) {
        $boolean = true;
        if (ClxCommon::$db->oneExistsRecords('CMP_DOC_CRITERIA', 'CMBD_CODE = ' . singleQuote($cmbd_code)) == CLX_NUM_ZERO) {
            return $boolean; //sin criterios retorna verdadero
        }
        $DBQY = &getTool('DBQY');
        $sql_sub = '';
        //Read process criterias to test if valid process.
        $sql = 'SELECT CMCT.IDCODE CRITERIA_CODE, CMCT.IDNAME CRITERIA_NAME, CMDC.ANDOR_OPER, CMDC.OPEN_BRACKETS, CMCT.QUERYCODE, CMDC.CLOSE_BRACKETS FROM CMP_DOC_CRITERIA CMDC, CMP_BUS_CRITERIA_TBL CMCT WHERE CMDC.CMBD_CODE = ' . singleQuote($cmbd_code) . ' AND CMDC.CMCT_CODE = CMCT.IDCODE AND CMCT.STATUS = ' . singleQuote('A') . ' AND CMDC.STATUS = ' . singleQuote('A') . ' ORDER BY CMDC.CMBD_CODE ASC, CMDC.SEQNUM ASC';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $this->criteria_name = $r['CRITERIA_NAME'];
            $queryinfo = $DBQY->getquery('DBQY', $r['QUERYCODE']);
            $and_oper = '';
            switch ($r['ANDOR_OPER']) {
                case 'NOT':
                    $and_oper = ' AND NOT ';
                    break;
                case 'OR':
                    $and_oper = ' OR ';
                    break;
                default:
                    $and_oper = ' AND ';
                    break;
            }
            $sql_sub .= CLX_CHAR_CR . $and_oper . $r['OPEN_BRACKETS'] . ' EXISTS(SELECT 1 VAL FROM ' . $queryinfo['FROMCLAUSE'] . ' WHERE 1=1 ';
            if (strpos($queryinfo['FROMCLAUSE'], 'CRM_ACCOUNTS ACCO') !== false) {
                $sql_sub .= ' AND ACCO.IDCODE = ' . singleQuote($acco_code) . ' ';
            }
            /*if (strpos($queryinfo['FROMCLAUSE'], 'SFA_OPPORTUNITIES OPPO') !== false) {
                $sql_sub .= ' AND OPPO.IDCODE = ' . singleQuote($oppo_code) . ' ';
            }*/
            if (strlen($queryinfo['WHERECLAUSE']) > CLX_NUM_ZERO) {
                $sql_sub .= ' AND ' . $queryinfo['WHERECLAUSE'];
            }
            $sql_sub .= ')' . $r['CLOSE_BRACKETS'];
        }
        if ($sql_sub <> '') {
            #$sql_crit = 'SELECT COUNT(ACCO1.ID) QTY FROM CRM_ACCOUNTS ACCO1, SFA_OPPORTUNITIES OPPO1 WHERE OPPO1.IDCODE = ' . singleQuote($oppo_code) . ' AND ACCO1.IDCODE = ' . singleQuote($acco_code) . ' ' . $sql_sub;
            $sql_crit = 'SELECT COUNT(ACCO1.ID) QTY FROM CRM_ACCOUNTS ACCO1 WHERE ACCO1.IDCODE = ' . singleQuote($acco_code) . ' ' . $sql_sub;
            if (ClxCommon::$db->getOne($sql_crit) == CLX_NUM_ZERO) {
                $boolean = false; //No se encontro criterio retornando false para prevenir ejecucion
            }
        }
        return $boolean;
    }

// end method
    // OTHER METHODS
    function cancelProcessBtn() {
        $idlist = getIdlist();
        $sql = 'UPDATE ' . $this->cmapname . ' SET CMP_STATUS = ' . singleQuote('CANC') . '  WHERE ID IN (' . toString($idlist) . ')';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'SELECT DISTINCT ACCOUNTCODE FROM ' . $this->cmapname . ' WHERE ID IN (' . toString($idlist) . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $this->reValidateCmap($r['ACCOUNTCODE']);
        }
    }

    /**
     * Additional CMAD Form Validations
     *
     * @param array $record
     * @param array $msg
     * @return void
     */
    static function validateCmadForm(&$record, &$msg) {
        $efftdate = xFormat::date($record ['CMAD_CLX_EFFTDATE'], 'Y-m-d');
        $issued = xFormat::date($record ['CMAD_ISSUE_DATE'], 'Y-m-d');
        // Issued Date could not be lass than efftdate
        if ($issued > $efftdate) {
            $msg ['CMAD_ISSUE_DATE'] = dict('CODE_CMP_ISSUEDLESSEFFT');
        }
        // if expiration date set then cant be less than issued date
        if (!empty($record ['CMAD_EXPIRATION_DATE'])) {
            $expire = xFormat::date($record ['CMAD_EXPIRATION_DATE'], 'Y-m-d');
            if ($expire < $issued) {
                $msg ['CMAD_EXPIRATION_DATE'] = dict('CODE_CMP_EXPILESSISSUED');
            }
            if ($expire < $efftdate) {
                $msg ['CMAD_EXPIRATION_DATE'] = dict('CODE_CMP_EFFTLESSEXPI');
            }
        }
        // Validate if document type requires expiration date
        $doc_types = ClxCommon::$db->getRecord('CMP_DOCUMENTS_TBL', 'IDCODE = ' . singleQuote($record ['CMAD_DOC_TYPE_CODE']));
        if (!empty($doc_types['REQ_EXPIRATION_DT']) && empty($record ['CMAD_EXPIRATION_DATE'])) {
            $msg ['CMAD_EXPIRATION_DATE'] = dict('GEN_LBL_FIELD_REQUIRED');
        }
        if (!empty($doc_types['REQ_FIELD_EXTRA01']) && $record ['CMAD_FIELD_EXTRA01'] === '') {
            $msg ['CMAD_FIELD_EXTRA01'] = (!empty($doc_types['REQ_FEXTRA01_MSG'])) ? $doc_types['REQ_FEXTRA01_MSG'] : dict('GEN_LBL_FIELD_REQUIRED');
        }
        if (!empty($doc_types['REQ_FIELD_EXTRA02']) && $record ['CMAD_FIELD_EXTRA02'] === '') {
            $msg ['CMAD_FIELD_EXTRA02'] = (!empty($doc_types['REQ_FEXTRA02_MSG'])) ? $doc_types['REQ_FEXTRA02_MSG'] : dict('GEN_LBL_FIELD_REQUIRED');
        }
        if (!empty($doc_types['REQ_FIELD_EXTRA03']) && $record ['CMAD_FIELD_EXTRA03'] === '') {
            $msg ['CMAD_FIELD_EXTRA03'] = (!empty($doc_types['REQ_FEXTRA03_MSG'])) ? $doc_types['REQ_FEXTRA03_MSG'] : dict('GEN_LBL_FIELD_REQUIRED');
        }
        if (!empty($doc_types['REQ_FIELD_EXTRA04']) && $record ['CMAD_FIELD_EXTRA04'] === '') {
            $msg ['CMAD_FIELD_EXTRA04'] = (!empty($doc_types['REQ_FEXTRA04_MSG'])) ? $doc_types['REQ_FEXTRA04_MSG'] : dict('GEN_LBL_FIELD_REQUIRED');
        }
    }

// end method
    /**
     * Returns contents to be set as part of html
     *
     * @return string $contents
     */
    function source() {
        return $this->contents;
    }

// end method
    /**
     * Process message field
     * @param string $accountcode
     */
    function processMessageField($accountcode,$error_criteria = '') {
        $contents = '';
        if($error_criteria <> '')
            $contents .= $error_criteria;
        else{
            $sql = 'SELECT CMBP.IDCODE, CMBP.IDNAME, CMAP.ACCOUNTCODE, CMAP.PROCRULE_CODE, CMAP.CMP_STATUS, CMAP.ERROR_MSGS, (SELECT DI.VALUE FROM CLX_DB_LIST_ITEMS LI, CLX_DICTIONARY DI WHERE LI.LISTCODE = ' . singleQuote('PRRS') . '  AND LI.IDCODE = CMAP.CMP_STATUS AND DI.ENTRY = LI.IDNAME AND UPPER(DI.LANGUAGE) = ' . singleQuote(uppercase($_SESSION ['prefs'] ['LANGUAGE'])) . ') CMP_STATUS_NAME, CMAP.MDATE FROM CMP_BUS_PROCS CMBP, CMP_ACCOUNT_PROCESSES CMAP, CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE = CMAP.ACCOUNTCODE AND CMBP.IDCODE = CMAP.PROCRULE_CODE AND CMAP.ACCOUNTCODE = ' . singleQuote($accountcode) . '  AND CMAP.ID = (SELECT MAX(X.ID) FROM CMP_ACCOUNT_PROCESSES X WHERE X.PROCRULE_CODE = CMAP.PROCRULE_CODE AND CMAP.CMP_STATUS <>' . "'CANC'" . ' AND X.ACCOUNTCODE = CMAP.ACCOUNTCODE)';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $contents .= substr($r ['ERROR_MSGS'], CLX_NUM_ZERO, strpos($r ['ERROR_MSGS'], '<!>')) . '<br>';
            }
        }
        ClxCommon::$db->updateRecord('CRM_ACCOUNTS', array('ERROR_MSGS' => $contents), 'IDCODE = ' . singleQuote($accountcode));
    }

    /**
     * Reports expired documents and request synchronization
     */
    function processExpiredDocuments() {
        $contenidoHTML = '';
        // Get the company parameters for email copy
        $cc = companyParameter('CMP_DOC_EXPIRATION_CC_EMAIL');
        $sql = 'SELECT CMAD.ID, CMAD.IDCODE, CMDT.IDNAME, CMAD.ACCOUNTCODE, ACCO.IDNAME ACCOUNTNAME, CMAD.CLX_EFFTDATE, CMAD.EXPIRATION_DATE, ACCO.COMPLIANCE_STATUS, FITR.USERNAME, FITR.EMAIL, CMDT.FROM_EMAIL FROM CMP_ACCOUNT_DOCS CMAD, CMP_DOCUMENTS_TBL CMDT, CRM_ACCOUNTS ACCO, FIDU_TRUSTEES FITR, FIDU_NOTIFY_PART FINP  WHERE CMDT.IDCODE = CMAD.DOC_TYPE_CODE AND FINP.FING_CODE = CMDT.FING_CODE AND FINP.FITR_CODE = FITR.IDCODE AND CMAD.DOC_STATUS = ' . singleQuote('A') . ' AND ACCO.ACCSTAT = ' . singleQuote('A') . ' AND ACCO.IDCODE = CMAD.ACCOUNTCODE AND CMAD.EXPIRATION_DATE <= CURDATE() AND CMAD.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM CMP_ACCOUNT_DOCS X WHERE X.IDCODE = CMAD.IDCODE AND X.CLX_EFFTDATE<=CURDATE())';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $from_email = kDefaultEmail;
            if (!empty($r['FROM_EMAIL']))
                $from_email = $r['FROM_EMAIL'];
            // 1 Mark as expired
            ClxCommon::$db->updateRecord($this->cmadname, array('DOC_STATUS' => 'E'), 'ID = ' . $r ['ID']);
            // 2 Mark compliance status for acco if not excempt
            $this->requestAccoSynch($r ['ACCOUNTCODE'], CLX_NUM_ZERO);
            // 3 Notify account executive
            if (!empty($r ['USERNAME'])) {
                $msg = dict('GEN_LBL_DOCUMENT_EXPIRED', $r ['IDNAME'] . '(' . $r ['IDCODE'] . ')', $r ['ACCOUNTNAME'] . '(' . $r ['ACCOUNTCODE'] . ')');
                alrt_send($msg, 'now', $r ['USERNAME']);
                // if not empty email
                if (!empty($r ['EMAIL'])) {
                    // 2913-10-10  -  - Case 1002383 - GB-Acentos en notificacion por venciminento de documentacion (compliance)
                    //clx_mail ( $from_email, $r ['EMAIL'], $msg, dict ( 'GEN_LBL_DOC_EXPIRED' ), true, $cc );
                    $em_response_1 = clx_mail_wres($from_email, $r ['EMAIL'], decode_string($msg), decode_string(dict('GEN_LBL_DOC_EXPIRED')), true, $cc, '', '', array(), '', false, 'ISO-8859-1', $this->debug);
                    if (!empty($em_response_1['error'])) {
                        $em_response_1['MSG_STATUS'] = dict('GEN_LBL_ERROR') . '<br>' . dict('GEN_LBL_ERRORMSG') . ': ' . $em_response_1['errormsg'];
                    } else {
                        $em_response_1['MSG_STATUS'] = dict('GEN_MAIL_SENT');
                    }
                    $contenidoHTML.= dict('GEN_LBL_FROM_EMAIL') . ': ' . $from_email . '<br>' . dict('GEN_LBL_TO_EMAIL') . ': ' . $r ['EMAIL'] . '<br>' . dict('GEN_LBL_SUBJECT') . ': ' . $r['ACCOUNTNAME'] . ', ' . dict('GEN_LBL_DOC_EXPIRED') . ' - ' . $r['IDNAME'] . ' [' . $r['IDCODE'] . ']<br>' . dict('GEN_LBL_RESULT') . ': ' . $em_response_1['MSG_STATUS'] . '<br>';
                }
            }
        } // end while
        echo $contenidoHTML;
    }

    /**
     * Set number of day prior to expiration
     */
    function processDocumentExpirationReminder() {
        // Get the company parameters for email copy
        $cc = companyParameter('CMP_DOC_EXPIRATION_CC_EMAIL');
        $sql = 'SELECT CMAD.ID, CMAD.IDCODE, CMDT.IDNAME, CMAD.ACCOUNTCODE, ACCO.IDNAME ACCOUNTNAME, CMAD.CLX_EFFTDATE, CMAD.EXPIRATION_DATE, ACCO.COMPLIANCE_STATUS, FITR.USERNAME, FITR.EMAIL, CMDT.EXP_REMINDER_DAYS, CMAD.EXP_REMINDED_DATE, CMAD.REMINDED_USER, CMDT.FROM_EMAIL FROM CMP_ACCOUNT_DOCS CMAD, CMP_DOCUMENTS_TBL CMDT, CRM_ACCOUNTS ACCO, FIDU_TRUSTEES FITR, FIDU_NOTIFY_PART FINP WHERE CMDT.IDCODE = CMAD.DOC_TYPE_CODE AND FINP.FING_CODE = CMDT.FING_CODE AND FINP.FITR_CODE = FITR.IDCODE AND CMAD.DOC_STATUS = ' . singleQuote('A') . ' AND ACCO.ACCSTAT = ' . singleQuote('A') . ' AND ACCO.IDCODE = CMAD.ACCOUNTCODE AND CMDT.EXP_REMINDER_DAYS > 0 AND CMAD.EXP_REMINDED_DATE IS NULL AND CMAD.EXPIRATION_DATE <= DATE_ADD(CURDATE(), INTERVAL CMDT.EXP_REMINDER_DAYS DAY) AND CMAD.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM CMP_ACCOUNT_DOCS X WHERE X.IDCODE = CMAD.IDCODE AND X.CLX_EFFTDATE<=CURDATE())';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $from_email = kDefaultEmail;
            if (!empty($r['FROM_EMAIL']))
                $from_email = $r['FROM_EMAIL'];
            // Notify account executive
            if (!empty($r ['USERNAME'])) {
                $msg = dict('GEN_LBL_DOCUMENT_TO_EXPIRE', $r ['EXP_REMINDER_DAYS'], $r ['IDNAME'] . '(' . $r ['IDCODE'] . ')', $r ['ACCOUNTNAME'] . '(' . $r ['ACCOUNTCODE'] . ')');
                alrt_send($msg, 'now', $r ['USERNAME']);
                // if not empty email
                if (!empty($r ['EMAIL'])) {
                    echoLog('Sending mail to: ' . $r ['EMAIL'] . ' On document: ' . $r ['IDCODE']);

                    clx_mail($from_email, $r ['EMAIL'], decode_string($msg), decode_string(dict('GEN_LBL_DOC_EXPIRED')), true, $cc, '', '', array(), '', false, 'ISO-8859-1', false);
					pre ("clx_mail({$from_email}, {$r['EMAIL']}, decode_string($msg), decode_string(dict('GEN_LBL_DOC_EXPIRED')), true, $cc, '', '', array(), '', false, 'ISO-8859-1', false);");
                } else {
                    echoLog('Not email found on document: ' . $r ['IDCODE']);
                }
            } else {
                $r ['USERNAME'] = $_SESSION ['user_record'] ['username'];
            }
            // set notification date
            $sql = 'UPDATE CMP_ACCOUNT_DOCS SET  EXP_REMINDED_DATE = ' . singleQuote($this->now) . ', REMINDED_USER = ' . singleQuote($r ['USERNAME']) . ' WHERE IDCODE = ' . singleQuote($r ['IDCODE']);
            ClxCommon::$db->executeQuery($sql);
        }
    }

// end method
    /**
     * Request account synchronization
     *
     * @param unknown_type $accountcode
     * @param unknown_type $compliance_status
     */
    function requestAccoSynch($accountcode, $compliance_status) {
        // setting compliance estatus where not excempt
        $sql = 'UPDATE CRM_ACCOUNTS SET COMPLIANCE_STATUS=' . singleQuote($compliance_status) . ' WHERE IDCODE = ' . singleQuote($accountcode) . ' AND COMPLIANCE_STATUS<>2';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE CRM_ACCOUNTS SET REQ_SYNCH = 1 WHERE IDCODE = ' . singleQuote($accountcode);
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     * Validates transaction according to account
     * @param string $contract_code
     * @param string $accountcode
     * @param string $on_authorize
     * @return boolean
     */
    function validateProcessTransaction($contract_code, $accountcode, $on_authorize = false) {
        /* Transaction Approval (FIAT_APR)   Transaction Validation (FIAT_VAL) */
        $type = ($on_authorize) ? 'FIAT_APR' : 'FIAT_VAL';
        $sql = 'SELECT CMBP.IDCODE FROM ' . $this->cmbpname . ' CMBP WHERE CMBP.CONTRACT_CODE = ' . singleQuote($contract_code) . ' AND CMBP.STATUS = ' . singleQuote('A') . ' AND BP_TRIGGER_EVENT = ' . singleQuote($type);
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            if (empty( $this->validateCmap($accountcode, $r['IDCODE'])) )
                return false;
        }
        return true;
    }

    function get_new_kype_secuence(&$record){
        if (UserRequest::$request['ac'] === 'CREATE'){
            $pep_seq = '(IFNULL(MAX(KYPE.PEP_SEQNUM),0))+1';
        }elseif(UserRequest::$request['ac'] === 'DUPLICATE_EFFTDATE'){
            $pep_seq = 'KYPE.PEP_SEQNUM';
        }

        $sql = 'SELECT '.$pep_seq.' PEP_SEQNUM FROM '.$this->kypename.' KYPE WHERE KYPE.ACCOUNTCODE = '.singleQuote($record['ACCOUNTCODE']);
        $last_pep_seq = ClxCommon::$db->getOne($sql);
        $record['PEP_SEQNUM'] = $last_pep_seq;
    }

}
