<?php
/**
 * ETL utilities
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-09-29 17:46:00 -0500 (Thu, 20 Sep 2018) $
 * @version    	$Rev: 10045 $
 */

class ETL_utilities {

    private $etl_param = array();
    private $etl_objs = array();
    
    const URL_LABEL_PREFIX = '- ';
    const DEF_LABEL_NOT_AVAIL = '** N/A **';    
    const DEF_VALUE_FOR_NOTIFICATION = '-';
    const DEF_URL_EDIT_DISPLAY = '<A HREF="'.kWebSite.'tool.php?to=EDIT&ac=DISPLAY&li=%LISTING%&idlist=%IDLIST%">%LABEL%</A>';
    const DEF_URL_TOOL_DISPLAY = '<A HREF="'.kWebSite.'tool.php?to=%TOOLCODE%&ac=DISPLAY&idlist=%IDLIST%">%LABEL%</A>';
    
    /**
     * Constructor
     * @param array $procParameters
     * @return void
     */
    function __construct($procParameters = array()) {
        /*
         * IMCF = CLX_ETL_IMPORT_CFG | Import Configurator Table
         * IMFT = CLX_ETL_IMPFILES_TMP | ETL - Import Files to be processed
         * IMOQ = CLX_ETL_OP_QUEUE | ETL - Processing Queue
         */
        $this->etl_param = $procParameters;
        // Nombres de tablas
        multiTableName($this, array('IMCF','IMOC', 'IMFT', 'IMOQ', 'PRRO', 'PRRP', 'DBIX'));
        // Lee Objetos CLXtools una sola vez
        $this->etl_objs['DBIX'] = &getTool('DBIX');
        //$this->etl_objs['SYAL'] = &getTool('SYAL');
        $this->etl_objs['UITM'] = &getTool('UITM');
        $this->etl_objs['PREL'] = &getTool('PREL');
        $this->etl_objs['ACUS'] = &getTool('ACUS');
		
		
        
        // Parametros generales
        $this->etl_param['debug'] = (!empty($this->etl_param['FLG_DEBUG'])) ? $this->etl_param['FLG_DEBUG'] == '1' : false;
//$this->etl_param['debug'] = true;
        $this->etl_param['BATCH_ID'] = (!empty($this->etl_param['BATCH_ID'])) ? $this->etl_param['BATCH_ID'] : batch_id();
        $this->etl_param['FILE_NAME_SEP'] = (!empty($this->etl_param['FILE_NAME_SEP'])) ? $this->etl_param['FILE_NAME_SEP'] : '_-_';
        $this->etl_param['username'] = $_SESSION['user_record']['username'];
        if (!empty(clx_language_lower_upper($_SESSION ['prefs'] ['LANGUAGE']))) {
            $this->etl_param['lang'] = clx_language_lower_upper($_SESSION ['prefs'] ['LANGUAGE']);
        } else {
            $this->etl_param['lang'] = clx_language_lower_upper(kSystemLanguage);
        }
        $this->etl_param['DBIM_test'] = (!empty($this->etl_param['TEST'])) ? $this->etl_param['TEST'] : '0';
        $this->etl_param['DBIM_show_file'] = (!empty($this->etl_param['SHOW_FILE'])) ? $this->etl_param['SHOW_FILE'] : '0';
        $this->etl_param['DBIM_error_limit'] = (!empty($this->etl_param['ERROR_LIMIT'])) ? $this->etl_param['ERROR_LIMIT'] : '100';
        // Variables generales
        $this->etl_param['error'] = array();
        $this->etl_param['qty_proc'] = CLX_INIT_ZERO;
        $this->etl_param['qty_err'] = CLX_INIT_ZERO;
        // Fecha de hoy para consultas contra CLX_EFFTDATE
        $this->etl_param['clx_date_par'] = singleQuote(xFormat::getNow('Y-m-d'));
        if (kDatabaseType === 'oci') {
            $this->etl_param['clx_date_par'] = ClxCommon::$db->db_to_date($this->etl_param['clx_date_par']);
        }
        // Parametros de directorios
		PRE($this->etl_param['COMP_CODE']);
        $this->etl_param['COMP_CODE'] = (!empty($this->etl_param['COMP_CODE'])) ? trim($this->etl_param['COMP_CODE']) : null;
        $this->etl_param['ETL_IMPORT_PEND_DIR'] = companyParameterDef('ETL_IMPORT_PEND_DIR', null, $this->etl_param['COMP_CODE']);
        $this->etl_param['ETL_IMPORT_REJ_DIR'] = companyParameterDef('ETL_IMPORT_REJ_DIR', null, $this->etl_param['COMP_CODE']);
        $this->etl_param['ETL_IMPORT_PROC_DIR'] = companyParameterDef('ETL_IMPORT_PROC_DIR', null, $this->etl_param['COMP_CODE']);
	//	$this->etl_param['ETL_IMPORT_PROC_DIR'] = companyParameterDef('ETL_IMPORT_PROC_DIR', null, $this->etl_param['COMP_CODE']);
		$this->etl_param['ETL_INFORMATION_CLOSE'] = companyParameterDef('ETL_INFORMATION_CLOSE', null, $this->etl_param['COMP_CODE']);
		//
		
        $this->etl_param['ETL_FTP_BASE_DIR'] = companyParameterDef('ETL_FTP_BASE_DIR', '', $this->etl_param['COMP_CODE']);
		// No interesan los separadores de directorio al final
		$this->etl_param['ETL_FTP_BASE_DIR'] = rtrim($this->etl_param['ETL_FTP_BASE_DIR'], '\\');
		$this->etl_param['ETL_FTP_BASE_DIR'] = rtrim($this->etl_param['ETL_FTP_BASE_DIR'], '/');
		$this->etl_param['ETL_FTP_BASE_DIR'] = rtrim($this->etl_param['ETL_FTP_BASE_DIR'], ':');
        // Data para alertas
        $this->etl_param['ETL_DEF_ALERT_TEMPLATE'] = companyParameterDef('ETL_DEF_ALERT_TEMPLATE', null, $this->etl_param['COMP_CODE']);
        $this->etl_param['ETL_DEF_NOTIFY_ROLE'] = companyParameterDef('ETL_DEF_NOTIFY_ROLE', null, $this->etl_param['COMP_CODE']);
        $this->etl_param['ETL_DEF_LSTG_IMFT'] = companyParameterDef('ETL_DEF_LSTG_IMFT', 'IMFT', $this->etl_param['COMP_CODE']);
        $this->etl_param['ETL_DEF_LSTG_IMCF'] = companyParameterDef('ETL_DEF_LSTG_IMCF', 'IMCF', $this->etl_param['COMP_CODE']);
        $this->etl_param['ETL_DEF_LSTG_IMOQ'] = companyParameterDef('ETL_DEF_LSTG_IMOQ', 'IMOQ', $this->etl_param['COMP_CODE']);
		
		// PENDIENTE
		$this->etl_param['ETL_HOUR_ALERT_FILE_NOT_FOUND'] = companyParameterDef('ETL_HOUR_ALERT_FILE_NOT_FOUND', '00:02', $this->etl_param['COMP_CODE']);
		// PENDIENTE
        // Debug report
		IF (ISSET($_SESSION['ADDRDEBUGETL']) && $_SESSION['ADDRDEBUGETL']==$_SERVER['REMOTE_ADDR']) {
			$this->etl_param['debug']=true;
			
		}	
        if($this->etl_param['debug'] === true) {
			pre($this->etl_param['ETL_IMPORT_PROC_DIR']);
			pre($this->etl_param['ETL_IMPORT_PEND_DIR']);		
			pre($this->etl_param['ETL_INFORMATION_CLOSE']);
			pre($procParameters); 
		}
    }
    function send_alert_not_diary_file() {
	
		$sql='	SELECT A.FILENAME_MASK,A.IMPORT_CODE,A.ID, A.COMP_CODE,TO_CHAR(CURRENT_DATE,'.singlequote('YYYY/MM/DD').')'.
					' DIA,TO_CHAR(A.CHECKING_HOUR,'.singlequote('HH24:MI:SS').')'.
					' CHECKING_HOUR from CLX_ETL_IMPORT_CFG A '.
			 '	WHERE STATUS='.singleQuote('A'). ' AND  TO_CHAR(A.CHECKING_HOUR,'.singlequote('HH24:MI:SS').')'.
					' <=TO_CHAR(CURRENT_DATE,'.singlequote('HH24:MI:SS').')'.
					' AND TO_CHAR(A.CHECKING_HOUR,'.singlequote('MI').')=TO_CHAR(CURRENT_DATE,'.singlequote('MI').')'.
				' MINUS '.
			 '	SELECT A.FILENAME_MASK,A.IMPORT_CODE,A.ID, A.COMP_CODE, TO_CHAR(CURRENT_DATE,'.singlequote('YYYY/MM/DD').')'.
					' DIA,TO_CHAR(A.CHECKING_HOUR,'.singlequote('HH24:MI:SS').')'.
					' CHECKING_HOUR from CLX_ETL_IMPORT_CFG A LEFT JOIN CLX_ETL_IMPFILES_TMP B '.
				' ON A.ID=B.IMCF_ID '.
				'	WHERE STATUS='.singleQuote('A'). ' AND  TO_CHAR(CURRENT_DATE,'.singlequote('YYYY/MM/DD').')'.
				'=TO_CHAR(B.CDATE,'.singlequote('YYYY/MM/DD').')'; 

		$_results = ClxCommon::$db->executeQuery($sql);
		while (($_record = ClxCommon::$db->getNextRecord($_results, ASSOCIATIVE))) {
			$errorMsg = dict('GEN_ERR_ETL', dict('GEN_ERR_ETL_FILE_NOT_FOUND2'),  $_record['IMPORT_CODE'],'') . ' [049]';
			$this->etl_send_alert($errorMsg,array('ETL_FILENAME' => $_record['FILENAME_MASK']));
			pre($errorMsg);
		}
    }
    /**
     * Proceso principal de ETL
     * @param void
     * @return boolean
     */
    function main_process() {
		$this->send_alert_not_diary_file();

		if($this->etl_param['debug'] === true) {
			echo "==========";pre($_SESSION);echo"=======,";
			echo "Function main_process, <br>"; 
		}
        // Levanta elementos básicos necesarios para el reporte de errores y el proceso en general
        $this->get_sys_email_from_data();
        $this->get_table_name_labels();
        // Verificaciones preliminares que condicionan el procesamiento completo
        if($this->pre_verifications() === false) {
            return false;
        }
        // Lee directorio y registra archivos en la tabla temporal
        $this->dir_process($this->etl_param['ETL_IMPORT_PEND_DIR']);
        // Procesa cada importador registrado
        $this->etl_process();
        // Para los archivos temporales que no encuentra importador, los mueve al directorio de archivos con error
        $this->etl_no_processed_moving();
	////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////	
		// Para procesos sin archivos
        if (date('H:i')<$this->etl_param['ETL_HOUR_ALERT_FILE_NOT_FOUND']){//echo 'if si';
			$this->etl_no_found_file();
		}
        // Si hubo errores, los reporta
        $this->etl_param['qty_err'] = count($this->etl_param['error']);
        if($this->etl_param['qty_err'] > 0) {
            // Si falta algun directorio, registra error y termina
            $this->log_error($this->etl_param['error']);
        }
        /*
         * GEN_ETL_MSG_010
         * ETL Process finished. ^1 files processed, ^2 errors
         * Proceso ETL terminado. ^1 archivos procesados, ^2 errores
         */
        $this->log_normal(dict('GEN_ETL_MSG_010', $this->etl_param['qty_proc'], $this->etl_param['qty_err']));
        return ($this->etl_param['qty_err'] == CLX_INIT_ZERO);
    }
    
    /**
     * Lee directorio y registra archivos en la tabla temporal
     * @param varchar $dir
     * @return void
     */
    function dir_process($dir) {
		if($this->etl_param['debug'] === true) {
			echo "Function dir_process, <br>"; 
			echo "scandir, <br>";
			pre($dir);
		}
		$sql = 'SELECT * FROM ' . $this->imcfname .
		' WHERE ETL_MANUAL_WORK=0 '.
		' AND STATUS='.singleQuote('A') .
		((is_null($this->etl_param['COMP_CODE'])) ?'':'  AND COMP_CODE = '.
		singleQuote($this->etl_param['COMP_CODE']));//echo $sql,"<br>";
		$IMCF_results = ClxCommon::$db->executeQuery($sql);
		if($this->etl_param['debug'] === true) {
			echo "===============imcf =============";
			echo "sql <br>";
			pre($sql);  
		}
		$IMCF_all_records=array();	
		while (($IMCF_record = ClxCommon::$db->getNextRecord($IMCF_results, ASSOCIATIVE))) {//echo 'si while 2<br>';
			$IMCF_all_records[]=$IMCF_record;
		}
		$dir_files = scandir($dir);
		$all_imoc=array();
		$imoc_filename=array();
		foreach($dir_files as $filename) {
			if (in_array($filename,array('.','..'))) { 
                // Marcas de directorios especiales
                continue;
            }
			foreach ($IMCF_all_records as $keyC=>$IMCF_record) {
		//		ECHO "/".$IMCF_record['FILENAME_FINISH']."/<BR>".$filename."<BR>";
				
				if (preg_match("/".$IMCF_record['FILENAME_FINISH']."/i",$filename,$matches)) {
					//pre($matches);
						
					$xa=fopen($dir."/".$filename,'r');
					$read=preg_split("/(\r)|(\n)/",fread($xa,filesize($dir."/".$filename)));
					fclose($xa);
					//}
					if($this->etl_param['debug'] === true) {
						pre("content finish");
						pre($read);
					}
					$rec_id=0;
					$imoc_filename[]=$filename;
					
					foreach ($read as $tkey=>$tvalue) {
						if (empty($tvalue)) { 
							// Marcas de directorios especiales
							continue;
						}
						if($this->etl_param['debug'] === true) {	
							ECHO " 	'$tvalue'=='{$IMCF_record['INFORMATION_FINISH']}' ";
						}
						if ($tvalue==$IMCF_record['INFORMATION_FINISH'] AND !EMPTY($tvalue) ) {
							

							$IMOC_record=array();
							$IMOC_record['FILE_NAME'] =$filename;
							$IMOC_record['FILEDATE'] = date ("Y/m/d", filemtime($dir."/".$filename));
							$IMOC_record['CLX_EFFTDATE'] = xFormat::getNow('Y-m-d H:i:s');;
							$IMOC_record['FILE_EXT'] = uppercase(end(explode('.', $filename)));
							$IMOC_record['FILENAME_MASK']=$IMCF_record['FILENAME_MASK'];
							$IMOC_record['CDATE'] = xFormat::getNow('Y-m-d H:i:s');
							$IMOC_record['MDATE'] = xFormat::getNow('Y-m-d H:i:s');
							$IMOC_record['CREATEDBY'] = $this->etl_param['username'];
							$IMOC_record['MODIFIEDBY'] = $this->etl_param['username'];
							$IMOC_record['STATUS'] = 'PEND';
							$IMOC_record['TEXT_INFORMATION_CLOSE'] = $tvalue;
							$IMOC_record['COMP_CODE']=$this->etl_param['COMP_CODE'];
							$IMOC_record['REC_ID']= ClxCommon::$db->getOne('SELECT count(*) FROM '.$this->imocname.' WHERE FILE_NAME='.singleQuote($IMOC_record['FILE_NAME']))+1;
	           				$IMOC_record['IMCF_ID']=$IMCF_record['ID'];
							$IMOC_record['IMOC_ID'] = ClxCommon::$db->createRecord($this->imocname, $IMOC_record, false);
							ClxCommon::$db->EXECUTEQUERY('COMMIT');
							$imoc_all[]=$IMOC_record;
							if($this->etl_param['debug'] === true) {
								pre("imoc_creado");
								pre($IMOC_record);
								
							}
						}	
						else {
							if($this->etl_param['debug'] === true) {
								pre("imoc no creado");
								
							}
						}	
					}
					
				}
		/*		else if ($IMCF_record['FILE_FINISH']==0) {
				 	$IMOC_record=array();
					$IMOC_record['FILE_NAME'] =$filename;
					$IMOC_record['FILEDATE'] = date ("Y/m/d", filemtime($dir."/".$filename));
					$IMOC_record['CLX_EFFTDATE'] = xFormat::getNow('Y-m-d H:i:s');;
					$IMOC_record['FILE_EXT'] = uppercase(end(explode('.', $filename)));
					$IMOC_record['FILENAME_MASK']=$IMCF_record['FILENAME_MASK'];
					$IMOC_record['CDATE'] = xFormat::getNow('Y-m-d H:i:s');
					$IMOC_record['MDATE'] = xFormat::getNow('Y-m-d H:i:s');
					$IMOC_record['CREATEDBY'] = $this->etl_param['username'];
					$IMOC_record['MODIFIEDBY'] = $this->etl_param['username'];
					$IMOC_record['STATUS'] = 'PEND';
					$IMOC_record['TEXT_INFORMATION_CLOSE'] = $tvalue;
					$IMOC_record['COMP_CODE']=$this->etl_param['COMP_CODE'];
					$IMOC_record['REC_ID']= ClxCommon::$db->getOne('SELECT count(*) FROM '.$this->imocname.' WHERE FILE_NAME='.singleQuote($IMOC_record['FILE_NAME']))+1;
					$IMOC_record['IMCF_ID']=$IMCF_record['ID'];
					$IMOC_record['IMOC_ID'] = ClxCommon::$db->createRecord($this->imocname, $IMOC_record, false);
					ClxCommon::$db->EXECUTEQUERY('COMMIT');
					$imoc_all[]=$IMOC_record;
					if($this->etl_param['debug'] === true) {
						pre("imoc_creado");
						pre($IMOC_record);
						
					}
					
				}*/
			}
			if($this->etl_param['debug'] === true) {
				PRE($imoc_all);
			}
			foreach ($imoc_filename as $key=>$filenamex) {
				if(!rename($dir."/".$filenamex, $this->etl_param['ETL_INFORMATION_CLOSE']."/".$filenamex)) {
							
						
				}
			}		
		}	
				
			
        $dir_files = scandir($dir);
        //$this->etl_param['qty_proc'] = CLX_INIT_ZERO;
        foreach($dir_files as $filename) {
			if($this->etl_param['debug'] === true) {
				echo "<b>dir_process filename:",$filename,"</b><br>";
			}
			
            if (in_array(trim($filename),array('.','..'))) { 
                // Marcas de directorios especiales
				if($this->etl_param['debug'] === true) {
					echo "<br><br>continue<br>";
                }
                continue;
            }
			$continue=true;
			if($this->etl_param['debug'] === true) {
				echo "================================================================<br>";	
			}
			foreach ($IMCF_all_records as $keyC=>$IMCF_record) {
				if($this->etl_param['debug'] === true) {
					pre($IMCF_record);
					ECHO "/".$IMCF_record['FILENAME_MASK']."/<BR>".$filename."<BR>";
					
					echo 'preg_match("/"."'.$IMCF_record['FILENAME_MASK'].'"."/i","'.$filename.'");';
					
				}
				if (preg_match("/".$IMCF_record['FILENAME_MASK']."/i",$filename,$matches)) {
					if($this->etl_param['debug'] === true) {
						echo "<br><br> match found PREGMATCH1 valido<br>";
						pre($matches);
					}
					if ($IMCF_record['FILE_FINISH']==1) {
						if($this->etl_param['debug'] === true) {
							echo "<br><br>verify get file_finish<br>";
							
						}
						foreach ($imoc_all as $keyC=>$IMOC_record) {
							if (preg_match("/".$IMOC_record['FILENAME_MASK']."/i",$filename,$matches)) {
								if($this->etl_param['debug'] === true) {
									echo "<br><br>pregmatch2<br>";
								}
								$continue=false;
								break;	
						
							}
						}
						
					}
					else {
						$continue=false;
					}
					if ($continue==false) {
						if($this->etl_param['debug'] === true) {
							echo "<br><br> break continue false<br>";
						}	
						break;
					}	
				}
				else {
					if($this->etl_param['debug'] === true) {
						echo "<br><br>====not match found PREGMATCH1<br>";
						pre ($filename);
						pre ($IMCF_record['FILENAME_MASK']);
						echo "<br>end not match found";
					}	
				}	
			}
			
			if ($continue==true) {
				if($this->etl_param['debug'] === true) {
					echo "<br>continue es true<br>";
				}	
				continue;
			}
			else {
				if($this->etl_param['debug'] === true) {
					echo "<br>next instruccion<br>";
				}	
			}
            if (is_dir($dir . DIRECTORY_SEPARATOR . $filename)) { 
                // Es un subdirectorio
                $this->dir_process($dir . DIRECTORY_SEPARATOR . $filename);
                continue;
            }
			else if($this->etl_param['debug'] === true) {
					echo "create IMFT <br>";
			}	
		

            // Crea fila en tabla temporal de archivos por procesar [IMFT]
            $filespec_from = $dir . DIRECTORY_SEPARATOR . $filename;
            $filespec_data = pathinfo($filespec_from);
            $IMFT_record = array();
            $IMFT_record['ETL_FILENAME'] = $filename;
            $IMFT_record['ETL_FILEPATH'] = $filespec_data['dirname'];
            $IMFT_record['ETL_FILEDATE'] = date('Y-m-d H:i:s', filemtime($filespec_from));
            $IMFT_record['ETL_FILEEXT'] = $filespec_data['extension'];
            $IMFT_record['ETL_FILEID'] = '';
            $IMFT_record['ETL_FILESEQ'] = CLX_INIT_ZERO;
            $IMFT_record['ETL_STATUS'] = 'PEN';
            $IMFT_record['ETL_OBS'] = '';
            $IMFT_record['RUNID'] = $this->etl_param['BATCH_ID'];
            $IMFT_record['CDATE'] = xFormat::getNow('Y-m-d H:i:s');
			$IMFT_record['IMCF_ID'] = $IMCF_record['ID'];
			
			
            $IMFT_id = ClxCommon::$db->createRecord($this->imftname, $IMFT_record, false);
            // Mueve archivo al directorio de pendientes de proceso
//			
//		$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivoETL2.txt','a+');
//		fwrite($tta,chr(13).chr(10).' hora:'.date( 'h:i:s d/m/Y').chr(13f).chr(10));	
//		fwrite($tta,chr(13).chr(10).'l-174::IMFT_id '.$IMFT_id.chr(13).chr(10));fclose($tta);
//			
            $filespec_dest = $this->etl_param['ETL_IMPORT_PROC_DIR'] . DIRECTORY_SEPARATOR . $IMFT_id . $this->etl_param['FILE_NAME_SEP'] . $IMFT_record['ETL_FILENAME'];
            if($this->etl_param['debug'] === true) {
				echo "IMFT_record<br>";
				pre($IMFT_record);
            echo $filespec_from, ",",$filespec_dest,"<br>";
			}
			if(!rename($filespec_from, $filespec_dest)) {
                /*
                 * GEN_ETL_ERR_020
                 * Could not move "^1" to "^2"
                 * No se pudo mover "^1" a "^2"
                 */
                $msg = dict('GEN_ETL_ERR_020', $filespec_from, $filespec_dest) . ' [010]';
                // OJO no se envia 'IMFT-ID' al alerta porque luego se elimina el registro...
                $this->etl_send_alert($msg, $IMFT_record); 
                // Elimina el registro de la tabla temporal
				if($this->etl_param['debug'] === true) {
					echo "delete ",$this->imftname," record: ",$IMFT_id,"<br>";
					
				}	
                ClxCommon::$db->deleteRecords($this->imftname, 'ID='.$IMFT_id);
            } else {
                // Actualiza directorio actual del archivo, porque lo pudo mover
                $record = array();
                $record['ETL_FILEPATH'] = $this->etl_param['ETL_IMPORT_PROC_DIR'];
                if($this->etl_param['debug'] === true) { ClxCommon::$db->debug=true; }
                ClxCommon::$db->updateRecord($this->imftname, $record, 'ID='.$IMFT_id);
                if($this->etl_param['debug'] === true) { ClxCommon::$db->debug=false; }
                $this->etl_param['qty_proc']++;
				if($this->etl_param['debug'] === true) {
					echo "update ",$this->imftname," record: ",$IMFT_id,"<br>";
					pre($record);
				}	
            }
        }
		foreach ($IMOC_all as $keyC=>$IMOC_record) {
			$sql='UPDATE '.$this->imocname. ' SET STATUS='.singleQuote('END') . ' WHERE ID='.$IMOC_record['IMOC_ID'];
			ClxCommon::$db->executeQuery($sql);
		}
		// actualizando campo a PEN cuando este en blanco, falla que no se entiende porque ocurre en el cliente
		$sql='UPDATE '.$this->imftname. ' SET ETL_STATUS='.singleQuote('PEN') . ' WHERE ETL_STATUS IS NULL OR ETL_STATUS='. singleQuote(''); 
		ClxCommon::$db->executeQuery($sql);
		if($this->etl_param['debug'] === true) { 
		   echo $sql,"<br>";
		}   
		$sql='UPDATE '.$this->imftname. ' SET ETL_STATUS='.singleQuote('ERR') . ', ETL_OBS='. singleQuote('ERROR INSERT QUEUE')  .' WHERE ETL_STATUS='. singleQuote('PRU'); 
		ClxCommon::$db->executeQuery($sql);
		if($this->etl_param['debug'] === true) { 
		   echo $sql,"<br>";
		}
		ClxCommon::$db->executeQuery('commit');	
	}
    
    /*
     * Validaciones de archivos no procesado o no recibidos que debieron estar
     * Validaciones de archivos no procesado o no recibidos que debieron estar
     * @param void
     * @return void
     */
    function etl_no_found_file() {
		if($this->etl_param['debug'] === true) {
			echo "Function etl_no_found_file, <br>"; 
		}
		//Registros que no tengan archivos con la fecha de ayer y que esten dentro de la expresion regular valida
		
		if (kDatabaseType === 'oci') {
			$sql='SELECT * FROM ( SELECT B.IMPORT_CODE,B.FILENAME_MASK,B.ID,MAX(CASE WHEN A.CLX_EFFTDATE IS NULL THEN TO_DATE('.
				singleQuote('1970/01/01').','.singleQuote('yyyy/mm/dd').') ELSE A.CLX_EFFTDATE END) MAX_DATE '.
				' FROM CLX_ETL_IMPORT_CFG B LEFT JOIN CLX_ETL_OP_QUEUE A ON A.IMPORT_CODE=B.IMPORT_CODE WHERE B.STATUS='.singleQuote('A').' GROUP BY  B.IMPORT_CODE,B.FILENAME_MASK,B.ID) X  WHERE trunc(CURRENT_DATE) >(MAX_DATE + 1)  ';
		}
		else {
			$sql='SELECT * FROM ( SELECT B.IMPORT_CODE,B.FILENAME_MASK,B.ID,TRUNC(MAX(CASE WHEN A.CLX_EFFTDATE IS NULL THEN DATE('.
				singleQuote('1970/01/01').') ELSE A.CLX_EFFTDATE END)) MAX_DATE '.
				' FROM CLX_ETL_IMPORT_CFG B LEFT JOIN CLX_ETL_OP_QUEUE A ON A.IMPORT_CODE=B.IMPORT_CODE WHERE B.STATUS='.singleQuote('A').' GROUP BY  B.IMPORT_CODE,B.FILENAME_MASK,B.ID) X  WHERE CURDATE()>DATE_ADD(MAX_DATE, INTERVAL 1 DAY)';
		}	
		
		$IMQuery_results = ClxCommon::$db->executeQuery($sql);
		if($this->etl_param['debug'] === true) {
			echo "sql<br>";
			pre($sql);
		}	
        while (($IMQuery_record = ClxCommon::$db->getNextRecord($IMQuery_results, ASSOCIATIVE))) { //echo 'si while 1<br>';
			$sql = 'SELECT * FROM ' . $this->imcfname . ' WHERE STATUS='.singleQuote('A') . ' AND ID ='.$IMQuery_record['ID'].((is_null($this->etl_param['COMP_CODE'])) ?'':' AND COMP_CODE = '.singleQuote($this->etl_param['COMP_CODE']));//echo $sql,"<br>";
			$IMCF_results = ClxCommon::$db->executeQuery($sql);
			if($this->etl_param['debug'] === true) {
				echo "sql2 <br>";
				pre($sql);  
			}
			
			while (($IMCF_record = ClxCommon::$db->getNextRecord($IMCF_results, ASSOCIATIVE))) {//echo 'si while 2<br>';
				//Verifica fecha a ejecutar, devuelve dos parametros Run si debe correr hoy y el segundo (no usado aqui) INACT pasar a Inactivo el ETL
				if($this->etl_param['debug'] === true) {
					echo "IMCF_record <br>";
					pre($IMCF_record);  
				}	
				$getNextRun=$this->GetNextRun($IMCF_record,true);
				
				if ($getNextRun['run']) {
					$errorMsg = dict('GEN_ERR_ETL', dict('GEN_ERR_ETL_FILE_NOT_FOUND'),  $IMCF_record['IMPORT_CODE'],'') . ' [029]';
					$this->etl_send_alert($errorMsg,array('ETL_FILENAME' => $IMCF_record['FILENAME_MASK']));
				}
				
				
			}
			
		}
    }
		
    /*
     * Procesa cada importador registrado, comparando los registros 
     * @param void
     * @return void
     */
    function etl_process() {
		if($this->etl_param['debug'] === true) {
			echo "Function etl_process, <br>"; 
		}
        $sql_where_extra = '';
        $binds = array();
        $binds['STATUS'] = 'A';
        if(!is_null($this->etl_param['COMP_CODE'])) {
            $binds['COMP_CODE'] = $this->etl_param['COMP_CODE'];
            $sql_where_extra .= ' AND COMP_CODE = :COMP_CODE';
        }
        // Tabla IMCF : $this->imcfname : CLX_ETL_IMPORT_CFG
        $sql = 'SELECT * FROM ' . $this->imcfname . ' WHERE STATUS=:STATUS' . $sql_where_extra;
        $IMCF_results = ClxCommon::$db->executeQueryUniversal($sql, $binds);
        if($this->etl_param['debug'] === true) { pre($sql); pre($binds); }
       // $a=fopen(kPathToWebSite."temp/salida.txt","a+");fwrite($a,"$sql ".chr(13).chr(10).print_r($binds,true));fclose($a) ;
		$arrayETL=array();
        while (($IMCF_record = ClxCommon::$db->getNextRecord($IMCF_results, ASSOCIATIVE))) {//$a=fopen(kPathToWebSite."temp/salida.txt","a+");fwrite($a,"primer ciclo(configuracion)".print_r($IMCF_record,true));fclose($a);
            //Verifica fecha a ejecutar, devuelve dos parametros Run si debe correr hoy y el segundo INACT pasar a Inactivo el ETL
            // Busca el archivo por patron de expresión regular
			// cambiado a extra2 para un query al final con los parametros anteriores del query anterior
            $sql_where_extra2 = '';
            //$binds = array($IMCF_record);
			//cambiados a binds2 para al final con los parametros anteriores del query anterior 
            $binds2 = array();
            $binds2['FILENAME_MASK'] = $IMCF_record['FILENAME_MASK'];
            $binds2['RUNID'] = $this->etl_param['BATCH_ID'];
            $binds2['ETL_STATUS'] = 'PEN';
            // Tabla IMFT : $this->imftname : CLX_ETL_IMPFILES_TMP
			if (kDatabaseType === 'oci') {
                //$sql = 'SELECT * FROM ' . $this->imftname . ' WHERE (ETL_FILESEQ = 0 OR ETL_FILESEQ IS NULL OR RUNID = :RUNID) AND REGEXP_LIKE (ETL_FILENAME, :FILENAME_MASK, ' . singleQuote('i') . ')' . $sql_where_extra2;
                $sql = 'SELECT * FROM ' . $this->imftname . ' WHERE (ETL_STATUS = :ETL_STATUS OR RUNID = :RUNID) AND REGEXP_LIKE (ETL_FILENAME, :FILENAME_MASK, ' . singleQuote('i') . ') ' . $sql_where_extra2;
            } else {
                //$sql = 'SELECT * FROM ' . $this->imftname . ' WHERE (ETL_FILESEQ = 0 OR ETL_FILESEQ IS NULL OR RUNID = :RUNID) AND ETL_FILENAME REGEXP :FILENAME_MASK' . $sql_where_extra2;
                $sql = 'SELECT * FROM ' . $this->imftname . ' WHERE (ETL_STATUS = :ETL_STATUS OR RUNID = :RUNID) AND ETL_FILENAME REGEXP :FILENAME_MASK ' . $sql_where_extra2;
            }
			
            if($this->etl_param['debug'] === true) { 
				ECHO "SQL IMFT LINEA APROXIMADA 526<BR>";
				pre($sql); pre($binds2); 
			}
			
            $IMFT_results = ClxCommon::$db->executeQueryUniversal($sql, $binds2);
			
		    // Si la encuentra, hace entrada en la cola de procesamiento
            while (($IMFT_record = ClxCommon::$db->getNextRecord($IMFT_results, ASSOCIATIVE))) { //$a=fopen(kPathToWebSite."temp/salida.txt","a+");fwrite($a,"segundo ciclo ciclo(ejecuccion)".print_r($IMFT_record,true));fclose($a);
			// DEL GROUP CONSULTO EL REGISTRO COMPLETO
				if($this->etl_param['debug'] === true) { 
					ECHO "IMFT_record<BR>";
					pre($IMFT_record);
				}
				if (!is_array($arrayETL[$IMFT_record['ETL_FILENAME']]))
					$arrayETL[$IMFT_record['ETL_FILENAME']]=array();
				$arrayETL[$IMFT_record['ETL_FILENAME']][]=array($IMCF_record,$IMFT_record);
			}	
        }
		foreach ($arrayETL as $filenamegroup =>$records) {			
			if($this->etl_param['debug'] === true) { 
				ECHO "filenamegroup<BR>";
				pre($filenamegroup);
				ECHO "record<BR>";
				pre($record);
			}		
			$valid_resp=array();
			$contador_valid=0;
			$IMOQ_record=array();
			for ($t=0;$t<count($records);$t++) {
				list($IMCF_record,$IMFT_record)=$records[$t];
				$getNextRun=$this->GetNextRun($IMCF_record);
				$evaluate=$this->IMOQ_Validations($IMCF_record, $IMFT_record,$getNextRun);
				if (!$evaluate['result']) {  				
					$valid_resp[++$contador_valid -1] = array($evaluate,$IMFT_record);
					continue;
				}
                // Tabla IMOQ : $this->imoqname : CLX_ETL_OP_QUEUE
                if($this->etl_param['debug'] === true) { pre($IMCF_record); }
                //
				
				$imoq_filename = $IMFT_record['ID'] . $this->etl_param['FILE_NAME_SEP'] . $IMFT_record['ETL_FILENAME'];
                $IMOQ_record['FILE_NAME'] = $imoq_filename;
                //
                $IMOQ_record['FILEDATE'] = $IMFT_record['ETL_FILEDATE'];
                $IMOQ_record['CLX_EFFTDATE'] = $IMFT_record['ETL_FILEDATE'];
                $IMOQ_record['FILE_EXT'] = uppercase($IMFT_record['ETL_FILEEXT']);
                $IMOQ_record['IMFT_ID'] = $IMFT_record['ID'];
                //
                $IMOQ_record['CDATE'] = xFormat::getNow('Y-m-d H:i:s');
                $IMOQ_record['MDATE'] = xFormat::getNow('Y-m-d H:i:s');
                $IMOQ_record['CREATEDBY'] = $this->etl_param['username'];
                $IMOQ_record['MODIFIEDBY'] = $this->etl_param['username'];
                $IMOQ_record['REC_STATUS'] = 'IDLE';
                $IMOQ_record['DBIM_ID'] = CLX_INIT_ZERO;
                $IMOQ_record['COMP_CODE']=$IMCF_record['COMP_CODE'];
                //
                $IMOQ_record['IMPORT_CODE']=$IMCF_record['IMPORT_CODE'];
				$IMOQ_record['IMPORT_CODE2']=$IMCF_record['IMPORT_CODE2'];
				$IMOQ_record['IMPORT_CODE3']=$IMCF_record['IMPORT_CODE3'];
				$IMOQ_record['IMPORT_CODE4']=$IMCF_record['IMPORT_CODE4'];
                $IMOQ_record['RECURRENT_R2']=$IMCF_record['RECURRENT_R2'];
                $IMOQ_record['RECURRENT_R3']=$IMCF_record['RECURRENT_R3'];
                $IMOQ_record['RECURRENT_R4']=$IMCF_record['RECURRENT_R4'];
                $IMOQ_record['RECURRENT_R5']=$IMCF_record['RECURRENT_R5'];
                $IMOQ_record['RECURRENT_R6']=$IMCF_record['RECURRENT_R6'];
                $IMOQ_record['RECURRENT_R7']=$IMCF_record['RECURRENT_R7'];
                $IMOQ_record['RECURRENT_R8']=$IMCF_record['RECURRENT_R8'];
                $IMOQ_record['RECURRENT_R9']=$IMCF_record['RECURRENT_R9'];
                $IMOQ_record['RECURRENT_R0']=$IMCF_record['RECURRENT_R0'];
                $IMOQ_record['RECURRENT_R1']=CLX_CHAR_EMPTY_STRING;
                $IMOQ_record['RECURMODE']=$IMCF_record['RECURMODE'];
                $IMOQ_record['NEXT_RUN_DATI']=$IMCF_record['NEXT_RUN_DATI'];
				
                // Estatus que quedara cuando de error, luego se cambian a ERR 
				$record['ETL_STATUS'] = 'PRU';
				if($this->etl_param['debug'] === true) { 
					ECHO "IMOQ_record<BR>";
					pre($IMOQ_record);
					
				}   
				
                ClxCommon::$db->updateRecord($this->imftname, $record, 'ID='.$IMFT_record['ID']);
                ClxCommon::$db->executeQuery('commit');
				
				$IMOQ_id = ClxCommon::$db->createRecord($this->imoqname, $IMOQ_record, false);
                // Marca registro temporal como asignado a cola de procesamiento
                $record = array();
                $record['ETL_FILESEQ'] = $IMOQ_id;
                $record['ETL_STATUS'] = 'RUN';
                if($this->etl_param['debug'] === true) { ClxCommon::$db->debug=true; }
                ClxCommon::$db->updateRecord($this->imftname, $record, 'ID='.$IMFT_record['ID']);
                if($this->etl_param['debug'] === true) { ClxCommon::$db->debug=false; }
				ClxCommon::$db->executeQuery('commit');
            }
			$yesprocess=false;
			for ($tcontador_valid=0;$tcontador_valid<$contador_valid;$tcontador_valid++) {
				$valid_respt=$valid_resp[$tcontador_valid][0];
				if($valid_respt['result'] !== false) {
					$yesprocess=true;
				}
			}
			for ($tcontador_valid=0;$tcontador_valid<$contador_valid;$tcontador_valid++) {
					
				$valid_respt=$valid_resp[$tcontador_valid][0];
				$IMFT_record_reject=$valid_resp[$tcontador_valid][1];
//				$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivoETL4.txt','a+');
//				fwrite($tta,chr(13).chr(10).'33333333334118- hora:'.date( 'h:i:s d/m/Y').chr(13).chr(10));	
//				fclose($tta);
//				
				if($valid_respt['result'] === false) {
					$this->imft_move_to_rejected($IMFT_record_reject, $valid_respt['errmsg'],$yesprocess);
				}
				
			}
			
        }
    }
    
    function IMOQ_Validations($IMCF_record, $IMFT_record, $getNextRun) {
		if($this->etl_param['debug'] === true) {
			echo "Function IMOQ_Validations, <br>"; 

			$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivo.txt','a+');
			fwrite($tta,chr(13).chr(10).'function IMOQ_Validations 4118- hora:'.date( 'h:i:s d/m/Y').chr(13).chr(10));	
			$te=debug_backtrace(); 
			for ($t=0;$t<12;$t++) {
				if (isset($te[$t]["file"])){
					fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));
				}
			}
			fclose($tta);
		}
        $errorMsg = array();
		
        // Verifica que haya pasado de la fecha fecha final
        if (!empty($IMCF_record['RECURRENT_R9']) && $IMCF_record['RECURRENT_R9'] < date('Y-m-d')) {
            $errorMsg[] = dict('GEN_ERR_ETL', dict('GEN_ERR_ETL_EXPIRE_DATE'),  $IMFT_record['ETL_FILENAME'], $IMCF_record['IMPORT_CODE']) . ' [020]';
        }
        // Verifica archivo en blanco
		if ( file_exists($IMFT_record['ETL_FILEPATH'].DIRECTORY_SEPARATOR.$IMFT_record['ETL_FILENAME']) ){
			if (filesize($IMFT_record['ETL_FILEPATH'].DIRECTORY_SEPARATOR.$IMFT_record['ETL_FILENAME'])==0){
            $errorMsg[] = dict('GEN_ERR_ETL', dict('GEN_ERR_ETL_SIZE_FILE'),  $filespec_from, $IMCF_record['IMPORT_CODE']) . ' [021]';
        }
			else if  ($IMCF_record['FILENAME_INC_DATE']==1) {
				preg_match('/\.([0-9]{2,4}\-[0-9]{1,2}\-[0-9]{1,2})\./',$IMFT_record['ETL_FILENAME'] ,$matches);
				$error=0;
				if (isset($matches[1])) {
					$cut=explode("-",$matches[1]);
					if (!(validateDate($matches[1],"Y-m-d")))
						$error=1;
				}
				else 
					$error=1;
				if ($error) {
					dict('GEN_ERR_ETL', dict('GEN_ERR_ETL_FILE_NOT_DATE2'),  $IMFT_record['ETL_FILENAME'], $IMCF_record['IMPORT_CODE']) . ' [222]';
				}
			}	
		}
        // Verifica que la fecha de proxima ejecución sea el dia de hoy
		
		if ($IMCF_record['RECURRENT_R1']!='NONE') {
        if (!$getNextRun['run']) {
				$errorMsg[] = dict('GEN_ERR_ETL', dict('GEN_ERR_ETL_FILE_NOT_DATE'),  $IMFT_record['ETL_FILENAME'], $IMCCF_record['IMPORT_CODE']) . ' [022]';
        }
			// Ve sea una sola ejecucion y que ya haya sucedido
        if ($IMCF_record['RECURMODE']=='ONE'){
			if (kDatabaseType === 'oci') {
				$sql = 'SELECT count(*) FROM CLX_ETL_OP_QUEUE WHERE IMPORT_CODE='.singleQuote($IMCF_record['IMPORT_CODE']).' and trunc(CLX_EFFTDATE)=to_date('.singleQuote(date('Y/m/d')).','.singleQuote('YYYY/MM/DD').')';
            }
			else { 
				$sql = 'SELECT count(*) FROM CLX_ETL_OP_QUEUE WHERE IMPORT_CODE='.singleQuote($IMCF_record['IMPORT_CODE']).' and CLX_EFFTDATE='.singleQuote(date('Y-m-d'));
			}	
			if(ClxCommon::$db->getOne($sql)>CLX_INIT_ZERO) {
                $errorMsg[] = dict('GEN_ERR_ETL', dict('GEN_ERR_ETL_TWO_FILE_PROCESS'),  $filespec_from, $IMCF_record['IMPORT_CODE']) . ' [023]';
            }
        }
        }
		
        return array('result' => empty($errorMsg), 'errmsg' => $errorMsg);
    }
    
    /*
     * Para los archivos temporales que no encuentra importador, los mueve al directorio de archivos con error
     * @param void
     * @return void
     */
    function etl_no_processed_moving() {
        if($this->etl_param['debug'] === true) {
			echo "Function etl_no_processed_moving, <br>"; 
		}
        /*
         * GEN_ETL_ERR_040
         * Could not process &quot;^1&quot; due to missing import configuration
         * No se pudo procesar archivo &quot;^1&quot; por no haber importador configurado
         */
        $rejection_reason = dict('GEN_ETL_ERR_040', '%filespec_dest%') . ' [040-NO-EXIST-IMCF]';
        $binds = array();
        $binds['RUNID'] = $this->etl_param['BATCH_ID'];
        $binds['CDATE'] = xFormat::getNow('Y-m-d');
        $binds['ETL_STATUS'] = 'PEN';
        // Busca los procesados en esta sesión o lo que estón en el aire desde ayer hacia atras...
        $sql = 'SELECT * FROM ' . $this->imftname . ' WHERE (ETL_FILESEQ = 0 OR ETL_FILESEQ IS NULL) AND (RUNID = :RUNID OR CDATE < :CDATE) AND (ETL_STATUS = :ETL_STATUS OR ETL_STATUS IS NULL)';
        if (kDatabaseType === 'oci') {
            $sql = str_replace(':CDATE', ClxCommon::$db->db_to_date(':CDATE'), $sql);
        }
        $IMFT_results = ClxCommon::$db->executeQueryUniversal($sql, $binds);
        if($this->etl_param['debug'] === true) { pre($sql); pre($binds); }
        while (($IMFT_record = ClxCommon::$db->getNextRecord($IMFT_results, ASSOCIATIVE))) {
				if($this->etl_param['debug'] === true) { 
					ECHO "IMFT_record<BR>";
					pre($IMFT_record);
					
				}   
//			$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivoETL5.txt','a+');
//				fwrite($tta,chr(13).chr(10).'222234118- hora:'.date( 'h:i:s d/m/Y').chr(13).chr(10));	
//				fclose($tta);
//				
            $this->imft_move_to_rejected($IMFT_record, $rejection_reason);
        }
    }
    
    /*
     * Procesa cola de operaciones de ETL, buscando los registros pendientes de procesar y verificando los que hayan termina de procesarse.
     * @param void
     * @return void
     */
    function imoq_process() {
		if($this->etl_param['debug'] === true) {
			echo "Function imoq_process, <br>"; 
		}
        // Cola de operaciones de ETL: manda a ejecutar en batch los Imports que están agendados y pendientes por ejecutar (IDLE)
		
        $this->imoq_sched_imports();
		
        // Cola de operaciones de ETL: busca registros en ejecución "RUN" cuyos importadores hayan terminado de ejecutarse
        $this->imoq_ver_ended_imps();
		
    }
    
    /*
     * Cola de operaciones de ETL: manda a ejecutar en batch los Imports que están agendados y pendientes por ejecutar (IDLE)
     * @param void
     * @return void
     *
     * @param void
     * @return void
     */
    function imoq_sched_imports() {
		if($this->etl_param['debug'] === true) {
			echo "Function imoq_sched_imports, <br>"; 
		}
        //$DBIX = &getTool('DBIX');
        $sql_where_extra = '';
        $binds = array();
        $binds['STATUS'] = 'A';
        $binds['REC_STATUS'] = 'IDLE';
        if(!is_null($this->etl_param['COMP_CODE'])) {
            $binds['COMP_CODE'] = $this->etl_param['COMP_CODE'];
            $sql_where_extra .= ' AND COMP_CODE = :COMP_CODE';
        }
        $sql = 'SELECT * FROM ' . $this->imoqname . ' WHERE STATUS=:STATUS AND REC_STATUS = :REC_STATUS' . $sql_where_extra . ' ORDER BY MDATE ASC';
        $IMOQ_results = ClxCommon::$db->executeQueryUniversal($sql, $binds);
        if($this->etl_param['debug'] === true) {
			echo "sql from imoq";
		    pre($sql); pre($binds);
            $entro =0;			
		}
        while (($IMOQ_record = ClxCommon::$db->getNextRecord($IMOQ_results, ASSOCIATIVE))) {
            $IMOQ_id = $IMOQ_record['ID'];
			if($this->etl_param['debug'] === true) {
				echo "while record results imoq";
		        pre($record);
				$entro=1;
		    }
            // Asegura que el archivo este en el directorio de procesados, esto porque se puede estar re-procesando archivos en directorio "rechazados" o archivos que originalmente no se pudo mover desde directorio "pendiente"
//
//				$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivo2.txt','a+');
//				fwrite($tta,chr(13).chr(10).'1118- hora:'.date( 'h:i:s d/m/Y').chr(13).chr(10));	
//				fwrite($tta,chr(13).chr(10).'$IMOQ_record'. print_r($IMOQ_record,true).chr(13).chr(10));fclose($tta);
//			
//			$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivo2.txt','a+');
//			fwrite($tta,chr(13).chr(10).'3321118- hora:'.date( 'h:i:s d/m/Y').chr(13).chr(10));	
//			fwrite($tta,chr(13).chr(10).'move linea 473 '. print_r($IMOQ_record,true).chr(13).chr(10));fclose($tta);
//
            $move_response = $this->move_imft_file($IMOQ_record['IMFT_ID'], $this->etl_param['ETL_IMPORT_PROC_DIR']);
			$IMFT_record = $move_response['IMFT_record'];
            if($move_response['error'] === true) {
                // Hubo problemas moviendo el archivo
                $this->etl_send_alert($move_response['msg'], array_merge(array('IMOQ-ID' => $IMOQ_record['ID']), $IMOQ_record));
                unset($move_response);
                continue;
            }
            unset($move_response);
            // FileSpec (directorio + nombre) del archivo de entrada
            //$original_filename = $IMOQ_record['IMFT_ID'] . $this->etl_param['FILE_NAME_SEP'] . $IMOQ_record['FILE_NAME'];
            $original_filename = $IMOQ_record['FILE_NAME'];
            $filespec_source = $this->etl_param['ETL_IMPORT_PROC_DIR'] . DIRECTORY_SEPARATOR . $original_filename;
            $line_count = CLX_INIT_ZERO;
/*
            // Copia archivo al directorio de importacion
            $filespec_dest = kPathToWebSite . 'import' . DIRECTORY_SEPARATOR . $original_filename;
            if(!copy($filespec_source, $filespec_dest)) {
                // Error en copia
                /*
                 * GEN_ETL_ERR_030
                 * Could not copy "^1" to "^2"
                 * No se pudo copiar "^1" a "^2"
                 * /
                $this->etl_param['error'][] = dict('GEN_ETL_ERR_030', $filespec_from, $filespec_dest) . ' [030]';
                continue;
            }
*/
            // asigna valores a ser serializados y pasados en la columna BATCH_PRMT
            $dbim_files = array();
            $dbim_files['DBIM_id'] = ClxCommon::$db->getField('CLX_DB_IMPORTS', 'ID', 'IDCODE='.singleQuote($IMOQ_record['IMPORT_CODE']));
            $dbim_files['DBIM_test'] = $this->etl_param['DBIM_test'];
            $dbim_files['DBIM_show_file'] = $this->etl_param['DBIM_show_file'];
            $dbim_files['DBIM_error_limit'] = $this->etl_param['DBIM_error_limit'];
            $dbim_files['DBIM_description'] = '[IMOQ-' . $IMOQ_record['ID'] . ']';
            $dbim_files['_FILES'] = array();
            $dbim_files['_FILES']['DBIM_file'] = array();
            $dbim_files['_FILES']['DBIM_file']['name'] = $original_filename;
            $dbim_files['_FILES']['DBIM_file']['tmp_name'] = $filespec_source;
            $dbim_files['DBIM_test'] = $this->etl_param['DBIM_test'];
			if($this->etl_param['debug'] === true) {
				echo "dbim_files ARRAY CREATE, <br>"; 
				pre($dbim_files);
			}
            // Ejecuta importador en batch
			$DBIX_rec=array();
			$DBIX_recX = $this->etl_objs['DBIX']->defaultTableRecord();
			unset($DBIX_recX['ID']);
			$DBIX_recX['IMPORTCODE'] = $IMOQ_record['IMPORT_CODE'];
			$DBIX_recX['RECORD_QTY'] = $line_count;
			$DBIX_recX['CDATE'] = xFormat::getNow('Y-m-d H:i:s');
			$DBIX_recX['OWNERCODE'] = (empty($this->etl_param['username'])? $_SESSION['code_parameters']['USERNAME'] :$this->etl_param['username']);

			$DBIX_recX['DESCRIPTION'] = $dbim_files['DBIM_description'];
			$DBIX_recX['FILENAME'] = $original_filename;
			$DBIX_recX['RUN_BATCH'] = CLX_NUM_ONE;
			$DBIX_recX['BATCH_STATUS'] = 'IDLE';
            //$DBIX_rec['STATUS'] = 'IACT';
			$DBIX_recX['BATCH_PID'] = CLX_INIT_ZERO;
			$DBIX_recX['BATCH_SDATE'] = null;
			$DBIX_recX['BATCH_EDATE'] = null;
			$DBIX_recX['BATCH_PRMT'] = serialize($dbim_files);
			$DBIX_recX['IMFT_ID']=$IMOQ_record['IMFT_ID'];
            
			$sqlz = 'SELECT FILENAME_INC_DATE,CH_VALUE_DATE FROM ' . $this->imcfname . ' WHERE ID= '.$IMFT_record['IMCF_ID'];
			
			$rxx = ClxCommon::$db->executeQuery($sqlz);
			$DBIX_recX['FILENAME_INC_DATE']=  $DBIX_recX['CH_VALUE_DATE']=  '';				
			$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivo23.txt','a+');
			fwrite($tta,chr(13).chr(10).'1118- hora:'.date( 'h:i:s d/m/Y').chr(13).chr(10));	
			fwrite($tta,chr(13).chr(10).'SQLZ'. $sqlz	.chr(13).chr(10));
			fclose($tta);	
			if ($rx = ClxCommon::$db->getNextRecord($rxx, ASSOCIATIVE)) {
				$DBIX_recX['FILENAME_INC_DATE']=  $rx['FILENAME_INC_DATE'];				
				$DBIX_recX['CH_VALUE_DATE']=  $rx['CH_VALUE_DATE'];				
				$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivo22.txt','a+');
				fwrite($tta,chr(13).chr(10).'1118- hora:'.date( 'h:i:s d/m/Y').chr(13).chr(10));	
				fwrite($tta,chr(13).chr(10).'$DBIX_record'. print_r($DBIX_recX,true).chr(13).chr(10));
				fclose($tta);
					
			}
			
			$DBIX_rec[]=$DBIX_recX;
			    			
			for ($t=2;$t<4;$t++) {
				if (!empty($IMOQ_record['IMPORT_CODE'.$t])) {
					$DBIX_recX['IMPORTCODE'] = $IMOQ_record['IMPORT_CODE'.$t];
					$DBIX_rec[]=$DBIX_recX;
				}
			}
			if($this->etl_param['debug'] === true) {
				echo "DBIX_rec CREATE NOW, <br>"; 
				pre($DBIX_rec);
			}
            // Verifica si ejecución en batch del importador ya esta agendada
            if (ClxCommon::$db->oneExistsRecords($this->etl_objs['DBIX']->tablename, 'FILENAME = ' . singleQuote($original_filename) . '  AND BATCH_STATUS =' . singleQuote('IDLE') . ' AND RUN_BATCH = 1') == CLX_NUM_ZERO) {
                // Agenda ejecución en batch del importador
				$record = array();
				$record['DBIM_ID'] =$record['DBIM_ID2'] =$record['DBIM_ID3']=$record['DBIM_ID4']=0;
				for ($t=0;$t<count($DBIX_rec);$t++) {
					$record['DBIM_ID'.($t==0?"":$t+1)] = ClxCommon::$db->createRecord($this->etl_objs['DBIX']->tablename, $DBIX_rec[$t], false);
                }
				
                // Marca registro IMOQ como "EN PROCESO"
                
                $record['REC_STATUS'] = 'RUN';
				if($this->etl_param['debug'] === true) {
					ECHO "UPDATE DBIX EN IMOQ";
					PRE($record);
				}	
                ClxCommon::$db->updateRecord($this->imoqname, $record, 'ID='.$IMOQ_id);
            } else {
				if($this->etl_param['debug'] === true) {
					ECHO "EXCEPCION NOT REGISTRO EN DB DBIX EN IMOQ";
					PRE($record);
				}
                // Ya se está procesando ????? >> INCONSISTENCIA...
                /*
                 * GEN_ERR_CONSISTENCY
                 * Consistency Error: ^1
                 * Error de Consistencia: ^1
                 */
                $msg = dict('GEN_ERR_CONSISTENCY', '[IMOQ-040-IMP-REPRO-NOT-ALLOW] ' . $original_filename);
               
				//comentado esta chocando por recurrencias con archivos muy voluminosos y manda el mensaje
 			    //$this->etl_send_alert($msg, array_merge(array_merge(array('IMOQ-ID' => $IMOQ_record['ID']), $IMOQ_record)), array_merge(array('IMFT-ID' => $IMFT_record['ID']), $IMFT_record));
            }
			ClxCommon::$db->executeQuery('commit');
        }
		if (!$entro) {
		   pre( "not imoq echo results");	
        }
    }
    
    /*
     * Cola de operaciones de ETL: busca registros en ejecución "RUN" cuyos importadores hayan terminado de ejecutarse
     * @param void
     * @return void
     */
    function imoq_ver_ended_imps() {
		if($this->etl_param['debug'] === true) {
			echo "Function imoq_ver_ended_imps, <br>"; 
		}
        //$DBIX = &getTool('DBIX');
        $sql_where_extra = '';
        $binds = array();
        $binds['STATUS'] = 'A';
        $binds['REC_STATUS'] = 'RUN';
//			
//		$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivoETL3.txt','a+');
//		fwrite($tta,chr(13).chr(10).' hora:'.date( 'h:i:s d/m/Y').chr(13).chr(10));	
//		fwrite($tta,chr(13).chr(10).'l-553::BIND '.print_r($binds,true).chr(13).chr(10));fclose($tta);
//		
        if(!is_null($this->etl_param['COMP_CODE'])) {
            $binds['COMP_CODE'] = $this->etl_param['COMP_CODE'];
            $sql_where_extra .= ' AND COMP_CODE = :COMP_CODE';
        }
        $sql = 'SELECT * FROM ' . $this->imoqname . ' WHERE STATUS=:STATUS AND REC_STATUS = :REC_STATUS' . $sql_where_extra . ' ORDER BY MDATE ASC';
        if($this->etl_param['debug'] === true) { pre($sql); pre($binds); }
        $IMOQ_results = ClxCommon::$db->executeQueryUniversal($sql, $binds);
//		$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivoETL3.txt','a+');
//		fwrite($tta,chr(13).chr(10).' hora:'.date( 'h:i:s d/m/Y').chr(13).chr(10));	
//		fwrite($tta,chr(13).chr(10).'l-553::sql '.$sql.chr(13).chr(10));fclose($tta);
//		
        while (($IMOQ_record = ClxCommon::$db->getNextRecord($IMOQ_results, ASSOCIATIVE))) {
//			$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivoETL3.txt','a+');
//		fwrite($tta,chr(13).chr(10).' hora:'.date( 'h:i:s d/m/Y').chr(13).chr(10));	
//		fwrite($tta,chr(13).chr(10).'l-597:: entrro records '.print_r($IMOQ_record,true).chr(13).chr(10));fclose($tta);
//			
			$cuenta1=ClxCommon::$db->oneExistsRecords($this->etl_objs['DBIX']->tablename, 'ID = ' . singleQuote($IMOQ_record['DBIM_ID']) . '  AND BATCH_STATUS =' . singleQuote('END') . ' AND RUN_BATCH = 1') == CLX_NUM_ZERO;
            $cuenta2=!empty($IMOQ_record['DBIM_ID2']) and ClxCommon::$db->oneExistsRecords($this->etl_objs['DBIX']->tablename, 'ID = ' . singleQuote($IMOQ_record['DBIM_ID2']) . '  AND BATCH_STATUS =' . singleQuote('END') . ' AND RUN_BATCH = 1')== CLX_NUM_ZERO;
            $cuenta3=!empty($IMOQ_record['DBIM_ID3']) and ClxCommon::$db->oneExistsRecords($this->etl_objs['DBIX']->tablename, 'ID = ' . singleQuote($IMOQ_record['DBIM_ID3']) . '  AND BATCH_STATUS =' . singleQuote('END') . ' AND RUN_BATCH = 1')== CLX_NUM_ZERO;
            $cuenta4=!empty($IMOQ_record['DBIM_ID4']) and ClxCommon::$db->oneExistsRecords($this->etl_objs['DBIX']->tablename, 'ID = ' . singleQuote($IMOQ_record['DBIM_ID4']) . '  AND BATCH_STATUS =' . singleQuote('END') . ' AND RUN_BATCH = 1')== CLX_NUM_ZERO;
            
			if ($cuenta1 == true && $cuenta2 == true  && $cuenta3 == true && $cuenta4 == true) {
//                $tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivoETL3.txt','a+');
//		fwrite($tta,chr(13).chr(10).' hora:'.date( 'h:i:s d/m/Y').chr(13).chr(10));	
//		fwrite($tta,chr(13).chr(10).'l-60::saliendo forzado '.$this->etl_objs['DBIX']->tablename. ' '. 'ID = ' . singleQuote($IMOQ_record['DBIM_ID']) . '  AND BATCH_STATUS =' . singleQuote('END') . ' AND RUN_BATCH = 1'.chr(13).chr(10));fclose($tta);
//		
//				
                // No ha terminado de ejecutarse
                continue;
            }
            // Si lo consigue, ya terminó de ejecutarse... Marca registro IMOQ como procesado
            $IMOQ_id = $IMOQ_record['ID'];
			$iMOQ_DBIM_id = $IMOQ_record['DBIM_ID'];
            
            $record = array();
            $record['REC_STATUS'] = 'END';
//		
//		$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivoETL3.txt','a+');
//				fwrite($tta,chr(13).chr(10).' hora:'.date( 'h:i:s d/m/Y').chr(13).chr(10));	
//				fwrite($tta,chr(13).chr(10).'l-553::update '.print_r($rcord,true).chr(13).chr(10));fclose($tta);
//		
//
			ClxCommon::$db->updateRecord($this->imoqname, $record, 'ID='.$IMOQ_id);
			$record = array();
         
			$record['ETL_STATUS'] = 'END';
			//OLD OBSERVATIONS READ
			$sql = 'SELECT ETL_OBS FROM ' . $this->imftname . ' WHERE ID='.$IMOQ_record['IMFT_ID'];
			$IMFT_results_ETL_OBS = ClxCommon::$db->getOne($sql);
			$record['ETL_OBS']=(!empty($IMFT_results_ETL_OBS)?$IMFT_results_ETL_OBS.'<br><br>':'');
			for ($t=0;$t<4;$t++) {
				if (empty($IMOQ_record['DBIM_ID'.($t==0?"":$t+1)])){
					continue;
				}	
				$iMOQ_DBIM_id = $IMOQ_record['DBIM_ID'.($t==0?"":$t+1)];
		 
			$sql = 'SELECT DBIX.DESCRIPTION,IMPORTCODE FROM CLX_DB_IMPORT_EXECUTIONS DBIX WHERE DBIX.ID='.singleQuote($iMOQ_DBIM_id);
			$DBIX_results = ClxCommon::$db->executeQuery($sql);
	//					$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivoETL3.txt','a+');
	//				fwrite($tta,chr(13).chr(10).' hora:'.date( 'h:i:s d/m/Y').chr(13).chr(10));	
	//				fwrite($tta,chr(13).chr(10).'l-633::sql '.$sql.chr(13).chr(10));fclose($tta);
	//		
			$DBIX_record = ClxCommon::$db->getNextRecord($DBIX_results, ASSOCIATIVE);
				$record['ETL_OBS'].=$DBIX_record['DESCRIPTION'].'('.$DBIX_record['IMPORTCODE'].')';
		
			}
		
            if($this->etl_param['debug'] === true) { ClxCommon::$db->debug=true; }
            ClxCommon::$db->updateRecord($this->imftname, $record, 'ID='.$IMOQ_record['IMFT_ID']);
//				$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivoETL3.txt','a+');
//				fwrite($tta,chr(13).chr(10).' hora:'.date( 'h:i:s d/m/Y').chr(13).chr(10));	
//				fwrite($tta,chr(13).chr(10).'l-665::update'.$this->imftname. '  '. 'ID='.$IMOQ_record['IMFT_ID'].chr(13).chr(10));fclose($tta);
//		
//		$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivoETL3.txt','a+');
//				fwrite($tta,chr(13).chr(10).' hora:'.date( 'h:i:s d/m/Y').chr(13).chr(10));	
//				fwrite($tta,chr(13).chr(10).'l-667::record update'.print_R($record,true).chr(13).chr(10));fclose($tta);
//		
			ClxCommon::$db->executeQuery('commit');
		
            if($this->etl_param['debug'] === true) { ClxCommon::$db->debug=false; }
        }
    }

    /*
     * Registra mensaje de error en el Log de operaciones
     * @param varchar/array $msg
     * @return void
     */
    function log_error($msg) {
		if($this->etl_param['debug'] === true) {
			echo "Function log_error, <br>"; 
		}
        if(!is_array($msg)) {
            $msg = array($msg);
        }
        //$PREL = &getTool('PREL');
        $PREL_record = array();
        $PREL_record['SCHEDULECODE'] = $this->etl_param['SCHEDULECODE'];
        $PREL_record['LOG_RECID'] = $this->etl_param['RUNID'];
        $PREL_record['EFFTDATE'] = $this->etl_param['CURRENT_TIME'];
        $PREL_record['TABLECODE'] = '';
        $PREL_record['RECORDID'] = 0;
        $PREL_record['PROC_STATUS'] = 'ERROR';
        foreach($msg as $key => $val) {
            $msg[$key] = 'ERROR-'.$val;
            $PREL_record['DESCRIPTION'] = $msg[$key];
            // $PREL->tablename = CLX_PR_EXCEPT_LOGS
            ClxCommon::$db->createRecord($this->etl_objs['PREL']->tablename, $PREL_record, false);
        }
        $this->log_general($msg);
    }

    /*
     * Registra mensaje en el Log de operaciones
     * @param varchar/array $msg
     * @return void
     */
    function log_normal($msg) {
        if($this->etl_param['debug'] === true) {
			echo "Function log_normal, <br>"; 
		}
        $this->log_general($msg);
    }
    
    /*
     * Registra mensaje en el Log de operaciones
     * @param varchar/array $msg
     * @return void
     */
    function log_general($msg) {
        if($this->etl_param['debug'] === true) {
			echo "Function log_general, <br>"; 
		}
        if(!is_array($msg)) {
            $msg = array($msg);
        }
        foreach($msg as $msg_val) {
            echo CLX_CHAR_NL . '<br>'.$msg_val;
        }
    }
    
    /**
     * Registra datos del remitente de los correos a ser enviados. Intenta extraerlo desde la cuenta del sistema registrada en "ClientTools > Sistema > Cuentas de Email" (por defecto del sistema), si no, la extra de los datos del CLX Configurator
     * @param void
     * @return void
     */
    function get_sys_email_from_data() {
        if($this->etl_param['debug'] === true) {
			echo "Function get_sys_email_from_data, <br>"; 
		}
        $maac_record = ClxCommon::$db->getRecord('CLX_MA_MAILACCOUNTS', 'SYSTEM_DEFAULT=1');
        $this->etl_param['MAAC'] = array();
        if($maac_record) {
            $this->etl_param['MAAC']['IDNAME'] = $maac_record['IDNAME'];
            $this->etl_param['MAAC']['EMAIL'] = $maac_record['EMAIL'];
            $this->etl_param['MAAC']['error'] = false;
        } else {
            $this->etl_param['MAAC']['IDNAME'] = 'kDefaultSystemMail';
            $this->etl_param['MAAC']['EMAIL'] = kDefaultMail;
            $this->etl_param['MAAC']['error'] = true;
        }
        if($this->etl_param['debug'] === true) { pre($this->etl_param['MAAC']); }
    }
    
    /**
     * Registra los nombres en singular de las tablas, usados para los enlaces a ser incluidos en las notificaciones
     * @param void
     * @return void
     */
    function get_table_name_labels() {
		if($this->etl_param['debug'] === true) {
			echo "Function get_table_name_labels, <br>"; 
		}
        $this->etl_param['dbtb_data'] = array();
        $sql = 'SELECT DBTB.IDCODE, DICT.VALUE RECORDNAME_SINGULAR FROM CLX_DICTIONARY DICT, CLX_DB_TABLES DBTB WHERE DICT.ENTRY=DBTB.RECORDNAME_SINGULAR AND UPPER(DICT.LANGUAGE)='. singleQuote(uppercase(substr($this->etl_param['lang'], CLX_INIT_ZERO, CLX_NUM_TWO))).' AND DBTB.IDCODE IN('.singleQuoteArray(array('IMOQ', 'IMCF', 'IMFT')).')';
        if($this->etl_param['debug'] === true) { pre($sql); }
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $this->etl_param['dbtb_data'][$r['IDCODE']] = $r['RECORDNAME_SINGULAR'];
        }
        if($this->etl_param['debug'] === true) { pre($this->etl_param['dbtb_data']); }
    }

    /**
     * Verificaciones previas a cualquier procesamiento
     * @param void
     * @return boolean
     */
    function pre_verifications() {
		if($this->etl_param['debug'] === true) {
			echo "Function pre_verifications, <br>"; 
		}
        $this->etl_param['error'] = array();
        // Verifica parametros de directorios
        if(is_null($this->etl_param['ETL_IMPORT_PEND_DIR'])) {
            /*
             * GEN_ETL_ERR_010
             * General parameter "^1" not defined
             * Parámetro general "^1" no definido
             */
            $this->etl_param['error'][] = dict('GEN_ETL_ERR_010', 'ETL_IMPORT_PEND_DIR');
        } elseif (!is_dir($this->etl_param['ETL_IMPORT_PEND_DIR'])) { 
            /*
             * GEN_ETL_ERR_070
             * Parameter "^1" is not a directory: ^2
             * El valor del parámetro "^1" no es un directorio: ^2
             */
            $this->etl_param['error'][] = dict('GEN_ETL_ERR_070', 'ETL_IMPORT_PEND_DIR', $this->etl_param['ETL_IMPORT_PEND_DIR']);
        }
        if(is_null($this->etl_param['ETL_IMPORT_REJ_DIR'])) {
            $this->etl_param['error'][] = dict('GEN_ETL_ERR_010', 'ETL_IMPORT_REJ_DIR');
        } elseif (!is_dir($this->etl_param['ETL_IMPORT_REJ_DIR'])) { 
            $this->etl_param['error'][] = dict('GEN_ETL_ERR_070', 'ETL_IMPORT_REJ_DIR', $this->etl_param['ETL_IMPORT_REJ_DIR']);
        }
        if(is_null($this->etl_param['ETL_IMPORT_PROC_DIR'])) {
            $this->etl_param['error'][] = dict('GEN_ETL_ERR_010', 'ETL_IMPORT_PROC_DIR');
        } elseif (!is_dir($this->etl_param['ETL_IMPORT_PROC_DIR'])) { 
            $this->etl_param['error'][] = dict('GEN_ETL_ERR_070', 'ETL_IMPORT_PROC_DIR', $this->etl_param['ETL_IMPORT_PROC_DIR']);
        }
        // Verifica otros parametros generales
        if(is_null($this->etl_param['ETL_DEF_NOTIFY_ROLE'])) {
            $this->etl_param['error'][] = dict('GEN_ETL_ERR_010', 'ETL_DEF_NOTIFY_ROLE');
        } else {
            $this->verify_notification_element('NOTIFY_ROLE', $this->etl_param['ETL_DEF_NOTIFY_ROLE']);
        }
        if(is_null($this->etl_param['ETL_DEF_ALERT_TEMPLATE'])) {
            $this->etl_param['error'][] = dict('GEN_ETL_ERR_010', 'ETL_DEF_ALERT_TEMPLATE');
        } else {
            $this->verify_notification_element('TEMPLATE_CODE', $this->etl_param['ETL_DEF_ALERT_TEMPLATE']);
        }
        if($this->etl_param['MAAC']['error'] === true) {
            // No esta definida la cuenta por defecto del sistema... lo reporta
            $this->etl_param['error'][] = dict('GEN_ETL_ERR_080');
        }
        if(!empty($this->etl_param['error'])) {
            // Si falta algun directorio o hay problemas con algun parametro general, registra error y termina
            $this->etl_send_alert($this->etl_param['error'], array('error_msg_sw'=>false));
            $this->log_error($this->etl_param['error']);
            return false;
        }
        return true;
    }

    /**
     * Verifica existencia de elementos de validacion. Va registrando el resultado de cada validacion en un "cache", en donde se indica True si hubo error, False si es valido
     * @param varchar $e_code Elemento: NOTIFY_ROLE, TEMPLATE_CODE, SYAL_CODE
     * @param varchar $e_val Valor del elemento
     * @return boolean True si hubo error, False si es valido
     */
    function verify_notification_element($e_code, $e_val) {
        if($this->etl_param['debug'] === true) {
			echo "Function verify_notification_element, <br>"; 
		}
        $e_data = array('error_sw' => false, 'data' => array());
        if(isset($this->etl_param['ver_not_ele'])) {
            $this->etl_param['ver_not_ele'] = array();
        }
        if(isset($this->etl_param['ver_not_ele'][$e_code])) {
            $this->etl_param['ver_not_ele'][$e_code] = array();
        }
        if(isset($this->etl_param['ver_not_ele'][$e_code][$e_val])) {
            return $this->etl_param['ver_not_ele'][$e_code][$e_val];
        }
        switch($e_code) {
            case 'NOTIFY_ROLE':
                if (ClxCommon::$db->oneExistsRecords($this->prroname, 'IDCODE = ' . singleQuote($e_val)) === CLX_NUM_ZERO) {
                    /*
                     * GEN_ETL_ERR_050
                     * No existe Rol de Notificación: ^1
                     * Notification Role not found: ^1
                     */
                    $this->etl_param['error'][] = dict('GEN_ETL_ERR_050', $e_val) . ' [PRRO-ERR-010]';
                    $e_data['error_sw'] = true;
                }
                break;
            case 'TEMPLATE_CODE':
                // El template queda en $this->etl_param['ver_not_ele']['TEMPLATE_CODE']
                $e_data['data']['UITM_record'] = ClxCommon::$db->getRecord($this->etl_objs['UITM']->tablename, 'IDCODE=' . singleQuote($e_val));
                if (empty($e_data['data']['UITM_record'])) {
                    /*
                     * GEN_ETL_ERR_060
                     * No existe Plantilla: ^1
                     * Template not found: ^1
                     */
                    $this->etl_param['error'][] = dict('GEN_ETL_ERR_060', $e_val) . ' [UITM-ERR-010]';
                    $e_data['error_sw'] = true;
                }
                break;
            case 'SYAL_CODE':
                if (ClxCommon::$db->oneExistsRecords($this->etl_objs['SYAL']->tablename, 'IDCODE = ' . singleQuote($e_val)) == CLX_NUM_ZERO) {
                    $this->etl_param['error'][] = dict('GEN_ERR_KEY_DONT_EXIST', $e_val) . ' [SYAL-ERR-010]';
                    $e_data['error_sw'] = true;
                }
                break;
        }
        $this->etl_param['ver_not_ele'][$e_code][$e_val] = $e_data;
        return $e_data['error_sw'];
    }
    
    /**
     * Envio de alertas con mensajes de error
     * @param variant $alrt_msg Mensaje de alerta, puede ser Array o Varchar. Si es array, los convierte a cadena de caracteres separado por <BR>
     * @param array $alrt_par Parametros del alerta
     * @return void
     */
    function etl_send_alert($alrt_msg, $alrt_par = array()) {
        if($this->etl_param['debug'] === true) {
			echo "Function etl_send_alert, <br>"; 
		}
        //$SYAL = &getTool('SYAL');
        $sendAlert_pars = array();
        // Mensaje(s) a enviar
        $sendAlert_pars['ALERT_MSG'] = $this->merge_msgs($alrt_msg);
        // Elimina base de FTP, por razones de seguridad
        $sendAlert_pars['ALERT_MSG'] = str_replace($this->etl_param['ETL_FTP_BASE_DIR'], '', $sendAlert_pars['ALERT_MSG']);
        if(isset($alrt_par['ETL_FILEPATH'])) {
            $alrt_par['ETL_FILEPATH'] = str_replace($this->etl_param['ETL_FTP_BASE_DIR'], '', $alrt_par['ETL_FILEPATH']);
        }
        // Valores por defecto
        $alrt_par['error_msg_sw'] = (!isset($alrt_par['error_msg_sw']) ? true : !empty($alrt_par['error_msg_sw']));
        $alrt_par['SEND_EMAIL'] = (!isset($alrt_par['SEND_EMAIL']) ? CLX_NUM_ONE : CLX_INIT_ZERO+$alrt_par['SEND_EMAIL']);
        $alrt_par['CREATE_ALERT'] = (!isset($alrt_par['CREATE_ALERT']) ? CLX_INIT_ZERO : CLX_INIT_ZERO+$alrt_par['CREATE_ALERT']);
        $alrt_par['CREATE_TASK'] = (!isset($alrt_par['CREATE_TASK']) ? CLX_INIT_ZERO : CLX_INIT_ZERO+$alrt_par['CREATE_TASK']);
        // Si es error, de una vez registra el mensaje para generar la excepción a nivel de cronograma
        if($alrt_par['error_msg_sw'] === true) {
            $this->etl_param['error'][] = $sendAlert_pars['ALERT_MSG'];
        }
        // Codigo compañia
		
	
        if(isset($alrt_par['COMP_CODE']) && !is_null($alrt_par['COMP_CODE']) && $alrt_par['COMP_CODE'] !== CLX_CHAR_EMPTY_STRING) {
            $sendAlert_pars['COMP_CODE'] = $alrt_par['COMP_CODE'];
        } else {
            $sendAlert_pars['COMP_CODE'] = $this->etl_param['COMP_CODE'];
        }
        // Rol de notificacion: para saber a quien(es) se debe enviar el Email
        if(isset($alrt_par['NOTIFY_ROLE']) && !is_null($alrt_par['NOTIFY_ROLE']) && $alrt_par['NOTIFY_ROLE'] !== CLX_CHAR_EMPTY_STRING) {
            $sendAlert_pars['NOTIFY_ROLE'] = $alrt_par['NOTIFY_ROLE'];
        } else {
            $sendAlert_pars['NOTIFY_ROLE'] = $this->etl_param['ETL_DEF_NOTIFY_ROLE'];
        }
        // Plantilla para el envio de la notificación
        if(isset($alrt_par['TEMPLATE_CODE']) && !is_null($alrt_par['TEMPLATE_CODE']) && $alrt_par['TEMPLATE_CODE'] !== CLX_CHAR_EMPTY_STRING) {
            $sendAlert_pars['TEMPLATE_CODE'] = $alrt_par['TEMPLATE_CODE'];
        } else {
            $sendAlert_pars['TEMPLATE_CODE'] = $this->etl_param['ETL_DEF_ALERT_TEMPLATE'];
        }
        // Realiza validaciones
        $error_sw = false;
        $error_sw = ($error_sw || $this->verify_notification_element('NOTIFY_ROLE', $sendAlert_pars['NOTIFY_ROLE']));
        $error_sw = ($error_sw || $this->verify_notification_element('TEMPLATE_CODE', $sendAlert_pars['TEMPLATE_CODE']));
        if($error_sw === true) {
            return;
        }
        $alrt_par['CURRENT_DATE'] = xFormat::getNow('Y-m-d H:i:s');
        // Datos para poder asignar enlaces que permitan ver el registro objeto del error
        /*
         * GEN_ETL_MSG_020
         * Ver registro en &quot;^1&quot;
         * Review record in &quot;^1&quot;
         */
        $alrt_par['REPLACE_URL'] = '' 
                . (!isset($alrt_par['IMCF-ID']) ? '' : self::URL_LABEL_PREFIX . $this->get_display_url($this->etl_param['ETL_DEF_LSTG_IMCF'], dict('GEN_ETL_MSG_020', $this->etl_param['dbtb_data']['IMCF']), $alrt_par['IMCF-ID']))
                . (!isset($alrt_par['IMFT-ID']) ? '' : self::URL_LABEL_PREFIX . $this->get_display_url($this->etl_param['ETL_DEF_LSTG_IMFT'], dict('GEN_ETL_MSG_020', $this->etl_param['dbtb_data']['IMFT']), $alrt_par['IMFT-ID']))
                . (!isset($alrt_par['IMOQ-ID']) ? '' : self::URL_LABEL_PREFIX . $this->get_display_url($this->etl_param['ETL_DEF_LSTG_IMOQ'], dict('GEN_ETL_MSG_020', $this->etl_param['dbtb_data']['IMOQ']), $alrt_par['IMOQ-ID']))
        ;
        // Para efecto de poder sustituir todos los campos en el cuerpo del mensaje de la notificacion, asigna valores pode defecto a los datos del registro IMTF
        if(!isset($alrt_par['IMFT-ID'])) {
            $alrt_par = $this->def_record_data_for_notification($alrt_par);
        }
        // Toma datos de la plantilla
        $UITM_record = $this->etl_param['ver_not_ele']['TEMPLATE_CODE'][$sendAlert_pars['TEMPLATE_CODE']]['data']['UITM_record'];
        $sendAlert_pars['SUBJECT'] = $UITM_record['IDNAME'];
        // mensaje HTML
        $alrt_par['ERROR_MESSAGE'] = $sendAlert_pars['ALERT_MSG'];
        $sendAlert_pars['CONTENTS'] = $this->replace_template_flds($UITM_record['CONTENTS'], $alrt_par);
        // mensaje solo texto
        $alrt_par['ERROR_MESSAGE'] = str_replace('<BR>', CLX_CHAR_NL, $sendAlert_pars['ALERT_MSG']);
        $sendAlert_pars['CONTENTS_TXT'] = $this->replace_template_flds($UITM_record['CONTENTS_TXT'], $alrt_par);
        // Datos de depuracion
        if($this->etl_param['debug'] === true) { pre('ETL_SEND_ALERT - $alrt_par'); pre($alrt_par); pre('$sendAlert_pars'); pre($sendAlert_pars);}
        // Envia coreos, alertas o crea tareas para los miembros del grupo de notificacion
        $this->trigger_notification($alrt_par, $sendAlert_pars);
    }
    
    /**
     * Envio del alerta o email, o registro de tarea, para un grupo de notificacion
     * @param array $alrt_par Parametros generales del envio; CRATE_ALERT, SEND_EMAIL y CREATE_TASK
     * @param  * @param array $sendAlert_pars Resto de los parametros de envio: CONTENTS, CONTENTS_TXT y SUBJECT
     * @return void
     */
    function trigger_notification($alrt_par, $sendAlert_pars) {
        if($this->etl_param['debug'] === true) {
			echo "Function trigger_notification, <br>"; 
		}
        $excludeemails = array();
        $excludetask = array();
        $excludealert = array();
        $sql = 'SELECT ACUS.USERNAME, ACUS.EMAIL, ACUS.FIRSTNAME, ACUS.LASTNAME FROM '.$this->prrpname.' PRRP, '.$this->etl_objs['ACUS']->tablename.' ACUS WHERE PRRP.ROLE_CODE_ETL = ' . singleQuote($sendAlert_pars['NOTIFY_ROLE']) . ' AND PRRP.USER_CODE = ACUS.USERNAME AND PRRP.CLX_EFFTDATE <=' . $this->etl_param['clx_date_par'];
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            if($this->etl_param['debug'] === true) { pre('Registro ACUS:'); pre($r); }
            // Agrega datos del destinatario al cuerpo del mensaje
            $contents = $this->replace_template_flds($sendAlert_pars['CONTENTS'], $r);
            $contents_txt = $this->replace_template_flds($sendAlert_pars['CONTENTS_TXT'], $r);
            // Envia la notificación
            if($alrt_par['CREATE_ALERT'] === CLX_NUM_ONE && empty($excludealert[$r['USERNAME']])) {
                alrt_send($contents_txt, 'now', $r['USERNAME']);
                $excludealert[$r['USERNAME']] = CLX_NUM_ONE;
                if($this->etl_param['debug'] === true) { pre('CREATE_ALERT for :'.$r['USERNAME']); }
            }
            // Envia correo
            if($alrt_par['SEND_EMAIL'] === CLX_NUM_ONE && empty($excludeemails[$r['EMAIL']])) {
                if($this->etl_param['MAAC']['IDNAME'] === 'kDefaultSystemMail') {
                    clx_mail($this->etl_param['MAAC']['EMAIL'], $r['EMAIL'], $contents, $sendAlert_pars['SUBJECT']);
                } else {
                    clx_mail_queue($this->etl_param['MAAC']['EMAIL'], $r['EMAIL'], $contents, $sendAlert_pars['SUBJECT'], true, '', '', '', array(), $contents_txt);
                }
                $excludeemails[$r['EMAIL']] = CLX_NUM_ONE;
                if($this->etl_param['debug'] === true) { pre('SEND_EMAIL for :'.$r['USERNAME'].' | "'.$r['EMAIL'].'" from '.$from, $r['EMAIL'].', Subject: '.$sendAlert_pars['SUBJECT']); }
            }
			if($this->etl_param['debug'] === true) {
				echo "alrt_par, <br>";
				pre($alrt_par);
			}

            // Crea tarea
            if($alrt_par['CREATE_TASK'] === CLX_NUM_ONE) {
                $task = array();
                $task['STATUS'] = 'IDLE';
                $task['TYPE'] = 'FIEK';
                $task['SUBJECT'] = $sendAlert_pars['SUBJECT'];
                $task['description'] = strip_tags(str_replace('<br>', CLX_CHAR_NL, $contents_txt));
                $task['PERCENT_COMPLETE'] = '0';
                $task['COMPLETE_DATE'] = 'null';
                $task['PRIORITY'] = 'N';
                $task['OWNERCODE'] = $r['USERNAME'];
                $task['ASSIGNEDTO'] = $r['USERNAME'];
                $task['REMINDER_DATETIME'] = 'null';
                $task['RECURRING'] = 'NONE';
                $task['DEPENDS'] = '0';
                $task['START_DATE'] = getNow('Y-m-d H:i:s');
                $task['DUE_DATE'] = '';
				if($this->etl_param['debug'] === true) {
					echo "task, <br>";
				    pre($task);
				}
                ClxCommon::$db->createRecord('CLX_US_TASKS', $task, false);
                $excludetask[$r['USERNAME']] = CLX_NUM_ONE;
                if($this->etl_param['debug'] === true) { pre('CREATE_TASK for :'.$r['USERNAME'].', Subject: '.$sendAlert_pars['SUBJECT']); }
            }
        }
    }
    
    /**
     * Reemplazar Elementos !VAR en el cuerpo del mensaje para envio del alerta o email
     * @param varchar $contents cuerpo del mensaje
     * @param array $alrt_par Elementos a reemplazar en el cuerpo del mensaje
     * @return varchar Template con los reemplazos realizados (MailMerge)
     */
    function replace_template_flds($contents, $alrt_par) {
        if($this->etl_param['debug'] === true) {
			echo "Function replace_template_flds, <br>"; 
		}
        foreach ($alrt_par as $key => $val) {
            $contents = str_replace('!'.$key, $val, $contents);
        }
        return $contents;
    }

    function merge_msgs($msg_par, $glue_par = '<BR>') {
        if($this->etl_param['debug'] === true) {
			echo "Function merge_msgs, <br>"; 
		}
        if(is_array($msg_par)) {
            $msg = implode($glue_par, $msg_par);
        } else {
            $msg = $msg_par;
        }
        return $msg;
    }
    
	    /**
     * Set the next Schedule Code
     */
    function GetNextRun($IMCF_record, $lastDay=false) {
		if($this->etl_param['debug'] === true) {
			echo "Function GetNextRun, <br>"; 
		}
        $run_ETL = array('run'=>null,'INACT'=>null);		
		/*
         * ['R1'] => Recurrence Type General Type of recurrence
         * ['R2'] => Day Value
         * ['R3'] => Day Type  if r2=5 semanal  if r2=numero que coloques dias xxx and r3=1 diario es
         * ['R4'] => Every week repetitions  if r4=numero que coloques semanas and r7 es el dia de la semana  r7=1 lunes domingo 7 
         * ['R5'] => Every Month r5    es mes
         * ['R6'] => Month type
         * ['R7'] => Week days for month            r1=MNTH
         * ['R8'] => Every Year                     r1 ="YEAR"  and r8  lleno en annios
         * ['R9'] => End date                         fecha 
         * solo 1 una vez      r1=ONE       r2 r4 r6 r8 =0
         * recurmode=ONE MUL NEV
         */
      
		//Si la fecha es llena y es menor que la actual
		if (!empty($IMCF_record['RECURRENT_R9']) && date('Y-m-d')>$IMCF_record['RECURRENT_R9']) { 
			$run_ETL = array('run'=>false,'INACT'=>true);
		}
		else {  //fecha inicial contra la fecha efectiva de la configuracion,
			$initial_run_date = $IMCF_record['CLX_EFFTDATE'];//$a=fopen(kPathToWebSite."temp/salida3.txt","a+");fwrite($a,"inicial ".$initial_run_date.chr(13).chr(10));fclose($a) ;
			//fecha inicial en dia mes año separados
			$day=ltrim(substr($initial_run_date,8,2),'0');//$a=fopen(kPathToWebSite."temp/salida3.txt","a+");fwrite($a,"actual ".date("Y/m/d").chr(13).chr(10));fclose($a) ;
			$month=ltrim(substr($initial_run_date,5,2),'0');
			$year=substr($initial_run_date,0,4);
			//fecha actual en dia mes y año
			$NowDay=ltrim(date('d'),'0');
			$NowMonth=ltrim(date('m'),'0');
			$NowYear=date('Y');
			if ($lastDay) {//para calculo sobre el dia anterior
				$mk=mktime(0,0,0,$NowMonth,$NowDay-1,$NowYear);
				$NowDay=ltrim(date('d',$mk),'0');
				$NowMonth=ltrim(date('m',$mk),'0');
				$NowYear=date('Y',$mk);
			}
		
			switch ($IMCF_record['RECURRENT_R1']) {
				case 'NONE':  // NO EXISTE RECURRENCIA NO CORRE
					$run_ETL = array('run'=>false,'INACT'=>true);
					break;
				case 'ONE': //CORRE UNA VEZ
					$run_ETL = array('run'=>true,'INACT'=>true);
					break;				
				case 'MNTH': //Corrida mensual que la resta del mes actual contra el mes inicial sea una division exacta al dividir por los meses  
					if ($nowDay==$day && ($NowMonth-$month +($NowYear-$year)*12 )%$IMCF_record['RECURRENT_R5']==0)
						$run_ETL = array('run'=>true,'INACT'=>false);
					else
						$run_ETL = array('run'=>false,'INACT'=>false);
					break;	
				case 'YEAR': //Division exacta de los años segun el tiempo transcurrido
					if ($nowDay==$day && $month==$NowMonth && ($NowYear-$year)%$IMCF_record['RECURRENT_R8']==0)
						$run_ETL = array('run'=>true,'INACT'=>false);
					else
						$run_ETL = array('run'=>false,'INACT'=>false);
					break;
				case 'WEEK':// si colocan el dia de la semana devuelve R7 del 1 al 7, sino escogieron se queda en 8 por tanto calculo contra efftdate
					if ($IMCF_record['RECURRENT_R7']==8) { //no day select calculate Now - efftdate =7
						$a=mktime(0, 0, 0, $month, $day, $year);
						$b=mktime(0, 0, 0, $NowMonth, $NowDay, $NowYear);
						//mktime devuelve segundos (1 dia es 86400 , la division exacta por 7 responde si es el septimo dia ==0)
						if ((($b-$a)/86400)%7==0)
							$run_ETL = array('run'=>true,'INACT'=>false);
						else
							$run_ETL = array('run'=>false,'INACT'=>false);		
					}else { //si colocaron el dia devuelve del 1 al 7  date(N) devuelve eso
						if (date('N')==$IMCF_record['RECURRENT_R7'])
							$run_ETL = array('run'=>true,'INACT'=>false);
						else
							$run_ETL = array('run'=>false,'INACT'=>false);		
					}		
					break;
				case 'DAY': // sacando el dato para ver los dias la division exacta da si es valido
						$a=mktime(0, 0, 0, $month, $day, $year);
						$b=mktime(0, 0, 0, $NowMonth, $NowDay, $NowYear);
						if ((($b-$a)/86400)%$IMCF_record['RECURRENT_R2']==0) {
							$run_ETL = array('run'=>true,'INACT'=>false);
						}	
						else {
							$run_ETL = array('run'=>false,'INACT'=>false);		
						}
					break;				
			}
		}	
		return $run_ETL;
    }
    
    function imft_move_to_rejected($IMFT_record, $rejection_reason, $IMCF_record = array(),$copyOrMoveFile=false) {
        if($this->etl_param['debug'] === true) {
			echo "Function imft_move_to_rejected, <br>"; 
		}
        $op_err = array();
        $op_err['msg']='';
        $op_err['error']=false;
        
        $rejection_reason = $this->merge_msgs($rejection_reason);
        
        $update_record_init = array();
        $update_record_init['ETL_FILESEQ'] = 'null';
        $update_record_init['ETL_STATUS'] = 'REJ';
        $update_record_init['ETL_OBS'] = $rejection_reason;
		if($this->etl_param['debug'] === true) {
			echo "update_record_init, <br>";
			pre($update_record_init);
		}
		
/*
        //$filespec_from = $this->etl_param['ETL_IMPORT_PROC_DIR'] . DIRECTORY_SEPARATOR . $IMFT_record['ID'] . $this->etl_param['FILE_NAME_SEP'] . $IMFT_record['ETL_FILENAME'];
        $filespec_from = $IMFT_record['ETL_FILEPATH'] . DIRECTORY_SEPARATOR . $IMFT_record['ID'] . $this->etl_param['FILE_NAME_SEP'] . $IMFT_record['ETL_FILENAME'];
        $filespec_dest = $this->etl_param['ETL_IMPORT_REJ_DIR'] . DIRECTORY_SEPARATOR . $IMFT_record['ID'] . $this->etl_param['FILE_NAME_SEP'] . $IMFT_record['ETL_FILENAME'];
        if(file_exists($filespec_from)) {
            if(!file_exists($filespec_dest)) {
                // Mueve archivo al directorio de archivos rechazados
                if(!rename($filespec_from, $filespec_dest)) {
                    // No lo pudo mover
                    $op_err['msg'] = dict('GEN_ETL_ERR_020', $filespec_from, $filespec_dest) . ' [020]';
                    $op_err['error'] = true;
                }
            } else {
                // Inconsistencia: existe en el origen y en el destino tambien
                $op_err['msg'] = dict('GEN_ETL_ERR_020', $filespec_from, $filespec_dest) . ' [025-EXIST-DEST]';
                $op_err['error'] = true;
            }
        } else {
            if(!file_exists($filespec_dest)) {
                // Inconsistencia: No existe en el origen ni en el destino
                $op_err['msg'] = dict('GEN_ETL_ERR_020', $filespec_from, $filespec_dest) . ' [027-NO-EXIST-ORIG]';
                $op_err['error'] = true;
            }
            // SI EXISTE EL DESTINO, ES QUE LO PROCESO, LO MOVIO PERO NO MARCO EL REGISTRO... ASI QUE LO MARCA...
        }
*/
//				$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivo2.txt','a+');
//				fwrite($tta,chr(13).chr(10).'2221118- hora:'.date( 'h:i:s d/m/Y').chr(13).chr(10));	
//				fwrite($tta,chr(13).chr(10).'move linea 1092,$IMFT_record'. print_r($IMFT_record,true).chr(13).chr(10));fclose($tta);
//			
        $move_response = $this->move_imft_file($IMFT_record['ID'], $this->etl_param['ETL_IMPORT_REJ_DIR'], $IMFT_record, $update_record_init,$copyOrMoveFile,true);
        $op_err['error'] = $move_response['error'];
        $op_err['msg'] = $move_response['msg'];
        unset($move_response);
        if($op_err['error'] === false) {

            // Actualiza directorio actual del archivo, porque lo pudo mover
            $record = array();
            $record['ETL_FILEPATH'] = $this->etl_param['ETL_IMPORT_REJ_DIR'];
            $record['ETL_FILESEQ'] = 'null';
            $record['ETL_STATUS'] = 'REJ';
            $record['ETL_OBS'] = $rejection_reason;
			
            if($this->etl_param['debug'] === true) {
				echo "record<br>";
				pre($record);
				ClxCommon::$db->debug=true;
			}
            ClxCommon::$db->updateRecord($this->imftname, $record, 'ID='.$IMFT_record['ID']);
            if($this->etl_param['debug'] === true) { ClxCommon::$db->debug=false; }

            // Lo pudo mover!
            if($op_err['msg'] === CLX_CHAR_EMPTY_STRING) {
                $filespec_from = $IMFT_record['ETL_FILEPATH'] . DIRECTORY_SEPARATOR . $IMFT_record['ID'] . $this->etl_param['FILE_NAME_SEP'] . $IMFT_record['ETL_FILENAME'];
                $op_err['msg'] = $rejection_reason;
            }
        }
        // En caso de existir el registro de IMCF, lo agrega al array que se va a enviar a etl_send_alert() para que ponga los enlaces
        if(isset($IMCF_record['ID'])) {
            $IMCF_record = array_merge(array('IMCF-ID' => $IMCF_record['ID']), $IMCF_record);
            $IMFT_record = array_merge($IMFT_record, $IMCF_record);
        }
        // Reporte de error o situacion
        $this->etl_send_alert($op_err['msg'], array_merge(array('IMFT-ID' => $IMFT_record['ID']), $IMFT_record));
    }
    function move_imft_file($IMFT_id, $destination_dir, $IMFT_record = null, $update_record_init = array(),$copyOrMoveFile=false) {
        pre($destination_dir);
		if($this->etl_param['debug'] === true) {
			echo "Function move_imft_file, <br>"; 
		}
        $response = array();
        $response['error'] = false;
        $response['msg'] = '';
        $response['IMFT_record'] = $IMFT_record;
        if(empty($response['IMFT_record'])) {
            $response['IMFT_record'] = ClxCommon::$db->getRecord($this->imftname, 'ID='.$IMFT_id);
            if(empty($response['IMFT_record'])) {
                /*
                 * GEN_MSG_RECORD_NOTFOUND
                 * Record not found: ^1
                 * Registro no encontrado: ^1
                 */
                $response['error'] = true;
                $response['msg'] = dict('GEN_MSG_RECORD_NOTFOUND', 'IMFT-ID "'.$IMFT_id.'"') . ' [040]';
                return $response;
            }
        }
        $filename_dest = $IMFT_id . $this->etl_param['FILE_NAME_SEP'] . $response['IMFT_record']['ETL_FILENAME'];
        $filespec_from = $response['IMFT_record']['ETL_FILEPATH'] . DIRECTORY_SEPARATOR . $filename_dest;
        $filespec_dest = $destination_dir . DIRECTORY_SEPARATOR . $filename_dest;
        $record = array();
		if($this->etl_param['debug'] === true) {
			echo "filespec_from =",$filespec_from ,"<br>";
			echo "filespec_dest =", $filespec_dest ,"<br>";

		
		}
        if($response['IMFT_record']['ETL_FILEPATH'] !== $destination_dir) {
            // El archivo NO está en el directorio de destino
            // Mueve archivo al directorio destino especificado
            if(file_exists($filespec_from)) {
                if(!file_exists($filespec_dest)) {
					if ($copyOrMoveFile) {
						$copyOrMoveFile=copy($filespec_from, $filespec_dest);
					}
					else {
						$copyOrMoveFile=rename($filespec_from, $filespec_dest);
					}
                    if(!$copyOrMoveFile) {
                        /*
                         * GEN_ETL_ERR_020
                         * Could not move "^1" to "^2"
                         * No se pudo mover "^1" a "^2"
                         */
                        $response['error'] = true;
                        $response['msg'] = dict('GEN_ETL_ERR_020', $filespec_from, $filespec_dest) . ' [010-A]';
                            // OJO no se envia 'IMFT-ID' al alerta porque luego se elimina el registro...
                            //$this->etl_send_alert($msg, $response['IMFT_record']); 
                            // Elimina el registro de la tabla temporal
                            //ClxCommon::$db->deleteRecords($this->imftname, 'ID='.$IMFT_id);
                    }
                } else {
                    // Inconsistencia: existe en el origen y en el destino tambien
                    $response['error'] = true;
                    $response['msg'] = dict('GEN_ETL_ERR_020', $filespec_from, $filespec_dest) . ' [025-EXIST-DEST]';
                }
            } else {
                if(!file_exists($filespec_dest)) {
                    // Inconsistencia: No existe en el origen ni en el destino
                    $response['error'] = true;
                    $response['msg'] = dict('GEN_ETL_ERR_020', $filespec_from, $filespec_dest) . ' [027-NO-EXIST-ORIG]';
                } else {
                    // SI EXISTE EL DESTINO, ES QUE LO PROCESO, LO MOVIO PERO NO MARCO EL REGISTRO... ASI QUE LO MARCA...
                    // Incluye valores de columnas a ser guardadas segun mandato del metodo que llamo a este metodo ($update_record_init)
                }
            }
        }
		//OLD  STATUS OBSERVATIONS ACUMULATE
		$sql = 'SELECT ETL_OBS FROM ' . $this->imftname . ' WHERE ID='.$IMFT_id;
		$IMFT_results_ETL_OBS = ClxCommon::$db->getOne($sql);
		$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivoETL6.txt','a+');
				fwrite($tta,chr(13).chr(10).'response:'.print_r($response,true).date( 'h:i:s d/m/Y').chr(13).chr(10));	
				fclose($tta);
		if($this->etl_param['debug'] === true) {
				echo "response:", print_r($response,true)."<br>";	
				
		}
		if($response['error'] === true){
            // Marca registro con status error
            $record['ETL_STATUS'] = 'ERR';
            // Si habia algun mensaje en $update_record_init['ETL_OBS'], lo pone delante de la observacion a ser registrada...
            $record['ETL_OBS'] = (isset($update_record_init['ETL_OBS']) ? $update_record_init['ETL_OBS'].'<BR>' : '') . $response['msg'];
			$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivoETL6.txt','a+');
				fwrite($tta,chr(13).chr(10).'equivocado '.print_r($record,true).date( 'h:i:s d/m/Y').chr(13).chr(10));	
				fclose($tta);
			if($this->etl_param['debug'] === true) {
				echo 'equivocado '.print_r($record,true)."<br>";	
				
			}		
		
        } else {
            // Incluye valores de columnas a ser guardadas segun mandato del metodo que llamo a este metodo ($update_record_init)
            $record = $update_record_init;
            // Actualiza directorio actual del archivo, porque lo pudo mover
            $record['ETL_FILEPATH'] = $destination_dir;
            //$this->etl_param['qty_proc']++;
//			$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivoETL6.txt','a+');
//				fwrite($tta,chr(13).chr(10).'lo que necesito:'.print_r($record,true).date( 'h:i:s d/m/Y').chr(13).chr(10));	
//				fclose($tta);
//		
        }
        if(isset($record['ETL_OBS'])) {
            // Reemplaza eventuales tokens
            $record['ETL_OBS'] = str_replace('%filename_dest%', $filename_dest, $record['ETL_OBS']);
            $record['ETL_OBS'] = str_replace('%filespec_from%', $filespec_from, $record['ETL_OBS']);
            $record['ETL_OBS'] = str_replace('%filespec_dest%', $filespec_dest, $record['ETL_OBS']);
		}
		else
			$record['ETL_OBS']='';
		$record['ETL_OBS'] = (!empty($IMFT_results_ETL_OBS)?$IMFT_results_ETL_OBS.'<br><br>':'').$record['ETL_OBS'];
        
		if($response['msg'] === CLX_CHAR_EMPTY_STRING && isset($record['ETL_OBS'])) {
            $response['msg'] = $record['ETL_OBS'];
        }
        if($this->etl_param['debug'] === true) { ClxCommon::$db->debug=true; }
        ClxCommon::$db->updateRecord($this->imftname, $record, 'ID='.$IMFT_id);
        if($this->etl_param['debug'] === true) { ClxCommon::$db->debug=false; }
		 ClxCommon::$db->executequery('commit');
        return $response;
    }
   
    function move_imft_filex($IMFT_id, $destination_dir, $IMFT_record = null, $update_record_init = array(),$copyOrMoveFile=false,$reject=false) {
        if($this->etl_param['debug'] === true) {
			echo "Function move_imft_filex, <br>"; 
		}
		$response = array();
        $response['error'] = false;
        $response['msg'] = '';
        $response['IMFT_record'] = $IMFT_record;
        if(empty($response['IMFT_record'])) {
            $response['IMFT_record'] = ClxCommon::$db->getRecord($this->imftname, 'ID='.$IMFT_id);
            if(empty($response['IMFT_record'])) {
                /*
                 * GEN_MSG_RECORD_NOTFOUND
                 * Record not found: ^1
                 * Registro no encontrado: ^1
                 */
                $response['error'] = true;
                $response['msg'] = dict('GEN_MSG_RECORD_NOTFOUND', 'IMFT-ID "'.$IMFT_id.'"') . ' [040]';
                if($this->etl_param['debug'] === true) {
					echo "Error in move_imft_filex, <br>";
					pre($response);
				}	
				return $response;
            }
        }
		$filename_dest = $IMFT_id . $this->etl_param['FILE_NAME_SEP'] . $response['IMFT_record']['ETL_FILENAME'];
				$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivo2.txt','a+');
				fwrite($tta,chr(13).chr(10).'4118- hora:'.date( 'h:i:s d/m/Y').chr(13).chr(10));	
				fwrite($tta,chr(13).chr(10).'$filename_dest:'. $filename_dest.chr(13).chr(10));
				
				$te=debug_backtrace(); 
				for ($t=0;$t<12;$t++) {
					if (isset($te[$t]["file"])){
						fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));
					}
				}
				fclose($tta);
				$filespec_from = $response['IMFT_record']['ETL_FILEPATH'] . DIRECTORY_SEPARATOR . $response['IMFT_record']['ETL_FILENAME'];
				$filespec_dest = $destination_dir . DIRECTORY_SEPARATOR . $filename_dest;
				//$filespec_dest=str_replace('-','_',str_replace('.','',$filespec_dest));
				$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivo2.txt','a+');
				fwrite($tta,chr(13).chr(10).'1118- hora:'.date( 'h:i:s d/m/Y').chr(13).chr(10));	
				fwrite($tta,chr(13).chr(10).'$filespec_dest:'. $filespec_dest.chr(13).chr(10));
				fwrite($tta,chr(13).chr(10).'$filespec_from:'. $filespec_from.chr(13).chr(10));
				fclose($tta);
				if($this->etl_param['debug'] === true) {
					echo '$filespec_dest:'. $filespec_dest."<br>";
					echo '$filespec_from:'. $filespec_from."<br><br>";
				
			
				}
		
        $record = array();
        if($response['IMFT_record']['ETL_FILEPATH'] !== $destination_dir) {
            // El archivo NO está en el directorio de destino
            // Mueve archivo al directorio destino especificado
            if(file_exists($filespec_from)) {
				$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivo2.txt','a+');
				fwrite($tta,chr(13).chr(10).'1118- hora:'.date( 'h:i:s d/m/Y').chr(13).chr(10));	
				fwrite($tta,chr(13).chr(10).'encontro'.$filespec_from. chr(13).chr(10));fclose($tta);
		
                if(!file_exists($filespec_dest)) {
					if ($copyOrMoveFile) {
						$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivo2.txt','a+');
				fwrite($tta,chr(13).chr(10).'1118- hora:'.date( 'h:i:s d/m/Y').chr(13).chr(10));	
				fwrite($tta,chr(13).chr(10).'verdadero'. chr(13).chr(10));fclose($tta);
		
						$copyOrMoveFile=copy($filespec_from, $filespec_dest);
						$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivo2.txt','a+');
				fwrite($tta,chr(13).chr(10).'1118- hora:'.date( 'h:i:s d/m/Y').chr(13).chr(10));	
				fwrite($tta,chr(13).chr(10).'si copio encontro'.$filespec_from. chr(13).chr(10));fclose($tta);
		
					}
					else {
						$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivo2.txt','a+');
				fwrite($tta,chr(13).chr(10).'1118- hora:'.date( 'h:i:s d/m/Y').chr(13).chr(10));	
				fwrite($tta,chr(13).chr(10).'si renombro'. chr(13).chr(10));fclose($tta);
		
				
						$copyOrMoveFile=rename($filespec_from, $filespec_dest);
					}
                    if(!$copyOrMoveFile) {
//								$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivo2.txt','a+');
//							fwrite($tta,chr(13).chr(10).'1118- hora:'.date( 'h:i:s d/m/Y').chr(13).chr(10));	
//						fwrite($tta,chr(13).chr(10).'si copio 2 fase encontro'.$filespec_from. chr(13).chr(10));fclose($tta);
		
	
		
                        /*
                         * GEN_ETL_ERR_020
                         * Could not move "^1" to "^2"
                         * No se pudo mover "^1" a "^2"
                         */
                        $response['error'] = true;
                        $response['msg'] = dict('GEN_ETL_ERR_020', $filespec_from, $filespec_dest) . ' [010-A]';
                            // OJO no se envia 'IMFT-ID' al alerta porque luego se elimina el registro...
                            //$this->etl_send_alert($msg, $response['IMFT_record']); 
                            // Elimina el registro de la tabla temporal
                            //ClxCommon::$db->deleteRecords($this->imftname, 'ID='.$IMFT_id);
                    }
                } else {
//							$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivo2.txt','a+');
//							fwrite($tta,chr(13).chr(10).'rr8- hora:'.date( 'h:i:s d/m/Y').chr(13).chr(10));	
//							fwrite($tta,chr(13).chr(10).'incosistencia'.$filespec_from. chr(13).chr(10));fclose($tta);
//		
				

                    // Inconsistencia: existe en el origen y en el destino tambien
                    $response['error'] = true;
                    $response['msg'] = dict('GEN_ETL_ERR_020', $filespec_from, $filespec_dest) . ' [025-EXIST-DEST]';
                }
            } else {
//				$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'archivo2.txt','a+');
//				fwrite($tta,chr(13).chr(10).'1118- hora:'.date( 'h:i:s d/m/Y').chr(13).chr(10));	
//				fwrite($tta,chr(13).chr(10).'no encontro'.$filespec_from. chr(13).chr(10));fclose($tta);
//		
                if(!file_exists($filespec_dest)) {
                    // Inconsistencia: No existe en el origen ni en el destino
                    $response['error'] = true;
                    $response['msg'] = dict('GEN_ETL_ERR_020', $filespec_from, $filespec_dest) . ' [027-NO-EXIST-ORIG]';
                } else {
                    // SI EXISTE EL DESTINO, ES QUE LO PROCESO, LO MOVIO PERO NO MARCO EL REGISTRO... ASI QUE LO MARCA...
                    // Incluye valores de columnas a ser guardadas segun mandato del metodo que llamo a este metodo ($update_record_init)
                }
            }
        }
		//OLD  STATUS OBSERVATIONS ACUMULATE
		$sql = 'SELECT ETL_OBS FROM ' . $this->imftname . ' WHERE ID='.$IMFT_id;
		$IMFT_results_ETL_OBS = ClxCommon::$db->getOne($sql);
		
        if($response['error'] === true){
            // Marca registro con status error
            $record['ETL_STATUS'] = 'ERR';
            // Si habia algun mensaje en $update_record_init['ETL_OBS'], lo pone delante de la observacion a ser registrada...
            $record['ETL_OBS'] = (isset($update_record_init['ETL_OBS']) ? $update_record_init['ETL_OBS'].'<BR>' : '') . $response['msg'];
        } else {
            // Incluye valores de columnas a ser guardadas segun mandato del metodo que llamo a este metodo ($update_record_init)
            $record = $update_record_init;
            // Actualiza directorio actual del archivo, porque lo pudo mover
            $record['ETL_FILEPATH'] = $destination_dir;
            //$this->etl_param['qty_proc']++;
        }
        if(isset($record['ETL_OBS'])) {
            // Reemplaza eventuales tokens
            $record['ETL_OBS'] = str_replace('%filename_dest%', $filename_dest, $record['ETL_OBS']);
            $record['ETL_OBS'] = str_replace('%filespec_from%', $filespec_from, $record['ETL_OBS']);
            $record['ETL_OBS'] = str_replace('%filespec_dest%', $filespec_dest, $record['ETL_OBS']);
		}
		else
			$record['ETL_OBS']='';
		$record['ETL_OBS'] = (!empty($IMFT_results_ETL_OBS)?$IMFT_results_ETL_OBS.'<br><br>':'').$record['ETL_OBS'];
        
		if($response['msg'] === CLX_CHAR_EMPTY_STRING && isset($record['ETL_OBS'])) {
            $response['msg'] = $record['ETL_OBS'];
        }
        if($this->etl_param['debug'] === true) { ClxCommon::$db->debug=true; }
        ClxCommon::$db->updateRecord($this->imftname, $record, 'ID='.$IMFT_id);
        if($this->etl_param['debug'] === true) { ClxCommon::$db->debug=false; }
        return $response;
    }
    
    function def_record_data_for_notification($IMFT_record = array()) {
		if($this->etl_param['debug'] === true) {
			echo "Function def_record_data_for_notification, <br>"; 
		}
        $flds_to_defval = array();
        //$flds_to_defval[] = 'ID';
        $flds_to_defval[] = 'ETL_FILENAME';
        $flds_to_defval[] = 'ETL_FILEPATH';
        $flds_to_defval[] = 'ETL_FILEID';
        $flds_to_defval[] = 'ETL_FILEDATE';
        $flds_to_defval[] = 'ETL_FILESEQ';
        $flds_to_defval[] = 'ETL_FILEEXT';
        foreach($flds_to_defval as $fld_name) {
            if(!isset($IMFT_record[$fld_name])) {
                $IMFT_record[$fld_name] = self::DEF_VALUE_FOR_NOTIFICATION;
            }
        }
        return $IMFT_record;
    }
    
    function mass_imft_status_ass($new_status, $idlist = null) {
		if($this->etl_param['debug'] === true) {
			echo "Function mass_imft_status_ass, <br>"; 
		}
        // Por Ej. $a = new ETL_utilities(); $a->mass_imft_status_ass('PEN');
        $extra_sql = '';
        $this->mass_status_ass_gen($new_status, $this->imftname, 'ETL_STATUS', $extra_sql, $idlist);
    }

    function mass_imoq_status_ass($new_status, $idlist = null) {
		if($this->etl_param['debug'] === true) {
			echo "Function mass_imoq_status_ass, <br>"; 
		}
        // Por Ej. $a = new ETL_utilities(); $a->mass_imoq_status_ass('IDLE');
        $extra_sql = ' AND NOT REC_STATUS IN '. singleQuoteArray(array('END','RUN'));
        $this->mass_status_ass_gen($new_status, $this->imoqname, 'REC_STATUS', $extra_sql, $idlist);
    }
    
    function mass_status_ass_gen($new_status, $tablename, $colname, $extra_sql = '', $idlist = null) {
        if($this->etl_param['debug'] === true) {
			echo "Function mass_status_ass_gen, <br>"; 
		}
        if(is_null($idlist)) {
            $idlist = getIdlist();
        }
        $record = array();
        $record[$colname] = $new_status;
        if($this->etl_param['debug'] === true) { ClxCommon::$db->debug=true; }
        ClxCommon::$db->updateRecord($tablename, $record, 'ID IN ('. implode(',', $idlist).')');
        if($this->etl_param['debug'] === true) { ClxCommon::$db->debug=false; }
    }
    
    function url_to_dbim($tablename, &$record, $source_colname = null, $destination_colname = 'DBIM_URL') {
        if($this->etl_param['debug'] === true) {
			echo "Function url_to_dbim, <br>"; 
		}
        if (UserRequest::$request['ac'] !== 'DISPLAY') {
            $record[$tablename.'_'.$destination_colname] = '';
            return;
        }
        $idlist = null;
        if(!is_null($source_colname)) {
            $idlist = $record[$tablename.'_'.$source_colname];
        } else {
            $idlist = ClxCommon::$db->getField('CLX_DB_IMPORTS', 'ID', 'IDCODE='.singleQuote($record[$tablename.'_IMPORT_CODE']));
        }
        if(!is_null($idlist) && trim($idlist) != CLX_CHAR_EMPTY_STRING) {
            /*
             * GEN_ETL_MSG_030
             * Click here to view record
             * Clic aquí para ver el registro
             */
            $record[$tablename.'_'.$destination_colname] = $this->get_display_url('', dict('GEN_ETL_MSG_030'), $idlist, 'DBIM', self::DEF_URL_TOOL_DISPLAY);
        }
//pre($record); exit();
    }
    
    function url_to_imoq($tablename, &$record, $source_colname = null, $destination_colname = 'IMOQ_URL') {
        if($this->etl_param['debug'] === true) {
			echo "Function url_to_imoq, <br>"; 
		}
        if (UserRequest::$request['ac'] !== 'DISPLAY') {
            $record[$tablename.'_'.$destination_colname] = '';
            return;
        }
        $idlist = null;
        if(!is_null($source_colname)) {
            $idlist = $record[$tablename.'_'.$source_colname];
        } else {
            if($tablename == 'IMFT') {
                $idlist = ClxCommon::$db->getField($this->imoqname, 'ID', 'IMFT_ID='.singleQuote($record[$tablename.'_ID']));
            }
        }
        if(!is_null($idlist) && trim($idlist) != CLX_CHAR_EMPTY_STRING) {
            $record[$tablename.'_'.$destination_colname] = $this->get_display_url($this->etl_param['ETL_DEF_LSTG_IMOQ'], dict('GEN_ETL_MSG_030'), $idlist);
        } else {
            $record[$tablename.'_'.$destination_colname] = self::DEF_LABEL_NOT_AVAIL;
        }
//pre($record); exit();
    }
    
    function url_to_imft($tablename, &$record, $source_colname = 'IMFT_ID', $destination_colname = 'IMFT_URL') {
        if($this->etl_param['debug'] === true) {
			echo "Function url_to_imft, <br>"; 
		}
        if (UserRequest::$request['ac'] !== 'DISPLAY') {
            $record[$tablename.'_'.$destination_colname] = '';
            return;
        }
        $idlist = $record[$tablename.'_'.$source_colname];
        $record[$tablename.'_'.$destination_colname] = $this->get_display_url($this->etl_param['ETL_DEF_LSTG_IMFT'], dict('GEN_ETL_MSG_030'), $idlist);
//pre($record); exit();
    }
    
    function get_display_url($listcode, $labelmsg, $idlist, $toolcode = 'EDIT', $url = self::DEF_URL_EDIT_DISPLAY) {
        if($this->etl_param['debug'] === true) {
			echo "Function get_display_url, <br>"; 
		}
        return str_replace('%TOOLCODE%', $toolcode, str_replace('%LISTING%', $listcode, str_replace('%LABEL%', $labelmsg, str_replace('%IDLIST%', $idlist, $url))));
    }
	function call_rename($filedestino,$IMFT_id) {
		if($this->etl_param['debug'] === true) {
			echo "Function call_rename, <br>";
			pre($IMFT_id);
		}
		rename($filedestino, str_replace($this->etl_param['ETL_IMPORT_PEND_DIR'],$this->etl_param['ETL_IMPORT_REJ_DIR'], $filespec_dest));
		$IMFT_record=$db->getrecord($this->imftname, 'ID='.$IMFT_id);
        $this->etl_send_alert(dict('FILE_PROCESS',$filedestino), array_merge(array('IMFT-ID' => $IMFT_record['ID']), $IMFT_record));
	}
}
