<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-10-07 11:58:37 -0400 (Wed, 07 Oct 2015) $
 * @version        $Rev: 7154 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class inve_utilities {

    var $code = 'FIRE';
    var $sdate = ''; // Start Date
    var $edate = ''; // End Date
    var $modstbl = 'FIDU_MODULE_TABLES';   // Module Tables
    var $cashtbl = 'FIDU_CASH';      // Cash table
    var $invstbl = 'FIDU_CONTRACT_INVESTMENTS';  // Cash table
    var $contents;  // Content Output
    var $tcontname; // Contracts
    var $tinstname; // Instructions
    var $tpartname; // Participants
    var $ttranname; // Contract Transactions
    var $tttblname; // Transactions Table
    var $tdistname; // Participant Distribution
    var $tassdname; // Asset Participant Distribution
    var $tlogsname; // Processes
    var $tassename; // Assets
    var $asset_accu; // Asset Accumulator array
    var $commitions = array(); //Comitions values

    /**
     * Contructor
     */

    function fidu_utilities() {
        if (!empty(UserRequest::$request[$this->code . '_SDATE'])) {
            $this->sdate = UserRequest::$request[$this->code . '_SDATE'];
            $this->edate = UserRequest::$request[$this->code . '_EDATE'];
        } else {
            $this->sdate = xFormat::getNow('Y-m-01');
            $this->edate = xFormat::getNow('Y-m-d');
        }
        $this->contents = '';
        $this->acconame = tableName('ACCO'); // Crm Accounts
        $this->acloname = tableName('ACLO'); // Account locations
        $this->ficoname = tableName('FICO'); // Contracts
        $this->fiainame = tableName('FIAI'); // Instructions
        $this->fipaname = tableName('FIPA'); // Participants
        $this->fiatname = tableName('FIAT'); // Contract Transactions
        $this->fitbname = tableName('FITB'); // Transactions Table
        $this->fipdname = tableName('FIPD'); // Participant Distribution
        $this->fidaname = tableName('FIDA'); // Asset Participant Distribution
        $this->procname = tableName('PROC'); // Processes
        $this->fiasname = tableName('FIAS'); // Assets
        $this->inprname = tableName('INPR'); // Protfolio Products table
    }

// End method
    /**
     * Builds the contract statement for each account
     * The following section will be included on report:
     * Participant Account, Message Board, Account Summary(General
     * Information), Portfolio Distribution, Account
     * Movements / Other Movements
     */
    function build() {
        $this->contents = '';
        $contractid = UserRequest::$request['idlist'];
        $msg = array();
        $ficoRec = ClxCommon::$db->getRecord($this->ficoname, 'ID = ' . singleQuote($contractid));
        $ficoRec[$this->code . '_CLIENT'] = (!empty(UserRequest::$request[$this->code . '_CLIENT'])) ? UserRequest::$request[$this->code . '_CLIENT'] : CLX_CHAR_EMPTY_STRING;
        $ficoRec[$this->code . '_SDATE'] = $this->sdate;
        $ficoRec[$this->code . '_EDATE'] = $this->edate;
        if ($contractid === true && empty(UserRequest::$request['confirm']) || !$this->checkDialog($msg)) {
            $this->print_dialog($ficoRec, $msg);
        } elseif (!empty($ficoRec)) {
            $tableFrame = new htmlTable(CLX_WIDTH_ONE);
            $table->setProps(array(CLX_PROP_WIDTH => '90%', CLX_PROP_ALIGN => 'center'));
            $tableFrame->addcell('<IMG SRC="./data/files/banklogo_sml.jpg"><br><br>');
            // Participant Account //FIPA.PARTICIPANT_TYPE = 'B'
            $sql = 'SELECT  ACCO.IDCODE, ACCO.IDNAME, ACLO.*  FROM  ' . $this->fipaname . ' FIPA,  ' . $this->acconame . ' ACCO  LEFT JOIN  ' . $this->acloname . ' ACLO ON  ACLO.ACCOUNTCODE = FIPA.ACCOUNTCODE WHERE  FIPA.CONTRACT_CODE =' . singleQuote($ficoRec['IDCODE']) . ' AND  ACCO.IDCODE = FIPA.ACCOUNTCODE AND  ACLO.ACCOUNTCODE = FIPA.ACCOUNTCODE AND  ACLO.ISPRIMARY  = 1 AND ACCO.IDCODE =' . singleQuote($ficoRec[$this->code . '_CLIENT']);
            $result = ClxCommon::$db->executeQuery($sql);
            while ($row = ClxCommon::$db->getNextRecord($result)) {
                $tableFrame->addcell($this->buldClient($ficoRec, $row));
            }
            $tableFrame->addcell('<hr size="1" noshade>');
            $tableFrame->addcell(dict('FIDU_CODE_TEST'), array(CLX_PROP_ALIGN => 'center'));
            $tableFrame->addcell('<hr size="1" noshade>');
            $tableFrame->addcell('<h3>' . dict('FIDU_CODE_SUMMARY') . '</h3>', array(CLX_PROP_ALIGN => 'center'));
            // Informacion General
            $tableFrame->addcell($this->buildSummary($ficoRec));
            $tableFrame->addcell('<hr size="1" noshade>');
            // Portfolio o Posicion de la cartera.
            $tableFrame->addcell($this->buildPorfolio($ficoRec));
            // Account Details
            $tableFrame->addcell('<h3>' . dict('FIDU_CODE_STATEMENT') . '</h3>', array(CLX_PROP_ALIGN => 'center'));
            $p = '<b>' . dict('FICO_CODE_PERIOD') . ': ' . $this->sdate . ' a ' . $this->edate . '</b>';
            $tableFrame->addcell($p, array(CLX_PROP_ALIGN => 'center'));
            unset($p);
            $tableFrame->addcell('<hr size="1" noshade>');
            //Period Transactions
            $tableFrame->addcell($this->buildTransactions($ficoRec));
            // Account Detail Others
            $tableFrame->addcell('<hr size="1" noshade>');
            $tableFrame->addcell($this->buildDetailCommitions($ficoRec));
            $tableFrame->addcell('<hr size="1" noshade>');
            $this->contents = $tableFrame->source();
        }
    }

// End method
    /**
     * Prompt period && Client to display on statement
     */
    function print_dialog($record, $msg) {
        $form = new htmlForm(CLX_PROP_ACTION, 'pop.php', CLX_PROP_ID, 'theForm', 'name', 'theForm');
        $form->addArgument(CLX_PROP_TO, UserRequest::$request[CLX_PROP_TO]);
        $form->addArgument('ac', UserRequest::$request['ac']);
        $form->addArgument('idlist', UserRequest::$request['idlist']);
        $form->addArgument('wind', '1');
        $form->addArgument('confirm', '1');
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_ALIGN => 'center'));
        $table->addCell(dict('FIDU_CODE_STATEMENT'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell(dict('FIDU_CODE_STATEMENT_EXPLAIN'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $field = getToolObject('DBFT', 'DATE');
        //Start Date
        $cell = $field->placeEditFieldObj('theForm', $msg, (empty(UserRequest::$post[$this->code . '_SDATE'])) ? $this->sdate : UserRequest::$post[$this->code . '_SDATE'], 'DATE', $this->code . '_SDATE', 'SDATE', 'GEN_LBL_FROM', CLX_NUM_20, CLX_NUM_20, '', '', '', true, false, false);
        $table->addCell($cell->source(), array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        //To date
        $cell = $field->placeEditFieldObj('theForm', $msg, (empty(UserRequest::$post[$this->code . '_EDATE'])) ? $this->edate : UserRequest::$post[$this->code . '_EDATE'], 'DATE', $this->code . '_EDATE', 'EDATE', 'GEN_LBL_TO', CLX_NUM_20, CLX_NUM_20, '', '', '', true, false, false);
        $table->addCell($cell->source(), array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        //Start Client Search
        if (!empty($_SESSION['user_record']['isadmin'])) {
            $table->addCell(dict('FIDU_CODE_CLIENT'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            $sql = 'SELECT ACCO.ID, ACCO.IDCODE, ACCO.IDNAME FROM ' . $this->fipaname . ' FIPA, ' . $this->acconame . ' ACCO WHERE  FIPA.CONTRACT_CODE =' . singleQuote($record['IDCODE']) . ' AND ACCO.IDCODE = FIPA.ACCOUNTCODE';
            $records = ClxCommon::$db->executeQuery($sql);
            $i = CLX_INIT_ZERO;
            while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
                $radio = new htmlRadioButton($this->code . '_CLIENT', true, $record['IDCODE']);
                $table->addCell($radio->source() . ' ' . $record['IDCODE'] . ',' . $record['IDNAME'], array(CLX_PROP_CLASS => (($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT), CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
                $i++;
            }
            $table->addCell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        } else {
            //If internet user
            $form->addArgument($this->code . '_CLIENT', $this->internetUserCheck($record));
        }
        $c = new htmlSubmit(dict('GEN_LBL_CONTINUE'), 'PRINT_DIALOG');
        $buttons = $c->source();
        $c = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $this->contents = $form->source();
    }

// End method
    /**
     * Validate if correct values
     */
    function checkDialog(&$msg) {
        $msg = array();
        xValidate::date($msg, $this->code . '_SDATE', $this->sdate, dict('GEN_LBL_DATE'));
        xValidate::date($msg, $this->code . '_EDATE', $this->edate, dict('GEN_LBL_DATE'));
        if (adodb_strtotime($this->sdate) >= adodb_strtotime($this->edate)) {
            $msg[$this->code . '_SDATE'] = dict('GEN_ERR_DATERANGEINVALID');
        }
        return count($msg) == CLX_NUM_ZERO;
    }

    function internetUserCheck($record) {
        $return = '';
        if (empty($_SESSION['user_record']['isadmin'])) {
            $userRec = ClxCommon::$db->getRecord('FIDU_TRUST_INTERNET_USERS', 'USER_CODE =' . singleQuote($_SESSION['user_record']['username']), 'CONTRACT_CODE =' . singleQuote($record['IDCODE']));
            if (!empty($userRec)) {
                $return = $userRec['ACCOUNTCODE'];
            }
        }// End if
        return $return;
    }

//End Method
    /**
     * Send to output statement
     */
    function source() {
        return $this->contents;
    }

// End Method
    // S E C T I O N  B U I L D E R S
    function buldClient($contract, $record) {
        $DBTL = getTool('DBLT');
        $tableFrame = new htmlTable(CLX_WIDTH_ONE + CLX_NUM_ONE);
        $tableFrame->setProps(array(CLX_PROP_WIDTH, CLX_PROP_100PCT));
        $table = new htmlTable(CLX_WIDTH_ONE);
        $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addcell('<b>' . $record['IDNAME'] . '</b>');
        $table->addcell($record['ADDRESS1'] . ' ' . $record['ADDRESS2']);
        $table->addcell($record['CITY'] . ', ' . $record['STATE'] . ' ' . $record['ZIPCODE']);
        $record['COUNTRY'] = $DBTL->getListItem('COUN', $record['COUNTRY']);
        $table->addcell($record['COUNTRY']);
        $tableFrame->addcell($table->source());
        //Account Information
        $table = new htmlTable(CLX_WIDTH_ONE);
        $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addcell('<b>' . dict('FIDU_CODE_ACCOUNTNO') . ':<i>' . $contract['IDCODE'] . '</i></b>', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
        $currency = $DBTL->getListItem('CURR', $contract['CURRENCY_CODE']);
        $table->addcell('<b>' . dict('GEN_LBL_CURRENCY') . ': ' . $currency . '</b>', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
        $table->addcell(CLX_CHAR_HTML_NBSP, CLX_PROP_ALIGN, CLX_PROP_RIGHT);
        $print_anchor = new htmlAnchor(dict('GEN_LBL_PRINT'), 'javascript: window.print();');
        $table->addcell('[ ' . $print_anchor->source() . ' ]', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
        $tableFrame->addcell($table->source(), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
        return $tableFrame->source();
    }

// End method
    function buildSummary($contract) {
        //Get Contract Cash code
        $cash_code = ClxCommon::$db->getField($this->fiasname, 'IDCODE', 'CONTRACT_CODE =' . singleQuote($contract['IDCODE']), 'TRUST_ITEM_TYPE = ' . singleQuote('CA') . '');
        //Start date stamp
        $sdate_stamp = adodb_strtotime($this->sdate);
        $DBTL = getTool('DBLT');
        $sql = 'SELECT  SUM(T.BASE_TRANS_AMT) BASE_TRANS_AMT,  T.ASSET_CODE ASSET_CODE,  CT.TRUST_MODULE,  CT.TRANS_TYPE DEBIT_CREDIT,  CT.AFFECT_CASH AFFECT_CASH,  CT.TRUST_MODULE TRUST_MODULE,  T.APPROVAL_DATE  FROM  ' . $this->fiatname . ' T,  ' . $this->fitbname . ' CT WHERE  CT.IDCODE = T.TRANSTBL_CODE AND  T.CONTRACT_CODE =' . singleQuote($contract['IDCODE']) . ' AND  (T.APPROVAL_DATE <= ' . singleQuote($this->edate . ' 23:59:59') . ' AND T.APPROVAL_DATE IS NOT null)  GROUP BY  CT.TRUST_MODULE, CT.TRANS_TYPE ORDER BY  T.APPROVAL_DATE';
        // Initialize variables
        $summary = array();
        $summary[$cash_code]['VAL'] = (float) CLX_NUM_0_PT_00;
        $summary[$cash_code]['VAL_PREV'] = (float) CLX_NUM_0_PT_00;
        $summary[$cash_code]['ENTRY'] = $DBTL->getListItem('FIMO', 'CAJ');
        $total = (float) CLX_NUM_0_PT_00;       // Total Current period
        $total_prev = (float) CLX_NUM_0_PT_00;  // Total Previous period
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            if (empty($summary[$result['ASSET_CODE']]['ENTRY'])) {
                $summary[$result['ASSET_CODE']]['ENTRY'] = $DBTL->getListItem('FIMO', $result['TRUST_MODULE']);
            }
            if (empty($summary[$result['ASSET_CODE']]['VAL']))
                $summary[$result['ASSET_CODE']]['VAL'] = CLX_INIT_ZERO;
            if (empty($summary[$result['ASSET_CODE']]['VAL_PREV']))
                $summary[$result['ASSET_CODE']]['VAL_PREV'] = CLX_INIT_ZERO;
            $has_prev = ($sdate_stamp > adodb_strtotime(substr($result['APPROVAL_DATE'], CLX_NUM_ZERO, CLX_NUM_TEN))) ? true : false;
            //Previous period
            if (!empty($has_prev)) {
                //Calculating previous period
                $amt_prev = (($result['DEBIT_CREDIT'] === 'DR') ? -CLX_NUM_ONE : CLX_NUM_ONE) * $result['BASE_TRANS_AMT'];
                $summary[$result['ASSET_CODE']]['VAL_PREV'] += $amt_prev;
                $total_prev += $amt_prev;
            }
            $amt = (($result['DEBIT_CREDIT'] === 'DR') ? -CLX_NUM_ONE : CLX_NUM_ONE) * $result['BASE_TRANS_AMT'];
            $summary[$result['ASSET_CODE']]['VAL'] += $amt;
            $total += $amt;
            //Update Cash balance Previous
            if (!empty($has_prev)) {
                if ($result['TRUST_MODULE'] <> 'CAJ' && $result['AFFECT_CASH'] <> 'N') {
                    if ($result['AFFECT_CASH'] === 'I') {
                        $summary[$cash_code]['VAL_PREV'] += $result['BASE_TRANS_AMT'];
                        $total_prev += $result['BASE_TRANS_AMT'];
                    } elseif ($result['AFFECT_CASH'] === 'E') {
                        $summary_prev[$cash_code]['VAL_PREV'] -= $result['BASE_TRANS_AMT'];
                        $total_prev -= $result['BASE_TRANS_AMT'];
                    }
                }
            }
            //Update Cash balance
            if ($result['TRUST_MODULE'] <> 'CAJ' && $result['AFFECT_CASH'] <> 'N') {
                if ($result['AFFECT_CASH'] === 'I') {
                    $summary[$cash_code]['VAL'] += $result['BASE_TRANS_AMT'];
                    $total += $result['BASE_TRANS_AMT'];
                } elseif ($result['AFFECT_CASH'] === 'E') {
                    $summary[$cash_code]['VAL'] -= $result['BASE_TRANS_AMT'];
                    $total -= $result['BASE_TRANS_AMT'];
                }
            }
        }
        // Generating output
        $tableFrame = new htmlTable(CLX_WIDTH_TWO);
        $tableFrame->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $tableFrame->addcell('<h3>' . dict('FICO_CODE_GENERALINFO') . '</h3>', array(CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table = new htmlTable(CLX_WIDTH_TWO + CLX_NUM_ONE);
        $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addcell(CLX_CHAR_HTML_NBSP);
        $table->addcell('<center><b>' . dict('FICO_CODE_PREVVAL') . '</b></center>');
        $table->addcell('<center><b>' . dict('FICO_CODE_CURRVAL') . '</b></center>');
        $pctget = CLX_INIT_ZERO;
        $pctget_prev = CLX_INIT_ZERO;
        //Plot data
        $plotdata = array();
        foreach ($summary as $key => $val) {
            $pctge = ($total > CLX_NUM_ZERO) ? round((($val['VAL'] / $total) * CLX_NUM_HUNDRED), CLX_NUM_THREE) : CLX_NUM_ZERO;
            $pctget += $pctge;
            $pctge_prev = ($total_prev > CLX_NUM_ZERO) ? round((($val['VAL_PREV'] / $total_prev) * CLX_NUM_HUNDRED), CLX_NUM_THREE) : CLX_NUM_ZERO;
            $pctget_prev += $pctge_prev;
            $table->addcell($val['ENTRY']);
            //Previous Period
            $t = new htmlTable(CLX_WIDTH_TWO);
            $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT, 'cellpadding' => '1'));
            $t->addcell(xFormat::number($val['VAL_PREV']), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
            $t->addcell(xFormat::number($pctge_prev) . '%', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_WIDTH => '45'));
            $table->addcell($t->source(), array(CLX_PROP_ALIGN => 'center'));
            // Current Period
            $t = new htmlTable(CLX_WIDTH_TWO);
            $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT, 'cellpadding' => '1'));
            $t->addcell(xFormat::number($val['VAL']), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
            $t->addcell(xFormat::number($pctge) . '%', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_WIDTH => '45'));
            $table->addcell($t->source(), array(CLX_PROP_ALIGN => 'center'));
            $plotdata[$val['ENTRY']] = $val['VAL'];
        }
        $table->addcell(dict('FICO_CODE_TOTAL'));
        //Plot
        $tableFrame->addcell($this->buildSummaryPlot($plotdata));
        unset($plotdata);
        //Preivous Period Total
        $t = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT, 'cellpadding' => '1'));
        $t->addcell('<b>' . xFormat::number($total_prev) . '</b>', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
        $t->addcell('<b>' . xFormat::number($pctget_prev) . '%</b>', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_WIDTH => '45'));
        $table->addcell($t->source(), array(CLX_PROP_ALIGN => 'center'));
        //Current Total
        $t = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT, 'cellpadding' => '1'));
        $t->addcell('<b>' . xFormat::number($total) . '</b>', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
        $t->addcell('<b>' . xFormat::number($pctget) . '%</b>', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT, CLX_PROP_WIDTH => '45'));
        $table->addcell($t->source(), array(CLX_PROP_ALIGN => 'center'));
        $table->addcell(CLX_CHAR_HTML_NBSP);
        $table->addcell(CLX_CHAR_HTML_NBSP);
        $table->addcell(CLX_CHAR_HTML_NBSP);
        $table->addcell(dict('FICO_CODE_INTDEVEN'));
        $table->addcell(CLX_CHAR_HTML_NBSP);
        $sql = 'SELECT  SUM(PD.BASE_BAL_AMT) BASE_BAL_AMT FROM  ' . $this->fidaname . ' PD WHERE PD.CONTRACT_CODE =' . singleQuote($contract['IDCODE']) . ' AND  (PD.INTPAID_DATE <= ' . singleQuote($this->edate . ' 23:59:59') . ' OR PD.INTPAID_DATE IS NULL)';
        $results = ClxCommon::$db->executeQuery($sql);
        $result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE);
        $result['BASE_BAL_AMT'] = CLX_INIT_ZERO;
        $table->addcell(xFormat::number($result['BASE_BAL_AMT']), array(CLX_PROP_ALIGN => 'center'));
        $table->addcell(dict('FIDU_CODE_INTERCASH'));
        $table->addcell(CLX_CHAR_HTML_NBSP);
        $table->addcell('0.00', array(CLX_PROP_ALIGN => 'center'));
        $tableFrame->addcell($table->source());
        return $tableFrame->source() . '<br>';
    }

    /**
     * Builds Posicion de cartera de inversiones.
     * @param: array Contract Record
     */
    function buildPorfolio($record) {
        $positions = array();
        $DBTL = getTool('DBLT');
        $contents = '';
        //Search Transactions
        $sql = 'SELECT  FIAS.*,  T.FROM_DATE, T.TO_DATE, T.BASE_TRANS_AMT FROM ' . $this->fiasname . ' FIAS, $this->fiatname T WHERE  T.ASSET_CODE = FIAS.IDCODE AND FIAS.CONTRACT_CODE=' . singleQuote($record['IDCODE']) . ' AND FIAS.TRUST_ITEM_TYPE IN (' . singleQuoteArray(array('SE', 'TIT')) . ')';
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            // Position array
            $position = array('TYPE' => '', 'NAME' => '', 'PERIOD' => '', 'SDATE' => '', 'EDATE' => '', 'SHARES' => CLX_NUM_ZERO, 'RATE' => CLX_NUM_ZERO, 'COST' => CLX_NUM_ZERO, 'PLUSMINUS' => CLX_NUM_ZERO, 'EVAL' => CLX_NUM_ZERO);
            $d = '';
            // Prepare instrument record according type
            if (!empty($result['INVESTPROD_CODE'])) { //Case Investment
                $d .= xFormat::date($result['FROM_DATE'], 'd - M') . ' ';
                $d .= xFormat::date($result['TO_DATE'], 'd - M');
                $invprod = ClxCommon::$db->getRecord($this->inprname, 'IDCODE=' . singleQuote($result['INVESTPROD_CODE']));
                $position['TYPE'] = $DBTL->getListItem('INST', $invprod['INV_INSTRUMENT']);
                $position['NAME'] = $invprod['IDCODE'];
                $position['RATE'] = $result['UNIT_PRICE'];
                $position['COST'] = $result['BASE_TRANS_AMT'];
                $position['SHARES'] = $result['SHARES'];
                $position['UNIT'] = $result['UNIT_PRICE'];
                $position['PERIOD'] = $d;
            } elseif (!empty($record['PORTFOLIO_CODE'])) { // Case Portfolio
            } elseif (!empty($record['LOAN_CODE'])) { // Case Loan
            } else { // Default, from asset record investment
            }
            $positions[$position['TYPE']][] = $position;
        }
        // Start Output
        if (!empty($positions)) {
            $tableFrame = new htmlTable(CLX_WIDTH_ONE);
            $tableFrame->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $tableFrame->addcell('<h3>' . dict('FICO_CODE_PORFOLIODESCRIPT') . '</h3><br>', array(CLX_PROP_ALIGN => CLX_PROP_LEFT));
            $total = CLX_INIT_ZERO;
            $j = CLX_NUM_ONE;
            foreach ($positions as $key => $val) {
                $tableFrame->addcell('<h4>' . $key . '</h4><br>');
                $table = new htmlTable(CLX_WIDTH_ONE + CLX_NUM_SIX);
                $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
                $table->addcell('<b>' . dict('FICO_CODE_TYPE') . '</b>');
                $table->addcell('<b>' . dict('FICO_CODE_PERIOD') . '</b>', array(CLX_PROP_ALIGN => 'center'));
                $table->addcell('<b>' . dict('FICO_CODE_TITLE') . '</b>', array(CLX_PROP_ALIGN => 'center'));
                $table->addcell('<b>' . dict('FICO_CODE_RATE') . '</b>', array(CLX_PROP_ALIGN => 'center'));
                $table->addcell('<b>' . dict('FICO_CODE_COST') . '</b>', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                $table->addcell('<b>' . dict('FICO_CODE_PLUSMINUS') . '</b>', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                $table->addcell('<b>' . dict('FICO_CODE_EVALCUT') . '</b>', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                $i = CLX_NUM_ONE;
                $subtotal = CLX_INIT_ZERO;
                foreach ($val as $key2 => $val2) {
                    $table->addcell(CLX_CHAR_HTML_NBSP, CLX_PROP_COLSPAN, CLX_NUM_7);
                    $table->addcell($val2['NAME']);
                    $table->addcell($val2['PERIOD'], array(CLX_PROP_ALIGN => 'center'));
                    $table->addcell($val2['SHARES'], array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                    $table->addcell($val2['RATE'], array(CLX_PROP_ALIGN => 'center'));
                    $table->addcell(xFormat::number($val2['UNIT']), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                    $table->addcell(xFormat::number(CLX_NUM_ZERO), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                    $table->addcell(xFormat::number($val2['COST']), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                    $table->addcell(CLX_CHAR_HTML_NBSP, CLX_PROP_COLSPAN, CLX_NUM_7);
                    $subtotal += $val2['COST'];
                    if ($i == count($val)) {
                        $table->addcell('<b>' . dict('FICO_CODE_SUBTOTAL') . ':</b>', array(CLX_PROP_COLSPAN => '3', CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                        $table->addcell(CLX_CHAR_HTML_NBSP);
                        $table->addcell('<b>' . xFormat::number($subtotal) . '</b>', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                        $table->addcell('<b>' . xFormat::number(CLX_NUM_ZERO) . '</b>', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                        $table->addcell('<b>' . xFormat::number($subtotal) . '</b>', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                        $table->addcell(CLX_CHAR_HTML_NBSP, CLX_PROP_COLSPAN, CLX_NUM_7);
                        $total += $subtotal;
                    }
                    $i++;
                }
                if ($j == count($positions)) {
                    $table->addcell('<b>' . dict('FICO_CODE_TOTAL') . '</b>', array(CLX_PROP_COLSPAN => '3', CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                    $table->addcell(CLX_CHAR_HTML_NBSP);
                    $table->addcell('<b>' . xFormat::number($total) . '</b>', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                    $table->addcell('<b>' . xFormat::number(CLX_NUM_ZERO) . '</b>', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                    $table->addcell('<b>' . xFormat::number($total) . '</b>', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                    $table->addcell(CLX_CHAR_HTML_NBSP, CLX_PROP_COLSPAN, CLX_NUM_7);
                }
                $tableFrame->addcell($table->source());
                $j++;
            }
            $contents = $tableFrame->source() . '<hr size="1" noshade>';
        }
        return $contents;
    }

// End method
    /**
     * Builds the period movements
     */
    function buildTransactions($contract) {
        $contents = '';
        $sql = ' SELECT  T.EFFTDATE, T.IDCODE TCODE,  T.IDNAME TNAME, T.BASE_TRANS_AMT, T.INVESTMENT_TYPE, T.SYMBOL, CT.TRUST_MODULE, CT.TRANS_TYPE DEBIT_CREDIT,  CT.AFFECT_CASH AFFECT_CASH, FA.TRUST_ITEM_TYPE FROM ' . $this->fiatname . ' T,  FIDU_TRANSACTION_TBL CT  LEFT JOIN ' . $this->fiasname . ' FA ON FA.IDCODE = T.ASSET_CODE WHERE  CT.IDCODE = T.TRANSTBL_CODE AND T.CONTRACT_CODE =' . singleQuote($contract['IDCODE']) . ' AND T.EFFTDATE <= ' . singleQuote($this->edate) . '  ORDER BY T.APPROVAL_DATE, T.ID ASC';
        $summary = array();  // Array with cash transactions
        $oth_summary = array(); // Array with other none cash transactions
        $summary[CLX_NUM_ZERO] = array('EFFTDATE' => $this->sdate, 'IDNAME' => dict('FICO_CODE_SBALANCE'), 'CR' => CLX_NUM_ZERO, 'DR' => CLX_NUM_ZERO, 'BAL' => CLX_NUM_ZERO);
        $st = adodb_strtotime($this->sdate);
        $initbal = (float) CLX_NUM_ZERO;
        $total = (float) CLX_NUM_ZERO;
        $results = ClxCommon::$db->executeQuery($sql);
        $i = CLX_NUM_ONE;
        $j = CLX_NUM_ZERO;
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            if ($result['TRUST_MODULE'] === 'HON') {
                $cr = $result['BASE_TRANS_AMT'];
                $dr = CLX_INIT_ZERO;
                $t = array('EFFTDATE' => $result['EFFTDATE'],
                    'IDNAME' => $result['TNAME'],
                    'CR' => $cr,
                    'DR' => $dr,
                    'BAL' => $cr);
                $this->commitions[] = $t;
                continue;
            }
            $cr = ($result['DEBIT_CREDIT'] === 'CR') ? $result['BASE_TRANS_AMT'] : CLX_NUM_ZERO;
            $dr = ($result['DEBIT_CREDIT'] === 'DR') ? $result['BASE_TRANS_AMT'] : CLX_NUM_ZERO;
            if ($result['TRUST_ITEM_TYPE'] <> 'CA') {
                $oth_summary[$j]['EFFTDATE'] = $result['EFFTDATE'];
                $oth_summary[$j]['IDNAME'] = $result['TNAME'];
                $oth_summary[$j]['CR'] = $cr;
                $oth_summary[$j]['DR'] = $dr;
                $j++;
            }
            if ($result['AFFECT_CASH'] <> 'N') {
                $cr = ($result['AFFECT_CASH'] === 'I') ? $result['BASE_TRANS_AMT'] : CLX_NUM_ZERO;
                $dr = ($result['AFFECT_CASH'] === 'E') ? $result['BASE_TRANS_AMT'] : CLX_NUM_ZERO;
            }
            if (adodb_strtotime($result['EFFTDATE']) < $st) {
                $initbal +=($cr - $dr);
            } elseif ($result['TRUST_ITEM_TYPE'] === 'CA' || $result['AFFECT_CASH'] <> 'N') {
                $total += ($cr - $dr);
                $summary[$i]['EFFTDATE'] = $result['EFFTDATE'];
                $summary[$i]['IDNAME'] = $result['TNAME'];
                $summary[$i]['CR'] = $cr;
                $summary[$i]['DR'] = $dr;
                $summary[$i]['BAL'] = $total;
            }
            $i++;
        }
        $summary[CLX_NUM_ZERO]['BAL'] = $initbal;
        $summary[] = array('EFFTDATE' => $this->edate, 'IDNAME' => dict('FICO_CODE_EBALANCE'),
            'CR' => '', 'DR' => '', 'BAL' => $total);
        $total += $initbal;
        $tableFrame = new htmlTable(CLX_WIDTH_ONE);
        $tableFrame->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $tableFrame->addcell('<h4>' . dict('FICO_CODE_MOVEMENTS') . '</h4>', array(CLX_PROP_ALIGN => CLX_PROP_LEFT));
        $table = new htmlTable(CLX_WIDTH_ONE + CLX_NUM_FOUR);
        $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addcell('<b>' . dict('FICO_CODE_DATE') . '</b>');
        $table->addcell('<b>' . dict('FICO_CODE_DESCRIPTION') . '</b>');
        $table->addcell('<b>' . dict('FICO_CODE_INCOME') . '</b>', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
        $table->addcell('<b>' . dict('FICO_CODE_WITHDRAWALS') . '</b>', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
        $table->addcell('<b>' . dict('FICO_CODE_BALANCE') . '</b>', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
        $table->addcell(CLX_CHAR_HTML_NBSP, CLX_PROP_COLSPAN, CLX_NUM_FIVE);
        //Detalle loop
        $i = count($summary);
        foreach ($summary as $key => $val) {
            $table->addcell(xFormat::date($val['EFFTDATE'], 'd - M'));
            if ($i > $key && $key > CLX_NUM_ZERO) {
                $table->addcell($val['IDNAME']);
                $table->addcell(xFormat::number($val['CR']), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                $table->addcell(xFormat::number($val['DR']), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                $table->addcell(xFormat::number($val['BAL']), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
            } else {
                $table->addcell('<b>' . $val['IDNAME'] . '</b>');
                $table->addcell(CLX_CHAR_HTML_NBSP, CLX_PROP_ALIGN, CLX_PROP_RIGHT);
                $table->addcell(CLX_CHAR_HTML_NBSP, CLX_PROP_ALIGN, CLX_PROP_RIGHT);
                $table->addcell('<b>' . xFormat::number($val['BAL']) . '</b>', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
            }
        }
        $tableFrame->addcell($table->source());
        $contents .= $tableFrame->source();
        //	Other movements not from cash
        if (!empty($oth_summary)) {
            $tableFrame = new htmlTable(CLX_WIDTH_ONE);
            $tableFrame->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $tableFrame->addcell('<hr size="1" noshade>');
            $tableFrame->addcell('<h4>' . dict('FICO_CODE_OTHER') . '</h4>', array(CLX_PROP_ALIGN => CLX_PROP_LEFT));
            $table = new htmlTable(CLX_WIDTH_ONE + CLX_NUM_THREE);
            $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $table->addcell('<b>' . dict('FICO_CODE_DATE') . '</b>');
            $table->addcell('<b>' . dict('FICO_CODE_DESCRIPTION') . '</b>');
            $table->addcell('<b>' . dict('FICO_CODE_INCOME') . '</b>', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
            $table->addcell('<b>' . dict('FICO_CODE_WITHDRAWALS') . '</b>', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
            $table->addcell(CLX_CHAR_HTML_NBSP, CLX_PROP_COLSPAN, CLX_NUM_FOUR);
            //Detalle loop
            foreach ($oth_summary as $key => $val) {
                $table->addcell(xFormat::date($val['EFFTDATE'], 'd - M'));
                $table->addcell($val['IDNAME']);
                $table->addcell(xFormat::number($val['CR']), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
                $table->addcell(xFormat::number($val['DR']), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
            }
            $tableFrame->addcell($table->source());
            $contents .=$tableFrame->source() . '<br>';
        }
        return $contents;
    }

// End method
    function buildDetailCommitions($record) {
        $tableFrame = new htmlTable(CLX_WIDTH_ONE);
        $tableFrame->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $tableFrame->addcell('<h4>' . dict('FICO_CODE_HONORANDCOMM') . '</h4>', array(CLX_PROP_ALIGN => CLX_PROP_LEFT));
        $table = new htmlTable(CLX_WIDTH_ONE + CLX_NUM_FOUR);
        $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addcell('<b>' . dict('FICO_CODE_DATE') . '</b>');
        $table->addcell('<b>' . dict('FICO_CODE_DESCRIPTION') . '</b>');
        $table->addcell('<b>' . dict('FICO_CODE_OWNEDBALANCE') . '</b>', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
        $table->addcell('<b>' . dict('FICO_CODE_PAYMENTS') . '</b>', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
        $table->addcell('<b>' . dict('FICO_CODE_BALANCE') . '</b>', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
        $table->addcell(CLX_CHAR_HTML_NBSP, CLX_PROP_COLSPAN, CLX_NUM_FIVE);
        $total = CLX_INIT_ZERO;
        foreach ($this->commitions as $key => $val) {
            $table->addcell(xFormat::date($val['EFFTDATE'], 'd - M'));
            $table->addcell($val['IDNAME']);
            $table->addcell(xFormat::number($val['CR']), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
            $table->addcell(xFormat::number($val['DR']), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
            $table->addcell(xFormat::number($val['BAL']), array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
            $total +=$val['TOTAL'];
        }
        //Saldo Inicial
        $table->addcell(CLX_CHAR_HTML_NBSP, CLX_PROP_COLSPAN, CLX_NUM_FIVE);
        $table->addcell(CLX_CHAR_HTML_NBSP);
        $table->addcell('<b>' . dict('FICO_CODE_TOTALPAYMENT') . '</b>', array(CLX_PROP_COLSPAN => CLX_NUM_THREE));
        $table->addcell('<b>' . xFormat::number($total) . '</b>', array(CLX_PROP_ALIGN => CLX_PROP_RIGHT));
        $tableFrame->addcell($table->source());
        return $tableFrame->source() . '<br>';
    }

// End method
    /**
     * Build Summary Plot
     */
    function buildSummaryPlot($data) {
        $xml = '<graph caption="' . dict('FIDU_CODE_SUMMARY') . '"  subCaption="" yaxisname="Title Y" xaxisname="Title X" numdivlines="0" zeroPlaneColor="FFFFFF" bgcolor = "FFFFFF" zeroPlaneAlpha="0" animation="0" showCanvas="0" areaAlpha="80" decimalPrecision="2" basefont="arial" showvalues="1" baseFontSize="17">';
        $color = hexdec('000000');
        foreach ($data as $key => $val) {
            $color += CLX_NUM_HUNDRED;
            $xml .= '<set name="' . $key . '" value="' . $val . '" color="' . dechex($color) . '" />';
        }
        $xml .='</graph>';
        $contents = '<OBJECT classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000"
	    codebase="http://download.macromedia.com/
	    pub/shockwave/cabs/flash/swflash.cab#version=6, 0, 0,0"
		WIDTH="310" HEIGHT="310" id="FC2Column" ALIGN="center" border=1>
	    <PARAM NAME=movie VALUE="plot/FC2Pie3D.swf">
	    <PARAM NAME="FlashVars" value="&dataXML="' . $xml . '">
	    <PARAM NAME=quality VALUE=high>
	    <PARAM NAME=bgcolor VALUE=#FFFFFF>
	    <EMBED src="plot/FC2Pie3D.swf" FlashVars="&dataXML="' . $xml . '" quality=high bgcolor=#FFFFFF
	    WIDTH="300" HEIGHT="330" NAME="FC2Column"  ALIGN="" TYPE="application/x-shockwave-flash" PLUGINSPAGE="http://www.macromedia.com/go/getflashplayer"></EMBED>
	    </OBJECT>';
        return $contents;
    }

}

// End class
