<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2016-05-11 16:39:16 -0400 (Wed, 11 May 2016) $
 * @version        $Rev: 8217 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Boit {
    /* Estructura Agregar campos en esta definicion de ser necesario */

    var $boit = array(
        array('fieldname' => 'CX_SECUENCIAL', 'type' => 'INTN', 'default' => CLX_NUM_ZERO), array('fieldname' => 'CX_COD_ALTERNO', 'type' => 'INTN', 'default' => CLX_NUM_ZERO), array('fieldname' => 'CX_FECHA_MOVIMIENTO', 'type' => 'DATE', 'default' => 'null'), array('fieldname' => 'CX_FECHA_VALOR', 'type' => 'DATE', 'default' => 'null'), array('fieldname' => 'CX_TIPO_PRODUCTO', 'type' => 'INTN', 'default' => CLX_NUM_ZERO), array('fieldname' => 'CX_TIPO_TRAN', 'type' => 'CHAR', 'default' => 'null'), array('fieldname' => 'CX_AFECTACION', 'type' => 'CHAR', 'default' => 'null'), array('fieldname' => 'CX_CAUSAL_TRAN', 'type' => 'CHAR', 'default' => 'null'), array('fieldname' => 'CX_CONCEPTO', 'type' => 'CHAR', 'default' => 'null'), array('fieldname' => 'CX_CUENTA_CB', 'type' => 'CHAR', 'default' => 'null'), array('fieldname' => 'CX_FIDEICOMISO', 'type' => 'CHAR', 'default' => 'null'), array('fieldname' => 'CX_CONCEPTO_PAGO', 'type' => 'CHAR', 'default' => 'null'), array('fieldname' => 'CX_MONTO', 'type' => 'DECN', 'default' => 'null'), array('fieldname' => 'EXT_CLIENT_NO', 'type' => 'INTN', 'default' => CLX_NUM_ZERO), //CX_CLIENTE
        array('fieldname' => 'CURRENCY_CODE', 'type' => 'INTN', 'default' => CLX_NUM_ZERO), //CX_MONEDA
        array('fieldname' => 'EXCHANGE_RT', 'type' => 'DECN', 'default' => CLX_NUM_ONE), //CX_TASA_CAMBIO
        array('fieldname' => 'CUR_OPERATOR', 'type' => 'INTN', 'default' => CLX_NUM_ONE)//CX_SIGNO_OPERACION
    );

    /**
     * Constructor
     * @param array [$procParameters]
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('BOIT', 'BOTT', 'FICO', 'JELN', 'JEHD', 'FIPA', 'FIAS', 'GLCP', 'COMP', 'LOTT', 'ACCO', 'FILO', 'PRAT', 'FIBK', 'GLAC'));

        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : xFormat::getNow('YmdHis');
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->today = xFormat::getNow('Y-m-d');
        $this->je_source = '';
    }

    /**
     * Sets the connector filename from parameters
     * @param string $filename
     */
    function import_file_set_name($filename) {
        $folder = companyParameter('BOIT_FILE_DIRECTORY');
        $filename = $folder . $filename;
        $sql = 'UPDATE CLX_SK_CONNECTORS SET IP_ADDRESS = ' . singleQuote($filename) . ' WHERE IDCODE = ' . singleQuote('BOIT') . '';
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     * Imports fils
     */
    function import_file() {
        $contenidoHTML = '';
        if (!class_exists('clx_file_delimited')) {
            require kPathToWebSite . 'classes/clx_file_delimited.php';
        }
        $SKCO = &getTool('SKCO');
        $connector = $SKCO->getConnector('BOIT');
        if (empty($connector['IP_ADDRESS'])) {
            addNotice('File not found');
        }
        //Rename file here
        //Process Renamed
        $line_delim = CLX_CHAR_NL; //CLX_CHAR_NL;
        $field_delim = chr(CLX_NUM_NINE); //CLX_CHAR_TAB;
        $contenidoHTML.= dict('GEN_LBL_FILENAME') . ': ' . $connector['IP_ADDRESS'] . '<Br><Br>';
        $i = CLX_INIT_ZERO;
        $j = CLX_INIT_ZERO;
        $fl = new clx_file_delimited($connector['IP_ADDRESS'], $line_delim, $field_delim);
        while ($ln = $fl->getNextRecord2()) {
            $i++;
            $ln = $fl->toArray($ln);
            $rec = array();
            foreach ($this->boit as $k => $v) {
                $value = $ln[$k];
                if ($v['type'] === 'DATE') {
                    $value = str_replace('/', '-', $value);
                }
                if ($v['fieldname'] === 'CX_TIPO_TRAN') {
                    if (strpos($value, '*', CLX_NUM_ZERO) !== false) {
                        //$value = substr($value,1, strlen($value));
                        $rec['REVERSAL'] = CLX_NUM_ONE;
                    } else {
                        $rec['REVERSAL'] = CLX_INIT_ZERO;
                    }
                }
                $rec[$v['fieldname']] = $value;
                $rec['BOIT_STATUS'] = 'PEN';
                $rec['CREATEDBY'] = $this->username;
                $rec['CDATE'] = $this->now;
                $rec['MODIFIEDBY'] = $this->username;
                $rec['MDATE'] = $this->now;
            }
            $rec['BATCH_ID'] = $this->batch_id;
            //Test if load
            if (!is_numeric($rec['CX_SECUENCIAL']))
                $rec['CX_SECUENCIAL'] = CLX_INIT_ZERO;
            if (!is_numeric($rec['CX_COD_ALTERNO']))
                $rec['CX_COD_ALTERNO'] = CLX_INIT_ZERO;
            $rec['CX_SECUENCIAL'] = intval($rec['CX_SECUENCIAL']);
            $rec['CX_COD_ALTERNO'] = floatval($rec['CX_COD_ALTERNO']);
            if (trim($rec['CX_TIPO_TRAN']) === '' || $rec['CX_TIPO_TRAN'] === 'null')
                $rec['CX_TIPO_TRAN'] = CLX_INIT_ZERO;
            if (trim($rec['CX_CAUSAL_TRAN']) === '' || $rec['CX_CAUSAL_TRAN'] === 'null')
                $rec['CX_CAUSAL_TRAN'] = CLX_INIT_ZERO;
            if (trim($rec['CX_CONCEPTO']) === '' || $rec['CX_CONCEPTO'] === 'null')
                $rec['CX_CONCEPTO'] = CLX_INIT_ZERO;
            if (trim($rec['CX_CONCEPTO']) === '' || $rec['CX_CONCEPTO'] === 'null')
                $rec['CX_CONCEPTO'] = CLX_INIT_ZERO;
            $rec['CURRENCY_CODE'] = trim($rec['CURRENCY_CODE']);
            $rec['CUR_OPERATOR'] = trim($rec['CUR_OPERATOR']);
            $rec['EXT_CLIENT_NO'] = trim($rec['EXT_CLIENT_NO']);
            //Load record if not exists
            $sql = 'SELECT COUNT(ID) FROM ' . $this->boitname . ' WHERE CX_SECUENCIAL = ' . singleQuote($rec['CX_SECUENCIAL']) . ' AND CX_COD_ALTERNO = ' . singleQuote($rec['CX_COD_ALTERNO']) . ' AND CX_FECHA_MOVIMIENTO  = ' . singleQuote($rec['CX_FECHA_MOVIMIENTO']);
            if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
                ClxCommon::$db->createRecord($this->boitname, $rec, false);
                $j++;
            } else {
                $contenidoHTML.= dict('GEN_LBL_DUPLICATE_IN_LINE') . ': ' . $i . ' Key: ' . $rec['CX_SECUENCIAL'] . ' | ' . $rec['CX_COD_ALTERNO'] . ' | ' . $rec['CX_FECHA_MOVIMIENTO'] . '<br>';
            }
            //Limiting to 100k records
            if ($i == CLX_NUM_HUNDRED_THOUSAND)
                break;
        }
        $total_lbl = dict('GEN_LBL_TOTAL');
        $contenidoHTML.= '<br>' . $total_lbl . ' ' . dict('GEN_LBL_RECORDS') . ': ' . $i . '<br>' .
                dict('GEN_LBL_TOTAL_IMPORTED') . ': ' . $j . '<br>' .
                $total_lbl . ' ' . dict('GEN_LBL_DUPLICATES') . ': ' . ($i - $j) . '<br>' .
                dict('GEN_LBL_COMPLETED') . ': ' . xFormat::getNow('Y-m-d h:i:s') . '<br>';
        //Ajuste
        echo $contenidoHTML;
        $this->process_complete_local_information();
        //Send to approval if Set for it.
        $this->process_on_load();
    }

    /**
     * Process all records
     */
    private function process_on_load() {
        //Set status and march batch_id
        // 2016-02-02 FS-MB-CR no estaba aprobando las transacciones una vez que se importaban desde Cobis
        ClxCommon::$db->updateRecord($this->boitname, array('BOIT_STATUS' => 'RUN', 'BATCH_ID' => $this->batch_id, 'MDATE' => $this->now, 'MODIFIEDBY' => $this->username), 'BOIT_STATUS = ' . singleQuote('PEN') . '');
        //Send to process
        $this->process('PROCESS');
    }

    /**
     * Loads file from process
     */
    function import_btn() {
        ob_start();

        $this->import_file();
        $contents = ob_get_contents();
        ob_end_clean();
        return note($contents);
    }

    /**
     * Loads selected entries for process
     * @param string $action
     */
    function process_btn($action = '') {
        //Set status and march batch_id
        ClxCommon::$db->updateRecord($this->boitname, array('BOIT_STATUS' => 'RUN', 'BATCH_ID' => $this->batch_id, 'MDATE' => $this->now, 'MODIFIEDBY' => $this->username), 'ID IN (' . toString(getIdlist()) . ') AND BOIT_STATUS IN (' . singleQuoteArray(array('PEN', 'ERR')) . ')');
        //Send to process
        $this->process($action);
    }

    /**
     * Process Record
     * @param unknown_type $boit_id
     * @param unknown_type $action
     */
    private function process($action) {
        switch ($action) {
            case 'PROCESS':
                //Complete local Information
                $this->process_complete_local_information();
                //Validate record or mark in error if there is a problem on local
                $this->process_validate();
                //Build journal Entry
                $this->process_build_journal_entry();
                break;
            case 'REJECT':
                //Just reject any thing that is selected
                ClxCommon::$db->updateRecord($this->boitname, array('BOIT_STATUS' => 'REJ'), 'BOIT_STATUS = ' . singleQuote('RUN') . ' AND BATCH_ID = ' . singleQuote($this->batch_id));
                break;
            default:
                break;
        }
        //Set in error any pending operation that could not be handled before
        //Every should be end on some status diferent than run at this point
        ClxCommon::$db->updateRecord($this->boitname, array('BOIT_STATUS' => 'ERR', 'ERR_MSG_CODE' => 'MSG-368'), 'BOIT_STATUS = ' . singleQuote('RUN') . ' AND BATCH_ID = ' . singleQuote($this->batch_id));
    }

    /**
     * Completes local information
     */
    private function process_complete_local_information() {
        //Colocando contrato y compania COMP_CODE, CHART_FIELD01
        $sql = 'UPDATE ' . $this->boitname . ' BOIT, ' . $this->ficoname . ' FICO SET BOIT.CHART_FIELD01 = FICO.IDCODE, BOIT.COMP_CODE = FICO.COMP_CODE WHERE BOIT.BOIT_STATUS IN (' . singleQuoteArray(array('RUN', 'PEN')) . ') AND BOIT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND FICO.CONTRACT_NUMBER = BOIT.CX_FIDEICOMISO';
        ClxCommon::$db->executeQuery($sql);
        //Colocando participante aunque sea principal ver si luego llega el cliente. CHART_FIELD02
        $sql = 'UPDATE ' . $this->boitname . ' BOIT, ' . $this->fipaname . ' FIPA SET BOIT.CHART_FIELD02 = FIPA.ACCOUNTCODE WHERE BOIT.BOIT_STATUS = ' . singleQuote('RUN') . ' AND BOIT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND FIPA.CONTRACT_CODE = BOIT.CHART_FIELD01 AND FIPA.ISPRIMARY = 1 AND FIPA.STATUS = ' . singleQuote('A') . '';
        ClxCommon::$db->executeQuery($sql);
        $this->process_build_fias();
        //CHART_FIELD03
        $sql = 'UPDATE ' . $this->boitname . ' BOIT, ' . $this->fiasname . ' FIAS SET BOIT.CHART_FIELD03 = FIAS.IDCODE WHERE BOIT.BOIT_STATUS = ' . singleQuote('RUN') . ' AND BOIT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND FIAS.CONTRACT_CODE = BOIT.CHART_FIELD01 AND FIAS.EXT_PRODUCT_CODE = BOIT.CX_CUENTA_CB';
        ClxCommon::$db->executeQuery($sql);
        //Colocando compania por defecto en caso de no existir referencia
        //Colocando contrato y compania COMP_CODE, CHART_FIELD01
        $sql = 'UPDATE ' . $this->boitname . ' BOIT, BASE_PARAMETERS PRMT SET BOIT.COMP_CODE = PRMT.PVALUE WHERE BOIT.BOIT_STATUS IN (' . singleQuoteArray(array('RUN', 'PEN')) . ') AND BOIT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND BOIT.COMP_CODE IS NULL AND PRMT.IDNAME = ' . singleQuote('BOIT_DEF_COMPANY');
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     * Build fias if not exists
     */
    private function process_build_fias() {
        if (!class_exists('Fias'))
            includeCodeLib('FIAS');
        $fias = new Fias();
        /* Ver se de traducciones */
        $sql = 'SELECT DISTINCT ' . singleQuote('AS') . ' GL_TYPE, CX_TIPO_PRODUCTO TRUST_ITEM_TYPE, BOIT.CX_CUENTA_CB EXT_PRODUCT_CODE, BOIT.CHART_FIELD01 CONTRACT_CODE, ' . singleQuote(dict('GEN_LBL_BANK_PRODUCT')) . ' IDNAME, BOIT.CURRENCY_CODE FROM ' . $this->boitname . ' BOIT, ' . $this->ficoname . ' FICO WHERE BOIT.CHART_FIELD01 = FICO.IDCODE AND BOIT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND NOT EXISTS(SELECT FIAS.ID FROM  ' . $this->fiasname . ' FIAS WHERE FIAS.CONTRACT_CODE = BOIT.CHART_FIELD01 AND FIAS.EXT_PRODUCT_CODE = BOIT.CX_CUENTA_CB)';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            //verificar mapeo de producto CX_TIPO_PRODUCTO
            $r['IDCODE'] = 'AUTO';
            $r['IDNAME'] .= ' ' . $r['TRUST_ITEM_TYPE'];
            switch ($r['TRUST_ITEM_TYPE']) {
                case '4':
                    $r['TRUST_ITEM_TYPE'] = 'CA';
                    $r['FIDU_BANKACT_CODE'] = $r['EXT_PRODUCT_CODE'];
                    break;
                case '7':
                    $r['LOAN_CODE'] = ClxCommon::$db->getField($this->filoname, 'IDCODE', 'EXT_PRODUCT_CODE = ' . singleQuote($r['EXT_PRODUCT_CODE']));
                    $r['TRUST_ITEM_TYPE'] = 'CR';
                    break;
                case '14':
                    $r['FIDU_BANKACT_CODE'] = $r['EXT_PRODUCT_CODE'];
                    $r['TRUST_ITEM_TYPE'] = 'CD';
                    break;
                default:
                    $r['TRUST_ITEM_TYPE'] = 'OT';
                    break;
            }
            $fias->fias_build($r);
        }
        unset($fias);
    }

    /**
     * Validate process information
     */
    private function process_validate() {
        //validate that record has company
        $sql = 'UPDATE ' . $this->boitname . ' BOIT SET BOIT.BOIT_STATUS = ' . singleQuote('ERR') . ', BOIT.ERR_MSG_CODE = ' . singleQuote('MSG-364') . ' WHERE BOIT.BOIT_STATUS = ' . singleQuote('RUN') . ' AND BOIT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND NOT EXISTS(SELECT COMP.ID FROM ' . $this->compname . ' COMP WHERE COMP.IDCODE = BOIT.COMP_CODE)';
        ClxCommon::$db->executeQuery($sql);
        //validate that record has contract
        $sql = 'UPDATE ' . $this->boitname . ' BOIT SET BOIT.BOIT_STATUS = ' . singleQuote('ERR') . ', BOIT.ERR_MSG_CODE = ' . singleQuote('MSG-363') . ' WHERE BOIT.BOIT_STATUS = ' . singleQuote('RUN') . ' AND BOIT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND NOT EXISTS(SELECT FICO.ID FROM ' . $this->ficoname . ' FICO WHERE FICO.IDCODE = BOIT.CHART_FIELD01)';
        ClxCommon::$db->executeQuery($sql);
        //validate that record has participant
        $sql = 'UPDATE ' . $this->boitname . ' BOIT SET BOIT.BOIT_STATUS = ' . singleQuote('ERR') . ', BOIT.ERR_MSG_CODE = ' . singleQuote('MSG-365') . ' WHERE BOIT.BOIT_STATUS = ' . singleQuote('RUN') . ' AND BOIT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND NOT EXISTS(SELECT FIPA.ID FROM ' . $this->fipaname . ' FIPA, ' . $this->acconame . ' ACCO WHERE ACCO.IDCODE = FIPA.ACCOUNTCODE AND FIPA.CONTRACT_CODE = BOIT.CHART_FIELD01 AND FIPA.ACCOUNTCODE = BOIT.CHART_FIELD02)';
        ClxCommon::$db->executeQuery($sql);
        //validate that transaction amount
        $sql = 'UPDATE ' . $this->boitname . ' BOIT SET BOIT.BOIT_STATUS = ' . singleQuote('ERR') . ', BOIT.ERR_MSG_CODE = ' . singleQuote('MSG-366') . ' WHERE BOIT.BOIT_STATUS = ' . singleQuote('RUN') . ' AND BOIT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND BOIT.CX_MONTO <= 0';
        ClxCommon::$db->executeQuery($sql);
        //validate that operation
        /* CX_TIPO_TRAN
         * CX_CAUSAL_TRAN Este es el concepto ver porque el concepto esta por separado
         *
         * CX_AFECTACION Indica el signo si es debito
         * 	CX_CONCEPTO
         */
        $sql = 'UPDATE ' . $this->boitname . ' BOIT SET BOIT.BOIT_STATUS = ' . singleQuote('ERR') . ', BOIT.ERR_MSG_CODE = ' . singleQuote('MSG-367') . ' WHERE BOIT.BOIT_STATUS = ' . singleQuote('RUN') . ' AND BOIT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND NOT EXISTS(SELECT BOTT.ID FROM ' . $this->bottname . ' BOTT, ' . $this->glcpname . ' GLCP WHERE BOTT.CX_TIPO_TRAN = BOIT.CX_TIPO_TRAN AND BOTT.CX_CAUSAL_TRAN = BOIT.CX_CAUSAL_TRAN AND BOTT.CX_CONCEPTO = BOIT.CX_CONCEPTO AND BOTT.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLCP.COMP_CODE = BOIT.COMP_CODE) ';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->boitname . ' BOIT SET BOIT.BOIT_STATUS = ' . singleQuote('ERR') . ', BOIT.ERR_MSG_CODE = ' . singleQuote('MSG-386') . ' WHERE BOIT.BOIT_STATUS = ' . singleQuote('RUN') . ' AND BOIT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND BOIT.CX_TIPO_PRODUCTO = 7 AND NOT EXISTS(SELECT FILO.ID FROM ' . $this->ficoname . ' FICO, ' . $this->fiasname . ' FIAS, ' . $this->filoname . ' FILO WHERE BOIT.CHART_FIELD01 = FICO.IDCODE AND FICO.IDCODE = FIAS.CONTRACT_CODE AND FIAS.LOAN_CODE = FILO.IDCODE AND FIAS.EXT_PRODUCT_CODE = BOIT.CX_CUENTA_CB)';
        ClxCommon::$db->executeQuery($sql);
        //Validar cuenta de banco y depositos
        $sql = 'UPDATE ' . $this->boitname . ' BOIT SET BOIT.BOIT_STATUS = ' . singleQuote('ERR') . ', BOIT.ERR_MSG_CODE = ' . singleQuote('MSG-387') . ' WHERE BOIT.BOIT_STATUS = ' . singleQuote('RUN') . ' AND BOIT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND BOIT.CX_TIPO_PRODUCTO IN (4, 14) AND NOT EXISTS(SELECT FIBK.ID FROM ' . $this->ficoname . ' FICO, ' . $this->fiasname . ' FIAS, ' . $this->fibkname . ' FIBK WHERE BOIT.CHART_FIELD01 = FICO.IDCODE AND FICO.IDCODE = FIAS.CONTRACT_CODE AND FIAS.FIDU_BANKACT_CODE = FIBK.BANK_ACCOUNT_NO AND FIAS.EXT_PRODUCT_CODE = BOIT.CX_CUENTA_CB)';
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     * Builds journal entry and approve journal
     */
    private function process_build_journal_entry() {
        if (!class_exists('Jehd')) {
            includeCodeLib('JEHD');
        }
        // Determine batch id
        $je_source = 'BOIT';
        $jehd = new Jehd ();

        $sql = 'SELECT DISTINCT BOIT.COMP_CODE, BOTT.JOURNAL_NAME IDNAME, BOIT.CX_FECHA_MOVIMIENTO REAL_DATE, BOIT.CX_FECHA_VALOR EFFTDATE, BOTT.ADJUSTMENT, BOTT.IS_PAYMENT, BOTT.IS_CASH_OPER, BOTT.APPROVE_OPER FROM ' . $this->boitname . ' BOIT, ' . $this->bottname . ' BOTT, ' . $this->glcpname . ' GLCP WHERE BOIT.BOIT_STATUS = ' . singleQuote('RUN') . ' AND BOIT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND BOTT.CX_TIPO_TRAN = BOIT.CX_TIPO_TRAN AND BOTT.CX_CAUSAL_TRAN = BOIT.CX_CAUSAL_TRAN AND BOTT.CX_CONCEPTO = BOIT.CX_CONCEPTO AND BOTT.GLGROUP_CODE = GLCP.GLGROUP_CODE AND BOIT.COMP_CODE = GLCP.COMP_CODE';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            //Build journal
            $jehdrec = array('IDCODE' => 'AUTO',
                'IDNAME' => $r['IDNAME'], 'COMP_CODE' => $r['COMP_CODE'], 'EFFTDATE' => $r['EFFTDATE'],
                'CLX_AUTH_STATUS' => 'PEND', 'JE_SOURCE' => $je_source, 'CLOSING_ENTRY' => CLX_NUM_ZERO, 'REVERSED' => CLX_NUM_ZERO, 'ADJUSTMENT' => $r['ADJUSTMENT'], 'IS_PAYMENT' => $r['IS_PAYMENT'],
                'IS_CASH_OPER' => $r['IS_CASH_OPER'],
                'BATCH_ID' => $this->batch_id, 'CREATEDBY' => $this->username, 'MODIFIEDBY' => $this->username, 'CDATE' => $this->now, 'MDATE' => $this->now);
            $jehd->jehd_build($jehdrec);
            $jehdr_code = $jehdrec ['IDCODE'];
            //Add lines debit
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, SEQNUM, GLACCOUNTCODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_CODE, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, DEBIT_AMT, CREDIT_AMT, RECONCILIED) SELECT ' . singleQuote($jehdr_code) . ' JEHDR_CODE, 0 SEQNUM, BOTT.DEBIT_GL_CODE GLACCOUNTCODE, BOIT.CHART_FIELD01, BOIT.CHART_FIELD02, BOIT.CHART_FIELD03, null CHART_FIELD04, BOTT.ITEM_CODE, CONCAT(CX_SECUENCIAL,\' - \',CX_COD_ALTERNO) ITEM_REF_NO, BOIT.CURRENCY_CODE, BOIT.EXCHANGE_RT, BOIT.CUR_OPERATOR, BOIT.CX_MONTO DEBIT_TRANS_AMT, 0 CREDIT_TRANS_AMT, ROUND(CX_MONTO*POW(EXCHANGE_RT, CUR_OPERATOR), 2)  DEBIT_AMT, 0 CREDIT_AMT, 0 RECONCILIED FROM ' . $this->boitname . ' BOIT, ' . $this->bottname . ' BOTT, ' . $this->glcpname . ' GLCP WHERE BOIT.BOIT_STATUS = ' . singleQuote('RUN') . ' AND BOIT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND BOTT.CX_TIPO_TRAN = BOIT.CX_TIPO_TRAN AND BOTT.CX_CAUSAL_TRAN = BOIT.CX_CAUSAL_TRAN AND BOTT.CX_CONCEPTO = BOIT.CX_CONCEPTO AND BOTT.GLGROUP_CODE = GLCP.GLGROUP_CODE AND BOIT.COMP_CODE = GLCP.COMP_CODE AND BOIT.COMP_CODE = ' . singleQuote($r['COMP_CODE']) . ' AND BOTT.JOURNAL_NAME = ' . singleQuote($r['IDNAME']) . ' AND BOIT.CX_FECHA_MOVIMIENTO = ' . singleQuote($r['REAL_DATE']) . ' AND BOIT.CX_FECHA_VALOR = ' . singleQuote($r['EFFTDATE']) . ' AND BOTT.ADJUSTMENT = ' . singleQuote($r['ADJUSTMENT']) . ' AND BOTT.IS_PAYMENT = ' . singleQuote($r['IS_PAYMENT']) . ' AND BOTT.APPROVE_OPER = ' . singleQuote($r['APPROVE_OPER']) . ' AND BOTT.IS_CASH_OPER = ' . singleQuote($r['IS_CASH_OPER']) . ' /* 1 */';
            ClxCommon::$db->executeQuery($sql);
            //Add lines credit
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, SEQNUM, GLACCOUNTCODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_CODE, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, DEBIT_AMT, CREDIT_AMT, RECONCILIED) SELECT ' . singleQuote($jehdr_code) . ' JEHDR_CODE, 1 SEQNUM, BOTT.CREDIT_GL_CODE GLACCOUNTCODE, BOIT.CHART_FIELD01, BOIT.CHART_FIELD02, BOIT.CHART_FIELD03, null CHART_FIELD04, BOTT.ITEM_CODE, CONCAT(CX_SECUENCIAL,\' - \',CX_COD_ALTERNO) ITEM_REF_NO, BOIT.CURRENCY_CODE, BOIT.EXCHANGE_RT, BOIT.CUR_OPERATOR, 0 DEBIT_TRANS_AMT, BOIT.CX_MONTO CREDIT_TRANS_AMT, 0 DEBIT_AMT, ROUND(CX_MONTO*POW(EXCHANGE_RT, CUR_OPERATOR), 2) CREDIT_AMT, 0 RECONCILIED FROM ' . $this->boitname . ' BOIT, ' . $this->bottname . ' BOTT, ' . $this->glcpname . ' GLCP WHERE BOIT.BOIT_STATUS = ' . singleQuote('RUN') . ' AND BOIT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND BOTT.CX_TIPO_TRAN = BOIT.CX_TIPO_TRAN AND BOTT.CX_CAUSAL_TRAN = BOIT.CX_CAUSAL_TRAN AND BOTT.CX_CONCEPTO = BOIT.CX_CONCEPTO AND BOTT.GLGROUP_CODE = GLCP.GLGROUP_CODE AND BOIT.COMP_CODE = GLCP.COMP_CODE AND BOIT.COMP_CODE = ' . singleQuote($r['COMP_CODE']) . ' AND BOTT.JOURNAL_NAME = ' . singleQuote($r['IDNAME']) . ' AND BOIT.CX_FECHA_MOVIMIENTO = ' . singleQuote($r['REAL_DATE']) . ' AND BOIT.CX_FECHA_VALOR = ' . singleQuote($r['EFFTDATE']) . ' AND BOTT.ADJUSTMENT = ' . singleQuote($r['ADJUSTMENT']) . ' AND BOTT.IS_PAYMENT = ' . singleQuote($r['IS_PAYMENT']) . ' AND BOTT.APPROVE_OPER = ' . singleQuote($r['APPROVE_OPER']) . ' AND BOTT.IS_CASH_OPER = ' . singleQuote($r['IS_CASH_OPER']) . ' /* 2 */';
            ClxCommon::$db->executeQuery($sql);
            //Mark as done
            $sql = 'UPDATE ' . $this->boitname . ' BOIT, ' . $this->bottname . ' BOTT, ' . $this->glcpname . ' GLCP SET BOIT.BOIT_STATUS = ' . singleQuote('END') . ', BOIT.ERR_MSG_CODE = null WHERE BOIT.BOIT_STATUS = ' . singleQuote('RUN') . ' AND BOIT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND BOTT.CX_TIPO_TRAN = BOIT.CX_TIPO_TRAN AND BOTT.CX_CAUSAL_TRAN = BOIT.CX_CAUSAL_TRAN AND BOTT.CX_CONCEPTO = BOIT.CX_CONCEPTO AND BOTT.GLGROUP_CODE = GLCP.GLGROUP_CODE AND BOIT.COMP_CODE = GLCP.COMP_CODE AND BOIT.COMP_CODE = ' . singleQuote($r['COMP_CODE']) . ' AND BOTT.JOURNAL_NAME = ' . singleQuote($r['IDNAME']) . ' AND BOIT.CX_FECHA_MOVIMIENTO = ' . singleQuote($r['REAL_DATE']) . ' AND BOIT.CX_FECHA_VALOR = ' . singleQuote($r['EFFTDATE']) . ' AND BOTT.ADJUSTMENT = ' . singleQuote($r['ADJUSTMENT']) . ' AND BOTT.APPROVE_OPER = ' . singleQuote($r['APPROVE_OPER']) . ' AND BOTT.IS_CASH_OPER = ' . singleQuote($r['IS_CASH_OPER']) . ' /* 3 */';
            ClxCommon::$db->executeQuery($sql);
            //Eliminate subaccounts if account donot belong to prduct
            $sql = 'UPDATE ' . $this->jelnname . ' JELN, ' . $this->fiasname . ' FIAS SET JELN.CHART_FIELD03 = null WHERE FIAS.IDCODE = JELN.CHART_FIELD03 AND FIAS.LOAN_CODE IS NOT null AND NOT EXISTS (SELECT PRAT.ID FROM ' . $this->filoname . ' FILO, ' . $this->pratname . ' PRAT WHERE FILO.IDCODE = FIAS.LOAN_CODE AND FILO.PRODUCT_CODE = PRAT.PRODUCT_CODE AND JELN.GLACCOUNTCODE IN (PRAT.PRO_GL_CODE, PRAT.AR_GL_CODE) ) AND JELN.JEHDR_CODE = ' . singleQuote($jehdr_code);
            ClxCommon::$db->executeQuery($sql);
            //Same as previous but with bank accounts
            $sql = 'UPDATE ' . $this->jelnname . ' JELN, ' . $this->fiasname . ' FIAS SET JELN.CHART_FIELD03 = null WHERE FIAS.IDCODE = JELN.CHART_FIELD03 AND FIAS.FIDU_BANKACT_CODE IS NOT null AND NOT EXISTS (SELECT PRAT.ID FROM ' . $this->fibkname . ' FIBK, ' . $this->pratname . ' PRAT WHERE FIBK.BANK_ACCOUNT_NO = FIAS.FIDU_BANKACT_CODE AND FIBK.BANK_PROD_CODE = PRAT.PRODUCT_CODE AND JELN.GLACCOUNTCODE IN (PRAT.PRO_GL_CODE, PRAT.AR_GL_CODE) ) AND JELN.JEHDR_CODE = ' . singleQuote($jehdr_code);
            ClxCommon::$db->executeQuery($sql);
            //All other assets
            $sql = 'UPDATE ' . $this->jelnname . ' JELN, ' . $this->fiasname . ' FIAS SET JELN.CHART_FIELD03 = null WHERE FIAS.IDCODE = JELN.CHART_FIELD03 AND FIAS.FIDU_BANKACT_CODE IS NULL AND FIAS.LOAN_CODE IS NULL AND NOT EXISTS (SELECT PRAT.ID FROM ' . $this->pratname . ' PRAT WHERE JELN.GLACCOUNTCODE IN (PRAT.PRO_GL_CODE, PRAT.AR_GL_CODE) ) AND JELN.JEHDR_CODE = ' . singleQuote($jehdr_code);
            ClxCommon::$db->executeQuery($sql);
            //If not asset or liability just no chart_field3
            $sql = 'UPDATE ' . $this->jelnname . ' JELN SET JELN.CHART_FIELD03 = null WHERE JELN.JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND NOT EXISTS (SELECT GLAC.ID FROM ' . $this->glacname . ' GLAC WHERE GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLAC.GL_TYPE IN (' . singleQuote('AS') . ',' . singleQuote('LI') . '))';
            ClxCommon::$db->executeQuery($sql);
            //check exchange rounds
            $jehd->balance_exchange_rounding($jehdr_code);
            //Send to queue for approval
            if (intval($r['APPROVE_OPER']) === CLX_NUM_ONE) {
                if(defined('kDefaultIsCron') && !empty(kDefaultIsCron)){
                    $jehd->jehd_approve_by_code($jehdr_code);
                }else{
                    $jehd->jehd_approve_queue_by_code($jehdr_code);
                }
            }
        }
    }

    /**
     * Displays a report on how the operation will account base on rules
     * @return string
     */
    function boit_accounting_details() {
        $idlist = toString(getIdlist());
        $tableWitdh = CLX_NUM_THREE;
        $table = new htmlTable($tableWitdh);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST));

        $table = new htmlTable($tableWitdh);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST));

        $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_OPERATIONS'), dict('GEN_LBL_DEBIT'), dict('GEN_LBL_CREDIT')));
        $sql = 'SELECT BOIT.ID, BOTT.CX_TIPO_TRAN, BOTT.CX_CAUSAL_TRAN, BOTT.CX_CONCEPTO, BOTT.GLGROUP_CODE, BOTT.DEBIT_GL_CODE, GLAC1.IDNAME DEBIT_GL_NAME, BOTT.CREDIT_GL_CODE, GLAC2.IDNAME CREDIT_GL_NAME, BOTT.ITEM_CODE, BOIT.CX_MONTO, BOIT.CX_CUENTA_CB, BOIT.CX_FIDEICOMISO, BOIT.CX_SECUENCIAL, BOIT.CX_COD_ALTERNO, BOIT.CX_FECHA_VALOR, BOIT.CX_FECHA_MOVIMIENTO FROM GL_BANK_OPERATION BOIT, GL_OPERATION_TBL BOTT, GL_PARAMETERS_TBL GLCP, GL_CODES_TBL GLAC1, GL_CODES_TBL GLAC2 WHERE BOTT.CX_TIPO_TRAN = BOIT.CX_TIPO_TRAN AND BOTT.CX_CAUSAL_TRAN = BOIT.CX_CAUSAL_TRAN AND BOTT.CX_CONCEPTO = BOIT.CX_CONCEPTO AND BOTT.GLGROUP_CODE = GLCP.GLGROUP_CODE AND BOIT.COMP_CODE = GLCP.COMP_CODE AND GLAC1.IDCODE = BOTT.DEBIT_GL_CODE AND GLAC2.IDCODE = BOTT.CREDIT_GL_CODE AND GLAC1.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLAC2.GLGROUP_CODE = GLCP.GLGROUP_CODE AND BOIT.ID IN (' . $idlist . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $txt = '<font size=1>Id:' . $r['ID'] . ' Ref: ' . $r['CX_SECUENCIAL'] . '.' . $r['CX_COD_ALTERNO'] . ' Valor: ' . $r['CX_FECHA_VALOR'] . ' Mov: ' . $r['CX_FECHA_MOVIMIENTO'] . '<br>Conf. Oper: Tipo: ' . $r['CX_TIPO_TRAN'] . ' | Causal: ' . $r['CX_CAUSAL_TRAN'] . ' | Concepto: ' . $r['CX_CONCEPTO'] . '<br> Cta. Cob.: ' . $r['CX_CUENTA_CB'] . ' Cont. Fideicomiso: ' . $r['CX_FIDEICOMISO'] . '<br>';
            $txt2 = '<b>' . $r['DEBIT_GL_CODE'] . ' ' . $r['DEBIT_GL_NAME'] . '</b><br>-Grupo: ' . $r['GLGROUP_CODE'] . ', Item:' . $r['ITEM_CODE'] . ' ';
            $table->addCells(CLX_CLASS_DATAALT, array($txt . $txt2, clx_format_currency($r['CX_MONTO']), CLX_CHAR_HTML_NBSP));
            $txt2 = '<b>' . $r['CREDIT_GL_CODE'] . ' ' . $r['CREDIT_GL_NAME'] . '</b><br>-Grupo: ' . $r['GLGROUP_CODE'] . ', Item:' . $r['ITEM_CODE'] . ' </font>';
            $table->addCells(CLX_CLASS_DATA, array($txt . $txt2, CLX_CHAR_HTML_NBSP, clx_format_currency($r['CX_MONTO'])));
            $table->addSeparator(CLX_CLASS_DATA);
        }
        $contents = $table->source() . '<br>';
        //Casos sin configuracion
        $tableWitdh = CLX_NUM_ONE;
        $table = new htmlTable($tableWitdh);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST));
        $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_MISSING_CONFIG')));
        $sql = 'SELECT DISTINCT BOIT.CX_TIPO_TRAN, BOIT.CX_CAUSAL_TRAN, BOIT.CX_CONCEPTO FROM GL_BANK_OPERATION BOIT WHERE BOIT.ID IN (' . $idlist . ') AND NOT EXISTS (SELECT BOTT.ID FROM GL_OPERATION_TBL BOTT WHERE BOTT.CX_TIPO_TRAN = BOIT.CX_TIPO_TRAN AND BOTT.CX_CAUSAL_TRAN = BOIT.CX_CAUSAL_TRAN AND BOTT.CX_CONCEPTO = BOIT.CX_CONCEPTO)';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $txt = '<font size=1>Tipo: ' . $r['CX_TIPO_TRAN'] . ' <br> Causal: ' . $r['CX_CAUSAL_TRAN'] . ' <br> Concepto: ' . $r['CX_CONCEPTO'] . '</font>';
            $table->addCells(CLX_CLASS_DATA, array($txt));
        }
        $contents .= $table->source();
        $contents = note($contents);
        return $contents;
    }

}
