/**
 *Init Depreciation actions
 */

function fiae_init_depreciation_form() {

    //see also amds.js
    //precision de registro
    var rtprec = 3;
    var amtprec = 2;
    field_set_readonly('FIAE_DEPRECIATION_AMT', true, 'hasCalculator');
    field_set_readonly('FIAE_DEPRECIATION_RT', true, 'hasCalculator');
    switch ($('#FIAE_DEPRECIATION_METHOD').val()) {
        case '10'://Fixed percentage (10)
            field_set_readonly('FIAE_DEPRECIATION_RT', false, 'hasCalculator');
            break;
        case '20'://Straight line (20)
            field_set_readonly('FIAE_DEPRECIATION_AMT', false, 'hasCalculator');
            break;
        case '30'://Declining-balance (30)
            field_set_readonly('FIAE_DEPRECIATION_RT', false, 'hasCalculator');
            break;
            //case '40'://Activity depreciation (40)
            //case '50'://Sum-of-years' digits (50)
            //case '60'://Units of production (60)
            //case '70'://Units of time (70)
        default:
            $('#FIAE_DEPRECIATION_AMT').val(numDec(0, amtprec));
            $('#FIAE_DEPRECIATION_RT').val(numDec(0, rtprec));
            break;
    }//end switch
}

/**
 * Sets Amount for depreciation
 */
function fiae_set_depreciation() {

    /*
     SIZE_COMMON_AR
     SIZE_USABLE
     SIZE_LOT
     */

    //see also amds.js

    field_set_readonly('FIAE_DEPRECIATION_AMT', true, 'hasCalculator');
    field_set_readonly('FIAE_DEPRECIATION_RT', true, 'hasCalculator');
    var amt = parseFloat($('#FIAE_PURCHASE_AMT').val());

    var periodtype = $('#FIAE_USEFUL_LIFE_UNIT').val();
    var period = parseFloat($('#FIAE_USEFUL_LIFE').val());
    var payfreq = parseFloat($('#FIAE_DEPRECIATION_FREQ').val());
    var periodfactor = 0;
    if (isNaN(period)) {
        period = 0;
    }
    if (periodtype == 'D') {
        periodfactor = 360;
    }
    else if (periodtype == 'W') {
        periodfactor = 52;
    }
    else if (periodtype == 'M') {
        periodfactor = 12;
    }
    else if (periodtype == 'Q') {
        periodfactor = 4;
    }
    else if (periodtype == 'S') {
        periodfactor = 2;
    }
    else if (periodtype == 'Y') {
        periodfactor = 1;
    }
    else {
        periodfactor = 0;
    }
    var per = 0;
    if (periodfactor > 0) {
        per = period * (payfreq / periodfactor);
    }
    if (payfreq == 99) {
        per = 1;
    }
    var sal = parseFloat($('#FIAE_SALVAGE_VALUE').val());
    var dm = $('#FIAE_DEPRECIATION_METHOD').val();
    var rtprec = 3;//precision de registro
    var amtprec = 2;
    switch (dm) {
        case '10'://Fixed percentage (10)
            $('#FIAE_DEPRECIATION_AMT').val(numDec(0, amtprec));
            field_set_readonly('FIAE_DEPRECIATION_RT', false, 'hasCalculator');
            if ($('#FIAE_DEPRECIATION_RT').val() == 0) {
                $('#FIAE_DEPRECIATION_RT').val( 
				(per == 0) ?
				numDec(0, rtprec):
				numDec((100 / per), rtprec));
            }
            break;
        case '20'://Straight line (20)
            $('#FIAE_DEPRECIATION_RT').val(numDec(0, rtprec));
            field_set_readonly('FIAE_DEPRECIATION_AMT', false, 'hasCalculator');
            if (per == 0) {
                $('#FIAE_DEPRECIATION_AMT').val(numDec(0, amtprec));
            } else {

                $('#FIAE_DEPRECIATION_AMT').val(numDec((amt - sal) / per, amtprec));
            }
            break;
        case '30'://Declining-balance (30)
            $('#FIAE_DEPRECIATION_AMT').val(numDec(0, amtprec));
            field_set_readonly('FIAE_DEPRECIATION_RT', false, 'hasCalculator');
            if (per == 0) {
                $('#FIAE_DEPRECIATION_RT').val(numDec(0, rtprec));
            } else {
                $('#FIAE_DEPRECIATION_RT').val(numDec((100 / per) * 2, rtprec));
            }
            break;
            //case '40'://Activity depreciation (40)
            //case '50'://Sum-of-years' digits (50)
            //case '60'://Units of production (60)
            //case '70'://Units of time (70)
        default:
            $('#FIAE_DEPRECIATION_AMT').val(numDec(0, amtprec));
            $('#FIAE_DEPRECIATION_RT').val(numDec(0, rtprec));
            return;
            break;
    }//end switch





}// End function

function fiae_set_panels() {
    /*init other values that may be required*/
    //FIAE_ASSET_TYPE
    if ($('#FIAE_ASSET_TYPE').val() == 'RE') {
        $('#3857').show();
    } else {
        $('#3857').hide();
    }

    /*if($('#FIAE_ASSET_TYPE').val()=='AU' || $('#FIAE_ASSET_TYPE').val()=='MV'){
     $('#3860').show();
     }else{
     $('#3860').hide();
     }*/
    if ($('#FIAE_ASSET_TYPE').val() == 'VH') {
        $('#3860').show();
    } else {
        $('#3860').hide();
    }

    //updateDBLT('FIAE_MANUFACTURER', 'FIAE_MODEL_TYPE');
}//end function



function fiae_set_areas() {
    var ua = parseFloat($('#FIAE_SIZE_LOT').val()) - parseFloat($('#FIAE_SIZE_COMMON_AR').val());
    $('#FIAE_SIZE_USABLE').val(numDec(ua, 4));
    var size = parseFloat($('#FIAE_SIZE_LOT').val());
    var price = parseFloat($('#FIAE_PURCHASE_AMT').val());
    var up = 0;
    if (size != 0) {
        up = price / size;
    }
    $('#FIAE_UNIT_COST').val(numDec(up, 2));
    up = 0;
    if (ua != 0) {
        up = price / ua;
    }
    $('#FIAE_AVAIL_UNIT_COST').val(numDec(up, 2));

}//end methd