/**
 * Update Principal Amount
 * @returns {undefined}
 */
function filsUpdatePrincipalAmt() {
    if ($('#FILS_LOAN_AMT').val() == '') {
        $('#FILS_LOAN_AMT').val(numDec(0, 2));
    }
    if ($('#FILS_PRINCIPAL_PAY').val() == '') {
        $('#FILS_PRINCIPAL_PAY').val(numDec(0, 2));
    }
    if ($('#FILS_BALLOON_PAY_AMT').val() == '') {
        $('#FILS_BALLOON_PAY_AMT').val(numDec(0, 2));
    }
    if ($('#FILS_INTEREST_PAY').val() == '') {
        $('#FILS_INTEREST_PAY').val(numDec(0, 2));
    }
    if ($('#FILS_FEES_AMT').val() == '') {
        $('#FILS_FEES_AMT').val(numDec(0, 2));
    }
    if ($('#FILS_RESERVE_PAY').val() == '') {
        $('#FILS_RESERVE_PAY').val(numDec(0, 2));
    }
    if ($('#FILS_NO_DAYS').val() == '') {
        $('#FILS_NO_DAYS').val(numDec(0, 0));
    }

    var l = parseFloat($('#FILS_LOAN_AMT').val());
    var p = parseFloat($('#FILS_PRINCIPAL_PAY').val());
    var b = parseFloat($('#FILS_BALLOON_PAY_AMT').val());
    var i = parseFloat($('#FILS_INTEREST_PAY').val());
    var f = parseFloat($('#FILS_FEES_AMT').val());
    var r = parseFloat($('#FILS_RESERVE_PAY').val());
    var m = 0;

    m = l - p - b - r;
    $('#FILS_PRINCIPAL_BAL').val(numDec(m, 2));

    m = (p + b + i + f) - r;
    $('#FILS_PAYMENT_AMT').val(numDec(m, 2));

}

/**
 * Calculates interest Based on change of Interest
 */
function filsUpdateInterestAmt() {
    filsUpdatePrincipalAmt();

    var d = parseFloat($('#FILS_NO_DAYS').val());
    var ip = parseFloat($('#FILS_INTEREST_PAY').val());

    var id;
    if (d == 0) {
        id = 0;
    } else {
        id = ip / d;
    }

    $('#FILS_DAILY_INTEREST').val(numDec(id, 2));
}

/**
 * Calculates interest fields
 */
function filsUpdateInterestPct() {

    if ($('#FILS_LOAN_AMT').val() == '') {
        $('#FILS_LOAN_AMT').val(numDec(0, 2));
    }
    if ($('#FILS_LOAN_INTEREST').val() == '') {
        $('#FILS_LOAN_INTEREST').val(numDec(0, 2));
    }
    if ($('#FILS_INTEREST_CALC').val() == '') {
        $('#FILS_INTEREST_CALC').val(numDec(0, 2));
    }
    if ($('#FILS_NO_DAYS').val() == '') {
        $('#FILS_NO_DAYS').val(numDec(0, 0));
    }

    var l = parseFloat($('#FILS_LOAN_AMT').val());
    var i = parseFloat($('#FILS_LOAN_INTEREST').val()) / 100;
    var b = parseFloat($('#FILS_INTEREST_CALC').val());
    var d = parseFloat($('#FILS_NO_DAYS').val());

    //interest calculations
    //FILS_LOAN_INTEREST
    //FILS_INTEREST_CALC
    //FILS_DAILY_INTEREST

    var ip = l * (i / b) * d;
    var id = 1 * (i / b);
    $('#FILS_INTEREST_PAY').val(numDec(ip, 2));
    $('#FILS_DAILY_INTEREST').val(numDec(id, 2));

    filsUpdatePrincipalAmt();

}

/**
 * Calculates dates intervals and recalculate interests
 */
function filsCalculateDates() {

    var sdate = $('#FILS_PERIOD_START_DATE').val();
    var edate = $('#FILS_PERIOD_END_DATE').val();
    var days = days_between(edate, sdate);
    $('#FILS_DUE_PAY_DATE').val(edate);
    $('#FILS_NO_DAYS').val(days);
    filsUpdateInterestPct();
}

function filsInitForm() {

    $(function () {
        $('#FILS_INTEREST_CALC option').each(function (i) {
            var self = this;
            switch ($(self).val()) {
                case '30/360':
                case '366':
                case 'AC/360':
                case '':
                case '30/365':
                case 'AC/365':
                case 'AC/AC':
                    $(self).hide();
                    break;
                default:
                    break;
            }
            ;
        });
    });

}