<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2016-09-29 15:21:10 -0400 (Thu, 29 Sep 2016) $
 * @version        $Rev: 8752 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Firt {

    /**
     * Contructor
     *
     * @param array $procParameters
     * @return void
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('FIRT', 'FITS', 'GLCP', 'JEIT', 'GLAC'));
        $this->batch_id = (!empty($procParameters ['BATCH_ID'])) ? $procParameters ['BATCH_ID'] : batch_id();
        $this->username = $_SESSION ['user_record'] ['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
    }

    /**
     * Initialice firt form
     * Executed on init event
     */
    function firt_init_form(&$record) {
        if (empty(UserRequest::$post ['confirm']) && (UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'DUPLICATE')) {
            $record ['FIRT_IDCODE'] = 'AUTO';
        }
        if (empty(UserRequest::$post ['confirm']) && UserRequest::$request['ac'] === 'CREATE') {
            if (!class_exists('Comp'))
                includeCodeLib('COMP');
            $comp = new Comp ();
            $comprec = $comp->comp_operation_parameters();
            unset($comp);
            $record ['FIRT_CLX_EFFTDATE'] = $comprec ['OPERATION_DATE'];
            $record ['FIRT_CURRENCY_CODE'] = $comprec ['CURRENCY_CODE'];
            $record ['FIRT_COMP_CODE'] = $comprec ['IDCODE'];
        }
    }

// end function
    /**
     * Validate record information
     * Executed on table validate
     */
    function firt_validate_form(&$record, &$msg) {
        // Segun FEE_TYPE validar cada set de parametros
        // todos deben incluir monto o porcentaje
        // si es monto no puede ser mayor que el maximo o menor que el minimo
        switch ($record ['FIRT_FEE_TYPE']) {
            case 'FLAT' :
                if ($record ['FIRT_FLAT_FEES'] != CLX_NUM_ZERO && $record ['FIRT_TRANS_PCT'] != CLX_NUM_ZERO) {
                    $msg ['FIRT_FLAT_FEES'] = smsg('MSG-74');
                }
                if (empty($record ['FIRT_TRANSCODE'])) {
                    $msg ['FIRT_TRANSCODE'] = smsg('MSG-75');
                }
                if (empty($record ['FIRT_FLAT_TX_CODE'])) {
                    $msg ['FIRT_FLAT_TX_CODE'] = smsg('MSG-75');
                }
                if ($record ['FIRT_TRANS_CHARGE_AFTER'] > CLX_NUM_ZERO && empty($record ['FIRT_TRANS_CHRG_PER'])) {
                    $msg ['FIRT_TRANS_CHRG_PER'] = smsg('MSG-75');
                }
                break;
            case 'ADMN' :
                if (empty($record ['FIRT_CHARGE_TX_CODE'])) {
                    $msg ['FIRT_CHARGE_TX_CODE'] = smsg('MSG-75');
                }
                if (empty($record ['FIRT_PAY_TX_CODE'])) {
                    $msg ['FIRT_PAY_TX_CODE'] = smsg('MSG-75');
                }
                if (empty($record ['FIRT_ASSET_COM_BASE'])) {
                    $msg ['FIRT_ASSET_COM_BASE'] = smsg('MSG-75');
                }
                if ($record ['FIRT_ASSET_COM_BASE'] === 'GLB' && empty($record ['FIRT_GL01_CODE'])) {
                    $msg ['FIRT_GL01_CODE'] = smsg('MSG-91');
                }
                if ($record ['FIRT_ASSET_COM_BASE'] !== 'FIAT' && $record ['FIRT_ASSET_COM_BASE'] !== 'GLO' && $record ['FIRT_ASSET_COM_BASE'] !== 'GLB' && !empty($record ['FIRT_GL01_CODE'])) {
                    $msg ['FIRT_GL01_CODE'] = smsg('MSG-92');
                }
                if (empty($record ['FIRT_DIVIDER_FACTOR'])) {
                    $msg ['FIRT_DIVIDER_FACTOR'] = smsg('MSG-75');
                }
                if (empty($record ['FIRT_FLAT_FEES']) && empty($record ['FIRT_ASSET_PCT']) && $record ['FIRT_SCALE_TYPE'] == CLX_NUM_ZERO) {
                    $msg ['FIRT_ASSET_PCT'] = smsg('MSG-75');
                }
                // SELECT * FROM FIDU_TRANSACTION_SPLIT WHERE TRANSTBL_CODE =
                if (empty($record ['FIRT_LGGROUP_CODE'])) {
                    $msg ['FIRT_LGGROUP_CODE'] = smsg('MSG-75');
                }
                if ($record ['FIRT_ASSET_COM_BASE'] === 'FIAT' && empty($record ['FIRT_ADM_TRANSTBL_CODE'])) {
                    // MSG-330
                    $msg ['FIRT_ADM_TRANSTBL_CODE'] = smsg('MSG-330');
                }
                break;
            case 'DISB' :
                if (empty($record ['FIRT_DISBURSEMENT_TYPE'])) {
                    $msg ['FIRT_DST_TX_CODE'] = smsg('MSG-75');
                }
                /*
                 * may have scale if($record['FIRT_DISBURSEMENT_PCT']==0 &&
                 * $record['FIRT_DISBURSEMENT_FEE']==0){
                 * $msg['FIRT_DISBURSEMENT_PCT'] = smsg('MSG-74'); }
                 */
                if ($record ['FIRT_DISBURSEMENT_PCT'] != CLX_NUM_ZERO && $record ['FIRT_DISBURSEMENT_FEE'] != CLX_NUM_ZERO) {
                    $msg ['FIRT_DISBURSEMENT_PCT'] = smsg('MSG-74');
                }
                if (empty($record ['FIRT_DST_TX_CODE'])) {
                    $msg ['FIRT_DST_TX_CODE'] = smsg('MSG-75');
                }
                break;
            default :
                break;
        } // end switch
        if (UserRequest::$request['ac'] === 'CREATE' && $record ['FIRT_STATUS'] !== 'A') {
            $msg ['FIRT_STATUS'] = dict('MSG-76');
        }
        if (!empty($record ['FIRT_TRANSCODE']) && $record ['FIRT_TRANSCODE'] === 'SYS_DESIN' && $record ['FIRT_FEE_TYPE'] !== 'FLAT') {
            $msg ['FIRT_FEE_TYPE'] = smsg('MSG-77');
        }
        getLookupValue('FIRT_CHARGE_TX_CODE', 'CHARGE_TX_CODE', $record);
        getLookupValue('FIRT_PAY_TX_CODE', 'PAY_TX_CODE', $record);
        getLookupValue('FIRT_TRANSCODE', 'TRANSCODE', $record);
        getLookupValue('FIRT_FLAT_TX_CODE', 'FLAT_TX_CODE', $record);
        getLookupValue('FIRT_DST_TX_CODE', 'DST_TX_CODE', $record);
        getLookupValue('FIRT_GL01_CODE', 'GL01_CODE', $record);
        if (!class_exists('Fiat'))
            includeCodeLib('FIAT');
        $fiat = new Fiat ();
        if (!empty($record ['FIRT_CHARGE_TX_CODE']) && $fiat->invalid_transaction_glroup($record ['FIRT_COMP_CODE'], $record ['FIRT_CHARGE_TX_CODE'])) {
            $msg ['FIRT_CHARGE_TX_CODE'] = smsg('MSG-329');
        }
        if (!empty($record ['FIRT_PAY_TX_CODE']) && $fiat->invalid_transaction_glroup($record ['FIRT_COMP_CODE'], $record ['FIRT_PAY_TX_CODE'])) {
            $msg ['FIRT_PAY_TX_CODE'] = smsg('MSG-329');
        }
        if (!empty($record ['FIRT_TRANSCODE']) && $fiat->invalid_transaction_glroup($record ['FIRT_COMP_CODE'], $record ['FIRT_TRANSCODE'])) {
            $msg ['FIRT_TRANSCODE'] = smsg('MSG-329');
        }
        if (!empty($record ['FIRT_FLAT_TX_CODE']) && $fiat->invalid_transaction_glroup($record ['FIRT_COMP_CODE'], $record ['FIRT_FLAT_TX_CODE'])) {
            $msg ['FIRT_FLAT_TX_CODE'] = smsg('MSG-329');
        }
        if (!empty($record ['FIRT_DST_TX_CODE']) && $fiat->invalid_transaction_glroup($record ['FIRT_COMP_CODE'], $record ['FIRT_DST_TX_CODE'])) {
            $msg ['FIRT_DST_TX_CODE'] = smsg('MSG-329');
        }
        if (!empty($record ['FIRT_ADM_TRANSTBL_CODE']) && $fiat->invalid_transaction_glroup($record ['FIRT_COMP_CODE'], $record ['FIRT_ADM_TRANSTBL_CODE'])) {
            $msg ['FIRT_ADM_TRANSTBL_CODE'] = smsg('MSG-329');
        }
        unset($fiat);
        if (!class_exists('Glac'))
            includeCodeLib('GLAC');
        $glac = new Glac ();
        if (!empty($record ['FIRT_GL01_CODE']) && $glac->invalid_gl_glroup($record ['FIRT_COMP_CODE'], $record ['FIRT_GL01_CODE'])) {
            $msg ['FIRT_GL01_CODE'] = smsg('MSG-329');
        }
        unset($glac);
        //Validaciones para comision de administradora
        if (!empty($record['FIRT_TGT_COMP_CODE'])) {
            //Verificar que coloca conceptos y parametros de comision
            if (empty($record['FIRT_TGT_ITEM_CODE'])) {
                $msg['FIRT_TGT_ITEM_CODE'] = dict('GEN_ERR_REQUIRED');
            }
            if (empty($record['FIRT_TGT_ITEM2_CODE'])) {
                $msg['FIRT_TGT_ITEM2_CODE'] = dict('GEN_ERR_REQUIRED');
            }
            //validar que la cuenta contable del concepto y de la compania administradora
            //esten en el mismo grupo contable
            $comp_glgroup = ClxCommon::$db->getField($this->glcpname, 'GLGROUP_CODE', 'COMP_CODE =' . singleQuote($record['FIRT_TGT_COMP_CODE']));
            $sql = 'SELECT JEIT.IDCODE, COUNT(JEIT.ID) QTY FROM  ' . $this->jeitname . ' JEIT,  ' . $this->glacname.' GLAC WHERE  GLAC.IDCODE = JEIT.GLACCOUNTCODE AND GLAC.GLGROUP_CODE <> ' . singleQuote($comp_glgroup) . ' AND JEIT.IDCODE IN (' . singleQuote($record['FIRT_TGT_ITEM_CODE']) . ',' . singleQuote($record['FIRT_TGT_ITEM2_CODE']) . ') GROUP BY  JEIT.IDCODE HAVING  COUNT(JEIT.ID) > 0';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                if ($r['IDCODE'] == $record['FIRT_TGT_ITEM_CODE']) {
                    $msg['FIRT_TGT_ITEM_CODE'] = smsg('MSG-361');
                } else {
                    $msg['FIRT_TGT_ITEM2_CODE'] = smsg('MSG-361');
                }
            }
        }
        
        if($record['FIRT_CHARGE_FREQUENCY'] != 'D' && !empty($record['FIRT_INT_PER_TYPE']))
            $msg['FIRT_INT_PER_TYPE'] = smsg('MSG-527');
    }

// end function
    /**
     * Update Parent (FIRT) Information one record is saved
     */
    function firt_save_form(&$record) {
        // Update modified by and modification date on FIRT
        if($record['CHARGE_DAY'] == 'null'){
            $record['CHARGE_DAY'] = 0;
        }

        if($record['PAY_DAY'] == 'null'){
            $record['PAY_DAY'] = 0;
        }
    }

}
