/**
 * Performs exchange rate calculation
 */
function invlCalculateTaxAmt(jeit_flat_rate, jeit_tax_witholding_pct, jeit_exempt_tax_amt) {


    var n_jeit_flat_rate = parseFloat(jeit_flat_rate);
    var n_jeit_tax_witholding_pct = parseFloat(jeit_tax_witholding_pct);
    var n_jeit_exempt_tax_amt = parseFloat(jeit_exempt_tax_amt);

    $("#INVL_LINE_TOTAL").val($("#INVL_LINE_TOTAL").val().replace(/,/g, ""));

    var invl_line_total = parseFloat($("#INVL_LINE_TOTAL").val   ());
    var invl_tax_amt = 0;

    invl_tax_amt = (invl_line_total-n_jeit_exempt_tax_amt) * (n_jeit_flat_rate/100) * (n_jeit_tax_witholding_pct/100);
    if (invl_tax_amt < 0) {
        invl_tax_amt = 0;
    }
    $("#INVL_TAX_AMT").val(numDec(invl_tax_amt, 2));

}

/*
 * Sets invoice line tax amount based on line's Item tax data
 */
function invlTaxAmt() {
    var invl_invoicecode = $('input[name="INVL_INVOICECODE"]').val();
    if(invl_invoicecode == undefined){
        invl_invoicecode = $("#INVL_INVOICECODE").val();
    }
    var invl_item_code = $('input[name="INVL_ITEM_CODE_prim"]').val();
    if(invl_item_code == undefined){
        invl_item_code = $('input[name="INVL_ITEM_CODE"]').val();
    }
    if(invl_item_code == undefined){
        invl_item_code = $("#INVL_ITEM_CODE").val();
    }
    if(invl_item_code == undefined){
        invl_item_code = $("#INVL_ITEM_CODE_prim").val();
    }

    $("#INVL_TAX_AMT").val(0);

    var url = "window.php?to=DBQY&ac=QXML&no_menu=1&no_alerts=1&qy=JEIT_AR_JS&fn[]=INVO.IDCODE&fv[]="+ invl_invoicecode + "&fn[]=JEIT.IDCODE&fv[]=" + invl_item_code;
    $.ajax({
        type : "GET",
        url : url,
        async : false,
        dataType : "xml",
        success : function(xml) {
            $(xml).find('JEIT_AR_JS').each(function() {
                var jeit_idcode = $(this).find('JEIT_IDCODE').text();
                var jeit_clx_efftdate = $(this).find('JEIT_CLX_EFFTDATE').text();
                var jeit_tax_type = $(this).find('JEIT_TAX_TYPE').text();
                $("#JEIT_IDCODE").val(jeit_idcode);
                $("#JEIT_CLX_EFFTDATE").val(jeit_clx_efftdate);
                $("#JEIT_TAX_TYPE").val(jeit_tax_type);

                var jeit_filing_status = $(this).find('JEIT_FILING_STATUS').text();
                var jeit_state = $(this).find('JEIT_STATE').text();
                var jeit_country = $(this).find('JEIT_COUNTRY').text();
                $("#JEIT_FILING_STATUS").val(jeit_filing_status);
                $("#JEIT_STATE").val(jeit_state);
                $("#JEIT_COUNTRY").val(jeit_country);

                var jeit_flat_rate = $(this).find('JEIT_FLAT_RATE').text();
                var jeit_tax_witholding_pct = $(this).find('JEIT_TAX_WITHOLDING_PCT').text();
                var jeit_exempt_tax_amt = $(this).find('JEIT_EXEMPT_TAX_AMT').text();
                $("#JEIT_FLAT_RATE").val(jeit_flat_rate);
                $("#JEIT_TAX_WITHOLDING_PCT").val(jeit_tax_witholding_pct);
                $("#JEIT_EXEMPT_TAX_AMT").val(jeit_exempt_tax_amt);

                invlCalculateTaxAmt(jeit_flat_rate, jeit_tax_witholding_pct, jeit_exempt_tax_amt);
            });
        }
    });
}

/*
 * Assignments based on price and quantity changes
 */
function invlSetAmts()
{
    var p = parseFloat($("#INVL_PRICE").val());
    var q = parseFloat($("#INVL_QUANTITY").val());
    $("#INVL_LINE_TOTAL").val(numDec(p*q,2));
    invlTaxAmt();
}

function invlSetListeners()
{
    $('#INVL_PRICE').change(invlSetAmts);
    $('#INVL_QUANTITY').change(invlSetAmts);
    $('#INVL_ITEM_CODE_prim').change(invlSetAmts);
    $('#INVL_ITEM_CODE').change(invlSetAmts);
    invlSetAmts();
}
