<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
if (!class_exists('anog') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'anog.php';

class anog_msexcel extends anog {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'AXLS';
        $this->name = 'Microsoft Excel';
        $this->type = 'ANOG';
        $this->version = '0.1.0.1';
        $this->description = 'Output Generator Form Format: Microsoft Excel';
        $this->editPanel = array('entries' => array(
			 array('label' => 'GEN_LBL_MSEXCELFILE',
			     'fields' => array(
			         array('name' => 'msexcelfile', 'type' => 'file'))
			 )
		  )
        );
    }

    function extractFields($templaterec) {
        require kPathToWebSite . 'classes/clx_msexcel.php';
        $templateid = $templaterec['ID'];
        $this->deletefiles($templateid);
        $field_name = $this->type . '_msexcelfile';
        $filename = kPathToWebSite . kPathToTemplates . $templateid . '.xls';
        if (!move_uploaded_file(UserRequest::$files[$field_name]['tmp_name'], $filename))
		  addMessage(dict('GEN_ERR_FILEUPLOADFAIL'));
        ClxCommon::$db->deleteRecords('CLX_AN_OUTPUT_GEN_FIELDS', 'TEMPLATECODE=' . singleQuote($templaterec['IDCODE']));
        $o = new clx_msexcel($filename);
        if ($o->error === true) {
		  echo 'Error: ', $o->errormsg;
        } else {
		  $o->sheets();
        }
    }

    function deletefiles($templateid) {
        $this->deleteFile($templateid . '.xls');
    }

    function printtemplate($templaterec, $tree, &$contents, &$headers) {

    }

    function set($field, $value) {

    }

    function view_template($templaterec) {

    }

}
