<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @package		Clientix.Tool.Interface
 * @abstract		System Chart Manager
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 */
include_once kPathToObjects . 'cpty.php';

class cpty_legendprops extends cpty {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'CLPR';
        $this->name = 'Legend';
        $this->type = 'CPTX';
        $this->version = '0.2.0.0';
        $this->description = 'Chart Legend Properties';
        $this->classname = '';
        $this->classfile = '';
        $this->functions = array(array('function' => 'SetAbsPos', 'name' => 'POSITION', CLX_CLASS_PROMPT => 'GEN_LBL_POSITION', 'arguments' => array(
			     array('name' => 'XPOS', 'type' => 'NUMBER', 'decimal' => '1', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_XPOS', 'postfix' => 'GEN_LBL_PIXELS', 'max' => '', 'min' => ''), array('name' => 'YPOS', 'type' => 'NUMBER', 'decimal' => '1', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_YPOS', 'postfix' => 'GEN_LBL_PIXELS', 'max' => '', 'min' => ''), array('name' => 'HALIGN', 'type' => 'LIST', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_HORALIGN', 'options' => 'left:GEN_LBL_LEFT,center:GEN_LBL_CENTER,right:GEN_LBL_RIGHT'),
			     array('name' => 'VALIGN', 'type' => 'LIST', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_VERALIGN', 'options' => 'top:GEN_LBL_TOP,center:GEN_LBL_CENTER,bottom:GEN_LBL_BOTTOM')
			 )
		  ), array('function' => 'SetColor', 'name' => 'COLOR', CLX_CLASS_PROMPT => 'GEN_LBL_COLOR', 'arguments' => array(
			     array('name' => 'FCOLOR', 'type' => 'STRING', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_FONTCOLOR', 'size' => '255', 'displaysize' => '45'), array('name' => 'LCOLOR', 'type' => 'STRING', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_LINECOLOR', 'size' => '255', 'displaysize' => '45'))
		  ), array('function' => 'SetColumns', 'name' => 'COLUMNS', CLX_CLASS_PROMPT => 'GEN_LBL_COLUMNS', 'arguments' => array(
			     array('name' => 'VALUE', 'type' => 'NUMBER', 'default' => '', 'max' => '', 'min' => ''))
		  ), array('function' => 'SetFillColor', 'name' => 'FILLCOLOR', CLX_CLASS_PROMPT => 'GEN_LBL_FILLCOLOR', 'arguments' => array(
			     array('name' => 'VALUE', 'type' => 'STRING', 'default' => '', 'size' => '255', 'displaysize' => '30'))
		  ), array('function' => 'SetFrameWeight', 'name' => 'FRAMEWIDTH', CLX_CLASS_PROMPT => 'GEN_LBL_FRAMEWIDTH', 'arguments' => array(
			     array('name' => 'VALUE', 'type' => 'NUMBER', 'default' => '', 'postfix' => 'GEN_LBL_PIXELS', 'max' => '', 'min' => ''))
		  ), array('function' => 'SetLayout', 'name' => 'LAYOUT', CLX_CLASS_PROMPT => 'GEN_LBL_LAYOUT', 'arguments' => array(
			     array('name' => 'VALUE', 'type' => 'LIST', 'default' => '', 'constant' => '1', 'options' => 'LEGEND_VERT:GEN_LBL_VERTICAL,LEGEND_HORIZONTAL:GEN_LBL_HORIZONTAL')
			 )
		  ), array('function' => 'SetLineSpacing', 'name' => 'LINESPACING', CLX_CLASS_PROMPT => 'GEN_LBL_LINESPACING', 'arguments' => array(
			     array('name' => 'VALUE', 'type' => 'NUMBER', 'default' => '', 'postfix' => 'GEN_LBL_PIXELS', 'max' => '', 'min' => ''))
		  ), array('function' => 'SetLineWeight', 'name' => 'LINEWEIGHT', CLX_CLASS_PROMPT => 'GEN_LBL_LINEWEIGHT', 'arguments' => array(
			     array('name' => 'VALUE', 'type' => 'NUMBER', 'default' => '', 'postfix' => 'GEN_LBL_PIXELS', 'max' => '', 'min' => ''))
		  ), array('function' => 'SetReverse', 'name' => 'REVERSE', CLX_CLASS_PROMPT => 'GEN_LBL_REVERSE', 'arguments' => array(
			     array('name' => 'VALUE', 'type' => 'BOOLEAN', 'default' => ''))
		  ), array('function' => 'SetShadow', 'name' => 'SHADOW', CLX_CLASS_PROMPT => 'GEN_LBL_SHADOW', 'arguments' => array(
			     array('name' => 'COLOR', 'type' => 'STRING', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_COLOR', 'size' => '255', 'displaysize' => '30'), array('name' => 'WIDTH', 'type' => 'NUMBER', 'default' => '', CLX_CLASS_PROMPT => 'GEN_LBL_WIDTH', 'max' => '', 'min' => '', 'default' => CLX_NUM_ZERO))
		  )
        );
    }

    function setFunctions(&$graph, $args, $series = array()) {
        $arguments = new XMLObject('properties', false);
        $arguments->parse($args);
        foreach ($this->functions as $function) {
		  if ($arguments->hasObject($function['name'])) {
			 $func_arguments = $arguments->getObject($function['name']);
			 $this->setFunction($graph->legend, $function, $func_arguments);
		  }
        }
    }

}
