<?php

/**
 * System lookup field object class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version    	$Rev: 9615 $
 */
if (!class_exists('dbft') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'dbft.php';

class dbft_sys_lookup extends dbft {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'SLUK';
        $this->name = 'System Tables Look up';
        $this->type = 'DBFT';
        $this->version = '0.2.4.2';
        $this->description = 'Can somebody place a nice description here?';
        $this->multifield = false; // Describes it field is a multi field see properties;
        $this->has_lookup = true; // Decribes if field can be set as copy field on lookup
        $this->has_question = true; // Describes if field can be used on queries criteria
        $this->operators = array('===' => 'GEN_LBL_EQUALTO',
		  '!== ' => 'GEN_LBL_NOTEQUALTO'
        );
    }

// End method
    function panel($msg, $fieldrecord, &$form) {
        $c = $this->code;
        if ($fieldrecord['DBFL_fieldtype'] != $c) {
		  $this->defaultRecord($fieldrecord);
        }
        $contents = '';
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $table->addCell(dict('GEN_LBL_SYSLOOKPROP'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $yesno = new htmlSelect($c . '_required');
        $yesno->addItem(dict('GEN_LBL_NO'), '0', ($fieldrecord[$c . '_required'] == CLX_NUM_ZERO));
        $yesno->addItem(dict('GEN_LBL_YES'), '1', ($fieldrecord[$c . '_required'] == CLX_NUM_ONE));
        $table->addData('Required:', $yesno->source());
        $table->addField($msg, dict('GEN_LBL_TABLE') . ':', $c . '_extra1', $fieldrecord[$c . '_extra1'], CLX_NUM_48, CLX_NUM_255);
        $table->addField($msg, dict('GEN_LBL_PRIMARY_SEARCH_FIELD') . ':', $c . '_extra2', $fieldrecord[$c . '_extra2'], CLX_NUM_48, CLX_NUM_255);
        $table->addField($msg, dict('GEN_LBL_SECONDARY_SEARCH_FIELD') . ':', $c . '_extra3', $fieldrecord[$c . '_extra3'], CLX_NUM_48, CLX_NUM_255);
        $table->addField($msg, dict('GEN_LBL_DEFAULT_ID') . ':', $c . '_extra4', $fieldrecord[$c . '_extra4'], CLX_NUM_24, CLX_NUM_24);
        $div = new htmlDiv($this->code, 'visibility:hidden; display:none', $table->source());
        $contents .= CLX_CHAR_NL . CLX_CHAR_NL . $div->source();
        return $contents . CLX_CHAR_NL . CLX_CHAR_NL;
    }

// End method
    function checkPanel(&$msg) {
        $c = $this->code;

        if (empty(UserRequest::$post[$c . '_extra1'])) {
		  $msg[$c . '_extra1'] = dict('GEN_ERR_REQUIRED');
        } elseif (!ClxCommon::$db->tableExists(UserRequest::$post[$c . '_extra1'])) {
		  $msg[$c . '_extra1'] = dict('GEN_ERR_TABLE_DOES_NOT_EXISTS');
        } else {
		  if (empty(UserRequest::$post[$c . '_extra2'])) {
			 $msg[$c . '_extra2'] = dict('GEN_ERR_REQUIRED');
		  } elseif (!ClxCommon::$db->fieldExists(UserRequest::$post[$c . '_extra1'], UserRequest::$post[$c . '_extra2'])) {
			 $msg[$c . '_extra2'] = dict('GEN_ERR_NOFIELDONTABLE');
		  }
		  if (empty(UserRequest::$post[$c . '_extra3'])) {
			 $msg[$c . '_extra3'] = dict('GEN_ERR_REQUIRED');
		  } elseif (!ClxCommon::$db->fieldExists(UserRequest::$post[$c . '_extra1'], UserRequest::$post[$c . '_extra3'])) {
			 $msg[$c . '_extra3'] = dict('GEN_ERR_NOFIELDONTABLE');
		  }
        }
        if (!empty(UserRequest::$post[$c . '_required'])) {
		  UserRequest::$post[$c . '_default'] = UserRequest::$post[$c . '_extra4'];
		  xValidate::required($msg, $c . '_extra4', UserRequest::$post[$c . '_extra4']);
        }
    }

// End method
    function savePanel(&$fieldrecord) {
        $c = $this->code;
        $fieldrecord['FIELD_SIZE'] = CLX_INIT_ZERO;
        $fieldrecord['FIELD_REQUIRED'] = UserRequest::$post[$c . '_required'];
        $fieldrecord['FIELD_FORMAT'] = '';
        $fieldrecord['FIELD_ALIGN'] = CLX_INIT_ZERO;
        $fieldrecord['FIELD_DEFAULT'] = UserRequest::$post[$c . '_extra4'];
        $fieldrecord['FIELD_MINVALUE'] = '';
        $fieldrecord['FIELD_MAXVALUE'] = '';
        $fieldrecord['FIELD_EXTRA1'] = UserRequest::$post[$c . '_extra1'];
        $fieldrecord['FIELD_EXTRA2'] = UserRequest::$post[$c . '_extra2'];
        $fieldrecord['FIELD_EXTRA3'] = UserRequest::$post[$c . '_extra3'];
        $fieldrecord['FIELD_EXTRA4'] = UserRequest::$post[$c . '_extra4'];
        $fieldrecord['FIELD_EXTRA5'] = '';
    }

// End method
    function loadPanel(&$fieldrecord, $values) {
        $c = $this->code;
        if ($values['FIELDTYPE'] == $c) {
		  $fieldrecord[$c . '_required'] = $values['FIELD_REQUIRED'];
		  $fieldrecord[$c . '_extra1'] = $values['FIELD_EXTRA1'];
		  $fieldrecord[$c . '_extra2'] = $values['FIELD_EXTRA2'];
		  $fieldrecord[$c . '_extra3'] = $values['FIELD_EXTRA3'];
		  $fieldrecord[$c . '_extra4'] = $values['FIELD_EXTRA4'];
		  $fieldrecord[$c . '_extra5'] = $values['FIELD_EXTRA5'];
        } else {
		  $this->defaultRecord($fieldrecord);
        }
    }

// End method
    function defaultRecord(&$fieldrecord) {
        $c = $this->code;
        $fieldrecord[$c . '_size'] = CLX_INIT_ZERO;
        $fieldrecord[$c . '_required'] = CLX_INIT_ZERO;
        $fieldrecord[$c . '_format'] = '';
        $fieldrecord[$c . '_align'] = CLX_INIT_ZERO;
        $fieldrecord[$c . '_default'] = '';
        $fieldrecord[$c . '_minvalue'] = '';
        $fieldrecord[$c . '_maxvalue'] = '';
        $fieldrecord[$c . '_extra1'] = 'CLX_';
        $fieldrecord[$c . '_extra2'] = '';
        $fieldrecord[$c . '_extra3'] = '';
        $fieldrecord[$c . '_extra4'] = '';
        $fieldrecord[$c . '_extra5'] = '';
    }

// End method
    function viewForm(&$table, $record) {
        $yesno = array(CLX_NUM_ZERO => dict('GEN_LBL_NO'), CLX_NUM_ONE => dict('GEN_LBL_YES'));
        $table->addData(dict('GEN_LBL_TYPE') . ':', $this->name);
        $table->addData(dict('GEN_LBL_REQUIRED') . ':', $yesno[$record['SLUK_required']]);
        $table->addData(dict('GEN_LBL_TABLE') . ':', $record['SLUK_extra1']);
        $table->addData(dict('GEN_LBL_PRIMARY_SEARCH_FIELD') . ':', $record['SLUK_extra2']);
        $table->addData(dict('GEN_LBL_SECONDARY_SEARCH_FIELD') . ':', $record['SLUK_extra3']);
        $table->addData(dict('GEN_LBL_DEFAULT_ID') . ':', $record['SLUK_extra4']);
    }

// End method
    function fieldProperties($fieldrecord) {
        $props = array();
        // DB implementation
        switch (kDatabaseType) {
		  case 'oci':
			 $props['type'] = 'NUMBER(11)';
			 break;
		  default:
			 $props['type'] = 'INT(11) UNSIGNED';
			 break;
        }
        if ($fieldrecord['FIELD_DEFAULT'] === 'null' || strlen($fieldrecord['FIELD_DEFAULT']) == CLX_NUM_ZERO) {
		  $props['default'] = 'null';
        } else {
		  $props['default_raw'] = $fieldrecord['FIELD_DEFAULT'];
		  $props['default'] = singleQuote($fieldrecord['FIELD_DEFAULT']);
        }
        $props['properties'] = '';
        $props['null'] = ($fieldrecord['FIELD_REQUIRED']) ? 'NO' : 'YES';
        return $props;
    }

// End method
}
