<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-09-22 12:16:08 -0400 (Sat, 22 Sep 2018) $
 * @version        $Rev: 10120 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
if (!class_exists('util') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'util.php';

class util_dbaudit extends util {

    var $dump_import_sql_script = false;

    function __construct() {
        $this->code = 'DBAU';
        $this->name = 'Audit Database';
        $this->type = 'UTIL';
        $this->version = '0.2.8.0';
        $this->description = 'This utility will audit the database.';
        $this->haspanel = true;
        $this->tablename = 'CLX_LOGGER';
        $this->batch = false;
        $this->panelform = array(CLX_CLASS_TITLE => 'UTIL_DBAU_TITLE_EXECUTE', CLX_CLASS_SUBTITLE => 'UTIL_DBAU_TITLE_EXPLAIN', 'button_labels' => array('SUBMIT' => dict('GEN_LBL_EXECUTE'), 'CANCEL' => dict('GEN_LBL_CANCEL')),
		  'panels' => array(
			 array(
			     'type' => 'normal',
			     'entries' => array(
			         array(
					   'label' => 'GEN_LBL_FIX_ERRORS',
					   'fields' => array(
						  array('name' => 'fix', 'type' => CLX_CLASS_LIST,
						      'options' => array(
								'0' => 'GEN_LBL_NO',
								'1' => 'GEN_LBL_YES'
						      )
						  )
					   )
			         ),
			         array(
					   'label' => 'GEN_LBL_TEST',
					   'fields' => array(
						  array('name' => 'tools', 'type' => 'checkbox', 'checked' => '1', CLX_CLASS_PROMPT => 'GEN_LBL_TOOLS', 'value' => ''),
						  array('name' => 'tables', 'type' => 'checkbox', 'checked' => '1', CLX_CLASS_PROMPT => 'GEN_LBL_TABLES', 'value' => ''),
						  array('name' => 'procedures_functions', 'type' => 'checkbox', 'checked' => '0', CLX_CLASS_PROMPT => 'GEN_LBL_PROCEDURES_FUNCTIONS', 'value' => ''),
						  array('name' => 'dynrel', 'type' => 'checkbox', 'checked' => '0', CLX_CLASS_PROMPT => 'GEN_LBL_DYNAMIC_RELATIONS', 'value' => ''),
						  array('name' => 'activeonly', 'type' => 'checkbox', 'checked' => '1', CLX_CLASS_PROMPT => 'GEN_LBL_ACTIVE_ONLY', 'value' => '1'),
						  array('name' => 'dynreldata', 'type' => 'checkbox', 'checked' => '0', CLX_CLASS_PROMPT => 'GEN_LBL_DYNREL_INTEGRITY', 'value' => '')
					   )
			         ), array(
					   'label' => 'GEN_LBL_ADDITIONALOPTS',
					   'fields' => array(
						  array('name' => 'dropfields', 'type' => 'checkbox', 'checked' => '0', CLX_CLASS_PROMPT => 'GEN_LBL_DROPFIELDS', 'value' => '1'),
						  array('name' => 'fieldsonly', 'type' => 'checkbox', 'checked' => '0', CLX_CLASS_PROMPT => 'GEN_LBL_FIELDS_ONLY', 'value' => '1'),
						  array('name' => 'indexesonly', 'type' => 'checkbox', 'checked' => '0', CLX_CLASS_PROMPT => 'GEN_LBL_INDEXES_ONLY', 'value' => '1'),
						  array('name' => 'compile', 'type' => 'checkbox', 'checked' => '1', CLX_CLASS_PROMPT => 'GEN_LBL_COMPILE', 'value' => '1')
					   )
			         ), array(
					   'label' => 'GEN_LBL_BATCH',
					   'fields' => array(
						  array('name' => 'batch', 'type' => 'checkbox', 'checked' => '1', CLX_CLASS_PROMPT => 'GEN_LBL_BATCH_OP', 'value' => '')
					   )
			         ),
			         array(
					   'label' => 'GEN_LBL_SAVE_REPORT',
					   'fields' => array(
						  array('name' => 'filename', 'type' => 'string', 'size' => '255', 'displaysize' => '48', 'prefix' => 'GEN_LBL_MSEXCELFILE')
					   )
			         )
			     )
			 )
		  )
        );
		$this->debugAU=false;
		IF (ISSET($GLOBALS['ADDRDEBUGAUDIT']) && $GLOBALS['ADDRDEBUGAUDIT']==$_SERVER['REMOTE_ADDR']) {
			$this->debugAU=true;
		}
    }

    function execute_() {
        if (!empty(UserRequest::$request[$this->code . '_batch'])) {
		  return $this->createAudit();
        } else {
		  return $this->audit();
        }
    }

    function audit() {
        UserResponse::setIgnoreUserAbort(CLX_NUM_ONE);
        UserResponse::setRunTimeLimit(CLX_NUM_24 * CLX_NUM_60 * CLX_NUM_TWO);
		print '	init fix' . CLX_CHAR_NL;
		$fix = UserRequest::$request[$this->code . '_fix'];
        
		$filename = UserRequest::$request[$this->code . '_filename'];
        
		print '	init contents' . CLX_CHAR_NL;
		$contents = '';
        //   - Audit dump to .SQL Script file instead of excecuting SQL senences directly
		echo CLX_NUM_ONE;
		if (defined('UTIL_DUMP_AUPK_SQL_SCRIPT'))
			$this->dump_import_sql_script = ( UTIL_DUMP_AUPK_SQL_SCRIPT === strval(CLX_NUM_ONE));
		else
			$this->dump_import_sql_script = strval(CLX_NUM_ONE);
		print '	init flmsg' . CLX_CHAR_NL;
        $flmsg = '';
		print '	dump' . CLX_CHAR_NL;
			 
        if ($this->dump_import_sql_script === true) {
		  ClxCommon::$db->scriptFileOut = kPathToTemp . clx_mcript('AUDIT_' . $filename) . '.sql';
		  $flmsg = '<br>' . dict('GEN_LBL_TO') . ' <a href=' . singleQuote(clxCommon::$db->scriptFileOut) . ' target=_blank>' . ClxCommon::$db->scriptFileOut . '</a>';
        }
        $htmltable = new htmlTable(CLX_WIDTH_FOUR);
        $htmltable->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));

        $htmltable->addCell(dict('GEN_LBL_RESULTS'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_FOUR));
        $fd = null;
        if (strlen($filename) > CLX_NUM_ZERO) {
		  if (($fd = fopen($filename, 'w')) === false) {
			 $htmltable->addCell('Can' . CLX_CHAR_SINGLE_QUOTE . 't open file: ' . $filename . '.  The report was not saved.', array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_FOUR));
		  }
        }
        $contents .= $htmltable->source();
		print ' drop fields' . CLX_CHAR_NL;
			 
        $drop_fields = (!empty(UserRequest::$request[$this->code . '_dropfields'])) ? true : false;
        $fields_only = (!empty(UserRequest::$request[$this->code . '_fieldsonly'])) ? true : false;
        $indexes_only = (!empty(UserRequest::$request[$this->code . '_indexesonly'])) ? true : false;
		$activeonly = (!empty(UserRequest::$request[$this->code . '_activeonly'])) ? true : false;
		
        $compile = (!empty(UserRequest::$request[$this->code . '_compile'])) ? true : false;
        if (!empty(UserRequest::$request[$this->code . '_tools']))
		  $contents .= $this->checkTools($fix, $fd, $fields_only, $indexes_only);
        if (!empty(UserRequest::$request[$this->code . '_tables']))
		  $contents .= $this->checkTables($fix, $fd, $drop_fields, $fields_only, $indexes_only,$activeonly);
        if (!empty(UserRequest::$request[$this->code . '_procedures_functions']))
		  $contents .= $this->checkProceduresFunctions($fix, $fd);
        if (!empty(UserRequest::$request[$this->code . '_dynrel']))
		  $contents .= $this->checkDynamicRelationDefinitions($fix, $fd);
        if (!empty(UserRequest::$request[$this->code . '_dynreldata']))
		  $contents .= $this->checkDynamicRelations($fix, $fd);
		
		
        // Control Buttons
        if ($this->batch != true) {
		  $htmltable = new htmlTable(CLX_WIDTH_FIVE);
		  $htmltable->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
		  $buttons = '';
		  $c = new HTMLButtonCancel(dict('GEN_LBL_RETURN'));
		  $buttons .= $c->source();
		  $htmltable->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_FIVE));
		  $contents .= $htmltable->source();
        }
        if ($fd != null)
		  fclose($fd);
		print '	closing fd'. CLX_CHAR_NL;
			 
        //   - Audit dump to .SQL Script file instead of excecuting SQL senences directly
        if ($this->dump_import_sql_script === true) {
		  $contents .= '<br><br>' . note(dict('GEL_LBL_OPER_COMP_SUCCESS') . ' ' . $flmsg, 'OK');
        }

        if($compile){
		  $CODE = &getTool('CODE');
		  $contents .= '<br>'.$CODE->compileEmbededPhpSourcesRun();
        }

        return $contents;
    }

    function createAudit() {
        $request = array();
        if (!empty(UserRequest::$request[$this->code . '_fix'])) {
		  $request[$this->code . '_fix'] = UserRequest::$request[$this->code . '_fix'];
        } else {
		  $request[$this->code . '_fix'] = '';
        };
        if (!empty(UserRequest::$request[$this->code . '_filename'])) {
		  $request[$this->code . '_filename'] = UserRequest::$request[$this->code . '_filename'];
        } else {
		  $request[$this->code . '_filename'] = '';
        };
        if (!empty(UserRequest::$request[$this->code . '_dropfields'])) {
		  $request[$this->code . '_dropfields'] = UserRequest::$request[$this->code . '_dropfields'];
        } else {
		  $request[$this->code . '_dropfields'] = '';
        };
        if (!empty(UserRequest::$request[$this->code . '_fieldsonly'])) {
		  $request[$this->code . '_fieldsonly'] = UserRequest::$request[$this->code . '_fieldsonly'];
        } else {
		  $request[$this->code . '_fieldsonly'] = '';
        };
        if (!empty(UserRequest::$request[$this->code . '_indexesonly'])) {
		  $request[$this->code . '_indexesonly'] = UserRequest::$request[$this->code . '_indexesonly'];
        } else {
		  $request[$this->code . '_indexesonly'] = '';
        };

        if (!empty(UserRequest::$request[$this->code . '_tools'])) {
		  $request[$this->code . '_tools'] = UserRequest::$request[$this->code . '_tools'];
        } else {
		  $request[$this->code . '_tools'] = '';
        };
        if (!empty(UserRequest::$request[$this->code . '_tables'])) {
		  $request[$this->code . '_tables'] = UserRequest::$request[$this->code . '_tables'];
        } else {
		  $request[$this->code . '_tables'] = '';
        };
        if (!empty(UserRequest::$request[$this->code . '_procedures_functions'])) {
		  $request[$this->code . '_procedures_functions'] = UserRequest::$request[$this->code . '_procedures_functions'];
        } else {
		  $request[$this->code . '_procedures_functions'] = '';
        };
        if (!empty(UserRequest::$request[$this->code . '_dynrel'])) {
		  $request[$this->code . '_dynrel'] = UserRequest::$request[$this->code . '_dynrel'];
        } else {
		  $request[$this->code . '_dynrel'] = '';
        };
        if (!empty(UserRequest::$request[$this->code . '_dynreldata'])) {
		  $request[$this->code . '_dynreldata'] = UserRequest::$request[$this->code . '_dynreldata'];
        } else {
		  $request[$this->code . '_dynreldata'] = '';
        };
        if (!empty(UserRequest::$request[$this->code . '_compile'])) {
		  $request[$this->code . '_compile'] = UserRequest::$request[$this->code . '_compile'];
        } else {
		  $request[$this->code . '_compile'] = '';
        };
		if (!empty(UserRequest::$request[$this->code . '_activeonly'])) {
		  $request[$this->code . '_activeonly'] = UserRequest::$request[$this->code . '_activeonly'];
        } else {
		  $request[$this->code . '_activeonly'] = '';
        };
		
        //First we're going to save the data to make the audit later.
        $record = array();
        $record['CDATE'] = xFormat::getNow('Y-m-d H:i:s');
        $record['OWNERCODE'] = $this->code;
        $record['USERNAME'] = $_SESSION['user_record']['username'];
        $record['STATUS'] = 'IDLE';
        $record['PARAMETERS'] = implode('|', $request);
        //Then we create the record.
        ClxCommon::$db->createRecord($this->tablename, $record, false);
        //And we return something that doesn't really says anything.
        $htmltable = new htmlTable(CLX_WIDTH_FOUR);
        $htmltable->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $htmltable->addCell(dict('GEN_LBL_RESULTS'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_FOUR));
        $htmltable->addCell(dict('GEN_LBL_AUDIT_IDLE'), array(CLX_PROP_CLASS => '', CLX_PROP_COLSPAN => CLX_WIDTH_FOUR));
        $buttons = '';
        $c = new HTMLButtonCancel(dict('GEN_LBL_RETURN'));
        $buttons .= $c->source();
        $htmltable->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_FOUR));
        $contents = $htmltable->source();
        return $contents;
    }

    function runAudits() {
        ClxCommon::$db->commit();
        $this->batch = true;  
        print CLX_CHAR_NL . 'Checking for pending audits' . CLX_CHAR_NL; 
        $rs = ClxCommon::$db->getRecords($this->tablename, 'OWNERCODE = ' . singleQuote($this->code), 'STATUS =' . singleQuote('IDLE'));
		while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  print '	Executing Audit ' . $r['ID'] . CLX_CHAR_NL;
		  $record = array('STATUS' => 'RUN');
		  ClxCommon::$db->updateRecord($this->tablename, $record, 'ID = ' . singleQuote($r['ID']));
		  ClxCommon::$db->commit();
		  print '	Loading audit data' . CLX_CHAR_NL;
		  $parameters = explode('|', $r['PARAMETERS']);
		  UserRequest::$request[$this->code . '_fix'] = $parameters[CLX_NUM_ZERO];
		  UserRequest::$request[$this->code . '_filename'] = $parameters[CLX_NUM_ONE];
		  UserRequest::$request[$this->code . '_dropfields'] = $parameters[CLX_NUM_TWO];
		  UserRequest::$request[$this->code . '_fieldsonly'] = $parameters[CLX_NUM_THREE];
		  UserRequest::$request[$this->code . '_indexesonly'] = $parameters[CLX_NUM_FOUR];
		  UserRequest::$request[$this->code . '_tools'] = $parameters[CLX_NUM_FIVE];
		  UserRequest::$request[$this->code . '_tables'] = $parameters[CLX_NUM_SIX];
		  UserRequest::$request[$this->code . '_procedures_functions'] = $parameters[CLX_NUM_7];
		  UserRequest::$request[$this->code . '_dynrel'] = $parameters[CLX_NUM_8];
		  UserRequest::$request[$this->code . '_dynreldata'] = $parameters[CLX_NUM_NINE];
		  UserRequest::$request[$this->code . '_compile'] = $parameters[CLX_NUM_TEN];
			UserRequest::$request[$this->code . '_activeonly'] = $parameters[CLX_NUM_11];
		  print '	Auditing' . CLX_CHAR_NL;
		  $_SESSION['silent'] = true;
		  try {
			 print '	Call audit here' . CLX_CHAR_NL;
			 $result = $this->audit();
			 print '	Saving results' . CLX_CHAR_NL;
			 
				$record['STATUS'] = 'END';
			 $record['RESULT'] = $result;
		  } catch (Exception $error) {
			 print '	There was an error, please check the log for details.' . CLX_CHAR_NL;
			 $record['STATUS'] = 'ERROR';
			 $record['RESULT'] = $error->getMessage();
		  }
		  $_SESSION['silent'] = false;
		  unset($_SESSION['silent']);
		  ClxCommon::$db->updateRecord($this->tablename, $record, 'ID = ' . singleQuote($r['ID']));
		  ClxCommon::$db->commit();
		  print '	Finishing Audit ' . $r['ID'] . CLX_CHAR_NL;
        }
		ClxCommon::$db->review_and_delete_old_tmp();
        print 'Done with the audits' . CLX_CHAR_NL;
    }

    function checkTools($fix, $fd, $drop_fields = false, $fields_only = false, $indexes_only = false) {
        $MAGR = &getTool('MAGR');
        $inited = false;
        $htmltable = new htmlTable(CLX_WIDTH_FOUR);
        $htmltable->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $records = ClxCommon::$db->getRecords('CLX_TOOLS', '1=1 ORDER BY IDCODE');
        while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
			IF (!in_array(  $record['IDCODE'],array('DICA','EDIT','MATE','UISK','USIF','UTIL'))) {
				$msg = $MAGR->checkTable($record, $fix, $drop_fields, $fields_only, $indexes_only, $this->dump_import_sql_script,true);
		 	}
		  if (empty($inited) && count($msg) > CLX_NUM_ZERO) {
			 $htmltable->addCell(dict('GEN_LBL_TOOLS'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_FOUR));
			 $htmltable->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_TABLE'), dict('GEN_LBL_FIELD'), dict('GEN_LBL_ERROR'), dict('GEN_LBL_COMMENTS')));
			 $inited = true;
			 if ($fd != null) {
			     fwrite($fd, dict('GEN_LBL_TOOLS') . CLX_CHAR_NL);
			     fwrite($fd, dict('GEN_LBL_TABLE') . CLX_CHAR_TAB . dict('GEN_LBL_FIELD') . CLX_CHAR_TAB . dict('GEN_LBL_ERROR') . CLX_CHAR_TAB . dict('GEN_LBL_COMMENTS') . CLX_CHAR_NL);
			 }
		  }
		  $i = CLX_INIT_ZERO;
		  foreach ($msg as $line) {
			 $htmltable->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array($line['tablename'], $line['fieldname'], $line['error'], $line['comments']));
			 if ($fd != null) {
			     fwrite($fd, $line['tablename'] . CLX_CHAR_TAB . $line['fieldname'] . CLX_CHAR_TAB . $line['error'] . CLX_CHAR_TAB . $line['comments'] . CLX_CHAR_NL);
			 }
			 $i++;
		  }
        }
        ClxCommon::$db->freeResult($records);
        if (empty($inited)) {
		  $htmltable->addCell(dict('GEN_LBL_TOOLS'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_FOUR));
		  $htmltable->addCell(dict('GEN_LBL_NOERRORFOUND'), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_FOUR));
        }
        return $htmltable->source();
    }

    function checkTables($fix, $fd, $drop_fields = false, $fields_only = false, $indexes_only = false,$activeonly = true) {
        $DBTB = &getTool('DBTB');
        $inited = false;
        $htmltable = new htmlTable(CLX_WIDTH_FOUR);
        $htmltable->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
		$AND='';
		IF ($activeonly == true) {
        $cc = ' STATUS = 1 ';
			$AND=' AND ';
		}
        if (kDatabaseType <> 'oci') {
		  $cc .= $AND.' TYPE <>' . singleQuote('TEMP') . ' ';
			$AND=' AND ';
        }
        $cc .= $AND.' TYPE <>' . singleQuote('VIEW') . ' ';
        $records = ClxCommon::$db->getRecords('CLX_DB_TABLES', $cc);
        $contar=0;
		if ($this->debugAU) {
			pre("audit sql ciclo");
			PRE($cc);
			die;
		
		}
		
        while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
		  if ($this->debugAU) {
				pre ('----'. ($contar++) .'----->audit records');
				pre($record);
			}
			$msg = $DBTB->checkTable($record, $fix, $drop_fields, $fields_only, $indexes_only, $this->dump_import_sql_script,true);
		  if (empty($inited) and count($msg) > CLX_NUM_ZERO) {
			 $htmltable->addCell(dict('GEN_LBL_TABLES'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_FOUR));
			 $htmltable->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_TABLE'), dict('GEN_LBL_FIELD'), dict('GEN_LBL_ERROR'), dict('GEN_LBL_COMMENTS')));
			 $inited = true;
			 if ($fd != null) {
			     fwrite($fd, dict('GEN_LBL_TABLES') . CLX_CHAR_NL);
			     fwrite($fd, dict('GEN_LBL_TABLE') . CLX_CHAR_TAB . dict('GEN_LBL_FIELD') . CLX_CHAR_TAB . dict('GEN_LBL_ERROR') . CLX_CHAR_TAB . dict('GEN_LBL_COMMENTS') . CLX_CHAR_NL);
			 }
		  }
		  $i = CLX_NUM_ZERO;
		  foreach ($msg as $line) {
			 $htmltable->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array($line['tablename'], $line['fieldname'], $line['error'], $line['comments']));
			 if ($fd != null) {
			     fwrite($fd, $line['tablename'] . CLX_CHAR_TAB . $line['fieldname'] . CLX_CHAR_TAB . $line['error'] . CLX_CHAR_TAB . $line['comments'] . CLX_CHAR_NL);
			 }
			 $i++;
		  }
        }
        $cc = 'TYPE =' . singleQuote('VIEW') . ' ';
		IF ($activeonly == true) {
			$cc .= ' AND  STATUS = 1 ';

		}
        $records = ClxCommon::$db->getRecords('CLX_DB_TABLES', $cc);
        while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
		  $msg = $DBTB->checkTable($record, $fix, $drop_fields, $fields_only, $indexes_only, $this->dump_import_sql_script);
		  if (empty($inited) and count($msg) > CLX_NUM_ZERO) {
			 $htmltable->addCell(dict('GEN_LBL_TABLES'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_FOUR));
			 $htmltable->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_TABLE'), dict('GEN_LBL_FIELD'), dict('GEN_LBL_ERROR'), dict('GEN_LBL_COMMENTS')));
			 $inited = true;
			 if ($fd != null) {
			     fwrite($fd, dict('GEN_LBL_TABLES') . CLX_CHAR_NL);
			     fwrite($fd, dict('GEN_LBL_TABLE') . CLX_CHAR_TAB . dict('GEN_LBL_FIELD') . CLX_CHAR_TAB . dict('GEN_LBL_ERROR') . CLX_CHAR_TAB . dict('GEN_LBL_COMMENTS') . CLX_CHAR_NL);
			 }
		  }
		  $i = CLX_NUM_ZERO;
		  foreach ($msg as $line) {
			 $htmltable->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array($line['tablename'], $line['fieldname'], $line['error'], $line['comments']));
			 if ($fd != null) {
			     fwrite($fd, $line['tablename'] . CLX_CHAR_TAB . $line['fieldname'] . CLX_CHAR_TAB . $line['error'] . CLX_CHAR_TAB . $line['comments'] . CLX_CHAR_NL);
			 }
			 $i++;
		  }
        }
        ClxCommon::$db->freeResult($records);
        if (empty($inited)) {
		  $htmltable->addCell(dict('GEN_LBL_TABLES'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_FOUR));
		  $htmltable->addCell(dict('GEN_LBL_NOERRORFOUND'), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_FOUR));
        }
        return $htmltable->source();
    }

    function checkProceduresFunctions($fix, $fd) {
        $this->status = array(
		  'GEN_LBL_INACTIVE',
		  'GEN_LBL_ACTIVE'
        );
        $this->db_type = array(
		  'any' => 'GEN_LBL_ANY',
		  'mysql' => 'GEN_LBL_MYSQL',
		  'mysqli' => 'GEN_LBL_MYSQL',
		  'oci' => 'GEN_LBL_OCI'
        );
        $DBPR = &getTool('DBPR');
        $sql = 'SELECT * FROM ' . $DBPR->tablename;
        $results = ClxCommon::$db->executeQuery($sql);
        $table = new htmlTable(CLX_WIDTH_FOUR);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('GEN_LBL_VERIFY_FUNCTION'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_FOUR));
        $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_PROCEDURES_OR_FUNCTIONS'), dict('GEN_LBL_OBJ_TYPE'), dict('GEN_LBL_DB_TYPE'), dict('GEN_LBL_COMMENTS')));
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
		  $rslt = '';
		  if (kDatabaseType === 'mysqli' && $result['DB_TYPE'] === 'mysql')
			 $result['DB_TYPE'] = 'mysqli';
		  if (($result['DB_TYPE'] === 'any') || ($result['DB_TYPE'] == kDatabaseType)) {
			 if ($result['OBJ_TYPE'] === 'PROCEDURE') {
			     $rslt = ClxCommon::$db->checkProcedure($result, $fix, $this->dump_import_sql_script);
			 } else {
			     $rslt = ClxCommon::$db->checkFunction($result, $fix, $this->dump_import_sql_script);
			 }
			 if ($rslt === true) {
			     if (!empty($fix)) {
			         $rslt = dict('GEN_LBL_PF_FIXED');
			     } else {
			         $rslt = dict('GEN_LBL_PF_CREATED');
			     }
			 } else {
			     if ($rslt === false) {
			         if (!empty($fix)) {
					   $rslt = dict('GEN_LBL_PF_NO_COMPILED');
			         } else {
					   $rslt = dict('GEN_LBL_PF_NOT_EXISTS');
			         }
			     }
			 }
		  } else {
			 $rslt = dict('GEN_LBL_INCOMPATIBLE_DATABASE');
		  }
		  $table->addCells(CLX_CLASS_DATA, array($result['IDCODE'], $result['OBJ_TYPE'], dict($this->db_type[$result['DB_TYPE']]), $rslt));
        }
        return $table->source();
    }

    function checkDynamicRelationDefinitions($fix, $fd) {
        $inited = false;
        $htmltable = new htmlTable(CLX_WIDTH_SIX);
        $htmltable->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $rs = ClxCommon::$db->getRecords('CLX_DB_DYNRELATIONS', 'ACTIVE = 1  AND RELATION_TYPE = 0');
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  $msg = $this->checkDynamicRelationDefinition($r, $fix);
		  if (empty($inited) and count($msg) > CLX_NUM_ZERO) {
			 $htmltable = new htmlTable(CLX_WIDTH_SIX);
			 $htmltable->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
			 $htmltable->addCell(dict('GEN_LBL_DYNAMIC_RELATIONS'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_SIX));
			 $htmltable->addCells(CLX_CLASS_HEADERS, array(
			     dict('GEN_LBL_PARENT_TABLECODE'),
			     dict('GEN_LBL_CHILD_TABLECODE'),
			     dict('GEN_LBL_REL_TABLECODE'),
			     dict('GEN_LBL_FIELD'),
			     dict('GEN_LBL_ERROR'),
			     dict('GEN_LBL_COMMENTS')));
			 $inited = true;
			 if ($fd != null) {
			     $l = dict('GEN_LBL_DYNAMIC_RELATIONS') . CLX_CHAR_NL;
			     $l .= dict('GEN_LBL_PARENT_TABLECODE') . CLX_CHAR_TAB;
			     $l .= dict('GEN_LBL_CHILD_TABLECODE') . CLX_CHAR_TAB;
			     $l .= dict('GEN_LBL_REL_TABLECODE') . CLX_CHAR_TAB;
			     $l .= dict('GEN_LBL_FIELD') . CLX_CHAR_TAB;
			     $l .= dict('GEN_LBL_ERROR') . CLX_CHAR_TAB;
			     $l .= dict('GEN_LBL_COMMENTS') . CLX_CHAR_NL;
			     fwrite($fd, $l);
			 }
		  }
		  $i = CLX_NUM_ZERO;
		  foreach ($msg as $line) {
			 $htmltable->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array(
			     $line['parent'],
			     $line['child'],
			     $line['rel'],
			     $line['FIELD'],
			     $line['ERROR'],
			     $line['comments']));
			 if ($fd != null) {
			     fwrite($fd, $line['parent'] . CLX_CHAR_TAB .
					   $line['child'] . CLX_CHAR_TAB .
					   $line['rel'] . CLX_CHAR_TAB .
					   $line['FIELD'] . CLX_CHAR_TAB .
					   $line['ERROR'] . CLX_CHAR_TAB .
					   $line['comments'] . CLX_CHAR_NL);
			 }
			 $i++;
		  }
        }
        if (empty($inited)) {
		  $htmltable->addCell(dict('GEN_LBL_DYNAMIC_RELATIONS'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_SIX));
		  $htmltable->addCell(dict('GEN_LBL_NOERRORFOUND'), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_SIX));
        }
        return $htmltable->source();
    }

    function checkDynamicRelationDefinition($record, $fix) {
        $msg = array();
        $parent = $record['PARENT_TABLECODE'];
        $child = $record['CHILD_TABLECODE'];
        $rel = $record['TABLECODE'];
        $error = array('parent' => $parent, 'child' => $child, 'rel' => $rel);
        if (ClxCommon::$db->oneExistsRecords('CLX_DB_TABLES', 'IDCODE=' . singleQuote($record['PARENT_TABLECODE'])) == CLX_NUM_ZERO) {
		  $error['FIELD'] = CLX_CHAR_SINGLE_QUOTE;
		  $error['ERROR'] = dict('GEN_ERR_TABLE_DOES_NOT_EXISTS');
		  $error['comments'] = dict('GEN_LBL_PARENT_TABLECODE') . ': ' . $record['PARENT_TABLECODE'];
		  $msg[] = $error;
        }
        if (ClxCommon::$db->oneExistsRecords('CLX_DB_TABLES', 'IDCODE=' . singleQuote($record['CHILD_TABLECODE'])) == CLX_NUM_ZERO) {
		  $error['FIELD'] = CLX_CHAR_SINGLE_QUOTE;
		  $error['ERROR'] = dict('GEN_ERR_TABLE_DOES_NOT_EXISTS');
		  $error['comments'] = dict('GEN_LBL_CHILD_TABLECODE') . ': ' . $record['CHILD_TABLECODE'];
		  $msg[] = $error;
        }
        if (ClxCommon::$db->oneExistsRecords('CLX_DB_TABLES', 'IDCODE=' . singleQuote($record['TABLECODE'])) == CLX_NUM_ZERO) {
		  $error['FIELD'] = CLX_CHAR_SINGLE_QUOTE;
		  $error['ERROR'] = dict('GEN_ERR_TABLE_DOES_NOT_EXISTS');
		  $error['comments'] = dict('GEN_LBL_REL_TABLECODE') . ': ' . $record['TABLECODE'];
		  $msg[] = $error;
        }
        //checking parent fields
        if (ClxCommon::$db->oneExistsRecords('CLX_DB_TABLEFIELDS', 'TABLECODE=' . singleQuote($record['PARENT_TABLECODE']) . ' AND FIELDNAME=' . singleQuote($record['PARENT_FIELDNAME'])) == CLX_NUM_ZERO) {
		  $error['FIELD'] = $record['PARENT_FIELDNAME'];
		  $error['ERROR'] = dict('GEN_ERR_FIELD_DOES_NOT_EXISTS');
		  $error['comments'] = dict('GEN_LBL_PARENT_FIELDNAME') . ': ' . $record['PARENT_TABLECODE'] . '.' . $record['PARENT_FIELDNAME'];
		  $msg[] = $error;
        }
        if (ClxCommon::$db->oneExistsRecords('CLX_DB_TABLEFIELDS', 'TABLECODE=' . singleQuote($record['CHILD_TABLECODE']) . ' AND FIELDNAME=' . singleQuote($record['CHILD_FIELDNAME'])) == CLX_NUM_ZERO) {
		  $error['FIELD'] = $record['CHILD_FIELDNAME'];
		  $error['ERROR'] = dict('GEN_ERR_FIELD_DOES_NOT_EXISTS');
		  $error['comments'] = dict('GEN_LBL_CHILD_FIELDNAME') . ': ' . $record['CHILD_TABLECODE'] . '.' . $record['CHILD_FIELDNAME'];
		  $msg[] = $error;
        }
        if (ClxCommon::$db->oneExistsRecords('CLX_DB_TABLEFIELDS', 'TABLECODE=' . singleQuote($record['TABLECODE']) . ' AND FIELDNAME=' . singleQuote($record['RELT_PFIELD'])) == CLX_NUM_ZERO) {
		  $error['FIELD'] = $record['RELT_PFIELD'];
		  $error['ERROR'] = dict('GEN_ERR_FIELD_DOES_NOT_EXISTS');
		  $error['comments'] = dict('GEN_LBL_RELTBL_PFIELD') . ': ' . $record['TABLECODE'] . '.' . $record['RELT_PFIELD'];
		  $msg[] = $error;
        }
        if (ClxCommon::$db->oneExistsRecords('CLX_DB_TABLEFIELDS', 'TABLECODE=' . singleQuote($record['TABLECODE']) . ' AND FIELDNAME=' . singleQuote($record['RELT_CFIELD'])) == CLX_NUM_ZERO) {
		  $error['FIELD'] = $record['RELT_CFIELD'];
		  $error['ERROR'] = dict('GEN_ERR_FIELD_DOES_NOT_EXISTS');
		  $error['comments'] = dict('GEN_LBL_RELTBL_CFIELD') . ': ' . $record['TABLECODE'] . '.' . $record['RELT_CFIELD'];
		  $msg[] = $error;
        }
        if (ClxCommon::$db->oneExistsRecords('CLX_DB_TABLEFIELDS', 'TABLECODE=' . singleQuote($record['TABLECODE']) . ' AND FIELDNAME=' . singleQuote('PARENT_TABLECODE')) == CLX_NUM_ZERO) {
		  $error['FIELD'] = 'PARENT_TABLECODE';
		  $error['ERROR'] = dict('GEN_ERR_FIELD_DOES_NOT_EXISTS');
		  $error['comments'] = dict('GEN_LBL_PARENT_TABLECODE') . ': ' . $record['TABLECODE'] . '.' . 'PARENT_TABLECODE';
		  $msg[] = $error;
        }
        if (ClxCommon::$db->oneExistsRecords('CLX_DB_TABLEFIELDS', 'TABLECODE=' . singleQuote($record['TABLECODE']) . ' AND FIELDNAME=' . singleQuote('CHILD_TABLECODE')) == CLX_NUM_ZERO) {
		  $error['FIELD'] = 'CHILD_TABLECODE';
		  $error['ERROR'] = dict('GEN_ERR_FIELD_DOES_NOT_EXISTS');
		  $error['comments'] = dict('GEN_LBL_CHILD_TABLECODE') . ': ' . $record['TABLECODE'] . '.' . 'CHILD_TABLECODE';
		  $msg[] = $error;
        }
        if ($record['EXCLUSIVES'] == CLX_NUM_ZERO && empty($record['SRCH_LISTING'])) {
		  $error['FIELD'] = '';
		  $error['ERROR'] = dict('GEN_ERR_MISSING_SRCH_LISTING');
		  $error['comments'] = dict('GEN_LBL_ADD_SRCH_LISTING');
		  $msg[] = $error;
        }
        if (!empty($record['SRCH_LISTING']) && ClxCommon::$db->oneExistsRecords('CLX_UI_LISTINGS', 'IDCODE=' . singleQuote($record['SRCH_LISTING'])) == CLX_NUM_ZERO) {
		  $error['FIELD'] = '';
		  $error['ERROR'] = dict('GEN_ERR_MISSING_SRCH_LISTING') . ': ' . $record['SRCH_LISTING'];
		  $error['comments'] = dict('GEN_LBL_ADD_SRCH_LISTING');
		  $msg[] = $error;
        }
        return $msg;
    }

    function checkDynamicRelations($fix, $fd) {
        $inited = false;
        $htmltable = new htmlTable(CLX_WIDTH_SIX);
        $htmltable->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $relations = ClxCommon::$db->getRecords('CLX_DB_DYNRELATIONS', 'ACTIVE=1  AND RELATION_TYPE = 0');
        while (($relation = ClxCommon::$db->getNextRecord($relations))) {
		  $msg = $this->checkDynamicRelation($relation, $fix);
		  if (empty($inited) and count($msg) > CLX_NUM_ZERO) {
			 $htmltable->addCell(dict('GEN_LBL_DYNAMIC_RELATION_INTEGRI'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_SIX));
			 $htmltable->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_PARENT_TABLECODE'), dict('GEN_LBL_PARENT_RECORDID'), dict('GEN_LBL_CHILD_TABLECODE'), dict('GEN_LBL_CHILD_RECORDID'), dict('GEN_LBL_ERROR'), dict('GEN_LBL_COMMENTS')));
			 $inited = true;
			 if ($fd != null) {
			     fwrite($fd, dict('GEN_LBL_DYNAMIC_RELATION_INTEGRI') . CLX_CHAR_NL);
			     fwrite($fd, dict('GEN_LBL_PARENT_TABLECODE') . CLX_CHAR_TAB . dict('GEN_LBL_PARENT_RECORDID') . CLX_CHAR_TAB . dict('GEN_LBL_CHILD_TABLECODE') . CLX_CHAR_TAB . dict('GEN_LBL_CHILD_RECORDID') . CLX_CHAR_TAB . dict('GEN_LBL_ERROR') . CLX_CHAR_TAB . dict('GEN_LBL_COMMENTS') . CLX_CHAR_NL);
			 }
		  }
		  $i = CLX_NUM_ZERO;
		  foreach ($msg as $line) {
			 $htmltable->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array($line['PARENT_TABLECODE'], $line['PARENT_RECORDID'], $line['CHILD_TABLECODE'], $line['CHILD_RECORDID'], $line['ERROR'], $line['comments']));
			 if ($fd != null) {
			     fwrite($fd, $line['PARENT_TABLECODE'] . CLX_CHAR_TAB . $line['PARENT_RECORDID'] . CLX_CHAR_TAB . $line['CHILD_TABLECODE'] . CLX_CHAR_TAB . $line['CHILD_RECORDID'] . CLX_CHAR_TAB . $line['ERROR'] . CLX_CHAR_TAB . $line['comments'] . CLX_CHAR_NL);
			 }
			 $i++;
		  }
        }
        if (empty($inited)) {
		  $htmltable->addCell(dict('GEN_LBL_DYNAMIC_RELATION_INTEGRI'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_SIX));
		  $htmltable->addCell(dict('GEN_LBL_NOERRORFOUND'), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_SIX));
        }
        return $htmltable->source();
    }

    function checkDynamicRelation($rel_rec, $fix) {
        if (empty($rel_rec)) {
		  return array('ERROR' => 'NO RELATION FOUND', 'COMMENTS' => '');
        }
        
        $rtablename = tableName($rel_rec['TABLECODE']);
        if (empty($rtablename)) {
		  return array('ERROR' => 'NO RELATED TABLE FOUND', 'COMMENTS' => '');
        }
        //Delete relation records where parent tablecode do not exists
        $sql = 'SELECT DISTINCT  R.PARENT_TABLECODE,  R.CHILD_TABLECODE, R.' . $rel_rec['RELT_PFIELD'] . ' PARENT_RECORDID, R.' . $rel_rec['RELT_CFIELD'] . ' CHILD_RECORDID FROM  '.$rtablename.' R LEFT JOIN  CLX_DB_TABLES DBTB ON R.PARENT_TABLECODE = DBTB.IDCODE WHERE  DBTB.IDCODE IS NULL';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  $error = $r;
		  $error['ERROR'] = dict('GEN_ERR_PARENT_TABLE_DOES_NOT_EX');
		  $error['comments'] = '';
		  if (!empty($fix)) {
			 if ($this->dump_import_sql_script === true)
			     ClxCommon::$db->dumpScript = true;
			 $sql = 'DELETE FROM ' . $rtablename . '   WHERE PARENT_TABLECODE = ' . singleQuote($r['PARENT_TABLECODE']) . '  OR PARENT_TABLECODE IS NULL';
			 ClxCommon::$db->executeQuery($sql);
			 if ($this->dump_import_sql_script === true)
			     ClxCommon::$db->dumpScript = false;
			 $error['comments'] = dict('GEN_LBL_FIXED');
		  }
		  $msg[] = $error;
        }
        //Delete relation where child tablecode donot exists
        $sql = 'SELECT DISTINCT  R.PARENT_TABLECODE,  R.CHILD_TABLECODE, R.' . $rel_rec['RELT_PFIELD'] . ' PARENT_RECORDID, R.' . $rel_rec['RELT_CFIELD'] . ' CHILD_RECORDID FROM  '.$rtablename.' R LEFT JOIN  CLX_DB_TABLES DBTB ON R.CHILD_TABLECODE = DBTB.IDCODE WHERE  DBTB.IDCODE IS NULL';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  $error = $r;
		  $error['ERROR'] = dict('GEN_ERR_CHILD_REC_DOES_NOT_EXISTS');
		  $error['comments'] = '';
		  if (!empty($fix)) {
			 if ($this->dump_import_sql_script === true)
			     ClxCommon::$db->dumpScript = true;
			 $sql = 'DELETE FROM ' . $rtablename . '   WHERE CHILD_TABLECODE = ' . singleQuote($r['CHILD_TABLECODE']) . ' OR CHILD_TABLECODE IS NULL';
			 ClxCommon::$db->executeQuery($sql);
			 $error['comments'] = dict('GEN_LBL_FIXED');
			 if ($this->dump_import_sql_script === true)
			     ClxCommon::$db->dumpScript = false;
		  }
		  $msg[] = $error;
        }
        //Delete parent record where record donot exists
        $ptablename = tableName($rel_rec['PARENT_TABLECODE']);
        if (empty($ptablename)) {
		  return array('ERROR' => 'NO PARENT TABLE FOUND', 'COMMENTS' => '');
        }
        $sql = 'SELECT DISTINCT  R.PARENT_TABLECODE,  R.CHILD_TABLECODE, R.' . $rel_rec['RELT_PFIELD'] . ' PARENT_RECORDID, R.' . $rel_rec['RELT_CFIELD'] . ' CHILD_RECORDID FROM  '.$rtablename.' R LEFT JOIN  ' . $ptablename . ' TB ON R.' . $rel_rec['RELT_PFIELD'] . ' = TB.' . $rel_rec['PARENT_FIELDNAME'] . ' WHERE  TB.' . $rel_rec['PARENT_FIELDNAME'] . ' IS NULL';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  $error = $r;
		  $error['ERROR'] = dict('GEN_ERR_PARENT_REC_DOES_NOT_EXISTS');
		  $error['comments'] = '';
		  if (!empty($fix)) {
			 if ($this->dump_import_sql_script === true)
			     ClxCommon::$db->dumpScript = true;
			 $sql = 'DELETE FROM ' . $rtablename . '   WHERE ' . $rel_rec['RELT_PFIELD'] . ' = ' . singleQuote($r['PARENT_RECORDID']) . '  OR ' . $rel_rec['RELT_PFIELD'] . ' IS NULL';
			 ClxCommon::$db->executeQuery($sql);
			 if ($this->dump_import_sql_script === true)
			     ClxCommon::$db->dumpScript = false;
			 $error['comments'] = dict('GEN_LBL_FIXED');
		  }
		  $msg[] = $error;
        }
        //Delete parent record where record donot exists
        $ctablename = tableName($rel_rec['CHILD_TABLECODE']);
        if (empty($ctablename)) {
		  return array('ERROR' => 'NO CHILD TABLE FOUND', 'COMMENTS' => '');
        }
        $sql = 'SELECT DISTINCT  R.PARENT_TABLECODE,  R.CHILD_TABLECODE, R.' . $rel_rec['RELT_PFIELD'] . ' PARENT_RECORDID, R.' . $rel_rec['RELT_CFIELD'] . ' CHILD_RECORDID FROM  '.$rtablename.' R LEFT JOIN  ' . $ctablename . ' TB ON R.' . $rel_rec['RELT_CFIELD'] . ' = TB.' . $rel_rec['CHILD_FIELDNAME'] . ' WHERE  TB.' . $rel_rec['CHILD_FIELDNAME'] . ' IS NULL';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  $error = $r;
		  $error['ERROR'] = dict('GEN_ERR_CHILD_REC_DOES_NOT_EXISTS');
		  $error['comments'] = '';
		  if (!empty($fix)) {
			 if ($this->dump_import_sql_script === true)
			     ClxCommon::$db->dumpScript = true;
			 $sql = 'DELETE FROM ' . $rtablename . '  WHERE ' . $rel_rec['RELT_CFIELD'] . ' = ' . singleQuote($r['CHILD_RECORDID']) . '  OR ' . $rel_rec['RELT_CFIELD'] . ' IS NULL';
			 ClxCommon::$db->executeQuery($sql);
			 if ($this->dump_import_sql_script === true)
			     ClxCommon::$db->dumpScript = false;
			 $error['comments'] = dict('GEN_LBL_FIXED');
		  }
		  $msg[] = $error;
        }
        return $msg;
    }

}
