<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
if (!class_exists('util') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'util.php';

class util_dict_clear_duplicate extends util {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'DICD';
        $this->name = 'Delete Dictionary Duplicate Entries';
        $this->type = 'UTIL';
        $this->version = '1.0.0.0';
        $this->description = 'Clear all  duplicates entries on dictionary table.';
        $this->haspanel = false;
    }

    function execute_() {
        pushHistory($this->code, 'IGNORE_THIS_ENTRY', CLX_NUM_ZERO);
        $contents = '';
        $DBLT = & getTool('DBLT');
        $langs = $DBLT->getListAsArray('LANG');
        $lang = array();
        foreach ($langs as $key => $val) {
			$key=clx_language_lower_upper($key);
		  $lang[] = $key;
		  $in = array();
		  //Search Duplicate Entries
		  $sql = 'SELECT ENTRY, LANGUAGE, COUNT(*)  FROM CLX_DICTIONARY WHERE LANGUAGE = ' . singleQuote($key) . ' GROUP BY ENTRY, LANGUAGE HAVING COUNT(*) > 1 ORDER BY ENTRY, LANGUAGE';
		  $results = ClxCommon::$db->executeQuery($sql);
		  while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
			 $in[] = $result['ENTRY'];
		  }
		  ClxCommon::$db->freeResult($results);
		  if (count($in) == CLX_NUM_ZERO) {
			 $contents .=dict('GEN_LBL_NODUPLICATESONLANGUAGE', $key) . '<br>';
			 continue;
		  }
		  //Search Entries to exclude English
		  $sql = 'SELECT ENTRY, MAX(ID) ID FROM CLX_DICTIONARY WHERE UPEPR(LANGUAGE) = ' . singleQuote(uppercase($key)) . ' AND ENTRY IN (' . singleQuote(implode("','", $in)) . ') GROUP BY ENTRY ORDER BY ID, ENTRY';
		  $results = ClxCommon::$db->executeQuery($sql);
		  $notin = array();
		  while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
			 $notin[] = $result['ID'];
		  }
		  ClxCommon::$db->freeResult($results);
		  //Build Delete Statement for english
		  $sql = 'DELETE FROM CLX_DICTIONARY WHERE UPPER(LANGUAGE) = ' . singleQuote(uppercase($key)) . ' AND ENTRY IN (' . singleQuote(implode("','", $in)) . ') AND ID NOT IN (' . implode(',', $notin) . ')';
		  $results = ClxCommon::$db->executeQuery($sql);
        }
        $sql = 'DELETE from CLX_DICTIONARY WHERE UPPER(LANGUAGE) NOT IN (' . singleQuote(uppercase(implode("','", $lang))) . ')';
        $results = ClxCommon::$db->executeQuery($sql);
        $contents .= dict('GEN_LBL_COMPLETED') . '<br>';
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $table->addCell(dict('GEN_LBL_CLEAR_DICTIONARY'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell($contents, array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $c = new htmlButtonReturn();
        $buttons = $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        return $table->source();
    }

}
