<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-08-23 18:18:58 -0400 (Thu, 23 Aug 2018) $
 * @version        $Rev: 9902 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
/* 	Object
  Import Map Data  Author:		ALeNet, Inc.
  Date:
  comments:
  INSTRUCTIONS General Information - Mapping has to be set at the first entry of the source csv or tab delimited file. - Application will set dinamyc relation and direct relation based on the provided mapping. - Each Colunm on source File will be interpreted as a field on import. if multiple columns has the same map all of them will be merge into a single sql statement.
  - Field imported on temporary table will manage next records to be imported, set to 1 to discart and 2 to mark as duplicated entry. To Get all duplicated entry or falure get all publish = 2  - Mapping Formats:
  DYNAMIC RELATIONS (Basic Syntax):
  Tables are separated by dot and parameters and conditions during execution can be additionally included. Examples:
  TABLECODE_A.TABLECODE_B.fieldname TABLECODE_A(fieldname_para1='value' and...etc).TABLECODE_B.fieldname TABLECODE_A[fieldname_cond2='value' and... etc].TABLECODE_B.fieldname  Important Note: Each parameter will be interpreted as a new db entry(New sql statement) for example, one contact record has to phones, type=work and type=fax. and needs to be set into a table as 2 records of phone and type each then mapping should be set CONT.ACPH(type=Work).phone, CONT.ACPH(type=fax).phone.
  Same Applies for Direct Relations  DIRECT RELATION:
  Relations is established by usign colon (:), the first elements concidered to be a lookup field, the second (after colon) the tablecode where this lookup field is placed. All parameters and conditions can also be used on field mapping.
  Example: CONT.contactcode:ACPH(type=Work).phone, CONT.contactcode:ACPH(type=fax).phone
  FINALLY: Dynamic Relation and Direct Relation can be convined to set a correct mapping.
  TO-DOs:
  1 On direct relation need to be added the alternative to include multiple key for a record, Ex: phone with accountcode and contactcode. Now only the one under the direct relation its allowed.
 */
if (!class_exists('util') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'util.php';

class util_importdata extends util {

    var $verbose = false; //Set true to display output
    var $create = false; //Set true to generate Insert
    var $createtmptable = false; //Set true to generate Insert
    var $duplicate = false; //if true it will insert child records for duplicates entries

// CONSTRUCTOR //

    function __construct() {
        error_reporting(E_ALL);
        ini_set('display_errors', 'on');
        $this->code = 'IPRD';
        $this->name = 'Import Data';
        $this->type = 'UTIL';
        $this->version = '0.0.0.1';
        $this->description = 'Import data to the database.';
        $this->haspanel = true;
        $this->debug = true;
        $this->duplicate = true;
    }

    function panel($msg) {
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->setProp('enctype', 'multipart/form-data');
        $form->setProp(CLX_PROP_TARGET, '_blank');
        $form->addArgument(CLX_PROP_TO, 'UTIL');
        $form->addArgument('ut', $this->code);
        $form->addArgument('ac', 'PANEL');
        $form->addArgument('confirm', '1');
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $table->addCell(dict('TOOL_IPRD_TITLE'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell(dict('TOOL_IPRD_TITLE_EXPLAIN1'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addFile($msg, dict('GEN_LBL_FILE') . ':', 'UTL_FILENAME', (!empty(UserRequest::$post['UTL_FILENAME'])) ? UserRequest::$post['UTL_FILENAME'] : '');
        $table->addField($msg, dict('TOOL_IPRD_FLB_utl_tmptable'), 'UTL_TMPTABLE', (!empty(UserRequest::$post['UTL_TMPTABLE']) ? uppercase(stripslashes(UserRequest::$post['UTL_TMPTABLE'])) : ''), '', '');
        $table->addField($msg, dict('TOOL_IPRD_FLB_utl_recdelimiter'), 'UTL_RECDELIMITER', (!empty(UserRequest::$post['UTL_RECDELIMITER']) ? stripslashes(UserRequest::$post['UTL_RECDELIMITER']) : CLX_CHAR_NL), '', '');
        $table->addField($msg, dict('TOOL_IPRD_FLB_utl_fielddelimiter'), 'UTL_FIELDDELIMITER', (!empty(UserRequest::$post['UTL_FIELDDELIMITER']) ? stripslashes(UserRequest::$post['UTL_FIELDDELIMITER']) : ','), '', '');
        $table->addField($msg, dict('TOOL_IPRD_FLB_utl_fieldenclosed'), 'UTL_FIELDENCLOSED', (!empty(UserRequest::$post['UTL_FIELDENCLOSED']) ? stripslashes(UserRequest::$post['UTL_FIELDENCLOSED']) : CLX_CHAR_SINGLE_QUOTE), '', '');
        $table->addField($msg, dict('TOOL_IPRD_FLB_utl_skipline'), 'UTL_SKIPLINE', (!empty(UserRequest::$post['UTL_SKIPLINE']) ? UserRequest::$post['UTL_SKIPLINE'] : '1'), '', '');
        $yesno = new htmlSelect('CREATE');
        $yesno->addItem(dict('GEN_LBL_NO'), '0', (empty(UserRequest::$post['CREATE'])));
        $yesno->addItem('Yes', '1', (!empty(UserRequest::$post['CREATE'])));
        $table->addData(dict('GEN_LBL_NO_RECORD_CREATE'), $yesno->source());
        $yesno = new htmlSelect('VERBOSE');
        $yesno->addItem(dict('GEN_LBL_NO'), '0', (empty(UserRequest::$post['VERBOSE'])));
        $yesno->addItem(dict('GEN_LBL_YES'), '1', (!empty(UserRequest::$post['VERBOSE'])));
        $table->addData(dict('GEN_LBL_REPORT'), $yesno->source());
        $yesno = new htmlSelect('UTL_CREATETMPTABLE');
        $yesno->addItem(dict('GEN_LBL_YES'), '1', true);
        $yesno->addItem(dict('GEN_LBL_NO'), '0', false);
        $table->addData(dict('TOOL_IPRD_FLB_utl_createtmptable'), $yesno->source());
        $yesno = new htmlSelect('DUPLICATE');
        $yesno->addItem(dict('GEN_LBL_YES'), '1', true);
        $yesno->addItem(dict('GEN_LBL_NO'), '0', false);
        $table->addData(dict('TOOL_IPRD_FLB_utl_duplicate'), $yesno->source());
        $c = new htmlSubmit('IMPORT');
        $buttons = $c->source();
        $c = new htmlButtonCancel();
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        return $form->source();
    }

    function checkPanel(&$msg) {
        $msg = array();
        $something = (strlen(UserRequest::$files['UTL_FILENAME']['name']) != CLX_NUM_ZERO);
        if (empty($something))
		  $msg['UTL_FILENAME'] = dict('GEN_ERR_SELECT_IMPORT');
        if (UserRequest::$files['UTL_FILENAME']['error']) {
		  $msg['UTL_FILENAME'] = dict('GEN_ERR_FILE_REQUIRED') . '(' . UserRequest::$files['UTL_FILENAME']['error'] . ')';
        }
        if (empty(UserRequest::$post['UTL_TMPTABLE']))
		  $msg['UTL_TMPTABLE'] = dict('GEN_ERR_TMPTABLE_REQUIRED');
        return count($msg) == CLX_NUM_ZERO;
    }

    function execute_() {
        $contenidoHTML = '';

        if (!function_exists('setCreationData'))
		  includeCodeLib('GEN_REC_UTIL');

        UserResponse::setRunTimeLimit(CLX_NUM_24 * CLX_NUM_60 * CLX_NUM_60);
        $contenidoHTML.= '<!-- NO OUTPUT -->&nbsp;';
        $this->verbose = (UserRequest::$post['VERBOSE'] === CLX_NUM_ONE) ? true : false;
        $this->create = (UserRequest::$post['CREATE'] === CLX_NUM_ONE) ? true : false;
        $this->createtmptable = (UserRequest::$post['UTL_CREATETMPTABLE'] === CLX_NUM_ONE) ? true : false;
        $this->duplicate = (UserRequest::$post['DUPLICATE'] === CLX_NUM_ONE) ? true : false;
        UserRequest::$post['UTL_RECDELIMITER'] = stripslashes(UserRequest::$post['UTL_RECDELIMITER']);
        UserRequest::$post['UTL_FIELDDELIMITER'] = stripslashes(UserRequest::$post['UTL_FIELDDELIMITER']);
        UserRequest::$post['UTL_SKIPLINE'] = stripslashes(UserRequest::$post['UTL_SKIPLINE']);
        UserRequest::$post['UTL_FIELDENCLOSED'] = stripslashes(UserRequest::$post['UTL_FIELDENCLOSED']);
        if (!empty($this->verbose)) {
		  $contenidoHTML.= 'Import Started<br>';
		  $contents = '<p>';
        }
        $yesno = array('No', 'Yes');
        $create = UserRequest::$post['CREATE'];
        $verbose = UserRequest::$post['VERBOSE'];
        $filename = kPathToWebSite . kPathToTemp . 'import_file_' . $_SESSION['user_record'][CLX_PROP_ID] . '_' . time() . '.txt';
        if (!empty($this->verbose))
		  $contenidoHTML.= dict('GEN_LBL_ORIG_FILE') . ': <b>' . UserRequest::$files['UTL_FILENAME']['name'] . '</b><br>';
        if (!stristr(UserRequest::$files['UTL_FILENAME']['type'], 'application/vnd.ms-excel') && !stristr(UserRequest::$files['UTL_FILENAME']['type'], 'text/comma-separated-values') && !stristr(UserRequest::$files['UTL_FILENAME']['type'], 'text/plain') && !stristr(UserRequest::$files['UTL_FILENAME']['type'], 'application/octet-stream')) {
		  if (!empty($this->verbose))
			 $contenidoHTML.= 'ERROR: Invalid File Type, must be text or csv <b>' . UserRequest::$files['UTL_FILENAME']['name'] . '</b><br></p>';
		  return CLX_CHAR_EMPTY_STRING;
        }
        move_uploaded_file(UserRequest::$files['UTL_FILENAME']['tmp_name'], $filename);
        $fd = fopen($filename, 'r');
        $buffersize = CLX_NUM_1024; //1 kbyte, 1024 bytes
        $filesize = filesize($filename);
        $loadedsize = CLX_INIT_ZERO;
        $buffer = '';
        if (!empty($this->verbose)) {
		  $contents .= dict('GEN_LBL_TEMP_FILE') . ': <b>' . UserRequest::$files['UTL_FILENAME']['tmp_name'] . '</b><br>';
		  $contents .= dict('GEN_LBL_NO_RECORD_CREATE') . ': <b>' . $yesno[$create] . '</b><br>';
		  $contents .= dict('GEN_LBL_VERBOSE') . '?: <b>' . $yesno[$verbose] . '</b><br>';
		  $contents .= dict('GEN_LBL_LOCALFILE') . ': <b>' . $filename . '</b><br>';
		  $contents .= dict('GEN_LBL_FILESIZE') . ': <b>' . $filesize . ' Bytes</b><br>';
		  $contents .= dict('GEN_LBL_BUFFER_SIZE') . ': <b>' . $buffersize . ' Bytes</b><br>';
		  $contenidoHTML.= $contents . '<BR>';
		  $contents = '';
        }//end verbose
        while ((strpos($buffer, $this->clean(UserRequest::$post['UTL_RECDELIMITER'])) === false) && ($loadedsize < $filesize)) {
		  $b = fread($fd, $buffersize);
		  $loadedsize += strlen($b);
		  $buffer .= $b;
		  if (!empty($this->verbose))
			 $contenidoHTML.= dict('GEN_LBL_LOADED') . '<b> $loadedsize/$filesize Bytes</b><br>';
        }
        $pos = strpos($buffer, $this->clean(UserRequest::$post['UTL_RECDELIMITER']), CLX_NUM_ZERO);
// if there are no more lines, take the rest of buffer as the last line.
        if ($pos === false)
		  $pos = strlen($buffer);
        if ($pos > CLX_NUM_ZERO) {
		  if (!empty($this->verbose))
			 $contents .= dict('GEN_LBL_INIMAP') . '<br>';
		  $line = str_replace($this->clean(UserRequest::$post['UTL_RECDELIMITER']), '', substr($buffer, CLX_NUM_ZERO, $pos));
		  $line = str_replace(CLX_CHAR_NL, '', $line);
		  $line = str_replace(chr(CLX_NUM_13), '', $line);
		  $map = explode($this->clean(UserRequest::$post['UTL_FIELDDELIMITER']), $line);
		  ClxFreeReturn($this->tmpTable($filename, $map, $contents));
        }
        fclose($fd);
        unset($line, $buffer, $fd, $pos, $loadedsize, $buffersize);
        if (!empty($this->verbose))
		  $contenidoHTML.= dict('GEN_LBL_VALIDATEMAP') . ': <b>';
        $tree = array('ERR' => '');
        reset($map);
        foreach ($map as $fkey => $val) {
		  $tree = $this->mapParse($fkey, $val, $tree);
		  if ($tree['ERR'] !== '')
			 break;
        }
        if (!empty($this->verbose)) {
		  $contenidoHTML.= dict('GEN_LBL_STATUS') . ':';
		  if ($tree['ERR'] !== '')
			 $contenidoHTML.= dict('GEN_LBL_FAIL') . ' <br>' . $tree['ERR'];
		  else
			 $contenidoHTML.= ' Ok<br>';
		  $contenidoHTML.= '</b>';
        }
        echo $contenidoHTML;
        $contenidoHTML = '';
        if ($tree['ERR'] === '') {
		  unset($tree['ERR']);
		  while (($rec = ClxCommon::$db->getRecord('TMP_' . uppercase(UserRequest::$post['UTL_TMPTABLE']), 'IMPORTED=0')) === true) {
			 if (!empty($this->verbose)) {
			     $contenidoHTML.= dict('GEN_LBL_NEXT_ID') . ': <b>' . $rec['ID'] . '</b>: <b><br>';
			 }
			 $result = $this->evalTree($tree, $rec, array());
			 if (!empty($this->verbose)) {
			     if (!empty($result['ERR']))
			         $contenidoHTML.= dict('GEN_LBL_FAIL') . ' ' . $result['ERR'] . '<br>';
			     elseif (empty($this->create))
			         $contenidoHTML.= 'Testing<br>';
			     else
			         $contenidoHTML.= ' ' . dict('GEN_LBL_STATUS') . ': Ok<br>';
			     $contenidoHTML.= '</b>';
			 }
//Mark as Complete
			 if (!empty($result['ERR'])) {
			     ClxCommon::$db->updateRecord('TMP_' . uppercase(UserRequest::$post['UTL_TMPTABLE']), array('IMPORTED' => CLX_NUM_TWO), 'ID=' . $rec['ID']);
			 } else {
			     ClxCommon::$db->updateRecord('TMP_' . uppercase(UserRequest::$post['UTL_TMPTABLE']), array('IMPORTED' => CLX_NUM_ONE), 'ID=' . $rec['ID']);
			 }
			 ob_flush();
		  }
//Return Condition to 0 if done testing to allow user to test run it again
		  if (empty($this->create))
			 ClxCommon::$db->updateRecord('TMP_' . uppercase(UserRequest::$post['UTL_TMPTABLE']), array('IMPORTED' => CLX_NUM_ZERO), '1=1');
        }
        if (!empty($this->verbose)) {
		  $contenidoHTML.= '<br>' . dict('GEN_LBL_IMPORTEND') . '</p>';
        }
        echo $contenidoHTML;
        return CLX_CHAR_EMPTY_STRING;
    }

    function evalTree($tree, $rec, $result) {
        foreach ($tree as $fkey => $val) {
		  if (!isset($val['SQLTABLE'])) {
			 $result = $this->evalTree($val, $rec, $result);
		  } else {
			 if ($this->create)
			     $result = $this->importRecord($val, $rec, $result);
			 else
			     $result = '';
		  }
        }
        return $result;
    }

//End Method
    function importRecord($map, $rec, $result) {
        $contenidoHTML = '';
        if (!empty($result['ERR']))
		  return $result;
        else
		  $result['ERR'] = CLX_INIT_ZERO;
//Create Record
        $record = array();
        $count = '';
//Keep info for skeep empty values
        $totalfields = count($map['REC']);
        $totalfound = CLX_INIT_ZERO;
//Start Mapping load
        foreach ($map['REC'] as $fkey => $val) {
		  if (isset($rec[$key])) {
			 $record[$val['fieldname']] = addslashes(trim($rec[$key]));
		  } else {
			 $totalfound--;
//$key implies that de value is a parameter not in the record for example =o for office on phtype=o
			 $record[$val['fieldname']] = addslashes(trim($key));
		  }
//Adding if not exists
		  if (strlen($record[$val['fieldname']]) > CLX_NUM_ZERO && $record[$val['fieldname']] !== 'AUTO') {
			 $totalfound++;
		  }
		  if (empty($record[$val['fieldname']]) && $record[$val['fieldname']] != CLX_NUM_ZERO) {
			 $record[$val['fieldname']] = '';
		  }
//Check if exists
		  if (isset($map['SQLTABLEKEYS'][$val['fieldname']]) && $map['SQLTABLEKEYS'][$val['fieldname']]['TYPE'] === 'UNI') {
			 if (!empty($map['SQLTABLEKEYS'][$val['fieldname']]['SIZE']) && $map['SQLTABLEKEYS'][$val['fieldname']]['SIZE'] > CLX_NUM_ZERO) {
//Since key on db can be shroter consecuence of a trimed key be need to check base on key size
			     $keysize = $map['SQLTABLEKEYS'][$val['fieldname']]['SIZE'];
			     $count = $val['fieldname'] . '=' . singleQuote(substr($record[$val['fieldname']], CLX_NUM_ZERO, $keysize)) . ',';
			 } else {
			     $count = $val['fieldname'] . '=' . singleQuote($record[$val['fieldname']]) . ',';
			 }
			 unset($keysize);
		  }
        }//end while
        if ($totalfound == CLX_NUM_ZERO) {
		  echo $contenidoHTML;
		  return $result;
        } else {
		  $contenidoHTML.= 'Creating Record on ' . $map['SQLTABLENAME'] . ', Total fields: ' . $totalfields . ', Found: ' . $totalfound . '<br>';
        }
        if (empty($record)) {//is no records to add return
		  $record['ID'] = '';
        }
        $count = trim(substr($count, CLX_NUM_ZERO, strlen($count) - CLX_NUM_ONE));
        $foundRecord = ''; //keep reord information if any found
//Check if Exists
        if (!empty($count) && ClxCommon::$db->oneExistsRecords($map['SQLTABLENAME'], $count) > CLX_NUM_ZERO) {
//Place to add the log for repetitions
		  if ($this->duplicate === true) {
			 $foundRecord = ClxCommon::$db->getRecord($map['SQLTABLENAME'], $count);
			 $result[$map['SQLKEY']] = array('ID' => $foundRecord['ID']);
		  } else {
			 $result['ERR'] = '<br>-->' . dict('GEN_LBL_DUPLICATE_ENTRY', $map['SQLTABLENAME'] . '-> ' . $count);
		  }
		  unset($count);
		  echo $contenidoHTML;
		  return $result;
        } else {

        }
        unset($count);
        switch ($map['RELTYPE']) {
		  case 'DYNAMIC':
//If Error during prev key end
			 if (!empty($result['ERR']))
			     break;
			 if (!empty($foundRecord)) {
			     $resultId = $foundRecord['ID'];
			 } else { //if !foudnrecord
			     if ($this->countRecord($map['SQLTABLENAME'], $record) == CLX_NUM_ZERO) {
//Set ID Code if set function
			         if (function_exists('setCreationIdCode')) {
					   $record = setCreationData($record);
					   $record = setCreationIdCode($record, $map['SQLTABLE']);
			         }
			         $resultId = ClxCommon::$db->createRecord($map['SQLTABLENAME'], $record, false);
			     } else {
			         break;
			     }
			 }
			 if ($resultId > CLX_NUM_ZERO) {
//Keep results
			     $result[$map['SQLKEY']] = array('ID' => $resultId);
//Generate Dynamic Rel
			     $relRec = ClxCommon::$db->getRecord('CLX_DB_DYNRELATIONS', 'PARENT_TABLECODE = ' . singleQuote($map['FATHERTABLE']), 'CHILD_TABLECODE = ' . singleQuote($map['SQLTABLE']) . '  AND RELATION_TYPE = 0');
			     $relRec = tableName($relRec['TABLECODE']);
			     $relrecord = array('PARENT_TABLECODE' => $map['FATHERTABLE'],
			         'PARENT_RECORDID' => $result[$map['FATHERKEY']]['ID'],
			         'CHILD_TABLECODE' => $map['SQLTABLE'],
			         'CHILD_RECORDID' => $result[$map['SQLKEY']]['ID']);
//e cho '<br>--->DYN: '.implode(',',$relrecord).' ';
			     $resultId = ClxCommon::$db->createRecord($relRec, $relrecord, false);
			     unset($relRec, $relrecord);
			 } else {
			     $result['ERR'] = CLX_NUM_ONE;
			 }
			 break;
		  case 'LOOKUP':
//If Error during prev key end
			 if (!empty($result['ERR']))
			     break;
//Get Parent Record
			 $parentRec = ClxCommon::$db->getRecord($map['FATHERTABLENAME'], 'ID=' . $result[$map['FATHERKEY']]['ID']);
			 if (!empty($parentRec)) {
			     $record[$map['SQLRELATION']['fieldname']] = $parentRec[$map['SQLRELATION']['FIELD_EXTRA2']];
//Create Record
			     if ($this->countRecord($map['SQLTABLENAME'], $record) == CLX_NUM_ZERO) {
//Setting code
			         if (function_exists('setCreationIdCode')) {
					   $record = setCreationData($record);
					   $record = setCreationIdCode($record, $map['SQLTABLE']);
			         }
			         $resultId = ClxCommon::$db->createRecord($map['SQLTABLENAME'], $record, false);
			         if ($resultId > CLX_NUM_ZERO)
					   $result[$map['SQLKEY']] = array('ID' => $resultId);
			         else
					   $result['ERR'] = CLX_NUM_ONE;
			     }else {
			         break;
			     }
			 } else {
			     $result['ERR'] = CLX_NUM_ONE;
			 }
			 break;
		  default:
//Default Case, usually field on father table where not relation can be found
			 if (!empty($result['ERR']))
			     break;
			 if (!empty($foundRecord)) {
			     $result[$map['SQLKEY']] = array('ID' => $foundRecord['ID']);
			 } else { //if !foudnrecord
//Set ID Code if set function
			     if (function_exists('setCreationIdCode')) {
			         $record = setCreationData($record);
			         $record = setCreationIdCode($record, $map['SQLTABLE']);
			     }
			     $resultId = ClxCommon::$db->createRecord($map['SQLTABLENAME'], $record, false);
			     if ($resultId > CLX_NUM_ZERO)
			         $result[$map['SQLKEY']] = array('ID' => $resultId);
			     else
			         $result['ERR'] = CLX_NUM_ONE;
			 }
			 break;
        }//End Switch
        unset($record, $resultId);
        echo $contenidoHTML;
        return $result;
    }

//End Method
    function mapParse($fkey, $map, $tree) {
        if (empty($tree))
		  $tree = array('ERR' => '');
        if (!strstr($map, '.'))
		  return array('ERR' => 'Invalid Map Syntax no table-field separator(.) found on map ' . $map . ' tablekey: MAP_' . $fkey);
        $parts = array();   //Method var to holds all exploded '.'
        $result = array();   //Array to keep map parts results
        $fatherkey = '';   //Array key to keep track of the mapp->-row
        $fathertable = '';
        $parts = explode('.', $map);
        foreach ($parts as $key => $val) {
		  if (count($parts) - CLX_NUM_ONE == $key)
			 continue; //Skip Last iteration fieldalready added
		  if ($key == CLX_NUM_ZERO) {
			 $maping['MAXLEVEL'] = count($parts);
			 $maping['MAP'] = $map . ' ';
		  }
//Keys to identify results and steps during insert
		  $maping['SQLLEVEL'] = $key;
		  $maping['SQLKEY'] = $val . '_' . $key;
		  $maping['FATHERKEY'] = $fatherkey;
//Father Table and Father Table Name
		  $maping['FATHERTABLE'] = $fathertable;
		  if (!empty($fathertable)) {
			 $maping['FATHERTABLENAME'] = tableName($fathertable);
		  }
		  $maping['SQLRELATION'] = '';
		  $maping['RELTYPE'] = 'NONE';
//Get Parameters
		  if (strstr($val, '(')) {
			 $posFrom = strpos($val, '(');
			 $posStep = strpos($val, ')') - ($posFrom - CLX_NUM_ONE);
			 $maping['SQLPARAMETER'] = substr($val, $posFrom, $posStep);
			 $val = str_replace($maping['SQLPARAMETER'], '', $val);
			 $maping['SQLPARAMETER'] = str_replace('(', '', $maping['SQLPARAMETER']);
			 $maping['SQLPARAMETER'] = str_replace(')', '', $maping['SQLPARAMETER']);
			 $maping['SQLPARAMETER'] = trim($maping['SQLPARAMETER']);
			 $maping['SQLPARAMETER'] = str_ireplace(' and ', ',', $maping['SQLPARAMETER']);
			 $maping['SQLPARAMETER'] = str_ireplace(' or ', ',', $maping['SQLPARAMETER']);
			 $maping['SQLPARAMETER'] = str_ireplace(' && ', ',', $maping['SQLPARAMETER']);
			 $maping['SQLPARAMETER'] = str_ireplace(' || ', ',', $maping['SQLPARAMETER']);
			 $maping['SQLPARAMETER'] = explode(',', $maping['SQLPARAMETER']);
			 foreach ($maping['SQLPARAMETER'] as $keyp => $valp) {
			     $tmp = explode('=', $valp);
			     if (empty($tmp[CLX_NUM_ONE])) {
			         continue;
			     } else {
			         $tmp[CLX_NUM_ONE] = str_replace(CLX_CHAR_SINGLE_QUOTE, '', $tmp[CLX_NUM_ONE]);
			         $result = ClxCommon::$db->executeQuery('SELECT ID, FIELDNAME, FIELDFORMLABEL, FIELDTYPE, FIELD_EXTRA1 FROM CLX_DB_FIELDS WHERE  FIELDNAME=' . singleQuote($tmp[CLX_NUM_ZERO]));
			         $maping['REC'][$tmp[CLX_NUM_ONE]] = ClxCommon::$db->getNextRecord($result);
			         $sqlparameterArray[] = $tmp[CLX_NUM_ZERO];
//Test if field Exists
			         if (empty($maping['REC'][$tmp[CLX_NUM_ONE]])) {
					   $tree = array('ERR' => 'Invalid field name: ' . $tmp[CLX_NUM_ZERO] . ', on ' . $valp);
					   unset($sqlparameterArray);
					   return $tree;
			         }
			     }
			 }
			 unset($tmp, $keyp, $valp);
		  }
//Get Conditions
		  if (strstr($val, '[')) {
			 $posFrom = strpos($val, '[', CLX_NUM_ZERO);
			 $posStep = strpos($val, ']', CLX_NUM_ZERO) - ($posFrom - CLX_NUM_ONE);
			 $maping['SQLCONDITION'] = substr($val, $posFrom, $posStep);
			 $val = str_replace($maping['SQLCONDITION'], '', $val);
			 $maping['SQLCONDITION'] = str_replace('[', '', $maping['SQLCONDITION']);
			 $maping['SQLCONDITION'] = str_replace(']', '', $maping['SQLCONDITION']);
			 $maping['SQLCONDITION'] = trim($maping['SQLCONDITION']);
		  }
//Lookup Setup
		  if (strstr($val, ':')) {
			 $posFrom = strpos($val, ':', CLX_NUM_ZERO) + CLX_NUM_ONE;
			 $posStep = strlen($val) - $posFrom;
			 $maping['SQLRELATION'] = substr($val, CLX_NUM_ZERO, $posFrom - CLX_NUM_ONE);
			 $val = substr($val, $posFrom, $posStep);
		  }
//If only one table and field left get both and end map
		  if (count($parts) - CLX_NUM_TWO == $key) {
			 $sqlfieldname = $parts[$key + CLX_NUM_ONE];
			 $fkey = 'MAP_' . $fkey;
			 $result = ClxCommon::$db->executeQuery('SELECT ID, FIELDNAME, FIELDFORMLABEL, FIELDTYPE, FIELD_EXTRA1 FROM CLX_DB_FIELDS WHERE  FIELDNAME=' . singleQuote($sqlfieldname));
			 $fieldrec = ClxCommon::$db->getNextRecord($result);
//Check if field exists
			 if (empty($fieldrec)) {
			     return array('ERR' => 'Invalid field name: ' . $sqlfieldname . ', on ' . $map);
			 }
//test if field exists on table
                if (ClxCommon::$db->oneExistsRecords('CLX_DB_TABLEFIELDS', 'FIELDNAME=' . singleQuote($sqlfieldname), 'TABLECODE=' . singleQuote($val)) == CLX_NUM_ZERO) {
			     return array('ERR' => 'Not a field: ' . $sqlfieldname . ', on table: ' . $val);
			 }
			 $maping['REC'][$fkey] = $fieldrec;
		  }
		  $maping['SQLTABLE'] = $val;
//Test if table Exists
            if (ClxCommon::$db->oneExistsRecords('CLX_DB_TABLES', 'IDCODE=' . singleQuote($maping['SQLTABLE'])) == CLX_NUM_ZERO) {
			 return array('ERR' => dict('GEN_ERR_NOTATABLE', $maping['SQLTABLE']));
		  }
//		  $tablerec = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE=' . singleQuote($val));
		  $maping['SQLTABLENAME'] = tableName($val);
//Test if field exists on table
		  reset($sqlparameterArray);
		  foreach ($sqlparameterArray as $keyrel => $valrel) {
                if (ClxCommon::$db->oneExistsRecords('CLX_DB_TABLEFIELDS', 'FIELDNAME=' . singleQuote($valrel), 'TABLECODE=' . singleQuote($maping['SQLTABLE'])) == CLX_NUM_ZERO) {
			     $tree = array('ERR' => 'No field: ' . $valrel . ', on table: ' . $maping['sqltable']);
			     unset($sqlparameterArray);
			     return $tree;
			 }
		  }
		  $fatherkey = $maping['SQLKEY'];
		  $fathertable = $val;
//Test Lookup or empty Relation means Dynamic Rel
		  if (!empty($maping['FATHERTABLE']) && !empty($maping['SQLRELATION'])) {
//Check if Table Exists
                if (ClxCommon::$db->oneExistsRecords('CLX_DB_TABLES', 'IDCODE=' . singleQuote($maping['FATHERTABLE'])) == CLX_NUM_ZERO) {
			     return array('ERR' => dict('GEN_ERR_NOT_TABLEONLOOK', $maping['SQLRELATION'] . ':' . $maping['FATHERTABLE']));
			 }
//Check if Field Exists
                if (ClxCommon::$db->oneExistsRecords('CLX_DB_FIELDS', 'FIELDNAME=' . singleQuote($maping['SQLRELATION']) . ' AND FIELDTYPE=' . singleQuote('LOOK') . ' AND FIELD_EXTRA1=' . singleQuote($maping['FATHERTABLE'])) == CLX_NUM_ZERO) {
			     return array('ERR' => dict('GEN_ERR_NOT_LOOKRELATION', $maping['SQLRELATION'] . ':' . $maping['FATHERTABLE']));
			 }
//Check Relation Field-Table Exists
                if (ClxCommon::$db->oneExistsRecords('CLX_DB_TABLEFIELDS', 'TABLECODE=' . singleQuote($maping['SQLTABLE']) . ' AND FIELDNAME=' . singleQuote($maping['SQLRELATION'])) == CLX_NUM_ZERO) {
			     return array('ERR' => dict('GEN_ERR_NOT_LOOKUPFIELDONTABLE', $maping['SQLRELATION'], $maping['SQLTABLE']));
			 }
//Find Relation field information and store it for later validation
			 $maping['SQLRELATION'] = ClxCommon::$db->getRecord('CLX_DB_FIELDS', 'FIELDNAME=' . singleQuote($maping['SQLRELATION']));
//Set Type of Relation Flag
			 $maping['RELTYPE'] = 'LOOKUP';
//Testing Dynamic Relation Section
		  } elseif (!empty($maping['FATHERTABLE'])) {
//Test if Dynamic Relation Exists
                if (ClxCommon::$db->oneExistsRecords('CLX_DB_DYNRELATIONS', 'PARENT_TABLECODE = ' . singleQuote($maping['FATHERTABLE']), 'CHILD_TABLECODE = ' . singleQuote($maping['SQLTABLE']) . '  AND RELATION_TYPE = 0') == CLX_NUM_ZERO) {
			     return array('ERR' => dict('GEN_ERR_NOTDYNAMICREL', $maping['FATHERTABLE'], $maping['SQLTABLE']));
			 }
//Set Type of Relation Flag
			 $maping['RELTYPE'] = 'DYNAMIC';
		  }//End If
//Catch all table key an request it during mapping Validation
		  $tbkeys = ClxCommon::$db->getRecords('CLX_DB_TABLEINDEXES', 'TABLECODE = ' . singleQuote($maping['SQLTABLE']));
		  $DBTI = getTool('DBTI');
		  $tbkeys = $DBTI->getTableIndexes($maping['SQLTABLE']);
		  foreach ($tbkeys as $key => $tbkey) {
			 $tbkey['fieldname'] = explode(',', $tbkey['fieldname']);
			 foreach ($tbkey['fieldname'] as $keyCLX_NUM_TWO => $val2) {
			     if ($val2 === 'ID')
			         continue;
			     $tbkeysfield = ClxCommon::$db->getRecord('CLX_DB_FIELDS', 'FIELDNAME = ' . singleQuote($val2));
			     $maping['SQLTABLEKEYS'][$val2] = array('TYPE' => $tbkey['TYPE'],
			         'SIZE' => ((!empty($tbkeysfield)) ? $tbkeysfield['FIELD_SIZE'] : CLX_NUM_ZERO));
			 }
			 unset($tbkeysfield);
		  }
//Preparing Tree, Key and Array
		  if (!empty($maping['FATHERKEY']))
			 $treeMap = $maping['FATHERKEY'] . '-' . $maping['SQLKEY'];
		  else
			 $treeMap = $maping['SQLKEY'];
//Add Item to tree
		  if (!empty($tree[$key][$treeMap])) {
			 if (!empty($maping['REC']))
			     $tree[$key][$treeMap]['REC'][$fkey] = $fieldrec;
			 $tree[$key][$treeMap]['MAP'] .= $maping['MAP'];
		  }else {
			 $tree[$key][$treeMap] = $maping;
		  }
        }//end for each
        return $tree;
    }

    function countRecord($table, $record) {
        foreach ($record as $key => $val) {
		  $rec[] = $key . '=' . singleQuote(' . $val.') . '';
        }
        $search = implode(' AND ', $rec);
        $count = ClxCommon::$db->oneExistsRecords($table, $search);
        return $count;
    }

    function tmpTable($filename, &$map, &$contents) {
        $contenidoHTML = '';
        $tmpTable = 'TMP_' . uppercase(UserRequest::$post['UTL_TMPTABLE']);
        if ($this->createtmptable)
		  ClxCommon::$db->dropTable($tmpTable);
        if ($this->verbose && $this->createtmptable)
		  $contenidoHTML.= dict('UTIL_IPRM_DROPTMPTABLEOK') . ': <b>' . $tmpTable . '</b><br>';
//Setting Temporary Table Fields
        $tmpFields = array();
        $toLoad = '';
        foreach ($map as $key => $value) {
		  $tmpFields['MAP_' . $key] = array('type' => 'text', 'null' => 'NO', 'properties' => '', 'index' => '');
		  $toLoad .= 'MAP_' . $key . ',';
        }
        if ($this->createtmptable) {
		  $toLoad = substr($toLoad, CLX_NUM_ZERO, strlen($toLoad) - CLX_NUM_ONE);
		  $tmpFields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
		  $tmpFields['IMPORTED'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'properties' => 'default 0', 'index' => '');
		  ClxCommon::$db->createTable($tmpTable, 'MyISAM COMMENT = ' . singleQuote('Temporary Import Tabl') . '', $tmpFields, false);
		  if (!empty($this->verbose))
			 $contenidoHTML.= dict('UTIL_IPRM_TABLECREATEDOK') . ': <b>' . $tmpTable . '</b><br>';
		  if (lowercase(UserRequest::$post['UTL_RECDELIMITER']) === 'n')
			 UserRequest::$post['UTL_RECDELIMITER'] = CLX_CHAR_NL;
		  elseif (lowercase(UserRequest::$post['UTL_RECDELIMITER']) === 'r')
			 UserRequest::$post['UTL_RECDELIMITER'] = CLX_CHAR_CR;
		  elseif (lowercase(UserRequest::$post['UTL_RECDELIMITER']) === 'rn')
			 UserRequest::$post['UTL_RECDELIMITER'] = CLX_CHAR_CR . CLX_CHAR_NL;
		  elseif (lowercase(UserRequest::$post['UTL_RECDELIMITER']) === CLX_CHAR_NL . CLX_CHAR_CR)
			 UserRequest::$post['UTL_RECDELIMITER'] = CLX_CHAR_NL . CLX_CHAR_CR;
		  $sql = 'LOAD DATA INFILE ' . singleQuote($filename) . ' ';
		  $sql .= 'INTO TABLE ' . $tmpTable . ' FIELDS TERMINATED BY ' . singleQuote(UserRequest::$post['UTL_FIELDDELIMITER']);
		  $sql .= ' OPTIONALLY ENCLOSED BY ' . singleQuote(UserRequest::$post['UTL_FIELDENCLOSED']) . ' LINES TERMINATED BY ' . singleQuote(UserRequest::$post['UTL_RECDELIMITER']) . ' IGNORE ' . UserRequest::$post['UTL_SKIPLINE'] . ' LINES (' . $toLoad . ')';
		  ClxCommon::$db->executeQuery($sql);
		  if (!empty($this->verbose))
			 $contenidoHTML.= dict('GEN_LBL_LOADED') . ': <b>' . $tmpTable . '</b><br>';
        }
        if (!empty($this->verbose))
		  $contenidoHTML.= dict('GEN_LBL_EXCLUDING_FIELD') . ' (!x): <b>';
        foreach ($map as $key => $value) {
		  if (stristr('!x', $value)) {
			 if (!empty($this->verbose))
			     $contenidoHTML.= 'MAP_' . $key . ', ';
			 if ($this->createtmptable)
			     ClxCommon::$db->dropField($tmpTable, 'MAP_' . $key);
			 unset($map[$key]);
		  }
        }
        if (!empty($this->verbose)) {
		  $contenidoHTML.= '</b><br>';
        }
        echo $contenidoHTML;
        return true;
    }

    function clean($value) {
        if (stristr($value, CLX_CHAR_NL . CLX_CHAR_CR)) {
		  $value = CLX_CHAR_NL . CLX_CHAR_CR;
        } elseif (stristr($value, CLX_CHAR_CR . CLX_CHAR_NL)) {
		  $value = CLX_CHAR_CR . CLX_CHAR_NL;
        } elseif (stristr($value, CLX_CHAR_NL)) {
		  $value = CLX_CHAR_NL;
        } elseif (stristr($value, CLX_CHAR_CR)) {
		  $value = CLX_CHAR_CR;
        } elseif (stristr($value, CLX_CHAR_NL . CLX_CHAR_CR)) {
		  $value = CLX_CHAR_NL . CLX_CHAR_CR;
        } elseif (stristr($value, CLX_CHAR_CR . CLX_CHAR_NL)) {
		  $value = CLX_CHAR_CR . CLX_CHAR_NL;
        } elseif (stristr($value, CLX_CHAR_NL)) {
		  $value = CLX_CHAR_NL;
        } elseif (stristr($value, CLX_CHAR_CR)) {
		  $value = CLX_CHAR_CR;
        } elseif (stristr($value, CLX_CHAR_SINGLE_QUOTE)) {
		  $value = CLX_CHAR_SINGLE_QUOTE;
        }
        return $value;
    }

}
