<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-12-10 18:11:05 -0400 (lu., 10 dic. 2018) $
 * @version        $Rev: 10412 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
if (!class_exists('util') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'util.php';

class util_sysinfo extends util {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'SINF';
        $this->name = 'System Information';
        $this->type = 'UTIL';
        $this->version = '0.1.1.0';
        $this->description = 'Shows a lot of information about the current installation.';
        $this->haspanel = false;
    }

    function execute_() {
		if(isset(UserRequest::$request['sac'])) {
			switch (UserRequest::$request['sac']) {
				case 'GPEL' :
					// Returns PHP error log
					return $this->GetPhpErrorLog();
					break;
			}
		}
        $contents = '';
        pushHistory($this->code, 'IGNORE_THIS_ENTRY', CLX_NUM_ZERO);
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->addArgument(CLX_PROP_TO, 'UTIL');
        $form->addArgument('ac', 'LIST');
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $table->addCell(dict('GEN_LBL_SYSTEMINFO'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell(dict('GEN_LBL_SYSTEM'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addData(dict('GEN_LBL_VERSION') . ':', kSystemVersion);
        $table->addCell(dict('GEN_LBL_DATABASE'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addData(dict('GEN_LBL_TYPE') . ':', kDatabaseType);
        $table->addData(dict('GEN_LBL_LOCATION') . ':', kDatabaseURL);
        $table->addData(dict('GEN_LBL_USERNAME') . ':', kDatabaseUsername);

        $table->addData(dict('GEN_LBL_NAME') . ':', kDatabaseName);
        $table->addCell(dict('GEN_LBL_WEBSITE'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addData(dict('GEN_LBL_PATHNAME') . ':', kPathToWebSite);
        $table->addData(dict('GEN_LBL_PATHTOOLS') . ':', kPathToWebSite . kPathToTools);
        $table->addData(dict('GEN_LBL_PATHOBJECTS') . ':', kPathToWebSite . kPathToObjects);
        $table->addData(dict('GEN_LBL_PATHDATA') . ':', kPathToWebSite . kPathToData);
        $table->addData(dict('GEN_LBL_PATHDCODE') . ':', kPathToWebSite . kPathToData);
        $table->addData(dict('GEN_LBL_PATHTEMPLATE') . ':', kPathToWebSite . kPathToTemplates);
        $table->addData(dict('GEN_LBL_PATHTEMP') . ':', kPathToWebSite . kPathToTemp);
        $table->addCell(dict('GEN_LBL_OTHERINFO'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addData(dict('GEN_LBL_SESSIONTIMEOUTSET') . ':', kSessionTimeout);
        $table->addData(dict('GEN_LBL_COMPANY') . ':', kDefaultCompany);
        $table->addData(dict('GEN_LBL_COOKIENAME') . ':', kSideBarCookieName);
		
		$a_href = new htmlAnchor(kPhpErrorLog, 'tool.php?to='.$this->type.'&ac=PANEL&ut='.$this->code.'&sac=GPEL');
        $table->addData(dict('GEN_LBL_ERRORLOG') . ':', $a_href->source());
		
        $c = new htmlButtonReturn();
        $buttons = $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $contents = $form->source();
        return $contents;
    }

	function GetPhpErrorLog() {
		$filepath_orig = kPhpErrorLog;
		if(class_exists('ZipArchive')) {
			$zip_filename = kPathToWebSite . kPathToTemp . 'gpel_'.xFormat::getNow('Y-m-d_H-i').'.zip';
			$zip = new ZipArchive();
			if ($zip->open($zip_filename, ZipArchive::CREATE)!==TRUE) {
				exit('cannot open <'.$zip_filename.'>'.CLX_CHAR_NL);
			}
			$zip->addFile($filepath_orig);
			$zip->close();
			header('Content-Type: application/zip');
			header('Content-Disposition: attachment; filename="'.basename($zip_filename).'"');
			header('Content-Length: '.filesize($zip_filename) );
			ob_clean();
			readfile($zip_filename);
		} else {
			header('Content-Type: application/text');
			header('Content-Disposition: attachment; filename="'.basename($filepath_orig).'"');
			header('Content-Length: '.filesize($filepath_orig) );
			ob_clean();
			readfile($filepath_orig);
		}
		exit();
	}
}
