<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-10-15 10:19:43 -0400 (Mon, 15 Oct 2018) $
 * @version        $Rev: 10245 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
if (!class_exists('util') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'util.php';

class util_truncatetable  extends util {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'TTAB';
        $this->name = 'Truncate Tables';
        $this->type = 'UTIL';
        $this->version = '0.1.0.0';
        $this->description = 'Clears all the data stored in the diferent log tables.';
        $this->haspanel = true;
        $this->interface = array(array('name' => 'TRUNCATE TABLES',
			 'dict' => 'GEN_LBL_TRUNCATE_RECORDS',
//			 'init' => true,
			 'init' => false,
			 'table' => 'CLX_DB_TABLES',
			 'dir' => '',
			 'archive' => 'true',
			 'tool' => 'DBTB'
		  ) 
		);
    }

    function panel($msg) {
        $contents = '';
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->addArgument(CLX_PROP_TO, 'UTIL');
        $form->addArgument('ut', $this->code);	
        $form->addArgument('ac', 'PANEL');
        $form->addArgument('confirm', '1');
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $table->addCell(dict('TOOL_CLEAR_TABLE'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addCell(dict('TOOL_CLEAR_TABLE_EXPLAIN'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $class = CLX_CLASS_DATA;
        
		
		
	    $table->addCells(CLX_CLASS_HEADERS, array( dict('GEN_LBL_TABLES')));

		$pop = new HTMLSelect('DBTB_selected');
        $pop->setProp('size', '10');
        $records = ClxCommon::$db->executeQuery('SELECT  MODULECODE, IDCODE TABLECODE, IDNAME TABLENAME FROM CLX_DB_TABLES ORDER BY MODULECODE, TABLECODE');
        while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
    
            $pop->addItem( $record['MODULECODE'].'_'.$record['TABLENAME']. ' (' .  $record['TABLECODE']. ')', $record['MODULECODE'].'_'.$record['TABLENAME'].'|'.$record['TABLECODE'], false);
        }
        $table->addCell($pop->source(), array());
  
		
		
        $c = new htmlSubmit(dict('GEN_LBL_TRUNCATE'));
        $buttons = $c->source();
        $c = new htmlButtonCancel();
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $contents = $form->source();
        return $contents;
    }

    function checkPanel(&$msg) {
        $msg = array();
        return count($msg) == CLX_NUM_ZERO;
    }

    function execute_() {
		if (isset( UserRequest::$request ['DBTABLES'])){
			$vl=explode('|',UserRequest::$request ['DBTABLES']);
			UserRequest::$request ['DBTABLES']=$vl[0];
			$tablecode=$vl[1];
			//pre($tablecode);
			$archsal='';	
			if (isset( UserRequest::$request ['selector_savadata'])){ 
				if (kDatabaseType == 'oci') {
					$select='SELECT COLUMN_NAME,DATA_TYPE FROM ALL_TAB_COLUMNS WHERE TABLE_NAME = '.singlequote(UserRequest::$request ['DBTABLES']);
				}
				else {
					//$select='SELECT COLUMN_NAME,DATA_TYPE FROM ALL_TAB_COLUMNS WHERE TABLE_NAME = '.singlequote(UserRequest::$request ['DBTABLES']);
                    $select='SELECT COLUMN_NAME,DATA_TYPE FROM INFORMATION_SCHEMA.COLUMNS WHERE table_schema=DATABASE() AND TABLE_NAME = '.singlequote(UserRequest::$request ['DBTABLES']);
				}
				$recs = ClxCommon::$db->executeQuery($select);
				$fields=array();
				while ($rec = ClxCommon::$db->getNextRecord($recs, ASSOCIATIVE)) {
					$fields[$rec['COLUMN_NAME']]=$rec['DATA_TYPE'];
				}
				$textsalida='';
				$init=1;
				$records = ClxCommon::$db->executeQuery('SELECT * FROM '.UserRequest::$request ['DBTABLES']);
				
				while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
					if ($init==1) {
						$col=array_keys($record);
						$INSERTFIELDS='INSERT INTO '.UserRequest::$request ['DBTABLES'].'('.implode(',',$col).') values (';
						for($t=0;$t<count($col);$t++) {
							if ($t>0)
								$INSERTFIELDS.=',';
							IF ($fields[$col[$t]]=='NUMBER'){
								$INSERTFIELDS.='%s';		
								
							}
							else {
								$INSERTFIELDS.=singlequote('%s');			
							}		
						}
						$INSERTFIELDS.=')';
						$init=0;	
					}
					
					$textsalida.=vsprintf($INSERTFIELDS,$record);
					$textsalida.=';'.chr(13).chr(10);
					
				}
				$salx=fopen(kPathToWebSite.kPathToTemp.($arcsal='sql'.rand(1,10000000).'.sql'),"w+");
				fwrite($salx,$textsalida);
				fclose($salx);
			}
			ClxCommon::$db->executeQuery('TRUNCATE TABLE '.	UserRequest::$request ['DBTABLES']);
			if (isset($GLOBALS['apc_cache_get_tables_queries'][$tablecode])) {
				apc_clear_xppaging_count_all_user($tablecode);
			}
		
			$form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
			$form->addArgument(CLX_PROP_TO, 'UTIL');
			$form->addArgument('ut', $this->code);	
			$form->addArgument('ac', 'PANEL');
			$form->addArgument('confirm', '1');
			$table = new htmlTable(CLX_WIDTH_TWO);
			$table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
			$table->addCell(dict('GEN_TTL_TRUNCATE_TERMINATE').'<BR>' 
			.(empty($arcsal)?'':'<br><a href='.kWebSite.'/download.php?filename='.$arcsal.'&site='.kPathToWebSite.'>'.dict('GEN_TTL_EXPORT_SQL').'</a>'), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
			
			
			
			
			$buttons = '';
			//$buttons .=htmlButton::getButton('submit', 'continue', array('action' => $ac,'ac=list', 'form' => $form->getProp(CLX_PROP_ID)))->source();
			$c = new htmlButtonCancel('continue');
			$buttons .= $c->source();
			$table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
			$form->setContents($table->source());
			return $form->source();
		
		
		
		
		
		

		}
		else {
			$form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
			$form->addArgument(CLX_PROP_TO, 'UTIL');
			$form->addArgument('ut', $this->code);	
			$form->addArgument('ac', 'PANEL');
			$form->addArgument('confirm', '1');
			$form->addArgument('DBTABLES', UserRequest::$request['DBTB_selected']);
			$table = new htmlTable(CLX_WIDTH_TWO);
			$table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
			$table->addCell(dict('GEN_TTL_TRUNCATE'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
			$table->addCell(dict('GEN_TTL_TRUNCATE_CONFIRM', UserRequest::$request['DBTB_selected']), array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
			
			
			
			$select = new htmlCheckbox('selector_savadata' , false);
			$table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
			  $table->addCell(dict('GEN_TTL_EXPORT_DATA'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
			  
			$buttons = '';
			$buttons .=htmlButton::getButton('submit', dict('GEN_LBL_TRUNCATE'), array('action' => UserRequest::$request['ac'], 'form' => $form->getProp(CLX_PROP_ID)))->source();
			$c = new htmlButtonCancel();
			$buttons .= $c->source();
			$table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
			$form->setContents($table->source());
			return $form->source();
		}
        
    }

    

}
