<?php

/**
 * Plot Tool Manager
 * For more information contact  support@alenet.com
 *
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2019-01-22 15:20:30 -0400 (ma., 22 ene. 2019) $
 * @version    	$Rev: 10484 $
 *
 * Based on Fusion Lite Chart http://www.infosoftglobal.com/
 * 7/5/2005 Oracle uppercase record changed
 */
class an_plot extends clx_tool {

    var $fonttypes;

    /**
     * Constructor
     */
    function __construct() {
        $this->code = 'ANPL';
        $this->name = 'Charts Plot Manager';
        $this->system = 'Analytics';
        $this->version = '4.0.1.2';

        $this->has_access = true;
        $this->has_package = true;
        $this->has_pagelet = true;
        $this->tablename = 'CLX_AN_PLOT';
        $this->record_name_singular = 'chart';
        $this->record_name_plural = 'charts';
        $this->primary_field = 'IDCODE';
        $this->secondary_field = 'IDNAME';

        $this->yes_no = array('GEN_LBL_NO', 'GEN_LBL_YES');
        $this->fonttypes = array('arial' => 'Arial',
		  'verdana' => 'Verdana');
    }

    function install() {
        $UIMI = getTool('UIMI');
        $UIMI->add($this->code, 'MENU_TOOLS:MENU_ANALYTICS:MENU_PLOT', 'TOOL', $this->code, 'ac=LIST');
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['IDCODE'] = array('type' => 'varchar(16)', 'null' => 'NO');
        $fields['IDNAME'] = array('type' => 'varchar(64)', 'null' => 'NO');
        $fields['TITLE'] = array('type' => 'varchar(50)', 'null' => 'NO', 'dict' => true);
        $fields['SUBTITLE'] = array('type' => 'varchar(50)', 'null' => 'NO', 'dict' => true);
        $fields['XLABEL'] = array('type' => 'varchar(50)', 'null' => 'YES', 'dict' => true);
        $fields['YLABEL'] = array('type' => 'varchar(50)', 'null' => 'YES', 'dict' => true);
        $fields['LINE_AVERAGE'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['LINE_MAX'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['LINE_MIN'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['SHOWNAMES'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['ROTATE_NAMES'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['SHOWVALUES'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['ANIMATION'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['SHOW_LEGEND'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['SHOW_COLSHADOW'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['SHOW_PCTVALUES'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['SHOW_PCTINLABEL'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['VERSION'] = array('type' => 'varchar(32)', 'null' => 'NO');
        $fields['VERSION_COUNTER'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES');
        $fields['MDATE'] = array('type' => 'datetime', 'null' => 'YES');
        $fields['USERNAME'] = array('type' => 'varchar(30)', 'null' => 'NO');
        $fields['DESCRIPTION'] = array('type' => 'mediumtext', 'null' => 'YES');
        $fields['QUERYCODE'] = array('type' => 'varchar(16)', 'null' => 'NO');
        $fields['MODULECODE'] = array('type' => 'varchar(4)', 'null' => 'NO');
        $fields['HSIZE'] = array('type' => 'int(5) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['VSIZE'] = array('type' => 'int(5) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['FONTSIZE'] = array('type' => 'int(3) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['FONTTYPE'] = array('type' => 'varchar(16)', 'null' => 'NO');
        $fields['BORDER'] = array('type' => 'int(3) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['PLOT_TYPE'] = array('type' => 'varchar(4)', 'null' => 'NO');
        $fields['SEARCH_FORM'] = array('type' => 'varchar(16)', 'null' => 'YES');
        $fields['EXEONSEARCH'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['FIELD_EXTRA1'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['FIELD_EXTRA2'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['FIELD_EXTRA3'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['FIELD_EXTRA4'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['FIELD_EXTRA5'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['FIELD_EXTRA6'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['FIELD_EXTRA7'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['FIELD_EXTRA8'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['FIELD_EXTRA9'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['FIELD_EXTRA10'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['FIELD_EXTRA11'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['FIELD_EXTRA12'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['FIELD_EXTRA13'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['FIELD_EXTRA14'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $fields['FIELD_EXTRA15'] = array('type' => 'varchar(255)', 'null' => 'YES');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'IDCODE');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'IDNAME');
        $indexes[$ipf . '04'] = array('index' => 'MUL', 'fieldname' => 'QUERYCODE');
        $indexes[$ipf . '05'] = array('index' => 'MUL', 'fieldname' => 'MODULECODE');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB', 'fields' => $fields, 'indexes' => $indexes);
    }

    function pack($record) {
        $o = $this->packRecord($record);
        $code = $record['IDCODE'];
        $objs = new XMLObject($this->code . '_OBJECTS');
        $this->packsub($objs, 'ANPS', 'SELECT * FROM CLX_AN_PLOT_SERIES WHERE CHARTCODE=' . singleQuote($code));
        $this->packsub($objs, 'DICT', 'SELECT DICT.* FROM CLX_DICTIONARY DICT, CLX_AN_PLOT X WHERE (DICT.ENTRY=X.TITLE OR DICT.ENTRY=X.SUBTITLE OR DICT.ENTRY=X.XLABEL OR DICT.ENTRY=X.YLABEL) AND X.IDCODE=' . singleQuote($code));
        $o->addObject($objs);
        return $o;
    }

    function unpack($parameters) {
        $parameters = array_values(array_merge(array('package' => null), $parameters));
        list($package) = $parameters;
        $record = $this->unpackRecord($package);
        $chartcode = $record['IDCODE'];
        $exists = (ClxCommon::$db->oneExistsRecords($this->tablename, 'IDCODE=' . singleQuote($chartcode)) > CLX_NUM_ZERO);
        if ($exists === true) {
		  $chartid = ClxCommon::$db->getField($this->tablename, 'ID', 'IDCODE=' . singleQuote($chartcode));
		  $this->deleteRecordSk($chartid);
        }
        $chartid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        if ($package->hasSubObject($this->code . '_OBJECTS')) {
		  $objs = $package->getObjectXml($this->code . '_OBJECTS');
		  foreach ($objs->objects as $o) {
			 $toolcode = $o->tag;
			 $tool = &getTool($toolcode);
			 $tool->unpack(array('package' => $o, 'id' => $chartcode));
		  }
        }
    }

    function action($ac, $idlist) {
        if ($this->getAccess()->canRead()) {
		  switch ($ac) {
			 case 'PLOT':
			     $contents = $this->plot(UserRequest::$request['pl']);
			     break;
			 case 'XML':
			     sendXmlHeader();
			     $contents = $this->getXmlData(UserRequest::$request['pl']);
			     break;
			 default:
			     $contents = parent::action($ac, $idlist);
			     break;
		  }
        } else {
		  $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [AN_PLOT-CAN_READ_3][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    function makelist($listingcode = null) {
        $t = time();
        $to = $this->code;
        $here = 'tool.php?to=' . $to . '&t=' . $t;
        clearHistory();
        pushHistory($this->code, 'LIST', array());
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->setProp(CLX_PROP_ID, 'ANPLList');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'NOT_DEFINED');
        $selectclause = '*';
        $fromclause = 'CLX_AN_PLOT';
        $whereclause = '';
        $sortclause = '';
        $page = new xPaging();
        $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
        $table = new htmlTable(CLX_WIDTH_NINE);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_ANPL_TITLE_LIST'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_NINE));
        $page->header($table);
        $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_MODULECODE'), dict('GEN_LBL_QUERYCODE'), dict('GEN_LBL_CODE'), dict('GEN_LBL_NAME'), dict('GEN_LBL_TYPE'), dict('GEN_LBL_VERSION'), dict('GEN_LBL_DESCRIPTION'), dict('GEN_LBL_ANIMATION')));
        $i = CLX_INIT_ZERO;
        while ($record = $page->nextRecord()) {
		  $recordid = $record['ID'];
            if (ClxCommon::$db->oneExistsRecords('CLX_OBJECTS', 'IDCODE = ' . singleQuote($record['PLOT_TYPE'])) > CLX_NUM_ZERO) {
			 $fieldobject = getToolObject('PLOT', $record['PLOT_TYPE']);
			 $name = $fieldobject->name;
		  } else {
			 $name = '-error-';
		  }
		  $select = new htmlCheckbox('selector_' . $recordid, false);
		  $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
		  $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
		  $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array($record['MODULECODE'], $record['QUERYCODE'], $record['IDCODE'], $record['IDNAME'], $name, $record['VERSION'] . '-' . $record['VERSION_COUNTER'], xFormat::text($record['DESCRIPTION']), dict($this->yes_no[$record['ANIMATION']])));
		  $i++;
        }
        $buttons = '';
        $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_DISPLAY'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        if ($this->getAccess()->canModify()) {
		  $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canDelete()) {
		  $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canDisplay()) {
		  $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DUPLICATE'), array('action' => 'DUPLICATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ONE'))->source();
        }
        if ($this->getAccess()->canDisplay()) {
		  $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE_SOMETHING', dict('GEN_LBL_CHART')), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        }
        $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_FILTER'), array('action' => 'FILTER', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        $form->addContents($page->footers($table, $buttons));
        return $form->source();
    }

    function searchForm() {
        $msg = array();
        $contents = '';
        // Search Form
        $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF']);
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'SEARCH');
        $form->addArgument('confirm', '1');
        $form->addArgument(CLX_PROP_TARGET, UserRequest::$request[CLX_PROP_TARGET]);
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_ANPL_TITLE_SEARCH'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        if (!array_key_exists('ANPL_idcode', UserRequest::$post))
		  UserRequest::$post['ANPL_idcode'] = '';
        $table->addField($msg, dict('GEN_LBL_CODE') . ':', 'ANPL_idcode', UserRequest::$post['ANPL_idcode'], CLX_NUM_16, CLX_NUM_16);
        if (!array_key_exists('ANPL_idname', UserRequest::$post))
		  UserRequest::$post['ANPL_idname'] = '';
        $table->addField($msg, dict('GEN_LBL_NAME') . ':', 'ANPL_idname', UserRequest::$post['ANPL_idname'], CLX_NUM_32, CLX_NUM_64);
        if (!array_key_exists('ANPL_querycode', UserRequest::$post))
		  UserRequest::$post['ANPL_querycode'] = '';
        $table->addField($msg, dict('GEN_LBL_QUERYCODE') . ':', 'ANPL_querycode', UserRequest::$post['ANPL_querycode'], CLX_NUM_16, CLX_NUM_16);
        if (!array_key_exists('ANPL_modulecode', UserRequest::$post))
		  UserRequest::$post['ANPL_modulecode'] = '';
        $table->addField($msg, dict('GEN_LBL_MODULECODE') . ':', 'ANPL_modulecode', UserRequest::$post['ANPL_modulecode'], CLX_NUM_FOUR, CLX_NUM_FOUR);
        $buttons = htmlButton::getButton('submit', dict('GEN_LBL_SEARCH'), array('action' => 'SEARCH', 'form' => $form->getProp(CLX_PROP_ID)))->source();
       // $buttons = $c->source();
        $c = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $contents .= $form->source();
        // Search Procedure
        if (isset(UserRequest::$post['confirm'])) {
		  $table = new htmlTable(CLX_WIDTH_TWO);
		  $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
		  $criteria = '';
		  if (UserRequest::$post['ANPL_idcode'] <> '') {
			 $criteria .= 'UPPER(IDCODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['ANPL_idcode']) . '%');
		  }
		  if (UserRequest::$post['ANPL_idname'] <> '') {
			 $criteria .= 'UPPER(IDNAME) LIKE ' . singleQuote(uppercase(clx_change_especial_char_html (UserRequest::$post['ANPL_idname'])) . '%');
		  }
		  if (UserRequest::$post['ANPL_modulecode'] <> '') {
			 $criteria .= 'UPPER(MODULECODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['ANPL_modulecode']) . '%');
		  }
		  if (UserRequest::$post['ANPL_querycode'] <> '') {
			 $criteria .= 'UPPER(QUERYCODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['ANPL_querycode']) . '%');
		  }
            $qty = ClxCommon::$db->oneExistsRecords($this->tablename, $criteria);
		  if ($qty == CLX_NUM_ZERO) {
			 $table->addCell(dict('TOOL_GEN_ERR_NOMATCH'), array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
		  } else {
			 $table->addCell(dict('TOOL_GEN_MSG_FOUNDRECORDS'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
			 $records = ClxCommon::$db->getRecords($this->tablename, $criteria);
			 $i = CLX_INIT_ZERO;
			 while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
			     $js = 'javascript:setLookupValue(' . quote(UserRequest::$request[CLX_PROP_TARGET]) . ', ' . quote($record['IDCODE']) . ');';
			     $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array('<page t=an_plot></page><a href=' . singleQuote($js) . '>' . $record['IDCODE'] . '</a>', $record['IDNAME']));
			     $i++;
			 }
		  }
		  $contents .= $table->source();
        }
        return $contents;
    }

    /**
     * Edit Form
     * @param type $ac
     * @param type $idlist
     * @param type $record
     * @param type $msg
     * @return type
     */
    function editForm($ac, $idlist, $record, $msg) {

        $DICT = &getTool('DICT');
        $modify = (UserRequest::$request['ac'] === 'MODIFY') ? true : false;
        $title = ($modify) ? dict('TOOL_ANPL_TITLE_MODIFY') : dict('TOOL_ANPL_TITLE_CREATE');

        // Build/get the different javascripts...
        $OBJS = &getTool('OBJS');
        $plotcodes = $OBJS->objectList('PLOT');
        $list = 'var panellist = new Array();' . CLX_CHAR_NL . CLX_CHAR_NL;
        $i = CLX_INIT_ZERO;
        foreach ($plotcodes as $plotcode) {
		  $list .= sprintf('panellist[%s] = ' . singleQuote('%s') . ';', $i, $plotcode) . CLX_CHAR_NL;
		  $i++;
        }

        $script = setJavaScriptTag($list, false);

        $variables = array();
        $variables['VISIBLEPANEL'] = 'ANPL_plot_type';
        $topscript = setJavaScriptTag(getJavaScript('dynform_top.js', $variables), false);
        $topscript .= setJavascriptTag(getJavaScriptFilename('PLOT_editform.js'), true);
        $btmscript = setJavaScriptTag(getJavaScriptFilename('dynform_btm.js'), true);
        $btmscript .= setJavaScriptTag('initForm();', false);

        //Build the form
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', $ac);
        $form->addArgument('confirm', '1');
        $form->addArgument('ANPL_id', $record['ANPL_id']);
        $form->addArgument('idlist', toString($idlist));

        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell($title, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        if (!empty($modify)) {
		  $table->addData(dict('GEN_LBL_CODE') . ':', $record['ANPL_idcode']);
		  $form->addArgument('ANPL_idcode', $record['ANPL_idcode']);
        } else {
		  $table->addField($msg, dict('GEN_LBL_CODE') . ':', 'ANPL_idcode', $record['ANPL_idcode'], CLX_NUM_16, CLX_NUM_16);
        }
        $table->addField($msg, dict('GEN_LBL_NAME') . ':', 'ANPL_idname', $record['ANPL_idname'], CLX_NUM_48, CLX_NUM_64);

        //Title, subtitle and axis labels
        $DICT->editEntry($msg, dict('GEN_LBL_TITLE') . ':', 'ANPL_title', $record, $table, $form);
        $DICT->editEntry($msg, dict('GEN_LBL_SUBTITLE') . ':', 'ANPL_subtitle', $record, $table, $form);
        $table->addText($msg, dict('GEN_LBL_DESCRIPTION') . ':', 'ANPL_description', $record['ANPL_description'], CLX_NUM_FOUR, CLX_NUM_48);
        $table->addField($msg, dict('GEN_LBL_VERSION') . ':', 'ANPL_version', $record['ANPL_version'], CLX_NUM_16, CLX_NUM_16);
        $DBQY = &getTool('DBQY');
        $DBQY->placeChooseQuery($msg, dict('GEN_LBL_QUERYCODE') . ':', 'ANPL_querycode', $record['ANPL_querycode'], $table);
        $DBMO = &getTool('DBMO');
        $DBMO->placeChooseModule($msg, dict('GEN_LBL_MODULECODE') . ':', 'ANPL_modulecode', $record['ANPL_modulecode'], $table);
        $UIFM = &getTool('UIFM');
        $UIFM->placeChooseForm($msg, dict('TOOL_UILG_PROMPT_SCHFORM') . ':', 'ANPL_search_form', $record['ANPL_search_form'], $table);
        $pop = new HTMLSelect('ANPL_exeonsearch');
        foreach ($this->yes_no as $key => $val) {
		  $pop->addItem(dict($val), $key, ($record['ANPL_exeonsearch'] == $key));
        }
        $table->addData(dict('TOOL_UILG_PROMPT_EXEONSEARCH') . ':', $pop->source());
        $table->addSeparator(CLX_CLASS_DATA);

        $table2 = new htmlTable(CLX_NUM_FOUR);
        $table2->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table2->addField($msg, dict('GEN_LBL_HSIZE') . ':', 'ANPL_hsize', $record['ANPL_hsize'], CLX_NUM_FIVE, CLX_NUM_FIVE);
        $table2->addField($msg, dict('GEN_LBL_VSIZE') . ':', 'ANPL_vsize', $record['ANPL_vsize'], CLX_NUM_FIVE, CLX_NUM_FIVE);
        $pop = new htmlSelect($this->code . '_fonttype');
        foreach ($this->fonttypes as $key => $val) {
		  $pop->addItem($val, $key, ($record[$this->code . '_fonttype'] == $key));
        }
        $table2->addData(dict('GEN_LBL_FONT_TYPE') . ':', $pop->source());
        $table2->addField($msg, dict('GEN_LBL_FONTSIZE') . ':', 'ANPL_fontsize', $record['ANPL_fontsize'], CLX_NUM_FIVE, CLX_NUM_THREE);
        $table2->addYesNo(dict('TOOL_UILG_PROMPT_SHOWNAMES'), 'ANPL_shownames', $record['ANPL_shownames'], CLX_NUM_ZERO);
        $table2->addYesNo(dict('GEN_LBL_ROTATE_NAMES'), 'ANPL_rotate_names', $record['ANPL_rotate_names'], CLX_NUM_ZERO);
        $table2->addYesNo(dict('TOOL_UILG_PROMPT_SHOWVALUES'), 'ANPL_showvalues', $record['ANPL_showvalues'], CLX_NUM_ZERO);
        $table2->addYesNo(dict('TOOL_UILG_SHOW_LEGEND'), 'ANPL_show_legend', $record['ANPL_show_legend'], CLX_NUM_ZERO);
        $table2->addYesNo(dict('TOOL_UILG_SHOW_COL_SHADOW'), 'ANPL_show_colshadow', $record['ANPL_show_colshadow'], CLX_NUM_ZERO);
        $table2->addYesNo(dict('TOOL_UILG_SHOW_PCT_VALUES'), 'ANPL_show_pctvalues', $record['ANPL_show_pctvalues'], CLX_NUM_ZERO);
        $table2->addYesNo(dict('TOOL_UILG_SHOW_PCT_ONLBL'), 'ANPL_show_pctinlabel', $record['ANPL_show_pctinlabel'], CLX_NUM_ZERO);
        $table2->addYesNo(dict('TOOL_UILG_PROMPT_ANIMATION'), 'ANPL_animation', $record['ANPL_animation'], CLX_NUM_ZERO);
        $table2->addField($msg, dict('GEN_LBL_BORDER') . ':', 'ANPL_border', $record['ANPL_border'], CLX_NUM_FIVE, CLX_NUM_TWO);
        $table2->addSeparator(CLX_CLASS_DATA, false, CLX_NUM_TWO);

        $table->addCell($table2->source(), array(CLX_PROP_COLSPAN => CLX_NUM_TWO));
        //Plot Type
        if (!empty($msg['ANPL_plot_type'])) {
		  $table->addCell($msg['ANPL_plot_type'], array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        }
        $plots = $OBJS->objectPop('PLOT', 'ANPL_plot_type', $record['ANPL_plot_type']);
        $plots->setProp('onchange', 'updateForm();');
        $table->addData(dict('GEN_LBL_TYPE'), $plots->source());

        $form->addContents($table->source());
        //-- Plot Types Properties
        foreach ($plotcodes as $plotcode) {
		  $fieldobject = $OBJS->getObject_('PLOT', $plotcode);
		  $form->addContents($fieldobject->panel($msg, $record, $form));
        }

        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $buttons = (!empty($modify)) ? htmlButton::getButton('submit', dict('GEN_LBL_SAVE'), array('action' => $ac, 'form' => $form->getProp(CLX_PROP_ID)))->source() : htmlButton::getButton('submit', dict('GEN_LBL_CREATE'), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID)))->source();

        $c = new htmlButtonCancel();
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->addContents($table->source());
        return $script . $topscript . $form->source() . $btmscript;
    }

    function checkForm(&$msg) {
        $msg = array();
        $action = UserRequest::$post['ac'];
        if ($action === 'CREATE') {
		  xValidate::unique($msg, 'ANPL_idcode', 'idcode', $this->tablename, 'IDCODE=' . singleQuote(UserRequest::$post['ANPL_idcode']));
        }
        $DBQY = &getTool('DBQY');
        if (!$DBQY->queryExists(UserRequest::$post['ANPL_querycode'])) {
		  $msg['ANPL_querycode'] = dict('TOOL_UIVW_NOQUERYCODE');
        }
        if (strlen(UserRequest::$post['ANPL_idname']) == CLX_NUM_ZERO) {
		  $msg['ANPL_idname'] = dict('GEN_ERR_REQUIRED_FIELD');
        }
        $DBMO = &getTool('DBMO');
        if (!$DBMO->moduleExists(UserRequest::$post['ANPL_modulecode'])) {
		  $msg['ANPL_modulecode'] = dict('TOOL_DBMO_ERR_NO_RECORD');
        }
        //Check Form for now only one
        $UIFM = &getTool('UIFM');
        $forms = array('ANPL_search_form');
        reset($forms);
        foreach ($forms as $key => $val) {
		  if (!empty(UserRequest::$post[$val])) {
			 if (!$UIFM->formExists(UserRequest::$post[$val])) {
			     $msg[$val] = dict('TOOL_UILG_ERR_NOFORMCODE');
			 }
		  }
        }
        xValidate::integer($msg, 'ANPL_hsize', UserRequest::$post['ANPL_hsize'], CLX_NUM_HUNDRED, '5000', dict('GEN_LBL_HSIZE'));
        xValidate::integer($msg, 'ANPL_vsize', UserRequest::$post['ANPL_vsize'], CLX_NUM_HUNDRED, '5000', dict('GEN_LBL_VSIZE'));
        xValidate::integer($msg, 'ANPL_fontsize', UserRequest::$post['ANPL_fontsize'], '1', '50', dict('GEN_LBL_VSIZE'));
        xValidate::integer($msg, 'ANPL_border', UserRequest::$post['ANPL_border'], '0', '50', dict('GEN_LBL_VSIZE'));
        if (UserRequest::$post['ANPL_exeonsearch'] == CLX_NUM_ONE && UserRequest::$post['ANPL_search_form'] === '') {
		  $msg['ANPL_search_form'] = dict('TOOL_UILG_ERR_SRCHFORMREQUIRED');
        }
        return count($msg) == CLX_NUM_ZERO;
    }

    function confirmDeleteFill(&$table, $record) {
        $table->addData(dict('GEN_LBL_CODE') . ':', $record['ANPL_idcode']);
        $table->addData(dict('GEN_LBL_NAME') . ':', $record['ANPL_idname']);
    }

    function viewFormFill($record) {

        addHistory('chartcode', $record['ANPL_idcode']);
        $contents = '';

        $table = new htmlTable(CLX_WIDTH_ONE);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_ANPL_TITLE_VIEW') . ': ' . $record['ANPL_idname'], array(CLX_PROP_CLASS => CLX_CLASS_TITLE));
        $contents .= $table->source();
        $infotable = new htmlTable(CLX_WIDTH_TWO);
        $infotable->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $infotable->addData(dict('GEN_LBL_CODE') . ':', $record['ANPL_idcode']);
        $infotable->addData(dict('GEN_LBL_NAME') . ':', $record['ANPL_idname']);
        $infotable->addData(dict('GEN_LBL_TITLE') . ':', dict($record['ANPL_title']));
        $infotable->addData(dict('GEN_LBL_SUBTITLE') . ':', dict($record['ANPL_subtitle']));
        $infotable->addData(dict('GEN_LBL_DESCRIPTION') . ':', xFormat::text($record['ANPL_description']));
        $infotable->addData(dict('GEN_LBL_VERSION') . ':', $record['ANPL_version'] . '-' . $record['ANPL_version_counter']);
        $infotable->addData(dict('GEN_LBL_MODULECODE') . ':', $record['ANPL_modulecode']);
        $infotable->addData(dict('GEN_LBL_QUERYCODE') . ':', $record['ANPL_querycode']);
        $infotable->addData(dict('TOOL_UILG_PROMPT_SCHFORM') . ':', $record['ANPL_search_form']);
        $infotable2 = new htmlTable(CLX_WIDTH_FOUR);
        $infotable2->addData(dict('GEN_LBL_FONTTYPE') . ':', $this->fonttypes[$record['ANPL_fonttype']]);
        $infotable2->addData(dict('GEN_LBL_SIZE') . ':', $record['ANPL_hsize'] . ' x ' . $record['ANPL_vsize']);
        $infotable2->addData(dict('GEN_LBL_FONTSIZE') . ':', $record['ANPL_fontsize']);
        $infotable2->addData(dict('GEN_LBL_BODER') . ':', $record['ANPL_border']);
        $infotable2->addData(dict('GEN_LBL_SHOWNAMES') . ':', dict($this->yes_no[$record['ANPL_shownames']]));
        $infotable2->addData(dict('GEN_LBL_ROTATE_NAMES') . ':', dict($this->yes_no[$record['ANPL_rotate_names']]));
        $infotable2->addData(dict('GEN_LBL_SHOWVALUES') . ':', dict($this->yes_no[$record['ANPL_showvalues']]));
        $infotable2->addData(dict('GEN_LBL_ANIMATION') . ':', dict($this->yes_no[$record['ANPL_animation']]));
        $infotable2->addData(dict('TOOL_UILG_SHOW_LEGEND') . ':', dict($this->yes_no[$record['ANPL_show_legend']]));
        $infotable2->addData(dict('TOOL_UILG_SHOW_COL_SHADOW') . ':', dict($this->yes_no[$record['ANPL_show_colshadow']]));
        $infotable2->addData(dict('TOOL_UILG_SHOW_PCT_VALUES') . ':', dict($this->yes_no[$record['ANPL_show_pctvalues']]));
        $infotable2->addData(dict('TOOL_UILG_SHOW_PCT_ONLBL') . ':', dict($this->yes_no[$record['ANPL_show_pctinlabel']]));
        $infotable->addCell($infotable2->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_NUM_TWO));
        $contents .= $infotable->source();

        /*         * **************** Details *********************** */
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $plotinstance = getToolObject('PLOT', $record['ANPL_plot_type']);
        $plotinstance->viewForm($table, $record);
        $contents .= buildPanelInterface('', 'PLOTDETAILS', $table->source(), -1 * CLX_NUM_ONE);

        /*         * **************** Preview *********************** */
        $imgconttable = new htmlTable(CLX_WIDTH_TWO);
        $imgconttable->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $imgtable = new htmlTable(CLX_WIDTH_ONE);
        $imgtable->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));

        $imgtable->addCell(dict('GEN_LBL_PLOT_SAMPLE'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE));
        $img = $this->plot($record['ANPL_idcode']);
        $imgtable->addCell($img, array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $imgconttable->addCell($imgtable->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));

        $imgtable = new htmlTable(CLX_WIDTH_ONE);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $imgtable->addCell(dict('GEN_LBL_PLOT_XML'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE));
        $text = new htmlTextArea('', $this->getXmlData($record['ANPL_idcode']), CLX_NUM_15, CLX_NUM_60);
        $text->setProp('readonly', 'true');
        $imgtable->addCell($text->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $imgconttable->addCell($imgtable->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $contents .= $imgconttable->source();
        /*         * **************** Ranges *********************** */
        if ($plotinstance->has_range === true) {
		  $ANPR = &getTool('ANPR');
		  $contents .= '<br>' . $ANPR->makepanel($record['ANPL_idcode']);
        }
        /*         * **************** Series *********************** */
        $ANPS = &getTool('ANPS');
        $contents .= $ANPS->makepanel($record['ANPL_idcode']);
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $table->addData(dict('GEN_LBL_CDATE') . ':', $record['ANPL_cdate']);
        $table->addData(dict('GEN_LBL_MDATE') . ':', $record['ANPL_mdate']);
        $table->addData(dict('GEN_LBL_USERNAME') . ':', $record['ANPL_username']);
        $contents .= buildPanelInterface(dict('GEN_TTL_SYSTEMINFO'), 'SYSTEMINFO', $table->source(), CLX_NUM_MINUS_1);
        return $contents;
    }

    function filterFormFill($msg, &$table) {
        $table->addField($msg, dict('GEN_LBL_CODE') . ':', 'ANPL_idcode', '', CLX_NUM_16, CLX_NUM_16);
        $table->addField($msg, dict('GEN_LBL_NAME') . ':', 'ANPL_idname', '', CLX_NUM_32, CLX_NUM_64);
        $table->addField($msg, dict('GEN_LBL_MODULECODE') . ':', 'ANPL_modulecode', '', CLX_NUM_FOUR, CLX_NUM_FOUR);
        $table->addField($msg, dict('GEN_LBL_QUERYCODE') . ':', 'ANPL_querycode', '', CLX_NUM_16, CLX_NUM_16);
        $sort = new HtmlSelect('ANPL_sort');
        $sort->addItem('', '', true);
        $sort->addItem('Module Code', 'modulecode', false);
        $sort->addItem('Query Code', 'querycode', false);
        $sort->addItem('Code', 'idcode', false);
        $sort->addItem('Name', 'idname', false);
        $table->addData(dict('GEN_LBL_ORDERBY') . ':', $sort->source());
    }

    function setfilter() {
        $filter = '';
        $boolean = '';
        if (!empty(UserRequest::$post['ANPL_idcode'])) {
		  $filter .= $boolean . ' UPPER(IDCODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['ANPL_idcode']) . '%');
		  $boolean = 'AND';
        }
        if (!empty(UserRequest::$post['ANPL_idname'])) {
		  $filter .= $boolean . ' UPPER(IDNAME) LIKE ' . singleQuote(uppercase(UserRequest::$post['ANPL_idname']). '%');
		  $boolean = 'AND';
        }
        if (!empty(UserRequest::$post['ANPL_modulecode'])) {
		  $filter .= $boolean . ' UPPER(MODULECODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['ANPL_modulecode']) . '%');
		  $boolean = 'AND';
        }
        if (!empty(UserRequest::$post['ANPL_querycode'])) {
		  $filter .= $boolean . ' UPPER(QUERYCODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['ANPL_querycode']) . '%');
		  $boolean = 'AND';
        }
        $_SESSION['paging']['ANPLList']['sortby'] = UserRequest::$post['ANPL_sort'];
        $_SESSION['paging']['ANPLList']['criteria'] = $filter;
        $_SESSION['paging']['ANPLList']['startat'] = '0';
    }
	///////////////////////////////////////////////////
	///comentado 22/01/2019 para utilizar la clx_tool
	//////////////////////////////////////////////////
    /*function clearfilter() {
        $_SESSION['paging']['ANPLList']['criteria'] = '';
    }*/

    function loadToolRecord($recordid) {
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $recordid);
        $record = array();
        $record['ANPL_id'] = $recordid;
        $record['ANPL_idcode'] = $values['IDCODE'];
        $record['ANPL_idname'] = $values['IDNAME'];
        $DICT = &getTool('DICT');
        $DICT->loadEntry('ANPL_title', $values['TITLE'], $record);
        $DICT->loadEntry('ANPL_subtitle', $values['SUBTITLE'], $record);
        $record['ANPL_version'] = $values['VERSION'];
        $record['ANPL_version_counter'] = $values['VERSION_COUNTER'];
        $record['ANPL_cdate'] = xFormat::date($values['CDATE']);
        $record['ANPL_mdate'] = xFormat::date($values['MDATE']);
        $record['ANPL_username'] = $values['USERNAME'];
        $record['ANPL_description'] = $values['DESCRIPTION'];
        $record['ANPL_modulecode'] = $values['MODULECODE'];
        $record['ANPL_querycode'] = $values['QUERYCODE'];
        $record['ANPL_search_form'] = $values['SEARCH_FORM'];
        $record['ANPL_hsize'] = $values['HSIZE'];
        $record['ANPL_vsize'] = $values['VSIZE'];
        $record['ANPL_fontsize'] = $values['FONTSIZE'];
        $record['ANPL_fonttype'] = $values['FONTTYPE'];
        $record['ANPL_border'] = $values['BORDER'];
        $record['ANPL_shownames'] = $values['SHOWNAMES'];
        $record['ANPL_rotate_names'] = $values['ROTATE_NAMES'];
        $record['ANPL_showvalues'] = $values['SHOWVALUES'];
        $record['ANPL_animation'] = $values['ANIMATION'];
        $record['ANPL_show_legend'] = $values['SHOW_LEGEND'];
        $record['ANPL_show_colshadow'] = $values['SHOW_COLSHADOW'];
        $record['ANPL_show_pctvalues'] = $values['SHOW_PCTVALUES'];
        $record['ANPL_show_pctinlabel'] = $values['SHOW_PCTINLABEL'];
        $record['ANPL_plot_type'] = $values['PLOT_TYPE'];
        $record['ANPL_exeonsearch'] = $values['EXEONSEARCH'];
        $OBJS = &getTool('OBJS');
        $plotcodes = $OBJS->objectList('PLOT');
        foreach ($plotcodes as $plotcode) {
		  $plotobject = $OBJS->getObject_('PLOT', $plotcode);
		  $plotobject->loadPanel($record, $values);
        }
        if ($values['PLOT_TYPE'] <> '') {
		  $plotobject = $OBJS->getObject_('PLOT', $values['PLOT_TYPE']);
		  $plotobject->loadPanel($record, $values);
        }
        return $record;
    }

    function saveRecord() {
        $d = xFormat::getNow('Y-m-d');
        $record = array();
        $record['IDNAME'] = UserRequest::$post['ANPL_idname'];
        $DICT = &getTool('DICT');
        $record['TITLE'] = $DICT->saveEntry('ANPL_title', UserRequest::$post);
        $record['SUBTITLE'] = $DICT->saveEntry('ANPL_subtitle', UserRequest::$post);
        $record['VERSION'] = UserRequest::$post['ANPL_version'];
        $record['MDATE'] = $d;
        $record['USERNAME'] = $_SESSION['user_record']['username'];
        $record['DESCRIPTION'] = UserRequest::$post['ANPL_description'];
        $record['QUERYCODE'] = UserRequest::$post['ANPL_querycode'];
        $record['SEARCH_FORM'] = UserRequest::$post['ANPL_search_form'];
        $record['MODULECODE'] = UserRequest::$post['ANPL_modulecode'];
        $record['HSIZE'] = UserRequest::$post['ANPL_hsize'];
        $record['VSIZE'] = UserRequest::$post['ANPL_vsize'];
        $record['FONTSIZE'] = UserRequest::$post['ANPL_fontsize'];
        $record['FONTTYPE'] = UserRequest::$post['ANPL_fonttype'];
        $record['BORDER'] = UserRequest::$post['ANPL_border'];
        $record['SHOWNAMES'] = UserRequest::$post['ANPL_shownames'];
        $record['ROTATE_NAMES'] = UserRequest::$post['ANPL_rotate_names'];
        $record['SHOWVALUES'] = UserRequest::$post['ANPL_showvalues'];
        $record['ANIMATION'] = UserRequest::$post['ANPL_animation'];
        $record['SHOW_LEGEND'] = UserRequest::$post['ANPL_show_legend'];
        $record['SHOW_COLSHADOW'] = UserRequest::$post['ANPL_show_colshadow'];
        $record['SHOW_PCTVALUES'] = UserRequest::$post['ANPL_show_pctvalues'];
        $record['SHOW_PCTINLABEL'] = UserRequest::$post['ANPL_show_pctinlabel'];
        $record['PLOT_TYPE'] = UserRequest::$post['ANPL_plot_type'];
        $record['exeonsearch'] = UserRequest::$post['ANPL_exeonsearch'];
        $plotobject = getToolObject('PLOT', UserRequest::$post['ANPL_plot_type']);
        $plotobject->savePanel($record);
        $recid = ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post['ANPL_id']);
        unset($recid);
        $this->versionIncrease('ID', UserRequest::$post['ANPL_id']);
    }

    function createRecordVoid_() {
        ClxFreeReturn($this->createRecord_());
    }

    function createRecord_() {
        $d = xFormat::getNow('Y-m-d');
        $record = array();
        $record['IDCODE'] = UserRequest::$post['ANPL_idcode'];
        $record['IDNAME'] = UserRequest::$post['ANPL_idname'];
        $DICT = &getTool('DICT');
        $record['TITLE'] = $DICT->createEntry('ANPL_title', UserRequest::$post);
        $record['SUBTITLE'] = $DICT->createEntry('ANPL_subtitle', UserRequest::$post);
        $record['VERSION'] = UserRequest::$post['ANPL_version'];
        $record['VERSION_COUNTER'] = '0';
        $record['CDATE'] = $d;
        $record['MDATE'] = $d;
        $record['USERNAME'] = $_SESSION['user_record']['username'];
        $record['DESCRIPTION'] = UserRequest::$post['ANPL_description'];
        $record['QUERYCODE'] = UserRequest::$post['ANPL_querycode'];
        $record['MODULECODE'] = UserRequest::$post['ANPL_modulecode'];
        $record['SEARCH_FORM'] = UserRequest::$post['ANPL_search_form'];
        $record['HSIZE'] = UserRequest::$post['ANPL_hsize'];
        $record['VSIZE'] = UserRequest::$post['ANPL_vsize'];
        $record['FONTSIZE'] = UserRequest::$post['ANPL_fontsize'];
        $record['FONTTYPE'] = UserRequest::$post['ANPL_fonttype'];
        $record['BORDER'] = UserRequest::$post['ANPL_border'];
        $record['SHOWNAMES'] = UserRequest::$post['ANPL_shownames'];
        $record['ROTATE_NAMES'] = UserRequest::$post['ANPL_rotate_names'];
        $record['SHOWVALUES'] = UserRequest::$post['ANPL_showvalues'];
        $record['ANIMATION'] = UserRequest::$post['ANPL_animation'];
        $record['SHOW_LEGEND'] = UserRequest::$post['ANPL_show_legend'];
        $record['SHOW_COLSHADOW'] = UserRequest::$post['ANPL_show_colshadow'];
        $record['SHOW_PCTVALUES'] = UserRequest::$post['ANPL_show_pctvalues'];
        $record['SHOW_PCTINLABEL'] = UserRequest::$post['ANPL_show_pctinlabel'];
        $record['PLOT_TYPE'] = UserRequest::$post['ANPL_plot_type'];
        $record['exeonsearch'] = UserRequest::$post['ANPL_exeonsearch'];
        $plotobject = getToolObject('PLOT', UserRequest::$post['ANPL_plot_type']);
        $plotobject->createPanel($record);
        $recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        $plotobject->defaultRange($record);
        $DBMO = &getTool('DBMO');
        $DBMO->versionIncrease('IDCODE', $record['MODULECODE']);
        return $recordid;
    }

    function duplicateRecord() {
        ClxFreeReturn( ClxCommon::$db->getRecord($this->tablename, 'ID=' . UserRequest::$post['ANPL_id']));
        return $this->createRecord();
    }

    function deleteRecordSk($id) {
        $record = $this->loadToolRecord($id);
        $plotobject = getToolObject('PLOT', $record['ANPL_plot_type']);
        $plotobject->deletePanel($record);
        ClxCommon::$db->deleteRecords('CLX_AN_PLOT_SERIES', 'CHARTCODE=' . singleQuote($record['ANPL_idcode']));
        ClxCommon::$db->deleteRecords('CLX_AN_PLOT_RANGES', 'CHARTCODE=' . singleQuote($record['ANPL_idcode']));
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
        $DBMO = &getTool('DBMO');
        $DBMO->versionIncrease('IDCODE', $record['ANPL_modulecode']);
    }

    function defaultRecord() {
        $record = array();
        $record['ANPL_id'] = CLX_INIT_ZERO;
        $record['ANPL_idcode'] = '';
        $record['ANPL_idname'] = '';
        $record['ANPL_title'] = '';
        $record['ANPL_title_DICT'] = '';
        $record['ANPL_subtitle'] = '';
        $record['ANPL_subtitle_DICT'] = '';
        $record['ANPL_version'] = '1.0.0';
        $record['ANPL_cdate'] = '';
        $record['ANPL_mdate'] = '';
        $record['ANPL_username'] = $_SESSION['user_record']['username'];
        $record['ANPL_description'] = '';
        $record['ANPL_modulecode'] = '';
        $record['ANPL_querycode'] = '';
        $record['ANPL_search_form'] = '';
        $record['ANPL_hsize'] = '400';
        $record['ANPL_vsize'] = '400';
        $record['ANPL_fontsize'] = '12';
        $record['ANPL_fonttype'] = 'arial';
        $record['ANPL_border'] = '1';
        $record['ANPL_exeonsearch'] = '1';
        $record['ANPL_shownames'] = CLX_INIT_ZERO;
        $record['ANPL_rotate_names'] = CLX_INIT_ZERO;
        $record['ANPL_showvalues'] = CLX_INIT_ZERO;
        $record['ANPL_animation'] = CLX_INIT_ZERO;
        $record['ANPL_show_legend'] = CLX_INIT_ZERO;
        $record['ANPL_show_colshadow'] = CLX_INIT_ZERO;
        $record['ANPL_show_pctvalues'] = CLX_INIT_ZERO;
        $record['ANPL_show_pctinlabel'] = CLX_INIT_ZERO;
        $record['ANPL_plot_type'] = 'PLAN';

        $OBJS = &getTool('OBJS');
        $plotcodes = $OBJS->objectList('PLOT');
        foreach ($plotcodes as $plotcode) {

		  $plotobject = $OBJS->getObject_('PLOT', $plotcode);
		  $plotobject->defaultPanel($record);
        }
        return $record;
    }

    function versionIncrease($fieldname, $fieldvalue) {
        parent::versionIncrease($fieldname, $fieldvalue);
        $modulecode = ClxCommon::$db->getField($this->tablename, 'MODULECODE', $fieldname . '=' . singleQuote($fieldvalue));
        $DBMO = &getTool('DBMO');
        $DBMO->versionIncrease('IDCODE', $modulecode);
    }

    /**
     * Builds Pagelet for Tool
     * @param string $code
     * @param string $ac
     * @param integer $objectid
     * @return string
     */
    function pagelet($code, $ac = null, $objectid = null) {
        return $this->plot($code);
    }

    function plotQuery($plotcode, &$series_records, &$sql) {
        $plotrecord = ClxCommon::$db->getRecord($this->tablename, 'IDCODE = ' . singleQuote($plotcode));
        $plotinstance = getToolObject('PLOT', $plotrecord['PLOT_TYPE']);
        $plotinstance->plotQuery($plotrecord, $series_records, $sql);
    }

    /**
     * Return true if plot exists or false on falure
     */
    function chartExists(&$idcode) {
        $qty = ClxCommon::$db->oneExistsRecords($this->tablename, 'IDCODE=' . singleQuote($idcode));
        if ($qty > CLX_NUM_ZERO) {
		  $idcode = ClxCommon::$db->getField($this->tablename, 'IDCODE', 'IDCODE=' . singleQuote($idcode));
        }
        return $qty > CLX_NUM_ZERO;
    }

    function plotData($plotrecord) {

        $plotinstance = getToolObject('PLOT', $plotrecord['PLOT_TYPE']);
        $series_data = $plotinstance->plotData($plotrecord);
        return $series_data;
    }

    /**
     * returns the actual flash plot
     *
     * @param unknown_type $chartcode
     * @return unknown
     */
    function plot($chartcode) {

        if (!$this->getAccess()->canRead()) {
		  return warning(dict('GEN_ERR_NO_ACCESS') . ' [AN_PLOT-CAN_READ_1]' . ' ' . $this->getCode(false));
        }
        $plotrec = ClxCommon::$db->getRecord($this->tablename, 'IDCODE=' . singleQuote($chartcode));
        $DBQY = getTool('DBQY');
        //$qaccess = $DBQY->getUserAccess($plotrec['QUERYCODE']);
        $qaccess = $DBQY->getAppAccess($plotrec['QUERYCODE']);
        if (!$qaccess->canRead()) {
		  return warning(dict('GEN_ERR_NO_ACCESS') . ' [AN_PLOT-CAN_READ_2]' . ' ' . $this->getCode(false) . ' Query: ' . $plotrec['QUERYCODE']);
        }
        $plotinstance = getToolObject('PLOT', $plotrec['PLOT_TYPE']);
        return $plotinstance->buildFlashHtml($plotrec);
    }

    /**
     * Returns plot xml data
     *
     * @param string $chartcode
     * @return string
     */
    function getXmlData($chartcode) {

        $plotrec = ClxCommon::$db->getRecord($this->tablename, 'IDCODE=' . singleQuote($chartcode));
        $plotinstance = getToolObject('PLOT', $plotrec['PLOT_TYPE']);
        $plotinstance->return_xml_only = true;
        return $plotinstance->build($plotrec);
    }

    function makeQuickFilterForm($plotcode) {
        $plotrecord = ClxCommon::$db->getRecord($this->tablename, 'IDCODE = ' . singleQuote($plotcode));
        $querycode = $plotrecord['QUERYCODE'];
        if (!empty($plotrecord['SEARCH_FORM'])) {
		  $UIFM = &getTool('UIFM');
		  $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
		  $form->setProp(CLX_PROP_ID, $querycode . '_QFILTER');
		  $form->addArgument(CLX_PROP_TO, 'EDIT');
		  $form->addArgument('ac', 'QFILTER');
		  $form->addArgument('li', $querycode);
		  $form->addArgument('qy', $querycode);
		  $schformrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE=' . singleQuote($plotrecord['SEARCH_FORM']));
		  $form->addContents($UIFM->userEditForm($schformrec, '', UserRequest::$request, array(), $form));
		  $table = new htmlTable(CLX_WIDTH_ONE);
		  $table->setProps(array(CLX_PROP_CLASS => 'buttons', CLX_PROP_WIDTH => CLX_PROP_100PCT));
		  $b = htmlButton::getButton('submit', dict('GEN_LBL_FILTER'), array('action' => 'FILTER', 'form' => $form->getProp(CLX_PROP_ID)));
		  $table->addCell($b->source(), array(CLX_PROP_CLASS => 'buttons'));
		  $form->addContents($table->source());
		  return $form->source();
        } else {
		  return CLX_CHAR_EMPTY_STRING;
        }
    }

// End method
}

//End Class
