<?php

/**
 * Process Seccion Manager
 *
 * @package		Clientix.Tool.Business Process
 * @abstract		Business Process Manager
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-06-21 08:03:11 -0400 (Thu, 21 Jun 2018) $
 * @version    	$Rev: 9841 $
 *
 */
class bp_performers extends clx_tool {

    /**
     * Constructor
     */
    function __construct() {
        $this->code = 'BPPE';
        $this->name = 'Business Process - Performers';
        $this->system = 'Business Process';
        $this->version = '5.5.0.1';
        $this->tablename = 'CLX_BP_PERFORMERS';
        $this->record_name_singular = 'GEN_LBL_BP_PERFORMER';
        $this->record_name_plural = 'GEN_LBL_BP_PERFORMERS';
        $this->primary_key = array('PERFORMERSCODE');
        $this->primary_field = 'PERFORMERSCODE';
        $this->secondary_field = 'IDNAME';
        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_BPPE_TITLE_CREATE', // ETIQUETA
		  'panels' => array(
			 array('type' => 'normal',
			     'entries' => array(
			         array('label' => 'GEN_LBL_PERFORMERSCODE',
					   'fields' => array(
						  array('name' => 'performerscode',
						      'type' => 'string',
						      'default' => '',
						      'size' => '16',
						      'displaysize' => '16',
						      'dontmodify' => '1',
						      'validations' => array(
								array('type' => 'string',
								    'required' => '1'
								), array('type' => 'unique',
								    'fieldname' => 'performerscode',
								    'tablename' => $this->tablename)
						      )
						  )
					   )
			         ), array('label' => 'GEN_LBL_NAME',
					   'fields' => array(
						  array('name' => 'idname',
						      'type' => 'string',
						      'default' => '',
						      'size' => '64',
						      'displaysize' => '48',
						      'validations' => array(
								array('type' => 'string',
								    'required' => '1'
								)
						      )
						  )
					   )
			         ), array('label' => 'GEN_LBL_ACTIVITIESCODE',
					   'fields' => array(
						  array('name' => 'activitiescode',
						      'type' => 'lookup',
						      'default' => '',
						      'readonly' => false,
						      'tool' => 'BPAC',
						      'validations' => array(
								array('type' => 'string',
								    'required' => '1'
								), array('type' => 'lookup',
								    'fieldname' => 'activitiescode',
								    'tablename' => 'CLX_BP_ACTIVITIES'
								)
						      )
						  )
					   )
			         ), array('label' => 'GEN_LBL_CATEGORIESCODE',
					   'fields' => array(
						  array('name' => 'categoriescode',
						      'type' => 'lookup',
						      'default' => '',
						      'readonly' => false,
						      'tool' => 'BPCT',
						      'validations' => array(
								array('type' => 'string',
								    'required' => '1'
								), array('type' => 'lookup',
								    'fieldname' => 'categoriescode',
								    'tablename' => 'CLX_BP_CATEGORIES'
								)
						      )
						  )
					   )
			         ), array('label' => 'GEN_LBL_DESCRIPTION',
					   'fields' => array(
						  array('name' => 'description',
						      'type' => 'text',
						      'default' => '',
						      'cols' => '48',
						      'rows' => '4'
						  )
					   )
			         )
			     )
			 )
		  )
        );
        $this->viewform = $this->editform;
        $this->viewform [CLX_CLASS_TITLE] = 'TOOL_BPPE_TITLE_DISPLAY'; // Etiqueta listo
        $this->toolpanelkeys = array(array('name' => 'ACTIVITIESCODE',
			 'type' => 'string'
		  )
        ); // listo
        $this->toolpanel = array('name' => $this->tablename, CLX_CLASS_TITLE => $this->record_name_plural, 'fields' => array(
			 array('name' => 'ID',
			     'label' => 'GEN_LBL_ID',
			     'type' => 'number'
			 ), array('name' => 'PERFORMERSCODE',
			     'label' => 'GEN_LBL_PERFORMERSCODE',
			     'type' => 'string'
			 ), array('name' => 'IDNAME',
			     'label' => 'GEN_LBL_IDNAME',
			     'type' => 'string'
			 ), array('name' => 'ACTIVITIESCODE',
			     'label' => 'GEN_LBL_ACTIVITIESCODE',
			     'type' => 'string'
			 ), array('name' => 'CATEGORIESCODE',
			     'label' => 'GEN_LBL_CATEGORIESCODE',
			     'type' => 'string'
			 ), array('name' => 'DESCRIPTION',
			     'label' => 'GEN_LBL_DESCRIPTION',
			     'type' => 'string'
			 )
		  )
        );
    }

// End method
    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::toolTableStructure()
     */
    function toolTableStructure() {
        $fields = array();
        $fields ['ID'] = array('type' => 'int(11) unsigned',
		  'null' => 'NO',
		  'properties' => 'auto_increment',
		  'index' => 'PRI'
        );
        $fields ['PERFORMERSCODE'] = array('type' => 'varchar(16)',
		  'null' => 'NO',
		  'properties' => ''
        );
        $fields ['IDNAME'] = array('type' => 'varchar(64)',
		  'null' => 'NO',
		  'properties' => ''
        );
        $fields ['ACTIVITIESCODE'] = array('type' => 'varchar(16)',
		  'null' => 'NO',
		  'properties' => ''
        );
        $fields ['CATEGORIESCODE'] = array('type' => 'varchar(16)',
		  'null' => 'NO',
		  'properties' => ''
        );
        $fields ['DESCRIPTION'] = array('type' => 'mediumtext',
		  'properties' => ''
        );
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes [$ipf . '01'] = array('index' => 'PRI',
		  'fieldname' => 'ID'
        );
        $indexes [$ipf . '02'] = array('index' => 'UNI',
		  'fieldname' => 'PERFORMERSCODE'
        );
        $indexes [$ipf . '03'] = array('index' => 'MUL',
		  'fieldname' => 'ACTIVITIESCODE'
        );
        $indexes [$ipf . '04'] = array('index' => 'MUL',
		  'fieldname' => 'CATEGORIESCODE'
        );
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
		  'fields' => $fields,
		  'indexes' => $indexes
        );
    }

// end method
    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::action()
     */
    function action($ac, $idlist) {
        //if ($this->access ['canread'] === true) {
        if ($this->getAccess()->canRead()) {
		  switch ($ac) {
			 default :
			     $contents = parent::action($ac, $idlist);
			     break;
		  }
        } else {
		  $contents = warning(dict('GEN_ERR_NO_ACCESS') . '[BP_PERFORMERS-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

// end method
    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::unpack()
     */
    function unpack($parameters) {
        $parameters = array_values(array_merge(array('package' => null), $parameters));
        list($package) = $parameters;
        $record = $this->unpackRecord($package);
        ClxCommon::$db->deleteRecords($this->tablename, $this->primary_field . '=' . singleQuote($record [$this->primary_field]));
        ClxCommon::$db->createRecord($this->tablename, $record, false);
    }

    /**
     * (non-PHPdoc)
     *
     * @see clx_tool::defaultRecord()
     */
    function defaultRecord() {
        $callingpage = peekHistory(); // Buscar ojo
        $record = parent::defaultRecord();
        $record ['BPPE_performerscode'] = $callingpage ['activitiescode'] . '.' . (ClxCommon::$db->countRecords($this->tablename, 'ACTIVITIESCODE = ' . singleQuote($callingpage ['activitiescode'])) + CLX_NUM_ONE);
        $record ['BPPE_activitiescode'] = $callingpage ['activitiescode'];
        return $record;
    }

// end method
}

// End class
