<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-10-05 09:42:44 -0400 (Fri, 05 Oct 2018) $
 * @version        $Rev: 10209 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
class db_import_qparallels extends clx_tool {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'DBIQ';
        $this->name = 'Import Executions Q Parallels';
        $this->system = 'Database';
        $this->version = '7.0.0.0';

        $this->accesskey = 'DBIM';


        $this->tablename = 'CLX_DB_QIMPORT_PARALLEL';
        $this->record_name_singular = 'import parallel';
        $this->record_name_plural = 'import parallel';
        $this->primary_field = 'ID';
    }

    function toolTableStructure() {if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1690;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import_parallels-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['IMPORTCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['SECOND_AVERAGE'] = array('type' => 'int(11) unsigned', 'null' => 'YES', 'properties' => '', 'default' => CLX_NUM_ZERO);;
        
		$indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'MUL', 'fieldname' => 'IMPORTCODE');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
            'fields' => $fields,
            'indexes' => $indexes);
    }
	function calculate() {
		$sql='INSERT INTO CLX_DB_QIMPORT_PARALLEL (IMPORTCODE,SECOND_AVERAGE)
			SELECT  IMPORTCODE,
       CAST( 1+ AVG(extract(second from BATCH_EDATE-BATCH_SDATE)+
        extract(minute from BATCH_EDATE-BATCH_SDATE)*60+
        extract(hour from BATCH_EDATE- BATCH_SDATE)*60*60+
        extract(day from BATCH_EDATE- BATCH_SDATE)*24*60*60) AS INT) second
    FROM CLX_DB_IMPORT_EXECUTIONS WHERE BATCH_EDATE IS NOT NULL AND BATCH_SDATE IS NOT NULL     
    GROUP BY IMPORTCODE';
	ClxCommon::$db->executeQuery('TRUNCATE TABLE CLX_DB_QIMPORT_PARALLEL');
	
	ClxCommon::$db->executeQuery($sql);
    
	}
	function makepanel($groupcode = null) {
	}
}
