<?php

/**
 * Service Messages Manager
 * Webservices Service Messages Manager
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-09-23 10:22:10 -0400 (Sun, 23 Sep 2018) $
 * @version    	$Rev: 10122 $
 *
 * CHANGE LOG
 *  Included label
 */
class db_procedures extends clx_tool {

    private $db_type;
    private $db_obj_type;
    public $return_type;

    function __construct() {
        $this->code = 'DBPR';
        $this->name = 'Procedures and Functions Manager';
        $this->system = 'Database';
        $this->version = '5.6.1.0';


        $this->has_package = true;

        $this->tablename = 'CLX_DB_PROCEDURES';
        $this->record_name_singular = 'TOOL_DBPR_PROCEDURE';
        $this->record_name_plural = 'TOOL_DBPR_PROCEDURES';
        $this->primary_key = array('IDCODE');
        $this->primary_field = 'IDCODE';
        $this->secondary_field = 'IDNAME';
        $this->terciary_field = 'MODULECODE';

        $this->db_type = array('mysql' => 'GEN_LBL_MYSQL', 'oci' => 'GEN_LBL_OCI', 'any' => 'GEN_LBL_ANY');
        $this->db_obj_type = array('function' => 'GEN_LBL_FUNCTIONS', 'PROCEDURE' => 'GEN_LBL_PROCEDURE');
        $this->return_type = array('IN' => 'GEN_LBL_IN', 'OUT' => 'GEN_LBL_OUT', '' => 'GEN_LBL_INOUT');
        $this->proc_parameter_type = array('STRING' => 'GEN_LBL_STRING', 'INTEGER' => 'GEN_LBL_INTEGER', 'REAL' => 'GEN_LBL_REAL', 'DECIMAL' => 'GEN_LBL_DECIMAL');
        $this->sql_sequrity = array('DEFINER' => 'GEN_LBL_STRING', 'INTEGER' => 'GEN_LBL_INTEGER');
        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_DBPR_TITLE_CREATE',
		  'panels' => array(
			 array('type' => 'normal',
			     'entries' => array(
			         array('label' => 'GEN_LBL_CODE',
					   'fields' => array(
						  array('name' => 'idcode', 'type' => 'string', 'default' => '', 'size' => '4', 'displaysize' => '4', 'dontmodify' => '1',
						      'validations' => array(
								array('type' => 'sqlobject', 'required' => '1'), array('type' => 'unique', 'fieldname' => 'idcode', 'tablename' => $this->tablename))
						  )
					   )
			         ), array('label' => 'GEN_LBL_NAME',
					   'fields' => array(
						  array('name' => 'idname', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '48',
						      'validations' => array(
								array('type' => 'sqlobject', 'required' => '1'))
						  )
					   )
			         ), array('label' => 'GEN_LBL_OBJ_TYPE',
					   'fields' => array(
						  array('name' => 'obj_type',
						      'default' => 'function',
						      'type' => 'dynamic',
						      'panels' => $this->db_obj_type)
					   )
			         ), array('label' => 'GEN_LBL_DB_TYPE',
					   'fields' => array(
						  array('name' => 'db_type',
						      'type' => CLX_CLASS_LIST,
						      'options' => $this->db_type, 'validations' => array(
								array('type' => 'string', 'required' => '1'))
						  )
					   )
			         ), array('label' => 'GEN_LBL_STATUS',
					   'fields' => array(
						  array('name' => 'status', 'type' => CLX_CLASS_LIST, 'default' => '1',
						      'options' => $this->status)
					   )
			         ), array('label' => 'GEN_LBL_DESCRIPTION',
					   'fields' => array(
						  array('name' => 'description', 'type' => 'text', 'default' => '', 'cols' => '48', 'rows' => '4'))
			         ), array('label' => 'GEN_LBL_MODULECODE',
					   'fields' => array(
						  array('name' => 'modulecode', 'type' => 'lookup', 'default' => '', 'tool' => 'DBMO', 'validations' => array(
								array('type' => 'sqlobject', 'required' => '1'), array('type' => 'lookup',
								    'fieldname' => 'idcode',
								    'tablename' => 'CLX_DB_MODULES')
						      )
						  )
					   )
			         ), array('label' => 'GEN_LBL_CDATE',
					   'fields' => array(
						  array('name' => 'cdate',
						      'type' => 'dati',
						      'dontmodify' => '1',
						      'displaysize' => '35',
						      'readonly' => false,
						      'options' => getNow('Y-m-d h:i:s'),
						      'validations' => array(
								array('type' => 'string'
								)
						      )
						  )
					   )
			         ), array('label' => 'GEN_LBL_MDATE',
					   'fields' => array(
						  array('name' => 'mdate',
						      'type' => 'dati',
						      'dontmodify' => '1',
						      'displaysize' => '35',
						      'readonly' => false,
						      'options' => getNow('Y-m-d h:i:s'),
						      'validations' => array(
								array('type' => 'string'
								)
						      )
						  )
					   )
			         )
			     )
			 ), array('type' => 'dynamic',
			     'code' => 'function',
			     'entries' => array(
			         array('label' => 'GEN_LBL_RETURN_TYPE',
					   'fields' => array(
						  array('name' => 'return_type',
						      'type' => 'string'
						  )
					   )
			         )
			     )
			 ), array('type' => 'dynamic',
			     'code' => 'PROCEDURE',
			     'entries' => array(
			     )
			 ), array('type' => 'normal',
			     'code' => 'PROCEDURE',
			     'caption' => 'GEN_LBL_CODE_DETAIL',
			     'entries' => array(
			         array('label' => 'GEN_LBL_PARAMETERS',
					   'fields' => array(
						  array('name' => 'parameters',
						      'type' => 'string',
						      'displaysize' => '56',
						      'size' => CLX_NUM_THOUSAND
						  )
					   )
			         ), array('label' => 'GEN_LBL_ROUTINE_BODY',
					   'fields' => array(
						  array('name' => 'routine_body', 'type' => 'text', 'default' => '', 'cols' => '200', 'rows' => '40', 'validations' => array(
								array('type' => 'string', 'required' => '1'))
						  )
					   )
			         )
			     )
			 ), array('type' => 'normal',
			     CLX_CLASS_TITLE => 'GEN_LBL_SECURITY_OPTS',
			     'entries' => array(
			         array('label' => 'GEN_LBL_DEFINER_USER',
					   'fields' => array(
						  array('name' => 'definer_user', 'type' => 'string', 'default' => '', 'size' => '40', 'displaysize' => '30',
						      'validations' => array(
								array('type' => 'string', 'required' => '1'))
						  )
					   )
			         )
			     )
			 ), array('type' => 'normal',
			     CLX_CLASS_TITLE => 'GEN_LBL_RECORD_INFO',
			     'entries' => array(
			         array('label' => 'GEN_LBL_VERSION',
					   'fields' => array(
						  array('name' => 'version', 'type' => 'string', 'default' => '1.0.0', 'size' => '32', 'displaysize' => '16',
						      'validations' => array(
								array('type' => 'string', 'required' => '1'))
						  )
					   )
			         ), array('label' => 'GEN_LBL_VERSION_COUNTER',
					   'fields' => array(
						  array('name' => 'version_counter', 'type' => 'string', 'default' => '1.0.0', 'readonly' => true, 'size' => '32', 'displaysize' => '16',
						      'validations' => array()
						  )
					   )
			         )
			     )
			 )
		  )
        );

        $this->quickfilterform = array(CLX_CLASS_TITLE => 'TOOL_DBPR_TITLE_CREATE',
		  'panels' => array(
			 array('type' => 'normal',
			     'entries' => array(
			         array('label' => 'GEN_LBL_CODE',
					   'fields' => array(
						  array('name' => 'idcode', 'type' => 'string', 'default' => '', 'size' => '4', 'displaysize' => '4', 'dontmodify' => '1')
					   )
			         ), array('label' => 'GEN_LBL_NAME',
					   'fields' => array(
						  array('name' => 'idname', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '48')
					   )
			         ),/* array('label' => 'GEN_LBL_OBJ_TYPE',
					   'fields' => array(
						  array('name' => 'obj_type',
						      'type' => CLX_CLASS_LIST,
						      'default' => 'function',
						      'options' => $this->db_obj_type)
					   )
			         ), array('label' => 'GEN_LBL_DB_TYPE',
					   'fields' => array(
						  array('name' => 'db_type',
						      'type' => CLX_CLASS_LIST,
						      'options' => $this->db_type)
					   )
			         ), array('label' => 'GEN_LBL_STATUS',
					   'fields' => array(
						  array('name' => 'status', 'type' => CLX_CLASS_LIST, 'default' => '1',
						      'options' => $this->status)
					   )
			         ),*/ array('label' => 'GEN_LBL_MODULECODE',
					   'fields' => array(
						  array('name' => 'modulecode', 'type' => 'lookup', 'default' => '', 'tool' => 'DBMO')
					   )
			         )
			     )
			 )
		  )
        );
        $this->viewform = $this->editform;
        $this->viewform[CLX_CLASS_TITLE] = 'TOOL_DBPR_TITLE_DISPLAY';
        $this->toollist = array('name' => $this->tablename, CLX_CLASS_TITLE => $this->record_name_plural, 'fields' => array(
			 array('name' => 'ID', 'type' => 'number', 'label' => 'GEN_LBL_ID'), array('name' => 'IDCODE', 'type' => 'string', 'label' => 'GEN_LBL_IDCODE'), array('name' => 'IDNAME', 'type' => 'string', 'label' => 'GEN_LBL_IDNAME'), array('name' => 'DB_TYPE', 'type' => CLX_CLASS_LIST, 'label' => 'GEN_LBL_DB_TYPE', 'options' => $this->db_type), array('name' => 'OBJ_TYPE', 'type' => 'string', 'label' => 'GEN_LBL_OBJ_TYPE'), array('name' => 'VERSION', 'type' => 'fieldgroup', 'fields' => array(
			         array('name' => 'VERSION', 'type' => 'string', 'sufix' => '.'), array('name' => 'VERSION_COUNTER', 'type' => 'number'))
			 )
		  ), 'buttons' =>
		  array(array('access' => 'canread',
			     'tool' => 'has_display',
			     'library' => 'GEN_LBL_VERIFY',
			     'name' => 'VERIFY',
			     'prop' => 'MULT'
			 ), array('access' => 'canread',
			     'tool' => 'has_display',
			     'library' => 'GEN_LBL_COMPILE',
			     'name' => 'COMPILE',
			     'prop' => 'MULT'
			 )
		  )
        );
    }

    function install() {
        $UIMI = getTool('UIMI');
        $UIMI->add($this->code, 'MENU_TOOLS:MENU_DATABASE:MENU_PROCED', 'TOOL', $this->code, 'ac=LIST', CLX_NUM_NINE);
    }

    function toolTableStructure() {
        $fields = array();
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI', 'index' => 'PRI');
        $fields['IDCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['IDNAME'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '');
        $fields['DB_TYPE'] = array('type' => 'varchar(10)', 'null' => 'YES', 'properties' => '');
        $fields['OBJ_TYPE'] = array('type' => 'varchar(10)', 'null' => 'YES', 'properties' => '');
        $fields['ROUTINE_BODY'] = array('type' => 'mediumtext', 'properties' => '');
        $fields['PARAMETERS'] = array('type' => 'mediumtext', 'properties' => '');
        $fields['RETURN_TYPE'] = array('type' => 'varchar(50)', 'null' => 'YES', 'properties' => '');
        $fields['PRMT_SCOPE'] = array('type' => 'varchar(10)', 'null' => 'YES', 'properties' => '');
        $fields['FUNC_PARAMETER'] = array('type' => 'mediumtext', 'properties' => '');
        $fields['DESCRIPTION'] = array('type' => 'mediumtext', 'null' => 'YES');
        $fields['MODULECODE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['DEFINER_USER'] = array('type' => 'varchar(40)', 'null' => 'NO', 'properties' => '', 'default' => singleQuote('"CURRENT_USER"'), 'default_raw' => 'CURRENT_USER');
        $fields['IS_DETERMINISTIC'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO, 'properties' => '');
        $fields['IS_SQL'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ONE, 'properties' => '');
        $fields['READS_SQL_DATA'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO, 'properties' => '');
        $fields['MODIFY_SQL_DATA'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO, 'properties' => '');
        $fields['IS_COMPILED'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO, 'properties' => '');
        $fields['STATUS'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => '1', 'properties' => '');
        $fields['VERSION'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
        $fields['VERSION_COUNTER'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['MDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['CREATEDBY'] = array('type' => 'varchar(30)', 'null' => 'YES', 'properties' => '');
        $fields['MODIFIEDBY'] = array('type' => 'varchar(30)', 'null' => 'YES', 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'IDCODE');
        //$indexes[$ipf . '03'] = array('index' => 'UNI', 'fieldname' => 'IDNAME,MODULECODE');
        $indexes[$ipf . '03'] = array('index' => 'UNI', 'fieldname' => 'IDNAME,MODULECODE,DB_TYPE');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
		  'fields' => $fields,
		  'indexes' => $indexes);
    }

    function action($ac, $idlist) {
        if ($this->getAccess()->canRead()) {
		  switch ($ac) {
			 case 'COMPILE':
			     //   - Audit dump to .SQL Script file instead of excecuting SQL senences directly
			     $dump = (defined('UTIL_DUMP_AUPK_SQL_SCRIPT') && UTIL_DUMP_AUPK_SQL_SCRIPT === strval(CLX_NUM_ONE));
			     $flmsg = '';
			     if (!empty($dump)) {
			         ClxCommon::$db->scriptFileOut = kPathToTemp . clx_mcript('FORM_DB_PROCEDURE_COMPILE') . '.sql';
			         $flmsg = '<br>' . dict('GEN_LBL_TO') . ' <a href="' . ClxCommon::$db->scriptFileOut . '" target=_blank>' . ClxCommon::$db->scriptFileOut . '</a>';
			     }
			     $contents = $this->verify($idlist, true, $dump);
			     //   - Audit dump to .SQL Script file instead of excecuting SQL senences directly
			     if (!empty($dump)) {
			         $contents .= '<br><br>' . note(dict('GEL_LBL_OPER_COMP_SUCCESS') . ' ' . $flmsg, 'OK');
			     }
			     break;
			 case 'VERIFY':
			     $contents = $this->verify($idlist, false);
			     break;
			 default:
			     $contents = parent::action($ac, $idlist);
			     break;
		  }
        } else {
		  $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [DB_PROCEDURES-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    function createRecord_() {
        UserRequest::$post['DBPR_parameters'] = clx_html_spchrs_decode(UserRequest::$post['DBPR_parameters']);
        UserRequest::$post['DBPR_definer_user'] = clx_html_spchrs_decode(UserRequest::$post['DBPR_definer_user']);
        UserRequest::$post['DBPR_routine_body'] = clx_html_spchrs_decode(UserRequest::$post['DBPR_routine_body']);
        parent::createRecord_();
    }

    function saveRecord() {
        UserRequest::$post['DBPR_parameters'] = clx_html_spchrs_decode(UserRequest::$post['DBPR_parameters']);
        UserRequest::$post['DBPR_definer_user'] = clx_html_spchrs_decode(UserRequest::$post['DBPR_definer_user']);
        UserRequest::$post['DBPR_routine_body'] = clx_html_spchrs_decode(UserRequest::$post['DBPR_routine_body']);
        UserRequest::$post['DBPR_version_counter'] = (isset(UserRequest::$post['DBPR_version_counter']) && !is_null(UserRequest::$post['DBPR_version_counter']) && trim(UserRequest::$post['DBPR_version_counter']) !== CLX_CHAR_EMPTY_STRING ? 0+UserRequest::$post['DBPR_version_counter'] : 0) ;
        parent::saveRecord();
    }

    function defaultRecord() {

        ClxFreeReturn(peekHistory());
        $record = parent::defaultRecord();
        $record['DBPR_version'] = '1.0.0';
        $record['DBPR_idname'] = '';
        $record["DBPR_parameters"] = 'VAR1 TIPO(DIMENSION). VAR2 TYPE (DIMENSION)';
        $record["DBPR_routine_body"] = '/*'.CLX_CHAR_NL.'Example 1 function getting variable SVAR from parameters'.CLX_CHAR_NL.'and returning concat:'.CLX_CHAR_NL.'RETURN CONCAT(\'CODE SAMPLE...\', CONCAT(\':\',SVAR));'.CLX_CHAR_NL.''.CLX_CHAR_NL.'Example 2 - Selecting code where condition met:'.CLX_CHAR_NL.'RETURN SELECT MAX(ID) FROM SAMPLE_TABLE WHERE NAME = SVAR;'.CLX_CHAR_NL.''.CLX_CHAR_NL.''.CLX_CHAR_NL.'Example 3 - Selecting value into variable and adding 1'.CLX_CHAR_NL.'SET @SAMPLEVAR = SELECT MAX(ID) FROM SAMPLE_TABLE WHERE NAME = SVAR;'.CLX_CHAR_NL.'@SAMPLEVAR = @SAMPLEVAR+1;'.CLX_CHAR_NL.'RETURN @SAMPLEVAR;'.CLX_CHAR_NL.''.CLX_CHAR_NL.'*/';

        return $record;
    }

    function verify($idlist, $fix, $dump = false) {
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('GEN_LBL_VERIFY_FUNCTION'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $sql = 'SELECT * FROM ' . $this->tablename . ' WHERE ID IN (' . toString($idlist) . ')';
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
		  $table->addCell('', array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
		  $table->addData(dict('GEN_LBL_IDCODE') . ':', $result['IDCODE']);
		  $table->addData(dict('GEN_LBL_IDNAME') . ':', $result['IDNAME']);
		  $table->addData(dict('GEN_LBL_DB_TYPE') . ':', dict($this->db_type[$result['DB_TYPE']]));
		  $table->addData(dict('GEN_LBL_OBJ_TYPE') . ':', $result['OBJ_TYPE']);
		  $table->addData(dict('GEN_LBL_STATUS') . ':', dict($this->status[$result['STATUS']]));
		  $rslt = '';
		  if ($result['DB_TYPE'] === 'mysql' && kDatabaseType === 'mysqli') {
			 $result['DB_TYPE'] = kDatabaseType;
		  }
		  if (($result['DB_TYPE'] === 'any') || ($result['DB_TYPE'] == kDatabaseType)) {
			 if ($result['OBJ_TYPE'] === 'PROCEDURE') {
			     $rslt = ClxCommon::$db->checkProcedure($result, $fix, $dump);
			 } else {
			     $rslt = ClxCommon::$db->checkFunction($result, $fix, $dump);
			 }
			 if ($rslt === true) {
			     if ($fix === true) {
			         $rslt = dict('GEN_LBL_PF_FIXED');
			     } else {
			         $rslt = dict('GEN_LBL_PF_CREATED');
			     }
			 } else {
			     if ($rslt === false) {
			         if ($fix === true) {
					   $rslt = dict('GEN_LBL_PF_NO_COMPILED');
			         } else {
					   $rslt = dict('GEN_LBL_PF_NOT_EXISTS');
			         }
			     }
			     // Para que ponga el error en ROJO | 2018-08-25 CR
			     $rslt = '<table><tr><td class='. singleQuote('fail').'>' . $rslt . '</td></tr></table>';
			     // Fin de "Para que ponga el error en ROJO"
			 }
		  } else {
			 $rslt = dict('GEN_LBL_INCOMPATIBLE_DATABASE');
		  }
		  $table->addData(dict('GEN_LBL_RESULT') . ':', $rslt);
        }
		ClxCommon::$db->freeResult($results);
        $c = new htmlButtonCancel(dict('GEN_LBL_RETURN'));
        $buttons = $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        return $table->source();
    }


}
