<?php

/**
 * Process Exception Logs Manager
 *
 * @package		Clientix.Tool.Process
 * @abstract		Process Engine Manager
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version    	$Rev: 9615 $
 *
 */
class pr_except_logs extends clx_tool {

    /**
     * Constructor
     */
    function __construct() {
        $this->code = 'PREL';
        $this->name = 'Process Exception Logs Manager';
        $this->system = 'Process';
        $this->version = '5.5.0.0';




        $this->tablename = 'CLX_PR_EXCEPT_LOGS';
        $this->record_name_singular = 'GEN_LBL_PR_LOG';
        $this->record_name_plural = 'GEN_LBL_PR_LOGS';
        $this->primary_field = 'ID';
        $this->secondary_field = 'LOG_RECID';
        $this->terciary_field = 'SCHEDULECODE';

        $this->viewform = array(CLX_CLASS_TITLE => 'TOOL_SCHPR_TITLE_CREATE',
		  'panels' => array(
			 array('type' => 'normal',
			     'entries' => array(
			         array('label' => 'GEN_LBL_LOG_RECID',
					   'fields' => array(
						  array('name' => 'log_recid', 'type' => 'lookup', 'default' => '', 'readonly' => false, 'tool' => 'PRPR', 'validations' => array(
								array('type' => 'sqlobject', 'required' => '1'), array('type' => 'lookup', 'fieldname' => 'idcode', 'tablename' => 'DBTB'))
						  )
					   )
			         ), array('label' => 'EFFTDATE',
					   'fields' => array(
						  array('name' => 'efftdate',
						      'type' => 'dati',
						      'displaysize' => '35',
						      'validations' => array(
								array('type' => 'string', 'required' => '0'))
						  )
					   )
			         ), array('label' => 'GEN_LBL_PROC_STATUS',
					   'fields' => array(
						  array('name' => 'proc_status',
						      'type' => CLX_CLASS_LIST,
						      'default' => '',
						      'options' => $this->notify_status
						  )
					   )
			         ), array('label' => 'GEN_LBL_DESCRIPTION',
					   'fields' => array(
						  array('name' => 'description', 'type' => 'text', 'default' => '', 'cols' => '48', 'rows' => '4'))
			         ), array('label' => 'GEN_LBL_SCHEDULECODE',
					   'fields' => array(
						  array('name' => 'schedulecode', 'type' => 'lookup', 'default' => '', 'readonly' => false, 'tool' => 'PRPR', 'validations' => array(
								array('type' => 'sqlobject', 'required' => '1'), array('type' => 'lookup', 'fieldname' => 'idcode', 'tablename' => 'PRSC'))
						  )
					   )
			         ), array('label' => 'GEN_LBL_TABLECODE',
					   'fields' => array(
						  array('name' => 'tablecode', 'type' => 'lookup', 'default' => '', 'readonly' => false, 'tool' => 'PRPR', 'validations' => array(
								array('type' => 'sqlobject', 'required' => '1'), array('type' => 'lookup', 'fieldname' => 'idcode', 'tablename' => 'DBTB'))
						  )
					   )
			         )
			     )
			 )
		  )
        );
        $this->quickfilterform = array(CLX_CLASS_TITLE => 'TOOL_SCHPR_TITLE_CREATE',
		  'panels' => array(
			 array('type' => 'normal',
			     'entries' => array(
			         array('label' => 'GEN_LBL_LOG_RECID',
					   'fields' => array(
						  array('name' => 'log_recid',
						      'type' => 'lookup',
						      'default' => '',
						      'readonly' => false,
						      'tool' => 'PRPR'
						  )
					   )
			         ), array('label' => 'EFFTDATE',
					   'fields' => array(
						  array('name' => 'efftdate',
						      'type' => 'dati',
						      'displaysize' => '35'
						  )
					   )
			         ), array('label' => 'GEN_LBL_PROC_STATUS',
					   'fields' => array(
						  array('name' => 'proc_status',
						      'type' => CLX_CLASS_LIST,
						      'default' => '',
						      'options' => $this->notify_status
						  )
					   )
			         ), array('label' => 'GEN_LBL_SCHEDULECODE',
					   'fields' => array(
						  array('name' => 'schedulecode',
						      'type' => 'lookup',
						      'default' => '',
						      'readonly' => false,
						      'tool' => 'PRPR'
						  )
					   )
			         ), array('label' => 'GEN_LBL_TABLECODE',
					   'fields' => array(
						  array('name' => 'tablecode',
						      'type' => 'lookup',
						      'default' => '',
						      'readonly' => false,
						      'tool' => 'PRPR'
						  )
					   )
			         )
			     )
			 )
		  )
        );
        $this->viewform[CLX_CLASS_TITLE] = 'TOOL_PRLO_TITLE_DISPLAY';
        $this->editform = $this->viewform;
        $this->toollist = array('name' => $this->tablename, CLX_CLASS_TITLE => $this->record_name_plural, 'has_modify' => false,
		  'has_create' => false,
		  'has_duplicate' => false,
		  'sortclause' => 'EFFTDATE DESC', //  FS+CR - Caso 1002606
		  'fields' =>
		  array(array('name' => 'ID', 'type' => 'number'), array('name' => 'LOG_RECID', 'type' => 'number'), array('name' => 'EFFTDATE', 'type' => 'dati'), array('name' => 'PROC_STATUS', 'type' => 'string'), array('name' => 'DESCRIPTION', 'type' => 'text'), array('name' => 'SCHEDULECODE', 'type' => 'string'), array('name' => 'TABLECODE', 'type' => 'string'), array('name' => 'RECORDID', 'type' => 'number'))
        );
        $this->toolpanelkeys = array(array('name' => 'LOG_RECID', 'type' => 'string'));
        $this->toolpanel = $this->toollist;
    }

// End method
    /**
     * Tool Table Structure
     * @return array
     */
    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['LOG_RECID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $fields['EFFTDATE'] = array('type' => 'datetime', 'null' => 'YES');
        $fields['PROC_STATUS'] = array('type' => 'varchar(10)', 'null' => 'NO', 'default' => '' . singleQuote('IDLE') . '', 'default_raw' => 'IDLE');
        $fields['DESCRIPTION'] = array('type' => 'mediumtext', 'null' => 'YES');
        $fields['SCHEDULECODE'] = array('type' => 'varchar(20)', 'null' => 'NO');
        $fields['TABLECODE'] = array('type' => 'varchar(16)', 'null' => 'YES');
        $fields['RECORDID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO);
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'MUL', 'fieldname' => 'LOG_RECID');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'SCHEDULECODE');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
		  'fields' => $fields,
		  'indexes' => $indexes);
    }

    /**
     * Tool Install Method
     */
    function install() {
        $UIMI = getTool('UIMI');
        $UIMI->add($this->code, 'MENU_TOOLS:MENU_PROCESS:MENU_' . $this->code, 'TOOL', $this->code, 'ac=LIST');
    }

//-- M E S A G E S
    /**
     * Tool Action
     * @param string $ac Action code
     * @param string $idlist Record(s) affected by action
     * @return string
     */
    function action($ac, $idlist) {
        if ($this->getAccess()->canRead()) {
		  switch ($ac) {
			 default:
			     $contents = parent::action($ac, $idlist);
			     break;
		  }
        } else {
		  $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [PR_EXCEPT_LOGS-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    /**
     * Delete schedule Exceptios
     * @param $schedulecode
     */
    function deleteScheduleExceptions($schedulecode) {
        $sql = 'DELETE FROM ' . $this->tablename . ' WHERE SCHEDULECODE = ' . singleQuote($schedulecode);
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     * Delete schedule Exceptios
     * @param $schedulecode
     */
    function deleteLogExceptions($logid) {
        $sql = 'DELETE FROM ' . $this->tablename . ' WHERE LOG_RECID = ' . singleQuote($logid);
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     *
     *
     * @return type
     */
    function toolArchive() {
        if (!defined('UTIL_ARCHIVE_MODE'))
		  define('UTIL_ARCHIVE_MODE', CLX_NUM_12);
        //Archive
        $sql = 'SELECT * FROM ' . $this->tablename;
        if (UTIL_ARCHIVE_MODE == CLX_NUM_ONE) {
		  $archive_tbl = $this->tablename . '_' . getNow('m') . '_' . getNow('Y');
        } else {
		  $archive_tbl = $this->tablename . '_' . getNow('Y');
        }
        $tableinfo = $this->toolTableStructure();
        unset($tableinfo['fields']['ID']);
        $tableinfo['name'] = $archive_tbl;
        $tableinfo['type'] = 'ARCHIVE';
        $tableinfo['indexes'] = array();
        $structure = ClxCommon::$db->translateTableStructure($tableinfo);
        //Create table if not exists
        if (!ClxCommon::$db->tableExists($structure['name'])) {
		  //Create table if not exists
		  ClxCommon::$db->createTable($structure['name'], $structure['type'], $structure['fields'], $structure['case_sensitive']);
        }
        $comma = '';
        $select = '';
        foreach ($structure['fields'] as $key => $val) {
		  $select .= $comma . $key;
		  $comma = ',';
        }
        //Lock table to archive
        $sql = 'SELECT MAX(ID) FROM ' . $this->tablename;
        $maxid = ClxCommon::$db->getOne($sql);
        if (empty($maxid))
		  return;
        //Backup
        $sql = 'INSERT INTO ' . $structure['name'] . '(' . $select . ') SELECT ' . $select . ' FROM ' . $this->tablename . ' WHERE ID <=' . $maxid;
        ClxCommon::$db->executeQuery($sql);
        //Unlock table
        $sql = 'DELETE FROM ' . $this->tablename . ' WHERE ID<=' . $maxid;
        ClxCommon::$db->executeQuery($sql);
        //Restore stats if apply
        ClxCommon::$db->buldStats($this->tablename);
    }

    function toolArchive_batch($parameters) {
        $contenidoHTML = '';
        //e cho 'TOOLARCHIVE_BATCH parameters:<br>'.CLX_CHAR_NL; print_r($parameters);
        //   - Caso 1002598 - BNP-Limpieza Proccess Logs en Batch
        // Method 'get_bkp_time_limit' implemented to avoid schedule CLX_PRLO_CLEAN
        // to remain un "In progress(RUN) status due to PHP timeout.
        $DBBK = getToolObject('UTIL', 'DBBK');
        $bkp_time_limit = $DBBK->get_bkp_time_limit();
        // Set it to twice the time limit of backup, just in case
        UserResponse::setRunTimeLimit($bkp_time_limit * CLX_NUM_TWO * CLX_NUM_60 * CLX_NUM_60);
        //   - Caso 1002598 - BNP-Limpieza Audit en Batch
        // Se agrega este método para realizar el archival en batch,
        // ya que en los casos que CLX_PR_PROC_LOGS tenga muchos registros,
        // se cae cuando se hace en el interactivo.
        // Realiza la llamada al método $this->toolArchive()
        $this->toolArchive();
        // Extrae la lista de las tablas con los archives existentes
        //   - Caso 1002670 - BNP-Limpieza Proc Log en batch
        // Fix size of SUBSTR with calculated strlen($this->tablename)+1
        // Substitutes table name prefix with $this->tablename
        /*
         * Para saber los nombres de los Archives de PROC_LOGS en la base de datos corriente
         */
        $sql = 'SELECT TABLE_NAME FROM INFORMATION_SCHEMA.TABLES WHERE SUBSTR(TABLE_NAME, 1, ' . (strlen($this->tablename) + CLX_NUM_ONE) . ') = ' . singleQuote($this->tablename . '_') . ' AND TABLE_SCHEMA = ' . singleQuote(kDatabaseName);
        $results = ClxCommon::$db->executeQuery($sql);
        $tables = array();
        while (($rec = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE))) {
		  $tables[] = $rec['TABLE_NAME'];
        }
        // Verifica su hay archives
        if (count($tables) > CLX_NUM_ZERO) {
		  // List of archive tables to backup (separated by '/')
		  $parameters['TABLES'] = implode('/', $tables);
		  //   - Caso 1002670 - BNP-Limpieza Proc Log en batch
		  // to avoid Recycler to delete those bkp files
		  // Le agrega lo necesario para que el respaldo se conserve del reciclaje
		  if (defined('ACAD_ARC_NAME_SUFFIX')) {
			 $archive_name_suffix = ACAD_ARC_NAME_SUFFIX;
		  } else {
			 $archive_name_suffix = '';
		  }
		  if ($archive_name_suffix === '' || $archive_name_suffix === 'null' || is_null($archive_name_suffix)
		  ) {
			 $archive_name_suffix = '';
		  }
		  // Backup file name
		  $parameters['NAME_SUFFIX'] = '_' . $this->tablename . $archive_name_suffix;
		  // No Drop Table option
		  $parameters['DUMP_OPTIONS'] = '--skip-add-drop-table';
		  // Local Backup Script optional parameters: Don't stop minute-by-minute process
		  $parameters['LBS_OPT_PAR'] = '-ncss 0';
		  $contenidoHTML.= '<br>' .
			     'Calling backup procedure<br>';
		  'Tables: ' . str_replace('/', ', ', $parameters['TABLES']) . '<br>';
		  'File name suffix: ' . $parameters['NAME_SUFFIX'] . '<br>';
		  // Llama al respaldo pasandole como parametro los nombres de los archives
		  $results = $DBBK->run($parameters);
		  if ($results === '') {
			 // Si el respaldo fue existoso, elimina los archives de la BDD
			 $contenidoHTML.= '<br>';
			 foreach ($tables as $key => $val) {
			     $contenidoHTML.= 'Dropping Table: ' . $val . '<br>';
			     $sql = 'DROP TABLE IF EXISTS ' . $val;
			     CLX_PROP_100PCTexecuteQuery($sql);
			 }
		  } else {
			 $contenidoHTML.= '<br>' .
			         'ERROR: excecuting backup<br>';
			 $results;
			 '<br>';
		  }
        }
        echo $contenidoHTML;
    }

}

// End class
