<?php

/**
 * Process Seccion Manager
 *
 * @package		Clientix.Tool.Process
 * @abstract		Process Engine Manager
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version    	$Rev: 9615 $
 *
 */
class pr_sections extends clx_tool {

    /**
     * Constructor
     */
    function __construct() {
        $this->code = 'PRSE';
        $this->name = 'Process Section Manager';
        $this->system = 'Process';
        $this->version = '5.5.0.0';
        $this->tablename = 'CLX_PR_SECTIONS';
        $this->record_name_singular = 'GEN_LBL_PR_SECTION';
        $this->record_name_plural = 'GEN_LBL_PR_SECTION';
        $this->primary_key = array('IDCODE');
        $this->primary_field = 'IDCODE';
        $this->secondary_field = 'IDNAME';
        $this->terciary_field = 'PROCESSCODE';

        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_PRSE_TITLE_CREATE',
		  'panels' => array(
			 array('type' => 'normal',
			     'entries' => array(
			         array('label' => 'GEN_LBL_CODE',
					   'fields' => array(
						  array('name' => 'idcode',
						      'type' => 'string',
						      'default' => '',
						      'size' => '16',
						      'displaysize' => '16',
						      'dontmodify' => '1',
						      'validations' => array(
								array('type' => 'sqlobject',
								    'required' => '1'
								), array('type' => 'unique',
								    'fieldname' => 'idcode',
								    'tablename' => $this->tablename)
						      )
						  )
					   )
			         ), array('label' => 'GEN_LBL_NAME',
					   'fields' => array(
						  array('name' => 'idname',
						      'type' => 'string',
						      'default' => '',
						      'size' => '64',
						      'displaysize' => '48',
						      'validations' => array(
								array('type' => 'string',
								    'required' => '1'
								)
						      )
						  )
					   )
			         ), array('label' => 'GEN_LBL_PROCESSCODE',
					   'fields' => array(
						  array('name' => 'processcode',
						      'type' => 'lookup',
						      'default' => '',
						      'readonly' => true,
						      'tool' => 'PRPR',
						      'validations' => array(
								array('type' => 'sqlobject',
								    'required' => '1'
								), array('type' => 'lookup',
								    'fieldname' => 'idcode',
								    'tablename' => 'CLX_PR_PROCESS'
								)
						      )
						  )
					   )
			         ), array('label' => 'GEN_LBL_IS_MAINSECTION',
					   'fields' => array(
						  array('name' => 'is_mainsection',
						      'type' => CLX_CLASS_LIST,
						      'default' => '0',
						      'options' => $this->yesno)
					   )
			         ), array('label' => 'GEN_LBL_STATUS',
					   'fields' => array(
						  array('name' => 'status',
						      'type' => CLX_CLASS_LIST,
						      'default' => '1',
						      'options' => $this->status)
					   )
			         ), array('label' => 'GEN_LBL_DESCRIPTION',
					   'fields' => array(
						  array('name' => 'description',
						      'type' => 'text',
						      'default' => '',
						      'cols' => '48',
						      'rows' => '4'
						  )
					   )
			         )
			     )
			 ), array('type' => 'normal',
			     CLX_CLASS_TITLE => 'GEN_LBL_RECORD_INFO',
			     'entries' => array(
			         array('label' => 'GEN_LBL_VERSION',
					   'fields' => array(
						  array('name' => 'version',
						      'type' => 'string',
						      'default' => '1.0.0',
						      'size' => '32',
						      'displaysize' => '16',
						      'validations' => array(
								array('type' => 'string',
								    'required' => '1'
								)
						      )
						  )
					   )
			         ), array('label' => 'GEN_LBL_VERSION_COUNTER',
					   'fields' => array(
						  array('name' => 'version_counter',
						      'type' => 'string',
						      'default' => '1.0.0',
						      'readonly' => true,
						      'size' => '32',
						      'displaysize' => '16'
						  )
					   )
			         )
			     )
			 )
		  )
        );
        $this->viewform = $this->editform;
        $this->viewform[CLX_CLASS_TITLE] = 'TOOL_PRSE_TITLE_DISPLAY';
        $this->toolpanelkeys = array(array('name' => 'PROCESSCODE', 'type' => 'string'));
        $this->toolpanel = array('name' => $this->tablename, CLX_CLASS_TITLE => $this->record_name_plural, 'fields' =>
		  array(array('name' => 'ID', 'label' => 'GEN_LBL_ID', 'type' => 'number'), array('name' => 'IDCODE', 'label' => 'GEN_LBL_IDCODE', 'type' => 'string'), array('name' => 'IDNAME', 'label' => 'GEN_LBL_IDNAME', 'type' => 'string'), array('name' => 'IS_MAINSECTION', 'label' => 'GEN_LBL_IS_MAINSECTION', 'options' => $this->yesno, 'type' => CLX_CLASS_LIST), array('name' => 'STATUS', 'label' => 'GEN_LBL_STATUS', 'options' => $this->status, 'type' => CLX_CLASS_LIST), array('name' => 'PROCESSCODE', 'label' => 'GEN_LBL_PROCESSCODE', 'type' => 'string'), array('name' => 'DESCRIPTION', 'label' => 'GEN_LBL_DESCRIPTION', 'type' => 'string'), array('name' => 'VERSION', 'type' => 'fieldgroup', 'fields' => array(
			         array('name' => 'VERSION', 'type' => 'string', 'sufix' => '.'), array('name' => 'VERSION_COUNTER', 'type' => 'number'))
			 )
		  )
        );
    }

// End method
    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['IDCODE'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
        $fields['IDNAME'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '');
        $fields['IS_MAINSECTION'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO, 'properties' => '');
        $fields['STATUS'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => '1', 'properties' => '');
        $fields['PROCESSCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['DESCRIPTION'] = array('type' => 'mediumtext', 'properties' => '');
        $fields['VERSION'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
        $fields['VERSION_COUNTER'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => '0');
        $fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['MDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'IDCODE');
        $indexes[$ipf . '04'] = array('index' => 'MUL', 'fieldname' => 'PROCESSCODE');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
		  'fields' => $fields,
		  'indexes' => $indexes);
    }

    function pack($record) {
        $o = $this->packRecord($record);
        $objs = new XMLObject($this->code . '_OBJECTS');
        $this->packsub($objs, 'EVNT', 'SELECT * FROM CLX_EVENTS WHERE OWNERID=' . singleQuote($record['IDCODE']) . ' AND OWNERCODE = ' . singleQuote('PRSE') . '');
        $o->addObject($objs);
        return $o;
    }

    function unpack($parameters) {
        $parameters = array_values(array_merge(array('package' => null), $parameters));
        list($package) = $parameters;
        $record = $this->unpackRecord($package);
        $exists = (ClxCommon::$db->oneExistsRecords($this->tablename, 'UPPER(IDCODE)=' . singleQuote(uppercase($record['IDCODE']))) > CLX_NUM_ZERO);
        if ($exists === true) {
		  ClxCommon::$db->deleteRecords($this->tablename, 'UPPER(IDCODE)=' . singleQuote(uppercase($record['IDCODE'])));
        }
        ClxCommon::$db->deleteRecords('CLX_EVENTS', 'OWNERID=' . singleQuote($record['IDCODE']) . ' AND OWNERCODE = ' . singleQuote('PRSE') . '');
        ClxCommon::$db->createRecordVoid($this->tablename, $record, false);
        if ($package->hasSubObject($this->code . '_OBJECTS')) {
		  $objs = $package->getObjectXml($this->code . '_OBJECTS');
		  foreach ($objs->objects as $o) {
			 $toolcode = $o->tag;
			 $tool = getTool($toolcode);
			 $tool->unpack(array('package' => $o, 'id' => $record['IDCODE']));
		  }
        }
    }

    /**
     * Tool Action
     * @param string $ac Action code
     * @param string $idlist Record(s) affected by action
     * @return string
     */
    function action($ac, $idlist) {
        if ($this->getAccess()->canRead()) {
		  $contents = parent::action($ac, $idlist);
        } else {
		  $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [PR_SECTIONS-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    /**
     * Verify Tool Form
     * @param array $msg
     * @return bool
     */
    function checkForm(&$msg) {
        $result = parent::checkForm($msg);
        //check if main section
        if (UserRequest::$post['PRSE_is_mainsection']) {
            $qty = ClxCommon::$db->oneExistsRecords($this->tablename, 'IS_MAINSECTION = 1 AND IDCODE <> ' . singleQuote(UserRequest::$post['PRSE_idcode']) . ' AND PROCESSCODE = ' . singleQuote(UserRequest::$post['PRSE_processcode']));
		  if ($qty != CLX_NUM_ZERO) {
			 $msg['PRSE_is_mainsection'] = dict('GEN_LBL_ERROR_MAINSECTION');
			 $result = false;
		  }
        }
        return $result;
    }

    /**
     * Build display form contents
     * @param array $record
     * @return string
     */
    function viewFormFill($record) {
        addHistory('sectionid', $record['PRSE_id']);
        addHistory('sectioncode', $record['PRSE_idcode']);
        addHistory('ownercode', $this->code);
        addHistory('ownerid', $record['PRSE_idcode']);
        addHistory('processcode', $record['PRSE_processcode']);
        $EVNT = &getTool('EVNT');
        return $EVNT->makepanel($this->code, $record['PRSE_idcode']);
    }

    /**
     * Deletes record on selected id
     *
     * @param integer $id
     */
    function deleteRecordSk($id) {
        $idcode = ClxCommon::$db->getField($this->tablename, 'IDCODE', 'ID=' . $id);
        //Deleting Steps
        $EVNT = getTool('EVNT');
        $rs = ClxCommon::$db->getRecords($EVNT->tablename, 'OWNERID=' . singleQuote($idcode) . ' AND OWNERCODE = ' . singleQuote($this->code));
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
		  $EVNT->deleteRecordSk($r['ID']);
        }
		ClxCommon::$db->freeResult( $rs );
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
    }

    function versionIncrease($fieldname, $fieldvalue) {
        $processcode = ClxCommon::$db->getField($this->tablename, 'PROCESSCODE', $fieldname . '=' . singleQuote($fieldvalue));
        $PRPR = &getTool('PRPR');
        $PRPR->versionIncrease('IDCODE', $processcode);
        parent::versionIncrease($fieldname, $fieldvalue);
    }

    function defaultRecord() {
        $callingpage = peekHistory();
        $record = parent::defaultRecord();
        $record['PRSE_version'] = '1.0.0';
        $record['PRSE_status'] = CLX_NUM_ONE;
        $record['PRSE_is_mainsection'] = CLX_INIT_ZERO;
        $record['PRSE_processcode'] = $callingpage['processcode'];
        return $record;
    }

}
