<?php

/**
 * Manager Logs
 * Webservices Manager Logs
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version      $Rev: 9615 $
 *
 * CHANGE LOG
 *  Included label
 */
class sk_logs extends clx_tool {

    var $import_types;
    var $importForm;

    /**
     * Constructor
     * @param void
     * @return void
     */
    function __construct() {
        $this->code = 'SKML';
        $this->name = 'Manager Logs';
        $this->system = 'Sockets';
        $this->version = '5.5.0.0';

        $this->has_access = true;


        $this->tablename = 'CLX_SK_LOGS';
        $this->record_name_singular = 'GEN_LBL_SERVICE_LOG';
        $this->record_name_plural = 'GEN_LBL_SERVICE_LOGS';
        $this->primary_field = 'SERV_CODE';
        $this->secondary_field = 'SERV_STATUS';

        $this->serv_status = array('NOT' => 'GEN_LBL_NOTSTARTED', 'IDLE' => 'GEN_LBL_IDLE', 'STOP' => 'GEN_LBL_STOPPED', 'RUN' => 'GEN_LBL_RUN', 'CANC' => 'GEN_LBL_CANC', 'ERRO' => 'GEN_LBL_ERROR', 'END' => 'GEN_LBL_END', 'ENDR' => 'GEN_LBL_ENDR');
        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_SKML_TITLE_CREATE',
            'panels' => array(
                array('type' => 'normal',
                    'entries' => array(
                        array('label' => 'GEN_LBL_SERV_CODE',
                            'fields' => array(
                                array('name' => 'serv_code', 'type' => 'lookup', 'default' => '', 'tool' => 'SKSV', 'validations' => array(
                                        array('type' => 'lookup',
                                            'fieldname' => 'IDCODE',
                                            'tablename' => 'CLX_SK_SERVICES')
                                    )
                                )
                            )
                        ), array('label' => 'GEN_LBL_MESSAGE',
                            'fields' => array(
                                array('name' => 'message', 'type' => 'text', 'default' => '', 'cols' => '48', 'rows' => '4'))
                        ), array('label' => 'GEN_LBL_SERV_STATUS',
                            'fields' => array(
                                array('name' => 'serv_status', 'type' => CLX_CLASS_LIST, 'options' => $this->serv_status)
                            )
                        )
                    )
                )
            )
        );
        $this->viewform = $this->editform;
    }

    function install() {
        $UIMI = getTool('UIMI');
        $UIMI->add($this->code, 'MENU_TOOLS:MENU_SERVCONNECTOR:MENU_SKLOGS', 'TOOL', $this->code, 'ac=LIST');
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI', 'index' => 'PRI');
        $fields['SERV_CODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['MDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['USERNAME'] = array('type' => 'varchar(30)', 'null' => 'YES', 'properties' => '');
        $fields['SERV_STATUS'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '', 'default' => '0', 'index' => 'MUL');
        $fields['MESSAGE'] = array('type' => 'text', 'properties' => '', 'index' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'MUL', 'fieldname' => 'SERV_CODE');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'USERNAME');
        $indexes[$ipf . '04'] = array('index' => 'MUL', 'fieldname' => 'SERV_STATUS');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB', 'fields' => $fields, 'indexes' => $indexes);
    }

    function makelist($listingcode = null) {
         //$t = time('U'); genera un warning
		$t = time();
        $to = $this->code;
        $here = 'tool.php?to=' . $to . '&t=' . $t;
        clearHistory();
        pushHistory($this->code, 'LIST', array());
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->setProp(CLX_PROP_ID, 'SKMLList');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'NOT_DEFINED');
        $selectclause = '*';
        $fromclause = $this->tablename;
        $whereclause = '';
        $sortclause = 'MDATE DESC, CDATE DESC';
        $page = new xPaging();
        $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
        $table = new htmlTable(CLX_WIDTH_7);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_SKML_TITLE_LIST'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_7));
        $page->header($table);
        $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_SERV_CODE'), dict('GEN_LBL_SERV_STATUS'), dict('GEN_LBL_USERNAME'), dict('GEN_LBL_MESSAGE'), dict('GEN_LBL_CDATE'), dict('GEN_LBL_MDATE')));
        $i = CLX_INIT_ZERO;
        while ($record = $page->nextRecord()) {
            $recordid = $record['ID'];
            $select = new htmlCheckbox('selector_' . $recordid, false);
            $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
            $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
            $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array(
                $record['SERV_CODE'], dict($this->serv_status[$record['SERV_STATUS']]), $record['USERNAME'], $record['MESSAGE'], $record['CDATE'], $record['MDATE']));
            $i++;
        }
        $buttons = htmlButton::getButton('submit', dict('GEN_LBL_DISPLAY'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        if ($this->getAccess()->canModify()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canDelete()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canDisplay()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE_SOMETHING', dict('GEN_LBL_SKML_CREATEMSG')), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        }
        $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_FILTER'), array('action' => 'FILTER', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        $form->addContents($page->footers($table, $buttons));
        return $form->source();
    }

    function confirmDeleteFill(&$table, $record) {
        $table->addData(dict('GEN_LBL_SERV_CODE') . ':', $record['SKML_serv_code']);
        $table->addData(dict('GEN_LBL_MESSAGE') . ':', $record['SKML_message']);
    }

    function loadToolRecord($recordid) {
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID= ' . $recordid);
        $record = array();
        $record['SKML_id'] = $recordid;
        $record['SKML_serv_code'] = $values['SERV_CODE'];
        $record['SKML_username'] = $values['USERNAME'];
        $record['SKML_cdate'] = $values['CDATE'];
        $record['SKML_mdate'] = $values['MDATE'];
        $record['SKML_serv_status'] = $values['SERV_STATUS'];
        $record['SKML_message'] = $values['MESSAGE'];
        return $record;
    }

    function saveRecord() {
        $d = xFormat::getNow('Y-m-d H:i:s');
        $record = array();
        $record['SERV_CODE'] = UserRequest::$post['SKML_serv_code'];
        $record['MDATE'] = $d;
        $record['SERV_STATUS'] = UserRequest::$post['SKML_serv_status'];
        $record['MESSAGE'] = UserRequest::$post['SKML_message'];
        return ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post['SKML_id']);
    }

    function createRecord_() {
        $d = xFormat::getNow('Y-m-d H:i:s');
        $record = array();
        $record['SERV_CODE'] = UserRequest::$post['SKML_serv_code'];
        $record['USERNAME'] = $_SESSION['user_record']['username'];
        $record['CDATE'] = $d;
        $record['MDATE'] = $d;
        $record['SERV_STATUS'] = UserRequest::$post['SKML_serv_status'];
        $record['MESSAGE'] = UserRequest::$post['SKML_message'];
        return ClxCommon::$db->createRecord($this->tablename, $record, false);
    }

    function deleteRecordSk($id) {
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
    }

    function defaultRecord() {
        $d = xFormat::getNow('Y-m-d H:i:s');
        $record = array();
        $record['SKML_id'] = CLX_INIT_ZERO;
        $record['SKML_serv_code'] = '';
        $record['SKML_username'] = $_SESSION['user_record']['username'];
        $record['SKML_cdate'] = $d;
        $record['SKML_mdate'] = $d;
        $record['SKML_serv_status'] = 'NOT';
        $record['SKML_message'] = '';
        return $record;
    }

    function versionIncrease($fieldname, $fieldvalue) {

    }

    /**
     * Submit entry to report log and return last inserted log id
     * @param string $service_code
     * @param string $message
     * @param string $status
     * @param int $log_id
     * @return int $log_id
     */
    function report($service_code, $msg, $status = 'NOT', $log_id = CLX_NUM_ZERO) {
        $save_post = UserRequest::$post;
        if ($log_id == CLX_NUM_ZERO) {
            $record = $this->defaultRecord();
            $record['SKML_serv_code'] = $service_code;
            $record['SKML_message'] = $msg;
            $record['SKML_serv_status'] = $status;
            UserRequest::$post = $record;
            $log_id = $this->createRecord();
        } else {
            $record = $this->loadToolRecord($log_id);
            $record['SKML_id'] = $log_id;
            $record['SKML_message'] .= '<br>' . $msg;
            $record['SKML_serv_status'] = $status;
            UserRequest::$post = $record;
            $log_id = $this->saveRecord();
        }
        UserRequest::$post = $save_post; //return post
        return $log_id;
    }

    function toolArchive() {
        if (!defined('UTIL_ARCHIVE_MODE'))
            define('UTIL_ARCHIVE_MODE', CLX_NUM_12);
        //Archive
        $sql = 'SELECT * FROM ' . $this->tablename;
        if (UTIL_ARCHIVE_MODE == CLX_NUM_ONE) {
            $archive_tbl = $this->tablename . '_' . getNow('m') . '_' . getNow('Y');
        } else {
            $archive_tbl = $this->tablename . '_' . getNow('Y');
        }
        $tableinfo = $this->toolTableStructure();
        unset($tableinfo['fields']['ID']);
        unset($tableinfo['fields']['SERV_STATUS']['index']);
        $tableinfo['name'] = $archive_tbl;
        $tableinfo['type'] = 'ARCHIVE';
        $tableinfo['indexes'] = array();
        $structure = ClxCommon::$db->translateTableStructure($tableinfo);
        //Create table if not exists
        if (!ClxCommon::$db->tableExists($structure['name'])) {
            //Create table if not exists
            ClxCommon::$db->createTable($structure['name'], $structure['type'], $structure['fields'], $structure['case_sensitive']);
        }
        $comma = '';
        $select = '';
        foreach ($structure['fields'] as $key => $val) {
            $select .= $comma . $key;
            $comma = ',';
        }
        //Lock table to archive
        $sql = 'SELECT MAX(ID) FROM ' . $this->tablename;
        $maxid = ClxCommon::$db->getOne($sql);
        if (empty($maxid))
            return;
        //Backup
        $sql = 'INSERT INTO ' . $structure['name'] . '(' . $select . ') SELECT ' . $select . ' FROM ' . $this->tablename . ' WHERE ID <=' . $maxid;
        ClxCommon::$db->executeQuery($sql);
        //Unlock table
        $sql = 'DELETE FROM ' . $this->tablename . ' WHERE ID<=' . $maxid;
        ClxCommon::$db->executeQuery($sql);
        //Restore stats if apply
        ClxCommon::$db->buldStats($this->tablename);
    }

    function toolArchive_batch($parameters) {
	$contenidoHTML='';
        //   - Caso 1002598 - BNP-Limpieza Proccess Logs en Batch
        // Method 'get_bkp_time_limit' implemented to avoid schedule CLX_PRLO_CLEAN
        // to remain un 'In progress(RUN) status due to PHP timeout.
        $DBBK = getToolObject('UTIL', 'DBBK');
        $bkp_time_limit = $DBBK->get_bkp_time_limit();
        // Set it to twice the time limit of backup, just in case
        UserResponse::setRunTimeLimit($bkp_time_limit * CLX_NUM_TWO * CLX_NUM_60 * CLX_NUM_60);
        //   - Caso 1002598 - BNP-Limpieza Audit en Batch
        // Se agrega este método para realizar el archival en batch,
        // ya que en los casos que CLX_PR_PROC_LOGS tenga muchos registros,
        // se cae cuando se hace en el interactivo.
        // Realiza la llamada al método $this->toolArchive()
        $this->toolArchive();
        // Extrae la lista de las tablas con los archives existentes
        //   - Caso 1002670 - BNP-Limpieza Proc Log en batch
        // Fix size of SUBSTR with calculated strlen($this->tablename)+1
        // Substitutes table name prefix with $this->tablename
        /*
         * Para saber los nombres de los Archives de PROC_LOGS en la base de datos corriente
         */
        $sql = 'SELECT  TABLE_NAME  FROM  INFORMATION_SCHEMA.TABLES  WHERE  /* SUBSTR(TABLE_NAME, 1, 13) = ' . singleQuote('CLX_SK_LOGS') . '  */ 					SUBSTR(TABLE_NAME, 1, ' . (strlen($this->tablename) + CLX_NUM_ONE) . ') = ' . singleQuote(($this->tablename . '_')) . '  AND TABLE_SCHEMA = ' . singleQuote(kDatabaseName);
        $results = ClxCommon::$db->executeQuery($sql);
        $tables = array();
        while (($rec = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE))) {
            $tables[] = $rec['TABLE_NAME'];
        }
        // Verifica su hay archives
        if (count($tables) > CLX_NUM_ZERO) {
            // List of archive tables to backup (separated by '/')
            $parameters['TABLES'] = implode('/', $tables);
            //   - Caso 1002670 - BNP-Limpieza Proc Log en batch
            // to avoid Recycler to delete those bkp files
            // Le agrega lo necesario para que el respaldo se conserve del reciclaje
            if (defined('ACAD_ARC_NAME_SUFFIX')) {
                $archive_name_suffix = ACAD_ARC_NAME_SUFFIX;
            } else {
                $archive_name_suffix = '';
            }
            if ($archive_name_suffix === '' || $archive_name_suffix === 'null' || is_null($archive_name_suffix)) {
                $archive_name_suffix = '';
            }
            // Backup file name
            $parameters['NAME_SUFFIX'] = '_' . $this->tablename . $archive_name_suffix;
            // No Drop Table option
            $parameters['DUMP_OPTIONS'] = '--skip-add-drop-table';
            // Local Backup Script optional parameters: Don't stop minute-by-minute process
            $parameters['LBS_OPT_PAR'] = '-ncss 0';
            $contenidoHTML.= '<br>' . 'Calling backup procedure<br>' . 'Tables: ' . str_replace('/', ', ', $parameters['TABLES']) . '<br>' . 'File name suffix: ' . $parameters['NAME_SUFFIX'] . '<br>';
            // Llama al respaldo pasandole como parametro los nombres de los archives
            $results = $DBBK->run($parameters);
            if ($results === '') {
                // Si el respaldo fue existoso, elimina los archives de la BDD
                $contenidoHTML.='<br>';
                foreach ($tables as $key => $val) {
                    $contenidoHTML.= 'Dropping Table: ' . $val . '<br>';
                    $sql = 'DROP TABLE IF EXISTS ' . $val;
                    ClxCommon::$db->executeQuery($sql);
                }
            } else {
                $contenidoHTML.= '<br>' .
                        'ERROR: excecuting backup<br>' .
                        $results . '<br>';
            }
	
        }
	echo $contenidoHTML;
    }

}

// End class
