<?php

/**
 * Service Messages Mapping Fields
 * Webservices Service Messages Mapping Fields
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date:  12:44:59 -0500 (Mon, 28 Dec 2009) $
 * @version    	$Rev: 1599 $
 *
 * CHANGE LOG
 *  Included label
 */
class sk_map_fields extends clx_tool {

    var $editform;

    function __construct() {
        $this->code = 'SKMF';
        $this->name = 'Service Messages Mapping Fields';
        $this->system = 'Sockets';
        $this->version = '5.5.1.0';
        $this->accesskey = 'EBSK';



        $this->tablename = 'CLX_SK_MAP_FIELDS';
        $this->record_name_singular = 'GEN_LBL_MAP_FIELDS';
        $this->record_name_plural = 'GEN_LBL_MAP_FIELD';
        $this->primary_field = 'IDCODE';
        $this->secondary_field = 'MAP_CODE';

        $this->yes_no = array('0' => 'GEN_LBL_NO', '1' => 'GEN_LBL_YES');
        $this->val_types = array('FILD' => 'GEN_LBL_MAP', 'PFIL' => 'GEN_LBL_FOREIGN_KEY', 'PRMT' => 'GEN_LBL_PARAMETER', 'CONS' => 'GEN_LBL_CONSTANT', 'IGNR' => 'TOOL_DBIC_IGNORE');
        $this->editform = array(CLX_CLASS_TITLE => 'TOOL_SKMF_TITLE_CREATE',
            'panels' => array(
                array('type' => 'normal',
                    'entries' => array(
                        array('label' => 'GEN_LBL_QUERYCODE',
                            'fields' => array(
                                array('name' => 'querycode', 'type' => 'lookup', 'default' => '', 'tool' => 'DBQY', 'validations' => array(
                                        array('type' => 'string', 'required' => '1'), array('type' => 'lookup', 'fieldname' => 'IDCODE', 'tablename' => 'CLX_DB_QUERIES'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_TABLECODE',
                            'fields' => array(
                                array('name' => 'tablecode', 'type' => 'lookup', 'default' => '', 'tool' => 'DBTB', 'validations' => array(
                                        array('type' => 'string', 'required' => '1'), array('type' => 'lookup', 'fieldname' => 'IDCODE', 'tablename' => 'CLX_DB_TABLES'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_FIELDNAME',
                            'fields' => array(
                                array('name' => 'fieldname', 'type' => 'lookup', 'tool' => 'DBTF', 'tablecode' => 'SKMF_tablecode', 'validations' => array(
                                        array('type' => 'sqlobject', 'required' => '1'), array('type' => 'query', 'query' => 'SELECT FIELDNAME SKMF_FIELDNAME FROM CLX_DB_TABLEFIELDS WHERE TABLECODE=' . singleQuote('SKMF_tablecode') . ' AND FIELDNAME=' . singleQuote('SKMF_fieldname') . ''))
                                )
                            )
                        ), array('label' => 'GEN_LBL_IDCODE',
                            'fields' => array(
                                array('name' => 'idcode', 'type' => 'string', 'default' => '', 'size' => '16', 'displaysize' => '64', 'dontmodify' => true,
                                    'validations' => array(
                                        array('type' => 'unique', 'fieldname' => 'IDCODE', 'tablename' => $this->tablename), array('type' => 'string', 'required' => '1'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_MAP_CODE',
                            'fields' => array(
                                array('name' => 'map_code', 'type' => 'string', 'default' => '', 'size' => '16', 'displaysize' => '64', 'readonly' => true, 'validations' => array(
                                        array('type' => 'string', 'required' => '1'))
                                )
                            )
                        ), array('label' => 'GEN_LBL_VAL_FORMULA',
                            'fields' => array(
                                array('name' => 'val_formula', 'type' => 'text', 'cols' => '48', 'rows' => '4'))
                        ), array('label' => 'GEN_LBL_CLXFIELD_FORMAT',
                            'fields' => array(
                                array('name' => 'clxfield_format', 'type' => CLX_CLASS_LIST, 'default' => '0', 'options' => $this->yes_no))
                        ), array('label' => 'GEN_LBL_READ_ONLY',
                            'fields' => array(
                                array('name' => 'read_only', 'type' => CLX_CLASS_LIST, 'default' => '0', 'options' => $this->read_only))
                        ), array('label' => 'GEN_LBL_SEARCH_KEY',
                            'fields' => array(
                                array('name' => 'search_key', 'type' => CLX_CLASS_LIST, 'default' => '0', 'options' => $this->yes_no))
                        ), array('label' => 'TOOL_SKMP_VAL_TYPE',
                            'fields' => array(
                                array('name' => 'val_type', 'type' => 'dynamic', 'panels' => $this->val_types)
                            )
                        )
                    )
                ), array('type' => 'dynamic',
                    'code' => 'FILD',
                    'entries' => array(
                        array('label' => 'GEN_LBL_VAL_ELEMENT',
                            'fields' => array(
                                array('name' => 'val_element', 'type' => 'lookup', 'default' => '', 'tool' => 'SKME', 'validations' => array(
                                        array('type' => 'lookup', 'fieldname' => 'IDCODE', 'tablename' => 'CLX_SK_ELEMENTS'))
                                )
                            )
                        )
                    )
                ), array('type' => 'dynamic',
                    'code' => 'PRMT',
                    'entries' => array(
                        array('label' => 'GEN_LBL_PRMT_NAME',
                            'fields' => array(
                                array('name' => 'prmt_name', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '64'))
                        )
                    )
                ), array('type' => 'dynamic',
                    'code' => 'PFIL',
                    'entries' => array(
                        array('label' => 'GEN_LBL_VAL_MAP_FIELD',
                            'fields' => array(
                                array('name' => 'val_map_field', 'type' => 'lookup', 'default' => '', 'tool' => 'SKMF', 'validations' => array(
                                        array('type' => 'lookup', 'fieldname' => 'IDCODE', 'tablename' => $this->tablename))
                                )
                            )
                        )
                    )
                ), array('type' => 'dynamic',
                    'code' => 'CONS',
                    'entries' => array(
                        array('label' => 'GEN_LBL_CONSTANT',
                            'fields' => array(
                                array('name' => 'val_constant', 'type' => 'string', 'default' => '', 'size' => '255', 'displaysize' => '64'))
                        )
                    )
                ), array('type' => 'dynamic',
                    'code' => 'IGNR',
                    'entries' => array()
                )
            )
        );
        $this->viewform = $this->editform;
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['IDCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['MSG_CODE'] = array('type' => 'varchar(16)', 'null' => 'YES', 'properties' => '');
        $fields['MAP_CODE'] = array('type' => 'varchar(16)', 'null' => 'YES', 'properties' => '');
        $fields['QUERYCODE'] = array('type' => 'varchar(16)', 'null' => 'YES', 'properties' => '');
        $fields['TABLECODE'] = array('type' => 'varchar(4)', 'null' => 'YES', 'properties' => '');
        $fields['FIELDNAME'] = array('type' => 'varchar(64)', 'null' => 'YES', 'properties' => '');
        $fields['PRMT_NAME'] = array('type' => 'varchar(64)', 'null' => 'YES', 'properties' => '');
        $fields['VAL_ELEMENT'] = array('type' => 'varchar(16)', 'null' => 'YES', 'properties' => '');
        $fields['VAL_MAP_FIELD'] = array('type' => 'varchar(16)', 'null' => 'YES', 'properties' => '');
        $fields['VAL_TYPE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['VAL_FORMULA'] = array('type' => 'mediumtext', 'null' => 'YES', 'properties' => '');
        $fields['VAL_CONSTANT'] = array('type' => 'varchar(255)', 'null' => 'YES', 'properties' => '');
        $fields['CLXFIELD_FORMAT'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO, 'properties' => '');
        $fields['SEARCH_KEY'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO, 'properties' => '');
        $fields['READ_ONLY'] = array('type' => 'tinyint(1) unsigned', 'null' => 'NO', 'default' => CLX_NUM_ZERO, 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'IDCODE');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'MSG_CODE');
        $indexes[$ipf . '04'] = array('index' => 'MUL', 'fieldname' => 'MAP_CODE');
        $indexes[$ipf . '05'] = array('index' => 'MUL', 'fieldname' => 'QUERYCODE,TABLECODE,FIELDNAME');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
            'fields' => $fields,
            'indexes' => $indexes);
    }

    function pack($record) {
        $o = $this->packRecord($record);
        $objs = new XMLObject($this->code . '_OBJECTS');
        $this->packsub($objs, 'SKMT', 'SELECT * FROM CLX_SK_TRANSLATIONS WHERE MAPF_CODE=' . singleQuote($record['IDCODE']));
        $o->addObject($objs);
        return $o;
    }

    function unpack($parameters) {
        $parameters = array_values(array_merge(array('package' => null), $parameters));
        list($package) = $parameters;
        $record = $this->unpackRecord($package);
        $exists = (ClxCommon::$db->oneExistsRecords($this->tablename, 'UPPER(IDCODE)=' . singleQuote(uppercase($record['IDCODE']))) > CLX_NUM_ZERO);
        if ($exists === true) {
            ClxCommon::$db->deleteRecords($this->tablename, 'UPPER(IDCODE)=' . singleQuote(uppercase($record['IDCODE'])));
        }
        $id = ClxCommon::$db->createRecord($this->tablename, $record, false);
        if ($package->hasSubObject($this->code . '_OBJECTS')) {
            $objs = $package->getObjectXml($this->code . '_OBJECTS');
            foreach ($objs->objects as $o) {
                $toolcode = $o->tag;
                $tool = getTool($toolcode);
                $tool->unpack(array('package' => $o, 'id' => $id));
            }
        }
    }

    function makepanel($map_code = null) {
        if ($this->getAccess()->canRead()) {
            $t = time();
            $to = $this->code;
            $here = 'tool.php?to=' . $to . '&t=' . $t;
            $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
            $form->setProp(CLX_PROP_ID, 'SKMFPanel');
            $form->addArgument(CLX_PROP_TO, $this->code);
            $form->addArgument('map_code', $map_code);
            $form->addArgument('ac', 'NOT_DEFINED');
            $selectclause = '*';
            $fromclause = $this->tablename;
            $whereclause = 'MAP_CODE=' . singleQuote($map_code);
            $sortclause = 'TABLECODE, IDCODE';
            $page = new xPaging();
            $page->setProp('rpp', CLX_NUM_TEN_THOUSAND);
            $page->setProp('printheaders', false);
            $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
            $table = new htmlTable(CLX_WIDTH_11);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $page->header($table);
            $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_FIELDNAME'), dict('GEN_LBL_IDCODE'), dict('GEN_LBL_VAL_TYPE'), dict('GEN_LBL_READ_ONLY'), dict('GEN_LBL_SEARCH_KEY'), dict('GEN_LBL_CLXFIELD_FORMAT'), dict('GEN_LBL_PRMT_NAME'), dict('GEN_LBL_VAL_FORMULA'), dict('GEN_LBL_VAL_ELEMENT'), dict('GEN_LBL_VAL_MAP_FIELD')));
            $i = CLX_INIT_ZERO;
            while ($record = $page->nextRecord()) {
                $recordid = $record['ID'];
                $select = new htmlCheckbox('selector_' . $recordid, false);
                $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
                $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
                if ($record['VAL_ELEMENT'] <> '') {
                    $ele = ClxCommon::$db->getFields('CLX_SK_ELEMENTS', 'IDCODE, IDNAME, MSG_CODE, XPATH', 'IDCODE =' . singleQuote($record['VAL_ELEMENT']));
                    if (!empty($ele['XPATH']))
                        $ele['IDNAME'] = $ele['XPATH'];
                    $record['VAL_ELEMENT'] = $ele['IDCODE'] . ': ' . $ele['XPATH'];
                }
                if ($record['VAL_MAP_FIELD'] <> '') {
                    $ele = ClxCommon::$db->getFields($this->tablename, 'IDCODE, TABLECODE, FIELDNAME', 'IDCODE =' . singleQuote($record['VAL_MAP_FIELD']));
                    $record['VAL_MAP_FIELD'] = $ele['IDCODE'] . ': ' . $ele['TABLECODE'] . '.' . $ele['fieldname'];
                }
                $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array(
                    $record['TABLECODE'] . '.' . $record['FIELDNAME'], $record['IDCODE'], dict($this->val_types[$record['VAL_TYPE']]), dict($this->read_only[$record['READ_ONLY']]),
                    dict($this->yes_no[$record['SEARCH_KEY']]), dict($this->yes_no[$record['CLXFIELD_FORMAT']]), $record['PRMT_NAME'], $record['VAL_FORMULA'], $record['VAL_ELEMENT'], $record['VAL_MAP_FIELD']));
                $i++;
            }
            $buttons = '';
            $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_DISPLAY'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            if ($this->getAccess()->canModify()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            }
            if ($this->getAccess()->canDelete()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
            }
            if ($this->getAccess()->canDisplay()) {
                $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE_SOMETHING', dict('GEN_LBL_MAP_FIELD')), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
            }
            $form->addContents($page->footers($table, $buttons));
            return buildPanelInterface(dict('TOOL_SKMF_TITLE_LIST'), 'EB_SOCKET_MAPPINGS_' . $map_code, $form->source(), CLX_NUM_MINUS_1);
        } else {
            return CLX_CHAR_EMPTY_STRING;
        }
    }

    function editForm($ac, $idlist, $record, $msg) {
        $this->editform['TITLE'] = (UserRequest::$request['ac'] === 'MODIFY') ? 'TOOL_' . $this->code . '_TITLE_MODIFY' : 'TOOL_' . $this->code . '_TITLE_CREATE';
        $form = new clx_form($this->code, $this->editform);
        return $form->editForm($ac, $idlist, $record, $msg);
    }

    function viewFormFill($record) {
        $contents = '';
        addHistory('mapf_code', $record['SKMF_idcode']);
        //Criterias
        //Translations
        $SKMT = &getTool('SKMT');
        $contents .= $SKMT->makepanel($record['SKMF_idcode']);
        return $contents;
    }

    function searchForm() {
        $contents = '';
        $msg = array();
        // Search Form
        $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF']);
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'SEARCH');
        $form->addArgument('confirm', '1');
        $form->addArgument(CLX_PROP_TARGET, UserRequest::$request[CLX_PROP_TARGET]);
        if (!empty(UserRequest::$request['msg_code'])) {
            $form->addArgument('msg_code', UserRequest::$request['msg_code']);
        }
        if (!empty(UserRequest::$request['map_code'])) {
            UserRequest::$request['msg_code'] = ClxCommon::$db->getField('CLX_SK_MAPPINGS', 'MSG_CODE', 'IDCODE = ' . singleQuote(UserRequest::$request['map_code']));
            $form->addArgument('msg_code', UserRequest::$request['msg_code']);
        }
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_SKMF_TITLE_SEARCH'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addField($msg, dict('GEN_LBL_IDCODE') . ':', 'SKMF_idcode', (array_key_exists('SKMF_idcode', UserRequest::$post)) ? UserRequest::$post['SKMF_idcode'] : '', CLX_NUM_16, CLX_NUM_16);
        $table->addField($msg, dict('GEN_LBL_TABLECODE') . ':', 'SKMF_tablecode', (array_key_exists('SKMF_element_code', UserRequest::$post)) ? UserRequest::$post['SKMF_tablecode'] : '', CLX_NUM_32, CLX_NUM_64);
        $table->addField($msg, dict('GEN_LBL_FIELDNAME') . ':', 'SKMF_fieldname', (array_key_exists('SKMF_element_code', UserRequest::$post)) ? UserRequest::$post['SKMF_fieldname'] : '', CLX_NUM_32, CLX_NUM_64);
        $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_SEARCH'), array('action' => 'SEARCH', 'form' => $form->getProp(CLX_PROP_ID)))->source();
        $c = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $contents .= $form->source();
        // Search Procedure
        if (isset(UserRequest::$post['confirm'])) {
            $table = new htmlTable(CLX_WIDTH_THREE);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $criteria = '';
            $comma = '';
            if (UserRequest::$post['SKMF_idcode'] <> '') {
                $criteria .= $comma . 'UPPER(IDCODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['SKMF_idcode']) . '%');
                $comma = ' AND ';
            }
            if (UserRequest::$post['SKMF_tablecode'] <> '') {
                $criteria .= $comma . 'UPPER(TABLECODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['SKMF_tablecode']) . '%');
                $comma = ' AND ';
            }
            if (UserRequest::$post['SKMF_fieldname'] <> '') {
                $criteria .= $comma . 'UPPER(FIELDNAME) LIKE ' . singleQuote(uppercase(UserRequest::$post['SKMF_fieldname']) . '%');
                $comma = ' AND ';
            }
            if (UserRequest::$post['msg_code'] <> '') {
                $criteria .= $comma . 'MSG_CODE = ' . singleQuote(UserRequest::$post['msg_code']);
                $comma = ' AND ';
            }
            $qty = ClxCommon::$db->oneExistsRecords($this->tablename, $criteria);
            if ($qty == CLX_NUM_ZERO) {
                $table->addCell(dict('TOOL_GEN_ERR_NOMATCH'), array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_11));
            } else {
                $table->addCell(dict('TOOL_GEN_MSG_FOUNDRECORDS'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_11));
                $records = ClxCommon::$db->getRecords($this->tablename, $criteria . ' ORDER BY MAP_CODE, ID ASC');
                $i = CLX_INIT_ZERO;
                while (($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE))) {
                    $js = 'javascript:setLookupValue(' . quote(UserRequest::$request[CLX_PROP_TARGET]) . ', ' . quote($record['IDCODE']) . ');';
                    $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array('<page t=map_fields></page><a href='. $js . '>' . $record['IDCODE'] . '</a>', $record['MAP_CODE'] . ': ' . $record['TABLECODE'] . '.' . $record['FIELDNAME'], dict($this->val_types[$record['VAL_TYPE']])));
                    $i++;
                }
				ClxCommon::$db->freeResult( $records);
            }
            $contents .= $table->source();
        }
        return $contents;
    }
    function checkForm(&$msg) {
        $msg = array();
        if (UserRequest::$post['SKMF_val_type'] <> 'IGNR') {
			if  (ClxCommon::$db->oneExistsRecords('CLX_DB_TABLEDFIELDS', 'TABLECODE = ' . singleQuote(UserRequest::$post['SKMF_tablecode']) . '  AND CONCAT(FIELDNAME,'.singlequote('_WRK').') = ' . singleQuote(UserRequest::$post['SKMF_fieldname']))==0)
				parent::checkForm($msg);
		}
        if (UserRequest::$post['SKMF_val_type'] === 'FILD') {
            ;
            if (ClxCommon::$db->oneExistsRecords('CLX_DB_QUERIES', 'IDCODE = ' . singleQuote(UserRequest::$post['SKMF_querycode'])) == CLX_NUM_ZERO) {
                $msg['SKMF_querycode'] = dict('GEN_LBL_FIELDREQUIREDORNOTVALID');
            }
            if (ClxCommon::$db->oneExistsRecords('CLX_DB_QUERY_TABLES', 'QUERYCODE = ' . singleQuote(UserRequest::$post['SKMF_querycode']) . ' AND TABLECODE = ' . singleQuote(UserRequest::$post['SKMF_tablecode'])) == CLX_NUM_ZERO) {
                $msg['SKMF_tablecode'] = dict('GEN_LBL_FIELDREQUIREDORNOTVALID');
            }
            $qty = ClxCommon::$db->countRecords('CLX_DB_TABLEFIELDS', 'TABLECODE = ' . singleQuote(UserRequest::$post['SKMF_tablecode']) . '  AND FIELDNAME = ' . singleQuote(UserRequest::$post['SKMF_fieldname']));
            $qty += ClxCommon::$db->countRecords('CLX_DB_TABLEDFIELDS', 'TABLECODE = ' . singleQuote(UserRequest::$post['SKMF_tablecode']) . '  AND CONCAT(FIELDNAME,'.singlequote('_WRK').') = ' . singleQuote(UserRequest::$post['SKMF_fieldname']));
            if ($qty == CLX_NUM_ZERO) {
                $msg['SKMF_fieldname'] = dict('GEN_LBL_FIELDREQUIREDORNOTVALID');
            }
        }
        return count($msg) == CLX_NUM_ZERO;
    }

    function confirmDeleteFill(&$table, $record) {
        $table->addData(dict('GEN_LBL_FIELDNAME') . ':', $record['SKMF_tablecode'] . '.' . $record['SKMF_fieldname']);
        $table->addData(dict('GEN_LBL_IDCODE') . ':', $record['SKMF_idcode']);
        $table->addData(dict('GEN_LBL_ELEMENT_CODE') . ':', $record['SKMF_val_element']);
    }

    function loadToolRecord($recordid) {
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID= ' . $recordid);
        $record = array();
        $record['SKMF_id'] = $recordid;
        $record['SKMF_idcode'] = $values['IDCODE'];
        $record['SKMF_map_code'] = $values['MAP_CODE'];
        $record['SKMF_val_type'] = $values['VAL_TYPE'];
        $record['SKMF_querycode'] = $values['QUERYCODE'];
        $record['SKMF_tablecode'] = $values['TABLECODE'];
        $record['SKMF_fieldname'] = $values['FIELDNAME'];
        $record['SKMF_prmt_name'] = $values['PRMT_NAME'];
        $record['SKMF_clxfield_format'] = $values['CLXFIELD_FORMAT'];
        $record['SKMF_search_key'] = $values['SEARCH_KEY'];
        $record['SKMF_val_formula'] = $values['VAL_FORMULA'];
        $record['SKMF_val_constant'] = $values['VAL_CONSTANT'];
        $record['SKMF_val_element'] = $values['VAL_ELEMENT'];
        $record['SKMF_val_map_field'] = $values['VAL_MAP_FIELD'];
        $record['SKMF_read_only'] = $values['READ_ONLY'];
        return $record;
    }

    function defaultRecord() {
        $callingpage = peekHistory();
        $record = array();
        $record['SKMF_id'] = CLX_INIT_ZERO;
        $record['SKMF_idcode'] = 'MAPF' . ClxCommon::$db->getOne('SELECT MAX(ID)+1  FROM ' . $this->tablename);
        $record['SKMF_map_code'] = $callingpage['map_code'];
        $record['SKMF_val_type'] = 'FILD';
        $record['SKMF_tablecode'] = '';
        $record['SKMF_querycode'] = '';
        $record['SKMF_fieldname'] = '';
        $record['SKMF_prmt_name'] = '';
        $record['SKMF_val_formula'] = '';
        $record['SKMF_val_constant'] = '';
        $record['SKMF_val_element'] = '';
        $record['SKMF_val_map_field'] = '';
        $record['SKMF_clxfield_format'] = '0';
        $record['SKMF_search_key'] = '0';
        $record['SKMF_read_only'] = '0';
        return $record;
    }

    function createRecord_() {
        $record = array();
        $record['IDCODE'] = UserRequest::$post['SKMF_idcode'];
        $record['MAP_CODE'] = UserRequest::$post['SKMF_map_code'];
        $record['VAL_TYPE'] = UserRequest::$post['SKMF_val_type'];
        $record['QUERYCODE'] = UserRequest::$post['SKMF_querycode'];
        $record['TABLECODE'] = UserRequest::$post['SKMF_tablecode'];
        $record['FIELDNAME'] = UserRequest::$post['SKMF_fieldname'];
        $record['PRMT_NAME'] = UserRequest::$post['SKMF_prmt_name'];
        $record['CLXFIELD_FORMAT'] = UserRequest::$post['SKMF_clxfield_format'];
        $record['SEARCH_KEY'] = UserRequest::$post['SKMF_search_key'];
        $record['VAL_FORMULA'] = UserRequest::$post['SKMF_val_formula'];
        $record['VAL_CONSTANT'] = UserRequest::$post['SKMF_val_constant'];
        $record['VAL_ELEMENT'] = UserRequest::$post['SKMF_val_element'];
        $record['VAL_MAP_FIELD'] = UserRequest::$post['SKMF_val_map_field'];
        $record['READ_ONLY'] = UserRequest::$post['SKMF_read_only'];
        $recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        $this->versionIncrease('ID', UserRequest::$post['SKMF_id']);
        return $recordid;
    }

    function saveRecord() {
        $record = array();
        $record['VAL_TYPE'] = UserRequest::$post['SKMF_val_type'];
        $record['QUERYCODE'] = UserRequest::$post['SKMF_querycode'];
        $record['TABLECODE'] = UserRequest::$post['SKMF_tablecode'];
        $record['FIELDNAME'] = UserRequest::$post['SKMF_fieldname'];
        $record['PRMT_NAME'] = UserRequest::$post['SKMF_prmt_name'];
        $record['CLXFIELD_FORMAT'] = UserRequest::$post['SKMF_clxfield_format'];
        $record['SEARCH_KEY'] = UserRequest::$post['SKMF_search_key'];
        $record['VAL_FORMULA'] = UserRequest::$post['SKMF_val_formula'];
        $record['VAL_CONSTANT'] = UserRequest::$post['SKMF_val_constant'];
        $record['READ_ONLY'] = UserRequest::$post['SKMF_read_only'];
        $record['VAL_ELEMENT'] = UserRequest::$post['SKMF_val_element'];
        $record['VAL_MAP_FIELD'] = UserRequest::$post['SKMF_val_map_field'];
        ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post['SKMF_id']);
        $this->versionIncrease('ID', UserRequest::$post['SKMF_id']);
    }

    function deleteRecordSk($id) {
        $record = ClxCommon::$db->getFields($this->tablename, 'IDCODE, MAP_CODE', 'ID=' . $id);
        //Deleting Translations and criterias
        $SKMT = getTool('SKMT');
        ClxCommon::$db->deleteRecords($SKMT->tablename, 'MAPF_CODE=' . singleQuote($record['IDCODE']));
        //ClxCommon::$db->deleteRecords($SKMC->tablename, 'MAPF_CODE='. singleQuote($record['IDCODE']) );
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
        $SKMP = &getTool('SKMP');
        $SKMP->versionIncrease('IDCODE', $record['MAP_CODE']);
    }

    function versionIncrease($fieldname, $fieldvalue) {
        $mapcode = ClxCommon::$db->getField($this->tablename, 'MAP_CODE', $fieldname . '=' . singleQuote($fieldvalue));
        $SKMP = &getTool('SKMP');
        $SKMP->versionIncrease('IDCODE', $mapcode);
    }

}
