<?php

/**
 * Services Manager
 * Webservices Services Manager
 *
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2019-01-22 15:45:22 -0400 (ma., 22 ene. 2019) $
 * @version      $Rev: 10496 $
 *
 * CHANGE LOG
 *  Included label
 */
 $GLOBALS['DEBUG_SK_SERVICE']=1;
class sk_services extends clx_tool {

    private $import_types;
    private $importForm;
    public $criterias = array(); //Stores mapping criterias
    public $formulas = array(); //Stores formulas during execution
    public $search_key = array(); //Stores search keys
    public $read_only = array(); //Stores search keys
    public $read_only_exclude = array(); //Read only exclude
    public $parent_record = array(); //Stores parent record id
    public $req_params = array(); //Request Parameters
    private $req_params_raw = array(); //Request Parameters as request
    private $req_params_prmts = array(); //Request Parameters Formated
    private $service_code = false; //Stores service code
    private $last_crits = ''; //Stores last criteria for delete on do record
    private $method = false; //Stores service method
    private $service_trace = true;   //By setting to true, socket will keep track of the resp/req xml
    private $service_exceptions = false;  //By setting to true, socket will keep track of the resp/req exceptions
    public $elements = array(); //Message elements
    public $mappings = array(); //Message Mappings
    public $tables = array(); //Set of tablename
    public $connector = false;
    private $encoding = 'ISO-8815-1';
    private $request_code = ''; //Stores request message code
    private $response_code = '';    //Stores response message code
    private $log_id = CLX_INIT_ZERO;
    public $skmt = null; //holds translation object
    private $a_last_op_result;
    private $b_test_mode = false;
    public $ele_types;
    private $b_assing_ele_type_if_no_defval = false;
    private $multichild_count = CLX_INIT_ZERO;
    public $dict = array(); //some labels used many times
    //New properties
    private $tmp_tbl_prefix = 'XTMP';
    private $tmp_tbl_type = 'TEMP';
    private $xml_structure = array();
    private $counter = array();
    private $table_counter = CLX_INIT_ZERO;
    private $struct_parent_xpath = '';
    public $result_query = '';
    private $msg_logs = array(); //Output message
    //Action status.
    private $action_message_code = CLX_INIT_ZERO; //records last action status.
    private $action_message = ''; //records last action messages
    private $action_message_recid = array();
    private $fields_definitions = array();

    /**
     * Contructor
     * @return void
     */
    function __construct() {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $this->code = 'SKSV';
        $this->name = 'Services Manager';
        $this->system = 'Sockets';
        $this->version = '5.5.0.0';

        $this->has_access = true;
        $this->has_package = true;

        $this->tablename = 'CLX_SK_SERVICES';
        $this->record_name_singular = 'GEN_LBL_SERVICE';
        $this->record_name_plural = 'GEN_LBL_SERVICES';
        $this->primary_key = array('IDCODE');
        $this->primary_field = 'IDCODE';
        $this->secondary_field = 'IDNAME';

        $this->dict = array('GEN_LBL_OK' => dict('GEN_LBL_OK'),
            'GEN_LBL_FAIL' => dict('GEN_LBL_FAIL'),
            'GEN_LBL_STATUS' => dict('GEN_LBL_STATUS'),
            'GEN_LBL_ACTION' => dict('GEN_LBL_ACTION'));
        $this->service_types = array('CLNT' => 'GEN_LBL_CLIENT',
            'SRVR' => 'GEN_LBL_SERVER');
        $this->access_types = array('OPEN' => 'GEN_LBL_PUBLIC',
            'SUSR' => 'GEN_LBL_SYS_USERNAME',
            'SUSF' => 'GEN_LBL_SYS_FIXUSER',
            'CUSR' => 'GEN_LBL_CUSTOM_USER');
        $this->serv_status = array('0' => 'GEN_LBL_INACTIVE',
            '1' => 'GEN_LBL_ACTIVE');
        $this->encodings = array('ISO-8859-1' => 'GEN_LBL_ISO_8859_1',
            'utf-8' => 'GEN_LBL_UTF_8');
        $this->SKFE = &getTool('SKFE');
		$this->editform = array(
            CLX_CLASS_TITLE => 'TOOL_SKSV_TITLE_CREATE',
            'panels' => array(
                array(
                    'type' => 'normal',
                    'entries' => array(
                        array(
                            'label' => 'GEN_LBL_CODE',
                            'fields' => array(
                                array('name' => 'idcode', 'type' => 'string', 'default' => '', 'size' => '16', 'displaysize' => '16', 'dontmodify' => '1',
                                    'validations' => array(
                                        array('type' => 'sqlobject', 'required' => '1'),
                                        array('type' => 'unique', 'fieldname' => 'idcode', 'tablename' => $this->tablename)
                                    )
                                )
                            )
                        ),
                        array(
                            'label' => 'GEN_LBL_NAME',
                            'fields' => array(
                                array('name' => 'idname', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '48',
                                    'validations' => array(
                                        array('type' => 'string', 'required' => '1')
                                    )
                                )
                            )
                        ),
                        array(
                            'label' => 'GEN_LBL_VERSION',
                            'fields' => array(
                                array('name' => 'version', 'type' => 'string', 'default' => '1.0.0', 'size' => '32', 'displaysize' => '16',
                                    'validations' => array(
                                        array('type' => 'string', 'required' => '1')
                                    )
                                )
                            )
                        ),
                        array(
                            'label' => 'GEN_LBL_DESCRIPTION',
                            'fields' => array(
                                array('name' => 'description', 'type' => 'text', 'default' => '', 'cols' => '48', 'rows' => '4')
                            )
                        ),
                        array(
                            'label' => 'GEN_LBL_MODULECODE',
                            'fields' => array(
                                array('name' => 'modulecode', 'type' => 'lookup', 'default' => '', 'tool' => 'DBMO',
                                    'validations' => array(
                                        array('type' => 'sqlobject', 'required' => '1'),
                                        array('type' => 'lookup', 'fieldname' => 'IDCODE', 'tablename' => 'CLX_DB_MODULES')
                                    )
                                )
                            )
                        ),
                        array(
                            'label' => 'GEN_LBL_SERV_STATUS',
                            'fields' => array(
                                array('name' => 'serv_status', 'type' => CLX_CLASS_LIST, 'default' => '1',
                                    'options' => $this->serv_status
                                )
                            )
                        ),
                        array(
                            'label' => 'GEN_LBL_SERVICE_TYPE',
                            'fields' => array(
                                array('name' => 'service_type', 'type' => CLX_CLASS_LIST, 'default' => 'CLNT',
                                    'options' => $this->service_types
                                )
                            )
                        ),
                        array(
                            'label' => 'GEN_LBL_SERV_ENCODING',
                            'fields' => array(
                                array('name' => 'serv_encoding', 'type' => CLX_CLASS_LIST, 'default' => 'ISO-8859-1',
                                    'options' => $this->encodings
                                )
                            )
                        ),
                        array(
                            'label' => 'GEN_LBL_CONNECTOR',
                            'fields' => array(
                                array('name' => 'connector', 'type' => 'lookup', 'default' => '', 'tool' => 'SKCO',
                                    'validations' => array(
                                        array('type' => 'sqlobject', 'required' => '1'),
                                        array('type' => 'lookup', 'fieldname' => 'idcode', 'tablename' => 'CLX_SK_CONNECTORS')
                                    )
                                )
                            )
                        ),
                        array(
                            'label' => 'GEN_LBL_REQUEST_CODE',
                            'fields' => array(
                                array('name' => 'request_code', 'type' => 'lookup', 'default' => '', 'tool' => 'SKMS',
                                    'validations' => array(
                                        array('type' => 'sqlobject', 'required' => '1'),
                                        array('type' => 'lookup', 'fieldname' => 'IDCODE', 'tablename' => 'CLX_SK_MESSAGES')
                                    )
                                )
                            )
                        ),
                        array(
                            'label' => 'GEN_LBL_RESPONSE_CODE',
                            'fields' => array(
                                array('name' => 'response_code', 'type' => 'lookup', 'default' => '', 'tool' => 'SKMS',
                                    'validations' => array(
                                        array('type' => 'sqlobject', 'required' => '1'),
                                        array('type' => 'lookup', 'fieldname' => 'IDCODE', 'tablename' => 'CLX_SK_MESSAGES')
                                    )
                                )
                            )
                        ),
                        array(
                            'label' => 'GEN_LBL_CODELIB',
                            'caption' => 'GEN_LBL_ALTERNATE_CLASS',
                            'fields' => array(
                                array('name' => 'opt_codelib', 'type' => 'lookup', 'default' => '', 'tool' => 'CODE',
                                    'validations' => array(
                                        array('type' => 'lookup', 'fieldname' => 'IDCODE', 'tablename' => 'CLX_CODELIB')
                                    )
                                )
                            )
                        ),
                        array(
                            'label' => 'GEN_LBL_CLASSNAME',
                            'fields' => array(
                                array('name' => 'opt_classname', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '48',
                                    'validations' => array(
                                        array('type' => 'sqlobject', 'required' => '0')
                                    )
                                )
                            )
                        ),
                        array(
                            'label' => 'GEN_LBL_LIBRARIES_STATUS',
                            'fields' => array(
                                array('name' => 'library_status', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '64', 'readonly' => true)
                            )
                        ),
                        array(
                            'label' => 'GEN_LBL_ACCESS_TYPE',
                            'fields' => array(
                                array('name' => 'access_type', 'type' => 'dynamic',
                                    'panels' => $this->access_types
                                )
                            )
                        )
                    )
                ),
                array(
                    'type' => 'dynamic',
                    'code' => 'OPEN',
                ),
                array(
                    'caption' => 'GEN_LBL_SYS_USERNAME',
                    'type' => 'dynamic',
                    'code' => 'SUSR',
                    CLX_PROP_ID => 'SUSR',
                    'entries' => array(
                        array('label' => 'GEN_LBL_SYSTEM_USER',
                            'fields' => array(
                                array('name' => 'sys_username', 'type' => 'lookup', 'default' => '', 'tool' => 'ACUS',
                                    'validations' => array(
                                        array('type' => 'sqlobject', 'required' => '0'),
                                        array('type' => 'lookup', 'fieldname' => 'username', 'tablename' => 'CLX_AC_USERS')
                                    )
                                )
                            )
                        )
                    )
                ),
                array(
                    'caption' => 'GEN_LBL_SYS_USERNAME',
                    'type' => 'dynamic',
                    'code' => 'SUSF',
                    CLX_PROP_ID => 'SUSF',
                    'entries' => array(
                        array('label' => 'GEN_LBL_SYSTEM_USER',
                            'fields' => array(
                                array('name' => 'sys_username', 'type' => 'lookup', 'default' => '', 'tool' => 'ACUS',
                                    'validations' => array(
                                        array('type' => 'sqlobject', 'required' => '0'),
                                        array('type' => 'lookup', 'fieldname' => 'username', 'tablename' => 'CLX_AC_USERS')
                                    )
                                )
                            )
                        )
                    )
                ),
                array(
                    'caption' => 'GEN_LBL_CUSTOM_USER',
                    'type' => 'dynamic',
                    'code' => 'CUSR',
                    CLX_PROP_ID => 'CUSR',
                    'entries' => array(
                        array('label' => 'GEN_LBL_OTHER_USERNAME',
                            'fields' => array(
                                array('name' => 'other_username', 'type' => 'string', 'default' => '', 'size' => CLX_NUM_HUNDRED, 'displaysize' => '30',
                                    'validations' => array(
                                        array('type' => 'string', 'required' => '0')
                                    )
                                )
                            )
                        ),
                        array(
                            'label' => 'GEN_LBL_OTHER_PASSWORD',
                            'fields' => array(
                                array('name' => 'other_password', 'type' => 'password', 'default' => '', 'size' => CLX_NUM_HUNDRED, 'displaysize' => '30',
                                    'validations' => array(
                                        array('type' => 'string', 'required' => '0')
                                    )
                                )
                            )
                        )
                    )
                )
            )
        );
        $this->viewform = $this->editform;
    }

    function install() {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $UIMI = getTool('UIMI');
        $UIMI->add($this->code, 'MENU_TOOLS:MENU_SERVCONNECTOR:MENU_SKSERVICES', 'TOOL', $this->code, 'ac=LIST');
    }

    function toolTableStructure() {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['IDCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['IDNAME'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '');
        $fields['VERSION'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
        $fields['VERSION_COUNTER'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['MDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
        $fields['USERNAME'] = array('type' => 'varchar(30)', 'null' => 'NO', 'properties' => '');
        $fields['DESCRIPTION'] = array('type' => 'mediumtext', 'properties' => '');
        $fields['SERVICE_TYPE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $fields['SERV_ENCODING'] = array('type' => 'varchar(20)', 'null' => 'NO', 'properties' => '');
        $fields['CONNECTOR'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['REQUEST_CODE'] = array('type' => 'varchar(16)', 'null' => 'YES', 'properties' => '');
        $fields['RESPONSE_CODE'] = array('type' => 'varchar(16)', 'null' => 'YES', 'properties' => '');
        $fields['OPT_CODELIB'] = array('type' => 'varchar(11)', 'null' => 'YES', 'properties' => '');
        $fields['OPT_CLASSNAME'] = array('type' => 'varchar(64)', 'null' => 'YES', 'properties' => '');
        $fields['SERV_STATUS'] = array('type' => 'int(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['ACCESS_TYPE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['SYS_USERNAME'] = array('type' => 'varchar(100)', 'null' => 'YES', 'properties' => '');
        $fields['OTHER_USERNAME'] = array('type' => 'varchar(100)', 'null' => 'YES', 'properties' => '');
        $fields['OTHER_PASSWORD'] = array('type' => 'varchar(100)', 'null' => 'YES', 'properties' => '');
        $fields['MODULECODE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'IDCODE');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'IDNAME');
        $indexes[$ipf . '04'] = array('index' => 'MUL', 'fieldname' => 'USERNAME');
        $indexes[$ipf . '05'] = array('index' => 'MUL', 'fieldname' => 'REQUEST_CODE');
        $indexes[$ipf . '06'] = array('index' => 'MUL', 'fieldname' => 'RESPONSE_CODE');
        $indexes[$ipf . '07'] = array('index' => 'MUL', 'fieldname' => 'MODULECODE');
        return array('idcode' => $this->code,
            'idname' => $this->name,
            'name' => $this->tablename,
            'type' => 'InnoDB',
            'fields' => $fields,
            'indexes' => $indexes);
    }

    function getImport_Types() {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        return $this->import_types;
    }

    function SetImport_Types($import) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $this->import_types = $import;
    }

    function getImport_Form() {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        return $this->importForm;
    }

    function SetImport_Form($form) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $this->importForm = $form;
    }

    function getMultiChild() {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        return $this->multichild_count;
    }

    function SetMultiChild($count) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $this->multichild_count = $count;
    }

    function getLastCrits() {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        return $this->last_crits;
    }

    function SetLastCrits($count) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $this->last_crits = $last_crits;
    }

    function action($ac, $idlist) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $contents = '';
        if ($this->getAccess()->canRead()) {
			UserRequest::$request['ac']=$ac;
			switch ($ac) {
                case 'CHECK':
                    $this->b_test_mode = true;
                    $this->set_ele_types();
                    $contents = $this->check();
                    $this->b_test_mode = false;
                    break;
                default:
                    $contents = parent::action($ac, $idlist);
                    break;
            }
        } else {
            $contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [SK_SERVICES-CAN_READ][' . $ac . '] ' . $this->getCode(false));
        }
        return $contents;
    }

    //-- P A C K A G E S
    function pack($record) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $o = $this->packRecord($record);
        $objs = new XMLObject($this->code . '_OBJECTS');
        $this->packsub($objs, 'SKMS', 'SELECT * FROM CLX_SK_MESSAGES WHERE IDCODE IN (' . singleQuote($record['REQUEST_CODE']) . ',' . singleQuote($record['RESPONSE_CODE']) . ')');
        $this->packsub($objs, 'SKCO', 'SELECT * FROM CLX_SK_CONNECTORS WHERE IDCODE=' . singleQuote($record['CONNECTOR']));
        $o->addObject($objs);
        return $o;
    }

    function unpack($parameters) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $parameters = array_values(array_merge(array('package' => null), $parameters));
        list($package) = $parameters;
        $record = $this->unpackRecord($package);
        $exists = (ClxCommon::$db->countRecords($this->tablename, 'UPPER(IDCODE)=' . singleQuote(uppercase($record['IDCODE']))) > CLX_NUM_ZERO);
        if ($exists === true) {
            ClxCommon::$db->deleteRecords($this->tablename, 'UPPER(IDCODE)=' . singleQuote(uppercase($record['IDCODE'])));
        }
        $id = ClxCommon::$db->createRecord($this->tablename, $record, false);
        if ($package->hasSubObject($this->code . '_OBJECTS')) {
            $objs = $package->getObjectXml($this->code . '_OBJECTS');
            foreach ($objs->objects as $o) {
                $toolcode = $o->tag;
                $tool = getTool($toolcode);
                $tool->unpack(array('package' => $o, 'id' => $id));
            }
        }
    }

    function makelist($listingcode = null) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
         //$t = time('U'); genera un warning
        $t = time();
        $to = $this->code;
        $here = 'tool.php?to=' . $to . '&t=' . $t;
        clearHistory();
        pushHistory($this->code, 'LIST', array());
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->setProp(CLX_PROP_ID, 'SKSVList');
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'NOT_DEFINED');
        $selectclause = '*';
        $fromclause = $this->tablename;
        $whereclause = '';
        $sortclause = '';
        $page = new xPaging();
        $page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
        $table = new htmlTable(CLX_WIDTH_12);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_SKSV_TITLE_LIST'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_12));
        $page->header($table);
        $table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_CODE'), dict('GEN_LBL_NAME'), dict('GEN_LBL_MODULECODE'), dict('GEN_LBL_SERV_STATUS'), dict('GEN_LBL_SERVICE_TYPE'), dict('GEN_LBL_REQUEST_CODE'), dict('GEN_LBL_RESPONSE_CODE'), dict('GEN_LBL_VERSION'), dict('GEN_LBL_DESCRIPTION'), dict('GEN_LBL_ACCESS_TYPE'), dict('GEN_LBL_SERV_ENCODING')));
        $i = CLX_INIT_ZERO;
        while ($record = $page->nextRecord()) {
            $recordid = $record['ID'];
            $select = new htmlCheckbox('selector_' . $recordid, false);
            $select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
            $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
            $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array($record['IDCODE'], $record['IDNAME'], $record['MODULECODE'], dict($this->serv_status[$record['SERV_STATUS']]), dict($this->service_types[$record['SERVICE_TYPE']]), $record['REQUEST_CODE'], $record['RESPONSE_CODE'], $record['VERSION'] . '-' . $record['VERSION_COUNTER'], xFormat::text($record['DESCRIPTION']), dict($this->access_types[$record['ACCESS_TYPE']]), $record['SERV_ENCODING']));
            $i++;
        }
        $buttons = '';
        $buttons .= htmlButton::getButton('submit', dict('GEN_LBL_DISPLAY'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        if ($this->getAccess()->canModify()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
		if ($this->getAccess()->canDisplay()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DUPLICATE'), array('action' => 'DUPLICATE', 'form' =>  $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ONE'))->source();
        }
        if ($this->getAccess()->canDelete()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
        }
        if ($this->getAccess()->canDisplay()) {
            $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE_SOMETHING', dict('GEN_LBL_SKSV_CREATEMSG')), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        }
        $b = new htmlFormSubmit(dict('GEN_LBL_CHECK'), 'CHECK', $form->getProp(CLX_PROP_ID));
        $b->setProp(CLX_PROP_ID, 'ONE');
        $buttons .= $b->source();
        $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_FILTER'), array('action' => 'FILTER', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
        $form->addContents($page->footers($table, $buttons));
        return $form->source();
    }

    function checkForm(&$msg) { IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $result = parent::checkForm($msg);
        return $result;
    }

    function searchForm() { IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $msg = array();
        $contents = '';
        // Search Form
        $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF']);
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', 'SEARCH');
        $form->addArgument('confirm', '1');
        $form->addArgument(CLX_PROP_TARGET, UserRequest::$request[CLX_PROP_TARGET]);
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_SKSV_TITLE_SEARCH'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $table->addField($msg, dict('GEN_LBL_CODE') . ':', 'SKSV_idcode', (array_key_exists('SKSV_idcode', UserRequest::$post)) ? UserRequest::$post['SKSV_idcode'] : '', CLX_NUM_16, CLX_NUM_16);
        $table->addField($msg, dict('GEN_LBL_NAME') . ':', 'SKSV_idname', (array_key_exists('SKSV_idname', UserRequest::$post)) ? UserRequest::$post['SKSV_idname'] : '', CLX_NUM_32, CLX_NUM_64);
        $table->addField($msg, dict('GEN_LBL_MODULECODE') . ':', 'SKSV_modulecode', (array_key_exists('SKSV_modulecode', UserRequest::$post)) ? UserRequest::$post['SKSV_modulecode'] : '', CLX_NUM_FOUR, CLX_NUM_FOUR);
        $buttons = htmlButton::getButton('submit', dict('GEN_LBL_SEARCH'), array('action' => 'SEARCH', 'form' => $form->getProp(CLX_PROP_ID)))->source();
        $c = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $contents .= $form->source();
        // Search Procedure
        if (isset(UserRequest::$post['confirm'])) { IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
            $table = new htmlTable(CLX_WIDTH_TWO);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $criteria = '';
            if (UserRequest::$post['SKSV_idcode'] <> '') {
                $criteria .= 'UPPER(IDCODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['SKSV_idcode']) . '%');
            }
            if (UserRequest::$post['SKSV_idname'] <> '') {
                $criteria .= 'UPPER(IDNAME) LIKE ' . singleQuote(uppercase(clx_change_especial_char_html (UserRequest::$post['SKSV_idname'])) . '%');
            }
            if (UserRequest::$post['SKSV_modulecode'] <> '') {
                $criteria .= 'UPPER(MODULECODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['SKSV_modulecode']) . '%');
            }
            $qty = ClxCommon::$db->oneExistsRecords($this->tablename, $criteria);IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' YY SQL '.$this->tablename. ' '. $criteria . chr(13).chr(10)); fclose($kk);}       
            if ($qty == CLX_NUM_ZERO) {
                $table->addCell(dict('TOOL_GEN_ERR_NOMATCH'), array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
            } else {
                $table->addCell(dict('TOOL_GEN_MSG_FOUNDRECORDS'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
                $records = ClxCommon::$db->getRecords($this->tablename, $criteria);
				$qty = ClxCommon::$db->oneExistsRecords($this->tablename, $criteria);IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' XX SQL '.$this->tablename. ' '. $criteria . chr(13).chr(10)); fclose($kk);}       
                $i = CLX_INIT_ZERO;
                while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
                    $js = 'javascript:setLookupValue(' . quote(UserRequest::$request[CLX_PROP_TARGET]) . ', ' . quote($record['IDCODE']) . ');';
                    $table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array('<page t=sk_services></page><a href=' . singleQuote($js) . '>' . $record['IDCODE'] . '</a>', $record['IDNAME']));
                    $i++;
                }
				ClxCommon::$db->freeResult( $records);
            }
            $contents .= $table->source();
        }
        return $contents;
    }

    function confirmDeleteFill(&$table, $record) { IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $table->addData(dict('GEN_LBL_CODE') . ':', $record['SKSV_idcode']);
        $table->addData(dict('GEN_LBL_NAME') . ':', $record['SKSV_idname']);
    }

    function filterFormFill($msg, &$table) { IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        if (!array_key_exists('SKSV_idcode', UserRequest::$post))
            UserRequest::$post['SKSV_idcode'] = '';
        if (!array_key_exists('SKSV_idname', UserRequest::$post))
            UserRequest::$post['SKSV_idname'] = '';
        if (!array_key_exists('SKSV_modulecode', UserRequest::$post))
            UserRequest::$post['SKSV_modulecode'] = '';
        $table->addField($msg, dict('GEN_LBL_CODE'), 'SKSV_idcode', UserRequest::$post['SKSV_idcode'], CLX_NUM_16, CLX_NUM_16);
        $table->addField($msg, dict('GEN_LBL_NAME'), 'SKSV_idname', UserRequest::$post['SKSV_idname'], CLX_NUM_32, CLX_NUM_64);
        $table->addField($msg, dict('GEN_LBL_MODULECODE'), 'SKSV_modulecode', UserRequest::$post['SKSV_modulecode'], CLX_NUM_FOUR, CLX_NUM_FOUR);
        $sort = new HtmlSelect('SKSV_sort');
        $sort->addItem('', '', true);
        $sort->addItem(dict('GEN_LBL_CODE'), 'idcode', false);
        $sort->addItem(dict('GEN_LBL_NAME'), 'idname', false);
        $sort->addItem(dict('GEN_LBL_MODULECODE'), 'modulecode', false);
        $table->addData(dict('GEN_LBL_ORDERBY') . ':', $sort->source());
    }

    function setfilter() { IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $filter = '';
        $bool = '';
        if (!empty(UserRequest::$post['SKSV_idcode'])) {
            $filter .= $bool . ' UPPER(IDCODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['SKSV_idcode']) . '%');
            $bool = 'AND';
        }
        if (!empty(UserRequest::$post['SKSV_idname'])) {
            $filter .= $bool . ' UPPER(IDNAME) LIKE ' . singleQuote(uppercase(clx_change_especial_char_html (UserRequest::$post['SKSV_idname'])) . '%');
            $bool = 'AND';
        }
        if (!empty(UserRequest::$post['SKSV_modulecode'])) {
            $filter .= $bool . ' UPPER(MODULECODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['SKSV_modulecode']) . '%');
            $bool = 'AND';
        }
        $_SESSION['paging']['SKSVList']['sortby'] = UserRequest::$post['SKSV_sort'];
        $_SESSION['paging']['SKSVList']['criteria'] = $filter;
        $_SESSION['paging']['SKSVList']['startat'] = '0';
    }
	///////////////////////////////////////////////////
	///comentado 22/01/2019 para utilizar la clx_tool
	//////////////////////////////////////////////////
    /*function clearfilter() {
        $_SESSION['paging']['SKSVList']['criteria'] = '';
    }*/

    /**
     * View form
     */
    function viewFormFill($record) { IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        addHistory('service_code', $record['SKSV_idcode']);
        $contents = parent::viewFormFill($record);
        //not used at the moment
        return $contents;
    }

    function loadToolRecord($recordid) { IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $values = ClxCommon::$db->getRecord($this->tablename, 'ID= ' . $recordid);
        $d = xFormat::getNow('Y-m-d');
        $record = array();
        $record['SKSV_id'] = $recordid;
        $record['SKSV_idcode'] = $values['IDCODE'];
        $record['SKSV_idname'] = $values['IDNAME'];
        $record['SKSV_modulecode'] = $values['MODULECODE'];
        $record['SKSV_version'] = $values['VERSION'];
        $record['SKSV_version_counter'] = $values['VERSION_COUNTER'];
        $record['SKSV_cdate'] = $d;
        $record['SKSV_mdate'] = $d;
        $record['SKSV_serv_status'] = $values['SERV_STATUS'];
        $record['SKSV_username'] = $values['USERNAME'];
        $record['SKSV_description'] = $values['DESCRIPTION'];
        $record['SKSV_service_type'] = $values['SERVICE_TYPE'];
        $record['SKSV_connector'] = $values['CONNECTOR'];
        $record['SKSV_request_code'] = $values['REQUEST_CODE'];
        $record['SKSV_response_code'] = $values['RESPONSE_CODE'];
        $record['SKSV_access_type'] = $values['ACCESS_TYPE'];
        $record['SKSV_serv_encoding'] = $values['SERV_ENCODING'];
        $record['SKSV_sys_username'] = $values['SYS_USERNAME'];
        $record['SKSV_other_username'] = $values['OTHER_USERNAME'];
        $record['SKSV_other_password'] = $values['OTHER_PASSWORD'];
        $record['SKSV_opt_codelib'] = $values['OPT_CODELIB'];
        $record['SKSV_opt_classname'] = $values['OPT_CLASSNAME'];
        $record['SKSV_library_status'] = $this->libraryStatusMsg();
        return $record;
    }

    function saveRecord() { IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $record = array();
        $record['IDNAME'] = UserRequest::$post['SKSV_idname'];
        $record['VERSION'] = UserRequest::$post['SKSV_version'];
        $record['MDATE'] = xFormat::getNow('Y-m-d');
        $record['USERNAME'] = $_SESSION['user_record']['username'];
        $record['DESCRIPTION'] = UserRequest::$post['SKSV_description'];
        $record['SERVICE_TYPE'] = UserRequest::$post['SKSV_service_type'];
        $record['SERV_STATUS'] = UserRequest::$post['SKSV_serv_status'];
        $record['CONNECTOR'] = UserRequest::$post['SKSV_connector'];
        $record['REQUEST_CODE'] = UserRequest::$post['SKSV_request_code'];
        $record['SERV_ENCODING'] = UserRequest::$post['SKSV_serv_encoding'];
        $record['RESPONSE_CODE'] = UserRequest::$post['SKSV_response_code'];
        $record['OPT_CODELIB'] = UserRequest::$post['SKSV_opt_codelib'];
        $record['OPT_CLASSNAME'] = UserRequest::$post['SKSV_opt_classname'];
        $record['ACCESS_TYPE'] = UserRequest::$post['SKSV_access_type'];
        switch ($record['ACCESS_TYPE']) {
            case 'OPEN':
                $record['SYS_USERNAME'] = null;
                $record['OTHER_USERNAME'] = null;
                $record['OTHER_PASSWORD'] = null;
                break;
            case 'SUSR': case 'SUSF':
                $record['SYS_USERNAME'] = UserRequest::$post['SKSV_sys_username'];
                $record['OTHER_USERNAME'] = null;
                $record['OTHER_PASSWORD'] = null;
                break;
            case 'CUSR':
                $record['SYS_USERNAME'] = null;
                $record['OTHER_USERNAME'] = UserRequest::$post['SKSV_other_username'];
                $record['OTHER_PASSWORD'] = UserRequest::$post['SKSV_other_password'];
                break;
            default :
                break;
        }
        $record['MODULECODE'] = UserRequest::$post['SKSV_modulecode'];
        ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post['SKSV_id']);
        $this->versionIncrease('ID', UserRequest::$post['SKSV_id']);
    }

    function createRecord_() { IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $d = xFormat::getNow('Y-m-d');
        $record = array();
        $record['IDCODE'] = UserRequest::$post['SKSV_idcode'];
        $record['IDNAME'] = UserRequest::$post['SKSV_idname'];
        $record['VERSION'] = UserRequest::$post['SKSV_version'];
        $record['VERSION_COUNTER'] = '0';
        $record['CDATE'] = $d;
        $record['MDATE'] = $d;
        $record['USERNAME'] = $_SESSION['user_record']['username'];
        $record['DESCRIPTION'] = UserRequest::$post['SKSV_description'];
        $record['SERVICE_TYPE'] = UserRequest::$post['SKSV_service_type'];
        $record['SERV_STATUS'] = UserRequest::$post['SKSV_serv_status'];
        $record['CONNECTOR'] = UserRequest::$post['SKSV_connector'];
        $record['REQUEST_CODE'] = UserRequest::$post['SKSV_request_code'];
        $record['RESPONSE_CODE'] = UserRequest::$post['SKSV_response_code'];
        $record['SERV_ENCODING'] = UserRequest::$post['SKSV_serv_encoding'];
        $record['OPT_CODELIB'] = UserRequest::$post['SKSV_opt_codelib'];
        $record['OPT_CLASSNAME'] = UserRequest::$post['SKSV_opt_classname'];
        $record['ACCESS_TYPE'] = UserRequest::$post['SKSV_access_type'];
        switch ($record['ACCESS_TYPE']) {
            case 'OPEN':
                $record['SYS_USERNAME'] = null;
                $record['OTHER_USERNAME'] = null;
                $record['OTHER_PASSWORD'] = null;
                break;
            case 'SUSR':
                $record['SYS_USERNAME'] = UserRequest::$post['SKSV_sys_username'];
                $record['OTHER_USERNAME'] = null;
                $record['OTHER_PASSWORD'] = null;
                break;
            case 'CUSR':
                $record['SYS_USERNAME'] = null;
                $record['OTHER_USERNAME'] = UserRequest::$post['SKSV_other_username'];
                $record['OTHER_PASSWORD'] = UserRequest::$post['SKSV_other_password'];
                break;
            default:
                break;
        }
        $record['MODULECODE'] = UserRequest::$post['SKSV_modulecode'];
        $recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);
        $DBMO = &getTool('DBMO');
        $DBMO->versionIncrease('IDCODE', $record['MODULECODE']);
        return $recordid;
    }

    function deleteRecordSk($id) { IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $modulecode = ClxCommon::$db->getField($this->tablename, 'MODULECODE', 'id=' . singleQuote($id));
        ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
        $DBMO = &getTool('DBMO');
        $DBMO->versionIncrease('IDCODE', $modulecode);
    }

    function defaultRecord() { IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $record = array();
        $record['SKSV_id'] = CLX_INIT_ZERO;
        $record['SKSV_idcode'] = '';
        $record['SKSV_idname'] = '';
        $record['SKSV_version'] = '1.0.0';
        $record['SKSV_cdate'] = '';
        $record['SKSV_mdate'] = '';
        $record['SKSV_username'] = $_SESSION['user_record']['username'];
        $record['SKSV_description'] = '';
        $record['SKSV_service_type'] = 'CLNT';
        $record['SKSV_serv_status'] = '1';
        $record['SKSV_connector'] = '';
        $record['SKSV_request_code'] = '';
        $record['SKSV_response_code'] = '';
        $record['SKSV_access_type'] = 'OPEN';
        $record['SKSV_sys_username'] = '';
        $record['SKSV_serv_encoding'] = 'ISO-8859-1';
        $record['SKSV_other_username'] = '';
        $record['SKSV_other_password'] = '';
        $record['SKSV_opt_codelib'] = '';
        $record['SKSV_opt_classname'] = '';
        $record['SKSV_library_status'] = $this->libraryStatusMsg();
        return $record;
    }

    function versionIncrease($fieldname, $fieldvalue) { IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        parent::versionIncrease($fieldname, $fieldvalue);
        $modulecode = ClxCommon::$db->getField($this->tablename, 'MODULECODE', $fieldname . '=' . singleQuote($fieldvalue));
        $DBMO = &getTool('DBMO');
        $DBMO->versionIncrease('IDCODE', $modulecode);
    }

    function libraryStatusMsg() { IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $return = '';
        $return .= dict('GEN_LBL_PHP_EXTENSION') . ': sockets, ' . dict('GEN_LBL_STATUS') . ': ' . dict((extension_loaded('sockets')) ?
                                'GEN_LBL_OK' : 'GEN_LBL_FAIL') . '<br>';
        $return .= dict('GEN_LBL_PHP_EXTENSION') . ': soap, ' . dict('GEN_LBL_STATUS') . ': ' . dict((extension_loaded('soap')) ?
                                'GEN_LBL_OK' : 'GEN_LBL_FAIL') . '<br>';
        $return .= dict('GEN_LBL_PHP_EXTENSION') . ': curl, ' . dict('GEN_LBL_STATUS') . ': ' . dict((extension_loaded('curl')) ?
                                'GEN_LBL_OK' : 'GEN_LBL_FAIL');
        return $return;
    }

    /**
     * Service Check Action
     * @param void
     * @return void
     */
    private function check() { IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $idlist = getIdlist();
        $table = new htmlTable(CLX_WIDTH_ONE);
        $table->setProps(array(CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_SKMP_PREVIEW'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE));
        $table->addCell(CLX_CHAR_HTML_NBSP);
        $this->debug = true;
        $map_tbl = new htmlTable(CLX_WIDTH_ONE);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        unset($map_tbl);
        $idlist = toString(getIdlist());
        //0. Busca los parametros del servicio y connector
        $service = $this->loadToolRecord($idlist);
        //1. Interpretar mensaje de Request y  Solicitar al usuario
        //los parametros     requeridos para el request de existir
        if ($this->hasReqParameters($service['SKSV_request_code'])) {
            $table->addCell($this->checkPromptReqParameters($service['SKSV_request_code']));
            $table->addCell(CLX_CHAR_HTML_NBSP);
        } else {
            UserRequest::$request['confirm'] = CLX_NUM_ONE;
        }
        if (!empty(UserRequest::$request['confirm'])) {
            //2. Prepara parametros a ser enviados al servicio
            $parameters = $this->buildReqParameters($service['SKSV_request_code']);
            $res = $this->execute2($service['SKSV_idcode'], $parameters);
            //5. Interpreta el resultado
            if (empty($res))
                $res = dict('GEN_LBL_EMPTY_RESPONSE');
            //6. Muestra resultado al cliente
            $table2 = new htmlTable(CLX_WIDTH_ONE);
            $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
            $table2->addCell(dict('GEN_LBL_RESULT'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE));
            $text = new htmlTextArea('response', print_r($res, true), CLX_NUM_20, CLX_NUM_150);
            $text->setProp('readOnly', 'true');
            $table2->addCell($text->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
            $b = new htmlButtonCancel(dict('GEN_LBL_RETURN'), null, 'tool.php');
            $table2->addCell($b->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS));
            $table->addCell($table2->source());
        }
        return $table->source();
    }

    /**
     * Test if message has elements
     *
     * @param string $msg_code
     * @return bool $qty
     */
    function hasReqParameters($msg_code) { IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $qty = ClxCommon::$db->oneExistsRecords('CLX_SK_ELEMENTS', 'ELE_TYPE <> ' . singleQuote('IGNR') . '', 'MSG_CODE = ' . singleQuote($msg_code));
        return (bool) ($qty > CLX_NUM_ZERO);
    }

    function buildReqParameters($msg_code) { IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $SKME = getTool('SKME');
        $parameters = array();
        $rs = $SKME->getElementsResults($msg_code);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            switch ($r['ELE_TYPE']) {
                default:
                    $parameters[$r['IDNAME']] = UserRequest::$post['SKSV_' . $r['IDNAME']];
                    break;
            }
        }
		ClxCommon::$db->freeResult( $rs );
        return $parameters;
    }

    function checkPromptReqParameters($msg_code) { IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $msg = array();
        $ac = UserRequest::$request['ac'];
        $idlist = toString(getIdlist());
        // Search Form
        $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF']);
        $form->addArgument(CLX_PROP_TO, $this->code);
        $form->addArgument('ac', $ac);
        $form->addArgument('confirm', '1');
        $form->addArgument('idlist', $idlist);
        $form->addArgument(CLX_PROP_TARGET, (array_key_exists(CLX_PROP_TARGET, UserRequest::$request)) ? UserRequest::$request[CLX_PROP_TARGET] : '');
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
        $table->addCell(dict('TOOL_SKSR_TEST_PARAMETERS'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $results = ClxCommon::$db->getRecords('CLX_SK_ELEMENTS', 'MSG_CODE = ' . singleQuote($msg_code) . ' AND ELE_TYPE <> ' . singleQuote('IGNR') . ' ORDER BY SEQNUM');
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            $table->addField($msg, '<b>' . uppercase($result['IDNAME']) . ':</b><br>' . $result['DESCRIPTION'], 'SKSV_' . $result['IDNAME'], ((array_key_exists('SKSV_' . $result['IDNAME'], UserRequest::$post)) ?
                            UserRequest::$post['SKSV_' . $result['IDNAME']] :
                            (($result['TEST_VALUE'] <> '') ?
                                    $result['TEST_VALUE'] : $result['ELE_DEFAULT'])), CLX_NUM_HUNDRED, '');
        }
		ClxCommon::$db->freeResult($results);
        $c = new htmlFormSubmit(dict('GEN_LBL_SUBMIT'), $ac, $form->getProp(CLX_PROP_ID));
        $buttons = $c->source();
        $c = new htmlButtonCancel(dict('GEN_LBL_RETURN'), null, 'tool.php');
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        return $form->source();
    }

    // SERVICE EXECUTION METHODS
    /**
     * Execute Service by code
     * @param string $service_code
     * @param array $parameters
     * @return bool $result
     *
     * By calling this method the following steps will be accomplished
     * 1. Validate Required
     * 2. Complete request
     * 3. Process response
     * 4. Execute Action on response event
     * 5. Generate log
     */
    function execute2($service_code, $parameters = array()) { IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $return = true;
        $this->service_code = $service_code;
        $this->skmt = &getTool('SKMT');
        //0. Busca los parametros del servicio y connector
        $service = $this->getServiceByCode($service_code);
        if (empty($service)) {
            $this->logService(dict('GEN_CODE_SKSV_NOSERVFOUND', $this->service_code), 'ERRO');
            return false;
        }
        $this->encoding = $service['SERV_ENCODING'];
        $this->method = $service['IDNAME'];
        $this->request_code = $service['REQUEST_CODE'];
        $this->response_code = $service['RESPONSE_CODE'];
        //Some service checking
        if ($service['SERVICE_TYPE'] === 'CLNT') {//Client
            //Some wsdl checking
            $this->connector = &getTool('SKCO');
            $this->connector->loadConnector($service['CONNECTOR']);
            if ($this->connector->hasErrors) {
                $this->logService(dict('GEN_CODE_SKSV_NOWSDLFOUND', $this->service_code), 'ERRO');
                return dict('GEN_CODE_SKSV_NOWSDLFOUND', $this->service_code);
            }
            $this->logService(dict('GEN_LBL_CLIENTEXEC', $this->service_code), 'RUN');
            $return = $this->executeClient($parameters);
        } else {//Server
            $this->logService(dict('GEN_LBL_SERVEREXEC', $this->service_code), 'RUN');
            if (!empty($service['OPT_CODELIB'])) {
                //Perform call for individual class
                if (!class_exists($service['OPT_CLASSNAME'])) {
                    includeCodeLib($service['OPT_CODELIB']);
                }
                $obj = new $service['OPT_CLASSNAME'];
                $return[] = call_user_func_array(array($obj, $service['IDNAME']), $parameters);
            } else {
                $return = $this->executeServer($parameters);
            }
        }//sleep(4);
        ClxCommon::$db->commit();
        return $return;
    }

    /**
     * Process Client Service Requests
     *
     * @param array $parameters
     * @return mixed $result
     */
    function executeClient(&$parameters) { IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $stime = microtime_float();
        $return = null;
        $this->initService();
        if ($this->hasRequest()) {
            $this->skmt->getTranslations($this->request_code, CLX_NUM_ONE);
            //Build parameters
            $prmt = $this->loadReqParameters($this->request_code, $parameters);
            $this->req_params_raw = $prmt; //Storing parameters
            //test if connector is type curl
            if ($this->connector->type === 'CURL') {
                //setting curl request
                $url = $this->connector->url . $this->method;
                //Test if request is Field pair type
                if (strpos($url, '?') > CLX_NUM_ZERO)
                    $comma = '';
                else
                    $comma = '?';
                foreach ($prmt as $key => $val) {
                    if (strlen($val) == CLX_NUM_ZERO)
                        continue;
                    $url .=$comma . $key . '=' . urlencode($val);
                    $comma = '&';
                }
                $client = curl_init();
                //Additional Parameters
                if ($this->connector->hasUser) {
                    curl_setopt($client, CURLOPT_USERPWD, $this->connector->other_user . ':' . $this->connector->other_pass);
                }
                curl_setopt($client, CURLOPT_URL, $url);
                curl_setopt($client, CURLOPT_POSTFIELDS, $prmt);
                curl_setopt($client, CURLOPT_HTTPGET, CLX_NUM_ONE);
                curl_setopt($client, CURLOPT_HEADER, false);
                $curl_header = array('Accept: application/xml', 'Content-Type: application/xml');
                curl_setopt($client, CURLOPT_HTTPHEADER, $curl_header);
                curl_setopt($client, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($client, CURLOPT_VERBOSE, false);
                if (preg_match('#^(https)#', $url)) {
                    curl_setopt($client, CURLOPT_SSL_VERIFYPEER, false);
                }
                $result = curl_exec($client);
                //pre(print_r( curl_getinfo  ($client )),true);
                if (curl_errno($client)) {
                    $this->logService(dict('GEN_CODE_SKSV_REQUESTERROR', $this->service_code, 'Err No:' . curl_errno($client) . ', Err: ' . curl_error($client)), 'ERRO');
                    return curl_error($client);
                } else {
                    $this->parseSoapResponse($result);
                    ClxFreeReturn($this->set_last_operation_result($result));
                }
                curl_close($client);
            } else {//all other connectors
                if ($this->encoding === 'UTF-8') {
                    foreach ($prmt as $key => $val) {
                        $prmt[$key] = utf8_encode($val);
                    }
                }
                //pre(htmlentities(print_r($prmt,true)));
                try {
                    $client = new SoapClient($this->connector->url, array('trace' => $this->service_trace,
                        'exceptions' => $this->service_exceptions));
                } catch (SoapFault $f) {
                    $this->logService(dict('GEN_CODE_SKSV_REQUESTERROR', $this->service_code, 'Err No:' . $f->faultcode . ', Err: ' . $f->faultstring), 'ERRO');
                    return print_r($f, true);
                } catch (Exception $f) {
                    $this->logService(dict('GEN_CODE_SKSV_REQUESTERROR', $this->service_code, 'Err No:' . $f->faultcode . ', Err: ' . $f->faultstring), 'ERRO');
                    return print_r($f, true);
                }
                $soap_header = new SoapHeader(kWebSite, 'RequestorName', kDatabaseName);
                $output_headers = null; //Must Be implemented
                //4. Send service request
                try {
                    $result = $client->__soapCall($this->method, $prmt, null, $soap_header, $output_headers);
                    //Translating soap result in well formed xml
                    ClxFreeReturn($this->set_last_operation_result($result));
                    $this->parseSoapResponse($result);
                } catch (SoapFault $f) {
                    $this->logService(
                            dict('GEN_CODE_SKSV_REQUESTERROR', $this->service_code, 'Err No:' . $f->faultcode . ', Err: ' . $f->faultstring), 'ERRO');
                    return dict('GEN_CODE_SKSV_REQUESTERROR', $this->service_code, 'Err No:' . $f->faultcode . ', Err: ' . $f->faultstring);
                }
            }
        }//else if not curl
        if ($this->hasResponse()) {
            $response_time = microtime_float() - $stime;
            //Process response
            $return = $this->executeMessage($this->response_code, $result);
            if ($this->encoding === 'UTF-8') {
                if (is_array($result)) {
                    foreach ($result as $key => $val) {
                        $result[$key] = utf8_decode($val);
                    }
                } else {
                    $result = utf8_decode($result);
                }
            }
            $result = print_r($result, true);
            $etime = microtime_float() - $stime;
            $return .=CLX_CHAR_NL . CLX_CHAR_NL . dict('GEN_LBL_RESPONSE') . ':' . CLX_CHAR_NL . ' Service Response Time: ' . $response_time . CLX_CHAR_NL . ' Total Service + Process time: ' . $etime . CLX_CHAR_NL;
            if (!empty($this->debug)) {
                $return .='Action message:' . $this->action_message . CLX_CHAR_NL;
            }
            $this->logService('Service Response Time: ' . $response_time . '
				Total Service + Process time: ' . $etime . ' Response Length ' . strlen($result), 'END');
        }
        if (!empty($this->debug)) {
            return 'Process Result:' . CLX_CHAR_NL . $return . CLX_CHAR_NL . CLX_CHAR_NL . $result;
        } else {
            return $return;
        }
    }

    /**
     * Process Server Service Responses.
     * @param array &$parameters
     * @return Mixed $response
     */
    function executeServer(&$parameters) { IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $this->initService();
        $stime = microtime_float();
        $response = null;
        $this->req_params_raw = $parameters; //Storing parameters
        //prepare keys since webservices returns 0,1,2,3 according wsdl
        $this->prepareServerInputParameters($parameters);
        if ($this->hasRequest()) {
            $this->skmt->getTranslations($this->request_code, CLX_NUM_ZERO);
            //Preparing headers. Verify information about loging
            $prmts = $this->loadReqParameters($this->request_code, $parameters);
            $this->req_params_prmts = $prmts;
            $xml_string = $this->arrayToXml($prmts);
            $response = $this->executeMessage($this->request_code, $xml_string);
		}
        if ($this->hasResponse()) {
            $action_type = ClxCommon::$db->getField('CLX_SK_MESSAGES', 'ACTION_TYPE', 'IDCODE = ' . singleQuote($this->response_code));
            if ($action_type === 'CODE') {
                $response = $this->executeCode($this->response_code, $prmts);
            } else {

                $this->skmt->getTranslations($this->response_code, CLX_NUM_ONE);
                $prmts = $this->loadReqParameters($this->response_code, $parameters);
                $xml_string = $this->arrayToXml($prmts);
                $response = $this->executeMessage($this->response_code, $xml_string, $prmts);
            }
        }
        if (array_key_exists(CLX_NUM_ONE, $response)) {
            $response = $response[CLX_NUM_ONE];
        }
        $response_time = microtime_float() - $stime;
        $etime = microtime_float() - $stime;
        $this->logService('Service Response Time: ' . $response_time . ' Total Service + Process time: ' . $etime, 'END');
        return $response;
    }

    // MESSAGE EXECUTION METHODS
    /**
     * Process Message
     *
     * @param String $msg_code
     * @param String $xml_string
     * @return Mixed
     */
    function executeMessage(&$msg_code, &$xml_string, $parameters = array()) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' -->24'. chr(13).chr(10)); fclose($kk);}       
       
		$action_type = ClxCommon::$db->getField('CLX_SK_MESSAGES', 'ACTION_TYPE', 'IDCODE = ' . singleQuote($msg_code));
      //  echo "----------4---";
		//pre($xml_string);  
		//echo 'action type :', $action_type;
	//	echo 'msg_code :', $msg_code;
		if ($action_type === 'NONE') {
            //nothing to do
            if (!empty($parameters)) {
                $this->msg_logs[CLX_NUM_ZERO] = $parameters;
            }
            return $this->msg_logs;
        }
		//echo "----------3---";
		//pre($xml_string); die;
        //FIRST LOADING XML DATA INTO RELATIONAL STRUCT
        //Set xml temporary table prefix
        $this->setTempTablePrefix($msg_code);
        //Parse XML
		
        try {
            $xml = new SimpleXMLElement($xml_string);
        } catch (Exception $e) {
			IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' -->26'. chr(13).chr(10)); fclose($kk);}       
           
			$this->reportError($e->getMessage() . '(' . $e->getCode() . ') '.__METHOD__.' '.__FILE__.':'.__LINE__, $xml_string);
        }
		
        //Parse Structure
		
        $this->loadXmlStructure($msg_code);
        if (!empty($this->debug))
            $this->msg_logs[] = 'XML Structure loaded' . CLX_CHAR_NL;
        //Build Temporary Tables\
		$this->buildTemporaryTables();
        if (!empty($this->debug))
            $this->msg_logs[] = 'Temporary tables created';
        //Load Temporary Tables
		IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' xml:'.print_r($xml, true). chr(13).chr(10)); fclose($kk);}       
		
		$this->loadMessageXmlInput($xml);
        if (!empty($this->debug))
            $this->msg_logs[] = 'Response loaded into temporary tables';
		//Build response query
        $this->buildResponseQuery();
        if (!empty($this->debug))
            $this->msg_logs[] = 'Load query defined';
        //SECOND TRANSFORM RELATIONAL DATA INTO REQ STRUCTURE (MAPS)
		$this->skmt->getTranslations($msg_code, CLX_NUM_ZERO);
        if (!empty($this->debug))
            $this->msg_logs[] = 'Initializing translations';
        //do record
		$this->transformRecord($msg_code, $action_type, '');
		//return implode(CLX_CHAR_NL, $this->msg_logs);
		return $this->msg_logs;
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $msg_code
     */
    function setTempTablePrefix($msg_code) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
		$this->tmp_tbl_prefix = 'X_' . $msg_code;
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $fieldname
     * @return unknown
     */
    function parseFieldName($fieldname) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        return str_replace('-', '_', $fieldname);
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $element_rec
     * @return unknown
     */
    function parseFieldType($element_rec) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $default_raw = $element_rec['ELE_DEFAULT'];
        if ($default_raw === '')
            $default_raw = 'null';
        $default = $element_rec['ELE_DEFAULT'];
        switch ($element_rec['ELE_TYPE']) {
            case 'CHAR':
                if ($default_raw <> 'null')
                    $default = singleQuote($default);
                return array('type' => 'varchar(255)', 'default' => $default, 'default_raw' => $default_raw, 'null' => 'YES', 'properties' => '');
                break;
            case 'TEXT':
                return array('type' => 'text', 'null' => 'YES', 'properties' => '');
                break;
            case 'INTN':
                return array('type' => 'int(11)', 'default' => $default, 'default_raw' => $default_raw, 'null' => 'YES', 'properties' => '');
                break;
            case 'DECN':
                return array('type' => 'dec(26,' . $element_rec['ELE_DECIMALS'] . ')', 'default' => $default, 'default_raw' => $default_raw, 'null' => 'YES', 'properties' => '');
                break;
            case 'DATE':
                return array('type' => 'date', 'null' => 'YES', 'properties' => '');
                break;
            case 'DATI':
                return array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
                break;
            default:
                if ($default_raw <> 'null')
                    $default = singleQuote($default);
                return array('type' => 'varchar(10)', 'default' => $default, 'default_raw' => $default_raw, 'null' => 'YES', 'properties' => '');
                break;
        }
    }

    /**
     * Build temporary table structure to be imported.
     *
     * @param unknown_type $msg_code
     */
    function loadXmlStructure($msg_code) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $elements = array();
        $SKME = getTool('SKME');
        $rs = $SKME->getElementsResults($msg_code);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $elements[$r['IDCODE']] = $r;
            if (empty($r['PARENT_ELEMENT'])) {
                $xpath = '/xml';
            } else {
                $xpath = '/xml' . $elements[$r['PARENT_ELEMENT']]['XPATH'];
            }
            if ($r['ELE_TYPE'] <> 'PNEL' && $r['ELE_TYPE'] <> 'SXML') {
                if (!array_key_exists($xpath, $this->xml_structure)) {
                    $this->xml_structure[$xpath]['parent'] = $this->struct_parent_xpath;
                    $this->xml_structure[$xpath]['table'] = $this->tmp_tbl_prefix . '_' . $this->table_counter . '_TMP';
                    $this->table_counter++;
                    $parent = implode('/', array_intersect(
                                    explode('/', $xpath), explode('/', $this->struct_parent_xpath)
                    ));
                    if ($this->struct_parent_xpath === '' || $parent <> $this->struct_parent_xpath) {
                        if ($parent === '') {
                            $this->struct_parent_xpath = $xpath;
                        } else {
                            $this->struct_parent_xpath = $parent;
                        }
                    }
                    //Adding key fields
                    $fielddef = array('type' => 'int(11) unsigned',
                        'null' => 'NO',
                        'properties' => '',
                        'index' => 'PRI',
                        'element' => 'clx_id');
                    $this->xml_structure[$xpath]['fields']['clx_id'] = $fielddef;
                    //Adding key fields
                    $fielddef = array('type' => 'int(11) unsigned',
                        'null' => 'YES',
                        'properties' => '',
                        'index' => '',
                        'element' => 'clx_parent_id');
                    $this->xml_structure[$xpath]['fields']['clx_parent_id'] = $fielddef;
                }
                $fielddef = $this->parseFieldType($r);
                $fielddef['element'] = $r['IDCODE'];
                $this->xml_structure[$xpath]['fields'][$this->parseFieldName($r['IDNAME'])] = $fielddef;
                $this->xml_structure[$xpath]['elements'][$this->parseFieldName($r['IDNAME'])] = $r;
            }
        }
		ClxCommon::$db->freeResult( $rs );
    }

    /**
     * Enter description here...
     *
     */
    function buildTemporaryTables() {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__. chr(13).chr(10)); fclose($kk);}       
        foreach ($this->xml_structure as $key => $val) {
            ClxCommon::$db->dropTable($val['table']);
			IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__. '  nombre temporal '. print_r($val['table'],true). ' fields'. print_r( $val['fields'], true) .  chr(13).chr(10)); fclose($kk);}       
            if (!ClxCommon::$db->tableExists($val['table'])) {
                ClxCommon::$db->createTable($val['table'], $this->tmp_tbl_type, $val['fields']);
            }
        }
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $tablename
     * @param unknown_type $record
     */
    function loadTemporaryRecord($tablename, $record) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__. chr(13).chr(10)); fclose($kk);}       
        ClxCommon::$db->createRecordVoid($tablename, $record, false);
    }

    /**
     * Enter description here...
     *
     * @param SimpleXMLElement $xml_obj
     * @param unknown_type $xpath
     */
    function loadMessageXmlInput(SimpleXMLElement $xml_obj, $xpath = '') {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' xml:'.print_r($xml_obj,true). chr(13).chr(10)); fclose($kk);}       
        $xpath .= '/' . $xml_obj->getName();
		IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.'&& xpath:'.print_r($xpath,true).' this->xml_structure '.print_r($this->xml_structure,true). chr(13).chr(10)); fclose($kk);}       
        if (array_key_exists($xpath, $this->xml_structure)) {
            //track counter
            if (!array_key_exists($xpath, $this->counter)) {
                $this->counter[$xpath] = CLX_INIT_ZERO;
            }
            $data_src = array();
			foreach ($this->xml_structure[$xpath]['fields'] as $key => $val) {
                if ($key === 'clx_id' || $key === 'clx_parent_id') {
                    //just id value
                } else {
                    $element_rec = $this->xml_structure[$xpath]['elements'][$key];
                    $i = CLX_INIT_ZERO;
					//echo  print_r((array)$xml_obj,true);die;
					//IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' obtener valor element_rec[IDNAME]: '.print_r($element_rec['IDNAME'],true). ':'.print_r($xml_obj->$element_rec['IDNAME'],true). chr(13).chr(10)); fclose($kk);}
					IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugaxx.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' obtener valor element_rec[IDNAME]: '.print_r($xml_obj,true). 'is_string:'.is_string($element_rec['IDNAME']). chr(13).chr(10)); fclose($kk);}

					$LA=$element_rec['IDNAME'];

					foreach ($xml_obj->$LA as $entry => $entry_data) {
                        switch ($element_rec['ELE_TYPE']) {
                            case 'INTN':
                                $data_src[$i][$key] = toNumber((string) $entry_data, $element_rec['ELE_DECIMALS'], $element_rec['ELE_DECSEP'], $element_rec['ELE_THOSEP']);
                                break;
                            case 'DECN':
                                $data_src[$i][$key] = toNumber((string) $entry_data, $element_rec['ELE_DECIMALS'], $element_rec['ELE_DECSEP'], $element_rec['ELE_THOSEP']);
                                break;
                            case 'DATE':
                                $data_src[$i][$key] = toIsoDate((string) $entry_data, $element_rec['ELE_DTFORMAT']);
                                break;
                            default:
                                $data_src[$i][$key] = (string) $entry_data;
                                $data_src[$i][$key] = utf8_decode($data_src[$i][$key]);
                                break;
                        }//end switch
                        $i++;
                    }//end foreach counter
                }//end if
            }
			IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' data_src valores : '.print_r($data_src,true). chr(13).chr(10)); fclose($kk);}       
            foreach ($data_src as $key => $data) {
                $data['clx_id'] = $this->counter[$xpath];
                $data['clx_parent_id'] = '';
                if ($this->xml_structure[$xpath]['parent'] <> '') {
                    if (!array_key_exists($this->xml_structure[$xpath]['parent'], $this->counter)) {
                        $data['clx_parent_id'] = '';
                    } else {
                        $data['clx_parent_id'] = $this->counter[$this->xml_structure[$xpath]['parent']] - CLX_NUM_ONE;
                    }
                }
                //Build temporary table is not exists
                //Load data on temporary table
                $this->loadTemporaryRecord($this->xml_structure[$xpath]['table'], $data);
                $this->counter[$xpath] ++;
            }
        }
		IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__. chr(13).chr(10)); fclose($kk);}       
		
		foreach ($xml_obj->children() as $child) {
			IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__. chr(13).chr(10)); fclose($kk);}       
            $this->loadMessageXmlInput($child, $xpath);
        }
    }

    /**
     * Enter description here...
     *
     */
    function buildResponseQuery() {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $aliases = array();
        $query = array();
        $i = CLX_INIT_ZERO;
	//	pre($this->xml_structure);
		foreach ($this->xml_structure as $key => $val) {
            $alias = 'X' . $i;
            $aliases[$key] = $alias;
            //Fields
            foreach ($val['fields'] as $key2 => $val2) {
                $query['maps'][$val2['element']]['name'] = $alias . '.' . $key2;
                $query['maps'][$val2['element']]['alias'] = $alias;
                $query['fields'][] = $alias . '.' . $key2 . ' ' . $alias . '_' . $key2;
            }
            if ($val['parent'] === '') {
                $query['tables'][CLX_NUM_ZERO] = CLX_CHAR_NL . '  ' . $val['table'] . ' ' . $alias;
            } else {
                $query['tables'][CLX_NUM_ZERO] .= CLX_CHAR_NL . '  LEFT JOIN ' . $val['table'] . ' ' . $alias . ' ON ' . $aliases[$val['parent']] . '.clx_id = ' . $alias . '.clx_parent_id';
            }
            //Criterias
            $i++;
        }
        $query['fromwhere'] = CLX_CHAR_NL . 'FROM ' . implode(',' . CLX_CHAR_NL . '  ', $query['tables']);
        if (!empty($query['criterias'])) {
            $query['fromwhere'] .= CLX_CHAR_NL . ' WHERE ' . CLX_CHAR_NL . '  ' . implode(CLX_CHAR_NL . '  AND ', $query['criterias']);
        }
        $sql = 'SELECT DISTINCT ' . CLX_CHAR_NL . '  ' . implode(',' . CLX_CHAR_NL . '  ', $query['fields']);
        $sql .= $query['fromwhere'];
        $query['sql'] = $sql;
        $this->result_query = $query;
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $msg_code
     * @param unknown_type $action_type
     * @param unknown_type $parent
     * @param unknown_type $parent_record
     * @param unknown_type $criteria
     */
    function transformRecord($msg_code, $action_type, $parent = '', $parent_record = array(), $criteria = '') {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' --> parent: '.  print_r($parent_record,true) . chr(13).chr(10)); fclose($kk);}       
        //Get every map
		IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' (this->result_query ) -->'.print_r($this->result_query ,true). chr(13).chr(10)); fclose($kk);}       
        if ($parent === '') {
            $sql = 'SELECT SKMP.*             FROM CLX_SK_MAPPINGS SKMP             WHERE                 SKMP.MSG_CODE = ' . singleQuote($msg_code) . '                 AND NOT EXISTS(                     SELECT SKMF.ID                     FROM CLX_SK_MAP_FIELDS SKMF                     WHERE SKMF.MAP_CODE = SKMP.IDCODE                     AND SKMF.VAL_TYPE = ' . singleQuote('PFILÃ') . ')             ORDER BY SKMP.SEQNUM ASC';
        } else {
            $sql = 'SELECT
                DISTINCT SKMP.*
            FROM
                CLX_SK_MAPPINGS SKMP,
                CLX_SK_MAP_FIELDS SKMF,
                CLX_SK_MAP_FIELDS SKMF2
            WHERE
                SKMF.MAP_CODE = SKMP.IDCODE
                AND SKMF2.IDCODE = SKMF.VAL_MAP_FIELD
                AND SKMP.MSG_CODE = ' . singleQuote($msg_code) . '
                AND SKMF.VAL_MAP_FIELD <>' . singleQuote(CLX_CHAR_EMPTY_STRING) . '
                AND SKMF.VAL_MAP_FIELD IS NOT null
                AND SKMF2.MAP_CODE = ' . singleQuote($parent) . '
                AND SKMF.VAL_TYPE = ' . "'PFIL'" . '
            ORDER BY SKMP.SEQNUM ASC';
        }
		$mps = ClxCommon::$db->executeQuery($sql);		IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' SQL 1006-->'.$sql. chr(13).chr(10)); fclose($kk);}       
        while (($mp = ClxCommon::$db->getNextRecord($mps))) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' -->200 mp: '.  print_r($mp,true) . chr(13).chr(10)); fclose($kk);}       
			$rec = array();
            $sql_fields = array();
            $relation_fields = array();
            $parent_fields = array();
            $field_formulas = array();
            $translation_fields = array();
            $parameters_fields = array();
            $not_null_constraing = '';
            //Build rec template and asociate sql mappings
			$sql = 'SELECT DISTINCT  SKMP.*, SKMPP.TABLECODE PARENT_TABLECODE, SKMPP.FIELDNAME PARENT_FIELDNAME,  DBFL.FIELD_DEFAULT,  (SELECT COUNT(SKMT.ID)  FROM CLX_SK_TRANSLATIONS SKMT  WHERE SKMT.MAPF_CODE = SKMP.IDCODE) HAS_TRANSLATIONS  FROM CLX_SK_MAPPINGS SKM, CLX_DB_FIELDS DBFL,  CLX_SK_MAP_FIELDS SKMP  LEFT JOIN  CLX_SK_MAP_FIELDS SKMPP ON SKMP.VAL_MAP_FIELD = SKMPP.IDCODE WHERE DBFL.FIELDNAME = SKMP.FIELDNAME AND SKMP.MAP_CODE = ' . singleQuote($mp['IDCODE']) . ' AND SKMP.MAP_CODE = SKM.IDCODE AND SKMP.VAL_TYPE <> ' . singleQuote('IGNR') . ' ORDER BY SKM.SEQNUM ASC';
           //ECHO $sql; 
		   $fls = ClxCommon::$db->executeQuery($sql);IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__. ' sql 1007-->  '.  $sql. chr(13).chr(10)); fclose($kk);}       
            while (($fl = ClxCommon::$db->getNextRecord($fls))) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugx1.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' -->201 fl: '.  print_r($fl,true) . chr(13).chr(10)); fclose($kk);}       
             //ECHO CHR(13),CHR(10).'ACA';   //nota: si no existe el VAL_ELEMENT en result_query es porque esta como ignore
               
				if ($fl['VAL_ELEMENT'] && array_key_exists($fl['VAL_ELEMENT'], $this->result_query['maps'])) {
					IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' -->300 fl: '.  $fl['VAL_ELEMENT']. ' ==> '. print_r( $this->result_query['maps'][$fl['VAL_ELEMENT']],true). chr(13).chr(10)); fclose($kk);}       
                    $sql_fields[$fl['FIELDNAME']] = $this->result_query['maps'][$fl['VAL_ELEMENT']]['name'] . ' ' . $fl['FIELDNAME'];
                    $relation_fields[$this->result_query['maps'][$fl['VAL_ELEMENT']]['alias']] = $this->result_query['maps'][$fl['VAL_ELEMENT']]['alias'] . '.clx_id ' . $this->result_query['maps'][$fl['VAL_ELEMENT']]['alias'] . '_clx_id';
                    $not_null_constraing = $this->result_query['maps'][$fl['VAL_ELEMENT']]['alias'] . '.clx_id ';
                }
                if ($fl['PARENT_FIELDNAME'] === true) {
                    $parent_fields[$fl['FIELDNAME']] = array('PARENT_TABLECODE' => $fl['PARENT_TABLECODE'], 'PARENT_FIELDNAME' => $fl['PARENT_FIELDNAME']);
                }
                if ($fl['VAL_FORMULA'] <> '') {
                    $field_formulas[$fl['FIELDNAME']] = $fl['VAL_FORMULA'];
                }
				if ($fl['HAS_TRANSLATIONS'] > CLX_NUM_ZERO) {
                    $translation_fields[$fl['FIELDNAME']] = $fl['IDCODE'];
                }
                if ($fl['SEARCH_KEY'] == CLX_NUM_ONE) {
                    $this->search_key[$fl['MAP_CODE']][$fl['TABLECODE']][$fl['FIELDNAME']] = CLX_NUM_ONE;
                }
                if ($fl['READ_ONLY'] > CLX_NUM_ZERO) {
                    $this->read_only[$fl['MAP_CODE']][$fl['TABLECODE']][$fl['FIELDNAME']] = $fl['READ_ONLY'];
                }
                if ($fl['PRMT_NAME'] <> '') {
                    $parameters_fields[$fl['FIELDNAME']] = $fl['PRMT_NAME'];
                }
                if ($fl['VAL_TYPE'] === 'CONS') {
                    $rec[$fl['FIELDNAME']] = $fl['VAL_CONSTANT'];
                } else {
                    if ($fl['FIELD_DEFAULT'] <> '') {
                        $rec[$fl['FIELDNAME']] = $fl['FIELD_DEFAULT'];
                    } else {
                        $rec[$fl['FIELDNAME']] = '';
                    }
                }
				IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__. ' sql_fields  '. print_r( $sql_fields  ,true) . chr(13).chr(10)); fclose($kk);}       	
            }//end while fl
			ClxCommon::$db->freeResult( $fls );
			$src_rec = $rec;
            //Search sql on source data
            $sql = 'SELECT DISTINCT ' . CLX_CHAR_NL . '  ' . implode(',' . CLX_CHAR_NL . '  ', $relation_fields) . ', ' . CLX_CHAR_NL . '  ' . implode(',' . CLX_CHAR_NL . '  ', $sql_fields) . ' ' . $this->result_query['fromwhere'] . ' ' . CLX_CHAR_NL . '  WHERE 1=1 ' . $criteria;
          //  ECHO CHR(13).CHR(10).$sql;
			
			if ($not_null_constraing <> '') {
                $sql .= ' AND ' . $not_null_constraing . ' IS NOT null ';
            }
			$srs = ClxCommon::$db->executeQuery($sql);	IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=	$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' SQL 1008-->'.$sql. chr(13).chr(10)); fclose($kk);}       
			while (($sr = ClxCommon::$db->getNextRecord($srs))) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=	$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' SQL 1008-->entro'. chr(13).chr(10)); fclose($kk);}       
	
                $criteria = '';
                foreach ($relation_fields as $key => $val) {
                    if (array_key_exists($key . '_clx_id', $sr) && $sr[$key . '_clx_id'] === '') {
                        $criteria .= ' AND ' . $key . '.clx_id IS NULL';
                    } else {
                        $criteria .= ' AND ' . $key . '.clx_id = ' . $sr[$key . '_clx_id'] . ' ';
                    }
                    unset($sr[$key . '_clx_id']);
                }
                $rec = $src_rec;
                $rec = array_merge($rec, $sr);
                foreach ($parent_fields as $key => $val) {
                    if (array_key_exists($val['PARENT_FIELDNAME'], $parent_record)) {
                        $rec[$key] = $parent_record[$val['PARENT_FIELDNAME']];
                    }
				}
                foreach ($parameters_fields as $key => $val) {
                    //print_r($this->para)
					
                    if (array_key_exists($val, $this->req_params_raw)) {
                        $rec[$key] = $this->req_params_raw[$val];
                    }
                }
                //insertar registro
                //executing Formulas key-fieldname val-formula
				foreach ($field_formulas as $key => $val) {
                    $this->executeFormula($val, $rec);
                }
                //do translation
                foreach ($translation_fields as $key => $val) {
                    $this->skmt->translate2($val, $rec[$key]);
                }
				IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>1'. chr(13).chr(10)); fclose($kk);}       

                //Perform Inserts
				$this->msg_logs[] = $this->processRecord($msg_code, $mp['IDCODE'], $action_type, $mp['QUERYCODE'], $mp['TABLECODE'], $rec);
             	
				//verificar si tiene hijos y ejecutar de nuevo en cada opcion
				$this->transformRecord($msg_code, $action_type, $mp['IDCODE'], $rec, $criteria);
			}
			ClxCommon::$db->freeResult( $srs );
        }
		ClxCommon::$db->freeResult( $mps );
		
 		IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
		//end while mp
		//if (!empty($this->processid))
		//	$this->msg_logs[] =$this->processid;
			
	}

    /**
     * Initializes services
     *
     */
    function initService() {
        $this->xml_structure = array();
        $this->counter = array();
        $this->table_counter = CLX_INIT_ZERO;
        $this->struct_parent_xpath = '';
        $this->result_query = '';
        $this->msg_logs = array(); //Output message
        $this->initActionStatus();
    }

    /**
     * Parse Respose Data
     *
     * @param mixed $response
     */
    function parseSoapResponse(&$response) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $xml = '<?xml version="1.0"?><xml>';
        if (!is_array($response)) {
            $xml .= substr($response, strpos($response, '?>') + CLX_NUM_TWO, strlen($response));
        } else {
            foreach ($response as $key => $val) {
                if (strpos($val, '<?xml') !== false) {
                    $val = substr($val, strpos($val, '?>') + CLX_NUM_TWO, strlen($val));
                }
                $xml .= '<$key>' . $val . '</$key>';
            }
        }
        $xml .='</xml>';
        $response = $xml;
    }

    /**
     * Loads elements into property
     *
     * @param string $msg_code
     */
    function initElements($msg_code) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        //Clean any element
        $this->elements = array();
        $sql = 'SELECT *         FROM CLX_SK_ELEMENTS         WHERE MSG_CODE = ' . singleQuote($msg_code) . '         ORDER BY SEQNUM ASC';
        $rs = ClxCommon::$db->executeQuery($sql);	IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=	$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' SQL-->'.$sql. chr(13).chr(10)); fclose($kk);}       
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $this->elements[$r['IDCODE']] = $r;
            $key = array();
            $this->buildElementXpath($key, $r);
            $key = array_reverse($key);
            $key = implode('/', $key);
            $this->elements[$r['IDCODE']]['XPATH'] = '/xml/' . $key;
        }
		ClxCommon::$db->freeResult( $rs );
    }

    /**
     * Builds mapping structure into property
     *
     * @param string $msg_code
     */
    function initMappings($msg_code) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        //Clear Parents
        $this->parent_record = array();
        $this->read_only_exclude = array();
        //Clear any mapping
        $this->initElements($msg_code);
        $this->mappings = array();
        $sql = 'SELECT
        SKME.IDCODE,
        SKMP.IDCODE MAP_CODE,
        SKMP.QUERYCODE MAP_QUERYCODE,
        SKMP.TABLECODE MAP_TABLECODE,
        SKMP.FIELDNAME MAP_FIELDNAME,
        SKMP.VAL_FORMULA,
        SKME.ELE_TYPE,
        SKME.ELE_DTFORMAT,
        SKME.ELE_THOSEP,
        SKME.ELE_DECSEP,
        SKME.ELE_DECIMALS,
        SKMP.ELEMENT_CODE,
        SKMP.VAL_FORMULA,
        SKMP.VAL_CONSTANT,
        SKMP.SEARCH_KEY,
        SKMP.READ_ONLY,
        SKMP.VAL_TYPE,
        SKMP.VAL_FORMULA,
        SKMP.VAL_ELEMENT,
        SKMP.CLXFIELD_FORMAT
        FROM CLX_SK_MESSAGES SKMS,
        CLX_SK_ELEMENTS SKME,
        CLX_SK_MAPPINGS SKMP
        WHERE
        SKMS.IDCODE = SKME.MSG_CODE
        AND SKMP.ELEMENT_CODE = SKME.IDCODE
        AND SKME.MSG_CODE = ' . singleQuote($msg_code) . '
        AND SKMP.TABLECODE IS NOT null
        AND SKMP.TABLECODE <> ' . singleQuote(CLX_CHAR_EMPTY_STRING) . '
        AND SKME.ELE_TYPE <> ' . singleQuote('IGNR') . '
        AND SKMP.VAL_TYPE <> ' . singleQuote('IGNR') . '
        ORDER BY SKME.SEQNUM ASC';
        $rs = ClxCommon::$db->executeQuery($sql);	IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=	$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' SQL 1009-->'.$sql. chr(13).chr(10)); fclose($kk);}       
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $mapkey = '/xml';
            $criterias = array();
            $r['XPATH'] = $this->elements[$r['IDCODE']]['XPATH'];
            //get criterias to build keys
            $sql = 'SELECT
                      	SKMC.TABLECODE1,
                      	SKMC.FIELDNAME1,
                      	SKMC.OPERATOR,
                      	SKMC.TABLECODE2,
                      	SKMC.FIELDNAME2,
                      	SKMC.FIELD_VALUE,
                      	SKMC.LOGICAL
                    FROM
                        CLX_SK_CRITERIAS SKMC
                    WHERE
                        SKMC.MAP_CODE = ' . singleQuote($r['MAP_CODE']) . '
                    ORDER BY SKMC.ID ASC';
            $rs2 = ClxCommon::$db->executeQuery($sql);	IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=	$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' SQL 1010-->'.$sql. chr(13).chr(10)); fclose($kk);}       
            while ($r2 = ClxCommon::$db->getNextRecord($rs2, ASSOCIATIVE)) {
                if ($r['MAP_TABLECODE'] == $r2['TABLECODE1']) {
                    //If criteria is inverted then try to reverse it
                    $r3 = $r2;
                    $r2['TABLECODE1'] = $r3['TABLECODE2'];
                    $r2['TABLECODE2'] = $r3['TABLECODE1'];
                    $r2['FIELDNAME1'] = $r3['FIELDNAME2'];
                    $r2['FIELDNAME2'] = $r3['FIELDNAME1'];
                    unset($r3);
                }
                $this->read_only_exclude[$r2['TABLECODE1']][$r2['FIELDNAME1']] = CLX_NUM_ONE;
                $mapkey .= implode('.', $r2);
                $criterias[] = $r2;
            }
			ClxCommon::$db->freeResult( $rs2 );
            //Store Criterias for latter
            //inverting criteras if parent and child are oposite
            $this->criterias[$mapkey] = $criterias;
            $this->mappings[$mapkey][$r['MAP_TABLECODE']][$r['MAP_FIELDNAME']] = $r;
        }
		ClxCommon::$db->freeResult( $rs );
    }

    /**
     * Construct Element xPath
     *
     * @param array $key
     * @param array $element_record
     * @return array
     */
    function buildElementXpath(&$key, &$element_record) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $key[] = $element_record['IDNAME'];
        if ($element_record['PARENT_ELEMENT'] <> '') {
            $this->buildElementXpath($key, $this->elements[$element_record['PARENT_ELEMENT']]);
        }
    }

    //Actions
    /**
     * Enter description here...
     *
     * @param String $action_type
     * @param String $msg_code
     * @param Array $record
     * @return boolean
     */
    function processRecordValidate($action_type, &$msg_code, &$record, &$msg) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $status = true;
        //Load fields definitions from mappings to be used on validations
        if (empty($this->fields_definitions)) {//doit once per messafe
            $sql = 'SELECT
                      SKME.IDNAME ELEMENT_NAME,
                      SKMP.TABLECODE,
                      DBFL.*
                    FROM
                      CLX_SK_ELEMENTS SKME,
                      CLX_SK_MAPPINGS SKMP,
                      CLX_SK_MAP_FIELDS SKMF,
                      CLX_DB_FIELDS DBFL
                    WHERE
                      SKMP.IDCODE = SKMF.MAP_CODE
                      AND SKME.MSG_CODE = SKMP.MSG_CODE
                      AND SKMF.VAL_ELEMENT = SKME.IDCODE
                      AND DBFL.FIELDNAME = SKMF.FIELDNAME
                      AND SKMP.MSG_CODE = ' . singleQuote($msg_code);
            $rs = ClxCommon::$db->executeQuery($sql);	IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=	$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' SQL 1011-->'.$sql. chr(13).chr(10)); fclose($kk);}       
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $this->fields_definitions[$r['FIELDNAME']] = $r;
            }
			ClxCommon::$db->freeResult( $rs );
        }
		//PRE($record);
        foreach ($record as $fieldname => $value) {
            if (empty($this->fields_definitions[$fieldname]))
                continue;
            $tmp_msg = array();
            $fieldinstance = getToolObject('DBFT', $this->fields_definitions[$fieldname]['FIELDTYPE']);
			//echo $fieldname,' ', $value,chr(10);
            $fieldinstance->validateImportField($tmp_msg, $this->fields_definitions[$fieldname], $value);
            if (!empty($tmp_msg[$fieldname])) {
                //Display element name for client to understand ELEMENT_NAME
                $msg[$this->fields_definitions[$fieldname]['ELEMENT_NAME']] = '<li>' . $this->fields_definitions[$fieldname]['ELEMENT_NAME'] . '-' . $this->fields_definitions[$fieldname]['TABLECODE'] . '.' . $fieldname . ': ' . $tmp_msg[$fieldname] . '. ' . dict('GEN_LBL_VALUE') . ': ' . $record[$fieldname] . '</li>';
            }
        }
        if (!empty($msg)) {
            $this->setActionStatus(CLX_NUM_ONE, implode(CLX_CHAR_NL, $msg));
            if (!empty($this->debug)) {
                $this->msg_logs[] = CLX_CHAR_NL . dict('GEN_LBL_ERROR') . ':' . CLX_CHAR_NL . $this->getActionStatusMessage() . CLX_CHAR_NL . print_r($record, true);
            } else {
                addMessage(str_replace(CLX_CHAR_NL, '<br>', $this->getActionStatusMessage()));
            }
            $status = false;
        }
        return $status;
    }

    /**
     * Enter description here...
     *
     */
    function processRecord(&$msg_code, &$map_code, &$action_type, &$querycode, &$tablecode, &$record) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' record:'.print_r($record,true). chr(13).chr(10)); fclose($kk);}       
        $response = ''; // pre($action_type);
		$tta=fopen(kPathToWebSite.'/temp/archjjjt.txt',"a+"); 	fwrite($tta,$action_type.chr(10).chr(13).print_R($record, true));fclose($tta);	
				IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>2'. chr(13).chr(10)); fclose($kk);}       
       
		switch ($action_type) {
            case 'SELECT':
							IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>3'. chr(13).chr(10)); fclose($kk);}       

                $response = $this->processSelect($msg_code, $querycode, $tablecode, $response, $record);
                				IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>4'. chr(13).chr(10)); fclose($kk);}       

				break;
            case 'CREATE'://IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' ( option create) -->121'. chr(13).chr(10)); fclose($kk);}       
				if ($this->processRecordValidate($action_type, $msg_code, $record, $msg)) {	
                    $response = $this->processCreateRecord($map_code, $tablecode, $record, $response); //ok
                } else {
                    $response = false;
                }
                break;
            case 'REPLACE'://Delete and create new
			IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' (option replace) -->122'. chr(13).chr(10)); fclose($kk);}       
                if ($this->processRecordValidate($action_type, $msg_code, $record, $msg)) {
                    $response = $this->processReplaceRecord($map_code, $tablecode, $record, $response); //ok
                } else {
                    $response = false;
                }
                break;
            case 'MODIFY'://just update
                IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' (option modify) -->123'. chr(13).chr(10)); fclose($kk);}       
				if ($this->processRecordValidate('MODIFY', $msg_code, $record, $msg)) {
                    ClxFreeReturn($this->processModifyRecord($map_code, $tablecode, $record, $response)); //ok
                } else {
                    $response = false;
                }
                break;
            case 'LOAD'://modify or update
				IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.'(option load) -->124'. chr(13).chr(10)); fclose($kk);}       
                ClxFreeReturn($this->processRecordValidate('MODIFY', $msg_code, $record, $msg));
				if ($this->processRecordValidate('MODIFY', $msg_code, $record, $msg)) {
					$response = $this->processLoadRecord($map_code, $tablecode, $record, $response); //ok
				} else {
                    $response = false;
                }
                break;
            case 'DELETE'://just delete
                $response = $this->processDeleteRecord($map_code, $tablecode, $record, $response); //ok
                break;
            case 'PROC'://process pending
                $response = dict('GEN_LBL_STATUS') . ':DISABLED, PENDING REVITION';
                break;
            case 'CODE'://code pending
                //Done on server
                $response = dict('GEN_LBL_STATUS') . ':DISABLED, PENDING REVITION';
                break;
            default:
                //noting to do
                break;
        }
        return $response;
    }

    /**
     * Performs query search
     *
     * @param string $msg_code
     * @param string $response
     * @param array $request
     * @return unknown
     */
    function processSelect($msg_code, &$querycode, &$tablecode, $response, $request) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $is_xml = (ClxCommon::$db->oneExistsRecords('CLX_SK_ELEMENTS', 'MSG_CODE = ' . singleQuote($msg_code) . ' AND ELE_TYPE = ' . singleQuote('PNEL') . '') == CLX_NUM_ZERO) ? false : true;
        if (!empty($is_xml)) {
            //Build Response object
							IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>5'. chr(13).chr(10)); fclose($kk);}     
			$retornoxml=$this->processSelectXml($msg_code);
			//print_r($retornoxml);
		//	$toarray=(array)$retornoxml;				
		//	IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
		//		' ==<>98'.' existe source '.print_r($toarray,true).' '. chr(13).chr(10)); fclose($kk);}  
				
		//	$retorno=$this->arrayToXml((array)$toarray['objects'][0]);	//
		
        if (defined('CLX_WEBSERVICE_EXEC_API')) {
			$retorno=$retornoxml;
		}
		else
			$retorno=$retornoxml->source();

		
					IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>99'. chr(13).chr(10)); fclose($kk);}
            return  $retorno;
        } else {
							IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>7'. chr(13).chr(10)); fclose($kk);}       
			$retorno=$this->processSelectNoXml($msg_code);
    					IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>6'. chr(13).chr(10)); fclose($kk);}       

			return $retorno;
        }
	
    }

    /**
     * Process Selects where no xml are required
     * @param $msg_code
     */
    function processSelectNoXml($msg_code) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
					IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>9'. chr(13).chr(10)); fclose($kk);}       

        $return = array();
        //Get all mapping for current level
        $sql = 'SELECT DISTINCT                     SKME.IDCODE,                     SKME.IDNAME,                     SKME.XPATH,                     SKME.ELE_TYPE,                     SKMP.QUERYCODE,                     SKMP.TABLECODE,                     SKMF.FIELDNAME,                     SKMF.VAL_FORMULA,                     SKMF.IDCODE MAPFIELD_CODE,                     SKMP.IDCODE MAP_CODE                 FROM                     CLX_SK_ELEMENTS SKME,                     CLX_SK_MAPPINGS SKMP,                     CLX_SK_MAP_FIELDS SKMF                 WHERE                     SKME.MSG_CODE = ' . singleQuote($msg_code) . '                     AND SKME.MSG_CODE = SKMP.MSG_CODE                     AND SKMP.IDCODE = SKMF.MAP_CODE                     AND SKMF.VAL_ELEMENT = SKME.IDCODE                     AND SKMF.VAL_TYPE<>' . "'IGNR'" . '                     AND SKME.ELE_TYPE<>' . "'IGNR'" . '                 ORDER BY                     SKME.SEQNUM ASC';
        $queries = array();
        $qfr = ClxCommon::$db->executeQuery($sql);	IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=	$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' SQL 1013-->'.$sql. chr(13).chr(10)); fclose($kk);}       
        while (($qf = ClxCommon::$db->getNextRecord($qfr))) {
            $queries[$qf['QUERYCODE']]['MAP_CODE'] = $qf['MAP_CODE'];
            unset($qf['MAP_CODE']);
            $queries[$qf['QUERYCODE']]['FIELDS'][] = $qf;
        }
		ClxCommon::$db->freeResult( $qfr );
        //Prepare Query, Load Results Into xml
		IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       

        if (!empty($queries)) {
            $DBQY = &getTool('DBQY');
            $SKMC = &getTool('SKMC');
            //Por cada query del mapping...
IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' queries '. print_r($queries,true). chr(13).chr(10)); fclose($kk);}       

            foreach ($queries as $query_code => $query_fields) {
                //Get Query Information
                $val = $DBQY->getQuery($this->code, $query_code);
                //adding field not found on query
IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' val:'.print_r($val,true). chr(13).chr(10)); fclose($kk);}       
IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' query_fields["FIELDS"]:'.print_r($query_fields['FIELDS'],true). chr(13).chr(10)); fclose($kk);}       

                foreach ($query_fields['FIELDS'] as $map_field) {
                    $alias = $map_field['TABLECODE'] . '_' . $map_field['FIELDNAME'];
					
                    if (!array_key_exists($alias, $val['COLUMNS'])) {
                        if ($val['SELECTCLAUSE'] <> '') {
                            $val['SELECTCLAUSE'] .= ', ';
                        }
                        $val['SELECTCLAUSE'] .=$map_field['TABLECODE'] . '.' . $map_field['FIELDNAME'] . ' ' . $alias;
                    }
                }
                //Get Criteria Information
                $crits = ClxCommon::$db->getRecords('CLX_SK_CRITERIAS'
                        , 'MAP_CODE = ' . singleQuote($query_fields['MAP_CODE']) . '
						ORDER BY SEQNUM');
                $sql_crits = '';
                $logical = '';
IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       

                while (($crit = ClxCommon::$db->getNextRecord($crits))) {
                    $sql_crits = '';
                    $logical = '';
                    $sql_crits .= $crit['OPEN_BRACKET'];
                    $sql_crits .= ' ' . $logical . ' ';
                    $sql_crits .= $crit['TABLECODE1'] . '.' . $crit['FIELDNAME1'];
                    $sql_crits .= ' ' . $SKMC->operators_value[$crit['OPERATOR']] . ' ';
                    if ($crit['FIELD_VALUE'] === '') {
                        if ($crit['TABLECODE2'] === '' && array_key_exists($crit['FIELDNAME2'], $this->req_params_prmts)) {
                            $value = $this->req_params_prmts[$crit['FIELDNAME2']];
                        } else {
                            $value = '';
                        }
                    } else {
                        $value = $crit['FIELD_VALUE'];
                    }
IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       

                    $DBQY->formatCriteriaValue($crit['OPERATOR'], $value);
                    if ($value === '') {
                        $value = '';
                    } elseif (!is_numeric($value)) {
                        $value = singleQuote(clxCommon::$db->addslashes($value));
                    }
                    $sql_crits .= $value;
                    $sql_crits .= $crit['CLOSE_BRACKET'];
                    $logical = $crit['LOGICAL'];
                    if ($sql_crits <> '') {
                        if (strlen($val['WHERECLAUSE']) > CLX_NUM_ZERO) {
                            $val['WHERECLAUSE'] .= ' AND ' . $sql_crits;
                        } else {
                            $val['WHERECLAUSE'] .= $sql_crits;
                        }
                    }
                }
				ClxCommon::$db->freeResult( $crits );
				IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       

                $sql = 'SELECT ' . $val['SELECTCLAUSE'];
                $sql .=' FROM ' . $val['FROMCLAUSE'];
                if ($val['WHERECLAUSE'] <> '')
                    $sql .= ' WHERE ' . $val['WHERECLAUSE'];
                if ($val['GROUPCLAUSE'] <> '')
                    $sql .= ' GROUP BY ' . $val['GROUPCLAUSE'];
                if ($val['SORTCLAUSE'] <> '')
                    $sql .= ' ORDER BY ' . $val['SORTCLAUSE'];
                $sql .= ' LIMIT 1';
IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '.$sql.' '. chr(13).chr(10)); fclose($kk);}       
				
                $sqlrs = ClxCommon::$db->executeQuery($sql);IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=		$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' SQL 1014-->'.$sqlrs. chr(13).chr(10)); fclose($kk);}       
                $i = CLX_INIT_ZERO;
                while (($sqlr = ClxCommon::$db->getNextRecord($sqlrs))) {
                    $i++;
                    //Por cada resultado del query...
                    foreach ($query_fields['FIELDS'] as $map_field) {
                        $this->executeFormula($map_field['VAL_FORMULA'], $sqlr);
                        //Here perform transalations if apply
                        $this->skmt->translate2($map_field['MAPFIELD_CODE'], $sqlr[$map_field['TABLECODE'] . '_' . $map_field['FIELDNAME']]);
                        $return[$map_field['IDNAME']] = $sqlr[$map_field['TABLECODE'] . '_' . $map_field['FIELDNAME']];
                    }
                }
				ClxCommon::$db->freeResult( $sqlrs );
                if (empty($return)) {
                    foreach ($query_fields['FIELDS'] as $map_field) {
                        $return[$map_field['IDNAME']] = '';
                    }
                }
            }
        }
        if (count($query_fields['FIELDS']) == CLX_NUM_ONE) {
            $return = $return[$map_field['IDNAME']];
        }
        return $return;
    }

    function processSelectXml($msg_code, $parent_element = '', $object = false) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
					IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>10'. chr(13).chr(10)); fclose($kk);}       
		if (is_bool($object))
						$object=   new xmlObject('xml', true);

		$foundData=false; //hay que ver si se puede retornar un mesanje en caso de falso;
            
        $sql = 'SELECT IDCODE, IDNAME FROM CLX_SK_ELEMENTS WHERE MSG_CODE = ' . singleQuote($msg_code) . 
				' AND ' . (($parent_element === '') ? ' (PARENT_ELEMENT IS NULL OR PARENT_ELEMENT = ' . singleQuote('').')' : ' PARENT_ELEMENT = ' . singleQuote($parent_element) . ' ') .
				' AND ELE_TYPE = ' . singlequote('PNEL') . ' ORDER BY XPATH ASC';
        $rs = ClxCommon::$db->executeQuery($sql);	IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=	$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' SQL 1020-->'.$sql. chr(13).chr(10)); fclose($kk);}       
					IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>11'. chr(13).chr(10)); fclose($kk);}       
		
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
					IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>12'. chr(13).chr(10)); fclose($kk);}       

            //Get all mapping for current level
            $sql = 'SELECT DISTINCT SKME.IDCODE, SKME.IDNAME, SKME.XPATH, SKME.ELE_TYPE, SKMP.QUERYCODE,
			SKMP.TABLECODE, SKMF.FIELDNAME, SKMF.VAL_FORMULA, SKMF.IDCODE MAPFIELD_CODE, SKMP.IDCODE MAP_CODE
			FROM CLX_SK_ELEMENTS SKME, CLX_SK_MAPPINGS SKMP, CLX_SK_MAP_FIELDS SKMF 					
			WHERE SKME.MSG_CODE = ' . singleQuote($msg_code) . ' AND SKME.MSG_CODE = SKMP.MSG_CODE
			AND SKMP.IDCODE = SKMF.MAP_CODE AND SKMF.VAL_ELEMENT = SKME.IDCODE 	AND SKME.ELE_TYPE <> '.
			singlequote('PNEL') . ' AND SKMF.VAL_TYPE<>' . singlequote('IGNR') . '	AND SKME.ELE_TYPE<>' . 
			singlequote('IGNR') . ' AND SKME.PARENT_ELEMENT = ' . singleQuote($r['IDCODE']) . ' ORDER BY SKME.SEQNUM ASC';
			$queries = array();
            $qfr = ClxCommon::$db->executeQuery($sql);	IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=	$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' SQL 1000-->'.$sql. chr(13).chr(10)); fclose($kk);}       
					IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>13'. chr(13).chr(10)); fclose($kk);}       

            while (($qf = ClxCommon::$db->getNextRecord($qfr))) {
                $queries[$qf['QUERYCODE']]['MAP_CODE'] = $qf['MAP_CODE'];
                unset($qf['MAP_CODE']);
                $queries[$qf['QUERYCODE']]['FIELDS'][] = $qf;
            }
			ClxCommon::$db->freeResult( $qfr );
								IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>14'. chr(13).chr(10)); fclose($kk);}       

            //Prepare Query, Load Results Into xml
            if (!empty($queries)) {
                $DBQY = getTool('DBQY');
									IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>16'. chr(13).chr(10)); fclose($kk);}       

                $SKMC = getTool('SKMC');
									IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>17'. chr(13).chr(10)); fclose($kk);}       

                //Por cada query del mapping...
                $object_added_on_query = false;
                foreach ($queries as $query_code => $query_fields) {
										IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>15'. chr(13).chr(10)); fclose($kk);}       

					
                    //Get Query Information
                    $val = $DBQY->getQuery($this->code, $query_code);
                    //adding field not found on query
                 					IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>18'. chr(13).chr(10)); fclose($kk);}       

					foreach ($query_fields['FIELDS'] as $map_field) {
                        					IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>19'. chr(13).chr(10)); fclose($kk);}       

						$alias = $map_field['TABLECODE'] . '_' . $map_field['FIELDNAME'];
                        if (!array_key_exists($alias, $val['COLUMNS'])) {
                            if ($val['SELECTCLAUSE'] <> '') {
                                $val['SELECTCLAUSE'] .= ', ';
                            }
                            $val['SELECTCLAUSE'] .=$map_field['TABLECODE'] . '.' . $map_field['FIELDNAME'] . ' ' . $alias;
                        }
                    }
										IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>20'. chr(13).chr(10)); fclose($kk);}       

                    //Get Criteria Information
                    $crits = ClxCommon::$db->getRecords('CLX_SK_CRITERIAS'
                            , 'MAP_CODE = ' . singleQuote($query_fields['MAP_CODE']) . ' ORDER BY SEQNUM');
                    $sql_crits = '';
                    $logical = '';
										IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>21'. chr(13).chr(10)); fclose($kk);}       
                    while (($crit = ClxCommon::$db->getNextRecord($crits))) {
                        					IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>22'. chr(13).chr(10)); fclose($kk);}       
						
						$sql_crits .= $crit['OPEN_BRACKET'];
                        $sql_crits .= ' ' . $logical . ' ';
                        $sql_crits .= $crit['TABLECODE1'] . '.' . $crit['FIELDNAME1'];
                        $sql_crits .= ' ' . $SKMC->operators_value[$crit['OPERATOR']] . ' ';
                        if ($crit['FIELD_VALUE'] === '') {
                            if ($crit['TABLECODE2'] === '' && array_key_exists($crit['FIELDNAME2'], $this->req_params_prmts)) {
                                $value = $this->req_params_prmts[$crit['FIELDNAME2']];
                            } else {
                                $value = '';
                            }
                        } else {
                            $value = $crit['FIELD_VALUE'];
                        }
											IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>23'. chr(13).chr(10)); fclose($kk);}       

                        $DBQY->formatCriteriaValue($crit['OPERATOR'], $value);
                        					IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>24'. chr(13).chr(10)); fclose($kk);}       

						if ($value === '') {
                            $value = '';
                        } elseif (!is_numeric($value)) {
                            $value = singleQuote(clxCommon::$db->addslashes($value));
                        }
                        $sql_crits .= $value;
                        $sql_crits .= $crit['CLOSE_BRACKET'];
                        $logical = $crit['LOGICAL'];
                        if ($sql_crits <> '') {
                            if (strlen($val['WHERECLAUSE']) > CLX_NUM_ZERO) {
                                $val['WHERECLAUSE'] .= ' AND ' . $sql_crits;
                            } else {
                                $val['WHERECLAUSE'] .= $sql_crits;
                            }
                        }
											IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>25'. chr(13).chr(10)); fclose($kk);}       

                    }
					ClxCommon::$db->freeResult( $crits );
										IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>26'. chr(13).chr(10)); fclose($kk);}       

                    $sql = 'SELECT ' . $val['SELECTCLAUSE'];
                    $sql .=' FROM ' . $val['FROMCLAUSE'];
                    if ($val['WHERECLAUSE'] <> '')
                        $sql .= ' WHERE ' . $val['WHERECLAUSE'];
                    if ($val['GROUPCLAUSE'] <> '')
                        $sql .= ' GROUP BY ' . $val['GROUPCLAUSE'];
                    if ($val['SORTCLAUSE'] <> '')
                        $sql .= ' ORDER BY ' . $val['SORTCLAUSE'];
                    					IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>27'. chr(13).chr(10)); fclose($kk);}       

					$sqlrs = ClxCommon::$db->executeQuery($sql);	IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=	$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' SQL 1001-->'.$sql. chr(13).chr(10)); fclose($kk);}       
                    $i = CLX_INIT_ZERO;
										IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>28'. chr(13).chr(10)); fclose($kk);}       

                    while (($sqlr = ClxCommon::$db->getNextRecord($sqlrs))) {
						IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>29'. chr(13).chr(10)); fclose($kk);}       
                      
						$obj = new xmlObject($r['IDNAME'], false);
                        //Por cada resultado del query...
                        					IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>30'. chr(13).chr(10)); fclose($kk);}       

						foreach ($query_fields['FIELDS'] as $map_field) {
					IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>31'. chr(13).chr(10)); fclose($kk);}       
                        
						$this->executeFormula($map_field['VAL_FORMULA'], $sqlr);
					IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>32'. chr(13).chr(10)); fclose($kk);}       
                 
						$objf = new xmlObject($map_field['IDNAME'], false);
					IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>33'. chr(13).chr(10)); fclose($kk);}       
                        
						//Here perform transalations if apply
                            $this->skmt->translate2($map_field['MAPFIELD_CODE'], $sqlr[$map_field['TABLECODE'] . '_' . $map_field['FIELDNAME']]);
					IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>34'. chr(13).chr(10)); fclose($kk);}       

                            $objf->addContents($this->clearXmlSpecialChars($sqlr[$map_field['TABLECODE'] . '_' . $map_field['FIELDNAME']]));
					IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>35'. chr(13).chr(10)); fclose($kk);}       
                        
						$obj->addObject($objf);
                        					IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>36'. chr(13).chr(10)); fclose($kk);}       

						}
                        					IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>37'. chr(13).chr(10)); fclose($kk);}       

					
					$object->addObject($obj);
					IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>38'. chr(13).chr(10)); fclose($kk);}       
                   
						$object_added_on_query = true;
                        $i++;
                    }
                }
				ClxCommon::$db->freeResult( $sqlrs );
            } else {
				IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>39'. chr(13).chr(10)); fclose($kk);}       
					IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugaxx.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>39'. chr(13).chr(10)); fclose($kk);}       



                $obj = new xmlObject($r['IDNAME'], false);
			
            }
			//if (!isset($null))
			//	$obj=false;
			if (empty($obj))
				continue;
			$foundData=true; //hay que ver si se puede retornar un mesanje en caso de falso;
            ClxFreeReturn($this->processSelectXml($msg_code, $r['IDCODE'], $obj));
            					IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>42'. chr(13).chr(10)); fclose($kk);}       

			if (empty($object)) {
                $object = $obj;
            } else {
                if (empty($object_added_on_query)) {
                    					IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>43'. chr(13).chr(10)); fclose($kk);}       
				
					$object->addObject($obj); 
										IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>44'. chr(13).chr(10)); fclose($kk);}       

                }
					IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>45'. chr(13).chr(10)); fclose($kk);}       

            }
								IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>46'. chr(13).chr(10)); fclose($kk);}       

        }
							IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebugdd.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.
				' ==<>47'. chr(13).chr(10)); fclose($kk);}       
		ClxCommon::$db->freeResult( $rs );
        return $object;
    }

    /**
     * Process Load.
     *
     * @param string $map_code
     * @param string $tablecode
     * @param array $record
     * @param string $response
     * @return bool
     */
    function processCreateRecord($map_code, $tablecode, &$record, &$response) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $status = true;
        $msg = array();
        $EVNT = getTool('EVNT');
        $ACAD = getTool('ACAD');
        //$DBDR = &getTool('DBDR'); //Review dynamic relation on servicess
        $ac_store = UserRequest::$ac;
        $tablename = $this->getTableName($tablecode);
        $tablerec = $this->getTableRecord($tablecode);
        //1. Find if record already exists based on search keys
        $criterias = ''; //returned fron executeSearchKeys
        $exists = $this->executeSearchKeys($map_code, $tablecode, $record, $criterias);
        if (!empty($this->debug)) {
            $this->msg_logs[] = 'Table:' . $tablecode . ', Crit:' . $criterias;
        }
        if ($exists === true) {
            $status = false;
        } else {
            //create
            UserRequest::$request['ac'] = 'CREATE';
            $this->executeReadOnly($map_code, $tablecode, 'CREATE', $record);
            $EVNT->execute5('DBTB', $tablerec['ID'], 'CREP', $record, $msg); //  Create Record Pre
            $record['ID'] = ClxCommon::$db->createRecord($tablename, $record, false);
            $this->setActionId($record['ID']);
            $EVNT->execute5('DBTB', $tablerec['ID'], 'CREC', $record, $msg); //  Create Record Post
            $this->restoreReadOnly($map_code, $tablecode, 'ID = ' . $record['ID'], 'CREATE', $record);
            $ACAD->log($tablerec, $record['ID'], 'CREATE_REC', $tablerec['IDNAME'], $record);
        }
        UserRequest::$request['ac'] = $ac_store;
        return $status;
    }

    /**
     * Process Load.
     *
     * @param string $map_code
     * @param string $tablecode
     * @param array $record
     * @param string $response
     * @return bool
     */
    function processModifyRecord($map_code, $tablecode, &$record, &$response) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $status = true;
        $msg = array();
        $EVNT = getTool('EVNT');
        $ACAD = getTool('ACAD');
        $ac_store = UserRequest::$request['ac'];
        $tablename = $this->getTableName($tablecode);
        $tablerec = $this->getTableRecord($tablecode);
        //1. Find if record already exists based on search keys
        $criterias = ''; //returned fron executeSearchKeys
        $exists = $this->executeSearchKeys($map_code, $tablecode, $record, $criterias);
        if (!empty($this->debug)) {
            $this->msg_logs[] = 'Table:' . $tablecode . ', Crit:' . $criterias;
        }
        if ($exists === true) {
            //update
            UserRequest::$request['ac'] = 'MODIFY';
            $this->executeReadOnly($map_code, $tablecode, 'MODIFY', $record);
            $EVNT->execute5('DBTB', $tablerec['ID'], 'UREP', $record, $msg); //  Update Record (pre database commit)
            ClxCommon::$db->updateRecord($tablename, $record, $criterias);
            if (ClxCommon::$db->fieldExists($tablename, 'ID')) {
                $record['ID'] = ClxCommon::$db->getField($tablename, 'ID', $criterias);
            } else {
                $record['ID'] = CLX_INIT_ZERO;
            }
            $this->setActionId($record['ID']);
            $EVNT->execute5('DBTB', $tablerec['ID'], 'UREC', $record, $msg); //  Update Record (post database commit)
            $this->restoreReadOnly($map_code, $tablecode, $criterias, 'MODIFY', $record);
            $ACAD->log($tablerec, $record['ID'], 'SAVE_REC', $tablerec['IDNAME'], $record);
            if (!empty($this->debug)) {
                $this->msg_logs[] = 'Action: ' . UserRequest::$request['ac'];
                $this->msg_logs[] = 'Rec: ' . print_r($record, true);
                $this->msg_logs[] = str_repeat('-', CLX_NUM_20);
            }
        } else {
            if (!empty($this->debug)) {
                $this->msg_logs[] = 'Action:' . UserRequest::$request['ac'];
                $this->msg_logs[] = 'Note: NO RECORD FOUND FOR UPDATE';
                $this->msg_logs[] = str_repeat('-', CLX_NUM_20);
            }
        }
        UserRequest::$request['ac'] = $ac_store;
        return $status;
    }

    /**
     * Process Load.
     *
     * @param string $map_code
     * @param string $tablecode
     * @param array $record
     * @param string $response
     * @return bool
     */
    function processReplaceRecord($map_code, $tablecode, &$record, &$response) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $status = true;
        $msg = array();
        $EVNT = &getTool('EVNT');
        $ACAD = getTool('ACAD');
        $ac_store = UserRequest::$request['ac'];
        $tablename = $this->getTableName($tablecode);
        $tablerec = $this->getTableRecord($tablecode);
        //1. Find if record already exists based on search keys
        $criterias = ''; //returned fron executeSearchKeys
        $exists = $this->executeSearchKeys($map_code, $tablecode, $record, $criterias);
        if (!empty($this->debug)) {
            $this->msg_logs[] = 'Table:' . $tablecode . ', Crit:' . $criterias;
        }
        if ($exists === true) {
            //Deleting Record
            if (ClxCommon::$db->fieldExists($tablename, 'ID')) {
                $EDIT = getTool('EDIT');
                $record['ID'] = ClxCommon::$db->getField($tablename, 'ID', $criterias);
                $EDIT->deleteRecord_($tablerec, $record['ID']);
                if (!empty($this->debug)) {
                    $this->msg_logs[] = ' DELETE BY ID:' . $record['ID'];
                }
            } else {
                ClxCommon::$db->deleteRecord_($tablename, $criterias);
                $this->msg_logs[] = ' DELETE BY ID:' . $record['ID'];
            }
        }
        //create
        UserRequest::$request['ac'] = 'CREATE';
        $this->executeReadOnly($map_code, $tablecode, 'CREATE', $record);
        $EVNT->execute5('DBTB', $tablerec['ID'], 'CREP', $record, $msg); //  Create Record Pre
        $record['ID'] = ClxCommon::$db->createRecord($tablename, $record, false);
        $this->setActionId($record['ID']);
        $EVNT->execute5('DBTB', $tablerec['ID'], 'CREC', $record, $msg); //  Create Record Post
        $ACAD->log($tablerec, $record['ID'], 'CREATE_REC', $tablerec['IDNAME'], $record);
        if (!empty($this->debug)) {
            $this->msg_logs[] = 'Action:' . UserRequest::$request['ac'];
            $this->msg_logs[] = 'Rec: ' . print_r($record, true);
            $this->msg_logs[] = str_repeat('-', CLX_NUM_20);
        }
        UserRequest::$request['ac'] = $ac_store;
        return $status;
    }

    /**
     * Process Delete.
     *
     * @param string $map_code
     * @param string $tablecode
     * @param array $record
     * @param string $response
     * @return bool
     */
    function processDeleteRecord($map_code, $tablecode, &$record, &$response) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $status = true;
        $tablename = $this->getTableName($tablecode);
        $tablerec = $this->getTableRecord($tablecode);
        //1. Find if record already exists based on search keys
        $criterias = ''; //returned fron executeSearchKeys
        $exists = $this->executeSearchKeys($map_code, $tablecode, $record, $criterias);
        if (!empty($this->debug))
            $response .= 'Table:' . $tablecode . CLX_CHAR_NL . ' Crit:' . $criterias . CLX_CHAR_NL . ' Action:';
        if ($exists === true) {
            //Deleting Record
            if (ClxCommon::$db->fieldExists($tablename, 'ID')) {
                $EDIT = getTool('EDIT');
                $record['ID'] = ClxCommon::$db->getField($tablename, 'ID', $criterias);
                $this->setActionId($record['ID']);
                $EDIT->deleteRecord_($tablerec, $record['ID']);
                if (!empty($this->debug))
                    $response .= ' DELETE BY ID:' . $record['ID'] . CLX_CHAR_NL;
            }else {
                ClxCommon::$db->deleteRecord_($tablename, $criterias);
                if (!empty($this->debug))
                    $response .= ' DELETE BY CRITERIA:' . $criterias . CLX_CHAR_NL;
            }
        }
        return $status;
    }

    /**
     * Process Load.
     *
     * @param string $map_code
     * @param string $tablecode
     * @param array $record
     * @param string $response
     * @return bool
     */
    function processLoadRecord($map_code, $tablecode, &$record, &$response) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $status = true;
        $msg = array();
        $EVNT = &getTool('EVNT');
        $ACAD = getTool('ACAD');
        //$DBDR = &getTool('DBDR'); //Review dynamic relation on servicess
        $ac_store = UserRequest::$request['ac'];
        $tablename = $this->getTableName($tablecode);
        $tablerec = $this->getTableRecord($tablecode);
        //1. Find if record already exists based on search keys
        $criterias = ''; //returned fron executeSearchKeys
        $exists = $this->executeSearchKeys($map_code, $tablecode, $record, $criterias);
        if (!empty($this->debug)) {
            $this->msg_logs[] = 'Table:' . $tablecode . ', Crit:' . $criterias;
        }
        if (empty($exists)) { IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' create record->'.print_r($record,true). chr(13).chr(10)); fclose($kk);}
            //create
            UserRequest::$request['ac'] = 'CREATE';
			$tta=fopen(kPathToWebSite.'/temp/archjjjt.txt',"a+"); 	fwrite($tta,'create');fclose($tta);
			$this->executeReadOnly($map_code, $tablecode, 'CREATE', $record);
            $EVNT->execute5('DBTB', $tablerec['ID'], 'CREP', $record, $msg); //  Create Record Pre
            $record['ID'] = ClxCommon::$db->createRecord($tablename, $record, false);
			$this->setActionId($record['ID']);
            $EVNT->execute5('DBTB', $tablerec['ID'], 'CREC', $record, $msg); //  Create Record Post
			$this->restoreReadOnly($map_code, $tablecode, 'ID = ' . $record['ID'], 'CREATE', $record);
			$ACAD->log($tablerec, $record['ID'], 'CREATE_REC', $tablerec['IDNAME'], $record);
			$this->processid=array('create'.$tablecode.'ID'=>$record['ID']);
			IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' create processid record->'.print_r($this->processid,true).' '.print_r($record,true). chr(13).chr(10)); fclose($kk);}
		
        } else {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' modify record->'.print_r($record,true). chr(13).chr(10)); fclose($kk);}
			//update
            UserRequest::$request['ac'] = 'MODIFY';$tta=fopen(kPathToWebSite.'/temp/archjjjt.txt',"w+"); 	fwrite($tta,'modify'	);fclose($tta);
			$this->executeReadOnly($map_code, $tablecode, 'MODIFY', $record);
            $EVNT->execute5('DBTB', $tablerec['ID'], 'UREP', $record, $msg); //  Update Record (pre database commit)
            ClxCommon::$db->updateRecord($tablename, $record, $criterias);
            if (ClxCommon::$db->fieldExists($tablename, '_ID')) {
                $record['ID'] = ClxCommon::$db->getField($tablename, 'ID', $criterias);
            } else {
                $record['ID'] = CLX_INIT_ZERO;
            }
            $this->setActionId($record['ID']);
            $EVNT->execute5('DBTB', $tablerec['ID'], 'UREC', $record, $msg); //  Update Record (post database commit)
            $this->restoreReadOnly($map_code, $tablecode, $criterias, 'MODIFY', $record);
            $ACAD->log($tablerec, $record['ID'], 'SAVE_REC', $tablerec['IDNAME'], $record);
			$this->processid=array('modify'.$tablecode.'_`ID'=>$record['ID']);
		}
        if (!empty($this->debug)) {
            $this->msg_logs[] = 'Action:' . UserRequest::$request['ac'];
            $this->msg_logs[] = 'Rec: ' . print_r($record, true);
            $this->msg_logs[] = str_repeat('-', CLX_NUM_20);
        }
        UserRequest::$request['ac'] = $ac_store;
        return $status;
    }

    /**
     * Transform raw input into field values
     *
     * @param array $parameters
     */
    function prepareServerInputParameters(&$parameters) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $SKME = getTool('SKME');
        if (count($parameters) > CLX_NUM_ZERO) {//no point if no paramter arrives
            $i = CLX_INIT_ZERO;
            $elements = $SKME->getElementsResults($this->request_code);
            while (($element = ClxCommon::$db->getNextRecord($elements))) {
                if (!array_key_exists($element['IDNAME'], $parameters)) {
                    if (array_key_exists($i, $parameters)) {
                        $parameters[$element['IDNAME']] = $parameters[$i];
                    } else {
                        $parameters[$element['IDNAME']] = '';
                    }
                }
                $i++;
            }
			ClxCommon::$db->freeResult( $elements );
        }
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $data
     * @param unknown_type $rootNodeName
     * @param unknown_type $xml
     * @return unknown
     */
	 
	function arrayToXml($array, $node='xml', &$dom='',$save=true){IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}
		if (empty($dom)) {
			$dom = new DOMDocument('1.0', 'iso-8859-1');
			$dom->xmlStandalone =true;
			$node = $dom->createElement($node);
			$dom->appendChild($node);
			//pre($dom);	
		}
		foreach($array as $key => $value)
		{ 	IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.'  '. print_r($key,true).'  '. print_r($value,true).'  '. chr(13).chr(10)); fclose($kk);}
 
			$key = preg_replace('/[^a-z_]/i', '', $key);
			if($key==='')
				$key = '_';
		
			$a = $dom->createElement($key);
			
			$node->appendChild($a);
			if(is_array($value)) {
				$this->arrayToXml($value, $a, $dom,false);
			}
			else {
				$a->appendChild($dom->createTextNode($value));
//				$a->appendChild($dom->createTextNode($key, $value));

			}
		}
		if($save==true) {
				$xml = $dom->saveXML();// simplexml_import_dom($dom);
IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.'  '. $xml.'  '. chr(13).chr(10)); fclose($kk);}
				return $xml;
		}

	} 

    function arrayToXml6($data, $node , &$dom = null,$save=true) {       
        	
		if (empty($dom)) {
			$dom = new DOMDocument('1.0', 'iso-8859-1');
			$dom->xmlStandalone =true;
			$node = $dom->createElement( 'xml');
			$dom->appendChild($elementParent);
			
		}
		foreach ($data as $key => $value) {
			// no numeric keys in our xml please!
			if (is_numeric($key)) {
				//make string key...
				$key = 'unknownNode_' . (string) $key;
			}
			// replace anything not alpha numeric
			$key = preg_replace('/[^a-z_]/i', '', $key);
			// if there is another array found recrusively call this function
			if (is_array($value)) {                
				$enode = $dom->createElement($key);
				$node->appendChild($enode);
				//recrusive call.
				$this->arrayToXml($value,$enode,$dom, false);
			} else {
				// add single node.
				$element = $dom->createElement($key, $value);
				$node->appendChild($element);
			}
		}	
		if ($xsave==true) {
			$xml = $dom->saveXML();
			return $xml;
		}

	
	}


    function arrayToXml3($data, $elementParent = 'xml', $dom = null,$save=true) {       
        	
		if (empty($dom)) {
			$dom = new DOMDocument('1.0', 'iso-8859-1');
			$dom->xmlStandalone =true;
			if ($elementParent!='') {
				$elementParent = $dom->createElement($elementParent, '');
				$dom->appendChild($elementParent);
			}
			else
				$elementParent=$dom;
		}
		foreach ($data as $key => $value) {
			IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' key ->'.$key.',value ->'.print_r($value,true). chr(13).chr(10)); fclose($kk);}       
			// no numeric keys in our xml please!
			if (is_numeric($key)) {
				//make string key...
				$key = 'unknownNode_' . (string) $key;
			}
			// replace anything not alpha numeric
			$key = preg_replace('/[^a-z_]/i', '', $key);
			// if there is another array found recrusively call this function
			if (is_array($value)) {                
				$node = $dom->createElement($key);
				$elementParent->appendChild($node);
				//recrusive call.
			//	pre($elementParent);
				
				$this->arrayToXml($value,$key,$dom , false);
			} else {
				// add single node.
				$element = $dom->createElement($key, $value);
				$elementParent->appendChild($element);
				$xml2 = $dom->saveXML();
				IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' -->22: xml2='.print_r($xml2,true). chr(13).chr(10)); fclose($kk);}       
	
			}
		}	
	//	IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' -->20: dom='.print_r($dom,true). chr(13).chr(10)); fclose($kk);}       
		
	//	echo 'aco1';	echo 'aca';echo 'rrr';die;	
	//	IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' -->21: xml='.print_r($xml,true). chr(13).chr(10)); fclose($kk);}       
		if ($save==true) {
			$xml = $dom->saveXML();// simplexml_import_dom($dom);
			return $xml;
		}
		else {
			return $dom;
		}
	
	}
/*	 
    function zarrayToXml($data, $rootNodeName = 'xml', $xml = false) {
        if ($xml == null) {
            $xml = simplexml_load_string(
                    '<?xml version="1.0" encoding="iso-8859-1" standalone="yes"?><$rootNodeName />'
					/* ,null, LIBXML_NOERROR | LIBXML_NOWARNING );
        }
		IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' xml ->'.print_r($xml,true). chr(13).chr(10)); fclose($kk);}       

        // loop through the data passed in.
        foreach ($data as $key => $value) {
			IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' key ->'.$key.',value ->'.print_r($value,true). chr(13).chr(10)); fclose($kk);}       
            // no numeric keys in our xml please!
            if (is_numeric($key)) {
                //make string key...
                $key = 'unknownNode_' . (string) $key;
            }
            // replace anything not alpha numeric
            $key = preg_replace('/[^a-z_]/i', '', $key);
            // if there is another array found recrusively call this function
            if (is_array($value)) {
                $node = $xml->addChild($key);
                //recrusive call.
                ClxFreeReturn($this->arrayToXml($value, $rootNodeName, $node));
            } else {
                // add single node.
                $value = $this->clearXmlSpecialChars($value);
				if (is_bool($value)) {
					$value=(($value===true)? 1: 0);
				}
				if (!is_bool($key)) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' key_value use '. chr(13).chr(10)); fclose($kk);}       
					$xml->addChild($key, $value);
				}
			}
		}
        // pass back as string. or simple xml object if you want!
        return $xml->asXML();
    }
*/
    /**
     * Prepares parameters required for the service by merging request message and user parameters.
     * @param string $msg_code
     * @param array $user_parameters
     * @param string $parent_element
     * @return array $service_parameters
     */
    function loadReqParameters($msg_code, $user_parameters = array(), $parent_element = null) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $serv_parameters = array();
        //1. Search all elements and its mapping if apply
        $sql = $this->loadReqParameters_sql($msg_code, $parent_element);
        //2. On each element replace default value for formula or user parameter
        $elements = ClxCommon::$db->executeQuery($sql);	IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=	$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' SQL 1002-->'.$sql. chr(13).chr(10)); fclose($kk);}       
        while (($element = ClxCommon::$db->getNextRecord($elements))) {
            // Get the element's value
            $serv_parameters[$element['IDNAME']] = $this->loadReqParameters_get_value($msg_code, $element, $user_parameters);
            //Store request parameters to be used latter on criterias
            $this->req_params[$element['IDCODE']] = $serv_parameters[$element['IDNAME']];
        }
		ClxCommon::$db->freeResult( $elements );
        return $serv_parameters;
    }

    /**
     * Prepares SQL statement to retrieve the socket definition (messages and elements)
     * @param string $msg_code
     * @param string $node
     * @return string $sql
     */
    function loadReqParameters_sql($msg_code, $node = null) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        if ($node == null) {
            $ad_sql = ' AND (SKME.PARENT_ELEMENT IS NULL OR SKME.PARENT_ELEMENT =' . "'')";
        } else {
            $ad_sql = ' AND SKME.PARENT_ELEMENT = ' . singleQuote($node) . ' ';
        }
        //1. Search all elements and its mapping if apply
        $sql = 'SELECT SKME.IDCODE, SKME.IDCODE, SKME.IDNAME,  SKME.MSG_CODE,   (SKME.SEQNUM-1) SEQNUM, SKME.ELE_TYPE, SKME.ELE_DEFAULT, '.
			'	SKME.PARENT_ELEMENT, SKME.TEST_VALUE,   SKMF.IDCODE MAP_CODE,   SKME.IDCODE ELEMENT_CODE,  SKMF.PRMT_NAME,  '.
			'   SKMF.QUERYCODE,   SKMF.TABLECODE,    SKMF.FIELDNAME,   SKMF.VAL_TYPE,   SKMF.VAL_FORMULA,   SKME.ELE_DTFORMAT, '.
			'	SKMF.CLXFIELD_FORMAT,  SKME.XPATH '.
			'	FROM         CLX_SK_MESSAGES SKMS,   CLX_SK_ELEMENTS SKME  '. 
			'			LEFT JOIN CLX_SK_MAP_FIELDS SKMF  '. 
			'			ON SKME.IDCODE = SKMF.VAL_ELEMENT   '.      
			' WHERE         SKMS.IDCODE = SKME.MSG_CODE   AND SKME.MSG_CODE = ' . singleQuote($msg_code) . 
			'         AND SKME.ELE_TYPE <> ' . singleQuote('IGNR') . ' ' . $ad_sql . '    ORDER BY SKME.SEQNUM ASC';
        return $sql;
    }

    /**
     * Get the value of a element accoding to it's definition
     * @param string $msg_code
     * @param array $elements
     * @param array $user_parameters
     * @return variant $value
     */
    function loadReqParameters_get_value($msg_code, &$element, &$user_parameters) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        //Formulas if exists
        $this->executeFormula($element['VAL_FORMULA'], $user_parameters);
        $value = $element['ELE_DEFAULT'];
        switch ($element['VAL_TYPE']) {
            case 'PRMT':
                $value = (array_key_exists($element['PRMT_NAME'], $user_parameters)) ? $user_parameters[$element['PRMT_NAME']] : null;
                break;
            case 'FILD':
                if (!array_key_exists($element['FIELDNAME'], $user_parameters) && array_key_exists($element['IDNAME'], $user_parameters)) {
                    $value = (array_key_exists($element['IDNAME'], $user_parameters)) ? $user_parameters[$element['IDNAME']] : null;
                } else {
                    $value = (array_key_exists($element['FIELDNAME'], $user_parameters)) ? $user_parameters[$element['FIELDNAME']] : null;
                }
                break;
            default:
                if (array_key_exists($element['IDNAME'], $user_parameters))
                    $value = $user_parameters[$element['IDNAME']];
                elseif (!array_key_exists($element['IDNAME'], $user_parameters) && array_key_exists($element['SEQNUM'], $user_parameters))
                    $value = $user_parameters[$element['SEQNUM']];
                elseif (strlen($value) == CLX_NUM_ZERO)
                    $value = null;
                break;
        }//end switch
        // Test mode : assign Test Value
        if ($this->b_test_mode && $value == null) {
            if ($element['TEST_VALUE'] <> '')
                $value = $element['TEST_VALUE'];
            elseif (strlen($element['ELE_DEFAULT']) > CLX_NUM_ZERO)
                $value = $element['ELE_DEFAULT'];
            elseif ($this->b_assing_ele_type_if_no_defval === true)
                $value = dict($this->ele_types[$element['ELE_TYPE']]);
            else
                $value = '';
        }
        $o_pnel_sxml = false;
        switch ($element['ELE_TYPE']) {
            case 'DATE':
                if ($element['ELE_DTFORMAT'] <> '' && $value <> '') {
                    $value = xFormat::date($value, $element['ELE_DTFORMAT']);
                }
                break;
            // Panel
            case 'PNEL':
                $value = $this->loadReqParameters(
                        $msg_code, $user_parameters, $element['IDCODE']);
                $o_pnel_sxml = true;
                break;
            // String XML
            case 'SXML':
                $value = $this->loadReqParameters_build_xml(
                        $msg_code, $element['IDCODE'], $user_parameters);
                $value = str_replace('<xml>', '', $value);
                $value = str_replace('</xml>', '', $value);
                $o_pnel_sxml = true;
                break;
            case 'ACMG':
                $value = $this->getActionStatusMessage();
                break;
            case 'ACST':
                $value = $this->getActionStatusCode();
                break;
            case 'ACID':
                $value = $this->getActionRecordId();
                break;
            default:
                //do nothing
                break;
        }
        if ($o_pnel_sxml == false) {
            //Here perform transalations if apply
            $sql = 'SELECT  SKMF.*  FROM CLX_SK_MAPPINGS SKMP, CLX_SK_MAP_FIELDS SKMF WHERE SKMP.IDCODE = SKMF.MAP_CODE             			AND SKMP.MSG_CODE = ' . singleQuote($element['MSG_CODE']) . '             			AND SKMF.VAL_ELEMENT = ' . singleQuote($element['IDCODE']) . ' AND SKMF.VAL_TYPE <> ' . singleQuote('IGNR');
            $results = ClxCommon::$db->executeQuery($sql);	IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=	$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' SQL 1003-->'.$sql. chr(13).chr(10)); fclose($kk);}       
            //ELE651 STAT
            while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
                $this->skmt->translate2($result['IDCODE'], $value);
            }
			ClxCommon::$db->freeResult($results);
            //Formulas if exists
            //moved on top
        }
        return $value;
    }

    /**
     * Set array with diccionaries entries for each definition element type
     * @param void
     * @return void
     */
    function set_ele_types() {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $this->ele_types = array(
            'CHAR' => 'GEN_LBL_CHARACTER',
            'PNEL' => 'TOOL_SKMP_FIELD_GROUP',
            'SXML' => 'TOOL_SKMP_STRING_XML',
            'IGNR' => 'TOOL_DBIC_IGNORE',
            'INTN' => 'GEN_LBL_INTEGER',
            'DECN' => 'GEN_LBL_DECIMAL',
            'DATE' => 'GEN_LBL_DATE'
        );
    }

    /**
     * SXML Element Type top level value constructor
     * @param string $msg_code
     * @param string $parent_element
     * @param array $user_parameters
     * @return string $return
     */
    function loadReqParameters_build_xml($msg_code, $parent_element, $user_parameters) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $o = null;
        $o = $this->loadReqParameters_build_xml_add_item($o, $msg_code, $user_parameters, $parent_element);
        if ($o === true) {
            $return = $o->source_(array('level' => CLX_NUM_ZERO));
        } else {
            $return = dict('GEN_LBL_NO_ELEMENTS_FOUND');
        }
        return $return;
    }

    /**
     * SXML Element Type low level value constructor
     * @param object $object
     * @param string $msg_code
     * @param array $user_parameters
     * @param string $parent_element
     * @return object $object
     */
    function loadReqParameters_build_xml_add_item($object, $msg_code, $user_parameters, $parent_element = null) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        if ($object == null)
            $object = new xmlObject('xml', false);
        $sql = $this->loadReqParameters_sql($msg_code, $parent_element);
        $elements = ClxCommon::$db->executeQuery($sql);		IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' SQL 1004-->'.$sql. chr(13).chr(10)); fclose($kk);}       
        while (($element = ClxCommon::$db->getNextRecord($elements))) {
            $o = new xmlObject($element['IDNAME'], false);
            $content = $this->loadReqParameters_get_value($msg_code, $element, $user_parameters);
            $o->addContents($content);
            $o = $this->loadReqParameters_build_xml_add_item($o, $msg_code, $user_parameters, $element['IDCODE']);
            //Building return
            $object->addObject($o);
        }
		ClxCommon::$db->freeResult( $elements );
        return $object;
    }

    /**
     * Retrive service record by code
     * @param string service_code
     * @return array service_record
     */
    function getServiceByCode($service_code) {
        return ClxCommon::$db->getRecord($this->tablename, 'UPPER(IDCODE) = ' . singleQuote(uppercase($service_code)) . ' AND SERV_STATUS = 1');
    }

    /**
     * Given a service name returns the service
     * record or null if not value found
     * @param string $service_name
     * @param array $service_record
     */
    function getServiceByName($service_name) {
		$x=	ClxCommon::$db->getOneRecord($sql='SELECT * FROM '.$this->tablename. ' WHERE  LOWER(IDNAME) = ' . singleQuote(lowercase($service_name)) . ' AND SERV_STATUS = 1');
//		pre( $sql);
//		echo '===============';
//		PRE($x);
		return $x;
	}

    /**
     * Return server service record only
     *
     * @param string $service_name
     * @return array $service
     */
    function getServerServiceByName($service_name) {
        $service = ClxCommon::$db->getRecord($this->tablename, 'SERVICE_TYPE = ' . singleQuote('SRV') . ' AND IDNAME = ' . singleQuote($service_name), 'SERV_STATUS = 1');
        return $service;
    }

    /**
     * Return server service code only
     *
     * @param string $service_name
     * @return array $service
     */
    function getServerServiceCodeByName($service_name) {
        return ClxCommon::$db->getField($this->tablename, 'IDCODE', 'SERVICE_TYPE = ' . singleQuote('SRV') . '', 'IDNAME = ' . singleQuote($service_name), 'SERV_STATUS = 1');
    }

    /**
     * Evaluates formula of elements
     *
     * @param string $formula
     * @param array &$record
     */
    protected function executeFormula($formula, &$record) {
        if (strlen($formula) > CLX_NUM_ZERO) {
			//$cal = new ClxExpression();
            //$formula = $cal->parseRecordFormula($formula);
			$valorunico=uniqid().rand(1,100).'.php';
			// eventos de un solo uso //creados y eliminados, se mandan a llamar sin ID o nombre de archivo.
			$fileusing=kPathToWebSite."/data/events/uniq_events/".$valorunico;
			$xa=fopen($fileusing,"w+");
			//$formula=str_replace('&quot;',CLX_CHAR_DOUBLE_QUOTE,$formula);
			$formula=html_entity_decode($formula,ENT_QUOTES);
			fwrite($xa,'<'.'?php'.chr(13).chr(10).$formula.chr(13).chr(10).'?>');
			fclose($xa);
			include($fileusing);
			unlink($fileusing);
		}
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $msg_code
     */
    function initJobFormulas($msg_code) {
        $this->formulas = array();
        $sql = 'SELECT DISTINCT SKMP.IDCODE MAP_CODE, SKME.MSG_CODE, SKMP.VAL_FORMULA, SKMP.TABLECODE, SKMP.CLXFIELD_FORMAT FROM CLX_SK_MESSAGES SKMS, CLX_SK_ELEMENTS SKME LEFT JOIN CLX_SK_MAPPINGS SKMP ON SKMP.ELEMENT_CODE = SKME.IDCODE WHERE SKMS.IDCODE = SKME.MSG_CODE AND SKMP.VAL_FORMULA IS NOT null AND SKMP.TABLECODE IS NOT null AND SKMP.TABLECODE <> ' . singleQuote(CLX_CHAR_EMPTY_STRING) . '         AND SKME.MSG_CODE = ' . singleQuote($msg_code) . ' AND SKME.ELE_TYPE <> ' . singleQuote('IGNR') . ' ORDER BY SKME.SEQNUM ASC';
        $results = ClxCommon::$db->executeQuery($sql);		IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' SQL 1005-->'.$sql. chr(13).chr(10)); fclose($kk);}       
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            if (strlen($result['VAL_FORMULA']) > CLX_NUM_ZERO) {
                $this->formulas[$result['TABLECODE']][$result['MAP_CODE']] = $result['VAL_FORMULA'];
            }
        }
		ClxCommon::$db->freeResult($results);
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $msg_code
     * @param unknown_type $response
     * @param unknown_type $load
     */
    function executeProcess($msg_code, $response, $load) {

    }

    /**
     * Enter description here...
     *
     * @param unknown_type $msg_code
     * @param unknown_type $response
     * @param unknown_type $load
     */
    function executeCode($msg_code, &$record) {
        $msg_rec = ClxCommon::$db->getFields('CLX_SK_MESSAGES', 'LIBRARY_CODE,CODE_CALL', 'IDCODE = ' . singleQuote($this->response_code));
        if (!empty($msg_rec['LIBRARY_CODE'])) {
            includeCodeLib($msg_rec['LIBRARY_CODE']);
        }
        if (!empty($msg_rec['CODE_CALL'])) {
            include savePhpCodeEvents('skms_' . $msg_rec['ID'], $msg_rec['CODE_CALL']);
        }
        return null;
    }

    /**
     * Writes message to log
     *
     * @param string $msg
     * @param string $status
     * @return void
     */
    private function logService($msg, $status) {
        if ($this->service_code === true) {
            $SKML = &getTool('SKML');
            $this->log_id = $SKML->report($this->service_code, $msg, $status, $this->log_id);
        }
    }

    /**
     * Returns true if service has request message
     * @param void
     * @return bool $status
     */
    function hasRequest() {
        return !empty($this->request_code);
    }

    /**
     * Returns true if service has response message
     * @param void
     * @return bool $status
     */
    function hasResponse() {
        return !empty($this->request_code);
    }

    /**
     * Get last operation result. Ussually it's an array
     * @param void
     * @return array
     */
    function get_last_operation_result() {
        return $this->a_last_op_result;
    }

    /**
     * Set last operation result. Ussually it's an array
     * @param array
     * @return array
     */
    function set_last_operation_result($a_new_val) {
        $this->a_last_op_result = $a_new_val;
        return $this->a_last_op_result;
    }

    /**
     * Sets tablename to tables properties
     *
     * @param string $tablecode
     */
    function setTableName($tablecode) {
		if (!isset($this->tables[$tablecode])) {
			$trec = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE = ' . singleQuote($tablecode));
			$this->tables[$tablecode] = array('NAME' => $trec['MODULECODE'] . '_' . $trec['IDNAME'], 'REC' => $trec);
		}
	}

    /**
     * Retrieve tablename property
     *
     * @param string $tablecode
     * @return string
     */
    function getTableName($tablecode) {
        if (empty($this->tables[$tablecode])) {
            $this->setTableName($tablecode);
        }
        return $this->tables[$tablecode]['NAME'];
    }

    /**
     * Returns table record
     *
     * @param unknown_type $tablecode
     * @return unknown
     */
    function getTableRecord($tablecode) {
        if (empty($this->tables[$tablecode])) {
            $this->setTableName($tablecode);
        }
        return $this->tables[$tablecode]['REC'];
    }

    /**
     * Parse read only properties and unset value if read only
     *
     * @param string $record_action
     * @param string $readonly_type
     * @param string $fieldname
     * @param array $record
     */
    function executeReadOnly($map_code, $tablecode, $record_action, &$record) {
        if (empty($this->read_only[$map_code][$tablecode]))
            return;
        //Nota: si el criterio esta en el search key entonces no se borra ya que se remplaza en la ejecucion del criterio.
        foreach ($this->read_only[$map_code][$tablecode] as $fieldname => $readonly_type) {
            switch (intval($readonly_type)) {
                case CLX_NUM_ONE://always
                    unset($record[$fieldname]); //always
                    break;
                case CLX_NUM_TWO:
                    if ($record_action === 'CREATE') {
                        unset($record[$fieldname]); //always
                    }
                    break;
                case CLX_NUM_THREE://on modify
                    if ($record_action === 'MODIFY') {
                        unset($record[$fieldname]); //always
                    }
                    break;
                default:
                    break;
            }//end switch
        }
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $map_code
     * @param unknown_type $tablecode
     * @param unknown_type $criterias
     * @param unknown_type $record_action
     * @param unknown_type $record
     */
    function restoreReadOnly($map_code, $tablecode, $criterias, $record_action, &$record) {
        if (empty($this->read_only[$map_code][$tablecode]))
            return;
        $fields = array();
        $tablename = $this->getTableName($tablecode);
        //Nota: si el criterio esta en el search key entonces no se borra ya que se remplaza en la ejecucion del criterio.
        foreach ($this->read_only[$map_code][$tablecode] as $fieldname => $readonly_type) {
            switch (intval($readonly_type)) {
                case CLX_NUM_ONE://always
                    $fields[] = $fieldname;
                    break;
                case CLX_NUM_TWO:
                    if ($record_action === 'CREATE') {
                        $fields[] = $fieldname;
                    }
                    break;
                case CLX_NUM_THREE://on modify
                    if ($record_action === 'MODIFY') {
                        $fields[] = $fieldname;
                    }
                    break;
                default:
                    break;
            }//end switch
        }
        if (!empty($fields)) {
            $sql = 'SELECT ' . implode(', ', $fields) . ' FROM ' . $tablename;
            if ($criterias <> '') {
                $sql .=' WHERE ' . $criterias;
            }
            $r = ClxCommon::$db->getOneRecord($sql);
            if (!empty($r)) {
                $record = array_merge($record, $r);
            }
        }
    }

    /**
     * Count record based on search keys and return true if record found
     * If record is found then the key will be replaced with found element
     *
     * @param string $record_action
     * @param string $readonly_type
     * @param string $fieldname
     * @param array $record
     */
    function executeSearchKeys($map_code, $tablecode, &$record, &$criterias) {
        if (empty($this->search_key[$map_code][$tablecode]))
            return false;
        $tablename = $this->getTableName($tablecode);
        $criterias = '';
        $comma = '';
        foreach ($this->search_key[$map_code][$tablecode] as $fieldname => $val) {
            $criterias .= $comma . $fieldname . '=' . singleQuote($record[$fieldname]);
            $comma = ' AND ';
        }
        $qty = ClxCommon::$db->oneExistsRecords($tablename, $criterias);
        return ($qty > CLX_NUM_ZERO) ? true : false;
    }

    /**
     * returns action status to initial values
     *
     */
    function initActionStatus() {
        $this->setActionStatus();
        $this->action_message_recid = array();
    }

    /**
     * Set the default status for response
     *
     * @param Integer $statuscode 0 implies ok
     * @param String $message
     */
    function setActionStatus($statuscode = CLX_NUM_ZERO, $message = '') {
        $this->action_message_code = $statuscode;
        $this->action_message = $message;
    }

    /**
     *
     * @param $record_id
     */
    function setActionId($record_id = CLX_NUM_ZERO) {
        if ($record_id <> CLX_NUM_ZERO) {
            $this->action_message_recid[] = $record_id;
        }
    }

    /**
     * Return status message
     *
     * @return integer
     */
    function getActionStatusCode() {
        return $this->action_message_code;
    }

    /**
     * Returns status message
     *
     * @return String
     */
    function getActionStatusMessage() {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        return $this->action_message;
    }

    /**
     * Returns status message
     *
     * @return String
     */
    function getActionRecordId() {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        return implode(',', $this->action_message_recid);
    }

    function reportError($errorMsg, $parameters, $dielevel = CLX_NUM_ONE) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        $request = array('script' => 'Webservice',
            'binds' => '',
            'request' => $parameters);
        $BUGS = getTool('BUGS');
        if (!empty($BUGS)) {
            $BUGS->report(E_USER_ERROR, $errorMsg, UserRequest::$server['SCRIPT_NAME'], 'unknown line', $request, $dielevel, '');
        }
    }

    /**
     * Replace none xml parsable characters
     * @param mixed $value
     */
    function clearXmlSpecialChars($value) {IF ($GLOBALS['DEBUG_SK_SERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}       
        if (!is_string($value)) {
            return $value;
        } else {
            $value = str_replace('&', '&amp;', $value);
            $value = str_replace('>', '&gt;', $value);
            $value = str_replace('<', '&lt;', $value);
            return $value;
        }
    }

}

// End class
