<?php

/**
 * ui_view_prefs
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version    	$Rev: 9615 $
 *
 * CHANGE LOG
 *  Included label
 *  Oracle uppercase record changed
 */
class ui_view_prefs extends clx_tool {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'UIVP';
        $this->name = 'View Preferences';
        $this->system = 'Interface';
        $this->version = '0.1.0.0';
        $this->accesskey = 'UIVW';



        $this->tablename = 'CLX_UI_VIEW_PREFS';
        $this->record_name_singular = 'view preference';
        $this->record_name_plural = 'view preferences';
        $this->primary_field = 'username';
        $this->secondary_field = 'QUERYCODE';
        $this->seqnum_field = 'SEQNUM';
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['QUERYCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
        $fields['USERNAME'] = array('type' => 'varchar(30)', 'null' => 'NO', 'properties' => '');
        $fields['VIEWID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'VIEWID,QUERYCODE,USERNAME');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
		  'fields' => $fields,
		  'indexes' => $indexes);
    }

//--  V I E W  P R E F E R E N C E S
    // Incredible, isn\'t it?
}
