<?php

/**
 * ui_view_sorts
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version    	$Rev: 9615 $
 *
 * CHANGE LOG
 *  Included label
 *  Oracle uppercase record changed
 */
class ui_view_sorts extends clx_tool {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'UIVS';
        $this->name = 'View Sorts';
        $this->system = 'Interface';
        $this->version = '0.1.1.0';
        $this->accesskey = 'UIVW';



        $this->tablename = 'CLX_UI_VIEW_SORTS';
        $this->record_name_singular = 'view sort';
        $this->record_name_plural = 'view sorts';
        $this->primary_field = 'VIEWID';
        $this->secondary_field = 'FIELDNAME';
        $this->seqnum_field = 'SEQNUM';
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['VIEWID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['FIELDID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $fields['TABLECODE'] = array('type' => 'varchar(4)', 'null' => 'YES', 'properties' => '');
        $fields['FIELDNAME'] = array('type' => 'varchar(64)', 'null' => 'YES', 'properties' => '');
        $fields['DIRECTION'] = array('type' => 'varchar(4)', 'properties' => '');
        $fields['SEQNUM'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'MUL', 'fieldname' => 'VIEWID');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'FIELDID');
        $indexes[$ipf . '04'] = array('index' => 'MUL', 'fieldname' => 'TABLECODE');
        $indexes[$ipf . '05'] = array('index' => 'MUL', 'fieldname' => 'FIELDNAME');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB',
		  'fields' => $fields,
		  'indexes' => $indexes);
    }

}
