<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author	   $Author: jclerma $
 * @copyright	Alenet, Inc.
 * @since		$Date: 2017-11-03 06:14:01 -0400 (vie., 03 nov. 2017) $
 * @version		$Rev: 9613 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Filo {

    var $batch_id = '';
    var $username = '';
    var $now = '';
    var $today = '';
    var $je_source = '';
    var $display = false;
    var $filsrec = array(); //store credit schedule fields

    /**
     * Contructor
     *
     * @param array $procParameters
     * @return void
     */

    function __construct($procParameters = array()) {
        multiTableName($this, array('FILO', 'CSCT', 'INFA', 'JEHD', 'GLAC', 'GLAG', 'COMP', 'INFU', 'INVT', 'FIAS', 'CSVW', 'JELN', 'TTPA', 'FIBK', 'GLCP', 'JABV', 'FIGN', 'FTMP', 'FIAT', 'FITB', 'FITS', 'JEIT', 'JELN', 'OPBV', 'LEDG', 'INFU', 'PTMP', 'FICO', 'FIPA', 'ININ', 'INPR', 'GLCP', 'INTL', 'INFH', 'INAT', 'JCBV', 'INDX', 'PRLT', 'PRAT', 'PROD', 'CURR', 'GLT1', 'CURR', 'FILS', 'GLPF', 'CRCL', 'LEBA', 'CREB', 'PRLM', 'ACCO', 'JECA', 'CVID', 'GDVW'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->today = xFormat::getNow('Y-m-d');
        $this->je_source = '';
    }

    /**
     * Initialice fiat form - Executed on init event
     *
     * @param array $record
     */
    function init_form(&$record) {
        if ((UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'DUPLICATE_EFFTDATE') && empty(UserRequest::$post['confirm'])) {
            if (!class_exists('Comp')){
                includeCodeLib('COMP');
            }
            $comp = new Comp();
            $comprec = $comp->comp_operation_parameters($record['FILO_COMP_CODE']);
            $record['FILO_START_DATE'] = $comprec['OPERATION_DATE'];
            $record['FILO_BALLOON_SDATE'] = $comprec['OPERATION_DATE'];
            $record['FILO_CLX_EFFTDATE'] = $this->today;
            //Refinanciamiento debe comensar en 0 el usuario lo cambia en pantalla al modificar con fecha efectiva lo que inicia el cronograma
            $record['FILO_REFINANCED'] = CLX_INIT_ZERO;
            $record['FILO_REFINANCED_DATE'] = '';
            $record['FILO_FIRST_PYMNT_DATE'] = $comprec['OPERATION_DATE'];
            $record['FILO_PAY_DAY'] = intval(xFormat::date($record['FILO_FIRST_PYMNT_DATE'], 'd'));
            $record['FILO_COUNTRY'] = $comprec['COUNTRY'];

        }
    }

    /**
     * Initialice form - Executed on init event
     *
     * @param array $record
     */
    function load_form(&$record) {
        if (!class_exists('Comp')) {
            includeCodeLib('COMP');
        }
        $comp = new Comp();
        $comprec = $comp->comp_operation_parameters($record['FILO_COMP_CODE']);
        if ((UserRequest::$request['ac'] === 'DUPLICATE') && empty(UserRequest::$post['confirm'])) {
            $record['FILO_IDCODE'] = 'AUTO';
            $record['FILO_START_DATE'] = $comprec['OPERATION_DATE'];
            $record['FILO_BALLOON_SDATE'] = $comprec['OPERATION_DATE'];
            $record['FILO_CLX_AUTH_STATUS'] = 'PEND';
            $record['FILO_LOAN_STATUS'] = 'PRE';
            $record['FILO_LOAN_AMT'] = CLX_INIT_ZERO;
            $record['FILO_DOWN_PYMT_AMT'] = CLX_INIT_ZERO;
            $record['FILO_PRINCIPAL_BAL'] = CLX_INIT_ZERO;
            $record['FILO_INTEARNED_AMT'] = CLX_INIT_ZERO;
            $record['FILO_INTPAID_AMT'] = CLX_INIT_ZERO;
        }
        if ((UserRequest::$request['ac'] === 'MODIFY_DISABLED' || UserRequest::$request['ac'] === 'DUPLICATE')) {
            //Importante mantener la fecha de la contabilidad
            //ya que al salvar el registro de filo
            //genera linea de devengo para fecha seleccionada
            $record['FILO_CLX_EFFTDATE'] = xFormat::getNow('Y-m-d');
        } elseif (UserRequest::$request['ac'] === 'DUPLICATE_EFFTDATE') {
            $record['FILO_CLX_EFFTDATE'] = xFormat::getNow('Y-m-d');
        }
        if (UserRequest::$request['ac'] !== 'CREATE') {
            $sql = 'SELECT FIAS.CONTRACT_CODE, FIAS.ACCOUNTCODE, FIPA.IDCODE PARTICIPANT_ID_prim, FIPA.ACCOUNTCODE PARTICIPANT_ID_secd, FIPA.CONTRACT_CODE PARTICIPANT_ID_terc FROM ' . $this->fiasname . ' FIAS LEFT JOIN ' . $this->fipaname . ' FIPA ON FIPA.CONTRACT_CODE = FIAS.CONTRACT_CODE AND FIPA.ACCOUNTCODE = FIAS.ACCOUNTCODE WHERE FIAS.LOAN_CODE = ' . singleQuote($record['FILO_IDCODE']);
            $fiasrec = ClxCommon::$db->getOneRecord($sql);
            $record['FILO_CONTRACT_CODE'] = $fiasrec['CONTRACT_CODE'];
            if (!empty($fiasrec['PARTICIPANT_ID_prim'])) {
                $record['FILO_PARTICIPANT_ID'] = $fiasrec['ACCOUNTCODE'];
                $record['FILO_PARTICIPANT_ID_prim'] = $fiasrec['PARTICIPANT_ID_prim'];
                $record['FILO_PARTICIPANT_ID_secd'] = $fiasrec['PARTICIPANT_ID_secd'];
                $record['FILO_PARTICIPANT_ID_terc'] = $fiasrec['PARTICIPANT_ID_terc'];
            } else {
                $record['FILO_PARTICIPANT_ID'] = $fiasrec['ACCOUNTCODE'];
            }
        }
        //Setting reserve index
        if ($record['FILO_RESERVE_INDEX'] !== 'N/A') {
            $record['FILO_RESERVE_INDX_PCT'] = rounder($record['FILO_LOAN_INTEREST'] - $record['FILO_RESERVE_PCT'], CLX_NUM_FIVE);
        } else {
            $record['FILO_RESERVE_INDX_PCT'] = '0.00000';
        }
        //set balloon payment
        $record['FILO_BALLOON_AMT'] = rounder($record['FILO_BALLOON_PAY_AMT'] * $record['FILO_BALLOON_PAYMENTS'], CLX_NUM_TWO);
        //Set Requested amount (derived)
        //Setting Class Information BDA Only
        if (!empty($record['FILO_GUARANTEE_01_TYPE'])) {
            $record['FILO_GUARANTEE_01_CLASS'] = ClxCommon::$db->getField('CLX_DB_LIST_ITEMS', 'PARENTITEM', 'LISTCODE = ' . singleQuote('RETY') . ' AND IDCODE = ' . singleQuote($record['FILO_GUARANTEE_01_TYPE']));
        }
        //Setting Class Information BDA Only
        if (!empty($record['FILO_GUARANTEE_02_TYPE'])) {
            $record['FILO_GUARANTEE_02_CLASS'] = ClxCommon::$db->getField('CLX_DB_LIST_ITEMS', 'PARENTITEM', 'LISTCODE = ' . singleQuote('RETY') . ' AND IDCODE = ' . singleQuote($record['FILO_GUARANTEE_02_TYPE']));
        }
        //Set product fees information
        if (!empty($record['FILO_PRODUCT_CODE'])) {
            $sql = 'SELECT IDNAME, SEQNUM, FEE_FORMULA FROM ' . $this->glpfname . ' WHERE PRODUCT_CODE = ' . singleQuote($record['FILO_PRODUCT_CODE']) . ' AND STATUS = ' . singleQuote('A') . ' ORDER BY SEQNUM ASC';
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $i = $r['SEQNUM'];
                $lbl = '';
                if (substr($r['FEE_FORMULA'], CLX_NUM_ZERO, CLX_NUM_ONE) === 'P')
                    $lbl = '% ';
                $record['FILO_FEE_0' . $i . '_NAME'] = $lbl . $r['IDNAME'];
            }
        }
        //Loading Installment Information
        //Ver registro de credito en funcion de fecha de operacion
        //Observar que el cliente debe ir con fecha del dia para poder ver
        //en que couta esta.
        $this->today = $comprec['OPERATION_DATE'];
        //Getting Installment Information
        $sql = 'SELECT PRINCIPAL_PAY, INTEREST_PAY, RESERVE_PAY, FEES_AMT, PAYMENT_AMT, DAILY_INTEREST, DAILY_RESERVE, PERIOD_START_DATE, PERIOD_END_DATE, DUE_PAY_DATE, PAID_AMT, INSTALLMENT_NO FROM ' . $this->filsname . ' WHERE LOAN_CODE = ' . singleQuote($record['FILO_IDCODE']) . ' AND EFFTDATE=' . singleQuote($record['FILO_CLX_EFFTDATE']) . ' AND PERIOD_START_DATE <= ' . singleQuote($this->today) . ' AND PERIOD_END_DATE >= ' . singleQuote($this->today);
        $filvrec = ClxCommon::$db->getOneRecord($sql);
        if (!empty($filvrec)) {
            foreach ($filvrec as $key => $val) {
                $record['FILO_' . $key] = $val;
            }
        }
        //Getting Paid Information
        $sql = 'SELECT SUM(PAID_AMT) PAID_AMT FROM ' . $this->filsname . ' WHERE LOAN_CODE = ' . singleQuote($record['FILO_IDCODE']) . ' AND EFFTDATE=' . singleQuote($record['FILO_CLX_EFFTDATE']);
        $filvrec = ClxCommon::$db->getOneRecord($sql);
        if (!empty($filvrec)) {
            if ($record['FILO_PAYMENT_AMT'] <= $filvrec['PAID_AMT']) {
                $record['FILO_DUE_BAL_AMT'] = no_format(CLX_NUM_ZERO, CLX_NUM_TWO);
            } else {
                $record['FILO_DUE_BAL_AMT'] = no_format($record['FILO_PAYMENT_AMT'] - $filvrec['PAID_AMT'], CLX_NUM_TWO);
            }
        }
    }

    /**
     * Validate record information
     * Executed on table validate
     *
     * @param array $record
     * @param array $msg
     * @return boolean
     */
    function validate_form(&$record, &$msg) {
       if (UserRequest::$request['ac'] === 'DELETE' ) {
            $sql = 'SELECT IDCODE, LOAN_STATUS FROM ' . $this->filoname . ' WHERE ID=' . singleQuote($record['idlist']);
            $reg = ClxCommon::$db->getOneRecord($sql);
            $record['FILO_IDCODE']=$reg['IDCODE'];
            $record['FILO_LOAN_STATUS']=$reg['LOAN_STATUS'];

             if ($record['FILO_LOAN_STATUS'] != 'PRE'){
                 $msg['FILO_LOAN_STATUS'] = smsg('MSG-202', $record['FILO_IDCODE']);
                 addMessage($msg['FILO_LOAN_STATUS']);
                 return false;
             }else{
                 return true;
             }    
        }
        $record['FILO_LOAN_AMT'] = str_replace(',', '', $record['FILO_LOAN_AMT']);
        //Si evento es crear el codigo no debe existir no importa la fecha efectivo
        if (UserRequest::$request['ac'] === 'CREATE') {
            if (ClxCommon::$db->countRecords($this->filoname, 'IDCODE = ' . singleQuote($record['FILO_IDCODE'])) > CLX_NUM_ZERO) {
                $msg['FILO_IDCODE'] = smsg('MSG-320');
                return false;
            }
        }
        if (UserRequest::$request['ac'] !== 'DUPLICATE_EFFTDATE' && $record['FILO_LOAN_STATUS'] !== 'PRE') {

        }
	
        /*$sql = "SELECT COUNT(*) FROM " . $this->fiasname . " WHERE EXT_PRODUCT_CODE = " . singleQuote($record['FILO_EXT_PRODUCT_CODE']) . " AND LOAN_CODE IS NOT NULL AND LOAN_CODE <> " . singleQuote('') . " AND TRUST_ITEM_TYPE = " . singleQuote('CR') . (UserRequest::$request['ac'] === 'MODIFY'? " AND LOAN_CODE <> " . singleQuote($record['FILO_IDCODE']) : "");
        
        if (ClxCommon::$db->getOne($sql) > 0 && UserRequest::$request['ac'] !== 'REQAUTHORIZATION') {
            $msg['FILO_EXT_PRODUCT_CODE'] = smsg('MSG-531');
            return false;
        }*/

        if(!empty($record['FILO_CRED_LINE_CODE'])){
            if(ClxCommon::$db->countRecords($this->crclname, 'IDCODE = ' . singleQuote($record['FILO_CRED_LINE_CODE']), 'COMP_CODE = ' . singleQuote($record['FILO_COMP_CODE']), 'ACCOUNTCODE = ' . singleQuote($record['FILO_DEBTOR_CODE'])) <= CLX_NUM_ZERO){
                $msg['FILO_DEBTOR_CODE'] = smsg('MSG-515');
                return false;
            }
        }

        //   Se levanto por el caso de Global, que no calcula interes pero la tasa la deben mantener para efectos de documentacion para tomos
        //Validacion de que la moneda de la linea de credito coincida con la moneda del credito
        //Validando restructuracion
        if (@$record['FILO_REFINANCED'] == CLX_NUM_ONE && round(($record['FILO_INTEARNED_AMT'] - $record['FILO_INTPAID_AMT']), CLX_NUM_TWO) <> CLX_NUM_ZERO) {
            $msg['FILO_REFINANCED'] = smsg('MSG-340');
            return false;
        }
        //Validar monto de couta bomba. Monto por cuotaas no puede ser mayor a monto de credito
        //MSG-253 parametro monto de couta balon.
        $record['FILO_BALLOON_AMT'] = rounder($record['FILO_BALLOON_PAY_AMT'] * $record['FILO_BALLOON_PAYMENTS'], CLX_NUM_TWO);
        if (($record['FILO_BALLOON_PAY_AMT'] > CLX_NUM_ZERO && $record['FILO_BALLOON_AMT'] == CLX_NUM_ZERO) || ($record['FILO_BALLOON_AMT'] > $record['FILO_LOAN_AMT'])) {
            $msg['FILO_BALLOON_AMT'] = smsg('MSG-253', $record['FILO_BALLOON_AMT'], $record['FILO_IDCODE']);
        }
        $prlt = ClxCommon::$db->getFields($this->prltname, 'HAS_DEDCTBLE, DEF_DEDCTBLE_PCT', 'PRODUCT_CODE = ' . singleQuote($record['FILO_PRODUCT_CODE']));
        if (!empty($prlt['HAS_DEDCTBLE']) && $record['FILO_DEDUCTIBLE_AMT'] == CLX_NUM_ZERO) {
            $sql = 'SELECT COUNT(FILO.ID) FROM ' . $this->filoname . ' FILO WHERE FILO.DEBTOR_CODE = ' . singleQuote($record['FILO_DEBTOR_CODE']) . ' AND FILO.COMP_CODE = ' . singleQuote($record['FILO_COMP_CODE']) . ' AND FILO.LOAN_STATUS IN (' . singleQuoteArray(array('MOR', 'LIT', 'CAS')) . ') AND FILO.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM ' . $this->filoname . ' X WHERE X.IDCODE = FILO.IDCODE) AND FILO.PRINCIPAL_BAL>0';
            if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
                $record['FILO_DEDUCTIBLE_AMT'] = rounder(($record['FILO_REQUESTED_AMT'] * ($prlt['DEF_DEDCTBLE_PCT'] / CLX_NUM_HUNDRED)), CLX_NUM_TWO);
                $record['FILO_DEDCTBLE_PCT'] = $prlt['DEF_DEDCTBLE_PCT'];
                $msg['FILO_DEDUCTIBLE_PCT'] = smsg('MSG-312');
                $msg['FILO_DEDUCTIBLE_AMT'] = $msg['FILO_DEDUCTIBLE_PCT'];
            }
        }
        //Validating restructure MSG-318
        if (UserRequest::$request['ac'] === 'DUPLICATE_EFFTDATE' && $record['FILO_REFINANCED'] == CLX_NUM_ONE) {
            $operation_date = ClxCommon::$db->getField($this->glcpname, 'OPERATION_DATE', 'COMP_CODE = ' . singleQuote($record['FILO_COMP_CODE']));
            if ($operation_date <> $record['FILO_START_DATE']) {
                $msg['FILO_START_DATE'] = smsg('MSG-318', $operation_date);
            }
        }
        //validando que linea de credito se encuentre aprobada
        if (!empty($record['FILO_CRED_LINE_CODE'])) {
            if (ClxCommon::$db->countRecords($this->crclname, 'IDCODE = ' . singleQuote($record['FILO_CRED_LINE_CODE']) . ' AND CURRENCY_CODE = ' . singleQuote($record['FILO_CURRENCY_CODE'])) == CLX_NUM_ZERO) {
                $msg['FILO_CRED_LINE_CODE'] = smsg('MSG-392');
            }
        }
        if (UserRequest::$request['ac'] === 'REQAUTHORIZATION') {
            //Validating beneficiary on approval
            $a = ClxCommon::$db->countRecords($this->prltname, 'PRODUCT_CODE = ' . singleQuote($record['FILO_PRODUCT_CODE']) . ' AND REQ_BENEFICIARY=1');
            $b = ClxCommon::$db->countRecords($this->crebname, 'LOAN_CODE = ' . singleQuote($record['FILO_IDCODE']));
            if ($a > CLX_NUM_ZERO && empty($b)) {
                $msg['FILO_IDCODE'] = smsg('MSG-175', $record['FILO_IDCODE']);
            }
            if ($a > CLX_NUM_ZERO && !empty($b)) {
                //testing benefifiario limits
                $sql = 'SELECT DISTINCT CREB.IDENTIFICATION, CREB.FULLNAME FROM ' . $this->crebname . ' CREB  WHERE CREB.LOAN_CODE = ' . singleQuote($record['FILO_IDCODE']) . ' AND CREB.EQ_GRACE_PERIODS <> ' . singleQuote($record['FILO_EQ_GRACE_PERIODS']) . ' AND CREB.EFFTDATE = (SELECT MAX(X.EFFTDATE) FROM ' . $this->crebname . ' X WHERE X.IDENTIFICATION = CREB.IDENTIFICATION AND X.LOAN_CODE = CREB.LOAN_CODE AND X.EFFTDATE<=' . singleQuote($record['FILO_CLX_EFFTDATE']) . ')';
                $rs = ClxCommon::$db->executeQuery($sql);
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    if (!array_key_exists('FILO_EQ_GRACE_PERIODS', $msg)) {
                        $msg['FILO_EQ_GRACE_PERIODS'] = '';
                    }
                    $msg['FILO_EQ_GRACE_PERIODS'] .= smsg('MSG-182', $record['FILO_EQ_GRACE_PERIODS'], $r['FULLNAME'], $r['IDENTIFICATION']) . '<br>';
                }
                $sql = 'SELECT DISTINCT CREB.IDENTIFICATION, CREB.FULLNAME FROM ' . $this->crebname . ' CREB WHERE CREB.LOAN_CODE = ' . singleQuote($record['FILO_IDCODE']) . ' AND (CREB.LOAN_PERIOD <> ' . singleQuote($record['FILO_LOAN_PERIOD']) . ') AND CREB.EFFTDATE = (SELECT MAX(X.EFFTDATE) FROM ' . $this->crebname . ' X WHERE X.IDENTIFICATION = CREB.IDENTIFICATION AND X.LOAN_CODE = CREB.LOAN_CODE AND X.EFFTDATE<=' . singleQuote($record['FILO_CLX_EFFTDATE']) . ')';
                $rs = ClxCommon::$db->executeQuery($sql);
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    if (!array_key_exists('FILO_LOAN_PERIOD', $msg)) {
                        $msg['FILO_LOAN_PERIOD'] = '';
                    }
                    $msg['FILO_LOAN_PERIOD'] .= smsg('MSG-183', $record['FILO_LOAN_PERIOD'], $r['FULLNAME'], $r['IDENTIFICATION']) . '<br>';
                }
                //Testing beneficiary loan amount vs credit loan amount
                $sql = 'SELECT SUM(CREB.LOAN_AMT) LOAN_AMT FROM ' . $this->crebname . ' CREB WHERE CREB.LOAN_CODE = ' . singleQuote($record['FILO_IDCODE']) . ' AND CREB.EFFTDATE = (SELECT MAX(X.EFFTDATE) FROM ' . $this->crebname . ' X WHERE X.IDENTIFICATION = CREB.IDENTIFICATION AND X.LOAN_CODE = CREB.LOAN_CODE AND X.EFFTDATE<=' . singleQuote($record['FILO_CLX_EFFTDATE']) . ')';
                if ($record['FILO_LOAN_AMT'] != ClxCommon::$db->getOne($sql)) {
                    $msg['FILO_LOAN_AMT'] = smsg('MSG-197', rounder($record['FILO_LOAN_AMT'], CLX_NUM_TWO));
                }
            }
            $operation_date = ClxCommon::$db->getField($this->glcpname, 'OPERATION_DATE', 'COMP_CODE=' . singleQuote($record['FILO_COMP_CODE']));
            if ($record['FILO_START_DATE'] > $operation_date) {
                $msg['FILO_START_DATE'] = smsg('MSG-190', $record['FILO_IDCODE'], $operation_date);
            }
            //validando que linea de credito se encuentre aprobada
            if (!empty($record['FILO_CRED_LINE_CODE'])) {
                if (ClxCommon::$db->countRecords($this->crclname, 'CLX_AUTH_STATUS = ' . singleQuote('AP') . ' AND IDCODE = ' . singleQuote($record['FILO_CRED_LINE_CODE'])) == CLX_NUM_ZERO) {
                    $msg['FILO_IDCODE'] = smsg('MSG-199');
                }
            }
            //Validanciones de tabla de amotirzacion
            return (count($msg) > CLX_NUM_ZERO) ? false : true;
        } //end if authorization
        //Validating interest
        if ($record['FILO_CALC_INTEREST'] == CLX_NUM_ONE && $record['FILO_INTEREST_TYPE'] === 'FIX' && $record['FILO_ADJ_INDEX'] !== 'N/A') {
            $msg['FILO_ADJ_INDEX'] = smsg('MSG-146', $record['FILO_IDCODE']);
        }
        if ($record['FILO_CALC_INTEREST'] == CLX_NUM_ONE && $record['FILO_INTEREST_TYPE'] === 'FIX' && $record['FILO_ADJ_POINTS_OVERINDEX'] != CLX_NUM_ZERO) {
            $msg['FILO_ADJ_POINTS_OVERINDEX'] = smsg('MSG-146', $record['FILO_IDCODE']);
        }
        if ($record['FILO_CALC_INTEREST'] == CLX_NUM_ONE && $record['FILO_INTEREST_TYPE'] === 'FIX' && $record['FILO_ADJ_PATTERN'] !== '') {
            $msg['FILO_ADJ_PATTERN'] = smsg('MSG-146', $record['FILO_IDCODE']);
        }
        if ($record['FILO_CALC_INTEREST'] == CLX_NUM_ONE && $record['FILO_INTEREST_TYPE'] === 'FIX' && $record['FILO_LOAN_INTEREST'] == CLX_NUM_ZERO) {
            $msg['FILO_LOAN_INTEREST'] = smsg('MSG-147', $record['FILO_IDCODE']);
        }
        //test variable
        if ($record['FILO_CALC_INTEREST'] == CLX_NUM_ONE && $record['FILO_INTEREST_TYPE'] === 'VAR' && $record['FILO_ADJ_INDEX'] === 'N/A') {
            $msg['FILO_ADJ_INDEX'] = smsg('MSG-148', $record['FILO_IDCODE']);
        }
        if ($record['FILO_CALC_INTEREST'] == CLX_NUM_ONE && $record['FILO_INTEREST_TYPE'] === 'VAR' && strlen($record['FILO_ADJ_POINTS_OVERINDEX']) == CLX_NUM_ZERO) {
            $msg['FILO_ADJ_POINTS_OVERINDEX'] = smsg('MSG-148', $record['FILO_IDCODE']);
        }
        //Si interes es variable solicitar recurrencia de evaluacion de indice
        if ($record['FILO_CALC_INTEREST'] == CLX_NUM_ONE && $record['FILO_INTEREST_TYPE'] === 'VAR' && strlen($record['FILO_ADJ_PATT_PERIOD']) == CLX_NUM_ZERO) {
            $msg['FILO_ADJ_PATT_PERIOD'] = smsg('MSG-242', $record['FILO_IDCODE']);
        }
        if ($record['FILO_CALC_INTEREST'] == CLX_NUM_ONE && $record['FILO_INTEREST_TYPE'] === 'VAR' && empty($record['FILO_ADJ_PATTERN'])) {
            $msg['FILO_ADJ_PATTERN'] = smsg('MSG-242', $record['FILO_IDCODE']);
        }
        if ($record['FILO_CALC_INTEREST'] == CLX_NUM_ONE && $record['FILO_INTEREST_TYPE'] === 'FIX' && $record['FILO_ADJ_PATT_PERIOD'] != CLX_NUM_ZERO) {
            $msg['FILO_ADJ_PATT_PERIOD'] = smsg('MSG-243', $record['FILO_IDCODE']);
        }
        if ($record['FILO_CALC_INTEREST'] == CLX_NUM_ONE && $record['FILO_INTEREST_TYPE'] === 'FIX' && !empty($record['FILO_ADJ_PATTERN'])) {
            $msg['FILO_ADJ_PATTERN'] = smsg('MSG-243', $record['FILO_IDCODE']);
        }
        if ($record['FILO_ADJ_INDEX'] !== 'N/A') {
            $sql = 'SELECT COUNT(ID) FROM ' . $this->indxname . '  WHERE ADJ_INDEX = ' . singleQuote($record['FILO_ADJ_INDEX']) . ' AND CLX_EFFTDATE<=' . singleQuote($record['FILO_CLX_EFFTDATE']) . ' LIMIT 1';
            if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
                $msg['FILO_ADJ_INDEX'] = smsg('MSG-149', $record['FILO_ADJ_INDEX'], $record['FILO_CLX_EFFTDATE']);
            }
        }
        //Validar que definicion contable y de parametros exista
        $sql = 'SELECT COUNT(ID) FROM ' . $this->pratname . '  WHERE PRODUCT_CODE = ' . singleQuote($record['FILO_PRODUCT_CODE']);
        if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
            $msg['FILO_PRODUCT_CODE'] = smsg('MSG-150', $record['FILO_PRODUCT_CODE']);
        }
        //Validar contrato, si no tiene contrato por defecto en producto
        $sql = 'SELECT CHART_FIELD01 FROM ' . $this->prltname . '  WHERE PRODUCT_CODE = ' . singleQuote($record['FILO_PRODUCT_CODE']);
        $prat_chart_field01 = ClxCommon::$db->getOne($sql);
        if (empty(UserRequest::$post['FILO_CONTRACT_CODE']) && $prat_chart_field01 === '') {
            $msg['FILO_CONTRACT_CODE'] = smsg('MSG-151', $record['FILO_CONTRACT_CODE']);
        }
        if (!empty(UserRequest::$post['FILO_CONTRACT_CODE'])) {
            $contract_code = UserRequest::$post['FILO_CONTRACT_CODE'];
        } else {
            $contract_code = $prat_chart_field01;
        }
        //Validar Crédito sea Estatus Activo
        $sql = 'SELECT STATUS FROM ' . $this->prodname . ' WHERE IDCODE = ' . singleQuote($record['FILO_PRODUCT_CODE']);
        $statusProducto = ClxCommon::$db->getOne($sql);
        if ($statusProducto === 'I') {
            $msg['FILO_PRODUCT_CODE'] = smsg('MSG-405');
        }

        //Validate contract vs company should match
        $sql = 'SELECT COUNT(COMP_CODE) FROM ' . $this->ficoname . '  WHERE IDCODE = ' . singleQuote($contract_code) . ' AND COMP_CODE = ' . singleQuote($record['FILO_COMP_CODE']);
        if (ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
            $msg['FILO_CONTRACT_CODE_prim'] = smsg('MSG-151', $record['FILO_COMP_CODE'] . '.' . $record['FILO_CONTRACT_CODE']);
        }
        if ($record['FILO_EQ_GRACE_PERIODS'] > CLX_NUM_ZERO && $record['FILO_NO_PAYMENTS'] <= $record['FILO_EQ_GRACE_PERIODS']) {
            $msg['FILO_EQ_GRACE_PERIODS'] = smsg('MSG-167');
        }
        if ($record['FILO_ADJ_PATTERN'] !== '' && $record['FILO_ADJ_PATT_PERIOD'] == CLX_NUM_ZERO) {
            $msg['FILO_ADJ_PATT_PERIOD'] = smsg('MSG-168');
        }
        if ($record['FILO_FEE_01_FIN_PER'] > CLX_NUM_ZERO && $record['FILO_NO_PAYMENTS'] < $record['FILO_FEE_01_FIN_PER']) {
            $msg['FILO_FEE_01_FIN_PER'] = smsg('MSG-393', $record['FILO_NO_PAYMENTS']);
        }
        if ($record['FILO_FEE_02_FIN_PER'] > CLX_NUM_ZERO && $record['FILO_NO_PAYMENTS'] < $record['FILO_FEE_02_FIN_PER']) {
            $msg['FILO_FEE_02_FIN_PER'] = smsg('MSG-394', $record['FILO_NO_PAYMENTS']);
        }
        if ($record['FILO_FEE_03_FIN_PER'] > CLX_NUM_ZERO && $record['FILO_NO_PAYMENTS'] < $record['FILO_FEE_03_FIN_PER']) {
            $msg['FILO_FEE_03_FIN_PER'] = smsg('MSG-395', $record['FILO_NO_PAYMENTS']);
        }
        if ($record['FILO_FEE_04_FIN_PER'] > CLX_NUM_ZERO && $record['FILO_NO_PAYMENTS'] < $record['FILO_FEE_04_FIN_PER']) {
            $msg['FILO_FEE_04_FIN_PER'] = smsg('MSG-396', $record['FILO_NO_PAYMENTS']);
        }
        if ($record['FILO_FEE_05_FIN_PER'] > CLX_NUM_ZERO && $record['FILO_NO_PAYMENTS'] < $record['FILO_FEE_05_FIN_PER']) {
            $msg['FILO_FEE_05_FIN_PER'] = smsg('MSG-397', $record['FILO_NO_PAYMENTS']);
        }
        //Line of credit validation
        $sql = 'SELECT COUNT(CRCL.ID) QTY, MAX(CRCL.LINE_AMT) LIMIT_AMT FROM ' . $this->crclname . ' CRCL WHERE CRCL.ACCOUNTCODE = ' . singleQuote($record['FILO_DEBTOR_CODE']) . ' AND CRCL.PRODUCT_CODE = ' . singleQuote($record['FILO_PRODUCT_CODE']) . ' AND CRCL.CLX_EFFTDATE = (SELECT MAX(CRCLX.CLX_EFFTDATE) FROM ' . $this->crclname . ' CRCLX WHERE CRCLX.ACCOUNTCODE = ' . singleQuote($record['FILO_DEBTOR_CODE']) . ' AND CRCLX.PRODUCT_CODE = ' . singleQuote($record['FILO_PRODUCT_CODE']) . ' AND CRCLX.CLX_EFFTDATE<=' . singleQuote($record['FILO_CLX_EFFTDATE']) . ' AND CRCLX.CLX_AUTH_STATUS = ' . singleQuote('AP') . ')';
        $crcl = ClxCommon::$db->getOneRecord($sql);
        $disponible = $record['FILO_LOAN_AMT'];
        $disponible = rounder($disponible, CLX_NUM_TWO);
        if (!empty($record['FILO_CRED_LINE_CODE']) && $crcl['QTY'] > CLX_NUM_ZERO && $crcl['LIMIT_AMT'] < $disponible) {
            $msg['FILO_LOAN_AMT'] = smsg('MSG-173', ' ' . rounder($crcl['LIMIT_AMT'], CLX_NUM_TWO), ' ' . $disponible);
        }
        $prltrec = ClxCommon::$db->getRecord($this->prltname, 'PRODUCT_CODE = ' . singleQuote($record['FILO_PRODUCT_CODE']));
        $prodrec = ClxCommon::$db->getRecord($this->prodname, 'IDCODE = ' . singleQuote($record['FILO_PRODUCT_CODE']));
        $req_line_cred = $prltrec['REQ_LINE_CREDIT'];
        $line_cred = ClxCommon::$db->countRecords($this->crclname, 'IDCODE = ' . singleQuote($record['FILO_CRED_LINE_CODE']));
        if ($req_line_cred > CLX_NUM_ZERO && $line_cred == CLX_NUM_ZERO) {
            $msg['FILO_CRED_LINE_CODE'] = smsg('MSG-174');
        }
        if (!empty($record['FILO_CRED_LINE_CODE'])) {
            $sql = 'SELECT (CRCL.LINE_AMT- IFNULL((SELECT SUM(case ' . ((!empty($prltrec['AMRT_LINE_CREDIT'])) ? CLX_NUM_ONE : CLX_NUM_ZERO) . ' WHEN 1 THEN FILO.PRINCIPAL_BAL ELSE FILO.LOAN_AMT END)+' . $record['FILO_LOAN_AMT'] . ' FROM ' . $this->filoname . ' FILO WHERE CRCL.IDCODE = FILO.CRED_LINE_CODE AND FILO.IDCODE <>' . singleQuote($record['FILO_IDCODE']) . ' AND FILO.ID = (SELECT MIN(X.ID) FROM CRED_CREDITS X WHERE X.IDCODE = FILO.IDCODE)),0)) BAL_AMT FROM ' . $this->crclname . ' CRCL, ' . $this->glcpname . ' GLCP WHERE GLCP.COMP_CODE = CRCL.COMP_CODE AND CRCL.IDCODE = ' . singleQuote($record['FILO_CRED_LINE_CODE']) . ' AND  CRCL.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) CLX_EFFTDATE FROM ' . $this->crclname . ' X WHERE X.IDCODE = CRCL.IDCODE AND X.CLX_EFFTDATE <= GLCP.OPERATION_DATE)';
            if (($line = ClxCommon::$db->getOne($sql)) < CLX_NUM_ZERO) {
                $msg['FILO_CRED_LINE_CODE'] = smsg('MSG-173', $record['FILO_CRED_LINE_CODE'], $line);
            }
        }
        //Validating max and min
        if ($prltrec['MAX_GRACE_PERIODS'] != CLX_NUM_ZERO && $prltrec['MAX_GRACE_PERIODS'] < $record['FILO_EQ_GRACE_PERIODS']) {
            $msg['FILO_EQ_GRACE_PERIODS'] = smsg('MSG-176', $prltrec['MAX_GRACE_PERIODS']);
        }
        if ($prltrec['MIN_GRACE_PERIODS'] != CLX_NUM_ZERO && $prltrec['MIN_GRACE_PERIODS'] > $record['FILO_EQ_GRACE_PERIODS']) {
            $msg['FILO_EQ_GRACE_PERIODS'] = smsg('MSG-177', $prltrec['MIN_GRACE_PERIODS']);
        }
        //MAX_LOAN_PERIODS
        if ($prltrec['MAX_LOAN_PERIODS'] != CLX_NUM_ZERO && $prltrec['MAX_LOAN_PERIODS'] < $record['FILO_LOAN_PERIOD']) {
            $msg['FILO_LOAN_PERIOD'] = smsg('MSG-196', $prltrec['MAX_LOAN_PERIODS']);
        }
        if ($prltrec['MIN_LOAN_PERIODS'] != CLX_NUM_ZERO && $prltrec['MIN_LOAN_PERIODS'] > $record['FILO_LOAN_PERIOD']) {
            $msg['FILO_LOAN_PERIOD'] = smsg('MSG-195', $prltrec['MIN_LOAN_PERIODS']);
        }
        if ($prltrec['MAX_INTEREST_PCT'] != CLX_NUM_ZERO && $prltrec['MAX_INTEREST_PCT'] < $record['FILO_LOAN_INTEREST']) {
            $msg['FILO_LOAN_INTEREST'] = smsg('MSG-178', $prltrec['MAX_INTEREST_PCT']);
        }
        if ($prltrec['MIN_INTEREST_PCT'] != CLX_NUM_ZERO && $prltrec['MIN_INTEREST_PCT'] > (string) $record['FILO_LOAN_INTEREST']) {
            $msg['FILO_LOAN_INTEREST'] = smsg('MSG-179', $prltrec['MIN_INTEREST_PCT']);
        }
        $sql = 'SELECT IFNULL(SUM(FILO.PRINCIPAL_BAL),0) LOAN_AMT FROM ' . $this->filoname . ' FILO WHERE FILO.PRODUCT_CODE = ' . singleQuote($record['FILO_PRODUCT_CODE']) . ' AND FILO.LOAN_STATUS = ' . singleQuote('VIG') . ' AND FILO.COMP_CODE = ' . singleQuote($record['FILO_COMP_CODE']) . ' AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILOX WHERE FILOX.IDCODE = FILO.IDCODE AND FILO.CLX_EFFTDATE<=' . singleQuote($this->now) . ')';
        if ($prodrec['MAX_PRODUCT_AMT'] != CLX_NUM_ZERO && ClxCommon::$db->getOne($sql) > $prodrec['MAX_PRODUCT_AMT']) {
            $msg['FILO_LOAN_AMT'] = smsg('MSG-180', $prodrec['MAX_PRODUCT_AMT']);
        }
        if ($prodrec['MAX_UNIT_PROD_AMT'] != CLX_NUM_ZERO && $record['FILO_LOAN_AMT'] > $prodrec['MAX_UNIT_PROD_AMT']) {
            $msg['FILO_LOAN_AMT'] = smsg('MSG-181', $prodrec['MAX_UNIT_PROD_AMT']);
        }
        //Validaciones de montos por limite de producto
        $sql = 'SELECT PRLM.MAX_PRODUCT_AMT, PRLM.MIN_PRODUCT_AMT, PRLM.MAX_UNIT_PROD_AMT, PRLM.MIN_UNIT_PROD_AMT FROM ' . $this->prlmname . ' PRLM,' . $this->acconame . ' ACCO WHERE ACCO.COSIZE_CLASS = PRLM.COSIZE_CLASS AND PRLM.IS_VALIDATION = 1 AND ACCO.IDCODE = ' . singleQuote($record['FILO_DEBTOR_CODE']) . ' AND PRLM.PRODUCT_CODE = ' . singleQuote($record['FILO_PRODUCT_CODE']) . ' AND PRLM.CLX_EFFTDATE = (SELECT MAX(PRLMX.CLX_EFFTDATE) FROM ' . $this->prlmname . ' PRLMX WHERE PRLMX.PRODUCT_CODE = PRLM.PRODUCT_CODE AND PRLMX.COSIZE_CLASS = PRLM.COSIZE_CLASS AND PRLMX.CLX_EFFTDATE<=' . singleQuote($this->now) . ')';
        $prlmrec = ClxCommon::$db->getOneRecord($sql);
        if (!empty($prlmrec['MAX_UNIT_PROD_AMT']) && $prlmrec['MAX_UNIT_PROD_AMT'] < $record['FILO_LOAN_AMT']) {
            $msg['FILO_LOAN_AMT'] = smsg('MSG-186', $prlmrec['MAX_UNIT_PROD_AMT']);
        }
        if (!empty($prlmrec['MIN_UNIT_PROD_AMT']) && $prlmrec['MIN_UNIT_PROD_AMT'] > $record['FILO_LOAN_AMT']) {
            $msg['FILO_LOAN_AMT'] = smsg('MSG-187', $prlmrec['MIN_UNIT_PROD_AMT']);
        }
        if (!empty($prlmrec['MAX_PRODUCT_AMT']) || !empty($prlmrec['MIN_PRODUCT_AMT'])) {
            $sql = 'SELECT IFNULL(SUM(FILO.LOAN_AMT),0) FROM ' . $this->filoname . ' FILO, ' . $this->glcpname . ' GLCP WHERE FILO.DEBTOR_CODE = ' . singleQuote($record['FILO_DEBTOR_CODE']) . ' AND GLCP.COMP_CODE = FILO.COMP_CODE AND FILO.IDCODE<>' . singleQuote($record['FILO_IDCODE']) . ' AND FILO.PRODUCT_CODE = ' . singleQuote($record['FILO_PRODUCT_CODE']) . ' AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILOX WHERE FILOX.IDCODE = FILO.IDCODE AND FILOX.CLX_EFFTDATE<=' . singleQuote($this->today) . ')'; /* GLCP.OPERATION_DATE */
            $principal_bal = ClxCommon::$db->getOne($sql) + $record['FILO_LOAN_AMT'];
            if ($prlmrec['MAX_PRODUCT_AMT'] != CLX_NUM_ZERO && $principal_bal > $prlmrec['MAX_PRODUCT_AMT']) {
                $msg['FILO_LOAN_AMT'] = smsg('MSG-184', $prlmrec['MAX_PRODUCT_AMT']);
            }
            if ($prlmrec['MIN_PRODUCT_AMT'] != CLX_NUM_ZERO && $principal_bal < $prlmrec['MIN_PRODUCT_AMT']) {
                $msg['FILO_LOAN_AMT'] = smsg('MSG-185', $prlmrec['MIN_PRODUCT_AMT']);
            }
        }
        //Validando que formula de calculo de periodo sea simple en periodos no mensuales
        if (($record['FILO_PERIOD_TYPE'] === 'D' || $record['FILO_PERIOD_TYPE'] === 'H' || $record['FILO_PERIOD_TYPE'] === 'W') && @$record['FILO_PERIOD_FORMULA'] != CLX_NUM_ZERO) {
            $msg['FILO_PERIOD_TYPE'] = smsg('MSG-193');
        }
        //validando linea de credito
        $sql = 'SELECT COUNT(ID) FROM ' . $this->crclname . ' WHERE IDCODE = ' . singleQuote($record['FILO_CRED_LINE_CODE']) . ' AND COMP_CODE = ' . singleQuote($record['FILO_COMP_CODE']);
        if (!empty($record['FILO_CRED_LINE_CODE']) && ClxCommon::$db->getOne($sql) == CLX_NUM_ZERO) {
            $msg['FILO_CRED_LINE_CODE'] = smsg('MSG-194');
        }
        //Validando que montos de credito sean mayores que cero
        if ($record['FILO_LOAN_AMT'] <= CLX_NUM_ZERO) {
            $msg['FILO_LOAN_AMT'] = smsg('MSG-204');
        }
        $sql = 'SELECT COUNT(CRCL.ID) FROM ' . $this->crclname . ' CRCL WHERE CRCL.IDCODE = ' . singleQuote($record['FILO_CRED_LINE_CODE']) . ' AND CRCL.COMP_CODE = ' . singleQuote($record['FILO_COMP_CODE']) . ' AND CRCL.END_DATE<' . singleQuote($record['FILO_START_DATE']) . ' AND CRCL.CLX_AUTH_STATUS = ' . singleQuote('AP') . ' AND CRCL.CLX_EFFTDATE = (SELECT MAX(CRCLX.CLX_EFFTDATE) FROM ' . $this->crclname . ' CRCLX WHERE CRCL.IDCODE = CRCLX.IDCODE)';
        if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
            $msg['FILO_CRED_LINE_CODE'] = smsg('MSG-210');
        }
        //Verificar que no haya cambio de moneda
        if (UserRequest::$request['ac'] === 'MODIFY' || UserRequest::$request['ac'] === 'DUPLICATE_EFFTDATE' || UserRequest::$request['ac'] === 'DUPLICATE') {
            $old_curr = ClxCommon::$db->getField($this->filoname, 'CURRENCY_CODE', 'IDCODE = ' . singleQuote($record['FILO_IDCODE']));
            if ($old_curr <> $record['FILO_CURRENCY_CODE']) {
                $msg['FILO_CURRENCY_CODE'] = smsg('MSG-413');
            }
        }
        if ($record['FILO_CALC_INTEREST'] == CLX_NUM_ONE && $record['FILO_LOAN_INTEREST'] == CLX_NUM_ZERO) {
            $msg['FILO_LOAN_INTEREST'] = smsg('MSG-223');
        }
        return (count($msg) > CLX_NUM_ZERO) ? false : true;
    }

    /**
     * Update Parent (FILO) Information one record is saved
     */
    function save_form(&$record) {
        if (ClxCommon::$db->countRecords($this->fiasname, 'LOAN_CODE = ' . singleQuote($record['IDCODE'])) == CLX_NUM_ZERO) {
            $this->build_fias($record);
        }
    }

    /**
     * Update (FILO) after saving the record
     */
    function save_form_post(&$record) {

        //Crea subcuenta de credito
        $this->build_fias($record);

        //crea subcuenta de cuenta de banco
        $this->build_fias_fibk($record);

        $restructure = (UserRequest::$request['ac'] === 'DUPLICATE_EFFTDATE' && !empty($record['REFINANCED'])) ? CLX_NUM_ONE : CLX_NUM_ZERO;

        //Create Participant if not exists and wont be approved
        if ($record['LOAN_STATUS'] <> 'PRE') {

            $contract_code = ClxCommon::$db->getField($this->fiasname, 'CONTRACT_CODE', 'LOAN_CODE = ' . singleQuote($record['IDCODE']));
            if(!empty($contract_code)){
                if (!class_exists('Fipa')){
                    includeCodeLib('FIPA');
                }
                $fipa = new Fipa();
                $fipa->build($contract_code, $record['DEBTOR_CODE'], 'DB');
            }
        }
        $sql = 'UPDATE ' . $this->filoname . ' FILO SET FILO.LAST_PAY_DATE = NULL WHERE FILO.IDCODE = ' . singleQuote($record['IDCODE']) . ' AND FILO.CLX_EFFTDATE = ' . singleQuote($record['CLX_EFFTDATE']) . ' AND FILO.LAST_PAY_AMT = 0';
        ClxFreeReturn(ClxCommon::$db->executeQuery($sql));


        $this->build_amortization($record['IDCODE'], $record['CLX_EFFTDATE'], $restructure, CLX_NUM_ZERO);
    }


    /**
     * Performs tasks after authorization
     *
     * @param array $record
     */
    function post_autorize(&$record) {
        if (UserRequest::$request['ac'] === 'DELETE')
            return;
        if (array_key_exists('FILO_IDCODE', $record)) {
            $prefix = 'FILO_';
            $loan_code = $record['FILO_IDCODE'];
        } else {
            $prefix = '';
            $loan_code = $record['IDCODE'];
        }
        $sql = 'SELECT LOAN_STATUS FROM ' . $this->filoname . '  WHERE IDCODE = ' . singleQuote($loan_code) . ' AND CLX_EFFTDATE = (SELECT MAX(CLX_EFFTDATE) FROM ' . $this->filoname . '  WHERE IDCODE = ' . singleQuote($loan_code) . ')';
        $loan_status = ClxCommon::$db->getOne($sql);
        if ($loan_status === 'PRE') {
            $this->change_status($loan_code, 'VIG');
            if (!class_exists('Fipa'))
                includeCodeLib('FIPA');
            $fipa = new Fipa();
            $contract_code = ClxCommon::$db->getField($this->fiasname, 'CONTRACT_CODE', 'LOAN_CODE = ' . singleQuote($loan_code));
            $fipa->build($contract_code, $record[$prefix . 'DEBTOR_CODE'], 'DB');
        }
    }

    /**
     * Delete record on delete.
     * @param array $record
     */
    function delete_record_post($record) {
        $sql = 'DELETE FROM ' . $this->filsname . '  WHERE LOAN_CODE = ' . singleQuote($record['IDCODE']) . ' AND EFFTDATE = ' . singleQuote($record['CLX_EFFTDATE']);
        ClxCommon::$db->executeQuery($sql);
    }

    function validate_record_delete(&$record, &$msg){
        $record['FILO_LOAN_AMT'] = str_replace(',', '', $record['FILO_LOAN_AMT']);
        if (UserRequest::$request['ac'] === 'DELETE' && $record['FILO_LOAN_STATUS'] !== 'PRE') {
            $msg['FILO_LOAN_STATUS'] = smsg('MSG-202', $record['FILO_IDCODE']);
            if (UserRequest::$request['ac'] === 'DELETE')
                addMessage($msg['FILO_LOAN_STATUS']);
            return false;
        }
    }

    /**
     * Updates loan balances based on accounting operation date
     *
     * @param string $loan_code
     * @param string $operation_type
     */
    function update_balances($loan_code, $operation_type = false, $je_source = false) {
        //Search last efftdate
        $efftdate = $this->get_current_efftdate($loan_code);
        if ($operation_type <> 'CAP') {
            $this->update_interest_balance($loan_code, $efftdate);
        }
        $this->update_reserve_balance($loan_code, $efftdate);
        $this->update_fees_balance($loan_code, $efftdate);
        /* capital was set already so addint for total paid */
        if ($operation_type === 'PAY') {
            $sql = 'UPDATE ' . $this->filsname . '  SET PAID_AMT = PPAL_PAID_AMT+INTPAID_AMT+ADVANCE_PAID_AMT WHERE LOAN_CODE = ' . singleQuote($loan_code) . ' AND EFFTDATE =' . singleQuote($efftdate);
            ClxCommon::$db->executeQuery($sql);
            //Verify reversals and datas of payment
            $sql = 'UPDATE ' . $this->filsname . '  SET PAYMENT_DATE = null WHERE LOAN_CODE = ' . singleQuote($loan_code) . ' AND EFFTDATE = ' . singleQuote($efftdate) . ' AND PAID_AMT = 0';
            ClxCommon::$db->executeQuery($sql);
        }
    }

    // Operaciones de Credits
    /**
     * Builds loan balances from transaction
     *
     * @param string $jehd_code
     */
    function update_balances_jehd($jehd_code, $batch_id = false) {
        if (ClxCommon::$db->countRecords($this->jehdname, 'IDCODE = ' . singleQuote($jehd_code) . ' AND JE_SOURCE = ' . singleQuote('INIT') . '') > CLX_NUM_ZERO) {
            return;
        }
        //Ajustando devengos en forma masiva no hace falta ajustar mas
        $je_source = ClxCommon::$db->getField($this->jehdname, 'JE_SOURCE', 'IDCODE = ' . singleQuote($jehd_code));
        if ($je_source === 'PINTP') {
            $this->update_interest_pint_jehd($jehd_code);
            return;
        }

        //Updateing fees
        $this->update_fees($jehd_code);
        if ($je_source === 'CRLF')
            return; //si son comisiones solo regresa ya que se actualizaron en paso anterior y no se hace nada mas
        $cc = ' JELN.JEHDR_CODE = ' . singleQuote($jehd_code);
        if ($batch_id === true) {
            $cc = ' JEHD.BATCH_ID = ' . singleQuote($batch_id);
        }
        $sql = 'SELECT DISTINCT JEHD.IDCODE, JEHD.EFFTDATE OPERATION_DATE, FIAS.LOAN_CODE, FILO.CLX_EFFTDATE, JEHD.TRANSTBL_CODE, JEHD.JE_SOURCE, JEHD.EFFTDATE TRANSACTION_DATE, JEHD.ADJUSTMENT, JEHD.IS_PAYMENT, FILO.START_DATE, FILO.START_DATE_ORI, FILO.FIRST_PYMNT_DATE, FILO.PAY_DAY FROM ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN, ' . $this->fiasname . ' FIAS, ' . $this->filoname . ' FILO WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND JELN.CHART_FIELD03 = FIAS.IDCODE AND FILO.IDCODE = FIAS.LOAN_CODE AND FILO.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM ' . $this->filoname . ' X WHERE X.IDCODE = FILO.IDCODE AND X.CLX_EFFTDATE<=' . singleQuote($this->today) . ') AND ' . $cc;
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            //Check for reschedule of paymens
            //Existe transaccion ver logica aplicada a pagos, desembolsos etc.
            $oper_type = $this->credit_operation_type($r['TRANSTBL_CODE'], $r['IS_PAYMENT']);
            //Si origen de asiento es de valoracion entonces ver operacion como desembolso
            //a la hora de actualizar auxiliares
            if ($je_source === 'CINDX') {
                $oper_type = 'DIS';
            }
            //Dealing with installments and payments
            $recalculate_schedule = $this->update_principal($r['IDCODE'], $r['LOAN_CODE'], $r['CLX_EFFTDATE'], $oper_type);
            $this->update_interest($r['IDCODE'], $r['LOAN_CODE'], $r['CLX_EFFTDATE'], $oper_type);
            $sql = 'UPDATE ' . $this->filsname . '  SET PAYMENT_DATE = null WHERE LOAN_CODE = ' . singleQuote($r['LOAN_CODE']) . ' AND EFFTDATE = ' . singleQuote($r['CLX_EFFTDATE']) . ' AND PAID_AMT = 0';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->filoname . ' FILO SET FILO.LAST_PAY_DATE = (SELECT MAX(FILS.PAYMENT_DATE) FROM ' . $this->filsname . ' FILS WHERE FILS.LOAN_CODE = ' . singleQuote($r['LOAN_CODE']) . ' AND FILS.EFFTDATE = ' . singleQuote($r['CLX_EFFTDATE']) . '), FILO.LAST_PAY_AMT = IFNULL((SELECT SUM(FILS.PAID_AMT) FROM ' . $this->filsname . ' FILS WHERE FILS.LOAN_CODE = ' . singleQuote($r['LOAN_CODE']) . ' AND FILS.EFFTDATE = ' . singleQuote($r['CLX_EFFTDATE']) . ' AND FILS.PAYMENT_DATE = ' . singleQuote($r['TRANSACTION_DATE']) . '),0), FILO.PAID_AMT = IFNULL((SELECT SUM(FILS.PAID_AMT) FROM ' . $this->filsname . ' FILS WHERE FILS.LOAN_CODE = ' . singleQuote($r['LOAN_CODE']) . ' AND FILS.EFFTDATE = ' . singleQuote($r['CLX_EFFTDATE']) . '),0) WHERE FILO.IDCODE = ' . singleQuote($r['LOAN_CODE']) . ' AND FILO.CLX_EFFTDATE =' . singleQuote($r['CLX_EFFTDATE']);
            ClxCommon::$db->executeQuery($sql);
            //No marcar como cancelado si se trata de desembolso
            if ($oper_type <> 'DIS') {
                $sql = 'UPDATE ' . $this->filoname . ' FILO  SET FILO.LOAN_STATUS = ' . singleQuote('CAN') . ' WHERE FILO.IDCODE = ' . singleQuote($r['LOAN_CODE']) . ' AND FILO.CLX_EFFTDATE =' . singleQuote($r['CLX_EFFTDATE']) . ' AND FILO.PRINCIPAL_BAL = 0 AND FILO.START_DATE < ' . singleQuote($r['OPERATION_DATE']) . ' ';
                ClxCommon::$db->executeQuery($sql);
            }
            /* Cambiar a vigente si esta con saldo diferente de cero pero no cancelado */
            $sql = 'UPDATE ' . $this->filoname . ' FILO SET FILO.LOAN_STATUS = ' . singleQuote('VIG') . ' WHERE FILO.IDCODE = ' . singleQuote($r['LOAN_CODE']) . '  AND FILO.CLX_EFFTDATE =' . singleQuote($r['CLX_EFFTDATE']) . ' AND FILO.PRINCIPAL_BAL <> 0 AND FILO.LOAN_STATUS = ' . singleQuote('CAN') . '';
            ClxCommon::$db->executeQuery($sql);

            //En caso del primer Otorgamiento de Cheque Refrendo guardar la fecha de inicio y refrescar el cronograma con la fecha del otorgamiento
            if($r['TRANSTBL_CODE'] === 'CRED_REFREO'){
                $partial_dis = '';
                if(!$r['START_DATE_ORI']){
                    //actualizar fecha de primer pago
                    $date1 = new DateTime($r['START_DATE']);
                    $date2 = new DateTime($r['OPERATION_DATE']);
                    $diff = $date1->diff($date2);
                    $first_pyment_date_ori = date($r['FIRST_PYMNT_DATE']);
                    $nuevafecha = strtotime ( '+'.$diff->days.' day' , strtotime ( $first_pyment_date_ori ) ) ;
                    $new_pay_day = ($r['PAY_DAY'] != '0')?date('d',$nuevafecha):'0';
                    $nuevafecha = date ( 'Y-m-d' , $nuevafecha );
                    $first_pay_date = $nuevafecha;

                    $sql = 'UPDATE ' . $this->filoname . ' FILO SET FILO.START_DATE_ORI = ' . singleQuote($r['START_DATE']) . ', FILO.START_DATE = ' . singleQuote($r['OPERATION_DATE']) . ' , FILO.FIRST_PYMNT_DATE = ' . singleQuote($first_pay_date) . ' , FILO.PAY_DAY = ' . $new_pay_day . '  WHERE FILO.IDCODE = ' . singleQuote($r['LOAN_CODE']) . '  AND FILO.CLX_EFFTDATE =' . singleQuote($r['CLX_EFFTDATE']) . '';
                    ClxCommon::$db->executeQuery($sql);
                    //eliminar el cronograma anterior
                    $sql = 'DELETE FROM CRED_PAYMNT_SCHEDULES WHERE LOAN_CODE = ' . singleQuote($r['LOAN_CODE']) . ' AND EFFTDATE = ' . singleQuote($r['CLX_EFFTDATE']);
                    ClxCommon::$db->executeQuery($sql);

                    $sql = 'SELECT FILO.PRINCIPAL_BAL, FILO.LOAN_AMT FROM ' . $this->filoname . ' FILO WHERE FILO.IDCODE = ' . singleQuote($r['LOAN_CODE']) . '  AND FILO.CLX_EFFTDATE =' . singleQuote($r['CLX_EFFTDATE']);
                    $filo_amt = ClxCommon::$db->getOneRecord($sql);
                    if($filo_amt['PRINCIPAL_BAL'] < $filo_amt['LOAN_AMT']) //si es primer desembolso parcial
                        $partial_dis = '1';
                    //Se reconstruye el cronograma
                    $this->build_amortization($r['LOAN_CODE'], $r['CLX_EFFTDATE'], CLX_NUM_ZERO, CLX_NUM_ZERO, $partial_dis);
                }else{
                    //segundo desembolso
                    ClxCommon::$db->executeQuery('CALL CRED_SET_FILS_DYNAMIC2(' . singleQuote($r['LOAN_CODE']) . ', ' . singleQuote($r['CLX_EFFTDATE']) . ',' . singleQuote($this->username) . ', 0, 0, ' . singleQuote($r['OPERATION_DATE']) . ')');
                }

            }

            //En caso del primer Otorgamiento desde el modulo de desembolsos guardar la fecha de inicio y refrescar el cronograma con la fecha del otorgamiento
            /*if($oper_type === 'DIS' && $r['TRANSTBL_CODE'] === 'SYS_CRED-DISB'){
                $partial_dis = '';
                if(!$r['START_DATE_ORI']){
                    //actualizar fecha de primer pago
                    $date1 = new DateTime($r['START_DATE']);
                    $date2 = new DateTime($r['OPERATION_DATE']);
                    $diff = $date1->diff($date2);
                    $first_pyment_date_ori = date($r['FIRST_PYMNT_DATE']);
                    $nuevafecha = strtotime ( '+'.$diff->days.' day' , strtotime ( $first_pyment_date_ori ) ) ;
                    $new_pay_day = ($r['PAY_DAY'] != '0')?date('d',$nuevafecha):'0';
                    $nuevafecha = date ( 'Y-m-d' , $nuevafecha );
                    $first_pay_date = $nuevafecha;

                    $sql = 'UPDATE ' . $this->filoname . ' FILO SET FILO.START_DATE_ORI = ' . singleQuote($r['START_DATE']) . ', FILO.START_DATE = ' . singleQuote($r['OPERATION_DATE']) . ' , FILO.FIRST_PYMNT_DATE = ' . singleQuote($first_pay_date) . ' , FILO.PAY_DAY = ' . $new_pay_day . '  WHERE FILO.IDCODE = ' . singleQuote($r['LOAN_CODE']) . '  AND FILO.CLX_EFFTDATE =' . singleQuote($r['CLX_EFFTDATE']) . '';
                    ClxCommon::$db->executeQuery($sql);
                    //eliminar el cronograma anterior
                    $sql = 'DELETE FROM CRED_PAYMNT_SCHEDULES WHERE LOAN_CODE = ' . singleQuote($r['LOAN_CODE']) . ' AND EFFTDATE = ' . singleQuote($r['CLX_EFFTDATE']);
                    ClxCommon::$db->executeQuery($sql);

                    $sql = 'SELECT FILO.PRINCIPAL_BAL, FILO.LOAN_AMT FROM ' . $this->filoname . ' FILO WHERE FILO.IDCODE = ' . singleQuote($r['LOAN_CODE']) . '  AND FILO.CLX_EFFTDATE =' . singleQuote($r['CLX_EFFTDATE']);
                    $filo_amt = ClxCommon::$db->getOneRecord($sql);
                    if($filo_amt['PRINCIPAL_BAL'] < $filo_amt['LOAN_AMT']) //si es primer desembolso parcial
                        $partial_dis = '1';
                    //Se reconstruye el cronograma
                    $this->build_amortization($r['LOAN_CODE'], $r['CLX_EFFTDATE'], CLX_NUM_ZERO, CLX_NUM_ZERO, $partial_dis);
                }else{
                    //segundo desembolso
                    ClxCommon::$db->executeQuery('CALL CRED_SET_FILS_DYNAMIC2(' . singleQuote($r['LOAN_CODE']) . ', ' . singleQuote($r['CLX_EFFTDATE']) . ',' . singleQuote($this->username) . ', 0, 0, ' . singleQuote($r['OPERATION_DATE']) . ')');
                }

            }*/

            //Check if status need to be reversed
            if ($oper_type === 'PAY') {
                $sql = 'SELECT MAX(FILO.COMP_CODE) COMP_CODE, MAX(FILO.IDCODE) IDCODE, MAX(FILO.LOAN_STATUS) LOAN_STATUS, MAX(FILO.PRINCIPAL_BAL) PRINCIPAL_BAL, IFNULL(ROUND(((SUM(IF(FILS.PERIOD_END_DATE <= GLCP.OPERATION_DATE, FILS.PRINCIPAL_PAY, 0))-SUM(FILS.PPAL_PAID_AMT))+ (SUM(IF(FILS.PERIOD_END_DATE <= GLCP.OPERATION_DATE, FILS.INTEREST_PAY, 0))-SUM(FILS.INTPAID_AMT))), 2),0) DUE_AMT FROM CRED_PAYMNT_SCHEDULES FILS, CRED_CREDITS FILO, GL_PARAMETERS_TBL GLCP WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILO.COMP_CODE = GLCP.COMP_CODE AND FILS.EFFTDATE = FILO.CLX_EFFTDATE AND FILS.PERIOD_START_DATE <= GLCP.OPERATION_DATE AND FILO.IDCODE = ' . singleQuote($r['LOAN_CODE']) . ' AND FILO.CLX_EFFTDATE = ' . singleQuote($r['CLX_EFFTDATE']);
                $r2 = ClxCommon::$db->getOneRecord($sql);
                //if ($r2['LOAN_STATUS'] <> 'VIG' && $r2['PRINCIPAL_BAL'] <> CLX_NUM_ZERO && $r2['DUE_AMT'] == CLX_NUM_ZERO){
                if ($r2['LOAN_STATUS'] <> 'VIG' && $r2['PRINCIPAL_BAL'] <> CLX_NUM_ZERO && $r2['DUE_AMT'] <= CLX_NUM_ZERO) {
                    $this->gl_account_set_status('VIG', $r2['COMP_CODE'], $r2['IDCODE']);
                }
            }
        }
    }

    /**
     * Updates loan balances based on accounting operation date
     *
     * @param string jehdr_code
     * @param string $loan_code
     * @param string $efftdate
     */
    private function update_principal($jehdr_code, $loan_code, $filo_efftdate, $oper_type) {
        $recalculate_schedule = false;
        //First get Operation Amount for credit
        $sql = 'SELECT JEHD.EFFTDATE, JEHD.ADJUSTMENT, JEHD.TRANSTBL_CODE, JEHD.REV_JEHDR_CODE, SUM(JELN.DEBIT_TRANS_AMT-JELN.CREDIT_TRANS_AMT) BALANCE_AMT FROM ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN, ' . $this->fiasname . ' FIAS, ' . $this->filoname . ' FILO WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND JELN.CHART_FIELD03 = FIAS.IDCODE AND JELN.CURRENCY_CODE = FILO.CURRENCY_CODE AND FIAS.LOAN_CODE = FILO.IDCODE AND JEHD.IDCODE = ' . singleQuote($jehdr_code) . ' AND FILO.IDCODE = ' . singleQuote($loan_code) . ' AND FILO.CLX_EFFTDATE = ' . singleQuote($filo_efftdate) . ' AND JEHD.JE_SOURCE <> ' . "'CRGC'" . ' AND EXISTS(SELECT PRAT.ID FROM ' . $this->pratname . ' PRAT WHERE PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE AND PRAT.PRO_GL_CODE = JELN.GLACCOUNTCODE) GROUP BY JEHD.EFFTDATE, JEHD.ADJUSTMENT, JEHD.TRANSTBL_CODE, JEHD.REV_JEHDR_CODE';
        $pay = ClxCommon::$db->getOneRecord($sql);
        if ($pay['BALANCE_AMT'] == CLX_NUM_ZERO)
            return false; //nothing to do
        $sign = ($this->is_asset($loan_code)) ? CLX_NUM_ONE : -CLX_NUM_ONE;
        $oper_amt = rounder(($sign * $pay['BALANCE_AMT']), CLX_NUM_TWO);
        if ($oper_type === 'DIS' || $oper_type === 'ADJ') {
            //Dibursement just update loan amount. Nothing to do on installments
            $sql = 'UPDATE ' . $this->filoname . ' SET PRINCIPAL_BAL = PRINCIPAL_BAL+(' . $oper_amt . ' ) WHERE IDCODE = ' . singleQuote($loan_code) . ' AND CLX_EFFTDATE =' . singleQuote($filo_efftdate);
            ClxCommon::$db->executeQuery($sql);
        } elseif ($oper_type === 'PAY' || $oper_type === 'CAP') { //Test for period to check if paid or not
            //In case of payments this amount has to be set on installments
            $sql = 'UPDATE ' . $this->filoname . ' FILO SET FILO.PRINCIPAL_BAL = PRINCIPAL_BAL+(' . $oper_amt . '), FILO.DUE_PRO_AMT = DUE_PRO_AMT+('.$oper_amt.') WHERE FILO.IDCODE = ' . singleQuote($loan_code) . ' AND FILO.CLX_EFFTDATE =' . singleQuote($filo_efftdate);
            ClxCommon::$db->executeQuery($sql);
            //if paid more then just clear to cero
            $sql = 'UPDATE ' . $this->filoname . ' FILO SET FILO.DUE_PRO_AMT = 0 WHERE FILO.IDCODE = ' . singleQuote($loan_code) . ' AND FILO.CLX_EFFTDATE =' . singleQuote($filo_efftdate) . ' AND FILO.DUE_PRO_AMT < 0';
            ClxCommon::$db->executeQuery($sql);
            //Setting installment Information for payment
            //El cronograma de pago se registra en positivo siempre.
            //se paga por eso el menos -1 cada couta debe reducir el monto pagado
            //el monto pagado puede tener mas de una cuota se paga la mas antigua primero
            $oper_amt = rounder((-CLX_NUM_ONE * $sign * $pay['BALANCE_AMT']), CLX_NUM_TWO);
            $sql = 'SELECT MAX(FILS.SEQNUM) SEQNUM FROM ' . $this->filsname . ' FILS WHERE FILS.LOAN_CODE = ' . singleQuote($loan_code) . ' AND FILS.EFFTDATE = (SELECT MAX(X.EFFTDATE) FROM CRED_PAYMNT_SCHEDULES X WHERE X.LOAN_CODE = FILS.LOAN_CODE AND X.EFFTDATE <= ' . singleQuote($this->today) . ') AND FILS.PERIOD_START_DATE < ' . singleQuote($pay['EFFTDATE']);
            $r = ClxCommon::$db->getOneRecord($sql);
            if (!empty($r['SEQNUM'])) {
                $sql = 'UPDATE ' . $this->filsname . '  SET PAYMENT_DATE = ' . singleQuote($pay['EFFTDATE']) . ', PPAL_PAID_AMT = PPAL_PAID_AMT+' . $oper_amt . ', PAID_AMT = PAID_AMT+'.$oper_amt.' WHERE LOAN_CODE = ' . singleQuote($loan_code) . ' AND SEQNUM = ' . $r['SEQNUM'];
                ClxCommon::$db->executeQuery($sql);
            }
        } //end if payment
        return $recalculate_schedule;
    }

    /**
     * Update interest payment information
     *
     * @param string $jehdr_code
     * @param string $loan_code
     */
    private function update_interest($jehdr_code, $loan_code, $filo_efftdate, $oper_type) {
        //First get Operation Amount for credit
        $sql = 'SELECT JEHD.IS_PAYMENT, JEHD.ADJUSTMENT, JEHD.EFFTDATE, JEHD.TRANSTBL_CODE, SUM(JELN.DEBIT_TRANS_AMT-JELN.CREDIT_TRANS_AMT) BALANCE_AMT FROM ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN, ' . $this->fiasname . ' FIAS, ' . $this->filoname . ' FILO WHERE JEHD.IDCODE = JELN.JEHDR_CODE AND JELN.CHART_FIELD03 = FIAS.IDCODE AND JELN.CHART_FIELD03 = FIAS.IDCODE AND JELN.CHART_FIELD01 = FIAS.CONTRACT_CODE AND JELN.CURRENCY_CODE = FILO.CURRENCY_CODE AND FIAS.LOAN_CODE = FILO.IDCODE AND JEHD.IDCODE = ' . singleQuote($jehdr_code) . ' AND JEHD.JE_SOURCE <> ' . singleQuote('CRGC') . ' AND FILO.IDCODE = ' . singleQuote($loan_code) . ' AND FILO.CLX_EFFTDATE = ' . singleQuote($filo_efftdate) . ' AND EXISTS (SELECT PRAT.ID FROM ' . $this->pratname . ' PRAT WHERE PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE AND JELN.GLACCOUNTCODE IN (PRAT.AR_GL_CODE, PRAT.CINT_GL_CODE)) AND NOT EXISTS (SELECT GLPF.ID FROM ' . $this->glpfname . ' GLPF WHERE GLPF.PRODUCT_CODE = FILO.PRODUCT_CODE AND JELN.GLACCOUNTCODE IN (GLPF.FEE2_GL_CODE)) GROUP BY JEHD.EFFTDATE, JEHD.TRANSTBL_CODE, JEHD.ADJUSTMENT';
        $pay = ClxCommon::$db->getOneRecord($sql);
        if ($pay['BALANCE_AMT'] == CLX_NUM_ZERO) {
            return; //nothing to do
        }
        if (!$this->is_asset($loan_code)) {
            $pay['BALANCE_AMT'] = rounder(-CLX_NUM_ONE * $pay['BALANCE_AMT'], CLX_NUM_TWO);
        }
        if ($oper_type === 'OTH') {
            if ($pay['IS_PAYMENT'] == CLX_NUM_ONE) {
                $oper_type = 'PAY';
            } else {
                $oper_type = 'DIS';
            }
        }
        //Capturando otras formas de operaciones
        if ($oper_type === 'PAY') { //Test for period to check if paid or not
            $sql = 'UPDATE ' . $this->filoname . '  SET INTPAID_AMT = INTPAID_AMT-(' . $pay['BALANCE_AMT'] . '), DUE_AR_AMT = DUE_AR_AMT+(' . $pay['BALANCE_AMT'] . ') WHERE IDCODE = ' . singleQuote($loan_code) . ' AND CLX_EFFTDATE >=' . singleQuote($filo_efftdate);
            ClxCommon::$db->executeQuery($sql);
            //CLEAR IF PAID MORE THAN REQUIRED
            $sql = 'UPDATE ' . $this->filoname . '  SET DUE_AR_AMT = 0 WHERE IDCODE = ' . singleQuote($loan_code) . ' AND CLX_EFFTDATE >=' . singleQuote($filo_efftdate) . ' AND DUE_AR_AMT < 0';
            ClxCommon::$db->executeQuery($sql);
            //Setting installment Information for payment
            //Para actualizar los cronogrma el monto pagado es positivo cuando
            //se paga por eso el menos -1 caa couta debe reducir el monto pagado
            //el monto pagado puede tener mas de una cuota se paga la mas antigua primero
            $oper_amt = rounder(-CLX_NUM_ONE * $pay['BALANCE_AMT'], CLX_NUM_TWO);
            $sql = 'SELECT MAX(FILS.SEQNUM) SEQNUM FROM ' . $this->filsname . ' FILS WHERE FILS.LOAN_CODE = ' . singleQuote($loan_code) . ' AND FILS.EFFTDATE = (SELECT MAX(X.EFFTDATE) FROM CRED_PAYMNT_SCHEDULES X WHERE X.LOAN_CODE = FILS.LOAN_CODE AND X.EFFTDATE <= ' . singleQuote($this->today) . ') AND FILS.PERIOD_START_DATE <' . singleQuote($pay['EFFTDATE']);
            /* AND FILS.PERIOD_START_DATE <=' . singleQuote($pay['EFFTDATE'] ) */
            $r = ClxCommon::$db->getOneRecord($sql);
            if (!empty($r['SEQNUM'])) {
                $sql = 'UPDATE ' . $this->filsname . '  SET INTPAID_AMT = INTPAID_AMT+' . $oper_amt . ', PAID_AMT = PAID_AMT+' . $oper_amt . ' WHERE LOAN_CODE = ' . singleQuote($loan_code) . ' AND SEQNUM = ' . $r['SEQNUM'];
                ClxCommon::$db->executeQuery($sql);
            }
        } else { //end fi pay
//            if ($oper_type === 'ADJ') {
                $sql = 'UPDATE ' . $this->filoname . '  SET INTEARNED_AMT = INTEARNED_AMT+(' . $pay['BALANCE_AMT'] . ') WHERE IDCODE = ' . singleQuote($loan_code) . ' AND CLX_EFFTDATE >=' . singleQuote($filo_efftdate);
 //           } else {
  //              //Interest Earned Amount
  //              $sql = 'UPDATE ' . $this->filoname . '  SET INTEARNED_AMT = INTEARNED_AMT+(' . $pay['BALANCE_AMT'] . ') WHERE IDCODE = ' . singleQuote($loan_code) . ' AND CLX_EFFTDATE >=' . singleQuote($filo_efftdate);
  //          }
            ClxCommon::$db->executeQuery($sql);
        }
    }

    /**
     *
     * @param unknown_type $jehdr_code
     */
    private function update_interest_pint_jehd($jehdr_code) {
        $this->initTemporaryTables($this->batch_id);
        //Find any case to recalculate late amounts only if
        //INT_ACCRUED_DAYS usado para contar el elemento de devengo
        $sql = 'INSERT INTO ' . $this->glt1name . ' (BATCH_ID, LOAN_CODE, EFFTDATE, BALANCE_AMT) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, FILO.IDCODE LOAN_CODE, FILO.CLX_EFFTDATE EFFTDATE, case GLAC.GL_TYPE WHEN ' . singleQuote('LI') . ' THEN SUM(JELN.CREDIT_TRANS_AMT-JELN.DEBIT_TRANS_AMT) ELSE SUM(JELN.DEBIT_TRANS_AMT-JELN.CREDIT_TRANS_AMT) END BALANCE_AMT FROM ' . $this->filoname . ' FILO, ' . $this->fiasname . ' FIAS, ' . $this->jelnname . ' JELN, ' . $this->jehdname . ' JEHD, ' . $this->glacname . ' GLAC, ' . $this->glcpname . ' GLCP WHERE JELN.JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND JEHD.IDCODE = JELN.JEHDR_CODE AND GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLCP.COMP_CODE = FILO.COMP_CODE AND JEHD.JE_SOURCE IN (' . singleQuoteArray(array('PINTP', 'CINDX')) . ') AND JELN.CHART_FIELD03 = FIAS.IDCODE AND JELN.CURRENCY_CODE = FILO.CURRENCY_CODE AND EXISTS(SELECT PRAT.ID FROM ' . $this->pratname . ' PRAT WHERE PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE AND JELN.GLACCOUNTCODE IN (PRAT.AR_GL_CODE, PRAT.CINT_GL_CODE)) AND FILO.IDCODE = FIAS.LOAN_CODE AND FILO.CLX_EFFTDATE = (SELECT MAX(FILO2.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILO2 WHERE FILO2.IDCODE = FILO.IDCODE AND FILO2.CLX_EFFTDATE<=' . singleQuote($this->today) . ' ) GROUP BY FILO.IDCODE, FILO.CLX_EFFTDATE, GLAC.GL_TYPE';
        ClxCommon::$db->executeQuery($sql);
        /* reversando ejecuciones del mismo dia */
        $sql = 'UPDATE ' . $this->filoname . ' FILO, ' . $this->glt1name . ' X SET FILO.INTEARNED_AMT = FILO.INTEARNED_AMT+IFNULL((X.BALANCE_AMT),0) WHERE FILO.IDCODE = X.LOAN_CODE AND FILO.CLX_EFFTDATE = X.EFFTDATE AND X.BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //Setting counter
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
        $sql = 'INSERT INTO ' . $this->glt1name . '  (BATCH_ID, LOAN_CODE, EFFTDATE, INT_ACCRUED_DAYS) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, FILO.IDCODE LOAN_CODE, FILO.CLX_EFFTDATE EFFTDATE, IF(REV_JEHDR_CODE=' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' OR REV_JEHDR_CODE IS NULL, 0, 1) INT_ACCRUED_DAYS FROM ' . $this->filoname . ' FILO, ' . $this->fiasname . ' FIAS, ' . $this->jelnname . ' JELN, ' . $this->jehdname . ' JEHD, ' . $this->glacname . ' GLAC, ' . $this->glcpname . ' GLCP WHERE JELN.JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND JEHD.IDCODE = JELN.JEHDR_CODE AND GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLCP.COMP_CODE = FILO.COMP_CODE AND JEHD.JE_SOURCE = ' . singleQuote('PINTP') . ' AND JELN.CHART_FIELD03 = FIAS.IDCODE AND JELN.CURRENCY_CODE = FILO.CURRENCY_CODE AND EXISTS(SELECT PRAT.ID FROM ' . $this->pratname . ' PRAT WHERE PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE AND JELN.GLACCOUNTCODE IN (PRAT.AR_GL_CODE, PRAT.CINT_GL_CODE)) AND FILO.IDCODE = FIAS.LOAN_CODE AND FILO.CLX_EFFTDATE = (SELECT MAX(FILO2.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILO2 WHERE FILO2.IDCODE = FILO.IDCODE AND FILO2.CLX_EFFTDATE<=' . singleQuote($this->today) . ') GROUP BY FILO.IDCODE, FILO.CLX_EFFTDATE, GLAC.GL_TYPE';
        ClxCommon::$db->executeQuery($sql);
        //Ajustando contador para incrementar si es devengo
        $sql = 'UPDATE ' . $this->filoname . ' FILO, ' . $this->glt1name . ' X SET FILO.INT_ACCRUED_DAYS = FILO.INT_ACCRUED_DAYS+1 WHERE FILO.IDCODE = X.LOAN_CODE AND FILO.CLX_EFFTDATE = X.EFFTDATE AND X.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND X.INT_ACCRUED_DAYS = 0';
        ClxCommon::$db->executeQuery($sql);
        //Reduciendo solo si es mayor a 0
        $sql = 'UPDATE ' . $this->filoname . ' FILO, ' . $this->glt1name . ' X SET FILO.INT_ACCRUED_DAYS = FILO.INT_ACCRUED_DAYS-1 WHERE FILO.IDCODE = X.LOAN_CODE AND FILO.CLX_EFFTDATE = X.EFFTDATE AND X.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND FILO.INT_ACCRUED_DAYS>0 AND X.INT_ACCRUED_DAYS = 1';
        ClxCommon::$db->executeQuery($sql);
        $this->initTemporaryTables($this->batch_id);
    }

    /**
     * Updates loan balances based on accounting operation date
     *
     * @param string $jehdr_code
     */
    private function update_fees($jehdr_code) {
        $sql = 'DROP TABLE IF EXISTS CRED_FEE_TMP';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'DROP TABLE IF EXISTS CRED_FEE2_TMP';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'CREATE TEMPORARY TABLE CRED_FEE_TMP SELECT FILO.IDCODE LOAN_CODE, FILO.CLX_EFFTDATE, FIAS.CONTRACT_CODE CHART_FIELD01, FIAS.IDCODE CHART_FIELD03, FILO.CURRENCY_CODE, GLPF.SEQNUM, GLPF.FEE_GL_CODE, GLPF.FEE2_GL_CODE, GLAC.GL_TYPE, case GLAC.GL_TYPE WHEN ' . singleQuote('LI') . ' THEN -1 ELSE 1 END MULSIGN, FILO.FEE_01_AMT, FILO.FEE_02_AMT, FILO.FEE_03_AMT, FILO.FEE_04_AMT, FILO.FEE_05_AMT FROM GL_PROD_FEES GLPF, GL_CODES_TBL GLAC, CRED_CREDITS FILO, FIDU_ITEMS FIAS WHERE GLAC.IDCODE = FEE2_GL_CODE AND GLAC.GLGROUP_CODE = GLPF.GLGROUP_CODE AND GLPF.PRODUCT_CODE = FILO.PRODUCT_CODE AND GLPF.STATUS = ' . singleQuote('A') . ' AND GLPF.CHARGE_CUSTOMER = 1 AND FIAS.LOAN_CODE = FILO.IDCODE AND FILO.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM CRED_CREDITS X WHERE X.IDCODE = FILO.IDCODE AND X.CLX_EFFTDATE <= NOW()) AND EXISTS (SELECT DISTINCT JELN.ID FROM GL_JOURNAL_LINES JELN WHERE JELN.JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND JELN.CHART_FIELD03 = FIAS.IDCODE AND JELN.GLACCOUNTCODE = GLPF.FEE2_GL_CODE) GROUP BY FILO.IDCODE,GLPF.FEE2_GL_CODE ORDER BY GLPF.SEQNUM ASC';
		//ORIGINAL$sql = 'CREATE TEMPORARY TABLE CRED_FEE_TMP SELECT FILO.IDCODE LOAN_CODE, FILO.CLX_EFFTDATE, FIAS.CONTRACT_CODE CHART_FIELD01, FIAS.IDCODE CHART_FIELD03, FILO.CURRENCY_CODE, GLPF.SEQNUM, GLPF.FEE_GL_CODE, GLPF.FEE2_GL_CODE, GLAC.GL_TYPE, case GLAC.GL_TYPE WHEN ' . singleQuote('LI') . ' THEN -1 ELSE 1 END MULSIGN, FILO.FEE_01_AMT, FILO.FEE_02_AMT, FILO.FEE_03_AMT, FILO.FEE_04_AMT, FILO.FEE_05_AMT FROM GL_PROD_FEES GLPF, GL_CODES_TBL GLAC, CRED_CREDITS FILO, FIDU_ITEMS FIAS WHERE GLAC.IDCODE = FEE2_GL_CODE AND GLAC.GLGROUP_CODE = GLPF.GLGROUP_CODE AND GLPF.PRODUCT_CODE = FILO.PRODUCT_CODE AND GLPF.STATUS = ' . singleQuote('A') . ' AND GLPF.CHARGE_CUSTOMER = 1 AND FIAS.LOAN_CODE = FILO.IDCODE AND FILO.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM CRED_CREDITS X WHERE X.IDCODE = FILO.IDCODE AND X.CLX_EFFTDATE <= NOW()) AND EXISTS (SELECT DISTINCT JELN.ID FROM GL_JOURNAL_LINES JELN WHERE JELN.JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND JELN.CHART_FIELD03 = FIAS.IDCODE AND JELN.GLACCOUNTCODE = GLPF.FEE2_GL_CODE) ORDER BY GLPF.SEQNUM ASC';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE CRED_FEE_TMP X SET X.FEE_01_AMT = 0 WHERE X.SEQNUM IN (2,3,4,5)';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE CRED_FEE_TMP X SET X.FEE_02_AMT = 0 WHERE X.SEQNUM IN (1,3,4,5)';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE CRED_FEE_TMP X SET X.FEE_03_AMT = 0 WHERE X.SEQNUM IN (1,2,4,5)';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE CRED_FEE_TMP X SET X.FEE_04_AMT = 0 WHERE X.SEQNUM IN (1,2,3,5)';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE CRED_FEE_TMP X SET X.FEE_05_AMT = 0 WHERE X.SEQNUM IN (1,2,3,4)';
        ClxCommon::$db->executeQuery($sql);
        for ($i = CLX_NUM_ONE; $i <= CLX_NUM_FIVE; $i++) {
            $sql = 'UPDATE CRED_FEE_TMP X SET X.FEE_0' . $i . '_AMT = X.FEE_0' . $i . '_AMT+(MULSIGN*IFNULL((SELECT SUM(JELN.DEBIT_TRANS_AMT-JELN.CREDIT_TRANS_AMT) FROM  GL_JOURNAL_LINES JELN WHERE JELN.CHART_FIELD03 = X.CHART_FIELD03 AND JELN.GLACCOUNTCODE = X.FEE2_GL_CODE AND JELN.CURRENCY_CODE = X.CURRENCY_CODE AND JELN.JEHDR_CODE = ' . singleQuote($jehdr_code) . '),0)) WHERE X.SEQNUM = ' . $i;
            ClxCommon::$db->executeQuery($sql);
        }
        $sql = 'CREATE TEMPORARY TABLE CRED_FEE2_TMP SELECT X.LOAN_CODE, X.CLX_EFFTDATE, SUM(X.FEE_01_AMT) FEE_01_AMT, SUM(X.FEE_02_AMT) FEE_02_AMT, SUM(X.FEE_03_AMT) FEE_03_AMT, SUM(X.FEE_04_AMT) FEE_04_AMT, SUM(X.FEE_05_AMT) FEE_05_AMT FROM CRED_FEE_TMP X GROUP BY X.LOAN_CODE, X.CLX_EFFTDATE';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE CRED_CREDITS FILO, CRED_FEE2_TMP X SET FILO.FEE_01_AMT = X.FEE_01_AMT, FILO.FEE_02_AMT = X.FEE_02_AMT, FILO.FEE_03_AMT = X.FEE_03_AMT, FILO.FEE_04_AMT = X.FEE_04_AMT, FILO.FEE_05_AMT = X.FEE_05_AMT WHERE FILO.IDCODE = X.LOAN_CODE AND FILO.CLX_EFFTDATE = X.CLX_EFFTDATE';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'DROP TABLE IF EXISTS CRED_FEE_TMP';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'DROP TABLE IF EXISTS CRED_FEE2_TMP';
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     * Updates loan balances based on accounting operation date
     * Method update balance of earned interest
     *
     * @param string $loan_code
     */
    private function update_interest_balance($loan_code, $efftdate) {
        //select options
        $s = ($this->is_interest_asset($loan_code)) ? CLX_NUM_ONE : -CLX_NUM_ONE;
        $cc = 'IFNULL(SUM((case JEHD.JE_SOURCE WHEN ' . singleQuote('CRGC') . ' THEN ' . $s . '*(JELN.DEBIT_TRANS_AMT-JELN.CREDIT_TRANS_AMT)
					WHEN ' . singleQuote('PINTP') . ' THEN ' . $s . '*(JELN.DEBIT_TRANS_AMT-JELN.CREDIT_TRANS_AMT)
					ELSE 0 END)),0) INTEARNED_AMT, IFNULL(SUM((case JEHD.JE_SOURCE WHEN ' . singleQuote('CRGC') . ' THEN 0 WHEN ' . singleQuote('PINTP') . ' THEN 0 ELSE ' . $s . '*(JELN.CREDIT_TRANS_AMT-JELN.DEBIT_TRANS_AMT) END)),0) INTPAID_AMT';
        $sql = 'SELECT ' . $cc . '   FROM ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN, ' . $this->fiasname . ' FIAS, ' . $this->filoname . ' FILO WHERE JELN.CHART_FIELD03 = FIAS.IDCODE AND JEHD.IDCODE = JELN.JEHDR_CODE AND FIAS.LOAN_CODE = FILO.IDCODE AND JEHD.JE_STATUS = ' . singleQuote('AP') . ' AND JELN.CURRENCY_CODE = FILO.CURRENCY_CODE AND FILO.IDCODE = ' . singleQuote($loan_code) . ' AND FILO.CLX_EFFTDATE  = ' . singleQuote($efftdate) . ' AND EXISTS(SELECT PRAT.ID FROM ' . $this->pratname . ' PRAT WHERE JELN.GLACCOUNTCODE IN (PRAT.AR_GL_CODE, PRAT.CINT_GL_CODE) AND PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE)';
        $r = ClxCommon::$db->getOneRecord($sql);
        //setting previoues amount for interest
        if (empty($r['INTEARNED_AMT']))
            $r['INTEARNED_AMT'] = CLX_INIT_ZERO;
        if (empty($r['INTPAID_AMT']))
            $r['INTPAID_AMT'] = CLX_INIT_ZERO;
        $sql = 'UPDATE ' . $this->filoname . '  SET PREV_INTEARNED_AMT = (INTEARNED_AMT-INTPAID_AMT), INTEARNED_AMT = ' . $r['INTEARNED_AMT'] . ', INTPAID_AMT = ' . $r['INTPAID_AMT'] . ' WHERE IDCODE = ' . singleQuote($loan_code) . ' AND CLX_EFFTDATE =' . singleQuote($efftdate);
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     * Updates loan balances based on accounting operation date
     *
     * @param string $loan_code
     */
    private function update_reserve_balance($loan_code, $efftdate) {
        $sql = 'SELECT IFNULL(SUM(JELN.DEBIT_TRANS_AMT-JELN.CREDIT_TRANS_AMT),0) RESERVE_AMT FROM ' . $this->jehdname . ' JEHD, ' . $this->jelnname . ' JELN, ' . $this->fiasname . ' FIAS, ' . $this->filoname . ' FILO, ' . $this->pratname . ' PRAT AND FILO.IDCODE = ' . singleQuote($loan_code) . ' AND FILO.CLX_EFFTDATE =' . singleQuote($efftdate);
        $intearned_amt = ClxCommon::$db->getOne($sql);
        //interest amount activos INTEARNED_AMT,PREV_INTEARNED_AMT,INTPAID_AMT
        $sql = 'UPDATE ' . $this->filoname . ' FILO SET FILO.RESERVE_AMT = ' . $intearned_amt . ' WHERE FILO.IDCODE = ' . singleQuote($loan_code) . ' AND FILO.CLX_EFFTDATE =NOW()';
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     * Updates loan balances based on accounting operation date
     *
     * @param string $loan_code
     * @param string $efftdate
     */
    private function update_fees_balance($loan_code, $efftdate) {
        //Commission COMMISSIONS_AMT,PREV_COMM_AMT
        $sql = 'SELECT GLPF.SEQNUM, GLPF.FEE_GL_CODE, GLPF.FEE2_GL_CODE, GLAC.GL_TYPE FROM ' . $this->glpfname . ' GLPF LEFT JOIN ' . $this->glacname . ' GLAC ON GLAC.IDCODE = FEE2_GL_CODE AND GLAC.GLGROUP_CODE = GLPF.GLGROUP_CODE WHERE GLPF.PRODUCT_CODE = (SELECT MAX(FILO.PRODUCT_CODE) FROM ' . $this->filoname . ' FILO WHERE FILO.IDCODE = ' . singleQuote($loan_code) . ' AND GLPF.STATUS = ' . singleQuote('A') . ' AND GLPF.FEE2_GL_CODE IS NOT null ORDER BY GLPF.SEQNUM ASC';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $sign = ($r['GL_TYPE'] === 'LI') ? -CLX_NUM_ONE : CLX_NUM_ONE;
            $i = $r['SEQNUM'];
            $fl = 'FILO.FEE_0' . $i . '_AMT';
            $sql = 'UPDATE ' . $this->filoname . ' FILO SET ' . $fl . ' = IFNULL((SELECT ' . $sign . '*SUM(JCBV.BALANCE_AMT) FROM ' . $this->jcbvname . ' JCBV, ' . $this->fiasname . ' FIAS WHERE JCBV.CHART_FIELD03 = FIAS.IDCODE AND JCBV.CURRENCY_CODE = FILO.CURRENCY_CODE AND JCBV.GLACCOUNTCODE = ' . singleQuote($r['FEE2_GL_CODE']) . ' AND FIAS.LOAN_CODE = FILO.IDCODE),0) WHERE FILO.IDCODE = ' . singleQuote($loan_code) . ' AND FILO.CLX_EFFTDATE >=' . singleQuote($efftdate);
            ClxCommon::$db->executeQuery($sql);
        }
    }

    /**
     * Evaluates operation type
     *
     * @param string $transtbl_code
     * @return string
     */
    private function credit_operation_type($transtbl_code, $is_payment = '') {
        $op_type = '';
        switch ($transtbl_code) {
            case 'SYS_CRED-PYMT':
                $op_type = 'PAY';
                break;
            case 'SYS_CRED-DISB':
                $op_type = 'DIS';
                break;
            case 'SYS_CRED-ADJ':
                $op_type = 'ADJ';
                break;
            case 'SYS_CRED_CAP':
                $op_type = 'CAP';
                break;
            default:
                if (strval($transtbl_code) === '') {
                    //Cualquier otra cosa se interpreta como un desembolso
                    //Ejemplo de iterfaz cobis con movimiento contable sin transacion
                    switch (strval($is_payment)) {
                        case '0':
                            $op_type = 'DIS';
                            break;
                        case '1':
                            $op_type = 'PAY';
                            break;
                        default:
                            $op_type = 'OTH';
                            break;
                    }
                } else {
                    //Si no es trasaccion de credito tratar de entender el signo
                    $sql = 'SELECT DEBIT_CREDIT FROM FIDU_TRANSACTION_SPLIT WHERE TRANSTBL_CODE = ' . singleQuote($transtbl_code) . ' AND AFFECT_TYPE=' . singleQuote('PRO_GL') . ';';
                    $debit_credit = ClxCommon::$db->getOne($sql);
                    if ($debit_credit === 'DR') {
                        $op_type = 'DIS';
                    } elseif ($debit_credit === 'CR') {
                        $op_type = 'PAY';
                    } else {
                        $op_type = '';
                    }
                }
                break;
        }

        return $op_type;
    }

    /**
     * Updates credit balance to date
     *
     * @param unknown_type $comp_code
     * @param unknown_type $efftdate
     */
    function update_balances_by_company($comp_code, $efftdate) {
        $sql = 'SELECT FILO.IDCODE FROM ' . $this->filoname . ' FILO WHERE FILO.COMP_CODE = ' . singleQuote($comp_code) . ' AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILOX WHERE FILO.IDCODE = FILOX.IDCODE AND FILOX.CLX_EFFTDATE<=' . singleQuote($this->today) . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while (($r = ClxCommon::$db->getNextRecord($rs, NUMERIC))) {
            $this->update_balances($r[CLX_NUM_ZERO]);
        }
    }

    /**
     * Changes status of a loan
     *
     * @param string $loan_code
     * @param string $status Loan current status
     * @param string $to_status Status to be set
     */
    function change_status($loan_code, $status, $to_status = 'PRE') {
        $sql = 'UPDATE CRED_CREDITS SET  LOAN_STATUS=' . singleQuote($status) . ' WHERE IDCODE = ' . singleQuote($loan_code) . ' AND LOAN_STATUS = ' . singleQuote($to_status);
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     * Metodo para creacion de subcuenta de efectivo
     * @param type $filorec
     * @return type
     */
    private function build_fias_fibk(&$filorec) {
        if ($filorec['PAY_BANKACT_NO'] === 'null' || empty($filorec['PAY_BANKACT_NO'])) {
            return;
        }
        //search if default contrac
        $sql = 'SELECT PRLT.CHART_FIELD01, PRLT.CHART_FIELD02 FROM CRED_PROD_PRMTR_TBL PRLT WHERE PRLT.PRODUCT_CODE = ' . singleQuote($filorec['PRODUCT_CODE']);
        $prltrec = ClxCommon::$db->getOneRecord($sql);
        if (!empty(UserRequest::$post['FILO_CONTRACT_CODE'])) {
            $prltrec['CHART_FIELD01'] = UserRequest::$post['FILO_CONTRACT_CODE'];
        }
        if (!empty(UserRequest::$post['FILO_PARTICIPANT_ID'])) {
            $prltrec['CHART_FIELD02'] = UserRequest::$post['FILO_PARTICIPANT_ID'];
        }
        if (!empty(UserRequest::$post['FILO_CONTRACT_CODE'])) {
            $prltrec['CHART_FIELD01'] = UserRequest::$post['FILO_CONTRACT_CODE'];
        }
        if (!empty(UserRequest::$post['FILO_PARTICIPANT_ID'])) {
            $prltrec['CHART_FIELD02'] = UserRequest::$post['FILO_PARTICIPANT_ID'];
        }
        //si no se determina el ccodigo del contrato regresar
        if (empty($prltrec['CHART_FIELD01']) || $prltrec['CHART_FIELD01'] === 'null') {
            return;
        }
        //test if already exists
        $sql = 'SELECT ID FROM ' . $this->fiasname . ' WHERE CONTRACT_CODE = ' . singleQuote(UserRequest::$post['FILO_CONTRACT_CODE'] .
                        '') . ' AND FIDU_BANKACT_CODE = ' . singleQuote($filorec['PAY_BANKACT_NO']) . ' AND TRUST_ITEM_TYPE = ' . singleQuote('CA') . '';
        $id = ClxCommon::$db->getOne($sql);
        if (!empty($id)) {
            return;
        }
        //test if already exists
        $fibkrec = ClxCommon::$db->getRecord($this->fibkname, 'BANK_ACCOUNT_NO = ' . singleQuote($filorec['PAY_BANKACT_NO']));
        $fibkrec['CONTRACT_CODE'] = UserRequest::$post['FILO_CONTRACT_CODE'];
        if (!class_exists('fibk_utilities'))
            includeCodeLib('FIBK');
        $fibk = new fibk_utilities();
        $fibk->build_fias($fibkrec);
    }

    /**
     * Builds fias record for loan
     *
     * @param array $filorec
     */
    function build_fias(&$filorec) {
        if ($filorec['IDCODE'] === 'AUTO')
            return; //No auto allow on create
//search if default contrac
        $sql = 'SELECT PRLT.CHART_FIELD01, PRLT.CHART_FIELD02 FROM CRED_PROD_PRMTR_TBL PRLT WHERE PRLT.PRODUCT_CODE = ' . singleQuote($filorec['PRODUCT_CODE']);
        $prltrec = ClxCommon::$db->getOneRecord($sql);
        //Read lookup info
        //if (array_key_exists('FILO_CONTRACT_CODE_prim', UserRequest::$post)) {
            getLookupValue('FILO_CONTRACT_CODE', 'CONTRACT_CODE', UserRequest::$post);
        //}
        //FILO_PARTICIPANT_ID_prim
        //if (array_key_exists('FILO_PARTICIPANT_ID_prim', UserRequest::$post)) {
            getLookupValue('FILO_PARTICIPANT_ID_prim', 'PARTICIPANT_ID', UserRequest::$post);
        //}
        if (!empty(UserRequest::$post['FILO_CONTRACT_CODE'])) {
            $prltrec['CHART_FIELD01'] = UserRequest::$post['FILO_CONTRACT_CODE'];
        }
        if (!empty(UserRequest::$post['FILO_PARTICIPANT_ID'])) {
            $prltrec['CHART_FIELD02'] = UserRequest::$post['FILO_PARTICIPANT_ID'];
        }
        if ($filorec['EXT_PRODUCT_CODE'] === 'null') {
            $filorec['EXT_PRODUCT_CODE'] = $filorec['IDCODE'];
        }
        //si no se determina el ccodigo del contrato regresar
        if (empty($prltrec['CHART_FIELD01']) || $prltrec['CHART_FIELD01'] === 'null') {
            return;
        }
        //test if already exists
        $sql = 'SELECT ID FROM ' . $this->fiasname . ' WHERE TRUST_ITEM_TYPE = "CR" AND LOAN_CODE = ' . singleQuote($filorec['IDCODE']) . ' ';
        if (!empty($filorec['EXT_PRODUCT_CODE'])) {
            $sql .=' OR (TRUST_ITEM_TYPE = "CR" AND EXT_PRODUCT_CODE = ' . singleQuote($filorec['EXT_PRODUCT_CODE']) . ' AND (LOAN_CODE = ' . singleQuote($filorec['IDCODE']) . ' OR LOAN_CODE IS NULL))';
        }
        $sql .=' ORDER BY LOAN_CODE DESC';
        $id = ClxCommon::$db->getOne($sql);
        if (!empty($id)) {
            $sql = 'UPDATE ' . $this->fiasname . ' SET IDNAME = ' . singleQuote($filorec['IDNAME']) . ', LOAN_CODE = ' . singleQuote($filorec['IDCODE']) . ', EXT_PRODUCT_CODE = ' . singleQuote($filorec['EXT_PRODUCT_CODE']) . ', CONTRACT_CODE=' . singleQuote($prltrec['CHART_FIELD01']) . ', ACCOUNTCODE=' . (($prltrec['CHART_FIELD02'] === '') ? 'null' : singleQuote($prltrec['CHART_FIELD02']) ) .
                    ' WHERE ID = ' . $id;
            ClxCommon::$db->executeQuery($sql);
            return;
        }
        //set fias type
        $sql = 'SELECT PROD.CURRENCY_CODE, GLAC.GL_TYPE, GLAC.TRUST_ITEM_TYPE FROM CRM_PRODUCTS PROD, GL_PROD_PRMTR_TBL PRAT, GL_CODES_TBL GLAC WHERE GLAC.IDCODE = PRAT.PRO_GL_CODE AND GLAC.GLGROUP_CODE = PRAT.GLGROUP_CODE AND PRAT.PRODUCT_CODE = ' . singleQuote($filorec['PRODUCT_CODE']);
        $pratrec = ClxCommon::$db->getOneRecord($sql);
        $r = array('LOAN_CODE' => $filorec['IDCODE'],
            'EXT_PRODUCT_CODE' => $filorec['EXT_PRODUCT_CODE'],
            'GL_TYPE' => $pratrec['GL_TYPE'],
            'TRUST_ITEM_TYPE' => $pratrec['TRUST_ITEM_TYPE'],
            'CURRENCY_CODE' => $filorec['CURRENCY_CODE'],
            'CONTRACT_CODE' => $prltrec['CHART_FIELD01'],
            'ACCOUNTCODE' => $prltrec['CHART_FIELD02'],
            'IDNAME' => $filorec['IDNAME'],
            'FIDU_BANKACT_CODE' => 'null',
            'ASSET_CODE' => 'null');
        if (!empty($r['CONTRACT_CODE'])) {
            if (!class_exists('Fias'))
                includeCodeLib('FIAS');
            $fias = new Fias();
            $fias->fias_build($r);
            unset($fias);
        }
    }

    function build_fias_from_rec(&$filorec) {
        //set fias type
        $sql = 'SELECT PROD.CURRENCY_CODE, GLAC.GL_TYPE, GLAC.TRUST_ITEM_TYPE FROM CRM_PRODUCTS PROD, GL_PROD_PRMTR_TBL PRAT, GL_CODES_TBL GLAC WHERE GLAC.IDCODE = PRAT.PRO_GL_CODE AND GLAC.GLGROUP_CODE = PRAT.GLGROUP_CODE AND PRAT.PRODUCT_CODE = ' . singleQuote($filorec['PRODUCT_CODE']);
        $pratrec = ClxCommon::$db->getOneRecord($sql);
        $r = array('LOAN_CODE' => $filorec['IDCODE'],
            'EXT_PRODUCT_CODE' => $filorec['EXT_PRODUCT_CODE'],
            'GL_TYPE' => $pratrec['GL_TYPE'],
            'TRUST_ITEM_TYPE' => $pratrec['TRUST_ITEM_TYPE'],
            'CURRENCY_CODE' => $pratrec['CURRENCY_CODE'],
            'CONTRACT_CODE' => $filorec['CHART_FIELD01'],
            'ACCOUNTCODE' => $filorec['CHART_FIELD02'],
            'IDNAME' => $filorec['IDNAME'],
            'FIDU_BANKACT_CODE' => 'null',
            'ASSET_CODE' => 'null');
        if (!empty($r['CONTRACT_CODE'])) {
            if (!class_exists('Fias'))
                includeCodeLib('FIAS');
            $fias = new Fias();
            $fias->fias_build($r);
            $filorec['CHART_FIELD03'] = $r['IDCODE'];
            unset($fias);
        }
    }

    // Procesos de Credito
    /**
     * Daily closing cron processes
     *
     * @param string $comp_code
     */
    function filo_daily_close_cron($comp_code) {
        $this->display = true;
        $start_time = microtime_float();
        $this->initTemporaryTables($this->batch_id);
        //first check index change
        $this->var_interest_adj($comp_code);
        echoLog('<br>filo var_interest_adj Elapse: ' . (microtime_float() - $start_time));
        //Revision de saldos
        $this->filo_register_late_amounts($comp_code, '');
        echoLog('<br>filo_register_late_amounts Elapse: ' . (microtime_float() - $start_time));
        //Cambio contable
        $this->gl_account_change($comp_code);
        echoLog('<br>filo gl_account_change Elapse: ' . (microtime_float() - $start_time));
        //Comisiones de mora
        $this->fees($comp_code);
        echoLog('<br>filo fees Elapse: ' . (microtime_float() - $start_time));
        //Evaluar ejecucion de provision y calificacion del cliente
        $glcp = ClxCommon::$db->getFields($this->glcpname, 'OPERATION_DATE, CR_PROV_FREQ, AC_QUAL_FREQ, CR_PROV_DAY, AC_QUAL_DAY', 'COMP_CODE = ' . singleQuote($comp_code));
        $run_prov = false;
        if (!empty($glcp['CR_PROV_FREQ'])) {
            $rdate = substr($glcp['OPERATION_DATE'], CLX_NUM_ZERO, CLX_NUM_8) . str_pad($glcp['CR_PROV_DAY'], CLX_NUM_TWO, '0', STR_PAD_LEFT);
            if ($glcp['CR_PROV_FREQ'] === 'D') {
                $run_prov = true;
            } elseif ($glcp['CR_PROV_FREQ'] === 'M') {
                if ($glcp['CR_PROV_DAY'] >= CLX_NUM_ONE && $glcp['CR_PROV_DAY'] <= CLX_NUM_28 && $rdate == $glcp['OPERATION_DATE']) {
                    $run_prov = true;
                } elseif (!($glcp['CR_PROV_DAY'] >= CLX_NUM_ONE && $glcp['CR_PROV_DAY'] <= CLX_NUM_28) && adodb_month_last_day($glcp['OPERATION_DATE'])) {
                    ////for 0, 29,30,31
                    $run_prov = true;
                }
            }
        }
        if ($run_prov === true) {
            //Revisionde calificaciones de credito
            $this->set_cred_calification_by_comp($comp_code);
            echoLog('Credit cualification Elapse: ' . (microtime_float() - $start_time));
        }
        $run_qual = false;
        if (!empty($glcp['AC_QUAL_FREQ'])) {
            $rdate = substr($glcp['OPERATION_DATE'], CLX_NUM_ZERO, CLX_NUM_8) . str_pad($glcp['AC_QUAL_DAY'], CLX_NUM_TWO, '0', STR_PAD_LEFT);
            if ($glcp['AC_QUAL_FREQ'] === 'D') {
                $run_qual = true;
            } elseif ($glcp['AC_QUAL_FREQ'] === 'M') {
                if ($glcp['AC_QUAL_DAY'] >= CLX_NUM_ONE && $glcp['AC_QUAL_DAY'] <= CLX_NUM_28 && $rdate == $glcp['OPERATION_DATE']) {
                    $run_qual = true;
                } elseif (!($glcp['AC_QUAL_DAY'] >= CLX_NUM_ONE && $glcp['AC_QUAL_DAY'] <= CLX_NUM_28) && adodb_month_last_day($glcp['OPERATION_DATE'])) {
                    ////for 0, 29,30,31
                    $run_qual = true;
                }
            }
        }
        if ($run_qual === true) {
            //Proceso de provision de creditos incobrables
            $this->late_cred_provision($comp_code, false);
            echoLog('filo late_cred_provision Elapse: ' . (microtime_float() - $start_time));
        }
    }

    /**
     * Daily closing cron processes after cron
     *
     * @param string $comp_code
     */
    function filo_daily_close_post_cron($comp_code) {
        //Interest
        $this->filo_earn_interest($comp_code, '', false);
    }

    /**
     * Calculates late amount for ending periods
     * @param string $comp_code
     * @param string $loan_code
     */
    function filo_register_late_amounts($comp_code, $loan_code = '') {
        //1. Se calcula monto tarde en monto tarde en fecha de vencimiento de couta.
        //el unico otro Este monto baja en caso de operaciones puntuales el cual baja este monto
        //este monto se utiliza para calculo de moras
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        $comp = new Comp();
        $comprec = $comp->comp_operation_parameters($comp_code);
        $operation_date = $comprec['OPERATION_DATE'];
        //Init Temporary Tables
        $this->initTemporaryTables($this->batch_id);
        //Find any case to recalculate late amounts only if
        $sql = 'INSERT INTO ' . $this->glt1name . '  (BATCH_ID, GEN_PERIOD, LOAN_CODE, EFFTDATE, PRODUCT_CODE) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, FILO.ID GEN_PERIOD, FILO.IDCODE LOAN_CODE, FILO.CLX_EFFTDATE EFFTDATE, FILO.PRODUCT_CODE FROM ' . $this->filoname . ' FILO WHERE FILO.COMP_CODE = ' . singleQuote($comp_code) . ' ' . (($loan_code !== '') ? ' AND FILO.IDCODE =' . singleQuote($loan_code) . ' ' : '') . ' AND EXISTS(SELECT FILS.ID FROM ' . $this->filsname . ' FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.EFFTDATE = FILO.CLX_EFFTDATE AND FILS.DUE_PAY_DATE = ' . singleQuote($operation_date) . ') AND FILO.CLX_EFFTDATE = (SELECT MAX(FILO2.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILO2 WHERE FILO2.IDCODE = FILO.IDCODE AND FILO2.CLX_EFFTDATE<=' . singleQuote($this->today) . ')';
        ClxCommon::$db->executeQuery($sql);
        //Se resta los dias de gracia por el interes diario para no incluir los dias adicionales de interes.
        //Otra forma de manejarlo puede ser revisando los intereses del periodo sin embargo al ser pocos dias se revisa contra el diario para aprovechar el pre
        $sql = 'UPDATE ' . $this->filoname . ' FILO, ' . $this->glt1name . ' X SET FILO.DUE_PRO_AMT = IFNULL((SELECT SUM(FILS.PRINCIPAL_PAY-FILS.PPAL_PAID_AMT) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.EFFTDATE = FILO.CLX_EFFTDATE AND FILS.DUE_PAY_DATE <= ' . singleQuote($operation_date) . '), 0), FILO.DUE_AR_AMT = (FILO.INTEARNED_AMT-FILO.INTPAID_AMT), FILO.LAST_DUE_DATE = ' . singleQuote($operation_date) . ' WHERE FILO.IDCODE = X.LOAN_CODE AND FILO.CLX_EFFTDATE = X.EFFTDATE AND X.BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //Ajuste de diferentia entre monto pagado
        $sql = 'UPDATE ' . $this->filoname . ' FILO, ' . $this->glt1name . ' X SET FILO.DUE_AR_AMT = FILO.DUE_AR_AMT-IFNULL((SELECT SUM(GDVW.DEBIT_TRANS_AMT-GDVW.CREDIT_TRANS_AMT) BALANCE_AMT FROM ' . $this->gdvwname . ' GDVW, ' . $this->fiasname . ' FIAS, ' . $this->pratname . ' PRAT WHERE GDVW.CHART_FIELD03 = FIAS.IDCODE AND FILO.IDCODE = FIAS.LOAN_CODE AND PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE AND PRAT.AR_GL_CODE = GDVW.GLACCOUNTCODE AND GDVW.CURRENCY_CODE = FILO.CURRENCY_CODE AND GDVW.EFFTDATE > (SELECT MAX(FILS.PERIOD_END_DATE) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.EFFTDATE = FILO.CLX_EFFTDATE AND FILS.DUE_PAY_DATE = ' . singleQuote($operation_date) . ')),0) WHERE FILO.IDCODE = X.LOAN_CODE AND FILO.CLX_EFFTDATE = X.EFFTDATE AND X.BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->filoname . ' FILO, ' . $this->glt1name . ' X SET FILO.DUE_PRO_AMT = 0 WHERE FILO.DUE_PRO_AMT < 0 AND FILO.IDCODE = X.LOAN_CODE AND FILO.CLX_EFFTDATE = X.EFFTDATE AND X.BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->filoname . ' FILO, ' . $this->glt1name . ' X SET FILO.DUE_AR_AMT = 0 WHERE FILO.DUE_AR_AMT < 0 AND FILO.IDCODE = X.LOAN_CODE AND FILO.CLX_EFFTDATE = X.EFFTDATE AND X.BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        $this->initTemporaryTables($this->batch_id);
    }

    /**
     * Runs interest calculation from btn
     *
     */
    function filo_run_interest() {
        $idlist = getIdlist();
        if (empty($idlist)) {
            return;
        }
        $sql = 'SELECT DISTINCT COMP_CODE, IDCODE FROM ' . $this->filoname . '  WHERE ID IN (' . toString($idlist) . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while (($r = ClxCommon::$db->getNextRecord($rs, NUMERIC))) {
            $this->filo_earn_interest($r[CLX_NUM_ZERO], $r[CLX_NUM_ONE], false);
        }
    }

    /**
     * Proceso para devengar intereses de portafolio
     *
     * @param string $comp_code
     * @param string $loan_code
     * @param boolean $reserves_interest
     */
    public function filo_earn_interest($comp_code, $loan_code = '', $reserves_interest = false) {
        $this->je_source = ($reserves_interest === true) ? 'PINTR' : 'PINTP'; //provision de intereses de prestamos
        $DBLT = &getTool('DBLT');
        $idname = substr($DBLT->getListItem('SOTY', $this->je_source), CLX_NUM_ZERO, CLX_NUM_60);
        if (!class_exists('Comp')) {
            includeCodeLib('COMP');
        }
        $comp = new Comp();
        $comprec = $comp->comp_operation_parameters($comp_code);
        $operation_date = $comprec['OPERATION_DATE'];
        if ($this->display === true) {
            if ($reserves_interest === true) {
                echoLog(' CREDIT RESERVES INTEREST CALC PROCESS. BATCH ID: ' . $this->batch_id);
            } else {
                echoLog(' CREDIT INTEREST CALC PROCESS. BATCH ID: ' . $this->batch_id);
            }
            echoLog('Efective date: ' . $operation_date);
            echoLog('Credit: ' . (($loan_code === '') ? 'ALL' : $loan_code));
        }
        if (empty($comprec) || empty($comp_code)) {
            echoLog('Error, no company operation parameters found');
        }


        //Init Temporary Tables
        $this->initTemporaryTables($this->batch_id);
        if (!class_exists('Jehd'))
            includeCodeLib('Jehd');
        $jehd = new Jehd();
        $jehd->display = $this->display;
        //Reject any posible todays entry from this process thas has run today
        $jehd->jehd_reverse_by_je_source($comp_code, $this->je_source, $operation_date);
        //loading temporary table
        //Find any case to recalculate late amounts only if
        $sql = 'INSERT INTO ' . $this->glt1name . ' (BATCH_ID, GEN_PERIOD, LOAN_CODE, EFFTDATE, PRODUCT_CODE, CAPITALIZE, INT_ACCRUED_DAYS) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, FILO.ID GEN_PERIOD, FILO.IDCODE LOAN_CODE, FILO.CLX_EFFTDATE EFFTDATE, FILO.PRODUCT_CODE, PRLT.SIMPLE_INTEREST, 1 INT_ACCRUED_DAYS FROM ' . $this->filoname . ' FILO, ' . $this->prltname . ' PRLT WHERE FILO.COMP_CODE = ' . singleQuote($comp_code) . ' AND (FILO.PRINCIPAL_BAL > 0 OR (LOAN_STATUS = ' . singleQuote('CAN') . ' AND INTEARNED_AMT<INTPAID_AMT)) AND PRLT.PRODUCT_CODE = FILO.PRODUCT_CODE AND FILO.START_DATE<' . singleQuote($operation_date) . ' AND FILO.CALC_INTEREST = 1 ' . (($loan_code !== '') ? ' AND FILO.IDCODE =' . singleQuote($loan_code) . ' ' : '') . ' AND FILO.CLX_EFFTDATE = (SELECT MAX(FILO2.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILO2 WHERE FILO2.IDCODE = FILO.IDCODE AND FILO2.CLX_EFFTDATE<=' . singleQuote($this->today) . ' )';
        //Prevenir que corra 2 veces si ya corrio y no se ha reversado el asiento de devengo
        if ($loan_code === '') {
            $sql .= ' AND NOT EXISTS(SELECT JEHD.ID FROM ' . $this->jehdname . ' JEHD WHERE JEHD.COMP_CODE = ' . singleQuote($comp_code) . ' AND JEHD.JE_SOURCE = ' . singleQuote($this->je_source) . ' AND JEHD.EFFTDATE = ' . singleQuote($operation_date) . ' AND JEHD.REAL_DATE = ' . singleQuote($operation_date) . ' AND JEHD.JE_STATUS = ' . singleQuote('AP') . ' AND JEHD.REVERSED = 0) ';
        }
        ClxCommon::$db->executeQuery($sql);
        //Check if something to do
        if (ClxCommon::$db->countRecords($this->glt1name, 'BATCH_ID = ' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
            return;
        }
        /*
         * Notas sobre el contador de dias.
         * -Se es
         * -En inicio de couta se coloca en 0
         * -Durante cada devengo se incrementa 1 dia para devengos diarios
         * -Si es el dia de fin de periodo:
         *     1. Si el nro de debenfos es igual al numero de dias en couta solo dejar sin devengo.
         *     2. Si el nro de dias es mayor al no devengos colocar diferencia a devengar.
         */
        //Si es la fecha menor a la fecha de fin de couta
        //y el numero de dias devengados es menor al numero de dias en couta entonces agregar no dias.
        //Esto solo en interes simple = no
        $sql = 'UPDATE ' . $this->glt1name . ' GLT1, ' . $this->filoname . ' FILO, ' . $this->filsname . ' FILS SET GLT1.INT_ACCRUED_DAYS = IF(FILO.INT_ACCRUED_DAYS< FILS.NO_DAYS, (FILS.NO_DAYS-FILO.INT_ACCRUED_DAYS), 0) WHERE FILO.COMP_CODE = ' . singleQuote($comp_code) . ' AND FILO.IDCODE = FILS.LOAN_CODE AND FILO.CLX_EFFTDATE = FILS.EFFTDATE AND FILS.PERIOD_END_DATE = ' . singleQuote($operation_date) . ' AND FILO.IDCODE = GLT1.LOAN_CODE AND FILO.CLX_EFFTDATE = GLT1.EFFTDATE AND GLT1.CAPITALIZE = 0';
        ClxCommon::$db->executeQuery($sql);
        //Si el numero de devengos es igual al numero de dias a devengar
        //entonces no devengar mas - Esto solo en interes simple = no
        $sql = 'DELETE GLT1.* FROM ' . $this->glt1name . ' GLT1, ' . $this->filoname . ' FILO, ' . $this->filsname . ' FILS WHERE FILO.COMP_CODE = ' . singleQuote($comp_code) . ' AND FILO.IDCODE = FILS.LOAN_CODE AND FILO.CLX_EFFTDATE = FILS.EFFTDATE AND FILO.IDCODE = GLT1.LOAN_CODE AND FILO.CLX_EFFTDATE = GLT1.EFFTDATE AND FILS.PERIOD_START_DATE < ' . singleQuote($operation_date) . ' AND FILS.PERIOD_END_DATE >= ' . singleQuote($operation_date) . ' AND FILO.INT_ACCRUED_DAYS >= FILS.NO_DAYS AND GLT1.CAPITALIZE = 0';
        ClxCommon::$db->executeQuery($sql);
        //Colocar en 0 los casos donde el numero de dias devengados sea igual al numero de dias en cuota
        //AND X.CAPITALIZE = 0 Implica que no es interes simple
        $sql = 'UPDATE ' . $this->filoname . ' FILO, ' . $this->filsname . ' FILS, ' . $this->glt1name . ' GLT1 SET FILO.INT_ACCRUED_DAYS = 0 WHERE FILO.COMP_CODE = ' . singleQuote($comp_code) . ' AND FILO.IDCODE = GLT1.LOAN_CODE AND FILO.CLX_EFFTDATE = GLT1.EFFTDATE AND FILS.LOAN_CODE = FILO.IDCODE AND FILS.EFFTDATE = FILO.CLX_EFFTDATE AND FILS.PERIOD_START_DATE = ' . singleQuote($operation_date) . ' AND GLT1.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GLT1.CAPITALIZE = 0 AND FILO.CALC_INTEREST = 1 ';
        ClxCommon::$db->executeQuery($sql);
        /* UPDATING DAYLY INTEREST FOR SIMPLE INTEREST */
        $sql = 'UPDATE ' . $this->filoname . ' FILO, ' . $this->glt1name . ' X SET FILO.DAILY_INTEREST = IFNULL(ROUND(FILO.PRINCIPAL_BAL*((FILO.LOAN_INTEREST/100)/(case FILO.INTEREST_CALC WHEN ' . singleQuote('AC/AC') . ' THEN 365 WHEN ' . singleQuote('AC/360') . ' THEN 360 WHEN ' . singleQuote('30/360') . ' THEN 360 WHEN ' . singleQuote('AC/365') . ' THEN 365 WHEN ' . singleQuote('30/365') . ' THEN 365 ELSE FILO.INTEREST_CALC END)), 5),0), FILO.INTEARNED_ACC = FILO.INTEARNED_ACC+IFNULL(ROUND(FILO.PRINCIPAL_BAL*((FILO.LOAN_INTEREST/100)/(case FILO.INTEREST_CALC WHEN ' . singleQuote('AC/AC') . ' THEN 365 WHEN ' . singleQuote('AC/365') . ' THEN 360 WHEN ' . singleQuote('30/360') . ' THEN 360 WHEN ' . singleQuote('AC/365') . ' THEN 365 WHEN ' . singleQuote('30/365') . ' THEN 365 ELSE FILO.INTEREST_CALC END)), 5),0), FILO.LAST_INT_DATE = ' . singleQuote($operation_date) . ' WHERE FILO.COMP_CODE = ' . singleQuote($comp_code) . ' AND FILO.IDCODE = X.LOAN_CODE AND FILO.CLX_EFFTDATE = X.EFFTDATE AND X.CAPITALIZE = 1 AND X.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND FILO.CALC_INTEREST = 1 ' . (($loan_code !== '') ? ' AND FILO.IDCODE =' . singleQuote($loan_code) . ' ' : '');
        ClxCommon::$db->executeQuery($sql);
        /* #UPDATING DAILY INTEREST FOR NON SIMPLE INTEREST */
        $sql = 'UPDATE ' . $this->filoname . ' FILO, ' . $this->glt1name . ' X SET /* FILO.INT_ACCRUED_DAYS = FILO.INT_ACCRUED_DAYS+1, */ FILO.DAILY_INTEREST = IFNULL(ROUND( (SELECT MAX(FILS.LOAN_AMT*((FILS.LOAN_INTEREST/100)/(case FILS.INTEREST_CALC WHEN ' . singleQuote('AC/AC') . ' THEN 365 WHEN ' . singleQuote('AC/360') . ' THEN 360 WHEN ' . singleQuote('30/360') . ' THEN 360 WHEN ' . singleQuote('AC/365') . ' THEN 365 WHEN ' . singleQuote('30/365') . ' THEN 365 ELSE FILS.INTEREST_CALC END))) FROM ' . $this->filsname . ' FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.EFFTDATE = FILO.CLX_EFFTDATE AND FILS.PERIOD_START_DATE < ' . singleQuote($operation_date) . ' AND FILS.PERIOD_END_DATE >= ' . singleQuote($operation_date) . ') , 5),0) WHERE FILO.COMP_CODE = ' . singleQuote($comp_code) . ' AND FILO.IDCODE = X.LOAN_CODE AND FILO.CLX_EFFTDATE = X.EFFTDATE AND X.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND X.CAPITALIZE = 0 AND FILO.CALC_INTEREST = 1 ';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->filoname . ' FILO, ' . $this->glt1name . ' X SET /* FILO.INT_ACCRUED_DAYS = FILO.INT_ACCRUED_DAYS+1, */ FILO.INTEARNED_ACC = ROUND(FILO.INTEARNED_ACC+(FILO.DAILY_INTEREST*X.INT_ACCRUED_DAYS), 5), FILO.LAST_INT_DATE = ' . singleQuote($operation_date) . ' WHERE FILO.COMP_CODE = ' . singleQuote($comp_code) . ' AND FILO.IDCODE = X.LOAN_CODE AND FILO.CLX_EFFTDATE = X.EFFTDATE AND X.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND X.CAPITALIZE = 0 AND FILO.CALC_INTEREST = 1 ';
        ClxCommon::$db->executeQuery($sql);
        //Init Temporary Tables
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
        /* preparando registros para contabilizacion */
        $sql = 'INSERT INTO ' . $this->glt1name . '  (COMP_CODE, BATCH_ID, EFFTDATE, GLACCOUNTCODE, GL01_CODE, GL02_CODE, GL_TYPE, BALANCE_AMT, CALC_AMT_01, CALC_AMT_02, CALC_AMT_03, CALC_AMT_04, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, LOAN_CODE, PRODUCT_CODE) SELECT ' . singleQuote($comp_code) . ' COMP_CODE, ' . singleQuote($this->batch_id) . ' BATCH_ID, FILO.CLX_EFFTDATE EFFTDATE, case IFNULL(PRAT.CINT_GL_CODE, 0) WHEN 0 THEN PRAT.AR_GL_CODE ELSE PRAT.CINT_GL_CODE END GLACCOUNTCODE, case IFNULL(PRAT.CINT2_GL_CODE, 0) WHEN 0 THEN PRAT.INC_GL_CODE ELSE PRAT.CINT2_GL_CODE END GL01_CODE, PRAT.PRO_GL_CODE GL02_CODE, JCBV.GL_TYPE, FILO.PRINCIPAL_BAL BALANCE_AMT, ROUND(FILO.INTEARNED_ACC, 2) CALC_AMT_01, SUM(JCBV.BALANCE_AMT) CALC_AMT_02, 0 CALC_AMT_03, FILO.ID CALC_AMT_04, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, JCBV.CURRENCY_CODE, 1 CUR_OPERATOR, 1 EXCHANGE_RT, 0 DEBIT_AMT, 0 CREDIT_AMT, 0 DEBIT_TRANS_AMT, 0 CREDIT_TRANS_AMT, FILO.IDCODE LOAN_CODE, FILO.PRODUCT_CODE FROM ' . $this->filoname . ' FILO, ' . $this->pratname . ' PRAT, ' . $this->jcbvname . ' JCBV, ' . $this->fiasname . ' FIAS WHERE FILO.COMP_CODE = ' . singleQuote($comp_code) . ' AND PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE AND PRAT.PROD_STATUS = FILO.LOAN_STATUS AND JCBV.CHART_FIELD03 = FIAS.IDCODE AND FIAS.LOAN_CODE = FILO.IDCODE AND JCBV.GLACCOUNTCODE = PRAT.PRO_GL_CODE AND PRAT.CALC_INTEREST = 1 AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILOX WHERE FILOX.IDCODE = FILO.IDCODE AND FILOX.CLX_EFFTDATE <= ' . singleQuote($this->now) . ') AND FILO.LAST_INT_DATE = ' . singleQuote($operation_date) . (($loan_code !== '') ? ' AND FILO.IDCODE =' . singleQuote($loan_code) . ' ' : '') .
                ' GROUP BY FILO.CLX_EFFTDATE, PRAT.AR_GL_CODE, PRAT.CINT_GL_CODE, PRAT.INC_GL_CODE, PRAT.CINT2_GL_CODE, PRAT.PRO_GL_CODE, JCBV.GL_TYPE, FILO.PRINCIPAL_BAL, FILO.ID, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, JCBV.CURRENCY_CODE, FILO.IDCODE, FILO.PRODUCT_CODE HAVING CALC_AMT_01<>0';
        ClxCommon::$db->executeQuery($sql);
        /* Incorporando registros de creditos cancelados antes de tiempo
          para nivelar saldo de interes */
        $sql = 'INSERT INTO ' . $this->glt1name . '  (COMP_CODE, BATCH_ID, EFFTDATE, GLACCOUNTCODE, GL01_CODE, GL02_CODE, GL_TYPE, BALANCE_AMT, CALC_AMT_01, CALC_AMT_02, CALC_AMT_03, CALC_AMT_04, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, LOAN_CODE, PRODUCT_CODE) SELECT ' . singleQuote($comp_code) . ' COMP_CODE, ' . singleQuote($this->batch_id) . ' BATCH_ID, FILO.CLX_EFFTDATE EFFTDATE, JCBV.GLACCOUNTCODE, case IFNULL(PRAT.CINT2_GL_CODE, 0) WHEN 0 THEN PRAT.INC_GL_CODE ELSE PRAT.CINT2_GL_CODE END  GL01_CODE, PRAT.PRO_GL_CODE GL02_CODE, JCBV.GL_TYPE, FILO.PRINCIPAL_BAL BALANCE_AMT, SUM(JCBV.BALANCE_AMT) CALC_AMT_01, ROUND(FILO.INTEARNED_AMT-FILO.INTPAID_AMT, 2) CALC_AMT_02, 0 CALC_AMT_03, FILO.ID CALC_AMT_04, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, JCBV.CURRENCY_CODE, 1 CUR_OPERATOR, 1 EXCHANGE_RT, 0 DEBIT_AMT, 0 CREDIT_AMT, 0 DEBIT_TRANS_AMT, 0 CREDIT_TRANS_AMT, FILO.IDCODE LOAN_CODE, FILO.PRODUCT_CODE FROM ' . $this->filoname . ' FILO, ' . $this->pratname . ' PRAT, ' . $this->jcbvname . ' JCBV, ' . $this->fiasname . ' FIAS WHERE FILO.COMP_CODE = ' . singleQuote($comp_code) . ' AND PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE AND PRAT.PROD_STATUS = ' . singleQuote('VIG') . ' AND FILO.LOAN_STATUS = ' . singleQuote('CAN') . ' AND JCBV.CHART_FIELD03 = FIAS.IDCODE AND FIAS.LOAN_CODE = FILO.IDCODE AND FILO.INTEARNED_AMT <> FILO.INTPAID_AMT AND PRAT.CALC_INTEREST = 1 AND EXISTS(SELECT PRAT2.ID FROM ' . $this->pratname . ' PRAT2 WHERE PRAT2.PRODUCT_CODE = FILO.PRODUCT_CODE AND PRAT2.AR_GL_CODE = JCBV.GLACCOUNTCODE) AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILOX WHERE FILOX.IDCODE = FILO.IDCODE AND FILOX.CLX_EFFTDATE <= ' . singleQuote($this->now) . ') ' .
                (($loan_code !== '') ? ' AND FILO.IDCODE =' . singleQuote($loan_code) . ' ' : '') .
                'GROUP BY FILO.CLX_EFFTDATE, PRAT.INC_GL_CODE, PRAT.CINT2_GL_CODE, JCBV.GL_TYPE, FILO.PRINCIPAL_BAL, FILO.ID, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, JCBV.CURRENCY_CODE, FILO.IDCODE, FILO.PRODUCT_CODE HAVING CALC_AMT_01<>0';
        ClxCommon::$db->executeQuery($sql);
        //Descontando lo que se contabiliza.
        //Notar que 0.00964-ROUND('0.0'0964, 2) = -00036
        //por lo que se ajusta en caso de que la condicion sea muy pequena
        $sql = 'UPDATE ' . $this->filoname . ' FILO, ' . $this->glt1name . ' X SET FILO.INTEARNED_ACC = 0 WHERE FILO.COMP_CODE = ' . singleQuote($comp_code) . ' AND FILO.IDCODE = X.LOAN_CODE AND FILO.CLX_EFFTDATE = X.EFFTDATE AND X.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND FILO.INTEARNED_ACC<ROUND(FILO.INTEARNED_ACC, 2)';
        ClxCommon::$db->executeQuery($sql);
        //Descargando monto que se contabilizara del registro de credito.
        $sql = 'UPDATE ' . $this->filoname . ' FILO SET FILO.INTEARNED_ACC = FILO.INTEARNED_ACC - ROUND(FILO.INTEARNED_ACC, 2) WHERE EXISTS (SELECT GLT1.LOAN_CODE FROM  ' . $this->glt1name . ' GLT1 WHERE FILO.IDCODE = GLT1.LOAN_CODE AND FILO.CLX_EFFTDATE = GLT1.EFFTDATE AND GLT1.BATCH_ID = ' . singleQuote($this->batch_id) . ')';
        ClxCommon::$db->executeQuery($sql);
        //SUMARIZANDO TOTAL PARA DISTRIBUCION
        $sql = 'UPDATE ' . $this->glt1name . ' GLT1 SET GLT1.CALC_AMT_03 = (SELECT SUM(JCBV.BALANCE_AMT) FROM ' . $this->jcbvname . ' JCBV WHERE JCBV.CHART_FIELD03 = GLT1.CHART_FIELD03 AND JCBV.GLACCOUNTCODE = GLT1.GL02_CODE AND JCBV.CURRENCY_CODE = GLT1.CURRENCY_CODE) WHERE GLT1.BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //Set type AS/LI
        $sql = 'UPDATE ' . $this->glt1name . '  GLT1 SET GLT1.GL_TYPE = (SELECT MAX(GLAC.GL_TYPE) FROM ' . $this->glacname . ' GLAC WHERE GLAC.IDCODE = GLT1.GL02_CODE) WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //setting exchange
        $sql = 'SELECT DISTINCT CURRENCY_CODE FROM ' . $this->glt1name . '  WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $rate = $comp->comp_current_exchange($comp_code, $r['CURRENCY_CODE'], $operation_date);
            $sql = 'UPDATE ' . $this->glt1name . ' SET CUR_OPERATOR = ' . singleQuote($rate['CUR_OPERATOR']) . ', EXCHANGE_RT = ' . singleQuote($rate['EXCHANGE_RT']) . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND CURRENCY_CODE = ' . singleQuote($r['CURRENCY_CODE']);
            ClxCommon::$db->executeQuery($sql);
        } //end while
        //Delete all participants where rows from overdraft loans. or cero that will not earn int.
        $sql = 'DELETE FROM ' . $this->glt1name . ' WHERE CALC_AMT_02 = 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //Generando Distribucion
        $sql = 'UPDATE ' . $this->glt1name . ' SET BALANCE_AMT = ROUND(CALC_AMT_01*(CALC_AMT_02/CALC_AMT_03), 2) WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //Ajustando rounding de distribucion
        $sql = 'SELECT LOAN_CODE, (SUM(BALANCE_AMT)-CALC_AMT_01) DIF FROM ' . $this->glt1name . '  WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' GROUP BY LOAN_CODE, CALC_AMT_04 HAVING (SUM(BALANCE_AMT)-CALC_AMT_04)<>0';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $sql = 'SELECT CHART_FIELD01, CHART_FIELD02 FROM ' . $this->glt1name . '  WHERE LOAN_CODE = ' . singleQuote($r['LOAN_CODE']) . ' LIMIT 1';
            $part = ClxCommon::$db->getOneRecord($sql);
            $sql = 'UPDATE ' . $this->glt1name . ' SET BALANCE_AMT = BALANCE_AMT + ' . $r['DIF'] . ' WHERE LOAN_CODE = ' . singleQuote($r['LOAN_CODE']) . ' AND BATCH_ID = ' . singleQuote($this->batch_id) . ' AND CHART_FIELD01 = ' . singleQuote($part['CHART_FIELD01']) . ' AND CHART_FIELD02 = ' . singleQuote($part['CHART_FIELD02']);
            ClxCommon::$db->executeQuery($sql);
        }
        //Colocando contabilidad
        $sql = 'UPDATE ' . $this->glt1name . '  SET DEBIT_AMT = BALANCE_AMT, DEBIT_TRANS_AMT = BALANCE_AMT WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE = ' . singleQuote('AS') . ' AND BALANCE_AMT>0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt1name . '  SET CREDIT_AMT = -1*BALANCE_AMT, CREDIT_TRANS_AMT = -1*BALANCE_AMT WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE = ' . singleQuote('AS') . ' AND BALANCE_AMT<0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt1name . '  SET CREDIT_AMT = BALANCE_AMT, CREDIT_TRANS_AMT = BALANCE_AMT WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE <> ' . singleQuote('AS') . ' AND BALANCE_AMT>0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt1name . '  SET DEBIT_AMT = -1*BALANCE_AMT, DEBIT_TRANS_AMT = -1*BALANCE_AMT WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE <> ' . singleQuote('AS') . ' AND BALANCE_AMT<0';
        ClxCommon::$db->executeQuery($sql);
        //Perform conversions
        $sql = 'UPDATE ' . $this->glt1name . ' SET DEBIT_AMT = ROUND(DEBIT_AMT*POW(EXCHANGE_RT, CUR_OPERATOR), 2) WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND DEBIT_AMT<>0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt1name . ' SET CREDIT_AMT = ROUND(CREDIT_AMT*POW(EXCHANGE_RT, CUR_OPERATOR), 2) WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND CREDIT_AMT<>0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'DELETE FROM ' . $this->glt1name . ' WHERE CREDIT_AMT=0 AND 	DEBIT_AMT = 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        /* 2. GENERAR ACTIVIDADES DE DEVENGO PARA PARTICIPANTES DE CONTRATO */
        //Build Header for this process, one pre currency
        $sql = 'SELECT DISTINCT COMP_CODE, ' . singleQuote($operation_date) . ' OPERATION_DATE, ' . singleQuote($comprec['LGGROUP_CODE']) . ' LGGROUP_CODE FROM ' . $this->glt1name . '  WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            $gl_rec = $jehd->jehd_init_record();
            $gl_rec['IDNAME'] = $idname;
            $gl_rec['JE_SOURCE'] = $this->je_source;
            $gl_rec['LGGROUP_CODE'] = $result['LGGROUP_CODE'];
            $gl_rec['EFFTDATE'] = $result['OPERATION_DATE'];
            $gl_rec['REAL_DATE'] = $result['OPERATION_DATE'];
            $gl_rec['COMP_CODE'] = $result['COMP_CODE'];
            $gl_rec['TRANS_CODE'] = null;
            if ($reserves_interest === true) {
                $gl_rec['TRANSTBL_CODE'] = 'SYS_CRED-RES';
            } else {
                $gl_rec['TRANSTBL_CODE'] = 'SYS_CRED-INTE';
            }
            $gl_rec['REQ_CHANNEL'] = 'SYS';
            $gl_rec['BATCH_ID'] = $this->batch_id;
            $jehd->jehd_build($gl_rec);
            //Search any scale if apply and dump lines to journal
            $sql = 'INSERT INTO ' . $this->jelnname . '  (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec['IDCODE']) . ' JEHDR_CODE, X.GLACCOUNTCODE GLACCOUNTCODE, ' . singleQuote('IP') . ' ITEM_CODE, X.CHART_FIELD01, X.CHART_FIELD02, X.CHART_FIELD03, X.CHART_FIELD04, X.LOAN_CODE ITEM_REF_NO, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR, X.DEBIT_AMT, X.CREDIT_AMT, X.DEBIT_TRANS_AMT, X.CREDIT_TRANS_AMT, 1 SEQNUM FROM ' . $this->glt1name . ' X WHERE BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            //contraparte
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec['IDCODE']) . ' JEHDR_CODE, X.GL01_CODE GLACCOUNTCODE, ' . singleQuote('IP') . ' ITEM_CODE, X.CHART_FIELD01, X.CHART_FIELD02, X.CHART_FIELD03, X.CHART_FIELD04, X.LOAN_CODE ITEM_REF_NO, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR, X.CREDIT_AMT DEBIT_AMT, X.DEBIT_AMT CREDIT_AMT, X.CREDIT_TRANS_AMT DEBIT_AMT, X.DEBIT_TRANS_AMT CREDIT_AMT, 2 SEQNUM FROM ' . $this->glt1name . ' X WHERE BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            //Removing sub account from in,ex,eq
            $sql = 'UPDATE ' . $this->jelnname . ' JELN SET JELN.CHART_FIELD03 = null WHERE JELN.JEHDR_CODE = ' . singleQuote($gl_rec['IDCODE']) . ' AND EXISTS(SELECT GLAC.ID FROM ' . $this->glacname . ' GLAC WHERE GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLAC.GL_TYPE IN (' . singleQuote('IN') . ',' . singleQuote('EX') . ',' . singleQuote('EQ') . '))';
            ClxCommon::$db->executeQuery($sql);
            //Verificando conversion;
            $jehd->balance_exchange_rounding($gl_rec['IDCODE']);
            $jehd->jehd_approve_by_code($gl_rec['IDCODE']);
        }
    }

    function run_gl_account_change() {
        $idlist = getIdlist();
        if (empty($idlist))
            return;
        $sql = 'SELECT DISTINCT COMP_CODE, IDCODE FROM ' . $this->filoname . '  WHERE ID IN (' . toString($idlist) . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while (($r = ClxCommon::$db->getNextRecord($rs, NUMERIC))) {
            $this->gl_account_change($r[CLX_NUM_ZERO], $r[CLX_NUM_ONE]);
        }
    }

    /**
     * Product gl account change process
     *
     * @param atring $comp_code
     * @param string $loan_code
     */
    private function gl_account_change($comp_code, $loan_code = '') {
        /*
          1 Si due_date>operation && due_amt then add late_day
          2. Si late_day == new status date -> change status from previous to new on late amount 3. Si hay pago descontar de registro con menor fecha efectiva 4. Volver al inicio y Repetir */
        $sql = 'SELECT X.QTY, X.LOAN_CODE, X.EFFTDATE, X.PRINCIPAL_PAY, X.PPAL_PAID_AMT, X.INTEREST_PAY, X.INTPAID_AMT, (X.PRINCIPAL_PAY+X.INTEREST_PAY) CAP_INT_PAY, (X.PPAL_PAID_AMT+X.INTPAID_AMT) CAP_INT_PAID /* nuevo */ ,(SELECT COUNT(COPE.TRANSTBL_CODE) FROM CRED_OPERATION COPE WHERE COPE.LOAN_CODE=X.LOAN_CODE AND COPE.TRANSTBL_CODE IN (' . singleQuote('SYS_CRED-DISB') . ',' . singleQuote('CRED_REFREO') . ') AND COPE.TRANS_STATUS = ' . singleQuote('AP') . ' ) OPERATION_TYPE /* fin nuevo */ ,(SELECT COUNT(FIAT.TRANSTBL_CODE) FROM FIDU_TRANSACTIONS FIAT, GL_JOURNAL_HDR JEHD, CRED_EXTENSION CRRP WHERE FIAT.JEHDR_CODE=JEHD.IDCODE AND JEHD.IDCODE=CRRP.JEHDR_CODE AND CRRP.NEW_LOAN_CODE=X.LOAN_CODE AND FIAT.TRANSTBL_CODE = '.singleQuote('SYS_CRED-REE').' AND FIAT.TRANS_STATUS = '.singleQuote('AP').' ) CRED_EXT FROM ( SELECT COUNT(FILO.ID) QTY,FILO.IDCODE LOAN_CODE, FILO.CLX_EFFTDATE EFFTDATE, SUM(FILS.PRINCIPAL_PAY) PRINCIPAL_PAY, (SELECT SUM(FILS2.PPAL_PAID_AMT) FROM CRED_PAYMNT_SCHEDULES FILS2 WHERE FILS2.LOAN_CODE = FILO.IDCODE AND FILS2.EFFTDATE = FILO.CLX_EFFTDATE) PPAL_PAID_AMT, SUM(FILS.INTEREST_PAY) INTEREST_PAY, (SELECT SUM(FILS2.INTPAID_AMT) FROM CRED_PAYMNT_SCHEDULES FILS2 WHERE FILS2.LOAN_CODE = FILO.IDCODE AND FILS2.EFFTDATE = FILO.CLX_EFFTDATE) INTPAID_AMT FROM ' . $this->filoname . ' FILO, ' . $this->filsname . ' FILS, ' . $this->glcpname . ' GLCP, ' . $this->prltname . ' PRLT WHERE FILO.COMP_CODE = GLCP.COMP_CODE AND FILO.IDCODE = FILS.LOAN_CODE AND FILO.CLX_EFFTDATE = FILS.EFFTDATE AND (((PRLT.STATUS_COND_01 = '.singleQuote('0').' OR (PRLT.STATUS_COND_01 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND (PRLT.PROD_STATUS_01 NOT IN (FILO.LOAN_STATUS , '. singleQuote(CLX_CHAR_EMPTY_STRING) .') AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.DAYS_STATUS_01 AND PRLT.UOM_STATUS_01 = '.singleQuote('0').') OR ((PRLT.STATUS_COND_02 = '.singleQuote('0').' OR (PRLT.STATUS_COND_02 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE) OR (PRLT.STATUS_COND_02 = '.singleQuote('2').' AND FILO.END_DATE<=GLCP.OPERATION_DATE)) AND PRLT.PROD_STATUS_02 NOT IN (FILO.LOAN_STATUS , '. singleQuote(CLX_CHAR_EMPTY_STRING) .') AND ((DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.DAYS_STATUS_02) OR (DATEDIFF(GLCP.OPERATION_DATE, FILO.END_DATE) = PRLT.DAYS_STATUS_02 AND PRLT.STATUS_COND_02 = '.singleQuote('2').')) AND PRLT.UOM_STATUS_02 = '.singleQuote('0').') OR ((PRLT.STATUS_COND_03 = '.singleQuote('0').' OR (PRLT.STATUS_COND_03 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND PRLT.PROD_STATUS_03 NOT IN (FILO.LOAN_STATUS , '. singleQuote(CLX_CHAR_EMPTY_STRING) .') AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.DAYS_STATUS_03 AND PRLT.UOM_STATUS_03 = '.singleQuote('0').') OR ((PRLT.STATUS_COND_04 = '.singleQuote('0').' OR (PRLT.STATUS_COND_04 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND PRLT.PROD_STATUS_04 NOT IN (FILO.LOAN_STATUS , '. singleQuote(CLX_CHAR_EMPTY_STRING) .') AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.DAYS_STATUS_04 AND PRLT.UOM_STATUS_04 = '.singleQuote('0').') OR (PRLT.REC_CAPTLZTION_DAYS > 0 AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.REC_CAPTLZTION_DAYS)) OR ((PRLT.STATUS_COND_01 = '.singleQuote('0').' OR (PRLT.STATUS_COND_01 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND (PRLT.PROD_STATUS_01 NOT IN (FILO.LOAN_STATUS , '. singleQuote(CLX_CHAR_EMPTY_STRING) .') AND (SELECT COUNT(*) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PAID_AMT = 0) = PRLT.DAYS_STATUS_01 AND PRLT.UOM_STATUS_01 = '.singleQuote('1').') OR ((PRLT.STATUS_COND_02 = '.singleQuote('0').' OR (PRLT.STATUS_COND_02 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND PRLT.PROD_STATUS_02 NOT IN (FILO.LOAN_STATUS , '. singleQuote(CLX_CHAR_EMPTY_STRING) .') AND (SELECT COUNT(*) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PAID_AMT = 0) = PRLT.DAYS_STATUS_02 AND PRLT.UOM_STATUS_02 = '.singleQuote('1').') OR ((PRLT.STATUS_COND_03 = '.singleQuote('0').' OR (PRLT.STATUS_COND_03 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND PRLT.PROD_STATUS_03 NOT IN (FILO.LOAN_STATUS , '. singleQuote(CLX_CHAR_EMPTY_STRING) .') AND (SELECT COUNT(*) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PAID_AMT = 0) = PRLT.DAYS_STATUS_03 AND PRLT.UOM_STATUS_03 = '.singleQuote('1').') OR ((PRLT.STATUS_COND_04 = '.singleQuote('0').' OR (PRLT.STATUS_COND_04 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND PRLT.PROD_STATUS_04 NOT IN (FILO.LOAN_STATUS , '. singleQuote(CLX_CHAR_EMPTY_STRING) .') AND (SELECT COUNT(*) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PAID_AMT = 0) = PRLT.DAYS_STATUS_04 AND PRLT.UOM_STATUS_04 = '.singleQuote('1').') OR (PRLT.REC_CAPTLZTION_DAYS > 0 AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.REC_CAPTLZTION_DAYS))) AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PERIOD_END_DATE = CRED_CHECK_DUE_DATE(FILO.IDCODE,FILO.CLX_EFFTDATE,GLCP.OPERATION_DATE) /*(SELECT MAX(FILSX.PERIOD_END_DATE) FROM ' . $this->filsname . ' FILSX WHERE FILSX.LOAN_CODE = FILO.IDCODE AND FILSX.EFFTDATE = FILO.CLX_EFFTDATE AND FILSX.DUE_PAY_DATE<=GLCP.OPERATION_DATE)*/ AND FILO.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM CRED_CREDITS X WHERE X.IDCODE = FILO.IDCODE AND X.CLX_EFFTDATE<=' . singleQuote($this->today) . ' ) AND PRLT.PRODUCT_CODE = FILO.PRODUCT_CODE AND FILO.COMP_CODE = ' . singleQuote($comp_code) . (($loan_code !== '') ? ' AND FILO.IDCODE = ' . singleQuote($loan_code) : '') . ' AND FILO.LOAN_STATUS NOT IN (' . singleQuoteArray(array('REEC', 'CAN')) . ') /* AND FILO.LOAN_STATUS <> ' . singleQuote('VEN') . ' */ AND ((SELECT COUNT(COPE.TRANSTBL_CODE) FROM CRED_OPERATION COPE WHERE COPE.LOAN_CODE=FILO.IDCODE AND COPE.TRANSTBL_CODE IN (' . singleQuote('SYS_CRED-DISB') . ',' . singleQuote('CRED_REFREO') . ') AND COPE.TRANS_STATUS = ' . singleQuote('AP') . ' ) OR (SELECT COUNT(FIAT.TRANSTBL_CODE) FROM FIDU_TRANSACTIONS FIAT, GL_JOURNAL_HDR JEHD, CRED_EXTENSION CRRP WHERE FIAT.JEHDR_CODE=JEHD.IDCODE AND JEHD.IDCODE=CRRP.JEHDR_CODE AND CRRP.NEW_LOAN_CODE=FILO.IDCODE AND FIAT.TRANSTBL_CODE = '.singleQuote('SYS_CRED-REE').' AND FIAT.TRANS_STATUS = ' . singleQuote('AP') . ' )) > 0 ) X HAVING        /*OPERATION_TYPE > 0  */ (OPERATION_TYPE > 0 OR CRED_EXT > 0) /* WHERE (X.PRINCIPAL_PAY+X.INTEREST_PAY) > (X.PPAL_PAID_AMT+X.INTPAID_AMT) */';
        //ORIGINAL $sql = 'SELECT X.QTY, X.PRINCIPAL_PAY, X.PPAL_PAID_AMT, X.INTEREST_PAY, X.INTPAID_AMT, (X.PRINCIPAL_PAY+X.INTEREST_PAY) CAP_INT_PAY, (X.PPAL_PAID_AMT+X.INTPAID_AMT) CAP_INT_PAID FROM ( SELECT COUNT(FILO.ID) QTY, SUM(FILS.PRINCIPAL_PAY) PRINCIPAL_PAY, (SELECT SUM(FILS2.PPAL_PAID_AMT) FROM CRED_PAYMNT_SCHEDULES FILS2 WHERE FILS2.LOAN_CODE = FILO.IDCODE AND FILS2.EFFTDATE = FILO.CLX_EFFTDATE) PPAL_PAID_AMT, SUM(FILS.INTEREST_PAY) INTEREST_PAY, (SELECT SUM(FILS2.INTPAID_AMT) FROM CRED_PAYMNT_SCHEDULES FILS2 WHERE FILS2.LOAN_CODE = FILO.IDCODE AND FILS2.EFFTDATE = FILO.CLX_EFFTDATE) INTPAID_AMT FROM ' . $this->filoname . ' FILO, ' . $this->filsname . ' FILS, ' . $this->glcpname . ' GLCP, ' . $this->prltname . ' PRLT WHERE FILO.COMP_CODE = GLCP.COMP_CODE AND FILO.IDCODE = FILS.LOAN_CODE AND FILO.CLX_EFFTDATE = FILS.EFFTDATE AND ((PRLT.PROD_STATUS_01 NOT IN (FILO.LOAN_STATUS , ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.DAYS_STATUS_01) OR (PRLT.PROD_STATUS_02 NOT IN (FILO.LOAN_STATUS , ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.DAYS_STATUS_02) OR (PRLT.PROD_STATUS_03 NOT IN (FILO.LOAN_STATUS , ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.DAYS_STATUS_03) OR (PRLT.PROD_STATUS_04 NOT IN (FILO.LOAN_STATUS , ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.DAYS_STATUS_04) OR (PRLT.REC_CAPTLZTION_DAYS > 0 AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.REC_CAPTLZTION_DAYS)) AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PERIOD_END_DATE = (SELECT MIN(FILSX.PERIOD_END_DATE) FROM ' . $this->filsname . ' FILSX WHERE FILSX.LOAN_CODE = FILO.IDCODE AND FILSX.EFFTDATE = FILO.CLX_EFFTDATE AND FILSX.DUE_PAY_DATE<=GLCP.OPERATION_DATE) AND FILO.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM CRED_CREDITS X WHERE X.IDCODE = FILO.IDCODE AND X.CLX_EFFTDATE<=' . singleQuote($this->today) . ' ) AND PRLT.PRODUCT_CODE = FILO.PRODUCT_CODE AND FILO.COMP_CODE = ' . singleQuote($comp_code) . (($loan_code !== '') ? ' AND FILO.IDCODE = ' . singleQuote($loan_code) : '') . ' ) X WHERE (X.PRINCIPAL_PAY+X.INTEREST_PAY) > (X.PPAL_PAID_AMT+X.INTPAID_AMT) '; /* GLCP.OPERATION_DATE */
        $r = ClxCommon::$db->getOneRecord($sql);
        if (empty($r['QTY']))
            return; //nothing to do if cero

        if($r['QTY']==1 && $this->checkDueAmt($r['LOAN_CODE'],$r['EFFTDATE'])<=0)
            return; //no tiene deuda

        unset($r);
        //GLT1
        $this->je_source = 'CRGC'; //Credit gl change
        $DBLT = &getTool('DBLT');
        $idname = $DBLT->getListItem('SOTY', $this->je_source);
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        $comp = new Comp();
        $comprec = $comp->comp_operation_parameters($comp_code);
        $operation_date = $comprec['OPERATION_DATE'];
        if ($this->display === true) {
            echoLog(' CREDIT GL CHANGE PROCESS. BATCH ID: ' . $this->batch_id);
            echoLog('Efective date: ' . $operation_date);
            echoLog('Credit: ' . (($loan_code === '') ? 'ALL' : $loan_code));
        }
        if (empty($comprec) || empty($comp_code)) {
            echoLog('Error, no company operation parameters found');
        }
        //Init temporary tables
        $this->initTemporaryTables($this->batch_id);
        //Updating credit status
        $sql = 'INSERT INTO ' . $this->glt1name . ' (BATCH_ID, LOAN_CODE, EFFTDATE, PROD_STATUS, CAPITALIZE) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, A.LOAN_CODE, A.EFFTDATE, A.PROD_STATUS, A.CAPITALIZE FROM (SELECT FILO.IDCODE LOAN_CODE, FILO.PRODUCT_CODE, FILO.CLX_EFFTDATE EFFTDATE, MAX(CASE WHEN FILO.LOAN_STATUS=' . singleQuote('PRE') . ' THEN ' . singleQuote('PRE') . ' WHEN ((PRLT.STATUS_COND_04 = '.singleQuote('0').' OR (PRLT.STATUS_COND_04 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=NULLIF(PRLT.DAYS_STATUS_04,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND PRLT.UOM_STATUS_04 = '.singleQuote('0').') THEN PRLT.PROD_STATUS_04 WHEN ((PRLT.STATUS_COND_03 = '.singleQuote('0').' OR (PRLT.STATUS_COND_03 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=NULLIF(PRLT.DAYS_STATUS_03,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND PRLT.UOM_STATUS_03 = '.singleQuote('0').') THEN PRLT.PROD_STATUS_03  WHEN ((PRLT.STATUS_COND_02 = '.singleQuote('0').' OR (PRLT.STATUS_COND_02 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE) OR (PRLT.STATUS_COND_02 = '.singleQuote('2').' AND FILO.END_DATE<=GLCP.OPERATION_DATE)) AND (DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=NULLIF(PRLT.DAYS_STATUS_02,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') OR (DATEDIFF(GLCP.OPERATION_DATE, FILO.END_DATE) >=NULLIF(PRLT.DAYS_STATUS_02,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND PRLT.STATUS_COND_02 = '.singleQuote('2').')) AND PRLT.UOM_STATUS_02 = '.singleQuote('0').') THEN PRLT.PROD_STATUS_02  WHEN ((PRLT.STATUS_COND_01 = '.singleQuote('0').' OR (PRLT.STATUS_COND_01 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=NULLIF(PRLT.DAYS_STATUS_01,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND PRLT.UOM_STATUS_01 = '.singleQuote('0').') THEN PRLT.PROD_STATUS_01 WHEN ((PRLT.STATUS_COND_04 = '.singleQuote('0').' OR (PRLT.STATUS_COND_04 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND (SELECT COUNT(*) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PAID_AMT = '.singleQuote('0').')>=NULLIF(PRLT.DAYS_STATUS_04,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND PRLT.UOM_STATUS_04 ='.singleQuote('1').') THEN PRLT.PROD_STATUS_04 WHEN ((PRLT.STATUS_COND_03 = '.singleQuote('0').' OR (PRLT.STATUS_COND_03 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND (SELECT COUNT(*) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PAID_AMT = '.singleQuote('0').')>=NULLIF(PRLT.DAYS_STATUS_03,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND PRLT.UOM_STATUS_03 ='.singleQuote('1').') THEN PRLT.PROD_STATUS_03 WHEN ((PRLT.STATUS_COND_02 = '.singleQuote('0').' OR (PRLT.STATUS_COND_02 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND (SELECT COUNT(*) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PAID_AMT = '.singleQuote('0').')>=NULLIF(PRLT.DAYS_STATUS_02,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND PRLT.UOM_STATUS_02 ='.singleQuote('1').') THEN PRLT.PROD_STATUS_02 WHEN ((PRLT.STATUS_COND_01 = '.singleQuote('0').' OR (PRLT.STATUS_COND_01 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND (SELECT COUNT(*) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PAID_AMT = '.singleQuote('0').')>=NULLIF(PRLT.DAYS_STATUS_01,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND PRLT.UOM_STATUS_01 ='.singleQuote('1').') THEN PRLT.PROD_STATUS_01 ELSE FILO.LOAN_STATUS END) PROD_STATUS, MAX(CASE WHEN FILO.LOAN_STATUS=' . singleQuote('PRE') . ' THEN ' . singleQuote('PRE') . ' WHEN ((PRLT.STATUS_COND_04 = '.singleQuote('0').' OR (PRLT.STATUS_COND_04 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=NULLIF(PRLT.DAYS_STATUS_04,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND PRLT.UOM_STATUS_04 = '.singleQuote('0').') THEN PRLT.CAP_STATUS_04 WHEN ((PRLT.STATUS_COND_03 = '.singleQuote('0').' OR (PRLT.STATUS_COND_03 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=NULLIF(PRLT.DAYS_STATUS_03,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND PRLT.UOM_STATUS_03 = '.singleQuote('0').') THEN PRLT.CAP_STATUS_03 WHEN ((PRLT.STATUS_COND_02 = '.singleQuote('0').' OR (PRLT.STATUS_COND_02 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE) OR (PRLT.STATUS_COND_02 = '.singleQuote('2').' AND FILO.END_DATE<=GLCP.OPERATION_DATE)) AND (DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=NULLIF(PRLT.DAYS_STATUS_02,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') OR (DATEDIFF(GLCP.OPERATION_DATE, FILO.END_DATE) >=NULLIF(PRLT.DAYS_STATUS_02,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND PRLT.STATUS_COND_02 = '.singleQuote('2').')) AND PRLT.UOM_STATUS_02 = '.singleQuote('0').') THEN PRLT.CAP_STATUS_02 WHEN ((PRLT.STATUS_COND_01 = '.singleQuote('0').' OR (PRLT.STATUS_COND_01 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=NULLIF(PRLT.DAYS_STATUS_01,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND PRLT.UOM_STATUS_01 = '.singleQuote('0').') THEN PRLT.CAP_STATUS_01 WHEN ((PRLT.STATUS_COND_04 = '.singleQuote('0').' OR (PRLT.STATUS_COND_04 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND (SELECT COUNT(*) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PAID_AMT = '.singleQuote('0').')>=NULLIF(PRLT.DAYS_STATUS_04,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND PRLT.UOM_STATUS_04 ='.singleQuote('1').') THEN PRLT.CAP_STATUS_04 WHEN ((PRLT.STATUS_COND_03 = '.singleQuote('0').' OR (PRLT.STATUS_COND_03 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND (SELECT COUNT(*) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PAID_AMT = '.singleQuote('0').')>=NULLIF(PRLT.DAYS_STATUS_03,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND PRLT.UOM_STATUS_03 ='.singleQuote('1').') THEN PRLT.CAP_STATUS_03 WHEN ((PRLT.STATUS_COND_02 = '.singleQuote('0').' OR (PRLT.STATUS_COND_02 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND (SELECT COUNT(*) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PAID_AMT = '.singleQuote('0').')>=NULLIF(PRLT.DAYS_STATUS_02,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND PRLT.UOM_STATUS_02 ='.singleQuote('1').') THEN PRLT.CAP_STATUS_02 WHEN ((PRLT.STATUS_COND_01 = '.singleQuote('0').' OR (PRLT.STATUS_COND_01 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND (SELECT COUNT(*) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PAID_AMT = '.singleQuote('0').')>=NULLIF(PRLT.DAYS_STATUS_01,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND PRLT.UOM_STATUS_01 ='.singleQuote('1').') THEN PRLT.CAP_STATUS_01 ELSE 0 END ) CAPITALIZE, SUM(FILS.PRINCIPAL_PAY+FILS.INTEREST_PAY) CAP_INT_PAY, (SELECT SUM(FILS2.PPAL_PAID_AMT+FILS2.PPAL_PAID_AMT+FILS.INTPAID_AMT) FROM CRED_PAYMNT_SCHEDULES FILS2 WHERE FILS2.LOAN_CODE = FILO.IDCODE AND FILS2.EFFTDATE = FILO.CLX_EFFTDATE) CAP_INT_PAID FROM ' . $this->glcpname . ' GLCP, ' . $this->filoname . ' FILO, ' . $this->filsname . ' FILS, ' . $this->prltname . ' PRLT WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.EFFTDATE = FILO.CLX_EFFTDATE AND GLCP.COMP_CODE = FILO.COMP_CODE AND (((PRLT.STATUS_COND_01 = '.singleQuote('0').' OR (PRLT.STATUS_COND_01 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND (PRLT.PROD_STATUS_01 NOT IN (FILO.LOAN_STATUS , ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.DAYS_STATUS_01 AND PRLT.UOM_STATUS_01 = '.singleQuote('0').') OR ((PRLT.STATUS_COND_02 = '.singleQuote('0').' OR (PRLT.STATUS_COND_02 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE) OR (PRLT.STATUS_COND_02 = '.singleQuote('2').' AND FILO.END_DATE<=GLCP.OPERATION_DATE)) AND PRLT.PROD_STATUS_02 NOT IN (FILO.LOAN_STATUS , ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND ((DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.DAYS_STATUS_02) OR (DATEDIFF(GLCP.OPERATION_DATE, FILO.END_DATE) = PRLT.DAYS_STATUS_02 AND PRLT.STATUS_COND_02 = '.singleQuote('2').')) AND PRLT.UOM_STATUS_02 = '.singleQuote('0').') OR ((PRLT.STATUS_COND_03 = '.singleQuote('0').' OR (PRLT.STATUS_COND_03 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND PRLT.PROD_STATUS_03 NOT IN (FILO.LOAN_STATUS , ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.DAYS_STATUS_03 AND PRLT.UOM_STATUS_03 = '.singleQuote('0').') OR ((PRLT.STATUS_COND_04 = '.singleQuote('0').' OR (PRLT.STATUS_COND_04 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND PRLT.PROD_STATUS_04 NOT IN (FILO.LOAN_STATUS , ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.DAYS_STATUS_04 AND PRLT.UOM_STATUS_04 = '.singleQuote('0').') OR (PRLT.REC_CAPTLZTION_DAYS > 0 AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.REC_CAPTLZTION_DAYS)) OR ((PRLT.STATUS_COND_01 = '.singleQuote('0').' OR (PRLT.STATUS_COND_01 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND (PRLT.PROD_STATUS_01 NOT IN (FILO.LOAN_STATUS , ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND (SELECT COUNT(*) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PAID_AMT = 0) = PRLT.DAYS_STATUS_01 AND PRLT.UOM_STATUS_01 = '.singleQuote('1').') OR ((PRLT.STATUS_COND_02 = '.singleQuote('0').' OR (PRLT.STATUS_COND_02 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND PRLT.PROD_STATUS_02 NOT IN (FILO.LOAN_STATUS , ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND (SELECT COUNT(*) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PAID_AMT = 0) = PRLT.DAYS_STATUS_02 AND PRLT.UOM_STATUS_02 = '.singleQuote('1').') OR ((PRLT.STATUS_COND_03 = '.singleQuote('0').' OR (PRLT.STATUS_COND_03 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND PRLT.PROD_STATUS_03 NOT IN (FILO.LOAN_STATUS , ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND (SELECT COUNT(*) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PAID_AMT = 0) = PRLT.DAYS_STATUS_03 AND PRLT.UOM_STATUS_03 = '.singleQuote('1').') OR ((PRLT.STATUS_COND_04 = '.singleQuote('0').' OR (PRLT.STATUS_COND_04 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND PRLT.PROD_STATUS_04 NOT IN (FILO.LOAN_STATUS , ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND (SELECT COUNT(*) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PAID_AMT = 0) = PRLT.DAYS_STATUS_04 AND PRLT.UOM_STATUS_04 = '.singleQuote('1').') OR (PRLT.REC_CAPTLZTION_DAYS > 0 AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.REC_CAPTLZTION_DAYS))) AND FILO.LOAN_STATUS NOT IN (' . singleQuoteArray(array('REEC', 'CAN')) . ')  AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PERIOD_END_DATE = CRED_CHECK_DUE_DATE(FILO.IDCODE,FILO.CLX_EFFTDATE,GLCP.OPERATION_DATE) /*(SELECT MAX(FILSX.PERIOD_END_DATE) FROM ' . $this->filsname . ' FILSX WHERE FILSX.LOAN_CODE = FILO.IDCODE AND FILSX.EFFTDATE = FILO.CLX_EFFTDATE AND FILSX.DUE_PAY_DATE<=GLCP.OPERATION_DATE)*/ AND PRLT.PRODUCT_CODE = FILO.PRODUCT_CODE AND FILO.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM ' . $this->filoname . ' X WHERE X.IDCODE = FILO.IDCODE AND X.CLX_EFFTDATE<=' . singleQuote($this->today) . ') AND FILO.COMP_CODE = ' . singleQuote($comp_code) . ' ' . (($loan_code !== '') ? 'AND FILO.IDCODE = ' . singleQuote($loan_code) : '') . ' /* AND FILO.LOAN_STATUS <> ' . singleQuote('VEN') . ' */ GROUP BY FILS.LOAN_CODE, FILO.PRODUCT_CODE, FILO.CLX_EFFTDATE /* HAVING CAP_INT_PAY > CAP_INT_PAID */) A WHERE CRED_CHECK_DUE_AMT(A.LOAN_CODE,A.EFFTDATE) > 0 HAVING ((SELECT COUNT(COPE.TRANSTBL_CODE) FROM CRED_OPERATION COPE WHERE COPE.LOAN_CODE=A.LOAN_CODE AND COPE.TRANSTBL_CODE IN (' . singleQuote('SYS_CRED-DISB') . ',' . singleQuote('CRED_REFREO') . ') AND COPE.TRANS_STATUS = ' . singleQuote('AP') . ' )OR(SELECT COUNT(FIAT.TRANSTBL_CODE) FROM FIDU_TRANSACTIONS FIAT, GL_JOURNAL_HDR JEHD, CRED_EXTENSION CRRP WHERE FIAT.JEHDR_CODE=JEHD.IDCODE AND JEHD.IDCODE=CRRP.JEHDR_CODE AND CRRP.NEW_LOAN_CODE=A.LOAN_CODE AND FIAT.TRANSTBL_CODE = '.singleQuote('SYS_CRED-REE').' AND FIAT.TRANS_STATUS = '.singleQuote('AP').' )) > 0';

        /*HAVING (SELECT COUNT(COPE.TRANSTBL_CODE) FROM CRED_OPERATION COPE WHERE COPE.LOAN_CODE=A.LOAN_CODE AND COPE.TRANSTBL_CODE IN (' . singleQuote('SYS_CRED-DISB') . ',' . singleQuote('CRED_REFREO') . ') AND COPE.TRANS_STATUS = ' . singleQuote('AP') . ' ) > 0';*/
        //ORIGINAL $sql = 'INSERT INTO ' . $this->glt1name . ' (BATCH_ID, LOAN_CODE, EFFTDATE, PROD_STATUS, CAPITALIZE) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, A.LOAN_CODE, A.EFFTDATE, A.PROD_STATUS, A.CAPITALIZE FROM (SELECT FILO.IDCODE LOAN_CODE, FILO.PRODUCT_CODE, FILO.CLX_EFFTDATE EFFTDATE, MAX(case WHEN FILO.LOAN_STATUS=' . singleQuote('PRE') . ' THEN ' . singleQuote('PRE') . ' WHEN DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=nullIF(PRLT.DAYS_STATUS_04,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') THEN PRLT.PROD_STATUS_04 WHEN DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=nullIF(PRLT.DAYS_STATUS_03,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') THEN PRLT.PROD_STATUS_03 WHEN DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=nullIF(PRLT.DAYS_STATUS_02,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') THEN PRLT.PROD_STATUS_02 WHEN DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=nullIF(PRLT.DAYS_STATUS_01,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') THEN PRLT.PROD_STATUS_01 ELSE FILO.LOAN_STATUS END) PROD_STATUS, MAX(case WHEN FILO.LOAN_STATUS=' . singleQuote('PRE') . ' THEN ' . singleQuote('PRE') . ' WHEN DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=nullIF(PRLT.DAYS_STATUS_04,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') THEN PRLT.CAP_STATUS_04 WHEN DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=nullIF(PRLT.DAYS_STATUS_03,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') THEN PRLT.CAP_STATUS_03 WHEN DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=nullIF(PRLT.DAYS_STATUS_02,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') THEN PRLT.CAP_STATUS_02 WHEN DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=nullIF(PRLT.DAYS_STATUS_01,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') THEN PRLT.CAP_STATUS_01 ELSE 0 END) CAPITALIZE, SUM(FILS.PRINCIPAL_PAY+FILS.INTEREST_PAY) CAP_INT_PAY, (SELECT SUM(FILS2.PPAL_PAID_AMT+FILS2.PPAL_PAID_AMT+FILS.INTPAID_AMT) FROM CRED_PAYMNT_SCHEDULES FILS2 WHERE FILS2.LOAN_CODE = FILO.IDCODE AND FILS2.EFFTDATE = FILO.CLX_EFFTDATE) CAP_INT_PAID FROM ' . $this->glcpname . ' GLCP, ' . $this->filoname . ' FILO, ' . $this->filsname . ' FILS, ' . $this->prltname . ' PRLT WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.EFFTDATE = FILO.CLX_EFFTDATE AND GLCP.COMP_CODE = FILO.COMP_CODE AND ((PRLT.PROD_STATUS_01 NOT IN (FILO.LOAN_STATUS , ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.DAYS_STATUS_01) OR (PRLT.PROD_STATUS_02 NOT IN (FILO.LOAN_STATUS , ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.DAYS_STATUS_02) OR (PRLT.PROD_STATUS_03 NOT IN (FILO.LOAN_STATUS , ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.DAYS_STATUS_03) OR (PRLT.PROD_STATUS_04 NOT IN (FILO.LOAN_STATUS , ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.DAYS_STATUS_04) OR (PRLT.REC_CAPTLZTION_DAYS > 0 AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.REC_CAPTLZTION_DAYS)) AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PERIOD_END_DATE = (SELECT MIN(FILSX.PERIOD_END_DATE) FROM ' . $this->filsname . ' FILSX WHERE FILSX.LOAN_CODE = FILO.IDCODE AND FILSX.EFFTDATE = FILO.CLX_EFFTDATE AND FILSX.DUE_PAY_DATE<=GLCP.OPERATION_DATE) AND PRLT.PRODUCT_CODE = FILO.PRODUCT_CODE AND FILO.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM ' . $this->filoname . ' X WHERE X.IDCODE = FILO.IDCODE AND X.CLX_EFFTDATE<=' . singleQuote($this->today) . ') AND FILO.COMP_CODE = ' . singleQuote($comp_code) . ' ' . (($loan_code !== '') ? 'AND FILO.IDCODE = ' . singleQuote($loan_code) : '') . ' GROUP BY FILS.LOAN_CODE, FILO.PRODUCT_CODE, FILO.CLX_EFFTDATE HAVING CAP_INT_PAY > CAP_INT_PAID) A';
        ClxCommon::$db->executeQuery($sql);
        //Updating credit status
        if (kDatabaseType === 'oci') {
            $sql = 'UPDATE ' . $this->filoname . ' FILO SET FILO.LOAN_STATUS = (SELECT MAX(X1.PROD_STATUS) FROM ' . $this->glt1name . ' X1 WHERE X1.LOAN_CODE = FILO.IDCODE AND X1.EFFTDATE = FILO.CLX_EFFTDATE AND X1.BATCH_ID = ' . singleQuote($this->batch_id) . ') WHERE EXISTS(SELECT X.LOAN_CODE FROM ' . $this->glt1name . ' X WHERE X.LOAN_CODE = FILO.IDCODE AND X.EFFTDATE = FILO.CLX_EFFTDATE AND X.BATCH_ID = ' . singleQuote($this->batch_id) . ')';
        } else {
            $sql = 'UPDATE ' . $this->filoname . ' FILO, ' . $this->glt1name . ' X SET FILO.LOAN_STATUS = X.PROD_STATUS WHERE X.LOAN_CODE = FILO.IDCODE AND X.EFFTDATE = FILO.CLX_EFFTDATE AND X.BATCH_ID = ' . singleQuote($this->batch_id);
        }
        ClxCommon::$db->executeQuery($sql);
        //Clear all credit statuses temporary records
        $sql = 'DELETE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //loading temporary table with balances of product and status to work gl change
        //where amount to transfer are related to expire installments
        //Not anymore transfer is full always
        //OPER_STATUS_01 = 0  removed
        //Doing temporary records for cases where amount is full transfer(a single status) and not by installment / status
        /* ((FILO.INTEARNED_AMT-FILO.INTPAID_AMT)+LATE_FEE_BALANCE+COMMISSIONS_AMT+INSURANCE_AMT+FEE_01_AMT+FEE_02_AMT+FEE_03_AMT+FEE_04_AMT+FEE_05_AMT) CAPITALIZATION_AMT, */
        //nota jcvb trae informacion por periodo recordar sumarizar para no tener 2 porciones
        $sql = 'INSERT INTO ' . $this->glt1name . '  (BATCH_ID, EFFTDATE, GLACCOUNTCODE, GL01_CODE, GL_TYPE, BALANCE_AMT, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, LOAN_CODE, PRODUCT_CODE, CALC_AMT_02, CALC_AMT_03, CALC_AMT_04, PROD_STATUS, CAPITALIZE, CAPITALIZATION_AMT, BATCH_LEVEL) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, A.EFFTDATE, JCBV.GLACCOUNTCODE GLACCOUNTCODE, JCBV.GLACCOUNTCODE GL01_CODE, JCBV.GL_TYPE, SUM(JCBV.BALANCE_AMT) BALANCE_AMT, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, JCBV.CURRENCY_CODE, 1 CUR_OPERATOR, 1 EXCHANGE_RT, 0 DEBIT_AMT, 0 CREDIT_AMT, 0 DEBIT_TRANS_AMT, 0 CREDIT_TRANS_AMT, A.LOAN_CODE, A.PRODUCT_CODE, SUM(JCBV.BALANCE_AMT) CALC_AMT_02, 0 CALC_AMT_03, A.DIFDAYS CALC_AMT_04, A.PROD_STATUS, A.CAPITALIZE, SUM(IF(JCBV.GLACCOUNTCODE = A.AR_GL_CODE, JCBV.BALANCE_AMT,0)) CAPITALIZATION_AMT, 0 BATCH_LEVEL FROM (SELECT DISTINCT FILO.IDCODE LOAN_CODE, FILO.CLX_EFFTDATE EFFTDATE, FIAS.IDCODE ASSET_CODE, FILO.PRODUCT_CODE, GLCP.OPERATION_DATE, PRAT.PRO_GL_CODE, PRAT.AR_GL_CODE, FILO.CURRENCY_CODE, DATEDIFF(GLCP.OPERATION_DATE,FILS.DUE_PAY_DATE) DIFDAYS, FILO.LOAN_STATUS PROD_STATUS, CASE WHEN FILO.LOAN_STATUS=' . singleQuote('PRE') . ' THEN ' . singleQuote('PRE') . ' WHEN ((PRLT.STATUS_COND_04 = '.singleQuote('0').' OR (PRLT.STATUS_COND_04 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=NULLIF(PRLT.DAYS_STATUS_04,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND PRLT.UOM_STATUS_04 = '.singleQuote('0').') THEN PRLT.CAP_STATUS_04 WHEN ((PRLT.STATUS_COND_03 = '.singleQuote('0').' OR (PRLT.STATUS_COND_03 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=NULLIF(PRLT.DAYS_STATUS_03,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND PRLT.UOM_STATUS_03 = '.singleQuote('0').') THEN PRLT.CAP_STATUS_03 WHEN ((PRLT.STATUS_COND_02 = '.singleQuote('0').' OR (PRLT.STATUS_COND_02 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE) OR (PRLT.STATUS_COND_02 = '.singleQuote('2').' AND FILO.END_DATE<=GLCP.OPERATION_DATE)) AND (DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=NULLIF(PRLT.DAYS_STATUS_02,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') OR (DATEDIFF(GLCP.OPERATION_DATE, FILO.END_DATE) >=NULLIF(PRLT.DAYS_STATUS_02,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND PRLT.STATUS_COND_02 = '.singleQuote('2').')) AND PRLT.UOM_STATUS_02 = '.singleQuote('0').') THEN PRLT.CAP_STATUS_02 WHEN ((PRLT.STATUS_COND_01 = '.singleQuote('0').' OR (PRLT.STATUS_COND_01 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=NULLIF(PRLT.DAYS_STATUS_01,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND PRLT.UOM_STATUS_01 = '.singleQuote('0').') THEN PRLT.CAP_STATUS_01 WHEN ((PRLT.STATUS_COND_04 = '.singleQuote('0').' OR (PRLT.STATUS_COND_04 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND (SELECT COUNT(*) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PAID_AMT = '.singleQuote('0').')>=NULLIF(PRLT.DAYS_STATUS_04,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND PRLT.UOM_STATUS_04 ='.singleQuote('1').') THEN PRLT.CAP_STATUS_04 WHEN ((PRLT.STATUS_COND_03 = '.singleQuote('0').' OR (PRLT.STATUS_COND_03 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND (SELECT COUNT(*) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PAID_AMT = '.singleQuote('0').')>=NULLIF(PRLT.DAYS_STATUS_03,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND PRLT.UOM_STATUS_03 ='.singleQuote('1').') THEN PRLT.CAP_STATUS_03 WHEN ((PRLT.STATUS_COND_02 = '.singleQuote('0').' OR (PRLT.STATUS_COND_02 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND (SELECT COUNT(*) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PAID_AMT = '.singleQuote('0').')>=NULLIF(PRLT.DAYS_STATUS_02,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND PRLT.UOM_STATUS_02 ='.singleQuote('1').') THEN PRLT.CAP_STATUS_02 WHEN ((PRLT.STATUS_COND_01 = '.singleQuote('0').' OR (PRLT.STATUS_COND_01 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND (SELECT COUNT(*) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PAID_AMT = '.singleQuote('0').')>=NULLIF(PRLT.DAYS_STATUS_01,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') AND PRLT.UOM_STATUS_01 ='.singleQuote('1').') THEN PRLT.CAP_STATUS_01 ELSE 0 END CAPITALIZE, SUM(FILS.PRINCIPAL_PAY+FILS.INTEREST_PAY) CAP_INT_PAY, (SELECT SUM(FILS2.PPAL_PAID_AMT+FILS2.INTPAID_AMT) FROM CRED_PAYMNT_SCHEDULES FILS2 WHERE FILS2.LOAN_CODE = FILO.IDCODE AND FILS2.EFFTDATE = FILO.CLX_EFFTDATE) CAP_INT_PAID FROM ' . $this->filoname . ' FILO, ' . $this->filsname . ' FILS, ' . $this->fiasname . ' FIAS, ' . $this->glcpname . ' GLCP, ' . $this->prltname . ' PRLT, ' . $this->pratname . ' PRAT WHERE FILO.COMP_CODE = GLCP.COMP_CODE AND PRLT.PRODUCT_CODE = FILO.PRODUCT_CODE AND PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE AND FIAS.LOAN_CODE = FILO.IDCODE AND FILO.IDCODE = FILS.LOAN_CODE AND FILO.CLX_EFFTDATE = FILS.EFFTDATE AND FILO.COMP_CODE = ' . singleQuote($comp_code) . ' AND FILO.LOAN_STATUS NOT IN (' . singleQuoteArray(array('REEC', 'CAN')) . ') AND (((PRLT.STATUS_COND_01 = '.singleQuote('0').' OR (PRLT.STATUS_COND_01 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND (PRLT.PROD_STATUS_01<>' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND PRAT.PROD_STATUS<>PRLT.PROD_STATUS_01 /*AND PRLT.OPER_STATUS_01 = 1 */ AND (PRLT.OPER_STATUS_01 = 1 OR (PRLT.OPER_STATUS_01 = 2 AND (SELECT COUNT(FIAT.TRANSTBL_CODE) FROM FIDU_TRANSACTIONS FIAT, GL_JOURNAL_HDR JEHD, CRED_EXTENSION CRRP WHERE FIAT.JEHDR_CODE=JEHD.IDCODE AND JEHD.IDCODE=CRRP.JEHDR_CODE AND CRRP.NEW_LOAN_CODE=FILO.IDCODE AND FIAT.TRANSTBL_CODE = '. singleQuote('SYS_CRED-REE') .' AND FIAT.TRANS_STATUS = '.singleQuote('AP') .' ) >0)) AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.DAYS_STATUS_01 AND PRLT.UOM_STATUS_01 = '.singleQuote('0').') OR ((PRLT.STATUS_COND_02 = '.singleQuote('0').' OR (PRLT.STATUS_COND_02 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE) OR (PRLT.STATUS_COND_02 = '.singleQuote('2').' AND FILO.END_DATE<=GLCP.OPERATION_DATE)) AND PRLT.PROD_STATUS_02<>' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND PRAT.PROD_STATUS<>PRLT.PROD_STATUS_02 AND PRLT.OPER_STATUS_02 = 1 AND ((DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.DAYS_STATUS_02) OR (DATEDIFF(GLCP.OPERATION_DATE, FILO.END_DATE) = PRLT.DAYS_STATUS_02 AND PRLT.STATUS_COND_02 = '.singleQuote('2').')) AND PRLT.UOM_STATUS_02 = '.singleQuote('0').') OR ((PRLT.STATUS_COND_03 = '.singleQuote('0').' OR (PRLT.STATUS_COND_03 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND PRLT.PROD_STATUS_03<>' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND PRAT.PROD_STATUS<>PRLT.PROD_STATUS_03 AND PRLT.OPER_STATUS_03 = 1 AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.DAYS_STATUS_03 AND PRLT.UOM_STATUS_03 = '.singleQuote('0').') OR ((PRLT.STATUS_COND_04 = '.singleQuote('0').' OR (PRLT.STATUS_COND_04 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND PRLT.PROD_STATUS_04<>' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND PRAT.PROD_STATUS<>PRLT.PROD_STATUS_04 AND PRLT.OPER_STATUS_04 = 1 AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.DAYS_STATUS_04 AND PRLT.UOM_STATUS_04 = '.singleQuote('0').')) OR ((PRLT.STATUS_COND_01 = '.singleQuote('0').' OR (PRLT.STATUS_COND_01 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND (PRLT.PROD_STATUS_01<>' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND PRAT.PROD_STATUS<>PRLT.PROD_STATUS_01 /*AND PRLT.OPER_STATUS_01 = 1 */ AND (PRLT.OPER_STATUS_01 = 1 OR (PRLT.OPER_STATUS_01 = 2 AND (SELECT COUNT(FIAT.TRANSTBL_CODE) FROM FIDU_TRANSACTIONS FIAT, GL_JOURNAL_HDR JEHD, CRED_EXTENSION CRRP WHERE FIAT.JEHDR_CODE=JEHD.IDCODE AND JEHD.IDCODE=CRRP.JEHDR_CODE AND CRRP.NEW_LOAN_CODE=FILO.IDCODE AND FIAT.TRANSTBL_CODE = '. singleQuote('SYS_CRED-REE') .' AND FIAT.TRANS_STATUS = '.singleQuote('AP') .' ) >0)) AND (SELECT COUNT(*) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PAID_AMT = 0) = PRLT.DAYS_STATUS_01 AND PRLT.UOM_STATUS_01 = '.singleQuote('1').') OR ((PRLT.STATUS_COND_02 = '.singleQuote('0').' OR (PRLT.STATUS_COND_02 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND PRLT.PROD_STATUS_02<>' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND PRAT.PROD_STATUS<>PRLT.PROD_STATUS_02 AND PRLT.OPER_STATUS_02 = 1 AND (SELECT COUNT(*) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PAID_AMT = 0) = PRLT.DAYS_STATUS_02 AND PRLT.UOM_STATUS_02 = '.singleQuote('1').') OR ((PRLT.STATUS_COND_03 = '.singleQuote('0').' OR (PRLT.STATUS_COND_03 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND PRLT.PROD_STATUS_03<>' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND PRAT.PROD_STATUS<>PRLT.PROD_STATUS_03 AND PRLT.OPER_STATUS_03 = 1 AND (SELECT COUNT(*) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PAID_AMT = 0) = PRLT.DAYS_STATUS_03 AND PRLT.UOM_STATUS_03 = '.singleQuote('1').') OR ((PRLT.STATUS_COND_04 = '.singleQuote('0').' OR (PRLT.STATUS_COND_04 = '.singleQuote('1').' AND FILO.END_DATE>=GLCP.OPERATION_DATE)) AND PRLT.PROD_STATUS_04<>' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND PRAT.PROD_STATUS<>PRLT.PROD_STATUS_04 AND PRLT.OPER_STATUS_04 = 1 AND (SELECT COUNT(*) FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PAID_AMT = 0) = PRLT.DAYS_STATUS_04 AND PRLT.UOM_STATUS_04 = '.singleQuote('1').'))) AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PERIOD_END_DATE = CRED_CHECK_DUE_DATE(FILO.IDCODE,FILO.CLX_EFFTDATE,GLCP.OPERATION_DATE) /*(SELECT MAX(FILSX.PERIOD_END_DATE) FROM ' . $this->filsname . ' FILSX WHERE FILSX.LOAN_CODE = FILO.IDCODE AND FILSX.EFFTDATE = FILO.CLX_EFFTDATE AND FILSX.DUE_PAY_DATE<=GLCP.OPERATION_DATE)*/ AND FILO.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM ' . $this->filoname . ' X WHERE X.IDCODE = FILO.IDCODE AND X.CLX_EFFTDATE<=' . singleQuote($this->now) . ') ' . (($loan_code !== '') ? ' AND FILO.IDCODE = ' . singleQuote($loan_code) . ' ' : '') . ' GROUP BY FILO.IDCODE, FILO.CLX_EFFTDATE, FIAS.IDCODE, FILO.PRODUCT_CODE, GLCP.OPERATION_DATE, PRAT.PRO_GL_CODE, PRAT.AR_GL_CODE, FILO.CURRENCY_CODE, DIFDAYS, FILO.LOAN_STATUS, CAPITALIZE /* HAVING  CAP_INT_PAY > CAP_INT_PAID */) A, ' . $this->jcbvname . ' JCBV WHERE JCBV.CHART_FIELD03 = A.ASSET_CODE AND JCBV.GLACCOUNTCODE IN (A.PRO_GL_CODE, A.AR_GL_CODE) AND JCBV.CURRENCY_CODE = A.CURRENCY_CODE GROUP BY A.EFFTDATE, JCBV.GLACCOUNTCODE, JCBV.GL_TYPE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, JCBV.CURRENCY_CODE, A.LOAN_CODE, A.PRODUCT_CODE, A.DIFDAYS, A.PROD_STATUS, A.CAPITALIZE';
        // ORIGINAL $sql = 'INSERT INTO ' . $this->glt1name . '  (BATCH_ID, EFFTDATE, GLACCOUNTCODE, GL01_CODE, GL_TYPE, BALANCE_AMT, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, LOAN_CODE, PRODUCT_CODE, CALC_AMT_02, CALC_AMT_03, CALC_AMT_04, PROD_STATUS, CAPITALIZE, CAPITALIZATION_AMT, BATCH_LEVEL) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, A.EFFTDATE, JCBV.GLACCOUNTCODE GLACCOUNTCODE, JCBV.GLACCOUNTCODE GL01_CODE, JCBV.GL_TYPE, SUM(JCBV.BALANCE_AMT) BALANCE_AMT, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, JCBV.CURRENCY_CODE, 1 CUR_OPERATOR, 1 EXCHANGE_RT, 0 DEBIT_AMT, 0 CREDIT_AMT, 0 DEBIT_TRANS_AMT, 0 CREDIT_TRANS_AMT, A.LOAN_CODE, A.PRODUCT_CODE, SUM(JCBV.BALANCE_AMT) CALC_AMT_02, 0 CALC_AMT_03, A.DIFDAYS CALC_AMT_04, A.PROD_STATUS, A.CAPITALIZE, SUM(IF(JCBV.GLACCOUNTCODE = A.AR_GL_CODE, JCBV.BALANCE_AMT,0)) CAPITALIZATION_AMT, 0 BATCH_LEVEL FROM (SELECT DISTINCT FILO.IDCODE LOAN_CODE, FILO.CLX_EFFTDATE EFFTDATE, FIAS.IDCODE ASSET_CODE, FILO.PRODUCT_CODE, GLCP.OPERATION_DATE, PRAT.PRO_GL_CODE, PRAT.AR_GL_CODE, FILO.CURRENCY_CODE, DATEDIFF(GLCP.OPERATION_DATE,FILS.DUE_PAY_DATE) DIFDAYS, FILO.LOAN_STATUS PROD_STATUS, case WHEN FILO.LOAN_STATUS=' . singleQuote('PRE') . ' THEN ' . singleQuote('PRE') . ' WHEN DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=nullIF(PRLT.DAYS_STATUS_04,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') THEN PRLT.CAP_STATUS_04 WHEN DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=nullIF(PRLT.DAYS_STATUS_03,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') THEN PRLT.CAP_STATUS_03 WHEN DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=nullIF(PRLT.DAYS_STATUS_02,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') THEN PRLT.CAP_STATUS_02 WHEN DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=nullIF(PRLT.DAYS_STATUS_01,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') THEN PRLT.CAP_STATUS_01 ELSE 0 END CAPITALIZE, SUM(FILS.PRINCIPAL_PAY+FILS.INTEREST_PAY) CAP_INT_PAY, (SELECT SUM(FILS2.PPAL_PAID_AMT+FILS2.INTPAID_AMT) FROM CRED_PAYMNT_SCHEDULES FILS2 WHERE FILS2.LOAN_CODE = FILO.IDCODE AND FILS2.EFFTDATE = FILO.CLX_EFFTDATE) CAP_INT_PAID FROM ' . $this->filoname . ' FILO, ' . $this->filsname . ' FILS, ' . $this->fiasname . ' FIAS, ' . $this->glcpname . ' GLCP, ' . $this->prltname . ' PRLT, ' . $this->pratname . ' PRAT WHERE FILO.COMP_CODE = GLCP.COMP_CODE AND PRLT.PRODUCT_CODE = FILO.PRODUCT_CODE AND PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE AND FIAS.LOAN_CODE = FILO.IDCODE AND FILO.IDCODE = FILS.LOAN_CODE AND FILO.CLX_EFFTDATE = FILS.EFFTDATE AND FILO.COMP_CODE = ' . singleQuote($comp_code) . ' AND ((PRLT.PROD_STATUS_01<>' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND PRAT.PROD_STATUS<>PRLT.PROD_STATUS_01 AND PRLT.OPER_STATUS_01 = 1 AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.DAYS_STATUS_01) OR (PRLT.PROD_STATUS_02<>' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND PRAT.PROD_STATUS<>PRLT.PROD_STATUS_02 AND PRLT.OPER_STATUS_02 = 1 AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.DAYS_STATUS_02) OR (PRLT.PROD_STATUS_03<>' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND PRAT.PROD_STATUS<>PRLT.PROD_STATUS_03 AND PRLT.OPER_STATUS_03 = 1 AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.DAYS_STATUS_03) OR (PRLT.PROD_STATUS_04<>' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND PRAT.PROD_STATUS<>PRLT.PROD_STATUS_04 AND PRLT.OPER_STATUS_04 = 1 AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.DAYS_STATUS_04)) AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PERIOD_END_DATE = (SELECT MIN(FILSX.PERIOD_END_DATE) FROM ' . $this->filsname . ' FILSX WHERE FILSX.LOAN_CODE = FILO.IDCODE AND FILSX.EFFTDATE = FILO.CLX_EFFTDATE AND FILSX.DUE_PAY_DATE<=GLCP.OPERATION_DATE) AND FILO.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM ' . $this->filoname . ' X WHERE X.IDCODE = FILO.IDCODE AND X.CLX_EFFTDATE<=' . singleQuote($this->now) . ') ' . (($loan_code !== '') ? ' AND FILO.IDCODE = ' . singleQuote($loan_code) . ' ' : '') . ' GROUP BY FILO.IDCODE, FILO.CLX_EFFTDATE, FIAS.IDCODE, FILO.PRODUCT_CODE, GLCP.OPERATION_DATE, PRAT.PRO_GL_CODE, PRAT.AR_GL_CODE, FILO.CURRENCY_CODE, DIFDAYS, FILO.LOAN_STATUS, CAPITALIZE HAVING  CAP_INT_PAY > CAP_INT_PAID ) A, ' . $this->jcbvname . ' JCBV WHERE JCBV.CHART_FIELD03 = A.ASSET_CODE AND JCBV.GLACCOUNTCODE IN (A.PRO_GL_CODE, A.AR_GL_CODE) AND JCBV.CURRENCY_CODE = A.CURRENCY_CODE GROUP BY A.EFFTDATE, JCBV.GLACCOUNTCODE, JCBV.GL_TYPE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, JCBV.CURRENCY_CODE, A.LOAN_CODE, A.PRODUCT_CODE, A.DIFDAYS, A.PROD_STATUS, A.CAPITALIZE';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'INSERT INTO ' . $this->glt1name . '  (BATCH_ID, EFFTDATE, GLACCOUNTCODE, GL01_CODE, GL_TYPE, BALANCE_AMT, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, DEBIT_AMT, CREDIT_AMT, LOAN_CODE, PRODUCT_CODE, CALC_AMT_02, CALC_AMT_03, CALC_AMT_04, PROD_STATUS, CAPITALIZE, CAPITALIZATION_AMT, BATCH_LEVEL) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, A.EFFTDATE, A.PRO_GL_CODE GLACCOUNTCODE, JCBV.GLACCOUNTCODE GL01_CODE, JCBV.GL_TYPE, SUM(JCBV.BALANCE_AMT) BALANCE_AMT, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, JCBV.CURRENCY_CODE, 1 CUR_OPERATOR, 1 EXCHANGE_RT, 0 DEBIT_AMT, 0 CREDIT_AMT, A.LOAN_CODE, A.PRODUCT_CODE, SUM(JCBV.BALANCE_AMT) CALC_AMT_02, 0 CALC_AMT_03, A.DIFDAYS CALC_AMT_04, A.PROD_STATUS, 1 CAPITALIZE, SUM(IF(JCBV.GLACCOUNTCODE = A.AR_GL_CODE, JCBV.BALANCE_AMT,0)) CAPITALIZATION_AMT, 4 BATCH_LEVEL FROM (SELECT DISTINCT FILO.IDCODE LOAN_CODE, FILO.CLX_EFFTDATE EFFTDATE, FIAS.IDCODE ASSET_CODE, FILO.CURRENCY_CODE, FILO.PRODUCT_CODE, GLCP.OPERATION_DATE, PRAT.PRO_GL_CODE, PRAT.AR_GL_CODE, DATEDIFF(GLCP.OPERATION_DATE,FILS.DUE_PAY_DATE) DIFDAYS, PRAT.PROD_STATUS, SUM(FILS.PRINCIPAL_PAY+FILS.INTEREST_PAY) CAP_INT_PAY, (SELECT SUM(FILS2.PPAL_PAID_AMT+FILS2.INTPAID_AMT) FROM CRED_PAYMNT_SCHEDULES FILS2 WHERE FILS2.LOAN_CODE = FILO.IDCODE AND FILS2.EFFTDATE = FILO.CLX_EFFTDATE) CAP_INT_PAID FROM ' . $this->filoname . ' FILO, ' . $this->filsname . ' FILS, ' . $this->fiasname . ' FIAS, ' . $this->glcpname . ' GLCP, ' . $this->prltname . ' PRLT, ' . $this->pratname . ' PRAT WHERE FILO.COMP_CODE = GLCP.COMP_CODE AND PRLT.PRODUCT_CODE = FILO.PRODUCT_CODE AND PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE AND FIAS.LOAN_CODE = FILO.IDCODE AND FILO.IDCODE = FILS.LOAN_CODE AND FILO.CLX_EFFTDATE = FILS.EFFTDATE AND PRAT.PROD_STATUS = FILO.LOAN_STATUS AND FILO.COMP_CODE = ' . singleQuote($comp_code) . ' 
  AND FILO.LOAN_STATUS NOT IN (' . singleQuoteArray(array('REEC', 'CAN')) . ') 
     /*AND (FILS.PRINCIPAL_PAY>FILS.PPAL_PAID_AMT OR FILS.INTEREST_PAY>FILS.INTPAID_AMT)*/ AND PRLT.REC_CAPTLZTION_DAYS > 0 AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.REC_CAPTLZTION_DAYS AND FILS.PERIOD_END_DATE = CRED_CHECK_DUE_DATE(FILO.IDCODE,FILO.CLX_EFFTDATE,GLCP.OPERATION_DATE) /*(SELECT MAX(FILSX.PERIOD_END_DATE) FROM CRED_PAYMNT_SCHEDULES FILSX WHERE FILSX.LOAN_CODE = FILO.IDCODE AND FILSX.EFFTDATE = FILO.CLX_EFFTDATE AND FILSX.DUE_PAY_DATE<=GLCP.OPERATION_DATE)*/ AND FILO.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM ' . $this->filoname . ' X WHERE X.IDCODE = FILO.IDCODE AND X.CLX_EFFTDATE<=' . singleQuote($this->now) . ') ' . (($loan_code !== '') ? ' AND FILO.IDCODE = ' . singleQuote($loan_code) . ' ' : '') . ' GROUP BY FILO.IDCODE, FILO.CLX_EFFTDATE, FIAS.IDCODE, FILO.CURRENCY_CODE, FILO.PRODUCT_CODE, GLCP.OPERATION_DATE, PRAT.PRO_GL_CODE, PRAT.AR_GL_CODE, DIFDAYS, PRAT.PROD_STATUS /* HAVING CAP_INT_PAY > CAP_INT_PAID */ ) A, ' . $this->jcbvname . ' JCBV WHERE JCBV.CHART_FIELD03 = A.ASSET_CODE AND JCBV.GLACCOUNTCODE = A.AR_GL_CODE AND JCBV.CURRENCY_CODE = A.CURRENCY_CODE GROUP BY A.EFFTDATE, JCBV.GLACCOUNTCODE, JCBV.GL_TYPE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, JCBV.CURRENCY_CODE, A.LOAN_CODE, A.PRODUCT_CODE, A.DIFDAYS, A.PROD_STATUS';
        //ORIGINAL $sql = 'INSERT INTO ' . $this->glt1name . '  (BATCH_ID, EFFTDATE, GLACCOUNTCODE, GL01_CODE, GL_TYPE, BALANCE_AMT, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, DEBIT_AMT, CREDIT_AMT, LOAN_CODE, PRODUCT_CODE, CALC_AMT_02, CALC_AMT_03, CALC_AMT_04, PROD_STATUS, CAPITALIZE, CAPITALIZATION_AMT, BATCH_LEVEL) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, A.EFFTDATE, A.PRO_GL_CODE GLACCOUNTCODE, JCBV.GLACCOUNTCODE GL01_CODE, JCBV.GL_TYPE, SUM(JCBV.BALANCE_AMT) BALANCE_AMT, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, JCBV.CURRENCY_CODE, 1 CUR_OPERATOR, 1 EXCHANGE_RT, 0 DEBIT_AMT, 0 CREDIT_AMT, A.LOAN_CODE, A.PRODUCT_CODE, SUM(JCBV.BALANCE_AMT) CALC_AMT_02, 0 CALC_AMT_03, A.DIFDAYS CALC_AMT_04, A.PROD_STATUS, 1 CAPITALIZE, SUM(IF(JCBV.GLACCOUNTCODE = A.AR_GL_CODE, JCBV.BALANCE_AMT,0)) CAPITALIZATION_AMT, 4 BATCH_LEVEL FROM (SELECT DISTINCT FILO.IDCODE LOAN_CODE, FILO.CLX_EFFTDATE EFFTDATE, FIAS.IDCODE ASSET_CODE, FILO.CURRENCY_CODE, FILO.PRODUCT_CODE, GLCP.OPERATION_DATE, PRAT.PRO_GL_CODE, PRAT.AR_GL_CODE, DATEDIFF(GLCP.OPERATION_DATE,FILS.DUE_PAY_DATE) DIFDAYS, PRAT.PROD_STATUS, SUM(FILS.PRINCIPAL_PAY+FILS.INTEREST_PAY) CAP_INT_PAY, (SELECT SUM(FILS2.PPAL_PAID_AMT+FILS2.INTPAID_AMT) FROM CRED_PAYMNT_SCHEDULES FILS2 WHERE FILS2.LOAN_CODE = FILO.IDCODE AND FILS2.EFFTDATE = FILO.CLX_EFFTDATE) CAP_INT_PAID FROM ' . $this->filoname . ' FILO, ' . $this->filsname . ' FILS, ' . $this->fiasname . ' FIAS, ' . $this->glcpname . ' GLCP, ' . $this->prltname . ' PRLT, ' . $this->pratname . ' PRAT WHERE FILO.COMP_CODE = GLCP.COMP_CODE AND PRLT.PRODUCT_CODE = FILO.PRODUCT_CODE AND PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE AND FIAS.LOAN_CODE = FILO.IDCODE AND FILO.IDCODE = FILS.LOAN_CODE AND FILO.CLX_EFFTDATE = FILS.EFFTDATE AND PRAT.PROD_STATUS = FILO.LOAN_STATUS AND FILO.COMP_CODE = ' . singleQuote($comp_code) . ' /*AND (FILS.PRINCIPAL_PAY>FILS.PPAL_PAID_AMT OR FILS.INTEREST_PAY>FILS.INTPAID_AMT)*/ AND PRLT.REC_CAPTLZTION_DAYS > 0 AND DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) = PRLT.REC_CAPTLZTION_DAYS AND FILS.PERIOD_END_DATE = (SELECT MIN(FILSX.PERIOD_END_DATE) FROM CRED_PAYMNT_SCHEDULES FILSX WHERE FILSX.LOAN_CODE = FILO.IDCODE AND FILSX.EFFTDATE = FILO.CLX_EFFTDATE AND FILSX.DUE_PAY_DATE<=GLCP.OPERATION_DATE) AND FILO.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM ' . $this->filoname . ' X WHERE X.IDCODE = FILO.IDCODE AND X.CLX_EFFTDATE<=' . singleQuote($this->now) . ') ' . (($loan_code !== '') ? ' AND FILO.IDCODE = ' . singleQuote($loan_code) . ' ' : '') . ' GROUP BY FILO.IDCODE, FILO.CLX_EFFTDATE, FIAS.IDCODE, FILO.CURRENCY_CODE, FILO.PRODUCT_CODE, GLCP.OPERATION_DATE, PRAT.PRO_GL_CODE, PRAT.AR_GL_CODE, DIFDAYS, PRAT.PROD_STATUS HAVING CAP_INT_PAY > CAP_INT_PAID ) A, ' . $this->jcbvname . ' JCBV WHERE JCBV.CHART_FIELD03 = A.ASSET_CODE AND JCBV.GLACCOUNTCODE = A.AR_GL_CODE AND JCBV.CURRENCY_CODE = A.CURRENCY_CODE GROUP BY A.EFFTDATE, JCBV.GLACCOUNTCODE, JCBV.GL_TYPE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, JCBV.CURRENCY_CODE, A.LOAN_CODE, A.PRODUCT_CODE, A.DIFDAYS, A.PROD_STATUS';
        ClxCommon::$db->executeQuery($sql);

        $sql = 'SELECT ID, PRODUCT_CODE, GL01_CODE, PROD_STATUS FROM ' . $this->glt1name . ' WHERE PROD_STATUS = '.singleQuote('VEN').' AND BATCH_ID = ' . singleQuote($this->batch_id);
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $sql = 'SELECT COUNT(*) FROM '.$this->glpfname.' GLPF WHERE GLPF.PRODUCT_CODE ='.singleQuote($r['PRODUCT_CODE']).' AND GLPF.FEE2_GL_CODE = '.singleQuote($r['GL01_CODE']).' AND GLPF.PROD_STATUS IN ('.singleQuoteArray(array('MOR', 'VEN')).')';
            $count_glpf = ClxCommon::$db->getOne($sql);
            if ($count_glpf > CLX_NUM_ONE) {
                    $sql = 'DELETE FROM ' . $this->glt1name . ' WHERE ID = '.singleQuote($r['ID']).' AND  BATCH_ID = ' . singleQuote($this->batch_id);
                    ClxCommon::$db->executeQuery($sql);
                }
            if($count_glpf == CLX_NUM_ONE){
                 $sql = 'UPDATE ' . $this->glt1name . ' GLT1 SET GLT1.GLACCOUNTCODE = (SELECT GLPF.FEE2_GL_CODE FROM '.$this->glpfname.' GLPF WHERE GLPF.PRODUCT_CODE =GLT1.PRODUCT_CODE AND GLPF.PROD_STATUS = '.singleQuote('VEN').') WHERE GLT1.ID = '.singleQuote($r['ID']).' AND  BATCH_ID = ' . singleQuote($this->batch_id);
                ClxCommon::$db->executeQuery($sql);
            }
        }

        $sql = 'UPDATE ' . $this->glt1name . '  GLT1 SET GLT1.GL_TYPE = (SELECT MAX(GLAC.GL_TYPE) FROM ' . $this->glacname . ' GLAC WHERE GLAC.IDCODE = GLT1.GLACCOUNTCODE) WHERE GLT1.BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //si el credito es AS y el seguro es LI entonces debe descargar seguro LI contra ingreso IN
        //Revisar para oracle para ejecutarse con subselects
        $sql = 'UPDATE ' . $this->glt1name . ' GLT1, ' . $this->filoname . ' FILO, ' . $this->pratname . ' PRAT, ' . $this->glcpname . ' GLCP, ' . $this->glacname . ' GLAC SET GLT1.GL01_CODE = PRAT.INC_GL_CODE, GLT1.BATCH_LEVEL = 2 WHERE FILO.IDCODE = GLT1.LOAN_CODE AND FILO.CLX_EFFTDATE = GLT1.EFFTDATE AND PRAT.PROD_STATUS = FILO.LOAN_STATUS AND GLCP.COMP_CODE = FILO.COMP_CODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE AND PRAT.PRO_GL_CODE = GLAC.IDCODE AND PRAT.PROD_STATUS = GLT1.PROD_STATUS AND GLT1.BATCH_LEVEL = 1 AND GLT1.GL_TYPE <> GLAC.GL_TYPE AND GLT1.BATCH_ID = ' . singleQuote($this->batch_id);
        //ClxCommon::$db->executeQuery($sql);//comentado por revision de capitalizacion de seguros
        $sql = 'UPDATE ' . $this->glt1name . '  GLT1 SET GLT1.CAPITALIZE = 0, GLT1.GLACCOUNTCODE = (SELECT MAX(PRAT.PRO_GL_CODE) FROM ' . $this->filoname . ' FILO, ' . $this->pratname . ' PRAT WHERE FILO.IDCODE = GLT1.LOAN_CODE AND FILO.CLX_EFFTDATE = GLT1.EFFTDATE AND PRAT.PRODUCT_CODE = GLT1.PRODUCT_CODE AND PRAT.PROD_STATUS = FILO.LOAN_STATUS) WHERE GLT1.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GLT1.GLACCOUNTCODE IN (SELECT PRAT1.PRO_GL_CODE FROM ' . $this->pratname . ' PRAT1 WHERE PRAT1.PRODUCT_CODE = GLT1.PRODUCT_CODE) AND GLT1.BATCH_LEVEL <> 4';
        ClxCommon::$db->executeQuery($sql);
        //Search for new gl account on status change for product accounts
        $sql = 'UPDATE ' . $this->glt1name . '  GLT1 SET GLT1.GLACCOUNTCODE = (SELECT MAX(PRAT.AR_GL_CODE) FROM ' . $this->filoname . ' FILO, ' . $this->pratname . ' PRAT WHERE FILO.IDCODE = GLT1.LOAN_CODE AND FILO.CLX_EFFTDATE = GLT1.EFFTDATE AND PRAT.PRODUCT_CODE = GLT1.PRODUCT_CODE AND PRAT.PROD_STATUS = FILO.LOAN_STATUS) WHERE GLT1.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GLT1.GLACCOUNTCODE IN (SELECT PRAT1.AR_GL_CODE FROM ' . $this->pratname . ' PRAT1 WHERE PRAT1.PRODUCT_CODE = GLT1.PRODUCT_CODE)';
        ClxCommon::$db->executeQuery($sql);
        //Sum total for each loan in case of distribution
        $sql = 'SELECT GLACCOUNTCODE, LOAN_CODE, PROD_STATUS, MAX(CALC_AMT_02) CALC_AMT_03 FROM ' . $this->glt1name . '  WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GLACCOUNTCODE IS NOT null GROUP BY LOAN_CODE, GLACCOUNTCODE, PROD_STATUS';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $sql = 'UPDATE ' . $this->glt1name . '   SET CALC_AMT_03 = ' . $r['CALC_AMT_03'] . ' WHERE LOAN_CODE = ' . singleQuote($r['LOAN_CODE']) . ' AND PROD_STATUS = ' . singleQuote($r['PROD_STATUS']) . ' AND GLACCOUNTCODE = ' . singleQuote($r['GLACCOUNTCODE']) . ' AND BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
        }
        //Set product accounts for cases where need to capitalize. Interest and other stuff must move as capital
        //Search for new gl account on status change for product accounts
        $sql = 'UPDATE ' . $this->glt1name . '  GLT1 SET GLT1.GLACCOUNTCODE = (SELECT MAX(PRAT.PRO_GL_CODE) FROM ' . $this->filoname . ' FILO, ' . $this->pratname . ' PRAT WHERE FILO.IDCODE = GLT1.LOAN_CODE AND FILO.CLX_EFFTDATE = GLT1.EFFTDATE AND PRAT.PRODUCT_CODE = GLT1.PRODUCT_CODE AND PRAT.PROD_STATUS = FILO.LOAN_STATUS) WHERE GLT1.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GLT1.CAPITALIZE = 1 AND GLT1.BATCH_LEVEL <>4'; //level 4 already have the account sinse int recurrect capitalization
        ClxCommon::$db->executeQuery($sql);
        //test if something to do
        if (ClxCommon::$db->countRecords($this->glt1name, 'BATCH_ID = ' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
            return;
        }
        //Set type AS/LI and debits according to participantion
        $sql = 'UPDATE ' . $this->glt1name . '  GLT1 SET GLT1.DEBIT_AMT = ROUND(GLT1.BALANCE_AMT*(GLT1.CALC_AMT_02/GLT1.CALC_AMT_03), 2), GLT1.CALC_AMT_04 = ROUND(GLT1.BALANCE_AMT*(GLT1.CALC_AMT_02/GLT1.CALC_AMT_03), 2) WHERE GLT1.BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt1name . ' SET EFFTDATE = ' . singleQuote($operation_date) . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'SELECT DISTINCT CURRENCY_CODE, ' . singleQuote($operation_date) . ' OPERATION_DATE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $rate = $comp->comp_current_exchange($comp_code, $r['CURRENCY_CODE'], $r['OPERATION_DATE']);
            $sql = 'UPDATE ' . $this->glt1name . ' SET CUR_OPERATOR = ' . singleQuote($rate['CUR_OPERATOR']) . ', EXCHANGE_RT = ' . singleQuote($rate['EXCHANGE_RT']) . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND CURRENCY_CODE = ' . singleQuote($r['CURRENCY_CODE']);
            ClxCommon::$db->executeQuery($sql);
        } //end while
        //Search diferences of distributions if any
        $sql = 'SELECT CHART_FIELD01,GLACCOUNTCODE, MAX(CHART_FIELD02) CHART_FIELD02, LOAN_CODE, PROD_STATUS, (BALANCE_AMT-SUM(CALC_AMT_04)) DIF FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' GROUP BY CHART_FIELD01, GLACCOUNTCODE, LOAN_CODE, PROD_STATUS, BALANCE_AMT HAVING (BALANCE_AMT-SUM(CALC_AMT_04))<>0 ';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $sql = 'UPDATE ' . $this->glt1name . ' SET CALC_AMT_04 = CALC_AMT_04+' . $r['DIF'] . ' WHERE LOAN_CODE = ' . singleQuote($r['LOAN_CODE']) . ' AND CHART_FIELD01 = ' . singleQuote($r['CHART_FIELD01']) . ' AND CHART_FIELD02 = ' . singleQuote($r['CHART_FIELD02']) . ' AND GLACCOUNTCODE = ' . singleQuote($r['GLACCOUNTCODE']) . ' AND PROD_STATUS = ' . singleQuote($r['PROD_STATUS']);
            ClxCommon::$db->executeQuery($sql);
        }

        //setting debits and credits for assets
        $sql = 'UPDATE ' . $this->glt1name . '  SET DEBIT_AMT = CALC_AMT_04 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE = ' . singleQuote('AS') . ' AND CALC_AMT_04>0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt1name . '  SET CREDIT_AMT = ABS(CALC_AMT_04) WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE = ' . singleQuote('AS') . ' AND CALC_AMT_04<0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt1name . '  SET CREDIT_AMT = CALC_AMT_04 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE <> ' . singleQuote('AS') . ' AND CALC_AMT_04>0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt1name . '  SET DEBIT_AMT = ABS(CALC_AMT_04) WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE <> ' . singleQuote('AS') . ' AND CALC_AMT_04<0';
        ClxCommon::$db->executeQuery($sql);
        //Delete all rows from overdraft loans. or cero that will not earn int.
        $sql = 'DELETE FROM ' . $this->glt1name . ' WHERE DEBIT_AMT = 0 AND CREDIT_AMT = 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt1name . '  SET EFFTDATE = ' . singleQuote($operation_date) . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //Currency conversion
        $sql = 'UPDATE ' . $this->glt1name . '  SET DEBIT_TRANS_AMT = DEBIT_AMT, DEBIT_AMT = ROUND(DEBIT_AMT*POW(EXCHANGE_RT, CUR_OPERATOR), 2) WHERE DEBIT_AMT <> 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt1name . '  SET CREDIT_TRANS_AMT = CREDIT_AMT, CREDIT_AMT = ROUND(CREDIT_AMT*POW(EXCHANGE_RT, CUR_OPERATOR), 2) WHERE CREDIT_AMT <> 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);

        //setting accounting
        if (!class_exists('Jehd'))
            includeCodeLib('Jehd');
        $jehd = new Jehd();
        $jehd->display = $this->display;
        //Reject any posible todays entry from this process thas has run today
        $jehd->jehd_reverse_by_je_source($comp_code, $this->je_source, $operation_date);
        //Build Header for this process, one pre currency
        $sql = 'SELECT DISTINCT EFFTDATE OPERATION_DATE, ' . singleQuote($comp_code) . ' COMP_CODE, ' . singleQuote($comprec['LGGROUP_CODE']) . ' LGGROUP_CODE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            $gl_rec = $jehd->jehd_init_record();
            $gl_rec['IDNAME'] = $idname;
            $gl_rec['JE_SOURCE'] = $this->je_source;
            $gl_rec['LGGROUP_CODE'] = $result['LGGROUP_CODE'];
            $gl_rec['EFFTDATE'] = $result['OPERATION_DATE'];
            $gl_rec['REAL_DATE'] = $result['OPERATION_DATE'];
            $gl_rec['COMP_CODE'] = $result['COMP_CODE'];
            $gl_rec['TRANS_CODE'] = null;
            $gl_rec['TRANSTBL_CODE'] = '';
            $gl_rec['REQ_CHANNEL'] = 'SYS';
            $gl_rec['BATCH_ID'] = $this->batch_id;
            $jehd->jehd_build($gl_rec);
            //Search any scale if apply and dump lines to journal
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec['IDCODE']) . ' JEHDR_CODE, X.GLACCOUNTCODE GLACCOUNTCODE, ' . singleQuote('CRED') . ' ITEM_CODE, X.CHART_FIELD01, X.CHART_FIELD02, X.CHART_FIELD03, X.CHART_FIELD04, X.LOAN_CODE ITEM_REF_NO, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR, X.DEBIT_AMT, X.CREDIT_AMT, X.DEBIT_TRANS_AMT, X.CREDIT_TRANS_AMT, 1 SEQNUM FROM ' . $this->glt1name . ' X WHERE BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            //contraparte
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec['IDCODE']) . ' JEHDR_CODE, X.GL01_CODE GLACCOUNTCODE, ' . singleQuote('CRED') . ' ITEM_CODE, X.CHART_FIELD01, X.CHART_FIELD02, X.CHART_FIELD03, X.CHART_FIELD04, X.LOAN_CODE ITEM_REF_NO, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR, X.CREDIT_AMT DEBIT_AMT, X.DEBIT_AMT CREDIT_AMT, X.CREDIT_TRANS_AMT DEBIT_TRANS_AMT, X.DEBIT_TRANS_AMT CREDIT_TRANS_AMT, 2 SEQNUM FROM ' . $this->glt1name . ' X WHERE BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            //Verificando conversion;
            $jehd->balance_exchange_rounding($gl_rec['IDCODE']);
            $jehd->jehd_approve_by_code($gl_rec['IDCODE']);
        }
        //Setting capitaliced amount into newly generated installments
        //Create new credit efftdate for cases where need to be capitalized
        $sql = 'SELECT DISTINCT LOAN_CODE, CAPITALIZATION_AMT, EFFTDATE FROM ' . $this->glt1name . '  WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND CAPITALIZE = 1 ';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            //Created new capitalizacion record for credit
            $this->build_credit_current_efftdate($r['LOAN_CODE']);
            //Setting capitaliced amount into newly generated installments
            $sql = 'UPDATE ' . $this->filsname . ' FILS SET FILS.BALLOON_PAY_AMT = ' . $r['CAPITALIZATION_AMT'] . ', FILS.RESTRUCTURE = 0 WHERE FILS.LOAN_CODE = ' . singleQuote($r['LOAN_CODE']) . ' AND FILS.EFFTDATE = ' . singleQuote($this->today) . ' AND FILS.PERIOD_START_DATE <= ' . singleQuote($r['EFFTDATE']) . ' AND FILS.PERIOD_END_DATE >= ' . singleQuote($r['EFFTDATE']);
            ClxCommon::$db->executeQuery($sql);
            //mark refinaning date
            $sql = 'UPDATE ' . $this->filoname . '  SET IS_REFINANCED = 1, REFINANCED = 0, REFINANCED_DATE = ' . singleQuote($r['EFFTDATE']) . ' WHERE IDCODE = ' . singleQuote($r['LOAN_CODE']) . ' AND CLX_EFFTDATE = ' . singleQuote($this->today);
            ClxCommon::$db->executeQuery($sql);
            //Recalculate amortization
            $this->build_amortization($r['LOAN_CODE'], $this->today, CLX_NUM_ZERO, CLX_NUM_ZERO);
        }
        $sql = 'DELETE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     * Ask for credit status
     * @return string
     */
    function run_gl_account_change_status_dialog() {
        $ac = UserRequest::$request ['ac'];
        $to = UserRequest::$request [CLX_PROP_TO];
        $it = '';
        UserRequest::$post['idlist'] = toString(getIdlist());
        // RTBL_REPCINV
        $EDIT = &getTool('EDIT');
        $record = array();
        $msg = array();
        $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote('FILO_ASK_STATUS') . '');
        $record = UserRequest::$post;
        if (!empty($record ['confirm'])) {
            $EDIT->checkForm2($msg, $formrec);
            if (UserRequest::$post['RTBL_LOAN_STATUS'] === 'CEAS' || UserRequest::$post['RTBL_LOAN_STATUS'] === 'VOID') {
                //Check that loan is on 0 balance
                $sql = 'SELECT COUNT(FILO.ID) FROM ' . $this->filoname . ' FILO WHERE FILO.ID IN (' . UserRequest::$post['idlist'] . ') AND FILO.PRINCIPAL_BAL <> 0 ';
                if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
                    $msg['RTBL_LOAN_STATUS'] = smsg('MSG-352');
                }
            } else {
                $sql = 'SELECT DISTINCT FILO.PRODUCT_CODE FROM ' . $this->filoname . ' FILO WHERE FILO.ID IN (' . UserRequest::$post['idlist'] . ') AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILOX WHERE FILOX.IDCODE = FILO.IDCODE AND FILOX.CLX_EFFTDATE <= ' . singleQuote($this->today) . ') AND NOT EXISTS(SELECT PRAT.ID FROM ' . $this->pratname . ' PRAT WHERE PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE AND PRAT.PROD_STATUS = ' . singleQuote(UserRequest::$post['RTBL_LOAN_STATUS']) . ') ';
                $rs = ClxCommon::$db->executeQuery($sql);
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                   if(ClxCommon::sessionUserIsAdmin() && UserRequest::$post['RTBL_LOAN_STATUS']<>'CAN'){

                   }else{
                       $msg['RTBL_LOAN_STATUS'] = smsg('MSG-150', $r['PRODUCT_CODE']);
                   }
                }
            }
            if(UserRequest::$post['RTBL_LOAN_STATUS'] === 'REE' || UserRequest::$post['RTBL_LOAN_STATUS'] === 'REEC' || UserRequest::$post['RTBL_LOAN_STATUS'] === 'ASU'){
                $msg['RTBL_LOAN_STATUS'] = smsg('MSG-20220412152852');
            }
            if (empty($msg) && !empty(UserRequest::$post['idlist'])) {
                $this->run_gl_account_change_status(UserRequest::$post['RTBL_LOAN_STATUS']);
                return note(dict('GEN_LBL_PROCESS_COMPLETED'), dict('GEN_LBL_CONTINUE'));
            }
        }
        $form = $EDIT->defaultForm($formrec, $record, $msg, $ac, $to, $it, 'tool.php', '', dict('TOOL_ANOG_CHOOSE_RECORD'), dict('GEN_LBL_EXECUTE'));
        return $form->source();
    }

    /**
     * Runs accounting to its active status. Runs by user demand
     */
    function run_gl_account_revert() {
        $this->run_gl_account_change_status('VIG');
    }

    /**
     * Sets credit status
     * @param unknown_type $status
     */
    function run_gl_account_change_status($status) {
        $idlist = getIdlist();
        if (empty($idlist))
            return;
        $sql = 'SELECT DISTINCT FILO.COMP_CODE, FILO.IDCODE, FILO.LOAN_STATUS FROM ' . $this->filoname . ' FILO WHERE FILO.ID IN (' . toString($idlist) . ') AND FILO.LOAN_STATUS <> ' . singleQuote($status) . ' AND FILO.ID = (SELECT MAX(FILOX.ID) FROM  ' . $this->filoname . ' FILOX WHERE FILOX.IDCODE = FILO.IDCODE AND FILOX.CLX_EFFTDATE<=' . singleQuote($this->today) . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while (($r = ClxCommon::$db->getNextRecord($rs, NUMERIC))) {
            $this->gl_account_set_status($status, $r[CLX_NUM_ZERO], $r[CLX_NUM_ONE]);
            //Change status
            $this->change_status($r[CLX_NUM_ONE], $status, $r[CLX_NUM_TWO]);
        }
    }

    /**
     * Changes all late credits to selected status
     * See also	PRSC: CRED_GLCH - Change Credit Status for Late credits
     * @param unknown_type $comp_code
     * @param unknown_type $status
     */
    function change_gl_all_late_credits_to_status($comp_code, $status) {
        $this->gl_account_set_status($status, $comp_code);
    }

    /**
     * Reverts accounting to selected status
     * @param string $comp_code
     * @param string $loan_code
     */
    private function gl_account_set_status($status, $comp_code, $loan_code = '') {
        //GLT1
        $this->je_source = 'CRGR'; //Credit gl change
        $DBLT = &getTool('DBLT');
        $idname = $DBLT->getListItem('SOTY', $this->je_source);
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        $comp = new Comp();
        $comprec = $comp->comp_operation_parameters($comp_code);
        $operation_date = $comprec['OPERATION_DATE'];
        if ($this->display === true) {
            echoLog(' CREDIT GL CHANGE PROCESS. BATCH ID: ' . $this->batch_id);
            echoLog('Efective date: ' . $operation_date);
            echoLog('Credit: ' . (($loan_code === '') ? 'ALL' : $loan_code));
        }
        if (empty($comprec) || empty($comp_code)) {
            echoLog('Error, no company operation parameters found');
        }
        $extra_cc = '';
        if ($loan_code === '') {
            //Seleccionando todos los casos que para la compania exista moras y cambiar status.
            $DBTB = &getTool('DBTB');
            $DBTB->buildTemporaryTable('CSCT');
            //Clear Records
            ClxCommon::$db->deleteRecords($this->csctname, '1=1');
            //Cargando tabla temporal con lista de creditos morosos
            $sql = 'INSERT INTO ' . $this->csctname . ' (COMP_CODE, LOAN_CODE, EFFTDATE, LOAN_AMT, PRINCIPAL_BAL) SELECT FILO.COMP_CODE, FILO.IDCODE LOAN_CODE, FILO.CLX_EFFTDATE, SUM(FILS.PRINCIPAL_PAY+FILS.INTEREST_PAY) LOAN_AMT, SUM(FILS.PPAL_PAID_AMT+FILS.INTPAID_AMT) PRINCIPAL_BAL FROM FIDU_CONTRACTS FICO, FIDU_ITEMS FIAS, CRED_CREDITS FILO, CRED_PAYMNT_SCHEDULES FILS, GL_PARAMETERS_TBL GLCP, CRED_PROD_PRMTR_TBL PRLT WHERE FILO.COMP_CODE = GLCP.COMP_CODE AND FILO.LOAN_STATUS NOT IN (' . singleQuote('PRE') . ', ' . singleQuote($status) . ') AND FIAS.CONTRACT_CODE = FICO.IDCODE AND FIAS.LOAN_CODE = FILO.IDCODE AND FILO.IDCODE = FILS.LOAN_CODE AND FILO.CLX_EFFTDATE = FILS.EFFTDATE AND FILS.DUE_PAY_DATE <= GLCP.OPERATION_DATE AND FILS.PERIOD_END_DATE = (SELECT MIN(FILSX.PERIOD_END_DATE) FROM CRED_PAYMNT_SCHEDULES FILSX WHERE FILSX.LOAN_CODE = FILO.IDCODE AND FILSX.EFFTDATE = FILO.CLX_EFFTDATE AND FILSX.DUE_PAY_DATE<=GLCP.OPERATION_DATE) AND FILO.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM CRED_CREDITS X WHERE X.IDCODE = FILO.IDCODE AND X.CLX_EFFTDATE<=CURDATE()) AND PRLT.PRODUCT_CODE = FILO.PRODUCT_CODE AND FILO.COMP_CODE = ' . singleQuote($comp_code) . ' AND FILO.PRINCIPAL_BAL <>0 GROUP BY FILO.COMP_CODE, FILO.IDCODE, FILO.CLX_EFFTDATE, FILO.LOAN_STATUS HAVING SUM(FILS.PRINCIPAL_PAY+FILS.INTEREST_PAY) > SUM(FILS.PPAL_PAID_AMT+FILS.INTPAID_AMT) ';
            ClxCommon::$db->executeQuery($sql);
            $extra_cc = ' AND EXISTS (SELECT CSCT.LOAN_CODE FROM ' . $this->csctname . ' CSCT WHERE CSCT.LOAN_CODE = FILO.IDCODE AND CSCT.EFFTDATE = FILO.CLX_EFFTDATE) ';
        }
        $this->initTemporaryTables($this->batch_id);
        $sql = 'INSERT INTO ' . $this->glt1name . ' (BATCH_ID, EFFTDATE, GLACCOUNTCODE, GL01_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, LOAN_CODE, PRODUCT_CODE, PROD_STATUS) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, MAX(FILO.CLX_EFFTDATE) EFFTDATE, JCBV.GLACCOUNTCODE, (case JCBV.GLACCOUNTCODE WHEN PRAT.PRO_GL_CODE THEN PRAT2.PRO_GL_CODE WHEN PRAT.AR_GL_CODE THEN PRAT2.AR_GL_CODE END) GL01_CODE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, FILO.CURRENCY_CODE, 1 CUR_OPERATOR, 1 EXCHANGE_RT, SUM(JCBV.BALANCE_AMT) DEBIT_AMT, 0 CREDIT_AMT, 0 DEBIT_TRANS_AMT, 0 CREDIT_TRANS_AMT, FILO.IDCODE LOAN_CODE, PRAT.PRODUCT_CODE, PRAT.PROD_STATUS FROM ' . $this->filoname . ' FILO, ' . $this->fiasname . ' FIAS, ' . $this->pratname . ' PRAT2, ' . $this->pratname . ' PRAT, ' . $this->jcbvname . ' JCBV WHERE FIAS.LOAN_CODE = FILO.IDCODE AND PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE AND PRAT2.PRODUCT_CODE = FILO.PRODUCT_CODE AND JCBV.CHART_FIELD01 = FIAS.CONTRACT_CODE AND JCBV.CHART_FIELD03 = FIAS.IDCODE AND JCBV.CURRENCY_CODE = FILO.CURRENCY_CODE AND JCBV.GLACCOUNTCODE IN (PRAT.PRO_GL_CODE, PRAT.AR_GL_CODE) AND FILO.LOAN_STATUS <> ' . "'PRE'" . ' AND PRAT2.PROD_STATUS = ' . singleQuote($status) . ' AND PRAT.PROD_STATUS = FILO.LOAN_STATUS AND FILO.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM CRED_CREDITS X WHERE X.IDCODE = FILO.IDCODE AND X.CLX_EFFTDATE<=' . singleQuote($this->today) . ') AND FILO.COMP_CODE = ' . singleQuote($comp_code) . ' ' . (($loan_code !== '') ? ' AND FILO.IDCODE = ' . singleQuote($loan_code) : '') . ' ' .
                $extra_cc . '  GROUP BY JCBV.GLACCOUNTCODE, PRAT.PRO_GL_CODE, PRAT2.PRO_GL_CODE, PRAT.AR_GL_CODE, PRAT2.AR_GL_CODE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, FILO.CURRENCY_CODE, FILO.IDCODE, PRAT.PRODUCT_CODE, PRAT.PROD_STATUS HAVING SUM(JCBV.BALANCE_AMT) <> 0 ORDER BY FILO.IDCODE, JCBV.GLACCOUNTCODE';
        ClxCommon::$db->executeQuery($sql);
        if (ClxCommon::$db->countRecords($this->glt1name, 'BATCH_ID = ' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
            return;
        }
        //Setting currency conversion
        $sql = 'SELECT DISTINCT CURRENCY_CODE, ' . singleQuote($operation_date) . ' OPERATION_DATE FROM ' . $this->glt1name . '  WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $rate = $comp->comp_current_exchange($comp_code, $r['CURRENCY_CODE'], $r['OPERATION_DATE']);
            $sql = 'UPDATE ' . $this->glt1name . '  SET CUR_OPERATOR = ' . singleQuote($rate['CUR_OPERATOR']) . ', EXCHANGE_RT = ' . singleQuote($rate['EXCHANGE_RT']) . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND CURRENCY_CODE = ' . singleQuote($r['CURRENCY_CODE']);
            ClxCommon::$db->executeQuery($sql);
        } //end while
        //setting credits and debits
        $sql = 'UPDATE ' . $this->glt1name . '  SET CREDIT_AMT =  -1*DEBIT_AMT WHERE DEBIT_AMT < 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt1name . '  SET DEBIT_AMT = 0 WHERE DEBIT_AMT < 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //Delete all rows from overdraft loans. or cero that will not earn int.
        $sql = 'DELETE FROM ' . $this->glt1name . ' WHERE DEBIT_AMT = 0 AND CREDIT_AMT = 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //Perform currency conversion
        //Currency conversion
        $sql = 'UPDATE ' . $this->glt1name . '  SET DEBIT_TRANS_AMT = DEBIT_AMT, DEBIT_AMT = ROUND(DEBIT_AMT*POW(EXCHANGE_RT, CUR_OPERATOR), 2) WHERE DEBIT_AMT <> 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt1name . ' SET CREDIT_TRANS_AMT = CREDIT_AMT, CREDIT_AMT = ROUND(CREDIT_AMT*POW(EXCHANGE_RT, CUR_OPERATOR), 2) WHERE CREDIT_AMT <> 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt1name . ' SET EFFTDATE = ' . singleQuote($operation_date) . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //Updating credit status
        $sql = 'UPDATE ' . $this->filoname . ' FILO, ' . $this->glt1name . ' X SET FILO.LOAN_STATUS = ' . singleQuote($status) . ' WHERE FILO.IDCODE = X.LOAN_CODE AND X.BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'DELETE FROM ' . $this->glt1name . ' WHERE GLACCOUNTCODE = GL01_CODE AND BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //setting accounting
        if (!class_exists('Jehd'))
            includeCodeLib('Jehd');
        $jehd = new Jehd();
        $jehd->display = $this->display;
        //Reject any posible todays entry from this process thas has run today
        //Build Header for this process, one pre currency
        $sql = 'SELECT DISTINCT ' . singleQuote($operation_date) . ' OPERATION_DATE, ' . singleQuote($comp_code) . ' COMP_CODE, ' . singleQuote($comprec['LGGROUP_CODE']) . ' LGGROUP_CODE FROM ' . $this->glt1name . '  WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            $gl_rec = $jehd->jehd_init_record();
            $gl_rec['IDNAME'] = $idname;
            $gl_rec['JE_SOURCE'] = $this->je_source;
            $gl_rec['LGGROUP_CODE'] = $result['LGGROUP_CODE'];
            $gl_rec['EFFTDATE'] = $result['OPERATION_DATE'];
            $gl_rec['REAL_DATE'] = $result['OPERATION_DATE'];
            $gl_rec['COMP_CODE'] = $result['COMP_CODE'];
            $gl_rec['TRANS_CODE'] = null;
            $gl_rec['TRANSTBL_CODE'] = '';
            $gl_rec['REQ_CHANNEL'] = 'SYS';
            $gl_rec['BATCH_ID'] = $this->batch_id;
            $jehd->jehd_build($gl_rec);
            //Search any scale if apply and dump lines to journal
            $sql = 'INSERT INTO ' . $this->jelnname . '  (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec['IDCODE']) . ' JEHDR_CODE, X.GLACCOUNTCODE GLACCOUNTCODE, ' . singleQuote('CRED') . ' ITEM_CODE, X.CHART_FIELD01, X.CHART_FIELD02, X.CHART_FIELD03, X.CHART_FIELD04, X.LOAN_CODE ITEM_REF_NO, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR, X.CREDIT_AMT, X.DEBIT_AMT, X.CREDIT_TRANS_AMT, X.DEBIT_TRANS_AMT, 1 SEQNUM FROM ' . $this->glt1name . ' X WHERE BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            //contraparte
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec['IDCODE']) . ' JEHDR_CODE, X.GL01_CODE GLACCOUNTCODE, ' . singleQuote('CRED') . ' ITEM_CODE, X.CHART_FIELD01, X.CHART_FIELD02, X.CHART_FIELD03, X.CHART_FIELD04, X.LOAN_CODE ITEM_REF_NO, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR, X.DEBIT_AMT DEBIT_AMT, X.CREDIT_AMT CREDIT_AMT, X.DEBIT_TRANS_AMT DEBIT_AMT, X.CREDIT_TRANS_AMT CREDIT_AMT, 2 SEQNUM FROM ' . $this->glt1name . ' X WHERE BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            //Verificando conversion;
            $jehd->balance_exchange_rounding($gl_rec['IDCODE']);
            $jehd->jehd_approve_queue_by_code($gl_rec['IDCODE']);
        }
        //Updating credit status
        //Concidenrando caso puntual en el que se cancelo completo y se necesita reversar.
        //al reversar hay que cambiar el status ya que no se puede aprobar la transaccion
        if ($loan_code <> '') {
            $sql = 'SELECT MAX(FILO.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILO WHERE FILO.IDCODE = ' . singleQuote($loan_code);
            $filo_efftdate = ClxCommon::$db->getOne($sql);
            $sql = 'UPDATE ' . $this->filoname . ' FILO SET FILO.LOAN_STATUS = ' . singleQuote($status) . ' WHERE FILO.IDCODE = ' . singleQuote($loan_code) . ' AND FILO.CLX_EFFTDATE = ' . singleQuote($filo_efftdate) . ' AND FILO.LOAN_STATUS = ' . singleQuote('CAN') . '';
            ClxCommon::$db->executeQuery($sql);
        }
        //Masive.
        if ($extra_cc <> '') {
            $sql = 'UPDATE ' . $this->filoname . ' FILO SET FILO.LOAN_STATUS = ' . singleQuote($status) . ' WHERE FILO.COMP_CODE = ' . singleQuote($comp_code) . ' $extra_cc';
            ClxCommon::$db->executeQuery($sql);
        }
    }

    /**
     * Runs pay reserveon test
     *
     */
    function filo_run_pay_reserves() {
        $idlist = getIdlist();
        if (empty($idlist))
            return;
        $sql = 'SELECT DISTINCT COMP_CODE, IDCODE FROM ' . $this->filoname . ' WHERE ID IN (' . toString($idlist) . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while (($r = ClxCommon::$db->getNextRecord($rs, NUMERIC))) {
            $this->filo_pay_reserves($r[CLX_NUM_ZERO], $r[CLX_NUM_ONE]);
        }
    }

    /**
     * Proceso para pago de reservas al fin de periodo
     *
     * @param string $comp_code
     * @param string $loan_code
     */
    private function filo_pay_reserves($comp_code, $loan_code = '') {
        //GLT1
        $this->je_source = 'PINTRP'; //Pago de intereses de reserva
        $DBLT = &getTool('DBLT');
        $idname = $DBLT->getListItem('SOTY', $this->je_source);
        $idname = substr($idname, CLX_NUM_ZERO, CLX_NUM_60);
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        $comp = new Comp();
        $comprec = $comp->comp_operation_parameters($comp_code);
        $operation_date = $comprec['OPERATION_DATE'];
        if ($this->display === true) {
            echoLog(' CREDIT RESERVES PAYMENT PROCESS. BATCH ID: ' . $this->batch_id);
            echoLog('Efective date: ' . $operation_date);
            echoLog('Credit: ' . (($loan_code === '') ? 'ALL' : $loan_code));
        }
        if (empty($comprec) || empty($comp_code)) {
            echoLog('Error, no company operation parameters found');
        }
        $this->initTemporaryTables($this->batch_id);
        //loading temporary table
        $sql = 'INSERT INTO ' . $this->glt1name . ' (BATCH_ID, EFFTDATE, GLACCOUNTCODE, GL01_CODE, GL_TYPE, BALANCE_AMT, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, LOAN_CODE, PRODUCT_CODE) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, ' . singleQuote($operation_date) . ' EFFTDATE, PRAT.RES_GL_CODE GLACCOUNTCODE, PRAT.PRO_GL_CODE GL01_CODE, ' . singleQuote('AS') . ' GL_TYPE, JCBV.BALANCE_AMT, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, JCBV.CURRENCY_CODE, 1 CUR_OPERATOR, 1 EXCHANGE_RT, 0 DEBIT_AMT, 0 CREDIT_AMT, 0 DEBIT_TRANS_AMT, 0 CREDIT_TRANS_AMT, FILO.IDCODE LOAN_CODE, FILO.PRODUCT_CODE FROM ' . $this->filoname . ' FILO, ' . $this->filsname . ' FILS, ' . $this->fiasname . ' FIAS, ' . $this->jcbvname . ' JCBV, ' . $this->pratname . ' PRAT WHERE FILO.IDCODE = FIAS.LOAN_CODE AND FIAS.IDCODE = JCBV.CHART_FIELD03 AND PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE AND PRAT.RES_GL_CODE = JCBV.GLACCOUNTCODE AND FILS.LOAN_CODE = FILO.IDCODE AND FILS.EFFTDATE = FILO.CLX_EFFTDATE AND FILO.COMP_CODE = ' . singleQuote($comp_code) . ' AND JCBV.BALANCE_AMT<>0 AND FILO.RESERVE_OPT = 1 AND FILS.PERIOD_END_DATE = ' . singleQuote($operation_date) . ' ' . (($loan_code !== '') ? ' AND FILO.IDCODE =' . singleQuote($loan_code) . ' ' : '') . ' AND FILO.CLX_EFFTDATE = (SELECT MAX(FILO2.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILO2 WHERE FILO2.IDCODE = FILO.IDCODE AND FILO2.CLX_EFFTDATE<=' . singleQuote($this->today) . ')';
        ClxCommon::$db->executeQuery($sql);
        if (ClxCommon::$db->countRecords($this->glt1name, 'BATCH_ID = ' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
            return;
        }
        //Set type AS/LI
        $sql = 'UPDATE ' . $this->glt1name . '  GLT1 SET GLT1.GL_TYPE = (SELECT MAX(GLAC.GL_TYPE) FROM ' . $this->glacname . ' GLAC WHERE GLAC.IDCODE = GLT1.GL01_CODE) WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'SELECT DISTINCT CURRENCY_CODE, ' . singleQuote($operation_date) . ' OPERATION_DATE FROM ' . $this->glt1name . '  WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $rate = $comp->comp_current_exchange($comp_code, $r['CURRENCY_CODE'], $r['OPERATION_DATE']);
            $sql = 'UPDATE ' . $this->glt1name . ' SET CUR_OPERATOR = ' . singleQuote($rate['CUR_OPERATOR']) . ', EXCHANGE_RT = ' . singleQuote($rate['EXCHANGE_RT']) . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND CURRENCY_CODE = ' . singleQuote($r['CURRENCY_CODE']);
            ClxCommon::$db->executeQuery($sql);
        } //end while
        //Calculando intereses
        $sql = 'UPDATE ' . $this->glt1name . ' SET DEBIT_AMT = -1*BALANCE_AMT WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND BALANCE_AMT<0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt1name . ' SET CREDIT_AMT = BALANCE_AMT WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND BALANCE_AMT>0';
        ClxCommon::$db->executeQuery($sql);
        //Currency conversion
        $sql = 'UPDATE ' . $this->glt1name . ' SET DEBIT_TRANS_AMT = DEBIT_AMT, DEBIT_AMT = ROUND(DEBIT_AMT*POW(EXCHANGE_RT, CUR_OPERATOR), 2) WHERE DEBIT_AMT <> 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt1name . ' SET CREDIT_TRANS_AMT = CREDIT_AMT, CREDIT_AMT = ROUND(CREDIT_AMT*POW(EXCHANGE_RT, CUR_OPERATOR), 2) WHERE CREDIT_AMT <> 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        if (!class_exists('Jehd'))
            includeCodeLib('Jehd');
        $jehd = new Jehd();
        $jehd->display = $this->display;
        //Reject any posible todays entry from this process thas has run today
        $jehd->jehd_reverse_by_je_source($comp_code, $this->je_source, $operation_date);
        /* 2. GENERAR ACTIVIDADES DE DEVENGO PARA PARTICIPANTES DE CONTRATO */
        //Build Header for this process, one pre currency
        $sql = 'SELECT DISTINCT CURRENCY_CODE, EFFTDATE OPERATION_DATE, ' . singleQuote($comp_code) . ' COMP_CODE, ' . singleQuote($comprec['LGGROUP_CODE']) . ' LGGROUP_CODE FROM ' . $this->glt1name . '  WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            $gl_rec = $jehd->jehd_init_record();
            $gl_rec['IDNAME'] = $idname;
            $gl_rec['JE_SOURCE'] = $this->je_source;
            $gl_rec['LGGROUP_CODE'] = $result['LGGROUP_CODE'];
            $gl_rec['EFFTDATE'] = $result['OPERATION_DATE'];
            $gl_rec['COMP_CODE'] = $result['COMP_CODE'];
            $gl_rec['TRANS_CODE'] = null;
            $gl_rec['TRANSTBL_CODE'] = 'SYS_CRED-RES';
            $gl_rec['REQ_CHANNEL'] = 'SYS';
            $gl_rec['BATCH_ID'] = $this->batch_id;
            $jehd->jehd_build($gl_rec);
            //Search any scale if apply and dump lines to journal
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec['IDCODE']) . ' JEHDR_CODE, X.GLACCOUNTCODE GLACCOUNTCODE, ' . singleQuote('IP') . ' ITEM_CODE, X.CHART_FIELD01, X.CHART_FIELD02, X.CHART_FIELD03, X.CHART_FIELD04, X.LOAN_CODE ITEM_REF_NO, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR, X.DEBIT_AMT, X.CREDIT_AMT, X.DEBIT_TRANS_AMT, X.CREDIT_TRANS_AMT, 1 SEQNUM FROM ' . $this->glt1name . ' X WHERE BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            //contraparte
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec['IDCODE']) . ' JEHDR_CODE, X.GL01_CODE GLACCOUNTCODE, ' . singleQuote('IP') . ' ITEM_CODE, X.CHART_FIELD01, X.CHART_FIELD02, X.CHART_FIELD03, X.CHART_FIELD04, X.LOAN_CODE ITEM_REF_NO, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR, X.CREDIT_AMT DEBIT_AMT, X.DEBIT_AMT CREDIT_AMT, X.CREDIT_TRANS_AMT DEBIT_TRANS_AMT, X.DEBIT_TRANS_AMT CREDIT_TRANS_AMT, 2 SEQNUM FROM ' . $this->glt1name . ' X WHERE BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
            //Verificando conversion;
            $jehd->balance_exchange_rounding($gl_rec['IDCODE']);
            $jehd->jehd_approve_by_code($gl_rec['IDCODE']);
        }
    }

    /**
     * Run late fees
     *
     * @param string $comp_code
     */
    function run_var_interest_adj_cron($comp_code) {
        $this->display = true;
        $this->var_interest_adj($comp_code);
    }

    /**
     * Calculate late fees
     *
     */
    function run_var_interest_adj() {
        $idlist = getIdlist();
        if (empty($idlist))
            return;
        $sql = 'SELECT DISTINCT COMP_CODE, IDCODE FROM ' . $this->filoname . '  WHERE ID IN (' . toString($idlist) . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while (($r = ClxCommon::$db->getNextRecord($rs, NUMERIC))) {
            $this->var_interest_adj($r[CLX_NUM_ZERO], $r[CLX_NUM_ONE]);
        }
    }

    /**
     * Variable interest adjustment process
     *
     * @param atring $comp_code
     * @param string $loan_code
     */
    private function var_interest_adj($comp_code, $loan_code = '') {
        /*
         * 1. Seleccionar todos los prestamos con fecha de revision de indice
         * 	de ADJ_INDEX_DATE + PERIODO = FECHA DE OPERACIONES
         * 2. Actualizar monto de Intereses y Reservas en registro temporal
         * 3. Insertar nuevos registros de prestamos.
         * 4. Copiar tablas de amortizaciones con nueva fecha efectiva
         * 5. Ajustar intervalo de couta.
         */
        $this->initTemporaryTables($this->batch_id);
        $sql = 'SELECT OPERATION_DATE FROM ' . $this->glcpname . '  WHERE COMP_CODE = ' . singleQuote($comp_code);
        $operation_date = ClxCommon::$db->getOne($sql);
        ClxFreeReturn(adodb_prev_day($operation_date));
        //Search field to include on the copy
        $fields = array();
        $sql = 'SELECT FIELDNAME FROM CLX_DB_TABLEFIELDS WHERE TABLECODE = ' . singleQuote('FILO') . ' AND FIELDNAME NOT IN (' . singleQuote('ID') . ',' . singleQuote('BATCH_ID') . ', ' . singleQuote('ADJ_INDEX_DATE') . ', ' . singleQuote('CLX_EFFTDATE') . ', ' . singleQuote('INDEX_RATE') . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $fields[] = $r['FIELDNAME'];
        }
        $fields_sel = 'FILO.' . implode(', FILO.', $fields);
        $fields = implode(', ', $fields);
        //clear table if exists
        ClxCommon::$db->dropTable('CRED_CREDIT_TMP');
        $sql = 'CREATE TEMPORARY TABLE CRED_CREDIT_TMP SELECT ' . $fields_sel . ', INDX.INTEREST_RT INDEX_RATE, (case FILO.ADJ_PATTERN WHEN ' . singleQuote('S') . ' THEN  ADDDATE(FILO.ADJ_INDEX_DATE, INTERVAL 6*FILO.ADJ_PATT_PERIOD MONTH) WHEN ' . singleQuote('M') . ' THEN  ADDDATE(FILO.ADJ_INDEX_DATE, INTERVAL FILO.ADJ_PATT_PERIOD MONTH) WHEN ' . singleQuote('Y') . ' THEN  ADDDATE(FILO.ADJ_INDEX_DATE, INTERVAL FILO.ADJ_PATT_PERIOD YEAR) WHEN ' . singleQuote('D') . ' THEN  ADDDATE(FILO.ADJ_INDEX_DATE, INTERVAL FILO.ADJ_PATT_PERIOD DAY) END ) ADJ_INDEX_DATE, ' . singleQuote($this->today) . ' CLX_EFFTDATE, ' . singleQuote($this->batch_id) . ' BATCH_ID, FILO.CLX_EFFTDATE FILO_PREV_EFFTDATE FROM ' . $this->prltname . ' PRLT, ' . $this->filoname . ' FILO, ' . $this->glcpname . ' GLCP, ' . $this->indxname . ' INDX WHERE GLCP.COMP_CODE = FILO.COMP_CODE AND PRLT.PRODUCT_CODE = FILO.PRODUCT_CODE AND FILO.CRED_PAY_METHOD IN (' . singleQuoteArray(array('1', '2')) . ') AND FILO.COMP_CODE = ' . singleQuote($comp_code) . ' AND FILO.INTEREST_TYPE = ' . singleQuote('VAR') . ' AND FILO.ADJ_PATTERN IN (' . singleQuoteArray(array('S', 'M', 'Y', 'D')) . ') AND FILO.ADJ_INDEX_DATE = GLCP.OPERATION_DATE AND INDX.INTEREST_RT<>FILO.INDEX_RATE AND INDX.ADJ_INDEX = FILO.ADJ_INDEX AND INDX.CLX_EFFTDATE = (SELECT MAX(Y.CLX_EFFTDATE) FROM ' . $this->indxname . ' Y WHERE Y.ADJ_INDEX = INDX.ADJ_INDEX AND Y.CLX_EFFTDATE <= GLCP.OPERATION_DATE) AND FILO.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM  ' . $this->filoname . ' X WHERE X.IDCODE = FILO.IDCODE AND X.CLX_EFFTDATE<=NOW()) ' . (($loan_code !== '') ? ' AND FILO.IDCODE =' . singleQuote($loan_code) . ' ' : '');
        ClxCommon::$db->executeQuery($sql);
        //actualizando indices.
        $sql = 'UPDATE CRED_CREDIT_TMP T SET T.RESERVE_PCT = IFNULL((SELECT INDX.INTEREST_RT FROM ' . $this->indxname . ' INDX WHERE INDX.ADJ_INDEX  = T.RESERVE_INDEX AND INDX.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM ' . $this->indxname . ' X WHERE X.ADJ_INDEX = INDX.ADJ_INDEX AND X.CLX_EFFTDATE<=' . singleQuote($operation_date) . ')),0) WHERE T.BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //Actualizando montos de intereses basados en nuevos indices
        $sql = 'UPDATE CRED_CREDIT_TMP SET LOAN_INTEREST = (INDEX_RATE+ADJ_POINTS_OVERINDEX), RESERVE_PCT = (LOAN_INTEREST-RESERVE_PCT) WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //Borrando nuevos registros de creditos que ya se encuentren registrados
        //para fecha de operaciones seleccionada
        $sql = 'DELETE T.* FROM CRED_CREDIT_TMP T WHERE T.IDCODE IN (SELECT DISTINCT FILO.IDCODE FROM ' . $this->filoname . ' FILO WHERE FILO.IDCODE = T.IDCODE AND FILO.CLX_EFFTDATE = T.CLX_EFFTDATE)';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'INSERT INTO ' . $this->filoname . '  (ADJ_INDEX_DATE, CLX_EFFTDATE, INDEX_RATE, '.$fields.') SELECT ADJ_INDEX_DATE, CLX_EFFTDATE, INDEX_RATE, ' . $fields . ' FROM CRED_CREDIT_TMP WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //Contruyendo nueva tablas de amortizaciones para los creditos
        $a = UserRequest::$request['ac']; //save for later
        $sql = 'SELECT IDCODE LOAN_CODE, CLX_EFFTDATE FROM CRED_CREDIT_TMP WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $this->build_amortization($r['LOAN_CODE'], $r['CLX_EFFTDATE'], CLX_NUM_ZERO, CLX_NUM_ONE);
        }
        unset($a);
    }

    /**
     * Calculate late fees
     *
     */
    function run_fees() {
        $idlist = getIdlist();
        if (empty($idlist))
            return;
        $sql = 'SELECT DISTINCT COMP_CODE, IDCODE FROM ' . $this->filoname . '  WHERE ID IN (' . toString($idlist) . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while (($r = ClxCommon::$db->getNextRecord($rs, NUMERIC))) {
            $this->filo_register_late_amounts($r[CLX_NUM_ZERO], $r[CLX_NUM_ONE]);
            $this->fees($r[CLX_NUM_ZERO], $r[CLX_NUM_ONE]);
        }
    }

    /**
     * Fees calculation process
     *
     * @param atring $comp_code
     * @param string $loan_code
     */
    private function fees($comp_code, $loan_code = '') {

        $this->je_source = 'CRLF'; //provision de intereses de prestamos
        $DBLT = &getTool('DBLT');
        $idname = $DBLT->getListItem('SOTY', $this->je_source);
        if (!class_exists('Comp')){
            includeCodeLib('COMP');
        }
        $comp = new Comp();
        $comprec = $comp->comp_operation_parameters($comp_code);
        $operation_date = $comprec['OPERATION_DATE'];
        if ($this->display === true) {
            echoLog(' CREDIT FEES CALC PROCESS. BATCH ID: ' . $this->batch_id);
            echoLog('Efective date: ' . $operation_date);
            echoLog('Credit: ' . (($loan_code === '') ? 'ALL' : $loan_code));
        }
        if (empty($comprec) || empty($comp_code)) {
            echoLog('Error, no company operation parameters found');
        }
        //Verificar si ya corrio el proceso
        $sql = 'SELECT COUNT(JEHD.ID) QTY FROM ' . $this->jehdname . ' JEHD WHERE JEHD.COMP_CODE = ' . singleQuote($comp_code) . ' AND JEHD.JE_SOURCE = ' . singleQuote($this->je_source) . ' AND JEHD.EFFTDATE = ' . singleQuote($operation_date) . ' AND JEHD.JE_STATUS = ' . singleQuote('AP') . ' AND JEHD.REVERSED = 0';
        if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
            if ($this->display === true) {
                echoLog('Already done process ' . $this->je_source . ' on ' . $comp_code . ' for ' . $operation_date);
            }
            return;
        }
        //Inicializando tablas temporales.
        $this->initTemporaryTables($this->batch_id);


        /* Seleccionando creditos y comisiones */
        #$sql = 'INSERT INTO ' . $this->glt1name . '  (BATCH_ID, COMP_CODE, EFFTDATE, GLACCOUNTCODE, GL01_CODE, GL_TYPE, BALANCE_AMT, CALC_AMT_01, PENALTY_CALC_TYPE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, LOAN_CODE, PRODUCT_CODE, CALC_AMT_02, CALC_AMT_03, CALC_AMT_04, DIVIDER_FACTOR, SEQNUM, BILLING, GLPF_ID) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, CRED.COMP_CODE, CRED.EFFTDATE, CRED.GLACCOUNTCODE, CRED.GL01_CODE, JCBV.GL_TYPE, CRED.DUE_AMT BALANCE_AMT, CRED.CALC_AMT_01, CRED.PENALTY_CALC_TYPE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, JCBV.CURRENCY_CODE, 1 CUR_OPERATOR, 1 EXCHANGE_RT, 0 DEBIT_AMT, 0 CREDIT_AMT, 0 DEBIT_TRANS_AMT, 0 CREDIT_TRANS_AMT, CRED.LOAN_CODE, CRED.PRODUCT_CODE, SUM(JCBV.BALANCE_AMT) CALC_AMT_02, 0 CALC_AMT_03, 0 CALC_AMT_04, CRED.DIVIDER_FACTOR, CRED.SEQNUM, CRED.BILLING, CRED.GLPF_ID FROM (SELECT DISTINCT GLPF.ID GLPF_ID, FILO.COMP_CODE, FILO.IDCODE LOAN_CODE, FIAS.IDCODE ASSET_CODE, FILO.LOAN_STATUS PROD_STATUS, FILO.CLX_EFFTDATE EFFTDATE, FILO.CURRENCY_CODE, PRAT.PRO_GL_CODE, GLPF.FEE_GL_CODE GLACCOUNTCODE, GLPF.FEE2_GL_CODE GL01_CODE, GLPF.SEQNUM CALC_AMT_01, GLPF.FEE_FORMULA PENALTY_CALC_TYPE, GLPF.PRODUCT_CODE, GLPF.DIVIDER_FACTOR, GLPF.SEQNUM, GLPF.CHARGE_CUSTOMER, case GLPF.FEE_FORMULA WHEN ' . singleQuote('P0001') . ' THEN  FILO.DUE_PRO_AMT WHEN ' . singleQuote('P0002') . ' THEN  (FILO.DUE_PRO_AMT+FILO.DUE_AR_AMT) WHEN ' . singleQuote('P0003') . ' THEN  FILO.DUE_AR_AMT ELSE 0 END DUE_AMT, GLPF.BILLING FROM ' . $this->fiasname . ' FIAS, ' . $this->filoname . ' FILO, ' . $this->glpfname . ' GLPF, ' . $this->pratname . ' PRAT WHERE GLPF.PRODUCT_CODE = FILO.PRODUCT_CODE AND GLPF.PROD_STATUS = FILO.LOAN_STATUS AND PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE AND PRAT.PROD_STATUS = FILO.LOAN_STATUS AND FIAS.LOAN_CODE = FILO.IDCODE AND GLPF.STATUS = ' . singleQuote('A') . ' AND GLPF.FEE_FORMULA IN (' . singleQuoteArray(array('P0001', 'P0002', 'P0003')) . ') AND FILO.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM CRED_CREDITS X WHERE X.IDCODE = FILO.IDCODE AND X.CLX_EFFTDATE<=' . singleQuote($this->today) . ') AND FILO.COMP_CODE = ' . singleQuote($comp_code) . ' AND ((GLPF.FEE_FORMULA = ' . singleQuote('P0001') . ' AND FILO.DUE_PRO_AMT>0) OR (GLPF.FEE_FORMULA = ' . singleQuote('P0002') . ' AND (FILO.DUE_PRO_AMT+FILO.DUE_AR_AMT)>0) OR (GLPF.FEE_FORMULA = ' . singleQuote('P0003') . ' AND FILO.DUE_AR_AMT>0)) ' . (($loan_code !== '') ? ' AND FILO.IDCODE =' . singleQuote($loan_code) . ' ' : '') . ' ) CRED, ' . $this->jcbvname . ' JCBV WHERE JCBV.CHART_FIELD03  = CRED.ASSET_CODE AND JCBV.GLACCOUNTCODE = CRED.PRO_GL_CODE AND CRED.CURRENCY_CODE = JCBV.CURRENCY_CODE AND JCBV.COMP_CODE = ' . singleQuote($comp_code) . ' ' . (($loan_code !== '') ? ' AND CRED.LOAN_CODE =' . singleQuote($loan_code) . ' ' : '') . ' GROUP BY CRED.COMP_CODE, CRED.EFFTDATE, CRED.GLACCOUNTCODE, CRED.GL01_CODE, JCBV.GL_TYPE, CRED.DUE_AMT, CRED.CALC_AMT_01, CRED.PENALTY_CALC_TYPE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, JCBV.CURRENCY_CODE, CRED.LOAN_CODE, CRED.PRODUCT_CODE, CRED.DIVIDER_FACTOR, CRED.SEQNUM, CRED.BILLING, CRED.GLPF_ID HAVING CRED.DUE_AMT>0 AND SUM(JCBV.BALANCE_AMT) <>0';
        /*SIN SUBCUENTA ORIGINAL*/ $sql = 'INSERT INTO ' . $this->glt1name . '  (BATCH_ID, COMP_CODE, EFFTDATE, GLACCOUNTCODE, GL01_CODE, GL_TYPE, BALANCE_AMT, CALC_AMT_01, PENALTY_CALC_TYPE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, LOAN_CODE, PRODUCT_CODE, CALC_AMT_02, CALC_AMT_03, CALC_AMT_04, DIVIDER_FACTOR, SEQNUM, BILLING, GLPF_ID) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, CRED.COMP_CODE, CRED.EFFTDATE, CRED.GLACCOUNTCODE, CRED.GL01_CODE, JCBV.GL_TYPE, CRED.DUE_AMT BALANCE_AMT, CRED.CALC_AMT_01, CRED.PENALTY_CALC_TYPE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, IF(CRED.CHARGE_CUSTOMER=1, JCBV.CHART_FIELD03, null) CHART_FIELD03, JCBV.CHART_FIELD04, JCBV.CURRENCY_CODE, 1 CUR_OPERATOR, 1 EXCHANGE_RT, 0 DEBIT_AMT, 0 CREDIT_AMT, 0 DEBIT_TRANS_AMT, 0 CREDIT_TRANS_AMT, CRED.LOAN_CODE, CRED.PRODUCT_CODE, SUM(JCBV.BALANCE_AMT) CALC_AMT_02, 0 CALC_AMT_03, 0 CALC_AMT_04, CRED.DIVIDER_FACTOR, CRED.SEQNUM, CRED.BILLING, CRED.GLPF_ID FROM (SELECT DISTINCT GLPF.ID GLPF_ID, FILO.COMP_CODE, FILO.IDCODE LOAN_CODE, FIAS.IDCODE ASSET_CODE, FILO.LOAN_STATUS PROD_STATUS, FILO.CLX_EFFTDATE EFFTDATE, FILO.CURRENCY_CODE, PRAT.PRO_GL_CODE, GLPF.FEE_GL_CODE GLACCOUNTCODE, GLPF.FEE2_GL_CODE GL01_CODE, GLPF.SEQNUM CALC_AMT_01, GLPF.FEE_FORMULA PENALTY_CALC_TYPE, GLPF.PRODUCT_CODE, GLPF.DIVIDER_FACTOR, GLPF.SEQNUM, GLPF.CHARGE_CUSTOMER, case GLPF.FEE_FORMULA WHEN ' . singleQuote('P0001') . ' THEN  FILO.DUE_PRO_AMT WHEN ' . singleQuote('P0002') . ' THEN  (FILO.DUE_PRO_AMT+FILO.DUE_AR_AMT) WHEN ' . singleQuote('P0003') . ' THEN  FILO.DUE_AR_AMT ELSE 0 END DUE_AMT, GLPF.BILLING FROM ' . $this->fiasname . ' FIAS, ' . $this->filoname . ' FILO, ' . $this->glpfname . ' GLPF, ' . $this->pratname . ' PRAT WHERE GLPF.PRODUCT_CODE = FILO.PRODUCT_CODE AND GLPF.PROD_STATUS = FILO.LOAN_STATUS AND PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE AND PRAT.PROD_STATUS = FILO.LOAN_STATUS AND FIAS.LOAN_CODE = FILO.IDCODE AND GLPF.STATUS = ' . singleQuote('A') . ' AND GLPF.FEE_FORMULA IN (' . singleQuoteArray(array('P0001', 'P0002', 'P0003')) . ') AND FILO.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM CRED_CREDITS X WHERE X.IDCODE = FILO.IDCODE AND X.CLX_EFFTDATE<=' . singleQuote($this->today) . ') AND FILO.COMP_CODE = ' . singleQuote($comp_code) . ' AND ((GLPF.FEE_FORMULA = ' . singleQuote('P0001') . ' AND FILO.DUE_PRO_AMT>0) OR (GLPF.FEE_FORMULA = ' . singleQuote('P0002') . ' AND (FILO.DUE_PRO_AMT+FILO.DUE_AR_AMT)>0) OR (GLPF.FEE_FORMULA = ' . singleQuote('P0003') . ' AND FILO.DUE_AR_AMT>0)) ' . (($loan_code !== '') ? ' AND FILO.IDCODE =' . singleQuote($loan_code) . ' ' : '') . ' ) CRED, ' . $this->jcbvname . ' JCBV WHERE JCBV.CHART_FIELD03  = CRED.ASSET_CODE AND JCBV.GLACCOUNTCODE = CRED.PRO_GL_CODE AND CRED.CURRENCY_CODE = JCBV.CURRENCY_CODE AND JCBV.COMP_CODE = ' . singleQuote($comp_code) . ' ' . (($loan_code !== '') ? ' AND CRED.LOAN_CODE =' . singleQuote($loan_code) . ' ' : '') . ' GROUP BY CRED.COMP_CODE, CRED.EFFTDATE, CRED.GLACCOUNTCODE, CRED.GL01_CODE, JCBV.GL_TYPE, CRED.DUE_AMT, CRED.CALC_AMT_01, CRED.PENALTY_CALC_TYPE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, JCBV.CURRENCY_CODE, CRED.LOAN_CODE, CRED.PRODUCT_CODE, CRED.DIVIDER_FACTOR, CRED.SEQNUM, CRED.BILLING, CRED.GLPF_ID HAVING CRED.DUE_AMT>0 AND SUM(JCBV.BALANCE_AMT) <>0';
        ClxCommon::$db->executeQuery($sql);


        //Adding fees for loan comisions
        //Saldo en cuota se agrega en pago para colocar este saldo
        //Se comenta la subcuenta para que no aparesca en el pago
        $sql = 'INSERT INTO ' . $this->glt1name . '  (COMP_CODE, BATCH_ID, EFFTDATE, GLACCOUNTCODE, GL01_CODE, GL_TYPE, BALANCE_AMT, CALC_AMT_01, PENALTY_CALC_TYPE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, DEBIT_AMT, CREDIT_AMT, LOAN_CODE, PRODUCT_CODE, CALC_AMT_02, CALC_AMT_03, CALC_AMT_04, DIVIDER_FACTOR, SEQNUM, PAY_TX_CODE, BILLING, GLPF_ID) SELECT CRED.COMP_CODE, ' . singleQuote($this->batch_id) . ' BATCH_ID, CRED.EFFTDATE, CRED.GLACCOUNTCODE, CRED.GL01_CODE, JCBV.GL_TYPE, CRED.PRINCIPAL_BAL BALANCE_AMT, CRED.CALC_AMT_01, CRED.PENALTY_CALC_TYPE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, IF(CRED.CHARGE_CUSTOMER=1, JCBV.CHART_FIELD03, null) CHART_FIELD03, JCBV.CHART_FIELD04, JCBV.CURRENCY_CODE, 1 CUR_OPERATOR, 1 EXCHANGE_RT, 0 DEBIT_AMT, 0 CREDIT_AMT, CRED.LOAN_CODE, CRED.PRODUCT_CODE, case JCBV.GL_TYPE WHEN ' . singleQuote('LI') . ' THEN -1*JCBV.BALANCE_AMT ELSE JCBV.BALANCE_AMT END CALC_AMT_02, 0 CALC_AMT_03, 0 CALC_AMT_04, CRED.DIVIDER_FACTOR, CRED.SEQNUM, CRED.PAY_TX_CODE, CRED.BILLING, CRED.GLPF_ID FROM (SELECT GLPF.ID GLPF_ID, FILO.COMP_CODE, FILO.IDCODE LOAN_CODE, GLPF.PROD_STATUS, FILO.CURRENCY_CODE, FILO.CLX_EFFTDATE EFFTDATE, GLPF.FEE_GL_CODE GLACCOUNTCODE, GLPF.FEE2_GL_CODE GL01_CODE, GLPF.SEQNUM CALC_AMT_01, GLPF.FEE_FORMULA PENALTY_CALC_TYPE, FILO.PRODUCT_CODE, GLPF.DIVIDER_FACTOR, GLPF.SEQNUM, GLPF.CHARGE_CUSTOMER, FILO.PRINCIPAL_BAL, FIAS.IDCODE ASSET_CODE, PRAT.PRO_GL_CODE, GLPF.PAY_TX_CODE, GLPF.BILLING FROM ' . $this->filoname . ' FILO, ' . $this->glpfname . ' GLPF, ' . $this->glcpname . ' GLCP, ' . $this->fiasname . ' FIAS, ' . $this->pratname . ' PRAT WHERE GLCP.COMP_CODE = FILO.COMP_CODE AND GLPF.PRODUCT_CODE = FILO.PRODUCT_CODE AND GLPF.PROD_STATUS = FILO.LOAN_STATUS AND FIAS.LOAN_CODE = FILO.IDCODE AND PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE AND PRAT.PROD_STATUS = FILO.LOAN_STATUS AND FILO.PRINCIPAL_BAL <> 0 AND GLPF.STATUS = ' . singleQuote('A') . ' AND GLPF.FEE_FORMULA = ' . singleQuote('P0004') . ' AND FILO.START_DATE <' . singleQuote($operation_date) . ' /*CONDICION DE COMISION POR SALDO EN COUTA*/ AND (GLPF.CPAY_FREQUENCY <> ' . singleQuote('CHGR') . ' OR (GLPF.CPAY_FREQUENCY = ' . singleQuote('CHGR') . ' AND EXISTS(SELECT FILS.ID FROM CRED_PAYMNT_SCHEDULES FILS WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILS.EFFTDATE = FILO.CLX_EFFTDATE AND FILS.PERIOD_END_DATE = ' . singleQuote($operation_date) . ')) ) AND FILO.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM CRED_CREDITS X WHERE X.IDCODE = FILO.IDCODE AND X.CLX_EFFTDATE<=' . singleQuote($this->now) . ') AND GLCP.COMP_CODE = ' . singleQuote($comp_code) . ' ' . (($loan_code !== '') ? ' AND FILO.IDCODE =' . singleQuote($loan_code) : '') . ') CRED, ' . $this->jcbvname . ' JCBV WHERE JCBV.CHART_FIELD03 = CRED.ASSET_CODE AND JCBV.GLACCOUNTCODE = CRED.PRO_GL_CODE AND JCBV.CURRENCY_CODE = CRED.CURRENCY_CODE AND JCBV.COMP_CODE = ' . singleQuote($comp_code) . ' ' . (($loan_code !== '') ? ' AND CRED.LOAN_CODE =' . singleQuote($loan_code) : '');
        ClxCommon::$db->executeQuery($sql);

        //Adding interest Fees This fee calculates partial interest for example if interest is 5% then 3%(spread) is for fees
        //so it calculates similar to the interest rutine. See filo::filo_earn_interest()
        //Colocando chart field3 en null ya que la comision se paga sin importar subcuentas va acuentas por cobrar
        //Debe calcular con la misma logica de los intereses segun sea el status. Interes simple en funcion del saldo o no interes simple segun cuota
        //interest over installment
        $sql = 'INSERT INTO ' . $this->glt1name . '  (COMP_CODE, BATCH_ID, EFFTDATE, GLACCOUNTCODE, GL01_CODE, GL_TYPE, BALANCE_AMT, CALC_AMT_01, PENALTY_CALC_TYPE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, DEBIT_AMT, CREDIT_AMT, LOAN_CODE, PRODUCT_CODE, CALC_AMT_02, CALC_AMT_03, CALC_AMT_04, DIVIDER_FACTOR, SEQNUM, BILLING, GLPF_ID) SELECT FILO.COMP_CODE, ' . singleQuote($this->batch_id) . ' BATCH_ID, FILO.CLX_EFFTDATE EFFTDATE, GLPF.FEE_GL_CODE GLACCOUNTCODE, GLPF.FEE2_GL_CODE GL01_CODE, JCBV.GL_TYPE, FILS.LOAN_AMT BALANCE_AMT, GLPF.SEQNUM CALC_AMT_01, GLPF.FEE_FORMULA PENALTY_CALC_TYPE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, null CHART_FIELD03, JCBV.CHART_FIELD04, JCBV.CURRENCY_CODE, 1 CUR_OPERATOR, 1 EXCHANGE_RT, 0 DEBIT_AMT, 0 CREDIT_AMT, FILO.IDCODE LOAN_CODE, FILO.PRODUCT_CODE, SUM(case JCBV.GL_TYPE WHEN ' . singleQuote('LI') . ' THEN -1*JCBV.BALANCE_AMT ELSE JCBV.BALANCE_AMT END) CALC_AMT_02, 0 CALC_AMT_03, 0 CALC_AMT_04, GLPF.DIVIDER_FACTOR DIVIDER_FACTOR, GLPF.SEQNUM, GLPF.BILLING, GLPF.ID GLPF_ID FROM ' . $this->filoname . ' FILO, ' . $this->filsname . ' FILS, ' . $this->fiasname . ' FIAS, ' . $this->jcbvname . ' JCBV, ' . $this->pratname . ' PRAT, ' . $this->prltname . ' PRLT, ' . $this->glpfname . ' GLPF WHERE FILO.IDCODE = FIAS.LOAN_CODE AND FILS.LOAN_CODE = FILO.IDCODE AND FILS.EFFTDATE = FILO.CLX_EFFTDATE AND GLPF.PRODUCT_CODE = PRAT.PRODUCT_CODE AND GLPF.PROD_STATUS = FILO.LOAN_STATUS AND GLPF.FEE_FORMULA = ' . singleQuote('P0005') . ' AND GLPF.STATUS = ' . singleQuote('A') . ' AND FILS.PERIOD_START_DATE < ' . singleQuote($operation_date) . ' AND FILS.PERIOD_END_DATE >= ' . singleQuote($operation_date) . ' AND FIAS.IDCODE = JCBV.CHART_FIELD03 AND PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE AND PRAT.PRO_GL_CODE = JCBV.GLACCOUNTCODE AND FILO.CURRENCY_CODE = JCBV.CURRENCY_CODE AND JCBV.BALANCE_AMT <> 0 AND FILS.INTEREST_PAY <> 0 AND FILS.INSTALLMENT_NO > FILO.INT_GRACE_PERIODS AND PRLT.PRODUCT_CODE = FILO.PRODUCT_CODE AND PRLT.SIMPLE_INTEREST = 0 AND PRAT.PROD_STATUS = FILO.LOAN_STATUS AND FILO.CALC_INTEREST = 1 AND FILO.COMP_CODE = ' . singleQuote($comp_code) . ' ' . (($loan_code !== '') ? ' AND FILO.IDCODE =' . singleQuote($loan_code) : '') . ' AND FILO.CLX_EFFTDATE = (SELECT MAX(FILO2.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILO2 WHERE FILO2.IDCODE = FILO.IDCODE AND FILO2.CLX_EFFTDATE<=' . singleQuote($this->now) . ') GROUP BY FILO.COMP_CODE, FILO.CLX_EFFTDATE, GLPF.FEE_GL_CODE, GLPF.FEE2_GL_CODE, JCBV.GL_TYPE, FILS.LOAN_AMT, GLPF.SEQNUM, GLPF.FEE_FORMULA, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD04, JCBV.CURRENCY_CODE, FILO.IDCODE, FILO.PRODUCT_CODE, JCBV.GL_TYPE, GLPF.DIVIDER_FACTOR, GLPF.SEQNUM, GLPF.BILLING, GLPF.ID';
        ClxCommon::$db->executeQuery($sql);

        //Caso de interes simple
        $sql = 'INSERT INTO ' . $this->glt1name . '  (COMP_CODE, BATCH_ID, EFFTDATE, GLACCOUNTCODE, GL01_CODE, GL_TYPE, BALANCE_AMT, CALC_AMT_01, PENALTY_CALC_TYPE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, DEBIT_AMT, CREDIT_AMT, LOAN_CODE, PRODUCT_CODE, CALC_AMT_02, CALC_AMT_03, CALC_AMT_04, DIVIDER_FACTOR, SEQNUM, BILLING, GLPF_ID) SELECT FILO.COMP_CODE, ' . singleQuote($this->batch_id) . ' BATCH_ID, FILO.CLX_EFFTDATE EFFTDATE, GLPF.FEE_GL_CODE GLACCOUNTCODE, GLPF.FEE2_GL_CODE GL01_CODE, JCBV.GL_TYPE, FILO.PRINCIPAL_BAL BALANCE_AMT, GLPF.SEQNUM CALC_AMT_01, GLPF.FEE_FORMULA PENALTY_CALC_TYPE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, null CHART_FIELD03, JCBV.CHART_FIELD04, JCBV.CURRENCY_CODE, 1 CUR_OPERATOR, 1 EXCHANGE_RT, 0 DEBIT_AMT, 0 CREDIT_AMT, FILO.IDCODE LOAN_CODE, FILO.PRODUCT_CODE, SUM(case JCBV.GL_TYPE WHEN ' . singleQuote('LI') . ' THEN -1*JCBV.BALANCE_AMT ELSE JCBV.BALANCE_AMT END) CALC_AMT_02, 0 CALC_AMT_03, 0 CALC_AMT_04, GLPF.DIVIDER_FACTOR DIVIDER_FACTOR, GLPF.SEQNUM, GLPF.BILLING, GLPF.ID FROM ' . $this->filoname . ' FILO, ' . $this->fiasname . ' FIAS, ' . $this->jcbvname . ' JCBV, ' . $this->pratname . ' PRAT, ' . $this->prltname . ' PRLT, '.$this->glpfname.' GLPF WHERE FILO.IDCODE = FIAS.LOAN_CODE AND FILO.START_DATE < ' . singleQuote($operation_date) . ' AND FIAS.IDCODE = JCBV.CHART_FIELD03 AND PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE AND PRAT.PRO_GL_CODE = JCBV.GLACCOUNTCODE AND FILO.CURRENCY_CODE = JCBV.CURRENCY_CODE AND PRLT.PRODUCT_CODE = FILO.PRODUCT_CODE AND GLPF.PRODUCT_CODE = PRAT.PRODUCT_CODE AND GLPF.PROD_STATUS = FILO.LOAN_STATUS AND GLPF.FEE_FORMULA = ' . singleQuote('P0005') . ' AND JCBV.BALANCE_AMT <> 0 AND GLPF.STATUS = ' . singleQuote('A') . ' AND PRLT.SIMPLE_INTEREST = 1 AND PRAT.PROD_STATUS = FILO.LOAN_STATUS AND FILO.CALC_INTEREST = 1 AND FILO.COMP_CODE = ' . singleQuote($comp_code) . ' ' . (($loan_code !== '') ? ' AND FILO.IDCODE =' . singleQuote($loan_code) : '') . ' AND FILO.CLX_EFFTDATE = (SELECT MAX(FILO2.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILO2 WHERE FILO2.IDCODE = FILO.IDCODE AND FILO2.CLX_EFFTDATE<=' . singleQuote($this->today) . ') GROUP BY FILO.COMP_CODE, FILO.CLX_EFFTDATE, GLPF.FEE_GL_CODE, GLPF.FEE2_GL_CODE, JCBV.GL_TYPE, FILO.PRINCIPAL_BAL, GLPF.SEQNUM, GLPF.FEE_FORMULA, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD04, JCBV.CURRENCY_CODE, FILO.IDCODE, FILO.PRODUCT_CODE, GLPF.DIVIDER_FACTOR, GLPF.SEQNUM, GLPF.BILLING, GLPF.ID';
        ClxCommon::$db->executeQuery($sql);

        /*
         * Comision por pago o desembolso financiada en este caso la comision se debenga al momento del vencimiento de la cuota
         * en este caso al vencer la couta se genera la cuenta por cobrar.
         *  AND GLPF.FEE3_GL_CODE IS NULL esto es porque si es financiada en desemblso contra pasivo no incluir en vencimiento de couta
         */
        $sql = 'INSERT INTO ' . $this->glt1name . '  (COMP_CODE, BATCH_ID, EFFTDATE, GLACCOUNTCODE, GL01_CODE, GL_TYPE, BALANCE_AMT, CALC_AMT_01, PENALTY_CALC_TYPE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, CURRENCY_CODE, CUR_OPERATOR, EXCHANGE_RT, DEBIT_AMT, CREDIT_AMT, LOAN_CODE, PRODUCT_CODE, CALC_AMT_02, CALC_AMT_03, CALC_AMT_04, DIVIDER_FACTOR, SEQNUM, PAY_TX_CODE, BILLING, GLPF_ID) SELECT CRED.COMP_CODE, ' . singleQuote($this->batch_id) . ' BATCH_ID, CRED.EFFTDATE, CRED.GLACCOUNTCODE, CRED.GL01_CODE, JCBV.GL_TYPE, CRED.FEE_AMT BALANCE_AMT, CRED.CALC_AMT_01, CRED.PENALTY_CALC_TYPE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, null CHART_FIELD03, JCBV.CHART_FIELD04, JCBV.CURRENCY_CODE, 1 CUR_OPERATOR, 1 EXCHANGE_RT, 0 DEBIT_AMT, 0 CREDIT_AMT, CRED.LOAN_CODE, CRED.PRODUCT_CODE, CRED.FEE_AMT CALC_AMT_02, 0 CALC_AMT_03, 0 CALC_AMT_04, CRED.DIVIDER_FACTOR, CRED.SEQNUM, CRED.PAY_TX_CODE, CRED.BILLING, CRED.GLPF_ID FROM (SELECT GLPF.ID GLPF_ID, FILO.COMP_CODE, FILO.IDCODE LOAN_CODE, GLPF.PROD_STATUS, FILO.CURRENCY_CODE, FILO.CLX_EFFTDATE EFFTDATE, GLPF.FEE_GL_CODE GLACCOUNTCODE, GLPF.FEE2_GL_CODE GL01_CODE, GLPF.SEQNUM CALC_AMT_01, GLPF.FEE_FORMULA PENALTY_CALC_TYPE, FILO.PRODUCT_CODE, GLPF.DIVIDER_FACTOR, GLPF.SEQNUM, FILO.PRINCIPAL_BAL, FIAS.IDCODE ASSET_CODE, PRAT.PRO_GL_CODE, GLPF.PAY_TX_CODE, GLPF.BILLING, case GLPF.SEQNUM WHEN 1 THEN FILS.FEE_01_AMT WHEN 2 THEN FILS.FEE_02_AMT WHEN 3 THEN FILS.FEE_03_AMT WHEN 4 THEN FILS.FEE_04_AMT WHEN 5 THEN FILS.FEE_05_AMT END FEE_AMT FROM ' . $this->filoname . ' FILO, ' . $this->glpfname . ' GLPF, ' . $this->glcpname . ' GLCP, ' . $this->fiasname . ' FIAS, ' . $this->pratname . ' PRAT, CRED_PAYMNT_SCHEDULES FILS WHERE GLCP.COMP_CODE = FILO.COMP_CODE AND GLPF.PRODUCT_CODE = FILO.PRODUCT_CODE AND GLPF.PROD_STATUS = FILO.LOAN_STATUS AND FIAS.LOAN_CODE = FILO.IDCODE AND PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE AND PRAT.PROD_STATUS = FILO.LOAN_STATUS AND FILO.PRINCIPAL_BAL <> 0 AND GLPF.STATUS = ' . singleQuote('A') . ' AND GLPF.FEE3_GL_CODE IS NULL AND GLPF.FEE_FORMULA IN (' . singleQuoteArray(array('P0007', 'P0008')) . ') AND FILO.START_DATE <' . singleQuote($operation_date) . ' AND GLPF.CPAY_FREQUENCY = ' . singleQuote('CHGR') . ' AND FILS.LOAN_CODE = FILO.IDCODE AND FILS.EFFTDATE = FILO.CLX_EFFTDATE AND FILS.PERIOD_END_DATE = ' . singleQuote($operation_date) . ' AND FILO.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM CRED_CREDITS X WHERE X.IDCODE = FILO.IDCODE AND X.CLX_EFFTDATE<=' . singleQuote($this->now) . ') AND GLCP.COMP_CODE = ' . singleQuote($comp_code) . ' ' . (($loan_code !== '') ? ' AND FILO.IDCODE =' . singleQuote($loan_code) : '') . ') CRED, ' . $this->jcbvname . ' JCBV WHERE JCBV.CHART_FIELD03 = CRED.ASSET_CODE AND JCBV.GLACCOUNTCODE = CRED.PRO_GL_CODE AND JCBV.CURRENCY_CODE = CRED.CURRENCY_CODE AND CRED.FEE_AMT<>0 AND JCBV.COMP_CODE = ' . singleQuote($comp_code) . ' ' . (($loan_code !== '') ? ' AND CRED.LOAN_CODE =' . singleQuote($loan_code) : '');
        ClxCommon::$db->executeQuery($sql);
        if (ClxCommon::$db->countRecords($this->glt1name, 'BATCH_ID = ' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
            return;
        }

        //Sum total for each GL loan balance in case of distribution
        $sql = 'SELECT LOAN_CODE, SUM(CALC_AMT_02) CALC_AMT_03, CALC_AMT_01 FROM ' . $this->glt1name . '  WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' GROUP BY LOAN_CODE, CALC_AMT_01';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $sql = 'UPDATE ' . $this->glt1name . ' SET CALC_AMT_03 = ' . $r['CALC_AMT_03'] . ' WHERE LOAN_CODE = ' . singleQuote($r['LOAN_CODE']) . ' AND CALC_AMT_01 = ' . singleQuote($r['CALC_AMT_01']) . ' AND BATCH_ID = ' . singleQuote($this->batch_id);
            ClxCommon::$db->executeQuery($sql);
        }
        //Setting interest Rate
        $sql = 'UPDATE ' . $this->glt1name . '  GLT1 SET GLT1.NO_DAYS = 1, GLT1.CALC_AMT_01 = IFNULL( (SELECT MAX(case GLT1.SEQNUM WHEN 1 THEN FILO.FEE_01_RATE WHEN 2 THEN FILO.FEE_02_RATE WHEN 3 THEN FILO.FEE_03_RATE WHEN 4 THEN FILO.FEE_04_RATE WHEN 5 THEN FILO.FEE_05_RATE END) FROM ' . $this->filoname . ' FILO WHERE FILO.IDCODE = GLT1.LOAN_CODE AND FILO.CLX_EFFTDATE = GLT1.EFFTDATE),0) WHERE GLT1.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GLT1.PENALTY_CALC_TYPE NOT IN (' . singleQuoteArray(array('P0007', 'P0008')) . ')';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt1name . '  GLT1 SET GLT1.NO_DAYS = 1, GLT1.CALC_AMT_01 = 100, GLT1.NO_DAYS = 1 WHERE GLT1.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GLT1.PENALTY_CALC_TYPE IN (' . singleQuoteArray(array('P0007', 'P0008')) . ')';
        ClxCommon::$db->executeQuery($sql);
        //Clear any not required
        $sql = 'DELETE FROM ' . $this->glt1name . ' WHERE CALC_AMT_01 = 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);

        //Setting the correct daycount
        $sql = 'CREATE TEMPORARY TABLE CRED_GLFP_DIVR_FACTOR_TMP SELECT GLT1.ID, FILS.LOAN_CODE, FILS.EFFTDATE, FILS.INSTALLMENT_NO, FILS.PERIOD_START_DATE, FILS.PERIOD_END_DATE, DATEDIFF(FILS.PERIOD_END_DATE, FILS.PERIOD_START_DATE) DCOUNT, (case GLT1.DIVIDER_FACTOR WHEN ' . singleQuote('30/360') . ' THEN 360 WHEN ' . singleQuote('30/365') . ' THEN 365 WHEN ' . singleQuote('AC/360') . ' THEN 360 WHEN ' . singleQuote('AC/365') . ' THEN 365 WHEN ' . singleQuote('AC/AC') . ' THEN 365 ELSE 1 END) DIVIDER_FACTOR FROM ' . $this->glt1name . ' GLT1, ' . $this->filsname . ' FILS WHERE GLT1.DIVIDER_FACTOR IN (' . singleQuoteArray(array('30/360', '30/365', 'AC/360', 'AC/365', 'AC/AC')) . ') AND FILS.LOAN_CODE = GLT1.LOAN_CODE AND FILS.EFFTDATE = GLT1.EFFTDATE AND FILS.INSTALLMENT_NO = (SELECT MAX(FILSX.INSTALLMENT_NO) FROM ' . $this->filsname . ' FILSX WHERE FILSX.LOAN_CODE = FILS.LOAN_CODE AND FILSX.EFFTDATE = FILS.EFFTDATE AND FILSX.PERIOD_END_DATE<=' . singleQuote($operation_date) . ')';
        ClxCommon::$db->executeQuery($sql);
        //Update divider Factor if apply
        $sql = 'UPDATE ' . $this->glt1name . ' GLT1, CRED_GLFP_DIVR_FACTOR_TMP TMP2 SET GLT1.NO_DAYS = TMP2.DCOUNT, GLT1.DIVIDER_FACTOR =TMP2.DIVIDER_FACTOR WHERE GLT1.ID = TMP2.ID AND GLT1.BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //Clear temporary table not needed anymore
        ClxCommon::$db->executeQuery('DROP TABLE CRED_GLFP_DIVR_FACTOR_TMP');
        //set fee amount based on left
        $sql = 'UPDATE ' . $this->glt1name . ' SET BALANCE_AMT = IFNULL(ROUND(BALANCE_AMT*(CALC_AMT_01/100)*(NO_DAYS/DIVIDER_FACTOR), 2),0) WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        //Set type AS/LI
        $sql = 'UPDATE ' . $this->glt1name . '  GLT1 SET GLT1.GL_TYPE = (SELECT MAX(GLAC.GL_TYPE) FROM ' . $this->glacname . ' GLAC WHERE GLAC.IDCODE = GLT1.GLACCOUNTCODE) WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);

        $sql = 'SELECT DISTINCT CURRENCY_CODE, ' . singleQuote($operation_date) . ' OPERATION_DATE FROM ' . $this->glt1name . '  WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $rate = $comp->comp_current_exchange($comp_code, $r['CURRENCY_CODE'], $r['OPERATION_DATE']);
            $sql = 'UPDATE ' . $this->glt1name . ' SET CUR_OPERATOR = ' . singleQuote($rate['CUR_OPERATOR']) . ', EXCHANGE_RT = ' . singleQuote($rate['EXCHANGE_RT']) . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND CURRENCY_CODE = ' . singleQuote($r['CURRENCY_CODE']);
            ClxCommon::$db->executeQuery($sql);
        } //end while

        //Setting credits and debits according to participantion
        $sql = 'UPDATE ' . $this->glt1name . ' SET CALC_AMT_04 = ROUND(BALANCE_AMT*(CALC_AMT_02/CALC_AMT_03), 2) WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);

        //Search diferences of distributions if any
        $sql = 'SELECT CHART_FIELD01, MAX(CHART_FIELD02) CHART_FIELD02, LOAN_CODE, PROD_STATUS, SUM(BALANCE_AMT-CALC_AMT_04) DIF FROM ' . $this->glt1name . '  WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' GROUP BY CHART_FIELD01, LOAN_CODE, PROD_STATUS, BALANCE_AMT HAVING SUM(BALANCE_AMT-CALC_AMT_04)<>0';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $sql = 'UPDATE ' . $this->glt1name . ' SET CALC_AMT_04 = CALC_AMT_04+' . $r['DIF'] . ' WHERE LOAN_CODE = ' . singleQuote($r['LOAN_CODE']) . ' AND CHART_FIELD01 = ' . singleQuote($r['CHART_FIELD01']) . ' AND CHART_FIELD02 = ' . singleQuote($r['CHART_FIELD02']) . ' AND PROD_STATUS = ' . singleQuote($r['PROD_STATUS']);
            ClxCommon::$db->executeQuery($sql);
        }
        //setting debits and credits for assets
        $sql = 'UPDATE ' . $this->glt1name . ' SET DEBIT_AMT = CALC_AMT_04 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE NOT IN (' . singleQuote('IN') . ',' . singleQuote('OR') . ',' . singleQuote('CG') . ') AND CALC_AMT_04>0';
        ClxCommon::$db->executeQuery($sql);

        $sql = 'UPDATE ' . $this->glt1name . ' SET CREDIT_AMT = ABS(CALC_AMT_04) WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE NOT IN (' . singleQuote('IN') . ',' . singleQuote('OR') . ',' . singleQuote('CG') . ') AND CALC_AMT_04<0';
        ClxCommon::$db->executeQuery($sql);

        $sql = 'UPDATE ' . $this->glt1name . ' SET CREDIT_AMT = CALC_AMT_04 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE IN (' . singleQuote('IN') . ',' . singleQuote('OR') . ',' . singleQuote('CG') . ') AND CALC_AMT_04>0';
        ClxCommon::$db->executeQuery($sql);

        $sql = 'UPDATE ' . $this->glt1name . ' SET DEBIT_AMT = ABS(CALC_AMT_04) WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE IN (' . singleQuote('IN') . ',' . singleQuote('OR') . ',' . singleQuote('CG') . ') AND CALC_AMT_04<0';
        ClxCommon::$db->executeQuery($sql);

        //Delete all rows from overdraft loans. or cero that will not earn int.
        $sql = 'DELETE FROM ' . $this->glt1name . ' WHERE DEBIT_AMT = 0 AND CREDIT_AMT = 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);

        //Currency conversion
        $sql = 'UPDATE ' . $this->glt1name . ' SET DEBIT_TRANS_AMT = DEBIT_AMT, DEBIT_AMT = ROUND(DEBIT_AMT*POW(EXCHANGE_RT, CUR_OPERATOR), 2) WHERE DEBIT_AMT <> 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);

        $sql = 'UPDATE ' . $this->glt1name . ' SET CREDIT_TRANS_AMT = CREDIT_AMT, CREDIT_AMT = ROUND(CREDIT_AMT*POW(EXCHANGE_RT, CUR_OPERATOR), 2) WHERE CREDIT_AMT <> 0 AND BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);

        $sql = 'UPDATE ' . $this->glt1name . ' SET EFFTDATE = ' . singleQuote($operation_date) . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);

        //setting accounting
        if (!class_exists('Jehd')){
            includeCodeLib('JEHD');
        }
        $jehd = new Jehd();
        $jehd->display = $this->display;
        //Reject any posible todays entry from this process thas has run today Si corre en dias anteriores se mueve al dia de operaciones por lo que no es posible reversar por fecha.
        /* 2. GENERAR ACTIVIDADES DE DEVENGO PARA PARTICIPANTES DE CONTRATO */
        //Build Header for this process, one pre currency
        $sql = 'SELECT DISTINCT EFFTDATE OPERATION_DATE, ' . singleQuote($comp_code) . ' COMP_CODE, ' . singleQuote($comprec['LGGROUP_CODE']) . ' LGGROUP_CODE FROM ' . $this->glt1name . '  WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            $gl_rec = $jehd->jehd_init_record();
            $gl_rec['IDNAME'] = $idname;
            $gl_rec['JE_SOURCE'] = $this->je_source;
            $gl_rec['LGGROUP_CODE'] = $result['LGGROUP_CODE'];
            $gl_rec['EFFTDATE'] = $result['OPERATION_DATE'];
            $gl_rec['COMP_CODE'] = $comp_code;
            $gl_rec['TRANS_CODE'] = null;
            $gl_rec['TRANSTBL_CODE'] = 'SYS_CRED-FEES';
            $gl_rec['REQ_CHANNEL'] = 'SYS';
            $gl_rec['BATCH_ID'] = $this->batch_id;
            $jehd->jehd_build($gl_rec);

            //Search any scale if apply and dump lines to journal
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec['IDCODE']) . ' JEHDR_CODE, X.GLACCOUNTCODE GLACCOUNTCODE, ' . singleQuote('CRED') . ' ITEM_CODE, X.CHART_FIELD01, X.CHART_FIELD02, X.CHART_FIELD03, X.CHART_FIELD04, X.LOAN_CODE ITEM_REF_NO, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR, SUM(X.DEBIT_AMT) DEBIT_AMT, SUM(X.CREDIT_AMT) CREDIT_AMT, SUM(X.DEBIT_TRANS_AMT) DEBIT_TRANS_AMT, SUM(X.CREDIT_TRANS_AMT) CREDIT_TRANS_AMT, 1 SEQNUM FROM ' . $this->glt1name . ' X WHERE X.EFFTDATE = '.singleQuote($result['OPERATION_DATE']).' AND X.BATCH_ID = ' . singleQuote($this->batch_id) . ' GROUP BY X.GLACCOUNTCODE, X.CHART_FIELD01, X.CHART_FIELD02, X.CHART_FIELD03, X.CHART_FIELD04, X.LOAN_CODE, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR';
            ClxCommon::$db->executeQuery($sql);
            //contraparte
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec['IDCODE']) . ' JEHDR_CODE, X.GL01_CODE GLACCOUNTCODE, ' . singleQuote('CRED') . ' ITEM_CODE, X.CHART_FIELD01, X.CHART_FIELD02, X.CHART_FIELD03, X.CHART_FIELD04, X.LOAN_CODE ITEM_REF_NO, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR, SUM(X.CREDIT_AMT) DEBIT_AMT, SUM(X.DEBIT_AMT) CREDIT_AMT, SUM(X.CREDIT_TRANS_AMT) DEBIT_TRANS_AMT, SUM(X.DEBIT_TRANS_AMT) CREDIT_TRANS_AMT, 2 SEQNUM FROM ' . $this->glt1name . ' X WHERE X.EFFTDATE = '.singleQuote($result['OPERATION_DATE']).' AND X.BATCH_ID = ' . singleQuote($this->batch_id) . ' GROUP BY X.GL01_CODE, X.CHART_FIELD01, X.CHART_FIELD02, X.CHART_FIELD03, X.CHART_FIELD04, X.LOAN_CODE, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR';
            ClxCommon::$db->executeQuery($sql);

            /* Limpiando subcuentas en caso de cuentas de ingreso */
            $sql = 'UPDATE ' . $this->jelnname . ' JELN SET JELN.CHART_FIELD03 = null WHERE JELN.JEHDR_CODE = ' . singleQuote($gl_rec['IDCODE']) . ' AND EXISTS(SELECT GLAC.IDCODE FROM ' . $this->glacname . ' GLAC WHERE GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLAC.GL_TYPE IN (' . singleQuote('IN') . ',' . singleQuote('EX') . ',' . singleQuote('EQ') . '))';
            ClxCommon::$db->executeQuery($sql);

            //Verificando conversion;
            $jehd->balance_exchange_rounding($gl_rec['IDCODE']);
            $jehd->jehd_approve_by_code($gl_rec['IDCODE']);
        }

        //Building payment transation for payment operations Procesando los que requiren transacciones de pago
        $this->build_pay_transaction();

        //Procesando los que requiren facturas de administradoras
        $this->build_adm_invoice();
    }

    /**
     * Builds payment transaction
     */
    private function build_pay_transaction() {
        //Se incluyen los casos donde billing sea 0
        //Borrando lineas temporales que no requieren generar transacciones de pago
        $sql = 'DELETE FROM	' . $this->glt1name . '  WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND PAY_TX_CODE IS NULL AND BILLING = 0'; //si no es billing solo retorna
        ClxCommon::$db->executeQuery($sql);
        //check if nothing to do or return
        if (ClxCommon::$db->countRecords($this->glt1name, 'BATCH_ID = ' . singleQuote($this->batch_id) . ' AND PAY_TX_CODE IS NOT null AND BILLING = 0') == CLX_NUM_ZERO) {
            return;
        }
        if (!class_exists('Fiat'))
            includeCodeLib('FIAT');
        $fiat = new Fiat ();
        if (!class_exists('Jehd'))
            includeCodeLib('JEHD');
        //Actualizando cuenta de banco para transaccion
        $sql = 'UPDATE ' . $this->glt1name . ' GLT1, ' . $this->filoname . ' FILO SET GLT1.BANK_ACCOUNT_NO = FILO.PAY_BANKACT_NO WHERE FILO.IDCODE = GLT1.LOAN_CODE AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILOX WHERE FILO.IDCODE = FILOX.IDCODE) AND GLT1.BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        // build transactions
        $sql = 'SELECT ' . singleQuote('AUTO') . ' IDCODE, FITB.IDNAME, GLT1.EFFTDATE, GLT1.COMP_CODE, GLT1.EFFTDATE AVAILABILITY_DATE, GLT1.EFFTDATE AVAILABILITY_DATE, GLT1.PAY_TX_CODE TRANSTBL_CODE, ' . singleQuote('PEND') . ' CLX_AUTH_STATUS, GLT1.CURRENCY_CODE, GLT1.EXCHANGE_RT, GLT1.CUR_OPERATOR, GLT1.LOAN_CODE ITEM_REF_NO, GLT1.COMP_CODE, GLT1.CHART_FIELD01, GLT1.CHART_FIELD02, GLT1.CHART_FIELD03, GLT1.CHART_FIELD04, GLT1.BANK_ACCOUNT_NO FIDU_BANKACT_CODE, ABS(DEBIT_TRANS_AMT-CREDIT_TRANS_AMT) TRANS_AMT, 0 RECONCILIED, ' . singleQuote('OT') . ' DISBURSEMENT_TYPE, GLT1.BANK_ACCOUNT_NO BANKAC_CODE, GLT1.EFFTDATE AVAILABILITY_DATE, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' BENEFICIARY_NAME, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' BRANCH_PRN, 0 RECORD_BLOCKING, GLT1.SEQNUM REFERENCE_NO, ' . singleQuote($this->batch_id) . ' BATCH_ID, ' . singleQuote($this->je_source) . ' JE_SOURCE, ' . singleQuote($this->username) . ' CREATEDBY, ' . singleQuote($this->now) . ' CDATE, ' . singleQuote($this->username) . ' MODIFIEDBY, ' . singleQuote($this->now) . ' MDATE FROM ' . $this->glt1name . ' GLT1, ' . $this->fitbname . ' FITB WHERE FITB.IDCODE = GLT1.PAY_TX_CODE AND GLT1.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GLT1.BILLING = 0';
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            $result ['EFFTDATE'] = adodb_next_day($result ['EFFTDATE']);
            $result ['REAL_DATE'] = $result ['EFFTDATE'];
            $result ['AVAILABILITY_DATE'] = $result ['EFFTDATE'];
            $fiat->fiat_buildVoid($result['COMP_CODE'], $result ['TRANSTBL_CODE'], $result ['CHART_FIELD01'], $result ['CHART_FIELD02'], $result ['TRANS_AMT'], $result);
        }
    }

    /**
     * Builds adm invoice
     */
    private function build_adm_invoice() {
        //check if nothing to do or return
        if (ClxCommon::$db->countRecords($this->glt1name, 'BATCH_ID = ' . singleQuote($this->batch_id) . ' AND PAY_TX_CODE IS NOT null AND BILLING = 1') == CLX_NUM_ZERO) {
            return;
        }
        $DBTB = &getTool('DBTB');
        $DBTB->buildTemporaryTable('INVT');
        //clear temporary table
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->invtname);
        //Read information to build Invoice
        $sql = 'INSERT INTO ' . $this->invtname . '  (IDNAME, VENDOR_CODE, INVOICEDATE, DUE_DATE, CURRENCY_CODE, INVOICE_AMT, EXT_REF_NO, INVO_STAT, COMP_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_CODE, GL_TYPE, JEHDR_CODE, GL01_CODE, GL02_CODE, TGT_ITEM_CODE, TGT_ITEM2_CODE, BATCH_ID, CDATE, CREATEDBY, FEE_01_RATE, GL03_CODE, FROM_CONTRACT_CODE, GLPF_ID) SELECT GLPF.IDNAME, GLPF.VENDOR_CODE, GLT1.EFFTDATE INVOICEDATE, GLT1.EFFTDATE DUE_DATE, GLT1.CURRENCY_CODE, GLT1.BALANCE_AMT INVOICE_AMT, GLT1.LOAN_CODE EXT_REF_NO, ' . "'01'" . ' INVO_STAT, GLPF.TGT_COMP_CODE COMP_CODE, GLPF.TGT_CHART_FIELD01 CHART_FIELD01, GLPF.TGT_CHART_FIELD02 CHART_FIELD02, null CHART_FIELD03, null CHART_FIELD04, GLPF.TGT_ITEM_CODE ITEM_CODE, null GL_TYPE, null JEHDR_CODE, null GL01_CODE, null GL02_CODE, GLPF.TGT_ITEM_CODE, GLPF.TGT_ITEM2_CODE, ' . singleQuote($this->batch_id) . ' BATCH_ID, ' . singleQuote($this->now) . ' CDATE, ' . singleQuote($this->username) . ' CREATEDBY, null FEE_01_RATE, null GL03_CODE, GLT1.CHART_FIELD01 FROM_CONTRACT_CODE, GLT1.GLPF_ID FROM ' . $this->glt1name . ' GLT1, '.$this->glpfname.' GLPF WHERE GLT1.GLPF_ID = GLPF.ID AND GLT1.BILLING = 1 AND GLPF.IS_TAXABLE = 0 AND GLT1.BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        /* Nota la factura debe sa */
        //Adding tax lines selecting
        //Usando gl type li para que sumen al generar la factura
        //Insertando linea menos el impuesto MONTO/1.PCT ex 1000/1.07 es el 70%
        $sql = 'INSERT INTO ' . $this->invtname . '  (IDNAME, VENDOR_CODE, INVOICEDATE, DUE_DATE, CURRENCY_CODE, INVOICE_AMT, EXT_REF_NO, INVO_STAT, COMP_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_CODE, GL_TYPE, JEHDR_CODE, GL01_CODE, GL02_CODE, TGT_ITEM_CODE, TGT_ITEM2_CODE, BATCH_ID, CDATE, CREATEDBY, FEE_01_RATE, GL03_CODE, FROM_CONTRACT_CODE, GLPF_ID) SELECT GLPF.IDNAME, GLPF.VENDOR_CODE, GLT1.EFFTDATE INVOICEDATE, GLT1.EFFTDATE DUE_DATE, GLT1.CURRENCY_CODE, ROUND((GLT1.BALANCE_AMT/( 1 +(JEIT.FLAT_RATE/100))), 2) INVOICE_AMT, GLT1.LOAN_CODE EXT_REF_NO, ' . "'01'" . ' INVO_STAT, GLPF.TGT_COMP_CODE COMP_CODE, GLPF.TGT_CHART_FIELD01 CHART_FIELD01, GLPF.TGT_CHART_FIELD02 CHART_FIELD02, null CHART_FIELD03, null CHART_FIELD04, GLPF.TGT_ITEM_CODE ITEM_CODE, null GL_TYPE, null JEHDR_CODE, null GL01_CODE, null GL02_CODE, GLPF.TGT_ITEM_CODE, GLPF.TGT_ITEM2_CODE, ' . singleQuote($this->batch_id) . ' BATCH_ID, ' . singleQuote($this->now) . ' CDATE, ' . singleQuote($this->username) . ' CREATEDBY, null FEE_01_RATE, null GL03_CODE, GLT1.CHART_FIELD01 FROM_CONTRACT_CODE, GLT1.GLPF_ID FROM ' . $this->glt1name . ' GLT1, ' . $this->glpfname . ' GLPF, ' . $this->jeitname . ' JEIT WHERE GLT1.GLPF_ID = GLPF.ID AND GLT1.BILLING = 1 AND GLPF.IS_TAXABLE = 1 AND GLT1.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GLPF.TGT_TAX_ITEM_CODE = JEIT.IDCODE AND JEIT.FLAT_RATE <> 0 AND JEIT.CLX_EFFTDATE<=(SELECT MAX(JEITX.CLX_EFFTDATE) FROM ' . $this->jeitname . ' JEITX WHERE JEITX.IDCODE = JEIT.IDCODE AND JEITX.CLX_EFFTDATE <= GLT1.EFFTDATE)';
        ClxCommon::$db->executeQuery($sql);
        /* nota este es el porcentage sin el monto de tax: ROUND((GLT1.BALANCE_AMT/( 1 +(JEIT.FLAT_RATE/100))), 2) es el monto impuesto */
        /* luego el tax se calcula sobre el monto sin tax para la //contraparte: SALDO-MONTO TAX O SALDO-ROUND((GLT1.BALANCE_AMT/( 1 +(JEIT.FLAT_RATE/100))), 2) */
        $sql = 'INSERT INTO ' . $this->invtname . '  (IDNAME, VENDOR_CODE, INVOICEDATE, DUE_DATE, CURRENCY_CODE, INVOICE_AMT, EXT_REF_NO, INVO_STAT, COMP_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_CODE, GL_TYPE, JEHDR_CODE, GL01_CODE, GL02_CODE, TGT_ITEM_CODE, TGT_ITEM2_CODE, BATCH_ID, CDATE, CREATEDBY, FEE_01_RATE, GL03_CODE, FROM_CONTRACT_CODE, GLPF_ID) SELECT GLPF.IDNAME, GLPF.VENDOR_CODE, GLT1.EFFTDATE INVOICEDATE, GLT1.EFFTDATE DUE_DATE, GLT1.CURRENCY_CODE, /*GLT1.BALANCE_AMT INVOICE_AMT,*/ /*ROUND((GLT1.BALANCE_AMT*(JEIT.FLAT_RATE/100)), 2) INVOICE_AMT,*/ /*ROUND((GLT1.BALANCE_AMT/( 1 +(JEIT.FLAT_RATE/100))), 2) INVOICE_AMT,*/ (GLT1.BALANCE_AMT-ROUND((GLT1.BALANCE_AMT/( 1 +(JEIT.FLAT_RATE/100))), 2)) INVOICE_AMT, GLT1.LOAN_CODE EXT_REF_NO, ' . "'01'" . ' INVO_STAT, GLPF.TGT_COMP_CODE COMP_CODE, GLPF.TGT_CHART_FIELD01 CHART_FIELD01, GLPF.TGT_CHART_FIELD02 CHART_FIELD02, null CHART_FIELD03, null CHART_FIELD04, GLPF.TGT_ITEM_CODE ITEM_CODE, null GL_TYPE, null JEHDR_CODE, null GL01_CODE, null GL02_CODE, GLPF.TGT_ITEM_CODE, GLPF.TGT_TAX_ITEM_CODE TGT_ITEM2_CODE, ' . singleQuote($this->batch_id) . ' BATCH_ID, ' . singleQuote($this->now) . ' CDATE, ' . singleQuote($this->username) . ' CREATEDBY, null FEE_01_RATE, null GL03_CODE, GLT1.CHART_FIELD01 FROM_CONTRACT_CODE, GLT1.GLPF_ID FROM ' . $this->glt1name . ' GLT1, ' . $this->glpfname . ' GLPF, ' . $this->jeitname . ' JEIT WHERE GLT1.GLPF_ID = GLPF.ID AND GLT1.BILLING = 1 AND GLPF.IS_TAXABLE = 1 AND GLT1.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GLPF.TGT_TAX_ITEM_CODE = JEIT.IDCODE AND JEIT.FLAT_RATE <> 0 AND JEIT.CLX_EFFTDATE<=(SELECT MAX(JEITX.CLX_EFFTDATE) FROM ' . $this->jeitname . ' JEITX WHERE JEITX.IDCODE = JEIT.IDCODE AND JEITX.CLX_EFFTDATE <= GLT1.EFFTDATE)';
        ClxCommon::$db->executeQuery($sql);
        //Updating tax pct
        $sql = 'UPDATE ' . $this->invtname . ' INVT, ' . $this->jeitname . ' JEIT SET INVT.INVOICE_AMT = ROUND((INVT.INVOICE_AMT*(JEIT.FLAT_RATE/100)), 2) WHERE INVT.TGT_ITEM2_CODE = JEIT.IDCODE AND INVT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND JEIT.FLAT_RATE <> 0 AND JEIT.CLX_EFFTDATE<=(SELECT MAX(JEITX.CLX_EFFTDATE) FROM ' . $this->jeitname . ' JEITX WHERE JEITX.IDCODE = JEIT.IDCODE AND JEITX.CLX_EFFTDATE <= INVT.INVOICEDATE)';
        //Return if no record
        if (ClxCommon::$db->countRecords($this->invtname, 'BATCH_ID=' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
            return;
        }
        //Update glaccounts
        $sql = 'UPDATE ' . $this->invtname . ' INVT, ' . $this->jeitname . ' JEIT SET INVT.GL01_CODE = JEIT.GLACCOUNTCODE WHERE INVT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND JEIT.IDCODE = INVT.TGT_ITEM_CODE AND JEIT.CLX_EFFTDATE=(SELECT MAX(JEITX.CLX_EFFTDATE) FROM ' . $this->jeitname . ' JEITX WHERE JEITX.IDCODE = JEIT.IDCODE AND JEITX.CLX_EFFTDATE <= INVT.INVOICEDATE)';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->invtname . ' INVT, ' . $this->jeitname . ' JEIT SET INVT.GL02_CODE = JEIT.GLACCOUNTCODE WHERE INVT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND JEIT.IDCODE = INVT.TGT_ITEM2_CODE AND JEIT.CLX_EFFTDATE=(SELECT MAX(JEITX.CLX_EFFTDATE) FROM ' . $this->jeitname . ' JEITX WHERE JEITX.IDCODE = JEIT.IDCODE AND JEITX.CLX_EFFTDATE <= INVT.INVOICEDATE)';
        ClxCommon::$db->executeQuery($sql);
        //Setting gltype
        $sql = 'UPDATE ' . $this->invtname . ' INVT, ' . $this->glacname . ' GLAC SET INVT.GL_TYPE = GLAC.GL_TYPE WHERE INVT.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GLAC.IDCODE = INVT.GL01_CODE';
        ClxCommon::$db->executeQuery($sql);
        //Build Invoice
        if (!class_exists('Apin'))
            includeCodeLib('APIN');
        $apin = new Apin();
        $apin->buildInvoceFromInvt($this->batch_id, 'LI', 'PEND', true);
        unset($apin);
        if (!class_exists('Invo'))
            includeCodeLib('INVO');
        $invo = new Invo();
        $invo->buildInvoceFromInvt($this->batch_id, 'AS', 'PEND', true);
        unset($invo);
    }

    /**
     * Returns true if loan is of type asset otherwise false
     *
     * @param string $loan_code
     * @return boolean
     */
    function is_asset($loan_code) {
        $sql = 'SELECT COUNT(GLAC.GL_TYPE) QTY FROM ' . $this->filoname . ' FILO, ' . $this->pratname . ' PRAT, ' . $this->glcpname . ' GLCP, ' . $this->glacname . ' GLAC WHERE GLCP.COMP_CODE = FILO.COMP_CODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE AND PRAT.PRO_GL_CODE = GLAC.IDCODE AND GLAC.GL_TYPE = ' . singleQuote('AS') . ' AND FILO.IDCODE = ' . singleQuote($loan_code) . ' AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILOX, ' . $this->glcpname . ' GLCPX WHERE FILOX.COMP_CODE = GLCPX.COMP_CODE AND FILOX.CLX_EFFTDATE<=NOW() AND FILOX.IDCODE = ' . singleQuote($loan_code) . ')'; /* GLCPX.OPERATION_DATE */
        return (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) ? true : false;
    }

    /**
     * Returns true if loan interest account is asset otherwise false
     *
     * @param string $loan_code
     * @return boolean
     */
    function is_interest_asset($loan_code) {
        $sql = 'SELECT COUNT(GLAC.GL_TYPE) QTY FROM ' . $this->filoname . ' FILO, ' . $this->pratname . ' PRAT, ' . $this->glcpname . ' GLCP, ' . $this->glacname . ' GLAC WHERE GLCP.COMP_CODE = FILO.COMP_CODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE AND PRAT.AR_GL_CODE = GLAC.IDCODE AND GLAC.GL_TYPE = ' . singleQuote('AS') . ' AND FILO.IDCODE = ' . singleQuote($loan_code) . ' AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILOX, ' . $this->glcpname . ' GLCPX WHERE FILOX.COMP_CODE = GLCPX.COMP_CODE AND FILOX.CLX_EFFTDATE<=NOW() AND FILOX.IDCODE = ' . singleQuote($loan_code) . ')'; /* GLCPX.OPERATION_DATE */
        return (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) ? true : false;
    }

    /**
     * Returns loan current parameters
     *
     * @param string $loan_code
     * @param string $loan_status
     * @return array
     */
    function get_parameters($loan_code, $loan_status = 'VIG') {
        $sql = 'SELECT PRAT.*, FILO.CURRENCY_CODE, GLCP.OPERATION_DATE, FILO.FEE_01_FIN_PER, FILO.FEE_02_FIN_PER, FILO.FEE_03_FIN_PER, FILO.FEE_04_FIN_PER, FILO.FEE_05_FIN_PER FROM ' . $this->filoname . ' FILO, ' . $this->pratname . ' PRAT, ' . $this->glcpname . ' GLCP, ' . $this->glacname . ' GLAC WHERE GLCP.COMP_CODE = FILO.COMP_CODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE AND PRAT.PRO_GL_CODE = GLAC.IDCODE AND PRAT.PROD_STATUS = FILO.LOAN_STATUS AND FILO.IDCODE = ' . singleQuote($loan_code) . ' AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILOX WHERE FILOX.IDCODE = FILO.IDCODE AND FILOX.CLX_EFFTDATE<=NOW())';
        return ClxCommon::$db->getOneRecord($sql);
    }

    /**
     * Returns loan current parameters
     *
     * @param string $loan_code
     * @return array
     */
    function has_parameters($loan_code) {
        $sql = 'SELECT COUNT(PRAT.ID) FROM ' . $this->filoname . ' FILO, ' . $this->pratname . ' PRAT, ' . $this->glcpname . ' GLCP, ' . $this->glacname . ' GLAC WHERE GLCP.COMP_CODE = FILO.COMP_CODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE AND PRAT.PRO_GL_CODE = GLAC.IDCODE AND PRAT.PROD_STATUS = FILO.LOAN_STATUS AND FILO.IDCODE = ' . singleQuote($loan_code) . ' AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILOX WHERE FILOX.IDCODE = FILO.IDCODE AND FILOX.CLX_EFFTDATE<=NOW())';
        return (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) ? true : false;
    }

    /**
     * Returns loan parameters
     *
     * @param string $fias_code
     * @return array
     */
    function get_parameters_by_fias($fias_code) {
        $loan_code = ClxCommon::$db->getField($this->fiasname, 'LOAN_CODE', 'IDCODE = ' . singleQuote($fias_code));
        return $this->get_parameters($loan_code);
    }

    /**
     * Return credit parameters by loan code
     *
     * @param string $loan_code
     * @return array
     */
    function get_cred_parameters($loan_code) {
        switch (kDatabaseType) {
            case 'oci':
                $sql = 'SELECT DISTINCT PRLT.ID,PRLT.PRODUCT_CODE,TO_CHAR(PRLT.MEMO),PRLT.CHART_FIELD01,PRLT.CHART_FIELD02,PRLT.PAY_SEQNO_PRO,PRLT.PAY_SEQNO_AR,PRLT.PAY_SEQNO_FEE,PRLT.PAY_SEQNO_LATEF,PRLT.PROD_STATUS_01,PRLT.DAYS_STATUS_01,PRLT.OPER_STATUS_01,PRLT.PROD_STATUS_02,PRLT.DAYS_STATUS_02,PRLT.OPER_STATUS_02,PRLT.PROD_STATUS_03,PRLT.DAYS_STATUS_03,PRLT.OPER_STATUS_03,PRLT.PROD_STATUS_04,PRLT.DAYS_STATUS_04,PRLT.OPER_STATUS_04,PRLT.MAX_INTEREST_PCT,PRLT.MIN_INTEREST_PCT,PRLT.MAX_GRACE_PERIODS,PRLT.MIN_GRACE_PERIODS,PRLT.MAX_LOAN_PERIODS,PRLT.MIN_LOAN_PERIODS,PRLT.REQ_LINE_CREDIT,PRLT.AMRT_LINE_CREDIT,PRLT.REQ_BENEFICIARY,PRLT.CREATEDBY,PRLT.CDATE,PRLT.MODIFIEDBY,PRLT.MDATE FROM CRED_CREDITS FILO, CRED_PROD_PRMTR_TBL PRLT WHERE PRLT.PRODUCT_CODE = FILO.PRODUCT_CODE AND TO_CHAR(FILO.IDCODE) = ' . singleQuote('100142') . ' AND FILO.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM CRED_CREDITS X WHERE FILO.IDCODE = X.IDCODE AND FILO.CLX_EFFTDATE<=SYSDATE)';
                break;
            default:
                $sql = 'SELECT DISTINCT PRLT.* FROM ' . $this->filoname . ' FILO, ' . $this->prltname . ' PRLT WHERE PRLT.PRODUCT_CODE = FILO.PRODUCT_CODE AND FILO.IDCODE = ' . singleQuote($loan_code) . ' AND FILO.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM ' . $this->filoname . ' X WHERE FILO.IDCODE = X.IDCODE AND FILO.CLX_EFFTDATE<=NOW())';
        }
        return ClxCommon::$db->getOneRecord($sql);
    }

    /**
     * Set credit amount
     *
     * @param string $fias_code
     * @return array
     */
    function get_cred_parameters_by_fias($fias_code) {
        $loan_code = ClxCommon::$db->getField($this->fiasname, 'LOAN_CODE', 'IDCODE = ' . singleQuote($fias_code));
        return $this->get_cred_parameters($loan_code);
    }

    /**
     * Return the last efftdate date to current operation date of filo
     *
     * @param string $loan_code
     * @return string
     */
    function get_current_efftdate($loan_code) {
        $sql = 'SELECT MAX(FILO.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILO, ' . $this->glcpname . ' GLCP WHERE GLCP.COMP_CODE = FILO.COMP_CODE AND FILO.IDCODE = ' . singleQuote($loan_code) . ' AND FILO.CLX_EFFTDATE<=' . singleQuote($this->today);
        return ClxCommon::$db->getOne($sql); /* GLCP.OPERATION_DATE */
    }

    /**
     * Return loan code from fias
     *
     * @param string $fias_code
     * @return srting
     */
    function get_loan_code_by_fias($fias_code) {
        $sql = 'SELECT FIAS.LOAN_CODE FROM ' . $this->fiasname . ' FIAS, ' . $this->filoname . ' FILO WHERE FIAS.LOAN_CODE = FILO.IDCODE AND FIAS.IDCODE = ' . singleQuote($fias_code);
        return ClxCommon::$db->getOne($sql);
    }

    /**
     * Returns product code for credit
     *
     * @param string $loan_code
     * @return string
     */
    function get_cred_product_code($loan_code) {
        $sql = 'SELECT PRODUCT_CODE FROM ' . $this->filoname . '  WHERE IDCODE = ' . singleQuote($loan_code) . ' LIMIT 1';
        return ClxCommon::$db->getOne($sql);
    }

    /**
     * Returns credit record
     * @param $loan_code
     * @param $efftdate
     * @return array
     */
    function get_credit_record($loan_code, $efftdate = '') {
        if ($efftdate === '')
            $efftdate = $this->today;
        $sql = 'SELECT FILO.* FROM ' . $this->filoname . ' FILO WHERE FILO.IDCODE = ' . singleQuote($loan_code) . ' AND FILO.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) FROM ' . $this->filoname . ' X WHERE X.IDCODE = FILO.IDCODE AND X.CLX_EFFTDATE<=NOW())';
        return ClxCommon::$db->getOneRecord($sql);
    }

    /**
     * Initialice all temporary tables
     *
     * @param string $batch_id
     */
    private function initTemporaryTables($batch_id) {
        //Load temporary table - Req on mysql
        $DBTB = &getTool('DBTB');
        $DBTB->buildTemporaryTable('GLT1'); //Clear tmp
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($batch_id));
    }

    /**
     * Creates a copy of loan for current date
     * @param string $loan_efftdatee
     */
    private function build_credit_current_efftdate($loan_code) {
        //1. Select credit record.
        $sql = 'SELECT FILO.* FROM ' . $this->filoname . ' FILO WHERE FILO.IDCODE = ' . singleQuote($loan_code) . ' AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILOX WHERE FILOX.IDCODE = FILO.IDCODE AND FILOX.CLX_EFFTDATE<=' . singleQuote($this->today) . ')';
        $filorec = ClxCommon::$db->getOneRecord($sql);
        if (empty($filorec))
            return;
        if ($this->today <> $filorec['CLX_EFFTDATE']) {
            $filorec['CLX_EFFTDATE'] = $this->today;
            unset($filorec['ID']);
            ClxCommon::$db->loadDbRecord($this->filoname, $filorec, false, 'IDCODE = ' . singleQuote($filorec['IDCODE']) . ' AND CLX_EFFTDATE = ' . singleQuote($filorec['CLX_EFFTDATE']));
            $this->build_amortization($loan_code, $this->today, CLX_NUM_ZERO, CLX_NUM_ZERO);
        }
    }

    /**
     * Reprogram schedule.
     * Creates a new entru on credit record and defines new amortization schedile
     * @param string $loan_code
     * @param string $efftdate
     */
    function recalculate_schedule($loan_code, $restructure = CLX_NUM_ZERO) {
        $this->build_credit_current_efftdate($loan_code);
    }

    /**
     * Builds amortization tables
     *
     * @param array $record
     */
    function build_amortization($loan_code, $efftdate = '', $restructure = CLX_NUM_ZERO, $rate_change = CLX_NUM_ZERO, $partial_dis = '') {
        //Calificacion
        //$restructure = CLX_INIT_ZERO ; //comentado para pruebas
        if ($efftdate === '') {
            $sql = 'SELECT MAX(CLX_EFFTDATE) FROM ' . $this->filoname . '  WHERE IDCODE = ' . singleQuote($loan_code);
            $efftdate = ClxCommon::$db->getOne($sql);
        }
        if (UserRequest::$request['ac'] <> 'DUPLICATE_EFFTDATE') {
            //Solo se colocara en duplicaate efftdate
            $restructure = CLX_INIT_ZERO;
        }

        switch($partial_dis){
            case '1':
                ClxCommon::$db->executeQuery('CALL CRED_SET_FILS_DYNAMIC(' . singleQuote($loan_code) . ', ' . singleQuote($efftdate) . ',' . singleQuote($this->username) . ', '.singleQuote($restructure).', '.singleQuote($rate_change).')');
            break;
            default:
                ClxCommon::$db->executeQuery('CALL CRED_SET_FILS(' . singleQuote($loan_code) . ', ' . singleQuote($efftdate) . ',' . singleQuote($this->username) . ', '.singleQuote($restructure).', '.singleQuote($rate_change).')');
            break;
        }

        
    }

    /**
     * Returns operation parameters by loan code
     *
     * @param string $loan_code
     * @return array
     */
    function operation_parameters($loan_code = '') {
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        if ($loan_code !== '') {
            $comp_code = ClxCommon::$db->getField($this->filoname, 'COMP_CODE', 'IDCODE = ' . singleQuote($loan_code));
        } else {
            $comp_code = '';
        }
        $comp = new Comp();
        return $comp->comp_operation_parameters($comp_code);
    }

    function reset() {
        //Recalculation ledgers
        if (!class_exists('Leba'))
            includeCodeLib('LEBA');
        $a = new Leba();
        $idlist = toString(getIdlist());
        $sql = 'SELECT DISTINCT FILO.IDCODE, FIAS.IDCODE ASSET_CODE, FILO.COMP_CODE FROM ' . $this->filoname . ' FILO LEFT JOIN ' . $this->fiasname . ' FIAS ON FIAS.LOAN_CODE = FILO.IDCODE WHERE FILO.ID IN (' . $idlist . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            //Delete headers
            $sql = 'DELETE FROM ' . $this->jehdname . '  WHERE TRANS_CODE IN (SELECT DISTINCT IDCODE FROM ' . $this->fiatname . '  WHERE CHART_FIELD03 = ' . singleQuote($r['ASSET_CODE']) . ') AND COMP_CODE = ' . singleQuote($r['COMP_CODE']);
            ClxCommon::$db->executeQuery($sql);
            //Delete headers
            $sql = 'DELETE FROM ' . $this->jehdname . '  WHERE IDCODE IN (SELECT DISTINCT JEHDR_CODE FROM ' . $this->jelnname . '  WHERE CHART_FIELD03 = ' . singleQuote($r['ASSET_CODE']) . ') AND COMP_CODE = ' . singleQuote($r['COMP_CODE']);
            ClxCommon::$db->executeQuery($sql);
            //Delete lines
            $sql = 'DELETE JELN.* FROM ' . $this->jelnname . ' JELN WHERE NOT EXISTS (SELECT JEHD.IDCODE FROM ' . $this->jehdname . ' JEHD WHERE JEHD.IDCODE = JELN.JEHDR_CODE)';
            ClxCommon::$db->executeQuery($sql);
            ClxCommon::$db->executeQuery('DELETE FROM ' . $this->lebaname . ' WHERE CHART_FIELD03 =' . singleQuote($r['ASSET_CODE']));
            ClxCommon::$db->executeQuery('UPDATE ' . $this->filoname . ' SET CLX_AUTH_STATUS = ' . singleQuote('PEND') . ', LOAN_STATUS=' . singleQuote('PRE') . ',PRINCIPAL_BAL = 0, INTEARNED_AMT = 0, INTPAID_AMT = 0, PREV_INTEARNED_AMT = 0, LATE_FEE_BALANCE = 0, PREV_LATE_FEE_AMT = 0, COMMISSIONS_AMT = 0, PREV_COMM_AMT = 0, LAST_PAY_DATE = null, PAID_AMT = 0, RESERVE_AMT = 0, INSURANCE_AMT = 0, DAILY_INTEREST = 0, INTEARNED_ACC = 0, LAST_INT_DATE = null, DUE_PRO_AMT = 0, DUE_AR_AMT = 0, LAST_DUE_DATE = null, FEE_01_AMT = 0, FEE_02_AMT = 0, FEE_03_AMT = 0, FEE_04_AMT = 0, FEE_05_AMT = 0 WHERE IDCODE =' . singleQuote($r['IDCODE']));
            //Delete headers
            $sql = 'DELETE FROM ' . $this->fiatname . ' WHERE CHART_FIELD03 = ' . singleQuote($r['ASSET_CODE']) . ' AND COMP_CODE = ' . singleQuote($r['COMP_CODE']);
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE ' . $this->filsname . '  SET PPAL_PAID_AMT = 0, INTPAID_AMT = 0, PAYMENT_DATE = null, PAID_AMT = 0, ADVANCE_PAID_AMT = 0, CAPITALIZATION_AMT = 0 WHERE LOAN_CODE = ' . singleQuote($r['IDCODE']);
            ClxCommon::$db->executeQuery($sql);
            $a->leba_rebuild($r['COMP_CODE']);
        } //end while
    }

    //PRCI
    /**
     * Calculate late fees
     *
     */
    function late_cred_provision_cron($comp_code, $queue = false) {
        if (empty($comp_code))
            return;
        $this->display = true;
        $this->late_cred_provision($comp_code, $queue);
    }

    /**
     * Variable interest adjustment process
     *
     * @param atring $comp_code
     * @param string $loan_code
     */
    private function late_cred_provision($comp_code, $queue = false) {
        if (empty($comp_code))
            return;
        $je_source = 'PRCI';
        //test for process
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        $comp = new Comp();
        if (!$comp->ruco_status($comp_code, $je_source)) {
            echoLog('Process: $this->je_source Inactive for company $comp_code ');
            return;
        }
        $comprec = $comp->comp_operation_parameters($comp_code);
        $operation_date = $comprec['OPERATION_DATE'];
        //Build temporary table
        $DBTB = &getTool('DBTB');
        $DBTB->buildTemporaryTable('FTMP');
        //Creating accounting
        if (!class_exists('Jehd'))
            includeCodeLib('JEHD');
        $jehd = new Jehd ();
        $DBLT = &getTool('DBLT');
        $idname = $DBLT->getListItem('SOTY', $je_source, CLX_NUM_TWO);
        //Reverse balances for provision accounts
        $this->late_cred_provision_reverse($comp_code, $comprec, $jehd, $DBLT, $queue);
        //Delete temporary table
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->ftmpname . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
        //Load currency exchange excluding portfolios
        //Provisionando por producto PROVISION_PROD = 1
        $sql = 'INSERT INTO ' . $this->ftmpname . '  (BATCH_ID, COMP_CODE, EFFTDATE, GLACCOUNTCODE, GL01_CODE, GL02_CODE, CURRENCY_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, SCALE_TYPE, FEE_TYPE, FISCAL_PERIOD, ITEM_REF_NO, EXCHANGE_RT, CUR_OPERATOR, CALC_AMT_01) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, X.COMP_CODE, X.OPERATION_DATE EFFTDATE, X.PRO_GL_CODE GLACCOUNTCODE, X.RES2_GL_CODE GL01_CODE, X.RES_GL_CODE GL02_CODE, X.CURRENCY_CODE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, X.SCGR_CODE SCALE_TYPE, X.SCTB_CODE FEE_TYPE, JCBV.GL_TYPE FISCAL_PERIOD, X.LOAN_CODE ITEM_REF_NO, 1 EXCHANGE_RT, 1 CUR_OPERATOR, SUM(JCBV.BALANCE_AMT) CALC_AMT_01 FROM GL_CUR_BALANCE_VW JCBV, (SELECT DISTINCT FILO.COMP_CODE, FILO.IDCODE LOAN_CODE, FILO.CLX_EFFTDATE, GLCP.OPERATION_DATE, FILO.CURRENCY_CODE, PRRT.CHART_FIELD03, (case PRLT.RATINGTYPE_RULE WHEN ' . "'01'" . ' THEN (SELECT MIN(RX.SCGR_CODE) FROM CRRM_PRODUCT_RATINGS RX WHERE RX.CHART_FIELD03 = PRRT.CHART_FIELD03 AND RX.CLX_EFFTDATE = PRRT.CLX_EFFTDATE) WHEN ' . singleQuote('02') . ' THEN (SELECT MAX(RX.SCGR_CODE) FROM CRRM_PRODUCT_RATINGS RX WHERE RX.CHART_FIELD03 = PRRT.CHART_FIELD03 AND RX.CLX_EFFTDATE = PRRT.CLX_EFFTDATE) ELSE PRRT.SCGR_CODE END) SCGR_CODE, PRLT.SCTB_CODE, PRLT.RATINGTYPE_RULE, FILO.PRINCIPAL_BAL, PRAT.RES_GL_CODE, PRAT.RES2_GL_CODE, PRAT.PRO_GL_CODE, FILO.LOAN_STATUS FROM GL_PARAMETERS_TBL GLCP, BASE_SCALE_GRADES SCGR, CRRM_PRODUCT_RATINGS PRRT, FIDU_ITEMS FIAS, CRED_CREDITS FILO, GL_PROD_PRMTR_TBL PRAT, CRED_PROD_PRMTR_TBL PRLT, GL_CODES_TBL GLAC, GL_CODES_TBL GLAC2 WHERE SCGR.IDCODE = PRRT.SCGR_CODE AND GLCP.COMP_CODE = FILO.COMP_CODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLAC2.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLAC.IDCODE = PRAT.RES_GL_CODE AND GLAC2.IDCODE = PRAT.RES2_GL_CODE AND PRRT.CHART_FIELD03 = FIAS.IDCODE AND PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE AND PRAT.PROD_STATUS = FILO.LOAN_STATUS AND PRLT.PRODUCT_CODE = FILO.PRODUCT_CODE AND PRLT.RATINGTYPE_RULE IN (PRRT.RATING_TYPE, ' . "'01'" . ',' . "'02'" . ') AND FILO.IDCODE = FIAS.LOAN_CODE AND FILO.CLX_EFFTDATE <= (SELECT MAX(FILOX.CLX_EFFTDATE) FROM CRED_CREDITS FILOX WHERE FILOX.IDCODE = FILO.IDCODE AND FILOX.CLX_EFFTDATE = FILO.CLX_EFFTDATE) AND PRRT.CLX_EFFTDATE = (SELECT MAX(PRRTX.CLX_EFFTDATE) FROM CRRM_PRODUCT_RATINGS PRRTX WHERE PRRTX.CHART_FIELD03 = PRRT.CHART_FIELD03 AND PRRTX.CLX_EFFTDATE <= GLCP.OPERATION_DATE AND PRRTX.RATING_TYPE = PRRT.RATING_TYPE) AND ( (PRLT.RATINGTYPE_RULE = ' . "'01'" . ' AND PRRT.SCGR_CODE = (SELECT MIN(RX2.SCGR_CODE) FROM CRRM_PRODUCT_RATINGS RX2 WHERE RX2.CHART_FIELD03 = PRRT.CHART_FIELD03 AND RX2.CLX_EFFTDATE <= PRRT.CLX_EFFTDATE)) OR (PRLT.RATINGTYPE_RULE = ' . singleQuote('02') . ' AND PRRT.SCGR_CODE = (SELECT MAX(RX2.SCGR_CODE) FROM CRRM_PRODUCT_RATINGS RX2 WHERE RX2.CHART_FIELD03 = PRRT.CHART_FIELD03 AND RX2.CLX_EFFTDATE <= PRRT.CLX_EFFTDATE)) OR PRLT.RATINGTYPE_RULE = PRRT.RATING_TYPE )  AND FILO.PRINCIPAL_BAL>0 AND GLCP.PROVISION_PROD = 1 AND FILO.COMP_CODE = ' . singleQuote($comp_code) . ' AND PRLT.SCTB_CODE IS NOT null) X WHERE JCBV.COMP_CODE = ' . singleQuote($comp_code) . ' AND JCBV.GLACCOUNTCODE = X.PRO_GL_CODE AND JCBV.CHART_FIELD03 = X.CHART_FIELD03 GROUP BY X.COMP_CODE, X.OPERATION_DATE, X.PRO_GL_CODE, X.RES_GL_CODE, X.RES2_GL_CODE, X.CURRENCY_CODE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, X.SCGR_CODE, X.SCTB_CODE, X.LOAN_CODE, JCBV.GL_TYPE HAVING CALC_AMT_01<>0';
        ClxCommon::$db->executeQuery($sql);
        //notas sobre provision:
        //Si la provision es subjetiva dehe hacerse por la ma
        //Provisionando en caso de ser por cliente PROVISION_PROD = 0
        $sql = 'INSERT INTO ' . $this->ftmpname . '  (BATCH_ID, COMP_CODE, EFFTDATE, GLACCOUNTCODE, GL01_CODE, GL02_CODE, CURRENCY_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, SCALE_TYPE, FEE_TYPE, FISCAL_PERIOD, ITEM_REF_NO, EXCHANGE_RT, CUR_OPERATOR, CALC_AMT_01, CALC_AMT_02, IDNAME) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, X.COMP_CODE, X.OPERATION_DATE EFFTDATE, X.PRO_GL_CODE GLACCOUNTCODE, X.RES2_GL_CODE GL01_CODE, X.RES_GL_CODE GL02_CODE, X.CURRENCY_CODE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, X.SCGR_CODE SCALE_TYPE, X.SCTB_CODE FEE_TYPE, JCBV.GL_TYPE FISCAL_PERIOD, X.LOAN_CODE ITEM_REF_NO, 1 EXCHANGE_RT, 1 CUR_OPERATOR, SUM(JCBV.BALANCE_AMT) CALC_AMT_01, 0 CALC_AMT_02, X.DEBTOR_CODE IDNAME FROM GL_CUR_BALANCE_VW JCBV, (SELECT FILO.COMP_CODE, FILO.IDCODE LOAN_CODE, FILO.CLX_EFFTDATE, GLCP.OPERATION_DATE, FILO.CURRENCY_CODE, FIAS.IDCODE CHART_FIELD03, /*GRADO DEL DEUDOR*/ FILO.DEBTOR_CODE, T.SCGR_CODE, PRLT.SCTB_CODE, PRLT.RATINGTYPE_RULE, FILO.PRINCIPAL_BAL, PRAT.RES_GL_CODE, PRAT.RES2_GL_CODE, PRAT.PRO_GL_CODE, FILO.LOAN_STATUS FROM GL_PARAMETERS_TBL GLCP, BASE_SCALES_TBL SCTB, FIDU_ITEMS FIAS, CRED_CREDITS FILO, GL_PROD_PRMTR_TBL PRAT, CRED_PROD_PRMTR_TBL PRLT, GL_CODES_TBL GLAC, GL_CODES_TBL GLAC2, /*VISTA DE CALIFICACION*/ (SELECT ACRT.ACCOUNTCODE, ACRT.RATING_TYPE, ACRT.SCGR_CODE FROM CRRM_ACCO_RATINGS ACRT WHERE ACRT.CLX_EFFTDATE = (SELECT MAX(ACRTX.CLX_EFFTDATE) FROM CRRM_ACCO_RATINGS ACRTX WHERE ACRTX.ACCOUNTCODE = ACRT.ACCOUNTCODE AND ACRTX.RATING_TYPE = ACRT.RATING_TYPE) UNION SELECT ACRT.ACCOUNTCODE,' . singleQuote('02') . ' RATING_TYPE, MIN(ACRT.SCGR_CODE) SCGR_CODE FROM CRRM_ACCO_RATINGS ACRT WHERE ACRT.CLX_EFFTDATE = (SELECT MAX(ACRTX.CLX_EFFTDATE) FROM CRRM_ACCO_RATINGS ACRTX WHERE ACRTX.ACCOUNTCODE = ACRT.ACCOUNTCODE AND ACRTX.RATING_TYPE = ACRT.RATING_TYPE) GROUP BY ACRT.ACCOUNTCODE UNION SELECT ACRT.ACCOUNTCODE,' . "'01'" . ' RATING_TYPE, MAX(ACRT.SCGR_CODE) SCGR_CODE FROM CRRM_ACCO_RATINGS ACRT WHERE ACRT.CLX_EFFTDATE = (SELECT MAX(ACRTX.CLX_EFFTDATE) FROM CRRM_ACCO_RATINGS ACRTX WHERE ACRTX.ACCOUNTCODE = ACRT.ACCOUNTCODE AND ACRTX.RATING_TYPE = ACRT.RATING_TYPE) GROUP BY ACRT.ACCOUNTCODE) T WHERE GLCP.COMP_CODE = FILO.COMP_CODE AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLAC2.GLGROUP_CODE = GLCP.GLGROUP_CODE AND GLAC.IDCODE = PRAT.RES_GL_CODE AND GLAC2.IDCODE = PRAT.RES2_GL_CODE AND PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE AND PRAT.PROD_STATUS = FILO.LOAN_STATUS AND PRLT.PRODUCT_CODE = FILO.PRODUCT_CODE AND PRLT.RATINGTYPE_RULE IN (' . singleQuoteArray(array('OBJ', 'SUB', '01', '02')) . ') AND FILO.DEBTOR_CODE = T.ACCOUNTCODE AND PRLT.RATINGTYPE_RULE = T.RATING_TYPE AND SCTB.STATUS = ' . singleQuote('A') . ' AND SCTB.IDCODE = PRLT.SCTB_CODE AND SCTB.CLX_EFFTDATE = (SELECT MAX(SCTBX.CLX_EFFTDATE) FROM BASE_SCALES_TBL SCTBX WHERE SCTBX.IDCODE = SCTB.IDCODE AND SCTBX.CLX_EFFTDATE<=GLCP.OPERATION_DATE) AND FILO.IDCODE = FIAS.LOAN_CODE AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) FROM CRED_CREDITS FILOX WHERE FILOX.IDCODE = FILO.IDCODE AND FILOX.CLX_EFFTDATE <= NOW()) AND FILO.PRINCIPAL_BAL>0 AND GLCP.PROVISION_PROD = 0 AND FILO.COMP_CODE = ' . singleQuote($comp_code) . ' AND PRLT.SCTB_CODE IS NOT null) X WHERE JCBV.COMP_CODE = ' . singleQuote($comp_code) . ' AND JCBV.GLACCOUNTCODE = X.PRO_GL_CODE AND JCBV.CHART_FIELD03 = X.CHART_FIELD03 GROUP BY X.COMP_CODE, X.OPERATION_DATE, X.PRO_GL_CODE, X.RES_GL_CODE, X.RES2_GL_CODE, X.CURRENCY_CODE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, X.SCGR_CODE, X.SCTB_CODE, X.LOAN_CODE, JCBV.GL_TYPE HAVING CALC_AMT_01<>0';
        ClxCommon::$db->executeQuery($sql);
        if (ClxCommon::$db->countRecords($this->ftmpname, 'BATCH_ID = ' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
            return;
        }
        //SET CURRENCY EXCHANGE
        $sql = 'UPDATE ' . $this->ftmpname . ' FTMP, (SELECT CURR.BASE_CURRENCY, CURR.EXCHANGE_RT, CURR.CUR_OPERATOR, CURR.CLX_EFFTDATE FROM  ' . $this->currname . ' CURR, ' . $this->compname . ' COMP WHERE COMP.IDCODE = ' . singleQuote($comp_code) . ' AND CURR.FOREIGN_CURRENCY = COMP.CURRENCY_CODE AND CURR.CLX_EFFTDATE = (SELECT MAX(CURRX.CLX_EFFTDATE) FROM  ' . $this->currname . ' CURRX WHERE CURRX.IDCODE = CURR.IDCODE AND CURRX.CLX_EFFTDATE <= ' . singleQuote($operation_date) . ') ) CURR SET FTMP.EXCHANGE_RT = CURR.EXCHANGE_RT, FTMP.CUR_OPERATOR = CURR.CUR_OPERATOR WHERE FTMP.CURRENCY_CODE = CURR.BASE_CURRENCY AND FTMP.COMP_CODE = ' . singleQuote($comp_code) . ' AND FTMP.BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->ftmpname . ' FTMP, BASE_SCALE_VW SCVW SET FTMP.CALC_AMT_02 = SCVW.RATE_PCT WHERE FTMP.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND SCVW.SCGR_CODE = FTMP.SCALE_TYPE AND SCVW.SCTB_CODE = FTMP.FEE_TYPE AND SCVW.CLX_EFFTDATE = (SELECT MAX(SCVWX.CLX_EFFTDATE) FROM BASE_SCALE_VW SCVWX WHERE SCVWX.SCGR_CODE = SCVW.SCGR_CODE AND SCVWX.SCTB_CODE = SCVW.SCTB_CODE AND SCVW.CLX_EFFTDATE<=' . singleQuote($operation_date) . ')';
        ClxCommon::$db->executeQuery($sql);
        //calculate operation amu
        $sql = 'UPDATE ' . $this->ftmpname . ' FTMP SET DEBIT_AMT = ROUND(FTMP.CALC_AMT_01*(FTMP.CALC_AMT_02/100), 2) WHERE FTMP.BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'DELETE FROM ' . $this->ftmpname . '  WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND DEBIT_AMT = 0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->ftmpname . '  SET CREDIT_AMT = -1*DEBIT_AMT, DEBIT_AMT = 0 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND DEBIT_AMT < 0';
        ClxCommon::$db->executeQuery($sql);
        // Build JEHD
        $sql = 'SELECT DISTINCT ' . singleQuote($idname) . ' IDNAME, FTMP.COMP_CODE, ' . singleQuote($operation_date) . ' EFFTDATE, ' . singleQuote($je_source) . ' JE_SOURCE, 0 CLOSING_ENTRY, 0 REVERSED, FTMP.BATCH_ID, ' . singleQuote($this->username) . ' CREATEDBY, ' . singleQuote($this->username) . ' MODIFIEDBY, ' . singleQuote($this->now) . ' CDATE, ' . singleQuote($this->now) . ' MDATE FROM ' . $this->ftmpname . ' FTMP WHERE FTMP.BATCH_ID = ' . singleQuote($this->batch_id);
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            // Generar encabezado para portafolio
            $jehd->jehd_build($r);
            $jehdr_code = $r ['IDCODE'];
            // Generando lineas
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, SEQNUM, GLACCOUNTCODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_CODE, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, DEBIT_AMT, CREDIT_AMT, RECONCILIED) SELECT ' . singleQuote($jehdr_code) . ' JEHDR_CODE, 1 SEQNUM, FTMP.GL01_CODE GLACCOUNTCODE, FTMP.CHART_FIELD01, FTMP.CHART_FIELD02, FTMP.CHART_FIELD03, FTMP.CHART_FIELD04, ' . singleQuote('SYS_' . $je_source) . ' ITEM_CODE, FTMP.ITEM_REF_NO, FTMP.CURRENCY_CODE, FTMP.EXCHANGE_RT, FTMP.CUR_OPERATOR, FTMP.DEBIT_AMT DEBIT_TRANS_AMT, FTMP.CREDIT_AMT CREDIT_TRANS_AMT, ROUND(FTMP.DEBIT_AMT*POWER(FTMP.EXCHANGE_RT, FTMP.CUR_OPERATOR), 2) DEBIT_AMT, ROUND(FTMP.CREDIT_AMT*POWER(FTMP.EXCHANGE_RT, FTMP.CUR_OPERATOR), 2) CREDIT_AMT, 0 RECONCILIED FROM ' . $this->ftmpname . ' FTMP WHERE FTMP.BATCH_ID = ' . singleQuote($this->batch_id) . ' ORDER BY FTMP.CHART_FIELD01 ASC';
            ClxCommon::$db->executeQuery($sql);
            // Contrapartida
            $sql = 'INSERT INTO ' . $this->jelnname . '  (JEHDR_CODE, SEQNUM, GLACCOUNTCODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_CODE, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, DEBIT_AMT, CREDIT_AMT, RECONCILIED) SELECT ' . singleQuote($jehdr_code) . ' JEHDR_CODE, 2 SEQNUM, FTMP.GL02_CODE GLACCOUNTCODE, FTMP.CHART_FIELD01, FTMP.CHART_FIELD02, FTMP.CHART_FIELD03, FTMP.CHART_FIELD04, ' . singleQuote('SYS_' . $je_source) . ' ITEM_CODE, FTMP.ITEM_REF_NO, FTMP.CURRENCY_CODE, FTMP.EXCHANGE_RT, FTMP.CUR_OPERATOR, FTMP.CREDIT_AMT DEBIT_TRANS_AMT, FTMP.DEBIT_AMT CREDIT_TRANS_AMT, ROUND(FTMP.CREDIT_AMT*POWER(FTMP.EXCHANGE_RT, FTMP.CUR_OPERATOR), 2) DEBIT_AMT, ROUND(FTMP.DEBIT_AMT*POWER(FTMP.EXCHANGE_RT, FTMP.CUR_OPERATOR), 2) CREDIT_AMT, 0 RECONCILIED FROM ' . $this->ftmpname . ' FTMP WHERE FTMP.BATCH_ID = ' . singleQuote($this->batch_id) . ' ORDER BY FTMP.CHART_FIELD01 ASC';
            ClxCommon::$db->executeQuery($sql);
            //Eliminando subcuentas en caso de no ser activos o pasivos
            $sql = 'UPDATE ' . $this->jelnname . ' JELN SET JELN.CHART_FIELD03 = null WHERE JELN.JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND NOT EXISTS (SELECT GLAC.IDCODE FROM ' . $this->glacname . ' GLAC WHERE GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLAC.GLGROUP_CODE = ' . singleQuote($comprec['GLGROUP_CODE']) . ' AND GLAC.GL_TYPE IN (' . singleQuote('AS') . ',' . singleQuote('LI') . ',' . singleQuote('OR') . ',' . singleQuote('CG') . '))';
            ClxCommon::$db->executeQuery($sql);
            // Cambiar estatus de asientos generados por el proceso
            if ($queue === true) {
                $jehd->jehd_approve_queue_by_code($jehdr_code);
            } else {
                $jehd->jehd_approve_by_code($jehdr_code);
            }
            if ($this->display === true) {
                echoLog('<br>Approving jehd: ' . $jehdr_code . '-' . $je_source);
            }
        } // end while
    }

    /**
     * Reverso de provisiones
     * @param type $comp_code
     * @param type $comprec
     * @param type $jehd
     * @param type $DBLT
     * @param type $queue
     * @return void
     */
    private function late_cred_provision_reverse(&$comp_code, &$comprec, &$jehd, &$DBLT, &$queue) {
        $je_source = 'PRCIR';
        $idname = $DBLT->getListItem('SOTY', $je_source, CLX_NUM_TWO);
        //Delete temporary table
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->ftmpname . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
        $operation_date = $comprec['OPERATION_DATE'];
        //Load reversal
        $sql = 'INSERT INTO ' . $this->ftmpname . '  (BATCH_ID, COMP_CODE, GLACCOUNTCODE, GL01_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_TRANS_AMT, DEBIT_AMT) SELECT ' . singleQuote($this->batch_id) . ' BATCH_ID, JCBV.COMP_CODE, JCBV.GLACCOUNTCODE, (SELECT MAX(PRAT2.RES3_GL_CODE) FROM GL_PROD_PRMTR_TBL PRAT2 WHERE PRAT2.PRODUCT_CODE = CRED.PRODUCT_CODE) GL01_CODE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, JCBV.CURRENCY_CODE, ROUND(SUM(JCBV.BASE_BAL_AMT)/SUM(JCBV.BALANCE_AMT), 5) EXCHANGE_RT, 1 CUR_OPERATOR, -1*SUM(JCBV.BALANCE_AMT) DEBIT_TRANS_AMT, -1*SUM(JCBV.BASE_BAL_AMT) DEBIT_AMT FROM GL_CUR_BALANCE_VW JCBV, GL_PARAMETERS_TBL GLCP, (SELECT FILO.IDCODE, FIAS.IDCODE CHART_FIELD03, FILO.PRODUCT_CODE FROM CRED_CREDITS FILO, FIDU_ITEMS FIAS WHERE FILO.COMP_CODE = ' . singleQuote($comp_code) . ' AND FILO.IDCODE = FIAS.LOAN_CODE AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) FROM CRED_CREDITS FILOX WHERE FILOX.IDCODE = FILO.IDCODE)) CRED WHERE JCBV.COMP_CODE = ' . singleQuote($comp_code) . ' AND JCBV.CHART_FIELD03 = CRED.CHART_FIELD03 AND GLCP.COMP_CODE = JCBV.COMP_CODE AND EXISTS (SELECT PRAT.ID FROM  GL_PROD_PRMTR_TBL PRAT WHERE GLCP.GLGROUP_CODE = PRAT.GLGROUP_CODE AND JCBV.GLACCOUNTCODE = PRAT.RES_GL_CODE ) GROUP BY JCBV.COMP_CODE, JCBV.GLACCOUNTCODE, JCBV.CHART_FIELD01, JCBV.CHART_FIELD02, JCBV.CHART_FIELD03, JCBV.CHART_FIELD04, JCBV.CURRENCY_CODE HAVING SUM(JCBV.BALANCE_AMT) <> 0 ';
        ClxCommon::$db->executeQuery($sql);
        if (ClxCommon::$db->countRecords($this->ftmpname, 'BATCH_ID = ' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
            return;
        }
        //SET CURRENCY EXCHANGE
        //CURRX.CLX_EFFTDATE <= '. singleQuote($operation_date).'
        $sql = 'UPDATE ' . $this->ftmpname . ' FTMP, (SELECT CURR.BASE_CURRENCY, CURR.EXCHANGE_RT, CURR.CUR_OPERATOR, CURR.CLX_EFFTDATE FROM ' . $this->currname . ' CURR, ' . $this->compname . ' COMP WHERE COMP.IDCODE = ' . singleQuote($comp_code) . ' AND CURR.FOREIGN_CURRENCY = COMP.CURRENCY_CODE AND CURR.CLX_EFFTDATE = (SELECT MAX(CURRX.CLX_EFFTDATE) FROM  ' . $this->currname . ' CURRX WHERE CURRX.IDCODE = CURR.IDCODE AND CURRX.CLX_EFFTDATE <= ' . singleQuote($operation_date) . ') ) CURR SET FTMP.EXCHANGE_RT = CURR.EXCHANGE_RT, FTMP.CUR_OPERATOR = CURR.CUR_OPERATOR WHERE FTMP.CURRENCY_CODE = CURR.BASE_CURRENCY AND FTMP.COMP_CODE = ' . singleQuote($comp_code) . ' AND FTMP.BATCH_ID = ' . singleQuote($this->batch_id);
        $sql = 'UPDATE ' . $this->ftmpname . '  SET CREDIT_AMT = -1*DEBIT_AMT, DEBIT_AMT = 0, CREDIT_TRANS_AMT = -1*DEBIT_TRANS_AMT, DEBIT_TRANS_AMT = 0 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND DEBIT_AMT < 0';
        ClxCommon::$db->executeQuery($sql);
        // Build JEHD
        $sql = 'SELECT DISTINCT ' . singleQuote($idname) . ' IDNAME, FTMP.COMP_CODE, ' . singleQuote($operation_date) . ' EFFTDATE, ' . singleQuote($je_source) . ' JE_SOURCE, 0 CLOSING_ENTRY, 0 REVERSED, FTMP.BATCH_ID, ' . singleQuote($this->username) . ' CREATEDBY, ' . singleQuote($this->username) . ' MODIFIEDBY, ' . singleQuote($this->now) . ' CDATE, ' . singleQuote($this->now) . ' MDATE FROM ' . $this->ftmpname . ' FTMP WHERE FTMP.BATCH_ID = ' . singleQuote($this->batch_id);
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            // Generar encabezado para portafolio
            $jehd->jehd_build($r);
            $jehdr_code = $r ['IDCODE'];
            // Generando lineas
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, SEQNUM, GLACCOUNTCODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_CODE, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, DEBIT_AMT, CREDIT_AMT, RECONCILIED) SELECT ' . singleQuote($jehdr_code) . ' JEHDR_CODE, 1 SEQNUM, FTMP.GLACCOUNTCODE, FTMP.CHART_FIELD01, FTMP.CHART_FIELD02, FTMP.CHART_FIELD03, FTMP.CHART_FIELD04, ' . singleQuote('SYS_' . $je_source) . ' ITEM_CODE, FTMP.ITEM_REF_NO, FTMP.CURRENCY_CODE, FTMP.EXCHANGE_RT, FTMP.CUR_OPERATOR, /*FTMP.DEBIT_AMT DEBIT_TRANS_AMT, FTMP.CREDIT_AMT CREDIT_TRANS_AMT, ROUND(FTMP.DEBIT_AMT*POWER(FTMP.EXCHANGE_RT, FTMP.CUR_OPERATOR), 2) DEBIT_AMT, ROUND(FTMP.CREDIT_AMT*POWER(FTMP.EXCHANGE_RT, FTMP.CUR_OPERATOR), 2) CREDIT_AMT,*/ FTMP.DEBIT_TRANS_AMT, FTMP.CREDIT_TRANS_AMT, FTMP.DEBIT_AMT, FTMP.CREDIT_AMT, 0 RECONCILIED FROM ' . $this->ftmpname . ' FTMP WHERE FTMP.BATCH_ID = ' . singleQuote($this->batch_id) . ' ORDER BY FTMP.CHART_FIELD01 ASC';
            ClxCommon::$db->executeQuery($sql);
            $sql = 'INSERT INTO ' . $this->jelnname . '   (JEHDR_CODE, SEQNUM, GLACCOUNTCODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_CODE, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, DEBIT_AMT, CREDIT_AMT, RECONCILIED) SELECT ' . singleQuote($jehdr_code) . ' JEHDR_CODE, 2 SEQNUM, FTMP.GL01_CODE, FTMP.CHART_FIELD01, FTMP.CHART_FIELD02, FTMP.CHART_FIELD03, FTMP.CHART_FIELD04, ' . singleQuote('SYS_' . $je_source) . ' ITEM_CODE, FTMP.ITEM_REF_NO, FTMP.CURRENCY_CODE, FTMP.EXCHANGE_RT, FTMP.CUR_OPERATOR, /*FTMP.CREDIT_AMT DEBIT_TRANS_AMT, FTMP.DEBIT_AMT CREDIT_TRANS_AMT, ROUND(FTMP.CREDIT_AMT*POWER(FTMP.EXCHANGE_RT, FTMP.CUR_OPERATOR), 2) DEBIT_AMT, ROUND(FTMP.DEBIT_AMT*POWER(FTMP.EXCHANGE_RT, FTMP.CUR_OPERATOR), 2) CREDIT_AMT,*/ FTMP.CREDIT_TRANS_AMT DEBIT_TRANS_AMT, FTMP.DEBIT_TRANS_AMT CREDIT_TRANS_AMT, FTMP.CREDIT_AMT DEBIT_AMT, FTMP.DEBIT_AMT CREDIT_AMT, 0 RECONCILIED FROM ' . $this->ftmpname . ' FTMP WHERE FTMP.BATCH_ID = ' . singleQuote($this->batch_id) . ' ORDER BY FTMP.CHART_FIELD01 ASC';
            ClxCommon::$db->executeQuery($sql);
            //Eliminando subcuentas en caso de no ser activos o pasivos
            $sql = 'UPDATE ' . $this->jelnname . ' JELN SET JELN.CHART_FIELD03 = null WHERE JELN.JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND NOT EXISTS (SELECT GLAC.IDCODE FROM ' . $this->glacname . ' GLAC WHERE GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLAC.GLGROUP_CODE = ' . singleQuote($comprec['GLGROUP_CODE']) . ' AND GLAC.GL_TYPE IN (' . singleQuote('AS') . ',' . singleQuote('LI') . ',' . singleQuote('OR') . ',' . singleQuote('CG') . '))';
            ClxCommon::$db->executeQuery($sql);
            // Cambiar estatus de asientos generados por el proceso
            if ($queue === true) {
                $jehd->jehd_approve_queue_by_code($jehdr_code);
            } else {
                $jehd->jehd_approve_by_code($jehdr_code);
            }
            if ($this->display === true) {
                echoLog('<br>Approving Reversal jehd: ' . $jehdr_code . '-' . $je_source);
            }
        } // end while
        //Delete temporary table
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->ftmpname . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id));
    }

    /**
     * Created product calification for product
     * @param string $comp_code
     * @param string [$loan_code Perf]
     */
    function set_cred_calification_by_comp($comp_code, $loan_code = '') {
        $this->set_cred_calification($comp_code, $loan_code);
    }

    /**
     * Creando registros de calificacion
     */
    private function set_cred_calification($comp_code, $loan_code = '') {
        if (empty($comp_code))
            return;
        $sql = 'DROP TABLE IF EXISTS CRM_PROD_RATINGS_TMP';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'CREATE TEMPORARY TABLE CRM_PROD_RATINGS_TMP SELECT F.CHART_FIELD03, F.OPERATION_DATE CLX_EFFTDATE, ' . singleQuote('OBJ') . ' RATING_TYPE, SCVW.SCGR_CODE, NOW() CDATE, ' . singleQuote($_SESSION['user_record']['username']) . ' CREATEDBY, NOW() MDATE, ' . singleQuote($_SESSION['user_record']['username']) . ' MODIFIEDBY FROM BASE_SCALE_VW SCVW, (SELECT FIAS.IDCODE CHART_FIELD03, PRLT.SCTB_CODE, GLCP.OPERATION_DATE, CRED_PASS_DUE_DAYS(FILO.IDCODE) DAYS_LATE FROM FIDU_ITEMS FIAS, CRED_CREDITS FILO, CRED_PROD_PRMTR_TBL PRLT, GL_PARAMETERS_TBL GLCP WHERE FILO.COMP_CODE = GLCP.COMP_CODE AND PRLT.PRODUCT_CODE = FILO.PRODUCT_CODE AND FILO.IDCODE = FIAS.LOAN_CODE AND PRLT.SCTB_CODE IS NOT null AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) FROM CRED_CREDITS FILOX WHERE FILOX.IDCODE = FILO.IDCODE AND FILOX.CLX_EFFTDATE <= ' . singleQuote($this->today) . ') AND FILO.PRINCIPAL_BAL <> 0 AND GLCP.COMP_CODE = ' . singleQuote($comp_code) . ' ' . ((!empty($loan_code)) ? ' AND FILO.IDCODE = ' . singleQuote($loan_code) : '') . ' ) F WHERE SCVW.SCTB_CODE = F.SCTB_CODE AND F.DAYS_LATE BETWEEN SCVW.FROM_AMT AND SCVW.TO_AMT AND SCVW.CLX_EFFTDATE = (SELECT MAX(SCVWX.CLX_EFFTDATE) FROM BASE_SCALE_VW SCVWX WHERE SCVWX.SCTB_CODE = SCVW.SCTB_CODE AND SCVWX.CLX_EFFTDATE <= F.OPERATION_DATE)';
        ClxCommon::$db->executeQuery($sql);
        //Eliminar casos donde la ultima calificacion es la misma que la nueva
        $sql = 'DELETE X.* FROM CRM_PROD_RATINGS_TMP X, CRRM_PRODUCT_RATINGS PRRT WHERE X.CHART_FIELD03 = PRRT.CHART_FIELD03 AND X.RATING_TYPE = PRRT.RATING_TYPE AND X.SCGR_CODE = PRRT.SCGR_CODE AND PRRT.CLX_EFFTDATE = (SELECT MAX(PRRTX.CLX_EFFTDATE) FROM CRRM_PRODUCT_RATINGS PRRTX WHERE PRRTX.CHART_FIELD03 = PRRT.CHART_FIELD03 AND PRRTX.RATING_TYPE = PRRTX.RATING_TYPE)';
        ClxCommon::$db->executeQuery($sql);
        //Actualizando las calificaciones que saliran. OBJ
        $sql = 'UPDATE CRRM_PRODUCT_RATINGS PRRT, CRM_PROD_RATINGS_TMP X SET PRRT.SCGR_CODE = X.SCGR_CODE, PRRT.MDATE = X.MDATE, PRRT.MODIFIEDBY = X.MODIFIEDBY WHERE PRRT.CHART_FIELD03 = X.CHART_FIELD03 AND PRRT.CLX_EFFTDATE = X.CLX_EFFTDATE AND PRRT.RATING_TYPE = X.RATING_TYPE ';
        ClxCommon::$db->executeQuery($sql);
        /* Creando nuevas entradas que no existan */
        $sql = 'INSERT INTO CRRM_PRODUCT_RATINGS (CHART_FIELD03, CLX_EFFTDATE, RATING_TYPE, SCGR_CODE, CDATE, CREATEDBY, MDATE, MODIFIEDBY) SELECT X.CHART_FIELD03, X.CLX_EFFTDATE, X.RATING_TYPE, MAX(X.SCGR_CODE) SCGR_CODE, X.CDATE, X.CREATEDBY, X.MDATE, X.MODIFIEDBY FROM CRM_PROD_RATINGS_TMP X LEFT JOIN CRRM_PRODUCT_RATINGS PRRT ON PRRT.CHART_FIELD03 = X.CHART_FIELD03 AND PRRT.CLX_EFFTDATE = X.CLX_EFFTDATE AND PRRT.RATING_TYPE = X.RATING_TYPE WHERE PRRT.ID IS NULL GROUP BY X.CHART_FIELD03, X.CLX_EFFTDATE, X.RATING_TYPE, X.CDATE, X.CREATEDBY, X.MDATE, X.MODIFIEDBY ';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'DROP TABLE IF EXISTS CRM_PROD_RATINGS_TMP';
        ClxCommon::$db->executeQuery($sql);
        $this->set_acco_calification($comp_code, $loan_code);
    }

    /**
     * Creando calificacion para el cliente
     * @param type $comp_code
     */
    private function set_acco_calification($comp_code, $loan_code = '') {
        $sql = 'DROP TABLE IF EXISTS CRM_PROD_RATINGS_TMP';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'CREATE TEMPORARY TABLE CRM_PROD_RATINGS_TMP SELECT FILO.DEBTOR_CODE ACCOUNTCODE, MAX(PRRT.CLX_EFFTDATE) CLX_EFFTDATE, ' . singleQuote('OBJ') . ' RATING_TYPE, MAX(PRRT.SCGR_CODE) SCGR_CODE, NOW() CDATE, ' . singleQuote($_SESSION['user_record']['username']) . ' CREATEDBY, NOW() MDATE, ' . singleQuote($_SESSION['user_record']['username']) . ' MODIFIEDBY FROM CRRM_PRODUCT_RATINGS PRRT, FIDU_ITEMS FIAS, CRED_CREDITS FILO, GL_PARAMETERS_TBL GLCP WHERE FIAS.LOAN_CODE = FILO.IDCODE AND GLCP.COMP_CODE = FILO.COMP_CODE AND FILO.PRINCIPAL_BAL > 0 AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) FROM CRED_CREDITS FILOX WHERE FILO.IDCODE = FILOX.IDCODE AND FILO.CLX_EFFTDATE<=CURDATE()) AND PRRT.CHART_FIELD03 = FIAS.IDCODE AND PRRT.CLX_EFFTDATE = (SELECT MAX(PRRTX.CLX_EFFTDATE) FROM CRRM_PRODUCT_RATINGS PRRTX WHERE PRRT.CHART_FIELD03 = PRRTX.CHART_FIELD03 AND PRRTX.CLX_EFFTDATE <= GLCP.OPERATION_DATE) AND PRRT.RATING_TYPE = (SELECT MAX(PRRTX2.RATING_TYPE) FROM CRRM_PRODUCT_RATINGS PRRTX2 WHERE PRRT.CHART_FIELD03 = PRRTX2.CHART_FIELD03 AND PRRTX2.CLX_EFFTDATE= PRRT.CLX_EFFTDATE) AND FILO.COMP_CODE = ' . singleQuote($comp_code) . ' ' . ((!empty($loan_code)) ? ' AND FILO.IDCODE = ' . singleQuote($loan_code) : '') . ' GROUP BY FILO.DEBTOR_CODE';
        ClxCommon::$db->executeQuery($sql);
        //Eliminar casos donde la ultima calificacion es la misma que la nueva
        $sql = 'DELETE X.* FROM CRM_PROD_RATINGS_TMP X, CRRM_ACCO_RATINGS ACRT WHERE X.ACCOUNTCODE = ACRT.ACCOUNTCODE AND X.RATING_TYPE = ACRT.RATING_TYPE AND X.SCGR_CODE = ACRT.SCGR_CODE AND ACRT.CLX_EFFTDATE = (SELECT MAX(ACRTX.CLX_EFFTDATE) FROM CRRM_ACCO_RATINGS ACRTX WHERE ACRTX.ACCOUNTCODE = ACRT.ACCOUNTCODE AND ACRTX.RATING_TYPE = ACRT.RATING_TYPE)';
        ClxCommon::$db->executeQuery($sql);
        //Actualizando las calificaciones que saliran. OBJ
        $sql = 'UPDATE CRRM_ACCO_RATINGS ACRT, CRM_PROD_RATINGS_TMP X SET ACRT.SCGR_CODE = X.SCGR_CODE, ACRT.MDATE = X.MDATE, ACRT.MODIFIEDBY = X.MODIFIEDBY WHERE ACRT.ACCOUNTCODE = X.ACCOUNTCODE AND ACRT.CLX_EFFTDATE = X.CLX_EFFTDATE AND ACRT.RATING_TYPE = X.RATING_TYPE ';
        ClxCommon::$db->executeQuery($sql);
        /* Creando nuevas entradas que no existan */
        $sql = 'INSERT INTO CRRM_ACCO_RATINGS (ACCOUNTCODE, CLX_EFFTDATE, RATING_TYPE, SCGR_CODE, CDATE, CREATEDBY, MDATE, MODIFIEDBY) SELECT X.ACCOUNTCODE, X.CLX_EFFTDATE, X.RATING_TYPE, MAX(X.SCGR_CODE) SCGR_CODE, X.CDATE, X.CREATEDBY, X.MDATE, X.MODIFIEDBY FROM CRM_PROD_RATINGS_TMP X LEFT JOIN CRRM_ACCO_RATINGS ACRT ON ACRT.ACCOUNTCODE = X.ACCOUNTCODE AND ACRT.CLX_EFFTDATE = X.CLX_EFFTDATE AND ACRT.RATING_TYPE = X.RATING_TYPE WHERE ACRT.ID IS NULL GROUP BY X.ACCOUNTCODE, X.CLX_EFFTDATE, X.RATING_TYPE, X.CDATE, X.CREATEDBY, X.MDATE, X.MODIFIEDBY';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'DROP TABLE IF EXISTS CRM_PROD_RATINGS_TMP';
        ClxCommon::$db->executeQuery($sql);
    }

    private function checkDueAmt($loan_code,$clx_efftdate)
    {
        $sql = 'SELECT IFNULL(ROUND(((SUM(IF(FILS.PERIOD_END_DATE <= GLCP.OPERATION_DATE, FILS.PRINCIPAL_PAY, 0))-SUM(FILS.PPAL_PAID_AMT))+ (SUM(IF(FILS.PERIOD_END_DATE <= GLCP.OPERATION_DATE, FILS.INTEREST_PAY, 0))-SUM(FILS.INTPAID_AMT))), 2),0) DUE_AMT FROM CRED_PAYMNT_SCHEDULES FILS, CRED_CREDITS FILO, GL_PARAMETERS_TBL GLCP WHERE FILS.LOAN_CODE = FILO.IDCODE AND FILO.COMP_CODE = GLCP.COMP_CODE AND FILS.EFFTDATE = FILO.CLX_EFFTDATE AND FILS.PERIOD_START_DATE <= GLCP.OPERATION_DATE AND FILO.IDCODE = ' . singleQuote($loan_code) . ' AND FILO.CLX_EFFTDATE = ' . singleQuote($clx_efftdate);
        $r = ClxCommon::$db->getOneRecord($sql);
        return $r['DUE_AMT'];
    }

}
