<?php
/**
 * Marketing Campaign Library
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-05-05 11:35:46 -0500 (sáb, 05 may 2018) $
 * @version    	$Rev: 9808 $
 */

init_mark_camp();

function init_mark_camp() {
    // Globals
    ClxCommon::$cached['b_mark_camp_debug'] = false;
//ClxCommon::$cached['b_mark_camp_debug'] = true;
        
    // Requires and constants
    require_once kPathToWebSite.kPathToPear.'Mail.php';      // These two files are part of Pear,
    require_once kPathToWebSite.kPathToPear.'Mail/mime.php'; // and are required for the Mail_Mime class
    if (!defined('kMarkCemlBatchId')) {
        define('kMarkCemlBatchId', batch_id());
    }
}

function campaignQueryId($record) {
    //[CAMPAIGNCODE] => C001 [QUERYLIST_CODE] => CAMP_TG_CLIENTS )
    $return = ClxCommon::$db->getField('MARK_CAMPAIGN_QUERIES', 'ID', 'CAMPAIGNCODE=' . singleQuote($record['CAMPAIGNCODE']) . ' AND QUERYLIST_CODE = ' . singleQuote($record['QUERYLIST_CODE']) . ' AND DELETED = 0 AND IDCODE = ' . singleQuote($record['IDCODE']));
    return $return;
}

/**
 * Updates additional fields on target record
 *
 * @param array $record
 */
function postSaveCtgtFormRecord(&$record) {
    /* $sql = 'UPDATE MARK_CAMPAIGN_TARGETS CTGT SET CTGT.CAMPAIGNCODE = (SELECT CQRY.CAMPAIGNCODE FROM MARK_CAMPAIGN_QUERIES CQRY WHERE CQRY.IDCODE = CTGT.CQRY_CODE) WHERE CTGT.CAMPAIGNCODE IS NULL';
    ClxCommon::$db->executeQuery($sql); */
    $a = new ctgt();
    $a->count_targets($record['CQRY_CODE']);
}

/**
 * Updates CAMPAIGNCODE of all targets with this column in NULL
 * @param void
 */
function CtgtCampaigncodeFix(){
    $sql = 'UPDATE MARK_CAMPAIGN_TARGETS CTGT SET CTGT.CAMPAIGNCODE = (SELECT CQRY.CAMPAIGNCODE FROM MARK_CAMPAIGN_QUERIES CQRY WHERE CQRY.IDCODE = CTGT.CQRY_CODE) WHERE CTGT.CAMPAIGNCODE IS NULL';
    ClxCommon::$db->executeQuery($sql);
}

/**
 * Get record with query key field names
 *
 * @param string $s_querycode
 * @return array
 */
function get_camp_qry_field_names($s_querycode) {
    $cqrlname = tableName('CQRL');
    if (ClxCommon::$cached['b_mark_camp_debug'] === true)
        ClxCommon::$db->debug = true;
    $a_response = ClxCommon::$db->getRecord($cqrlname, 'QUERYCODE = ' . singleQuote($s_querycode));
    if (ClxCommon::$cached['b_mark_camp_debug'] === true) {
        ClxCommon::$db->debug = false;
        print_r($a_response);
    }
    if (!isset($a_response['ID_FIELD']))
        $a_response['ID_FIELD'] = 'ID';
    if (!isset($a_response['LASTNAME_FIELD']))
        $a_response['LASTNAME_FIELD'] = 'LASTNAME';
    if (!isset($a_response['FIRSTNAME_FIELD']))
        $a_response['FIRSTNAME_FIELD'] = 'FIRSTNAME';
    if (!isset($a_response['PHONE_FIELD']))
        $a_response['PHONE_FIELD'] = 'PHONE';
    if (!isset($a_response['EMAIL_FIELD']))
        $a_response['EMAIL_FIELD'] = 'EMAIL';
    if (ClxCommon::$cached['b_mark_camp_debug'] === true)
        print_r($a_response);
    return $a_response;
}

/**
 * To be called from the screen listing. User must select the Queries to be processed
 *
 * @param void
 * @return void
 */
function executeCampaignQueries() {
    $a = new ctgt();
    $a->save_exec_cqry_btn();
}

/**
 * Removes all targets from campaign where no query exists
 *
 * @param string $campaigncode
 * @return void
 */
function clearUnknownQueryTargets($campaigncode) {
    $sql = 'SELECT DISTINCT CTGT.QUERYCODE, CTGT.CAMPAIGNCODE FROM MARK_CAMPAIGN_TARGETS CTGT LEFT JOIN MARK_CAMPAIGN_QUERIES CQRY ON CQRY.CAMPAIGNCODE = CTGT.CAMPAIGNCODE AND CQRY.QUERYLIST_CODE = CTGT.QUERYCODE WHERE CTGT.CAMPAIGNCODE = ' . singleQuote($campaigncode) . ' AND CQRY.ID IS NULL';
    $results = ClxCommon::$db->executeQuery($sql);
    while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
        $sql = 'DELETE FROM MARK_CAMPAIGN_TARGETS WHERE CAMPAIGNCODE =' . singleQuote($result['CAMPAIGNCODE']) . ' AND QUERYCODE = ' . singleQuote($result['QUERYCODE']);
        ClxCommon::$db->executeQuery($sql);
    }
}

/**
 * Execute queries for campaign
 *
 * @param int $campqueryid
 * @return void
 */
function executeCampaignQuery($campqueryid) {
    init_mark_camp();
    $executeCampaignQuery_insertinto = true;  // uses massive sql insert-into-select  instead a one by one php procedure
    $command_tail = CLX_CHAR_EMPTY_STRING;
    if (empty($campqueryid))
        return; // Target without Query...
    ClxCommon::$db->executeQuery('UPDATE ' . tableName('CQRY') . ' SET INDICTED = ' . singleQuote('OPER') . ' WHERE ID = ' . $campqueryid);
    ClxCommon::$db->commit();
    $max_time = CLX_NUM_60 * CLX_NUM_60 * CLX_NUM_ONE;
    UserResponse::setRunTimeLimit($max_time);
    $DBQY = &getTool('DBQY'); // The query manager
    $campqueryrec = ClxCommon::$db->getRecord('MARK_CAMPAIGN_QUERIES', 'ID = ' . singleQuote($campqueryid));
    //Clean up any target that is not in the query list
    //Deprecated know you can have targets without query
    if (ClxCommon::$cached['b_executeCampaignQuery_debug'] === true)
        echoLog(debug_dump('campqueryrec', $campqueryrec));
    $querycode = $campqueryrec['QUERYLIST_CODE'];
    // Clean targets not sent that belongs to the qury
    $sql = 'DELETE FROM MARK_CAMPAIGN_TARGETS WHERE CQRY_CODE = ' . singleQuote($querycode) . ' AND QUERYCODE <> ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND EMAIL_STATUS <>' . singleQuote('SENT');
    ClxCommon::$db->executeQuery($sql);
    $queryrec = $DBQY->getQuery('MARK', $querycode);
    if (ClxCommon::$cached['b_executeCampaignQuery_debug'] === true) {
        echoLog(debug_dump('queryrec', $queryrec));
    }
    $a_cqrl_rec = get_camp_qry_field_names($querycode);
    $cmd = $queryrec['FROMWHERESORT'];
    $record = array();
    $record['EXEC_DATE'] = date('Y-m-d H:i:s');
    ClxCommon::$db->updateRecord('MARK_CAMPAIGN_QUERIES', $record, 'ID=' . singleQuote($campqueryid));
    $s_aliases_sin_from = str_replace('FROM ', CLX_CHAR_EMPTY_STRING, trim($queryrec['FROMCLAUSE']));
    $a_aliases = explode(',', $s_aliases_sin_from);
    $sw_encontro_alias_ppal = false;
    $total = count($a_aliases);
    for ($i = CLX_INIT_ZERO; $i < $total; $i++) {
        list($nombre_tabla, $alias_tabla) = explode(' ', trim($a_aliases[$i]));
        if ($alias_tabla === 'LEAP' || $alias_tabla === 'ACCO' || $alias_tabla === 'CONT') {
            $sw_encontro_alias_ppal = true;
            break;
        }
    }
    if($sw_encontro_alias_ppal === false) {
        /*
         * MARKCAMP_ALIASNOTFND
         * Couldn´t find CRM Account (ACCO), contacts (CONT) or Leads (LEAD) Table Alias in Query
         * No se pudo encontrar en el Query el alias de alguna de las tablas de Cuenta CRM (ACCO), contactos (CONT)  o Candidatos (LEAD)
         */
        /* FJSH - si el query no tiene criterio entonces anula esta busqueda */
        $s_msg = dict('MARKCAMP_ALIASNOTFND');
        addMessage($s_msg);
        $sw_stop = true;
    } else {
        $s_msg = CLX_CHAR_EMPTY_STRING;
        $s_must_inc_col = CLX_CHAR_EMPTY_STRING;
        $sw_stop = false;
        if (!isset($queryrec['COLUMNS'][$alias_tabla . '_' . $a_cqrl_rec['ID_FIELD']])) {
            $s_msg .= $a_cqrl_rec['ID_FIELD'] . ', ';
            $s_must_inc_col = $a_cqrl_rec['ID_FIELD'] . ', ';
            $sw_stop = true;
        }
        if (!isset($queryrec['COLUMNS'][$alias_tabla . '_' . $a_cqrl_rec['FIRSTNAME_FIELD']]))
            $s_msg .= $a_cqrl_rec['FIRSTNAME_FIELD'] . ', ';
        if (!isset($queryrec['COLUMNS'][$alias_tabla . '_' . $a_cqrl_rec['LASTNAME_FIELD']]))
            $s_msg .= $a_cqrl_rec['LASTNAME_FIELD'] . ', ';
        if (!isset($queryrec['COLUMNS'][$alias_tabla . '_' . $a_cqrl_rec['EMAIL_FIELD']]))
            $s_msg .= $a_cqrl_rec['EMAIL_FIELD'] . ', ';
        if (!isset($queryrec['COLUMNS'][$alias_tabla . '_' . $a_cqrl_rec['PHONE_FIELD']]))
            $s_msg .= $a_cqrl_rec['PHONE_FIELD'] . ', ';
        if (!empty($s_msg)) {
            /*             * *
             * MARKCAMP_COLSNOTFND1
             * QUERY ^1: column(s) not included: ^2
             * QUERY ^1: no se incluyó la(s) columna(s): ^2
             */
            $s_msg = substr($s_msg, CLX_NUM_ZERO, strlen($s_msg) - CLX_NUM_TWO);
            $s_msg = dict('MARKCAMP_COLSNOTFND1', $querycode, $s_msg);
            if ($sw_stop === true) {
                /*                 * *
                 * MARKCAMP_COLSNOTFND2
                 * Cannot process the segmentation because it's a must to include columns: ^1
                 * No se puede procesar la segmentación ya que son obligatorias las columnas: ^1
                 */
                $s_must_inc_col = substr($s_must_inc_col, CLX_NUM_ZERO, strlen($s_must_inc_col) - CLX_NUM_TWO);
                $s_msg .= '. ' . dict('MARKCAMP_COLSNOTFND2', $s_must_inc_col);
            }
            addMessage($s_msg);
        }
    }
    if ($sw_stop === true) {
        // There's a must stop processing condition
    } elseif ($executeCampaignQuery_insertinto === true) {
        // Construye la lista de los campos coincidentes entre el Query y la tabla de targets
        $a_target_fieldlist = array();
        $o_target_fieldlist = ClxCommon::$db->fieldList('MARK_CAMPAIGN_TARGETS');
        while (($a_record = ClxCommon::$db->getNextRecord($o_target_fieldlist, ASSOCIATIVE))) {
            $a_target_fieldlist[$a_record['Field']] = CLX_INIT_ZERO;
        }
        if (ClxCommon::$cached['b_executeCampaignQuery_debug'] === true)
            echoLog(debug_dump('a_target_fieldlist', $a_target_fieldlist));
        reset($queryrec['COLUMNS']);
        $a_coincident_fields = array();
        $a_coincident_fields_expressions = array();
        foreach ($queryrec['COLUMNS'] as $fld_name_w_alias => $s_content) {
            $fld_name = str_replace($alias_tabla . '_', CLX_CHAR_EMPTY_STRING, $fld_name_w_alias);
            if ($s_content['WORKFIELD_NAME'] !== CLX_CHAR_EMPTY_STRING) {
                $fld_name = $s_content['WORKFIELD_NAME'];
            }
            if (ClxCommon::$cached['b_executeCampaignQuery_debug'] === true)
                echoLog('<br>fld_name_w_alias=' . $fld_name_w_alias . ', fld_name=' . $fld_name);
            if (isset($a_target_fieldlist[$fld_name])) {
                if ($fld_name != $a_cqrl_rec['ID_FIELD'] &&
                        $fld_name !== 'FULLNAME' &&
                        $fld_name != $a_cqrl_rec['EMAIL_FIELD'] &&
                        $fld_name != $a_cqrl_rec['PHONE_FIELD']) {
                    $a_coincident_fields[] = $fld_name;
                    if (trim($queryrec['COLUMNS'][$fld_name_w_alias]['EXPRESSION_ONLY']) !== CLX_CHAR_EMPTY_STRING) {
                        $a_coincident_fields_expressions[] = $queryrec['COLUMNS'][$fld_name_w_alias]['EXPRESSION_ONLY'];
                    } else {
                        $a_coincident_fields_expressions[] = CLX_CHAR_EMPTY_STRING;
                    }
                }
            }
        }
        if (ClxCommon::$cached['b_executeCampaignQuery_debug'] === true)
            echo debug_dump('a_coincident_fields', $a_coincident_fields);
        $s_list_column_names = CLX_CHAR_EMPTY_STRING;
        $s_list_values = CLX_CHAR_EMPTY_STRING;
        $total = count($a_coincident_fields);
        for ($ii = CLX_INIT_ZERO; $ii < $total; $ii++) {
            $s_list_column_names .= ', ' . $a_coincident_fields[$ii];
            if ($a_coincident_fields_expressions[$ii] !== CLX_CHAR_EMPTY_STRING) {
                $s_list_values .= ', ' . '(' . $a_coincident_fields_expressions[$ii] . ') ' . $a_coincident_fields[$ii];
            } else {
                $s_list_values .= ', ' . $alias_tabla . '.' . $a_coincident_fields[$ii];
            }
        }
        if (ClxCommon::$cached['b_executeCampaignQuery_debug'] === true)
            echoLog('<br>s_list_column_names = ' . $s_list_column_names . '<br>s_list_values = ' . $s_list_values);
        /* begin INSERT INTO MASIVO */
        // If address column is specified in qry, uses it as e-mail address, else if email column is specified in qry, includes it into de insert, else, put null string value
        if (isset($queryrec['COLUMNS'][$alias_tabla . '_ADDRESS']))
            $email_field = $alias_tabla . '.ADDRESS';
        elseif (isset($queryrec['COLUMNS'][$alias_tabla . '_' . $a_cqrl_rec['EMAIL_FIELD']]))
            $email_field = $alias_tabla . '.' . $a_cqrl_rec['EMAIL_FIELD'];
        else
            $email_field = singleQuote('null');
        // If phone column is specified in qry, includes it into de insert, else, put in blank
        if (isset($queryrec['COLUMNS'][$alias_tabla . '_' . $a_cqrl_rec['PHONE_FIELD']]))
            $phone_field = $alias_tabla . '.' . $a_cqrl_rec['PHONE_FIELD'];
        else
            $phone_field = singleQuote(CLX_CHAR_EMPTY_STRING);
        $additional_condition_to_insert = CLX_CHAR_EMPTY_STRING;
        // If email column is in query, put an additional condition to insert ercords only in case of email not in blank
        $command_tail .= (empty($queryrec['SORTCLAUSE']) ? CLX_CHAR_EMPTY_STRING : ' ORDER BY ' . $queryrec['SORTCLAUSE']) . (empty($queryrec['GROUPCLAUSE']) ? CLX_CHAR_EMPTY_STRING : ' GROUP BY ' . $queryrec['GROUPCLAUSE']);
        $where_clause = trim($queryrec['WHERECLAUSE']);
        if (!empty($where_clause)) {
            $where_clause = ' AND ' . $where_clause;
        }
        $sql = 'INSERT INTO MARK_CAMPAIGN_TARGETS ( `CQRY_CODE`, `CAMPAIGNCODE`, `CONTACTID`, `REC_ID`, `QUERYCODE`, `FULLNAME`, `CALL_DATE`, `EMAIL_DATE`, `EMAIL_STATUS`, `EMAIL`, `PHONE`, `STATUS` ' . $s_list_column_names . ' ) SELECT ' . singleQuote($campqueryrec['IDCODE']) . ' IDCODE, ' . singleQuote($campqueryrec['CAMPAIGNCODE']) . ' CAMPAIGNCODE, ' . $alias_tabla . '.' . $a_cqrl_rec['ID_FIELD'] . ' CONTACTID, ' . $alias_tabla . '.' . $a_cqrl_rec['ID_FIELD'] . ' REC_ID, ' . singleQuote($querycode) . ' QUERYCODE, IF(' . $alias_tabla . '.' . $a_cqrl_rec['LASTNAME_FIELD'] . CLX_CHAR_DIFERENTE_SING . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND ' . $alias_tabla . '.' . $a_cqrl_rec['FIRSTNAME_FIELD'] . CLX_CHAR_DIFERENTE_SING . singleQuote(CLX_CHAR_EMPTY_STRING) . ', CONCAT(' . $alias_tabla . '.' . $a_cqrl_rec['LASTNAME_FIELD'] . ', ' . singleQuote(', ') . ', ' . $alias_tabla . '.' . $a_cqrl_rec['FIRSTNAME_FIELD'] . '), IF(' . $alias_tabla . '.' . $a_cqrl_rec['LASTNAME_FIELD'] . CLX_CHAR_DIFERENTE_SING . singleQuote(CLX_CHAR_EMPTY_STRING) . ',' . $alias_tabla . '.' . $a_cqrl_rec['LASTNAME_FIELD'] . ', IF(' . $alias_tabla . '.' . $a_cqrl_rec['FIRSTNAME_FIELD'] . CLX_CHAR_DIFERENTE_SING . singleQuote(CLX_CHAR_EMPTY_STRING) . ',' . $alias_tabla . '.' . $a_cqrl_rec['FIRSTNAME_FIELD'] . ', ' . $alias_tabla . '.' . $a_cqrl_rec['EMAIL_FIELD'] . ' ) ) ) FULLNAME, ' . singleQuote(xFormat::getNow()) . '  CALL_DATE, NULL EMAIL_DATE, ' . singleQuote('PEND') . ' EMAIL_STATUS, ' . $email_field . ' EMAIL, ' . $phone_field . ' PHONE, ' . singleQuote('A') . ' STATUS ' . $s_list_values . ' FROM ' . $queryrec['FROMCLAUSE'] . ' WHERE 1=1 ' . $where_clause . ' AND NOT EXISTS ( SELECT ' . singleQuote('X') . ' FROM MARK_CAMPAIGN_TARGETS X WHERE X.CAMPAIGNCODE=' . singleQuote($campqueryrec['CAMPAIGNCODE']) . ' AND X.REC_ID=' . $alias_tabla . '.' . $a_cqrl_rec['ID_FIELD'] . ' AND UPPER(X.QUERYCODE)=' . singleQuote(UPPERCASE($querycode)) . ' )' . $additional_condition_to_insert . ' ' . $command_tail;
        if (ClxCommon::$cached['b_executeCampaignQuery_debug'] === true)
            echoLog('<BR><BR>EN INSERT INTO DREAMTEAM:<BR>' . $sql);
        ClxCommon::$db->executeQuery($sql);
        /* end  INSERT INTO MASIVO */
    } else {
        /* begin ONE BY ONE PHP PROCEDURE */
        $records = ClxCommon::$db->executeQuery('SELECT ' . $queryrec['selectclause'] . $cmd);
        if (ClxCommon::$cached['b_executeCampaignQuery_debug'] === true)
            echoLog('<br>El Qry: SELECT ' . $queryrec['selectclause'] . $cmd);
        while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
            if (ClxCommon::$cached['b_executeCampaignQuery_debug'] === true)
                echoLog(debug_dump('record antes de remover tabl', $record));
            foreach ($record as $key => $val) {//Removing table code from record field
                $record[substr($key, CLX_NUM_FIVE, strlen($key) - CLX_NUM_FIVE)] = $val;
            }
            if (ClxCommon::$cached['b_executeCampaignQuery_debug'] === true)
                echoLog(debug_dump('record DESPUES de remover tabl', $record));
            if (ClxCommon::$cached['b_executeCampaignQuery_debug'] === true)
                ClxCommon::$db->debug = true;
            $qty = ClxCommon::$db->oneExistsRecords('MARK_CAMPAIGN_TARGETS', 'CAMPAIGNCODE=' . singleQuote($campqueryrec['CAMPAIGNCODE']) . ' AND REC_ID=' . singleQuote($record['ID']) . ' AND UPPER(QUERYCODE)=' . singleQuote(UPPERCASE($querycode)));
            if (ClxCommon::$cached['b_executeCampaignQuery_debug'] === true)
                ClxCommon::$db->debug = false;
            if ($qty == CLX_NUM_ZERO) {
                $contact = array();
                $contact['CAMPAIGNCODE'] = $campqueryrec['CAMPAIGNCODE'];
                $contact['CONTACTID'] = $record['ID'];
                $contact['REC_ID'] = $record['ID'];
                $contact['QUERYCODE'] = $querycode;
                $contact['FULLNAME'] = CLX_CHAR_EMPTY_STRING;
                $contact['CALL_DATE'] = xFormat::getNow();
                $contact['EMAIL_DATE'] = 'null';
                $contact['EMAIL_STATUS'] = 'PEND';
                //Targeted Email Address
                if (isset($record['ADDRESS']))
                    $contact['EMAIL'] = $record['ADDRESS'];
                elseif (isset($record['EMAIL']))
                    $contact['EMAIL'] = $record['EMAIL'];
                else
                    $contact['EMAIL'] = 'null';
                if (isset($record['PHONE']))
                    $contact['PHONE'] = $record['PHONE'];
                else
                    $contact['PHONE'] = CLX_CHAR_EMPTY_STRING;
                //Adding Name Label
                if (!empty($record['LASTNAME']) && !empty($record['FIRSTNAME'])) {
                    $contact['FULLNAME'] = $record['LASTNAME'] . ', ' . $record['FIRSTNAME'];
                } elseif (empty($record['LASTNAME']) || empty($record['FIRSTNAME'])) {
                    if (!empty($record['LASTNAME']))
                        $contact['FULLNAME'] = $record['LASTNAME'];
                    if (!empty($record['FIRSTNAME']))
                        $contact['FULLNAME'] = $record['FIRSTNAME'];
                }else {
                    $contact['FULLNAME'] = $record['EMAIL'];
                }
                //BYPASS IF NO EMAILS FOUND
                if (!empty($record['EMAIL'])) {
                    if (ClxCommon::$cached['b_executeCampaignQuery_debug'] === true)
                        ClxCommon::$db->debug = true;
                    ClxCommon::$db->createRecord('MARK_CAMPAIGN_TARGETS', $contact, false);
                    if (ClxCommon::$cached['b_executeCampaignQuery_debug'] === true)
                        ClxCommon::$db->debug = false;
                }
            }//end if
        }//end while
        /* end ONE BY ONE PHP PROCEDURE */
    }
    ClxCommon::$db->executeQuery('UPDATE ' . tableName('CQRY') . ' SET INDICTED = ' . singleQuote('PROC') . ' WHERE ID = ' . $campqueryid);
    ClxCommon::$db->commit();
}

/**
 * CTMK Table restart
 *
 * @param void
 * @return void
 */
function CTMK_restart() {
    $DBTF = getTool('DBTF');
    $ctmkname = tableName('CTMK');
    $cteaname = tableName('CTEA');
    $ctername = tableName('CTER');
    $f = 'CAMPSECTION_TELE_CODE';
    $idlist = toString(getIdlist());
    if(empty($idlist)){
        return;
    }
    $results = ClxCommon::$db->getRecords($ctmkname, 'ID IN (' . $idlist . ')');
    while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
        $sql = 'SELECT Q.RESULT_TABLECODE FROM MARK_CAMPSEC_TELEMARK X, CLX_AN_QUESTIONARIES Q WHERE X.QUESTIONARYCODE = Q.IDCODE AND X.ID=' . singleQuote($result['ID']);
        $result_tablecode = ClxCommon::$db->getOne($sql);
        if ($DBTF->fieldExists($result_tablecode, $f)) {
            $sql = 'DELETE FROM ' . tableName($result_tablecode) . ' WHERE CAMPSECTION_TELE_CODE = ' . singleQuote($result['IDCODE']);
            ClxCommon::$db->executeQuery($sql);
        }
        ClxCommon::$db->deleteRecords($cteaname, 'CAMPSECTION_TELE_CODE = ' . singleQuote($result['ID']));
        ClxCommon::$db->deleteRecords($ctername, 'CAMPSECTION_TELE_CODE = ' . singleQuote($result['ID']));
        ClxCommon::$db->updateRecord($ctmkname, array('CAMPSECTION_STATUS' => 'IDLE'), 'ID =' . singleQuote($result['ID']));
    }
}

// EMAIL CAMPAIGNS

/**
 * CEML Table restart
 *
 * @param void
 * @return void
 */
function CEML_restart() {
    $content = CLX_CHAR_EMPTY_STRING;
    $sec_deleted = CLX_CHAR_EMPTY_STRING;
    $sec_not_deleted = CLX_CHAR_EMPTY_STRING;
    $cemlname = tableName('CEML'); //CEML 	CAMPSEC_EMAIL
    $idlist = toString(getIdlist());
    $rs = ClxCommon::$db->getRecords($cemlname, 'ID IN (' . singleQuote($idlist) . ') /* AND CAMPSECTION_STATUS<>' . singleQuote('WORK') . '*/');
    while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
        if($r['CAMPSECTION_STATUS'] === 'WORK') {
            $sec_not_deleted .= ('<li>' . $r['IDCODE'] . ' : ' . $r['IDNAME'] . '</li>');
            continue;
        }
        ClxCommon::$db->updateRecord($cemlname, array('CAMPSECTION_STATUS' => 'IDLE', 'PROCESS_MSG' => CLX_CHAR_EMPTY_STRING), 'ID=' . singleQuote($r['ID']));
        ClxCommon::$db->executeQuery('UPDATE MARK_CAMPAIGN_TARGETS SET EXCLUDED=0, EMAIL_STATUS=' . singleQuote('PEND') . ', RESULT_CODE=' . singleQuote(CLX_CHAR_EMPTY_STRING) . ', EMAIL_DATE=' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' WHERE CAMPAIGNCODE=' . singleQuote($r['CAMPAIGNCODE']) . ' AND DELETED=0');
        $sql = 'DELETE CEMR.* FROM MARK_CAMPSEC_EMAIL_RES CEMR, MARK_CAMPSEC_EMAIL_EXE CEME WHERE CEMR.CEME_ID = CEME.ID AND CEME.CEML_CODE='.singleQuote($r['IDCODE']);
        ClxCommon::$db->executeQuery($sql);
        ClxCommon::$db->executeQuery('DELETE FROM MARK_CAMPSEC_EMAIL_EXE WHERE CEML_CODE=' . singleQuote($r['IDCODE']));
        ClxCommon::$db->executeQuery('DELETE FROM BASE_EMAIL WHERE CEML_CODE=' . singleQuote($r['IDCODE']) . ' AND EMAIL_STATUS=' . singleQuote('PEND'));
        $sec_deleted .= ('<li>' . $r['IDCODE'] . ' : ' . $r['IDNAME'] . '</li>');
    }
    if($sec_deleted != CLX_CHAR_EMPTY_STRING) {
        /*
         * GEN_LBL_MARK_CAMP_00270
         * The sent email and executions logs has been deleted. Section(s):<br>^1
         * Se eliminó el registro de todas las ejecuciones y todos los correos enviados para la(s) Sección(es):<br>^1
         */
        $content .= dict('GEN_LBL_MARK_CAMP_00270', '<ul>' . $sec_deleted . '</ul>');
    }
    if($sec_not_deleted != CLX_CHAR_EMPTY_STRING) {
        /*
         * GEN_LBL_MARK_CAMP_00290
         * The execution logs cannot be deleted because Emails section is still running. Please stop it before repeat this action.
         * No se puede limpiar los registros de ejecuciones porque la sección de Email está en marcha. Favor detenerla antes de realizar esta operación.
         */
        $content .= ($content == CLX_CHAR_EMPTY_STRING ? CLX_CHAR_EMPTY_STRING : '<br><br>') . mb_convert_case(dict('GEN_LBL_MARK_CAMP_00290'), MB_CASE_UPPER) . '<br><br>' . dict('GEN_LBL_MARK_CAMPSEC', '<BR><ul>' . $sec_not_deleted . '</ul>');
    }
    return $content;
}

/**
 * CEML Table clean
 *
 * @param void
 * @return void
 */
function CEML_clean() {
    $content = CLX_CHAR_EMPTY_STRING;
    $sec_deleted = CLX_CHAR_EMPTY_STRING;
    $sec_not_deleted = CLX_CHAR_EMPTY_STRING;
    $cemlname = tableName('CEML');  //CEML  CAMPSEC_EMAIL
    $cemename = tableName('CEME');  //CEME  MARK_CAMPSEC_EMAIL_EXE
    $cemrname = tableName('CEMR');  //CEMR  MARK_CAMPSEC_EMAIL_RES
    $idlist = toString(getIdlist());
    $rs = ClxCommon::$db->getRecords($cemlname, 'ID IN (' . singleQuote($idlist) . ') /* AND CAMPSECTION_STATUS<>' . singleQuote('WORK') . '*/');
    while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
        if($r['CAMPSECTION_STATUS'] === 'WORK') {
            $sec_not_deleted .= ('<li>' . $r['IDCODE'] . ' : ' . $r['IDNAME'] . '</li>');
            continue;
        }
        $ceme_records = ClxCommon::$db->getRecords($cemename, 'CEML_CODE=' . singleQuote($r['IDCODE']));
        while ($ceme_record = ClxCommon::$db->getNextRecord($ceme_records, ASSOCIATIVE)) {
            $sql = 'SELECT IFNULL(COUNT(CEMR.ID),0) FROM '.$cemrname.' CEMR WHERE CEMR.CEME_ID='.$ceme_record['ID'].' AND CEMR.RESULT_CODE='.singleQuote('READ');
            $total_read = ClxCommon::$db->getOne($sql);
            $sql = 'UPDATE '.$cemename.' CEME SET CEME.TOTAL_READ='.$total_read.' WHERE CEME.ID='.$ceme_record['ID'];
            ClxCommon::$db->executeQuery($sql);
        }
        // Elimina los enviados para esta sección de email
        $sql = 'DELETE CEMR.* FROM '.$cemrname.' CEMR, '.$cemename.' CEME WHERE CEMR.CEME_ID=CEME.ID AND CEME.CEML_CODE='.singleQuote($r['IDCODE']);
        ClxCommon::$db->executeQuery($sql);
        $sec_deleted .= ('<li>' . $r['IDCODE'] . ' : ' . $r['IDNAME'] . '</li>');
    }            
    if($sec_deleted != CLX_CHAR_EMPTY_STRING) {
        /*
         * GEN_LBL_MARK_CAMP_00250
         * The email sent log was deleted. Section(s):<br>^1
         * Se eliminó el registro de todos los correos enviados para la(s) Sección(es):<br>^1
         */
        $content .= dict('GEN_LBL_MARK_CAMP_00250', '<ul>' . $sec_deleted . '</ul>');
    }
    if($sec_not_deleted != CLX_CHAR_EMPTY_STRING) {
        /*
         * GEN_LBL_MARK_CAMP_00290
         * The execution logs cannot be deleted because Emails section is still running. Please stop it before repeat this action.
         * No se puede limpiar los registros de ejecuciones porque la sección de Email está en marcha. Favor detenerla antes de realizar esta operación.
         */
        $content .= ($content == CLX_CHAR_EMPTY_STRING ? CLX_CHAR_EMPTY_STRING : '<br><br>') . mb_convert_case(dict('GEN_LBL_MARK_CAMP_00290'), MB_CASE_UPPER) . '<br><br>' . dict('GEN_LBL_MARK_CAMPSEC', '<BR><ul>' . $sec_not_deleted . '</ul>');
    }
    return $content;
}

//---------------------------------------------------------------------
//---------------------------------------------------------------------
//---------------------------------------------------------------------

function mark_camp_popup_action($ac) {
    $msg = array();
    $contents = CLX_CHAR_EMPTY_STRING;
    $proceed_answer = '1';
    $get_flds = array();
//pre(UserRequest::$post);
    $get_flds['confirm'] = array( 'field_name' => 'confirm', 'field_type' => 'hidden', 'field_value' => (isset(UserRequest::$post['confirm'])?UserRequest::$post['confirm']:'0') );
    $mark_camp_sched_mode = get_def_company_param('MARK_CAMP_SCHED_MODE', '1');
    $delivery_date_field_spec = array('field_name' => 'delivery_date', 'field_type' => 'datetime', 'field_label' => dict('GEN_LBL_NEXT_RUN_TIME'), 'field_value' => (isset(UserRequest::$post['delivery_date'])?UserRequest::$post['delivery_date']:xFormat::date('now','Y-m-d H:i:s')));
    $errmsg = array();
    //$url_parent = 'window.opener.location.href=' . singleQuote('tool.php?to=EDIT&ac=DISPLAY&li=MARK_CAMP&qy=MARK_CAMP&relfm=&idlist='.get_ceml_camp_id()) . ';';
    $url_parent = '';
    /*
     * GEN_LBL_OPER_EXECUTED
     * Operation done
     * Operación realizada
     */
    $msg_oper_executed = dict('GEN_LBL_OPER_EXECUTED');
    /*
     * GEN_LBL_OPER_ABORTED
     * Operation cancelled
     * Operación cancelada
     */
    $msg_oper_aborted = dict('GEN_LBL_OPER_ABORTED');
    $txt_ceml_names = get_ceml_names();
    switch ($ac) {
        case 'START' :
            // START Email campaign delivery from scratch | CONTINUE Email campaign delivery
        case 'CONTINUE' :
            // CONTINUE Email campaign delivery
            $gen_msg = array();
            /*
             * GEN_LBL_INIT_EXEC
             * Start execution
             * Iniciar ejecución
             *
             * GEN_LBL_FROM_BEGINING
             * From the begining
             * Desde el inicio
             *
             * GEN_LBL_MARK_CAMP_00200
             * NOTICE: A new email delivery FROM SCRATCH execution will be started. Section(s):<br>^1
             * ATENCIÓN: se iniciará una nueva ejecución de envío de correos DESDE EL INICIO para la(s) Sección(es):<br>^1
             *
             * GEN_LBL_MARK_CAMP_00180
             * A new email delivery execution was started. Section(s):<br>^1
             * Se inició una nueva ejecución de envío de correos para la(s) Sección(es):<br>^1
             */
            $gen_msg['START'] = array();
            $gen_msg['START']['TITLE'] = mb_convert_case(dict('GEN_LBL_INIT_EXEC'), MB_CASE_UPPER);
            $gen_msg['START']['SUBTITLE'] = '('.mb_convert_case(dict('GEN_LBL_FROM_BEGINING'), MB_CASE_UPPER).')';
            $gen_msg['START']['EXE_WILL_START_DICT'] = 'GEN_LBL_MARK_CAMP_00200';
            $gen_msg['START']['EXE_STARTED_DICT'] = 'GEN_LBL_MARK_CAMP_00180';
            /*
             * GEN_LBL_CONT_EXEC
             * Continue execution
             * Continuar ejecución
             *
             * GEN_LBL_RESUME_FROM
             * Resume from last execution
             * Reanudar desde el punto donde quedó
             *
             * GEN_LBL_MARK_CAMP_00220
             * NOTICE: A email resumed delivery execution will start (excluding e-mail already sent). Section(s):<br>^1
             * ATENCIÓN: se iniciará una nueva ejecución de envío de correos a (sin incluir e-mails ya enviados), para la(s) Sección(es):<br>^1
             *
             * GEN_LBL_MARK_CAMP_00210
             * A email delivery execution was resumed. Section(s):<br>^1
             * Se reinició la ejecución de envío de correos para la(s) Sección(es):<br>^1
             */
            $gen_msg['CONTINUE'] = array();
            $gen_msg['CONTINUE']['TITLE'] = mb_convert_case(dict('GEN_LBL_CONT_EXEC'), MB_CASE_UPPER);
            $gen_msg['CONTINUE']['SUBTITLE'] = '('.mb_convert_case(dict('GEN_LBL_RESUME_FROM'), MB_CASE_UPPER).')';
            $gen_msg['CONTINUE']['EXE_WILL_START_DICT'] = 'GEN_LBL_MARK_CAMP_00220';
            $gen_msg['CONTINUE']['EXE_STARTED_DICT'] = 'GEN_LBL_MARK_CAMP_00210';

            $dmode = (isset(UserRequest::$post['dmode']) ? UserRequest::$post['dmode'] : 'CONTINUE');
            if(isset(UserRequest::$post['dmode']) && CLX_NUM_ZERO+$get_flds['confirm']['field_value'] > CLX_NUM_ZERO) {
                $get_flds['dmode'] = array('field_name' => 'dmode', 'field_type' => 'hidden', 'field_value' => $dmode);
            } else {
                $get_flds['dmode'] = array('field_name' => 'dmode', 'field_type' => 'list', 'field_label' => dict('GEN_LBL_MODE'), 'field_value' => $dmode, 'list_items' => array('CONTINUE'=>'GEN_LBL_CONT_EXEC', 'START'=>'GEN_LBL_INIT_EXEC') );
                $msg[] = '<div id="pop_title">' . dict('GEN_LBL_INIT_EXEC') . '</div>';
                $contents .= popup_form_Warning($msg, $get_flds, $errmsg);
                break;
            }
            if($mark_camp_sched_mode == '0') {
                $get_flds['delivery_date'] = $delivery_date_field_spec;
            } else {
                UserRequest::$post['delivery_date'] = CLX_CHAR_EMPTY_STRING;
            }
            $msg[] = array(
                '<div id="pop_title">' . $gen_msg[$dmode]['TITLE'] . '</div>',
                '<div id="pop_subtitle">' . $gen_msg[$dmode]['SUBTITLE'] . '</div>'
            );
            if (isset(UserRequest::$post ['confirm']) && UserRequest::$post ['confirm'] === '2') {
                if($mark_camp_sched_mode == '0') {
                    xValidate::datetime($errmsg, 'delivery_date', UserRequest::$post['delivery_date'], dict('GEN_LBL_NEXT_RUN_TIME'));
                }
                if (isset($errmsg['delivery_date'])) {
                    // Error en fecha de envio
                    $msg[] = '<div id="pop_intro">' . dict($gen_msg[$dmode]['EXE_WILL_START_DICT'], $txt_ceml_names) . '</div>';
                    $contents .= popup_form_Warning($msg, $get_flds, $errmsg, false, true);
                    break;
                } elseif (UserRequest::$post ['yesno'] === $proceed_answer) {
                    // Ejecuta el envío desde cero ($dmode = START) o continuado ($dmode = CONTNUE)
                    $contents .= CEML_execute($dmode, UserRequest::$post['delivery_date']);
                    $msg[] = $msg_oper_executed;
                    $msg[] = CLX_CHAR_EMPTY_STRING;
                    $msg[] = dict($gen_msg[$dmode]['EXE_STARTED_DICT'], $txt_ceml_names);
                    $msg[] = $delivery_date_field_spec['field_label'] . ': ' . $delivery_date_field_spec['field_value'];
                } else {
                    $msg[] = $msg_oper_aborted;
                }
                $contents .= popup_form_Finish($msg, $url_parent);
            } else {
                $msg[] = '<div id="pop_intro">' . dict($gen_msg[$dmode]['EXE_WILL_START_DICT'], $txt_ceml_names) . '</div>';
                $contents .= popup_form_Warning($msg, $get_flds, $errmsg, false, true);
            }
            break;
        case 'STOP' :
            // STOP Campaign
            /*
             * GEN_LBL_STOP_EXEC
             * Stop execution
             * Detener ejecución
             */
            $msg[] = mb_convert_case(dict('GEN_LBL_STOP_EXEC'), MB_CASE_UPPER);
            if (isset(UserRequest::$post ['confirm'])) {
                if (UserRequest::$post ['yesno'] == $proceed_answer) {
                    $contents .= CEML_execute('STOP');
                    $msg[] = $msg_oper_executed;
                    $msg[] = CLX_CHAR_EMPTY_STRING;
                    /*
                     * GEN_LBL_MARK_CAMP_00230
                     * A email delivery execution was stopped. Section(s):<br>^1
                     * Se detuvo la ejecución de envío de correos para la(s) Sección(es):<br>^1
                     */
                    $msg[] = dict('GEN_LBL_MARK_CAMP_00230', $txt_ceml_names);
                } else {
                    $msg[] = $msg_oper_aborted;
                }
                $contents .= popup_form_Finish($msg, $url_parent);
            } else {
                /*
                 * GEN_LBL_MARK_CAMP_00240
                 * NOTICE: A email delivery execution will be stopped. Section(s):<br>^1
                 * ATENCIÓN: se detendrá la ejecución actual de envío de correos de la(s) Sección(es):<br>^1
                 */
                $msg[] = dict('GEN_LBL_MARK_CAMP_00240', $txt_ceml_names);
                $contents .= popup_form_Warning($msg, $get_flds, $errmsg, false, true);
            }
            break;
        case 'CLEAN' :
            // Clean execution data
        case 'RESTART' :
            // Restart (delete) all email campaign section data
            $gen_msg = array();
            /*
             * GEN_LBL_CLEAN_EMAIL_SENT
             * Clean Emails sent log
             * Limpiar log de Emails enviados
             *
             * GEN_LBL_MARK_CAMP_00260
             * NOTICE: The sent email log will be deleted. Section(s):<br>^1
             * ATENCIÓN: Se eliminará el registro de todos los correos enviados para la(s) Sección(es):<br>^1
             */
            $gen_msg['CLEAN'] = array();
            $gen_msg['CLEAN']['TITLE'] = mb_convert_case(dict('GEN_LBL_CLEAN_EMAIL_SENT'), MB_CASE_UPPER);
            $gen_msg['CLEAN']['EXE_WILL_START_DICT'] = 'GEN_LBL_MARK_CAMP_00260';
            /*
             * GEN_LBL_RESUME_SECTION
             * Re-start section
             * Reiniciar sección
             *
             * GEN_LBL_MARK_CAMP_00280
             * NOTICE: The sent email and executions logs will be deleted. Section(s):<br>^1
             * ATENCIÓN: Se eliminará el registro de ejecuciones y todos los correos enviados para la(s) Sección(es):<br>^1
             */
            $gen_msg['RESTART'] = array();
            $gen_msg['RESTART']['TITLE'] = mb_convert_case(dict('GEN_LBL_RESUME_SECTION'), MB_CASE_UPPER);
            $gen_msg['RESTART']['EXE_WILL_START_DICT'] = 'GEN_LBL_MARK_CAMP_00280';

            $dmode = (isset(UserRequest::$post['dmode']) ? UserRequest::$post['dmode'] : 'RESTART');
            if(isset(UserRequest::$post['dmode']) && CLX_NUM_ZERO+$get_flds['confirm']['field_value'] > 0) {
                $get_flds['dmode'] = array('field_name' => 'dmode', 'field_type' => 'hidden', 'field_value' => $dmode);
            } else {
                $get_flds['dmode'] = array('field_name' => 'dmode', 'field_type' => 'list', 'field_label' => dict('GEN_LBL_ACTION'), 'field_value' => $dmode, 'list_items' => array('RESTART'=>'GEN_LBL_RESUME_SECTION', 'CLEAN'=>'GEN_LBL_CLEAN_EMAIL_SENT') );
                $msg[] = '<div id="pop_title">' . dict('GEN_LBL_RESUME_SECTION') . '</div>';
                $contents .= popup_form_Warning($msg, $get_flds, $errmsg);
                break;
            }

            if($mark_camp_sched_mode == '0') {
                $get_flds['delivery_date'] = $delivery_date_field_spec;
            } else {
                UserRequest::$post['delivery_date'] = CLX_CHAR_EMPTY_STRING;
            }
            $msg[] = '<div id="pop_title">' . $gen_msg[$dmode]['TITLE'] . '</div>';
            if (isset(UserRequest::$post ['confirm']) && UserRequest::$post ['confirm'] == '2') {
                if (UserRequest::$post ['yesno'] == $proceed_answer && $dmode == 'CLEAN') {
                    $msg[] = CEML_clean();
                } elseif (UserRequest::$post ['yesno'] == $proceed_answer && $dmode == 'RESTART') {
                    $msg[] = CEML_restart();
                } else {
                    $msg[] = $msg_oper_aborted;
                }
                $contents .= popup_form_Finish($msg, $url_parent);
            } else {
                $msg[] = dict($gen_msg[$dmode]['EXE_WILL_START_DICT'], $txt_ceml_names);
                $contents .= popup_form_Warning($msg, $get_flds, $errmsg, true);
            }
            break;
        default :
            $msg[] = mb_convert_case(dict('GEN_LBL_ERROR'), MB_CASE_UPPER);
            /*
             * GEN_LBL_INVALID_OPT
             * Invalid option: ^1
             * Opción inválida: ^1
             */
            $msg[] = dict('GEN_LBL_INVALID_OPT', '[' . $ac . ']');
            $contents .= popup_form_Finish($msg, $url_parent);
            break;
    }
    return $contents;
}

function get_ceml_names() {
    $cemlname = tableName('CEML');  // CEML = MARK_CAMPSEC_EMAIL
    $idlist = toString(getIdlist());
    $rs = ClxCommon::$db->getRecords($cemlname, 'ID IN ('.$idlist.')');
    $contents = '<ul>';
    while(($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE))){
        $contents .= '<li>' . $r['IDCODE'] . ' : ' . $r['IDNAME'] . '</li>';
    }
    $contents .= '</ul>';
    return $contents;
}

function get_ceml_camp_id() {
    $cemlname = tableName('CEML');  // CEML = MARK_CAMPSEC_EMAIL
    $campname = tableName('CAMP');  // CAMP = MARK_CAMPAIGNS
    $idlist = getIdlist();
    $sql = 'SELECT CAMP.ID FROM '.$cemlname.' CEML, '.$campname.' CAMP WHERE CEML.CAMPAIGNCODE=CAMP.IDCODE AND CEML.ID = '.$idlist[0];
    $camp_id = ClxCommon::$db->getOne($sql);
    return $camp_id;
}

function popup_form_Warning($msg, $get_flds, $errmsg, $double_confirm = false, $finish_screen = null) {
    if(is_null($finish_screen)) {
        $finish_screen = ($double_confirm == true);
    }
    $js_code = CLX_CHAR_EMPTY_STRING;
    $form = popup_form_init();
    $form->addArgument('idlist', toString(getIdlist()));
    $form->setProp('enctype', 'multipart/form-data');

    $tableWidth = CLX_NUM_TWO;
    $table = new htmlTable($tableWidth);
    $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
    if(is_array($msg[0])) {
        $table->addCell($msg[0][0], array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => $tableWidth));
        $table->addCell($msg[0][1], array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => $tableWidth));
    } else {
        $table->addCell($msg[0], array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => $tableWidth));
    }
    $table->addCell('&nbsp;', array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => $tableWidth));
    for($i=CLX_NUM_ONE; $i<count($msg); $i++) {
        if($msg[$i] == CLX_CHAR_EMPTY_STRING) $msg[$i] = '&nbsp;';
        $table->addCell($msg[$i], array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => $tableWidth));
    }
    foreach($get_flds as $i => $val) {
        $get_flds[$i]['field_length'] = (isset($get_flds[$i]['field_length'])?$get_flds[$i]['field_length']:'20');
        $get_flds[$i]['field_maxlength'] = (isset($get_flds[$i]['field_maxlength'])?$get_flds[$i]['field_maxlength']:'50');
        $get_flds[$i]['field_required'] = (isset($get_flds[$i]['field_required'])?$get_flds[$i]['field_required']:true);
        switch($get_flds[$i]['field_type']) {
            case 'js':
                $js_code .=  '<!-- BEGIN: ' . $get_flds[$i]['field_name'] . ' -->' . CLX_CHAR_NL . $get_flds[$i]['field_value'] . CLX_CHAR_NL . '<!-- END: ' . $get_flds[$i]['field_name'] . ' -->' . CLX_CHAR_NL;
                break;
            case 'hidden':
                $form->addArgument($get_flds[$i]['field_name'], $get_flds[$i]['field_value']);
                break;
            case 'list':
                $table->addList($get_flds[$i]['field_label'], $get_flds[$i]['field_name'], $get_flds[$i]['field_value'], $get_flds[$i]['list_items'], (isset($get_flds[$i]['field_required']) ? $get_flds[$i]['field_required'] : false));
                break;
            case 'list-no-dict':
                $table->addCell($get_flds[$i]['field_label'], array(CLX_PROP_CLASS => (!(isset($get_flds[$i]['field_required']) ? $get_flds[$i]['field_required'] : false))?'prompt':'promptrequired'));
                $pop = new htmlSelect($get_flds[$i]['field_name']);
                foreach($get_flds[$i]['list_items'] as $key=>$val){
                    $pop->addItem($val, $key, ($get_flds[$i]['field_value'] == $key));
                }
                $table->addCell($pop->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                break;
            case 'datetime':
                $table->addDate($errmsg, $get_flds[$i]['field_label'], $get_flds[$i]['field_name'], $get_flds[$i]['field_value'], $get_flds[$i]['field_length'], $get_flds[$i]['field_maxlength'], $get_flds[$i]['field_required'], true);
                break;
            case 'file':
                $table->addFile($errmsg, $get_flds[$i]['field_label'], $get_flds[$i]['field_name'], $get_flds[$i]['field_value'], $get_flds[$i]['field_length'], $get_flds[$i]['field_maxlength'], $get_flds[$i]['field_required']);
                break;
            case 'yesno':
                $table->addYesNo($get_flds[$i]['field_label'], $get_flds[$i]['field_name'], CLX_NUM_ZERO+$get_flds[$i]['field_value'], ($get_flds[$i]['field_value']=='0' ? 1 : 0));
                break;
            case 'label':
                if(isset($get_flds[$i]['field_value'])) {
                    $table->addCell((isset($get_flds[$i]['field_label']) ? $get_flds[$i]['field_label'] : CLX_CHAR_EMPTY_STRING), array(CLX_PROP_CLASS => 'prompt'));
                    $table->addCell($get_flds[$i]['field_value'], array(CLX_PROP_CLASS => CLX_CLASS_DATA));
                } else {
                    $table->addCell($get_flds[$i]['field_label'], array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => $tableWidth));
                }
                break;
            default:
                $table->addField($errmsg, $get_flds[$i]['field_label'], $get_flds[$i]['field_name'], $get_flds[$i]['field_value'], $get_flds[$i]['field_length'], $get_flds[$i]['field_maxlength'], $get_flds[$i]['field_required']);
                break;
        }
    }
    if($double_confirm) {
        $table->addYesNo(dict('GEN_LBL_CONTINUE'), 'yesno', CLX_NUM_ZERO, CLX_NUM_ONE);
    } else {
        $form->addArgument('yesno', '1');
    }
    $table->addCell('&nbsp;', array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => $tableWidth));
    $form->addContents($table->source());
    $buttons = CLX_CHAR_EMPTY_STRING;
    //$onclick = '$(\'#confirm\').val(\'%confirm_val%\');setFormAction(\''.$form->getProp('id').'\',\''.UserRequest::$request['ac'].'\')';
    $onclick = 'document.getElementsByName('. singleQuote('confirm') . ')[0].value=' . singleQuote('%confirm_val%') . ';setFormAction(' . singleQuote($form->getProp('id')) . ',' . singleQuote(UserRequest::$request['ac']) . ')';
    $table = new htmlTable($tableWidth);
    $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
    /*
     * GEN_LBL_WIZ_PREV
     * Back
     * Anterior
     *
     * GEN_LBL_WIZ_FWRD
     * Next
     * Siguiente
     */
    if($get_flds['confirm']['field_value'] != '0') {
        //$c = new htmlSubmit(dict('GEN_LBL_WIZ_PREV'), 'name', 'SUBMIT_2');
        $c = htmlButton::getButton('submit', dict('GEN_LBL_WIZ_PREV'), array('action' => '', 'name', 'SUBMIT_2', 'form' => $form->getProp(CLX_PROP_ID)));
        $c->setProp('onclick', str_replace('%confirm_val%', (-1+$get_flds['confirm']['field_value']), $onclick ));
        $buttons .= $c->source();
    }
    //$c = new htmlSubmit(dict($finish_screen ? 'GEN_LBL_WIZ_FINISH' : 'GEN_LBL_WIZ_FWRD'));
    $c = htmlButton::getButton('submit', dict($finish_screen ? 'GEN_LBL_WIZ_FINISH' : 'GEN_LBL_WIZ_FWRD'), array('action' => '', 'form' => $form->getProp(CLX_PROP_ID)));
    $c->setProp('onclick', str_replace('%confirm_val%', (1+$get_flds['confirm']['field_value']), $onclick ));
    $buttons .= $c->source();
    $c = new htmlButtonCloseWindow (dict('GEN_LBL_CANCEL'));
    $buttons .= $c->source();
    $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => $tableWidth));
    $form->addContents($table->source());
    return ($form->source() . $js_code);
}

class MarkCampButtonCloseWindow extends htmlButton {
    function __construct($title, $url_add) {
        $js_onclick = $url_add . 'closeWindow();';
        parent::__construct($title, 'onclick', $js_onclick);
    }
}

function popup_form_Finish($msg, $url_parent = '') {
    $form = popup_form_init();
    $tableWidth = CLX_NUM_TWO;
    $table = new htmlTable($tableWidth);
    $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
    if(is_array($msg[0])) {
        $table->addCell($msg[0][0], array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => $tableWidth));
        $table->addCell($msg[0][1], array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => $tableWidth));
    } else {
        $table->addCell($msg[0], array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => $tableWidth));
    }
    $table->addCell('&nbsp;', array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => $tableWidth));
    for($i=CLX_NUM_ONE; $i<count($msg); $i++) {
        if($msg[$i] == CLX_CHAR_EMPTY_STRING) $msg[$i] = '&nbsp;';
        $table->addCell($msg[$i], array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => $tableWidth));
    }
    $table->addCell('&nbsp;', array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => $tableWidth));
    $form->addContents($table->source());
    $buttons = CLX_CHAR_EMPTY_STRING;
    $table = new htmlTable($tableWidth);
    $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
    $ibsMode = (isset($_SESSION['ibslog']) && $_SESSION['ibslog'] == '1');
    if($ibsMode) {
        $c = new htmlButtonCloseWindow (dict('GEN_LBL_CLOSEWINDOW'));
    } else {
        $c = new MarkCampButtonCloseWindow (dict('GEN_LBL_CLOSEWINDOW'), $url_parent);
    }
    $buttons .= $c->source();
    $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => $tableWidth));
    $form->addContents($table->source());
    return $form->source();
}

function popup_form_init($method = 'post', $vars_to_set = array()) {
    $form = new htmlForm(CLX_PROP_ACTION, 'pop.php', 'method', $method);
    $hidden_vars = UserRequest::$get;
    if(count($hidden_vars) == 0) {
        if(isset(UserRequest::$post['to'])) { $hidden_vars['to'] = UserRequest::$post['to']; }
        if(isset(UserRequest::$post['ac'])) { $hidden_vars['ac'] = UserRequest::$post['ac']; }
        if(isset(UserRequest::$post['wind'])) { $hidden_vars['wind'] = UserRequest::$post['wind']; }
        if(isset(UserRequest::$post['it'])) { $hidden_vars['it'] = UserRequest::$post['it']; }
    }
    foreach($hidden_vars as $key=>$val) {
        if(isset($vars_to_set[$key])) {
            // Override value passed in parameter
            $form->addArgument($key,$vars_to_set[$key]);
        } else {
            // Preserve previous value
            $form->addArgument($key,$val);
        }
    }
    return $form;
}

//---------------------------------------------------------------------
//---------------------------------------------------------------------
//---------------------------------------------------------------------

function CEML_setCreationData(&$record) {
    $record['CAMPSECTION_STATUS'] = 'IDLE';
}

function CEML_init(&$record) {
    if (empty($record['CEML_OPTOUT_MSG'])) {
        $record['CEML_OPTOUT_MSG']=get_def_optout_msg();
    }
}
/**
 * Devuelve el valor por defecto para el Mensaje de Unsubscribe
 * @return type string
 */
function get_def_optout_msg() {
    // Mensaje de Unsubscribe por defecto: <p><center><a href="<-unsubcribe->" target="_blank">Unsubscribe</a></center></p>
    return get_def_company_param('MARK_CAMP_OPTOUT_MSG', '<p><center><a href="<-unsubcribe->" target="_blank">Unsubscribe</a></center></p>');
}

/**
 * Devuelve el valor de un parametro general de nombre $paraName, y si no lo encuentra devuelve un valor por defecto especificado en $paraDefVal
 * @param string $paraName
 * @param string $paraDefVal
 * @return type string
 */
function get_def_company_param($paraName, $paraDefVal) {
    $response = companyParameter($paraName);
    if(is_null($response) || trim($response) == CLX_CHAR_EMPTY_STRING) {
        $response = $paraDefVal;
    }
    return $response;
}

function CEML_execute($operation_type = 'START', $delivery_date = '') {
    $contents = CLX_CHAR_EMPTY_STRING;
    $cemlname = tableName('CEML'); //CEML 	CAMPSEC_EMAIL
    $PRSC = getTool('PRSC');
    $prscname = $PRSC->tablename; //PRSC 	Process schedule
    $idlist = getIdlist();
    if (empty($idlist))
        $idlist = array(CLX_NUM_ZERO);
    $rs = ClxCommon::$db->getRecords($cemlname, 'ID IN (' . toString($idlist) . ')', 'DELETED=0');
    //Load new libreries
    while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
        if ($r['CAMPSECTION_STATUS'] === 'END' || $r['CAMPSECTION_STATUS'] === 'ERROR') {
            //en caso de reejecutar enviadas reenvia todo
            $r['CAMPSECTION_STATUS'] = 'IDLE';
        }
        if($operation_type == 'STOP'){
            //Detiene la ejecución
            ClxCommon::$db->updateRecord($cemlname, array('CAMPSECTION_STATUS'=>'END', 'OPERATION_TYPE'=>$operation_type, 'CEME_ID' => null), 'ID=' . singleQuote($r['ID']));
        } else {
            switch ($r['CAMPSECTION_STATUS']) {
                case 'IDLE'://Start it
                    //Set Process engine to send all mails
                    if (ClxCommon::$db->oneExistsRecords($prscname, 'IDCODE = ' . singleQuote('MAILCAMP')) == CLX_NUM_ZERO) {
                        $contents.=warning(dict('GEN_ERR_MARKNOPROC'));
                        continue 2;
                    }
                    //test if templates are correct
                    if (ClxCommon::$db->oneExistsRecords('CLX_UI_TEMPLATES', 'IDCODE=' . singleQuote($r['TEMPLATE_CODE'])) == CLX_NUM_ZERO) {
                        $contents.=warning(dict('GEN_ERR_MARKNOHTMLTEMP'));
                        continue 2;
                    }
                    // Se asigna la fecha/hora de envío. Si se dejó en blanco, asume 'now' (enviar ahora mismo)
                    if(trim($delivery_date) === CLX_CHAR_EMPTY_STRING) {
                        $delivery_date = 'now';
                    }
                    $delivery_date = xFormat::date($delivery_date,'Y-m-d H:i:s');
                    // Se asigna el tipo de operación en la sección de Email de la campaña
                    ClxCommon::$db->updateRecord($cemlname, array('CAMPSECTION_STATUS'=>'WORK', 'OPERATION_TYPE'=>$operation_type, 'DELIVERY_DATE' => $delivery_date), 'ID = ' . singleQuote($r['ID']));
                    // Modalidad de agendamiento: 1=Agendarlo mediante el motor de procesos principal, 0=No agendar mediante el motor de procesos principal (tiene un CRON independiente)
                    $mark_camp_sched_mode = get_def_company_param('MARK_CAMP_SCHED_MODE', '1');
                    if($mark_camp_sched_mode === '1') {
                        // Para pasar el parametro OPERATION_TYPE para diferenciar 'Ejecución' ('START') de 'Continuar Ejecución' ('CONTINUE')
                        $schedule_params = array('OPERATION_TYPE' => $operation_type);
                        $PRSC->runScheduleOneTimeNow('MAILCAMP', $schedule_params);
                    }
                    break;
                default:
                    break;
            }//end switch
        }
    }//end while
    return $contents;
}

/**
 * start send email process
 */

ClxCommon::$cached['PHPMail'] = false;
ClxCommon::$cached['done_set_phpmail_default'] = false;

function PHPMail_lib_load(&$sched_params) {
    // Se implementa PHPMailer para poder usar servicios con servidor SSL como office365.com
    ClxCommon::$cached['done_set_phpmail_default'] = false;
    $sched_params['MAIL_OUT_DIR_PHPMAIL'] = get_def_company_param('MAIL_OUT_DIR_PHPMAIL', '..');
    $sched_params['MAIL_OUT_EXCEPTIONS_PHPMAIL'] = get_def_company_param('MAIL_OUT_EXCEPTIONS_PHPMAIL', '0');
    $sched_params['MAIL_OUT_INSTANCE_EM_PHPMAIL'] = get_def_company_param('MAIL_OUT_INSTANCE_EM_PHPMAIL', '1');
    if(file_exists($sched_params['MAIL_OUT_DIR_PHPMAIL'].'/PHPMailer/class.phpmailer.php')){
        require_once $sched_params['MAIL_OUT_DIR_PHPMAIL'].'/PHPMailer/class.phpmailer.php';
        //$exceptions = true;   // Para que se detenga con un PHP Fatal Error y muestre el Stack de llamadas + mensaje de error
        //$exceptions = false;    // Para que NO se detenga con un PHP Fatal Error y devuelva mensaje de error
        $exceptions = ($sched_params['MAIL_OUT_EXCEPTIONS_PHPMAIL'] === '1');    // False: para que NO se detenga con un PHP Fatal Error y devuelva mensaje de error
        ClxCommon::$cached['PHPMail'] = new PHPMailer($exceptions);
        ClxCommon::$cached['PHPMail']->SMTPKeepAlive = true;
    }else{
        ClxCommon::$cached['PHPMail'] = false;
    }
}

function PHPMail_lib_unload() {
    if(ClxCommon::$cached['PHPMail'] != false){
        ClxCommon::$cached['PHPMail']->SmtpClose();
    }
}

function get_server_info() {
    return 'SERVER: ' . (isset(UserRequest::$server['SERVER_ADDR']) && UserRequest::$server['SERVER_ADDR'] != CLX_CHAR_EMPTY_STRING ? UserRequest::$server['SERVER_ADDR'] : (isset(UserRequest::$server['LOCAL_ADDR']) && UserRequest::$server['LOCAL_ADDR'] != CLX_CHAR_EMPTY_STRING ? UserRequest::$server['LOCAL_ADDR'] : kWebSite)) . ' | ' . str_replace('.php', CLX_CHAR_EMPTY_STRING, UserRequest::$server['PHP_SELF']) . ' [' . kDatabaseName . ']';
}

function email_go() {
    $cemlname = tableName('CEML'); //CEML 	CAMPSEC_EMAIL
    // FS-CR Hace autocommit desde el principio para evitar los Dead Locks
    ClxCommon::$db->setAutocommit(true);
    // PHPMail - Carga la libreria
    PHPMail_lib_load($sched_params);
    // Verifica ecitencia de índices clave
    $content = CLX_CHAR_EMPTY_STRING;
    //$content .= check_create_index('MARK_CAMPSEC_EMAIL_RES', 'CEMR_EMAIL', 'EMAIL');
    //$content .= check_create_index('MARK_CAMPSEC_EMAIL_EXE', 'CEME_CEML_CODE', 'CEML_CODE');
    // Busca secciones de Email pendientes por ser ejecutadas
    $sql = 'SELECT CEML.* FROM ' . $cemlname . ' CEML WHERE CEML.CAMPSECTION_STATUS=' . singleQuote('WORK') . ' AND CEML.DELETED=0 AND (CEME_ID IS NULL OR CEML.CEME_ID=0) AND DELIVERY_DATE<=' . singleQuote(adodb_date('Y-m-d H:i:s')) . ' ORDER BY DELIVERY_DATE ASC';
    $rs = ClxCommon::$db->executeQuery($sql);
    while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
        $sched_params['OPERATION_TYPE'] = $r['OPERATION_TYPE']; // Toma la operación del registro de CEML
        // Se pasa los parámetros del cronograma MAILCAMP, de tal forma de conocer el valor del parametro OPERATION_TYPE,
        // para diferenciar 'Ejecución' ('START') de 'Continuar Ejecución' ('CONTINUE')
        CEML_execute_real($r, $sched_params, $content);
        $content = CLX_CHAR_EMPTY_STRING;
    }
    PHPMail_lib_unload();
}

function email_go_monitor($sched_params){
    $prmts = array();
    // Para poder registrar Excepciones de la ejecución del Cronograma
    if(!class_exists('proc_eng_params'))
        includeCodeLib('PROC_2');
    $prmts['o_proc_eng_params'] = new proc_eng_params($sched_params);
    // 2016-10-11 FS-CR PHPMail - Carga la libreria
    PHPMail_lib_load($sched_params);
    // Tipo de Emailer
    $prmts['MARK_CAMP_MAIL_TYPE'] = get_def_company_param('MAIL_OUT_TYPE', '1');
    // Parametro general para saber cada cuánto tiempo debe enviar un recordatorio de que la campaña está en ejecución
    $mark_camp_remindr_lapse = CLX_NUM_ZERO+get_def_company_param('MARK_CAMP_REMINDR_LAPSE', 5); // 5 horas por defecto
    // Parametro general para saber cada cuánto tiempo debe enviar un recordatorio de que la campaña se detuvo anormalmente
    $mark_camp_remindr_abend = CLX_NUM_ZERO+get_def_company_param('MARK_CAMP_REMINDR_ABEND', $mark_camp_remindr_lapse); // asume el mismo valor del parametro MARK_CAMP_REMINDR_LAPSE
    $sql = 'SELECT CAMP.IDCODE CAMP_IDCODE, CAMP.IDNAME CAMP_IDNAME, CEML.IDCODE CEML_IDCODE, BEAC.EMAIL BEAC_EMAIL, BEAC.IDNAME BEAC_IDNAME, BEAC.SMTP_HOSTNAME BEAC_SMTP_HOSTNAME, BEAC.SMTP_PORT BEAC_SMTP_PORT, BEAC.SMTP_USERNAME BEAC_SMTP_USERNAME, BEAC.SMTP_PASSWORD BEAC_SMTP_PASSWORD, BEAC.SMTP_AUTHENTICATE BEAC_SMTP_AUTHENTICATE, BEAC.SMTP_SECURE BEAC_SMTP_SECURE, CEME.ID CEME_ID, CEME.LAST_REMINDR_DT CEME_LAST_REMINDR_DT, CEME.LAST_EMAILS_PROC CEME_LAST_EMAILS_PROC, CEME.EMAILS_PROC CEME_EMAILS_PROC, PRLO.ID PRLO_ID, PRLO.PROC_STATUS PRLO_PROC_STATUS, PRLO.BATCH_PID PRLO_BATCH_PID, PRLO.SDATE PRLO_SDATE, PRLO.EDATE PRLO_EDATE, PRLO.SCHEDULECODE PRLO_SCHEDULECODE FROM MARK_CAMPAIGNS CAMP, MARK_CAMPSEC_EMAIL CEML LEFT JOIN BASE_EMAIL_ACCOUNTS BEAC ON BEAC.ID=CEML.CAMPSECTION_FROM LEFT JOIN MARK_CAMPSEC_EMAIL_EXE CEME ON CEME.ID=CEML.CEME_ID LEFT JOIN CLX_PR_PROC_LOGS PRLO ON PRLO.ID=CEME.PRLO_ID WHERE CEML.CAMPAIGNCODE = CAMP.IDCODE AND CEML.CAMPSECTION_STATUS=' . singleQuote('WORK') . ' AND CEML.DELETED=0 AND CEML.CEME_ID IS NOT NULL AND CEML.CEME_ID <> 0';
    $rs = ClxCommon::$db->executeQuery($sql);
    while(($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE))){
        echo '<br>' . dict('GEN_LBL_MARK_CAMP', $r['CAMP_IDNAME'].' ['.$r['CAMP_IDCODE'].']') . ': ';
        $msgbody = CLX_CHAR_EMPTY_STRING;
        $update_last_remindr = false;
        if(is_null($r['CEME_ID'])) {
            // No encontro el registro CEME de la sección de envío
            /*
             * GEN_LBL_MARK_CAMP_00100
             * Inconsistency ERROR - Delivery section row ID "^1" not found [CEME Table]
             * ERROR de inconsistencia - No encontró el registro con ID "^1" de la sección de envío [Tabla CEME]
             */
            //$msgbody = '<BR>' . 'ERROR de inconsistencia - No encontro el registro CEME de la sección de envío: ' . $r['CEME_ID'];
            $msgbody = '<BR>' . dict('GEN_LBL_MARK_CAMP_00100', $r['CEME_ID']);
        } elseif(is_null($r['PRLO_ID'])) {
            // No encontro el registro PRLO de bitácora de cronograma
            /*
             * GEN_LBL_MARK_CAMP_00110
             * Inconsistency ERROR - Schedule log row ID "^1" not found [PRLO Tool]
             * ERROR de inconsistencia - No encontró el registro con ID "^1" en la bitácora de cronograma [Tool PRLO]
             */
            //$msgbody = '<BR>' . 'ERROR de inconsistencia - No encontro el registro PRLO de bitácora de cronograma: ' . $r['PRLO_ID'];
            $msgbody = '<BR>' . dict('GEN_LBL_MARK_CAMP_00110', $r['PRLO_ID']);
        } elseif($r['PRLO_PROC_STATUS'] != 'RUN') {
            // Inconsistency: batch process status is not RUN
            /*
             * GEN_LBL_MARK_CAMP_00120
             * Inconsistency ERROR - Status "^1" of schedule "^2" is not "RUN"
             * ERROR de inconsistencia - El Status "^1" del cronograma "^2" no es "RUN"
             */
            //$msgbody .= '<BR>' . 'ERROR de inconsistencia - El status del cronograma no es RUN: ' . $r['PRLO_PROC_STATUS'];
            $msgbody .= '<BR>' . dict('GEN_LBL_MARK_CAMP_00120', $r['PRLO_PROC_STATUS'], $r['PRLO_SCHEDULECODE']);
        } elseif(is_null($r['PRLO_BATCH_PID'])) {
            // Inconsistency: batch process id is NULL
            /*
             * GEN_LBL_MARK_CAMP_00130
             * Inconsistency ERROR - Excecution PID of schedule "^1" is null
             * ERROR de inconsistencia - El PID de ejecución del Cronograma "^1" es nulo
             */
            //$msgbody .= '<BR>' . 'ERROR de inconsistencia - el PID del proceso es nulo';
            $msgbody .= '<BR>' . dict('GEN_LBL_MARK_CAMP_00130', $r['PRLO_SCHEDULECODE']);
        } else {
            $response = ver_running_pid($r['PRLO_BATCH_PID'], $sched_params);
            if($response === '1') {
                // Process is still running
                if(is_null($r['CEME_LAST_REMINDR_DT']) || trim($r['CEME_LAST_REMINDR_DT']) === CLX_CHAR_EMPTY_STRING) {
                    $r['CEME_LAST_REMINDR_DT'] = $r['PRLO_SDATE'];
                }
                // Verifica la cantidad de horas transcurridas desde el último recordatorio
                if( ( dateDifference(date('Y-m-d H:i:s'), $r['CEME_LAST_REMINDR_DT'])/CLX_NUM_60 ) > $mark_camp_remindr_lapse) {
                    /*
                     * GEN_LBL_MARK_CAMP_00140
                     * Campaign "^1" is still running...
                     * La campaña "^1" aun está en ejecución...
                     */
                    $msgbody .= '<BR>' . dict('GEN_LBL_MARK_CAMP_00140', $r['CAMP_IDCODE']);
                    if($r['CEME_LAST_EMAILS_PROC'] === $r['CEME_EMAILS_PROC']) {
                        /*
                         * GEN_LBL_MARK_CAMP_00160
                         * And it seems to do Nothing because it's still in ^1 records processed since: ^2
                         * Y al parecer NO está haciendo nada, porque sigue con ^1 registros procesados, tal como estaba en: ^2
                         */
                        $msgbody .= '<BR>' . dict('GEN_LBL_MARK_CAMP_00160', $r['CEME_LAST_EMAILS_PROC'], $r['CEME_LAST_REMINDR_DT']);
                    } else {
                        /*
                         * GEN_LBL_MARK_CAMP_00170
                         * Until now, it has ^1 records processed.
                         * Lleva ^1 registros procesados hasta ahora.
                         */
                        $msgbody .= '<BR>' . dict('GEN_LBL_MARK_CAMP_00170', $r['CEME_EMAILS_PROC']);
                    }
                    $update_last_remindr = true;
                }
            } else {
                // Process stopped...
                if(is_null($r['CEME_LAST_REMINDR_DT']) || trim($r['CEME_LAST_REMINDR_DT']) === CLX_CHAR_EMPTY_STRING ||
                   (dateDifference(date('Y-m-d H:i:s'), $r['CEME_LAST_REMINDR_DT'])/CLX_NUM_60) > $mark_camp_remindr_abend) {
                    /*
                     * GEN_LBL_MARK_CAMP_00150
                     * ERROR - Process PID "^2" associated with the "^1" schedule is not running.<BR>Please Stop campaign "^3" and Resume it.
                     * ERROR - El proceso PID "^2" asociado al Cronograma "^1" se detuvo.<BR>Favor detener la campaña "^3" y Reanudar su ejecución.
                     */
                    $msgbody .= dict('GEN_LBL_MARK_CAMP_00150', $r['PRLO_SCHEDULECODE'], $r['PRLO_BATCH_PID'], $r['CAMP_IDCODE']);
                    $update_last_remindr = true;
                }
            }
        }
        // Envia correo de recordatorio o error al dueño de la campaña
        if($msgbody === CLX_CHAR_EMPTY_STRING) {
            echo '...';
        } else {
            $msgbody = str_replace('\\"', '"', $msgbody);
            $msgbody .= '<br><br>' . get_server_info();
            echo '<br>Sending email to: ' . get_name_email($r['BEAC_IDNAME'], $r['BEAC_EMAIL']);
            echo '<br>' . $msgbody;
            echo '<br>** Result: ';
            $send_result = send_email_to_owner($prmts, $r, $msgbody, CLX_CHAR_EMPTY_STRING);
            echo $send_result;
            if(substr($send_result, CLX_NUM_ZERO, CLX_NUM_FIVE) == 'ERROR') {
                error_trap_register($send_result, $send_result, __LINE__, $prmts);
            }
        }
        // Actualiza ultima fecha/hora de recordatorio enviado
        if($update_last_remindr === true) {
            $record = array();
            $record['LAST_REMINDR_DT'] = date('Y-m-d H:i:s');
            $record['LAST_EMAILS_PROC'] = $r['CEME_EMAILS_PROC'];
            ClxCommon::$db->updateRecord('MARK_CAMPSEC_EMAIL_EXE', $record, 'ID = '.$r['CEME_ID']);
        }
    }
    PHPMail_lib_unload();
}

/*
 * Date/time difference
 * @param String $date_1 First date/time
 * @param String $date_2 Second date/time
 * @param String $differenceFormat Format of returning value. Defaul: %i = Minutes, other possible values: %h = Hours, %s = Seconds, %d Days
 */
function dateDifference($date_1, $date_2, $differenceFormat = '%i') {
    // Reference: http://php.net/manual/es/function.date-diff.php
    $datetime1 = date_create($date_1);
    $datetime2 = date_create($date_2);
    $interval = date_diff($datetime1, $datetime2);
    return $interval->format($differenceFormat);
}

/**
 * Create indexes if they doesn't exist
 * @param String $tablename Table name
 * @param String $indexname Index name
 * @param String $fieldname Index field name
 * @retuen String Verbouse text of index creation or '' if index creation isn't necessary
 */
function check_create_index($tablename, $indexname, $fieldname) {
    if (ClxCommon::$db->hasIndex($tablename, $fieldname, $indexname)) {
        return CLX_CHAR_EMPTY_STRING;
    }
    ClxCommon::$db->createIndex($tablename, $fieldname, $indexname);
    return 'Creating Index [' . $indexname . '] : ' . $tablename . '.' . $fieldname . '<br>';
}

/**
 * Send notification email to owner using CEME record
 * @param Array $prmts General working parameters
 * @param Integer $ceme_id ID of CEME record
 * @return String Email sent status
 */
function send_email_to_owner_from_ceme(&$prmts, $ceme_id) {
    $DBLT = getTool('DBLT');
    $sql = 'SELECT CEME.ID, CAMP.IDCODE CAMP_IDCODE, CAMP.IDNAME CAMP_IDNAME, CEML.IDCODE CEML_IDCODE, CEML.IDNAME CEML_IDNAME, CEML.SEND_ALL_EMAILS, CEME.LOG_FILE_NAME, CEME.OPERATION_TYPE, CEME.SDATE, CEME.EDATE, CEME.CAMPSECTION_STATUS, CEME.PROCESS_MSG, BEAC.EMAIL BEAC_EMAIL, BEAC.IDNAME BEAC_IDNAME, BEAC.SMTP_HOSTNAME BEAC_SMTP_HOSTNAME, BEAC.SMTP_PORT BEAC_SMTP_PORT, BEAC.SMTP_USERNAME BEAC_SMTP_USERNAME, BEAC.SMTP_SECURE BEAC_SMTP_SECURE, BEAC.SMTP_PASSWORD BEAC_SMTP_PASSWORD, BEAC.SMTP_AUTHENTICATE BEAC_SMTP_AUTHENTICATE FROM MARK_CAMPSEC_EMAIL CEML LEFT JOIN BASE_EMAIL_ACCOUNTS BEAC ON BEAC.ID=CEML.CAMPSECTION_FROM, MARK_CAMPSEC_EMAIL_EXE CEME, MARK_CAMPAIGNS CAMP WHERE CEML.CAMPAIGNCODE=CAMP.IDCODE AND CEML.IDCODE=CEME.CEML_CODE AND CEME.ID='.$ceme_id;
    $rs = ClxCommon::$db->executeQuery($sql);
    $r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE);
    // Statistics report text
    $output =
        '<br><br>*** '. dict('GEN_LBL_METRICS') .' ***' .
        '%general_info%' .
        '<br><br>' . dict('GEN_LBL_QUERIES') . ':' .
        '<br>' . dict('GEN_LBL_REC_TOBE_PROCESSED') . ': ' . $prmts['QUERIES_email_to_be_processed'] .
        '<br>' . dict('GEN_LBL_REC_EFFT_PROCESSED') . ': ' . $prmts['QUERIES_email_processed'] .
        '<br>' . dict('GEN_MAIL_SENT') . ': ' . $prmts['QUERIES_email_sent'].
        '<br>SQL - ' . dict('GEN_LBL_LAPSE_SECS') . ': ' . $prmts['QUERIES_lapse_secs_sql'].
        '<br>SMTP - ' . dict('GEN_LBL_LAPSE_SECS') . ': ' . $prmts['QUERIES_lapse_secs_smtp'] .
        '<br>' . dict('GEN_LBL_PROCESSES') . ' - ' . dict('GEN_LBL_LAPSE_SECS') . ': ' . $prmts['QUERIES_lapse_secs_process'] .
        '<br><br>' . dict('GEN_LBL_TARGETS') . ':' .
        '<br>' . dict('GEN_LBL_REC_TOBE_PROCESSED') . ': ' . $prmts['TARGETS_email_to_be_processed'] .
        '<br>' . dict('GEN_LBL_REC_EFFT_PROCESSED') . ': ' . $prmts['TARGETS_email_processed'] .
        '<br>' . dict('GEN_MAIL_SENT') . ': ' . $prmts['TARGETS_email_sent'].
        '<br>SQL - ' . dict('GEN_LBL_LAPSE_SECS') . ': ' . $prmts['TARGETS_lapse_secs_sql'].
        '<br>SMTP - ' . dict('GEN_LBL_LAPSE_SECS') . ': ' . $prmts['TARGETS_lapse_secs_smtp'] .
        '<br>' . dict('GEN_LBL_PROCESSES') . ' - ' . dict('GEN_LBL_LAPSE_SECS') . ': ' . $prmts['TARGETS_lapse_secs_process'] .
        '<br><br>' . dict('GEN_LBL_TOTALES') . ':' .
        '<br>' . dict('GEN_LBL_REC_TOBE_PROCESSED') . ': ' . ($prmts['QUERIES_email_to_be_processed']+$prmts['TARGETS_email_to_be_processed']).
        '<br>' . dict('GEN_LBL_REC_EFFT_PROCESSED') . ': ' . ($prmts['QUERIES_email_processed']+$prmts['TARGETS_email_processed']) .
        '<br>' . dict('GEN_MAIL_SENT') . ': ' . ($prmts['QUERIES_email_sent']+$prmts['TARGETS_email_sent']) .
        '<br>SQL - ' . dict('GEN_LBL_LAPSE_SECS') . ': ' . ($prmts['QUERIES_lapse_secs_sql']+$prmts['TARGETS_lapse_secs_sql']).
        '<br>SMTP - ' . dict('GEN_LBL_LAPSE_SECS') . ': ' . ($prmts['QUERIES_lapse_secs_smtp']+$prmts['TARGETS_lapse_secs_smtp']) .
        '<br>' . dict('GEN_LBL_PROCESSES') . ' - ' . dict('GEN_LBL_LAPSE_SECS') . ': ' . ($prmts['QUERIES_lapse_secs_process']+$prmts['TARGETS_lapse_secs_process']);
    if(empty($r)) {
        // No encontró la sección...
        // Throw statistics (with error NO_CEME)
        markcamp_echo_and_log_write($prmts, str_replace('%general_info%', '<br><br>ATTENTION: ERROR!!! NO_CEME', $output) );
        return 'NO_CEME';
    }
    // Finish Statistics
    markcamp_echo_and_log_write( $prmts, str_replace('%general_info%',
        '<br><br>' . dict('GEN_LBL_MARK_CAMP', $r['CAMP_IDNAME'].' ['.$r['CAMP_IDCODE'].']') .
        '<br>' . dict('GEN_LBL_MARK_CAMPSEC', $r['CEML_IDNAME'].' ['.$r['CEML_IDCODE'].']') .
        '<br>' .dict('GEN_LBL_OPERATION_TYPE') . ': ' . $DBLT->getListItem('EMOT', $r['OPERATION_TYPE'], 2) .
        '<br>'. dict('GEN_LBL_SIMULATION_MODE') . ': ' . ($r['SEND_ALL_EMAILS'] ? dict('GEN_LBL_NO') : dict('GEN_LBL_YES')) .
        '<br>' . dict('GEN_LBL_DURATION') . ': ' . $r['SDATE'] . ' > ' . $r['EDATE'] . ' = ' . dateDifference($r['EDATE'], $r['SDATE'], $prmts['date_diff_fmt'])
        , $output)
    );
    // Construye el cuerpo del mensaje
    $output =
        dict('GEN_LBL_MARK_CAMP', $r['CAMP_IDNAME'].' ['.$r['CAMP_IDCODE'].']') . '<br>' .
        dict('GEN_LBL_MARK_CAMPSEC', $r['CEML_IDNAME'].' ['.$r['CEML_IDCODE'].']') . '<br>' .
        dict('GEN_LBL_OPERATION_TYPE') . ': ' . $DBLT->getListItem('EMOT', $r['OPERATION_TYPE'], 2) . '<br>' .
        dict('GEN_LBL_RESULT') . ': ' . ($r['PROCESS_MSG']===CLX_CHAR_EMPTY_STRING ? dict('GEL_LBL_OPER_COMP_SUCCESS') : $r['PROCESS_MSG']) . '<br>' .
        dict('GEN_LBL_STATUS') . ': ' . $r['CAMPSECTION_STATUS'] . ($prmts['RUN_FLAG'] ? CLX_CHAR_EMPTY_STRING : ' - BREAK CONDITION') . '<br>' .
        '<br>*** '. dict('GEN_LBL_METRICS') .' ***<br>' .
        dict('GEN_LBL_TARGETS') . ': ' . dict('GEN_MAIL_SENT') . ': ' . $prmts['TARGETS_email_sent'] . ', ' . dict('GEN_LBL_PROCESSED') . ': ' . $prmts['TARGETS_email_processed'] . '<br>' .
        dict('GEN_LBL_QUERIES') . ': ' . dict('GEN_MAIL_SENT') . ': ' . $prmts['QUERIES_email_sent'] . ', ' . dict('GEN_LBL_PROCESSED') . ': ' . $prmts['QUERIES_email_processed'] . '<br>' .
        dict('GEN_LBL_DURATION') . ': ' . $r['SDATE'] . ' > ' . $r['EDATE'] . ' = ' . dateDifference($r['EDATE'], $r['SDATE'], $prmts['date_diff_fmt']) . '<br>' .
        '<br>'. dict('GEN_LBL_LOG_FILE',  $r['LOG_FILE_NAME']) . '<br>' .
        '<br>' . get_server_info() . '<br>';
    // Envia mensaje al dueño de la campaña
    return send_email_to_owner($prmts, $r, $output, CLX_CHAR_EMPTY_STRING);
}

/**
 * Send notification email to owner (raw)
 * @param Array $r CEME, CEML and CAMP tables SQL result
 * @param String $html_body Body of message
 * @param String $subject Subject of message
 * @return String Email sent status
 */
function send_email_to_owner(&$prmts, $r, $html_body, $subject) {
    // Toma el remitente de la cuenta de correo del sistema
    $from_rec = array();
    $maac_record = ClxCommon::$db->getRecord('CLX_MA_MAILACCOUNTS', 'SYSTEM_DEFAULT=1');
    if($maac_record) {
        $from_rec['IDNAME'] = $maac_record['IDNAME'];
        $from_rec['SMTP_HOSTNAME'] = $maac_record['OUT_HOSTNAME'];
        $from_rec['SMTP_PORT'] = $maac_record['OUT_PORT'];
        $from_rec['SMTP_AUTHENTICATE'] = $maac_record['OUT_AUTHENTICATE'];
        $from_rec['SMTP_USERNAME'] = $maac_record['OUT_USERNAME'];
        $from_rec['SMTP_PASSWORD'] = $maac_record['OUT_PASSWORD'];
        $from_rec['SMTP_SECURE'] = (isset($maac_record['SMTP_SECURE']) ? $maac_record['SMTP_SECURE'] : 0);
        $from_rec['EMAIL'] = $maac_record['EMAIL'];
        $prmts['send_email_to_owner_smtp_acc'] = 'System Email Account [' . $from_rec['IDNAME'] . ']';
    } else {
        // Si no hay cuenta de correo del sistema definida, el remitente es el mismo dueño de la campaña
        $from_rec['IDNAME'] = $r['BEAC_IDNAME'];
        $from_rec['SMTP_HOSTNAME'] = $r['BEAC_SMTP_HOSTNAME'];
        $from_rec['SMTP_PORT'] = $r['BEAC_SMTP_PORT'];
        $from_rec['SMTP_AUTHENTICATE'] = $r['BEAC_SMTP_AUTHENTICATE'];
        $from_rec['SMTP_USERNAME'] = $r['BEAC_SMTP_USERNAME'];
        $from_rec['SMTP_PASSWORD'] = $r['BEAC_SMTP_PASSWORD'];
        $from_rec['SMTP_SECURE'] = (isset($maac_record['BEAC_SMTP_SECURE']) ? $maac_record['BEAC_SMTP_SECURE'] : 0);
        $from_rec['EMAIL'] = $r['BEAC_EMAIL'];
        $prmts['send_email_to_owner_smtp_acc'] = 'Campaign Email Account [' . $from_rec['IDNAME'] . ']';
    }
    if($prmts['MARK_CAMP_MAIL_TYPE'] == '3' && ClxCommon::$cached['PHPMail'] == false) {
        return 'ERROR: PHPMail not started';
    }
    // Construye el asunto
    if($subject === CLX_CHAR_EMPTY_STRING) {
        $subject = 'CRM-' . dict('GEN_LBL_STATUS') . ' ' . dict('GEN_LBL_MARK_CAMP', $r['CAMP_IDNAME'].' ['.$r['CAMP_IDCODE'].']');
    }
    // El destinatario es el dueño de la campaña: $r['BEAC_EMAIL'], $r['BEAC_IDNAME']
    $subject = decode_string($subject);
    $text_body = str_replace('<br>', CLX_CHAR_NL, $html_body);
    $text_body = decode_tracercode($text_body);
    $html_body = decode_string($html_body);
    // Para que no envie los Attachments en el reporte al dueño de la campaña
    if(ClxCommon::$cached['done_set_phpmail_default']){
        ClxCommon::$cached['PHPMail']->clearAttachments();
    }
    $smtp_response = mark_camp_send_one_mail($prmts, $from_rec, array(), $r['BEAC_EMAIL'], $r['BEAC_IDNAME'], $subject, $text_body, $html_body, array());
    $prmts['send_email_to_owner_to'] = $r['BEAC_EMAIL'];
    if($smtp_response['error'] === false) {
        return 'OK';
    } else {
        return 'ERROR: ' . $smtp_response['errormsg'];
    }
}

/**
 * Send final email by SMTP server
 * @param Array $prmts General process parameters
 * @param Array $from_rec From record
 * @param Array $reply_rec Replay record
 * @param String $email Recipient email address
 * @param String $name Recipient name
 * @param String $subject Subject of message
 * @param String $text_body Body of message (text version)
 * @param String $html_body Body of message (html version)
 * @param Array $ar_attachments Attachments
 * @return Array Email sent status
 */
function mark_camp_send_one_mail($prmts, $from_rec, $reply_rec, $email, $name, $subject, $text_body, $html_body, $ar_attachments) {
    $response = array();
    $response['lapse_secs_smtp'] = 0;
    $response['errormsg'] = CLX_CHAR_EMPTY_STRING;
    $response['error'] = false;
    $response['mail_send_result'] = null;
    $to_w_name = get_name_email($name, $email);
    // Para corregir problema del mismo email destino en el 'Para' del mensaje de email
    // En vez de instanciar en Mail_mime al principio y colocarlo en el array de los parametros,
    // coloca en el array de parametros los attachments e instancia Mail_mime por cada mensaje enviado
    // create the mime instance
    $crlf = chr(CLX_NUM_13).chr(CLX_NUM_TEN);
    if($prmts['MARK_CAMP_MAIL_TYPE'] === '3') {
        $phpmailatt = array();  // 2016-10-11 FS-CR PHPMail
        foreach($ar_attachments as $ref => $val) {
            $phpmailatt[] = array('string' => $val['filecontents'], 'filename' => ((!empty($val['name']))?$val['name']:$val['filename']), 'encoding' => $val['encoding'], 'type' => $val['type']);
        }
    } else {
        // Build the headers...
        $headers = array('From' => fullemailaddress($from_rec),
            'To' => $to_w_name,
            'Reply-to' => fullemailaddress($reply_rec),
            'Subject' => $subject,
            'Organization' => kDefaultCompany,
            'Date' => date('r'),
            'Message-ID' => batch_id(),
            'X-Mailer' => 'clx-mail '.kSystemVersion,
            'X-Accept-Language' =>clx_language_lower_upper(kSystemLanguage));
        $mime = new Mail_mime($crlf);
        foreach($ar_attachments as $ref => $val) {
            $mime->addAttachment($val['filecontents'], $val['type'], $val['name'], false);
        }
        $mime->setTXTBody($text_body);
        $mime->setHTMLBody($html_body);
        $body = $mime->get();
        $hdrs = $mime->headers($headers);
    }
    $px = array();
    $px['host'] = $from_rec['SMTP_HOSTNAME'];      // - The server to connect. Default is localhost
    $px['port'] = CLX_NUM_25;      // - The port to connect. Default is 25
    if(isset($from_rec['SMTP_PORT']) && !empty($from_rec['SMTP_PORT'])) {
        $px['port'] = $from_rec['SMTP_PORT'];
    }
    $px['persist'] =  false; //- Indicates whether or not the SMTP connection should persist over multiple calls to the send() method.
    if($from_rec['SMTP_AUTHENTICATE']==1){
        $px['auth'] = true;     // - Whether or not to use SMTP authentication. Default is FALSE
        $px['username'] = $from_rec['SMTP_USERNAME'];  // - The username to use for SMTP authentication.
        $px['password'] = $from_rec['SMTP_PASSWORD'];  // - The password to use for SMTP authentication.
    }else{
        $px['auth'] = false;
    }
    // FS en PRD era:
    //$px["secure"] = (!empty($from_rec['SMTP_SECURE'])) ? 'tls' : '';
    if(!isset($from_rec['SMTP_SECURE']) || is_null($from_rec['SMTP_SECURE']) || trim($from_rec['SMTP_SECURE']) === CLX_CHAR_EMPTY_STRING) {
        // Por defecto asume servidor NO seguro
        $from_rec['SMTP_SECURE'] = CLX_NUM_ZERO;
    } else {
        $from_rec['SMTP_SECURE'] = CLX_NUM_ZERO+$from_rec['SMTP_SECURE'];
    }
    $px['secure'] = ($from_rec['SMTP_SECURE'] === CLX_NUM_ONE ? 'tls' : CLX_CHAR_EMPTY_STRING);
    // EMAIL SENT STATUS variables
    $response['error'] = false;
    $q123 = microtime_float();
    // 0=php mail(), 1=pear(smtp), 2=pear(mail), 3=PHPMailer
    switch($prmts['MARK_CAMP_MAIL_TYPE']) {
        case '0':
            $response['mail_send_result'] = mail($email, $subject, $text_body, 'From:'.$from_rec['EMAIL']);
            if($response['mail_send_result'] == false) {
                $response['error'] = true;
                $response['errormsg'] = '[CLX] Unknown error sending email';
            }
            break;
        case '1':   // Valor por defecto que se asigna a $prmts['MARK_CAMP_MAIL_TYPE'] cuando no existe el parametro general MAIL_OUT_TYPE
            $mail = &Mail::factory('smtp', $px);
            $response['mail_send_result'] = $mail->send($to_w_name, $hdrs, $body);
            if (PEAR::isError($response['mail_send_result'])) {
                $response['error'] = true;
                $response['errormsg'] = ($response['mail_send_result']->getMessage());
            }
            break;
        case '2':
            $mail = &Mail::factory('mail');
            $response['mail_send_result'] = $mail->send($to_w_name, $hdrs, $body);
            if (PEAR::isError($response['mail_send_result'])) {
                $response['error'] = true;
                $response['errormsg'] = ($response['mail_send_result']->getMessage());
            }
            break;
        case '3':
            // 2016-10-11 FS-CR PHPMail
            try{
                if(!ClxCommon::$cached['done_set_phpmail_default'] || $prmts['MAIL_OUT_INSTANCE_EM_PHPMAIL'] === '1'){
                    ClxCommon::$cached['done_set_phpmail_default'] = true;
                    $exceptions = ($prmts['MAIL_OUT_EXCEPTIONS_PHPMAIL'] === '1');    // False: para que NO se detenga con un PHP Fatal Error y devuelva mensaje de error
                    ClxCommon::$cached['PHPMail'] = new PHPMailer($exceptions);
                    ClxCommon::$cached['PHPMail']->Host = $px['host'];
                    ClxCommon::$cached['PHPMail']->Port = $px['port'];
                    ClxCommon::$cached['PHPMail']->IsSMTP();
                    ClxCommon::$cached['PHPMail']->SMTPSecure = $px['secure'];
                    ClxCommon::$cached['PHPMail']->SMTPAuth = $px['auth'];
                    ClxCommon::$cached['PHPMail']->Username = $px['username'];
                    ClxCommon::$cached['PHPMail']->Password = $px['password'];
                    if (!empty($reply_rec)) {
                       ClxCommon::$cached['PHPMail']->addReplyTo($reply_rec['EMAIL'], $reply_rec['IDNAME']);
                    }
                    ClxCommon::$cached['PHPMail']->SetFrom($from_rec['EMAIL'], $from_rec['IDNAME']);
                    //Attach an image file
                    foreach ($phpmailatt as $k=>$val) {
                        //ClxCommon::$cached['PHPMail']->AddStringAttachment($val['string'], $val['filename'], $val['encoding'], $val['type']);
                        ClxCommon::$cached['PHPMail']->AddStringAttachment($val['string'], $val['filename']);
                    }
                }
                if(!ClxCommon::$cached['PHPMail']->validateAddress($email)) {
                    $response['mail_send_result'] = false;
                    $response['error'] = true;
                    $response['errormsg'] = '[PHPMailer] Invalid E-mail address';
                } else {
                    ClxCommon::$cached['PHPMail']->addAddress($email, $name);
                    ClxCommon::$cached['PHPMail']->Subject = $subject;
                    if (ClxCommon::$cached['b_mark_camp_debug']) {
                        ClxCommon::$cached['PHPMail']->SMTPDebug = CLX_NUM_TWO;
                    } else {
                        ClxCommon::$cached['PHPMail']->SMTPDebug = CLX_NUM_ZERO;
                    }
                    //$phpMailer->SmtpClose();
                    ClxCommon::$cached['PHPMail']->IsHTML(true);
                    ClxCommon::$cached['PHPMail']->MsgHTML($html_body);
                    ClxCommon::$cached['PHPMail']->AltBody = $text_body;
                    // Send the message, check for errors
                    if (!ClxCommon::$cached['PHPMail']->Send()) {
                        $response['mail_send_result'] = false;
                        $response['error'] = true;
                        $response['errormsg'] = (ClxCommon::$cached['PHPMail']->ErrorInfo);
                    } else {
                        $response['mail_send_result'] = true;
                    }
                    ClxCommon::$cached['PHPMail']->clearAddresses();
                }
            } catch (phpmailerException $e) {
                $response['mail_send_result'] = false;
                $response['error'] = true;
                $response['errormsg'] = $e->errorMessage(); //Pretty error messages from PHPMailer
            } catch (Exception $e) {
                $response['mail_send_result'] = false;
                $response['error'] = true;
                $response['errormsg'] = $e->getMessage(); //Boring error messages from anything else!
            }
            break;
        default:
            $response['mail_send_result'] = false;
            $response['error'] = true;
            $response['errormsg'] = 'Invalid mail out configuration (' . $prmts['MARK_CAMP_MAIL_TYPE'] . ')';
            break;
    }
    $response['lapse_secs_smtp'] = (microtime_float()-$q123);
    return $response;
}

/**
 * Returns email address with name
 * @param String $fullname
 * @param String $email
 * @return String
 */
function get_name_email($fullname, $email) {
    $email = trim($email);
    if(!is_null($fullname) && !empty($fullname) && $fullname != $email){
        $to_w_name = '"' . $fullname . '" <'. $email . '>';
    }else{
        $to_w_name = $email;
    }
    return $to_w_name;
}

/**
 * Returns records to be processed and emails found quantity, to be recorded on CEME
 * @param Array $prmts General process parameters
 * @param Array $campsection Current CEML record data
 * @return Array with TARGETS_email_to_be_processed, QUERIES_email_to_be_processed, WRK_QUANTITY (sum of the previous two) and WRK_EMAILS_FOUND
 */
function count_rec_to_process($prmts, $campsection) {
    $response = array();
    $response['TARGETS_email_to_be_processed'] = CLX_NUM_ZERO;
    $response['QUERIES_email_to_be_processed'] = CLX_NUM_ZERO;
    $response['WRK_EMAILS_FOUND'] = CLX_NUM_ZERO;
    $response['WRK_QUANTITY'] = CLX_NUM_ZERO;
    /*
     * Cuenta los emails que encuentra
     */
    $sql = 'SELECT IFNULL(SUM(CQRY.EMAILS_FOUND),0) WRK_EMAILS_FOUND FROM MARK_CAMPAIGN_QUERIES CQRY WHERE CQRY.CAMPAIGNCODE=' . singleQuote($campsection['CAMPAIGNCODE']) . ' AND CQRY.STATUS=' . singleQuote('A') . ' AND CQRY.DELETED=0';
    if(ClxCommon::$cached['b_mark_camp_debug']) 
        markcamp_log_write($prmts, '<br>' . $sql . '<br><br>');
    $q123 = microtime_float();
    markcamp_log_write($prmts, '<br>SQL SELECT COUNT(EMAILS FOUND) | BEGIN: ' . xFormat::getNow('Y-m-d H:i:s'));
    $rs = ClxCommon::$db->executeQuery($sql);
    $r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE);
    $q123 = (microtime_float()-$q123);
    markcamp_log_write($prmts, ' -> END: ' . xFormat::getNow('Y-m-d H:i:s') . ' | Elapse (secs): ' . $q123);
    $response['WRK_EMAILS_FOUND'] = $r['WRK_EMAILS_FOUND'];
    /* Cuenta lo que efectivamente se va a procesar, porque...
     * IFNULL(SUM(CQRY.QUANTITY),0) WRK_QUANTITY
     * Trae todos los registros que encuentra en todos las listas de consulta de la campaña...
     * Por eso no se hizo en el SQL anterior
     */
    $sql = 'SELECT CQRY.IDCODE, CQRY.QUERYLIST_CODE, CQRY.CAMPAIGNCODE FROM ' . tableName('CQRY') . ' CQRY WHERE CAMPAIGNCODE=' . singleQuote($campsection['CAMPAIGNCODE']) . ' AND CQRY.STATUS = ' . singleQuote('A') . ' AND CQRY.DELETED=0';
    $rs = ClxCommon::$db->executeQuery($sql);
    while(($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE))){
        $prmts['email_fld_name'] = 'EMAIL';
        if($r['QUERYLIST_CODE']==null){
            $sub_sql = CEML_get_target_sql($r, $campsection, $prmts);
            $response['TARGETS_email_to_be_processed'] += get_sql_rec_to_proc_count('TARGETS', $sub_sql, $campsection, $prmts);
        }    
        if(!empty($r['QUERYLIST_CODE'])){
            $sub_sql = CEML_get_query_sql($r, $campsection, $prmts);
            $response['QUERIES_email_to_be_processed'] += get_sql_rec_to_proc_count('QUERIES', $sub_sql, $campsection, $prmts);
        }
    }
    $response['WRK_QUANTITY'] = $response['TARGETS_email_to_be_processed'] + $response['QUERIES_email_to_be_processed'];
    return $response;
}

/**
 * Returns records to be processed, as 'CEML_run_sql_targets' method would do
 * @param String $CEML_part Part: Queries or Targets
 * @param String $sql SQL Select to be tested
 * @param Array $campsection Current CEML record data
 * @param Array $prmts General process parameters
 * @return Integet ROW_QTY
 */
function get_sql_rec_to_proc_count($CEML_part, $sql, $campsection, $prmts) {
    // Fix SQL as 'CEML_run_sql_targets' method do
    $sql = str_replace('1=1', 'trim('.$prmts['email_fld_name'] . ') <>' . singleQuote(CLX_CHAR_EMPTY_STRING), $sql);
    if($prmts['CONTINUE_FLAG']) {
        $sql = str_replace('/* CONTINUE_FLAG_CONDITION */', 'AND ' . $prmts['email_fld_name'] . ' NOT IN (SELECT DISTINCT CEMR.EMAIL FROM MARK_CAMPSEC_EMAIL_RES CEMR WHERE CEMR.CEME_ID IN (SELECT CEME.ID FROM MARK_CAMPSEC_EMAIL_EXE CEME WHERE CEME.CEML_CODE=' . singleQuote($campsection['IDCODE']) . '))', $sql);
    }
    $sql = str_replace('<RECID>', '0', $sql);
    // Use the SQL as sub-query on FROM to count rows to be processed and returns it in ROW_QTY column
    $sql = 'SELECT COUNT(EMAIL) ROW_QTY FROM (' . $sql . ') DUMMY';
    if(ClxCommon::$cached['b_mark_camp_debug']) 
        markcamp_log_write($prmts, '<br>' . $sql . '<br><br>');
    $q123 = microtime_float();
    //echo  $sql.'</br>';

    markcamp_log_write($prmts, '<br>SQL SELECT COUNT('.$CEML_part.') | BEGIN: ' . xFormat::getNow('Y-m-d H:i:s'));
    $rs = ClxCommon::$db->executeQuery($sql);
    $r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE);
    $q123 = (microtime_float()-$q123);
    markcamp_log_write($prmts, ' -> END: ' . xFormat::getNow('Y-m-d H:i:s') . ' | Elapse (secs): ' . $q123 );
    return $r['ROW_QTY'];
}

/**
 * Initialices common elements to section
 * @global type $db
 * @param type $campsection_id
 * @return type
 */
function CEML_init_section_commons($campsection_id, $sched_params){
    // Para registrar globalmente los parametros que vienen del cronograma MAILCAMP
    // En particular el parametro OPERATION_TYPE, utilizado para diferenciar 'Ejecución' ('START') de 'Continuar Ejecución' ('CONTINUE')
    $array_result = array();
    if(!class_exists('proc_eng_params')) 
        includeCodeLib('PROC_2');
    $array_result['o_proc_eng_params'] = new proc_eng_params($sched_params);
    $array_result['run_error'] = false;
    $array_result['RUN_FLAG'] = true;
    // Verifica que exista el parametro OPERATION_TYPE
    // 0=php mail(), [1]=pear(smtp), 2=pear(mail), 3=PHPMailer
    $array_result['MARK_CAMP_MAIL_TYPE'] = get_def_company_param('MAIL_OUT_TYPE', '1');
    // Para solucionar el problema de no envio de los archivos adjuntos
    $ceml = ClxCommon::$db->getFields(tableName('CEML'), 'IDCODE, TEMPLATE_CODE, CAMPSECTION_FROM, CAMPSECTION_REPLYTO', 'ID='.$campsection_id);
    // Buscar plantilla y todo lo que se pueda necesitar muchas veces
    $template = ClxCommon::$db->getFields('CLX_UI_TEMPLATES', 'CONTENTS, CONTENTS_TXT', 'IDCODE='.singleQuote($ceml['TEMPLATE_CODE']));
    $array_result['CONTENTS'] = $template['CONTENTS'];
    $array_result['CONTENTS_TXT'] = $template['CONTENTS_TXT'];
    // The from and reply to fields...
    $array_result['FROM_REC'] = (!empty($ceml['CAMPSECTION_FROM'])) ? ClxCommon::$db->getRecord('BASE_EMAIL_ACCOUNTS', 'ID='.$ceml['CAMPSECTION_FROM']) : array('EMAIL' => 'noemail@localhost');
    $array_result['REPLAY_REC'] = (!empty($ceml['CAMPSECTION_REPLYTO'])) ? ClxCommon::$db->getRecord('BASE_EMAIL_ACCOUNTS', 'ID=' . $ceml['CAMPSECTION_REPLYTO']) : CLX_CHAR_EMPTY_STRING;
    // Para corregir problema del mismo email destino en el 'Para' del mensaje de email
    // En vez de instanciar en Mail_mime al principio y colocarlo en el array de los parametros,
    // coloca en el array de parametros los attachments e instancia Mail_mime por cada mensaje enviado
    // Create attachments array
    $attachments = array();
    // Mover a parametros
    // Para solucionar el problema de no envio de los archivos adjuntos, se ua $ceml['IDCODE'] en vez de $campsection_id
    $files = ClxCommon::$db->getRecords('MARK_CAMPSEC_EMAIL_ATTACH', 'CEML_CODE='.singleQuote($ceml['IDCODE']), 'DELETED=0');
    while(($file = ClxCommon::$db->getNextRecord($files, ASSOCIATIVE))) {
        $fileid = $file['ANYFILE'];
        $filerec = ClxCommon::$db->getRecord('CLX_SD_FILES', 'ID='.singleQuote($fileid));
        if (strlen($filerec['FILENAME']) == CLX_NUM_ZERO) {
            $filecontents = $filerec['CONTENTS'];
        } else {
            $filecontents = file_get_contents(kPathToWebSite . $filerec['FILENAME']);
        }
        $attachments[] = array(
			'filecontents' => $filecontents,
			'type' => $filerec['TYPE'],
			'name' => $filerec['NAME'],
			'filename' => $filerec['FILENAME'], // 2016-10-11 FS-CR PHPMail
                        'encoding' => $filerec['ENCODING']  // 2016-10-11 FS-CR PHPMail
                );
    }
    $array_result['attachments'] = $attachments;
    // Mensaje de Unsubscribe por defecto - 2016-10-06 CR
    $array_result['MARK_CAMP_OPTOUT_MSG'] = get_def_optout_msg();
    // Ruta/Nombre por defecto del programa Email Tracer - 2016-10-06 CR
    $array_result['MARK_CAMP_OPTOUT_PROG'] = get_def_company_param('MARK_CAMP_OPTOUT_PROG', kWebSite.'email_tracer.php');
    // Reemplaza eventual token con dirección base del sitio web - 2016-10-06 CR
    $array_result['MARK_CAMP_OPTOUT_PROG'] = str_replace('kWebSite', kWebSite, $array_result['MARK_CAMP_OPTOUT_PROG']);
    return $array_result;
}


/**
 * Marca el status de la seccion
 * @param type $campsection
 * @param type $campsectionstatus
 */
function CEML_record_start_ceme(&$prmts, $campsection, $sched_params, $sw_count=true){
    $DBTB = &getTool('DBTB');
    $record = $DBTB->tableDefaultRecord('CEME');
    $record['CEML_CODE'] = $campsection['IDCODE'];
    $record['EXEC_DATE'] =  date ( 'Y-m-d H:i:s' );
    $record['CAMPSECTION_STATUS'] = 'WORK';
    $record['LOG_FILE_NAME'] = $prmts['mark_camp_log']; // Guarda el nombre del archivo Log
    $record['QUANTITY'] = CLX_NUM_ZERO;
    $record['EMAILS_FOUND'] = CLX_NUM_ZERO;
    $record['EMAILS_PROC'] = CLX_NUM_ZERO;
    $record['EMAILS_SENT'] = CLX_NUM_ZERO;
    $record['TOTAL_READ'] = CLX_NUM_ZERO;
    $record['SDATE'] =  $record['EXEC_DATE'];
    $record['EDATE'] =  CLX_CHAR_EMPTY_STRING;
    $record['OWNERCODE'] = $_SESSION['user_record']['username']; // El dueño de la Ejecucion es el dueño del cronograma MAILCAMP
    $record['OPERATION_TYPE'] = $sched_params['OPERATION_TYPE'];
    $record['PRLO_ID'] = (isset($sched_params['RUNID']) ? $sched_params['RUNID'] : 0);
    $record['LAST_REMINDR_DT'] = null;
    $record['LAST_EMAILS_PROC'] = 0;
    // Se debe crear primero el registro CEME para poder tener el CEME_ID
    $ceme_id = ClxCommon::$db->createRecord('MARK_CAMPSEC_EMAIL_EXE', $record, false);
    ClxCommon::$db->commit();
    if($sw_count===true) {
        // Se cuenta los registros a procesar (necesita CEME_ID) e emails encontrados
        $campsection['CEME_ID'] = $ceme_id;
        $response = count_rec_to_process($prmts, $campsection);
        $prmts['TARGETS_email_to_be_processed'] = $response['TARGETS_email_to_be_processed'];
        $prmts['QUERIES_email_to_be_processed'] = $response['QUERIES_email_to_be_processed'];
        // Se memoriza los registros a procesar e emails encontrados
        $record = array();
        $record['QUANTITY'] = $response['WRK_QUANTITY'];
        $record['EMAILS_FOUND'] = $response['WRK_EMAILS_FOUND'];
        ClxCommon::$db->updateRecord('MARK_CAMPSEC_EMAIL_EXE', $record, 'ID='.$ceme_id);
        ClxCommon::$db->commit();
    }
    return $ceme_id;
}

/**
 * Process message
 * @global type $db
 * @param type $ceml_code
 * @param type $status
 * @param type $message
 */
function CEML_record_end_ceme($prmts, $ceme_id, $status, $message){
    $record = array();
    $record['CAMPSECTION_STATUS'] = $status;
    $record['PROCESS_MSG'] = $message;
    $record['EDATE'] = date('Y-m-d H:i:s');
    CEML_update_ceme_total_sent($prmts, $ceme_id, $record);
}

/**
 * Actualiza el contador de total enviados
 * @global type $db
 * @param type $ceme_id
 */
function CEML_update_ceme_total_sent($prmts, $ceme_id, $record){
    $record['EMAILS_SENT'] = ($prmts['QUERIES_email_sent']+$prmts['TARGETS_email_sent']);
    $record['EMAILS_PROC'] = ($prmts['QUERIES_email_processed']+$prmts['TARGETS_email_processed']);
    if(ClxCommon::$cached['b_mark_camp_debug']) {
        $sql = 'UPDATE MARK_CAMPSEC_EMAIL_EXE SET EMAILS_SENT=' . $record['EMAILS_SENT'] . ', EMAILS_PROC=' . $record['EMAILS_PROC'] . '  WHERE ID='.$ceme_id;
        markcamp_log_write($prmts, '<br>' . $sql . '<br><br>');
    }
    $q123 = microtime_float();
    markcamp_log_write($prmts, '<br>SQL UPDATE | BEGIN: ' . xFormat::getNow('Y-m-d H:i:s'));
    ClxCommon::$db->updateRecord('MARK_CAMPSEC_EMAIL_EXE', $record, 'ID='.$ceme_id);
    ClxCommon::$db->commit();
    $q123 = (microtime_float()-$q123);
    markcamp_log_write($prmts, ' -> END: ' . xFormat::getNow('Y-m-d H:i:s') . ' | Elapse (secs): ' . $q123 );
}

//--------------------------------------------------
//--------------------------------------------------
//--------------------------------------------------

/**
 * New execution of campaign emails
 * @global type $db
 * @param type $campsection
 */
function CEML_execute_real($campsection, $sched_params, $content){
    $sw_section = CLX_NUM_ZERO;
    // Se agrega parametro MARK_CAMP_SQL_PAGE para asigna el valor de la
    // frecuencia de ejecución de SQL para paginación de envios.
    // antes tenia un valor fijo de 1000
    $page = CLX_NUM_ZERO+get_def_company_param('MARK_CAMP_SQL_PAGE', 1000);
    // Para poner la identificacion de la campaña en el Log de Ejecución del Cronograma
    echo    CLX_CHAR_NL . CLX_CHAR_NL .
            dict('GEN_LBL_MARK_CAMP', $campsection['CAMPAIGNCODE']) .
            CLX_CHAR_NL .
            dict('GEN_LBL_MARK_CAMPSEC', $campsection['IDCODE']);
    // Para registrar globalmente los parametros que vienen del cronograma MAILCAMP
    $prmts = CEML_init_section_commons($campsection['ID'], $sched_params);
    // Mascara para mostrar los tiempos en días, horas, minutos y segundos
    $prmts['date_diff_fmt'] = '%d ' . dict('GEN_LBL_DAY-S') . ', %h ' . dict('GEN_LBL_HOUR-S') . ', %i ' . dict('GEN_LBL_MINUTE-S') . ', %s ' . dict('GEN_LBL_SECONDS-S');
    $prmts['CONTINUE_FLAG'] = ($sched_params['OPERATION_TYPE'] == 'CONTINUE');
    // Guarda el directorio del PHPMAILer para eventual reporte de error
    $prmts['MAIL_OUT_DIR_PHPMAIL'] = (isset($sched_params['MAIL_OUT_DIR_PHPMAIL']) ? $sched_params['MAIL_OUT_DIR_PHPMAIL'] : CLX_CHAR_EMPTY_STRING);
    unset($sched_params['MAIL_OUT_DIR_PHPMAIL']);
    // Guarda parametro de excepciones del PHPMAILer
    $prmts['MAIL_OUT_EXCEPTIONS_PHPMAIL'] = (isset($sched_params['MAIL_OUT_EXCEPTIONS_PHPMAIL']) ? $sched_params['MAIL_OUT_EXCEPTIONS_PHPMAIL'] : CLX_CHAR_EMPTY_STRING);
    unset($sched_params['MAIL_OUT_EXCEPTIONS_PHPMAIL']);
    // Guarda parametro de instanciar PHPMAILer por cada email [1] o hacerlo sólo una vez [0]
    $prmts['MAIL_OUT_INSTANCE_EM_PHPMAIL'] = (isset($sched_params['MAIL_OUT_INSTANCE_EM_PHPMAIL']) ? $sched_params['MAIL_OUT_INSTANCE_EM_PHPMAIL'] : CLX_CHAR_EMPTY_STRING);
    unset($sched_params['MAIL_OUT_INSTANCE_EM_PHPMAIL']);
    /*
        Creadas variables
        $mark_camp_sleep_records records
        $mark_camp_sleep_time tiempo
        cambio de limite tiempo dependiendo del tiempo sleep y cantidad por ciclo
        Se tomo tiempo calculo para envio de 1 millon de envios de correos maximo
        Timeout = 60 seg (Sleep defecto) por 1000000 (correos) / 2000 (tamaño lote);
    */
    $prmts['mark_camp_sleep_records'] = CLX_NUM_ZERO+get_def_company_param('MARK_CAMP_SLEEP_RECORDS', CLX_NUM_THOUSAND); // Hace sleep cada 1000 registros, por defecto
    $prmts['mark_camp_sleep_time'] = CLX_NUM_ZERO+get_def_company_param('MARK_CAMP_SLEEP_TIME', CLX_NUM_300); // 30 segundos de SleepTime, por defecto
    $prmts['mark_camp_auto_resume'] = CLX_NUM_ZERO+get_def_company_param('MARK_CAMP_AUTO_RESUME', CLX_NUM_ONE); // Resume automaticamente cuando hay desconexión con el servidor SMTP
    $prmts['mark_camp_commit_every'] = CLX_NUM_ZERO+get_def_company_param('MARK_CAMP_COMMIT_EVERY', CLX_NUM_FIVE); // Hace commit cada 5 registros leidos por defecto

    // 2016-03-30 - Caso 1003122 - BNP-Incid 303458 CRM - BEGIN
    $prmts['mark_camp_log'] = get_def_company_param('MARK_CAMP_LOG', CLX_CHAR_EMPTY_STRING); // nombre del log file, vacio por defecto
    if (trim($prmts['mark_camp_log']) === CLX_CHAR_EMPTY_STRING) {
        // Si esta vacio, no crea Log File
        echo $content;
    } else {
        // Si existe parametro general MARK_CAMP_LOG, abre archivo de salida para generar el Log
        $prmts['mark_camp_log']=str_replace('{datetime}', adodb_date('Ymd') . '_' . adodb_date('His'), trim($prmts['mark_camp_log']));
        $prmts['mark_camp_log']=str_replace('{campaign}', $campsection['CAMPAIGNCODE'], $prmts['mark_camp_log']);
        $prmts['mark_camp_log']=str_replace('{section}', $campsection['IDCODE'], $prmts['mark_camp_log']);
        $prmts['mark_camp_log_handle'] = new clx_file($prmts['mark_camp_log'], 'w');
        $prmts['mark_camp_log_handle']->open();
        if($prmts['mark_camp_log_handle']->error) {
            // No pudo abrir el Log
            $errmsg_short = $prmts['mark_camp_log_handle']->errorMsg . ' [' . $prmts['mark_camp_log'] . ']';
            $errmsg_long = $errmsg_short;
            echo 'ERROR: ' . $errmsg_long . '<br>' . CLX_CHAR_NL;
            echo $content;
            error_trap_register($errmsg_short, $errmsg_long, __LINE__, $prmts);
            terminate_campaign($prmts, $campsection, 'ERROR', $errmsg_short, false);
            return false;
        } else {
            // Identifica el nombre del archivo Log en el Log de Ejecución del Cronograma (Step Log)
            markcamp_echo_and_log_write($prmts, '<br>Log File: [' . $prmts['mark_camp_log'] . ']<br><br>' . $content);
            // Identifica la campaña en el Log
            markcamp_log_write($prmts, dict( 'GEN_LBL_MARK_CAMP', '[' . $campsection['CAMPAIGNCODE'] . '] ' . ClxCommon::$db->getField('MARK_CAMPAIGNS' /* CAMP */, 'IDNAME', 'IDCODE=' . singleQuote($campsection['CAMPAIGNCODE'])) ) . '<br>' . dict('GEN_LBL_MARK_CAMPSEC', '[' . $campsection['IDCODE'] .'] ' . $campsection['IDNAME']) . '<br>' . xFormat::getNow('Y-m-d H:i:s') . ' [' . $sched_params['OPERATION_TYPE'] . ']' . '<br>');
        }
    }
    $prmts['DEBUG_FLAG'] = (isset($sched_params['IS_DEBUG']) && $sched_params['IS_DEBUG'] == '1');
    ClxCommon::$cached['b_mark_camp_debug'] = (ClxCommon::$cached['b_mark_camp_debug'] || ($prmts['DEBUG_FLAG'] == '1'));
    set_time_limit(CLX_NUM_ZERO);
    markcamp_echo_and_log_write($prmts,
        '<br>' . get_server_info() .
        '<br>IS_DEBUG = [' . (isset($sched_params['IS_DEBUG']) ? $sched_params['IS_DEBUG'] : '[N/D]') . ']' .
        '<br>SEND_ALL_EMAILS = [' . $campsection['SEND_ALL_EMAILS'] . ']' .
        '<br>OPERATION_TYPE = ' . $sched_params['OPERATION_TYPE'] .
        '<br>MAIL_OUT_TYPE = ' . $prmts['MARK_CAMP_MAIL_TYPE'] .
        ($prmts['MAIL_OUT_INSTANCE_EM_PHPMAIL'] == CLX_CHAR_EMPTY_STRING ? CLX_CHAR_EMPTY_STRING : '<br>MAIL_OUT_INSTANCE_EM_PHPMAIL = ' . $prmts['MAIL_OUT_INSTANCE_EM_PHPMAIL']) .
        ($prmts['MAIL_OUT_EXCEPTIONS_PHPMAIL'] == CLX_CHAR_EMPTY_STRING ? CLX_CHAR_EMPTY_STRING : '<br>MAIL_OUT_EXCEPTIONS_PHPMAIL = ' . $prmts['MAIL_OUT_EXCEPTIONS_PHPMAIL']) .
        '<br>SMTP_ACCOUNT = ' . $prmts['FROM_REC']['IDNAME'] . ' [' . $prmts['FROM_REC']['EMAIL'] . ']' .
        '<br>SMTP_HOSTNAME = ' . $prmts['FROM_REC']['SMTP_HOSTNAME'] .
        '<br>MARK_CAMP_SLEEP_RECORDS = ' . $prmts['mark_camp_sleep_records'] .
        '<br>MARK_CAMP_SLEEP_TIME = ' . $prmts['mark_camp_sleep_time'] .
        '<br>MARK_CAMP_AUTO_RESUME = ' . $prmts['mark_camp_auto_resume'] .
        '<br>MARK_CAMP_SQL_PAGE = ' . $page .
        '<br>'
    );
    if($prmts['MARK_CAMP_MAIL_TYPE'] == '3' && ClxCommon::$cached['PHPMail'] == false) {
        // Registra en la trampa de errores la detencion de la campaña porque el Mailer es '3' (PHPMail) y no se pudo cargar la librería
        /*
         * TOOL_CODE_ERR_NOINCLUDE
         * Error on library load, could not be included or evaluated
         * Error al cargar la libreria, no pudo ser evaluada
         */
        $errmsg_short = dict('TOOL_CODE_ERR_NOINCLUDE') . ': "' . $prmts['MAIL_OUT_DIR_PHPMAIL'].'/PHPMailer"';
        $errmsg_long = $errmsg_short . ', ' . dict('GEN_LBL_MARK_CAMP', $campsection['CAMPAIGNCODE']);
        error_trap_register($errmsg_short, $errmsg_long, __LINE__, $prmts);
        $campsection['CEME_ID'] = CEML_record_start_ceme($prmts, $campsection, $sched_params, false);
        terminate_campaign($prmts, $campsection, 'ERROR', $errmsg_short);
        return false;
    }
    if(!isset($sched_params['OPERATION_TYPE']))
        {
        // Registra en la trampa de errores la detencion de la campaña por no tener el parametro OPERATION_TYPE
        /*
         * GEN_ERR_MISS_PAR
         * Parameter ^1 is missing. ^2
         * El parámetro ^1 no existe. ^2
         */
        $errmsg_short = dict('GEN_ERR_MISS_PAR', 'OPERATION_TYPE', dict('GEN_LBL_SCHEDULE') . ': ' . $sched_params['SCHEDULECODE']);
        $errmsg_long = $errmsg_short . ' ' . dict('GEN_LBL_MARK_CAMP', $campsection['CAMPAIGNCODE']);
        error_trap_register($errmsg_short, $errmsg_long, __LINE__, $prmts);
        $campsection['CEME_ID'] = CEML_record_start_ceme($prmts, $campsection, $sched_params, false);
        terminate_campaign($prmts, $campsection, 'ERROR', $errmsg_short);
        return false;
    }
    // Contadores de metricas
    $prmts['TARGETS_email_processed'] = CLX_NUM_ZERO;
    $prmts['TARGETS_email_sent'] = CLX_NUM_ZERO;
    $prmts['TARGETS_lapse_secs_sql'] = CLX_NUM_ZERO;
    $prmts['TARGETS_lapse_secs_smtp'] = CLX_NUM_ZERO;
    $prmts['TARGETS_lapse_secs_process'] = CLX_NUM_ZERO;
    $prmts['QUERIES_email_processed'] = CLX_NUM_ZERO;
    $prmts['QUERIES_email_sent'] = CLX_NUM_ZERO;
    $prmts['QUERIES_lapse_secs_sql'] = CLX_NUM_ZERO;
    $prmts['QUERIES_lapse_secs_smtp'] = CLX_NUM_ZERO;
    $prmts['QUERIES_lapse_secs_process'] = CLX_NUM_ZERO;
    $prmts['TARGETS_email_to_be_processed'] = CLX_NUM_ZERO;
    $prmts['QUERIES_email_to_be_processed'] = CLX_NUM_ZERO;
    // Inicia registro de CEME
    $campsection['CEME_ID'] = CEML_record_start_ceme($prmts, $campsection, $sched_params, true);
    // Asigna CEME_ID para saber cual es la ejecución corriente. Es NULL si termino bien o no a comenzado
    ClxCommon::$db->updateRecord('MARK_CAMPSEC_EMAIL', array('CEME_ID' => $campsection['CEME_ID']), 'ID='.$campsection['ID']);
    /*
     * Se corrige problema de que no emite mensaje de error en los Logs porque se estaba
     * suprimiendo con error_reporting(0) en método 'CEML_execute_real()', lo que evita
     * ver el problema cuando procesa los mas de 900,000 registros y queda en ejecución
     * ya que no llega a procesar ni 100 mil.
     */
    $sql = 'SELECT CQRY.IDCODE, CQRY.QUERYLIST_CODE, CQRY.CAMPAIGNCODE FROM '.tableName('CQRY').' CQRY WHERE CAMPAIGNCODE = '.singleQuote($campsection['CAMPAIGNCODE']).' AND CQRY.STATUS='.singleQuote('A').' AND CQRY.DELETED=0';
    if(ClxCommon::$cached['b_mark_camp_debug']) 
        markcamp_log_write($prmts, '<br>CEML_execute_real:<br>' . $sql);
    $rs = ClxCommon::$db->executeQuery($sql);
    while(($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE))){
        // Columna de EMAIL por defecto (Puede cambiar en Metodo CEML_get_query_sql)
        $prmts['email_fld_name'] = 'EMAIL';
        if($r['QUERYLIST_CODE']==null){
            $sql = CEML_get_target_sql($r, $campsection, $prmts);
            $sw_section += CEML_run_sql_targets('TARGETS', $sql, $page, $campsection, $prmts, $r);
        }    
        if(!$prmts['RUN_FLAG']) {
            break;
        }
        if(!empty($r['QUERYLIST_CODE'])){
            $sql = CEML_get_query_sql($r, $campsection, $prmts);
            $sw_section += CEML_run_sql_targets('QUERIES', $sql, $page, $campsection, $prmts, $r);
        }
        if(!$prmts['RUN_FLAG']) {
            break;
        }
    }
    if($sw_section == 0){
        // No se envio nada de la seccion | Check if not target found and end section
        terminate_campaign($prmts, $campsection, 'ERROR', dict('GEN_ERR_NOTARGETFOUND'));
    }else{
        // Campaign terminates OK
        $send = ($campsection['SEND_ALL_EMAILS'])?true:false;
        terminate_campaign($prmts, $campsection, (!$send?'IDLE':'END'), (!$send?dict('GEN_LBL_TEST'):CLX_CHAR_EMPTY_STRING));
    }
    if(isset($prmts['mark_camp_log_handle'])) {
        // Cierra el Log File
        $prmts['mark_camp_log_handle']->close();
    }
    // Si RUN_FLAG es falso, se detuvo la campaña por algún problema
    return ($prmts['RUN_FLAG'] == true);
}

function get_ql_prev_init_const() {
    if(defined('TGPV_OP_REPORT_ONLY')) {
        return;
    }
    define('TGPV_OP_REPORT_ONLY', 'RO');
    define('TGPV_OP_BASIC_VERIF', 'BV');
    define('TGPV_OP_CARE_LIST_VERIF', 'REV');
    define('TGPV_OP_INBOX_VERIF', 'IV');
    define('TGPV_OP_DOMAIN_VERIF', 'DV');
    define('TGPV_DEFAULT_INBOX', CLX_CHAR_EMPTY_STRING);
    define('TGPV_IMAP_INBOX_FOLDER_ID', 'INBOX');
    define('TGPV_IMAP_RB_DEF_FLDR', get_def_company_param('MARK_CAMP_IMAP_RB_DEF_FLDR', 'Rebound'));
    define('TGPV_IMAP_RB_1ST_EMAIL', get_def_company_param('MARK_CAMP_IMAP_RB_1ST_EMAIL', '1'));
    define('TGPV_QL_MODE_INBOX_VERIF_ONLY', 'IVO');
}

function get_ql_preview($ql_mode = '') {
    // Listing: MARK_CQRY
    get_ql_prev_init_const();
    ClxCommon::$cached['b_mark_camp_debug'] = false;
    $contents = CLX_CHAR_EMPTY_STRING;
    $idlist = (isset(UserRequest::$post['idlist']) ? UserRequest::$post['idlist'] : toString(getIdlist()));
    if(empty($idlist) && $ql_mode != TGPV_QL_MODE_INBOX_VERIF_ONLY) {
        $contents .= 'Empty ID List';
        return $contents;
    }
    $prmts = array();
    $prmts['carename'] = tableName('CARE');
    $prmts['firstname_fld_name'] = 'FIRSTNAME';
    $prmts['lastname_fld_name'] = 'LASTNAME';
    $prmts['phone_fld_name'] = 'PHONE';
    $prmts['report_type'] = 'xls';
    $prmts['sep_col'] = CLX_CHAR_TAB;
    $prmts['sep_rec'] = CLX_CHAR_CR . CLX_CHAR_NL;
    $prmts['header_sent'] = false;
    $prmts['sched_params'] = array();
    if($ql_mode == TGPV_QL_MODE_INBOX_VERIF_ONLY) {
        /*
         * TITLE_REJECTED_EMAIL_SEARCH
         * Rejected Email Search
         * Busqueda de Emails Rechazados
         */
        $prmts['report_title'] = dict('TITLE_REJECTED_EMAIL_SEARCH');
        $prmts['report_type'] = 'html';
    } else {
        /*
         * TITLE_MARKCAMP_TARGET_PREVIEW
         * Query List Preview
         * Vista Previa de Listas de Consulta
         */
        $prmts['report_title'] = dict('TITLE_MARKCAMP_TARGET_PREVIEW');  // 760F71803177FA1D238C8265CC407648 = Database Query List | Lista de Consulta
        $prmts['cqry_title'] = $prmts['report_title'];
    }
    $campsection = array(); // Table: MARK_CAMPSEC_EMAIL CEML
    $campsection['CEME_ID'] = 0;
    $confirm = ( isset(UserRequest::$post['confirm']) ? UserRequest::$post['confirm'] : '0');
    $prmts['dmode'] = ( isset(UserRequest::$post['dmode']) ? UserRequest::$post['dmode'] : TGPV_OP_REPORT_ONLY);
    $prmts['inbox'] = ( isset(UserRequest::$post['inbox']) ? UserRequest::$post['inbox'] : TGPV_DEFAULT_INBOX);
    $prmts['folder'] = ( isset(UserRequest::$post['folder']) ? UserRequest::$post['folder'] : TGPV_IMAP_RB_DEF_FLDR);
    $prmts['adderr'] = ( isset(UserRequest::$post['adderr']) ? UserRequest::$post['adderr'] : '1');
    $get_flds = array();
    $get_flds['confirm'] = array( 'field_name' => 'confirm', 'field_type' => 'hidden', 'field_value' => (isset(UserRequest::$post['confirm'])?UserRequest::$post['confirm']:'0') );
    $get_flds['idlist'] = array( 'field_name' => 'idlist', 'field_type' => 'hidden', 'field_value' => $idlist );
    $get_flds['dmode'] = array( 'field_name' => 'dmode', 'field_type' => 'hidden', 'field_value' => $prmts['dmode'] );
    $get_flds['inbox'] = array( 'field_name' => 'inbox', 'field_type' => 'hidden', 'field_value' => $prmts['inbox'] );
    $get_flds['folder'] = array( 'field_name' => 'folder', 'field_type' => 'hidden', 'field_value' => $prmts['folder'] );
    $get_flds['adderr'] = array( 'field_name' => 'adderr', 'field_type' => 'hidden', 'field_value' => $prmts['adderr'] );
    $msg = array();
    $msg[] = $prmts['report_title'];
    $errmsg = array();
    /*
     * GEN_LBL_TGPV_OPL_RO
     * Report only
     * Sólo reporte
     *
     * GEN_LBL_TGPV_OPD_RO
     * Report Targets and Database Query List emails addresses and telephone numbers.
     * Reporte de direcciones de Email y números de teléfono en listas de Targets y de Consultas de Base de Datos.
     *
     * GEN_LBL_TGPV_OPL_BV
     * Report with basic verification
     * Reporte con verificacion básica
     *
     * GEN_LBL_TGPV_OPD_BV
     * Report Targets and Database Query List emails addresses and telephone numbers, with basic email address syntax verification. No Internet connection required.
     * Reporte de direcciones de Email y teléfonos en listas de Targets y de Consultas de Base de Datos, con verificación básica de sintaxis de direcciones de correo. No requiere conexión a Internet.
     *
     * GEN_LBL_TGPV_OPL_REV
     * Report with Rejected List verification
     * Reporte con verificacion en Emails rechazados
     *
     * GEN_LBL_TGPV_OPD_REV
     * Report Targets and Database Query List emails addresses and telephone numbers, with Rejected Email List verification. No Internet connection required.
     * Reporte de direcciones de Email y teléfonos en listas de Targets y de Consultas de Base de Datos, con verificación de direcciones en Lista de Emails rechazados. No requiere conexión a Internet.
     *
     * GEN_LBL_TGPV_OPL_DV
     * Report with Domain verification
     * Reporte con verificacion de Dominio
     *
     * GEN_LBL_TGPV_OPD_DV
     * Report Targets and Database Query List emails addresses and telephone numbers, with email address syntax and Domain name verification. Internet connection required.
     * Reporte de direcciones de Email y teléfonos en listas de Targets y de Consultas de Base de Datos, con verificación de sintaxis y de nombre de Dominio en las direcciones de correo. Requiere conexión a Internet.
     *
     * GEN_LBL_TGPV_OPL_IV
     * Report with Domain and Inbox verification
     * Reporte con verificacion de Dominio e Inbox
     *
     * GEN_LBL_TGPV_OPD_IV
     * Report Targets and Database Query List emails addresses and telephone numbers, with email address syntax, Domain name and Inbox rejection messages verification. Internet connection and Inbox IMAP access required.
     * Reporte de direcciones de Email y teléfonos en listas de Targets y de Consultas de Base de Datos, con verificación de sintaxis de las direcciones de correo, nombre de Dominio y existencia de mensajes de rechazo en carpeta de buzón de entrada. Requiere conexión a Internet y acceso a un buzón de correo IMAP.
     *
     * ...
     *
     * GEN_LBL_TGPV_OPD_IVO
     * This process performs rejected messages verification in a Email account folder. Internet connection and Inbox IMAP access will be required.
     * Este proceso realiza la verificación de existencia de mensajes de direcciones de Email rechazadas en una carpeta de correo. Requiere conexión a Internet y acceso a un buzón de correo IMAP.
     *
     */
    switch ($confirm) {
        // Pide la accion [dmode]:
        // RO) Sólo reporte
        // BV) Reporte con verificacion básica (no requiere Internet)
        // REV) Reporte con verificacion en Emails rechazados (no requiere Internet)
        // DV) Reporte con verificacion de Dominio (requiere acceso a Internet)
        // IV) Reporte con verificacion de Dominio + Inbox (requiere acceso a Internet + acceso a Inbox IMAP)
        case '0':
            $err_msg = CLX_CHAR_EMPTY_STRING;
            if(!function_exists('imap_open')) {
                /*
                 * GEN_LBL_PHPINI_EXT_NEEDED
                 * It's neccesary to enable extension ^1 in PHP.INI
                 * Es necesario habilitar extensión ^1 en el PHP.INI
                 *
                 * GEN_MSG_MAILDISABLED
                 * Mail unavailable at the moment.
                 * Correo desactivado por el momento.
                 */
                $err_msg = '<BR><BR><b>' . mb_convert_case(dict('GEN_LBL_WARNING'), MB_CASE_UPPER) . ': ' .  dict('GEN_MSG_MAILDISABLED') . ' (IMAP)</b> [MC-ER-035-A]' . '<br>' . dict('GEN_LBL_PHPINI_EXT_NEEDED', 'php_imap');
            }
            if($ql_mode == TGPV_QL_MODE_INBOX_VERIF_ONLY) {
                $prmts['dmode'] = TGPV_OP_INBOX_VERIF;
                $get_flds['dmode']['field_value'] = $prmts['dmode'];
                $get_flds['pop_desc'] = array('field_name' => 'pop_desc', 'field_type' => 'label', 'field_label' => '<div id="pop_desc">'.dict('GEN_LBL_TGPV_OPD_IVO').$err_msg.'</div>');
            } else {
                $options = array(TGPV_OP_REPORT_ONLY=>'GEN_LBL_TGPV_OPL_RO', TGPV_OP_BASIC_VERIF=>'GEN_LBL_TGPV_OPL_BV', TGPV_OP_CARE_LIST_VERIF=>'GEN_LBL_TGPV_OPL_REV', TGPV_OP_DOMAIN_VERIF=>'GEN_LBL_TGPV_OPL_DV', TGPV_OP_INBOX_VERIF=>'GEN_LBL_TGPV_OPL_IV');
                $get_flds['dmode'] = array('field_name' => 'dmode', 'field_type' => 'list', 'field_label' => dict('GEN_LBL_MODE'), 'field_value' => $prmts['dmode'], 'list_items' => $options );
                $get_flds['js_dmode'] = array('field_name' => 'js_dmode', 'field_type' => 'js', 'field_value' => '
<script type="text/javascript">
$("#dmode").live("change", function() {
    switch ( this.value ) {
        case "' . TGPV_OP_REPORT_ONLY . '":
            $("#pop_desc").html("' . dict('GEN_LBL_TGPV_OPD_RO') . '");
            break;
        case "' . TGPV_OP_BASIC_VERIF . '":
            $("#pop_desc").html("' . dict('GEN_LBL_TGPV_OPD_BV') . '");
            break;
        case "' . TGPV_OP_CARE_LIST_VERIF . '":
            $("#pop_desc").html("' . dict('GEN_LBL_TGPV_OPD_REV') . '");
            break;
        case "' . TGPV_OP_DOMAIN_VERIF . '":
            $("#pop_desc").html("' . dict('GEN_LBL_TGPV_OPD_DV') . '");
            break;
        case "' . TGPV_OP_INBOX_VERIF . '":
            $("#pop_desc").html("' . dict('GEN_LBL_TGPV_OPD_IV') . $err_msg . '");
            break;
        default:
            str = "' . dict('GEN_LBL_INVALID_OPT') . '";
            $("#pop_desc").html(str.replace("^1", this.value));
            break;
    }
});
</script>'
                );
                $get_flds['line1'] = array('field_name' => 'line1', 'field_type' => 'label', 'field_label' => '&nbsp;');
                $get_flds['pop_desc'] = array('field_name' => 'pop_desc', 'field_type' => 'label', 'field_label' => '<div id="pop_desc">'.dict('GEN_LBL_TGPV_OPD_'.$prmts['dmode']).($prmts['dmode']==TGPV_OP_INBOX_VERIF ? $err_msg : CLX_CHAR_EMPTY_STRING).'</div>');
            }
            $contents .= popup_form_Warning($msg, $get_flds, $errmsg);
            return $contents;
        // Pide la cuenta de correo, en caso que sea la opción 'IV'
        // Para cualquier otra opcion, pide la confirmación para generar el reporte
        case '1':
            if($prmts['dmode'] != TGPV_OP_INBOX_VERIF) {
                $get_flds['dmode_id'] = array('field_name' => 'dmode_id', 'field_type' => 'label', 'field_label' => dict('GEN_LBL_MODE'), 'field_value' => dict('GEN_LBL_TGPV_OPD_'.$prmts['dmode']));
                /*
                 * GEN_LBL_ADD_BAD_EM_TO_CARE
                 * Add other bad Emails to rejected list?
                 * ¿Agregar otros Emails con error a lista de Rechazados?
                 */
                if($prmts['dmode'] != TGPV_OP_REPORT_ONLY) {
                    // Si no es 'solo reporte', pide confirmación para agregar otroa email con error a la lista de rechazados
                    unset($get_flds['adderr']);
                    $get_flds['adderr'] = array('field_name' => 'adderr', 'field_type' => 'yesno', 'field_label' => dict('GEN_LBL_ADD_BAD_EM_TO_CARE'), 'field_value' => $prmts['adderr'] );
                }
                $contents .= popup_form_Warning($msg, $get_flds, $errmsg, true);
                return $contents;
            }
            if(!function_exists('imap_open')) {
                $err_msg = dict('GEN_MSG_MAILDISABLED') . ' (IMAP) [MC-ER-035-B]' . '<br>' . dict('GEN_LBL_PHPINI_EXT_NEEDED', 'php_imap');
                $get_flds['err'] = array('field_name' => 'err', 'field_type' => 'label', 'field_label' => $err_msg);
                $contents .= popup_form_Warning($msg, $get_flds, $errmsg);
                return $contents;
            }
            $options = array();
            $maacname = tableName('MAAC');
            $sql = 'SELECT ID, EMAIL, IDNAME FROM ' . $maacname . ' ORDER BY IDNAME';
            $rs = ClxCommon::$db->executeQuery($sql);
            while(($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE))) {
                $options[CLX_CHAR_EMPTY_STRING.$r['ID']] = $r['IDNAME'] . ' (' . $r['EMAIL'] . ')';
            }
            if(empty($options)) {
                /*
                 * TOOL_UILG_ERR_NO_RECORD
                 * No record found
                 * No se encontraron registros
                 *
                 * BASE_MAIL_NO_ACCOUNTS
                 * No email accounts configured
                 * Favor configurar una cuenta de correo.
                 */
                $err_msg = dict('TOOL_UILG_ERR_NO_RECORD') . '. ' . dict('BASE_MAIL_NO_ACCOUNTS') . ' [MC-ER-010]';
                $get_flds['err'] = array('field_name' => 'err', 'field_type' => 'label', 'field_label' => $err_msg);
                $contents .= popup_form_Warning($msg, $get_flds, $errmsg);
                return $contents;
            }
            /*
             * GEN_LBL_EMAIL_ACCOUNT
             * Email Account
             * Cuenta de Email
             */
            $get_flds['inbox'] = array('field_name' => 'inbox', 'field_type' => 'list-no-dict', 'field_label' => dict('GEN_LBL_EMAIL_ACCOUNT'), 'field_value' => $prmts['inbox'], 'list_items' => $options );
            $contents .= popup_form_Warning($msg, $get_flds, $errmsg);
            return $contents;
        // Pide la carpeta del la cuenta IMAP
        case '2':
            if($prmts['dmode'] != TGPV_OP_INBOX_VERIF) {
                break;
            }
            $err_msg = CLX_CHAR_EMPTY_STRING;
            if(empty($prmts['inbox'])) {
                $err_msg = dict('BASE_MAIL_NO_ACCOUNTS') . ' [MC-ER-020]';
                $get_flds['err'] = array('field_name' => 'err', 'field_type' => 'label', 'field_label' => $err_msg);
                $contents .= popup_form_Warning($msg, $get_flds, $errmsg);
                return $contents;
            }
            $mail_account = get_MAAC_mail_account($prmts['inbox']);
            if(empty($mail_account)) {
                $err_msg = dict('TOOL_UILG_ERR_NO_RECORD') . ': ' . $prmts['inbox'] . ' [MC-ER-030]';
                $get_flds['err'] = array('field_name' => 'err', 'field_type' => 'label', 'field_label' => $err_msg);
                $contents .= popup_form_Warning($msg, $get_flds, $errmsg);
                return $contents;
            }
            $MAIL = gettool('MAIL');
            $MAIL->IMAP_connect($mail_account);
            if($MAIL->IMAP_errormsg != CLX_CHAR_EMPTY_STRING) {
                $get_flds['err'] = array('field_name' => 'err', 'field_type' => 'label', 'field_label' => $MAIL->IMAP_errormsg);
                $contents .= popup_form_Warning($msg, $get_flds, $errmsg);
                return $contents;
            }
            $options = $MAIL->IMAP_get_folders();
            if($MAIL->IMAP_errormsg != CLX_CHAR_EMPTY_STRING) {
                $err_msg = $MAIL->IMAP_errormsg;
            } elseif(empty($options)) {
                $err_msg = dict('TOOL_UILG_ERR_NO_RECORD') . ' (' . dict('GEN_LBL_MAILFOLDER') . ') [MC-ER-060]';
            }
            $MAIL->IMAP_disconnect();
            if(!empty($err_msg)) {
                $get_flds['err'] = array('field_name' => 'err', 'field_type' => 'label', 'field_label' => $err_msg);
                $contents .= popup_form_Warning($msg, $get_flds, $errmsg);
                return $contents;
            }
            /*
             * GEN_LBL_MAILFOLDER
             * Folder
             * Carpeta
             */
            $get_flds['mail_id'] = array('field_name' => 'mail_id', 'field_type' => 'label', 'field_label' => dict('GEN_LBL_EMAIL_ACCOUNT'), 'field_value' => ($mail_account['IDNAME'] . ' (' . $mail_account['EMAIL'] . ')'), 'list_items' => $options );
            unset($get_flds['folder']);
            $get_flds['folder'] = array('field_name' => 'folder', 'field_type' => 'list-no-dict', 'field_label' => dict('GEN_LBL_MAILFOLDER'), 'field_value' => $prmts['folder'], 'list_items' => $options );
            $contents .= popup_form_Warning($msg, $get_flds, $errmsg);
            return $contents;
        // Pide confirmacion para terminar
        case '3':
            if($prmts['dmode'] != TGPV_OP_INBOX_VERIF) {
                break;
            }
            /*
             * GEN_LBL_TGPV_WNG_01
             * All emails addresses in specified Folder's messages will be included in Rejected Email list
             * Todas las direcciones de Email en los mensajes de la Carpeta especificada se registrarán en la lista de Emails rechazados
             *
             * GEN_LBL_TGPV_WNG_02
             * WARNING: it's not recommended to use ^1 folder to accomplish this task!
             * ADVERTENCIA: no es recomendable utilizar la carpeta ^1 para llevar a cabo esta tarea!
             *
             * GEN_LBL_SURESQL
             * Are you sure you want to execute?
             * Esta seguro que quiere ejecutar?
             */
            $mail_account = get_MAAC_mail_account($prmts['inbox']);
            if($ql_mode != TGPV_QL_MODE_INBOX_VERIF_ONLY) {
                $get_flds['dmode_id'] = array('field_name' => 'dmode_id', 'field_type' => 'label', 'field_label' => dict('GEN_LBL_MODE'), 'field_value' => dict('GEN_LBL_TGPV_OPD_'.$prmts['dmode']));
            }
            $get_flds['mail_id'] = array('field_name' => 'mail_id', 'field_type' => 'label', 'field_label' => dict('GEN_LBL_EMAIL_ACCOUNT'), 'field_value' => ($mail_account['IDNAME'] . ' (' . $mail_account['EMAIL'] . ')'));
            $get_flds['folder_id'] = array('field_name' => 'folder_id', 'field_type' => 'label', 'field_label' => dict('GEN_LBL_MAILFOLDER'), 'field_value' => $prmts['folder']);
            $get_flds['warning_1'] = array('field_name' => 'warning_1', 'field_type' => 'label', 'field_label' => dict('GEN_LBL_TGPV_WNG_01'));
            if($prmts['folder'] == TGPV_IMAP_INBOX_FOLDER_ID) {
                $get_flds['warning_2'] = array('field_name' => 'warning_1', 'field_type' => 'label', 'field_label' => dict('GEN_LBL_TGPV_WNG_02', TGPV_IMAP_INBOX_FOLDER_ID));
            }
            if($ql_mode != TGPV_QL_MODE_INBOX_VERIF_ONLY) {
                unset($get_flds['adderr']);
                $get_flds['adderr'] = array('field_name' => 'adderr', 'field_type' => 'yesno', 'field_label' => dict('GEN_LBL_ADD_BAD_EM_TO_CARE'), 'field_value' => $prmts['adderr'] );
            }
            $get_flds['warning_3'] = array('field_name' => 'warning_1', 'field_type' => 'label', 'field_label' => dict('GEN_LBL_SURESQL'));
            $contents .= popup_form_Warning($msg, $get_flds, $errmsg, true);
            return $contents;
    }
    if(isset(UserRequest::$post['yesno']) && UserRequest::$post['yesno'] == '0') {
        $msg[] = dict('GEN_LBL_OPER_ABORTED');
        $contents .= popup_form_Finish($msg);
        return $contents;
    }
    //
    //UserRequest::$request[dict('GEN_LBL_BATCH_ACTION')]='SHOW_PANEL';
    //UserRequest::$post = array_merge(UserRequest::$request, UserRequest::$post);
    //$ANRJ = getTool('ANRJ');
    //$ANRJ->setBatchReports($prmts['report_title'], $prmts['report_type'], UserRequest::$post);
    //
    //$ANRJ = getTool('ANRJ');
    //$ANRJ->setBatchGeneral($prmts['report_title'], $prmts['report_type'], UserRequest::$post);
    //
    if($prmts['dmode'] === TGPV_OP_INBOX_VERIF) {
        $response = registerCareTableRecords($prmts);
        if($response['errormsg'] != CLX_CHAR_EMPTY_STRING) {
            $get_flds['err'] = array('field_name' => 'err', 'field_type' => 'label', 'field_label' => $response['errormsg']);
            $contents .= popup_form_Warning($msg, $get_flds, $errmsg);
            return $contents;
        }
        if($ql_mode == TGPV_QL_MODE_INBOX_VERIF_ONLY) {
            $msg[] = dict('GEN_LBL_PROCESS_COMPLETED');
            $contents .= popup_form_Finish($msg);
            return $contents;
        }
    }
    $sql = 'SELECT IDCODE, IDNAME, QUERYLIST_CODE, CAMPAIGNCODE FROM '.tableName('CQRY').' WHERE ID IN ('.$idlist.') AND DELETED=0';
    $rs = ClxCommon::$db->executeQuery($sql);
    while(($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE))){
        $campsection['CAMPAIGNCODE'] = $r['CAMPAIGNCODE'];
        if($prmts['header_sent'] === false) {
            $prmts['header_sent'] = true;
            $name = 'MARKCAMP_CQRY_PREVIEW_' . $r['CAMPAIGNCODE'] .'.xls';
            $filename = kPathToTemp.'rep'.str_replace('.',CLX_CHAR_EMPTY_STRING,microtime(true)).'.xls';
            $prmts['fl'] = new clx_file($filename, 'a');
            $prmts['fl']->open();
        }
        $prmts['email_fld_name'] = 'EMAIL';
        if($r['QUERYLIST_CODE']==null){
            $sql = CEML_get_target_sql($r, $campsection, $prmts);
            echo 'entro por aca';
            get_ql_preview_report('TARGETS', $sql, $prmts, $r);
        }    
        if(!empty($r['QUERYLIST_CODE'])){
            $sql = CEML_get_query_sql($r, $campsection, $prmts);
            $prmts['email_fld_name'] = 'EMAIL';
            get_ql_preview_report('QUERIES', $sql, $prmts, $r);
        }
    }
    $prmts['fl']->close();
    $msg[] = note('<a href="'.$filename.'" target="_blank">'.dict('GEN_LBL_DOWNLOAD_THE_FILE').'</a><br>');
    $contents .= popup_form_Finish($msg);
    return $contents;
}

function get_ql_preview_report($cqry_type, $sql, $prmts, $cqry_record) {
    if(!defined('ERR_MSG_SEPARATOR')) {
        define('ERR_MSG_SEPARATOR', ', ');
    }
    $sql = str_replace('<RECID>', '0', $sql);
    // Encabezados
    $headers = $prmts['firstname_fld_name'] . $prmts['sep_col'] . $prmts['lastname_fld_name'] . $prmts['sep_col'] . $prmts['email_fld_name'] . $prmts['sep_col'] . $prmts['phone_fld_name'];
    // Columnas opcionales que se requiere incluir en caso que estén en el Query
    $optional_columns = array('COMPANY', 'COUNTRY');
    $rs = ClxCommon::$db->executeQuery($sql);
    while( $r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE) ) {
        $valid_em = CLX_CHAR_EMPTY_STRING;
        $invalid_reason = CLX_CHAR_EMPTY_STRING;
        if($r[$prmts['email_fld_name']] != CLX_CHAR_EMPTY_STRING) {
            switch($prmts['dmode']) {
                case TGPV_OP_REPORT_ONLY:
                    break;
                case TGPV_OP_CARE_LIST_VERIF:
                case TGPV_OP_INBOX_VERIF:
                    if (ClxCommon::$db->oneExistsRecords($prmts['carename'].'/* 2 */', 'EMAIL='.singleQuote($r[$prmts['email_fld_name']])) > CLX_NUM_ZERO) {
                        $valid_em = 'ERROR';
                        $invalid_reason .= ($invalid_reason == CLX_CHAR_EMPTY_STRING ? CLX_CHAR_EMPTY_STRING : ERR_MSG_SEPARATOR) . 'In rejected list';
                    }
                case TGPV_OP_DOMAIN_VERIF:
                    $email_parts = explode('@', $r[$prmts['email_fld_name']]);
                    if(isset($email_parts[1]) && !checkdnsrr($email_parts[1], 'ANY') ) {
                        $valid_em = 'ERROR';
                        $invalid_reason .= ($invalid_reason == CLX_CHAR_EMPTY_STRING ? CLX_CHAR_EMPTY_STRING : ERR_MSG_SEPARATOR) . 'Invalid domain';
                        if($prmts['adderr'] === '1') {
                            registerCareTableAddEmail($r[$prmts['email_fld_name']], $prmts);
                        }
                    }
                case TGPV_OP_BASIC_VERIF:
                    if(! xValidate::is_valid_email($r[$prmts['email_fld_name']]) ) {
                        $valid_em = 'ERROR';
                        $invalid_reason .= ($invalid_reason == CLX_CHAR_EMPTY_STRING ? CLX_CHAR_EMPTY_STRING : ERR_MSG_SEPARATOR) . 'Syntax error';
                        if($prmts['adderr'] === '1') {
                            registerCareTableAddEmail($r[$prmts['email_fld_name']], $prmts);
                        }
                    }
                    break;
            }
        }
        $contents = $r[$prmts['firstname_fld_name']] . $prmts['sep_col'] . $r[$prmts['lastname_fld_name']] . $prmts['sep_col'] . $r[$prmts['email_fld_name']] . $prmts['sep_col'] . $r[$prmts['phone_fld_name']];
        foreach($optional_columns as $colname) {
            if(array_key_exists($colname, $r)) {
                $contents .= $prmts['sep_col'] . $r[$colname];
                if($headers != CLX_CHAR_EMPTY_STRING) {
                    $headers .= $prmts['sep_col'] . $colname;
                }
            }
        }
        if($headers != CLX_CHAR_EMPTY_STRING) {
            // Completa los Encabezados
            $headers .=  $prmts['sep_col'] . 'VALID_EMAIL' . $prmts['sep_col'] . 'INVALID_REASON' . $prmts['sep_rec'] . $prmts['sep_rec'];
            // Antepone el Titulo que identifica la lista de consulta
            $headers = $prmts['sep_rec'] . $prmts['sep_rec'] . $cqry_type . ' - ' . $prmts['cqry_title'] . ': ' . $cqry_record['IDCODE'] . ' - ' . $cqry_record['IDNAME'] . $prmts['sep_rec'] . $prmts['sep_rec'] . $headers;
            $prmts['fl']->write(utf8_decode($headers));
            $headers = CLX_CHAR_EMPTY_STRING;
        }
        $contents .= $prmts['sep_col'] . $valid_em . $prmts['sep_col'] . $invalid_reason . $prmts['sep_rec'];
        $prmts['fl']->write(utf8_decode($contents));
    }
}

function get_MAAC_mail_account($mail_acc_id) {
    define('IMAP_DEFAULT_PORT', '143');
    define('POP3_DEFAULT_PORT', '110');
    $maacname = tableName('MAAC');
    $mail_account = ClxCommon::$db->getRecord($maacname, 'ID='.$mail_acc_id);
    if(empty($mail_account))
        return $mail_account;
    if(!isset($mail_account['POP3_PORT'])) {
        $options = explode(':', $mail_account['POP3_HOSTNAME']);
        $mail_account['POP3_PORT'] = CLX_CHAR_EMPTY_STRING;
        if(isset($options[CLX_NUM_ONE]))
            $mail_account['POP3_PORT'] = $options[CLX_NUM_ONE];
    }
    if(trim($mail_account['POP3_PORT']) === CLX_CHAR_EMPTY_STRING)
        $mail_account['POP3_PORT'] = IMAP_DEFAULT_PORT;
    if(!isset($mail_account['EMAIL_TYPE'])) {
        $mail_account['EMAIL_TYPE'] = 'IMAP'; // 'IMAP' => 'GEN_LBL_IMAP'
        if($mail_account['POP3_PORT'] === POP3_DEFAULT_PORT)
            $mail_account['EMAIL_TYPE'] = 'POP3'; // 'POP3' => 'GEN_LBL_POP3'
    }
    $mail_account['IN_HOSTNAME'] = $mail_account['POP3_HOSTNAME'];
    $mail_account['IN_PORT'] = $mail_account['POP3_PORT'];
    $mail_account['IN_USERNAME'] = $mail_account['POP3_USERNAME'];
    $mail_account['IN_PASSWORD'] = $mail_account['POP3_PASSWORD'];
    $mail_account['IN_DELETEMSG'] = $mail_account['POP3_DELETEMSG'];
    return $mail_account;
}

function registerCareTableRecords(&$prmts) {
    $response = array('errormsg' => CLX_CHAR_EMPTY_STRING, 'contents' => CLX_CHAR_EMPTY_STRING);
    $mail_account = get_MAAC_mail_account($prmts['inbox']);
    if (empty($mail_account)) {
        $response['errormsg'] = dict('TOOL_UILG_ERR_NO_RECORD') . ': ' . $prmts['inbox'] . ' [MC-ER-030-B]';
        return $response;
    }
    $prmts['MAIL'] = gettool('MAIL');
    $prmts['MAIL']->IMAP_connect($mail_account, $prmts['folder']);
    if ($prmts['MAIL']->IMAP_errormsg != CLX_CHAR_EMPTY_STRING) {
        $response['errormsg'] = $MAIL->IMAP_errormsg;
        return $response;
    }
    $numMessages = $prmts['MAIL']->IMAP_get_numMessages();
    for ($i = $numMessages; $i > CLX_NUM_ZERO; $i--) {
        $uid = $prmts['MAIL']->IMAP_get_uid($i);
        $body = $prmts['MAIL']->IMAP_get_body($uid);
        $emailsFound = $prmts['MAIL']->parseTextForEmail($body, array($mail_account['EMAIL']));
        foreach ($emailsFound as $email_address) {
            registerCareTableAddEmail($email_address, $prmts);
            if(TGPV_IMAP_RB_1ST_EMAIL === '1') {
                // Sólo toma la 1era dirección email que encuentra en el mensaje
                break;
            }
        }
    }
    $prmts['MAIL']->IMAP_disconnect();
    return $response;
}

function registerCareTableAddEmail($email_address, &$prmts) {
    if(!isset($prmts['carename'])) {
        $prmts['carename'] = tableName('CARE');
    }
    if(!function_exists('setCreationData')) {
        includeCodeLib('GEN_REC_UTIL');
    }
    if (ClxCommon::$db->oneExistsRecords($prmts['carename'] . '/* 1 */', 'EMAIL=' . singleQuote($email_address)) === CLX_NUM_ZERO) {
        $record = array('email' => $email_address, 'cdate' => CLX_CHAR_EMPTY_STRING, 'mdate' => CLX_CHAR_EMPTY_STRING, 'createdby' => CLX_CHAR_EMPTY_STRING, 'modifiedby' => CLX_CHAR_EMPTY_STRING);
        setCreationData($record);
        ClxCommon::$db->createRecord($prmts['carename'], $record, false);
    }
}

function terminate_campaign($prmts, $campsection, $final_status, $final_msg, $write_log_file = true) {
    // Prepara Array para reportar eventual error y finalizar la campaña
    $record = array();
    $record['CEME_ID'] = '';  // Para identificar que la campaña terminó correctamente
    $record['OPERATION_TYPE'] = '';
    $record['CAMPSECTION_STATUS'] = $final_status;
    $record['PROCESS_MSG'] = $final_msg;
    // Update the section record
    ClxCommon::$db->updateRecord('MARK_CAMPSEC_EMAIL', $record, 'ID='.$campsection['ID']);
    ClxCommon::$db->commit();
    // Terminates send record
    CEML_record_end_ceme($prmts, $campsection['CEME_ID'], $final_status, $final_msg);
    // Send results email to campaign owner and throw statistics
    $send = send_email_to_owner_from_ceme($prmts, $campsection['CEME_ID']);
    // Report final status, final message and owner email send result
    $record['PROCESS_MSG'] =
        '<br>' .
        '<br>' . dict('GEN_LBL_STATUS') . ': ' . $final_status . ($prmts['RUN_FLAG'] ? CLX_CHAR_EMPTY_STRING : ' - BREAK CONDITION') .
        '<br>' . dict('GEN_LBL_RESULT') . ': ' . ($final_msg===CLX_CHAR_EMPTY_STRING ? dict('GEL_LBL_OPER_COMP_SUCCESS') : $final_msg) .
        '<br>' .
        '<br>Result\'s e-mail to Owner [' . $prmts['send_email_to_owner_to'] . '] = ' . $send .
        '<br>Sent from: ' . $prmts['send_email_to_owner_smtp_acc'];
    if($write_log_file === true) {
        // Write to log file
        markcamp_echo_and_log_write($prmts, $record['PROCESS_MSG']);
    } else {
        // Write to openWindow / step log because log file is not activated
        echo $record['PROCESS_MSG'];
    }
}

/**
 * Query
 * @param type $cqry
 * @param type $campsection
 * @param type $prmts
 * @return string
 */
function CEML_get_target_sql($cqry, &$campsection, &$prmts){
    // Se agrega /* CONTINUE_FLAG_CONDITION */ al SQL para poder insertar la eventual instrucciones
    // para continuar con la ejecución de la campaña
    $sql = 'SELECT CTGT.*, (SELECT IFNULL(1,0) FROM MARK_CAMPSEC_EMAIL_RES CEMR WHERE CEMR.CEME_ID='.$campsection['CEME_ID'].' AND CEMR.EMAIL=CTGT.EMAIL LIMIT 1) DONE FROM '.tableName('CTGT').' CTGT WHERE 1=1 AND CTGT.CQRY_CODE='.singleQuote($cqry['IDCODE']).' AND CTGT.EXCLUDED=0 AND CTGT.STATUS='.singleQuote('A'). ' AND CTGT.DELETED=0 AND CTGT.ID > <RECID> AND NOT EXISTS (SELECT CAEX.ID FROM MARK_CAMPSEC_EXCLUSIONS CAEX WHERE CAEX.EMAIL = CTGT.EMAIL) /* CONTINUE_FLAG_CONDITION */ ORDER BY CTGT.ID ASC';
    return $sql;
}

/**
 * Construye el query para la campana
 * @global type $db
 * @param type $cqry
 * @return type
 */
function CEML_get_query_sql($cqry, &$campsection, &$prmts){
    $DBQY = &getTool('DBQY');
    $queryrec = $DBQY->getQuery('MARK', $cqry['QUERYLIST_CODE']);//Informacion del query
    $cqrl_rec = get_camp_qry_field_names($cqry['QUERYLIST_CODE']); //Informacion de configuracion de lista de campana
    // Construye la lista de los campos que tendra el select segun campos de tabla ctgt, el cual se toma como standard a la hora de enviar el registro del target

    $ctgt_flds = array();
    $sql = 'SELECT DBTF.FIELDNAME FROM CLX_DB_TABLEFIELDS DBTF WHERE DBTF.TABLECODE = ' . singleQuote('CTGT') . ' ORDER BY DBTF.SEQNUM ASC';
    $rs = ClxCommon::$db->executeQuery($sql);
    while(($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE))) {
        $ctgt_flds[$r['FIELDNAME']] = array('null', $r['FIELDNAME']); //Item sera array('EXPRESION', 'ALIAS');
    }
    //Incorporar todos los campos que existan con el mismo nombre en las tablas asociadas a las consu;tas solo quedra con uno por campo
    $sql = 'SELECT DBTF.TABLECODE, DBTF.FIELDNAME FROM CLX_DB_QUERY_TABLES DBQT, CLX_DB_TABLEFIELDS DBTF WHERE DBTF.TABLECODE = DBQT.TABLECODE AND DBQT.QUERYCODE = '.singleQuote($cqry['QUERYLIST_CODE']).' AND EXISTS(SELECT DBTF2.ID FROM CLX_DB_TABLEFIELDS DBTF2 WHERE DBTF2.TABLECODE = '. singleQuote('CTGT') .' AND DBTF2.FIELDNAME = DBTF.FIELDNAME)';
    if(ClxCommon::$cached['b_mark_camp_debug']) 
        markcamp_log_write($prmts, '<br>CEML_get_query_sql:<br>' . $sql);
    $rs = ClxCommon::$db->executeQuery($sql);
    while(($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE))){
        $ctgt_flds[$r['FIELDNAME']] = array($r['TABLECODE'].'.'.$r['FIELDNAME'], $r['FIELDNAME']);
    }
    $add_crits = CLX_CHAR_EMPTY_STRING;
    $prmts['SORTCLAUSE'] = $queryrec['SORTCLAUSE'];
    //Remplazando aquellos campos que esten definidos explisitos en la consulta
    foreach($queryrec['COLUMNS'] as $k => $v){ //$k es alias ej: ACCO_FIELDNAME, $v es el registro del campo. Columnas del sql estan por lo menos en la definicion.
        $v['EXPRESSION_ONLY'] = trim($v['EXPRESSION_ONLY']);//borrar espacios en expresiones
        if(!empty($v['EXPRESSION_ONLY'])){
            $ctgt_flds[$v['FIELDNAME']] = array($v['EXPRESSION_ONLY'], $v['FIELDNAME']); //Campo en consulta puede tener una expresion en vez de caso
        }else{
            $ctgt_flds[$v['FIELDNAME']] = array($v['TABLECODE'].'.'.$v['FIELDNAME'], $v['FIELDNAME']);
        }
        //Agregando casos adicionles
        if( $v['FIELDNAME'] == $cqrl_rec['ID_FIELD']){
            $ctgt_flds['CONTACTID'] = array($v['TABLECODE'].'.'.$v['FIELDNAME'], 'CONTACTID');
            $ctgt_flds['REC_ID'] = array($v['TABLECODE'].'.'.$v['FIELDNAME'], 'REC_ID');
            if(empty($queryrec['SORTCLAUSE']) || $queryrec['SORTCLAUSE'] == ($v['TABLECODE'].'.'.$v['FIELDNAME'].' ASC')) {
                // Solo agrega el ID > <RECID> en caso que no tenga ORDER BY o que el ORDER BY del Query sea el ID
                $prmts['SORTCLAUSE'] = 'ID';
                // En caso que el query no tuviese ORDER BY, le agrega ORDER BY ID, sino lo deja como estaba
                $queryrec['SORTCLAUSE'] = (empty($queryrec['SORTCLAUSE']) ? ($v['TABLECODE'].'.'.$v['FIELDNAME']) : $queryrec['SORTCLAUSE']);
                $add_crits .= ' AND '.$v['TABLECODE'].'.'.$v['FIELDNAME'].' > <RECID>';
            }
        }
        if( $v['FIELDNAME'] == 'FULLNAME') {
            $ctgt_flds['FULLNAME'] = array($v['TABLECODE'].'.'.$v['FIELDNAME'], $v['FIELDNAME']);
        }
        if( $v['FIELDNAME'] === $cqrl_rec['EMAIL_FIELD'] ) {
            $ctgt_flds['EMAIL'] = array($v['TABLECODE'].'.'.$v['FIELDNAME'] , 'EMAIL');
            $ctgt_flds['DONE'] = array('(SELECT IFNULL(1,0) FROM MARK_CAMPSEC_EMAIL_RES CEMR WHERE CEMR.CEME_ID = '.$campsection['CEME_ID'].' AND CEMR.EMAIL = '.$v['TABLECODE'].'.'.$v['FIELDNAME'].' LIMIT 1)','DONE');
            $prmts['email_fld_name'] = $v['TABLECODE'].'.'.$v['FIELDNAME'];
            $ctgt_flds['OPTOUT'] =array('(SELECT CAEX.ID FROM MARK_CAMPSEC_EXCLUSIONS CAEX WHERE CAEX.EMAIL = '.$prmts['email_fld_name'].' LIMIT 1)', 'OPTOUT');
        }
        if( $v['FIELDNAME'] == $cqrl_rec['PHONE_FIELD']) {
            $ctgt_flds['PHONE'] = array($v['TABLECODE'].'.'.$v['FIELDNAME'], 'PHONE');
        }
    }
    //Preparando logica de fullname
    $ctgt_flds['CQRY_CODE'] = array(singleQuote($cqry['IDCODE']), 'CQRY_CODE');
    $ctgt_flds['CAMPAIGNCODE'] = array(singleQuote($cqry['CAMPAIGNCODE']), 'CAMPAIGNCODE');
    $ctgt_flds['QUERYCODE'] = array(singleQuote($cqry['QUERYLIST_CODE']), 'QUERYCODE');
    $ctgt_flds['CALL_DATE'] = array(singleQuote(xFormat::getNow()), 'CALL_DATE');
    $ctgt_flds['EMAIL_DATE'] = array('null', 'EMAIL_DATE');
    $ctgt_flds['EMAIL_STATUS'] = array(singleQuote('PEND'), 'EMAIL_STATUS');
    $ctgt_flds['STATUS'] = array(singleQuote('A'), 'STATUS');
    $ctgt_flds['EXCLUDED'] = array('0', 'EXCLUDED');
    $ctgt_flds['DELETED'] = array('0', 'DELETED');
    $queryrec['WHERECLAUSE'] = trim($queryrec['WHERECLAUSE']);
    $command_tail = (empty($queryrec['SORTCLAUSE']) ? CLX_CHAR_EMPTY_STRING : ' ORDER BY ' . $queryrec['SORTCLAUSE']);
    $command_tail .= (empty($queryrec['GROUPCLAUSE']) ? CLX_CHAR_EMPTY_STRING : ' GROUP BY ' . $queryrec['GROUPCLAUSE']);
    $queryrec['WHERECLAUSE'] = trim($queryrec['WHERECLAUSE']);
    $where_clause = (!empty($queryrec['WHERECLAUSE']))?' AND ' . $queryrec['WHERECLAUSE']:CLX_CHAR_EMPTY_STRING;
    $s_list_values = CLX_CHAR_EMPTY_STRING; $comma = CLX_CHAR_EMPTY_STRING;
    foreach($ctgt_flds as $k=>$v){
        $s_list_values .= $comma.$v[CLX_NUM_ZERO].' '.$v[CLX_NUM_ONE].CLX_CHAR_NL;
        $comma = ', ';
    }
    // Se agrega /* CONTINUE_FLAG_CONDITION */ al SQL para poder insertar la eventual instrucciones
    // para continuar con la ejecución de la campaña
    $sql = 'SELECT ' . $s_list_values . ' FROM ' . $queryrec['FROMCLAUSE'] . ' WHERE 1=1 '. $add_crits . ' ' . $where_clause . ' /* CONTINUE_FLAG_CONDITION */ ' . $command_tail;
    return $sql;
}

/**
 * Prepares Target Records
 * @global type $db
 * @param type $sql_string
 * @param type $page
 * @param type $campsection
 * @param type $prmts
 * @return type
 */
function CEML_run_sql_targets($CEML_part, $sql_string, $page, $campsection, &$prmts, $cqry_record){
    // Report parameter values to Schedule Log
    markcamp_echo_and_log_write($prmts, '<br>CQRY_IDCODE = ' . $cqry_record['IDCODE'] . ' [' . $CEML_part . ']');
    if(!empty($cqry_record['QUERYLIST_CODE'])) 
        markcamp_echo_and_log_write($prmts, '<br>CQRY_QUERYLIST_CODE = ' . $cqry_record['QUERYLIST_CODE']);
    markcamp_echo_and_log_write($prmts, '<br>' . xFormat::getNow('Y-m-d H:i:s') . '<br>');
    $lapse_secs_process = microtime_float();
    $i = CLX_NUM_ZERO;
    $lastid = CLX_NUM_ZERO;
    $count_sleep = CLX_NUM_ZERO;
    do{
        $commit_count = CLX_NUM_ZERO; $commit_every = $prmts['mark_camp_commit_every'];
        $j = CLX_NUM_ZERO;//mantiene el numero de registros seleccionado
        // Debido a que se está haciendo ya un filtro por el ACCO.ID > x,
        // el LIMIT debe siempre empezar desde 0
        // para evitar saltar miles de registros a medida que avanza el envio
        if($prmts['SORTCLAUSE'] != 'ID') {
            $sql = $sql_string . ' LIMIT ' . $i . ', ' . $page;
        } else {
            $sql = $sql_string . ' LIMIT 0, ' . $page;
        }
        $sql = str_replace('1=1',  'trim('.$prmts['email_fld_name'] . ') <>' . singleQuote(CLX_CHAR_EMPTY_STRING), $sql);
        // Se sustituye /* CONTINUE_FLAG_CONDITION */ por las instrucciones
        // para excluir aquellos correos ya enviados al continuar con la ejecución de la campaña
        if($prmts['CONTINUE_FLAG']) {
            $sql = str_replace('/* CONTINUE_FLAG_CONDITION */', 'AND ' . $prmts['email_fld_name'] . ' NOT IN (SELECT DISTINCT CEMR.EMAIL FROM MARK_CAMPSEC_EMAIL_RES CEMR WHERE CEMR.CEME_ID IN (SELECT CEME.ID FROM MARK_CAMPSEC_EMAIL_EXE CEME WHERE CEME.CEML_CODE = ' . singleQuote($campsection['IDCODE']) . '))', $sql);
        }
        if($prmts['SORTCLAUSE'] != 'ID') {
            $sql = str_replace('<RECID>', '0', $sql);
        } else {
            $sql = str_replace('<RECID>', $lastid, $sql);
        }
        // Escribe sql en el Log
        if(ClxCommon::$cached['b_mark_camp_debug']) 
            markcamp_log_write($prmts, '<br>' . $sql . '<br><br>');
	$q123 = microtime_float();
        markcamp_log_write($prmts, '<br>SQL SELECT | BEGIN: ' . xFormat::getNow('Y-m-d H:i:s'));
        $rs = ClxCommon::$db->executeQuery($sql);
        $q123 = (microtime_float()-$q123);
        $prmts[$CEML_part . '_lapse_secs_sql'] += $q123;
        markcamp_log_write($prmts, ' -> END: ' . xFormat::getNow('Y-m-d H:i:s') . ' | Elapse (secs): ' . $q123);
        while(($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE))) {
            $lastid = $r['REC_ID'];
            // Se agregó a CEML_send_mail() que devuelva TRUE si pudo enviar el correo
            // En el resto de los casos, devuelve FALSE
            $sm_result = CEML_send_mail($r, $campsection, $prmts);
            $j++;
            $commit_count++;
            $prmts[$CEML_part . '_email_processed']++;
            if($sm_result['sent'] === true) {
                $prmts[$CEML_part . '_email_sent']++;
            }
            // Escribe ID e Email en el Log
            markcamp_log_write($prmts, '<br>' . $prmts[$CEML_part . '_email_processed'] . ') ' . xFormat::getNow('Y-m-d H:i:s') . ' - ID=' . $lastid . ' - ' . $r['EMAIL'] . ' [' . ($sm_result['sent'] === true ? 'SENT' : 'NO SENT') . '] ' . $sm_result['msg']);
            $prmts[$CEML_part . '_lapse_secs_sql'] += $sm_result['lapse_secs_sql'];
            $prmts[$CEML_part . '_lapse_secs_smtp'] += $sm_result['lapse_secs_smtp'];
            //commits en cada 10
            if($commit_count>=$commit_every){
                $q123 = microtime_float();
                CEML_update_ceme_total_sent($prmts, $campsection['CEME_ID'], array());
                ClxCommon::$db->commit();
                $prmts[$CEML_part . '_lapse_secs_sql'] += (microtime_float()-$q123);
                $commit_count = CLX_NUM_ZERO;
            }
            $count_sleep++;
            if ($count_sleep>=$prmts['mark_camp_sleep_records']) {
                markcamp_echo_and_log_write($prmts, '<br>Pause of ' . $prmts['mark_camp_sleep_time'] . ' seconds each ' . $prmts['mark_camp_sleep_records'] . ' records...');
                do_mark_camp_auto_resume($campsection, $prmts);
                $count_sleep=0;
            }
            if(!$prmts['RUN_FLAG']) {
                break;
            }
        }
        $i += $page;
        //Si el numero de registros en mayor o igual a la paginacion continuar proximo
        $flag = ($j===CLX_NUM_ZERO || $j<$page)?false:true;
        //if($i==3000) break;//cortando para pruebas eliminar
        //check if error and return
        if(!$prmts['RUN_FLAG']) {
            $flag = false;
            break;
        }
    } while($flag);
    ClxCommon::$db->commit();
    $prmts[$CEML_part . '_lapse_secs_process'] += (microtime_float()-$lapse_secs_process);
    markcamp_echo_and_log_write($prmts, '<br><br>' . xFormat::getNow('Y-m-d H:i:s') . ' - Emails Sent = ' . $prmts[$CEML_part . '_email_sent'] . ', Processed = ' . $prmts[$CEML_part . '_email_processed']);
    if(!$prmts['RUN_FLAG']) 
        markcamp_echo_and_log_write($prmts, '<br><br>ATTENTION: BREAK CONDITION !!!!');
    markcamp_echo_and_log_write($prmts, '<br>');
    return $i;
}

function markcamp_echo_and_log_write(&$prmts, $line) {
    echo $line;
    return markcamp_log_write($prmts, $line);
}

function markcamp_log_write(&$prmts, $line) {
    $line = str_replace('<br>', CLX_CHAR_NL, $line);
    $line = str_replace('<br/>', CLX_CHAR_NL, $line);
    $line = str_replace('<br />', CLX_CHAR_NL, $line);
    $line = decode_string($line); // 2018-05-05 CR Para que no salga garabatos en el Log
    if(isset($prmts['mark_camp_log_handle'])) {
        $prmts['mark_camp_log_handle']->write($line);
    }
    return true;
}

/**
 * Records result for email
 * @global type $db
 * @param type $record
 * @param type $campsection
 * @param type $prmts
 * @param type $result_code
 * @param type $result_msg
 * @param type $to
 * @param type $from_rec_ownercode
 */
function CEML_record_cemr(&$record, &$campsection, &$prmts, $result_code = '', $result_msg = '', $to = '', $from_rec_ownercode=''){
    $camptarget_name = CLX_CHAR_EMPTY_STRING;
    if(isset($record['FULLNAME'])) {
        $camptarget_name = $record['FULLNAME'];
    }
    if( ($camptarget_name === $to || trim($camptarget_name) === CLX_CHAR_EMPTY_STRING || $camptarget_name === '.') && isset($record['FIRSTNAME']) && isset($record['LASTNAME']) ) {
        $camptarget_name = trim($record['FIRSTNAME'] . ' ' . $record['LASTNAME']);
    }
    if($camptarget_name === CLX_CHAR_EMPTY_STRING) {
        $camptarget_name = $to;
    }
    //Build result
    $r = array( 'CEME_ID' => $campsection['CEME_ID'],
                'EXEC_DATE' => date('Y-m-d H:i:s'),
                'RESULT_CODE' => $result_code,
                'RESULT_MSG' => $result_msg,
                'EMAIL' => get_email_for_sqls($record['EMAIL']),
                'CAMPTARGET_NAME' => $camptarget_name,
                'CONTACTID' => $record['ID'],
                'CAMPTARGET_ID' => $record['PRIMARY_KEY'],
                'OWNERCODE' => $from_rec_ownercode);
    ClxCommon::$db->createRecord('MARK_CAMPSEC_EMAIL_RES', $r, false);
}

function get_email_for_sqls($email) {
    $email = addslashes($email);
    return $email;
}

//--------------------------------------------------
//--------------------------------------------------
//--------------------------------------------------

/*
  Updates the repeated emails that will never be send
 */
function replace_repeated($campaigncode) {
    $record = array(
        'RESULT_CODE' => 'REPEATED',
        'EMAIL_STATUS' => 'DENY'
    );
    ClxCommon::$db->updateRecord('MARK_CAMPAIGN_TARGETS', $record, 'CAMPAIGNCODE=' . singleQuote($campaigncode) . ' AND DELETED=0 AND STATUS = ' . singleQuote('A') . ' AND EXCLUDED = 0 AND EMAIL_STATUS = ' . singleQuote('PEND') . ' AND (RESULT_CODE = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' OR RESULT_CODE IS NULL)');
}


//--------------------------------------------------
//--------------------------------------------------
//--------------------------------------------------

/**
 * Runs email campaign
 * @global type $db
 * @param type $record
 * @param type $campsection
 * @param type $prmts
 * @return type
 */
function CEML_send_mail(&$record, &$campsection, &$prmts){
    $response = array();
    $response['sent'] = true;
    $response['msg'] = '';
    $response['lapse_secs_sql'] = CLX_NUM_ZERO;
    $response['lapse_secs_smtp'] = CLX_NUM_ZERO;
    //Casos previos
    if(empty($campsection['CEME_ID'])){
        // Campana invalida : detener
        /*
         * Registra en la trampa de errores la detencion de la campaña para el caso de campo CEME_ID vacio
         * (campo que apunta a la tabla CEML de Sección de la Campaña desde la tabla CEME de
         * Ejecución de Sección de Email - CEME.CEML_CODE = CEML.IDCODE)
         */
        /*
         * GEN_ERR_MARK_NO_CEME
         * Error: Empty campaign execution ID
         * Error: ID de Ejecución de Campaña está vacio
         */
        $errmsg_short = dict('GEN_ERR_MARK_NO_CEME');
        /*
         * GEN_LBL_MARK_CAMPSEC
         * Sección de Campaña: ^1
         * Campaign Section: ^1
         *
         * GEN_LBL_MARK_CAMP
         * Campaign: ^1
         * Campaña: ^1
         */
        $errmsg_long = $errmsg_short . ', ' . dict('EMAIL') . ': "' . $record['EMAIL'] . '", ' . dict('GEN_LBL_MARK_CAMPSEC', $campsection['IDCODE']) . ', ' . dict('GEN_LBL_MARK_CAMP', $campsection['CAMPAIGNCODE']);
        error_trap_register($errmsg_short, $errmsg_long, __LINE__, $prmts);
        $prmts['RUN_FLAG'] = false;
        $response['sent'] = false;
        $response['msg'] = $errmsg_short;
        return $response;
    }
    $email = trim($record['EMAIL']);
    //Verificar si ya fue enviado o regresar
    $q123 = microtime_float();
    $condition = 'CEME_ID = '.$campsection['CEME_ID'].' AND EMAIL = '. singleQuote(get_email_for_sqls($email));
    // 2018-05-05 CR - La verificacion de "ya enviado" excluye los casos de emails en blanco
    if(!empty($email) && !strpos($email, '@') === false && !strpos($email, '.') === false){
        if(!empty($record['DONE']) /*|| ClxCommon::$db->oneExistsRecords('MARK_CAMPSEC_EMAIL_RES', $condition) > CLX_NUM_ZERO*/) {
            //ya se realizo el envio
            $response['lapse_secs_sql'] += (microtime_float()-$q123);
            $response['sent'] = false;
            $response['msg'] = 'Already sent';
            return $response;
        }
    }
    if(!is_null($record['OPTOUT']) && $record['OPTOUT']>0){
        // Esta en lista de exclusión
        $response['lapse_secs_sql'] += (microtime_float()-$q123);
        $response['sent'] = false;
        $response['msg'] = 'Unsubscribed';
        return $response;
    }
    $response['lapse_secs_sql'] += (microtime_float()-$q123);
    if(empty($email) || strpos($email, '@') === false || strpos($email, '.') === false){
        //Build result
        $q123 = microtime_float();
        CEML_record_cemr($record, $campsection, $prmts, 'ERROR', dict('GEN_ERR_EXPECTING_EMAIL'), $email, $prmts['FROM_REC']['OWNERCODE']);
        $response['lapse_secs_sql'] += (microtime_float()-$q123);
        //email invalido o campana invalida
        $response['sent'] = false;
        $response['msg'] = dict('GEN_ERR_EXPECTING_EMAIL');
        return $response;
    }
    //Insertar registro de resultado
    $campsection['CONTENTS'] = $prmts['CONTENTS'];
    $campsection['CONTENTS_TXT'] = $prmts['CONTENTS_TXT'];
    $record['PRIMARY_KEY'] = $record['ID'];
    $record['CAMPTARGET_ID'] = $record['ID'];
    // The from and reply to fields...
    $from_rec = $prmts['FROM_REC'];
    $reply_rec = $prmts['REPLAY_REC'];
    // To email address...
    $to = $record['EMAIL'];
    $fullname = str_replace(',','',$record['FULLNAME']);
    $fullname = str_replace('.','',$fullname);
    $fullname = str_replace('null','',$fullname);
    // Take care of the subject field...
    $template_subject = $campsection['SUBJECT'];
    $subject = $template_subject;
    foreach($record as $key=>$value) {
        $subject = str_replace ('['.$key.']', $value, $subject);
        $subject = str_replace ('!'.$key, $value, $subject);
    }
    // El 'Subject' se convierte a ASCCI para evitar los garabatos
    $subject = decode_string($subject);
    // The Output Generator manager (templates)
    $UITM = &getTool('UITM');
    $templates = $UITM->replace($campsection['CONTENTS'], $campsection['CONTENTS_TXT'], $record);
    // 2018-05-05 CR - Se agrega decode_string() para que no aparezca garabatos en el cuerpo del mensaje...
    $text_body = str_replace('</BODY>',  '</body>', decode_string($templates['CONTENTS_TXT']));
    $html_body = str_replace('</BODY>',  '</body>', decode_string($templates['CONTENTS']));
    // add the sender signature
    if(!empty($from_rec['SIGNATURE'])) {
        // Se convierte a ASCCI para evitar los garabatos
        // El mensaje era algo como: Este correo ha sido enviado a usted por el Banco Nacional de PanamÃ¡ a la direcciÃ³n electrÃ³nica que mantenemos en nuestra base de datos. Por ser este un correo automatizado, le agradecemos no conteste a este mensaje.
        // Para que convierta UTF-8 de la firma a ASCCI pero conservando los eventuales códigos HTML
        $from_rec['SIGNATURE'] = decode_string($from_rec['SIGNATURE'], 'ISO-8859-1', 'UTF-8');
        if (strpos($text_body, '</body>')!==false) {
            $text_body = str_replace('</body>',  $from_rec['SIGNATURE'].'</body>', $text_body);
        } else {
            $text_body .= $from_rec['SIGNATURE'];
        }
        $s_sign_w_br = str_replace(CLX_CHAR_NL, '<br>', $from_rec['SIGNATURE']);
        $s_sign_w_br = TildesHtml($s_sign_w_br);    // Convierte acentos a &xacute; y tildes a &xtilde;
        if (strpos($html_body, '</body>')!==false) {
            $html_body = str_replace('</body>',  $s_sign_w_br . '</body>', $html_body);
        } else {
            $html_body .= $s_sign_w_br;
        }
    }
    // add the email tracer thingy...
    if ($campsection['INCLUDE_EMAIL_TRACER']) {
        $tracercode = '<img height="1" width="1" border="0" src="'.$prmts['MARK_CAMP_OPTOUT_PROG'].'?sc='.$campsection['IDCODE'].'&tg='.$email.'&ceme='.$campsection['CEME_ID'].'">';
        // El texto dentro del código HTML 'Opt-Out' se convierte a ASCCI para evitar los garabatos
        $tracercode = decode_tracercode($tracercode);
        $html_body .= $tracercode;
    }
    // add the optout form...
    if($campsection['OPTOUT_FORM']){
        //variables tg=X&tgty=1. tg for target and tgty=1 for unsbscribe
        if(empty($campsection['OPTOUT_MSG'])) {
            $tracercode = $prmts['MARK_CAMP_OPTOUT_MSG'];
        } else {
            $tracercode = $campsection['OPTOUT_MSG'];
        }
        $tracercode = str_replace('<-unsubcribe->',$prmts['MARK_CAMP_OPTOUT_PROG'].'?sc='.$campsection['IDCODE'].'&ceme='.$campsection['CEME_ID'].'&tg='.$email.'&tgty=1',$tracercode);
        // El texto dentro del código HTML 'Opt-Out' se convierte a ASCCI para evitar los garabatos
        $tracercode = decode_tracercode($tracercode);
        $html_body .= $tracercode;
    }
    // SEND EMAIL
    $s_result_msg = '';
    $status = true;
    if($campsection['SEND_ALL_EMAILS']){
        $smtp_response = mark_camp_send_one_mail($prmts, $from_rec, $reply_rec, $email, $fullname, $subject, $text_body, $html_body, $prmts['attachments']);
        $status = (!$smtp_response['error']);
        $s_result_msg = $smtp_response['errormsg'];
        $response['lapse_secs_smtp'] = $smtp_response['lapse_secs_smtp'];
        $mail_send_result = $smtp_response['mail_send_result'];
    }
    if ($campsection['SAVE_EMAILS']) {
        $timestamp = xFormat::getNow('Y-m-d H:i:s');
        $r = array(
            'OWNERCODE' => $from_rec['OWNERCODE'],
            'SUBJECT' => addslashes($subject),
            'FROM_EMAIL' => $from_rec['EMAIL'],
            'TO_EMAIL' => $to,
            'MIME_TYPE_PRIMARY' => 'html',
            'MIME_TYPE_SECONDARY' => 'text',
            'MIME_ENCODING' => CLX_CHAR_EMPTY_STRING,
            'SEND_DATE' => ($campsection['SEND_ALL_EMAILS'])?$timestamp:'',
            'CDATE' => $timestamp,
            'MDATE' => $timestamp,
            'EMAIL_TREE' => 'AAAA',
            'EMAIL_CONTENTS' => $html_body,
            'EMAIL_DIRECTION' => 'OUT',
            'CAMPAIGN_CODE' => $campsection['CAMPAIGNCODE'],
            'CEML_CODE' => $campsection['IDCODE'],
            'CAMPTARGET_ID' => $record['PRIMARY_KEY'],
            'CEME_ID'=>$campsection['CEME_ID']);
        $q123 = microtime_float();
        ClxCommon::$db->createRecord('BASE_EMAIL', $r, false);
        $response['lapse_secs_sql'] += (microtime_float()-$q123);
    }
    //update target status
    if($campsection['SEND_ALL_EMAILS']){
        // create a record for the results
        if (is_object($mail_send_result)) {
            if (PEAR::isError($mail_send_result)) {
                //si el error es 10001 entonces hay un error de conexion por lo que hay que mandar a detener el proceso.
                if($mail_send_result->getCode()=='10001'){
                    /*
                     * Registra en la trampa de errores la detencion de la campaña por error 10001
                     * enviado por el servidor SMTP, lo que significa que hubo un error de conexion
                     */
                    /*
                     * GEN_ERR_MARK_SMTP_E01
                     * SMTP: Error ^1 en envio de Email
                     * SMTP: Email sending Error ^1
                     */
                    $errmsg_short = dict('GEN_ERR_MARK_SMTP_E01', $mail_send_result->getCode());
                    /*
                     * GEN_LBL_MARK_CAMPSEC
                     * Sección de Campaña: ^1
                     * Campaign Section: ^1
                     *
                     * GEN_LBL_MARK_EXEID
                     * Execution Id: ^1
                     * Id de la ejecución: ^1
                     */
                    $errmsg_long = $errmsg_short . ', ' . dict('GEN_LBL_MARK_EXEID', $campsection['CEME_ID']) . ', ' . dict('EMAIL') . ': ' . $to . ', ' . dict('GEN_LBL_MARK_CAMPSEC', $campsection['IDCODE']) . ', ' . dict('GEN_LBL_MARK_CAMP', $campsection['CAMPAIGNCODE']);
                    error_trap_register($errmsg_short, $errmsg_long, __LINE__, $prmts);
                    $prmts['RUN_FLAG']=false;
                    do_mark_camp_auto_resume($campsection, $prmts);
                }
                $s_result_code_int = $mail_send_result->getCode();
                if(!empty($s_result_code_int)) $s_result_code_int = ' (' . $s_result_code_int . ')';
                $s_result_msg = $mail_send_result->getMessage();
                if(empty($s_result_msg)) $s_result_msg = $mail_send_result->message;
                $s_result_msg .= $s_result_code_int;
                $s_result_code = 'ERROR';
                $response['sent'] = false;
            } else {
                // Pudo enviar el correo
                $s_result_code = 'SENT';
            }
        } elseif (is_null($mail_send_result) || $mail_send_result == false) {
            $s_result_code = 'ERROR';
            $response['sent'] = false;
        } elseif ($mail_send_result == true) {
            // Normalmente cuando el correo se logra enviar, pasa por acá...
            $s_result_code = 'SENT';
        }
    }else{
        $s_result_code = 'END';
        $s_result_msg = 'TEST RUN';
    }
    //Build result
    $q123 = microtime_float();
    CEML_record_cemr($record, $campsection, $prmts, $s_result_code, $s_result_msg, $to, $from_rec['OWNERCODE']);
    $response['lapse_secs_sql'] += (microtime_float()-$q123);
    $response['msg'] = $s_result_msg;
    return $response;
}

/**
 * Convierte las tildes de un texto a sus entidades HTML.
 * @param string $cadena Cadena a modificar.
 * @return string Cadena de texto con codigos html.
 */
function TildesHtml($cadena) {
   return str_replace(array('á','é','í','ó','ú','ñ','Á','É','Í','Ó','Ú','Ñ'), array('&aacute;','&eacute;','&iacute;','&oacute;','&uacute;','&ntilde;', '&Aacute;','&Eacute;','&Iacute;','&Oacute;','&Uacute;','&Ntilde;'), $cadena);
}

function do_mark_camp_auto_resume($campsection, &$prmts) {
    if($prmts['mark_camp_auto_resume'] === CLX_NUM_ONE) {
        // Si el flag de resumen automatico esta activado
        // y la sección de email sigue en marcha...
        if(ClxCommon::$db->oneExistsRecords('MARK_CAMPSEC_EMAIL', 'IDCODE = ' . singleQuote($campsection['IDCODE']) . ' AND CAMPSECTION_STATUS = ' . singleQuote('WORK') . ' AND DELETED = 0') > CLX_NUM_ZERO) {
            // Hace una pausa...
            sleep($prmts['mark_camp_sleep_time']);
            // Continua con el envío...
            $prmts['RUN_FLAG']=true;
        } else {
            // Detiene el envio, porque el usuario dio la orden
            $prmts['RUN_FLAG']=false;
            do_stopped_by_user_exception($campsection, $prmts);
        }
    }
}

function do_stopped_by_user_exception($campsection, $prmts) {
    /*
     * GEN_LBL_MARK_EXEID
     * Execution Id: ^1
     * Id de la ejecución: ^1
     */
    $errmsg_short = dict('GEN_LBL_MARK_EXEID', ($campsection['CEME_ID'] . ': ' . /* Detenido */ dict('GEN_LBL_STOPPED') . ' (' . /* (enviado por el usuario) */ dict('GEN_LBL_SENTBY_USER') . ')' ));
    /*
     * GEN_LBL_MARK_CAMPSEC
     * Sección de Campaña: ^1
     * Campaign Section: ^1
     */
    $errmsg_long = $errmsg_short . ', ' . dict('GEN_LBL_MARK_CAMPSEC', $campsection['IDCODE']) . ', ' . dict('GEN_LBL_MARK_CAMP', $campsection['CAMPAIGNCODE']);
    error_trap_register($errmsg_short, $errmsg_long, __LINE__, $prmts);
}

function decode_tracercode($tracercode) {
    // El texto dentro del código HTML 'Opt-Out' se convierte a ASCCI para evitar los garabatos
    $search_str = strip_tags($tracercode);
    $replace_str = decode_string($search_str);
    $response = str_replace($search_str, $replace_str, $tracercode);
    return $response;
}

function error_trap_register($errmsg_short, $errmsg_long, $linenum, $prmts) {
    // Registra error en trampa de errores
    $BUGS = &getTool('BUGS');
    $BUGS->report(E_USER_WARNING, $errmsg_short, UserRequest::$server['SCRIPT_NAME'], $linenum, UserRequest::$request, CLX_NUM_ZERO, $errmsg_long);
    // Registra error en excepciones, para que el status final del cronograma ser ENDR
    $prmts['o_proc_eng_params']->report_exceptions($errmsg_long);
    $prmts['run_error'] = true;
}

//--------------------------------------------------
//--------------------------------------------------
//--------------------------------------------------

function fullemailaddress($mail_account_rec) {
    if ($mail_account_rec === CLX_CHAR_EMPTY_STRING)
        return CLX_CHAR_EMPTY_STRING;
    return get_name_email((isset($mail_account_rec['IDNAME']) ? $mail_account_rec['IDNAME'] : CLX_CHAR_EMPTY_STRING), $mail_account_rec['EMAIL']);
}

function ctml_buld_result($questionarycode, $campsection_tele_code){

        $questionary = ClxCommon::$db->getRecord('CLX_AN_QUESTIONARIES',"IDCODE = '".$questionarycode."'");			
        $result_tablecode = $questionary['RESULT_TABLECODE']; 	

        $b_err = false;
        if(empty($result_tablecode)) {
                /*
                    * GEN_ERR_MARKQUESTNOTFND
                    * Cuestionary '^1' doesn't exists or is uncorrectly defined (Code ^2 on Telemarketing Section)
                    * Cuestionario '^1' no existe o no está definido correctamente (Código ^2 en la Sección de Telemarketing)
                    */
                echo "<br>" .
                        dict('GEN_ERR_MARKQUESTNOTFND', $questionarycode, $campsection_tele_code);
                $b_err = true;
        } elseif(ClxCommon::$db->countRecords('CLX_DB_TABLES', "IDCODE = '$result_tablecode'")==0){
                /*
                    * GEN_ERR_MARKRESTBNOTFND
                    * Table "^3" of Cuestionary "^1" doesn't exists (Code ^2 on Telemarketing Section)
                    * Tabla "^3" del Cuestionario "^1" no existe (Código ^2 en la Sección de Telemarketing)
                    */
                echo "<br>" .
                        dict('GEN_ERR_MARKRESTBNOTFND', $questionarycode, $campsection_tele_code, $result_tablecode);
                $b_err = true;
        }
        if($b_err) {
                return;
        }

        $has_target = false;

        //0. init listings, forms, query

        //CLX_UI_LISTING_BUTTONS LISTINGCODE
        $UILG = getTool('UILG');
        $id = ClxCommon::$db->getField($UILG->tablename, "ID", "IDCODE = '$result_tablecode'");
        if(!empty($id)) $UILG->deleteRecordSk($id);
		
        $DBQY = getTool("DBQY");
        $id = ClxCommon::$db->getField($DBQY->tablename, "ID", "IDCODE = '$result_tablecode'");
        if(!empty($id)) $DBQY->deleteRecordSk($id);

        $UIFM = getTool("UIFM");
        $id = ClxCommon::$db->getField($UIFM->tablename, "ID", "IDCODE = '$result_tablecode'");
        if(!empty($id)) $UIFM->deleteRecordSk($id);
		

        //1. Creates ui (Forms, listing, etc) if not exists
		//$aja = ClxCommon::$db->countRecords('CLX_UI_LISTINGS', "IDCODE = '$result_tablecode'");
		//echo $result_tablecode; die;
        if(ClxCommon::$db->countRecords('CLX_UI_LISTINGS', "IDCODE = '$result_tablecode'")==0){
                $DBTB = getTool("DBTB");				
                $DBTB->create_ui(array(ClxCommon::$db->getField($DBTB->tablename, "ID", "IDCODE = '$result_tablecode'")));

                //2. Add all fields to listing query
                $sql = "INSERT INTO 
                        CLX_DB_QUERY_FIELDS 
                                (QUERYCODE, 
                                TABLECODE, 
                                FIELDNAME, 
                                SORT, 
                                VISIBLE, 
                                FILTER, 
                                SEQNUM, 
                                GROUPED) 
                        SELECT 
                                '".$result_tablecode."' QUERYCODE, 
                                TABLECODE, 
                                FIELDNAME, 
                                0 SORT, 
                                1 VISIBLE, 
                                0 FILTER, 
                                0 SEQNUM, 
                                0 GROUPED 
                        FROM CLX_DB_TABLEFIELDS 
                        WHERE TABLECODE = '".$result_tablecode."'
                        AND FIELDNAME NOT LIKE '".$questionary['IDCODE']."%'
                        ORDER BY SEQNUM ASC ";		
                ClxCommon::$db->executeQuery($sql);

                $sql = "INSERT INTO 
                        CLX_DB_QUERY_FIELDS 
                                (QUERYCODE, 
                                TABLECODE, 
                                FIELDNAME, 
                                SORT, 
                                VISIBLE, 
                                FILTER, 
                                SEQNUM, 
                                GROUPED) 
                        SELECT 
                                '".$result_tablecode."' QUERYCODE, 
                                TABLECODE, 
                                FIELDNAME, 
                                0 SORT, 
                                1 VISIBLE, 
                                0 FILTER, 
                                1 SEQNUM, 
                                0 GROUPED 
                        FROM CLX_DB_TABLEFIELDS 
                        WHERE TABLECODE = '".$result_tablecode."'
                        AND FIELDNAME LIKE '".$questionary['IDCODE']."%'
                        ORDER BY FIELDNAME ASC ";
                ClxCommon::$db->executeQuery($sql);
				
				$temp = 'CAMPTARGET_ID';
				$temp2 = 'RESULT_CODE';
				

				$sql = "DELETE  FROM CLX_DB_QUERY_FIELDS WHERE QUERYCODE ='".$result_tablecode."' AND FIELDNAME = '".$temp."'";
				ClxCommon::$db->executeQuery($sql);
				$sql = "DELETE  FROM CLX_DB_QUERY_FIELDS WHERE QUERYCODE ='".$result_tablecode."' AND FIELDNAME = '".$temp2."'";
				ClxCommon::$db->executeQuery($sql);

                $DBTF = getTool('DBTF');
                
                if($DBTF->fieldExists($result_tablecode, $temp)){   

                        $sql = "INSERT INTO 
                                 CLX_DB_QUERY_FIELDS 
                                        (QUERYCODE, 
                                        TABLECODE, 
                                        FIELDNAME, 
                                        SORT, 
                                        VISIBLE, 
                                        FILTER, 
                                        SEQNUM, 
                                        GROUPED) 
                                SELECT 
                                        '".$result_tablecode."' QUERYCODE, 
                                        TABLECODE, 
                                        FIELDNAME, 
                                        0 SORT, 
                                        1 VISIBLE, 
                                        0 FILTER, 
                                        2 SEQNUM, 
                                        0 GROUPED 
                                FROM CLX_DB_TABLEFIELDS 
                                WHERE TABLECODE = 'CTGT' 
                                        AND FIELDNAME NOT IN ('CONTACTID','ID','REC_ID',
                                                'EMAIL_STATUS','EMAIL_DATE','RESULT_MSG',
                                                'RESULT_CODE','CAMPAIGNCODE','QUESTIONARY_CODE',
                                                'CREATEDBY','QUERYCODE','MODIFIEDBY','CDATE',
                                                'MDATE','CALL_DATE')
                                ORDER BY SEQNUM ASC";
                        //$db->executeQuery($sql);
                        //ADDING RESCHEDULE FIELD
                        $sql = "INSERT INTO 
                                                CLX_DB_QUERY_FIELDS 
                                        (QUERYCODE, 
                                        TABLECODE, 
                                        FIELDNAME, 
                                        SORT, 
                                        VISIBLE, 
                                        FILTER, 
                                        SEQNUM, 
                                        GROUPED) 
                                SELECT 
                                        '".$result_tablecode."' QUERYCODE, 
                                        TABLECODE, 
                                        FIELDNAME, 
                                        0 SORT, 
                                        1 VISIBLE, 
                                        0 FILTER, 
                                        2 SEQNUM, 
                                        0 GROUPED 
                                FROM CLX_DB_TABLEFIELDS 
                                WHERE TABLECODE = 'CTER' 
                                        AND FIELDNAME IN ('RESULT_CODE','CALL_USER','CALL_DATE','CAMPTARGET_NAME','EMAIL','PHONE','MOBILE_PHONE','HOME_PHONE')
                                ORDER BY SEQNUM ASC";								
                        //cartesiano con tabla cetr falta id de resultados para poder 
                        //verlo correctamente
                        ClxCommon::$db->executeQuery($sql);
                        $has_target = true;
                        $rec = array("QUERYCODE"=>$result_tablecode, "TABLECODE"=>'CTGT', "INVISIBLE"=>0);
                       // $db->createRecord('CLX_DB_QUERY_TABLES', $rec);
                        $rec = array("QUERYCODE"=>$result_tablecode, "TABLECODE"=>'CTMK', "INVISIBLE"=>0);
                        ClxCommon::$db->createRecord('CLX_DB_QUERY_TABLES', $rec);
                        //cartesiano con resultado la idea era mostrar el agente que  llama
                        $rec = array("QUERYCODE"=>$result_tablecode, "TABLECODE"=>'CTER', "INVISIBLE"=>0);
                        ClxCommon::$db->createRecord('CLX_DB_QUERY_TABLES', $rec);
                        $rec = array(
                                                /*array("QUERYCODE"=>$result_tablecode,
                                                        "LOGICAL"=>"AND",
                                                        "TABLECODE"=>$result_tablecode,
                                                        "FIELDNAME"=>"CAMPTARGET_ID",
                                                        "OPERATOR"=>"EQ",
                                                        "TYPE"=>"f",
                                                        "VALUE"=>"CTGT.ID",
                                                        "OPEN_BRACKETS"=>"",
                                                        "CLOSE_BRACKETS"=>"",
                                                        "SEQNUM"=>"100",
                                                        "SPECIAL"=>"0"),
                                                array("QUERYCODE"=>$result_tablecode,
                                                        "LOGICAL"=>"AND",
                                                        "TABLECODE"=>'CTGT',
                                                        "FIELDNAME"=>"ID",
                                                        "OPERATOR"=>"EQ",
                                                        "TYPE"=>"f",
                                                        "VALUE"=>$result_tablecode.".CAMPTARGET_ID",
                                                        "OPEN_BRACKETS"=>"",
                                                        "CLOSE_BRACKETS"=>"",
                                                        "SEQNUM"=>"100",
                                                        "SPECIAL"=>"0"),*/
                                                array("QUERYCODE"=>$result_tablecode,
                                                        "LOGICAL"=>"AND",
                                                        "TABLECODE"=>'CTMK',
                                                        "FIELDNAME"=>"IDCODE",
                                                        "OPERATOR"=>"EQ",
                                                        "TYPE"=>"f",
                                                        "VALUE"=>$result_tablecode.".CAMPSECTION_TELE_CODE",
                                                        "OPEN_BRACKETS"=>"",
                                                        "CLOSE_BRACKETS"=>"",
                                                        "SEQNUM"=>"100",
                                                        "SPECIAL"=>"0"),
                                        /*	cartesiano con resultado la idea era mostrar el agente que  llama*/
                                             array("QUERYCODE"=>$result_tablecode,
                                                        "LOGICAL"=>"AND",
                                                        "TABLECODE"=>'CTER',
                                                        "FIELDNAME"=>"CAMPSECTION_TELE_CODE",
                                                        "OPERATOR"=>"EQ",
                                                        "TYPE"=>"f",
                                                        "VALUE"=>$result_tablecode.".CAMPSECTION_TELE_CODE",
                                                        "OPEN_BRACKETS"=>"",
                                                        "CLOSE_BRACKETS"=>"",
                                                        "SEQNUM"=>"100",
                                                        "SPECIAL"=>"0"),
                                                /*array("QUERYCODE"=>$result_tablecode,
                                                        "LOGICAL"=>"AND",
                                                        "TABLECODE"=>'CTER',
                                                        "FIELDNAME"=>"CAMPTARGET_ID",
                                                        "OPERATOR"=>"EQ",
                                                        "TYPE"=>"f",
                                                        "VALUE"=>$result_tablecode.".CAMPTARGET_ID",
                                                        "OPEN_BRACKETS"=>"",
                                                        "CLOSE_BRACKETS"=>"",
                                                        "SEQNUM"=>"100",
                                                        "SPECIAL"=>"0"),*/
												array("QUERYCODE"=>$result_tablecode,
                                                        "LOGICAL"=>"AND",
                                                        "TABLECODE"=>'CTER',
                                                        "FIELDNAME"=>"ID",
                                                        "OPERATOR"=>"EQ",
                                                        "TYPE"=>"f",
                                                        "VALUE"=>$result_tablecode.".CAMPTELERES_ID",
                                                        "OPEN_BRACKETS"=>"",
                                                        "CLOSE_BRACKETS"=>"",
                                                        "SEQNUM"=>"100",
                                                        "SPECIAL"=>"0"),
                                                array("QUERYCODE"=>$result_tablecode,
                                                        "LOGICAL"=>"AND",
                                                        "TABLECODE"=>$result_tablecode,
                                                        "FIELDNAME"=>"CAMPSECTION_TELE_CODE",
                                                        "OPERATOR"=>"EQ",
                                                        "TYPE"=>"f",
                                                        //"VALUE"=>"CTMK.IDCODE",
                                                        "VALUE"=>"'$campsection_tele_code'",
                                                        "OPEN_BRACKETS"=>"",
                                                        "CLOSE_BRACKETS"=>"",
                                                        "SEQNUM"=>"100",
                                                        "SPECIAL"=>"0")
                                        );
                        foreach($rec as $key=>$val){
                            ClxCommon::$db->createRecord('CLX_DB_QUERY_CRITERIA', $val);
                        }

                } 

        }

        ClxCommon::$db->deleteRecords("CLX_AN_REPORT_COLUMNS", "REPORTCODE = '".$questionary['IDCODE']."'");
        ClxCommon::$db->deleteRecords("CLX_AN_REPORTS", "IDCODE = '".$questionary['IDCODE']."'");


        //$rec
        $rec= array("IDCODE"=>$questionary['IDCODE'],
                                "IDNAME"=>$questionary['IDNAME'],
                                "VERSION"=>'1.0.0',
                                "VERSION_COUNTER"=>1,
                                "CDATE"=>xFormat::getNow('Y-m-d H:i:s'),
                                "MDATE"=>xFormat::getNow('Y-m-d H:i:s'),
                                "USERNAME"=>$_SESSION["user_record"]["username"],
                                "DESCRIPTION"=>$questionary['DESCRIPTION'],
                                "QUERYCODE"=>$result_tablecode,
                                "MODULECODE"=>$questionary['MODULECODE'],
                                "SHOW_DETAIL"=>1,
                                "TITLE"=>'GEN_LBL_RESULTS',
                                "SUBTITLE"=>'',	
                                "COLAPSABLE"=>1);
        $reportid = ClxCommon::$db->createRecord("CLX_AN_REPORTS", $rec);

        $sql = "INSERT INTO 
                        CLX_AN_REPORT_COLUMNS 
                                (REPORTCODE, 
                                TABLECODE, 
                                FIELDNAME, 
                                SEQNUM, 
                                SORTING, 
                                FORMAT) 
                        SELECT 
                                '".$questionary['IDCODE']."' REPORTCODE, 
                                TABLECODE, 
                                FIELDNAME, 
                                0 SEQNUM, 'NONE',
                                1 FORMAT 
                        FROM CLX_DB_TABLEFIELDS 
                        WHERE TABLECODE = '".$result_tablecode."'
                        AND FIELDNAME NOT LIKE '".$questionary['IDCODE']."%'
                        ORDER BY SEQNUM ASC";
        //$db->executeQuery($sql);

        $sql = "INSERT INTO 
                        CLX_AN_REPORT_COLUMNS 
                                (REPORTCODE, 
                                TABLECODE, 
                                FIELDNAME, 
                                SEQNUM, 
                                SORTING, 
                                FORMAT) 
                        SELECT 
                                '".$questionary['IDCODE']."' REPORTCODE, 
                                TABLECODE, 
                                FIELDNAME, 
                                1 SEQNUM, 'NONE',
                                1 FORMAT 
                        FROM CLX_DB_TABLEFIELDS 
                        WHERE TABLECODE = '".$result_tablecode."'
                        AND FIELDNAME LIKE '".$questionary['IDCODE']."%'
                        ORDER BY FIELDNAME ASC";
        //$db->executeQuery($sql);
		
		$sql = "INSERT INTO 
                        CLX_AN_REPORT_COLUMNS 
                                (REPORTCODE, 
                                TABLECODE, 
                                FIELDNAME, 
                                SEQNUM, 
                                SORTING, 
                                FORMAT) 
                        SELECT 
                                '".$questionary['IDCODE']."' REPORTCODE, 
                                TABLECODE, 
                                FIELDNAME, 
                                1 SEQNUM, 'NONE',
                                1 FORMAT 
                        FROM CLX_DB_TABLEFIELDS 
                        WHERE TABLECODE = '".$result_tablecode."'
                        AND FIELDNAME NOT IN ('ID','CAMPTELERES_ID','CREATEDBY','CDATE')
                        ORDER BY FIELDNAME ASC";
		ClxCommon::$db->executeQuery($sql);
		$sql = "UPDATE CLX_AN_REPORT_COLUMNS SET  SORTING = 'DESC' WHERE FIELDNAME = 'MDATE' AND REPORTCODE = '".$questionary['IDCODE']."' ";
		ClxCommon::$db->executeQuery($sql);
        if($has_target){
                $sql = "INSERT INTO 
                        CLX_AN_REPORT_COLUMNS 
                                (REPORTCODE, 
                                TABLECODE, 
                                FIELDNAME, 
                                SEQNUM, 
                                SORTING,
                                FORMAT) 
                        SELECT 
                                '".$questionary['IDCODE']."' REPORTCODE, 
                                TABLECODE, 
                                FIELDNAME, 
                                2 SEQNUM, 'NONE',
                                1 FORMAT 
                        FROM 
                                CLX_DB_TABLEFIELDS 
                        WHERE 
                            TABLECODE = 'CTGT' 
                                AND FIELDNAME NOT IN ('CONTACTID',
                                                                'ID','REC_ID','EMAIL_STATUS',
                                                                'EMAIL_DATE','RESULT_MSG',
                                                                'RESULT_CODE','CAMPAIGNCODE',
                                                                'QUESTIONARY_CODE',
                                                                'CREATEDBY','QUERYCODE',
                                                                'MODIFIEDBY','CDATE','MDATE','CALL_DATE')
                        ORDER BY SEQNUM ASC";
                //$db->executeQuery($sql);
                //ADDING RESCHEDULE FIELDS
                $sql = "INSERT INTO 
                        CLX_AN_REPORT_COLUMNS 
                                (REPORTCODE, 
                                TABLECODE, 
                                FIELDNAME, 
                                SEQNUM, 
                                SORTING,
                                FORMAT) 
                        SELECT 
                                '".$questionary['IDCODE']."' REPORTCODE, 
                                TABLECODE, 
                                FIELDNAME, 
                                2 SEQNUM, 'NONE',
                                1 FORMAT 
                        FROM 
                                CLX_DB_TABLEFIELDS 
                        WHERE 
                            TABLECODE = 'CTER' 
                                AND FIELDNAME IN ('CAMPTARGET_NAME','EMAIL','PHONE','MOBILE_PHONE','HOME_PHONE','RESULT_CODE')
                        ORDER BY SEQNUM ASC";
                //cartesiano con resultado la idea era mostrar el agente que  llama
                ClxCommon::$db->executeQuery($sql);
        }
		$sql = "DELETE  FROM CLX_AN_REPORT_COLUMNS WHERE REPORTCODE ='".$questionary['IDCODE']."' AND FIELDNAME = '".$temp."'";
		ClxCommon::$db->executeQuery($sql);
		$sql = "DELETE  FROM CLX_AN_REPORT_COLUMNS WHERE REPORTCODE ='".$questionary['IDCODE']."' AND FIELDNAME = '".$temp2."' AND TABLECODE = '".$result_tablecode."'";
		//ClxCommon::$db->executeQuery($sql);
        //ACA SE VERIFICA EL PERMISO DE ACCESO A LA TABLA...SI NO TIENE ACCESO SE LE CONCEDE PARA CUALQUIER USUARIO
        //POR DEFECTO AL CREAR EL CUESTIONARIO SE CREA LA TABLA DE RESULTADOS SIN PERMISOS
        setpermits_access($result_tablecode);
        $url = "location: pop.php?to=ANRP&ac=REPORT_BUILD&ANRP_id=$reportid";
        header($url);
        exit(0);

}

/**
 * Exports telemarketing results
 */
function ctmk_build_results() {
    $ctmkname = tableName('CTMK');
    $idlist = toString(getIdlist());
    $o_results = ClxCommon::$db->getRecords($ctmkname, 'ID IN (' . singleQuote($idlist) . ')');
    while (($a_record = ClxCommon::$db->getNextRecord($o_results, ASSOCIATIVE))) {
        ctml_buld_result($a_record['QUESTIONARYCODE'], $a_record['IDCODE']);
    }
}

//04-03-2022 EC - FUNCIÓN PARA COLOCAR PERMISOS DE ACCESO A LA TABLA DE RESULTADOS PARA EL USUARIO
function setpermits_access($result_tablecode){
    $username = $_SESSION['user_record']['username'];

    if (!ClxCommon::sessionUserIsAdmin()) {
        $sql = 'SELECT MAX(CANREAD) as CANREAD FROM CLX_AC_TABLES WHERE TABLECODE = '.singleQuote($result_tablecode).' AND OWNERCODE='.singleQuote('USER').' AND OWNERREF='.singleQuote($username);
        $conta = ClxCommon::$db->getOneRecord($sql);

        $security= Array();
        $security['OWNERCODE'] = 'USER';
        $security['OWNERREF'] = $username; 
        $security['TABLECODE'] = $result_tablecode;
        $security['ISADMIN'] = 0;
        $security['CANREAD'] = 1;
        $security['CANMODIFY'] = 0;
        $security['CANDELETE'] = 0;
        $security['CANAPPEND'] = 0;

        if ($conta['CANREAD']==null) {
            // 'NO EXISTE EL PERMISO LO CREO';
            ClxCommon::$db->createRecord('CLX_AC_TABLES', $security, false);
        }else{
            // 'SI EXISTE Y NO TIENE PERMISOS SE ACTUALIZA';
            if ($conta['CANREAD']==0){
                ClxCommon::$db->updateRecord('CLX_AC_TABLES', $security, 'TABLECODE = '.singleQuote($result_tablecode).' AND OWNERCODE='.singleQuote('USER').' AND OWNERREF='.singleQuote($username));
            }
        }
    } 

}

//------------------------------------------------------------------------------
// Importador de archivo de Targets para Mercadeo
//------------------------------------------------------------------------------

class MARK_CAMP_import {
    
    var $contents = CLX_CHAR_EMPTY_STRING;
    var $s_formcode = 'RTBL_MARK_IMP';
    var $o_proc_eng_params;
    var $s_log_filename;
    var $o_logfile_mngr;
    var $s_title;
    var $s_process_code = 'MARK_TIMP';
    var $s_cqry_idcode;
    var $s_campaigncode;
    var $s_logfile_folder = kPathToWebSite.'/export/';
    var $s_import_folder = kPathToWebSite.'/temp/';
	
    var $s_tool_pop = 'tool.php';
    var $s_import_def_code = 'CTGT_01';
    var $s_filename_init_string = 'mark_camp_import';
    var $cqryname;
    var $cietclass;
    
    /*
     * Constructor
     */
    function __construct($parameters = array()) {
        // Instance extended import methods & loads required classes
        if (!class_exists('clx_import_extended_tool'))
            includeCodeLib('CIET');
        $this->cietclass = new clx_import_extended_tool($parameters, $this->s_import_def_code);
        // Inicializa los parametros del process engine
        $this->o_proc_eng_params = new proc_eng_params($parameters);
        // Extensión del archivo log
        define('IMPORT_ERRFILE_EXT', '.html');
        // Titulo para el reporte de resultado
        /*
         * MKCP_IMP_TITLE
         * Marketing Targets Import
         * Importación de Targets de Mercadeo
         */
        //$this->s_title = dict('MKCP_IMP_TITLE');
        $this->s_title = $this->cietclass->s_title;
        multiTableName($this, array('CQRY'));
    }

    /*
     * Shows form to get the input filespec
     */
    function prompt($s_campaigncode = '') {
        $ac = UserRequest::$request['ac'];
        $to = UserRequest::$request[CLX_PROP_TO];
        $it = (isset(UserRequest::$request['it']) ? UserRequest::$request['it'] : CLX_CHAR_EMPTY_STRING);
        $b_sw_process = true;
        $this->file_fields = array();
        $EDIT = &getTool('EDIT');
        $msg = array();
        $formrec = ClxCommon::$db->getRecord('CLX_UI_FORMS', 'IDCODE = ' . singleQuote($this->s_formcode));
        $record = UserRequest::$post;
        UserRequest::$post['RTBL_ID'] = CLX_CHAR_EMPTY_STRING; //Entrada en blanco para evitar warning en object file.
        $this->s_campaigncode = $s_campaigncode;
        if ($this->s_campaigncode === CLX_CHAR_EMPTY_STRING) {
            $this->s_campaigncode = $_SESSION['history']['main'][CLX_NUM_ONE]['parentrecord']['CAMP_IDCODE'];
        }
        //Prepare Values
        if (!empty($record['confirm'])) {
            if ($this->s_campaigncode === CLX_CHAR_EMPTY_STRING) {
                /*
                 * MKCP_IMP_ER_CMPCODE_NF
                 * Campaign code not set
                 * No se especificó el código de la campaña
                 */
                addMessage(dict('MKCP_IMP_ER_CMPCODE_NF'));
                $b_sw_process = false;
            }
            
            $checkForm_response = $EDIT->checkForm2($msg, $formrec);
            if ($checkForm_response) {
                if (empty(UserRequest::$post['RTBL_localfile'])) {
                    $filename_tmp = UserRequest::$files['RTBL_TEXT_FILE']['tmp_name'];
                    $path_parts = pathinfo(UserRequest::$files['RTBL_TEXT_FILE']['name']);
                    // El 'filename' se convierte a ASCCI con decode_string() para evitar los garabatos en el nombre de archivo final
                    //$filename = $this->s_import_folder . decode_string($path_parts['filename']) . '_' . adodb_date('Ymd') . '_' . adodb_date('His') . '.' . $path_parts['extension'];
                    $filename = $this->s_import_folder . $path_parts['filename'] . '_' . adodb_date('Ymd') . '_' . adodb_date('His') . '.' . $path_parts['extension'];
                    if (!move_uploaded_file($filename_tmp, $filename)) {
                        addMessage(dict('GEN_ERR_UPLOADFAIL'));
                        $b_sw_process = false;
                    }
                } else {
                    $filename = UserRequest::$post['RTBL_localfile'];
                }
            } else {
                $b_sw_process = false;
            }
            //Upload OK Start Procesing FIle
            if ($b_sw_process === true) {
                $this->scheduleImport($filename);
                return true;
            }
        }
        $this->print_btn = false;
        /*
         * 035D1BF8979A2A307BE4F259D50D791A
         * Campaign Code
         * Código de Campaña
         */
        $s_title_tmp = $this->s_title . ' - ' . dict('035D1BF8979A2A307BE4F259D50D791A') . ': ' . $this->s_campaigncode;
        $form = $EDIT->defaultForm($formrec, $record, $msg, $ac, $to, $it, $this->s_tool_pop, CLX_CHAR_EMPTY_STRING, $s_title_tmp, dict('GEN_LBL_EXECUTE'));
        $this->contents .= $form->source();
        return (empty($record['confirm']) || !empty($msg)) ? false : true;
    }

    /**
     * Schedule import process to  inmediate excecution
     */
    function scheduleImport($filename) {
        $ar_pars_2_send = array();
        $ar_pars_2_send['ANYFILE'] = $filename;
        $ar_pars_2_send['CAMPAIGNCODE'] = $this->s_campaigncode;
        $ar_pars_2_send['USERNAME'] = $_SESSION['user_record']['username'];
        //$form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF'], CLX_PROP_ID, 'theForm', 'name', 'theForm');
        $form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF']);
        //
        $form->addArgument(CLX_PROP_TO, 'PRLO');
        $form->addArgument('ac', 'LIST');
        $form->addArgument('PRLO_schedulecode', $this->s_process_code);
        /*
         * GEN_LBL_RETURN
         * Go back
         * Ir Atras
         */
        $s_msg_back = dict('GEN_LBL_RETURN');
        /*
         * GEN_LBL_SHOW_TGT_IMPRT_SCHD
         * Check import batch process (Schedule: ^1)
         * Monitorear la importación en proceso Batch (Cronomgrama: ^1)
         */
        $s_msg_goto_monitor = dict('GEN_LBL_SHOW_TGT_IMPRT_SCHD', $this->s_process_code);
        $s_adic_html = $form->source() . '<BR><BR>'
            . '<A HREF="#" onclick="javascript:;window.location.href=clearUriAnchor(' . singleQuote(UserRequest::$server['PHP_SELF'] . '?pop=1') . ');">' . $s_msg_back . '</A><BR>'
            . '<A HREF="#" onclick="javascript:theForm.submit();">' . $s_msg_goto_monitor . '</A>';
        $this->contents .= $this->o_proc_eng_params->create_proc_sched( $this->s_title, $ar_pars_2_send, null, $this->s_process_code, $s_adic_html );
    }

    /**
     * Function will extract the flat file and load it into CTGT
     * Entry point for batch process engine
     */
    function process_file($filename = '') {
        // Verifies process engine parameters
        if (!$this->o_proc_eng_params->verify_parameters()) {
            echoLog('<h1>' . $this->o_proc_eng_params->errormsg . '</h1>');
            return false;
        }
        $this->o_proc_eng_params->set_tablename($this->cietclass->a_import_header['TABLECODE']);
        // Reads the file name (if not specified as method's parameter, look for it at process parameter)
        if ($filename === CLX_CHAR_EMPTY_STRING) {
            $filename = $this->o_proc_eng_params->process_parameters['ANYFILE'];
        }
		// Se le quita caracteres espciales en HTML entities (como la Ñ)
		$filename = html_entity_decode($filename);
        // Verifies the input file existance
        $a_report_file_existance_and_openit_response = $this->cietclass->report_file_existance_and_openit($filename);
        if ($a_report_file_existance_and_openit_response['error'] === true) {
            echoLog($a_report_file_existance_and_openit_response['errormsg']);
            return false;
        }
        // Opens log file
        if (!$this->open_log_file($filename)) {
            return false;
        }
        // Begin reporting
        $this->o_logfile_mngr->write($this->cietclass->report_init());
        $this->o_logfile_mngr->write(CLX_CHAR_NL . '<tr>' . $this->cietclass->s_record_data_to_show . '</tr>' . CLX_CHAR_NL);
        // Assigns campaign code
        $this->s_campaigncode = $this->o_proc_eng_params->process_parameters['CAMPAIGNCODE'];
		// Asigna arreglo con los valores de las formulas especificas de este proceso, porque con el nuevo clx56 y la supresion de formulas calculadas on-the-fly para evitar penalizacion del kiuwan
		$a_predef_frmla = array();
		$a_predef_frmla['$this->s_campaigncode'] = $this->o_proc_eng_params->process_parameters['CAMPAIGNCODE'];
		$a_predef_frmla['$this->s_cqry_idcode'] = 'null';
        // Creates Campaign Query List header
        ClxFreeReturn($this->cqry_row_creation());
        // Starts reading flat file
        $i_imported_rec_counter = CLX_INIT_ZERO;
        while (($line = $this->cietclass->read_next_line())) {
            // Read next line
            $record = $this->cietclass->read_line_into_record_array($line, $a_predef_frmla);
            // Prepares reporting detail line
            $i_imported_rec_counter++;
            $this->cietclass->s_record_data_to_show = str_replace('%i_imported_rec_counter%', $i_imported_rec_counter, $this->cietclass->s_record_data_to_show);
            $this->cietclass->s_record_data_to_show = str_replace('%extra_info%', CLX_CHAR_EMPTY_STRING, $this->cietclass->s_record_data_to_show);
            // Record creation
            ClxFreeReturn($this->ctgt_row_creation($record));
            // Reporting...
            $this->o_logfile_mngr->write($this->cietclass->s_record_data_to_show);
        }
        $a = new ctgt();
        $a->count_targets($this->s_cqry_idcode);
        // Assigns NEVER to the process scheduling and closes log/debug files
        $this->terminates_process();
        return true;
    }

    /*
     * Opens the error log flat text file
     */
    function open_log_file($filename) {
		$filename = decode_string($filename);
        $this->s_log_filename = $this->import_log_filename($this->s_filename_init_string, 'log');
        /*
         * GEN_LBL_ORIG_FILE
         * Source File
         * Archivo Fuente
         */
        /*
         * GEN_LBL_LOGFILE
         * Log file
         * Archivo de Errores
         */
        $title = htmlentities(decode_string($this->s_title)) . '<br><br>' . dict('GEN_LBL_ORIG_FILE') . ': ' . $filename . '<br>' . dict('GEN_LBL_LOGFILE') . ': ' . $this->s_log_filename . '<br><br>';
        $this->o_logfile_mngr = new clx_logfile_mngr($this->s_logfile_folder . $this->s_log_filename);
        if ($this->o_logfile_mngr->error === true) {
            $this->cietclass->proc_log_write($this->o_logfile_mngr->errorMsg);
            return false;
        }
        $this->o_logfile_mngr->write($title);
        return true;
    }

    /**
     * Returns the log flat text file name
     */
    function import_log_filename($filename, $filetype) {
        $s_response = $filename . '_' . $filetype . '_' . adodb_date('Ymd') . '_' . adodb_date('His') . IMPORT_ERRFILE_EXT;
        return $s_response;
    }

    /*
     * Campaign Query List row creation
     */
    function cqry_row_creation() {
        $record = array();
        $record['IDCODE'] = 'AUTO';
        $record = setCreationIdCode($record, 'CQRY');
        $this->s_cqry_idcode = $record['IDCODE'];
        $record['IDNAME'] = date('Y-m-d H:i:s');
        $record['STATUS'] = 'A';
        $record['DESCRIPTION'] = $this->s_title . ' : ' . $record['IDNAME'];
        $record['CAMPAIGNCODE'] = $this->s_campaigncode;
        $record['QUERYLIST_CODE'] = CLX_CHAR_EMPTY_STRING;
        $record['EXEC_DATE'] = date('Y-m-d H:i:s');
        $i_cqry_id = ClxCommon::$db->createRecord($this->cqryname, $record, false);
        return $i_cqry_id;
    }

    /*
     * Target row creation
     */
    function ctgt_row_creation($record) {
        // If audit data is present, assigns it
        if (count($this->a_usr_date_fields_existance) > CLX_NUM_ZERO) {
            $total = count($this->a_usr_date_fields_existance);
            for ($i = CLX_INIT_ZERO; $i < $total; $i++) {
                $record[$this->a_usr_date_fields_existance[$i]] = CLX_CHAR_EMPTY_STRING;
            }
            $record = setCreationData($record);
        }
        // Campaign and Qry List codes
        $record['CAMPAIGNCODE'] = $this->s_campaigncode;
        $record['CQRY_CODE'] = $this->s_cqry_idcode;
        $record['CALL_DATE'] = xFormat::getNow();
        // Creates record
        $record_id = ClxCommon::$db->createRecord($this->cietclass->s_main_table_name, $record, false);
        ClxCommon::$db->commit();
        return $record_id;
    }

    /*
     * Put a link to the file
     */
    function put_link_to_logfile() {
        $filespec = $this->s_logfile_folder . $this->s_log_filename;
        echo $this->o_proc_eng_params->get_file_link(
                array(
                    array(
                        'FILENAME' => $filespec,
                    )
                )
        );
    }

    /*
     * Terminates de process to prepares it for new execution, optimize table and close log/debug files
     */
    function terminates_process() {
        // Terminates reporting
        $this->o_logfile_mngr->write($this->cietclass->report_ending());
        // Closes input file
        $this->cietclass->terminates_process();
        // Close log file
        $this->o_logfile_mngr->close();
        // Put a link to the file
        $this->put_link_to_logfile();
        // Assigns NEVER to the process scheduling
        $a_pars_tobe_erased = array();
        $this->o_proc_eng_params->stop_proc_sched($a_pars_tobe_erased);
        // Optimize table (recommended on large import processes
        $this->o_proc_eng_params->optimize_table();
    }

}

/**
 * Campaign target class
 */
class ctgt {

    /**
     * Constructor
     *
     * @return ctgt
     */
    function __construct() {
        multiTableName($this, array('CAMP', 'CTGT', 'CQRY', 'CEML', 'CEMA', 'CEME', 'CTMK', 'CTMA', 'CTOT', 'PRSC', 'CAEX'));
    }

    /**
     * Event post database commit
     *
     */
    function save_post_commit($record) {
        //Reprocess recors
        if (!empty(UserRequest::$post['CTGT_RESCHEDULE_CALL']) && !empty(UserRequest::$post['CTGT_ID'])) {
            //Remove telemarketing result to reprocess
            $sql = 'UPDATE MARK_CAMPSEC_TELEMARK_RES SET RESULT_CODE = ' . singleQuote('RESC') . ' WHERE CAMPTARGET_ID = ' . UserRequest::$post['CTGT_ID'];
            ClxCommon::$db->executeQuery($sql);
            $sql = 'UPDATE MARK_CAMPSEC_TELEMARK SET CAMPSECTION_STATUS = ' . singleQuote('WORK') . ' WHERE CAMPSECTION_STATUS = ' . singleQuote('END') . ' AND IDCODE IN (SELECT X.CAMPSECTION_TELE_CODE FROM MARK_CAMPSEC_TELEMARK_RES X WHERE X.CAMPTARGET_ID = ' . UserRequest::$post['CTGT_ID'] . ')';
            ClxCommon::$db->executeQuery($sql);
        }
    }

    function deleted_CAMP($idlist) {
        $sql = 'UPDATE ' . $this->campname . ' CAMP SET CAMP.DELETED = ' . singleQuote(CLX_NUM_ONE) . ' WHERE CAMP.ID IN (' . $idlist . ')';
        ClxCommon::$db->executeQuery($sql);
    }

    function deleted_CQRY($idlist) {
        $sql = 'UPDATE ' . $this->cqryname . ' CQRY SET CQRY.DELETED = ' . singleQuote(CLX_NUM_ONE) . ' WHERE CQRY.ID IN (' . $idlist . ')';
        ClxCommon::$db->executeQuery($sql);
    }

    function deleted_CTGT($idlist) {
        $status_proceso = ClxCommon::$db->oneExistsRecords($this->prscname, '((IDCODE = ' . singleQuote('CQRY01') . ' AND PROC_STATUS IN (' . singleQuoteArray(array('RUN', 'IDLE')) . ')) OR (IDCODE = ' . singleQuote('CTGT_DLTE') . ' AND PROC_STATUS = ' . singleQuote('RUN') . '))');
        if ($status_proceso === CLX_NUM_ZERO) {
            $sql = 'UPDATE ' . $this->ctgtname . ' CTGT SET CTGT.DELETED = ' . singleQuote(CLX_NUM_ONE) . ' WHERE CTGT.ID IN (' . $idlist . ')';
            ClxCommon::$db->executeQuery($sql);
        } else {
            addMessage(smsg('MSG-477'));
        }
    }

    function deleted_CEML($idlist) {
        $sql = 'UPDATE ' . $this->cemlname . ' CEML SET CEML.DELETED = ' . singleQuote(CLX_NUM_ONE) . ' WHERE CEML.ID IN (' . $idlist . ')';
        ClxCommon::$db->executeQuery($sql);
    }

    function deleted_CEMA($idlist) {
        $sql = 'UPDATE ' . $this->cemaname . ' CEMA SET CEMA.DELETED = ' . singleQuote(CLX_NUM_ONE) . ' WHERE CEMA.ID IN (' . $idlist . ')';
        ClxCommon::$db->executeQuery($sql);
    }

    function deleted_CTMK($idlist, $sw = CLX_NUM_ZERO) {
        $sql = 'UPDATE ' . $this->ctmkname . ' CTMK SET CTMK.DELETED = ' . singleQuote(CLX_NUM_ONE) . ' WHERE CTMK.ID IN (' . $idlist . ')';
        ClxCommon::$db->executeQuery($sql);
    }

    function deleted_CTMA($idlist, $sw = CLX_NUM_ZERO) {
        $sql = 'UPDATE ' . $this->ctmaname . ' CTMA SET CTMA.DELETED = ' . singleQuote(CLX_NUM_ONE) . ' WHERE CTMA.ID IN (' . $idlist . ')';
        ClxCommon::$db->executeQuery($sql);
    }

    function deleted_CTOT($idlist, $sw = CLX_NUM_ZERO) {
        $sql = 'UPDATE ' . $this->ctotname . ' CTOT SET CTOT.DELETED = ' . singleQuote(CLX_NUM_ONE) . ' WHERE CTOT.ID IN (' . $idlist . ')';
        ClxCommon::$db->executeQuery($sql);
    }

    function activate_deleted() {
        $status_proceso = ClxCommon::$db->oneExistsRecords($this->prscname, '((IDCODE = ' . singleQuote('CQRY01') . ' AND PROC_STATUS IN (' . singleQuoteArray(array('RUN', 'IDLE')) . ')) OR (IDCODE = ' . singleQuote('CTGT_DLTE') . ' AND PROC_STATUS = ' . singleQuote('RUN') . '))');
        if ($status_proceso === CLX_NUM_ZERO) {
            $x = getTool('PRSC');
            $x->runScheduleOneTimeNow('CTGT_DLTE');
            unset($x);
        }
    }

    function deleted_campaign() {
        $camps = ClxCommon::$db->executeQuery('SELECT CAMP.IDCODE FROM ' . $this->campname . ' CAMP WHERE CAMP.DELETED = 1');
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->campname . ' WHERE DELETED = 1');
        //Camps
        while (($result = ClxCommon::$db->getNextRecord($camps, ASSOCIATIVE))) {
            ClxCommon::$db->executeQuery('UPDATE ' . $this->cqryname . ' CQRY SET CQRY.DELETED = 1 WHERE CQRY.CAMPAIGNCODE = ' . singleQuote($result['IDCODE']));
            ClxCommon::$db->executeQuery('UPDATE ' . $this->cemlname . ' CEML SET CEML.DELETED = 1 WHERE CEML.CAMPAIGNCODE = ' . singleQuote($result['IDCODE']));
            ClxCommon::$db->executeQuery('UPDATE ' . $this->ctmkname . ' CTMK SET CTMK.DELETED = 1 WHERE CTMK.CAMPAIGNCODE = ' . singleQuote($result['IDCODE']));
            ClxCommon::$db->executeQuery('UPDATE ' . $this->ctotname . ' CTOT SET CTOT.DELETED = 1 WHERE CTOT.CAMPAIGNCODE = ' . singleQuote($result['IDCODE']));
            ClxCommon::$db->executeQuery('UPDATE ' . $this->ctgtname . ' CTGT SET CTGT.DELETED = 1 WHERE CTGT.CAMPAIGNCODE = ' . singleQuote($result['IDCODE']));
        }
        ClxCommon::$db->commit();
        $cqrys = ClxCommon::$db->executeQuery('SELECT CQRY.IDCODE FROM ' . $this->cqryname . ' CQRY WHERE CQRY.DELETED = 1');
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->cqryname . ' WHERE DELETED = 1');
        $cemls = ClxCommon::$db->executeQuery('SELECT CEML.IDCODE FROM ' . $this->cemlname . ' CEML WHERE CEML.DELETED = 1');
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->cemlname . ' WHERE DELETED = 1');
        $ctmks = ClxCommon::$db->executeQuery('SELECT CTMK.IDCODE FROM ' . $this->ctmkname . ' CTMK WHERE CTMK.DELETED = 1');
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->ctmkname . ' WHERE DELETED = 1');
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->ctotname . ' WHERE DELETED = 1');
        //Querys
        while (($result = ClxCommon::$db->getNextRecord($cqrys, ASSOCIATIVE))) {
            ClxCommon::$db->executeQuery('UPDATE ' . $this->ctgtname . ' CTGT SET CTGT.DELETED = 1 WHERE CTGT.CQRY_CODE = ' . singleQuote($result['IDCODE']));
        }
        ClxCommon::$db->commit();
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->ctgtname . ' WHERE DELETED = 1');
        //E-Mails
        while (($result = ClxCommon::$db->getNextRecord($cemls, ASSOCIATIVE))) {
            ClxCommon::$db->executeQuery('UPDATE ' . $this->cemaname . ' CEMA SET CEMA.DELETED = 1 WHERE CEMA.CEML_CODE = ' . singleQuote($result['IDCODE']));
            ClxCommon::$db->executeQuery('UPDATE ' . $this->cemename . ' CEME SET CEME.DELETED = 1 WHERE CEME.CEML_CODE = ' . singleQuote($result['IDCODE']));
        }
        ClxCommon::$db->commit();
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->cemaname . ' WHERE DELETED = 1');
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->cemename . ' WHERE DELETED = 1');
        //Telemark
        while (($result = ClxCommon::$db->getNextRecord($ctmks, ASSOCIATIVE))) {
            ClxCommon::$db->executeQuery('UPDATE ' . $this->ctmaname . ' CTMA SET CTMA.DELETED = 1 WHERE CTMA.CAMPSECTION_TELEMARK_CODE = ' . singleQuote($result['IDCODE']));
        }
        ClxCommon::$db->commit();
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->ctmaname . ' WHERE DELETED = 1');
    }

    /**
     * Evento al ejecutar la forma - asigna status para realizar conteos de campa?a en batch.
     * @global type $db
     * @param type $record
     * @return type
     */
    function save_form_post_cqry(&$record){
        /*
         * Status de INDICTED para calculos en batch
         * CLCP = Pendiente c?lculo
         * CLCC = Calculando
         */
        $sql = 'UPDATE ' . $this->cqryname . ' SET INDICTED = ' . singleQuote('CLCP') . ', PHONES_FOUND = 0, EMAILS_FOUND = 0, QUANTITY = 0, OPTOUT_PHONE_QTY = 0, OPTOUT_EMAIL_QTY = 0, OPTOUTS = 0 WHERE IDCODE IN (' . singleQuote($record['IDCODE']) . ')';
        ClxCommon::$db->executeQuery($sql);
        ClxCommon::$db->commit();
        $proc_cqry_calc_code = 'CQRY02';
        $proc_cqry_calc_name = ClxCommon::$db->getField($this->prscname, 'IDNAME', 'IDCODE = ' . singleQuote($proc_cqry_calc_code));
        $msg_out = '[' . $proc_cqry_calc_code . '] ' . $proc_cqry_calc_name . ' [' . singleQuote($record['IDCODE']) . ']';
        $status_proceso = ClxCommon::$db->oneExistsRecords($this->prscname, '( (IDCODE = ' . singleQuote($proc_cqry_calc_code) . ' AND PROC_STATUS IN ('. singleQuote('RUN') . ')) )');
        if($status_proceso === CLX_NUM_ZERO){
            $x = getTool('PRSC');
            $x->runScheduleOneTimeNow($proc_cqry_calc_code);
            unset($x);
            addMessage(dict('UTIL_DBBK_PROC_SCHEDULED') . ': ' . $msg_out);
        } else {
            addMessage(smsg('MSG-476', $msg_out));
        }
    }

    function preparingCampaignQuery(){
        // Ya no se usa, pero lo llama el proceso CQRY01. Se dejó para que no termine con error y detenga el motor de procesos
    }

    /*
     * NOTA IMPORTANTE: En versiones anteriores, se insertaban los Registros en los Target de campaña 
     * mediante el Cronograna CQRY01. 
     * A partir de la incidencia de BNP en fecha 2015-07-08, 
     * Caso 1002695 - BNP-Problema en Lista de Consulta al crear Campaña,
     * se eliminó esa forma de trabajo. Ahora en el caso de los Query, sólo cuenta los registros sin 
     * insertarlos en las campañas, porque en BNP cada campaña iba a tener por lo menos 1 millon de registros. 
     * En el caso de los Targets importados o registrados a mano, si los cuenta desde la tabla CTGT
     * Los métodos que hacían esos INSERTS eran save_form_post_cqry() y preparingCampaignQuery()
     */
    /* 
    function save_form_post_cqry(&$record) {
        if (UserRequest::$request['ac'] === 'MODIFY') {
            ClxCommon::$db->executeQuery('UPDATE MARK_CAMPAIGN_QUERIES SET INDICTED = ' . singleQuote('PEND') . ' WHERE IDCODE = ' . singleQuote($record['IDCODE']));
        }
        $status_proceso = ClxCommon::$db->oneExistsRecords($this->prscname, '((IDCODE = ' . singleQuote('CQRY01') . ' AND PROC_STATUS =' . singleQuote('RUN') . ') OR (IDCODE = ' . singleQuote('CTGT_DLTE') . ' AND PROC_STATUS IN (' . singleQuoteArray(array('RUN', 'IDLE')) . ')))');
        if ($status_proceso == CLX_NUM_ZERO) {
            $x = getTool('PRSC');
            $x->runScheduleOneTimeNow('CQRY01');
            unset($x);
            addMessage(smsg('MSG-471'));
        } else {
            addMessage(smsg('MSG-476', dict('MARK_CAMP_CTGT')));
        }
    }

    function preparingCampaignQuery() {
        $sql = 'SELECT CQRY.ID, CQRY.IDCODE FROM ' . $this->cqryname . ' CQRY WHERE CQRY.INDICTED = ' . singleQuote('PEND') . ' AND CQRY.DELETED = 0';
        $querys = ClxCommon::$db->executeQuery($sql);
        while (($result = ClxCommon::$db->getNextRecord($querys))) {
            $sql = 'DELETE FROM ' . $this->ctgtname . ' WHERE CQRY_CODE = ' . singleQuote($result['IDCODE']);
            ClxCommon::$db->executeQuery($sql);
            executeCampaignQuery($result['ID']);
        }
    }
    */
    
     /*
      * Evento al ejecutar la forma. Realiza conteos de campaña.
      * @param void
      * @return void
      */
    function save_exec_cqry_btn(){
        $idlist = toString(getIdlist());
        if (empty($idlist))
            return;
        $sql = 'SELECT CTGT.IDCODE FROM ' . $this->cqryname . ' CTGT WHERE CTGT.ID IN (' . $idlist . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $this->count_targets ($r['IDCODE']);
        }
    }

//----------------------------------
//----------------------------------
//----------------------------------

    /**
     * Procesa los conteos de targets de campa?a pendientes.
     * @global type $db
     * @param type $record
     * @return type
     */
    function save_form_post_cqry_batch() {
        $sql = 'SELECT IDCODE FROM ' . $this->cqryname . ' WHERE INDICTED = '.singleQuote('CLCP');
        $results = ClxCommon::$db->executeQuery($sql);
        while(($record = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE))){
            // Asigna estado 'Calculando'
            $sql = 'UPDATE ' . $this->cqryname . ' SET INDICTED = '.singleQuote('CLCC').', PHONES_FOUND = 0, EMAILS_FOUND = 0, QUANTITY = 0, OPTOUT_PHONE_QTY = 0, OPTOUT_EMAIL_QTY = 0, OPTOUTS = 0 WHERE IDCODE = ' . singleQuote($record['IDCODE']);
            ClxCommon::$db->executeQuery($sql);
            ClxCommon::$db->commit();
            // Procesa los conteos de targets de campa?a para este Query
            $this->count_targets ($record['IDCODE']);
            // Asigna estado 'Listo'
            $sql = 'UPDATE ' . $this->cqryname . ' SET INDICTED = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' WHERE IDCODE = ' . singleQuote($record['IDCODE']);
            ClxCommon::$db->executeQuery($sql);
            ClxCommon::$db->commit();
        }
    }

    /**
     * Methodo posterior a guardar methodo de telemercadeo.
     * @param type $record
     */
    function save_ctmk_totals($campaign_code) {
        //Setting total por email section
        $sql = 'UPDATE ' . $this->ctmkname . ' CTMK SET CTMK.PHONES_FOUND = IFNULL((SELECT SUM(CQRY.PHONES_FOUND) FROM ' . $this->cqryname . ' CQRY WHERE CQRY.CAMPAIGNCODE = CTMK.CAMPAIGNCODE AND CQRY.STATUS = ' . singleQuote('A') . '),0) WHERE CTMK.CAMPAIGNCODE = ' . singleQuote($campaign_code);
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     * Cuenta numero de emails encontrados en campana
     * @global type $db
     * @param type $cqry_code
     */
    function count_targets ($cqry_code) {
        $sql = 'UPDATE ' . $this->cqryname . ' SET PHONES_FOUND = 0, EMAILS_FOUND = 0, QUANTITY = 0, OPTOUTS = 0 WHERE IDCODE = '.singleQuote($cqry_code);
        ClxCommon::$db->executeQuery($sql);
        //Items individuales
        $this->count_target($cqry_code);
        //Items especificos
        $this->count_query($cqry_code);
        //Codigo de campana
        $campaign_code = ClxCommon::$db->getField($this->cqryname, 'CAMPAIGNCODE', 'IDCODE = '.singleQuote($cqry_code));
        //Agregar conteo de telefonos en seccion de telemercadeo
        $this->save_ctmk_totals($campaign_code);
    }

    private function count_target($cqry_code){
        $sql = 'SELECT
              MAX(RE.QTY) QTY,
              SUM(RE.EMAIL_QTY) EMAIL_QTY,
              SUM(RE.PHONE_QTY) PHONE_QTY,
              SUM(RE.OPTOUT_EMAIL_QTY) OPTOUT_EMAIL_QTY,
              SUM(RE.OPTOUT_PHONE_QTY) OPTOUT_PHONE_QTY,
              SUM(RE.OPTOUTS) OPTOUTS
        FROM
        (
            /*EN TARGETS*/
            SELECT
              COUNT(CTGT.ID) QTY,
              SUM(IF(CTGT.EMAIL = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' OR CTGT.EMAIL IS NULL, 0, 1)) EMAIL_QTY,
              0 PHONE_QTY,
              SUM(IF(CAEX.EMAIL = CTGT.EMAIL, 1,0)) OPTOUT_EMAIL_QTY,
              0 OPTOUT_PHONE_QTY,
              SUM(IF(CAEX.ID IS NULL,0,1)) OPTOUTS
            FROM
              '.$this->ctgtname.' CTGT
                LEFT JOIN
                  '.$this->caexname.' CAEX
                  ON ((CAEX.EMAIL = CTGT.EMAIL AND CAEX.EMAIL IS NOT NULL AND CAEX.EMAIL <> ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' ))
            WHERE
              1=1
              AND CTGT.STATUS = '. singleQuote('A') . '
              AND CTGT.DELETED = 0
              AND CTGT.CQRY_CODE = '.singleQuote($cqry_code).'
            UNION ALL
            SELECT
              COUNT(CTGT.ID) QTY,
              0 EMAIL_QTY,
              SUM(IF(CTGT.PHONE = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' OR CTGT.PHONE IS NULL, 0, 1)) PHONE_QTY,
              0 OPTOUT_EMAIL_QTY,
              SUM(IF(CAEX.PHONE = CTGT.PHONE, 1,0)) OPTOUT_PHONE_QTY,
              SUM(IF(CAEX.ID IS NULL,0,1)) OPTOUTS
            FROM
              MARK_CAMPAIGN_TARGETS CTGT
                LEFT JOIN
                  '.$this->caexname.' CAEX
                  ON ((CAEX.PHONE = CTGT.PHONE  AND CAEX.PHONE IS NOT NULL AND CAEX.PHONE <> ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' ))
            WHERE
              1=1
              AND CTGT.STATUS = '. singleQuote('A') . '
              AND CTGT.DELETED = 0
              AND CTGT.CQRY_CODE ='.singleQuote($cqry_code).'
        ) RE';
        
        $result = ClxCommon::$db->executeQuery($sql);
        $conta = ClxCommon::$db->getNextRecord($result, ASSOCIATIVE);
        $sql = 'UPDATE '.$this->cqryname.'
                SET
                    PHONES_FOUND = PHONES_FOUND + '.$conta['PHONE_QTY'].',
                    EMAILS_FOUND = EMAILS_FOUND + '.$conta['EMAIL_QTY'].',
                    OPTOUT_PHONE_QTY = OPTOUT_PHONE_QTY + '.(CLX_NUM_ZERO+$conta['OPTOUT_PHONE_QTY']).',
                    OPTOUT_EMAIL_QTY = OPTOUT_EMAIL_QTY + '.(CLX_NUM_ZERO+$conta['OPTOUT_EMAIL_QTY']).',
                    OPTOUTS = OPTOUTS + '.(CLX_NUM_ZERO+$conta['OPTOUT_EMAIL_QTY']+$conta['OPTOUT_PHONE_QTY']).',
                    QUANTITY = QUANTITY + '.$conta['QTY'].'
                WHERE
                    IDCODE = '.singleQuote($cqry_code);
        ClxCommon::$db->executeQuery($sql);
        ClxCommon::$db->commit();
    }

    /**
     * Cuenta numero de emails encontrados en consulta
     * @global type $db
     * @param type $cqry_code
     * @return type
     */
    private function count_query($cqry_code){
        $querycode = ClxCommon::$db->getField($this->cqryname, 'QUERYLIST_CODE', 'IDCODE = '.singleQuote($cqry_code).' AND STATUS = '.singleQuote('A'));
        if(empty($querycode)) 
            return;
        $DBQY = &getTool('DBQY');
        $queryrec = $DBQY->getQuery('MARK', $querycode);
        $s_aliases_sin_from = str_replace('FROM ', CLX_CHAR_EMPTY_STRING, trim($queryrec['FROMCLAUSE']));
        $a_aliases = explode(',', $s_aliases_sin_from);
        $sw_encontro_alias_ppal = false;
        $total = count($a_aliases);
        for($i=CLX_NUM_ZERO; $i < $total; $i++) {
            list($nombre_tabla, $alias_tabla) = explode(' ', trim($a_aliases[$i]));
            if($i===CLX_NUM_ZERO) {
                // Guarda los primeros que encuentra
                $nombre_tabla_1 = $nombre_tabla;
                $alias_tabla_1 = $alias_tabla;
            }
            if($alias_tabla === 'LEAP' || $alias_tabla === 'ACCO' || $alias_tabla === 'CONT') {
                $sw_encontro_alias_ppal = true;
                break;
            }
        }
        if($sw_encontro_alias_ppal == false) {
            // No encontro 'LEAD', 'ACCO' o 'CONT', asi que toma la primera table luego del FROM
            $nombre_tabla = $nombre_tabla_1;
            $alias_tabla = $alias_tabla_1;
        }
        $a_cqrl_rec = get_camp_qry_field_names($querycode);
        if( strpos($queryrec['FROMWHERESORT'], 'WHERE') === false ) {
            $from_where_01 = $queryrec['FROMWHERESORT'] . ' WHERE ';
            $from_where_02 = $queryrec['FROMWHERESORT'] . ', MARK_CAMPSEC_EXCLUSIONS CAEX WHERE ';
        } else {
            $from_where_01 = str_replace(' WHERE ', ' WHERE ', $queryrec['FROMWHERESORT']) . ' AND ';
            $from_where_02 = str_replace(' WHERE ', ', MARK_CAMPSEC_EXCLUSIONS CAEX WHERE ', $queryrec['FROMWHERESORT']) . ' AND ';
        }

        $sql = 'SELECT
                    (SELECT SUM(SUBSEL.QTY) FROM (SELECT COUNT('.$alias_tabla.'.ID) QTY '.$queryrec['FROMWHERESORT'].') SUBSEL) QTY,
                    (SELECT COUNT('.$alias_tabla.'.'.$a_cqrl_rec['EMAIL_FIELD'].') QTY '.$from_where_01.'('.$alias_tabla.'.'.$a_cqrl_rec['EMAIL_FIELD'].' <> '.singleQuote(CLX_CHAR_EMPTY_STRING).')) EMAIL_QTY,
                    (SELECT COUNT('.$alias_tabla.'.'.$a_cqrl_rec['PHONE_FIELD'].') QTY '.$from_where_01.'('.$alias_tabla.'.'.$a_cqrl_rec['PHONE_FIELD'].' <> '.singleQuote(CLX_CHAR_EMPTY_STRING).')) PHONE_QTY,
                    (SELECT COUNT('.$alias_tabla.'.ID) QTY '.$from_where_02.' (CAEX.PHONE = '.$alias_tabla.'.'.$a_cqrl_rec['PHONE_FIELD'].' AND  CAEX.PHONE IS NOT NULL AND CAEX.PHONE <> ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ')) OPTOUT_PHONE_QTY,
                    (SELECT COUNT('.$alias_tabla.'.ID) QTY '.$from_where_02.' (CAEX.EMAIL = '.$alias_tabla.'.'.$a_cqrl_rec['EMAIL_FIELD'].' AND  CAEX.EMAIL IS NOT NULL AND CAEX.EMAIL <> ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' )) OPTOUT_EMAIL_QTY
                FROM DUAL';

        $conta = ClxCommon::$db->getOneRecord($sql);
        $sql = 'UPDATE '.$this->cqryname.' SET '
                    . ' PHONES_FOUND = PHONES_FOUND + '.$conta['PHONE_QTY'].','
                    . ' EMAILS_FOUND = EMAILS_FOUND + '.$conta['EMAIL_QTY'].','
                    . ' OPTOUT_PHONE_QTY = OPTOUT_PHONE_QTY + '.(0+$conta['OPTOUT_PHONE_QTY']).','
                    . ' OPTOUT_EMAIL_QTY = OPTOUT_EMAIL_QTY + '.(0+$conta['OPTOUT_EMAIL_QTY']).','
                    . ' /* OPTOUTS = OPTOUTS + '.$conta['OPTOUTS'].', */'
                    . ' OPTOUTS = OPTOUTS + '.(CLX_NUM_ZERO+$conta['OPTOUT_EMAIL_QTY']+$conta['OPTOUT_PHONE_QTY']).','
                    . ' QUANTITY = QUANTITY + '.$conta['QTY']
            . ' WHERE IDCODE = '.singleQuote($cqry_code);
        ClxCommon::$db->executeQuery($sql);
        ClxCommon::$db->commit();
    }

    function save_form_post_cqry_idlist() {
        $cqryname = tableName('CQRY');
        $idlist = getIdlist();
        $record = ClxCommon::$db->getFields($cqryname, 'GROUP_CONCAT(IDCODE SEPARATOR "' . singleQuote(',') . '") IDCODE', 'ID IN ('.  implode(',', $idlist).')');
        $this->save_form_post_cqry($record);
    }
//----------------------------------
//----------------------------------
//----------------------------------
}