<?php

/**
 * General Code File
 * For more information contact support@alenet.com
 *
 * @author $Author: cramirez $
 * @copyright Alenet, Inc.
 * @since $Date: 2018-08-23 18:18:58 -0400 (Thu, 23 Aug 2018) $
 * @version $Rev: 9902 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Invo {

    var $display = false;

    /**
     * Constructor
     * @param array [$procParameters]
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('FIAC', 'FIRT', 'FIPA', 'GDVW', 'FTMP', 'INVT', 'INVO', 'INVL', 'PROD', 'PRAT', 'GLAC', 'AMDS', 'GLT1', 'JEHD', 'JELN', 'FIAT', 'JCBV', 'JEIT', 'FICO', 'ARAS', 'GLCP', 'GLPF', 'FILO', 'INPY', 'GOVW', 'FIPA', 'TXRT', 'COMP'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->today = xFormat::getNow('Y-m-d');
        $this->je_source = '';
		
    }

    /**
     * Execute bottom reverse from listing invo
     */
    function invo_reverse_build() {
        $idlist = toString(getIdlist());
		$results = ClxCommon::$db->executeQuery('SELECT IDCODE, JEHDR_CODE, INVO_STAT, COMP_CODE FROM ' . $this->invoname . ' WHERE ID IN (' . $idlist . ')');
        if (!class_exists('Jehd'))
            includeCodeLib('JEHD');
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {

            if (!empty($result['JEHDR_CODE'])) {
                $verifica = ClxCommon::$db->getOneRecord('SELECT IDCODE, CLX_AUTH_STATUS FROM ' . $this->jehdname . ' WHERE REV_JEHDR_CODE = ' . singleQuote($result['JEHDR_CODE']));
                if (!empty($verifica['IDCODE'])) {
                    addMessage(smsg('MSG-406', $result['IDCODE'], $verifica['IDCODE'], $verifica['CLX_AUTH_STATUS']));
                    return false;
                }

				//Validar que tenga transacciones sin reversos.
                $sql = 'SELECT COUNT(FIAT.ID) QTY FROM BILL_INVOICE INVO, FIDU_TRANSACTIONS FIAT, GL_JOURNAL_HDR JEHD, BILL_INVPYMT_TRANS INPY WHERE INPY.INVOICECODE = INVO.IDCODE AND INPY.JEHDR_CODE = JEHD.IDCODE AND FIAT.IDCODE = JEHD.TRANS_CODE AND FIAT.CLX_AUTH_STATUS<> ' .singleQuote('REJ'). ' AND FIAT.VOID = 0 AND INVO.IDCODE = ' . singleQuote($result['IDCODE']);
                if (ClxCommon::$db->getOne($sql) > 0) {
                    addMessage(smsg('MSG-496'));
                    return false;
                }
                
				if(companyParameter('INVO_REASO_ANUL', $result['COMP_CODE']) == 1){
					//Validar que la factura tenga las razones de la anulación de la misma
					$sql='SELECT IDCODE, REVERSE_REA FROM ' . $this->invoname . ' WHERE IDCODE = ' . singleQuote($result['IDCODE']) . ' AND (REVERSE_REA IS NULL OR REVERSE_REA='.singleQuote('').')';

					if (ClxCommon::$db->getOne($sql) > 0){
						addMessage(smsg('MSG-532'));
						return false;
					}
				}
				
				$jehd = new Jehd();
                $cod_new_jehdr = $jehd->jehd_reverse($result['JEHDR_CODE']);
                unset($jehd);
                if ($cod_new_jehdr !== '') {
                    //chequear parametros de la compania para ver si la fecha del comprobante debe ser la de operaciones
                $sql = 'SELECT COMP_CODE FROM ' . $this->jehdname . ' WHERE IDCODE = '. singleQuote($cod_new_jehdr);
                    $comp_code = ClxCommon::$db->getOne($sql);

                    $sql = 'SELECT GLCP.INVO_REV_OP_DATE INVO_REV_OP_DATE, GLCP.OPERATION_DATE OPERATION_DATE  FROM ' . $this->compname . ' COMP, ' . $this->glcpname . ' GLCP WHERE COMP.IDCODE = GLCP.COMP_CODE AND COMP.IDCODE = ' . singleQuote($comp_code);
                    $comp_info = ClxCommon::$db->getOneRecord($sql);
                    if($comp_info['INVO_REV_OP_DATE']){
                        $sql = 'UPDATE ' . $this->jehdname . '  SET EFFTDATE = '.singleQuote($comp_info['OPERATION_DATE']).' WHERE IDCODE = ' . singleQuote($cod_new_jehdr);
                        ClxCommon::$db->executeQuery($sql);
                    }

                    addMessage(smsg('MSG-401', $result['IDCODE'], $cod_new_jehdr));
                }
				
            } else {//factura no tiene asiento contable
                addMessage(smsg('MSG-400', $result['IDCODE']));
                return false;
            }
        }
    }

    /**
     * Initialice fiat form - Executed on init event
     *
     * @param array $record
     */
    function init_form(&$record) {
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        $comp = new Comp();
        $comprec = $comp->comp_operation_parameters($record['INVO_COMP_CODE']);
        if ((UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'DUPLICATE' || UserRequest::$request['ac'] === 'CODE') && empty(UserRequest::$post['confirm'])) {
            $record['INVO_INVOICEDATE'] = $comprec['OPERATION_DATE'];
            $record['INVO_CURRENCY_CODE'] = $comprec['CURRENCY_CODE'];
            $record['INVO_IDCODE'] = 'AUTO';
            $record['INVO_CLX_AUTH_STATUS'] = 'PEND';
            $record['INVO_INVO_STAT'] = '01';
            $record['INVO_JEHDR_CODE'] = '';
            $record['INVO_JEHDR_CODE_prim'] = '';
            $record['INVO_JEHDR_CODE_secd'] = '';
            $record['INVO_PAY_JEHDR_CODE'] = '';
            $record['INVO_PAY_JEHDR_CODE_prim'] = '';
            $record['INVO_PAY_JEHDR_CODE_secd'] = '';
			$record['INVO_TAXRCPT_NO']= '';
			$record['INVO_REL_INVOICE']= '';
			$record['INVO_REL_INVOICE_prim']= '';
			$record['INVO_REL_INVOICE_secd']= '';
			$record['INVO_REL_INVOICE_terc']= '';
			$record['INVO_REVERSE_REA']= '';
            $record['INVO_RESTRICTED'] = CLX_INIT_ZERO;
            if (!empty($comprec['INVO_DEFDUE_FREQ'])) {
                $record['INVO_DUE_DATE'] = adodb_period_date($record['INVO_INVOICEDATE'], $comprec['INVO_DEFDUE_FREQ'], $comprec['INVO_DEFDUE_PER'], 'Y-m-d');
            }
        }
    }

    /**
     * Initialice form - Executed on init event
     *
     * @param array $record
     */
    function load_form(&$record) {
        if ((UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'DUPLICATE' || UserRequest::$request['ac'] === 'CODE') && empty(UserRequest::$post['confirm'])) {
            $this->init_form($record);
        }
    }

    /**
     * Validate record information
     * Executed on table validate
     *
     * @param array $record
     * @param array $msg
     */
    function validate_form(&$record, &$msg) {
		//pre($record);

        if (UserRequest::$request['ac'] <> 'DELETE') {
            if (empty(UserRequest::$post['fm']))
            UserRequest::$post['fm'] = '';
            //Si la factura esta aprobada pero tiene razón de anulación entonces solo actualizo el campo INVO_REVERSE_REA para que permita al usuario definir las razón de anulación E.C 27-01-2020
            if(companyParameter('INVO_REASO_ANUL', $record['INVO_COMP_CODE']) == 1){
                if (UserRequest::$request['ac'] == 'MODIFY' && $record['INVO_CLX_AUTH_STATUS'] == 'AP' && !empty($record['INVO_REVERSE_REA'])){
                    ClxCommon::$db->updateRecord($this->invoname, array('REVERSE_REA' => $record['INVO_REVERSE_REA']), 'IDCODE = ' . singleQuote($record['INVO_IDCODE']));
                    $msg['INVO_CLX_AUTH_STATUS'] = smsg('MSG-535', $record['INVO_IDCODE']);
                    return false;
                    //addMessage($msg['INVO_CLX_AUTH_STATUS']);
                }
            }

            if ($record['INVO_CLX_AUTH_STATUS'] <> 'PEND' && $record['INVO_CLX_AUTH_STATUS'] <> 'OPQU' && UserRequest::$post['fm'] <> 'INVO_APP') {
                $msg['INVO_CLX_AUTH_STATUS'] = smsg('MSG-262', $record['INVO_IDCODE']);
                return false;
            }

            $sql = 'SELECT FICO.CONTRACT_STATUS FROM ' . $this->ficoname . ' FICO WHERE FICO.IDCODE = ' . singleQuote($record['INVO_CHART_FIELD01']);
            $CONTRACT_STATUS = ClxCommon::$db->getOne($sql);
            if ($CONTRACT_STATUS === 'FINQ') {
                $msg['INVO_CHART_FIELD01'] = smsg('MSG-410', $record['INVO_CHART_FIELD01_prim']);
            }


            if(companyParameter('INVO_ASSIG_NCF', $record['INVO_COMP_CODE']) == 1){
                if (UserRequest::$request['ac'] === 'REQAUTHORIZATION' && $record['INVO_INVO_STAT'] === '01') {
                    $sql = 'SELECT TXRT.TAXRCPT_TYPE, TXRT.TAXRCPT_NEXTSEQ, TXRT.TAXRCPT_FINALSEQ, TXRT.TAXRCPT_ASIGN FROM ' . $this->txrtname . ' TXRT WHERE TXRT.TAXRCPT_TYPE = '.singleQuote($record['INVO_TAXRCPT_TYPE']). ' AND TXRT.TAXRCPT_FINALSEQ>TXRT.TAXRCPT_ASIGN AND  TXRT.TAXRCPT_EXPDATE>= ' . singleQuote($this->today);
                    $txrtnfc = ClxCommon::$db->getOneRecord($sql);
                    if (empty($txrtnfc)) {
                        $msg['INVO_AR_ITEM_CODE'] = smsg('MSG-531');
                        return false;
                    }
                 }
            }

            if (UserRequest::$request['ac'] === 'REQAUTHORIZATION' && $record['INVO_INVO_STAT'] === '04') {
                $msg['INVO_CLX_AUTH_STATUS'] = smsg('MSG-404', $record['INVO_IDCODE']);
                return false;
            }

            if (UserRequest::$request['ac'] === 'REQAUTHORIZATION' && $record['INVO_INVO_STAT'] === '04') {
                $msg['INVO_INVO_STAT'] = smsg('MSG-404', $record['INVO_IDCODE']);
                return false;
            }
            /// ivan
            if ($record['INVO_CLX_AUTH_STATUS'] == 'PEND' && $record['INVO_INVO_STAT'] === '04') {
                $jehd_status=ClxCommon::$db->getOneRecord('select CLX_AUTH_STATUS from '. $this->jehdname .' where IDCODE = ' . singleQuote( $record['INVO_JEHDR_CODE']));            
                if ($jehd_status['CLX_AUTH_STATUS']=='AP') {
                    $msg['INVO_INVO_STAT'] = smsg('MSG-20170712161614', $record['INVO_IDCODE'],$record['INVO_JEHDR_CODE']);
                }    
                return false;


            }

            if (UserRequest::$request['ac'] === 'MODIFY' && ClxCommon::$db->oneExistsRecords($this->invoname, 'IDCODE = ' . singleQuote($record['INVO_IDCODE']) . ' AND INVO_STAT IN (' . singleQuote('02') . ',' . singleQuote('04') . ',' . singleQuote('05') . ')') > CLX_NUM_ZERO) {
                $msg['INVO_INVO_STAT'] = smsg('MSG-404', $record['INVO_IDCODE']);
                return false;
            }

            //Validating amortization type
            if ($record['INVO_AR_AMORT_METHOD'] == CLX_NUM_ONE && $record['INVO_AMORTIZATION_AMT'] == CLX_NUM_ZERO) {
                $msg['INVO_AMORTIZATION_AMT'] = smsg('MSG-301');
            }
            if ($record['INVO_AR_AMORT_METHOD'] == CLX_NUM_TWO && $record['INVO_AMORTIZATION_RT'] == CLX_NUM_ZERO) {
                $msg['INVO_AMORTIZATION_RT'] = smsg('MSG-302');
            }
            if ($record['INVO_AMORTIZATION_AMT'] > CLX_NUM_ZERO && $record['INVO_AMORTIZATION_RT'] > CLX_NUM_ZERO) {
                $msg['INVO_AMORTIZATION_RT'] = smsg('MSG-303');
                $msg['INVO_AMORTIZATION_AMT'] = smsg('MSG-303');
            }
            if ($record['INVO_AR_AMORT_METHOD'] == CLX_NUM_ZERO && $record['INVO_AMORTIZATION_AMT'] <> CLX_NUM_ZERO) {
                $msg['INVO_AMORTIZATION_AMT'] = smsg('MSG-304');
            }
            if ($record['INVO_AR_AMORT_METHOD'] == CLX_NUM_ONE && $record['INVO_AMORTIZATION_RT'] <> CLX_NUM_ZERO) {
                $msg['INVO_AMORTIZATION_RT'] = smsg('MSG-304');
            }

            if(!empty($record['INVO_DUE_DATE']) && $record['INVO_INVOICEDATE']>$record['INVO_DUE_DATE']){
                $msg['INVO_INVOICEDATE'] = smsg('MSG-20170327152025');
            }

            //E.C 28-01-2020 validando que si el usuario selecciono tipo de comprobante B04 o B03 Notas de Debito y credito deba indicar la factura padre relacionada 

            if (( $record['INVO_TAXRCPT_TYPE']==='B03' || $record['INVO_TAXRCPT_TYPE']==='B04') && $record['INVO_REL_INVOICE']===''){
                $msg['INVO_REL_INVOICE_prim'] = smsg('MSG-534');
            }


            $sql = 'SELECT GLAC.IDCODE, GLAC.GL_TYPE FROM ' . $this->glacname . ' GLAC, ' . $this->jeitname . ' JEIT, ' . $this->glcpname . ' GLCP WHERE JEIT.GLACCOUNTCODE = GLAC.IDCODE AND GLCP.GLGROUP_CODE = GLAC.GLGROUP_CODE AND GLCP.COMP_CODE = ' . singleQuote($record['INVO_COMP_CODE']) . ' AND JEIT.IDCODE = ' . singleQuote($record['INVO_AR_ITEM_CODE']);
            $glacrec = ClxCommon::$db->getOneRecord($sql);
            if (empty($glacrec)) {
                $msg['INVO_AR_ITEM_CODE'] = smsg('MSG-305');
            }
            //validando amortizacion de ser pago anticipado
            if (!empty($glacrec['GL_TYPE']) && $glacrec['GL_TYPE'] === 'LI' && $record['INVO_AR_AMORT_METHOD'] == CLX_NUM_ZERO) {
                $msg['INVO_AR_AMORT_METHOD'] = smsg('MSG-306');
            }
            if (!empty($record['INVO_ORDERCODE'])) {
                //Total en orden
                $sql = 'SELECT SUM(ORDL.LINE_TOTAL) FROM ORDR_ORDER_LINES ORDL WHERE ORDL.ORDERCODE=' . singleQuote($record['INVO_ORDERCODE']);
                $orderamt = ClxCommon::$db->getOne($sql);
                if (empty($orderamt))
                    $orderamt = CLX_INIT_ZERO;
                //total en facturas
                $sql = 'SELECT SUM(INVO.INVOICE_AMT) FROM ' . $this->invoname . ' INVO WHERE INVO.ORDERCODE=' . singleQuote($record['INVO_ORDERCODE']) . ' AND INVO.IDCODE <> ' . singleQuote($record['INVO_IDCODE']);
                $invototalamt = ClxCommon::$db->getOne($sql);
                if (empty($invototalamt))
                    $invototalamt = CLX_INIT_ZERO;
                $invototalamt += $record['INVO_INVOICE_AMT'];
                if ($invototalamt > $orderamt) {
                    $msg['INVO_ORDERCODE'] = smsg('MSG-324', rounder($orderamt, CLX_NUM_TWO), rounder($invototalamt, CLX_NUM_TWO));
                }
            }
            if (UserRequest::$request['ac'] === 'REQAUTHORIZATION' && empty($msg)) {
                //Validar que la suma de las amortizaciones sea igual a monto de la factura
                if ($record['INVO_AR_AMORT_METHOD'] > CLX_NUM_ZERO) {
                    //val
                    $sql = 'SELECT SUM(AMORTIZATION_AMT) AMORTIZATION_AMT FROM ' . $this->arasname . ' WHERE INVOICECODE = ' . singleQuote($record['INVO_IDCODE']);
                    $amt = ClxCommon::$db->getOne($sql);
                    if ($amt <> ($record['INVO_INVOICE_AMT'] - $record['INVO_AMORTIZATION_INIT'])) {
                        $msg['INVO_CLX_AUTH_STATUS'] = smsg('MSG-307', $record['INVO_IDCODE']);
                    }
                }
                if ($record['INVO_RESTRICTED'] == CLX_NUM_ZERO) {
                    //Count lines at least 1 must exists
                    if (ClxCommon::$db->oneExistsRecords($this->invlname, 'INVOICECODE = ' . singleQuote($record['INVO_IDCODE'])) == CLX_NUM_ZERO) {
                        $msg['INVO_CLX_AUTH_STATUS'] = smsg('MSG-310', $record['INVO_IDCODE']);
                    }
                }
                if ($record['INVO_RESTRICTED'] == CLX_NUM_ZERO && $record['INVO_AR_AMORT_METHOD'] == CLX_NUM_ZERO) {
                    //Previous to autorization
                    if (empty($msg)) { //pre($record);
                        $record['INVO_JEHDR_CODE'] =$this->buildAccounting($record['INVO_IDCODE'],$record['INVO_INVO_STAT']);
                    }
                    if (!class_exists('Jehd'))
                        includeCodeLib('JEHD');
                    $jehd = new Jehd();
                    $jehdrec = ClxCommon::$db->getRecord($this->jehdname, 'IDCODE = ' . singleQuote($record['INVO_JEHDR_CODE']));
                    if (!empty($jehdrec)) {
                        foreach ($jehdrec as $key => $val) {
                            $jehdrec['JEHD_' . $key] = $val;
                        }
                    } else {
                        $msg['INVO_CLX_AUTH_STATUS'] = smsg('MSG-272', $record['INVO_IDCODE']);
                        return false;
                    }
                    $jehd->jehd_validate_form($jehdrec, $msg);
                    unset($jehd);
                }
            }
            return (count($msg) > CLX_NUM_ZERO) ? false : true;
        }else{
            $sql = 'SELECT INVO.IDCODE, INVO.CLX_AUTH_STATUS FROM ' . $this->invoname . ' INVO WHERE INVO.ID in ('.singleQuote($record['idlist']). ')';
            $r = ClxCommon::$db->getOneRecord($sql);
            $record['INVO_IDCODE']=$r['IDCODE'];
            $record['INVO_CLX_AUTH_STATUS'] =$r['CLX_AUTH_STATUS'];
            if ($record['INVO_CLX_AUTH_STATUS'] <> 'PEND' && $record['INVO_CLX_AUTH_STATUS'] <> 'OPQU') {
                $msg['INVO_CLX_AUTH_STATUS'] = smsg('MSG-262', $record['INVO_IDCODE']);
                if (UserRequest::$request['ac'] === 'DELETE') {
                    addMessage($msg['INVO_CLX_AUTH_STATUS']);
                }
                return false;
            }
        }    
    }

    /**
     * Update Information one record is saved
     */
    function save_form(&$record) {
        /* Caso 1002909 - BEGIN - CJRD */
        // Updates lines tax amounts
        $this->invl_all_lines_tax_calc($record['IDCODE']);
        // Updates invoice total amount
        if (UserRequest::$request['ac'] <> 'DUPLICATE') {
            $record['INVOICE_AMT'] = $this->update_invo_total_amt($record['IDCODE'], 'get');
        }
        /* Caso 1002909 - END - CJRD */


        //Find accounting for cases
        if ($record['RESTRICTED'] == CLX_NUM_ZERO) {
            $sql = 'SELECT JEIT.GLACCOUNTCODE FROM ' . $this->jeitname . ' JEIT WHERE JEIT.IDCODE = ' . singleQuote($record['AR_ITEM_CODE']) . ' AND JEIT.CLX_EFFTDATE = (SELECT MAX(JEIT2.CLX_EFFTDATE) FROM GL_ITEM_TBL JEIT2 WHERE JEIT.IDCODE = JEIT2.IDCODE AND JEIT2.CLX_EFFTDATE<=' . singleQuote($this->now) . ')';
            $record['GLACCOUNTCODE'] = ClxCommon::$db->getOne($sql);
        }
    }

    /**
     * Update Information one record is saved
     */
    function save_form_post(&$record){
        //done by aproval 
        if (UserRequest::$request['ac'] === 'DUPLICATE' && $record['INVO_STAT']=='04') {
            $record['CLX_AUTH_STATUS']=='REJ';
        }else if($record['CLX_AUTH_STATUS'] === 'PEND'){
            if(companyParameter('INVO_BUILD_GL_ON_SAVE', $record["COMP_CODE"]) == 1 && $record['AR_AMORT_METHOD'] == CLX_NUM_ZERO) {
                $this->buildAccounting($record['IDCODE'],$record['INVO_STAT']); 
            }
            if ($record['INVO_STAT']=='04') {
                $jehd_status=ClxCommon::$db->getOneRecord('SELECT JE_STATUS FROM '. $this->jehdname .' WHERE IDCODE = ' . singleQuote($record['JEHDR_CODE']));
				if (empty($jehd_status) || empty($jehd_status['JE_STATUS']) || $jehd_status['JE_STATUS']==='REJ' || $jehd_status['JE_STATUS']==='PEND' || $jehd_status['JE_STATUS']==='') {   
				   ClxCommon::$db->updateRecord($this->invoname, array('CLX_AUTH_STATUS' => 'REJ'), 'IDCODE = ' . singleQuote($record['IDCODE']).' AND CLX_AUTH_STATUS<>'.singleQuote('AP'));
				   ClxCommon::$db->updateRecord($this->jehdname, array('CLX_AUTH_STATUS' => 'REJ', 'JE_STATUS'=>'REJ'), 'IDCODE = ' . singleQuote($record['JEHDR_CODE']));
                } 
            }
            //Build Amortization
            if (!class_exists('Aras'))
                includeCodeLib('ARAS');
            $aras = new Aras();
            $aras->build_amortization($record['IDCODE']);
        }
    }

    /**
     * Delete record on delete.
     * @param array $record
     */
    function delete_record_post($record) {

    }

    /**
     * Post Authorization Method
     *
     * @param array $record
     * @param boolean $reject
     */
    function post_autorize(&$record, $reject = false) {
        if (UserRequest::$request['ac'] === 'DELETE')
            return;
        if (array_key_exists('INVO_IDCODE', $record)) {
            $invoicecode = $record['INVO_IDCODE'];
        } else {
            $invoicecode = $record['IDCODE'];
        }
        if (empty($reject)) {
            if (!class_exists('Jehd'))
                includeCodeLib('JEHD');
            $jehd = new Jehd();
            //get approve invoice and approve journal if found
            $sql = 'SELECT JEHD.IDCODE FROM ' . $this->jehdname . ' JEHD, ' . $this->invoname . ' INVO WHERE JEHD.IDCODE = INVO.JEHDR_CODE AND INVO.CLX_AUTH_STATUS = ' . singleQuote('AP') . ' AND JEHD.CLX_AUTH_STATUS = ' . singleQuote('PEND') . ' AND INVO.IDCODE = ' . singleQuote($invoicecode);
            $rs = ClxCommon::$db->executeQuery($sql);
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                $jehd->jehd_approve_queue_by_code($r['IDCODE']);
            }
        } else {
            //   - Caso 1002718 - COR-Al rechazar la aprobacion de la factura el comprobante queda en pendiente
            // Reject invoice
            ClxCommon::$db->updateRecord($this->invoname, array('CLX_AUTH_STATUS' => 'REJ'), 'IDCODE = ' . singleQuote($invoicecode));
            // Reject journal entry
            $invo_jehdr_code = ClxCommon::$db->getField($this->invoname, 'JEHDR_CODE', 'IDCODE = ' . singleQuote($invoicecode));
            if (!is_null($invo_jehdr_code) && $invo_jehdr_code !== '') {
                ClxCommon::$db->updateRecord($this->jehdname, array('JE_STATUS' => 'REJ', 'CLX_AUTH_STATUS' => 'REJ'), 'IDCODE = ' . singleQuote($invo_jehdr_code));
            }
        }
    }

    /**
     * Builds accounting for invoice. Account Receivables
     * @param string $invoicecode
     */
    //ivan
    function buildAccounting($invoicecode,$invo_stat='') {
        $this->je_source = 'AR-ARC';
        $invorec = ClxCommon::$db->getRecord($this->invoname, 'IDCODE = ' . singleQuote($invoicecode));
        if (empty($invoicecode))
            return '';
        if ($invorec['RESTRICTED'] == CLX_NUM_ONE)
            return '';
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        if (!class_exists('Jehd'))
            includeCodeLib('JEHD');
        $jehd = new Jehd();
        $comp = new Comp();
        $oper = $comp->comp_operation_parameters($invorec['COMP_CODE']);
        $rate = $comp->comp_current_exchange($oper['IDCODE'], $invorec['CURRENCY_CODE'], $oper['OPERATION_DATE']);
        $jehdr_code = $invorec['JEHDR_CODE'];
        if (ClxCommon::$db->oneExistsRecords($this->jehdname, 'IDCODE = ' . singleQuote($invorec['JEHDR_CODE'])) == CLX_NUM_ZERO) {
            $jehdr_code = '';
        }
        //Try to search any pending journal for current operation
        if ($jehdr_code === '') {
            $gl_rec = $jehd->jehd_init_record();
            $gl_rec['IDNAME'] = $invorec['IDNAME'];
            $gl_rec['JE_SOURCE'] = $this->je_source;
            $gl_rec['LGGROUP_CODE'] = $oper['LGGROUP_CODE'];
            $gl_rec['EFFTDATE'] = (!empty($invorec['INVOICEDATE'])) ? $invorec['INVOICEDATE'] : $oper['OPERATION_DATE'];
            $gl_rec['REAL_DATE'] = $oper['OPERATION_DATE'];
            $gl_rec['JE_STATUS'] = 'PEND';
            $gl_rec['CLX_AUTH_STATUS'] = 'PEND';
            $gl_rec['COMP_CODE'] = $oper['IDCODE'];
            $gl_rec['FISCAL_PERIOD'] = $oper['FISCAL_PERIOD'];
            $gl_rec['TRANS_CODE'] = 'null';
            $gl_rec['TRANSTBL_CODE'] = 'null';
            $gl_rec['REQ_CHANNEL'] = 'SYS';
            $gl_rec['BATCH_ID'] = $this->batch_id;
            $jehd->jehd_build($gl_rec);
            $jehdr_code = $gl_rec['IDCODE'];
            ClxCommon::$db->updateRecord($this->invoname, array('JEHDR_CODE' => $jehdr_code), 'IDCODE = ' . singleQuote($invoicecode));
        } else {
            $gl_rec = array();
            $gl_rec['IDNAME'] = $invorec['IDNAME'];
            $gl_rec['FISCAL_PERIOD'] = $oper['FISCAL_PERIOD'];
            $gl_rec['EFFTDATE'] = (!empty($invorec['INVOICEDATE'])) ? $invorec['INVOICEDATE'] : $oper['OPERATION_DATE'];
            $gl_rec['REAL_DATE'] = $oper['OPERATION_DATE'];
            $gl_rec['LGGROUP_CODE'] = $oper['LGGROUP_CODE'];
            $gl_rec['FISCAL_PERIOD'] = $oper['FISCAL_PERIOD'];
            $gl_rec['BATCH_ID'] = $this->batch_id;
            // ivan
            if ($invo_stat=='04') {
                $jehd_status=ClxCommon::$db->getOneRecord('select CLX_AUTH_STATUS from '. $this->jehdname .' where IDCODE = ' . singleQuote($invorec['JEHDR_CODE']));
                if ($jehd_status['CLX_AUTH_STATUS']=='PEND') {
                   $gl_rec['CLX_AUTH_STATUS']='REJ';
                   $gl_rec['JE_STATUS']='REJ';
                }   
            }
            ClxCommon::$db->updateRecord($this->jehdname, $gl_rec, 'IDCODE = ' . singleQuote($jehdr_code));
        }
        //Mark lines for delete
        $sql = 'UPDATE ' . $this->jelnname . ' SET IS_REMOVE = 1 WHERE JEHDR_CODE = ' . singleQuote($jehdr_code);
        ClxCommon::$db->executeQuery($sql);
        //adding lines to journal
        $sql = 'SELECT ' . singleQuote($jehdr_code) . ' JEHDR_CODE, INVO.GLACCOUNTCODE, INVO.AR_ITEM_CODE ITEM_CODE, INVO.CHART_FIELD01, INVO.CHART_FIELD02, INVO.CHART_FIELD03, INVO.CHART_FIELD04, INVO.EXT_REF_NO ITEM_REF_NO, INVO.CURRENCY_CODE, ' . $rate['EXCHANGE_RT'] . ' EXCHANGE_RT, ' . $rate['CUR_OPERATOR'] . ' CUR_OPERATOR, ROUND(INVO.INVOICE_AMT*POW(' . $rate['EXCHANGE_RT'] . ', ' . $rate['CUR_OPERATOR'] . '), 2) DEBIT_AMT, 0 CREDIT_AMT, INVO.INVOICE_AMT DEBIT_TRANS_AMT, 0 CREDIT_TRANS_AMT, 1 SEQNUM FROM ' . $this->invoname . ' INVO WHERE INVO.IDCODE = ' . singleQuote($invoicecode);
        $line = ClxCommon::$db->getOneRecord($sql);
        if (!empty($line)) {
            if (empty($line['CHART_FIELD03'])) {
                $line['CHART_FIELD03'] = 'null';
            }
            if (empty($line['CHART_FIELD04'])) {
                $line['CHART_FIELD04'] = 'null';
            }
            if ($line['DEBIT_AMT'] > CLX_NUM_ZERO) {
                $line['CREDIT_AMT'] = CLX_INIT_ZERO;
                $line['CREDIT_TRANS_AMT'] = CLX_INIT_ZERO;
            } elseif ($line['DEBIT_AMT'] < CLX_NUM_ZERO) {
                $line['CREDIT_AMT'] = bcabs($line['DEBIT_AMT']);
                $line['DEBIT_AMT'] = CLX_INIT_ZERO;
                $line['CREDIT_TRANS_AMT'] = bcabs($line['DEBIT_TRANS_AMT']);
                $line['DEBIT_TRANS_AMT'] = CLX_INIT_ZERO;
            }
            $line['IS_REMOVE'] = CLX_INIT_ZERO;
            $qty = ClxCommon::$db->oneExistsRecords($this->jelnname, 'JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND SEQNUM=1');
            if ($qty == CLX_NUM_ZERO) {
                ClxCommon::$db->createRecord($this->jelnname, $line, false);
            } else {
                ClxCommon::$db->updateRecord($this->jelnname, $line, 'JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND SEQNUM=1');
            }
        }
        //adding lines to journal
        $sql = 'SELECT ' . singleQuote($jehdr_code) . ' JEHDR_CODE, INVL.TAX_AMT, INVL.GLACCOUNTCODE, INVL.ITEM_CODE, INVO.CHART_FIELD01, INVO.CHART_FIELD02, INVL.CHART_FIELD03, INVL.CHART_FIELD04, INVO.EXT_REF_NO ITEM_REF_NO, INVO.CURRENCY_CODE, ' . $rate['EXCHANGE_RT'] . ' EXCHANGE_RT, ' . $rate['CUR_OPERATOR'] . ' CUR_OPERATOR, INVL.LINE_TOTAL DEBIT_TRANS_AMT, 0 CREDIT_TRANS_AMT, ROUND(INVL.LINE_TOTAL*POW(' . $rate['EXCHANGE_RT'] . ', ' . $rate['CUR_OPERATOR'] . '), 2) DEBIT_AMT, 0 CREDIT_AMT, INVL.SEQNUM SEQNUM FROM ' . $this->invoname . ' INVO, ' . $this->invlname . ' INVL WHERE INVL.INVOICECODE = INVO.IDCODE AND INVO.IDCODE = ' . singleQuote($invoicecode) . ' ORDER BY INVL.SEQNUM ASC';
        
		$lines = ClxCommon::$db->executeQuery($sql);
        $i = CLX_NUM_TWO;
		while (($line = ClxCommon::$db->getNextRecord($lines))) {
			if (!empty($line)) {
                $this_line_tax_amt = $line['TAX_AMT'];
                unset($line['TAX_AMT']);

                $line_fact=$line['SEQNUM'];
				$line['SEQNUM'] = $i;
                if (empty($line['CHART_FIELD03'])) {
                    $line['CHART_FIELD03'] = 'null';
                }
                if (empty($line['CHART_FIELD04'])) {
                    $line['CHART_FIELD04'] = 'null';
                }
                if ($line['DEBIT_AMT'] > CLX_NUM_ZERO) {
                    $line['CREDIT_AMT'] = $line['DEBIT_AMT'];
                    $line['DEBIT_AMT'] = CLX_INIT_ZERO;
                    $line['CREDIT_TRANS_AMT'] = $line['DEBIT_TRANS_AMT'];
                    $line['DEBIT_TRANS_AMT'] = CLX_INIT_ZERO;
                } elseif ($line['DEBIT_AMT'] < CLX_NUM_ZERO) {
                    $line['DEBIT_AMT'] = bcabs($line['DEBIT_AMT']);
                    $line['CREDIT_AMT'] = CLX_INIT_ZERO;
                    $line['DEBIT_TRANS_AMT'] = bcabs($line['DEBIT_TRANS_AMT']);
                    $line['CREDIT_TRANS_AMT'] = CLX_INIT_ZERO;
                }
                $line['IS_REMOVE'] = CLX_INIT_ZERO;
                $qty = ClxCommon::$db->oneExistsRecords($this->jelnname, 'JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND SEQNUM=' . $i);
				
				if ($line['GLACCOUNTCODE']!=''){
					if ($qty == CLX_NUM_ZERO) {
						ClxCommon::$db->createRecord($this->jelnname, $line, false);
					} else {
						ClxCommon::$db->updateRecord($this->jelnname, $line, 'JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND SEQNUM=' . $i);
					}
					$i++;
				}
                //Linea de impuestos
                /* Caso 1002909 - BEGIN - CJRD */
                if ($this_line_tax_amt > 0) {
                    $tax_line = $line;

                    $a_item_tax_data = $this->get_item_tax_data($line['ITEM_CODE'], $invoicecode);
                    if ($a_item_tax_data['error'] == true || $a_item_tax_data['found'] == false) {
                        // Invalid item, so set an empty G/L account code to force system to throw a warning
                        $tax_line['GLACCOUNTCODE'] = '';
                    } else {
                        $tax_line['GLACCOUNTCODE'] = $a_item_tax_data['data']['GLACCOUNTC_TAX'];
                    }
 

                    // line has a Tax Item code, so look for it and calculate tax amount
					if ($tax_line['DEBIT_AMT'] > 0) {
                        $line_amt_colname = 'DEBIT_AMT';
                        $line_trans_amt_colname = 'DEBIT_TRANS_AMT';
					} else {
                        $line_amt_colname = 'CREDIT_AMT';
                        $line_trans_amt_colname = 'CREDIT_TRANS_AMT';
                    }
		

					// Aqui veo si la linea es solo un impuesto y no un rubro con impuesto
                    $sql = 'SELECT INVO.JEHDR_CODE, INVL.TAX_AMT, INVL.LINE_TOTAL, INVL.LINE_TOTAL_W, INVL.ITEM_CODE, JEIT.ITEM_TYPE FROM ' . $this->invoname . ' INVO, ' . $this->invlname . ' INVL, ' . $this->jeitname  . ' JEIT, ' . $this->jelnname  . ' JELN  WHERE INVL.INVOICECODE = INVO.IDCODE AND INVL.ITEM_CODE = JEIT.IDCODE AND INVO.JEHDR_CODE=JELN.JEHDR_CODE AND INVO.IDCODE = ' . singleQuote($invoicecode) . ' AND INVL.SEQNUM= '.singleQuote($line_fact);
					$linea_fact = ClxCommon::$db->getOneRecord($sql);

					
					//Si la linea es solo un impuesto y no un rubro se debe hacer un ajuste para que el comprobante quede equilibrado
					//Si es impuesto por pagar o impuesto por cobrar recupero el importe usado para el calculo de impuesto
					if ($linea_fact['ITEM_TYPE']=='IXP' || $linea_fact['ITEM_TYPE']=='IXC'){
						$tax_line[$line_trans_amt_colname]=$linea_fact['LINE_TOTAL_W'];
					}


                    $tax_line[$line_amt_colname] = $this_line_tax_amt;
                    if ($tax_line[$line_amt_colname] <> $tax_line[$line_trans_amt_colname]) {
						$tax_line[$line_trans_amt_colname] = $this->calc_tax_amt($tax_line[$line_trans_amt_colname], $a_item_tax_data);
                    } else {
						$tax_line[$line_trans_amt_colname] = $this_line_tax_amt;
                    }

					$tax_line['SEQNUM'] = $i;
                    $qty = ClxCommon::$db->oneExistsRecords($this->jelnname, 'JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND SEQNUM=' . $i);
                    if ($qty == 0) {
                        ClxCommon::$db->createRecord($this->jelnname, $tax_line, false);
                    } else {
                        ClxCommon::$db->updateRecord($this->jelnname, $tax_line, 'JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND SEQNUM=' . $i);
                    }
                    $i++;
                }
                /* Caso 1002909 - END - CJRD */
            }
        }
        $sql = 'DELETE FROM ' . $this->jelnname . ' WHERE JEHDR_CODE = ' . singleQuote($jehdr_code) . ' AND IS_REMOVE = 1';
        ClxCommon::$db->executeQuery($sql);
        return $jehdr_code;
    }

    /* Caso 1002909 - BEGIN - CJRD */
    /*
     * 2015-08-28 CJRD
     * Caso 1002909 - MUN-Agregar calc ITBMS en Fact
     */

    /**
     * Get invoice line tax amount
     */
    private function get_tax_amt($line_item_code, $line_total, $invoicecode) {
        $a_item_tax_data = $this->get_item_tax_data($line_item_code, $invoicecode);
        if ($a_item_tax_data['error'] == true || $a_item_tax_data['found'] == false) {
            return 0;
        }
        // line has a Tax Item code, so look for it and calculate tax amount
        return $this->calc_tax_amt($line_total, $a_item_tax_data);
    }

    /**
     * Calc line tax amount
     */
    private function calc_tax_amt($line_total, $sales_tax_data) {

        $response = bcmul(bcmul(bcsub($line_total, $sales_tax_data['data']['EXEMPT_TAX_AMT']), bcdiv($sales_tax_data['data']['FLAT_RATE'], 100)), bcdiv($sales_tax_data['data']['TAX_WITHOLDING_PCT'], '100'));

        if ($response < 0) {
            $response = 0;
        }
        return $response;
    }

    /**
     * Get invoice line tax item record
     */
    private function get_item_tax_data($line_item_code, $invoicecode) {


        $a_response = array();
        $a_response['error'] = false;
        $a_response['found'] = false;

        $sql = 'SELECT INVO.ACCOUNTCODE, ACCO.LEGAL_TYPE, ACCO.STATE, ACCO.COUNTRY, JEIT.FLAT_RATE, JEIT.EXEMPT_TAX_AMT, JEIT.TAX_WITHOLDING_PCT,JEIT.TAX_TYPE, JEIT.FILING_STATUS, JEIT.STATE, JEIT.COUNTRY, IFNULL(JEIT.GLACCOUNTC_TAX, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') GLACCOUNTC_TAX, JEIT.GLACCOUNTCODE FROM ' . $this->invoname . ' INVO LEFT JOIN CRM_ACCOUNTS ACCO ON ACCO.IDCODE = INVO.ACCOUNTCODE, ' . $this->jeitname . ' JEIT WHERE INVO.IDCODE = ' . singleQuote($invoicecode) . ' AND JEIT.IDCODE = ' . singleQuote($line_item_code) . '  AND JEIT.CLX_EFFTDATE=(SELECT MAX(X.CLX_EFFTDATE) CLX_EFFTDATE FROM ' . $this->jeitname . ' X  WHERE  X.IDCODE=JEIT.IDCODE AND  X.CLX_EFFTDATE <=  INVO.INVOICEDATE)';
        $rs = ClxCommon::$db->executeQuery($sql);
        if ($r = ClxCommon::$db->getNextRecord($rs)) {
            $a_response['data'] = $r;
            $a_response['found'] = true;
        }
       
        return $a_response;
    }

    /**
     * Calculate Tax amount for all invoice lines
     */
    private function invl_all_lines_tax_calc($invoicecode) {

        $sql = 'SELECT INVL.ID, INVL.ITEM_CODE, INVL.TAX_AMT, (CASE WHEN ITEM_TYPE=\'IXC\' THEN INVL.LINE_TOTAL_W WHEN ITEM_TYPE=\'IXP\' THEN INVL.LINE_TOTAL_W ELSE INVL.LINE_TOTAL END) LINE_TOTAL FROM ' . $this->invlname . ' INVL, '. $this->jeitname . ' JEIT WHERE INVL.INVOICECODE = ' . singleQuote($invoicecode) . ' AND INVL.ITEM_CODE=JEIT.IDCODE';
		
		
        $lines = ClxCommon::$db->executeQuery($sql);
		
        while ($line = ClxCommon::$db->getNextRecord($lines)) {
			
			$this_line_tax_amt = 0;
            $a_item_tax_data = $this->get_item_tax_data($line['ITEM_CODE'], $invoicecode);
            if ($a_item_tax_data['error'] == false && $a_item_tax_data['found'] == true) {
                // line has a Tax Item code, so look for it and calculate tax amount
                $this_line_tax_amt = $this->calc_tax_amt($line ['LINE_TOTAL'], $a_item_tax_data);
            }

            if ($this_line_tax_amt <> $line ['TAX_AMT'] && !empty($line ['ID'])) {
                $tax_line = array('TAX_AMT' => $this_line_tax_amt);
                ClxCommon::$db->updateRecord($this->invlname, $tax_line, 'ID = ' . $line ['ID']);
            }
        }
    }

    /**
     * Update invoice total amount from invoice lines
     */
    private function update_invo_total_amt($invoicecode, $action) {

        if ($action == 'set') {
            $sql = 'UPDATE ' . $this->invoname . ' INVO SET INVO.INVOICE_AMT = IFNULL((SELECT SUM(INVL.LINE_TOTAL+INVL.TAX_AMT) FROM ' . $this->invlname . ' INVL WHERE INVL.INVOICECODE = INVO.IDCODE), 0) WHERE INVO.IDCODE = \'' . $invoicecode . '\'';
			
            ClxCommon::$db->executeQuery($sql);
            $response = ClxCommon::$db->getField($this->invoname, 'INVOICE_AMT', 'IDCODE = ' . singleQuote($invoicecode));
        } else {
            $response = ClxCommon::$db->getField($this->invlname, 'SUM(LINE_TOTAL+TAX_AMT)', 'INVOICECODE = ' . singleQuote($invoicecode));
        }

        return $response;
    }

    /**
     * Recalculate amount
     */
    function recalculateTotalFromLine() {
        $cp = peekHistory();
        if (!empty($cp['parentrecord']['INVO_IDCODE'])) {
            if ($cp['parentrecord']['INVO_CLX_AUTH_STATUS'] == 'PEND') {
                // Updates lines tax amounts
                $this->invl_all_lines_tax_calc($cp['parentrecord']['INVO_IDCODE']);
                // Updates invoice total amount
                $prev_invoice_amt = 0 + $cp['parentrecord']['INVO_INVOICE_AMT'];
                $new_invoice_amt = $this->update_invo_total_amt($cp['parentrecord']['INVO_IDCODE'], 'set');
                if ($prev_invoice_amt != $new_invoice_amt && $cp['parentrecord']['INVO_JEHDR_CODE'] != '') {
                    /*
                     * Re-Builds accounting if invoice total amount was changed in this method
                     * and journal entry was already generated
                     */
                    $this->buildAccounting($cp['parentrecord']['INVO_IDCODE']);
                }
            } else {
                addMessage(smsg('MSG-262', $cp['parentrecord']['INVO_IDCODE']));
            }
        } else {
            addMessage('INTERNAL ERROR: no Invoice code...');
        }
    }

    /* Caso 1002909 - END - CJRD */

    /**
     * Load transaction form with invoice information
     * @return string
     */
    function recievePayments() {
        if (!class_exists('Fiat'))
            includeCodeLib('FIAT');
        $idlist = getIdlist();
        $_SESSION['FIAT_OPTS'] = array();
        $_SESSION['FIAT_OPTS']['INVO'] = $idlist;
        $idlist = toString($idlist);
        //check status
        $sql = 'SELECT COUNT(ID) FROM ' . $this->invoname . ' WHERE (CLX_AUTH_STATUS <> ' . singleQuote('AP') . ' OR INVO_STAT = '. singleQuote('05') .') AND ID IN (' . $idlist . ')';
        if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
            return note(smsg('MSG-276'));
        }

        $sql = 'SELECT INVO.COMP_CODE, INVO.CHART_FIELD01, INVO.ACCOUNTCODE BENEFICIARY_CODE, INVO.CHART_FIELD02, INVO.CHART_FIELD03, INVO.CURRENCY_CODE, INVO.CHART_FIELD04, /*Open Balance*/ SUM(IFNULL(INVO.INVOICE_AMT-(IF(INVO.OPENING_BAL<>0, INVO.INVOICE_AMT-INVO.OPENING_BAL, 0)+ IFNULL((SELECT SUM(INPY.PAID_AMT) FIAT_TRANS_AMT FROM GL_JOURNAL_HDR JEHD, FIDU_TRANSACTIONS FIAT, BILL_INVPYMT_TRANS INPY WHERE INPY.INVOICECODE = INVO.IDCODE AND INPY.JEHDR_CODE = JEHD.IDCODE AND FIAT.IDCODE = JEHD.TRANS_CODE AND FIAT.CLX_AUTH_STATUS<> ' .singleQuote('REJ'). ' AND FIAT.VOID = 0),0)),0)) INVOICE_AMT, MAX(INVO.INVOICEDATE) INVOICE_DATE, MAX(INVO.IDNAME) IDNAME, MAX(IFNULL(NULLIF(INVO.EXT_REF_NO,' . singleQuote(CLX_CHAR_EMPTY_STRING) . '),INVO.IDCODE)) EXT_REF_NO, MAX((IFNULL((SELECT SUM(INVL.TAX_AMT) FROM ' . $this->invlname . ' INVL WHERE INVL.INVOICECODE = INVO.IDCODE), 0))) TAX_AMT FROM ' . $this->invoname . ' INVO WHERE INVO.ID IN (' . $idlist . ') GROUP BY INVO.COMP_CODE, INVO.ACCOUNTCODE, INVO.CHART_FIELD01, INVO.CHART_FIELD02';

        $r = ClxCommon::$db->getOneRecord($sql);
        if (empty($r)) {
            return note(smsg('MSG-276'));
        }
        
		UserRequest::$post['FIAT_COMP_CODE'] = $r['COMP_CODE'];
        UserRequest::$post['FIAT_CHART_FIELD01'] = $r['CHART_FIELD01'];
        UserRequest::$post['FIAT_CHART_FIELD02'] = $r['CHART_FIELD02'];
        UserRequest::$post['FIAT_CHART_FIELD03'] = $r['CHART_FIELD03'];
        UserRequest::$post['FIAT_CHART_FIELD04'] = $r['CHART_FIELD04'];
        UserRequest::$post['FIAT_CURRENCY_CODE'] = $r['CURRENCY_CODE'];
        UserRequest::$post['FIAT_TRANS_AMT'] = $r['INVOICE_AMT'];
        UserRequest::$post['FIAT_TAX_AMT'] = $r['TAX_AMT'];
        
		//se quito porque no aplica para OMG
		//UserRequest::$post['FIAT_DISBURSEMENT_TYPE'] = 'OT';
        UserRequest::$post['FIAT_DISBURSEMENT_TYPE'] = '';
		
		UserRequest::$post['FIAT_BENEFICIARY_CODE'] = $r['BENEFICIARY_CODE'];
        UserRequest::$post['FIAT_BENEFICIARY_CODE_prim'] = $r['BENEFICIARY_CODE'];
        UserRequest::$post['FIAT_INVOICE_DATE'] = $r['INVOICE_DATE'];
        UserRequest::$post['FIAT_IDNAME'] = $r['IDNAME'];
        UserRequest::$post['FIAT_REFERENCE_NO'] = $r['EXT_REF_NO'];
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        if (!class_exists('Jehd'))
            includeCodeLib('JEHD');
        $comp = new Comp();
        $oper = $comp->comp_operation_parameters($r['COMP_CODE']);
        $rate = $comp->comp_current_exchange($oper['IDCODE'], $r['CURRENCY_CODE'], $oper['OPERATION_DATE']);
        UserRequest::$post['FIAT_EXCHANGE_RT'] = $rate['EXCHANGE_RT'];
        UserRequest::$post['FIAT_CUR_OPERATOR'] = $rate['CUR_OPERATOR'];
        UserRequest::$post['FIAT_BASE_TRANS_AMT'] = $r['INVOICE_AMT'];
        if ($rate['CUR_OPERATOR'] == CLX_NUM_ONE) {
            UserRequest::$post['FIAT_BASE_TRANS_AMT'] = rounder($r['INVOICE_AMT'] * $rate['EXCHANGE_RT'], CLX_NUM_TWO);
        } else {
            UserRequest::$post['FIAT_BASE_TRANS_AMT'] = rounder($r['INVOICE_AMT'] / $rate['EXCHANGE_RT'], CLX_NUM_TWO);
        }
        $ac = 'CREATE';
        UserRequest::$request['ac'] = $ac;
        UserRequest::$post['ac'] = $ac;
        UserRequest::$get['ac'] = $ac;
        UserRequest::$request['li'] = 'FIAT_AR_SRCH'; //to enable list after save
        pushHistory('EDIT', 'LIST', '', 'li', 'FIAT_AR_SRCH');
        $EDIT = getTool('EDIT');
        return $EDIT->action('CREATE', CLX_NUM_ZERO);
    }

    /**
     * Builds Apin Record, Used in processes
     * @param unknown_type $record
     */
    function build_record(&$record) {
        if (empty($record))
            return;
        if (!function_exists('setCreationData')) {
            includeCodeLib('GEN_REC_UTIL');
        }
        setCreationData($record);
        setCreationIdCode($record, 'INVO');
        ClxCommon::$db->loadDbRecord($this->invoname, $record, false, 'IDCODE = ' . singleQuote($record['IDCODE']));
    }

    //INVL Events
    function invl_init_form(&$record) {
		$cp = peekHistory();
        if (!empty($cp['parentrecord']['INVO_CHART_FIELD01'])) {
            $record['INVL_CHART_FIELD01'] = $cp['parentrecord']['INVO_CHART_FIELD01'];
        }
        if (UserRequest::$request['ac'] === 'CREATE' && empty(UserRequest::$post['confirm'])) {
            $cp = peekHistory();
            if (!empty($cp['parentrecord']['INVO_CHART_FIELD01'])) {
                $record['INVL_CHART_FIELD01'] = $cp['parentrecord']['INVO_CHART_FIELD01'];
            }
            $sql = 'SELECT ROUND((INVOICE_AMT - IFNULL((SELECT SUM(LINE_TOTAL) TOTAL_LINES FROM ' . $this->invlname . ' WHERE INVOICECODE = ' . singleQuote($record['INVL_INVOICECODE']) . '),0)), 2) TOTAL FROM ' . $this->invoname . ' WHERE IDCODE = ' . singleQuote($record['INVL_INVOICECODE']);
            $total = ClxCommon::$db->getOne($sql);
            //$record['INVL_LINE_TOTAL'] = $total;
            //$record['INVL_PRICE'] = $total;
            //$record['INVL_QUANTITY'] = CLX_NUM_ONE;
			//igualamos a cero para que cargue esos campos en  cero. Anteriormente se traia el valor de la ultima linea
			$record['INVL_LINE_TOTAL'] = 0;
            $record['INVL_PRICE'] = 0;
            $record['INVL_QUANTITY'] = 0;
        }else{
			$sql = 'SELECT INVL.PRICE_W, INVL.QUANTITY_W, JEIT.ITEM_TYPE FROM ' . $this->invlname . ' INVL, '. $this->jeitname .' JEIT WHERE INVL.ID= '.singleQuote($record['INVL_ID']). ' AND INVL.INVOICECODE = ' . singleQuote($record['INVL_INVOICECODE']) . ' AND INVL.ITEM_CODE = JEIT.IDCODE';
            $r = ClxCommon::$db->getOneRecord($sql);
			if ($r['ITEM_TYPE'] === 'IXP' or $r['ITEM_TYPE'] === 'IXC'){
            	$record['INVL_PRICE'] = $r['PRICE_W'];
				$record['INVL_QUANTITY'] = $r['QUANTITY_W'];
			}else{
				//pre($record);
				//exit;
			}
		}
    }

    /**
     * Update Information one record is saved
     */
    function invl_save_form(&$record) {
        //Find accounting for cases
        $restricted = ClxCommon::$db->getField($this->invoname, 'RESTRICTED', 'IDCODE = ' . singleQuote($record['INVOICECODE']));
        if ($restricted == CLX_NUM_ZERO) {
            $sql = 'SELECT JEIT.GLACCOUNTCODE FROM ' . $this->jeitname . ' JEIT WHERE JEIT.IDCODE = ' . singleQuote($record['ITEM_CODE']) . ' AND JEIT.CLX_EFFTDATE = (SELECT MAX(JEIT2.CLX_EFFTDATE) FROM GL_ITEM_TBL JEIT2 WHERE JEIT.IDCODE = JEIT2.IDCODE AND JEIT2.CLX_EFFTDATE<=' . singleQuote($this->now) . ')';
            $record['GLACCOUNTCODE'] = ClxCommon::$db->getOne($sql);
        }
    }

    /**
     * Validate record information for invoice lines
     * Executed on table validate
     *
     * @param array $record
     * @param array $msg
     */
    function invl_validate_form(&$record, &$msg) {
        if  (UserRequest::$request['ac']=='DELETE'){
            $sql = 'SELECT INVL.INVOICECODE FROM ' . $this->invlname . ' INVL WHERE INVL.ID in ('.singleQuote($record['idlist']). ')';
            $r = ClxCommon::$db->getOneRecord($sql);
            $record['INVL_INVOICECODE']=$r['INVOICECODE'];
        }
        $invorec = ClxCommon::$db->getRecord($this->invoname, 'IDCODE = ' . singleQuote($record['INVL_INVOICECODE']));
        if ($invorec['CLX_AUTH_STATUS'] <> 'PEND') {
            $msg['INVL_INVOICECODE'] = smsg('MSG-262', $record['INVL_INVOICECODE']);
            if (UserRequest::$request['ac'] == 'DELETE')
                addMessage(smsg('MSG-262', $record['INVL_INVOICECODE']));
            return false;
        }
        

        if  (UserRequest::$request['ac']=='CREATE' || UserRequest::$request['ac']=='MODIFY' ){
            //Validate line amount must be greater than cero.
            if ($record['INVL_LINE_TOTAL'] == CLX_NUM_ZERO) {
                $msg['INVL_LINE_TOTAL'] = smsg('MSG-296', $record['INVL_INVOICECODE']);
                return false;
            }
            // Aqui preguntamos si la linea de factura es solo un impuesto, si lo es colocamos quantity=0, price=0 y Line_total=0 para que no nos sume en el total de factura antes de guardar
            $sql='SELECT ITEM_TYPE FROM '. $this->jeitname .' WHERE IDCODE = '. singleQuote($record['INVL_ITEM_CODE']);
            $item_imp = ClxCommon::$db->getOneRecord($sql);

            if ($item_imp['ITEM_TYPE'] == 'IXP' or $item_imp['ITEM_TYPE'] == 'IXC') {
                $record['INVL_QUANTITY_W']=$record['INVL_QUANTITY'];
                $record['INVL_PRICE_W']=$record['INVL_PRICE'];
                $record['INVL_LINE_TOTAL_W']=$record['INVL_LINE_TOTAL'];
                $record['INVL_QUANTITY']=0;
                $record['INVL_PRICE']=0.00;
                $record['INVL_LINE_TOTAL']=0.00;	
            }else{
                // Solo se valida cuenta contable si no es un impuesto
                $sql = 'SELECT GLAC.IDCODE, GLAC.GL_TYPE FROM ' . $this->glacname . ' GLAC, ' . $this->jeitname . ' JEIT, ' . $this->glcpname . ' GLCP WHERE JEIT.GLACCOUNTCODE = GLAC.IDCODE AND GLCP.GLGROUP_CODE = GLAC.GLGROUP_CODE AND GLCP.COMP_CODE = ' . singleQuote($invorec['COMP_CODE']) . ' AND JEIT.IDCODE = ' . singleQuote($record['INVL_ITEM_CODE']);
                $glacrec = ClxCommon::$db->getOneRecord($sql);
                if (empty($glacrec)) {
                    $msg['INVL_ITEM_CODE'] = smsg('MSG-315');
                }
            }
       }
    }

    /**
     * Post line save events that affect invoice headers
     * @param $record
     */
    function updateTotalFromLine($record) {
		$sql = 'UPDATE ' . $this->invoname . ' INVO SET INVOICE_AMT = IFNULL((SELECT SUM(INVL.LINE_TOTAL+INVL.TAX_AMT) FROM ' . $this->invlname . ' INVL WHERE INVL.INVOICECODE = INVO.IDCODE),0) WHERE IDCODE = ' . singleQuote($record['INVOICECODE']);
        ClxCommon::$db->executeQuery($sql);
        $invorec = ClxCommon::$db->getFields($this->invoname, 'IDCODE, CLX_AUTH_STATUS, COMP_CODE, AR_AMORT_METHOD', 'IDCODE = ' . singleQuote($record['INVOICECODE']));
        if ($invorec['CLX_AUTH_STATUS'] === 'PEND') {
            if (!class_exists('Apas'))
                includeCodeLib('ARAS');
            $aras = new Aras();
            $aras->build_amortization($invorec['IDCODE']);
            unset($aras);
            if(companyParameter('INVO_BUILD_GL_ON_SAVE', $invorec["COMP_CODE"]) == 1 && $invorec['AR_AMORT_METHOD'] == CLX_NUM_ZERO)
                $this->buildAccounting($invorec['IDCODE']);
        }
    }

    //Amortization process run by daily closing
    /**
     * Runs interest calculation from btn
     *
     */
    function run_amortization_accounting_btn() {
        $idlist = getIdlist();
        if (empty($idlist))
            return;
        $sql = 'SELECT DISTINCT COMP_CODE, IDCODE FROM ' . $this->invoname . ' WHERE ID IN (' . toString($idlist) . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while (($r = ClxCommon::$db->getNextRecord($rs, NUMERIC))) {
            $this->build_amortization_accounting($r[CLX_NUM_ZERO], $r[CLX_NUM_ONE]);
        }
    }

    /**
     * Runs asset depreciation on closing
     * @param string $comp_code
     */
    function run_amortization_cron($comp_code) {
        $this->display = true;
        $this->build_amortization_accounting($comp_code);
    }

    /**
     * Proceso para construccion de amortizacion de facturas
     *
     * @param string $comp_code
     * @param string $invoice_code
     */
    private function build_amortization_accounting($comp_code, $invoice_code = '') {
        //GLT1
        $this->je_source = 'AR.ARAS'; //Amortizacion de cuentas por cobrar. Deferred Income
        $DBLT = &getTool('DBLT');
        $idname = $DBLT->getListItem('SOTY', $this->je_source);
        $idname = substr($idname, CLX_NUM_ZERO, CLX_NUM_60);
        if (!class_exists('Comp'))
            includeCodeLib('COMP');
        $comp = new Comp();
        $comprec = $comp->comp_operation_parameters($comp_code);
        $operation_date = $comprec['OPERATION_DATE'];
		if (empty($operation_date)) {
			echoLog('<br> ERROR not operation date for company: '.$comp_code.' <br>');
			return;
		}
        if ($this->display === true) {
            echoLog('AR DEFERRED INCOME PROCESS. BATCH ID: ' . $this->batch_id);
            echoLog('Efective date: ' . $operation_date);
            echoLog('Invoice: ' . (($invoice_code === '') ? 'ALL' : $invoice_code));
        }
        if (empty($comprec) || empty($comp_code)) {
            echoLog('Error, no company operation parameters found');
        }
        //Init Temporary Tables
        $this->initTemporaryTables($this->batch_id);
        //loading temporary table
        /* Note LI balance will be -1 that is why -1* and AND JCBV.BALANCE_AMT <= ARAS.AMORTIZATION_AMT */
        $sql = 'INSERT INTO ' . $this->glt1name . '
						(COMP_CODE,
						BATCH_ID,
						EFFTDATE,
						GLACCOUNTCODE,
						GL01_CODE,
						GL_TYPE,
						BALANCE_AMT,
						CALC_AMT_01,
						CALC_AMT_02,
						CALC_AMT_03,
						CALC_AMT_04,
						CHART_FIELD01,
						CHART_FIELD02,
						CHART_FIELD03,
						CHART_FIELD04,
						CURRENCY_CODE,
						CUR_OPERATOR,
						EXCHANGE_RT,
						DEBIT_AMT,
						CREDIT_AMT,
						DEBIT_TRANS_AMT,
						CREDIT_TRANS_AMT,
						LOAN_CODE,
						ITEM_CODE,
					 	ITEM02_CODE)
					SELECT INVO.COMP_CODE,
						' . singleQuote($this->batch_id) . ' BATCH_ID,
						INVO.INVOICEDATE EFFTDATE,
						INVO.GLACCOUNTCODE,
						INVL.GLACCOUNTCODE GL01_CODE,
						JCBV.GL_TYPE,
						SUM(JCBV.BALANCE_AMT) BALANCE_AMT,
						ARAS.AMORTIZATION_AMT CALC_AMT_01,
						SUM(JCBV.BALANCE_AMT) CALC_AMT_02,
						INVO.INVOICE_AMT CALC_AMT_03,
						INVL.LINE_TOTAL CALC_AMT_04,
						JCBV.CHART_FIELD01,
						JCBV.CHART_FIELD02,
						JCBV.CHART_FIELD03,
						JCBV.CHART_FIELD04,
						JCBV.CURRENCY_CODE,
						1 CUR_OPERATOR,
						1 EXCHANGE_RT,
						0 DEBIT_AMT,
						0 CREDIT_AMT,
						0 DEBIT_TRANS_AMT,
						0 CREDIT_TRANS_AMT,
						INVO.IDCODE LOAN_CODE,
						INVO.AR_ITEM_CODE ITEM_CODE,
					 	INVL.ITEM_CODE ITEM02_CODE
					FROM
						'. $this->invoname .' INVO ,
						'. $this->invlname .' INVL,
						'. $this->arasname .' ARAS,
						'. $this->jcbvname .' JCBV,
	                    '. $this->fipaname .' FIPA
					WHERE
						ARAS.INVOICECODE = INVO.IDCODE
						AND INVL.INVOICECODE = INVO.IDCODE
						AND JCBV.CHART_FIELD01 = INVO.CHART_FIELD01
						AND JCBV.CHART_FIELD02 = INVO.CHART_FIELD02
	                    AND FIPA.CONTRACT_CODE = INVO.CHART_FIELD01
	                    AND FIPA.ACCOUNTCODE = INVO.CHART_FIELD02
	                    AND FIPA.STATUS = ' . singleQuote('A') . '
						AND INVO.GLACCOUNTCODE = JCBV.GLACCOUNTCODE
						AND INVO.CURRENCY_CODE = JCBV.CURRENCY_CODE
						AND INVO.CLX_AUTH_STATUS = ' . singleQuote('AP') . '
						AND ARAS.PERIOD_END_DATE = ' . singleQuote($operation_date) . '
						AND INVO.COMP_CODE = ' . singleQuote($comp_code) . ' ' . (($invoice_code != '') ? ' 
                        AND INVO.IDCODE =' . singleQuote($invoice_code) : '') . ' 
						AND INVO.INVO_STAT = ' . singleQuote('02') . '
						AND EXISTS(SELECT GLAC.ID FROM '. $this->glacname . ' GLAC WHERE GLAC.IDCODE = INVL.GLACCOUNTCODE AND GLAC.GL_TYPE = ' . singleQuote('EX') . ')
                    GROUP BY
	                    INVO.COMP_CODE,
					    INVO.INVOICEDATE,
	                    INVO.GLACCOUNTCODE,
	                    INVL.GLACCOUNTCODE,
	                    JCBV.GL_TYPE,
	                    ARAS.AMORTIZATION_AMT,
	                    INVO.INVOICE_AMT,
	                    INVL.LINE_TOTAL,
	                    JCBV.CHART_FIELD01,
	                    JCBV.CHART_FIELD02,
	                    JCBV.CHART_FIELD03,
	                    JCBV.CHART_FIELD04,
	                    JCBV.CURRENCY_CODE,
	                    INVO.IDCODE,
	                    INVO.AR_ITEM_CODE,
	                    INVL.ITEM_CODE
	                 HAVING
	                    SUM(JCBV.BALANCE_AMT) >= ARAS.AMORTIZATION_AMT'; 

        ClxCommon::$db->executeQuery($sql);
        if (ClxCommon::$db->oneExistsRecords($this->glt1name, 'BATCH_ID = ' . singleQuote($this->batch_id)) == CLX_NUM_ZERO) {
            return;
        }
        //Actualizar porcentage que representa el concepto sobre el total de la factura.
        //Distribuir en funcion del concepto si tiene multiples cuentas contables
        $sql = 'UPDATE ' . $this->glt1name . ' SET CALC_AMT_01 = round(CALC_AMT_01 * (CALC_AMT_04/CALC_AMT_03), 2) WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'SELECT DISTINCT COMP_CODE, CURRENCY_CODE, EFFTDATE OPERATION_DATE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $rate = $comp->comp_current_exchange($r['COMP_CODE'], $r['CURRENCY_CODE'], $r['OPERATION_DATE']);
            $sql = 'UPDATE ' . $this->glt1name . ' SET CUR_OPERATOR = ' . singleQuote($rate['CUR_OPERATOR']) . ', EXCHANGE_RT = ' . singleQuote($rate['EXCHANGE_RT']) . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND CURRENCY_CODE = ' . singleQuote($r['CURRENCY_CODE']) . ' AND COMP_CODE = ' . singleQuote($r['COMP_CODE']);
            ClxCommon::$db->executeQuery($sql);
        } //end while
        //Colocando contabilidad
        $sql = 'UPDATE ' . $this->glt1name . ' SET DEBIT_AMT = CALC_AMT_01 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE = ' . singleQuote('AS') . '';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt1name . ' SET CREDIT_AMT = CALC_AMT_01 WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND GL_TYPE <> ' . singleQuote('AS') . '';
        ClxCommon::$db->executeQuery($sql);
        //Colocando contabilidad
        $sql = 'UPDATE ' . $this->glt1name . ' SET DEBIT_TRANS_AMT = DEBIT_AMT, DEBIT_AMT = ROUND((DEBIT_AMT*POW(EXCHANGE_RT, CUR_OPERATOR)), 2) WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND DEBIT_AMT <> 0';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->glt1name . ' SET CREDIT_TRANS_AMT = CREDIT_AMT, CREDIT_AMT = ROUND((CREDIT_AMT*POW(EXCHANGE_RT, CUR_OPERATOR)), 2) WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' AND CREDIT_AMT <> 0';
        ClxCommon::$db->executeQuery($sql);
        if (!class_exists('Jehd'))
            includeCodeLib('Jehd');
        $jehd = new Jehd();
        $jehd->display = $this->display;
        //Reject any posible todays entry from this process thas has run today
        $jehd->jehd_reverse_by_je_source($comp_code, $this->je_source, $operation_date);
        /* 2. GENERAR ACTIVIDADES DE DEVENGO PARA PARTICIPANTES DE CONTRATO */
        //Build Header for this process, one pre currency
        $sql = 'SELECT DISTINCT COMP_CODE, ' . singleQuote($operation_date) . ' OPERATION_DATE, ' . singleQuote($comprec['LGGROUP_CODE']) . ' LGGROUP_CODE FROM ' . $this->glt1name . ' WHERE BATCH_ID = ' . singleQuote($this->batch_id);
        $results = ClxCommon::$db->executeQuery($sql);
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            $gl_rec = $jehd->jehd_init_record();
            $gl_rec['IDCODE'] = 'AUTO';
            $gl_rec['IDNAME'] = $idname;
            $gl_rec['JE_SOURCE'] = $this->je_source;
            $gl_rec['LGGROUP_CODE'] = $result['LGGROUP_CODE'];
            $gl_rec['EFFTDATE'] = $result['OPERATION_DATE'];
            $gl_rec['COMP_CODE'] = $result['COMP_CODE'];
            $gl_rec['TRANS_CODE'] = null;
            $gl_rec['TRANSTBL_CODE'] = 'SYS_CRED-INTE';
            $gl_rec['REQ_CHANNEL'] = 'SYS';
            $gl_rec['BATCH_ID'] = $this->batch_id;
            $jehd->jehd_build($gl_rec);
            //Search any scale if apply and dump lines to journal
            //debit in credit as
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec['IDCODE']) . ' JEHDR_CODE, X.GL01_CODE GLACCOUNTCODE, X.ITEM02_CODE ITEM_CODE, X.CHART_FIELD01, X.CHART_FIELD02, X.CHART_FIELD03, X.CHART_FIELD04, X.LOAN_CODE ITEM_REF_NO, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR, X.DEBIT_AMT, X.CREDIT_AMT, X.DEBIT_TRANS_AMT, X.CREDIT_TRANS_AMT, 1 SEQNUM FROM ' . $this->glt1name . ' X WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' ';
            ClxCommon::$db->executeQuery($sql);
            //contraparte
            $sql = 'INSERT INTO ' . $this->jelnname . ' (JEHDR_CODE, GLACCOUNTCODE, ITEM_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, ITEM_REF_NO, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, DEBIT_AMT, CREDIT_AMT, DEBIT_TRANS_AMT, CREDIT_TRANS_AMT, SEQNUM) SELECT ' . singleQuote($gl_rec['IDCODE']) . ' JEHDR_CODE, X.GLACCOUNTCODE GLACCOUNTCODE, X.ITEM_CODE ITEM_CODE, X.CHART_FIELD01, X.CHART_FIELD02, X.CHART_FIELD03, X.CHART_FIELD04, X.LOAN_CODE ITEM_REF_NO, X.CURRENCY_CODE, X.EXCHANGE_RT, X.CUR_OPERATOR, X.CREDIT_AMT DEBIT_AMT, X.DEBIT_AMT CREDIT_AMT, X.CREDIT_TRANS_AMT DEBIT_TRANS_AMT, X.DEBIT_TRANS_AMT CREDIT_TRANS_AMT, 2 SEQNUM FROM ' . $this->glt1name . ' X WHERE BATCH_ID = ' . singleQuote($this->batch_id) . ' ';
            ClxCommon::$db->executeQuery($sql);
            //Removing sub account from in,ex,eq
            $sql = 'UPDATE ' . $this->jelnname . ' JELN SET JELN.CHART_FIELD03 = null WHERE JELN.JEHDR_CODE = ' . singleQuote($gl_rec['IDCODE']) . ' AND EXISTS(SELECT GLAC.ID FROM ' . $this->glacname . ' GLAC WHERE GLAC.IDCODE = JELN.GLACCOUNTCODE AND GLAC.GL_TYPE IN (' . singleQuote('IN') . ',' . singleQuote('EX') . ',' . singleQuote('EQ') . '))';
            ClxCommon::$db->executeQuery($sql);
            $jehd->jehd_approve_by_code($gl_rec['IDCODE']);
        }
    }

    /**
     * Initialice all temporary tables
     *
     * @param string $batch_id
     */
    private function initTemporaryTables($batch_id) {
        //Load temporary table - Req on mysql
        $DBTB = &getTool('DBTB');
        $DBTB->buildTemporaryTable('GLT1'); //Clear tmp
        ClxCommon::$db->executeQuery('DELETE FROM ' . $this->glt1name);
        ClxCommon::$db->executequery('COMMIT');
    }

    //Other methods
    /**
     * Used by fiat to mark invoice payment transactions
     * @param unknown_type $jehdr_code
     */
    function record_fiat_payment_trasaction($jehdr_code, $invo_idlist) {
        //edgard
		$sql = 'INSERT INTO ' . $this->inpyname . ' (INVOICECODE, JEHDR_CODE, CDATE, MDATE, CREATEDBY, MODIFIEDBY) SELECT INVO.IDCODE INVOICECODE, JEHD.IDCODE JEHDR_CODE, ' . singleQuote($this->now) . ' CDATE, ' . singleQuote($this->now) . ' MDATE, ' . singleQuote($this->username) . ' CREATEDBY, ' . singleQuote($this->username) . ' MODIFIEDBY FROM ' . $this->invoname . ' INVO, ' . $this->jehdname . ' JEHD WHERE JEHD.IDCODE = ' . singleQuote($jehdr_code) . ' AND INVO.ID IN (' . toString($invo_idlist) . ') AND NOT EXISTS(SELECT INPY.ID FROM ' . $this->inpyname . ' INPY WHERE INPY.INVOICECODE = INVO.IDCODE AND INPY.JEHDR_CODE = JEHD.IDCODE)';
        ClxCommon::$db->executeQuery($sql);
        //This will be deprecated. Display just the last
        $sql = 'UPDATE ' . $this->invoname . ' SET PAY_JEHDR_CODE = ' . singleQuote($jehdr_code) . ' WHERE ID IN (' . toString($invo_idlist) . ')';
        ClxCommon::$db->executeQuery($sql);
    }

    /**
     * Builds invoice from temporary table. Used by fiac and glpf
     * @param unknown_type $batch_id
     * @param unknown_type $gl_type
     * @param unknown_type $auth_status
     * @param unknown_type $approve
     */
    function buildInvoceFromInvt($batch_id, $gl_type = '', $auth_status = 'AP', $approve = false) {
        if ($approve === true) {
            if (!class_exists('Jehd'))
                includeCodeLib('JEHD');
            $jehd = new Jehd();
        }

        if (empty($auth_status)) {
            $auth_status = 'PEND';
        }
        //Item2 se usa en comisiones de adm pero no en otras facturas que solo usan item
        //Por eso copiar el valor si no esta definido
        $sql = 'UPDATE ' . $this->invtname . ' SET TGT_ITEM2_CODE = ITEM_CODE WHERE TGT_ITEM2_CODE IS NULL AND BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);

        //Setting due date
        $sql = 'UPDATE ' . $this->invtname . ' INVT, GL_PARAMETERS_TBL GLCP SET INVT.DUE_DATE = IFNULL((CASE GLCP.INVO_DEFDUE_FREQ WHEN ' . singleQuote('Y') . ' THEN ADDDATE(INVT.INVOICEDATE, INTERVAL  GLCP.INVO_DEFDUE_PER YEAR) WHEN ' . singleQuote('M') . ' THEN ADDDATE(INVT.INVOICEDATE, INTERVAL  GLCP.INVO_DEFDUE_PER MONTH) WHEN ' . singleQuote('D') . ' THEN ADDDATE(INVT.INVOICEDATE, INTERVAL  GLCP.INVO_DEFDUE_PER DAY) ELSE ADDDATE(INVT.INVOICEDATE, INTERVAL 1 DAY) END),INVT.DUE_DATE) WHERE INVT.COMP_CODE = GLCP.COMP_CODE AND INVT.BATCH_ID = ' . singleQuote($batch_id);
        ClxCommon::$db->executeQuery($sql);

        //Creating Invoices
        $sql = 'SELECT ' . singleQuote('AUTO') . ' IDCODE, MAX(IDNAME) IDNAME, VENDOR_CODE ACCOUNTCODE, MAX(INVOICEDATE) INVOICEDATE, MAX(DUE_DATE) DUE_DATE, CURRENCY_CODE, SUM(INVOICE_AMT) INVOICE_AMT, MAX(INVO_STAT) INVO_STAT, COMP_CODE, CHART_FIELD01, CHART_FIELD02, ITEM_CODE AR_ITEM_CODE, GL01_CODE GLACCOUNTCODE, MAX(CDATE) CDATE, MAX(CREATEDBY) CREATEDBY, MAX(CDATE) MDATE, MAX(CREATEDBY) MODIFIEDBY, RESTRICTED, FROM_CONTRACT_CODE, COMMISSION_CODE, BATCH_ID, EXT_REF_NO, GLPF_ID FROM ' . $this->invtname . ' WHERE BATCH_ID = ' . singleQuote($batch_id) . ' ' . (($gl_type <> '') ? ' AND GL_TYPE = ' . singleQuote($gl_type) : ' ') . ' GROUP BY VENDOR_CODE, CURRENCY_CODE, COMP_CODE, CHART_FIELD01, CHART_FIELD02, ITEM_CODE, GL01_CODE, FROM_CONTRACT_CODE, COMMISSION_CODE, RESTRICTED, BATCH_ID, EXT_REF_NO, GLPF_ID';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $r['CLX_AUTH_STATUS'] = $auth_status;
            //Building Account Payables Apin bill
            //$r['DUE_DATE'] = adodb_next_day($r['DUE_DATE']);
            $this->build_record($r);
            ClxCommon::$db->executeQuery('DELETE FROM ' . $this->invlname . ' WHERE INVOICECODE = ' . singleQuote($r['IDCODE']));
			$sql = 'INSERT INTO ' . $this->invlname . ' (INVOICECODE, SEQNUM, DESCRIPTION, QUANTITY, PRICE, LINE_TOTAL, ITEM_CODE, GLACCOUNTCODE, CHART_FIELD03, CHART_FIELD04) SELECT ' . singleQuote($r['IDCODE']) . ' INVOICECODE, (@rownum:=@rownum+1) SEQNUM, CONCAT(CONCAT(IDNAME,' . singleQuote('-') . '), EXT_REF_NO) DESCRIPTION, 1 QUANTITY, (INVOICE_AMT) PRICE, (INVOICE_AMT) LINE_TOTAL, TGT_ITEM2_CODE ITEM_CODE, GL02_CODE GLACCOUNTCODE, CHART_FIELD03, CHART_FIELD04 FROM ' . $this->invtname . ', (SELECT @rownum:=0) r WHERE GL_TYPE = ' . singleQuote('AS') . ' AND ITEM_CODE = ' . singleQuote($r['AR_ITEM_CODE']) . ' AND GL01_CODE = ' . singleQuote($r['GLACCOUNTCODE']) . ' AND VENDOR_CODE = ' . singleQuote($r['ACCOUNTCODE']) . ' AND CURRENCY_CODE = ' . singleQuote($r['CURRENCY_CODE']) . ' AND COMP_CODE = ' . singleQuote($r['COMP_CODE']) . ' AND CHART_FIELD01 = ' . singleQuote($r['CHART_FIELD01']) . ' AND CHART_FIELD02 = ' . singleQuote($r['CHART_FIELD02']);
            if (!empty($r['FROM_CONTRACT_CODE'])) {
                $sql .=' AND FROM_CONTRACT_CODE = ' . singleQuote($r['FROM_CONTRACT_CODE']);
            }
            if (!empty($r['COMMISSION_CODE'])) {
                $sql .=' AND COMMISSION_CODE = ' . singleQuote($r['COMMISSION_CODE']);
            }
            if (!empty($r['EXT_REF_NO'])) {
                $sql .=' AND EXT_REF_NO = ' . singleQuote($r['EXT_REF_NO']);
            }
            if (!empty($r['GLPF_ID'])) {
                $sql .=' AND GLPF_ID = ' . singleQuote($r['GLPF_ID']);
            }
            ClxCommon::$db->executeQuery($sql);
            if ($r['RESTRICTED'] == CLX_NUM_ZERO) {
                $jehdr_code = $this->buildAccounting($r['IDCODE']);
                $sql = 'UPDATE ' . $this->invoname . ' SET JEHDR_CODE = ' . singleQuote($jehdr_code) . ' WHERE IDCODE = ' . singleQuote($r['IDCODE']);
                ClxCommon::$db->executeQuery($sql);
            }
            if ($auth_status === 'PEND' && $approve) {
                if ($jehd->jehd_approve_by_code($jehdr_code)) {
                    $sql = 'UPDATE ' . $this->invoname . ' SET CLX_AUTH_STATUS = ' . singleQuote('AP') . ' WHERE IDCODE = ' . singleQuote($r['IDCODE']);
                    ClxCommon::$db->executeQuery($sql);
                }
            }
        }
    }

    /**
     * Sets invoice status post authorization of journal entries
     * @param string $jehd_code
     */
    function post_jehd_approve($jehd_code) {
        //Marcar autorizacion como completada
        $sql = 'UPDATE CLX_AC_AUTHORIZATIONS AUTH, ' . $this->invoname . ' INVO SET AUTH.AUTH_STATUS = ' . singleQuote('AP') . ' WHERE AUTH.TABLECODE = ' . singleQuote('INVO') . ' AND AUTH.REC_ID = INVO.ID AND AUTH.AUTH_STATUS in (' . singleQuoteArray(array('PEND', 'PEAP')). ') ' . ' AND INVO.JEHDR_CODE = ' . singleQuote($jehd_code) ;
        ClxCommon::$db->executeQuery($sql);
        //Metodo se alimenta con codigo de asiento al aprobar. Una vez aprobado cambia el status
        $sql = 'SELECT JEHD.REV_JEHDR_CODE FROM ' . $this->jehdname . ' JEHD WHERE JEHD.IDCODE = ' . singleQuote($jehd_code) . ' AND EXISTS (SELECT INVO.ID FROM ' . $this->invoname . ' INVO WHERE INVO.JEHDR_CODE = JEHD.REV_JEHDR_CODE)';
        $rev_jehdr_code = ClxCommon::$db->getOne($sql);
        if (!empty($rev_jehdr_code)) {
            // setting void status
            $sql = 'UPDATE ' . $this->invoname . ' SET CLX_AUTH_STATUS = ' . singleQuote('AP') . ', INVO_STAT = ' . singleQuote('05') . ' WHERE JEHDR_CODE = ' . singleQuote($rev_jehdr_code);
            ClxCommon::$db->executeQuery($sql);
            return;
        }
        //UPDATE AUTORIZATION STATUS
        $sql = 'UPDATE ' . $this->invoname . ' SET CLX_AUTH_STATUS = ' . singleQuote('AP') . ' WHERE JEHDR_CODE = ' . singleQuote($jehd_code) . ' AND CLX_AUTH_STATUS IN (' . singleQuoteArray(array('PEND', 'PEAP')) . ')';
        ClxCommon::$db->executeQuery($sql);

        $rev_jehdr_code = ClxCommon::$db->getField($this->jehdname, 'REV_JEHDR_CODE', 'IDCODE = ' . singleQuote($jehd_code));

        $sql = 'SELECT INVO.IDCODE, IFNULL((INVO.INVOICE_AMT-(IF(INVO.OPENING_BAL<>0, INVO.INVOICE_AMT-INVO.OPENING_BAL, 0)+ IFNULL((SELECT SUM(INPY.PAID_AMT) FIAT_TRANS_AMT FROM BILL_INVPYMT_TRANS INPY, GL_JOURNAL_HDR JEHDX WHERE INPY.INVOICECODE = INVO.IDCODE AND JEHDX.IDCODE = INPY.JEHDR_CODE AND JEHDX.JE_STATUS = ' . singleQuote('AP') . ' AND JEHDX.REVERSED = 0),0))),0) OPEN_BALANCE FROM ' . $this->invoname . ' INVO WHERE INVO.IDCODE IN (SELECT DISTINCT INPY2.INVOICECODE FROM ' . $this->inpyname . ' INPY2 WHERE INPY2.JEHDR_CODE = ' . singleQuote(((!empty($rev_jehdr_code)) ? $rev_jehdr_code : $jehd_code)) . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $status = ($r['OPEN_BALANCE'] == 0) ? "02" : "01";
            //Paid status
            $sql = 'UPDATE ' . $this->invoname . ' SET INVO_STAT = ' . singleQuote($status) . ' WHERE IDCODE = ' . singleQuote($r['IDCODE']) . ' AND INVO_STAT IN (' . singleQuote('01') . ',' . singleQuote('02') . ')';
            ClxCommon::$db->executeQuery($sql);
            //Si aplica genera la comision en el contrato relacionado
            if ($status === '02') {
                $this->pay_related_commision($jehd_code);
            }
        }
    }

    /**
     * Generates transation for dependant contract
     * @param string $jehdr_code
     */
    function pay_related_commision($jehd_code) {
        $sql = 'SELECT COUNT(FIAC.ID) FROM ' . $this->invoname . ' INVO, ' . $this->fiacname . ' FIAC, ' . $this->inpyname . ' INPY WHERE INPY.JEHDR_CODE = ' . singleQuote($jehd_code) . ' AND INPY.INVOICECODE = INVO.IDCODE AND FIAC.IDCODE = INVO.COMMISSION_CODE';
        if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
            $this->pay_related_commision_fiac($jehd_code);
        }
        $sql = 'SELECT COUNT(GLPF.ID) FROM ' . $this->invoname . ' INVO, ' . $this->glpfname . ' GLPF, ' . $this->inpyname . ' INPY WHERE INPY.JEHDR_CODE = ' . singleQuote($jehd_code) . ' AND INPY.INVOICECODE = INVO.IDCODE AND GLPF.ID = INVO.GLPF_ID';
        if (ClxCommon::$db->getOne($sql) > CLX_NUM_ZERO) {
            $this->pay_related_commision_glpf($jehd_code);
        }
    }

    /**
     * Generates transation for dependant contract
     * @param string $jehdr_code
     */
    private function pay_related_commision_fiac($jehd_code) {
        // Load temporary table - Req on mysql
        $DBTB = &getTool('DBTB');
        $DBTB->buildTemporaryTable('FTMP');
        ClxCommon::$db->deleteRecords($this->ftmpname, 'BATCH_ID = ' . singleQuote($this->batch_id));
        //Si es una factura de la administradora con origen en una comision al marcar como pagada
        //es necesario generar la transaccion de pago en el contrato de fideicomiso para completar el ciclo
        //1.Seleccionar facturas pagadas por asiento que tengan contrato relacionado
        /* Nota se buscan saldos de transacciones de pago por lo que dr-cr es <0 si es activo */
        // AND INVO.INVO_STAT = '01' se contemplan solo facturas que esten pendientes de pago
        //Casos que vienen por comision
        $sql = 'INSERT INTO ' . $this->ftmpname . ' (IDNAME, EFFTDATE, TRANSTBL_CODE, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, LGGROUP_CODE, ITEM_REF_NO, COMP_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, BANKACCOUNT_CODE, CALC_AMT_01, CALC_AMT_02, CALC_AMT_03, DISBURSEMENT_TYPE, BENEFICIARY_NAME, BRANCH_PRN, BATCH_ID, REC_STATUS, REC_ID) SELECT FIRT.IDNAME, GLCP.OPERATION_DATE EFFTDATE, FIRT.PAY_TX_CODE TRANSTBL_CODE, FIAT.CURRENCY_CODE, FIAT.EXCHANGE_RT, FIAT.CUR_OPERATOR, GLCP.DEF_LGGROUP_CODE LGGROUP_CODE, FIAC.IDCODE ITEM_REF_NO, FIRT.COMP_CODE, FIAC.CONTRACT_CODE CHART_FIELD01, INVO.ACCOUNTCODE CHART_FIELD02, null CHART_FIELD03, null CHART_FIELD04, FIAC.FIDU_BANKACT_CODE BANKACCOUNT_CODE, INVO.INVOICE_AMT CALC_AMT_01, FIAC.APPROVE_PAYMENT CALC_AMT_02, (SELECT IFNULL(SUM(INVL.LINE_TOTAL),0) FROM ' . $this->invlname . ' INVL, ' . $this->jeitname . ' JEIT WHERE INVL.INVOICECODE = INVO.IDCODE AND JEIT.TAX_TYPE <> ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND JEIT.IDCODE = INVL.ITEM_CODE AND JEIT.CLX_EFFTDATE = (SELECT MAX(JEITX.CLX_EFFTDATE) FROM GL_ITEM_TBL JEITX WHERE JEITX.IDCODE = JEIT.IDCODE AND JEITX.CLX_EFFTDATE<=' . singleQuote($this->now) . ')) CALC_AMT_03, FIAC.ADM_DISMNT_TYPE DISBURSEMENT_TYPE, FIAC.BENEFICIARY_NAME, FIAC.BRANCH_PRN, ' . singleQuote($this->batch_id) . ' BATCH_ID, ' . singleQuote('RUN') . ' REC_STATUS, INPY.ID FROM ' . $this->glcpname . ' GLCP, ' . $this->invoname . ' INVO, ' . $this->fiacname . ' FIAC, ' . $this->firtname . ' FIRT, ' . $this->jehdname . ' JEHD, ' . $this->fiatname . ' FIAT, ' . $this->inpyname . ' INPY WHERE INVO.PAY_JEHDR_CODE = ' . singleQuote($jehd_code) . ' AND FIAT.IDCODE = JEHD.TRANS_CODE AND GLCP.COMP_CODE = FIRT.COMP_CODE AND JEHD.IDCODE = INPY.JEHDR_CODE AND INVO.IDCODE = INPY.INVOICECODE AND FIAC.IDCODE = INVO.COMMISSION_CODE AND FIAC.FIDU_RATETBLCODE = FIRT.IDCODE AND FIRT.CLX_EFFTDATE=(SELECT MAX(X.CLX_EFFTDATE) CLX_EFFTDATE FROM ' . $this->firtname . ' X WHERE X.IDCODE=FIRT.IDCODE AND X.CLX_EFFTDATE<=INVO.INVOICEDATE)';
        ClxCommon::$db->executeQuery($sql);
        if (!class_exists('Fiac')) {
            includeCodeLib('FIAC');
        }
        $fiac = new Fiac();
        $fiac->build_invoice_pay_fiat_from_ftmp($this->batch_id, 'FIRTADMPAY');
        unset($fiac);
    }

    /**
     * Generates transation for dependant contract credit
     * @param string $jehdr_code
     */
    private function pay_related_commision_glpf($jehd_code) {
        // Load temporary table - Req on mysql
        $DBTB = &getTool('DBTB');
        $DBTB->buildTemporaryTable('FTMP');
        ClxCommon::$db->deleteRecords($this->ftmpname, 'BATCH_ID = ' . singleQuote($this->batch_id));
        //Si es una factura de la administradora con origen en una comision al marcar como pagada
        //es necesario generar la transaccion de pago en el contrato de fideicomiso para completar el ciclo
        //1.Seleccionar facturas pagadas por asiento que tengan contrato relacionado
        /* Nota se buscan saldos de transacciones de pago por lo que dr-cr es <0 si es activo */
        // AND INVO.INVO_STAT = '01' se contemplan solo facturas que esten pendientes de pago
        //Casos que vienen por comision
        $sql = 'INSERT INTO ' . $this->ftmpname . '(IDNAME, EFFTDATE, TRANSTBL_CODE, CURRENCY_CODE, EXCHANGE_RT, CUR_OPERATOR, LGGROUP_CODE, ITEM_REF_NO, COMP_CODE, CHART_FIELD01, CHART_FIELD02, CHART_FIELD03, CHART_FIELD04, BANKACCOUNT_CODE, CALC_AMT_01, CALC_AMT_02, CALC_AMT_03, DISBURSEMENT_TYPE, BENEFICIARY_NAME, BENEFICIARY_CODE, BRANCH_PRN, BATCH_ID, REC_STATUS, GLPF_ID, REC_ID) SELECT GLPF.IDNAME, GLCP.OPERATION_DATE EFFTDATE, GLPF.PAY_TX_CODE TRANSTBL_CODE, FIAT.CURRENCY_CODE, FIAT.EXCHANGE_RT, FIAT.CUR_OPERATOR, GLCP.DEF_LGGROUP_CODE LGGROUP_CODE, INVO.EXT_REF_NO ITEM_REF_NO, FICO.COMP_CODE, INVO.FROM_CONTRACT_CODE CHART_FIELD01, INVO.ACCOUNTCODE CHART_FIELD02, null CHART_FIELD03, null CHART_FIELD04, null BANKACCOUNT_CODE, INVO.INVOICE_AMT CALC_AMT_01, GLPF.APPROVE_PAYMENT CALC_AMT_02, (SELECT IFNULL(SUM(INVL.LINE_TOTAL),0) FROM ' . $this->invlname . ' INVL, ' . $this->jeitname . ' JEIT WHERE INVL.INVOICECODE = INVO.IDCODE AND JEIT.TAX_TYPE <> ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ' AND JEIT.IDCODE = INVL.ITEM_CODE AND JEIT.CLX_EFFTDATE = (SELECT MAX(JEITX.CLX_EFFTDATE) FROM GL_ITEM_TBL JEITX WHERE JEITX.IDCODE = JEIT.IDCODE AND JEITX.CLX_EFFTDATE<=' . singleQuote($this->now) . ')) CALC_AMT_03, FIAT.DISBURSEMENT_TYPE, FIAT.BENEFICIARY_NAME, FIAT.BENEFICIARY_CODE, FIAT.BRANCH_PRN, ' . singleQuote($this->batch_id) . ' BATCH_ID, ' . singleQuote('RUN') . ' REC_STATUS, GLPF.ID, INPY.ID FROM ' . $this->ficoname . ' FICO, ' . $this->glcpname . ' GLCP, ' . $this->invoname . ' INVO, ' . $this->glpfname . ' GLPF, ' . $this->jehdname . ' JEHD, ' . $this->fiatname . ' FIAT, ' . $this->inpyname . ' INPY WHERE INPY.JEHDR_CODE = ' . singleQuote($jehd_code) . ' AND INPY.INVOICECODE = INVO.IDCODE AND INVO.FROM_CONTRACT_CODE = FICO.IDCODE AND FIAT.IDCODE = JEHD.TRANS_CODE AND GLCP.COMP_CODE = FICO.COMP_CODE AND JEHD.IDCODE = INVO.PAY_JEHDR_CODE AND GLPF.ID = INVO.GLPF_ID';
        ClxCommon::$db->executeQuery($sql);
        //Actualizando participante principal del contrato
        $sql = 'UPDATE ' . $this->ftmpname . ' FTMP, ' . $this->fipaname . ' FIPA SET FTMP.BANKACCOUNT_CODE = FIPA.DEF_BANKACC_CODE, FTMP.CHART_FIELD02 = FIPA.ACCOUNTCODE WHERE FIPA.CONTRACT_CODE = FTMP.CHART_FIELD01 AND FIPA.ISPRIMARY = 1 AND FTMP.BATCH_ID = ' . singleQuote($this->batch_id);
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->ftmpname . ' FTMP, ' . $this->filoname . ' FILO SET FTMP.BANKACCOUNT_CODE = FILO.PAY_BANKACT_NO WHERE FILO.IDCODE = FTMP.ITEM_REF_NO AND FTMP.BATCH_ID = ' . singleQuote($this->batch_id) . ' AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE) FROM ' . $this->filoname . ' FILOX WHERE FILOX.IDCODE = FILO.IDCODE)';
        ClxCommon::$db->executeQuery($sql);
        if (!class_exists('Glpf')) {
            includeCodeLib('GLPF');
        }
        $glpf = new Glpf();
        $glpf->build_invoice_pay_fiat_from_ftmp($this->batch_id, 'GLPFADMPAY');
        unset($glpf);
    }

    /**
     * Method to reset invoce to pending
     */
    function invoice_reset() {
        $idlist = toString(getIdlist());
        ClxCommon::$db->updateRecord($this->invoname, array('CLX_AUTH_STATUS' => 'PEND', 'INVO_STAT' => '01'), 'ID IN (' . $idlist . ')');
        $sql = 'UPDATE ' . $this->fiatname . ' FIAT SET FIAT.CLX_AUTH_STATUS = ' . singleQuote('PEND') . ', FIAT.TRANS_STATUS = ' . singleQuote('PEND') . ' WHERE FIAT.TRANS_STATUS <> ' . singleQuote('RE') . ' AND FIAT.IDCODE IN (SELECT JEHD.TRANS_CODE FROM ' . $this->jehdname . ' JEHD, $this->invoname INVO WHERE (JEHD.IDCODE IN (INVO.JEHDR_CODE, INVO.PAY_JEHDR_CODE) OR EXISTS (SELECT INPY.ID FROM ' . $this->inpyname . ' INPY WHERE INPY.INVOICECODE = INVO.IDCODE)) AND INVO.ID IN (' . $idlist . ') AND JEHD.TRANS_CODE IS NOT null)';
        ClxCommon::$db->executeQuery($sql);
        $sql = 'UPDATE ' . $this->jehdname . ' JEHD SET JEHD.CLX_AUTH_STATUS = ' . singleQuote('PEND') . ', JEHD.JE_STATUS = ' . singleQuote('PEND') . ' WHERE JEHD.JE_STATUS <> ' . singleQuote('RE') . ' AND EXISTS (SELECT INVO.ID FROM ' . $this->invoname . ' INVO WHERE (INVO.JEHDR_CODE = JEHD.IDCODE OR INVO.PAY_JEHDR_CODE = JEHD.IDCODE OR EXISTS (SELECT INPY.ID FROM ' . $this->inpyname . ' INPY WHERE INPY.INVOICECODE = INVO.IDCODE)) AND INVO.ID IN (' . $idlist . '))';
        ClxCommon::$db->executeQuery($sql);
        //Recalculation ledgers
        if (!class_exists('Leba'))
            includeCodeLib('LEBA');
        if (!class_exists('Jebl'))
            includeCodeLib('JEBL');
        $a = new Leba();
        $b = new Jebl();
        $sql = 'SELECT COMP_CODE, MIN(INVOICEDATE) INVOICEDATE FROM ' . $this->invoname . ' WHERE ID IN (' . $idlist . ') GROUP BY COMP_CODE';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $a->leba_rebuild($r['COMP_CODE']);
            $b->jebl_build($r['COMP_CODE'], $r['INVOICEDATE']);
        }
        unset($a);
    }

    // TRANSACTION REPORTS JASPER OMG
    function print_invoice_omg() {
		$tool = &getTool('ANRP');
		$controls = array();
		$idlist = toString(getIdlist());
		
		$fact = ClxCommon::$db->getFields('BILL_INVOICE', 'IDCODE, TAXRCPT_TYPE, COMP_CODE', 'ID=' . $idlist);
		//pre ($fact);
		
		$controls['nfactura']=$fact['IDCODE'];
        $controls['RTBL_COMP_CODE']=$fact['COMP_CODE'];
        $controls['RTBL_URI_IMAGES']=@ANRP_JASPER_SERVER_URI_IMAGES;
		//pre($controls);
		//exit;
		$controls['view_display']=true;
		if ($fact['TAXRCPT_TYPE']==='B01'){
		    return $tool->buildRunJasperReport('01', 'pdf', 'invo/Detail_Fact_Fiscal', $controls);
		}
		if ($fact['TAXRCPT_TYPE']==='B02'){
		    return $tool->buildRunJasperReport('02', 'pdf', 'invo/Detail_Fact_Consumo', $controls);
		}
		if ($fact['TAXRCPT_TYPE']==='B04'){
		    return $tool->buildRunJasperReport('04', 'pdf', 'invo/Detail_Nota_Credito', $controls);
		}
		if ($fact['TAXRCPT_TYPE']==='B14'){
		    return $tool->buildRunJasperReport('14', 'pdf', 'invo/Detail_Reg_Especiales', $controls);
		}
		if ($fact['TAXRCPT_TYPE']==='B15'){
		    return $tool->buildRunJasperReport('15', 'pdf', 'invo/Detail_Fact_Gubernamental', $controls);
		}
		if ($fact['TAXRCPT_TYPE']!='B01' && $fact['TAXRCPT_TYPE']!='B02' && $fact['TAXRCPT_TYPE']!='B04' && $fact['TAXRCPT_TYPE']!='B14' && $fact['TAXRCPT_TYPE']!='B15'){
			print "Warning: Factura no tiene tipo de Comprobante Fiscal definido";
		}
	}
	
	
	// TRANSACTION REPORTS
    function print_invoice() {
        $this->tabprops = 'BILL_INVOICE_PROPS';
        $this->tfdprops = 'BILL_INVOICE_PROPS_FIELDS_DET';
        $this->tdfprops = 'BILL_INVOICE_PROPS_FIELDS_DET_FD';
        $ibs_print = (companyParameter('EIBS_ENABLE_INVOICE_PRINT')) ? true : false;

        if ($ibs_print === true) {
            // Llamada de la interfase de IBS en caso de
            // impresion de cheques por ibs
            includeCodeLib('EIBS_CHK');
            $a = new ibs_check_socket_interface ();
            // $a->debug = false;
            return $a->printChecks();
        }
        $idlist = getIdlist();
        if (empty($idlist))
            return alert('Not Found');
        $allcompc = array();
        foreach ($idlist as $transid) {
            $this->comp_code = $this->getCompCode($transid);
            $allcompc[$this->comp_code] = $this->getCompCode($transid);
        }
        //pre($allcompc);
        if (count($allcompc) > CLX_NUM_ONE) {
            return warning(dict('GEN_ERR_NO_SAME_CHK_COMPANY'));
        }
        //Prompt format
        if (empty(UserRequest::$get['template'])) {
            return $this->prompt_invoice_template();
        }
        $DBLT = &getTool('DBLT');
        if (!class_exists('PDF_Visibility') && file_exists(kPathToFpdf . 'PDF_Visibility.php')) {
            include_once kPathToWebSite . kPathToFpdf . 'PDF_Visibility.php';
        }

        $chk_props = $this->print_invoice_templates(UserRequest::$get['template']);
        // includeCodeLib('GEN_NO_TEXT');
		ob_clean();
        $pdf = new PDF_Visibility($chk_props['direction'], $chk_props['unit'], array($chk_props['w'], $chk_props['h']));
        $pdf->SetMargins(CLX_NUM_ZERO, CLX_NUM_ZERO, CLX_NUM_ZERO);
        $sql = 'SELECT INVO.COMP_CODE, INVO.CURRENCY_CODE, INVO.ID ID, INVO.IDCODE IDCODE, INVO.IDNAME IDNAME, INVO.JEHDR_CODE, INVO.INVOICEDATE EFFTDATE, INVO.ACCOUNTCODE ACCOUNTCODE, INVO.DEBTOR_FICO_CODE, IFNULL((SELECT IFNULL(ACCO.LEGAL_NAME, ACCO.IDNAME) FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE = INVO.ACCOUNTCODE),' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') BENEFICIARY_NAME, IFNULL((SELECT IFNULL(CONCAT_WS(' . singleQuote(CLX_CHAR_EMPTY_STRING) . ', ACCO.ADDRESS1, ACCO.ADDRESS2),CONCAT_WS(' . singleQuote(CLX_CHAR_EMPTY_STRING) . ',ACCO.ADDRESS1_02, ACCO.ADDRESS2_02)) ADDRESS FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE = INVO.ACCOUNTCODE),' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') ADDRESS, IFNULL((SELECT IFNULL(ACCO.STATE,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') STATE FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE = INVO.ACCOUNTCODE),' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') STATE, IFNULL((SELECT IFNULL(ACCO.COUNTRY,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') STATE FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE = INVO.ACCOUNTCODE),' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') COUNTRY, 0 SUB_TOTAL, 0 ITBMS, INVO.INVOICE_AMT TOTAL, INVO.CHART_FIELD01 CHART_FIELD01, INVO.CHART_FIELD02 CHART_FIELD02, IFNULL((SELECT IFNULL(ACCO.LEGAL_NAME, ACCO.IDNAME) FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE = INVO.CHART_FIELD02),' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') PARTICIPANT, IFNULL((SELECT IFNULL(CONCAT_WS(' . singleQuote(CLX_CHAR_EMPTY_STRING) . ', ACCO.ADDRESS1, ACCO.ADDRESS2),CONCAT_WS(' . singleQuote(CLX_CHAR_EMPTY_STRING) . ',ACCO.ADDRESS1_02, ACCO.ADDRESS2_02)) ADDRESS FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE = INVO.CHART_FIELD02),' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') ADDRESS_PARTICIPANT, IFNULL((SELECT IFNULL(ACCO.STATE,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') STATE FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE = INVO.CHART_FIELD02),' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') STATE_PARTICIPANT, IFNULL((SELECT IFNULL(ACCO.COUNTRY,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') STATE FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE = INVO.CHART_FIELD02),' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') COUNTRY_PARTICIPANT, INVO.CLX_AUTH_STATUS INVO_CLX_AUTH_STATUS, INVO.AR_ITEM_CODE INVO_AR_ITEM_CODE, INVO.AR_AMORT_METHOD INVO_AR_AMORT_METHOD, IFNULL((SELECT IFNULL(ACCO.PHONE, ACCO.HOME_PHONE) FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE = INVO.CHART_FIELD02),' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') PHONE, INVO.MODIFIEDBY MODIFIEDBY, IFNULL((SELECT IFNULL(FICO.CONTRACT_NUMBER,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') CONTRACT_NUMBER FROM FIDU_CONTRACTS FICO WHERE FICO.IDCODE = INVO.IDCODE),' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') CONTRACT_NAME, IFNULL((SELECT IFNULL(FICO.IDNAME,' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') CONTACT FROM FIDU_CONTRACTS FICO WHERE FICO.IDCODE = INVO.IDCODE),' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') CONTACT_NAME, IFNULL((SELECT IFNULL(ACCO.CITY, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE = INVO.CHART_FIELD02),' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') CITI, IFNULL((SELECT IFNULL(ACCO.IDENTIFICATION, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE = INVO.CHART_FIELD02),' . singleQuote(CLX_CHAR_EMPTY_STRING) . ') IDENTIFICATION FROM ' . $this->invoname . ' INVO WHERE INVO.ID IN (' . toString($idlist) . ') AND INVO.CLX_AUTH_STATUS = ' . singleQuote('AP') . ' AND INVO.RESTRICTED = 0 ';
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            if (!empty($r['DEBTOR_FICO_CODE'])) {
                $r['BENEFICIARY_NAME'] = ClxCommon::$db->getField($this->ficoname, 'CONTRACT_NUMBER', 'IDCODE = ' . singleQuote($r['DEBTOR_FICO_CODE'])) . ' ' . $r['BENEFICIARY_NAME'];
            }
            $r['CONTACT_NAME'] = 'CONTACTO: ' . trim($r['CONTACT_NAME']);
            $r['PHONE'] = 'TELEFONO: ' . trim($r['PHONE']);
            $r['CITI'] = $DBLT->getListItem('CITI', $r['CITI'], CLX_NUM_7);
            $r['STATE'] = $DBLT->getListItem('STAT', $r['STATE'], CLX_NUM_7);
            $r['COUNTRY'] = $DBLT->getListItem('COUN', $r['COUNTRY'], CLX_NUM_7);
            $r['ADDRESS_FULL'] = $r['ADDRESS'] . CLX_CHAR_NL . $r['STATE'] . CLX_CHAR_NL . $r['COUNTRY'];
            $r['STATE_PARTICIPANT'] = $DBLT->getListItem('CITI', $r['STATE_PARTICIPANT'], CLX_NUM_7);
            $r['COUNTRY_PARTICIPANT'] = $DBLT->getListItem('COUN', $r['COUNTRY_PARTICIPANT'], CLX_NUM_7);
            $r['ADDRESS_PARTICIPANT'] = $r['ADDRESS_PARTICIPANT'] . CLX_CHAR_NL . $r['STATE_PARTICIPANT'] . CLX_CHAR_NL . $r['COUNTRY_PARTICIPANT'];
            $r['DETAIL'] = array();
            $r ['EFFTDATE_TEXT'] = xFormat::textdate($r ['EFFTDATE'], 'Y-m-d');
            $r ['MODIFIEDBY'] = $_SESSION ['user_record'] ['username'];
            if ($r ['BENEFICIARY_NAME'] === '') {
                $r ['BENEFICIARY_NAME'] = $r ['PARTICIPANT_NAME'];
            }
            foreach ($r as $key => $val) {
                if (!is_array($val)) {
                    $r [$key] = uppercase($val);
                }
            }
            //Journal Details
            $sql = 'SELECT INVL.DESCRIPTION GL_NAME, INVL.PRICE TRANS_AMT, INVL.TAX_AMT, INVL.LINE_TOTAL LINE_TOTAL, INVL.ITEM_CODE ITEM_CODE, INVL.GLACCOUNTCODE GLACCOUNTCODE, GLAC.IS_FEE_TAX_ACC IS_TAG FROM ' . $this->invlname . ' INVL, ' . $this->glacname . ' GLAC WHERE INVL.GLACCOUNTCODE = GLAC.IDCODE AND INVL.INVOICECODE = ' . singleQuote($r['IDCODE']);
            $rs2 = ClxCommon::$db->executeQuery($sql);
            while ($r2 = ClxCommon::$db->getNextRecord($rs2, ASSOCIATIVE)) {
                if (intval($r2['IS_TAG']) === CLX_NUM_ZERO) {
                    $r['SUB_TOTAL'] = bcadd($r['SUB_TOTAL'], $r2['LINE_TOTAL']);
                    $r['ITBMS'] = bcadd($r['ITBMS'], $r2['TAX_AMT']);
                    $r['DETAIL'][] = $r2;
                } else {
                    $r['ITBMS'] = bcadd($r['ITBMS'], $r2['TRANS_AMT']);
                }
            }

            $pdf->AddPage();
            $pdf->SetFont($chk_props['font'], '', $chk_props['fontsize']);
            $pdf->SetVisibility('screen');
            $pdf->SetXY(CLX_NUM_ZERO, CLX_NUM_ZERO);
            $pdf->SetVisibility('all');
            $monto = array();
            foreach ($chk_props['fields'] as $k => $v) {
                if (empty($v['enabled']))
                    continue;
                if (array_key_exists('fields', $v)) {
                    //Description
                    $y_increment = CLX_INIT_ZERO;
                    $totals = array();
                    $deci = array();

                    foreach ($r [$k] as $item => $row) {
                        foreach ($v['fields'] as $k2 => $v2) {
                            if (!empty($v2['has_total'])) {
                                if (!array_key_exists($k2, $totals)) {
                                    $totals[$k2] = array($row[$k2], 'x' => $v2['x_total'], 'y' => $v2['y_total']);
                                } else {
                                    $totals[$k2][CLX_NUM_ZERO] += $row[$k2];
                                }
                            }
                            $c = CLX_INIT_ZERO;
                            if (!empty($v2['has_decimal'])) {
                                (strpos($row[$k2], '.') !== ' ') ? $c++ : $c = CLX_INIT_ZERO;
                                $tmp_amt = $row[$k2];
                                switch (getCurrentLanguage()) {
                                    case 'en': case 'es_PA':
                                        $row[$k2] = clx_format_currency($row[$k2], CLX_NUM_TWO);
                                        break;
                                    default:
                                        $row[$k2] = clx_format_currency($row[$k2], CLX_NUM_TWO, ',', '.');
                                        break;
                                }
                                $row[$k2] = substr($row[$k2], CLX_NUM_ZERO, mb_strlen($row[$k2]) - CLX_NUM_THREE);
                                switch (getCurrentLanguage()) {
                                    case 'en': case 'es_PA':
                                        $monto[] = clx_format_currency($tmp_amt, CLX_NUM_TWO);
                                        break;
                                    default:
                                        $monto[] = clx_format_currency($tmp_amt, CLX_NUM_TWO, ',', '.');
                                        break;
                                }
                                (empty($v2['decimal_w']) || $v2['decimal_w'] == CLX_NUM_ZERO) ? $v2['decimal_w'] = $v2['w'] : '';
                                (empty($v2['decimal_h']) || $v2['decimal_h'] == CLX_NUM_ZERO) ? $v2['decimal_h'] = $v2['h'] : '';
                                $deci[$k2] = array('x' => $v2['x_decimal'], 'y' => $v2['y_decimal'], 'w' => $v2['decimal_w'], 'h' => $v2['decimal_h']);
                                (empty($v2['decimal_w']) || $v2['decimal_w'] == CLX_NUM_ZERO) ? $v2['decimal_w'] = $v2['w'] : '';
                                (empty($v2['decimal_h']) || $v2['decimal_h'] == CLX_NUM_ZERO) ? $v2['decimal_h'] = $v2['h'] : '';
                                $pdf->SetXY($v2['x'], ($v2['y'] + $y_increment));
                                $pdf->Cell($v2['w'], $v2['h'], decode_string($row[$k2]), CLX_NUM_ZERO, CLX_NUM_ZERO, $v2[CLX_PROP_ALIGN]);
                            } else {
                                $pdf->SetXY($v2['x'], ($v2['y'] + $y_increment));
                                $pdf->MultiCell($v2['w'], $v2['h'], decode_string($row[$k2]), CLX_NUM_ZERO, $v2[CLX_PROP_ALIGN]);
                            }
                        }
                        $y_increment += $v['row_separation'];
                    }
                    if (!empty($totals)) {
                        foreach ($totals as $k2 => $v2) {
                            switch (getCurrentLanguage()) {
                                case 'en': case 'es_PA':
                                    $v2[CLX_NUM_ZERO] = clx_format_currency($v2[CLX_NUM_ZERO], CLX_NUM_TWO);
                                    break;
                                default:
                                    $v2[CLX_NUM_ZERO] = clx_format_currency($v2[CLX_NUM_ZERO], CLX_NUM_TWO, ',', '.');
                                    break;
                            }
                            $pdf->Text($v2['x'], $v2['y'], $v2[CLX_NUM_ZERO]);
                        }
                    }
                    $i = CLX_INIT_ZERO;
                    foreach ($monto as $value) {
                        $pdf->SetXY($deci[$k2]['x'], $deci[$k2]['y'] + $i);
                        $pdf->Cell($deci[$k2]['w'], $deci[$k2]['h'], substr($value, strlen($value) - CLX_NUM_TWO), CLX_NUM_ZERO, CLX_NUM_ZERO, $v2[CLX_PROP_ALIGN]);
                        $i = $i + CLX_NUM_0_PT_4;
                    }
                } else {
                    $r [$k] = decode_string($r[$k]);
                    if (!empty($v['enclose'])) {
                        $r [$k] = $v['enclose'] . $r [$k] . $v['enclose'];
                    }
                    //Normal FIeld
                    if (!empty($v['show_location'])) {
                        $r [$k] = $r ['LOCATION'] . ' ' . $r [$k];
                    }
                    if (!empty($v['wordwrap'])) {
                        $r [$k] = wordwrap($r[$k], $v['wordwrap']);
                    }
                    if (!empty($v['has_decimal'])) {
                        $d = explode('.', $r[$k]);
                        (empty($v['decimal_w']) || $v['decimal_w'] == CLX_NUM_ZERO) ? $v['decimal_w'] = $v['w'] : '';
                        (empty($v['decimal_h']) || $v['decimal_h'] == CLX_NUM_ZERO) ? $v['decimal_h'] = $v['h'] : '';
                        $deci[$k] = array((!empty($d[CLX_NUM_ONE])) ? substr($d[CLX_NUM_ONE], CLX_NUM_ZERO, CLX_NUM_TWO) : CLX_NUM_ZERO, 'x' => $v['x_decimal'], 'y' => $v['y_decimal'], 'w' => $v['decimal_w'], 'h' => $v['decimal_h']);
                        //$deci[$k][CLX_NUM_ZERO] = clx_format_currency ( $deci[$k][CLX_NUM_ZERO], 0 );
                        switch (getCurrentLanguage()) {
                            case 'en': case 'es_PA':
                                $r[$k] = clx_format_currency($d[CLX_NUM_ZERO], CLX_NUM_ZERO);
                                break;
                            default:
                                $r[$k] = clx_format_currency($d[CLX_NUM_ZERO], CLX_NUM_ZERO, ',', '.');
                                break;
                        }
                        $pdf->SetXY($v['x'], $v['y']);
                        $pdf->Cell($v['w'], $v['h'], decode_string($r [$k]), CLX_NUM_ZERO, CLX_NUM_ZERO, $v[CLX_PROP_ALIGN]);
                    } else {
                        if ((empty($v['w']) || $v['w'] == CLX_NUM_ZERO) && (empty($v['h']) || $v['h'] == CLX_NUM_ZERO)) {
                            if (empty($v['wrap_separation'])) {
                                $pdf->Text($v['x'], $v['y'], decode_string($r [$k]));
                            } else {
                                $pdf->SetXY($v['x'], $v['y']);
                                //$pdf->Write ( 5, decode_string( $r [$k]) );
                                if (!array_key_exists('x_total', $v))
                                    $v['x_total'] = 0;
                                if (!array_key_exists('y_total', $v))
                                    $v['y_total'] = 0;
                                $pdf->MultiCell($v['x_total'], $v['y_total'], decode_string($r [$k]), CLX_NUM_ZERO, $v[CLX_PROP_ALIGN]);
                            }
                        } else {
                            $pdf->SetXY($v['x'], $v['y']);
                            $pdf->MultiCell($v['w'], $v['h'], decode_string($r [$k]), CLX_NUM_ZERO, $v[CLX_PROP_ALIGN]);
                        }
                    }
                    if (array_key_exists($k, $deci)) {
                        $pdf->SetXY($deci[$k]['x'], $deci[$k]['y']);
                        $pdf->Cell($deci[$k]['w'], $deci[$k]['h'], $deci[$k][CLX_NUM_ZERO], CLX_NUM_ZERO, CLX_NUM_ZERO, $v[CLX_PROP_ALIGN]);
                    }
                }
            }
        } // end foreach trans_id
        $pdf->Output();
    }

    /**
     * Prompt Invoice Templates
     */
    private function prompt_invoice_template() {
        $props = $this->print_invoice_templates();
        $form = new htmlForm(CLX_PROP_ACTION, 'pop.php', 'method', 'get');
        foreach (UserRequest::$get as $key => $val) {
            $form->addArgument($key, $val);
        }
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $table->addCell(dict('GEN_LBL_SELECT_OPTION'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_NUM_TWO));
        $table->addCell(dict('GEN_LBL_INVOICE_TEMPLATE'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $select = new htmlSelect('template');
        foreach ($props as $key => $val) {
            $select->addItem($val['template_name'], $key, false);
        }
        $table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
        $bs = new htmlSubmit(dict('GEN_LBL_SUBMIT'));
        $b = $bs->source();
        $bs = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
        $b .= $bs->source();
        $table->addCell($b, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_NUM_TWO));
        $form->addContents($table->source());
        return $form->source();
    }

    /**
     * Check Templates
     */
    private function print_invoice_templates($template = '') {
        $props = array();
        $DBLT = &getTool('DBLT');
        $fieldtp = $DBLT->getListAsArray('INPF');
        unset($fieldtp [null]);
        $FILE = getToolObject('DBFT', 'FILE');
        $sql = 'SELECT ID id, WIDTH w, HEIGHT h, IMG_Y img_y, IMG_X img_x, IMG_W img_w, IMG_H img_h, TEMPLATE_NAME template_name, FILE_DIR file, UNIT unit, GUIDANCE_PAPER direction, FONT_SIZE fontsize, FONT_TYPE font FROM ' . $this->tabprops . ' WHERE COMP_CODE = ' . singleQuote($this->comp_code);
        $rs = ClxCommon::$db->executeQuery($sql);
        while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $props[$r[CLX_PROP_ID]] = array(CLX_PROP_ID => $r[CLX_PROP_ID], 'w' => $r['w'], 'h' => $r['h'], 'img_y' => $r['img_y'], 'img_x' => $r['img_x'], 'img_w' => $r['img_w'], 'img_h' => $r['img_h'], 'template_name' => $r['template_name'], 'file' => $r['file'], 'unit' => $r['unit'], 'direction' => $r['direction'], 'fontsize' => $r['fontsize'], 'font' => $r['font'], 'fields' => $r[CLX_PROP_ID]);
        }
        $idd = array();
        foreach ($props as $k => $v) {
            $idd[$k]['fields'] = $props[$k]['fields'];
            $props[$k]['fields'] = array();
            $props[$k]['file'] = $FILE->fileName($props[$k]['file']);
        }
        foreach ($idd as $k => $v) {
            $sql = 'SELECT ID ID, IDFIELD_INV fieldname, ENABLED enabled, POSITION_Y y, POSITION_X x, WIDTH w, HEIGHT h, ENCLOSE enclose, SHOW_LOCATION show_location, WORDWRAP wordwrap, WRAP_SEPARATION wrap_separation, ROW_SEPARATION row_separation, ALIGN align, HAS_TOTAL has_total, Y_TOTAL y_total, X_TOTAL x_total, HAS_DECIMAL has_decimal, Y_DECIMAL y_decimal, X_DECIMAL x_decimal, DECIMAL_W decimal_w, DECIMAL_H decimal_h FROM ' . $this->tfdprops . ' WHERE IDDETAIL = ' . $idd[$k]['fields'];
            $rs = ClxCommon::$db->executeQuery($sql);
            $df = CLX_INIT_ZERO;
            while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                (($r['enabled'] == CLX_NUM_ONE) ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['enabled'] = true : $props[$k]['fields'][$fieldtp[$r['fieldname']]]['enabled'] = false );
                $props[$k]['fields'][$fieldtp[$r['fieldname']]]['y'] = $r['y'];
                $props[$k]['fields'][$fieldtp[$r['fieldname']]]['x'] = $r['x'];
                (($r['w'] !== '') ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['w'] = $r['w'] : '' );
                (($r['h'] !== '') ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['h'] = $r['h'] : '' );
                (($r['enclose'] !== '') ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['enclose'] = $r['enclose'] : '' );
                (($r['show_location'] == CLX_NUM_ONE) ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['show_location'] = true : '' );
                (($r['wordwrap'] != CLX_NUM_ZERO) ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['wordwrap'] = $r['wordwrap'] : '' );
                (($r['wrap_separation'] != CLX_NUM_ZERO) ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['wrap_separation'] = $r['wrap_separation'] : '' );
                (($r['row_separation'] != CLX_NUM_ZERO) ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['row_separation'] = $r['row_separation'] : '' );
                (($r[CLX_PROP_ALIGN] !== '') ? $props[$k]['fields'][$fieldtp[$r['fieldname']]][CLX_PROP_ALIGN] = $r[CLX_PROP_ALIGN] : '' );
                (($r['has_total'] == CLX_NUM_ONE) ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['has_total'] = true : '' );
                (($r['y_total'] != CLX_NUM_ZERO) ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['y_total'] = $r['y_total'] : '' );
                (($r['x_total'] != CLX_NUM_ZERO) ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['x_total'] = $r['x_total'] : '' );
                (($r['has_decimal'] == CLX_NUM_ONE) ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['has_decimal'] = true : '' );
                (($r['y_decimal'] != CLX_NUM_ZERO) ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['y_decimal'] = $r['y_decimal'] : '' );
                (($r['x_decimal'] != CLX_NUM_ZERO) ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['x_decimal'] = $r['x_decimal'] : '' );
                (($r['decimal_w'] != CLX_NUM_ZERO) ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['decimal_w'] = $r['decimal_w'] : '' );
                (($r['decimal_h'] != CLX_NUM_ZERO) ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['decimal_h'] = $r['decimal_h'] : '' );
                if ($fieldtp[$r['fieldname']] === 'DETAIL') {
                    $df = $r['ID'];
                    $props[$k]['fields'][$fieldtp[$r['fieldname']]]['fields'] = array();
                }
            }
            if (array_key_exists('DETAIL', $props[$k]['fields'])) {
                $sql = 'SELECT IDFIELD_INV fieldname, ENABLED enabled, POSITION_Y y, POSITION_X x, WIDTH w, HEIGHT h, ENCLOSE enclose, SHOW_LOCATION show_location, WORDWRAP wordwrap, WRAP_SEPARATION wrap_separation, ROW_SEPARATION row_separation, ALIGN align, HAS_TOTAL has_total, Y_TOTAL y_total, X_TOTAL x_total, HAS_DECIMAL has_decimal, Y_DECIMAL y_decimal, X_DECIMAL x_decimal, DECIMAL_W decimal_w, DECIMAL_H decimal_h FROM ' . $this->tdfprops . ' WHERE IDFIELDDT = ' . $df . ' ';
                $rs = ClxCommon::$db->executeQuery($sql);
                while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
                    (($r['enabled'] == CLX_NUM_ONE) ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['enabled'] = true : $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['enabled'] = false );
                    $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['x'] = $r['x'];
                    $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['y'] = $r['y'];
                    (($r['w'] !== '') ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['w'] = $r['w'] : '' );
                    (($r['h'] !== '') ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['h'] = $r['h'] : '' );
                    (($r['enclose'] !== '') ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['enclose'] = $r['enclose'] : '' );
                    (($r['show_location'] == CLX_NUM_ONE) ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['show_location'] = true : '' );
                    (($r['wordwrap'] != CLX_NUM_ZERO) ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['wordwrap'] = $r['wordwrap'] : '' );
                    (($r['wrap_separation'] != CLX_NUM_ZERO) ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['wrap_separation'] = $r['wrap_separation'] : '' );
                    (($r['row_separation'] != CLX_NUM_ZERO) ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['row_separation'] = $r['row_separation'] : '' );
                    (($r[CLX_PROP_ALIGN] !== '') ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]][CLX_PROP_ALIGN] = $r[CLX_PROP_ALIGN] : '' );
                    (($r['has_total'] == CLX_NUM_ONE) ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['has_total'] = true : '' );
                    (($r['y_total'] != CLX_NUM_ZERO) ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['y_total'] = $r['y_total'] : '' );
                    (($r['x_total'] != CLX_NUM_ZERO) ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['x_total'] = $r['x_total'] : '' );
                    (($r['has_decimal'] == CLX_NUM_ONE) ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['has_decimal'] = true : '' );
                    (($r['y_decimal'] != CLX_NUM_ZERO) ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['y_decimal'] = $r['y_decimal'] : '' );
                    (($r['x_decimal'] != CLX_NUM_ZERO) ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['x_decimal'] = $r['x_decimal'] : '' );
                    (($r['decimal_w'] != CLX_NUM_ZERO) ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['decimal_w'] = $r['decimal_w'] : '' );
                    (($r['decimal_h'] != CLX_NUM_ZERO) ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['decimal_y'] = $r['decimal_h'] : '' );
                }
            }
        }
        if ($template === '') {
            return $props;
        } else {
            return $props[$template];
        }
    }

// end method
    function getCompCode($id) {
        $sql = 'SELECT COMP_CODE FROM ' . $this->invoname . ' INVO WHERE INVO.ID = ' . $id;
        return ClxCommon::$db->getOne($sql);
    }

    /**
     * Verificar si factura esta aprobada
     */
    function getAprovementInv($id) {
        $sql = 'SELECT CLX_AUTH_STATUS FROM ' . $this->invoname . ' INVO WHERE INVO.ID = ' . $id;
        return (ClxCommon::$db->getOne($sql) === 'AP') ? false : true;
    }
	

	    /**
     * función para exportar las ventas a rendir a la DGII
     */
    function invo_export_ventas() {
       
		//pre ($_SESSION);
		$criteria=$_SESSION['paging']['INVO_607_LIST'];
		$comp_code='';
		//verificamos que existe la variable de session qfilter que contiene la compañia seleccionada en el criterio de busqueda
		if (empty($criteria['qfilter']['INVF_COMP_CODE'])){
			addMessage(smsg('MSG-536', '607'));
		}else{
			$comp_code=$criteria['qfilter']['INVF_COMP_CODE']; //obtenemos el codigo de compañía
			
			$ncfinvo = ClxCommon::$db->getFields('BILL_INVOICE_DGIIH', 'TYPE_REPORT, TAXID, PERIOD_NAME, REGISTER_NUMBER', 'COMP_CODE='.singleQuote($comp_code));


			$cab=$ncfinvo['TYPE_REPORT'].'|'.$ncfinvo['TAXID'].'|'.$ncfinvo['PERIOD_NAME'].'|'.$ncfinvo['REGISTER_NUMBER'];
			$cab.=chr(13).chr(10);

			$taxid=$ncfinvo['TAXID'];
			$periodo=$ncfinvo['PERIOD_NAME'];

			
			$sql="SELECT IDENTIFICATION, (CASE WHEN ID_TYPE='RNC' THEN '1' WHEN ID_TYPE='CIV' THEN '2' WHEN ID_TYPE='PAS' THEN '3' WHEN ID_TYPE='NIT' THEN '3' ELSE '0' END) AS ID_TYPE, TAXRCPT_NO, TAXRCPTREL_NO, INCOME_TYPE, INVOICEDATE+0 AS INVOICEDATE, (CASE WHEN RETENTIONDATE='0000-00-00' THEN '' ELSE RETENTIONDATE+0 END) AS RETENTIONDATE, INVOICE_AMT, TAX_AMT, IFNULL(TAX_AMT_TPARTIES,'') AS TAX_AMT_TPARTIES, IFNULL(TAX_AMT_PER,'') AS TAX_AMT_PER,IFNULL(TAX_SR_TPARTIES,'') AS TAX_SR_TPARTIES, IFNULL(TAX_SR,'') AS TAX_SR, IFNULL(TAX_SEL_CONS,'') AS TAX_SEL_CONS, TAX_OTHER, AMT_PROP, CASH_AMOUNT, PAY_CHTRDEP, PAY_CREDCARD, IFNULL(CREDIT_AMT,'') AS CREDIT_AMT, IFNULL(PAY_BONDCERT,'') AS PAY_BONDCERT, IFNULL(PAY_TRANSPER,'') AS PAY_TRANSPER, IFNULL(PAY_OTHER,'')  AS PAY_OTHER FROM BILL_INVOICE_DGII WHERE COMP_CODE = ".singleQuote($comp_code);

			$rs = ClxCommon::$db->executeQuery($sql);

			$cuerpo=$cab;
			while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {                                  
				$cuerpo.=$r['IDENTIFICATION']."|";
				$cuerpo.=$r['ID_TYPE']."|";
				$cuerpo.=$r['TAXRCPT_NO']."|";
				$cuerpo.=$r['TAXRCPTREL_NO']."|"; 
				$cuerpo.=$r['INCOME_TYPE']."|";
				$cuerpo.=$r['INVOICEDATE']."|";
				$cuerpo.=$r['RETENTIONDATE']."|";
				$cuerpo.=$r['INVOICE_AMT']."|";
				$cuerpo.=$r['TAX_AMT']."|";
				$cuerpo.=$r['TAX_AMT_TPARTIES']."|";
				$cuerpo.=$r['TAX_AMT_PER']."|";
				$cuerpo.=$r['TAX_SR_TPARTIES']."|";
				$cuerpo.=$r['TAX_SR']."|";
				$cuerpo.=$r['TAX_SEL_CONS']."|";
				$cuerpo.=$r['TAX_OTHER']."|";
				$cuerpo.=$r['AMT_PROP']."|";
				$cuerpo.=$r['CASH_AMOUNT']."|";
				$cuerpo.=$r['PAY_CHTRDEP']."|";
				$cuerpo.=$r['PAY_CREDCARD']."|";
				$cuerpo.=$r['CREDIT_AMT']."|";
				$cuerpo.=$r['PAY_BONDCERT']."|";
				$cuerpo.=$r['PAY_TRANSPER']."|";
				$cuerpo.=$r['PAY_OTHER'].chr(13).chr(10);
			}

			$path = "temp/DGII_F_607_".$taxid."_".$periodo.".txt";

			$nomb_descarga="DGII_F_607_".$taxid."_".$periodo.".txt";

			if($archivo = fopen($path, "w+"))
			{
				if(fwrite($archivo, $cuerpo))
				{
					addMessage("Se ha ejecutado correctamente la generación del archivo. </br> Descargar en el siguiente enlace:  ".chr(60)."a href='$path' "."download='".$nomb_descarga."'".chr(62)."$nomb_descarga".chr(60)."a".chr(62)); 
				}
				else
				{
					addMessage("Se ha producido un problema al crear el archivo");
				}
				fclose($archivo);
			}

			}

	    }
	
	    /**
     * función para exportar las facturas anuladas a rendir a la DGII
     */
		function invo_export_anuladas() {
       
			$criteria=$_SESSION['paging']['INVO_608_LIST'];
			$comp_code='';
			//verificamos que existe la variable de session qfilter que contiene la compañia seleccionada en el criterio de busqueda
			if (empty($criteria['qfilter']['INVA_COMP_CODE'])){
				addMessage(smsg('MSG-536', '608'));
			}else{
				$comp_code=$criteria['qfilter']['INVA_COMP_CODE']; //obtenemos el codigo de compañía

				$ncfinvo = ClxCommon::$db->getFields('BILL_INV_ANUL_DGIIH', 'TYPE_REPORT, TAXID, PERIOD_NAME, REGISTER_NUMBER', 'COMP_CODE='.singleQuote($comp_code));


				$cab=$ncfinvo['TYPE_REPORT'].'|'.$ncfinvo['TAXID'].'|'.$ncfinvo['PERIOD_NAME'].'|'.$ncfinvo['REGISTER_NUMBER'];
				$cab.=chr(13).chr(10);

				$taxid=$ncfinvo['TAXID'];
				$periodo=$ncfinvo['PERIOD_NAME'];

				$sql='SELECT TAXRCPT_NO, INVOICEDATE+0 AS INVOICEDATE, REVERSE_REA FROM BILL_INV_ANUL_DGII WHERE COMP_CODE = '.singleQuote($comp_code);

				$rs = ClxCommon::$db->executeQuery($sql);

				$cuerpo=$cab;
				while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {                                  
					$cuerpo.=$r['TAXRCPT_NO']."|";
					$cuerpo.=$r['INVOICEDATE']."|";
					$cuerpo.=$r['REVERSE_REA'].chr(13).chr(10);
				}

				$path = 'temp/DGII_F_608_'.$taxid.'_'.$periodo.'.txt';

				$nomb_descarga='DGII_F_608_'.$taxid.'_'.$periodo.'.txt';

				if($archivo = fopen($path, "w+"))
				{
					if(fwrite($archivo, $cuerpo))
					{
						addMessage("Se ha ejecutado correctamente la generación del archivo. </br> Descargar en el siguiente enlace:  ".chr(60)."a href='$path' "."download='".$nomb_descarga."'".chr(62)."$nomb_descarga".chr(60)."a".chr(62)); 
					}
					else
					{
						addMessage("Se ha producido un problema al crear el archivo");
					}
					fclose($archivo);
				}
			}
	    }
		
	//MIGRACION DE DESARROLLO DE FACTURAS PARA BAT / 05-03-2021 EDGARD
	/**
	 * Check Templates
	 */
	
	function print_invoice_templates_bat($template = '',$type='01') {
	    //global $db;
	    $props = array();
	    $DBLT = &getTool('DBLT');
	    $fieldtp = $DBLT->getListAsArray('INPF');
	    unset($fieldtp [null]);

	    //$OBJS = &getTool("OBJS");
	    $FILE = getToolObject("DBFT", 'FILE');

	    $sql = "SELECT
				    ID id,
				    WIDTH w,
				    HEIGHT h,
				    IMG_Y img_y,
				    IMG_X img_x,
				    IMG_W img_w,
				    IMG_H img_h,
				    TEMPLATE_NAME template_name,
				    FILE_DIR file,
				    UNIT unit,
				    GUIDANCE_PAPER direction,
				    FONT_SIZE fontsize,
				    FONT_TYPE font
			    FROM
				    $this->tabprops

			    WHERE   INV_TYPE='$type' and
				    COMP_CODE = '{$this->comp_code}'";
	    if (ISSET(UserRequest::$get['VER'])){
		pre($sql);
	    }
		
	    $rs = ClxCommon::$db->executeQuery($sql);
	    while (($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) == true) {
		$props[$r['id']] = array(
		    'id' => $r['id'],
		    'w' => $r['w'],
		    'h' => $r['h'],
		    'img_y' => $r['img_y'],
		    'img_x' => $r['img_x'],
		    'img_w' => $r['img_w'],
		    'img_h' => $r['img_h'], //h 22 w 19
		    'template_name' => $r['template_name'],
		    'file' => $r['file'],
		    'unit' => $r['unit'],
		    'direction' => $r['direction'],
		    'fontsize' => $r['fontsize'],
		    'font' => $r['font'],
		    'fields' => $r['id']
		);
	    }


	    $idd = array();
	    foreach ($props as $k => $v) {
		$idd[$k]['fields'] = $props[$k]['fields'];
		$props[$k]['fields'] = array();
		$props[$k]['file'] = $FILE->fileName($props[$k]['file']);
	    }

	    foreach ($idd as $k => $v) {

		$sql = "SELECT
					    ID ID,
					    IDFIELD_INV fieldname,
					    ENABLED enabled,
					    POSITION_Y y,
					    POSITION_X x,
					    WIDTH w,
					    HEIGHT h,
					    ENCLOSE enclose,
					    SHOW_LOCATION show_location,
					    WORDWRAP wordwrap,
					    WRAP_SEPARATION wrap_separation,
					    ROW_SEPARATION row_separation,
					    ALIGN align,
					    HAS_TOTAL has_total,
					    Y_TOTAL y_total,
					    X_TOTAL x_total,
					    HAS_DECIMAL has_decimal,
					    Y_DECIMAL y_decimal,
					    X_DECIMAL x_decimal,
					    DECIMAL_W decimal_w,
					    DECIMAL_H decimal_h
				    FROM
					    $this->tfdprops
				    WHERE
					    IDDETAIL = " . $idd[$k]['fields'] . "
				    ";
		if (ISSET(UserRequest::$get['VER'])){
		    pre($sql);
		}

		$rs = ClxCommon::$db->executeQuery($sql);
		$df = 0;
		while (($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) == true) {
		    if (empty($props[$k]['fields']))
			continue;
		    (($r['enabled'] == 1) ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['enabled'] = true : $props[$k]['fields'][$fieldtp[$r['fieldname']]]['enabled'] = false );
		    $props[$k]['fields'][$fieldtp[$r['fieldname']]]['y'] = $r['y'];
		    $props[$k]['fields'][$fieldtp[$r['fieldname']]]['x'] = $r['x'];
		    (($r['w'] != '') ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['w'] = $r['w'] : '' );
		    (($r['h'] != '') ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['h'] = $r['h'] : '' );
		    (($r['enclose'] != '') ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['enclose'] = $r['enclose'] : '' );
		    (($r['show_location'] == 1) ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['show_location'] = true : '' );
		    (($r['wordwrap'] != 0) ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['wordwrap'] = $r['wordwrap'] : '' );
		    (($r['wrap_separation'] != 0) ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['wrap_separation'] = $r['wrap_separation'] : '' );
		    (($r['row_separation'] != 0) ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['row_separation'] = $r['row_separation'] : '' );
		    (($r['align'] != '') ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['align'] = $r['align'] : '' );
		    (($r['has_total'] == 1) ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['has_total'] = true : '' );
		    (($r['y_total'] != 0) ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['y_total'] = $r['y_total'] : '' );
		    (($r['x_total'] != 0) ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['x_total'] = $r['x_total'] : '' );
		    (($r['has_decimal'] == 1) ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['has_decimal'] = true : '' );
		    (($r['y_decimal'] != 0) ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['y_decimal'] = $r['y_decimal'] : '' );
		    (($r['x_decimal'] != 0) ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['x_decimal'] = $r['x_decimal'] : '' );
		    (($r['decimal_w'] != 0) ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['decimal_w'] = $r['decimal_w'] : '' );
		    (($r['decimal_h'] != 0) ? $props[$k]['fields'][$fieldtp[$r['fieldname']]]['decimal_h'] = $r['decimal_h'] : '' );
		    if ($fieldtp[$r['fieldname']] == 'DETAIL') {
			$df = $r['ID'];
			$props[$k]['fields'][$fieldtp[$r['fieldname']]]['fields'] = array();
		    }
		}

		if (array_key_exists('DETAIL', $props[$k]['fields'])) {
		    $sql = "SELECT
					    IDFIELD_INV fieldname,
					    ENABLED enabled,
					    POSITION_Y y,
					    POSITION_X x,
					    WIDTH w,
					    HEIGHT h,
					    ENCLOSE enclose,
					    SHOW_LOCATION show_location,
					    WORDWRAP wordwrap,
					    WRAP_SEPARATION wrap_separation,
					    ROW_SEPARATION row_separation,
					    ALIGN align,
					    HAS_TOTAL has_total,
					    Y_TOTAL y_total,
					    X_TOTAL x_total,
					    HAS_DECIMAL has_decimal,
					    Y_DECIMAL y_decimal,
					    X_DECIMAL x_decimal,
					    DECIMAL_W decimal_w,
					    DECIMAL_H decimal_h
				    FROM
					    $this->tdfprops
				    WHERE
					    IDFIELDDT = " . $df . "
			    ";
	    	    if (ISSET(UserRequest::$get['VER'])){
			pre($sql);
		    }

		    $rs = ClxCommon::$db->executeQuery($sql);
		    while (($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) == true) {
			(($r['enabled'] == 1) ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['enabled'] = true : $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['enabled'] = false );
			$props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['x'] = $r['x'];
			$props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['y'] = $r['y'];
			(($r['w'] != '') ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['w'] = $r['w'] : '' );
			(($r['h'] != '') ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['h'] = $r['h'] : '' );
			(($r['enclose'] != '') ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['enclose'] = $r['enclose'] : '' );
			(($r['show_location'] == 1) ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['show_location'] = true : '' );
			(($r['wordwrap'] != 0) ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['wordwrap'] = $r['wordwrap'] : '' );
			(($r['wrap_separation'] != 0) ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['wrap_separation'] = $r['wrap_separation'] : '' );
			(($r['row_separation'] != 0) ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['row_separation'] = $r['row_separation'] : '' );
			(($r['align'] != '') ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['align'] = $r['align'] : '' );
			(($r['has_total'] == 1) ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['has_total'] = true : '' );
			(($r['y_total'] != 0) ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['y_total'] = $r['y_total'] : '' );
			(($r['x_total'] != 0) ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['x_total'] = $r['x_total'] : '' );
			(($r['has_decimal'] == 1) ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['has_decimal'] = true : '' );
			(($r['y_decimal'] != 0) ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['y_decimal'] = $r['y_decimal'] : '' );
			(($r['x_decimal'] != 0) ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['x_decimal'] = $r['x_decimal'] : '' );
			(($r['decimal_w'] != 0) ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['decimal_w'] = $r['decimal_w'] : '' );
			(($r['decimal_h'] != 0) ? $props[$k]['fields']['DETAIL']['fields'][$fieldtp[$r['fieldname']]]['decimal_y'] = $r['decimal_h'] : '' );
		    }
		}

	    }
	    if ($template == '') {
		return $props;
	    } else {
		return $props[$template];
	    }
	}	
	
	
	
	function prompt_invoice_template_bat(&$msg,$type) {
	    $props = $this->print_invoice_templates_bat('',$type);
	    $form = new htmlForm(CLX_PROP_ACTION, 'pop.php', 'method', 'get');
	    foreach (UserRequest::$get as $key => $val) {
			$form->addArgument($key, $val);
	    }
	    $table = new htmlTable(2);
	    $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM)); 
	    //$table->addCell(dict('GEN_LBL_SELECT_OPTION'), "class", "title", "colspan", 2);
		$table->addCell(dict('GEN_LBL_SELECT_OPTION'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_NUM_TWO));
	    if (array_key_exists('template', $msg) && $msg['template'] <> "") {
			$table->addCell($msg['template'], array(CLX_PROP_CLASS => 'alert', CLX_PROP_COLSPAN => CLX_NUM_TWO));
			//$table->addCell($msg['template'], "class", "alert", "colspan", 2);
	    }

		$table->addCell(dict('GEN_LBL_INVOICE_TEMPLATE'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
	    //$table->addCell(dict('GEN_LBL_INVOICE_TEMPLATE'), "class", "prompt");
	    $select = new htmlSelect('template');
	    foreach ($props as $key => $val) {
		    $select->addItem($val['template_name'], $key, false);
	    }
	    //$table->addCell($select->source(), "class", "data");
		$table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
	    $bs = new htmlSubmit(dict('GEN_LBL_SUBMIT'));
	    $b = $bs->source();
	    $bs = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
	    $b .= $bs->source();
	    //$table->addCell($b, "class", "title", "colspan", 2);
 	    $table->addCell($b, array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_NUM_TWO));
	    $form->addContents($table->source());
	    return $form->source();
	}
	
	function getCompCode_bat($id,$type) {
	    //global $db;
	    if ($type=='01') {
		$sql = 'SELECT COMP_CODE FROM ' . $this->invoname . ' INVO WHERE INVO.ID = ' . $id;
	    }	
	    else if ($type=='03') {
		$sql ="SELECT COMP_CODE FROM $this->fiatname FIAT WHERE ID = $id";
	    }
   	    else if ($type=='05') {
		$sql ="SELECT COMP_CODE FROM $this->apinname APIN WHERE ID = $id";
	    }

	    return ClxCommon::$db->getOne($sql);
	}	

	function print_invoice_bat() {
	    //global $db;
        $idlist = getIdlist();
		
	    $DBLT = &getTool('DBLT');

	    //require_once kPathToWebSite . 'classes/fpdf_current/fpdf.php';
	    if (!class_exists('PDF_Visibility') && file_exists(kPathToFpdf . 'PDF_Visibility.php')) {
            include_once kPathToWebSite . kPathToFpdf . 'PDF_Visibility.php';
        }
		$chk_props = $this->print_invoice_templates_bat(UserRequest::$get['template']);

	    // includeCodeLib('GEN_NO_TEXT');
	    $pdf = new PDF_Visibility($chk_props['direction'], $chk_props['unit'], array($chk_props['w'], $chk_props['h']));

	    //$pdf=new PDF_Visibility($chk_props['direction'], $chk_props['unit'], 'Letter' );
	    $pdf->SetMargins(0, 0, 0);

	    $sql = "SELECT
			    INVO.COMP_CODE,
			    INVO.CURRENCY_CODE,
			    INVO.ID ID,
			    INVO.IDCODE IDCODE,
			    INVO.IDNAME IDNAME,
			    INVO.JEHDR_CODE,
			    INVO.INVOICEDATE EFFTDATE,
			    INVO.ACCOUNTCODE ACCOUNTCODE,
			    INVO.DEBTOR_FICO_CODE,
			    IFNULL((SELECT IFNULL(ACCO.LEGAL_NAME, ACCO.IDNAME) FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE = INVO.ACCOUNTCODE),'') BENEFICIARY_NAME,
			    IFNULL((SELECT IFNULL(CONCAT_WS(' ', ACCO.ADDRESS1, ACCO.ADDRESS2),CONCAT_WS(' ',ACCO.ADDRESS1_02, ACCO.ADDRESS2_02)) ADDRESS FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE = INVO.ACCOUNTCODE),'') ADDRESS,
			    IFNULL((SELECT IFNULL(ACCO.STATE,'') STATE FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE = INVO.ACCOUNTCODE),'') STATE,
			    IFNULL((SELECT IFNULL(ACCO.COUNTRY,'') STATE FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE = INVO.ACCOUNTCODE),'') COUNTRY,
			    0 SUB_TOTAL,
			    0 ITBMS,
			    INVO.INVOICE_AMT TOTAL,

			    INVO.CHART_FIELD01 CHART_FIELD01,
			    INVO.CHART_FIELD02 CHART_FIELD02,
			    IFNULL((SELECT IFNULL(ACCO.LEGAL_NAME, ACCO.IDNAME) FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE = INVO.CHART_FIELD02),'') PARTICIPANT,

			    IFNULL((SELECT IFNULL(CONCAT_WS(' ', ACCO.ADDRESS1, ACCO.ADDRESS2),CONCAT_WS(' ',ACCO.ADDRESS1_02, ACCO.ADDRESS2_02)) ADDRESS FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE = INVO.CHART_FIELD02),'') ADDRESS_PARTICIPANT,
			    IFNULL((SELECT IFNULL(ACCO.STATE,'') STATE FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE = INVO.CHART_FIELD02),'') STATE_PARTICIPANT,
			    IFNULL((SELECT IFNULL(ACCO.COUNTRY,'') STATE FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE = INVO.CHART_FIELD02),'') COUNTRY_PARTICIPANT,


			    INVO.CLX_AUTH_STATUS INVO_CLX_AUTH_STATUS,

			    INVO.AR_ITEM_CODE INVO_AR_ITEM_CODE,
			    INVO.AR_AMORT_METHOD INVO_AR_AMORT_METHOD,
			    IFNULL((SELECT IFNULL(ACCO.PHONE, ACCO.HOME_PHONE) FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE = INVO.CHART_FIELD02),'') PHONE,
			    INVO.MODIFIEDBY MODIFIEDBY,
			    IFNULL((SELECT IFNULL(FICO.CONTRACT_NUMBER,'') CONTRACT_NUMBER FROM FIDU_CONTRACTS FICO WHERE FICO.IDCODE = INVO.IDCODE),'') CONTRACT_NAME,
			    IFNULL((SELECT IFNULL(FICO.IDNAME,'') CONTACT FROM FIDU_CONTRACTS FICO WHERE FICO.IDCODE = INVO.IDCODE),'') CONTACT_NAME,
			    IFNULL((SELECT IFNULL(ACCO.CITY, '') FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE = INVO.CHART_FIELD02),'') CITI,
			    IFNULL((SELECT IFNULL(ACCO.IDENTIFICATION, '') FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE = INVO.CHART_FIELD02),'') IDENTIFICATION

			 FROM
				    $this->invoname INVO

			 WHERE
				    INVO.ID IN (" . toString($idlist) . ")
					AND INVO.CLX_AUTH_STATUS = 'AP'
					AND INVO.RESTRICTED = 0
			    ";

	    //print_r($sql );
		//return alert(dict('017E8B29849843B6DAA2501AAD99F7C1')); si no esta aprobado este era un mensaje de error
	    //foreach ( $idlist as $transid ) {
	    $rs = ClxCommon::$db->executeQuery($sql);
	    while (($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) == true) {

		$debtor_contract_number = '';
		if (!empty($r['DEBTOR_FICO_CODE'])) {
		    $r['BENEFICIARY_NAME'] = $db->getField($this->ficoname, 'CONTRACT_NUMBER', "IDCODE = '" . $r['DEBTOR_FICO_CODE'] . "'") . ' ' . $r['BENEFICIARY_NAME'];
		}
		$r['CONTACT_NAME'] = "CONTACTO: " . trim($r['CONTACT_NAME']);
		$r['PHONE'] = "TELEFONO: " . trim($r['PHONE']);
		$r['CITI'] = $DBLT->getListItem('CITI', $r['CITI'], 7);
		$r['STATE'] = $DBLT->getListItem('STAT', $r['STATE'], 7);
		$r['COUNTRY'] = $DBLT->getListItem('COUN', $r['COUNTRY'], 7);

		$r['ADDRESS_FULL'] = $r['ADDRESS'] . CLX_CHAR_NL . $r['STATE'] . CLX_CHAR_NL . $r['COUNTRY'];
		//$r['ADDRESS'] = $r['ADDRESS'].', '.$r['STATE'].','.$r['COUNTRY'];
		$r['STATE_PARTICIPANT'] = $DBLT->getListItem('CITI', $r['STATE_PARTICIPANT'], 7);
		$r['COUNTRY_PARTICIPANT'] = $DBLT->getListItem('COUN', $r['COUNTRY_PARTICIPANT'], 7);

		$r['ADDRESS_PARTICIPANT'] = $r['ADDRESS_PARTICIPANT'] . CLX_CHAR_NL . $r['STATE_PARTICIPANT'] . CLX_CHAR_NL . $r['COUNTRY_PARTICIPANT'];
		//$r['LOCATION'] = $DBLT->getListItem('CITI',$db->getField($this->coloname, 'CITY',"IDCODE = '".$r['BRANCH']."' AND COMP_CODE = '".$r['COMP_CODE']."'"));
		//$r['LOCATION'] = $DBLT->getListItem('CITI',$db->getField($this->coloname, 'CITY',"IDCODE = '".$r['BRANCH']."'"), 2);
		$r['DETAIL'] = array();

		//$db->updateRecord ( $this->fiatname, array ('CHECK_PRINT_DATI' => $this->now, 'CHECK_PRINT_BY' => $_SESSION ['user_record'] ['username'] ), "ID = $transid" );

		/* Caso 1002909 - BEGIN - CJRD */
		/*
		 * ANTENCION: Este cambio se hizo porque la funcion xFormat::date,
		 * al especificar "F" en el formato de fecha, devuelve el nombre del mes mal.
		 * Por ejemplo, para septiembre, devuelve "Septiembretember", para Junio devuelve "Junioe"
		 */
		/*
		  $r ['EFFTDATE_TEXT'] = xFormat::date ( $r ['EFFTDATE'], 'd/F/Y' );
		  //$r ['EFFTDATE'] = xFormat::date ( $r ['EFFTDATE'], 'd/m/Y' );
		 */
		$r ['EFFTDATE_TEXT'] = xFormat::date($r ['EFFTDATE'], 'd/m/Y');
		/* Caso 1002909 - BEGIN - CJRD - CJRD */

		$r ['MODIFIEDBY'] = $_SESSION ['user_record'] ['username'];
		if ($r ['BENEFICIARY_NAME'] == '') {
		    $r ['BENEFICIARY_NAME'] = $r ['PARTICIPANT_NAME'];
		}
		$tdate = explode('/', $r ['EFFTDATE_TEXT']);
		if (getCurrentLanguage() == 'en') {
		    /* Caso 1002909 - BEGIN - CJRD */
		    //$r ['EFFTDATE'] = $tdate[1].' '.$tdate[0].'th of '.$tdate[2];
		    $meses = array(
			'01' => 'January',
			'02' => 'February',
			'03' => 'March',
			'04' => 'April',
			'05' => 'May',
			'06' => 'June',
			'07' => 'July',
			'08' => 'August',
			'09' => 'September',
			'10' => 'October',
			'11' => 'November',
			'12' => 'December'
		    );
		    $r ['EFFTDATE'] = $meses[$tdate[1]] . ' ' . $tdate[0] . 'th of ' . $tdate[2];
		    /* Caso 1002909 - END - CJRD */
		} else {
		    /*
		      switch($tdate[1]){
		      case 'January': $tdate[1] = 'ENERO';break;
		      case 'February': $tdate[1] = 'FEBRERO';break;
		      case 'March': $tdate[1] = 'MARZO';break;
		      case 'April': $tdate[1] = 'ABRIL';break;
		      case 'May': $tdate[1] = 'MAYO';break;
		      case 'June': $tdate[1] = 'JUNIO';break;
		      case 'July': $tdate[1] = 'JULIO';break;
		      case 'August': $tdate[1] = 'AGOSTO';break;
		      case 'September': $tdate[1] = 'SEPTIEMBRE';break;
		      /* Caso 1002909 - BEGIN - CJRD * /
		      case 'Septiembretember': $tdate[1] = 'SEPTIEMBRE';break;
		      /* Caso 1002909 - END - CJRD * /
		      case 'October': $tdate[1] = 'OCTUBRE';break;
		      case 'November': $tdate[1] = 'NOVIEMBRE';break;
		      case 'December': $tdate[1] = 'DICIEMBRE';break;
		      }
		      $r ['EFFTDATE'] = $tdate[0].' de '.$tdate[1].' de '.$tdate[2];
		     */
		    $meses = array(
			'01' => 'Enero',
			'02' => 'Febrero',
			'03' => 'Marzo',
			'04' => 'Abril',
			'05' => 'Mayo',
			'06' => 'Junio',
			'07' => 'Julio',
			'08' => 'Agosto',
			'09' => 'Septiembre',
			'10' => 'Octubre',
			'11' => 'Noviembre',
			'12' => 'Diciembre'
		    );
		    $r ['EFFTDATE'] = $tdate[0] . ' de ' . $meses[$tdate[1]] . ' de ' . $tdate[2];
		}

		foreach ($r as $key => $val) {
		    if (!is_array($val)) {
			//$r [$key] = uppercase ( $val );
			$r [$key] = strtoupper($val);
		    }
		}

		//Journal Details
		$sql = "SELECT
					INVL.DESCRIPTION GL_NAME,
					INVL.PRICE TRANS_AMT,
					/* Caso 1002909 - BEGIN - CJRD 
					INVL.TAX_AMT,
					 Caso 1002909 - END - CJRD */
					INVL.LINE_TOTAL LINE_TOTAL,
					INVL.ITEM_CODE ITEM_CODE,
					INVL.GLACCOUNTCODE GLACCOUNTCODE,
					GLAC.IS_FEE_TAX_ACC IS_TAG,
					INVL.ITEM_CODE ITEM_CODE
				    FROM
					$this->invlname INVL,
					$this->glacname GLAC
				    WHERE
					INVL.GLACCOUNTCODE = GLAC.IDCODE
					AND INVL.INVOICECODE = '" . $r['IDCODE'] . "'";

		//print_r($sql );
		$rs2 = ClxCommon::$db->executeQuery($sql);

		while (($r2 = ClxCommon::$db->getNextRecord($rs2, ASSOCIATIVE)) == true) {
		    if ($r2['IS_TAG'] == 0) {

			/* Caso 1002909 - BEGIN - CJRD */
			//$r ['SUB_TOTAL'] = bcadd($r ['SUB_TOTAL'], $r2 ['TRANS_AMT']);
			$r ['SUB_TOTAL'] = bcadd($r ['SUB_TOTAL'], $r2 ['LINE_TOTAL']);
			$r['ITBMS'] = bcadd($r['ITBMS'], $r2['TAX_AMT']);
			/* Caso 1002909 - END - CJRD */

			//$r ['TRANS_AMT'] = clx_format_currency ( $r ['TRANS_AMT'], 2, ',' );

			$r['DETAIL'][] = $r2;
		    } else {
			/* Caso 1002909 - BEGIN - CJRD */
			//$r['ITBMS'] = $r2['TRANS_AMT'];
			$r['ITBMS'] += $r2['LINE_TOTAL'];
			/* Caso 1002909 - END - CJRD */
		    }
		}

		//$record ['TOTAL'] = clx_format_currency ( $record ['TOTAL'], 2, ',' );
		//$record ['SUB_TOTAL'] = clx_format_currency ( $record ['SUB_TOTAL'], 2, ',' );
		//$record ['ITBMS'] = clx_format_currency ( $record ['ITBMS'], 2, ',' );

		$pdf->AddPage();
		$pdf->SetFont($chk_props['font'], '', $chk_props['fontsize']);

		$pdf->SetVisibility('screen');
		//$pdf->Image($chk_props['file'], 0, 0, $chk_props['w'], $chk_props['h']);
		//$pdf->Image($chk_props['file'], $chk_props['img_x'], $chk_props['img_y'], $chk_props['img_w'], $chk_props['img_h']);



		$pdf->SetXY(0, 0);
		$pdf->SetVisibility('all');

		foreach ($chk_props['fields'] as $k => $v) {

		    if (!$v['enabled'])
			continue;


		    if (array_key_exists('fields', $v)) {


			//Description
			$y_increment = 0;

			$totals = array();
			$deci = array();
			foreach ($r [$k] as $item => $row) {

			    foreach ($v['fields'] as $k2 => $v2) {

				if (!empty($v2['has_total'])) {
				    if (!array_key_exists($k2, $totals)) {
					$totals[$k2] = array($row[$k2], 'x' => $v2['x_total'], 'y' => $v2['y_total']);
				    } else {
					$totals[$k2][0] += $row[$k2];
				    }
				}
				$c = 0;
				if (!empty($v2['has_decimal'])) {

				    strpos($row[$k2], ".") != " " ? $c++ : $c = 0;
				    /* Caso 1002909 - BEGIN - CJRD */
				    $tmp_amt = $row[$k2];
				    $row[$k2] = clx_format_currency($row[$k2], 0);
				    //$monto[] = clx_format_currency($row[$k2],2);
				    $monto[] = clx_format_currency($tmp_amt, 2);
				    /* Caso 1002909 - END - CJRD */

				    (empty($v2['decimal_w']) || $v2['decimal_w'] == 0) ? $v2['decimal_w'] = $v2['w'] : '';
				    (empty($v2['decimal_h']) || $v2['decimal_h'] == 0) ? $v2['decimal_h'] = $v2['h'] : '';



				    //$row1[] = $row[$k2];
				    $deci[$k2] = array('x' => $v2['x_decimal'], 'y' => $v2['y_decimal'], 'w' => $v2['decimal_w'], 'h' => $v2['decimal_h']);

//
//									//$d = explode('.',$row[$k2]);
				    (empty($v2['decimal_w']) || $v2['decimal_w'] == 0) ? $v2['decimal_w'] = $v2['w'] : '';
				    (empty($v2['decimal_h']) || $v2['decimal_h'] == 0) ? $v2['decimal_h'] = $v2['h'] : '';
//									$deci[$k2] = array( (!empty($d[1])) ? substr($d[1],0,2) : 0, 'x'=>$v2['x_decimal'],'y'=>$v2['y_decimal'], 'w'=>$v2['decimal_w'], 'h'=>$v2['decimal_h']);
//									//$deci[$k2][0] = clx_format_currency ( $deci[$k2][0], 0 );
//									if (getCurrentLanguage () == 'en') {
//										$row[$k2] = clx_format_currency ( $d[0], 0 );
//									} else {
//										$row[$k2] = clx_format_currency ( $d[0], 0, ',', '.' );
//									}
				    //$pdf->Text ( $v2['x'], ($v2['y']+$y_increment), decode_string($row[$k2]) );
				    $pdf->SetXY($v2['x'], ($v2['y'] + $y_increment));
				    $pdf->Cell($v2['w'], $v2['h'], decode_string($row[$k2]), 0, 0, $v2['align']);
				} else {
				    //$pdf->Text ( $v2['x'], ($v2['y']+$y_increment), decode_string($row[$k2]) );
				    $pdf->SetXY($v2['x'], ($v2['y'] + $y_increment));
				    $pdf->MultiCell($v2['w'], $v2['h'], decode_string($row[$k2]), 0, $v2['align']);
				}
			    }
			    if (array_key_exists('row_separation', $v))
				$y_increment += $v['row_separation'];
			}

			if (!empty($totals)) {
			    foreach ($totals as $k2 => $v2) {
				if (getCurrentLanguage() == 'en') {
				    $v2[0] = clx_format_currency($v2[0]);
				} else {
				    $v2[0] = clx_format_currency($v2[0], 2, ',', '.');
				}
				$pdf->Text($v2['x'], $v2['y'], $v2[0]);

				//$pdf->SetXY($v2['x'], $v2['y']);
				//if(empty($v2['align'])) $v2['align'] = 'L';
				//$pdf->MultiCell ( 0, $w, $v2 [0], 0, $v2['align']);
			    }
			}
			$i = 0;
			foreach ($monto as $value) {

//                                                   $pdf->SetXY( $deci[$k2]['x'], $deci[$k2]['y'] );
//                                                   $pdf->Cell ( $v2['w'], $v2['h'], substr($value, strlen($value)-2),0, 0, $v2['align'] );
//
			    $pdf->SetXY($deci[$k2]['x'], $deci[$k2]['y'] + $i);
			    /* Caso 1002909 - BEGIN - CJRD */
//                                                    $pdf->Cell ( $deci[$k2]['w'], $deci[$k2]['h'],substr($value, strlen($value)-2), 0, 0, $v2['align'] );
			    $decimal = substr($value, strlen($value) - 2);
			    $pdf->Cell($deci[$k2]['w'], $deci[$k2]['h'], $decimal, 0, 0, $v2['align']);
			    /* Caso 1002909 - END - CJRD */
			    $i = $i + 0.4;
			}
//                                                for ($index = 0; $index < count($deci); $index++)
//                                                {
//                                                    //$pdf->SetXY( $deci[$k2]['x'], $deci[$k2]['y'] );
//                                                    $pdf->SetXY( 5+$index, 5+$index );
//                                                    //$pdf->MultiCell ( $v2['w'], $v2['h'], decode_string($row[$k2]), 0, $v2['align'] );
//                                                    $pdf->MultiCell ( $deci[$k2]['w'], $deci[$k2]['h'], substr($monto[$i], strlen($monto[$i])-2), 0, $v2['align'] );
//                                                    $i++;
//                                                }
			/* if(array_key_exists($k2, $deci)){

			  //$pdf->Text ( $deci[$k2]['x'], $deci[$k2]['y'], $deci[$k2][0]);
			  $pdf->SetXY( $deci[$k2]['x'], $deci[$k2]['y'] );
			  $pdf->Cell ( $deci[$k2]['w'], $deci[$k2]['h'], $deci[$k2][0], 0, 0, $v2['align'] );
			  } */
		    } else {
			$r [$k] = decode_string($r[$k]);

			if (!empty($v['enclose'])) {
			    $r [$k] = $v['enclose'] . $r [$k] . $v['enclose'];
			}
			//Normal FIeld
			if (!empty($v['show_location'])) {
			    $r [$k] = $r ['LOCATION'] . ' ' . $r [$k];
			}

			$w = 0;
			if (!empty($v['wordwrap'])) {
			    $r [$k] = wordwrap($r[$k], $v['wordwrap']);
			    if (strlen($r[$k]) > $v['wordwrap']) {
				$w = $v['wrap_separation'];
			    }
			}

			if (!empty($v['has_decimal'])) {
			    $d = explode('.', $r[$k]);
			    (empty($v['decimal_w']) || $v['decimal_w'] == 0) ? $v['decimal_w'] = $v['w'] : '';
			    (empty($v['decimal_h']) || $v['decimal_h'] == 0) ? $v['decimal_h'] = $v['h'] : '';
			    $deci[$k] = array((!empty($d[1])) ? substr($d[1], 0, 2) : 0, 'x' => $v['x_decimal'], 'y' => $v['y_decimal'], 'w' => $v['decimal_w'], 'h' => $v['decimal_h']);
			    //$deci[$k][0] = clx_format_currency ( $deci[$k][0], 0 );
			    if (getCurrentLanguage() == 'en') {
				$r[$k] = clx_format_currency($d[0], 0);
			    } else {
				$r[$k] = clx_format_currency($d[0], 0, ',', '.');
			    }
			    //$pdf->Text ( $v['x'], $v['y'], decode_string( $r [$k]) );
			    $pdf->SetXY($v['x'], $v['y']);
			    $pdf->Cell($v['w'], $v['h'], decode_string($r [$k]), 0, 0, $v['align']);
			} else {
			    if ((empty($v['w']) || $v['w'] == 0) && (empty($v['h']) || $v['h'] == 0)) {
				if (empty($v['wrap_separation'])) {
				    $pdf->Text($v['x'], $v['y'], decode_string($r [$k]));
				} else {
				    $pdf->SetXY($v['x'], $v['y']);
				    //$pdf->Write ( 5, decode_string( $r [$k]) );
				    $pdf->MultiCell($v['x_total'], $v['y_total'], decode_string($r [$k]), 0, $v['align']);
				}
			    } else {
				$pdf->SetXY($v['x'], $v['y']);
				$pdf->MultiCell($v['w'], $v['h'], decode_string($r [$k]), 0, $v['align']);
			    }
			}
			if (array_key_exists($k, $deci)) {

			    //$pdf->Text ( $deci[$k]['x'], $deci[$k]['y'], $deci[$k][0]);
			    $pdf->SetXY($deci[$k]['x'], $deci[$k]['y']);
			    $pdf->Cell($deci[$k]['w'], $deci[$k]['h'], $deci[$k][0], 0, 0, $v['align']);
			}

			/* $pdf->SetXY($v['x'], $v['y']);
			  if(empty($v['align'])) $v['align'] = 'L';
			  $pdf->MultiCell ( 0, $w, $r [$k], 0, $v['align']); */
		    }
		}
	    } // end foreach trans_id
	    $pdf->Output();
	}
	
	
	function printer($type) {
	    //global $db;
	    $idlist = getIdlist();

	    $this->tabprops = "BILL_INVOICE_PROPS";
	    $this->tfdprops = "BILL_INVOICE_PROPS_FIELDS_DET";
	    $this->tdfprops = "BILL_INVOICE_PROPS_FIELDS_DET_FD";

	    $ibs_print = (companyParameter('EIBS_ENABLE_INVOICE_PRINT')) ? true : false;
	    // 2013-07-08 CJRD
	    if ($ibs_print) {
		// Llamada de la interfase de IBS en caso de
		// impresion de cheques por ibs
		includeCodeLib('EIBS_CHK');
		$a = new ibs_check_socket_interface ();
		// $a->debug = false;
		return $a->printChecks();
	    }
	    if (empty($idlist))
		return alert('Not Found');
	    $allcompc = array();
	    foreach ($idlist as $transid) {
			$value=$this->getCompCode_bat($transid,$type);
			$this->comp_code =$allcompc[$value] = $value;
	    }
	    if (count($allcompc) > 1) {
			return warning(dict('GEN_ERR_NO_SAME_CHK_COMPANY'));
	    }

	    $msg = array();
	    //Prompt format

	    if (empty(UserRequest::$get['template'])) {
			return $this->prompt_invoice_template_bat($msg,$type);
	    } else {

			if ($type == '01') {
				$msg =$this->filter_invoice($idlist,$type);
				if (!empty($msg)){
					return $this->prompt_invoice_template_bat($msg,$type);
				}
			}
			else if ($type == '03') {
				$msg =$this->filter_alquiler($idlist,$type);
				if (!empty($msg))
				return $this->prompt_invoice_template_bat($msg,$type);
			}
			else if ($type == '05') {
				$msg =$this->filter_retencion($idlist,$type);
				if (!empty($msg))
				return $this->prompt_invoice_template_bat($msg,$type);
			}

		$sql = "SELECT INVP.* " .
			" FROM {$this->invpname} INVP WHERE INVP.COMP_CODE =
		    '{$this->comp_code}' and id='" . UserRequest::$get['template'] . "' LIMIT 1";

		$rrecord = ClxCommon::$db->getOneRecord($sql);	

		if ($rrecord["TEMPLATE_TYPE"] == 2) {
		    $this->formatInvoiceTempletaGraphics = true;
		    if ($type=='01')
			$this->print_format($rrecord, $idlist,$type);
		    else if ($type=='03')
			$this->print_format($rrecord, $idlist,$type);
		    else if ($type=='05')
			$this->print_format($rrecord, $idlist,$type);
		}
		else if ($type=='01') {
		   $this->print_invoice_bat();
		}
	    }
	}
	
	function filter_invoice($idlist,$type) {
	    //global $db;
	    $msg=Array();
	    $sql = "SELECT 
		            INCP.ID INCP_ID,
			    INVOICEDATE,
			    INVO.INVOICE_NO,
			    INCP.CLX_AUTH_STATUS,
			    INCP.INV_NUMBER,
			    INCP.ADDRESS,
			    INCP.LAST_INV_NUMBER,
			    INCP.INV_SERIE_TO,
			    INCP.EMAIL,
			    INCP.VALID_UNTIL
			    FROM 
	                         {$this->invoname} INVO 
	    		    LEFT JOIN
				 (SELECT INCP2.* FROM {$this->incpname} INCP2, {$this->invoname} INVO2 WHERE INCP2.INV_TYPE='$type' AND INCP2.CLX_AUTH_STATUS='AP' AND INVO2.CHART_FIELD01=INCP2.CHART_FIELD01 AND
			         INVO2.COMP_CODE=INCP2.COMP_CODE AND INVO2.ID={$idlist[0]}  ORDER BY INCP2.VALID_UNTIL DESC  LIMIT 1) INCP 
			    ON	 INVO.CHART_FIELD01=INCP.CHART_FIELD01 AND
			         INVO.COMP_CODE=INCP.COMP_CODE 
			    WHERE INVO.ID={$idlist[0]} ORDER BY INCP.VALID_UNTIL DESC LIMIT 1";
	    $rs = ClxCommon::$db->executeQuery($sql);
	    if (($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) == true) {
		if ($r['INVOICE_NO'] == '') {
		    if ($r['INV_NUMBER'] == '' or $r['LAST_INV_NUMBER'] == '' or $r['INV_SERIE_TO'] == '' or $r['CLX_AUTH_STATUS']!='AP' or $r['ADDRESS']=='' or $r['EMAIL']=='') {
			$msg['template'] = smsg('MSG-537'); //'Falta información para generar facturación de este contrato';
		    } else if ($r['VALID_UNTIL'] < date('Y-m-d')) {
			echo $r['VALID_UNTIL']. ' '.date('Y-m-d');
			$msg['template'] = smsg('MSG-538'); //'Se ha superado el tope de fecha válido';
		    } else if ($r['VALID_UNTIL'] < $r['INVOICEDATE']) {
			$msg['template'] = smsg('MSG-539'); //'La fecha de la factura es mayor que el rango válido de fecha';
		    } else if ($r['LAST_INV_NUMBER'] + 1 > $r['INV_SERIE_TO']) {
			$msg['template'] = smsg('MSG-519'); //'Número de Factura fuera de rango de emisión';
		    } else {
			$pad = str_pad($r['LAST_INV_NUMBER'] + 1, 6, "0", STR_PAD_LEFT);
			$fac = $r['INV_NUMBER'] . $pad;
			$sql = "UPDATE {$this->incpname} SET LAST_INV_NUMBER=LPAD(LAST_INV_NUMBER+1,6,'0') where id={$r['INCP_ID']} and CLX_AUTH_STATUS='AP' and LAST_INV_NUMBER={$r['LAST_INV_NUMBER']}  and LAST_INV_NUMBER={$r['LAST_INV_NUMBER']} and INV_TYPE='$type' and ID={$r['INCP_ID']};";
			ClxCommon::$db->executeQuery($sql);
			$sql = "UPDATE {$this->invoname} INVO SET INVOICE_NO='{$fac}' where id={$idlist[0]} and exists(
				    SELECT 1 FROM {$this->incpname} INCP WHERE  INV_TYPE='$type' AND 
				    INVO.CHART_FIELD01=INCP.CHART_FIELD01 AND INVO.COMP_CODE=INCP.COMP_CODE AND 
				    INCP.LAST_INV_NUMBER='$pad' and INCP.ID={$r['INCP_ID']});";
			ClxCommon::$db->executeQuery($sql);
		    }
		}
	    }
	    return $msg;
	}

	function filter_alquiler($idlist,$type) {
	    //global $db;
	    $msg=Array();
	    $sql = "SELECT 
		            INCP.ID INCP_ID,
			    INCP.CLX_AUTH_STATUS,
			    INCP.INV_NUMBER,
			    INCP.LAST_INV_NUMBER,
			    INCP.ADDRESS,
			    INCP.INV_SERIE_TO,
			    INCP.VALID_UNTIL,
			    INCP.EMAIL,
			    FIAT.REAL_DATE,
			    FIAT.RENTAL_NO,
			    FIAT.EFFTDATE FIAT_EFFTDATE,
			    INCP.CLX_EFFTDATE INCP_EFFTDATE,
			    FICO.TAXID
			    FROM 
	                         {$this->fiatname} FIAT
	    		    LEFT JOIN
				 (SELECT INCP2.* FROM {$this->incpname} INCP2, {$this->fiatname} FIAT2 WHERE INCP2.INV_TYPE='$type' AND INCP2.CLX_AUTH_STATUS='AP' AND FIAT2.CHART_FIELD01=INCP2.CHART_FIELD01 AND
			         FIAT2.COMP_CODE=INCP2.COMP_CODE AND FIAT2.ID={$idlist[0]}  ORDER BY INCP2.VALID_UNTIL DESC  LIMIT 1) INCP 
			    ON	 1=1
			    LEFT JOIN
				 (SELECT FICO2.TAXID FROM {$this->ficoname} FICO2, {$this->fiatname} FIAT2 WHERE  FIAT2.CHART_FIELD01=FICO2.IDCODE AND
			         FIAT2.COMP_CODE=FICO2.COMP_CODE AND FIAT2.ID={$idlist[0]}   LIMIT 1) FICO
			    ON	 1=1
			    WHERE FIAT.ID={$idlist[0]} ORDER BY INCP.VALID_UNTIL DESC LIMIT 1";
	    //print_r ($sql);
		$rs = ClxCommon::$db->executeQuery($sql);
	    if (($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) == true) {
		if ($r['INV_NUMBER'] == '' or $r['LAST_INV_NUMBER'] == '' or $r['INV_SERIE_TO'] == '' or $r['CLX_AUTH_STATUS']!='AP' or $r['ADDRESS']=='' or $r['EMAIL']=='') {
		    $msg['template'] = smsg('MSG-537'); //'Falta información para generar facturación de este contrato';
		} else if ($r['VALID_UNTIL'] < date('Y-m-d')) {
		    $msg['template'] = smsg('MSG-538'); //'Se ha superado el tope de fecha válido';
		} else if ($r['VALID_UNTIL'] < $r['REAL_DATE']) {
		    $msg['template'] = smsg('MSG-539'); //'La fecha de la factura es mayor que el rango válido de fecha';*/
		} else if ($r['LAST_INV_NUMBER'] + 1 > $r['INV_SERIE_TO']) {
		    $msg['template'] = smsg('MSG-519'); //'Número de Factura fuera de rango de emisión';
		} else if ($r['FIAT_EFFTDATE'] < $r['INCP_EFFTDATE']) {
		    $msg['template'] = smsg('MSG-521'); //'La fecha de propiedades factura de alquiler es mayor que la fecha efftdate de la transacción';*/
		}
		else if (empty($r['TAXID'])) {
		    $msg['template'] = smsg('MSG-522'); //'Identificación tributaria en blanco;*/
		}else {

		    $pad = str_pad($r['LAST_INV_NUMBER'] + 1, 6, "0", STR_PAD_LEFT);
		    $alq = $r['INV_NUMBER'] . $pad;
		    $sql = "UPDATE {$this->incpname} SET LAST_INV_NUMBER=LPAD(LAST_INV_NUMBER+1,6,'0') where id={$r['INCP_ID']} and CLX_AUTH_STATUS='AP' and LAST_INV_NUMBER={$r['LAST_INV_NUMBER']}  and LAST_INV_NUMBER={$r['LAST_INV_NUMBER']} and INV_TYPE='$type' and ID={$r['INCP_ID']};";
		    ClxCommon::$db->executeQuery($sql);
		    $sql = "UPDATE {$this->fiatname} INVO SET RENTAL_NO='{$alq}' where id={$idlist[0]} and exists(
				SELECT 1 FROM {$this->incpname} INCP WHERE  INCP.INV_TYPE='$type' AND 
				INVO.CHART_FIELD01=INCP.CHART_FIELD01 AND INVO.COMP_CODE=INCP.COMP_CODE AND 
				INCP.LAST_INV_NUMBER='$pad' and INCP.ID={$r['INCP_ID']});";

		    ClxCommon::$db->executeQuery($sql);

		}
	    }
	    else {
		$msg['template'] = smsg('MSG-537'); //'Falta información para generar facturación de este contrato';
	    }
	return $msg;


	}	
	
	function filter_retencion($idlist,$type) {
	    //global $db;
	    $msg=Array();
	    $sql = "SELECT 
		            INCP.ID INCP_ID,
			    INVOICEDATE,
			    APIN.RETENCION_NO,
			    INCP.CLX_AUTH_STATUS,
			    INCP.ADDRESS,
			    INCP.INV_NUMBER,
			    INCP.LAST_INV_NUMBER,
			    INCP.EMAIL,
			    INCP.INV_SERIE_TO,
			    INCP.VALID_UNTIL
			    FROM 
	                         {$this->apinname} APIN
	    		    LEFT JOIN
				 (SELECT INCP2.* FROM {$this->incpname} INCP2, {$this->apinname} APIN2 WHERE INCP2.INV_TYPE='$type' AND INCP2.CLX_AUTH_STATUS='AP' AND APIN2.CHART_FIELD01=INCP2.CHART_FIELD01 AND
			         APIN2.COMP_CODE=INCP2.COMP_CODE AND APIN2.ID={$idlist[0]}  ORDER BY INCP2.VALID_UNTIL DESC  LIMIT 1) INCP 
			    ON	 APIN.CHART_FIELD01=INCP.CHART_FIELD01 AND
			         APIN.COMP_CODE=INCP.COMP_CODE 
			    WHERE APIN.ID={$idlist[0]} ORDER BY INCP.VALID_UNTIL DESC LIMIT 1";

	    $rs = ClxCommon::$db->executeQuery($sql);
	    if (ISSET($_GET['VER'])){
		pre($sql);
	    }
	    if (($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) == true) {
		if ($r['RETENCION_NO'] == '') {
		    if ($r['INV_NUMBER'] == '' or $r['LAST_INV_NUMBER'] == '' or $r['INV_SERIE_TO'] == '' or $r['CLX_AUTH_STATUS']!='AP' or $r['ADDRESS']=='' or $r['EMAIL']=='') {
			$msg['template'] = smsg('MSG-537'); //'Falta información para generar facturación de este contrato';
		    } else if ($r['VALID_UNTIL'] < date('Y-m-d')) {
			$msg['template'] = smsg('MSG-538'); //'Se ha superado el tope de fecha válido';
		    } else if ($r['VALID_UNTIL'] < $r['INVOICEDATE']) {
			$msg['template'] = smsg('MSG-539'); //'La fecha de la factura es mayor que el rango válido de fecha';
		    } else if ($r['LAST_INV_NUMBER'] + 1 > $r['INV_SERIE_TO']) {
			$msg['template'] = smsg('MSG-519'); //'Número de Factura fuera de rango de emisión';
		    } else {
			$pad = str_pad($r['LAST_INV_NUMBER'] + 1, 6, "0", STR_PAD_LEFT);
			$fac = $r['INV_NUMBER'] . $pad;
			$sql = "UPDATE {$this->incpname} SET LAST_INV_NUMBER=LPAD(LAST_INV_NUMBER+1,6,'0') where id={$r['INCP_ID']} and CLX_AUTH_STATUS='AP' and LAST_INV_NUMBER={$r['LAST_INV_NUMBER']}  and LAST_INV_NUMBER={$r['LAST_INV_NUMBER']} and INV_TYPE='$type' and ID={$r['INCP_ID']};";
			ClxCommon::$db->executeQuery($sql);
			$sql = "UPDATE {$this->apinname} APIN SET RETENCION_NO='{$fac}' where id={$idlist[0]} and exists(
				    SELECT 1 FROM {$this->incpname} INCP WHERE  INV_TYPE='$type' AND 
				    APIN.CHART_FIELD01=INCP.CHART_FIELD01 AND APIN.COMP_CODE=INCP.COMP_CODE AND 
				    INCP.LAST_INV_NUMBER='$pad' and INCP.ID={$r['INCP_ID']});";
			ClxCommon::$db->executeQuery($sql);
		    }
		}
	    }
	    return $msg;
	}
	
	function print_format($proper_page, $idlist,$type) {
	    //global $db;

	    $callingpage = peekHistory();
	    $idcode = (!empty($callingpage['parentrecord']['INVP_IDCODE'])) ? $callingpage['parentrecord']['INVP_IDCODE'] : 0;

	    if (!class_exists('PDF_Visibility') && file_exists(kPathToFpdf . 'PDF_Visibility.php')) {
            include_once kPathToWebSite . kPathToFpdf . 'PDF_Visibility.php';
        }
		//require_once kPathToWebSite . 'classes/fpdf_current/PDF_Visibility.php';
	    $record = $_POST;

	    if ($type=='01') {
		$result = $this->queryFactura($record, toString($idlist));
	    }	
	    else if ($type=='03') {
		$result = $this->queryAlquiler($record, toString($idlist));
	    }
    	else if ($type=='05') {
		$result = $this->queryRetencion($record, toString($idlist));
	    }

	    $record = array();
	    while (($r = ClxCommon::$db->getNextRecord($result, ASSOCIATIVE)) == true) {
		$record[] = $r;
	    }
	    //print_r($record);
		if (ISSET(UserRequest::$get["VER"])) {
		pre($record);
	    }

	    //print_r($record);
	    if (empty($record)) {
		echo "not option print";
		return;
	    }

	    $sql = "SELECT
			INPD.PAGE_NUMBER INPD_PAGE_NUMBER,
			INPD.IDNAME INPD_IDNAME,
			INPD.IDFIELD_INV IDFIELD_INV,
			(select ITEM.IDNAME from CLX_DB_LIST_ITEMS ITEM where
			    INPD.IDFIELD_INV=ITEM.IDCODE AND ITEM.LISTCODE ='INPF') INPD_FIELDNAME,
			INPD.IDNAME2 INPD_IDNAME2,
			INPD.ENABLED INPD_ENABLED,
			INPD.POSITION_PX_X INPD_POSITION_PX_X,
			INPD.POSITION_PX_Y INPD_POSITION_PX_Y,
			INPD.X_TOTAL INPD_X_TOTAL,
			INPD.Y_TOTAL INPD_Y_TOTAL,
			INPD.ALIGN INPD_ALIGN,
			INPD.ENCLOSE INPD_ENCLOSE,
			INPD.ALIGN INPD_ALIGN,
			INPD.FONT_SIZE INPD_FONT_SIZE,
			INPD.FONT_TYPE INPD_FONT_TYPE,
			INPD.FONT_COLOR INPD_FONT_COLOR,
			INPD.FONT_FILL INPD_FONT_FILL,
			INPD.ENCLOSE INPD_ENCLOSE,
			INPD.SECTOR_FIELD INPD_SECTOR_FIELD,
			INPD.ROW_SEPARATION INPD_ROW_SEPARATION,
			INPD.REPEAT_FIELD INPD_REPEAT_FIELD,
			INPD.WORDWRAP INPD_WORDWRAP,
			INPD.WRAP_SEPARATION INPD_WRAP_SEPARATION,
			INPD.ROW_SEPARATION INPD_ROW_SEPARATION,
			INPD.FORMULA INPD_FORMULA,
			INPD.DETFIELD INPD_DETFIELD,
			INPD.WIDTH INPD_SIZECELL,
			INPD.HEIGHT INPD_HEIGHTCELL,
			INPD.FORMAT_PRINT INPD_FORMAT_PRINT,
			INPD.ENABLED INPD_ENABLED,
			INPD.DISABLEDFILL INPD_DISABLEDFILL,
			INPD.STRINGPOSITION INPD_STRINGPOSITION,
			INPD.SIZE_LENGTH INPD_SIZE_LENGTH,
			INPD.PRETEXT INPD_PRETEXT
			FROM
			    $this->inpdname INPD 
			WHERE INPD.IDDETAIL='" . $proper_page["ID"] . "'
			ORDER BY
			    INPD.PAGE_NUMBER ASC,
    			    INPD.POSITION_PX_Y ASC,
			    INPD.POSITION_PX_X ASC ";
	    $rs = ClxCommon::$db->executeQuery($sql);
	    $optionsPrint = array();
	    while (($rec = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) == true) {
		$max = 1;
		$rec["INPD_FONT_COLOR"] = array(hexdec(substr($rec["INPD_FONT_COLOR"], 1, 2)),
		    hexdec(substr($rec["INPD_FONT_COLOR"], 3, 2)),
		    hexdec(substr($rec["INPD_FONT_COLOR"], 5, 2)));
		$rec["INPD_FONT_FILL"] = array(hexdec(substr($rec["INPD_FONT_FILL"], 1, 2)),
		    hexdec(substr($rec["INPD_FONT_FILL"], 3, 2)),
		    hexdec(substr($rec["INPD_FONT_FILL"], 5, 2)));
		if ($rec["INPD_SECTOR_FIELD"] == '2') {
		    $max = $rec["INPD_REPEAT_FIELD"];
		    for ($t = 1; $t <= $max; $t++) {
			$temp = $rec;
			$temp["INPD_IDNAME2"] = $temp["INPD_IDNAME2"] . str_pad($t, 2, "0", STR_PAD_LEFT);
			$temp["INPD_POSITION_PX_Y"] = $temp["INPD_POSITION_PX_Y"] + $temp["INPD_ROW_SEPARATION"] * ($t - 1);
			$optionsPrint[] = $temp;
		    }
		} else {
		    if ($rec["INPD_SECTOR_FIELD"]==0) 
			$rec["INPD_VALUE"]=$rec["INPD_IDNAME2"];
		    $optionsPrint[] = $rec;
		}

	    }
	    /* if ($_SERVER['REMOTE_ADDR']=='201.208.246.66' and isset($_GET["VER"])) {
	      pre($optionsPrint);
	      die;
	      } */
		//print_r($optionsPrint);
	    if (empty($optionsPrint)) {
		echo "no hay opciones";
		return;
	    }

	    $unit = $proper_page['UNIT'];


	    //    $pdf = new FPDF($proper_page["GUIDANCE_PAPER"],$proper_page['UNIT'], array($proper_page['HEIGHT'],$proper_page['WIDTH']));

    	    if ($unit == 'pt')
		$k = 1;
	    elseif ($unit == 'mm')
		$k = 72 / 25.4;
	    elseif ($unit == 'cm')
		$k = 72 / 2.54;
	    elseif ($unit == 'in')
		$k = 72;
	 //   pre($k)
	    /*/echo $proper_page['HEIGHT']*$k*105/72;
	    echo ",";
	    echo $proper_page['WIDTH']*$k*105/72;
	    die;*/
	    $pdf = new PDF_Visibility($proper_page["GUIDANCE_PAPER"], 'pt'/*$proper_page['UNIT']*/, array($proper_page['HEIGHT']*$k*105/72 , $proper_page['WIDTH']*$k));

	    $pdf->SetMargins($proper_page["IMG_X"], $proper_page["IMG_Y"]);

	    //$db->updateRecord($this->fiatname, array('CHECK_PRINT_DATI' => $this->now,
	    //    'CHECK_PRINT_BY' => $_SESSION['user_record']['username']), "ID = $transid");

	    $page = -1;
	    //$imagenes = array('FRONT_IMG', 'BACK_IMG');
	    $imagenes = array('FILE_DIR');


	    //PRE($optionsPrint);
	    if (ISSET($_GET["VER"])) {
		pre($optionsPrint);

	    }	

	    $this->format($record, $optionsPrint);
	    $resolucionimagen = 96;
	    $resolucionimpresion = 72;
	    if (ISSET($_GET["VER"])) {
		pre($optionsPrint);
	    }	
	    foreach ($optionsPrint as $opt) {
		/* if ($opt["IDFIELD_INV"]=="INV_C_NMBR") {
		  ECHO 'ACA';
		  } */
		if ($opt["INPD_ENABLED"] && isset($opt["INPD_VALUE"])) {
		    /* if ($opt["IDFIELD_INV"]=="INV_C_NMBR") {
		      ECHO 'ACA2';
		      } */

		    if ($page <> $opt["INPD_PAGE_NUMBER"]) {
			$pdf->AddPage();
			if ($proper_page["PRN_IMG_BACK"] != 'YES') {
			    $pdf->SetVisibility('screen');
			}
			$OBJS = &getTool('OBJS');
			$page = $opt["INPD_PAGE_NUMBER"];
			$fieldinstance = getToolObject('DBFT', 'FILE');
			$filename = $fieldinstance->fileName($proper_page[$imagenes[$page - 1]]);
			$pdf->Image($filename, 0, 7, $proper_page['WIDTH']*$k,  $proper_page['HEIGHT']*$k);
			$pdf->SetVisibility('all');
		    }
		    $resolutionfont=(int) ($opt["INPD_FONT_SIZE"] / $resolucionimagen * $resolucionimpresion);
		      if (trim($opt["INPD_FONT_TYPE"])=='Arial b')
			$pdf->SetFont('Arial', 'B', $resolutionfont);
		    else 
			$pdf->SetFont($opt["INPD_FONT_TYPE"], '', $resolutionfont);
		    $pdf->SetTextColor($opt["INPD_FONT_COLOR"][0], $opt["INPD_FONT_COLOR"][1], $opt["INPD_FONT_COLOR"][2]);
		    IF ($opt["INPD_STRINGPOSITION"] == 'RIGHT') {
			$opt["INPD_VALUE"] = SUBSTR($opt["INPD_VALUE"], - $opt["INPD_SIZE_LENGTH"], $opt["INPD_SIZE_LENGTH"] + 1);
		    } else if ($opt["INPD_STRINGPOSITION"] == 'LEFT') {
			$opt["INPD_VALUE"] = SUBSTR($opt["INPD_VALUE"], 0, $opt["INPD_SIZE_LENGTH"]);
		    }
		    $opt["INPD_VALUE"] = $opt["INPD_PRETEXT"] . " " . $opt["INPD_VALUE"];
		    if ($opt["INPD_WORDWRAP"]==0) {
			$maxlinea=1;
			$opt["INPD_WORDWRAP"]=1000000000;
		    }	
		    else {
			$maxlinea=strlen($opt["INPD_VALUE"])/$opt["INPD_WORDWRAP"]+1;
		    }
		    if ($opt["INPD_ROW_SEPARATION"]>$resolutionfont)
			$resolutionfont=$opt["INPD_ROW_SEPARATION"];
		    for ($linea=0;$linea<$maxlinea;$linea++){
			$pdf->SetXY(( ($opt["INPD_POSITION_PX_X"] / $resolucionimagen * $resolucionimpresion )),($linea)*($resolutionfont+1.1)+ ( ($opt["INPD_POSITION_PX_Y"]  / $resolucionimagen * $resolucionimpresion )));
			$vtext=trim(substr($opt["INPD_VALUE"],$linea*$opt["INPD_WORDWRAP"],$opt["INPD_WORDWRAP"]));
			$pdf->Cell(($opt["INPD_SIZECELL"] / $resolucionimagen * $resolucionimpresion), ($opt["INPD_HEIGHTCELL"]  / $resolucionimagen * $resolucionimpresion), $vtext , 0, 1, $opt["INPD_ALIGN"], $opt["INPD_DISABLEDFILL"] != 'YES');
		    }	
		}
	    }
	    $pdf->Output();
	    die();
	}
	
	function queryFactura($record, $id) {

	    $id = ($id > 0) ? " AND INVO.ID=$id" : " ORDER BY INVO.IDCODE DESC LIMIT 1";

	    //global $db;
	    $sql = "	DROP TEMPORARY TABLE IF EXISTS INVOICE_TEMP;";
	    ClxCommon::$db->executequery($sql);
	    $sql = "	DROP TEMPORARY TABLE IF EXISTS INVOICE_TEMP2;";
	    ClxCommon::$db->executequery($sql);
	    $sql = "	DROP TEMPORARY TABLE IF EXISTS INCP_TEMP;";
	    ClxCommon::$db->executequery($sql);


	    $sql = "CREATE TEMPORARY TABLE INCP_TEMP AS SELECT 
			FICO.IDNAME nombre_empresa,
			FICO.TAXID IDENTICATION2,
			INVO.INVOICE_NO INVOICE_NO,
			INVO.ID,
			INCP.ID INCP_ID,
			INCP.PHONE PHONE2,
			INCP.ADDRESS ADDRESS2,
			INCP.COMPANY,
			INCP.EMAIL,
			INCP.CHART_FIELD01,
			INCP.INV_NUMBER,
			INCP.LAST_INV_NUMBER,
			concat(INCP.INV_NUMBER,INCP.INV_SERIE_FROM) INV_SERIE_FROM,
			concat(INCP.INV_NUMBER,INCP.INV_SERIE_TO)INV_SERIE_TO,
			INCP.VALID_UNTIL,
			INCP.INV_CAI_NUMBER

			FROM 
			$this->invoname INVO
			LEFT JOIN $this->ficoname FICO ON FICO.IDCODE = INVO.CHART_FIELD01
			LEFT JOIN $this->compname COMP ON COMP.IDCODE = FICO.COMP_CODE		
			LEFT JOIN $this->incpname INCP ON  INCP.COMP_CODE = INVO.COMP_CODE AND FICO.IDCODE = INCP.CHART_FIELD01
			WHERE 
			 INCP.CLX_EFFTDATE = (SELECT MAX(INCPX.CLX_EFFTDATE) 
			FROM $this->incpname INCPX
			WHERE INCPX.COMP_CODE = INVO.COMP_CODE
				AND INCPX.CHART_FIELD01 = INCP.CHART_FIELD01
				AND INCPX.CLX_EFFTDATE <= INVO.INVOICEDATE 
				AND INCPX.INV_TYPE = INCP.INV_TYPE)
				AND INCP.INV_TYPE = '01'
			".
				 $id
			;
		//print_r($sql);
		ClxCommon::$db->executequery($sql);



	//    pre($sql);

//		$rsa = $db->executeQuery('select * from INCP_TEMP');
	    $optionsPrint = array();  
//		while (($reca = $db->getNextRecord($rsa)) == true) {
//			PRE($reca);
//		}
if ( isset(UserRequest::$get["VER"])) {
		PRE($sql);
	    }

	    $sql = "CREATE TEMPORARY TABLE INVOICE_TEMP AS
		SELECT 	INVO.COMP_CODE,
			INVO.CURRENCY_CODE,
			INVO.ID INVOID,
			INVO.IDCODE IDCODE,
			INVO.IDNAME IDNAME,
			INVO.JEHDR_CODE,
			INVO.INVOICEDATE EFFTDATE,
			INVO.ACCOUNTCODE ACCOUNTCODE,
			INVO.DEBTOR_FICO_CODE,
			INVO.INVOICE_AMT,
			INVO.CHART_FIELD01,
			INVO.CHART_FIELD02,
			INVO.CLX_AUTH_STATUS CLX_AUTH_STATUS,
			INVO.INVOICEDATE INVOICEDATE,   
			INVO.AR_ITEM_CODE AR_ITEM_CODE,
			INVO.AR_AMORT_METHOD AR_AMORT_METHOD,
			INVO.MODIFIEDBY MODIFIEDBY,
			INVO.ID ID,
			INVO.RESTRICTED ,
			INVL.QUANTITY,
			INVL.PRICE,
			INVL.LINE_TOTAL,
			JEIT.IDNAME DESCRIPTION,
			INVL.ITEM_CODE,
			INVL.CHART_FIELD03,
			INVL.CHART_FIELD04,
			INVL.GLACCOUNTCODE,
			INVL.INVOICECODE,
			JEIT.CLX_EFFTDATE
              FROM	$this->invoname INVO 
		  JOIN	    $this->invlname INVL 
		  on	    INVL.INVOICECODE =INVO.IDCODE
              JOIN        $this->jeitname JEIT
                   ON	    JEIT.IDCODE = INVL.ITEM_CODE	

		    WHERE COALESCE(JEIT.TAX_TYPE,'')<>'IVA' AND
		    INVO.CLX_AUTH_STATUS = 'AP' 
		    AND INVO.RESTRICTED = 0 

		    AND JEIT.CLX_EFFTDATE = (SELECT MAX(JEITX.CLX_EFFTDATE)
			    FROM GL_ITEM_TBL JEITX
			    WHERE JEITX.IDCODE = JEIT.IDCODE
			    AND JEITX.CLX_EFFTDATE <= INVO.INVOICEDATE

		    ) $id
		     ";
			 //print_r($sql);
		if ( isset(UserRequest::$get["VER"])) {
		PRE($sql);
	    }
	    ClxCommon::$db->executequery($sql);
	    //pre($sql);

	    $sql = "CREATE TEMPORARY TABLE INVOICE_TEMP2 AS
		SELECT 	INVO.ID,
			COALESCE(INVL.PRICE,0) TAXABLE_AMT

              FROM	$this->invoname INVO 
		  JOIN	    $this->invlname INVL 
		  on	    INVL.INVOICECODE =INVO.IDCODE
              JOIN        $this->jeitname JEIT
                   ON	    JEIT.IDCODE = INVL.ITEM_CODE	

		    WHERE COALESCE(JEIT.TAX_TYPE,'')='IVA' AND
		    INVO.CLX_AUTH_STATUS = 'AP' 
		    AND INVO.RESTRICTED = 0 

		    AND JEIT.CLX_EFFTDATE = (SELECT MAX(JEITX.CLX_EFFTDATE)
			    FROM GL_ITEM_TBL JEITX
			    WHERE JEITX.IDCODE = JEIT.IDCODE
			    AND JEITX.CLX_EFFTDATE <= INVO.INVOICEDATE

		    ) 	    $id
		     ";//echo($sql);
	    ClxCommon::$db->executequery($sql);
	    if ( isset(UserRequest::$get["VER"])) {
		PRE($sql);
	    }

	    //pre($sql);


	    $sql = "SELECT
			INVO.COMP_CODE,
			INVO.CURRENCY_CODE,

			INVO.INVOID INVOID,
			INVO.IDCODE IDCODE,
			INVO.IDNAME IDNAME,
			INVO.JEHDR_CODE,
			INVO.INVOICEDATE EFFTDATE,
			INVO.ACCOUNTCODE ACCOUNTCODE,
			INVO.DEBTOR_FICO_CODE,
			IFNULL(ACCO.LEGAL_NAME, ACCO.IDNAME) LEGAL_NAME,
			IFNULL((SELECT IFNULL(CONCAT_WS(' ', ACCO.ADDRESS1, ACCO.ADDRESS2),CONCAT_WS(' ',ACCO.ADDRESS1_02, ACCO.ADDRESS2_02)) ADDRESS FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE = INVO.ACCOUNTCODE),'') ADDRESS1,
			IFNULL(ACCO.STATE,'') STATE,
			IFNULL(ACCO.COUNTRY,'') COUNTRY,   

			/*IVA SI EN EN LA LINEA*/
			INVO.INVOICE_AMT-COALESCE(INVO2.TAXABLE_AMT,0)  BASE_TOTAL_AMT,
			COALESCE(INVO2.TAXABLE_AMT,0) TAXABLE_AMT,
			INVO.INVOICE_AMT,
			    
    			IFNULL(CONCAT_WS(' ', ACCO.ADDRESS1, ACCO.ADDRESS2), CONCAT_WS(' ',ACCO.ADDRESS1_02, ACCO.ADDRESS2_02)) ADDRESS3,
			IFNULL(ACCO.STATE,'') STATE,
			IFNULL(ACCO.COUNTRY,'') COUNTRY,
			INVO.CLX_AUTH_STATUS CLX_AUTH_STATUS,
			INVO.INVOICEDATE INVOICEDATE,   

			INVO.AR_ITEM_CODE AR_ITEM_CODE,
			INVO.AR_AMORT_METHOD AR_AMORT_METHOD,
			IFNULL(ACCO.PHONE, ACCO.HOME_PHONE) HOME_PHONE,
			INVO.MODIFIEDBY MODIFIEDBY,
			IFNULL(FICO.CONTRACT_NUMBER,'') CONTRACT_NUMBER,
			IFNULL(FICO.IDNAME,'') FICO_IDNAME,
			IFNULL(ACCO.CITY, '') CITY,
			IFNULL(ACCO.IDENTIFICATION, '') IDENTIFICATION,
			INVO.QUANTITY,
			INVO.PRICE,
			INVO.DESCRIPTION,
			INVO.LINE_TOTAL,
			INVO.ITEM_CODE,
			INVO.CHART_FIELD03,
			INVO.CHART_FIELD04,
			INVO.GLACCOUNTCODE,
			INCP.IDENTICATION2,
			INCP.INVOICE_NO,
			INCP.PHONE2,
			INCP.ADDRESS2,
			INCP.COMPANY,
			INCP.EMAIL,
			INCP.CHART_FIELD01,
			INCP.INV_NUMBER,
			INCP.LAST_INV_NUMBER,
			INCP.INV_SERIE_FROM,
			INCP.INV_SERIE_TO,
			INCP.VALID_UNTIL,
			INCP.INV_CAI_NUMBER
			
      FROM
				$this->ficoname FICO 
				join	    INVOICE_TEMP INVO
				    on	    FICO.IDCODE = INVO.CHART_FIELD01
				    
				join	    $this->acconame ACCO 
				    on	    ACCO.IDCODE = INVO.CHART_FIELD02
				left join 	    INVOICE_TEMP2 INVO2
				    on INVO.ID=INVO2.ID
				left join   INCP_TEMP INCP 
				    on	    INVO.ID=INCP.ID
			
		";//print_r($sql);
	    if ( isset(UserRequest::$get["VER"])) {
		PRE($sql);
	    }
	    $result = ClxCommon::$db->executequery($sql);

	    return $result;
	}	

	function queryAlquiler($record, $id) {
	    //global $db;
	    $id1 = ($id > 0) ? " AND FIAT.ID=$id" : " ORDER BY FIAT.IDCODE DESC LIMIT 1";


	    $sql = "DROP TEMPORARY TABLE IF EXISTS INCP_TEMP;";
	    ClxCommon::$db->executequery($sql);


	    $sql = "CREATE TEMPORARY TABLE INCP_TEMP AS
		SELECT 
			FIAT.ID,
			FICO.IDCODE,
			FICO.IDNAME nombre_empresa,
			FICO.TAXID IDENTICATION2,
			INCP.PHONE PHONE2,
			INCP.ADDRESS ADDRESS2,
			INCP.COMPANY,
			INCP.EMAIL,
			INCP.CHART_FIELD01,
			INCP.INV_NUMBER,
			INCP.LAST_INV_NUMBER,
			CONCAT(INCP.INV_NUMBER,INCP.INV_SERIE_FROM) INV_SERIE_FROM,
			CONCAT(INCP.INV_NUMBER,INCP.INV_SERIE_TO)INV_SERIE_TO,
			INCP.VALID_UNTIL,
			INCP.INV_CAI_NUMBER
			FROM 
			    $this->incpname INCP, 
			    $this->fiatname FIAT,
			    $this->ficoname FICO,
			    $this->compname COMP

			WHERE 
			    COMP.IDCODE = FICO.COMP_CODE
			    AND FICO.IDCODE = FIAT.CHART_FIELD01
			    AND INCP.COMP_CODE = FIAT.COMP_CODE
			   AND FICO.IDCODE = INCP.CHART_FIELD01
			  AND INCP.CLX_EFFTDATE = (SELECT MAX(INCPX.CLX_EFFTDATE) 
			FROM BILL_INV_CONTRACT_PROPS INCPX
			WHERE INCPX.COMP_CODE = FIAT.COMP_CODE
				AND INCPX.CHART_FIELD01 = INCP.CHART_FIELD01
				AND INCPX.CLX_EFFTDATE <= FIAT.EFFTDATE
				AND INCPX.INV_TYPE = INCP.INV_TYPE)
				AND INCP.INV_TYPE = '03'
				$id1
			";
	    ClxCommon::$db->executequery($sql);

	    if ( isset($_GET["VER"])) {
		PRE($sql);
	    }

	    $sql = "	
		SELECT 
		      IFNULL(ACCO.LEGAL_NAME, ACCO.IDNAME) LEGAL_NAME,
					IFNULL((SELECT IFNULL(CONCAT_WS(' ', ACCO.ADDRESS1, ACCO.ADDRESS2),CONCAT_WS(' ',ACCO.ADDRESS1_02, ACCO.ADDRESS2_02)) ADDRESS FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE = AAGR.CONTRACTEE_CODE),'') ADDRESS1,
					IFNULL(ACCO.STATE,'') STATE,
					IFNULL(ACCO.COUNTRY,'') COUNTRY,   
			IFNULL(CONCAT_WS(' ', ACCO.ADDRESS1, ACCO.ADDRESS2), CONCAT_WS(' ',ACCO.ADDRESS1_02, ACCO.ADDRESS2_02)) ADDRESS3,
					IFNULL(ACCO.STATE,'') STATE,
					IFNULL(ACCO.COUNTRY,'') COUNTRY,
					IFNULL(ACCO.PHONE, ACCO.HOME_PHONE) HOME_PHONE,
					IFNULL(FICO.CONTRACT_NUMBER,'') CONTRACT_NUMBER,
					IFNULL(FICO.IDNAME,'') FICO_IDNAME,
					IFNULL(ACCO.CITY, '') CITY,
					IFNULL(ACCO.IDENTIFICATION, '') IDENTIFICATION,
					INCP.IDENTICATION2,
					INCP.PHONE2,
					INCP.ADDRESS2,
					INCP.COMPANY,
					INCP.EMAIL,
					INCP.CHART_FIELD01,
					INCP.INV_NUMBER,
					INCP.LAST_INV_NUMBER,
					INCP.INV_SERIE_FROM,
					INCP.INV_SERIE_TO,
					INCP.VALID_UNTIL,
					INCP.INV_CAI_NUMBER,  
		      AAGR.ASSETCODE,
		      AAGR.AGREEMNT_CLASS,
		      AAGR.AGREEMNT_TYPE,
		      AAGR.AGREEMENT_AMT,
		      AAGR.GUARANTEE_AMT,
		      AAGR.FEES_AMT,
		      AAGR.INSURANCE_AMT,
		      AAGR.PAYMENT_FREQ,
		      AAGR.CURRENCY_CODE,
		      FIAT.IDNAME DESCRIPTION,
		      FIAT.REAL_DATE,
		      FIAT.RENTAL_NO,
		      FIAT.FISCAL_PERIOD,
		      FIAT.LGGROUP_CODE,
		      FIAT.TRANSTBL_CODE,
		      FIAT.CURRENCY_CODE,
		      FIAT.EXCHANGE_RT,
		      FIAT.CUR_OPERATOR,
		      FIAT.ITEM_REF_NO,
		      FIAT.TRANS_AMT,
		      FIAT.TAXABLE_AMT,
		      FIAT.JE_SOURCE,
		      FIAT.REQ_CHANNEL


		FROM 
		  $this->ficoname FICO,
		  $this->aagrname AAGR,
		  $this->acconame ACCO,
		  $this->fiasname FIAS,
		  $this->fiatname FIAT left join
		  INCP_TEMP INCP on INCP.ID=FIAT.ID 
		WHERE
		  FICO.IDCODE = AAGR.CHART_FIELD01
		  AND ACCO.IDCODE = AAGR.CONTRACTEE_CODE
		  AND FIAS.CONTRACT_CODE = AAGR.CHART_FIELD01
		  AND FIAS.ASSET_CODE = AAGR.ASSETCODE
		  AND FIAT.CHART_FIELD03 = FIAS.IDCODE
		  AND FIAT.ITEM_REF_NO = AAGR.IDCODE
		  AND AAGR.CLX_EFFTDATE = (SELECT MAX(AAGRX.CLX_EFFTDATE) FROM AMGT_AGREEMENTS AAGRX WHERE AAGRX.IDCODE = AAGR.IDCODE AND AAGRX.CLX_EFFTDATE<=FIAT.EFFTDATE)
		  $id1
		";
		if ( isset($_GET["VER"])) {
		    PRE($sql);
		}

	    $result = ClxCommon::$db->executequery($sql);
	    return $result;
	}
	
	function queryRetencion($record, $id) {

	    $id = ($id > 0) ? " AND APIN.ID=$id" : " ORDER BY APIN.IDCODE DESC LIMIT 1";

	    //global $db;
	    $sql = "DROP TEMPORARY TABLE IF EXISTS INCP_TEMP;";
	    ClxCommon::$db->executequery($sql);


	    $sql = "CREATE TEMPORARY TABLE INCP_TEMP AS SELECT 
			FICO.IDNAME nombre_empresa,
			FICO.TAXID IDENTICATION2,
			APIN.ID,
			INCP.PHONE PHONE2,
			INCP.ADDRESS ADDRESS2,
			INCP.COMPANY,
			INCP.EMAIL,
			INCP.CHART_FIELD01,
			INCP.INV_NUMBER,
			INCP.LAST_INV_NUMBER,
			concat(INCP.INV_NUMBER,INCP.INV_SERIE_FROM) INV_SERIE_FROM,
			concat(INCP.INV_NUMBER,INCP.INV_SERIE_TO)INV_SERIE_TO,
			INCP.VALID_UNTIL,
			INCP.INV_CAI_NUMBER

			FROM 
			    $this->incpname INCP, 
			    $this->apinname APIN,
			    $this->ficoname FICO,
			    $this->compname COMP
			WHERE 
			    COMP.IDCODE = FICO.COMP_CODE
			    AND FICO.IDCODE = APIN.CHART_FIELD01
			    AND INCP.COMP_CODE = APIN.COMP_CODE
			AND FICO.IDCODE = INCP.CHART_FIELD01
			AND INCP.CLX_EFFTDATE = (SELECT MAX(INCPX.CLX_EFFTDATE) 
			FROM $this->incpname INCPX
			WHERE INCPX.COMP_CODE = APIN.COMP_CODE
				AND INCPX.CHART_FIELD01 = INCP.CHART_FIELD01
				AND INCPX.CLX_EFFTDATE <= APIN.INVOICEDATE 
				AND INCPX.INV_TYPE = INCP.INV_TYPE)
				AND INCP.INV_TYPE = '05'
				$id
			";
	    ClxCommon::$db->executequery($sql);
	    //print_r($sql);

	    if ( isset($_GET["VER"])) {
		PRE($sql);
	    }
	    //pre($sql);


	    $sql = "SELECT
			APIN.COMP_CODE,
			APIN.CURRENCY_CODE,
			APIN.IDCODE IDCODE,
			APIN.IDNAME IDNAME,
			APIN.INVOICEDATE,
			APIN.DUE_DATE,
			APIN.CURRENCY_CODE,
			APIN.INVOICE_AMT,
			APIN.GLACCOUNTCODE,
			APIN.AMORTIZATION_AMT,
			APIN.AMORTIZATION_RT,
			APIN.MODIFIEDBY ,
			APIN.CLX_AUTH_STATUS ,
			APIN.RETENCION_NO,
			APIN.INV_CAI_NUMBER_C,
			APIN.INV_NUMBER_C,
			IFNULL(ACCO.LEGAL_NAME, ACCO.IDNAME) LEGAL_NAME,
			IFNULL((SELECT IFNULL(CONCAT_WS(' ', ACCO.ADDRESS1, ACCO.ADDRESS2),CONCAT_WS(' ',ACCO.ADDRESS1_02, ACCO.ADDRESS2_02)) ADDRESS FROM CRM_ACCOUNTS ACCO WHERE ACCO.IDCODE = APIN.VENDOR_CODE),'') ADDRESS1,
			IFNULL(ACCO.STATE,'') STATE,
			IFNULL(ACCO.COUNTRY,'') COUNTRY,   
    			IFNULL(CONCAT_WS(' ', ACCO.ADDRESS1, ACCO.ADDRESS2), CONCAT_WS(' ',ACCO.ADDRESS1_02, ACCO.ADDRESS2_02)) ADDRESS3,
			IFNULL(ACCO.STATE,'') STATE,
			IFNULL(ACCO.COUNTRY,'') COUNTRY,
			IFNULL(ACCO.PHONE, ACCO.HOME_PHONE) HOME_PHONE,
			IFNULL(FICO.CONTRACT_NUMBER,'') CONTRACT_NUMBER,
			IFNULL(FICO.IDNAME,'') FICO_IDNAME,
			IFNULL(ACCO.CITY, '') CITY,
			IFNULL(ACCO.IDENTIFICATION, '') IDENTIFICATION,
			INCP.IDENTICATION2,
			INCP.PHONE2,
			INCP.ADDRESS2,
			INCP.COMPANY,
			INCP.EMAIL,
			INCP.CHART_FIELD01,
			INCP.INV_NUMBER,
			INCP.LAST_INV_NUMBER,
			INCP.INV_SERIE_FROM,
			INCP.INV_SERIE_TO,
			INCP.VALID_UNTIL,
			INCP.INV_CAI_NUMBER,
			ABS(APIL2.LINE_TOTAL)*100/ ABS(APIL.LINE_TOTAL) FLAT_RATE,
			IF(APIL2.DESCRIPTION IS NULL OR APIL2.DESCRIPTION ='',  JEIT2.IDNAME,APIL2.DESCRIPTION) DESCRIPTION ,
			APIL2.QUANTITY,  
			ABS(APIL.LINE_TOTAL) BASE_LINE_AMT,
			ABS(APIL2.LINE_TOTAL) LINE_TOTAL,
			APIL2.SEQNUM,
			APIL2.ITEM_CODE,
			APIL2.CHART_FIELD03,
			APIL2.CHART_FIELD04,
			APIL2.PAYINV_CODE,
			JEIT2.TAX_TYPE


      FROM
				$this->ficoname FICO 
				join  $this->apinname APIN
				    on	    FICO.IDCODE = APIN.CHART_FIELD01
				join	    $this->acconame ACCO 
				    on	    ACCO.IDCODE = APIN.VENDOR_CODE
				left join  $this->apilname APIL
				    on APIN.IDCODE = APIL.PAYINV_CODE
				left join  $this->jeitname JEIT
				    on JEIT.IDCODE = APIL.ITEM_CODE
				left join  $this->apilname APIL2
				    on APIN.IDCODE = APIL2.PAYINV_CODE    
				left join  $this->jeitname JEIT2
				    on JEIT2.IDCODE = APIL2.ITEM_CODE    
				left join   INCP_TEMP INCP 
				    on	    APIN.ID=INCP.ID
				where --JEIT.TAX_TYPE IS NOT NULL AND /*ISLR TAL VEZ PARA OBTENER SOLO LAS LINEAS DE IMPUESTO*/
				      JEIT2.TAX_TYPE IS NOT NULL 	
				      AND APIN.CLX_AUTH_STATUS = 'AP'    

				$id";

	    //print_r($sql);
		if ( isset($_GET["VER"])) {
		PRE($sql);
	    }
	    $result = ClxCommon::$db->executequery($sql);
	    return $result;
	}
	
	function format(&$trecord, &$optionsPrint) {
	    //global $db;
	    /* 	    $trecord[] =$trecord[0];
	      $trecord[] =$trecord[0];
	      $trecord[] =$trecord[0];
	      $trecord[] =$trecord[0];
	      $trecord[] =$trecord[0];
	      $trecord[] =$trecord[0];
	      $trecord[] =$trecord[0];
	      $trecord[] =$trecord[0];
	      $trecord[] =$trecord[0];
	      $trecord[] =$trecord[0];
	      $trecord[] =$trecord[0];
	     */
	    $d = 0;

	    foreach ($trecord as $record) {
		//pre($record);
		$d++;
		$key=array_keys($record);
		for ($k = 0; $k < count($optionsPrint); $k++) {
		    $r = &$optionsPrint[$k];
		    if (empty($r["INPD_FIELDNAME"]))
			continue;
		    //   echo "<BR>", $r["INPD_FIELDNAME"],",";
		    if (isset(UserRequest::$get["VER"])) {
			PRE($r["INPD_FIELDNAME"]);
		    }
		    $r["INPD_FIELDNAME"] = strtoupper(dict($r["INPD_FIELDNAME"]));
		    if (isset(UserRequest::$get["VER"])) {
			PRE(dict($r["INPD_FIELDNAME"]));
		    }
		    $si = false;
		    if ( in_array($r["INPD_FIELDNAME"],$key)) {
			if ($r["INPD_IDNAME"] . str_pad($d, 2, "0", STR_PAD_LEFT) == $r["INPD_IDNAME2"]) {
			    $si = true;
			    $field = "INPD_IDNAME";
			} else if ($r["INPD_IDNAME"] == $r["INPD_IDNAME2"]) {
			    $si = true;
			    $field = "INPD_IDNAME";
			}
		    }

		    if ($si) {
			//	echo "x,<br>";
			//		echo $r["INPD_IDNAME"],"<br>";
			if ($r["INPD_FORMAT_PRINT"] == ',' OR $r["INPD_FORMAT_PRINT"] == '') {
			    $r["INPD_VALUE"] = $record[$r["INPD_FIELDNAME"]];
			} else if ($r["INPD_FORMAT_PRINT"] == "Text(--)") {
			    $str = '---';
			    $r["INPD_VALUE"] = $str . " " . $record[$r["INPD_FIELDNAME"]] . " " . $str;
			} else {
			    $fieldrec = ClxCommon::$db->getRecord("CLX_DB_FIELDS", "FIELDNAME='" . $r["INPD_FIELDNAME"] . "'");
			    //		    ECHO "-", $fieldrec["FIELDTYPE"],"<BR>";
			    if ($fieldrec["FIELDTYPE"] == 'DATE') {
				$lang=getCurrentLanguage();
				if (substr($lang,0,2)=='es')
				    setlocale(LC_ALL, 'es_ES');
				$formatvalue = array("d", "F", "m", "Y", "d/m/y", "d-m-Y", "Y-m-d", "Y/m/d", "m-d-Y", "m/d/Y");

				if (in_array($r["INPD_FORMAT_PRINT"], $formatvalue)) {
				    $r["INPD_VALUE"] = date($r["INPD_FORMAT_PRINT"], strtotime($record[$r["INPD_FIELDNAME"]]));
				}
				if ($r["INPD_FORMAT_PRINT"] == 'F')
				    $r["INPD_VALUE"] = dict("GEN_LBL_" . trim(strtoupper($r["INPD_VALUE"])));
			    }
			    else if ($fieldrec["FIELDTYPE"] == 'DECN' or $fieldrec["FIELDTYPE"] == 'INTN') {
				$str = '';
				//			echo $r["INPD_FORMAT_PRINT"];
				switch ($r["INPD_FORMAT_PRINT"]) {
				    case "*9,999*":
					$str = '*';
				    case "9,999":

					$r["INPD_VALUE"] = $str . " " . number_format($record[$r["INPD_FIELDNAME"]], 0, ".", ",") . " " . $str;
					break;

				    case "*9.999*":
					$str = '*';
				    case "9.999":
					$r["INPD_VALUE"] = $str . " " . number_format($record[$r["INPD_FIELDNAME"]], 0, ",", ".") . " " . $str;
					break;
				    case "*9,999.99*":
					$str = '*';
				    case "9,999.99":
					$r["INPD_VALUE"] = $str . " " . number_format($record[$r["INPD_FIELDNAME"]], 2, ".", ",") . " " . $str;
					break;
				    case "*9.999,99*":
					$str = '*';
				    case "9.999,99":
					$r["INPD_VALUE"] = $str . " " . number_format($record[$r["INPD_FIELDNAME"]], 2, ",", ".") . " " . $str;
					break;
				    case "*9999,99*":
					$str = '*';
				    case "9999,99":
					$r["INPD_VALUE"] = $str . " " . number_format($record[$r["INPD_FIELDNAME"]], 2, ",", "") . " " . $str;
					break;
				    case "*9999.99*":
					$str = '*';
				    case "9999.99":
					$r["INPD_VALUE"] = $str . " " . number_format($record[$r["INPD_FIELDNAME"]], 2, ".", "") . " " . $str;
					break;
				    case "9999":
					$r["INPD_VALUE"] = ((int) $record[$r["INPD_FIELDNAME"]]) . " " . $str;
					break;

				    case "TextEn(--)" :
					$str = '---';
				    case "TextIntege":
					try {

					    $r["INPD_VALUE"] = $str . " " . clx_format_textual($record[$r["INPD_FIELDNAME"]], getCurrentLanguage(), true, true, 0) . " " . $str;
					} catch (Exception $e) {

					}
					break;
				    case "Dec99":
					$r["INPD_VALUE"] = substr((int) ($record[$r["INPD_FIELDNAME"]] * 100), -2);
					break;
				    case "Dec999":
					$r["INPD_VALUE"] = substr((int) ($record[$r["INPD_FIELDNAME"]] * 1000), -3);
					break;
				    case "TextCu":
					$tt = new TextualNumber();
					try {
					    $r["INPD_VALUE"] = $str . " " . clx_format_textual($record[$r["INPD_FIELDNAME"]], getCurrentLanguage(), false, true, 2,$record["CURRENCY_CODE"]) . " " . $str;
					} catch (Exception $e) {
					}
					break;
				    case "TextNu(--)" :
					$str = '---';
				    case "TextNumber":
					$tt = new TextualNumber();
					try {
					    $r["INPD_VALUE"] = $str . " " . clx_format_textual($record[$r["INPD_FIELDNAME"]], getCurrentLanguage(), false, true, 2) . " " . $str;
					} catch (Exception $e) {

					}
					break;
				}
			    } else {
				$r["INPD_VALUE"] = $record[$r["INPD_FIELDNAME"]];
			    }
			}
			/* if ($r["IDFIELD_INV"]=="INV_SR_T") {
			  pre($r);
			  } */
		    } else {

		    }

		    if ($r["INPD_FIELDNAME"] == "QUANTITY") {
			/* echo $optionsPrint[$k]["INPD_VALUE"],",";
			  echo  $r["INPD_VALUE"], ",", $si,",$d,",$r["INPD_FIELDNAME"],",",$r["INPD_IDNAME"],",",$r["INPD_IDNAME2"];
			  DIE; */
		    }
		}
	    }
	    if ( isset(UserRequest::$get["VER"])) {
		PRE($optionsPrint);
		PRE($trecord);
	    }
	}

	function eventoFactura(&$record) {
	    //global $ac;
		$ac = UserRequest::$request['ac'];
	    $callingpage = peekHistory();
	    $record["INPD_FILE_ID"] = $callingpage["parentrecord"]["INVP_FILE_DIR"];
	    $record["INPD_TEMPLATE_TYPE"] = $callingpage["parentrecord"]["INVP_TEMPLATE_TYPE"];
	    $record["INPD_IMG_W"] = $callingpage["parentrecord"]["INVP_IMG_W"];
	    $record["INPD_IMG_H"] = $callingpage["parentrecord"]["INVP_IMG_H"];
	    $record["INPD_DISPLAYJAVASCRIPT"] = ISSET(UserRequest::$post["INPD_DISPLAYJAVASCRIPT"]);
	    $record["INPD_CREATEANDVIEW"] = ($ac == 'MODIFY') ? DICT("UPDATE&VIEW") : DICT("CREATE&VIEW");
	    /*

	      $sql = "SELECT INVP.* FROM $this->invpname INVP WHERE INVP.IDCODE = ".singleQuote($idcode);
	      $rs = $db->executeQuery($sql);
	      $rrecord = $db->getNextRecord($rs,ASSOCIATIVE);
	      $sql= "SELECT FILENAME FROM CLX_SD_FILES WHERE ID='{$rrecord['FILE_DIR']}'";
	      $rs2 = $db->executeQuery($sql);
	      $rrecord2 = $db->getNextRecord($rs2,ASSOCIATIVE);
	      $ppp =$this->ppp($rrecord2["FILENAME"]);
	      $string_content= "   var formatInvoiceGraphics=".(($rrecord["TEMPLATE_TYPE"]==2)?"true":"false"). ";";
	      if($rrecord["TEMPLATE_TYPE"]==2) {
	      $string_content.="   var imp_fondos=['../../window.php?to=SDFL&ac=SHOW_FILE&no_menu=1&no_alerts=1&ff={$rrecord['FILE_DIR']}',
	      '../../window.php?to=SDFL&ac=SHOW_FILE&no_menu=1&no_alerts=1&ff={$rrecord['FILE_DIR']}' ];
	      {$rrecord['IMG_W']},$ppp;
	      var img_w=".((int)($rrecord['IMG_W']*96/2.54)).";
	      var img_h=".((int)($rrecord['IMG_H']*96/2.54)).";";

	      }

	      return setJavaScriptTag($string_content, false); */
	}
	
	function generatelist($record) {
	    //global $db;
	    if (isset(UserRequest::$post["INVP_INV_TYPE"])) {
		if (UserRequest::$post["INVP_INV_TYPE"]=='01') {
			$resource = $this->queryFactura($record, 0);
		}
		else if(UserRequest::$post["INVP_INV_TYPE"]=='03') {
		    $resource = $this->queryAlquiler($record, 0);
		}	
		else if(UserRequest::$post["INVP_INV_TYPE"]=='05') {
		    $resource = $this->queryRetencion($record, 0);
		}	
	    }	
	    $result = ClxCommon::$db->getNextRecord($resource);

	    $str = array("A" => "", "E" => "", "I" => "", "O" => "", "U" => "");
	    foreach ($result as $key => $field) {
		$md5 = md5($key);
		$key2 = $key;
		if (strlen($key2) > 10) {
		    $key2 = $key[0] . strtr(substr($key, 1), $str);
		    //$md5=md5($key);
		}
		if (strlen($key2) > 10)
		    $key2 = substr($key2, 0, 8) . substr($key2, -2);
		$sql = "
			INSERT INTO CLX_DICTIONARY ( `VALUE`, `ENTRY`, `MDATE`, `LANGUAGE`, `ENTRY_VERSION`, `SOURCE_LANGUAGE`) " .
			"select '$key', '$md5', '" . date('Y-m-d') . " 12:00:00', 'es', '0', 'es' from DUAL " .
			"where NOT EXISTS (SELECT 1 FROM CLX_DICTIONARY WHERE /*VALUE='$key' OR*/ ENTRY='$md5');";
		ClxCommon::$db->executequery($sql);
		$sql = "INSERT INTO CLX_DB_LIST_ITEMS ( `LISTCODE`, `IDCODE`, `PARENTITEM`, `IDNAME`, `IDNAME2`, `SEQNUM`, `INACTIVE`) " .
			"SELECT 'INPF', '$key2', '', '$md5', 'D41D8CD98F00B204E9800998ECF8427E',(SELECT MAX(SEQNUM)+1 FROM CLX_DB_LIST_ITEMS WHERE LISTCODE='INPF') , '0' from DUAL " .
			"WHERE NOT EXISTS (SELECT 1 FROM CLX_DB_LIST_ITEMS WHERE LISTCODE='INPF' AND IDCODE='$key2');";
		ClxCommon::$db->executequery($sql);
		$sql = "INSERT INTO CLX_DICTIONARY_HEAP ( `ENTRY`, `VALUE`, `LANGUAGE`) " .
			"SELECT '$md5', '$key', 'es' FROM DUAL " .
			"WHERE NOT EXISTS (SELECT 1 FROM CLX_DICTIONARY_HEAP WHERE ENTRY='$md5' );";
		ClxCommon::$db->executequery($sql);
	    }
	}

    
	
}
