<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-10-15 10:19:43 -0400 (Mon, 15 Oct 2018) $
 * @version        $Rev: 10245 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
if (!class_exists('util') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'util.php';

class util_reset_system  extends util {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'RESY';
        $this->name = 'RESET SYSTEM';
        $this->type = 'UTIL';
        $this->version = '0.1.0.0';
        $this->description = 'Clears Data New Site';
        $this->haspanel = true;
        $this->interface = array(array('name' => 'Reset System',
                'dict' => 'GEN_LBL_RESET_DATA_SYSTEM',
//                'init' => true,
                'init' => false,
                'table' => 'CLX_DB_TABLES',
                'dir' => '',
                'archive' => 'true',
                'tool' => 'DBTB'
            ) 
		);
    }

    function panel($msg) {
		
	    $contents = '';
       //PRE(get_defined_constants());
		$form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->addArgument(CLX_PROP_TO, 'UTIL');
        $form->addArgument('ut', $this->code);	
        $form->addArgument('ac', 'PANEL');
        $form->addArgument('confirm', '1');
		
		if (kDatabaseType == 'oci') {
			$sql="SELECT OWNER FROM(SELECT COUNT(1) X,OWNER FROM ALL_TABLES WHERE TABLE_NAME IN ('CLX_DB_IMPORTS','CLX_BUGS','CLX_EVENTS' ) GROUP BY OWNER) ORDER BY X DESC ";
		}
		else {
			$sql="SELECT TABLE_SCHEMA OWNER FROM(SELECT COUNT(1) X,OWNER FROM PERFORMANCE_SCHEMA.TABLES WHERE TABLE_NAME IN ('CLX_DB_IMPORTS','CLX_BUGS','CLX_EVENTS' ) GROUP BY TABLE_SCHEMA) ORDER BY X DESC ";
		}
        $rs = ClxCommon::$db->executeQuery($sql);
		$TABLESPACE='';
    	while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
			if (empty($TABLESPACE))
				$TABLESPACE=$r['OWNER'];
			else if ($this->databaseName==$r['OWNER'])
				$TABLESPACE=$r['OWNER'];
		}
		
		$table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $table->addCell(dict('CLX_CLEAN_SITE'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO ));
        
		
		$base = new htmlSelect( 'BASE_DE_DATOS');
		$selected=false;
		//kDatabaseName
		//pre($GLOBALS['kDatabase']);
		foreach ( $GLOBALS['kDatabase'] as $key=>$bd) {
			if ("'$bd[0]'"=="'".kDatabaseDisplay."'")
				$selected=true;
			$base->addItem($bd[3].' ('.$bd[0].')', $bd[3], $selected);
			$selected=false;
		}
		$base->setProp('disabled', 'true');
		$table->addData(dict('GEN_LBL_BASE_DATA') . ':', $base->source());
		$checkbox = new htmlCheckBox('CHECKBOX_DROP_TABLE_HUERFAN', true);
        $table->addCell(dict('CHECKBOX_DROP_TABLE_HUERFAN'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($checkbox->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
		
		$moduleTruncate = new htmlSelect( 'MODULE_TRUNCATE[]');
		$moduleDrop = new htmlSelect( 'MODULE_DROP[]');
		$moduleDelete = new htmlSelect( 'MODULE_DELETE[]');
		$sql = 'SELECT IDCODE FROM CLX_DB_MODULES';
        $rs = ClxCommon::$db->executeQuery($sql);
        $selected='false';
		while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
			if ($r['IDCODE']<>'CLX' && $r['IDCODE']<>'BASE' && $r['IDCODE']<>'ALRT')
				$moduleTruncate->addItem($r['IDCODE'], $r['IDCODE'],$selected );
			if ($r['IDCODE']<>'CLX' && $r['IDCODE']<>'BASE' && $r['IDCODE']<>'ALRT')
				$moduleDrop->addItem($r['IDCODE'], $r['IDCODE'],$selected );
			if ($r['IDCODE']<>'CLX' && $r['IDCODE']<>'BASE' && $r['IDCODE']<>'ALRT')
				$moduleDelete->addItem($r['IDCODE'], $r['IDCODE'],$selected );
	    }
			
		
		$moduleTruncate->setProp('multiple', '');
		$moduleTruncate->setProp('size', '4');
		$moduleTruncate->setProp('style', 'width:110px');
		$table->addData(dict('GEN_LBL_MODULE_TRUNCATE') . ':', $moduleTruncate->source());
		
		$moduleDrop->setProp('multiple', '');
		$moduleDrop->setProp('size', '4');
		$moduleDrop->setProp('style', 'width:110px');
		$table->addData(dict('GEN_LBL_MODULE_DROP') . ':', $moduleDrop->source());
		
		$moduleDelete->setProp('multiple', '');
		$moduleDelete->setProp('size', '4');
		$moduleDelete->setProp('style', 'width:110px');
		$table->addData(dict('GEN_LBL_MODULE_DELETE') . ':', $moduleDelete->source());
		
		
		$moduleTruncateCLX = new htmlSelect( 'MODULE_TRUNCATE_CLX[]');
		
		if (kDatabaseType == 'oci') {
			$sql = 'SELECT TABLE_NAME FROM ALL_TABLES WHERE (SUBSTR(TABLE_NAME,1,3)=\'CLX\' OR SUBSTR(TABLE_NAME,1,4)=\'BASE\')  AND OWNER='. singlequote( $TABLESPACE  ). ' ORDER BY TABLE_NAME';
		}
		else {
			$sql = 'SELECT TABLE_NAME FROM PERFORMANCE_SCHEMA.TABLES WHERE (SUBSTR(TABLE_NAME,1,3)=\'CLX\' OR SUBSTR(TABLE_NAME,1,4)=\'BASE\')  AND TABLE_SCHEMA='. singlequote( $TABLESPACE  ). ' ORDER BY TABLE_NAME';
		}


		
		$selected='false';
		$rs = ClxCommon::$db->executeQuery($sql);
		
		while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
			$moduleTruncateCLX->addItem($r['TABLE_NAME'], $r['TABLE_NAME'],$selected );
	    }
		$moduleTruncateCLX->setProp('multiple', '');
		$moduleTruncateCLX->setProp('size', '4');
		$moduleTruncateCLX->setProp('style', 'width:240px');
		$table->addData(dict('GEN_LBL_MODULE_TRUNCATE_CLX') . ':', $moduleTruncateCLX->source());
		
		
		$eliminatecompanies = new htmlSelect( 'ELIMINATE_COMPANIES[]');
		
		$sql = 'SELECT IDCODE,IDNAME FROM BASE_COMPANIES '; 
		$selected='false';
		$rs = ClxCommon::$db->executeQuery($sql);
		
		while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
			$eliminatecompanies->addItem($r['IDNAME'].' ('. $r['IDCODE'].')',$r['IDCODE'],$selected );
	    }
		$eliminatecompanies->setProp('multiple', '');
		$eliminatecompanies->setProp('size', '4');
		$eliminatecompanies->setProp('style', 'width:240px');
		$table->addData(dict('GEN_LBL_ELIMINATE_COMPANIES') . ':', $eliminatecompanies->source());
		
		
		$checkbox = new htmlCheckBox('CHECKBOX_DELETE_HUERPHAN_FIELDS', true);
        $table->addCell(dict('GEN_LBL_DELETE_HUERPHAN_FIELDS'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($checkbox->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
			
		$checkbox = new htmlCheckBox('CHECKBOX_DROP_HISTORIC', false);
        $table->addCell(dict('GEN_LBL_CHECKBOX_DROP_HISTORIC'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($checkbox->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
			
		$user = new htmlSelect( 'DROP_USERS_INFORMATION[]');
		$selected=false;
		$sql = "SELECT FIRSTNAME,LASTNAME, USERNAME, ID FROM CLX_AC_USERS WHERE USERNAME NOT IN ('mbelfort','imrsnik','salegrett','mapacheco','system','administrador','wsserveruser','lcanizales','mchirinos','admin','test','ecampos','ebravo','rsilva')";
        $rs = ClxCommon::$db->executeQuery($sql);
        $selected='false';
		while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
			$user->addItem($r['FIRSTNAME'].' '. $r['LASTNAME'].' ('. $r['USERNAME'].')' , $r['USERNAME'],$selected );
	    }
		$user->setProp('multiple', '');
		$user->setProp('size', '4');
		$user->setProp('style', 'width:180px');
		
		$table->addData(dict('GEN_LBL_DELETE_USERS_INFORMATION') . ':', $user->source() );

		$checkbox = new htmlCheckBox('CHECKBOX_RESET_BASE_CODES', false);
        $table->addCell(dict('GEN_LBL_RESET_BASE_CODES'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($checkbox->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));

		$checkbox = new htmlCheckBox('CHECKBOX_RESET_BASE_SEQUENCE', false);
        $table->addCell(dict('GEN_LBL_RESET_SEQUENCE'), array(CLX_PROP_CLASS => CLX_CLASS_PROMPT));
        $table->addCell($checkbox->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
		

        $c = new htmlSubmit(dict('GEN_LBL_GENERATE_SQL'));
        $buttons = $c->source();
        $c = new htmlButtonCancel();
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $contents = $form->source();

        
		$contents.=
		'
			<script language="JavaScript">
			
				var dropDown = document.getElementById("MODULE_TRUNCATE");
				for (i = 0; i < dropDown.options.length ; i += 1) {
					switch (dropDown.options[i].value) {
						case "USER":
						case "TEST":
							break;
						default:	
							dropDown.options[i].selected=1;
							break;
					}	
				}
				dropDown = document.getElementById("MODULE_DROP");
				for (i = 0; i < dropDown.options.length ; i += 1) {
					switch (dropDown.options[i].value) {
						case "USER":
							dropDown.options[i].selected=1;
							break;
						default:	
							break;
					}	
				}
				dropDown = document.getElementById("MODULE_DELETE");
				for (i = 0; i < dropDown.options.length ; i += 1) {
					switch (dropDown.options[i].value) {
						case "USER":
							dropDown.options[i].selected=1;
							break;
						default:	
							break;
					}	
				}
				dropDown = document.getElementById("MODULE_TRUNCATE_CLX");
				for (i = 0; i < dropDown.options.length ; i += 1) {
				//	console.log(dropDown.options[i].value);
					switch (dropDown.options[i].value) {
						case \'CLX_DB_IMPORTS\':
						case \'CLX_DB_IMPORT_PARSINGS\':
						case \'CLX_DB_IMPORT_MAPPINGS\':
						case \'CLX_DB_IMPORT_FIELDS\':
						case \'CLX_ETL_ROLES\':
						case \'CLX_ETL_IMPORT_SETS\':
						case \'CLX_DB_QUERY_SAVE\':
						case \'CLX_DB_IMPORT_ERRORS\':
						case \'CLX_DB_IMPORT_TRANSLATIONS\':
						case \'CLX_ETL_IMPORT_CFG\':
						case \'CLX_ETL_OP_CLOSE\':
						case \'CLX_AN_GRAPHICS_RANGES\':
						case \'CLX_DB_QIMPORT_PARALLEL\':
						case \'CLX_AN_CHARTS\':
						case \'CLX_AN_CHART_PROPERTIES\':
						case \'CLX_AN_CHART_SERIES\':
						case \'CLX_AN_PLOT\':
						case \'CLX_AN_PLOT_SERIES\':
						case \'CLX_AN_QUESTIONARIES\':
						case \'CLX_AN_QUESTIONARY_OPTIONS\':
						case \'CLX_AN_QUESTIONARY_QUESTS\':
						case \'CLX_AN_REPORT_JOBS\':
						case \'CLX_AN_OUTPUT_GEN\':
						case \'CLX_DB_IMPORT_FIELDS_RULE\':
						case \'CLX_BP_ACTIVITIES\':
						case \'CLX_BUGS\':
						case \'CLX_DB_EXPORTS\':
						case \'CLX_DB_EXPORT_EXECUTIONS\':
						
						case \'CLX_DB_IMPORT_EXCEPTIONS\':
						case \'CLX_DB_IMPORT_EXECUTIONS\':
						case \'CLX_SK_CONNECTORS\':
						case \'CLX_SK_ELEMENTS\':
						case \'CLX_SK_LOGS\':
						case \'CLX_SK_MAP_FIELDS\':
						case \'CLX_SK_MESSAGES\':
						case \'CLX_SK_SERVICES\':
						case \'CLX_SK_CRITERIAS\':
						case \'CLX_AC_AUTHORIZATIONS\':
						case \'CLX_SYS_NOTIFY_LOGS\':
						case \'CLX_SYS_NOTIFY_LOGS\':
						case \'CLX_AN_GRAPHICS\':
						case \'CLX_AN_GRAPHICS_SERIES\':
						case \'CLX_PR_PROC_LOGS\':
						case \'CLX_PR_STEP_LOGS\':
						case \'CLX_PR_EXCEPT_LOGS\':
						case \'CLX_AC_AUDIT\':
						case \'CLX_SD_FILES\':
						case \'CLX_PACKAGES\':
						case \'CLX_ETL_IMPFILES_TMP\':
						case \'CLX_ETL_OP_CLOSE\':
						case \'CLX_ETL_OP_QUEUE\':
						case \'CLX_PACKAGE_CONTENTS\':
						case \'CLX_PACKAGES\':
						case \'CLX_DB_EXPORT_EXECUTIONS\':
						case \'CLX_US_TASKS\':
						case \'CLX_PR_PROC_LOGS\':
						case \'BASE_PROFIT_CENTERS_TBL\':
						case \'CLX_AC_AUDIT\':
						case \'CLX_PR_PROCS_LOGS\':
						case \'CLX_MA_MAILS\':
						case \'CLX_LOGGER\':
							dropDown.options[i].selected=1;
							break;
						default:	
							
							break;
					}	
				}
				jQuery("form").bind("submit", function() {
					document.getElementById("#BASE_DE_DATOS").css("background-color:#33FF33");
					jQuery(this).find(":disabled").removeAttr("disabled");
					
				
				});
				
				$("#DROP_USERS_INFORMATION").parent().append("<input id=\"checkusers\" type=\"checkbox\" /> ");
				$("#MODULE_TRUNCATE_CLX").parent().append("<input id=\"checkclx\" type=\"checkbox\" /> ");
				
				$("#BASE_DE_DATOS").attr("style", "background-color:white;color:black;border: 1px solid black")
				
				//set initial state.
				$("#checkusers").mousedown(function() {
					dropDown = document.getElementById("DROP_USERS_INFORMATION");
					var x=!$(this).is(":checked");
					for (i = 0; i < dropDown.options.length ; i += 1) {
						dropDown.options[i].selected=x;
							
					}
					
				});
				//set initial state.
				$("#checkclx").mousedown(function() {
					dropDown = document.getElementById("MODULE_TRUNCATE_CLX");
					var x=!$(this).is(":checked");
					for (i = 0; i < dropDown.options.length ; i += 1) {
						dropDown.options[i].selected=x;
							
					}
					
				});
			</script>';
		//;font-weight: bold;border: 1px solid #CCC;
        return $contents;
    }

    function checkPanel(&$msg) {
        $msg = array();
        return count($msg) == CLX_NUM_ZERO;
    }
	
    function execute_() {
			//pre($_POST);
			/////////////////////////////////////////////////////////////////////////////////////////////////////////////////					
					$prueba_individual=0;
					ClxCommon::$db->temporary_supress_squote_change=true;			
					$sustituir=array(
						##Para poder hacer drop de tablas no definidas en clientis
						## Para borrar registros estos tipos de modulos EN DB_TABLES
						"&&MODULESDELETE2" => "X.MODULECODE IN ('".implode("','",$_POST['MODULE_DELETE']).  "')",
					
						"&&MODULESDELETE" => "MODULECODE IN ('".implode("','",$_POST['MODULE_DELETE']).  "')",
						
						"&&MODULESTRUNCATE" => "MODULECODE IN ('".implode("','",$_POST['MODULE_TRUNCATE']).  "')",
						"&&MODULESTRUNCATECLX" => $MODULESTRUNCATECLX="TABLE_NAME IN ('".implode("','",$_POST['MODULE_TRUNCATE_CLX']).  "')",
						## Para poder hacer minus contra ALL_TABLES
						"&&MODULESDROP" => "MODULECODE NOT IN ( '".implode("','",$_POST['MODULE_DROP'])."')",
	
						"&&DROP_USERS_INFORMATION1"=>(count($_POST['DROP_USERS_INFORMATION'])==0?"0=1":" USERNAME IN('".implode("','",$_POST['DROP_USERS_INFORMATION'])."')"),
						"&&DROP_USERS_INFORMATION2"=>(count($_POST['DROP_USERS_INFORMATION'])==0?"0=1":" UPPER(USER_CODE) IN('".implode("','",$_POST['DROP_USERS_INFORMATION'])."')"),
						
					//	"&&ELIMINATE_COMPANIES"=>$ELIMINATE_COMPANIES= (COUNT($_POST['ELIMINATE_COMPANIES']<1 ? "": " COMP_CODE IN ('".IMPLODE("','",$_POST['ELIMINATE_COMPANIES']."')"),
						"&&ELIMINATE_COMPANIES"=> " COMP_CODE IN ('".IMPLODE("','",$_POST['ELIMINATE_COMPANIES'])."')",
						
						"&&MODULES_PRINCIPAL" => "'SYS','BASE'",
						"&&MODULES_PRINCIPAL2"  => "''SYS'',''BASE''",
						"&&CHAR_COMILLAS"=>(kDatabaseType == 'oci') ? '"':'`'
					);

					if (kDatabaseType == 'oci') {
						$sql="SELECT OWNER FROM(SELECT COUNT(1) X,OWNER FROM ALL_TABLES WHERE TABLE_NAME IN ('CLX_DB_IMPORTS','CLX_BUGS','CLX_EVENTS' ) GROUP BY OWNER) ORDER BY X DESC ";
					}
					else {
						$sql="SELECT TABLE_SCHEMA OWNER FROM(SELECT COUNT(1) X,OWNER FROM PERFORMANCE_SCHEMA.TABLES WHERE TABLE_NAME IN ('CLX_DB_IMPORTS','CLX_BUGS','CLX_EVENTS' ) GROUP BY TABLE_SCHEMA) ORDER BY X DESC ";
					}
					
					$rs = ClxCommon::$db->executeQuery($sql);
					$TABLESPACE='';
					while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
						if (empty($TABLESPACE))
							$TABLESPACE=$r['OWNER'];
						else if ($this->databaseName==$r['OWNER'])
							$TABLESPACE=$r['OWNER'];
					}
					$sustituir["&&NAMETABLESPACE"] = $TABLESPACE;
						
					if (kDatabaseType == 'oci') {
						$sql="SELECT TABLE_NAME FROM ALL_TABLES WHERE OWNER='$TABLESPACE'";
					}
					else {
						$sql="SELECT TABLE_NAME FROM PERFORMANCE_SCHEMA.TABLES WHERE TABLE_SCHEMA='$TABLESPACE'";
					}
					
					$rs = ClxCommon::$db->executeQuery($sql);
					$tables=array();
					while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
						$tables[$r['TABLE_NAME']]=1;
					}			

				    $select='SELECT INSTRUCCION FROM ( ';
					if ($prueba_individual) {
						
						$select='';
						$qunion=' ';
					}
					else {
						$qunion=' UNION ';
					}
					$select.="SELECT '-- DROP TABLE'  INSTRUCCION,".__LINE__." ORDENADO FROM DUAL UNION";
					
					if ($_POST['CHECKBOX_DROP_TABLE_HUERFAN']==1) {
						
							$select.=" SELECT CONCAT(CONCAT('DROP TABLE ',CONCAT(CONCAT('&&CHAR_COMILLAS',TABLE_NAME),'&&CHAR_COMILLAS')),';') INSTRUCCION, ".__LINE__." ORDENADO FROM ( ".
									 ( (kDatabaseType == 'oci') 
									 ? "	SELECT CAST(TABLE_NAME AS VARCHAR(500)) TABLE_NAME  FROM ALL_TABLES WHERE OWNER='&&NAMETABLESPACE' "
									 : "	SELECT CAST(TABLE_NAME AS VARCHAR(500)) TABLE_NAME  FROM PERFORMANCE_SCHEMA.TABLES WHERE TABLE_SCHEMA='&&NAMETABLESPACE' "
									 ).
	

									 "	MINUS
										SELECT CAST(TABLE_NAME AS VARCHAR(500)) FROM (
										   SELECT CONCAT(CONCAT(MODULECODE,'_'),IDNAME) TABLE_NAME FROM CLX_DB_TABLES WHERE &&MODULESDROP
										   UNION
										   SELECT CONCAT('CLX_',UPPER(CLASS)) TABLE_NAME FROM  CLX_TOOLS
										   UNION
										   SELECT CONCAT(CONCAT('CLX_',UPPER(CLASS)),'S') TABLE_NAME FROM  CLX_TOOLS
											UNION
										   SELECT CONCAT(CONCAT('CLX_',UPPER(CLASS)),'ES') TABLE_NAME FROM  CLX_TOOLS
										) 
									) WHERE SUBSTR(TABLE_NAME,1,4) NOT IN (&&MODULES_PRINCIPAL) AND
									   TABLE_NAME NOT IN ( 	'CLX_AC_TREE_CONTENTS',
															'CLX_AN_QUESTIONARIES',
															'CLX_AN_QUESTIONARY_QUESTS',
															'CLX_AN_REP_QRY_CRITS',
															'CLX_DB_IMPORT_FIELDS_RULE',
															'CLX_MA_MAILACCOUNTS',
															'CLX_MA_MAILATTACHMENTS',
															'CLX_DB_DYNRELATIONS',
															'CLX_DB_DYNRELATION_COLS',
															'CLX_UI_PAGE_OBJECTS',
															'CLX_UI_PAGE_OBJ_CRITS',
															'CLX_DB_IMPORT_RULES',
															'CLX_DB_INDEX_COLUMNS',
															'CLX_DB_QUERY_JOIN_TYPE_RELATION',
															'CLX_PR_PROCESS',    
															'CLX_BP_ACTIVITY_PRMTS',    
															'CLX_SYS_TRANSL_ITEMS',
															'CLX_SYS_TRANSL_SETS',
															'CLX_DB_QUERY_SAVE',
															'CLX_TOOLS',
															'CLX_UI_FORM_LISTING_CRITS',
															'CLX_DB_QIMPORT_PARALLEL',
															'SERV_ROLES',
															'GL_CODES_TBL',
															'GL_GLACCOUNT_GROUPS'
									  )  ".$qunion." ".CHR(13).CHR(10);
							
					}	
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->temporary_supress_squote_change=true;
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}
					$select.="SELECT '-- BORRADO DE ALL_TAB_COLUMNS CAMPOS TEMP ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					$select.="
									SELECT CAST(CONCAT(CONCAT(CONCAT(' ALTER TABLE ',TABLE_NAME), CONCAT(' DROP COLUMN ',COLUMN_NAME)), '; -- NO SE USA EN NINGUNA TABLA FIELD:')  AS VARCHAR(500)) INSTRUCCION
										,".__LINE__." ORDENADO   FROM (
										
										SELECT TABLE_NAME,COLUMN_NAME FROM ALL_TAB_COLUMNS WHERE OWNER = '&&NAMETABLESPACE'
											AND COLUMN_NAME LIKE '%__TMP'
					
										
										) X ".$qunion." ".CHR(13).CHR(10);
					
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->temporary_supress_squote_change=true;
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}	
					if ($prueba_individual) {
						$select='';
					}
					
					$select.="SELECT '-- BORRADO DE TEMPLATES DE MODULO DE LETE O NO EXISTS USERNAME ' INSTRUCCION, ".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (COUNT($_POST['MODULE_DELETE'])>0) {
							$select.="
									  --  BORRADO DE REGISTRO TEMPLATES
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_UI_TEMPLATES WHERE ID= ', ID),';-- TEMPLATE '),IDNAME) AS VARCHAR(500)) INSTRUCCION, ".__LINE__." ORDENADO FROM (

											SELECT  ID, CONCAT(CONCAT(MODULECODE,'_'),IDCODE) IDNAME FROM CLX_UI_TEMPLATES Y WHERE &&MODULESDELETE	
											
												OR NOT EXISTS (
														SELECT 1 FROM CLX_AC_USERS X WHERE X.USERNAME=Y.USERNAME
												)
											
									)  X ".$qunion." ".CHR(13).CHR(10);

					}
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE CLX_US_PREFERENCES DE MODULO DE LETE O NO EXISTS USERNAME ' INSTRUCCION, ".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (COUNT($_POST['MODULE_DELETE'])>0) {
							$select.="
									  --  BORRADO DE REGISTRO TEMPLATES
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_US_PREFERENCES WHERE ID= ', ID),';-- TEMPLATE '),IDNAME) AS VARCHAR(500)) INSTRUCCION, ".__LINE__." ORDENADO FROM (

											SELECT  ID, USERNAME IDNAME FROM CLX_US_PREFERENCES Y WHERE 	
											
												NOT EXISTS (
														SELECT 1 FROM CLX_AC_USERS X WHERE X.USERNAME=Y.USERNAME
												)
											
									)  X ".$qunion." ".CHR(13).CHR(10);

					}
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}
					
					
					
					
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE CLX_AC_GROUP_MEMBERS  NOT EXISTS USERNAME' INSTRUCCION, ".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (COUNT($_POST['MODULE_DELETE'])>0) {
							$select.="
									  -- BORRADO DE REGISTRO EN REGISTRO AC_GROUP_MEMBERS
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_AC_GROUP_MEMBERS WHERE ID= ', ID),';-- PAGE '),IDNAME) AS VARCHAR(500)) INSTRUCCION, ".__LINE__." ORDENADO FROM (

										SELECT  ID, GROUPCODE IDNAME FROM CLX_AC_GROUP_MEMBERS Y WHERE 
											NOT EXISTS (
													SELECT 1 FROM CLX_AC_USERS X WHERE X.USERNAME=Y.USERNAME
											)
										
									)  X ".$qunion." ".CHR(13).CHR(10);

						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}
					}

					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE TEMPLATES DE MODULO DE LETE O NO EXISTS USERNAME ' INSTRUCCION, ".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (COUNT($_POST['MODULE_DELETE'])>0) {
							$select.="
									  --  BORRADO DE REGISTRO TEMPLATES
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_UI_TEMPLATES WHERE ID= ', ID),';-- TEMPLATE '),IDNAME) AS VARCHAR(500)) INSTRUCCION, ".__LINE__." ORDENADO FROM (

											SELECT  ID, CONCAT(CONCAT(MODULECODE,'_'),IDCODE) IDNAME FROM CLX_UI_TEMPLATES Y WHERE &&MODULESDELETE	
											
												OR NOT EXISTS (
														SELECT 1 FROM CLX_AC_USERS X WHERE X.USERNAME=Y.USERNAME
												)
											
									)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}
					}
					
					if ($prueba_individual) {
						$select='';
					}
					
					
					$select.="SELECT '-- BORRADO DE PAGES ROWS MODULO DE LETE  OR NOT EXISTS USERNAME' INSTRUCCION, ".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (COUNT($_POST['MODULE_DELETE'])>0) {
							$select.="
									  -- BORRADO DE REGISTRO EN REGISTRO CLX_UI_PAGE_ROWS 
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_UI_PAGE_ROWS WHERE ID= ', ID),';-- PAGE ROWS '),IDNAME) AS VARCHAR(500)) INSTRUCCION, ".__LINE__." ORDENADO FROM (

										SELECT  ID, CONCAT(CONCAT(PAGECODE,'_'),NAME) IDNAME FROM CLX_UI_PAGE_ROWS Y WHERE
										
											NOT EXISTS (
													SELECT 1 FROM CLX_UI_PAGES X WHERE X.IDCODE=Y.PAGECODE
													
											)
											OR EXISTS (
													SELECT 1 FROM CLX_UI_PAGES X WHERE &&MODULESDELETE	AND X.IDCODE=Y.PAGECODE
											)
										
									)  X ".$qunion." ".CHR(13).CHR(10);

						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
						
						}
					}
					
			//		$sql='DELETE FROM CLX_UI_PAGE_OBJECTS WHERE 1=1 AND EXISTS (SELECT 1 FROM CLX_UI_PAGE_ROWS UIPR WHERE 1=1 AND UIPR.PAGECODE = CONCAT('.singleQuote('RCTM_PEND_').', '.$RCTM_IDCODE.') AND CLX_UI_PAGE_OBJECTS.IDROW=UIPR.ID)';
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE PAGE_OBJECTS MODULO DELETE  OR NOT EXISTS USERNAME ' INSTRUCCION, ".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (COUNT($_POST['MODULE_DELETE'])>0) {
							$select.="
									  -- BORRADO DE REGISTRO EN UI_PAGE_OBJECTS 
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_UI_PAGE_OBJECTS WHERE ID= ', ID),';-- PAGE OBJECTS '),IDNAME) AS VARCHAR(500)) INSTRUCCION, ".__LINE__." ORDENADO FROM (

										SELECT  ID, CONCAT(CONCAT(OBJECTCODE,','),TOOLCODE) IDNAME FROM CLX_UI_PAGE_OBJECTS Y WHERE
										
											NOT EXISTS (
													SELECT 1 FROM CLX_UI_PAGES X WHERE Y.IDROW=X.ID
													
											)
											OR EXISTS (
													SELECT 1 FROM CLX_UI_PAGES X WHERE &&MODULESDELETE	AND  Y.IDROW=X.ID
											)
										
									)  X ".$qunion." ".CHR(13).CHR(10);

						
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
						}
						
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE CLX_UI_PAGES MODULO DELETE  OR NOT EXISTS USERNAME ' INSTRUCCION, ".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (COUNT($_POST['MODULE_DELETE'])>0) {
							$select.="
									  -- BORRADO DE REGISTRO EN UI_PAGES 
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_UI_PAGES WHERE ID= ', ID),';-- PAGE OBJECTS '),IDNAME) AS VARCHAR(500)) INSTRUCCION, ".__LINE__." ORDENADO FROM (

											SELECT  ID, IDNAME FROM CLX_UI_PAGES Y WHERE
										
											 &&MODULESDELETE	
										)
										
									  X ".$qunion." ".CHR(13).CHR(10);

						
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
						}
						
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE TABLAS DE MODULO DELETE ' INSTRUCCION,".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (COUNT($_POST['MODULE_DELETE'])>0) {
							$select.="
									  -- BORRADO DE TABLAS COMO REGISTRO EN DB_TABLES 
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_TABLES WHERE ID= ', ID),';-- TABLE '),TABLE_NAME) AS VARCHAR(500)) INSTRUCCION, ".__LINE__." ORDENADO FROM (

										SELECT  ID, CONCAT(CONCAT(MODULECODE,'_'),IDNAME) TABLE_NAME FROM CLX_DB_TABLES WHERE &&MODULESDELETE	
									)  X ".$qunion." ".CHR(13).CHR(10);

					
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
						}
						
					}	
					$select.="SELECT '-- BORRADO DE TABLAS COMO REGISTRO EN DB_TABLES NOT EXISTS FIELDS O SOLO EXISTE ID ' INSTRUCCION,".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					$select.="
									-- BORRADO DE TABLAS COMO REGISTRO EN DB_TABLES 
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_TABLES WHERE ID= ', ID),';-- TABLE '),TABLE_NAME) AS VARCHAR(500)) INSTRUCCION, ".__LINE__." ORDENADO FROM (

										SELECT  ID, CONCAT(CONCAT(MODULECODE,'_'),IDNAME) TABLE_NAME FROM CLX_DB_TABLES X WHERE 
										NOT EXISTS (SELECT 1 FROM CLX_DB_TABLEFIELDS Y WHERE Y.TABLECODE=X.IDCODE AND Y.FIELDNAME<>'ID')
									)  X ".$qunion." ".CHR(13).CHR(10);

					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE REGISTRO DE TABLEINDEXES QUE SEA DE MODULE DELETE' INSTRUCCION,".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);;
					if (COUNT($_POST['MODULE_DELETE'])>0) {
							$select.="		
									-- BORRADO DE REGISTRO DE TABLEINDEXES QUE NO EXISTA EN DB_TABLES
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_TABLEINDEXES WHERE ID= ', ID),';--  TABLE_INDEXES '),IDNAME)AS VARCHAR(500)) INSTRUCCION, ".__LINE__." ORDENADO FROM (
									
									   SELECT Y.ID,CONCAT(CONCAT(CONCAT(X.MODULECODE,'_'),X.IDNAME), CONCAT(' FIELD ',CONCAT(CONCAT(Y.TABLECODE,'_'),Y.FIELDNAME)) ) IDNAME FROM CLX_DB_TABLES X,CLX_DB_TABLEINDEXES Y WHERE &&MODULESDELETE AND Y.TABLECODE=X.IDCODE
									)  X ".$qunion." ".CHR(13).CHR(10);;
					
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}
					}
					$select.="SELECT '-- BORRADO DE REGISTRO DE TABLEINDEXES QUE NO EXISTA TABLE ' INSTRUCCION,".__LINE__." ORDENADO FROM DUAL UNION ";
					$select.="		
									-- BORRADO DE REGISTRO DE TABLEINDEXES QUE NO EXISTA EN DB_TABLES
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_TABLEINDEXES WHERE ID= ', ID),';--  TABLE_INDEXES '),IDNAME)AS VARCHAR(500)) INSTRUCCION, ".__LINE__." ORDENADO FROM (
									
										SELECT Y.ID,CONCAT(' FIELD ',CONCAT(CONCAT(Y.TABLECODE,'_'),Y.FIELDNAME)) IDNAME FROM CLX_DB_TABLEINDEXES Y WHERE 
											NOT EXISTS(SELECT 1 FROM CLX_DB_TABLES X WHERE Y.TABLECODE=X.IDCODE)
									)  X ".$qunion." ".CHR(13).CHR(10);;
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}	
					
					$select.="SELECT '-- BORRADO DE REGISTRO DE TABLEFIELDS QUE SEA MODULO DELETE' INSTRUCCION,".__LINE__." ORDENADO FROM DUAL UNION ";
					if (COUNT($_POST['MODULE_DELETE'])>0) {						
							$select.="	-- BORRADO DE REGISTRO DE TABLE_FIELDS QUE NO EXISTA EN DB_TABLES
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_TABLEFIELDS WHERE ID= ', ID),';--  TABLE_FIELDS '),IDNAME)AS VARCHAR(500)) INSTRUCCION, ".__LINE__." ORDENADO FROM (
										
										SELECT Y.ID,CONCAT(CONCAT(Y.TABLECODE,'.'),Y.FIELDNAME) IDNAME FROM CLX_DB_TABLES X,CLX_DB_TABLEFIELDS Y WHERE &&MODULESDELETE AND Y.TABLECODE=X.IDCODE
									)  X ".$qunion." ".CHR(13).CHR(10);
					}
					
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}	
					
					$select.="SELECT '-- BORRADO DE REGISTRO DE TABLEFIELDS QUE NO EXISTA EN DB_TABLES' INSTRUCCION,".__LINE__." ORDENADO FROM DUAL UNION ";
					$select.="
									-- BORRADO DE REGISTRO DE TABLEFIELDS QUE NO EXISTA EN DB_TABLES
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_TABLEFIELDS WHERE ID= ', ID),';--  TABLE_FIELDS '),IDNAME)AS VARCHAR(500)) INSTRUCCION, ".__LINE__." ORDENADO FROM (
										
										SELECT Y.ID,CONCAT(CONCAT(Y.TABLECODE,'_'),Y.FIELDNAME) IDNAME FROM CLX_DB_TABLEFIELDS Y WHERE
											NOT EXISTS (SELECT 1 FROM CLX_DB_TABLES X WHERE Y.TABLECODE=X.IDCODE)
									)  X ".$qunion." ".CHR(13).CHR(10);
					
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}	
					
					$select.="SELECT '-- BORRADO DE REGISTRO DE TABLEDFIELDS (DERIVADO) QUE SEA MODULE DELETE' INSTRUCCION,".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (COUNT($_POST['MODULE_DELETE'])>0) {						
							$select.="
									-- BORRADO DE REGISTRO DE TABLED_FIELDS (DERIVADO) QUE SEA MODULE DELETE
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_TABLEDFIELDS WHERE ID= ', ID),';--  TABLED_FIELDS '),IDNAME)AS VARCHAR(500)) INSTRUCCION, ".__LINE__." ORDENADO FROM (
									
										SELECT Y.ID, CONCAT(CONCAT(FIELDNAME,' '),CONCAT(CONCAT(X.MODULECODE,'_'),X.IDNAME)) IDNAME FROM CLX_DB_TABLES X,CLX_DB_TABLEDFIELDS Y WHERE &&MODULESDELETE AND Y.TABLECODE=X.IDCODE
									)  X ".$qunion." ".CHR(13).CHR(10);
					}
					
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}	
					
					
					$select.="SELECT '-- BORRADO DE REGISTRO DE TABLEDFIELDS (DERIVADO) QUE SEA MODULE DELETE' INSTRUCCION,".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (COUNT($_POST['MODULE_DELETE'])>0) {						
							$select.="
									-- BORRADO DE REGISTRO DE TABLEDFIELDS (DERIVADO) QUE NO EXISTA EN DB_TABLES
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_TABLEDFIELDS WHERE ID= ', ID),';--  TABLED_FIELDS '),IDNAME)AS VARCHAR(500)) INSTRUCCION, ".__LINE__."ORDENADO FROM (
									
										SELECT Y.ID, CONCAT(CONCAT(Y.TABLECODE,'_'),Y.FIELDNAME) IDNAME FROM CLX_DB_TABLEDFIELDS Y WHERE 
											NOT EXISTS (SELECT 1 FROM CLX_DB_TABLES X WHERE Y.TABLECODE=X.IDCODE)
									)  X ".$qunion." ".CHR(13).CHR(10);
					}
					
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}	
					$select.="SELECT '-- BORRADO DE REGISTRO DE BASE_DYNAMIC_RELATIONS_MASTER QUE SEA DE MODULE DELETE' INSTRUCCION,".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);;
					if (COUNT($_POST['MODULE_DELETE'])>0) {
							$select.="		
									-- BORRADO DE REGISTRO DE BASE_DYNAMIC_RELATIONS_MASTER QUE NO EXISTA EN DB_TABLES
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM BASE_DYNAMIC_RELATIONS_MASTER WHERE ID= ', ID),';--  TABLE_INDEXES '),IDNAME)AS VARCHAR(500)) INSTRUCCION, ".__LINE__." ORDENADO FROM (
									
										SELECT Y.ID,CONCAT(CONCAT(Y.CHILD_TABLECODE,','),Y.PARENT_TABLECODE)  IDNAME FROM BASE_DYNAMIC_RELATIONS_MASTER Y WHERE 

												NOT EXISTS (SELECT 1 FROM CLX_DB_TABLES X WHERE Y.PARENT_TABLECODE=X.IDCODE AND X.ID=Y.PARENT_RECORDID )
											AND NOT EXISTS (SELECT 1 FROM CLX_DB_TABLES X WHERE Y.CHILD_TABLECODE=X.IDCODE AND X.ID=Y.CHILD_RECORDID )
									)  X ".$qunion." ".CHR(13).CHR(10);;
					
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE REGISTRO DE IMPORT QUE SERA BORRADO POR MODULO DELETE ' INSTRUCCION,".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (COUNT($_POST['MODULE_DELETE'])>0 &&  strpos($MODULESTRUNCATECLX,'CLX_DB_IMPORTS')==false) {						
							$select.="
									-- BORRADO DE REGISTRO DE IMPORT QUE NO EXISTA EN DB_TABLES
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_IMPORTS WHERE ID= ', ID),';-- IMPORTCODE O TABLECODE '),IDNAME)AS VARCHAR(500)) INSTRUCCION, ".__LINE__." ORDENADO FROM (
									
									   SELECT Y.ID,X.IDNAME FROM CLX_DB_TABLES X,CLX_DB_IMPORTS Y WHERE &&MODULESDELETE2 AND Y.TABLECODE=X.IDCODE
									   UNION
									   SELECT X.ID,X.TABLECODE IDNAME FROM CLX_DB_IMPORTS X WHERE &&MODULESDELETE2 
									)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}	
							
					}
					
					
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE REGISTRO DE IMPORT NOT EXIST TABLE ' INSTRUCCION,".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if ( strpos($MODULESTRUNCATECLX,'CLX_DB_IMPORTS')==false) {	
						$select.=" 
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_IMPORTS WHERE ID= ', ID),';--  TABLED_FIELDS '),IDNAME)AS VARCHAR(500)) INSTRUCCION, ".__LINE__." ORDENADO FROM (
											SELECT Y.ID,Y.TABLECODE IDNAME FROM CLX_DB_IMPORTS Y LEFT JOIN CLX_DB_TABLES X ON Y.TABLECODE=X.IDCODE AND X.IDCODE IS NULL
										)  X ".$qunion." ".CHR(13).CHR(10);
										
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
						}	
					}	
					
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE REGISTRO DE IMPORT ERRORS ' INSTRUCCION,".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (strpos($MODULESTRUNCATECLX,'CLX_DB_IMPORT_ERRORS')==false) {
						$select.="
										-- BORRADO DE REGISTRO DE IMPORT ERRORS
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_IMPORT_ERRORS WHERE ID= ', ID),'; -- HUERPHAN IMPORTCODE '),IDNAME)AS VARCHAR(500)) INSTRUCCION, ".__LINE__." ORDENADO FROM (
										
										   SELECT Y.ID,X.IDNAME FROM CLX_DB_IMPORTS X,CLX_DB_IMPORT_ERRORS Y WHERE  Y.IMPORTCODE=X.IDCODE AND &&MODULESDELETE2
										   
										)  X ".$qunion." ".CHR(13).CHR(10);
						
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}	
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE REGISTRO DE IMPORT EXCEPTIONS ' INSTRUCCION,".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (strpos($MODULESTRUNCATECLX,'CLX_DB_IMPORT_EXCEPTIONS')==false) {
						$select.="
										-- BORRADO DE REGISTRO DE IMPORT EXCEPTIONS
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_IMPORT_EXCEPTIONS WHERE ID= ', ID),';-- HUERPHAN IMPORTCODE '),IDNAME)AS VARCHAR(500)) INSTRUCCION, ".__LINE__." ORDENADO FROM (
										
										   SELECT Y.ID,X.IDNAME FROM CLX_DB_IMPORTS X,CLX_DB_IMPORT_EXCEPTIONS Y WHERE  Y.IMPORTCODE=X.IDCODE AND &&MODULESDELETE2
										   
										)  X ".$qunion." ".CHR(13).CHR(10);		
					
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
						}
					}	
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE REGISTRO DE IMPORT EXECUTIONS ' INSTRUCCION,".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (strpos($MODULESTRUNCATECLX,'CLX_DB_IMPORT_EXECUTIONS')==false) {
						$select.="
										-- BORRADO DE REGISTRO DE IMPORT EXECUTIONS
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_IMPORT_EXECUTIONS WHERE ID= ', ID),';-- HUERPHAN IMPORTCODE'),IDNAME)AS VARCHAR(500)) INSTRUCCION, ".__LINE__." ORDENADO FROM (
										
										   SELECT Y.ID,X.IDNAME FROM CLX_DB_IMPORTS X,CLX_DB_IMPORT_EXCEPTIONS Y WHERE  Y.IMPORTCODE=X.IDCODE AND &&MODULESDELETE2
										   
										)  X ".$qunion." ".CHR(13).CHR(10);
						
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}	
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE REGISTRO DE IMPORT FIELDS ' INSTRUCCION,".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (strpos($MODULESTRUNCATECLX,'CLX_DB_IMPORT_FIELDS')==false) {
						$select.="
										-- BORRADO DE REGISTRO DE IMPORT FIELDS
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_IMPORT_FIELDS WHERE ID= ', ID),';-- HUERPHAN IMPORTCODE '),IDNAME)AS VARCHAR(500)) INSTRUCCION, ".__LINE__." ORDENADO FROM (
										
										   SELECT Y.ID,CONCAT(CONCAT(X.IDNAME,'.'),Y.FILE_FIELDNAME) IDNAME FROM CLX_DB_IMPORTS X,CLX_DB_IMPORT_FIELDS Y WHERE  Y.IMPORTCODE=X.IDCODE AND &&MODULESDELETE2
										   
										)  X ".$qunion." ".CHR(13).CHR(10);
						
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}	
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE REGISTRO DE IMPORT FIELDS RULE ' INSTRUCCION,".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (strpos($MODULESTRUNCATECLX,'CLX_DB_IMPORT_FIELDS_RULE')==false) {
						$select.="
										-- BORRADO DE REGISTRO DE IMPORT FIELDS RULE
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_IMPORT_FIELDS_RULE WHERE ID= ', ID),';-- HUERPHAN IMPORTOCDE '),IDNAME)AS VARCHAR(500)) INSTRUCCION, ".__LINE__." ORDENADO FROM (
										
											SELECT Y.ID,R.IMPORTCODE IDNAME FROM CLX_DB_IMPORT_MAPPINGS R,CLX_DB_IMPORT_FIELDS_RULE Y WHERE  Y.ID=R.RULE_ID AND
												EXISTS (SELECT 1 FROM CLX_DB_IMPORTS X WHERE R.IMPORTCODE=X.IDCODE AND &&MODULESDELETE2)
										   
										)  X ".$qunion." ".CHR(13).CHR(10);
										
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
						}	
					}	
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE REGISTRO DE IMPORT MAPPINGS ' INSTRUCCION,".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (strpos($MODULESTRUNCATECLX,'CLX_DB_IMPORT_MAPPINGS')==false) {
						$select.="
										-- BORRADO DE REGISTRO DE CLX_DB_IMPORT_MAPPINGS
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_IMPORT_MAPPINGS WHERE ID= ', ID),';-- HUERPHAN IMPORTCODE '),IDNAME    )AS VARCHAR(500)) INSTRUCCION, ".__LINE__." ORDENADO FROM (
										
										SELECT Y.ID,CONCAT(CONCAT(X.IDCODE,'.'),Y.TABLE_FIELDNAME) IDNAME FROM CLX_DB_IMPORTS X,CLX_DB_IMPORT_MAPPINGS Y WHERE  Y.IMPORTCODE=X.IDCODE AND &&MODULESDELETE2
										)  X ".$qunion." ".CHR(13).CHR(10);
					
					
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}	
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE REGISTRO DE IMPORT  PARSINGS ' INSTRUCCION,".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (strpos($MODULESTRUNCATECLX,'CLX_DB_IMPORT_PARSINGS ')==false) {
						$select.="
										-- BORRADO DE REGISTRO DE IMPORT FIELDS
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_IMPORT_PARSINGS WHERE ID= ', ID),';-- HUERPHAN IMPORTCODE '),IDNAME)AS VARCHAR(500)) INSTRUCCION, ".__LINE__." ORDENADO FROM (
										
										   SELECT Y.ID,X.IDNAME FROM CLX_DB_IMPORTS X,CLX_DB_IMPORT_PARSINGS Y WHERE Y.IMPORTCODE=X.IDCODE AND &&MODULESDELETE2
										   
										)  X ".$qunion." ".CHR(13).CHR(10);
						
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}	
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE REGISTRO DE IMPORT TRASLATIONS ' INSTRUCCION,".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (strpos($MODULESTRUNCATECLX,'CLX_DB_IMPORT_TRANSLATIONS')==false) {
						$select.="
										-- BORRADO DE REGISTRO DE IMPORT FIELDS
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_IMPORT_TRANSLATIONS WHERE ID= ', ID),';-- HUERPHAN IMPORTCODE '),IDNAME)AS VARCHAR(500)) INSTRUCCION, ".__LINE__." ORDENADO FROM (
										
											SELECT Y.ID,R.IMPORTCODE IDNAME FROM CLX_DB_IMPORT_MAPPINGS R,CLX_DB_IMPORT_TRANSLATIONS Y WHERE R.ID=Y.MAPID AND 
												EXISTS (SELECT 1 FROM CLX_DB_IMPORTS X WHERE R.IMPORTCODE=X.IDCODE AND &&MODULESDELETE2)
										   
										)  X ".$qunion." ".CHR(13).CHR(10);						
						
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}	
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE REGISTRO DE ETL_IMPORT QUE NO EXISTA EN IMPORT ' INSTRUCCION,".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					
					if (isset($table['ETL_IMPORT_CFG']) && strpos($MODULESTRUNCATECLX,'CLX_ETL_IMPORT_CFG')==false) {
							$select.=" 
									-- BORRADO DE REGISTRO DE ETL_IMPORT QUE NO EXISTA EN IMPORT
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_ETL_IMPORT_CFG WHERE ID= ', ID),';-- HUERPHAN IMPORTCODE '),IDNAME)AS VARCHAR(500)) INSTRUCCION, ".__LINE__." ORDENADO FROM (
									
									   SELECT Y.ID,Y.IMPORT_CODE FROM CLX_ETL_IMPORT_CFG Y WHERE 
									   NOT EXISTS  (SELECT 1 FROM CLX_DB_IMPORTS X WHERE X.IDCODE IN (Y.IMPORT_CODE,Y.IMPORT_CODE2,Y.IMPORT_CODE3,Y.IMPORT_CODE4)) 
									)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE REGISTRO DE ETL_IMPORT_QUEUE QUE NO EXISTA EN IMPORT ' INSTRUCCION,".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['ETL_IMPORT_QUEUE']) && strpos($MODULESTRUNCATECLX,'CLX_ETL_OP_QUEUE')==false) {
							$select.="								
									-- BORRADO DE REGISTRO DE IMPORT QUE NO EXISTA EN ETL_IMPORT_QUEUE
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_ETL_OP_QUEUE WHERE ID= ', ID),';-- HUERPHAN IMPORTCODE '),IDNAME)AS VARCHAR(500)) INSTRUCCION, ".__LINE__." ORDENADO FROM (
									
										SELECT Y.ID,Y.IMPORT_CODE FROM CLX_ETL_OP_QUEUE Y WHERE 
											NOT EXISTS (SELECT 1 FROM CLX_DB_IMPORTS X WHERE 
												X.IDCODE IN (Y.IMPORT_CODE,Y.IMPORT_CODE2,Y.IMPORT_CODE3,Y.IMPORT_CODE4))
									)  X ".$qunion." ".CHR(13).CHR(10);
								
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE REGISTRO DE ETL_IMPORT_QUEUE QUE NO EXISTA EN TABLE DEL IMPORT' INSTRUCCION,".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['ETL_IMPORT_QUEUE']) && strpos($MODULESTRUNCATECLX,'CLX_ETL_OP_QUEUE')==false) {	
							$select.="								
									-- BORRADO DE REGISTRO DE IMPORT QUE NO EXISTA EN ETL_IMPORT_QUEUE
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_ETL_OP_QUEUE WHERE ID= ', ID),'; -- HUERPHAN IMPORTCODE '),IDNAME)AS VARCHAR(500)) INSTRUCCION, ".__LINE__." ORDENADO FROM (
									
										SELECT Y.ID,X.IDNAME FROM CLX_ETL_OP_QUEUE Y WHERE 
											NOT EXISTS (SELECT 1 FROM CLX_DB_IMPORTS X,CLX_DB_TABLES R WHERE X.TABLECODE=R.IDCODE AND
												X.IDCODE IN (Y.IMPORT_CODE,Y.IMPORT_CODE2,Y.IMPORT_CODE3,Y.IMPORT_CODE4))
									)  X ".$qunion." ".CHR(13).CHR(10);
								
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN ETL_OP_CLOSE' INSTRUCCION,".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['CLX_ETL_OP_CLOSE'])&& strpos($MODULESTRUNCATECLX,'CLX_ETL_OP_CLOSE')==false) {
							$select.="									
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN ETL_OP_CLOSE
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_ETL_OP_CLOSE WHERE ID= ', ID),';--  CLX_ETL_OP_CLOSE '),IDNAME)AS VARCHAR(500)), ".__LINE__." ORDENADO FROM (
									
									   SELECT Y.ID, Y.FILE_NAME IDNAME FROM CLX_ETL_OP_CLOSE Y WHERE 
									   &&ELIMINATE_COMPANIES
									) X ".$qunion." " .CHR(13).CHR(10);	
								
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}		
					$select.="SELECT '-- BORRADO DE REGISTRO DE IMPORT QUE NO EXISTA EN ETL_IMPORT_SET',".__LINE__." ORDENADO FROM DUAL ".$qunion." ".CHR(13).CHR(10);
					if (isset($table['CLX_ETL_IMPORT_SET'])&& strpos($MODULESTRUNCATECLX,'CLX_ETL_IMPORT_SET')==false) {
							$select.="									
									-- BORRADO DE REGISTRO DE IMPORT QUE NO EXISTA EN ETL_IMPORT_SET
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_ETL_IMPORT_SET WHERE ID= ', ID),';--  TABLED_FIELDS '),IDNAME)AS VARCHAR(500)), ".__LINE__." ORDENADO FROM (
									
									   SELECT Y.ID,X.IDNAME FROM CLX_ETL_IMPORT_SET Y WHERE 
									   NOT EXISTS (
											SELECT 1 FROM CLX_ETL_IMPORT_CFG R WHERE AND R.IDCODE=Y.IDCODE 
											AND EXISTS
											(SELECT 1 FROM CLX_DB_IMPORTS X WHERE X.IDCODE IN (R.IMPORT_CODE,R.IMPORT_CODE2,R.IMPORT_CODE3,R.IMPORT_CODE4))
									   )
									) X ".$qunion." " .CHR(13).CHR(10);	
													
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE REGISTRO DE IMPORT QUE NO EXISTA EN ETL_IMPORT_ROLES',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['ETL_IMPORT_ROLES'])&& strpos($MODULESTRUNCATECLX,'CLX_ETL_IMPORT_ROLES')==false) {
							$select.="									
									-- BORRADO DE REGISTRO DE IMPORT QUE NO EXISTA EN ETL_IMPORT_ROLES
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_ETL_IMPORT_ROLES WHERE ID= ', ID),';--  TABLED_FIELDS '),IDNAME)AS VARCHAR(500)), ".__LINE__." ORDENADO FROM (
									
										SELECT Y.ID,X.IDNAME FROM CLX_ETL_IMPORT_ROLES Y WHERE 
										NOT EXISTS (
											SELECT 1 FROM CLX_ETL_IMPORT_CFG R WHERE AND R.IDCODE=Y.IDCODE 
											AND EXISTS
											(SELECT 1 FROM CLX_DB_IMPORTS X WHERE X.IDCODE IN (R.IMPORT_CODE,R.IMPORT_CODE2,R.IMPORT_CODE3,R.IMPORT_CODE4))
										)
									)  X ".$qunion." ".CHR(13).CHR(10);		
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE REGISTRO DE EXPORT QUE MODULE DELETE OR QUERYCODE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (strpos($MODULESTRUNCATECLX,'CLX_DB_EXPORTS')==false) {
						$select.="
									-- BORRADO DE REGISTRO DE EXPORT QUE NO EXPORT
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_EXPORTS WHERE ID= ', ID),';-- HUERPHAN EXPORT '),IDNAME)AS VARCHAR(500)), ".__LINE__." ORDENADO FROM ( ".
									
										(COUNT($_POST['MODULE_DELETE'])>0 
										? " SELECT X.ID,X.IDCODE IDNAME FROM CLX_DB_EXPORTS X WHERE &&MODULESDELETE2 OR "
										: "") .	  
											" NOT EXISTS (SELECT 1 FROM CLX_DB_QUERIES Y WHERE  X.QUERYCODE=Y.IDCODE) )
									 X ".$qunion." ".CHR(13).CHR(10);	
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE REGISTRO DE AC_TABLES QUE NO EXISTE EN DB_TABLES OR MODULO SERA BORRADO EN TABLAS',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (strpos($MODULESTRUNCATECLX,'CLX_AC_TABLES')==false) {
						$select.="
										-- BORRADO DE REGISTRO DE AC_TABLES QUE NO EXISTE EN DB_TABLES OR MODULO SERA BORRADO EN TABLAS
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_AC_TABLES WHERE ID= ', ID),';--  AC TABLE : '),IDNAME)AS VARCHAR(500)), ".__LINE__." ORDENADO FROM (".

											(COUNT($_POST['MODULE_DELETE'])>0 
											? " SELECT Y.ID,CONCAT(CONCAT(X.MODULECODE,'_'),X.IDNAME) IDNAME FROM CLX_DB_TABLES X,CLX_AC_TABLES Y WHERE &&MODULESDELETE AND Y.TABLECODE=X.IDCODE UNION "
											: "") .	  
											"	SELECT Y.ID,Y.TABLECODE IDNAME FROM CLX_DB_TABLES X,CLX_AC_TABLES Y WHERE Y.TABLECODE=X.IDCODE AND Y.TABLECODE IS NULL 
										)  X ".$qunion." ".CHR(13).CHR(10);
									
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}	
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO RELACION CON HISTORICO SINO  EXISSTE EN DB_TABLES',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (COUNT($_POST['MODULE_DELETE'])>0 && strpos($MODULESTRUNCATECLX,'CLX_DB_TABLE_HIST')==false) {
							$select.="
									-- BORRADO RELACION CON HISTORICO SINO  EXISSTE EN DB_TABLES
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_TABLE_HIST WHERE ID= ', ID),';-- QUERY TABLES HIST '),IDNAME)AS VARCHAR(500)), ".__LINE__." ORDENADO FROM (
										
										   SELECT Y.ID,X.IDNAME FROM CLX_DB_TABLES X,CLX_DB_TABLE_HIST Y WHERE &&MODULESDELETE AND Y.TABLE_CODE=X.IDCODE
										   UNION
										   SELECT Y.ID,Y.TABLECODE IDNAME FROM CLX_DB_TABLES X,CLX_AC_TABLES Y WHERE Y.TABLECODE=X.IDCODE AND Y.TABLECODE IS NULL 
									)  X ".$qunion." ".CHR(13).CHR(10);	
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					
					$select.="SELECT '-- BORRADO DE TABLAS EN DB_QUERY_TABLES QUE YA NO EXISTSN EN DB_TABLES',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (COUNT($_POST['MODULE_DELETE'])>0 && strpos($MODULESTRUNCATECLX,'CLX_DB_QUERY_TABLES')==false) {
							$select.="		

									-- BORRADO DE TABLAS EN DB_QUERY_TABLES QUE YA NO EXISTSN EN DB_TABLES
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_QUERY_TABLES WHERE ID= ', ID),';-- QUERY TABLES '),IDNAME)AS VARCHAR(500)),".__LINE__." ORDENADO FROM (
										
										   SELECT Y.ID,X.IDNAME FROM CLX_DB_QUERIES X,CLX_DB_QUERY_TABLES Y WHERE &&MODULESDELETE AND Y.QUERYCODE=X.IDCODE
										   UNION
										   SELECT R.ID,R.IDNAME FROM (SELECT Y.ID,Y.QUERYCODE IDNAME FROM CLX_DB_QUERIES X LEFT JOIN CLX_DB_QUERY_TABLES Y ON Y.QUERYCODE=X.IDCODE WHERE X.IDCODE IS NULL) R	
									)  X ".$qunion." ".CHR(13).CHR(10);
								
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}						
					$select.="SELECT '-- BORRADO DE CLX_DB_QUERY_SAVE',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (COUNT($_POST['MODULE_DELETE'])>0  && strpos($MODULESTRUNCATECLX,'CLX_DB_QUERY_TABLES')==false) {
							$select.="
									-- BORRADO DE CLX_DB_QUERY_SAVE
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_QUERY_SAVE WHERE ID= ', ID),';-- QUERY SAVE '),IDNAME)AS VARCHAR(500)), ".__LINE__." ORDENADO FROM (
									
									   SELECT Y.ID,X.IDNAME FROM CLX_DB_QUERIES X,CLX_DB_QUERY_SAVE Y WHERE &&MODULESDELETE AND Y.QUERYCODE=X.IDCODE
									   UNION
									   SELECT R.ID,R.IDNAME FROM (SELECT Y.ID,Y.QUERYCODE IDNAME FROM CLX_DB_QUERIES X LEFT JOIN CLX_DB_QUERY_SAVE Y ON Y.QUERYCODE=X.IDCODE WHERE X.IDCODE IS NULL) R	
									)  X ".$qunion." ".CHR(13).CHR(10); 

						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}					
					$select.="SELECT '-- BORRADO DE JOIN_CRITERIA QUE SEA MODULO PARA BORRAR',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (COUNT($_POST['MODULE_DELETE'])>0  && strpos($MODULESTRUNCATECLX,'CLX_DB_QUERY_JOIN_CRITERIA')==false) {
							$select.="	
									-- BORRADO DE JOIN_CRITERIA QUE SEA MODULO PARA BORRAR
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_QUERY_JOIN_CRITERIA WHERE ID= ', ID),';-- QUERY JOIN CRITERIA '),IDNAME)AS VARCHAR(500)), ".__LINE__." ORDENADO FROM (
										
											SELECT Y.ID,X.IDNAME FROM CLX_DB_QUERIES X,CLX_DB_QUERY_JOIN_CRITERIA Y WHERE &&MODULESDELETE AND Y.QUERYCODE=X.IDCODE
											UNION
											SELECT R.ID,R.IDNAME FROM (SELECT Y.ID,Y.QUERYCODE IDNAME FROM CLX_DB_QUERIES X  LEFT JOIN CLX_DB_QUERY_JOIN_CRITERIA Y ON Y.QUERYCODE=X.IDCODE WHERE X.IDCODE IS NULL) R	
									)  X ".$qunion." ".CHR(13).CHR(10); 
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}						
					$select.="SELECT '-- BORRADO DE CLX_DB_QUERY_JOIN_TYPE_RELATION TIPO DE RELACION DEL JOIN SI ESTA MODULO PARA BORRAR',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					
					IF (COUNT($_POST['MODULE_DELETE'])>0 && strpos($MODULESTRUNCATECLX,'CLX_DB_QUERY_JOIN_TYPE_RELATION')==false) {
							$select.="	
									-- BORRADO DE DB_QUERY TIPO DE RELACION DEL JOIN SI ESTA MODULO PARA BORRAR
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_QUERY_JOIN_TYPE_RELATION WHERE ID= ', ID),';-- QUERY JOIN TYPE RELATION '),IDNAME)AS VARCHAR(500)), ".__LINE__." ORDENADO FROM (
										
											SELECT Y.ID,X.IDNAME FROM CLX_DB_QUERIES X,CLX_DB_QUERY_JOIN_TYPE_RELATION Y WHERE &&MODULESDELETE AND Y.QUERYCODE=X.IDCODE
											UNION
											SELECT R.ID,R.IDNAME FROM (SELECT Y.ID,Y.QUERYCODE IDNAME FROM CLX_DB_QUERIES X  LEFT JOIN CLX_DB_QUERY_JOIN_TYPE_RELATION Y ON Y.QUERYCODE=X.IDCODE WHERE X.IDCODE IS NULL) R	
									)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- DELETE CLX_DB_QUERY_FIELDS WHERE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					
					IF (COUNT($_POST['MODULE_DELETE'])>0 && strpos($MODULESTRUNCATECLX,'CLX_DB_QUERY_FIELDS')==false) {
							$select.="	
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_QUERY_FIELDS WHERE ID= ', ID),';-- QUERY FIELDS '),IDNAME)AS VARCHAR(500)), ".__LINE__." ORDENADO FROM (
										
											SELECT Y.ID,CONCAT(CONCAT(Y.QUERYCODE,'.'),Y.FIELDNAME) IDNAME FROM CLX_DB_QUERIES X,CLX_DB_QUERY_FIELDS Y WHERE &&MODULESDELETE AND Y.QUERYCODE=X.IDCODE
											UNION
											SELECT R.ID,R.IDNAME FROM (SELECT Y.ID,CONCAT(CONCAT(Y.QUERYCODE,'.'),Y.FIELDNAME) IDNAME FROM CLX_DB_QUERIES X  LEFT JOIN CLX_DB_QUERY_FIELDS Y ON Y.QUERYCODE=X.IDCODE WHERE X.IDCODE IS NULL) R	
									)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}					
					$select.="SELECT '-- DELETE DE DB_QUERY_CRITERIA',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					
					IF (COUNT($_POST['MODULE_DELETE'])>0 && strpos($MODULESTRUNCATECLX,'CLX_DB_QUERY_CRITERIA')==false) {
							$select.="
									-- DELETE DE DB_QUERY_CRITERIA
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_QUERY_CRITERIA WHERE ID= ', ID),';-- QUERY CRITERIA '),IDNAME)AS VARCHAR(500)), ".__LINE__." ORDENADO FROM (
										
											SELECT Y.ID,CONCAT(CONCAT(Y.QUERYCODE,'.'),Y.FIELDNAME) IDNAME FROM CLX_DB_QUERIES X,CLX_DB_QUERY_CRITERIA Y WHERE &&MODULESDELETE AND Y.QUERYCODE=X.IDCODE
											UNION
											SELECT R.ID,R.IDNAME FROM (SELECT X.ID,X.QUERYCODE IDNAME FROM CLX_DB_QUERY_CRITERIA X  LEFT JOIN CLX_DB_QUERY_FIELDS Y ON Y.QUERYCODE=X.QUERYCODE AND Y.TABLECODE=X.TABLECODE AND Y.FIELDNAME=X.FIELDNAME WHERE Y.TABLECODE IS NULL) R	
									)  X ".$qunion." ".CHR(13).CHR(10);
							
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE QUERYS QUE NO EXISTAN EN DB_QUERYS_TABLES O QUE ESTEN EN MODULOS PARA BORRAR',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (strpos($MODULESTRUNCATECLX,'CLX_DB_QUERIES')==false) {
						$select.=	"	
										-- BORRADO DE QUERYS QUE NO EXISTAN EN DB_QUERYS_TABLES O QUE ESTEN EN MODULOS PARA BORRAR 
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_QUERIES WHERE ID= ', ID),';-- QUERIES '),IDNAME)AS VARCHAR(500)),".__LINE__." ORDENADO FROM (
										
										   SELECT ID,IDNAME FROM CLX_DB_QUERIES X WHERE &&MODULESDELETE
												OR NOT EXISTS( SELECT 1 FROM CLX_DB_QUERY_TABLES Y WHERE  Y.QUERYCODE=X.IDCODE)
												OR NOT EXISTS( SELECT 1 FROM CLX_DB_QUERY_FIELDS Y WHERE  Y.QUERYCODE=X.IDCODE) 	
												OR NOT EXISTS( SELECT 1 FROM CLX_DB_QUERY_TABLES Y WHERE  Y.QUERYCODE=X.IDCODE AND EXISTS (SELECT 1 FROM CLX_DB_TABLES R WHERE R.IDCODE=Y.TABLECODE ) ) 	
										)
										X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO  CLX_DB_QUERY_JOIN_CRITERIA SINO EXISTE TABLA O QUERY',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (strpos($MODULESTRUNCATECLX,'CLX_DB_QUERY_JOIN_CRITERIA')==false) {
						$select.="	
								-- BORRADO CLX_DB_QUERY_JOIN_CRITERIA SINO EXISTE TABLA O QUERY
								SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_QUERY_JOIN_CRITERIA WHERE ID= ', ID),';-- QUERY JOIN CRITERIA '),IDNAME)AS VARCHAR(500)) INSTRUCCION, ".__LINE__." ORDENADO FROM (
										SELECT Y.ID,Y.QUERYCODE IDNAME FROM CLX_DB_QUERY_JOIN_CRITERIA Y WHERE 
												NOT EXISTS(SELECT 1 FROM CLX_DB_QUERIES X 	WHERE  Y.QUERYCODE=X.IDCODE)
											OR  NOT EXISTS(SELECT 1 FROM CLX_DB_TABLES	X 	WHERE  Y.TABLECODE=X.IDCODE)
										
								)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}	
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO CLX_DB_QUERY_JOIN_TYPE_RELATION',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (strpos($MODULESTRUNCATECLX,'CLX_DB_QUERY_JOIN_TYPE_RELATION')==false) {
						$select.="		 
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_QUERY_JOIN_TYPE_RELATION WHERE ID= ', ID),';-- QUERY_JOIN_TYPE_RELATION HUERFANO '),IDNAME)AS VARCHAR(500)) INSTRUCCION
											, ".__LINE__." ORDENADO FROM (
											
												SELECT Y.ID,Y.QUERYCODE IDNAME FROM CLX_DB_QUERY_JOIN_TYPE_RELATION Y WHERE 
														NOT EXISTS(	SELECT 1 FROM CLX_DB_QUERIES X WHERE  Y.QUERYCODE=X.IDCODE)
													OR	NOT EXISTS(	SELECT 1 FROM CLX_DB_TABLES X WHERE  Y.JOIN_TABLE1=X.IDCODE)
													OR 	NOT EXISTS(	SELECT 1 FROM CLX_DB_TABLES X WHERE  Y.JOIN_TABLE2=X.IDCODE)
											)  X ".$qunion." ".CHR(13).CHR(10); 
						
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}	
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE CLX_UI_LISTINGS QUE NO EXISTA TABLA O QUERY',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (strpos($MODULESTRUNCATECLX,'CLX_UI_LISTINGS')==false) {
						$select.="		
										-- BORRADO DE LISTINGS QUE NO EXISTA TABLA O QUERY
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_UI_LISTINGS WHERE ID= ', ID),';-- LISTING '),IDNAME)AS VARCHAR(500)) INSTRUCCION
											, ".__LINE__." ORDENADO  FROM (
										
												SELECT ID,IDNAME FROM CLX_UI_LISTINGS Y WHERE " 
												. ((COUNT($_POST['MODULE_DELETE'])==0) ? "":
													"	&&MODULESDELETE  ").
													"	OR	NOT EXISTS(	SELECT 1 FROM CLX_DB_TABLES X 	WHERE X.IDCODE=Y.TABLECODE)
														OR	NOT EXISTS( SELECT 1 FROM CLX_DB_QUERIES X 	WHERE X.IDCODE=Y.QUERYCODE) 	
											) X ".$qunion." ".CHR(13).CHR(10); 
				
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}	
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE CLX_UI_FORM_PANEL_FIELDS QUE NO EXISTA TABLA O QUERY',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (strpos($MODULESTRUNCATECLX,'CLX_UI_FORM_PANEL_FIELDS')==false) {
						$select.="	  
										SELECT CAST( CONCAT(CONCAT(CONCAT('DELETE FROM CLX_UI_FORM_PANEL_FIELDS WHERE ID= ', ID),';-- FORM '),IDNAME)AS VARCHAR(500)) INSTRUCCION
											, ".__LINE__." ORDENADO FROM (
										
												SELECT ID, CONCAT(CONCAT(PANELID,'_'),FIELDNAME) IDNAME FROM CLX_UI_FORM_PANEL_FIELDS Y WHERE
													NOT EXISTS( SELECT ID,IDNAME FROM CLX_UI_FORM_PANELS X WHERE X.IDCODE=Y.PANELID)
											) X ".$qunion." ".CHR(13).CHR(10);
					
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE CLX_UI_SRCH_LIST_CRITS QUE NOT EXIST FORM FIELDS',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (strpos($MODULESTRUNCATECLX,'CLX_UI_SRCH_LIST_CRITS')==false) {
						$select.="	  
										SELECT CAST( CONCAT(CONCAT(CONCAT('DELETE FROM CLX_UI_SRCH_LIST_CRITS WHERE ID= ', ID),';-- FORM '),IDNAME)AS VARCHAR(500)) INSTRUCCION
											, ".__LINE__." ORDENADO FROM (
											
												SELECT ID, CONCAT(CONCAT(PFID,'_'),FRM_FIELDNAME) IDNAME FROM  CLX_UI_SRCH_LIST_CRITS Y  WHERE 
													NOT EXISTS(SELECT 1 FROM CLX_UI_FORM_PANEL_FIELDS X WHERE  X.PANELID=TO_CHAR(Y.PFID))
								
										) X ".$qunion." ".CHR(13).CHR(10);
					
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}
					}
					
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE CLX_AC_USERS DROP USER ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (strpos($MODULESTRUNCATECLX,'CLX_AC_USERS')==false) {
						$select.="	  
										SELECT CAST( CONCAT(CONCAT(CONCAT('DELETE FROM CLX_AC_USERS WHERE ID= ', ID),';-- FORM '),IDNAME)AS VARCHAR(500)) INSTRUCCION
											, ".__LINE__." ORDENADO FROM (
										
												SELECT ID, USERNAME IDNAME FROM CLX_AC_USERS WHERE &&DROP_USERS_INFORMATION1
											) X ".$qunion." ".CHR(13).CHR(10);
						
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}	
					}
					
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE CLX_UI_FILTER_PREFS DROP USER ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (strpos($MODULESTRUNCATECLX,'CLX_UI_FILTER_PREFS')==false) {
						$select.="	  
										SELECT CAST( CONCAT(CONCAT(CONCAT('DELETE FROM CLX_UI_FILTER_PREFS WHERE ID= ', ID),';-- FORM '),IDNAME)AS VARCHAR(500)) INSTRUCCION
											, ".__LINE__." ORDENADO FROM (
										
												SELECT ID, CONCAT(CONCAT(USERNAME,','),QUERYCODE) IDNAME FROM CLX_UI_FILTER_PREFS Y WHERE &&DROP_USERS_INFORMATION1
													OR NOT EXISTS(SELECT 1 FROM CLX_AC_USERS X WHERE Y.USERNAME=X.USERNAME)
													OR  NOT EXISTS (SELECT 1 FROM CLX_DB_QUERIES X WHERE X.IDCODE =Y.QUERYCODE) 
													
											) X ".$qunion." ".CHR(13).CHR(10);
					
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}	
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE CLX_UI_FILTER_CRITERIA DROP USER ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (strpos($MODULESTRUNCATECLX,'CLX_UI_FILTER_PREFS')==false) {
						$select.="	  
										SELECT CAST( CONCAT(CONCAT(CONCAT('DELETE FROM CLX_UI_FILTER_CRITERIA WHERE ID= ', ID),';-- FORM '),IDNAME)AS VARCHAR(500)) INSTRUCCION
											, ".__LINE__." ORDENADO FROM (
										
												SELECT ID, CONCAT(CONCAT(TABLECODE,','),FIELDNAME) IDNAME FROM CLX_UI_FILTER_CRITERIA Y WHERE
													NOT 	EXISTS	(SELECT 1 FROM CLX_DB_TABLES X WHERE Y.TABLECODE=X.IDCODE)
													OR  NOT EXISTS	(SELECT 1 FROM CLX_DB_FIELDS X WHERE X.FIELDNAME =Y.FIELDNAME) 
													
											) X ".$qunion." ".CHR(13).CHR(10);
					
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}	
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE CLX_UI_MENUITEMS DROP LISTINGS ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (strpos($MODULESTRUNCATECLX,'CLX_UI_FILTER_PREFS')==false) {
						$select.="	  
										SELECT CAST( CONCAT(CONCAT(CONCAT('DELETE FROM CLX_UI_MENUITEMS WHERE ID= ', ID),';-- FORM '),IDNAME)AS VARCHAR(500)) INSTRUCCION
											, ".__LINE__." ORDENADO FROM (
										
												SELECT ID, USERNAME IDNAME FROM CLX_UI_MENUITEMS Y WHERE  TYPE='LSTR'
													AND NOT EXISTS(SELECT 1 FROM CLX_UI_LISTINGS X WHERE X.IDCODE=Y.EXTRA1)
													
											) X ".$qunion." ".CHR(13).CHR(10);
					
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}	
					}
					$select.="SELECT '-- BORRADO DE CLX_UI_MENUITEMS DROP LISTINGS ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (strpos($MODULESTRUNCATECLX,'CLX_AC_MENUITEMS')==false) {
						$select.="	  
										SELECT CAST( CONCAT(CONCAT(CONCAT('DELETE FROM CLX_AC_MENUITEMS WHERE ID= ', ID),';-- FORM '),IDNAME)AS VARCHAR(500)) INSTRUCCION
											, ".__LINE__." ORDENADO FROM (
										
												SELECT ID, TABLECODE IDNAME FROM CLX_AC_MENUITEMS Y WHERE TOOLCODE='EDIT' AND TABLECODE<>'NOTABLE' AND TABLECODE IS NOT  NULL
													AND NOT EXISTS(SELECT 1 FROM CLX_DB_TABLES X WHERE X.IDCODE=Y.TABLECODE)
													
											) X ".$qunion." ".CHR(13).CHR(10);
					
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}	
					}
					IF (strpos($MODULESTRUNCATECLX,'CLX_AC_TABLES')==false) {
						$select.="	  
										SELECT CAST( CONCAT(CONCAT(CONCAT('DELETE FROM CLX_AC_TABLES WHERE ID= ', ID),';-- FORM '),IDNAME)AS VARCHAR(500)) INSTRUCCION
											, ".__LINE__." ORDENADO FROM (
										
												SELECT ID, TABLECODE IDNAME FROM CLX_AC_TABLES Y WHERE 
													NOT EXISTS(SELECT 1 FROM CLX_DB_TABLES X WHERE X.IDCODE=Y.TABLECODE)
													
											) X ".$qunion." ".CHR(13).CHR(10);
					
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}	
					}
					if ($prueba_individual) {
						$select='';
					}
					
					$select.="SELECT '-- BORRADO DE CLX_UI_FILTERS DROP USER ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (strpos($MODULESTRUNCATECLX,'CLX_UI_FILTERS')==false) {
						$select.="	  
										SELECT CAST( CONCAT(CONCAT(CONCAT('DELETE FROM CLX_UI_FILTERS WHERE ID= ', ID),';-- FORM '),IDNAME)AS VARCHAR(500)) INSTRUCCION
											, ".__LINE__." ORDENADO FROM (
										
												SELECT ID, USERNAME IDNAME FROM CLX_UI_FILTERS WHERE &&DROP_USERS_INFORMATION1
											) X ".$qunion." ".CHR(13).CHR(10);
					
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}	
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE CLX_UI_FORM_FLD_PROP ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (strpos($MODULESTRUNCATECLX,'CLX_UI_FORM_FLD_PROP')==false) {
						$select.="	  
										SELECT CAST( CONCAT(CONCAT(CONCAT('DELETE FROM CLX_UI_FORM_FLD_PROP  WHERE ID= ', ID),';-- FORM,FIELDNAME '),IDNAME)AS VARCHAR(500)) INSTRUCCION
											, ".__LINE__." ORDENADO FROM (
										
												SELECT ID, CONCAT (CONCAT(Y.FORMCODE,','),FIELDNAME1) IDNAME FROM 
												CLX_UI_FORM_FLD_PROP Y    WHERE 
														NOT EXISTS (SELECT 1 FROM CLX_DB_FIELDS X WHERE Y.FIELDNAME1=X.FIELDNAME)
													OR  NOT EXISTS (SELECT 1 FROM CLX_DB_FIELDS X WHERE Y.FIELDNAME=X.FIELDNAME)
													OR  NOT EXISTS (SELECT 1 FROM CLX_UI_FORMS X WHERE Y.FORMCODE=X.IDCODE)
											) X ".$qunion." ".CHR(13).CHR(10);
					
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}	
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE CLX_UI_FORM_LISTING_CRITS ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					
					IF (strpos($MODULESTRUNCATECLX,'CLX_UI_FORM_LISTING_CRITS')==false) {
						$select.="	  
										SELECT CAST( CONCAT(CONCAT(CONCAT('DELETE FROM CLX_UI_FORM_LISTING_CRITS WHERE ID= ', ID),';-- FORM,FIELDNAME '),IDNAME)AS VARCHAR(500)) INSTRUCCION
											, ".__LINE__." ORDENADO FROM (
										
											 SELECT ID, CONCAT (CONCAT(Y.FIELDNAME1,','),FIELDNAME2) IDNAME FROM 
												CLX_UI_FORM_LISTING_CRITS Y    WHERE 
														NOT EXISTS (SELECT 1 FROM CLX_DB_FIELDS X WHERE Y.FIELDNAME1=X.FIELDNAME)
													OR  NOT EXISTS (SELECT 1 FROM CLX_DB_FIELDS X WHERE Y.FIELDNAME2=X.FIELDNAME)
													OR  NOT EXISTS (SELECT 1 FROM CLX_UI_FORM_LISTINGS X WHERE Y.ID=X.ID)
											) X ".$qunion." ".CHR(13).CHR(10);
					
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}	
					}
					if ($prueba_individual) {
						$select='';
					}
				/*	$select.="SELECT '-- BORRADO DE CLX_AC_USERS DROP USER ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (strpos($MODULESTRUNCATECLX,'CLX_AC_USERS')==false) {
						$select.="	  
										SELECT CAST( CONCAT(CONCAT(CONCAT('DELETE FROM CLX_AC_USERS WHERE ID= ', ID),';-- FORM '),IDNAME)AS VARCHAR(500)) INSTRUCCION
											, ".__LINE__." ORDENADO FROM (
										
												SELECT ID, USERNAME IDNAME FROM CLX_AC_USERS WHERE &&DROP_USERS_INFORMATION1
											) X ".$qunion." ".CHR(13).CHR(10);
					
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}	
					}*/
					
					if ($prueba_individual) {
						$select='';
					}
					
					
					$select.="SELECT '-- BORRADO DE CLX_ETL_ROLE_PARTICIPANTS ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (strpos($MODULESTRUNCATECLX,'CLX_ETL_ROLE_PARTICIPANTS')==false) {
						$select.="	  
										SELECT CAST( CONCAT(CONCAT(CONCAT('DELETE FROM  CLX_ETL_ROLE_PARTICIPANTS WHERE ID= ', ID),';-- FORM '),IDNAME)AS VARCHAR(500)) INSTRUCCION
											, ".__LINE__." ORDENADO FROM (
										
												SELECT ID, USER_CODE IDNAME FROM  CLX_ETL_ROLE_PARTICIPANTS WHERE &&DROP_USERS_INFORMATION2
											) X ".$qunion." ".CHR(13).CHR(10);
					
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}	
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE CLX_UI_FORM_PANELS NOT EXISTS FORMS ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);	   
					IF (strpos($MODULESTRUNCATECLX,'CLX_UI_FORM_PANELS')==false) {
						$select.="	  
										SELECT CAST( CONCAT(CONCAT(CONCAT('DELETE FROM CLX_UI_FORM_PANELS WHERE ID= ', ID),';-- FORM '),IDNAME)AS VARCHAR(500)) INSTRUCCION
											, ".__LINE__." ORDENADO FROM (
										
												SELECT ID, FORMCODE IDNAME FROM CLX_UI_FORM_PANELS Y WHERE
													NOT EXISTS(SELECT ID,IDNAME FROM CLX_UI_FORMS X WHERE X.IDCODE=Y.FORMCODE)
											) X ".$qunion." ".CHR(13).CHR(10);
								
						
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE CLX_UI_FORM_LISTINGS NOT EXISTS FORMS OR LISTINGS FORMCODE, OR FORMS IN MODULES DELETE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);	 		
					IF (strpos($MODULESTRUNCATECLX,'CLX_UI_FORM_LISTINGS')==false) {
						$select.="	   
										SELECT CAST( CONCAT(CONCAT(CONCAT('DELETE FROM CLX_UI_FORM_LISTINGS WHERE ID= ', ID),';-- FORM OR LISTING '),IDNAME)AS VARCHAR(500)) INSTRUCCION
											, ".__LINE__." ORDENADO FROM (
										
												SELECT ID, CONCAT(CONCAT(FORMCODE,','),LISTINGCODE)  IDNAME FROM CLX_UI_FORM_LISTINGS Y WHERE
													NOT EXISTS(SELECT 1 FROM CLX_UI_FORMS X 	WHERE X.IDCODE=Y.FORMCODE)
												OR  	EXISTS(SELECT 1 FROM CLX_UI_FORMS X     WHERE X.IDCODE=Y.FORMCODE AND &&MODULESDELETE)
												OR	NOT EXISTS(SELECT 1 FROM CLX_UI_LISTINGS X	WHERE X.IDCODE=Y.LISTINGCODE)
												OR		EXISTS(SELECT 1 FROM CLX_UI_LISTINGS X	WHERE X.IDCODE=Y.LISTINGCODE AND &&MODULESDELETE)
											) X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE CLX_UI_FORMS POR MODULOS POR BORRAR ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);	 		
					IF (COUNT($_POST['MODULE_DELETE'])>0 && strpos($MODULESTRUNCATECLX,'CLX_UI_FORMS')==false) {
						$select.="	
									SELECT CAST( CONCAT(CONCAT(CONCAT('DELETE FROM CLX_UI_FORMS WHERE ID= ', ID),';-- FORM '),IDNAME)AS VARCHAR(500)) INSTRUCCION
										, ".__LINE__." ORDENADO FROM (
											SELECT ID,IDNAME FROM CLX_UI_FORMS WHERE &&MODULESDELETE
											
										) X ".$qunion." ".CHR(13).CHR(10);
										
					
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
						}
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE CLX_SYS_TRANSL_SETS POR MODULOS POR BORRAR ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);	 		
					IF (COUNT($_POST['MODULE_DELETE'])>0 && strpos($MODULESTRUNCATECLX,'CLX_SYS_TRANSL_SETS')==false) {
						$select.="	
									SELECT CAST( CONCAT(CONCAT(CONCAT('DELETE FROM CLX_SYS_TRANSL_SETS WHERE ID= ', ID),';-- FORM '),IDNAME)AS VARCHAR(500)) INSTRUCCION
										, ".__LINE__." ORDENADO FROM (
											SELECT ID,IDNAME FROM CLX_SYS_TRANSL_SETS WHERE &&MODULESDELETE
											
										) X ".$qunion." ".CHR(13).CHR(10);
										
					
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
						}
					}	
					if ($prueba_individual) {
						$select='';
					}					
					$select.="SELECT '-- BORRADO DE CLX_UI_LISTING_BUTTONS NOT EXISTS UI_LISTING ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (COUNT($_POST['MODULE_DELETE'])>0 && strpos($MODULESTRUNCATECLX,'CLX_UI_LISTING_BUTTONS')==false) {
						$select.="	
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_UI_LISTING_BUTTONS WHERE ID= ', ID),';-- LISTING '),IDNAME)AS VARCHAR(500))
											, ".__LINE__." ORDENADO  FROM (
											
												SELECT ID,LISTINGCODE IDNAME FROM CLX_UI_LISTING_BUTTONS Y WHERE
														NOT EXISTS(SELECT 1 FROM CLX_UI_LISTINGS X WHERE X.IDCODE=Y.LISTINGCODE) 
													OR		EXISTS(SELECT 1 FROM CLX_UI_LISTINGS X WHERE X.IDCODE=Y.LISTINGCODE AND &&MODULESDELETE)
													OR	NOT	EXISTS(SELECT 1 FROM CLX_UI_LISTINGS X, CLX_DB_QUERIES R WHERE X.IDCODE=Y.LISTINGCODE AND R.IDCODE=X.QUERYCODE)
											) X ".$qunion." ".CHR(13).CHR(10);
					
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
						}
					}
					if ($prueba_individual) {
						$select='';
					}					
					$select.="SELECT '-- BORRADO DE CLX_EVENTS MODULE DELETE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (COUNT($_POST['MODULE_DELETE'])>0 && strpos($MODULESTRUNCATECLX,'CLX_EVENTS')==false) {
							$select.="	
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_EVENTS WHERE ID= ', ID),';--  TABLE_EVENTS  '),IDNAME)AS VARCHAR(500))
										, ".__LINE__." ORDENADO FROM (
										   SELECT Y.ID,CONCAT(CONCAT(X.MODULECODE,'_'),X.IDNAME) IDNAME FROM CLX_DB_TABLES X,CLX_EVENTS Y WHERE &&MODULESDELETE AND Y.OWNERCODE='DBTB' AND 
											  ".((kDatabaseType === 'oci') ? 'TO_CHAR(X.ID)' : 'X.ID')."=Y.OWNERID  
										) X ".$qunion." ".CHR(13).CHR(10); 
							
					
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
						}
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE EVENTS  NOT EXISTS TABLE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (strpos($MODULESTRUNCATECLX,'CLX_EVENTS')==false) {
						$select.="	
								SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_EVENTS WHERE ID= ', ID),';--  EVENTS  NOT EXISTS TABLE  '),IDNAME)AS VARCHAR(500))
									, ".__LINE__." ORDENADO FROM (
									
											SELECT Y.ID,CONCAT(CONCAT(Y.OWNERCODE,' OWNERID:'),Y.ID) IDNAME FROM CLX_EVENTS Y WHERE 
												Y.OWNERCODE='DBTB' AND NOT EXISTS (SELECT 1 FROM CLX_DB_TABLES X WHERE ".((kDatabaseType === 'oci') ? 'TO_CHAR(X.ID)' : 'X.ID')."=Y.OWNERID  
									)) X ".$qunion." ".CHR(13).CHR(10); 
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}
					}	
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE EVENTS  NOT EXISTS LISTINGS',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (strpos($MODULESTRUNCATECLX,'CLX_EVENTS')==false) {
						$select.="	
								SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_EVENTS WHERE ID= ', ID),';--  EVENTS  NOT EXISTS LISTINGS  '),IDNAME)AS VARCHAR(500))
									, ".__LINE__." ORDENADO FROM (
									
											SELECT Y.ID,CONCAT(CONCAT(Y.OWNERCODE,' OWNERID:'),Y.ID) IDNAME FROM CLX_EVENTS Y WHERE 
												Y.OWNERCODE='UILG' AND NOT EXISTS (SELECT 1 FROM CLX_UI_LISTINGS X WHERE ".((kDatabaseType === 'oci') ? 'TO_CHAR(X.ID)' : 'X.ID')."=Y.OWNERID  
									)) X ".$qunion." ".CHR(13).CHR(10); 
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE  EVENTS  NOT EXISTS ALERTS ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (strpos($MODULESTRUNCATECLX,'CLX_EVENTS')==false) {
						$select.="	
								SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_EVENTS WHERE ID= ', ID),';--  EVENTS  NOT EXISTS ALERTS  '),IDNAME)AS VARCHAR(500))
									, ".__LINE__." ORDENADO FROM (
									
											SELECT Y.ID,CONCAT(CONCAT(Y.OWNERCODE,' OWNERID:'),Y.ID) IDNAME FROM CLX_EVENTS Y WHERE 
												Y.OWNERCODE='UILG' AND NOT EXISTS (SELECT 1 FROM CLX_SYS_ALERTS X WHERE ".((kDatabaseType === 'oci') ? 'TO_CHAR(X.ID)' : 'X.ID')."=Y.OWNERID  
									)) X ".$qunion." ".CHR(13).CHR(10); 
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}
					}	
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO EVENTS  NOT EXISTS FORMS ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (strpos($MODULESTRUNCATECLX,'CLX_EVENTS')==false) {
						$select.="	
								SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_EVENTS WHERE ID= ', ID),';-- EVENT  NOT EXISTS FORMS   '),IDNAME)AS VARCHAR(500))
									, ".__LINE__." ORDENADO FROM (
									
											SELECT Y.ID,CONCAT(CONCAT(Y.OWNERCODE,' OWNERID:'),Y.ID) IDNAME FROM CLX_EVENTS Y WHERE 
												Y.OWNERCODE='UIFM' AND NOT EXISTS (SELECT 1 FROM CLX_UI_FORMS X WHERE ".((kDatabaseType === 'oci') ? 'TO_CHAR(X.ID)' : 'X.ID')."=Y.OWNERID  
									)) X ".$qunion." ".CHR(13).CHR(10); 
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO EVENTS NOT PANEL EXISTS ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (strpos($MODULESTRUNCATECLX,'CLX_EVENTS')==false) {
						$select.="	
								SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_EVENTS WHERE ID= ', ID),';-- EVENT NOT PANEL EXISTS  '),IDNAME)AS VARCHAR(500))
									, ".__LINE__." ORDENADO FROM (
									
											SELECT Y.ID,CONCAT(CONCAT(Y.OWNERCODE,' OWNERID:'),Y.ID) IDNAME FROM CLX_EVENTS Y WHERE 
												Y.OWNERCODE='UIFP' AND NOT EXISTS (SELECT 1 FROM CLX_UI_FORM_PANELS X WHERE ".((kDatabaseType === 'oci') ? 'TO_CHAR(X.ID)' : 'X.ID')."=Y.OWNERID  
									)) X ".$qunion." ".CHR(13).CHR(10); 
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE CLX_EVENTS UILISTING ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (strpos($MODULESTRUNCATECLX,'CLX_EVENTS')==false) {
						$select.="
								SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_EVENTS WHERE ID= ', ID),';--  CLX_EVENTS UILISTING  '),IDNAME)AS VARCHAR(500)) 
									, ".__LINE__." ORDENADO FROM (	
									   SELECT Y.ID, CONCAT(CONCAT(Y.OWNERCODE,' OWNERID:'),Y.ID) IDNAME FROM CLX_EVENTS Y WHERE  Y.OWNERCODE='UIFF' AND
											NOT EXISTS (SELECT 1 FROM CLX_UI_FORM_PANEL_FIELDS X, CLX_UI_FORM_PANELS Z WHERE X.PANELID=Z.IDCODE AND ".((kDatabaseType === 'oci') ? 'TO_CHAR(X.ID)' : 'X.ID')."=Y.OWNERID   )
									) X ".$qunion." ".CHR(13).CHR(10);	
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
						}
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE CLX_EVENTS IMPORT NOT EXISTS ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (strpos($MODULESTRUNCATECLX,'CLX_EVENTS')==false) {
						$select.="
								SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_EVENTS WHERE ID= ', ID),';--  CLX_EVENTS DE IMPORTADOR NOT EXISTS  '),IDNAME)AS VARCHAR(500)) 
									, ".__LINE__." ORDENADO FROM (	
									   SELECT Y.ID, CONCAT(CONCAT(Y.OWNERCODE,' OWNERID:'),Y.ID) IDNAME  FROM CLX_EVENTS Y WHERE  Y.OWNERCODE='DBIM' AND
											NOT EXISTS (SELECT 1 FROM CLX_DB_IMPORTS X WHERE  ".((kDatabaseType === 'oci') ? 'TO_CHAR(X.ID)' : 'X.ID')."=Y.OWNERID   )
									) X ".$qunion." ".CHR(13).CHR(10);			
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE CLX_EVENTS PROCESS NOT EXISTS ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (strpos($MODULESTRUNCATECLX,'CLX_EVENTS')==false) {
						$select.="
								SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_EVENTS WHERE ID= ', ID),';--  CLX_EVENTS PROCESS NOT EXISTS  '),IDNAME)AS VARCHAR(500)) 
									, ".__LINE__." ORDENADO FROM (	
									   SELECT Y.ID, CONCAT(CONCAT(Y.OWNERCODE,' OWNERID:'),Y.ID) IDNAME  FROM CLX_EVENTS Y WHERE  Y.OWNERCODE='PRSE' AND
											NOT EXISTS (SELECT 1 FROM CLX_PR_PROCESS X WHERE  ".((kDatabaseType === 'oci') ? 'TO_CHAR(X.ID)' : 'X.ID')."=Y.OWNERID   )
									) X ".$qunion." ".CHR(13).CHR(10);			
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
						}
					}
					if ($prueba_individual) {
						$select='';
					}					
					$select.="SELECT '-- BORRADO DE CLX_AN_REPORTS  NOT EXISTS QUERYCODE, O  se mando a borrar modulo',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (COUNT($_POST['MODULE_DELETE']) && strpos($MODULESTRUNCATECLX,'CLX_AN_REPORTS WHERE')==false) {	
							$select.="
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_AN_REPORTS WHERE ID= ', ID),';-- AN_REPORTS '),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
											
											   SELECT ID,IDNAME FROM CLX_AN_REPORTS Y WHERE &&MODULESDELETE
											   OR  NOT EXISTS (SELECT 1 FROM CLX_DB_QUERIES X WHERE X.IDCODE =Y.QUERYCODE) 
										)  X ".$qunion." ".CHR(13).CHR(10);
						     
						
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
						}
					}
					if ($prueba_individual) {
						$select='';
					}					
					$select.="SELECT '-- BORRADO DE CLX_AN_REPORTS  NOT EXISTS QUERYCODE  ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (strpos($MODULESTRUNCATECLX,'CLX_AN_REPORT_QUERIES')==false) {
						$select.="
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_AN_REPORT_QUERIES WHERE ID= ', ID),';-- AN_REPORTS '),IDNAME)AS VARCHAR(500))
											,".__LINE__." ORDENADO FROM (
										
												   SELECT ID,IDNAME FROM CLX_AN_REPORT_QUERIES Y WHERE  NOT EXISTS (SELECT 1 FROM CLX_DB_QUERIES X WHERE X.IDCODE =Y.QUERYCODE) 
											)  X ".$qunion." ".CHR(13).CHR(10);
								 
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
						}
					}
					if ($prueba_individual) {
						$select='';
					}					
					$select.="SELECT '-- BORRADO DE CLX_AN_REPORTS  NOT EXISTS TABLE OR REPORTS ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (strpos($MODULESTRUNCATECLX,'CLX_AN_REPORT_GROUPS')==false) {
						$select.="		
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_AN_REPORT_GROUPS WHERE ID= ', ID),';-- HUERFANO AN_REPORT GROUPS '),IDNAME)AS VARCHAR(500))
											,".__LINE__." ORDENADO FROM (
										
													SELECT ID, REPORTCODE IDNAME FROM CLX_AN_REPORT_GROUPS Y WHERE 
														NOT EXISTS(SELECT 1 FROM CLX_DB_TABLES X WHERE Y.TABLECODE=X.IDCODE)
												   OR NOT EXISTS(SELECT 1 FROM CLX_AN_REPORTS X WHERE Y.REPORTCODE=X.IDCODE)
											)  X ".$qunion." ".CHR(13).CHR(10);
								 
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
						}
					}
					if ($prueba_individual) {
						$select='';
					}					
					$select.="SELECT '-- BORRADO DE CLX_AN_REPORTS  NOT EXISTS QUERYCODE, O MODULEDELETE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (strpos($MODULESTRUNCATECLX,'CLX_AN_REPORT_GROUP_FUNC')==false) {
						$select.="		
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_AN_REPORT_GROUP_FUNC WHERE ID= ', ID),';-- HUERFANO AN_REPORT GROUP_FUNC '),TABLECODE)AS VARCHAR(500))
											,".__LINE__." ORDENADO FROM (
										
												   SELECT ID, TABLECODE  FROM CLX_AN_REPORT_GROUP_FUNC Y WHERE 
												   NOT EXISTS(SELECT 1 FROM CLX_DB_TABLES X WHERE Y.TABLECODE=X.IDCODE)
											)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
						}
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE CLX_AN_REPORTS  NOT EXISTS QUERYCODE, O MODULEDELETE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (strpos($MODULESTRUNCATECLX,'CLX_AN_REPORT_COLUMNS')==false) {
						$select.="		
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_AN_REPORT_COLUMNS WHERE ID= ', ID),';-- HUERFANO AN_REPORT GROUP_FUNC '),TABLECODE)AS VARCHAR(500))
											,".__LINE__."ORDENADO FROM (
												SELECT ID, TABLECODE  FROM CLX_AN_REPORT_COLUMNS Y WHERE 
													NOT EXISTS(SELECT 1 FROM CLX_DB_TABLES X WHERE Y.TABLECODE=X.IDCODE)
												OR	NOT EXISTS(SELECT 1 FROM CLX_AN_REPORTS X WHERE Y.REPORTCODE=X.IDCODE)
											)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
						}	
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE CLX_AN_HEAD_FOOT  POR MODULE DELETE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (COUNT($_POST['MODULE_DELETE'])>0 && isset($table['CLX_AN_HEAD_FOOT']) && strpos($MODULESTRUNCATECLX,'CLX_AN_HEAD_FOOT')==false){	
						$select.="	
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_AN_HEAD_FOOT WHERE ID= ', ID),'; -- AN HEAD FOOT '),IDNAME) AS VARCHAR(500))
										, ".__LINE__." ORDENADO FROM (
										   
											SELECT Y.ID,IDNAME FROM CLX_AN_HEAD_FOOT Y WHERE 
											&&MODULESDELETE
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE AN REP QRY CRITS NOT EXISTS QUERYCODE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					$select.="
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_AN_REP_QRY_CRITS WHERE ID= ', ID),';-- HUERFANO AN REP QRY CRITS '),REPQRYCODE)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									
											SELECT ID,REPQRYCODE   FROM CLX_AN_REP_QRY_CRITS Y WHERE 
												NOT EXISTS (SELECT 1 FROM CLX_DB_QUERIES X WHERE X.IDCODE =Y.REPQRYCODE)
											UNION
											SELECT ID,REPQRYCODE   FROM CLX_AN_REP_QRY_CRITS Y WHERE 
												NOT EXISTS (SELECT 1 FROM CLX_DB_QUERIES X WHERE Y.REPQRYCODE2 IS NULL OR X.IDCODE =Y.REPQRYCODE2)
										)  X ".$qunion." ".CHR(13).CHR(10);
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}							 
					$select.="SELECT '-- BORRADO DE CLX_DB_TABLEINDEXES NOT EXISTS TABLE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					$select.="		 
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_TABLEINDEXES WHERE ID= ', ID),'; -- HUERFANO ID TABLECODE:'),IDNAME) AS VARCHAR(500))
										, ".__LINE__." ORDENADO FROM (
									
											SELECT Y.ID,CONCAT(CONCAT(Y.TABLECODE,'.'),Y.FIELDNAME) IDNAME FROM CLX_DB_TABLEINDEXES Y WHERE 
												NOT EXISTS(SELECT 1 FROM CLX_DB_TABLES X WHERE Y.TABLECODE=X.IDCODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}
					$select.="SELECT '-- BORRADO DE CLX_DB_INDEX_COLUMNS NOT EXISTS TABLE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					$select.="	SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_INDEX_COLUMNS WHERE ID= ', ID),'; -- HUERFANO ID INDEX COLUMNS:'),IDNAME) AS VARCHAR(500))
										, ".__LINE__." ORDENADO FROM (
											SELECT ID,CONCAT(CONCAT(INDEX_CODE,'.'),FIELDNAME) IDNAME FROM CLX_DB_INDEX_COLUMNS Y WHERE 
												NOT EXISTS( SELECT * FROM CLX_DB_TABLEINDEXES X WHERE X.IDCODE=Y.INDEX_CODE)
												OR NOT EXISTS ( SELECT * FROM CLX_DB_TABLEFIELDS X WHERE X.FIELDNAME=Y.FIELDNAME)
										) X ".$qunion." ".CHR(13).CHR(10);
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}
					$select.="SELECT '-- BORRADO DE CLX_DB_TABLEFIELDS NOT EXISTS TABLE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					$select.="
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_TABLEFIELDS WHERE ID= ', ID),'; -- HUERFANO ID TABLECODE:'),IDNAME) AS VARCHAR(500))
										, ".__LINE__." ORDENADO FROM (
									
											SELECT Y.ID,CONCAT(CONCAT(Y.TABLECODE,'.'),Y.FIELDNAME) IDNAME  FROM CLX_DB_TABLEFIELDS Y WHERE 
												NOT EXISTS(SELECT 1 FROM CLX_DB_TABLES X WHERE Y.TABLECODE=X.IDCODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}
					$select.="SELECT '-- BORRADO DE CLX_UI_VIEW_COLUMNS NOT EXISTS TABLE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					$select.="
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_UI_VIEW_COLUMNS WHERE ID= ', ID),'; -- HUERFANO ID TABLECODE OR FIELD:'),IDNAME) AS VARCHAR(500))
										, ".__LINE__." ORDENADO FROM (
									
											SELECT Y.ID,CONCAT(CONCAT(Y.TABLECODE,'.'),Y.FIELDNAME) IDNAME  FROM CLX_UI_VIEW_COLUMNS Y WHERE 
													NOT EXISTS(SELECT 1 FROM CLX_DB_TABLES X WHERE Y.TABLECODE=X.IDCODE)
												OR	NOT EXISTS(SELECT 1 FROM CLX_DB_FIELDS X WHERE Y.FIELDNAME=X.FIELDNAME)
												
										)  X ".$qunion." ".CHR(13).CHR(10);
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}
					$select.="SELECT '-- BORRADO DE CLX_AN_REPORT_GROUPS NOT EXISTS TABLE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					$select.="
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_AN_REPORT_GROUPS WHERE ID= ', ID),'; -- HUERFANO ID TABLECODE OR FIELD:'),IDNAME) AS VARCHAR(500))
										, ".__LINE__." ORDENADO FROM (
									
											SELECT Y.ID,CONCAT(CONCAT(Y.TABLECODE,'.'),Y.FIELDNAME) IDNAME  FROM CLX_AN_REPORT_GROUPS Y WHERE 
													NOT EXISTS(SELECT 1 FROM CLX_DB_TABLES X WHERE Y.TABLECODE=X.IDCODE)
												OR NOT EXISTS(SELECT 1 FROM CLX_DB_FIELDS X WHERE Y.FIELDNAME=X.FIELDNAME)
												OR	NOT EXISTS(SELECT 1 FROM CLX_DB_QUERIES X WHERE Y.REPQRYCODE=X.IDCODE)
												OR	NOT EXISTS(SELECT 1 FROM CLX_AN_REPORTS X WHERE Y.REPORTCODE=X.IDCODE)
											
										)  X ".$qunion." ".CHR(13).CHR(10);
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}
					$select.="SELECT '-- BORRADO DE CLX_UI_VIEW_PREFS NOT EXISTS TABLE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					$select.="
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_UI_VIEW_PREFS WHERE ID= ', ID),'; -- HUERFANO ID TABLECODE OR FIELD:'),IDNAME) AS VARCHAR(500))
										, ".__LINE__." ORDENADO FROM (
									
											SELECT Y.ID,CONCAT(CONCAT(Y.QUERYCODE,','),Y.USERNAME) IDNAME  FROM CLX_UI_VIEW_PREFS Y WHERE 
													NOT EXISTS(SELECT 1 FROM CLX_DB_QUERIES X WHERE Y.QUERYCODE=X.IDCODE)
												OR NOT EXISTS(SELECT 1 FROM CLX_AC_USERS X WHERE Y.USERNAME=X.USERNAME)
									
										)  X ".$qunion." ".CHR(13).CHR(10);
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}
					$select.="SELECT '-- BORRADO DE CLX_UI_VIEW_SORTS NOT EXISTS TABLE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					$select.="
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_UI_VIEW_SORTS WHERE ID= ', ID),'; -- HUERFANO ID TABLECODE OR FIELD:'),IDNAME) AS VARCHAR(500))
										, ".__LINE__." ORDENADO FROM (
									
											SELECT Y.ID,CONCAT(CONCAT(Y.TABLECODE,'.'),Y.FIELDNAME) IDNAME  FROM CLX_UI_VIEW_SORTS Y WHERE 
													NOT EXISTS(SELECT 1 FROM CLX_DB_TABLES X WHERE Y.TABLECODE=X.IDCODE)
												OR NOT EXISTS(SELECT 1 FROM CLX_DB_FIELDS X WHERE Y.FIELDNAME=X.FIELDNAME)
									
										)  X ".$qunion." ".CHR(13).CHR(10);
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}
					$select.="SELECT '-- BORRADO DE CLX_UI_VIEW_SORTS NOT EXISTS TABLE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					$select.="
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_UI_VIEW_SORTS  WHERE ID= ', ID),'; -- HUERFANO ID TABLECODE OR FIELD:'),IDNAME) AS VARCHAR(500))
										, ".__LINE__." ORDENADO FROM (
									
											SELECT Y.ID,CONCAT(CONCAT(Y.TABLECODE,'.'),Y.FIELDNAME) IDNAME  FROM CLX_UI_VIEW_SORTS  Y WHERE 
													NOT EXISTS(SELECT 1 FROM CLX_DB_TABLES X WHERE Y.TABLECODE=X.IDCODE)
												OR NOT EXISTS(SELECT 1 FROM CLX_DB_FIELDS X WHERE Y.FIELDNAME=X.FIELDNAME)
									
										)  X ".$qunion." ".CHR(13).CHR(10);
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}
					$select.="SELECT '-- BORRADO DE CLX_UI_VIEWS NOT EXISTS TABLE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					$select.="
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_UI_VIEWS  WHERE ID= ', ID),'; -- HUERFANO ID TABLECODE:'),IDNAME) AS VARCHAR(500))
										, ".__LINE__." ORDENADO FROM (
									
											SELECT Y.ID,Y.QUERYCODE IDNAME  FROM CLX_UI_VIEWS  Y WHERE 
													NOT EXISTS(SELECT 1 FROM CLX_DB_QUERIES X WHERE Y.QUERYCODE=X.IDCODE)
											
										)  X ".$qunion." ".CHR(13).CHR(10);
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}
					$select.="SELECT '-- BORRADO DE CLX_DB_DYNRELATION_COLS NOT EXISTS TABLE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					$select.="		
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_DYNRELATION_COLS WHERE ID= ', ID),'; -- HUERFANO ID TABLECODE:'),TABLECODE) AS VARCHAR(500))
										, ".__LINE__." ORDENADO FROM (
									
											SELECT Y.ID,CHILD_TABLECODE TABLECODE FROM  CLX_DB_DYNRELATION_COLS   Y WHERE 
												NOT EXISTS(SELECT 1 FROM CLX_DB_TABLES X WHERE Y.CHILD_TABLECODE=X.IDCODE)
											UNION
											SELECT Y.ID,PARENT_TABLECODE TABLECODE FROM  CLX_DB_DYNRELATION_COLS   Y WHERE 
												NOT EXISTS(SELECT 1 FROM CLX_DB_TABLES X WHERE Y.PARENT_TABLECODE=X.IDCODE)
										)  X ".$qunion." ".CHR(13).CHR(10);

					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}
					$select.="SELECT '-- BORRADO DE CLX_AN_REPORTS  NOT EXISTS QUERYCODE, O MODULEDELETE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					$select.="
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_DYNRELATIONS WHERE ID= ', ID),'; -- HUERFANO ID TABLECODE:'),TABLECODE) AS VARCHAR(500))
											, ".__LINE__." ORDENADO FROM (
									
												SELECT Y.ID,CHILD_TABLECODE TABLECODE FROM  CLX_DB_DYNRELATIONS   Y WHERE 
													NOT EXISTS(SELECT 1 FROM CLX_DB_TABLES X WHERE Y.CHILD_TABLECODE=X.IDCODE)
												UNION
												SELECT Y.ID,PARENT_TABLECODE TABLECODE FROM  CLX_DB_DYNRELATIONS   Y WHERE 
													NOT EXISTS(SELECT 1 FROM CLX_DB_TABLES X WHERE Y.PARENT_TABLECODE=X.IDCODE)
											)  X ".$qunion." ".CHR(13).CHR(10);
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}
					$select.="SELECT '-- BORRADO DE CLX_DB_TABLE_HIST  NOT EXISTS TABLE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (isset($table['CLX_DB_TABLE_HIST'])) {
						$select.="
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DB_TABLE_HIST WHERE ID= ', ID),'; -- HUERFANO ID TABLECODE:'),TABLECODE) AS VARCHAR(500))
										, ".__LINE__." ORDENADO FROM (
										
										   SELECT Y.ID,TABLE_CODE TABLECODE FROM CLX_DB_TABLE_HIST Y WHERE 
											  NOT EXISTS(SELECT 1 FROM CLX_DB_TABLES X WHERE Y.TABLE_CODE=X.IDCODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}						
					$select.="SELECT '-- BORRADO DE BASE_IDCODES NOT EXISTS TABLE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					$select.="
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM BASE_IDCODES WHERE ID= ', ID),'; -- HUERFANO ID TABLECODE:'),TABLECODE) AS VARCHAR(500))
										, ".__LINE__." ORDENADO FROM (
										
											SELECT Y.ID,TABLECODE TABLECODE FROM BASE_IDCODES Y WHERE 
												NOT EXISTS(SELECT 1 FROM CLX_DB_TABLES X WHERE Y.TABLECODE=X.IDCODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}
					$select.="SELECT '-- BORRADO DE CLX_SK_CONNECTORS NOT EXISTS QUERYCODE, O MODULEDELETE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					$select.="
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_SK_CONNECTORS WHERE ID= ', ID),'; --SK CONECTORS ID:'),IDNAME) AS VARCHAR(500))
										, ".__LINE__." ORDENADO FROM (
										
										   SELECT Y.ID,IDNAME FROM CLX_SK_CONNECTORS Y WHERE MODULECODE NOT IN (&&MODULES_PRINCIPAL)
										)  X ".$qunion." ".CHR(13).CHR(10);
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}
					$select.="SELECT '-- BORRADO DE CLX_AN_GRAPHICS_SERIES NOT EXISTS QUERY, O TABLE O GRAPHICS ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (isset($table['CLX_DB_TABLE_HIST'])) {
						$select.="		
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_AN_GRAPHICS_SERIES WHERE ID= ', ID),'; -- HUERPHAN AN GRAPHICS SERIES :'),IDNAME) AS VARCHAR(500))
										, ".__LINE__." ORDENADO FROM (
												
											SELECT Y.ID,CHARTCODE IDNAME FROM CLX_AN_GRAPHICS_SERIES Y WHERE 
													NOT EXISTS(SELECT 1 FROM CLX_DB_TABLES X WHERE Y.TABLECODE=X.IDCODE)
												OR 	NOT EXISTS(SELECT 1 FROM CLX_DB_QUERIES X WHERE Y.QUERYCODE=X.IDCODE)
												OR	NOT EXISTS(SELECT 1 FROM CLX_AN_GRAPHICS X WHERE Y.CHARTCODE=X.IDCODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE CLX_AN_CHART_SERIES NOT EXISTS TABLA O CHARTS ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					$select.="	
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_AN_CHART_SERIES WHERE ID= ', ID),'; -- HUERPHAN AN GRAPHICS SERIES :'),IDNAME) AS VARCHAR(500))
										, ".__LINE__." ORDENADO FROM (
										
											SELECT Y.ID,CHARTCODE IDNAME FROM CLX_AN_CHART_SERIES Y WHERE 
												NOT EXISTS(SELECT 1 FROM CLX_DB_TABLES X WHERE Y.TABLECODE=X.IDCODE)
											OR	NOT EXISTS(SELECT 1 FROM CLX_AN_CHARTS X WHERE Y.CHARTCODE=X.IDCODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}
					$select.="SELECT '-- BORRADO DE CLX_AN_REPORTS  NOT EXISTS QUERYCODE, O MODULEDELETE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					$select.="		
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_AN_CHART_PROPERTIES WHERE ID= ', ID),'; -- HUERPHAN AN GRAPHICS SERIES :'),IDNAME) AS VARCHAR(500))INSTRUCCION
										, ".__LINE__." ORDENADO FROM (
										
											SELECT Y.ID,CHARTCODE IDNAME FROM CLX_AN_CHART_PROPERTIES Y WHERE 
												NOT EXISTS(SELECT 1 FROM CLX_AN_CHARTS X WHERE Y.CHARTCODE=X.IDCODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}
					$select.="SELECT '-- BORRADO DE CLX_AN_CHART_PROPERTIES NOT EXISTS CHARTS ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					$select.="
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_AN_CHART_PROPERTIES WHERE ID= ', ID),'; -- HUERPHAN AN GRAPHICS SERIES :'),IDNAME) AS VARCHAR(500)) INSTRUCCION
										, ".__LINE__." ORDENADO FROM (
										
											SELECT Y.ID,CHARTCODE IDNAME FROM CLX_AN_CHART_PROPERTIES Y WHERE 
												NOT EXISTS(SELECT 1 FROM CLX_AN_CHARTS X WHERE Y.CHARTCODE=X.IDCODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}
					$select.="SELECT '-- BORRADO DE CLX_AN_CHARTS  NOT EXISTS QUERYCODE, O MODULE DELETE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					$select.="
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_AN_CHARTS WHERE ID= ', ID),'; -- HUERPHAN AN GRAPHICS SERIES :'),IDNAME) AS VARCHAR(500)) INSTRUCCION
										, ".__LINE__." ORDENADO FROM (
											
											SELECT Y.ID, IDNAME FROM CLX_AN_CHARTS Y WHERE 
												". ((COUNT($_POST['MODULE_DELETE'])==0) ? "":
												"	&&MODULESDELETE OR ").
												"  NOT EXISTS(SELECT 1 FROM CLX_DB_QUERIES X WHERE Y.QUERYCODE=X.IDCODE)
										  
										)  X ".$qunion." ".CHR(13).CHR(10);
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}
					
					$select.="SELECT '-- BORRADO DE CLX_AN_REPORTS  NOT EXISTS QUERYCODE, O MODULEDELETE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (isset($table['CLX_AN_GRAPHICS'])) {
						$select.="
									-- DELETE CLX_AN_GRAPHICS
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_AN_GRAPHICS WHERE ID= ', ID),'; -- HUERPHAN AN GRAPHICS :'),IDNAME) AS VARCHAR(500)) INSTRUCCION
										, ".__LINE__." ORDENADO FROM (
										
											SELECT Y.ID, IDNAME FROM CLX_AN_GRAPHICS Y WHERE 
												NOT EXISTS(SELECT 1 FROM CLX_AN_GRAPHICS_SERIES X WHERE X.CHARTCODE=Y.IDCODE)
											  
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE CLX_AN_GRAPHICS_RANGES  NOT EXISTS CLX_AN_GRAPHICS ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					IF (isset($table['CLX_AN_GRAPHICS_RANGES'])) {		
						$select.="
									-- DELETE CLX_AN_GRAPHICS
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_AN_GRAPHICS_RANGES WHERE ID= ', ID),'; -- HUERPHAN AN GRAPHICS RANGE :'),IDNAME) AS VARCHAR(500)) INSTRUCCION
										, ".__LINE__." ORDENADO FROM (
										
											SELECT Y.ID,CHARTCODE IDNAME FROM CLX_AN_GRAPHICS_RANGES Y WHERE 
												NOT EXISTS(SELECT 1 FROM CLX_AN_GRAPHICS X WHERE Y.CHARTCODE=X.IDCODE)
											
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->temporary_supress_squote_change=true;
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE CLX_DICTIONARY REGLA IMPORT ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (strpos($MODULESTRUNCATECLX, 'IMPORT')>0) { 
						$select.="
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DICTIONARY WHERE ID= ', ID),'; -- BORRADO REGLA CAMPO AN DICTIONARY :'),IDNAME) AS VARCHAR(500)) INSTRUCCION
										, ".__LINE__." ORDENADO FROM (
									
											SELECT ID,ENTRY IDNAME FROM CLX_DICTIONARY WHERE ENTRY LIKE 'GEN_LBL_RULE_GENAUTO%' AND ENTRY LIKE '%RU%'
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->temporary_supress_squote_change=true;
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '--  TRUNCATE VARIADOS TOOLS ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					$select.=" 
									-- TRUNCATE ALERTAS, ALGUNOS TOOLS
									SELECT CAST(CONCAT(CONCAT ('TRUNCATE TABLE ' ,CONCAT(CONCAT('&&CHAR_COMILLAS',TABLE_NAME),'&&CHAR_COMILLAS')),';') AS VARCHAR(500))  INSTRUCCION
										,".__LINE__." ORDENADO FROM ALL_TABLES WHERE OWNER='&&NAMETABLESPACE' AND SUBSTR(TABLE_NAME,1,4)!='BASE' AND SUBSTR(TABLE_NAME,1,4)!='ALRT' AND ( SUBSTR(TABLE_NAME,1,4)='ETL_' OR SUBSTR(TABLE_NAME,1,6)='CLX_PR' OR SUBSTR(TABLE_NAME,1,6)='CLX_BP') 
											AND TABLE_NAME !='BASE_IDCODES' AND TABLE_NAME !='BASE_DYNAMIC_RELATIONS_MASTER'
											AND TABLE_NAME !='CLX_PR_PROCESS'
											AND TABLE_NAME !='CLX_PR_SECTIONS'
											AND TABLE_NAME !='CLX_PR_PARAMETERS'
											AND TABLE_NAME !='CLX_PR_SCHEDULES'
										 ".$qunion." ".CHR(13).CHR(10);
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->temporary_supress_squote_change=true;
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}
					
					$select.="SELECT '-- BORRADO DE TABLAS VARIAS  ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					$select.="
									SELECT CAST(CONCAT(CONCAT(CONCAT (CONCAT('DELETE FROM ' ,CONCAT(CONCAT('&&CHAR_COMILLAS',TABLE_NAME),'&&CHAR_COMILLAS')) ,' WHERE MODULECODE NOT IN ('),'&&MODULES_PRINCIPAL2'),');')AS VARCHAR(500)) INSTRUCCION
										,".__LINE__." ORDENADO FROM ALL_TABLES WHERE OWNER='&&NAMETABLESPACE' AND SUBSTR(TABLE_NAME,1,6)='CLX_PR' 
											AND (TABLE_NAME ='CLX_PR_PROCESS'
												)
										 ".$qunion." ".CHR(13).CHR(10);
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->temporary_supress_squote_change=true;
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}
					
					$select.="SELECT '--TRUNCATE TABLES TOOLS ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					$select.="
									-- TRUNCATE TABLES LOGS, BUGS, CLX_SD, CLX_SK
									SELECT CAST(CONCAT(CONCAT('TRUNCATE TABLE ' ,CONCAT(CONCAT('&&CHAR_COMILLAS',TABLE_NAME),'&&CHAR_COMILLAS')),';') AS VARCHAR(500)) INSTRUCCION
										,".__LINE__." ORDENADO FROM ALL_TABLES WHERE OWNER='&&NAMETABLESPACE'  
											AND &&MODULESTRUNCATECLX
										 ".$qunion." ".CHR(13).CHR(10);
					
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->temporary_supress_squote_change=true;
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}
					
					$select.="SELECT '-- TRUNCATE DE VARIAS TABLAS ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					$select.="
									--TRUNCATE SEGUN MODULE TRUNCATE
									SELECT CAST(CONCAT(CONCAT(CONCAT(CONCAT(CONCAT('TRUNCATE TABLE ' ,MODULECODE),'_'),IDNAME),';-- TRUNCATE TABLE FROM DB_TABLES ID '),ID) AS VARCHAR(500)) INSTRUCCION
										,".__LINE__." ORDENADO FROM CLX_DB_TABLES WHERE &&MODULESTRUNCATE AND TYPE<>'VIEW'
										 ".$qunion." ".CHR(13).CHR(10);
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					}
			
					$select.="SELECT '-- BORRADO DE CLX_DB_FIELDS NO SE USAN ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					$select.="
									SELECT CONCAT(CONCAT(CONCAT(' DELETE FROM CLX_DB_FIELDS WHERE ID=',ID),'; -- NO SE USA EN NINGUNA TABLA FIELD:'),CAST(FIELDNAME AS VARCHAR(500))) INSTRUCCION
										,".__LINE__." ORDENADO   FROM CLX_DB_FIELDS Y 
											WHERE 
												NOT EXISTS
												(SELECT 1 FROM ALL_TAB_COLUMNS X WHERE OWNER='&&NAMETABLESPACE'   AND Y.FIELDNAME=X.COLUMN_NAME
										)  ".$qunion." ".CHR(13).CHR(10);
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->executeQuery($select);
						$select='';
					}
				
				
					$select.="SELECT '-- BORRADO DE CLX_AC_TREE_USERS NOT EXISTS EN CLX_AC_TREES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if ( strpos($MODULESTRUNCATECLX,'CLX_AC_TREE_USERS')==false) {
						$select.="
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_AC_TREE_USERS WHERE ID= ', ID),'; -- HUERPHAN AC_TREE_USERS :'),IDNAME) AS VARCHAR(500)) INSTRUCCION
											, ".__LINE__." ORDENADO FROM (
									
												SELECT Y.ID, USERNAME IDNAME FROM CLX_AC_TREE_USERS Y WHERE 
													NOT EXISTS(SELECT 1 FROM CLX_AC_TREES X WHERE X.USERNAME=Y.USERNAME)
											)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
						}	
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE CLX_AN_REPORTS  NOT EXISTS QUERYCODE, O MODULEDELETE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if ( strpos($MODULESTRUNCATECLX,'CLX_AN_REPORTS')==false) {
						$select.="
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_AC_TREE_USERS WHERE ID= ', ID),'; -- HUERPHAN  CLX_AN_REPORTS :'),IDNAME) AS VARCHAR(500)) INSTRUCCION
											,".__LINE__." ORDENADO FROM (
									
												SELECT Y.ID, USERNAME IDNAME  FROM CLX_AC_USER_FSECURE Y WHERE 
													NOT EXISTS(SELECT 1 FROM CLX_AC_TREES X WHERE X.USERNAME=Y.USERNAME)
											)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
						}
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE CLX_AC_USER_SESSIONS EN CLX_AC_TREES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if ( strpos($MODULESTRUNCATECLX,'CLX_AC_USER_SESSIONS')==false) {
						$select.="
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_AC_USER_SESSIONS WHERE ID= ', ID),'; -- HUERPHAN AC_USER_SESSIONS :'),IDNAME) AS VARCHAR(500)) INSTRUCCION
											, ".__LINE__." ORDENADO FROM (
											
											   SELECT Y.ID, USERNAME IDNAME  FROM CLX_AC_USER_SESSIONS Y WHERE 
												  NOT EXISTS(SELECT 1 FROM CLX_AC_USERS X WHERE X.USERNAME=Y.USERNAME)
											)  X ".$qunion." ".CHR(13).CHR(10);

						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
						}
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE BASE_COMP_COLO_REL NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if ( strpos($MODULESTRUNCATECLX,'BASE_COMP_COLO_REL')==false) {
						$select.="
										-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN BASE_COMP_COLO_REL
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM BASE_COMP_COLO_REL WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
											,".__LINE__." ORDENADO FROM (
									 
												SELECT Y.ID, Y.COMPLOC_CODE IDNAME,COMP_CODE  FROM BASE_COMP_COLO_REL  Y WHERE 
													&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
											)  X ".$qunion." ".CHR(13).CHR(10);
					
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
						}
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE BASE_HOLIDAY_CONFIGURATION NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if ( strpos($MODULESTRUNCATECLX,'BASE_COMP_COLO_REL')==false) {
						$select.=" 
										-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN BASE_HOLIDAY_CONFIGURATION
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM BASE_HOLIDAY_CONFIGURATION WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
											,".__LINE__." ORDENADO FROM (
										 
												SELECT Y.ID, Y.COMP_CODE IDNAME,COMP_CODE  FROM BASE_HOLIDAY_CONFIGURATION  Y WHERE 
													&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
											)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
						}
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE BASE_HOLIDAY_SCHEDULE NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if ( strpos($MODULESTRUNCATECLX,'BASE_HOLIDAY_SCHEDULE')==false) {
						$select.=" 
										-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN BASE_HOLIDAY_SCHEDULE
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM BASE_HOLIDAY_SCHEDULE WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
											,".__LINE__." ORDENADO FROM (
										 
												SELECT Y.ID, Y.IDNAME IDNAME,COMP_CODE  FROM BASE_HOLIDAY_SCHEDULE  Y WHERE 
													&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
											)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
						}
					}
	/// siempre comp_code esta vacio
			/*		$select.="SELECT '-- BORRADO DE BASE_PARAMETERS NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					$select.=" 
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN BASE_PARAMETERS
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM BASE_PARAMETERS WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.IDNAME IDNAME,COMP_CODE  FROM BASE_PARAMETERS  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
					if ($prueba_individual) {
						$select=strtr($select,$sustituir);
						ClxCommon::$db->executeQuery($select);
						$select='';
						
					} */
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE BASE_PROFIT_CENTERS_TBL NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if ( strpos($MODULESTRUNCATECLX,'BASE_PROFIT_CENTERS_TBL')==false) {
						$select.="
										-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN BASE_PROFIT_CENTERS_TBL
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM BASE_PROFIT_CENTERS_TBL WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
											,".__LINE__." ORDENADO FROM (
										 
												SELECT Y.ID, Y.IDCODE IDNAME,COMP_CODE  FROM BASE_PROFIT_CENTERS_TBL  Y WHERE 
													&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
											)  X ".$qunion." ".CHR(13).CHR(10);
										
						if ($prueba_individual) {
							$select=strtr($select,$sustituir); //ECHO $select;
							ClxCommon::$db->executeQuery($select);
							$select='';
						}			
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE BASE_REL_COMP_LOCS NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if ( strpos($MODULESTRUNCATECLX,'BASE_REL_COMP_LOCS')==false) {
						$select.="
										-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN BASE_REL_COMP_LOCS
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM BASE_REL_COMP_LOCS WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
											,".__LINE__." ORDENADO FROM (
										 
												SELECT Y.ID, Y.COMP_CODE IDNAME,COMP_CODE  FROM BASE_REL_COMP_LOCS  Y WHERE 
													&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
											)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
						}
					}
					if ($prueba_individual) {
						$select='';
					}
					$select.="SELECT '-- BORRADO DE CLX_AC_AUTHORIZATIONS NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if ( strpos($MODULESTRUNCATECLX,'CLX_AC_AUTHORIZATIONS')==false) {
						$select.="
										-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN CLX_AC_AUTHORIZATIONS
										SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_AC_AUTHORIZATIONS WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
											,".__LINE__." ORDENADO FROM (
									 
												SELECT Y.ID, Y.EVENT_NAME IDNAME,COMP_CODE  FROM CLX_AC_AUTHORIZATIONS  Y WHERE 
													&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
											)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
						}
					}
					if ($prueba_individual) {
						$select='';
					}
				/*	
					es una vista
					
						$select.="SELECT '-- BORRADO DE  CLX_DEFAULT_COMPANY_VIEW NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['CLX_DEFAULT_COMPANY_VIEW'])) {	
							$select.="
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN CLX_DEFAULT_COMPANY_VIEW
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DEFAULT_COMPANY_VIEW WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.SESSION_ID IDNAME FROM CLX_DEFAULT_COMPANY_VIEW  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					*/

					$select.="SELECT '-- BORRADO DE CLX_DEFAULT_SQL_COMPANY NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['CLX_DEFAULT_SQL_COMPANY'])&& strpos($MODULESTRUNCATECLX,'CLX_DEFAULT_SQL_COMPANY')==false) {
							$select.="	
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN CLX_DEFAULT_SQL_COMPANY
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_DEFAULT_SQL_COMPANY WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.SESSION_ID IDNAME,COMP_CODE  FROM CLX_DEFAULT_SQL_COMPANY  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE CLX_ETL_IMPORT_CFG NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['CLX_ETL_IMPORT_CFG'])&& strpos($MODULESTRUNCATECLX,'CLX_ETL_IMPORT_CFG')==false) {
							$select.="							
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN CLX_ETL_IMPORT_CFG
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_ETL_IMPORT_CFG WHERE ID= ',CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.IMST_CODE IDNAME,COMP_CODE  FROM CLX_ETL_IMPORT_CFG  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE CLX_ETL_OP_CLOSE NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['CLX_ETL_OP_CLOSE']) && strpos($MODULESTRUNCATECLX,'CLX_ETL_OP_CLOSE')==false) {
							$select.="	
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN CLX_ETL_OP_CLOSE
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_ETL_OP_CLOSE WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.FILE_NAME IDNAME,COMP_CODE FROM CLX_ETL_OP_CLOSE  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE CLX_ETL_OP_QUEUE NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['CLX_ETL_OP_QUEUE']) && strpos($MODULESTRUNCATECLX,'CLX_ETL_OP_QUEUE')==false ) {
							$select.="
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN CLX_ETL_OP_QUEUE
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_ETL_OP_QUEUE WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE) ),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.FILE_NAME IDNAME,COMP_CODE  FROM CLX_ETL_OP_QUEUE  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE CLX_PR_EXEC_SCH NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['CLX_PR_EXEC_SCH'])) {
							$select.="
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN CLX_PR_EXEC_SCH
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_PR_EXEC_SCH WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.RCTM_CODE IDNAME,COMP_CODE  FROM CLX_PR_EXEC_SCH  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE LOIN_INS_BALANCES NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['LOIN_INS_BALANCES'])) {
							$select.="	
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN LOIN_INS_BALANCES
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM LOIN_INS_BALANCES WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.LOAN_NO IDNAME,COMP_CODE  FROM LOIN_INS_BALANCES  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE BASE_HOLIDAY_SCHEDULE NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['OIN_INS_BALANCES_HIST'])) {
							$select.="			
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN LOIN_INS_BALANCES_HIST
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM LOIN_INS_BALANCES_HIST WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.LOAN_NO IDNAME,COMP_CODE  FROM LOIN_INS_BALANCES_HIST  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE LOIN_LOANS NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['LOIN_LOANS'])) {
							$select.="			
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN LOIN_LOANS
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM LOIN_LOANS WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.LOAN_NO IDNAME,COMP_CODE  FROM LOIN_LOANS  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE LOIN_LOANS_DATASRC NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['LOIN_LOANS_DATASRC'])) {
							$select.="		
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN LOIN_LOANS_DATASRC
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM LOIN_LOANS_DATASRC WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
										
											SELECT Y.ID, Y.IDCODE IDNAME,COMP_CODE  FROM LOIN_LOANS_DATASRC  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
									)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE LOIN_LOIN01_WRK NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['LOIN_LOIN01_WRK'])) {
							$select.="
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN LOIN_LOIN01_WRK
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM LOIN_LOIN01_WRK WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.COMP_CODE IDNAME,COMP_CODE  FROM LOIN_LOIN01_WRK  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE LOIN_TRANSACTIONS NOT EXISTS QUERYCODE, O MODULEDELETE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['LOIN_TRANSACTIONS'])) {

							$select.="	
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN LOIN_TRANSACTIONS
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM LOIN_TRANSACTIONS WHERE ID= ', ID),'CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.LOAN_NO IDNAME,COMP_CODE  FROM LOIN_TRANSACTIONS  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE LOIN_TRANSACTIONS_HIST NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['LOIN_TRANSACTIONS_HIST'])) {
							$select.="	
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN LOIN_TRANSACTIONS_HIST
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM LOIN_TRANSACTIONS_HIST WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.LOAN_NO IDNAME,COMP_CODE  FROM LOIN_TRANSACTIONS_HIST  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE RCAA_ACC_PERIODS NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['RCAA_ACC_PERIODS'])) {
							$select.="	
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN RCAA_ACC_PERIODS
									 SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM RCAA_ACC_PERIODS WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.IDCODE IDNAME,COMP_CODE  FROM RCAA_ACC_PERIODS  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);	
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE FROM RCAA_BALANCES_SUM NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['RCAA_BALANCES_SUM'])) {
							$select.="	
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN RCAA_BALANCES_SUM
									 SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM RCAA_BALANCES_SUM WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.RCTB_CODE IDNAME,COMP_CODE  FROM RCAA_BALANCES_SUM  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE CLX_AN_REPORTS NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['RCAA_JOURNAL_HDR'])) {
							$select.="	
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN RCAA_JOURNAL_HDR
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM RCAA_JOURNAL_HDR WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.IDCODE IDNAME,COMP_CODE  FROM RCAA_JOURNAL_HDR  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE RCAA_JOURNALS_EXP NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['RCAA_JOURNALS_EXP'])) {
							$select.="
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN RCAA_JOURNALS_EXP
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM RCAA_JOURNALS_EXP WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.RCAC_CODE IDNAME,COMP_CODE  FROM RCAA_JOURNALS_EXP  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE CLX_AN_REPORTS NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['RCAA_LEDGERS_BALANCES'])) {
							$select.="
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN RCAA_LEDGERS_BALANCES
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM RCAA_LEDGERS_BALANCES WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, CONCAT(CONCAT(Y.RCLE_CODE,','),RCAC_CODE) IDNAME,COMP_CODE  FROM RCAA_LEDGERS_BALANCES  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);	
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE RCAA_LEDGERS_BALANCES_TMP NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['RCAA_LEDGERS_BALANCES_TMP'])) {
							$select.="
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN RCAA_LEDGERS_BALANCES_TMP
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM RCAA_LEDGERS_BALANCES_TMP WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.RCAC_CODE IDNAME,COMP_CODE  FROM RCAA_LEDGERS_BALANCES_TMP  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);	
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE RCAA_RCBAL01_TMP NOT EXISTS COMPANIES  ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['RCAA_RCBAL01_TMP'])) {
							$select.="
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN RCAA_RCBAL01_TMP
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM RCAA_RCBAL01_TMP WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.RCTB_CODE IDNAME FROM RCAA_RCBAL01_TMP  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE RCAA_RECON_CNTL  NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['RCAA_RECON_CNTL'])) {
							$select.="	
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN RCAA_RECON_CNTL
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM RCAA_RECON_CNTL WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
										 
											SELECT Y.ID, Y.CLX_EFFTDATE IDNAME,COMP_CODE  FROM RCAA_RECON_CNTL  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE RCAA_RECON_TBL NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['RCAA_RECON_TBL'])) {
							$select.="	
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN RCAA_RECON_TBL
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM RCAA_RECON_TBL WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.IDCODE IDNAME,COMP_CODE  FROM RCAA_RECON_TBL  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE RCAA_SUBLEDGER_BALANCES NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['RCAA_SUBLEDGER_BALANCES'])) {
							$select.="	
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN RCAA_SUBLEDGER_BALANCES
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM RCAA_SUBLEDGER_BALANCES WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.RCTB_CODE IDNAME,COMP_CODE  FROM RCAA_SUBLEDGER_BALANCES  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE RCAA_SUBLEDGER_TRANS NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['RCAA_SUBLEDGER_TRANS'])) {
							$select.="	
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN RCAA_SUBLEDGER_TRANS
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM RCAA_SUBLEDGER_TRANS WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
										 
											SELECT Y.ID, Y.RCTB_CODE IDNAME,COMP_CODE  FROM RCAA_SUBLEDGER_TRANS  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE RCAA_SUBLEDGER_TRANS_UNIQUE_REG NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['RCAA_SUBLEDGER_TRANS_UNIQUE_REG'])) {
							$select.="	
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN RCAA_SUBLEDGER_TRANS_UNIQUE_REG
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM RCAA_SUBLEDGER_TRANS_UNIQUE_REG WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
								 
											SELECT Y.ID, Y.RCTB_CODE IDNAME,COMP_CODE  FROM RCAA_SUBLEDGER_TRANS_UNIQUE_REG  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);	
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE RCTA_MATCH_CALENDARS NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['RCTA_MATCH_CALENDARS'])) { 
							$select.=" 
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN RCTA_MATCH_CALENDARS
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM RCTA_MATCH_CALENDARS WHERE ID= ', ID),'CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.IDNAME IDNAME,COMP_CODE  FROM RCTA_MATCH_CALENDARS  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE RCTA_PARAMETERS_TBL NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['RCTA_PARAMETERS_TBL'])) {
							$select.="	
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN RCTA_PARAMETERS_TBL
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM RCTA_PARAMETERS_TBL WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.COMP_CODE IDNAME,COMP_CODE  FROM RCTA_PARAMETERS_TBL  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE RCTA_PARAMETERS_TBL_HIST NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['RCTA_PARAMETERS_TBL_HIST'])) {
							$select.="
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN RCTA_PARAMETERS_TBL_HIST
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM RCTA_PARAMETERS_TBL_HIST WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.COMP_CODE IDNAME,COMP_CODE  FROM RCTA_PARAMETERS_TBL_HIST  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE RCTA_TRN_MATCH_TBL NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['RCTA_TRN_MATCH_TBL'])) {
							$select.="	
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN RCTA_TRN_MATCH_TBL
									 SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM RCTA_TRN_MATCH_TBL WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.IDCODE IDNAME,COMP_CODE  FROM RCTA_TRN_MATCH_TBL  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE REDI_ABONOS_EXTRAORDINARIOS NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['REDI_ABONOS_EXTRAORDINARIOS'])) {
							$select.="	
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN REDI_ABONOS_EXTRAORDINARIOS
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM REDI_ABONOS_EXTRAORDINARIOS WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
										 
										  SELECT Y.ID, Y.REDI_NO IDNAME,COMP_CODE  FROM REDI_ABONOS_EXTRAORDINARIOS  Y WHERE 
										   &&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE CLX_AN_REPORTS NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['REDI_BALANCES'])) {
							$select.="	
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN REDI_BALANCES
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM REDI_BALANCES WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											  SELECT Y.ID, Y.REDI_NO IDNAME,COMP_CODE  FROM REDI_BALANCES  Y WHERE 
											   &&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE CLX_AN_REPORTS  NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['REDI_INVOICES'])) {
							$select.="
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN REDI_INVOICES
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM REDI_INVOICES WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.IDCODE IDNAME,COMP_CODE  FROM REDI_INVOICES  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE REDI_LOANS  NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['REDI_LOANS'])) {
							$select.="
									-- BORRADO DE REDI_LOANS POR REGISTRO DE COMPAÑIA NO EXISTE O BORRARLA
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM REDI_LOANS WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.LOAN_NO IDNAME,COMP_CODE  FROM REDI_LOANS  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);	
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE REDI_LOANS_DATASRC  NOT EXISTS COMPANIES ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['REDI_LOANS_DATASRC'])) {
							$select.="
									-- BORRADO DE REDI_LOANS_DATASRC POR REGISTRO DE COMPAÑIA NO EXISTE O BORRARLA
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM REDI_LOANS_DATASRC WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.IDCODE IDNAME,COMP_CODE  FROM REDI_LOANS_DATASRC  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE REDI_LOANS_DATASRC NOT EXISTS QUERYCODE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['REDI_LOANS_DATASRC'])) {
							$select.="
									-- BORRADO DE REDI_LOANS_DATASRC NOT EXISTS COMPANIES
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM REDI_LOANS_DATASRC WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.IDCODE IDNAME,COMP_CODE  FROM REDI_LOANS_DATASRC Y WHERE 
												NOT EXISTS(SELECT 1 FROM CLX_DB_QUERY X WHERE X.IDCODE=Y.REDS_QRYCODE)
										
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE REDI_PARAMETERS_TBL POR REGISTRO DE COMPAÑIA NO EXISTE O BORRARLA  ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['REDI_PARAMETERS_TBL'])) {
							$select.="
									-- BORRADO DE REDI_PARAMETERS_TBL POR REGISTRO DE COMPAÑIA NO EXISTE O BORRARLA
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM REDI_PARAMETERS_TBL WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.OPERATION_DATE IDNAME,COMP_CODE  FROM REDI_PARAMETERS_TBL  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE REDI_REDISCOUNTS POR REGISTRO DE COMPAÑIA NO EXISTE O BORRARLA ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['REDI_REDISCOUNTS'])) {
							$select.="
									-- BORRADO DE REDI_REDISCOUNTS POR REGISTRO DE COMPAÑIA NO EXISTE O BORRARLA
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM REDI_REDISCOUNTS WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.REDI_NO IDNAME,COMP_CODE  FROM REDI_REDISCOUNTS  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE REDI_RELO01_WRK POR REGISTRO DE COMPAÑIA NO EXISTE O BORRARLA ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['REDI_RELO01_WRK'])) {
							$select.="
									-- BORRADO DE REDI_RELO01_WRK POR REGISTRO DE COMPAÑIA NO EXISTE O BORRARLA
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM REDI_RELO01_WRK WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.RUNID IDNAME,COMP_CODE  FROM REDI_RELO01_WRK  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);	
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE REDI_TRANSACTIONS POR REGISTRO DE COMPAÑIA NO EXISTE O BORRARLA ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['REDI_TRANSACTIONS'])) {
							$select.="
									--'-- BORRADO DE REDI_TRANSACTIONS POR REGISTRO DE COMPAÑIA NO EXISTE O BORRARLA 
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM REDI_TRANSACTIONS WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.REDI_CODE IDNAME,COMP_CODE  FROM REDI_TRANSACTIONS  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}		
					$select.="SELECT '-- BORRADO DE USER_TRANSACCION_REDESCUENTOS POR REGISTRO DE COMPAÑIA NO EXISTE O BORRARLA ',".__LINE__."ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['USER_TRANSACCION_REDESCUENTOS'])) {
							$select.="
									-- BORRADO DE USER_TRANSACCION_REDESCUENTOS POR REGISTRO DE COMPAÑIA NO EXISTE O BORRARLA
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM USER_TRANSACCION_REDESCUENTOS WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.REDI_NO IDNAME FROM USER_TRANSACCION_REDESCUENTOS  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);	
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}	
					$select.="SELECT '-- BORRADO DE USER_TRANSACTIONS_HIST POR REGISTRO DE COMPAÑIA NO EXISTE O BORRARLA  ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['USER_TRANSACTIONS_HIST']) && strpos($MODULESTRUNCATECLX,'USER_TRANSACTIONS_HIST')==false)  {
							$select.="
									---- BORRADO DE USER_TRANSACTIONS_HIST POR REGISTRO DE COMPAÑIA NO EXISTE O BORRARLA 
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM USER_TRANSACTIONS_HIST WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
											 
											SELECT Y.ID, Y.REDI_CODE IDNAME,COMP_CODE  FROM USER_TRANSACTIONS_HIST  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}		
					$select.="SELECT '-- -- BORRADO DE CLX_SCHEDULER_IMPORT_ETL POR REGISTRO DE COMPAÑIA NO EXISTE O BORRARLA ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['CLX_SCHEDULER_IMPORT_ETL']) && strpos($MODULESTRUNCATECLX,'CLX_SCHEDULER_IMPORT_ETL')==false) {
							$select.="
									---- BORRADO DE CLX_SCHEDULER_IMPORT_ETL POR REGISTRO DE COMPAÑIA NO EXISTE O BORRARLA 
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_SCHEDULER_IMPORT_ETL WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.IMPORTCODE IDNAME,COMP_CODE  FROM CLX_SCHEDULER_IMPORT_ETL  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}		
					$select.="SELECT '-- BORRADO DE CLX_SCHEDULER_IMPORT  NOT EXISTS IMPORT OR COMPANIES ',".__LINE__."ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['CLX_SCHEDULER_IMPORT'])   && strpos($MODULESTRUNCATECLX,'CLX_SCHEDULER_IMPORT')==false) {
							$select.="
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN CLX_SCHEDULER_IMPORT
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM CLX_SCHEDULER_IMPORT WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
										 
											SELECT Y.ID, Y.IMPORTCODE IDNAME,COMP_CODE  FROM CLX_SCHEDULER_IMPORT  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
												OR NOT EXISTS (SELECT 1 FROM CLX_DB_IMPORTS X WHERE X.IDCODE=Y.IMPORTCODE)
										)  X ".$qunion." ".CHR(13).CHR(10);	
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
					}		
					$select.="SELECT '-- BORRADO DE RCTA_SCHEDULER_MATCHING NOT EXISTS QUERYCODE, O MODULEDELETE ',".__LINE__." ORDENADO FROM DUAL UNION ".CHR(13).CHR(10);
					if (isset($table['RCTA_SCHEDULER_MATCHING'])) {
							$select.="
									-- BORRADO DE REGISTRO POR COMPAÑia QUE NO EXISTA EN RCTA_SCHEDULER_MATCHING
									SELECT CAST(CONCAT(CONCAT(CONCAT('DELETE FROM RCTA_SCHEDULER_MATCHING WHERE ID= ', ID),CONCAT(';--   HUERPHAN OR DELETE  COMPANIES ',COMP_CODE)),IDNAME)AS VARCHAR(500))
										,".__LINE__." ORDENADO FROM (
									 
											SELECT Y.ID, Y.RCTM_CODE IDNAME,COMP_CODE  FROM RCTA_SCHEDULER_MATCHING  Y WHERE 
												&&ELIMINATE_COMPANIES OR NOT EXISTS(SELECT 1 FROM BASE_COMPANIES X WHERE X.IDCODE=Y.COMP_CODE)
										)  X ".$qunion." ".CHR(13).CHR(10);
								
						if ($prueba_individual) {
							$select=strtr($select,$sustituir);
							ClxCommon::$db->executeQuery($select);
							$select='';
							
						}				
							
													
					}
					
					if ($prueba_individual) {
						$select='';
						echo 'fin';
						return '';
					}		
					
					
					
					$select=substr($select, 0, strripos($select,' UNION '));
				
					
					$select.=") X 

								ORDER BY ORDENADO

								
						
					";
					$select=strtr($select,$sustituir);
					//pre($select);
				ClxCommon::$db->temporary_supress_squote_change=true;
				//pre($select);
				$rs = ClxCommon::$db->executeQuery($select);
				$salida='';
				$contdor=0;
				$listasalidas=array();
				$sal=fopen(kPathToWebSite.'temp/'.$name=(uniqid().'.sql'),'w+');
				$listasalidas[]=$name;
				while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
					$salida.= $r['INSTRUCCION'].chr(13).chr(10);
					$contador++;
					if ($contador/100001==  (int) ( $contador/100001)) {
						$salida.='commit;'.chr(13).chr(10);
						fwrite($sal,$salida);
						fclose($sal);
						$sal=fopen(kPathToWebSite.'temp/'.$name=(uniqid().'.sql'),'w+');
						$listasalidas[]=$name;
						$salida=' -- contuacion '.chr(13).chr(10);
					}
					else if ($contador/250==  (int) ( $contador/250)) {
						$salida.='commit;'.chr(13).chr(10);
						
					}
					
				}
				
				fwrite($sal,$salida);
		
				$salida='';
				$salida.='-- HISTORICOS  DROP TABLE '.CHR(13).CHR(10);
				IF ($_POST['CHECKBOX_DROP_HISTORIC'] ) {

					if (kDatabaseType == 'oci') {
						$sql = 'SELECT TABLE_NAME FROM ALL_TABLES WHERE TABLE_NAME LIKE \'%_HIST\' AND OWNER='. singlequote( $TABLESPACE  ). ' ORDER BY TABLE_NAME';
					}
					else {
						$sql = 'SELECT TABLE_NAME FROM PERFORMANCE_SCHEMA.TABLES WHERE TABLE_NAME LIKE \'%_HIST\'  AND TABLE_SCHEMA='. singlequote( $TABLESPACE  ). ' ORDER BY TABLE_NAME';
					}


					
					$selected='false';
					$rs = ClxCommon::$db->executeQuery($sql);
					
					while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
						$salida.= 'DROP TABLE '.$r['TABLE_NAME'].';'.CHR(13).CHR(10);
						$contador++;
						if ($contador/100001==  (int) ( $contador/100001)) {
							$salida.='commit;'.chr(13).chr(10);
							fwrite($sal,$salida);
							fclose($sal);
							$sal=fopen(kPathToWebSite.'temp/'.$name=(uniqid().'.sql'),'w+');
							$listasalidas[]=$name;
							$salida=' -- contuacion '.chr(13).chr(10);
						}
						else if ($contador/250==  (int) ( $contador/250)) {
							$salida.='commit;'.chr(13).chr(10);
						
						}
					}
				}
				fwrite($sal,$salida);
				
			//	pre($_POST);
				
				IF ($_POST['CHECKBOX_RESET_BASE_CODES']==1) {
					$sql= " SELECT CAST(CONCAT(CONCAT('UPDATE BASE_IDCODES SET LAST_IDCODE= CASE WHEN ',CONCAT(TABLECODE,'.MAX <>''''  THEN  ')), CONCAT(CONCAT( CONCAT(TABLECODE,'.MAX  ELSE '), CONCAT(CONCAT('''',REPLACE(IDCODE_FORMAT ,'#','0')),'''')) ,'  END ')) AS VARCHAR(500)) SQL FROM BASE_IDCODES ";

					$sql=strtr($sql,$sustituir);
					$rs = ClxCommon::$db->executeQuery($sql);
					$sql_texto='';
					while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
						$sql_texto.=$r['SQL'].';'.CHR(13).CHR(10);
						$contador++;
					}
					$sql2 = "SELECT IDCODE, CONCAT( '  SELECT MAX(IDCODE) IDCODE FROM ', CONCAT( CONCAT( MODULECODE, CONCAT('_' , IDNAME ) ) ,'  '   ) ) MAXIMO FROM CLX_DB_TABLES Y WHERE EXISTS (SELECT 1 FROM BASE_IDCODES X WHERE X.TABLECODE=Y.IDCODE AND EXISTS ( SELECT 1 FROM CLX_DB_TABLEFIELDS R WHERE R.TABLECODE=X.TABLECODE AND R.FIELDNAME='IDCODE'))";
					
					$rs = ClxCommon::$db->executeQuery($sql2);
					while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
						
						$sql_texto=str_replace($r['IDCODE'].'.MAX',singlequote(ClxCommon::$db->getone($r['MAXIMO'])),$sql_texto);
						$contador++;
						if ($contador/250==  (int) ( $contador/250))
							$sql_texto.='commit;'.chr(13).chr(10);
					}
					
					fwrite($sal,$sql_texto);
				
				}
				////	pre($_POST);
				IF ( $_POST['CHECKBOX_RESET_BASE_SEQUENCE']==1) {
				
					$sql_texto='';
					$sql="SELECT CONCAT( CONCAT('ALTER SEQUENCE ',  X.OBJECT_NAME  ) ,' RESTART START WITH ') OBJECT1, CONCAT('SELECT MAX(ID) FROM ', CONCAT(CONCAT( ' ',Y.MODULECODE),CONCAT('_', Y.IDNAME))) OBJECT2 FROM ALL_OBJECTS X,CLX_DB_TABLES Y WHERE OWNER='&&NAMETABLESPACE' AND OBJECT_NAME NOT LIKE '%$%' AND OBJECT_TYPE='SEQUENCE' AND  X.OBJECT_NAME=CONCAT('S',CONCAT(Y.MODULECODE,REPLACE(Y.IDNAME, '_','')))";
					$sql=strtr($sql,$sustituir);
					$rs = ClxCommon::$db->executeQuery($sql);
					
					while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
						$valor=ClxCommon::$db->getOne($r['OBJECT2']);
						if (empty($valor))
							$valor=0;
						$sql_texto.=$r['OBJECT1'].' '.$valor .';'.CHR(13).CHR(10);
						$contador++;
						if ($contador/250==  (int) ( $contador/250))
							$sql_texto.='commit;'.chr(13).chr(10);
					
					}
					fwrite($sal,$sql_texto);
				
					$sql_texto='';
					
					$sql="	select * from (
							SELECT OBJECT_NAME,OBJECT_ID,OBJECT_TYPE,OWNER FROM ALL_OBJECTS X LEFT JOIN CLX_DB_TABLES Y ON
                               OBJECT_TYPE='SEQUENCE' AND
								X.OBJECT_NAME=CONCAT('S',CONCAT(Y.MODULECODE,REPLACE(Y.IDNAME, '_',''))
                               ) WHERE  OWNER='".$TABLESPACE."' AND IDCODE IS NULL AND OBJECT_TYPE='SEQUENCE'
                              AND SUBSTR(OBJECT_NAME,2,4) NOT IN ( 'ALRT','BASE')
                            AND SUBSTR(OBJECT_NAME,2,3) NOT IN ('CLX')  ) X ";



						;
					$sql=strtr($sql,$sustituir);
					$rs = ClxCommon::$db->executeQuery($sql);
					while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
						$sql_texto.=' DROP SEQUENCE '.$r['OBJECT_NAME'].'; -- OBJETO ORACLE '.$r['OBJECT_ID'] .CHR(13).CHR(10);
						$contador++;
						
						if ($contador/250==  (int) ( $contador/250))
							$sql_texto.='commit;'.chr(13).chr(10);
						
					}
					fwrite($sal,$sql_texto);
					$sql_texto='';
					$sql="select * from (
							 SELECT OBJECT_NAME,OBJECT_ID,OBJECT_TYPE,OWNER FROM ALL_OBJECTS X LEFT JOIN CLX_DB_TABLES Y ON
                               OBJECT_TYPE='TRIGGER' AND
								X.OBJECT_NAME=CONCAT('S',CONCAT(Y.MODULECODE,REPLACE(Y.IDNAME, '_',''))
                               ) WHERE  OWNER='".$TABLESPACE."' AND IDCODE IS NULL AND OBJECT_TYPE='TRIGGER'
                              AND SUBSTR(OBJECT_NAME,2,4) NOT IN ( 'ALRT','BASE')
                            AND SUBSTR(OBJECT_NAME,2,3) NOT IN ('CLX')  ) X  "      ;
					$sql=strtr($sql,$sustituir);
					$rs = ClxCommon::$db->executeQuery($sql);
					while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
						$sql_texto.=' DROP TRIGGER '.$r['OBJECT_NAME'].'; -- OBJETO ORACLE '.$r['OBJECT_ID'] .CHR(13).CHR(10);
						$contador++;
						if ($contador/250==  (int) ( $contador/250))
							$sql_texto.='commit;'.chr(13).chr(10);
					}
					fwrite($sal,$sql_texto);
				
				}
				
				
				fwrite($sal,$sql_texto);
				fwrite($sal,'commit;'.chr(13).chr(10));
				fclose($sal);
				//echo ;
				$download='';
				
				foreach($listasalidas as $key=>$valorname) {
					$rkey=$key+1;
					$download.='<a href='.kWebSite.'/temp/'.$valorname.'>Download_'.$rkey.'</a><br>';
				}
				return NOTE(dict('GEN_LBL_CREATE_FILE', $contador,$download)).'<br>';		
        
    }

    

}
