SHOW TABLES LIKE 'PROC_PROCESSES';
SHOW TABLES LIKE 'PROC_PROCESSES';
DROP VIEW PROC_PROCESSES;
CREATE VIEW PROC_PROCESSES AS SELECT  ID, IDCODE, IDNAME, DESCRIPTION, MODULECODE MCODE, STATUS, PRIORITY_SEQNUM, PARAMETERS_TABLE, VERSION, VERSION_COUNTER, CDATE, MDATE, CREATEDBY, MODIFIEDBY
FROM CLX_PR_PROCESS;
SHOW TABLES LIKE 'PROC_PROCESS_SECTIONS';
SHOW TABLES LIKE 'PROC_PROCESS_SECTIONS';
DROP VIEW PROC_PROCESS_SECTIONS;
CREATE VIEW PROC_PROCESS_SECTIONS AS SELECT ID, IDCODE, IDNAME, IS_MAINSECTION, STATUS, PROCESSCODE, DESCRIPTION, VERSION, VERSION_COUNTER, CDATE, MDATE
FROM CLX_PR_SECTIONS;
SHOW TABLES LIKE 'PROC_PROCESS_STEPS';
SHOW TABLES LIKE 'PROC_PROCESS_STEPS';
DROP VIEW PROC_PROCESS_STEPS;
CREATE VIEW PROC_PROCESS_STEPS AS SELECT OWNERID SECTIONCODE,OWNERCODE,ACTION CODE_TYPE,EVENT,EXTRA2 CODE_TEXT,EXTRA3 CODE_LIBRARY,DO_SECTION,DO_SECTION_TYPE,SEQNUM,STATUS
FROM CLX_EVENTS;
SHOW TABLES LIKE 'PROC_PROCESS_SCHEDULES';
SHOW TABLES LIKE 'PROC_PROCESS_SCHEDULES';
DROP VIEW PROC_PROCESS_SCHEDULES;
CREATE VIEW PROC_PROCESS_SCHEDULES AS SELECT ID,IDCODE,IDNAME,PROCESSCODE,NOTES,OWNERCODE,PROC_STATUS,STATUS,IS_DEBUG,IS_DISPLAY,LOG_METHOD,PR_VALUE,TOUSER,NOTIFY_STATUS,SUBJECT,MESSAGE,CREATE_TASK,CREATE_ALERT,SEND_EMAIL,PR_RECURRENCE,BATCH_PID,NEXT_RUN_TIME,CDATE,MDATE,CREATEDBY,MODIFIEDBY
FROM CLX_PR_SCHEDULES;
SHOW TABLES LIKE 'PROC_PROCESS_LOG';
SHOW TABLES LIKE 'PROC_PROCESS_LOG';
DROP VIEW PROC_PROCESS_LOG;
CREATE VIEW PROC_PROCESS_LOG AS SELECT 
  ID, 
  PROCESSCODE, EXECUTEDBY, SDATE, EDATE, PROCESS_MSG, PROC_STATUS, SCHEDULECODE SCHEDULE_CODE, BATCH_PID
FROM CLX_PR_PROC_LOGS;
SHOW TABLES LIKE 'PROC_PROCESS_PARAMETERS';
SHOW TABLES LIKE 'PROC_PROCESS_PARAMETERS';
DROP VIEW PROC_PROCESS_PARAMETERS;
CREATE VIEW PROC_PROCESS_PARAMETERS AS SELECT ID,PROCESSCODE,IDNAME,FIELDNAME,VERSION,VERSION_COUNTER,CDATE,MDATE
FROM CLX_PR_PARAMETERS;
SHOW TABLES LIKE 'PROC_SCHEDULE_PARAMETERS';
SHOW TABLES LIKE 'PROC_SCHEDULE_PARAMETERS';
DROP VIEW PROC_SCHEDULE_PARAMETERS;
CREATE VIEW PROC_SCHEDULE_PARAMETERS AS SELECT ID, SCHEDULECODE, FIELDNAME, PARAMETER_VALUE
FROM CLX_PR_SCHED_PRMTS;
SHOW TABLES LIKE 'GL_CUR_BALANCE_VW';
SHOW TABLES LIKE 'GL_CUR_BALANCE_VW';
DROP VIEW GL_CUR_BALANCE_VW;
CREATE VIEW GL_CUR_BALANCE_VW AS SELECT
	0 ID,
	A.LEDGER_CODE,
	A.FISCAL_PERIOD,
	A.GLACCOUNTCODE,
	GLAC.GL_TYPE,
	GLAC.TRUST_ITEM_TYPE,
	A.COMP_CODE,
	A.CHART_FIELD01,
	A.CHART_FIELD02,
	A.CHART_FIELD03,
	A.CHART_FIELD04,
	A.CURRENCY_CODE,
	SUM(A.BALANCE_AMT) BALANCE_AMT,
	SUM(A.BASE_BAL_AMT) BASE_BAL_AMT
FROM
	GL_LEDGERS A,
	GL_CODES_TBL GLAC,
	GL_PARAMETERS_TBL GLCP
WHERE 
	GLAC.IDCODE = A.GLACCOUNTCODE
	AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE
	AND GLCP.COMP_CODE = A.COMP_CODE
GROUP BY
	A.LEDGER_CODE,
	A.FISCAL_PERIOD,
	A.GLACCOUNTCODE,
	A.COMP_CODE,
	A.CHART_FIELD01,
	A.CHART_FIELD02,
	A.CHART_FIELD03,
	A.CHART_FIELD04,
	A.CURRENCY_CODE;
SHOW TABLES LIKE 'GL_OPER_BALANCE_VW';
SHOW TABLES LIKE 'GL_OPER_BALANCE_VW';
DROP VIEW GL_OPER_BALANCE_VW;
CREATE VIEW GL_OPER_BALANCE_VW AS SELECT 
	JEHD.ID,
	JEHD.IDCODE JEHDR_CODE,
	LEGI.LEDGER_CODE,
	JELN.GLACCOUNTCODE,
	JELN.CHART_FIELD01,
	JELN.CHART_FIELD02,
	JELN.CHART_FIELD03,
	JELN.CHART_FIELD04,
	JELN.CURRENCY_CODE,
	GLAC.GL_TYPE,
	(CASE GLAC.GL_TYPE 
	   WHEN 'AS' THEN 1
	   WHEN 'EX' THEN 1
           WHEN 'CO' THEN 1
     WHEN 'OR' THEN 1
	   ELSE -1
	END) *
	(CASE GLAC.PROVISION
	WHEN 1 THEN -1
	ELSE  1
	END) GLAC_SIGN,
	IFNULL((SELECT SUM(JCBV.BALANCE_AMT) 
FROM 
	GL_CUR_BALANCE_VW JCBV
WHERE 
	JCBV.GLACCOUNTCODE = JELN.GLACCOUNTCODE
     AND JCBV.LEDGER_CODE = LEGI.LEDGER_CODE
     /*AND JCBV.FISCAL_PERIOD = JEHD.FISCAL_PERIOD*/
     AND JCBV.GLACCOUNTCODE = JELN.GLACCOUNTCODE
     AND JCBV.COMP_CODE = JEHD.COMP_CODE
     AND JCBV.CHART_FIELD01 = JELN.CHART_FIELD01
     AND JCBV.CHART_FIELD02 = JELN.CHART_FIELD02
     AND ((CASE GLAC.GL_TYPE
					WHEN 'AS' THEN IFNULL(JCBV.CHART_FIELD03,'NA') = IFNULL(JELN.CHART_FIELD03,'NA')
					WHEN 'LI' THEN IFNULL(JCBV.CHART_FIELD03,'NA') = IFNULL(JELN.CHART_FIELD03,'NA')
					ELSE  1=1
					END))
			AND ((CASE GLAC.GL_TYPE
					WHEN 'AS' THEN IFNULL(JCBV.CHART_FIELD04,'NA') = IFNULL(JELN.CHART_FIELD04,'NA')
					WHEN 'LI' THEN IFNULL(JCBV.CHART_FIELD04,'NA') = IFNULL(JELN.CHART_FIELD04,'NA')
					ELSE  1=1
					END))
     /*AND (IFNULL(JCBV.CHART_FIELD03,'NA') = IFNULL(JELN.CHART_FIELD03,'NA'))
     AND (IFNULL(JCBV.CHART_FIELD04,'NA') = IFNULL(JELN.CHART_FIELD04,'NA'))*/
     AND JCBV.CURRENCY_CODE = JELN.CURRENCY_CODE),0) BALANCE_AMT,
	SUM(DEBIT_AMT-CREDIT_AMT) POSTED_AMT,
	IFNULL((SELECT SUM(JCBV.BALANCE_AMT) 
	FROM GL_CUR_BALANCE_VW JCBV
	WHERE JCBV.GLACCOUNTCODE = JELN.GLACCOUNTCODE
	     AND JCBV.LEDGER_CODE = LEGI.LEDGER_CODE
	     /*AND JCBV.FISCAL_PERIOD = JEHD.FISCAL_PERIOD*/
	     AND JCBV.GLACCOUNTCODE = JELN.GLACCOUNTCODE
	     AND JCBV.COMP_CODE = JEHD.COMP_CODE
	     AND JCBV.CHART_FIELD01 = JELN.CHART_FIELD01
	     AND JCBV.CHART_FIELD02 = JELN.CHART_FIELD02
			 AND ((CASE GLAC.GL_TYPE
					WHEN 'AS' THEN IFNULL(JCBV.CHART_FIELD03,'NA') = IFNULL(JELN.CHART_FIELD03,'NA')
					WHEN 'LI' THEN IFNULL(JCBV.CHART_FIELD03,'NA') = IFNULL(JELN.CHART_FIELD03,'NA')
					ELSE  1=1
					END))
			AND ((CASE GLAC.GL_TYPE
					WHEN 'AS' THEN IFNULL(JCBV.CHART_FIELD04,'NA') = IFNULL(JELN.CHART_FIELD04,'NA')
					WHEN 'LI' THEN IFNULL(JCBV.CHART_FIELD04,'NA') = IFNULL(JELN.CHART_FIELD04,'NA')
					ELSE  1=1
					END))
			 /*AND (IFNULL(JCBV.CHART_FIELD03,'NA') = IFNULL(JELN.CHART_FIELD03,'NA'))
       AND (IFNULL(JCBV.CHART_FIELD04,'NA') = IFNULL(JELN.CHART_FIELD04,'NA'))*/
	     AND JCBV.CURRENCY_CODE = JELN.CURRENCY_CODE
	),0) +
	SUM(DEBIT_AMT-CREDIT_AMT) FINAL_BAL_AMT
FROM 
	GL_LED_GITEMS_TBL LEGI,
	GL_JOURNAL_HDR JEHD,
	GL_JOURNAL_LINES JELN,
	GL_CODES_TBL GLAC,
	GL_PARAMETERS_TBL GLCP
WHERE 
	JEHD.IDCODE = JELN.JEHDR_CODE
	AND GLCP.COMP_CODE = JEHD.COMP_CODE
	AND GLAC.IDCODE = JELN.GLACCOUNTCODE
	AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE
	AND LEGI.LGGROUP_CODE = JEHD.LGGROUP_CODE
	AND GLAC.ALLOW_OVERDRAFT = 0
GROUP BY 
	JEHD.ID,
	JEHD.IDCODE, 
	GLAC.GL_TYPE, 
	GLAC.PROVISION,
	JELN.GLACCOUNTCODE, 
  JELN.CHART_FIELD01,
	JELN.CHART_FIELD02,
	JELN.CHART_FIELD03,
	JELN.CHART_FIELD04,
	LEGI.LEDGER_CODE, 
	JELN.CURRENCY_CODE;
SHOW TABLES LIKE 'GL_AC_BALANCE_VW';
SHOW TABLES LIKE 'GL_AC_BALANCE_VW';
DROP VIEW GL_AC_BALANCE_VW;
CREATE VIEW GL_AC_BALANCE_VW AS SELECT 
  0 ID,
  LEBA.LEDGER_CODE,
  LEBA.FISCAL_PERIOD,
  LEBA.GLACCOUNTCODE,
  GLAC.GL_TYPE,
  GLAC.TRUST_ITEM_TYPE,
  LEBA.COMP_CODE,
  LEBA.CHART_FIELD01,
  LEBA.CHART_FIELD02,
  LEBA.CHART_FIELD03,
  LEBA.CHART_FIELD04,
  LEBA.CURRENCY_CODE,
  SUM(LEBA.DEBITS) DEBITS,
  SUM(LEBA.CREDITS) CREDITS,
  SUM(LEBA.BASE_DEBITS) BASE_DEBITS,
  SUM(LEBA.BASE_CREDITS) BASE_CREDITS,
  SUM(LEBA.ADJUST_AMT) ADJUST_AMT,
  SUM(LEBA.BASE_ADJUST_AMT) BASE_ADJUST_AMT,
  SUM(LEBA.BALANCE_AMT) BALANCE_AMT,
  SUM(LEBA.BASE_BAL_AMT) BASE_BAL_AMT
FROM 
  GL_LEDGERS LEBA,
  GL_PARAMETERS_TBL GLCP,
  GL_CODES_TBL GLAC
WHERE   
  GLCP.COMP_CODE = LEBA.COMP_CODE
  AND GLCP.DEF_LEDGER_CODE = LEBA.LEDGER_CODE 
  AND GLAC.IDCODE = LEBA.GLACCOUNTCODE
  AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE
GROUP BY
  LEBA.LEDGER_CODE,
  LEBA.FISCAL_PERIOD,
  LEBA.GLACCOUNTCODE,
  GLAC.GL_TYPE,
  GLAC.TRUST_ITEM_TYPE,
  LEBA.COMP_CODE,
  LEBA.CHART_FIELD01,
  LEBA.CHART_FIELD02,
  LEBA.CHART_FIELD03,
  LEBA.CHART_FIELD04,
  LEBA.CURRENCY_CODE;
SHOW TABLES LIKE 'GL_COMP_CLOSING_VW';
SHOW TABLES LIKE 'GL_COMP_CLOSING_VW';
DROP VIEW GL_COMP_CLOSING_VW;
CREATE VIEW GL_COMP_CLOSING_VW AS SELECT
	GLCP.COMP_CODE,
	GLCP.CLOSING_PERIOD,
	GLCP.FMTH_FISCALYEAR,
	GLCP.OPERATION_DATE,
	CASE
	(((GLCP.FMTH_FISCALYEAR-DATE_FORMAT(GLCP.OPERATION_DATE,"%c")-1)/GLCP.CLOSING_PERIOD) -
	TRUNCATE((GLCP.FMTH_FISCALYEAR-DATE_FORMAT(GLCP.OPERATION_DATE,"%c")-1)/GLCP.CLOSING_PERIOD,0))
	WHEN 0 THEN 1
	ELSE 0
	END CLOSING_ENTRY,
	CASE
	DATEDIFF(LAST_DAY(DATE_FORMAT(GLCP.OPERATION_DATE,"%Y-%m%-01") ),GLCP.OPERATION_DATE)
	WHEN 0 THEN 1
	ELSE 0
	END MONTH_END,
	CASE (DATE_FORMAT(DATE_ADD(GLCP.OPERATION_DATE, INTERVAL 1 DAY),"%c")-GLCP.FMTH_FISCALYEAR)
	WHEN 0 THEN 1
	ELSE 0
	END FISCAL_YEAR_END
FROM 
	GL_PARAMETERS_TBL GLCP
WHERE GLCP.CLOSING_PERIOD>0
ORDER BY GLCP.COMP_CODE;
SHOW TABLES LIKE 'GL_FICO_CLOSING_VW';
SHOW TABLES LIKE 'GL_FICO_CLOSING_VW';
DROP VIEW GL_FICO_CLOSING_VW;
CREATE VIEW GL_FICO_CLOSING_VW AS SELECT
	GLCP.COMP_CODE,
	FICO.IDCODE CHART_FIELD01,
	FICO.CLOSING_PERIOD,
	FICO.FMTH_FISCALYEAR,
	GLCP.OPERATION_DATE,
	CASE
	(((FICO.FMTH_FISCALYEAR-DATE_FORMAT(GLCP.OPERATION_DATE,"%c")-1)/FICO.CLOSING_PERIOD) -
	TRUNCATE((FICO.FMTH_FISCALYEAR-DATE_FORMAT(GLCP.OPERATION_DATE,"%c")-1)/FICO.CLOSING_PERIOD,0))
	WHEN 0 THEN 1
	ELSE 0
	END CLOSING_ENTRY,
	CASE
	DATEDIFF(LAST_DAY(DATE_FORMAT(GLCP.OPERATION_DATE,"%Y-%m%-01") ),GLCP.OPERATION_DATE)
	WHEN 0 THEN 1
	ELSE 0
	END MONTH_END,
	CASE (DATE_FORMAT(DATE_ADD(GLCP.OPERATION_DATE, INTERVAL 1 DAY),"%c")-GLCP.FMTH_FISCALYEAR)
	WHEN 0 THEN 1
	ELSE 0
	END FISCAL_YEAR_END
FROM 
	GL_PARAMETERS_TBL GLCP,
	FIDU_CONTRACTS FICO
WHERE 
	FICO.COMP_CODE = GLCP.COMP_CODE
	AND FICO.CLOSING_PERIOD>0
	AND FICO.FMTH_FISCALYEAR>0
	AND FICO.CONTRACT_STATUS = 'ACTI'
ORDER BY GLCP.COMP_CODE,FICO.IDCODE;
SHOW TABLES LIKE 'GL_FIPA_CLOSING_VW';
SHOW TABLES LIKE 'GL_FIPA_CLOSING_VW';
DROP VIEW GL_FIPA_CLOSING_VW;
CREATE VIEW GL_FIPA_CLOSING_VW AS SELECT
	GLCP.COMP_CODE,
	FICO.IDCODE CHART_FIELD01,
	FIPA.ACCOUNTCODE CHART_FIELD02,
	FIPA.CAP_PERIOD,
DATE_SUB(GLCP.OPERATION_DATE, INTERVAL FIPA.CAP_PERIOD MONTH) PERIOD_START_DATE,
	GLCP.OPERATION_DATE,
	CASE
	((DATE_FORMAT(GLCP.OPERATION_DATE,"%c")/FIPA.CAP_PERIOD) -
	TRUNCATE(DATE_FORMAT(GLCP.OPERATION_DATE,"%c")/FIPA.CAP_PERIOD,0))
	WHEN 0 THEN 1
	ELSE 0
	END CLOSING_ENTRY,
	CASE
	DATEDIFF(LAST_DAY(DATE_FORMAT(GLCP.OPERATION_DATE,"%Y-%m%-01") ),GLCP.OPERATION_DATE)
	WHEN 0 THEN 1
	ELSE 0
	END MONTH_END
FROM
	GL_PARAMETERS_TBL GLCP,
	FIDU_CONTRACTS FICO,
	FIDU_PARTICIPANTS FIPA
WHERE
	GLCP.COMP_CODE = FICO.COMP_CODE
	AND FIPA.CONTRACT_CODE = FICO.IDCODE
	AND FICO.CONTRACT_STATUS = 'ACTI'
	AND FIPA.STATUS = 'A'
	AND FIPA.CAP_PERIOD > 0
ORDER BY GLCP.COMP_CODE, FICO.IDCODE, FIPA.ACCOUNTCODE;
SHOW TABLES LIKE 'FIDU_FIBK_BALANCE_VW';
SHOW TABLES LIKE 'FIDU_FIBK_BALANCE_VW';
DROP VIEW FIDU_FIBK_BALANCE_VW;
CREATE VIEW FIDU_FIBK_BALANCE_VW AS SELECT 
  FIBK.ID,
  FIBK.COMP_CODE,
  FIBK.BANK_ACCOUNT_NO,
  PRAT.GLGROUP_CODE,
  FIAS.CONTRACT_CODE CHART_FIELD01,
  FIPA.ACCOUNTCODE CHART_FIELD02,
  FIAS.IDCODE CHART_FIELD03,
  PRAT.PRO_GL_CODE,
  IFNULL((SELECT SUM(JABV.BALANCE_AMT)
    FROM GL_AC_BALANCE_VW JABV
    WHERE JABV.CHART_FIELD03 = FIAS.IDCODE
    AND JABV.CHART_FIELD02 = FIPA.ACCOUNTCODE
    AND JABV.CHART_FIELD03 = FIAS.IDCODE
    AND PRAT.PRO_GL_CODE = JABV.GLACCOUNTCODE),0) BALANCE_AMT,
  PRAT.AR_GL_CODE,
  IFNULL((SELECT SUM(JABV.DEBITS+JABV.ADJUST_AMT)
    FROM GL_AC_BALANCE_VW JABV
    WHERE JABV.CHART_FIELD03 = FIAS.IDCODE
    AND JABV.CHART_FIELD02 = FIPA.ACCOUNTCODE
    AND JABV.CHART_FIELD03 = FIAS.IDCODE
    AND PRAT.AR_GL_CODE = JABV.GLACCOUNTCODE),0) INTEARNED_AMT,
 IFNULL((SELECT SUM(JABV.CREDITS+JABV.ADJUST_AMT)
    FROM GL_AC_BALANCE_VW JABV
    WHERE JABV.CHART_FIELD03 = FIAS.IDCODE
    AND JABV.CHART_FIELD02 = FIPA.ACCOUNTCODE
    AND JABV.CHART_FIELD03 = FIAS.IDCODE
    AND PRAT.AR_GL_CODE = JABV.GLACCOUNTCODE),0) INTPAID_AMT
FROM 
  CRM_PRODUCTS PROD,
  GL_PROD_PRMTR_TBL PRAT,
  FIDU_BANK_ACCOUNTS FIBK, 
  FIDU_ITEMS FIAS,
  FIDU_PARTICIPANTS FIPA
  WHERE
  FIBK.BANK_ACCOUNT_NO = FIAS.FIDU_BANKACT_CODE
  AND FIPA.CONTRACT_CODE = FIAS.CONTRACT_CODE
  AND PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE
  AND PROD.IDCODE = FIBK.BANK_PROD_CODE;
SHOW TABLES LIKE 'GL_JOURNAL_VW';
SHOW TABLES LIKE 'GL_JOURNAL_VW';
DROP VIEW GL_JOURNAL_VW;
CREATE VIEW GL_JOURNAL_VW AS SELECT 
  JEHD.COMP_CODE,
  JELN.CHART_FIELD01,
  JELN.CHART_FIELD02,
  JELN.CHART_FIELD03,
  JELN.CHART_FIELD04,
  JELN.CURRENCY_CODE,
  JELN.GLACCOUNTCODE,
  JEHD.EFFTDATE,
  SUM(JELN.DEBIT_TRANS_AMT) DEBITS,
  SUM(JELN.CREDIT_TRANS_AMT) CREDITS,
  SUM(JELN.DEBIT_AMT) BASE_DEBITS,
  SUM(JELN.CREDIT_AMT) BASE_CREDITS
FROM 
  GL_JOURNAL_HDR JEHD,
  GL_JOURNAL_LINES JELN
WHERE 
  JEHD.IDCODE = JELN.JEHDR_CODE
  AND JEHD.JE_STATUS = 'AP'
GROUP BY 
  JEHD.COMP_CODE,
  JEHD.JE_SOURCE,
  JELN.CHART_FIELD01,
  JELN.CHART_FIELD02,
  JELN.CHART_FIELD03,
  JELN.CHART_FIELD04,
  JELN.CURRENCY_CODE,
  JELN.GLACCOUNTCODE,
  JEHD.EFFTDATE;
SHOW TABLES LIKE 'CRM_CONTACTS_DUPS_VW';
SHOW TABLES LIKE 'CRM_CONTACTS_DUPS_VW';
DROP VIEW CRM_CONTACTS_DUPS_VW;
CREATE VIEW CRM_CONTACTS_DUPS_VW AS SELECT 
MIN(ID) ID, 
CONT.LASTNAME,CONT.FIRSTNAME ,COUNT(*) REC_COUNT
 FROM 
 CRM_CONTACTS CONT 
GROUP BY 
CONT.LASTNAME,CONT.FIRSTNAME
HAVING COUNT(*) > 1
ORDER BY 
CONT.LASTNAME ASC,CONT.FIRSTNAME ASC;
SHOW TABLES LIKE 'CRM_CONTACT_EMAILS_VW';
SHOW TABLES LIKE 'CRM_CONTACT_EMAILS_VW';
DROP VIEW CRM_CONTACT_EMAILS_VW;
CREATE VIEW CRM_CONTACT_EMAILS_VW AS SELECT 
  MA.ID,
  CONT.ID CONTACTID,
  MA.SUBJECT,
  MA.FROM_EMAIL,
  MA.TO_EMAIL,
  MA.CC_EMAIL,
  MA.BCC_EMAIL,
  MA.REPLY_EMAIL,
  MA.SEND_DATE,
  MA.RECEIVED_DATE,
  MA.EMAIL_STATUS,
  MA.EMAIL_PRIORITY,
  MA.EMAIL_HEADERS,
  MA.EMAIL_CONTENTS,
  MA.MIME_TYPE_PRIMARY,
  MA.MIME_TYPE_SECONDARY,
  MA.MIME_ENCODING,
  CONT.CONT_ACCESS EMAIL_TREE,
  MA.USERNAME  OWNERCODE,
  MA.EMAIL_DIRECTION,
  MA.EMAIL_ACCOUNT,
  MA.MDATE,
  MA.CDATE,
  MA.IS_SIGNATURE,
  CASE INSTR(MA.FROM_EMAIL, '<') 
   WHEN 0 THEN MA.FROM_EMAIL
   ELSE SUBSTR(MA.FROM_EMAIL, (INSTR(MA.FROM_EMAIL, '<')+1), LENGTH(MA.FROM_EMAIL)-INSTR(FROM_EMAIL, '<')-1) 
   END 
  FROM_EADD,
  CASE INSTR(MA.TO_EMAIL, '<') 
   WHEN 0 THEN MA.TO_EMAIL
   ELSE SUBSTR(MA.TO_EMAIL, (INSTR(MA.TO_EMAIL, '<')+1), LENGTH(MA.TO_EMAIL)-INSTR(TO_EMAIL, '<')-1) 
   END 
  TO_EADD,
  NULL CAMPAIGN_CODE,
  NULL CEML_CODE,
  NULL CAMPTARGET_ID
FROM 
  CLX_MA_MAILS MA,
  CRM_CONTACTS CONT
WHERE
  (CASE INSTR( CONT.EMAIL, '<') 
   WHEN 0 THEN  CONT.EMAIL
   ELSE SUBSTR(CONT.EMAIL, (INSTR( CONT.EMAIL, '<')+1), LENGTH(CONT.EMAIL)-INSTR(CONT.EMAIL, '<')-1) 
   END )  = ( CASE INSTR(MA.FROM_EMAIL, '<') 
   WHEN 0 THEN MA.FROM_EMAIL
   ELSE SUBSTR(MA.FROM_EMAIL, (INSTR(MA.FROM_EMAIL, '<')+1), LENGTH(MA.FROM_EMAIL)-INSTR(FROM_EMAIL, '<')-1) 
   END )
  OR 
    (CASE INSTR( CONT.EMAIL, '<') 
   WHEN 0 THEN  CONT.EMAIL
   ELSE SUBSTR(CONT.EMAIL, (INSTR( CONT.EMAIL, '<')+1), LENGTH(CONT.EMAIL)-INSTR(CONT.EMAIL, '<')-1) 
   END ) = (CASE INSTR(MA.TO_EMAIL, '<') 
   WHEN 0 THEN MA.TO_EMAIL
   ELSE SUBSTR(MA.TO_EMAIL, (INSTR(MA.TO_EMAIL, '<')+1), LENGTH(MA.TO_EMAIL)-INSTR(TO_EMAIL, '<')-1) 
   END )
  OR
    (CASE INSTR( CONT.EMAIL_02, '<') 
   WHEN 0 THEN  CONT.EMAIL_02
   ELSE SUBSTR(CONT.EMAIL_02, (INSTR( CONT.EMAIL_02, '<')+1), LENGTH(CONT.EMAIL_02)-INSTR(CONT.EMAIL_02, '<')-1) 
   END )  = ( CASE INSTR(MA.FROM_EMAIL, '<') 
   WHEN 0 THEN MA.FROM_EMAIL
   ELSE SUBSTR(MA.FROM_EMAIL, (INSTR(MA.FROM_EMAIL, '<')+1), LENGTH(MA.FROM_EMAIL)-INSTR(FROM_EMAIL, '<')-1) 
   END )
  OR 
    (CASE INSTR( CONT.EMAIL_02, '<') 
   WHEN 0 THEN  CONT.EMAIL_02
   ELSE SUBSTR(CONT.EMAIL_02, (INSTR( CONT.EMAIL_02, '<')+1), LENGTH(CONT.EMAIL_02)-INSTR(CONT.EMAIL_02, '<')-1) 
   END ) = (CASE INSTR(MA.TO_EMAIL, '<') 
   WHEN 0 THEN MA.TO_EMAIL
   ELSE SUBSTR(MA.TO_EMAIL, (INSTR(MA.TO_EMAIL, '<')+1), LENGTH(MA.TO_EMAIL)-INSTR(TO_EMAIL, '<')-1) 
   END )
  OR
  (CASE INSTR( CONT.EMAIL_03, '<') 
   WHEN 0 THEN  CONT.EMAIL_03
   ELSE SUBSTR(CONT.EMAIL_03, (INSTR( CONT.EMAIL_03, '<')+1), LENGTH(CONT.EMAIL_03)-INSTR(CONT.EMAIL_03, '<')-1) 
   END )  = ( CASE INSTR(MA.FROM_EMAIL, '<') 
   WHEN 0 THEN MA.FROM_EMAIL
   ELSE SUBSTR(MA.FROM_EMAIL, (INSTR(MA.FROM_EMAIL, '<')+1), LENGTH(MA.FROM_EMAIL)-INSTR(FROM_EMAIL, '<')-1) 
   END )
  OR 
    (CASE INSTR( CONT.EMAIL_03, '<') 
   WHEN 0 THEN  CONT.EMAIL_03
   ELSE SUBSTR(CONT.EMAIL_03, (INSTR( CONT.EMAIL_03, '<')+1), LENGTH(CONT.EMAIL_03)-INSTR(CONT.EMAIL_03, '<')-1) 
   END ) = (CASE INSTR(MA.TO_EMAIL, '<') 
   WHEN 0 THEN MA.TO_EMAIL
   ELSE SUBSTR(MA.TO_EMAIL, (INSTR(MA.TO_EMAIL, '<')+1), LENGTH(MA.TO_EMAIL)-INSTR(TO_EMAIL, '<')-1) 
   END );
SHOW TABLES LIKE 'INVE_INV_DISTRIBUTIONS_VW';
SHOW TABLES LIKE 'INVE_INV_DISTRIBUTIONS_VW';
DROP VIEW INVE_INV_DISTRIBUTIONS_VW;
CREATE VIEW INVE_INV_DISTRIBUTIONS_VW AS SELECT
  INDT.ID,
  GLCP.OPERATION_DATE EFFTDATE,
  INDT.INVESTMENT_CODE,
  INDT.PORTFOLIO_CODE,
  INDT.CHART_FIELD01,
  INDT.CHART_FIELD02,
  INDT.INVEST_AMT,
  INDT.FACE_VALUE,
  INDT.SHARES,
  INDT.AMORTIZED_AMT,
  INDT.ACCRUED_INT_AMT,
  INDT.GAIN_AMT,
  INDT.TAX_AMT,
  INDT.FEES_AMT,
  INDT.DIVIDEND_AMT
FROM 
  GL_PARAMETERS_TBL GLCP,
  INVE_PORTFOLIOS INFU,
  INVE_INV_DISTRIBUTIONS INDT
WHERE 
  GLCP.COMP_CODE = INFU.COMP_CODE
  AND INFU.IDCODE = INDT.PORTFOLIO_CODE
  AND INDT.EFFTDATE = (SELECT MAX(X.EFFTDATE)
			FROM INVE_INV_DISTRIBUTIONS X
			WHERE 
			  X.INVESTMENT_CODE = INDT.INVESTMENT_CODE
			  AND X.CHART_FIELD01 = INDT.CHART_FIELD01
			  AND X.CHART_FIELD02 = INDT.CHART_FIELD02
			  AND X.PORTFOLIO_CODE = INDT.PORTFOLIO_CODE
			  AND X.EFFTDATE <= GLCP.OPERATION_DATE);
SHOW TABLES LIKE 'FIDU_SETTLEMENT_VW';
SHOW TABLES LIKE 'FIDU_SETTLEMENT_VW';
DROP VIEW FIDU_SETTLEMENT_VW;
CREATE VIEW FIDU_SETTLEMENT_VW AS SELECT 
  FIPA.ID,
  GLCP.OPERATION_DATE END_DATE,
  FICO.COMP_CODE,
  FIPA.CONTRACT_CODE,
  FIPA.ACCOUNTCODE,
  CASE FICO.CANCEL_DATE
  WHEN GLCP.OPERATION_DATE THEN 1
  ELSE 0
  END IS_FICO_SETT
FROM 
  FIDU_PARTICIPANTS FIPA, 
  FIDU_CONTRACTS FICO, 
  GL_PARAMETERS_TBL GLCP,
  CRM_ACCOUNTS ACCO 
WHERE 
  FIPA.CONTRACT_CODE = FICO.IDCODE
  AND ACCO.IDCODE = FIPA.ACCOUNTCODE 
  AND FICO.COMP_CODE = GLCP.COMP_CODE 
  AND FIPA.STATUS = 'A'
  AND FICO.CONTRACT_STATUS = 'ACTI'
  AND (FIPA.END_DATE = GLCP.OPERATION_DATE 
  OR FICO.CANCEL_DATE = GLCP.OPERATION_DATE);
SHOW TABLES LIKE 'GL_JOURNAL_DET_VW';
SHOW TABLES LIKE 'GL_JOURNAL_DET_VW';
DROP VIEW GL_JOURNAL_DET_VW;
CREATE VIEW GL_JOURNAL_DET_VW AS SELECT 
  JEHD.IDCODE,
  JEHD.EFFTDATE,  
  JELN.GLACCOUNTCODE,
  GLAC.GL_TYPE,
  GLAC.TRUST_ITEM_TYPE,
  GLAC.REP_ITEM_TYPE,
  JELN.CURRENCY_CODE,
  JELN.EXCHANGE_RT,
  JELN.CUR_OPERATOR,
  JELN.DEBIT_TRANS_AMT,
  JELN.CREDIT_TRANS_AMT,
  JELN.DEBIT_AMT,
  JELN.CREDIT_AMT,
  JEHD.COMP_CODE,
  JELN.CHART_FIELD01,
  JELN.CHART_FIELD02,
  JELN.CHART_FIELD03,
  JELN.CHART_FIELD04,
  JELN.ITEM_CODE,
  JELN.ITEM_REF_NO,
  JEHD.JE_SOURCE,
  JEHD.REVERSED,
  JEHD.ADJUSTMENT,
  JEHD.IDNAME,
  JEHD.TRANS_CODE,
  JEHD.INAT_CODE,
  JEHD.TRANSTBL_CODE,
  JEHD.HAS_INVOICE,
  JEHD.CLOSING_ENTRY
FROM 
  GL_JOURNAL_HDR JEHD,
  GL_JOURNAL_LINES JELN,
  GL_CODES_TBL GLAC,
  GL_PARAMETERS_TBL GLCP
WHERE
  JELN.JEHDR_CODE = JEHD.IDCODE
  AND GLCP.COMP_CODE = JEHD.COMP_CODE
  AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE 
  AND GLAC.IDCODE = JELN.GLACCOUNTCODE
  AND JEHD.JE_STATUS IN ('AP','CLOS');
SHOW TABLES LIKE 'GL_PROD_FEES_VW';
SHOW TABLES LIKE 'GL_PROD_FEES_VW';
DROP VIEW GL_PROD_FEES_VW;
CREATE VIEW GL_PROD_FEES_VW AS SELECT 
 GLPF.ID,
 GLCP.COMP_CODE,
 GLPF.PRODUCT_CODE,
 GLPF.SEQNUM,
 GLPF.IDNAME,
 GLPF.FEE_FORMULA,
 GLPF.MINIMUM_FEE,
 GLPF.MAXIMUM_FEE,
 GLPF.IS_TAXABLE,
 GLPF.TAX_ITEM_CODE,
 GLPF.TAX_GL_CODE,
 IFNULL(JEIT.FLAT_RATE,0) FLAT_RATE, 
 IFNULL(JEIT.EXEMPT_TAX_AMT,0) EXEMPT_TAX_AMT, 
 IFNULL(JEIT.TAX_WITHOLDING_PCT,0) TAX_WITHOLDING_PCT
FROM 
 GL_PARAMETERS_TBL GLCP,
 GL_PROD_FEES GLPF
 LEFT JOIN GL_ITEM_TBL JEIT 
    ON JEIT.IDCODE = GLPF.TAX_ITEM_CODE
    AND JEIT.CLX_EFFTDATE = 
	(SELECT MAX(X.CLX_EFFTDATE)
	FROM GL_ITEM_TBL X, GL_PARAMETERS_TBL GLCP2
	WHERE X.IDCODE = JEIT.IDCODE
	AND X.CLX_EFFTDATE<=GLCP2.OPERATION_DATE);
SHOW TABLES LIKE 'CRED_CRED_STATUS_VW';
SHOW TABLES LIKE 'CRED_CRED_STATUS_VW';
DROP VIEW CRED_CRED_STATUS_VW;
CREATE VIEW CRED_CRED_STATUS_VW AS SELECT DISTINCT
	FILO.COMP_CODE,
	FILO.IDCODE LOAN_CODE,
	CASE WHEN FILO.LOAN_STATUS='PRE' THEN 'PRE'
		WHEN DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=NULLIF(PRLT.DAYS_STATUS_04,'') THEN PRLT.PROD_STATUS_04
	  WHEN DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=NULLIF(PRLT.DAYS_STATUS_03,'') THEN PRLT.PROD_STATUS_03
	  WHEN DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=NULLIF(PRLT.DAYS_STATUS_02,'') THEN PRLT.PROD_STATUS_02
	  WHEN DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=NULLIF(PRLT.DAYS_STATUS_01,'') THEN PRLT.PROD_STATUS_01
		ELSE 'VIG'
	END LOAN_STATUS,
	CASE 
	  WHEN DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=NULLIF(PRLT.DAYS_STATUS_04,'') THEN PRLT.DAYS_STATUS_04
	  WHEN DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=NULLIF(PRLT.DAYS_STATUS_03,'') THEN PRLT.DAYS_STATUS_03
	  WHEN DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=NULLIF(PRLT.DAYS_STATUS_02,'') THEN PRLT.DAYS_STATUS_02
	  WHEN DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE)>=NULLIF(PRLT.DAYS_STATUS_01,'') THEN PRLT.DAYS_STATUS_01
	ELSE 0
	END DAYS_STATUS,
	FILS.DUE_PAY_DATE,
	GLCP.OPERATION_DATE,
	DATEDIFF(GLCP.OPERATION_DATE, FILS.DUE_PAY_DATE) LATE_PAY_DAYS
FROM 
	GL_PARAMETERS_TBL GLCP,
	CRED_CREDITS FILO,
	CRED_PAYMNT_SCHEDULES FILS,
	CRED_PROD_PRMTR_TBL PRLT
WHERE
	FILO.PRODUCT_CODE = PRLT.PRODUCT_CODE
	AND FILS.LOAN_CODE = FILO.IDCODE
	AND FILS.EFFTDATE = FILO.CLX_EFFTDATE
	AND GLCP.COMP_CODE = FILO.COMP_CODE
	AND FILS.INSTALLMENT_NO = (SELECT MAX(FILSX.INSTALLMENT_NO) 
                FROM CRED_PAYMNT_SCHEDULES FILSX
                WHERE FILSX.LOAN_CODE = FILO.IDCODE
                  AND FILSX.EFFTDATE = FILO.CLX_EFFTDATE
                  AND FILSX.PERIOD_START_DATE <= GLCP.OPERATION_DATE)
	AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE)
			FROM CRED_CREDITS FILOX
			WHERE FILOX.IDCODE = FILO.IDCODE
			AND FILOX.CLX_EFFTDATE<=CURDATE());
SHOW TABLES LIKE 'CRRM_SCORE_SUM_VW';
SHOW TABLES LIKE 'CRRM_SCORE_SUM_VW';
DROP VIEW CRRM_SCORE_SUM_VW;
CREATE VIEW CRRM_SCORE_SUM_VW AS SELECT 
0 ID
,CRAI.LEAD_CODE
,CRAI.PERIODCODE
,CRIT.EVAL_MODEL
,CRIT.KPI_CAT
,(SUM(CRPI.KPI_SCORE*(CRIT.KPICAT_WGHT/100))*(MODEL_WGHT/100)) KPI_PTS
FROM  
CRRM_APPL_KPIS CRAI, CRRM_KPI_TBL CRIT, CRRM_KPI_CAT_TBL CRIC,  CRRM_KPI_LEVELS CRPI
WHERE 
CRIT.EVAL_MODEL = CRAI.EVAL_MODEL 
AND  CRIT.KPI_TYPE = CRAI.KPI_TYPE 
AND  CRIC.KPI_CAT = CRIT.KPI_CAT 
AND  CRPI.KPI_CODE = CRIT.IDCODE
AND  CRAI.KPI_VALUE >= CRPI.SCOREFROM_PCT 
AND  CRAI.KPI_VALUE <= CRPI.SCORETO_PCT  

AND CRIT.CLX_EFFTDATE=(SELECT MAX(X.CLX_EFFTDATE) CLX_EFFTDATE
			FROM CRRM_KPI_TBL X 
			WHERE  X.IDCODE=CRIT.IDCODE 
			AND  X.CLX_EFFTDATE <= NOW())

AND  CRIC.CLX_EFFTDATE=(SELECT MAX(X.CLX_EFFTDATE) CLX_EFFTDATE
	FROM CRRM_KPI_CAT_TBL X 
	WHERE  X.KPI_CAT=CRIC.KPI_CAT AND  X.CLX_EFFTDATE <= NOW()) 

AND CRPI.CLX_EFFTDATE=(SELECT MAX(X.CLX_EFFTDATE) CLX_EFFTDATE
			FROM CRRM_KPI_LEVELS X 
			WHERE  X.KPI_CODE=CRPI.KPI_CODE 
			AND X.KPI_LEVEL=CRPI.KPI_LEVEL 
			AND  X.CLX_EFFTDATE <= NOW())


GROUP BY 
CRAI.LEAD_CODE, CRAI.PERIODCODE, CRIC.KPI_CAT
ORDER BY 
CRAI.LEAD_CODE ASC,CRAI.PERIODCODE DESC,CRIC.SEQNUM ASC;
SHOW TABLES LIKE 'CRRM_MODEL_PTS_VW';
SHOW TABLES LIKE 'CRRM_MODEL_PTS_VW';
DROP VIEW CRRM_MODEL_PTS_VW;
CREATE VIEW CRRM_MODEL_PTS_VW AS SELECT 
0 ID
,KASM.LEAD_CODE
,KASM.EVAL_MODEL
,KASM.PERIODCODE
,ROUND((SUM(KASM.KPI_PTS)*10),2) MODPTS_PCT
 FROM 
 CRRM_SCORE_SUM_VW KASM
WHERE 
 1=1
GROUP BY 
KASM.LEAD_CODE, KASM.EVAL_MODEL,KASM.PERIODCODE, KASM.PERIODCODE
ORDER BY 
KASM.LEAD_CODE ASC, KASM.PERIODCODE DESC;
SHOW TABLES LIKE 'CRRM_MODEL_ELIG_VW';
SHOW TABLES LIKE 'CRRM_MODEL_ELIG_VW';
DROP VIEW CRRM_MODEL_ELIG_VW;
CREATE VIEW CRRM_MODEL_ELIG_VW AS SELECT 
0 ID
,KMPT.LEAD_CODE
,KMPT.EVAL_MODEL
,KMPT.PERIODCODE
,KMPT.MODPTS_PCT
,CRMS.PTSPCT_FROM
,CRMS.PTSPCT_TO
,CRMS.MODEL_SCORE
,CRMS.MODEL_ELEGIBILITY
 FROM 
 CRRM_MODEL_PTS_VW KMPT, CRRM_MODEL_SCORE_TBL CRMS
WHERE 
    1=1
    AND KMPT.MODPTS_PCT>=CRMS.PTSPCT_FROM AND KMPT.MODPTS_PCT <= CRMS.PTSPCT_TO 
GROUP BY 
KMPT.LEAD_CODE, KMPT.EVAL_MODEL, KMPT.PERIODCODE
ORDER BY 
KMPT.LEAD_CODE ASC, KMPT.EVAL_MODEL,KMPT.PERIODCODE DESC;
SHOW TABLES LIKE 'CRRM_MODEL_KPIS_VW';
SHOW TABLES LIKE 'CRRM_MODEL_KPIS_VW';
DROP VIEW CRRM_MODEL_KPIS_VW;
CREATE VIEW CRRM_MODEL_KPIS_VW AS SELECT DISTINCT
	CRIT.EVAL_MODEL EVAL_MODEL,
	CRIT.KPI_CAT KPI_CAT,
	CRIT.KPI_TYPE KPI_TYPE,
	DICT.VALUE KPI_TYPE_NAME,
	DICT.LANGUAGE
FROM 
 CRRM_KPI_CAT_TBL CRIC,
 CRRM_KPI_TBL CRIT,
 CLX_DB_LIST_ITEMS DBLI,
 CLX_DICTIONARY DICT
WHERE 
 DBLI.IDCODE = CRIT.KPI_TYPE
 AND DBLI.IDNAME = DICT.ENTRY
 AND CRIT.EVAL_MODEL = CRIC.EVAL_MODEL 
 AND CRIT.KPI_CAT = CRIC.KPI_CAT
 AND DBLI.LISTCODE = 'KPIT'
  AND CRIC.CLX_EFFTDATE=(SELECT MAX(X1.CLX_EFFTDATE) CLX_EFFTDATE
							FROM CRRM_KPI_CAT_TBL X1 
							WHERE  X1.KPI_CAT = CRIC.KPI_CAT
                AND X1.EVAL_MODEL = CRIC.EVAL_MODEL
                AND X1.CLX_EFFTDATE  <= NOW()) 
 AND CRIT.CLX_EFFTDATE=(SELECT MAX(X.CLX_EFFTDATE) CLX_EFFTDATE
							FROM CRRM_KPI_TBL X 
							WHERE  X.KPI_CAT=CRIT.KPI_CAT 
								AND X.KPI_TYPE = CRIT.KPI_TYPE
								AND X.EVAL_MODEL = CRIT.EVAL_MODEL
								AND  X.CLX_EFFTDATE <= NOW()) 
ORDER BY 
	CRIT.EVAL_MODEL ASC,
	DICT.LANGUAGE ASC,
  CRIC.SEQNUM ASC,
  CRIT.SEQNUM ASC;
SHOW TABLES LIKE 'GL_JOURNAL_REP_VW';
SHOW TABLES LIKE 'GL_JOURNAL_REP_VW';
DROP VIEW GL_JOURNAL_REP_VW;
CREATE VIEW GL_JOURNAL_REP_VW AS SELECT 
 JELN.ID,
 JEHD.IDCODE JEHDR_CODE,
 JEHD.JE_STATUS,
 JEHD.JE_SOURCE,
 JEHD.EFFTDATE,
 JEHD.COMP_CODE,
 JEHD.TRANS_CODE,
 JELN.GLACCOUNTCODE,
 JELN.CHART_FIELD01, 
 JELN.CHART_FIELD02, 
 JELN.CHART_FIELD03, 
 JELN.CHART_FIELD04,
 JELN.ITEM_CODE,
 JELN.ITEM_REF_NO, 
 JELN.CURRENCY_CODE,
 JELN.EXCHANGE_RT,
 JELN.CUR_OPERATOR,
 JELN.DEBIT_TRANS_AMT,
 JELN.CREDIT_TRANS_AMT,
 JELN.DEBIT_AMT,
 JELN.CREDIT_AMT,
 (JELN.DEBIT_TRANS_AMT-JELN.CREDIT_TRANS_AMT) BALANCE_AMT,
 (JELN.DEBIT_AMT-JELN.CREDIT_AMT) BASE_BAL_AMT
FROM 
 GL_JOURNAL_HDR JEHD,
 GL_JOURNAL_LINES JELN
WHERE
 JELN.JEHDR_CODE = JEHD.IDCODE
ORDER BY 
	JEHD.EFFTDATE ASC,
	JEHD.IDCODE ASC,
	JELN.SEQNUM ASC;
SHOW TABLES LIKE 'PRSO_PLAN_LIMIT_VW';
SHOW TABLES LIKE 'PRSO_PLAN_LIMIT_VW';
DROP VIEW PRSO_PLAN_LIMIT_VW;
CREATE VIEW PRSO_PLAN_LIMIT_VW AS SELECT 
		X.CONTRACT_CODE,
		X.GL_PER_FIPA,
		CASE PRAT.PRODUCT_CODE 
		WHEN X.ADVN_PROD_CODE THEN 'AD'
		ELSE 'PR' 
		END TRUST_ITEM_TYPE,
		PRAT.PRODUCT_CODE,
		PRAT.PRO_GL_CODE,
		CASE PRAT.PRODUCT_CODE 
		WHEN X.ADVN_PROD_CODE THEN X.PRES_ADVNCE_PCT
		ELSE X.PRES_AVAIL_PCT
		END ALLOCATION_PCT,
		GLCP.OPERATION_DATE,
		CASE (CASE PRAT.PRODUCT_CODE WHEN X.ADVN_PROD_CODE 
				THEN X.PRES_ADVN_PERIOD
				ELSE X.PRES_AVAIL_PERIOD 
				END)
				WHEN 'W' THEN ADDDATE(GLCP.OPERATION_DATE, INTERVAL -1 WEEK)
				WHEN 'M' THEN ADDDATE(GLCP.OPERATION_DATE, INTERVAL -1 MONTH)
				WHEN 'B' THEN ADDDATE(GLCP.OPERATION_DATE, INTERVAL -2 MONTH)
				WHEN 'Q' THEN ADDDATE(GLCP.OPERATION_DATE, INTERVAL -3 MONTH)
				WHEN 'S' THEN ADDDATE(GLCP.OPERATION_DATE, INTERVAL -6 MONTH)
				WHEN 'A' THEN ADDDATE(GLCP.OPERATION_DATE, INTERVAL -1 YEAR)
				ELSE ADDDATE(GLCP.OPERATION_DATE, INTERVAL -1 DAY)
			END PERIOD_START_DATE,
			X.ADVANCE_REASONS,
		IFNULL(X.PRBE_OPER_IN,'SYS_PRES-INCOR') PRBE_OPER_IN,
		IFNULL(X.PRBE_OPER_AP,'SYS_PRES-APOR') PRBE_OPER_AP,
		IFNULL(X.PRBE_OPER_AN,'SYS_PRES-ANT') PRBE_OPER_AN,
		IFNULL(X.PRBE_OPER_PR,'SYS_PRES-PRESTA') PRBE_OPER_PR,
		IFNULL(X.PRBE_OPER_AM,'SYS_PRES-AMORT') PRBE_OPER_AM,
		IFNULL(X.PRBE_OPER_DI,'SYS_PRES-DESIN') PRBE_OPER_DI
	FROM 
		FIDU_CONTRACTS FICO,
		GL_PARAMETERS_TBL GLCP,
		GL_PROD_PRMTR_TBL PRAT,
		PRSO_PLAN_PRMTRS_TBL X
	WHERE 
		FICO.IDCODE = X.CONTRACT_CODE
		AND GLCP.COMP_CODE = FICO.COMP_CODE
		AND PRAT.PRODUCT_CODE IN (X.ADVN_PROD_CODE, X.LOAN_PROD_CODE)
		AND PRAT.PROD_STATUS = 'VIG'
		AND X.CLX_EFFTDATE = 
			(SELECT MAX(Y.CLX_EFFTDATE)
			 FROM PRSO_PLAN_PRMTRS_TBL Y
			WHERE Y.CONTRACT_CODE = X.CONTRACT_CODE
				AND Y.CLX_EFFTDATE<=GLCP.OPERATION_DATE);
SHOW TABLES LIKE 'CRRM_ALLOCTN_VW';
SHOW TABLES LIKE 'CRRM_ALLOCTN_VW';
DROP VIEW CRRM_ALLOCTN_VW;
CREATE VIEW CRRM_ALLOCTN_VW AS SELECT 
0 ID
,CRAI.LEAD_CODE
,CRAI.EVAL_MODEL
,CRAI.PERIODCODE
,CRAR.IDCODE ALLOCRULE_CODE
,ROUND(SUM(CRAI.KPI_VALUE * (CRAR.KPI_MULT_PCT/100) * ( KMEL.MODPTS_PCT/100)),0) ALLOCTN_AMT 

FROM 
  CRRM_APPL_KPIS CRAI
 ,CRRM_ALLOCTN_RULES CRAR
 ,CRRM_MODEL_ELIG_VW KMEL

WHERE 
  1=1
  AND CRAI.EVAL_MODEL=KMEL.EVAL_MODEL
  AND CRAI.LEAD_CODE=KMEL.LEAD_CODE
  AND CRAI.PERIODCODE=KMEL.PERIODCODE
  AND CRAI.EVAL_MODEL=CRAR.EVAL_MODEL
  AND CRAI.KPI_TYPE=CRAR.KPI_TYPE
  AND CRAR.CLX_EFFTDATE=(SELECT MAX(X.CLX_EFFTDATE)
              FROM CRRM_ALLOCTN_RULES X
              WHERE X.EVAL_MODEL=CRAR.EVAL_MODEL
                AND X.KPI_TYPE=CRAR.KPI_TYPE
                AND X.SEQNUM = CRAR.SEQNUM
               AND X.CLX_EFFTDATE <= CURDATE() )

GROUP BY 
 CRAI.LEAD_CODE
,CRAI.EVAL_MODEL
,CRAI.PERIODCODE
,CRAR.IDCODE;
SHOW TABLES LIKE 'CRRM_ALLOCTN_RPT_VW';
SHOW TABLES LIKE 'CRRM_ALLOCTN_RPT_VW';
DROP VIEW CRRM_ALLOCTN_RPT_VW;
CREATE VIEW CRRM_ALLOCTN_RPT_VW AS SELECT 
0 ID
,CRAI.LEAD_CODE
,CRAI.EVAL_MODEL
,CRAI.PERIODCODE
,CRAR.IDCODE ALLOCRULE_CODE
,ROUND(CRAI.KPI_VALUE,2)  KPI_VALUE
,ROUND(SUM(CRAI.KPI_VALUE * (CRAR.KPI_MULT_PCT/100) * ( KMEL.MODPTS_PCT/100)),0) ALLOCTN_AMT 


FROM 
  CRRM_APPL_KPIS CRAI
 ,CRRM_ALLOCTN_RULES CRAR
 ,CRRM_MODEL_ELIG_VW KMEL

WHERE 
  1=1
  AND CRAI.EVAL_MODEL=KMEL.EVAL_MODEL
  AND CRAI.LEAD_CODE=KMEL.LEAD_CODE
  AND CRAI.PERIODCODE=KMEL.PERIODCODE
  AND CRAI.EVAL_MODEL=CRAR.EVAL_MODEL
  AND CRAI.KPI_TYPE=CRAR.KPI_TYPE
  
GROUP BY 
 CRAI.LEAD_CODE
,CRAI.EVAL_MODEL
,CRAI.PERIODCODE
,CRAR.IDCODE

UNION

SELECT 
KAAL.ID ID
,KAAL.LEAD_CODE
,KAAL.EVAL_MODEL
,KAAL.PERIODCODE
,'X====CUPO' ALLOCRULE_CODE
,0          KPI_VALUE
,MIN(KAAL.ALLOCTN_AMT) ALLOCTN_AMT

FROM  CRRM_ALLOCTN_VW KAAL 
GROUP BY KAAL.LEAD_CODE,KAAL.EVAL_MODEL,KAAL.PERIODCODE 
ORDER BY 1, 2, 3, 4, 5;
SHOW TABLES LIKE 'ITC_LIMT_BENEF_VW';
SHOW TABLES LIKE 'ITC_LIMT_BENEF_VW';
DROP VIEW ITC_LIMT_BENEF_VW;
CREATE VIEW ITC_LIMT_BENEF_VW AS SELECT 
		MAX(CREB.ID) ID,
		FILO.COMP_CODE,
		FILO.DEBTOR_CODE,
		CREB.COSIZE_CLASS,
		FILO.PRODUCT_CODE,
		CREB.EFFTDATE,
		CREB.STATE,
		CREB.CITY,
		CREB.INDUSTRYCLASS,
		REPLACE(CREB.FULLNAME, 'NULL','') FULLNAME,
		CREB.IDENTIFICATION,
		SUM(CREB.LOAN_AMT) LOAN_AMT,
		PRLM.MAX_PRODUCT_AMT,
		PRLM.MIN_PRODUCT_AMT,
		PRLM.MAX_UNIT_PROD_AMT,
		PRLM.MIN_UNIT_PROD_AMT,
		IF (NULLIF(PRLM.MAX_UNIT_PROD_AMT,0)<SUM(CREB.LOAN_AMT),1,0) OVER_MAX_PRODUCT,
	  IF (NULLIF(PRLM.MIN_UNIT_PROD_AMT,0)>SUM(CREB.LOAN_AMT),1,0) BELOW_MIN_PRODUCT
	FROM 
		CRED_CREDITS FILO,
		CRED_BENEFICIARIES CREB,
		CRM_PROD_LIMITS PRLM
	WHERE 
	  CREB.LOAN_CODE = FILO.IDCODE
		AND PRLM.PRODUCT_CODE = FILO.PRODUCT_CODE
		AND PRLM.COSIZE_CLASS = CREB.COSIZE_CLASS
		AND FILO.LOAN_STATUS <> 'PRE'
		AND	PRLM.CLX_EFFTDATE = 
				(SELECT MAX(X3.CLX_EFFTDATE)
				 FROM CRM_PROD_LIMITS X3
				 WHERE X3.PRODUCT_CODE = PRLM.PRODUCT_CODE
							AND X3.COSIZE_CLASS = PRLM.COSIZE_CLASS
							AND X3.CLX_EFFTDATE<=CREB.EFFTDATE)
		AND	FILO.CLX_EFFTDATE = 
				(SELECT MAX(X1.CLX_EFFTDATE)
				 FROM CRED_CREDITS X1
				 WHERE X1.IDCODE = FILO.IDCODE
				 AND X1.CLX_EFFTDATE<=CREB.EFFTDATE)
		/*AND CREB.ID = 
			(SELECT MAX(X2.ID)
			FROM CRED_BENEFICIARIES X2
			WHERE X2.IDENTIFICATION = CREB.IDENTIFICATION
			AND X2.LOAN_CODE = CREB.LOAN_CODE)*/
		GROUP BY 
			FILO.COMP_CODE,
			FILO.DEBTOR_CODE,
			CREB.COSIZE_CLASS,
			FILO.PRODUCT_CODE,
			CREB.EFFTDATE,
			CREB.FULLNAME,
			CREB.IDENTIFICATION,
			PRLM.MAX_PRODUCT_AMT,
			PRLM.MIN_PRODUCT_AMT,
			PRLM.MAX_UNIT_PROD_AMT,
			PRLM.MIN_UNIT_PROD_AMT,
			CREB.STATE,
			CREB.CITY,
			CREB.INDUSTRYCLASS;
SHOW TABLES LIKE 'CRRM_MODEL_APLACC_VW';
SHOW TABLES LIKE 'CRRM_MODEL_APLACC_VW';
DROP VIEW CRRM_MODEL_APLACC_VW;
CREATE VIEW CRRM_MODEL_APLACC_VW AS SELECT 
	CRAT.EVAL_MODEL,
	CRAI.LEAD_CODE,
	CRAI.PERIODCODE,
	CRAC.KPI_ACC_CODE,
	ROUND(SUM(CRAI.KPI_VALUE*(CRAC.KPI_MULT_PCT/100)),5) KPI_ACC_VAL
FROM
	CRRM_APPL_KPIS CRAI,
	CRRM_KPI_ACCUM_TBL CRAT,
	CRRM_KPI_ACCUM_ITEMS CRAC
WHERE 1=1
	AND CRAI.EVAL_MODEL = CRAT.EVAL_MODEL
	AND CRAT.IDCODE = CRAC.KPI_ACC_CODE
	AND CRAC.CLX_EFFTDATE = (SELECT MAX(CRACX.CLX_EFFTDATE)
				FROM CRRM_KPI_ACCUM_ITEMS CRACX
				WHERE CRACX.KPI_ACC_CODE = CRAC.KPI_ACC_CODE
				AND CRACX.KPI_TYPE = CRAC.KPI_TYPE
				AND CRACX.CLX_EFFTDATE<=NOW())
GROUP BY
	CRAT.EVAL_MODEL,
	CRAI.LEAD_CODE,
	CRAI.PERIODCODE,
	CRAC.KPI_ACC_CODE;
SHOW TABLES LIKE 'CRRM_MODEL_ACKPI_VW';
SHOW TABLES LIKE 'CRRM_MODEL_ACKPI_VW';
DROP VIEW CRRM_MODEL_ACKPI_VW;
CREATE VIEW CRRM_MODEL_ACKPI_VW AS SELECT
	CRIT.EVAL_MODEL,
	CRIT.KPI_CAT,
	CRIT.KPI_TYPE,
	KMAV1.LEAD_CODE,
	KMAV1.PERIODCODE,
	CRIT.KPIACCUM_CODE01,
	KMAV1.KPI_ACC_VAL CALC_AMT_01,
	CRIT.KPIACCUM_CODE02,
	KMAV2.KPI_ACC_VAL CALC_AMT_02,
	CRIT.MATH_OPERATOR,
	ROUND((CASE CRIT.MATH_OPERATOR
	WHEN '+' THEN (KMAV1.KPI_ACC_VAL+KMAV2.KPI_ACC_VAL)
	WHEN '-' THEN (KMAV1.KPI_ACC_VAL-KMAV2.KPI_ACC_VAL)
	WHEN '*' THEN (KMAV1.KPI_ACC_VAL*KMAV2.KPI_ACC_VAL)
	WHEN '/' THEN (KMAV1.KPI_ACC_VAL/NULLIF(KMAV2.KPI_ACC_VAL,0))
	ELSE 0 END),5) KPI_VALUE
FROM	
	CRRM_KPI_TBL CRIT,
	CRRM_MODEL_APLACC_VW KMAV1,
	CRRM_MODEL_APLACC_VW KMAV2
WHERE
	KMAV1.EVAL_MODEL = CRIT.EVAL_MODEL
	AND KMAV2.EVAL_MODEL = CRIT.EVAL_MODEL
	AND CRIT.KPIACCUM_CODE01 = KMAV1.KPI_ACC_CODE
	AND CRIT.KPIACCUM_CODE02 = KMAV2.KPI_ACC_CODE
	AND KMAV1.LEAD_CODE = KMAV2.LEAD_CODE
	AND KMAV1.PERIODCODE = KMAV2.PERIODCODE
	AND CRIT.CLX_EFFTDATE=(SELECT MAX(X.CLX_EFFTDATE) CLX_EFFTDATE
			FROM CRRM_KPI_TBL X 
			WHERE  X.IDCODE=CRIT.IDCODE 
			AND  X.CLX_EFFTDATE <= NOW())
ORDER BY 
	CRIT.KPI_TYPE;
SHOW TABLES LIKE 'MARK_TELE_RES_VW';
SHOW TABLES LIKE 'MARK_TELE_RES_VW';
DROP VIEW MARK_TELE_RES_VW;
CREATE VIEW MARK_TELE_RES_VW AS SELECT 
	CAMP.ID,
	CTER.CAMPAIGNCODE,
	CTER.CALL_DATE,
	CTER.OWNERCODE, 
	CTER.RESULT_CODE,
	COUNT(CTER.ID) QUANTITY
FROM 
	MARK_CAMPAIGNS CAMP,
	MARK_CAMPSEC_TELEMARK_RES CTER
WHERE 
	CAMP.IDCODE = CTER.CAMPAIGNCODE
GROUP BY	
	CAMP.ID,
	CTER.CAMPAIGNCODE,
	CTER.OWNERCODE, 
	CTER.RESULT_CODE;
SHOW TABLES LIKE 'PROC_PROCESS_EXCEPTIONS_LOG';
SHOW TABLES LIKE 'PROC_PROCESS_EXCEPTIONS_LOG';
DROP VIEW PROC_PROCESS_EXCEPTIONS_LOG;
CREATE VIEW PROC_PROCESS_EXCEPTIONS_LOG AS SELECT
 ID, LOG_RECID, EFFTDATE, PROC_STATUS, DESCRIPTION, SCHEDULECODE SCHEDULE_CODE, TABLECODE, RECORDID 
FROM CLX_PR_EXCEPT_LOGS;
SHOW TABLES LIKE 'AP_INVOICES_01_VW';
SHOW TABLES LIKE 'AP_INVOICES_01_VW';
DROP VIEW AP_INVOICES_01_VW;
CREATE VIEW AP_INVOICES_01_VW AS SELECT * FROM AP_PAY_INVOICES;
SHOW TABLES LIKE 'CRED_ASOPA_REFE_VW';
SHOW TABLES LIKE 'CRED_ASOPA_REFE_VW';
DROP VIEW CRED_ASOPA_REFE_VW;
CREATE VIEW CRED_ASOPA_REFE_VW AS SELECT 
	/* ACCO.IDENTIFICATION IDENT_CLIE, */
	LEFT(IF(ACCO.IDENTIFICATION_APC <> '', ACCO.IDENTIFICATION_APC, ACCO.IDENTIFICATION),21) IDENT_CLIE,
	IFNULL(ACCO.LEGAL_TYPE,'C') TIPO_CLIE,
	LEFT((SELECT MAX(PRMTX.PVALUE)
  FROM BASE_PARAMETERS PRMTX
  WHERE PRMTX.COMP_CODE = FILO.COMP_CODE
  AND PRMTX.IDNAME = 'CRED_APC_COD_GRUPO_ECON'),2) COD_GRUPO_ECON,
	LEFT((SELECT MAX(PRMTX.PVALUE)
  FROM BASE_PARAMETERS PRMTX 
  WHERE PRMTX.COMP_CODE = FILO.COMP_CODE
  AND PRMTX.IDNAME = 'CRED_APC_TIPO_ASOC'),2) TIPO_ASOC,
	LEFT((SELECT MAX(PRMTX.PVALUE)
  FROM BASE_PARAMETERS PRMTX
  WHERE PRMTX.COMP_CODE = FILO.COMP_CODE
  AND PRMTX.IDNAME = 'CRED_APC_IDENT_ASOC'),6) IDENT_ASOC,
	LEFT(REPLACE(FILO.IDCODE,"-",""),25) CUENTA,
	LEFT(CONCAT('DM',(SELECT MAX(PRMTX.PVALUE)
  FROM BASE_PARAMETERS PRMTX
  WHERE PRMTX.COMP_CODE = FILO.COMP_CODE
  AND PRMTX.IDNAME = 'CRED_APC_IDENT_ASOC')),8) USER_ID,
	FILO.PAY_OR_FREQ_TYPE TIPO_FORMA_PAGO,
	FILO.STAT_REL_TYPE TIPO_RELACION,
	DATE_FORMAT(FILO.START_DATE, '%m/%d/%Y') FEC_INICIO_REL,
	DATE_FORMAT(FILO.END_DATE, '%m/%d/%Y') FEC_FINAL_REL,
	ROUND(FILO.LOAN_AMT,2) MONTO_ORIGINAL,
	ROUND(FILO.PRINCIPAL_BAL,2) SALDO_ACTUAL,
	LEFT(FILO.NO_PAYMENTS,3) NUM_PAGOS,
	ROUND(FILS.PAYMENT_AMT, 2) IMPORTE_PAGO,
	DATE_FORMAT(FILO.LAST_PAY_DATE, '%m/%d/%Y') FEC_ULTIMO_PAGO,
	ROUND(IFNULL((SELECT FILO.LAST_PAY_AMT),0) ,2) MONTO_ULTIMO_PAGO,
	DATE_FORMAT(FILO.END_DATE, '%m/%d/%Y')  FEC_CANCELACIÓN,
	'' TIPO_COMPORTA,/*Este campo debe enviarse en blanco*/
	FILO.LOAN_STATUS ESTATUS_REF,
	IF(DATEDIFF(FILS.PERIOD_END_DATE, NOW())>0 AND FILS.PAID_AMT=0, DATEDIFF(FILS.PERIOD_END_DATE, NOW()), 0) NUM_DIAS_ATRASO,
	'' MONTO_CODIFICADO,
	'' TIPO_CIFRA,
	FILO.STATUS_DESC OBSERVACION,
	DATE_FORMAT(GLCP.OPERATION_DATE, '%m/%d/%Y') FEC_CORTE,
	(SELECT MAX(ACCOX.IDNAME) 
	FROM CRM_ACCOUNTS ACCOX
	WHERE ACCOX.IDCODE = FILO.GUARANTOR_01) NOM_FIADOR,
	(SELECT MAX(ACCOX.IDENTIFICATION) 
	FROM CRM_ACCOUNTS ACCOX
	WHERE ACCOX.IDCODE = FILO.GUARANTOR_01) CED_FIADOR
FROM
	CRM_ACCOUNTS ACCO,
	CRED_CREDITS FILO,
	CRED_PAYMNT_SCHEDULES FILS,
	BASE_PARAMETERS PRMT,
	GL_PARAMETERS_TBL GLCP
WHERE
  GLCP.COMP_CODE = FILO.COMP_CODE
	AND ACCO.IDCODE = FILO.DEBTOR_CODE
	/*AND FILO.COMP_CODE = @COMP_CODE */
	/*AND FILO.IDCODE = '10031'*/
	AND FILS.LOAN_CODE = FILO.IDCODE
	AND FILS.EFFTDATE = FILO.CLX_EFFTDATE
	AND FILS.PERIOD_START_DATE <= CURDATE()
	AND FILS.PERIOD_END_DATE >= CURDATE()
  AND PRMT.COMP_CODE = FILO.COMP_CODE
  AND PRMT.IDNAME = 'CRED_APC_REPORT_ENABLED'
  AND PRMT.PVALUE = '1'
  AND (FILO.LOAN_STATUS NOT IN ('PRE','VEN') OR (FILO.LOAN_STATUS = 'VEN' 
  AND EXTRACT(YEAR_MONTH FROM FILO.END_DATE)=EXTRACT(YEAR_MONTH FROM NOW())))
	AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE)
			FROM CRED_CREDITS FILOX
			WHERE FILOX.IDCODE = FILO.IDCODE
			AND FILOX.CLX_EFFTDATE<=CURDATE())
  AND EXISTS (SELECT PRLT.ID
              FROM CRED_PROD_PRMTR_TBL PRLT
              WHERE PRLT.PRODUCT_CODE = FILO.PRODUCT_CODE
              AND PRLT.HAS_APC_EXPORT = 1);
SHOW TABLES LIKE 'CRED_ASOPA_CLIE_VW';
SHOW TABLES LIKE 'CRED_ASOPA_CLIE_VW';
DROP VIEW CRED_ASOPA_CLIE_VW;
CREATE VIEW CRED_ASOPA_CLIE_VW AS SELECT DISTINCT
	/* ACCO.IDENTIFICATION IDENT_CLIE, */
	LEFT(IF(ACCO.IDENTIFICATION_APC <> '', ACCO.IDENTIFICATION_APC, ACCO.IDENTIFICATION),21) IDENT_CLIE,
	/*ACCO.ISINDIVIDUAL TIPO_CLIE,*/
	IFNULL(ACCO.LEGAL_TYPE,'C') TIPO_CLIE,/*SET TRANSLATION 1,2,3*/
	/*ASUMIENTO ESPACIO COMO SEPARACION DE APELLIDOS*/
	LEFT(IF(NULLIF(LOCATE(' ', TRIM(ACCO.LASTNAME)),0) IS NULL, ACCO.LASTNAME, TRIM(LEFT(ACCO.LASTNAME, LOCATE(' ', TRIM(ACCO.LASTNAME))))),25) APEL_PATERNO,
	LEFT(IF(NULLIF(LOCATE(' ', TRIM(ACCO.LASTNAME)),0) IS NULL, '', TRIM(REPLACE(ACCO.LASTNAME, LEFT(ACCO.LASTNAME, LOCATE(' ', TRIM(ACCO.LASTNAME))),''))),25) APEL_MATERNO,
	LEFT(ACCO.MARRIED_NAME,25) APEL_CASADA,
	LEFT(ACCO.FIRSTNAME,25) PRIMER_NOM,
	LEFT(ACCO.SECOND_NAME,25) SEGUNDO_NOM,
	CASE ACCO.SEX WHEN 'F' THEN 2
	ELSE 1 END SEXO_CLIE,/*1=M, 2=F SET TRANSLATE*/
	LEFT(ACCO.TAXID,25) SEGURO_SOCIAL,/*CUSTOMER_TAX REPLACED BY TAXID ID?*/
	ACCO.MARITAL_STATUS ESTADO_CIVIL,/*1 SOLTERO 2 CASADO 3 VIUDO 4 UNIDO 5	DIVORCIADO INCLUIR SOLO CODIGO*/
	LEFT(ACCO.LEGAL_NAME,70) NOM_LEGAL,
	LEFT(ACCO.IDNAME,70) NOM_COMERCIAL,
	LEFT(ACCO.ADDRESS1,80) DIREC_CLIE,
	DATE_FORMAT(CASE ACCO.ISINDIVIDUAL
	WHEN 1 THEN ACCO.BIRTHDATE 
	ELSE ACCO.INCORPORATION_DATE END,
	'%m/%d/%Y') FEC_NAC_INI_OP,
	LEFT(ACCO.HOME_PHONE,7) TELEF_CASA,
	LEFT(ACCO.FAX,7) TELEF_FAX1,
	LEFT(ACCO.FAX_02,7) TELEF_FAX2,
	LEFT(ACCO.OTHER_PHONE,7) TELEF_OTRO,
	LEFT(ACCO.MOBILE_PHONE,7) TELEF_CELULAR,
	LEFT(ACCO.EMPLOYER,50) LUG_TRAB,
	LEFT(ACCO.ADDRESS1_02,80) DIREC_TRAB,
	LEFT(ACCO.JOBTITLE, 50) POSICION_TRAB,
	ACCO.INCOME INGRESO_MENSUAL,
	ACCO.EMPLOYER_SINCE FEC_INGRESO_TRAB,
	LEFT(ACCO.BUSINESS_PHONE, 7) TELEF_OFICINA,
	LEFT(ACCO.BUSINESS_EXT, 5) TELEF_OFICINA_EXT,
	/*ASUMIENDO APELLIDO APELLIDO2, NOMBRE NOMBRE2*/
	/*ACCO.SPOUSE NOM_CONYUGE,
	ACCO.SPOUSE APEL_CONYUGE,*/
	LEFT(IF(NULLIF(LOCATE(',', TRIM(ACCO.SPOUSE)),0) IS NULL, '', TRIM(REPLACE(REPLACE(ACCO.SPOUSE, LEFT(ACCO.SPOUSE, LOCATE(',', TRIM(ACCO.SPOUSE))),','),',',''))),20) NOM_CONYUGE,
	LEFT(IF(NULLIF(LOCATE(',', TRIM(ACCO.SPOUSE)),0) IS NULL, ACCO.SPOUSE, TRIM(REPLACE(LEFT(ACCO.SPOUSE, LOCATE(',', TRIM(ACCO.SPOUSE))),',',''))), 20) APEL_CONYUGE,
	LEFT(ACCO.SPOUSE_ID, 21) CED_CONYUGE,
	LEFT(IF(NULLIF(LOCATE(',', TRIM(ACCO.FATHER_FULLNAME)),0) IS NULL, '', TRIM(REPLACE(REPLACE(ACCO.FATHER_FULLNAME, LEFT(ACCO.FATHER_FULLNAME, LOCATE(',', TRIM(ACCO.FATHER_FULLNAME))),','),',',''))), 20) NOM_PADRE,
	LEFT(IF(NULLIF(LOCATE(',', TRIM(ACCO.FATHER_FULLNAME)),0) IS NULL, ACCO.FATHER_FULLNAME, TRIM(REPLACE(LEFT(ACCO.FATHER_FULLNAME, LOCATE(',', TRIM(ACCO.FATHER_FULLNAME))),',',''))), 20) APEL_PADRE,
	LEFT(IF(NULLIF(LOCATE(',', TRIM(ACCO.MOTHER_FULLNAME)),0) IS NULL, '', TRIM(REPLACE(REPLACE(ACCO.MOTHER_FULLNAME, LEFT(ACCO.MOTHER_FULLNAME, LOCATE(',', TRIM(ACCO.MOTHER_FULLNAME))),','),',',''))), 20) NOM_MADRE,
	LEFT(IF(NULLIF(LOCATE(',', TRIM(ACCO.MOTHER_FULLNAME)),0) IS NULL, ACCO.MOTHER_FULLNAME, TRIM(REPLACE(LEFT(ACCO.MOTHER_FULLNAME, LOCATE(',', TRIM(ACCO.MOTHER_FULLNAME))),',',''))), 20) APEL_MADRE
FROM
	CRM_ACCOUNTS ACCO,
	CRED_CREDITS FILO,
	BASE_PARAMETERS PRMT 
WHERE
  /*FILO.COMP_CODE = @COMP_CODE  AND */
	ACCO.IDCODE = FILO.DEBTOR_CODE
	AND PRMT.COMP_CODE = FILO.COMP_CODE
  AND PRMT.IDNAME = 'CRED_APC_REPORT_ENABLED'
  AND PRMT.PVALUE = '1'
  AND (FILO.LOAN_STATUS NOT IN ('PRE','VEN') OR (FILO.LOAN_STATUS = 'VEN' 
  AND EXTRACT(YEAR_MONTH FROM FILO.END_DATE)=EXTRACT(YEAR_MONTH FROM NOW())))
	AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE)
			FROM CRED_CREDITS FILOX
			WHERE FILOX.IDCODE = FILO.IDCODE
			AND FILOX.CLX_EFFTDATE<=NOW())
  AND EXISTS (SELECT PRLT.ID
              FROM CRED_PROD_PRMTR_TBL PRLT
              WHERE PRLT.PRODUCT_CODE = FILO.PRODUCT_CODE
              AND PRLT.HAS_APC_EXPORT = 1);
SHOW TABLES LIKE 'CRM_ACCO_EMAILS_VW';
SHOW TABLES LIKE 'CRM_ACCO_EMAILS_VW';
DROP VIEW CRM_ACCO_EMAILS_VW;
CREATE VIEW CRM_ACCO_EMAILS_VW AS SELECT 
  MA.ID,
  ACCO.IDCODE ACCOUNT_CODE,
  CONT.IDCODE CONTACT_CODE,
  MA.SUBJECT,
  MA.FROM_EMAIL,
  MA.TO_EMAIL,
  MA.CC_EMAIL,
  MA.BCC_EMAIL,
  MA.REPLY_EMAIL,
  MA.SEND_DATE,
  MA.RECEIVED_DATE,
  MA.EMAIL_STATUS,
  MA.EMAIL_PRIORITY,
  MA.EMAIL_HEADERS,
  MA.EMAIL_CONTENTS,
  MA.MIME_TYPE_PRIMARY,
  MA.MIME_TYPE_SECONDARY,
  MA.MIME_ENCODING,
  CONT.CONT_ACCESS EMAIL_TREE,
  MA.USERNAME  OWNERCODE,
  MA.EMAIL_DIRECTION,
  MA.EMAIL_ACCOUNT,
  MA.MDATE,
  MA.CDATE,
  MA.IS_SIGNATURE,
  CASE INSTR(MA.FROM_EMAIL, '<') 
   WHEN 0 THEN MA.FROM_EMAIL
   ELSE SUBSTR(MA.FROM_EMAIL, (INSTR(MA.FROM_EMAIL, '<')+1), LENGTH(MA.FROM_EMAIL)-INSTR(FROM_EMAIL, '<')-1) 
   END 
  FROM_EADD,
  CASE INSTR(MA.TO_EMAIL, '<') 
   WHEN 0 THEN MA.TO_EMAIL
   ELSE SUBSTR(MA.TO_EMAIL, (INSTR(MA.TO_EMAIL, '<')+1), LENGTH(MA.TO_EMAIL)-INSTR(TO_EMAIL, '<')-1) 
   END 
  TO_EADD,
  NULL CAMPAIGN_CODE,
  NULL CAMPSECTION_EMAIL_CODE,
  NULL CAMPTARGET_ID
FROM 
  CLX_MA_MAILS MA,
  CRM_CONTACTS CONT,
  CRM_ACCOUNTS ACCO,
  CRM_REL_CONTACTS DYCO
WHERE
   1=1
   AND DYCO.PARENT_TABLECODE = 'ACCO'
   AND DYCO.CHILD_TABLECODE ='CONT'
   AND DYCO.PARENT_RECORDID = ACCO.ID
   AND DYCO.CHILD_RECORDID = CONT.ID
   AND (
  (CASE INSTR( CONT.EMAIL, '<') 
   WHEN 0 THEN  CONT.EMAIL
   ELSE SUBSTR(CONT.EMAIL, (INSTR( CONT.EMAIL, '<')+1), LENGTH(CONT.EMAIL)-INSTR(CONT.EMAIL, '<')-1) 
   END )  = ( CASE INSTR(MA.FROM_EMAIL, '<') 
   WHEN 0 THEN MA.FROM_EMAIL
   ELSE SUBSTR(MA.FROM_EMAIL, (INSTR(MA.FROM_EMAIL, '<')+1), LENGTH(MA.FROM_EMAIL)-INSTR(FROM_EMAIL, '<')-1) 
   END )
  OR 
    (CASE INSTR( CONT.EMAIL, '<') 
   WHEN 0 THEN  CONT.EMAIL
   ELSE SUBSTR(CONT.EMAIL, (INSTR( CONT.EMAIL, '<')+1), LENGTH(CONT.EMAIL)-INSTR(CONT.EMAIL, '<')-1) 
   END ) = (CASE INSTR(MA.TO_EMAIL, '<') 
   WHEN 0 THEN MA.TO_EMAIL
   ELSE SUBSTR(MA.TO_EMAIL, (INSTR(MA.TO_EMAIL, '<')+1), LENGTH(MA.TO_EMAIL)-INSTR(TO_EMAIL, '<')-1) 
   END )
  OR
    (CASE INSTR( CONT.EMAIL_02, '<') 
   WHEN 0 THEN  CONT.EMAIL_02
   ELSE SUBSTR(CONT.EMAIL_02, (INSTR( CONT.EMAIL_02, '<')+1), LENGTH(CONT.EMAIL_02)-INSTR(CONT.EMAIL_02, '<')-1) 
   END )  = ( CASE INSTR(MA.FROM_EMAIL, '<') 
   WHEN 0 THEN MA.FROM_EMAIL
   ELSE SUBSTR(MA.FROM_EMAIL, (INSTR(MA.FROM_EMAIL, '<')+1), LENGTH(MA.FROM_EMAIL)-INSTR(FROM_EMAIL, '<')-1) 
   END )
  OR 
    (CASE INSTR( CONT.EMAIL_02, '<') 
   WHEN 0 THEN  CONT.EMAIL_02
   ELSE SUBSTR(CONT.EMAIL_02, (INSTR( CONT.EMAIL_02, '<')+1), LENGTH(CONT.EMAIL_02)-INSTR(CONT.EMAIL_02, '<')-1) 
   END ) = (CASE INSTR(MA.TO_EMAIL, '<') 
   WHEN 0 THEN MA.TO_EMAIL
   ELSE SUBSTR(MA.TO_EMAIL, (INSTR(MA.TO_EMAIL, '<')+1), LENGTH(MA.TO_EMAIL)-INSTR(TO_EMAIL, '<')-1) 
   END )
  OR
  (CASE INSTR( CONT.EMAIL_03, '<') 
   WHEN 0 THEN  CONT.EMAIL_03
   ELSE SUBSTR(CONT.EMAIL_03, (INSTR( CONT.EMAIL_03, '<')+1), LENGTH(CONT.EMAIL_03)-INSTR(CONT.EMAIL_03, '<')-1) 
   END )  = ( CASE INSTR(MA.FROM_EMAIL, '<') 
   WHEN 0 THEN MA.FROM_EMAIL
   ELSE SUBSTR(MA.FROM_EMAIL, (INSTR(MA.FROM_EMAIL, '<')+1), LENGTH(MA.FROM_EMAIL)-INSTR(FROM_EMAIL, '<')-1) 
   END )
  OR 
    (CASE INSTR( CONT.EMAIL_03, '<') 
   WHEN 0 THEN  CONT.EMAIL_03
   ELSE SUBSTR(CONT.EMAIL_03, (INSTR( CONT.EMAIL_03, '<')+1), LENGTH(CONT.EMAIL_03)-INSTR(CONT.EMAIL_03, '<')-1) 
   END ) = (CASE INSTR(MA.TO_EMAIL, '<') 
   WHEN 0 THEN MA.TO_EMAIL
   ELSE SUBSTR(MA.TO_EMAIL, (INSTR(MA.TO_EMAIL, '<')+1), LENGTH(MA.TO_EMAIL)-INSTR(TO_EMAIL, '<')-1) 
   END )
   );
SHOW TABLES LIKE 'BASE_STOCK_QUOTES_VW';
SHOW TABLES LIKE 'BASE_STOCK_QUOTES_VW';
DROP VIEW BASE_STOCK_QUOTES_VW;
CREATE VIEW BASE_STOCK_QUOTES_VW AS SELECT 
  STOC.IDCODE,
  STOC.INVESTPROD_CODE,
  STOC.CLX_EFFTDATE,
  STOC.CURRENCY_CODE,
  STOC.PRICE,
  STOC.DIRTY_PRICE
FROM 
  BASE_STOCK_QUOTES STOC 
WHERE 
  STOC.CLX_EFFTDATE  = (SELECT MAX(STOCX.CLX_EFFTDATE) 
      FROM BASE_STOCK_QUOTES STOCX
      WHERE STOCX.INVESTPROD_CODE = STOC.INVESTPROD_CODE
        AND STOCX.CLX_EFFTDATE<=NOW())
AND STOC.CLX_AUTH_STATUS = 'AP';
SHOW TABLES LIKE 'CRM_ACCO_REVSUM_VW';
SHOW TABLES LIKE 'CRM_ACCO_REVSUM_VW';
DROP VIEW CRM_ACCO_REVSUM_VW;
CREATE VIEW CRM_ACCO_REVSUM_VW AS SELECT 
1 ID
,ASSIGNEDTO_USER
,COUNT(ID) ACCO_CNT
FROM CRM_ACCOUNTS ACCO
WHERE 1=1
AND EXISTS (SELECT 'X' 
	FROM CRM_ACCOUNT_PRODUCTS ACPS
	WHERE ACPS.ACCOUNTCODE = ACCO.IDCODE
	AND ACPS_STAT <> "I"
	AND ACPS.OPENING_DATE <= DATE_SUB(CURDATE(),INTERVAL 1 YEAR) 
	)
GROUP BY ASSIGNEDTO_USER;
SHOW TABLES LIKE 'CRM_ACCOPROD_VW';
SHOW TABLES LIKE 'CRM_ACCOPROD_VW';
DROP VIEW CRM_ACCOPROD_VW;
CREATE VIEW CRM_ACCOPROD_VW AS SELECT 
1 ID,
PROD.BUSINESS_UNIT,
COLO.REGION_CODE,
ACPS.BRANCH,
ACCO.ASSIGNEDTO_USER,
ACUS.EMAIL,
ACCO.IDNAME ACCO_NAME,
ACPS.IDCODE ACPS_CODE,
ACPS.CLX_EFFTDATE EFFTDATE,
ACPS.CLIENT_TYPE,
(SELECT ACPS1.CLIENT_TYPE
  FROM CRM_ACCOUNT_PRODUCTS ACPS1
  WHERE ACPS1.IDCODE=ACPS.IDCODE
  AND ACPS1.CLX_EFFTDATE=(SELECT MAX(X.CLX_EFFTDATE) CLX_EFFTDATE 
	FROM CRM_ACCOUNT_PRODUCTS X 
	WHERE  1=1
	AND X.IDCODE=ACPS1.IDCODE 
	AND X.CLX_EFFTDATE < ACPS.CLX_EFFTDATE)) PREVCLIENT_TYPE,
ACPS.BALANCE_AMT,
(SELECT ACPS2.BALANCE_AMT
  FROM CRM_ACCOUNT_PRODUCTS ACPS2
  WHERE ACPS2.IDCODE=ACPS.IDCODE
  AND ACPS2.CLX_EFFTDATE=(SELECT MAX(X.CLX_EFFTDATE) CLX_EFFTDATE 
	FROM CRM_ACCOUNT_PRODUCTS X 
	WHERE  1=1
	AND X.IDCODE=ACPS2.IDCODE 
	AND X.CLX_EFFTDATE <= CONCAT((YEAR(ACPS.CLX_EFFTDATE)-1),'-12-31'))) PREVYRBAL_AMT,
( (ACPS.BALANCE_AMT) - 
(SELECT ACPS1.BALANCE_AMT
  FROM CRM_ACCOUNT_PRODUCTS ACPS1
  WHERE ACPS1.IDCODE=ACPS.IDCODE
  AND ACPS1.CLX_EFFTDATE=(SELECT MAX(X.CLX_EFFTDATE) EFFTDATE 
	FROM CRM_ACCOUNT_PRODUCTS X 
	WHERE  1=1
	AND X.IDCODE=ACPS1.IDCODE 
	AND X.CLX_EFFTDATE <= CONCAT((YEAR(ACPS.CLX_EFFTDATE)-1),'-12-31')))
	) BALANCE_INC_AMT
FROM 
 CRM_ACCOUNTS ACCO,  CRM_ACCOUNT_PRODUCTS ACPS,  BASE_COMPANY_LOCATIONS COLO,  CRM_PRODUCTS PROD, CLX_AC_USERS ACUS
WHERE 1=1
AND  ACPS.ACCOUNTCODE = ACCO.IDCODE
AND  ACPS.BRANCH = COLO.IDCODE
AND  ACPS.PRODUCTCODE = PROD.IDCODE
AND  ACPS.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE) EFFTDATE
	FROM CRM_ACCOUNT_PRODUCTS X 
	WHERE  X.IDCODE=ACPS.IDCODE )
AND  ACCO.ASSIGNEDTO_USER = ACUS.USERNAME
ORDER BY 
PROD.BUSINESS_UNIT ASC,COLO.REGION_CODE ASC,ACPS.BRANCH ASC,ACCO.ASSIGNEDTO_USER ASC,ACPS.IDCODE ASC,ACPS.CLX_EFFTDATE DESC;
SHOW TABLES LIKE 'GL_AS_BALANCE_VW';
SHOW TABLES LIKE 'GL_AS_BALANCE_VW';
DROP VIEW GL_AS_BALANCE_VW;
CREATE VIEW GL_AS_BALANCE_VW AS SELECT 
  0 ID,
  LEBA.GLACCOUNTCODE,
  GLAC.GL_TYPE,
  GLAC.TRUST_ITEM_TYPE,
  LEBA.COMP_CODE,
  LEBA.CHART_FIELD01,
  LEBA.CHART_FIELD02,
  LEBA.CHART_FIELD03,
  LEBA.CHART_FIELD04,
  LEBA.CURRENCY_CODE,
  SUM(LEBA.BALANCE_AMT) BALANCE_AMT,
  SUM(LEBA.BASE_BAL_AMT) BASE_BAL_AMT
FROM 
  GL_LEDGERS LEBA,
  GL_PARAMETERS_TBL GLCP,
  GL_CODES_TBL GLAC
WHERE   
  GLCP.COMP_CODE = LEBA.COMP_CODE
  AND GLCP.DEF_LEDGER_CODE = LEBA.LEDGER_CODE 
  AND GLAC.IDCODE = LEBA.GLACCOUNTCODE
  AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE
GROUP BY  LEBA.GLACCOUNTCODE,
  GLAC.GL_TYPE,
  GLAC.TRUST_ITEM_TYPE,
  LEBA.COMP_CODE,
  LEBA.CHART_FIELD01,
  LEBA.CHART_FIELD02,
  LEBA.CHART_FIELD03,
  LEBA.CHART_FIELD04,
  LEBA.CURRENCY_CODE;
SHOW TABLES LIKE 'INVE_RISKMGMT_ALLOC_VW';
SHOW TABLES LIKE 'INVE_RISKMGMT_ALLOC_VW';
DROP VIEW INVE_RISKMGMT_ALLOC_VW;
CREATE VIEW INVE_RISKMGMT_ALLOC_VW AS SELECT 
  INRD.ID,
  INRD.RM_POLICY,
  INRD.CLX_EFFTDATE,
  INRD.IDNAME,
  INRD.CLX_AUTH_STATUS,
  INRD.STATUS,
  INRD.INVE_INSTRMT_CODE,
  INRD.INSTRMT_ALOC_TYPE,
  INRD.INSTRMT_CODE_PCT,
  INRD.INSTRMT_CODE_AMT,
  INRD.PRODUCT_TYPE,
  INRD.PRODUCT_ALOC_TYPE,
  INRD.PRODUCT_TYPE_PCT,
  INRD.PRODUCT_TYPE_AMT,
  INRD.REGION_CODE,
  INRD.REGION_ALOC_TYPE,
  INRD.REGION_PCT,
  INRD.REGION_AMT,
  INRD.INV_SECTOR,
  INRD.INV_SECTOR_ALOC_TYPE,
  INRD.INV_SECTOR_PCT,
  INRD.INV_SECTOR_AMT,
  INRD.INVCRED_RATING,
  INRD.INVCRED_ALOC_TYPE,
  INRD.INVRATING_PCT,
  INRD.INVRATING_AMT,
  INRD.SEC_ISSUER,
  INRD.SEC_ISSR_ALOC_TYPE,
  INRD.SEC_ISSR_PCT,
  INRD.SEC_ISSR_AMT,
  INRD.COUNTRY,
  INRD.COUNTRY_ALOC_TYPE,
  INRD.COUNTRY_PCT,
  INRD.COUNTRY_AMT,
  INRD.GL_TYPE,
  INRD.GL_TYPE_ALOC_TYPE,
  INRD.GL_TYPE_PCT,
  INRD.GL_TYPE_AMT,
  INRD.TRUST_ITEM_TYPE,
  INRD.TRUST_ITEM_ALOC_TYPE,
  INRD.TRUST_ITEM_PCT,
  INRD.TRUST_ITEM_AMT,
  INRD.FIAE_CODE,
  INRD.FIAE_ALOC_TYPE,
  INRD.FIAE_PCT,
  INRD.FIAE_AMT,
  INRD.CREATEDBY,
  INRD.CDATE,
  INRD.MODIFIEDBY,
  INRD.MDATE,
  INRM.IDNAME POLICY_NAME,
  INRM.CHART_FIELD01,
  INRM.PORTFOLIO_CODE
FROM 
  INVE_RISKMGMT_POLICIES INRM,
  INVE_RISKMGMT_PROD_ALLOC INRD
WHERE 1=1
  AND INRM.STATUS = 'A'
  AND INRD.STATUS = 'A'
  AND INRD.CLX_AUTH_STATUS = 'AP'
  AND INRM.IDCODE = INRD.RM_POLICY 
  AND INRM.CLX_EFFTDATE = INRD.CLX_EFFTDATE;
SHOW TABLES LIKE 'GL_JOURNAL_OPER_VW';
SHOW TABLES LIKE 'GL_JOURNAL_OPER_VW';
DROP VIEW GL_JOURNAL_OPER_VW;
CREATE VIEW GL_JOURNAL_OPER_VW AS SELECT 
  JEHD.IDCODE,
  JEHD.EFFTDATE,  
  JELN.GLACCOUNTCODE,
  GLAC.GL_TYPE,
  GLAC.TRUST_ITEM_TYPE,
  JELN.CURRENCY_CODE,
  JELN.EXCHANGE_RT,
  JELN.CUR_OPERATOR,
  JELN.DEBIT_TRANS_AMT,
  JELN.CREDIT_TRANS_AMT,
  JELN.DEBIT_AMT,
  JELN.CREDIT_AMT,
  JEHD.COMP_CODE,
  JELN.CHART_FIELD01,
  JELN.CHART_FIELD02,
  JELN.CHART_FIELD03,
  JELN.CHART_FIELD04,
  JELN.ITEM_CODE,
  JELN.ITEM_REF_NO,
  JEHD.JE_SOURCE,
  JEHD.REVERSED,
  JEHD.ADJUSTMENT,
  JEHD.IDNAME,
  JEHD.TRANS_CODE,
  JEHD.INAT_CODE,
  JEHD.TRANSTBL_CODE,
  JEHD.HAS_INVOICE,
  JEHD.CLOSING_ENTRY
FROM 
  GL_JOURNAL_HDR JEHD,
  GL_JOURNAL_LINES JELN,
  GL_CODES_TBL GLAC,
  GL_PARAMETERS_TBL GLCP
WHERE
  JELN.JEHDR_CODE = JEHD.IDCODE
  AND GLCP.COMP_CODE = JEHD.COMP_CODE
  AND GLAC.GLGROUP_CODE = GLCP.GLGROUP_CODE 
  AND GLAC.IDCODE = JELN.GLACCOUNTCODE;
SHOW TABLES LIKE 'GL_ASSETS_AND_ACC_VW';
SHOW TABLES LIKE 'GL_ASSETS_AND_ACC_VW';
DROP VIEW GL_ASSETS_AND_ACC_VW;
CREATE VIEW GL_ASSETS_AND_ACC_VW AS SELECT /*CUENTAS DE BANCO*/
  FIAS.ID,
  'FIBK' TABLECODE,
  FIBK.COMP_CODE, 
  FIAS.CONTRACT_CODE CHART_FIELD01, 
  FIAS.IDCODE CHART_FIELD03, 
  FIBK.BANK_ACCOUNT_NO PRODUCT_NO, 
  PRAT.PRODUCT_CODE,
  PRAT.PROD_STATUS,
  PRAT.PRO_GL_CODE,
  PRAT.AR_GL_CODE,
  FIBK.CURRENCY_CODE,
  NULL PORTFOLIO_CODE,
  PROD.PRODUCT_CLASS PRODUCT_CLASS,
  PROD.PRODUCT_TYPE PRODUCT_TYPE
FROM 
  FIDU_BANK_ACCOUNTS FIBK,
  FIDU_ITEMS FIAS,  
  CRM_PRODUCTS PROD,
  GL_PROD_PRMTR_TBL PRAT
WHERE 
  FIBK.BANK_ACCOUNT_NO = FIAS.FIDU_BANKACT_CODE
  AND PROD.IDCODE = PRAT.PRODUCT_CODE
  AND PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE
  AND PRAT.PROD_STATUS = 'VIG'
UNION
SELECT /*CREDITOS*/
  FIAS.ID,
  'FILO' TABLECODE,
  FILO.COMP_CODE, 
  FIAS.CONTRACT_CODE CHART_FIELD01, 
  FIAS.IDCODE CHART_FIELD03, 
  FILO.IDCODE PRODUCT_NO, 
  PRAT.PRODUCT_CODE,
  PRAT.PROD_STATUS,
  PRAT.PRO_GL_CODE,
  PRAT.AR_GL_CODE,
  FILO.CURRENCY_CODE,
  NULL PORTFOLIO_CODE,
  PROD.PRODUCT_CLASS,
  PROD.PRODUCT_TYPE

FROM 
  CRED_CREDITS FILO,
  FIDU_ITEMS FIAS,  
  CRM_PRODUCTS PROD,
  GL_PROD_PRMTR_TBL PRAT
WHERE 
  FILO.IDCODE = FIAS.LOAN_CODE
  AND PROD.IDCODE = PRAT.PRODUCT_CODE
  AND PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE
  AND PRAT.PROD_STATUS = FILO.LOAN_STATUS
  AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE)
    FROM CRED_CREDITS FILOX
    WHERE FILOX.IDCODE = FILO.IDCODE
      AND FILOX.CLX_EFFTDATE <= NOW())
UNION
SELECT /*BIENES*/
  FIAS.ID,
  'FIAE' TABLECODE,
  FIAE.COMP_CODE, 
  FIAS.CONTRACT_CODE CHART_FIELD01, 
  FIAS.IDCODE CHART_FIELD03, 
  FIAE.IDCODE PRODUCT_NO, 
  PRAT.PRODUCT_CODE,
  PRAT.PROD_STATUS,
  PRAT.PRO_GL_CODE,
  PRAT.AR_GL_CODE,
  FIAE.CURRENCY_CODE,
  NULL PORTFOLIO_CODE,
  PROD.PRODUCT_CLASS,
  PROD.PRODUCT_TYPE

FROM 
  AMGT_ASSETS FIAE,
  GL_PROD_PRMTR_TBL PRAT,
  CRM_PRODUCTS PROD,
  FIDU_ITEMS FIAS
	/*,
  GL_AS_BALANCE_VW JACV
	*/
WHERE 
  FIAE.IDCODE = FIAS.ASSET_CODE
	/*
  AND JACV.GLACCOUNTCODE = PRAT.PRO_GL_CODE 
	*/
  AND PROD.IDCODE = PRAT.PRODUCT_CODE
	/*
  AND JACV.CHART_FIELD03 = FIAS.IDCODE
  AND JACV.CURRENCY_CODE = FIAE.CURRENCY_CODE
	*/
  AND PRAT.PRODUCT_CODE = FIAE.PRODUCT_CODE
  AND PRAT.PROD_STATUS = 'VIG'
  AND FIAE.CLX_EFFTDATE = (SELECT MAX(FIAEX.CLX_EFFTDATE)
    FROM AMGT_ASSETS FIAEX
    WHERE FIAEX.IDCODE = FIAE.IDCODE
      AND FIAEX.CLX_EFFTDATE <= NOW())
UNION
SELECT /*inversiones*/
  FIAS.ID,
  'INFA' TABLECODE,
  INFA.COMP_CODE, 
  FIAS.CONTRACT_CODE CHART_FIELD01, 
  FIAS.IDCODE CHART_FIELD03, 
  'MANY' PRODUCT_NO, 
  MAX(PRAT.PRODUCT_CODE) PRODUCT_CODE,
  MAX(PRAT.PROD_STATUS) PROD_STATUS,
  PRAT.PRO_GL_CODE,
  PRAT.AR_GL_CODE,
  INFA.CURRENCY_CODE,
  FIAS.PORTFOLIO_CODE,
  MAX(PROD.PRODUCT_CLASS) PRODUCT_CLASS,
  MAX(PROD.PRODUCT_TYPE) PRODUCT_TYPE
FROM 
  INVE_PRODUCTS_TBL INPR,
  INVE_INVESTMENTS INFA,
  FIDU_ITEMS FIAS,  
  CRM_PRODUCTS PROD,
  GL_PROD_PRMTR_TBL PRAT
WHERE 
  INFA.PORTFOLIO_CODE = FIAS.PORTFOLIO_CODE
  AND PROD.IDCODE = PRAT.PRODUCT_CODE
  AND PRAT.PRODUCT_CODE = INFA.PRODUCT_CODE
  AND INPR.INVESTMENT_CODE = INFA.INVESTMENT_CODE
  AND INPR.CLX_EFFTDATE = (SELECT MAX(INPRX.CLX_EFFTDATE)
    FROM INVE_PRODUCTS_TBL INPRX
    WHERE INPRX.INVESTMENT_CODE = INPR.INVESTMENT_CODE
    AND INPRX.CLX_EFFTDATE<=NOW())
  AND PRAT.PROD_STATUS = 'VIG'
 GROUP BY
   FIAS.ID,
  INFA.COMP_CODE, 
  FIAS.CONTRACT_CODE, 
  FIAS.IDCODE, 
  PRAT.PRO_GL_CODE,
  PRAT.AR_GL_CODE,
  INFA.CURRENCY_CODE,
  FIAS.PORTFOLIO_CODE;
SHOW TABLES LIKE 'GL_ALL_ASSETS2_VW';
SHOW TABLES LIKE 'GL_ALL_ASSETS2_VW';
DROP VIEW GL_ALL_ASSETS2_VW;
CREATE VIEW GL_ALL_ASSETS2_VW AS SELECT /*CUENTAS DE BANCO*/
  FIAS.ID,
  'FIBK' TABLECODE,
  FIBK.COMP_CODE, 
  FIAS.CONTRACT_CODE CHART_FIELD01, 
  FIAS.IDCODE CHART_FIELD03, 
  FIBK.BANK_ACCOUNT_NO PRODUCT_NO, 
  PRAT.PRODUCT_CODE,
  PRAT.PROD_STATUS,
  PRAT.PRO_GL_CODE,
  PRAT.AR_GL_CODE,
  FIBK.CURRENCY_CODE,
	/*
  FIBK.BALANCE_AMT,
  FIBK.INTEARNED_AMT,
	FIBK.INTPAID_AMT,
	*/
	NULL PORTFOLIO_CODE,
  PROD.PRODUCT_CLASS,
  PROD.PRODUCT_TYPE,
  NULL INV_SECTOR,
  NULL INVCRED_RATING,
  FIBK.COUNTRY,
  FIBK.BANK_CODE SEC_ISSUER,
  NULL REGION_CODE
FROM 
  FIDU_BANK_ACCOUNTS FIBK,
  FIDU_ITEMS FIAS,  
  CRM_PRODUCTS PROD,
  GL_PROD_PRMTR_TBL PRAT
WHERE 
  FIBK.BANK_ACCOUNT_NO = FIAS.FIDU_BANKACT_CODE
  AND PROD.IDCODE = PRAT.PRODUCT_CODE
  AND PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE
  AND PRAT.PROD_STATUS = 'VIG'
UNION
SELECT /*CREDITOS*/
  FIAS.ID,
  'FILO' TABLECODE,
  FILO.COMP_CODE, 
  FIAS.CONTRACT_CODE CHART_FIELD01, 
  FIAS.IDCODE CHART_FIELD03, 
  FILO.IDCODE PRODUCT_NO, 
  PRAT.PRODUCT_CODE,
  PRAT.PROD_STATUS,
  PRAT.PRO_GL_CODE,
  PRAT.AR_GL_CODE,
  FILO.CURRENCY_CODE,
	/*
  FILO.PRINCIPAL_BAL BALANCE_AMT,
  FILO.INTEARNED_AMT,
	FILO.INTPAID_AMT,
	*/
	NULL PORTFOLIO_CODE,
  PROD.PRODUCT_CLASS,
  PROD.PRODUCT_TYPE,
  NULL INV_SECTOR,
  NULL INVCRED_RATING,
  NULL COUNTRY,
  NULL SEC_ISSUER,
  NULL REGION_CODE
FROM 
  CRED_CREDITS FILO,
  FIDU_ITEMS FIAS,  
  CRM_PRODUCTS PROD,
  GL_PROD_PRMTR_TBL PRAT
WHERE 
  FILO.IDCODE = FIAS.LOAN_CODE
  AND PROD.IDCODE = PRAT.PRODUCT_CODE
  AND PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE
  AND PRAT.PROD_STATUS = FILO.LOAN_STATUS
  AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE)
    FROM CRED_CREDITS FILOX
    WHERE FILOX.IDCODE = FILO.IDCODE
      AND FILOX.CLX_EFFTDATE <= NOW())
UNION
SELECT /*BIENES*/
  FIAS.ID,
  'FIAE' TABLECODE,
  FIAE.COMP_CODE, 
  FIAS.CONTRACT_CODE CHART_FIELD01, 
  FIAS.IDCODE CHART_FIELD03, 
  FIAE.IDCODE PRODUCT_NO, 
  PRAT.PRODUCT_CODE,
  PRAT.PROD_STATUS,
  PRAT.PRO_GL_CODE,
  PRAT.AR_GL_CODE,
  FIAE.CURRENCY_CODE,
	/*
  JACV.BALANCE_AMT,
  0 INTEARNED_AMT,
	0 INTPAID_AMT,
	*/
	NULL PORTFOLIO_CODE,
  PROD.PRODUCT_CLASS,
  PROD.PRODUCT_TYPE,
  NULL INV_SECTOR,
  FIAE.INVCRED_RATING,
  FIAE.COUNTRY,
  FIAE.SEC_ISSUER,
  NULL REGION_CODE
FROM 
  AMGT_ASSETS FIAE,
  GL_PROD_PRMTR_TBL PRAT,
  CRM_PRODUCTS PROD,
  FIDU_ITEMS FIAS
	/*,
  GL_AS_BALANCE_VW JACV
	*/
WHERE 
  FIAE.IDCODE = FIAS.LOAN_CODE
	/*
  AND JACV.GLACCOUNTCODE = PRAT.PRO_GL_CODE 
	*/
  AND PROD.IDCODE = PRAT.PRODUCT_CODE
	/*
  AND JACV.CHART_FIELD03 = FIAS.IDCODE
  AND JACV.CURRENCY_CODE = FIAE.CURRENCY_CODE
	*/
  AND PRAT.PRODUCT_CODE = FIAE.PRODUCT_CODE
  AND PRAT.PROD_STATUS = 'VIG'
  AND FIAE.CLX_EFFTDATE = (SELECT MAX(FIAEX.CLX_EFFTDATE)
    FROM AMGT_ASSETS FIAEX
    WHERE FIAEX.IDCODE = FIAE.IDCODE
      AND FIAEX.CLX_EFFTDATE <= NOW())
UNION
SELECT /*inversiones*/
  FIAS.ID,
  'INFA' TABLECODE,
  INFA.COMP_CODE, 
  FIAS.CONTRACT_CODE CHART_FIELD01, 
  FIAS.IDCODE CHART_FIELD03, 
  INFA.INVESTMENT_CODE PRODUCT_NO, 
  PRAT.PRODUCT_CODE,
  PRAT.PROD_STATUS,
  PRAT.PRO_GL_CODE,
  PRAT.AR_GL_CODE,
  INFA.CURRENCY_CODE,
	/*
  INFA.INVEST_AMT BALANCE_AMT,
  INFA.ACCRUED_INT_AMT INTEARNED_AMT,
	INFA.PAID_INT_AMT INTPAID_AMT,
	*/
	INFA.PORTFOLIO_CODE,
  PROD.PRODUCT_CLASS,
  PROD.PRODUCT_TYPE,
  INPR.INV_SECTOR,
  INPR.INVCRED_RATING,
  INPR.COUNTRY,
  INPR.SEC_ISSUER,
  NULL REGION_CODE
FROM 
  INVE_PRODUCTS_TBL INPR,
  INVE_INVESTMENTS INFA,
  FIDU_ITEMS FIAS,  
  CRM_PRODUCTS PROD,
  GL_PROD_PRMTR_TBL PRAT
WHERE 
  INFA.PORTFOLIO_CODE = FIAS.PORTFOLIO_CODE
  AND PROD.IDCODE = PRAT.PRODUCT_CODE
  AND PRAT.PRODUCT_CODE = INFA.PRODUCT_CODE
  AND INPR.INVESTMENT_CODE = INFA.INVESTMENT_CODE
  AND INPR.CLX_EFFTDATE = (SELECT MAX(INPRX.CLX_EFFTDATE)
    FROM INVE_PRODUCTS_TBL INPRX
    WHERE INPRX.INVESTMENT_CODE = INPR.INVESTMENT_CODE
    AND INPRX.CLX_EFFTDATE<=NOW())
  AND PRAT.PROD_STATUS = 'VIG'
 
 ORDER BY 
	CHART_FIELD01, 
  CHART_FIELD03, 
  PRODUCT_NO
 ;;
SHOW TABLES LIKE 'CRED_CREDIT_PRMT_VW';
SHOW TABLES LIKE 'CRED_CREDIT_PRMT_VW';
DROP VIEW CRED_CREDIT_PRMT_VW;
CREATE VIEW CRED_CREDIT_PRMT_VW AS SELECT 
  PRAT.ID,
  FIAS.LOAN_CODE,
  PRAT.PRODUCT_CODE,
  PRAT.PROD_STATUS,
  PRAT.PRO_GL_CODE,
  PRAT.AR_GL_CODE,
  FIAS.CONTRACT_CODE CHART_FIELD01,
  FIAS.IDCODE CHART_FIELD03
FROM 
  GL_PROD_PRMTR_TBL PRAT, 
  CRED_CREDITS FILO, 
  FIDU_ITEMS FIAS
WHERE
  FIAS.LOAN_CODE = FILO.IDCODE
  AND PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE;
SHOW TABLES LIKE 'BASE_SCALE_VW';
SHOW TABLES LIKE 'BASE_SCALE_VW';
DROP VIEW BASE_SCALE_VW;
CREATE VIEW BASE_SCALE_VW AS SELECT 
  SCIT.ID,
  SCIT.SCTB_CODE,
  SCIT.SEQNUM,
  SCIT.CLX_EFFTDATE,
  SCIT.FROM_AMT,
  SCIT.TO_AMT,
  SCIT.SCGR_CODE,
  SCIT.RATE_PCT,
  SCTB.IDNAME
FROM
  BASE_SCALES_TBL SCTB,
  BASE_SCALE_ITEMS SCIT
WHERE 
  SCTB.IDCODE = SCIT.SCTB_CODE 
  AND SCTB.CLX_EFFTDATE = SCIT.CLX_EFFTDATE
  AND SCIT.STATUS = 'A'
  AND SCTB.STATUS = 'A';
SHOW TABLES LIKE 'BILL_INVOICES_VW';
SHOW TABLES LIKE 'BILL_INVOICES_VW';
DROP VIEW BILL_INVOICES_VW;
CREATE VIEW BILL_INVOICES_VW AS SELECT 
  INVO.ID,
  INVO.COMP_CODE,
  INVO.IDCODE,
  INVO.INVOICE_NO,
  INVO.INVOICEDATE,
  INVO.ACCOUNTCODE,
  INVO.DEBTOR_FICO_CODE,
  INVO.IDNAME,
  INVO.CURRENCY_CODE,
  INVO.INVOICE_AMT,
  IFNULL(IF(INVO.OPENING_BAL<>0, INVO.INVOICE_AMT-INVO.OPENING_BAL, 0)+
    IFNULL((SELECT 
      SUM(INPY.PAID_AMT) FIAT_TRANS_AMT
    FROM 
     GL_JOURNAL_HDR JEHD,
     FIDU_TRANSACTIONS FIAT,  
     BILL_INVPYMT_TRANS INPY
    WHERE 
      INPY.INVOICECODE = INVO.IDCODE 
      AND INPY.JEHDR_CODE = JEHD.IDCODE 
      AND FIAT.IDCODE = JEHD.TRANS_CODE
      AND FIAT.TRANS_STATUS = 'AP'
      AND FIAT.VOID = 0),0),0) PAID_AMT,
  IFNULL(INVO.INVOICE_AMT-(IF(INVO.OPENING_BAL<>0, INVO.INVOICE_AMT-INVO.OPENING_BAL, 0)+
    IFNULL((SELECT 
      SUM(INPY.PAID_AMT) FIAT_TRANS_AMT
    FROM 
     GL_JOURNAL_HDR JEHD,
     FIDU_TRANSACTIONS FIAT,  
     BILL_INVPYMT_TRANS INPY
    WHERE 
      INPY.INVOICECODE = INVO.IDCODE 
      AND INPY.JEHDR_CODE = JEHD.IDCODE
      AND FIAT.IDCODE = JEHD.TRANS_CODE
      AND FIAT.TRANS_STATUS = 'AP'
      AND FIAT.VOID = 0),0)),0) OPEN_BALANCE,
  INVO.AR_ITEM_CODE,
  INVO.DUE_DATE,
  INVO.INVO_STAT,
  INVO.CHART_FIELD01,
  INVO.CHART_FIELD02,
  INVO.CHART_FIELD03,
  INVO.CHART_FIELD04,
  INVO.EXT_REF_NO,
  INVO.CLX_AUTH_STATUS,
  INVO.JEHDR_CODE,
  INVO.PAY_JEHDR_CODE,
  INVO.CDATE,
  INVO.CREATEDBY,
  INVO.MDATE,
  INVO.MODIFIEDBY, 
  #AND GLCP.INVO_AGING_0TO30,
  IF(INVO.DUE_DATE>CURDATE(),0,IF(INVO.INVO_STAT IN ('01','03'), DATEDIFF(CURDATE(),INVO.DUE_DATE), 0)) AGEDAYS,
  IF(GLCP.INVO_AGING_0TO30=1,
  (CASE 
   WHEN (IF(INVO.INVO_STAT IN ('01','03'), DATEDIFF(CURDATE(),INVO.INVOICEDATE), 0)) <= 30 THEN '0030'
   WHEN (IF(INVO.INVO_STAT IN ('01','03'), DATEDIFF(CURDATE(),INVO.INVOICEDATE), 0)) BETWEEN 31 AND 60 THEN '3160'
   WHEN (IF(INVO.INVO_STAT IN ('01','03'), DATEDIFF(CURDATE(),INVO.INVOICEDATE), 0)) BETWEEN 61 AND 90 THEN '6190'
   WHEN (IF(INVO.INVO_STAT IN ('01','03'), DATEDIFF(CURDATE(),INVO.INVOICEDATE), 0)) > 90 THEN 'GT90'
   ELSE NULL
  END),
  (CASE 
   WHEN (IF(INVO.INVO_STAT IN ('01','03'), DATEDIFF(CURDATE(),INVO.DUE_DATE), 0)) <= 0 THEN '00'
   WHEN (IF(INVO.INVO_STAT IN ('01','03'), DATEDIFF(CURDATE(),INVO.DUE_DATE), 0)) BETWEEN 1 AND 30 THEN '0130'
   WHEN (IF(INVO.INVO_STAT IN ('01','03'), DATEDIFF(CURDATE(),INVO.DUE_DATE), 0)) BETWEEN 1 AND 30 THEN '0130'
   WHEN (IF(INVO.INVO_STAT IN ('01','03'), DATEDIFF(CURDATE(),INVO.DUE_DATE), 0)) BETWEEN 31 AND 60 THEN '3160'
   WHEN (IF(INVO.INVO_STAT IN ('01','03'), DATEDIFF(CURDATE(),INVO.DUE_DATE), 0)) BETWEEN 61 AND 90 THEN '6190'
   WHEN (IF(INVO.INVO_STAT IN ('01','03'), DATEDIFF(CURDATE(),INVO.DUE_DATE), 0)) > 90 THEN 'GT90'
   ELSE NULL
  END)) AS AGING_CTG,
  CURDATE() ASOF_DATE
FROM 
  GL_PARAMETERS_TBL GLCP,
  BILL_INVOICE INVO
WHERE
  GLCP.COMP_CODE = INVO.COMP_CODE;
SHOW TABLES LIKE 'GL_ALL_ASSETS_VW';
SHOW TABLES LIKE 'GL_ALL_ASSETS_VW';
DROP VIEW GL_ALL_ASSETS_VW;
CREATE VIEW GL_ALL_ASSETS_VW AS SELECT /*CUENTAS DE BANCO*/
  FIAS.ID,
  'FIBK' TABLECODE,
  FIBK.COMP_CODE, 
  FIAS.CONTRACT_CODE CHART_FIELD01, 
  FIAS.IDCODE CHART_FIELD03, 
  FIBK.BANK_ACCOUNT_NO PRODUCT_NO, 
  FIBK.IDNAME IDNAME, 
  PRAT.PRODUCT_CODE,
  PRAT.PROD_STATUS,
  PRAT.PRO_GL_CODE,
  PRAT.AR_GL_CODE,
  FIBK.CURRENCY_CODE,
  FIBK.BALANCE_AMT,
  FIBK.INTEARNED_AMT,
	FIBK.INTPAID_AMT,
	NULL PORTFOLIO_CODE,
  PROD.PRODUCT_CLASS,
  PROD.PRODUCT_TYPE,
  NULL INV_SECTOR,
  NULL INVCRED_RATING,
  FIBK.COUNTRY,
  FIBK.BANK_CODE SEC_ISSUER,
  NULL REGION_CODE
FROM 
  FIDU_BANK_ACCOUNTS FIBK,
  FIDU_ITEMS FIAS,  
  CRM_PRODUCTS PROD,
  GL_PROD_PRMTR_TBL PRAT
WHERE 
  FIBK.BANK_ACCOUNT_NO = FIAS.FIDU_BANKACT_CODE
  AND PROD.IDCODE = PRAT.PRODUCT_CODE
  AND PRAT.PRODUCT_CODE = FIBK.BANK_PROD_CODE
  AND PRAT.PROD_STATUS = 'VIG'
UNION ALL
SELECT /*CREDITOS*/
  FIAS.ID,
  'FILO' TABLECODE,
  FILO.COMP_CODE, 
  FIAS.CONTRACT_CODE CHART_FIELD01, 
  FIAS.IDCODE CHART_FIELD03, 
  FILO.IDCODE PRODUCT_NO, 
  FILO.IDNAME IDNAME, 
  PRAT.PRODUCT_CODE,
  PRAT.PROD_STATUS,
  PRAT.PRO_GL_CODE,
  PRAT.AR_GL_CODE,
  FILO.CURRENCY_CODE,
  FILO.PRINCIPAL_BAL BALANCE_AMT,
  FILO.INTEARNED_AMT,
	FILO.INTPAID_AMT,
	NULL PORTFOLIO_CODE,
  PROD.PRODUCT_CLASS,
  PROD.PRODUCT_TYPE,
  NULL INV_SECTOR,
  NULL INVCRED_RATING,
  NULL COUNTRY,
  NULL SEC_ISSUER,
  NULL REGION_CODE
FROM 
  CRED_CREDITS FILO,
  FIDU_ITEMS FIAS,  
  CRM_PRODUCTS PROD,
  GL_PROD_PRMTR_TBL PRAT
WHERE 
  FILO.IDCODE = FIAS.LOAN_CODE
  AND PROD.IDCODE = PRAT.PRODUCT_CODE
  AND PRAT.PRODUCT_CODE = FILO.PRODUCT_CODE
  AND PRAT.PROD_STATUS = FILO.LOAN_STATUS
  AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE)
    FROM CRED_CREDITS FILOX
    WHERE FILOX.IDCODE = FILO.IDCODE
      AND FILOX.CLX_EFFTDATE <= NOW())
UNION ALL
SELECT /*BIENES*/
  FIAS.ID,
  'FIAE' TABLECODE,
  FIAE.COMP_CODE, 
  FIAS.CONTRACT_CODE CHART_FIELD01, 
  FIAS.IDCODE CHART_FIELD03, 
  FIAE.IDCODE PRODUCT_NO, 
  FIAE.IDNAME IDNAME, 
  PRAT.PRODUCT_CODE,
  PRAT.PROD_STATUS,
  PRAT.PRO_GL_CODE,
  PRAT.AR_GL_CODE,
  FIAE.CURRENCY_CODE,
  JACV.BALANCE_AMT,
  0 INTEARNED_AMT,
	0 INTPAID_AMT,
	NULL PORTFOLIO_CODE,
  PROD.PRODUCT_CLASS,
  PROD.PRODUCT_TYPE,
  NULL INV_SECTOR,
  FIAE.INVCRED_RATING,
  FIAE.COUNTRY,
  FIAE.SEC_ISSUER,
  NULL REGION_CODE
FROM 
  AMGT_ASSETS FIAE,
  GL_PROD_PRMTR_TBL PRAT,
  CRM_PRODUCTS PROD,
  FIDU_ITEMS FIAS,
  GL_AS_BALANCE_VW JACV
WHERE 
  FIAE.IDCODE = FIAS.ASSET_CODE
  AND JACV.GLACCOUNTCODE = PRAT.PRO_GL_CODE 
  AND PROD.IDCODE = PRAT.PRODUCT_CODE
  AND JACV.CHART_FIELD03 = FIAS.IDCODE
  AND JACV.CURRENCY_CODE = FIAE.CURRENCY_CODE
  AND PRAT.PRODUCT_CODE = FIAE.PRODUCT_CODE
  AND PRAT.PROD_STATUS = 'VIG'
  AND FIAE.CLX_EFFTDATE = (SELECT MAX(FIAEX.CLX_EFFTDATE)
    FROM AMGT_ASSETS FIAEX
    WHERE FIAEX.IDCODE = FIAE.IDCODE
      AND FIAEX.CLX_EFFTDATE <= NOW())
UNION ALL
SELECT /*inversiones*/
  FIAS.ID,
  'INFA' TABLECODE,
  INFA.COMP_CODE, 
  FIAS.CONTRACT_CODE CHART_FIELD01, 
  FIAS.IDCODE CHART_FIELD03, 
  INFA.INVESTMENT_CODE PRODUCT_NO, 
  INPR.IDNAME IDNAME,
  PRAT.PRODUCT_CODE,
  PRAT.PROD_STATUS,
  PRAT.PRO_GL_CODE,
  PRAT.AR_GL_CODE,
  INFA.CURRENCY_CODE,
  INFA.INVEST_AMT BALANCE_AMT,
  INFA.ACCRUED_INT_AMT INTEARNED_AMT,
	INFA.PAID_INT_AMT INTPAID_AMT,
	INFA.PORTFOLIO_CODE,
  PROD.PRODUCT_CLASS,
  PROD.PRODUCT_TYPE,
  INPR.INV_SECTOR,
  INPR.INVCRED_RATING,
  INPR.COUNTRY,
  INPR.SEC_ISSUER,
  NULL REGION_CODE
FROM 
  INVE_PRODUCTS_TBL INPR,
  INVE_INVESTMENTS INFA,
  FIDU_ITEMS FIAS,  
  CRM_PRODUCTS PROD,
  GL_PROD_PRMTR_TBL PRAT
WHERE 
  INFA.PORTFOLIO_CODE = FIAS.PORTFOLIO_CODE
  AND PROD.IDCODE = PRAT.PRODUCT_CODE
  AND PRAT.PRODUCT_CODE = INFA.PRODUCT_CODE
  AND INPR.INVESTMENT_CODE = INFA.INVESTMENT_CODE
  AND INFA.CONTRACT_CODE = FIAS.CONTRACT_CODE
  AND INPR.CLX_EFFTDATE = (SELECT MAX(INPRX.CLX_EFFTDATE)
    FROM INVE_PRODUCTS_TBL INPRX
    WHERE INPRX.INVESTMENT_CODE = INPR.INVESTMENT_CODE
    AND INPRX.CLX_EFFTDATE<=NOW())
  AND PRAT.PROD_STATUS = 'VIG'
 ORDER BY 
	CHART_FIELD01, 
  CHART_FIELD03, 
  PRODUCT_NO;
SHOW TABLES LIKE 'BASE_USER_LANG_VW';
SHOW TABLES LIKE 'BASE_USER_LANG_VW';
DROP VIEW BASE_USER_LANG_VW;
CREATE VIEW BASE_USER_LANG_VW AS SELECT 
ID, 
USERNAME, 
PREFVALUE LANGUAGE
FROM CLX_US_PREFERENCES 
WHERE PREFKEY = 'LANGUAGE';
SHOW TABLES LIKE 'AP_PAY_INVOICES_VW';
SHOW TABLES LIKE 'AP_PAY_INVOICES_VW';
DROP VIEW AP_PAY_INVOICES_VW;
CREATE VIEW AP_PAY_INVOICES_VW AS SELECT 
  APIN.ID,
  APIN.COMP_CODE,
  APIN.IDCODE,
  APIN.INVOICE_NO,
  APIN.INVOICEDATE,
  APIN.VENDOR_CODE,
  APIN.IDNAME,
  APIN.CURRENCY_CODE,
  APIN.INVOICE_AMT,
  IFNULL(IF(APIN.OPENING_BAL<>0, APIN.INVOICE_AMT-APIN.OPENING_BAL, 0)+
    IFNULL((SELECT 
      SUM(APPY.PAID_AMT) FIAT_TRANS_AMT
    FROM 
     GL_JOURNAL_HDR JEHD,
     FIDU_TRANSACTIONS FIAT,  
     AP_PYMT_TRANS APPY
    WHERE 
      APPY.PAYINV_CODE = APIN.IDCODE 
      AND APPY.JEHDR_CODE = JEHD.IDCODE 
      AND FIAT.IDCODE = JEHD.TRANS_CODE
      AND FIAT.TRANS_STATUS = 'AP'
      AND FIAT.VOID = 0),0),0) PAID_AMT,
  IFNULL(APIN.INVOICE_AMT-(IF(APIN.OPENING_BAL<>0, APIN.INVOICE_AMT-APIN.OPENING_BAL, 0)+
    IFNULL((SELECT 
      SUM(APPY.PAID_AMT) FIAT_TRANS_AMT
    FROM 
     GL_JOURNAL_HDR JEHD,
     FIDU_TRANSACTIONS FIAT,  
     AP_PYMT_TRANS APPY
    WHERE 
      APPY.PAYINV_CODE = APIN.IDCODE 
      AND APPY.JEHDR_CODE = JEHD.IDCODE
      AND FIAT.IDCODE = JEHD.TRANS_CODE
      AND FIAT.TRANS_STATUS = 'AP'
      AND FIAT.VOID = 0),0)),0) OPEN_BALANCE,
  APIN.AP_ITEM_CODE,
  APIN.DUE_DATE,
  APIN.INVO_STAT,
  APIN.CHART_FIELD01,
  APIN.CHART_FIELD02,
  APIN.CHART_FIELD03,
  APIN.CHART_FIELD04,
  APIN.EXT_REF_NO,
  APIN.CLX_AUTH_STATUS,
  APIN.JEHDR_CODE,
  APIN.PAY_JEHDR_CODE,
  APIN.CDATE,
  APIN.CREATEDBY,
  APIN.MDATE,
  APIN.MODIFIEDBY, 
  #AND GLCP.INVO_AGING_0TO30,
  IF(APIN.DUE_DATE>CURDATE(),0,IF(APIN.INVO_STAT IN ('01','03'), DATEDIFF(CURDATE(),APIN.DUE_DATE), 0)) AGEDAYS,
  IF(GLCP.INVO_AGING_0TO30=1,
  (CASE 
   WHEN (IF(APIN.INVO_STAT IN ('01','03'), DATEDIFF(CURDATE(),APIN.INVOICEDATE), 0)) <= 30 THEN '0030'
   WHEN (IF(APIN.INVO_STAT IN ('01','03'), DATEDIFF(CURDATE(),APIN.INVOICEDATE), 0)) BETWEEN 31 AND 60 THEN '3160'
   WHEN (IF(APIN.INVO_STAT IN ('01','03'), DATEDIFF(CURDATE(),APIN.INVOICEDATE), 0)) BETWEEN 61 AND 90 THEN '6190'
   WHEN (IF(APIN.INVO_STAT IN ('01','03'), DATEDIFF(CURDATE(),APIN.INVOICEDATE), 0)) > 90 THEN 'GT90'
   ELSE NULL
  END),
  (CASE 
   WHEN (IF(APIN.INVO_STAT IN ('01','03'), DATEDIFF(CURDATE(),APIN.DUE_DATE), 0)) <= 0 THEN '00'
   WHEN (IF(APIN.INVO_STAT IN ('01','03'), DATEDIFF(CURDATE(),APIN.DUE_DATE), 0)) BETWEEN 1 AND 30 THEN '0130'
   WHEN (IF(APIN.INVO_STAT IN ('01','03'), DATEDIFF(CURDATE(),APIN.DUE_DATE), 0)) BETWEEN 1 AND 30 THEN '0130'
   WHEN (IF(APIN.INVO_STAT IN ('01','03'), DATEDIFF(CURDATE(),APIN.DUE_DATE), 0)) BETWEEN 31 AND 60 THEN '3160'
   WHEN (IF(APIN.INVO_STAT IN ('01','03'), DATEDIFF(CURDATE(),APIN.DUE_DATE), 0)) BETWEEN 61 AND 90 THEN '6190'
   WHEN (IF(APIN.INVO_STAT IN ('01','03'), DATEDIFF(CURDATE(),APIN.DUE_DATE), 0)) > 90 THEN 'GT90'
   ELSE NULL
  END)) AS AGING_CTG,
  CURDATE() ASOF_DATE
FROM 
  GL_PARAMETERS_TBL GLCP,
  AP_PAY_INVOICES APIN
WHERE
  GLCP.COMP_CODE = APIN.COMP_CODE;
SHOW TABLES LIKE 'CRED_ASOP2_REFE_VW';
SHOW TABLES LIKE 'CRED_ASOP2_REFE_VW';
DROP VIEW CRED_ASOP2_REFE_VW;
CREATE VIEW CRED_ASOP2_REFE_VW AS /*
 * Vista "APR2" (despues del cambio del "Caso 1002893 - BDA-Eliminar cred 7 yr Rep REFERE")
 */
SELECT 
	/* LEFT(IF(ACCO.IDENTIFICATION_APC <> '', ACCO.IDENTIFICATION_APC, ACCO.IDENTIFICATION),21) IDENT_CLIE, */
	LEFT(BASE_PA_IDENTIFICATION_MASK(ACCO.IDENTIFICATION, ACCO.ID_TYPE),21) IDENT_CLIE,

	IFNULL(ACCO.LEGAL_TYPE,'C') TIPO_CLIE,

	LEFT((SELECT MAX(PRMTX.PVALUE)
  FROM BASE_PARAMETERS PRMTX
  WHERE PRMTX.COMP_CODE = FILO.COMP_CODE
  AND PRMTX.IDNAME = 'CRED_APC_COD_GRUPO_ECON'),2) COD_GRUPO_ECON,

	LEFT((SELECT MAX(PRMTX.PVALUE)
  FROM BASE_PARAMETERS PRMTX 
  WHERE PRMTX.COMP_CODE = FILO.COMP_CODE
  AND PRMTX.IDNAME = 'CRED_APC_TIPO_ASOC'),2) TIPO_ASOC,
  
	LEFT((SELECT MAX(PRMTX.PVALUE)
  FROM BASE_PARAMETERS PRMTX
  WHERE PRMTX.COMP_CODE = FILO.COMP_CODE
  AND PRMTX.IDNAME = 'CRED_APC_IDENT_ASOC'),6) IDENT_ASOC,
  
	LEFT(REPLACE(REPLACE(FILO.IDCODE," ",""),"-",""),25) CUENTA,
	
	LEFT(CONCAT('DM',(SELECT MAX(PRMTX.PVALUE)
  FROM BASE_PARAMETERS PRMTX
  WHERE PRMTX.COMP_CODE = FILO.COMP_CODE
  AND PRMTX.IDNAME = 'CRED_APC_IDENT_ASOC')),8) USER_ID,
  
	FILO.PAY_OR_FREQ_TYPE TIPO_FORMA_PAGO,
	
	FILO.STAT_REL_TYPE TIPO_RELACION,
	
	DATE_FORMAT(FILO.START_DATE, '%m/%d/%Y') FEC_INICIO_REL,
	
	DATE_FORMAT(FILO.END_DATE, '%m/%d/%Y') FEC_FINAL_REL,
	
	ROUND(FILO.LOAN_AMT,2) MONTO_ORIGINAL,
	
	ROUND(FILO.PRINCIPAL_BAL,2) SALDO_ACTUAL,
	
	LEFT(FILO.NO_PAYMENTS,3) NUM_PAGOS,
	
	ROUND(FILS.PAYMENT_AMT, 2) IMPORTE_PAGO,
	
	/* DATE_FORMAT(FILO.LAST_PAY_DATE, '%m/%d/%Y') FEC_ULTIMO_PAGO, */
	DATE_FORMAT(NULLIF(FILO.LAST_PAY_DATE, "0000-00-00"), '%m/%d/%Y') FEC_ULTIMO_PAGO,
	
	/* ROUND(IFNULL((SELECT FILO.LAST_PAY_AMT),0) ,2) MONTO_ULTIMO_PAGO, */
	IFNULL(ROUND(FILO.LAST_PAY_AMT,2), NULL) MONTO_ULTIMO_PAGO,
	
	/*
	DATE_FORMAT(FILO.END_DATE, '%m/%d/%Y')  FEC_CANCELACIÓN,
	*/
	IF(FILO.LOAN_STATUS="CAN", IF(FILO.PRINCIPAL_BAL=0, DATE_FORMAT(FILO.END_DATE, '%m/%d/%Y'), ""), "") FEC_CANCELACIÓN,
	
	'' TIPO_COMPORTA,/*Este campo debe enviarse en blanco*/
	
	/*
	FILO.LOAN_STATUS ESTATUS_REF,
	*/
	IF(FILO.LOAN_STATUS="CAN", IF(FILO.PRINCIPAL_BAL=0, "2", "1"), "1") ESTATUS_REF,
	
	/*
		OJO = Esta columna comparaba contra la fecha del parametro CRED_APC_EXPORT_DATE
		Mientras que CRED_PASS_DUE_DAYS() lo hace contra la fecha de operaciones de la compania
	*/
	/*
	IF(DATEDIFF(PRMT_EXP_APC_DATE.PVALUE, FILS.PERIOD_END_DATE)>0 AND FILS.PAID_AMT=0, DATEDIFF(PRMT_EXP_APC_DATE.PVALUE, FILS.PERIOD_END_DATE), 0) NUM_DIAS_ATRASO,
	*/
CRED_PASS_DUE_DAYS_ASOF(FILO.IDCODE, PRMT_EXP_APC_DATE.PVALUE) NUM_DIAS_ATRASO,
	
	'' MONTO_CODIFICADO,
	
	'' TIPO_CIFRA,
	
	FILO.STATUS_DESC OBSERVACION,
	
	DATE_FORMAT(PRMT_EXP_APC_DATE.PVALUE, '%m/%d/%Y') FEC_CORTE,
	
	(SELECT MAX(ACCOX.IDNAME) 
	FROM CRM_ACCOUNTS ACCOX
	WHERE ACCOX.IDCODE = FILO.GUARANTOR_01) NOM_FIADOR,
	
	(SELECT MAX(ACCOX.IDENTIFICATION) 
	FROM CRM_ACCOUNTS ACCOX
	WHERE ACCOX.IDCODE = FILO.GUARANTOR_01) CED_FIADOR
	
FROM
	BASE_PARAMETERS PRMT_EXP_APC_DATE,
	BASE_PARAMETERS PRMT_EXP_APC_EXPRY_SW, /* Flag Prescripcion a los 7 anios */
	CRM_ACCOUNTS ACCO,
	CRED_CREDITS FILO,
	CRED_PAYMNT_SCHEDULES FILS,
	BASE_PARAMETERS PRMT,
	GL_PARAMETERS_TBL GLCP
WHERE
  GLCP.COMP_CODE = FILO.COMP_CODE
	AND ACCO.IDCODE = FILO.DEBTOR_CODE
	/*AND FILO.COMP_CODE = @COMP_CODE */
	/*AND FILO.IDCODE = '10031'*/
	AND FILS.LOAN_CODE = FILO.IDCODE
	AND FILS.EFFTDATE = FILO.CLX_EFFTDATE
	AND FILS.PERIOD_START_DATE <= PRMT_EXP_APC_DATE.PVALUE
	/* AND FILS.PERIOD_END_DATE >= PRMT_EXP_APC_DATE.PVALUE */
	AND FILS.SEQNUM = (SELECT MAX(FILSX.SEQNUM)
                  FROM CRED_PAYMNT_SCHEDULES FILSX
                  WHERE FILSX.LOAN_CODE = FILO.IDCODE
                    AND FILSX.EFFTDATE = FILO.CLX_EFFTDATE
                    AND FILSX.PERIOD_START_DATE <= PRMT_EXP_APC_DATE.PVALUE)
  AND PRMT.COMP_CODE = FILO.COMP_CODE
  AND PRMT.IDNAME = 'CRED_APC_REPORT_ENABLED'
  AND PRMT.PVALUE = '1'
  AND (
	/* FILO.LOAN_STATUS NOT IN ('PRE','VEN') 
	OR (FILO.LOAN_STATUS = 'VEN' AND EXTRACT(YEAR_MONTH FROM FILO.END_DATE)=EXTRACT(YEAR_MONTH FROM PRMT_EXP_APC_DATE.PVALUE)) */
    FILO.LOAN_STATUS NOT IN ('PRE','CAN','VOID','CEAS') 
    OR (FILO.LOAN_STATUS = 'CAN' AND EXTRACT(YEAR_MONTH FROM FILO.END_DATE)=EXTRACT(YEAR_MONTH FROM PRMT_EXP_APC_DATE.PVALUE))
	)
	/* Condicion Prescripcion a los 7 anios - Inicio */
	AND (
			( 
				(
					FILO.LAST_PAY_DATE >= ADDDATE(PRMT_EXP_APC_DATE.PVALUE, INTERVAL -7 YEAR) 
					OR ( (FILO.LAST_PAY_DATE IS NULL OR FILO.LAST_PAY_DATE = '0000-00-00') 
					AND FILO.START_DATE >= ADDDATE(PRMT_EXP_APC_DATE.PVALUE, INTERVAL -7 YEAR)) 
				)
				AND PRMT_EXP_APC_EXPRY_SW.PVALUE = '1'
			) OR PRMT_EXP_APC_EXPRY_SW.PVALUE = '0'
		)
	/* Condicion Prescripcion a los 7 anios - Fin */
	AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE)
			FROM CRED_CREDITS FILOX
			WHERE FILOX.IDCODE = FILO.IDCODE
			AND FILOX.CLX_EFFTDATE<=PRMT_EXP_APC_DATE.PVALUE)
  AND EXISTS (SELECT PRLT.ID
              FROM CRED_PROD_PRMTR_TBL PRLT
              WHERE PRLT.PRODUCT_CODE = FILO.PRODUCT_CODE
              AND PRLT.HAS_APC_EXPORT = 1) 
  AND PRMT_EXP_APC_DATE.COMP_CODE = FILO.COMP_CODE
  AND PRMT_EXP_APC_DATE.IDNAME = 'CRED_APC_EXPORT_DATE'
  /* Flag Prescripcion a los 7 anios - Inicio */
  AND PRMT_EXP_APC_EXPRY_SW.COMP_CODE = FILO.COMP_CODE
  AND PRMT_EXP_APC_EXPRY_SW.IDNAME = 'CRED_APC_EXPORT_EXPRY_SW'
  /* Flag Prescripcion a los 7 anios - Fin */
;;
SHOW TABLES LIKE 'CRED_ASOP2_CLIE_VW';
SHOW TABLES LIKE 'CRED_ASOP2_CLIE_VW';
DROP VIEW CRED_ASOP2_CLIE_VW;
CREATE VIEW CRED_ASOP2_CLIE_VW AS /*
 * Vista "APC2" (despues del cambio del "Caso 1002893 - BDA-Eliminar cred 7 yr Rep REFERE")
 */
SELECT DISTINCT
	/* LEFT(IF(ACCO.IDENTIFICATION_APC <> '', ACCO.IDENTIFICATION_APC, ACCO.IDENTIFICATION),21) IDENT_CLIE, */
	LEFT(BASE_PA_IDENTIFICATION_MASK(ACCO.IDENTIFICATION, ACCO.ID_TYPE),21) IDENT_CLIE,
	/*ACCO.ISINDIVIDUAL TIPO_CLIE,*/
	IFNULL(ACCO.LEGAL_TYPE,'C') TIPO_CLIE,/*SET TRANSLATION 1,2,3*/
	/*ASUMIENTO ESPACIO COMO SEPARACION DE APELLIDOS*/
	LEFT(IF(NULLIF(LOCATE(' ', TRIM(ACCO.LASTNAME)),0) IS NULL, ACCO.LASTNAME, TRIM(LEFT(ACCO.LASTNAME, LOCATE(' ', TRIM(ACCO.LASTNAME))))),25) APEL_PATERNO,
	LEFT(IF(NULLIF(LOCATE(' ', TRIM(ACCO.LASTNAME)),0) IS NULL, '', TRIM(REPLACE(ACCO.LASTNAME, LEFT(ACCO.LASTNAME, LOCATE(' ', TRIM(ACCO.LASTNAME))),''))),25) APEL_MATERNO,
	LEFT(ACCO.MARRIED_NAME,25) APEL_CASADA,
	LEFT(ACCO.FIRSTNAME,25) PRIMER_NOM,
	LEFT(ACCO.SECOND_NAME,25) SEGUNDO_NOM,
	CASE ACCO.SEX WHEN 'F' THEN 2
	ELSE 1 END SEXO_CLIE,/*1=M, 2=F SET TRANSLATE*/
	LEFT(ACCO.TAXID,25) SEGURO_SOCIAL,/*CUSTOMER_TAX REPLACED BY TAXID ID?*/
	ACCO.MARITAL_STATUS ESTADO_CIVIL,/*1 SOLTERO 2 CASADO 3 VIUDO 4 UNIDO 5	DIVORCIADO INCLUIR SOLO CODIGO*/
	LEFT(ACCO.LEGAL_NAME,70) NOM_LEGAL,
	LEFT(ACCO.IDNAME,70) NOM_COMERCIAL,
	LEFT(ACCO.ADDRESS1,80) DIREC_CLIE,
	DATE_FORMAT(CASE ACCO.ISINDIVIDUAL
	WHEN 1 THEN ACCO.BIRTHDATE 
	ELSE ACCO.INCORPORATION_DATE END,
	'%m/%d/%Y') FEC_NAC_INI_OP,
	LEFT(ACCO.HOME_PHONE,7) TELEF_CASA,
	LEFT(ACCO.FAX,7) TELEF_FAX1,
	LEFT(ACCO.FAX_02,7) TELEF_FAX2,
	LEFT(ACCO.OTHER_PHONE,7) TELEF_OTRO,
	LEFT(ACCO.MOBILE_PHONE,7) TELEF_CELULAR,
	LEFT(ACCO.EMPLOYER,50) LUG_TRAB,
	LEFT(ACCO.ADDRESS1_02,80) DIREC_TRAB,
	LEFT(ACCO.TITLE, 50) POSICION_TRAB,
	ACCO.INCOME INGRESO_MENSUAL,
	ACCO.EMPLOYER_SINCE FEC_INGRESO_TRAB,
	LEFT(ACCO.BUSINESS_PHONE, 7) TELEF_OFICINA,
	LEFT(ACCO.BUSINESS_EXT, 5) TELEF_OFICINA_EXT,
	/*ASUMIENDO APELLIDO APELLIDO2, NOMBRE NOMBRE2*/
	/*ACCO.SPOUSE NOM_CONYUGE,
	ACCO.SPOUSE APEL_CONYUGE,*/
	LEFT(IF(NULLIF(LOCATE(',', TRIM(ACCO.SPOUSE)),0) IS NULL, '', TRIM(REPLACE(REPLACE(ACCO.SPOUSE, LEFT(ACCO.SPOUSE, LOCATE(',', TRIM(ACCO.SPOUSE))),','),',',''))),20) NOM_CONYUGE,
	LEFT(IF(NULLIF(LOCATE(',', TRIM(ACCO.SPOUSE)),0) IS NULL, ACCO.SPOUSE, TRIM(REPLACE(LEFT(ACCO.SPOUSE, LOCATE(',', TRIM(ACCO.SPOUSE))),',',''))), 20) APEL_CONYUGE,
	LEFT(ACCO.SPOUSE_ID, 21) CED_CONYUGE,
	LEFT(IF(NULLIF(LOCATE(',', TRIM(ACCO.FATHER_FULLNAME)),0) IS NULL, '', TRIM(REPLACE(REPLACE(ACCO.FATHER_FULLNAME, LEFT(ACCO.FATHER_FULLNAME, LOCATE(',', TRIM(ACCO.FATHER_FULLNAME))),','),',',''))), 20) NOM_PADRE,
	LEFT(IF(NULLIF(LOCATE(',', TRIM(ACCO.FATHER_FULLNAME)),0) IS NULL, ACCO.FATHER_FULLNAME, TRIM(REPLACE(LEFT(ACCO.FATHER_FULLNAME, LOCATE(',', TRIM(ACCO.FATHER_FULLNAME))),',',''))), 20) APEL_PADRE,
	LEFT(IF(NULLIF(LOCATE(',', TRIM(ACCO.MOTHER_FULLNAME)),0) IS NULL, '', TRIM(REPLACE(REPLACE(ACCO.MOTHER_FULLNAME, LEFT(ACCO.MOTHER_FULLNAME, LOCATE(',', TRIM(ACCO.MOTHER_FULLNAME))),','),',',''))), 20) NOM_MADRE,
	LEFT(IF(NULLIF(LOCATE(',', TRIM(ACCO.MOTHER_FULLNAME)),0) IS NULL, ACCO.MOTHER_FULLNAME, TRIM(REPLACE(LEFT(ACCO.MOTHER_FULLNAME, LOCATE(',', TRIM(ACCO.MOTHER_FULLNAME))),',',''))), 20) APEL_MADRE
FROM
	BASE_PARAMETERS PRMT_EXP_APC_DATE,
	BASE_PARAMETERS PRMT_EXP_APC_EXPRY_SW, /* Flag Prescripcion a los 7 anios */
	CRM_ACCOUNTS ACCO,
	CRED_CREDITS FILO,
	BASE_PARAMETERS PRMT 
WHERE
  /*FILO.COMP_CODE = @COMP_CODE  AND */
  ACCO.IDCODE = FILO.DEBTOR_CODE
  AND PRMT.COMP_CODE = FILO.COMP_CODE
  AND PRMT.IDNAME = 'CRED_APC_REPORT_ENABLED'
  AND PRMT.PVALUE = '1'
  AND (
  /*
  FILO.LOAN_STATUS NOT IN ('PRE','VEN') OR (FILO.LOAN_STATUS = 'VEN' 
  AND EXTRACT(YEAR_MONTH FROM FILO.END_DATE)=EXTRACT(YEAR_MONTH FROM NOW()))
  */
  FILO.LOAN_STATUS NOT IN ('PRE','CAN','VOID','CEAS') 
  OR (FILO.LOAN_STATUS = 'CAN' AND EXTRACT(YEAR_MONTH FROM FILO.END_DATE)=EXTRACT(YEAR_MONTH FROM PRMT_EXP_APC_DATE.PVALUE))
  )
	/* Condicion Prescripcion a los 7 anios - Inicio */
	AND (
			( 
				(
					FILO.LAST_PAY_DATE >= ADDDATE(PRMT_EXP_APC_DATE.PVALUE, INTERVAL -7 YEAR) 
					OR ( (FILO.LAST_PAY_DATE IS NULL OR FILO.LAST_PAY_DATE = '0000-00-00') 
					AND FILO.START_DATE >= ADDDATE(PRMT_EXP_APC_DATE.PVALUE, INTERVAL -7 YEAR)) 
				)
				AND PRMT_EXP_APC_EXPRY_SW.PVALUE = '1'
			) OR PRMT_EXP_APC_EXPRY_SW.PVALUE = '0'
		)
	/* Condicion Prescripcion a los 7 anios - Fin */
	AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE)
			FROM CRED_CREDITS FILOX
			WHERE FILOX.IDCODE = FILO.IDCODE
			AND FILOX.CLX_EFFTDATE<=PRMT_EXP_APC_DATE.PVALUE)
  AND EXISTS (SELECT PRLT.ID
              FROM CRED_PROD_PRMTR_TBL PRLT
              WHERE PRLT.PRODUCT_CODE = FILO.PRODUCT_CODE
              AND PRLT.HAS_APC_EXPORT = 1)
  AND PRMT_EXP_APC_DATE.COMP_CODE = FILO.COMP_CODE
  AND PRMT_EXP_APC_DATE.IDNAME = 'CRED_APC_EXPORT_DATE'
  /* Flag Prescripcion a los 7 anios - Inicio */
  AND PRMT_EXP_APC_EXPRY_SW.COMP_CODE = FILO.COMP_CODE
  AND PRMT_EXP_APC_EXPRY_SW.IDNAME = 'CRED_APC_EXPORT_EXPRY_SW'
  /* Flag Prescripcion a los 7 anios - Fin */;
SHOW TABLES LIKE 'CRED_OPERATION';
SHOW TABLES LIKE 'CRED_OPERATION';
DROP VIEW CRED_OPERATION;
CREATE VIEW CRED_OPERATION AS SELECT
  FIAT.ID,
  FIAT.COMP_CODE,
  FIAS.LOAN_CODE,
  FIAT.CHART_FIELD03,
  FIAT.IDCODE TRANS_CODE,
  FIAT.REAL_DATE,
  FIAT.EFFTDATE,
  (CASE FIAT.TRANSTBL_CODE WHEN 'SYS_CRED-DISB' THEN 1 WHEN 'SYS_CRED-PYMT' THEN -1 ELSE 1 END*IF(FIAT.REV_TRANS_CODE IS NOT NULL, -1, 1)) OPERATION_SIGN,
  FIAT.REVERSED,
  FIAT.TRANS_STATUS,
  FIAT.TRANSTBL_CODE,
  (CASE FIAT.TRANSTBL_CODE WHEN 'SYS_CRED-DISB' THEN 1 WHEN 'SYS_CRED-PYMT' THEN -1 ELSE 1 END*IF(FIAT.REV_TRANS_CODE IS NOT NULL, -1, 1))*FIAT.PRINCIPAL_PAY PRINCIPAL_PAY, 
  (CASE FIAT.TRANSTBL_CODE WHEN 'SYS_CRED-DISB' THEN 1 WHEN 'SYS_CRED-PYMT' THEN -1 ELSE 1 END*IF(FIAT.REV_TRANS_CODE IS NOT NULL, -1, 1))*FIAT.INTEREST_PAY INTEREST_PAY, 
  (CASE FIAT.TRANSTBL_CODE WHEN 'SYS_CRED-DISB' THEN 1 WHEN 'SYS_CRED-PYMT' THEN -1 ELSE 1 END*IF(FIAT.REV_TRANS_CODE IS NOT NULL, -1, 1))*FIAT.FEE_01_PAY FEE_01_PAY, 
  (CASE FIAT.TRANSTBL_CODE WHEN 'SYS_CRED-DISB' THEN 1 WHEN 'SYS_CRED-PYMT' THEN -1 ELSE 1 END*IF(FIAT.REV_TRANS_CODE IS NOT NULL, -1, 1))*FIAT.FEE_02_PAY FEE_02_PAY,
  (CASE FIAT.TRANSTBL_CODE WHEN 'SYS_CRED-DISB' THEN 1 WHEN 'SYS_CRED-PYMT' THEN -1 ELSE 1 END*IF(FIAT.REV_TRANS_CODE IS NOT NULL, -1, 1))*FIAT.FEE_03_PAY FEE_03_PAY,
  (CASE FIAT.TRANSTBL_CODE WHEN 'SYS_CRED-DISB' THEN 1 WHEN 'SYS_CRED-PYMT' THEN -1 ELSE 1 END*IF(FIAT.REV_TRANS_CODE IS NOT NULL, -1, 1))*FIAT.FEE_03_PAY FEE_04_PAY,
  (CASE FIAT.TRANSTBL_CODE WHEN 'SYS_CRED-DISB' THEN 1 WHEN 'SYS_CRED-PYMT' THEN -1 ELSE 1 END*IF(FIAT.REV_TRANS_CODE IS NOT NULL, -1, 1))*FIAT.FEE_05_PAY FEE_05_PAY,
  (CASE FIAT.TRANSTBL_CODE WHEN 'SYS_CRED-DISB' THEN 1 WHEN 'SYS_CRED-PYMT' THEN -1 ELSE 1 END*IF(FIAT.REV_TRANS_CODE IS NOT NULL, -1, 1))*FIAT.FEE_06_PAY FEE_06_PAY,
  (CASE FIAT.TRANSTBL_CODE WHEN 'SYS_CRED-DISB' THEN 1 WHEN 'SYS_CRED-PYMT' THEN -1 ELSE 1 END*IF(FIAT.REV_TRANS_CODE IS NOT NULL, -1, 1))*FIAT.FEE_07_PAY FEE_07_PAY,
  FIAT.CREATEDBY,
  FIAT.CDATE,
  FIAT.MODIFIEDBY,
  FIAT.MDATE
FROM 
  FIDU_TRANSACTION_TBL FITB,
  FIDU_TRANSACTIONS FIAT,
  FIDU_ITEMS FIAS
WHERE
  FIAS.IDCODE = FIAT.CHART_FIELD03
  AND FITB.IDCODE = FIAT.TRANSTBL_CODE
  AND FITB.MODULECODE = 'CRED'
  AND FIAS.LOAN_CODE IS NOT NULL;
SHOW TABLES LIKE 'CRED_COLL_COVERAGE_VW';
SHOW TABLES LIKE 'CRED_COLL_COVERAGE_VW';
DROP VIEW CRED_COLL_COVERAGE_VW;
CREATE VIEW CRED_COLL_COVERAGE_VW AS SELECT 
  ASVA.ID,
  FILC.LOAN_CODE,
  FILC.ASSETCODE,
  CURR.EXCHANGE_RT,
  CURR.CUR_OPERATOR,
  FILO.CURRENCY_CODE CURRENCY_CODE,
  IF(FILO.LOAN_STATUS = 'PRE', FILO.LOAN_AMT, FILO.PRINCIPAL_BAL) LOAN_AMT,
  ASVA.CURRENCY_CODE AVAL_CURRENCY_CODE,
  ASVA.VALUATION_AMT,
  ROUND(ASVA.VALUATION_AMT*POW(CURR.EXCHANGE_RT, CURR.CUR_OPERATOR),2) COVERAGE_AMT,
  (ROUND(ASVA.VALUATION_AMT*POW(CURR.EXCHANGE_RT, CURR.CUR_OPERATOR),2)/FILO.LOAN_AMT) COVERAGE_RATIO
FROM 
  BASE_CURRENCY_CONVERSIONS CURR,
  CRED_CREDITS FILO,
  CRED_COLLATERALS FILC,
  AMGT_ASSET_VALUATIONS ASVA
WHERE
  1=1
  AND FILO.IDCODE = FILC.LOAN_CODE
  AND FILO.CLX_EFFTDATE = (SELECT MAX(FILOX.CLX_EFFTDATE)
    FROM CRED_CREDITS FILOX
    WHERE FILOX.IDCODE = FILO.IDCODE
      AND FILOX.CLX_EFFTDATE<=NOW())
  AND ASVA.ASSET_CODE = FILC.ASSETCODE
  AND ASVA.CLX_EFFTDATE  = (SELECT MAX(ASVAX.CLX_EFFTDATE) 
    FROM AMGT_ASSET_VALUATIONS ASVAX
    WHERE ASVAX.ASSET_CODE = ASVA.ASSET_CODE
      AND ASVAX.CLX_EFFTDATE <= NOW())

 /*AND CURR.FOREIGN_CURRENCY = ASVA.CURRENCY_CODE     
 AND CURR.BASE_CURRENCY = FILO.CURRENCY_CODE*/
 AND CURR.FOREIGN_CURRENCY = FILO.CURRENCY_CODE     
 AND CURR.BASE_CURRENCY = ASVA.CURRENCY_CODE

 AND CURR.CLX_EFFTDATE = (SELECT MAX(CURRX.CLX_EFFTDATE)
      FROM BASE_CURRENCY_CONVERSIONS CURRX
      WHERE CURRX.IDCODE = CURR.IDCODE 
        AND CURRX.CLX_EFFTDATE<=NOW())
  AND FILC.CLX_EFFTDATE = (SELECT MAX(FILCX.CLX_EFFTDATE)
    FROM CRED_COLLATERALS FILCX
    WHERE FILCX.LOAN_CODE = FILC.LOAN_CODE
      AND FILCX.ASSETCODE = FILC.ASSETCODE
      AND FILCX.CLX_EFFTDATE <= NOW());
SHOW TABLES LIKE 'CRED_XXXXXXXXXX';
SHOW TABLES LIKE 'CRED_XXXXXXXXXX';
DROP VIEW CRED_XXXXXXXXXX;
CREATE VIEW CRED_XXXXXXXXXX AS select 1 xxx, 2 yyy from dual;
SHOW TABLES LIKE 'CRM_ACCO_PRODELIG';
SHOW TABLES LIKE 'CRM_ACCO_PRODELIG';
DROP VIEW CRM_ACCO_PRODELIG;
CREATE VIEW CRM_ACCO_PRODELIG AS SELECT 
1 ID,
ACCO.IDCODE ACCOUNTCODE,
PRER.PRODUCT_CODE PRODUCT_CODE,
PROD.PRODUCT_TYPE PRODUCT_TYPE,
PROD.PRODUCT_CLASS PRODUCT_CLASS
FROM  CRM_ACCOUNTS ACCO, CRM_PRODELIG_RULES PRER, CRM_PRODUCTS PROD
 WHERE  PROD.IDCODE = PRER.PRODUCT_CODE 
 AND (PRER.ISINDIVIDUAL IS NULL OR PRER.ISINDIVIDUAL = ACCO.ISINDIVIDUAL)
 AND (PRER.ACCTYPE IS NULL OR PRER.ACCTYPE = ACCO.ACCTYPE) 
 AND (PRER.AGE IS NULL OR  PRER.AGE  >= (YEAR(ACCO.BIRTHDATE) - YEAR(CURDATE()) )  ) 
 AND (PRER.SEX IS NULL OR  PRER.SEX = ACCO.`SEX`)
 AND (PRER.COUNTRY IS NULL OR PRER.COUNTRY = ACCO.COUNTRY )
 AND (PRER.CITIZENSHIP IS NULL OR   PRER.CITIZENSHIP = ACCO.CITIZENSHIP)
 AND (PRER.MIGRA_STAT IS NULL OR  PRER.MIGRA_STAT = ACCO.MIGRA_STAT )
 AND (PRER.INCOME_LEVEL IS NULL OR  PRER.INCOME_LEVEL  = ACCO.INCOME_LEVEL)
 AND (PRER.RISK_LEVEL IS NULL OR  PRER.RISK_LEVEL = ACCO.RISK_LEVEL)
 AND (PRER.LEGAL_TYPE IS NULL OR  PRER.LEGAL_TYPE = ACCO.LEGAL_TYPE)
 AND (PRER.COTYPE IS NULL OR  PRER.COTYPE =ACCO.COTYPE)
 AND (PRER.COSIZE_CLASS IS NULL OR  PRER.COSIZE_CLASS = ACCO.COSIZE_CLASS)
 AND (PRER.INDUSTRYCLASS IS NULL OR  PRER.INDUSTRYCLASS = ACCO.INDUSTRYCLASS)
 AND (PRER.INCORPORATION_COUNTRY IS NULL OR  ACCO.INCORPORATION_COUNTRY)

 AND  PRER.CLX_EFFTDATE=(SELECT MAX(X.CLX_EFFTDATE) CLX_EFFTDATE FROM CRM_PRODELIG_RULES X WHERE  X.PRODUCT_CODE=PRER.PRODUCT_CODE AND X.SEQNUM=PRER.SEQNUM AND  X.CLX_EFFTDATE <= NOW())
ORDER BY 
PRER.PRODUCT_CODE DESC,PRER.SEQNUM ASC,PRER.CLX_EFFTDATE DESC;
SHOW TABLES LIKE 'CLX_QRY_FIELDS_VW';
SHOW TABLES LIKE 'CLX_QRY_FIELDS_VW';
DROP VIEW CLX_QRY_FIELDS_VW;
CREATE VIEW CLX_QRY_FIELDS_VW AS SELECT 
0 ID,
DBQF.QUERYCODE,
DBQY.IDNAME,
DBQF.SEQNUM,
DBQF.TABLECODE,
DBQF.FIELDNAME,
CONCAT(DBQF.TABLECODE, "_",DBQF.FIELDNAME) TABLE_FIELD,
CLX_DICVAL(DBFL.FIELDFORMLABEL,'es') FIELD_LABEL,
DBFL.FIELDTYPE,
DBQF.SORT,
DBQF.VISIBLE,
DBQF.FILTER,
DBQF.GROUPED,
DBQF.EXPRESSION,
DBQF.CURRENCY_FIELD_TBL,
DBQF.CURRENCY_FIELD,
DBQF.FIELD_FORMAT
FROM CLX_DB_QUERY_FIELDS DBQF, CLX_DB_QUERIES DBQY, CLX_DB_FIELDS DBFL 
WHERE 1=1
AND DBQF.QUERYCODE = DBQY.IDCODE
AND DBFL.FIELDNAME = REPLACE(DBQF.FIELDNAME,'_WRK', '')  
ORDER BY DBQF.QUERYCODE,  DBQF.SEQNUM;
SHOW TABLES LIKE 'CLX_QRY_TABLES_VW';
SHOW TABLES LIKE 'CLX_QRY_TABLES_VW';
DROP VIEW CLX_QRY_TABLES_VW;
CREATE VIEW CLX_QRY_TABLES_VW AS SELECT 
  0 ID,
DBQT.QUERYCODE,
DBQT.TABLECODE
FROM CLX_DB_QUERY_TABLES DBQT
ORDER BY DBQT.QUERYCODE, DBQT.ID;
SHOW TABLES LIKE 'CLX_PAGES_VW';
SHOW TABLES LIKE 'CLX_PAGES_VW';
DROP VIEW CLX_PAGES_VW;
CREATE VIEW CLX_PAGES_VW AS SELECT
ID, 
IDCODE,
IDNAME,
VERSION,
VERSION_COUNTER,
CDATE,
MDATE,
USERNAME,
DESCRIPTION,
ACCESSES,
MODULECODE,
TITLE,
EXEONSEARCH,
ACTIVE,
(SELECT RCTM.IDCODE FROM RCTA_TRN_MATCH_TBL RCTM 
 WHERE  UIPG.IDCODE LIKE '%RCTM%' AND   
                UIPG.MODULECODE = 'USER' AND  
                RCTM.IDCODE = SUBSTR(UIPG.IDCODE, LENGTH(UIPG.IDCODE)-LENGTH(RCTM.IDCODE)+1,LENGTH(RCTM.IDCODE)) 

                  AND  RCTM.CLX_EFFTDATE=(SELECT MAX(X.CLX_EFFTDATE) CLX_EFFTDATE FROM RCTA_TRN_MATCH_TBL X WHERE  X.IDCODE=RCTM.IDCODE AND  X.CLX_EFFTDATE <= CURRENT_DATE()) )  RCTM_CODE

FROM CLX_UI_PAGES UIPG
ORDER BY ID;
SHOW TABLES LIKE 'CLX_LISTINGS_VW';
SHOW TABLES LIKE 'CLX_LISTINGS_VW';
DROP VIEW CLX_LISTINGS_VW;
CREATE VIEW CLX_LISTINGS_VW AS SELECT 
0 ID,
UILS.IDCODE,
UILS.IDNAME,
UILS.TITLE LSTN_TITLE,
CLX_DICVAL(UILS.TITLE,'es') TITLE_NAME,
UILS.TABLECODE,
UILS.QUERYCODE,
UILS.MODULECODE,
UILS.CREATE_FORM,
UILS.MODIFY_FORM,
UILS.DISPLAY_FORM,
UILS.DELETE_FORM,
UILS.SEARCH_FORM,
UILS.DUPLICATE_FORM,
UILS.EFFTDATE_FORM,
UILS.TOOLTIP_FORM,
UILS.CONTROL_EXPORT,
UILS.CONTROL_VIEWS,
UILS.CONTROL_FILTERS,
UILS.VIEW_SUMMARY,
UILS.VIEW_SUMMARY_EXP,
UILS.EXEONSEARCH,
UILS.HIDE_EFFTDATE,
UILS.AUTH_DISABLED,
UILS.AUTH_BTCH_FILD,
UILS.AUTH_BTCH_FILDSUM

FROM CLX_UI_LISTINGS UILS
ORDER BY UILS.ID;
SHOW TABLES LIKE 'CLX_TABLE_HIST_VW';
SHOW TABLES LIKE 'CLX_TABLE_HIST_VW';
DROP VIEW CLX_TABLE_HIST_VW;
CREATE VIEW CLX_TABLE_HIST_VW AS SELECT 
ID 'ID',
TABLE_CODE 'TABLECODE',
TABLE_CODE_HIST 'TABLE_HIST',
USERNAME,
DESCRIPTION,
CDATE,
MDATE
FROM CLX_DB_TABLE_HIST;
SHOW TABLES LIKE 'CMP_TRANSACTONS_VW';
SHOW TABLES LIKE 'CMP_TRANSACTONS_VW';
DROP VIEW CMP_TRANSACTONS_VW;
CREATE VIEW CMP_TRANSACTONS_VW AS ### FIAT - FIDUCIARY TRANSACTIONS
SELECT 
FIAT.ID
,FIAT.COMP_CODE
,01 TRXREC_TYPE
,FIPA.CONTRACT_CODE
,FICO.CONTRACT_NUMBER
,FICO.IDNAME CONTRACT_NAME
,FICO.FI_TYPE
,FICO.ACCO_EXEC
,FIPA.ACCOUNTCODE
,ACCO.IDNAME ACCO_NAME
,ACCO.FIRSTNAME
,ACCO.LASTNAME
,ACCO.RISK_LEVEL
,ACCO.PEP
,(IF(ACCO.PEP > 0, 1, 0)) ISPEP
,FIAT.IDCODE TXN
,FIAT.REAL_DATE
,FIAT.EFFTDATE
,FIAT.TRANSTBL_CODE TXNTYPE_CODE
,FITB.FI_TRANS_TYPE 
,FIAT.IDNAME TRANS_NAME
,FIAT.TRANS_STATUS CLX_AUTH_STATUS
,FIAT.TRANS_AMT
,FIAT.CURRENCY_CODE
,FIAT.EXCHANGE_RT
,FIAT.CUR_OPERATOR
,(CASE FITB.FI_TRANS_TYPE
	WHEN '02' THEN ROUND(FIAT.TRANS_AMT*POWER(FIAT.EXCHANGE_RT, FIAT.CUR_OPERATOR),4)
	WHEN '06' THEN ROUND(FIAT.TRANS_AMT*POWER(FIAT.EXCHANGE_RT, FIAT.CUR_OPERATOR),4)
	ELSE 0.00
	END) CONTRIBUTION_AMT
,(CASE FITB.FI_TRANS_TYPE 
	WHEN '03' THEN ROUND(FIAT.TRANS_AMT*POWER(FIAT.EXCHANGE_RT, FIAT.CUR_OPERATOR),4)
	WHEN '07' THEN ROUND(FIAT.TRANS_AMT*POWER(FIAT.EXCHANGE_RT, FIAT.CUR_OPERATOR),4)
	ELSE 0.00
	END) WITHDRAWAL_AMT
,((ROUND(COALESCE( (SELECT SUM((IF(FITB1.FI_TRANS_TYPE <> '03', FIAT1.TRANS_AMT*POWER(FIAT1.EXCHANGE_RT, FIAT1.CUR_OPERATOR),(FIAT1.TRANS_AMT*POWER(FIAT1.EXCHANGE_RT, FIAT1.CUR_OPERATOR)*-1)))) 
    FROM FIDU_TRANSACTIONS FIAT1,FIDU_TRANSACTION_TBL FITB1 
    WHERE FIAT1.TRANSTBL_CODE = FITB1.IDCODE 
    AND FITB1.FI_TRANS_TYPE IN ('01','02','03') 
    AND FIAT1.CHART_FIELD01 = FIAT.CHART_FIELD01 
    AND FIAT1.IDCODE <= FIAT.IDCODE), 0),2) ) + 
    
   (ROUND(COALESCE( (SELECT SUM(IF(INTT2.FI_TRANS_TYPE<>'03',CURR_EXCHANGE_AMT(INAT2.INVEST_AMT, INFU2.CURRENCY_CODE, COMP2.CURRENCY_CODE, INAT2.EFFTDATE)
             ,CURR_EXCHANGE_AMT(INAT2.INVEST_AMT, INFU2.CURRENCY_CODE, COMP2.CURRENCY_CODE, INAT2.EFFTDATE)*-1) )
     FROM INVE_ACTIVITIES INAT2, INVE_PORTFOLIOS INFU2, INVE_ACTIVITIES_TBL INTT2, BASE_COMPANIES COMP2
     WHERE 
	 INAT2.INVEST_ACTIVITY = INTT2.IDCODE
	 AND  INTT2.FI_TRANS_TYPE IN ('01','02','03')  
	 AND  INAT2.COMP_CODE = COMP2.IDCODE
	 AND  INAT2.PORTFOLIO_CODE = INFU2.IDCODE
	 AND  INAT2.INVEST_AMT <> 0.00
	 AND  INAT2.CLX_AUTH_STATUS = 'AP'
	 AND  INAT2.CONTRACT_CODE = FIAT.CHART_FIELD01
	 AND  INAT2.REAL_DATE < FIAT.REAL_DATE), 0),2) ) 
  	    
    ) FIDU_CONTRIB_AMT

FROM 
  FIDU_TRANSACTIONS FIAT, INVE_PORTFOLIOS INFU, FIDU_TRANSACTION_TBL FITB, FIDU_CONTRACTS FICO, FIDU_PARTICIPANTS FIPA, CRM_ACCOUNTS ACCO
WHERE 
  FIAT.TRANSTBL_CODE = FITB.IDCODE
  AND  FITB.FI_TRANS_TYPE IN ('02','03', '06', '07') 
  AND  FIAT.CHART_FIELD01 = FICO.IDCODE
  AND  FIPA.CONTRACT_CODE = FIAT.CHART_FIELD01
  AND  FIPA.ACCOUNTCODE = ACCO.IDCODE
  AND  FIPA.ISPRIMARY = 1
  AND  FIAT.CLX_AUTH_STATUS = 'AP'
  AND  FIAT.TRANS_AMT <> 0
#ORDER BY 
#FIPA.CONTRACT_CODE ASC,FIAT.IDCODE ASC,FIAT.REAL_DATE ASC, TRXREC_TYPE ASC

UNION

# INAT - INVESTEMENT ACTIVITIES
SELECT 
INAT.ID
,INAT.COMP_CODE
,02 TRXREC_TYPE
,FIPA.CONTRACT_CODE
,FICO.CONTRACT_NUMBER
,FICO.IDNAME CONTRACT_NAME
,FICO.FI_TYPE
,FICO.ACCO_EXEC
,FIPA.ACCOUNTCODE 
,ACCO.IDNAME ACCO_NAME
,ACCO.FIRSTNAME ACCO_FIRSTNAME
,ACCO.LASTNAME ACCO_LASTNAME
,ACCO.RISK_LEVEL ACCO_RISK_LEVEL
,ACCO.PEP ACCO_PEP,(IF(ACCO.PEP > 0, 1, 0)) ACCO_ISPEP
,INAT.IDCODE TXN
,INAT.REAL_DATE
,INAT.EFFTDATE
,INAT.INVEST_ACTIVITY TXNTYPE_CODE
,INTT.FI_TRANS_TYPE
,CONCAT('INVERSION-',INTT.IDNAME) TRANS_NAME
,INAT.CLX_AUTH_STATUS
,INAT.INVEST_AMT TRANS_AMT
,INFU.CURRENCY_CODE
,CURR_EXCHANGE_RT(INFU.CURRENCY_CODE, COMP.CURRENCY_CODE, INAT.EFFTDATE)
,1 INAT_CUR_OPERATOR
,(CASE INTT.FI_TRANS_TYPE
	WHEN '02' THEN CURR_EXCHANGE_AMT(INAT.INVEST_AMT, INFU.CURRENCY_CODE, COMP.CURRENCY_CODE, INAT.EFFTDATE)
	WHEN '06' THEN CURR_EXCHANGE_AMT(INAT.INVEST_AMT, INFU.CURRENCY_CODE, COMP.CURRENCY_CODE, INAT.EFFTDATE)
	ELSE 0.00
	END) CONTRIBUTION_AMT
,(CASE INTT.FI_TRANS_TYPE 
	WHEN '03' THEN CURR_EXCHANGE_AMT(INAT.INVEST_AMT, INFU.CURRENCY_CODE, COMP.CURRENCY_CODE, INAT.EFFTDATE)
	WHEN '07' THEN CURR_EXCHANGE_AMT(INAT.INVEST_AMT, INFU.CURRENCY_CODE, COMP.CURRENCY_CODE, INAT.EFFTDATE)
	ELSE 0.00
	END) WITHDRAWAL_AMT

,(
 (ROUND( COALESCE( (SELECT SUM(IF(FITB2.FI_TRANS_TYPE <> '03', FIAT2.TRANS_AMT*POWER(FIAT2.EXCHANGE_RT, FIAT2.CUR_OPERATOR), (FIAT2.TRANS_AMT*POWER(FIAT2.EXCHANGE_RT, FIAT2.CUR_OPERATOR)*-1)))  
    FROM FIDU_TRANSACTIONS FIAT2,FIDU_TRANSACTION_TBL FITB2 
    WHERE FIAT2.TRANSTBL_CODE = FITB2.IDCODE 
    AND FITB2.FI_TRANS_TYPE IN ('01','02','03')
    AND FIAT2.CHART_FIELD01 = INAT.CONTRACT_CODE 
    AND FIAT2.REAL_DATE <= INAT.REAL_DATE
    AND FIAT2.IDCODE <=(SELECT MAX(FIATX.IDCODE) FROM FIDU_TRANSACTIONS FIATX
        WHERE FIATX.CHART_FIELD01 = FIAT2.CHART_FIELD01
        AND FIATX.REAL_DATE <= FIAT2.REAL_DATE) ) ,0),2) ) 
    + 
   (ROUND(COALESCE( (SELECT SUM(IF(INTT2.FI_TRANS_TYPE<>'03',CURR_EXCHANGE_AMT(INAT2.INVEST_AMT, INFU2.CURRENCY_CODE, COMP2.CURRENCY_CODE, INAT2.EFFTDATE)
             ,CURR_EXCHANGE_AMT(INAT2.INVEST_AMT, INFU2.CURRENCY_CODE, COMP2.CURRENCY_CODE, INAT2.EFFTDATE)*-1) )
     FROM INVE_ACTIVITIES INAT2, INVE_PORTFOLIOS INFU2, INVE_ACTIVITIES_TBL INTT2, BASE_COMPANIES COMP2
     WHERE 
	 INAT2.INVEST_ACTIVITY = INTT2.IDCODE
	 AND  INTT2.FI_TRANS_TYPE IN ('01','02','03')  
	 AND  INAT2.COMP_CODE = COMP2.IDCODE
	 AND  INAT2.PORTFOLIO_CODE = INFU2.IDCODE
	 AND  INAT2.INVEST_AMT <> 0.00
	 AND  INAT2.CLX_AUTH_STATUS = 'AP'
	 AND  INAT2.CONTRACT_CODE = INAT.CONTRACT_CODE
	 AND  INAT2.IDCODE <= INAT.IDCODE ) ,0),2) )
	    
    ) FIDU_CONTRIB_AMT

FROM 
  INVE_ACTIVITIES INAT, INVE_PORTFOLIOS INFU, INVE_ACTIVITIES_TBL INTT, BASE_COMPANIES COMP, CRM_ACCOUNTS ACCO,  FIDU_CONTRACTS FICO,  FIDU_PARTICIPANTS FIPA
WHERE 
  INAT.INVEST_ACTIVITY = INTT.IDCODE
  AND  INTT.FI_TRANS_TYPE IN ('02','03', '06', '07') 
  AND  INAT.COMP_CODE = COMP.IDCODE
  AND  INAT.PORTFOLIO_CODE = INFU.IDCODE
  AND  INAT.INVEST_AMT<> 0.00
  AND  INAT.CLX_AUTH_STATUS = 'AP'
  AND  INAT.CONTRACT_CODE = FICO.IDCODE
  AND  FIPA.ACCOUNTCODE = ACCO.IDCODE
  AND  FIPA.CONTRACT_CODE = FICO.IDCODE
  AND  FIPA.ISPRIMARY = 1
ORDER BY 
  2, 4, 14, 3, 13
# FIPA.CONTRACT_CODE ASC, INAT.REAL_DATE ASC, TRXREC_TYPE ASC, INAT.IDCODE ASC;
SHOW TABLES LIKE 'RCAA_BALANCES_VW';
SHOW TABLES LIKE 'RCAA_BALANCES_VW';
DROP VIEW RCAA_BALANCES_VW;
CREATE VIEW RCAA_BALANCES_VW AS SELECT 
 RCAV.ID  ID
,RCAV.RCTB_CODE  RCTB_CODE
,RCAV.RC_REPGRP  RC_REPGRP
,RCAV.RCAC_CODE  SUBACCOUNT_CODE
,RCSS.EFFTDATE  EFFTDATE

,(SELECT COALESCE(SUM(RCSB.BAL_AMT),0)
 FROM  RCAA_SUBLEDGER_BALANCES RCSB
 WHERE RCSB.RCTB_CODE = RCAV.RCTB_CODE 
   AND RCSB.RCLE_CODE = RCTB.RCLE_CODE 
   AND RCSB.SUBACCOUNT_CODE = RCAV.RCAC_CODE
   AND RCSB.EFFTDATE  = RCSS.EFFTDATE
   AND RCSB.RECON_ITEM = RCAV.RECON_ITEM)  SUBSYS_BAL_AMT

,(SELECT COALESCE(SUM(RCBA.BAL_AMT),0) 
 FROM  RCAA_LEDGERS_BALANCES RCBA
 WHERE RCBA.RCAC_CODE = RCAV.RCAC_CODE
   AND RCBA.COMP_CODE = RCTB.COMP_CODE
   AND RCBA.RCLE_CODE = RCTB.RCLE_CODE 
   AND RCBA.EFFTDATE = RCSS.EFFTDATE )  GL_BAL_AMT

,0.00  BASE_BAL_AMT

,((SELECT COALESCE(SUM(RCSB.BAL_AMT),0)
 FROM  RCAA_SUBLEDGER_BALANCES RCSB
 WHERE RCSB.RCTB_CODE = RCAV.RCTB_CODE 
   AND RCSB.RCLE_CODE = RCTB.RCLE_CODE 
   AND RCSB.SUBACCOUNT_CODE = RCAV.RCAC_CODE
   AND RCSB.EFFTDATE  = RCSS.EFFTDATE
   AND RCSB.RECON_ITEM = RCAV.RECON_ITEM)
   - (SELECT COALESCE(SUM(RCBA.BAL_AMT),0) 
  FROM  RCAA_LEDGERS_BALANCES RCBA
  WHERE RCBA.RCAC_CODE = RCAV.RCAC_CODE
   AND RCBA.COMP_CODE = RCTB.COMP_CODE
   AND RCBA.RCLE_CODE = RCTB.RCLE_CODE 
   AND RCBA.EFFTDATE = RCSS.EFFTDATE ) )  DIF_BALANCE_AMT

,(SELECT COALESCE(SUM(RCTR.TRANS_AMT),0) 
  FROM RCAA_SUBLEDGER_TRANS RCTR 
    WHERE RCTR.RCTB_CODE = RCTB.IDCODE 
    AND RCTR.SUBACCOUNT_CODE = RCAV.RCAC_CODE 
    AND RCTR.EFFTDATE = RCSS.EFFTDATE 
    AND RCTR.RECON_ITEM = 1 
    AND (RCTR.ITEM_REF_NO IS NULL OR RCTR.ITEM_REF_NO = 'ENLZ') )  RECONITEMS_BAL

,((SELECT COALESCE(SUM(RCSB.BAL_AMT),0) 
	FROM  RCAA_SUBLEDGER_BALANCES RCSB
	WHERE RCSB.RCTB_CODE = RCAV.RCTB_CODE 
	  AND RCSB.RCLE_CODE = RCTB.RCLE_CODE 
	  AND RCSB.SUBACCOUNT_CODE = RCAV.RCAC_CODE
	  AND RCSB.EFFTDATE  = RCSS.EFFTDATE
	  AND RCSB.RECON_ITEM = RCAV.RECON_ITEM)
  - (SELECT COALESCE(SUM(RCBA.BAL_AMT),0) 
	FROM  RCAA_LEDGERS_BALANCES RCBA
	WHERE RCBA.RCAC_CODE = RCAV.RCAC_CODE
	  AND RCBA.COMP_CODE = RCTB.COMP_CODE
	  AND RCBA.RCLE_CODE = RCTB.RCLE_CODE 
	  AND RCBA.EFFTDATE = RCSS.EFFTDATE )
  - (SELECT COALESCE(SUM(RCTR.TRANS_AMT),0) 
	FROM RCAA_SUBLEDGER_TRANS RCTR 
	WHERE RCTR.RCTB_CODE = RCTB.IDCODE 
	  AND RCTR.SUBACCOUNT_CODE = RCAV.RCAC_CODE
	  AND RCTR.EFFTDATE = RCSS.EFFTDATE 
	  AND RCTR.RECON_ITEM = 1 
	  AND (RCTR.ITEM_REF_NO IS NULL OR RCTR.ITEM_REF_NO = 'ENLZ')) ) RCITEMBAL_DIFF

FROM RCAA_RECON_ACCO_VW RCAV, RCAA_RECON_SET_STAT RCSS, RCAA_RECON_TBL RCTB
 
WHERE  1=1
  AND RCAV.RCTB_CODE = RCTB.IDCODE
  AND RCAV.RCTB_CODE = RCSS.RCTB_CODE
  AND RCAV.RECON_ITEM = '0'
 
ORDER BY RCAV.RCTB_CODE, RCAV.RC_REPGRP, RCAV.RCAC_CODE, RCSS.EFFTDATE;
SHOW TABLES LIKE 'RCAA_RECON_ACCO_VW';
SHOW TABLES LIKE 'RCAA_RECON_ACCO_VW';
DROP VIEW RCAA_RECON_ACCO_VW;
CREATE VIEW RCAA_RECON_ACCO_VW AS SELECT 
 MAX(ID)  ID
,RCTB_CODE
,RC_REPGRP
,RCAC_CODE
,CHART_FLD01
,CHART_FLD02
,CHART_FLD03
,RECON_ITEM

FROM RCAA_RECON_ACCOUNTS 

WHERE 1=1

GROUP BY RCTB_CODE, RC_REPGRP, RCAC_CODE, CHART_FLD01, CHART_FLD02, CHART_FLD03, RECON_ITEM;
SHOW TABLES LIKE 'RCAA_SUBLEDGER_BAL_VW';
CREATE VIEW RCAA_SUBLEDGER_BAL_VW AS SELECT 
MAX(ID) ID
,COMP_CODE
,RCLE_CODE
,RCTB_CODE
,RC_REPGRP
,RECON_ITEM
,QUERYCODE
,SUBACCOUNT_CODE
,CHART_FLD01
,CHART_FLD02
,CHART_FLD03
,TO_CHAR(EFFTDATE, 'YYYY-MM-DD') RCAP_CODE
,EFFTDATE
,REC_SRC
,CURRENCY_CODE
,1 EXCHANGE_RT
,SUM(COALESCE(TRANS_AMT,0)) BAL_AMT
,SUM(COALESCE(BASE_TRANS_AMT,0)) BASE_BAL_AMT

FROM RCAA_SUBLEDGER_TRANS RCTR

WHERE 1=1
AND RCTR.CLX_AUTH_STATUS = 'AP'
AND ( RCTR.ITEM_REF_NO IS NULL OR  RCTR.ITEM_REF_NO = 'ENLZ')

GROUP BY COMP_CODE, RCLE_CODE, RCTB_CODE, RC_REPGRP, RECON_ITEM, QUERYCODE, SUBACCOUNT_CODE, CHART_FLD01, CHART_FLD02, CHART_FLD03, EFFTDATE, REC_SRC, CURRENCY_CODE;
rollback;
INSERT INTO CLX_BUGS ( `CDATE`,  `MDATE`,  `URL`,  `USERNAME`,  `DESCRIPTION`,  `CONTEXT`,  `TYPE`,  `PRIORITY`,  `STATUS`,  `ERRMSG`,  `ERRNUM`) VALUES ('2021-05-06 15:05:17', '2021-05-06 15:05:17', 'clxcron.php at line 37', 'N/A', 'CREATE VIEW RCAA_SUBLEDGER_BAL_VW AS SELECT 
MAX(ID) ID
,COMP_CODE
,RCLE_CODE
,RCTB_CODE
,RC_REPGRP
,RECON_ITEM
,QUERYCODE
,SUBACCOUNT_CODE
,CHART_FLD01
,CHART_FLD02
,CHART_FLD03
,TO_CHAR(EFFTDATE, \\\'YYYY-MM-DD\\\') RCAP_CODE
,EFFTDATE
,REC_SRC
,CURRENCY_CODE
,1 EXCHANGE_RT
,SUM(COALESCE(TRANS_AMT,0)) BAL_AMT
,SUM(COALESCE(BASE_TRANS_AMT,0)) BASE_BAL_AMT

FROM RCAA_SUBLEDGER_TRANS RCTR

WHERE 1=1
AND RCTR.CLX_AUTH_STATUS = \\\'AP\\\'
AND ( RCTR.ITEM_REF_NO IS NULL OR  RCTR.ITEM_REF_NO = \\\'ENLZ\\\')

GROUP BY COMP_CODE, RCLE_CODE, RCTB_CODE, RC_REPGRP, RECON_ITEM, QUERYCODE, SUBACCOUNT_CODE, CHART_FLD01, CHART_FLD02, CHART_FLD03, EFFTDATE, REC_SRC, CURRENCY_CODE', 'Array
(
    [script] => CREATE VIEW RCAA_SUBLEDGER_BAL_VW AS SELECT 
MAX(ID) ID
,COMP_CODE
,RCLE_CODE
,RCTB_CODE
,RC_REPGRP
,RECON_ITEM
,QUERYCODE
,SUBACCOUNT_CODE
,CHART_FLD01
,CHART_FLD02
,CHART_FLD03
,TO_CHAR(EFFTDATE, \\\'YYYY-MM-DD\\\') RCAP_CODE
,EFFTDATE
,REC_SRC
,CURRENCY_CODE
,1 EXCHANGE_RT
,SUM(COALESCE(TRANS_AMT,0)) BAL_AMT
,SUM(COALESCE(BASE_TRANS_AMT,0)) BASE_BAL_AMT

FROM RCAA_SUBLEDGER_TRANS RCTR

WHERE 1=1
AND RCTR.CLX_AUTH_STATUS = \\\'AP\\\'
AND ( RCTR.ITEM_REF_NO IS NULL OR  RCTR.ITEM_REF_NO = \\\'ENLZ\\\')

GROUP BY COMP_CODE, RCLE_CODE, RCTB_CODE, RC_REPGRP, RECON_ITEM, QUERYCODE, SUBACCOUNT_CODE, CHART_FLD01, CHART_FLD02, CHART_FLD03, EFFTDATE, REC_SRC, CURRENCY_CODE
    [binds] => Array
        (
        )

    [backtrace] => Array
        (
            [0] => D:\\\\inetpub\\\\wwwroot\\\\clx56dev\\\\classes\\\\MysqliDatabase.php | 130 | reportError()
            [1] => D:\\\\inetpub\\\\wwwroot\\\\clx56dev\\\\classes\\\\ClxDatabase.php | 442 | executeQuery()
            [2] => D:\\\\inetpub\\\\wwwroot\\\\clx56dev\\\\classes\\\\ClxDatabase.php | 1527 | createView()
            [3] => D:\\\\inetpub\\\\wwwroot\\\\clx56dev\\\\tools\\\\db_tables.php | 1252 | checkTable()
            [4] => D:\\\\inetpub\\\\wwwroot\\\\clx56dev\\\\objects\\\\util_dbaudit.php | 399 | checkTable()
            [5] => D:\\\\inetpub\\\\wwwroot\\\\clx56dev\\\\objects\\\\util_dbaudit.php | 142 | checkTables()
            [6] => D:\\\\inetpub\\\\wwwroot\\\\clx56dev\\\\objects\\\\util_dbaudit.php | 292 | audit()
            [7] => D:\\\\inetpub\\\\wwwroot\\\\clx56dev\\\\clxcron.php | 37 | runAudits()
        )

    [request] => Array
        (
            [ac] => 
            [idlist] => 
            [to] => 
            [mc] => 
            [relfm] => 
            [DBAU_fix] => 1
            [DBAU_filename] => 
            [DBAU_dropfields] => 
            [DBAU_fieldsonly] => 
            [DBAU_indexesonly] => 
            [DBAU_tools] => 1
            [DBAU_tables] => 1
            [DBAU_procedures_functions] => 
            [DBAU_dynrel] => 
            [DBAU_dynreldata] => 
            [DBAU_compile] => 1
            [DBAU_activeonly] => 1
        )

)
', '1', '0', '1', 'FUNCTION clx56dev.TO_CHAR does not exist (1305 )', '256') ;
commit;
SELECT VALUE FROM CLX_DICTIONARY_HEAP WHERE ENTRY='GEN_ERR_CHECKTRAP' AND UPPER(LANGUAGE)='ES';
UPDATE CLX_LOGGER SET  `STATUS`='ERROR',  `RESULT`='<table border=0 cellspacing=0 cellpadding=0 class=\"form\">
<tr><td colspan=2 rowspan=1 valign=\"top\" class=\"title\">ERROR</td>
</tr>
<tr><td colspan=1 rowspan=1 valign=\"top\" class=\"prompt\">Error number:</td>
<td colspan=1 rowspan=1 valign=\"top\" class=\"data\">256</td>
</tr>
<tr><td colspan=1 rowspan=1 valign=\"top\" class=\"prompt\">Error message:</td>
<td colspan=1 rowspan=1 valign=\"top\" class=\"data\">FUNCTION clx56dev.TO_CHAR does not exist (1305 )</td>
</tr>
<tr><td colspan=1 rowspan=1 valign=\"top\" class=\"prompt\">File name:</td>
<td colspan=1 rowspan=1 valign=\"top\" class=\"data\">clxcron.php</td>
</tr>
<tr><td colspan=1 rowspan=1 valign=\"top\" class=\"prompt\">Line number:</td>
<td colspan=1 rowspan=1 valign=\"top\" class=\"data\">37</td>
</tr>
<tr><td colspan=1 rowspan=1 valign=\"top\" class=\"prompt\">Error context:</td>
<td colspan=1 rowspan=1 valign=\"top\" class=\"data\"><textarea name=\"\" id=\"\" rows=30 cols=120 readonly=\"true\">Array
(
    [script] => CREATE VIEW RCAA_SUBLEDGER_BAL_VW AS SELECT 
MAX(ID) ID
,COMP_CODE
,RCLE_CODE
,RCTB_CODE
,RC_REPGRP
,RECON_ITEM
,QUERYCODE
,SUBACCOUNT_CODE
,CHART_FLD01
,CHART_FLD02
,CHART_FLD03
,TO_CHAR(EFFTDATE, \'YYYY-MM-DD\') RCAP_CODE
,EFFTDATE
,REC_SRC
,CURRENCY_CODE
,1 EXCHANGE_RT
,SUM(COALESCE(TRANS_AMT,0)) BAL_AMT
,SUM(COALESCE(BASE_TRANS_AMT,0)) BASE_BAL_AMT

FROM RCAA_SUBLEDGER_TRANS RCTR

WHERE 1=1
AND RCTR.CLX_AUTH_STATUS = \'AP\'
AND ( RCTR.ITEM_REF_NO IS NULL OR  RCTR.ITEM_REF_NO = \'ENLZ\')

GROUP BY COMP_CODE, RCLE_CODE, RCTB_CODE, RC_REPGRP, RECON_ITEM, QUERYCODE, SUBACCOUNT_CODE, CHART_FLD01, CHART_FLD02, CHART_FLD03, EFFTDATE, REC_SRC, CURRENCY_CODE
    [binds] => Array
        (
        )

    [backtrace] => Array
        (
            [0] => D:\\inetpub\\wwwroot\\clx56dev\\classes\\MysqliDatabase.php | 130 | reportError()
            [1] => D:\\inetpub\\wwwroot\\clx56dev\\classes\\ClxDatabase.php | 442 | executeQuery()
            [2] => D:\\inetpub\\wwwroot\\clx56dev\\classes\\ClxDatabase.php | 1527 | createView()
            [3] => D:\\inetpub\\wwwroot\\clx56dev\\tools\\db_tables.php | 1252 | checkTable()
            [4] => D:\\inetpub\\wwwroot\\clx56dev\\objects\\util_dbaudit.php | 399 | checkTable()
            [5] => D:\\inetpub\\wwwroot\\clx56dev\\objects\\util_dbaudit.php | 142 | checkTables()
            [6] => D:\\inetpub\\wwwroot\\clx56dev\\objects\\util_dbaudit.php | 292 | audit()
            [7] => D:\\inetpub\\wwwroot\\clx56dev\\clxcron.php | 37 | runAudits()
        )

    [request] => Array
        (
            [ac] => 
            [idlist] => 
            [to] => 
            [mc] => 
            [relfm] => 
            [DBAU_fix] => 1
            [DBAU_filename] => 
            [DBAU_dropfields] => 
            [DBAU_fieldsonly] => 
            [DBAU_indexesonly] => 
            [DBAU_tools] => 1
            [DBAU_tables] => 1
            [DBAU_procedures_functions] => 
            [DBAU_dynrel] => 
            [DBAU_dynreldata] => 
            [DBAU_compile] => 1
            [DBAU_activeonly] => 1
        )

)
</textarea>
</td>
</tr>
</table>

' WHERE ID = '278';
commit;
SELECT  SYPRVALUE FROM CLX_SYS_PARAMETERS WHERE SYPRKEY='MAX_TIME_HOUR_DELETE_TMP' AND TOOLCODE = 'DBTB';
SELECT TABLE_NAME  FROM information_schema.tables WHERE   table_type = "base table" AND  table_schema=DATABASE() AND TABLE_NAME LIKE 'Z__TMP_%';
START TRANSACTION WITH CONSISTENT SNAPSHOT;
UPDATE CLX_PR_SCHEDULES  PRSC SET PROC_STATUS = 'RUN', BATCH_PID = '3372.1699036967134588' WHERE PRSC.NEXT_RUN_TIME <= '2021-05-06 15:05:18' AND PRSC.PROC_STATUS ='IDLE' AND PRSC.STATUS = 1 AND PRSC.PR_RECURRENCE <> 'NEV' ;
commit;
SELECT ID, IDCODE, IDNAME, NEXT_RUN_TIME, OWNERCODE, MODIFIEDBY FROM CLX_PR_SCHEDULES  WHERE PROC_STATUS ='RUN'  AND BATCH_PID = '3372.1699036967134588'  ORDER BY NEXT_RUN_TIME ASC;
UPDATE CLX_PR_SCHEDULES SET BATCH_PID = '3372.16990369671345881' WHERE BATCH_PID = '3372.1699036967134588' AND ID = 211;
UPDATE CLX_AC_USERS SET LOGIN_ATTEMPTS = 0, STATUS = 1 WHERE UPPER(USERNAME) = 'SYSTEM';
SELECT ID, FIRSTNAME, LASTNAME, USERNAME, ISADMIN, STATUS, EMAIL, COMPANY, POSITION, CREATORUSER, AUDITU, LOGIN_ATTEMPTS, PASSEXPIRE, PASSREQCHANGE, PASSLSTCHANGE, LOGIN_COUNTER, PHONE, FAX, LAST_SESSION_IP, LAST_SESSION_DATE, EXT_REF_NO FROM CLX_AC_USERS WHERE UPPER( USERNAME)='SYSTEM';
SHOW FIELDS FROM CLX_AC_USERS LIKE 'LAST_SESSION_IP';
SHOW FIELDS FROM CLX_AC_USERS LIKE 'LAST_SESSION_DATE';
UPDATE CLX_AC_USERS SET  `LAST_SESSION_IP`='127.0.0.1',  `LAST_SESSION_DATE`='2021-05-06 15:05:18' WHERE UPPER(USERNAME) = 'SYSTEM';
SELECT COUNT(*) FROM CLX_US_PREFERENCES WHERE UPPER(USERNAME) = 'SYSTEM' AND PREFKEY = 'LANGUAGE';
UPDATE CLX_US_PREFERENCES SET  `USERNAME`='system',  `PREFKEY`='LANGUAGE',  `PREFVALUE`='es' WHERE UPPER(USERNAME) = 'SYSTEM' AND PREFKEY = 'LANGUAGE';
SELECT * FROM CLX_US_PREFERENCES WHERE USERNAME='system';
SHOW TABLES LIKE 'CLX_DEFAULT_SQL_COMPANY';
SELECT DISTINCT UIFU.FILTERID FROM CLX_UI_FILTERS UIFT, CLX_UI_FILTER_PREFS UIFU, CLX_UI_LISTINGS UILG, CLX_DB_QUERIES DBQY WHERE UIFT.ID = UIFU.FILTERID AND UIFU.QUERYCODE = DBQY.IDCODE AND UILG.IDCODE = DBQY.IDCODE AND UIFU.USERNAME='system';
SELECT * FROM CLX_AC_GROUP_MEMBERS WHERE UPPER(USERNAME)='SYSTEM';
SELECT * FROM CLX_AC_USER_FSECURE WHERE UPPER(USERNAME) = 'SYSTEM';
commit;
set autocommit = 1;
SELECT * FROM CLX_TOOLS WHERE IDCODE='PRPR';
SELECT * FROM CLX_PR_SCHEDULES WHERE STATUS=1 AND IDCODE IN ('SFA001');
UPDATE CLX_PR_SCHEDULES  SET NEXT_RUN_TIME = '2021-05-06 14:53:46'  WHERE IDCODE = 'SFA001';
commit;
SELECT ID FROM CLX_PR_PROC_LOGS WHERE PROCESSCODE = 'SFA001' AND SCHEDULECODE = 'SFA001';
SELECT ID FROM CLX_PR_PROC_LOGS WHERE ID=4349;
SELECT * FROM CLX_PR_EXCEPT_LOGS WHERE LOG_RECID='4349';
SELECT * FROM CLX_PR_STEP_LOGS WHERE LOG_RECID='4349';
DELETE FROM CLX_PR_STEP_LOGS WHERE ID=3052092;
SELECT VALUE FROM CLX_DICTIONARY_HEAP WHERE ENTRY='BASE_PROC_TTL_RUN' AND UPPER(LANGUAGE)='ES';
SELECT PRLO.* FROM CLX_PR_SCHEDULES PRSC, CLX_PR_PROC_LOGS PRLO WHERE PRSC.LOG_METHOD = 1 AND PRSC.IDCODE = SCHEDULECODE AND PRLO.SCHEDULECODE = 'SFA001' AND PRLO.PROC_STATUS='END' AND PRLO.ID = (SELECT MAX(PRLO2.ID) FROM CLX_PR_PROC_LOGS PRLO2 WHERE PRLO2.SCHEDULECODE = PRLO.SCHEDULECODE);
UPDATE CLX_PR_PROC_LOGS SET  `ID`='4349',  `SCHEDULECODE`='SFA001',  `PROCESSCODE`='SFA001',  `PROCESS_MSG`='',  `EXECUTEDBY`='system',  `PROC_STATUS`='RUN',  `BATCH_PID`='3372.0',  `SDATE`='2021-05-06 15:05:18',  `EDATE`='2021-05-06 15:05:18' WHERE ID = 4349;
COMMIT;
SELECT COUNT(*) FROM CLX_DB_LISTS WHERE IDCODE = 'PROS' AND SORT_BY_LABEL = 0;
SELECT DBLI.IDCODE, IFNULL(DICT.VALUE, IFNULL((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = DBLI.IDNAME AND UPPER(D.LANGUAGE) ='ES'), DBLI.IDNAME)) IDNAME, IFNULL(DICT2.VALUE, IFNULL((SELECT MAX(D2.VALUE) FROM CLX_DICTIONARY D2 WHERE D2.ENTRY = DBLI.IDNAME2 AND LOWER(D2.LANGUAGE) ='es'), DBLI.IDNAME2)) IDNAME2 FROM CLX_DB_LISTS DBLT, CLX_DB_LIST_ITEMS DBLI LEFT JOIN CLX_DICTIONARY DICT ON DICT.ENTRY = DBLI.IDNAME AND LOWER(DICT.LANGUAGE) = 'es' LEFT JOIN CLX_DICTIONARY DICT2 ON DICT2.ENTRY = DBLI.IDNAME2 AND LOWER(DICT2.LANGUAGE) = 'es' WHERE DBLT.IDCODE = DBLI.LISTCODE AND DBLI.INACTIVE = 0 AND DBLI.LISTCODE='PROS'  AND DBLI.IDCODE = 'RUN' ORDER BY DBLI.SEQNUM ;
SELECT VALUE FROM CLX_DICTIONARY_HEAP WHERE ENTRY='GEN_LBL_SYSTEM' AND UPPER(LANGUAGE)='ES';
SELECT VALUE FROM CLX_DICTIONARY_HEAP WHERE ENTRY='GEN_LBL_SCHEDULE' AND UPPER(LANGUAGE)='ES';
SELECT VALUE FROM CLX_DICTIONARY_HEAP WHERE ENTRY='GEN_LBL_MESSAGE' AND UPPER(LANGUAGE)='ES';
SELECT PRSC.NOTIFY_STATUS, PRSC.TOUSER USERNAME, PRSC.SUBJECT, PRSC.MESSAGE, PRSC.CREATE_TASK, PRSC.CREATE_ALERT, PRSC.SEND_EMAIL, ACUS.EMAIL, ACUS.FIRSTNAME, ACUS.LASTNAME FROM CLX_PR_SCHEDULES PRSC, CLX_AC_USERS ACUS WHERE PRSC.IDCODE = 'SFA001' AND PRSC.TOUSER = ACUS.USERNAME AND PRSC.NOTIFY_STATUS ='RUN';
UPDATE CLX_PR_PROC_LOGS SET SDATE = '2021-05-06 15:05:18', EDATE = '2021-05-06 15:05:18', PROC_STATUS = 'RUN', schedulecode = 'SFA001' WHERE ID='4349';
COMMIT;
SELECT VALUE FROM CLX_DICTIONARY_HEAP WHERE ENTRY='BASE_PROC_LBL_START' AND UPPER(LANGUAGE)='ES';
SELECT COUNT(*) FROM CLX_DB_LISTS WHERE IDCODE = 'PROS' AND SORT_BY_LABEL = 0;
SELECT DBLI.IDCODE, IFNULL(DICT.VALUE, IFNULL((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = DBLI.IDNAME AND UPPER(D.LANGUAGE) ='ES'), DBLI.IDNAME)) IDNAME, IFNULL(DICT2.VALUE, IFNULL((SELECT MAX(D2.VALUE) FROM CLX_DICTIONARY D2 WHERE D2.ENTRY = DBLI.IDNAME2 AND LOWER(D2.LANGUAGE) ='es'), DBLI.IDNAME2)) IDNAME2 FROM CLX_DB_LISTS DBLT, CLX_DB_LIST_ITEMS DBLI LEFT JOIN CLX_DICTIONARY DICT ON DICT.ENTRY = DBLI.IDNAME AND LOWER(DICT.LANGUAGE) = 'es' LEFT JOIN CLX_DICTIONARY DICT2 ON DICT2.ENTRY = DBLI.IDNAME2 AND LOWER(DICT2.LANGUAGE) = 'es' WHERE DBLT.IDCODE = DBLI.LISTCODE AND DBLI.INACTIVE = 0 AND DBLI.LISTCODE='PROS'  AND DBLI.IDCODE = 'RUN' ORDER BY DBLI.SEQNUM ;
SELECT PRSC.NOTIFY_STATUS, PRSC.TOUSER USERNAME, PRSC.SUBJECT, PRSC.MESSAGE, PRSC.CREATE_TASK, PRSC.CREATE_ALERT, PRSC.SEND_EMAIL, ACUS.EMAIL, ACUS.FIRSTNAME, ACUS.LASTNAME FROM CLX_PR_SCHEDULES PRSC, CLX_AC_USERS ACUS WHERE PRSC.IDCODE = 'SFA001' AND PRSC.TOUSER = ACUS.USERNAME AND PRSC.NOTIFY_STATUS ='RUN';
UPDATE CLX_PR_PROC_LOGS SET SDATE = '2021-05-06 15:05:18', EDATE = '2021-05-06 15:05:18', PROC_STATUS = 'RUN', schedulecode = 'SFA001' WHERE ID='4349';
COMMIT;
SELECT * FROM CLX_PR_PROCESS WHERE IDCODE='SFA001';
SELECT COUNT(*) FROM CLX_PR_SECTIONS WHERE PROCESSCODE='SFA001' AND IS_MAINSECTION = 1 AND STATUS = 1;
SELECT * FROM CLX_PR_SCHED_PRMTS WHERE SCHEDULECODE = 'SFA001';
SELECT VALUE FROM CLX_DICTIONARY_HEAP WHERE ENTRY='GEN_LBL_PARAMETERS' AND UPPER(LANGUAGE)='ES';
SELECT COUNT(*) FROM CLX_DB_LISTS WHERE IDCODE = 'PROS' AND SORT_BY_LABEL = 0;
SELECT DBLI.IDCODE, IFNULL(DICT.VALUE, IFNULL((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = DBLI.IDNAME AND UPPER(D.LANGUAGE) ='ES'), DBLI.IDNAME)) IDNAME, IFNULL(DICT2.VALUE, IFNULL((SELECT MAX(D2.VALUE) FROM CLX_DICTIONARY D2 WHERE D2.ENTRY = DBLI.IDNAME2 AND LOWER(D2.LANGUAGE) ='es'), DBLI.IDNAME2)) IDNAME2 FROM CLX_DB_LISTS DBLT, CLX_DB_LIST_ITEMS DBLI LEFT JOIN CLX_DICTIONARY DICT ON DICT.ENTRY = DBLI.IDNAME AND LOWER(DICT.LANGUAGE) = 'es' LEFT JOIN CLX_DICTIONARY DICT2 ON DICT2.ENTRY = DBLI.IDNAME2 AND LOWER(DICT2.LANGUAGE) = 'es' WHERE DBLT.IDCODE = DBLI.LISTCODE AND DBLI.INACTIVE = 0 AND DBLI.LISTCODE='PROS'  AND DBLI.IDCODE = 'RUN' ORDER BY DBLI.SEQNUM ;
SELECT PRSC.NOTIFY_STATUS, PRSC.TOUSER USERNAME, PRSC.SUBJECT, PRSC.MESSAGE, PRSC.CREATE_TASK, PRSC.CREATE_ALERT, PRSC.SEND_EMAIL, ACUS.EMAIL, ACUS.FIRSTNAME, ACUS.LASTNAME FROM CLX_PR_SCHEDULES PRSC, CLX_AC_USERS ACUS WHERE PRSC.IDCODE = 'SFA001' AND PRSC.TOUSER = ACUS.USERNAME AND PRSC.NOTIFY_STATUS ='RUN';
UPDATE CLX_PR_PROC_LOGS SET SDATE = '2021-05-06 15:05:18', EDATE = '2021-05-06 15:05:18', PROC_STATUS = 'RUN', schedulecode = 'SFA001' WHERE ID='4349';
COMMIT;
SELECT * FROM CLX_PR_SECTIONS WHERE STATUS = 1 AND PROCESSCODE='SFA001' AND IS_MAINSECTION = 1;
SELECT * FROM CLX_PR_SECTIONS WHERE IDCODE='SFA001_MAIN';
SELECT VALUE FROM CLX_DICTIONARY_HEAP WHERE ENTRY='BASE_PROC_LBL_SECSTART' AND UPPER(LANGUAGE)='ES';
SELECT COUNT(*) FROM CLX_DB_LISTS WHERE IDCODE = 'PROS' AND SORT_BY_LABEL = 0;
SELECT DBLI.IDCODE, IFNULL(DICT.VALUE, IFNULL((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = DBLI.IDNAME AND UPPER(D.LANGUAGE) ='ES'), DBLI.IDNAME)) IDNAME, IFNULL(DICT2.VALUE, IFNULL((SELECT MAX(D2.VALUE) FROM CLX_DICTIONARY D2 WHERE D2.ENTRY = DBLI.IDNAME2 AND LOWER(D2.LANGUAGE) ='es'), DBLI.IDNAME2)) IDNAME2 FROM CLX_DB_LISTS DBLT, CLX_DB_LIST_ITEMS DBLI LEFT JOIN CLX_DICTIONARY DICT ON DICT.ENTRY = DBLI.IDNAME AND LOWER(DICT.LANGUAGE) = 'es' LEFT JOIN CLX_DICTIONARY DICT2 ON DICT2.ENTRY = DBLI.IDNAME2 AND LOWER(DICT2.LANGUAGE) = 'es' WHERE DBLT.IDCODE = DBLI.LISTCODE AND DBLI.INACTIVE = 0 AND DBLI.LISTCODE='PROS'  AND DBLI.IDCODE = 'RUN' ORDER BY DBLI.SEQNUM ;
SELECT PRSC.NOTIFY_STATUS, PRSC.TOUSER USERNAME, PRSC.SUBJECT, PRSC.MESSAGE, PRSC.CREATE_TASK, PRSC.CREATE_ALERT, PRSC.SEND_EMAIL, ACUS.EMAIL, ACUS.FIRSTNAME, ACUS.LASTNAME FROM CLX_PR_SCHEDULES PRSC, CLX_AC_USERS ACUS WHERE PRSC.IDCODE = 'SFA001' AND PRSC.TOUSER = ACUS.USERNAME AND PRSC.NOTIFY_STATUS ='RUN';
UPDATE CLX_PR_PROC_LOGS SET SDATE = '2021-05-06 15:05:18', EDATE = '2021-05-06 15:05:18', PROC_STATUS = 'RUN', schedulecode = 'SFA001' WHERE ID='4349';
COMMIT;
SELECT * FROM CLX_EVENTS WHERE STATUS = 1 AND OWNERID='SFA001_MAIN' AND OWNERCODE = 'PRSE' ORDER BY SEQNUM;
INSERT INTO CLX_PR_STEP_LOGS ( `LOG_RECID`,  `SEQNUM`,  `CODE_TYPE`,  `CODE_TEXT`,  `DO_SECTION`,  `DO_SECTION_TYPE`,  `STEP_STATUS`,  `STEP_MSG`,  `SECTIONCODE`,  `SDATE`) VALUES ('4349', '0', 'CODE', '$a = new Acti();
$a->escalation();
unset($a);', '', '', 'RUN', 'Proceso
 <br>Estado SFA001
 <br>Proceso Iniciado:2021-05-06 15:05:18
 <br>Parámetros<br><ul><li>PROCESSCODE: SFA001</li><li>RUNID: 4349</li><li>USERNAME: system</li><li>START_TIME: 2021-05-06 15:05:18</li><li>SCHEDULECODE: SFA001</li><li>CURRENT_TIME: 2021-05-06 03:05:18</li></ul>
 <br>Sección SFA001_MAIN Iniciada
 <br>', 'SFA001_MAIN', '2021-05-06 15:05:19') ;
commit;
SELECT VALUE FROM CLX_DICTIONARY_HEAP WHERE ENTRY='BASE_PROC_LBL_STEPSTART' AND UPPER(LANGUAGE)='ES';
SELECT VALUE FROM CLX_DICTIONARY_HEAP WHERE ENTRY='GEN_LBL_SEQNUM' AND UPPER(LANGUAGE)='ES';
SELECT VALUE FROM CLX_DICTIONARY_HEAP WHERE ENTRY='GEN_LBL_TYPE' AND UPPER(LANGUAGE)='ES';
SELECT VALUE FROM CLX_DICTIONARY_HEAP WHERE ENTRY='GEN_LBL_DO_SECTION_TYPE' AND UPPER(LANGUAGE)='ES';
SELECT COUNT(*) FROM CLX_DB_LISTS WHERE IDCODE = 'PROS' AND SORT_BY_LABEL = 0;
SELECT DBLI.IDCODE, IFNULL(DICT.VALUE, IFNULL((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = DBLI.IDNAME AND UPPER(D.LANGUAGE) ='ES'), DBLI.IDNAME)) IDNAME, IFNULL(DICT2.VALUE, IFNULL((SELECT MAX(D2.VALUE) FROM CLX_DICTIONARY D2 WHERE D2.ENTRY = DBLI.IDNAME2 AND LOWER(D2.LANGUAGE) ='es'), DBLI.IDNAME2)) IDNAME2 FROM CLX_DB_LISTS DBLT, CLX_DB_LIST_ITEMS DBLI LEFT JOIN CLX_DICTIONARY DICT ON DICT.ENTRY = DBLI.IDNAME AND LOWER(DICT.LANGUAGE) = 'es' LEFT JOIN CLX_DICTIONARY DICT2 ON DICT2.ENTRY = DBLI.IDNAME2 AND LOWER(DICT2.LANGUAGE) = 'es' WHERE DBLT.IDCODE = DBLI.LISTCODE AND DBLI.INACTIVE = 0 AND DBLI.LISTCODE='PROS'  AND DBLI.IDCODE = 'RUN' ORDER BY DBLI.SEQNUM ;
SELECT PRSC.NOTIFY_STATUS, PRSC.TOUSER USERNAME, PRSC.SUBJECT, PRSC.MESSAGE, PRSC.CREATE_TASK, PRSC.CREATE_ALERT, PRSC.SEND_EMAIL, ACUS.EMAIL, ACUS.FIRSTNAME, ACUS.LASTNAME FROM CLX_PR_SCHEDULES PRSC, CLX_AC_USERS ACUS WHERE PRSC.IDCODE = 'SFA001' AND PRSC.TOUSER = ACUS.USERNAME AND PRSC.NOTIFY_STATUS ='RUN';
UPDATE CLX_PR_PROC_LOGS SET SDATE = '2021-05-06 15:05:18', EDATE = '2021-05-06 15:05:19', PROC_STATUS = 'RUN', schedulecode = 'SFA001' WHERE ID='4349';
COMMIT;
SELECT * FROM CLX_EVENTS WHERE ID=9289;
SELECT * FROM CLX_OBJECTS WHERE TYPE='ACTN' AND IDCODE='CODE';
SELECT * FROM CLX_CODELIB WHERE UPPER(IDCODE)='ACTI';
SELECT IDCODE, MODULECODE, IDNAME FROM CLX_DB_TABLES WHERE IDCODE IN ('ACTI','OPPO','ACTH','PROD','SRER','SRRP','ACCO','SLAP','SLAA','SRAP','SRAA','SRRQ');
SELECT COUNT(*) FROM CLX_PR_SCHEDULES WHERE PROC_STATUS = 'RUN' AND PROCESSCODE = 'SFA001';
SELECT * FROM CLX_CODELIB WHERE UPPER(IDCODE)='SRER';
SELECT IDCODE, MODULECODE, IDNAME FROM CLX_DB_TABLES WHERE IDCODE IN ('SRER');
UPDATE CRM_ACTIVITIES  SET LAST_ESCALATION = NOW() WHERE LAST_ESCALATION IS NULL;
SELECT SRER.* FROM SERV_ESCALATION_RULES SRER WHERE SRER.MODULECODE = 'SFA' AND SRER.STATUS = 'A' AND SRER.SCALE_AFTER > 0;
SELECT VALUE FROM CLX_DICTIONARY_HEAP WHERE ENTRY='BASE_PROC_LBL_DISPLAY' AND UPPER(LANGUAGE)='ES';
SELECT COUNT(*) FROM CLX_DB_LISTS WHERE IDCODE = 'PROS' AND SORT_BY_LABEL = 0;
SELECT DBLI.IDCODE, IFNULL(DICT.VALUE, IFNULL((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = DBLI.IDNAME AND UPPER(D.LANGUAGE) ='ES'), DBLI.IDNAME)) IDNAME, IFNULL(DICT2.VALUE, IFNULL((SELECT MAX(D2.VALUE) FROM CLX_DICTIONARY D2 WHERE D2.ENTRY = DBLI.IDNAME2 AND LOWER(D2.LANGUAGE) ='es'), DBLI.IDNAME2)) IDNAME2 FROM CLX_DB_LISTS DBLT, CLX_DB_LIST_ITEMS DBLI LEFT JOIN CLX_DICTIONARY DICT ON DICT.ENTRY = DBLI.IDNAME AND LOWER(DICT.LANGUAGE) = 'es' LEFT JOIN CLX_DICTIONARY DICT2 ON DICT2.ENTRY = DBLI.IDNAME2 AND LOWER(DICT2.LANGUAGE) = 'es' WHERE DBLT.IDCODE = DBLI.LISTCODE AND DBLI.INACTIVE = 0 AND DBLI.LISTCODE='PROS'  AND DBLI.IDCODE = 'RUN' ORDER BY DBLI.SEQNUM ;
SELECT PRSC.NOTIFY_STATUS, PRSC.TOUSER USERNAME, PRSC.SUBJECT, PRSC.MESSAGE, PRSC.CREATE_TASK, PRSC.CREATE_ALERT, PRSC.SEND_EMAIL, ACUS.EMAIL, ACUS.FIRSTNAME, ACUS.LASTNAME FROM CLX_PR_SCHEDULES PRSC, CLX_AC_USERS ACUS WHERE PRSC.IDCODE = 'SFA001' AND PRSC.TOUSER = ACUS.USERNAME AND PRSC.NOTIFY_STATUS ='RUN';
UPDATE CLX_PR_PROC_LOGS SET SDATE = '2021-05-06 15:05:18', EDATE = '2021-05-06 15:05:19', PROC_STATUS = 'RUN', schedulecode = 'SFA001' WHERE ID='4349';
COMMIT;
UPDATE CLX_PR_STEP_LOGS SET  `EDATE`='2021-05-06 15:05:19',  `PARAMETERS_OUT`='<ul><li>PROCESSCODE: SFA001</li><li>RUNID: 4349</li><li>USERNAME: system</li><li>START_TIME: 2021-05-06 15:05:18</li><li>SCHEDULECODE: SFA001</li><li>CURRENT_TIME: 2021-05-06 03:05:18</li></ul>',  `STEP_STATUS`='END',  `STEP_MSG`='Paso Iniciado. Número de Secuencia: 0, Tipo: CODE,Ejecutar Sección (Tipo):
 <br>Salida
 <br>' WHERE ID=3052096;
SELECT COUNT(*) FROM CLX_PR_EXCEPT_LOGS WHERE SCHEDULECODE = 'SFA001' AND LOG_RECID = '4349';
SELECT VALUE FROM CLX_DICTIONARY_HEAP WHERE ENTRY='BASE_PROC_LBL_END' AND UPPER(LANGUAGE)='ES';
SELECT COUNT(*) FROM CLX_DB_LISTS WHERE IDCODE = 'PROS' AND SORT_BY_LABEL = 0;
SELECT DBLI.IDCODE, IFNULL(DICT.VALUE, IFNULL((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = DBLI.IDNAME AND UPPER(D.LANGUAGE) ='ES'), DBLI.IDNAME)) IDNAME, IFNULL(DICT2.VALUE, IFNULL((SELECT MAX(D2.VALUE) FROM CLX_DICTIONARY D2 WHERE D2.ENTRY = DBLI.IDNAME2 AND LOWER(D2.LANGUAGE) ='es'), DBLI.IDNAME2)) IDNAME2 FROM CLX_DB_LISTS DBLT, CLX_DB_LIST_ITEMS DBLI LEFT JOIN CLX_DICTIONARY DICT ON DICT.ENTRY = DBLI.IDNAME AND LOWER(DICT.LANGUAGE) = 'es' LEFT JOIN CLX_DICTIONARY DICT2 ON DICT2.ENTRY = DBLI.IDNAME2 AND LOWER(DICT2.LANGUAGE) = 'es' WHERE DBLT.IDCODE = DBLI.LISTCODE AND DBLI.INACTIVE = 0 AND DBLI.LISTCODE='PROS'  AND DBLI.IDCODE = 'END' ORDER BY DBLI.SEQNUM ;
SELECT PRSC.NOTIFY_STATUS, PRSC.TOUSER USERNAME, PRSC.SUBJECT, PRSC.MESSAGE, PRSC.CREATE_TASK, PRSC.CREATE_ALERT, PRSC.SEND_EMAIL, ACUS.EMAIL, ACUS.FIRSTNAME, ACUS.LASTNAME FROM CLX_PR_SCHEDULES PRSC, CLX_AC_USERS ACUS WHERE PRSC.IDCODE = 'SFA001' AND PRSC.TOUSER = ACUS.USERNAME AND PRSC.NOTIFY_STATUS ='END';
UPDATE CLX_PR_PROC_LOGS SET SDATE = '2021-05-06 15:05:18', EDATE = '2021-05-06 15:05:19', PROC_STATUS = 'END', schedulecode = 'SFA001' WHERE ID='4349';
COMMIT;
commit;
set autocommit = 0;
UPDATE CLX_PR_SCHEDULES  SET PROC_STATUS = 'END' WHERE NEXT_RUN_TIME IS NULL AND ID = 211;
UPDATE CLX_PR_SCHEDULES SET PROC_STATUS ='IDLE' WHERE NEXT_RUN_TIME IS NOT null AND ID = 211;
commit;
UPDATE CLX_PR_SCHEDULES SET BATCH_PID = '3372.16990369671345882' WHERE BATCH_PID = '3372.1699036967134588' AND ID = 174;
commit;
set autocommit = 1;
SELECT * FROM CLX_TOOLS WHERE IDCODE='PRPR';
SELECT * FROM CLX_PR_SCHEDULES WHERE STATUS=1 AND IDCODE IN ('GLOQ');
UPDATE CLX_PR_SCHEDULES  SET NEXT_RUN_TIME = '2021-05-06 14:54:46'  WHERE IDCODE = 'GLOQ';
commit;
SELECT ID FROM CLX_PR_PROC_LOGS WHERE PROCESSCODE = 'GLOQ' AND SCHEDULECODE = 'GLOQ';
SELECT ID FROM CLX_PR_PROC_LOGS WHERE ID=98954;
SELECT * FROM CLX_PR_EXCEPT_LOGS WHERE LOG_RECID='98954';
SELECT * FROM CLX_PR_STEP_LOGS WHERE LOG_RECID='98954';
SELECT PRLO.* FROM CLX_PR_SCHEDULES PRSC, CLX_PR_PROC_LOGS PRLO WHERE PRSC.LOG_METHOD = 1 AND PRSC.IDCODE = SCHEDULECODE AND PRLO.SCHEDULECODE = 'GLOQ' AND PRLO.PROC_STATUS='END' AND PRLO.ID = (SELECT MAX(PRLO2.ID) FROM CLX_PR_PROC_LOGS PRLO2 WHERE PRLO2.SCHEDULECODE = PRLO.SCHEDULECODE);
UPDATE CLX_PR_PROC_LOGS SET  `ID`='104021',  `SCHEDULECODE`='GLOQ',  `PROCESSCODE`='GLOQ',  `PROCESS_MSG`='',  `EXECUTEDBY`='system',  `PROC_STATUS`='RUN',  `BATCH_PID`='3372.0',  `SDATE`='2021-05-06 15:05:19',  `EDATE`='2021-05-06 15:05:19' WHERE ID = 104021;
COMMIT;
SELECT COUNT(*) FROM CLX_DB_LISTS WHERE IDCODE = 'PROS' AND SORT_BY_LABEL = 0;
SELECT DBLI.IDCODE, IFNULL(DICT.VALUE, IFNULL((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = DBLI.IDNAME AND UPPER(D.LANGUAGE) ='ES'), DBLI.IDNAME)) IDNAME, IFNULL(DICT2.VALUE, IFNULL((SELECT MAX(D2.VALUE) FROM CLX_DICTIONARY D2 WHERE D2.ENTRY = DBLI.IDNAME2 AND LOWER(D2.LANGUAGE) ='es'), DBLI.IDNAME2)) IDNAME2 FROM CLX_DB_LISTS DBLT, CLX_DB_LIST_ITEMS DBLI LEFT JOIN CLX_DICTIONARY DICT ON DICT.ENTRY = DBLI.IDNAME AND LOWER(DICT.LANGUAGE) = 'es' LEFT JOIN CLX_DICTIONARY DICT2 ON DICT2.ENTRY = DBLI.IDNAME2 AND LOWER(DICT2.LANGUAGE) = 'es' WHERE DBLT.IDCODE = DBLI.LISTCODE AND DBLI.INACTIVE = 0 AND DBLI.LISTCODE='PROS'  AND DBLI.IDCODE = 'RUN' ORDER BY DBLI.SEQNUM ;
SELECT PRSC.NOTIFY_STATUS, PRSC.TOUSER USERNAME, PRSC.SUBJECT, PRSC.MESSAGE, PRSC.CREATE_TASK, PRSC.CREATE_ALERT, PRSC.SEND_EMAIL, ACUS.EMAIL, ACUS.FIRSTNAME, ACUS.LASTNAME FROM CLX_PR_SCHEDULES PRSC, CLX_AC_USERS ACUS WHERE PRSC.IDCODE = 'GLOQ' AND PRSC.TOUSER = ACUS.USERNAME AND PRSC.NOTIFY_STATUS ='RUN';
UPDATE CLX_PR_PROC_LOGS SET SDATE = '2021-05-06 15:05:19', EDATE = '2021-05-06 15:05:19', PROC_STATUS = 'RUN', schedulecode = 'GLOQ' WHERE ID='104021';
COMMIT;
SELECT COUNT(*) FROM CLX_DB_LISTS WHERE IDCODE = 'PROS' AND SORT_BY_LABEL = 0;
SELECT DBLI.IDCODE, IFNULL(DICT.VALUE, IFNULL((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = DBLI.IDNAME AND UPPER(D.LANGUAGE) ='ES'), DBLI.IDNAME)) IDNAME, IFNULL(DICT2.VALUE, IFNULL((SELECT MAX(D2.VALUE) FROM CLX_DICTIONARY D2 WHERE D2.ENTRY = DBLI.IDNAME2 AND LOWER(D2.LANGUAGE) ='es'), DBLI.IDNAME2)) IDNAME2 FROM CLX_DB_LISTS DBLT, CLX_DB_LIST_ITEMS DBLI LEFT JOIN CLX_DICTIONARY DICT ON DICT.ENTRY = DBLI.IDNAME AND LOWER(DICT.LANGUAGE) = 'es' LEFT JOIN CLX_DICTIONARY DICT2 ON DICT2.ENTRY = DBLI.IDNAME2 AND LOWER(DICT2.LANGUAGE) = 'es' WHERE DBLT.IDCODE = DBLI.LISTCODE AND DBLI.INACTIVE = 0 AND DBLI.LISTCODE='PROS'  AND DBLI.IDCODE = 'RUN' ORDER BY DBLI.SEQNUM ;
SELECT PRSC.NOTIFY_STATUS, PRSC.TOUSER USERNAME, PRSC.SUBJECT, PRSC.MESSAGE, PRSC.CREATE_TASK, PRSC.CREATE_ALERT, PRSC.SEND_EMAIL, ACUS.EMAIL, ACUS.FIRSTNAME, ACUS.LASTNAME FROM CLX_PR_SCHEDULES PRSC, CLX_AC_USERS ACUS WHERE PRSC.IDCODE = 'GLOQ' AND PRSC.TOUSER = ACUS.USERNAME AND PRSC.NOTIFY_STATUS ='RUN';
UPDATE CLX_PR_PROC_LOGS SET SDATE = '2021-05-06 15:05:19', EDATE = '2021-05-06 15:05:19', PROC_STATUS = 'RUN', schedulecode = 'GLOQ' WHERE ID='104021';
COMMIT;
SELECT * FROM CLX_PR_PROCESS WHERE IDCODE='GLOQ';
SELECT COUNT(*) FROM CLX_PR_SECTIONS WHERE PROCESSCODE='GLOQ' AND IS_MAINSECTION = 1 AND STATUS = 1;
SELECT * FROM CLX_PR_SCHED_PRMTS WHERE SCHEDULECODE = 'GLOQ';
SELECT COUNT(*) FROM CLX_DB_LISTS WHERE IDCODE = 'PROS' AND SORT_BY_LABEL = 0;
SELECT DBLI.IDCODE, IFNULL(DICT.VALUE, IFNULL((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = DBLI.IDNAME AND UPPER(D.LANGUAGE) ='ES'), DBLI.IDNAME)) IDNAME, IFNULL(DICT2.VALUE, IFNULL((SELECT MAX(D2.VALUE) FROM CLX_DICTIONARY D2 WHERE D2.ENTRY = DBLI.IDNAME2 AND LOWER(D2.LANGUAGE) ='es'), DBLI.IDNAME2)) IDNAME2 FROM CLX_DB_LISTS DBLT, CLX_DB_LIST_ITEMS DBLI LEFT JOIN CLX_DICTIONARY DICT ON DICT.ENTRY = DBLI.IDNAME AND LOWER(DICT.LANGUAGE) = 'es' LEFT JOIN CLX_DICTIONARY DICT2 ON DICT2.ENTRY = DBLI.IDNAME2 AND LOWER(DICT2.LANGUAGE) = 'es' WHERE DBLT.IDCODE = DBLI.LISTCODE AND DBLI.INACTIVE = 0 AND DBLI.LISTCODE='PROS'  AND DBLI.IDCODE = 'RUN' ORDER BY DBLI.SEQNUM ;
SELECT PRSC.NOTIFY_STATUS, PRSC.TOUSER USERNAME, PRSC.SUBJECT, PRSC.MESSAGE, PRSC.CREATE_TASK, PRSC.CREATE_ALERT, PRSC.SEND_EMAIL, ACUS.EMAIL, ACUS.FIRSTNAME, ACUS.LASTNAME FROM CLX_PR_SCHEDULES PRSC, CLX_AC_USERS ACUS WHERE PRSC.IDCODE = 'GLOQ' AND PRSC.TOUSER = ACUS.USERNAME AND PRSC.NOTIFY_STATUS ='RUN';
UPDATE CLX_PR_PROC_LOGS SET SDATE = '2021-05-06 15:05:19', EDATE = '2021-05-06 15:05:19', PROC_STATUS = 'RUN', schedulecode = 'GLOQ' WHERE ID='104021';
COMMIT;
SELECT * FROM CLX_PR_SECTIONS WHERE STATUS = 1 AND PROCESSCODE='GLOQ' AND IS_MAINSECTION = 1;
SELECT * FROM CLX_PR_SECTIONS WHERE IDCODE='GLOQ_MAIN';
SELECT COUNT(*) FROM CLX_DB_LISTS WHERE IDCODE = 'PROS' AND SORT_BY_LABEL = 0;
SELECT DBLI.IDCODE, IFNULL(DICT.VALUE, IFNULL((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = DBLI.IDNAME AND UPPER(D.LANGUAGE) ='ES'), DBLI.IDNAME)) IDNAME, IFNULL(DICT2.VALUE, IFNULL((SELECT MAX(D2.VALUE) FROM CLX_DICTIONARY D2 WHERE D2.ENTRY = DBLI.IDNAME2 AND LOWER(D2.LANGUAGE) ='es'), DBLI.IDNAME2)) IDNAME2 FROM CLX_DB_LISTS DBLT, CLX_DB_LIST_ITEMS DBLI LEFT JOIN CLX_DICTIONARY DICT ON DICT.ENTRY = DBLI.IDNAME AND LOWER(DICT.LANGUAGE) = 'es' LEFT JOIN CLX_DICTIONARY DICT2 ON DICT2.ENTRY = DBLI.IDNAME2 AND LOWER(DICT2.LANGUAGE) = 'es' WHERE DBLT.IDCODE = DBLI.LISTCODE AND DBLI.INACTIVE = 0 AND DBLI.LISTCODE='PROS'  AND DBLI.IDCODE = 'RUN' ORDER BY DBLI.SEQNUM ;
SELECT PRSC.NOTIFY_STATUS, PRSC.TOUSER USERNAME, PRSC.SUBJECT, PRSC.MESSAGE, PRSC.CREATE_TASK, PRSC.CREATE_ALERT, PRSC.SEND_EMAIL, ACUS.EMAIL, ACUS.FIRSTNAME, ACUS.LASTNAME FROM CLX_PR_SCHEDULES PRSC, CLX_AC_USERS ACUS WHERE PRSC.IDCODE = 'GLOQ' AND PRSC.TOUSER = ACUS.USERNAME AND PRSC.NOTIFY_STATUS ='RUN';
UPDATE CLX_PR_PROC_LOGS SET SDATE = '2021-05-06 15:05:19', EDATE = '2021-05-06 15:05:19', PROC_STATUS = 'RUN', schedulecode = 'GLOQ' WHERE ID='104021';
COMMIT;
SELECT * FROM CLX_EVENTS WHERE STATUS = 1 AND OWNERID='GLOQ_MAIN' AND OWNERCODE = 'PRSE' ORDER BY SEQNUM;
INSERT INTO CLX_PR_STEP_LOGS ( `LOG_RECID`,  `SEQNUM`,  `CODE_TYPE`,  `CODE_TEXT`,  `DO_SECTION`,  `DO_SECTION_TYPE`,  `STEP_STATUS`,  `STEP_MSG`,  `SECTIONCODE`,  `SDATE`) VALUES ('104021', '1', 'CODE', 'echo kPathToWebSite.\"/data/code/gloq.php\";
$a = new  Gloq();
$a->checkQueue();
unset($a);', '', 'NOT', 'RUN', 'Proceso
 Ending Process: SFA001, Activity Escalation Process
Starting Process: GLOQ, PROCESS QUEUE
Next run date: 2021-05-06 14:54:46
<br>Estado GLOQ
 <br>Proceso Iniciado:2021-05-06 15:05:19
 <br>Parámetros<br><ul><li>PROCESSCODE: GLOQ</li><li>RUNID: 104021</li><li>USERNAME: system</li><li>START_TIME: 2021-05-06 15:05:19</li><li>SCHEDULECODE: GLOQ</li><li>CURRENT_TIME: 2021-05-06 03:05:19</li></ul>
 <br>Sección GLOQ_MAIN Iniciada
 <br>', 'GLOQ_MAIN', '2021-05-06 15:05:19') ;
commit;
SELECT COUNT(*) FROM CLX_DB_LISTS WHERE IDCODE = 'PROS' AND SORT_BY_LABEL = 0;
SELECT DBLI.IDCODE, IFNULL(DICT.VALUE, IFNULL((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = DBLI.IDNAME AND UPPER(D.LANGUAGE) ='ES'), DBLI.IDNAME)) IDNAME, IFNULL(DICT2.VALUE, IFNULL((SELECT MAX(D2.VALUE) FROM CLX_DICTIONARY D2 WHERE D2.ENTRY = DBLI.IDNAME2 AND LOWER(D2.LANGUAGE) ='es'), DBLI.IDNAME2)) IDNAME2 FROM CLX_DB_LISTS DBLT, CLX_DB_LIST_ITEMS DBLI LEFT JOIN CLX_DICTIONARY DICT ON DICT.ENTRY = DBLI.IDNAME AND LOWER(DICT.LANGUAGE) = 'es' LEFT JOIN CLX_DICTIONARY DICT2 ON DICT2.ENTRY = DBLI.IDNAME2 AND LOWER(DICT2.LANGUAGE) = 'es' WHERE DBLT.IDCODE = DBLI.LISTCODE AND DBLI.INACTIVE = 0 AND DBLI.LISTCODE='PROS'  AND DBLI.IDCODE = 'RUN' ORDER BY DBLI.SEQNUM ;
SELECT PRSC.NOTIFY_STATUS, PRSC.TOUSER USERNAME, PRSC.SUBJECT, PRSC.MESSAGE, PRSC.CREATE_TASK, PRSC.CREATE_ALERT, PRSC.SEND_EMAIL, ACUS.EMAIL, ACUS.FIRSTNAME, ACUS.LASTNAME FROM CLX_PR_SCHEDULES PRSC, CLX_AC_USERS ACUS WHERE PRSC.IDCODE = 'GLOQ' AND PRSC.TOUSER = ACUS.USERNAME AND PRSC.NOTIFY_STATUS ='RUN';
UPDATE CLX_PR_PROC_LOGS SET SDATE = '2021-05-06 15:05:19', EDATE = '2021-05-06 15:05:19', PROC_STATUS = 'RUN', schedulecode = 'GLOQ' WHERE ID='104021';
COMMIT;
SELECT VALUE FROM CLX_DICTIONARY_HEAP WHERE ENTRY='GEN_LBL_SOURCECODE' AND UPPER(LANGUAGE)='ES';
SELECT COUNT(*) FROM CLX_DB_LISTS WHERE IDCODE = 'PROS' AND SORT_BY_LABEL = 0;
SELECT DBLI.IDCODE, IFNULL(DICT.VALUE, IFNULL((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = DBLI.IDNAME AND UPPER(D.LANGUAGE) ='ES'), DBLI.IDNAME)) IDNAME, IFNULL(DICT2.VALUE, IFNULL((SELECT MAX(D2.VALUE) FROM CLX_DICTIONARY D2 WHERE D2.ENTRY = DBLI.IDNAME2 AND LOWER(D2.LANGUAGE) ='es'), DBLI.IDNAME2)) IDNAME2 FROM CLX_DB_LISTS DBLT, CLX_DB_LIST_ITEMS DBLI LEFT JOIN CLX_DICTIONARY DICT ON DICT.ENTRY = DBLI.IDNAME AND LOWER(DICT.LANGUAGE) = 'es' LEFT JOIN CLX_DICTIONARY DICT2 ON DICT2.ENTRY = DBLI.IDNAME2 AND LOWER(DICT2.LANGUAGE) = 'es' WHERE DBLT.IDCODE = DBLI.LISTCODE AND DBLI.INACTIVE = 0 AND DBLI.LISTCODE='PROS'  AND DBLI.IDCODE = 'RUN' ORDER BY DBLI.SEQNUM ;
SELECT PRSC.NOTIFY_STATUS, PRSC.TOUSER USERNAME, PRSC.SUBJECT, PRSC.MESSAGE, PRSC.CREATE_TASK, PRSC.CREATE_ALERT, PRSC.SEND_EMAIL, ACUS.EMAIL, ACUS.FIRSTNAME, ACUS.LASTNAME FROM CLX_PR_SCHEDULES PRSC, CLX_AC_USERS ACUS WHERE PRSC.IDCODE = 'GLOQ' AND PRSC.TOUSER = ACUS.USERNAME AND PRSC.NOTIFY_STATUS ='RUN';
UPDATE CLX_PR_PROC_LOGS SET SDATE = '2021-05-06 15:05:19', EDATE = '2021-05-06 15:05:20', PROC_STATUS = 'RUN', schedulecode = 'GLOQ' WHERE ID='104021';
COMMIT;
SELECT * FROM CLX_EVENTS WHERE ID=8563;
SELECT * FROM CLX_CODELIB WHERE UPPER(IDCODE)='GLOQ';
SELECT IDCODE, MODULECODE, IDNAME FROM CLX_DB_TABLES WHERE IDCODE IN ('GLOQ','FIAT','FICO','INAT','COMP','INFU','PRSP','PRSC','FPCT','PRLO','JEHD','GLCP','FIMT');
START TRANSACTION WITH CONSISTENT SNAPSHOT;
SELECT COUNT(*) FROM GL_OPERATION_QUEUE WHERE REC_STATUS = 'RUN';
UPDATE GL_OPERATION_QUEUE GLOQ SET GLOQ.BATCH_PID = '3372', GLOQ.REC_STATUS = 'RUN', GLOQ.SDATE = '2021-05-06 15:05:20' WHERE GLOQ.REC_STATUS = 'IDLE';
commit;
SELECT * FROM GL_OPERATION_QUEUE WHERE REC_STATUS = 'RUN' AND BATCH_PID = '3372';
SELECT COUNT(*) FROM CLX_DB_LISTS WHERE IDCODE = 'PROS' AND SORT_BY_LABEL = 0;
SELECT DBLI.IDCODE, IFNULL(DICT.VALUE, IFNULL((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = DBLI.IDNAME AND UPPER(D.LANGUAGE) ='ES'), DBLI.IDNAME)) IDNAME, IFNULL(DICT2.VALUE, IFNULL((SELECT MAX(D2.VALUE) FROM CLX_DICTIONARY D2 WHERE D2.ENTRY = DBLI.IDNAME2 AND LOWER(D2.LANGUAGE) ='es'), DBLI.IDNAME2)) IDNAME2 FROM CLX_DB_LISTS DBLT, CLX_DB_LIST_ITEMS DBLI LEFT JOIN CLX_DICTIONARY DICT ON DICT.ENTRY = DBLI.IDNAME AND LOWER(DICT.LANGUAGE) = 'es' LEFT JOIN CLX_DICTIONARY DICT2 ON DICT2.ENTRY = DBLI.IDNAME2 AND LOWER(DICT2.LANGUAGE) = 'es' WHERE DBLT.IDCODE = DBLI.LISTCODE AND DBLI.INACTIVE = 0 AND DBLI.LISTCODE='PROS'  AND DBLI.IDCODE = 'RUN' ORDER BY DBLI.SEQNUM ;
SELECT PRSC.NOTIFY_STATUS, PRSC.TOUSER USERNAME, PRSC.SUBJECT, PRSC.MESSAGE, PRSC.CREATE_TASK, PRSC.CREATE_ALERT, PRSC.SEND_EMAIL, ACUS.EMAIL, ACUS.FIRSTNAME, ACUS.LASTNAME FROM CLX_PR_SCHEDULES PRSC, CLX_AC_USERS ACUS WHERE PRSC.IDCODE = 'GLOQ' AND PRSC.TOUSER = ACUS.USERNAME AND PRSC.NOTIFY_STATUS ='RUN';
UPDATE CLX_PR_PROC_LOGS SET SDATE = '2021-05-06 15:05:19', EDATE = '2021-05-06 15:05:20', PROC_STATUS = 'RUN', schedulecode = 'GLOQ' WHERE ID='104021';
COMMIT;
UPDATE CLX_PR_STEP_LOGS SET  `EDATE`='2021-05-06 15:05:20',  `PARAMETERS_OUT`='<ul><li>PROCESSCODE: GLOQ</li><li>RUNID: 104021</li><li>USERNAME: system</li><li>START_TIME: 2021-05-06 15:05:19</li><li>SCHEDULECODE: GLOQ</li><li>CURRENT_TIME: 2021-05-06 03:05:19</li></ul>',  `STEP_STATUS`='END',  `STEP_MSG`='Paso Iniciado. Número de Secuencia: 1, Tipo: CODE,Ejecutar Sección (Tipo):NOT
 <br>Codigo Fuente
 echo kPathToWebSite.\"/data/code/gloq.php\";
$a = new  Gloq();
$a->checkQueue();
unset($a);
<br>Salida
 D:\\inetpub\\wwwroot/clx56dev//data/code/gloq.php<br>' WHERE ID=3052097;
SELECT COUNT(*) FROM CLX_PR_EXCEPT_LOGS WHERE SCHEDULECODE = 'GLOQ' AND LOG_RECID = '104021';
SELECT COUNT(*) FROM CLX_DB_LISTS WHERE IDCODE = 'PROS' AND SORT_BY_LABEL = 0;
SELECT DBLI.IDCODE, IFNULL(DICT.VALUE, IFNULL((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = DBLI.IDNAME AND UPPER(D.LANGUAGE) ='ES'), DBLI.IDNAME)) IDNAME, IFNULL(DICT2.VALUE, IFNULL((SELECT MAX(D2.VALUE) FROM CLX_DICTIONARY D2 WHERE D2.ENTRY = DBLI.IDNAME2 AND LOWER(D2.LANGUAGE) ='es'), DBLI.IDNAME2)) IDNAME2 FROM CLX_DB_LISTS DBLT, CLX_DB_LIST_ITEMS DBLI LEFT JOIN CLX_DICTIONARY DICT ON DICT.ENTRY = DBLI.IDNAME AND LOWER(DICT.LANGUAGE) = 'es' LEFT JOIN CLX_DICTIONARY DICT2 ON DICT2.ENTRY = DBLI.IDNAME2 AND LOWER(DICT2.LANGUAGE) = 'es' WHERE DBLT.IDCODE = DBLI.LISTCODE AND DBLI.INACTIVE = 0 AND DBLI.LISTCODE='PROS'  AND DBLI.IDCODE = 'END' ORDER BY DBLI.SEQNUM ;
SELECT PRSC.NOTIFY_STATUS, PRSC.TOUSER USERNAME, PRSC.SUBJECT, PRSC.MESSAGE, PRSC.CREATE_TASK, PRSC.CREATE_ALERT, PRSC.SEND_EMAIL, ACUS.EMAIL, ACUS.FIRSTNAME, ACUS.LASTNAME FROM CLX_PR_SCHEDULES PRSC, CLX_AC_USERS ACUS WHERE PRSC.IDCODE = 'GLOQ' AND PRSC.TOUSER = ACUS.USERNAME AND PRSC.NOTIFY_STATUS ='END';
UPDATE CLX_PR_PROC_LOGS SET SDATE = '2021-05-06 15:05:19', EDATE = '2021-05-06 15:05:20', PROC_STATUS = 'END', schedulecode = 'GLOQ' WHERE ID='104021';
COMMIT;
commit;
set autocommit = 0;
UPDATE CLX_PR_SCHEDULES  SET PROC_STATUS = 'END' WHERE NEXT_RUN_TIME IS NULL AND ID = 174;
UPDATE CLX_PR_SCHEDULES SET PROC_STATUS ='IDLE' WHERE NEXT_RUN_TIME IS NOT null AND ID = 174;
commit;
UPDATE CLX_PR_SCHEDULES SET BATCH_PID = '3372.16990369671345883' WHERE BATCH_PID = '3372.1699036967134588' AND ID = 179;
commit;
set autocommit = 1;
SELECT * FROM CLX_TOOLS WHERE IDCODE='PRPR';
SELECT * FROM CLX_PR_SCHEDULES WHERE STATUS=1 AND IDCODE IN ('ACTI_ALRT_MON');
UPDATE CLX_PR_SCHEDULES  SET NEXT_RUN_TIME = '2021-05-06 14:54:46'  WHERE IDCODE = 'ACTI_ALRT_MON';
commit;
SELECT ID FROM CLX_PR_PROC_LOGS WHERE PROCESSCODE = 'ACTI_ALRT_MON' AND SCHEDULECODE = 'ACTI_ALRT_MON';
SELECT ID FROM CLX_PR_PROC_LOGS WHERE ID=100931;
SELECT * FROM CLX_PR_EXCEPT_LOGS WHERE LOG_RECID='100931';
SELECT * FROM CLX_PR_STEP_LOGS WHERE LOG_RECID='100931';
DELETE FROM CLX_PR_STEP_LOGS WHERE ID=3052094;
SELECT PRLO.* FROM CLX_PR_SCHEDULES PRSC, CLX_PR_PROC_LOGS PRLO WHERE PRSC.LOG_METHOD = 1 AND PRSC.IDCODE = SCHEDULECODE AND PRLO.SCHEDULECODE = 'ACTI_ALRT_MON' AND PRLO.PROC_STATUS='END' AND PRLO.ID = (SELECT MAX(PRLO2.ID) FROM CLX_PR_PROC_LOGS PRLO2 WHERE PRLO2.SCHEDULECODE = PRLO.SCHEDULECODE);
UPDATE CLX_PR_PROC_LOGS SET  `ID`='100931',  `SCHEDULECODE`='ACTI_ALRT_MON',  `PROCESSCODE`='ACTI_ALRT_MON',  `PROCESS_MSG`='',  `EXECUTEDBY`='system',  `PROC_STATUS`='RUN',  `BATCH_PID`='3372.0',  `SDATE`='2021-05-06 15:05:20',  `EDATE`='2021-05-06 15:05:20' WHERE ID = 100931;
COMMIT;
SELECT COUNT(*) FROM CLX_DB_LISTS WHERE IDCODE = 'PROS' AND SORT_BY_LABEL = 0;
SELECT DBLI.IDCODE, IFNULL(DICT.VALUE, IFNULL((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = DBLI.IDNAME AND UPPER(D.LANGUAGE) ='ES'), DBLI.IDNAME)) IDNAME, IFNULL(DICT2.VALUE, IFNULL((SELECT MAX(D2.VALUE) FROM CLX_DICTIONARY D2 WHERE D2.ENTRY = DBLI.IDNAME2 AND LOWER(D2.LANGUAGE) ='es'), DBLI.IDNAME2)) IDNAME2 FROM CLX_DB_LISTS DBLT, CLX_DB_LIST_ITEMS DBLI LEFT JOIN CLX_DICTIONARY DICT ON DICT.ENTRY = DBLI.IDNAME AND LOWER(DICT.LANGUAGE) = 'es' LEFT JOIN CLX_DICTIONARY DICT2 ON DICT2.ENTRY = DBLI.IDNAME2 AND LOWER(DICT2.LANGUAGE) = 'es' WHERE DBLT.IDCODE = DBLI.LISTCODE AND DBLI.INACTIVE = 0 AND DBLI.LISTCODE='PROS'  AND DBLI.IDCODE = 'RUN' ORDER BY DBLI.SEQNUM ;
SELECT PRSC.NOTIFY_STATUS, PRSC.TOUSER USERNAME, PRSC.SUBJECT, PRSC.MESSAGE, PRSC.CREATE_TASK, PRSC.CREATE_ALERT, PRSC.SEND_EMAIL, ACUS.EMAIL, ACUS.FIRSTNAME, ACUS.LASTNAME FROM CLX_PR_SCHEDULES PRSC, CLX_AC_USERS ACUS WHERE PRSC.IDCODE = 'ACTI_ALRT_MON' AND PRSC.TOUSER = ACUS.USERNAME AND PRSC.NOTIFY_STATUS ='RUN';
UPDATE CLX_PR_PROC_LOGS SET SDATE = '2021-05-06 15:05:20', EDATE = '2021-05-06 15:05:20', PROC_STATUS = 'RUN', schedulecode = 'ACTI_ALRT_MON' WHERE ID='100931';
COMMIT;
SELECT COUNT(*) FROM CLX_DB_LISTS WHERE IDCODE = 'PROS' AND SORT_BY_LABEL = 0;
SELECT DBLI.IDCODE, IFNULL(DICT.VALUE, IFNULL((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = DBLI.IDNAME AND UPPER(D.LANGUAGE) ='ES'), DBLI.IDNAME)) IDNAME, IFNULL(DICT2.VALUE, IFNULL((SELECT MAX(D2.VALUE) FROM CLX_DICTIONARY D2 WHERE D2.ENTRY = DBLI.IDNAME2 AND LOWER(D2.LANGUAGE) ='es'), DBLI.IDNAME2)) IDNAME2 FROM CLX_DB_LISTS DBLT, CLX_DB_LIST_ITEMS DBLI LEFT JOIN CLX_DICTIONARY DICT ON DICT.ENTRY = DBLI.IDNAME AND LOWER(DICT.LANGUAGE) = 'es' LEFT JOIN CLX_DICTIONARY DICT2 ON DICT2.ENTRY = DBLI.IDNAME2 AND LOWER(DICT2.LANGUAGE) = 'es' WHERE DBLT.IDCODE = DBLI.LISTCODE AND DBLI.INACTIVE = 0 AND DBLI.LISTCODE='PROS'  AND DBLI.IDCODE = 'RUN' ORDER BY DBLI.SEQNUM ;
SELECT PRSC.NOTIFY_STATUS, PRSC.TOUSER USERNAME, PRSC.SUBJECT, PRSC.MESSAGE, PRSC.CREATE_TASK, PRSC.CREATE_ALERT, PRSC.SEND_EMAIL, ACUS.EMAIL, ACUS.FIRSTNAME, ACUS.LASTNAME FROM CLX_PR_SCHEDULES PRSC, CLX_AC_USERS ACUS WHERE PRSC.IDCODE = 'ACTI_ALRT_MON' AND PRSC.TOUSER = ACUS.USERNAME AND PRSC.NOTIFY_STATUS ='RUN';
UPDATE CLX_PR_PROC_LOGS SET SDATE = '2021-05-06 15:05:20', EDATE = '2021-05-06 15:05:20', PROC_STATUS = 'RUN', schedulecode = 'ACTI_ALRT_MON' WHERE ID='100931';
COMMIT;
SELECT * FROM CLX_PR_PROCESS WHERE IDCODE='ACTI_ALRT_MON';
SELECT COUNT(*) FROM CLX_PR_SECTIONS WHERE PROCESSCODE='ACTI_ALRT_MON' AND IS_MAINSECTION = 1 AND STATUS = 1;
SELECT * FROM CLX_PR_SCHED_PRMTS WHERE SCHEDULECODE = 'ACTI_ALRT_MON';
SELECT COUNT(*) FROM CLX_DB_LISTS WHERE IDCODE = 'PROS' AND SORT_BY_LABEL = 0;
SELECT DBLI.IDCODE, IFNULL(DICT.VALUE, IFNULL((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = DBLI.IDNAME AND UPPER(D.LANGUAGE) ='ES'), DBLI.IDNAME)) IDNAME, IFNULL(DICT2.VALUE, IFNULL((SELECT MAX(D2.VALUE) FROM CLX_DICTIONARY D2 WHERE D2.ENTRY = DBLI.IDNAME2 AND LOWER(D2.LANGUAGE) ='es'), DBLI.IDNAME2)) IDNAME2 FROM CLX_DB_LISTS DBLT, CLX_DB_LIST_ITEMS DBLI LEFT JOIN CLX_DICTIONARY DICT ON DICT.ENTRY = DBLI.IDNAME AND LOWER(DICT.LANGUAGE) = 'es' LEFT JOIN CLX_DICTIONARY DICT2 ON DICT2.ENTRY = DBLI.IDNAME2 AND LOWER(DICT2.LANGUAGE) = 'es' WHERE DBLT.IDCODE = DBLI.LISTCODE AND DBLI.INACTIVE = 0 AND DBLI.LISTCODE='PROS'  AND DBLI.IDCODE = 'RUN' ORDER BY DBLI.SEQNUM ;
SELECT PRSC.NOTIFY_STATUS, PRSC.TOUSER USERNAME, PRSC.SUBJECT, PRSC.MESSAGE, PRSC.CREATE_TASK, PRSC.CREATE_ALERT, PRSC.SEND_EMAIL, ACUS.EMAIL, ACUS.FIRSTNAME, ACUS.LASTNAME FROM CLX_PR_SCHEDULES PRSC, CLX_AC_USERS ACUS WHERE PRSC.IDCODE = 'ACTI_ALRT_MON' AND PRSC.TOUSER = ACUS.USERNAME AND PRSC.NOTIFY_STATUS ='RUN';
UPDATE CLX_PR_PROC_LOGS SET SDATE = '2021-05-06 15:05:20', EDATE = '2021-05-06 15:05:21', PROC_STATUS = 'RUN', schedulecode = 'ACTI_ALRT_MON' WHERE ID='100931';
COMMIT;
SELECT * FROM CLX_PR_SECTIONS WHERE STATUS = 1 AND PROCESSCODE='ACTI_ALRT_MON' AND IS_MAINSECTION = 1;
SELECT * FROM CLX_PR_SECTIONS WHERE IDCODE='ACTI_ALRT_MO_MA';
SELECT COUNT(*) FROM CLX_DB_LISTS WHERE IDCODE = 'PROS' AND SORT_BY_LABEL = 0;
SELECT DBLI.IDCODE, IFNULL(DICT.VALUE, IFNULL((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = DBLI.IDNAME AND UPPER(D.LANGUAGE) ='ES'), DBLI.IDNAME)) IDNAME, IFNULL(DICT2.VALUE, IFNULL((SELECT MAX(D2.VALUE) FROM CLX_DICTIONARY D2 WHERE D2.ENTRY = DBLI.IDNAME2 AND LOWER(D2.LANGUAGE) ='es'), DBLI.IDNAME2)) IDNAME2 FROM CLX_DB_LISTS DBLT, CLX_DB_LIST_ITEMS DBLI LEFT JOIN CLX_DICTIONARY DICT ON DICT.ENTRY = DBLI.IDNAME AND LOWER(DICT.LANGUAGE) = 'es' LEFT JOIN CLX_DICTIONARY DICT2 ON DICT2.ENTRY = DBLI.IDNAME2 AND LOWER(DICT2.LANGUAGE) = 'es' WHERE DBLT.IDCODE = DBLI.LISTCODE AND DBLI.INACTIVE = 0 AND DBLI.LISTCODE='PROS'  AND DBLI.IDCODE = 'RUN' ORDER BY DBLI.SEQNUM ;
SELECT PRSC.NOTIFY_STATUS, PRSC.TOUSER USERNAME, PRSC.SUBJECT, PRSC.MESSAGE, PRSC.CREATE_TASK, PRSC.CREATE_ALERT, PRSC.SEND_EMAIL, ACUS.EMAIL, ACUS.FIRSTNAME, ACUS.LASTNAME FROM CLX_PR_SCHEDULES PRSC, CLX_AC_USERS ACUS WHERE PRSC.IDCODE = 'ACTI_ALRT_MON' AND PRSC.TOUSER = ACUS.USERNAME AND PRSC.NOTIFY_STATUS ='RUN';
UPDATE CLX_PR_PROC_LOGS SET SDATE = '2021-05-06 15:05:20', EDATE = '2021-05-06 15:05:21', PROC_STATUS = 'RUN', schedulecode = 'ACTI_ALRT_MON' WHERE ID='100931';
COMMIT;
SELECT * FROM CLX_EVENTS WHERE STATUS = 1 AND OWNERID='ACTI_ALRT_MO_MA' AND OWNERCODE = 'PRSE' ORDER BY SEQNUM;
INSERT INTO CLX_PR_STEP_LOGS ( `LOG_RECID`,  `SEQNUM`,  `CODE_TYPE`,  `CODE_TEXT`,  `DO_SECTION`,  `DO_SECTION_TYPE`,  `STEP_STATUS`,  `STEP_MSG`,  `SECTIONCODE`,  `SDATE`) VALUES ('100931', '1', 'CODE', '$a = new Acti($parameters);
$a->acti_reminder();
unset($a);', '', 'NOT', 'RUN', 'Proceso<br>Estado ACTI_ALRT_MON<br>Proceso Iniciado:2021-05-06 15:05:20<br>Parámetros<br><ul><li>PROCESSCODE: ACTI_ALRT_MON</li><li>RUNID: 100931</li><li>USERNAME: system</li><li>START_TIME: 2021-05-06 15:05:20</li><li>SCHEDULECODE: ACTI_ALRT_MON</li><li>CURRENT_TIME: 2021-05-06 03:05:21</li></ul><br>Sección ACTI_ALRT_MO_MA Iniciada<br>', 'ACTI_ALRT_MO_MA', '2021-05-06 15:05:21') ;
commit;
SELECT COUNT(*) FROM CLX_DB_LISTS WHERE IDCODE = 'PROS' AND SORT_BY_LABEL = 0;
SELECT DBLI.IDCODE, IFNULL(DICT.VALUE, IFNULL((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = DBLI.IDNAME AND UPPER(D.LANGUAGE) ='ES'), DBLI.IDNAME)) IDNAME, IFNULL(DICT2.VALUE, IFNULL((SELECT MAX(D2.VALUE) FROM CLX_DICTIONARY D2 WHERE D2.ENTRY = DBLI.IDNAME2 AND LOWER(D2.LANGUAGE) ='es'), DBLI.IDNAME2)) IDNAME2 FROM CLX_DB_LISTS DBLT, CLX_DB_LIST_ITEMS DBLI LEFT JOIN CLX_DICTIONARY DICT ON DICT.ENTRY = DBLI.IDNAME AND LOWER(DICT.LANGUAGE) = 'es' LEFT JOIN CLX_DICTIONARY DICT2 ON DICT2.ENTRY = DBLI.IDNAME2 AND LOWER(DICT2.LANGUAGE) = 'es' WHERE DBLT.IDCODE = DBLI.LISTCODE AND DBLI.INACTIVE = 0 AND DBLI.LISTCODE='PROS'  AND DBLI.IDCODE = 'RUN' ORDER BY DBLI.SEQNUM ;
SELECT PRSC.NOTIFY_STATUS, PRSC.TOUSER USERNAME, PRSC.SUBJECT, PRSC.MESSAGE, PRSC.CREATE_TASK, PRSC.CREATE_ALERT, PRSC.SEND_EMAIL, ACUS.EMAIL, ACUS.FIRSTNAME, ACUS.LASTNAME FROM CLX_PR_SCHEDULES PRSC, CLX_AC_USERS ACUS WHERE PRSC.IDCODE = 'ACTI_ALRT_MON' AND PRSC.TOUSER = ACUS.USERNAME AND PRSC.NOTIFY_STATUS ='RUN';
UPDATE CLX_PR_PROC_LOGS SET SDATE = '2021-05-06 15:05:20', EDATE = '2021-05-06 15:05:21', PROC_STATUS = 'RUN', schedulecode = 'ACTI_ALRT_MON' WHERE ID='100931';
COMMIT;
SELECT * FROM CLX_EVENTS WHERE ID=8568;
SELECT * FROM CLX_CODELIB WHERE UPPER(IDCODE)='ACTI';
SELECT IDCODE, MODULECODE, IDNAME FROM CLX_DB_TABLES WHERE IDCODE IN ('ACTI','OPPO','ACTH','PROD','SRER','SRRP','ACCO','SLAP','SLAA','SRAP','SRAA','SRRQ');
UPDATE CRM_ACTIVITIES  SET LAST_REMINDER = '2021-05-06 15:05:21' WHERE (CREATE_ALERT = 1 OR SEND_EMAIL = 1) AND REMINDER IS NOT null AND LAST_REMINDER IS NULL AND REMINDER<=now() AND ACTIVITY_STATUS IN ('N','I','W');
SELECT DISTINCT ACTI.ID, ACTI.IDNAME, ACTI.DESCRIPTION, ACTI.REMINDER_REL, ACTI.REMINDER, ACTI.LAST_REMINDER, ACTI.ASSIGNEDTO_USER, ACTI.ACTIVITY_STATUS, ACTI.START_DTTM, ACTI.DUEDATE, ACTI.COMPLETE_DATE, ACTI.PERCENT_COMPLETE, ACTI.PRIORITY, ACTI.OWNERCODE, ACTI.CREATE_ALERT, ACTI.SEND_EMAIL FROM CRM_ACTIVITIES ACTI WHERE ACTI.LAST_REMINDER = '2021-05-06 15:05:21';
SELECT COUNT(*) FROM CLX_DB_LISTS WHERE IDCODE = 'PROS' AND SORT_BY_LABEL = 0;
SELECT DBLI.IDCODE, IFNULL(DICT.VALUE, IFNULL((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = DBLI.IDNAME AND UPPER(D.LANGUAGE) ='ES'), DBLI.IDNAME)) IDNAME, IFNULL(DICT2.VALUE, IFNULL((SELECT MAX(D2.VALUE) FROM CLX_DICTIONARY D2 WHERE D2.ENTRY = DBLI.IDNAME2 AND LOWER(D2.LANGUAGE) ='es'), DBLI.IDNAME2)) IDNAME2 FROM CLX_DB_LISTS DBLT, CLX_DB_LIST_ITEMS DBLI LEFT JOIN CLX_DICTIONARY DICT ON DICT.ENTRY = DBLI.IDNAME AND LOWER(DICT.LANGUAGE) = 'es' LEFT JOIN CLX_DICTIONARY DICT2 ON DICT2.ENTRY = DBLI.IDNAME2 AND LOWER(DICT2.LANGUAGE) = 'es' WHERE DBLT.IDCODE = DBLI.LISTCODE AND DBLI.INACTIVE = 0 AND DBLI.LISTCODE='PROS'  AND DBLI.IDCODE = 'RUN' ORDER BY DBLI.SEQNUM ;
SELECT PRSC.NOTIFY_STATUS, PRSC.TOUSER USERNAME, PRSC.SUBJECT, PRSC.MESSAGE, PRSC.CREATE_TASK, PRSC.CREATE_ALERT, PRSC.SEND_EMAIL, ACUS.EMAIL, ACUS.FIRSTNAME, ACUS.LASTNAME FROM CLX_PR_SCHEDULES PRSC, CLX_AC_USERS ACUS WHERE PRSC.IDCODE = 'ACTI_ALRT_MON' AND PRSC.TOUSER = ACUS.USERNAME AND PRSC.NOTIFY_STATUS ='RUN';
UPDATE CLX_PR_PROC_LOGS SET SDATE = '2021-05-06 15:05:20', EDATE = '2021-05-06 15:05:21', PROC_STATUS = 'RUN', schedulecode = 'ACTI_ALRT_MON' WHERE ID='100931';
COMMIT;
UPDATE CLX_PR_STEP_LOGS SET  `EDATE`='2021-05-06 15:05:22',  `PARAMETERS_OUT`='<ul><li>PROCESSCODE: ACTI_ALRT_MON</li><li>RUNID: 100931</li><li>USERNAME: system</li><li>START_TIME: 2021-05-06 15:05:20</li><li>SCHEDULECODE: ACTI_ALRT_MON</li><li>CURRENT_TIME: 2021-05-06 03:05:21</li></ul>',  `STEP_STATUS`='END',  `STEP_MSG`='Paso Iniciado. Número de Secuencia: 1, Tipo: CODE,Ejecutar Sección (Tipo):NOT<br>Salida<br>' WHERE ID=3052098;
SELECT COUNT(*) FROM CLX_PR_EXCEPT_LOGS WHERE SCHEDULECODE = 'ACTI_ALRT_MON' AND LOG_RECID = '100931';
SELECT COUNT(*) FROM CLX_DB_LISTS WHERE IDCODE = 'PROS' AND SORT_BY_LABEL = 0;
SELECT DBLI.IDCODE, IFNULL(DICT.VALUE, IFNULL((SELECT MAX(D.VALUE) FROM CLX_DICTIONARY D WHERE D.ENTRY = DBLI.IDNAME AND UPPER(D.LANGUAGE) ='ES'), DBLI.IDNAME)) IDNAME, IFNULL(DICT2.VALUE, IFNULL((SELECT MAX(D2.VALUE) FROM CLX_DICTIONARY D2 WHERE D2.ENTRY = DBLI.IDNAME2 AND LOWER(D2.LANGUAGE) ='es'), DBLI.IDNAME2)) IDNAME2 FROM CLX_DB_LISTS DBLT, CLX_DB_LIST_ITEMS DBLI LEFT JOIN CLX_DICTIONARY DICT ON DICT.ENTRY = DBLI.IDNAME AND LOWER(DICT.LANGUAGE) = 'es' LEFT JOIN CLX_DICTIONARY DICT2 ON DICT2.ENTRY = DBLI.IDNAME2 AND LOWER(DICT2.LANGUAGE) = 'es' WHERE DBLT.IDCODE = DBLI.LISTCODE AND DBLI.INACTIVE = 0 AND DBLI.LISTCODE='PROS'  AND DBLI.IDCODE = 'END' ORDER BY DBLI.SEQNUM ;
SELECT PRSC.NOTIFY_STATUS, PRSC.TOUSER USERNAME, PRSC.SUBJECT, PRSC.MESSAGE, PRSC.CREATE_TASK, PRSC.CREATE_ALERT, PRSC.SEND_EMAIL, ACUS.EMAIL, ACUS.FIRSTNAME, ACUS.LASTNAME FROM CLX_PR_SCHEDULES PRSC, CLX_AC_USERS ACUS WHERE PRSC.IDCODE = 'ACTI_ALRT_MON' AND PRSC.TOUSER = ACUS.USERNAME AND PRSC.NOTIFY_STATUS ='END';
UPDATE CLX_PR_PROC_LOGS SET SDATE = '2021-05-06 15:05:20', EDATE = '2021-05-06 15:05:22', PROC_STATUS = 'END', schedulecode = 'ACTI_ALRT_MON' WHERE ID='100931';
COMMIT;
commit;
set autocommit = 0;
UPDATE CLX_PR_SCHEDULES  SET PROC_STATUS = 'END' WHERE NEXT_RUN_TIME IS NULL AND ID = 179;
UPDATE CLX_PR_SCHEDULES SET PROC_STATUS ='IDLE' WHERE NEXT_RUN_TIME IS NOT null AND ID = 179;
commit;
commit;
commit;
UPDATE CLX_MA_MAILS  SET MESSAGEID = '1620327922030433500 ', EMAIL_STATUS = 'PRO'  WHERE FOLDER = 'OUBX'  AND EMAIL_DIRECTION = 'OUT'  AND EMAIL_STATUS = 'QUEUE';
commit;
SELECT COUNT(*) FROM CLX_MA_MAILS WHERE MESSAGEID = '1620327922030433500 ' AND EMAIL_STATUS = 'PRO';
SELECT ID FROM CLX_MA_MAILS WHERE MESSAGEID = '1620327922030433500 ' AND EMAIL_STATUS = 'PRO';
SELECT COUNT(*) FROM CLX_MA_MAILS WHERE MESSAGEID = '1620327922030433500 ' AND EMAIL_STATUS = 'ERR';
