<?php

/**
* Tool Class
* For more information contact  support@alenet.com
*
* @author	   $Author: alenetdev $
* @copyright	Alenet, Inc.
* @since		$Date: 2019-03-19 17:29:16 -0400 (ma., 19 mar. 2019) $
* @version		$Rev: 10577 $
*
* CHANGE LOG
*  Oracle uppercase record changed
*  Included label
*/
if (!defined('READ_EXCEL_TOOL') or READ_EXCEL_TOOL==1)
	define('kPathToSimpleExcel', kPathToWebSite.'/'.'../extlibs/php/simple Excel/');
else
	define('kPathToSimpleExcel', kPathToWebSite.'/'.'../extlibs/php/PHPExcel/');
define('kPathJquery_1_11_4', '../extlibs/js/jquery-ui-1.11.4/');
class db_import extends clx_tool {

	var $import_types;
	var $import_typesnormal;
	var $import_excel_types;
	var $importForm;
	var $idcode;
	var $if_duplicates;
	var $excel_count_sheets;
	var $record_commit_counter = CLX_NUM_FIVE;
	private $formula_file = '';
	// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - BEGIN
	var $use_record_delimiter_reading_fixlen_files = false; // flag to use record delimiter instead of record length reading fixed length files
	// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - END

	function __construct() {

		$this->code = 'DBIM';
		$this->name = 'Import Manager';
		$this->system = 'Database';
		$this->version = '0.5.1.0';
		
		$this->has_access = true;
		$this->has_package = true;

		$this->tablename = 'CLX_DB_IMPORTS';
		$this->record_name_singular = 'import';
		$this->record_name_plural = 'imports';
		$this->primary_field = 'IDCODE';
		$this->secondary_field = 'IDNAME';

		$this->if_duplicates = array('0' => 'GEN_LBL_IGNORE', '1' => 'GEN_LBL_REPLACE');
		$this->if_UTF8 = array('0' => 'GEN_LBL_IGNORE', '1' => 'GEN_LBL_REPLACE');
		$this->filedate_inc_date = array('0' => 'GEN_LBL_IGNORE', '1' => 'GEN_LBL_INCLUDE');
		$this->excel_count_sheets = array('0' => 'GEN_LBL_SHEET_SELECT', '1' => 'GEN_LBL_ALL_SHEETS');
		$this->import_typesnormal=array('CSV' => 'GEN_LBL_DELIMITED_FIELDS', 'FRL' => 'GEN_LBL_FRL','XLS' => 'GEN_LBL_XLS');
		IF (kDatabaseType=='oci') {
			$this->import_types = array('CSV' => 'GEN_LBL_DELIMITED_FIELDS', 'CSV2' => 'GEN_LBL_DELIMITED_FIELDS_BULK', 'FRL' => 'GEN_LBL_FRL','FRL2' => 'GEN_LBL_FRL2','FRL3' => 'GEN_LBL_FRL3','XLS' => 'GEN_LBL_XLS','XLS2' => 'GEN_LBL_XLS2');
		}
		else {
			$this->import_types = $this->import_typesnormal ;

		}
		$this->GROUP_PRIORITY= array('1' => 'PRIORITY_OR_GROUP1', '2' => 'PRIORITY_OR_GROUP2', '3' => 'PRIORITY_OR_GROUP3');
		$this->GROUP_PRIORITY2=array('0'=>'71BE2318385D6DD0F002F576952AAD70', '1' => 'PRIORITY_OR_GROUP1', '2' => 'PRIORITY_OR_GROUP2', '3' => 'PRIORITY_OR_GROUP3');


		$this->import_excel_types = array('xls' => 'GEN_LBL_XLS_2', 'xlsx' => 'GEN_LBL_XLS_1','ods' => 'GEN_LBL_ODS');

		$this->filedate_ch_value_date=getlistbycode('CDAE');
		$this->import_extra_fields_required = '';// companyParameterDef('IMPORT_EXTRA_FIELDS_REQUIRED', 'DBIM', $_SESSION['prefs']['UIFF_COMP_CODE']);
		$optioncsv=array(
					'caption' => 'GEN_LBL_FILE_PROPERTIES',
					'type' => 'dynamic',
					'code' => 'CSV',
					'entries' => array(
						array(
							'label' => 'GEN_LBL_FIELD_DELIM',
							'fields' => array(
								array('name' => 'field_delim[0]', 'type' => 'checkbox', 'value' => '[9]', CLX_CLASS_PROMPT => 'GEN_LBL_TAB'),
								array('name' => 'field_delim[1]', 'type' => 'checkbox', 'value' => ',', CLX_CLASS_PROMPT => 'GEN_LBL_COMMA'),
								array('name' => 'field_delim[2]', 'type' => 'checkbox', 'value' => ';', CLX_CLASS_PROMPT => 'GEN_LBL_SEMICOLON'),
								array('name' => 'field_delim[3]', 'type' => 'checkbox', 'value' => '[32]', CLX_CLASS_PROMPT => 'GEN_LBL_SPACE'),
								array('name' => 'field_delim[4]', 'type' => 'checkbox', 'value' => 'other', CLX_CLASS_PROMPT => 'GEN_LBL_OTHER'),
								array('name' => 'field_cdelim[4]', 'type' => 'string', 'default' => '', 'size' => '10', 'displaysize' => '5'),
								array('name' => 'field_delim[5]', 'type' => 'checkbox', 'value' => 'other', CLX_CLASS_PROMPT => 'GEN_LBL_OTHER2'),
								array('name' => 'field_cdelim[5]', 'type' => 'string', 'default' => '', 'size' => '10', 'displaysize' => '5'),
								array('name' => 'field_delim[6]', 'type' => 'checkbox', 'value' => 'other', CLX_CLASS_PROMPT => 'GEN_LBL_OTHER3'),
								array('name' => 'field_cdelim[6]', 'type' => 'string', 'default' => '', 'size' => '10', 'displaysize' => '5','sufix_extra'=>"<br>"),
								array('name' => 'field_delim[7]', 'type' => 'checkbox', 'value' => 'Expresion', CLX_CLASS_PROMPT => 'GEN_LBL_EXPRESION'),
								array('name' => 'field_cdelim[7]', 'type' => 'text', 'default' => '', 'cols' => '80', 'rows' => '4','sufix_extra'=>"<br>"),

							),

						),
						array(
							'label' => 'GEN_LBL_RECORD_DELIM',
							'fields' => array(
								array('name' => 'record_delim', 'type' => 'radiobutton', 'value' => '[13]', CLX_CLASS_PROMPT => 'GEN_LBL_CARRIAGE_RETURN'),
								array('name' => 'record_delim', 'type' => 'radiobutton', 'value' => '[10]', CLX_CLASS_PROMPT => 'GEN_LBL_LINE_FEED'),
								array('name' => 'record_delim', 'type' => 'radiobutton', 'value' => '[13][10]', CLX_CLASS_PROMPT => 'GEN_LBL_CRLF'),
								array('name' => 'record_delim', 'type' => 'radiobutton', 'value' => 'other', CLX_CLASS_PROMPT => 'GEN_LBL_OTHER'),
								array('name' => 'record_delim_other', 'type' => 'string',  'size' => '24', 'displaysize' => '24')
							)
						)/*,
						array(
							'label' => 'GEN_LBL_RECORD_DELETE',
							'fields' => array(
								array('name' => 'record_text[0]', 'type' => 'checkbox', 'value' => '[13]', CLX_CLASS_PROMPT => 'GEN_LBL_RECORD_INIT_TEXT'),

								array('name' => 'record_ctext[0]', 'type' => 'string', 'default' => '', 'size' => '15', 'displaysize' => '8'),
								array('name' => 'record_text[1]', 'type' => 'checkbox', 'value' => '[13]', CLX_CLASS_PROMPT => 'GEN_LBL_RECORD_END_TEXT'),
								array('name' => 'record_ctext[1]', 'type' => 'string', 'default' => '', 'size' => '15', 'displaysize' => '8'),
								array('name' => 'record_text[2]', 'type' => 'checkbox', 'value' => '[13]', CLX_CLASS_PROMPT => 'GEN_LBL_RECORD_WITH_TEXT'),
								array('name' => 'record_ctext[2]', 'type' => 'string', 'default' => '', 'size' => '15', 'displaysize' => '8','sufix_extra'=>"<br>"),
								array('name' => 'record_text[3]', 'type' => 'checkbox', 'value' => '[13]', CLX_CLASS_PROMPT => 'GEN_LBL_RECORD_TEXT_MIN'),
								array('name' => 'record_ctext[3]', 'type' => 'string', 'default' => '', 'size' => '7', 'displaysize' => '3'),
								array('name' => 'record_text[4]', 'type' => 'checkbox', 'value' => '[13]', CLX_CLASS_PROMPT => 'GEN_LBL_RECORD_TEXT_MAX'),
								array('name' => 'record_ctext[4]', 'type' => 'string', 'default' => '', 'size' => '7', 'displaysize' => '3'),
								array('name' => 'record_text[5]', 'type' => 'checkbox', 'value' => '[13]', CLX_CLASS_PROMPT => 'GEN_LBL_DEL_NEXT_HEADER'),
								array('name' => 'record_text[6]', 'type' => 'checkbox', 'value' => '[13]', CLX_CLASS_PROMPT => 'GEN_LBL_RECORD_SPACE')
							)
						)*/,
						array(
							'label' => 'GEN_LBL_DATA_PROPERTY',
							'fields' => array(
								array('name' => 'record_prop[0]', 'type' => 'checkbox', 'value' => '1', CLX_CLASS_PROMPT => 'GEN_LBL_RECORD_POS1_HEADER'),
									array('name' => 'record_cprop[0]', 'type' => CLX_CLASS_LIST, 'default' => '1',
										'options' => array("0"=>"0",1=>"1",2=>"2",3=>"3",4=>"4",5=>"5",6=>"6",7=>"7",8=>"8",9=>"9",
										10=>"10",11=>"11",12=>"12",13=>"13",14=>"14",15=>"15",16=>"16",17=>"17",
										18=>"18",19=>"19",20=>"20",21=>"21",22=>"22",23=>"23",24=>"24")
									),
								array('name' => 'record_prop[1]', 'type' => 'checkbox', 'value' => '1', CLX_CLASS_PROMPT => 'GEN_LBL_RECORD_POS2_HEADER'),
									array('name' => 'record_cprop[1]', 'type' => CLX_CLASS_LIST, 'default' => '1',
										'options' => array("0"=>"0",1=>"1",2=>"2",3=>"3",4=>"4",5=>"5",6=>"6",7=>"7",8=>"8",9=>"9",
										10=>"10",11=>"11",12=>"12",13=>"13",14=>"14",15=>"15",16=>"16",17=>"17",
										18=>"18",19=>"19",20=>"20",21=>"21",22=>"22",23=>"23",24=>"24"),'sufix_extra'=>"<br>"
									),
								array('name' => 'record_prop[3]', 'type' => 'checkbox', 'value' => '', CLX_CLASS_PROMPT => 'GEN_LBL_RECORD_HEADER_INIT'),
								array('name' => 'record_cprop[3]', 'type' => 'string', 'default' => '', 'size' => '15', 'displaysize' => '8')//,

								/*array('name' => 'record_prop[2]', 'type' => 'checkbox', 'value' => '[13]', CLX_CLASS_PROMPT => 'GEN_LBL_RECORD_LINE_DATA'),
								array('name' => 'record_cprop[2]', 'type' => CLX_CLASS_LIST, 'default' => '0',
										'options' => array(0=>1,1=>2,2=>3)
									)*/
							)

						),
						array(
							'label' => 'GEN_LBL_FILE',
							'fields' => array(
											array('name' => 'file', 'type' => 'file', 'default' => '','sufix_extra'=>'|file|', 'prefix_extra'=>'<table ><tr id="mensajy1"><td colspan="2" rowspan="1" class="alert" valign="top" id="mensajx1"></td></tr></table>')
										//	,		array('name' => 'remapping_field', 'type' => 'checkbox', 'value' => '1', CLX_CLASS_PROMPT => 'GEN_LBL_REMAPPING_FIELDS')
										)
						)
					)

				);
				$optioncsv2=$optioncsv;
				$optioncsv2['code'] = 'CSV2';
				$optioncsv2['entries'] = $optioncsv['entries'];
				$optionfrl=		array(
					'caption' => 'GEN_LBL_FILE_PROPERTIES',
					'type' => 'dynamic',
					'code' => 'FRL',
					'entries' => array(
// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - BEGIN
						array(
							'label' => 'GEN_LBL_RECORD_DELIM',
							'fields' => array(
								array('name' => 'record_delim_frl', 'type' => 'radiobutton', 'value' => '[13]', CLX_CLASS_PROMPT => 'GEN_LBL_CARRIAGE_RETURN'),
								array('name' => 'record_delim_frl', 'type' => 'radiobutton', 'value' => '[10]', CLX_CLASS_PROMPT => 'GEN_LBL_LINE_FEED'),
								array('name' => 'record_delim_frl', 'type' => 'radiobutton', 'value' => '[13][10]', CLX_CLASS_PROMPT => 'GEN_LBL_CRLF'),
								array('name' => 'record_delim_frl', 'type' => 'radiobutton', 'value' => 'other', CLX_CLASS_PROMPT => 'GEN_LBL_OTHER'),
								array('name' => 'record_delim_other_frl', 'type' => 'string', 'default' => '', 'size' => '24', 'displaysize' => '24')
							)
						),
// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - END

						array(
							'label' => 'GEN_LBL_RECORD_LENGTH',
							'fields' => array(
								array('name' => 'record_length', 'type' => 'string', 'default' => '512', 'size' => '32', 'displaysize' => '16', 'sufix' => 'GEN_LBL_CHARACTERS',
									'validations' => array(
										array('type' => 'integer', 'required' => '0')
									)
								)
							)
						),

				/*		array(
							'label' => 'GEN_LBL_DATA_PROPERTY',
							'fields' => array(
									array('readonly'=>true,'name' => 'record_prop[4]', 'type' => 'checkbox', 'value' => '1', CLX_CLASS_PROMPT => 'GEN_LBL_RECORD_POS1_HEADER'),
										array('name' => 'record_cprop[4]', 'type' => CLX_CLASS_LIST, 'default' => '0',
											'options' => array(1=>"1",2=>"2",3=>"3",4=>"4",5=>"5",6=>"6",7=>"7",8=>"8",9=>"9",
											10=>"10",11=>"11",12=>"12",13=>"13",14=>"14",15=>"15",16=>"16",17=>"17",
											18=>"18",19=>"19",20=>"20",21=>"21",22=>"22",23=>"23",24=>"24")
										),
									array('readonly'=>true,'name' => 'record_prop[5]', 'type' => 'checkbox', 'value' => '1', CLX_CLASS_PROMPT => 'GEN_LBL_RECORD_POS2_HEADER'),
										array('name' => 'record_cprop[5]', 'type' => CLX_CLASS_LIST, 'default' => '0',
											'options' => array(1=>"1",2=>"2",3=>"3",4=>"4",5=>"5",6=>"6",7=>"7",8=>"8",9=>"9",
											10=>"10",11=>"11",12=>"12",13=>"13",14=>"14",15=>"15",16=>"16",17=>"17",
											18=>"18",19=>"19",20=>"20",21=>"21",22=>"22",23=>"23",24=>"24"),'sufix_extra'=>"<br>"
										),
									array('readonly'=>true,'name' => 'record_prop[6]', 'type' => 'checkbox', 'value' => '', CLX_CLASS_PROMPT => 'GEN_LBL_RECORD_HEADER_INIT'),
									array('readonly'=>true,'name' => 'record_cprop[6]', 'type' => 'string', 'default' => '', 'size' => '15', 'displaysize' => '8'),

									array('readonly'=>true,'name' => 'record_prop[7]', 'type' => 'checkbox', 'value' => '', CLX_CLASS_PROMPT => 'GEN_LBL_RECORD_LINE_DATA'),
									array('readonly'=>true,'name' => 'record_cprop[7]', 'type' => CLX_CLASS_LIST, 'default' => '0',
										'options' => array(0=>1,1=>2,2=>3)
									)
							)

						),*/
						array(
							'label' => 'GEN_LBL_FILE',
							'fields' => array(
											array('name' => 'filefixed', 'type' => 'file', 'default' => '','sufix_extra'=>'|filefixed|', 'prefix_extra'=>'<table ><tr id="mensajy2"><td colspan="2" rowspan="1" class="alert" valign="top" id="mensajx2"></td></tr></table>')
										)
						)
					)
				);
				$optionfrl2=$optionfrl;
				$optionfrl2['code'] = 'FRL2';
				$optionfrl3=$optionfrl;
				$optionfrl3['code'] = 'FRL3';
//		Campos Basicos de Importacion, para uso masivo. Caso Ficosha
		$this->editform = array(
			CLX_CLASS_TITLE => 'TOOL_DBIM_TITLE_CREATE',
			'panels' => array(
				array(
					'type' => 'normal',
					'entries' => array(
						array(
							'label' => 'GEN_LBL_CODE',
							'fields' => array(
								array('name' => 'idcode', 'type' => 'string', 'default' => '', 'size' => '16', 'displaysize' => '16', 'dontmodify' => '1',
									'validations' => array(
										array('type' => 'sqlobject', 'required' => '1'),
										array('type' => 'unique', 'fieldname' => 'idcode', 'tablename' => $this->tablename)
									)
								)
							)
						),
						array(
							'label' => 'GEN_LBL_NAME',
							'fields' => array(
								array('name' => 'idname', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '48',
									'validations' => array(
										array('type' => 'string', 'required' => '1')
									)
								)
							)
						),
						array(
							'label' => 'GEN_LBL_VERSION',
							'fields' => array(
								array('name' => 'version', 'type' => 'string', 'default' => '1.0.0', 'size' => '32', 'displaysize' => '16',
									'validations' => array(
										array('type' => 'string', 'required' => '1')
									)
								)
							)
						),
						array(
							'label' => 'GEN_LBL_DESCRIPTION',
							'fields' => array(
								array('name' => 'description', 'type' => 'text', 'default' => '', 'cols' => '48', 'rows' => '4')
							)
						),
						array(
							'label' => 'GEN_LBL_MODULECODE',
							'fields' => array(
								array('name' => 'modulecode', 'type' => 'lookup', 'default' => '', 'tool' => 'DBMO',
									'validations' => array(
										array('type' => 'sqlobject', 'required' => '1'),
										array('type' => 'lookup', 'fieldname' => 'idcode', 'tablename' => 'CLX_DB_MODULES')
									)
								)
							)
						),
						array(
							'label' => 'GEN_LBL_TABLECODE',
							'fields' => array(
								array('name' => 'tablecode', 'type' => 'lookup', 'default' => '', 'tool' => 'DBTB',
									'validations' => array(
										array('type' => 'sqlobject', 'required' => '0'),
										array('type' => 'lookup', 'fieldname' => 'idcode', 'tablename' => 'CLX_DB_TABLES')
									)
								)
							)
						),
						array(
							'label' => 'GEN_LBL_GROUP_PRIORITY',
							'fields' => array(
								array('name' => 'execute_priority', 'type' => CLX_CLASS_LIST, 'default' => '1',
									'options' => $this->GROUP_PRIORITY
								)
							)
						),
						/*array(
							'label' => 'GEN_LBL_NEWTABLECODE',
							'fields' => array(
								array('name' => 'newtablecode', 'type' => 'checkbox', 'value' => '1', CLX_CLASS_PROMPT => 'GEN_3_TABLE')
							)

						),
						*/


						array(
							'label' => 'GEN_LBL_IF_DUPLICATES',
							'fields' => array(
								array('name' => 'if_duplicates', 'type' => CLX_CLASS_LIST, 'default' => '0',
									'options' => $this->if_duplicates
								)
							)
						),
						array(
							'label' => 'GEN_LBL_TYPE',
							'fields' => array(
								array('name' => 'type', 'type' => 'dynamic',
									'panels' => 									 (kDatabaseType=='oci') ? $this->import_types :	$this->import_typesnormal

								)
							),
							'fulloptions'=>$this->import_types
				),
				array(
							'label' => 'GEN_LBL_UTF8',
							'fields' => array(
								array('name' => 'IF_UTF8', 'type' => CLX_CLASS_LIST, 'default' => '0',
									'options' => $this->if_UTF8
								)
							)
						)
					)
				),
					$optioncsv
			 //   ,
			//		$optioncsv2
				,
					$optionfrl
			//	,
			//		$optionfrl2

			//	,
			//		$optionfrl3
				,
				array(
					'caption' => 'GEN_LBL_FILE_PROPERTIES',
					'type' => 'dynamic',
					'code' => 'XLS',
					'entries' => array(
									array(
										'label' => 'GEN_LBL_EXCEL_TYPE',
										'fields' => array(

											array('name' => 'excel_type', 'type' => CLX_CLASS_LIST, 'default' => '0',
											'options' => $this->import_excel_types
											)
										)
									),

									array(
										'label' => 'GEN_LBL_COUNT_SHEETS',
										'fields' => array(
											array('name' => 'excel_count_sheets', 'type' => CLX_CLASS_LIST, 'default' => '0',
												'options' => $this->excel_count_sheets
											)
										)
									),

					array(
						'label' => 'GEN_LBL_DATA_PROPERTY',
						'fields' => array(
								array('name' => 'record_prop[8]', 'type' => 'checkbox', 'value' => '1', CLX_CLASS_PROMPT => 'GEN_LBL_RECORD_POS1_HEADER'),
									array('name' => 'record_cprop[8]', 'type' => CLX_CLASS_LIST, 'default' => '0',
										'options' => array("0"=>"0",1=>"1",2=>"2",3=>"3",4=>"4",5=>"5",6=>"6",7=>"7",8=>"8",9=>"9",
										10=>"10",11=>"11",12=>"12",13=>"13",14=>"14",15=>"15",16=>"16",17=>"17",
										18=>"18",19=>"19",20=>"20",21=>"21",22=>"22",23=>"23",24=>"24")
									),
								array('name' => 'record_prop[9]', 'type' => 'checkbox', 'value' => '1', CLX_CLASS_PROMPT => 'GEN_LBL_RECORD_POS2_HEADER'),
									array('name' => 'record_cprop[9]', 'type' => CLX_CLASS_LIST, 'default' => '0',
										'options' => array("0"=>"0",1=>"1",2=>"2",3=>"3",4=>"4",5=>"5",6=>"6",7=>"7",8=>"8",9=>"9",
										10=>"10",11=>"11",12=>"12",13=>"13",14=>"14",15=>"15",16=>"16",17=>"17",
										18=>"18",19=>"19",20=>"20",21=>"21",22=>"22",23=>"23",24=>"24")
									)
								)
						),
						array(
							'label' => 'GEN_LBL_FILE',
							'fields' => array(
								array('name' => 'fileexcel', 'type' => 'file', 'default' => '','sufix_extra'=>'|file_excel|', 'prefix_extra'=>'<table ><tr id="mensajy3"><td colspan="2" rowspan="1" class="alert" valign="top" id="mensajx3"></td></tr></table>')
							)
						)
					)
					/*	array(
							'label' => 'GEN_LBL_RECORD_DELETE',
							'fields' => array(
								array('name' => 'record_text[0]', 'type' => 'checkbox', 'value' => '[13]', CLX_CLASS_PROMPT => 'GEN_LBL_RECORD_INIT_TEXT'),
								array('name' => 'record_ctext[0]', 'type' => 'string', 'default' => '', 'size' => '15', 'displaysize' => '8'),
								array('name' => 'record_text[1]', 'type' => 'checkbox', 'value' => '[13]', CLX_CLASS_PROMPT => 'GEN_LBL_RECORD_END_TEXT'),
								array('name' => 'record_ctext[1]', 'type' => 'string', 'default' => '', 'size' => '15', 'displaysize' => '8'),
								array('name' => 'record_text[2]', 'type' => 'checkbox', 'value' => '[13]', CLX_CLASS_PROMPT => 'GEN_LBL_RECORD_WITH_TEXT'),
								array('name' => 'record_ctext[2]', 'type' => 'string', 'default' => '', 'size' => '15', 'displaysize' => '8','sufix_extra'=>"<br>"),
								array('name' => 'record_text[5]', 'type' => 'checkbox', 'value' => '[13]', CLX_CLASS_PROMPT => 'GEN_LBL_RECORD_SPACE')
							)
						),*/

					)
				)

			)
		;

		
		$this->importform = array(
			CLX_CLASS_TITLE => 'TOOL_DBIM_EXECUTE',
			'panels' => array(
				array(
					'type' => 'normal',
					'entries' => array(
						array(
							'label' => 'GEN_LBL_IDCODE',
							'fields' => array(
								array('name' => 'idcode', 'type' => 'string', 'readonly' => '1')
							)
						),
						array(
							'label' => 'GEN_LBL_IDNAME',
							'fields' => array(
								array('name' => 'idname', 'type' => 'string', 'readonly' => '1')
							)
						),
						array(
							'label' => 'GEN_LBL_INFO_MAPP',
							'fields' => array(
								array('name' => 'mapinfo', 'type' => 'string', 'readonly' => '1')
							)
						),
						array(
							'label' => 'GEN_LBL_FILE',
							'fields' => array(
								array('name' => 'file', 'type' => 'file', 'default' => '',
									'validations' => array(
										array('type' => 'string', 'required' => '1')
									), 'prefix_extra'=>'<table ><tr id="mensajy4"><td colspan="2" rowspan="1" class="alert" valign="top" id="mensajx4"></td></tr></table>'
								)
							)
						),
						array(
							'label' => 'GEN_LBL_TEST',
							'fields' => array(
								array('name' => 'test', 'type' => CLX_CLASS_LIST, 'default' => '0', 'options' => array('0' => 'GEN_LBL_NO', '1' => 'GEN_LBL_YES'))
							)
						),
						array(
							'label' => 'GEN_LBL_SAVE_ERRORS',
							'fields' => array(
								array('name' => 'save_errors', 'type' => CLX_CLASS_LIST, 'default' => '0', 'options' => array('0' => 'GEN_LBL_NO', '1' => 'GEN_LBL_YES'))
							)
						),
						array(
							'label' => 'GEN_LBL_SHOW_FILE',
							'fields' => array(
								array('name' => 'show_file', 'type' => CLX_CLASS_LIST, 'default' => '0', 'options' => array('0' => 'GEN_LBL_NO', '1' => 'GEN_LBL_YES'))
							)
						),

					   array(
							'label' => 'GEN_LBL_ERROR_LIMIT',
							'fields' => array(
								array('name' => 'error_limit', 'type' => 'string',
									'validations' => array(
										array('type' => 'number', 'minimum' => '0', 'maximum' => CLX_NUM_TEN_THOUSAND, 'required' => '1')
									)
								)
							)
						),

						array(
							'label' => 'GEN_LBL_FILENAME_INC_DATE',
							'fields' => array(
								array('name' => 'FILENAME_INC_DATE', 'type' => CLX_CLASS_LIST, 'default' => '0',
									'options' => $this->filedate_inc_date
								)
							)
						)
						,array(
							'label' => '1611603111.65',
							'fields' => array(
								array('name' => 'CH_VALUE_DATE', 'type' => CLX_CLASS_LIST, 'default' => '0AADDATE',
									'options' => $this->filedate_ch_value_date
								)
							)
						),
						

						array(
							'label' => 'GEN_LBL_DESCRIPTION',
							'fields' => array(
								array('name' => 'description', 'type' => 'text', 'default' => '', 'cols' => '48', 'rows' => '4')
							)
						)
					)
				)
			)
		);


		$this->quickfilterform = array('panels' => array(
				array('type' => 'normal',
					'entries' => array(
						array('label' => 'GEN_LBL_CODE', 'fields' => array(array('name' => 'idcode', 'type' => 'string', 'default' => '', 'size' => '16', 'displaysize' => '16'))),
						array('label' => 'GEN_LBL_NAME', 'fields' => array(array('name' => 'idname', 'type' => 'string', 'default' => '', 'size' => '64', 'displaysize' => '48'))),
						array('label' => 'GEN_LBL_TYPE', 'fields' => array(array('name' => 'type', 'type' => CLX_CLASS_LIST, 'default' => '', 'options' => array_merge(array(""=>"") ,$this->import_types)))), //,$this->import_typesnormal)))),
						array('label' => 'GEN_LBL_MODULECODE', 'fields' => array(array('name' => 'modulecode', 'type' => 'lookup', 'default' => '', 'readonly' => false, 'tool' => 'DBMO'))),
						array('label' => 'GEN_LBL_TABLECODE', 'fields' => array(array('name' => 'tablecode', 'type' => 'lookup', 'default' => '', 'readonly' => false, 'tool' => 'DBTB'))),						
						array('label' => 'GEN_LBL_GROUP_PRIORITY','fields' => array(array('name' => 'execute_priority', 'type' => CLX_CLASS_LIST, 'default' => '0',	'options' => $this->GROUP_PRIORITY2))),
						array('label' => 'GEN_LBL_MDATE', 'fields' => array(array('name' => 'mdate', 'type' => 'date', 'default' => '', 'readonly' => false, 'tool' => 'DBTB')))

		))));
	//	$GLOBALS['ADDRDEBUGIMPORTREP']='(1)';
		//$GLOBALS['ADDRDEBUGIMPORT']=1;
		$GLOBALS['ADDRDEBUGIMPORTVALID']=0;
		$this->debugValid=false;
		
		IF (!EMPTY($GLOBALS['ADDRDEBUGIMPORTVALID']) && (empty($_SERVER['REMOTE_ADDR']) || $GLOBALS['ADDRDEBUGIMPORTVALID']==$_SERVER['REMOTE_ADDR'])) {
			$GLOBALS['ADDRDEBUGIMPORTVALID']=1;
			$this->debugValid=true;
		}
		$GLOBALS['ADDRDEBUGIMPORT']=0;
		IF (ISSET($_SESSION['ADDRDEBUGIMPORT']) && (empty($_SERVER['REMOTE_ADDR']) || $_SESSION['ADDRDEBUGIMPORT']==$_SERVER['REMOTE_ADDR'])) {
			$this->debug=true;
			$GLOBALS['ADDRDEBUGIMPORT']=1;
		}
		else if ( ISSET($_SESSION['ADDRDEBUGIMPORTREP']) && ($_SESSION['ADDRDEBUGIMPORTREP']==$_SERVER['REMOTE_ADDR'] or $_SESSION['ADDRDEBUGIMPORTREP']=='(1)' )){
			$this->debug=true;
			$this->debugescribir=true;
		}

		

	}

	function install() {if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1627;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		$UIMI = getTool('UIMI');
		$UIMI->add($this->code, 'MENU_TOOLS:MENU_DATABASE:MENU_IMPORTS', 'TOOL', $this->code, 'ac=LIST');
	}
	function duplicateRecord() {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}
		$id_orig=UserRequest::$post[$this->code . '_id'];
		UserRequest::$post[$this->code . '_id'] = CLX_INIT_ZERO;
		$recordid = $this->createRecord_();
		if ($this->debug==true) {echo 'duplicate createrecord import in '.__LINE__;}
		return $recordid;
	}

	function toolTableStructure() {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1628;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		$fields = array();
		$fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
		$fields['IDCODE'] = array('type' => 'varchar(16)', 'null' => 'NO', 'properties' => '');
		$fields['IDNAME'] = array('type' => 'varchar(64)', 'null' => 'NO', 'properties' => '');
		$fields['VERSION'] = array('type' => 'varchar(32)', 'null' => 'NO', 'properties' => '');
		$fields['VERSION_COUNTER'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
		$fields['CDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
		$fields['MDATE'] = array('type' => 'datetime', 'null' => 'YES', 'properties' => '');
		$fields['USERNAME'] = array('type' => 'varchar(30)', 'null' => 'NO', 'properties' => '');
		$fields['DESCRIPTION'] = array('type' => 'mediumtext', 'properties' => '');
		$fields['MODULECODE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
		$fields['TABLECODE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
		$fields['NEWTABLECODE'] = array('type' => 'int(1)', 'null' => 'YES', 'properties' => '');
		$fields['TYPE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
		$fields['FIELD_DELIM'] = array('type' => 'varchar(64)', 'null' => 'YES', 'properties' => '');
		$fields['FIELD_CDELIM'] = array('type' => 'varchar(512)', 'null' => 'YES', 'properties' => '');
		$fields['RECORD_DELIM'] = array('type' => 'varchar(16)', 'null' => 'YES', 'properties' => '');
		$fields['RECORD_PROP'] = array('type' => 'varchar(512)', 'null' => 'YES', 'properties' => '');
		$fields['RECORD_CPROP'] = array('type' => 'varchar(512)', 'null' => 'YES', 'properties' => '');
		$fields['RECORD_LENGTH'] = array('type' => 'int(11) unsigned', 'null' => 'YES', 'properties' => '');
		$fields['IF_DUPLICATES'] = array('type' => 'int(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
		$fields['IF_UTF8'] = array('type' => 'int(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
		$fields['FILE'] =array('type' => 'varchar(64)', 'null' => 'YES', 'properties' => '');
		$fields['FILE_DELIM']=array('type' => 'varchar(64)', 'null' => 'YES', 'properties' => '');
		$fields['FILE_EXCEL']=array('type' => 'varchar(64)', 'null' => 'YES', 'properties' => '');
		$fields['FILE_C'] =array('type' => 'MEDIUMBLOB', 'null' => 'YES', 'properties' => '');
		$fields['FILE_CDELIM']=array('type' => 'MEDIUMBLOB', 'null' => 'YES', 'properties' => '');
		$fields['FILE_CEXCEL']=array('type' => 'MEDIUMBLOB', 'null' => 'YES', 'properties' => '');
		$fields['EXCEL_COUNT_SHEETS'] = array('type' => 'int(1) unsigned', 'null' => 'YES', 'properties' => '', 'default' => CLX_NUM_ZERO);
		$fields['FILENAME_INC_DATE'] =array('type' => 'int(1) unsigned', 'null' => 'YES', 'properties' => '', 'default' => CLX_NUM_ZERO);
		$fields['CH_VALUE_DATE']=array('type' => 'varchar(10)', 'null' => 'YES', 'properties' => '');
		//$fields['EXCEL_TYPE'] = array('type' => 'varchar(4)', 'null' => 'NO', 'properties' => '');
		$fields['EXCEL_TYPE'] = array('type' => 'varchar(4)', 'null' => 'YES', 'properties' => '');
		$fields['LOG_ID'] = array('type' => 'int(11) unsigned', 'null' => 'YES', 'properties' => '', 'default' => CLX_NUM_ZERO);
		$fields['EXECUTE_PRIORITY'] = array('type' => 'int(1) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ONE);
		$indexes = array();
		$ipf = 'CLX' . $this->code;
		$indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
		$indexes[$ipf . '02'] = array('index' => 'UNI', 'fieldname' => 'IDCODE');
		$indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'IDNAME');
		$indexes[$ipf . '04'] = array('index' => 'MUL', 'fieldname' => 'USERNAME');
		$indexes[$ipf . '05'] = array('index' => 'MUL', 'fieldname' => 'MODULECODE');
		$indexes[$ipf . '06'] = array('index' => 'MUL', 'fieldname' => 'TYPE');
		return array('idcode' => $this->code,
			'idname' => $this->name,
			'name' => $this->tablename,
			'type' => 'InnoDB',
			'fields' => $fields,
			'indexes' => $indexes);
	}
	function assignedchecked(&$record) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1601;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		$delim_record=$record["DBIM_field_delim"];
		$record_prop=$record["DBIM_record_prop"];
		$record_cprop=$record["DBIM_record_cprop"];
		foreach ($this->editform as &$x) {
			if (is_Array($x)) {
				foreach ($x as &$x2) {
					if (is_Array($x2)) {
						foreach ($x2 as &$x3) {
							if (is_Array($x3)) {
								foreach ($x3 as &$x4) {
									if (is_array($x4) ) {
										if($x4["label"] == "GEN_LBL_NEWTABLECODE") {
											$x4["fields"][0]["checked"]=isset($record["DBIM_newtablecode"])?1:0;
										}
										if ($x4["label"] =="GEN_LBL_FIELD_DELIM") {
											if (isset($x4["fields"])) {

												for($x5=0;$x5<count($x4["fields"]);$x5++) {

													if (isset($delim_record[$x5]) ) {
														if (strpos(" ".$x4["fields"][$x5]["name"], "field_delim")==1 ) {
															if (!empty($record["DBIM_field_delim"][$x5]))
																$x4["fields"][$x5]["checked"]=true;
														}

													}
													switch ($x4["fields"][$x5]["name"]) {
														case "field_cdelim[4]": $x4["fields"][$x5]["default"]=(empty($record["DBIM_field_cdelim"][4])?'':$record["DBIM_field_cdelim"][4]); break;
														case "field_cdelim[5]": $x4["fields"][$x5]["default"]=(empty($record["DBIM_field_cdelim"][5])?'':$record["DBIM_field_cdelim"][5]); break;
														case "field_cdelim[6]": $x4["fields"][$x5]["default"]=(empty($record["DBIM_field_cdelim"][6])?'':$record["DBIM_field_cdelim"][6]); break;
														case "field_cdelim[7]": $x4["fields"][$x5]["default"]=(empty($record["DBIM_field_cdelim"][7])?'':$record["DBIM_field_cdelim"][7]); break;

													}
												}


											}

										}
										else if($x4["label"] == "GEN_LBL_DATA_PROPERTY") {
											for($x5=0;$x5<count($x4["fields"]);$x5++) {
												if ($x4["fields"][$x5]["type"]=="checkbox") {

													preg_match("/\[\d+\]/", $x4["fields"][$x5]["name"],$matches);
													$matches=preg_replace("/(\[)|(\])/","", $matches[0]);

													if(isset($record["DBIM_record_prop"][$matches])) {
														$x4["fields"][$x5]["checked"]=1;
														$x4["fields"][$x5+1]["default"]=$record["DBIM_record_cprop"][$matches];
													}
												}
											}

										}
									}
								}
							}
						}
					}
				}
			}
		}

	}
	function editForm($ac, $idlist, $record, $msg) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=16129;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		$this->assignedchecked($record);
		if (UserRequest::$request['ac'] === 'MODIFY') {
			$this->editform[CLX_CLASS_TITLE] = 'TOOL_' . $this->code . '_TITLE_MODIFY';
		} else {
			$this->editform[CLX_CLASS_TITLE] = 'TOOL_' . $this->code . '_TITLE_CREATE';
		}
		
		$form = new clx_form($this->code, $this->editform);
		$forma=$form->editForm($ac, $idlist, $record, $msg);
		$forma=str_replace('|file|',empty($record['DBIM_file'])? '':' ('.$record['DBIM_file'].')',$forma);
		$forma=str_replace('|filefixed|',empty($record['DBIM_filefixed'])? '':' ('.$record['DBIM_filefixed'].')',$forma);
		$forma=str_replace('|file_excel|',empty($record['DBIM_fileexcel'])? '':' ('.$record['DBIM_fileexcel'].')',$forma);

		$variables = array('CONTENTS' => '');
		$TYPE=$record['DBIM_type'];
		if ($TYPE=='CSV2') {
			$TYPE='CSV';
		}
		else if ($TYPE=='FRL2'||$TYPE=='FRL3') {
			$TYPE='FRL';
		}
		else if ($TYPE=='XLS2') {
			$TYPE='XLS';
		}
		$optioncheck1=$optioncheck2=$optioncheck3=$optioncheck4='';
		if ($record['DBIM_type']=='CSV2' )
			$optioncheck1='selected';

		if ($record['DBIM_type']=='FRL2' )
			$optioncheck2='selected';

		if ($record['DBIM_type']=='FRL3' )
			$optioncheck3='selected';

		if ($record['DBIM_type']=='XLS2' )
			$optioncheck4='selected';

	
		##print_r($partes);

		$script = setJavaScriptTag('var menj='.singleQuote(dict('GEN_LBL_MENSAGE_FILE_EXTENSION')).';var menj2='.singleQuote(dict('GEN_LBL_MENSAGE_FILE_SIZE')).';var xtype='.singleQuote( $TYPE ).';var Exceltype='.singleQuote( $record['DBIM_excel_type'] ).';'.getJavaScript('DBIM_editform.js', $variables), false);
		return  $forma.$script;
	}
//-- I M P O R T S
	function pack($record) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1630;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		$o = $this->packRecord($record);
		$id = $record['ID'];
		$code = $record['IDCODE'];
		$objs = new XMLObject($this->code . '_OBJECTS');
		$this->packsub($objs, 'DBIF', 'SELECT * FROM CLX_DB_IMPORT_FIELDS WHERE IMPORTCODE=' . singleQuote($code));
		$this->packsub($objs, 'DBIC', 'SELECT * FROM CLX_DB_IMPORT_MAPPINGS WHERE IMPORTCODE=' . singleQuote($code));
		$this->packsub($objs, 'DBIP', 'SELECT * FROM CLX_DB_IMPORT_EXCEPTIONS WHERE IMPORTCODE=' . singleQuote($code));
		//da error al pasar la data al cliente registro repetidos adicionalmente borra las trazas actuales del importador.
		if (defined('DBIM_DISABLE_PACKAGE_EXECUTIONS_ERROR') && DBIM_DISABLE_PACKAGE_EXECUTIONS_ERROR==1) {
			$this->packsub($objs, 'DBIX', 'SELECT * FROM CLX_DB_IMPORT_EXECUTIONS WHERE IMPORTCODE=' . singleQuote($code));
			$this->packsub($objs, 'DBIE', 'SELECT * FROM CLX_DB_IMPORT_ERRORS WHERE IMPORTCODE=' . singleQuote($code));
		}
		$this->packsub($objs, 'EVNT', 'SELECT * FROM CLX_EVENTS WHERE OWNERCODE=' . singleQuote($this->code) . ' AND OWNERID=' . $id . ' ');
		$o->addObject($objs);
		return $o;
	}

	function unpack($parameters) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);} if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1631;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		$parameters = array_values(array_merge(array('package' => null), $parameters));
		list($package) = $parameters;
		$record = $this->unpackRecord($package);
		$importcode = $record['IDCODE'];
		$exists = (ClxCommon::$db->oneExistsRecords($this->tablename, 'IDCODE=' . singleQuote($importcode)));
		if (!empty($exists)) {
			//
			$rec_id = ClxCommon::$db->getField($this->tablename, 'ID', 'IDCODE=' . singleQuote($importcode));
			ClxCommon::$db->deleteRecords('CLX_EVENTS', 'OWNERCODE=' . singleQuote($this->code) . ' AND OWNERID=' . singleQuote($rec_id));
			//
			$mappings = ClxCommon::$db->getRecords('CLX_DB_IMPORT_MAPPINGS', 'IMPORTCODE=' . singleQuote($importcode));
			while (($mapping = ClxCommon::$db->getNextRecord($mappings))) {
				$mappingid = $mapping['ID'];
				ClxCommon::$db->deleteRecords('CLX_DB_IMPORT_TRANSLATIONS', 'MAPID=' . singleQuote($mappingid));
			}
			ClxCommon::$db->deleteRecords('CLX_DB_IMPORT_FIELDS', 'IMPORTCODE=' . singleQuote($importcode));
			ClxCommon::$db->deleteRecords('CLX_DB_IMPORT_MAPPINGS', 'IMPORTCODE=' . singleQuote($importcode));
			ClxCommon::$db->deleteRecords('CLX_DB_IMPORT_EXCEPTIONS', 'IMPORTCODE=' . singleQuote($importcode));

			//da error registro repetido al pasa paquete pero estamps pasando ejecucciones desde alenet adicionalmente borra las trazas actuales
			if (defined('DBIM_DISABLE_PACKAGE_EXECUTIONS_ERROR') && DBIM_DISABLE_PACKAGE_EXECUTIONS_ERROR==1) {
				ClxCommon::$db->deleteRecords('CLX_DB_IMPORT_EXECUTIONS', 'IMPORTCODE=' . singleQuote($importcode));
				ClxCommon::$db->deleteRecords('CLX_DB_IMPORT_ERRORS', 'IMPORTCODE=' . singleQuote($importcode));
			}
			ClxCommon::$db->deleteRecords($this->tablename, 'IDCODE=' . singleQuote($importcode));
		}
		$importid = ClxCommon::$db->createRecord($this->tablename, $record, false);
		if ($this->debug==true) {echo $b='update import in 741';pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}
		$fields = array();
		if ($package->hasSubObject($this->code . '_OBJECTS')) {
			$objs = $package->getObjectXml($this->code . '_OBJECTS');
			foreach ($objs->objects as $o) {
				$toolcode = $o->tag;
				$tool = &getTool($toolcode);
				$tool->unpack(array('package' => $o, 'id' => $importid));
			}
		}
	}

	function action($ac, $idlist) { IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1632;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		if ($this->getAccess()->canRead()) {
			if(isset(UserRequest::$post['confirm']) && $ac == 'IMPORT_Q') {
				$ac = ((UserRequest::$post['DBIM_batch'])?'IMPORT_BATCH':'IMPORT');
			}
			$msg = array();
			switch ($ac) {
				case 'DISPLAY_IDCODE':
					if (!empty(UserRequest::$get['idcode'])) {
						$idlist = array();
						$idlist[] = ClxCommon::$db->getField($this->tablename, 'ID', 'IDCODE=' . singleQuote(UserRequest::$get['idcode']));
					}
					$ac = 'DISPLAY';
					$contents = parent::action($ac, $idlist);
					break;
				case 'IMPORT_Q': /* Agrega campo de consulta batch => Si o No */
					$this->importform['panels'][0]['entries'][] = array(
						'label' => 'GEN_LBL_BATCH_PRMT',
						'fields' => array(
							array('name' => 'batch', 'type' => CLX_CLASS_LIST, 'default' => '1', 'options' => array('1' => 'GEN_LBL_YES', '0' => 'GEN_LBL_NO'))
						)
					);

					IF (!DEFINED('DBIM_INCLUDE_DATE_INF') || DBIM_INCLUDE_DATE_INF==0) {
						foreach ($this->importform['panels'][0]['entries'] as $key=>&$entry) {
							if ($entry['fields'][0]['name']=='FILENAME_INC_DATE'  ||
								$entry['fields'][0]['name']=='CH_VALUE_DATE'	)
									unset($this->importform['panels'][0]['entries'][$key]);


						}
					}
					$form = new clx_form($this->code, $this->importform);
					if ($this->getAccess()->canRead()) {
						if (!isset(UserRequest::$post['confirm'])) {

							if (!empty(UserRequest::$get['idcode'])) {
								$import_rec = ClxCommon::$db->getRecord($this->tablename, 'IDCODE=' . singleQuote(UserRequest::$get['idcode']));
								$idlist[CLX_NUM_ZERO] = $import_rec['ID'];
							} else {
								$import_rec = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $idlist[CLX_NUM_ZERO]);
							}
							clearHistory();
							pushHistory($this->code, 'IMPORT_Q', $idlist);
							$record = array();
							$record['DBIM_idcode'] = $import_rec['IDCODE'];
							$record['DBIM_idname'] = $import_rec['IDNAME'];
							$record['DBIM_id'] = $idlist[CLX_NUM_ZERO];

							$record['DBIM_test'] = CLX_NUM_ONE;
							$record['DBIM_save_errors'] = CLX_NUM_ONE;
							$record['DBIM_error_limit'] = CLX_NUM_HUNDRED;
							$record['DBIM_description'] = $import_rec['DESCRIPTION'];

						//	$contents = $form->editForm($ac, $idlist, $record, $msg);
							$TYPE=$import_rec['TYPE'];
							if ($TYPE=='CSV2') {
								$TYPE='CSV';
							}
							else if ($TYPE=='FRL2'||$TYPE=='FRL3') {
								$TYPE='FRL';
							}
							else if ($TYPE=='XLS2') {
								$TYPE='XLS';
							}
							$script= 'var yesimport=1;var menj='.singleQuote(dict('GEN_LBL_MENSAGE_FILE_EXTENSION')).';var menj2='.singleQuote(dict('GEN_LBL_MENSAGE_FILE_SIZE')).';var xtype ='.singleQuote($TYPE).';'.'var Exceltype='.singleQuote($import_rec['EXCEL_TYPE']).';';
							$record['DBIM_file']='';
							$record['DBIM_show_file']='';
							$contents = $form->editForm($ac, $idlist, $record, $msg). setJavaScriptTag($script.getJavaScript('DBIM_editform.js', ''), false);

							// Link: Ver Bit�cora
							$flname = kWebSite . 'tool.php?to=DBIM&ac=DISPLAY&idlist=' . $import_rec['ID'];
							$hrefBitacora = '<a href=' . singleQuote($flname) . '>' . dict('GEN_LBL_IMP_LOG') . '</a>';

							$lastId = ClxCommon::$db->getField('BASE_IDCODES', 'LAST_IDCODE', 'TABLECODE = ' . singleQuote($import_rec['TABLECODE']));
							$contents .= "
								<br>
								<table class='form' width='90%' cellspacing='0' cellpadding='0' border='0'>
									<tbody>
										<tr>
											<td colspan='1' rowspan='1' class='prompt' valign='top'>" . $hrefBitacora . "</td>
										</tr>
										<tr>
											<td colspan='1' rowspan='1' class='prompt' valign='top'>" . dict('56A6F3CD1DE7870D46ACCE0A35E38070') . " [" . $import_rec['TABLECODE'] . "]: " . (($lastId)?$lastId:dict('GEN_LBL_NOT_APPLY')) . "</td>
										</tr>
									</tbody>
								</table>";
							$this->getContentsBAR($contents);

						}
					} else {
						$contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [DB_IMPORT-CAN_READ_1][' . $ac . '] ' . $this->getCode(false));
					}
					break;
				case 'IMPORT_BATCH':
					IF (!DEFINED('DBIM_INCLUDE_DATE_INF') || DBIM_INCLUDE_DATE_INF==0) {
						foreach ($this->importform['panels'][0]['entries'] as $key=>&$entry) {
							if ($entry['fields'][0]['name']=='FILENAME_INC_DATE'  ||
								$entry['fields'][0]['name']=='CH_VALUE_DATE'	)
									unset($this->importform['panels'][0]['entries'][$key]);


						}
					}
					$this->importform[CLX_CLASS_TITLE] = 'TOOL_DBIM_EXECUTE_BATCH';
					$this->importform['panels'][0]['entries'][6]['fields']= array(
								array('name' => 'show_file', 'type' => 'string', 'default' => '0' ,'options' => array('0' => 'GEN_LBL_NO', '1' => 'GEN_LBL_YES'), 'readonly' => '1')
							);
					$form = new clx_form($this->code, $this->importform);
					if ($this->getAccess()->canRead()) {
						if (isset(UserRequest::$post['confirm'])) {
							if (isset(UserRequest::$post['DBIM_precharge']) && UserRequest::$post['DBIM_precharge']==1 && UserRequest::$post['DBIM_file_precharge']!='') {
								if (isset(UserRequest::$post['DBIM_file'])){
									UserRequest::$post['DBIM_file']=UserRequest::$post['DBIM_file_precharge'];
								}
								if (isset(UserRequest::$post['DBIM_filefixed'])){
									UserRequest::$post['DBIM_filefixed']=UserRequest::$post['DBIM_file_precharge'];
								}
								if (isset(UserRequest::$post['DBIM_fileexcel'])){
									UserRequest::$post['DBIM_fileexcel']=UserRequest::$post['DBIM_file_precharge'];
								}
							}


							if ($form->checkForm1(UserRequest::$post['ac'], UserRequest::$post, $msg)) {
								$DBIU=new db_import_run();
								$contents = $DBIU->import_batch_schedule();
							} else {
								$import_rec = ClxCommon::$db->getRecord($this->tablename, 'ID=' .UserRequest::$post['DBIM_id'] );
								$TYPE=$import_rec['TYPE'];
								if ($TYPE=='CSV2') {
									$TYPE='CSV';
								}
								else if ($TYPE=='FRL2'||$TYPE=='FRL3') {
									$TYPE='FRL';
								}
								else if ($TYPE=='XLS2') {
									$TYPE='XLS';
								}
								$script= 'var yesimport=1;var menj='.singleQuote(dict('GEN_LBL_MENSAGE_FILE_EXTENSION')).';var menj2='.singleQuote(dict('GEN_LBL_MENSAGE_FILE_SIZE')).';var xtype ='.singleQuote($TYPE).';'.'var Exceltype='.singleQuote($import_rec['EXCEL_TYPE']).';';

								$contents = $form->editForm($ac, $idlist, UserRequest::$post, $msg). setJavaScriptTag($script.getJavaScript('DBIM_editform.js', ''), false);
						   }
						} else {
							if (!empty(UserRequest::$get['idcode'])) {
								$import_rec = ClxCommon::$db->getRecord($this->tablename, 'IDCODE=' . singleQuote(UserRequest::$get['idcode']));

								$idlist[CLX_NUM_ZERO] = $import_rec['ID'];
							} else {
								$import_rec = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $idlist[CLX_NUM_ZERO]);
							}
							clearHistory();
							pushHistory($this->code, 'LIST', $idlist);
							$record = array();
							$record['DBIM_idcode'] = $import_rec['IDCODE'];
							$record['DBIM_idname'] = $import_rec['IDNAME'];
							$record['DBIM_id'] = $idlist[CLX_NUM_ZERO];
							$record['DBIM_test'] = CLX_NUM_ONE;
							$record['DBIM_save_errors'] = CLX_NUM_ONE;
							$record['DBIM_error_limit'] = CLX_NUM_HUNDRED;
							$record['DBIM_description'] = $import_rec['DESCRIPTION'];
							$TYPE=$import_rec['TYPE'];
							if ($TYPE=='CSV2') {
								$TYPE='CSV';
							}
							else if ($TYPE=='FRL2'||$TYPE=='FRL3') {
								$TYPE='FRL';
							}
							else if ($TYPE=='XLS2') {
								$TYPE='XLS';
							}
							$script= 'var yesimport=1;var menj='.singleQuote(dict('GEN_LBL_MENSAGE_FILE_EXTENSION')).';var menj2='.singleQuote(dict('GEN_LBL_MENSAGE_FILE_SIZE')).';var xtype ='.singleQuote($TYPE).';'.'var Exceltype='.singleQuote($import_rec['EXCEL_TYPE']).';';
							$record['DBIM_file']='';
							$record['DBIM_show_file']='';
							$contents = $form->editForm($ac, $idlist, $record, $msg). setJavaScriptTag($script).setJavaScriptTag(getJavaScript('DBIM_editform.js', ''), false);
							$this->getContentsBAR($contents);
						}
					} else {
						$contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [DB_IMPORT-CAN_READ_1][' . $ac . '] ' . $this->getCode(false));
					}
					break;
				case 'IMPORT':

					IF (!DEFINED('DBIM_INCLUDE_DATE_INF') || DBIM_INCLUDE_DATE_INF==0) {
						foreach ($this->importform['panels'][0]['entries'] as $key=>&$entry) {
							if ($entry['fields'][0]['name']=='FILENAME_INC_DATE'  ||
								$entry['fields'][0]['name']=='CH_VALUE_DATE'	)
									unset($this->importform['panels'][0]['entries'][$key]);


						}
					}
					$form = new clx_form($this->code, $this->importform);
					 if ($this->getAccess()->canRead()) {
						if (isset(UserRequest::$post['confirm'])) {
							$this->defaultPost();

							if (isset(UserRequest::$post['DBIM_precharge']) && UserRequest::$post['DBIM_precharge']==1 && UserRequest::$post['DBIM_file_precharge']!='') {
								if (isset(UserRequest::$post['DBIM_file'])){
									UserRequest::$post['DBIM_file']=UserRequest::$post['DBIM_file_precharge'];
								}
								if (isset(UserRequest::$post['DBIM_filefixed'])){
									UserRequest::$post['DBIM_filefixed']=UserRequest::$post['DBIM_file_precharge'];
								}
								if (isset(UserRequest::$post['DBIM_fileexcel'])){
									UserRequest::$post['DBIM_fileexcel']=UserRequest::$post['DBIM_file_precharge'];
								}
							}
							if ($form->checkForm1(UserRequest::$post['ac'], UserRequest::$post, $msg)) {
								$DBIU=new db_import_run();
								if($_POST['DBIM_idcode']=='FIATIHCAFE'){
									$transaction[1] = $db->getField('BASE_PARAMETERS', "PVALUE" ,"IDNAME='FIAT_PRESTAMO_COSECHA'");
									$transaction[2] = $db->getField('BASE_PARAMETERS', "PVALUE" ,"IDNAME='FIAT_TRASLADO_COSECHA'");
									$contents = $DBIU->import_ihcafe(false,$transaction);
								}elseif($_POST['DBIM_idcode']=='FIATRETIHCAFE'){
									$contents = $DBIU->import_ihcafe_ret();
								}elseif($_POST['DBIM_idcode']=='FIATIHCAFECOS'){
									$contents = $DBIU->import_ihcafe_cos();
								}else
									$contents = $DBIU->import(false);
							} else {
								$import_rec = ClxCommon::$db->getRecord($this->tablename, 'ID=' .UserRequest::$post['DBIM_id'] );
								$TYPE=$import_rec['TYPE'];
								if ($TYPE=='CSV2') {
									$TYPE='CSV';
								}
								else if ($TYPE=='FRL2'||$TYPE=='FRL3') {
									$TYPE='FRL';
								}
								else if ($TYPE=='XLS2') {
									$TYPE='XLS';
								}
								$script= 'var yesimport=1;var menj='.singleQuote(dict('GEN_LBL_MENSAGE_FILE_EXTENSION')).';var menj2='.singleQuote(dict('GEN_LBL_MENSAGE_FILE_SIZE')).';var xtype ='.singleQuote($TYPE).';'.'var Exceltype='.singleQuote($import_rec['EXCEL_TYPE']).';';

								$contents = $form->editForm($ac, $idlist, UserRequest::$post, $msg). setJavaScriptTag($script.getJavaScript('DBIM_editform.js', ''), false);
							}
						} else {
							if (!empty(UserRequest::$get['idcode'])) {
								$import_rec = ClxCommon::$db->getRecord($this->tablename, 'IDCODE=' . singleQuote(UserRequest::$get['idcode']));
								$idlist[CLX_NUM_ZERO] = $import_rec['ID'];
							} else {
								$import_rec = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $idlist[CLX_NUM_ZERO]);
							}
							$this->seekmapping($msg,$import_rec);
							clearHistory();
							pushHistory($this->code, 'LIST', $idlist);  //ORIGINAL DECIA IMPORT EN VEZ DE LIST NO FUNCIONA CANCELAR AL EJECUTAR
							$record = array();
							$record['DBIM_idcode'] = $import_rec['IDCODE'];
							$record['DBIM_idname'] = $import_rec['IDNAME'];
							$record['DBIM_id'] = $idlist[CLX_NUM_ZERO];
							$record['DBIM_test'] = CLX_NUM_ONE;
							$record['DBIM_save_errors'] = CLX_NUM_ONE;
							$record['DBIM_error_limit'] = CLX_NUM_HUNDRED;
							$record['DBIM_mapinfo'] = empty($import_rec['DBIM_mapinfo']) ?dict('GEN_LBL_NONE')['TRADUCTORDICT_0']:$import_rec['DBIM_mapinfo'];
							$record['DBIM_description'] = $import_rec['DESCRIPTION'];
							$TYPE=$import_rec['TYPE'];
							if ($TYPE=='CSV2') {
								$TYPE='CSV';
							}
							else if ($TYPE=='FRL2'||$TYPE=='FRL3') {
								$TYPE='FRL';
							}
							else if ($TYPE=='XLS2') {
									$TYPE='XLS';
							}
							$script= 'var yesimport=1;var menj='.singleQuote(dict('GEN_LBL_MENSAGE_FILE_EXTENSION')).';var menj2='.singleQuote(dict('GEN_LBL_MENSAGE_FILE_SIZE')).';var xtype ='.singleQuote($TYPE).';'.'var Exceltype='.singleQuote($import_rec['EXCEL_TYPE']).';';
							$record['DBIM_file']='';
							$record['DBIM_show_file']='';
							$contents = $form->editForm($ac, $idlist, $record, $msg). setJavaScriptTag($script.getJavaScript('DBIM_editform.js', ''), false);;
							$this->getContentsBAR($contents);
						}
					} else {
						$contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [DB_IMPORT-CAN_READ_1][' . $ac . '] ' . $this->getCode(false));
					}
					break;
				case 'IMPORT_STRUCTURE':
					$DBIU=new db_import_run();
					$contents = $DBIU->importStructure();
					break;
				case 'IMPORT_RECREATE_STRUCTURE':
					$DBIU=new db_import_run();
					$contents = $DBIU->importRecreateStructure();
					break;
				case 'DOWNSAMPLE':
					$DBIU=new db_import_run();
					$contents = $DBIU->Importsample();
					break;
				case 'PARSER':
					$contents = $this->Importparser();
					break;
				case 'UPDATE':
					if (empty($idlist ) ) {
						$idlist[] = ClxCommon::$db->getField($this->tablename, 'ID', 'IDCODE=' . (singleQuote(empty(UserRequest::$request['idcode']) ?UserRequest::$request['DBIM_idcode'] :UserRequest::$request['idcode']  )));
						$contents = parent::action($ac, $idlist);
						$info = popHistory();
						$contents = executeHistory($info);

					}
					break;
				 case 'DUPLICATE':
					if ($this->getAccess()->canModify() && ($this->getAccess()->canDisplay())) {
						if (isset(UserRequest::$post['confirm'])) {
							if ($this->checkForm($msg)) {
								ClxFreeReturn($this->duplicateRecord());
								if ( isset($GLOBALS["process"])  ) {
									$contents="";
								} else {
									$info = popHistory();
									$contents = executeHistory($info);
								}
							} else {
								$contents = $this->editForm($ac, $idlist, UserRequest::$post, $msg);
							}
						} else {
							$id = array_pop($idlist);
							$record = $this->loadToolRecord($id);
							$contents = $this->editForm($ac, $idlist, $record, $msg);
						}
					} else {
						$contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [CLX_TOOL-CAN_MODIFY & CAN_APPEND][' . $ac . '] ' . $this->getCode(false));
					}
					break;

				default:
					$this->defaultPost();
					$contents = parent::action($ac, $idlist);
					break;

			}
		} else {
			$contents = warning(dict('GEN_ERR_NO_ACCESS') . ' [DB_IMPORT-CAN_READ_2][' . $ac . '] ' . $this->getCode(false));
		}
		return $contents;
	}
	function getContentsBAR(&$contents) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}
		if(DBIM_UPLOAD_FILE==0)
			return;
		$site= UserRequest::$server['HTTP_REFERER'];
		$uplodadfile=explode("tool.php",$site)[0]."data/code/upload.php";

		$contents=
		' <script>
			/* jquery.form.min.js */
			(function(e){"use strict";if(typeof define==="function"&&define.amd){define(["jquery"],e)}else{e(typeof jQuery!="undefined"?jQuery:window.Zepto)}})(function(e){"use strict";function r(t){var n=t.data;if(!t.isDefaultPrevented()){t.preventDefault();e(t.target).ajaxSubmit(n)}}function i(t){var n=t.target;var r=e(n);if(!r.is("[type=submit],[type=image]")){var i=r.closest("[type=submit]");if(i.length===0){return}n=i[0]}var s=this;s.clk=n;if(n.type=="image"){if(t.offsetX!==undefined){s.clk_x=t.offsetX;s.clk_y=t.offsetY}else if(typeof e.fn.offset=="function"){var o=r.offset();s.clk_x=t.pageX-o.left;s.clk_y=t.pageY-o.top}else{s.clk_x=t.pageX-n.offsetLeft;s.clk_y=t.pageY-n.offsetTop}}setTimeout(function(){s.clk=s.clk_x=s.clk_y=null},100)}function s(){if(!e.fn.ajaxSubmit.debug){return}var t="[jquery.form] "+Array.prototype.join.call(arguments,"");if(window.console&&window.console.log){window.console.log(t)}else if(window.opera&&window.opera.postError){window.opera.postError(t)}}var t={};t.fileapi=e("<input type=\'file\'/>").get(0).files!==undefined;t.formdata=window.FormData!==undefined;var n=!!e.fn.prop;e.fn.attr2=function(){if(!n){return this.attr.apply(this,arguments)}var e=this.prop.apply(this,arguments);if(e&&e.jquery||typeof e==="string"){return e}return this.attr.apply(this,arguments)};e.fn.ajaxSubmit=function(r){function k(t){var n=e.param(t,r.traditional).split("&");var i=n.length;var s=[];var o,u;for(o=0;o<i;o++){n[o]=n[o].replace(/\+/g," ");u=n[o].split("=");s.push([decodeURIComponent(u[0]),decodeURIComponent(u[1])])}return s}function L(t){var n=new FormData;for(var s=0;s<t.length;s++){n.append(t[s].name,t[s].value)}if(r.extraData){var o=k(r.extraData);for(s=0;s<o.length;s++){if(o[s]){n.append(o[s][0],o[s][1])}}}r.data=null;var u=e.extend(true,{},e.ajaxSettings,r,{contentType:false,processData:false,cache:false,type:i||"POST"});if(r.uploadProgress){u.xhr=function(){var t=e.ajaxSettings.xhr();if(t.upload){t.upload.addEventListener("progress",function(e){var t=0;var n=e.loaded||e.position;var i=e.total;if(e.lengthComputable){t=Math.ceil(n/i*100)}r.uploadProgress(e,n,i,t)},false)}return t}}u.data=null;var a=u.beforeSend;u.beforeSend=function(e,t){if(r.formData){t.data=r.formData}else{t.data=n}if(a){a.call(this,e,t)}};return e.ajax(u)}function A(t){function T(e){var t=null;try{if(e.contentWindow){t=e.contentWindow.document}}catch(n){s("cannot get iframe.contentWindow document: "+n)}if(t){return t}try{t=e.contentDocument?e.contentDocument:e.document}catch(n){s("cannot get iframe.contentDocument: "+n);t=e.document}return t}function k(){function f(){try{var e=T(v).readyState;s("state = "+e);if(e&&e.toLowerCase()=="uninitialized"){setTimeout(f,50)}}catch(t){s("Server abort: ",t," (",t.name,")");_(x);if(w){clearTimeout(w)}w=undefined}}var t=a.attr2("target"),n=a.attr2("action"),r="multipart/form-data",u=a.attr("enctype")||a.attr("encoding")||r;o.setAttribute("target",p);if(!i||/post/i.test(i)){o.setAttribute("method","POST")}if(n!=l.url){o.setAttribute("action",l.url)}if(!l.skipEncodingOverride&&(!i||/post/i.test(i))){a.attr({encoding:"multipart/form-data",enctype:"multipart/form-data"})}if(l.timeout){w=setTimeout(function(){b=true;_(S)},l.timeout)}var c=[];try{if(l.extraData){for(var h in l.extraData){if(l.extraData.hasOwnProperty(h)){if(e.isPlainObject(l.extraData[h])&&l.extraData[h].hasOwnProperty("name")&&l.extraData[h].hasOwnProperty("value")){c.push(e(\'<input type="hidden" name="\'+l.extraData[h].name+\'">\').val(l.extraData[h].value).appendTo(o)[0])}else{c.push(e(\'<input type="hidden" name="\'+h+\'">\').val(l.extraData[h]).appendTo(o)[0])}}}}if(!l.iframeTarget){d.appendTo("body")}if(v.attachEvent){v.attachEvent("onload",_)}else{v.addEventListener("load",_,false)}setTimeout(f,15);try{o.submit()}catch(m){var g=document.createElement("form").submit;g.apply(o)}}finally{o.setAttribute("action",n);o.setAttribute("enctype",u);if(t){o.setAttribute("target",t)}else{a.removeAttr("target")}e(c).remove()}}function _(t){if(m.aborted||M){return}A=T(v);if(!A){s("cannot access response document");t=x}if(t===S&&m){m.abort("timeout");E.reject(m,"timeout");return}else if(t==x&&m){m.abort("server abort");E.reject(m,"error","server abort");return}if(!A||A.location.href==l.iframeSrc){if(!b){return}}if(v.detachEvent){v.detachEvent("onload",_)}else{v.removeEventListener("load",_,false)}var n="success",r;try{if(b){throw"timeout"}var i=l.dataType=="xml"||A.XMLDocument||e.isXMLDoc(A);s("isXml="+i);if(!i&&window.opera&&(A.body===null||!A.body.innerHTML)){if(--O){s("requeing onLoad callback, DOM not available");setTimeout(_,250);return}}var o=A.body?A.body:A.documentElement;m.responseText=o?o.innerHTML:null;m.responseXML=A.XMLDocument?A.XMLDocument:A;if(i){l.dataType="xml"}m.getResponseHeader=function(e){var t={"content-type":l.dataType};return t[e.toLowerCase()]};if(o){m.status=Number(o.getAttribute("status"))||m.status;m.statusText=o.getAttribute("statusText")||m.statusText}var u=(l.dataType||"").toLowerCase();var a=/(json|script|text)/.test(u);if(a||l.textarea){var f=A.getElementsByTagName("textarea")[0];if(f){m.responseText=f.value;m.status=Number(f.getAttribute("status"))||m.status;m.statusText=f.getAttribute("statusText")||m.statusText}else if(a){var c=A.getElementsByTagName("pre")[0];var p=A.getElementsByTagName("body")[0];if(c){m.responseText=c.textContent?c.textContent:c.innerText}else if(p){m.responseText=p.textContent?p.textContent:p.innerText}}}else if(u=="xml"&&!m.responseXML&&m.responseText){m.responseXML=D(m.responseText)}try{L=H(m,u,l)}catch(g){n="parsererror";m.error=r=g||n}}catch(g){s("error caught: ",g);n="error";m.error=r=g||n}if(m.aborted){s("upload aborted");n=null}if(m.status){n=m.status>=200&&m.status<300||m.status===304?"success":"error"}if(n==="success"){if(l.success){l.success.call(l.context,L,"success",m)}E.resolve(m.responseText,"success",m);if(h){e.event.trigger("ajaxSuccess",[m,l])}}else if(n){if(r===undefined){r=m.statusText}if(l.error){l.error.call(l.context,m,n,r)}E.reject(m,"error",r);if(h){e.event.trigger("ajaxError",[m,l,r])}}if(h){e.event.trigger("ajaxComplete",[m,l])}if(h&&!--e.active){e.event.trigger("ajaxStop")}if(l.complete){l.complete.call(l.context,m,n)}M=true;if(l.timeout){clearTimeout(w)}setTimeout(function(){if(!l.iframeTarget){d.remove()}else{d.attr("src",l.iframeSrc)}m.responseXML=null},100)}var o=a[0],u,f,l,h,p,d,v,m,g,y,b,w;var E=e.Deferred();E.abort=function(e){m.abort(e)};if(t){for(f=0;f<c.length;f++){u=e(c[f]);if(n){u.prop("disabled",false)}else{u.removeAttr("disabled")}}}l=e.extend(true,{},e.ajaxSettings,r);l.context=l.context||l;p="jqFormIO"+(new Date).getTime();if(l.iframeTarget){d=e(l.iframeTarget);y=d.attr2("name");if(!y){d.attr2("name",p)}else{p=y}}else{d=e(\'<iframe name="\'+p+\'" src="\'+l.iframeSrc+\'" />\');d.css({position:"absolute",top:"-1000px",left:"-1000px"})}v=d[0];m={aborted:0,responseText:null,responseXML:null,status:0,statusText:"n/a",getAllResponseHeaders:function(){},getResponseHeader:function(){},setRequestHeader:function(){},abort:function(t){var n=t==="timeout"?"timeout":"aborted";s("aborting upload... "+n);this.aborted=1;try{if(v.contentWindow.document.execCommand){v.contentWindow.document.execCommand("Stop")}}catch(r){}d.attr("src",l.iframeSrc);m.error=n;if(l.error){l.error.call(l.context,m,n,t)}if(h){e.event.trigger("ajaxError",[m,l,n])}if(l.complete){l.complete.call(l.context,m,n)}}};h=l.global;if(h&&0===e.active++){e.event.trigger("ajaxStart")}if(h){e.event.trigger("ajaxSend",[m,l])}if(l.beforeSend&&l.beforeSend.call(l.context,m,l)===false){if(l.global){e.active--}E.reject();return E}if(m.aborted){E.reject();return E}g=o.clk;if(g){y=g.name;if(y&&!g.disabled){l.extraData=l.extraData||{};l.extraData[y]=g.value;if(g.type=="image"){l.extraData[y+".x"]=o.clk_x;l.extraData[y+".y"]=o.clk_y}}}var S=1;var x=2;var N=e("meta[name=csrf-token]").attr("content");var C=e("meta[name=csrf-param]").attr("content");if(C&&N){l.extraData=l.extraData||{};l.extraData[C]=N}if(l.forceSync){k()}else{setTimeout(k,10)}var L,A,O=50,M;var D=e.parseXML||function(e,t){if(window.ActiveXObject){t=new ActiveXObject("Microsoft.XMLDOM");t.async="false";t.loadXML(e)}else{t=(new DOMParser).parseFromString(e,"text/xml")}return t&&t.documentElement&&t.documentElement.nodeName!="parsererror"?t:null};var P=e.parseJSON||function(e){return window["eval"]("("+e+")")};var H=function(t,n,r){var i=t.getResponseHeader("content-type")||"",s=n==="xml"||!n&&i.indexOf("xml")>=0,o=s?t.responseXML:t.responseText;if(s&&o.documentElement.nodeName==="parsererror"){if(e.error){e.error("parsererror")}}if(r&&r.dataFilter){o=r.dataFilter(o,n)}if(typeof o==="string"){if(n==="json"||!n&&i.indexOf("json")>=0){o=P(o)}else if(n==="script"||!n&&i.indexOf("javascript")>=0){e.globalEval(o)}}return o};return E}if(!this.length){s("ajaxSubmit: skipping submit process - no element selected");return this}var i,o,u,a=this;if(typeof r=="function"){r={success:r}}else if(r===undefined){r={}}i=r.type||this.attr2("method");o=r.url||this.attr2("action");u=typeof o==="string"?e.trim(o):"";u=u||window.location.href||"";if(u){u=(u.match(/^([^#]+)/)||[])[1]}r=e.extend(true,{url:u,success:e.ajaxSettings.success,type:i||e.ajaxSettings.type,iframeSrc:/^https/i.test(window.location.href||"")?"javascript:false":"about:blank"},r);var f={};this.trigger("form-pre-serialize",[this,r,f]);if(f.veto){s("ajaxSubmit: submit vetoed via form-pre-serialize trigger");return this}if(r.beforeSerialize&&r.beforeSerialize(this,r)===false){s("ajaxSubmit: submit aborted via beforeSerialize callback");return this}var l=r.traditional;if(l===undefined){l=e.ajaxSettings.traditional}var c=[];var h,p=this.formToArray(r.semantic,c);if(r.data){r.extraData=r.data;h=e.param(r.data,l)}if(r.beforeSubmit&&r.beforeSubmit(p,this,r)===false){s("ajaxSubmit: submit aborted via beforeSubmit callback");return this}this.trigger("form-submit-validate",[p,this,r,f]);if(f.veto){s("ajaxSubmit: submit vetoed via form-submit-validate trigger");return this}var d=e.param(p,l);if(h){d=d?d+"&"+h:h}if(r.type.toUpperCase()=="GET"){r.url+=(r.url.indexOf("?")>=0?"&":"?")+d;r.data=null}else{r.data=d}var v=[];if(r.resetForm){v.push(function(){a.resetForm()})}if(r.clearForm){v.push(function(){a.clearForm(r.includeHidden)})}if(!r.dataType&&r.target){var m=r.success||function(){};v.push(function(t){var n=r.replaceTarget?"replaceWith":"html";e(r.target)[n](t).each(m,arguments)})}else if(r.success){v.push(r.success)}r.success=function(e,t,n){var i=r.context||this;for(var s=0,o=v.length;s<o;s++){v[s].apply(i,[e,t,n||a,a])}};if(r.error){var g=r.error;r.error=function(e,t,n){var i=r.context||this;g.apply(i,[e,t,n,a])}}if(r.complete){var y=r.complete;r.complete=function(e,t){var n=r.context||this;y.apply(n,[e,t,a])}}var b=e("input[type=file]:enabled",this).filter(function(){return e(this).val()!==""});var w=b.length>0;var E="multipart/form-data";var S=a.attr("enctype")==E||a.attr("encoding")==E;var x=t.fileapi&&t.formdata;s("fileAPI :"+x);var T=(w||S)&&!x;var N;if(r.iframe!==false&&(r.iframe||T)){if(r.closeKeepAlive){e.get(r.closeKeepAlive,function(){N=A(p)})}else{N=A(p)}}else if((w||S)&&x){N=L(p)}else{N=e.ajax(r)}a.removeData("jqxhr").data("jqxhr",N);for(var C=0;C<c.length;C++){c[C]=null}this.trigger("form-submit-notify",[this,r]);return this};e.fn.ajaxForm=function(t){t=t||{};t.delegation=t.delegation&&e.isFunction(e.fn.on);if(!t.delegation&&this.length===0){var n={s:this.selector,c:this.context};if(!e.isReady&&n.s){s("DOM not ready, queuing ajaxForm");e(function(){e(n.s,n.c).ajaxForm(t)});return this}s("terminating; zero elements found by selector"+(e.isReady?"":" (DOM not ready)"));return this}if(t.delegation){e(document).off("submit.form-plugin",this.selector,r).off("click.form-plugin",this.selector,i).on("submit.form-plugin",this.selector,t,r).on("click.form-plugin",this.selector,t,i);return this}return this.ajaxFormUnbind().bind("submit.form-plugin",t,r).bind("click.form-plugin",t,i)};e.fn.ajaxFormUnbind=function(){return this.unbind("submit.form-plugin click.form-plugin")};e.fn.formToArray=function(n,r){var i=[];if(this.length===0){return i}var s=this[0];var o=this.attr("id");var u=n?s.getElementsByTagName("*"):s.elements;var a;if(u&&!/MSIE [678]/.test(navigator.userAgent)){u=e(u).get()}if(o){a=e(\':input[form="\'+o+\'"]\').get();if(a.length){u=(u||[]).concat(a)}}if(!u||!u.length){return i}var f,l,c,h,p,d,v;for(f=0,d=u.length;f<d;f++){p=u[f];c=p.name;if(!c||p.disabled){continue}if(n&&s.clk&&p.type=="image"){if(s.clk==p){i.push({name:c,value:e(p).val(),type:p.type});i.push({name:c+".x",value:s.clk_x},{name:c+".y",value:s.clk_y})}continue}h=e.fieldValue(p,true);if(h&&h.constructor==Array){if(r){r.push(p)}for(l=0,v=h.length;l<v;l++){i.push({name:c,value:h[l]})}}else if(t.fileapi&&p.type=="file"){if(r){r.push(p)}var m=p.files;if(m.length){for(l=0;l<m.length;l++){i.push({name:c,value:m[l],type:p.type})}}else{i.push({name:c,value:"",type:p.type})}}else if(h!==null&&typeof h!="undefined"){if(r){r.push(p)}i.push({name:c,value:h,type:p.type,required:p.required})}}if(!n&&s.clk){var g=e(s.clk),y=g[0];c=y.name;if(c&&!y.disabled&&y.type=="image"){i.push({name:c,value:g.val()});i.push({name:c+".x",value:s.clk_x},{name:c+".y",value:s.clk_y})}}return i};e.fn.formSerialize=function(t){return e.param(this.formToArray(t))};e.fn.fieldSerialize=function(t){var n=[];this.each(function(){var r=this.name;if(!r){return}var i=e.fieldValue(this,t);if(i&&i.constructor==Array){for(var s=0,o=i.length;s<o;s++){n.push({name:r,value:i[s]})}}else if(i!==null&&typeof i!="undefined"){n.push({name:this.name,value:i})}});return e.param(n)};e.fn.fieldValue=function(t){for(var n=[],r=0,i=this.length;r<i;r++){var s=this[r];var o=e.fieldValue(s,t);if(o===null||typeof o=="undefined"||o.constructor==Array&&!o.length){continue}if(o.constructor==Array){e.merge(n,o)}else{n.push(o)}}return n};e.fieldValue=function(t,n){var r=t.name,i=t.type,s=t.tagName.toLowerCase();if(n===undefined){n=true}if(n&&(!r||t.disabled||i=="reset"||i=="button"||(i=="checkbox"||i=="radio")&&!t.checked||(i=="submit"||i=="image")&&t.form&&t.form.clk!=t||s=="select"&&t.selectedIndex==-1)){return null}if(s=="select"){var o=t.selectedIndex;if(o<0){return null}var u=[],a=t.options;var f=i=="select-one";var l=f?o+1:a.length;for(var c=f?o:0;c<l;c++){var h=a[c];if(h.selected){var p=h.value;if(!p){p=h.attributes&&h.attributes.value&&!h.attributes.value.specified?h.text:h.value}if(f){return p}u.push(p)}}return u}return e(t).val()};e.fn.clearForm=function(t){return this.each(function(){e("input,select,textarea",this).clearFields(t)})};e.fn.clearFields=e.fn.clearInputs=function(t){var n=/^(?:color|date|datetime|email|month|number|password|range|search|tel|text|time|url|week)$/i;return this.each(function(){var r=this.type,i=this.tagName.toLowerCase();if(n.test(r)||i=="textarea"){this.value=""}else if(r=="checkbox"||r=="radio"){this.checked=false}else if(i=="select"){this.selectedIndex=-1}else if(r=="file"){if(/MSIE/.test(navigator.userAgent)){e(this).replaceWith(e(this).clone(true))}else{e(this).val("")}}else if(t){if(t===true&&/hidden/.test(r)||typeof t=="string"&&e(this).is(t)){this.value=""}}})};e.fn.resetForm=function(){return this.each(function(){if(typeof this.reset=="function"||typeof this.reset=="object"&&!this.reset.nodeType){this.reset()}})};e.fn.enable=function(e){if(e===undefined){e=true}return this.each(function(){this.disabled=!e})};e.fn.selected=function(t){if(t===undefined){t=true}return this.each(function(){var n=this.type;if(n=="checkbox"||n=="radio"){this.checked=t}else if(this.tagName.toLowerCase()=="option"){var r=e(this).parent("select");if(t&&r[0]&&r[0].type=="select-one"){r.find("option").selected(false)}this.selected=t}})};e.fn.ajaxSubmit.debug=false})
		 </script>
		 <link rel="stylesheet" href="'.kPathJquery_1_11_4.'themes/smoothness/jquery-ui.css">
		<script src="'.kPathJquery_1_11_4.'jquery-ui.js"></script>
		<style>
			#uploadForm {border-top:#F0F0F0 0px solid;padding:10px;}
			#uploadForm label {margin:2px; font-size:11px; font-weight:bold;}
			.demoInputBox{padding:5px; border:#F0F0F0 1px solid; border-radius:4px; background-color:#FFF;}
			#progress-bar {background-color: #12CC1A;height:12px;color: #FFFFFF;width:0%;-webkit-transition: width .3s;-moz-transition: width .3s;transition: width .3s;}
			.btnSubmit{ font-size:11px;background-color:#09f;border:0;padding:5px 20px;color:#FFF;border:#F0F0F0 1px solid; border-radius:4px;}
			#progress-div {border:#0FA015 1px solid;padding: 0px 1px;margin:9px 0px;font-size:10px;border-radius:4px;text-align:center;}
			#targetLayer{width:100%;text-align:center;}
			.no-close .ui-dialog-titlebar-close {
			  display: none;
			}
			.ui-dialog-title{
				font-size: 12px;
			}
		</style>


		<script type="text/javascript">
				$(function() {
					$( "#dialog-1" ).dialog({
						autoOpen: false,
						width:"800",
						height:"150",
						modal:true,
						open: function(event, ui) {
							$(this).parent().css({"top": window.pageYOffset+174});
						}

					});
				/*	$( "#dialog-1" ).on("keydown", function(evt) {
						if (evt.keyCode === $.ui.keyCode.ESCAPE) {
							alert(1);
							dialog.dialog("close");
						}
						evt.stopPropagation();
					});*/
					$("#opener" ).click(function() {//alert("111");
						$( "#dialog-1" ).dialog( "open" );
						$( ".ui-dialog-titlebar-close" ).hide();

					});
				});
		</script>'.
			str_replace('<input type="file" name="DBIM_file" value="">',
						'<input type="file" name="DBIM_file" value="">'.
								chr(13).chr(10).'<button  type="button" id = "opener">'.dict('DBIM_PREUPLOAD').'</button>'.
								'<input type="text" placeholder="'.dict('DBIM_FILE_SELECTED').'" style="border: 0px solid;width:304px; background-color: transparent;" readonly id="DBIM_file_precharge" name="DBIM_file_precharge" value="">',
							str_replace('<input type="hidden" name="to" value="DBIM">','<input type="hidden" name="to" value="DBIM">'.'<input type="hidden" id="DBIM_precharge" name="DBIM_precharge" value="0">'.chr(13).chr(10),$contents)).
		'<div id = "dialog-1" style="font-size:9px" title= "'.dict('DBIM_TITLE_PREUPLOAD').'" >
		 <form id="uploadForm" action="'.$uplodadfile.'" method="post">
		   	<div style="width: 750px;height: 60px">
				<div style="float:left;">
				<label style="font-size:11px">Upload:</label>
				<input name="userImage" id="userImage" style="font-size:11px" type="file" class="demoInputBox" />
				<input type="submit" id="btnSubmit" style="font-size:11px" value="Submit" class="btnSubmit" />
				</div>
				<div style="float:right;">
					<div id="progress-div" style="width:220px; padding-top: 0px;">
						<div id="progress-bar"style="width:0px">
						</div>
					</div>
				<div>
			</div>
		<form>
	</div>


	<script type="text/javascript">
			var clicked=0;
			$(document).ready(function() {
				 $("#uploadForm").submit(function(e) {
					e.preventDefault();

					if($("#userImage").val()=="" ) {

					}
					else if (clicked==0) {
						$("#DBIM_precharge").val("0");
						clicked=1;
						$("#userImage").click(function(){return false;});
						$(this).ajaxSubmit({
							target:   "#targetLayer",
							beforeSubmit: function() {
							  $("#progress-bar").width("0%");
							},
							uploadProgress: function (event, position, total, percentComplete){
								$("#progress-bar").width(percentComplete + "%");
								$("#progress-bar").html(\'<div id="progress-status">\' + percentComplete +" %</div>")
								$(\'input[name*="DBIM_file"]\').val("");
								$(\'input[name*="DBIM_filefixed"]\').val("");
								$(\'input[name*="DBIM_fileexcel"]\').val("");

								if (percentComplete>=98) {//
									namefile=$("#userImage").val();
									pnamefile=namefile.split(/\\\|\//);
									xnamefile=pnamefile[pnamefile["length"]-1];
									$("#DBIM_file_precharge").val(xnamefile);
									$("#DBIM_precharge").val("1");
									clicked=0;
									$("#userImage").unbind();
								}

								if (percentComplete>=100) {//
									setTimeout(\'$("#dialog-1").dialog("close");clicked=0;$("#userImage").unbind();$("#progress-bar").width("0%");\',2500);

								}
							},
							success:function (){console.log("ffff");
									$("#dialog-1").dialog("close");
							},
							resetForm: true
						});
					}
				});
			});
			$(\'input[name*="file"]\' ).each(function( xindex ) {if (typeof $(this).attr("id")=="undefined") { $( this ).attr("id","xfile"+xindex ); if (jQuery().jquery >"1.9") { $("#xfile"+xindex).on( "click", function() {  $( "#DBIM_file_precharge" ).val("") ;$( "#DBIM_precharge" ).val("0") ; }).hide();} else { $("#xfile"+xindex).live( "click", function() {  $( "#DBIM_file_precharge" ).val("") ;$( "#DBIM_precharge" ).val("0") ; }).hide()}  }});

				</script>
	';
		//$(\'input[name*="file"]\' ).each(function( xindex ) { if (typeof $(this).attr("id")=="undefined") { $( this ).attr("id","xfile"+xindex );		$("#xfile"+xindex).on( "click", function() {$( "#DBIM_file_precharge" ).val("") ;$( "#DBIM_precharge" ).val("0") ;});				   }})

	}
	function defaultPost() {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}
		if (empty(UserRequest::$post['DBIM_test']))UserRequest::$post['DBIM_test']='';
		if (empty(UserRequest::$post['DBIM_save_errors']))UserRequest::$post['DBIM_save_errors']='';
		if (empty(UserRequest::$post['DBIM_show_file']))UserRequest::$post['DBIM_show_file']='';
		if (empty(UserRequest::$post['DBIM_error_limit']))UserRequest::$post['DBIM_error_limit']='';
		if (empty(UserRequest::$post['DBIM_description']))UserRequest::$post['DBIM_description']='';


	}
	function defaultRecord() {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1605;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		$record = array();
		$record['DBIM_id'] = CLX_INIT_ZERO;
		$record['DBIM_idcode'] = '';
		$record['DBIM_idname'] = '';
		$record['DBIM_version'] = '1.0.0';
		$record['DBIM_cdate'] = '';
		$record['DBIM_mdate'] = '';
		$record['DBIM_username'] = $_SESSION['user_record']['username'];
		$record['DBIM_description'] = '';
		$record['DBIM_modulecode'] = '';
		$record['DBIM_tablecode'] = '';
		$record['DBIM_type'] = 'FRL';
		$record['DBIM_record_delim'] = '[13][10]';
		$record['DBIM_field_delim'] = array(array(0=>'[9]'));
// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - BEGIN
		$record['DBIM_record_delim_frl'] = '[13][10]';
// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - END

		$record['DBIM_record_length'] = '512';
		$record['DBIM_if_duplicates'] = CLX_INIT_ZERO;
		$record['DBIM_excel_count_sheets']= CLX_INIT_ZERO;
		$record['DBIM_file']	  = '';
		$record['DBIM_filefixed'] = '';
		$record['DBIM_fileexcel'] = '';
		$record['DBIM_field_delim'] =array(0=>'[9]',1=>'',2=>'',3=>'',4=>'',5=>'',6=>'',7=>'');
		$record['DBIM_field_cdelim'] =array(4=>'',5=>'',6=>'');
		$record['DBIM_field_prop']=array("","","");
		$record['DBIM_field_cprop']=array("","","");
		$record['DBIM_record_prop']=array("","","");
		$record['DBIM_record_cprop']=array("","","");
		$record['DBIM_excel_type']= 'xlsx';
		$record['DBIM_priority']= '1';

		/*$record['DBIM_record_delim'] = $values['RECORD_DELIM'];
		$record['DBIM_field_delim_other'] = $values['FIELD_DELIM'];
		$record['DBIM_record_delim_other'] = $values['RECORD_DELIM'];
		$record['DBIM_record_length'] = $values['RECORD_LENGTH'];
*/
		return $record;
	}
	function seekmapping(&$msg,&$record){IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}
		$maps = ClxCommon::$db->getRecord('CLX_DB_IMPORT_MAPPINGS' , 'IMPORTCODE=' . singleQuote($record['IDCODE']).' AND TYPE != '.singlequote('IGNR'));
		if (empty($maps['IMPORTCODE'])) {
			$record['DBIM_mapinfo']=dict('GEN_LBL_NONE');
			$msg['DBIM_mapinfo']=dict('GEN_LBL_NONEX');
		}
		else {
			$qty = ClxCommon::$db->countRecords('CLX_DB_IMPORT_MAPPINGS', 'IMPORTCODE=' . singleQuote($record['IDCODE']));
			$record['DBIM_mapinfo']=/*'<b>'.*/dict('GEN_LBL_FIELDS_MAPPING')./*':</b>'.*/ ' '. $qty;
			$record['DBIM_mapinfo'].=($record['TYPE']=='XLS') ? /*' (<b>'*/' ('.dict('GEN_LBL_SHEETNAME')./*':</b>'*/ ' '.$maps['IMPORTSHEETS'].')':'';
//		  $record['DBIM_mapinfo'].=($record['TYPE']=='XLS') ? '(<b>'.dict('GEN_LBL_SHEETNAME').':</b>'.$maps['IMPORTSHEETS'].')':'';

		}

	}
	function makelist($listingcode = null) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1633;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		ClxFreeReturn($listingcode);
		//$t = time('U'); genera un warning
		$t = time();
		$to = $this->code;
		$here = 'tool.php?to=' . $to . '&t=' . $t;
		clearHistory();
		pushHistory($this->code, 'LIST', array());
		$form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
		$form->setProp(CLX_PROP_ID, 'DBIMList');
		$form->addArgument(CLX_PROP_TO, $this->code);
		$form->addArgument('ac', 'NOT_DEFINED');
		$selectclause = '*';
		$fromclause = 'CLX_DB_IMPORTS';
		$whereclause = '';
		$sortclause = '';
		$page = new xPaging();
		$page->pageInit($form->getProp(CLX_PROP_ID), $here, $selectclause, $fromclause, $whereclause, $sortclause, '');
		$table = new htmlTable(CLX_NUM_TEN);
		$table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
		$table->addCell(dict('TOOL_DBIM_TITLE_LIST'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_NUM_TEN));
		$page->header($table);
		$table->addCells(CLX_CLASS_HEADERS, array(dict('GEN_LBL_SEL'), dict('GEN_LBL_MODULECODE'), dict('GEN_LBL_CODE'), dict('GEN_LBL_NAME'), dict('GEN_LBL_TYPE'), dict('GEN_LBL_VERSION'), dict('GEN_LBL_DESCRIPTION'), dict('GEN_LBL_IF_DUPLICATES'), dict('GEN_LBL_TABLECODE'), dict('GEN_LBL_MDATE')));
		$i = CLX_INIT_ZERO;

		while ($record = $page->nextRecord()) {
			$recordid = $record['ID'];
			$select = new htmlCheckbox('selector_' . $recordid, false);
			$select->setProp('onclick', 'selectButtons(' . singleQuote($form->getProp(CLX_PROP_ID)) . ');');
			$table->addCell($select->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_WIDTH => '40', CLX_PROP_ALIGN => 'center'));
			$recordtype=$record['TYPE'];
			IF (kDatabaseType!='oci') {
				if ($recordtype=='CSV2')
					$recordtype='CSV';
				else if ($recordtype=='FRL2')
					$recordtype='FRL';
				else if ($recordtype=='FRL3')
					$recordtype='FRL';

			}

			$table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array($record['MODULECODE'], $record['IDCODE'], $record['IDNAME'], dict($this->import_types[$recordtype]), $record['VERSION'] . '-' . $record['VERSION_COUNTER'], xFormat::text($record['DESCRIPTION']), dict($this->if_duplicates[$record['IF_DUPLICATES']]),$record['TABLECODE'].' ('. (ClxCommon::$db->getone('SELECT count(1) FROM CLX_DB_TABLES WHERE IDCODE='.singleQuote($record['TABLECODE']))==1? dict('GEN_LBL_EXISTS') : dict('GEN_LBL_NOT_EXISTS') ).')' ,Substr($record['MDATE'],0,10)));
			$i++;
		}
		$buttons = '';
		$buttons .= htmlButton::getButton('submit', dict('GEN_LBL_DISPLAY'), array('action' => 'DISPLAY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
		if ($this->getAccess()->canModify()) {
			$buttons .=htmlButton::getButton('submit', dict('GEN_LBL_MODIFY'), array('action' => 'MODIFY', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
		}
		if ($this->getAccess()->canDelete()) {
			$buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DELETE'), array('action' => 'DELETE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
		}
		if ($this->getAccess()->canRead()) {
			$buttons .=htmlButton::getButton('submit', dict('GEN_LBL_EXECUTE'), array('action' => 'IMPORT', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ONE'))->source();
		}
		if ($this->getAccess()->canRead()) {
			$buttons .=htmlButton::getButton('submit', dict('GEN_LBL_EXECUTE_BATCH'), array('action' => 'IMPORT_BATCH', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ONE'))->source();
		}
		if ($this->getAccess()->canDisplay()) {
			$buttons .=htmlButton::getButton('submit', dict('GEN_LBL_CREATE_SOMETHING', dict('GEN_LBL_IMPORT')), array('action' => 'CREATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
			 $buttons .=htmlButton::getButton('submit', dict('GEN_LBL_DUPLICATE')	  							, array('action' => 'DUPLICATE', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'MULT'))->source();
		}
		$buttons .=htmlButton::getButton('submit', dict('GEN_LBL_FILTER'), array('action' => 'FILTER', 'form' => $form->getProp(CLX_PROP_ID), CLX_PROP_ID => 'ON'))->source();
		$form->addContents($page->footers($table, $buttons));
		return $form->source();
	}

	function searchForm() {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) ) { $tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");   fwrite($tta,chr(13).chr(10)."1602 searchForm_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fclose($tta);}
		$contents = '';
		$msg = array();
		// Search Form
		$form = new htmlForm(CLX_PROP_ACTION, UserRequest::$server['PHP_SELF']);
		$form->addArgument(CLX_PROP_TO, $this->code);
		$form->addArgument('ac', 'SEARCH');
		$form->addArgument('confirm', '1');
		$form->addArgument(CLX_PROP_TARGET, UserRequest::$request[CLX_PROP_TARGET]);
		$table = new htmlTable(CLX_WIDTH_TWO);
		$table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
		$table->addCell(dict('TOOL_DBIM_TITLE_SEARCH'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
		$table->addField($msg, dict('GEN_LBL_CODE') . ':', 'DBIM_idcode', UserRequest::$post['DBIM_idcode'], CLX_NUM_16, CLX_NUM_16);
		$table->addField($msg, dict('GEN_LBL_NAME') . ':', 'DBIM_idname', UserRequest::$post['DBIM_idname'], CLX_NUM_32, CLX_NUM_64);
		$table->addField($msg, dict('GEN_LBL_MODULECODE') . ':', 'DBIM_modulecode', UserRequest::$post['DBIM_modulecode'], CLX_NUM_FOUR, CLX_NUM_FOUR);
		$table->addField($msg, dict('GEN_LBL_MDATE') . ':', 'DBIM_mdate', UserRequest::$post['DBIM_mdate'], CLX_NUM_FOUR, CLX_NUM_FOUR);

		$buttons = htmlButton::getButton('submit', dict('GEN_LBL_SEARCH'), array('action' => 'SEARCH', 'form' => $form->getProp(CLX_PROP_ID)))->source();
		$c = new htmlButtonCloseWindow(dict('GEN_LBL_CANCEL'));
		$buttons .= $c->source();
		$table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
		$form->setContents($table->source());
		$contents .= $form->source();
		// Search Procedure
		if (isset(UserRequest::$post['confirm'])) {
			$table = new htmlTable(CLX_WIDTH_TWO);
			$table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
			$criteria = '';
			$and='';
			if (UserRequest::$post['DBIM_idcode'] <> '') {
				$criteria .= $and.' UPPER(IDCODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['DBIM_idcode']) . '%');
				$and='AND';
			}
			if (UserRequest::$post['DBIM_idname'] <> '') {
				$criteria .= $and.' UPPER(IDNAME) LIKE ' . singleQuote(uppercase(clx_change_especial_char_html (UserRequest::$post['DBIM_idname'])) . '%');
				$and='AND';
			}
			if (UserRequest::$post['DBIM_modulecode'] <> '') {
				$criteria .= $and.' UPPER(MODULECODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['DBIM_modulecode']). '%');
				$and='AND';
			}
			if (UserRequest::$post['DBIM_mdate'] <> '') {
				$criteria .= $and.' MDATE > ' . singlequote(UserRequest::$post['DBIM_mdate']);
				$and='AND';
			}
			$qty = ClxCommon::$db->oneExistsRecords($this->tablename, $criteria);
			if ($qty == CLX_NUM_ZERO) {
				$table->addCell(dict('TOOL_GEN_ERR_NOMATCH'), array(CLX_PROP_CLASS => CLX_CLASS_ALERT, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
			} else {
				$table->addCell(dict('TOOL_GEN_MSG_FOUNDRECORDS'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
				$records = ClxCommon::$db->getRecords($this->tablename, $criteria);
				$i = CLX_INIT_ZERO;
				while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
					$js = 'javascript:setLookupValue(' . quote(UserRequest::$request[CLX_PROP_TARGET]) . ', ' . quote($record['IDCODE']) . ');';
					$table->addCells(($i % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT, array('<page t=db_import></page><a href=' . singleQuote($js) . '>' . $record['IDCODE'] . '</a>', $record['IDNAME']));
					$i++;
				}
			}
			$contents .= $table->source();
		}
		return $contents;
	}

	function confirmDeleteFill(&$table, $record) { IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);} if ( !empty($_SESSION["_dEBUG"]) ) { $tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");  fwrite($tta,chr(13).chr(10)."1610 confirmDeleteFill_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fclose($tta);}
		$table->addData(dict('GEN_LBL_CODE') . ':', $record['DBIM_idcode']);
		$table->addData(dict('GEN_LBL_NAME') . ':', $record['DBIM_idname']);
	}

	function viewFormFill($record) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}
		if ( !empty($_SESSION["_dEBUG"]) ) { $tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+"); 	fwrite($tta,chr(13).chr(10)."1611 viewFormFill_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fclose($tta);}
		addHistory('ownerid', $record['DBIM_id']);
		addHistory('ownercode', $this->code);
		addHistory('importcode', $record['DBIM_idcode']);
		$contents = '';
		$table = new htmlTable(CLX_WIDTH_TWO);
		$table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
		$table->addCell(dict('TOOL_DBIM_TITLE_VIEW') . ': ' . $record['DBIM_idname'], array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
		$table->addData(dict('GEN_LBL_CODE') . ':', $record['DBIM_idcode']);
		$table->addData(dict('GEN_LBL_NAME') . ':', $record['DBIM_idname']);
		$table->addData(dict('GEN_LBL_VERSION') . ':', $record['DBIM_version'] . '-' . $record['DBIM_version_counter']);
		$table->addData(dict('GEN_LBL_DESCRIPTION') . ':', xFormat::text($record['DBIM_description']));
		$table->addData(dict('GEN_LBL_MODULECODE') . ':', $record['DBIM_modulecode']);
		$table->addData(dict('GEN_LBL_TABLECODE') . ':', $record['DBIM_tablecode']);
		$table->addData(dict('GEN_LBL_GROUP_PRIORITY') . ':', DICT( $this->GROUP_PRIORITY[$record['DBIM_execute_priority']]));
		$table->addData(dict('GEN_LBL_IF_DUPLICATES') . ':', dict($this->if_duplicates[$record['DBIM_if_duplicates']]));
	///ECHO "EEEEEEEEEEEEEE";
		if ($this->debug==true) {
			pre("record_principal");
			pre($record);
		}
		if ($this->import_types[$record['DBIM_type']]=='GEN_LBL_XLS'||  $this->import_types[$record['DBIM_type']]=='GEN_LBL_XLS2') {

			$sheet = new HtmlSelect('DBIM_sheets');
			$rs = ClxCommon::$db->executeQuery($x2='SELECT DISTINCT IMPORTSHEETS FROM CLX_DB_IMPORT_FIELDS WHERE IMPORTCODE=' . singleQuote($record['DBIM_idcode']));

			switch (kDatabaseType) {
				case 'oci': // Oracle
					$rs2 = ClxCommon::$db->executeQuery($x='SELECT * FROM (SELECT DISTINCT IMPORTSHEETS,POSITION_SHEET FROM CLX_DB_IMPORT_MAPPINGS WHERE IMPORTSHEETS IS NOT NULL AND IMPORTCODE=' . singleQuote($record['DBIM_idcode']).')X ORDER BY POSITION_SHEET');
					break;
				default:
					$rs2 = ClxCommon::$db->executeQuery($x='SELECT * FROM (SELECT DISTINCT IMPORTSHEETS,POSITION_SHEET  FROM CLX_DB_IMPORT_MAPPINGS WHERE IMPORTSHEETS!="" AND IMPORTCODE=' . singleQuote($record['DBIM_idcode']).')X ORDER BY POSITION_SHEET' );
					break;
			}


			$r2 = ClxCommon::$db->getNextRecord($rs2, ASSOCIATIVE);
			$xcontar=0;
			if ($this->debug==true) {
				echo $x, "<br><br>";
				echo $x2,"<br><br>";
				echo "inicio ver combos de excel:<br>";
				pre('combos A '.__LINE__ .' '. __METHOD__);
					pre($r2);
				PRE("-----");	
			}
			while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
				if ($this->debug==true) {
					pre('combos b '.__LINE__ .' '. __METHOD__);
					pre($r);
					PRE("-----");
				}	
				//if (empty(UserRequest::$post['sheets_'])) {
					$match=false;
					if (isset($r2['IMPORTSHEETS']) && $r['IMPORTSHEETS']==$r2['IMPORTSHEETS'])
						$match=true;
						
					$sheet->addItem($r['IMPORTSHEETS'].'('.($xcontar).')', $r['IMPORTSHEETS'].'('.($xcontar++).')',$match);
					if ($this->debug==true) {
						echo 'combo paginas:',$r['IMPORTSHEETS'];
					}
			//	}
			//	else {
				//	$sheet->addItem($r['IMPORTSHEETS'], $r['IMPORTSHEETS'],$r['IMPORTSHEETS']==UserRequest::$post['sheets_']);
			//	}
			}
			$sheet->setProp('onchange', '$(\'[name=\\\'sheets_\\\']\').val($(\'#DBIM_sheets\').val());  ');
			$sheet->setProp('onclick', ' $(\'#DBIM_sheets\').prop( \'disabled\', false );  $(\'div[id*=\\\'MAPPINGS\\\'] tr:not(:first-child):not(:last-child) td:nth-child(4)\').each(function() {if ($(this).text()!=\''.dict('GEN_LBL_IGNORE').'\')$(\'#DBIM_sheets\').prop( \'disabled\', true )}) ');
			$table->addData(dict('GEN_LBL_COUNT_SHEETS') . ':',$sheet->source());
		}
		$table->addData(dict('GEN_LBL_TYPE') . ':', dict($this->import_types[$record['DBIM_type']]));
		$url = 'window.php?to=' . $this->code . '&ac=IMPORT_STRUCTURE&importcode=' . $record['DBIM_idcode'];
		$url2 = 'window.php?to=' . $this->code . '&ac=DOWNSAMPLE&importcode=' . $record['DBIM_idcode']."&codeoriginal=1";
		$url3 =	'window.php?to=' . $this->code . '&ac=IMPORT_RECREATE_STRUCTURE&importcode=' . $record['DBIM_idcode']."&codeoriginal=1";
		$valor_upload=(empty($record['DBIM_file'])? '':$record['DBIM_file']).(empty($record['DBIM_fileexcel'])? '':$record['DBIM_fileexcel']).(empty($record['DBIM_filefixed'])? '':$record['DBIM_filefixed']);

		$table->addData(dict('GEN_LBL_SAMPLE_FILE') . ':', empty($record['DBIM_tablecode'])? '': '<a href="' . $url . '" target="blank">' . $record['DBIM_idcode'] . '.xls</a>');

		$table->addData(dict('GEN_LBL_SAMPLE_FILEO') . ':', empty($valor_upload)? '<a href="' . $url3 . '" target="blank">' . dict('VALORGENERALFILEORIGINAL') . '</a>': '<a href="' . $url2 . '" target="blank">' . dict('VALORFILEORIGINAL') . '</a>');


		$contents .= $table->source();

		// Mappings

		if (!empty($record['DBIM_tablecode'])) {
			$DBIC = &getTool('DBIC');
			$contents .= $DBIC->makepanel($record['DBIM_idcode']);
		}
		else {
			$DBIP = &getTool('DBIP');
			$contents .= $DBIP->makepanel($record['DBIM_idcode']);
		}
		$EVNT = &getTool('EVNT');
		$contents .= $EVNT->makepanel($this->code, $record['DBIM_id']);
		$RULE = &getTool('DBIR');
		$contents .= $RULE->makepanel( $record['DBIM_idcode']);

		// Exceptions
		if ($record['DBIM_type'] === 'FRL') {
			$DBIP = &getTool('DBIP');
			$contents .= $DBIP->makepanel($record['DBIM_idcode']);
		}
		// Executions
		$DBIX = &getTool('DBIX');
		$contents .= $DBIX->makepanel($record['DBIM_idcode']);
		// Errors
		$DBIE = &getTool('DBIE');
		$contents .= $DBIE->makepanel($record['DBIM_idcode']);
		$table = new htmlTable(CLX_WIDTH_TWO);
		$table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
		$table->addData(dict('GEN_LBL_CDATE') . ':', $record['DBIM_cdate']);
		$table->addData(dict('GEN_LBL_MDATE') . ':', $record['DBIM_mdate']);
		$table->addData(dict('GEN_LBL_USERNAME') . ':', $record['DBIM_username']);
		$contents .= buildPanelInterface(dict('GEN_TTL_SYSTEMINFO'), 'SYSTEMINFO', $table->source(), CLX_NUM_MINUS_1);
		return $contents.setJavaScriptTag("$(document).ready(function(){XX=$( 'button, input[type=\'button\']:last').clone();$('#main table:first tr:last' ).after(XX);})");
	}

	function filterFormFill($msg, &$table) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) ) { $tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");  fwrite($tta,chr(13).chr(10)."1612 filterFormFill_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fclose($tta);}

	   if (!array_key_exists('DBIM_idcode', UserRequest::$post))
			UserRequest::$post['DBIM_idcode'] = '';
		if (!array_key_exists('DBIM_idname', UserRequest::$post))
			UserRequest::$post['DBIM_idname'] = '';
		if (!array_key_exists('DBIM_modulecode', UserRequest::$post))
			UserRequest::$post['DBIM_modulecode'] = '';
		$table->addField($msg, dict('GEN_LBL_CODE'), 'DBIM_idcode', UserRequest::$post['DBIM_idcode'], CLX_NUM_16, CLX_NUM_16);
		$table->addField($msg, dict('GEN_LBL_NAME'), 'DBIM_idname', UserRequest::$post['DBIM_idname'], CLX_NUM_32, CLX_NUM_64);
		$table->addField($msg, dict('GEN_LBL_MODULECODE'), 'DBIM_modulecode', UserRequest::$post['DBIM_modulecode'], CLX_NUM_FOUR, CLX_NUM_FOUR);
		$sort = new HtmlSelect('DBIM_sort');
		$sort->addItem('', '', true);
		$sort->addItem(dict('GEN_LBL_CODE'), 'idcode', false);
		$sort->addItem(dict('GEN_LBL_NAME'), 'idname', false);
		$sort->addItem(dict('GEN_LBL_MODULECODE'), 'modulecode', false);
		$table->addData(dict('GEN_LBL_ORDERBY') . ':', $sort->source());
	}
	function setfilter() {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}
		$filter = '';
		$boolean = '';
		$tbl_def = $this->toolTableStructure();
		foreach ($tbl_def['fields'] as $key => $val) {
			$formfield = $this->code . '_' . lowercase($key);
			if (array_key_exists($formfield, UserRequest::$post) && strlen(UserRequest::$post[$formfield]) > CLX_NUM_ZERO) {

				if ($formfield=='DBIM_idcode' && !empty(UserRequest::$post['DBIM_idcode'])) {
					$filter .= $boolean . ' UPPER(IDCODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['DBIM_idcode']) . '%');
					$boolean = ' AND ';
				}
				if ($formfield=='DBIM_idname' &&!empty(UserRequest::$post['DBIM_idname'])) {
					$filter .= $boolean . ' UPPER(IDNAME) LIKE ' . singleQuote(uppercase(clx_change_especial_char_html (UserRequest::$post['DBIM_idname'] )). '%');
					$boolean = ' AND ';
				}
				if ($formfield=='DBIM_modulecode' && !empty(UserRequest::$post['DBIM_modulecode'])) {
					$filter .= $boolean . ' UPPER(MODULECODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['DBIM_modulecode']) . '%');
					$boolean = ' AND ';
				}
				if ($formfield=='DBIM_date' && !empty(UserRequest::$post['DBIM_mdate'])) {
					$filter .= $boolean . ' MDATE > ' . singleQuote(UserRequest::$post['DBIM_mdate']);
					$boolean = ' AND ';
				}
				if ($formfield=='DBIM_tablecode' && !empty(UserRequest::$post['DBIM_tablecode'])) {
					$filter .= $boolean . ' tablecode=  ' . singleQuote(UserRequest::$post['DBIM_tablecode']);
					$boolean = ' AND ';
				}
				if ($formfield=='DBIM_execute_priority' && !empty(UserRequest::$post['DBIM_execute_priority'])) {
					$filter .= $boolean . ' execute_priority=  ' . singleQuote(UserRequest::$post['DBIM_execute_priority']);
					$boolean = ' AND ';
				}
				
				
				if ($formfield=='DBIM_type' &&!empty(UserRequest::$post['DBIM_type'])){
				//	pre($formatfield);
				//	pre($filter);
					$filter .= $boolean.'TYPE = ' . singleQuote(UserRequest::$post['DBIM_type'] );
				}	
				$_SESSION['paging']['DBIMList']['sortby'] = empty(UserRequest::$post['DBIM_sort'])?'':UserRequest::$post['DBIM_sort'];
			}
		}

		$this->setFilterKeys($filter, '', 0);
	}

	/**
	 * Set filter keys
	 * @param string $filter
	 * @param string $sortby
	 * @param int $startat
	 */

	function setfilterold() {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) ) { $tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+"); 	fwrite($tta,chr(13).chr(10)."161 setfilter_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fclose($tta);}
		$filter = '';
		$boolean = '';
		parent::setfilter();
		if (!empty(UserRequest::$post['DBIM_idcode'])) {
			$filter .= $boolean . ' UPPER(IDCODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['DBIM_idcode']) . '%');
			$boolean = ' AND ';
		}
		if (!empty(UserRequest::$post['DBIM_idname'])) {
			$filter .= $boolean . ' UPPER(IDNAME) LIKE ' . singleQuote(uppercase(clx_change_especial_char_html (UserRequest::$post['DBIM_idname'] )). '%');
			$boolean = ' AND ';
		}
		if (!empty(UserRequest::$post['DBIM_modulecode'])) {
			$filter .= $boolean . ' UPPER(MODULECODE) LIKE ' . singleQuote(uppercase(UserRequest::$post['DBIM_modulecode']) . '%');
			$boolean = ' AND ';
		}
		if (!empty(UserRequest::$post['DBIM_mdate'])) {
			$filter .= $boolean . ' MDATE > ' . singleQuote(UserRequest::$post['DBIM_mdate']);
			$boolean = ' AND ';
		}
		if (!empty(UserRequest::$post['DBIM_type']))
			$filter .= $boolean.'TYPE = ' . singleQuote(UserRequest::$post['DBIM_type'] );
		$_SESSION['paging']['DBIMList']['sortby'] = empty(UserRequest::$post['DBIM_sort'])?'':UserRequest::$post['DBIM_sort'];
		//$_SESSION['paging']['DBIMList']['criteria'] = $filter;
		//$_SESSION['paging']['DBIMList']['startat'] = '0';
	}
	///////////////////////////////////////////////////
	///comentado 22/01/2019 para utilizar la clx_tool
	//////////////////////////////////////////////////
	/*function clearfilter() {if ( !empty($_SESSION["_dEBUG"]) ) { $tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");	fwrite($tta,chr(13).chr(10)."16098 editForm_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fclose($tta);}
		$_SESSION['paging']['DBIMList']['criteria'] = '';
	}*/

	function loadToolRecord($recordid) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) ) { $tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");  fwrite($tta,chr(13).chr(10)."16098 editForm_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fclose($tta);}
		$values = ClxCommon::$db->getRecord($this->tablename, 'ID= ' . $recordid);
		$record = array();
		$record['DBIM_id'] = $recordid;
		$record['DBIM_idcode'] = $values['IDCODE'];
		$record['DBIM_idname'] = $values['IDNAME'];
		$record['DBIM_version'] = $values['VERSION'];
		$record['DBIM_version_counter'] = $values['VERSION_COUNTER'];
		$record['DBIM_cdate'] = xFormat::date($values['CDATE']);
		$record['DBIM_mdate'] = xFormat::date($values['MDATE']);
		$record['DBIM_username'] = $values['USERNAME'];
		$record['DBIM_description'] = $values['DESCRIPTION'];
		$record['DBIM_modulecode'] = $values['MODULECODE'];
		$record['DBIM_tablecode'] = $values['TABLECODE'];
		$record['DBIM_file']	  = $values['FILE'];
		$record['DBIM_filefixed'] = $values['FILE_DELIM'];
		$record['DBIM_fileexcel'] = $values['FILE_EXCEL'];
		$record['DBIM_newtablecode'] = $values['NEWTABLECODE'];
		$record['DBIM_type'] = $values['TYPE'];
		$record['DBIM_if_duplicates'] = $values['IF_DUPLICATES'];
		$record['DBIM_IF_UTF8'] = $values['IF_UTF8'];
		$record['DBIM_excel_count_sheets'] = $values['EXCEL_COUNT_SHEETS'];
		if (strpos($values['FIELD_DELIM'],":")>0 or ((!empty($values['FIELD_DELIM'][0]))&& $values['FIELD_DELIM'][0]=='[')) {
			$record['DBIM_field_delim'] =json_decode($values['FIELD_DELIM'],true);
		}
		else {
			$record['DBIM_field_delim'] = $values['FIELD_DELIM'];
		}

		$record['DBIM_field_cdelim'] =json_decode($values['FIELD_CDELIM'],true);

//		$delim_record=array_keys(json_decode($record["DBIM_field_delim"],true));
//		$field_prop=array_keys(json_decode($record["DBIM_field_delim"],true));
		$record['DBIM_record_prop']=json_decode($values["RECORD_PROP"],true);
		$record['DBIM_record_cprop']=json_decode($values["RECORD_CPROP"],true);
		$record['DBIM_record_delim'] = $values['RECORD_DELIM'];
		$record['DBIM_field_delim_other'] = $values['FIELD_DELIM'];
		$record['DBIM_record_delim_other'] = $values['RECORD_DELIM'];
		$record['DBIM_record_length'] = $values['RECORD_LENGTH'];
// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - BEGIN
		$record['DBIM_record_delim_frl'] = $values['RECORD_DELIM'];
		$record['DBIM_record_delim_other_frl'] = $values['RECORD_DELIM'];
// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - END
		$record['DBIM_excel_type'] = $values['EXCEL_TYPE'];
		$record['DBIM_execute_priority'] = $values['EXECUTE_PRIORITY'];
		return $record;
	}

	function checkForm(&$msg) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) ) { $tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");   fwrite($tta,chr(13).chr(10)."16098 editForm_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fclose($tta);}
		$form = new clx_form($this->code, $this->editform);
		$record=UserRequest::$post;
		$retorno=$form->checkForm1(UserRequest::$post['ac'],$record, $msg);
		if (empty($record["DBIM_tablecode"]) and empty($record["DBIM_newtablecode"]) ) {
			$msg['DBIM_tablecode'] = smsg('MSG-7512345678');
			$retorno =false;
		}
		return $retorno;
	}
	function comuncodesaverecord(&$record){IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}
		if (empty(UserRequest::$post['DBIM_newtablecode']))	UserRequest::$post['DBIM_newtablecode']='';
		if (empty(UserRequest::$post['DBIM_field_delim']))	UserRequest::$post['DBIM_field_delim']='';
		if (empty(UserRequest::$post['DBIM_field_prop']))	UserRequest::$post['DBIM_field_prop']='';
		if (empty(UserRequest::$post['DBIM_record_delim']))	UserRequest::$post['DBIM_record_delim']='';

		$record['IDNAME'] = UserRequest::$post['DBIM_idname'];
		$record['VERSION'] = UserRequest::$post['DBIM_version'];
		$record['MDATE'] = xFormat::getNow('Y-m-d');
		$record['USERNAME'] = $_SESSION['user_record']['username'];
		$record['DESCRIPTION'] = UserRequest::$post['DBIM_description'];
		$record['MODULECODE'] = UserRequest::$post['DBIM_modulecode'];
		$record['TABLECODE'] = UserRequest::$post['DBIM_tablecode'];
		$record['NEWTABLECODE'] = UserRequest::$post['DBIM_newtablecode'];
		$record['TYPE'] = UserRequest::$post['DBIM_type'];
		$record['IF_DUPLICATES'] = UserRequest::$post['DBIM_if_duplicates'];
		$record['IF_UTF8'] = UserRequest::$post['DBIM_IF_UTF8'];
		$record['EXCEL_COUNT_SHEETS']= UserRequest::$post['DBIM_excel_count_sheets'];
		$record['EXCEL_TYPE']= UserRequest::$post['DBIM_excel_type'];
		$record['EXECUTE_PRIORITY']= UserRequest::$post['DBIM_execute_priority'] ;
		if (!empty(UserRequest::$files['DBIM_file']['name'])) {
			$record['FILE'] =	   UserRequest::$files['DBIM_file']['name'];
			if (file_exists(UserRequest::$files['DBIM_file']['tmp_name']))
				$record['FILE_C'] =	  base64_encode(file_get_contents(UserRequest::$files['DBIM_file']['tmp_name']));
		}
		if (!empty(UserRequest::$files['DBIM_filefixed']['name'])) {
			$record['FILE_DELIM'] = UserRequest::$files['DBIM_filefixed']['name'];
			if (file_exists(UserRequest::$files['DBIM_filefixed']['tmp_name']))
				$record['FILE_CDELIM'] = base64_encode(file_get_contents(UserRequest::$files['DBIM_filefixed']['tmp_name']));
		}
		if (!empty(UserRequest::$files['DBIM_fileexcel']['name'])) {
			$record['FILE_EXCEL'] = UserRequest::$files['DBIM_fileexcel']['name'];
			if (file_exists(UserRequest::$files['DBIM_fileexcel']['tmp_name']))
				$record['FILE_CEXCEL'] = base64_encode(file_get_contents(UserRequest::$files['DBIM_fileexcel']['tmp_name']));
		}


		if ($record['TYPE'] === 'FRL' ||$record['TYPE'] === 'FRL2'||$record['TYPE'] === 'FRL3') {
			$record['RECORD_LENGTH'] = UserRequest::$post['DBIM_record_length'];
// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - BEGIN
			if (UserRequest::$post['DBIM_record_delim_frl'] === 'other') {
				$record['RECORD_DELIM'] = UserRequest::$post['DBIM_record_delim_other_frl'];
			} else if (isset(UserRequest::$post['DBIM_record_delim_frl'])){
				$record['RECORD_DELIM'] = UserRequest::$post['DBIM_record_delim_frl'];
			} else if (isset(UserRequest::$post['DBIM_record_delim'])){
				$record['RECORD_DELIM'] = UserRequest::$post['DBIM_record_delim'];
			}
// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - END

		}
		else
			$record['RECORD_DELIM']=UserRequest::$post["DBIM_record_delim"];
		if (is_Array(UserRequest::$post['DBIM_field_delim'])) {
			$record['FIELD_DELIM']=json_encode(UserRequest::$post['DBIM_field_delim']);
		}
		if (is_Array(UserRequest::$post['DBIM_field_cdelim'])) {
			for ($x=4;$x<7;$x++) {
				if (!empty(UserRequest::$post['DBIM_field_cdelim'][$x])) {
					switch (lowercase(UserRequest::$post['DBIM_field_cdelim'][$x])) {
						case "&quot;":
							UserRequest::$post['DBIM_field_cdelim'][$x]='"';


					}
				}
			}
			$record['FIELD_CDELIM']=json_encode(UserRequest::$post['DBIM_field_cdelim']);

		}

		if (is_Array(UserRequest::$post['DBIM_field_prop'])) {
			$record['FIELD_PROP']=json_encode(UserRequest::$post['DBIM_field_prop']);
		}
		if (!empty(UserRequest::$post['DBIM_record_prop']) and is_Array(UserRequest::$post['DBIM_record_prop'])) {

			for ($k=0;$k<10;$k++){
				if (substr(UserRequest::$post  ['DBIM_type'] ,0,3)=='XLS' && $k<8) {
					unset (UserRequest::$post["DBIM_record_prop"][$k]);
					unset (UserRequest::$post["DBIM_record_cprop"][$k]);

				}
				if (substr(UserRequest::$post  ['DBIM_type'] ,0,3)=='CSV' && $k>1){
					unset (UserRequest::$post["DBIM_record_prop"][$k]);
					unset (UserRequest::$post["DBIM_record_cprop"][$k]);
				}
			}

			$record['RECORD_PROP']=json_encode(UserRequest::$post["DBIM_record_prop"]);
			$record['RECORD_CPROP']=json_encode(UserRequest::$post["DBIM_record_cprop"]);

		}
		else {
			$record['RECORD_PROP']=json_encode(array());
		}
		
		//


	}
	function saveRecord() {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) ) { $tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");   fwrite($tta,chr(13).chr(10)."16098 editForm_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fclose($tta);}
		$record=array();
		UserResponse::setRunTimeLimit(CLX_NUM_FIVE * CLX_NUM_60);

		$DBIU=new db_import_run();
		$this->comuncodesaverecord($record);
	//	pr e(UserRequest::$post);
		$importrec = ClxCommon::$db->getRecord($this->tablename, 'UPPER(IDCODE)=' . singleQuote(uppercase(UserRequest::$post['DBIM_idcode'] )));
		$si=false;
		//ClxCommon::$db->deleteRecords('CLX_DB_IMPORT_FIELDS', 'IMPORTCODE=' . UserRequest::$post['DBIM_id']);


		if (substr($importrec["TYPE"],0,3)!=substr(UserRequest::$post['DBIM_type'],0,3) || (!empty(UserRequest::$post['DBIM_fileexcel']) or !empty(UserRequest::$post['DBIM_file']) or !empty(UserRequest::$post['DBIM_filefixed']))) {
			ClxCommon::$db->deleteRecords('CLX_DB_IMPORT_FIELDS', 'IMPORTCODE=' . singleQuote(UserRequest::$post['DBIM_idcode']));
		//}
		//if (!(empty(UserRequest::$post['DBIM_fileexcel']) ||empty(UserRequest::$post['DBIM_file']) || empty(UserRequest::$post['DBIM_filefixed'])) {

			$mappings=$DBIU->getMappings(UserRequest::$post['DBIM_idcode']);
			if (empty($mappings))
				$mappingsheet='';
			else
				$mappingsheet=$mappings[array_keys($mappings)[0]]['IMPORTSHEETS'];
			//ClxCommon::$db->deleteRecords('CLX_DB_IMPORT_MAPPINGS', 'IMPORTCODE=' . UserRequest::$post['DBIM_id']);
			ClxCommon::$db->deleteRecords('CLX_DB_IMPORT_MAPPINGS', 'IMPORTCODE=' . singleQuote(UserRequest::$post['DBIM_idcode']));
			$si=true;
		}

		ClxCommon::$db->updateRecord($this->tablename, $record, 'ID=' . UserRequest::$post['DBIM_id']);
		$this->versionIncrease('ID', UserRequest::$post['DBIM_id']);
		if (!array_key_exists('RECORD_DELIM', $record))
			$record['RECORD_DELIM'] = "";
		if (!array_key_exists('FIELD_DELIM', $record)) {
			$record['FIELD_DELIM'] = json_encode(array());
			$record['FIELD_CDELIM'] = json_encode(array());

		}

		if (empty($mappings))
				$mappingsheet='';
		if (!empty(UserRequest::$post['DBIM_fileexcel']) or !empty(UserRequest::$post['DBIM_file']) or !empty(UserRequest::$post['DBIM_filefixed'])) {
			$DBIU->getFields(UserRequest::$post['DBIM_idcode'], replace_ascii_chars($record['RECORD_DELIM']), $record['FIELD_DELIM'],$record['FIELD_CDELIM'],$mappingsheet);
		}

		$DBIU->basicFields($record['TABLECODE']);
		if ($si==true) {
			$x=rand(0,100000000000);
			$sql='DELETE FROM CLX_MESSAGE WHERE IDCODE ='.SINGLEQUOTE('Xmsg_'.$x);
			ClxCommon::$db->executequery($sql);
			ClxCommon::$db->executequery('commit');
			$MSG=base64_encode(NOTE(dict('MESG_SAVE01').UserRequest::$post['DBIM_idcode']));
			$sql='INSERT INTO CLX_MESSAGE (ID,IDCODE,TEXT_MESSAGE) VALUES (0,'.SINGLEQUOTE('Xmsg_'.$x).','. SINGLEQUOTE($MSG).  ')';
			ClxCommon::$db->executequery($sql);
			ClxCommon::$db->executequery('commit');
			OB_CLEAN();
			header('Location:'.''. kWebSite.'tool.php?ac=SHOWMSG&to=EDIT&Xmsg='.'Xmsg_'.$x);
		}
		ClxCommon::$db->executequery('UPDATE '.$this->tablename.' SET EXECUTE_PRIORITY='.UserRequest::$post['DBIM_execute_priority'].' WHERE TABLECODE='.singlequote(UserRequest::$post['DBIM_tablecode']));
	}

	function createRecord_() {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) ) { $tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");	fwrite($tta,chr(13).chr(10)."16098 editForm_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fclose($tta);}
		$record=array();
		$record['IDCODE'] = UserRequest::$post['DBIM_idcode'];
		$record['VERSION_COUNTER'] = '0';
		$this->comuncodesaverecord($record);
		$record['CDATE'] = $record['MDATE'];
		$recordid = ClxCommon::$db->createRecord($this->tablename, $record, false);
		
		if ($this->debug==true) {echo $b='update import in '.__LINE__;pre($record);if (isset($this->debugescribir) && $this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}

		$DBMO = &getTool('DBMO');
		$DBMO->versionIncrease('IDCODE', $record['MODULECODE']);
		if (!array_key_exists('RECORD_DELIM', $record))
			$record['RECORD_DELIM'] = '';
		if (!array_key_exists('FIELD_DELIM', $record)) {
			$record['FIELD_DELIM'] = json_encode(array());
			$record['FIELD_CDELIM'] = json_encode(array());
		}
		$DBIU=new db_import_run();
		if (!empty($record['FILE_C']) or !empty($record['FILE_CDELIM']) or !empty($record['FILE_CEXCEL'])) {
			$DBIU->getFields(UserRequest::$post['DBIM_idcode'], replace_ascii_chars($record['RECORD_DELIM']),  $record['FIELD_DELIM'],$record['FIELD_CDELIM']);
		}
		$DBIU->basicFields($record['TABLECODE']);
		ClxCommon::$db->executequery('UPDATE '.$this->tablename.' SET EXECUTE_PRIORITY='.UserRequest::$post['DBIM_execute_priority'].' WHERE TABLECODE='.singlequote(UserRequest::$post['DBIM_tablecode']));

		return $recordid;
	}

	public function import_batch_run($group) {
		
		IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}
		pre("group");
		pre($group);
		
		print CLX_CHAR_NL . 'Checking for pending Imports';
		if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1611;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		
		$DBIMR = new db_import_run();
		$DBIMR->import_batch_run($group);
		$this->importscode=$DBIMR->importscode;
		print CLX_CHAR_NL . 'Done with the Imports' . CLX_CHAR_NL;
	}
}

////////////////////////////////////
////////////////////////////////////

class db_import_run extends clx_tool {
	var $import_types;
	var $import_typesnormal;
	var $import_excel_types;
	var $importForm;
	var $idcode;
	var $if_duplicates;
	var $excel_count_sheets;
	var $record_commit_counter = CLX_NUM_FIVE;
	private $formula_file = '';
	// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - BEGIN
	var $use_record_delimiter_reading_fixlen_files = false; // flag to use record delimiter instead of record length reading fixed length files
	// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - END

	function __construct() {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}
			$this->code = 'DBIM';
			$this->name = 'Import Import Run';
			$this->system = 'Database';
			$this->tablename = 'CLX_DB_IMPORTS';
			$this->record_name_singular = 'import';
			$this->record_name_plural = 'imports';
			$this->primary_field = 'IDCODE';
			$this->secondary_field = 'IDNAME';
//		$this->memorylimit=companyParameterDef('DBIM_BATCH_MEMLIMIT', '300M', null);
		$this->import_extra_fields_required = '';//companyParameterDef('IMPORT_EXTRA_FIELDS_REQUIRED', 'DBIM', $_SESSION['prefs']['UIFF_COMP_CODE']);
		$this->fieldnotignr=ARRAY();//'CDATE','MDATE','CREATEDBY','MODIFIEDBY');
		multiTableName($this,array('IMFT'));
		//$GLOBALS['ADDRDEBUGIMPORTREP']='(1)';
		IF (  ( ISSET($GLOBALS['ADDRDEBUGIMPORT']) && $GLOBALS['ADDRDEBUGIMPORT']==$_SERVER['REMOTE_ADDR'])) {
			$this->debug=true;
			$this->debugescribir=false;
		}
		else if ( ISSET($GLOBALS['ADDRDEBUGIMPORTREP']) && ($GLOBALS['ADDRDEBUGIMPORTREP']==$_SERVER['REMOTE_ADDR'] or $GLOBALS['ADDRDEBUGIMPORTREP']=='(1)' )){
			$this->debug=true;
			$this->debugescribir=true;
		}
		IF (  ( ISSET($GLOBALS['ADDRDEBUGIMPORTVALID']) && $GLOBALS['ADDRDEBUGIMPORTVALID']==$_SERVER['REMOTE_ADDR'])) {
			$this->debugValid=true;
		
		}
	}
	function basicFields($tablecode) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}
		if (empty($this->import_extra_fields_required)) {
			$this->modulecode = ClxCommon::$db->getone('SELECT MODULECODE FROM CLX_DB_TABLES WHERE IDCODE='.singleQuote($tablecode));
			if ($this->modulecode=='USER') {
				$this->import_extra_fields_required='FILEDATE_REQ,CDATE,MDATE,ID,IMPORTCODE,LINE_OF_LOG_ID,LOG_ID,CREATEDBY,MODIFIEDBY,IMPORTSHEETS';
			}
			else {
				$this->import_extra_fields_required='.';
				return false;
			}
		}
		elseif ($this->import_extra_fields_required=='.') {
			return false;
		}
		$rs = ClxCommon::$db->executeQuery('SELECT FIELDNAME FROM CLX_DB_TABLEFIELDS WHERE TABLECODE='.singleQuote($tablecode));
		//Select imports and run them
		$fields=array();
		while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
			$fields[$r['FIELDNAME']]=$r['FIELDNAME'];
		}
		$antpost=UserRequest::$post;
		$antget=UserRequest::$get;
		$antrequest=UserRequest::$request;
		UserRequest::$post=array();

		$DBTB = &getTool('DBTB');
		$DBFL = &getTool('DBFL');
		$DBTF = &getTool('DBTF');
		$DBTI = &getTool('DBTI');

		if (isset(ClxCommon::$db->debugCF) && ClxCommon::$db->debugCF==true){
			pre($fields);
		}
		if (!empty($this->import_extra_fields_required) && $this->import_extra_fields_required!='.') {
			$insertfields=explode(",",str_replace(' ','',$this->import_extra_fields_required));
		$infofield=array ( 'to' => 'DBTF',  'ac' => 'INCLUDE',  'confirm' => '1',  'DBTF_id' => '',  'DBTF_tablecode' => $tablecode,  'DBTF_cascade_delete' => '0',  'idlist' => '',  'DBTF_fieldname' => 'CDATE',  'submit1' => 'Incluir');
		for($t=0;$t<count($insertfields);$t++) {
			if ( !isset($fields[$insertfields[$t]]) ) {
				if ($insertfields[$t]=='LINE_OF_LOG_ID') {
					if (!ClxCommon::$db->getOne('SELECT count(FIELDNAME) FROM CLX_DB_FIELDS WHERE FIELDNAME='.singleQuote('LINE_OF_LOG_ID')))
					{
						UserRequest::$post=array ('to' => 'DBFL','ac' => 'CREATE','confirm' => '1','DBFL_id' => '','idlist' => '', 'BOOL_extra1' => '',  'BOOL_extra2' => '',  'DBFL_fieldlistlabel' => '',  'DBFL_fieldformlabel' => '',  'DBFL_fieldprefix' => '',  'DBFL_fieldsufix' => '',  'DBFL_fieldname' => 'LINE_OF_LOG_ID',  'DBFL_description' => 'LINE_OF_LOG_ID',  'DBFL_fieldtype' => 'INTN',  'DBFL_version' => '1.0.0',  'BLOB_size' => '1',  'BOOL_extra1_DICT' => '',  'BOOL_extra2_DICT' => '',  'BOOL_default' => '0',  'BOOL_extra3' => '0',  'CHAR_size' => '32',  'CHAR_required' => '0',  'CHAR_format' => '0',  'CHAR_align' => '0',  'CHAR_default' => 'null',  'CHAR_displaysize' => '32',  'DATE_required' => '0',  'DATE_format' => 'Y-m-d',  'DATE_default' => 'today',  'DATE_displaysize' => '30',  'DATE_size' => '30',  'DATI_required' => '0',  'DATI_format' => 'Y-m-d H:i:s',  'DATI_default' => 'today',  'DATI_displaysize' => '30',  'DATI_size' => '30',  'DECN_required' => '0',  'DECN_format' => '10,2',  'DECN_align' => '2',  'DECN_default' => '0.00',  'DECN_minvalue' => '0.00',  'DECN_maxvalue' => '100.00',  'DECN_displaysize' => '20',  'DECN_extra1' => '0',  'DECN_extra2' => '2',  'FILE_required' => '0',  'FILE_extra1' => '',  'FILE_maxvalue' => '2',  'FILE_extra2' => '0',  'FILE_extra3' => 'data/files/',  'INTN_size' => '3',  'INTN_required' => '0',  'INTN_extra1' => '0',  'INTN_extra2' => '0',  'INTN_align' => '2',  'INTN_default' => '0',  'INTN_minvalue' => '0',  'INTN_maxvalue' => '10000000',  'INTN_displaysize' => '10',  'LIST_required' => '0',  'LIST_extra1' => '',  'LIST_extra2' => '',  'LIST_extra3' => '0',  'LIST_extra4' => '1',  'LOOK_required' => '0',  'LOOK_default' => 'null',  'LOOK_extra1' => '',  'LOOK_extra2' => '',  'LOOK_extra3' => '',  'LOOK_extra4' => '',  'LOOK_extra9' => '',  'LOOK_extra5' => '0',  'LOOK_extra8' => '0',  'LOOK_extra6' => '',  'LOOK_extra7' => '',  'SOBJ_required' => '0',  'SOBJ_extra1' => 'ACTR',  'SLUK_required' => '0',  'SLUK_extra1' => 'CLX_',  'SLUK_extra2' => '',  'SLUK_extra3' => '',  'SLUK_extra4' => '',  'TEXT_size' => '1',  'TEXT_extra1' => '4',  'TEXT_extra2' => '48',  'TIME_required' => '0',  'TIME_format' => 'H:i:s',  'TIME_default' => 'now',  'TIME_displaysize' => '30',  'TLOK_extra1' => '',  'RECU_required' => '0',  'RECU_default' => 'NONE',  'BARS_size' => '32',  'BARS_required' => '0',  'BARS_format' => '0',  'BARS_align' => '0',  'BARS_extra1' => 'UCC128',  'BARS_default' => 'null',  'BARS_displaysize' => '32',  'DBFL_fieldlistlabel_DICT' => 'LINE_OF_LOTE',  'DBFL_fieldformlabel_DICT' => 'LINE_OF_LOTE',  'DBFL_fieldprefix_DICT' => '',  'DBFL_fieldsufix_DICT' => '',  'DBFL_field_anchor' => '',  'DBFL_fieldformula' => '',  'submit1' => 'Crear');
						$DBFL->createRecord_();
					}
				}
				else if ($insertfields[$t]=='LOG_ID') {
					if (!ClxCommon::$db->getOne('SELECT count(FIELDNAME) FROM CLX_DB_FIELDS WHERE FIELDNAME='.singleQuote('LOG_ID')))
					{
						UserRequest::$post=array ('to' => 'DBFL','ac' => 'CREATE','confirm' => '1','DBFL_id' => '','idlist' => '', 'BOOL_extra1' => '',  'BOOL_extra2' => '',  'DBFL_fieldlistlabel' => '',  'DBFL_fieldformlabel' => '',  'DBFL_fieldprefix' => '',  'DBFL_fieldsufix' => '',  'DBFL_fieldname' => 'LOG_ID',  'DBFL_description' => 'LOG_ID',  'DBFL_fieldtype' => 'INTN',  'DBFL_version' => '1.0.0',  'BLOB_size' => '1',  'BOOL_extra1_DICT' => '',  'BOOL_extra2_DICT' => '',  'BOOL_default' => '0',  'BOOL_extra3' => '0',  'CHAR_size' => '32',  'CHAR_required' => '0',  'CHAR_format' => '0',  'CHAR_align' => '0',  'CHAR_default' => 'null',  'CHAR_displaysize' => '32',  'DATE_required' => '0',  'DATE_format' => 'Y-m-d',  'DATE_default' => 'today',  'DATE_displaysize' => '30',  'DATE_size' => '30',  'DATI_required' => '0',  'DATI_format' => 'Y-m-d H:i:s',  'DATI_default' => 'today',  'DATI_displaysize' => '30',  'DATI_size' => '30',  'DECN_required' => '0',  'DECN_format' => '10,2',  'DECN_align' => '2',  'DECN_default' => '0.00',  'DECN_minvalue' => '0.00',  'DECN_maxvalue' => '100.00',  'DECN_displaysize' => '20',  'DECN_extra1' => '0',  'DECN_extra2' => '2',  'FILE_required' => '0',  'FILE_extra1' => '',  'FILE_maxvalue' => '2',  'FILE_extra2' => '0',  'FILE_extra3' => 'data/files/',  'INTN_size' => '3',  'INTN_required' => '0',  'INTN_extra1' => '0',  'INTN_extra2' => '0',  'INTN_align' => '2',  'INTN_default' => '0',  'INTN_minvalue' => '0',  'INTN_maxvalue' => '10000000',  'INTN_displaysize' => '10',  'LIST_required' => '0',  'LIST_extra1' => '',  'LIST_extra2' => '',  'LIST_extra3' => '0',  'LIST_extra4' => '1',  'LOOK_required' => '0',  'LOOK_default' => 'null',  'LOOK_extra1' => '',  'LOOK_extra2' => '',  'LOOK_extra3' => '',  'LOOK_extra4' => '',  'LOOK_extra9' => '',  'LOOK_extra5' => '0',  'LOOK_extra8' => '0',  'LOOK_extra6' => '',  'LOOK_extra7' => '',  'SOBJ_required' => '0',  'SOBJ_extra1' => 'ACTR',  'SLUK_required' => '0',  'SLUK_extra1' => 'CLX_',  'SLUK_extra2' => '',  'SLUK_extra3' => '',  'SLUK_extra4' => '',  'TEXT_size' => '1',  'TEXT_extra1' => '4',  'TEXT_extra2' => '48',  'TIME_required' => '0',  'TIME_format' => 'H:i:s',  'TIME_default' => 'now',  'TIME_displaysize' => '30',  'TLOK_extra1' => '',  'RECU_required' => '0',  'RECU_default' => 'NONE',  'BARS_size' => '32',  'BARS_required' => '0',  'BARS_format' => '0',  'BARS_align' => '0',  'BARS_extra1' => 'UCC128',  'BARS_default' => 'null',  'BARS_displaysize' => '32',  'DBFL_fieldlistlabel_DICT' => 'LINE_OF_LOTE',  'DBFL_fieldformlabel_DICT' => 'LINE_OF_LOTE',  'DBFL_fieldprefix_DICT' => '',  'DBFL_fieldsufix_DICT' => '',  'DBFL_field_anchor' => '',  'DBFL_fieldformula' => '',  'submit1' => 'Crear');
						$DBFL->createRecord_();
					}
				}
				else if ($insertfields[$t]=='IMPORTSHEETS') {
					if (!ClxCommon::$db->getOne('SELECT count(FIELDNAME) FROM CLX_DB_FIELDS WHERE FIELDNAME='.singleQuote('IMPORTSHEETS')))
					{
						UserRequest::$post=array ( 'to' => 'DBFL',  'ac' => 'CREATE',  'confirm' => '1',  'DBFL_id' => '',  'idlist' => '',  'BOOL_extra1' => '',  'BOOL_extra2' => '',  'DBFL_fieldlistlabel' => '',  'DBFL_fieldformlabel' => '',  'DBFL_fieldprefix' => '',  'DBFL_fieldsufix' => '',  'DBFL_fieldname' => 'IMPORTSHEETS',  'DBFL_description' => 'IMPORT SHEETS',  'DBFL_fieldtype' => 'CHAR',  'DBFL_version' => '1.0.0',  'BLOB_size' => '1',  'BOOL_extra1_DICT' => '',  'BOOL_extra2_DICT' => '',  'BOOL_default' => '0',  'BOOL_extra3' => '0',  'CHAR_size' => '255',  'CHAR_required' => '0',  'CHAR_format' => '0',  'CHAR_align' => '0',  'CHAR_default' => 'null',  'CHAR_displaysize' => '32',  'DATE_required' => '0',  'DATE_format' => 'Y-m-d',  'DATE_default' => 'today',  'DATE_displaysize' => '30',  'DATE_size' => '30',  'DATI_required' => '0',  'DATI_format' => 'Y-m-d H:i:s',  'DATI_default' => 'today',  'DATI_displaysize' => '30',  'DATI_size' => '30',  'DECN_required' => '0',  'DECN_format' => '10,2',  'DECN_align' => '2',  'DECN_default' => '0.00',  'DECN_minvalue' => '0.00',  'DECN_maxvalue' => '100.00',  'DECN_displaysize' => '20',  'DECN_extra1' => '0',  'DECN_extra2' => '2','FILE_required' => '0',  'FILE_extra1' => '',  'FILE_maxvalue' => '2',  'FILE_extra2' => '0',  'FILE_extra3' => 'data/files/',  'INTN_size' => '3',  'INTN_required' => '0',  'INTN_extra1' => '0',  'INTN_extra2' => '0',  'INTN_align' => '2',  'INTN_default' => '0',  'INTN_minvalue' => '0',  'INTN_maxvalue' => '100',  'INTN_displaysize' => '10',  'LIST_required' => '0',  'LIST_extra1' => '',  'LIST_extra2' => '',  'LIST_extra3' => '0',  'LIST_extra4' => '1',  'LOOK_required' => '0',  'LOOK_default' => 'null',  'LOOK_extra1' => '',  'LOOK_extra2' => '',  'LOOK_extra3' => '',  'LOOK_extra4' => '',  'LOOK_extra9' => '',  'LOOK_extra5' => '0',  'LOOK_extra8' => '0',  'LOOK_extra6' => '',  'LOOK_extra7' => '',  'SOBJ_required' => '0',  'SOBJ_extra1' => 'ACTR',  'SLUK_required' => '0',  'SLUK_extra1' => 'CLX_',  'SLUK_extra2' => '',  'SLUK_extra3' => '',  'SLUK_extra4' => '',  'TEXT_size' => '1',  'TEXT_extra1' => '4',  'TEXT_extra2' => '48',  'TIME_required' => '0',  'TIME_format' => 'H:i:s',  'TIME_default' => 'now',  'TIME_displaysize' => '30',  'TLOK_extra1' => '',  'RECU_required' => '0',  'RECU_default' => 'NONE',  'BARS_size' => '32',  'BARS_required' => '0',  'BARS_format' => '0',  'BARS_align' => '0',  'BARS_extra1' => 'UCC128',  'BARS_default' => 'null',  'BARS_displaysize' => '32',  'DBFL_fieldlistlabel_DICT' => 'IMPORTS SHEETS',  'DBFL_fieldformlabel_DICT' => 'IMPORTS SHEETS',  'DBFL_fieldprefix_DICT' => '',  'DBFL_fieldsufix_DICT' => '',  'DBFL_field_anchor' => '',  'DBFL_fieldformula' => '',  'submit1' => 'Crear');
						$DBFL->createRecord_();
					}
				}
					else if ($insertfields[$t]=='FILEDATE_REQ') {
						if (!ClxCommon::$db->getOne('SELECT count(FIELDNAME) FROM CLX_DB_FIELDS WHERE FIELDNAME='.singleQuote('FILEDATE_REQ')))
					{
						UserRequest::$post=//array ( 'to' => 'DBFL',  'ac' => 'CREATE',  'confirm' => '1',  'DBFL_id' => '',  'idlist' => '',  'BOOL_extra1' => '',  'BOOL_extra2' => '',  'DBFL_fieldlistlabel' => '',  'DBFL_fieldformlabel' => '',  'DBFL_fieldprefix' => '',  'DBFL_fieldsufix' => '',  'DBFL_fieldname' => 'IMPORTCODE',  'DBFL_description' => 'IMPORT CODES',  'DBFL_fieldtype' => 'CHAR',  'DBFL_version' => '1.0.0',  'BLOB_size' => '1',  'BOOL_extra1_DICT' => '',  'BOOL_extra2_DICT' => '',  'BOOL_default' => '0',  'BOOL_extra3' => '0',  'CHAR_size' => '16',  'CHAR_required' => '0',  'CHAR_format' => '0',  'CHAR_align' => '0',  'CHAR_default' => 'null',  'CHAR_displaysize' => '32',  'DATE_required' => '0',  'DATE_format' => 'Y-m-d',  'DATE_default' => 'today',  'DATE_displaysize' => '30',  'DATE_size' => '30',  'DATI_required' => '0',  'DATI_format' => 'Y-m-d H:i:s',  'DATI_default' => 'today',  'DATI_displaysize' => '30',  'DATI_size' => '30',  'DECN_required' => '0',  'DECN_format' => '10,2',  'DECN_align' => '2',  'DECN_default' => '0.00',  'DECN_minvalue' => '0.00',  'DECN_maxvalue' => '100.00',  'DECN_displaysize' => '20',  'DECN_extra1' => '0',  'DECN_extra2' => '2','FILE_required' => '0',  'FILE_extra1' => '',  'FILE_maxvalue' => '2',  'FILE_extra2' => '0',  'FILE_extra3' => 'data/files/',  'INTN_size' => '3',  'INTN_required' => '0',  'INTN_extra1' => '0',  'INTN_extra2' => '0',  'INTN_align' => '2',  'INTN_default' => '0',  'INTN_minvalue' => '0',  'INTN_maxvalue' => '100',  'INTN_displaysize' => '10',  'LIST_required' => '0',  'LIST_extra1' => '',  'LIST_extra2' => '',  'LIST_extra3' => '0',  'LIST_extra4' => '1',  'LOOK_required' => '0',  'LOOK_default' => 'null',  'LOOK_extra1' => '',  'LOOK_extra2' => '',  'LOOK_extra3' => '',  'LOOK_extra4' => '',  'LOOK_extra9' => '',  'LOOK_extra5' => '0',  'LOOK_extra8' => '0',  'LOOK_extra6' => '',  'LOOK_extra7' => '',  'SOBJ_required' => '0',  'SOBJ_extra1' => 'ACTR',  'SLUK_required' => '0',  'SLUK_extra1' => 'CLX_',  'SLUK_extra2' => '',  'SLUK_extra3' => '',  'SLUK_extra4' => '',  'TEXT_size' => '1',  'TEXT_extra1' => '4',  'TEXT_extra2' => '48',  'TIME_required' => '0',  'TIME_format' => 'H:i:s',  'TIME_default' => 'now',  'TIME_displaysize' => '30',  'TLOK_extra1' => '',  'RECU_required' => '0',  'RECU_default' => 'NONE',  'BARS_size' => '32',  'BARS_required' => '0',  'BARS_format' => '0',  'BARS_align' => '0',  'BARS_extra1' => 'UCC128',  'BARS_default' => 'null',  'BARS_displaysize' => '32',  'DBFL_fieldlistlabel_DICT' => 'IMPORTS CODES',  'DBFL_fieldformlabel_DICT' => 'IMPORTS CODES',  'DBFL_fieldprefix_DICT' => '',  'DBFL_fieldsufix_DICT' => '',  'DBFL_field_anchor' => '',  'DBFL_fieldformula' => '',  'submit1' => 'Crear');
											  // Array (  'to' => 'DBFL',  'ac' => 'CREATE',  'confirm' => '1',  'DBFL_id' => '',  'idlist' => '',  'BOOL_extra1' => '',  'BOOL_extra2' => '',  'DBFL_fieldlistlabel' => '',  'DBFL_fieldformlabel' => '',  'DBFL_fieldprefix' => '',  'DBFL_fieldsufix' => '',  'DBFL_fieldname' => 'IMPORTCODE',  'DBFL_description' => 'IMPORT CODES',  'DBFL_fieldtype' => 'CHAR',  'DBFL_version' => '1.0.0',  'BLOB_size' => '1',  'BOOL_extra1_DICT' => '',  'BOOL_extra2_DICT' => '',  'BOOL_default' => '0',  'BOOL_extra3' => '0',  'CHAR_size' => '16',  'CHAR_required' => '0',  'CHAR_format' => '0',  'CHAR_align' => '0',  'CHAR_default' => 'null',  'CHAR_displaysize' => '32',  'DATE_required' => '0',  'DATE_format' => 'Y-m-d',  'DATE_default' => 'today',  'DATE_displaysize' => '30',  'DATE_size' => '30',  'DATI_required' => '0',  'DATI_format' => 'Y-m-d H:i:s',  'DATI_default' => 'today',  'DATI_displaysize' => '30',  'DATI_size' => '30',  'DECN_required' => '0',  'DECN_format' => '10,2',  'DECN_align' => '2',  'DECN_default' => '0.00',  'DECN_minvalue' => '0.00',  'DECN_maxvalue' => '100.00',  'DECN_displaysize' => '20',  'DECN_extra1' => '0',  'DECN_extra2' => '2',  'FILE_required' => '0',  'FILE_extra1' => '',  'FILE_maxvalue' => '2',  'FILE_extra2' => '0',  'FILE_extra3' => 'data/files/',  'INTN_size' => '3',  'INTN_required' => '0',  'INTN_extra1' => '0',  'INTN_extra2' => '0',  'INTN_align' => '2',  'INTN_default' => '0',  'INTN_minvalue' => '0',  'INTN_maxvalue' => '100',  'INTN_displaysize' => '10',  'LIST_required' => '0',  'LIST_extra1' => '',  'LIST_extra2' => '',  'LIST_extra3' => '0',  'LIST_extra4' => '1',  'LOOK_required' => '0',  'LOOK_default' => 'null',  'LOOK_extra1' => '',  'LOOK_extra2' => '',  'LOOK_extra3' => '',  'LOOK_extra4' => '',  'LOOK_extra9' => '',  'LOOK_extra5' => '0',  'LOOK_extra8' => '0',  'LOOK_extra6' => '',  'LOOK_extra7' => '',  'SOBJ_required' => '0',  'SOBJ_extra1' => 'ACTR',  'SLUK_required' => '0',  'SLUK_extra1' => 'CLX_',  'SLUK_extra2' => '',  'SLUK_extra3' => '',  'SLUK_extra4' => '',  'TEXT_size' => '1',  'TEXT_extra1' => '4',  'TEXT_extra2' => '48',  'TIME_required' => '0',  'TIME_format' => 'H:i:s',  'TIME_default' => 'now',  'TIME_displaysize' => '30',  'TLOK_extra1' => '',  'RECU_required' => '0',  'RECU_default' => 'NONE',  'BARS_size' => '32',  'BARS_required' => '0',  'BARS_format' => '0',  'BARS_align' => '0',  'BARS_extra1' => 'UCC128',  'BARS_default' => 'null',  'BARS_displaysize' => '32',  'DBFL_fieldlistlabel_DICT' => 'IMPORTCODE',  				'DBFL_fieldformlabel_DICT' => 'IMPORTCODE',  				'DBFL_fieldprefix_DICT' => '',  'DBFL_fieldsufix_DICT' => '',  'DBFL_field_anchor' => '',  'DBFL_fieldformula' => '',  'submit1' => 'Crear',);
											   Array(   'to' => 'DBFL',  'ac' => 'CREATE',  'confirm' => '1',  'DBFL_id' => '',  'idlist' => '',  'BOOL_extra1' => '',  'BOOL_extra2' => '',  'DBFL_fieldlistlabel' => '',  'DBFL_fieldformlabel' => '',  'DBFL_fieldprefix' => '',  'DBFL_fieldsufix' => '',  'DBFL_fieldname' => 'FILENAME_REQ','DBFL_description' => 'FILENAME_REQ',  'DBFL_fieldtype' => 'DATE',  'DBFL_version' => '1.0.0',  'BLOB_size' => '1',  'BOOL_extra1_DICT' => '',  'BOOL_extra2_DICT' => '',  'BOOL_default' => '0',  'BOOL_extra3' => '0',  'CHAR_size' => '32',  'CHAR_required' => '0',  'CHAR_format' => '0',  'CHAR_align' => '0',  'CHAR_default' => 'null',  'CHAR_displaysize' => '32',  'DATE_required' => '0',  'DATE_format' => 'Y-m-d',  'DATE_default' => 'today',  'DATE_displaysize' => '30',  'DATE_size' => '30',  'DATI_required' => '0',  'DATI_format' => 'Y-m-d H:i:s',  'DATI_default' => 'today',  'DATI_displaysize' => '30',  'DATI_size' => '30',  'DECN_required' => '0',  'DECN_format' => '10,2',  'DECN_align' => '2',  'DECN_default' => '0.00',  'DECN_minvalue' => '0.00',  'DECN_maxvalue' => '100.00',  'DECN_displaysize' => '20',  'DECN_extra1' => '0',  'DECN_extra2' => '2',  'FILE_required' => '0',  'FILE_extra1' => '',  'FILE_maxvalue' => '2',  'FILE_extra2' => '0',  'FILE_extra3' => 'data/files/',  'INTN_size' => '3',  'INTN_required' => '0',  'INTN_extra1' => '0',  'INTN_extra2' => '0',  'INTN_align' => '2',  'INTN_default' => '0',  'INTN_minvalue' => '0',  'INTN_maxvalue' => '100',  'INTN_displaysize' => '10',  'LIST_required' => '0',  'LIST_extra1' => '',  'LIST_extra2' => '',  'LIST_extra3' => '0',  'LIST_extra4' => '1',  'LOOK_required' => '0',  'LOOK_default' => 'null',  'LOOK_extra1' => '',  'LOOK_extra2' => '',  'LOOK_extra3' => '',  'LOOK_extra4' => '',  'LOOK_extra9' => '',  'LOOK_extra5' => '0',  'LOOK_extra8' => '0',  'LOOK_extra6' => '',  'LOOK_extra7' => '',  'SOBJ_required' => '0',  'SOBJ_extra1' => 'ACTR',  'SLUK_required' => '0',  'SLUK_extra1' => 'CLX_',  'SLUK_extra2' => '',  'SLUK_extra3' => '',  'SLUK_extra4' => '',  'TEXT_size' => '1',  'TEXT_extra1' => '4',  'TEXT_extra2' => '48',  'TIME_required' => '0',  'TIME_format' => 'H:i:s',  'TIME_default' => 'now',  'TIME_displaysize' => '30',  'TLOK_extra1' => '',  'RECU_required' => '0',  'RECU_default' => 'NONE',  'BARS_size' => '32',  'BARS_required' => '0',  'BARS_format' => '0',  'BARS_align' => '0',  'BARS_extra1' => 'UCC128',  'BARS_default' => 'null',  'BARS_displaysize' => '32',  'DBFL_fieldlistlabel_DICT' => 'Filename date Requerido',	'DBFL_fieldformlabel_DICT' => 'Filename date Requerido',	'DBFL_fieldprefix_DICT' => '',  'DBFL_fieldsufix_DICT' => '',  'DBFL_field_anchor' => '',  'DBFL_fieldformula' => '',  'submit1' => 'Crear',);

							$DBFL->createRecord_();

						}

					}
					else if ($insertfields[$t]=='LINE_OF_LOG_ID') {
						if (!ClxCommon::$db->getOne('SELECT count(FIELDNAME) FROM CLX_DB_FIELDS WHERE FIELDNAME='.singleQuote('LINE_OF_LOG_ID')))
						{
							UserRequest::$post=array ('to' => 'DBFL','ac' => 'CREATE','confirm' => '1','DBFL_id' => '','idlist' => '', 'BOOL_extra1' => '',  'BOOL_extra2' => '',  'DBFL_fieldlistlabel' => '',  'DBFL_fieldformlabel' => '',  'DBFL_fieldprefix' => '',  'DBFL_fieldsufix' => '',  'DBFL_fieldname' => 'LINE_OF_LOG_ID',  'DBFL_description' => 'LINE_OF_LOG_ID',  'DBFL_fieldtype' => 'INTN',  'DBFL_version' => '1.0.0',  'BLOB_size' => '1',  'BOOL_extra1_DICT' => '',  'BOOL_extra2_DICT' => '',  'BOOL_default' => '0',  'BOOL_extra3' => '0',  'CHAR_size' => '32',  'CHAR_required' => '0',  'CHAR_format' => '0',  'CHAR_align' => '0',  'CHAR_default' => 'null',  'CHAR_displaysize' => '32',  'DATE_required' => '0',  'DATE_format' => 'Y-m-d',  'DATE_default' => 'today',  'DATE_displaysize' => '30',  'DATE_size' => '30',  'DATI_required' => '0',  'DATI_format' => 'Y-m-d H:i:s',  'DATI_default' => 'today',  'DATI_displaysize' => '30',  'DATI_size' => '30',  'DECN_required' => '0',  'DECN_format' => '10,2',  'DECN_align' => '2',  'DECN_default' => '0.00',  'DECN_minvalue' => '0.00',  'DECN_maxvalue' => '100.00',  'DECN_displaysize' => '20',  'DECN_extra1' => '0',  'DECN_extra2' => '2',  'FILE_required' => '0',  'FILE_extra1' => '',  'FILE_maxvalue' => '2',  'FILE_extra2' => '0',  'FILE_extra3' => 'data/files/',  'INTN_size' => '3',  'INTN_required' => '0',  'INTN_extra1' => '0',  'INTN_extra2' => '0',  'INTN_align' => '2',  'INTN_default' => '0',  'INTN_minvalue' => '0',  'INTN_maxvalue' => '10000000',  'INTN_displaysize' => '10',  'LIST_required' => '0',  'LIST_extra1' => '',  'LIST_extra2' => '',  'LIST_extra3' => '0',  'LIST_extra4' => '1',  'LOOK_required' => '0',  'LOOK_default' => 'null',  'LOOK_extra1' => '',  'LOOK_extra2' => '',  'LOOK_extra3' => '',  'LOOK_extra4' => '',  'LOOK_extra9' => '',  'LOOK_extra5' => '0',  'LOOK_extra8' => '0',  'LOOK_extra6' => '',  'LOOK_extra7' => '',  'SOBJ_required' => '0',  'SOBJ_extra1' => 'ACTR',  'SLUK_required' => '0',  'SLUK_extra1' => 'CLX_',  'SLUK_extra2' => '',  'SLUK_extra3' => '',  'SLUK_extra4' => '',  'TEXT_size' => '1',  'TEXT_extra1' => '4',  'TEXT_extra2' => '48',  'TIME_required' => '0',  'TIME_format' => 'H:i:s',  'TIME_default' => 'now',  'TIME_displaysize' => '30',  'TLOK_extra1' => '',  'RECU_required' => '0',  'RECU_default' => 'NONE',  'BARS_size' => '32',  'BARS_required' => '0',  'BARS_format' => '0',  'BARS_align' => '0',  'BARS_extra1' => 'UCC128',  'BARS_default' => 'null',  'BARS_displaysize' => '32',  'DBFL_fieldlistlabel_DICT' => 'LINE_OF_LOTE',  'DBFL_fieldformlabel_DICT' => 'LINE_OF_LOTE',  'DBFL_fieldprefix_DICT' => '',  'DBFL_fieldsufix_DICT' => '',  'DBFL_field_anchor' => '',  'DBFL_fieldformula' => '',  'submit1' => 'Crear');
						$DBFL->createRecord_();
					}
				}

				$infofield['DBTF_fieldname']=$insertfields[$t];
				UserRequest::$request=UserRequest::$post=$infofield;
					if (isset(ClxCommon::$db->debugCF) && ClxCommon::$db->debugCF==true){
						echo "===create field en tabla====";
						pre(UserRequest::$post);
					}
					$DBTF->createRecord_();

			}
		}
			if (ClxCommon::$db->getOne('SELECT COUNT(1) FROM CLX_DB_TABLEINDEXES A,CLX_DB_INDEX_COLUMNS B WHERE TYPE='.singlequote('MUL').' AND TABLECODE='.singlequote($tablecode).' AND A.IDCODE=B.INDEX_CODE AND B.FIELDNAME IN ('.singlequoteArray(array('LOG_ID','IMPORTCODE')).') GROUP BY INDEX_CODE HAVING COUNT(1)=2')!=2)
			{
				UserRequest::$post =array ('to' => 'DBTI',  'ac' => 'CREATE',  'confirm' => '1',  'idlist' => '',  'DBTI_id' => '0',  'DBTI_tablecode' => $tablecode,  'DBTI_fieldname' => '',  'DBTI_fieldname_sec' => '',  'selected' => 'LOG_ID,IMPORTCODE',  'DBTI_idcode' => $tablecode.date('his').rand(0,1000000)  ,  'DBTI_type' => 'MUL',  'DBTI_fields' => 'IMPORTCODE',  'DBTI_fields_function' => '0',  'DBTI_selected' => 'IMPORTCODE',  'submit1' => 'Crear');

				$DBTI->createRecord_();


			}
			$dump = (defined('UTIL_DUMP_AUPK_SQL_SCRIPT') && UTIL_DUMP_AUPK_SQL_SCRIPT === strval(CLX_NUM_ONE)) ? true : false;
			$id = ClxCommon::$db->getone('SELECT ID FROM CLX_DB_TABLES WHERE IDCODE='.singleQuote($tablecode));

			UserRequest::$post =array (  'ac' => 'FIX',  'to' => 'DBTB',  'idlist' => $id,  'next' => '1',  'relfm' => '',  'submit1' => 'Arreglar Tabla');
			$contents = $DBTB->checkTableForm(array($id), true, $dump,false);

		UserRequest::$post=$antpost;
		//UserRequest::$post=$antpost['DBIM_idcode']='';
		UserRequest::$request=$antrequest;
		UserRequest::$get=$antget;
		}
	}
	function getFields($importcode, $record_delim, $field_delim, $field_cdelim, $sheetPage='') {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1602;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}

		$importrec = ClxCommon::$db->getRecord($this->tablename, 'IDCODE=' . singleQuote($importcode));
		$tablecode = $importrec['TABLECODE'];
		$sheetName="";
		$file_fields=array();
		if ($this->debug)
			pre("---DDS----->".$importrec['TYPE']);
		if ($importrec['TYPE'] === 'CSV'||$importrec['TYPE'] === 'CSV2') {
			$file_fields = $this->extractFileFields($importcode, $record_delim, $field_delim, $field_cdelim);
			$qrcol=1;
			foreach($file_fields as $key=>&$value) {
				if (strlen($value)==0) {
					$value='('.dict('GEN_LBL_COLUMN').' ['.$qrcol.'])';
				}
				$qrcol++;
			}
		}
		else if ($importrec['TYPE'] === 'XLS'||$importrec['TYPE'] === 'XLS2') {
			if ($this->debug) {
				PRE("++++++INI++++++++++++++++++".__LINE__);
			}
			$lines=json_decode($importrec['RECORD_PROP'],true);
			list($sheetName,$file_fields) = $this->extractFileFieldsExcel($importcode,$sheetPage,false,true,$lines);
			if ($this->debug) {
			
				PRE("++++++FIN++++++++++++++++++".__LINE__);
			}
			if($this->debug) {
						PRE( "<B>extractFileFieldsExcel</B>". __LINE__);
						PRE($sheetPage);
						PRE($file_fields);
						PRE("++++++FIN33++++++++++++++++++");
			
			}
			if ($this->debug) {
				echo 'XLS----000-->mappingg table_fields '.$importcode.__LINE__;
				pre ($table_fields);
				echo 'XLS----001-->mappingg create'.__LINE__;

				pre ($mappings);
				echo 'XLS----002-->mappingg file_fields'.__LINE__;
				pre ($file_fields);
				
			}
		}
		else if ($importrec['TYPE'] === 'FRL'|| $importrec['TYPE'] === 'FRL2'||$importrec['TYPE'] === 'FRL3')
			$file_fields = array('('.dict('GEN_LBL_COLUMN').' [1])');
		$table_fields = $this->getTableFields($tablecode);
		$mappings = $this->getMappings($importcode);
		ClxCommon::$db->deleteRecords('CLX_DB_IMPORT_MAPPINGS', 'IMPORTCODE=' . singleQuote($importcode));
		$i = CLX_INIT_ZERO;
		if ($this->debug) {
			echo 'FLR----000-->mappingg table_fields '.$importcode.__LINE__;
			pre ($table_fields);
			echo 'FLR----001-->mappingg create'.__LINE__;
			pre ($mappings);
			echo 'FLR----002-->mappingg file_fields'.__LINE__;
			pre ($file_fields);
			
			
		}
		
		foreach ($table_fields as $table_field) {
			$table_field=clx_change_acentos_char_html($table_field);

			$record = array();
			$record['IMPORTCODE'] = $importcode;
			$record['SEQNUM'] = $i;
			$record['IMPORTSHEETS']=$sheetName;
			if (array_key_exists($table_field, $mappings) and array_search($table_field,$file_fields) and (($mappings[$table_field]['TYPE']!='FILE' and $mappings[$table_field]['TYPE']!='IGNR') or ($mappings[$table_field]['MAPPING_MANUAL']))) {
				$record['FILE_FIELDNAME'] = $mappings[$table_field]['FILE_FIELDNAME'];
				$record['TABLE_FIELDNAME'] = $mappings[$table_field]['TABLE_FIELDNAME'];
				$record['TYPE'] = $mappings[$table_field]['TYPE'];
				$record['FORMULA'] = $mappings[$table_field]['FORMULA'];
				$record['MAPPING_MANUAL']=$mappings[$table_field]['MAPPING_MANUAL'];
				$record['RULE_ID']=$mappings[$table_field]['RULE_ID'];
			} else {
				$record['FORMULA'] = '';
				if (is_array($file_fields) && in_array($table_field, $file_fields)) {
					$record['TYPE'] = 'FILE';
					$record['FILE_FIELDNAME'] = $table_field;
					$record['TABLE_FIELDNAME'] = $table_field;
				} else {
					$record['TYPE'] = 'IGNR';
					$record['FILE_FIELDNAME'] = '';
					$record['TABLE_FIELDNAME'] = $table_field;
				} 
			}
			if (empty($this->posSheetname)) {
				if (isset ( UserRequest::$request['sheets_'])){
					$pos=strpos(UserRequest::$request['sheets_'],'(');
					$record['POSITION_SHEET']=substr(UserRequest::$request['sheets_'],$pos);
				}
				else
					$record['POSITION_SHEET']='';
			}
			else {
				$record['POSITION_SHEET']=$this->posSheetname;
			}
			ClxCommon::$db->createRecord('CLX_DB_IMPORT_MAPPINGS', $record, false);
			if ($this->debug==true) {pre('<B>yyyyyyyyy record'.__LINE__.'</B>');pre($record);echo $b='createrecord mappings '.__LINE__;pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}

			$i++;
		}
	}
	function limpia($field) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}
		$field=str_replace('&#65279;','',$field);
		$field=str_replace('&Aacute;','A',$field);
		$field=str_replace('&Eacute;','E',$field);
		$field=str_replace('&Iacute;','I',$field);
		$field=str_replace('&Oacute;','O',$field);
		$field=str_replace('&Uacute;','U',$field);
		$field=str_replace('&aacute;','a',$field);
		$field=str_replace('&eacute;','e',$field);
		$field=str_replace('&iacute;','i',$field);
		$field=str_replace('&oacute;','o',$field);
		$field=str_replace('&uacute;','u',$field);
		$field=str_replace('&ntilde;','n',$field);
		$field=str_replace('&Ntilde;','N',$field);
		$field=str_replace(chr(13),'',$field);
		$field=str_replace(chr(10),'',$field);

		return trim($field);
	}
	function getFieldsTest($importcode, $record_delim, $field_delim, $field_cdelim, $sheetPage='') {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1602;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		$importrec = ClxCommon::$db->getRecord($this->tablename, 'IDCODE=' . singleQuote($importcode));
		$tablecode = $importrec['TABLECODE'];
		$sheetName="";
		if ($this->debug==true){ pre( $importrec['TYPE'] . ' in function getFieldstest'); }

		if ($importrec['TYPE'] === 'CSV'||$importrec['TYPE'] === 'CSV2') {
			$this->readTEXTimportCode($importcode,true);
			$file_fields = $this->extractFileFields($importcode, $record_delim, $field_delim, $field_cdelim,true);
			if ($this->debug==true){ pre('file_fileds');pre($file_fields); }
		}
		else if ($importrec['TYPE'] === 'XLS'||$importrec['TYPE'] === 'XLS2') {
			$this->readFileExcelImportCode($importcode,true);
			list($sheetName,$file_fields) = $this->extractFileFieldsExcel($importcode,$sheetPage,true);
			if($this->debug) {
				PRE( "sheetname ". __LINE__.' '. __METHOD__);
				PRE($sheetName);
				PRE( "sheetpage ". __LINE__.' '. __METHOD__);
				PRE($sheetPage);
				PRE( "file_fields ". __LINE__.' '. __METHOD__);
				PRE($file_fields);
			}
		}
		else if ($importrec['TYPE'] === 'FRL'|| $importrec['TYPE'] === 'FRL2'||$importrec['TYPE'] === 'FRL3')   {

			list($filepath,$name)=$this->readTEXTimportCode($importcode,true);
			$file_fields = array($this->readfixtext($importcode, $record_delim,$importrec,$filepath));
		}
		$file_fields2=array();
		if (is_array($file_fields)) {
			foreach($file_fields as $key=>$value){
				$file_fields2[clx_change_acentos_char_html($key)]=$value;
			}
		}
		return array($file_fields2,$sheetName);

	}
	function readfixtext($importcode,$record_delim,$importrec,$fileread) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}

		require_once'classes/clx_file_fixed_record_length.php';
/// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - BEGIN
		$record_delim = replace_ascii_chars($importrec['RECORD_DELIM']);
		$record_length = intval($importrec['RECORD_LENGTH']) + mb_strlen($record_delim, kDefaultEncoding);

// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - END
		$fd = new clx_file_fixed_record_length($fileread, $record_length,false,$importrec['IF_UTF8']);
// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - BEGIN
		// It's fixed lenght, but reads only until EOL character, to avoid cases of not so fixed lenght files like IBS's
		if($record_delim != '') {
			$this->use_record_delimiter_reading_fixlen_files = true;
		}
		if ($this->use_record_delimiter_reading_fixlen_files === true) {
			$fd->line_delim = $record_delim;
		}
// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - END
		$rline=0;
		$restrictions= $this->getRestriction($importcode);
		$restrict=false;
		while (!$fd->EOF) {
			$restrict=false;
			$rline++;
			$buffer = $this->input_line_encoding_detect($fd->getNextRecord2_exp());
			if (empty($this->s_input_line_encoding_detect2)) {
				$buffer=dict("GEN_LBL_NOTANSIORUTF8");
				break;
			}
			if (count($restrictions)>0) {
				$restrict=$this->apply_Restriction($restrictions,$buffer,$rline);
			}
			if (!$restrict) {
				//$buffer = $this->input_line_encoding_detect($fd->getNextRecord2());
				break;
			}
			else {
				$buffer='';
			}
		}
		return $buffer;

	}
	function apply_Restriction(&$restrictions,$buffer,$rline) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}
		$restrict=false;
		for ($tr=0;$tr<count($restrictions) and !$restrict; $tr++ ) {
			$valueRule=&$restrictions[$tr];
			if (!isset($valueRule['RULE']))
				continue;
			switch ($valueRule['RULE']) {
				case 'WREC':
						$conservar = '0-9a-zA-Z'; // juego de caracteres a conservar
						$regex = sprintf('~[^%s]++~i', $conservar); // case insensitive

				///e cho strlen(preg_replace($regex, '', $buffer));

					if (strlen(preg_replace($regex, '', $buffer))<$valueRule['RULE_TEXT'])
						$restrict=true;
					break;
				case 'TREC':
					if (strpos(" ".$buffer,$valueRule['RULE_TEXT'])>0)
						$restrict=true;
					break;
				case 'NREC':
					if (strpos($valueRule['RULE_TEXT2'],",$rline,")>0) {
						$restrict=true;
						$valueRule['RULE_TEXT2']=str_replace(",$rline,",',',$valueRule['RULE_TEXT2']);
						if ($valueRule['RULE_TEXT2']==',,')
							unset($restrictions[$tr]);
					}
					break;
			}
		}
		return $restrict;
	}
	function extractFileFields($importcode, $record_delim, $field_delim,$field_cdelim=array(),$test=false,$remapping=false) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1603;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		require_once'classes/clx_file_delimited.php';
		$fileYes=false;
		$rline=0;
		$encodedetect="X";
		$sample_fields=array();
		$restrictions= $this->getRestriction($importcode);
		if ($test) {
			$importrec = ClxCommon::$db->getRecord($this->tablename, 'IDCODE=' . singleQuote($importcode));
			if ($importrec['TYPE'] === 'CSV'||$importrec['TYPE'] === 'CSV2') {
				$fileread=kPathToWebSite.'import/_'.$importrec['FILE'] ;
				if (filesize($fileread)>0) {


					$leer='';
					if (filesize($fileread)>0){
						$a=fopen($fileread,"r");
						$leer=fread($a,filesize($fileread));
						fclose($a);
					}
					$encodedetect=mb_detect_encoding($leer, "auto");

				}
				else
					$encodedetect='';
				if (empty($encodedetect)) {
					$file_fields["ERROR"]=dict("GEN_LBL_NOTANSIORUTF8");
					$sample_fields["ERROR"]=dict("GEN_LBL_NOTANSIORUTF8");
				}
			}
			else if ($importrec['TYPE'] === 'XLS'||$importrec['TYPE'] === 'XLS2') {
				$fileread=kPathToWebSite.'import/_'.$importrec['FILE_EXCEL'];
			}
			else if ($importrec['TYPE'] === 'FRL' || $importrec['TYPE'] === 'FRL2'||$importrec['TYPE'] === 'FRL3')   {
				$fileread=kPathToWebSite.'import/_'.$importrec['FILE_DELIM'] ;
				$a=fopen($fileread,"r");
				$encodedetect=mb_detect_encoding(fread($a,filesize($fileread)), "auto");
				fclose($a);
				if (empty($encodedetect)) {
					$file_fields["ERROR"]=dict("GEN_LBL_NOTANSIORUTF8");
					$sample_fields["ERROR"]=dict("GEN_LBL_NOTANSIORUTF8");
				}

			}
			$fileYes=true;
		}
		else if(isset (UserRequest::$files['DBIM_file']['tmp_name'])) {
			$fileread=UserRequest::$files['DBIM_file']['tmp_name'];
			$fileYes=true;
			$path_info = pathinfo($fileread);
			$fileext=uppercase($path_info['extension']);
			if ($fileext!="XLS" and $fileext!="XLSX" and $fileext!="ODT") {
				$a=fopen($fileread,"r");
				$encodedetect=mb_detect_encoding(fread($a,filesize($fileread)), "auto");
				fclose($a);
				if (empty($encodedetect)) {
					$file_fields["ERROR"]= dict("GEN_LBL_NOTANSIORUTF8");
					$sample_fields["ERROR"]= dict("GEN_LBL_NOTANSIORUTF8");
				}
			}
		}
		$importrec = ClxCommon::$db->getRecord($this->tablename, 'IDCODE=' . singleQuote($importcode));
		$importrec['RECORD_PROP']=json_decode($importrec['RECORD_PROP'],true);
		$importrec['RECORD_CPROP']=json_decode($importrec['RECORD_CPROP'],true);
		// The following deletes all file fields and saves a fresh copy from the file.

		$from=$to=0;
		$col=0;
		IF (!empty($importrec['RECORD_PROP'][$col])){
			$from=$to=$importrec['RECORD_CPROP'][$col];
		}
		IF (!empty($importrec['RECORD_PROP'][$col+1]) and $importrec['RECORD_CPROP'][$col+1]>=$from) {
			$to=$importrec['RECORD_CPROP'][$col+1];
		}

		if ($fileYes and !empty($encodedetect))  {
			if (!$test or $remapping) {
				ClxCommon::$db->deleteRecords('CLX_DB_IMPORT_FIELDS', 'IMPORTCODE=' . singleQuote($importcode));
			}
			$fd = new clx_file_delimited($fileread, $record_delim, $field_delim,array(CLX_CHAR_TAB),false,false,$importrec['IF_UTF8']);
			IF ($this->debug==true) {
						pre('import de entrada8');
						pre($fd);
						pre($fileread);
						pre('--------xxx----------');
			}
			$detect=true;
			$line=0;
			$count_fields=0;
			$file_fields=array();
			$si_text=false;

			while (!$fd->EOF){
				$rline++;
				$restrict=false;
				$lineread = $fd->getNextRecord2();
				$this->input_line_encoding_detect($lineread);
				if (empty($this->s_input_line_encoding_detect2)) {
					$file_fields["ERROR"]=dict("GEN_LBL_NOTANSIORUTF8");
					$sample_fields["ERROR"]=dict("GEN_LBL_NOTANSIORUTF8");
					break;
				}
				if ($detect) {
					$this->parsertextdetect($line, $field_delim, $field_cdelim );
					$detect=false;
				}
				if (count($restrictions)>0) {
					$restrict=$this->apply_Restriction($restrictions,$lineread,$rline);
				}
				if (!$restrict) {
					$read_fields= $this->parsertext($lineread);
					$sample_content_fields=$read_fields;


					if ($to>=$rline and $from<=$rline ) {
						foreach ($read_fields as $key=>$field) {
							if ($rline>=$from and $rline<=$to ) {
								$file_fields[$key] = //((empty($file_fields[$key])) ? " ": $file_fields[$key])
													 $field;

							}
						}
						if ($to==$rline) {
							$count_fields=count($read_fields);
						}
					}
					else if ($to<$rline) {
						if ($to==0) {
							$count_fields=count($read_fields);
						}
						break;
					}
				}
			}
			if ($count_fields>0 AND count($file_fields)==0) {
				for ($key=0;$key<$count_fields;$key++) {
					$file_fields[$key]= '('.dict('GEN_LBL_COLUMN')." [".($key+1).'])';
					$sample_fields[$file_fields[$key]]=$sample_content_fields[$key];
				}
			}
			else {
				for ($key=0;$key<count($file_fields);$key++) {
					$file_fields[$key]=trim($file_fields[$key]);
					if (empty($file_fields[$key]) or isset( $sample_fields[$file_fields[$key]])) {
						$file_fields[$key]='('.dict('GEN_LBL_COLUMN').' ['.($key+1).'])';
					}
					$sample_fields[$file_fields[$key]]='';
					IF (ISSET($sample_content_fields[$key]))
						$sample_fields[$file_fields[$key]]=$sample_content_fields[$key];
				}
			}

			if (!$test or $remapping) {
				$record = array();
				$record['IMPORTCODE'] = $importcode;
				$i = CLX_INIT_ZERO;
				foreach ($file_fields as $field) {
					$record['FILE_FIELDNAME'] = $field;
					$record['SEQNUM'] = $i;
					ClxCommon::$db->createRecord('CLX_DB_IMPORT_FIELDS', $record, false);
					if ($this->debug==true) {echo $b='update import_fields in '.__LINE__;pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}
					$i++;
				}
			}
		} else {
			$file_fields = array();
			$records = ClxCommon::$db->getRecords('CLX_DB_IMPORT_FIELDS', 'IMPORTCODE=' . singleQuote($importcode));
			while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
				$file_fields[] = $record['FILE_FIELDNAME'];
			}
		}
		if (!$test)
			return $file_fields;
		else
			return $sample_fields;
	}
	function Importsamplenotdownload($importcode='') {
		if (empty($importcode)) {
			return '';
		}
		$record = ClxCommon::$db->getRecord($this->tablename, 'IDCODE = ' . singleQuote($importcode));
		if ($record['TYPE']=='XLS' ||$record['TYPE'] === 'XLS2') {
			$name=$record['FILE_EXCEL'];
			$contenido=$record['FILE_CEXCEL'];
		}
		else if ($record['TYPE']=='CSV' ||$record['TYPE'] === 'CSV2') {
			$name=$record['FILE'];
			$contenido=$record['FILE_C'];
		}
		else {
			$name=$record['FILE_DELIM'];
			$contenido=$record['FILE_CDELIM'];
		}
		$contenido=base64_decode($contenido);
		$a=FOPEN($name=kPathToWebSite.'import/_'.$name,"wb");
		FWRITE($a,$contenido);
		FCLOSE($a);
		return $name;
	}
	function importSample() {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1625;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		//if (!ob_get_contents())
//		RESTORE_ERROR_HANDLER(); ERROR_REPORTING(E_ALL);
		ob_start();//
		
		if (empty(UserRequest::$get['importcode'])) {
			return alert(dict('GEN_LBL_ERROR'));
		}
		$record = ClxCommon::$db->getRecord($this->tablename, 'IDCODE = ' . singleQuote(UserRequest::$get['importcode']));
		if (empty(UserRequest::$get['importcode'])) {
			return alert(dict('GEN_LBL_ERROR'));
		}
		if ($record['TYPE']=='XLS' ||$record['TYPE'] === 'XLS2') {
			$name=$record['FILE_EXCEL'];
			$contenido=$record['FILE_CEXCEL'];
		}
		else if ($record['TYPE']=='CSV' ||$record['TYPE'] === 'CSV2') {
			$name=$record['FILE'];
			$contenido=$record['FILE_C'];
		}
		else {
			$name=$record['FILE_DELIM'];
			$contenido=$record['FILE_CDELIM'];
		}
		$contenido=base64_decode($contenido);
		$path_info = pathinfo($name);
		$fileext= $path_info['extension'];
		$filename= $path_info['filename'];
		//$A=FOPEN('XXX.XLSX',"wb");
		//FWRITE($A,$contenido);
		//FCLOSE($A);
		if (ob_get_contents())
			ob_clean();
		sendDownloadFile('_'.str_replace(' ','_',$filename)/*.'.'.$fileext*/, $fileext);
		return $contenido;

	}
	function readFileCSVImportCode($importcode,$mapping=false) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}
		$record = ClxCommon::$db->getRecord($this->tablename, 'IDCODE=' . singleQuote($importcode));
		$name=$record['FILE_'];
		$contenido=base64_decode($record['FILE_C']);
		$a=fopen($Filepath=kPathToWebSite.'import/'.$name  ,"wb+");
		fwrite($a,$contenido);
		fclose($a);
		if (!$mapping)
			return array($Filepath,$name);
	}
	function readTEXTimportCode($importcode,$test) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}

		$importrec = ClxCommon::$db->getRecord($this->tablename, 'IDCODE=' . singleQuote($importcode));

		if ($importrec['TYPE']=='CSV'||$importrec['TYPE'] === 'CSV2') {
			$name=$importrec['FILE'];
			$contenido=base64_decode($importrec['FILE_C']);
		}
		else {
			$name=$importrec['FILE_DELIM'];
			$contenido=base64_decode($importrec['FILE_CDELIM']);
		}

		$a=fopen($Filepath=kPathToWebSite.'import/'.($test?'_':'').$name ,"wb+");

		fwrite($a,$contenido);
		fclose($a);
		//if (!$mapping)
		return array($Filepath,$name);
	}
	function readFileExcelImportCode($importcode,$mapping=false,$test=false) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}
		$record = ClxCommon::$db->getRecord($this->tablename, 'IDCODE=' . singleQuote($importcode));
		$name=$record['FILE_EXCEL'];
		$contenido=base64_decode($record['FILE_CEXCEL']);
		$Filepath='';
		if (!empty($name)) {
			$a=fopen($Filepath=kPathToWebSite.'import/'.($test?'_':'').  $name  ,"wb+");
			fwrite($a,$contenido);
			fclose($a);
	
		}
		if (!$mapping) {
			return array($Filepath,$name);
		}
	}
	function readFileExcelTmpWrite() {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}
		IF (file_exists(UserRequest::$files['DBIM_fileexcel']['tmp_name'])) {
			$filex=UserRequest::$files['DBIM_fileexcel'];
			$a=fopen($filex['tmp_name'],"r");
			$x=fread($a,filesize($filex['tmp_name']));
			fclose($a);
			$a=fopen($Filepath=kPathToWebSite.'import/'.$filex['name']  ,"wb+");
			fwrite($a,$x);
			fclose($a);
			return array($Filepath,$filex['name']);
		}
		else {
		
		}
	}
	function extractFileFieldsExcel($importcode,$sheetPage='',$test=false,$onlyTitles=false,$lines=array()) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).'<p style="font-size=18">'.__METHOD__.'</p> '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1603;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		IF ($this->debug==true) {
				echo 'importcode:'.$importcode. ' '.__LINE__ . " <font style='font-size:28px'>" . __METHOD__ .   '</font><br>';
				echo 'sheetpage:'.$sheetPage.'<br>';
				echo 'test:'.$test.'<br>';
				echo 'paso1:';
				echo $sheetPage!=''|| !isset(UserRequest::$files['DBIM_fileexcel']),'<br>';
				PRE("<font style='font-size:20px'>onlyTitles</font>");
				PRE($onlyTitles);
				PRE("<font style='font-size:20px'>LINES</font>");
				PRE($lines);
		}
		if ($sheetPage!=''|| !isset(UserRequest::$files['DBIM_fileexcel'])) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) { echo "<br>". __METHOD__.' '.__FILE__.':'.__LINE__ ."<br>";}
			
			list($Filepath,$NameFile)=$this->readFileExcelImportCode($importcode,false);
			IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1){ echo "<br>",$Filepath," !||||||! ",$NameFile ,"<br>";}
		}
		else {
			list($Filepath,$NameFile)=$this->readFileExcelTmpWrite();
		}
		$importrec = ClxCommon::$db->getRecord($this->tablename, 'IDCODE=' . singleQuote($importcode));
		$mappings = $this->getMappings($importcode);
		
		$getTitles=array();
		$xreturn=array('','');
		$countMaxWhite=0;
		if($this->debug) {
			PRE("MAPPINGS");
			PRE($mappings);
			PRE("Filepath");
					pre($Filepath);
					PRE("NAMEFILE");
					pre($NameFile);
					pre('------------1------ACAaca 10--------------'. __LINE__);
					pre((strlen($Filepath) > CLX_NUM_ZERO or $sheetPage!='')and strlen($NameFile) > CLX_NUM_ZERO);
		
				
				PRE("<font style='font-size:20px'>onlyTitles> ". __LINE__ ."</font>");
				PRE($onlyTitles);
		}
		if ((strlen($Filepath) > CLX_NUM_ZERO or $sheetPage!='')and strlen($NameFile) > CLX_NUM_ZERO  ) {
			$path_info = pathinfo($NameFile);
			$from=$to=-2;
			$fileext= lowercase($path_info['extension']);
			$filename= $path_info['filename'];
			$Rowrest=0;
			if (lowercase($fileext)!="xls")
				$Rowrest=-1;
			$importrec = ClxCommon::$db->getRecord($this->tablename, 'IDCODE=' . singleQuote($importcode));
			if (!defined('READ_EXCEL_TOOL') or READ_EXCEL_TOOL==1) {
				require_once(kPathToSimpleExcel.'/php-excel-reader/excel_reader2.php');
				require_once(kPathToSimpleExcel.'/SpreadsheetReader.php');
			}
			else {
				require_once(kPathToSimpleExcel.'/Classes/PHPExcel.php');
			}
			if($this->debug) {
				pre('---------------'.__LINE__. ' ' .__METHOD__.'------');
			}
			if (!$test)
				ClxCommon::$db->deleteRecords('CLX_DB_IMPORT_FIELDS', 'IMPORTCODE=' . singleQuote($importcode));
			$importrec['RECORD_PROP']=json_decode($importrec['RECORD_PROP'],true);
			$importrec['RECORD_CPROP']=json_decode($importrec['RECORD_CPROP'],true);
			$restrictions= $this->getRestriction($importcode);
			IF (!empty($importrec['RECORD_PROP'][8])){
				$from=$to=$importrec['RECORD_CPROP'][8];
			}
			IF (!empty($importrec['RECORD_PROP'][9]) and $importrec['RECORD_CPROP'][9]>=$from) {
				$to=$importrec['RECORD_CPROP'][9];
			}
			if($this->debug) {
				pre('---------------'.__LINE__. ' ' .__METHOD__.'------');
			}
			try {
				IF ($this->debug==true) {
				
					PRE("<font style='font-size:20px>onlyTitles'> ". __LINE__ ."</font>");
					PRE($onlyTitles);
				}
				
				if (!defined('READ_EXCEL_TOOL') or READ_EXCEL_TOOL==1) {
					$Spreadsheet = new SpreadsheetReader($Filepath);
					$Sheets = $Spreadsheet -> Sheets();
										
				}
				else {
					$Spreadsheet = PHPExcel_IOFactory::createReaderForFile($Filepath);
					$excelObj = $Spreadsheet->load($Filepath);
					$sheets = $excelObj->getSheetNames();
										
				}
				if($this->debug) {
					pre('---------------'.__LINE__. ' ' .__METHOD__.'------');
				}
				$countFields=0;
				$xreturn=array();
				$NameText='';
				$contar=0;
				$this->posSheetname='';
				
				foreach ($Sheets as $Index => $Name) {
					if ($this->debug) {
						pre('-------NAME--------'.__LINE__. ' ' .__METHOD__.'------');
						pre($Name);
					}
					if(substr($sheetPage,0,strlen($Name))==$Name){
						$NameText=$Name;
						$this->posSheetname=substr($sheetPage,strlen($Name));
					}
					else if (empty($NameText) ){
						$NameText=$Name;
						$this->posSheetname='('.$contar.')';

					}
					
					$contar++;
				}
			
				$positionpage=-1;
				$siseekposition=true;
				$changedirectorioall=false;
				$changedirectorio=true;
		/*		foreach ($Sheets as $Index => $Name) {
						PRE(' antes  '.$Index.' => '.$Name.' '.__LINE__ );
					
				}*/
				foreach ($Sheets as $Index => $Name) {
					IF ($this->debug==true) {
						echo 'nombre hoja:'.$Name.' '.__LINE__. '<br>';
					}

					if ($siseekposition) {
						$positionpage++;

					}
					if ($NameText!=$Name and $test)  {
						if ($this->debug) {
							echo "<font style='color:red'>.........Name....se va continue......";
							pre($Name);
							echo "............NameText....";
							pre($NameText);
							echo "............test....";
							pre($test);
							echo "</font>";
						}
						continue;
					}
					else {
						$siseekposition=false;
					}
					$restrict=false;
					if (!defined('READ_EXCEL_TOOL') or READ_EXCEL_TOOL==1) {
						$Spreadsheet -> ChangeSheet($Index);
						$changedirectorioall=true;
						if ($this->debug==true) {
							echo 'nombre hoja ACTIVA1:'.$Index.' '.__LINE__. '<br>';
						}	

					}
					else {
						if ($this->debug==true) {
							echo 'nombre hoja ACTIVA2:'.$Index.' '.__LINE__. '<br>';
						}
						$Spreadsheet->setActiveSheetIndex($Index);
						$changedirectorioall=true;
					}
					if($this->debug) {
						pre('---------------'.__LINE__. ' ' .__METHOD__.'------');
					}
					$file_fields=array();
					$maxCol=-1;

					if (lowercase($fileext)=='ods') {
						//ods seek max columns (default 16000 columns all time) preg_replace replace columns blank repeat text,
						// size problem preg_replace problem  {2,} and many replace with 16000 repeat, solutions two preg_replace;
						// not determin max problem timeout, all  columns create database.
						if (!defined('READ_EXCEL_TOOL') or READ_EXCEL_TOOL==1) {
							foreach ($Sprepreadsheet as $Key => $Row) {
								$txt=implode('{cort_cut}',$Row);
								$txt =preg_replace('@(\{cort_cut\}){100,800}@i', '{cort_cut}',$txt);
								$txt =preg_replace('@(\{cort_cut\}){2,100}$@i', '{cort_cut}',$txt);
								$cant=count(explode('{cort_cut}',$txt));
								if ($cant>$maxCol)
									$maxCol=$cant;
							}
						}
						else {
							foreach ($objWorksheet->getRowIterator() as $Row) {
								$txt=implode('{cort_cut}',$Row);
								$txt =preg_replace('@(\{cort_cut\}){100,800}@i', '{cort_cut}',$txt);
								$txt =preg_replace('@(\{cort_cut\}){2,100}$@i', '{cort_cut}',$txt);
								$cant=count(explode('{cort_cut}',$txt));
								if ($cant>$maxCol)
									$maxCol=$cant;

							}
						}

					}

					$sample_fields=array();
			//		$sample=explode(chr(10),$this->read_Excel_From_gnumeric_sample($Filepath,$positionpage));
					$sample=explode(chr(10),$this->read_Excel_From_gnumeric_sample($Filepath,$mappings,$importcode));
					if($this->debug) {
						pre('-----SAMPLE----------'.__LINE__. ' ' .__METHOD__.'------');
						PRE($sample);
						pre('------FROM---------'.__LINE__. ' ' .__METHOD__.'------');
						pre($from);
						pre('-----IMPORTREC----------'.__LINE__. ' ' .__METHOD__.'------');
						pre($importrec);
					}
					if ($from+1<0) {
						$from=-1;
					}
					$samplecamposgnumeric=array();
					for($xfrom=$from;$xfrom<$from+10;$xfrom++) {
						$copiarestrictions=$restrictions;

						if (count($copiarestrictions)>0) {
							if (isset($sample[$xfrom+1]))
								$restrict=$this->apply_Restriction($copiarestrictions,$sample[$xfrom+1],$xfrom+1);
						}
						if ( $restrict) {
							continue;
						}
						if ($xfrom>$from) {
							$oldsamplecamposgnumeric=$samplecamposgnumeric;
						}
						$samplecamposgnumeric=array();
						
						if (isset($sample[$xfrom/*+($importrec['EXCEL_TYPE'] == 'xlsx'?1:0)*/]))//	if (isset($sample[$xfrom+1]))
							$samplecamposgnumeric=explode('{|}',$sample[$xfrom+($importrec['EXCEL_TYPE'] == 'xlsx'?1:0)]);
						$txpos=0;
						if($this->debug) {
							pre( "--22--------------samplegnumeric-----array-----------" . __LINE__ .",");
							pre($samplecamposgnumeric);
							pre($xfrom+($importrec['EXCEL_TYPE'] == 'xlsx'?1:0));
						}
						
						if (($xfrom/*+($importrec['EXCEL_TYPE'] == 'xlsx'?1:0)*/)>$from) {

							foreach($samplecamposgnumeric as $ekey=>$evalue) {

								if (isset($oldsamplecamposgnumeric[$ekey]) && preg_match('/^([0-9\/\.\,\-\+]+)$/', $oldsamplecamposgnumeric[$ekey])==preg_match('/^([0-9\/\.\,\-\+]+)$/',$evalue)) {
									$txpos++;
								}
							}
							if($this->debug) {
								pre( "----sample-----array-----------" . __LINE__ .",");
								pre($samplecamposgnumeric);
								
							}
							if (count($samplecamposgnumeric)==count($oldsamplecamposgnumeric) && $txpos * 1.3 >count($samplecamposgnumeric)) {
								$samplecamposgnumeric=$oldsamplecamposgnumeric;
								break;
							}

						}

					}
					IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1){ echo "<br> post sample gnumeric". __METHOD__.' '.__FILE__.':'.__LINE__.print_r($samplecamposgnumeric,true) ."<br>";}
					if($this->debug) {
						pre('----------ACAaca 14----'.$importcode.'---------'. __LINE__);
				
					}
					IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1){ echo "<br> post sample gnumeric". __METHOD__.' '.__FILE__.':'.__LINE__.print_r($samplecamposgnumeric,true) ."<br>";}
					if ($changedirectorioall==true ) {
						if ( (!defined('READ_EXCEL_TOOL') or READ_EXCEL_TOOL==1)) {
							if($this->debug)pre('<font style="font-size:15px;color:blue">============>>>>>>>aqui1</font>');
							
							if ( (!defined('READ_EXCEL_TOOL') or READ_EXCEL_TOOL==1)) {
								foreach ($Spreadsheet as $Key => $Row) {
									if ($this->debug){
										pre("row  ". __LINE__. ' '. __METHOD__);
										pre( $Row);
									}
									if ($Key==0 and $Rowrest==-1)
										$Rowrest=0;
									$restrict=false;
									if($this->debug) {
									
										pre('----KEY-----------'.__LINE__. ' ' .__METHOD__.'------');
										PRE($Key);
									}	
									if (!empty(implode("",$Row)) ) {if($this->debug)pre('============>>>>>>>aqui3');
										$countFields=count($Row);
										
										if($this->debug) {
											pre('------------ROWREST-------------'.__LINE__. ' ' .__METHOD__.'------');
											PRE($Rowrest);
											pre('------------from-------------'.__LINE__. ' ' .__METHOD__.'------');
											PRE($from);
											pre('------------KEY-------------'.__LINE__. ' ' .__METHOD__.'------');
											PRE($Key);
											pre('------------to------------'.__LINE__. ' ' .__METHOD__.'------');
											PRE($to);
										}
										if ($Key>=$from+$Rowrest and $Key<=$to+$Rowrest ) {
											if($this->debug)pre('----------'.__LINE__. ' ' .__METHOD__.'------');
											foreach ($Row as $key2=>$field) {
												if($key2<$maxCol or $maxCol==-1) {
													$file_fields[$key2] =	//((empty($file_fields[$key2])) ? " ": $file_fields[$key2])
																		 $field;
												}
											}
										}
										$buffer=implode($Row);
										if (count($restrictions)>0) {
											$restrict=$this->apply_Restriction($restrictions,$buffer,$Key+$Rowrest);
										}

										if ($Key>=$to+$Rowrest+1 && !$restrict) {//echo "aqui";
											
											foreach ($Row as $key2=>$field) {
												$sample_content_fields[$key2] = //((empty($file_fields[$key2])) ? " ": $file_fields[$key2])
																					 $field;
											}
											if($this->debug) {
												pre('------BREAK---sample_content_fields----------'.__LINE__. ' ' .__METHOD__.'------');
												PRE($sample_content_fields);
												PRE ("$Key>=$to+$Rowrest+1 && !$restrict");
											}
											if (!empty($sheetPage)) {
												
												//break;
											}	
										}
										if ($this->debug){
											pre('------------GETTITLES-------------'.__LINE__. ' ' .__METHOD__.'------');
											PRE($getTitles);
											pre('------------KEY-------------'.__LINE__. ' ' .__METHOD__.'------');
											pre($Key);
											pre('------------LINES-------------'.__LINE__. ' ' .__METHOD__.'------');
											pre($lines);
											
										}
										if (isset($lines[8])&& $Key+1>=$lines[8]+ ( $importrec['EXCEL_TYPE']=='xls'?1:0)  and 
											isset($lines[9])&& $Key+1<=$lines[9]+ ( $importrec['EXCEL_TYPE']=='xls'?1:0) ){
											
											$getTitles=$Row;
										}
										if ($this->debug){
											Pre('------------GETTITLES-------------'.__LINE__. ' ' .__METHOD__.'------');
											PRE($getTitles);

										}
									}
								}	
							}
						}
						else {
							$Key=-1;

							foreach ($objWorksheet->getRowIterator() as $Row) {
								if (++$Key==0 and $Rowrest==-1)
									$Rowrest=0;

								$restrict=false;
								if ($this->debug){
									pre("row  ". __LINE__. ' '. __METHOD__);
									echo $Row;
								}
								if (!empty(implode("",$Row)) ) {
									$countFields=count($Row);
									if ($Key>=$from+$Rowrest and $Key<=$to+$Rowrest ) {

										foreach ($Row as $key2=>$field) {
											if($key2<$maxCol or $maxCol==-1) {
												$file_fields[$key2] = 	//((empty($file_fields[$key2])) ? " ": $file_fields[$key2])
																	 $field;
											}
										}
									}
									$buffer=implode($Row);
									if (count($restrictions)>0) {
										$restrict=$this->apply_Restriction($restrictions,$buffer,$Key+$Rowrest);
									}

									if ($Key>=$to+$Rowrest+1 && !$restrict) {
										foreach ($Row as $key2=>$field) {
											$sample_content_fields[$key2] = //((empty($file_fields[$key2])) ? " ": $file_fields[$key2])
																				 $field;
										}
										break;
									}
								}
							}
						}
					
					}
					if($this->debug) {
						pre('------------file_fields-------------'.__LINE__. ' ' .__METHOD__.'------');
						PRE($file_fields);
						echo '-------------';
					}
					if (empty($sample_content_fields)){
						$sample_content_fields=$file_fields;
					}
					if (empty($file_fields)) {
						if ($this->debug){
							pre('-------!A!-----vacio file fieldss------</B>-------'.__LINE__. ' ' .__METHOD__.'------');
						}	
						for ($key2=0;$key2<$countFields;$key2++) {
							$v=((int)($key2/26))*26;
							$htexCol=(($v>0)? chr(65+$v/26-1):"").chr(65+$key2-$v);
							$file_fields[$key2]= "(".dict('GEN_LBL_COLUMN')." [".$htexCol.'])';
							//e cho $samplecamposgnumeric[$key2];
							$patron = '/^(([0-9]{4})(\/|\-)([0-9]{2})(\/|\-)([0-9]{2})|([0-9]{2})(\/|\-)([0-9]{2})(\/|\-)([0-9]{4}))/';
							if(preg_match($patron, $samplecamposgnumeric[$key2]) === 1) {
								$sample_fields[$file_fields[$key2]]=$samplecamposgnumeric[$key2];
								if ($this->debug){
									echo "opcion1";
								}
							}
							else {
								$sample_fields[$file_fields[$key2]]=$sample_content_fields[$key2];
								if ($this->debug){
									echo "opcion2";
								}
								
							}
						}
					}
					else {
						if ($this->debug){
								pre('-------!B!----- file fieldss CON DATOS------</B>-------'.__LINE__. ' ' .__METHOD__.'------');

								PRE($file_fields);
						}	
							
						foreach($file_fields as $key2=>&$value) {
							$value=trim($value);

							if (empty($value) or isset($sample_fields[$value])) {
								$v=((int)($key2/26))*26;
								$htexCol=(($v>0)? chr(65+$v/26-1):"").chr(65+$key2-$v);
								$value= "(".dict('GEN_LBL_COLUMN')." [".$htexCol.'])';
							}
							$file_fields[$key2]=$value;
							//	e cho $samplecamposgnumeric[$key2];
							$patron = '/^(([0-9]{4})(\/|\-)([0-9]{2})(\/|\-)([0-9]{2})|([0-9]{2})(\/|\-)([0-9]{2})(\/|\-)([0-9]{4}))/';
							//	e cho "<br>|",$samplecamposgnumeric[$key2];
							if(isset($samplecamposgnumeric[$key2]) && preg_match($patron, $samplecamposgnumeric[$key2]) === 1) {
								$sample_fields[$value]=$samplecamposgnumeric[$key2];
							}
							else {
								$sample_fields[$value]=$sample_content_fields[$key2];
							}
						}
						if ($this->debug){
									pre( "sample_fields".__LINE__);
									PRE($sample_fields);
						}	
					}
					IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1){ 
						echo "<br> pre assing xreturn". __METHOD__.' '.__FILE__.':'.__LINE__,"<pre>",print_r($xreturn,true) ,"</pre>";
					}
					if($this->debug) {
						pre('--------sample+fields----------Acaaca 16-------------'. __LINE__);
						pre($sample_fields);
					}
				
					
					$pso=1;
					if($this->debug) {
						pre('--------------xreturn------------'. __LINE__);
						pre($xreturn);
						pre('--------------name------------'. __LINE__);
						pre($Name);
						pre('--------------sheetpage------------'. __LINE__);
						pre($sheetPage);
					}
					if (empty($xreturn) && (substr($sheetPage,0,strlen($Name))==$Name || $sheetPage=='')  ) {
						if (!$test) {
							if (isset($sample_content_fields) && count($sample_content_fields)>0)
							{  
								$xreturn=array($Name,$sample_content_fields);
							}
							else {
								$xreturn=array($Name,$file_fields);
							}
						}
						else {
							$xreturn=array($Name,$sample_fields);
							
						}
					}
					IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1){ 
						echo "<br> post assign¨ xreturn",   __METHOD__.' '.__FILE__.':',__LINE__,"<pre>",print_r($xreturn,true) ,"</pre> test:",$test;
					}
					$countFields=0;
					IF ($this->debug==true) {
						pre($file_fields);
						PRE("TEST ".$Index.' => '.$Name .' | ' .__METHOD__.' '.__LINE__);
						PRE($test);
					}
					if (count($file_fields)>0 and !$test ) {
						$record = array();
						$record['IMPORTCODE'] = $importcode;
						$record['IMPORTSHEETS'] = $Name;
						$i = CLX_INIT_ZERO;
						foreach ($file_fields as $field) {
							if (!(strpos($field,chr(195))===false)) {
								$record['FILE_FIELDNAME'] = clx_change_acentos_char_html($field);
							}
							else {
								$record['FILE_FIELDNAME'] = clx_change_acentos_char_html($field);
							}
							$record['SEQNUM'] = $i;
							ClxCommon::$db->createRecord('CLX_DB_IMPORT_FIELDS', $record, false);
							if ($this->debug==true) {echo $b='update import_fields in '.__LINE__;pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}
							$i++;
						}
					}
				}		
			}
			catch (Exception $E)
			{
				echo  $E -> getMessage();
			}

		} else {
			IF ($this->debug==true) {
			
				PRE("<font style='font-size:20px>onlyTitles'> ". __LINE__ ."</font>");
				PRE($onlyTitles);
			}
			$file_fields = array();
			$records = ClxCommon::$db->getRecords('CLX_DB_IMPORT_FIELDS', 'IMPORTCODE=' . singleQuote($importcode));
			while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
				$file_fields[] = $record['FILE_FIELDNAME'];
			}
		}
		IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1){ echo "<br> post sample gnumeric". __METHOD__.' '.__FILE__.':'.__LINE__.print_r($xreturn,true) ."<br>";}
		IF ($this->debug==true) {
			pre('--------------xreturn--final1--'.$sheetPage.'--------'. __LINE__);
			pre($xreturn);
			pre('--------------$onlyTitles--------'. __LINE__);
			pre($onlyTitles);
			pre('--------------getTitles--------'. __LINE__);
			pre($getTitles);
		}
		if ($onlyTitles==true) {
			$xreturn[1]=$getTitles;
		}
		IF ($this->debug==true) {
			pre('--------------xreturn--final2--'.$sheetPage.'--------'. __LINE__);
			pre($xreturn);
		}
		return $xreturn;

	}
	function read_Excel_From_gnumeric_sample(&$file,$mappings,$importcode='') {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}
		$fileread2= str_ireplace('xls','txt',str_ireplace('xlsx','txt', $file));
		if (file_exists($fileread2))
			unlink($fileread2);//restore_error_handler();

		for ($k=0;$k<10;$k++) {
			if (file_exists($fileread2.'.'.$k)) {

				unlink($fileread2.'.'.$k);
			}
		}
		if (file_exists(str_ireplace('.xls','.txt',str_ireplace('.xlsx','.txt', $file))))
			unlink(str_ireplace('.xls','.txt',str_ireplace('.xlsx','.txt', $file)));
	//	pre(get_defined_constants());
	
	
	//////////////////////////////////////////////////////
	
		IF (stripos(' '.PHP_OS,'WIN')>0){//DBIM_SCONVERT_GEN_WINDOWS_FILE
			if (!defined('DBIM_SCONVERT_GEN_WINDOWS_FILE'))
				PRE(NOTE('Not exists constants: '.DBIM_SCONVERT_GEN_WINDOWS_FILE));

			$filegentoimp=$fileread2;
			$fileread2=DBIM_SCONVERT_GEN_WINDOWS_FILE .basename($fileread2);
			
			$fileimptogen=DBIM_SCONVERT_GEN_WINDOWS_FILE .basename($file);
		
		}
		if (file_exists($fileread2))
			unlink($fileread2);

		for ($k=0;$k<10;$k++) {
			if (file_exists($fileread2.'.'.$k)) {
				unlink($fileread2.'.'.$k);
			}
		}
		$hoja='';
		foreach($mappings as $tkey=>$tvalue) {

			$hoja=$tvalue['IMPORTSHEETS'];
			break;
		}
		if ( empty($hoja)) {
			$impInfoSample=$this->Importsamplenotdownload($importcode);
			$impInfoSample;
		
			$Spreadsheet = new SpreadsheetReader($impInfoSample);
			$Sheets = $Spreadsheet -> Sheets();
			$hojas=array();
		//	pre($Sheets);
			foreach ($Sheets as $Index => $NameSheet) {	
				$hojas[$Index]=$NameSheet;
				
			}
			$hoja=$hojas[0];
		}
		//exec('ssconvert  -S '.quote($file).' '. (quote($fileread2= str_ireplace('.xls','.csv',str_ireplace('.xlsx','.csv', $file)))));
		//hoja particular
		if (file_exists(str_ireplace('.xls','.txt',str_ireplace('.xlsx','.txt', $file))))
			unlink(str_ireplace('.xls','.txt',str_ireplace('.xlsx','.txt', $file)));
		IF (stripos(' '.PHP_OS,'WIN')>0){//DBIM_SCONVERT_GEN_WINDOWS_FILE
			if (!defined('DBIM_SCONVERT_GEN_WINDOWS_FILE'))
				PRE(NOTE('Not exists constants: '.DBIM_SCONVERT_GEN_WINDOWS_FILE));
			
			copy($file, $fileimptogen);
			//echo " copy($file, $fileimptogen);";
			$CM= 	(QUOTE(DBIM_SCONVERT_GEN_WINDOWS_FILE.'ssconvert.EXE').' -O '.quote( 'sheet='.singlequote($hoja).' separator={|} eol=windows ').' '.quote($fileimptogen).' '. (quote($fileread2)));
			
			$CM=str_replace('/','\\',$CM);
			if ($this->debug==true) {PRE('SSCONVERT '.__LINE__);PRE($CM);}
			
			if ($this->debug)
				ECHO "<BR>".__LINE__." ",$CM, "<BR>";
			IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1){ echo "<br> cm",   __METHOD__.' '.__FILE__.':',__LINE__,"<pre>",$CM;}

			$a1=fopen(kPathToWebSite.'temp/ssconvert.txt','a+');
			fwrite($a1, __LINE__ .' '. __METHOD__ .' '.getcwd().CHR(13).CHR(10));
			fwrite($a1, $CM.CHR(13).CHR(10));
			fclose($a1);
			$te=debug_backtrace(); 

			exec($CM);
			//@copy($fileread2,$filegentoimp);
			//@unlink($fileread2);
			//@unlink($fileimptogen);
		//	$fileread2=$filegentoimp;
		//	echo "copy($fileread2,$filegentoimp);";
			//die;		
		}
		else {
		
			$CM= 	('ssconvert  -O '.singlequote( 'sheet='.quote($hoja).' separator={|} eol=windows ').' '.quote($file).' '. (quote($fileread2= str_ireplace('.xls','.txt',str_ireplace('.xlsx','.txt', $file)))));
			IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1){ echo "<br> cm",   __METHOD__.' '.__FILE__.':',__LINE__,"<pre>",$CM;}

			exec($CM);
			if ($this->debug==true) {PRE('SSCONVERT '.__LINE__);PRE($CM);}

		}
		
		/*
		foreach($mappings as $tkey=>$tvalue) {

			$fileread3=str_replace('csv',$x='csv'.preg_replace('/\((.*?)\)/', ".$1", $tvalue['POSITION_SHEET']),$fileread2);

			if (file_exists($fileread3)){
				$fileread2=$fileread3;
			}

			break;
		}*/

		$file=$fileread2;
		return  cambiocomillascomas_simple($fileread2,true);
	}
	function read_Excel_From_gnumeric_sample2(&$file,$mappings) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}
		$fileread2= str_ireplace('xls','csv',str_ireplace('xlsx','txt', $file));
		IF (stripos(' '.PHP_OS,'WIN')>0){//DBIM_SCONVERT_GEN_WINDOWS_FILE
			if (!defined('DBIM_SCONVERT_GEN_WINDOWS_FILE'))
				PRE(NOTE('Not exists constants: '.DBIM_SCONVERT_GEN_WINDOWS_FILE));
			$filegentoimp=$fileread2;
			$fileread2=DBIM_SCONVERT_GEN_WINDOWS_FILE .basename($fileread2);
			
			$fileimptogen=DBIM_SCONVERT_GEN_WINDOWS_FILE .basename($file);
		
		}
		if (file_exists($fileread2))
			unlink($fileread2);

		for ($k=0;$k<10;$k++) {
			if (file_exists($fileread2.'.'.$k)) {

				unlink($fileread2.'.'.$k);
			}
		}
		$hoja='';
		foreach($mappings as $tkey=>$tvalue) {

			$hoja=$tvalue['IMPORTSHEETS'];
			break;
		}
		//todo hojas'
		//exec('ssconvert  -S '.quote($file).' '. (quote($fileread2= str_ireplace('.xls','.csv',str_ireplace('.xlsx','.csv', $file)))));
		//hoja particular
		if (file_exists(str_ireplace('.xls','.txt',str_ireplace('.xlsx','.txt', $file))))
			unlink(str_ireplace('.xls','.txt',str_ireplace('.xlsx','.txt', $file)));
		IF (stripos(' '.PHP_OS,'WIN')>0){//DBIM_SCONVERT_GEN_WINDOWS_FILE
			if (!defined('DBIM_SCONVERT_GEN_WINDOWS_FILE'))
				PRE(NOTE('Not exists constants: '.DBIM_SCONVERT_GEN_WINDOWS_FILE));
			copy($file, $fileimptogen);
			$CM= 	(QUOTE(DBIM_SCONVERT_GEN_WINDOWS_FILE.'ssconvert.EXE').' -O '.quote( 'sheet='.singlequote($hoja).' separator={|} eol=windows ').' '.quote($fileimptogen).' '. (quote($fileread2)));
			$CM=str_replace('/','\\',$CM);
			if ($this->debug==true) {PRE('SSCONVERT '.__LINE__);PRE($CM);}

			//ECHO "<BR>",$CM, "<BR>";
			IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1){ echo "<br> cm",   __METHOD__.' '.__FILE__.':',__LINE__,"<pre>",$CM;}

			exec($CM);
			copy($fileread2,$filegentoimp);
			unlink($fileread2);
			unlink($fileimptogen);
			$fileread2=$filegentoimp;
	
	
			$ret=-1;
			exec($CM,$out,$ret);
		}	
		else {
			$CM= 	('ssconvert  -O '.singlequote( 'sheet='.quote($hoja).' separator={|} eol=windows ').' '.quote($file).' '. (quote($fileread2= str_ireplace('.xls','.txt',str_ireplace('.xlsx','.txt', $file)))));
			IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1){ echo "<br> cm",   __METHOD__.' '.__FILE__.':',__LINE__,"<pre>",$CM;}

			exec($CM);
			if ($this->debug==true) {PRE('SSCONVERT '.__LINE__);PRE($CM);}

		}
		$a1=fopen(kPathToWebSite.'temp/ssconvert.txt','a+');
			fwrite($a1, __LINE__ .' '. __METHOD__ .' '.getcwd().CHR(13).CHR(10));
			fwrite($a1, $CM.CHR(13).CHR(10));
			fclose($a1);
		$count=0;
		if (file_exists($fileread2)) {
			$fx=fopen($fileread2,'r');
			while ($tx=fread($fx, 200000)) {
				$count+=count(explode(chr(10),$tx));
				$tx='';
			}
			fclose($fx);
		}
		return  $count;
	}
	

	function deleteRecordSk($id) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1604;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		$record = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $id);
		$idcode = $record['IDCODE'];
		$maps = ClxCommon::$db->getRecords('CLX_DB_IMPORT_MAPPINGS', 'IMPORTCODE=' . singleQuote($idcode));
		while (($map = ClxCommon::$db->getNextRecord($maps))) {
			ClxCommon::$db->deleteRecords('CLX_DB_IMPORT_TRANSLATIONS', 'MAPID=' . $map['ID']);
		}
		ClxCommon::$db->deleteRecords('CLX_DB_IMPORT_FIELDS', 'IMPORTCODE=' . singleQuote($idcode));
		ClxCommon::$db->deleteRecords('CLX_DB_IMPORT_EXECUTIONS', 'IMPORTCODE=' . singleQuote($idcode));
		ClxCommon::$db->deleteRecords('CLX_DB_IMPORT_MAPPINGS', 'IMPORTCODE=' . singleQuote($idcode));
		ClxCommon::$db->deleteRecords('CLX_DB_IMPORT_ERRORS', 'IMPORTCODE=' . singleQuote($idcode));
		ClxCommon::$db->deleteRecords($this->tablename, 'ID=' . $id);
		$DBMO = &getTool('DBMO');
		$DBMO->versionIncrease('IDCODE', $record['MODULECODE']);
	}

	function defaultRecord() {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1605;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		$record = array();
		$record['DBIM_id'] = CLX_INIT_ZERO;
		$record['DBIM_idcode'] = '';
		$record['DBIM_idname'] = '';
		$record['DBIM_version'] = '1.0.0';
		$record['DBIM_cdate'] = '';
		$record['DBIM_mdate'] = '';
		$record['DBIM_username'] = $_SESSION['user_record']['username'];
		$record['DBIM_description'] = '';
		$record['DBIM_modulecode'] = '';
		$record['DBIM_tablecode'] = '';
		$record['DBIM_type'] = 'FRL';
		$record['DBIM_record_delim'] = '[13][10]';
		$record['DBIM_field_delim'] = array(array(0=>'[9]'));
// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - BEGIN
		$record['DBIM_record_delim_frl'] = '[13][10]';
// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - END

		$record['DBIM_record_length'] = '512';
		$record['DBIM_if_duplicates'] = CLX_INIT_ZERO;
		$record['DBIM_excel_count_sheets']= CLX_INIT_ZERO;
		$record['DBIM_file']	  = '';
		$record['DBIM_filefixed'] = '';
		$record['DBIM_fileexcel'] = '';
		$record['DBIM_field_delim'] =array(0=>'[9]',1=>'',2=>'',3=>'',4=>'',5=>'',6=>'',7=>'');
		$record['DBIM_field_cdelim'] =array(4=>'',5=>'',6=>'');
		$record['DBIM_field_prop']=array("","","");
		$record['DBIM_field_cprop']=array("","","");
		$record['DBIM_record_prop']=array("","","");
		$record['DBIM_record_cprop']=array("","","");
		$record['DBIM_excel_type']= 'xlsx';

		/*$record['DBIM_record_delim'] = $values['RECORD_DELIM'];
		$record['DBIM_field_delim_other'] = $values['FIELD_DELIM'];
		$record['DBIM_record_delim_other'] = $values['RECORD_DELIM'];
		$record['DBIM_record_length'] = $values['RECORD_LENGTH'];
*/
		return $record;
	}

	function versionIncrease($fieldname, $fieldvalue) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1606;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		parent::versionIncrease($fieldname, $fieldvalue);
		$modulecode = ClxCommon::$db->getField($this->tablename, 'MODULECODE', $fieldname . '=' . singleQuote($fieldvalue));
		$DBMO = &getTool('DBMO');
		$DBMO->versionIncrease('IDCODE', $modulecode);
	}

	private $s_input_line_encoding_detect;

	private function input_line_encoding_detect($buffer) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1607;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		if (is_null($this->s_input_line_encoding_detect)) {
			$this->s_input_line_encoding_detect = mb_detect_encoding($buffer . 'a', 'UTF-8, ISO-8859-1', true);
		}
		$this->s_input_line_encoding_detect2 = mb_detect_encoding($buffer , 'auto');
		if ($this->s_input_line_encoding_detect !== 'UTF-8') {
			$buffer = encode_string($buffer, 'UTF-8', $this->s_input_line_encoding_detect);
			$this->s_input_line_encoding_detect2 = mb_detect_encoding($buffer , 'auto');
		}

		return $buffer;
	}
	function validar_tabla($mappings, $field_records,$field_derived,$tablename,$importcode,$code_lot,$cdatecomunerror) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}

		switch (kDatabaseType) {
			case 'oci': // Oracle
				$rs = ClxCommon::$db->executeQuerySilent('SELECT column_name, data_type  FROM all_tab_columns  WHERE table_name = '.singleQuote($tablename));
				break;
			default:
				$rs = ClxCommon::$db->executeQuerySilent('describe '.$tablename);
			break;

		}
		$fisic_fields=array();
		$key_fisic_fields=array();
		if (!empty($rs)) {
			while ($r = ClxCommon::$db->getNextRecord($rs, NUMERIC)) {
				$r[1]=uppercase(preg_replace('/\((.*?)\)/i', '',$r[1]));

				$fisic_fields[uppercase($r[0])]=$r[1];
				$key_fisic_fields[]=uppercase($r[0]);
			}
		}
		$valid=1;
		$keys_mappings=array_keys($mappings);
		$keys_field_derived=array_keys($field_derived);
		$keys_field_records=array_keys($field_records);
		foreach ($mappings as $key=>$value) {
			if (in_array(uppercase($mappings[$key]['TABLE_FIELDNAME']),$key_fisic_fields)) {
				if (in_array(uppercase($mappings[$key]['TABLE_FIELDNAME']),$keys_field_derived)) {
					//no view case sample

				}
				else if (in_array(uppercase($mappings[$key]['TABLE_FIELDNAME']),$keys_field_records)) {
					// validation type file
					if (strpos(' ,CHAR,VARCHAR,SOBJ,TLOOK,TLOK,NVARCHAR,VARCHAR2,NVARCHAR2,TEXT,TEXTO,',','. $field_records[uppercase($mappings[$key]['TABLE_FIELDNAME'])]['FIELDTYPE'].',') >0 &&
						strpos(' ,CHAR,VARCHAR,SOBJ,TLOOK,TLOK,NVARCHAR,VARCHAR2,NVARCHAR2,TEXT,TEXTO,', ','.$fisic_fields[uppercase($mappings[$key]['TABLE_FIELDNAME'])].','	)>0) {

					}
					else if (strpos(' ,NUMERIC,DECIMAL,DECN,INT,INTEGER,INTN,INTUNSIGNED,INT UNSIGNED,PRIM,FLOAT,LONG,NUMBER,TINYINT,SMALLINT,MEDIUMINT,BIGINT,DOUBLE,TINYINT UNSIGNED,SMALLINT UNSIGNED,BIGINT UNSIGNED,MEDIUMINT UNSIGNED,PHOTO FILE', ','.$field_records[uppercase($mappings[$key]['TABLE_FIELDNAME'])]['FIELDTYPE'].',') >0 &&
						strpos(' ,NUMERIC,DECIMAL,DECN,INT,INTEGER,INTN,INTUNSIGNED,INT UNSIGNED,PRIM,FLOAT,LONG,NUMBER,TINYINT,SMALLINT,MEDIUMINT,BIGINT,DOUBLE,TINYINT UNSIGNED,BIGINT UNSIGNED,SMALLINT UNSIGNED,MEDIUMINT UNSIGNED,PHOTO FILE', ','.$fisic_fields[uppercase($mappings[$key]['TABLE_FIELDNAME'])].','	)>0) {

					}
					else if (strpos(' ,DATE,DATI,TIMESTAMP,TIME,', ','.$field_records[uppercase($mappings[$key]['TABLE_FIELDNAME'])]['FIELDTYPE'].',') >0 &&
						strpos(' ,DATE,DATI,TIMESTAMP,TIME,', ','.$fisic_fields[uppercase($mappings[$key]['TABLE_FIELDNAME'])].','	)>0) {

					}
					else if (strpos(' ,DATI,DATETIME,TIMESTAMP,', ','.$field_records[uppercase($mappings[$key]['TABLE_FIELDNAME'])]['FIELDTYPE'].',') >0 &&
						strpos(' ,DATI,DATETIME,TIMESTAMP,', ','.$fisic_fields[uppercase($mappings[$key]['TABLE_FIELDNAME'])].','	)>0) {

					}
					else if (strpos(' ,CLOB,BLOB,NCLOB,TINITEXT,TINYBLOB,MEDIUMBLOB,MEDIUMTEXT,LONGBLOB,LONGTEXT,TEXT,', ','.$field_records[uppercase($mappings[$key]['TABLE_FIELDNAME'])]['FIELDTYPE'].',') >0 &&
						strpos(' ,CLOB,BLOB,NCLOB,TINITEXT,TINYBLOB,MEDIUMBLOB,MEDIUMTEXT,LONGBLOB,LONGTEXT,TEXT,', ','.$fisic_fields[uppercase($mappings[$key]['TABLE_FIELDNAME'])].','	)>0) {

					}
					else if (strpos(' ,RAW,LONG RAW,', ','.$field_records[uppercase($mappings[$key]['TABLE_FIELDNAME'])]['FIELDTYPE'].',') >0 &&
						strpos(' ,RAW,LONG RAW,', ','.$fisic_fields[uppercase($mappings[$key]['TABLE_FIELDNAME'])].','	)>0) {

					}
					else if (strpos(' ,BFILE,', ','.$field_records[uppercase($mappings[$key]['TABLE_FIELDNAME'])]['FIELDTYPE'].',') >0 &&
						strpos(' ,BFILE,', ','.$fisic_fields[uppercase($mappings[$key]['TABLE_FIELDNAME'])].','	)>0) {

					}
					else if (strpos(' ,ENUM,', ','.$field_records[uppercase($mappings[$key]['TABLE_FIELDNAME'])]['FIELDTYPE'].',') >0 &&
						strpos(' ,ENUM,', ','.$fisic_fields[uppercase($mappings[$key]['TABLE_FIELDNAME'])].','	)>0) {

					}
					else if (strpos(' ,SET,', ','.$field_records[uppercase($mappings[$key]['TABLE_FIELDNAME'])]['FIELDTYPE'].',') >0 &&
						strpos(' ,SET,', ','.$fisic_fields[uppercase($mappings[$key]['TABLE_FIELDNAME'])].','	)>0) {

					}
					else if (strpos(' ,BOOL,', ','.$field_records[uppercase($mappings[$key]['TABLE_FIELDNAME'])]['FIELDTYPE'].',') >0 &&
						strpos(' ,TINYINT UNSIGNED,NUMBER,', ','.$fisic_fields[uppercase($mappings[$key]['TABLE_FIELDNAME'])].','	)>0) {

					}
					else if (strpos(' ,LOOK,LIST,', ','.$field_records[uppercase($mappings[$key]['TABLE_FIELDNAME'])]['FIELDTYPE'].',') >0 &&
						strpos(' ,VARCHAR,NVARCHAR2,VARCHAR2,INT UNSIGNED,', ','.$fisic_fields[uppercase($mappings[$key]['TABLE_FIELDNAME'])].','	)>0) {

					}
					else { //error type file
						$valid=4;
						$saved_errors=0;
						$this->saveErrors($importcode, '-1', array('File'=>dict("GEN_LBL_NON_TYPE_VALID ").$mappings[$key]['TABLE_FIELDNAME'].' '.$field_records[	uppercase($mappings[$key]['TABLE_FIELDNAME'])]['FIELDTYPE'].' '.	$fisic_fields[uppercase($mappings[$key]['TABLE_FIELDNAME'])]), $saved_errors,$code_lot,$cdatecomunerror,false);

						/*$tta=fopen(kPathToWebSite."/".kPathToTemp."invalid_type.txt","a+");
						fwrite($tta, $mappings[$key]['TABLE_FIELDNAME'],chr(13).chr(10));
						fwrite($tta,$field_records[uppercase($mappings[$key]['TABLE_FIELDNAME'])]['FIELDTYPE'].chr(13).chr(10));
						fwrite($tta,$fisic_fields[uppercase($mappings[$key]['TABLE_FIELDNAME'])].chr(13).chr(10).chr(13).chr(10));
						fclose($tta);*/
					}
				}
				else{ // error fisic field and mapping yes and not field in type fields
					$valid=2;$saved_errors=0;
					$this->saveErrors($importcode, '-1',array('File'=>"campo buscado:".uppercase($mappings[$key]['TABLE_FIELDNAME']).'<br>'. "tabla campos fisico:". implode(', ',$key_fisic_fields)), $saved_errors,$code_lot,$cdatecomunerror,false);
								break;
				}
			}
			else if(isset( $field_derived[uppercase($mappings[$key]['TABLE_FIELDNAME'])])) {
				//is_derived
			}
			else { //fisic field no or field en db_table and mapping field yes
				$valid=3;$saved_errors=0;
				$this->saveErrors($importcode, '-1',array('File'=>"campo buscado:".uppercase($mappings[$key]['TABLE_FIELDNAME']).'<br>'. "tabla campos fisico:". implode(', ',$key_fisic_fields)), $saved_errors,$code_lot,$cdatecomunerror,false);

				break;
			}
		}	// not error
		return $valid==1;
	}
	function writeziptotext($ruta='',$filename='',&$filenameinzip='') {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}##print_r(UserRequest::$files['DBIM_file']);

		if (!empty($filename)) {
			$path_info=pathinfo($filename);

			IF(ISSET($path_info['extension'])) {
				$fileext=lowercase($path_info['extension']);
				if ($fileext==="zip") {
					$zip = new ZipArchive;
					$zip->open($ruta.$filename);
					$texto= $zip->getFromIndex(0);
					$filenameinzip = $zip->getNameIndex(0);
					$zip->close();
					$afile=fopen($ruta.$filenameinzip,"w+");
					fwrite($afile,$texto);
					fclose($afile);
				}
			}
		}
		else {
			$path_info=pathinfo(UserRequest::$files['DBIM_file']['name']);
			IF(ISSET($path_info['extension'])) {
				$fileext=lowercase($path_info['extension']);
				if ($fileext==="zip") {
					$zip = new ZipArchive;
					$filename = UserRequest::$files['DBIM_file']['tmp_name'];
					$zip->open($filename);
					$texto= $zip->getFromIndex(0);
					$filenameinzip = $zip->getNameIndex(0);
					$zip->close();
					$filename = UserRequest::$files['DBIM_file']['tmp_name']=kPathToWebSite."/".kPathToTemp."/".UserRequest::$files['DBIM_file']['name'];
					$afile=fopen($filename,"w+");
					fwrite($afile,$texto);
					fclose($afile);
					UserRequest::$files['DBIM_file']['name']=$filenameinzip;
				}
			}
		}
	}
	function import($is_batch=true) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1608;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		//$this->debug=true;
		if (isset($this->batch_pid))
			$batch_log_id=$this->batch_pid;
		else
			$batch_log_id=0;
		
		IF ($this->debug==true)
			$debug=true;
		$vv=microtime(true);
		$GLOBALS['PROCESS']='DBIM';
		$DBEX = &getTool('DBIX');
		$timex=microtime(true);
		##$tta=fopen(kPathToWebSite."/".kPathToTemp."archivoX2.txt","a+");fwrite($tta,"SIIIIIIIIIII".CHR(13).CHR(10));fclose($tta);

		$init_time_out = ini_get('max_execution_time');
		//ini_set('display_errors', '1');
		//ini_set('memory_limit',$this->memorylimit);
		UserResponse::setRunTimeLimit(CLX_NUM_24 * CLX_NUM_60 * CLX_NUM_60);
		$this->s_input_line_encoding_detect = null;
		$this->s_input_line_encoding_detect2= null;
		$EVNT = &getTool('EVNT');
		//Stored for returning later
		$savepost = UserRequest::$post;
		$saverequest = UserRequest::$request;
		$saveget = UserRequest::$get;
		if (empty(UserRequest::$post['DBIM_id'])) {
			 return note('Not set option');

		}
		if (isset(UserRequest::$post['DBIM_precharge']))
			$PRECHARGE=UserRequest::$post['DBIM_precharge'];
		else
			$PRECHARGE=0;
		$importid = UserRequest::$post['DBIM_id'];
		$test = UserRequest::$post['DBIM_test'];
		$show_file = UserRequest::$post['DBIM_show_file'];
		$error_limit = UserRequest::$post['DBIM_error_limit'];
		$description = UserRequest::$post['DBIM_description'];
		$original_filename = UserRequest::$files['DBIM_file']['name'];
		if ($PRECHARGE==1) {
			$original_filename=UserRequest::$post['DBIM_file_precharge'];
		}
		else if (empty($original_filename))
			$original_filename = UserRequest::$files['DBIM_file'];

		if(isset(UserRequest::$post['DBIM_FILENAME_INC_DATE']))
			$FILENAME_INC_DATE = UserRequest::$post['DBIM_FILENAME_INC_DATE'];
		else if(isset(UserRequest::$post['FILENAME_INC_DATE']))
			$FILENAME_INC_DATE = UserRequest::$post['FILENAME_INC_DATE'];
		else
			$FILENAME_INC_DATE ='';
		if(isset(UserRequest::$post['DBIM_CH_VALUE_DATE']))
			$CH_VALUE_DATE = UserRequest::$post['DBIM_CH_VALUE_DATE'];
		else if(isset(UserRequest::$post['CH_VALUE_DATE']))
			$CH_VALUE_DATE = UserRequest::$post['CH_VALUE_DATE'];

		if ($FILENAME_INC_DATE==0 &&defined('DBIM_EXCEPT_NOT_USER_FILEDATE_REQ')) {
			$evalor=explode(",",DBIM_EXCEPT_NOT_USER_FILEDATE_REQ);
			foreach($evalor as $key=>$xv) {
				//pre($xv."__".UserRequest::$post['DBIM_idcode']);
				//pre("pos1");pre($xv);
				if($xv==UserRequest::$post['DBIM_idcode']) {
					$FILENAME_INC_DATE=1;
					$CH_VALUE_DATE='';
				}
			}
		}
		IF ($this->debug==true) {
			echo "post para ejecutar ";
			PRE(UserRequest::$post);
		}


		$imft_record=array();
		if(!empty(UserRequest::$post['IMFT_ID'])) {
			$_SESSION['IMFT_ID'] =UserRequest::$post['IMFT_ID'];
			$DBIX_rec = ClxCommon::$db->getONERecord($sql='SELECT * FROM CLX_DB_IMPORT_EXECUTIONS WHERE IMFT_ID=' . UserRequest::$post['IMFT_ID']);
			$imft_record = ClxCommon::$db->getRecord($this->imftname, 'ID=' . UserRequest::$post['IMFT_ID']);
			if (empty($original_filename)){// pre($imft_record);
				$original_filename=$DBIX_rec['FILENAME'] ;
			}
			if (empty($original_filename)){// pre($imft_record);
				$original_filename=$imft_record['ETL_FILENAME'] ;
			}
			IF ($this->debug==true)
				pre($imft_record['ETL_FILEPATH']  .'/'.$original_filename);
			if (file_exists($imft_record['ETL_FILEPATH']  .'/'.$original_filename)) {
				copy($imft_record['ETL_FILEPATH']  .'/'.$original_filename,  kPathToWebSite."/import/".$original_filename);
			}

		}
		$saved_errors = CLX_INIT_ZERO;
		//May come from batch then no extra log is required since was set on schedule batch

		$idrecordexecutions = (!empty(UserRequest::$post['RINNING_BATCH'])) ? UserRequest::$post['RINNING_BATCH'] : CLX_NUM_ZERO;

		$importrec = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $importid);
		if (isset($FILENAME_INC_DATE)) {
			$importrec['FILENAME_INC_DATE']=$FILENAME_INC_DATE;
		}
		if (isset($CH_VALUE_DATE)) {
			$importrec['CH_VALUE_DATE']=$CH_VALUE_DATE;
		}
		if ($FILENAME_INC_DATE==0 &&defined('DBIM_EXCEPT_NOT_USER_FILEDATE_REQ')) {

		}
		else {
			$FILENAME_INC_DATE=$importrec['FILENAME_INC_DATE'];
			$CH_VALUE_DATE=$importrec['CH_VALUE_DATE'];
		}
		$typeoriginal=$importrec['TYPE']=uppercase($importrec['TYPE']);
		$code_lot=++$importrec['LOG_ID'];
		$importrec2=$importrec;
		unset($importrec2['ID']);
		unset($importrec2['FILE_C']);
		unset($importrec2['FILE_CEXCEL']);
		unset($importrec2['FILE_CDELIM']);
		unset($importrec2['CDATE']);
		unset($importrec2['MDATE']);
		unset($importrec2['USERNAME']);
		unset($importrec2['TYPE']);
		unset($importrec2['IF_DUPLICATE']);
		unset($importrec2['IF_UTF8']);
		unset($importrec2['FIELD_DELIM']);
		unset($importrec2['NEWTABLECODE']);
		unset($importrec2['FILE_CDELIM']);
		unset($importrec2['VERSION']);
		unset($importrec2['DESCRIPTION']);
		unset($importrec2['FIELD_DELIM']);
		unset($importrec2['FIELD_CDELIM']);
		unset($importrec2['RECORD_PROP']);
		unset($importrec2['RECORD_CPROP']);
		unset($importrec2['FILE']);
		unset($importrec2['FILE_EXCEL']);
		unset($importrec2['FILE_DELIM']);
		unset($importrec2['NEWTABLECODE']);
		unset($importrec2['EXCEL_TYPE']);

		ClxCommon::$db->updateRecord($this->tablename, $importrec2, 'ID=' . $importid);

		$importrec["RECORD_PROP"]=json_decode($importrec["RECORD_PROP"],true);
		$importrec["RECORD_CPROP"]=json_decode($importrec["RECORD_CPROP"],true);
//$importrec["FIELD_DELIM"]=json_decode($importrec["FIELD_DELIM"],true);
//$importrec["FIELD_CDELIM"]=json_decode($importrec["FIELD_CDELIM"],true);

		$importcode = $importrec['IDCODE'];
		$tablecode = $importrec['TABLECODE'];
		$DBIU=new db_import_run();
		$DBIU->basicFields($importrec['TABLECODE']);
		$this->import_extra_fields_required=$DBIU->import_extra_fields_required;
		$insertfields=explode(",",$this->import_extra_fields_required);

		$this->compileCodeFormulas($importcode);
		$tablerec = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE=' . singleQuote($tablecode));
		$tablename = $tablerec['MODULECODE'] . '_' . $tablerec['IDNAME'];
		//ClxCommon::$db->deleteRecords('CLX_DB_IMPORT_ERRORS', 'IMPORTCODE=' . singleQuote($importcode));
		$mappings = $this->getMappings($importcode);

		$SEEKMAPPINGS=	true;
		if ($typeoriginal=='XLS2') {
			foreach($mappings as $tkey=>$info) {
				if (empty($info['POSITION_SHEET']) &&$SEEKMAPPINGS ) {
					$DBIU->extractFileFieldsExcel($importcode,$info['IMPORTSHEETS']);
					if($this->debug) {
						PRE( "extractFileFieldsExcel". __LINE__);
					}
					$sql='UPDATE CLX_DB_IMPORT_MAPPINGS SET POSITION_SHEET ='.singlequote($DBIU->posSheetname).'   WHERE  IMPORTCODE=' . singleQuote($importcode);
					ClxCommon::$db->executequery($sql);
					if ($this->debug==true) {echo $b='update mappings in 2978';pre($sql);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).$sql,true); fclose($tta);}}
					$SEEKMAPPINGS=false;
					$mappings = $this->getMappings($importcode);

				}
				break;
			}//e cho $file
		}
		$mappings2 = $this->getMappings($importcode,true);

		$restrictions= $this->getRestriction($importcode);
		$formulas = $this->getFormulas($importcode);
		$translations = $this->getTranslations($importcode, $mappings);
		$exceptions = $this->getExceptions($importcode);
		$field_records = $this->getTableFieldRecords($tablecode);
		$field_derived = $this->getDerivedFields($tablecode);
		$required_fields = $this->getTableRequiredFields($tablecode);
		//Search Indexes
		$DBTI = &getTool('DBTI');
		$commit_count = CLX_INIT_ZERO;
		$imported_records = CLX_INIT_ZERO;
		$updated_records = CLX_INIT_ZERO;

		$created_records = CLX_INIT_ZERO;
		$count_fields=CLX_INIT_ZERO;
		$rline=CLX_INIT_ZERO;

		$ignored_records = CLX_INIT_ZERO;
		$ignored_records2 = CLX_INIT_ZERO;
		$cdatecomunerror	= xFormat::getNow('Y-m-d H:i:s');

		if (!empty($idrecordexecutions)) {
			$sql='UPDATE CLX_DB_IMPORT_EXECUTIONS SET  LOG_ID='.singlequote($code_lot).' WHERE ID = ' . $idrecordexecutions;
			ClxCommon::$db->executequery($sql);
			if ($this->debug==true) {echo $b='update executions in 3012';pre($sql);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).$sql,true); fclose($tta);}}
			ClxCommon::$db->executequery('commit');

		}
		$recordsall=array();
		if (!$this->validar_tabla($mappings2, $field_records,$field_derived,$tablename,$importcode,$code_lot,$cdatecomunerror)) {
			$saved_errors=1;
			$line=1;
			$record = array();
			$record['IMPORTCODE'] = $importcode;
			if ($importrec['TYPE']!='XLS' && $importrec['TYPE']!='XLS2')
			$record['RECORD_QTY'] = $imported_records;
			$record['CDATE'] = xFormat::getNow('Y-m-d H:i:s');
			$record['OWNERCODE'] = $_SESSION['user_record']['username'];
			$record['DESCRIPTION'] = dict('CLX_USER_SIST_O').(stripos(' '.PHP_OS,'WIN')>0 ? '' : posix_getpwuid(posix_geteuid())['name']).'<br>'.chr(13).chr(10).$description;
			$record['FILENAME'] = $original_filename;
			$record['LOG_ID']=$code_lot;
			$record['FILENAME_INC_DATE']=(!empty($FILENAME_INC_DATE))? $FILENAME_INC_DATE:0;
			$record['CH_VALUE_DATE']=(!empty($CH_VALUE_DATE))?$CH_VALUE_DATE:"";
			$record['STATUS']='ACT';
			$record['BATCH_PID']= (!empty($this->batch_pid)?$this->batch_pid: $this->batch_pid=singleQuote(getPid()));

			//   - Caso 1002490 - CLX-Herr IMPORT Batch
			// Separates created record counter from record processed counter
			$result_msg0 = dict('TOOL_DBIM_IMPORT_COMPLETE', $saved_errors, 0, $ignored_records,$ignored_records2, $updated_records, $created_records);

			$this->saveErrors($importcode, $line, array('File'=>dict("GEN_LBL_NOT_TABLE_VALID")), $saved_errors,$code_lot,$cdatecomunerror,$test);
			$record['OBSERVATION'] = 'IP SERVER:'.(ISSET($_SERVER['SERVER_ADDR'])? $_SERVER['SERVER_ADDR'] : $_SERVER['LOCAL_ADDR']).' SERVER NAME:'.(EMPTY($_SERVER['SERVER_NAME'])? $_SERVER['COMPUTERNAME']:$_SERVER['SERVER_NAME'] );

			if (empty($idrecordexecutions)) {
				$record['DESCRIPTION'] = $result_msg0 . '<br>' . CLX_CHAR_NL . $record['DESCRIPTION'];
				$idrecordexecutions=ClxCommon::$db->createRecord('CLX_DB_IMPORT_EXECUTIONS', $record, false);
				if ($this->debug==true) {echo $b='createrecord executios))) in 3043';pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}

			} else {
				unset($record['CDATE'], $record['OWNERCODE']); //just keep from batch
				ClxCommon::$db->updateRecord('CLX_DB_IMPORT_EXECUTIONS', $record, 'ID = ' . $idrecordexecutions);
				if ($this->debug==true) {echo $b='update import_fields in 3048';pre($record);pre('ID = ' . $idrecordexecutions);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true).'ID = ' . $idrecordexecutions.chr(13).chr(10)); fclose($tta);}}
			}
			ClxCommon::$db->executequery('commit');
			$errors_link = '';
			if ($saved_errors > CLX_NUM_ZERO) {
				$errors_link = '<a href="tool.php?to=' . $this->code . '&ac=DISPLAY&idlist=' . $importid . '">' .
				dict('GEN_LBL_DISPLAY') . ' ' . dict('GEN_LBL_ERRORS') . '</a>';
			}

			$note = note($result_msg0 . '<br>' . $errors_link, dict('GEN_LBL_OK'));
			$table = new htmlTable(CLX_WIDTH_TWO);
			if (!empty($show_file)&& ! in_array($table_fieldname, $this->fieldnotignr)) {
				$c = new htmlButtonCancel(dict('GEN_LBL_RETURN'));
				$qty_fields=count($mappings);
				$table->addCell($c->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => $qty_fields));
				return $note . '<Br>' . $table->source();
			} else {
				//return note(dict('TOOL_DBIM_IMPORT_COMPLETE', $saved_errors, $fd->num_records), dict('GEN_LBL_OK'));
				return $note;
			}
		}
		if (!empty($show_file)) {
			$ignore = CLX_INIT_ZERO;
			$qty_fields=count($mappings);
			foreach ($mappings as $table_fieldname => $info) {
				if ($info['TYPE'] === 'IGNR' || in_array($table_fieldname, $this->fieldnotignr )) {
					$ignore++;
				}
			}
			$table = new htmlTable($qty_fields - $ignore);
			$table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
			$table->addCell(dict('GEN_LBL_FILE_CONTENTS'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => $qty_fields));
			foreach ($mappings as $table_fieldname => $info) {
				if ($info['TYPE'] !== 'IGNR') {
					$table->addCell($info['TABLE_FIELDNAME'], array(CLX_PROP_CLASS => CLX_CLASS_HEADERS));
				}
			}
		}
		$indx = $DBTI->getTableIndexes($tablecode, 'UNI');
		$indx2 = ClxCommon::$db->getTableByIndexes($tablecode, 'UNI');
		$indx_crit = array();
		foreach ($indx as $key => $val) {
			$fields = explode(',', $val['FIELDNAME']);
			foreach ($fields as $v) {
				$indx_crit[$key][] = $v . ' = ' . singleQuote('!' . $v);
			}
		}
		$crit_sql = '';
		$comma = '';
		foreach ($indx_crit as $key => $val) {
			$crit_sql .= $comma . ' (' . implode(' AND ', $val) . ') ';
			$comma = ' AND ';
		}
		$qty_fields = count($mappings);
		//$record_prop=(empty($importrec['RECORD_PROP']))? '' :json_decode($importrec['RECORD_PROP'],true);
		$from=$to=0;
		$recordlotcreate=0;
		$encodedetect="X";

		if ($importrec['TYPE'] === 'CSV' ||$importrec['TYPE'] === 'CSV2') {
			require_once'classes/clx_file_delimited.php';
			$record_delim = replace_ascii_chars($importrec['RECORD_DELIM']);
			$field_delim = $importrec['FIELD_DELIM'];
			$field_delim2 = json_decode($importrec['FIELD_DELIM'],true);
			$field_cdelim = $importrec['FIELD_CDELIM'];
			$field_cdelim2 = json_decode($importrec['FIELD_CDELIM'],true);
			if ($PRECHARGE==1) {
				$this->writeziptotext(kPathToWebSite."/import/",$original_filename,$newfilename);
				if (!empty($newfilename))
					$original_filename=$newfilename;
			}
			else {
				$this->writeziptotext();
			}
			$fileread2=$fileread=UserRequest::$files['DBIM_file']['tmp_name'];
			if (count($imft_record)>0 || $is_batch==true|| $PRECHARGE==1) {
				$fileread2=kPathToWebSite."/import/".$original_filename;
			}
			if (empty($FILENAME_INC_DATE)) {
				$importrec['FILEDATE_REQ']='';
				$importrec['CH_VALUE_DATE']='';


			}
			else{
				preg_match('/\.([0-9]{2,4}\-[0-9]{1,2}\-[0-9]{1,2})\./',$original_filename ,$matches);
				if (isset($matches[1])) {
					$importrec['FILEDATE_REQ']=$matches[1];
					if (!empty(!$CH_VALUE_DATE) && empty($importrec['CH_VALUE_DATE']))
						$importrec['CH_VALUE_DATE']=$CH_VALUE_DATE;
				}
				IF ($this->debug==true)
						ECHO "FILEDATEREQ";

			}


			$a=fopen($fileread2,"r");
			$encodedetect=mb_detect_encoding(fread($a,$archivotext=filesize($fileread2)), "auto");
			fclose($a);
			if (empty($encodedetect)) {
				$this->saveErrors($importcode, $rline, array('File'=>dict("GEN_LBL_NOTANSIORUTF8")), $saved_errors,$code_lot,$cdatecomunerror,$test);
			}
			if ($test) {
				$readall=$importrec['TYPE'] = 'CSV';
			}
			$this->string_parser=-1;
			if ($readall=$importrec['TYPE'] === 'CSV2') {
				if (empty($field_delim2[7])){
					$this->type_parser=1;
					$key=array_keys($field_delim2)[0];

					if ($key<4) {
						$this->string_parser=replace_ascii_chars($field_delim2[$key]);
					}
					//else if ($key==4)
					else	{
						$this->string_parser=$field_cdelim2[$key];
					}

				}
				else {
					$this->type_parser=2;
					$this->string_parser=$field_cdelim2[7];
				}
			}


			$fd = new clx_file_delimited($fileread2, $record_delim, $this->string_parser,false,$readall,$importrec['IF_UTF8']);
			$col=0;
			IF ($this->debug==true) {
							pre('import de entrada9');
				pre($fd);
				pre($fileread2);
				pre('--------xxx----------');
			}
			IF (!empty($importrec['RECORD_PROP'][$col])){
				$from=$to=$importrec['RECORD_CPROP'][$col];
			}
			IF (!empty($importrec['RECORD_PROP'][$col+1]) and	$importrec['RECORD_CPROP'][$col+1]>=$from) {
				$to=$importrec['RECORD_CPROP'][$col+1];
			}


		} elseif ($importrec['TYPE'] === 'FRL'  ||$importrec['TYPE'] === 'FRL2'||$importrec['TYPE'] === 'FRL3' ) {
			require_once'classes/clx_file_fixed_record_length.php';
			$fileread2=$fileread=UserRequest::$files['DBIM_file']['tmp_name'];
			if (count($imft_record)>0 || $PRECHARGE==1|| $is_batch==true ) {
				$fileread2=kPathToWebSite."/import/".$original_filename;
			}
			$a=fopen($fileread2,"r");
			if ($test) {
				$readall=$importrec['TYPE'] = 'FRL';
			}

			if (empty($FILENAME_INC_DATE)) {
				$importrec['FILEDATE_REQ']='';
				$importrec['CH_VALUE_DATE']='';

				IF ($this->debug==true)
					ECHO "NO FILEDATEREQ3";
			}
			else{
				preg_match('/\.([0-9]{2,4}\-[0-9]{1,2}\-[0-9]{1,2})\./',$original_filename ,$matches);
				if (isset($matches[1]))
					$importrec['FILEDATE_REQ']=$matches[1];
				IF ($this->debug==true)
						ECHO "FILEDATEREQ3";

			}

			$readall=$importrec['TYPE'] !== 'FRL';
			$encodedetect=mb_detect_encoding(fread($a,$archivotext=filesize($fileread2)), "auto");
			fclose($a);
			if ($PRECHARGE==1) {
				$this->writeziptotext(kPathToWebSite."/import/",$original_filename,$newfilename);
				if (!empty($newfilename))
					$original_filename=$newfilename;
			}
			else {
				$this->writeziptotext();
			}
			$fileread=UserRequest::$files['DBIM_file']['tmp_name'];
			if($PRECHARGE==1||$is_batch==true) {
				$fileread2=kPathToWebSite."/import/".$original_filename;
			}
			if (empty($encodedetect)) {
				$texto='';
				$this->saveErrors($importcode, $rline, array('File'=>dict("GEN_LBL_NOTANSIORUTF8")), $saved_errors,$code_lot,$cdatecomunerror,$test);
				$texto=array('File'=>dict("GEN_LBL_NOTANSIORUTF8"));
			}
		/// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - BEGIN
			$record_delim = replace_ascii_chars($importrec['RECORD_DELIM']);

			//$record_length = $importrec['RECORD_LENGTH'];
			$record_length = intval($importrec['RECORD_LENGTH']) + mb_strlen($record_delim, kDefaultEncoding);
// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - END


			$fd = new clx_file_fixed_record_length($fileread2, $record_length,$readall,$importrec['IF_UTF8'],($importrec['TYPE'] == 'FRL3')?true:false,$record_delim );
// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - BEGIN
			// It's fixed lenght, but reads only until EOL character, to avoid cases of not so fixed lenght files like IBS's




			if($record_delim != '') {
				$this->use_record_delimiter_reading_fixlen_files = true;
			}
			if ($this->use_record_delimiter_reading_fixlen_files === true) {
				$fd->line_delim = $record_delim;
			}
// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - END
		}
		elseif ($importrec['TYPE'] === 'XLS' ||$importrec['TYPE'] === 'XLS2') {
			IF ($test)
				$importrec['TYPE'] = 'XLS';
			if (!defined('READ_EXCEL_TOOL') or READ_EXCEL_TOOL==1) {
				require_once(kPathToSimpleExcel.'/php-excel-reader/excel_reader2.php');
				require_once(kPathToSimpleExcel.'/SpreadsheetReader.php');
			}
			else {
				require_once(kPathToSimpleExcel.'/Classes/PHPExcel.php');
			}
			require_once'classes/clx_file_array_data.php';
			if ($importrec['TYPE'] === 'XLS2') {
				$GLOBALS['PROCESS']='DBIM';
				$DBEX = &getTool('DBIX');


				if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1626;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");fwrite($tta,chr(13).chr(10)."db_import-hora inicio de funcion read excel ".date("h:i:s d/m/Y").chr(13).chr(10));fclose($tta);}
				$processfile=false;
				$timex=microtime(true);
				if (count($imft_record)>0 or $PRECHARGE==1) {
					$fileread2=kPathToWebSite."/import/".$original_filename;
					if (empty($FILENAME_INC_DATE)) {
						$importrec['FILEDATE_REQ']='';
						$importrec['CH_VALUE_DATE']='';

					}
					else{
						preg_match('/\.([0-9]{2,4}\-[0-9]{1,2}\-[0-9]{1,2})\./',$original_filename ,$matches);
						if (isset($matches[1]))
							$importrec['FILEDATE_REQ']=$matches[1];
						if (!empty(!$CH_VALUE_DATE) && empty($importrec['CH_VALUE_DATE']))
							$importrec['CH_VALUE_DATE']=$CH_VALUE_DATE;

					}
					$path_info = pathinfo($original_filename);
					$fileext= lowercase($path_info['extension']);
					$filename= $path_info['filename'];
					$fileext2='';
					$path_info2 = pathinfo($original_filename);
					if (isset($path_info2['extension']))
						$fileext2= lowercase($path_info2['extension']);

				}
				else {
					if (!empty(UserRequest::$files['DBIM_fileexcel'])){
						$filex=UserRequest::$files['DBIM_fileexcel'];
						$original_filename=$filex['name'];
					}
					else {
						$filex=UserRequest::$files['DBIM_file'];
						$original_filename=$filex['name'];
					}
					$fileread2=$fileread=UserRequest::$files['DBIM_file']['tmp_name'];
					if($PRECHARGE==1) {
						$fileread=$fileread2=kPathToWebSite."/import/".$original_filename;
					}

					$path_info = pathinfo($filex['name']);

					if (empty($FILENAME_INC_DATE)) {
						$importrec['FILEDATE_REQ']='';
						$importrec['CH_VALUE_DATE']='';

					}
					else{
						preg_match('/\.([0-9]{2,4}\-[0-9]{1,2}\-[0-9]{1,2})\./',$filex['name'] ,$matches);
						if (isset($matches[1]))
							$importrec['FILEDATE_REQ']=$matches[1];
						if (!empty(!$CH_VALUE_DATE) && empty($importrec['CH_VALUE_DATE']))
							$importrec['CH_VALUE_DATE']=$CH_VALUE_DATE;

					}

					if ($this->debug==true) {
						PRE ($importrec);
					}
					$fileext= lowercase($path_info['extension']);
					$filename= $path_info['filename'];
					$fileext2='';
					$path_info2 = pathinfo($filex['tmp_name']);
					if($PRECHARGE==1) {
						$path_info2 = pathinfo($original_filename);
					}

					if (isset($path_info2['extension']))
						$fileext2= lowercase($path_info2['extension']);

				}
				$savepost = UserRequest::$post;
				$saverequest = UserRequest::$request;
				$saveget = UserRequest::$get;
				$description = UserRequest::$post['DBIM_description'];

				$Rowrest=0;
				$imported_records=CLX_NUM_ZERO;
				$commit_count = CLX_INIT_ZERO;

				if (lowercase($fileext)!="xls")
					$Rowrest=-1;
				if (!($fileext2=='tmp' || $fileext2=='')) {
					$Filepath=$filex['name']=$filex['tmp_name'];
				}
				else {
					if($PRECHARGE==1) {
					}
					else {
						if (empty($filex['name'])&& $is_batch==true) {
							$filex['name']= $savepost['DBIM_file'];
						}

						$Filepath=kPathToWebSite . 'import/'.$filex['name'];
						if(empty($idrecordexecutions)){
							$a=fopen($filex['tmp_name'],"r");
							$x=fread($a,filesize($filex['tmp_name']));
							fclose($a);
							$a=fopen($Filepath,"w+");
							fwrite($a,$x);
							fclose($a);
						}
					}
				}
				//$fileread2= str_ireplace('xls','csv',str_ireplace('xlsx','csv', $file));
				if (count($imft_record)==0 && $PRECHARGE!=1) {
					$fileread3= str_ireplace('.xls','.txt',str_ireplace('.xlsx','.txt', $Filepath));
				}
				else {

					$fileread3= str_ireplace('.xls','.txt',str_ireplace('.xlsx','.txt', $fileread2));
					$Filepath=$fileread2;
				}



				if (file_exists($fileread3))
					unlink($fileread3);//restore_error_handler();

				foreach($mappings as $tkey=>$tvalue) {
					$hoja=$tvalue['IMPORTSHEETS'];
					break;
				}
				//todo hojas'
				//exec('ssconvert  -S '.quote($Filepath).' '. (quote($fileread2)));
				//exec('ssconvert  -S '.quote($Filepath).' '. (quote($fileread2)));
				//hoja particular
				//echo "exec('ssconvert -O '".singlequote( 'sheet='.quote($hoja).' separator={|} eol=windowsW').' '.quote($Filepath).' '. (quote($fileread3)).")";
		//		exec(DBIM_SCONVERT_GEN_WINDOWS_FILE.'ssconvert -O '.singlequote( 'sheet='.quote($hoja).' separator={|} eol=windows').' '.quote($Filepath).' '. (quote($fileread3)));
				
				////////////////////////////////
						
				IF (stripos(' '.PHP_OS,'WIN')>0){//DBIM_SCONVERT_GEN_WINDOWS_FILE
					if (!defined('DBIM_SCONVERT_GEN_WINDOWS_FILE'))
						PRE(NOTE('Not exists constants: '.DBIM_SCONVERT_GEN_WINDOWS_FILE));

					$filegentoimp=$fileread3;
					$fileread3=basename($fileread3);
					
					$fileimptogen=basename($Filepath);
				
				}
				if (file_exists($fileread3))
					unlink($fileread3);

				for ($k=0;$k<10;$k++) {
					if (file_exists($fileread3.'.'.$k)) {
						unlink($fileread3.'.'.$k);
					}
				}
				$hoja='';
				foreach($mappings as $tkey=>$tvalue) {

					$hoja=$tvalue['IMPORTSHEETS'];
					break;
				}
				if (file_exists(str_ireplace('.xls','.txt',str_ireplace('.xlsx','.txt', $file))))
					unlink(str_ireplace('.xls','.txt',str_ireplace('.xlsx','.txt', $file)));
				IF (stripos(' '.PHP_OS,'WIN')>0){//DBIM_SCONVERT_GEN_WINDOWS_FILE
					if (!defined('DBIM_SCONVERT_GEN_WINDOWS_FILE'))
						PRE(NOTE('Not exists constants: '.DBIM_SCONVERT_GEN_WINDOWS_FILE));

					//pre($file);		
					//copy($file, $fileimptogen);
					//echo " copy($file, $fileimptogen);";
					$CM= 	QUOTE(DBIM_SCONVERT_GEN_WINDOWS_FILE.
							'ssconvert.EXE').
							' -O '.
							quote( 'sheet='.
							singlequote($hoja).
							' separator={|} eol=windows ').
							' '. 
							quote(kPathToWebSite.
							'import/'.
							$fileimptogen).
							' '. 
							(quote(kPathToWebSite.
							'import/'.
							$fileread3));
					$CM=str_replace('/','\\',$CM);
					if ($this->debug==true) {PRE('SSCONVERT '.__LINE__);PRE($CM);}

					IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1){ echo "<br> cm",   __METHOD__.' '.__FILE__.':',__LINE__,"<pre>",$CM;}

					exec($CM);
					copy($fileread3,$filegentoimp);
					unlink($fileread3);
					unlink($fileimptogen);
					$fileread3=$filegentoimp;
				}	
				else {
					$CM= 	('ssconvert  -O '.singlequote( 'sheet='.quote($hoja).' separator={|} eol=windows ').' '.quote($Filepath).' '. (quote($fileread3)));
								IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1){ echo "<br> cm",   __METHOD__.' '.__FILE__.':',__LINE__,"<pre>",$CM;}

					exec($CM);
					if ($this->debug==true) {PRE('SSCONVERT '.__LINE__);PRE($CM);}

				}
				$a1=fopen(kPathToWebSite.'temp/ssconvert.txt','a+');
				fwrite($a1, __LINE__ .' '. __METHOD__ .' '.getcwd().CHR(13).CHR(10));
				fwrite($a1, $CM.CHR(13).CHR(10));
				fclose($a1);
				require_once'classes/clx_file_delimited.php';

				$readall=true;
				$this->type_parser=1;
				$field_cdelim='{|}';
				$importrec['TYPE']='CSV2';
				$record_delim=CHR(13).CHR(10);
				$importrec['IF_UTF8']=false;
				$replace_monto=true;
				$col=8;

				IF (!empty($importrec['RECORD_PROP'][$col])){
					$from=$to=$importrec['RECORD_CPROP'][$col]+1;
				}
				IF (!empty($importrec['RECORD_PROP'][$col+1]) and	$importrec['RECORD_CPROP'][$col+1]>=$from) {
					$to=$importrec['RECORD_CPROP'][$col+1]+1;
				}

				$fd = new clx_file_delimited($fileread3, $record_delim, $field_cdelim,false,$readall,$importrec['IF_UTF8'],$replace_monto);
				IF ($this->debug==true) {
					pre('import de entrada2');
					pre($fd);
							pre($fileread3);
					pre('--------xxx----------');
				}

		/*
			IF (!empty($importrec['RECORD_PROP'][$col])){
				$from=$to=$importrec['RECORD_CPROP'][$col];
			}
			IF (!empty($importrec['RECORD_PROP'][$col+1]) and	$importrec['RECORD_CPROP'][$col+1]>=$from) {
				$to=$importrec['RECORD_CPROP'][$col+1];
			}
		*/




				//e cho memory_get_usage(),"<br>";
			/*	if (!defined('READ_EXCEL_TOOL') or READ_EXCEL_TOOL==1) {
					$Spreadsheet = new SpreadsheetReader($Filepath,false, false,$xsheetnames,500);
				}
				else {
					$excelReader = PHPExcel_IOFactory::createReaderForFile($Filepath);
					$Spreadsheet = $excelReader->load($Filepath,false,false,$xsheetnames,500);
				}

				$columns=&$Spreadsheet->columns();

				$from=$to=-2;
				IF (!empty($importrec['RECORD_PROP'][8])){
					$from=$to=$importrec['RECORD_CPROP'][8];
				}
				IF (!empty($importrec['RECORD_PROP'][9]) and	$importrec['RECORD_CPROP'][9]>=$from) {
					$to=$importrec['RECORD_CPROP'][9];
				}*/
			}
			else {
			//	RESTORE_ERROR_HANDLER();
				if (empty($FILENAME_INC_DATE)) {
					$importrec['FILEDATE_REQ']='';
					$importrec['CH_VALUE_DATE']='';

				}
				else{
					preg_match('/\.([0-9]{2,4}\-[0-9]{1,2}\-[0-9]{1,2})\./',$original_filename ,$matches);
					if (isset($matches[1]))
						$importrec['FILEDATE_REQ']=$matches[1];
					if (!empty(!$CH_VALUE_DATE) && empty($importrec['CH_VALUE_DATE']))
						$importrec['CH_VALUE_DATE']=$CH_VALUE_DATE;

				}
				if ($this->debug==true) {
					pre($importrec);
				}
				$retorno=$this->readExcel($test,$importcode,$tablecode,$importid,$show_file, $mappings,$restrictions,$exceptions,$translations,$formulas,$tablerec,$tablename,$field_records,$importrec,$code_lot,$idrecordexecutions,$cdatecomunerror,$error_limit,$crit_sql,$importrec['FILEDATE_REQ']);
				apc_clear_xppaging_count_all_user($tablecode);
				return $retorno;
			}

		} else {
			return note(dict('TOOL_DBIM_INVALID_FILE_TYPE') . ' ' . $importrec['TYPE'], dict('GEN_LBL_OK'));
		}

		if (empty($test)) {
			//Running Events
			$evnt_msg = array();
			$EVNT = &getTool('EVNT');
			$EVNT->execute5('DBIM', $importrec['ID'], 'INPR', $savepost, $evnt_msg); //  Events Pre Import
		}
		$locals_var=get_defined_vars();
		$describe=ClxCommon::$db->describe_table($tablename);
		if ($importrec['TYPE'] === 'FRL' || $importrec['TYPE'] === 'CSV' ) {
			return $this->importnormal($fd,$locals_var);
		}
		else {

			$ignored_records2=0;
			$this->options_import=array();
			$this->options_import['ignored_records2']=&$ignored_records2;
			$this->options_import['insertfields']=&$insertfields;
			$this->options_import['mappings']=&$mappings;
			$this->options_import['from']=$from;
			$this->options_import['to']=$to;
			$this->options_import['log_id']=$code_lot;
			$this->options_import['batch_log_id']=$batch_log_id;
			$this->options_import['code_lot']=$code_lot;
			$this->options_import['type']=$importrec['TYPE'];
			$this->options_import['typeoriginal']=$typeoriginal;
			$this->options_import['restrictions']=$restrictions;
			$this->options_import['IMPORTCODE']=&$importcode;
			$this->options_import['CREATEDBY'] 	= $_SESSION['user_record']['username'];
			$this->options_import['MODIFIEDBY'] = $_SESSION['user_record']['username'];
			$this->options_import['CDATE'] 	= xFormat::getNow('Y-m-d H:i:s');
			$this->options_import['MDATE'] 	= xFormat::getNow('Y-m-d H:i:s');
			$this->options_import['FILEDATE_REQ']=$importrec['FILEDATE_REQ'];
			$this->options_import['CH_VALUE_DATE']=$importrec['CH_VALUE_DATE'];

			$this->options_import['translations'] 	=$translations;
			$this->options_import['importrec'] 	=$importrec;
			$this->options_import['IF_DUPLICATES']=$importrec['IF_DUPLICATES'];
			$this->options_import['superlotnum']=0;
			$this->options_import['original_filename']=$original_filename;
			if (isset($describe ['key_fisic_fields']['LOG_ID']) && ISSET($describe ['key_fisic_fields']['IMPORTCODE']))  {
				if ($this->debug==true) {
					echo "contador sin count";
				}
			}
			else {

				$previo_count_records=ClxCommon::$db->getOne($sql='SELECT COUNT(1) FROM '. $tablename);
				$previo_errors=ClxCommon::$db->getOne($sql='SELECT COUNT(1) FROM CLX_DB_IMPORT_ERRORS WHERE IMPORTCODE='.singlequote($importcode));
				if ($this->debug==true) {
					echo "contador count previo ";
					pre($sql);
					pre($previo_count_records);
				}
			}

			$keys=array_keys($mappings);
			////////////////////////////////////////////
			$retorno= $this->importbulk($fd,$locals_var);
			/////////////////////////////////////////
			$ignored_records2=empty($this->options_import['ignored_records2'])? 0 : $this->options_import['ignored_records2'];

			$ignored_records=0;
			$update_records=0;
			if($importrec['IF_DUPLICATES'])
				$update_records=$this->options_import['superlotnum'];
			ClxCommon::$db->executequery('commit');
			if (isset($describe ['key_fisic_fields']['LOG_ID']) && ISSET($describe ['key_fisic_fields']['IMPORTCODE']))  {
				$created_records=ClxCommon::$db->getOne($sql='SELECT COUNT(1) FROM '. $tablename . ' where LOG_ID='.$code_lot. ' AND IMPORTCODE='.singlequote($importcode) );
				$saved_errors=ClxCommon::$db->getOne($sql='SELECT COUNT(1) FROM CLX_DB_IMPORT_ERRORS where LOG_ID='.$code_lot. ' AND IMPORTCODE='.singlequote($importcode));
			}
			else {
				$created_records=ClxCommon::$db->getOne($sql='SELECT COUNT(1) FROM '. $tablename)-$previo_count_records;
				if ($this->debug==true) {
					echo "contador count posterior ";
					pre($sql);
					pre($created_records);
				}
				$saved_errors=ClxCommon::$db->getOne($sql='SELECT COUNT(1) FROM CLX_DB_IMPORT_ERRORS WHERE IMPORTCODE='.singlequote($importcode))-$previo_errors;
			}
			if($importrec['IF_DUPLICATES']) {
				$update_records=$this->options_import['superlotnum']-(	$ignored_records+	$created_records+$saved_errors+$ignored_records2);
			}
			$total_records=	$ignored_records+	$created_records+$update_records+$saved_errors+$ignored_records2;

			IF ($this->debug==true) {
				echo "ignored_records:".$ignored_records."<br>";
				echo "created_records:".$created_records."<br>";
				echo "update_records:".$update_records."<br>";
				echo "saved_errors:".$saved_errors."<br>";
				echo "ignored_records2:".$ignored_records2."<br>";

			}

			$result_msg0 = dict('TOOL_DBIM_IMPORT_COMPLETE', $saved_errors,$total_records, $ignored_records,$ignored_records2, $update_records, $created_records);
			if ($saved_errors > CLX_NUM_ZERO) {
				$errors_link = '<a href="tool.php?to=' . $this->code . '&ac=DISPLAY&idlist=' . $importid . '">' .
				dict('GEN_LBL_DISPLAY') . ' ' . dict('GEN_LBL_ERRORS') . '</a>';
			} else {
				$errors_link = '';
			}
			$msgextra='<br>Time:'.(round (microtime(true)-$timex,1)."").' seconds<br> ';

			$note = note($result_msg0 .$msgextra.  $errors_link, dict('GEN_LBL_OK'));
			UserResponse::setRunTimeLimit($init_time_out);
			if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1626;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");fwrite($tta,chr(13).chr(10)."db_import-hora fin de funcion import ".date("h:i:s d/m/Y").chr(13).chr(10));fclose($tta);}

			//$record['DESCRIPTION'] = $result_msg0 . '<br>' . CLX_CHAR_NL . $record['DESCRIPTION'];
			$record = array();
			$record['IMPORTCODE'] = $importcode;
			$record['RECORD_QTY'] = $ignored_records2+$ignored_records+$created_records+$update_records+$saved_errors;
			$record['CDATE'] = xFormat::getNow('Y-m-d H:i:s');
			$record['OWNERCODE'] = $_SESSION['user_record']['username'];
			$record['DESCRIPTION'] =  dict('CLX_USER_SIST_O').(stripos(' '.PHP_OS,'WIN')>0 ? '' : posix_getpwuid(posix_geteuid())['name']).'<br>'.chr(13).chr(10).$result_msg0.$description;
			$record['FILENAME'] = $original_filename;
			$record['LOG_ID']=$code_lot;
			$record['STATUS']='ACT';
			$record['OBSERVATION'] = 'IP SERVER:'.(ISSET($_SERVER['SERVER_ADDR'])? $_SERVER['SERVER_ADDR'] : $_SERVER['LOCAL_ADDR']).' SERVER NAME:'.(EMPTY($_SERVER['SERVER_NAME'])? $_SERVER['COMPUTERNAME']:$_SERVER['SERVER_NAME'] );
			$record['BATCH_PID']='-1';
			//$DBIU->changefiledatereq($importrec);

			$record['FILEDATE_REQ']=$importrec['FILEDATE_REQ'];
			$record['CH_VALUE_DATE']=$importrec['CH_VALUE_DATE'];



			if ($is_batch) {
				$record['BATCH_PID']=$batch_log_id;
			}

			$record['FILEDATE_REQ']=$importrec['FILEDATE_REQ'];
			$record['CH_VALUE_DATE']=$importrec['CH_VALUE_DATE'];
			$record['OBSERVATION'] = 'IP SERVER:'.(ISSET($_SERVER['SERVER_ADDR'])? $_SERVER['SERVER_ADDR'] : $_SERVER['LOCAL_ADDR']).' SERVER NAME:'.(EMPTY($_SERVER['SERVER_NAME'])? $_SERVER['COMPUTERNAME']:$_SERVER['SERVER_NAME'] );

			if (empty($idrecordexecutions)) {
				$record['DESCRIPTION'] =  $record['DESCRIPTION'];
				ClxCommon::$db->createRecord('CLX_DB_IMPORT_EXECUTIONS', $record, false);
				//pr e($record);
				if ($this->debug==true) {echo $b='create executios in 3602';pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}

			} else {
				unset($record['CDATE'], $record['OWNERCODE']); //just keep from batch
				ClxCommon::$db->updateRecord('CLX_DB_IMPORT_EXECUTIONS', $record, 'ID = ' .$idrecordexecutions);
				if ($this->debug==true) {echo $b='update executios in ',__LINE__;pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}
			}
			ClxCommon::$db->executequery('commit');
			apc_clear_xppaging_count_all_user($tablecode);
			$fd->close();
			if (empty($test)) {
			//  Events Post Import
				$EVNT->execute5('DBIM', $importrec['ID'], 'INPO', $savepost, $evnt_msg);
			}
			apc_clear_xppaging_count_all_user($tablecode);
			return $note;
		}
	}
	function import_ihcafe_ret($is_batch=true) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1608;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		$GLOBALS['PROCESS']='DBIM';
		$DBEX = &getTool('DBIX');
		$timex=microtime(true);
		//cargar transacciones
		$trans_prest = ClxCommon::$db->getField('BASE_PARAMETERS', "PVALUE" ,"IDNAME='FIAT_PRESTAMO_COSECHA'");
		$trans_ret = ClxCommon::$db->getField('BASE_PARAMETERS', "PVALUE" ,"IDNAME='FIAT_RETENCION_COSECHA'");
		$trans_dev = ClxCommon::$db->getField('BASE_PARAMETERS', "PVALUE" ,"IDNAME='FIAT_DEVOLUCION_COSECHA'");
		##$tta=fopen(kPathToWebSite."/".kPathToTemp."archivoX2.txt","a+");fwrite($tta,"SIIIIIIIIIII".CHR(13).CHR(10));fclose($tta);

		$init_time_out = ini_get('max_execution_time'); ini_set('display_errors', '1');
		ini_set('memory_limit',$this->memorylimit);
		UserResponse::setRunTimeLimit(CLX_NUM_24 * CLX_NUM_60 * CLX_NUM_60);
		$this->s_input_line_encoding_detect = null;
		$this->s_input_line_encoding_detect2= null;
		$EVNT = &getTool('EVNT');
		//Stored for returning later
		$savepost = UserRequest::$post;
		$saverequest = UserRequest::$request;
		$saveget = UserRequest::$get;
		if (empty(UserRequest::$post['DBIM_id'])) {
			 return note('Not set option');

		}
		$importid = UserRequest::$post['DBIM_id'];
		$test = UserRequest::$post['DBIM_test'];
		$show_file = UserRequest::$post['DBIM_show_file'];
		$error_limit = UserRequest::$post['DBIM_error_limit'];
		$description = UserRequest::$post['DBIM_description'];
		$original_filename = UserRequest::$files['DBIM_file']['name'];
		$saved_errors = CLX_INIT_ZERO;
		//May come from batch then no extra log is required since was set on schedule batch
		$batch_log_id = (!empty(UserRequest::$post['RINNING_BATCH'])) ? UserRequest::$post['RINNING_BATCH'] : CLX_NUM_ZERO;
		$importrec = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $importid);
		$code_lot=++$importrec['LOG_ID'];
		$importrec2=$importrec;
		unset($importrec2['ID']);
		unset($importrec2['FILE_C']);
		unset($importrec2['FILE_CEXCEL']);
		unset($importrec2['FILE_CDELIM']);
		unset($importrec2['CDATE']);
		unset($importrec2['MDATE']);
		unset($importrec2['USERNAME']);
		unset($importrec2['TYPE']);
		unset($importrec2['IF_DUPLICATE']);
		unset($importrec2['IF_UTF8']);
		unset($importrec2['FIELD_DELIM']);
		unset($importrec2['NEWTABLECODE']);
		unset($importrec2['FILE_CDELIM']);
		unset($importrec2['VERSION']);
		unset($importrec2['DESCRIPTION']);
		unset($importrec2['FIELD_DELIM']);
		unset($importrec2['FIELD_CDELIM']);
		unset($importrec2['RECORD_PROP']);
		unset($importrec2['RECORD_CPROP']);
		unset($importrec2['FILE']);
		unset($importrec2['FILE_EXCEL']);
		unset($importrec2['FILE_DELIM']);
		unset($importrec2['NEWTABLECODE']);
		unset($importrec2['EXCEL_TYPE']);
		ClxCommon::$db->updateRecord($this->tablename, $importrec2, 'ID=' . $importid);


		$importrec["RECORD_PROP"]=json_decode($importrec["RECORD_PROP"],true);
		$importrec["RECORD_CPROP"]=json_decode($importrec["RECORD_CPROP"],true);
//$importrec["FIELD_DELIM"]=json_decode($importrec["FIELD_DELIM"],true);
//$importrec["FIELD_CDELIM"]=json_decode($importrec["FIELD_CDELIM"],true);

		$importcode = $importrec['IDCODE'];
		$tablecode = $importrec['TABLECODE'];
		$DBIU=new db_import_run();
		$DBIU->basicFields($record['TABLECODE']);
		$this->import_extra_fields_required=$DBIU->import_extra_fields_required;
		$insertfields=explode(",",$this->import_extra_fields_required);

		$insertfields2=explode(",",$this->import_extra_fields_required);
		$mappings = $this->getMappings($importcode);
		$mappings2 = $this->getMappings($importcode,true);
		foreach ($mappings as $key=>$value) {
			$insertfields2[]=$key;
		}

		$this->compileCodeFormulas($importcode);
		$tablerec = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE=' . singleQuote($tablecode));
		$tablename = $tablerec['MODULECODE'] . '_' . $tablerec['IDNAME'];
		//ClxCommon::$db->deleteRecords('CLX_DB_IMPORT_ERRORS', 'IMPORTCODE=' . singleQuote($importcode));

		$restrictions= $this->getRestriction($importcode);
		$formulas = $this->getFormulas($importcode);
		$translations = $this->getTranslations($importcode, $mappings);
		$exceptions = $this->getExceptions($importcode);
		$field_records = $this->getTableFieldRecords($tablecode);
		$field_derived = $this->getDerivedFields($tablecode);
		$required_fields = $this->getTableRequiredFields($tablecode);
		//Search Indexes
		$DBTI = &getTool('DBTI');
		$commit_count = CLX_INIT_ZERO;
		$imported_records = CLX_INIT_ZERO;
		$updated_records = CLX_INIT_ZERO;

		$created_records = CLX_INIT_ZERO;
		$count_fields=CLX_INIT_ZERO;
		$rline=CLX_INIT_ZERO;

		$ignored_records = CLX_INIT_ZERO;
		$ignored_records2 = CLX_INIT_ZERO;
		$cdatecomunerror	= xFormat::getNow('Y-m-d H:i:s');
		ClxCommon::$db->executequery('UPDATE CLX_DB_IMPORT_EXECUTIONS SET LOG_ID='.singlequote($code_lot).' WHERE ID = ' . $batch_log_id);
		ClxCommon::$db->executequery('commit');
		if ($this->debug==true) {echo $b='update import in 3728';pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}
		if (!$this->validar_tabla($mappings2, $field_records,$field_derived,$tablename,$importcode,$code_lot,$cdatecomunerror)) {
			$saved_errors=1;
			$line=1;
			$record = array();
			$record['IMPORTCODE'] = $importcode;
			$record['RECORD_QTY'] = $imported_records;
			$record['CDATE'] = xFormat::getNow('Y-m-d H:i:s');
			$record['OWNERCODE'] = $_SESSION['user_record']['username'];
			$record['DESCRIPTION'] = dict('CLX_USER_SIST_O').(stripos(' '.PHP_OS,'WIN')>0 ? '' : posix_getpwuid(posix_geteuid())['name']).'<br>'.chr(13).chr(10).$description;
			$record['FILENAME'] = $original_filename;
			$record['LOG_ID']=$code_lot;
			$record['OBSERVATION'] = 'IP SERVER:'.(ISSET($_SERVER['SERVER_ADDR'])? $_SERVER['SERVER_ADDR'] : $_SERVER['LOCAL_ADDR']).' SERVER NAME:'.(EMPTY($_SERVER['SERVER_NAME'])? $_SERVER['COMPUTERNAME']:$_SERVER['SERVER_NAME'] );
			$record['STATUS']='ACT';
			//   - Caso 1002490 - CLX-Herr IMPORT Batch
			// Separates created record counter from record processed counter
			$result_msg0 = dict('TOOL_DBIM_IMPORT_COMPLETE', $saved_errors, 0, $ignored_records,$ignored_records2, $updated_records, $created_records);

			$this->saveErrors($importcode, $line, array('File'=>dict("GEN_LBL_NOT_TABLE_VALID")), $saved_errors,$code_lot,$cdatecomunerror,$test);

			if ($batch_log_id == CLX_NUM_ZERO) {
				$record['DESCRIPTION'] = $result_msg0 . '<br>' . CLX_CHAR_NL . $record['DESCRIPTION'];
				ClxCommon::$db->createRecord('CLX_DB_IMPORT_EXECUTIONS', $record, false);
				if ($this->debug==true) {echo $b='createrecord executions in 3750';pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}

			} else {
				unset($record['CDATE'], $record['OWNERCODE']); //just keep from batch
				ClxCommon::$db->updateRecord('CLX_DB_IMPORT_EXECUTIONS', $record, 'ID = ' . $batch_log_id);
				if ($this->debug==true) {echo $b='update executions in 3755';pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}
			}
			ClxCommon::$db->executequery('commit');
			$errors_link = '';
			if ($saved_errors > CLX_NUM_ZERO) {
				$errors_link = '<a href="tool.php?to=' . $this->code . '&ac=DISPLAY&idlist=' . $importid . '">' .
				dict('GEN_LBL_DISPLAY') . ' ' . dict('GEN_LBL_ERRORS') . '</a>';
			}

			$note = note($result_msg0 . '<br>' . $errors_link, dict('GEN_LBL_OK'));
			$table = new htmlTable(CLX_WIDTH_TWO);
			if (!empty($show_file)) {
				$c = new htmlButtonCancel(dict('GEN_LBL_RETURN'));
				$qty_fields=count($mappings);
				$table->addCell($c->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => $qty_fields));
				return $note . '<Br>' . $table->source();
			} else {
				//return note(dict('TOOL_DBIM_IMPORT_COMPLETE', $saved_errors, $fd->num_records), dict('GEN_LBL_OK'));
				return $note;
			}
		}
		if (!empty($show_file)) {
			$ignore = CLX_INIT_ZERO;
			$qty_fields=count($mappings);
			foreach ($mappings as $table_fieldname => $info) {
				if ($info['TYPE'] === 'IGNR') {
					$ignore++;
				}
			}
			$table = new htmlTable($qty_fields - $ignore);
			$table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
			$table->addCell(dict('GEN_LBL_FILE_CONTENTS'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => $qty_fields));
			foreach ($mappings as $table_fieldname => $info) {
				if ($info['TYPE'] !== 'IGNR') {
					$table->addCell($info['TABLE_FIELDNAME'], array(CLX_PROP_CLASS => CLX_CLASS_HEADERS));
				}
			}
		}

		$indx = $DBTI->getTableIndexes($tablecode, 'UNI');
		$indx2 = ClxCommon::$db->getTableByIndexes($tablecode, 'UNI');
		//pre($indx);
		//pre($indx2);
		//die;
		$indx_crit = array();
		foreach ($indx as $key => $val) {
			$fields = explode(',', $val['FIELDNAME']);
			foreach ($fields as $v) {
				$indx_crit[$key][] = $v . ' = ' . singleQuote('!' . $v);
			}
		}
		$crit_sql = '';
		$comma = '';
		foreach ($indx_crit as $key => $val) {
			$crit_sql .= $comma . ' (' . implode(' AND ', $val) . ') ';
			$comma = ' AND ';
		}
		$qty_fields = count($mappings);
		//$record_prop=(empty($importrec['RECORD_PROP']))? '' :json_decode($importrec['RECORD_PROP'],true);
		$from=$to=0;
		$recordlotcreate=0;
		$encodedetect="X";
		if ($importrec['TYPE'] === 'CSV') {
			require_once'classes/clx_file_delimited.php';
			$record_delim = replace_ascii_chars($importrec['RECORD_DELIM']);
			$field_delim = $importrec['FIELD_DELIM'];
			$field_cdelim = $importrec['FIELD_CDELIM'];
			$fileread=UserRequest::$files['DBIM_file']['tmp_name'];
			if($PRECHARGE==1) {
				$fileread=kPathToWebSite."/import/".$original_filename;
			}
			$this->writeziptotext();
			$a=fopen($fileread,"r");
			$encodedetect=mb_detect_encoding(fread($a,$archivotext=filesize($fileread)), "auto");
			fclose($a);
			if (empty($encodedetect)) {
				$this->saveErrors($importcode, $rline, array('File'=>dict("GEN_LBL_NOTANSIORUTF8")), $saved_errors,$code_lot,$cdatecomunerror,$test);
			}


			$fd = new clx_file_delimited($fileread, $record_delim, $field_delim);
			IF ($this->debug==true) {
				pre('import de entrada3');
				pre($fd);
				pre($fileread);
				pre('--------xxx----------');
			}
			$col=0;

			IF (!empty($importrec['RECORD_PROP'][$col])){
				$from=$to=$importrec['RECORD_CPROP'][$col];
			}
			IF (!empty($importrec['RECORD_PROP'][$col+1]) and	$importrec['RECORD_CPROP'][$col+1]>=$from) {
				$to=$importrec['RECORD_CPROP'][$col+1];
			}

		} elseif ($importrec['TYPE'] === 'FRL') {
			require_once'classes/clx_file_fixed_record_length.php';
			$fileread=UserRequest::$files['DBIM_file']['tmp_name'];
			if($PRECHARGE==1) {
				$fileread=kPathToWebSite."/import/".$original_filename;
			}

			$a=fopen($fileread,"r");
			$encodedetect=mb_detect_encoding(fread($a,$archivotext=filesize($fileread)), "auto");
			fclose($a);
			$this->writeziptotext($archivo_text);

			if (empty($encodedetect)) {
				$texto='';
				$this->saveErrors($importcode, $rline, array('File'=>dict("GEN_LBL_NOTANSIORUTF8")), $saved_errors,$code_lot,$cdatecomunerror,$test);
				$texto=array('File'=>dict("GEN_LBL_NOTANSIORUTF8"));
			}
		/// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - BEGIN
			$record_delim = replace_ascii_chars($importrec['RECORD_DELIM']);
			//$record_length = $importrec['RECORD_LENGTH'];
			$record_length = intval($importrec['RECORD_LENGTH']) + mb_strlen($record_delim, kDefaultEncoding);
// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - END
			$fd = new clx_file_fixed_record_length($fileread, $record_length);
// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - BEGIN
			// It's fixed lenght, but reads only until EOL character, to avoid cases of not so fixed lenght files like IBS's




			if($record_delim != '') {
				$this->use_record_delimiter_reading_fixlen_files = true;
			}
			if ($this->use_record_delimiter_reading_fixlen_files === true) {
				$fd->line_delim = $record_delim;
			}
// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - END
		} elseif ($importrec['TYPE'] === 'XLS') {

			require_once(kPathToSimpleExcel.'/php-excel-reader/excel_reader2.php');
			require_once(kPathToSimpleExcel.'/SpreadsheetReader.php');

			return $this->readExcel($test,$importcode,$tablecode,$importid,$show_file, $mappings,$restrictions,$exceptions,$translations,$formulas,$tablerec,$tablename,$field_records,$importrec,$code_lot,$batch_log_id,$cdatecomunerror,$error_limit);


		} else {
			return note(dict('TOOL_DBIM_INVALID_FILE_TYPE') . ' ' . $importrec['TYPE'], dict('GEN_LBL_OK'));
		}
		if (empty($test)) {
			//Running Events
			$evnt_msg = array();
			$EVNT = &getTool('EVNT');
			$EVNT->execute5('DBIM', $importrec['ID'], 'INPR', $savepost, $evnt_msg); //  Events Pre Import
		}
		//convertToString($field_text,$Rule,$capturehtml=false)
		$read_fields=array();
		$detect=true;
		$file_fieldnames=array();
		if (!empty($encodedetect)) {
			$RARD = getToolObject('ACTN', 'RARD');
			while (!$fd->EOF) {
				$rline++;
				$buffer = $this->input_line_encoding_detect($fd->getNextRecord2($importrec['IF_UTF8']));
				if (empty($this->s_input_line_encoding_detect2)) {
					$this->saveErrors($importcode, $rline, array('File'=>dict("GEN_LBL_NOTANSIORUTF8")), $saved_errors,$code_lot,$cdatecomunerror,$test);
					break;
				}

				if (count($restrictions)>0) {
					$restrict=$this->apply_Restriction($restrictions,$buffer,$rline);
					if ($restrict) {
						$ignored_records2++;
						continue;
					}
				}

				if ($importrec['TYPE'] === 'CSV') {
					if ($detect) {
						$this->parsertextdetect($buffer, $field_delim, $field_cdelim );
						$detect=false;
					}
					$parserline= $this->parsertext($buffer);
				}
				$count_fields=count($parserline);
				if (strlen(trim($buffer)) == CLX_NUM_ZERO) {
					$ignored_records2++;
					continue;
				}
				if ($from>=$rline and $rline<=$to) {
					foreach ($parserline as $key=>$field) {
						$read_fields[$key] = ((empty($read_fields[$key])) ? " ": $read_fields[$key]) . $field;
					}
				}
				if ($rline>$to) {
					if ($importrec['TYPE'] === 'CSV' && count($file_fieldnames)==0) {
						if (count($read_fields)==0) {
							for ($key=0;$key<$count_fields;$key++) {
								$file_fieldnames[$key]= "(".dict('GEN_LBL_COLUMN')." [".($key+1).'])';
							}
						}
						else {$wcol=0;
							foreach ($read_fields as $key=>&$field) {
								$field=trim($field);
							}
							$file_fieldnames=$read_fields;
						}
					}
					$validate_record = array();

					if ($commit_count == $this->record_commit_counter) {
						$commit_count = CLX_INIT_ZERO;
						ClxCommon::$db->commit();
					}
					$commit_count++;

					if ($commit_count == $this->record_commit_counter) {
						$commit_count = CLX_INIT_ZERO;
						ClxCommon::$db->commit();
					}
					$commit_count++;

					$record = array();
					$errors = false;
					$class = ($fd->num_records % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT;
					if ($this->isException($exceptions, $buffer)) {
						if (!empty($show_file)) {
							$table->addCell(dict('GEN_LBL_RECORD_NOT_IMPORTED'), array(CLX_PROP_CLASS => $class, CLX_PROP_COLSPAN => $qty_fields));
						}
					} else {
						foreach ($mappings as $table_fieldname => $info) {
							$field_value = '';
							//echo 'mapeo:<pre>',var_export($info),'</pre><br>';
							if ($info['TYPE'] !== 'IGNR') {
								if ($info['TYPE'] === 'FIX'  and ($info['START_POSITION']>0 or $info['FIELD_LENGTH']>0))  {
	// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - BEGIN
								//$field_value = trim(substr($buffer, $info['START_POSITION']-1, $info['FIELD_LENGTH']));
								////$field_value = substr($buffer, $info['START_POSITION'] + CLX_NUM_ONE, $info['FIELD_LENGTH']);


									if (empty($info['RULE_TEXT'])) {
										$field_value = trim(substr($buffer, $info['START_POSITION'], $info['FIELD_LENGTH']));
									}
									else {
										$field_value =$this->convertToString($buffer,json_decode($info['RULE_TEXT']),false,false,false);
									}

	// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - END
								} else if ($info['TYPE'] === 'FILE') {
									$i = array_search($info['FILE_FIELDNAME'], $file_fieldnames);

									$field_value = ($i !== false && array_key_exists($i, $parserline)) ? $parserline[$i] : null;
									if (!empty($info['RULE_TEXT']))
										$field_value =$this->convertToString($field_value,json_decode($info['RULE_TEXT']),false,false,false);
								} elseif ($info['TYPE'] === 'CALC') {
									$field_value = $this->executeConstants($info, $parserline, $buffer);
								} elseif ($info['TYPE'] === 'FORM') {
									$i = array_search($info['FILE_FIELDNAME'], $file_fieldnames);
									$field_value = ($i !== false && array_key_exists($i, $parserline)) ? $parserline[$i] : '';
								}


								//SETTING RIGHT ENCODING
								$field_value = encode_string($field_value, kDefaultEncoding);
								$field_value = trim($field_value);
								//  FS - Caso 1002490 - CLX-Herr IMPORT Batch
								// Quote processing optimization to avoid PHP to hangs processing imports like FIAE
								//Eliminar enclosing de comillas de existir
								$lgth = mb_strlen($field_value);
								if ($lgth > CLX_NUM_ONE && mb_substr($field_value, CLX_NUM_ZERO, CLX_NUM_ONE) == CLX_CHAR_SINGLE_QUOTE && mb_substr($field_value, CLX_NUM_MINUS_1) == CLX_CHAR_SINGLE_QUOTE) {
									$field_value = mb_substr($field_value, CLX_NUM_ONE, $lgth - CLX_NUM_TWO);
								}
								if (!empty($translations)&&(array_key_exists(uppercase($field_value), $translations))) {
									$this->translate($field_value, $translations[$table_fieldname]);
								}
								$record[$table_fieldname] = str_ireplace(str_repeat(singleQuote(CLX_CHAR_EMPTY_STRING), CLX_NUM_THREE), singleQuote(CLX_CHAR_EMPTY_STRING), $field_value);
								//adding entry for validation
							}

						}
						foreach ($formulas as $key => $val) {
							ClxFreeReturn($this->executeFormula($val, $record));
						}

						//constructing record tablecode_fieldname forma. must be done after formulas to pass values to validate events on table.
						foreach ($mappings as $table_fieldname => $info) {
							if ($info['TYPE'] !== 'IGNR') {
								//adding entry for validation
								$validate_record[$tablerec['IDCODE'] . '_' . $table_fieldname] = $record[$table_fieldname];
							}
						}
						$msg = array();
						foreach ($record as $key => $val) {
							$fieldrec = $field_records[$key];
							$fieldinstance = getToolObject('DBFT', $fieldrec['FIELDTYPE']);
							if ($record[$key] === '') {
								if ($fieldrec['FIELDTYPE'] === 'BOOL') {
									$record[$key] = ($fieldrec['FIELD_DEFAULT']) ? CLX_NUM_ONE : CLX_NUM_ZERO;
									$val = $record[$key];
								} elseif (empty($required_fields[$key])) {
									$record[$key] = 'null';
									$val = $record[$key]; //notar $val que es lo que se pasa a la validacion
								}
							}
							$fieldinstance->validateImportField($msg, $fieldrec, $val);
						}
						$imported_records++;
						//Run table Validate events
						if($validate_record['FIAT_TRANSTBL_CODE'] == '')$validate_record['FIAT_TRANSTBL_CODE'] = $trans_ret;
						UserRequest::$post = $validate_record;
						$EVNT->execute5('DBTB', $tablerec['ID'], 'VREC', $validate_record, $msg); //  Validate Record
						unset($validate_record);
						foreach($record as $key => $val) {
							if (!empty($msg[$key])) {
								if (strlen($val)>20)
									$val="(".substr($val,0,20).'...'.")";
								else
									$val="(".$val.")";
								$msg[$key].='<font style=\'font-weight:800;color:#ff0000\'>'.$val.'</font>';

							}
						}

						//Reporting Errors
						//   - Caso 1002490 - CLX-Herr IMPORT Batch
						// Se habilita la posibilidad de especificar REPORTE SIN LIMITE de errores
						if ((count($msg) > CLX_NUM_ZERO) && ($saved_errors < $error_limit || $error_limit == CLX_NUM_ZERO)) {
							$this->saveErrors($importcode, $fd->line_num, $msg, $saved_errors,$code_lot,$cdatecomunerror,$test);
						}
						$errors = ($errors or ( count($msg) > CLX_NUM_ZERO));
						if (!empty($show_file)) {
							foreach ($record as $val) {
								$table->addCell($val, array(CLX_PROP_CLASS => $class));
							}
						}
						if (empty($test) && empty($errors)) {
							if (ISSET($record['IDCODE']) and $record['IDCODE']=='AUTO' ) {
								$RARD->setCreationIdCode($record, $tablecode);
							}
							//Check for duplicates
							if (strlen($crit_sql) > CLX_NUM_ZERO) {
								$sql = $crit_sql;
								foreach ($record as $key => $val) {
									$sql = str_replace('!' . $key, $val, $sql);
								}
								$count = ClxCommon::$db->countRecords($tablename, $sql);
							} else {
								$count = CLX_INIT_ZERO;
							}
							foreach ($field_derived as $key => $val) {
								unset($record[$key]);
							}
							//Adding
						//	$record['BATCH_ID']=$batch_log_id;

							if (in_array('LOG_ID',$insertfields))
								$record['LOG_ID']=$code_lot;
							if (in_array('LINE_OF_LOG_ID',$insertfields))
								$record['LINE_OF_LOG_ID']=$rline;
							if (in_array('IMPORTSHEETS',$insertfields))
								$record['IMPORTSHEETS']='';
							if (in_array('IMPORTCODE',$insertfields))
								$record['IMPORTCODE']=$importrec['IDCODE'];
							if (in_array('MODIFIEDBY',$insertfields2))
								$record['MODIFIEDBY']   = $_SESSION['user_record']['username'];
							if (in_array('MDATE',$insertfields2))
								$record['MDATE']		= xFormat::getNow('Y-m-d H:i:s');


							if ($count == CLX_NUM_ZERO) {
								//verificar si tiene credito
								$hasCred = ClxCommon::$db->oneExistsRecords('FIDU_TRANSACTIONS', "TRANSTBL_CODE = '" . $trans_prest . "'", "TRANS_STATUS = 'AP'", "REVERSED = '0'", "IDENTIFICATION = '".$record['IDENTIFICATION']."'");
								if($hasCred==0)
									$record['TRANSTBL_CODE'] =$trans_dev;
								else
									$record['TRANSTBL_CODE'] =$trans_ret;
								//Generar transacciones
								$record['IDCODE'] = 'AUTO';
								$EVNT->execute5('DBTB', $tablerec['ID'], 'CREP', $record, $msg); //  Create Record (pre database commit)
								if (in_array('CREATEDBY',$insertfields2))
									$record['CREATEDBY'] 	= $_SESSION['user_record']['username'];
								if (in_array('CDATE',$insertfields2))
									$record['CDATE'] 		= xFormat::getNow('Y-m-d H:i:s');

								ClxCommon::$db->createRecord($tablename, $record, false);
								if ($this->debug==true) {echo $b='create record de la data '.__LINE__S;pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}

								$EVNT->execute5('DBTB', $tablerec['ID'], 'CREC', $record, $msg); //  Create Record (post database commit)
								//   - Caso 1002490 - CLX-Herr IMPORT Batch
								// Separates created record counter from record processed counter
								$created_records++;
							} elseif ($count > CLX_NUM_ZERO && $importrec['IF_DUPLICATES'] == CLX_NUM_ONE) {
								unset($record['ID']); //solo por si existe campo
								$EVNT->execute5('DBTB', $tablerec['ID'], 'UREP', $record, $msg); //  Update Record (pre database commit)
								ClxCommon::$db->updateRecord($tablename, $record, $sql);
								$EVNT->execute5('DBTB', $tablerec['ID'], 'UREC', $record, $msg); //  Update Record (post database commit)
								$updated_records++;
							} else {
								$ignored_records++;
							}
						} else {
							$ignored_records++;
						}

					}
				}
			}
		}
		$fd->close();
		file_put_contents($namefileBarr,100);

		if (empty($test)) {
			//  Events Post Import
			$EVNT->execute5('DBIM', $importrec['ID'], 'INPO', $savepost, $evnt_msg);
		}
		UserRequest::$get = $saveget;
		UserRequest::$post = $savepost;
		UserRequest::$request = $saverequest;
		$record = array();
		$record['IMPORTCODE'] = $importcode;
		$record['RECORD_QTY'] = $imported_records;
		$record['CDATE'] = xFormat::getNow('Y-m-d H:i:s');
		$record['OWNERCODE'] = $_SESSION['user_record']['username'];
		$record['DESCRIPTION'] = $record['DESCRIPTION'] = dict('CLX_USER_SIST_O').(stripos(' '.PHP_OS,'WIN')>0 ? '' : posix_getpwuid(posix_geteuid())['name']).'<br>'.chr(13).chr(10).$description;
		$record['FILENAME'] = $original_filename;
		$record['OBSERVATION'] = 'IP SERVER:'.(ISSET($_SERVER['SERVER_ADDR'])? $_SERVER['SERVER_ADDR'] : $_SERVER['LOCAL_ADDR']).' SERVER NAME:'.(EMPTY($_SERVER['SERVER_NAME'])? $_SERVER['COMPUTERNAME']:$_SERVER['SERVER_NAME'] );
		$record['LOG_ID']=$code_lot;
		$record['STATUS']='ACT';
		//   - Caso 1002490 - CLX-Herr IMPORT Batch
		// Separates created record counter from record processed counter
		$result_msg0 = dict('TOOL_DBIM_IMPORT_COMPLETE', $saved_errors, $fd->num_records, $ignored_records,$ignored_records2, $updated_records, $created_records);
		if ($batch_log_id == CLX_NUM_ZERO) {
			$record['DESCRIPTION'] = $result_msg0 . '<br>' . CLX_CHAR_NL . $record['DESCRIPTION'];
			ClxCommon::$db->createRecord('CLX_DB_IMPORT_EXECUTIONS', $record, false);
			if ($this->debug==true) {echo $b='createrecord executions '.__LINE__;pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}
		} else {
			unset($record['CDATE'], $record['OWNERCODE']); //just keep from batch
			ClxCommon::$db->updateRecord('CLX_DB_IMPORT_EXECUTIONS', $record, 'ID = ' . $batch_log_id);
			if ($this->debug==true) {echo $b='updaterecord executions '.__LINE__;pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}
		}

		ClxCommon::$db->executequery('commit');

		if ($saved_errors > CLX_NUM_ZERO) {
			$errors_link = '<a href="tool.php?to=' . $this->code . '&ac=DISPLAY&idlist=' . $importid . '">' .
			dict('GEN_LBL_DISPLAY') . ' ' . dict('GEN_LBL_ERRORS') . '</a>';
		} else {
			$errors_link = '';
		}
		if (!empty($test)) {
			$ignored_records = $fd->num_records;
		}
		$note = note($result_msg0 . '<br>' . $errors_link, dict('GEN_LBL_OK'));
		if (!empty($show_file)) {
			$c = new htmlButtonCancel(dict('GEN_LBL_RETURN'));
			$table->addCell($c->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => $qty_fields));
			return $note . '<Br>' . $table->source();
		} else {
			//return note(dict('TOOL_DBIM_IMPORT_COMPLETE', $saved_errors, $fd->num_records), dict('GEN_LBL_OK'));
			return $note;
		}
		 UserResponse::setRunTimeLimit($init_time_out);
		 if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1626;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");fwrite($tta,chr(13).chr(10)."db_import-hora fin de funcion import ".date("h:i:s d/m/Y").chr(13).chr(10));fclose($tta);}

	}
	function import_ihcafe_cos($is_batch=true) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1608;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		$GLOBALS['PROCESS']='DBIM';
		$DBEX = &getTool('DBIX');
		$timex=microtime(true);
		$trans_cos = ClxCommon::$db->getField('BASE_PARAMETERS', "PVALUE" ,"IDNAME='FIAT_COSECHA'");
		##$tta=fopen(kPathToWebSite."/".kPathToTemp."archivoX2.txt","a+");fwrite($tta,"SIIIIIIIIIII".CHR(13).CHR(10));fclose($tta);

		$init_time_out = ini_get('max_execution_time'); ini_set('display_errors', '1');
		ini_set('memory_limit',$this->memorylimit);
		UserResponse::setRunTimeLimit(CLX_NUM_24 * CLX_NUM_60 * CLX_NUM_60);
		$this->s_input_line_encoding_detect = null;
		$this->s_input_line_encoding_detect2= null;
		$EVNT = &getTool('EVNT');
		//Stored for returning later
		$savepost = UserRequest::$post;
		$saverequest = UserRequest::$request;
		$saveget = UserRequest::$get;
		if (empty(UserRequest::$post['DBIM_id'])) {
			 return note('Not set option');

		}
		$importid = UserRequest::$post['DBIM_id'];
		$test = UserRequest::$post['DBIM_test'];
		$show_file = UserRequest::$post['DBIM_show_file'];
		$error_limit = UserRequest::$post['DBIM_error_limit'];
		$description = UserRequest::$post['DBIM_description'];
		$original_filename = UserRequest::$files['DBIM_file']['name'];
		$saved_errors = CLX_INIT_ZERO;
		//May come from batch then no extra log is required since was set on schedule batch
		$batch_log_id = (!empty(UserRequest::$post['RINNING_BATCH'])) ? UserRequest::$post['RINNING_BATCH'] : CLX_NUM_ZERO;
		$importrec = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $importid);
		$code_lot=++$importrec['LOG_ID'];
		$importrec2=$importrec;
		unset($importrec2['ID']);
		unset($importrec2['FILE_C']);
		unset($importrec2['FILE_CEXCEL']);
		unset($importrec2['FILE_CDELIM']);
		unset($importrec2['CDATE']);
		unset($importrec2['MDATE']);
		unset($importrec2['USERNAME']);
		unset($importrec2['TYPE']);
		unset($importrec2['IF_DUPLICATE']);
		unset($importrec2['IF_UTF8']);
		unset($importrec2['FIELD_DELIM']);
		unset($importrec2['NEWTABLECODE']);
		unset($importrec2['FILE_CDELIM']);
		unset($importrec2['VERSION']);
		unset($importrec2['DESCRIPTION']);
		unset($importrec2['FIELD_DELIM']);
		unset($importrec2['FIELD_CDELIM']);
		unset($importrec2['RECORD_PROP']);
		unset($importrec2['RECORD_CPROP']);
		unset($importrec2['FILE']);
		unset($importrec2['FILE_EXCEL']);
		unset($importrec2['FILE_DELIM']);
		unset($importrec2['NEWTABLECODE']);
		unset($importrec2['EXCEL_TYPE']);
		ClxCommon::$db->updateRecord($this->tablename, $importrec2, 'ID=' . $importid);


		$importrec["RECORD_PROP"]=json_decode($importrec["RECORD_PROP"],true);
		$importrec["RECORD_CPROP"]=json_decode($importrec["RECORD_CPROP"],true);
//$importrec["FIELD_DELIM"]=json_decode($importrec["FIELD_DELIM"],true);
//$importrec["FIELD_CDELIM"]=json_decode($importrec["FIELD_CDELIM"],true);

		$importcode = $importrec['IDCODE'];
		$tablecode = $importrec['TABLECODE'];
		$DBIU=new db_import_run();
		$DBIU->basicFields($record['TABLECODE']);
		$this->import_extra_fields_required=$DBIU->import_extra_fields_required;
		$insertfields=explode(",",$this->import_extra_fields_required);

		$insertfields2=explode(",",$this->import_extra_fields_required);
		$mappings = $this->getMappings($importcode);
		$mappings2 = $this->getMappings($importcode,true);
		foreach ($mappings as $key=>$value) {
			$insertfields2[]=$key;
		}

		$this->compileCodeFormulas($importcode);
		$tablerec = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE=' . singleQuote($tablecode));
		$tablename = $tablerec['MODULECODE'] . '_' . $tablerec['IDNAME'];
		//ClxCommon::$db->deleteRecords('CLX_DB_IMPORT_ERRORS', 'IMPORTCODE=' . singleQuote($importcode));

		$restrictions= $this->getRestriction($importcode);
		$formulas = $this->getFormulas($importcode);
		$translations = $this->getTranslations($importcode, $mappings);
		$exceptions = $this->getExceptions($importcode);
		$field_records = $this->getTableFieldRecords($tablecode);
		$field_derived = $this->getDerivedFields($tablecode);
		$required_fields = $this->getTableRequiredFields($tablecode);
		//Search Indexes
		$DBTI = &getTool('DBTI');
		$commit_count = CLX_INIT_ZERO;
		$imported_records = CLX_INIT_ZERO;
		$updated_records = CLX_INIT_ZERO;

		$created_records = CLX_INIT_ZERO;
		$count_fields=CLX_INIT_ZERO;
		$rline=CLX_INIT_ZERO;

		$ignored_records = CLX_INIT_ZERO;
		$ignored_records2 = CLX_INIT_ZERO;
		$cdatecomunerror	= xFormat::getNow('Y-m-d H:i:s');
		ClxCommon::$db->executequery('UPDATE CLX_DB_IMPORT_EXECUTIONS SET LOG_ID='.singlequote($code_lot).' WHERE ID = ' . $batch_log_id);
		ClxCommon::$db->executequery('commit');
		if ($this->debug==true) {echo $b='update executions in 4303';pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}
		if (!$this->validar_tabla($mappings2, $field_records,$field_derived,$tablename,$importcode,$code_lot,$cdatecomunerror)) {
			$saved_errors=1;
			$line=1;
			$record = array();
			$record['IMPORTCODE'] = $importcode;
			$record['RECORD_QTY'] = $imported_records;
			$record['CDATE'] = xFormat::getNow('Y-m-d H:i:s');
			$record['OWNERCODE'] = $_SESSION['user_record']['username'];
			$record['DESCRIPTION'] = dict('CLX_USER_SIST_O').(stripos(' '.PHP_OS,'WIN')>0 ? '' : posix_getpwuid(posix_geteuid())['name']).'<br>'.chr(13).chr(10).$description;
			$record['FILENAME'] = $original_filename;
			$record['OBSERVATION'] = 'IP SERVER:'.(ISSET($_SERVER['SERVER_ADDR'])? $_SERVER['SERVER_ADDR'] : $_SERVER['LOCAL_ADDR']).' SERVER NAME:'.(EMPTY($_SERVER['SERVER_NAME'])? $_SERVER['COMPUTERNAME']:$_SERVER['SERVER_NAME'] );
			$record['LOG_ID']=$code_lot;
			$record['STATUS']='ACT';
			//   - Caso 1002490 - CLX-Herr IMPORT Batch
			// Separates created record counter from record processed counter
			$result_msg0 = dict('TOOL_DBIM_IMPORT_COMPLETE', $saved_errors, 0, $ignored_records,$ignored_records2, $updated_records, $created_records);

			$this->saveErrors($importcode, $line, array('File'=>dict("GEN_LBL_NOT_TABLE_VALID")), $saved_errors,$code_lot,$cdatecomunerror,$test);

			if ($batch_log_id == CLX_NUM_ZERO) {
				$record['DESCRIPTION'] = $result_msg0 . '<br>' . CLX_CHAR_NL . $record['DESCRIPTION'];
				ClxCommon::$db->createRecord('CLX_DB_IMPORT_EXECUTIONS', $record, false);
				if ($this->debug==true) {echo $b='createrecord executions '.__LINE__;pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}
			} else {
				unset($record['CDATE'], $record['OWNERCODE']); //just keep from batch
				ClxCommon::$db->updateRecord('CLX_DB_IMPORT_EXECUTIONS', $record, 'ID = ' . $batch_log_id);
				if ($this->debug==true) {echo $b= 'updaterecord executions '.__LINE__;pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}
			}
			ClxCommon::$db->executequery('commit');
			$errors_link = '';
			if ($saved_errors > CLX_NUM_ZERO) {
				$errors_link = '<a href="tool.php?to=' . $this->code . '&ac=DISPLAY&idlist=' . $importid . '">' .
				dict('GEN_LBL_DISPLAY') . ' ' . dict('GEN_LBL_ERRORS') . '</a>';
			}

			$note = note($result_msg0 . '<br>' . $errors_link, dict('GEN_LBL_OK'));
			$table = new htmlTable(CLX_WIDTH_TWO);
			if (!empty($show_file)) {
				$c = new htmlButtonCancel(dict('GEN_LBL_RETURN'));
				$qty_fields=count($mappings);
				$table->addCell($c->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => $qty_fields));
				return $note . '<Br>' . $table->source();
			} else {
				//return note(dict('TOOL_DBIM_IMPORT_COMPLETE', $saved_errors, $fd->num_records), dict('GEN_LBL_OK'));
				return $note;
			}
		}
		if (!empty($show_file)) {
			$ignore = CLX_INIT_ZERO;
			$qty_fields=count($mappings);
			foreach ($mappings as $table_fieldname => $info) {
				if ($info['TYPE'] === 'IGNR') {
					$ignore++;
				}
			}
			$table = new htmlTable($qty_fields - $ignore);
			$table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
			$table->addCell(dict('GEN_LBL_FILE_CONTENTS'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => $qty_fields));
			foreach ($mappings as $table_fieldname => $info) {
				if ($info['TYPE'] !== 'IGNR') {
					$table->addCell($info['TABLE_FIELDNAME'], array(CLX_PROP_CLASS => CLX_CLASS_HEADERS));
				}
			}
		}

		$indx = $DBTI->getTableIndexes($tablecode, 'UNI');
		$indx2 = ClxCommon::$db->getTableByIndexes($tablecode, 'UNI');
		//pre($indx);
		//pre($indx2);
		//die;
		$indx_crit = array();
		foreach ($indx as $key => $val) {
			$fields = explode(',', $val['FIELDNAME']);
			foreach ($fields as $v) {
				$indx_crit[$key][] = $v . ' = ' . singleQuote('!' . $v);
			}
		}
		$crit_sql = '';
		$comma = '';
		foreach ($indx_crit as $key => $val) {
			$crit_sql .= $comma . ' (' . implode(' AND ', $val) . ') ';
			$comma = ' AND ';
		}
		$qty_fields = count($mappings);
		//$record_prop=(empty($importrec['RECORD_PROP']))? '' :json_decode($importrec['RECORD_PROP'],true);
		$from=$to=0;
		$recordlotcreate=0;
		$encodedetect="X";
		if ($importrec['TYPE'] === 'CSV') {
			require_once'classes/clx_file_delimited.php';
			$record_delim = replace_ascii_chars($importrec['RECORD_DELIM']);
			$field_delim = $importrec['FIELD_DELIM'];
			$field_cdelim = $importrec['FIELD_CDELIM'];
			$fileread=UserRequest::$files['DBIM_file']['tmp_name'];
			$this->writeziptotext();
			$a=fopen($fileread,"r");
			$encodedetect=mb_detect_encoding(fread($a,$archivotext=filesize($fileread)), "auto");
			fclose($a);
			if (empty($encodedetect)) {
				$this->saveErrors($importcode, $rline, array('File'=>dict("GEN_LBL_NOTANSIORUTF8")), $saved_errors,$code_lot,$cdatecomunerror,$test);
			}


			$fd = new clx_file_delimited($fileread, $record_delim, $field_delim);
			IF ($this->debug==true) {
				pre('import de entrada4');
				pre($fd);
				pre($fileread);
				pre('--------xxx----------');
			}
			$col=0;

			IF (!empty($importrec['RECORD_PROP'][$col])){
				$from=$to=$importrec['RECORD_CPROP'][$col];
			}
			IF (!empty($importrec['RECORD_PROP'][$col+1]) and	$importrec['RECORD_CPROP'][$col+1]>=$from) {
				$to=$importrec['RECORD_CPROP'][$col+1];
			}

		} elseif ($importrec['TYPE'] === 'FRL') {
			require_once'classes/clx_file_fixed_record_length.php';
			$fileread=UserRequest::$files['DBIM_file']['tmp_name'];
			$a=fopen($fileread,"r");
			$encodedetect=mb_detect_encoding(fread($a,$archivotext=filesize($fileread)), "auto");
			fclose($a);
			$this->writeziptotext($archivo_text);

			if (empty($encodedetect)) {
				$texto='';
				$this->saveErrors($importcode, $rline, array('File'=>dict("GEN_LBL_NOTANSIORUTF8")), $saved_errors,$code_lot,$cdatecomunerror,$test);
				$texto=array('File'=>dict("GEN_LBL_NOTANSIORUTF8"));
			}
		/// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - BEGIN
			$record_delim = replace_ascii_chars($importrec['RECORD_DELIM']);
			//$record_length = $importrec['RECORD_LENGTH'];
			$record_length = intval($importrec['RECORD_LENGTH']) + mb_strlen($record_delim, kDefaultEncoding);
// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - END
			$fd = new clx_file_fixed_record_length($fileread, $record_length);
			IF ($this->debug==true) {
				pre('import de entrada5');
				pre($fd);
				pre($fileread);
				pre('--------xxx----------');
			}
// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - BEGIN
			// It's fixed lenght, but reads only until EOL character, to avoid cases of not so fixed lenght files like IBS's




			if($record_delim != '') {
				$this->use_record_delimiter_reading_fixlen_files = true;
			}
			if ($this->use_record_delimiter_reading_fixlen_files === true) {
				$fd->line_delim = $record_delim;
			}
// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - END
		} elseif ($importrec['TYPE'] === 'XLS') {

			require_once(kPathToSimpleExcel.'/php-excel-reader/excel_reader2.php');
			require_once(kPathToSimpleExcel.'/SpreadsheetReader.php');

			return $this->readExcel($test,$importcode,$tablecode,$importid,$show_file, $mappings,$restrictions,$exceptions,$translations,$formulas,$tablerec,$tablename,$field_records,$importrec,$code_lot,$batch_log_id,$cdatecomunerror,$error_limit);


		} else {
			return note(dict('TOOL_DBIM_INVALID_FILE_TYPE') . ' ' . $importrec['TYPE'], dict('GEN_LBL_OK'));
		}
		if (empty($test)) {
			//Running Events
			$evnt_msg = array();
			$EVNT = &getTool('EVNT');
			$EVNT->execute5('DBIM', $importrec['ID'], 'INPR', $savepost, $evnt_msg); //  Events Pre Import
		}
		//convertToString($field_text,$Rule,$capturehtml=false)
		$read_fields=array();
		$detect=true;
		$file_fieldnames=array();

		if (!empty($encodedetect)) {
			$RARD = getToolObject('ACTN', 'RARD');
			while (!$fd->EOF) {
				$rline++;
				$buffer = $this->input_line_encoding_detect($fd->getNextRecord2($importrec['IF_UTF8']));
				if (empty($this->s_input_line_encoding_detect2)) {
					$this->saveErrors($importcode, $rline, array('File'=>dict("GEN_LBL_NOTANSIORUTF8")), $saved_errors,$code_lot,$cdatecomunerror,$test);
					break;
				}

				if (count($restrictions)>0) {
					$restrict=$this->apply_Restriction($restrictions,$buffer,$rline);
					if ($restrict) {
						$ignored_records2++;
						continue;
					}
				}

				if ($importrec['TYPE'] === 'CSV') {
					if ($detect) {
						$this->parsertextdetect($buffer, $field_delim, $field_cdelim );
						$detect=false;
					}
					$parserline= $this->parsertext($buffer);
				}
				$count_fields=count($parserline);
				if (strlen(trim($buffer)) == CLX_NUM_ZERO) {
					$ignored_records2++;
					continue;
				}
				if ($from>=$rline and $rline<=$to) {
					foreach ($parserline as $key=>$field) {
						$read_fields[$key] = ((empty($read_fields[$key])) ? " ": $read_fields[$key]) . $field;
					}
				}
				if ($rline>$to) {
					if ($importrec['TYPE'] === 'CSV' && count($file_fieldnames)==0) {
						if (count($read_fields)==0) {
							for ($key=0;$key<$count_fields;$key++) {
								$file_fieldnames[$key]= "(".dict('GEN_LBL_COLUMN')." [".($key+1).'])';
							}
						}
						else {$wcol=0;
							foreach ($read_fields as $key=>&$field) {
								$field=trim($field);
							}
							$file_fieldnames=$read_fields;
						}
					}
					$validate_record = array();

					if ($commit_count == $this->record_commit_counter) {
						$commit_count = CLX_INIT_ZERO;
						ClxCommon::$db->commit();
					}
					$commit_count++;

					if ($commit_count == $this->record_commit_counter) {
						$commit_count = CLX_INIT_ZERO;
						ClxCommon::$db->commit();
					}
					$commit_count++;

					$record = array();
					$errors = false;
					$class = ($fd->num_records % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT;
					if ($this->isException($exceptions, $buffer)) {
						if (!empty($show_file)) {
							$table->addCell(dict('GEN_LBL_RECORD_NOT_IMPORTED'), array(CLX_PROP_CLASS => $class, CLX_PROP_COLSPAN => $qty_fields));
						}
					} else {
						foreach ($mappings as $table_fieldname => $info) {
							$field_value = '';
							if ($info['TYPE'] !== 'IGNR') {
								if ($info['TYPE'] === 'FIX'  and ($info['START_POSITION']>0 or $info['FIELD_LENGTH']>0))  {
	// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - BEGIN
								//$field_value = trim(substr($buffer, $info['START_POSITION']-1, $info['FIELD_LENGTH']));
								////$field_value = substr($buffer, $info['START_POSITION'] + CLX_NUM_ONE, $info['FIELD_LENGTH']);


									if (empty($info['RULE_TEXT'])) {
										$field_value = trim(substr($buffer, $info['START_POSITION'], $info['FIELD_LENGTH']));
									}
									else {
										$field_value =$this->convertToString($buffer,json_decode($info['RULE_TEXT']),false,false,false);
									}

	// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - END
								} else if ($info['TYPE'] === 'FILE') {
									$i = array_search($info['FILE_FIELDNAME'], $file_fieldnames);

									$field_value = ($i !== false && array_key_exists($i, $parserline)) ? $parserline[$i] : null;
									if (!empty($info['RULE_TEXT']))
										$field_value =$this->convertToString($field_value,json_decode($info['RULE_TEXT']),false,false,false);
								} elseif ($info['TYPE'] === 'CALC') {
									$field_value = $this->executeConstants($info, $parserline, $buffer);
								} elseif ($info['TYPE'] === 'FORM') {
									$i = array_search($info['FILE_FIELDNAME'], $file_fieldnames);
									$field_value = ($i !== false && array_key_exists($i, $parserline)) ? $parserline[$i] : '';
								}


								//SETTING RIGHT ENCODING
								$field_value = encode_string($field_value, kDefaultEncoding);
								$field_value = trim($field_value);
								//  FS - Caso 1002490 - CLX-Herr IMPORT Batch
								// Quote processing optimization to avoid PHP to hangs processing imports like FIAE
								//Eliminar enclosing de comillas de existir
								$lgth = mb_strlen($field_value);
								if ($lgth > CLX_NUM_ONE && mb_substr($field_value, CLX_NUM_ZERO, CLX_NUM_ONE) == CLX_CHAR_SINGLE_QUOTE && mb_substr($field_value, CLX_NUM_MINUS_1) == CLX_CHAR_SINGLE_QUOTE) {
									$field_value = mb_substr($field_value, CLX_NUM_ONE, $lgth - CLX_NUM_TWO);
								}
								if (!empty($translations)&&(array_key_exists(uppercase($field_value), $translations))) {
									$this->translate($field_value, $translations[$table_fieldname]);
								}
								$record[$table_fieldname] = str_ireplace(str_repeat(singleQuote(CLX_CHAR_EMPTY_STRING), CLX_NUM_THREE), singleQuote(CLX_CHAR_EMPTY_STRING), $field_value);
								//adding entry for validation
							}
						}
						foreach ($formulas as $key => $val) {
							ClxFreeReturn($this->executeFormula($val, $record));
						}

						//constructing record tablecode_fieldname forma. must be done after formulas to pass values to validate events on table.
						foreach ($mappings as $table_fieldname => $info) {
							if ($info['TYPE'] !== 'IGNR') {
								//adding entry for validation
								$validate_record[$tablerec['IDCODE'] . '_' . $table_fieldname] = $record[$table_fieldname];
							}
						}
						$msg = array();
						foreach ($record as $key => $val) {
							$fieldrec = $field_records[$key];
							$fieldinstance = getToolObject('DBFT', $fieldrec['FIELDTYPE']);
							if ($record[$key] === '') {
								if ($fieldrec['FIELDTYPE'] === 'BOOL') {
									$record[$key] = ($fieldrec['FIELD_DEFAULT']) ? CLX_NUM_ONE : CLX_NUM_ZERO;
									$val = $record[$key];
								} elseif (empty($required_fields[$key])) {
									$record[$key] = 'null';
									$val = $record[$key]; //notar $val que es lo que se pasa a la validacion
								}
							}
							$fieldinstance->validateImportField($msg, $fieldrec, $val);
						}
						$imported_records++;
						//Run table Validate events
						if($validate_record['FIAT_TRANSTBL_CODE'] == '')$validate_record['FIAT_TRANSTBL_CODE'] = $trans_cos;
						UserRequest::$post = $validate_record;
						$EVNT->execute5('DBTB', $tablerec['ID'], 'VREC', $validate_record, $msg); //  Validate Record
						unset($validate_record);
						foreach($record as $key => $val) {
							if (!empty($msg[$key])) {
								if (strlen($val)>20)
									$val="(".substr($val,0,20).'...'.")";
								else
									$val="(".$val.")";
								$msg[$key].='<font style=\'font-weight:800;color:#ff0000\'>'.$val.'</font>';

							}
						}

						//Reporting Errors
						//   - Caso 1002490 - CLX-Herr IMPORT Batch
						// Se habilita la posibilidad de especificar REPORTE SIN LIMITE de errores
						if ((count($msg) > CLX_NUM_ZERO) && ($saved_errors < $error_limit || $error_limit == CLX_NUM_ZERO)) {
							$this->saveErrors($importcode, $fd->line_num, $msg, $saved_errors,$code_lot,$cdatecomunerror,$test);
						}
						$errors = ($errors or ( count($msg) > CLX_NUM_ZERO));
						if (!empty($show_file)) {
							foreach ($record as $val) {
								$table->addCell($val, array(CLX_PROP_CLASS => $class));
							}
						}
						if (empty($test) && empty($errors)) {
							if (ISSET($record['IDCODE']) and $record['IDCODE']=='AUTO' ) {
								$RARD->setCreationIdCode($record, $tablecode);
							}
							//Check for duplicates
							if (strlen($crit_sql) > CLX_NUM_ZERO) {
								$sql = $crit_sql;
								foreach ($record as $key => $val) {
									$sql = str_replace('!' . $key, $val, $sql);
								}
								$count = ClxCommon::$db->countRecords($tablename, $sql);
							} else {
								$count = CLX_INIT_ZERO;
							}
							foreach ($field_derived as $key => $val) {
								unset($record[$key]);
							}
							//Adding
						//	$record['BATCH_ID']=$batch_log_id;

							if (in_array('LOG_ID',$insertfields))
								$record['LOG_ID']=$code_lot;
							if (in_array('LINE_OF_LOG_ID',$insertfields))
								$record['LINE_OF_LOG_ID']=$rline;
							if (in_array('IMPORTSHEETS',$insertfields))
								$record['IMPORTSHEETS']='';
							if (in_array('IMPORTCODE',$insertfields))
								$record['IMPORTCODE']=$importrec['IDCODE'];
							if (in_array('MODIFIEDBY',$insertfields2))
								$record['MODIFIEDBY'] 	= $_SESSION['user_record']['username'];
							if (in_array('MDATE',$insertfields2))
								$record['MDATE']		= xFormat::getNow('Y-m-d H:i:s');


							if ($count == CLX_NUM_ZERO) {
								//Registrar beneficiarios en caso de que no exista
								if(ClxCommon::$db->oneExistsRecords("CRED_BENEFICIARIES",  "IDENTIFICATION = '".$record['IDENTIFICATION']."'")==0){
									$now_benef = xFormat::getNow("Y-m-d H:i:s");
									$r = array(
										'IDENTIFICATION'=>$record['IDENTIFICATION'],
										'FULLNAME'=> $record['BENEFICIARY_NAME'],
										'EFFTDATE'=> $now_benef,
										'CREATEDBY'=> $_SESSION["user_record"]["username"],
										'MODIFIEDBY'=> $_SESSION["user_record"]["username"],
										'CDATE'=> $now_benef,
										'MDATE'=> $now_benef,
									);
									if (!function_exists('setCreationData')) includeCodeLib('GEN_REC_UTIL');
									setCreationData($r);
									ClxCommon::$db->createRecord('CRED_BENEFICIARIES', $r);
									if ($this->debug==true) {echo $b= 'update cred_beneficiaries in 4695';pre($r);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($r,true)); fclose($tta);}}

								}

								$record['TRANSTBL_CODE']=$trans_cos;
								$record['IDCODE'] = 'AUTO';

								$EVNT->execute5('DBTB', $tablerec['ID'], 'CREP', $record, $msg); //  Create Record (pre database commit)
								if (in_array('CREATEDBY',$insertfields2))
									$record['CREATEDBY']	= $_SESSION['user_record']['username'];
								if (in_array('CDATE',$insertfields2))
									$record['CDATE']		= xFormat::getNow('Y-m-d H:i:s');

								ClxCommon::$db->createRecord($tablename, $record, false);
								if ($this->debug==true) {echo $b= 'create record data in 4700';pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}

								$EVNT->execute5('DBTB', $tablerec['ID'], 'CREC', $record, $msg); //  Create Record (post database commit)
								//   - Caso 1002490 - CLX-Herr IMPORT Batch
								// Separates created record counter from record processed counter
								$created_records++;
							} elseif ($count > CLX_NUM_ZERO && $importrec['IF_DUPLICATES'] == CLX_NUM_ONE) {
								unset($record['ID']); //solo por si existe campo
								$EVNT->execute5('DBTB', $tablerec['ID'], 'UREP', $record, $msg); //  Update Record (pre database commit)
								ClxCommon::$db->updateRecord($tablename, $record, $sql);
								$EVNT->execute5('DBTB', $tablerec['ID'], 'UREC', $record, $msg); //  Update Record (post database commit)
								$updated_records++;
							} else {
								$ignored_records++;
							}
						} else {
							$ignored_records++;
						}

					}
				}
			}
		}
		$fd->close();
		if (empty($test)) {
			//  Events Post Import
			$EVNT->execute5('DBIM', $importrec['ID'], 'INPO', $savepost, $evnt_msg);
		}
		UserRequest::$get = $saveget;
		UserRequest::$post = $savepost;
		UserRequest::$request = $saverequest;
		$record = array();
		$record['IMPORTCODE'] = $importcode;
		$record['RECORD_QTY'] = $imported_records;
		$record['CDATE'] = xFormat::getNow('Y-m-d H:i:s');
		$record['OWNERCODE'] = $_SESSION['user_record']['username'];
		$record['DESCRIPTION'] = $record['DESCRIPTION'] = dict('CLX_USER_SIST_O').(stripos(' '.PHP_OS,'WIN')>0 ? '' : posix_getpwuid(posix_geteuid())['name']).'<br>'.chr(13).chr(10).$description;
		$record['FILENAME'] = $original_filename;
		$record['OBSERVATION'] = 'IP SERVER:'.(ISSET($_SERVER['SERVER_ADDR'])? $_SERVER['SERVER_ADDR'] : $_SERVER['LOCAL_ADDR']).' SERVER NAME:'.(EMPTY($_SERVER['SERVER_NAME'])? $_SERVER['COMPUTERNAME']:$_SERVER['SERVER_NAME'] );
		$record['LOG_ID']=$code_lot;
		$record['STATUS']='ACT';
		//   - Caso 1002490 - CLX-Herr IMPORT Batch
		// Separates created record counter from record processed counter
		$result_msg0 = dict('TOOL_DBIM_IMPORT_COMPLETE', $saved_errors, $fd->num_records, $ignored_records,$ignored_records2, $updated_records, $created_records);
		if ($batch_log_id == CLX_NUM_ZERO) {
			$record['DESCRIPTION'] = $result_msg0 . '<br>' . CLX_CHAR_NL . $record['DESCRIPTION'];
			ClxCommon::$db->createRecord('CLX_DB_IMPORT_EXECUTIONS', $record, false);
			if ($this->debug==true) {echo $b= 'createrecord executions in 4754';pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}

		} else {
			unset($record['CDATE'], $record['OWNERCODE']); //just keep from batch
			ClxCommon::$db->updateRecord('CLX_DB_IMPORT_EXECUTIONS', $record, 'ID = ' . $batch_log_id);
			if ($this->debug==true) {echo $b= 'updaterecord executions in 4759';pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}
		}
		ClxCommon::$db->executequery('commit');

		if ($saved_errors > CLX_NUM_ZERO) {
			$errors_link = '<a href="tool.php?to=' . $this->code . '&ac=DISPLAY&idlist=' . $importid . '">' .
			dict('GEN_LBL_DISPLAY') . ' ' . dict('GEN_LBL_ERRORS') . '</a>';
		} else {
			$errors_link = '';
		}
		if (!empty($test)) {
			$ignored_records = $fd->num_records;
		}
		$note = note($result_msg0 . '<br>' . $errors_link, dict('GEN_LBL_OK'));
		if (!empty($show_file)) {
			$c = new htmlButtonCancel(dict('GEN_LBL_RETURN'));
			$table->addCell($c->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => $qty_fields));
			return $note . '<Br>' . $table->source();
		} else {
			//return note(dict('TOOL_DBIM_IMPORT_COMPLETE', $saved_errors, $fd->num_records), dict('GEN_LBL_OK'));
			return $note;
		}
		 UserResponse::setRunTimeLimit($init_time_out);
		 if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1626;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");fwrite($tta,chr(13).chr(10)."db_import-hora fin de funcion import ".date("h:i:s d/m/Y").chr(13).chr(10));fclose($tta);}

	}
	function import_ihcafe($is_batch=true,$transaction) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1608;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		$GLOBALS['PROCESS']='DBIM';
		$DBEX = &getTool('DBIX');
		$timex=microtime(true);
		##$tta=fopen(kPathToWebSite."/".kPathToTemp."archivoX2.txt","a+");fwrite($tta,"SIIIIIIIIIII".CHR(13).CHR(10));fclose($tta);

		$init_time_out = ini_get('max_execution_time'); ini_set('display_errors', '1');
		ini_set('memory_limit',$this->memorylimit);
		UserResponse::setRunTimeLimit(CLX_NUM_24 * CLX_NUM_60 * CLX_NUM_60);
		$this->s_input_line_encoding_detect = null;
		$this->s_input_line_encoding_detect2= null;
		$EVNT = &getTool('EVNT');
		//Stored for returning later
		$savepost = UserRequest::$post;
		$saverequest = UserRequest::$request;
		$saveget = UserRequest::$get;
		if (empty(UserRequest::$post['DBIM_id'])) {
			 return note('Not set option');

		}
		$importid = UserRequest::$post['DBIM_id'];
		$test = UserRequest::$post['DBIM_test'];
		$show_file = UserRequest::$post['DBIM_show_file'];
		$error_limit = UserRequest::$post['DBIM_error_limit'];
		$description = UserRequest::$post['DBIM_description'];
		$original_filename = UserRequest::$files['DBIM_file']['name'];
		$saved_errors = CLX_INIT_ZERO;
		//May come from batch then no extra log is required since was set on schedule batch
		$batch_log_id = (!empty(UserRequest::$post['RINNING_BATCH'])) ? UserRequest::$post['RINNING_BATCH'] : CLX_NUM_ZERO;
		$importrec = ClxCommon::$db->getRecord($this->tablename, 'ID=' . $importid);
		$code_lot=++$importrec['LOG_ID'];
		$importrec2=$importrec;
		unset($importrec2['ID']);
		unset($importrec2['FILE_C']);
		unset($importrec2['FILE_CEXCEL']);
		unset($importrec2['FILE_CDELIM']);
		unset($importrec2['CDATE']);
		unset($importrec2['MDATE']);
		unset($importrec2['USERNAME']);
		unset($importrec2['TYPE']);
		unset($importrec2['IF_DUPLICATE']);
		unset($importrec2['IF_UTF8']);
		unset($importrec2['FIELD_DELIM']);
		unset($importrec2['NEWTABLECODE']);
		unset($importrec2['FILE_CDELIM']);
		unset($importrec2['VERSION']);
		unset($importrec2['DESCRIPTION']);
		unset($importrec2['FIELD_DELIM']);
		unset($importrec2['FIELD_CDELIM']);
		unset($importrec2['RECORD_PROP']);
		unset($importrec2['RECORD_CPROP']);
		unset($importrec2['FILE']);
		unset($importrec2['FILE_EXCEL']);
		unset($importrec2['FILE_DELIM']);
		unset($importrec2['NEWTABLECODE']);
		unset($importrec2['EXCEL_TYPE']);
		ClxCommon::$db->updateRecord($this->tablename, $importrec2, 'ID=' . $importid);


		$importrec["RECORD_PROP"]=json_decode($importrec["RECORD_PROP"],true);
		$importrec["RECORD_CPROP"]=json_decode($importrec["RECORD_CPROP"],true);
//$importrec["FIELD_DELIM"]=json_decode($importrec["FIELD_DELIM"],true);
//$importrec["FIELD_CDELIM"]=json_decode($importrec["FIELD_CDELIM"],true);

		$importcode = $importrec['IDCODE'];
		$tablecode = $importrec['TABLECODE'];
		$DBIU=new db_import_run();
		$DBIU->basicFields($record['TABLECODE']);
		$this->import_extra_fields_required=$DBIU->import_extra_fields_required;
		$insertfields=explode(",",$this->import_extra_fields_required);

		$insertfields2=explode(",",$this->import_extra_fields_required);
		$mappings = $this->getMappings($importcode);
		$mappings2 = $this->getMappings($importcode,true);
		foreach ($mappings as $key=>$value) {
			$insertfields2[]=$key;
		}

		$this->compileCodeFormulas($importcode);
		$tablerec = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE=' . singleQuote($tablecode));
		$tablename = $tablerec['MODULECODE'] . '_' . $tablerec['IDNAME'];
		//ClxCommon::$db->deleteRecords('CLX_DB_IMPORT_ERRORS', 'IMPORTCODE=' . singleQuote($importcode));

		$restrictions= $this->getRestriction($importcode);
		$formulas = $this->getFormulas($importcode);
		$translations = $this->getTranslations($importcode, $mappings);
		$exceptions = $this->getExceptions($importcode);
		$field_records = $this->getTableFieldRecords($tablecode);
		$field_derived = $this->getDerivedFields($tablecode);
		$required_fields = $this->getTableRequiredFields($tablecode);
		//Search Indexes
		$DBTI = &getTool('DBTI');
		$commit_count = CLX_INIT_ZERO;
		$imported_records = CLX_INIT_ZERO;
		$updated_records = CLX_INIT_ZERO;

		$created_records = CLX_INIT_ZERO;
		$count_fields=CLX_INIT_ZERO;
		$rline=CLX_INIT_ZERO;

		$ignored_records = CLX_INIT_ZERO;
		$ignored_records2 = CLX_INIT_ZERO;
		$cdatecomunerror	= xFormat::getNow('Y-m-d H:i:s');
		ClxCommon::$db->executequery('UPDATE CLX_DB_IMPORT_EXECUTIONS SET LOG_ID='.singlequote($code_lot).' WHERE ID = ' . $batch_log_id);
		ClxCommon::$db->executequery('commit');
		if ($this->debug==true) {echo $b='update executions 4890';pre($sql);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).$sql,true); fclose($tta);}}

		if (!$this->validar_tabla($mappings2, $field_records,$field_derived,$tablename,$importcode,$code_lot,$cdatecomunerror)) {
			$saved_errors=1;
			$line=1;
			$record = array();
			$record['IMPORTCODE'] = $importcode;
			$record['RECORD_QTY'] = $imported_records;
			$record['CDATE'] = xFormat::getNow('Y-m-d H:i:s');
			$record['OWNERCODE'] = $_SESSION['user_record']['username'];
			$record['DESCRIPTION'] = dict('CLX_USER_SIST_O').(stripos(' '.PHP_OS,'WIN')>0 ? '' : posix_getpwuid(posix_geteuid())['name']).'<br>'.chr(13).chr(10).$description;
			$record['FILENAME'] = $original_filename;
			$record['OBSERVATION'] = 'IP SERVER:'.(ISSET($_SERVER['SERVER_ADDR'])? $_SERVER['SERVER_ADDR'] : $_SERVER['LOCAL_ADDR']).' SERVER NAME:'.(EMPTY($_SERVER['SERVER_NAME'])? $_SERVER['COMPUTERNAME']:$_SERVER['SERVER_NAME'] );
			$record['LOG_ID']=$code_lot;
			$record['STATUS']='ACT';
			//   - Caso 1002490 - CLX-Herr IMPORT Batch
			// Separates created record counter from record processed counter
			$result_msg0 = dict('TOOL_DBIM_IMPORT_COMPLETE', $saved_errors, 0, $ignored_records,$ignored_records2, $updated_records, $created_records);

			$this->saveErrors($importcode, $line, array('File'=>dict("GEN_LBL_NOT_TABLE_VALID")), $saved_errors,$code_lot,$cdatecomunerror,$test);

			if ($batch_log_id == CLX_NUM_ZERO) {
				$record['DESCRIPTION'] = $result_msg0 . '<br>' . CLX_CHAR_NL . $record['DESCRIPTION'];
				ClxCommon::$db->createRecord('CLX_DB_IMPORT_EXECUTIONS', $record, false);
				if ($this->debug==true) {echo $b= 'createrecord executions 4913';pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}
			} else {
				unset($record['CDATE'], $record['OWNERCODE']); //just keep from batch
				ClxCommon::$db->updateRecord('CLX_DB_IMPORT_EXECUTIONS', $record, 'ID = ' . $batch_log_id);
				if ($this->debug==true) {echo $b= 'updaterecord executions in 4917';pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}
			}
			ClxCommon::$db->executequery('commit');
			$errors_link = '';
			if ($saved_errors > CLX_NUM_ZERO) {
				$errors_link = '<a href="tool.php?to=' . $this->code . '&ac=DISPLAY&idlist=' . $importid . '">' .
				dict('GEN_LBL_DISPLAY') . ' ' . dict('GEN_LBL_ERRORS') . '</a>';
			}

			$note = note($result_msg0 . '<br>' . $errors_link, dict('GEN_LBL_OK'));
			$table = new htmlTable(CLX_WIDTH_TWO);
			if (!empty($show_file)) {
				$c = new htmlButtonCancel(dict('GEN_LBL_RETURN'));
				$qty_fields=count($mappings);
				$table->addCell($c->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => $qty_fields));
				return $note . '<Br>' . $table->source();
			} else {
				//return note(dict('TOOL_DBIM_IMPORT_COMPLETE', $saved_errors, $fd->num_records), dict('GEN_LBL_OK'));
				return $note;
			}
		}
		if (!empty($show_file)) {
			$ignore = CLX_INIT_ZERO;
			$qty_fields=count($mappings);
			foreach ($mappings as $table_fieldname => $info) {
				if ($info['TYPE'] === 'IGNR') {
					$ignore++;
				}
			}
			$table = new htmlTable($qty_fields - $ignore);
			$table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
			$table->addCell(dict('GEN_LBL_FILE_CONTENTS'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => $qty_fields));
			foreach ($mappings as $table_fieldname => $info) {
				if ($info['TYPE'] !== 'IGNR') {
					$table->addCell($info['TABLE_FIELDNAME'], array(CLX_PROP_CLASS => CLX_CLASS_HEADERS));
				}
			}
		}

		$indx = $DBTI->getTableIndexes($tablecode, 'UNI');
		$indx2 = ClxCommon::$db->getTableByIndexes($tablecode, 'UNI');
		//pre($indx);
		//pre($indx2);
		//die;
		$indx_crit = array();
		foreach ($indx as $key => $val) {
			$fields = explode(',', $val['FIELDNAME']);
			foreach ($fields as $v) {
				$indx_crit[$key][] = $v . ' = ' . singleQuote('!' . $v);
			}
		}
		$crit_sql = '';
		$comma = '';
		foreach ($indx_crit as $key => $val) {
			$crit_sql .= $comma . ' (' . implode(' AND ', $val) . ') ';
			$comma = ' AND ';
		}
		$qty_fields = count($mappings);
		//$record_prop=(empty($importrec['RECORD_PROP']))? '' :json_decode($importrec['RECORD_PROP'],true);
		$from=$to=0;
		$recordlotcreate=0;
		$encodedetect="X";
		if ($importrec['TYPE'] === 'CSV') {
			require_once'classes/clx_file_delimited.php';
			$record_delim = replace_ascii_chars($importrec['RECORD_DELIM']);
			$field_delim = $importrec['FIELD_DELIM'];
			$field_cdelim = $importrec['FIELD_CDELIM'];
			$fileread=UserRequest::$files['DBIM_file']['tmp_name'];
			$this->writeziptotext();
			$a=fopen($fileread,"r");
			$encodedetect=mb_detect_encoding(fread($a,$archivotext=filesize($fileread)), "auto");
			fclose($a);
			if (empty($encodedetect)) {
				$this->saveErrors($importcode, $rline, array('File'=>dict("GEN_LBL_NOTANSIORUTF8")), $saved_errors,$code_lot,$cdatecomunerror,$test);
			}


			$fd = new clx_file_delimited($fileread, $record_delim, $field_delim);
			IF ($this->debug==true) {
				pre('import de entrada6');
				pre($fd);
				pre($fileread);
				pre('--------xxx----------');
			}
			$col=0;

			IF (!empty($importrec['RECORD_PROP'][$col])){
				$from=$to=$importrec['RECORD_CPROP'][$col];
			}
			IF (!empty($importrec['RECORD_PROP'][$col+1]) and   $importrec['RECORD_CPROP'][$col+1]>=$from) {
				$to=$importrec['RECORD_CPROP'][$col+1];
			}

		} elseif ($importrec['TYPE'] === 'FRL') {
			require_once'classes/clx_file_fixed_record_length.php';
			$fileread=UserRequest::$files['DBIM_file']['tmp_name'];
			$a=fopen($fileread,"r");
			$encodedetect=mb_detect_encoding(fread($a,$archivotext=filesize($fileread)), "auto");
			fclose($a);
			$this->writeziptotext($archivo_text);

			if (empty($encodedetect)) {
				$texto='';
				$this->saveErrors($importcode, $rline, array('File'=>dict("GEN_LBL_NOTANSIORUTF8")), $saved_errors,$code_lot,$cdatecomunerror,$test);
				$texto=array('File'=>dict("GEN_LBL_NOTANSIORUTF8"));
			}
		/// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - BEGIN
			$record_delim = replace_ascii_chars($importrec['RECORD_DELIM']);
			//$record_length = $importrec['RECORD_LENGTH'];
			$record_length = intval($importrec['RECORD_LENGTH']) + mb_strlen($record_delim, kDefaultEncoding);
// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - END
			$fd = new clx_file_fixed_record_length($fileread, $record_length);
// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - BEGIN
			// It's fixed lenght, but reads only until EOL character, to avoid cases of not so fixed lenght files like IBS's




			if($record_delim != '') {
				$this->use_record_delimiter_reading_fixlen_files = true;
			}
			if ($this->use_record_delimiter_reading_fixlen_files === true) {
				$fd->line_delim = $record_delim;
			}
// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - END
		} elseif ($importrec['TYPE'] === 'XLS') {

			require_once(kPathToSimpleExcel.'/php-excel-reader/excel_reader2.php');
			require_once(kPathToSimpleExcel.'/SpreadsheetReader.php');

			return $this->readExcel($test,$importcode,$tablecode,$importid,$show_file, $mappings,$restrictions,$exceptions,$translations,$formulas,$tablerec,$tablename,$field_records,$importrec,$code_lot,$batch_log_id,$cdatecomunerror,$error_limit);


		} else {
			return note(dict('TOOL_DBIM_INVALID_FILE_TYPE') . ' ' . $importrec['TYPE'], dict('GEN_LBL_OK'));
		}
		if (empty($test)) {
			//Running Events
			$evnt_msg = array();
			$EVNT = &getTool('EVNT');
			$EVNT->execute5('DBIM', $importrec['ID'], 'INPR', $savepost, $evnt_msg); //  Events Pre Import
		}
		//convertToString($field_text,$Rule,$capturehtml=false)
		$read_fields=array();
		$detect=true;
		$file_fieldnames=array();
		if (!empty($encodedetect)) {
			$RARD = getToolObject('ACTN', 'RARD');
			while (!$fd->EOF) {
				$rline++;
				$buffer = $this->input_line_encoding_detect($fd->getNextRecord2($importrec['IF_UTF8']));
				if (empty($this->s_input_line_encoding_detect2)) {
					$this->saveErrors($importcode, $rline, array('File'=>dict("GEN_LBL_NOTANSIORUTF8")), $saved_errors,$code_lot,$cdatecomunerror,$test);
					break;
				}

				if (count($restrictions)>0) {
					$restrict=$this->apply_Restriction($restrictions,$buffer,$rline);
					if ($restrict) {
						$ignored_records2++;
						continue;
					}
				}

				if ($importrec['TYPE'] === 'CSV') {
					if ($detect) {
						$this->parsertextdetect($buffer, $field_delim, $field_cdelim );
						$detect=false;
					}
					$parserline= $this->parsertext($buffer);
				}
				$count_fields=count($parserline);
				if (strlen(trim($buffer)) == CLX_NUM_ZERO) {
					$ignored_records2++;
					continue;
				}
				if ($from>=$rline and $rline<=$to) {
					foreach ($parserline as $key=>$field) {
						$read_fields[$key] = ((empty($read_fields[$key])) ? " ": $read_fields[$key]) . $field;
					}
				}
				if ($rline>$to) {
					if ($importrec['TYPE'] === 'CSV' && count($file_fieldnames)==0) {
						if (count($read_fields)==0) {
							for ($key=0;$key<$count_fields;$key++) {
								$file_fieldnames[$key]= "(".dict('GEN_LBL_COLUMN')." [".($key+1).'])';
							}
						}
						else {$wcol=0;
							foreach ($read_fields as $key=>&$field) {
								$field=trim($field);
							}
							$file_fieldnames=$read_fields;
						}
					}
					$validate_record = array();

					if ($commit_count == $this->record_commit_counter) {
						$commit_count = CLX_INIT_ZERO;
						ClxCommon::$db->commit();
					}
					$commit_count++;

					if ($commit_count == $this->record_commit_counter) {
						$commit_count = CLX_INIT_ZERO;
						ClxCommon::$db->commit();
					}
					$commit_count++;

					$record = array();
					$errors = false;
					$class = ($fd->num_records % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT;
					if ($this->isException($exceptions, $buffer)) {
						if (!empty($show_file)) {
							$table->addCell(dict('GEN_LBL_RECORD_NOT_IMPORTED'), array(CLX_PROP_CLASS => $class, CLX_PROP_COLSPAN => $qty_fields));
						}
					} else {
						foreach ($mappings as $table_fieldname => $info) {
							$field_value = '';

							if ($info['TYPE'] !== 'IGNR') {
								if ($info['TYPE'] === 'FIX'  and ($info['START_POSITION']>0 or $info['FIELD_LENGTH']>0))  {
	// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - BEGIN
								//$field_value = trim(substr($buffer, $info['START_POSITION']-1, $info['FIELD_LENGTH']));
								////$field_value = substr($buffer, $info['START_POSITION'] + CLX_NUM_ONE, $info['FIELD_LENGTH']);


									if (empty($info['RULE_TEXT'])) {
										$field_value = trim(substr($buffer, $info['START_POSITION'], $info['FIELD_LENGTH']));
									}
									else {
										$field_value =$this->convertToString($buffer,json_decode($info['RULE_TEXT']),false,false,false);
									}

	// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - END
								} else if ($info['TYPE'] === 'FILE') {
									$i = array_search($info['FILE_FIELDNAME'], $file_fieldnames);

									$field_value = ($i !== false && array_key_exists($i, $parserline)) ? $parserline[$i] : null;
									if (!empty($info['RULE_TEXT']))
										$field_value =$this->convertToString($field_value,json_decode($info['RULE_TEXT']),false,false,false);
								} elseif ($info['TYPE'] === 'CALC') {
									$field_value = $this->executeConstants($info, $parserline, $buffer);
								} elseif ($info['TYPE'] === 'FORM') {
									$i = array_search($info['FILE_FIELDNAME'], $file_fieldnames);
									$field_value = ($i !== false && array_key_exists($i, $parserline)) ? $parserline[$i] : '';
								}


								//SETTING RIGHT ENCODING
								$field_value = encode_string($field_value, kDefaultEncoding);
								$field_value = trim($field_value);
								//  FS - Caso 1002490 - CLX-Herr IMPORT Batch
								// Quote processing optimization to avoid PHP to hangs processing imports like FIAE
								//Eliminar enclosing de comillas de existir
								$lgth = mb_strlen($field_value);
								if ($lgth > CLX_NUM_ONE && mb_substr($field_value, CLX_NUM_ZERO, CLX_NUM_ONE) == CLX_CHAR_SINGLE_QUOTE && mb_substr($field_value, CLX_NUM_MINUS_1) == CLX_CHAR_SINGLE_QUOTE) {
									$field_value = mb_substr($field_value, CLX_NUM_ONE, $lgth - CLX_NUM_TWO);
								}
								if (!empty($translations)&&(array_key_exists(uppercase($field_value), $translations))) {
									$this->translate($field_value, $translations[$table_fieldname]);
								}
								$record[$table_fieldname] = str_ireplace(str_repeat(singleQuote(CLX_CHAR_EMPTY_STRING), CLX_NUM_THREE), singleQuote(CLX_CHAR_EMPTY_STRING), $field_value);
								//adding entry for validation
							}
							else {
							//	ECHO '-----------------<br>';
							//	pre($table_fieldname);
							//	ECHO '-----------------<br>';
								if (in_array($table_fieldname, $this->fieldnotignr)) {
								//	ECHO 'INCLUDE_EXTRA2X,'.$table_fieldname;
									$record[$table_fieldname] ='';
								}
							}


						}
						foreach ($formulas as $key => $val) {
							ClxFreeReturn($this->executeFormula($val, $record));
						}

						//constructing record tablecode_fieldname forma. must be done after formulas to pass values to validate events on table.
						foreach ($mappings as $table_fieldname => $info) {
							if ($info['TYPE'] !== 'IGNR') {
								//adding entry for validation
								$validate_record[$tablerec['IDCODE'] . '_' . $table_fieldname] = $record[$table_fieldname];
							}
						}
						$msg = array();
						foreach ($record as $key => $val) {
							$fieldrec = $field_records[$key];
							$fieldinstance = getToolObject('DBFT', $fieldrec['FIELDTYPE']);
							if ($record[$key] === '') {
								if ($fieldrec['FIELDTYPE'] === 'BOOL') {
									$record[$key] = ($fieldrec['FIELD_DEFAULT']) ? CLX_NUM_ONE : CLX_NUM_ZERO;
									$val = $record[$key];
								} elseif (empty($required_fields[$key])) {
									$record[$key] = 'null';
									$val = $record[$key]; //notar $val que es lo que se pasa a la validacion
								}
							}
							$fieldinstance->validateImportField($msg, $fieldrec, $val);
						}
						$imported_records++;
						//Run table Validate events
						if($validate_record['FIAT_TRANSTBL_CODE'] == '')$validate_record['FIAT_TRANSTBL_CODE'] = $transaction[1];
						UserRequest::$post = $validate_record;
						$EVNT->execute5('DBTB', $tablerec['ID'], 'VREC', $validate_record, $msg); //  Validate Record
						unset($validate_record);
						foreach($record as $key => $val) {
							if (!empty($msg[$key])) {
								if (strlen($val)>20)
									$val="(".substr($val,0,20).'...'.")";
								else
									$val="(".$val.")";
								$msg[$key].='<font style=\'font-weight:800;color:#ff0000\'>'.$val.'</font>';

							}
						}

						//Reporting Errors
						//   - Caso 1002490 - CLX-Herr IMPORT Batch
						// Se habilita la posibilidad de especificar REPORTE SIN LIMITE de errores
						if ((count($msg) > CLX_NUM_ZERO) && ($saved_errors < $error_limit || $error_limit == CLX_NUM_ZERO)) {
							$this->saveErrors($importcode, $fd->line_num, $msg, $saved_errors,$code_lot,$cdatecomunerror,$test);
						}
						$errors = ($errors or ( count($msg) > CLX_NUM_ZERO));
						if (!empty($show_file)) {
							foreach ($record as $val) {
								$table->addCell($val, array(CLX_PROP_CLASS => $class));
							}
						}
						if (empty($test) && empty($errors)) {
							if (ISSET($record['IDCODE']) and $record['IDCODE']=='AUTO' ) {
								$RARD->setCreationIdCode($record, $tablecode);
							}
							//Check for duplicates
							if (strlen($crit_sql) > CLX_NUM_ZERO) {
								$sql = $crit_sql;
								foreach ($record as $key => $val) {
									$sql = str_replace('!' . $key, $val, $sql);
								}
								$count = ClxCommon::$db->countRecords($tablename, $sql);
							} else {
								$count = CLX_INIT_ZERO;
							}
							foreach ($field_derived as $key => $val) {
								unset($record[$key]);
							}
							//Adding
						//  $record['BATCH_ID']=$batch_log_id;

							if (in_array('LOG_ID',$insertfields))
								$record['LOG_ID']=$code_lot;
							if (in_array('LINE_OF_LOG_ID',$insertfields))
								$record['LINE_OF_LOG_ID']=$rline;
							if (in_array('IMPORTSHEETS',$insertfields))
								$record['IMPORTSHEETS']='';
							if (in_array('IMPORTCODE',$insertfields))
								$record['IMPORTCODE']=$importrec['IDCODE'];
							if (in_array('MODIFIEDBY',$insertfields2))
								$record['MODIFIEDBY']   = $_SESSION['user_record']['username'];
							if (in_array('MDATE',$insertfields2))
								$record['MDATE']		= xFormat::getNow('Y-m-d H:i:s');


							if ($count == CLX_NUM_ZERO) {
								//Generar transacciones
								foreach ($transaction as $transVal) {
									//pre($transVal);
									$record['TRANSTBL_CODE']=$transVal;
									$record['IDCODE'] = 'AUTO';
									$EVNT->execute("DBTB", $tablerec["ID"], "CREP", $record, $msg); //  Create Record (pre database commit)
									if (in_array('CREATEDBY',$insertfields2))
										 $record['CREATEDBY']	= $_SESSION['user_record']['username'];
									if (in_array('CDATE',$insertfields2))
										$record['CDATE']		= xFormat::getNow('Y-m-d H:i:s');

									ClxCommon::$db->createRecord($tablename, $record, false);
									$EVNT->execute5('DBTB', $tablerec['ID'], 'CREC', $record, $msg); //  Create Record (post database commit)
									if ($this->debug==true) {echo $b= 'createrecord executions in '.__LINE__;pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}
								}
								//   - Caso 1002490 - CLX-Herr IMPORT Batch
								// Separates created record counter from record processed counter
								$created_records++;
							} elseif ($count > CLX_NUM_ZERO && $importrec['IF_DUPLICATES'] == CLX_NUM_ONE) {
								unset($record['ID']); //solo por si existe campo
								$EVNT->execute5('DBTB', $tablerec['ID'], 'UREP', $record, $msg); //  Update Record (pre database commit)
								ClxCommon::$db->updateRecord($tablename, $record, $sql);
								$EVNT->execute5('DBTB', $tablerec['ID'], 'UREC', $record, $msg); //  Update Record (post database commit)
								$updated_records++;
							} else {
								$ignored_records++;
							}
						} else {
							$ignored_records++;
						}

					}
				}
			}
		}
		$fd->close();
		if (empty($test)) {
			//  Events Post Import
			$EVNT->execute5('DBIM', $importrec['ID'], 'INPO', $savepost, $evnt_msg);
		}
		UserRequest::$get = $saveget;
		UserRequest::$post = $savepost;
		UserRequest::$request = $saverequest;
		$record = array();
		$record['IMPORTCODE'] = $importcode;
		$record['RECORD_QTY'] = $imported_records;
		$record['CDATE'] = xFormat::getNow('Y-m-d H:i:s');
		$record['OWNERCODE'] = $_SESSION['user_record']['username'];
		$record['DESCRIPTION'] = $record['DESCRIPTION'] = dict('CLX_USER_SIST_O').(stripos(' '.PHP_OS,'WIN')>0 ? '' : posix_getpwuid(posix_geteuid())['name']).'<br>'.chr(13).chr(10).$description;
		$record['FILENAME'] = $original_filename;
		$record['OBSERVATION'] = 'IP SERVER:'.(ISSET($_SERVER['SERVER_ADDR'])? $_SERVER['SERVER_ADDR'] : $_SERVER['LOCAL_ADDR']).' SERVER NAME:'.(EMPTY($_SERVER['SERVER_NAME'])? $_SERVER['COMPUTERNAME']:$_SERVER['SERVER_NAME'] );
		$record['LOG_ID']=$code_lot;
		$record['STATUS']='ACT';
		//   - Caso 1002490 - CLX-Herr IMPORT Batch
		// Separates created record counter from record processed counter
		$result_msg0 = dict('TOOL_DBIM_IMPORT_COMPLETE', $saved_errors, $fd->num_records, $ignored_records,$ignored_records2, $updated_records, $created_records);
		if ($batch_log_id == CLX_NUM_ZERO) {
			$record['DESCRIPTION'] = $result_msg0 . '<br>' . CLX_CHAR_NL . $record['DESCRIPTION'];
			ClxCommon::$db->createRecord('CLX_DB_IMPORT_EXECUTIONS', $record, false);
			if ($this->debug==true) {echo $b= 'createrecord executions  5325';pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}
		} else {
			unset($record['CDATE'], $record['OWNERCODE']); //just keep from batch
			ClxCommon::$db->updateRecord('CLX_DB_IMPORT_EXECUTIONS', $record, 'ID = ' . $batch_log_id);
			if ($this->debug==true) {echo $b= 'updaterecord executions in 5329';pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}

		}
		ClxCommon::$db->executequery('commit');

		if ($saved_errors > CLX_NUM_ZERO) {
			$errors_link = '<a href="tool.php?to=' . $this->code . '&ac=DISPLAY&idlist=' . $importid . '">' .
			dict('GEN_LBL_DISPLAY') . ' ' . dict('GEN_LBL_ERRORS') . '</a>';
		} else {
			$errors_link = '';
		}
		if (!empty($test)) {
			$ignored_records = $fd->num_records;
		}
		$note = note($result_msg0 . '<br>' . $errors_link, dict('GEN_LBL_OK'));
		if (!empty($show_file)) {
			$c = new htmlButtonCancel(dict('GEN_LBL_RETURN'));
			$table->addCell($c->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => $qty_fields));
			return $note . '<Br>' . $table->source();
		} else {
			//return note(dict('TOOL_DBIM_IMPORT_COMPLETE', $saved_errors, $fd->num_records), dict('GEN_LBL_OK'));
			return $note;
		}
		 UserResponse::setRunTimeLimit($init_time_out);
		 if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1626;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");fwrite($tta,chr(13).chr(10)."db_import-hora fin de funcion import ".date("h:i:s d/m/Y").chr(13).chr(10));fclose($tta);}

	}

	function importbulk	(&$fd,&$locals_var) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}
		extract($locals_var);
		$name_procedure='PR_'.$tablename.'_bulk';
		ClxCommon::$db->bulk_insert($fd,$this,$tablename,$name_procedure);
		apc_clear_xppaging_count_all_user($tablecode);
	}
	function importnormal(&$fd,&$locals_var) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}
		unset ($locals_var['fd']);
		$debug=false;
		IF ($GLOBALS['ADDRDEBUGIMPORT'] ||$this->debug==true) {
			$debug=true;
			pre('importnormal:$fd');
			pre($fd);
		}
	//	pre($GLOBALS);
		IF (ISSET($GLOBALS['ADDRDEBUGIMPORTEXTRA']) ) {
			ECHO "INICIANDO A VER IMPORTADOR EXTRA";
		
		}
		$num_record_error=0;
		extract($locals_var);
		$read_fields=array();
		$detect=true;
		$file_fieldnames=array();
		$insertfields=explode(",",$this->import_extra_fields_required);
		IF($debug) {pre("paso1");}
		if (!empty($encodedetect)) {
			$maxNumRowFile=$fd->getNumrowMax();
			IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fwrite($kk,print_r($locals_var,true));	fwrite($kk, 'filenum:'. $maxNumRowFile);fwrite($kk, print_r($fd,true));fclose($kk);}

			$namefilebarr=kPathToWebSite.'/temp/'.str_replace('.','',$original_filename).'.barr';
			$cuentabarr=(int) ($maxNumRowFile/10);
			
			if ($cuentabarr>500)
				$cuentabarr=500;
			else if ($cuentabarr<20)
				$cuentabarr=15;
			$this->getTableFields($tablecode);
			$RARD = getToolObject('ACTN', 'RARD');
			$proxbloque=0;
			while (!$fd->EOF) {
				$rline++;
				$posact=(int)($rline*10 /$cuentabarr);
				/*if (($posact=(int)($rline*100 /$cuentabarr)) == 0 ) {
					file_put_contents($namefilebarr,$posact);
					pre('name'); pre ($namefilebarr);
				}pre('rline');pre($rline);pre($posact); 
				echo '----';*/
				if ($rline>$proximobloque) {
					file_put_contents($namefilebarr,$posact);
					$proximobloque+=$cuentabarr;
				}
				$buffer = $this->input_line_encoding_detect($fd->getNextRecord2($importrec['IF_UTF8']));
				IF($debug) {pre("paso3");}
				if (empty($this->s_input_line_encoding_detect2)) {
					$this->saveErrors($importcode, $rline, array('File'=>dict("GEN_LBL_NOTANSIORUTF8")), $saved_errors,$code_lot,$cdatecomunerror,$test);
					break;
				}
				/*if ($importrec['IF_UTF8']==1) {
					$buffer=utf8_encode($buffer);

				}*/
				if (count($restrictions)>0) {
					$restrict=$this->apply_Restriction($restrictions,$buffer,$rline);
					if ($restrict) {
						$ignored_records2++;
						continue;
					}
				}
				IF($debug) {pre("paso4");}
				$parserline='';
				if ($importrec['TYPE'] === 'CSV'||$importrec['TYPE'] === 'CSV2') {

					if ($detect) {
						$this->parsertextdetect($buffer, $field_delim, $field_cdelim );
						$detect=false;
					}

					$parserline= $this->parsertext($buffer);
				}

				$count_fields=count($parserline);
				if (strlen(trim($buffer)) == CLX_NUM_ZERO) {
					$ignored_records2++;
					continue;
				}
				if ($from<=$rline and $rline<=$to) {
					foreach ($parserline as $key=>$field) {
						$read_fields[$key] = ((empty($read_fields[$key])) ? " ": $read_fields[$key]) . $field;
					}
				}
				IF ($this->debug==true){
					pre('[valores] para obtener fieldnames de to,from,rline ');
					pre('valores de '.$to.','.$from.','.$rline );
				}

				if ($rline>$to) {IF($debug) {pre("paso5");}
					if (($importrec['TYPE'] === 'CSV'||$importrec['TYPE'] === 'CSV2') && count($file_fieldnames)==0) {
						if (count($read_fields)==0) {
							for ($key=0;$key<$count_fields;$key++) {
								$file_fieldnames[$key]= "(".dict('GEN_LBL_COLUMN')." [".($key+1).'])'	;
							}
						}
						else {$wcol=0;
							foreach ($read_fields as $key=>&$field) {
								$field=clx_change_acentos_char_html(trim($field));
							}
							$file_fieldnames=$read_fields;
						}
					}
					$validate_record = array();
					if(!defined('DBIM_COUNT_REG_IMPORT'))
						define('DBIM_COUNT_REG_IMPORT',1);
					if ($commit_count == $this->record_commit_counter*DBIM_COUNT_REG_IMPORT) {
						$commit_count = CLX_INIT_ZERO;
						ClxCommon::$db->commit();
					}
					$commit_count++;
					$record = array();
					$errors = false;
					$class = ($fd->num_records % CLX_NUM_TWO == CLX_NUM_ZERO) ? CLX_CLASS_DATA : CLX_CLASS_DATAALT;
					if ($this->isException($exceptions, $buffer)) {
						if (!empty($show_file)) {
							$table->addCell(dict('GEN_LBL_RECORD_NOT_IMPORTED'), array(CLX_PROP_CLASS => $class, CLX_PROP_COLSPAN => $qty_fields));
						}
					} else {

						foreach ($mappings as $table_fieldname => $info) {

							$field_value = '';
							IF ($debug==true) {echo 'llenando:'; pre($record);}
							if ($info['TYPE'] !== 'IGNR') {
								$field_value = '';
								if ($info['TYPE'] === 'FIX'  and ($info['START_POSITION']>0 or $info['FIELD_LENGTH']>0))  {
	// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - BEGIN
								//$field_value = trim(substr($buffer, $info['START_POSITION']-1, $info['FIELD_LENGTH']));
								////$field_value = substr($buffer, $info['START_POSITION'] + CLX_NUM_ONE, $info['FIELD_LENGTH']);


									if (empty($info['RULE_TEXT'])) {
										$field_value = trim(substr($buffer, $info['START_POSITION'], $info['FIELD_LENGTH']));
									}
									else {
										$field_value =$this->convertToString($buffer,json_decode($info['RULE_TEXT']),false,false,false);
									}

	// 2018-07-27 CR - Caso 1003704 - FICOHSA-Desar PDF Reader Oracle - END
								} else if ($info['TYPE'] === 'FILE') {
									$i = array_search($info['FILE_FIELDNAME'], $file_fieldnames);

									$field_value = ($i !== false && array_key_exists($i, $parserline)) ? $parserline[$i] : null;

									if (!empty($info['RULE_TEXT']))
										$field_value =$this->convertToString($field_value,json_decode($info['RULE_TEXT']),false,false,false);
								} elseif ($info['TYPE'] === 'CALC') {
									$field_value = $this->executeConstants($info, $parserline, $buffer);
									if ($this->debug==true) {
										echo "[[[[[[[[[[[[[[[[[[[[[[[[constante $field_value]]]]]]]]]]]";
										pre($field_value);
									}
								} elseif ($info['TYPE'] === 'FORM') {
								//	$i = array_search($info['FILE_FIELDNAME'], $file_fieldnames);
								//	$field_value = ($i !== false && array_key_exists($i, $parserline)) ? $parserline[$i] : '';
									if ($this->debug==true) {
										echo "[[[[[[[[[[[[[[[[[[[[[[[[formula  $field_value]]]]]]]]]]]";
										pre($field_value);
									}
								}



								//SETTING RIGHT ENCODING
								$field_value = encode_string($field_value, kDefaultEncoding);
								$field_value = trim($field_value);
								//  FS - Caso 1002490 - CLX-Herr IMPORT Batch
								// Quote processing optimization to avoid PHP to hangs processing imports like FIAE
								//Eliminar enclosing de comillas de existir
								$lgth = mb_strlen($field_value);
								if ($lgth > CLX_NUM_ONE && mb_substr($field_value, CLX_NUM_ZERO, CLX_NUM_ONE) == CLX_CHAR_SINGLE_QUOTE && mb_substr($field_value, CLX_NUM_MINUS_1) == CLX_CHAR_SINGLE_QUOTE) {
									$field_value = mb_substr($field_value, CLX_NUM_ONE, $lgth - CLX_NUM_TWO);
								}
								if (!empty($translations)&&(array_key_exists(uppercase($field_value), $translations[$table_fieldname]))) {
									if (!empty($translations[$table_fieldname]))
										$this->translate($field_value, $translations[$table_fieldname]);

								}

								$record[$table_fieldname] = str_ireplace(str_repeat(singleQuote(CLX_CHAR_EMPTY_STRING), CLX_NUM_THREE), singleQuote(CLX_CHAR_EMPTY_STRING), $field_value);
								//adding entry for validation
							}
							else {
							//	ECHO '-----------------<br>';
							//	pre($table_fieldname);
							//	ECHO '-----------------<br>';
								if (in_array($table_fieldname, $this->fieldnotignr)) {
								//	ECHO 'INCLUDE_EXTRA2X,'.$table_fieldname;
									$record[$table_fieldname] ='';
								}
							}


						}
						if (!empty($this->options_import['FILEDATE_REQ'])) {
							IF ($debug==true) {echo 'usando fileda_req:'; pre($formulas);}
							$record['FILEDATE_REQ']=$this->options_import['FILEDATE_REQ'];
							$record['CH_VALUE_DATE']=$this->options_import['CH_VALUE_DATE'];

						}
						$six=1;
						IF ($debug==true) {echo 'pre_formulas:'; pre($this->options_import['FILEDATE_REQ']);}
					
						foreach ($formulas as $key => $val) {
							IF ($debug==true&&$six==1) {$six=0;pre( 'reemplazo de formulas:' );}
							ClxFreeReturn($this->executeFormula($val, $record));
						}

						//constructing record tablecode_fieldname forma. must be done after formulas to pass values to validate events on table.
						$six=1;
						foreach ($mappings as $table_fieldname => $info) {
							IF ($debug==true &&$six==1) {$six=0;pre( 'creando registro par validar:' );}
							//pre($DBIU->fieldsRegTable);
							if ($info['TYPE'] !== 'IGNR' && in_array($table_fieldname,$this->fieldsRegTable)) {
								//adding entry for validation
								$validate_record[$tablerec['IDCODE'] . '_' . $table_fieldname] = $record[$table_fieldname];
							}
						}
						$msg = array();
						$six=1;
						foreach ($record as $key => $val) {
							IF ($debug==true &&$six==1) {$six=0;pre( 'ejecutando registro validateImportField:' );}
							
							$fieldrec = $field_records[$key];
							$fieldinstance = getToolObject('DBFT', $fieldrec['FIELDTYPE']);
							if ($record[$key] === '') {
								if ($fieldrec['FIELDTYPE'] === 'BOOL') {
									$record[$key] = ($fieldrec['FIELD_DEFAULT']) ? CLX_NUM_ONE : CLX_NUM_ZERO;
									$val = $record[$key];
								} elseif (empty($required_fields[$key])) {
									$record[$key] = 'null';
									$val = $record[$key]; //notar $val que es lo que se pasa a la validacion
								}
							}
							$fieldinstance->validateImportField($msg, $fieldrec, $val);
						}
						$imported_records++;
						IF ($debug==true) {$six=0;pre( 'aumento de importrecord:'.$imported_records );}
							
						//Run table Validate events
						$keys_validate_record=$validate_record;
						UserRequest::$post = $validate_record;
						IF ($debug==true) {$six=0;pre( 'ejecuccion de evento de tablaa:' );}
						
						$EVNT->execute5('DBTB', $tablerec['ID'], 'VREC', $validate_record, $msg); //  Validate Record
						
						foreach($record as $key => $val) {
							if (!empty($msg[$key])) {
								if (strlen($val)>20)
									$val="(".substr($val,0,20).'...'.")";
								else
									$val="(".$val.")";
								$msg[$key].='<font style=\'font-weight:800;color:#ff0000\'>'.$val.'</font>';

							}
						}

						//Reporting Errors
						//   - Caso 1002490 - CLX-Herr IMPORT Batch
						// Se habilita la posibilidad de especificar REPORTE SIN LIMITE de errores
						IF ($debug==true && count($msg) > CLX_NUM_ZERO ) {$six=0;pre( 'msg: ('.$error_limit.') no aumenta contador salvados');pre($msg);}
						
						if ((count($msg) > CLX_NUM_ZERO) && ($saved_errors < $error_limit || $error_limit == CLX_NUM_ZERO)) {
							$this->saveErrors($importcode, $fd->line_num, $msg, $saved_errors,$code_lot,$cdatecomunerror,$test);
						}
						$errors = ($errors or ( count($msg) > CLX_NUM_ZERO));
						if (!empty($show_file)) {
							IF ($debug==true) {$six=0;pre( 'msg: no aumenta contador salvados');
								pre('count'); 
								pre('('.count($validate_record).')');
								pre($validate_record );
							}

							foreach ($validate_record as $zakey=>$zaval) {
								if (isset($keys_validate_record[$zakey])===true)		
									$table->addCell($zaval, array(CLX_PROP_CLASS => $class));
							}
						}unset($validate_record);
						if ($this->debug==true) {echo $b= 'postvalidation '.__LINE__;echo  'verification errors:',"'$errors'";}

						///pre($errors);
						if (!empty($errors)) {
							IF ($this->debug==true ||ISSET($GLOBALS['ADDRDEBUGIMPORTEXTRA']) &&$GLOBALS['ADDRDEBUGIMPORTEXTRA']==1) {
									ECHO " REGISTRO error:",$tablename;
									PRE($record);
									
									ECHO '<BR>';

							}
							
							$num_record_error++;
						}
						else if (empty($test)) {
							//Check for duplicates
							if (ISSET($record['IDCODE']) and $record['IDCODE']=='AUTO' ) {
								$RARD->setCreationIdCode($record, $tablecode);
							}

							if (strlen($crit_sql) > CLX_NUM_ZERO) {
								$sql = $crit_sql;
								foreach ($record as $key => $val) {
									$sql = str_replace('!' . $key, $val, $sql);
								}
								$count = ClxCommon::$db->oneExistsRecords($tablename, $sql);
								IF ($this->debug==true) {
									PRE("si COUNT verifica si existe: ".$count.", ".$sql);
								}
							} else {
								$count = CLX_INIT_ZERO;
							}
							foreach ($field_derived as $key => $val) {
								unset($record[$key]);
							}

//		pre($record);
							$cprecord=$record;
							foreach($cprecord as $key=>$evalue) {
								IF (!in_array($key,$this->fieldsRegTable))
									unset($record[$key]);
							}
				//			//echo 'yy';



							//Adding
							if (in_array('LOG_ID',$insertfields))
								$record['LOG_ID']=$code_lot;
							if (in_array('LINE_OF_LOG_ID',$insertfields))
								$record['LINE_OF_LOG_ID']=$rline;
							if (in_array('IMPORTSHEETS',$insertfields))
								$record['IMPORTSHEETS']='';
							if (in_array('IMPORTCODE',$insertfields))
								$record['IMPORTCODE']=$importrec['IDCODE'];
							IF ($this->debug==true || ISSET($GLOBALS['ADDRDEBUGIMPORTEXTRA']) &&$GLOBALS['ADDRDEBUGIMPORTEXTRA']==1) {
								ECHO "PRECREANDO REGISTRO:",$tablename;
								PRE($record);
								ECHO "COUNT:",$count;
								ECHO '<BR>';

							}
							$DBIU=new db_import_run();
		
							$DBIU->changefiledatereq($record);
							if ($this->debug==true) {echo $b= 'precreaterecord data in '.__LINE__;echo  'count:',"'$count'";}

							if ($count == CLX_NUM_ZERO) {
								if ($this->debug==true) {
									pre('creando insert en record');
								}	
								$EVNT->execute5('DBTB', $tablerec['ID'], 'CREP', $record, $msg); //  Create Record (pre database commit)
								if (in_array('CREATEDBY',$insertfields))
									$record['CREATEDBY'] 	= $_SESSION['user_record']['username'];
								if (in_array('MODIFIEDBY',$insertfields))
									$record['MODIFIEDBY'] 	= $_SESSION['user_record']['username'];
								if (in_array('CDATE',$insertfields))
									$record['CDATE'] 		= xFormat::getNow('Y-m-d H:i:s');
								if (in_array('MDATE',$insertfields))
									$record['MDATE'] 		= xFormat::getNow('Y-m-d H:i:s');
								IF ($this->debug==true ||ISSET($GLOBALS['ADDRDEBUGIMPORTEXTRA']) &&$GLOBALS['ADDRDEBUGIMPORTEXTRA']==1) {
									ECHO "PRECREANDO REGISTRO SIGUE:",$tablename;
									PRE($record);
									ECHO "DBIM_COUNT_REG_IMPORT:",DBIM_COUNT_REG_IMPORT;
									ECHO "'",DEFINED(DBIM_COUNT_REG_IMPORT),"',";
									ECHO '<BR>';

								}
								
								if ($this->debug==true ||defined('DBIM_COUNT_REG_IMPORT') && DBIM_COUNT_REG_IMPORT>=1 || !defined('DBIM_COUNT_REG_IMPORT') ) {
									IF ($this->debug==true || ISSET($GLOBALS['ADDRDEBUGIMPORTEXTRA']) &&$GLOBALS['ADDRDEBUGIMPORTEXTRA']==1) {
										ECHO "CREANDO REGISTRO:",$tablename;
											PRE($record);
									}
									ClxCommon::$db->createRecord($tablename, $record, false);
									$EVNT->execute5('DBTB', $tablerec['ID'], 'CREC', $record, $msg); //  Create Record (post database commit)
									$created_records++;
									if ($this->debug==true) {echo $b= 'createrecord data in '.__LINE__;pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}
								}
								else {
									IF ($this->debug==true ||ISSET($GLOBALS['ADDRDEBUGIMPORTEXTRA']) &&$GLOBALS['ADDRDEBUGIMPORTEXTRA']==1) {
										ECHO "CREANDO REGISTRO MULTI:",$tablename;
											PRE($record);
									}	
									$recordsall[]=$record;
									if 	(DBIM_COUNT_REG_IMPORT==count($recordsall)) {

										ClxCommon::$db->MulticreateRecord($tablename, $recordsall, false);
										foreach($recordsall as $record){
											$EVNT->execute5('DBTB', $tablerec['ID'], 'CREC', $record, $msg); //  Create Record (post database commit)
										}
										$created_records+=DBIM_COUNT_REG_IMPORT;
										$recordsall=array();
									}

								}
								//   - Caso 1002490 - CLX-Herr IMPORT Batch
								// Separates created record counter from record processed counter

								IF (!empty($GLOBALS['ERRORPROCESOBUG'])) {++$saved_errors;

									$result_msg0 = dict('TOOL_DBIM_IMPORT_ERROR_RUN');

									$this->call_error_or_description_debug($importcode,$original_filename,$fileread,$rline,$result_msg0,$idrecordexecutions,$fd->num_records,$saved_errors,$code_lot,$cdatecomunerror,$imported_records,$fd->num_records,$decription,$test,$timex,$num_record_error) ;
								}
								else {

								}
							} elseif ( $count > CLX_NUM_ZERO && $importrec['IF_DUPLICATES'] == CLX_NUM_ONE) {
								if ($this->debug==true) {
									pre('creando update en record');
								}	
								IF (ISSET($GLOBALS['ADDRDEBUGIMPORTEXTRA']) &&$GLOBALS['ADDRDEBUGIMPORTEXTRA']==1) {
										ECHO "UPDATE REGISTRO:",$tablename;
											PRE($record);
								}	
								unset($record['ID']); //solo por si existe campo
								if (in_array('MODIFIEDBY',$insertfields))
									$record['MODIFIEDBY'] 	= $_SESSION['user_record']['username'];
								if (in_array('MDATE',$insertfields))
									$record['MDATE'] 		= xFormat::getNow('Y-m-d H:i:s');
								$EVNT->execute5('DBTB', $tablerec['ID'], 'UREP', $record, $msg); //  Update Record (pre database commit)
								ClxCommon::$db->updateRecord($tablename, $record, $sql);
								$EVNT->execute5('DBTB', $tablerec['ID'], 'UREC', $record, $msg); //  Update Record (post database commit)
								IF (!empty($GLOBALS['ERRORPROCESOBUG'])) {++$saved_errors;
									$this->call_error_or_description_debug($importcode,$original_filename,$fileread,$rline,$result_msg0,$idrecordexecutions,$fd->num_records,$saved_errors,$code_lot,$cdatecomunerror,$imported_records,$fd->num_records,$description,$test,$timex,false,$num_record_error) ;
								}
								else {
									$updated_records++;
								}
							} else {
								$ignored_records++;
							}
						} else {
							IF ($this->debug==true ||ISSET($GLOBALS['ADDRDEBUGIMPORTEXTRA']) &&$GLOBALS['ADDRDEBUGIMPORTEXTRA']==1) {
									ECHO " REGISTRO ignorado test:",$tablename;
									PRE($record);
									
									ECHO '<BR>';

							}
							$ignored_records++;
						}

					}
				}
			}
			if (count($recordsall)>0) {
				ClxCommon::$db->MulticreateRecord($tablename, $recordsall, false);
				foreach($recordsall as $record){
					$EVNT->execute5('DBTB', $tablerec['ID'], 'CREC', $record, $msg); //  Create Record (post database commit)
				}
				$created_records+=count($recordsall);
				ClxCommon::$db->executequery('commit');
				IF (!empty($GLOBALS['ERRORPROCESOBUG'])) {++$saved_errors;
					$result_msg0 = dict('TOOL_DBIM_IMPORT_ERROR_RUN');
					$this->call_error_or_description_debug($importcode,$original_filename,$fileread,$line_num,$result_msg0,$idrecordexecutions,$fd->num_records,$saved_errors,$code_lot,$cdatecomunerror,$imported_records,$description,$test,$timex,$num_record_errors);
				}
				else {

				}

			}
		}
		$fd->close();
		$kk=fopen('temp/saldebugIMP2.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fwrite($kk,$namefilebarr);fclose($kk);
		file_put_contents($namefilebarr,100);

		if (empty($test)) {
			//  Events Post Import
			$EVNT->execute5('DBIM', $importrec['ID'], 'INPO', $savepost, $evnt_msg);
		}
		UserRequest::$get = $saveget;
		UserRequest::$post = $savepost;
		UserRequest::$request = $saverequest;
		$record = array();
		$record['IMPORTCODE'] = $importcode;
		$record['RECORD_QTY'] = $imported_records;
		$record['CDATE'] = xFormat::getNow('Y-m-d H:i:s');
		$record['OWNERCODE'] = $_SESSION['user_record']['username'];
		$record['DESCRIPTION'] =  dict('CLX_USER_SIST_O').(stripos(' '.PHP_OS,'WIN')>0 ? '' : posix_getpwuid(posix_geteuid())['name']).'<br>'.chr(13).chr(10).$description;
		$record['FILENAME'] = $original_filename;
		$record['OBSERVATION'] = 'IP SERVER:'.(ISSET($_SERVER['SERVER_ADDR'])? $_SERVER['SERVER_ADDR'] : $_SERVER['LOCAL_ADDR']).' SERVER NAME:'.(EMPTY($_SERVER['SERVER_NAME'])? $_SERVER['COMPUTERNAME']:$_SERVER['SERVER_NAME'] );
		$record['LOG_ID']=$code_lot;
		$record['STATUS']='ACT';

		if (!empty($importrec['FILEDATE_REQ'])) {
			$record['FILEDATE_REQ']=$importrec['FILEDATE_REQ'];
			$record['CH_VALUE_DATE']=$importrec['CH_VALUE_DATE'];
		}
		if ($this->debug==true) {
			echo $b='llamada creation_executions_description_status '. __LINE__;
			PRE('ID = ' . $idrecordexecutions);
		if ($this->debugescribir==true){
			$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).'ID = ' . $idrecordexecutions.chr(13).chr(10) );
		fclose($tta);}}

		if ($this->debug==true) {echo $b='llamada creation_executions_description_status  5707 ';
			PRE('ID = ' . $idrecordexecutions);
		if ($this->debugescribir==true){
			$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).'ID = ' . $idrecordexecutions.chr(13).chr(10) );
		fclose($tta);}}
		list($result_msg0,$idrecordexecutions)=$this->creation_executions_description_status($record,'',$idrecordexecutions,$saved_errors, $fd->num_records, $ignored_records,$ignored_records2, $updated_records, $created_records,$timex,'',$num_record_error);

		/*
		//   - Caso 1002490 - CLX-Herr IMPORT Batch
		// Separates created record counter from record processed counter
		if (empty($idrecordexecutions)) {
			$record['DESCRIPTION'] = $result_msg0 . '<br>' . CLX_CHAR_NL . $record['DESCRIPTION'];
			ClxCommon::$db->createRecord('CLX_DB_IMPORT_EXECUTIONS', $record, false);
			IF ($this->debug==true){
				pre('insertupdate (disyuntiva) create4');
				pre($record);
			}
		} else {
			unset($record['CDATE'], $record['OWNERCODE']); //just keep from batch
			ClxCommon::$db->updateRecord('CLX_DB_IMPORT_EXECUTIONS', $record, 'ID = ' . $idrecordexecutions);
			IF ($this->debug==true){
				pre('update (disyuntiva) update4');
				pre($record);

			}
		}
		ClxCommon::$db->executequery('commit');*/
		if ($saved_errors > CLX_NUM_ZERO) {
			$errors_link = '<a href="tool.php?to=' . $this->code . '&ac=DISPLAY&idlist=' . $importid . '">' .
			dict('GEN_LBL_DISPLAY') . ' ' . dict('GEN_LBL_ERRORS') . '</a>';
		} else {
			$errors_link = '';
		}

		if (!empty($test)) {
			$ignored_records = $fd->num_records;
		}
		$note = note($result_msg0 . '<br>' . $errors_link, dict('GEN_LBL_OK'));
		UserResponse::setRunTimeLimit($init_time_out);
	//	if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1626;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");fwrite($tta,chr(13).chr(10)."db_import-hora fin de funcion import ".date("h:i:s d/m/Y").chr(13).chr(10));fclose($tta);}


		if (!empty($show_file)) {
			$c = new htmlButtonCancel(dict('GEN_LBL_RETURN'));
			$table->addCell($c->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => $qty_fields));
			return $note . '<Br>' . $table->source();


		} else {
			//return note(dict('TOOL_DBIM_IMPORT_COMPLETE', $saved_errors, $fd->num_records), dict('GEN_LBL_OK'));
			return $note;
		}


	}

	public function getmappingsx(&$fd,&$import,&$restrictions,&$insertfields,&$options_import,$numlot,$superlot) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}
		IF ($this->debug==true) {
		   pre("-----------> ". __LINE__ .",". __METHOD__. " " ."inicio de get11mappingx");
		}
		$DBIU=new db_import_run();
		$field_counter='';
		$mappings=$import->options_import['mappings'];
		IF ($this->debug==true) {
			pre("opciones de mapeo");
			pre($mappings);
		}
		$translations=$this->options_import['translations'];
		$batch_log_id=$this->options_import['batch_log_id'];


		$filedate_req=$this->options_import['FILEDATE_REQ'];
		$ch_value_date=$this->options_import['CH_VALUE_DATE'];

		if (isset($import->options_import['importrec']) &&
			isset($import->options_import['importrec']['FILEDATE_REQ']) ) {
			$this->options_import['FILEDATE_REQ']=$filedate_req=$import->options_import['importrec']['FILEDATE_REQ'];
			$this->options_import['CH_VALUE_DATE']=$ch_value_date=$import->options_import['importrec']['CH_VALUE_DATE'];

		}
		if (in_array('LINE_OF_LOG_ID',$insertfields)) {
			$field_counter='LINE_OF_LOG_ID';
		}

		if ($this->options_import['type']=='FRL2' || $this->options_import['type']=='FRL3') {
			if ($numlot==0) {
				$cuts_options=array();
				foreach($mappings as $key=>$evalue) {
					if ($value['TYPE']!='IGNR') {
						// $cuts_options[$key]=array();
						$cuts_options[$key]['START_POSITION']=$evalue['START_POSITION'];
						$cuts_options[$key]['FIELD_LENGTH']= $evalue['FIELD_LENGTH'];
					}
				}
				$import->options_import['cuts_options']=&$cuts_options;
				$file_fieldnames=array_keys($cuts_options);
			}
			else {
				$cuts_options=$import->options_import['cuts_options'];
			}

		}
		if ($this->options_import['type']=='XLS2')
			$retorno=$fd->nextlotarray($import,$restrictions,$field_counter,$numlot,$superlot);
		else
			$retorno=$fd->parsetoarray($import,$restrictions,$field_counter,$numlot,$superlot);


		if (!$retorno)	{
		//	e cho "<br><br>,return, no reg<br><br>";
			return;
		}

		$readbuffer=$fd->bufferx;
		IF ($this->debug==true) {
			echo "valores de readbuffer<br>";
			pre($readbuffer);



		}

		if ($this->options_import['type']=='CSV2'|| $this->options_import['type']=='XLS2') {
			$maxlot=count($readbuffer);
		}
		else {
			$campos=array_keys($cuts_options);

			$maxlot=count($readbuffer[$campos[0]]);
		}

		$to=&$this->options_import['to'];
		$from=&$this->options_import['from'];
		$mappings=&$this->options_import['mappings'];
//		$maxcolumns=0;
//		foreach($mappings as $key=>$value){
//			if ($value['TYPE']<>'IGNR'){
//				$maxcolumns++;
//			}
//		}
		$code_lot=$this->options_import['code_lot'];
		$log_id=$this->options_import['log_id'];
		$importrec=&$this->options_import['importrec'];

	/*
	if ($Key+$Rowrest<=$to) {
									if ($Key+$Rowrest>=$from ) {
										foreach ($Row as $key2=>$field) {
											$file_fieldnames[$key2] = clx_change_acentos_char_html($field);

										}
									}
								}

	*/
	//		RESTORE_ERROR_HANDLER();

		if ($this->options_import['type']=='CSV2' ) {
			foreach ($mappings as $table_fieldname => $info) {
				$sheetPage=$info['IMPORTSHEETS'];
				$importcode=$info['IMPORTCODE'];
				$maxcolumns=count($mappings)+1;
				break;
			}	//pr e($this->options_import)	;
			$xfile_fields=array();
			if ($this->debug==true) {
				echo '[[[[[[[[[import en '. __LINE__ .",". __METHOD__ . " " .']]]]]]';
			}
			IF ($this->options_import['typeoriginal']=='XLS2') {
				IF ($this->debug==true) {
					echo "<b> LEIDO COMO EXCEL</b>";
					echo 'valores de variable importrec<br>';
					pre($importrec['RECORD_PROP']);
				}
				IF(isset($importrec['RECORD_PROP'][8]) and !isset($importrec['RECORD_PROP'][9]))
					$importrec['RECORD_PROP'][9]=$importrec['RECORD_PROP'][8];
				IF (!empty($importrec['RECORD_PROP'][9])) {
					IF ($this->debug==true) {
						echo "<b> comprobacion record_prop ". __LINE__ .",". __METHOD__. " " ."</b><br>";
					}
					list($xsheetName,$xfile_fields) = $this->extractFileFieldsExcel($importcode,$sheetPage,true);
					if($this->debug) {
						PRE( "extractFileFieldsExcel". __LINE__);
					}
				}
			}
			else {

				IF ($this->debug==true) {
					echo "<b> LEIDO COMO TEXTO". __LINE__ .",". __METHOD__ . " </b><br>";
					echo "valores de importrec<br>";
					pre($this->options_import['importrec']);
				}
				$field_delim=$this->options_import['importrec']['FIELD_DELIM'];
				$field_cdelim=$this->options_import['importrec']['FIELD_CDELIM'];
				$record_delim= replace_ascii_chars($this->options_import['importrec'] ['RECORD_DELIM'] );


				$xfile_fields = $this->extractFileFields($importcode, $record_delim, $field_delim, $field_cdelim,true);
				IF ($this->debug==true) {
					pre('extra fields');
					pre($xfile_fields);
				}				

			}
			IF ($this->debug==true) {
					pre('extra fields '. __LINE__ .",". __METHOD__ );
					pre($xfile_fields);
			}
			if (isset($xfile_fields) && $maxcolumns<count($xfile_fields))
				$maxcolumns=count($xfile_fields);

			//	pr e($readbuffer);
			for ($r=0;$r<=$to+10;$r++) {
				$contador=0;
				foreach($xfile_fields as $key=>$fvalue) {
					for ($t=0;$t<$maxcolumns;$t++) {
						if (!empty($readbuffer[$r][$t])) {
							if ($readbuffer[$r][$t]==$key){
								$contador++;
							}
						}
					}

				}
				IF ($this->debug==true) {
					pre('contador break de que es una fila con columnas varias con data'. __LINE__ .",". __METHOD__ );
					pre($contador);
				}
				if ($contador>4) {
					$from=$to=$r+1;
					break;
				}
			}

			IF ($this->debug==true) {
					echo "valores xfile_fields<br>";
					pre($xfile_fields);
					pre( count($xfile_fields));
					if (isset($file_fieldnames)) {
						echo "valores de file_fieldnames ". __LINE__ .",". __METHOD__ . "<br>";
						pre($file_fieldnames);

					}
					else
						echo "<b><p bgcolor=red>====> advertencia, no [file fieldnames var con valor] en import todavia ". __LINE__ .",". __METHOD__ . "</p>";

					echo "valores de read_buffer<br>";
					pre($readbuffer);
			}

			IF ($this->debug==true) {
				echo 'previo a verificar numlot o superlot '. __LINE__ .",". __METHOD__ . '<br>';
			
					pre('[valores] para obtener numlot y superlot ');
					pre('valores de '.$numlot.' y '.$superlot );
					pre('[importrec]');
					pre($importrec);
			}
			if ($numlot==0 && $superlot==0) {
				IF ($this->debug==true) {
					echo 'afirmativo detro del if verificar superlot o numlot '. __LINE__ .",". __METHOD__ . '<br>';
				}
				if (empty($importrec['RECORD_PROP'])) {
					IF ($this->debug==true) {
						echo '[importrec] vacio<br>';
					}
					$maxcolumns=count($mappings)+1;
					if (isset($xfile_fields) && $maxcolumns<count($xfile_fields))
						$maxcolumns=count($xfile_fields);

					IF ($this->options_import['typeoriginal']=='XLS2') {
						IF ($this->debug==true) {
							echo 'afirmativo if de verificacion typeoriginal vs XLS2<br>';
						}
						for ($key=0;$key<$maxcolumns+1;$key++) {
							$v=((int)($key/26))*26;
							$htexCol=(($v>0)? chr(65+$v/26-1):"").chr(65+$key-$v);
							$file_fieldnames[$key]= "(".dict('GEN_LBL_COLUMN')." [".$htexCol.'])';
						}
						list($xsheetName,$xfile_fields) = $DBIU->extractFileFieldsExcel($importcode,$sheetPage,true);
						if($this->debug) {
							PRE( "extractFileFieldsExcel". __LINE__);
						}
					}
					else {
						IF ($this->debug==true) {
							echo 'falso  if de verificacion typeoriginal vs XLS<br>';
						}
						for ($key=0;$key<$maxcolumns+1;$key++) {
							$file_fieldnames[$key]= "(".dict('GEN_LBL_COLUMN')." [".($key+1).'])'	;
						}

					}


				}
				else {
					IF ($this->debug==true) {
						echo '[importrec] no vacio '. __LINE__ .",". __METHOD__ . '<br>';
					}

					$read_files=array();
					$read_files2=array();
					$maxcolumns=count($mappings)+1;
					if (isset($xfile_fields) && $maxcolumns<count($xfile_fields))
						$maxcolumns=count($xfile_fields);

					for ($t=0;$t<$maxcolumns;$t++) {
						$read_fields[$t]='';
						$read_fields2[$t]='';
					}
					//////////titulos

					IF ($this->debug==true) {
						echo " FROM para TITULOS ". __LINE__ .",". __METHOD__ . "";
						PRE($from);
						echo " FROM para TITULOS ";
						PRE($to);
						echo " read_field para TITULOS ";
						pre($readbuffer);

					}
					IF ($this->debug==true) {
						echo "variable maxcoluns ";
						pre($maxcolumns);
					}
					for ($r=$from-1;$r<=$to-1;$r++) {

						for ($t=0;$t<$maxcolumns;$t++) {
							if (!empty($readbuffer[$r][$t])) {
								$read_fields[$t].=$readbuffer[$r][$t];
								$read_fields2[$t].=$readbuffer[$r+1][$t];
							}
						}
						for ($t=0;$t<$maxcolumns;$t++) {
							if (isset($readbuffer[$r][$t]))
							unset($readbuffer[$r][$t]);
						}

					}
					IF ($this->debug==true) {
						echo "read_fields del titulo | ". __LINE__ .",". __METHOD__ . "";
						pre($read_fields);
						echo "read_fields del titulo2";
						pre($read_fields2);
					}
					//unset($readbuffer[$r]);
					foreach ($read_fields as $key=>&$field) {
						$field=clx_change_acentos_char_html(trim($field));
					}
					foreach ($read_fields2 as $key=>&$field) {
						$field=clx_change_acentos_char_html(trim($field));
					}

					$file_fieldnames=$read_fields;
					$file_fieldnames2=$read_fields2;

					$verificar_posicion1=0;
					$verificar_posicion2=0;
					IF ($this->debug==true) {
						pre('mappings'. __LINE__ .",". __METHOD__ );
						pre($mappings);
					}
					for ($r=0;$r<count($file_fieldnames);$r++){
						foreach ($mappings as $table_fieldname => $info) {
							IF (!empty($info['FILE_FIELDNAME'])){
								if ((array_search($info['FILE_FIELDNAME'],$file_fieldnames))!==false)
									$verificar_posicion1++;
								if ((array_search($info['FILE_FIELDNAME'],$file_fieldnames2))!==false)
									$verificar_posicion2++;
								IF ($this->debug==true) {
									echo "[[[[var info]]]";
									pre($info);
									pre($verificar_posicion1.','.$verificar_posicion2);
								}
							}
						}
					}
					IF ($this->debug==true) {
						echo 'verificar primera posicion con la siguiente'. __LINE__ .",". __METHOD__ . '<br>';
						pre($verificar_posicion1.'<'.$verificar_posicion2);
					}
					if ($verificar_posicion1<$verificar_posicion2) {
						$file_fieldnames=$file_fieldnames2;
						IF ($this->debug==true) {
							echo 'unset en el cambio<br>';
						}

						for ($t=0;$t<$maxcolumns;$t++) {
							unset ($readbuffer[$to+1][$t]);
						}

					}
				}

				IF ($this->debug==true) {
					echo "actual file fieldnames (TITULOS)<br>";
					pre($file_fieldnames);

				}
			//	$si=false;
				for ($t=0;$t<$maxcolumns;$t++) {
					IF (empty($file_fieldnames[$t])) {
						IF ($this->debug==true) {
							echo "unset file fieldnames: ".$t,'<br>';
						}

						unset($file_fieldnames[$t]);
			//			$si=true;
					}
				}
			//	$file_fieldnames=array_values($file_fieldnames);
				$this->options_import['file_fieldnames']=&$file_fieldnames;

			}
			else {
				IF ($this->debug==true) {
					echo "cache file fieldnames ".'<br>';
				}
				$file_fieldnames=&$this->options_import['file_fieldnames'];
			}
		}
		else if ($this->options_import['type']=='XLS2'	) {
			unset($readbuffer['joined']);
			IF ($this->debug==true) {
				echo 'afirmativo para options import (type)XLS2'. __LINE__ .",". __METHOD__ . '<br>';
			}
			$maxcolumns=count($readbuffer)-1;
			if (isset($xfile_fields) && $maxcolumns<count($xfile_fields))
				$maxcolumns=count($xfile_fields);
			IF ($this->debug==true) {
				echo "valores de maxcolumns<br>";
				echo $maxcolumns;
				echo 'previo a verificacion de numlot y superlot<br>';
			}

			if ($numlot==0 &&$superlot==0) {
				for ($t=0;$t<$maxcolumns;$t++) {
					$read_fields[$t]='';
				}
				//////////titulos
				for ($r=0;$r<=$to;$r++) {
					if ($r>=$to && $r<=$from)	{
						for ($t=0;$t<$maxcolumns;$t++) {
							if (isset($readbuffer[$t][$r])) {
								$read_fields[$t].=$readbuffer[$t][$r];
							}
						}
						for ($t=0;$t<$maxcolumns;$t++) {
							foreach ($read_fields as $key=>&$field) {
								$field=clx_change_acentos_char_html(trim($field));
							}
							$file_fieldnames=$read_fields;
						}
					}
				}
				$p=0;
				IF ($this->debug==true) {
					echo 'previo a for de lectura readbuffer<br>';
				}
				for ($t=0;$t<$maxcolumns;$t++) {
					for ($r=0;$r<=$to;$r++) {
						if($r<$from+1) {

								unset($readbuffer[$t][$r]);
						}
						unset($readbuffer['LINE_OF_LOG_ID'][$r]);
					}
					$readbuffer[$t]=array_values($readbuffer[$t]);
				}
				$readbuffer['LINE_OF_LOG_ID']=array_values($readbuffer['LINE_OF_LOG_ID']);
				$this->options_import['file_fieldnames']=&$file_fieldnames;
			}
			else {
				$file_fieldnames=&$this->options_import['file_fieldnames'];
			}
		}
		IF ($this->debug==true) {
			echo "valores de readbuffer". __LINE__ .",". __METHOD__ ;
			pre($readbuffer);



		}
		$array_valid_column=array();
		$mappings_copia=$mappings;
	//	PR E($file_fieldnames);
	//	pr e($mappings_copia);die;
	//	pr e($mappings_copia);
	
		foreach ($mappings_copia as $table_fieldname => $info) {
		//	ec ho "++++++++++++";
		//	pr e($info);
			
			if ($info['TYPE'] === 'FIX' )  {
				$valores=&$readbuffer[$table_fieldname];
				if (!empty($info['RULE_TEXT'])) {
					$rule=json_decode($info['RULE_TEXT'],false);
					unset($rule[0]);

					if (count($rule)>0) {
						$max1=count($valores);

						for ($t=0;$t<$max1;$t++) {
							$valores[$t] =$this->convertToString($valores[$t],$rule);
						}
					}
				}
				$array_valid_column[uppercase($info['TABLE_FIELDNAME'])]=$valores;

			}
			else if ($info['TYPE'] == 'FILE' ) {//p re($info['FILE_FIELDNAME']);

				IF ($this->debug==true) {
					echo "==============revisando los file_fields name vs info del mapping de una columna (campo fieldnames)". __LINE__ . " ". __METHOD__   ."===========<br>";
					PRE($file_fieldnames);
					pre("info");
					PRE ($info);

					echo '[[[[[[readbuffer]]]]'.$info['FILE_FIELDNAME'].']';

				}
				
				if (($pos=array_search($info['FILE_FIELDNAME'],$file_fieldnames))!==false) {
					if ($this->options_import['type']!='XLS2') {
						IF ($this->debug==true) {
							echo "========= IF (por NOT XLS2) ". __LINE__ . " ". __METHOD__   ."===========<br>";
						}
						$valores=array_column($readbuffer, $pos);
						$max1=count($valores);
						if (!empty($info['RULE_TEXT'])) {
							$rule=json_decode($info['RULE_TEXT'],false);

							for ($t=0;$t<$max1;$t++) {
								$valores[$t]=$this->convertToString($valores[$t],$rule,false,$this->options_import['typeoriginal']=='XLS2',$this->options_import['typeoriginal']=='XLS2');
							}
						}
						$array_valid_column[uppercase($info['TABLE_FIELDNAME'])]=$valores;
						unset($mappings_copia[$table_fieldname]);
						IF ($this->debug==true) {
							echo "========= IF (por NOT XLS2) add column ". __LINE__ . " ". __METHOD__   ."==br>";
						}

					}
					else {
						IF ($this->debug==true) {
								echo "========= else (por XLS2) ". __LINE__ . " ". __METHOD__   ."===========";
						}
						$max1=count($readbuffer[$pos]);
						if (!empty($info['RULE_TEXT'])) {
							$rule=json_decode($info['RULE_TEXT'],false);
							for ($t=0;$t<$max1;$t++) {
								$readbuffer[$pos][$t]=$this->convertToString($readbuffer[$pos][$t],$rule,false,false,false);
							}
							$array_valid_column[uppercase($info['TABLE_FIELDNAME'])]=$readbuffer[$pos];
						}
					}
				}
			}
			else if ($info['TYPE'] == 'IGNR') {
				unset($mappings_copia[$table_fieldname]);
			}

		}
		IF ($this->debug==true) {
					echo "valores de maxcolumns<br>";
					echo $maxcolumns;
					pre($array_valid_column);
		}
		foreach ($mappings_copia as $table_fieldname => $info) {
			if ($info['TYPE'] === 'CALC') {
				$maxlineas=0;
				foreach ($array_valid_column as $key=>$avalue) {
					if (is_array($avalue)) {
						$maxlineas=count($avalue);
						break;
					}
				}
				if ($maxlineas==0)
					$maxlineas=count(array_column($readbuffer, 'LINE_OF_LOG_ID'));
				//$maxcolumnas=count($readbuffer)-1;
				$valor= trim($info['FORMULA']);		   /// no hace nada   $this->executeConstants($info, '', '');
				$array_valid_column[uppercase($info['TABLE_FIELDNAME'])]=array_fill(0,$maxlineas,$valor);
			}
		}
		//pr e($array_valid_column);
		if (!empty($translations)) {
			$list_translate=array();
			foreach($translations as $key=>$bvalue){

				if (!empty($bvalue)) {
					$list_translate[$key]=array();

					foreach($bvalue as $key2=>$value2){
						$caracter=($value2['CASE_SENSITIVE']==0) ?'':'I';
						if (!isset($list_translate[$key]['ORIGINAL_VALUE'.$caracter])) {
							$list_translate[$key]['ORIGINAL_VALUE'.$caracter]=array();
							$list_translate[$key]['REPLACE_VALUE'.$caracter]=array();
						}
						$list_translate[$key]['ORIGINAL_VALUE'.$caracter][]=$value2['ORIGINAL_VALUE'];
						$list_translate[$key]['REPLACE_VALUE'.$caracter][$value2['ORIGINAL_VALUE']]='#!='.$value2['REPLACE_VALUE'].'#!=';

					}
				}
			}
			foreach ($mappings as $table_fieldname => $info) {
				if ($info['TYPE'] == 'IGNR') {
					unset($mappings[$info['TABLE_FIELDNAME']]);
					continue;
				}
				if (!empty($info['ID']) &&!empty($translations[$info['TABLE_FIELDNAME']])) {
					$str='#!='.implode('#!=',$array_valid_column[uppercase($info['TABLE_FIELDNAME'])]).'#!=';
					if (!empty($list_translate[$info['TABLE_FIELDNAME']]['ORIGINAL_VALUE'])) {
						$GLOBALS['TEXTOS']=$list_translate[$info['TABLE_FIELDNAME']]['REPLACE_VALUE'];
						$str=replace_words($list_translate[$info['TABLE_FIELDNAME']]['ORIGINAL_VALUE'],$str,'', function($v) {
							return $GLOBALS['TEXTOS']["{$v}"];
						}) ;
						$str=replace_words($list_translate[$info['TABLE_FIELDNAME']]['ORIGINAL_VALUE'],$str,'', function($v) {
							return $GLOBALS['TEXTOS']["{$v}"];
						}) ;
					}
					if (!empty($list_translate[$info['TABLE_FIELDNAME']]['ORIGINAL_VALUEI'])) {
						$GLOBALS['TEXTOS']=$list_translate[$info['TABLE_FIELDNAME']]['ORIGINAL_VALUEI'];
						$str=replace_words($list_translate[$info['TABLE_FIELDNAME']]['REPLACE_VALUE'],$str,'i', function($v) {
							return $GLOBALS['TEXTOS']["{$v}"];
						}) ;
						$str=replace_words($list_translate[$info['TABLE_FIELDNAME']]['REPLACE_VALUE'],$str,'i', function($v) {
							return $GLOBALS['TEXTOS']["{$v}"];
						}) ;

					}
					$str=substr($str,3,strlen($str)-6);
					$array_valid_column[uppercase($info['TABLE_FIELDNAME'])]=explode('#!=',$str);
				}

			}

		}

		if (in_array('LINE_OF_LOG_ID',$insertfields)) {
			if ($this->options_import['type']=='CSV2') {
				$valores=array_column($readbuffer, 'LINE_OF_LOG_ID');
			}
			else{
				$valores=$readbuffer['LINE_OF_LOG_ID'];
			}
			$array_valid_column['LINE_OF_LOG_ID']=$valores;
		}
						//	print_r($mappings_copia);


		$verificar_column=array();
		$single_column=array();
		if (in_array('BATCH_ID',$insertfields))
		$single_column['BATCH_ID']=$batch_log_id;
		if (in_array('INIT_POS',$insertfields))
		$single_column['INIT_POS']=0;

		if (in_array('LOG_ID',$insertfields))
			$single_column['LOG_ID']=$code_lot;
		if (in_array('IMPORTSHEETS',$insertfields))
			$single_column['IMPORTSHEETS']='';
		if (in_array('IMPORTCODE',$insertfields))
			$single_column['IMPORTCODE']=&$options_import['IMPORTCODE'];
		if (in_array('CREATEDBY',$insertfields))
			$single_column['CREATEDBY'] 	= $_SESSION['user_record']['username'];
		if (in_array('MODIFIEDBY',$insertfields))
			$single_column['MODIFIEDBY'] 	= $_SESSION['user_record']['username'];
		if (in_array('CDATE',$insertfields))
			$single_column['CDATE'] 		= xFormat::getNow('Y-m-d H:i:s');
		if (in_array('MDATE',$insertfields))
			$single_column['MDATE'] 		= xFormat::getNow('Y-m-d H:i:s');
		if (!empty($filedate_req) && validateDate($filedate_req, $format = 'Y-m-d')) {
			$FX=1;
			if (defined('DBIM_EXCEPT_NOT_USER_FILEDATE_REQ')) {
				$evalor=explode(",",DBIM_EXCEPT_NOT_USER_FILEDATE_REQ);
				foreach($evalor as $key=>$xv) {//pre("pos2");pre($xv);
					if($xv==$options_import['IMPORTCODE']) {
						$FX=0;
					}
				}
			}
			IF ($FX==1) {
				$arreglox=array('FILEDATE_REQ'=>$filedate_req,'CH_VALUE_DATE'=>$ch_value_date);
				$this->changefiledatereq($arreglox);
				$filedate_req=$single_column['FILEDATE_REQ']=$arreglox['FILEDATE_REQ'];

			}
		
		}
	
		//pre($options_import);
		//pre($filedate_req);
		//pre($single_column);
		$this->options_import['verificar']=$verificar_column;
		$this->options_import['single_column']=$single_column;
		if ($this->debug) {
			echo "single column";
			PRE($single_column);
		}
		$keys_array_valid_columns=array_keys($array_valid_column);
		foreach ($single_column as $key=>$fvalue) {
			if ($this->debug) {
				echo "Eliminando key repetidos de 2 fuentes";
				pre($key);
				pre($keys_array_valid_columns);
			}
			if (in_array($key,$keys_array_valid_columns)) {
				unset ($array_valid_column[$key]);
				if ($this->debug) {
					echo "Eliminando key repetidos de 2 fuentes " . __LINE__ ." ". __METHOD__ ."<BR>";
					pre($key);
					pre($keys_array_valid_columns);
				}
			}
		}
		$this->options_import['array_valid_column']=$array_valid_column;
		
		IF ($this->debug==true) {
			ECHO 'ARRAY COLUM VALID';
			pre($array_valid_column);
			pre("----------->final y retorno de getmappingx" . __LINE__ ." ". __METHOD__ ."<BR>");
			pre($array_single_column);
		}	

		IF ($this->debug==true) {
		   pre("----------->fin de getmappingx");
		}
		return count($array_valid_column);

	}



 	function creation_executions_description_status($record,$result_msg0,$idrecordexecutions,$saved_errors, $fd,              $ignored_records,$ignored_records2, $updated_records, $created_records,$timex,$xsheets='',$num_record_error=0) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}
		if ($this->debug==true) {echo $b= 'in creation_executions_description_status  id : = ' . $idrecordexecutions;if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10)); fclose($tta);}}
		if ($this->debug==true) {			$posx=0;
			$te=debug_backtrace();$posx=0;
			for ($t=0;$t<12;$t++) {
				if (isset($te[$t]["file"])){
					if ($t==$posx)
						echo $posx."_".$te[$posx]["function"]."_util(pre)-hora:".date("h:i:s d/m/Y")."<br>";
					echo substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"]."<br>";
				}
			}
		}
		//   - Caso 1002490 - CLX-Herr IMPORT Batch
		// Separates created record counter from record processed counter
		$num_records=$ignored_records+$ignored_records2+ $updated_records+ $created_records+$num_record_error;
		$result_msg0 = dict((empty($result_msg0)?'TOOL_DBIM_IMPORT_COMPLETE':$result_msg0), $saved_errors,$num_records , $ignored_records,$ignored_records2, $updated_records, $created_records,$xsheets).' '.dict('GEN_LBL_COMPLETE_SECONDS').' '. (int)(microtime(true)-$timex);
		$record['OBSERVATION'] = 'IP SERVER:'.(ISSET($_SERVER['SERVER_ADDR'])? $_SERVER['SERVER_ADDR'] : $_SERVER['LOCAL_ADDR']).' SERVER NAME:'.(EMPTY($_SERVER['SERVER_NAME'])? $_SERVER['COMPUTERNAME']:$_SERVER['SERVER_NAME'] );

		if (empty($idrecordexecutions)) {
			$record['DESCRIPTION'] = $result_msg0 . '<br>' . CLX_CHAR_NL . $record['DESCRIPTION'];
			if (!isset($record['BATCH_PID']))
				$record['BATCH_PID'] ='-1';
			$idrecordexecutions=ClxCommon::$db->createRecord('CLX_DB_IMPORT_EXECUTIONS', $record, false);
			if ($this->debug==true) {echo $b= 'insert executions (disyuntiva2) in '. __LINE__ ;pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}
		} else {
			unset($record['CDATE'], $record['OWNERCODE']); //just keep from batch
			ClxCommon::$db->updateRecord('CLX_DB_IMPORT_EXECUTIONS', $record, 'ID = ' . $idrecordexecutions);
			if ($this->debug==true) {echo $b= 'update execution (disyuntiva2) in  '. __LINE__ ;PRE('ID = ' . $idrecordexecutions);pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true).'ID = ' . $idrecordexecutions.chr(13).chr(10) ); fclose($tta);}}
		}
		ClxCommon::$db->executequery('commit');

		return array($result_msg0,$idrecordexecutions);

	}
	function parsertext($buffer) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}
		if ($this->type_parser==1){
			$parser = explode($this->string_parser, $buffer);
		}
		else {
			$texto_array = preg_split($this->string_parser, $buffer, PREG_SPLIT_OFFSET_CAPTURE);
			$paser=array();
			foreach ($texto_array as $rvalues) {
				//$parser[]=values[1];
				$parser[]=$rvalues[1];
			}
		}
		if (empty($parser))
			$parser=array($buffer);
		return $parser;
	}
	function parsertextdetect($buffer,$field_delim,$field_cdelim) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}
		//if (strpos(" ".$field_delim,"{")>0 or $field_delim{0}=="[") { //DEPRECATED
		if (strpos(" ".$field_delim,"{")>0 or $field_delim[0]=="[") {
			$field_delim=json_decode($field_delim,true);
			$field_cdelim=json_decode($field_cdelim,true);
			if (count($field_delim)==1) {
				if (empty($field_delim[7])){
					$this->type_parser=1;
					$key=array_keys($field_delim)[0];
					if ($key<4) {
						$this->string_parser=replace_ascii_chars($field_delim[$key]);
					}
					//else if ($key==4)
					else	{
						$this->string_parser=$field_cdelim[$key];
				}

				}
				else {
					$this->type_parser=2;
					$this->string_parser=$field_cdelim[7];
				}

			}
			else {$this->type_parser=2;
				$tdelim='';
				$texto='';
				$counts=0;

				foreach($field_delim as $key=>$xvalue) {
					if($key<7) {
						if ($key<4) {
							$textoparser=replace_ascii_chars($xvalue);
						}
						else {
							$textoparser=$field_cdelim[$key];
						}
						$stexto='';
						for($x=0;$x<strlen($textoparser);$x++) {
							//$stexto.='\x{'. substr('0000'.ord($texto{$x}),-4).'}'; //DEPRECATED
							$stexto.='\x{'. substr('0000'.ord($texto[$x]),-4).'}';
						}
						$tdelim.='('.$stexto.')';

					}
				}
				$this->string_parser=$tdelim;
			}
		}
		else {
			$this->type_parser=1;
			$this->string_parser=replace_ascii_chars($field_delim);
		}


	}
	function reconvertirformatofecha($field,$formatgood,$formatbad) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}
		$months=array('ENE'=>'01','FEB'=>'02','MAR'=>'03','ABR'=>'04','MAY'=>'05','JUN'=>'06','JUL'=>'07','AGO'=>'08','SEP'=>'09','OCT'=>'10','NOV'=>'11','DIC'=>'12','JAN'=>'01','APR'=>'04','AUG'=>'08','DEC'=>'12');
		$formatbad= strtr(uppercase($formatbad),$months);
		$posblank1=strpos($formatbad,' ');
		$hora2=$minuto2=$segundo2=$am2=$pm2='';
		if ($posblank1!==false){
			$thora1=substr($formatbad,$posblank1+1);
			$tfecha1=substr($formatbad,0,$posblank1);

			$am1=stripos($formatbad,'am');
			$pm1=stripos($formatbad,'pm');
			list($hora1,$minuto1,$segundo1)=explode(":",str_ireplace(' ','',str_ireplace('pm','',str_ireplace('am','',$thora1))));


			$x=preg_split('/[\/\-\#]/',trim($tfecha1));
			$bad1=$bad2=$bad3='';
			if (count($x)>2)
				list($bad1,$bad2,$bad3)=$x;
		}
		else {
			$x=preg_split('/[\/\-\#]/',trim($formatbad));
			$bad1=$bad2=$bad3='';
			if (count($x)>2)
				list($bad1,$bad2,$bad3)=$x;

		}
		if (!isset($GLOBALS['FORMAT_FIELD'.$field])) {
			$posblank2=strpos($formatgood,' ');
			if (empty($posblank2))
				$posblank2=strlen($formatgood);
			if ($posblank1!==false){
				$thora2=substr($formatgood,$posblank2+1);

				$tfecha2=substr($formatgood,0,$posblank2);

				$am2=stripos($formatgood,'am');
				$pm2=stripos($formatgood,'pm');
				list($hora2,$minuto2,$segundo2)=explode(":",str_ireplace(' ','',str_ireplace('pm','',str_ireplace('am','',$thora2))));
				list($year2,$month2,$day2)=preg_split('/[\/\-\#]/',$tfecha2);
			}
			else {
				list($year2,$month2,$day2)=preg_split('/[\/\-\#]/',$formatgood);
			}

					if (strlen($bad1)==4) {
						if (strval($bad2)==strval($month2)) {
							$format='bad1-bad2-bad3';
						}
						else if (strval($bad3)==strval($month2)) {
							$format='bad1-bad3-bad2';
						}
					}
					else if (strlen($bad2)==4) {
						if (strval($bad1)==strval($month2)) {
							$format='bad2-bad1-bad3';
						}
						else if (strval($bad3)==strval($month2)) {
							$format='bad2-bad3-bad1';
						}
					}
					else if (strlen($bad3)==4) {
						if (strval($bad1)==strval($month2)) {
							$format='bad3-bad1-bad2';
						}
						else if (strval($bad2)==strval($month2)) {
							$format='bad3-bad2-bad1';
						}
					}
					else  if (substr($year2,2,2)==$bad1) {
						if (strval($bad2)==strval($month2)) {
							$format='evalbad1-bad2-bad3';
						}
						else if (strval($bad3)==strval($month2)) {
							$format='evalbad1-bad3-bad2';
						}
					}
					else if (substr($year2,2,2)==$bad2) {
						if (strval($bad1)==strval($month2)) {
							$format='evalbad2-bad1-bad3';
						}
						else if (strval($bad3)==strval($month2)) {
							$format='evalbad2-bad3-bad1';
						}
					}
			else if (substr($year2,2,2)==$bad3) {
						if (strval($bad1)==strval($month2)) {
							$format='evalbad3-bad1-bad2';
						}
						else if (strval($bad2)==strval($month2)) {
							$format='evalbad3-bad2-bad1';
						}
					}
				$GLOBALS['FORMAT_FIELD'.$field]=array(
														$am2,
														$pm2,
														$hora2,
														$minuto2,
														$segundo2,
														$year2,
														$month2,
														$day2,
														$format);




		}
		else {
													list ($am2,
														$pm2,
														$hora2,
														$minuto2,
														$segundo2,
														$year2,
														$month2,
														$day2,
														$format)=$GLOBALS['FORMAT_FIELD'.$field];
		}
		$extra1='';
		$fecha='';

		if (!empty($hora1)) {
			if (!empty($pm1) ){
				if (empty($pm2)  ||empty($am2))
					$hora1+=12;
				else
					$extra1=" pm";
			}
			if (!empty($am1)) {
				if (!(empty($pm2)  ||empty($am2)) ) {

					$extra1.=" am";
				}
				else if  ($hora1>=12){
					$hora1-=12;
				}

			}
			$fecha= " ".substr('00'.$hora1,-2).':'.	substr('00'.$minuto1,-2).':'.	substr('00'.$segundo1,-2).$extra1;

		}
		$convertir=array (
			'evalbad1'=>(($bad1>"50")? '19':'20') .substr('00'.$bad1,-2),
			'evalbad2'=>(($bad2>"50")? '19':'20') .substr('00'.$bad2,-2),
			'evalbad3'=>(($bad3>"50")? '19':'20') .substr('00'.$bad3,-2),
			'bad1'=>(strlen($bad1)>2) ? $bad1 : substr('00'.$bad1,-2),
			'bad2'=>(strlen($bad2)>2) ? $bad2 : substr('00'.$bad2,-2),
			'bad3'=>(strlen($bad3)>2) ? $bad3 : substr('00'.$bad3,-2),
		);
		$fecha= strtr($format,$convertir).$fecha;

		if ($fecha=='2000-00-00' ||$fecha=='00-00-2000' ||$fecha=='') $fecha='';
		return $fecha;
	}
	function readExcel($test,$importcode,$tablecode,$importid, $show_file,$mappings,$restrictions,$exceptions,$translations,$formulas,$tablerec,$tablename,$field_records,$importrec,$code_lot,$idrecordexecutions,$cdatecomunerror,$error_limit,$crit_sql) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1609;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		$GLOBALS['PROCESS']='DBIM';
		$debug=false;
		IF ($this->debug==true) {
			$debug=true;

		}
		
		$num_record_error=0;
		$DBEX = &getTool('DBIX');
		$recordsall=array();
		if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1626;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");fwrite($tta,chr(13).chr(10)."db_import-hora inicio de funcion read excel ".date("h:i:s d/m/Y").chr(13).chr(10));fclose($tta);}
		$processfile=false;
		$timex=microtime(true);
		$PRECHARGE=0;
		if (isset(UserRequest::$post['DBIM_precharge']))
			$PRECHARGE=UserRequest::$post['DBIM_precharge'];
		$fileread=UserRequest::$files['DBIM_file']['tmp_name'];
		if ($PRECHARGE==1) {
			$fileread=$original_filename=UserRequest::$post['DBIM_file_precharge'];
			$filex=array('name'=>$original_filename,'tmp_name'=>$original_filename);
		}else if (!empty(UserRequest::$files['DBIM_fileexcel'])){
			$filex=UserRequest::$files['DBIM_fileexcel'];
			$original_filename=$filex['name'];
		}
		else {
			$filex=UserRequest::$files['DBIM_file'];
			$original_filename=$filex['name'];
		}
		IF ($debug==true) {
			echo 'precharge:',$PRECHARGE,'<br>';
			echo 'fileread:',$fileread,'<br>';
			echo 'filex:';
			pre($filex);
		}

	//	$cpfileto =PathToWebSite.'import/'.$original_filename;
	//	copy ($fileread, $cpfileto);
		$savepost = UserRequest::$post;
		$saverequest = UserRequest::$request;
		$saveget = UserRequest::$get;
		$description = UserRequest::$post['DBIM_description'];
		$path_info = pathinfo($filex['name']);
		$fileext= lowercase($path_info['extension']);
		$filename= $path_info['filename'];

		$path_info2 = pathinfo($filex['tmp_name']);
		$fileext2='';


		$insertfields=explode(",",str_replace(' ','',$this->import_extra_fields_required));

		$Rowrest=0;
		$imported_records=CLX_NUM_ZERO;
		$commit_count = CLX_INIT_ZERO;

		if (lowercase($fileext)!="xls")
			$Rowrest=-1;
		if (!($fileext2=='tmp' || $fileext2=='')) {
			$Filepath=$filex['name']=$filex['tmp_name'];
		}
		else {
			$Filepath=kPathToWebSite . 'import/'.$filex['name'];
			if  ($PRECHARGE!=1) {
			//	$Filepath2=kPathToWebSite . 'import/x'.$filex['name'];
				if(empty($idrecordexecutions)){
					$a=fopen($filex['tmp_name'],"r");
					$x=fread($a,filesize($filex['tmp_name']));
					fclose($a);
					$a=fopen($Filepath,"w+");
					fwrite($a,$x);
					fclose($a);

				}
			}
		}
		$maxNumRowFile=$this->read_Excel_From_gnumeric_sample2($Filepath,$mappings);
		if (!empty($mappings)) {
			$mappingsheet=$mappings[array_keys($mappings)[0]]['IMPORTSHEETS'];
			if ($mappingsheet==''){
				return note(dict('GEN_LBL_NOT_MAPPINGS'));
			}
			else {

				try {
					$EVNT = &getTool('EVNT');
					$file_fieldnames=array();
					$cleanheaders=true;
					$saved_errors= $line= $ignored_records=$ignored_records2= $updated_records= $created_records= $xsheets=0;
					$from=$to=-2;
					IF (!empty($importrec['RECORD_PROP'][8])){
						$from=$to=$importrec['RECORD_CPROP'][8];
					}



////////////////////////////////////////////////////////
				if (isset($path_info2['extension']))
					$fileext2= lowercase($path_info2['extension']);
				$Filepath2=$Filepath;



				$sample=explode(chr(10),$this->read_Excel_From_gnumeric_sample($Filepath2,$mappings,$importcode));
				if ($this->debug==true) {
					echo "<b>sample gnumeric</b>";
						pre($sample);
						pre($Filepath2);
						pre($mappings);
				}

				if ($from+1<0) {
					$from=-1;

				}
				$DBIU=new db_import_run();
				$DBIU->getTableFields($tablecode);
				for($xfrom=$from;$xfrom<$from+10;$xfrom++) {
					$copiarestrictions=$restrictions;
					$restrict=false;
					if (count($copiarestrictions)>0) {
						$restrict=$this->apply_Restriction($copiarestrictions,$sample[$xfrom+1],$xfrom+1);
					}
					if ( $restrict) {
						continue;
					}
					if ($xfrom>$from) {
						$oldsamplecamposgnumeric=$samplecamposgnumeric;
					}
					$samplecamposgnumeric=explode('{|}',$sample[$xfrom+1]);
					$txpos=0;

					if ($xfrom>$from) {

						foreach($samplecamposgnumeric as $ekey=>$evalue) {


							if (preg_match('/^([0-9\/\.\,\-\+]+)$/', $oldsamplecamposgnumeric[$ekey])==preg_match('/^([0-9\/\.\,\-\+]+)$/',$evalue)) {
								$txpos++;

							}
						}

						if (count($samplecamposgnumeric)==count($oldsamplecamposgnumeric) && $txpos * 1.3 >count($samplecamposgnumeric)) {
							$samplecamposgnumeric=$oldsamplecamposgnumeric;
							break;
						}
						if ($debug==true) {
							echo "<b>sample final gumeric valores de samplecamposgnumeric</b>";
							pre($samplecamposgnumeric);
						}
					}

				}



//////////////////////////////////////////////////////////



					IF (!empty($importrec['RECORD_PROP'][9]) and	$importrec['RECORD_CPROP'][9]>=$from) {
						$to=$importrec['RECORD_CPROP'][9];
					}
					$validate_record = array();
					$msg = array();
					IF ($debug==true) {
						echo 'spreadsheet:',$Filepath,'<br>';
						echo 'file existe:',file_exists($Filepath),'<br>';
					}

					$Spreadsheet = new SpreadsheetReader($Filepath);
					IF ($debug==true) {
						pre($Spreadsheet);
					}
					$Sheets = $Spreadsheet -> Sheets();

					$saved_errors=0;
					$rline=0;
					$xsheets=0;
					$rowtotal=0;
					if (!empty($show_file)) {
						$ignore = CLX_INIT_ZERO;
						$qty_fields=count($mappings);
						foreach ($mappings as $table_fieldname => $info) {
							if ($info['TYPE'] === 'IGNR') {
								$ignore++;
							}
						}
						$table = new htmlTable($qty_fields - $ignore);
						$table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_LIST, CLX_PROP_WIDTH => CLX_PROP_100PCT));
						$table->addCell(dict('GEN_LBL_FILE_CONTENTS'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => $qty_fields));
						foreach ($mappings as $table_fieldname => $info) {
							if ($info['TYPE'] !== 'IGNR') {
								$table->addCell($info['TABLE_FIELDNAME'], array(CLX_PROP_CLASS => CLX_CLASS_HEADERS));
							}
						}
					}


					$SheetFound=false;
					$Sheeting=array($mappingsheet);
					IF ($debug==true) {
						echo '<b>revisar sheet:</b><br>';
					}
					$RARD = getToolObject('ACTN', 'RARD');
					foreach ($Sheets as $Index => $NameSheet) {
						IF ($debug==true) {
							echo 'sheets'.$Index.':';
							pre($NameSheet);

						}
						$Sheeting[]=$NameSheet;
						if (/*$importrec['EXCEL_COUNT_SHEETS']==0 or*/ str_replace('_',' ',$mappingsheet)!=str_replace('_',' ',$NameSheet)) {
							continue;
						}
						$SheetFound=true;
						$Spreadsheet -> ChangeSheet($Index);




						$rline=0;
						//IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fwrite($kk,print_r($locals_var,true));	fwrite($kk, 'filenum:'. $maxNumRowFile);fclose($kk);}

						$namefilebarr=kPathToWebSite.'/temp/'.str_replace('.','',$original_filename).'.barr';
						$cuentabarr=(int) ($maxNumRowFile/10);
						if ($cuentabarr>500)
							$cuentabarr=500;
						else if ($cuentabarr<20)
							$cuentabarr=20;


						$xsheets++;
						$restrict=false;

						if ($commit_count == $this->record_commit_counter) {
							$commit_count = CLX_INIT_ZERO;
							ClxCommon::$db->commit();
						}
						$commit_count++;
						$revisarfechas=array();
						$maxNumRowFile=0;
						foreach ($Spreadsheet as $Key => $Row)	{
							$maxNumRowFile++;
						}
						$Spreadsheet->rewind();
						//pre($maxNumRowFile);
						foreach ($Spreadsheet as $Key => $Row)	{
							if (($posact=(int)($Key*100 /$cuentabarr)) == 0 ) {
								file_put_contents($namefilebarr,$posact);
							}

							if ($Key==0 && $Rowrest==-1)
								$Rowrest=0;
							$cont=0;
							$rowtotal++;
							$countFields=count($Row);
							if (empty(implode("",$Row)) ) {
								$ignored_records2++;
								$rline=$Key+$Rowrest;


							}
							else {
								$rline=$Key+$Rowrest;
								$buffer=implode($Row);
								if ($commit_count == $this->record_commit_counter) {
									$commit_count = CLX_INIT_ZERO;
									ClxCommon::$db->commit();
								}
								$commit_count++;

								if (count($restrictions)>0) {
									$restrict=$this->apply_Restriction($restrictions,$buffer,$rline);
									if ($restrict) {
										$ignored_records2++;
										continue;
									}
								}


								$patron = '/^(([0-9]{4})(\/|\-)([0-9]{2})(\/|\-)([0-9]{2})|([0-9]{2})(\/|\-)([0-9]{2})(\/|\-)([0-9]{4}))/';






								if ($Key+$Rowrest<=$to) {
									if ($Key+$Rowrest>=$from ) {
										foreach ($Row as $key2=>$field) {
											$file_fieldnames[$key2] = clx_change_acentos_char_html($field);
											if(preg_match($patron, $samplecamposgnumeric[$key2]) === 1) {
												$file_fieldnamesgnumeric[$file_fieldnames[$key2]]=$samplecamposgnumeric[$key2];
											}


										}
									}
								}
								else if ($Key+$Rowrest >$to) {


									if(count($file_fieldnames)>0) {
										$repetido=array();
										$contv=0;
										$vkey=0;
										foreach($file_fieldnames as $key=>&$value) {
											$value=clx_change_acentos_char_html(trim($value));
											if (empty($value) or isset($repetido[$value])) {
												$v=((int)($contv/26))*26;
												$htexCol=(($v>0)? chr(65+$v/26-1):"").chr(65+$key-$v);
												$value= "(".dict('GEN_LBL_COLUMN')." [".$htexCol.'])';

											};
											$repetido[$value]='.';
										}
										if ($this->debug==true) {
												echo "=====================aca2<br>";
												pre($file_fieldnames);
										}

										foreach($file_fieldnames as $key=>&$value) {

											if(preg_match($patron, $samplecamposgnumeric[$vkey]) === 1) {
												$file_fieldnamesgnumeric[$value]=$samplecamposgnumeric[$vkey];
											}
											$vkey++;

								//		  print_r($repetido);
										}
									}
									else {

										for ($key2=0;$key2<$countFields;$key2++) {
											$v=((int)($key2/26))*26;
											$htexCol=(($v>0)? chr(65+$v/26-1):"").chr(65+$key2-$v);
											$file_fieldnames[$key2]= "(".dict('GEN_LBL_COLUMN')." [".$htexCol.'])';
											if(preg_match($patron, $samplecamposgnumeric[$key2]) === 1) {
												$file_fieldnamesgnumeric[$file_fieldnames[$key2]]=$samplecamposgnumeric[$key2];
											}
										}
									}

									$validate_record = array();
									$record = array();
									$errors = false;
									$class = CLX_CLASS_DATA ;

									if ($this->debug==true) {
										echo "-------aqui--------". __LINE__ ."<br>";
										pre($file_fieldnames);
									}
									if ($this->isException($exceptions, $buffer)) {
										if (!empty($show_file)) {
											$table->addCell(dict('GEN_LBL_RECORD_NOT_IMPORTED'), array(CLX_PROP_CLASS => $class, CLX_PROP_COLSPAN => $qty_fields));
										}
									}
									else {

										if ($this->debug==true) {
											echo "echomappings:";
											pre($mappings);
										}
										foreach ($mappings as $table_fieldname => $info) {
											$field_value = '';

											if ($info['TYPE'] !== 'IGNR') {
												if ($info['TYPE'] === 'FILE') {
													$i = array_search($info['FILE_FIELDNAME'], $file_fieldnames);
													if($i===false)
														continue;
													$field_value = $Row[$i];
													if (!isset($revisarfechas[$info['FILE_FIELDNAME']])) {
														$revisarfechas[$info['FILE_FIELDNAME']]=( !empty($file_fieldnamesgnumeric[$info['FILE_FIELDNAME']]) && $file_fieldnamesgnumeric[$info['FILE_FIELDNAME']]!=$field_value );

													}
													if ($this->debugValid==true) {
															echo "====================info ini<br>";
															pre($field_value);
													}
													if ( $revisarfechas[$info['FILE_FIELDNAME']] ) {
														$field_value=	$this->reconvertirformatofecha($info['FILE_FIELDNAME'],$file_fieldnamesgnumeric[$info['FILE_FIELDNAME']],$field_value);
													}
													if ($this->debugValid==true) {
															echo "====================info fin<br>";
															pre($field_value);
													}

													if (!empty($info['RULE_TEXT'])) {
														$field_value =$this->convertToString($field_value,json_decode($info['RULE_TEXT']),false,false,false);
													}
												} elseif ($info['TYPE'] === 'CALC') {
													$field_value = $this->executeConstants($info, '', '');
												} elseif ($info['TYPE'] === 'FORM') {

													//	$i = array_search($info['FILE_FIELDNAME'], $file_fieldnames);
													//	$field_value = ($i !== false && array_key_exists($i, $parserline)) ? $parserline[$i] : '';
														if ($this->debug==true) {
															echo "[[[[[[[[[[[[[[[[[[[[[[[[formula  $field_value]]]]]]]]]]]";
															pre($field_value);
														}

												}
												//SETTING RIGHT ENCODING
												$field_value = encode_string($field_value, kDefaultEncoding);
												$field_value = trim($field_value);
												//  FS - Caso 1002490 - CLX-Herr IMPORT Batch
												// Quote processing optimization to avoid PHP to hangs processing imports like FIAE
												//Eliminar enclosing de comillas de existir
												$lgth = mb_strlen($field_value);
												if ($lgth > CLX_NUM_ONE && mb_substr($field_value, CLX_NUM_ZERO, CLX_NUM_ONE) == CLX_CHAR_SINGLE_QUOTE && mb_substr($field_value, CLX_NUM_MINUS_1) == CLX_CHAR_SINGLE_QUOTE) {
													$field_value = mb_substr($field_value, CLX_NUM_ONE, $lgth - CLX_NUM_TWO);
												}
												if (!empty($translations)&&(array_key_exists(uppercase($field_value), $translations[$table_fieldname]))) {
													if (!empty($translations[$table_fieldname]))
												$this->translate($field_value, $translations[$table_fieldname]);

												}

												$record[$table_fieldname] = str_ireplace(str_repeat(singleQuote(CLX_CHAR_EMPTY_STRING), CLX_NUM_THREE), singleQuote(CLX_CHAR_EMPTY_STRING), $field_value);

												//adding entry for validation
											}
										}
										
										if ($this->debug==true or $this->debugValid==true) {
												echo "=====================aca3<br>";
												pre($file_fieldnames);
												pre('mostrar record');
												pre($record);
										}
										foreach ($formulas as $key => $val) {
											ClxFreeReturn($this->executeFormula($val, $record));
											
										}
										if($this->debugValid==true) {
												pre("formulas");
												pre($record);
										}
										//constructing record tablecode_fieldname forma. must be done after formulas to pass values to validate events on table.
										foreach ($mappings as $table_fieldname => $info) {
											if ($info['TYPE'] !== 'IGNR') {
												//adding entry for validation
												if ($info['TYPE'] !== 'IGNR' && in_array($table_fieldname,$this->fieldsRegTable)) {
													if (!isset($record[$table_fieldname])) $record[$table_fieldname]='';
													$validate_record[$tablerec['IDCODE'] . '_' . $table_fieldname] = $record[$table_fieldname];
												}
											}
										}
										if($this->debugValid==true) {
											pre("validate record");
											pre($record);
											pre("validate revalidate record");
											pre($validate_record);
										}
										$msg = array();
										if ($this->debug==true) {
												echo "=====================aca4<br>";
												pre($file_fieldnames);
										}
										foreach ($record as $key => $val) {
											$fieldrec = $field_records[$key];
											$fieldinstance = getToolObject('DBFT', $fieldrec['FIELDTYPE']);
											if ($record[$key] === '') {
												if ($fieldrec['FIELDTYPE'] === 'BOOL') {
													$record[$key] = ($fieldrec['FIELD_DEFAULT']) ? CLX_NUM_ONE : CLX_NUM_ZERO;
													$val = $record[$key];
												} elseif (empty($required_fields[$key])) {
													$record[$key] = 'null';
													$val = $record[$key]; //notar $val que es lo que se pasa a la validacion
												}
												if ($this->debug==true and count($msg)>0) {
													pre('validando field');
													pre($fieldrec);
													pre($msg);
												}
											}
											$fieldinstance->validateImportField($msg, $fieldrec, $val);
											if ($this->debug==true && count($msg)>0) {
												pre('validando record');
												pre($tablerec);
												pre($validate_record);
												pre($msg);
											}
										}
										if($this->debugValid==true && count($msg)>0) {
											
											pre("validate 2");
											pre($record);
										}
										$imported_records++;
										//Run table Validate events
										$keys_validate_record=$validate_record;
										UserRequest::$post = $validate_record;
										$EVNT->execute5('DBTB', $tablerec['ID'], 'VREC', $validate_record, $msg); //  Validate Record
										foreach($record as $key2 => $val2) {
											if (!empty($msg[$key2])) {
												if (strlen($val2)>20)
													$val2="(".substr($val2,0,20).'...'.")";
												else
													$val2="(".$val2.")";
												$msg[$key2].='<font style=\'font-weight:800;color:#ff0000\'>'.$val2.'</font>';

											}
										}
										
										//Reporting Errors
										//   - Caso 1002490 - CLX-Herr IMPORT Batch
										// Se habilita la posibilidad de especificar REPORTE SIN LIMITE de errores
										if ((count($msg) > CLX_NUM_ZERO) && ($saved_errors < $error_limit || $error_limit == CLX_NUM_ZERO)) {
											$this->saveErrors($importcode, $rline, $msg, $saved_errors,$code_lot,$cdatecomunerror,$test);
										}
										$errors = ($errors or ( count($msg) > CLX_NUM_ZERO));
										$num_record_error++;
										if($this->debugValid==true) {
											pre("validate record result");
											pre($validate_record);
										}
										$errors = ($errors or ( count($msg) > CLX_NUM_ZERO));
										if (!empty($show_file)) { 
											
											foreach ($validate_record as $zakey=>$zaval) {
												if (isset($keys_validate_record[$zakey])===true)		
													$table->addCell($zaval/*.'('.$zakey.')'*/, array(CLX_PROP_CLASS => $class));
											}
										}//pre($record);
										unset($validate_record);
										if (empty($test) && empty($errors)) {
											if (ISSET($record['IDCODE']) and uppercase($record['IDCODE'])=='AUTO' ) {
												$RARD->setCreationIdCode($record, $tablecode);
											}
											//Check for duplicates
											IF ($this->debug==true) {
												ECHO "CRIT_SQL";
												PRE( $crit_sql);
											}
											if (!empty($crit_sql)) {
												$sql = $crit_sql;
												foreach ($record as $key => $val) {
													$sql = str_replace('!' . $key, $val, $sql);
												}
												$count = ClxCommon::$db->countRecords($tablename, $sql);
											} else {
												$count = CLX_INIT_ZERO;
											}
											if (!empty($field_derived)) {
												foreach ($field_derived as $key => $val) {
													unset($record[$key]);
												}
											}
											//Adding
											//$record['BATCH_ID']=$batch_log_id;

										//		pre($record);

										$cprecord=$record;
										if ($this->debug==true) {
											echo "=====================aca7-1s<br>";
											pre($file_fieldnames);
										}
										foreach($cprecord as $akey=>$rvalue) {
											if ($this->debug==true) {
												echo "=====================aca7-2sss<br>";
												pre($file_fieldnames);
											}
											IF (!in_array($akey,$this->fieldsRegTable)) {

												if ($this->debug==true) {
													echo "borrado ";
													pre($DBIU->fieldsRegTable);
												}
												//echo 'acccccccppppppppppppppppppppppppppppppp';


												unset($record[$akey]);
											}
										}
							//			echo 'yy';
										if ($this->debug==true) {
											echo "=====================aca7<br>";
											pre($file_fieldnames);
										}

										//pr e($insertfields);
										if (in_array('LOG_ID',$insertfields))
											$record['LOG_ID']=$code_lot;
										if (in_array('LINE_OF_LOG_ID',$insertfields))
											$record['LINE_OF_LOG_ID']=$rline;
										if (in_array('IMPORTSHEETS',$insertfields))
											$record['IMPORTSHEETS']='';
										if (in_array('IMPORTCODE',$insertfields))
											$record['IMPORTCODE']=$importrec['IDCODE'];
											if ($count == CLX_NUM_ZERO) {
												$EVNT->execute5('DBTB', $tablerec['ID'], 'CREP', $record, $msg); //  Create Record (pre database commit)
											if (in_array('CREATEDBY',$insertfields))
												$record['CREATEDBY'] 	= $_SESSION['user_record']['username'];
											if (in_array('MODIFIEDBY',$insertfields))
												$record['MODIFIEDBY'] 	= $_SESSION['user_record']['username'];
											if (in_array('CDATE',$insertfields))
												$record['CDATE'] 		= xFormat::getNow('Y-m-d H:i:s');
											if (in_array('MDATE',$insertfields))
												$record['MDATE'] 		= xFormat::getNow('Y-m-d H:i:s');
											$DBIU->changefiledatereq($record);
											if (defined('DBIM_COUNT_REG_IMPORT') && DBIM_COUNT_REG_IMPORT==1 || !defined('DBIM_COUNT_REG_IMPORT') ) {
												$idi=ClxCommon::$db->createRecord($tablename, $record, false);
												if ($this->debug==true) echo 'creando',	$idi;
												
												$EVNT->execute5('DBTB', $tablerec['ID'], 'CREC', $record, $msg); //  Create Record (post database commit)
												$created_records++;
												if ($this->debug==true) {echo $b= 'createrecord data in '. __LINE__;pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}
											}
											else {
												$recordsall[]=$record;
												if 	(DBIM_COUNT_REG_IMPORT==count($recordsall)) {

													ClxCommon::$db->MulticreateRecord($tablename, $recordsall, false);
													foreach($recordsall as $record){
														$EVNT->execute5('DBTB', $tablerec['ID'], 'CREC', $record, $msg); //  Create Record (post database commit)
													}
													$created_records+=DBIM_COUNT_REG_IMPORT;
													$recordsall=array();
												}

											}
												//   - Caso 1002490 - CLX-Herr IMPORT Batch
												// Separates created record counter from record processed counter
											IF (!empty($GLOBALS['ERRORPROCESOBUG'])) {++$saved_errors;
												$result_msg0 = dict('TOOL_DBIM_IMPORT_ERROR_RUN');
												if (!isset($description))
													$description = '';

												$this->call_error_or_description_debug($importcode,$original_filename,$fileread,$rline,$result_msg0,$idrecordexecutions,0,$saved_errors,$code_lot,$cdatecomunerror,$imported_records,$decription,$test,$timex);

												}

											} elseif ($count > CLX_NUM_ZERO && $importrec['IF_DUPLICATES'] == CLX_NUM_ONE) {
											//
												if (in_array('MODIFIEDBY',$insertfields))
													$record['MODIFIEDBY'] 	= $_SESSION['user_record']['username'];
												if (in_array('MDATE',$insertfields))
													$record['MDATE']		= xFormat::getNow('Y-m-d H:i:s');

												unset($record['ID']); //solo por si existe campo
												$EVNT->execute5('DBTB', $tablerec['ID'], 'UREP', $record, $msg); //  Update Record (pre database commit)
												ClxCommon::$db->updateRecord($tablename, $record, $sql);
												$EVNT->execute5('DBTB', $tablerec['ID'], 'UREC', $record, $msg); //  Update Record (post database commit)
												IF (!empty($GLOBALS['ERRORPROCESOBUG'])) {++$saved_errors;
													$this->call_error_or_description_debug($importcode,$original_filename,$fileread,$rline,$result_msg0,$idrecordexecutions,0,$saved_errors,$code_lot,$cdatecomunerror,$imported_records,$description,$test,$timex) ;
												}
												else {
													$updated_records++;
												}
											} else {
												$ignored_records++;
											}
										} else {
											$ignored_records++;
										}
									}
								}
							}
						}

						if (count($recordsall)>0) {
							ClxCommon::$db->MulticreateRecord($tablename, $recordsall, false);
							foreach($recordsall as $record){
								$EVNT->execute5('DBTB', $tablerec['ID'], 'CREC', $record, $msg); //  Create Record (post database commit)
						}
							$created_records+=count($recordsall);
							ClxCommon::$db->executequery('commit');
							IF (!empty($GLOBALS['ERRORPROCESOBUG'])) {++$saved_errors;
								$this->call_error_or_description_debug($importcode,$original_filename,$fileread,$rline,$result_msg0,$idrecordexecutions,0,$saved_errors,$code_lot,$cdatecomunerror,$imported_records,$description,$test,$timex);
							}
							else {

							}
						}


					}
					file_put_contents($namefilebarr,100);
					ClxCommon::$db->executequery('commit');

					if (empty($test)) {
						//  Events Post Import
						$EVNT->execute5('DBIM', $importrec['ID'], 'INPO', $savepost, $evnt_msg);
					}
					UserRequest::$get = $saveget;
					UserRequest::$post = $savepost;
					UserRequest::$request = $saverequest;
					$record = array();
					$record['IMPORTCODE'] = $importcode;
					$record['RECORD_QTY'] = $imported_records;
					$record['CDATE'] = xFormat::getNow('Y-m-d H:i:s');
					$record['OWNERCODE'] = $_SESSION['user_record']['username'];
					$record['DESCRIPTION'] = dict('CLX_USER_SIST_O').(stripos(' '.PHP_OS,'WIN')>0 ? '' : posix_getpwuid(posix_geteuid())['name']).'<br>'.chr(13).chr(10).$description;
					$record['FILENAME'] = $original_filename;
					$record['OBSERVATION'] = 'IP SERVER:'.(ISSET($_SERVER['SERVER_ADDR'])? $_SERVER['SERVER_ADDR'] : $_SERVER['LOCAL_ADDR']).' SERVER NAME:'.(EMPTY($_SERVER['SERVER_NAME'])? $_SERVER['COMPUTERNAME']:$_SERVER['SERVER_NAME'] );

					$record['LOG_ID']=$code_lot;
					$record['STATUS']='ACT';
					$record['FILENAME_INC_DATE']=0;
					$record['CH_VALUE_DATE']=$importrec['CH_VALUE_DATE'];
					$record['FILEDATE_REQ']=$importrec['FILEDATE_REQ'];
					//   - Caso 1002490 - CLX-Herr IMPORT Batch
					// Separates created record counter from record processed counter
					if ($this->debug==true) {echo $b='llamada creation_executions_description_status  7226 ';PRE('ID = ' . $idrecordexecutions);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).'ID = ' . $idrecordexecutions.chr(13).chr(10) ); fclose($tta);}}
					list($result_msg0,$idrecordexecutions)=$this->creation_executions_description_status($record,'TOOL_DBIM_IMPORT_COMPLETE2',$idrecordexecutions,$saved_errors, $rline, $ignored_records,$ignored_records2, $updated_records, $created_records,$timex,$xsheets,$num_record_error);
					if(!$SheetFound) {
						$result_msg0 .="<br><br>".dict('GEN_LBL_NOT_SEEK_SHEET').':'.$Sheeting[0];
						unset($Sheeting[0]);
						$result_msg0 .=' ('. dict('GEN_LBL_SEEK_SHEET').':'.implode(',',$Sheeting).')';
					}


					$record['DESCRIPTION'] = $result_msg0 . '<br>' . CLX_CHAR_NL . $record['DESCRIPTION'];
					$record['OBSERVATION'] = 'IP SERVER:'.(ISSET($_SERVER['SERVER_ADDR'])? $_SERVER['SERVER_ADDR'] : $_SERVER['LOCAL_ADDR']).' SERVER NAME:'.(EMPTY($_SERVER['SERVER_NAME'])? $_SERVER['COMPUTERNAME']:$_SERVER['SERVER_NAME'] );

					if (empty($idrecordexecutions)) {
						//$record['DESCRIPTION'] = $result_msg0 . '<br>' . CLX_CHAR_NL . $record['DESCRIPTION'];
						ClxCommon::$db->createRecord('CLX_DB_IMPORT_EXECUTIONS', $record, false);
						if ($this->debug==true) {echo $b= 'insert executions (disyuntiva3) in 7216';;pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}
					} else {
						unset($record['CDATE'], $record['OWNERCODE']); //just keep from batch
						ClxCommon::$db->updateRecord('CLX_DB_IMPORT_EXECUTIONS', $record, 'ID = ' . $idrecordexecutions);
						if ($this->debug==true) {echo $b= 'update executions (disyuntiva3) in 7231';pre($record);pre( 'ID = ' . $idrecordexecutions);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true). 'ID = ' . $idrecordexecutions.chr(13).chr(10)); fclose($tta);}}
					}
					ClxCommon::$db->executequery('commit');

					if ($saved_errors > CLX_NUM_ZERO) {
						$errors_link = '<a href="tool.php?to=' . $this->code . '&ac=DISPLAY&idlist=' . $importid . '">' .
						dict('GEN_LBL_DISPLAY') . ' ' . dict('GEN_LBL_ERRORS') . '</a>';
					} else {
						$errors_link = '';
					}

					$note = note($result_msg0 . '<br>' . $errors_link, dict('GEN_LBL_OK'));
					if (!empty($show_file)) {
						$c = new htmlButtonCancel(dict('GEN_LBL_RETURN'));
						$table->addCell($c->source(), array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => $qty_fields));
						return $note . '<Br>' . $table->source();
					} else {
						//return note(dict('TOOL_DBIM_IMPORT_COMPLETE', $saved_errors, $fd->num_records), dict('GEN_LBL_OK'));
						return $note;
					}



				}
				catch (Exception $E)
				{	echo 'error:';
					echo $E -> getMessage();
				}
			}
		}
		if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1626;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");fwrite($tta,chr(13).chr(10)."db_import-hora fin de funcion read excel ".date("h:i:s d/m/Y").chr(13).chr(10));fclose($tta);}

/////////////////////////////////////
	}




	/**
	 * Method schedules import batch for later execution.
	 * First loads the file then created schedule to be loaded
	 *
	 * @return string
	 */
	function import_batch_schedule() {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1610;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		$PRECHARGE=0;
	//	pre(UserRequest::$post);
		if (isset(UserRequest::$post['DBIM_precharge']) && UserRequest::$post['DBIM_precharge']==1 && UserRequest::$post['DBIM_file_precharge']!='') {
			$PRECHARGE=1;
			$this->writeziptotext(kPathToWebSite."/import/",UserRequest::$post['DBIM_file_precharge'],$newfilename);
			if (!empty($newfilename))
				UserRequest::$post['DBIM_file_precharge']=$newfilename;

			if (isset(UserRequest::$post['DBIM_file'])){
				UserRequest::$post['DBIM_file']=UserRequest::$post['DBIM_file_precharge'];
			}
			if (isset(UserRequest::$post['DBIM_filefixed'])){
				UserRequest::$post['DBIM_filefixed']=UserRequest::$post['DBIM_file_precharge'];
			}
			if (isset(UserRequest::$post['DBIM_fileexcel'])){
				UserRequest::$post['DBIM_fileexcel']=UserRequest::$post['DBIM_file_precharge'];
			}
		}

		if ((empty(UserRequest::$files['DBIM_file']['tmp_name']) && $PRECHARGE==0) || empty(UserRequest::$post['DBIM_id'])) {
			return alert(dict('TOOL_DBIM_INVALID_FILE_TYPE'), dict('GEN_LBL_CONTINUE'));
		}
		IF ($this->debug==true) {
			pre("post import batch schedule");
			pre(UserRequest::$post);
			pre("files import batch schedule");
			pre(UserRequest::$files);
		}
		$importrec = ClxCommon::$db->getRecord($this->tablename, 'ID=' . UserRequest::$post['DBIM_id']);
		if (empty($importrec)) {
			return alert(dict('TOOL_DBIM_INVALID_IMPORT'), dict('GEN_LBL_CONTINUE'));
		}
		if ($PRECHARGE==1) {
			$original_filename = kPathToWebSite . 'import/' .UserRequest::$post['DBIM_file_precharge'];
		}
		else {
	   		$original_filename = UserRequest::$files['DBIM_file']['name'];
		}
		$filebarr=kPathToWebSite."/".kPathToTemp.str_replace(".","",basename($original_filename)).".barr";
		//$tta=fopen(kPathToWebSite."/".kPathToTemp."archivoee.txt","a+");
		//fwrite($tta,chr(13).chr(10).$filebarr .chr(13).chr(10));
		//fclose($tta);
		if (file_exists($filebarr))
		unlink($filebarr);

		IF ($this->debug==true) {
			pre("original_filename import batch schedule");
			pre($original_filename);
		}
		if (  $PRECHARGE!=1 &&  isset(UserRequest::$files['DBIM_file']['tmp_name'])) {

			$fd = new clx_file(UserRequest::$files['DBIM_file']['tmp_name'], 'r');
		}
		else {
			$fd = new clx_file($original_filename, 'r');
		}
		$fd->open();
		if ($importrec['TYPE']=='XLS' || $importrec['TYPE']=='XLS2') {
			$line_count =CLX_NUM_ZERO;
		}
		else {
			$line_count = $fd->line_count();

			if ($line_count == CLX_NUM_ZERO) {
				return alert(dict('TOOL_DBIM_FILE_EMPTY'), dict('GEN_LBL_CONTINUE'));
			}
		}
		//Copy the file to export directory and leave it there
		if ($PRECHARGE!=1) {
			IF (file_exists(kPathToWebSite . 'import/' . $original_filename))
			unlink(kPathToWebSite . 'import/' . $original_filename);

			$fd->copy(UserRequest::$files['DBIM_file']['tmp_name'], kPathToWebSite . 'import/' . $original_filename);
			UserRequest::$files['DBIM_file']['tmp_name'] = kPathToWebSite . 'import/' . $original_filename;
			//Store file info to serialize it and pass it to the batch
			UserRequest::$post['$_FILES'] = UserRequest::$files;

		}

		//Store new path to file
		//Create
		$DBEX = &getTool('DBIX');
		ClxCommon::$dbexrec = $DBEX->defaultTableRecord();
		unset(ClxCommon::$dbexrec['ID']);
		ClxCommon::$dbexrec['IMPORTCODE'] = $importrec['IDCODE'];

		ClxCommon::$dbexrec['RECORD_QTY'] = $line_count;
		ClxCommon::$dbexrec['CDATE'] = xFormat::getNow('Y-m-d H:i:s');
		ClxCommon::$dbexrec['OWNERCODE'] = $_SESSION['user_record']['username'];
		ClxCommon::$dbexrec['DESCRIPTION'] = $record['DESCRIPTION'] = dict('CLX_USER_SIST_O').(stripos(' '.PHP_OS,'WIN')>0 ? '' : posix_getpwuid(posix_geteuid())['name']).'<br>'.chr(13).chr(10).$importrec['IDNAME'];
		ClxCommon::$dbexrec['FILENAME'] = $original_filename;

		ClxCommon::$dbexrec['OBSERVATION'] = 'IP SERVER:'.(ISSET($_SERVER['SERVER_ADDR'])? $_SERVER['SERVER_ADDR'] : $_SERVER['LOCAL_ADDR']).' SERVER NAME:'.(EMPTY($_SERVER['SERVER_NAME'])? $_SERVER['COMPUTERNAME']:$_SERVER['SERVER_NAME'] );
		if (isset(UserRequest::$post['FILENAME_INC_DATE']) && UserRequest::$post['FILENAME_INC_DATE']==CLX_NUM_ONE) {
			ClxCommon::$dbexrec['FILENAME_INC_DATE']=CLX_NUM_ONE;
			ClxCommon::$dbexrec['CH_VALUE_DATE']=UserRequest::$post['CH_VALUE_DATE'];
		}
		else {
			ClxCommon::$dbexrec['FILENAME_INC_DATE']=CLX_NUM_ZERO;
			ClxCommon::$dbexrec['CH_VALUE_DATE']='';

		}
		ClxCommon::$dbexrec['PRE_CHARGE']=$PRECHARGE;

		IF (!empty(UserRequest::$post['DBIM_FILENAME_INC_DATE'])) {
			ClxCommon::$dbexrec['FILENAME_INC_DATE']=CLX_NUM_ONE;
			ClxCommon::$dbexrec['CH_VALUE_DATE']=UserRequest::$post['DBIM_CH_VALUE_DATE'];
		}
		ClxCommon::$dbexrec['RUN_BATCH'] = CLX_NUM_ONE;
		ClxCommon::$dbexrec['BATCH_STATUS'] = 'IDLE';
		ClxCommon::$dbexrec['BATCH_PID'] = CLX_INIT_ZERO;
		ClxCommon::$dbexrec['BATCH_SDATE'] = null;
		ClxCommon::$dbexrec['BATCH_EDATE'] = null;
		IF ($this->debug==true) {
			pre("montando scheduler record");
			pre(ClxCommon::$dbexrec);
			pre(UserRequest::$post);
		}
		UserRequest::$post['dbim_var_files']=UserRequest::$files;
		ClxCommon::$dbexrec['BATCH_PRMT'] = serialize(UserRequest::$post);
		//ClxCommon::$dbexrec['BATCH_DATAFILE'] = $fd->read();//may be latter storing the file into db
		if (ClxCommon::$db->oneExistsRecords($DBEX->tablename, 'FILENAME = ' . singleQuote($original_filename) . '  AND BATCH_STATUS =' . singleQuote('IDLE') . ' AND RUN_BATCH = 1') == CLX_NUM_ZERO) {
			$id=ClxCommon::$db->createRecord($DBEX->tablename, ClxCommon::$dbexrec, false);
			if ($this->debug==true) {echo $b= 'createrecord executions in '. __LINE__ ;pre(ClxCommon::$dbexrec);
			echo 'id:',$id,chr(13).chr(10);
			if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).'id='.$id.chr(13).chr(10).print_r(ClxCommon::$dbexrec,true));fclose($tta);}}
			ClxCommon::$db->executequery('commit');
				
			switch (kDatabaseType) {
				case 'oci': // Oracle
				$sql='UPDATE '.$DBEX->tablename.' SET LOG_ID=(SELECT MAX(LOG_ID)+1 FROM '.$DBEX->tablename.' WHERE IMPORTCODE='.singlequote($importrec['IDCODE']).')  WHERE ID='.$id;
				if ($this->debug==true) {echo $b='update import in '. __LINE__;pre($sql);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).$sql,true); fclose($tta);}}
					ClxCommon::$db->executequery($sql);
					break;
				default:
					$sql='SELECT MAX(LOG_ID)+1 FROM '.$DBEX->tablename.' WHERE IMPORTCODE='.singlequote($importrec['IDCODE']);
					$LOG_XID=ClxCommon::$db->getOne($sql);
					if ($this->debug==true) {echo $b='update import in 7349';pre($sql);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).$sql,true); fclose($tta);}}
					ClxCommon::$db->executequery($sql);

					$sql='UPDATE '.$DBEX->tablename.' SET LOG_ID='.$LOG_XID.'  WHERE ID='.$id;
					if ($this->debug==true) {echo $b='update import in 7349';pre($sql);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).$sql,true); fclose($tta);}}
					ClxCommon::$db->executequery($sql);
					break;
			}


			ClxCommon::$db->executequery('commit');
		}
		else {
			IF ($this->debug==true) {
				pre("registro montado con anterioridad");

			}

		}
		$fd->close();
		// Link: Ver Bit�cora
		$flname = kWebSite . 'tool.php?to=DBIM&ac=DISPLAY&idlist=' . $importrec['ID'];
		$hrefBitacora = '<a href=' . singleQuote($flname) . '>' . dict('GEN_LBL_IMP_LOG') . '</a>';
		return note(dict('TOOL_DBIM_IMPORT_SCHEDULED', singleQuote($importrec['IDCODE'] . ' ' . $importrec['IDNAME']), $original_filename) . "<br />" . $hrefBitacora, dict('GEN_LBL_CONTINUE'));
	}

	/**
	 * Runs scheduled batch
	 * @global object ClxCommon::$db
	 */
	public function import_batch_run($group) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1611;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		IF ($this->debug==true) {
			pre("inicio batch run en db_import");

		}
		//PRE('EEEE');
		$this->importscode=array();
		FOR ($r=0;$r<10; $r++){
			$DBEX = &getTool('DBIX');
			//Mark imports to processCLAVE:d435f58a
			$this->batch_pid=singleQuote(getPid());
			switch (kDatabaseType) {
				case 'oci': // Oracle
						$sql = 'UPDATE ' . $DBEX->tablename . 
							' SET BATCH_PID = ' . $this->batch_pid . 
							', BATCH_SDATE = CURRENT_DATE, BATCH_STATUS =' . singleQuote('RUN') .
							' WHERE BATCH_STATUS =' . singleQuote('IDLE') .
							' AND RUN_BATCH = 1 AND ROWNUM=1' .
							( empty($group)? '': ' AND EXISTS (SELECT 1 FROM '.$this->tablename .
							                                   ' X WHERE '.$DBEX->tablename. 
															   '.IMPORTCODE=X.IDCODE  AND X.EXECUTE_PRIORITY= '.$group.')');
					##	$sql = 'UPDATE ' . $DBEX->tablename . ' SET BATCH_PID = ' . $this->batch_pid . ', BATCH_SDATE = CURRENT_DATE, BATCH_STATUS =' . singleQuote('RUN') . ' WHERE BATCH_STATUS =' . singleQuote('IDLE') . ' AND RUN_BATCH = 1 AND ROWNUM=1' ) ;
					break;
				default:
					$sql = 'UPDATE ' . $DBEX->tablename . ' SET BATCH_PID = ' . $this->batch_pid . ', BATCH_SDATE = NOW(), BATCH_STATUS =' . singleQuote('RUN') . ' WHERE BATCH_STATUS =' . singleQuote('IDLE') . ' AND RUN_BATCH = 1 '.  empty($group)? '': ' AND EXISTS (SELECT 1 FROM '.$this->tablename .
							                                   ' X WHERE '.$DBEX->tablename. 
															   '.IMPORTCODE=X.IDCODE  AND X.EXECUTE_PRIORITY= '.$group.')'.   ' LIMIT 1';
					break;
			}
				IF ($this->debug==true){
					pre('update executions');
					pre($sql);
				}

			$rs = ClxCommon::$db->executeQuery($sql);
			unset($rs);
			ClxCommon::$db->commit();
			
			//Select imports and run them
			$usr_not_assigned = (!isset($_SESSION['user_record']['username']));
			if (empty ($group)) 
				$rs = ClxCommon::$db->getRecords($DBEX->tablename, 'BATCH_PID = ' . $this->batch_pid, 'BATCH_STATUS =' . singleQuote('RUN'));
			else {
				$sql='select X.* from '. $DBEX->tablename .' X join '.$this->tablename .' Y ON X.IMPORTCODE= Y.IDCODE where Y.EXECUTE_PRIORITY= '.$group.' AND X.BATCH_PID = ' . $this->batch_pid. ' AND X. BATCH_STATUS =' . singleQuote('RUN');
				pre($sql);
				
				$rs=ClxCommon::$db->executequery($sql);
			}
			
				
			
			while ($DBEX_record = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
				PRE('============EXECUTE=================');
				PRE($DBEX_record);
				$this->importscode[$DBEX_record['IMPORTCODE']]=$DBEX_record['IMPORTCODE'];
				if($usr_not_assigned == true) {
					$_SESSION['user_record']['username'] = $DBEX_record['OWNERCODE'];
				}
				$_SESSION['FILENAME_INC_DATE'] =$DBEX_record['FILENAME_INC_DATE'];
				UserRequest::$post['FILENAME_INC_DATE']=$DBEX_record['FILENAME_INC_DATE'];

				$_SESSION['CH_VALUE_DATE'] =$DBEX_record['CH_VALUE_DATE'];
				UserRequest::$post['CH_VALUE_DATE']=$DBEX_record['CH_VALUE_DATE'];


				$_SESSION['IMFT_ID'] =$DBEX_record['IMFT_ID'];
				UserRequest::$post['IMFT_ID']=$DBEX_record['IMFT_ID'];
				if (!empty(UserRequest::$post['IMFT_ID'])) {
					$sql='SELECT IM.*,IC.FILENAME_INC_DATE,IC.CH_VALUE_DATE FROM CLX_ETL_IMPFILES_TMP IM, CLX_ETL_IMPORT_CFG IC WHERE IM.IMCF_ID=IC.ID AND IM.ID=' . UserRequest::$post['IMFT_ID'];
					$xrecords = ClxCommon::$db->executeQuery($sql);
					while ($xrecord = ClxCommon::$db->getNextRecord($xrecords, ASSOCIATIVE)) {
					
						$logsids=explode('|',$xrecord['LOGS_IDS']);
						$encontrado=false;
						$cuenta=0;
						foreach  ($logsids as $key=>&$valueid) {
							$cuenta=1;
							$part=explode(':',$valueid);
							if ($part[0]==$DBEX_record['IMPORTCODE']) {
								$encontrado=true;
							}
						}
						if (!$encontrado) {
							$xrecord['LOGS_IDS'].= ($cuenta==1?'|':'').$DBEX_record['IMPORTCODE'].':'.$DBEX_record['LOG_ID'];
						}
						$sql='UPDATE '.$this->imftname.' SET LOGS_IDS='.singlequote($xrecord['LOGS_IDS']).' WHERE ID=' . UserRequest::$post['IMFT_ID'];
						ClxCommon::$db->executeQuery($sql);
						if ($this->debug==true) {echo $b='update import in '. __LINE__ ;pre($sql);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).$sql,true); fclose($tta);}}
								
						$_SESSION['FILENAME_INC_DATE'] =$xrecord['FILENAME_INC_DATE'];
						UserRequest::$post['FILENAME_INC_DATE']=$xrecord['FILENAME_INC_DATE'];
				
						$_SESSION['CH_VALUE_DATE'] =$xrecord['CH_VALUE_DATE'];
						UserRequest::$post['CH_VALUE_DATE']=$xrecord['CH_VALUE_DATE'];

					}
				}

				print CLX_CHAR_NL . 'Import ID=' . $r['ID'] . CLX_CHAR_NL;

				$this->import_batch($DBEX_record);
////////////////////////////////////////////////////////////////////
				$this->load_trx($DBEX_record['IMPORTCODE']);
			}
			ClxCommon::$db->commit();
			//$sql = 'UPDATE ' . $DBEX->tablename . ' SET BATCH_PID = ' . $this->batch_pid . ', BATCH_SDATE = NOW(), BATCH_STATUS =' . singleQuote('END') . ' WHERE BATCH_STATUS =' . singleQuote('RUN') . ' AND RUN_BATCH = 1 LIMIT 1';
			//$rs = ClxCommon::$db->executeQuery($sql);

		}
	}
	function load_trx($ImpCode) {
		
		pre( 'inicio proceso nuevo');
		if (ClxCommon::$db->tableExists('RCAA_DEPENDENCIES')) {
			pre( 'paso consulta de existencia de dependencias');
			$sql='SELECT * FROM CLX_PR_SCHEDULES WHERE IDCODE='.SINGLEQUOTE('RC_LOADTRX');
			$rs=ClxCommon::$db->executequery($sql);
			$prsc_options = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE);
			$display = (!empty($prsc_options['IS_DISPLAY'])) ? true : false;
			$debug = (!empty($prsc_options['IS_DEBUG'])) ? true : false;
			$html = true;
			  
			
					
			pre( 'buscando para llamar load_trx importcode desde db_import '.$ImpCode);
			 $sql= ' SELECT 
									   DEP.IMPORT_CODE, 
									  IMP.TABLECODE, 
									   RCDS.RCTB_CODE, 
									  QRY.QUERYCODE, 
									  RCAP.CLX_EFFTDATE

						 FROM 
									  CLX_DB_IMPORTS IMP, 
									  RCAA_DEPENDENCIES DEP, 
									  RCAA_RECON_TBL RCTB, 
									 RCAA_RECON_DATASRC RCDS, 
									 CLX_DB_QUERY_TABLES QRY,
									  (SELECT MAX(CLX_EFFTDATE)CLX_EFFTDATE, COMP_CODE FROM RCAA_RECON_CNTL RCAP  group by 
												   RCAP.COMP_CODE ) RCAP

							WHERE
										 RCTB.STATUS='.SINGLEQUOTE('A').' 
										 AND IMP.IDCODE = DEP.IMPORT_CODE
										  AND DEP.RCTB_CODE = RCTB.IDCODE
										 AND RCTB.COMP_CODE=  RCAP.COMP_CODE
										 AND RCDS.RCTB_CODE = RCTB.IDCODE
										 AND RCDS.QUERYCODE = QRY.QUERYCODE
										 AND QRY.TABLECODE = IMP.TABLECODE
										  AND IMP.IDCODE = '. singlequote( $ImpCode). '
										 AND NOT EXISTS
											 (SELECT 1 FROM RCTA_DEPENDENCIES RC, RCTA_TRN_MATCH_TBL RT 
										   WHERE RC.IMPORT_CODE=IMP.IDCODE
										  
											 AND RC.RCTM_CODE=RT.IDCODE AND RT.STATUS='.SINGLEQUOTE('A').' )';
			$rs=ClxCommon::$db->executequery($sql);
			while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
					$PRPR=&getTool ( 'PRPR' );
					$PRPR->processcode='RC_LOADTRX';
					$PRPR->schedulecode='RC_LOADTRX';

					$parameters = $PRPR->loadParameters('RC_LOADTRX',false);
					$parameters['SCHEDULECODE'] = 'RC_LOADTRX' ;
					$parameters['RCTB_CODE']=$r['RCTB_CODE'];
					$parameters['EFFTDATE']=substr($r['CLX_EFFTDATE'],0,10) ;		 
					$parameters['USERNAME'] = (EMPTY($parameters['USERNAME']) ? 'administrador' : $parameters['USERNAME']);
					$parameters['START_TIME'] = getNow('Y-m-d H:i:s'); 
					$parameters['QUERYCODE']=$r['QUERYCODE'] ;
					$parameters['RC_RERUN']=(EMPTY($r['RC_RERUN']))?'0':$r['RC_RERUN'] ;
					$PRPR->parameters_agenda=$parameters;
					pre( 'iniciando lance a Rc_loadtrx');

					$PRPR->execute_process('RC_LOADTRX','RC_LOADTRX', $display, $debug, $html);



			}
		
						
		}
		
	}
	/**
	 * Executes batch import
	 * @param array &$dbex_record
	 */
	private function import_batch(&$dbex_record) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1612;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		$DBEX = &getTool('DBIX');
		echo 'Running import batch: ', CLX_CHAR_NL, '  Code:', $dbex_record['IMPORTCODE'], ' ', CLX_CHAR_NL, '  Name:', $dbex_record['DESCRIPTION'], ' ', CLX_CHAR_NL, '  File:', $dbex_record['FILENAME'], CLX_CHAR_NL;
		$init_time_out = ini_get('max_execution_time');
		UserResponse::setRunTimeLimit(CLX_NUM_24 * CLX_NUM_60 * CLX_NUM_60);
		//save values
		$save_post = UserRequest::$post;
		if (isset (UserRequest::$files))
			$save_file = UserRequest::$files;
		else if (isset(UserRequest::$post['_FILES']))
			$save_file = UserRequest::$post['_FILES'];
		else
			$save_file = $_FILES;
		//Set POST and FILES for Import to work
		UserRequest::$post = unserialize($dbex_record['BATCH_PRMT']);
		//PRE(dbex_record);
		if (!isset(UserRequest::$post['FILENAME_INC_DATE'])&& isset ($save_post['FILENAME_INC_DATE']))
			UserRequest::$post['FILENAME_INC_DATE']=$save_post['FILENAME_INC_DATE'];
		else if (!isset(UserRequest::$post['FILENAME_INC_DATE']) && isset($dbex_record['FILENAME_INC_DATE']))
			UserRequest::$post['FILENAME_INC_DATE'] = $dbex_record['FILENAME_INC_DATE'];

	   if (!isset(UserRequest::$post['CH_VALUE_DATE'])&& isset ($save_post['CH_VALUE_DATE']))
			UserRequest::$post['CH_VALUE_DATE']=$save_post['CH_VALUE_DATE'];
		else if (!isset(UserRequest::$post['CH_VALUE_DATE']) && isset($dbex_record['CH_VALUE_DATE']))
			UserRequest::$post['CH_VALUE_DATE'] = $dbex_record['CH_VALUE_DATE'];




		UserRequest::$post['RINNING_BATCH'] = $dbex_record['ID']; //used to prevent creating a new log on execution
		if (isset( UserRequest::$post['_FILES']))
			UserRequest::$files =UserRequest::$post['_FILES'];
		else
			UserRequest::$files = $_FILES;
		IF (ISSET($dbex_record['IMFT_ID']) && !empty($dbex_record['IMFT_ID'])) {
			UserRequest::$post['IMFT_ID'] = $dbex_record['IMFT_ID'];
			UserRequest::$post['DBIM_id']=$dbex_record['DBIM_id']=ClxCommon::$db->getone('SELECT ID FROM CLX_DB_IMPORTS WHERE IDCODE='.singleQuote($dbex_record['IMPORTCODE']));
		}
		else {
			UserRequest::$post['IMFT_ID']='';
		}
		if (isset(UserRequest::$post['_FILES']))
			unset(UserRequest::$post['_FILES']);
		//Call Import method
		$result = $this->import();
		$result = str_replace(array(CLX_CHAR_NL . CLX_CHAR_NL, CLX_CHAR_CR . CLX_CHAR_CR), CLX_CHAR_NL, strip_tags($result)) . CLX_CHAR_NL;
		//Set run status to end to mark as completed
		 switch (kDatabaseType) {
			case 'oci': // Oracle
				$sql = 'UPDATE ' . $DBEX->tablename . ' SET BATCH_EDATE = CURRENT_DATE, BATCH_STATUS = ' . singleQuote('END') . ', DESCRIPTION = ' .singleQuote(dict('CLX_USER_SIST_O').(stripos(' '.PHP_OS,'WIN')>0 ? '' : posix_getpwuid(posix_geteuid())['name']).chr(13).chr(10). $result) . ' WHERE ID = ' . $dbex_record['ID'] . ' AND RUN_BATCH = 1';

				break;
			default:
		$sql = 'UPDATE ' . $DBEX->tablename . ' SET BATCH_EDATE = NOW(), BATCH_STATUS = ' . singleQuote('END') . ', DESCRIPTION = ' .singleQuote(dict('CLX_USER_SIST_O').(stripos(' '.PHP_OS,'WIN')>0 ? '' : posix_getpwuid(posix_geteuid())['name']).chr(13).chr(10). $result) . ' WHERE ID = ' . $dbex_record['ID'] . ' AND RUN_BATCH = 1';
				break;
		}
		ClxCommon::$db->executeQuery($sql);
		if ($this->debug==true) {
			echo 'update import executions';
			pre($sql);
		}
		ClxCommon::$db->commit();
		UserRequest::$post = $save_post;
		$_FILES = $save_file;
		//Restore original value
		UserResponse::setRunTimeLimit($init_time_out);
	}

	function import_from_list($list_file = 'import_list.txt') {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1613;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		$init_time_out = ini_get('max_execution_time');
		$import_folder = kPathToWebSite . kPathToImport;
		echo CLX_CHAR_NL, '********************************', CLX_CHAR_NL;
		echo uppercase(dict('BASE_PROC_LBL_START')), CLX_CHAR_NL;
		echo 'DATE:', xFormat::getNow('Y-m-d H:i:s'), CLX_CHAR_NL;
		echo '********************************', CLX_CHAR_NL;
		$f = new clx_file($import_folder . $list_file, 'r');
		$f->open();
		if (!empty($f->error)) {
			echo uppercase(dict('GEN_ERR_FILE_NOT_FOUND'), ': ', $list_file), CLX_CHAR_NL;
			return;
		}
		if (!defined('DBIM_DEF_LIST_IMP_USER')) {
			echo 'Missing system parameter  DBIM_DEF_LIST_IMP_USER', CLX_CHAR_NL;
		}
		//Login in for system to set user information
		$ACUS = &getTool('ACUS');
		if (!$ACUS->process_list_import_login(DBIM_DEF_LIST_IMP_USER)) {
			echo $ACUS->get_login_msg(), CLX_CHAR_NL;
			return;
		}
		$i = CLX_INIT_ZERO;
		while (empty($f->eof)) {
			UserResponse::setRunTimeLimit(CLX_NUM_24 * CLX_NUM_60 * CLX_NUM_60);
			$ln = $f->read_line();
			$i++;
			ob_flush();
			if ($i == CLX_NUM_ONE || strlen(trim($ln)) == CLX_NUM_ZERO)
				continue; //Skeep first line
			$ln = explode(',', $ln);
			//Validating Options
			if (count($ln) != CLX_NUM_THREE) {
				echo 'Invalid line. Instruction must be 2 elements separated by comma on line '.$i, CLX_CHAR_NL;
				continue;
			}
			echo CLX_CHAR_NL;
			//Test for numeric option 'TEST'
			if (!is_numeric($ln[CLX_NUM_ZERO])) {
				echo uppercase('Invalid TEST flag on line '.$i), CLX_CHAR_NL;
				continue;
			}
			$ln[CLX_NUM_ZERO] = (intval($ln[CLX_NUM_ZERO]) == CLX_NUM_ZERO) ? CLX_NUM_ZERO : CLX_NUM_ONE; //TEST
			$ln[CLX_NUM_ONE] = trim($ln[CLX_NUM_ONE]); //IMPORT CODE
			$ln[CLX_NUM_TWO] = trim($ln[CLX_NUM_TWO]); //IMPORT FILENAME
			//   - Caso 1002490 - CLX-Herr IMPORT Batch
			// Se habilita la posibilidad de especificar limite de errores en el archivo
			// mediante el 4to parametro de cada l?nea
			$ln[CLX_NUM_THREE] = (isset($ln[CLX_NUM_THREE]) ? trim($ln[CLX_NUM_THREE]) : CLX_NUM_ZERO); //ERROR LIMIT. [CLX_NUM_ZERO]=UNLIMITED
			//Test for numeric option 'ERROR LIMIT'
			if (!is_numeric($ln[CLX_NUM_THREE])) {
				echo uppercase('Invalid ERROR LIMIT on line '.$i), CLX_CHAR_NL;
				continue;
			}
			//Test import existance
			$dbim = ClxCommon::$db->getFields($this->tablename, 'ID, IDCODE,IDNAME', 'IDCODE = ' . singleQuote($ln[CLX_NUM_ONE]));
			if (empty($dbim)) {
				echo uppercase('Import ', $ln[CLX_NUM_ONE], ' donot exists on line '.$i), CLX_CHAR_NL;
				continue;
			}
			//Test if file exists
			if (!file_exists($import_folder . $ln[CLX_NUM_TWO])) {
				echo uppercase('Import file ', $ln[CLX_NUM_TWO], ' not found on line '.$i), CLX_CHAR_NL;
				continue;
			}
			//Prepare information
			//Set POST and FILES for Import to work
			UserRequest::$post = array(CLX_PROP_TO => 'DBIM', 'ac' => 'IMPORT', 'confirm' => CLX_NUM_ONE, 'idlist' => $dbim['ID'],
				'DBIM_id' => $dbim['ID'], 'DBIM_idcode' => $dbim['IDCODE'], 'DBIM_idname' => $dbim['IDNAME'],
				'DBIM_test' => $ln[CLX_NUM_ZERO], 'DBIM_save_errors' => CLX_NUM_ONE, 'DBIM_show_file' => CLX_NUM_ZERO,
				/*
				  //   - Caso 1002490 - CLX-Herr IMPORT Batch
				  'DBIM_error_limit' => 100,
				 */
				'DBIM_error_limit' => $ln[CLX_NUM_THREE],
				'DBIM_description' => '', 'DBIM_file' => $ln[CLX_NUM_TWO], 'RINNING_BATCH' => CLX_NUM_ZERO);
			UserRequest::$files = array('DBIM_file' => array('name' => $ln[CLX_NUM_TWO],
					'type' => 'text/plain',
					'tmp_name' => $import_folder . $ln[CLX_NUM_TWO],
					'error' => CLX_NUM_ZERO, 'size' => CLX_NUM_ZERO));
			$result = $this->import();
			ClxCommon::$db->commit();
			$result = str_replace(dict('GEN_LBL_DISPLAY') . ' ' . dict('GEN_LBL_ERRORS'), '', $result);
			ob_flush();
			$sql = 'SELECT BATCH_ID,LINENUM, FIELDNAME, ERRORMSG   FROM CLX_DB_IMPORT_ERRORS WHERE IMPORTCODE = ' . singleQuote($ln[CLX_NUM_ONE]) . ' ORDER BY LINENUM ASC';
			$rs = ClxCommon::$db->executeQuery($sql);
			$dbim = CLX_INIT_ZERO;
			while (($r = ClxCommon::$db->getNextRecord($rs, NUMERIC))) {
				$dbim++;
				if ($dbim > CLX_NUM_20) {
					ob_flush();
					$dbim = CLX_INIT_ZERO;
				}
			}
			//   - Caso 1002490 - CLX-Herr IMPORT Batch
			// Clean up variables to free memory
			ob_flush();
			$rs = null;
			$dbim = null;
			$result = null;
		}
		$f->close();
		//   - Caso 1002490 - CLX-Herr IMPORT Batch
		// Adds date/time at the end
		echo CLX_CHAR_NL;
		echo '********************************', CLX_CHAR_NL;
		echo uppercase(dict('GEN_LBL_PROCESS_COMPLETE')), CLX_CHAR_NL;
		echo 'TIME: ', xFormat::getNow('Y-m-d H:i:s'), CLX_CHAR_NL;
		echo '********************************', CLX_CHAR_NL;
		//Restore original value
		UserResponse::setRunTimeLimit($init_time_out);
		ob_flush();
	}

	/**
	 * Sabes errors
	 *
	 * @param type $importcode
	 * @param type $linenum
	 * @param type $msg
	 * @param type $saved_errors
	 */
	function saveErrors($importcode, $linenum, $msg, &$saved_errors,$log_id,$cdate,$test) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1614;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		$record = array();
		$record['IMPORTCODE'] = $importcode;
		$record['LINENUM'] = $linenum;
		$record['ERRORNUM'] = '0';
		$record['LOG_ID']=$log_id;
		$record['CDATE']=$cdate;
		$record['TEST']=$test;

		foreach ($msg as $fieldname => $error) {
			$record['FIELDNAME'] = $fieldname;
			$record['ERRORMSG'] = addslashes($error);
			ClxCommon::$db->createRecord('CLX_DB_IMPORT_ERRORS', $record, false);
			$saved_errors++;
			if ($this->debug==true) {echo $b= 'create record errors in '. __LINE__;pre($record);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).print_r($record,true)); fclose($tta);}}
		}

	}

	function getTableFields($tablecode) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1615;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		$table_fields = array();
		if (!empty($tablecode)) {
			$sql = 'SELECT	A.FIELDNAME FROM (SELECT FIELDNAME, 0 DERIVED, SEQNUM,ID FROM CLX_DB_TABLEFIELDS WHERE TABLECODE = ' . singleQuote($tablecode)
			. ') A ORDER BY A.DERIVED ASC, A.ID, A.SEQNUM ASC';
			if ($this->debug==true) {
				pre('fieldsRegTable 1:');
				pre($sql);
			}
			$records = ClxCommon::$db->executeQuery($sql);
			while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
				$table_fields[] = $record['FIELDNAME'];
			}
			$this->fieldsRegTable= $table_fields;
			$sql = ' SELECT	A.FIELDNAME FROM ( SELECT FIELDNAME, 1 DERIVED, SEQNUM,ID FROM CLX_DB_TABLEDFIELDS WHERE TABLECODE = ' . singleQuote($tablecode)
	   . 	') A ORDER BY A.DERIVED ASC, A.ID, A.SEQNUM ASC';
			if ($this->debug==true) {
				pre('fieldsRegTable 2:');
				pre($sql);
			}
			$records = ClxCommon::$db->executeQuery($sql);
			while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
				$table_fields[] = $record['FIELDNAME'];
			}




		}
		$this->fieldsRegTable=$table_fields;
		return $table_fields;
	}

	/**
	 * Required Fields
	 * @param string $tablecode
	 * @return array
	 */
	function getTableRequiredFields($tablecode) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1616;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		$table_fields=array();
		if (!empty($tablecode)) {
			$sql = 'SELECT FIELDNAME FROM CLX_DB_TABLEFIELDS WHERE TABLECODE = ' . singleQuote($tablecode) . ' AND FIELD_REQUIRED = 1';
			$records = ClxCommon::$db->executeQuery($sql);
			while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
				$table_fields[$record['FIELDNAME']] = CLX_NUM_ONE;
			}
		}
		return $table_fields;
	}

	/**
	 * Table field records
	 * @param string $tablecode
	 * @return array
	 */
	function getTableFieldRecords($tablecode) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) ) { $tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");   fwrite($tta,chr(13).chr(10)."16098 editForm_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fclose($tta);}
		$field_records = array();
		$table_fields=array();
		if (!empty($tablecode)) {
			$sql = 'SELECT		 -- F.*,
									F.ID, F.VERSION,	F.VERSION_COUNTER ,   F.CDATE,			 F.MDATE,		 F.USERNAME,
									' . ClxCommon::$db->cast_to_char('F.DESCRIPTION') . ' DESCRIPTION,
									F.FIELDNAME,		F.FIELDFORMLABEL,	 F.FIELDLISTLABEL,	F.FIELDPREFIX,
									F.FIELDSUFIX,	   F.FIELDTYPE,		  F.FIELD_ANCHOR,
									' . ClxCommon::$db->cast_to_char('F.FIELDFORMULA') . ' FIELDFORMULA,
									F.FIELD_SIZE,	   F.FIELD_REQUIRED,	 F.FIELD_FORMAT,	  F.FIELD_ALIGN,   F.FIELD_DEFAULT,
									F.FIELD_MINVALUE,   F.FIELD_MAXVALUE,	 F.FIELD_DISPLAYSIZE, F.FIELD_EXTRA1,  F.FIELD_EXTRA2,
									F.FIELD_EXTRA3,	 F.FIELD_EXTRA4,	   F.FIELD_EXTRA5,	  F.FIELD_EXTRA6,  F.FIELD_EXTRA7,
									F.FIELD_EXTRA8,	 F.FIELD_EXTRA9,	   TF.FIELD_REQUIRED TF_FIELD_REQUIRED,
									TF.FIELD_DEFAULT TF_FIELD_DEFAULT
							FROM
									CLX_DB_TABLEFIELDS TF,   CLX_DB_FIELDS F
							WHERE
									TF.TABLECODE=' . singleQuote($tablecode) . ' AND TF.FIELDNAME = F.FIELDNAME';
			$records = ClxCommon::$db->executeQuery($sql);
			while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
				$record['FIELD_REQUIRED'] = $record['TF_FIELD_REQUIRED'];
				$record['FIELD_DEFAULT'] = $record['TF_FIELD_DEFAULT'];
				$field_records[$record['FIELDNAME']] = $record;
				$table_fields[]=$record['FIELDNAME'];

			}
			$this->fieldsRegTable= $table_fields;

			$sql = 'SELECT
									-- F.*,
									F.ID,  F.VERSION,	F.VERSION_COUNTER,   F.CDATE,			 F.MDATE,		 F.USERNAME,
									' . ClxCommon::$db->cast_to_char('F.DESCRIPTION') . ' DESCRIPTION,
									F.FIELDNAME,		 F.FIELDFORMLABEL,	F.FIELDLISTLABEL,	F.FIELDPREFIX,
									F.FIELDSUFIX,		F.FIELDTYPE,		 F.FIELD_ANCHOR,
									' . ClxCommon::$db->cast_to_char('F.FIELDFORMULA') . ' FIELDFORMULA,
									F.FIELD_SIZE,		F.FIELD_REQUIRED,	F.FIELD_FORMAT,	  F.FIELD_ALIGN,   F.FIELD_DEFAULT,
									F.FIELD_MINVALUE,	F.FIELD_MAXVALUE,	F.FIELD_DISPLAYSIZE, F.FIELD_EXTRA1,  F.FIELD_EXTRA2,
									F.FIELD_EXTRA3,	  F.FIELD_EXTRA4,	  F.FIELD_EXTRA5,	  F.FIELD_EXTRA6,  F.FIELD_EXTRA7,
									F.FIELD_EXTRA8,	  F.FIELD_EXTRA9,	  F.FIELD_REQUIRED TF_FIELD_REQUIRED,
									F.FIELD_DEFAULT TF_FIELD_DEFAULT
							FROM
									CLX_DB_TABLEDFIELDS TF,
									CLX_DB_FIELDS F
							WHERE
									TF.TABLECODE=' . singleQuote($tablecode) . 
									' AND TF.FIELDNAME = F.FIELDNAME';
			$records = ClxCommon::$db->executeQuery($sql);
			while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
				$record['FIELD_REQUIRED'] = $record['TF_FIELD_REQUIRED'];
				$record['FIELD_DEFAULT'] = $record['TF_FIELD_DEFAULT'];
				$field_records[$record['FIELDNAME']] = $record;
			}

		}
		return $field_records;
	}

	function getDerivedFields($tablecode) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1617;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		$field_records = array();
		if (!empty($tablecode)) {
			$sql = 'SELECT F.* FROM CLX_DB_TABLEDFIELDS TF, CLX_DB_FIELDS F WHERE TF.TABLECODE=' . singleQuote($tablecode) . ' AND TF.FIELDNAME = F.FIELDNAME';
			$records = ClxCommon::$db->executeQuery($sql);
			while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
				$field_records[$record['FIELDNAME']] = $record;
			}
		}
		return $field_records;
	}


	function getMappings($importcode,$delete_ignr=false) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1618;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		$mappings = array();

		$sql='SELECT MAP.*,(SELECT X.RULE FROM CLX_DB_IMPORT_FIELDS_RULE X WHERE X.ID=RULE_ID AND RULE_ID<>0 AND LENGTH(RULE)>3) RULE_TEXT FROM CLX_DB_IMPORT_MAPPINGS MAP WHERE '.
		(($delete_ignr==true) ? 'MAP.TYPE!='.singlequote('IGNR').' AND ' :'').
		' MAP.IMPORTCODE = ' . singleQuote($importcode) . ' ORDER BY MAP.SEQNUM ASC';
		$records = ClxCommon::$db->executeQuery($sql);

		while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
			$mappings[$record['TABLE_FIELDNAME']] = $record;
		}
		return $mappings;
	}
	function getRestriction($importcode) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}
		$restrictions = array();
		$records = ClxCommon::$db->getRecords('CLX_DB_IMPORT_RULES', 'STATUS=1 AND IMPORTCODE = ' . singleQuote($importcode) . ' ');
		while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
			IF ($record['RULE']=='NREC') {
				$ru=EXPLODE(",",$record['RULE_TEXT']);
				$texto=',,';
				FOREACH($ru AS $value) {
					$div=explode('-',$value);
					$si=true;
					for($tx=$div[0];$tx<=$div[count($div)-1];$tx++) {
						$texto.=$tx.",";
						$si=false;
					}
					if ($si)
						$texto.=$value.",";
				}
				$record['RULE_TEXT2']=$texto;
			}
			$restrictions[] = $record;
		}
		return $restrictions;

	}
	function getFormulas($importcode) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1619;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		$formulas = array();
		$records = ClxCommon::$db->getRecords('CLX_DB_IMPORT_MAPPINGS', 'TYPE='.singleQuote('FORM'), 'IMPORTCODE = ' . singleQuote($importcode) . ' ORDER BY SEQNUM');
		while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
			$formulas[] = $record;
		}
		return $formulas;
	}

	function getExceptions($importcode) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1620;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		$exceptions = array();
		$records = ClxCommon::$db->getRecords('CLX_DB_IMPORT_EXCEPTIONS', 'IMPORTCODE = ' . singleQuote($importcode) . ' ORDER BY SEQNUM');
		while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
			$exceptions[$record['TABLE_FIELDNAME']] = $record;
		}
		return $exceptions;
	}

	function getTranslations($importcode, $mappings, $direction = CLX_NUM_ZERO) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1621;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		ClxFreeReturn($mappings);
		$translations = array();
		foreach ($mappings as $fieldname => $info) {
			$mapid = $info['ID'];
			$list = array();
			$sql = 'SELECT
					   Z.MAPID,
					   Z.ORIGINAL_VALUE,
					   Z.REPLACE_VALUE,
					   Z.CASE_SENSITIVE,
					   Z.SEQNUM
					FROM
					  CLX_DB_IMPORT_TRANSLATIONS Z
					WHERE
					  Z.MAPID = ' . $mapid . '
					  AND (Z.TRANSL_CODE IS NULL OR Z.TRANSL_CODE = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ')
					UNION ALL
					SELECT
					   X.MAPID,
					   Z.ORIGINAL_VALUE,
					   Z.REPLACE_VALUE,
					   Z.CASE_SENSITIVE,
					   Z.SEQNUM
					FROM
					 CLX_DB_IMPORT_TRANSLATIONS X,
					  CLX_SYS_TRANSL_SETS Y,
					  CLX_SYS_TRANSL_ITEMS Z
					WHERE
					  Y.IDCODE = Z.TRANSL_CODE
					  AND X.TRANSL_CODE = Y.IDCODE
					  AND X.MAPID = ' . $mapid . '
					  AND Z.DIRECTION = ' . $direction;
			$records = ClxCommon::$db->executeQuery($sql);
			while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
				//set keys to upper on index to avaluate the index case insentive
				$list[uppercase($record['ORIGINAL_VALUE'])] = $record;
			}
			$translations[$fieldname] = $list;
		}
		return $translations;
	}

	function getTranslationsnew($mappings, $direction = CLX_NUM_ZERO) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1621;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		ClxFreeReturn($mappings);
		$translations = array();
		$arrayid=array();
		foreach ($mappings as $fieldname => $info) {
			$arrayid=$info['id'];
		}
		$sql = 'SELECT
				   Z.MAPID,
				   Z.ORIGINAL_VALUE,
				   Z.REPLACE_VALUE,
				   Z.CASE_SENSITIVE,
				   Z.SEQNUM
				FROM
				  CLX_DB_IMPORT_TRANSLATIONS Z
				WHERE
				  Z.MAPID in ' . singlequoteArray($arrayid) . '
				  AND (Z.TRANSL_CODE IS NULL OR Z.TRANSL_CODE = ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ')
				UNION ALL
				SELECT
				   X.MAPID,
				   Z.ORIGINAL_VALUE,
				   Z.REPLACE_VALUE,
				   Z.CASE_SENSITIVE,
				   Z.SEQNUM
				FROM
				 CLX_DB_IMPORT_TRANSLATIONS X,
				  CLX_SYS_TRANSL_SETS Y,
				  CLX_SYS_TRANSL_ITEMS Z
				WHERE
				  Y.IDCODE = Z.TRANSL_CODE
				  AND X.TRANSL_CODE = Y.IDCODE
				  AND X.MAPID in ' . singlequoteArray($arrayid) . '
				  AND Z.DIRECTION = ' . $direction .' ORDER BY MAPID,SEQNUM';
		$records = ClxCommon::$db->executeQuery($sql);
		while ($record = ClxCommon::$db->getNextRecord($records, ASSOCIATIVE)) {
			//set keys to upper on index to avaluate the index case insentive
			if ($record['CASE_SENSITIVE']) {
				$list[$info['id']]['ORIGINAL_VALUEI'][] = '#!='.$record['ORIGINAL_VALUE'].'#!=';
				$list[$info['id']]['REPLACE_VALUEI'][] = $record['REPLACE_VALUE'];
			}
			else {
				$list[$info['id']]['ORIGINAL_VALUE'][] = '#!='.$record['ORIGINAL_VALUE'].'#!=';
				$list[$info['id']]['REPLACE_VALUE'][] = $record['REPLACE_VALUE'];
			}
		}


		return  $list;
	}




	function translate(&$field_value, $translations) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1622;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		if (empty($translations))
			return;
		$index = uppercase($field_value);
		if (array_key_exists($index, $translations)) {
			if (!empty($translations[$index]['case_sensitive'])) {
				if (strcmp($field_value, $translations[$index]['ORIGINAL_VALUE']) == CLX_NUM_ZERO) {
					$field_value = $translations[$index]['REPLACE_VALUE'];
				}
			} else {
				$field_value = $translations[$index]['REPLACE_VALUE'];
			}
		}
	}

	private function executeConstants($maprecord, $line, $buffer) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) ) { $tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");   fwrite($tta,chr(13).chr(10)."16098 editForm_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fclose($tta);}
		ClxFreeReturn($line);
		ClxFreeReturn($buffer);
		$cal = new ClxExpression();
		return $cal->parseRecordConstant(trim($maprecord['FORMULA']));
	}

	/**
	 * Returns formulas for import
	 * @param type $maprecord
	 * @param type $record
	 * @return boolean
	 */
	private function executeFormula(&$maprecord, &$record) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1623;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}

		$return = false;
		if ($this->debug==true) {
			echo "incluyendo ",$this->formula_file,"<br>pre record";
			if ($this->debug==true)
				pre($record);
		}
		require $this->formula_file;
		if ($this->debug==true) {
			echo "post record";
			pre($record);
		}
		return $return;
	}

	function isException($exceptions, $buffer) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1624;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		$is = false;
		foreach ($exceptions as $exception) {
			switch ($exception['OPERATOR']) {
				case 'EQ':
					$is = ($is or ( substr($buffer, $exception['POSITION'], strlen($exception['value'])) == $exception['value']));
					break;
				case 'NQ':
					$is = ($is or ( substr($buffer, $exception['POSITION'], strlen($exception['value'])) != $exception['value']));
					break;
				case 'LS':
					$is = ($is or ( substr($buffer, $exception['POSITION'], strlen($exception['value'])) < $exception['value']));
					break;
				case 'LQ':
					$is = ($is or ( substr($buffer, $exception['POSITION'], strlen($exception['value'])) <= $exception['value']));
					break;
				case 'GQ':
					$is = ($is or ( substr($buffer, $exception['POSITION'], strlen($exception['value'])) >= $exception['value']));
					break;
				case 'GT':
					$is = ($is or ( substr($buffer, $exception['POSITION'], strlen($exception['value'])) > $exception['value']));
					break;
				default:
					break;
			}
		}
		return $is;
	}

	/**
	 * Build description file used on interfases
	 * @param: string Tablecode
	 */
	function importStructure() {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1625;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
		ob_start();
		if (empty(UserRequest::$get['importcode'])) {
			return alert(dict('GEN_LBL_ERROR'));
		}

		$tb = ClxCommon::$db->getRecord($this->tablename, 'IDCODE = ' . singleQuote(UserRequest::$get['importcode']));
		if (empty($tb)) {
			return alert(dict('GEN_LBL_ERROR'));
		}
		$line = str_repeat('_', CLX_NUM_HUNDRED);
		if (!class_exists('clx_msexcell'))
			include_once kPathToWebSite . 'classes/clx_msexcel.php';
		$data = array();
		//Table General Information
		$filename = lowercase($tb['IDCODE'] . '_' . str_replace('.', '', $tb['VERSION'] . '.' . $tb['VERSION_COUNTER']));
		$data[] = array($line, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array(uppercase(dict('GEN_LBL_TBL_STREPORT')), CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array($line, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array(CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array(uppercase(dict('GEN_LBL_CODE')), $tb['IDCODE'], CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array(uppercase(dict('GEN_LBL_NAME')), $tb['MODULECODE'] . '_' . $tb['IDNAME'], CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array(uppercase(dict('GEN_LBL_VERSION')), $tb['VERSION'] . '.' . $tb['VERSION_COUNTER'], CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array(uppercase(dict('GEN_LBL_MODULE')), $tb['MODULECODE'], CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array(uppercase(dict('GEN_LBL_TABLE')), $tb['TABLECODE'], CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array(uppercase(dict('GEN_LBL_DATE')), date('Y-m-d'), CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array(CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array(uppercase(dict('TOOL_DBTF_TITLE_FIELDS')), CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array(CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array('###',
			uppercase(dict('GEN_LBL_FILE_FIELDNAME')),
			uppercase(dict('GEN_LBL_FIELDNAME')),
			uppercase(dict('GEN_LBL_TYPE')),
			uppercase(dict('GEN_LBL_REQUIRED')),
			uppercase(dict('GEN_LBL_DEFAULT')),
			uppercase(dict('GEN_LBL_DESCRIPTION')),
			uppercase(dict('GEN_LBL_LIST')),
			uppercase(dict('GEN_LBL_TABLE')),
		);
		$data[] = array(CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		//Fields Details
		$sql = 'SELECT DBIC.SEQNUM, DBIC.FILE_FIELDNAME, DBIC.TABLE_FIELDNAME FIELDNAME, IFNULL((SELECT CONCAT(' . singleQuote('LOOKUP,') . ', CONCAT(X.FIELDTYPE, CONCAT(' . singleQuote(CLX_CHAR_EMPTY_STRING) . ', CONCAT(X.FIELD_SIZE, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ')))) FROM CLX_DB_FIELDS X WHERE X.FIELDNAME = DBFL.FIELD_EXTRA2 AND DBFL.FIELDTYPE=' . singleQuote('LOOK') . '), DBFL.FIELDTYPE) FIELDTYPE, DBFL.FIELD_SIZE, DBFL.FIELD_REQUIRED, DBFL.FIELD_DEFAULT, DBFL.DESCRIPTION, DBFL.FIELDFORMLABEL LABEL, DBFL.FIELD_EXTRA1, DBFL.FIELD_FORMAT FROM CLX_DB_IMPORT_MAPPINGS DBIC LEFT JOIN CLX_DB_FIELDS DBFL ON DBFL.FIELDNAME = DBIC.TABLE_FIELDNAME WHERE DBIC.IMPORTCODE = ' . singleQuote($tb['IDCODE']) . ' AND DBIC.TYPE NOT IN (' . singleQuote('IGNR') . ') ORDER BY				   DBIC.SEQNUM ASC';
		$rs = ClxCommon::$db->executeQuery($sql);
		$i = CLX_INIT_ZERO;
		while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
			$r['SEQNUM'] = $i;
			$i++;
			$r['FIELD_REQUIRED'] = ($r['FIELD_REQUIRED'] == CLX_NUM_ONE) ? '*' : CLX_CHAR_EMPTY_STRING;
			$r['LABEL'] = capitalize(str_replace(CLX_CHAR_CR, CLX_CHAR_EMPTY_STRING, dict($r['LABEL'])));
			$r['EXTRACOL_LIST'] = CLX_CHAR_EMPTY_STRING;
			$r['EXTRACOL_TABLE'] = CLX_CHAR_EMPTY_STRING;
			switch ($r['FIELDTYPE']) {
				case 'PRIM':
					$r['FIELDTYPE'] = 'dec(11)';
					break;
				case 'BOOL':
					$r['FIELDTYPE'] = 'BOOLEAN(1)';
					$r['LABEL'] .= '. ' . dict('GEN_LBL_FORMAT') . ': 0 / 1';
					break;
				case 'TLOK': /* Access Tree lookup field */
					$r['FIELDTYPE'] = 'ACCESS TREE, CHAR(255)';
					$r['LABEL'] .= '. ' . dict('GEN_LBL_TREECODE') . ': ' . $r['FIELD_EXTRA1'];
					break;
				case 'TEXT':
					break;
				case 'DATI':
				case 'DATE':
					$r['FIELDTYPE'] = 'char(19)';
					$r['LABEL'] .= '. ' . dict('GEN_LBL_FORMAT') . ': YYYY-MM-DD 24:MM:SS';
					break;
				case 'TIME':
					$r['FIELDTYPE'] = 'char(8)';
					$r['LABEL'] .= '. ' . dict('GEN_LBL_FORMAT') . ': 24:MM:SS';
					break;
				case 'DECN':
					$r['FIELDTYPE'] = 'dec(' . $r['FIELD_FORMAT'] . ')';
					break;
				case 'INTN':
					$r['FIELDTYPE'] = 'dec(' . $r['FIELD_SIZE'] . ')';
					break;
				case 'LIST':
					$r['FIELDTYPE'] = 'LIST, CHAR(10)';
					$r['LABEL'] .='. ' . dict('GEN_LBL_SEE_LIST') . ': ' . $r['FIELD_EXTRA1'];
					$r['EXTRACOL_LIST'] = $r['FIELD_EXTRA1'];
					break;
				case 'SOBJ':
					$r['FIELDTYPE'] = 'char(255)';
					break;
				case 'TLOK':
					$r['FIELDTYPE'] = 'char(255)';
					break;
				case 'SLUK':
					$r['FIELDTYPE'] = 'char(255)';
					break;
				default:
					if (substr($r['FIELDTYPE'], CLX_NUM_ZERO, CLX_NUM_SIX) === 'LOOKUP') {
						$r['EXTRACOL_TABLE'] = $r['FIELD_EXTRA1'];
					} else {
						$r['FIELDTYPE'] = 'char(' . $r['FIELD_SIZE'] . ')';
					}
					break;
			}
			$r['FIELDTYPE'] = uppercase($r['FIELDTYPE']);
			unset($r['DESCRIPTION'], $r['FIELD_SIZE'], $r['FIELD_EXTRA1'], $r['FIELD_FORMAT']);
			$data[] = $r;
		}
		//List Options
		$data[] = array(CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array($line, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array(uppercase(dict('GEN_LBL_DB_LISTS')), CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array($line, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array(CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$sql = 'SELECT DISTINCT  X.IDCODE, X.IDNAME, X.MODULECODE, X.VERSION, X.VERSION_COUNTER FROM (SELECT DBLT.IDCODE, DBLT.IDNAME, DBLT.MODULECODE, DBLT.VERSION, DBLT.VERSION_COUNTER,DBIC.SEQNUM FROM CLX_DB_IMPORT_MAPPINGS DBIC,CLX_DB_FIELDS DBFL, CLX_DB_LISTS DBLT  WHERE  DBFL.FIELDNAME = DBIC.TABLE_FIELDNAME  AND DBLT.IDCODE = DBFL.FIELD_EXTRA1 AND DBFL.FIELDTYPE = ' . singleQuote('LIST') . ' AND DBIC.IMPORTCODE = ' . singleQuote($tb['IDCODE']) . '  AND DBIC.TYPE NOT IN (' . singleQuote('IGNR') . ') ORDER BY DBIC.SEQNUM ASC) X';
		$rs = ClxCommon::$db->executeQuery($sql);
		while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
			$data[] = array(uppercase(dict('GEN_LBL_CODE')), $r['IDCODE'], CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
			$data[] = array(uppercase(dict('GEN_LBL_NAME')), $r['IDNAME'], CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
			$data[] = array(uppercase(dict('GEN_LBL_VERSION')), $r['VERSION'] . '.' . $r['VERSION_COUNTER'], CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
			$data[] = array(uppercase(dict('GEN_LBL_MODULE')), $r['MODULECODE'], CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
			$data[] = array(CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
			$data[] = array('###', uppercase(dict('GEN_LBL_CODE')), uppercase(dict('GEN_LBL_NAME')), CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
			$data[] = array(CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
			$sql = 'SELECT SEQNUM, IDCODE, IDNAME, "","","","" FROM CLX_DB_LIST_ITEMS  WHERE LISTCODE = ' . singleQuote($r['IDCODE']) . ' AND INACTIVE = 0';
			$rs2 = ClxCommon::$db->executeQuery($sql);
			$i = CLX_INIT_ZERO;
			while ($r2 = ClxCommon::$db->getNextRecord($rs2, ASSOCIATIVE)) {
				$r2['SEQNUM'] = $i;
				$r2['IDNAME'] = trim(dict($r2['IDNAME']));
				$data[] = $r2;
				$i++;
			}
			$data[] = array($line, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
			$data[] = array(CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		}
		if (ob_get_contents())
			ob_clean();
		sendDownloadFile($filename, 'xls');
		$contents = CLX_CHAR_EMPTY_STRING;
		foreach ($data as $val) {
			$contents .=implode(CLX_CHAR_TAB, $val) . CLX_CHAR_NL;
		}
		return decode_string($contents);
	}
	/**
	 * Build description file used on interfases
	 * @param: string Tablecode
	 */
	function importRecreateStructure() {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1625;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}

		if (empty(UserRequest::$get['importcode'])) {
			return alert(dict('GEN_LBL_ERROR'));
		}

		$tb = ClxCommon::$db->getRecord($this->tablename, 'IDCODE = ' . singleQuote(UserRequest::$get['importcode']));
		if (empty($tb)) {
			return alert(dict('GEN_LBL_ERROR'));
		}
		$line = str_repeat('_', CLX_NUM_HUNDRED);

		$data = array();
		//Table General Information
		$filename = lowercase($tb['IDCODE'] . '_' . str_replace('.', '', $tb['VERSION'] . '.' . $tb['VERSION_COUNTER']));
		$data[] = array($line, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array(uppercase(dict('GEN_LBL_TBL_STREPORT')), CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array($line, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array(CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array(uppercase(dict('GEN_LBL_CODE')), $tb['IDCODE'], CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array(uppercase(dict('GEN_LBL_NAME')), $tb['MODULECODE'] . '_' . $tb['IDNAME'], CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array(uppercase(dict('GEN_LBL_VERSION')), $tb['VERSION'] . '.' . $tb['VERSION_COUNTER'], CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array(uppercase(dict('GEN_LBL_MODULE')), $tb['MODULECODE'], CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array(uppercase(dict('GEN_LBL_TABLE')), $tb['TABLECODE'], CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array(uppercase(dict('GEN_LBL_DATE')), date('Y-m-d'), CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array(CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array(uppercase(dict('TOOL_DBTF_TITLE_FIELDS')), CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array(CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array('###',
			uppercase(dict('GEN_LBL_FILE_FIELDNAME')),
			uppercase(dict('GEN_LBL_FIELDNAME')),
			uppercase(dict('GEN_LBL_TYPE')),
			uppercase(dict('GEN_LBL_REQUIRED')),
			uppercase(dict('GEN_LBL_DEFAULT')),
			uppercase(dict('GEN_LBL_DESCRIPTION')),
			uppercase(dict('GEN_LBL_LIST')),
			uppercase(dict('GEN_LBL_TABLE')),
		);
		$data[] = array(CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		//Fields Details
		$sql = 'SELECT DBIC.SEQNUM, DBIC.FILE_FIELDNAME, DBIC.TABLE_FIELDNAME FIELDNAME, IFNULL((SELECT CONCAT(' . singleQuote('LOOKUP,') . ', CONCAT(X.FIELDTYPE, CONCAT(' . singleQuote(CLX_CHAR_EMPTY_STRING) . ', CONCAT(X.FIELD_SIZE, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ')))) FROM CLX_DB_FIELDS X WHERE X.FIELDNAME = DBFL.FIELD_EXTRA2 AND DBFL.FIELDTYPE=' . singleQuote('LOOK') . '), DBFL.FIELDTYPE) FIELDTYPE, DBFL.FIELD_SIZE, DBFL.FIELD_REQUIRED, DBFL.FIELD_DEFAULT, DBFL.DESCRIPTION, DBFL.FIELDFORMLABEL LABEL, DBFL.FIELD_EXTRA1, DBFL.FIELD_FORMAT FROM CLX_DB_IMPORT_MAPPINGS DBIC LEFT JOIN CLX_DB_FIELDS DBFL ON DBFL.FIELDNAME = DBIC.TABLE_FIELDNAME WHERE DBIC.IMPORTCODE = ' . singleQuote($tb['IDCODE']) . ' AND DBIC.TYPE NOT IN (' . singleQuote('IGNR') . ') ORDER BY				   DBIC.SEQNUM ASC';
		$rs = ClxCommon::$db->executeQuery($sql);
		$i = CLX_INIT_ZERO;
		while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
			$r['SEQNUM'] = $i;
			$i++;
			$r['FIELD_REQUIRED'] = ($r['FIELD_REQUIRED'] == CLX_NUM_ONE) ? '*' : CLX_CHAR_EMPTY_STRING;
			$r['LABEL'] = capitalize(str_replace(CLX_CHAR_CR, CLX_CHAR_EMPTY_STRING, dict($r['LABEL'])));
			$r['EXTRACOL_LIST'] = CLX_CHAR_EMPTY_STRING;
			$r['EXTRACOL_TABLE'] = CLX_CHAR_EMPTY_STRING;
			switch ($r['FIELDTYPE']) {
				case 'PRIM':
					$r['FIELDTYPE'] = 'dec(11)';
					break;
				case 'BOOL':
					$r['FIELDTYPE'] = 'BOOLEAN(1)';
					$r['LABEL'] .= '. ' . dict('GEN_LBL_FORMAT') . ': 0 / 1';
					break;
				case 'TLOK': /* Access Tree lookup field */
					$r['FIELDTYPE'] = 'ACCESS TREE, CHAR(255)';
					$r['LABEL'] .= '. ' . dict('GEN_LBL_TREECODE') . ': ' . $r['FIELD_EXTRA1'];
					break;
				case 'TEXT':
					break;
				case 'DATI':
				case 'DATE':
					$r['FIELDTYPE'] = 'char(19)';
					$r['LABEL'] .= '. ' . dict('GEN_LBL_FORMAT') . ': YYYY-MM-DD 24:MM:SS';
					break;
				case 'TIME':
					$r['FIELDTYPE'] = 'char(8)';
					$r['LABEL'] .= '. ' . dict('GEN_LBL_FORMAT') . ': 24:MM:SS';
					break;
				case 'DECN':
					$r['FIELDTYPE'] = 'dec(' . $r['FIELD_FORMAT'] . ')';
					break;
				case 'INTN':
					$r['FIELDTYPE'] = 'dec(' . $r['FIELD_SIZE'] . ')';
					break;
				case 'LIST':
					$r['FIELDTYPE'] = 'LIST, CHAR(10)';
					$r['LABEL'] .='. ' . dict('GEN_LBL_SEE_LIST') . ': ' . $r['FIELD_EXTRA1'];
					$r['EXTRACOL_LIST'] = $r['FIELD_EXTRA1'];
					break;
				case 'SOBJ':
					$r['FIELDTYPE'] = 'char(255)';
					break;
				case 'TLOK':
					$r['FIELDTYPE'] = 'char(255)';
					break;
				case 'SLUK':
					$r['FIELDTYPE'] = 'char(255)';
					break;
				default:
					if (substr($r['FIELDTYPE'], CLX_NUM_ZERO, CLX_NUM_SIX) === 'LOOKUP') {
						$r['EXTRACOL_TABLE'] = $r['FIELD_EXTRA1'];
					} else {
						$r['FIELDTYPE'] = 'char(' . $r['FIELD_SIZE'] . ')';
					}
					break;
			}
			$r['FIELDTYPE'] = uppercase($r['FIELDTYPE']);
			unset($r['DESCRIPTION'], $r['FIELD_SIZE'], $r['FIELD_EXTRA1'], $r['FIELD_FORMAT']);
			$data[] = $r;
		}
		//List Options
		$data[] = array(CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array($line, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array(uppercase(dict('GEN_LBL_DB_LISTS')), CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array($line, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$data[] = array(CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		$sql = 'SELECT DISTINCT  X.IDCODE, X.IDNAME, X.MODULECODE, X.VERSION, X.VERSION_COUNTER FROM (SELECT DBLT.IDCODE, DBLT.IDNAME, DBLT.MODULECODE, DBLT.VERSION, DBLT.VERSION_COUNTER,DBIC.SEQNUM FROM CLX_DB_IMPORT_MAPPINGS DBIC,CLX_DB_FIELDS DBFL, CLX_DB_LISTS DBLT  WHERE  DBFL.FIELDNAME = DBIC.TABLE_FIELDNAME  AND DBLT.IDCODE = DBFL.FIELD_EXTRA1 AND DBFL.FIELDTYPE = ' . singleQuote('LIST') . ' AND DBIC.IMPORTCODE = ' . singleQuote($tb['IDCODE']) . '  AND DBIC.TYPE NOT IN (' . singleQuote('IGNR') . ') ORDER BY DBIC.SEQNUM ASC) X';
		$rs = ClxCommon::$db->executeQuery($sql);
		while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
			$data[] = array(uppercase(dict('GEN_LBL_CODE')), $r['IDCODE'], CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
			$data[] = array(uppercase(dict('GEN_LBL_NAME')), $r['IDNAME'], CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
			$data[] = array(uppercase(dict('GEN_LBL_VERSION')), $r['VERSION'] . '.' . $r['VERSION_COUNTER'], CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
			$data[] = array(uppercase(dict('GEN_LBL_MODULE')), $r['MODULECODE'], CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
			$data[] = array(CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
			$data[] = array('###', uppercase(dict('GEN_LBL_CODE')), uppercase(dict('GEN_LBL_NAME')), CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
			$data[] = array(CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
			$sql = 'SELECT SEQNUM, IDCODE, IDNAME, "","","","" FROM CLX_DB_LIST_ITEMS  WHERE LISTCODE = ' . singleQuote($r['IDCODE']) . ' AND INACTIVE = 0';
			$rs2 = ClxCommon::$db->executeQuery($sql);
			$i = CLX_INIT_ZERO;
			while ($r2 = ClxCommon::$db->getNextRecord($rs2, ASSOCIATIVE)) {
				$r2['SEQNUM'] = $i;
				$r2['IDNAME'] = trim(dict($r2['IDNAME']));
				$data[] = $r2;
				$i++;
			}
			$data[] = array($line, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
			$data[] = array(CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING, CLX_CHAR_EMPTY_STRING);
		}

	   // sendDownloadFile($filename, 'xls');
		$contents = CLX_CHAR_EMPTY_STRING;
		foreach ($data as $val) {
			$contents .=implode(CLX_CHAR_TAB, $val) . CLX_CHAR_NL;
		}

		$tablecode=$tb['TABLECODE'];
		$record_length=$tb['RECORD_LENGTH'];
		switch (kDatabaseType) {
			case 'oci': // Oracle
				  $rs = ClxCommon::$db->executequery('SELECT * FROM '.ClxCommon::$db->getTableNameFromCode($tablecode).' X WHERE ROWNUM<100');
					break;
			default: // MySQL Version all others
					$rs = ClxCommon::$db->executequery('SELECT * FROM '.ClxCommon::$db->getTableNameFromCode($tablecode).' X  LIMIT 1,100');
					 break;

		}
		$datars = ClxCommon::$db->fetch_all($rs);

	//	pre($datars);
		$field_delim=$tb['FIELD_DELIM'];
		$record_delim=$tb['RECORD_DELIM'];
		$exceltype=$tb['EXCEL_TYPE'];
		$type=$tb['TYPE'];
		for($k=0;$k<256;$k++) {
			$field_delim=str_replace('['.$k.']',chr($k),$field_delim);
			$record_delim=str_replace('['.$k.']',chr($k),$record_delim);
		}
		$line='';
		$yes=false;
		$tabla1=array();

		$contar=0;
		IF ($type=='CSV' or $type=='CSV2') {
			foreach($data as $keyd=>$valued) {
				IF (ISSET($valued['FILE_FIELDNAME']))	{
					$linea=0;
					if (!isset($tabla1[$linea]))
						$tabla1[$linea]=array();

					$tabla1[$linea++][$contar]=$valued['FILE_FIELDNAME'];
					foreach($datars as $key=>$fields) {
						if (!isset($tabla1[$linea]))
							$tabla1[$linea]=array();
						$tabla1[$linea++][$contar]=$fields[$valued['FIELDNAME']];
					}
					$contar++;
				}
			}
			$texto='';
			foreach($tabla1 as $keyd=>$columns) {
				$texto.=implode($field_delim,$columns).$record_delim;
			}
			$texto=base64_encode($texto);
			$sql='UPDATE CLX_DB_IMPORTS SET FILE='.singlequote('GENERATE_FILE_'.$tablecode.date('Y_m_d').'.txt').', FILE_C= '.singlequote($texto).' WHERE IDCODE='.singlequote(UserRequest::$get['importcode']);
			ClxCommon::$db->executeQuery($sql);
			if ($this->debug==true) {echo $b='update import in 8335';pre($sql);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).$sql,true); fclose($tta);}}

		//	pre($texto);
//			PRE(BEAUTIFUL_SQL($sql));
		}
		else IF ($type=='FRL' or $type=='FRL2' or $type=='FRL3') {
			$fieldscortes=array();
			$rs = ClxCommon::$db->getRecords('CLX_DB_IMPORT_MAPPINGS', 'IMPORTCODE = ' .  singleQuote(UserRequest::$get['importcode']) . ' AND TYPE= '.singleQuote('FIX').' ORDER BY START_POSITION');
			while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
				$fieldscortes[$r['TABLE_FIELDNAME']]=array($r['START_POSITION'],$r['FIELD_LENGTH']);
			}
			$texto='';
			foreach ($datars as $keyY=>$datasreg) {
				$linea='';
				$linea2='';
				foreach($fieldscortes as $keyX=>$valueX) {
					$linea=substr($linea.str_repeat(' ',1000),0,$valueX[0]-1);
					$linea2.=','.$datasreg[$keyX];
					$linea.=substr($datasreg[$keyX].str_repeat(' ',1000),0,$valueX[1]);
				}
	//			pre($linea);
	//			pre($linea2);
				IF ($type=='FRL3')
					$texto .=substr($linea.str_repeat(' ',2500),$record_length-strlen($record_delim)).$record_delim;
				ELSE
					$texto .=$linea.$record_delim;
			}
//			pre($texto);
			$texto=base64_encode($texto);
//			pre($texto);
			$sql='UPDATE CLX_DB_IMPORTS SET FILE_DELIM='.singlequote('GENERATE_FILE_'.$tablecode.date('Y_m_d').'.txt').', FILE_CDELIM= '.singlequote($texto).' WHERE IDCODE='.singlequote(UserRequest::$get['importcode']);
			ClxCommon::$db->executeQuery($sql);
			if ($this->debug==true) {echo $b='update import in 8367';pre($sql);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).$sql,true); fclose($tta);}}

		//	pre($texto);
		}
		ELSE IF ($type=='XLS' or $type=='XLS2') {
			foreach($data as $keyd=>$valued) {
				IF (ISSET($valued['FILE_FIELDNAME']))	{
					$linea=0;
					if (!isset($tabla1[$linea]))
						$tabla1[$linea]=array();

					$tabla1[$linea++][$contar]=$valued['FILE_FIELDNAME'];
					foreach($datars as $key=>$fields) {
						if (!isset($tabla1[$linea]))
							$tabla1[$linea]=array();
						$tabla1[$linea++][$contar]=$fields[$valued['FIELDNAME']];
					}
					$contar++;
				}
			}
			require "PHPExcel/Classes/PHPExcel.php";
			if($exceltype=='xls') {
				require "PHPExcel/Classes/PHPExcel/Writer/Excel5.php";
				$extension='.xls';
			}
			else {
				require "PHPExcel/Classes/PHPExcel/Writer/Excel2007.php";
				$extension='.xlsx';
			}
			$objPHPExcel = new PHPExcel();
			$objPHPExcel->getActiveSheet()->fromArray($tabla1, null, 'A1');
			$objPHPExcel->getActiveSheet()->setTitle('PageGen_'.UserRequest::$get['importcode']);
			// Set active sheet index to the first sheet, so Excel opens this as the first sheet
			$objPHPExcel->setActiveSheetIndex(0);
			$filename = kPathToWebSite."/".kPathToTemp.'/'.UserRequest::$get['importcode'].'_'.date('Ymd').$extension;

			if($exceltype=='xls') {
				$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, "Excel5");
			}
			else {
				$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, "Excel2007");
			}
			$objWriter->save($filename);
			$fi=fopen($filename,'r+');
			$filetext=fread($fi,filesize($filename));
			fclose($fi);
			$filetext=base64_encode($filetext);
			$sql='UPDATE CLX_DB_IMPORTS SET FILE_EXCEL='.singlequote('GENERATE_FILE_'.$tablecode.date('Y_m_d').$extension).', FILE_CEXCEL= '.singlequote($filetext).' WHERE IDCODE='.singlequote(UserRequest::$get['importcode']);
			ClxCommon::$db->executeQuery($sql);
			if ($this->debug==true) {echo $b='update import in 8415';pre($sql);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).$sql,true); fclose($tta);}}
			$sql='UPDATE CLX_DB_IMPORT_MAPPINGS SET IMPORTSHEETS='.singlequote('PageGen_'.UserRequest::$get['importcode']).' WHERE IMPORTCODE='.singlequote(UserRequest::$get['importcode']);
			ClxCommon::$db->executeQuery($sql);
			if ($this->debug==true) {echo $b='update import in 8419';pre($sql);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).$sql,true); fclose($tta);}}
		//	pre($texto);
		//	PRE(BEAUTIFUL_SQL($sql));
		}
	//	pre('data1');
	//	pre($tabla1);
	//	pre('tb');
	//	pre($tb);
	//	pre($data);die;
		return note(dict('GEN_LBL_PROCESS_COMPLETED'), dict('GEN_LBL_CONTINUE'));
	}
	function importparser() {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1625;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}

		if (empty(UserRequest::$get['importcode'])) {
			return alert(dict('GEN_LBL_ERROR'));
		}

		$tb = ClxCommon::$db->getRecord($this->tablename, 'IDCODE = ' . singleQuote(UserRequest::$get['importcode']));
		if (empty($tb)) {
			return alert(dict('GEN_LBL_ERROR'));
		}
		return "prueba";
	}


	/**
	 * Builds events phisical library
	 */
	private function compileCodeFormulas($importcode) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}if ( !empty($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1626;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_db_import-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}

		//$rs = ClxCommon::$db->getRecords('CLX_DB_IMPORT_MAPPINGS', 'IMPORTCODE = ' . singleQuote($importcode) . ' AND TYPE= '.singleQuote('FORM').' AND FORMULA <> ' . singleQuote(''));
		switch (kDatabaseType) {
		case 'oci': // Oracle
					$rs = ClxCommon::$db->getRecords('CLX_DB_IMPORT_MAPPINGS', 'IMPORTCODE = ' . singleQuote($importcode) .' AND TYPE= '.singleQuote('FORM'). ' AND TO_CHAR(FORMULA) IS NOT NULL');
					break;
		default: // MySQL Version all others
					$rs = ClxCommon::$db->getRecords('CLX_DB_IMPORT_MAPPINGS', 'IMPORTCODE = ' . singleQuote($importcode) . ' AND TYPE= '.singleQuote('FORM').' AND FORMULA <> ' . singleQuote(''));
					break;
		}
		$src = '$return = true; ' . CLX_CHAR_NL . 'switch (intval($maprecord[' . singleQuote('ID') . '])) {';
		while ($r = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
			$fm = str_replace(';;', ';', trim($r['FORMULA']) . ';');
			$src .= CLX_CHAR_NL . CLX_CHAR_TAB . 'case ' . $r['ID'] . ':' . CLX_CHAR_NL . str_repeat(CLX_CHAR_TAB, 2) . $fm . CLX_CHAR_NL . str_repeat(CLX_CHAR_TAB, 2) . ' break;';
		}
		$src .= CLX_CHAR_NL . CLX_CHAR_TAB . 'default:' . CLX_CHAR_NL . str_repeat(CLX_CHAR_TAB, 2) . ' $return = false;' . CLX_CHAR_NL . str_repeat(CLX_CHAR_TAB, 2) . ' break;' . CLX_CHAR_NL . ' }';

		$this->formula_file = saveAndUpdatePhpCodeEvents('dbim_' . $importcode, $src);
	}
	
	function convertToString($field_text,$Rule,$capturehtml=false,$xlstocsv=false,$ssconvert=false) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}
		$ruleAplicattion=array();
		$line=0;
		$ruleAplicattion[$line]=$field_text;

		if (is_array($Rule)) {
			foreach ($Rule as $key=>$value) {
				$matches=preg_split('/(\|,Set2:)|(\|,Set1:)|(\|,size:)|(\|,end-text:)|(\|,Rep_new:)|(Cut_pos:)|(Cut_fr_text:)|(Rep_f1:)|(Rep_f2:)|(format:)/', $value,-1, PREG_SPLIT_DELIM_CAPTURE);
				$combinacion=0;
				for ($t=0;$t<count($matches);$t++) {
					switch ($matches[$t]) {
						case '|,Set2:':
							$set2=$matches[$t+1];
							break;
						case '|,Set1:':
							$set1=$matches[$t+1];
							break;
						case '|,size:':
							$size=$matches[$t+1]; $combinacion+=2;

							break;
						case '|,end-text:':
							$endText=$matches[$t+1]; $combinacion+=4;
							break;
						case '|,Rep_new:':
							$repNew=$matches[$t+1];
							break;
						case 'Cut_pos:':
							$cutPos=$matches[$t+1];$combinacion+=1;

							break;
						case 'Cut_fr_text:':
							$cutFrText=$matches[$t+1];$combinacion+=7;
							break;
						case 'Rep_f1:':
							$RepF1=$matches[$t+1]; $combinacion+=15;
							break;
						case 'Rep_f2:':
							$RepF2=$matches[$t+1]; $combinacion+=20;
							break;
						case 'format:':
							$format=$matches[$t+1]; $combinacion+=30;
							break;
					}
				}
				switch ($combinacion) {
					case 3: //Cut from position size char
						if ($set1=='Eliminar texto Seleccionado'){
							$temp=$ruleAplicattion[$line+1]=substr($ruleAplicattion[$line],$cutPos,$size);
							$ruleAplicattion[$line+1]=str_replace($temp,'',$ruleAplicattion[$line]);
						}
						else
							$ruleAplicattion[$line+1]=substr($ruleAplicattion[$line],$cutPos,$size);
						$line++;
						break;



					case 5: //case from position end texto text
						$size=strpos($ruleAplicattion[$line],$endText);
						if ($size===false) {
							$ruleAplicattion[$line+1]=$ruleAplicattion[$line];
						}
						else {
							$size-=$cutPos;
							if ($set1=='Eliminar texto Seleccionado'){
								$temp=$ruleAplicattion[$line+1]=substr($ruleAplicattion[$line],$cutPos,$size+strlen($endText));
								$ruleAplicattion[$line+1]=str_replace($temp,'',$ruleAplicattion[$line]);
							}
							else
								$ruleAplicattion[$line+1]=substr($ruleAplicattion[$line],$cutPos,$size+strlen($endText));
							}
						$line++;
						break;
					case 9: //case from text from end text
						$cutPos=strpos($ruleAplicattion[$line],$cutFrText);
						if ($cutPos===false) {
							$ruleAplicattion[$line+1]=$ruleAplicattion[$line];
						}
						else {
							//$cutPos+=strlen($cutFrText);
							if ($set1=='Eliminar texto Seleccionado'){
								$temp=$ruleAplicattion[$line+1]=substr($ruleAplicattion[$line],$cutPos,$size);
								$ruleAplicattion[$line+1]=str_replace($temp,'',$ruleAplicattion[$line]);
							}
							else
								$ruleAplicattion[$line+1]=substr($ruleAplicattion[$line],$cutPos,$size);
						}
						$line++;
						break;

					case 11: //case from text size char
						$cutPos=strpos($ruleAplicattion[$line],$cutFrText);
						$cutPos2=strpos($ruleAplicattion[$line],$endText);
						if ($cutPos===false or $cutPos2===false) {
							$ruleAplicattion[$line+1]=$ruleAplicattion[$line];
						}
						else if ($set1=='Eliminar texto Seleccionado'){

							$temp=substr($ruleAplicattion[$line],0,$cutPos);

							$ruleAplicattion[$line+1]=$temp.substr($ruleAplicattion[$line],$cutPos2+strlen($cutPos2));
						}
						else
							$ruleAplicattion[$line+1]=substr($ruleAplicattion[$line],$cutPos,$cutPos2-$cutPos+strlen($cutPos2));
						$line++;
						break;
					case 15: //Reemplazo
						$claves = preg_split("/\][\s]{0,10}(,)[\s]{0,10}\[+/", '],'.$RepF1.',[');
						if (count($claves)>3) {
							$clavesnew = preg_split("/\][\s]{0,10}(,)[\s]{0,10}\[+/", '],'.$repNew.',[');
							$ruleAplicattion[$line+1]=str_replace($claves,$clavesnew,$ruleAplicattion[$line]);

						}
						else {
							$set2=str_replace(' ','',uppercase(trim($set2)));
							$RepF1=html_entity_decode($RepF1, ENT_QUOTES, 'UTF-8') ;
							$repNew=html_entity_decode($repNew, ENT_QUOTES, 'UTF-8') ;
							if ($set2=='TODOELTEXTO' or $set2=='ALLTEXT'){
								$ruleAplicattion[$line+1]=str_replace($RepF1,$repNew,$ruleAplicattion[$line]);
							}
							else if ($set2=='DERECHADELTEXTO' OR $set2=='RIGHTTEXT'){
								$ruleAplicattion[$line+1]=preg_replace("/$RepF1$/",$repNew,$ruleAplicattion[$line]);
							}
							else if ($set2=='IZQUIERDADELTEXTO' OR $set2=='LEFTTEXT'){
								$ruleAplicattion[$line+1]=preg_replace("/^$RepF1/",$repNew,$ruleAplicattion[$line]);
							}
							else {
								if ($set2=='TERCERAOCURRENCIA' OR $set2=='THIRDCASE' )
									$pos=2;
								else if ($set2=='SEGUNDAOCURRENCIA' OR $set2=='SECONDCASE' )
									$pos=1;
								else
									$pos=0;
								preg_match_all('/('.$RepF1.')/', $ruleAplicattion[$line], $matches, PREG_OFFSET_CAPTURE);
								if (count($matches[0]>0) and !empty($matches[0][$pos]))
									$ruleAplicattion[$line+1]=substr($ruleAplicattion[$line],0,$matches[0][$pos][1]).$repNew.substr($ruleAplicattion[$line],$matches[0][$pos][1]+strlen($RepF1));
								else
									$ruleAplicattion[$line+1]=$ruleAplicattion[$line];
							}

						}
						$line++;
						break;
					case 20: //Reemplazo Expresion Regular
						$ruleAplicattion[$line+1]=preg_replace($ruleAplicattion[$line],$RepF2,$repNew);
						$line++;
						break;
					case 30: //format

						switch ($format) {
							case 'Convertir a Decimal':
								$ruleAplicattion[$line+1]=@number_format($ruleAplicattion[$line], 2, '.', '');
								$line++;
								break;
							case 'Convertir a Entero':
								$ruleAplicattion[$line+1]=@number_format($ruleAplicattion[$line], 0, '.', '');
								$line++;
								break;
							default : //ec ho "acax";
								preg_match("/\((.*?)\)/i",trim($format),$formatx);
								$format=trim($formatx[1]);
							//	if (!$xlstocsv) {
							
								if ($ssconvert==false) { if ($this->debug)	echo "------------> ssconvert usado conversion " ;
									$ruleAplicattion[$line+1]=convert_to_date($ruleAplicattion[$line],$format);
									$line++;
								}else 	{if ($this->debug) {$te=debug_backtrace();$posx=0;for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)echo $pos."_".$te[$posx]["function"]."_util(pre)-hora:".date("h:i:s d/m/Y")."<br>";echo substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"]."<br>";}}	echo "------------> ssconvert no usado conversion " ;}}
								
							//	}

						}
						break;
				}
			}
		}
		if ($capturehtml) {
			$table = new htmlTable(CLX_WIDTH_TWO);
			$table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM, CLX_PROP_WIDTH => CLX_PROP_100PCT));
			$table->addCell(dict('GEN_LBL_CONVERT_TEXT'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
			$table->addCell(dict('GEN_LBL_ORIGINAL_TEXT_TEST'),   array(CLX_PROP_CLASS => CLX_CLASS_PROMPT ));
			$table->addCell('<pre><p id="Original" style="background-color:#77DAE0;">'.$field_text.'</p></pre>',   array(CLX_PROP_CLASS => CLX_CLASS_DATAALT));
			for ($t=1;$t<count($ruleAplicattion);$t++) {
				$table->addCell(dict('GEN_LBL_TEXT_RULE').' '.$t.'-  ',   array(CLX_PROP_CLASS => CLX_CLASS_PROMPT ));

				$table->addCell('<pre><p style="margin-left:auto;display:inline-block;margin-right:auto;background-color:#77DAE0;">'.$ruleAplicattion[$t].'</p></pre>',   array(CLX_PROP_CLASS => ($t%2==0)? CLX_CLASS_DATAALT:CLX_CLASS_DATA));
			}
			return $table->source();
		}
		else {
			return $ruleAplicattion[$line];

		}

	}
	function changefiledatereq(&$record){ IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}

		IF (!isset($record['CH_VALUE_DATE']) || $record['CH_VALUE_DATE']=='')
			$record['CH_VALUE_DATE']='0AADDATE';
		$replax=array('0AADDATE'=>0,'1DAYADD'=>1,'1DAYMINUS'=>-1,'2DAYMINUS'=>'-2');
		if (!empty($record['FILEDATE_REQ']) && validateDate($record['FILEDATE_REQ'], $format = 'Y-m-d')) {
			$fecha = new DateTime($record['FILEDATE_REQ']);

			$change=$replax[$record['CH_VALUE_DATE']].' days';
		

			date_add($fecha, date_interval_create_from_date_string($change));

			$record['FILEDATE_REQ']=  date_format($fecha, 'Y-m-d');
		}
		if (isset($record['CH_VALUE_DATE'])) 
			unset($record['CH_VALUE_DATE']);
	}
	function call_error_or_description_debug($importcode,$original_filename,$fileread,$line_num,$result_msg0,$idrecordexecutions,$num_records,$saved_errors,$code_lot,$cdatecomunerror,$imported_records,$description,$test,$timex,$exit=true) {IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}
		$xsheets='';
		$this->saveErrors($importcode, $line_num,array("ERROR"=>  '<a href="tool.php?to=BUGS&ac=LIST">'.dict('GEN_ERR_CHECKTRAP').'</a>'), $saved_errors,$code_lot,$cdatecomunerror,$record,$result_msg0,$idrecordexecutions,$saved_errors, $num_records, $ignored_records,$ignored_records2, $updated_records, $created_records,$timex,$xsheets,$test);
		$result_msg0 = dict('TOOL_DBIM_IMPORT_ERROR_RUN');
		$record = array();
		$record['IMPORTCODE'] = $importcode;
		$record['RECORD_QTY'] = $imported_records;
		$record['CDATE'] = xFormat::getNow('Y-m-d H:i:s');
		$record['OWNERCODE'] = $_SESSION['user_record']['username'];
		$record['DESCRIPTION'] = dict('CLX_USER_SIST_O').(stripos(' '.PHP_OS,'WIN')>0 ? '' : posix_getpwuid(posix_geteuid())['name']).'<br>'.chr(13).chr(10).$description;
		$record['FILENAME'] = $original_filename;
		$record['LOG_ID']=$code_lot;
		$record['STATUS']='ERRO';
		$record['OBSERVATION'] = 'IP SERVER:'. (isset($_SERVER['SERVER_ADDR']) ? $_SERVER['SERVER_ADDR'] :'').' SERVER NAME:'.$_SERVER['SERVER_NAME'];
		$record['FILENAME_INC_DATE']=0;
		$record['CH_VALUE_DATE']='';
		if (!isset($ignored_records))
			$ignored_records=0;
		if (!isset($ignored_records2))
			$ignored_records2=0;
		if (!isset($updated_records))
			$updated_records=0;
		if (!isset($created_records))
			$created_records=0;
		$this->saveErrors($importcode, $line_num,array("ERROR"=>  '<a href="tool.php?to=BUGS&ac=LIST">'.dict('GEN_ERR_CHECKTRAP').'</a>'), $saved_errors,$code_lot,$cdatecomunerror,$record,$result_msg0,$idrecordexecutions,$saved_errors, $num_records, $ignored_records,$ignored_records2, $updated_records, $created_records,$timex,$xsheets,$test);
		
		if ($this->debug==true) {echo $b='llamada creation_executions_description_status  8701 ';PRE('ID = ' . $idrecordexecutions);if ($this->debugescribir==true){$tta=fopen(kPathToWebSite."/".kPathToTemp."archivode.txt","a+");fwrite($tta,$b.chr(13).chr(10).'ID = ' . $idrecordexecutions.chr(13).chr(10) ); fclose($tta);}}
		$this->creation_executions_description_status($record,$result_msg0,$idrecordexecutions,$saved_errors, $num_records, $ignored_records,$ignored_records2, $updated_records, $created_records,$timex,$xsheets);
		ClxCommon::$db->executequery('commit');
		if (!empty(UserRequest::$post['IMFT_ID'])) {
			require kPathToWebSite."/data/code/ETL_utilities.php";

			$etl=new ETL_utilities();
			$etl->call_rename($fileread,UserRequest::$post['IMFT_ID']);

		}
		if ($exit){
			salir(0);
		}


	}
}
function replace_words($listword, $texto,$upper, $callback) { IF (!empty($GLOBALS['ADDRDEBUGIMPORT']) &&$GLOBALS['ADDRDEBUGIMPORT']==1) {$kk=fopen('temp/saldebugIMP.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' '. chr(13).chr(10)); fclose($kk);}
	return preg_replace_callback(
		'/\#\!\=(' . implode('|', array_map('preg_quote', $listword)) . ')\#\!\=/m'.$upper,
		function($v) use ($callback) { return  $callback($v[1]) ; },
		$texto
	);
}
